/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/objects","vs/editor/common/core/lineRange","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],K=function(z){for(var t=[],P=0,k=z.length;P<k;P++)t[P]=J[z[P]];return t};const xe=this,We=typeof global=="object"?global:{};var de;(function(z){z.global=xe;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof z.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}z.Environment=t})(de||(de={}));var de;(function(z){class t{constructor(u,L,c){this.type=u,this.detail=L,this.timestamp=c}}z.LoaderEvent=t;class P{constructor(u){this._events=[new t(1,"",u)]}record(u,L){this._events.push(new t(u,L,z.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}z.LoaderEventRecorder=P;class k{record(u,L){}getEvents(){return[]}}k.INSTANCE=new k,z.NullLoaderEventRecorder=k})(de||(de={}));var de;(function(z){class t{static fileUriToFilePath(k,i){if(i=decodeURI(i).replace(/%23/g,"#"),k){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(k,i){return k.length>=i.length&&k.substr(0,i.length)===i}static endsWith(k,i){return k.length>=i.length&&k.substr(k.length-i.length)===i}static containsQueryString(k){return/^[^\#]*\?/gi.test(k)}static isAbsolutePath(k){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(k)}static forEachProperty(k,i){if(k){let u;for(u in k)k.hasOwnProperty(u)&&i(u,k[u])}}static isEmpty(k){let i=!0;return t.forEachProperty(k,()=>{i=!1}),i}static recursiveClone(k){if(!k||typeof k!="object"||k instanceof RegExp||!Array.isArray(k)&&Object.getPrototypeOf(k)!==Object.prototype)return k;let i=Array.isArray(k)?[]:{};return t.forEachProperty(k,(u,L)=>{L&&typeof L=="object"?i[u]=t.recursiveClone(L):i[u]=L}),i}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(k){return t.startsWith(k,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=z.global.performance&&typeof z.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?z.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,z.Utilities=t})(de||(de={}));var de;(function(z){function t(i){if(i instanceof Error)return i;const u=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(u.stack=i.stack),u}z.ensureError=t;class P{static validateConfigurationOptions(u){function L(c){if(c.phase==="loading"){console.error('Loading "'+c.moduleId+'" failed'),console.error(c),console.error("Here are the modules that depend on it:"),console.error(c.neededBy);return}if(c.phase==="factory"){console.error('The factory function of "'+c.moduleId+'" has thrown an exception'),console.error(c),console.error("Here are the modules that depend on it:"),console.error(c.neededBy);return}}if(u=u||{},typeof u.baseUrl!="string"&&(u.baseUrl=""),typeof u.isBuild!="boolean"&&(u.isBuild=!1),typeof u.paths!="object"&&(u.paths={}),typeof u.config!="object"&&(u.config={}),typeof u.catchError>"u"&&(u.catchError=!1),typeof u.recordStats>"u"&&(u.recordStats=!1),typeof u.urlArgs!="string"&&(u.urlArgs=""),typeof u.onError!="function"&&(u.onError=L),Array.isArray(u.ignoreDuplicateModules)||(u.ignoreDuplicateModules=[]),u.baseUrl.length>0&&(z.Utilities.endsWith(u.baseUrl,"/")||(u.baseUrl+="/")),typeof u.cspNonce!="string"&&(u.cspNonce=""),typeof u.preferScriptTags>"u"&&(u.preferScriptTags=!1),u.nodeCachedData&&typeof u.nodeCachedData=="object"&&(typeof u.nodeCachedData.seed!="string"&&(u.nodeCachedData.seed="seed"),(typeof u.nodeCachedData.writeDelay!="number"||u.nodeCachedData.writeDelay<0)&&(u.nodeCachedData.writeDelay=1e3*7),!u.nodeCachedData.path||typeof u.nodeCachedData.path!="string")){const c=t(new Error("INVALID cached data configuration, 'path' MUST be set"));c.phase="configuration",u.onError(c),u.nodeCachedData=void 0}return u}static mergeConfigurationOptions(u=null,L=null){let c=z.Utilities.recursiveClone(L||{});return z.Utilities.forEachProperty(u,(s,l)=>{s==="ignoreDuplicateModules"&&typeof c.ignoreDuplicateModules<"u"?c.ignoreDuplicateModules=c.ignoreDuplicateModules.concat(l):s==="paths"&&typeof c.paths<"u"?z.Utilities.forEachProperty(l,(f,R)=>c.paths[f]=R):s==="config"&&typeof c.config<"u"?z.Utilities.forEachProperty(l,(f,R)=>c.config[f]=R):c[s]=z.Utilities.recursiveClone(l)}),P.validateConfigurationOptions(c)}}z.ConfigurationOptionsUtil=P;class k{constructor(u,L){if(this._env=u,this.options=P.mergeConfigurationOptions(L),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let c=this.options.nodeRequire.main.filename,s=Math.max(c.lastIndexOf("/"),c.lastIndexOf("\\"));this.options.baseUrl=c.substring(0,s+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let u=0;u<this.options.ignoreDuplicateModules.length;u++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[u]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],z.Utilities.forEachProperty(this.options.paths,(u,L)=>{Array.isArray(L)?this.sortedPathsRules.push({from:u,to:L}):this.sortedPathsRules.push({from:u,to:[L]})}),this.sortedPathsRules.sort((u,L)=>L.from.length-u.from.length)}cloneAndMerge(u){return new k(this._env,P.mergeConfigurationOptions(u,this.options))}getOptionsLiteral(){return this.options}_applyPaths(u){let L;for(let c=0,s=this.sortedPathsRules.length;c<s;c++)if(L=this.sortedPathsRules[c],z.Utilities.startsWith(u,L.from)){let l=[];for(let f=0,R=L.to.length;f<R;f++)l.push(L.to[f]+u.substr(L.from.length));return l}return[u]}_addUrlArgsToUrl(u){return z.Utilities.containsQueryString(u)?u+"&"+this.options.urlArgs:u+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(u){return this.options.urlArgs?this._addUrlArgsToUrl(u):u}_addUrlArgsIfNecessaryToUrls(u){if(this.options.urlArgs)for(let L=0,c=u.length;L<c;L++)u[L]=this._addUrlArgsToUrl(u[L]);return u}moduleIdToPaths(u){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(u))return this.isBuild()?["empty:"]:["node|"+u];let L=u,c;if(!z.Utilities.endsWith(L,".js")&&!z.Utilities.isAbsolutePath(L)){c=this._applyPaths(L);for(let s=0,l=c.length;s<l;s++)this.isBuild()&&c[s]==="empty:"||(z.Utilities.isAbsolutePath(c[s])||(c[s]=this.options.baseUrl+c[s]),!z.Utilities.endsWith(c[s],".js")&&!z.Utilities.containsQueryString(c[s])&&(c[s]=c[s]+".js"))}else!z.Utilities.endsWith(L,".js")&&!z.Utilities.containsQueryString(L)&&(L=L+".js"),c=[L];return this._addUrlArgsIfNecessaryToUrls(c)}requireToUrl(u){let L=u;return z.Utilities.isAbsolutePath(L)||(L=this._applyPaths(L)[0],z.Utilities.isAbsolutePath(L)||(L=this.options.baseUrl+L)),this._addUrlArgsIfNecessaryToUrl(L)}isBuild(){return this.options.isBuild}shouldInvokeFactory(u){return!!(!this.options.isBuild||z.Utilities.isAnonymousModule(u)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[u])}isDuplicateMessageIgnoredFor(u){return this.ignoreDuplicateModulesMap.hasOwnProperty(u)}getConfigForModule(u){if(this.options.config)return this.options.config[u]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(u){this.options.onError(u)}}z.Configuration=k})(de||(de={}));var de;(function(z){class t{constructor(l){this._env=l,this._scriptLoader=null,this._callbackMap={}}load(l,f,R,h){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=l.getConfig().getOptionsLiteral();e?this._scriptLoader=new P:this._scriptLoader=new u(this._env)}else this._env.isNode?this._scriptLoader=new u(this._env):this._scriptLoader=new P;let o={callback:R,errorback:h};if(this._callbackMap.hasOwnProperty(f)){this._callbackMap[f].push(o);return}this._callbackMap[f]=[o],this._scriptLoader.load(l,f,()=>this.triggerCallback(f),e=>this.triggerErrorback(f,e))}triggerCallback(l){let f=this._callbackMap[l];delete this._callbackMap[l];for(let R=0;R<f.length;R++)f[R].callback()}triggerErrorback(l,f){let R=this._callbackMap[l];delete this._callbackMap[l];for(let h=0;h<R.length;h++)R[h].errorback(f)}}class P{attachListeners(l,f,R){let h=()=>{l.removeEventListener("load",o),l.removeEventListener("error",e)},o=w=>{h(),f()},e=w=>{h(),R(w)};l.addEventListener("load",o),l.addEventListener("error",e)}load(l,f,R,h){if(/^node\|/.test(f)){let o=l.getConfig().getOptionsLiteral(),e=L(l.getRecorder(),o.nodeRequire||z.global.nodeRequire),w=f.split("|"),y=null;try{y=e(w[1])}catch(A){h(A);return}l.enqueueDefineAnonymousModule([],()=>y),R()}else{let o=document.createElement("script");o.setAttribute("async","async"),o.setAttribute("type","text/javascript"),this.attachListeners(o,R,h);const{trustedTypesPolicy:e}=l.getConfig().getOptionsLiteral();e&&(f=e.createScriptURL(f)),o.setAttribute("src",f);const{cspNonce:w}=l.getConfig().getOptionsLiteral();w&&o.setAttribute("nonce",w),document.getElementsByTagName("head")[0].appendChild(o)}}}function k(s){const{trustedTypesPolicy:l}=s.getConfig().getOptionsLiteral();try{return(l?self.eval(l.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(l){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=k(l)),this._cachedCanUseEval}load(l,f,R,h){if(/^node\|/.test(f)){const o=l.getConfig().getOptionsLiteral(),e=L(l.getRecorder(),o.nodeRequire||z.global.nodeRequire),w=f.split("|");let y=null;try{y=e(w[1])}catch(A){h(A);return}l.enqueueDefineAnonymousModule([],function(){return y}),R()}else{const{trustedTypesPolicy:o}=l.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(f)&&f.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(l)){fetch(f).then(w=>{if(w.status!==200)throw new Error(w.statusText);return w.text()}).then(w=>{w=`${w}
//# sourceURL=${f}`,(o?self.eval(o.createScript("",w)):new Function(w)).call(self),R()}).then(void 0,h);return}try{o&&(f=o.createScriptURL(f)),importScripts(f),R()}catch(w){h(w)}}}}class u{constructor(l){this._env=l,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(l){this._didInitialize||(this._didInitialize=!0,this._fs=l("fs"),this._vm=l("vm"),this._path=l("path"),this._crypto=l("crypto"))}_initNodeRequire(l,f){const{nodeCachedData:R}=f.getConfig().getOptionsLiteral();if(!R||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const h=this,o=l("module");function e(w){const y=w.constructor;let A=function(E){try{return w.require(E)}finally{}};return A.resolve=function(E,g){return y._resolveFilename(E,w,!1,g)},A.resolve.paths=function(E){return y._resolveLookupPaths(E,w)},A.main=process.mainModule,A.extensions=y._extensions,A.cache=y._cache,A}o.prototype._compile=function(w,y){const A=o.wrap(w.replace(/^#!.*/,"")),b=f.getRecorder(),E=h._getCachedDataPath(R,y),g={filename:y};let m;try{const p=h._fs.readFileSync(E);m=p.slice(0,16),g.cachedData=p.slice(16),b.record(60,E)}catch{b.record(61,E)}const r=new h._vm.Script(A,g),a=r.runInThisContext(g),N=h._path.dirname(y),d=e(this),_=[this.exports,d,this,y,N,process,We,Buffer],v=a.apply(this.exports,_);return h._handleCachedData(r,A,E,!g.cachedData,f),h._verifyCachedData(r,A,E,m,f),v}}load(l,f,R,h){const o=l.getConfig().getOptionsLiteral(),e=L(l.getRecorder(),o.nodeRequire||z.global.nodeRequire),w=o.nodeInstrumenter||function(A){return A};this._init(e),this._initNodeRequire(e,l);let y=l.getRecorder();if(/^node\|/.test(f)){let A=f.split("|"),b=null;try{b=e(A[1])}catch(E){h(E);return}l.enqueueDefineAnonymousModule([],()=>b),R()}else{f=z.Utilities.fileUriToFilePath(this._env.isWindows,f);const A=this._path.normalize(f),b=this._getElectronRendererScriptPathOrUri(A),E=!!o.nodeCachedData,g=E?this._getCachedDataPath(o.nodeCachedData,f):void 0;this._readSourceAndCachedData(A,g,y,(m,r,a,N)=>{if(m){h(m);return}let d;r.charCodeAt(0)===u._BOM?d=u._PREFIX+r.substring(1)+u._SUFFIX:d=u._PREFIX+r+u._SUFFIX,d=w(d,A);const _={filename:b,cachedData:a},v=this._createAndEvalScript(l,d,_,R,h);this._handleCachedData(v,d,g,E&&!a,l),this._verifyCachedData(v,d,g,N,l)})}}_createAndEvalScript(l,f,R,h,o){const e=l.getRecorder();e.record(31,R.filename);const w=new this._vm.Script(f,R),y=w.runInThisContext(R),A=l.getGlobalAMDDefineFunc();let b=!1;const E=function(){return b=!0,A.apply(null,arguments)};return E.amd=A.amd,y.call(z.global,l.getGlobalAMDRequireFunc(),E,R.filename,this._path.dirname(R.filename)),e.record(32,R.filename),b?h():o(new Error(`Didn't receive define call in ${R.filename}!`)),w}_getElectronRendererScriptPathOrUri(l){if(!this._env.isElectronRenderer)return l;let f=l.match(/^([a-z])\:(.*)/i);return f?`file:///${(f[1].toUpperCase()+":"+f[2]).replace(/\\/g,"/")}`:`file://${l}`}_getCachedDataPath(l,f){const R=this._crypto.createHash("md5").update(f,"utf8").update(l.seed,"utf8").update(process.arch,"").digest("hex"),h=this._path.basename(f).replace(/\.js$/,"");return this._path.join(l.path,`${h}-${R}.code`)}_handleCachedData(l,f,R,h,o){l.cachedDataRejected?this._fs.unlink(R,e=>{o.getRecorder().record(62,R),this._createAndWriteCachedData(l,f,R,o),e&&o.getConfig().onError(e)}):h&&this._createAndWriteCachedData(l,f,R,o)}_createAndWriteCachedData(l,f,R,h){let o=Math.ceil(h.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,w=0,y;const A=()=>{setTimeout(()=>{y||(y=this._crypto.createHash("md5").update(f,"utf8").digest());const b=l.createCachedData();if(!(b.length===0||b.length===e||w>=5)){if(b.length<e){A();return}e=b.length,this._fs.writeFile(R,Buffer.concat([y,b]),E=>{E&&h.getConfig().onError(E),h.getRecorder().record(63,R),A()})}},o*Math.pow(4,w++))};A()}_readSourceAndCachedData(l,f,R,h){if(!f)this._fs.readFile(l,{encoding:"utf8"},h);else{let o,e,w,y=2;const A=b=>{b?h(b):--y===0&&h(void 0,o,e,w)};this._fs.readFile(l,{encoding:"utf8"},(b,E)=>{o=E,A(b)}),this._fs.readFile(f,(b,E)=>{!b&&E&&E.length>0?(w=E.slice(0,16),e=E.slice(16),R.record(60,f)):R.record(61,f),A()})}}_verifyCachedData(l,f,R,h,o){h&&(l.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(f,"utf8").digest();h.equals(e)||(o.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${R}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(R,w=>{w&&o.getConfig().onError(w)}))},Math.ceil(5e3*(1+Math.random()))))}}u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`;function L(s,l){if(l.__$__isRecorded)return l;const f=function(h){s.record(33,h);try{return l(h)}finally{s.record(34,h)}};return f.__$__isRecorded=!0,f}z.ensureRecordedNodeRequire=L;function c(s){return new t(s)}z.createScriptLoader=c})(de||(de={}));var de;(function(z){class t{constructor(s){let l=s.lastIndexOf("/");l!==-1?this.fromModulePath=s.substr(0,l+1):this.fromModulePath=""}static _normalizeModuleId(s){let l=s,f;for(f=/\/\.\//;f.test(l);)l=l.replace(f,"/");for(l=l.replace(/^\.\//g,""),f=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;f.test(l);)l=l.replace(f,"/");return l=l.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),l}resolveModule(s){let l=s;return z.Utilities.isAbsolutePath(l)||(z.Utilities.startsWith(l,"./")||z.Utilities.startsWith(l,"../"))&&(l=t._normalizeModuleId(this.fromModulePath+l)),l}}t.ROOT=new t(""),z.ModuleIdResolver=t;class P{constructor(s,l,f,R,h,o){this.id=s,this.strId=l,this.dependencies=f,this._callback=R,this._errorback=h,this.moduleIdResolver=o,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(s,l){try{return{returnedValue:s.apply(z.global,l),producedError:null}}catch(f){return{returnedValue:null,producedError:f}}}static _invokeFactory(s,l,f,R){return s.shouldInvokeFactory(l)?s.shouldCatchError()?this._safeInvokeFunction(f,R):{returnedValue:f.apply(z.global,R),producedError:null}:{returnedValue:null,producedError:null}}complete(s,l,f,R){this._isComplete=!0;let h=null;if(this._callback)if(typeof this._callback=="function"){s.record(21,this.strId);let o=P._invokeFactory(l,this.strId,this._callback,f);h=o.producedError,s.record(22,this.strId),!h&&typeof o.returnedValue<"u"&&(!this.exportsPassedIn||z.Utilities.isEmpty(this.exports))&&(this.exports=o.returnedValue)}else this.exports=this._callback;if(h){let o=z.ensureError(h);o.phase="factory",o.moduleId=this.strId,o.neededBy=R(this.id),this.error=o,l.onError(o)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(s){return this._isComplete=!0,this.error=s,this._errorback?(this._errorback(s),!0):!1}isComplete(){return this._isComplete}}z.Module=P;class k{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(s){let l=this._strModuleIdToIntModuleId.get(s);return typeof l>"u"&&(l=this._nextId++,this._strModuleIdToIntModuleId.set(s,l),this._intModuleIdToStrModuleId[l]=s),l}getStrModuleId(s){return this._intModuleIdToStrModuleId[s]}}class i{constructor(s){this.id=s}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),z.RegularDependency=i;class u{constructor(s,l,f){this.id=s,this.pluginId=l,this.pluginParam=f}}z.PluginDependency=u;class L{constructor(s,l,f,R,h=0){this._env=s,this._scriptLoader=l,this._loaderAvailableTimestamp=h,this._defineFunc=f,this._requireFunc=R,this._moduleIdProvider=new k,this._config=new z.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new L(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(s,l){let f=o=>o.replace(/\\/g,"/"),R=f(s),h=l.split(/\n/);for(let o=0;o<h.length;o++){let e=h[o].match(/(.*):(\d+):(\d+)\)?$/);if(e){let w=e[1],y=e[2],A=e[3],b=Math.max(w.lastIndexOf(" ")+1,w.lastIndexOf("(")+1);if(w=w.substr(b),w=f(w),w===R){let E={line:parseInt(y,10),col:parseInt(A,10)};return E.line===1&&(E.col-=53),E}}}throw new Error("Could not correlate define call site for needle "+s)}getBuildInfo(){if(!this._config.isBuild())return null;let s=[],l=0;for(let f=0,R=this._modules2.length;f<R;f++){let h=this._modules2[f];if(!h)continue;let o=this._buildInfoPath[h.id]||null,e=this._buildInfoDefineStack[h.id]||null,w=this._buildInfoDependencies[h.id];s[l++]={id:h.strId,path:o,defineLocation:o&&e?L._findRelevantLocationInStack(o,e):null,dependencies:w,shim:null,exports:h.exports}}return s}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new z.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=z.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(s,l){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let f=null;this._config.isBuild()&&(f=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:f,dependencies:s,callback:l}}defineModule(s,l,f,R,h,o=new t(s)){let e=this._moduleIdProvider.getModuleId(s);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(s)||console.warn("Duplicate definition of module '"+s+"'");return}let w=new P(e,s,this._normalizeDependencies(l,o),f,R,o);this._modules2[e]=w,this._config.isBuild()&&(this._buildInfoDefineStack[e]=h,this._buildInfoDependencies[e]=(w.dependencies||[]).map(y=>this._moduleIdProvider.getStrModuleId(y.id))),this._resolve(w)}_normalizeDependency(s,l){if(s==="exports")return i.EXPORTS;if(s==="module")return i.MODULE;if(s==="require")return i.REQUIRE;let f=s.indexOf("!");if(f>=0){let R=l.resolveModule(s.substr(0,f)),h=l.resolveModule(s.substr(f+1)),o=this._moduleIdProvider.getModuleId(R+"!"+h),e=this._moduleIdProvider.getModuleId(R);return new u(o,e,h)}return new i(this._moduleIdProvider.getModuleId(l.resolveModule(s)))}_normalizeDependencies(s,l){let f=[],R=0;for(let h=0,o=s.length;h<o;h++)f[R++]=this._normalizeDependency(s[h],l);return f}_relativeRequire(s,l,f,R){if(typeof l=="string")return this.synchronousRequire(l,s);this.defineModule(z.Utilities.generateAnonymousModule(),l,f,R,null,s)}synchronousRequire(s,l=new t(s)){let f=this._normalizeDependency(s,l),R=this._modules2[f.id];if(!R)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+s+"'. This is the first mention of this module!");if(!R.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+s+"'. This module has not been resolved completely yet.");if(R.error)throw R.error;return R.exports}configure(s,l){let f=this._config.shouldRecordStats();l?this._config=new z.Configuration(this._env,s):this._config=this._config.cloneAndMerge(s),this._config.shouldRecordStats()&&!f&&(this._recorder=null)}getConfig(){return this._config}_onLoad(s){if(this._currentAnonymousDefineCall!==null){let l=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(s),l.dependencies,l.callback,null,l.stack)}}_createLoadError(s,l){let f=this._moduleIdProvider.getStrModuleId(s),R=(this._inverseDependencies2[s]||[]).map(o=>this._moduleIdProvider.getStrModuleId(o));const h=z.ensureError(l);return h.phase="loading",h.moduleId=f,h.neededBy=R,h}_onLoadError(s,l){const f=this._createLoadError(s,l);this._modules2[s]||(this._modules2[s]=new P(s,this._moduleIdProvider.getStrModuleId(s),[],()=>{},null,null));let R=[];for(let e=0,w=this._moduleIdProvider.getMaxModuleId();e<w;e++)R[e]=!1;let h=!1,o=[];for(o.push(s),R[s]=!0;o.length>0;){let e=o.shift(),w=this._modules2[e];w&&(h=w.onDependencyError(f)||h);let y=this._inverseDependencies2[e];if(y)for(let A=0,b=y.length;A<b;A++){let E=y[A];R[E]||(o.push(E),R[E]=!0)}}h||this._config.onError(f)}_hasDependencyPath(s,l){let f=this._modules2[s];if(!f)return!1;let R=[];for(let o=0,e=this._moduleIdProvider.getMaxModuleId();o<e;o++)R[o]=!1;let h=[];for(h.push(f),R[s]=!0;h.length>0;){let e=h.shift().dependencies;if(e)for(let w=0,y=e.length;w<y;w++){let A=e[w];if(A.id===l)return!0;let b=this._modules2[A.id];b&&!R[A.id]&&(R[A.id]=!0,h.push(b))}}return!1}_findCyclePath(s,l,f){if(s===l||f===50)return[s];let R=this._modules2[s];if(!R)return null;let h=R.dependencies;if(h)for(let o=0,e=h.length;o<e;o++){let w=this._findCyclePath(h[o].id,l,f+1);if(w!==null)return w.push(s),w}return null}_createRequire(s){let l=(f,R,h)=>this._relativeRequire(s,f,R,h);return l.toUrl=f=>this._config.requireToUrl(s.resolveModule(f)),l.getStats=()=>this.getLoaderEvents(),l.hasDependencyCycle=()=>this._hasDependencyCycle,l.config=(f,R=!1)=>{this.configure(f,R)},l.__$__nodeRequire=z.global.nodeRequire,l}_loadModule(s){if(this._modules2[s]||this._knownModules2[s])return;this._knownModules2[s]=!0;let l=this._moduleIdProvider.getStrModuleId(s),f=this._config.moduleIdToPaths(l),R=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(l.indexOf("/")===-1||R.test(l))&&f.push("node|"+l);let h=-1,o=e=>{if(h++,h>=f.length)this._onLoadError(s,e);else{let w=f[h],y=this.getRecorder();if(this._config.isBuild()&&w==="empty:"){this._buildInfoPath[s]=w,this.defineModule(this._moduleIdProvider.getStrModuleId(s),[],null,null,null),this._onLoad(s);return}y.record(10,w),this._scriptLoader.load(this,w,()=>{this._config.isBuild()&&(this._buildInfoPath[s]=w),y.record(11,w),this._onLoad(s)},A=>{y.record(12,w),o(A)})}};o(null)}_loadPluginDependency(s,l){if(this._modules2[l.id]||this._knownModules2[l.id])return;this._knownModules2[l.id]=!0;let f=R=>{this.defineModule(this._moduleIdProvider.getStrModuleId(l.id),[],R,null,null)};f.error=R=>{this._config.onError(this._createLoadError(l.id,R))},s.load(l.pluginParam,this._createRequire(t.ROOT),f,this._config.getOptionsLiteral())}_resolve(s){let l=s.dependencies;if(l)for(let f=0,R=l.length;f<R;f++){let h=l[f];if(h===i.EXPORTS){s.exportsPassedIn=!0,s.unresolvedDependenciesCount--;continue}if(h===i.MODULE){s.unresolvedDependenciesCount--;continue}if(h===i.REQUIRE){s.unresolvedDependenciesCount--;continue}let o=this._modules2[h.id];if(o&&o.isComplete()){if(o.error){s.onDependencyError(o.error);return}s.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(h.id,s.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(h.id)+"' and '"+this._moduleIdProvider.getStrModuleId(s.id)+"'. The cyclic path follows:");let e=this._findCyclePath(h.id,s.id,0)||[];e.reverse(),e.push(h.id),console.warn(e.map(w=>this._moduleIdProvider.getStrModuleId(w)).join(` => 
`)),s.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[h.id]=this._inverseDependencies2[h.id]||[],this._inverseDependencies2[h.id].push(s.id),h instanceof u){let e=this._modules2[h.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,h);continue}let w=this._inversePluginDependencies2.get(h.pluginId);w||(w=[],this._inversePluginDependencies2.set(h.pluginId,w)),w.push(h),this._loadModule(h.pluginId);continue}this._loadModule(h.id)}s.unresolvedDependenciesCount===0&&this._onModuleComplete(s)}_onModuleComplete(s){let l=this.getRecorder();if(s.isComplete())return;let f=s.dependencies,R=[];if(f)for(let w=0,y=f.length;w<y;w++){let A=f[w];if(A===i.EXPORTS){R[w]=s.exports;continue}if(A===i.MODULE){R[w]={id:s.strId,config:()=>this._config.getConfigForModule(s.strId)};continue}if(A===i.REQUIRE){R[w]=this._createRequire(s.moduleIdResolver);continue}let b=this._modules2[A.id];if(b){R[w]=b.exports;continue}R[w]=null}const h=w=>(this._inverseDependencies2[w]||[]).map(y=>this._moduleIdProvider.getStrModuleId(y));s.complete(l,this._config,R,h);let o=this._inverseDependencies2[s.id];if(this._inverseDependencies2[s.id]=null,o)for(let w=0,y=o.length;w<y;w++){let A=o[w],b=this._modules2[A];b.unresolvedDependenciesCount--,b.unresolvedDependenciesCount===0&&this._onModuleComplete(b)}let e=this._inversePluginDependencies2.get(s.id);if(e){this._inversePluginDependencies2.delete(s.id);for(let w=0,y=e.length;w<y;w++)this._loadPluginDependency(s.exports,e[w])}}}z.ModuleManager=L})(de||(de={}));var Z,de;(function(z){const t=new z.Environment;let P=null;const k=function(c,s,l){typeof c!="string"&&(l=s,s=c,c=null),(typeof s!="object"||!Array.isArray(s))&&(l=s,s=null),s||(s=["require","exports","module"]),c?P.defineModule(c,s,l,null,null):P.enqueueDefineAnonymousModule(s,l)};k.amd={jQuery:!0};const i=function(c,s=!1){P.configure(c,s)},u=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return P.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){P.defineModule(z.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};u.config=i,u.getConfig=function(){return P.getConfig().getOptionsLiteral()},u.reset=function(){P=P.reset()},u.getBuildInfo=function(){return P.getBuildInfo()},u.getStats=function(){return P.getLoaderEvents()},u.define=k;function L(){if(typeof z.global.require<"u"||typeof require<"u"){const c=z.global.require||require;if(typeof c=="function"&&typeof c.resolve=="function"){const s=z.ensureRecordedNodeRequire(P.getRecorder(),c);z.global.nodeRequire=s,u.nodeRequire=s,u.__$__nodeRequire=s}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=u:(t.isElectronRenderer||(z.global.define=k),z.global.require=u)}z.init=L,(typeof z.global.define!="function"||!z.global.define.amd)&&(P=new z.ModuleManager(t,z.createScriptLoader(t),k,u,z.Utilities.getHighPerformanceTimestamp()),typeof z.global.require<"u"&&typeof z.global.require!="function"&&u.config(z.global.require),Z=function(){return k.apply(null,arguments)},Z.amd=k.amd,typeof doNotInitLoader>"u"&&L())})(de||(de={})),Z(J[62],K([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function P(c,s,l,f){if(f=f||{},(f["vs/css"]||{}).disabled){l({});return}const h=s.toUrl(c+".css");k(c,h,()=>{l({})},o=>{typeof l.error=="function"&&l.error("Could not find "+h+".")})}t.load=P;function k(c,s,l,f){if(i(c,s)){l();return}u(c,s,l,f)}function i(c,s){const l=document.getElementsByTagName("link");for(let f=0,R=l.length;f<R;f++){const h=l[f].getAttribute("data-name"),o=l[f].getAttribute("href");if(h===c||o===s)return!0}return!1}function u(c,s,l,f){const R=document.createElement("link");R.setAttribute("rel","stylesheet"),R.setAttribute("type","text/css"),R.setAttribute("data-name",c),L(c,R,l,f),R.setAttribute("href",s),(document.head||document.getElementsByTagName("head")[0]).appendChild(R)}function L(c,s,l,f){const R=()=>{s.removeEventListener("load",h),s.removeEventListener("error",o)},h=e=>{R(),l()},o=e=>{R(),f(e)};s.addEventListener("load",h),s.addEventListener("error",o)}}),Z("vs/nls",["require","exports"],function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let P=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const k="i-default";function i(e,w){let y;return w.length===0?y=e:y=e.replace(/\{(\d+)\}/g,(A,b)=>{const E=b[0],g=w[E];let m=A;return typeof g=="string"?m=g:(typeof g=="number"||typeof g=="boolean"||g===void 0||g===null)&&(m=String(g)),m}),P&&(y="\uFF3B"+y.replace(/[aouei]/g,"$&$&")+"\uFF3D"),y}function u(e,w){let y=e[w];return y||(y=e["*"],y)?y:null}function L(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function c(e,w,y){const A=L(e)+L(w)+"vscode/"+L(y),b=await fetch(A);if(b.ok)return await b.json();throw new Error(`${b.status} - ${b.statusText}`)}function s(e){return function(w,y){const A=Array.prototype.slice.call(arguments,2);return i(e[w],A)}}function l(e,w,...y){return i(w,y)}t.localize=l;function f(e){}t.getConfiguredDefaultLocale=f;function R(e){P=e}t.setPseudoTranslation=R;function h(e,w){return{localize:s(w[e]),getConfiguredDefaultLocale:w.getConfiguredDefaultLocale??(y=>{})}}t.create=h;function o(e,w,y,A){const b=A["vs/nls"]??{};if(!e||e.length===0)return y({localize:l,getConfiguredDefaultLocale:()=>b.availableLanguages?.["*"]});const E=b.availableLanguages?u(b.availableLanguages,e):null,g=E===null||E===k;let m=".nls";g||(m=m+"."+E);const r=a=>{Array.isArray(a)?a.localize=s(a):a.localize=s(a[e]),a.getConfiguredDefaultLocale=()=>b.availableLanguages?.["*"],y(a)};typeof b.loadBundle=="function"?b.loadBundle(e,E,(a,N)=>{a?w([e+".nls"],r):r(N)}):b.translationServiceUrl&&!g?(async()=>{try{const a=await c(b.translationServiceUrl,E,e);return r(a)}catch(a){if(!E.includes("-"))return console.error(a),w([e+".nls"],r);try{const N=E.split("-")[0],d=await c(b.translationServiceUrl,N,e);return b.availableLanguages??={},b.availableLanguages["*"]=N,r(d)}catch(N){return console.error(N),w([e+".nls"],r)}}})():w([e+m],r,a=>{if(m===".nls"){console.error("Failed trying to load default language strings",a);return}console.error(`Failed to load message bundle for language ${E}. Falling back to the default language:`,a),w([e+".nls"],r)})}t.load=o}),function(){const z=globalThis.MonacoEnvironment,t=z&&z.baseUrl?z.baseUrl:"../../../";function P(f,R){if(z?.createTrustedTypesPolicy)try{return z.createTrustedTypesPolicy(f,R)}catch(h){console.warn(h);return}try{return self.trustedTypes?.createPolicy(f,R)}catch(h){console.warn(h);return}}const k=P("amdLoader",{createScriptURL:f=>f,createScript:(f,...R)=>{const h=R.slice(0,-1).join(","),o=R.pop().toString();return`(function anonymous(${h}) { ${o}
})`}});function i(){try{return(k?globalThis.eval(k.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function u(){return new Promise((f,R)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return f();const h=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(h).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${h}`,(k?globalThis.eval(k.createScript("",e)):new Function(e)).call(globalThis),f()}).then(void 0,R);return}k?importScripts(k.createScriptURL(h)):importScripts(h),f()})}function L(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:k,amdModulesPattern:/^vs\//})}function c(f){u().then(()=>{L(),require([f],function(R){setTimeout(function(){const h=R.create((o,e)=>{globalThis.postMessage(o,e)},null);for(globalThis.onmessage=o=>h.onmessage(o.data,o.ports);l.length>0;){const o=l.shift();h.onmessage(o.data,o.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&L();let s=!0;const l=[];globalThis.onmessage=f=>{if(!s){l.push(f);return}s=!1,c(f.data)}}(),Z(J[27],K([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function P(c,s){const l=Math.pow(10,s);return Math.round(c*l)/l}class k{constructor(s,l,f,R=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,s))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=P(Math.max(Math.min(1,R),0),3)}static equals(s,l){return s.r===l.r&&s.g===l.g&&s.b===l.b&&s.a===l.a}}t.RGBA=k;class i{constructor(s,l,f,R){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,s),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.l=P(Math.max(Math.min(1,f),0),3),this.a=P(Math.max(Math.min(1,R),0),3)}static equals(s,l){return s.h===l.h&&s.s===l.s&&s.l===l.l&&s.a===l.a}static fromRGBA(s){const l=s.r/255,f=s.g/255,R=s.b/255,h=s.a,o=Math.max(l,f,R),e=Math.min(l,f,R);let w=0,y=0;const A=(e+o)/2,b=o-e;if(b>0){switch(y=Math.min(A<=.5?b/(2*A):b/(2-2*A),1),o){case l:w=(f-R)/b+(f<R?6:0);break;case f:w=(R-l)/b+2;break;case R:w=(l-f)/b+4;break}w*=60,w=Math.round(w)}return new i(w,y,A,h)}static _hue2rgb(s,l,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?s+(l-s)*6*f:f<1/2?l:f<2/3?s+(l-s)*(2/3-f)*6:s}static toRGBA(s){const l=s.h/360,{s:f,l:R,a:h}=s;let o,e,w;if(f===0)o=e=w=R;else{const y=R<.5?R*(1+f):R+f-R*f,A=2*R-y;o=i._hue2rgb(A,y,l+1/3),e=i._hue2rgb(A,y,l),w=i._hue2rgb(A,y,l-1/3)}return new k(Math.round(o*255),Math.round(e*255),Math.round(w*255),h)}}t.HSLA=i;class u{constructor(s,l,f,R){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,s),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.v=P(Math.max(Math.min(1,f),0),3),this.a=P(Math.max(Math.min(1,R),0),3)}static equals(s,l){return s.h===l.h&&s.s===l.s&&s.v===l.v&&s.a===l.a}static fromRGBA(s){const l=s.r/255,f=s.g/255,R=s.b/255,h=Math.max(l,f,R),o=Math.min(l,f,R),e=h-o,w=h===0?0:e/h;let y;return e===0?y=0:h===l?y=((f-R)/e%6+6)%6:h===f?y=(R-l)/e+2:y=(l-f)/e+4,new u(Math.round(y*60),w,h,s.a)}static toRGBA(s){const{h:l,s:f,v:R,a:h}=s,o=R*f,e=o*(1-Math.abs(l/60%2-1)),w=R-o;let[y,A,b]=[0,0,0];return l<60?(y=o,A=e):l<120?(y=e,A=o):l<180?(A=o,b=e):l<240?(A=e,b=o):l<300?(y=e,b=o):l<=360&&(y=o,b=e),y=Math.round((y+w)*255),A=Math.round((A+w)*255),b=Math.round((b+w)*255),new k(y,A,b,h)}}t.HSVA=u;class L{static fromHex(s){return L.Format.CSS.parseHex(s)||L.red}static equals(s,l){return!s&&!l?!0:!s||!l?!1:s.equals(l)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:u.fromRGBA(this.rgba)}constructor(s){if(s)if(s instanceof k)this.rgba=s;else if(s instanceof i)this._hsla=s,this.rgba=i.toRGBA(s);else if(s instanceof u)this._hsva=s,this.rgba=u.toRGBA(s);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(s){return!!s&&k.equals(this.rgba,s.rgba)&&i.equals(this.hsla,s.hsla)&&u.equals(this.hsva,s.hsva)}getRelativeLuminance(){const s=L._relativeLuminanceForComponent(this.rgba.r),l=L._relativeLuminanceForComponent(this.rgba.g),f=L._relativeLuminanceForComponent(this.rgba.b),R=.2126*s+.7152*l+.0722*f;return P(R,4)}static _relativeLuminanceForComponent(s){const l=s/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(s){const l=this.getRelativeLuminance(),f=s.getRelativeLuminance();return l>f?(l+.05)/(f+.05):(f+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(s){const l=this.getRelativeLuminance(),f=s.getRelativeLuminance();return l>f}isDarkerThan(s){const l=this.getRelativeLuminance(),f=s.getRelativeLuminance();return l<f}lighten(s){return new L(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*s,this.hsla.a))}darken(s){return new L(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*s,this.hsla.a))}transparent(s){const{r:l,g:f,b:R,a:h}=this.rgba;return new L(new k(l,f,R,h*s))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new L(new k(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(s){const l=s.rgba,f=this.rgba.a,R=l.a,h=f+R*(1-f);if(h<1e-6)return L.transparent;const o=this.rgba.r*f/h+l.r*R*(1-f)/h,e=this.rgba.g*f/h+l.g*R*(1-f)/h,w=this.rgba.b*f/h+l.b*R*(1-f)/h;return new L(new k(o,e,w,h))}makeOpaque(s){if(this.isOpaque()||s.rgba.a!==1)return this;const{r:l,g:f,b:R,a:h}=this.rgba;return new L(new k(s.rgba.r-h*(s.rgba.r-l),s.rgba.g-h*(s.rgba.g-f),s.rgba.b-h*(s.rgba.b-R),1))}flatten(...s){const l=s.reduceRight((f,R)=>L._flatten(R,f));return L._flatten(this,l)}static _flatten(s,l){const f=1-s.rgba.a;return new L(new k(f*l.rgba.r+s.rgba.a*s.rgba.r,f*l.rgba.g+s.rgba.a*s.rgba.g,f*l.rgba.b+s.rgba.a*s.rgba.b))}toString(){return this._toString||(this._toString=L.Format.CSS.format(this)),this._toString}static getLighterColor(s,l,f){if(s.isLighterThan(l))return s;f=f||.5;const R=s.getRelativeLuminance(),h=l.getRelativeLuminance();return f=f*(h-R)/h,s.lighten(f)}static getDarkerColor(s,l,f){if(s.isDarkerThan(l))return s;f=f||.5;const R=s.getRelativeLuminance(),h=l.getRelativeLuminance();return f=f*(R-h)/R,s.darken(f)}static{this.white=new L(new k(255,255,255,1))}static{this.black=new L(new k(0,0,0,1))}static{this.red=new L(new k(255,0,0,1))}static{this.blue=new L(new k(0,0,255,1))}static{this.green=new L(new k(0,255,0,1))}static{this.cyan=new L(new k(0,255,255,1))}static{this.lightgrey=new L(new k(211,211,211,1))}static{this.transparent=new L(new k(0,0,0,0))}}t.Color=L,function(c){let s;(function(l){let f;(function(R){function h(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:c.Format.CSS.formatRGBA(r)}R.formatRGB=h;function o(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}R.formatRGBA=o;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:c.Format.CSS.formatHSLA(r)}R.formatHSL=e;function w(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}R.formatHSLA=w;function y(r){const a=r.toString(16);return a.length!==2?"0"+a:a}function A(r){return`#${y(r.rgba.r)}${y(r.rgba.g)}${y(r.rgba.b)}`}R.formatHex=A;function b(r,a=!1){return a&&r.rgba.a===1?c.Format.CSS.formatHex(r):`#${y(r.rgba.r)}${y(r.rgba.g)}${y(r.rgba.b)}${y(Math.round(r.rgba.a*255))}`}R.formatHexA=b;function E(r){return r.isOpaque()?c.Format.CSS.formatHex(r):c.Format.CSS.formatRGBA(r)}R.format=E;function g(r){const a=r.length;if(a===0||r.charCodeAt(0)!==35)return null;if(a===7){const N=16*m(r.charCodeAt(1))+m(r.charCodeAt(2)),d=16*m(r.charCodeAt(3))+m(r.charCodeAt(4)),_=16*m(r.charCodeAt(5))+m(r.charCodeAt(6));return new c(new k(N,d,_,1))}if(a===9){const N=16*m(r.charCodeAt(1))+m(r.charCodeAt(2)),d=16*m(r.charCodeAt(3))+m(r.charCodeAt(4)),_=16*m(r.charCodeAt(5))+m(r.charCodeAt(6)),v=16*m(r.charCodeAt(7))+m(r.charCodeAt(8));return new c(new k(N,d,_,v/255))}if(a===4){const N=m(r.charCodeAt(1)),d=m(r.charCodeAt(2)),_=m(r.charCodeAt(3));return new c(new k(16*N+N,16*d+d,16*_+_))}if(a===5){const N=m(r.charCodeAt(1)),d=m(r.charCodeAt(2)),_=m(r.charCodeAt(3)),v=m(r.charCodeAt(4));return new c(new k(16*N+N,16*d+d,16*_+_,(16*v+v)/255))}return null}R.parseHex=g;function m(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(f=l.CSS||(l.CSS={}))})(s=c.Format||(c.Format={}))}(L||(t.Color=L={}))}),Z(J[28],K([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class P{constructor(i,u,L,c){this.originalStart=i,this.originalLength=u,this.modifiedStart=L,this.modifiedLength=c}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=P}),Z(J[3],K([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class P{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?g.isErrorNoTelemetry(a)?new g(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(N=>{N(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}t.ErrorHandler=P,t.errorHandler=new P;function k(r){t.errorHandler.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=k;function i(r){if(!r||typeof r!="object")return!1;const a=r;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function u(r){l(r)||t.errorHandler.onUnexpectedError(r)}t.onUnexpectedError=u;function L(r){l(r)||t.errorHandler.onUnexpectedExternalError(r)}t.onUnexpectedExternalError=L;function c(r){if(r instanceof Error){const{name:a,message:N}=r,d=r.stacktrace||r.stack;return{$isError:!0,name:a,message:N,stack:d,noTelemetry:g.isErrorNoTelemetry(r)}}return r}t.transformErrorForSerialization=c;const s="Canceled";function l(r){return r instanceof f?!0:r instanceof Error&&r.name===s&&r.message===s}t.isCancellationError=l;class f extends Error{constructor(){super(s),this.name=this.message}}t.CancellationError=f;function R(){const r=new Error(s);return r.name=r.message,r}t.canceled=R;function h(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.illegalArgument=h;function o(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.illegalState=o;function e(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function w(r){const a=new Error(`${r} has been disposed`);return a.name="DISPOSED",a}t.disposed=w;function y(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.getErrorMessage=y;class A extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}t.NotImplementedError=A;class b extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}t.NotSupportedError=b;class E extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=E;class g extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof g)return a;const N=new g;return N.message=a.message,N.stack=a.stack,N}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}t.ErrorNoTelemetry=g;class m extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}t.BugIndicatingError=m}),Z(J[29],K([0,1,3]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function k(C,U=0){return C[C.length-(1+U)]}t.tail=k;function i(C){if(C.length===0)throw new Error("Invalid tail call");return[C.slice(0,C.length-1),C[C.length-1]]}t.tail2=i;function u(C,U,B=(x,j)=>x===j){if(C===U)return!0;if(!C||!U||C.length!==U.length)return!1;for(let x=0,j=C.length;x<j;x++)if(!B(C[x],U[x]))return!1;return!0}t.equals=u;function L(C,U){const B=C.length-1;U<B&&(C[U]=C[B]),C.pop()}t.removeFastWithoutKeepingOrder=L;function c(C,U,B){return s(C.length,x=>B(C[x],U))}t.binarySearch=c;function s(C,U){let B=0,x=C-1;for(;B<=x;){const j=(B+x)/2|0,Y=U(j);if(Y<0)B=j+1;else if(Y>0)x=j-1;else return j}return-(B+1)}t.binarySearch2=s;function l(C,U){let B=0,x=C.length;if(x===0)return 0;for(;B<x;){const j=Math.floor((B+x)/2);U(C[j])?x=j:B=j+1}return B}t.findFirstInSorted=l;function f(C,U,B){if(C=C|0,C>=U.length)throw new TypeError("invalid index");const x=U[Math.floor(U.length*Math.random())],j=[],Y=[],te=[];for(const se of U){const fe=B(se,x);fe<0?j.push(se):fe>0?Y.push(se):te.push(se)}return C<j.length?f(C,j,B):C<j.length+te.length?te[0]:f(C-(j.length+te.length),Y,B)}t.quickSelect=f;function R(C,U){const B=[];let x;for(const j of C.slice(0).sort(U))!x||U(x[0],j)!==0?(x=[j],B.push(x)):x.push(j);return B}t.groupBy=R;function h(C,U,B){const x=[];function j(se,fe,he){if(fe===0&&he.length===0)return;const _e=x[x.length-1];_e&&_e.start+_e.deleteCount===se?(_e.deleteCount+=fe,_e.toInsert.push(...he)):x.push({start:se,deleteCount:fe,toInsert:he})}let Y=0,te=0;for(;;){if(Y===C.length){j(Y,0,U.slice(te));break}if(te===U.length){j(Y,C.length-Y,[]);break}const se=C[Y],fe=U[te],he=B(se,fe);he===0?(Y+=1,te+=1):he<0?(j(Y,1,[]),Y+=1):he>0&&(j(Y,0,[fe]),te+=1)}return x}t.sortedDiff=h;function o(C,U,B){const x=h(C,U,B),j=[],Y=[];for(const te of x)j.push(...C.slice(te.start,te.start+te.deleteCount)),Y.push(...te.toInsert);return{removed:j,added:Y}}t.delta=o;function e(C,U,B){if(B===0)return[];const x=C.slice(0,B).sort(U);return y(C,U,x,B,C.length),x}t.top=e;function w(C,U,B,x,j){return B===0?Promise.resolve([]):new Promise((Y,te)=>{(async()=>{const se=C.length,fe=C.slice(0,B).sort(U);for(let he=B,_e=Math.min(B+x,se);he<se;he=_e,_e=Math.min(_e+x,se)){if(he>B&&await new Promise(ye=>setTimeout(ye)),j&&j.isCancellationRequested)throw new P.CancellationError;y(C,U,fe,he,_e)}return fe})().then(Y,te)})}t.topAsync=w;function y(C,U,B,x,j){for(const Y=B.length;x<j;x++){const te=C[x];if(U(te,B[Y-1])<0){B.pop();const se=l(B,fe=>U(te,fe)<0);B.splice(se,0,te)}}}function A(C){return C.filter(U=>!!U)}t.coalesce=A;function b(C){let U=0;for(let B=0;B<C.length;B++)C[B]&&(C[U]=C[B],U+=1);C.length=U}t.coalesceInPlace=b;function E(C,U,B){C.splice(B,0,C.splice(U,1)[0])}t.move=E;function g(C){return!Array.isArray(C)||C.length===0}t.isFalsyOrEmpty=g;function m(C){return Array.isArray(C)&&C.length>0}t.isNonEmptyArray=m;function r(C,U=B=>B){const B=new Set;return C.filter(x=>{const j=U(x);return B.has(j)?!1:(B.add(j),!0)})}t.distinct=r;function a(C){const U=new Set;return B=>{const x=C(B);return U.has(x)?!1:(U.add(x),!0)}}t.uniqueFilter=a;function N(C,U){const B=d(C,U);if(B!==-1)return C[B]}t.findLast=N;function d(C,U){for(let B=C.length-1;B>=0;B--){const x=C[B];if(U(x))return B}return-1}t.lastIndex=d;function _(C,U){return C.length>0?C[0]:U}t.firstOrDefault=_;function v(C,U){return C.length>0?C[C.length-1]:U}t.lastOrDefault=v;function p(C,U,B=(x,j)=>x===j){let x=0;for(let j=0,Y=Math.min(C.length,U.length);j<Y&&B(C[j],U[j]);j++)x++;return x}t.commonPrefixLength=p;function D(C){return[].concat(...C)}t.flatten=D;function M(C,U){let B=typeof U=="number"?C:0;typeof U=="number"?B=C:(B=0,U=C);const x=[];if(B<=U)for(let j=B;j<U;j++)x.push(j);else for(let j=B;j>U;j--)x.push(j);return x}t.range=M;function F(C,U,B){return C.reduce((x,j)=>(x[U(j)]=B?B(j):j,x),Object.create(null))}t.index=F;function I(C,U){return C.push(U),()=>q(C,U)}t.insert=I;function q(C,U){const B=C.indexOf(U);if(B>-1)return C.splice(B,1),U}t.remove=q;function O(C,U,B){const x=C.slice(0,U),j=C.slice(U);return x.concat(B,j)}t.arrayInsert=O;function H(C,U){let B;if(typeof U=="number"){let x=U;B=()=>{const j=Math.sin(x++)*179426549;return j-Math.floor(j)}}else B=Math.random;for(let x=C.length-1;x>0;x-=1){const j=Math.floor(B()*(x+1)),Y=C[x];C[x]=C[j],C[j]=Y}}t.shuffle=H;function S(C,U){const B=C.indexOf(U);B>-1&&(C.splice(B,1),C.unshift(U))}t.pushToStart=S;function W(C,U){const B=C.indexOf(U);B>-1&&(C.splice(B,1),C.push(U))}t.pushToEnd=W;function Q(C,U){for(const B of U)C.push(B)}t.pushMany=Q;function $(C,U){return Array.isArray(C)?C.map(U):U(C)}t.mapArrayOrNot=$;function ne(C){return Array.isArray(C)?C:[C]}t.asArray=ne;function n(C){return C[Math.floor(Math.random()*C.length)]}t.getRandomElement=n;function oe(C,U){for(const B of C){const x=U(B);if(x!==void 0)return x}}t.mapFind=oe;function ce(C,U,B){const x=ge(C,U),j=C.length,Y=B.length;C.length=j+Y;for(let te=j-1;te>=x;te--)C[te+Y]=C[te];for(let te=0;te<Y;te++)C[te+x]=B[te]}t.insertInto=ce;function me(C,U,B,x){const j=ge(C,U),Y=C.splice(j,B);return ce(C,j,x),Y}t.splice=me;function ge(C,U){return U<0?Math.max(U+C.length,0):Math.min(U,C.length)}var Le;(function(C){function U(j){return j<0}C.isLessThan=U;function B(j){return j>0}C.isGreaterThan=B;function x(j){return j===0}C.isNeitherLessOrGreaterThan=x,C.greaterThan=1,C.lessThan=-1,C.neitherLessOrGreaterThan=0})(Le||(t.CompareResult=Le={}));function pe(C,U){return(B,x)=>U(C(B),C(x))}t.compareBy=pe;function Ne(...C){return(U,B)=>{for(const x of C){const j=x(U,B);if(!Le.isNeitherLessOrGreaterThan(j))return j}return Le.neitherLessOrGreaterThan}}t.tieBreakComparators=Ne;const we=(C,U)=>C-U;t.numberComparator=we;function Me(C,U){if(C.length===0)return;let B=C[0];for(let x=1;x<C.length;x++){const j=C[x];U(j,B)>0&&(B=j)}return B}t.findMaxBy=Me;function ae(C,U){if(C.length===0)return;let B=C[0];for(let x=1;x<C.length;x++){const j=C[x];U(j,B)>=0&&(B=j)}return B}t.findLastMaxBy=ae;function ue(C,U){return Me(C,(B,x)=>-U(B,x))}t.findMinBy=ue;class ie{constructor(U){this.items=U,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(U){let B=this.firstIdx;for(;B<this.items.length&&U(this.items[B]);)B++;const x=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,x}takeFromEndWhile(U){let B=this.lastIdx;for(;B>=0&&U(this.items[B]);)B--;const x=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,x}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const U=this.items[this.firstIdx];return this.firstIdx++,U}removeLast(){const U=this.items[this.lastIdx];return this.lastIdx--,U}takeCount(U){const B=this.items.slice(this.firstIdx,this.firstIdx+U);return this.firstIdx+=U,B}}t.ArrayQueue=ie;class le{static{this.empty=new le(U=>{})}constructor(U){this.iterate=U}forEach(U){this.iterate(B=>(U(B),!0))}toArray(){const U=[];return this.iterate(B=>(U.push(B),!0)),U}filter(U){return new le(B=>this.iterate(x=>U(x)?B(x):!0))}map(U){return new le(B=>this.iterate(x=>B(U(x))))}some(U){let B=!1;return this.iterate(x=>(B=U(x),!B)),B}findFirst(U){let B;return this.iterate(x=>U(x)?(B=x,!1):!0),B}findLast(U){let B;return this.iterate(x=>(U(x)&&(B=x),!0)),B}findLastMaxBy(U){let B,x=!0;return this.iterate(j=>((x||Le.isGreaterThan(U(j,B)))&&(x=!1,B=j),!0)),B}}t.CallbackIterable=le}),Z(J[10],K([0,1,3]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function k(s,l){if(!s)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}t.ok=k;function i(s,l="Unreachable"){throw new Error(l)}t.assertNever=i;function u(s){if(!s)throw new P.BugIndicatingError("Assertion Failed")}t.assert=u;function L(s){if(!s()){debugger;s(),(0,P.onUnexpectedError)(new P.BugIndicatingError("Assertion Failed"))}}t.assertFn=L;function c(s,l){let f=0;for(;f<s.length-1;){const R=s[f],h=s[f+1];if(!l(R,h))return!1;f++}return!0}t.checkAdjacentItems=c}),Z(J[15],K([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function P(k){const i=this;let u=!1,L;return function(){return u||(u=!0,L=k.apply(i,arguments)),L}}t.once=P}),Z(J[16],K([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var P;(function(k){function i(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}k.is=i;const u=Object.freeze([]);function L(){return u}k.empty=L;function*c(g){yield g}k.single=c;function s(g){return i(g)?g:c(g)}k.wrap=s;function l(g){return g||u}k.from=l;function f(g){return!g||g[Symbol.iterator]().next().done===!0}k.isEmpty=f;function R(g){return g[Symbol.iterator]().next().value}k.first=R;function h(g,m){for(const r of g)if(m(r))return!0;return!1}k.some=h;function o(g,m){for(const r of g)if(m(r))return r}k.find=o;function*e(g,m){for(const r of g)m(r)&&(yield r)}k.filter=e;function*w(g,m){let r=0;for(const a of g)yield m(a,r++)}k.map=w;function*y(...g){for(const m of g)for(const r of m)yield r}k.concat=y;function A(g,m,r){let a=r;for(const N of g)a=m(a,N);return a}k.reduce=A;function*b(g,m,r=g.length){for(m<0&&(m+=g.length),r<0?r+=g.length:r>g.length&&(r=g.length);m<r;m++)yield g[m]}k.slice=b;function E(g,m=Number.POSITIVE_INFINITY){const r=[];if(m===0)return[r,g];const a=g[Symbol.iterator]();for(let N=0;N<m;N++){const d=a.next();if(d.done)return[r,k.empty()];r.push(d.value)}return[r,{[Symbol.iterator](){return a}}]}k.consume=E})(P||(t.Iterable=P={}))}),Z(J[30],K([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(P||(t.KeyCode=P={}));var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(k||(t.ScanCode=k={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,y){this._keyCodeToStr[w]=y,this._strToKeyCode[y.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const u=new i,L=new i,c=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const s=[],l=Object.create(null),f=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>f[e]||0,toEnum:e=>l[e]||0,toString:e=>s[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",w=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],y=[],A=[];for(const b of w){const[E,g,m,r,a,N,d,_,v]=b;if(A[g]||(A[g]=!0,s[g]=m,l[m]=g,f[m.toLowerCase()]=g,E&&(t.IMMUTABLE_CODE_TO_KEY_CODE[g]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[r]=g))),!y[r]){if(y[r]=!0,!a)throw new Error(`String representation missing for key code ${r} around scan code ${m}`);u.define(r,a),L.define(r,_||a),c.define(r,v||_||a)}N&&(t.EVENT_KEY_CODE_MAP[N]=r),d&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[d]=r)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var R;(function(e){function w(m){return u.keyCodeToStr(m)}e.toString=w;function y(m){return u.strToKeyCode(m)}e.fromString=y;function A(m){return L.keyCodeToStr(m)}e.toUserSettingsUS=A;function b(m){return c.keyCodeToStr(m)}e.toUserSettingsGeneral=b;function E(m){return L.strToKeyCode(m)||c.strToKeyCode(m)}e.fromUserSettings=E;function g(m){if(m>=98&&m<=113)return null;switch(m){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return u.keyCodeToStr(m)}e.toElectronAccelerator=g})(R||(t.KeyCodeUtils=R={}));var h;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(h||(t.KeyMod=h={}));function o(e,w){const y=(w&65535)<<16>>>0;return(e|y)>>>0}t.KeyChord=o}),Z(J[31],K([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class P{constructor(i){this.executor=i,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=P}),Z(J[7],K([0,1,15,16]),function(z,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let u=null;function L(v){u=v}if(t.setDisposableTracker=L,i){const v="__is_disposable_tracked__";L(new class{trackDisposable(p){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[v]||console.log(D)},3e3)}setParent(p,D){if(p&&p!==b.None)try{p[v]=!0}catch{}}markAsDisposed(p){if(p&&p!==b.None)try{p[v]=!0}catch{}}markAsSingleton(p){}})}function c(v){return u?.trackDisposable(v),v}function s(v){u?.markAsDisposed(v)}function l(v,p){u?.setParent(v,p)}function f(v,p){if(u)for(const D of v)u.setParent(D,p)}function R(v){return u?.markAsSingleton(v),v}t.markAsSingleton=R;function h(v){return typeof v.dispose=="function"&&v.dispose.length===0}t.isDisposable=h;function o(v){if(k.Iterable.is(v)){const p=[];for(const D of v)if(D)try{D.dispose()}catch(M){p.push(M)}if(p.length===1)throw p[0];if(p.length>1)throw new AggregateError(p,"Encountered errors while disposing of store");return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}t.dispose=o;function e(v){for(const p of v)h(p)&&p.dispose();return[]}t.disposeIfDisposable=e;function w(...v){const p=y(()=>o(v));return f(v,p),p}t.combinedDisposable=w;function y(v){const p=c({dispose:(0,P.once)(()=>{s(p),v()})});return p}t.toDisposable=y;class A{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,c(this)}dispose(){this._isDisposed||(s(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{o(this._toDispose)}finally{this._toDispose.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return l(p,this),this._isDisposed?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(p),p}}t.DisposableStore=A;class b{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new A,c(this),l(this._store,this)}dispose(){s(this),this._store.dispose()}_register(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(p)}}t.Disposable=b;class E{constructor(){this._isDisposed=!1,c(this)}get value(){return this._isDisposed?void 0:this._value}set value(p){this._isDisposed||p===this._value||(this._value?.dispose(),p&&l(p,this),this._value=p)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,s(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const p=this._value;return this._value=void 0,p&&l(p,null),p}}t.MutableDisposable=E;class g{constructor(p){this._disposable=p,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=g;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,c(this)}set(p){let D=p;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,s(this))},this}}t.SafeDisposable=m;class r{constructor(){this.references=new Map}acquire(p,...D){let M=this.references.get(p);M||(M={counter:0,object:this.createReferencedObject(p,...D)},this.references.set(p,M));const{object:F}=M,I=(0,P.once)(()=>{--M.counter===0&&(this.destroyReferencedObject(p,M.object),this.references.delete(p))});return M.counter++,{object:F,dispose:I}}}t.ReferenceCollection=r;class a{constructor(p){this.referenceCollection=p}async acquire(p,...D){const M=this.referenceCollection.acquire(p,...D);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(F){throw M.dispose(),F}}}t.AsyncReferenceCollection=a;class N{constructor(p){this.object=p}dispose(){}}t.ImmortalReference=N;function d(v){const p=new A;try{v(p)}finally{p.dispose()}}t.disposeOnReturn=d;class _{constructor(){this._store=new Map,this._isDisposed=!1,c(this)}dispose(){s(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{o(this._store.values())}finally{this._store.clear()}}has(p){return this._store.has(p)}get(p){return this._store.get(p)}set(p,D,M=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this._store.get(p)?.dispose(),this._store.set(p,D)}deleteAndDispose(p){this._store.get(p)?.dispose(),this._store.delete(p)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=_}),Z(J[17],K([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class P{static{this.Undefined=new P(void 0)}constructor(u){this.element=u,this.next=P.Undefined,this.prev=P.Undefined}}class k{constructor(){this._first=P.Undefined,this._last=P.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===P.Undefined}clear(){let u=this._first;for(;u!==P.Undefined;){const L=u.next;u.prev=P.Undefined,u.next=P.Undefined,u=L}this._first=P.Undefined,this._last=P.Undefined,this._size=0}unshift(u){return this._insert(u,!1)}push(u){return this._insert(u,!0)}_insert(u,L){const c=new P(u);if(this._first===P.Undefined)this._first=c,this._last=c;else if(L){const l=this._last;this._last=c,c.prev=l,l.next=c}else{const l=this._first;this._first=c,c.next=l,l.prev=c}this._size+=1;let s=!1;return()=>{s||(s=!0,this._remove(c))}}shift(){if(this._first!==P.Undefined){const u=this._first.element;return this._remove(this._first),u}}pop(){if(this._last!==P.Undefined){const u=this._last.element;return this._remove(this._last),u}}_remove(u){if(u.prev!==P.Undefined&&u.next!==P.Undefined){const L=u.prev;L.next=u.next,u.next.prev=L}else u.prev===P.Undefined&&u.next===P.Undefined?(this._first=P.Undefined,this._last=P.Undefined):u.next===P.Undefined?(this._last=this._last.prev,this._last.next=P.Undefined):u.prev===P.Undefined&&(this._first=this._first.next,this._first.prev=P.Undefined);this._size-=1}*[Symbol.iterator](){let u=this._first;for(;u!==P.Undefined;)yield u.element,u=u.next}}t.LinkedList=k}),Z(J[18],K([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class k{static create(u){return new k(u)}constructor(u){this._now=P&&u===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=k}),Z(J[8],K([0,1,3,15,7,17,18]),function(z,t,P,k,i,u,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const c=!1,s=!1;var l;(function(D){D.None=()=>i.Disposable.None;function M(C){if(s){const{onDidAddListener:U}=C,B=e.create();let x=0;C.onDidAddListener=()=>{++x===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),B.print()),U?.()}}}function F(C,U){return ne(C,()=>{},0,void 0,!0,void 0,U)}D.defer=F;function I(C){return(U,B=null,x)=>{let j=!1,Y;return Y=C(te=>{if(!j)return Y?Y.dispose():j=!0,U.call(B,te)},null,x),j&&Y.dispose(),Y}}D.once=I;function q(C,U,B){return $((x,j=null,Y)=>C(te=>x.call(j,U(te)),null,Y),B)}D.map=q;function O(C,U,B){return $((x,j=null,Y)=>C(te=>{U(te),x.call(j,te)},null,Y),B)}D.forEach=O;function H(C,U,B){return $((x,j=null,Y)=>C(te=>U(te)&&x.call(j,te),null,Y),B)}D.filter=H;function S(C){return C}D.signal=S;function W(...C){return(U,B=null,x)=>(0,i.combinedDisposable)(...C.map(j=>j(Y=>U.call(B,Y),null,x)))}D.any=W;function Q(C,U,B,x){let j=B;return q(C,Y=>(j=U(j,Y),j),x)}D.reduce=Q;function $(C,U){let B;const x={onWillAddFirstListener(){B=C(j.fire,j)},onDidRemoveLastListener(){B?.dispose()}};U||M(x);const j=new E(x);return U?.add(j),j.event}function ne(C,U,B=100,x=!1,j=!1,Y,te){let se,fe,he,_e=0,ye;const Ie={leakWarningThreshold:Y,onWillAddFirstListener(){se=C(Ce=>{_e++,fe=U(fe,Ce),x&&!he&&(Pe.fire(fe),fe=void 0),ye=()=>{const Oe=fe;fe=void 0,he=void 0,(!x||_e>1)&&Pe.fire(Oe),_e=0},typeof B=="number"?(clearTimeout(he),he=setTimeout(ye,B)):he===void 0&&(he=0,queueMicrotask(ye))})},onWillRemoveListener(){j&&_e>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,se.dispose()}};te||M(Ie);const Pe=new E(Ie);return te?.add(Pe),Pe.event}D.debounce=ne;function n(C,U=0,B){return D.debounce(C,(x,j)=>x?(x.push(j),x):[j],U,void 0,!0,void 0,B)}D.accumulate=n;function oe(C,U=(x,j)=>x===j,B){let x=!0,j;return H(C,Y=>{const te=x||!U(Y,j);return x=!1,j=Y,te},B)}D.latch=oe;function ce(C,U,B){return[D.filter(C,U,B),D.filter(C,x=>!U(x),B)]}D.split=ce;function me(C,U=!1,B=[]){let x=B.slice(),j=C(se=>{x?x.push(se):te.fire(se)});const Y=()=>{x?.forEach(se=>te.fire(se)),x=null},te=new E({onWillAddFirstListener(){j||(j=C(se=>te.fire(se)))},onDidAddFirstListener(){x&&(U?setTimeout(Y):Y())},onDidRemoveLastListener(){j&&j.dispose(),j=null}});return te.event}D.buffer=me;class ge{constructor(U){this.event=U,this.disposables=new i.DisposableStore}map(U){return new ge(q(this.event,U,this.disposables))}forEach(U){return new ge(O(this.event,U,this.disposables))}filter(U){return new ge(H(this.event,U,this.disposables))}reduce(U,B){return new ge(Q(this.event,U,B,this.disposables))}latch(){return new ge(oe(this.event,void 0,this.disposables))}debounce(U,B=100,x=!1,j=!1,Y){return new ge(ne(this.event,U,B,x,j,Y,this.disposables))}on(U,B,x){return this.event(U,B,x)}once(U,B,x){return I(this.event)(U,B,x)}dispose(){this.disposables.dispose()}}function Le(C){return new ge(C)}D.chain=Le;function pe(C,U,B=x=>x){const x=(...se)=>te.fire(B(...se)),j=()=>C.on(U,x),Y=()=>C.removeListener(U,x),te=new E({onWillAddFirstListener:j,onDidRemoveLastListener:Y});return te.event}D.fromNodeEventEmitter=pe;function Ne(C,U,B=x=>x){const x=(...se)=>te.fire(B(...se)),j=()=>C.addEventListener(U,x),Y=()=>C.removeEventListener(U,x),te=new E({onWillAddFirstListener:j,onDidRemoveLastListener:Y});return te.event}D.fromDOMEventEmitter=Ne;function we(C){return new Promise(U=>I(C)(U))}D.toPromise=we;function Me(C,U){return U(void 0),C(B=>U(B))}D.runAndSubscribe=Me;function ae(C,U){let B=null;function x(Y){B?.dispose(),B=new i.DisposableStore,U(Y,B)}x(void 0);const j=C(Y=>x(Y));return(0,i.toDisposable)(()=>{j.dispose(),B?.dispose()})}D.runAndSubscribeWithStore=ae;class ue{constructor(U,B){this._observable=U,this._counter=0,this._hasChanged=!1;const x={onWillAddFirstListener:()=>{U.addObserver(this)},onDidRemoveLastListener:()=>{U.removeObserver(this)}};B||M(x),this.emitter=new E(x),B&&B.add(this.emitter)}beginUpdate(U){this._counter++}handlePossibleChange(U){}handleChange(U,B){this._hasChanged=!0}endUpdate(U){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ie(C,U){return new ue(C,U).emitter.event}D.fromObservable=ie;function le(C){return U=>{let B=0,x=!1;const j={beginUpdate(){B++},endUpdate(){B--,B===0&&(C.reportChanges(),x&&(x=!1,U()))},handlePossibleChange(){},handleChange(){x=!0}};return C.addObserver(j),C.reportChanges(),{dispose(){C.removeObserver(j)}}}}D.fromObservableLight=le})(l||(t.Event=l={}));class f{static{this.all=new Set}static{this._idPool=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${f._idPool++}`,f.all.add(this)}start(M){this._stopWatch=new L.StopWatch,this.listenerCount=M}stop(){if(this._stopWatch){const M=this._stopWatch.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=f;let R=-1;function h(D){const M=R;return R=D,{dispose(){R=M}}}t.setGlobalLeakWarningThreshold=h;class o{constructor(M,F=Math.random().toString(18).slice(2,5)){this.threshold=M,this.name=F,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(M,F){const I=this.threshold;if(I<=0||F<I)return;this._stacks||(this._stacks=new Map);const q=this._stacks.get(M.value)||0;if(this._stacks.set(M.value,q+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=I*.5;let O,H=0;for(const[S,W]of this._stacks)(!O||H<W)&&(O=S,H=W);console.warn(`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${H}):`),console.warn(O)}return()=>{const O=this._stacks.get(M.value)||0;this._stacks.set(M.value,O-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class y{constructor(M){this.value=M,this.id=w++}}const A=2,b=(D,M)=>{if(D instanceof y)M(D);else for(let F=0;F<D.length;F++){const I=D[F];I&&M(I)}};class E{constructor(M){this._size=0,this._options=M,this._leakageMon=R>0||this._options?.leakWarningThreshold?new o(this._options?.leakWarningThreshold??R):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(c){const M=this._listeners;queueMicrotask(()=>{b(M,F=>F.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(M,F,I)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;if(this._disposed)return i.Disposable.None;F&&(M=M.bind(F));const q=new y(M);let O,H;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(q.stack=e.create(),O=this._leakageMon.check(q.stack,this._size+1)),c&&(q.stack=H??e.create()),this._listeners?this._listeners instanceof y?(this._deliveryQueue??=new m,this._listeners=[this._listeners,q]):this._listeners.push(q):(this._options?.onWillAddFirstListener?.(this),this._listeners=q,this._options?.onDidAddFirstListener?.(this)),this._size++;const S=(0,i.toDisposable)(()=>{O?.(),this._removeListener(q)});return I instanceof i.DisposableStore?I.add(S):Array.isArray(I)&&I.push(S),S},this._event}_removeListener(M){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const F=this._listeners,I=F.indexOf(M);if(I===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,F[I]=void 0;const q=this._deliveryQueue.current===this;if(this._size*A<=F.length){let O=0;for(let H=0;H<F.length;H++)F[H]?F[O++]=F[H]:q&&(this._deliveryQueue.end--,O<this._deliveryQueue.i&&this._deliveryQueue.i--);F.length=O}}_deliver(M,F){if(!M)return;const I=this._options?.onListenerError||P.onUnexpectedError;if(!I){M.value(F);return}try{M.value(F)}catch(q){I(q)}}_deliverQueue(M){const F=M.current._listeners;for(;M.i<M.end;)this._deliver(F[M.i++],M.value);M.reset()}fire(M){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof y)this._deliver(this._listeners,M);else{const F=this._deliveryQueue;F.enqueue(this,M,this._listeners.length),this._deliverQueue(F)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=E;const g=()=>new m;t.createEventDeliveryQueue=g;class m{constructor(){this.i=-1,this.end=0}enqueue(M,F,I){this.i=0,this.end=I,this.current=M,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends E{async fireAsync(M,F,I){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new u.LinkedList),b(this._listeners,q=>this._asyncDeliveryQueue.push([q.value,M]));this._asyncDeliveryQueue.size>0&&!F.isCancellationRequested;){const[q,O]=this._asyncDeliveryQueue.shift(),H=[],S={...O,token:F,waitUntil:W=>{if(Object.isFrozen(H))throw new Error("waitUntil can NOT be called asynchronous");I&&(W=I(W,q)),H.push(W)}};try{q(S)}catch(W){(0,P.onUnexpectedError)(W);continue}Object.freeze(H),await Promise.allSettled(H).then(W=>{for(const Q of W)Q.status==="rejected"&&(0,P.onUnexpectedError)(Q.reason)})}}}t.AsyncEmitter=r;class a extends E{get isPaused(){return this._isPaused!==0}constructor(M){super(M),this._isPaused=0,this._eventQueue=new u.LinkedList,this._mergeFn=M?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const M=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(M))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(M){this._size&&(this._isPaused!==0?this._eventQueue.push(M):super.fire(M))}}t.PauseableEmitter=a;class N extends a{constructor(M){super(M),this._delay=M.delay??100}fire(M){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(M)}}t.DebounceEmitter=N;class d extends E{constructor(M){super(M),this._queuedEvents=[],this._mergeFn=M?.merge}fire(M){this.hasListeners()&&(this._queuedEvents.push(M),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(F=>super.fire(F)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=d;class _{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(M){const F={event:M,listener:null};this.events.push(F),this.hasListeners&&this.hook(F);const I=()=>{this.hasListeners&&this.unhook(F);const q=this.events.indexOf(F);this.events.splice(q,1)};return(0,i.toDisposable)((0,k.once)(I))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(M=>this.hook(M))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(M=>this.unhook(M))}hook(M){M.listener=M.event(F=>this.emitter.fire(F))}unhook(M){M.listener&&M.listener.dispose(),M.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=_;class v{constructor(){this.buffers=[]}wrapEvent(M){return(F,I,q)=>M(O=>{const H=this.buffers[this.buffers.length-1];H?H.push(()=>F.call(I,O)):F.call(I,O)},void 0,q)}bufferEvents(M){const F=[];this.buffers.push(F);const I=M();return this.buffers.pop(),F.forEach(q=>q()),I}}t.EventBufferer=v;class p{constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=i.Disposable.None,this.emitter=new E({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(M){this.inputEvent=M,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=M(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=p}),Z(J[19],K([0,1,8]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const k=Object.freeze(function(c,s){const l=setTimeout(c.bind(s),0);return{dispose(){clearTimeout(l)}}});var i;(function(c){function s(l){return l===c.None||l===c.Cancelled||l instanceof u?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}c.isCancellationToken=s,c.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),c.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(i||(t.CancellationToken=i={}));class u{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new P.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(s){this._token=void 0,this._parentListener=void 0,this._parentListener=s&&s.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new u),this._token}cancel(){this._token?this._token instanceof u&&this._token.cancel():this._token=i.Cancelled}dispose(s=!1){s&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof u&&this._token.dispose():this._token=i.None}}t.CancellationTokenSource=L}),Z(J[32],K([0,1,19]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class k{constructor(c){this.task=c,this.result=null}get(){if(this.result)return this.result;const c=new P.CancellationTokenSource,s=this.task(c.token);return this.result={promise:s,dispose:()=>{this.result=null,c.cancel(),c.dispose()}},this.result}}t.Cache=k;class i{constructor(c){this.fn=c,this.lastCache=void 0,this.lastArgKey=void 0}get(c){const s=JSON.stringify(c);return this.lastArgKey!==s&&(this.lastArgKey=s,this.lastCache=this.fn(c)),this.lastCache}}t.LRUCachedFunction=i;class u{get cachedValues(){return this._map}constructor(c){this.fn=c,this._map=new Map}get(c){if(this._map.has(c))return this._map.get(c);const s=this.fn(c);return this._map.set(c,s),s}}t.CachedFunction=u}),Z(J[5],K([0,1,32,31]),function(z,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function i(T){return!T||typeof T!="string"?!0:T.trim().length===0}t.isFalsyOrWhitespace=i;const u=/{(\d+)}/g;function L(T,...V){return V.length===0?T:T.replace(u,function(G,X){const ee=parseInt(X,10);return isNaN(ee)||ee<0||ee>=V.length?G:V[ee]})}t.format=L;const c=/{([^}]+)}/g;function s(T,V){return T.replace(c,(G,X)=>V[X]??G)}t.format2=s;function l(T){return T.replace(/[<>&]/g,function(V){switch(V){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return V}})}t.escape=l;function f(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=f;function R(T,V){let G=0;const X=V.charCodeAt(0);for(let ee=T.length-1;ee>=0;ee--)T.charCodeAt(ee)===X&&G++;return G}t.count=R;function h(T,V,G="\u2026"){return T.length<=V?T:`${T.substr(0,V)}${G}`}t.truncate=h;function o(T,V=" "){const G=e(T,V);return w(G,V)}t.trim=o;function e(T,V){if(!T||!V)return T;const G=V.length;if(G===0||T.length===0)return T;let X=0;for(;T.indexOf(V,X)===X;)X=X+G;return T.substring(X)}t.ltrim=e;function w(T,V){if(!T||!V)return T;const G=V.length,X=T.length;if(G===0||X===0)return T;let ee=X,re=-1;for(;re=T.lastIndexOf(V,ee-1),!(re===-1||re+G!==ee);){if(re===0)return"";ee=re}return T.substring(0,ee)}t.rtrim=w;function y(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=y;function A(T){return T.replace(/\*/g,"")}t.stripWildcards=A;function b(T,V,G={}){if(!T)throw new Error("Cannot create regex from empty string");V||(T=f(T)),G.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let X="";return G.global&&(X+="g"),G.matchCase||(X+="i"),G.multiline&&(X+="m"),G.unicode&&(X+="u"),new RegExp(T,X)}t.createRegExp=b;function E(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}t.regExpLeadsToEndlessLoop=E;function g(T){return!!T.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=g;function m(T){return(T.global?"g":"")+(T.ignoreCase?"i":"")+(T.multiline?"m":"")+(T.unicode?"u":"")}t.regExpFlags=m;function r(T){return T.split(/\r\n|\r|\n/)}t.splitLines=r;function a(T){for(let V=0,G=T.length;V<G;V++){const X=T.charCodeAt(V);if(X!==32&&X!==9)return V}return-1}t.firstNonWhitespaceIndex=a;function N(T,V=0,G=T.length){for(let X=V;X<G;X++){const ee=T.charCodeAt(X);if(ee!==32&&ee!==9)return T.substring(V,X)}return T.substring(V,G)}t.getLeadingWhitespace=N;function d(T,V=T.length-1){for(let G=V;G>=0;G--){const X=T.charCodeAt(G);if(X!==32&&X!==9)return G}return-1}t.lastNonWhitespaceIndex=d;function _(T,V,G){const X=[];let ee=0;for(const re of T.matchAll(V)){if(X.push(T.slice(ee,re.index)),re.index===void 0)throw new Error("match.index should be defined");ee=re.index+re[0].length,X.push(G(re[0],...re.slice(1),re.index,T,re.groups))}return X.push(T.slice(ee)),Promise.all(X).then(re=>re.join(""))}t.replaceAsync=_;function v(T,V){return T<V?-1:T>V?1:0}t.compare=v;function p(T,V,G=0,X=T.length,ee=0,re=V.length){for(;G<X&&ee<re;G++,ee++){const Ae=T.charCodeAt(G),Ee=V.charCodeAt(ee);if(Ae<Ee)return-1;if(Ae>Ee)return 1}const be=X-G,De=re-ee;return be<De?-1:be>De?1:0}t.compareSubstring=p;function D(T,V){return M(T,V,0,T.length,0,V.length)}t.compareIgnoreCase=D;function M(T,V,G=0,X=T.length,ee=0,re=V.length){for(;G<X&&ee<re;G++,ee++){let Ae=T.charCodeAt(G),Ee=V.charCodeAt(ee);if(Ae===Ee)continue;if(Ae>=128||Ee>=128)return p(T.toLowerCase(),V.toLowerCase(),G,X,ee,re);I(Ae)&&(Ae-=32),I(Ee)&&(Ee-=32);const ve=Ae-Ee;if(ve!==0)return ve}const be=X-G,De=re-ee;return be<De?-1:be>De?1:0}t.compareSubstringIgnoreCase=M;function F(T){return T>=48&&T<=57}t.isAsciiDigit=F;function I(T){return T>=97&&T<=122}t.isLowerAsciiLetter=I;function q(T){return T>=65&&T<=90}t.isUpperAsciiLetter=q;function O(T,V){return T.length===V.length&&M(T,V)===0}t.equalsIgnoreCase=O;function H(T,V){const G=V.length;return V.length>T.length?!1:M(T,V,0,G)===0}t.startsWithIgnoreCase=H;function S(T,V){const G=Math.min(T.length,V.length);let X;for(X=0;X<G;X++)if(T.charCodeAt(X)!==V.charCodeAt(X))return X;return G}t.commonPrefixLength=S;function W(T,V){const G=Math.min(T.length,V.length);let X;const ee=T.length-1,re=V.length-1;for(X=0;X<G;X++)if(T.charCodeAt(ee-X)!==V.charCodeAt(re-X))return X;return G}t.commonSuffixLength=W;function Q(T){return 55296<=T&&T<=56319}t.isHighSurrogate=Q;function $(T){return 56320<=T&&T<=57343}t.isLowSurrogate=$;function ne(T,V){return(T-55296<<10)+(V-56320)+65536}t.computeCodePoint=ne;function n(T,V,G){const X=T.charCodeAt(G);if(Q(X)&&G+1<V){const ee=T.charCodeAt(G+1);if($(ee))return ne(X,ee)}return X}t.getNextCodePoint=n;function oe(T,V){const G=T.charCodeAt(V-1);if($(G)&&V>1){const X=T.charCodeAt(V-2);if(Q(X))return ne(X,G)}return G}class ce{get offset(){return this._offset}constructor(V,G=0){this._str=V,this._len=V.length,this._offset=G}setOffset(V){this._offset=V}prevCodePoint(){const V=oe(this._str,this._offset);return this._offset-=V>=65536?2:1,V}nextCodePoint(){const V=n(this._str,this._len,this._offset);return this._offset+=V>=65536?2:1,V}eol(){return this._offset>=this._len}}t.CodePointIterator=ce;class me{get offset(){return this._iterator.offset}constructor(V,G=0){this._iterator=new ce(V,G)}nextGraphemeLength(){const V=Se.getInstance(),G=this._iterator,X=G.offset;let ee=V.getGraphemeBreakType(G.nextCodePoint());for(;!G.eol();){const re=G.offset,be=V.getGraphemeBreakType(G.nextCodePoint());if(Ce(ee,be)){G.setOffset(re);break}ee=be}return G.offset-X}prevGraphemeLength(){const V=Se.getInstance(),G=this._iterator,X=G.offset;let ee=V.getGraphemeBreakType(G.prevCodePoint());for(;G.offset>0;){const re=G.offset,be=V.getGraphemeBreakType(G.prevCodePoint());if(Ce(be,ee)){G.setOffset(re);break}ee=be}return X-G.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=me;function ge(T,V){return new me(T,V).nextGraphemeLength()}t.nextCharLength=ge;function Le(T,V){return new me(T,V).prevGraphemeLength()}t.prevCharLength=Le;function pe(T,V){V>0&&$(T.charCodeAt(V))&&V--;const G=V+ge(T,V);return[G-Le(T,G),G]}t.getCharContainingOffset=pe;function Ne(T){const V=new me(T);let G=0;for(;!V.eol();)G++,V.nextGraphemeLength();return G}t.charCount=Ne;let we;function Me(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ae(T){return we||(we=Me()),we.test(T)}t.containsRTL=ae;const ue=/^[\t\n\r\x20-\x7E]*$/;function ie(T){return ue.test(T)}t.isBasicASCII=ie,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function le(T){return t.UNUSUAL_LINE_TERMINATORS.test(T)}t.containsUnusualLineTerminators=le;function C(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}t.isFullWidthCharacter=C;function U(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}t.isEmojiImprecise=U;function B(T,V){if(T.length<V)return T;const G=/\b/g;let X=0;for(;G.test(T)&&!(T.length-G.lastIndex<V);)X=G.lastIndex,G.lastIndex+=1;return T.substring(X).replace(/^\s/,"")}t.lcut=B;const x=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,j=/\x1b\].*?\x07/g;function Y(T){return T&&(T=T.replace(x,"").replace(j,"")),T}t.removeAnsiEscapeCodes=Y,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function te(T){return!!(T&&T.length>0&&T.charCodeAt(0)===65279)}t.startsWithUTF8BOM=te;function se(T){return te(T)?T.substr(1):T}t.stripUTF8BOM=se;function fe(T,V){if(!T||!V||T.length<V.length)return!1;const G=V.length,X=T.toLowerCase();let ee=0,re=-1;for(;ee<G;){const be=X.indexOf(V[ee],re+1);if(be<0)return!1;re=be,ee++}return!0}t.fuzzyContains=fe;function he(T,V=!1){return T?(V&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}t.containsUppercaseCharacter=he;function _e(T){return T.charAt(0).toUpperCase()+T.slice(1)}t.uppercaseFirstLetter=_e;function ye(T,V=1){if(V===0)return"";let G=-1;do G=T.indexOf(`
`,G+1),V--;while(V>0&&G>=0);return G===-1?T:(T[G-1]==="\r"&&G--,T.substr(0,G))}t.getNLines=ye;function Ie(T){return T=T%(2*26),T<26?String.fromCharCode(97+T):String.fromCharCode(65+T-26)}t.singleLetterHash=Ie;function Pe(T){return Se.getInstance().getGraphemeBreakType(T)}t.getGraphemeBreakType=Pe;function Ce(T,V){return T===0?V!==5&&V!==7:T===2&&V===3?!1:T===4||T===2||T===3||V===4||V===2||V===3?!0:!(T===8&&(V===8||V===9||V===11||V===12)||(T===11||T===9)&&(V===9||V===10)||(T===12||T===10)&&V===10||V===5||V===13||V===7||T===1||T===13&&V===14||T===6&&V===6)}var Oe;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(Oe||(t.GraphemeBreakType=Oe={}));class Se{static{this._INSTANCE=null}static getInstance(){return Se._INSTANCE||(Se._INSTANCE=new Se),Se._INSTANCE}constructor(){this._data=Ve()}getGraphemeBreakType(V){if(V<32)return V===10?3:V===13?2:4;if(V<127)return 0;const G=this._data,X=G.length/3;let ee=1;for(;ee<=X;)if(V<G[3*ee])ee=2*ee;else if(V>G[3*ee+1])ee=2*ee+1;else return G[3*ee+2];return 0}}function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(T,V){if(T===0)return 0;const G=ze(T,V);if(G!==void 0)return G;const X=new ce(V,T);return X.prevCodePoint(),X.offset}t.getLeftDeleteOffset=He;function ze(T,V){const G=new ce(V,T);let X=G.prevCodePoint();for(;je(X)||X===65039||X===8419;){if(G.offset===0)return;X=G.prevCodePoint()}if(!U(X))return;let ee=G.offset;return ee>0&&G.prevCodePoint()===8205&&(ee=G.offset),ee}function je(T){return 127995<=T&&T<=127999}var qe;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),t.noBreakWhitespace="\xA0";class ke{static{this.ambiguousCharacterData=new k.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new P.LRUCachedFunction(V=>{function G(ve){const Fe=new Map;for(let Re=0;Re<ve.length;Re+=2)Fe.set(ve[Re],ve[Re+1]);return Fe}function X(ve,Fe){const Re=new Map(ve);for(const[Ue,Be]of Fe)Re.set(Ue,Be);return Re}function ee(ve,Fe){if(!ve)return Fe;const Re=new Map;for(const[Ue,Be]of ve)Fe.has(Ue)&&Re.set(Ue,Be);return Re}const re=this.ambiguousCharacterData.value;let be=V.filter(ve=>!ve.startsWith("_")&&ve in re);be.length===0&&(be=["_default"]);let De;for(const ve of be){const Fe=G(re[ve]);De=ee(De,Fe)}const Ae=G(re._common),Ee=X(Ae,De);return new ke(Ee)})}static getInstance(V){return ke.cache.get(Array.from(V))}static{this._locales=new k.Lazy(()=>Object.keys(ke.ambiguousCharacterData.value).filter(V=>!V.startsWith("_")))}static getLocales(){return ke._locales.value}constructor(V){this.confusableDictionary=V}isAmbiguous(V){return this.confusableDictionary.has(V)}getPrimaryConfusable(V){return this.confusableDictionary.get(V)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=ke;class Te{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Te.getRawData())),this._data}static isInvisibleCharacter(V){return Te.getData().has(V)}static get codePoints(){return Te.getData()}}t.InvisibleCharacters=Te}),Z(J[33],K([0,1,5]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function k(A){return i(A,0)}t.hash=k;function i(A,b){switch(typeof A){case"object":return A===null?u(349,b):Array.isArray(A)?s(A,b):l(A,b);case"string":return c(A,b);case"boolean":return L(A,b);case"number":return u(A,b);case"undefined":return u(937,b);default:return u(617,b)}}t.doHash=i;function u(A,b){return(b<<5)-b+A|0}t.numberHash=u;function L(A,b){return u(A?433:863,b)}function c(A,b){b=u(149417,b);for(let E=0,g=A.length;E<g;E++)b=u(A.charCodeAt(E),b);return b}t.stringHash=c;function s(A,b){return b=u(104579,b),A.reduce((E,g)=>i(g,E),b)}function l(A,b){return b=u(181387,b),Object.keys(A).sort().reduce((E,g)=>(E=c(g,E),i(A[g],E)),b)}class f{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=i(b,this._value),this._value}}t.Hasher=f;var R;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function h(A,b,E=32){const g=E-b,m=~((1<<g)-1);return(A<<b|(m&A)>>>g)>>>0}function o(A,b=0,E=A.byteLength,g=0){for(let m=0;m<E;m++)A[b+m]=g}function e(A,b,E="0"){for(;A.length<b;)A=E+A;return A}function w(A,b=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(E=>E.toString(16).padStart(2,"0")).join(""):e((A>>>0).toString(16),b/4)}t.toHexString=w;class y{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const E=b.length;if(E===0)return;const g=this._buff;let m=this._buffLen,r=this._leftoverHighSurrogate,a,N;for(r!==0?(a=r,N=-1,r=0):(a=b.charCodeAt(0),N=0);;){let d=a;if(P.isHighSurrogate(a))if(N+1<E){const _=b.charCodeAt(N+1);P.isLowSurrogate(_)?(N++,d=P.computeCodePoint(a,_)):d=65533}else{r=a;break}else P.isLowSurrogate(a)&&(d=65533);if(m=this._push(g,m,d),N++,N<E)a=b.charCodeAt(N);else break}this._buffLen=m,this._leftoverHighSurrogate=r}_push(b,E,g){return g<128?b[E++]=g:g<2048?(b[E++]=192|(g&1984)>>>6,b[E++]=128|(g&63)>>>0):g<65536?(b[E++]=224|(g&61440)>>>12,b[E++]=128|(g&4032)>>>6,b[E++]=128|(g&63)>>>0):(b[E++]=240|(g&1835008)>>>18,b[E++]=128|(g&258048)>>>12,b[E++]=128|(g&4032)>>>6,b[E++]=128|(g&63)>>>0),E>=64&&(this._step(),E-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),E}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,o(this._buff,this._buffLen),this._buffLen>56&&(this._step(),o(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=y._bigBlock32,E=this._buffDV;for(let p=0;p<64;p+=4)b.setUint32(p,E.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)b.setUint32(p,h(b.getUint32(p-12,!1)^b.getUint32(p-32,!1)^b.getUint32(p-56,!1)^b.getUint32(p-64,!1),1),!1);let g=this._h0,m=this._h1,r=this._h2,a=this._h3,N=this._h4,d,_,v;for(let p=0;p<80;p++)p<20?(d=m&r|~m&a,_=1518500249):p<40?(d=m^r^a,_=1859775393):p<60?(d=m&r|m&a|r&a,_=2400959708):(d=m^r^a,_=3395469782),v=h(g,5)+d+N+_+b.getUint32(p*4,!1)&4294967295,N=a,a=r,r=h(m,30),m=g,g=v;this._h0=this._h0+g&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+N&4294967295}}t.StringSHA1=y}),Z(J[20],K([0,1,28,33]),function(z,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(h){this.source=h}getElements(){const h=this.source,o=new Int32Array(h.length);for(let e=0,w=h.length;e<w;e++)o[e]=h.charCodeAt(e);return o}}t.StringDiffSequence=i;function u(R,h,o){return new f(new i(R),new i(h)).ComputeDiff(o).changes}t.stringDiff=u;class L{static Assert(h,o){if(!h)throw new Error(o)}}class c{static Copy(h,o,e,w,y){for(let A=0;A<y;A++)e[w+A]=h[o+A]}static Copy2(h,o,e,w,y){for(let A=0;A<y;A++)e[w+A]=h[o+A]}}var s;(function(R){R[R.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(s||(s={}));class l{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new P.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(h,o){this.m_originalStart=Math.min(this.m_originalStart,h),this.m_modifiedStart=Math.min(this.m_modifiedStart,o),this.m_originalCount++}AddModifiedElement(h,o){this.m_originalStart=Math.min(this.m_originalStart,h),this.m_modifiedStart=Math.min(this.m_modifiedStart,o),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class f{constructor(h,o,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=h,this._modifiedSequence=o;const[w,y,A]=f._getElements(h),[b,E,g]=f._getElements(o);this._hasStrings=A&&g,this._originalStringElements=w,this._originalElementsOrHash=y,this._modifiedStringElements=b,this._modifiedElementsOrHash=E,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(h){return h.length>0&&typeof h[0]=="string"}static _getElements(h){const o=h.getElements();if(f._isStringArray(o)){const e=new Int32Array(o.length);for(let w=0,y=o.length;w<y;w++)e[w]=(0,k.stringHash)(o[w],0);return[o,e,!0]}return o instanceof Int32Array?[[],o,!1]:[[],new Int32Array(o),!1]}ElementsAreEqual(h,o){return this._originalElementsOrHash[h]!==this._modifiedElementsOrHash[o]?!1:this._hasStrings?this._originalStringElements[h]===this._modifiedStringElements[o]:!0}ElementsAreStrictEqual(h,o){if(!this.ElementsAreEqual(h,o))return!1;const e=f._getStrictElement(this._originalSequence,h),w=f._getStrictElement(this._modifiedSequence,o);return e===w}static _getStrictElement(h,o){return typeof h.getStrictElement=="function"?h.getStrictElement(o):null}OriginalElementsAreEqual(h,o){return this._originalElementsOrHash[h]!==this._originalElementsOrHash[o]?!1:this._hasStrings?this._originalStringElements[h]===this._originalStringElements[o]:!0}ModifiedElementsAreEqual(h,o){return this._modifiedElementsOrHash[h]!==this._modifiedElementsOrHash[o]?!1:this._hasStrings?this._modifiedStringElements[h]===this._modifiedStringElements[o]:!0}ComputeDiff(h){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,h)}_ComputeDiff(h,o,e,w,y){const A=[!1];let b=this.ComputeDiffRecursive(h,o,e,w,A);return y&&(b=this.PrettifyChanges(b)),{quitEarly:A[0],changes:b}}ComputeDiffRecursive(h,o,e,w,y){for(y[0]=!1;h<=o&&e<=w&&this.ElementsAreEqual(h,e);)h++,e++;for(;o>=h&&w>=e&&this.ElementsAreEqual(o,w);)o--,w--;if(h>o||e>w){let r;return e<=w?(L.Assert(h===o+1,"originalStart should only be one more than originalEnd"),r=[new P.DiffChange(h,0,e,w-e+1)]):h<=o?(L.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),r=[new P.DiffChange(h,o-h+1,e,0)]):(L.Assert(h===o+1,"originalStart should only be one more than originalEnd"),L.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const A=[0],b=[0],E=this.ComputeRecursionPoint(h,o,e,w,A,b,y),g=A[0],m=b[0];if(E!==null)return E;if(!y[0]){const r=this.ComputeDiffRecursive(h,g,e,m,y);let a=[];return y[0]?a=[new P.DiffChange(g+1,o-(g+1)+1,m+1,w-(m+1)+1)]:a=this.ComputeDiffRecursive(g+1,o,m+1,w,y),this.ConcatenateChanges(r,a)}return[new P.DiffChange(h,o-h+1,e,w-e+1)]}WALKTRACE(h,o,e,w,y,A,b,E,g,m,r,a,N,d,_,v,p,D){let M=null,F=null,I=new l,q=o,O=e,H=N[0]-v[0]-w,S=-1073741824,W=this.m_forwardHistory.length-1;do{const Q=H+h;Q===q||Q<O&&g[Q-1]<g[Q+1]?(r=g[Q+1],d=r-H-w,r<S&&I.MarkNextChange(),S=r,I.AddModifiedElement(r+1,d),H=Q+1-h):(r=g[Q-1]+1,d=r-H-w,r<S&&I.MarkNextChange(),S=r-1,I.AddOriginalElement(r,d+1),H=Q-1-h),W>=0&&(g=this.m_forwardHistory[W],h=g[0],q=1,O=g.length-1)}while(--W>=-1);if(M=I.getReverseChanges(),D[0]){let Q=N[0]+1,$=v[0]+1;if(M!==null&&M.length>0){const ne=M[M.length-1];Q=Math.max(Q,ne.getOriginalEnd()),$=Math.max($,ne.getModifiedEnd())}F=[new P.DiffChange(Q,a-Q+1,$,_-$+1)]}else{I=new l,q=A,O=b,H=N[0]-v[0]-E,S=1073741824,W=p?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const Q=H+y;Q===q||Q<O&&m[Q-1]>=m[Q+1]?(r=m[Q+1]-1,d=r-H-E,r>S&&I.MarkNextChange(),S=r+1,I.AddOriginalElement(r+1,d+1),H=Q+1-y):(r=m[Q-1],d=r-H-E,r>S&&I.MarkNextChange(),S=r,I.AddModifiedElement(r+1,d+1),H=Q-1-y),W>=0&&(m=this.m_reverseHistory[W],y=m[0],q=1,O=m.length-1)}while(--W>=-1);F=I.getChanges()}return this.ConcatenateChanges(M,F)}ComputeRecursionPoint(h,o,e,w,y,A,b){let E=0,g=0,m=0,r=0,a=0,N=0;h--,e--,y[0]=0,A[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const d=o-h+(w-e),_=d+1,v=new Int32Array(_),p=new Int32Array(_),D=w-e,M=o-h,F=h-e,I=o-w,O=(M-D)%2===0;v[D]=h,p[M]=o,b[0]=!1;for(let H=1;H<=d/2+1;H++){let S=0,W=0;m=this.ClipDiagonalBound(D-H,H,D,_),r=this.ClipDiagonalBound(D+H,H,D,_);for(let $=m;$<=r;$+=2){$===m||$<r&&v[$-1]<v[$+1]?E=v[$+1]:E=v[$-1]+1,g=E-($-D)-F;const ne=E;for(;E<o&&g<w&&this.ElementsAreEqual(E+1,g+1);)E++,g++;if(v[$]=E,E+g>S+W&&(S=E,W=g),!O&&Math.abs($-M)<=H-1&&E>=p[$])return y[0]=E,A[0]=g,ne<=p[$]&&1447>0&&H<=1447+1?this.WALKTRACE(D,m,r,F,M,a,N,I,v,p,E,o,y,g,w,A,O,b):null}const Q=(S-h+(W-e)-H)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(S,Q))return b[0]=!0,y[0]=S,A[0]=W,Q>0&&1447>0&&H<=1447+1?this.WALKTRACE(D,m,r,F,M,a,N,I,v,p,E,o,y,g,w,A,O,b):(h++,e++,[new P.DiffChange(h,o-h+1,e,w-e+1)]);a=this.ClipDiagonalBound(M-H,H,M,_),N=this.ClipDiagonalBound(M+H,H,M,_);for(let $=a;$<=N;$+=2){$===a||$<N&&p[$-1]>=p[$+1]?E=p[$+1]-1:E=p[$-1],g=E-($-M)-I;const ne=E;for(;E>h&&g>e&&this.ElementsAreEqual(E,g);)E--,g--;if(p[$]=E,O&&Math.abs($-D)<=H&&E<=v[$])return y[0]=E,A[0]=g,ne>=v[$]&&1447>0&&H<=1447+1?this.WALKTRACE(D,m,r,F,M,a,N,I,v,p,E,o,y,g,w,A,O,b):null}if(H<=1447){let $=new Int32Array(r-m+2);$[0]=D-m+1,c.Copy2(v,m,$,1,r-m+1),this.m_forwardHistory.push($),$=new Int32Array(N-a+2),$[0]=M-a+1,c.Copy2(p,a,$,1,N-a+1),this.m_reverseHistory.push($)}}return this.WALKTRACE(D,m,r,F,M,a,N,I,v,p,E,o,y,g,w,A,O,b)}PrettifyChanges(h){for(let o=0;o<h.length;o++){const e=h[o],w=o<h.length-1?h[o+1].originalStart:this._originalElementsOrHash.length,y=o<h.length-1?h[o+1].modifiedStart:this._modifiedElementsOrHash.length,A=e.originalLength>0,b=e.modifiedLength>0;for(;e.originalStart+e.originalLength<w&&e.modifiedStart+e.modifiedLength<y&&(!A||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!b||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const g=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!g)break;e.originalStart++,e.modifiedStart++}const E=[null];if(o<h.length-1&&this.ChangesOverlap(h[o],h[o+1],E)){h[o]=E[0],h.splice(o+1,1),o--;continue}}for(let o=h.length-1;o>=0;o--){const e=h[o];let w=0,y=0;if(o>0){const r=h[o-1];w=r.originalStart+r.originalLength,y=r.modifiedStart+r.modifiedLength}const A=e.originalLength>0,b=e.modifiedLength>0;let E=0,g=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const a=e.originalStart-r,N=e.modifiedStart-r;if(a<w||N<y||A&&!this.OriginalElementsAreEqual(a,a+e.originalLength)||b&&!this.ModifiedElementsAreEqual(N,N+e.modifiedLength))break;const _=(a===w&&N===y?5:0)+this._boundaryScore(a,e.originalLength,N,e.modifiedLength);_>g&&(g=_,E=r)}e.originalStart-=E,e.modifiedStart-=E;const m=[null];if(o>0&&this.ChangesOverlap(h[o-1],h[o],m)){h[o-1]=m[0],h.splice(o,1),o++;continue}}if(this._hasStrings)for(let o=1,e=h.length;o<e;o++){const w=h[o-1],y=h[o],A=y.originalStart-w.originalStart-w.originalLength,b=w.originalStart,E=y.originalStart+y.originalLength,g=E-b,m=w.modifiedStart,r=y.modifiedStart+y.modifiedLength,a=r-m;if(A<5&&g<20&&a<20){const N=this._findBetterContiguousSequence(b,g,m,a,A);if(N){const[d,_]=N;(d!==w.originalStart+w.originalLength||_!==w.modifiedStart+w.modifiedLength)&&(w.originalLength=d-w.originalStart,w.modifiedLength=_-w.modifiedStart,y.originalStart=d+A,y.modifiedStart=_+A,y.originalLength=E-y.originalStart,y.modifiedLength=r-y.modifiedStart)}}}return h}_findBetterContiguousSequence(h,o,e,w,y){if(o<y||w<y)return null;const A=h+o-y+1,b=e+w-y+1;let E=0,g=0,m=0;for(let r=h;r<A;r++)for(let a=e;a<b;a++){const N=this._contiguousSequenceScore(r,a,y);N>0&&N>E&&(E=N,g=r,m=a)}return E>0?[g,m]:null}_contiguousSequenceScore(h,o,e){let w=0;for(let y=0;y<e;y++){if(!this.ElementsAreEqual(h+y,o+y))return 0;w+=this._originalStringElements[h+y].length}return w}_OriginalIsBoundary(h){return h<=0||h>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[h])}_OriginalRegionIsBoundary(h,o){if(this._OriginalIsBoundary(h)||this._OriginalIsBoundary(h-1))return!0;if(o>0){const e=h+o;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(h){return h<=0||h>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[h])}_ModifiedRegionIsBoundary(h,o){if(this._ModifiedIsBoundary(h)||this._ModifiedIsBoundary(h-1))return!0;if(o>0){const e=h+o;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(h,o,e,w){const y=this._OriginalRegionIsBoundary(h,o)?1:0,A=this._ModifiedRegionIsBoundary(e,w)?1:0;return y+A}ConcatenateChanges(h,o){const e=[];if(h.length===0||o.length===0)return o.length>0?o:h;if(this.ChangesOverlap(h[h.length-1],o[0],e)){const w=new Array(h.length+o.length-1);return c.Copy(h,0,w,0,h.length-1),w[h.length-1]=e[0],c.Copy(o,1,w,h.length,o.length-1),w}else{const w=new Array(h.length+o.length);return c.Copy(h,0,w,0,h.length),c.Copy(o,0,w,h.length,o.length),w}}ChangesOverlap(h,o,e){if(L.Assert(h.originalStart<=o.originalStart,"Left change is not less than or equal to right change"),L.Assert(h.modifiedStart<=o.modifiedStart,"Left change is not less than or equal to right change"),h.originalStart+h.originalLength>=o.originalStart||h.modifiedStart+h.modifiedLength>=o.modifiedStart){const w=h.originalStart;let y=h.originalLength;const A=h.modifiedStart;let b=h.modifiedLength;return h.originalStart+h.originalLength>=o.originalStart&&(y=o.originalStart+o.originalLength-h.originalStart),h.modifiedStart+h.modifiedLength>=o.modifiedStart&&(b=o.modifiedStart+o.modifiedLength-h.modifiedStart),e[0]=new P.DiffChange(w,y,A,b),!0}else return e[0]=null,!1}ClipDiagonalBound(h,o,e,w){if(h>=0&&h<w)return h;const y=e,A=w-e-1,b=o%2===0;if(h<0){const E=y%2===0;return b===E?0:1}else{const E=A%2===0;return b===E?w-1:w-2}}}t.LcsDiff=f}),Z(J[21],K([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function P(a){return typeof a=="string"}t.isString=P;function k(a){return Array.isArray(a)&&a.every(N=>P(N))}t.isStringArray=k;function i(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}t.isObject=i;function u(a){const N=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof N}t.isTypedArray=u;function L(a){return typeof a=="number"&&!isNaN(a)}t.isNumber=L;function c(a){return!!a&&typeof a[Symbol.iterator]=="function"}t.isIterable=c;function s(a){return a===!0||a===!1}t.isBoolean=s;function l(a){return typeof a>"u"}t.isUndefined=l;function f(a){return!R(a)}t.isDefined=f;function R(a){return l(a)||a===null}t.isUndefinedOrNull=R;function h(a,N){if(!a)throw new Error(N?`Unexpected type, expected '${N}'`:"Unexpected type")}t.assertType=h;function o(a){if(R(a))throw new Error("Assertion Failed: argument is undefined or null");return a}t.assertIsDefined=o;function e(...a){const N=[];for(let d=0;d<a.length;d++){const _=a[d];if(R(_))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);N.push(_)}return N}t.assertAllDefined=e;const w=Object.prototype.hasOwnProperty;function y(a){if(!i(a))return!1;for(const N in a)if(w.call(a,N))return!1;return!0}t.isEmptyObject=y;function A(a){return typeof a=="function"}t.isFunction=A;function b(...a){return a.length>0&&a.every(A)}t.areFunctions=b;function E(a,N){const d=Math.min(a.length,N.length);for(let _=0;_<d;_++)g(a[_],N[_])}t.validateConstraints=E;function g(a,N){if(P(N)){if(typeof a!==N)throw new Error(`argument does not match constraint: typeof ${N}`)}else if(A(N)){try{if(a instanceof N)return}catch{}if(!R(a)&&a.constructor===N||N.length===1&&N.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=g;function m(a){return a===null?void 0:a}t.withNullAsUndefined=m;function r(a){return typeof a>"u"?null:a}t.withUndefinedAsNull=r}),Z(J[34],K([0,1,21]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const k=Object.create(null);function i(c,s){if((0,P.isString)(s)){const l=k[s];if(l===void 0)throw new Error(`${c} references an unknown codicon: ${s}`);s=l}return k[c]=s,{id:c}}function u(){return k}t.getCodiconFontCharacters=u;function L(){return Object.values(t.Codicon)}t.getAllCodicons=L,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),Z(J[11],K([0,1,21]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function k(A){if(!A||typeof A!="object"||A instanceof RegExp)return A;const b=Array.isArray(A)?[]:{};return Object.entries(A).forEach(([E,g])=>{b[E]=g&&typeof g=="object"?k(g):g}),b}t.deepClone=k;function i(A){if(!A||typeof A!="object")return A;const b=[A];for(;b.length>0;){const E=b.shift();Object.freeze(E);for(const g in E)if(u.call(E,g)){const m=E[g];typeof m=="object"&&!Object.isFrozen(m)&&!(0,P.isTypedArray)(m)&&b.push(m)}}return A}t.deepFreeze=i;const u=Object.prototype.hasOwnProperty;function L(A,b){return c(A,b,new Set)}t.cloneAndChange=L;function c(A,b,E){if((0,P.isUndefinedOrNull)(A))return A;const g=b(A);if(typeof g<"u")return g;if(Array.isArray(A)){const m=[];for(const r of A)m.push(c(r,b,E));return m}if((0,P.isObject)(A)){if(E.has(A))throw new Error("Cannot clone recursive data-structure");E.add(A);const m={};for(const r in A)u.call(A,r)&&(m[r]=c(A[r],b,E));return E.delete(A),m}return A}function s(A,b,E=!0){return(0,P.isObject)(A)?((0,P.isObject)(b)&&Object.keys(b).forEach(g=>{g in A?E&&((0,P.isObject)(A[g])&&(0,P.isObject)(b[g])?s(A[g],b[g],E):A[g]=b[g]):A[g]=b[g]}),A):b}t.mixin=s;function l(A,b){if(A===b)return!0;if(A==null||b===null||b===void 0||typeof A!=typeof b||typeof A!="object"||Array.isArray(A)!==Array.isArray(b))return!1;let E,g;if(Array.isArray(A)){if(A.length!==b.length)return!1;for(E=0;E<A.length;E++)if(!l(A[E],b[E]))return!1}else{const m=[];for(g in A)m.push(g);m.sort();const r=[];for(g in b)r.push(g);if(r.sort(),!l(m,r))return!1;for(E=0;E<m.length;E++)if(!l(A[m[E]],b[m[E]]))return!1}return!0}t.equals=l;function f(A){const b=new Set;return JSON.stringify(A,(E,g)=>{if((0,P.isObject)(g)||Array.isArray(g)){if(b.has(g))return"[Circular]";b.add(g)}return g})}t.safeStringify=f;function R(A,b){const E=Object.create(null);return!A||!b||Object.keys(b).forEach(m=>{const r=A[m],a=b[m];l(r,a)||(E[m]=a)}),E}t.distinct=R;function h(A,b){const E=b.toLowerCase(),g=Object.keys(A).find(m=>m.toLowerCase()===E);return g?A[g]:A[b]}t.getCaseInsensitive=h;function o(A,b){const E=Object.create(null);for(const[g,m]of Object.entries(A))b(g,m)&&(E[g]=m);return E}t.filter=o;function e(A){let b=[];for(;Object.prototype!==A;)b=b.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return b}t.getAllPropertyNames=e;function w(A){const b=[];for(const E of e(A))typeof A[E]=="function"&&b.push(E);return b}t.getAllMethodNames=w;function y(A,b){const E=m=>function(){const r=Array.prototype.slice.call(arguments,0);return b(m,r)},g={};for(const m of A)g[m]=E(m);return g}t.createProxyObject=y}),Z(J[22],K([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var P;(function(u){u[u.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",u[u.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",u[u.MAX_UINT_8=255]="MAX_UINT_8",u[u.MAX_UINT_16=65535]="MAX_UINT_16",u[u.MAX_UINT_32=4294967295]="MAX_UINT_32",u[u.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P||(t.Constants=P={}));function k(u){return u<0?0:u>255?255:u|0}t.toUint8=k;function i(u){return u<0?0:u>4294967295?4294967295:u|0}t.toUint32=i}),Z(J[23],K([0,1,22]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class k{constructor(c){const s=(0,P.toUint8)(c);this._defaultValue=s,this._asciiMap=k._createAsciiMap(s),this._map=new Map}static _createAsciiMap(c){const s=new Uint8Array(256);return s.fill(c),s}set(c,s){const l=(0,P.toUint8)(s);c>=0&&c<256?this._asciiMap[c]=l:this._map.set(c,l)}get(c){return c>=0&&c<256?this._asciiMap[c]:this._map.get(c)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}t.CharacterClassifier=k;var i;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(i||(i={}));class u{constructor(){this._actual=new k(0)}add(c){this._actual.set(c,1)}has(c){return this._actual.get(c)===1}clear(){return this._actual.clear()}}t.CharacterSet=u}),Z(J[6],K([0,1,3]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRange=void 0;class k{static addRange(u,L){let c=0;for(;c<L.length&&L[c].endExclusive<u.start;)c++;let s=c;for(;s<L.length&&L[s].start<=u.endExclusive;)s++;if(c===s)L.splice(c,0,u);else{const l=Math.min(u.start,L[c].start),f=Math.max(u.endExclusive,L[s-1].endExclusive);L.splice(c,s-c,new k(l,f))}}static tryCreate(u,L){if(!(u>L))return new k(u,L)}constructor(u,L){if(this.start=u,this.endExclusive=L,u>L)throw new P.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(u){return new k(this.start+u,this.endExclusive+u)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(u){return this.start===u.start&&this.endExclusive===u.endExclusive}containsRange(u){return this.start<=u.start&&u.endExclusive<=this.endExclusive}contains(u){return this.start<=u&&u<this.endExclusive}join(u){return new k(Math.min(this.start,u.start),Math.max(this.endExclusive,u.endExclusive))}intersect(u){const L=Math.max(this.start,u.start),c=Math.min(this.endExclusive,u.endExclusive);if(L<=c)return new k(L,c)}}t.OffsetRange=k}),Z(J[4],K([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class P{constructor(i,u){this.lineNumber=i,this.column=u}with(i=this.lineNumber,u=this.column){return i===this.lineNumber&&u===this.column?this:new P(i,u)}delta(i=0,u=0){return this.with(this.lineNumber+i,this.column+u)}equals(i){return P.equals(this,i)}static equals(i,u){return!i&&!u?!0:!!i&&!!u&&i.lineNumber===u.lineNumber&&i.column===u.column}isBefore(i){return P.isBefore(this,i)}static isBefore(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<u.column}isBeforeOrEqual(i){return P.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<=u.column}static compare(i,u){const L=i.lineNumber|0,c=u.lineNumber|0;if(L===c){const s=i.column|0,l=u.column|0;return s-l}return L-c}clone(){return new P(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new P(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}t.Position=P}),Z(J[2],K([0,1,4]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class k{constructor(u,L,c,s){u>c||u===c&&L>s?(this.startLineNumber=c,this.startColumn=s,this.endLineNumber=u,this.endColumn=L):(this.startLineNumber=u,this.startColumn=L,this.endLineNumber=c,this.endColumn=s)}isEmpty(){return k.isEmpty(this)}static isEmpty(u){return u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn}containsPosition(u){return k.containsPosition(this,u)}static containsPosition(u,L){return!(L.lineNumber<u.startLineNumber||L.lineNumber>u.endLineNumber||L.lineNumber===u.startLineNumber&&L.column<u.startColumn||L.lineNumber===u.endLineNumber&&L.column>u.endColumn)}static strictContainsPosition(u,L){return!(L.lineNumber<u.startLineNumber||L.lineNumber>u.endLineNumber||L.lineNumber===u.startLineNumber&&L.column<=u.startColumn||L.lineNumber===u.endLineNumber&&L.column>=u.endColumn)}containsRange(u){return k.containsRange(this,u)}static containsRange(u,L){return!(L.startLineNumber<u.startLineNumber||L.endLineNumber<u.startLineNumber||L.startLineNumber>u.endLineNumber||L.endLineNumber>u.endLineNumber||L.startLineNumber===u.startLineNumber&&L.startColumn<u.startColumn||L.endLineNumber===u.endLineNumber&&L.endColumn>u.endColumn)}strictContainsRange(u){return k.strictContainsRange(this,u)}static strictContainsRange(u,L){return!(L.startLineNumber<u.startLineNumber||L.endLineNumber<u.startLineNumber||L.startLineNumber>u.endLineNumber||L.endLineNumber>u.endLineNumber||L.startLineNumber===u.startLineNumber&&L.startColumn<=u.startColumn||L.endLineNumber===u.endLineNumber&&L.endColumn>=u.endColumn)}plusRange(u){return k.plusRange(this,u)}static plusRange(u,L){let c,s,l,f;return L.startLineNumber<u.startLineNumber?(c=L.startLineNumber,s=L.startColumn):L.startLineNumber===u.startLineNumber?(c=L.startLineNumber,s=Math.min(L.startColumn,u.startColumn)):(c=u.startLineNumber,s=u.startColumn),L.endLineNumber>u.endLineNumber?(l=L.endLineNumber,f=L.endColumn):L.endLineNumber===u.endLineNumber?(l=L.endLineNumber,f=Math.max(L.endColumn,u.endColumn)):(l=u.endLineNumber,f=u.endColumn),new k(c,s,l,f)}intersectRanges(u){return k.intersectRanges(this,u)}static intersectRanges(u,L){let c=u.startLineNumber,s=u.startColumn,l=u.endLineNumber,f=u.endColumn;const R=L.startLineNumber,h=L.startColumn,o=L.endLineNumber,e=L.endColumn;return c<R?(c=R,s=h):c===R&&(s=Math.max(s,h)),l>o?(l=o,f=e):l===o&&(f=Math.min(f,e)),c>l||c===l&&s>f?null:new k(c,s,l,f)}equalsRange(u){return k.equalsRange(this,u)}static equalsRange(u,L){return!u&&!L?!0:!!u&&!!L&&u.startLineNumber===L.startLineNumber&&u.startColumn===L.startColumn&&u.endLineNumber===L.endLineNumber&&u.endColumn===L.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(u){return new P.Position(u.endLineNumber,u.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(u){return new P.Position(u.startLineNumber,u.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(u,L){return new k(this.startLineNumber,this.startColumn,u,L)}setStartPosition(u,L){return new k(u,L,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(u){return new k(u.startLineNumber,u.startColumn,u.startLineNumber,u.startColumn)}collapseToEnd(){return k.collapseToEnd(this)}static collapseToEnd(u){return new k(u.endLineNumber,u.endColumn,u.endLineNumber,u.endColumn)}delta(u){return new k(this.startLineNumber+u,this.startColumn,this.endLineNumber+u,this.endColumn)}static fromPositions(u,L=u){return new k(u.lineNumber,u.column,L.lineNumber,L.column)}static lift(u){return u?new k(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):null}static isIRange(u){return u&&typeof u.startLineNumber=="number"&&typeof u.startColumn=="number"&&typeof u.endLineNumber=="number"&&typeof u.endColumn=="number"}static areIntersectingOrTouching(u,L){return!(u.endLineNumber<L.startLineNumber||u.endLineNumber===L.startLineNumber&&u.endColumn<L.startColumn||L.endLineNumber<u.startLineNumber||L.endLineNumber===u.startLineNumber&&L.endColumn<u.startColumn)}static areIntersecting(u,L){return!(u.endLineNumber<L.startLineNumber||u.endLineNumber===L.startLineNumber&&u.endColumn<=L.startColumn||L.endLineNumber<u.startLineNumber||L.endLineNumber===u.startLineNumber&&L.endColumn<=u.startColumn)}static compareRangesUsingStarts(u,L){if(u&&L){const l=u.startLineNumber|0,f=L.startLineNumber|0;if(l===f){const R=u.startColumn|0,h=L.startColumn|0;if(R===h){const o=u.endLineNumber|0,e=L.endLineNumber|0;if(o===e){const w=u.endColumn|0,y=L.endColumn|0;return w-y}return o-e}return R-h}return l-f}return(u?1:0)-(L?1:0)}static compareRangesUsingEnds(u,L){return u.endLineNumber===L.endLineNumber?u.endColumn===L.endColumn?u.startLineNumber===L.startLineNumber?u.startColumn-L.startColumn:u.startLineNumber-L.startLineNumber:u.endColumn-L.endColumn:u.endLineNumber-L.endLineNumber}static spansMultipleLines(u){return u.endLineNumber>u.startLineNumber}toJSON(){return this}}t.Range=k}),Z(J[35],K([0,1,2]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditOperation=void 0;class k{static insert(u,L){return{range:new P.Range(u.lineNumber,u.column,u.lineNumber,u.column),text:L,forceMoveMarkers:!0}}static delete(u){return{range:u,text:null}}static replace(u,L){return{range:u,text:L}}static replaceMove(u,L){return{range:u,text:L,forceMoveMarkers:!0}}}t.EditOperation=k}),Z(J[12],K([0,1,3,2]),function(z,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRange=void 0;class i{static fromRange(L){return new i(L.startLineNumber,L.endLineNumber)}static subtract(L,c){return c?L.startLineNumber<c.startLineNumber&&c.endLineNumberExclusive<L.endLineNumberExclusive?[new i(L.startLineNumber,c.startLineNumber),new i(c.endLineNumberExclusive,L.endLineNumberExclusive)]:c.startLineNumber<=L.startLineNumber&&L.endLineNumberExclusive<=c.endLineNumberExclusive?[]:c.endLineNumberExclusive<L.endLineNumberExclusive?[new i(Math.max(c.endLineNumberExclusive,L.startLineNumber),L.endLineNumberExclusive)]:[new i(L.startLineNumber,Math.min(c.startLineNumber,L.endLineNumberExclusive))]:[L]}static joinMany(L){if(L.length===0)return[];let c=L[0];for(let s=1;s<L.length;s++)c=this.join(c,L[s]);return c}static join(L,c){if(L.length===0)return c;if(c.length===0)return L;const s=[];let l=0,f=0,R=null;for(;l<L.length||f<c.length;){let h=null;if(l<L.length&&f<c.length){const o=L[l],e=c[f];o.startLineNumber<e.startLineNumber?(h=o,l++):(h=e,f++)}else l<L.length?(h=L[l],l++):(h=c[f],f++);R===null?R=h:R.endLineNumberExclusive>=h.startLineNumber?R=new i(R.startLineNumber,Math.max(R.endLineNumberExclusive,h.endLineNumberExclusive)):(s.push(R),R=h)}return R!==null&&s.push(R),s}static ofLength(L,c){return new i(L,L+c)}static deserialize(L){return new i(L[0],L[1])}constructor(L,c){if(L>c)throw new P.BugIndicatingError(`startLineNumber ${L} cannot be after endLineNumberExclusive ${c}`);this.startLineNumber=L,this.endLineNumberExclusive=c}contains(L){return this.startLineNumber<=L&&L<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(L){return new i(this.startLineNumber+L,this.endLineNumberExclusive+L)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(L){return new i(Math.min(this.startLineNumber,L.startLineNumber),Math.max(this.endLineNumberExclusive,L.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(L){const c=Math.max(this.startLineNumber,L.startLineNumber),s=Math.min(this.endLineNumberExclusive,L.endLineNumberExclusive);if(c<=s)return new i(c,s)}intersectsStrict(L){return this.startLineNumber<L.endLineNumberExclusive&&L.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(L){return this.startLineNumber<=L.endLineNumberExclusive&&L.startLineNumber<=this.endLineNumberExclusive}equals(L){return this.startLineNumber===L.startLineNumber&&this.endLineNumberExclusive===L.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new k.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new k.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(L){const c=[];for(let s=this.startLineNumber;s<this.endLineNumberExclusive;s++)c.push(L(s));return c}forEach(L){for(let c=this.startLineNumber;c<this.endLineNumberExclusive;c++)L(c)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(L){return this.startLineNumber<=L&&L<this.endLineNumberExclusive}}t.LineRange=i}),Z(J[36],K([0,1,4,2]),function(z,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var i;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(i||(t.SelectionDirection=i={}));class u extends k.Range{constructor(c,s,l,f){super(c,s,l,f),this.selectionStartLineNumber=c,this.selectionStartColumn=s,this.positionLineNumber=l,this.positionColumn=f}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(c){return u.selectionsEqual(this,c)}static selectionsEqual(c,s){return c.selectionStartLineNumber===s.selectionStartLineNumber&&c.selectionStartColumn===s.selectionStartColumn&&c.positionLineNumber===s.positionLineNumber&&c.positionColumn===s.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(c,s){return this.getDirection()===0?new u(this.startLineNumber,this.startColumn,c,s):new u(c,s,this.startLineNumber,this.startColumn)}getPosition(){return new P.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new P.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(c,s){return this.getDirection()===0?new u(c,s,this.endLineNumber,this.endColumn):new u(this.endLineNumber,this.endColumn,c,s)}static fromPositions(c,s=c){return new u(c.lineNumber,c.column,s.lineNumber,s.column)}static fromRange(c,s){return s===0?new u(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):new u(c.endLineNumber,c.endColumn,c.startLineNumber,c.startColumn)}static liftSelection(c){return new u(c.selectionStartLineNumber,c.selectionStartColumn,c.positionLineNumber,c.positionColumn)}static selectionsArrEqual(c,s){if(c&&!s||!c&&s)return!1;if(!c&&!s)return!0;if(c.length!==s.length)return!1;for(let l=0,f=c.length;l<f;l++)if(!this.selectionsEqual(c[l],s[l]))return!1;return!0}static isISelection(c){return c&&typeof c.selectionStartLineNumber=="number"&&typeof c.selectionStartColumn=="number"&&typeof c.positionLineNumber=="number"&&typeof c.positionColumn=="number"}static createWithDirection(c,s,l,f,R){return R===0?new u(c,s,l,f):new u(l,f,c,s)}}t.Selection=u}),Z(J[37],K([0,1,23]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var k;(function(L){L[L.Regular=0]="Regular",L[L.Whitespace=1]="Whitespace",L[L.WordSeparator=2]="WordSeparator"})(k||(t.WordCharacterClass=k={}));class i extends P.CharacterClassifier{constructor(c){super(0);for(let s=0,l=c.length;s<l;s++)this.set(c.charCodeAt(s),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=i;function u(L){const c={};return s=>(c.hasOwnProperty(s)||(c[s]=L(s)),c[s])}t.getMapForWordSeparators=u(L=>new i(L))}),Z(J[24],K([0,1,16,7,17]),function(z,t,P,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.setDefaultGetWordAtTextConfig=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function u(R=""){let h="(-?\\d*\\.\\d\\w*)|([^";for(const o of t.USUAL_WORD_SEPARATORS)R.indexOf(o)>=0||(h+="\\"+o);return h+="\\s]+)",new RegExp(h,"g")}t.DEFAULT_WORD_REGEXP=u();function L(R){let h=t.DEFAULT_WORD_REGEXP;if(R&&R instanceof RegExp)if(R.global)h=R;else{let o="g";R.ignoreCase&&(o+="i"),R.multiline&&(o+="m"),R.unicode&&(o+="u"),h=new RegExp(R.source,o)}return h.lastIndex=0,h}t.ensureValidWordDefinition=L;const c=new i.LinkedList;c.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function s(R){const h=c.unshift(R);return(0,k.toDisposable)(h)}t.setDefaultGetWordAtTextConfig=s;function l(R,h,o,e,w){if(w||(w=P.Iterable.first(c)),o.length>w.maxLen){let g=R-w.maxLen/2;return g<0?g=0:e+=g,o=o.substring(g,R+w.maxLen/2),l(R,h,o,e,w)}const y=Date.now(),A=R-1-e;let b=-1,E=null;for(let g=1;!(Date.now()-y>=w.timeBudget);g++){const m=A-w.windowSize*g;h.lastIndex=Math.max(0,m);const r=f(h,o,A,b);if(!r&&E||(E=r,m<=0))break;b=m}if(E){const g={word:E[0],startColumn:e+1+E.index,endColumn:e+1+E.index+E[0].length};return h.lastIndex=0,g}return null}t.getWordAtText=l;function f(R,h,o,e){let w;for(;w=R.exec(h);){const y=w.index||0;if(y<=o&&R.lastIndex>=o)return w;if(e>0&&y>e)return null}return null}}),Z(J[9],K([0,1,3,6]),function(z,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DateTimeout=t.InfiniteTimeout=t.SequenceDiff=t.DiffAlgorithmResult=void 0;class i{static trivial(l,f){return new i([new u(new k.OffsetRange(0,l.length),new k.OffsetRange(0,f.length))],!1)}static trivialTimedOut(l,f){return new i([new u(new k.OffsetRange(0,l.length),new k.OffsetRange(0,f.length))],!0)}constructor(l,f){this.diffs=l,this.hitTimeout=f}}t.DiffAlgorithmResult=i;class u{constructor(l,f){this.seq1Range=l,this.seq2Range=f}reverse(){return new u(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(l){return new u(this.seq1Range.join(l.seq1Range),this.seq2Range.join(l.seq2Range))}delta(l){return l===0?this:new u(this.seq1Range.delta(l),this.seq2Range.delta(l))}}t.SequenceDiff=u;class L{static{this.instance=new L}isValid(){return!0}}t.InfiniteTimeout=L;class c{constructor(l){if(this.timeout=l,this.startTime=Date.now(),this.valid=!0,l<=0)throw new P.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}disable(){this.timeout=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.valid=!0}}t.DateTimeout=c}),Z(J[38],K([0,1,6,9]),function(z,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shiftSequenceDiffs=t.joinSequenceDiffs=t.removeRandomMatches=t.smoothenSequenceDiffs=t.optimizeSequenceDiffs=void 0;function i(f,R,h){let o=h;return o=c(f,R,o),o=s(f,R,o),o}t.optimizeSequenceDiffs=i;function u(f,R,h){const o=[];for(const e of h){const w=o[o.length-1];if(!w){o.push(e);continue}e.seq1Range.start-w.seq1Range.endExclusive<=2||e.seq2Range.start-w.seq2Range.endExclusive<=2?o[o.length-1]=new k.SequenceDiff(w.seq1Range.join(e.seq1Range),w.seq2Range.join(e.seq2Range)):o.push(e)}return o}t.smoothenSequenceDiffs=u;function L(f,R,h){let o=h;if(o.length===0)return o;let e=0,w;do{w=!1;const y=[o[0]];for(let A=1;A<o.length;A++){let g=function(r,a){const N=new P.OffsetRange(E.seq1Range.endExclusive,b.seq1Range.start);if(f.countLinesIn(N)>5||N.length>500)return!1;const _=f.getText(N).trim();if(_.length>20||_.split(/\r\n|\r|\n/).length>1)return!1;const v=f.countLinesIn(r.seq1Range),p=r.seq1Range.length,D=R.countLinesIn(r.seq2Range),M=r.seq2Range.length,F=f.countLinesIn(a.seq1Range),I=a.seq1Range.length,q=R.countLinesIn(a.seq2Range),O=a.seq2Range.length,H=2*40+50;function S(W){return Math.min(W,H)}return Math.pow(Math.pow(S(v*40+p),1.5)+Math.pow(S(D*40+M),1.5),1.5)+Math.pow(Math.pow(S(F*40+I),1.5)+Math.pow(S(q*40+O),1.5),1.5)>(H**1.5)**1.5*1.3};const b=o[A],E=y[y.length-1];g(E,b)?(w=!0,y[y.length-1]=y[y.length-1].join(b)):y.push(b)}o=y}while(e++<10&&w);return o}t.removeRandomMatches=L;function c(f,R,h){if(h.length===0)return h;const o=[];o.push(h[0]);for(let w=1;w<h.length;w++){const y=o[o.length-1];let A=h[w];if(A.seq1Range.isEmpty||A.seq2Range.isEmpty){const b=A.seq1Range.start-y.seq1Range.endExclusive;let E;for(E=1;E<=b&&!(f.getElement(A.seq1Range.start-E)!==f.getElement(A.seq1Range.endExclusive-E)||R.getElement(A.seq2Range.start-E)!==R.getElement(A.seq2Range.endExclusive-E));E++);if(E--,E===b){o[o.length-1]=new k.SequenceDiff(new P.OffsetRange(y.seq1Range.start,A.seq1Range.endExclusive-b),new P.OffsetRange(y.seq2Range.start,A.seq2Range.endExclusive-b));continue}A=A.delta(-E)}o.push(A)}const e=[];for(let w=0;w<o.length-1;w++){const y=o[w+1];let A=o[w];if(A.seq1Range.isEmpty||A.seq2Range.isEmpty){const b=y.seq1Range.start-A.seq1Range.endExclusive;let E;for(E=0;E<b&&!(f.getElement(A.seq1Range.start+E)!==f.getElement(A.seq1Range.endExclusive+E)||R.getElement(A.seq2Range.start+E)!==R.getElement(A.seq2Range.endExclusive+E));E++);if(E===b){o[w+1]=new k.SequenceDiff(new P.OffsetRange(A.seq1Range.start+b,y.seq1Range.endExclusive),new P.OffsetRange(A.seq2Range.start+b,y.seq2Range.endExclusive));continue}E>0&&(A=A.delta(E))}e.push(A)}return o.length>0&&e.push(o[o.length-1]),e}t.joinSequenceDiffs=c;function s(f,R,h){if(!f.getBoundaryScore||!R.getBoundaryScore)return h;for(let o=0;o<h.length;o++){const e=o>0?h[o-1]:void 0,w=h[o],y=o+1<h.length?h[o+1]:void 0,A=new P.OffsetRange(e?e.seq1Range.start+1:0,y?y.seq1Range.endExclusive-1:f.length),b=new P.OffsetRange(e?e.seq2Range.start+1:0,y?y.seq2Range.endExclusive-1:R.length);w.seq1Range.isEmpty?h[o]=l(w,f,R,A,b):w.seq2Range.isEmpty&&(h[o]=l(w.reverse(),R,f,b,A).reverse())}return h}t.shiftSequenceDiffs=s;function l(f,R,h,o,e){let y=1;for(;f.seq1Range.start-y>=o.start&&f.seq2Range.start-y>=e.start&&h.getElement(f.seq2Range.start-y)===h.getElement(f.seq2Range.endExclusive-y)&&y<100;)y++;y--;let A=0;for(;f.seq1Range.start+A<o.endExclusive&&f.seq2Range.endExclusive+A<e.endExclusive&&h.getElement(f.seq2Range.start+A)===h.getElement(f.seq2Range.endExclusive+A)&&A<100;)A++;if(y===0&&A===0)return f;let b=0,E=-1;for(let g=-y;g<=A;g++){const m=f.seq2Range.start+g,r=f.seq2Range.endExclusive+g,a=f.seq1Range.start+g,N=R.getBoundaryScore(a)+h.getBoundaryScore(m)+h.getBoundaryScore(r);N>E&&(E=N,b=g)}return f.delta(b)}}),Z(J[39],K([0,1,6,9]),function(z,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class i{compute(l,f,R=k.InfiniteTimeout.instance){if(l.length===0||f.length===0)return k.DiffAlgorithmResult.trivial(l,f);function h(m,r){for(;m<l.length&&r<f.length&&l.getElement(m)===f.getElement(r);)m++,r++;return m}let o=0;const e=new L;e.set(0,h(0,0));const w=new c;w.set(0,e.get(0)===0?null:new u(null,0,0,e.get(0)));let y=0;e:for(;;){if(o++,!R.isValid())return k.DiffAlgorithmResult.trivialTimedOut(l,f);const m=-Math.min(o,f.length+o%2),r=Math.min(o,l.length+o%2);for(y=m;y<=r;y+=2){const a=y===r?-1:e.get(y+1),N=y===m?-1:e.get(y-1)+1,d=Math.min(Math.max(a,N),l.length),_=d-y;if(d>l.length||_>f.length)continue;const v=h(d,_);e.set(y,v);const p=d===a?w.get(y+1):w.get(y-1);if(w.set(y,v!==d?new u(p,d,_,v-d):p),e.get(y)===l.length&&e.get(y)-y===f.length)break e}}let A=w.get(y);const b=[];let E=l.length,g=f.length;for(;;){const m=A?A.x+A.length:0,r=A?A.y+A.length:0;if((m!==E||r!==g)&&b.push(new k.SequenceDiff(new P.OffsetRange(m,E),new P.OffsetRange(r,g))),!A)break;E=A.x,g=A.y,A=A.prev}return b.reverse(),new k.DiffAlgorithmResult(b,!1)}}t.MyersDiffAlgorithm=i;class u{constructor(l,f,R,h){this.prev=l,this.x=f,this.y=R,this.length=h}}class L{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,f){if(l<0){if(l=-l-1,l>=this.negativeArr.length){const R=this.negativeArr;this.negativeArr=new Int32Array(R.length*2),this.negativeArr.set(R)}this.negativeArr[l]=f}else{if(l>=this.positiveArr.length){const R=this.positiveArr;this.positiveArr=new Int32Array(R.length*2),this.positiveArr.set(R)}this.positiveArr[l]=f}}}class c{constructor(){this.positiveArr=[],this.negativeArr=[]}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,f){l<0?(l=-l-1,this.negativeArr[l]=f):this.positiveArr[l]=f}}}),Z(J[40],K([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Array2D=void 0;class P{constructor(i,u){this.width=i,this.height=u,this.array=[],this.array=new Array(i*u)}get(i,u){return this.array[i+u*this.width]}set(i,u,L){this.array[i+u*this.width]=L}}t.Array2D=P}),Z(J[41],K([0,1,6,9,40]),function(z,t,P,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class u{compute(c,s,l=k.InfiniteTimeout.instance,f){if(c.length===0||s.length===0)return k.DiffAlgorithmResult.trivial(c,s);const R=new i.Array2D(c.length,s.length),h=new i.Array2D(c.length,s.length),o=new i.Array2D(c.length,s.length);for(let g=0;g<c.length;g++)for(let m=0;m<s.length;m++){if(!l.isValid())return k.DiffAlgorithmResult.trivialTimedOut(c,s);const r=g===0?0:R.get(g-1,m),a=m===0?0:R.get(g,m-1);let N;c.getElement(g)===s.getElement(m)?(g===0||m===0?N=0:N=R.get(g-1,m-1),g>0&&m>0&&h.get(g-1,m-1)===3&&(N+=o.get(g-1,m-1)),N+=f?f(g,m):1):N=-1;const d=Math.max(r,a,N);if(d===N){const _=g>0&&m>0?o.get(g-1,m-1):0;o.set(g,m,_+1),h.set(g,m,3)}else d===r?(o.set(g,m,0),h.set(g,m,1)):d===a&&(o.set(g,m,0),h.set(g,m,2));R.set(g,m,d)}const e=[];let w=c.length,y=s.length;function A(g,m){(g+1!==w||m+1!==y)&&e.push(new k.SequenceDiff(new P.OffsetRange(g+1,w),new P.OffsetRange(m+1,y))),w=g,y=m}let b=c.length-1,E=s.length-1;for(;b>=0&&E>=0;)h.get(b,E)===3?(A(b,E),b--,E--):h.get(b,E)===1?b--:E--;return A(-1,-1),e.reverse(),new k.DiffAlgorithmResult(e,!1)}}t.DynamicProgrammingDiffing=u}),Z(J[25],K([0,1,12]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MovedText=t.SimpleLineRangeMapping=t.RangeMapping=t.LineRangeMapping=t.LinesDiff=void 0;class k{constructor(l,f,R){this.changes=l,this.moves=f,this.hitTimeout=R}}t.LinesDiff=k;class i{static inverse(l,f,R){const h=[];let o=1,e=1;for(const y of l){const A=new i(new P.LineRange(o,y.originalRange.startLineNumber),new P.LineRange(e,y.modifiedRange.startLineNumber),void 0);A.modifiedRange.isEmpty||h.push(A),o=y.originalRange.endLineNumberExclusive,e=y.modifiedRange.endLineNumberExclusive}const w=new i(new P.LineRange(o,f+1),new P.LineRange(e,R+1),void 0);return w.modifiedRange.isEmpty||h.push(w),h}constructor(l,f,R){this.originalRange=l,this.modifiedRange=f,this.innerChanges=R}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}flip(){return new i(this.modifiedRange,this.originalRange,this.innerChanges?.map(l=>l.flip()))}}t.LineRangeMapping=i;class u{constructor(l,f){this.originalRange=l,this.modifiedRange=f}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new u(this.modifiedRange,this.originalRange)}}t.RangeMapping=u;class L{constructor(l,f){this.original=l,this.modified=f}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new L(this.modified,this.original)}}t.SimpleLineRangeMapping=L;class c{constructor(l,f){this.lineRangeMapping=l,this.changes=f}flip(){return new c(this.lineRangeMapping.flip(),this.changes.map(l=>l.flip()))}}t.MovedText=c}),Z(J[26],K([0,1,20,25,5,2,10,12]),function(z,t,P,k,i,u,L,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.SmartLinesDiffComputer=void 0;const s=3;class l{computeDiff(m,r,a){const d=new y(m,r,{maxComputationTime:a.maxComputationTimeMs,shouldIgnoreTrimWhitespace:a.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),_=[];let v=null;for(const p of d.changes){let D;p.originalEndLineNumber===0?D=new c.LineRange(p.originalStartLineNumber+1,p.originalStartLineNumber+1):D=new c.LineRange(p.originalStartLineNumber,p.originalEndLineNumber+1);let M;p.modifiedEndLineNumber===0?M=new c.LineRange(p.modifiedStartLineNumber+1,p.modifiedStartLineNumber+1):M=new c.LineRange(p.modifiedStartLineNumber,p.modifiedEndLineNumber+1);let F=new k.LineRangeMapping(D,M,p.charChanges?.map(I=>new k.RangeMapping(new u.Range(I.originalStartLineNumber,I.originalStartColumn,I.originalEndLineNumber,I.originalEndColumn),new u.Range(I.modifiedStartLineNumber,I.modifiedStartColumn,I.modifiedEndLineNumber,I.modifiedEndColumn))));v&&(v.modifiedRange.endLineNumberExclusive===F.modifiedRange.startLineNumber||v.originalRange.endLineNumberExclusive===F.originalRange.startLineNumber)&&(F=new k.LineRangeMapping(v.originalRange.join(F.originalRange),v.modifiedRange.join(F.modifiedRange),v.innerChanges&&F.innerChanges?v.innerChanges.concat(F.innerChanges):void 0),_.pop()),_.push(F),v=F}return(0,L.assertFn)(()=>(0,L.checkAdjacentItems)(_,(p,D)=>D.originalRange.startLineNumber-p.originalRange.endLineNumberExclusive===D.modifiedRange.startLineNumber-p.modifiedRange.endLineNumberExclusive&&p.originalRange.endLineNumberExclusive<D.originalRange.startLineNumber&&p.modifiedRange.endLineNumberExclusive<D.modifiedRange.startLineNumber)),new k.LinesDiff(_,[],d.quitEarly)}}t.SmartLinesDiffComputer=l;function f(g,m,r,a){return new P.LcsDiff(g,m,r).ComputeDiff(a)}class R{constructor(m){const r=[],a=[];for(let N=0,d=m.length;N<d;N++)r[N]=A(m[N],1),a[N]=b(m[N],1);this.lines=m,this._startColumns=r,this._endColumns=a}getElements(){const m=[];for(let r=0,a=this.lines.length;r<a;r++)m[r]=this.lines[r].substring(this._startColumns[r]-1,this._endColumns[r]-1);return m}getStrictElement(m){return this.lines[m]}getStartLineNumber(m){return m+1}getEndLineNumber(m){return m+1}createCharSequence(m,r,a){const N=[],d=[],_=[];let v=0;for(let p=r;p<=a;p++){const D=this.lines[p],M=m?this._startColumns[p]:1,F=m?this._endColumns[p]:D.length+1;for(let I=M;I<F;I++)N[v]=D.charCodeAt(I-1),d[v]=p+1,_[v]=I,v++;!m&&p<a&&(N[v]=10,d[v]=p+1,_[v]=D.length+1,v++)}return new h(N,d,_)}}class h{constructor(m,r,a){this._charCodes=m,this._lineNumbers=r,this._columns=a}toString(){return"["+this._charCodes.map((m,r)=>(m===10?"\\n":String.fromCharCode(m))+`-(${this._lineNumbers[r]},${this._columns[r]})`).join(", ")+"]"}_assertIndex(m,r){if(m<0||m>=r.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(m){return m>0&&m===this._lineNumbers.length?this.getEndLineNumber(m-1):(this._assertIndex(m,this._lineNumbers),this._lineNumbers[m])}getEndLineNumber(m){return m===-1?this.getStartLineNumber(m+1):(this._assertIndex(m,this._lineNumbers),this._charCodes[m]===10?this._lineNumbers[m]+1:this._lineNumbers[m])}getStartColumn(m){return m>0&&m===this._columns.length?this.getEndColumn(m-1):(this._assertIndex(m,this._columns),this._columns[m])}getEndColumn(m){return m===-1?this.getStartColumn(m+1):(this._assertIndex(m,this._columns),this._charCodes[m]===10?1:this._columns[m]+1)}}class o{constructor(m,r,a,N,d,_,v,p){this.originalStartLineNumber=m,this.originalStartColumn=r,this.originalEndLineNumber=a,this.originalEndColumn=N,this.modifiedStartLineNumber=d,this.modifiedStartColumn=_,this.modifiedEndLineNumber=v,this.modifiedEndColumn=p}static createFromDiffChange(m,r,a){const N=r.getStartLineNumber(m.originalStart),d=r.getStartColumn(m.originalStart),_=r.getEndLineNumber(m.originalStart+m.originalLength-1),v=r.getEndColumn(m.originalStart+m.originalLength-1),p=a.getStartLineNumber(m.modifiedStart),D=a.getStartColumn(m.modifiedStart),M=a.getEndLineNumber(m.modifiedStart+m.modifiedLength-1),F=a.getEndColumn(m.modifiedStart+m.modifiedLength-1);return new o(N,d,_,v,p,D,M,F)}}function e(g){if(g.length<=1)return g;const m=[g[0]];let r=m[0];for(let a=1,N=g.length;a<N;a++){const d=g[a],_=d.originalStart-(r.originalStart+r.originalLength),v=d.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(_,v)<s?(r.originalLength=d.originalStart+d.originalLength-r.originalStart,r.modifiedLength=d.modifiedStart+d.modifiedLength-r.modifiedStart):(m.push(d),r=d)}return m}class w{constructor(m,r,a,N,d){this.originalStartLineNumber=m,this.originalEndLineNumber=r,this.modifiedStartLineNumber=a,this.modifiedEndLineNumber=N,this.charChanges=d}static createFromDiffResult(m,r,a,N,d,_,v){let p,D,M,F,I;if(r.originalLength===0?(p=a.getStartLineNumber(r.originalStart)-1,D=0):(p=a.getStartLineNumber(r.originalStart),D=a.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(M=N.getStartLineNumber(r.modifiedStart)-1,F=0):(M=N.getStartLineNumber(r.modifiedStart),F=N.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),_&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&d()){const q=a.createCharSequence(m,r.originalStart,r.originalStart+r.originalLength-1),O=N.createCharSequence(m,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(q.getElements().length>0&&O.getElements().length>0){let H=f(q,O,d,!0).changes;v&&(H=e(H)),I=[];for(let S=0,W=H.length;S<W;S++)I.push(o.createFromDiffChange(H[S],q,O))}}return new w(p,D,M,F,I)}}class y{constructor(m,r,a){this.shouldComputeCharChanges=a.shouldComputeCharChanges,this.shouldPostProcessCharChanges=a.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=a.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=a.shouldMakePrettyDiff,this.originalLines=m,this.modifiedLines=r,this.original=new R(m),this.modified=new R(r),this.continueLineDiff=E(a.maxComputationTime),this.continueCharDiff=E(a.maxComputationTime===0?0:Math.min(a.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const m=f(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),r=m.changes,a=m.quitEarly;if(this.shouldIgnoreTrimWhitespace){const v=[];for(let p=0,D=r.length;p<D;p++)v.push(w.createFromDiffResult(this.shouldIgnoreTrimWhitespace,r[p],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:a,changes:v}}const N=[];let d=0,_=0;for(let v=-1,p=r.length;v<p;v++){const D=v+1<p?r[v+1]:null,M=D?D.originalStart:this.originalLines.length,F=D?D.modifiedStart:this.modifiedLines.length;for(;d<M&&_<F;){const I=this.originalLines[d],q=this.modifiedLines[_];if(I!==q){{let O=A(I,1),H=A(q,1);for(;O>1&&H>1;){const S=I.charCodeAt(O-2),W=q.charCodeAt(H-2);if(S!==W)break;O--,H--}(O>1||H>1)&&this._pushTrimWhitespaceCharChange(N,d+1,1,O,_+1,1,H)}{let O=b(I,1),H=b(q,1);const S=I.length+1,W=q.length+1;for(;O<S&&H<W;){const Q=I.charCodeAt(O-1),$=I.charCodeAt(H-1);if(Q!==$)break;O++,H++}(O<S||H<W)&&this._pushTrimWhitespaceCharChange(N,d+1,O,S,_+1,H,W)}}d++,_++}D&&(N.push(w.createFromDiffResult(this.shouldIgnoreTrimWhitespace,D,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),d+=D.originalLength,_+=D.modifiedLength)}return{quitEarly:a,changes:N}}_pushTrimWhitespaceCharChange(m,r,a,N,d,_,v){if(this._mergeTrimWhitespaceCharChange(m,r,a,N,d,_,v))return;let p;this.shouldComputeCharChanges&&(p=[new o(r,a,r,N,d,_,d,v)]),m.push(new w(r,r,d,d,p))}_mergeTrimWhitespaceCharChange(m,r,a,N,d,_,v){const p=m.length;if(p===0)return!1;const D=m[p-1];return D.originalEndLineNumber===0||D.modifiedEndLineNumber===0?!1:D.originalEndLineNumber===r&&D.modifiedEndLineNumber===d?(this.shouldComputeCharChanges&&D.charChanges&&D.charChanges.push(new o(r,a,r,N,d,_,d,v)),!0):D.originalEndLineNumber+1===r&&D.modifiedEndLineNumber+1===d?(D.originalEndLineNumber=r,D.modifiedEndLineNumber=d,this.shouldComputeCharChanges&&D.charChanges&&D.charChanges.push(new o(r,a,r,N,d,_,d,v)),!0):!1}}t.DiffComputer=y;function A(g,m){const r=i.firstNonWhitespaceIndex(g);return r===-1?m:r+1}function b(g,m){const r=i.lastNonWhitespaceIndex(g);return r===-1?m:r+2}function E(g){if(g===0)return()=>!0;const m=Date.now();return()=>Date.now()-m<g}}),Z(J[42],K([0,1,10,12,6,4,2,9,41,38,39,25]),function(z,t,P,k,i,u,L,c,s,l,f,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinesSliceCharSequence=t.LineSequence=t.getLineRangeMapping=t.lineRangeMappingFromRangeMappings=t.StandardLinesDiffComputer=void 0;class h{constructor(){this.dynamicProgrammingDiffing=new s.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new f.MyersDiffAlgorithm}computeDiff(F,I,q){if(F.length===1&&F[0].length===0||I.length===1&&I[0].length===0)return{changes:[new R.LineRangeMapping(new k.LineRange(1,F.length+1),new k.LineRange(1,I.length+1),[new R.RangeMapping(new L.Range(1,1,F.length,F[0].length+1),new L.Range(1,1,I.length,I[0].length+1))])],hitTimeout:!1,moves:[]};const O=q.maxComputationTimeMs===0?c.InfiniteTimeout.instance:new c.DateTimeout(q.maxComputationTimeMs),H=!q.ignoreTrimWhitespace,S=new Map;function W(ae){let ue=S.get(ae);return ue===void 0&&(ue=S.size,S.set(ae,ue)),ue}const Q=F.map(ae=>W(ae.trim())),$=I.map(ae=>W(ae.trim())),ne=new b(Q,F),n=new b($,I),oe=(()=>ne.length+n.length<1500?this.dynamicProgrammingDiffing.compute(ne,n,O,(ae,ue)=>F[ae]===I[ue]?I[ue].length===0?.1:1+Math.log(1+I[ue].length):.99):this.myersDiffingAlgorithm.compute(ne,n))();let ce=oe.diffs,me=oe.hitTimeout;ce=(0,l.optimizeSequenceDiffs)(ne,n,ce);const ge=[],Le=ae=>{if(H)for(let ue=0;ue<ae;ue++){const ie=pe+ue,le=Ne+ue;if(F[ie]!==I[le]){const C=this.refineDiff(F,I,new c.SequenceDiff(new i.OffsetRange(ie,ie+1),new i.OffsetRange(le,le+1)),O,H);for(const U of C.mappings)ge.push(U);C.hitTimeout&&(me=!0)}}};let pe=0,Ne=0;for(const ae of ce){(0,P.assertFn)(()=>ae.seq1Range.start-pe===ae.seq2Range.start-Ne);const ue=ae.seq1Range.start-pe;Le(ue),pe=ae.seq1Range.endExclusive,Ne=ae.seq2Range.endExclusive;const ie=this.refineDiff(F,I,ae,O,H);ie.hitTimeout&&(me=!0);for(const le of ie.mappings)ge.push(le)}Le(F.length-pe);const we=w(ge,F,I),Me=[];if(q.computeMoves){const ae=we.filter(ie=>ie.modifiedRange.isEmpty&&ie.originalRange.length>=3).map(ie=>new D(ie.originalRange,F)),ue=new Set(we.filter(ie=>ie.originalRange.isEmpty&&ie.modifiedRange.length>=3).map(ie=>new D(ie.modifiedRange,I)));for(const ie of ae){let le=-1,C;for(const U of ue){const B=ie.computeSimilarity(U);B>le&&(le=B,C=U)}if(le>.9&&C){const U=this.refineDiff(F,I,new c.SequenceDiff(new i.OffsetRange(ie.range.startLineNumber-1,ie.range.endLineNumberExclusive-1),new i.OffsetRange(C.range.startLineNumber-1,C.range.endLineNumberExclusive-1)),O,H),B=w(U.mappings,F,I,!0);ue.delete(C),Me.push(new R.MovedText(new R.SimpleLineRangeMapping(ie.range,C.range),B))}}}return(0,P.assertFn)(()=>{function ae(ie,le){if(ie.lineNumber<1||ie.lineNumber>le.length)return!1;const C=le[ie.lineNumber-1];return!(ie.column<1||ie.column>C.length+1)}function ue(ie,le){return!(ie.startLineNumber<1||ie.startLineNumber>le.length+1||ie.endLineNumberExclusive<1||ie.endLineNumberExclusive>le.length+1)}for(const ie of we){if(!ie.innerChanges)return!1;for(const le of ie.innerChanges)if(!(ae(le.modifiedRange.getStartPosition(),I)&&ae(le.modifiedRange.getEndPosition(),I)&&ae(le.originalRange.getStartPosition(),F)&&ae(le.originalRange.getEndPosition(),F)))return!1;if(!ue(ie.modifiedRange,I)||!ue(ie.originalRange,F))return!1}return!0}),new R.LinesDiff(we,Me,me)}refineDiff(F,I,q,O,H){const S=new g(F,q.seq1Range,H),W=new g(I,q.seq2Range,H),Q=S.length+W.length<500?this.dynamicProgrammingDiffing.compute(S,W,O):this.myersDiffingAlgorithm.compute(S,W,O);let $=Q.diffs;return $=(0,l.optimizeSequenceDiffs)(S,W,$),$=o(S,W,$),$=(0,l.smoothenSequenceDiffs)(S,W,$),$=(0,l.removeRandomMatches)(S,W,$),{mappings:$.map(n=>new R.RangeMapping(S.translateRange(n.seq1Range),W.translateRange(n.seq2Range))),hitTimeout:Q.hitTimeout}}}t.StandardLinesDiffComputer=h;function o(M,F,I){const q=[];let O;function H(){if(!O)return;const W=O.s1Range.length-O.deleted,Q=O.s2Range.length-O.added;Math.max(O.deleted,O.added)+(O.count-1)>W&&q.push(new c.SequenceDiff(O.s1Range,O.s2Range)),O=void 0}for(const W of I){let Q=function(ce,me){if(!O||!O.s1Range.containsRange(ce)||!O.s2Range.containsRange(me))if(O&&!(O.s1Range.endExclusive<ce.start&&O.s2Range.endExclusive<me.start)){const pe=i.OffsetRange.tryCreate(O.s1Range.endExclusive,ce.start),Ne=i.OffsetRange.tryCreate(O.s2Range.endExclusive,me.start);O.deleted+=pe?.length??0,O.added+=Ne?.length??0,O.s1Range=O.s1Range.join(ce),O.s2Range=O.s2Range.join(me)}else H(),O={added:0,deleted:0,count:0,s1Range:ce,s2Range:me};const ge=ce.intersect(W.seq1Range),Le=me.intersect(W.seq2Range);O.count++,O.deleted+=ge?.length??0,O.added+=Le?.length??0};const $=M.findWordContaining(W.seq1Range.start-1),ne=F.findWordContaining(W.seq2Range.start-1),n=M.findWordContaining(W.seq1Range.endExclusive),oe=F.findWordContaining(W.seq2Range.endExclusive);$&&n&&ne&&oe&&$.equals(n)&&ne.equals(oe)?Q($,ne):($&&ne&&Q($,ne),n&&oe&&Q(n,oe))}return H(),e(I,q)}function e(M,F){const I=[];for(;M.length>0||F.length>0;){const q=M[0],O=F[0];let H;q&&(!O||q.seq1Range.start<O.seq1Range.start)?H=M.shift():H=F.shift(),I.length>0&&I[I.length-1].seq1Range.endExclusive>=H.seq1Range.start?I[I.length-1]=I[I.length-1].join(H):I.push(H)}return I}function w(M,F,I,q=!1){const O=[];for(const H of A(M.map(S=>y(S,F,I)),(S,W)=>S.originalRange.overlapOrTouch(W.originalRange)||S.modifiedRange.overlapOrTouch(W.modifiedRange))){const S=H[0],W=H[H.length-1];O.push(new R.LineRangeMapping(S.originalRange.join(W.originalRange),S.modifiedRange.join(W.modifiedRange),H.map(Q=>Q.innerChanges[0])))}return(0,P.assertFn)(()=>!q&&O.length>0&&O[0].originalRange.startLineNumber!==O[0].modifiedRange.startLineNumber?!1:(0,P.checkAdjacentItems)(O,(H,S)=>S.originalRange.startLineNumber-H.originalRange.endLineNumberExclusive===S.modifiedRange.startLineNumber-H.modifiedRange.endLineNumberExclusive&&H.originalRange.endLineNumberExclusive<S.originalRange.startLineNumber&&H.modifiedRange.endLineNumberExclusive<S.modifiedRange.startLineNumber)),O}t.lineRangeMappingFromRangeMappings=w;function y(M,F,I){let q=0,O=0;M.modifiedRange.endColumn===1&&M.originalRange.endColumn===1&&M.originalRange.startLineNumber+q<=M.originalRange.endLineNumber&&M.modifiedRange.startLineNumber+q<=M.modifiedRange.endLineNumber&&(O=-1),M.modifiedRange.startColumn-1>=I[M.modifiedRange.startLineNumber-1].length&&M.originalRange.startColumn-1>=F[M.originalRange.startLineNumber-1].length&&M.originalRange.startLineNumber<=M.originalRange.endLineNumber+O&&M.modifiedRange.startLineNumber<=M.modifiedRange.endLineNumber+O&&(q=1);const H=new k.LineRange(M.originalRange.startLineNumber+q,M.originalRange.endLineNumber+1+O),S=new k.LineRange(M.modifiedRange.startLineNumber+q,M.modifiedRange.endLineNumber+1+O);return new R.LineRangeMapping(H,S,[M])}t.getLineRangeMapping=y;function*A(M,F){let I,q;for(const O of M)q!==void 0&&F(q,O)?I.push(O):(I&&(yield I),I=[O]),q=O;I&&(yield I)}class b{constructor(F,I){this.trimmedHash=F,this.lines=I}getElement(F){return this.trimmedHash[F]}get length(){return this.trimmedHash.length}getBoundaryScore(F){const I=F===0?0:E(this.lines[F-1]),q=F===this.lines.length?0:E(this.lines[F]);return 1e3-(I+q)}}t.LineSequence=b;function E(M){let F=0;for(;F<M.length&&(M.charCodeAt(F)===32||M.charCodeAt(F)===9);)F++;return F}class g{constructor(F,I,q){this.lines=F,this.considerWhitespaceChanges=q,this.elements=[],this.firstCharOffsetByLineMinusOne=[],this.offsetByLine=[];let O=!1;I.start>0&&I.endExclusive>=F.length&&(I=new i.OffsetRange(I.start-1,I.endExclusive),O=!0),this.lineRange=I;for(let H=this.lineRange.start;H<this.lineRange.endExclusive;H++){let S=F[H],W=0;if(O)W=S.length,S="",O=!1;else if(!q){const Q=S.trimStart();W=S.length-Q.length,S=Q.trimEnd()}this.offsetByLine.push(W);for(let Q=0;Q<S.length;Q++)this.elements.push(S.charCodeAt(Q));H<F.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLineMinusOne[H-this.lineRange.start]=this.elements.length)}this.offsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new i.OffsetRange(0,this.length))}getText(F){return this.elements.slice(F.start,F.endExclusive).map(I=>String.fromCharCode(I)).join("")}getElement(F){return this.elements[F]}get length(){return this.elements.length}getBoundaryScore(F){const I=d(F>0?this.elements[F-1]:-1),q=d(F<this.elements.length?this.elements[F]:-1);if(I===6&&q===7)return 0;let O=0;return I!==q&&(O+=10,q===1&&(O+=1)),O+=N(I),O+=N(q),O}translateOffset(F){if(this.lineRange.isEmpty)return new u.Position(this.lineRange.start+1,1);let I=0,q=this.firstCharOffsetByLineMinusOne.length;for(;I<q;){const H=Math.floor((I+q)/2);this.firstCharOffsetByLineMinusOne[H]>F?q=H:I=H+1}const O=I===0?0:this.firstCharOffsetByLineMinusOne[I-1];return new u.Position(this.lineRange.start+I+1,F-O+1+this.offsetByLine[I])}translateRange(F){return L.Range.fromPositions(this.translateOffset(F.start),this.translateOffset(F.endExclusive))}findWordContaining(F){if(F<0||F>=this.elements.length||!m(this.elements[F]))return;let I=F;for(;I>0&&m(this.elements[I-1]);)I--;let q=F;for(;q<this.elements.length&&m(this.elements[q]);)q++;return new i.OffsetRange(I,q)}countLinesIn(F){return this.translateOffset(F.endExclusive).lineNumber-this.translateOffset(F.start).lineNumber}}t.LinesSliceCharSequence=g;function m(M){return M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57}var r;(function(M){M[M.WordLower=0]="WordLower",M[M.WordUpper=1]="WordUpper",M[M.WordNumber=2]="WordNumber",M[M.End=3]="End",M[M.Other=4]="Other",M[M.Space=5]="Space",M[M.LineBreakCR=6]="LineBreakCR",M[M.LineBreakLF=7]="LineBreakLF"})(r||(r={}));const a={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function N(M){return a[M]}function d(M){return M===10?7:M===13?6:_(M)?5:M>=97&&M<=122?0:M>=65&&M<=90?1:M>=48&&M<=57?2:M===-1?3:4}function _(M){return M===32||M===9}const v=new Map;function p(M){let F=v.get(M);return F===void 0&&(F=v.size,v.set(M,F)),F}class D{constructor(F,I){this.range=F,this.lines=I,this.histogram=[];let q=0;for(let O=F.startLineNumber-1;O<F.endLineNumberExclusive-1;O++){const H=I[O];for(let W=0;W<H.length;W++){q++;const Q=H[W],$=p(Q);this.histogram[$]=(this.histogram[$]||0)+1}q++;const S=p(`
`);this.histogram[S]=(this.histogram[S]||0)+1}this.totalCount=q}computeSimilarity(F){let I=0;const q=Math.max(this.histogram.length,F.histogram.length);for(let O=0;O<q;O++)I+=Math.abs((this.histogram[O]??0)-(F.histogram[O]??0));return 1-I/(this.totalCount+F.totalCount)}}}),Z(J[43],K([0,1,26,42]),function(z,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={getLegacy:()=>new P.SmartLinesDiffComputer,getAdvanced:()=>new k.StandardLinesDiffComputer}}),Z(J[44],K([0,1,27]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeDefaultDocumentColors=void 0;function k(h){const o=[];for(const e of h){const w=Number(e);(w||w===0&&e.replace(/\s/g,"")!=="")&&o.push(w)}return o}function i(h,o,e,w){return{red:h/255,blue:e/255,green:o/255,alpha:w}}function u(h,o){const e=o.index,w=o[0].length;if(!e)return;const y=h.positionAt(e);return{startLineNumber:y.lineNumber,startColumn:y.column,endLineNumber:y.lineNumber,endColumn:y.column+w}}function L(h,o){if(!h)return;const e=P.Color.Format.CSS.parseHex(o);if(e)return{range:h,color:i(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function c(h,o,e){if(!h||o.length!==1)return;const y=o[0].values(),A=k(y);return{range:h,color:i(A[0],A[1],A[2],e?A[3]:1)}}function s(h,o,e){if(!h||o.length!==1)return;const y=o[0].values(),A=k(y),b=new P.Color(new P.HSLA(A[0],A[1]/100,A[2]/100,e?A[3]:1));return{range:h,color:i(b.rgba.r,b.rgba.g,b.rgba.b,b.rgba.a)}}function l(h,o){return typeof h=="string"?[...h.matchAll(o)]:h.findMatches(o)}function f(h){const o=[],w=l(h,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(w.length>0)for(const y of w){const A=y.filter(m=>m!==void 0),b=A[1],E=A[2];if(!E)continue;let g;if(b==="rgb"){const m=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;g=c(u(h,y),l(E,m),!1)}else if(b==="rgba"){const m=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;g=c(u(h,y),l(E,m),!0)}else if(b==="hsl"){const m=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;g=s(u(h,y),l(E,m),!1)}else if(b==="hsla"){const m=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;g=s(u(h,y),l(E,m),!0)}else b==="#"&&(g=L(u(h,y),b+E));g&&o.push(g)}return o}function R(h){return!h||typeof h.getValue!="function"||typeof h.positionAt!="function"?[]:f(h)}t.computeDefaultDocumentColors=R}),Z(J[45],K([0,1,23]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.State=void 0;var k;(function(o){o[o.Invalid=0]="Invalid",o[o.Start=1]="Start",o[o.H=2]="H",o[o.HT=3]="HT",o[o.HTT=4]="HTT",o[o.HTTP=5]="HTTP",o[o.F=6]="F",o[o.FI=7]="FI",o[o.FIL=8]="FIL",o[o.BeforeColon=9]="BeforeColon",o[o.AfterColon=10]="AfterColon",o[o.AlmostThere=11]="AlmostThere",o[o.End=12]="End",o[o.Accept=13]="Accept",o[o.LastKnownState=14]="LastKnownState"})(k||(t.State=k={}));class i{constructor(e,w,y){const A=new Uint8Array(e*w);for(let b=0,E=e*w;b<E;b++)A[b]=y;this._data=A,this.rows=e,this.cols=w}get(e,w){return this._data[e*this.cols+w]}set(e,w,y){this._data[e*this.cols+w]=y}}class u{constructor(e){let w=0,y=0;for(let b=0,E=e.length;b<E;b++){const[g,m,r]=e[b];m>w&&(w=m),g>y&&(y=g),r>y&&(y=r)}w++,y++;const A=new i(y,w,0);for(let b=0,E=e.length;b<E;b++){const[g,m,r]=e[b];A.set(g,m,r)}this._states=A,this._maxCharCode=w}nextState(e,w){return w<0||w>=this._maxCharCode?0:this._states.get(e,w)}}t.StateMachine=u;let L=null;function c(){return L===null&&(L=new u([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var s;(function(o){o[o.None=0]="None",o[o.ForceTermination=1]="ForceTermination",o[o.CannotEndIn=2]="CannotEndIn"})(s||(s={}));let l=null;function f(){if(l===null){l=new P.CharacterClassifier(0);const o=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<o.length;w++)l.set(o.charCodeAt(w),1);const e=".,;:";for(let w=0;w<e.length;w++)l.set(e.charCodeAt(w),2)}return l}class R{static _createLink(e,w,y,A,b){let E=b-1;do{const g=w.charCodeAt(E);if(e.get(g)!==2)break;E--}while(E>A);if(A>0){const g=w.charCodeAt(A-1),m=w.charCodeAt(E);(g===40&&m===41||g===91&&m===93||g===123&&m===125)&&E--}return{range:{startLineNumber:y,startColumn:A+1,endLineNumber:y,endColumn:E+2},url:w.substring(A,E+1)}}static computeLinks(e,w=c()){const y=f(),A=[];for(let b=1,E=e.getLineCount();b<=E;b++){const g=e.getLineContent(b),m=g.length;let r=0,a=0,N=0,d=1,_=!1,v=!1,p=!1,D=!1;for(;r<m;){let M=!1;const F=g.charCodeAt(r);if(d===13){let I;switch(F){case 40:_=!0,I=0;break;case 41:I=_?0:1;break;case 91:p=!0,v=!0,I=0;break;case 93:p=!1,I=v?0:1;break;case 123:D=!0,I=0;break;case 125:I=D?0:1;break;case 39:case 34:case 96:N===F?I=1:N===39||N===34||N===96?I=0:I=1;break;case 42:I=N===42?1:0;break;case 124:I=N===124?1:0;break;case 32:I=p?0:1;break;default:I=y.get(F)}I===1&&(A.push(R._createLink(y,g,b,a,r)),M=!0)}else if(d===12){let I;F===91?(v=!0,I=0):I=y.get(F),I===1?M=!0:d=13}else d=w.nextState(d,F),d===0&&(M=!0);M&&(d=1,_=!1,v=!1,D=!1,a=r+1,N=F),r++}d===13&&A.push(R._createLink(y,g,b,a,m))}return A}}t.LinkComputer=R;function h(o){return!o||typeof o.getLineCount!="function"||typeof o.getLineContent!="function"?[]:R.computeLinks(o)}t.computeLinks=h}),Z(J[46],K([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class P{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new P}navigateValueSet(i,u,L,c,s){if(i&&u){const l=this.doNavigateValueSet(u,s);if(l)return{range:i,value:l}}if(L&&c){const l=this.doNavigateValueSet(c,s);if(l)return{range:L,value:l}}return null}doNavigateValueSet(i,u){const L=this.numberReplace(i,u);return L!==null?L:this.textReplace(i,u)}numberReplace(i,u){const L=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let c=Number(i);const s=parseFloat(i);return!isNaN(c)&&!isNaN(s)&&c===s?c===0&&!u?null:(c=Math.floor(c*L),c+=u?L:-L,String(c/L)):null}textReplace(i,u){return this.valueSetsReplace(this._defaultValueSet,i,u)}valueSetsReplace(i,u,L){let c=null;for(let s=0,l=i.length;c===null&&s<l;s++)c=this.valueSetReplace(i[s],u,L);return c}valueSetReplace(i,u,L){let c=i.indexOf(u);return c>=0?(c+=L?1:-1,c<0?c=i.length-1:c%=i.length,i[c]):null}}t.BasicInplaceReplace=P}),Z(J[47],K([0,1,11]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.isITextSnapshot=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var k;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(k||(t.OverviewRulerLane=k={}));var i;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(i||(t.GlyphMarginLane=i={}));var u;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(u||(t.MinimapPosition=u={}));var L;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(L||(t.InjectedTextCursorStops=L={}));var c;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(c||(t.EndOfLinePreference=c={}));var s;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(s||(t.DefaultEndOfLine=s={}));var l;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(l||(t.EndOfLineSequence=l={}));class f{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),m.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,m.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!m.insertSpaces,this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=!!m.trimAutoWhitespace,this.bracketPairColorizationOptions=m.bracketPairColorizationOptions}equals(m){return this.tabSize===m.tabSize&&this._indentSizeIsTabSize===m._indentSizeIsTabSize&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace&&(0,P.equals)(this.bracketPairColorizationOptions,m.bracketPairColorizationOptions)}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}t.TextModelResolvedOptions=f;class R{constructor(m,r){this._findMatchBrand=void 0,this.range=m,this.matches=r}}t.FindMatch=R;var h;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(h||(t.TrackedRangeStickiness=h={}));function o(g){return g&&typeof g.read=="function"}t.isITextSnapshot=o;var e;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var w;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w||(t.ModelConstants=w={}));class y{constructor(m,r,a,N,d,_){this.identifier=m,this.range=r,this.text=a,this.forceMoveMarkers=N,this.isAutoWhitespaceEdit=d,this._isTracked=_}}t.ValidAnnotatedEditOperation=y;class A{constructor(m,r,a){this.regex=m,this.wordSeparators=r,this.simpleSearch=a}}t.SearchData=A;class b{constructor(m,r,a){this.reverseEdits=m,this.changes=r,this.trimAutoWhitespaceLineNumbers=a}}t.ApplyEditsResult=b;function E(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}t.shouldSynchronizeModel=E}),Z(J[48],K([0,1,29,22]),function(z,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class i{constructor(s){this.values=s,this.prefixSum=new Uint32Array(s.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(s,l){s=(0,k.toUint32)(s);const f=this.values,R=this.prefixSum,h=l.length;return h===0?!1:(this.values=new Uint32Array(f.length+h),this.values.set(f.subarray(0,s),0),this.values.set(f.subarray(s),s+h),this.values.set(l,s),s-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=s-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(R.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(s,l){return s=(0,k.toUint32)(s),l=(0,k.toUint32)(l),this.values[s]===l?!1:(this.values[s]=l,s-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=s-1),!0)}removeValues(s,l){s=(0,k.toUint32)(s),l=(0,k.toUint32)(l);const f=this.values,R=this.prefixSum;if(s>=f.length)return!1;const h=f.length-s;return l>=h&&(l=h),l===0?!1:(this.values=new Uint32Array(f.length-l),this.values.set(f.subarray(0,s),0),this.values.set(f.subarray(s+l),s),this.prefixSum=new Uint32Array(this.values.length),s-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=s-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(R.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(s){return s<0?0:(s=(0,k.toUint32)(s),this._getPrefixSum(s))}_getPrefixSum(s){if(s<=this.prefixSumValidIndex[0])return this.prefixSum[s];let l=this.prefixSumValidIndex[0]+1;l===0&&(this.prefixSum[0]=this.values[0],l++),s>=this.values.length&&(s=this.values.length-1);for(let f=l;f<=s;f++)this.prefixSum[f]=this.prefixSum[f-1]+this.values[f];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],s),this.prefixSum[s]}getIndexOf(s){s=Math.floor(s),this.getTotalSum();let l=0,f=this.values.length-1,R=0,h=0,o=0;for(;l<=f;)if(R=l+(f-l)/2|0,h=this.prefixSum[R],o=h-this.values[R],s<o)f=R-1;else if(s>=h)l=R+1;else break;return new L(R,s-o)}}t.PrefixSumComputer=i;class u{constructor(s){this._values=s,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(s){return this._ensureValid(),s===0?0:this._prefixSum[s-1]}getIndexOf(s){this._ensureValid();const l=this._indexBySum[s],f=l>0?this._prefixSum[l-1]:0;return new L(l,s-f)}removeValues(s,l){this._values.splice(s,l),this._invalidate(s)}insertValues(s,l){this._values=(0,P.arrayInsert)(this._values,s,l),this._invalidate(s)}_invalidate(s){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,s-1)}_ensureValid(){if(!this._isValid){for(let s=this._validEndIndex+1,l=this._values.length;s<l;s++){const f=this._values[s],R=s>0?this._prefixSum[s-1]:0;this._prefixSum[s]=R+f;for(let h=0;h<f;h++)this._indexBySum[R+h]=s}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(s,l){this._values[s]!==l&&(this._values[s]=l,this._invalidate(s))}}t.ConstantTimePrefixSumComputer=u;class L{constructor(s,l){this.index=s,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=s,this.remainder=l}}t.PrefixSumIndexOfResult=L}),Z(J[49],K([0,1,5,4,48]),function(z,t,P,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class u{constructor(c,s,l,f){this._uri=c,this._lines=s,this._eol=l,this._versionId=f,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(c){c.eol&&c.eol!==this._eol&&(this._eol=c.eol,this._lineStarts=null);const s=c.changes;for(const l of s)this._acceptDeleteRange(l.range),this._acceptInsertText(new k.Position(l.range.startLineNumber,l.range.startColumn),l.text);this._versionId=c.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const c=this._eol.length,s=this._lines.length,l=new Uint32Array(s);for(let f=0;f<s;f++)l[f]=this._lines[f].length+c;this._lineStarts=new i.PrefixSumComputer(l)}}_setLineText(c,s){this._lines[c]=s,this._lineStarts&&this._lineStarts.setValue(c,this._lines[c].length+this._eol.length)}_acceptDeleteRange(c){if(c.startLineNumber===c.endLineNumber){if(c.startColumn===c.endColumn)return;this._setLineText(c.startLineNumber-1,this._lines[c.startLineNumber-1].substring(0,c.startColumn-1)+this._lines[c.startLineNumber-1].substring(c.endColumn-1));return}this._setLineText(c.startLineNumber-1,this._lines[c.startLineNumber-1].substring(0,c.startColumn-1)+this._lines[c.endLineNumber-1].substring(c.endColumn-1)),this._lines.splice(c.startLineNumber,c.endLineNumber-c.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(c.startLineNumber,c.endLineNumber-c.startLineNumber)}_acceptInsertText(c,s){if(s.length===0)return;const l=(0,P.splitLines)(s);if(l.length===1){this._setLineText(c.lineNumber-1,this._lines[c.lineNumber-1].substring(0,c.column-1)+l[0]+this._lines[c.lineNumber-1].substring(c.column-1));return}l[l.length-1]+=this._lines[c.lineNumber-1].substring(c.column-1),this._setLineText(c.lineNumber-1,this._lines[c.lineNumber-1].substring(0,c.column-1)+l[0]);const f=new Uint32Array(l.length-1);for(let R=1;R<l.length;R++)this._lines.splice(c.lineNumber+R-1,0,l[R]),f[R-1]=l[R].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(c.lineNumber,f)}}t.MirrorTextModel=u}),Z(J[50],K([0,1,5,37,4,2,47]),function(z,t,P,k,i,u,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const c=999;class s{constructor(b,E,g,m){this.searchString=b,this.isRegex=E,this.matchCase=g,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=l(this.searchString):b=this.searchString.indexOf(`
`)>=0;let E=null;try{E=P.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!E)return null;let g=!this.isRegex&&!b;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new L.SearchData(E,this.wordSeparators?(0,k.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}t.SearchParams=s;function l(A){if(!A||A.length===0)return!1;for(let b=0,E=A.length;b<E;b++){const g=A.charCodeAt(b);if(g===10)return!0;if(g===92){if(b++,b>=E)break;const m=A.charCodeAt(b);if(m===110||m===114||m===87)return!0}}return!1}t.isMultilineRegexSource=l;function f(A,b,E){if(!E)return new L.FindMatch(A,null);const g=[];for(let m=0,r=b.length;m<r;m++)g[m]=b[m];return new L.FindMatch(A,g)}t.createFindMatch=f;class R{constructor(b){const E=[];let g=0;for(let m=0,r=b.length;m<r;m++)b.charCodeAt(m)===10&&(E[g++]=m);this._lineFeedsOffsets=E}findLineFeedCountBeforeOffset(b){const E=this._lineFeedsOffsets;let g=0,m=E.length-1;if(m===-1||b<=E[0])return 0;for(;g<m;){const r=g+((m-g)/2>>0);E[r]>=b?m=r-1:E[r+1]>=b?(g=r,m=r):g=r+1}return g+1}}class h{static findMatches(b,E,g,m,r){const a=E.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(b,g,new y(a.wordSeparators,a.regex),m,r):this._doFindMatchesLineByLine(b,g,a,m,r):[]}static _getMultilineMatchRange(b,E,g,m,r,a){let N,d=0;m?(d=m.findLineFeedCountBeforeOffset(r),N=E+r+d):N=E+r;let _;if(m){const M=m.findLineFeedCountBeforeOffset(r+a.length)-d;_=N+a.length+M}else _=N+a.length;const v=b.getPositionAt(N),p=b.getPositionAt(_);return new u.Range(v.lineNumber,v.column,p.lineNumber,p.column)}static _doFindMatchesMultiline(b,E,g,m,r){const a=b.getOffsetAt(E.getStartPosition()),N=b.getValueInRange(E,1),d=b.getEOL()===`\r
`?new R(N):null,_=[];let v=0,p;for(g.reset(0);p=g.next(N);)if(_[v++]=f(this._getMultilineMatchRange(b,a,N,d,p.index,p[0]),p,m),v>=r)return _;return _}static _doFindMatchesLineByLine(b,E,g,m,r){const a=[];let N=0;if(E.startLineNumber===E.endLineNumber){const _=b.getLineContent(E.startLineNumber).substring(E.startColumn-1,E.endColumn-1);return N=this._findMatchesInLine(g,_,E.startLineNumber,E.startColumn-1,N,a,m,r),a}const d=b.getLineContent(E.startLineNumber).substring(E.startColumn-1);N=this._findMatchesInLine(g,d,E.startLineNumber,E.startColumn-1,N,a,m,r);for(let _=E.startLineNumber+1;_<E.endLineNumber&&N<r;_++)N=this._findMatchesInLine(g,b.getLineContent(_),_,0,N,a,m,r);if(N<r){const _=b.getLineContent(E.endLineNumber).substring(0,E.endColumn-1);N=this._findMatchesInLine(g,_,E.endLineNumber,0,N,a,m,r)}return a}static _findMatchesInLine(b,E,g,m,r,a,N,d){const _=b.wordSeparators;if(!N&&b.simpleSearch){const D=b.simpleSearch,M=D.length,F=E.length;let I=-M;for(;(I=E.indexOf(D,I+M))!==-1;)if((!_||w(_,E,F,I,M))&&(a[r++]=new L.FindMatch(new u.Range(g,I+1+m,g,I+1+M+m),null),r>=d))return r;return r}const v=new y(b.wordSeparators,b.regex);let p;v.reset(0);do if(p=v.next(E),p&&(a[r++]=f(new u.Range(g,p.index+1+m,g,p.index+1+p[0].length+m),p,N),r>=d))return r;while(p);return r}static findNextMatch(b,E,g,m){const r=E.parseSearchRequest();if(!r)return null;const a=new y(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(b,g,a,m):this._doFindNextMatchLineByLine(b,g,a,m)}static _doFindNextMatchMultiline(b,E,g,m){const r=new i.Position(E.lineNumber,1),a=b.getOffsetAt(r),N=b.getLineCount(),d=b.getValueInRange(new u.Range(r.lineNumber,r.column,N,b.getLineMaxColumn(N)),1),_=b.getEOL()===`\r
`?new R(d):null;g.reset(E.column-1);const v=g.next(d);return v?f(this._getMultilineMatchRange(b,a,d,_,v.index,v[0]),v,m):E.lineNumber!==1||E.column!==1?this._doFindNextMatchMultiline(b,new i.Position(1,1),g,m):null}static _doFindNextMatchLineByLine(b,E,g,m){const r=b.getLineCount(),a=E.lineNumber,N=b.getLineContent(a),d=this._findFirstMatchInLine(g,N,a,E.column,m);if(d)return d;for(let _=1;_<=r;_++){const v=(a+_-1)%r,p=b.getLineContent(v+1),D=this._findFirstMatchInLine(g,p,v+1,1,m);if(D)return D}return null}static _findFirstMatchInLine(b,E,g,m,r){b.reset(m-1);const a=b.next(E);return a?f(new u.Range(g,a.index+1,g,a.index+1+a[0].length),a,r):null}static findPreviousMatch(b,E,g,m){const r=E.parseSearchRequest();if(!r)return null;const a=new y(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(b,g,a,m):this._doFindPreviousMatchLineByLine(b,g,a,m)}static _doFindPreviousMatchMultiline(b,E,g,m){const r=this._doFindMatchesMultiline(b,new u.Range(1,1,E.lineNumber,E.column),g,m,10*c);if(r.length>0)return r[r.length-1];const a=b.getLineCount();return E.lineNumber!==a||E.column!==b.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(b,new i.Position(a,b.getLineMaxColumn(a)),g,m):null}static _doFindPreviousMatchLineByLine(b,E,g,m){const r=b.getLineCount(),a=E.lineNumber,N=b.getLineContent(a).substring(0,E.column-1),d=this._findLastMatchInLine(g,N,a,m);if(d)return d;for(let _=1;_<=r;_++){const v=(r+a-_-1)%r,p=b.getLineContent(v+1),D=this._findLastMatchInLine(g,p,v+1,m);if(D)return D}return null}static _findLastMatchInLine(b,E,g,m){let r=null,a;for(b.reset(0);a=b.next(E);)r=f(new u.Range(g,a.index+1,g,a.index+1+a[0].length),a,m);return r}}t.TextModelSearch=h;function o(A,b,E,g,m){if(g===0)return!0;const r=b.charCodeAt(g-1);if(A.get(r)!==0||r===13||r===10)return!0;if(m>0){const a=b.charCodeAt(g);if(A.get(a)!==0)return!0}return!1}function e(A,b,E,g,m){if(g+m===E)return!0;const r=b.charCodeAt(g+m);if(A.get(r)!==0||r===13||r===10)return!0;if(m>0){const a=b.charCodeAt(g+m-1);if(A.get(a)!==0)return!0}return!1}function w(A,b,E,g,m){return o(A,b,E,g,m)&&e(A,b,E,g,m)}t.isValidMatch=w;class y{constructor(b,E){this._wordSeparators=b,this._searchRegex=E,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(b){this._searchRegex.lastIndex=b,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(b){const E=b.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===E||(g=this._searchRegex.exec(b),!g))return null;const m=g.index,r=g[0].length;if(m===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){P.getNextCodePoint(b,E,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=m,this._prevMatchLength=r,!this._wordSeparators||w(this._wordSeparators,b,E,m,r))return g}while(g);return null}}t.Searcher=y}),Z(J[51],K([0,1,2,50,5,10,24]),function(z,t,P,k,i,u,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class c{static computeUnicodeHighlights(e,w,y){const A=y?y.startLineNumber:1,b=y?y.endLineNumber:e.getLineCount(),E=new f(w),g=E.getCandidateCodePoints();let m;g==="allNonBasicAscii"?m=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):m=new RegExp(`${s(Array.from(g))}`,"g");const r=new k.Searcher(null,m),a=[];let N=!1,d,_=0,v=0,p=0;e:for(let D=A,M=b;D<=M;D++){const F=e.getLineContent(D),I=F.length;r.reset(0);do if(d=r.next(F),d){let q=d.index,O=d.index+d[0].length;if(q>0){const Q=F.charCodeAt(q-1);i.isHighSurrogate(Q)&&q--}if(O+1<I){const Q=F.charCodeAt(O-1);i.isHighSurrogate(Q)&&O++}const H=F.substring(q,O);let S=(0,L.getWordAtText)(q+1,L.DEFAULT_WORD_REGEXP,F,0);S&&S.endColumn<=q+1&&(S=null);const W=E.shouldHighlightNonBasicASCII(H,S?S.word:null);if(W!==0){W===3?_++:W===2?v++:W===1?p++:(0,u.assertNever)(W);const Q=1e3;if(a.length>=Q){N=!0;break e}a.push(new P.Range(D,q+1,D,O+1))}}while(d)}return{ranges:a,hasMore:N,ambiguousCharacterCount:_,invisibleCharacterCount:v,nonBasicAsciiCharacterCount:p}}static computeUnicodeHighlightReason(e,w){const y=new f(w);switch(y.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const b=e.codePointAt(0),E=y.ambiguousCharacters.getPrimaryConfusable(b),g=i.AmbiguousCharacters.getLocales().filter(m=>!i.AmbiguousCharacters.getInstance(new Set([...w.allowedLocales,m])).isAmbiguous(b));return{kind:0,confusableWith:String.fromCodePoint(E),notAmbiguousInLocales:g}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=c;function s(o,e){return`[${i.escapeRegExpCharacters(o.map(y=>String.fromCodePoint(y)).join(""))}]`}var l;(function(o){o[o.Ambiguous=0]="Ambiguous",o[o.Invisible=1]="Invisible",o[o.NonBasicAscii=2]="NonBasicAscii"})(l||(t.UnicodeHighlighterReasonKind=l={}));class f{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const w of i.InvisibleCharacters.codePoints)R(String.fromCodePoint(w))||e.add(w);if(this.options.ambiguousCharacters)for(const w of this.ambiguousCharacters.getConfusableCodePoints())e.add(w);for(const w of this.allowedCodePoints)e.delete(w);return e}shouldHighlightNonBasicASCII(e,w){const y=e.codePointAt(0);if(this.allowedCodePoints.has(y))return 0;if(this.options.nonBasicASCII)return 1;let A=!1,b=!1;if(w)for(const E of w){const g=E.codePointAt(0),m=i.isBasicASCII(E);A=A||m,!m&&!this.ambiguousCharacters.isAmbiguous(g)&&!i.InvisibleCharacters.isInvisibleCharacter(g)&&(b=!0)}return!A&&b?0:this.options.invisibleCharacters&&!R(e)&&i.InvisibleCharacters.isInvisibleCharacter(y)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(y)?3:0}}function R(o){return o===" "||o===`
`||o==="	"}var h;(function(o){o[o.None=0]="None",o[o.NonBasicASCII=1]="NonBasicASCII",o[o.Invisible=2]="Invisible",o[o.Ambiguous=3]="Ambiguous"})(h||(h={}))}),Z(J[52],K([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var P;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(P||(t.AccessibilitySupport=P={}));var k;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(k||(t.CodeActionTriggerType=k={}));var i;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(i||(t.CompletionItemInsertTextRule=i={}));var u;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(u||(t.CompletionItemKind=u={}));var L;(function(n){n[n.Deprecated=1]="Deprecated"})(L||(t.CompletionItemTag=L={}));var c;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(t.CompletionTriggerKind=c={}));var s;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(s||(t.ContentWidgetPositionPreference=s={}));var l;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(l||(t.CursorChangeReason=l={}));var f;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(f||(t.DefaultEndOfLine=f={}));var R;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(R||(t.DocumentHighlightKind=R={}));var h;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(h||(t.EditorAutoIndentStrategy=h={}));var o;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=8]="autoClosingDelete",n[n.autoClosingOvertype=9]="autoClosingOvertype",n[n.autoClosingQuotes=10]="autoClosingQuotes",n[n.autoIndent=11]="autoIndent",n[n.automaticLayout=12]="automaticLayout",n[n.autoSurround=13]="autoSurround",n[n.bracketPairColorization=14]="bracketPairColorization",n[n.guides=15]="guides",n[n.codeLens=16]="codeLens",n[n.codeLensFontFamily=17]="codeLensFontFamily",n[n.codeLensFontSize=18]="codeLensFontSize",n[n.colorDecorators=19]="colorDecorators",n[n.colorDecoratorsLimit=20]="colorDecoratorsLimit",n[n.columnSelection=21]="columnSelection",n[n.comments=22]="comments",n[n.contextmenu=23]="contextmenu",n[n.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",n[n.cursorBlinking=25]="cursorBlinking",n[n.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",n[n.cursorStyle=27]="cursorStyle",n[n.cursorSurroundingLines=28]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",n[n.cursorWidth=30]="cursorWidth",n[n.disableLayerHinting=31]="disableLayerHinting",n[n.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",n[n.domReadOnly=33]="domReadOnly",n[n.dragAndDrop=34]="dragAndDrop",n[n.dropIntoEditor=35]="dropIntoEditor",n[n.emptySelectionClipboard=36]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",n[n.extraEditorClassName=38]="extraEditorClassName",n[n.fastScrollSensitivity=39]="fastScrollSensitivity",n[n.find=40]="find",n[n.fixedOverflowWidgets=41]="fixedOverflowWidgets",n[n.folding=42]="folding",n[n.foldingStrategy=43]="foldingStrategy",n[n.foldingHighlight=44]="foldingHighlight",n[n.foldingImportsByDefault=45]="foldingImportsByDefault",n[n.foldingMaximumRegions=46]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=48]="fontFamily",n[n.fontInfo=49]="fontInfo",n[n.fontLigatures=50]="fontLigatures",n[n.fontSize=51]="fontSize",n[n.fontWeight=52]="fontWeight",n[n.fontVariations=53]="fontVariations",n[n.formatOnPaste=54]="formatOnPaste",n[n.formatOnType=55]="formatOnType",n[n.glyphMargin=56]="glyphMargin",n[n.gotoLocation=57]="gotoLocation",n[n.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",n[n.hover=59]="hover",n[n.inDiffEditor=60]="inDiffEditor",n[n.inlineSuggest=61]="inlineSuggest",n[n.letterSpacing=62]="letterSpacing",n[n.lightbulb=63]="lightbulb",n[n.lineDecorationsWidth=64]="lineDecorationsWidth",n[n.lineHeight=65]="lineHeight",n[n.lineNumbers=66]="lineNumbers",n[n.lineNumbersMinChars=67]="lineNumbersMinChars",n[n.linkedEditing=68]="linkedEditing",n[n.links=69]="links",n[n.matchBrackets=70]="matchBrackets",n[n.minimap=71]="minimap",n[n.mouseStyle=72]="mouseStyle",n[n.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=74]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",n[n.multiCursorModifier=76]="multiCursorModifier",n[n.multiCursorPaste=77]="multiCursorPaste",n[n.multiCursorLimit=78]="multiCursorLimit",n[n.occurrencesHighlight=79]="occurrencesHighlight",n[n.overviewRulerBorder=80]="overviewRulerBorder",n[n.overviewRulerLanes=81]="overviewRulerLanes",n[n.padding=82]="padding",n[n.pasteAs=83]="pasteAs",n[n.parameterHints=84]="parameterHints",n[n.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",n[n.quickSuggestions=87]="quickSuggestions",n[n.quickSuggestionsDelay=88]="quickSuggestionsDelay",n[n.readOnly=89]="readOnly",n[n.readOnlyMessage=90]="readOnlyMessage",n[n.renameOnType=91]="renameOnType",n[n.renderControlCharacters=92]="renderControlCharacters",n[n.renderFinalNewline=93]="renderFinalNewline",n[n.renderLineHighlight=94]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=96]="renderValidationDecorations",n[n.renderWhitespace=97]="renderWhitespace",n[n.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",n[n.roundedSelection=99]="roundedSelection",n[n.rulers=100]="rulers",n[n.scrollbar=101]="scrollbar",n[n.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=103]="scrollBeyondLastLine",n[n.scrollPredominantAxis=104]="scrollPredominantAxis",n[n.selectionClipboard=105]="selectionClipboard",n[n.selectionHighlight=106]="selectionHighlight",n[n.selectOnLineNumbers=107]="selectOnLineNumbers",n[n.showFoldingControls=108]="showFoldingControls",n[n.showUnused=109]="showUnused",n[n.snippetSuggestions=110]="snippetSuggestions",n[n.smartSelect=111]="smartSelect",n[n.smoothScrolling=112]="smoothScrolling",n[n.stickyScroll=113]="stickyScroll",n[n.stickyTabStops=114]="stickyTabStops",n[n.stopRenderingLineAfter=115]="stopRenderingLineAfter",n[n.suggest=116]="suggest",n[n.suggestFontSize=117]="suggestFontSize",n[n.suggestLineHeight=118]="suggestLineHeight",n[n.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",n[n.suggestSelection=120]="suggestSelection",n[n.tabCompletion=121]="tabCompletion",n[n.tabIndex=122]="tabIndex",n[n.unicodeHighlighting=123]="unicodeHighlighting",n[n.unusualLineTerminators=124]="unusualLineTerminators",n[n.useShadowDOM=125]="useShadowDOM",n[n.useTabStops=126]="useTabStops",n[n.wordBreak=127]="wordBreak",n[n.wordSeparators=128]="wordSeparators",n[n.wordWrap=129]="wordWrap",n[n.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=132]="wordWrapColumn",n[n.wordWrapOverride1=133]="wordWrapOverride1",n[n.wordWrapOverride2=134]="wordWrapOverride2",n[n.wrappingIndent=135]="wrappingIndent",n[n.wrappingStrategy=136]="wrappingStrategy",n[n.showDeprecated=137]="showDeprecated",n[n.inlayHints=138]="inlayHints",n[n.editorClassName=139]="editorClassName",n[n.pixelRatio=140]="pixelRatio",n[n.tabFocusMode=141]="tabFocusMode",n[n.layoutInfo=142]="layoutInfo",n[n.wrappingInfo=143]="wrappingInfo",n[n.defaultColorDecorators=144]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn"})(o||(t.EditorOption=o={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var w;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(w||(t.EndOfLineSequence=w={}));var y;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(y||(t.GlyphMarginLane=y={}));var A;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(A||(t.IndentAction=A={}));var b;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(b||(t.InjectedTextCursorStops=b={}));var E;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(E||(t.InlayHintKind=E={}));var g;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(g||(t.InlineCompletionTriggerKind=g={}));var m;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(m||(t.KeyCode=m={}));var r;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(r||(t.MarkerSeverity=r={}));var a;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(a||(t.MarkerTag=a={}));var N;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(N||(t.MinimapPosition=N={}));var d;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(d||(t.MouseTargetType=d={}));var _;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(_||(t.OverlayWidgetPositionPreference=_={}));var v;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(v||(t.OverviewRulerLane=v={}));var p;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(p||(t.PositionAffinity=p={}));var D;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(D||(t.RenderLineNumbersType=D={}));var M;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(M||(t.RenderMinimap=M={}));var F;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(F||(t.ScrollType=F={}));var I;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(I||(t.ScrollbarVisibility=I={}));var q;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(q||(t.SelectionDirection=q={}));var O;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(O||(t.SignatureHelpTriggerKind=O={}));var H;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(H||(t.SymbolKind=H={}));var S;(function(n){n[n.Deprecated=1]="Deprecated"})(S||(t.SymbolTag=S={}));var W;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(W||(t.TextEditorCursorBlinkingStyle=W={}));var Q;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(Q||(t.TextEditorCursorStyle=Q={}));var $;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($||(t.TrackedRangeStickiness=$={}));var ne;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(ne||(t.WrappingIndent=ne={}))}),Z(J[53],K([0,1,8,7]),function(z,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(c){this._onDidChange.fire({changedLanguages:c,changedColorMap:!1})}register(c,s){return this._tokenizationSupports.set(c,s),this.handleChange([c]),(0,k.toDisposable)(()=>{this._tokenizationSupports.get(c)===s&&(this._tokenizationSupports.delete(c),this.handleChange([c]))})}get(c){return this._tokenizationSupports.get(c)||null}registerFactory(c,s){this._factories.get(c)?.dispose();const l=new u(this,c,s);return this._factories.set(c,l),(0,k.toDisposable)(()=>{const f=this._factories.get(c);!f||f!==l||(this._factories.delete(c),f.dispose())})}async getOrCreate(c){const s=this.get(c);if(s)return s;const l=this._factories.get(c);return!l||l.isResolved?null:(await l.resolve(),this.get(c))}isResolved(c){if(this.get(c))return!0;const l=this._factories.get(c);return!!(!l||l.isResolved)}setColorMap(c){this._colorMap=c,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}t.TokenizationRegistry=i;class u extends k.Disposable{get isResolved(){return this._isResolved}constructor(c,s,l){super(),this._registry=c,this._languageId=s,this._factory=l,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const c=await this._factory.tokenizationSupport;this._isResolved=!0,c&&!this._isDisposed&&this._register(this._registry.register(this._languageId,c))}}}),Z(J[54],K([55,56]),function(z,t){return z.create("vs/base/common/platform",t)}),Z(J[13],K([0,1,54]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let k=!1,i=!1,u=!1,L=!1,c=!1,s=!1,l=!1,f=!1,R=!1,h=!1,o,e=t.LANGUAGE_DEFAULT,w=t.LANGUAGE_DEFAULT,y,A;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let b;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?b=t.globals.vscode.process:typeof process<"u"&&(b=process);const E=typeof b?.versions?.electron=="string",g=E&&b?.type==="renderer";if(typeof navigator=="object"&&!g)A=navigator.userAgent,k=A.indexOf("Windows")>=0,i=A.indexOf("Macintosh")>=0,f=(A.indexOf("Macintosh")>=0||A.indexOf("iPad")>=0||A.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,u=A.indexOf("Linux")>=0,h=A?.indexOf("Mobi")>=0,s=!0,o=P.getConfiguredDefaultLocale(P.localize(0,null))||t.LANGUAGE_DEFAULT,e=o,w=navigator.language;else if(typeof b=="object"){k=b.platform==="win32",i=b.platform==="darwin",u=b.platform==="linux",L=u&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,l=E,R=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,o=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const D=b.env.VSCODE_NLS_CONFIG;if(D)try{const M=JSON.parse(D),F=M.availableLanguages["*"];o=M.locale,w=M.osLocale,e=F||t.LANGUAGE_DEFAULT,y=M._translationsConfigFile}catch{}c=!0}else console.error("Unable to resolve platform.");var m;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(m||(t.Platform=m={}));function r(D){switch(D){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=r;let a=0;i?a=1:k?a=3:u&&(a=2),t.isWindows=k,t.isMacintosh=i,t.isLinux=u,t.isLinuxSnap=L,t.isNative=c,t.isElectron=l,t.isWeb=s,t.isWebWorker=s&&typeof t.globals.importScripts=="function",t.isIOS=f,t.isMobile=h,t.isCI=R,t.platform=a,t.userAgent=A,t.language=e;var N;(function(D){function M(){return t.language}D.value=M;function F(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}D.isDefaultVariant=F;function I(){return t.language==="en"}D.isDefault=I})(N||(t.Language=N={})),t.locale=o,t.platformLocale=w,t.translationsConfigFile=y,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const D=[];t.globals.addEventListener("message",F=>{if(F.data&&F.data.vscodeScheduleAsyncWork)for(let I=0,q=D.length;I<q;I++){const O=D[I];if(O.id===F.data.vscodeScheduleAsyncWork){D.splice(I,1),O.callback();return}}});let M=0;return F=>{const I=++M;D.push({id:I,callback:F}),t.globals.postMessage({vscodeScheduleAsyncWork:I},"*")}}return D=>setTimeout(D)})();var d;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(d||(t.OperatingSystem=d={})),t.OS=i||f?2:k?1:3;let _=!0,v=!1;function p(){if(!v){v=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,_=new Uint16Array(D.buffer)[0]===(2<<8)+1}return _}t.isLittleEndian=p,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),Z(J[57],K([0,1,13]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let k;if(typeof P.globals.vscode<"u"&&typeof P.globals.vscode.process<"u"){const i=P.globals.vscode.process;k={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?k={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:k={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=k.cwd,t.env=k.env,t.platform=k.platform,t.arch=k.arch}),Z(J[58],K([0,1,57]),function(z,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const k=65,i=97,u=90,L=122,c=46,s=47,l=92,f=58,R=63;class h extends Error{constructor(a,N,d){let _;typeof N=="string"&&N.indexOf("not ")===0?(_="must not be",N=N.replace(/^not /,"")):_="must be";const v=a.indexOf(".")!==-1?"property":"argument";let p=`The "${a}" ${v} ${_} of type ${N}`;p+=`. Received type ${typeof d}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function o(r,a){if(r===null||typeof r!="object")throw new h(a,"Object",r)}function e(r,a){if(typeof r!="string")throw new h(a,"string",r)}const w=P.platform==="win32";function y(r){return r===s||r===l}function A(r){return r===s}function b(r){return r>=k&&r<=u||r>=i&&r<=L}function E(r,a,N,d){let _="",v=0,p=-1,D=0,M=0;for(let F=0;F<=r.length;++F){if(F<r.length)M=r.charCodeAt(F);else{if(d(M))break;M=s}if(d(M)){if(!(p===F-1||D===1))if(D===2){if(_.length<2||v!==2||_.charCodeAt(_.length-1)!==c||_.charCodeAt(_.length-2)!==c){if(_.length>2){const I=_.lastIndexOf(N);I===-1?(_="",v=0):(_=_.slice(0,I),v=_.length-1-_.lastIndexOf(N)),p=F,D=0;continue}else if(_.length!==0){_="",v=0,p=F,D=0;continue}}a&&(_+=_.length>0?`${N}..`:"..",v=2)}else _.length>0?_+=`${N}${r.slice(p+1,F)}`:_=r.slice(p+1,F),v=F-p-1;p=F,D=0}else M===c&&D!==-1?++D:D=-1}return _}function g(r,a){o(a,"pathObject");const N=a.dir||a.root,d=a.base||`${a.name||""}${a.ext||""}`;return N?N===a.root?`${N}${d}`:`${N}${r}${d}`:d}t.win32={resolve(...r){let a="",N="",d=!1;for(let _=r.length-1;_>=-1;_--){let v;if(_>=0){if(v=r[_],e(v,"path"),v.length===0)continue}else a.length===0?v=P.cwd():(v=P.env[`=${a}`]||P.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==a.toLowerCase()&&v.charCodeAt(2)===l)&&(v=`${a}\\`));const p=v.length;let D=0,M="",F=!1;const I=v.charCodeAt(0);if(p===1)y(I)&&(D=1,F=!0);else if(y(I))if(F=!0,y(v.charCodeAt(1))){let q=2,O=q;for(;q<p&&!y(v.charCodeAt(q));)q++;if(q<p&&q!==O){const H=v.slice(O,q);for(O=q;q<p&&y(v.charCodeAt(q));)q++;if(q<p&&q!==O){for(O=q;q<p&&!y(v.charCodeAt(q));)q++;(q===p||q!==O)&&(M=`\\\\${H}\\${v.slice(O,q)}`,D=q)}}}else D=1;else b(I)&&v.charCodeAt(1)===f&&(M=v.slice(0,2),D=2,p>2&&y(v.charCodeAt(2))&&(F=!0,D=3));if(M.length>0)if(a.length>0){if(M.toLowerCase()!==a.toLowerCase())continue}else a=M;if(d){if(a.length>0)break}else if(N=`${v.slice(D)}\\${N}`,d=F,F&&a.length>0)break}return N=E(N,!d,"\\",y),d?`${a}\\${N}`:`${a}${N}`||"."},normalize(r){e(r,"path");const a=r.length;if(a===0)return".";let N=0,d,_=!1;const v=r.charCodeAt(0);if(a===1)return A(v)?"\\":r;if(y(v))if(_=!0,y(r.charCodeAt(1))){let D=2,M=D;for(;D<a&&!y(r.charCodeAt(D));)D++;if(D<a&&D!==M){const F=r.slice(M,D);for(M=D;D<a&&y(r.charCodeAt(D));)D++;if(D<a&&D!==M){for(M=D;D<a&&!y(r.charCodeAt(D));)D++;if(D===a)return`\\\\${F}\\${r.slice(M)}\\`;D!==M&&(d=`\\\\${F}\\${r.slice(M,D)}`,N=D)}}}else N=1;else b(v)&&r.charCodeAt(1)===f&&(d=r.slice(0,2),N=2,a>2&&y(r.charCodeAt(2))&&(_=!0,N=3));let p=N<a?E(r.slice(N),!_,"\\",y):"";return p.length===0&&!_&&(p="."),p.length>0&&y(r.charCodeAt(a-1))&&(p+="\\"),d===void 0?_?`\\${p}`:p:_?`${d}\\${p}`:`${d}${p}`},isAbsolute(r){e(r,"path");const a=r.length;if(a===0)return!1;const N=r.charCodeAt(0);return y(N)||a>2&&b(N)&&r.charCodeAt(1)===f&&y(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let a,N;for(let v=0;v<r.length;++v){const p=r[v];e(p,"path"),p.length>0&&(a===void 0?a=N=p:a+=`\\${p}`)}if(a===void 0)return".";let d=!0,_=0;if(typeof N=="string"&&y(N.charCodeAt(0))){++_;const v=N.length;v>1&&y(N.charCodeAt(1))&&(++_,v>2&&(y(N.charCodeAt(2))?++_:d=!1))}if(d){for(;_<a.length&&y(a.charCodeAt(_));)_++;_>=2&&(a=`\\${a.slice(_)}`)}return t.win32.normalize(a)},relative(r,a){if(e(r,"from"),e(a,"to"),r===a)return"";const N=t.win32.resolve(r),d=t.win32.resolve(a);if(N===d||(r=N.toLowerCase(),a=d.toLowerCase(),r===a))return"";let _=0;for(;_<r.length&&r.charCodeAt(_)===l;)_++;let v=r.length;for(;v-1>_&&r.charCodeAt(v-1)===l;)v--;const p=v-_;let D=0;for(;D<a.length&&a.charCodeAt(D)===l;)D++;let M=a.length;for(;M-1>D&&a.charCodeAt(M-1)===l;)M--;const F=M-D,I=p<F?p:F;let q=-1,O=0;for(;O<I;O++){const S=r.charCodeAt(_+O);if(S!==a.charCodeAt(D+O))break;S===l&&(q=O)}if(O!==I){if(q===-1)return d}else{if(F>I){if(a.charCodeAt(D+O)===l)return d.slice(D+O+1);if(O===2)return d.slice(D+O)}p>I&&(r.charCodeAt(_+O)===l?q=O:O===2&&(q=3)),q===-1&&(q=0)}let H="";for(O=_+q+1;O<=v;++O)(O===v||r.charCodeAt(O)===l)&&(H+=H.length===0?"..":"\\..");return D+=q,H.length>0?`${H}${d.slice(D,M)}`:(d.charCodeAt(D)===l&&++D,d.slice(D,M))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const a=t.win32.resolve(r);if(a.length<=2)return r;if(a.charCodeAt(0)===l){if(a.charCodeAt(1)===l){const N=a.charCodeAt(2);if(N!==R&&N!==c)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(b(a.charCodeAt(0))&&a.charCodeAt(1)===f&&a.charCodeAt(2)===l)return`\\\\?\\${a}`;return r},dirname(r){e(r,"path");const a=r.length;if(a===0)return".";let N=-1,d=0;const _=r.charCodeAt(0);if(a===1)return y(_)?r:".";if(y(_)){if(N=d=1,y(r.charCodeAt(1))){let D=2,M=D;for(;D<a&&!y(r.charCodeAt(D));)D++;if(D<a&&D!==M){for(M=D;D<a&&y(r.charCodeAt(D));)D++;if(D<a&&D!==M){for(M=D;D<a&&!y(r.charCodeAt(D));)D++;if(D===a)return r;D!==M&&(N=d=D+1)}}}}else b(_)&&r.charCodeAt(1)===f&&(N=a>2&&y(r.charCodeAt(2))?3:2,d=N);let v=-1,p=!0;for(let D=a-1;D>=d;--D)if(y(r.charCodeAt(D))){if(!p){v=D;break}}else p=!1;if(v===-1){if(N===-1)return".";v=N}return r.slice(0,v)},basename(r,a){a!==void 0&&e(a,"ext"),e(r,"path");let N=0,d=-1,_=!0,v;if(r.length>=2&&b(r.charCodeAt(0))&&r.charCodeAt(1)===f&&(N=2),a!==void 0&&a.length>0&&a.length<=r.length){if(a===r)return"";let p=a.length-1,D=-1;for(v=r.length-1;v>=N;--v){const M=r.charCodeAt(v);if(y(M)){if(!_){N=v+1;break}}else D===-1&&(_=!1,D=v+1),p>=0&&(M===a.charCodeAt(p)?--p===-1&&(d=v):(p=-1,d=D))}return N===d?d=D:d===-1&&(d=r.length),r.slice(N,d)}for(v=r.length-1;v>=N;--v)if(y(r.charCodeAt(v))){if(!_){N=v+1;break}}else d===-1&&(_=!1,d=v+1);return d===-1?"":r.slice(N,d)},extname(r){e(r,"path");let a=0,N=-1,d=0,_=-1,v=!0,p=0;r.length>=2&&r.charCodeAt(1)===f&&b(r.charCodeAt(0))&&(a=d=2);for(let D=r.length-1;D>=a;--D){const M=r.charCodeAt(D);if(y(M)){if(!v){d=D+1;break}continue}_===-1&&(v=!1,_=D+1),M===c?N===-1?N=D:p!==1&&(p=1):N!==-1&&(p=-1)}return N===-1||_===-1||p===0||p===1&&N===_-1&&N===d+1?"":r.slice(N,_)},format:g.bind(null,"\\"),parse(r){e(r,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return a;const N=r.length;let d=0,_=r.charCodeAt(0);if(N===1)return y(_)?(a.root=a.dir=r,a):(a.base=a.name=r,a);if(y(_)){if(d=1,y(r.charCodeAt(1))){let q=2,O=q;for(;q<N&&!y(r.charCodeAt(q));)q++;if(q<N&&q!==O){for(O=q;q<N&&y(r.charCodeAt(q));)q++;if(q<N&&q!==O){for(O=q;q<N&&!y(r.charCodeAt(q));)q++;q===N?d=q:q!==O&&(d=q+1)}}}}else if(b(_)&&r.charCodeAt(1)===f){if(N<=2)return a.root=a.dir=r,a;if(d=2,y(r.charCodeAt(2))){if(N===3)return a.root=a.dir=r,a;d=3}}d>0&&(a.root=r.slice(0,d));let v=-1,p=d,D=-1,M=!0,F=r.length-1,I=0;for(;F>=d;--F){if(_=r.charCodeAt(F),y(_)){if(!M){p=F+1;break}continue}D===-1&&(M=!1,D=F+1),_===c?v===-1?v=F:I!==1&&(I=1):v!==-1&&(I=-1)}return D!==-1&&(v===-1||I===0||I===1&&v===D-1&&v===p+1?a.base=a.name=r.slice(p,D):(a.name=r.slice(p,v),a.base=r.slice(p,D),a.ext=r.slice(v,D))),p>0&&p!==d?a.dir=r.slice(0,p-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(w){const r=/\\/g;return()=>{const a=P.cwd().replace(r,"/");return a.slice(a.indexOf("/"))}}return()=>P.cwd()})();t.posix={resolve(...r){let a="",N=!1;for(let d=r.length-1;d>=-1&&!N;d--){const _=d>=0?r[d]:m();e(_,"path"),_.length!==0&&(a=`${_}/${a}`,N=_.charCodeAt(0)===s)}return a=E(a,!N,"/",A),N?`/${a}`:a.length>0?a:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const a=r.charCodeAt(0)===s,N=r.charCodeAt(r.length-1)===s;return r=E(r,!a,"/",A),r.length===0?a?"/":N?"./":".":(N&&(r+="/"),a?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===s},join(...r){if(r.length===0)return".";let a;for(let N=0;N<r.length;++N){const d=r[N];e(d,"path"),d.length>0&&(a===void 0?a=d:a+=`/${d}`)}return a===void 0?".":t.posix.normalize(a)},relative(r,a){if(e(r,"from"),e(a,"to"),r===a||(r=t.posix.resolve(r),a=t.posix.resolve(a),r===a))return"";const N=1,d=r.length,_=d-N,v=1,p=a.length-v,D=_<p?_:p;let M=-1,F=0;for(;F<D;F++){const q=r.charCodeAt(N+F);if(q!==a.charCodeAt(v+F))break;q===s&&(M=F)}if(F===D)if(p>D){if(a.charCodeAt(v+F)===s)return a.slice(v+F+1);if(F===0)return a.slice(v+F)}else _>D&&(r.charCodeAt(N+F)===s?M=F:F===0&&(M=0));let I="";for(F=N+M+1;F<=d;++F)(F===d||r.charCodeAt(F)===s)&&(I+=I.length===0?"..":"/..");return`${I}${a.slice(v+M)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const a=r.charCodeAt(0)===s;let N=-1,d=!0;for(let _=r.length-1;_>=1;--_)if(r.charCodeAt(_)===s){if(!d){N=_;break}}else d=!1;return N===-1?a?"/":".":a&&N===1?"//":r.slice(0,N)},basename(r,a){a!==void 0&&e(a,"ext"),e(r,"path");let N=0,d=-1,_=!0,v;if(a!==void 0&&a.length>0&&a.length<=r.length){if(a===r)return"";let p=a.length-1,D=-1;for(v=r.length-1;v>=0;--v){const M=r.charCodeAt(v);if(M===s){if(!_){N=v+1;break}}else D===-1&&(_=!1,D=v+1),p>=0&&(M===a.charCodeAt(p)?--p===-1&&(d=v):(p=-1,d=D))}return N===d?d=D:d===-1&&(d=r.length),r.slice(N,d)}for(v=r.length-1;v>=0;--v)if(r.charCodeAt(v)===s){if(!_){N=v+1;break}}else d===-1&&(_=!1,d=v+1);return d===-1?"":r.slice(N,d)},extname(r){e(r,"path");let a=-1,N=0,d=-1,_=!0,v=0;for(let p=r.length-1;p>=0;--p){const D=r.charCodeAt(p);if(D===s){if(!_){N=p+1;break}continue}d===-1&&(_=!1,d=p+1),D===c?a===-1?a=p:v!==1&&(v=1):a!==-1&&(v=-1)}return a===-1||d===-1||v===0||v===1&&a===d-1&&a===N+1?"":r.slice(a,d)},format:g.bind(null,"/"),parse(r){e(r,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return a;const N=r.charCodeAt(0)===s;let d;N?(a.root="/",d=1):d=0;let _=-1,v=0,p=-1,D=!0,M=r.length-1,F=0;for(;M>=d;--M){const I=r.charCodeAt(M);if(I===s){if(!D){v=M+1;break}continue}p===-1&&(D=!1,p=M+1),I===c?_===-1?_=M:F!==1&&(F=1):_!==-1&&(F=-1)}if(p!==-1){const I=v===0&&N?1:v;_===-1||F===0||F===1&&_===p-1&&_===v+1?a.base=a.name=r.slice(I,p):(a.name=r.slice(I,_),a.base=r.slice(I,p),a.ext=r.slice(_,p))}return v>0?a.dir=r.slice(0,v-1):N&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=w?t.win32.normalize:t.posix.normalize,t.isAbsolute=w?t.win32.isAbsolute:t.posix.isAbsolute,t.join=w?t.win32.join:t.posix.join,t.resolve=w?t.win32.resolve:t.posix.resolve,t.relative=w?t.win32.relative:t.posix.relative,t.dirname=w?t.win32.dirname:t.posix.dirname,t.basename=w?t.win32.basename:t.posix.basename,t.extname=w?t.win32.extname:t.posix.extname,t.format=w?t.win32.format:t.posix.format,t.parse=w?t.win32.parse:t.posix.parse,t.toNamespacedPath=w?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=w?t.win32.sep:t.posix.sep,t.delimiter=w?t.win32.delimiter:t.posix.delimiter}),Z(J[14],K([0,1,58,13]),function(z,t,P,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.isUriComponents=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,u=/^\//,L=/^\/\//;function c(d,_){if(!d.scheme&&_)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!i.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!u.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function s(d,_){return!d&&!_?"file":d}function l(d,_){switch(d){case"https":case"http":case"file":_?_[0]!==R&&(_=R+_):_=R;break}return _}const f="",R="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class o{static isUri(_){return _ instanceof o?!0:_?typeof _.authority=="string"&&typeof _.fragment=="string"&&typeof _.path=="string"&&typeof _.query=="string"&&typeof _.scheme=="string"&&typeof _.fsPath=="string"&&typeof _.with=="function"&&typeof _.toString=="function":!1}constructor(_,v,p,D,M,F=!1){typeof _=="object"?(this.scheme=_.scheme||f,this.authority=_.authority||f,this.path=_.path||f,this.query=_.query||f,this.fragment=_.fragment||f):(this.scheme=s(_,F),this.authority=v||f,this.path=l(this.scheme,p||f),this.query=D||f,this.fragment=M||f,c(this,F))}get fsPath(){return g(this,!1)}with(_){if(!_)return this;let{scheme:v,authority:p,path:D,query:M,fragment:F}=_;return v===void 0?v=this.scheme:v===null&&(v=f),p===void 0?p=this.authority:p===null&&(p=f),D===void 0?D=this.path:D===null&&(D=f),M===void 0?M=this.query:M===null&&(M=f),F===void 0?F=this.fragment:F===null&&(F=f),v===this.scheme&&p===this.authority&&D===this.path&&M===this.query&&F===this.fragment?this:new y(v,p,D,M,F)}static parse(_,v=!1){const p=h.exec(_);return p?new y(p[2]||f,N(p[4]||f),N(p[5]||f),N(p[7]||f),N(p[9]||f),v):new y(f,f,f,f,f)}static file(_){let v=f;if(k.isWindows&&(_=_.replace(/\\/g,R)),_[0]===R&&_[1]===R){const p=_.indexOf(R,2);p===-1?(v=_.substring(2),_=R):(v=_.substring(2,p),_=_.substring(p)||R)}return new y("file",v,_,f,f)}static from(_,v){return new y(_.scheme,_.authority,_.path,_.query,_.fragment,v)}static joinPath(_,...v){if(!_.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return k.isWindows&&_.scheme==="file"?p=o.file(P.win32.join(g(_,!0),...v)).path:p=P.posix.join(_.path,...v),_.with({path:p})}toString(_=!1){return m(this,_)}toJSON(){return this}static revive(_){if(_){if(_ instanceof o)return _;{const v=new y(_);return v._formatted=_.external??null,v._fsPath=_._sep===w?_.fsPath??null:null,v}}else return _}}t.URI=o;function e(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}t.isUriComponents=e;const w=k.isWindows?1:void 0;class y extends o{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(_=!1){return _?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const _={$mid:1};return this._fsPath&&(_.fsPath=this._fsPath,_._sep=w),this._formatted&&(_.external=this._formatted),this.path&&(_.path=this.path),this.scheme&&(_.scheme=this.scheme),this.authority&&(_.authority=this.authority),this.query&&(_.query=this.query),this.fragment&&(_.fragment=this.fragment),_}}const A={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(d,_,v){let p,D=-1;for(let M=0;M<d.length;M++){const F=d.charCodeAt(M);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||_&&F===47||v&&F===91||v&&F===93||v&&F===58)D!==-1&&(p+=encodeURIComponent(d.substring(D,M)),D=-1),p!==void 0&&(p+=d.charAt(M));else{p===void 0&&(p=d.substr(0,M));const I=A[F];I!==void 0?(D!==-1&&(p+=encodeURIComponent(d.substring(D,M)),D=-1),p+=I):D===-1&&(D=M)}}return D!==-1&&(p+=encodeURIComponent(d.substring(D))),p!==void 0?p:d}function E(d){let _;for(let v=0;v<d.length;v++){const p=d.charCodeAt(v);p===35||p===63?(_===void 0&&(_=d.substr(0,v)),_+=A[p]):_!==void 0&&(_+=d[v])}return _!==void 0?_:d}function g(d,_){let v;return d.authority&&d.path.length>1&&d.scheme==="file"?v=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?_?v=d.path.substr(1):v=d.path[1].toLowerCase()+d.path.substr(2):v=d.path,k.isWindows&&(v=v.replace(/\//g,"\\")),v}t.uriToFsPath=g;function m(d,_){const v=_?E:b;let p="",{scheme:D,authority:M,path:F,query:I,fragment:q}=d;if(D&&(p+=D,p+=":"),(M||D==="file")&&(p+=R,p+=R),M){let O=M.indexOf("@");if(O!==-1){const H=M.substr(0,O);M=M.substr(O+1),O=H.lastIndexOf(":"),O===-1?p+=v(H,!1,!1):(p+=v(H.substr(0,O),!1,!1),p+=":",p+=v(H.substr(O+1),!1,!0)),p+="@"}M=M.toLowerCase(),O=M.lastIndexOf(":"),O===-1?p+=v(M,!1,!0):(p+=v(M.substr(0,O),!1,!0),p+=M.substr(O))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const O=F.charCodeAt(1);O>=65&&O<=90&&(F=`/${String.fromCharCode(O+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const O=F.charCodeAt(0);O>=65&&O<=90&&(F=`${String.fromCharCode(O+32)}:${F.substr(2)}`)}p+=v(F,!0,!1)}return I&&(p+="?",p+=v(I,!1,!1)),q&&(p+="#",p+=_?q:b(q,!1,!1)),p}function r(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+r(d.substr(3)):d}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N(d){return d.match(a)?d.replace(a,_=>r(_)):d}}),Z(J[63],K([0,1,3,8,7,11,13,5]),function(z,t,P,k,i,u,L,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const s="$initialize";let l=!1;function f(N){L.isWeb&&(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(N.message))}t.logOnceWebWorkerWarning=f;var R;(function(N){N[N.Request=0]="Request",N[N.Reply=1]="Reply",N[N.SubscribeEvent=2]="SubscribeEvent",N[N.Event=3]="Event",N[N.UnsubscribeEvent=4]="UnsubscribeEvent"})(R||(R={}));class h{constructor(d,_,v,p){this.vsWorker=d,this.req=_,this.method=v,this.args=p,this.type=0}}class o{constructor(d,_,v,p){this.vsWorker=d,this.seq=_,this.res=v,this.err=p,this.type=1}}class e{constructor(d,_,v,p){this.vsWorker=d,this.req=_,this.eventName=v,this.arg=p,this.type=2}}class w{constructor(d,_,v){this.vsWorker=d,this.req=_,this.event=v,this.type=3}}class y{constructor(d,_){this.vsWorker=d,this.req=_,this.type=4}}class A{constructor(d){this._workerId=-1,this._handler=d,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(d){this._workerId=d}sendMessage(d,_){const v=String(++this._lastSentReq);return new Promise((p,D)=>{this._pendingReplies[v]={resolve:p,reject:D},this._send(new h(this._workerId,v,d,_))})}listen(d,_){let v=null;const p=new k.Emitter({onWillAddFirstListener:()=>{v=String(++this._lastSentReq),this._pendingEmitters.set(v,p),this._send(new e(this._workerId,v,d,_))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(v),this._send(new y(this._workerId,v)),v=null}});return p.event}handleMessage(d){!d||!d.vsWorker||this._workerId!==-1&&d.vsWorker!==this._workerId||this._handleMessage(d)}_handleMessage(d){switch(d.type){case 1:return this._handleReplyMessage(d);case 0:return this._handleRequestMessage(d);case 2:return this._handleSubscribeEventMessage(d);case 3:return this._handleEventMessage(d);case 4:return this._handleUnsubscribeEventMessage(d)}}_handleReplyMessage(d){if(!this._pendingReplies[d.seq]){console.warn("Got reply to unknown seq");return}const _=this._pendingReplies[d.seq];if(delete this._pendingReplies[d.seq],d.err){let v=d.err;d.err.$isError&&(v=new Error,v.name=d.err.name,v.message=d.err.message,v.stack=d.err.stack),_.reject(v);return}_.resolve(d.res)}_handleRequestMessage(d){const _=d.req;this._handler.handleMessage(d.method,d.args).then(p=>{this._send(new o(this._workerId,_,p,void 0))},p=>{p.detail instanceof Error&&(p.detail=(0,P.transformErrorForSerialization)(p.detail)),this._send(new o(this._workerId,_,void 0,(0,P.transformErrorForSerialization)(p)))})}_handleSubscribeEventMessage(d){const _=d.req,v=this._handler.handleEvent(d.eventName,d.arg)(p=>{this._send(new w(this._workerId,_,p))});this._pendingEvents.set(_,v)}_handleEventMessage(d){if(!this._pendingEmitters.has(d.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(d.req).fire(d.event)}_handleUnsubscribeEventMessage(d){if(!this._pendingEvents.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(d.req).dispose(),this._pendingEvents.delete(d.req)}_send(d){const _=[];if(d.type===0)for(let v=0;v<d.args.length;v++)d.args[v]instanceof ArrayBuffer&&_.push(d.args[v]);else d.type===1&&d.res instanceof ArrayBuffer&&_.push(d.res);this._handler.sendMessage(d,_)}}class b extends i.Disposable{constructor(d,_,v){super();let p=null;this._worker=this._register(d.create("vs/base/common/worker/simpleWorker",O=>{this._protocol.handleMessage(O)},O=>{p?.(O)})),this._protocol=new A({sendMessage:(O,H)=>{this._worker.postMessage(O,H)},handleMessage:(O,H)=>{if(typeof v[O]!="function")return Promise.reject(new Error("Missing method "+O+" on main thread host."));try{return Promise.resolve(v[O].apply(v,H))}catch(S){return Promise.reject(S)}},handleEvent:(O,H)=>{if(g(O)){const S=v[O].call(v,H);if(typeof S!="function")throw new Error(`Missing dynamic event ${O} on main thread host.`);return S}if(E(O)){const S=v[O];if(typeof S!="function")throw new Error(`Missing event ${O} on main thread host.`);return S}throw new Error(`Malformed event name ${O}`)}}),this._protocol.setWorkerId(this._worker.getId());let D=null;const M=globalThis.require;typeof M<"u"&&typeof M.getConfig=="function"?D=M.getConfig():typeof globalThis.requirejs<"u"&&(D=globalThis.requirejs.s.contexts._.config);const F=(0,u.getAllMethodNames)(v);this._onModuleLoaded=this._protocol.sendMessage(s,[this._worker.getId(),JSON.parse(JSON.stringify(D)),_,F]);const I=(O,H)=>this._request(O,H),q=(O,H)=>this._protocol.listen(O,H);this._lazyProxy=new Promise((O,H)=>{p=H,this._onModuleLoaded.then(S=>{O(m(S,I,q))},S=>{H(S),this._onError("Worker failed to load "+_,S)})})}getProxyObject(){return this._lazyProxy}_request(d,_){return new Promise((v,p)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(d,_).then(v,p)},p)})}_onError(d,_){console.error(d),console.info(_)}}t.SimpleWorkerClient=b;function E(N){return N[0]==="o"&&N[1]==="n"&&c.isUpperAsciiLetter(N.charCodeAt(2))}function g(N){return/^onDynamic/.test(N)&&c.isUpperAsciiLetter(N.charCodeAt(9))}function m(N,d,_){const v=M=>function(){const F=Array.prototype.slice.call(arguments,0);return d(M,F)},p=M=>function(F){return _(M,F)},D={};for(const M of N){if(g(M)){D[M]=p(M);continue}if(E(M)){D[M]=_(M,void 0);continue}D[M]=v(M)}return D}class r{constructor(d,_){this._requestHandlerFactory=_,this._requestHandler=null,this._protocol=new A({sendMessage:(v,p)=>{d(v,p)},handleMessage:(v,p)=>this._handleMessage(v,p),handleEvent:(v,p)=>this._handleEvent(v,p)})}onmessage(d){this._protocol.handleMessage(d)}_handleMessage(d,_){if(d===s)return this.initialize(_[0],_[1],_[2],_[3]);if(!this._requestHandler||typeof this._requestHandler[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this._requestHandler[d].apply(this._requestHandler,_))}catch(v){return Promise.reject(v)}}_handleEvent(d,_){if(!this._requestHandler)throw new Error("Missing requestHandler");if(g(d)){const v=this._requestHandler[d].call(this._requestHandler,_);if(typeof v!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return v}if(E(d)){const v=this._requestHandler[d];if(typeof v!="function")throw new Error(`Missing event ${d} on request handler.`);return v}throw new Error(`Malformed event name ${d}`)}initialize(d,_,v,p){this._protocol.setWorkerId(d);const F=m(p,(I,q)=>this._protocol.sendMessage(I,q),(I,q)=>this._protocol.listen(I,q));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(F),Promise.resolve((0,u.getAllMethodNames)(this._requestHandler))):(_&&(typeof _.baseUrl<"u"&&delete _.baseUrl,typeof _.paths<"u"&&typeof _.paths.vs<"u"&&delete _.paths.vs,typeof _.trustedTypesPolicy!==void 0&&delete _.trustedTypesPolicy,_.catchError=!0,globalThis.require.config(_)),new Promise((I,q)=>{(globalThis.require||z)([v],H=>{if(this._requestHandler=H.create(F),!this._requestHandler){q(new Error("No RequestHandler!"));return}I((0,u.getAllMethodNames)(this._requestHandler))},q)}))}}t.SimpleWorkerServer=r;function a(N){return new r(N,null)}t.create=a}),Z(J[59],K([55,56]),function(z,t){return z.create("vs/editor/common/languages",t)}),Z(J[60],K([0,1,34,14,35,2,53,59]),function(z,t,P,k,i,u,L,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.LazyTokenizationSupport=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.FoldingRangeKind=t.TextEdit=t.SymbolKinds=t.SymbolTag=t.getAriaLabelForSymbol=t.symbolKindNames=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.SelectedSuggestionInfo=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0;class s{constructor(W,Q,$){this.offset=W,this.type=Q,this.language=$,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=s;class l{constructor(W,Q){this.tokens=W,this.endState=Q,this._tokenizationResultBrand=void 0}}t.TokenizationResult=l;class f{constructor(W,Q){this.tokens=W,this.endState=Q,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=f;var R;(function(S){S[S.Method=0]="Method",S[S.Function=1]="Function",S[S.Constructor=2]="Constructor",S[S.Field=3]="Field",S[S.Variable=4]="Variable",S[S.Class=5]="Class",S[S.Struct=6]="Struct",S[S.Interface=7]="Interface",S[S.Module=8]="Module",S[S.Property=9]="Property",S[S.Event=10]="Event",S[S.Operator=11]="Operator",S[S.Unit=12]="Unit",S[S.Value=13]="Value",S[S.Constant=14]="Constant",S[S.Enum=15]="Enum",S[S.EnumMember=16]="EnumMember",S[S.Keyword=17]="Keyword",S[S.Text=18]="Text",S[S.Color=19]="Color",S[S.File=20]="File",S[S.Reference=21]="Reference",S[S.Customcolor=22]="Customcolor",S[S.Folder=23]="Folder",S[S.TypeParameter=24]="TypeParameter",S[S.User=25]="User",S[S.Issue=26]="Issue",S[S.Snippet=27]="Snippet"})(R||(t.CompletionItemKind=R={}));var h;(function(S){const W=new Map;W.set(0,P.Codicon.symbolMethod),W.set(1,P.Codicon.symbolFunction),W.set(2,P.Codicon.symbolConstructor),W.set(3,P.Codicon.symbolField),W.set(4,P.Codicon.symbolVariable),W.set(5,P.Codicon.symbolClass),W.set(6,P.Codicon.symbolStruct),W.set(7,P.Codicon.symbolInterface),W.set(8,P.Codicon.symbolModule),W.set(9,P.Codicon.symbolProperty),W.set(10,P.Codicon.symbolEvent),W.set(11,P.Codicon.symbolOperator),W.set(12,P.Codicon.symbolUnit),W.set(13,P.Codicon.symbolValue),W.set(15,P.Codicon.symbolEnum),W.set(14,P.Codicon.symbolConstant),W.set(15,P.Codicon.symbolEnum),W.set(16,P.Codicon.symbolEnumMember),W.set(17,P.Codicon.symbolKeyword),W.set(27,P.Codicon.symbolSnippet),W.set(18,P.Codicon.symbolText),W.set(19,P.Codicon.symbolColor),W.set(20,P.Codicon.symbolFile),W.set(21,P.Codicon.symbolReference),W.set(22,P.Codicon.symbolCustomColor),W.set(23,P.Codicon.symbolFolder),W.set(24,P.Codicon.symbolTypeParameter),W.set(25,P.Codicon.account),W.set(26,P.Codicon.issues);function Q(n){let oe=W.get(n);return oe||(console.info("No codicon found for CompletionItemKind "+n),oe=P.Codicon.symbolProperty),oe}S.toIcon=Q;const $=new Map;$.set("method",0),$.set("function",1),$.set("constructor",2),$.set("field",3),$.set("variable",4),$.set("class",5),$.set("struct",6),$.set("interface",7),$.set("module",8),$.set("property",9),$.set("event",10),$.set("operator",11),$.set("unit",12),$.set("value",13),$.set("constant",14),$.set("enum",15),$.set("enum-member",16),$.set("enumMember",16),$.set("keyword",17),$.set("snippet",27),$.set("text",18),$.set("color",19),$.set("file",20),$.set("reference",21),$.set("customcolor",22),$.set("folder",23),$.set("type-parameter",24),$.set("typeParameter",24),$.set("account",25),$.set("issue",26);function ne(n,oe){let ce=$.get(n);return typeof ce>"u"&&!oe&&(ce=9),ce}S.fromString=ne})(h||(t.CompletionItemKinds=h={}));var o;(function(S){S[S.Deprecated=1]="Deprecated"})(o||(t.CompletionItemTag=o={}));var e;(function(S){S[S.None=0]="None",S[S.KeepWhitespace=1]="KeepWhitespace",S[S.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var w;(function(S){S[S.Invoke=0]="Invoke",S[S.TriggerCharacter=1]="TriggerCharacter",S[S.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(t.CompletionTriggerKind=w={}));var y;(function(S){S[S.Automatic=0]="Automatic",S[S.Explicit=1]="Explicit"})(y||(t.InlineCompletionTriggerKind=y={}));class A{constructor(W,Q,$,ne){this.range=W,this.text=Q,this.completionKind=$,this.isSnippetText=ne}equals(W){return u.Range.lift(this.range).equalsRange(W.range)&&this.text===W.text&&this.completionKind===W.completionKind&&this.isSnippetText===W.isSnippetText}}t.SelectedSuggestionInfo=A;var b;(function(S){S[S.Invoke=1]="Invoke",S[S.Auto=2]="Auto"})(b||(t.CodeActionTriggerType=b={}));var E;(function(S){S[S.Invoke=1]="Invoke",S[S.TriggerCharacter=2]="TriggerCharacter",S[S.ContentChange=3]="ContentChange"})(E||(t.SignatureHelpTriggerKind=E={}));var g;(function(S){S[S.Text=0]="Text",S[S.Read=1]="Read",S[S.Write=2]="Write"})(g||(t.DocumentHighlightKind=g={}));function m(S){return S&&k.URI.isUri(S.uri)&&u.Range.isIRange(S.range)&&(u.Range.isIRange(S.originSelectionRange)||u.Range.isIRange(S.targetSelectionRange))}t.isLocationLink=m;var r;(function(S){S[S.File=0]="File",S[S.Module=1]="Module",S[S.Namespace=2]="Namespace",S[S.Package=3]="Package",S[S.Class=4]="Class",S[S.Method=5]="Method",S[S.Property=6]="Property",S[S.Field=7]="Field",S[S.Constructor=8]="Constructor",S[S.Enum=9]="Enum",S[S.Interface=10]="Interface",S[S.Function=11]="Function",S[S.Variable=12]="Variable",S[S.Constant=13]="Constant",S[S.String=14]="String",S[S.Number=15]="Number",S[S.Boolean=16]="Boolean",S[S.Array=17]="Array",S[S.Object=18]="Object",S[S.Key=19]="Key",S[S.Null=20]="Null",S[S.EnumMember=21]="EnumMember",S[S.Struct=22]="Struct",S[S.Event=23]="Event",S[S.Operator=24]="Operator",S[S.TypeParameter=25]="TypeParameter"})(r||(t.SymbolKind=r={})),t.symbolKindNames={[17]:(0,c.localize)(0,null),[16]:(0,c.localize)(1,null),[4]:(0,c.localize)(2,null),[13]:(0,c.localize)(3,null),[8]:(0,c.localize)(4,null),[9]:(0,c.localize)(5,null),[21]:(0,c.localize)(6,null),[23]:(0,c.localize)(7,null),[7]:(0,c.localize)(8,null),[0]:(0,c.localize)(9,null),[11]:(0,c.localize)(10,null),[10]:(0,c.localize)(11,null),[19]:(0,c.localize)(12,null),[5]:(0,c.localize)(13,null),[1]:(0,c.localize)(14,null),[2]:(0,c.localize)(15,null),[20]:(0,c.localize)(16,null),[15]:(0,c.localize)(17,null),[18]:(0,c.localize)(18,null),[24]:(0,c.localize)(19,null),[3]:(0,c.localize)(20,null),[6]:(0,c.localize)(21,null),[14]:(0,c.localize)(22,null),[22]:(0,c.localize)(23,null),[25]:(0,c.localize)(24,null),[12]:(0,c.localize)(25,null)};function a(S,W){return(0,c.localize)(26,null,S,t.symbolKindNames[W])}t.getAriaLabelForSymbol=a;var N;(function(S){S[S.Deprecated=1]="Deprecated"})(N||(t.SymbolTag=N={}));var d;(function(S){const W=new Map;W.set(0,P.Codicon.symbolFile),W.set(1,P.Codicon.symbolModule),W.set(2,P.Codicon.symbolNamespace),W.set(3,P.Codicon.symbolPackage),W.set(4,P.Codicon.symbolClass),W.set(5,P.Codicon.symbolMethod),W.set(6,P.Codicon.symbolProperty),W.set(7,P.Codicon.symbolField),W.set(8,P.Codicon.symbolConstructor),W.set(9,P.Codicon.symbolEnum),W.set(10,P.Codicon.symbolInterface),W.set(11,P.Codicon.symbolFunction),W.set(12,P.Codicon.symbolVariable),W.set(13,P.Codicon.symbolConstant),W.set(14,P.Codicon.symbolString),W.set(15,P.Codicon.symbolNumber),W.set(16,P.Codicon.symbolBoolean),W.set(17,P.Codicon.symbolArray),W.set(18,P.Codicon.symbolObject),W.set(19,P.Codicon.symbolKey),W.set(20,P.Codicon.symbolNull),W.set(21,P.Codicon.symbolEnumMember),W.set(22,P.Codicon.symbolStruct),W.set(23,P.Codicon.symbolEvent),W.set(24,P.Codicon.symbolOperator),W.set(25,P.Codicon.symbolTypeParameter);function Q($){let ne=W.get($);return ne||(console.info("No codicon found for SymbolKind "+$),ne=P.Codicon.symbolProperty),ne}S.toIcon=Q})(d||(t.SymbolKinds=d={}));class _{static asEditOperation(W){return i.EditOperation.replace(u.Range.lift(W.range),W.text)}}t.TextEdit=_;class v{static{this.Comment=new v("comment")}static{this.Imports=new v("imports")}static{this.Region=new v("region")}static fromValue(W){switch(W){case"comment":return v.Comment;case"imports":return v.Imports;case"region":return v.Region}return new v(W)}constructor(W){this.value=W}}t.FoldingRangeKind=v;var p;(function(S){function W(Q){return!Q||typeof Q!="object"?!1:typeof Q.id=="string"&&typeof Q.title=="string"}S.is=W})(p||(t.Command=p={}));var D;(function(S){S[S.Collapsed=0]="Collapsed",S[S.Expanded=1]="Expanded"})(D||(t.CommentThreadCollapsibleState=D={}));var M;(function(S){S[S.Unresolved=0]="Unresolved",S[S.Resolved=1]="Resolved"})(M||(t.CommentThreadState=M={}));var F;(function(S){S[S.Editing=0]="Editing",S[S.Preview=1]="Preview"})(F||(t.CommentMode=F={}));var I;(function(S){S[S.Published=0]="Published",S[S.Draft=1]="Draft"})(I||(t.CommentState=I={}));var q;(function(S){S[S.Type=1]="Type",S[S.Parameter=2]="Parameter"})(q||(t.InlayHintKind=q={}));class O{constructor(W){this.createSupport=W,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(W=>{W&&W.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}t.LazyTokenizationSupport=O,t.TokenizationRegistry=new L.TokenizationRegistry;var H;(function(S){S[S.None=0]="None",S[S.Option=1]="Option",S[S.Default=2]="Default",S[S.Preferred=3]="Preferred"})(H||(t.ExternalUriOpenerPriority=H={}))}),Z(J[61],K([0,1,19,8,30,14,4,2,36,60,52]),function(z,t,P,k,i,u,L,c,s,l,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class R{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,w){return(0,i.KeyChord)(e,w)}}t.KeyMod=R;function h(){return{editor:void 0,languages:void 0,CancellationTokenSource:P.CancellationTokenSource,Emitter:k.Emitter,KeyCode:f.KeyCode,KeyMod:R,Position:L.Position,Range:c.Range,Selection:s.Selection,SelectionDirection:f.SelectionDirection,MarkerSeverity:f.MarkerSeverity,MarkerTag:f.MarkerTag,Uri:u.URI,Token:l.Token}}t.createMonacoBaseAPI=h}),Z(J[64],K([0,1,20,14,4,2,49,24,45,46,61,18,51,26,43,11,3,44]),function(z,t,P,k,i,u,L,c,s,l,f,R,h,o,e,w,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class b extends L.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(r){const a=[];for(let N=0;N<this._lines.length;N++){const d=this._lines[N],_=this.offsetAt(new i.Position(N+1,1)),v=d.matchAll(r);for(const p of v)(p.index||p.index===0)&&(p.index=p.index+_),a.push(p)}return a}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(r){return this._lines[r-1]}getWordAtPosition(r,a){const N=(0,c.getWordAtText)(r.column,(0,c.ensureValidWordDefinition)(a),this._lines[r.lineNumber-1],0);return N?new u.Range(r.lineNumber,N.startColumn,r.lineNumber,N.endColumn):null}getWordUntilPosition(r,a){const N=this.getWordAtPosition(r,a);return N?{word:this._lines[r.lineNumber-1].substring(N.startColumn-1,r.column-1),startColumn:N.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const a=this._lines,N=this._wordenize.bind(this);let d=0,_="",v=0,p=[];return{*[Symbol.iterator](){for(;;)if(v<p.length){const D=_.substring(p[v].start,p[v].end);v+=1,yield D}else if(d<a.length)_=a[d],p=N(_,r),v=0,d+=1;else break}}}getLineWords(r,a){const N=this._lines[r-1],d=this._wordenize(N,a),_=[];for(const v of d)_.push({word:N.substring(v.start,v.end),startColumn:v.start+1,endColumn:v.end+1});return _}_wordenize(r,a){const N=[];let d;for(a.lastIndex=0;(d=a.exec(r))&&d[0].length!==0;)N.push({start:d.index,end:d.index+d[0].length});return N}getValueInRange(r){if(r=this._validateRange(r),r.startLineNumber===r.endLineNumber)return this._lines[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const a=this._eol,N=r.startLineNumber-1,d=r.endLineNumber-1,_=[];_.push(this._lines[N].substring(r.startColumn-1));for(let v=N+1;v<d;v++)_.push(this._lines[v]);return _.push(this._lines[d].substring(0,r.endColumn-1)),_.join(a)}offsetAt(r){return r=this._validatePosition(r),this._ensureLineStarts(),this._lineStarts.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this._ensureLineStarts();const a=this._lineStarts.getIndexOf(r),N=this._lines[a.index].length;return{lineNumber:1+a.index,column:1+Math.min(a.remainder,N)}}_validateRange(r){const a=this._validatePosition({lineNumber:r.startLineNumber,column:r.startColumn}),N=this._validatePosition({lineNumber:r.endLineNumber,column:r.endColumn});return a.lineNumber!==r.startLineNumber||a.column!==r.startColumn||N.lineNumber!==r.endLineNumber||N.column!==r.endColumn?{startLineNumber:a.lineNumber,startColumn:a.column,endLineNumber:N.lineNumber,endColumn:N.column}:r}_validatePosition(r){if(!i.Position.isIPosition(r))throw new Error("bad position");let{lineNumber:a,column:N}=r,d=!1;if(a<1)a=1,N=1,d=!0;else if(a>this._lines.length)a=this._lines.length,N=this._lines[a-1].length+1,d=!0;else{const _=this._lines[a-1].length+1;N<1?(N=1,d=!0):N>_&&(N=_,d=!0)}return d?{lineNumber:a,column:N}:r}}class E{constructor(r,a){this._host=r,this._models=Object.create(null),this._foreignModuleFactory=a,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(r){return this._models[r]}_getModels(){const r=[];return Object.keys(this._models).forEach(a=>r.push(this._models[a])),r}acceptNewModel(r){this._models[r.url]=new b(k.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,a){if(!this._models[r])return;this._models[r].onEvents(a)}acceptRemovedModel(r){this._models[r]&&delete this._models[r]}async computeUnicodeHighlights(r,a,N){const d=this._getModel(r);return d?h.UnicodeTextModelHighlighter.computeUnicodeHighlights(d,a,N):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(r,a,N,d){const _=this._getModel(r),v=this._getModel(a);return!_||!v?null:E.computeDiff(_,v,N,d)}static computeDiff(r,a,N,d){const _=d==="advanced"?e.linesDiffComputers.getAdvanced():e.linesDiffComputers.getLegacy(),v=r.getLinesContent(),p=a.getLinesContent(),D=_.computeDiff(v,p,N),M=D.changes.length>0?!1:this._modelsAreIdentical(r,a);function F(I){return I.map(q=>[q.originalRange.startLineNumber,q.originalRange.endLineNumberExclusive,q.modifiedRange.startLineNumber,q.modifiedRange.endLineNumberExclusive,q.innerChanges?.map(O=>[O.originalRange.startLineNumber,O.originalRange.startColumn,O.originalRange.endLineNumber,O.originalRange.endColumn,O.modifiedRange.startLineNumber,O.modifiedRange.startColumn,O.modifiedRange.endLineNumber,O.modifiedRange.endColumn])])}return{identical:M,quitEarly:D.hitTimeout,changes:F(D.changes),moves:D.moves.map(I=>[I.lineRangeMapping.original.startLineNumber,I.lineRangeMapping.original.endLineNumberExclusive,I.lineRangeMapping.modified.startLineNumber,I.lineRangeMapping.modified.endLineNumberExclusive,F(I.changes)])}}static _modelsAreIdentical(r,a){const N=r.getLineCount(),d=a.getLineCount();if(N!==d)return!1;for(let _=1;_<=N;_++){const v=r.getLineContent(_),p=a.getLineContent(_);if(v!==p)return!1}return!0}async computeDirtyDiff(r,a,N){const d=this._getModel(r),_=this._getModel(a);if(!d||!_)return null;const v=d.getLinesContent(),p=_.getLinesContent();return new o.DiffComputer(v,p,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:N,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this._diffLimit=1e5}async computeMoreMinimalEdits(r,a,N){const d=this._getModel(r);if(!d)return a;const _=[];let v;a=a.slice(0).sort((p,D)=>{if(p.range&&D.range)return u.Range.compareRangesUsingStarts(p.range,D.range);const M=p.range?0:1,F=D.range?0:1;return M-F});for(let{range:p,text:D,eol:M}of a){if(typeof M=="number"&&(v=M),u.Range.isEmpty(p)&&!D)continue;const F=d.getValueInRange(p);if(D=D.replace(/\r\n|\n|\r/g,d.eol),F===D)continue;if(Math.max(D.length,F.length)>E._diffLimit){_.push({range:p,text:D});continue}const I=(0,P.stringDiff)(F,D,N),q=d.offsetAt(u.Range.lift(p).getStartPosition());for(const O of I){const H=d.positionAt(q+O.originalStart),S=d.positionAt(q+O.originalStart+O.originalLength),W={text:D.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:H.lineNumber,startColumn:H.column,endLineNumber:S.lineNumber,endColumn:S.column}};d.getValueInRange(W.range)!==W.text&&_.push(W)}}return typeof v=="number"&&_.push({eol:v,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),_}async computeHumanReadableDiff(r,a,N){const d=this._getModel(r);if(!d)return a;const _=[];let v;a=a.slice(0).sort((p,D)=>{if(p.range&&D.range)return u.Range.compareRangesUsingStarts(p.range,D.range);const M=p.range?0:1,F=D.range?0:1;return M-F});for(let{range:p,text:D,eol:M}of a){let S=function(Q,$){return new i.Position(Q.lineNumber+$.lineNumber-1,$.lineNumber===1?Q.column+$.column-1:$.column)},W=function(Q,$){const ne=[];for(let n=$.startLineNumber;n<=$.endLineNumber;n++){const oe=Q[n-1];n===$.startLineNumber&&n===$.endLineNumber?ne.push(oe.substring($.startColumn-1,$.endColumn-1)):n===$.startLineNumber?ne.push(oe.substring($.startColumn-1)):n===$.endLineNumber?ne.push(oe.substring(0,$.endColumn-1)):ne.push(oe)}return ne};if(typeof M=="number"&&(v=M),u.Range.isEmpty(p)&&!D)continue;const F=d.getValueInRange(p);if(D=D.replace(/\r\n|\n|\r/g,d.eol),F===D)continue;if(Math.max(D.length,F.length)>E._diffLimit){_.push({range:p,text:D});continue}const I=F.split(/\r\n|\n|\r/),q=D.split(/\r\n|\n|\r/),O=e.linesDiffComputers.getAdvanced().computeDiff(I,q,N),H=u.Range.lift(p).getStartPosition();for(const Q of O.changes)if(Q.innerChanges)for(const $ of Q.innerChanges)_.push({range:u.Range.fromPositions(S(H,$.originalRange.getStartPosition()),S(H,$.originalRange.getEndPosition())),text:W(q,$.modifiedRange).join(d.eol)});else throw new y.BugIndicatingError("The experimental diff algorithm always produces inner changes")}return typeof v=="number"&&_.push({eol:v,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),_}async computeLinks(r){const a=this._getModel(r);return a?(0,s.computeLinks)(a):null}async computeDefaultDocumentColors(r){const a=this._getModel(r);return a?(0,A.computeDefaultDocumentColors)(a):null}static{this._suggestionsLimit=1e4}async textualSuggest(r,a,N,d){const _=new R.StopWatch,v=new RegExp(N,d),p=new Set;e:for(const D of r){const M=this._getModel(D);if(M){for(const F of M.words(v))if(!(F===a||!isNaN(Number(F)))&&(p.add(F),p.size>E._suggestionsLimit))break e}}return{words:Array.from(p),duration:_.elapsed()}}async computeWordRanges(r,a,N,d){const _=this._getModel(r);if(!_)return Object.create(null);const v=new RegExp(N,d),p=Object.create(null);for(let D=a.startLineNumber;D<a.endLineNumber;D++){const M=_.getLineWords(D,v);for(const F of M){if(!isNaN(Number(F.word)))continue;let I=p[F.word];I||(I=[],p[F.word]=I),I.push({startLineNumber:D,startColumn:F.startColumn,endLineNumber:D,endColumn:F.endColumn})}}return p}async navigateValueSet(r,a,N,d,_){const v=this._getModel(r);if(!v)return null;const p=new RegExp(d,_);a.startColumn===a.endColumn&&(a={startLineNumber:a.startLineNumber,startColumn:a.startColumn,endLineNumber:a.endLineNumber,endColumn:a.endColumn+1});const D=v.getValueInRange(a),M=v.getWordAtPosition({lineNumber:a.startLineNumber,column:a.startColumn},p);if(!M)return null;const F=v.getValueInRange(M);return l.BasicInplaceReplace.INSTANCE.navigateValueSet(a,D,M,F,N)}loadForeignModule(r,a,N){const d=(p,D)=>this._host.fhr(p,D),v={host:(0,w.createProxyObject)(N,d),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(v,a),Promise.resolve((0,w.getAllMethodNames)(this._foreignModule))):new Promise((p,D)=>{z([r],M=>{this._foreignModule=M.create(v,a),p((0,w.getAllMethodNames)(this._foreignModule))},D)})}fmr(r,a){if(!this._foreignModule||typeof this._foreignModule[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this._foreignModule[r].apply(this._foreignModule,a))}catch(N){return Promise.reject(N)}}}t.EditorSimpleWorker=E;function g(m){return new E(m,null)}t.create=g,typeof importScripts=="function"&&(globalThis.monaco=(0,f.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/aef377c42cea6e9aea642829953104f07097abfa/core/vs/base/worker/workerMain.js.map
