/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/types","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/arrays","vs/base/common/strings","vs/platform/telemetry/common/telemetry","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/node/state","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/stream","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","crypto","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/lazy","vs/base/common/normalization","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/parts/ipc/node/ipc.net","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/code/electron-main/auth","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ie=function(j){for(var e=[],P=0,L=j.length;P<L;P++)e[P]=te[j[P]];return e};define(te[134],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function P(I,h){const c=Math.pow(10,h);return Math.round(I*c)/c}class L{constructor(h,c,m,f=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,m))|0,this.a=P(Math.max(Math.min(1,f),0),3)}static equals(h,c){return h.r===c.r&&h.g===c.g&&h.b===c.b&&h.a===c.a}}e.RGBA=L;class s{constructor(h,c,m,f){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=P(Math.max(Math.min(1,c),0),3),this.l=P(Math.max(Math.min(1,m),0),3),this.a=P(Math.max(Math.min(1,f),0),3)}static equals(h,c){return h.h===c.h&&h.s===c.s&&h.l===c.l&&h.a===c.a}static fromRGBA(h){const c=h.r/255,m=h.g/255,f=h.b/255,w=h.a,d=Math.max(c,m,f),b=Math.min(c,m,f);let y=0,o=0;const g=(b+d)/2,l=d-b;if(l>0){switch(o=Math.min(g<=.5?l/(2*g):l/(2-2*g),1),d){case c:y=(m-f)/l+(m<f?6:0);break;case m:y=(f-c)/l+2;break;case f:y=(c-m)/l+4;break}y*=60,y=Math.round(y)}return new s(y,o,g,w)}static _hue2rgb(h,c,m){return m<0&&(m+=1),m>1&&(m-=1),m<1/6?h+(c-h)*6*m:m<1/2?c:m<2/3?h+(c-h)*(2/3-m)*6:h}static toRGBA(h){const c=h.h/360,{s:m,l:f,a:w}=h;let d,b,y;if(m===0)d=b=y=f;else{const o=f<.5?f*(1+m):f+m-f*m,g=2*f-o;d=s._hue2rgb(g,o,c+1/3),b=s._hue2rgb(g,o,c),y=s._hue2rgb(g,o,c-1/3)}return new L(Math.round(d*255),Math.round(b*255),Math.round(y*255),w)}}e.HSLA=s;class _{constructor(h,c,m,f){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=P(Math.max(Math.min(1,c),0),3),this.v=P(Math.max(Math.min(1,m),0),3),this.a=P(Math.max(Math.min(1,f),0),3)}static equals(h,c){return h.h===c.h&&h.s===c.s&&h.v===c.v&&h.a===c.a}static fromRGBA(h){const c=h.r/255,m=h.g/255,f=h.b/255,w=Math.max(c,m,f),d=Math.min(c,m,f),b=w-d,y=w===0?0:b/w;let o;return b===0?o=0:w===c?o=((m-f)/b%6+6)%6:w===m?o=(f-c)/b+2:o=(c-m)/b+4,new _(Math.round(o*60),y,w,h.a)}static toRGBA(h){const{h:c,s:m,v:f,a:w}=h,d=f*m,b=d*(1-Math.abs(c/60%2-1)),y=f-d;let[o,g,l]=[0,0,0];return c<60?(o=d,g=b):c<120?(o=b,g=d):c<180?(g=d,l=b):c<240?(g=b,l=d):c<300?(o=b,l=d):c<=360&&(o=d,l=b),o=Math.round((o+y)*255),g=Math.round((g+y)*255),l=Math.round((l+y)*255),new L(o,g,l,w)}}e.HSVA=_;class M{static fromHex(h){return M.Format.CSS.parseHex(h)||M.red}static equals(h,c){return!h&&!c?!0:!h||!c?!1:h.equals(c)}get hsla(){return this._hsla?this._hsla:s.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:_.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof L)this.rgba=h;else if(h instanceof s)this._hsla=h,this.rgba=s.toRGBA(h);else if(h instanceof _)this._hsva=h,this.rgba=_.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&L.equals(this.rgba,h.rgba)&&s.equals(this.hsla,h.hsla)&&_.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=M._relativeLuminanceForComponent(this.rgba.r),c=M._relativeLuminanceForComponent(this.rgba.g),m=M._relativeLuminanceForComponent(this.rgba.b),f=.2126*h+.7152*c+.0722*m;return P(f,4)}static _relativeLuminanceForComponent(h){const c=h/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(h){const c=this.getRelativeLuminance(),m=h.getRelativeLuminance();return c>m?(c+.05)/(m+.05):(m+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const c=this.getRelativeLuminance(),m=h.getRelativeLuminance();return c>m}isDarkerThan(h){const c=this.getRelativeLuminance(),m=h.getRelativeLuminance();return c<m}lighten(h){return new M(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new M(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:c,g:m,b:f,a:w}=this.rgba;return new M(new L(c,m,f,w*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const c=h.rgba,m=this.rgba.a,f=c.a,w=m+f*(1-m);if(w<1e-6)return M.transparent;const d=this.rgba.r*m/w+c.r*f*(1-m)/w,b=this.rgba.g*m/w+c.g*f*(1-m)/w,y=this.rgba.b*m/w+c.b*f*(1-m)/w;return new M(new L(d,b,y,w))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:c,g:m,b:f,a:w}=this.rgba;return new M(new L(h.rgba.r-w*(h.rgba.r-c),h.rgba.g-w*(h.rgba.g-m),h.rgba.b-w*(h.rgba.b-f),1))}flatten(...h){const c=h.reduceRight((m,f)=>M._flatten(f,m));return M._flatten(this,c)}static _flatten(h,c){const m=1-h.rgba.a;return new M(new L(m*c.rgba.r+h.rgba.a*h.rgba.r,m*c.rgba.g+h.rgba.a*h.rgba.g,m*c.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this._toString||(this._toString=M.Format.CSS.format(this)),this._toString}static getLighterColor(h,c,m){if(h.isLighterThan(c))return h;m=m||.5;const f=h.getRelativeLuminance(),w=c.getRelativeLuminance();return m=m*(w-f)/w,h.lighten(m)}static getDarkerColor(h,c,m){if(h.isDarkerThan(c))return h;m=m||.5;const f=h.getRelativeLuminance(),w=c.getRelativeLuminance();return m=m*(f-w)/f,h.darken(m)}static{this.white=new M(new L(255,255,255,1))}static{this.black=new M(new L(0,0,0,1))}static{this.red=new M(new L(255,0,0,1))}static{this.blue=new M(new L(0,0,255,1))}static{this.green=new M(new L(0,255,0,1))}static{this.cyan=new M(new L(0,255,255,1))}static{this.lightgrey=new M(new L(211,211,211,1))}static{this.transparent=new M(new L(0,0,0,0))}}e.Color=M,function(I){let h;(function(c){let m;(function(f){function w(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:I.Format.CSS.formatRGBA(t)}f.formatRGB=w;function d(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}f.formatRGBA=d;function b(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:I.Format.CSS.formatHSLA(t)}f.formatHSL=b;function y(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}f.formatHSLA=y;function o(t){const u=t.toString(16);return u.length!==2?"0"+u:u}function g(t){return`#${o(t.rgba.r)}${o(t.rgba.g)}${o(t.rgba.b)}`}f.formatHex=g;function l(t,u=!1){return u&&t.rgba.a===1?I.Format.CSS.formatHex(t):`#${o(t.rgba.r)}${o(t.rgba.g)}${o(t.rgba.b)}${o(Math.round(t.rgba.a*255))}`}f.formatHexA=l;function v(t){return t.isOpaque()?I.Format.CSS.formatHex(t):I.Format.CSS.formatRGBA(t)}f.format=v;function E(t){const u=t.length;if(u===0||t.charCodeAt(0)!==35)return null;if(u===7){const r=16*S(t.charCodeAt(1))+S(t.charCodeAt(2)),n=16*S(t.charCodeAt(3))+S(t.charCodeAt(4)),i=16*S(t.charCodeAt(5))+S(t.charCodeAt(6));return new I(new L(r,n,i,1))}if(u===9){const r=16*S(t.charCodeAt(1))+S(t.charCodeAt(2)),n=16*S(t.charCodeAt(3))+S(t.charCodeAt(4)),i=16*S(t.charCodeAt(5))+S(t.charCodeAt(6)),a=16*S(t.charCodeAt(7))+S(t.charCodeAt(8));return new I(new L(r,n,i,a/255))}if(u===4){const r=S(t.charCodeAt(1)),n=S(t.charCodeAt(2)),i=S(t.charCodeAt(3));return new I(new L(16*r+r,16*n+n,16*i+i))}if(u===5){const r=S(t.charCodeAt(1)),n=S(t.charCodeAt(2)),i=S(t.charCodeAt(3)),a=S(t.charCodeAt(4));return new I(new L(16*r+r,16*n+n,16*i+i,(16*a+a)/255))}return null}f.parseHex=E;function S(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(m=c.CSS||(c.CSS={}))})(h=I.Format||(I.Format={}))}(M||(e.Color=M={}))}),define(te[55],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function P(M){return(I,h,c)=>{let m=null,f=null;if(typeof c.value=="function"?(m="value",f=c.value):typeof c.get=="function"&&(m="get",f=c.get),!f)throw new Error("not supported");c[m]=M(f,h)}}function L(M,I,h){let c=null,m=null;if(typeof h.value=="function"?(c="value",m=h.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",m=h.get),!m)throw new Error("not supported");const f=`$memoize$${I}`;h[c]=function(...w){return this.hasOwnProperty(f)||Object.defineProperty(this,f,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,w)}),this[f]}}e.memoize=L;function s(M,I,h){return P((c,m)=>{const f=`$debounce$${m}`,w=`$debounce$result$${m}`;return function(...d){this[w]||(this[w]=h?h():void 0),clearTimeout(this[f]),I&&(this[w]=I(this[w],...d),d=[this[w]]),this[f]=setTimeout(()=>{c.apply(this,d),this[w]=h?h():void 0},M)}})}e.debounce=s;function _(M,I,h){return P((c,m)=>{const f=`$throttle$timer$${m}`,w=`$throttle$result$${m}`,d=`$throttle$lastRun$${m}`,b=`$throttle$pending$${m}`;return function(...y){if(this[w]||(this[w]=h?h():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),I&&(this[w]=I(this[w],...y)),this[b])return;const o=this[d]+M;o<=Date.now()?(this[d]=Date.now(),c.apply(this,[this[w]]),this[w]=h?h():void 0):(this[b]=!0,this[f]=setTimeout(()=>{this[b]=!1,this[d]=Date.now(),c.apply(this,[this[w]]),this[w]=h?h():void 0},o-Date.now()))}})}e.throttle=_}),define(te[13],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class P{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(u){setTimeout(()=>{throw u.stack?E.isErrorNoTelemetry(u)?new E(u.message+`

`+u.stack):new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.listeners.push(u),()=>{this._removeListener(u)}}emit(u){this.listeners.forEach(r=>{r(u)})}_removeListener(u){this.listeners.splice(this.listeners.indexOf(u),1)}setUnexpectedErrorHandler(u){this.unexpectedErrorHandler=u}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(u){this.unexpectedErrorHandler(u),this.emit(u)}onUnexpectedExternalError(u){this.unexpectedErrorHandler(u)}}e.ErrorHandler=P,e.errorHandler=new P;function L(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function s(t){if(!t||typeof t!="object")return!1;const u=t;return u.code==="EPIPE"&&u.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=s;function _(t){c(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=_;function M(t){c(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=M;function I(t){if(t instanceof Error){const{name:u,message:r}=t,n=t.stacktrace||t.stack;return{$isError:!0,name:u,message:r,stack:n,noTelemetry:E.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=I;const h="Canceled";function c(t){return t instanceof m?!0:t instanceof Error&&t.name===h&&t.message===h}e.isCancellationError=c;class m extends Error{constructor(){super(h),this.name=this.message}}e.CancellationError=m;function f(){const t=new Error(h);return t.name=t.message,t}e.canceled=f;function w(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=w;function d(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=d;function b(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function y(t){const u=new Error(`${t} has been disposed`);return u.name="DISPOSED",u}e.disposed=y;function o(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=o;class g extends Error{constructor(u){super("NotImplemented"),u&&(this.message=u)}}e.NotImplementedError=g;class l extends Error{constructor(u){super("NotSupported"),u&&(this.message=u)}}e.NotSupportedError=l;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class E extends Error{constructor(u){super(u),this.name="CodeExpectedError"}static fromError(u){if(u instanceof E)return u;const r=new E;return r.message=u.message,r.stack=u.stack,r}static isErrorNoTelemetry(u){return u.name==="CodeExpectedError"}}e.ErrorNoTelemetry=E;class S extends Error{constructor(u){super(u||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype)}}e.BugIndicatingError=S}),define(te[24],ie([0,1,13]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L(z,$=0){return z[z.length-(1+$)]}e.tail=L;function s(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=s;function _(z,$,K=(re,le)=>re===le){if(z===$)return!0;if(!z||!$||z.length!==$.length)return!1;for(let re=0,le=z.length;re<le;re++)if(!K(z[re],$[re]))return!1;return!0}e.equals=_;function M(z,$){const K=z.length-1;$<K&&(z[$]=z[K]),z.pop()}e.removeFastWithoutKeepingOrder=M;function I(z,$,K){return h(z.length,re=>K(z[re],$))}e.binarySearch=I;function h(z,$){let K=0,re=z-1;for(;K<=re;){const le=(K+re)/2|0,ge=$(le);if(ge<0)K=le+1;else if(ge>0)re=le-1;else return le}return-(K+1)}e.binarySearch2=h;function c(z,$){let K=0,re=z.length;if(re===0)return 0;for(;K<re;){const le=Math.floor((K+re)/2);$(z[le])?re=le:K=le+1}return K}e.findFirstInSorted=c;function m(z,$,K){if(z=z|0,z>=$.length)throw new TypeError("invalid index");const re=$[Math.floor($.length*Math.random())],le=[],ge=[],Ce=[];for(const Me of $){const Re=K(Me,re);Re<0?le.push(Me):Re>0?ge.push(Me):Ce.push(Me)}return z<le.length?m(z,le,K):z<le.length+Ce.length?Ce[0]:m(z-(le.length+Ce.length),ge,K)}e.quickSelect=m;function f(z,$){const K=[];let re;for(const le of z.slice(0).sort($))!re||$(re[0],le)!==0?(re=[le],K.push(re)):re.push(le);return K}e.groupBy=f;function w(z,$,K){const re=[];function le(Me,Re,Oe){if(Re===0&&Oe.length===0)return;const He=re[re.length-1];He&&He.start+He.deleteCount===Me?(He.deleteCount+=Re,He.toInsert.push(...Oe)):re.push({start:Me,deleteCount:Re,toInsert:Oe})}let ge=0,Ce=0;for(;;){if(ge===z.length){le(ge,0,$.slice(Ce));break}if(Ce===$.length){le(ge,z.length-ge,[]);break}const Me=z[ge],Re=$[Ce],Oe=K(Me,Re);Oe===0?(ge+=1,Ce+=1):Oe<0?(le(ge,1,[]),ge+=1):Oe>0&&(le(ge,0,[Re]),Ce+=1)}return re}e.sortedDiff=w;function d(z,$,K){const re=w(z,$,K),le=[],ge=[];for(const Ce of re)le.push(...z.slice(Ce.start,Ce.start+Ce.deleteCount)),ge.push(...Ce.toInsert);return{removed:le,added:ge}}e.delta=d;function b(z,$,K){if(K===0)return[];const re=z.slice(0,K).sort($);return o(z,$,re,K,z.length),re}e.top=b;function y(z,$,K,re,le){return K===0?Promise.resolve([]):new Promise((ge,Ce)=>{(async()=>{const Me=z.length,Re=z.slice(0,K).sort($);for(let Oe=K,He=Math.min(K+re,Me);Oe<Me;Oe=He,He=Math.min(He+re,Me)){if(Oe>K&&await new Promise(pe=>setTimeout(pe)),le&&le.isCancellationRequested)throw new P.CancellationError;o(z,$,Re,Oe,He)}return Re})().then(ge,Ce)})}e.topAsync=y;function o(z,$,K,re,le){for(const ge=K.length;re<le;re++){const Ce=z[re];if($(Ce,K[ge-1])<0){K.pop();const Me=c(K,Re=>$(Ce,Re)<0);K.splice(Me,0,Ce)}}}function g(z){return z.filter($=>!!$)}e.coalesce=g;function l(z){let $=0;for(let K=0;K<z.length;K++)z[K]&&(z[$]=z[K],$+=1);z.length=$}e.coalesceInPlace=l;function v(z,$,K){z.splice(K,0,z.splice($,1)[0])}e.move=v;function E(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=E;function S(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=S;function t(z,$=K=>K){const K=new Set;return z.filter(re=>{const le=$(re);return K.has(le)?!1:(K.add(le),!0)})}e.distinct=t;function u(z){const $=new Set;return K=>{const re=z(K);return $.has(re)?!1:($.add(re),!0)}}e.uniqueFilter=u;function r(z,$){const K=n(z,$);if(K!==-1)return z[K]}e.findLast=r;function n(z,$){for(let K=z.length-1;K>=0;K--){const re=z[K];if($(re))return K}return-1}e.lastIndex=n;function i(z,$){return z.length>0?z[0]:$}e.firstOrDefault=i;function a(z,$){return z.length>0?z[z.length-1]:$}e.lastOrDefault=a;function p(z,$,K=(re,le)=>re===le){let re=0;for(let le=0,ge=Math.min(z.length,$.length);le<ge&&K(z[le],$[le]);le++)re++;return re}e.commonPrefixLength=p;function C(z){return[].concat(...z)}e.flatten=C;function k(z,$){let K=typeof $=="number"?z:0;typeof $=="number"?K=z:(K=0,$=z);const re=[];if(K<=$)for(let le=K;le<$;le++)re.push(le);else for(let le=K;le>$;le--)re.push(le);return re}e.range=k;function D(z,$,K){return z.reduce((re,le)=>(re[$(le)]=K?K(le):le,re),Object.create(null))}e.index=D;function A(z,$){return z.push($),()=>O(z,$)}e.insert=A;function O(z,$){const K=z.indexOf($);if(K>-1)return z.splice(K,1),$}e.remove=O;function U(z,$,K){const re=z.slice(0,$),le=z.slice($);return re.concat(K,le)}e.arrayInsert=U;function q(z,$){let K;if(typeof $=="number"){let re=$;K=()=>{const le=Math.sin(re++)*179426549;return le-Math.floor(le)}}else K=Math.random;for(let re=z.length-1;re>0;re-=1){const le=Math.floor(K()*(re+1)),ge=z[re];z[re]=z[le],z[le]=ge}}e.shuffle=q;function se(z,$){const K=z.indexOf($);K>-1&&(z.splice(K,1),z.unshift($))}e.pushToStart=se;function ne(z,$){const K=z.indexOf($);K>-1&&(z.splice(K,1),z.push($))}e.pushToEnd=ne;function ee(z,$){for(const K of $)z.push(K)}e.pushMany=ee;function ae(z,$){return Array.isArray(z)?z.map($):$(z)}e.mapArrayOrNot=ae;function ue(z){return Array.isArray(z)?z:[z]}e.asArray=ue;function G(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=G;function Y(z,$){for(const K of z){const re=$(K);if(re!==void 0)return re}}e.mapFind=Y;function F(z,$,K){const re=B(z,$),le=z.length,ge=K.length;z.length=le+ge;for(let Ce=le-1;Ce>=re;Ce--)z[Ce+ge]=z[Ce];for(let Ce=0;Ce<ge;Ce++)z[Ce+re]=K[Ce]}e.insertInto=F;function N(z,$,K,re){const le=B(z,$),ge=z.splice(le,K);return F(z,le,re),ge}e.splice=N;function B(z,$){return $<0?Math.max($+z.length,0):Math.min($,z.length)}var V;(function(z){function $(le){return le<0}z.isLessThan=$;function K(le){return le>0}z.isGreaterThan=K;function re(le){return le===0}z.isNeitherLessOrGreaterThan=re,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function X(z,$){return(K,re)=>$(z(K),z(re))}e.compareBy=X;function ce(...z){return($,K)=>{for(const re of z){const le=re($,K);if(!V.isNeitherLessOrGreaterThan(le))return le}return V.neitherLessOrGreaterThan}}e.tieBreakComparators=ce;const oe=(z,$)=>z-$;e.numberComparator=oe;function T(z,$){if(z.length===0)return;let K=z[0];for(let re=1;re<z.length;re++){const le=z[re];$(le,K)>0&&(K=le)}return K}e.findMaxBy=T;function R(z,$){if(z.length===0)return;let K=z[0];for(let re=1;re<z.length;re++){const le=z[re];$(le,K)>=0&&(K=le)}return K}e.findLastMaxBy=R;function W(z,$){return T(z,(K,re)=>-$(K,re))}e.findMinBy=W;class H{constructor($){this.items=$,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile($){let K=this.firstIdx;for(;K<this.items.length&&$(this.items[K]);)K++;const re=K===this.firstIdx?null:this.items.slice(this.firstIdx,K);return this.firstIdx=K,re}takeFromEndWhile($){let K=this.lastIdx;for(;K>=0&&$(this.items[K]);)K--;const re=K===this.lastIdx?null:this.items.slice(K+1,this.lastIdx+1);return this.lastIdx=K,re}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const $=this.items[this.firstIdx];return this.firstIdx++,$}removeLast(){const $=this.items[this.lastIdx];return this.lastIdx--,$}takeCount($){const K=this.items.slice(this.firstIdx,this.firstIdx+$);return this.firstIdx+=$,K}}e.ArrayQueue=H;class x{static{this.empty=new x($=>{})}constructor($){this.iterate=$}forEach($){this.iterate(K=>($(K),!0))}toArray(){const $=[];return this.iterate(K=>($.push(K),!0)),$}filter($){return new x(K=>this.iterate(re=>$(re)?K(re):!0))}map($){return new x(K=>this.iterate(re=>K($(re))))}some($){let K=!1;return this.iterate(re=>(K=$(re),!K)),K}findFirst($){let K;return this.iterate(re=>$(re)?(K=re,!1):!0),K}findLast($){let K;return this.iterate(re=>($(re)&&(K=re),!0)),K}findLastMaxBy($){let K,re=!0;return this.iterate(le=>((re||V.isGreaterThan($(le,K)))&&(re=!1,K=le),!0)),K}}e.CallbackIterable=x}),define(te[135],ie([0,1,13]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(h,c){if(!h)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=L;function s(h,c="Unreachable"){throw new Error(c)}e.assertNever=s;function _(h){if(!h)throw new P.BugIndicatingError("Assertion Failed")}e.assert=_;function M(h){if(!h()){debugger;h(),(0,P.onUnexpectedError)(new P.BugIndicatingError("Assertion Failed"))}}e.assertFn=M;function I(h,c){let m=0;for(;m<h.length-1;){const f=h[m],w=h[m+1];if(!c(f,w))return!1;m++}return!0}e.checkAdjacentItems=I}),define(te[49],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function P(L){const s=this;let _=!1,M;return function(){return _||(_=!0,M=L.apply(s,arguments)),M}}e.once=P}),define(te[68],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(L){function s(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}L.is=s;const _=Object.freeze([]);function M(){return _}L.empty=M;function*I(E){yield E}L.single=I;function h(E){return s(E)?E:I(E)}L.wrap=h;function c(E){return E||_}L.from=c;function m(E){return!E||E[Symbol.iterator]().next().done===!0}L.isEmpty=m;function f(E){return E[Symbol.iterator]().next().value}L.first=f;function w(E,S){for(const t of E)if(S(t))return!0;return!1}L.some=w;function d(E,S){for(const t of E)if(S(t))return t}L.find=d;function*b(E,S){for(const t of E)S(t)&&(yield t)}L.filter=b;function*y(E,S){let t=0;for(const u of E)yield S(u,t++)}L.map=y;function*o(...E){for(const S of E)for(const t of S)yield t}L.concat=o;function g(E,S,t){let u=t;for(const r of E)u=S(u,r);return u}L.reduce=g;function*l(E,S,t=E.length){for(S<0&&(S+=E.length),t<0?t+=E.length:t>E.length&&(t=E.length);S<t;S++)yield E[S]}L.slice=l;function v(E,S=Number.POSITIVE_INFINITY){const t=[];if(S===0)return[t,E];const u=E[Symbol.iterator]();for(let r=0;r<S;r++){const n=u.next();if(n.done)return[t,L.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return u}}]}L.consume=v})(P||(e.Iterable=P={}))}),define(te[45],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var _;(function(t){t.DEFAULT={allowTrailingComma:!0}})(_||(e.ParseOptions=_={}));function M(t,u=!1){let r=0;const n=t.length;let i="",a=0,p=16,C=0;function k(ne){let ee=0,ae=0;for(;ee<ne;){const ue=t.charCodeAt(r);if(ue>=48&&ue<=57)ae=ae*16+ue-48;else if(ue>=65&&ue<=70)ae=ae*16+ue-65+10;else if(ue>=97&&ue<=102)ae=ae*16+ue-97+10;else break;r++,ee++}return ee<ne&&(ae=-1),ae}function D(ne){r=ne,i="",a=0,p=16,C=0}function A(){const ne=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&c(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&c(t.charCodeAt(r)))for(r++;r<t.length&&c(t.charCodeAt(r));)r++;else return C=3,t.substring(ne,r);let ee=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&c(t.charCodeAt(r))){for(r++;r<t.length&&c(t.charCodeAt(r));)r++;ee=r}else C=3;return t.substring(ne,ee)}function O(){let ne="",ee=r;for(;;){if(r>=n){ne+=t.substring(ee,r),C=2;break}const ae=t.charCodeAt(r);if(ae===34){ne+=t.substring(ee,r),r++;break}if(ae===92){if(ne+=t.substring(ee,r),r++,r>=n){C=2;break}switch(t.charCodeAt(r++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const G=k(4);G>=0?ne+=String.fromCharCode(G):C=4;break}default:C=5}ee=r;continue}if(ae>=0&&ae<=31)if(h(ae)){ne+=t.substring(ee,r),C=2;break}else C=6;r++}return ne}function U(){if(i="",C=0,a=r,r>=n)return a=n,p=17;let ne=t.charCodeAt(r);if(I(ne)){do r++,i+=String.fromCharCode(ne),ne=t.charCodeAt(r);while(I(ne));return p=15}if(h(ne))return r++,i+=String.fromCharCode(ne),ne===13&&t.charCodeAt(r)===10&&(r++,i+=`
`),p=14;switch(ne){case 123:return r++,p=1;case 125:return r++,p=2;case 91:return r++,p=3;case 93:return r++,p=4;case 58:return r++,p=6;case 44:return r++,p=5;case 34:return r++,i=O(),p=10;case 47:{const ee=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<n&&!h(t.charCodeAt(r));)r++;return i=t.substring(ee,r),p=12}if(t.charCodeAt(r+1)===42){r+=2;const ae=n-1;let ue=!1;for(;r<ae;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ue=!0;break}r++}return ue||(r++,C=1),i=t.substring(ee,r),p=13}return i+=String.fromCharCode(ne),r++,p=16}case 45:if(i+=String.fromCharCode(ne),r++,r===n||!c(t.charCodeAt(r)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=A(),p=11;default:for(;r<n&&q(ne);)r++,ne=t.charCodeAt(r);if(a!==r){switch(i=t.substring(a,r),i){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return i+=String.fromCharCode(ne),r++,p=16}}function q(ne){if(I(ne)||h(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let ne;do ne=U();while(ne>=12&&ne<=15);return ne}return{setPosition:D,getPosition:()=>r,scan:u?se:U,getToken:()=>p,getTokenValue:()=>i,getTokenOffset:()=>a,getTokenLength:()=>r-a,getTokenError:()=>C}}e.createScanner=M;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var m;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(m||(m={}));function f(t,u){const r=[],n=new Object;let i;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function C(k,D,A,O){a.value=k,a.offset=D,a.length=A,a.type=O,a.colonOffset=void 0,i=a}try{v(t,{onObjectBegin:(k,D)=>{if(u<=k)throw n;i=void 0,p=u>k,r.push("")},onObjectProperty:(k,D,A)=>{if(u<D||(C(k,D,A,"property"),r[r.length-1]=k,u<=D+A))throw n},onObjectEnd:(k,D)=>{if(u<=k)throw n;i=void 0,r.pop()},onArrayBegin:(k,D)=>{if(u<=k)throw n;i=void 0,r.push(0)},onArrayEnd:(k,D)=>{if(u<=k)throw n;i=void 0,r.pop()},onLiteralValue:(k,D,A)=>{if(u<D||(C(k,D,A,S(k)),u<=D+A))throw n},onSeparator:(k,D,A)=>{if(u<=D)throw n;if(k===":"&&i&&i.type==="property")i.colonOffset=D,p=!1,i=void 0;else if(k===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(p=!0,r[r.length-1]=""),i=void 0}}})}catch(k){if(k!==n)throw k}return{path:r,previousNode:i,isAtPropertyKey:p,matches:k=>{let D=0;for(let A=0;D<k.length&&A<r.length;A++)if(k[D]===r[A]||k[D]==="*")D++;else if(k[D]!=="**")return!1;return D===k.length}}}e.getLocation=f;function w(t,u=[],r=_.DEFAULT){let n=null,i=[];const a=[];function p(k){Array.isArray(i)?i.push(k):n!==null&&(i[n]=k)}return v(t,{onObjectBegin:()=>{const k={};p(k),a.push(i),i=k,n=null},onObjectProperty:k=>{n=k},onObjectEnd:()=>{i=a.pop()},onArrayBegin:()=>{const k=[];p(k),a.push(i),i=k,n=null},onArrayEnd:()=>{i=a.pop()},onLiteralValue:p,onError:(k,D,A)=>{u.push({error:k,offset:D,length:A})}},r),i[0]}e.parse=w;function d(t,u=[],r=_.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(k){n.type==="property"&&(n.length=k-n.offset,n=n.parent)}function a(k){return n.children.push(k),k}v(t,{onObjectBegin:k=>{n=a({type:"object",offset:k,length:-1,parent:n,children:[]})},onObjectProperty:(k,D,A)=>{n=a({type:"property",offset:D,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:k,offset:D,length:A,parent:n})},onObjectEnd:(k,D)=>{n.length=k+D-n.offset,n=n.parent,i(k+D)},onArrayBegin:(k,D)=>{n=a({type:"array",offset:k,length:-1,parent:n,children:[]})},onArrayEnd:(k,D)=>{n.length=k+D-n.offset,n=n.parent,i(k+D)},onLiteralValue:(k,D,A)=>{a({type:S(k),offset:D,length:A,parent:n,value:k}),i(D+A)},onSeparator:(k,D,A)=>{n.type==="property"&&(k===":"?n.colonOffset=D:k===","&&i(D))},onError:(k,D,A)=>{u.push({error:k,offset:D,length:A})}},r);const C=n.children[0];return C&&delete C.parent,C}e.parseTree=d;function b(t,u){if(!t)return;let r=t;for(const n of u)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let i=!1;for(const a of r.children)if(Array.isArray(a.children)&&a.children[0].value===n){r=a.children[1],i=!0;break}if(!i)return}else{const i=n;if(r.type!=="array"||i<0||!Array.isArray(r.children)||i>=r.children.length)return;r=r.children[i]}return r}e.findNodeAtLocation=b;function y(t){if(!t.parent||!t.parent.children)return[];const u=y(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;u.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&u.push(r)}return u}e.getNodePath=y;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const u=Object.create(null);for(const r of t.children){const n=r.children[1];n&&(u[r.children[0].value]=o(n))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=o;function g(t,u,r=!1){return u>=t.offset&&u<t.offset+t.length||r&&u===t.offset+t.length}e.contains=g;function l(t,u,r=!1){if(g(t,u,r)){const n=t.children;if(Array.isArray(n))for(let i=0;i<n.length&&n[i].offset<=u;i++){const a=l(n[i],u,r);if(a)return a}return t}}e.findNodeAtOffset=l;function v(t,u,r=_.DEFAULT){const n=M(t,!1);function i(X){return X?()=>X(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(X){return X?ce=>X(ce,n.getTokenOffset(),n.getTokenLength()):()=>!0}const p=i(u.onObjectBegin),C=a(u.onObjectProperty),k=i(u.onObjectEnd),D=i(u.onArrayBegin),A=i(u.onArrayEnd),O=a(u.onLiteralValue),U=a(u.onSeparator),q=i(u.onComment),se=a(u.onError),ne=r&&r.disallowComments,ee=r&&r.allowTrailingComma;function ae(){for(;;){const X=n.scan();switch(n.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:ne||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(X){case 12:case 13:ne?ue(10):q();break;case 16:ue(1);break;case 15:case 14:break;default:return X}}}function ue(X,ce=[],oe=[]){if(se(X),ce.length+oe.length>0){let T=n.getToken();for(;T!==17;){if(ce.indexOf(T)!==-1){ae();break}else if(oe.indexOf(T)!==-1)break;T=ae()}}}function G(X){const ce=n.getTokenValue();return X?O(ce):C(ce),ae(),!0}function Y(){switch(n.getToken()){case 11:{let X=0;try{X=JSON.parse(n.getTokenValue()),typeof X!="number"&&(ue(2),X=0)}catch{ue(2)}O(X);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return ae(),!0}function F(){return n.getToken()!==10?(ue(3,[],[2,5]),!1):(G(!1),n.getToken()===6?(U(":"),ae(),V()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function N(){p(),ae();let X=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(X||ue(4,[],[]),U(","),ae(),n.getToken()===2&&ee)break}else X&&ue(6,[],[]);F()||ue(4,[],[2,5]),X=!0}return k(),n.getToken()!==2?ue(7,[2],[]):ae(),!0}function B(){D(),ae();let X=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(X||ue(4,[],[]),U(","),ae(),n.getToken()===4&&ee)break}else X&&ue(6,[],[]);V()||ue(4,[],[4,5]),X=!0}return A(),n.getToken()!==4?ue(8,[4],[]):ae(),!0}function V(){switch(n.getToken()){case 3:return B();case 1:return N();case 10:return G(!0);default:return Y()}}return ae(),n.getToken()===17?r.allowEmptyContent?!0:(ue(4,[],[]),!1):V()?(n.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.visit=v;function E(t,u){const r=M(t),n=[];let i,a=0,p;do switch(p=r.getPosition(),i=r.scan(),i){case 12:case 13:case 17:a!==p&&n.push(t.substring(a,p)),u!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,u)),a=r.getPosition();break}while(i!==17);return n.join("")}e.stripComments=E;function S(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=S}),define(te[136],ie([0,1,45]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function L(c,m,f){let w,d,b,y,o;if(m){for(y=m.offset,o=y+m.length,b=y;b>0&&!h(c,b-1);)b--;let p=o;for(;p<c.length&&!h(c,p);)p++;d=c.substring(b,p),w=M(d,f)}else d=c,w=0,b=0,y=0,o=c.length;const g=I(f,c);let l=!1,v=0,E;f.insertSpaces?E=_(" ",f.tabSize||4):E="	";const S=(0,P.createScanner)(d,!1);let t=!1;function u(){return g+_(E,w+v)}function r(){let p=S.scan();for(l=!1;p===15||p===14;)l=l||p===14,p=S.scan();return t=p===16||S.getTokenError()!==0,p}const n=[];function i(p,C,k){!t&&C<o&&k>y&&c.substring(C,k)!==p&&n.push({offset:C,length:k-C,content:p})}let a=r();if(a!==17){const p=S.getTokenOffset()+b,C=_(E,w);i(C,b,p)}for(;a!==17;){let p=S.getTokenOffset()+S.getTokenLength()+b,C=r(),k="";for(;!l&&(C===12||C===13);){const A=S.getTokenOffset()+b;i(" ",p,A),p=S.getTokenOffset()+S.getTokenLength()+b,k=C===12?u():"",C=r()}if(C===2)a!==1&&(v--,k=u());else if(C===4)a!==3&&(v--,k=u());else{switch(a){case 3:case 1:v++,k=u();break;case 5:case 12:k=u();break;case 13:l?k=u():k=" ";break;case 6:k=" ";break;case 10:if(C===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:C===12||C===13?k=" ":C!==5&&C!==17&&(t=!0);break;case 16:t=!0;break}l&&(C===12||C===13)&&(k=u())}const D=S.getTokenOffset()+b;i(k,p,D),a=C}return n}e.format=L;function s(c,m){const f=JSON.stringify(c,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?f.replace(/\r\n|\r|\n/g,m.eol):f}e.toFormattedString=s;function _(c,m){let f="";for(let w=0;w<m;w++)f+=c;return f}function M(c,m){let f=0,w=0;const d=m.tabSize||4;for(;f<c.length;){const b=c.charAt(f);if(b===" ")w++;else if(b==="	")w+=d;else break;f++}return Math.floor(w/d)}function I(c,m){for(let f=0;f<m.length;f++){const w=m.charAt(f);if(w==="\r")return f+1<m.length&&m.charAt(f+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return c&&c.eol||`
`}e.getEOL=I;function h(c,m){return`\r
`.indexOf(c.charAt(m))!==-1}e.isEOL=h}),define(te[137],ie([0,1,45,136]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function s(c,m,f){return _(c,m,void 0,f)}e.removeProperty=s;function _(c,m,f,w,d){const b=m.slice(),y=[],o=(0,P.parseTree)(c,y);let g,l;for(;b.length>0&&(l=b.pop(),g=(0,P.findNodeAtLocation)(o,b),g===void 0&&f!==void 0);)typeof l=="string"?f={[l]:f}:f=[f];if(g)if(g.type==="object"&&typeof l=="string"&&Array.isArray(g.children)){const v=(0,P.findNodeAtLocation)(g,[l]);if(v!==void 0)if(f===void 0){if(!v.parent)throw new Error("Malformed AST");const E=g.children.indexOf(v.parent);let S,t=v.parent.offset+v.parent.length;if(E>0){const u=g.children[E-1];S=u.offset+u.length}else S=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return M(c,{offset:S,length:t-S,content:""},w)}else return M(c,{offset:v.offset,length:v.length,content:JSON.stringify(f)},w);else{if(f===void 0)return[];const E=`${JSON.stringify(l)}: ${JSON.stringify(f)}`,S=d?d(g.children.map(u=>u.children[0].value)):g.children.length;let t;if(S>0){const u=g.children[S-1];t={offset:u.offset+u.length,length:0,content:","+E}}else g.children.length===0?t={offset:g.offset+1,length:0,content:E}:t={offset:g.offset+1,length:0,content:E+","};return M(c,t,w)}}else if(g.type==="array"&&typeof l=="number"&&Array.isArray(g.children))if(f!==void 0){const v=`${JSON.stringify(f)}`;let E;if(g.children.length===0||l===0)E={offset:g.offset+1,length:0,content:g.children.length===0?v:v+","};else{const S=l===-1||l>g.children.length?g.children.length:l,t=g.children[S-1];E={offset:t.offset+t.length,length:0,content:","+v}}return M(c,E,w)}else{const v=l,E=g.children[v];let S;if(g.children.length===1)S={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===v){const t=g.children[v-1],u=t.offset+t.length,r=g.offset+g.length;S={offset:u,length:r-2-u,content:""}}else S={offset:E.offset,length:g.children[v+1].offset-E.offset,content:""};return M(c,S,w)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${g.type}`);else{if(f===void 0)throw new Error("Can not delete in empty document");return M(c,{offset:o?o.offset:0,length:o?o.length:0,content:JSON.stringify(f)},w)}}e.setProperty=_;function M(c,m,f){let w=I(c,m),d=m.offset,b=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;d>0&&!(0,L.isEOL)(w,d-1);)d--;for(;b<w.length&&!(0,L.isEOL)(w,b);)b++}const y=(0,L.format)(w,{offset:d,length:b-d},f);for(let g=y.length-1;g>=0;g--){const l=y[g];w=I(w,l),d=Math.min(d,l.offset),b=Math.max(b,l.offset+l.length),b+=l.content.length-l.length}const o=c.length-(w.length-b)-d;return[{offset:d,length:o,content:w.substring(d,b)}]}e.withFormatting=M;function I(c,m){return c.substring(0,m.offset)+m.content+c.substring(m.offset+m.length)}e.applyEdit=I;function h(c,m){const f=m.slice(0).sort((d,b)=>{const y=d.offset-b.offset;return y===0?d.length-b.length:y});let w=c.length;for(let d=f.length-1;d>=0;d--){const b=f[d];if(b.offset+b.length<=w)c=I(c,b);else throw new Error("Overlapping edit");w=b.offset}return c}e.applyEdits=h}),define(te[85],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class P{constructor(s){this.executor=s,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(s){this._error=s}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=P}),define(te[2],ie([0,1,49,68]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const s=!1;let _=null;function M(a){_=a}if(e.setDisposableTracker=M,s){const a="__is_disposable_tracked__";M(new class{trackDisposable(p){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[a]||console.log(C)},3e3)}setParent(p,C){if(p&&p!==l.None)try{p[a]=!0}catch{}}markAsDisposed(p){if(p&&p!==l.None)try{p[a]=!0}catch{}}markAsSingleton(p){}})}function I(a){return _?.trackDisposable(a),a}function h(a){_?.markAsDisposed(a)}function c(a,p){_?.setParent(a,p)}function m(a,p){if(_)for(const C of a)_.setParent(C,p)}function f(a){return _?.markAsSingleton(a),a}e.markAsSingleton=f;function w(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=w;function d(a){if(L.Iterable.is(a)){const p=[];for(const C of a)if(C)try{C.dispose()}catch(k){p.push(k)}if(p.length===1)throw p[0];if(p.length>1)throw new AggregateError(p,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=d;function b(a){for(const p of a)w(p)&&p.dispose();return[]}e.disposeIfDisposable=b;function y(...a){const p=o(()=>d(a));return m(a,p),p}e.combinedDisposable=y;function o(a){const p=I({dispose:(0,P.once)(()=>{h(p),a()})});return p}e.toDisposable=o;class g{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{d(this._toDispose)}finally{this._toDispose.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return c(p,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(p),p}}e.DisposableStore=g;class l{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new g,I(this),c(this._store,this)}dispose(){h(this),this._store.dispose()}_register(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(p)}}e.Disposable=l;class v{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(p){this._isDisposed||p===this._value||(this._value?.dispose(),p&&c(p,this),this._value=p)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const p=this._value;return this._value=void 0,p&&c(p,null),p}}e.MutableDisposable=v;class E{constructor(p){this._disposable=p,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=E;class S{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(p){let C=p;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,h(this))},this}}e.SafeDisposable=S;class t{constructor(){this.references=new Map}acquire(p,...C){let k=this.references.get(p);k||(k={counter:0,object:this.createReferencedObject(p,...C)},this.references.set(p,k));const{object:D}=k,A=(0,P.once)(()=>{--k.counter===0&&(this.destroyReferencedObject(p,k.object),this.references.delete(p))});return k.counter++,{object:D,dispose:A}}}e.ReferenceCollection=t;class u{constructor(p){this.referenceCollection=p}async acquire(p,...C){const k=this.referenceCollection.acquire(p,...C);try{return{object:await k.object,dispose:()=>k.dispose()}}catch(D){throw k.dispose(),D}}}e.AsyncReferenceCollection=u;class r{constructor(p){this.object=p}dispose(){}}e.ImmortalReference=r;function n(a){const p=new g;try{a(p)}finally{p.dispose()}}e.disposeOnReturn=n;class i{constructor(){this._store=new Map,this._isDisposed=!1,I(this)}dispose(){h(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{d(this._store.values())}finally{this._store.clear()}}has(p){return this._store.has(p)}get(p){return this._store.get(p)}set(p,C,k=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),k||this._store.get(p)?.dispose(),this._store.set(p,C)}deleteAndDispose(p){this._store.get(p)?.dispose(),this._store.delete(p)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=i}),define(te[101],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class P{static{this.Undefined=new P(void 0)}constructor(_){this.element=_,this.next=P.Undefined,this.prev=P.Undefined}}class L{constructor(){this._first=P.Undefined,this._last=P.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===P.Undefined}clear(){let _=this._first;for(;_!==P.Undefined;){const M=_.next;_.prev=P.Undefined,_.next=P.Undefined,_=M}this._first=P.Undefined,this._last=P.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,M){const I=new P(_);if(this._first===P.Undefined)this._first=I,this._last=I;else if(M){const c=this._last;this._last=I,I.prev=c,c.next=I}else{const c=this._first;this._first=I,I.next=c,c.prev=I}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(I))}}shift(){if(this._first!==P.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==P.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==P.Undefined&&_.next!==P.Undefined){const M=_.prev;M.next=_.next,_.next.prev=M}else _.prev===P.Undefined&&_.next===P.Undefined?(this._first=P.Undefined,this._last=P.Undefined):_.next===P.Undefined?(this._last=this._last.prev,this._last.next=P.Undefined):_.prev===P.Undefined&&(this._first=this._first.next,this._first.prev=P.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==P.Undefined;)yield _.element,_=_.next}}e.LinkedList=L}),define(te[35],ie([0,1]),function(j,e){"use strict";var P,L,s;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function _(y,o,g){let l=y.get(o);return l===void 0&&(l=g,y.set(o,l)),l}e.getOrSet=_;function M(y){const o=[];return y.forEach((g,l)=>{o.push(`${l} => ${g}`)}),`Map(${y.size}) {${o.join(", ")}}`}e.mapToString=M;function I(y){const o=[];return y.forEach(g=>{o.push(g)}),`Set(${y.size}) {${o.join(", ")}}`}e.setToString=I;class h{constructor(o,g){this.uri=o,this.value=g}}class c{static{this.defaultToKey=o=>o.toString()}constructor(o,g){this[P]="ResourceMap",o instanceof c?(this.map=new Map(o.map),this.toKey=g??c.defaultToKey):(this.map=new Map,this.toKey=o??c.defaultToKey)}set(o,g){return this.map.set(this.toKey(o),new h(o,g)),this}get(o){return this.map.get(this.toKey(o))?.value}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,g){typeof g<"u"&&(o=o.bind(g));for(const[l,v]of this.map)o(v.value,v.uri,this)}*values(){for(const o of this.map.values())yield o.value}*keys(){for(const o of this.map.values())yield o.uri}*entries(){for(const o of this.map.values())yield[o.uri,o.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.map)yield[o.uri,o.value]}}e.ResourceMap=c;class m{constructor(o,g){this[L]="ResourceSet",!o||typeof o=="function"?this._map=new c(o):(this._map=new c(g),o.forEach(this.add,this))}get size(){return this._map.size}add(o){return this._map.set(o,o),this}clear(){this._map.clear()}delete(o){return this._map.delete(o)}forEach(o,g){this._map.forEach((l,v)=>o.call(g,v,v,this))}has(o){return this._map.has(o)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=m;var f;(function(y){y[y.None=0]="None",y[y.AsOld=1]="AsOld",y[y.AsNew=2]="AsNew"})(f||(e.Touch=f={}));class w{constructor(){this[s]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(o){return this._map.has(o)}get(o,g=0){const l=this._map.get(o);if(l)return g!==0&&this.touch(l,g),l.value}set(o,g,l=0){let v=this._map.get(o);if(v)v.value=g,l!==0&&this.touch(v,l);else{switch(v={key:o,value:g,next:void 0,previous:void 0},l){case 0:this.addItemLast(v);break;case 1:this.addItemFirst(v);break;case 2:this.addItemLast(v);break;default:this.addItemLast(v);break}this._map.set(o,v),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const g=this._map.get(o);if(g)return this._map.delete(o),this.removeItem(g),this._size--,g.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}forEach(o,g){const l=this._state;let v=this._head;for(;v;){if(g?o.bind(g)(v.value,v.key,this):o(v.value,v.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const o=this,g=this._state;let l=this._head;const v={[Symbol.iterator](){return v},next(){if(o._state!==g)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.key,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return v}values(){const o=this,g=this._state;let l=this._head;const v={[Symbol.iterator](){return v},next(){if(o._state!==g)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.value,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return v}entries(){const o=this,g=this._state;let l=this._head;const v={[Symbol.iterator](){return v},next(){if(o._state!==g)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:[l.key,l.value],done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return v}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(o>=this.size)return;if(o===0){this.clear();return}let g=this._head,l=this.size;for(;g&&l>o;)this._map.delete(g.key),g=g.next,l--;this._head=g,this._size=l,g&&(g.previous=void 0),this._state++}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const g=o.next,l=o.previous;if(!g||!l)throw new Error("Invalid list");g.previous=l,l.next=g}o.next=void 0,o.previous=void 0,this._state++}touch(o,g){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(o===this._head)return;const l=o.next,v=o.previous;o===this._tail?(v.next=void 0,this._tail=v):(l.previous=v,v.next=l),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(g===2){if(o===this._tail)return;const l=o.next,v=o.previous;o===this._head?(l.previous=void 0,this._head=l):(l.previous=v,v.next=l),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((g,l)=>{o.push([l,g])}),o}fromJSON(o){this.clear();for(const[g,l]of o)this.set(g,l)}}e.LinkedMap=w;class d extends w{constructor(o,g=1){super(),this._limit=o,this._ratio=Math.min(Math.max(0,g),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,g=2){return super.get(o,g)}peek(o){return super.get(o,0)}set(o,g){return super.set(o,g,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d;class b{constructor(){this.map=new Map}add(o){return this.map.set(o,(this.map.get(o)||0)+1),this}delete(o){let g=this.map.get(o)||0;return g===0?!1:(g--,g===0?this.map.delete(o):this.map.set(o,g),!0)}has(o){return this.map.has(o)}}e.CounterSet=b}),define(te[86],ie([0,1,35]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new P.LRUCache(1e4);function s(c){return h(c,"NFC",L)}e.normalizeNFC=s;const _=new P.LRUCache(1e4);function M(c){return h(c,"NFD",_)}e.normalizeNFD=M;const I=/[^\u0000-\u0080]/;function h(c,m,f){if(!c)return c;const w=f.get(c);if(w)return w;let d;return I.test(c)?d=c.normalize(m):d=c,f.set(c,d),d}e.removeAccents=function(){const c=/[\u0300-\u036f]/g;return function(m){return M(m).replace(c,"")}}()}),define(te[138],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function P(I,h,c){return Math.min(Math.max(I,h),c)}e.clamp=P;function L(I,h){return(h+I%h)%h}e.rot=L;class s{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=s;class _{constructor(){this._n=1,this._val=0}update(h){return this._val=this._val+(h-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=_;class M{constructor(h){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(h),this._values.fill(0,0,h)}update(h){const c=this._values[this._index];return this._values[this._index]=h,this._index=(this._index+1)%this._values.length,this._sum-=c,this._sum+=h,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=M}),function(){function j(s){const _=[];typeof s=="number"&&_.push("code/timeOrigin",s);function M(h){_.push(h,Date.now())}function I(){const h=[];for(let c=0;c<_.length;c+=2)h.push({name:_[c],startTime:_[c+1]});return h}return{mark:M,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const M of performance.getEntriesByType("mark"))_.push({name:M.name,startTime:Math.round(s+M.startTime)});return _}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function P(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=P(L))}(),function(j,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var L in P)(typeof exports=="object"?exports:j)[L]=P[L]}}(typeof self<"u"?self:this,function(){return function(j){var e={};function P(L){if(e[L])return e[L].exports;var s=e[L]={i:L,l:!1,exports:{}};return j[L].call(s.exports,s,s.exports,P),s.l=!0,s.exports}return P.m=j,P.c=e,P.d=function(L,s,_){P.o(L,s)||Object.defineProperty(L,s,{enumerable:!0,get:_})},P.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},P.t=function(L,s){if(1&s&&(L=P(L)),8&s||4&s&&typeof L=="object"&&L&&L.__esModule)return L;var _=Object.create(null);if(P.r(_),Object.defineProperty(_,"default",{enumerable:!0,value:L}),2&s&&typeof L!="string")for(var M in L)P.d(_,M,function(I){return L[I]}.bind(null,M));return _},P.n=function(L){var s=L&&L.__esModule?function(){return L.default}:function(){return L};return P.d(s,"a",s),s},P.o=function(L,s){return Object.prototype.hasOwnProperty.call(L,s)},P.p="",P(P.s=0)}([function(j,e,P){(function(L){var s;e=j.exports=oe,s=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var _=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],h=e.src=[],c=0,m=c++;h[m]="0|[1-9]\\d*";var f=c++;h[f]="[0-9]+";var w=c++;h[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=c++;h[d]="("+h[m]+")\\.("+h[m]+")\\.("+h[m]+")";var b=c++;h[b]="("+h[f]+")\\.("+h[f]+")\\.("+h[f]+")";var y=c++;h[y]="(?:"+h[m]+"|"+h[w]+")";var o=c++;h[o]="(?:"+h[f]+"|"+h[w]+")";var g=c++;h[g]="(?:-("+h[y]+"(?:\\."+h[y]+")*))";var l=c++;h[l]="(?:-?("+h[o]+"(?:\\."+h[o]+")*))";var v=c++;h[v]="[0-9A-Za-z-]+";var E=c++;h[E]="(?:\\+("+h[v]+"(?:\\."+h[v]+")*))";var S=c++,t="v?"+h[d]+h[g]+"?"+h[E]+"?";h[S]="^"+t+"$";var u="[v=\\s]*"+h[b]+h[l]+"?"+h[E]+"?",r=c++;h[r]="^"+u+"$";var n=c++;h[n]="((?:<|>)?=?)";var i=c++;h[i]=h[f]+"|x|X|\\*";var a=c++;h[a]=h[m]+"|x|X|\\*";var p=c++;h[p]="[v=\\s]*("+h[a]+")(?:\\.("+h[a]+")(?:\\.("+h[a]+")(?:"+h[g]+")?"+h[E]+"?)?)?";var C=c++;h[C]="[v=\\s]*("+h[i]+")(?:\\.("+h[i]+")(?:\\.("+h[i]+")(?:"+h[l]+")?"+h[E]+"?)?)?";var k=c++;h[k]="^"+h[n]+"\\s*"+h[p]+"$";var D=c++;h[D]="^"+h[n]+"\\s*"+h[C]+"$";var A=c++;h[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=c++;h[O]="(?:~>?)";var U=c++;h[U]="(\\s*)"+h[O]+"\\s+",I[U]=new RegExp(h[U],"g");var q=c++;h[q]="^"+h[O]+h[p]+"$";var se=c++;h[se]="^"+h[O]+h[C]+"$";var ne=c++;h[ne]="(?:\\^)";var ee=c++;h[ee]="(\\s*)"+h[ne]+"\\s+",I[ee]=new RegExp(h[ee],"g");var ae=c++;h[ae]="^"+h[ne]+h[p]+"$";var ue=c++;h[ue]="^"+h[ne]+h[C]+"$";var G=c++;h[G]="^"+h[n]+"\\s*("+u+")$|^$";var Y=c++;h[Y]="^"+h[n]+"\\s*("+t+")$|^$";var F=c++;h[F]="(\\s*)"+h[n]+"\\s*("+u+"|"+h[p]+")",I[F]=new RegExp(h[F],"g");var N=c++;h[N]="^\\s*("+h[p]+")\\s+-\\s+("+h[p]+")\\s*$";var B=c++;h[B]="^\\s*("+h[C]+")\\s+-\\s+("+h[C]+")\\s*$";var V=c++;h[V]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)s(X,h[X]),I[X]||(I[X]=new RegExp(h[X]));function ce(Z,de){if(Z instanceof oe)return Z;if(typeof Z!="string"||Z.length>_||!(de?I[r]:I[S]).test(Z))return null;try{return new oe(Z,de)}catch{return null}}function oe(Z,de){if(Z instanceof oe){if(Z.loose===de)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>_)throw new TypeError("version is longer than "+_+" characters");if(!(this instanceof oe))return new oe(Z,de);s("SemVer",Z,de),this.loose=de;var fe=Z.trim().match(de?I[r]:I[S]);if(!fe)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Le=+Ie;if(Le>=0&&Le<M)return Le}return Ie}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=ce,e.valid=function(Z,de){var fe=ce(Z,de);return fe?fe.version:null},e.clean=function(Z,de){var fe=ce(Z.trim().replace(/^[=v]+/,""),de);return fe?fe.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(Z){return s("SemVer.compare",this.version,this.loose,Z),Z instanceof oe||(Z=new oe(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},oe.prototype.compareMain=function(Z){return Z instanceof oe||(Z=new oe(Z,this.loose)),R(this.major,Z.major)||R(this.minor,Z.minor)||R(this.patch,Z.patch)},oe.prototype.comparePre=function(Z){if(Z instanceof oe||(Z=new oe(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var de=0;do{var fe=this.prerelease[de],Ie=Z.prerelease[de];if(s("prerelease compare",de,fe,Ie),fe===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ie)return R(fe,Ie)}while(++de)},oe.prototype.inc=function(Z,de){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,de,fe,Ie){typeof fe=="string"&&(Ie=fe,fe=void 0);try{return new oe(Z,fe).inc(de,Ie).version}catch{return null}},e.diff=function(Z,de){if(z(Z,de))return null;var fe=ce(Z),Ie=ce(de);if(fe.prerelease.length||Ie.prerelease.length){for(var Le in fe)if((Le==="major"||Le==="minor"||Le==="patch")&&fe[Le]!==Ie[Le])return"pre"+Le;return"prerelease"}for(var Le in fe)if((Le==="major"||Le==="minor"||Le==="patch")&&fe[Le]!==Ie[Le])return Le},e.compareIdentifiers=R;var T=/^[0-9]+$/;function R(Z,de){var fe=T.test(Z),Ie=T.test(de);return fe&&Ie&&(Z=+Z,de=+de),fe&&!Ie?-1:Ie&&!fe?1:Z<de?-1:Z>de?1:0}function W(Z,de,fe){return new oe(Z,fe).compare(new oe(de,fe))}function H(Z,de,fe){return W(Z,de,fe)>0}function x(Z,de,fe){return W(Z,de,fe)<0}function z(Z,de,fe){return W(Z,de,fe)===0}function $(Z,de,fe){return W(Z,de,fe)!==0}function K(Z,de,fe){return W(Z,de,fe)>=0}function re(Z,de,fe){return W(Z,de,fe)<=0}function le(Z,de,fe,Ie){var Le;switch(de){case"===":typeof Z=="object"&&(Z=Z.version),typeof fe=="object"&&(fe=fe.version),Le=Z===fe;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof fe=="object"&&(fe=fe.version),Le=Z!==fe;break;case"":case"=":case"==":Le=z(Z,fe,Ie);break;case"!=":Le=$(Z,fe,Ie);break;case">":Le=H(Z,fe,Ie);break;case">=":Le=K(Z,fe,Ie);break;case"<":Le=x(Z,fe,Ie);break;case"<=":Le=re(Z,fe,Ie);break;default:throw new TypeError("Invalid operator: "+de)}return Le}function ge(Z,de){if(Z instanceof ge){if(Z.loose===de)return Z;Z=Z.value}if(!(this instanceof ge))return new ge(Z,de);s("comparator",Z,de),this.loose=de,this.parse(Z),this.semver===Ce?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(Z,de){return R(de,Z)},e.major=function(Z,de){return new oe(Z,de).major},e.minor=function(Z,de){return new oe(Z,de).minor},e.patch=function(Z,de){return new oe(Z,de).patch},e.compare=W,e.compareLoose=function(Z,de){return W(Z,de,!0)},e.rcompare=function(Z,de,fe){return W(de,Z,fe)},e.sort=function(Z,de){return Z.sort(function(fe,Ie){return e.compare(fe,Ie,de)})},e.rsort=function(Z,de){return Z.sort(function(fe,Ie){return e.rcompare(fe,Ie,de)})},e.gt=H,e.lt=x,e.eq=z,e.neq=$,e.gte=K,e.lte=re,e.cmp=le,e.Comparator=ge;var Ce={};function Me(Z,de){if(Z instanceof Me)return Z.loose===de?Z:new Me(Z.raw,de);if(Z instanceof ge)return new Me(Z.value,de);if(!(this instanceof Me))return new Me(Z,de);if(this.loose=de,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Re(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function Oe(Z,de,fe,Ie,Le,Te,Ae,Be,Ne,qe,ze,Q,he){return((de=Re(fe)?"":Re(Ie)?">="+fe+".0.0":Re(Le)?">="+fe+"."+Ie+".0":">="+de)+" "+(Be=Re(Ne)?"":Re(qe)?"<"+(+Ne+1)+".0.0":Re(ze)?"<"+Ne+"."+(+qe+1)+".0":Q?"<="+Ne+"."+qe+"."+ze+"-"+Q:"<="+Be)).trim()}function He(Z,de){for(var fe=0;fe<Z.length;fe++)if(!Z[fe].test(de))return!1;if(de.prerelease.length){for(fe=0;fe<Z.length;fe++)if(s(Z[fe].semver),Z[fe].semver!==Ce&&Z[fe].semver.prerelease.length>0){var Ie=Z[fe].semver;if(Ie.major===de.major&&Ie.minor===de.minor&&Ie.patch===de.patch)return!0}return!1}return!0}function pe(Z,de,fe){try{de=new Me(de,fe)}catch{return!1}return de.test(Z)}function ve(Z,de,fe,Ie){var Le,Te,Ae,Be,Ne;switch(Z=new oe(Z,Ie),de=new Me(de,Ie),fe){case">":Le=H,Te=re,Ae=x,Be=">",Ne=">=";break;case"<":Le=x,Te=K,Ae=H,Be="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(Z,de,Ie))return!1;for(var qe=0;qe<de.set.length;++qe){var ze=de.set[qe],Q=null,he=null;if(ze.forEach(function(me){me.semver===Ce&&(me=new ge(">=0.0.0")),Q=Q||me,he=he||me,Le(me.semver,Q.semver,Ie)?Q=me:Ae(me.semver,he.semver,Ie)&&(he=me)}),Q.operator===Be||Q.operator===Ne||(!he.operator||he.operator===Be)&&Te(Z,he.semver)||he.operator===Ne&&Ae(Z,he.semver))return!1}return!0}ge.prototype.parse=function(Z){var de=this.loose?I[G]:I[Y],fe=Z.match(de);if(!fe)throw new TypeError("Invalid comparator: "+Z);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new oe(fe[2],this.loose):this.semver=Ce},ge.prototype.toString=function(){return this.value},ge.prototype.test=function(Z){return s("Comparator.test",Z,this.loose),this.semver===Ce||(typeof Z=="string"&&(Z=new oe(Z,this.loose)),le(Z,this.operator,this.semver,this.loose))},ge.prototype.intersects=function(Z,de){if(!(Z instanceof ge))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Me(Z.value,de),pe(this.value,fe,de);if(Z.operator==="")return fe=new Me(this.value,de),pe(Z.semver,fe,de);var Ie=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Le=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Te=this.semver.version===Z.semver.version,Ae=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),Be=le(this.semver,"<",Z.semver,de)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),Ne=le(this.semver,">",Z.semver,de)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return Ie||Le||Te&&Ae||Be||Ne},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(Z){var de=this.loose;Z=Z.trim(),s("range",Z,de);var fe=de?I[B]:I[N];Z=Z.replace(fe,Oe),s("hyphen replace",Z),Z=Z.replace(I[F],"$1$2$3"),s("comparator trim",Z,I[F]),Z=(Z=(Z=Z.replace(I[U],"$1~")).replace(I[ee],"$1^")).split(/\s+/).join(" ");var Ie=de?I[G]:I[Y],Le=Z.split(" ").map(function(Te){return function(Ae,Be){return s("comp",Ae),Ae=function(Ne,qe){return Ne.trim().split(/\s+/).map(function(ze){return function(Q,he){s("caret",Q,he);var me=he?I[ue]:I[ae];return Q.replace(me,function(be,ye,De,We,$e){var je;return s("caret",Q,be,ye,De,We,$e),Re(ye)?je="":Re(De)?je=">="+ye+".0.0 <"+(+ye+1)+".0.0":Re(We)?je=ye==="0"?">="+ye+"."+De+".0 <"+ye+"."+(+De+1)+".0":">="+ye+"."+De+".0 <"+(+ye+1)+".0.0":$e?(s("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),je=ye==="0"?De==="0"?">="+ye+"."+De+"."+We+$e+" <"+ye+"."+De+"."+(+We+1):">="+ye+"."+De+"."+We+$e+" <"+ye+"."+(+De+1)+".0":">="+ye+"."+De+"."+We+$e+" <"+(+ye+1)+".0.0"):(s("no pr"),je=ye==="0"?De==="0"?">="+ye+"."+De+"."+We+" <"+ye+"."+De+"."+(+We+1):">="+ye+"."+De+"."+We+" <"+ye+"."+(+De+1)+".0":">="+ye+"."+De+"."+We+" <"+(+ye+1)+".0.0"),s("caret return",je),je})}(ze,qe)}).join(" ")}(Ae,Be),s("caret",Ae),Ae=function(Ne,qe){return Ne.trim().split(/\s+/).map(function(ze){return function(Q,he){var me=he?I[se]:I[q];return Q.replace(me,function(be,ye,De,We,$e){var je;return s("tilde",Q,be,ye,De,We,$e),Re(ye)?je="":Re(De)?je=">="+ye+".0.0 <"+(+ye+1)+".0.0":Re(We)?je=">="+ye+"."+De+".0 <"+ye+"."+(+De+1)+".0":$e?(s("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),je=">="+ye+"."+De+"."+We+$e+" <"+ye+"."+(+De+1)+".0"):je=">="+ye+"."+De+"."+We+" <"+ye+"."+(+De+1)+".0",s("tilde return",je),je})}(ze,qe)}).join(" ")}(Ae,Be),s("tildes",Ae),Ae=function(Ne,qe){return s("replaceXRanges",Ne,qe),Ne.split(/\s+/).map(function(ze){return function(Q,he){Q=Q.trim();var me=he?I[D]:I[k];return Q.replace(me,function(be,ye,De,We,$e,je){s("xRange",Q,be,ye,De,We,$e,je);var Je=Re(De),Ye=Je||Re(We),Xe=Ye||Re($e);return ye==="="&&Xe&&(ye=""),Je?be=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Xe?(Ye&&(We=0),Xe&&($e=0),ye===">"?(ye=">=",Ye?(De=+De+1,We=0,$e=0):Xe&&(We=+We+1,$e=0)):ye==="<="&&(ye="<",Ye?De=+De+1:We=+We+1),be=ye+De+"."+We+"."+$e):Ye?be=">="+De+".0.0 <"+(+De+1)+".0.0":Xe&&(be=">="+De+"."+We+".0 <"+De+"."+(+We+1)+".0"),s("xRange return",be),be})}(ze,qe)}).join(" ")}(Ae,Be),s("xrange",Ae),Ae=function(Ne,qe){return s("replaceStars",Ne,qe),Ne.trim().replace(I[V],"")}(Ae,Be),s("stars",Ae),Ae}(Te,de)}).join(" ").split(/\s+/);return this.loose&&(Le=Le.filter(function(Te){return!!Te.match(Ie)})),Le=Le.map(function(Te){return new ge(Te,de)})},Me.prototype.intersects=function(Z,de){if(!(Z instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ie){return Z.set.some(function(Le){return Le.every(function(Te){return Ie.intersects(Te,de)})})})})},e.toComparators=function(Z,de){return new Me(Z,de).set.map(function(fe){return fe.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new oe(Z,this.loose));for(var de=0;de<this.set.length;de++)if(He(this.set[de],Z))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(Z,de,fe){var Ie=null,Le=null;try{var Te=new Me(de,fe)}catch{return null}return Z.forEach(function(Ae){Te.test(Ae)&&(Ie&&Le.compare(Ae)!==-1||(Le=new oe(Ie=Ae,fe)))}),Ie},e.minSatisfying=function(Z,de,fe){var Ie=null,Le=null;try{var Te=new Me(de,fe)}catch{return null}return Z.forEach(function(Ae){Te.test(Ae)&&(Ie&&Le.compare(Ae)!==1||(Le=new oe(Ie=Ae,fe)))}),Ie},e.validRange=function(Z,de){try{return new Me(Z,de).range||"*"}catch{return null}},e.ltr=function(Z,de,fe){return ve(Z,de,"<",fe)},e.gtr=function(Z,de,fe){return ve(Z,de,">",fe)},e.outside=ve,e.prerelease=function(Z,de){var fe=ce(Z,de);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(Z,de,fe){return Z=new Me(Z,fe),de=new Me(de,fe),Z.intersects(de)},e.coerce=function(Z){if(Z instanceof oe)return Z;if(typeof Z!="string")return null;var de=Z.match(I[A]);return de==null?null:ce((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,P(1))},function(j,e){var P,L,s=j.exports={};function _(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function I(o){if(P===setTimeout)return setTimeout(o,0);if((P===_||!P)&&setTimeout)return P=setTimeout,setTimeout(o,0);try{return P(o,0)}catch{try{return P.call(null,o,0)}catch{return P.call(this,o,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:_}catch{P=_}try{L=typeof clearTimeout=="function"?clearTimeout:M}catch{L=M}})();var h,c=[],m=!1,f=-1;function w(){m&&h&&(m=!1,h.length?c=h.concat(c):f=-1,c.length&&d())}function d(){if(!m){var o=I(w);m=!0;for(var g=c.length;g;){for(h=c,c=[];++f<g;)h&&h[f].run();f=-1,g=c.length}h=null,m=!1,function(l){if(L===clearTimeout)return clearTimeout(l);if((L===M||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(l);try{L(l)}catch{try{return L.call(null,l)}catch{return L.call(this,l)}}}(o)}}function b(o,g){this.fun=o,this.array=g}function y(){}s.nextTick=function(o){var g=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)g[l-1]=arguments[l];c.push(new b(o,g)),c.length!==1||m||I(d)},b.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=y,s.addListener=y,s.once=y,s.off=y,s.removeListener=y,s.removeAllListeners=y,s.emit=y,s.prependListener=y,s.prependOnceListener=y,s.listeners=function(o){return[]},s.binding=function(o){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(o){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(te[139],ie([0,1]),function(j,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(I,h,c){this.level=I,this.key=h,this.value=c,this.forward=[]}}const s=void 0;class _{constructor(I,h=2**16){this.comparator=I,this[P]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(h)|0),this._header=new L(this._maxLevel,s,s)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,s,s)}has(I){return!!_._search(this,I,this.comparator)}get(I){return _._search(this,I,this.comparator)?.value}set(I,h){return _._insert(this,I,h,this.comparator)&&(this._size+=1),this}delete(I){const h=_._delete(this,I,this.comparator);return h&&(this._size-=1),h}forEach(I,h){let c=this._header.forward[0];for(;c;)I.call(h,c.value,c.key,this),c=c.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",h=this._header.forward[0];for(;h;)I+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return I}static _search(I,h,c){let m=I._header;for(let f=I._level-1;f>=0;f--)for(;m.forward[f]&&c(m.forward[f].key,h)<0;)m=m.forward[f];if(m=m.forward[0],m&&c(m.key,h)===0)return m}static _insert(I,h,c,m){const f=[];let w=I._header;for(let d=I._level-1;d>=0;d--){for(;w.forward[d]&&m(w.forward[d].key,h)<0;)w=w.forward[d];f[d]=w}if(w=w.forward[0],w&&m(w.key,h)===0)return w.value=c,!1;{const d=_._randomLevel(I);if(d>I._level){for(let b=I._level;b<d;b++)f[b]=I._header;I._level=d}w=new L(d,h,c);for(let b=0;b<d;b++)w.forward[b]=f[b].forward[b],f[b].forward[b]=w;return!0}}static _randomLevel(I,h=.5){let c=1;for(;Math.random()<h&&c<I._maxLevel;)c+=1;return c}static _delete(I,h,c){const m=[];let f=I._header;for(let w=I._level-1;w>=0;w--){for(;f.forward[w]&&c(f.forward[w].key,h)<0;)f=f.forward[w];m[w]=f}if(f=f.forward[0],!f||c(f.key,h)!==0)return!1;for(let w=0;w<I._level&&m[w].forward[w]===f;w++)m[w].forward[w]=f.forward[w];for(;I._level>0&&I._header.forward[I._level-1]===s;)I._level-=1;return!0}}e.SkipList=_}),define(te[69],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(_){return new L(_)}constructor(_){this._now=P&&_===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=L}),define(te[3],ie([0,1,13,49,2,101,69]),function(j,e,P,L,s,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,h=!1;var c;(function(C){C.None=()=>s.Disposable.None;function k(z){if(h){const{onDidAddListener:$}=z,K=b.create();let re=0;z.onDidAddListener=()=>{++re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),K.print()),$?.()}}}function D(z,$){return ue(z,()=>{},0,void 0,!0,void 0,$)}C.defer=D;function A(z){return($,K=null,re)=>{let le=!1,ge;return ge=z(Ce=>{if(!le)return ge?ge.dispose():le=!0,$.call(K,Ce)},null,re),le&&ge.dispose(),ge}}C.once=A;function O(z,$,K){return ae((re,le=null,ge)=>z(Ce=>re.call(le,$(Ce)),null,ge),K)}C.map=O;function U(z,$,K){return ae((re,le=null,ge)=>z(Ce=>{$(Ce),re.call(le,Ce)},null,ge),K)}C.forEach=U;function q(z,$,K){return ae((re,le=null,ge)=>z(Ce=>$(Ce)&&re.call(le,Ce),null,ge),K)}C.filter=q;function se(z){return z}C.signal=se;function ne(...z){return($,K=null,re)=>(0,s.combinedDisposable)(...z.map(le=>le(ge=>$.call(K,ge),null,re)))}C.any=ne;function ee(z,$,K,re){let le=K;return O(z,ge=>(le=$(le,ge),le),re)}C.reduce=ee;function ae(z,$){let K;const re={onWillAddFirstListener(){K=z(le.fire,le)},onDidRemoveLastListener(){K?.dispose()}};$||k(re);const le=new v(re);return $?.add(le),le.event}function ue(z,$,K=100,re=!1,le=!1,ge,Ce){let Me,Re,Oe,He=0,pe;const ve={leakWarningThreshold:ge,onWillAddFirstListener(){Me=z(de=>{He++,Re=$(Re,de),re&&!Oe&&(Z.fire(Re),Re=void 0),pe=()=>{const fe=Re;Re=void 0,Oe=void 0,(!re||He>1)&&Z.fire(fe),He=0},typeof K=="number"?(clearTimeout(Oe),Oe=setTimeout(pe,K)):Oe===void 0&&(Oe=0,queueMicrotask(pe))})},onWillRemoveListener(){le&&He>0&&pe?.()},onDidRemoveLastListener(){pe=void 0,Me.dispose()}};Ce||k(ve);const Z=new v(ve);return Ce?.add(Z),Z.event}C.debounce=ue;function G(z,$=0,K){return C.debounce(z,(re,le)=>re?(re.push(le),re):[le],$,void 0,!0,void 0,K)}C.accumulate=G;function Y(z,$=(re,le)=>re===le,K){let re=!0,le;return q(z,ge=>{const Ce=re||!$(ge,le);return re=!1,le=ge,Ce},K)}C.latch=Y;function F(z,$,K){return[C.filter(z,$,K),C.filter(z,re=>!$(re),K)]}C.split=F;function N(z,$=!1,K=[]){let re=K.slice(),le=z(Me=>{re?re.push(Me):Ce.fire(Me)});const ge=()=>{re?.forEach(Me=>Ce.fire(Me)),re=null},Ce=new v({onWillAddFirstListener(){le||(le=z(Me=>Ce.fire(Me)))},onDidAddFirstListener(){re&&($?setTimeout(ge):ge())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return Ce.event}C.buffer=N;class B{constructor($){this.event=$,this.disposables=new s.DisposableStore}map($){return new B(O(this.event,$,this.disposables))}forEach($){return new B(U(this.event,$,this.disposables))}filter($){return new B(q(this.event,$,this.disposables))}reduce($,K){return new B(ee(this.event,$,K,this.disposables))}latch(){return new B(Y(this.event,void 0,this.disposables))}debounce($,K=100,re=!1,le=!1,ge){return new B(ue(this.event,$,K,re,le,ge,this.disposables))}on($,K,re){return this.event($,K,re)}once($,K,re){return A(this.event)($,K,re)}dispose(){this.disposables.dispose()}}function V(z){return new B(z)}C.chain=V;function X(z,$,K=re=>re){const re=(...Me)=>Ce.fire(K(...Me)),le=()=>z.on($,re),ge=()=>z.removeListener($,re),Ce=new v({onWillAddFirstListener:le,onDidRemoveLastListener:ge});return Ce.event}C.fromNodeEventEmitter=X;function ce(z,$,K=re=>re){const re=(...Me)=>Ce.fire(K(...Me)),le=()=>z.addEventListener($,re),ge=()=>z.removeEventListener($,re),Ce=new v({onWillAddFirstListener:le,onDidRemoveLastListener:ge});return Ce.event}C.fromDOMEventEmitter=ce;function oe(z){return new Promise($=>A(z)($))}C.toPromise=oe;function T(z,$){return $(void 0),z(K=>$(K))}C.runAndSubscribe=T;function R(z,$){let K=null;function re(ge){K?.dispose(),K=new s.DisposableStore,$(ge,K)}re(void 0);const le=z(ge=>re(ge));return(0,s.toDisposable)(()=>{le.dispose(),K?.dispose()})}C.runAndSubscribeWithStore=R;class W{constructor($,K){this._observable=$,this._counter=0,this._hasChanged=!1;const re={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};K||k(re),this.emitter=new v(re),K&&K.add(this.emitter)}beginUpdate($){this._counter++}handlePossibleChange($){}handleChange($,K){this._hasChanged=!0}endUpdate($){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function H(z,$){return new W(z,$).emitter.event}C.fromObservable=H;function x(z){return $=>{let K=0,re=!1;const le={beginUpdate(){K++},endUpdate(){K--,K===0&&(z.reportChanges(),re&&(re=!1,$()))},handlePossibleChange(){},handleChange(){re=!0}};return z.addObserver(le),z.reportChanges(),{dispose(){z.removeObserver(le)}}}}C.fromObservableLight=x})(c||(e.Event=c={}));class m{static{this.all=new Set}static{this._idPool=0}constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${m._idPool++}`,m.all.add(this)}start(k){this._stopWatch=new M.StopWatch,this.listenerCount=k}stop(){if(this._stopWatch){const k=this._stopWatch.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=m;let f=-1;function w(C){const k=f;return f=C,{dispose(){f=k}}}e.setGlobalLeakWarningThreshold=w;class d{constructor(k,D=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=D,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(k,D){const A=this.threshold;if(A<=0||D<A)return;this._stacks||(this._stacks=new Map);const O=this._stacks.get(k.value)||0;if(this._stacks.set(k.value,O+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=A*.5;let U,q=0;for(const[se,ne]of this._stacks)(!U||q<ne)&&(U=se,q=ne);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${q}):`),console.warn(U)}return()=>{const U=this._stacks.get(k.value)||0;this._stacks.set(k.value,U-1)}}}class b{static create(){return new b(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class o{constructor(k){this.value=k,this.id=y++}}const g=2,l=(C,k)=>{if(C instanceof o)k(C);else for(let D=0;D<C.length;D++){const A=C[D];A&&k(A)}};class v{constructor(k){this._size=0,this._options=k,this._leakageMon=f>0||this._options?.leakWarningThreshold?new d(this._options?.leakWarningThreshold??f):void 0,this._perfMon=this._options?._profName?new m(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(I){const k=this._listeners;queueMicrotask(()=>{l(k,D=>D.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(k,D,A)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.Disposable.None;if(this._disposed)return s.Disposable.None;D&&(k=k.bind(D));const O=new o(k);let U,q;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(O.stack=b.create(),U=this._leakageMon.check(O.stack,this._size+1)),I&&(O.stack=q??b.create()),this._listeners?this._listeners instanceof o?(this._deliveryQueue??=new S,this._listeners=[this._listeners,O]):this._listeners.push(O):(this._options?.onWillAddFirstListener?.(this),this._listeners=O,this._options?.onDidAddFirstListener?.(this)),this._size++;const se=(0,s.toDisposable)(()=>{U?.(),this._removeListener(O)});return A instanceof s.DisposableStore?A.add(se):Array.isArray(A)&&A.push(se),se},this._event}_removeListener(k){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const D=this._listeners,A=D.indexOf(k);if(A===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,D[A]=void 0;const O=this._deliveryQueue.current===this;if(this._size*g<=D.length){let U=0;for(let q=0;q<D.length;q++)D[q]?D[U++]=D[q]:O&&(this._deliveryQueue.end--,U<this._deliveryQueue.i&&this._deliveryQueue.i--);D.length=U}}_deliver(k,D){if(!k)return;const A=this._options?.onListenerError||P.onUnexpectedError;if(!A){k.value(D);return}try{k.value(D)}catch(O){A(O)}}_deliverQueue(k){const D=k.current._listeners;for(;k.i<k.end;)this._deliver(D[k.i++],k.value);k.reset()}fire(k){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof o)this._deliver(this._listeners,k);else{const D=this._deliveryQueue;D.enqueue(this,k,this._listeners.length),this._deliverQueue(D)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=v;const E=()=>new S;e.createEventDeliveryQueue=E;class S{constructor(){this.i=-1,this.end=0}enqueue(k,D,A){this.i=0,this.end=A,this.current=k,this.value=D}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends v{async fireAsync(k,D,A){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList),l(this._listeners,O=>this._asyncDeliveryQueue.push([O.value,k]));this._asyncDeliveryQueue.size>0&&!D.isCancellationRequested;){const[O,U]=this._asyncDeliveryQueue.shift(),q=[],se={...U,token:D,waitUntil:ne=>{if(Object.isFrozen(q))throw new Error("waitUntil can NOT be called asynchronous");A&&(ne=A(ne,O)),q.push(ne)}};try{O(se)}catch(ne){(0,P.onUnexpectedError)(ne);continue}Object.freeze(q),await Promise.allSettled(q).then(ne=>{for(const ee of ne)ee.status==="rejected"&&(0,P.onUnexpectedError)(ee.reason)})}}}e.AsyncEmitter=t;class u extends v{get isPaused(){return this._isPaused!==0}constructor(k){super(k),this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=k?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const k=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(k))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(k){this._size&&(this._isPaused!==0?this._eventQueue.push(k):super.fire(k))}}e.PauseableEmitter=u;class r extends u{constructor(k){super(k),this._delay=k.delay??100}fire(k){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(k)}}e.DebounceEmitter=r;class n extends v{constructor(k){super(k),this._queuedEvents=[],this._mergeFn=k?.merge}fire(k){this.hasListeners()&&(this._queuedEvents.push(k),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(D=>super.fire(D)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=n;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(k){const D={event:k,listener:null};this.events.push(D),this.hasListeners&&this.hook(D);const A=()=>{this.hasListeners&&this.unhook(D);const O=this.events.indexOf(D);this.events.splice(O,1)};return(0,s.toDisposable)((0,L.once)(A))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(k=>this.hook(k))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(k=>this.unhook(k))}hook(k){k.listener=k.event(D=>this.emitter.fire(D))}unhook(k){k.listener&&k.listener.dispose(),k.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class a{constructor(){this.buffers=[]}wrapEvent(k){return(D,A,O)=>k(U=>{const q=this.buffers[this.buffers.length-1];q?q.push(()=>D.call(A,U)):D.call(A,U)},void 0,O)}bufferEvents(k){const D=[];this.buffers.push(D);const A=k();return this.buffers.pop(),D.forEach(O=>O()),A}}e.EventBufferer=a;class p{constructor(){this.listening=!1,this.inputEvent=c.None,this.inputEventListener=s.Disposable.None,this.emitter=new v({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(k){this.inputEvent=k,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=k(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(te[21],ie([0,1,3]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(I,h){const c=setTimeout(I.bind(h),0);return{dispose(){clearTimeout(c)}}});var s;(function(I){function h(c){return c===I.None||c===I.Cancelled||c instanceof _?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}I.isCancellationToken=h,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(s||(e.CancellationToken=s={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new P.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=s.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=s.None}}e.CancellationTokenSource=M}),define(te[140],ie([0,1,21]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new P.CancellationTokenSource,h=this.task(I.token);return this.result={promise:h,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=L;class s{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const h=JSON.stringify(I);return this.lastArgKey!==h&&(this.lastArgKey=h,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=s;class _{get cachedValues(){return this._map}constructor(I){this.fn=I,this._map=new Map}get(I){if(this._map.has(I))return this._map.get(I);const h=this.fn(I);return this._map.set(I,h),h}}e.CachedFunction=_}),define(te[56],ie([0,1,13,2]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function s(E){const S=E;return S?typeof S.read=="function":!1}e.isReadable=s;function _(E){const S=E;return S?[S.on,S.pause,S.resume,S.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=_;function M(E){const S=E;return S?_(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.isReadableBufferedStream=M;function I(E,S){return new h(E,S)}e.newWriteableStream=I;class h{constructor(S,t){this.reducer=S,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(S){if(!this.state.destroyed){if(this.state.flowing)this.emitData(S);else if(this.buffer.data.push(S),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(S){this.state.destroyed||(this.state.flowing?this.emitError(S):this.buffer.error.push(S))}end(S){this.state.destroyed||(typeof S<"u"&&this.write(S),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(S){this.listeners.data.slice(0).forEach(t=>t(S))}emitError(S){this.listeners.error.length===0?(0,P.onUnexpectedError)(S):this.listeners.error.slice(0).forEach(t=>t(S))}emitEnd(){this.listeners.end.slice(0).forEach(S=>S())}on(S,t){if(!this.state.destroyed)switch(S){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(S,t){if(this.state.destroyed)return;let u;switch(S){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const r=u.indexOf(t);r>=0&&u.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const S=this.reducer(this.buffer.data);this.emitData(S),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const S of this.buffer.error)this.emitError(S);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(E,S){const t=[];let u;for(;(u=E.read())!==null;)t.push(u);return S(t)}e.consumeReadable=c;function m(E,S,t){const u=[];let r;for(;(r=E.read())!==null&&u.length<t;)u.push(r);return r===null&&u.length>0?S(u):{read:()=>{if(u.length>0)return u.shift();if(typeof r<"u"){const n=r;return r=void 0,n}return E.read()}}}e.peekReadable=m;function f(E,S){return new Promise((t,u)=>{const r=[];w(E,{onData:n=>{S&&r.push(n)},onError:n=>{S?u(n):t(void 0)},onEnd:()=>{t(S?S(r):void 0)}})})}e.consumeStream=f;function w(E,S){let t=!1;return E.on("error",u=>{t||S.onError(u)}),E.on("end",()=>{t||S.onEnd()}),E.on("data",u=>{t||S.onData(u)}),(0,L.toDisposable)(()=>t=!0)}e.listenStream=w;function d(E,S){return new Promise((t,u)=>{const r=new L.DisposableStore,n=[],i=C=>{if(n.push(C),n.length>S)return r.dispose(),E.pause(),t({stream:E,buffer:n,ended:!1})},a=C=>u(C),p=()=>t({stream:E,buffer:n,ended:!0});r.add((0,L.toDisposable)(()=>E.removeListener("error",a))),E.on("error",a),r.add((0,L.toDisposable)(()=>E.removeListener("end",p))),E.on("end",p),r.add((0,L.toDisposable)(()=>E.removeListener("data",i))),E.on("data",i)})}e.peekStream=d;function b(E,S){const t=I(S);return t.end(E),t}e.toStream=b;function y(){const E=I(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=y;function o(E){let S=!1;return{read:()=>S?null:(S=!0,E)}}e.toReadable=o;function g(E,S,t){const u=I(t);return w(E,{onData:r=>u.write(S.data(r)),onError:r=>u.error(S.error?S.error(r):r),onEnd:()=>u.end()}),u}e.transform=g;function l(E,S,t){let u=!1;return{read:()=>{const r=S.read();return u?r:(u=!0,r!==null?t([E,r]):E)}}}e.prefixedReadable=l;function v(E,S,t){let u=!1;const r=I(t);return w(S,{onData:n=>u?r.write(n):(u=!0,r.write(t([E,n]))),onError:n=>r.error(n),onEnd:()=>{u||(u=!0,r.write(E)),r.end()}}),r}e.prefixedStream=v}),define(te[17],ie([0,1,85,56]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const s=typeof Buffer<"u",_=new P.Lazy(()=>new Uint8Array(256));let M,I;class h{static alloc(A){return s?new h(Buffer.allocUnsafe(A)):new h(new Uint8Array(A))}static wrap(A){return s&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new h(A)}static fromString(A,O){return!(O?.dontUseNodeBuffer||!1)&&s?new h(Buffer.from(A)):(M||(M=new TextEncoder),new h(M.encode(A)))}static fromByteArray(A){const O=h.alloc(A.length);for(let U=0,q=A.length;U<q;U++)O.buffer[U]=A[U];return O}static concat(A,O){if(typeof O>"u"){O=0;for(let se=0,ne=A.length;se<ne;se++)O+=A[se].byteLength}const U=h.alloc(O);let q=0;for(let se=0,ne=A.length;se<ne;se++){const ee=A[se];U.set(ee,q),q+=ee.byteLength}return U}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=h.alloc(this.byteLength);return A.set(this),A}toString(){return s?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(A,O){return new h(this.buffer.subarray(A,O))}set(A,O){if(A instanceof h)this.buffer.set(A.buffer,O);else if(A instanceof Uint8Array)this.buffer.set(A,O);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),O);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return w(this.buffer,A)}writeUInt32BE(A,O){d(this.buffer,A,O)}readUInt32LE(A){return b(this.buffer,A)}writeUInt32LE(A,O){y(this.buffer,A,O)}readUInt8(A){return o(this.buffer,A)}writeUInt8(A,O){g(this.buffer,A,O)}indexOf(A,O=0){return c(this.buffer,A instanceof h?A.buffer:A,O)}}e.VSBuffer=h;function c(D,A,O=0){const U=A.byteLength,q=D.byteLength;if(U===0)return 0;if(U===1)return D.indexOf(A[0]);if(U>q-O)return-1;const se=_.value;se.fill(A.length);for(let ue=0;ue<A.length;ue++)se[A[ue]]=A.length-ue-1;let ne=O+A.length-1,ee=ne,ae=-1;for(;ne<q;)if(D[ne]===A[ee]){if(ee===0){ae=ne;break}ne--,ee--}else ne+=Math.max(A.length-ee,se[D[ne]]),ee=A.length-1;return ae}e.binaryIndexOf=c;function m(D,A){return D[A+0]<<0>>>0|D[A+1]<<8>>>0}e.readUInt16LE=m;function f(D,A,O){D[O+0]=A&255,A=A>>>8,D[O+1]=A&255}e.writeUInt16LE=f;function w(D,A){return D[A]*2**24+D[A+1]*2**16+D[A+2]*2**8+D[A+3]}e.readUInt32BE=w;function d(D,A,O){D[O+3]=A,A=A>>>8,D[O+2]=A,A=A>>>8,D[O+1]=A,A=A>>>8,D[O]=A}e.writeUInt32BE=d;function b(D,A){return D[A+0]<<0>>>0|D[A+1]<<8>>>0|D[A+2]<<16>>>0|D[A+3]<<24>>>0}e.readUInt32LE=b;function y(D,A,O){D[O+0]=A&255,A=A>>>8,D[O+1]=A&255,A=A>>>8,D[O+2]=A&255,A=A>>>8,D[O+3]=A&255}e.writeUInt32LE=y;function o(D,A){return D[A]}e.readUInt8=o;function g(D,A,O){D[O]=A}e.writeUInt8=g;function l(D){return L.consumeReadable(D,A=>h.concat(A))}e.readableToBuffer=l;function v(D){return L.toReadable(D)}e.bufferToReadable=v;function E(D){return L.consumeStream(D,A=>h.concat(A))}e.streamToBuffer=E;async function S(D){return D.ended?h.concat(D.buffer):h.concat([...D.buffer,await E(D.stream)])}e.bufferedStreamToBuffer=S;function t(D){return L.toStream(D,A=>h.concat(A))}e.bufferToStream=t;function u(D){return L.transform(D,{data:A=>typeof A=="string"?h.fromString(A):h.wrap(A)},A=>h.concat(A))}e.streamToBufferReadableStream=u;function r(D){return L.newWriteableStream(A=>h.concat(A),D)}e.newWriteableBufferStream=r;function n(D,A){return L.prefixedReadable(D,A,O=>h.concat(O))}e.prefixedBufferReadable=n;function i(D,A){return L.prefixedStream(D,A,O=>h.concat(O))}e.prefixedBufferStream=i;function a(D){let A=0,O=0,U=0;const q=new Uint8Array(Math.floor(D.length/4*3)),se=ee=>{switch(O){case 3:q[U++]=A|ee,O=0;break;case 2:q[U++]=A|ee>>>2,A=ee<<6,O=3;break;case 1:q[U++]=A|ee>>>4,A=ee<<4,O=2;break;default:A=ee<<2,O=1}};for(let ee=0;ee<D.length;ee++){const ae=D.charCodeAt(ee);if(ae>=65&&ae<=90)se(ae-65);else if(ae>=97&&ae<=122)se(ae-97+26);else if(ae>=48&&ae<=57)se(ae-48+52);else if(ae===43||ae===45)se(62);else if(ae===47||ae===95)se(63);else{if(ae===61)break;throw new SyntaxError(`Unexpected base64 character ${D[ee]}`)}}const ne=U;for(;O>0;)se(0);return h.wrap(q).slice(0,ne)}e.decodeBase64=a;const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:D},A=!0,O=!1){const U=O?C:p;let q="";const se=D.byteLength%3;let ne=0;for(;ne<D.byteLength-se;ne+=3){const ee=D[ne+0],ae=D[ne+1],ue=D[ne+2];q+=U[ee>>>2],q+=U[(ee<<4|ae>>>4)&63],q+=U[(ae<<2|ue>>>6)&63],q+=U[ue&63]}if(se===1){const ee=D[ne+0];q+=U[ee>>>2],q+=U[ee<<4&63],A&&(q+="==")}else if(se===2){const ee=D[ne+0],ae=D[ne+1];q+=U[ee>>>2],q+=U[(ee<<4|ae>>>4)&63],q+=U[ae<<2&63],A&&(q+="=")}return q}e.encodeBase64=k}),define(te[25],ie([0,1,140,85]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function s(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=s;const _=/{(\d+)}/g;function M(Q,...he){return he.length===0?Q:Q.replace(_,function(me,be){const ye=parseInt(be,10);return isNaN(ye)||ye<0||ye>=he.length?me:he[ye]})}e.format=M;const I=/{([^}]+)}/g;function h(Q,he){return Q.replace(I,(me,be)=>he[be]??me)}e.format2=h;function c(Q){return Q.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=c;function m(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=m;function f(Q,he){let me=0;const be=he.charCodeAt(0);for(let ye=Q.length-1;ye>=0;ye--)Q.charCodeAt(ye)===be&&me++;return me}e.count=f;function w(Q,he,me="\u2026"){return Q.length<=he?Q:`${Q.substr(0,he)}${me}`}e.truncate=w;function d(Q,he=" "){const me=b(Q,he);return y(me,he)}e.trim=d;function b(Q,he){if(!Q||!he)return Q;const me=he.length;if(me===0||Q.length===0)return Q;let be=0;for(;Q.indexOf(he,be)===be;)be=be+me;return Q.substring(be)}e.ltrim=b;function y(Q,he){if(!Q||!he)return Q;const me=he.length,be=Q.length;if(me===0||be===0)return Q;let ye=be,De=-1;for(;De=Q.lastIndexOf(he,ye-1),!(De===-1||De+me!==ye);){if(De===0)return"";ye=De}return Q.substring(0,ye)}e.rtrim=y;function o(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=o;function g(Q){return Q.replace(/\*/g,"")}e.stripWildcards=g;function l(Q,he,me={}){if(!Q)throw new Error("Cannot create regex from empty string");he||(Q=m(Q)),me.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let be="";return me.global&&(be+="g"),me.matchCase||(be+="i"),me.multiline&&(be+="m"),me.unicode&&(be+="u"),new RegExp(Q,be)}e.createRegExp=l;function v(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function E(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function S(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=S;function t(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=t;function u(Q){for(let he=0,me=Q.length;he<me;he++){const be=Q.charCodeAt(he);if(be!==32&&be!==9)return he}return-1}e.firstNonWhitespaceIndex=u;function r(Q,he=0,me=Q.length){for(let be=he;be<me;be++){const ye=Q.charCodeAt(be);if(ye!==32&&ye!==9)return Q.substring(he,be)}return Q.substring(he,me)}e.getLeadingWhitespace=r;function n(Q,he=Q.length-1){for(let me=he;me>=0;me--){const be=Q.charCodeAt(me);if(be!==32&&be!==9)return me}return-1}e.lastNonWhitespaceIndex=n;function i(Q,he,me){const be=[];let ye=0;for(const De of Q.matchAll(he)){if(be.push(Q.slice(ye,De.index)),De.index===void 0)throw new Error("match.index should be defined");ye=De.index+De[0].length,be.push(me(De[0],...De.slice(1),De.index,Q,De.groups))}return be.push(Q.slice(ye)),Promise.all(be).then(De=>De.join(""))}e.replaceAsync=i;function a(Q,he){return Q<he?-1:Q>he?1:0}e.compare=a;function p(Q,he,me=0,be=Q.length,ye=0,De=he.length){for(;me<be&&ye<De;me++,ye++){const je=Q.charCodeAt(me),Je=he.charCodeAt(ye);if(je<Je)return-1;if(je>Je)return 1}const We=be-me,$e=De-ye;return We<$e?-1:We>$e?1:0}e.compareSubstring=p;function C(Q,he){return k(Q,he,0,Q.length,0,he.length)}e.compareIgnoreCase=C;function k(Q,he,me=0,be=Q.length,ye=0,De=he.length){for(;me<be&&ye<De;me++,ye++){let je=Q.charCodeAt(me),Je=he.charCodeAt(ye);if(je===Je)continue;if(je>=128||Je>=128)return p(Q.toLowerCase(),he.toLowerCase(),me,be,ye,De);A(je)&&(je-=32),A(Je)&&(Je-=32);const Ye=je-Je;if(Ye!==0)return Ye}const We=be-me,$e=De-ye;return We<$e?-1:We>$e?1:0}e.compareSubstringIgnoreCase=k;function D(Q){return Q>=48&&Q<=57}e.isAsciiDigit=D;function A(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=A;function O(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=O;function U(Q,he){return Q.length===he.length&&k(Q,he)===0}e.equalsIgnoreCase=U;function q(Q,he){const me=he.length;return he.length>Q.length?!1:k(Q,he,0,me)===0}e.startsWithIgnoreCase=q;function se(Q,he){const me=Math.min(Q.length,he.length);let be;for(be=0;be<me;be++)if(Q.charCodeAt(be)!==he.charCodeAt(be))return be;return me}e.commonPrefixLength=se;function ne(Q,he){const me=Math.min(Q.length,he.length);let be;const ye=Q.length-1,De=he.length-1;for(be=0;be<me;be++)if(Q.charCodeAt(ye-be)!==he.charCodeAt(De-be))return be;return me}e.commonSuffixLength=ne;function ee(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=ee;function ae(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=ae;function ue(Q,he){return(Q-55296<<10)+(he-56320)+65536}e.computeCodePoint=ue;function G(Q,he,me){const be=Q.charCodeAt(me);if(ee(be)&&me+1<he){const ye=Q.charCodeAt(me+1);if(ae(ye))return ue(be,ye)}return be}e.getNextCodePoint=G;function Y(Q,he){const me=Q.charCodeAt(he-1);if(ae(me)&&he>1){const be=Q.charCodeAt(he-2);if(ee(be))return ue(be,me)}return me}class F{get offset(){return this._offset}constructor(he,me=0){this._str=he,this._len=he.length,this._offset=me}setOffset(he){this._offset=he}prevCodePoint(){const he=Y(this._str,this._offset);return this._offset-=he>=65536?2:1,he}nextCodePoint(){const he=G(this._str,this._len,this._offset);return this._offset+=he>=65536?2:1,he}eol(){return this._offset>=this._len}}e.CodePointIterator=F;class N{get offset(){return this._iterator.offset}constructor(he,me=0){this._iterator=new F(he,me)}nextGraphemeLength(){const he=Ie.getInstance(),me=this._iterator,be=me.offset;let ye=he.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const De=me.offset,We=he.getGraphemeBreakType(me.nextCodePoint());if(de(ye,We)){me.setOffset(De);break}ye=We}return me.offset-be}prevGraphemeLength(){const he=Ie.getInstance(),me=this._iterator,be=me.offset;let ye=he.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const De=me.offset,We=he.getGraphemeBreakType(me.prevCodePoint());if(de(We,ye)){me.setOffset(De);break}ye=We}return be-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=N;function B(Q,he){return new N(Q,he).nextGraphemeLength()}e.nextCharLength=B;function V(Q,he){return new N(Q,he).prevGraphemeLength()}e.prevCharLength=V;function X(Q,he){he>0&&ae(Q.charCodeAt(he))&&he--;const me=he+B(Q,he);return[me-V(Q,me),me]}e.getCharContainingOffset=X;function ce(Q){const he=new N(Q);let me=0;for(;!he.eol();)me++,he.nextGraphemeLength();return me}e.charCount=ce;let oe;function T(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function R(Q){return oe||(oe=T()),oe.test(Q)}e.containsRTL=R;const W=/^[\t\n\r\x20-\x7E]*$/;function H(Q){return W.test(Q)}e.isBasicASCII=H,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function x(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=x;function z(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=z;function $(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=$;function K(Q,he){if(Q.length<he)return Q;const me=/\b/g;let be=0;for(;me.test(Q)&&!(Q.length-me.lastIndex<he);)be=me.lastIndex,me.lastIndex+=1;return Q.substring(be).replace(/^\s/,"")}e.lcut=K;const re=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,le=/\x1b\].*?\x07/g;function ge(Q){return Q&&(Q=Q.replace(re,"").replace(le,"")),Q}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Me(Q){return Ce(Q)?Q.substr(1):Q}e.stripUTF8BOM=Me;function Re(Q,he){if(!Q||!he||Q.length<he.length)return!1;const me=he.length,be=Q.toLowerCase();let ye=0,De=-1;for(;ye<me;){const We=be.indexOf(he[ye],De+1);if(We<0)return!1;De=We,ye++}return!0}e.fuzzyContains=Re;function Oe(Q,he=!1){return Q?(he&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=Oe;function He(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=He;function pe(Q,he=1){if(he===0)return"";let me=-1;do me=Q.indexOf(`
`,me+1),he--;while(he>0&&me>=0);return me===-1?Q:(Q[me-1]==="\r"&&me--,Q.substr(0,me))}e.getNLines=pe;function ve(Q){return Q=Q%(2*26),Q<26?String.fromCharCode(97+Q):String.fromCharCode(65+Q-26)}e.singleLetterHash=ve;function Z(Q){return Ie.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=Z;function de(Q,he){return Q===0?he!==5&&he!==7:Q===2&&he===3?!1:Q===4||Q===2||Q===3||he===4||he===2||he===3?!0:!(Q===8&&(he===8||he===9||he===11||he===12)||(Q===11||Q===9)&&(he===9||he===10)||(Q===12||Q===10)&&he===10||he===5||he===13||he===7||Q===1||Q===13&&he===14||Q===6&&he===6)}var fe;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(fe||(e.GraphemeBreakType=fe={}));class Ie{static{this._INSTANCE=null}static getInstance(){return Ie._INSTANCE||(Ie._INSTANCE=new Ie),Ie._INSTANCE}constructor(){this._data=Le()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const me=this._data,be=me.length/3;let ye=1;for(;ye<=be;)if(he<me[3*ye])ye=2*ye;else if(he>me[3*ye+1])ye=2*ye+1;else return me[3*ye+2];return 0}}function Le(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(Q,he){if(Q===0)return 0;const me=Ae(Q,he);if(me!==void 0)return me;const be=new F(he,Q);return be.prevCodePoint(),be.offset}e.getLeftDeleteOffset=Te;function Ae(Q,he){const me=new F(he,Q);let be=me.prevCodePoint();for(;Be(be)||be===65039||be===8419;){if(me.offset===0)return;be=me.prevCodePoint()}if(!$(be))return;let ye=me.offset;return ye>0&&me.prevCodePoint()===8205&&(ye=me.offset),ye}function Be(Q){return 127995<=Q&&Q<=127999}var Ne;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(Ne||(Ne={})),e.noBreakWhitespace="\xA0";class qe{static{this.ambiguousCharacterData=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new P.LRUCachedFunction(he=>{function me(Ye){const Xe=new Map;for(let tt=0;tt<Ye.length;tt+=2)Xe.set(Ye[tt],Ye[tt+1]);return Xe}function be(Ye,Xe){const tt=new Map(Ye);for(const[ot,ct]of Xe)tt.set(ot,ct);return tt}function ye(Ye,Xe){if(!Ye)return Xe;const tt=new Map;for(const[ot,ct]of Ye)Xe.has(ot)&&tt.set(ot,ct);return tt}const De=this.ambiguousCharacterData.value;let We=he.filter(Ye=>!Ye.startsWith("_")&&Ye in De);We.length===0&&(We=["_default"]);let $e;for(const Ye of We){const Xe=me(De[Ye]);$e=ye($e,Xe)}const je=me(De._common),Je=be(je,$e);return new qe(Je)})}static getInstance(he){return qe.cache.get(Array.from(he))}static{this._locales=new L.Lazy(()=>Object.keys(qe.ambiguousCharacterData.value).filter(he=>!he.startsWith("_")))}static getLocales(){return qe._locales.value}constructor(he){this.confusableDictionary=he}isAmbiguous(he){return this.confusableDictionary.has(he)}getPrimaryConfusable(he){return this.confusableDictionary.get(he)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=qe;class ze{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(ze.getRawData())),this._data}static isInvisibleCharacter(he){return ze.getData().has(he)}static get codePoints(){return ze.getData()}}e.InvisibleCharacters=ze}),define(te[57],ie([0,1,25]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(g){return s(g,0)}e.hash=L;function s(g,l){switch(typeof g){case"object":return g===null?_(349,l):Array.isArray(g)?h(g,l):c(g,l);case"string":return I(g,l);case"boolean":return M(g,l);case"number":return _(g,l);case"undefined":return _(937,l);default:return _(617,l)}}e.doHash=s;function _(g,l){return(l<<5)-l+g|0}e.numberHash=_;function M(g,l){return _(g?433:863,l)}function I(g,l){l=_(149417,l);for(let v=0,E=g.length;v<E;v++)l=_(g.charCodeAt(v),l);return l}e.stringHash=I;function h(g,l){return l=_(104579,l),g.reduce((v,E)=>s(E,v),l)}function c(g,l){return l=_(181387,l),Object.keys(g).sort().reduce((v,E)=>(v=I(E,v),s(g[E],v)),l)}class m{constructor(){this._value=0}get value(){return this._value}hash(l){return this._value=s(l,this._value),this._value}}e.Hasher=m;var f;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(f||(f={}));function w(g,l,v=32){const E=v-l,S=~((1<<E)-1);return(g<<l|(S&g)>>>E)>>>0}function d(g,l=0,v=g.byteLength,E=0){for(let S=0;S<v;S++)g[l+S]=E}function b(g,l,v="0"){for(;g.length<l;)g=v+g;return g}function y(g,l=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(v=>v.toString(16).padStart(2,"0")).join(""):b((g>>>0).toString(16),l/4)}e.toHexString=y;class o{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(l){const v=l.length;if(v===0)return;const E=this._buff;let S=this._buffLen,t=this._leftoverHighSurrogate,u,r;for(t!==0?(u=t,r=-1,t=0):(u=l.charCodeAt(0),r=0);;){let n=u;if(P.isHighSurrogate(u))if(r+1<v){const i=l.charCodeAt(r+1);P.isLowSurrogate(i)?(r++,n=P.computeCodePoint(u,i)):n=65533}else{t=u;break}else P.isLowSurrogate(u)&&(n=65533);if(S=this._push(E,S,n),r++,r<v)u=l.charCodeAt(r);else break}this._buffLen=S,this._leftoverHighSurrogate=t}_push(l,v,E){return E<128?l[v++]=E:E<2048?(l[v++]=192|(E&1984)>>>6,l[v++]=128|(E&63)>>>0):E<65536?(l[v++]=224|(E&61440)>>>12,l[v++]=128|(E&4032)>>>6,l[v++]=128|(E&63)>>>0):(l[v++]=240|(E&1835008)>>>18,l[v++]=128|(E&258048)>>>12,l[v++]=128|(E&4032)>>>6,l[v++]=128|(E&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const l=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(l/4294967296),!1),this._buffDV.setUint32(60,l%4294967296,!1),this._step()}_step(){const l=o._bigBlock32,v=this._buffDV;for(let p=0;p<64;p+=4)l.setUint32(p,v.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)l.setUint32(p,w(l.getUint32(p-12,!1)^l.getUint32(p-32,!1)^l.getUint32(p-56,!1)^l.getUint32(p-64,!1),1),!1);let E=this._h0,S=this._h1,t=this._h2,u=this._h3,r=this._h4,n,i,a;for(let p=0;p<80;p++)p<20?(n=S&t|~S&u,i=1518500249):p<40?(n=S^t^u,i=1859775393):p<60?(n=S&t|S&u|t&u,i=2400959708):(n=S^t^u,i=3395469782),a=w(E,5)+n+r+i+l.getUint32(p*4,!1)&4294967295,r=u,u=t,t=w(S,30),S=E,E=a;this._h0=this._h0+E&4294967295,this._h1=this._h1+S&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=o}),define(te[70],ie([0,1,25]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(L||(L={})),function(s){const _="error",M="warning",I="warn",h="info",c="ignore";function m(w){return w?P.equalsIgnoreCase(_,w)?s.Error:P.equalsIgnoreCase(M,w)||P.equalsIgnoreCase(I,w)?s.Warning:P.equalsIgnoreCase(h,w)?s.Info:s.Ignore:s.Ignore}s.fromValue=m;function f(w){switch(w){case s.Error:return _;case s.Warning:return M;case s.Info:return h;default:return c}}s.toString=f}(L||(L={})),e.default=L}),define(te[141],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(te[58],ie([0,1,24,25]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class s{constructor(){this._value="",this._pos=0}reset(d){return this._value=d,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(d){const b=d.charCodeAt(0),y=this._value.charCodeAt(this._pos);return b-y}value(){return this._value[this._pos]}}e.StringIterator=s;class _{constructor(d=!0){this._caseSensitive=d}reset(d){return this._value=d,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let d=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(d)this._from++;else break;else d=!1;return this}cmp(d){return this._caseSensitive?(0,L.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class M{constructor(d=!0,b=!0){this._splitOnBackslash=d,this._caseSensitive=b}reset(d){this._from=0,this._to=0,this._value=d,this._valueLen=d.length;for(let b=d.length-1;b>=0;b--,this._valueLen--){const y=this._value.charCodeAt(b);if(!(y===47||this._splitOnBackslash&&y===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let d=!0;for(;this._to<this._valueLen;this._to++){const b=this._value.charCodeAt(this._to);if(b===47||this._splitOnBackslash&&b===92)if(d)this._from++;else break;else d=!1}return this}cmp(d){return this._caseSensitive?(0,L.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=M;var I;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(I||(I={}));class h{constructor(d,b){this._ignorePathCasing=d,this._ignoreQueryAndFragment=b,this._states=[],this._stateIdx=0}reset(d){return this._value=d,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new M(!1,!this._ignorePathCasing(d)),this._pathIterator.reset(d.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(d)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(d){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(d,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(d,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(d);if(this._states[this._stateIdx]===4)return(0,L.compare)(d,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(d,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(m||(m={}));class f{static forUris(d=()=>!1,b=()=>!1){return new f(new h(d,b))}static forPaths(d=!1){return new f(new M(void 0,!d))}static forStrings(){return new f(new s)}static forConfigKeys(){return new f(new _)}constructor(d){this._iter=d}clear(){this._root=void 0}fill(d,b){if(b){const y=b.slice(0);(0,P.shuffle)(y);for(const o of y)this.set(o,d)}else{const y=d.slice(0);(0,P.shuffle)(y);for(const o of y)this.set(o[0],o[1])}}set(d,b){const y=this._iter.reset(d);let o;this._root||(this._root=new c,this._root.segment=y.value());const g=[];for(o=this._root;;){const v=y.cmp(o.segment);if(v>0)o.left||(o.left=new c,o.left.segment=y.value()),g.push([-1,o]),o=o.left;else if(v<0)o.right||(o.right=new c,o.right.segment=y.value()),g.push([1,o]),o=o.right;else if(y.hasNext())y.next(),o.mid||(o.mid=new c,o.mid.segment=y.value()),g.push([0,o]),o=o.mid;else break}const l=o.value;o.value=b,o.key=d;for(let v=g.length-1;v>=0;v--){const E=g[v][1];E.updateHeight();const S=E.balanceFactor();if(S<-1||S>1){const t=g[v][0],u=g[v+1][0];if(t===1&&u===1)g[v][1]=E.rotateLeft();else if(t===-1&&u===-1)g[v][1]=E.rotateRight();else if(t===1&&u===-1)E.right=g[v+1][1]=g[v+1][1].rotateRight(),g[v][1]=E.rotateLeft();else if(t===-1&&u===1)E.left=g[v+1][1]=g[v+1][1].rotateLeft(),g[v][1]=E.rotateRight();else throw new Error;if(v>0)switch(g[v-1][0]){case-1:g[v-1][1].left=g[v][1];break;case 1:g[v-1][1].right=g[v][1];break;case 0:g[v-1][1].mid=g[v][1];break}else this._root=g[0][1]}}return l}get(d){return this._getNode(d)?.value}_getNode(d){const b=this._iter.reset(d);let y=this._root;for(;y;){const o=b.cmp(y.segment);if(o>0)y=y.left;else if(o<0)y=y.right;else if(b.hasNext())b.next(),y=y.mid;else break}return y}has(d){const b=this._getNode(d);return!(b?.value===void 0&&b?.mid===void 0)}delete(d){return this._delete(d,!1)}deleteSuperstr(d){return this._delete(d,!0)}_delete(d,b){const y=this._iter.reset(d),o=[];let g=this._root;for(;g;){const l=y.cmp(g.segment);if(l>0)o.push([-1,g]),g=g.left;else if(l<0)o.push([1,g]),g=g.right;else if(y.hasNext())y.next(),o.push([0,g]),g=g.mid;else break}if(g){if(b?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const l=this._min(g.right);if(l.key){const{key:v,value:E,segment:S}=l;this._delete(l.key,!1),g.key=v,g.value=E,g.segment=S}}else{const l=g.left??g.right;if(o.length>0){const[v,E]=o[o.length-1];switch(v){case-1:E.left=l;break;case 0:E.mid=l;break;case 1:E.right=l;break}}else this._root=l}for(let l=o.length-1;l>=0;l--){const v=o[l][1];v.updateHeight();const E=v.balanceFactor();if(E>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),o[l][1]=v.rotateLeft()):E<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),o[l][1]=v.rotateRight()),l>0)switch(o[l-1][0]){case-1:o[l-1][1].left=o[l][1];break;case 1:o[l-1][1].right=o[l][1];break;case 0:o[l-1][1].mid=o[l][1];break}else this._root=o[0][1]}}}_min(d){for(;d.left;)d=d.left;return d}findSubstr(d){const b=this._iter.reset(d);let y=this._root,o;for(;y;){const g=b.cmp(y.segment);if(g>0)y=y.left;else if(g<0)y=y.right;else if(b.hasNext())b.next(),o=y.value||o,y=y.mid;else break}return y&&y.value||o}findSuperstr(d){return this._findSuperstrOrElement(d,!1)}_findSuperstrOrElement(d,b){const y=this._iter.reset(d);let o=this._root;for(;o;){const g=y.cmp(o.segment);if(g>0)o=o.left;else if(g<0)o=o.right;else if(y.hasNext())y.next(),o=o.mid;else return o.mid?this._entries(o.mid):b?o.value:void 0}}hasElementOrSubtree(d){return this._findSuperstrOrElement(d,!0)!==void 0}forEach(d){for(const[b,y]of this)d(y,b)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(d){const b=[];return this._dfsEntries(d,b),b[Symbol.iterator]()}_dfsEntries(d,b){d&&(d.left&&this._dfsEntries(d.left,b),d.value&&b.push([d.key,d.value]),d.mid&&this._dfsEntries(d.mid,b),d.right&&this._dfsEntries(d.right,b))}_isBalanced(){const d=b=>{if(!b)return!0;const y=b.balanceFactor();return y<-1||y>1?!1:d(b.left)&&d(b.right)};return d(this._root)}}e.TernarySearchTree=f}),define(te[10],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function P(u){return typeof u=="string"}e.isString=P;function L(u){return Array.isArray(u)&&u.every(r=>P(r))}e.isStringArray=L;function s(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=s;function _(u){const r=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof r}e.isTypedArray=_;function M(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=M;function I(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=I;function h(u){return u===!0||u===!1}e.isBoolean=h;function c(u){return typeof u>"u"}e.isUndefined=c;function m(u){return!f(u)}e.isDefined=m;function f(u){return c(u)||u===null}e.isUndefinedOrNull=f;function w(u,r){if(!u)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=w;function d(u){if(f(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=d;function b(...u){const r=[];for(let n=0;n<u.length;n++){const i=u[n];if(f(i))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);r.push(i)}return r}e.assertAllDefined=b;const y=Object.prototype.hasOwnProperty;function o(u){if(!s(u))return!1;for(const r in u)if(y.call(u,r))return!1;return!0}e.isEmptyObject=o;function g(u){return typeof u=="function"}e.isFunction=g;function l(...u){return u.length>0&&u.every(g)}e.areFunctions=l;function v(u,r){const n=Math.min(u.length,r.length);for(let i=0;i<n;i++)E(u[i],r[i])}e.validateConstraints=v;function E(u,r){if(P(r)){if(typeof u!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(g(r)){try{if(u instanceof r)return}catch{}if(!f(u)&&u.constructor===r||r.length===1&&r.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E;function S(u){return u===null?void 0:u}e.withNullAsUndefined=S;function t(u){return typeof u>"u"?null:u}e.withUndefinedAsNull=t}),define(te[71],ie([0,1,10]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function s(I,h){if((0,P.isString)(h)){const c=L[h];if(c===void 0)throw new Error(`${I} references an unknown codicon: ${h}`);h=c}return L[I]=h,{id:I}}function _(){return L}e.getCodiconFontCharacters=_;function M(){return Object.values(e.Codicon)}e.getAllCodicons=M,e.Codicon={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package_:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(te[37],ie([0,1,10]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const l=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([v,E])=>{l[v]=E&&typeof E=="object"?L(E):E}),l}e.deepClone=L;function s(g){if(!g||typeof g!="object")return g;const l=[g];for(;l.length>0;){const v=l.shift();Object.freeze(v);for(const E in v)if(_.call(v,E)){const S=v[E];typeof S=="object"&&!Object.isFrozen(S)&&!(0,P.isTypedArray)(S)&&l.push(S)}}return g}e.deepFreeze=s;const _=Object.prototype.hasOwnProperty;function M(g,l){return I(g,l,new Set)}e.cloneAndChange=M;function I(g,l,v){if((0,P.isUndefinedOrNull)(g))return g;const E=l(g);if(typeof E<"u")return E;if(Array.isArray(g)){const S=[];for(const t of g)S.push(I(t,l,v));return S}if((0,P.isObject)(g)){if(v.has(g))throw new Error("Cannot clone recursive data-structure");v.add(g);const S={};for(const t in g)_.call(g,t)&&(S[t]=I(g[t],l,v));return v.delete(g),S}return g}function h(g,l,v=!0){return(0,P.isObject)(g)?((0,P.isObject)(l)&&Object.keys(l).forEach(E=>{E in g?v&&((0,P.isObject)(g[E])&&(0,P.isObject)(l[E])?h(g[E],l[E],v):g[E]=l[E]):g[E]=l[E]}),g):l}e.mixin=h;function c(g,l){if(g===l)return!0;if(g==null||l===null||l===void 0||typeof g!=typeof l||typeof g!="object"||Array.isArray(g)!==Array.isArray(l))return!1;let v,E;if(Array.isArray(g)){if(g.length!==l.length)return!1;for(v=0;v<g.length;v++)if(!c(g[v],l[v]))return!1}else{const S=[];for(E in g)S.push(E);S.sort();const t=[];for(E in l)t.push(E);if(t.sort(),!c(S,t))return!1;for(v=0;v<S.length;v++)if(!c(g[S[v]],l[S[v]]))return!1}return!0}e.equals=c;function m(g){const l=new Set;return JSON.stringify(g,(v,E)=>{if((0,P.isObject)(E)||Array.isArray(E)){if(l.has(E))return"[Circular]";l.add(E)}return E})}e.safeStringify=m;function f(g,l){const v=Object.create(null);return!g||!l||Object.keys(l).forEach(S=>{const t=g[S],u=l[S];c(t,u)||(v[S]=u)}),v}e.distinct=f;function w(g,l){const v=l.toLowerCase(),E=Object.keys(g).find(S=>S.toLowerCase()===v);return E?g[E]:g[l]}e.getCaseInsensitive=w;function d(g,l){const v=Object.create(null);for(const[E,S]of Object.entries(g))l(E,S)&&(v[E]=S);return v}e.filter=d;function b(g){let l=[];for(;Object.prototype!==g;)l=l.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return l}e.getAllPropertyNames=b;function y(g){const l=[];for(const v of b(g))typeof g[v]=="function"&&l.push(v);return l}e.getAllMethodNames=y;function o(g,l){const v=S=>function(){const t=Array.prototype.slice.call(arguments,0);return l(S,t)},E={};for(const S of g)E[S]=v(S);return E}e.createProxyObject=o}),define(te[102],ie([0,1,71]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(M){function I(h){return h&&typeof h=="object"&&typeof h.id=="string"}M.isThemeColor=I})(L||(e.ThemeColor=L={}));function s(M){return{id:M}}e.themeColorFromId=s;var _;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function h(l){const v=I.exec(l.id);if(!v)return h(P.Codicon.error);const[,E,S]=v,t=["codicon","codicon-"+E];return S&&t.push("codicon-modifier-"+S.substring(1)),t}M.asClassNameArray=h;function c(l){return h(l).join(" ")}M.asClassName=c;function m(l){return"."+h(l).join(".")}M.asCSSSelector=m;function f(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||L.isThemeColor(l.color))}M.isThemeIcon=f;const w=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function d(l){const v=w.exec(l);if(!v)return;const[,E]=v;return{id:E}}M.fromString=d;function b(l){return{id:l}}M.fromId=b;function y(l,v){let E=l.id;const S=E.lastIndexOf("~");return S!==-1&&(E=E.substring(0,S)),v&&(E=`${E}~${v}`),{id:E}}M.modify=y;function o(l){const v=l.id.lastIndexOf("~");if(v!==-1)return l.id.substring(v+1)}M.getModifier=o;function g(l,v){return l.id===v.id&&l.color?.id===v.color?.id}M.isEqual=g})(_||(e.ThemeIcon=_={}))}),define(te[31],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(s){return P.test(s)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(I){for(let h=0;h<I.length;h++)I[h]=Math.floor(Math.random()*256);return I};const _=new Uint8Array(16),M=[];for(let I=0;I<256;I++)M.push(I.toString(16).padStart(2,"0"));return function(){s(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let h=0,c="";return c+=M[_[h++]],c+=M[_[h++]],c+=M[_[h++]],c+=M[_[h++]],c+="-",c+=M[_[h++]],c+=M[_[h++]],c+="-",c+=M[_[h++]],c+=M[_[h++]],c+="-",c+=M[_[h++]],c+=M[_[h++]],c+="-",c+=M[_[h++]],c+=M[_[h++]],c+=M[_[h++]],c+=M[_[h++]],c+=M[_[h++]],c+=M[_[h++]],c}}()}),define(te[142],ie([0,1,72,42,49]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function _(M,I){if(await new Promise((m,f)=>{const w=L.createReadStream(M),d=P.createHash("sha1");w.pipe(d);const b=(0,s.once)((y,o)=>{w.removeAllListeners(),d.removeAllListeners(),y?f(y):m(o)});w.once("error",b),w.once("end",b),d.once("error",b),d.once("data",y=>b(void 0,y.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=_}),define(te[143],ie([0,1,27]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(M){const I=M.replace(/\-/g,":").toLowerCase();return!L.has(I)}function _(){const M=(0,P.networkInterfaces)();for(const I in M){const h=M[I];if(h){for(const{mac:c}of h)if(s(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=_}),define(te[87],ie([0,1,27,58,31,143]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(c){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(c)}value(){if(this._value===void 0){let c=0,m=0;const f=(0,P.networkInterfaces)();for(const w in f){const d=f[w];if(d)for(const{mac:b,internal:y}of d)y||(m+=1,this._isVirtualMachineMacAddress(b.toUpperCase())&&(c+=1))}this._value=m>0?c/m:0}return this._value}};let M;async function I(c){return M||(M=(async()=>await h(c)||s.generateUuid())()),M}e.getMachineId=I;async function h(c){try{const m=await new Promise((w,d)=>{j(["crypto"],w,d)}),f=(0,_.getMac)();return m.createHash("sha256").update(f,"utf8").digest("hex")}catch(m){c(m);return}}}),define(te[103],ie([0,1,88]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(I,h,c,m=1){let f=!1;return new Promise(w=>{const d=setTimeout(()=>{if(!f)return f=!0,w(0)},c);s(I,h,m,b=>{if(!f)return f=!0,clearTimeout(d),w(b)})})}e.findFreePort=L;function s(I,h,c,m){if(h===0)return m(0);const f=new P.Socket;f.once("connect",()=>(M(f),s(I+c,h-1,c,m))),f.once("data",()=>{}),f.once("error",w=>(M(f),w.code!=="ECONNREFUSED"?s(I+c,h-1,c,m):m(I))),f.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function _(I,h,c,m="127.0.0.1"){let f=!1,w,d=1;const b=P.createServer({pauseOnConnect:!0});function y(o,g){f||(f=!0,b.removeAllListeners(),b.close(),w&&clearTimeout(w),g(o))}return new Promise(o=>{w=setTimeout(()=>{y(0,o)},c),b.on("listening",()=>{y(I,o)}),b.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&d<h?(I++,d++,b.listen(I,m)):y(0,o)}),b.on("close",()=>{y(0,o)}),b.listen(I,m)})}e.findFreePortFaster=_;function M(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(h){console.error(h)}}}),function(){function j(){function e(){return process.uncHostAllowlist}function P(h){const c=new Set;if(Array.isArray(h))for(const m of h)typeof m=="string"&&c.add(m);return Array.from(c)}function L(){const h=e();return h?Array.from(h):[]}function s(h){if(process.platform!=="win32")return;const c=e();if(c)if(typeof h=="string")c.add(h.toLowerCase());else for(const m of P(h))s(m)}function _(h){if(typeof h!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const f of c){if(h.indexOf(f)!==0)continue;const d=h.indexOf("\\",f.length);if(d===-1)continue;const b=h.substring(f.length,d);if(b){m=b;break}}return m}function M(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:L,addUNCHostToAllowlist:s,getUNCHost:_,disableUNCAccessRestrictions:M,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return j()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=j():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(te[144],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(te[145],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class P{constructor(s,_){this.sender=s,this.onMessage=_}send(s){try{this.sender.send("vscode:message",s.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=P}),define(te[38],ie([0,1,14,13]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class s{constructor(){this.mapListenerToWrapper=new WeakMap}on(M,I){const h=(c,...m)=>{this.validateEvent(M,c)&&I(c,...m)};return this.mapListenerToWrapper.set(I,h),P.ipcMain.on(M,h),this}once(M,I){return P.ipcMain.once(M,(h,...c)=>{this.validateEvent(M,h)&&I(h,...c)}),this}handle(M,I){return P.ipcMain.handle(M,(h,...c)=>this.validateEvent(M,h)?I(h,...c):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return P.ipcMain.removeHandler(M),this}removeListener(M,I){const h=this.mapListenerToWrapper.get(I);return h&&(P.ipcMain.removeListener(M,h),this.mapListenerToWrapper.delete(I)),this}validateEvent(M,I){if(!M||!M.startsWith("vscode:"))return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const h=I.senderFrame,c=h.url;if(!c)return!0;let m="unknown";try{m=new URL(c).host}catch{return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${c}'.`),!1}return m!=="vscode-app"?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${m}'.`),!1):h.parent!==null?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${m}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new s}),define(te[146],ie([0,1,14,38,10,144]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){L.validatedIpcMain.on(_.CONTEXT_MENU_CHANNEL,(h,c,m,f,w)=>{const d=I(h,f,m);d.popup({window:(0,s.withNullAsUndefined)(P.BrowserWindow.fromWebContents(h.sender)),x:w?w.x:void 0,y:w?w.y:void 0,positioningItem:w?w.positioningItem:void 0,callback:()=>{d&&h.sender.send(_.CONTEXT_MENU_CLOSE_CHANNEL,c)}})})}e.registerContextMenuListener=M;function I(h,c,m){const f=new P.Menu;return m.forEach(w=>{let d;w.type==="separator"?d=new P.MenuItem({type:w.type}):Array.isArray(w.submenu)?d=new P.MenuItem({submenu:I(h,c,w.submenu),label:w.label}):d=new P.MenuItem({label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:w.enabled,visible:w.visible,click:(b,y,o)=>h.sender.send(c,w.id,o)}),f.append(d)}),f}}),define(te[147],ie([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(te[148],ie([0,1,147]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,s=L*60,_=s*24,M=_*7,I=_*30,h=_*365;function c(f,w,d,b){typeof f!="number"&&(f=f.getTime());const y=Math.round((new Date().getTime()-f)/1e3);if(y<-30)return(0,P.localize)(0,null,c(new Date().getTime()+y*1e3,!1));if(!b&&y<30)return(0,P.localize)(1,null);let o;return y<L?(o=y,w?o===1?d?(0,P.localize)(2,null,o):(0,P.localize)(3,null,o):d?(0,P.localize)(4,null,o):(0,P.localize)(5,null,o):o===1?d?(0,P.localize)(6,null,o):(0,P.localize)(7,null,o):d?(0,P.localize)(8,null,o):(0,P.localize)(9,null,o)):y<s?(o=Math.floor(y/L),w?o===1?d?(0,P.localize)(10,null,o):(0,P.localize)(11,null,o):d?(0,P.localize)(12,null,o):(0,P.localize)(13,null,o):o===1?d?(0,P.localize)(14,null,o):(0,P.localize)(15,null,o):d?(0,P.localize)(16,null,o):(0,P.localize)(17,null,o)):y<_?(o=Math.floor(y/s),w?o===1?d?(0,P.localize)(18,null,o):(0,P.localize)(19,null,o):d?(0,P.localize)(20,null,o):(0,P.localize)(21,null,o):o===1?d?(0,P.localize)(22,null,o):(0,P.localize)(23,null,o):d?(0,P.localize)(24,null,o):(0,P.localize)(25,null,o)):y<M?(o=Math.floor(y/_),w?o===1?(0,P.localize)(26,null,o):(0,P.localize)(27,null,o):o===1?(0,P.localize)(28,null,o):(0,P.localize)(29,null,o)):y<I?(o=Math.floor(y/M),w?o===1?d?(0,P.localize)(30,null,o):(0,P.localize)(31,null,o):d?(0,P.localize)(32,null,o):(0,P.localize)(33,null,o):o===1?d?(0,P.localize)(34,null,o):(0,P.localize)(35,null,o):d?(0,P.localize)(36,null,o):(0,P.localize)(37,null,o)):y<h?(o=Math.floor(y/I),w?o===1?d?(0,P.localize)(38,null,o):(0,P.localize)(39,null,o):d?(0,P.localize)(40,null,o):(0,P.localize)(41,null,o):o===1?d?(0,P.localize)(42,null,o):(0,P.localize)(43,null,o):d?(0,P.localize)(44,null,o):(0,P.localize)(45,null,o)):(o=Math.floor(y/h),w?o===1?d?(0,P.localize)(46,null,o):(0,P.localize)(47,null,o):d?(0,P.localize)(48,null,o):(0,P.localize)(49,null,o):o===1?d?(0,P.localize)(50,null,o):(0,P.localize)(51,null,o):d?(0,P.localize)(52,null,o):(0,P.localize)(53,null,o))}e.fromNow=c;function m(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=m}),define(te[149],ie([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(te[50],ie([0,1,24,10,149]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function _(f,w){return w&&(f.stack||f.stacktrace)?s.localize(0,null,I(f),M(f.stack)||M(f.stacktrace)):I(f)}function M(f){return Array.isArray(f)?f.join(`
`):f}function I(f){return f.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${f.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?s.localize(1,null,f.message):f.message||s.localize(2,null)}function h(f=null,w=!1){if(!f)return s.localize(3,null);if(Array.isArray(f)){const d=P.coalesce(f),b=h(d[0],w);return d.length>1?s.localize(4,null,b,d.length):b}if(L.isString(f))return f;if(f.detail){const d=f.detail;if(d.error)return _(d.error,w);if(d.exception)return _(d.exception,w)}return f.stack?_(f,w):f.message?f.message:s.localize(5,null)}e.toErrorMessage=h;function c(f){const w=f;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=c;function m(f,w){let d;return typeof f=="string"?d=new Error(f):d=f,d.actions=w,d}e.createErrorWithActions=m}),define(te[150],ie([12,11]),function(j,e){return j.create("vs/base/common/jsonErrorMessages",e)}),define(te[151],ie([0,1,150]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(s){switch(s){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(te[152],ie([12,11]),function(j,e){return j.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,152]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,s=!1,_=!1,M=!1,I=!1,h=!1,c=!1,m=!1,f=!1,w=!1,d,b=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT,o,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?l=e.globals.vscode.process:typeof process<"u"&&(l=process);const v=typeof l?.versions?.electron=="string",E=v&&l?.type==="renderer";if(typeof navigator=="object"&&!E)g=navigator.userAgent,L=g.indexOf("Windows")>=0,s=g.indexOf("Macintosh")>=0,m=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=g.indexOf("Linux")>=0,w=g?.indexOf("Mobi")>=0,h=!0,d=P.getConfiguredDefaultLocale(P.localize(0,null))||e.LANGUAGE_DEFAULT,b=d,y=navigator.language;else if(typeof l=="object"){L=l.platform==="win32",s=l.platform==="darwin",_=l.platform==="linux",M=_&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,c=v,f=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,b=e.LANGUAGE_DEFAULT;const C=l.env.VSCODE_NLS_CONFIG;if(C)try{const k=JSON.parse(C),D=k.availableLanguages["*"];d=k.locale,y=k.osLocale,b=D||e.LANGUAGE_DEFAULT,o=k._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var S;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(S||(e.Platform=S={}));function t(C){switch(C){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let u=0;s?u=1:L?u=3:_&&(u=2),e.isWindows=L,e.isMacintosh=s,e.isLinux=_,e.isLinuxSnap=M,e.isNative=I,e.isElectron=c,e.isWeb=h,e.isWebWorker=h&&typeof e.globals.importScripts=="function",e.isIOS=m,e.isMobile=w,e.isCI=f,e.platform=u,e.userAgent=g,e.language=b;var r;(function(C){function k(){return e.language}C.value=k;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}C.isDefaultVariant=D;function A(){return e.language==="en"}C.isDefault=A})(r||(e.Language=r={})),e.locale=d,e.platformLocale=y,e.translationsConfigFile=o,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const C=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let A=0,O=C.length;A<O;A++){const U=C[A];if(U.id===D.data.vscodeScheduleAsyncWork){C.splice(A,1),U.callback();return}}});let k=0;return D=>{const A=++k;C.push({id:A,callback:D}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return C=>setTimeout(C)})();var n;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=s||m?2:L?1:3;let i=!0,a=!1;function p(){if(!a){a=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,i=new Uint16Array(C.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=p,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[36],ie([0,1,4]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof P.globals.vscode<"u"&&typeof P.globals.vscode.process<"u"){const s=P.globals.vscode.process;L={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(te[9],ie([0,1,36]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,s=97,_=90,M=122,I=46,h=47,c=92,m=58,f=63;class w extends Error{constructor(u,r,n){let i;typeof r=="string"&&r.indexOf("not ")===0?(i="must not be",r=r.replace(/^not /,"")):i="must be";const a=u.indexOf(".")!==-1?"property":"argument";let p=`The "${u}" ${a} ${i} of type ${r}`;p+=`. Received type ${typeof n}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function d(t,u){if(t===null||typeof t!="object")throw new w(u,"Object",t)}function b(t,u){if(typeof t!="string")throw new w(u,"string",t)}const y=P.platform==="win32";function o(t){return t===h||t===c}function g(t){return t===h}function l(t){return t>=L&&t<=_||t>=s&&t<=M}function v(t,u,r,n){let i="",a=0,p=-1,C=0,k=0;for(let D=0;D<=t.length;++D){if(D<t.length)k=t.charCodeAt(D);else{if(n(k))break;k=h}if(n(k)){if(!(p===D-1||C===1))if(C===2){if(i.length<2||a!==2||i.charCodeAt(i.length-1)!==I||i.charCodeAt(i.length-2)!==I){if(i.length>2){const A=i.lastIndexOf(r);A===-1?(i="",a=0):(i=i.slice(0,A),a=i.length-1-i.lastIndexOf(r)),p=D,C=0;continue}else if(i.length!==0){i="",a=0,p=D,C=0;continue}}u&&(i+=i.length>0?`${r}..`:"..",a=2)}else i.length>0?i+=`${r}${t.slice(p+1,D)}`:i=t.slice(p+1,D),a=D-p-1;p=D,C=0}else k===I&&C!==-1?++C:C=-1}return i}function E(t,u){d(u,"pathObject");const r=u.dir||u.root,n=u.base||`${u.name||""}${u.ext||""}`;return r?r===u.root?`${r}${n}`:`${r}${t}${n}`:n}e.win32={resolve(...t){let u="",r="",n=!1;for(let i=t.length-1;i>=-1;i--){let a;if(i>=0){if(a=t[i],b(a,"path"),a.length===0)continue}else u.length===0?a=P.cwd():(a=P.env[`=${u}`]||P.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==u.toLowerCase()&&a.charCodeAt(2)===c)&&(a=`${u}\\`));const p=a.length;let C=0,k="",D=!1;const A=a.charCodeAt(0);if(p===1)o(A)&&(C=1,D=!0);else if(o(A))if(D=!0,o(a.charCodeAt(1))){let O=2,U=O;for(;O<p&&!o(a.charCodeAt(O));)O++;if(O<p&&O!==U){const q=a.slice(U,O);for(U=O;O<p&&o(a.charCodeAt(O));)O++;if(O<p&&O!==U){for(U=O;O<p&&!o(a.charCodeAt(O));)O++;(O===p||O!==U)&&(k=`\\\\${q}\\${a.slice(U,O)}`,C=O)}}}else C=1;else l(A)&&a.charCodeAt(1)===m&&(k=a.slice(0,2),C=2,p>2&&o(a.charCodeAt(2))&&(D=!0,C=3));if(k.length>0)if(u.length>0){if(k.toLowerCase()!==u.toLowerCase())continue}else u=k;if(n){if(u.length>0)break}else if(r=`${a.slice(C)}\\${r}`,n=D,D&&u.length>0)break}return r=v(r,!n,"\\",o),n?`${u}\\${r}`:`${u}${r}`||"."},normalize(t){b(t,"path");const u=t.length;if(u===0)return".";let r=0,n,i=!1;const a=t.charCodeAt(0);if(u===1)return g(a)?"\\":t;if(o(a))if(i=!0,o(t.charCodeAt(1))){let C=2,k=C;for(;C<u&&!o(t.charCodeAt(C));)C++;if(C<u&&C!==k){const D=t.slice(k,C);for(k=C;C<u&&o(t.charCodeAt(C));)C++;if(C<u&&C!==k){for(k=C;C<u&&!o(t.charCodeAt(C));)C++;if(C===u)return`\\\\${D}\\${t.slice(k)}\\`;C!==k&&(n=`\\\\${D}\\${t.slice(k,C)}`,r=C)}}}else r=1;else l(a)&&t.charCodeAt(1)===m&&(n=t.slice(0,2),r=2,u>2&&o(t.charCodeAt(2))&&(i=!0,r=3));let p=r<u?v(t.slice(r),!i,"\\",o):"";return p.length===0&&!i&&(p="."),p.length>0&&o(t.charCodeAt(u-1))&&(p+="\\"),n===void 0?i?`\\${p}`:p:i?`${n}\\${p}`:`${n}${p}`},isAbsolute(t){b(t,"path");const u=t.length;if(u===0)return!1;const r=t.charCodeAt(0);return o(r)||u>2&&l(r)&&t.charCodeAt(1)===m&&o(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let u,r;for(let a=0;a<t.length;++a){const p=t[a];b(p,"path"),p.length>0&&(u===void 0?u=r=p:u+=`\\${p}`)}if(u===void 0)return".";let n=!0,i=0;if(typeof r=="string"&&o(r.charCodeAt(0))){++i;const a=r.length;a>1&&o(r.charCodeAt(1))&&(++i,a>2&&(o(r.charCodeAt(2))?++i:n=!1))}if(n){for(;i<u.length&&o(u.charCodeAt(i));)i++;i>=2&&(u=`\\${u.slice(i)}`)}return e.win32.normalize(u)},relative(t,u){if(b(t,"from"),b(u,"to"),t===u)return"";const r=e.win32.resolve(t),n=e.win32.resolve(u);if(r===n||(t=r.toLowerCase(),u=n.toLowerCase(),t===u))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===c;)i++;let a=t.length;for(;a-1>i&&t.charCodeAt(a-1)===c;)a--;const p=a-i;let C=0;for(;C<u.length&&u.charCodeAt(C)===c;)C++;let k=u.length;for(;k-1>C&&u.charCodeAt(k-1)===c;)k--;const D=k-C,A=p<D?p:D;let O=-1,U=0;for(;U<A;U++){const se=t.charCodeAt(i+U);if(se!==u.charCodeAt(C+U))break;se===c&&(O=U)}if(U!==A){if(O===-1)return n}else{if(D>A){if(u.charCodeAt(C+U)===c)return n.slice(C+U+1);if(U===2)return n.slice(C+U)}p>A&&(t.charCodeAt(i+U)===c?O=U:U===2&&(O=3)),O===-1&&(O=0)}let q="";for(U=i+O+1;U<=a;++U)(U===a||t.charCodeAt(U)===c)&&(q+=q.length===0?"..":"\\..");return C+=O,q.length>0?`${q}${n.slice(C,k)}`:(n.charCodeAt(C)===c&&++C,n.slice(C,k))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const u=e.win32.resolve(t);if(u.length<=2)return t;if(u.charCodeAt(0)===c){if(u.charCodeAt(1)===c){const r=u.charCodeAt(2);if(r!==f&&r!==I)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(l(u.charCodeAt(0))&&u.charCodeAt(1)===m&&u.charCodeAt(2)===c)return`\\\\?\\${u}`;return t},dirname(t){b(t,"path");const u=t.length;if(u===0)return".";let r=-1,n=0;const i=t.charCodeAt(0);if(u===1)return o(i)?t:".";if(o(i)){if(r=n=1,o(t.charCodeAt(1))){let C=2,k=C;for(;C<u&&!o(t.charCodeAt(C));)C++;if(C<u&&C!==k){for(k=C;C<u&&o(t.charCodeAt(C));)C++;if(C<u&&C!==k){for(k=C;C<u&&!o(t.charCodeAt(C));)C++;if(C===u)return t;C!==k&&(r=n=C+1)}}}}else l(i)&&t.charCodeAt(1)===m&&(r=u>2&&o(t.charCodeAt(2))?3:2,n=r);let a=-1,p=!0;for(let C=u-1;C>=n;--C)if(o(t.charCodeAt(C))){if(!p){a=C;break}}else p=!1;if(a===-1){if(r===-1)return".";a=r}return t.slice(0,a)},basename(t,u){u!==void 0&&b(u,"ext"),b(t,"path");let r=0,n=-1,i=!0,a;if(t.length>=2&&l(t.charCodeAt(0))&&t.charCodeAt(1)===m&&(r=2),u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let p=u.length-1,C=-1;for(a=t.length-1;a>=r;--a){const k=t.charCodeAt(a);if(o(k)){if(!i){r=a+1;break}}else C===-1&&(i=!1,C=a+1),p>=0&&(k===u.charCodeAt(p)?--p===-1&&(n=a):(p=-1,n=C))}return r===n?n=C:n===-1&&(n=t.length),t.slice(r,n)}for(a=t.length-1;a>=r;--a)if(o(t.charCodeAt(a))){if(!i){r=a+1;break}}else n===-1&&(i=!1,n=a+1);return n===-1?"":t.slice(r,n)},extname(t){b(t,"path");let u=0,r=-1,n=0,i=-1,a=!0,p=0;t.length>=2&&t.charCodeAt(1)===m&&l(t.charCodeAt(0))&&(u=n=2);for(let C=t.length-1;C>=u;--C){const k=t.charCodeAt(C);if(o(k)){if(!a){n=C+1;break}continue}i===-1&&(a=!1,i=C+1),k===I?r===-1?r=C:p!==1&&(p=1):r!==-1&&(p=-1)}return r===-1||i===-1||p===0||p===1&&r===i-1&&r===n+1?"":t.slice(r,i)},format:E.bind(null,"\\"),parse(t){b(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const r=t.length;let n=0,i=t.charCodeAt(0);if(r===1)return o(i)?(u.root=u.dir=t,u):(u.base=u.name=t,u);if(o(i)){if(n=1,o(t.charCodeAt(1))){let O=2,U=O;for(;O<r&&!o(t.charCodeAt(O));)O++;if(O<r&&O!==U){for(U=O;O<r&&o(t.charCodeAt(O));)O++;if(O<r&&O!==U){for(U=O;O<r&&!o(t.charCodeAt(O));)O++;O===r?n=O:O!==U&&(n=O+1)}}}}else if(l(i)&&t.charCodeAt(1)===m){if(r<=2)return u.root=u.dir=t,u;if(n=2,o(t.charCodeAt(2))){if(r===3)return u.root=u.dir=t,u;n=3}}n>0&&(u.root=t.slice(0,n));let a=-1,p=n,C=-1,k=!0,D=t.length-1,A=0;for(;D>=n;--D){if(i=t.charCodeAt(D),o(i)){if(!k){p=D+1;break}continue}C===-1&&(k=!1,C=D+1),i===I?a===-1?a=D:A!==1&&(A=1):a!==-1&&(A=-1)}return C!==-1&&(a===-1||A===0||A===1&&a===C-1&&a===p+1?u.base=u.name=t.slice(p,C):(u.name=t.slice(p,a),u.base=t.slice(p,C),u.ext=t.slice(a,C))),p>0&&p!==n?u.dir=t.slice(0,p-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(y){const t=/\\/g;return()=>{const u=P.cwd().replace(t,"/");return u.slice(u.indexOf("/"))}}return()=>P.cwd()})();e.posix={resolve(...t){let u="",r=!1;for(let n=t.length-1;n>=-1&&!r;n--){const i=n>=0?t[n]:S();b(i,"path"),i.length!==0&&(u=`${i}/${u}`,r=i.charCodeAt(0)===h)}return u=v(u,!r,"/",g),r?`/${u}`:u.length>0?u:"."},normalize(t){if(b(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===h,r=t.charCodeAt(t.length-1)===h;return t=v(t,!u,"/",g),t.length===0?u?"/":r?"./":".":(r&&(t+="/"),u?`/${t}`:t)},isAbsolute(t){return b(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let u;for(let r=0;r<t.length;++r){const n=t[r];b(n,"path"),n.length>0&&(u===void 0?u=n:u+=`/${n}`)}return u===void 0?".":e.posix.normalize(u)},relative(t,u){if(b(t,"from"),b(u,"to"),t===u||(t=e.posix.resolve(t),u=e.posix.resolve(u),t===u))return"";const r=1,n=t.length,i=n-r,a=1,p=u.length-a,C=i<p?i:p;let k=-1,D=0;for(;D<C;D++){const O=t.charCodeAt(r+D);if(O!==u.charCodeAt(a+D))break;O===h&&(k=D)}if(D===C)if(p>C){if(u.charCodeAt(a+D)===h)return u.slice(a+D+1);if(D===0)return u.slice(a+D)}else i>C&&(t.charCodeAt(r+D)===h?k=D:D===0&&(k=0));let A="";for(D=r+k+1;D<=n;++D)(D===n||t.charCodeAt(D)===h)&&(A+=A.length===0?"..":"/..");return`${A}${u.slice(a+k)}`},toNamespacedPath(t){return t},dirname(t){if(b(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===h;let r=-1,n=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===h){if(!n){r=i;break}}else n=!1;return r===-1?u?"/":".":u&&r===1?"//":t.slice(0,r)},basename(t,u){u!==void 0&&b(u,"ext"),b(t,"path");let r=0,n=-1,i=!0,a;if(u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let p=u.length-1,C=-1;for(a=t.length-1;a>=0;--a){const k=t.charCodeAt(a);if(k===h){if(!i){r=a+1;break}}else C===-1&&(i=!1,C=a+1),p>=0&&(k===u.charCodeAt(p)?--p===-1&&(n=a):(p=-1,n=C))}return r===n?n=C:n===-1&&(n=t.length),t.slice(r,n)}for(a=t.length-1;a>=0;--a)if(t.charCodeAt(a)===h){if(!i){r=a+1;break}}else n===-1&&(i=!1,n=a+1);return n===-1?"":t.slice(r,n)},extname(t){b(t,"path");let u=-1,r=0,n=-1,i=!0,a=0;for(let p=t.length-1;p>=0;--p){const C=t.charCodeAt(p);if(C===h){if(!i){r=p+1;break}continue}n===-1&&(i=!1,n=p+1),C===I?u===-1?u=p:a!==1&&(a=1):u!==-1&&(a=-1)}return u===-1||n===-1||a===0||a===1&&u===n-1&&u===r+1?"":t.slice(u,n)},format:E.bind(null,"/"),parse(t){b(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const r=t.charCodeAt(0)===h;let n;r?(u.root="/",n=1):n=0;let i=-1,a=0,p=-1,C=!0,k=t.length-1,D=0;for(;k>=n;--k){const A=t.charCodeAt(k);if(A===h){if(!C){a=k+1;break}continue}p===-1&&(C=!1,p=k+1),A===I?i===-1?i=k:D!==1&&(D=1):i!==-1&&(D=-1)}if(p!==-1){const A=a===0&&r?1:a;i===-1||D===0||D===1&&i===p-1&&i===a+1?u.base=u.name=t.slice(A,p):(u.name=t.slice(A,i),u.base=t.slice(A,p),u.ext=t.slice(i,p))}return a>0?u.dir=t.slice(0,a-1):r&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y?e.win32.normalize:e.posix.normalize,e.isAbsolute=y?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y?e.win32.join:e.posix.join,e.resolve=y?e.win32.resolve:e.posix.resolve,e.relative=y?e.win32.relative:e.posix.relative,e.dirname=y?e.win32.dirname:e.posix.dirname,e.basename=y?e.win32.basename:e.posix.basename,e.extname=y?e.win32.extname:e.posix.extname,e.format=y?e.win32.format:e.posix.format,e.parse=y?e.win32.parse:e.posix.parse,e.toNamespacedPath=y?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y?e.win32.sep:e.posix.sep,e.delimiter=y?e.win32.delimiter:e.posix.delimiter}),define(te[32],ie([0,1,9,4,25,10]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(a){return a===47||a===92}e.isPathSeparator=M;function I(a){return a.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=I;function h(a){return a.indexOf("/")===-1&&(a=I(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=h;function c(a,p=P.posix.sep){if(!a)return"";const C=a.length,k=a.charCodeAt(0);if(M(k)){if(M(a.charCodeAt(1))&&!M(a.charCodeAt(2))){let A=3;const O=A;for(;A<C&&!M(a.charCodeAt(A));A++);if(O!==A&&!M(a.charCodeAt(A+1))){for(A+=1;A<C;A++)if(M(a.charCodeAt(A)))return a.slice(0,A+1).replace(/[\\/]/g,p)}}return p}else if(g(k)&&a.charCodeAt(1)===58)return M(a.charCodeAt(2))?a.slice(0,2)+p:a.slice(0,2);let D=a.indexOf("://");if(D!==-1){for(D+=3;D<C;D++)if(M(a.charCodeAt(D)))return a.slice(0,D+1)}return""}e.getRoot=c;function m(a){if(!L.isWindows||!a||a.length<5)return!1;let p=a.charCodeAt(0);if(p!==92||(p=a.charCodeAt(1),p!==92))return!1;let C=2;const k=C;for(;C<a.length&&(p=a.charCodeAt(C),p!==92);C++);return!(k===C||(p=a.charCodeAt(C+1),isNaN(p)||p===92))}e.isUNC=m;const f=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(a,p=L.isWindows){const C=p?f:w;return!(!a||a.length===0||/^\s+$/.test(a)||(C.lastIndex=0,C.test(a))||p&&d.test(a)||a==="."||a===".."||p&&a[a.length-1]==="."||p&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=b;function y(a,p,C){const k=a===p;return!C||k?k:!a||!p?!1:(0,s.equalsIgnoreCase)(a,p)}e.isEqual=y;function o(a,p,C,k=P.sep){if(a===p)return!0;if(!a||!p||p.length>a.length)return!1;if(C){if(!(0,s.startsWithIgnoreCase)(a,p))return!1;if(p.length===a.length)return!0;let A=p.length;return p.charAt(p.length-1)===k&&A--,a.charAt(A)===k}return p.charAt(p.length-1)!==k&&(p+=k),a.indexOf(p)===0}e.isEqualOrParent=o;function g(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=g;function l(a,p){return L.isWindows&&a.endsWith(":")&&(a+=P.sep),(0,P.isAbsolute)(a)||(a=(0,P.join)(p,a)),a=(0,P.normalize)(a),L.isWindows?(a=(0,s.rtrim)(a,P.sep),a.endsWith(":")&&(a+=P.sep)):(a=(0,s.rtrim)(a,P.sep),a||(a=P.sep)),a}e.sanitizeFilePath=l;function v(a){const p=(0,P.normalize)(a);return L.isWindows?a.length>3?!1:E(p)&&(a.length===2||p.charCodeAt(2)===92):p===P.posix.sep}e.isRootOrDriveLetter=v;function E(a,p=L.isWindows){return p?g(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function S(a,p=L.isWindows){return E(a,p)?a[0]:void 0}e.getDriveLetter=S;function t(a,p,C){return p.length>a.length?-1:a===p?0:(C&&(a=a.toLowerCase(),p=p.toLowerCase()),a.indexOf(p))}e.indexOfPath=t;function u(a){const p=a.split(":");let C,k,D;for(const A of p){const O=Number(A);(0,_.isNumber)(O)?k===void 0?k=O:D===void 0&&(D=O):C=C?[C,A].join(":"):A}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:k!==void 0?k:void 0,column:D!==void 0?D:k!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(a,p,C=8){let k="";for(let A=0;A<C;A++){let O;A===0&&L.isWindows&&!p&&(C===3||C===4)?O=n:O=r,k+=O.charAt(Math.floor(Math.random()*O.length))}let D;return p?D=`${p}-${k}`:D=k,a?(0,P.join)(a,D):D}e.randomPath=i}),define(te[73],ie([0,1,4]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(L||(e.Source=L={}));var s;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function _(I,...h){const c=h.reduce((w,d)=>(w[d]=!0,w),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(w=>!c[w]).forEach(w=>{for(let d=0;d<m.length;d++)if(w.search(m[d])!==-1){delete I[w];break}})}e.sanitizeProcessEnvironment=_;function M(I){I&&(delete I.DEBUG,P.isMacintosh&&delete I.DYLD_LIBRARY_PATH,P.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(te[7],ie([0,1,9,4]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,_=/^\//,M=/^\/\//;function I(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!s.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!_.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(n,i){return!n&&!i?"file":n}function c(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==f&&(i=f+i):i=f;break}return i}const m="",f="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(i){return i instanceof d?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,a,p,C,k,D=!1){typeof i=="object"?(this.scheme=i.scheme||m,this.authority=i.authority||m,this.path=i.path||m,this.query=i.query||m,this.fragment=i.fragment||m):(this.scheme=h(i,D),this.authority=a||m,this.path=c(this.scheme,p||m),this.query=C||m,this.fragment=k||m,I(this,D))}get fsPath(){return E(this,!1)}with(i){if(!i)return this;let{scheme:a,authority:p,path:C,query:k,fragment:D}=i;return a===void 0?a=this.scheme:a===null&&(a=m),p===void 0?p=this.authority:p===null&&(p=m),C===void 0?C=this.path:C===null&&(C=m),k===void 0?k=this.query:k===null&&(k=m),D===void 0?D=this.fragment:D===null&&(D=m),a===this.scheme&&p===this.authority&&C===this.path&&k===this.query&&D===this.fragment?this:new o(a,p,C,k,D)}static parse(i,a=!1){const p=w.exec(i);return p?new o(p[2]||m,r(p[4]||m),r(p[5]||m),r(p[7]||m),r(p[9]||m),a):new o(m,m,m,m,m)}static file(i){let a=m;if(L.isWindows&&(i=i.replace(/\\/g,f)),i[0]===f&&i[1]===f){const p=i.indexOf(f,2);p===-1?(a=i.substring(2),i=f):(a=i.substring(2,p),i=i.substring(p)||f)}return new o("file",a,i,m,m)}static from(i,a){return new o(i.scheme,i.authority,i.path,i.query,i.fragment,a)}static joinPath(i,...a){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return L.isWindows&&i.scheme==="file"?p=d.file(P.win32.join(E(i,!0),...a)).path:p=P.posix.join(i.path,...a),i.with({path:p})}toString(i=!1){return S(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof d)return i;{const a=new o(i);return a._formatted=i.external??null,a._fsPath=i._sep===y?i.fsPath??null:null,a}}else return i}}e.URI=d;function b(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.isUriComponents=b;const y=L.isWindows?1:void 0;class o extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(i=!1){return i?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=y),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(n,i,a){let p,C=-1;for(let k=0;k<n.length;k++){const D=n.charCodeAt(k);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||i&&D===47||a&&D===91||a&&D===93||a&&D===58)C!==-1&&(p+=encodeURIComponent(n.substring(C,k)),C=-1),p!==void 0&&(p+=n.charAt(k));else{p===void 0&&(p=n.substr(0,k));const A=g[D];A!==void 0?(C!==-1&&(p+=encodeURIComponent(n.substring(C,k)),C=-1),p+=A):C===-1&&(C=k)}}return C!==-1&&(p+=encodeURIComponent(n.substring(C))),p!==void 0?p:n}function v(n){let i;for(let a=0;a<n.length;a++){const p=n.charCodeAt(a);p===35||p===63?(i===void 0&&(i=n.substr(0,a)),i+=g[p]):i!==void 0&&(i+=n[a])}return i!==void 0?i:n}function E(n,i){let a;return n.authority&&n.path.length>1&&n.scheme==="file"?a=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?a=n.path.substr(1):a=n.path[1].toLowerCase()+n.path.substr(2):a=n.path,L.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=E;function S(n,i){const a=i?v:l;let p="",{scheme:C,authority:k,path:D,query:A,fragment:O}=n;if(C&&(p+=C,p+=":"),(k||C==="file")&&(p+=f,p+=f),k){let U=k.indexOf("@");if(U!==-1){const q=k.substr(0,U);k=k.substr(U+1),U=q.lastIndexOf(":"),U===-1?p+=a(q,!1,!1):(p+=a(q.substr(0,U),!1,!1),p+=":",p+=a(q.substr(U+1),!1,!0)),p+="@"}k=k.toLowerCase(),U=k.lastIndexOf(":"),U===-1?p+=a(k,!1,!0):(p+=a(k.substr(0,U),!1,!0),p+=k.substr(U))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const U=D.charCodeAt(1);U>=65&&U<=90&&(D=`/${String.fromCharCode(U+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const U=D.charCodeAt(0);U>=65&&U<=90&&(D=`${String.fromCharCode(U+32)}:${D.substr(2)}`)}p+=a(D,!0,!1)}return A&&(p+="?",p+=a(A,!1,!1)),O&&(p+="#",p+=i?O:l(O,!1,!1)),p}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(u)?n.replace(u,i=>t(i)):n}}),define(te[153],ie([0,1,7]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(c){const m=c;return m&&typeof m.type=="string"&&typeof m.severity=="string"}e.isRemoteConsoleLog=L;function s(c){const m=[];let f;try{const w=JSON.parse(c.arguments),d=w[w.length-1];d&&d.__$stack&&(w.pop(),f=d.__$stack),m.push(...w)}catch{m.push("Unable to log remote console arguments",c.arguments)}return{args:m,stack:f}}e.parse=s;function _(c){if(typeof c!="string")return _(s(c).stack);const m=c;if(m){const f=M(m),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(f||"");if(w&&w.length===4)return{uri:P.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.getFirstFrame=_;function M(c){if(!c)return c;const m=c.indexOf(`
`);return m===-1?c:c.substring(0,m)}function I(c,m){const{args:f,stack:w}=s(c),d=typeof f[0]=="string"&&f.length===1;let b=M(w);b&&(b=`(${b.trim()})`);let y=[];if(typeof f[0]=="string"?b&&d?y=[`%c[${m}] %c${f[0]} %c${b}`,h("blue"),h(""),h("grey")]:y=[`%c[${m}] %c${f[0]}`,h("blue"),h(""),...f.slice(1)]:y=[`%c[${m}]%`,h("blue"),...f],b&&!d&&y.push(b),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,y)}e.log=I;function h(c){return`color: ${c}`}}),define(te[74],ie([0,1,17,25,7]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function _(c){return JSON.stringify(c,I)}e.stringify=_;function M(c){let m=JSON.parse(c);return m=h(m),m}e.parse=M;function I(c,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:(0,L.regExpFlags)(m)}:m}function h(c,m=0){if(!c||m>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return s.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof P.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let f=0;f<c.length;++f)c[f]=h(c[f],m+1);else for(const f in c)Object.hasOwnProperty.call(c,f)&&(c[f]=h(c[f],m+1))}return c}e.revive=h}),define(te[15],ie([0,1,13,4,7]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var _;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm"})(_||(e.Schemas=_={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${_.vscodeRemoteResource}`}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}setServerRootPath(m){this._remoteResourcesPath=`${m}/${_.vscodeRemoteResource}`}set(m,f,w){this._hosts[m]=f,this._ports[m]=w}setConnectionToken(m,f){this._connectionTokens[m]=f}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(m){if(this._delegate)try{return this._delegate(m)}catch(o){return P.onUnexpectedError(o),m}const f=m.authority;let w=this._hosts[f];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const d=this._ports[f],b=this._connectionTokens[f];let y=`path=${encodeURIComponent(m.path)}`;return typeof b=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(b)}`),s.URI.from({scheme:L.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${w}:${d}`,path:this._remoteResourcesPath,query:y})}}e.RemoteAuthorities=new M,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class I{static{this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(m){const f=this.toUri(m,j);return this.uriToBrowserUri(f)}uriToBrowserUri(m){return m.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(m):m.scheme===_.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${_.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?m.with({scheme:_.vscodeFileResource,authority:m.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):m}asFileUri(m){const f=this.toUri(m,j);return this.uriToFileUri(f)}uriToFileUri(m){return m.scheme===_.vscodeFileResource?m.with({scheme:_.file,authority:m.authority!==I.FALLBACK_AUTHORITY?m.authority:null,query:null,fragment:null}):m}toUri(m,f){return s.URI.isUri(m)?m:s.URI.parse(f.toUrl(m))}}e.FileAccess=new I;var h;(function(c){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(m.get("3"));const f="vscode-coi";function w(b){let y;typeof b=="string"?y=new URL(b).searchParams:b instanceof URL?y=b.searchParams:s.URI.isUri(b)&&(y=new URL(b.toString(!0)).searchParams);const o=y?.get(f);if(o)return m.get(o)}c.getHeadersFromQuery=w;function d(b,y,o){if(!globalThis.crossOriginIsolated)return;const g=y&&o?"3":o?"2":"1";b instanceof URLSearchParams?b.set(f,g):b[f]=g}c.addSearchParam=d})(h||(e.COI=h={}))}),define(te[19],ie([0,1,32,15,9,4,25,7]),function(j,e,P,L,s,_,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(d){return(0,I.uriToFsPath)(d,!0)}e.originalFSPath=h;class c{constructor(b){this._ignorePathCasing=b}compare(b,y,o=!1){return b===y?0:(0,M.compare)(this.getComparisonKey(b,o),this.getComparisonKey(y,o))}isEqual(b,y,o=!1){return b===y?!0:!b||!y?!1:this.getComparisonKey(b,o)===this.getComparisonKey(y,o)}getComparisonKey(b,y=!1){return b.with({path:this._ignorePathCasing(b)?b.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(b){return this._ignorePathCasing(b)}isEqualOrParent(b,y,o=!1){if(b.scheme===y.scheme){if(b.scheme===L.Schemas.file)return P.isEqualOrParent(h(b),h(y),this._ignorePathCasing(b))&&b.query===y.query&&(o||b.fragment===y.fragment);if((0,e.isEqualAuthority)(b.authority,y.authority))return P.isEqualOrParent(b.path,y.path,this._ignorePathCasing(b),"/")&&b.query===y.query&&(o||b.fragment===y.fragment)}return!1}joinPath(b,...y){return I.URI.joinPath(b,...y)}basenameOrAuthority(b){return(0,e.basename)(b)||b.authority}basename(b){return s.posix.basename(b.path)}extname(b){return s.posix.extname(b.path)}dirname(b){if(b.path.length===0)return b;let y;return b.scheme===L.Schemas.file?y=I.URI.file(s.dirname(h(b))).path:(y=s.posix.dirname(b.path),b.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${b.toString})) resulted in a relative path`),y="/")),b.with({path:y})}normalizePath(b){if(!b.path.length)return b;let y;return b.scheme===L.Schemas.file?y=I.URI.file(s.normalize(h(b))).path:y=s.posix.normalize(b.path),b.with({path:y})}relativePath(b,y){if(b.scheme!==y.scheme||!(0,e.isEqualAuthority)(b.authority,y.authority))return;if(b.scheme===L.Schemas.file){const l=s.relative(h(b),h(y));return _.isWindows?P.toSlashes(l):l}let o=b.path||"/";const g=y.path||"/";if(this._ignorePathCasing(b)){let l=0;for(const v=Math.min(o.length,g.length);l<v&&!(o.charCodeAt(l)!==g.charCodeAt(l)&&o.charAt(l).toLowerCase()!==g.charAt(l).toLowerCase());l++);o=g.substr(0,l)+o.substr(l)}return s.posix.relative(o,g)}resolvePath(b,y){if(b.scheme===L.Schemas.file){const o=I.URI.file(s.resolve(h(b),y));return b.with({authority:o.authority,path:o.path})}return y=P.toPosixPath(y),b.with({path:s.posix.resolve(b.path,y)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,y){return b===y||b!==void 0&&y!==void 0&&(0,M.equalsIgnoreCase)(b,y)}hasTrailingPathSeparator(b,y=s.sep){if(b.scheme===L.Schemas.file){const o=h(b);return o.length>P.getRoot(o).length&&o[o.length-1]===y}else{const o=b.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,y=s.sep){return(0,e.hasTrailingPathSeparator)(b,y)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,y=s.sep){let o=!1;if(b.scheme===L.Schemas.file){const g=h(b);o=g!==void 0&&g.length===P.getRoot(g).length&&g[g.length-1]===y}else{y="/";const g=b.path;o=g.length===1&&g.charCodeAt(g.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(b,y)?b.with({path:b.path+"/"}):b}}e.ExtUri=c,e.extUri=new c(()=>!1),e.extUriBiasedIgnorePathCase=new c(d=>d.scheme===L.Schemas.file?!_.isLinux:!0),e.extUriIgnorePathCase=new c(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function m(d,b){const y=[];for(let o=0;o<d.length;o++){const g=b(d[o]);d.some((l,v)=>v===o?!1:(0,e.isEqualOrParent)(g,b(l)))||y.push(d[o])}return y}e.distinctParents=m;var f;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function b(y){const o=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(v=>{const[E,S]=v.split(":");E&&S&&o.set(E,S)});const l=y.path.substring(0,y.path.indexOf(";"));return l&&o.set(d.META_DATA_MIME,l),o}d.parseMetaData=b})(f||(e.DataUri=f={}));function w(d,b,y){if(b){let o=d.path;return o&&o[0]!==s.posix.sep&&(o=s.posix.sep+o),d.with({scheme:y,authority:b,path:o})}return d.with({scheme:y})}e.toLocalResource=w}),define(te[8],ie([0,1,21,13,3,2,19,4,141]),function(j,e,P,L,s,_,M,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function c(T){return!!T&&typeof T.then=="function"}e.isThenable=c;function m(T){const R=new P.CancellationTokenSource,W=T(R.token),H=new Promise((x,z)=>{const $=R.token.onCancellationRequested(()=>{$.dispose(),R.dispose(),z(new L.CancellationError)});Promise.resolve(W).then(K=>{$.dispose(),R.dispose(),x(K)},K=>{$.dispose(),R.dispose(),z(K)})});return new class{cancel(){R.cancel()}then(x,z){return H.then(x,z)}catch(x){return this.then(void 0,x)}finally(x){return H.finally(x)}}}e.createCancelablePromise=m;function f(T,R,W){return new Promise((H,x)=>{const z=R.onCancellationRequested(()=>{z.dispose(),H(W)});T.then(H,x).finally(()=>z.dispose())})}e.raceCancellation=f;function w(T,R){return new Promise((W,H)=>{const x=R.onCancellationRequested(()=>{x.dispose(),H(new L.CancellationError)});T.then(W,H).finally(()=>x.dispose())})}e.raceCancellationError=w;async function d(T){let R=-1;const W=T.map((H,x)=>H.then(z=>(R=x,z)));try{return await Promise.race(W)}finally{T.forEach((H,x)=>{x!==R&&H.cancel()})}}e.raceCancellablePromises=d;function b(T,R,W){let H;const x=setTimeout(()=>{H?.(void 0),W?.()},R);return Promise.race([T.finally(()=>clearTimeout(x)),new Promise(z=>H=z)])}e.raceTimeout=b;function y(T){return new Promise((R,W)=>{const H=T();c(H)?H.then(R,W):R(H)})}e.asPromise=y;class o{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(R){if(this.isDisposed)throw new Error("Throttler is disposed");if(this.activePromise){if(this.queuedPromiseFactory=R,!this.queuedPromise){const W=()=>{if(this.queuedPromise=null,this.isDisposed)return;const H=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,H};this.queuedPromise=new Promise(H=>{this.activePromise.then(W,W).then(H)})}return new Promise((W,H)=>{this.queuedPromise.then(W,H)})}return this.activePromise=R(),new Promise((W,H)=>{this.activePromise.then(x=>{this.activePromise=null,W(x)},x=>{this.activePromise=null,H(x)})})}dispose(){this.isDisposed=!0}}e.Throttler=o;class g{constructor(){this.current=Promise.resolve(null)}queue(R){return this.current=this.current.then(()=>R(),()=>R())}}e.Sequencer=g;class l{constructor(){this.promiseMap=new Map}queue(R,W){const x=(this.promiseMap.get(R)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(R)===x&&this.promiseMap.delete(R)});return this.promiseMap.set(R,x),x}}e.SequencerByKey=l;const v=(T,R)=>{let W=!0;const H=setTimeout(()=>{W=!1,R()},T);return{isTriggered:()=>W,dispose:()=>{clearTimeout(H),W=!1}}},E=T=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,T())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};class S{constructor(R){this.defaultDelay=R,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(R,W=this.defaultDelay){this.task=R,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((x,z)=>{this.doResolve=x,this.doReject=z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const x=this.task;return this.task=null,x()}}));const H=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=W===h.MicrotaskDelay?E(H):v(W,H),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=S;class t{constructor(R){this.delayer=new S(R),this.throttler=new o}trigger(R,W){return this.delayer.trigger(()=>this.throttler.queue(R),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=t;class u{constructor(){this._isOpen=!1,this._promise=new Promise((R,W)=>{this._completePromise=R})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class r extends u{constructor(R){super(),this._timeout=setTimeout(()=>this.open(),R)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function n(T,R){return R?new Promise((W,H)=>{const x=setTimeout(()=>{z.dispose(),W()},T),z=R.onCancellationRequested(()=>{clearTimeout(x),z.dispose(),H(new L.CancellationError)})}):m(W=>n(T,W))}e.timeout=n;function i(T,R=0){const W=setTimeout(T,R);return(0,_.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=i;function a(T){const R=[];let W=0;const H=T.length;function x(){return W<H?T[W++]():null}function z($){$!=null&&R.push($);const K=x();return K?K.then(z):Promise.resolve(R)}return Promise.resolve(null).then(z)}e.sequence=a;function p(T,R=H=>!!H,W=null){let H=0;const x=T.length,z=()=>{if(H>=x)return Promise.resolve(W);const $=T[H++];return Promise.resolve($()).then(re=>R(re)?Promise.resolve(re):z())};return z()}e.first=p;function C(T,R=H=>!!H,W=null){if(T.length===0)return Promise.resolve(W);let H=T.length;const x=()=>{H=-1;for(const z of T)z.cancel?.()};return new Promise((z,$)=>{for(const K of T)K.then(re=>{--H>=0&&R(re)?(x(),z(re)):H===0&&z(W)}).catch(re=>{--H>=0&&(x(),$(re))})})}e.firstParallel=C;class k{constructor(R){this._size=0,this.maxDegreeOfParalellism=R,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new s.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(R){return this._size++,new Promise((W,H)=>{this.outstandingPromises.push({factory:R,c:W,e:H}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const R=this.outstandingPromises.shift();this.runningPromises++;const W=R.factory();W.then(R.c,R.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=k;class D extends k{constructor(){super(1)}}e.Queue=D;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const R=new N;return this.drainers.add(R),R.p}isDrained(){for(const[,R]of this.queues)if(R.size>0)return!1;return!0}queueFor(R,W=M.extUri){const H=W.getComparisonKey(R);let x=this.queues.get(H);return x||(x=new D,s.Event.once(x.onDrained)(()=>{x?.dispose(),this.queues.delete(H),this.onDidQueueDrain()}),this.queues.set(H,x)),x}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const R of this.drainers)R.complete();this.drainers.clear()}dispose(){for(const[,R]of this.queues)R.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class O{constructor(R,W){this._token=-1,typeof R=="function"&&typeof W=="number"&&this.setIfNotSet(R,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(R,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,R()},W)}setIfNotSet(R,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,R()},W))}}e.TimeoutTimer=O;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(R,W){this.cancel(),this._token=setInterval(()=>{R()},W)}}e.IntervalTimer=U;class q{constructor(R,W){this.timeoutToken=-1,this.runner=R,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(R=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,R)}get delay(){return this.timeout}set delay(R){this.timeout=R}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=q;class se{constructor(R,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=R,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(R=this.timeout){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(R/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=se;class ne extends q{constructor(R,W){super(R,W),this.units=[]}work(R){this.units.push(R),this.isScheduled()||this.schedule()}doRun(){const R=this.units;this.units=[],this.runner?.(R)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ne;class ee extends _.Disposable{constructor(R,W){super(),this.options=R,this.handler=W,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(R){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+R.length>this.options.maxBufferedWork)return!1}else if(this.pending+R.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const W of R)this.pendingWork.push(W);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ee,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=T=>{(0,I.setTimeout0)(()=>{if(R)return;const W=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:e.runWhenIdle=(T,R)=>{const W=requestIdleCallback(T,typeof R=="number"?{timeout:R}:void 0);let H=!1;return{dispose(){H||(H=!0,cancelIdleCallback(W))}}}}();class ae{constructor(R){this._didRun=!1,this._executor=()=>{try{this._value=R()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ae;async function ue(T,R,W){let H;for(let x=0;x<W;x++)try{return await T()}catch(z){H=z,await n(R)}throw H}e.retry=ue;class G{hasPending(R){return this._pending?typeof R=="number"?this._pending.taskId===R:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(R,W,H){return this._pending={taskId:R,cancel:()=>H?.(),promise:W},W.then(()=>this.donePending(R),()=>this.donePending(R)),W}donePending(R){this._pending&&R===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const R=this._next;this._next=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}setNext(R){if(this._next)this._next.run=R;else{let W,H;const x=new Promise((z,$)=>{W=z,H=$});this._next={run:R,promise:x,promiseResolve:W,promiseReject:H}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=G;class Y{constructor(R,W=()=>Date.now()){this.interval=R,this.nowFn=W,this.lastIncrementTime=0,this.value=0}increment(){const R=this.nowFn();return R-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=R,this.value=0),this.value++,this.value}}e.IntervalCounter=Y;var F;(function(T){T[T.Resolved=0]="Resolved",T[T.Rejected=1]="Rejected"})(F||(F={}));class N{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((R,W)=>{this.completeCallback=R,this.errorCallback=W})}complete(R){return new Promise(W=>{this.completeCallback(R),this.outcome={outcome:0,value:R},W()})}error(R){return new Promise(W=>{this.errorCallback(R),this.outcome={outcome:1,value:R},W()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=N;var B;(function(T){async function R(H){let x;const z=await Promise.all(H.map($=>$.then(K=>K,K=>{x||(x=K)})));if(typeof x<"u")throw x;return z}T.settled=R;function W(H){return new Promise(async(x,z)=>{try{await H(x,z)}catch($){z($)}})}T.withAsyncBody=W})(B||(e.Promises=B={}));var V;(function(T){T[T.Initial=0]="Initial",T[T.DoneOK=1]="DoneOK",T[T.DoneError=2]="DoneError"})(V||(V={}));class X{static fromArray(R){return new X(W=>{W.emitMany(R)})}static fromPromise(R){return new X(async W=>{W.emitMany(await R)})}static fromPromises(R){return new X(async W=>{await Promise.all(R.map(async H=>W.emitOne(await H)))})}static merge(R){return new X(async W=>{await Promise.all(R.map(async H=>{for await(const x of H)W.emitOne(x)}))})}static{this.EMPTY=X.fromArray([])}constructor(R){this._state=0,this._results=[],this._error=null,this._onStateChanged=new s.Emitter,queueMicrotask(async()=>{const W={emitOne:H=>this.emitOne(H),emitMany:H=>this.emitMany(H),reject:H=>this.reject(H)};try{await Promise.resolve(R(W)),this.resolve()}catch(H){this.reject(H)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(R<this._results.length)return{done:!1,value:this._results[R++]};if(this._state===1)return{done:!0,value:void 0};await s.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(R,W){return new X(async H=>{for await(const x of R)H.emitOne(W(x))})}map(R){return X.map(this,R)}static filter(R,W){return new X(async H=>{for await(const x of R)W(x)&&H.emitOne(x)})}filter(R){return X.filter(this,R)}static coalesce(R){return X.filter(R,W=>!!W)}coalesce(){return X.coalesce(this)}static async toPromise(R){const W=[];for await(const H of R)W.push(H);return W}toPromise(){return X.toPromise(this)}emitOne(R){this._state===0&&(this._results.push(R),this._onStateChanged.fire())}emitMany(R){this._state===0&&(this._results=this._results.concat(R),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(R){this._state===0&&(this._state=2,this._error=R,this._onStateChanged.fire())}}e.AsyncIterableObject=X;class ce extends X{constructor(R,W){super(W),this._source=R}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function oe(T){const R=new P.CancellationTokenSource,W=T(R.token);return new ce(R,async H=>{const x=R.token.onCancellationRequested(()=>{x.dispose(),R.dispose(),H.reject(new L.CancellationError)});try{for await(const z of W){if(R.token.isCancellationRequested)return;H.emitOne(z)}x.dispose(),R.dispose()}catch(z){x.dispose(),R.dispose(),H.reject(z)}})}e.createCancelableAsyncIterable=oe}),define(te[104],ie([0,1,24,8,32,35,9,4,25]),function(j,e,P,L,s,_,M,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function c(){return Object.create(null)}e.getEmptyExpression=c,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const m="[/\\\\]",f="[^/\\\\]",w=/\//g;function d(Y,F){switch(Y){case 0:return"";case 1:return`${f}*?`;default:return`(?:${m}|${f}+${m}${F?`|${m}${f}+`:""})*?`}}function b(Y,F){if(!Y)return[];const N=[];let B=!1,V=!1,X="";for(const ce of Y){switch(ce){case F:if(!B&&!V){N.push(X),X="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":V=!0;break;case"]":V=!1;break}X+=ce}return X&&N.push(X),N}e.splitGlobAware=b;function y(Y){if(!Y)return"";let F="";const N=b(Y,e.GLOB_SPLIT);if(N.every(B=>B===e.GLOBSTAR))F=".*";else{let B=!1;N.forEach((V,X)=>{if(V===e.GLOBSTAR){if(B)return;F+=d(2,X===N.length-1)}else{let ce=!1,oe="",T=!1,R="";for(const W of V){if(W!=="}"&&ce){oe+=W;continue}if(T&&(W!=="]"||!R)){let H;W==="-"?H=W:(W==="^"||W==="!")&&!R?H="^":W===e.GLOB_SPLIT?H="":H=(0,h.escapeRegExpCharacters)(W),R+=H;continue}switch(W){case"{":ce=!0;continue;case"[":T=!0;continue;case"}":{const x=`(?:${b(oe,",").map(z=>y(z)).join("|")})`;F+=x,ce=!1,oe="";break}case"]":{F+="["+R+"]",T=!1,R="";break}case"?":F+=f;continue;case"*":F+=d(1);continue;default:F+=(0,h.escapeRegExpCharacters)(W)}}X<N.length-1&&(N[X+1]!==e.GLOBSTAR||X+2<N.length)&&(F+=m)}B=V===e.GLOBSTAR})}return F}const o=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new _.LRUCache(1e4),u=function(){return!1},r=function(){return null};function n(Y,F){if(!Y)return r;let N;typeof Y!="string"?N=Y.pattern:N=Y,N=N.trim();const B=`${N}_${!!F.trimForExclusions}`;let V=t.get(B);if(V)return i(V,Y);let X;return o.test(N)?V=p(N.substr(4),N):(X=g.exec(a(N,F)))?V=C(X[1],N):(F.trimForExclusions?v:l).test(N)?V=k(N,F):(X=E.exec(a(N,F)))?V=D(X[1].substr(1),N,!0):(X=S.exec(a(N,F)))?V=D(X[1],N,!1):V=A(N),t.set(B,V),i(V,Y)}function i(Y,F){if(typeof F=="string")return Y;const N=function(B,V){return(0,s.isEqualOrParent)(B,F.base,!I.isLinux)?Y((0,h.ltrim)(B.substr(F.base.length),M.sep),V):null};return N.allBasenames=Y.allBasenames,N.allPaths=Y.allPaths,N.basenames=Y.basenames,N.patterns=Y.patterns,N}function a(Y,F){return F.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function p(Y,F){return function(N,B){return typeof N=="string"&&N.endsWith(Y)?F:null}}function C(Y,F){const N=`/${Y}`,B=`\\${Y}`,V=function(ce,oe){return typeof ce!="string"?null:oe?oe===Y?F:null:ce===Y||ce.endsWith(N)||ce.endsWith(B)?F:null},X=[Y];return V.basenames=X,V.patterns=[F],V.allBasenames=X,V}function k(Y,F){const N=ue(Y.slice(1,-1).split(",").map(oe=>n(oe,F)).filter(oe=>oe!==r),Y),B=N.length;if(!B)return r;if(B===1)return N[0];const V=function(oe,T){for(let R=0,W=N.length;R<W;R++)if(N[R](oe,T))return Y;return null},X=N.find(oe=>!!oe.allBasenames);X&&(V.allBasenames=X.allBasenames);const ce=N.reduce((oe,T)=>T.allPaths?oe.concat(T.allPaths):oe,[]);return ce.length&&(V.allPaths=ce),V}function D(Y,F,N){const B=M.sep===M.posix.sep,V=B?Y:Y.replace(w,M.sep),X=M.sep+V,ce=M.posix.sep+Y;let oe;return N?oe=function(T,R){return typeof T=="string"&&(T===V||T.endsWith(X)||!B&&(T===Y||T.endsWith(ce)))?F:null}:oe=function(T,R){return typeof T=="string"&&(T===V||!B&&T===Y)?F:null},oe.allPaths=[(N?"*/":"./")+Y],oe}function A(Y){try{const F=new RegExp(`^${y(Y)}$`);return function(N){return F.lastIndex=0,typeof N=="string"&&F.test(N)?Y:null}}catch{return r}}function O(Y,F,N){return!Y||typeof F!="string"?!1:U(Y)(F,void 0,N)}e.match=O;function U(Y,F={}){if(!Y)return u;if(typeof Y=="string"||q(Y)){const N=n(Y,F);if(N===r)return u;const B=function(V,X){return!!N(V,X)};return N.allBasenames&&(B.allBasenames=N.allBasenames),N.allPaths&&(B.allPaths=N.allPaths),B}return ee(Y,F)}e.parse=U;function q(Y){const F=Y;return F?typeof F.base=="string"&&typeof F.pattern=="string":!1}e.isRelativePattern=q;function se(Y){return Y.allBasenames||[]}e.getBasenameTerms=se;function ne(Y){return Y.allPaths||[]}e.getPathTerms=ne;function ee(Y,F){const N=ue(Object.getOwnPropertyNames(Y).map(oe=>ae(oe,Y[oe],F)).filter(oe=>oe!==r)),B=N.length;if(!B)return r;if(!N.some(oe=>!!oe.requiresSiblings)){if(B===1)return N[0];const oe=function(W,H){let x;for(let z=0,$=N.length;z<$;z++){const K=N[z](W,H);if(typeof K=="string")return K;(0,L.isThenable)(K)&&(x||(x=[]),x.push(K))}return x?(async()=>{for(const z of x){const $=await z;if(typeof $=="string")return $}return null})():null},T=N.find(W=>!!W.allBasenames);T&&(oe.allBasenames=T.allBasenames);const R=N.reduce((W,H)=>H.allPaths?W.concat(H.allPaths):W,[]);return R.length&&(oe.allPaths=R),oe}const V=function(oe,T,R){let W,H;for(let x=0,z=N.length;x<z;x++){const $=N[x];$.requiresSiblings&&R&&(T||(T=(0,M.basename)(oe)),W||(W=T.substr(0,T.length-(0,M.extname)(oe).length)));const K=$(oe,T,W,R);if(typeof K=="string")return K;(0,L.isThenable)(K)&&(H||(H=[]),H.push(K))}return H?(async()=>{for(const x of H){const z=await x;if(typeof z=="string")return z}return null})():null},X=N.find(oe=>!!oe.allBasenames);X&&(V.allBasenames=X.allBasenames);const ce=N.reduce((oe,T)=>T.allPaths?oe.concat(T.allPaths):oe,[]);return ce.length&&(V.allPaths=ce),V}function ae(Y,F,N){if(F===!1)return r;const B=n(Y,N);if(B===r)return r;if(typeof F=="boolean")return B;if(F){const V=F.when;if(typeof V=="string"){const X=(ce,oe,T,R)=>{if(!R||!B(ce,oe))return null;const W=V.replace("$(basename)",()=>T),H=R(W);return(0,L.isThenable)(H)?H.then(x=>x?Y:null):H?Y:null};return X.requiresSiblings=!0,X}}return B}function ue(Y,F){const N=Y.filter(oe=>!!oe.basenames);if(N.length<2)return Y;const B=N.reduce((oe,T)=>{const R=T.basenames;return R?oe.concat(R):oe},[]);let V;if(F){V=[];for(let oe=0,T=B.length;oe<T;oe++)V.push(F)}else V=N.reduce((oe,T)=>{const R=T.patterns;return R?oe.concat(R):oe},[]);const X=function(oe,T){if(typeof oe!="string")return null;if(!T){let W;for(W=oe.length;W>0;W--){const H=oe.charCodeAt(W-1);if(H===47||H===92)break}T=oe.substr(W)}const R=B.indexOf(T);return R!==-1?V[R]:null};X.basenames=B,X.patterns=V,X.allBasenames=B;const ce=Y.filter(oe=>!oe.basenames);return ce.push(X),ce}function G(Y,F){return(0,P.equals)(Y,F,(N,B)=>typeof N=="string"&&typeof B=="string"?N===B:typeof N!="string"&&typeof B!="string"?N.base===B.base&&N.pattern===B.pattern:!1)}e.patternsEquals=G}),define(te[46],ie([0,1,24,32,9,4,19,25]),function(j,e,P,L,s,_,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function h(n,i){const{os:a,tildify:p,relative:C}=i;if(C){const A=c(n,C,a);if(typeof A=="string")return A}let k=n.fsPath;if(a===1&&!_.isWindows?k=k.replace(/\//g,"\\"):a!==1&&_.isWindows&&(k=k.replace(/\\/g,"/")),a!==1&&p?.userHome){const A=p.userHome.fsPath;let O;n.scheme!==p.userHome.scheme&&n.path.startsWith(s.posix.sep)?O=p.userHome.with({path:n.path}).fsPath:O=n.fsPath,k=w(O,A,a)}return(a===1?s.win32:s.posix).normalize(m(k,a===1))}e.getPathLabel=h;function c(n,i,a){const p=a===1?s.win32:s.posix,C=a===3?M.extUri:M.extUriIgnorePathCase,k=i.getWorkspace(),D=(0,P.firstOrDefault)(k.folders);if(!D)return;n.scheme!==D.uri.scheme&&n.path.startsWith(s.posix.sep)&&(n=D.uri.with({path:n.path}));const A=i.getWorkspaceFolder(n);if(!A)return;let O;if(C.isEqual(A.uri,n)?O="":O=C.relativePath(A.uri,n)??"",O&&(O=p.normalize(O)),k.folders.length>1&&!i.noPrefix){const U=A.name?A.name:C.basenameOrAuthority(A.uri);O=O?`${U} \u2022 ${O}`:U}return O}function m(n,i=_.isWindows){return(0,L.hasDriveLetter)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=m;let f=Object.create(null);function w(n,i,a=_.OS){if(a===1||!n||!i)return n;let p=f.original===i?f.normalized:void 0;p||(p=i,_.isWindows&&(p=(0,L.toSlashes)(p)),p=`${(0,I.rtrim)(p,s.posix.sep)}${s.posix.sep}`,f={original:i,normalized:p});let C=n;return _.isWindows&&(C=(0,L.toSlashes)(C)),(a===3?C.startsWith(p):(0,I.startsWithIgnoreCase)(C,p))?`~/${C.substr(p.length)}`:n}e.tildify=w;function d(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=d;const b="\u2026",y="\\\\",o="~";function g(n,i=s.sep){const a=new Array(n.length);let p=!1;for(let C=0;C<n.length;C++){const k=n[C];if(k===""){a[C]=`.${i}`;continue}if(!k){a[C]=k;continue}p=!0;let D="",A=k;A.indexOf(y)===0?(D=A.substr(0,A.indexOf(y)+y.length),A=A.substr(A.indexOf(y)+y.length)):A.indexOf(i)===0?(D=A.substr(0,A.indexOf(i)+i.length),A=A.substr(A.indexOf(i)+i.length)):A.indexOf(o)===0&&(D=A.substr(0,A.indexOf(o)+o.length),A=A.substr(A.indexOf(o)+o.length));const O=A.split(i);for(let U=1;p&&U<=O.length;U++)for(let q=O.length-U;p&&q>=0;q--){p=!1;let se=O.slice(q,q+U).join(i);for(let ne=0;!p&&ne<n.length;ne++)if(ne!==C&&n[ne]&&n[ne].indexOf(se)>-1){const ee=q+U===O.length,ae=q>0&&n[ne].indexOf(i)>-1?i+se:se,ue=n[ne].endsWith(ae);p=!ee||ue}if(!p){let ne="";(O[0].endsWith(":")||D!=="")&&(q===1&&(q=0,U++,se=O[0]+i+se),q>0&&(ne=O[0]+i),ne=D+ne),q>0&&(ne=ne+b+i),ne=ne+se,q+U<O.length&&(ne=ne+i+b),a[C]=ne}}p&&(a[C]=k)}return a}e.shorten=g;var l;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function v(n,i=Object.create(null)){const a=[];let p=!1,C="";for(const k of n)if(k==="$"||p&&k==="{")C&&a.push({value:C,type:l.TEXT}),C="",p=!0;else if(k==="}"&&p){const D=i[C];if(typeof D=="string")D.length&&a.push({value:D,type:l.VARIABLE});else if(D){const A=a[a.length-1];(!A||A.type!==l.SEPARATOR)&&a.push({value:D.label,type:l.SEPARATOR})}C="",p=!1}else C+=k;return C&&!p&&a.push({value:C,type:l.TEXT}),a.filter((k,D)=>{if(k.type===l.SEPARATOR){const A=a[D-1],O=a[D+1];return[A,O].every(U=>U&&(U.type===l.VARIABLE||U.type===l.TEXT)&&U.value.length>0)}return!0}).map(k=>k.value).join("")}e.template=v;function E(n,i){return _.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,_.isMacintosh?"&":"&&"):n.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function S(n,i){return _.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,""):_.isWindows?n.replace(/&&|&/g,a=>a==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=S;function t(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=t;function u(n){if(n.endsWith("]")){const i=n.lastIndexOf(" [",n.length-2);if(i!==-1){const a=r(n.substring(0,i));return{name:a.name,parentPath:a.parentPath+n.substring(i)}}}return r(n)}e.splitRecentLabel=u;function r(n){const i=n.indexOf("/")!==-1?s.posix:s.win32,a=i.basename(n),p=i.dirname(n);return a.length?{name:a,parentPath:p}:{name:p,parentPath:""}}}),define(te[154],ie([0,1,17,7]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function s(f){return f.toJSON()}class _{constructor(w){this._uriTransformer=w}transformIncoming(w){const d=this._uriTransformer.transformIncoming(w);return d===w?w:s(L.URI.from(d))}transformOutgoing(w){const d=this._uriTransformer.transformOutgoing(w);return d===w?w:s(L.URI.from(d))}transformOutgoingURI(w){const d=this._uriTransformer.transformOutgoing(w);return d===w?w:L.URI.from(d)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(f){return f}transformOutgoing(f){return f}transformOutgoingURI(f){return f}transformOutgoingScheme(f){return f}};function M(f,w,d){if(!f||d>200)return null;if(typeof f=="object"){if(f instanceof L.URI)return w.transformOutgoing(f);for(const b in f)if(Object.hasOwnProperty.call(f,b)){const y=M(f[b],w,d+1);y!==null&&(f[b]=y)}}return null}function I(f,w){const d=M(f,w,0);return d===null?f:d}e.transformOutgoingURIs=I;function h(f,w,d,b){if(!f||b>200)return null;if(typeof f=="object"){if(f.$mid===1)return d?L.URI.revive(w.transformIncoming(f)):w.transformIncoming(f);if(f instanceof P.VSBuffer)return null;for(const y in f)if(Object.hasOwnProperty.call(f,y)){const o=h(f[y],w,d,b+1);o!==null&&(f[y]=o)}}return null}function c(f,w){const d=h(f,w,!1,0);return d===null?f:d}e.transformIncomingURIs=c;function m(f,w){const d=h(f,w,!0,0);return d===null?f:d}e.transformAndReviveIncomingURIs=m}),define(te[22],ie([0,1,42,27,155,8,32,86,9,4,19,7]),function(j,e,P,L,s,_,M,I,h,c,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(ee){ee[ee.UNLINK=0]="UNLINK",ee[ee.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function d(ee,ae=w.UNLINK,ue){if((0,M.isRootOrDriveLetter)(ee))throw new Error("rimraf - will refuse to recursively delete root");return ae===w.UNLINK?y(ee):b(ee,ue)}async function b(ee,ae=(0,M.randomPath)((0,L.tmpdir)())){try{try{await P.promises.rename(ee,ae)}catch(ue){return ue.code==="ENOENT"?void 0:y(ee)}y(ae).catch(ue=>{})}catch(ue){if(ue.code!=="ENOENT")throw ue}}async function y(ee){return(0,s.promisify)(P.rm)(ee,{recursive:!0,force:!0,maxRetries:3})}function o(ee){if((0,M.isRootOrDriveLetter)(ee))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(ee,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=o;async function g(ee,ae){return E(await(ae?l(ee):(0,s.promisify)(P.readdir)(ee)))}async function l(ee){try{return await(0,s.promisify)(P.readdir)(ee,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const ae=[],ue=await g(ee);for(const G of ue){let Y=!1,F=!1,N=!1;try{const B=await e.Promises.lstat((0,h.join)(ee,G));Y=B.isFile(),F=B.isDirectory(),N=B.isSymbolicLink()}catch(B){console.warn("[node.js fs] unexpected error from lstat after readdir: ",B)}ae.push({name:G,isFile:()=>Y,isDirectory:()=>F,isSymbolicLink:()=>N})}return ae}function v(ee){return E(P.readdirSync(ee))}e.readdirSync=v;function E(ee){return ee.map(ae=>typeof ae=="string"?c.isMacintosh?(0,I.normalizeNFC)(ae):ae:(ae.name=c.isMacintosh?(0,I.normalizeNFC)(ae.name):ae.name,ae))}async function S(ee){const ae=await g(ee),ue=[];for(const G of ae)await u.existsDirectory((0,h.join)(ee,G))&&ue.push(G);return ue}function t(ee,ae=1e3){return new Promise(ue=>{let G=!1;const Y=setInterval(()=>{G||(G=!0,P.access(ee,F=>{G=!1,F&&(clearInterval(Y),ue(void 0))}))},ae)})}e.whenDeleted=t;var u;(function(ee){async function ae(Y){let F;try{if(F=await e.Promises.lstat(Y),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(c.isWindows&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(B){if(B.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw B}throw N}}ee.stat=ae;async function ue(Y){try{const{stat:F,symbolicLink:N}=await ee.stat(Y);return F.isFile()&&N?.dangling!==!0}catch{}return!1}ee.existsFile=ue;async function G(Y){try{const{stat:F,symbolicLink:N}=await ee.stat(Y);return F.isDirectory()&&N?.dangling!==!0}catch{}return!1}ee.existsDirectory=G})(u||(e.SymlinkSupport=u={}));const r=new _.ResourceQueue;function n(ee,ae,ue){return r.queueFor(f.URI.file(ee),m.extUriBiasedIgnorePathCase).queue(()=>{const G=k(ue);return new Promise((Y,F)=>p(ee,ae,G,N=>N?F(N):Y()))})}let i=!0;function a(ee){i=ee}e.configureFlushOnWrite=a;function p(ee,ae,ue,G){if(!i)return P.writeFile(ee,ae,{mode:ue.mode,flag:ue.flag},G);P.open(ee,ue.flag,ue.mode,(Y,F)=>{if(Y)return G(Y);P.writeFile(F,ae,N=>{if(N)return P.close(F,()=>G(N));P.fdatasync(F,B=>(B&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",B),a(!1)),P.close(F,V=>G(V))))})})}function C(ee,ae,ue){const G=k(ue);if(!i)return P.writeFileSync(ee,ae,{mode:G.mode,flag:G.flag});const Y=P.openSync(ee,G.flag,G.mode);try{P.writeFileSync(Y,ae);try{P.fdatasyncSync(Y)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),a(!1)}}finally{P.closeSync(Y)}}e.writeFileSync=C;function k(ee){return ee?{mode:typeof ee.mode=="number"?ee.mode:438,flag:typeof ee.flag=="string"?ee.flag:"w"}:{mode:438,flag:"w"}}async function D(ee,ae){if(ee!==ae)try{await e.Promises.rename(ee,ae)}catch(ue){if(ee.toLowerCase()!==ae.toLowerCase()&&ue.code==="EXDEV"||ee.endsWith("."))await A(ee,ae,{preserveSymlinks:!1}),await d(ee,w.MOVE);else throw ue}}async function A(ee,ae,ue){return U(ee,ae,{root:{source:ee,target:ae},options:ue,handledSourcePaths:new Set})}const O=511;async function U(ee,ae,ue){if(ue.handledSourcePaths.has(ee))return;ue.handledSourcePaths.add(ee);const{stat:G,symbolicLink:Y}=await u.stat(ee);if(Y){if(ue.options.preserveSymlinks)try{return await ne(ee,ae,ue)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(Y.dangling)return}return G.isDirectory()?q(ee,ae,G.mode&O,ue):se(ee,ae,G.mode&O)}async function q(ee,ae,ue,G){await e.Promises.mkdir(ae,{recursive:!0,mode:ue});const Y=await g(ee);for(const F of Y)await U((0,h.join)(ee,F),(0,h.join)(ae,F),G)}async function se(ee,ae,ue){await e.Promises.copyFile(ee,ae),await e.Promises.chmod(ae,ue)}async function ne(ee,ae,ue){let G=await e.Promises.readlink(ee);(0,M.isEqualOrParent)(G,ue.root.source,!c.isLinux)&&(G=(0,h.join)(ue.root.target,G.substr(ue.root.source.length+1))),await e.Promises.symlink(G,ae)}e.Promises=new class{get access(){return(0,s.promisify)(P.access)}get stat(){return(0,s.promisify)(P.stat)}get lstat(){return(0,s.promisify)(P.lstat)}get utimes(){return(0,s.promisify)(P.utimes)}get read(){return(ee,ae,ue,G,Y)=>new Promise((F,N)=>{P.read(ee,ae,ue,G,Y,(B,V,X)=>B?N(B):F({bytesRead:V,buffer:X}))})}get readFile(){return(0,s.promisify)(P.readFile)}get write(){return(ee,ae,ue,G,Y)=>new Promise((F,N)=>{P.write(ee,ae,ue,G,Y,(B,V,X)=>B?N(B):F({bytesWritten:V,buffer:X}))})}get appendFile(){return(0,s.promisify)(P.appendFile)}get fdatasync(){return(0,s.promisify)(P.fdatasync)}get truncate(){return(0,s.promisify)(P.truncate)}get rename(){return(0,s.promisify)(P.rename)}get copyFile(){return(0,s.promisify)(P.copyFile)}get open(){return(0,s.promisify)(P.open)}get close(){return(0,s.promisify)(P.close)}get symlink(){return(0,s.promisify)(P.symlink)}get readlink(){return(0,s.promisify)(P.readlink)}get chmod(){return(0,s.promisify)(P.chmod)}get mkdir(){return(0,s.promisify)(P.mkdir)}get unlink(){return(0,s.promisify)(P.unlink)}get rmdir(){return(0,s.promisify)(P.rmdir)}get realpath(){return(0,s.promisify)(P.realpath)}async exists(ee){try{return await e.Promises.access(ee),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return S}get writeFile(){return n}get rm(){return d}get move(){return D}get copy(){return A}}}),define(te[105],ie([0,1,42,9,4,25,22]),function(j,e,P,L,s,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(w){if(s.isLinux)return w;const d=(0,L.dirname)(w);if(w===d)return w;const b=((0,L.basename)(w)||w).toLowerCase();try{const o=(0,M.readdirSync)(d).filter(g=>g.toLowerCase()===b);if(o.length===1){const g=I(d);if(g)return(0,L.join)(g,o[0])}else if(o.length>1){const g=o.indexOf(b);if(g>=0){const l=I(d);if(l)return(0,L.join)(l,o[g])}}}catch{}return null}e.realcaseSync=I;async function h(w){if(s.isLinux)return w;const d=(0,L.dirname)(w);if(w===d)return w;const b=((0,L.basename)(w)||w).toLowerCase();try{const o=(await M.Promises.readdir(d)).filter(g=>g.toLowerCase()===b);if(o.length===1){const g=await h(d);if(g)return(0,L.join)(g,o[0])}else if(o.length>1){const g=o.indexOf(b);if(g>=0){const l=await h(d);if(l)return(0,L.join)(l,o[g])}}}catch{}return null}e.realcase=h;async function c(w){try{return await M.Promises.realpath(w)}catch{const b=f(w);return await M.Promises.access(b,P.constants.R_OK),b}}e.realpath=c;function m(w){try{return P.realpathSync(w)}catch{const b=f(w);return P.accessSync(b,P.constants.R_OK),b}}e.realpathSync=m;function f(w){return(0,_.rtrim)((0,L.normalize)(w),L.sep)}}),define(te[106],ie([0,1,27,9,22]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const _=/^\d+$/,M=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var h;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class f{constructor(S,t,u){this.exePath=S,this.displayName=t,this.knownToExist=u}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await s.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:E=!1}={}){return E?c===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:E=!1,findPreview:S=!1}={}){const t=w({useAlternateBitness:E});if(!t)return null;const u=L.join(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(u))return null;let r=-1,n=null;for(const p of await s.Promises.readdir(u)){let C=-1;if(S){const D=p.indexOf("-");if(D<0)continue;const A=p.substring(0,D);if(!_.test(A)||p.substring(D+1)!=="preview")continue;C=parseInt(A,10)}else{if(!_.test(p))continue;C=parseInt(p,10)}if(C<=r)continue;const k=L.join(u,p,"pwsh.exe");await s.SymlinkSupport.existsFile(k)&&(n=k,r=C)}if(!n)return null;const i=t.includes("x86")?" (x86)":"",a=S?" Preview":"";return new f(n,`PowerShell${a}${i}`,!0)}async function b({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const S=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(S))return null;const{pwshMsixDirRegex:t,pwshMsixName:u}=E?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(S))if(t.test(r)){const n=L.join(S,r,"pwsh.exe");return new f(n,u)}return null}function y(){const E=L.join(P.homedir(),".dotnet","tools","pwsh.exe");return new f(E,".NET Core PowerShell Global Tool")}function o(){const E=L.join(process.env.windir,c===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new f(E,"Windows PowerShell",!0)}async function*g(){let E=await d();E&&(yield E),E=await d({useAlternateBitness:!0}),E&&(yield E),E=await b(),E&&(yield E),E=y(),E&&(yield E),E=await d({findPreview:!0}),E&&(yield E),E=await b({findPreview:!0}),E&&(yield E),E=await d({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=o(),E&&(yield E)}async function*l(){for await(const E of g())await E.exists()&&(yield E)}e.enumeratePowerShellInstallations=l;async function v(){for await(const E of l())return E;return null}e.getFirstAvailablePowerShellInstallation=v}),define(te[89],ie([0,1,9,4,36,73,10,22]),function(j,e,P,L,s,_,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return _.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return _.TerminateResponseCode}});function h(f=s.env){return f.comspec||"cmd.exe"}e.getWindowsShell=h;function c(f){let w=[],d=!1;const b=function(y){if(d){w.push(y);return}(!f.send(y,g=>{if(g&&console.error(g),d=!1,w.length>0){const l=w.slice(0);w=[],l.forEach(v=>b(v))}})||L.isWindows)&&(d=!0)};return{send:b}}e.createQueuedSender=c;var m;(function(f){async function w(d,b,y){if(P.isAbsolute(d))return d;if(b===void 0&&(b=s.cwd()),P.dirname(d)!=="."||(y===void 0&&M.isString(s.env.PATH)&&(y=s.env.PATH.split(P.delimiter)),y===void 0||y.length===0))return P.join(b,d);async function g(l){if(await I.Promises.exists(l)){let v;try{v=await I.Promises.stat(l)}catch(E){E.message.startsWith("EACCES")&&(v=await I.Promises.lstat(l))}return v?!v.isDirectory():!1}return!1}for(const l of y){let v;if(P.isAbsolute(l)?v=P.join(l,d):v=P.join(b,l,d),await g(v))return v;let E=v+".com";if(await g(E)||(E=v+".exe",await g(E)))return E}return P.join(b,d)}f.findExecutable=w})(m||(e.win32=m={}))}),define(te[107],ie([0,1,47,15]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function s(M){return new Promise((I,h)=>{let c;const m=new Map;function f(d,b,y,o,g){const l=m.get(b);if(d===M||l){const v={name:w(y),cmd:y,pid:d,ppid:b,load:o,mem:g};m.set(d,v),d===M&&(c=v),l&&(l.children||(l.children=[]),l.children.push(v),l.children.length>1&&(l.children=l.children.sort((E,S)=>E.pid-S.pid)))}}function w(d){const b=/--utility-sub-type=network/i,y=/--ms-enable-electron-run-as-node/i,o=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,v=/--type=([a-zA-Z-]+)/;if(o.exec(d))return"electron-crash-reporter";if(g.exec(d))return"winpty-agent";if(l.exec(d))return"conpty-agent";let E=v.exec(d);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?b.exec(d)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const S=/[a-zA-Z-]+\.js/g;let t="";do E=S.exec(d),E&&(t+=E+" ");while(E);return t&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${t})`:y.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=b=>b.indexOf("\\\\?\\")===0||b.indexOf("\\??\\")===0?b.substring(4):b.indexOf('"\\\\?\\')===0||b.indexOf('"\\??\\')===0?'"'+b.substring(5):b;new Promise((b,y)=>{j(["@vscode/windows-process-tree"],b,y)}).then(b=>{b.getProcessList(M,y=>{if(!y){h(new Error(`Root process ${M} not found`));return}b.getProcessCpuUsage(y,o=>{const g=new Map;o.forEach(l=>{const v=d(l.commandLine||"");g.set(l.pid,{name:w(v),cmd:v,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),c=g.get(M),c?(g.forEach(l=>{const v=g.get(l.ppid);v&&(v.children||(v.children=[]),v.children.push(l))}),g.forEach(l=>{l.children&&(l.children=l.children.sort((v,E)=>v.pid-E.pid))}),I(c)):h(new Error(`Root process ${M} not found`))})},b.ProcessDataFlag.CommandLine|b.ProcessDataFlag.Memory)})}else{let d=function(){let b=[c];const y=[];for(;b.length;){const g=b.shift();g&&(y.push(g.pid),g.children&&(b=b.concat(g.children)))}let o=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);o+=" "+y.join(" "),(0,P.exec)(o,{},(g,l,v)=>{if(g||v)h(g||new Error(v.toString()));else{const E=l.toString().split(`
`);for(let S=0;S<y.length;S++){const t=m.get(y[S]);t.load=parseFloat(E[S])}if(!c){h(new Error(`Root process ${M} not found`));return}I(c)}})};(0,P.exec)("which ps",{},(b,y,o)=>{if(b||o)if(process.platform!=="linux")h(b||new Error(o.toString()));else{const g=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(g,{},(l,v,E)=>{l||E?h(l||new Error(E.toString())):(_(v,f),d())})}else{const g=y.toString().trim(),l="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${g} ${l}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,E,S)=>{v||S&&!S.includes("screen size is bogus")?h(v||new Error(S.toString())):(_(E,f),process.platform==="linux"?d():c?I(c):h(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=s;function _(M,I){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=M.toString().split(`
`);for(const m of c){const f=h.exec(m.trim());f&&f.length===6&&I(parseInt(f[1]),parseInt(f[2]),f[5],parseFloat(f[3]),parseFloat(f[4]))}}}),define(te[108],ie([0,1,27,4,106,89]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function M(f,w){return f===1?L.isWindows?m():_.getWindowsShell(w):h(f,w)}e.getSystemShell=M;let I=null;function h(f,w){if(L.isLinux&&f===2||L.isMacintosh&&f===3)return"/bin/bash";if(!I){let d;if(L.isWindows)d="/bin/bash";else{if(d=w.SHELL,!d)try{d=(0,P.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}I=d}return I}let c=null;async function m(){return c||(c=(await(0,s.getFirstAvailablePowerShellInstallation)()).exePath),c}});var Se=this&&this.__decorate||function(j,e,P,L){var s=arguments.length,_=s<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,P):L,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(j,e,P,L);else for(var I=j.length-1;I>=0;I--)(M=j[I])&&(_=(s<3?M(_):s>3?M(e,P,_):M(e,P))||_);return s>3&&_&&Object.defineProperty(e,P,_),_};define(te[43],ie([0,1,24,8,17,21,55,13,3,2,74,25,10]),function(j,e,P,L,s,_,M,I,h,c,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(d||(d={}));function b(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(y||(y={}));function o(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(g||(g={}));function l(F){let N=0;for(let B=0;;B+=7){const V=F.read(1);if(N|=(V.buffer[0]&127)<<B,!(V.buffer[0]&128))return N}}const v=r(0);function E(F,N){if(N===0){F.write(v);return}let B=0;for(let X=N;X!==0;X=X>>>7)B++;const V=s.VSBuffer.alloc(B);for(let X=0;N!==0;X++)V.buffer[X]=N&127,N=N>>>7,N>0&&(V.buffer[X]|=128);F.write(V)}class S{constructor(N){this.buffer=N,this.pos=0}read(N){const B=this.buffer.slice(this.pos,this.pos+N);return this.pos+=B.byteLength,B}}e.BufferReader=S;class t{constructor(){this.buffers=[]}get buffer(){return s.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}e.BufferWriter=t;var u;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object",F[F.Int=6]="Int"})(u||(u={}));function r(F){const N=s.VSBuffer.alloc(1);return N.writeUInt8(F,0),N}const n={Undefined:r(u.Undefined),String:r(u.String),Buffer:r(u.Buffer),VSBuffer:r(u.VSBuffer),Array:r(u.Array),Object:r(u.Object),Uint:r(u.Int)},i=typeof Buffer<"u";function a(F,N){if(typeof N>"u")F.write(n.Undefined);else if(typeof N=="string"){const B=s.VSBuffer.fromString(N);F.write(n.String),E(F,B.byteLength),F.write(B)}else if(i&&Buffer.isBuffer(N)){const B=s.VSBuffer.wrap(N);F.write(n.Buffer),E(F,B.byteLength),F.write(B)}else if(N instanceof s.VSBuffer)F.write(n.VSBuffer),E(F,N.byteLength),F.write(N);else if(Array.isArray(N)){F.write(n.Array),E(F,N.length);for(const B of N)a(F,B)}else if(typeof N=="number"&&(N|0)===N)F.write(n.Uint),E(F,N);else{const B=s.VSBuffer.fromString(JSON.stringify(N));F.write(n.Object),E(F,B.byteLength),F.write(B)}}e.serialize=a;function p(F){switch(F.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return F.read(l(F)).toString();case u.Buffer:return F.read(l(F)).buffer;case u.VSBuffer:return F.read(l(F));case u.Array:{const B=l(F),V=[];for(let X=0;X<B;X++)V.push(p(F));return V}case u.Object:return JSON.parse(F.read(l(F)).toString());case u.Int:return l(F)}}e.deserialize=p;class C{constructor(N,B,V=null,X=1e3){this.protocol=N,this.ctx=B,this.logger=V,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ce=>this.onRawMessage(ce)),this.sendResponse({type:200})}registerChannel(N,B){this.channels.set(N,B),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const B=this.send([N.type]);this.logger?.logOutgoing(B,0,1,o(N.type));return}case 201:case 202:case 204:case 203:{const B=this.send([N.type,N.id],N.data);this.logger?.logOutgoing(B,N.id,1,o(N.type),N.data);return}}}send(N,B=void 0){const V=new t;return a(V,N),a(V,B),this.sendBuffer(V.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch{return 0}}onRawMessage(N){const B=new S(N),V=p(B),X=p(B),ce=V[0];switch(ce){case 100:return this.logger?.logIncoming(N.byteLength,V[1],1,`${b(ce)}: ${V[2]}.${V[3]}`,X),this.onPromise({type:ce,id:V[1],channelName:V[2],name:V[3],arg:X});case 102:return this.logger?.logIncoming(N.byteLength,V[1],1,`${b(ce)}: ${V[2]}.${V[3]}`,X),this.onEventListen({type:ce,id:V[1],channelName:V[2],name:V[3],arg:X});case 101:return this.logger?.logIncoming(N.byteLength,V[1],1,`${b(ce)}`),this.disposeActiveRequest({type:ce,id:V[1]});case 103:return this.logger?.logIncoming(N.byteLength,V[1],1,`${b(ce)}`),this.disposeActiveRequest({type:ce,id:V[1]})}}onPromise(N){const B=this.channels.get(N.channelName);if(!B){this.collectPendingRequest(N);return}const V=new _.CancellationTokenSource;let X;try{X=B.call(this.ctx,N.name,N.arg,V.token)}catch(T){X=Promise.reject(T)}const ce=N.id;X.then(T=>{this.sendResponse({id:ce,data:T,type:201}),this.activeRequests.delete(N.id)},T=>{T instanceof Error?this.sendResponse({id:ce,data:{message:T.message,name:T.name,stack:T.stack?T.stack.split?T.stack.split(`
`):T.stack:void 0},type:202}):this.sendResponse({id:ce,data:T,type:203}),this.activeRequests.delete(N.id)});const oe=(0,c.toDisposable)(()=>V.cancel());this.activeRequests.set(N.id,oe)}onEventListen(N){const B=this.channels.get(N.channelName);if(!B){this.collectPendingRequest(N);return}const V=N.id,ce=B.listen(this.ctx,N.name,N.arg)(oe=>this.sendResponse({id:V,data:oe,type:204}));this.activeRequests.set(N.id,ce)}disposeActiveRequest(N){const B=this.activeRequests.get(N.id);B&&(B.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let B=this.pendingRequests.get(N.channelName);B||(B=[],this.pendingRequests.set(N.channelName,B));const V=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);B.push({request:N,timeoutTimer:V})}flushPendingRequests(N){const B=this.pendingRequests.get(N);if(B){for(const V of B)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=C;var k;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class D{constructor(N,B=null){this.protocol=N,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=B}getChannel(N){const B=this;return{call(V,X,ce){return B.isDisposed?Promise.reject(new I.CancellationError):B.requestPromise(N,V,X,ce)},listen(V,X){return B.isDisposed?h.Event.None:B.requestEvent(N,V,X)}}}requestPromise(N,B,V,X=_.CancellationToken.None){const ce=this.lastRequestId++,T={id:ce,type:100,channelName:N,name:B,arg:V};if(X.isCancellationRequested)return Promise.reject(new I.CancellationError);let R;return new Promise((H,x)=>{if(X.isCancellationRequested)return x(new I.CancellationError);const z=()=>{const le=ge=>{switch(ge.type){case 201:this.handlers.delete(ce),H(ge.data);break;case 202:{this.handlers.delete(ce);const Ce=new Error(ge.data.message);Ce.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,Ce.name=ge.data.name,x(Ce);break}case 203:this.handlers.delete(ce),x(ge.data);break}};this.handlers.set(ce,le),this.sendRequest(T)};let $=null;this.state===g.Idle?z():($=(0,L.createCancelablePromise)(le=>this.whenInitialized()),$.then(()=>{$=null,z()}));const K=()=>{$?($.cancel(),$=null):this.sendRequest({id:ce,type:101}),x(new I.CancellationError)},re=X.onCancellationRequested(K);R=(0,c.combinedDisposable)((0,c.toDisposable)(K),re),this.activeRequests.add(R)}).finally(()=>{this.activeRequests.delete(R)})}requestEvent(N,B,V){const X=this.lastRequestId++,oe={id:X,type:102,channelName:N,name:B,arg:V};let T=null;const R=new h.Emitter({onWillAddFirstListener:()=>{T=(0,L.createCancelablePromise)(H=>this.whenInitialized()),T.then(()=>{T=null,this.activeRequests.add(R),this.sendRequest(oe)})},onDidRemoveLastListener:()=>{T?(T.cancel(),T=null):(this.activeRequests.delete(R),this.sendRequest({id:X,type:103}))}}),W=H=>R.fire(H.data);return this.handlers.set(X,W),R.event}sendRequest(N){switch(N.type){case 100:case 102:{const B=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger?.logOutgoing(B,N.id,0,`${b(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const B=this.send([N.type,N.id]);this.logger?.logOutgoing(B,N.id,0,b(N.type));return}}}send(N,B=void 0){const V=new t;return a(V,N),a(V,B),this.sendBuffer(V.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch{return 0}}onBuffer(N){const B=new S(N),V=p(B),X=p(B),ce=V[0];switch(ce){case 200:return this.logger?.logIncoming(N.byteLength,0,0,o(ce)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(N.byteLength,V[1],0,o(ce),X),this.onResponse({type:V[0],id:V[1],data:X})}}onResponse(N){if(N.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}this.handlers.get(N.id)?.(N)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=D,Se([M.memoize],D.prototype,"onDidInitializePromise",null);class A{get connections(){const N=[];return this._connections.forEach(B=>N.push(B)),N}constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:B,onDidClientDisconnect:V})=>{h.Event.once(B.onMessage)(ce=>{const oe=new S(ce),T=p(oe),R=new C(B,T),W=new D(B);this.channels.forEach((x,z)=>R.registerChannel(z,x));const H={channelServer:R,channelClient:W,ctx:T};this._connections.add(H),this._onDidAddConnection.fire(H),V(()=>{R.dispose(),W.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)})})})}getChannel(N,B){const V=this;return{call(X,ce,oe){let T;if((0,w.isFunction)(B)){const W=(0,P.getRandomElement)(V.connections.filter(B));T=W?Promise.resolve(W):h.Event.toPromise(h.Event.filter(V.onDidAddConnection,B))}else T=B.routeCall(V,X,ce);const R=T.then(W=>W.channelClient.getChannel(N));return U(R).call(X,ce,oe)},listen(X,ce){if((0,w.isFunction)(B))return V.getMulticastEvent(N,B,X,ce);const oe=B.routeEvent(V,X,ce).then(T=>T.channelClient.getChannel(N));return U(oe).listen(X,ce)}}}getMulticastEvent(N,B,V,X){const ce=this;let oe=new c.DisposableStore;const T=new h.Emitter({onWillAddFirstListener:()=>{oe=new c.DisposableStore;const R=new h.EventMultiplexer,W=new Map,H=z=>{const K=z.channelClient.getChannel(N).listen(V,X),re=R.add(K);W.set(z,re)},x=z=>{const $=W.get(z);$&&($.dispose(),W.delete(z))};ce.connections.filter(B).forEach(H),h.Event.filter(ce.onDidAddConnection,B)(H,void 0,oe),ce.onDidRemoveConnection(x,void 0,oe),R.event(T.fire,T,oe),oe.add(R)},onDidRemoveLastListener:()=>{oe.dispose()}});return T.event}registerChannel(N,B){this.channels.set(N,B),this._connections.forEach(V=>{V.channelServer.registerChannel(N,B)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class O{constructor(N,B,V=null){const X=new t;a(X,B),N.send(X.buffer),this.channelClient=new D(N,V),this.channelServer=new C(N,B,V)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,B){this.channelServer.registerChannel(N,B)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function U(F){return{call(N,B,V){return F.then(X=>X.call(N,B,V))},listen(N,B){const V=new h.Relay;return F.then(X=>V.input=X.listen(N,B)),V.event}}}e.getDelayedChannel=U;function q(F){let N=!1;return{call(B,V,X){return N?F.call(B,V,X):(0,L.timeout)(0).then(()=>N=!0).then(()=>F.call(B,V,X))},listen(B,V){if(N)return F.listen(B,V);const X=new h.Relay;return(0,L.timeout)(0).then(()=>N=!0).then(()=>X.input=F.listen(B,V)),X.event}}}e.getNextTickChannel=q;class se{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const B of N.connections)if(await Promise.resolve(this.fn(B.ctx)))return Promise.resolve(B);return await h.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=se;var ne;(function(F){function N(ce,oe){const T=ce,R=oe&&oe.disableMarshalling,W=new Map;for(const H in T)V(H)&&W.set(H,h.Event.buffer(T[H],!0));return new class{listen(H,x,z){const $=W.get(x);if($)return $;if(X(x)){const K=T[x];if(typeof K=="function")return K.call(T,z)}throw new I.ErrorNoTelemetry(`Event not found: ${x}`)}call(H,x,z){const $=T[x];if(typeof $=="function"){if(!R&&Array.isArray(z))for(let K=0;K<z.length;K++)z[K]=(0,m.revive)(z[K]);return $.apply(T,z)}throw new I.ErrorNoTelemetry(`Method not found: ${x}`)}}}F.fromService=N;function B(ce,oe){const T=oe&&oe.disableMarshalling;return new Proxy({},{get(R,W){if(typeof W=="string")return oe?.properties?.has(W)?oe.properties.get(W):X(W)?function(H){return ce.listen(W,H)}:V(W)?ce.listen(W):async function(...H){let x;oe&&!(0,w.isUndefinedOrNull)(oe.context)?x=[oe.context,...H]:x=H;const z=await ce.call(W,x);return T?z:(0,m.revive)(z)};throw new I.ErrorNoTelemetry(`Property not found: ${String(W)}`)}})}F.toService=B;function V(ce){return ce[0]==="o"&&ce[1]==="n"&&f.isUpperAsciiLetter(ce.charCodeAt(2))}function X(ce){return/^onDynamic/.test(ce)&&f.isUpperAsciiLetter(ce.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ae(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const N=F.toString();if(N!=="[object Object]")return N}return F}function ue(F){return Array.isArray(F)?F.map(ae):ae(F)}function G(F,N,B,V,X,ce,oe){oe=ue(oe);const T=ee[X],R=T[V%T.length];let W=[`%c[${F}]%c[${String(N).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${R}`];/\($/.test(ce)?(W=W.concat(oe),W.push(")")):W.push(oe),console.log.apply(console,W)}class Y{constructor(N,B){this._outgoingPrefix=N,this._incomingPrefix=B,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,B,V,X,ce){this._totalOutgoing+=N,G(this._outgoingPrefix,this._totalOutgoing,N,B,V,X,ce)}logIncoming(N,B,V,X,ce){this._totalIncoming+=N,G(this._incomingPrefix,this._totalIncoming,N,B,V,X,ce)}}e.IPCLogger=Y}),define(te[156],ie([0,1,17,3,43]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class _{constructor(h){this.port=h,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",c=>P.VSBuffer.wrap(c.data)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=_;class M extends s.IPCClient{constructor(h,c){const m=new _(h);super(m,c),this.protocol=m}dispose(){this.protocol.disconnect()}}e.Client=M}),define(te[109],ie([0,1,17,3,2,43]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var I;(function(n){n.enableDiagnostics=!1,n.records=[];const i=new WeakMap;let a=0;function p(k,D){if(!i.has(k)){const A=String(++a);i.set(k,A)}return i.get(k)}function C(k,D,A,O){if(!n.enableDiagnostics)return;const U=p(k,D);if(O instanceof P.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const q=P.VSBuffer.alloc(O.byteLength);q.set(O),n.records.push({timestamp:Date.now(),id:U,label:D,type:A,buff:q})}else n.records.push({timestamp:Date.now(),id:U,label:D,type:A,data:O})}n.traceSocketEvent=C})(I||(e.SocketDiagnostics=I={}));var h;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let c=null;function m(){return c||(c=P.VSBuffer.alloc(0)),c}class f{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,a){if(i===0)return m();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const D=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=i),D}if(this._chunks[0].byteLength>i){const D=this._chunks[0].slice(0,i);return a&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),D}const p=P.VSBuffer.alloc(i);let C=0,k=0;for(;i>0;){const D=this._chunks[k];if(D.byteLength>i){const A=D.slice(0,i);p.set(A,C),C+=i,a&&(this._chunks[k]=D.slice(i),this._totalLength-=i),i-=i}else p.set(D,C),C+=D.byteLength,a?(this._chunks.shift(),this._totalLength-=D.byteLength):k++,i-=D.byteLength}return p}}e.ChunkStream=f;var w;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(w||(w={}));function d(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var b;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(b||(e.ProtocolConstants=b={}));class y{constructor(i,a,p,C){this.type=i,this.id=a,this.ack=p,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class o extends s.Disposable{constructor(i){super(),this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new f,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:d(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const p=this._state.messageType,C=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new y(p,C,k,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(i){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=P.VSBuffer.alloc(13);a.writeUInt8(i.type,0),a.writeUInt32BE(i.id,1),a.writeUInt32BE(i.ack,5),a.writeUInt32BE(i.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:d(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",i.data),this._writeSoon(a,i.data)}_bufferAdd(i,a){const p=this._totalLength===0;return this._data.push(i,a),this._totalLength+=i.byteLength+a.byteLength,p}_bufferTake(){const i=P.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,a){this._bufferAdd(i,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const i=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this._socket.write(i)}}class l extends s.Disposable{constructor(i){super(),this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new o(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new y(1,0,0,i))}}e.Protocol=l;class v extends _.IPCClient{static fromSocket(i,a){return new v(new l(i),a)}get onDidDispose(){return this.protocol.onDidDispose}constructor(i,a,p=null){super(i,a,p),this.protocol=i}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=v;class E{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=E;class S{constructor(i){this.data=i,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let i=0,a=this._first;for(;a;)a=a.next,i++;return i}peek(){return this._first?this._first.data:null}toArray(){const i=[];let a=0,p=this._first;for(;p;)i[a++]=p.data,p=p.next;return i}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const a=new S(i);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class u{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}constructor(){this.lastRuns=[];const i=Date.now();for(let a=0;a<u._HISTORY_LENGTH;a++)this.lastRuns[a]=i-1e3*a;setInterval(()=>{for(let a=u._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}load(){const i=Date.now(),a=(1+u._HISTORY_LENGTH)*1e3;let p=0;for(let C=0;C<u._HISTORY_LENGTH;C++)i-this.lastRuns[C]<=a&&p++;return 1-p/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class r{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(i){this._onControlMessage=new E,this.onControlMessage=this._onControlMessage.event,this._onMessage=new E,this.onMessage=this._onMessage.event,this._onDidDispose=new E,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new E,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new E,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=i.loadEstimator??u.getInstance(),this._shouldSendKeepAlive=i.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new s.DisposableStore,this._socket=i.socket,this._socketWriter=this._socketDisposables.add(new g(this._socket)),this._socketReader=this._socketDisposables.add(new o(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.add(this._socket.onClose(a=>this._onSocketClose.fire(a))),i.initialChunk&&this._socketReader.acceptChunk(i.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new y(5,0,0,m());this._socketWriter.write(i),this._socketWriter.flush()}sendPause(){const i=new y(7,0,0,m());this._socketWriter.write(i)}sendResume(){const i=new y(8,0,0,m());this._socketWriter.write(i)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,a){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new s.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=i,this._socketWriter=this._socketDisposables.add(new g(this._socket)),this._socketReader=this._socketDisposables.add(new o(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.add(this._socket.onClose(p=>this._onSocketClose.fire(p))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const i=new y(3,0,this._incomingAckId,m());this._socketWriter.write(i);const a=this._outgoingUnackMsg.toArray();for(let p=0,C=a.length;p<C;p++)this._socketWriter.write(a[p]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new y(6,0,0,m())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data);break}case 2:{this._onControlMessage.fire(i.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let p=0,C=a.length;p<C;p++)this._socketWriter.write(a[p]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const p=new y(1,a,this._incomingAckId,i);this._outgoingUnackMsg.push(p),this._isReconnecting||(this._socketWriter.write(p),this._recvAckCheck())}sendControl(i){const a=new y(2,0,0,i);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),a=Date.now()-i.writtenTime,p=Date.now()-this._socketReader.lastReadTime,C=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&p>=2e4&&C>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:p});return}const k=Math.max(2e4-a,2e4-p,2e4-C,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},k)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new y(3,0,this._incomingAckId,m());this._socketWriter.write(i)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const i=new y(9,0,this._incomingAckId,m());this._socketWriter.write(i)}}e.PersistentProtocol=r}),define(te[157],ie([0,1,38,17,3,2,43,145]),function(j,e,P,L,s,_,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(m,f){const w=s.Event.fromNodeEventEmitter(P.validatedIpcMain,f,(b,y)=>({event:b,message:y})),d=s.Event.filter(w,({event:b})=>b.sender.id===m);return s.Event.map(d,({message:b})=>b&&L.VSBuffer.wrap(b))}class c extends M.IPCServer{static{this.Clients=new Map}static getOnDidClientConnect(){const f=s.Event.fromNodeEventEmitter(P.validatedIpcMain,"vscode:hello",({sender:w})=>w);return s.Event.map(f,w=>{const d=w.id;c.Clients.get(d)?.dispose();const y=new s.Emitter;c.Clients.set(d,(0,_.toDisposable)(()=>y.fire()));const o=h(d,"vscode:message"),g=s.Event.any(s.Event.signal(h(d,"vscode:disconnect")),y.event);return{protocol:new I.Protocol(w,o),onDidClientDisconnect:g}})}constructor(){super(c.getOnDidClientConnect())}}e.Server=c}),define(te[110],ie([0,1,38,3,31,156]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends _.Client{constructor(c,m){super({addEventListener:(f,w)=>c.addListener(f,w),removeEventListener:(f,w)=>c.removeListener(f,w),postMessage:f=>c.postMessage(f),start:()=>c.start(),close:()=>c.close()},m)}}e.Client=M;async function I(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,s.generateUuid)();h.webContents.send("vscode:createMessageChannel",c);const m=L.Event.fromNodeEventEmitter(P.validatedIpcMain,"vscode:createMessageChannelResult",(w,d)=>({nonce:d,port:w.ports[0]})),{port:f}=await L.Event.toPromise(L.Event.once(L.Event.filter(m,w=>w.nonce===c)));return f}e.connect=I}),define(te[158],ie([0,1,47,8,17,21,153,13,3,2,37,89,73,43]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class b extends d.ChannelServer{constructor(g){super({send:l=>{try{process.send?.(l.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",l=>s.VSBuffer.wrap(Buffer.from(l,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.Server=b;class y{constructor(g,l){this.modulePath=g,this.options=l,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=l&&l.timeout?l.timeout:6e4;this.disposeDelayer=new L.Delayer(v),this.child=null,this._client=null}getChannel(g){const l=this;return{call(v,E,S){return l.requestPromise(g,v,E,S)},listen(v,E){return l.requestEvent(g,v,E)}}}requestPromise(g,l,v,E=_.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const S=this.getCachedChannel(g),t=(0,L.createCancelablePromise)(n=>S.call(l,v,n)),u=E.onCancellationRequested(()=>t.cancel()),r=(0,c.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{u.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(g,l,v){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let E;const S=new h.Emitter({onWillAddFirstListener:()=>{E=this.getCachedChannel(g).listen(l,v)(S.fire,S),this.activeRequests.add(E)},onDidRemoveLastListener:()=>{this.activeRequests.delete(E),E.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return S.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],l=Object.create(null);l.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(l.env={...l.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(l.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,w.removeDangerousEnvVariables)(l.env),this.child=(0,P.fork)(this.modulePath,g,l);const v=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,M.isRemoteConsoleLog)(i)){(0,M.log)(i,`IPC Library: ${this.options.serverName}`);return}v.fire(s.VSBuffer.wrap(Buffer.from(i,"base64")))});const S=this.options.useQueue?(0,f.createQueuedSender)(this.child):this.child,t=i=>this.child&&this.child.connected&&S.send(i.buffer.toString("base64")),u=v.event,r={send:t,onMessage:u};this._client=new d.ChannelClient(r);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,a)=>{process.removeListener("exit",n),this.activeRequests.forEach(p=>(0,c.dispose)(p)),this.activeRequests.clear(),i!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:a})})}return this._client}getCachedChannel(g){let l=this.channels.get(g);return l||(l=this.client.getChannel(g),this.channels.set(g,l)),l}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(te[111],ie([0,1,8,3,2,74,10]),function(j,e,P,L,s,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var I;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function h(w){const d=w;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=h;var c;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(c||(e.StorageState=c={}));class m extends s.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(d,b=Object.create(null)){super(),this.database=d,this.options=b,this._onDidChangeStorage=this._register(new L.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new P.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){this._onDidChangeStorage.pause();try{d.changed?.forEach((b,y)=>this.acceptExternal(y,b)),d.deleted?.forEach(b=>this.acceptExternal(b,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(d,b){if(this.state===c.Closed)return;let y=!1;(0,M.isUndefinedOrNull)(b)?y=this.cache.delete(d):this.cache.get(d)!==b&&(this.cache.set(d,b),y=!0),y&&this._onDidChangeStorage.fire({key:d,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,b){const y=this.cache.get(d);return(0,M.isUndefinedOrNull)(y)?b:y}getBoolean(d,b){const y=this.get(d);return(0,M.isUndefinedOrNull)(y)?b:y==="true"}getNumber(d,b){const y=this.get(d);return(0,M.isUndefinedOrNull)(y)?b:parseInt(y,10)}getObject(d,b){const y=this.get(d);return(0,M.isUndefinedOrNull)(y)?b:(0,_.parse)(y)}async set(d,b,y=!1){if(this.state===c.Closed)return;if((0,M.isUndefinedOrNull)(b))return this.delete(d,y);const o=(0,M.isObject)(b)||Array.isArray(b)?(0,_.stringify)(b):String(b);if(this.cache.get(d)!==o)return this.cache.set(d,o),this.pendingInserts.set(d,o),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire({key:d,external:y}),this.doFlush()}async delete(d,b=!1){if(!(this.state===c.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire({key:d,external:b}),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}isInMemory(){return this.options.hint===I.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=m;class f{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert?.forEach((b,y)=>this.items.set(y,b)),d.delete?.forEach(b=>this.items.delete(b))}async close(){}}e.InMemoryStorageDatabase=f}),define(te[159],ie([0,1,8,3,35,9,22]),function(j,e,P,L,s,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return L.Event.None}static{this.BUSY_OPEN_TIMEOUT=2e3}static{this.MAX_HOST_PARAMETERS=256}constructor(m,f=Object.create(null)){this.path=m,this.options=f,this.name=(0,_.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const m=await this.whenConnected,f=new Map;return(await this.all(m,"SELECT * FROM ItemTable")).forEach(d=>f.set(d.key,d.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${f.size} rows`),f}async updateItems(m){const f=await this.whenConnected;return this.doUpdateItems(f,m)}doUpdateItems(m,f){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${f.insert?(0,s.mapToString)(f.insert):"0"}), delete(${f.delete?(0,s.setToString)(f.delete):"0"})`),this.transaction(m,()=>{const w=f.insert,d=f.delete;if(w&&w.size>0){const b=[];b.push([]);let y=0;w.forEach((o,g)=>{let l=b[y];l.length>I.MAX_HOST_PARAMETERS&&(y++,l=[],b.push(l)),l.push(g,o)}),b.forEach(o=>{this.prepare(m,`INSERT INTO ItemTable VALUES ${new Array(o.length/2).fill("(?,?)").join(",")}`,g=>g.run(o),()=>{const g=[];let l=0;return w.forEach((v,E)=>{g.push(E),l+=v.length}),`Keys: ${g.join(", ")} Length: ${l}`})})}if(d&&d.size){const b=[];b.push([]);let y=0;d.forEach(o=>{let g=b[y];g.length>I.MAX_HOST_PARAMETERS&&(y++,g=[],b.push(g)),g.push(o)}),b.forEach(o=>{this.prepare(m,`DELETE FROM ItemTable WHERE key IN (${new Array(o.length).fill("?").join(",")})`,g=>g.run(o),()=>{const g=[];return d.forEach(l=>{g.push(l)}),`Keys: ${g.join(", ")}`})})}})}async close(m){this.logger.trace(`[storage ${this.name}] close()`);const f=await this.whenConnected;return this.doClose(f,m)}doClose(m,f){return new Promise((w,d)=>{m.db.close(b=>(b&&this.handleSQLiteError(m,`[storage ${this.name}] close(): ${b}`),this.path===I.IN_MEMORY_PATH?w():!m.isErroneous&&!m.isInMemory?this.backup().then(w,y=>(this.logger.error(`[storage ${this.name}] backup(): ${y}`),w())):typeof f=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(y=>{const o=()=>this.doClose(y,void 0);return this.doUpdateItems(y,{insert:f()}).then(()=>o(),g=>(o(),Promise.reject(g)))})).then(w,d):d(b||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const m=this.toBackupPath(this.path);return M.Promises.copy(this.path,m,{preserveSymlinks:!1})}toBackupPath(m){return`${m}.backup`}async checkIntegrity(m){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${m})`);const f=await this.whenConnected,w=await this.get(f,m?"PRAGMA integrity_check":"PRAGMA quick_check"),d=m?w.integrity_check:w.quick_check;return f.isErroneous?`${d} (last error: ${f.lastError})`:f.isInMemory?`${d} (in-memory!)`:d}async connect(m,f=!0){this.logger.trace(`[storage ${this.name}] open(${m}, retryOnBusy: ${f})`);try{return await this.doConnect(m)}catch(w){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${w}`),w.code==="SQLITE_BUSY"&&f)return await(0,P.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(m,!1);try{await M.Promises.unlink(m);try{await M.Promises.rename(this.toBackupPath(m),m)}catch{}return await this.doConnect(m)}catch(d){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${d}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(m,f){m.isErroneous=!0,m.lastError=f,this.logger.error(f)}doConnect(m){return new Promise((f,w)=>{new Promise((d,b)=>{j(["@vscode/sqlite3"],d,b)}).then(d=>{const b={db:new(this.logger.isTracing?d.verbose().Database:d.Database)(m,y=>y?b.db&&y.code!=="SQLITE_CANTOPEN"?b.db.close(()=>w(y)):w(y):this.exec(b,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>f(b),o=>b.db.close(()=>w(o)))),isInMemory:m===I.IN_MEMORY_PATH};b.db.on("error",y=>this.handleSQLiteError(b,`[storage ${this.name}] Error (event): ${y}`)),this.logger.isTracing&&b.db.on("trace",y=>this.logger.trace(`[storage ${this.name}] Trace (event): ${y}`))},w)})}exec(m,f){return new Promise((w,d)=>{m.db.exec(f,b=>b?(this.handleSQLiteError(m,`[storage ${this.name}] exec(): ${b}`),d(b)):w())})}get(m,f){return new Promise((w,d)=>{m.db.get(f,(b,y)=>b?(this.handleSQLiteError(m,`[storage ${this.name}] get(): ${b}`),d(b)):w(y))})}all(m,f){return new Promise((w,d)=>{m.db.all(f,(b,y)=>b?(this.handleSQLiteError(m,`[storage ${this.name}] all(): ${b}`),d(b)):w(y))})}transaction(m,f){return new Promise((w,d)=>{m.db.serialize(()=>{m.db.run("BEGIN TRANSACTION"),f(),m.db.run("END TRANSACTION",b=>b?(this.handleSQLiteError(m,`[storage ${this.name}] transaction(): ${b}`),d(b)):w())})})}prepare(m,f,w,d){const b=m.db.prepare(f),y=o=>{this.handleSQLiteError(m,`[storage ${this.name}] prepare(): ${o} (${f}). Details: ${d()}`)};b.on("error",y),w(b),b.finalize(o=>{o&&y(o),b.removeListener("error",y)})}}e.SQLiteStorageDatabase=I;class h{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor(m){m&&typeof m.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=m.logTrace),m&&typeof m.logError=="function"&&(this.logError=m.logError)}get isTracing(){return!!this.logTrace}trace(m){this.logTrace?.(m)}error(m){this.logError?.(m)}}}),define(te[160],ie([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(te[161],ie([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[162],ie([12,11]),function(j,e){return j.create("vs/platform/contextkey/common/contextkey",e)}),define(te[163],ie([12,11]),function(j,e){return j.create("vs/platform/contextkey/common/scanner",e)}),define(te[164],ie([12,11]),function(j,e){return j.create("vs/platform/dialogs/common/dialogs",e)}),define(te[165],ie([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[166],ie([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(te[167],ie([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(te[168],ie([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[169],ie([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[170],ie([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[171],ie([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[172],ie([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[173],ie([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(te[174],ie([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(te[175],ie([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(te[176],ie([12,11]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[177],ie([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[178],ie([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[179],ie([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[180],ie([12,11]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[181],ie([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(te[182],ie([12,11]),function(j,e){return j.create("vs/platform/shell/node/shellEnv",e)}),define(te[183],ie([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[184],ie([12,11]),function(j,e){return j.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[185],ie([12,11]),function(j,e){return j.create("vs/platform/terminal/common/terminalProfiles",e)}),define(te[186],ie([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(te[187],ie([12,11]),function(j,e){return j.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[188],ie([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[189],ie([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[190],ie([12,11]),function(j,e){return j.create("vs/platform/workspace/common/workspace",e)}),define(te[191],ie([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[192],ie([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[193],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function P(s){return s&&s.hasOwnProperty("folderUri")}e.isFolderBackupInfo=P;function L(s){return s&&s.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=L}),define(te[194],ie([0,1,7]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function L(M){return typeof M?.backupFolder=="string"}e.isEmptyWindowBackupInfo=L;function s(M){let I=[];try{Array.isArray(M.workspaces)&&(I=M.workspaces.map(h=>({workspace:{id:h.id,configPath:P.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return I}e.deserializeWorkspaceInfos=s;function _(M){let I=[];try{Array.isArray(M.folders)&&(I=M.folders.map(h=>({folderUri:P.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return I}e.deserializeFolderInfos=_}),define(te[195],ie([0,1,13,163]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var s;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(s||(e.TokenType=s={}));function _(...c){switch(c.length){case 1:return(0,L.localize)(0,null,c[0]);case 2:return(0,L.localize)(1,null,c[0],c[1]);case 3:return(0,L.localize)(2,null,c[0],c[1],c[2]);default:return}}const M=(0,L.localize)(3,null),I=(0,L.localize)(4,null);class h{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(m){switch(m.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return m.isTripleEq?"===":"==";case 4:return m.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return m.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return m.lexeme;case 18:return m.lexeme;case 19:return m.lexeme;case 20:return"EOF";default:throw(0,P.illegalState)(`unhandled token type: ${JSON.stringify(m)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(m){return this._input=m,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const f=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:f})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const f=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:f})}else this._match(126)?this._addToken(9):this._error(_("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(_("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(_("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(m){return this._isAtEnd()||this._input.charCodeAt(this._current)!==m?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(m){this._tokens.push({type:m,offset:this._start})}_error(m){const f=this._start,w=this._input.substring(this._start,this._current),d={type:19,offset:this._start,lexeme:w};this._errors.push({offset:f,lexeme:w,additionalInfo:m}),this._tokens.push(d)}_string(){this.stringRe.lastIndex=this._start;const m=this.stringRe.exec(this._input);if(m){this._current=this._start+m[0].length;const f=this._input.substring(this._start,this._current),w=h._keywords.get(f);w?this._addToken(w):this._tokens.push({type:17,lexeme:f,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(M);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let m=this._current,f=!1,w=!1;for(;;){if(m>=this._input.length){this._current=m,this._error(I);return}const b=this._input.charCodeAt(m);if(f)f=!1;else if(b===47&&!w){m++;break}else b===91?w=!0:b===92?f=!0:b===93&&(w=!1);m++}for(;m<this._input.length&&h._regexFlags.has(this._input.charCodeAt(m));)m++;this._current=m;const d=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:d,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=h}),define(te[196],ie([0,1,3,2]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class s{constructor(){this._onCloseEmitter=new P.Emitter,this._onReloadEmitter=new P.Emitter,this._onTerminateEmitter=new P.Emitter,this._onAttachEmitter=new P.Emitter}static{this.ChannelName="extensionhostdebugservice"}call(I,h,c){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(I,h,c){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=s;class _ extends L.Disposable{constructor(I){super(),this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,h,c){this.channel.call("attach",[I,h,c])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,h){this.channel.call("terminate",[I,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,h){return this.channel.call("openExtensionDevelopmentHostWindow",[I,h])}}e.ExtensionHostDebugChannelClient=_}),define(te[197],ie([0,1,148,55,15,9,36,19,7]),function(j,e,P,L,s,_,M,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,_.dirname)(s.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,_.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,_.join)(this.userDataPath,"logs",d)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(h.URI.file((0,_.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=M.env.VSCODE_PORTABLE;return d?h.URI.file((0,_.join)(d,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,_.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,_.resolve)(d):(0,_.normalize)((0,_.join)(s.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?h.URI.file((0,_.resolve)(d)):h.URI.file((0,_.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,_.resolve)(d);const b=M.env.VSCODE_EXTENSIONS;if(b)return b;const y=M.env.VSCODE_PORTABLE;return y?(0,_.join)(y,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(b=>/^[^:/?#]+?:\/\//.test(b)?h.URI.parse(b):h.URI.file((0,_.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?h.URI.parse(d):h.URI.file((0,_.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const b of this.args.log||[]){const y=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(b);y&&y[1]&&y[2]&&d.push([y[1],y[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=M.env.VSCODE_PORTABLE;return d?h.URI.file((0,_.join)(d,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this._args}constructor(d,b,y){this._args=d,this.paths=b,this.productService=y,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=c,Se([L.memoize],c.prototype,"appRoot",null),Se([L.memoize],c.prototype,"userHome",null),Se([L.memoize],c.prototype,"userDataPath",null),Se([L.memoize],c.prototype,"appSettingsHome",null),Se([L.memoize],c.prototype,"tmpDir",null),Se([L.memoize],c.prototype,"cacheHome",null),Se([L.memoize],c.prototype,"stateResource",null),Se([L.memoize],c.prototype,"userRoamingDataHome",null),Se([L.memoize],c.prototype,"userDataSyncHome",null),Se([L.memoize],c.prototype,"sync",null),Se([L.memoize],c.prototype,"machineSettingsResource",null),Se([L.memoize],c.prototype,"workspaceStorageHome",null),Se([L.memoize],c.prototype,"localHistoryHome",null),Se([L.memoize],c.prototype,"keyboardLayoutResource",null),Se([L.memoize],c.prototype,"argvResource",null),Se([L.memoize],c.prototype,"isExtensionDevelopment",null),Se([L.memoize],c.prototype,"untitledWorkspacesHome",null),Se([L.memoize],c.prototype,"builtinExtensionsPath",null),Se([L.memoize],c.prototype,"extensionsPath",null),Se([L.memoize],c.prototype,"extensionDevelopmentLocationURI",null),Se([L.memoize],c.prototype,"extensionDevelopmentKind",null),Se([L.memoize],c.prototype,"extensionTestsLocationURI",null),Se([L.memoize],c.prototype,"debugExtensionHost",null),Se([L.memoize],c.prototype,"logLevel",null),Se([L.memoize],c.prototype,"extensionLogLevel",null),Se([L.memoize],c.prototype,"serviceMachineIdResource",null),Se([L.memoize],c.prototype,"disableTelemetry",null),Se([L.memoize],c.prototype,"disableWorkspaceTrust",null),Se([L.memoize],c.prototype,"policyFile",null);function m(w,d){return f(w["inspect-extensions"],w["inspect-brk-extensions"],5870,d,w.debugId,w.extensionEnvironment)}e.parseExtensionHostDebugPort=m;function f(w,d,b,y,o,g){const v=Number(d||w)||(y?null:b),E=v?!!d:!1;let S;if(g)try{S=JSON.parse(g)}catch{}return{port:v,break:E,debugId:o,env:S}}e.parseDebugParams=f}),define(te[112],ie([0,1,307,4,166]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const _={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(33,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(y,o,g=M){const l=y.find(a=>a.length>0&&a[0]!=="-"),v={},E=["_"],S=[],t={};let u;for(const a in o){const p=o[a];p.type==="subcommand"?a===l&&(u=p):(p.alias&&(v[a]=p.alias),p.type==="string"||p.type==="string[]"?(E.push(a),p.deprecates&&E.push(...p.deprecates)):p.type==="boolean"&&(S.push(a),p.deprecates&&S.push(...p.deprecates)),p.global&&(t[a]=p))}if(u&&l){const a=t;for(const D in u.options)a[D]=u.options[D];const p=y.filter(D=>D!==l),C=g.getSubcommandReporter?g.getSubcommandReporter(l):void 0,k=I(p,a,C);return{[l]:k,_:[]}}const r=P(y,{string:E,boolean:S,alias:v}),n={},i=r;n._=r._.map(a=>String(a)).filter(a=>a.length>0),delete i._;for(const a in o){const p=o[a];if(p.type==="subcommand")continue;p.alias&&delete i[p.alias];let C=i[a];if(p.deprecates)for(const k of p.deprecates)i.hasOwnProperty(k)&&(C||(C=i[k],C&&g.onDeprecatedOption(k,p.deprecationMessage||(0,s.localize)(36,null,a))),delete i[k]);if(typeof C<"u"){if(p.type==="string[]"){if(Array.isArray(C)||(C=[C]),!p.allowEmptyValue){const k=C.filter(D=>D.length>0);k.length!==C.length&&(g.onEmptyValue(a),C=k.length>0?k:void 0)}}else p.type==="string"&&(Array.isArray(C)?(C=C.pop(),g.onMultipleValues(a,C)):!C&&!p.allowEmptyValue&&(g.onEmptyValue(a),C=void 0));n[a]=C,p.deprecationMessage&&g.onDeprecatedOption(a,p.deprecationMessage)}delete i[a]}for(const a in i)g.onUnknownOption(a);return n}e.parseArgs=I;function h(y,o){let g="";return o.args&&(Array.isArray(o.args)?g=` <${o.args.join("> <")}>`:g=` <${o.args}>`),o.alias?`-${o.alias} --${y}${g}`:`--${y}${g}`}function c(y,o){const g=[];for(const l in y){const v=y[l],E=h(l,v);g.push([E,v.description])}return m(g,o)}e.formatOptions=c;function m(y,o){const l=y.reduce((S,t)=>Math.max(S,t[0].length),12)+2+1;if(o-l<25)return y.reduce((S,t)=>S.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const v=o-l-1,E=[];for(const S of y){const t=S[0],u=w(S[1],v),r=f(l-t.length-2);E.push("  "+t+r+u[0]);for(let n=1;n<u.length;n++)E.push(f(l)+u[n])}return E}function f(y){return" ".repeat(y)}function w(y,o){const g=[];for(;y.length;){const l=y.length<o?y.length:y.lastIndexOf(" ",o),v=y.slice(0,l).trim();y=y.slice(l),g.push(v)}return g}function d(y,o,g,l,v){const E=process.stdout.isTTY&&process.stdout.columns||80,S=v?.noInputFiles!==!0?`[${(0,s.localize)(37,null)}...]`:"",t=[`${y} ${g}`];t.push(""),t.push(`${(0,s.localize)(38,null)}: ${o} [${(0,s.localize)(39,null)}]${S}`),t.push(""),v?.noPipe!==!0&&(L.isWindows?t.push((0,s.localize)(40,null,o)):t.push((0,s.localize)(41,null,o)),t.push(""));const u={},r=[];for(const n in l){const i=l[n];if(i.type==="subcommand")i.description&&r.push({command:n,description:i.description});else if(i.description&&i.cat){let a=u[i.cat];a||(u[i.cat]=a={}),a[n]=i}}for(const n in u){const i=n,a=u[i];a&&(t.push(_[i]),t.push(...c(a,E)),t.push(""))}return r.length&&(t.push((0,s.localize)(42,null)),t.push(...m(r.map(n=>[n.command,n.description]),E)),t.push("")),t.join(`
`)}e.buildHelpMessage=d;function b(y,o){return`${y||(0,s.localize)(43,null)}
${o||(0,s.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=b}),define(te[198],ie([0,1,88,196,112]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class _ extends L.ExtensionHostDebugBroadcastChannel{constructor(I){super(),this.windowsMainService=I}call(I,h,c){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(c[0],c[1]):super.call(I,h,c)}async openExtensionDevelopmentHostWindow(I,h){const c=(0,s.parseArgs)(I,s.OPTIONS);c.debugRenderer=h;const m=c.extensionDevelopmentPath;if(!m)return{success:!1};const[f]=await this.windowsMainService.openExtensionDevelopmentHostWindow(m,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!h)return{success:!0};const w=f.win;if(!w)return{success:!0};const d=w.webContents.debugger;let b=d.isAttached()?1/0:0;const y=(0,P.createServer)(o=>{b++===0&&d.attach();let g=!1;const l=S=>{g||o.write(JSON.stringify(S)+"\0")},v=(S,t,u,r)=>l({method:t,params:u,sessionId:r});w.on("close",()=>{d.removeListener("message",v),o.end(),g=!0}),d.addListener("message",v);let E=Buffer.alloc(0);o.on("data",S=>{E=Buffer.concat([E,S]);for(let t=E.indexOf(0);t!==-1;t=E.indexOf(0)){let u;try{const r=E.slice(0,t).toString("utf8");E=E.slice(t+1),u=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}d.sendCommand(u.method,u.params,u.sessionId).then(r=>l({id:u.id,sessionId:u.sessionId,result:r})).catch(r=>l({id:u.id,sessionId:u.sessionId,error:{code:0,message:r.message}}))}}),o.on("error",S=>{console.error("error on cdp pipe:",S)}),o.on("close",()=>{g=!0,--b===0&&d.detach()})});return await new Promise(o=>y.listen(0,o)),w.on("close",()=>y.close()),{rendererDebugPort:y.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=_}),define(te[63],ie([0,1,308,167,112]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function _(f,w){const d=(v,E)=>{console.warn((0,L.localize)(0,null,v,E))},b=v=>{console.warn((0,L.localize)(1,null,v))},y=(v,E)=>{console.warn((0,L.localize)(2,null,v,E))},o=v=>({onUnknownOption:E=>{v!=="tunnel"&&console.warn((0,L.localize)(3,null,E,v))},onMultipleValues:d,onEmptyValue:b,onDeprecatedOption:y,getSubcommandReporter:v!=="tunnel"?o:void 0}),g={onUnknownOption:v=>{console.warn((0,L.localize)(4,null,v))},onMultipleValues:d,onEmptyValue:b,onDeprecatedOption:y,getSubcommandReporter:o},l=(0,s.parseArgs)(f,s.OPTIONS,w?g:void 0);return l.goto&&l._.forEach(v=>P(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(v),(0,L.localize)(5,null))),l}function M(f){const w=f.findIndex(d=>!/^-/.test(d));if(w>-1)return[...f.slice(0,w),...f.slice(w+1)]}function I(f){let[,...w]=f;process.env.VSCODE_DEV&&(w=M(w)||[]);const d=!m(process.env);return _(w,d)}e.parseMainProcessArgv=I;function h(f){let[,,...w]=f;return process.env.VSCODE_DEV&&(w=M(w)||[]),_(w,!0)}e.parseCLIProcessArgv=h;function c(f,...w){const d=f.indexOf("--");return d===-1?f.push(...w):f.splice(d,0,...w),f}e.addArg=c;function m(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=m}),function(){"use strict";function j(e,P,L){function s(M,I){const h=_(M,I),c=[h];return e.isAbsolute(h)||c.unshift(L),e.resolve(...c)}function _(M,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,I);const m=M["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const f=process.env.USERPROFILE;if(typeof f!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(f,"AppData","Roaming")}break;case"darwin":c=e.join(P.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,I)}return{getUserDataPath:s}}if(typeof define=="function")define(te[199],ie([113,27,36]),function(e,P,L){return j(e,P,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=j(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[90],ie([0,1,27,197,199]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class _ extends L.AbstractNativeEnvironmentService{constructor(c,m){super(c,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,s.getUserDataPath)(c,m.nameShort)},m)}}e.NativeEnvironmentService=_;function M(h,c){return(0,L.parseDebugParams)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}e.parsePtyHostDebugPort=M;function I(h,c){return(0,L.parseDebugParams)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}e.parseSharedProcessDebugPort=I}),define(te[200],ie([0,1,42,27,32]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function _(M){const I=(0,s.randomPath)((0,L.tmpdir)());try{return(0,P.writeFileSync)(I,""),M&&console.log(`Marker file for --wait created: ${I}`),I}catch(h){M&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFileSync=_}),define(te[201],ie([0,1,10,169]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function s(M,I,h){try{_(M,I,h)}catch(c){console.error(c?.message??c)}return M}e.localizeManifest=s;function _(M,I,h){const c=(m,f,w)=>{const d=m[f];if((0,P.isString)(d)){const b=d,y=b.length;if(y>1&&b[0]==="%"&&b[y-1]==="%"){const o=b.substr(1,y-2);let g=I[o];g===void 0&&h&&(g=h[o]);const l=typeof g=="string"?g:g?.message,v=h?.[o],E=typeof v=="string"?v:v?.message;if(!l){E||console.warn(`[${M.name}]: ${(0,L.localize)(0,null,o)}`);return}if(w&&(f==="title"||f==="category")&&E&&E!==l){const S={value:l,original:E};m[f]=S}else m[f]=l}}else if((0,P.isObject)(d))for(const b in d)d.hasOwnProperty(b)&&(b==="commands"?c(d,b,!0):c(d,b,w));else if(Array.isArray(d))for(let b=0;b<d.length;b++)c(d,b,w)};for(const m in M)M.hasOwnProperty(m)&&c(M,m)}}),define(te[202],ie([0,1,19,70,171,203]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function h(g){return g=g.trim(),g==="*"||M.test(g)}e.isValidVersionStr=h;function c(g){if(!h(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const l=g.match(M);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}e.parseVersion=c;function m(g){if(!g)return null;const l=g.majorBase,v=g.majorMustEqual,E=g.minorBase;let S=g.minorMustEqual;const t=g.patchBase;let u=g.patchMustEqual;g.hasCaret&&(l===0||(S=!1),u=!1);let r=0;if(g.preRelease){const n=I.exec(g.preRelease);if(n){const[,i,a,p]=n;r=Date.UTC(Number(i),Number(a)-1,Number(p))}}return{majorBase:l,majorMustEqual:v,minorBase:E,minorMustEqual:S,patchBase:t,patchMustEqual:u,isMinimum:g.hasGreaterEquals,notBefore:r}}e.normalizeVersion=m;function f(g,l,v){let E;typeof g=="string"?E=m(c(g)):E=g;let S;l instanceof Date?S=l.getTime():typeof l=="string"&&(S=new Date(l).getTime());let t;if(typeof v=="string"?t=m(c(v)):t=v,!E||!t)return!1;const u=E.majorBase,r=E.minorBase,n=E.patchBase;let i=t.majorBase,a=t.minorBase,p=t.patchBase;const C=t.notBefore;let k=t.majorMustEqual,D=t.minorMustEqual,A=t.patchMustEqual;return t.isMinimum?u>i?!0:u<i?!1:r>a?!0:r<a||S&&S<C?!1:n>=p:(u===1&&i===0&&(!k||!D||!A)&&(i=1,a=0,p=0,k=!0,D=!1,A=!1),u<i?!1:u>i?!k:r<a?!1:r>a?!D:n<p?!1:n>p?!A:!(S&&S<C))}e.isValidVersion=f;function w(g,l,v,E,S){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([L.default.Error,s.localize(0,null)]),t;if(typeof E.name!="string")return t.push([L.default.Error,s.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([L.default.Error,s.localize(2,null,"version")]),t;if(!E.engines)return t.push([L.default.Error,s.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([L.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!o(E.extensionDependencies))return t.push([L.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!o(E.activationEvents))return t.push([L.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([L.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([L.default.Warning,s.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([L.default.Error,s.localize(9,null,"main")]),t;{const n=(0,P.joinPath)(v,E.main);(0,P.isEqualOrParent)(n,v)||t.push([L.default.Warning,s.localize(10,null,n.path,v.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([L.default.Error,s.localize(11,null,"browser")]),t;{const n=(0,P.joinPath)(v,E.browser);(0,P.isEqualOrParent)(n,v)||t.push([L.default.Warning,s.localize(12,null,n.path,v.path)])}}if(!_.valid(E.version))return t.push([L.default.Error,s.localize(13,null)]),t;const u=[];if(!d(g,l,E,S,u))for(const n of u)t.push([L.default.Error,n]);return t}e.validateExtensionManifest=w;function d(g,l,v,E,S){return E||typeof v.main>"u"&&typeof v.browser>"u"?!0:y(g,l,v.engines.vscode,S)}e.isValidExtensionVersion=d;function b(g,l,v){return g==="*"||y(l,v,g)}e.isEngineValid=b;function y(g,l,v,E=[]){const S=m(c(v));if(!S)return E.push(s.localize(14,null,v)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return E.push(s.localize(15,null,v)),!1}else if(!S.majorMustEqual)return E.push(s.localize(16,null,v)),!1;return f(g,l,S)?!0:(E.push(s.localize(17,null,g,v)),!1)}function o(g){if(!Array.isArray(g))return!1;for(let l=0,v=g.length;l<v;l++)if(typeof g[l]!="string")return!1;return!0}}),define(te[204],ie([0,1,17,31]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function s(_,M,I){let h=I&&I.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const m=(await M.readFile(_.serviceMachineIdResource)).value.toString();h=(0,L.isUUID)(m)?m:null}catch{h=null}if(!h){h=(0,L.generateUuid)();try{await M.writeFile(_.serviceMachineIdResource,P.VSBuffer.fromString(h))}catch{}}return I?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=s}),define(te[75],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class P{constructor(s,_=[],M=!1){this.ctor=s,this.staticArguments=_,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=P}),define(te[205],ie([0,1,75]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var s;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function _(I,h,c){h instanceof P.SyncDescriptor||(h=new P.SyncDescriptor(h,[],!!c)),L.push([I,h])}e.registerSingleton=_;function M(){return L}e.getSingletonServiceDescriptors=M}),define(te[206],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class P{constructor(_,M){this.key=_,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.Node=P;class L{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(const M of this._nodes.values())M.outgoing.size===0&&_.push(M);return _}insertEdge(_,M){const I=this.lookupOrInsertNode(_),h=this.lookupOrInsertNode(M);I.outgoing.set(h.key,h),h.incoming.set(I.key,I)}removeNode(_){const M=this._hashFn(_);this._nodes.delete(M);for(const I of this._nodes.values())I.outgoing.delete(M),I.incoming.delete(M)}lookupOrInsertNode(_){const M=this._hashFn(_);let I=this._nodes.get(M);return I||(I=new P(M,_),this._nodes.set(M,I)),I}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){const _=[];for(const[M,I]of this._nodes)_.push(`${M}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return _.join(`
`)}findCycleSlow(){for(const[_,M]of this._nodes){const I=new Set([_]),h=this._findCycle(M,I);if(h)return h}}_findCycle(_,M){for(const[I,h]of _.outgoing){if(M.has(I))return[...M,I].join(" -> ");M.add(I);const c=this._findCycle(h,M);if(c)return c;M.delete(I)}}}e.Graph=L}),define(te[6],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var P;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function I(h){return h[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=I})(P||(e._util=P={})),e.IInstantiationService=s("instantiationService");function L(M,I,h){I[P.DI_TARGET]===I?I[P.DI_DEPENDENCIES].push({id:M,index:h}):(I[P.DI_DEPENDENCIES]=[{id:M,index:h}],I[P.DI_TARGET]=I)}function s(M){if(P.serviceIds.has(M))return P.serviceIds.get(M);const I=function(h,c,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(I,h,m)};return I.toString=()=>M,P.serviceIds.set(M,I),I}e.createDecorator=s;function _(M){return M}e.refineServiceDecorator=_}),define(te[64],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,P.createDecorator)("backupMainService")}),define(te[18],ie([0,1,10,7,6]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,s.createDecorator)("configurationService");function _(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof L.URI)}e.isConfigurationOverrides=_;function M(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=M;var I;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function h(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function c(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}e.isConfigured=c;function m(g,l){const v=Object.create(null);for(const E in g)f(v,E,g[E],l);return v}e.toValuesTree=m;function f(g,l,v,E){const S=l.split("."),t=S.pop();let u=g;for(let r=0;r<S.length;r++){const n=S[r];let i=u[n];switch(typeof i){case"undefined":i=u[n]=Object.create(null);break;case"object":break;default:E(`Ignoring ${l} as ${S.slice(0,r+1).join(".")} is ${JSON.stringify(i)}`);return}u=i}if(typeof u=="object"&&u!==null)try{u[t]=v}catch{E(`Ignoring ${l} as ${S.join(".")} is ${JSON.stringify(u)}`)}else E(`Ignoring ${l} as ${S.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=f;function w(g,l){const v=l.split(".");d(g,v)}e.removeFromValueTree=w;function d(g,l){const v=l.shift();if(l.length===0){delete g[v];return}if(Object.keys(g).indexOf(v)!==-1){const E=g[v];typeof E=="object"&&!Array.isArray(E)&&(d(E,l),Object.keys(E).length===0&&delete g[v])}}function b(g,l,v){function E(u,r){let n=u;for(const i of r){if(typeof n!="object"||n===null)return;n=n[i]}return n}const S=l.split("."),t=E(g,S);return typeof t>"u"?v:t}e.getConfigurationValue=b;function y(g,l,v){Object.keys(l).forEach(E=>{E!=="__proto__"&&(E in g?P.isObject(g[E])&&P.isObject(l[E])?y(g[E],l[E],v):v&&(g[E]=l[E]):g[E]=l[E])})}e.merge=y;function o(g){return g.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=o}),define(te[114],ie([0,1,4,25,195,6,162,13]),function(j,e,P,L,s,_,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",P.isMacintosh),h.set("isLinux",P.isLinux),h.set("isWindows",P.isWindows),h.set("isWeb",P.isWeb),h.set("isMacNative",P.isMacintosh&&!P.isWeb),h.set("isEdge",P.isEdge),h.set("isFirefox",P.isFirefox),h.set("isChrome",P.isChrome),h.set("isSafari",P.isSafari);function c(T,R){if(h.get(T)!==void 0)throw(0,I.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(T,R)}e.setConstant=c;const m=Object.prototype.hasOwnProperty;var f;(function(T){T[T.False=0]="False",T[T.True=1]="True",T[T.Defined=2]="Defined",T[T.Not=3]="Not",T[T.Equals=4]="Equals",T[T.NotEquals=5]="NotEquals",T[T.And=6]="And",T[T.Regex=7]="Regex",T[T.NotRegex=8]="NotRegex",T[T.Or=9]="Or",T[T.In=10]="In",T[T.NotIn=11]="NotIn",T[T.Greater=12]="Greater",T[T.GreaterEquals=13]="GreaterEquals",T[T.Smaller=14]="Smaller",T[T.SmallerEquals=15]="SmallerEquals"})(f||(e.ContextKeyExprType=f={}));const w={regexParsingWithErrorRecovery:!0},d=(0,M.localize)(0,null),b=(0,M.localize)(1,null),y=(0,M.localize)(2,null),o=(0,M.localize)(3,null),g=(0,M.localize)(4,null),l=(0,M.localize)(5,null),v=(0,M.localize)(6,null),E=(0,M.localize)(7,null);class S{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(R=w){this._config=R,this._scanner=new s.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(R){if(R===""){this._parsingErrors.push({message:d,offset:0,lexeme:"",additionalInfo:b});return}this._tokens=this._scanner.reset(R).scan(),this._current=0,this._parsingErrors=[];try{const W=this._expr();if(!this._isAtEnd()){const H=this._peek(),x=H.type===17?l:void 0;throw this._parsingErrors.push({message:g,offset:H.offset,lexeme:s.Scanner.getLexeme(H),additionalInfo:x}),S._parseError}return W}catch(W){if(W!==S._parseError)throw W;return}}_expr(){return this._or()}_or(){const R=[this._and()];for(;this._matchOne(16);){const W=this._and();R.push(W)}return R.length===1?R[0]:t.or(...R)}_and(){const R=[this._term()];for(;this._matchOne(15);){const W=this._term();R.push(W)}return R.length===1?R[0]:t.and(...R)}_term(){if(this._matchOne(2)){const R=this._peek();switch(R.type){case 11:return this._advance(),i.INSTANCE;case 12:return this._advance(),a.INSTANCE;case 0:{this._advance();const W=this._expr();return this._consume(1,o),W?.negate()}case 17:return this._advance(),O.create(R.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",R)}}return this._primary()}_primary(){const R=this._peek();switch(R.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const W=this._expr();return this._consume(1,o),W}case 17:{const W=R.lexeme;if(this._advance(),this._matchOne(9)){const x=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),x.type!==10)throw this._errExpectedButGot("REGEX",x);const z=x.lexeme,$=z.lastIndexOf("/"),K=$===z.length-1?void 0:this._removeFlagsGY(z.substring($+1));let re;try{re=new RegExp(z.substring(1,$),K)}catch{throw this._errExpectedButGot("REGEX",x)}return ae.create(W,re)}switch(x.type){case 10:case 19:{const z=[x.lexeme];this._advance();let $=this._peek(),K=0;for(let Me=0;Me<x.lexeme.length;Me++)x.lexeme.charCodeAt(Me)===40?K++:x.lexeme.charCodeAt(Me)===41&&K--;for(;!this._isAtEnd()&&$.type!==15&&$.type!==16;){switch($.type){case 0:K++;break;case 1:K--;break;case 10:case 18:for(let Me=0;Me<$.lexeme.length;Me++)$.lexeme.charCodeAt(Me)===40?K++:x.lexeme.charCodeAt(Me)===41&&K--}if(K<0)break;z.push(s.Scanner.getLexeme($)),this._advance(),$=this._peek()}const re=z.join(""),le=re.lastIndexOf("/"),ge=le===re.length-1?void 0:this._removeFlagsGY(re.substring(le+1));let Ce;try{Ce=new RegExp(re.substring(1,le),ge)}catch{throw this._errExpectedButGot("REGEX",x)}return t.regex(W,Ce)}case 18:{const z=x.lexeme;this._advance();let $=null;if(!(0,L.isFalsyOrWhitespace)(z)){const K=z.indexOf("/"),re=z.lastIndexOf("/");if(K!==re&&K>=0){const le=z.slice(K+1,re),ge=z[re+1]==="i"?"i":"";try{$=new RegExp(le,ge)}catch{throw this._errExpectedButGot("REGEX",x)}}}if($===null)throw this._errExpectedButGot("REGEX",x);return ae.create(W,$)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,y);const x=this._value();return t.notIn(W,x)}switch(this._peek().type){case 3:{this._advance();const x=this._value();if(this._previous().type===18)return t.equals(W,x);switch(x){case"true":return t.has(W);case"false":return t.not(W);default:return t.equals(W,x)}}case 4:{this._advance();const x=this._value();if(this._previous().type===18)return t.notEquals(W,x);switch(x){case"true":return t.not(W);case"false":return t.has(W);default:return t.notEquals(W,x)}}case 5:return this._advance(),ne.create(W,this._value());case 6:return this._advance(),ee.create(W,this._value());case 7:return this._advance(),q.create(W,this._value());case 8:return this._advance(),se.create(W,this._value());case 13:return this._advance(),t.in(W,this._value());default:return t.has(W)}}case 20:throw this._parsingErrors.push({message:v,offset:R.offset,lexeme:"",additionalInfo:E}),S._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const R=this._peek();switch(R.type){case 17:case 18:return this._advance(),R.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(R){return R.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(R){return this._check(R)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(R,W){if(this._check(R))return this._advance();throw this._errExpectedButGot(W,this._peek())}_errExpectedButGot(R,W,H){const x=(0,M.localize)(8,null,R,s.Scanner.getLexeme(W)),z=W.offset,$=s.Scanner.getLexeme(W);return this._parsingErrors.push({message:x,offset:z,lexeme:$,additionalInfo:H}),S._parseError}_check(R){return this._peek().type===R}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=S;class t{static false(){return i.INSTANCE}static true(){return a.INSTANCE}static has(R){return p.create(R)}static equals(R,W){return C.create(R,W)}static notEquals(R,W){return A.create(R,W)}static regex(R,W){return ae.create(R,W)}static in(R,W){return k.create(R,W)}static notIn(R,W){return D.create(R,W)}static not(R){return O.create(R)}static and(...R){return Y.create(R,null,!0)}static or(...R){return F.create(R,null,!0)}static greater(R,W){return q.create(R,W)}static greaterEquals(R,W){return se.create(R,W)}static smaller(R,W){return ne.create(R,W)}static smallerEquals(R,W){return ee.create(R,W)}static{this._parser=new S({regexParsingWithErrorRecovery:!1})}static deserialize(R){return R==null?void 0:this._parser.parse(R)}}e.ContextKeyExpr=t;function u(T){const R=new S({regexParsingWithErrorRecovery:!1});return T.map(W=>(R.parse(W),R.lexingErrors.length>0?R.lexingErrors.map(H=>({errorMessage:H.additionalInfo?(0,M.localize)(9,null,H.additionalInfo):(0,M.localize)(10,null),offset:H.offset,length:H.lexeme.length})):R.parsingErrors.length>0?R.parsingErrors.map(H=>({errorMessage:H.additionalInfo?`${H.message}. ${H.additionalInfo}`:H.message,offset:H.offset,length:H.lexeme.length})):[]))}e.validateWhenClauses=u;function r(T,R){const W=T?T.substituteConstants():void 0,H=R?R.substituteConstants():void 0;return!W&&!H?!0:!W||!H?!1:W.equals(H)}e.expressionsAreEqualWithConstantSubstitution=r;function n(T,R){return T.cmp(R)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return a.INSTANCE}}e.ContextKeyFalseExpr=i;class a{static{this.INSTANCE=new a}constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return i.INSTANCE}}e.ContextKeyTrueExpr=a;class p{static create(R,W=null){const H=h.get(R);return typeof H=="boolean"?H?a.INSTANCE:i.INSTANCE:new p(R,W)}constructor(R,W){this.key=R,this.negated=W,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:B(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=h.get(this.key);return typeof R=="boolean"?R?a.INSTANCE:i.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.negated||(this.negated=O.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=p;class C{static create(R,W,H=null){if(typeof W=="boolean")return W?p.create(R,H):O.create(R,H);const x=h.get(R);return typeof x=="boolean"?W===(x?"true":"false")?a.INSTANCE:i.INSTANCE:new C(R,W,H)}constructor(R,W,H){this.key=R,this.value=W,this.negated=H,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:V(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=h.get(this.key);if(typeof R=="boolean"){const W=R?"true":"false";return this.value===W?a.INSTANCE:i.INSTANCE}return this}evaluate(R){return R.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(R){return R.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=A.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=C;class k{static create(R,W){return new k(R,W)}constructor(R,W){this.key=R,this.valueKey=W,this.type=10,this.negated=null}cmp(R){return R.type!==this.type?this.type-R.type:V(this.key,this.valueKey,R.key,R.valueKey)}equals(R){return R.type===this.type?this.key===R.key&&this.valueKey===R.valueKey:!1}substituteConstants(){return this}evaluate(R){const W=R.getValue(this.valueKey),H=R.getValue(this.key);return Array.isArray(W)?W.includes(H):typeof H=="string"&&typeof W=="object"&&W!==null?m.call(W,H):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(R){return R.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=D.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=k;class D{static create(R,W){return new D(R,W)}constructor(R,W){this.key=R,this.valueKey=W,this.type=11,this._negated=k.create(R,W)}cmp(R){return R.type!==this.type?this.type-R.type:this._negated.cmp(R._negated)}equals(R){return R.type===this.type?this._negated.equals(R._negated):!1}substituteConstants(){return this}evaluate(R){return!this._negated.evaluate(R)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(R){return R.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=D;class A{static create(R,W,H=null){if(typeof W=="boolean")return W?O.create(R,H):p.create(R,H);const x=h.get(R);return typeof x=="boolean"?W===(x?"true":"false")?i.INSTANCE:a.INSTANCE:new A(R,W,H)}constructor(R,W,H){this.key=R,this.value=W,this.negated=H,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:V(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=h.get(this.key);if(typeof R=="boolean"){const W=R?"true":"false";return this.value===W?i.INSTANCE:a.INSTANCE}return this}evaluate(R){return R.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(R){return R.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=A;class O{static create(R,W=null){const H=h.get(R);return typeof H=="boolean"?H?i.INSTANCE:a.INSTANCE:new O(R,W)}constructor(R,W){this.key=R,this.negated=W,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:B(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=h.get(this.key);return typeof R=="boolean"?R?i.INSTANCE:a.INSTANCE:this}evaluate(R){return!R.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(R){return R.mapNot(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=O;function U(T,R){if(typeof T=="string"){const W=parseFloat(T);isNaN(W)||(T=W)}return typeof T=="string"||typeof T=="number"?R(T):i.INSTANCE}class q{static create(R,W,H=null){return U(W,x=>new q(R,x,H))}constructor(R,W,H){this.key=R,this.value=W,this.negated=H,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:V(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ee.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=q;class se{static create(R,W,H=null){return U(W,x=>new se(R,x,H))}constructor(R,W,H){this.key=R,this.value=W,this.negated=H,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:V(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=ne.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=se;class ne{static create(R,W,H=null){return U(W,x=>new ne(R,x,H))}constructor(R,W,H){this.key=R,this.value=W,this.negated=H,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:V(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=se.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=ne;class ee{static create(R,W,H=null){return U(W,x=>new ee(R,x,H))}constructor(R,W,H){this.key=R,this.value=W,this.negated=H,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:V(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=q.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ee;class ae{static create(R,W){return new ae(R,W)}constructor(R,W){this.key=R,this.regexp=W,this.type=7,this.negated=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.key<R.key)return-1;if(this.key>R.key)return 1;const W=this.regexp?this.regexp.source:"",H=R.regexp?R.regexp.source:"";return W<H?-1:W>H?1:0}equals(R){if(R.type===this.type){const W=this.regexp?this.regexp.source:"",H=R.regexp?R.regexp.source:"";return this.key===R.key&&W===H}return!1}substituteConstants(){return this}evaluate(R){const W=R.getValue(this.key);return this.regexp?this.regexp.test(W):!1}serialize(){const R=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${R}`}keys(){return[this.key]}map(R){return R.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ue.create(this)),this.negated}}e.ContextKeyRegexExpr=ae;class ue{static create(R){return new ue(R)}constructor(R){this._actual=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(R){return new ue(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ue;function G(T){let R=null;for(let W=0,H=T.length;W<H;W++){const x=T[W].substituteConstants();if(T[W]!==x&&R===null){R=[];for(let z=0;z<W;z++)R[z]=T[z]}R!==null&&(R[W]=x)}return R===null?T:R}class Y{static create(R,W,H){return Y._normalizeArr(R,W,H)}constructor(R,W){this.expr=R,this.negated=W,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let W=0,H=this.expr.length;W<H;W++){const x=n(this.expr[W],R.expr[W]);if(x!==0)return x}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let W=0,H=this.expr.length;W<H;W++)if(!this.expr[W].equals(R.expr[W]))return!1;return!0}return!1}substituteConstants(){const R=G(this.expr);return R===this.expr?this:Y.create(R,this.negated,!1)}evaluate(R){for(let W=0,H=this.expr.length;W<H;W++)if(!this.expr[W].evaluate(R))return!1;return!0}static _normalizeArr(R,W,H){const x=[];let z=!1;for(const $ of R)if($){if($.type===1){z=!0;continue}if($.type===0)return i.INSTANCE;if($.type===6){x.push(...$.expr);continue}x.push($)}if(x.length===0&&z)return a.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(n);for(let $=1;$<x.length;$++)x[$-1].equals(x[$])&&(x.splice($,1),$--);if(x.length===1)return x[0];for(;x.length>1;){const $=x[x.length-1];if($.type!==9)break;x.pop();const K=x.pop(),re=x.length===0,le=F.create($.expr.map(ge=>Y.create([ge,K],null,H)),null,re);le&&(x.push(le),x.sort(n))}if(x.length===1)return x[0];if(H){for(let $=0;$<x.length;$++)for(let K=$+1;K<x.length;K++)if(x[$].negate().equals(x[K]))return i.INSTANCE;if(x.length===1)return x[0]}return new Y(x,W)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const W of this.expr)R.push(...W.keys());return R}map(R){return new Y(this.expr.map(W=>W.map(R)),null)}negate(){if(!this.negated){const R=[];for(const W of this.expr)R.push(W.negate());this.negated=F.create(R,this,!0)}return this.negated}}e.ContextKeyAndExpr=Y;class F{static create(R,W,H){return F._normalizeArr(R,W,H)}constructor(R,W){this.expr=R,this.negated=W,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let W=0,H=this.expr.length;W<H;W++){const x=n(this.expr[W],R.expr[W]);if(x!==0)return x}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let W=0,H=this.expr.length;W<H;W++)if(!this.expr[W].equals(R.expr[W]))return!1;return!0}return!1}substituteConstants(){const R=G(this.expr);return R===this.expr?this:F.create(R,this.negated,!1)}evaluate(R){for(let W=0,H=this.expr.length;W<H;W++)if(this.expr[W].evaluate(R))return!0;return!1}static _normalizeArr(R,W,H){let x=[],z=!1;if(R){for(let $=0,K=R.length;$<K;$++){const re=R[$];if(re){if(re.type===0){z=!0;continue}if(re.type===1)return a.INSTANCE;if(re.type===9){x=x.concat(re.expr);continue}x.push(re)}}if(x.length===0&&z)return i.INSTANCE;x.sort(n)}if(x.length!==0){if(x.length===1)return x[0];for(let $=1;$<x.length;$++)x[$-1].equals(x[$])&&(x.splice($,1),$--);if(x.length===1)return x[0];if(H){for(let $=0;$<x.length;$++)for(let K=$+1;K<x.length;K++)if(x[$].negate().equals(x[K]))return a.INSTANCE;if(x.length===1)return x[0]}return new F(x,W)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const W of this.expr)R.push(...W.keys());return R}map(R){return new F(this.expr.map(W=>W.map(R)),null)}negate(){if(!this.negated){const R=[];for(const W of this.expr)R.push(W.negate());for(;R.length>1;){const W=R.shift(),H=R.shift(),x=[];for(const z of oe(W))for(const $ of oe(H))x.push(Y.create([z,$],null,!1));R.unshift(F.create(x,null,!1))}this.negated=F.create(R,this,!0)}return this.negated}}e.ContextKeyOrExpr=F;class N extends p{static{this._info=[]}static all(){return N._info.values()}constructor(R,W,H){super(R,null),this._defaultValue=W,typeof H=="object"?N._info.push({...H,key:R}):H!==!0&&N._info.push({key:R,description:H,type:W!=null?typeof W:void 0})}bindTo(R){return R.createKey(this.key,this._defaultValue)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return C.create(this.key,R)}notEqualsTo(R){return A.create(this.key,R)}}e.RawContextKey=N,e.IContextKeyService=(0,_.createDecorator)("contextKeyService");function B(T,R){return T<R?-1:T>R?1:0}function V(T,R,W,H){return T<W?-1:T>W?1:R<H?-1:R>H?1:0}function X(T,R){if(T.type===0||R.type===1)return!0;if(T.type===9)return R.type===9?ce(T.expr,R.expr):!1;if(R.type===9){for(const W of R.expr)if(X(T,W))return!0;return!1}if(T.type===6){if(R.type===6)return ce(R.expr,T.expr);for(const W of T.expr)if(X(W,R))return!0;return!1}return T.equals(R)}e.implies=X;function ce(T,R){let W=0,H=0;for(;W<T.length&&H<R.length;){const x=T[W].cmp(R[H]);if(x<0)return!1;x===0&&W++,H++}return W===T.length}function oe(T){return T.type===9?T.expr:[T]}}),define(te[76],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,P.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,P.createDecorator)("credentialsMainService");class L{constructor(){this.secretVault={}}async getPassword(_,M){return this.secretVault[_]?.[M]??null}async setPassword(_,M,I){this.secretVault[_]=this.secretVault[_]??{},this.secretVault[_][M]=I}async deletePassword(_,M){return this.secretVault[_]?.[M]?(delete this.secretVault[_][M],Object.keys(this.secretVault[_]).length===0&&delete this.secretVault[_],!0):!1}async findPassword(_){return JSON.stringify(this.secretVault[_])??null}async findCredentials(_){const M=[];for(const I of Object.keys(this.secretVault[_]||{}))M.push({account:I,password:this.secretVault[_][I]});return M}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=L}),define(te[91],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,P.createDecorator)(e.ID);function L(_){return!!_.hostName&&!!_.errorMessage}e.isRemoteDiagnosticError=L;class s{async getPerformanceInfo(M,I){return{}}async getSystemInfo(M,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,I){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=s}),define(te[92],ie([0,1,19,70,164,6,46,4,37]),function(j,e,P,L,s,_,M,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,_.createDecorator)("dialogService");var c;(function(y){y[y.Confirmation=1]="Confirmation",y[y.Prompt=2]="Prompt",y[y.Input=3]="Input"})(c||(c={}));class m{getConfirmationButtons(o){return this.getButtons(o,c.Confirmation)}getPromptButtons(o){return this.getButtons(o,c.Prompt)}getInputButtons(o){return this.getButtons(o,c.Input)}getButtons(o,g){const l=[];switch(g){case c.Confirmation:{const v=o;v.primaryButton?l.push(v.primaryButton):l.push((0,s.localize)(0,null)),v.cancelButton?l.push(v.cancelButton):l.push((0,s.localize)(1,null));break}case c.Prompt:{const v=o;Array.isArray(v.buttons)&&v.buttons.length>0&&l.push(...v.buttons.map(E=>E.label)),v.cancelButton&&(v.cancelButton===!0?l.push((0,s.localize)(2,null)):typeof v.cancelButton=="string"?l.push(v.cancelButton):v.cancelButton.label?l.push(v.cancelButton.label):l.push((0,s.localize)(3,null))),l.length===0&&l.push((0,s.localize)(4,null));break}case c.Input:{const v=o;v.primaryButton?l.push(v.primaryButton):l.push((0,s.localize)(5,null)),v.cancelButton?l.push(v.cancelButton):l.push((0,s.localize)(6,null));break}}return l}getDialogType(o){if(typeof o=="string")return o;if(typeof o=="number")return o===L.default.Info?"info":o===L.default.Error?"error":o===L.default.Warning?"warning":"none"}async getPromptResult(o,g,l){const v=[...o.buttons??[]];return o.cancelButton&&typeof o.cancelButton!="string"&&typeof o.cancelButton!="boolean"&&v.push(o.cancelButton),{result:await v[g]?.run({checkboxChecked:l}),checkboxChecked:l}}}e.AbstractDialogHandler=m,e.IFileDialogService=(0,_.createDecorator)("fileDialogService");var f;(function(y){y[y.SAVE=0]="SAVE",y[y.DONT_SAVE=1]="DONT_SAVE",y[y.CANCEL=2]="CANCEL"})(f||(e.ConfirmResult=f={}));const w=10;function d(y){const o=[];return o.push(...y.slice(0,w).map(g=>typeof g=="string"?g:(0,P.basename)(g))),y.length>w&&(y.length-w===1?o.push((0,s.localize)(7,null)):o.push((0,s.localize)(8,null,y.length-w))),o.push(""),o.join(`
`)}e.getFileNamesMessage=d;function b(y,o){const g=(0,h.deepClone)(y);let l=(g.buttons??[]).map(t=>(0,M.mnemonicButtonLabel)(t)),v=(y.buttons||[]).map((t,u)=>u),E=0,S=g.cancelId??l.length-1;if(l.length>1){const t=typeof S=="number"?l[S]:void 0;if(I.isLinux||I.isMacintosh){if(typeof t=="string"&&l.length>1&&S!==1){l.splice(S,1),l.splice(1,0,t);const u=v[S];v.splice(S,1),v.splice(1,0,u),S=1}I.isLinux&&l.length>1&&(l=l.reverse(),v=v.reverse(),E=l.length-1,typeof t=="string"&&(S=E-1))}else if(I.isWindows&&typeof t=="string"&&l.length>1&&S!==l.length-1){l.splice(S,1),l.push(t);const u=v[S];v.splice(S,1),v.push(u),S=l.length-1}}return g.buttons=l,g.defaultId=E,g.cancelId=S,g.noLink=!0,g.title=g.title||o.nameLong,{options:g,buttonIndeces:v}}e.massageMessageBoxOptions=b}),define(te[115],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isGnome=e.isKwallet=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.IEncryptionMainService=e.IEncryptionService=void 0,e.IEncryptionService=(0,P.createDecorator)("encryptionService"),e.IEncryptionMainService=(0,P.createDecorator)("encryptionMainService");var L;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnome="gnome",I.gnomeKeyring="gnome-keyring",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(L||(e.PasswordStoreCLIOption=L={}));var s;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function _(I){return I==="kwallet"||I==="kwallet5"||I==="kwallet6"}e.isKwallet=_;function M(I){return I==="gnome_any"||I==="gnome_libsecret"||I==="gnome_keyring"}e.isGnome=M}),define(te[33],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,P.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,P.refineServiceDecorator)(e.IEnvironmentService)}),define(te[116],ie([0,1,168,6]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function s(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=s;function _(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=_;function M(l,v){switch(l){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":v==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function I(l,v){return v==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function h(l,v,E){return I(v,E)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===E?!0:c(E).includes(l)}e.isTargetPlatformCompatible=h;function c(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function m(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=m;var f;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(f||(e.SortBy=f={}));var w;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var d;(function(l){l.Install="install",l.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var b;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var y;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var o;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(o||(e.ExtensionSignaturetErrorCode=o={}));class g extends Error{constructor(v,E){super(v),this.code=E,this.name=E}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,P.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,P.localize)(1,null),original:"Preferences"}}),define(te[207],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,P.createDecorator)("extensionUrlTrustService")}),define(te[208],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,P.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[117],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,P.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,P.createDecorator)("externalTerminal")}),define(te[209],ie([0,1,47,15,9,4,73,22,89,172,117]),function(j,e,P,L,s,_,M,I,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const f=c.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await y.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends w{static{this.CMD="cmd.exe"}openTerminal(E,S){return this.spawnTerminal(P,E,h.getWindowsShell(),S)}spawnTerminal(E,S,t,u){const r=S.windowsExec||d.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const n=s.basename(r,".exe").toLowerCase();if(n==="cmder")return E.spawn(r,u?[u]:void 0),Promise.resolve(void 0);const i=["/c","start","/wait"];return r.indexOf(" ")>=0&&i.push('""'),i.push(r),n==="wt"&&i.push("-d ."),new Promise((a,p)=>{const C=o(process),k=E.spawn(t,i,{cwd:u,env:C});k.on("error",p),k.on("exit",()=>a())})}runInTerminal(E,S,t,u,r){const n="windowsExec"in r&&r.windowsExec?r.windowsExec:d.getDefaultTerminalWindows();return new Promise((i,a)=>{const p=`"${S} - ${f}"`,C=`""${t.join('" "')}" & pause"`,k=Object.assign({},o(process),u);Object.keys(k).filter(q=>k[q]===null).forEach(q=>delete k[q]);const D={cwd:S,env:k,windowsVerbatimArguments:!0};let A,O;s.basename(n,".exe")==="wt"?(A=n,O=["-d",".",d.CMD,"/c",C]):(A=d.CMD,O=["/c","start",p,"/wait",n,"/c",C]),P.spawn(A,O,D).on("error",q=>{a(g(q))}),i(void 0)})}static getDefaultTerminalWindows(){if(!d._DEFAULT_TERMINAL_WINDOWS){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return d._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=d;class b extends w{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(E,S){return this.spawnTerminal(P,E,S)}runInTerminal(E,S,t,u,r){const n=r.osxExec||m.DEFAULT_TERMINAL_OSX;return new Promise((i,a)=>{if(n===m.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const p=n===m.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",k=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${p}.scpt`).fsPath,"-t",E||f,"-w",S];for(const O of t)k.push("-a"),k.push(O);if(u){const O=Object.assign({},o(process),u);for(const U in O){const q=O[U];q===null?(k.push("-u"),k.push(U)):(k.push("-e"),k.push(`${U}=${q}`))}}let D="";const A=P.spawn(b.OSASCRIPT,k);A.on("error",O=>{a(g(O))}),A.stderr.on("data",O=>{D+=O.toString()}),A.on("exit",O=>{if(O===0)i(void 0);else if(D){const U=D.split(`
`,1);a(new Error(U[0]))}else a(new Error(c.localize(1,null,p,O)))})}else a(new Error(c.localize(2,null,n)))})}spawnTerminal(E,S,t){const u=S.osxExec||m.DEFAULT_TERMINAL_OSX;return new Promise((r,n)=>{const i=["-a",u];t&&i.push(t);const a=o(process),p=E.spawn("/usr/bin/open",i,{cwd:t,env:a});p.on("error",n),p.on("exit",()=>r())})}}e.MacExternalTerminalService=b;class y extends w{static{this.WAIT_MESSAGE=c.localize(3,null)}openTerminal(E,S){return this.spawnTerminal(P,E,S)}runInTerminal(E,S,t,u,r){const n=r.linuxExec?Promise.resolve(r.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((i,a)=>{const p=[];n.then(C=>{C.indexOf("gnome-terminal")>=0?p.push("-x"):p.push("-e"),p.push("bash"),p.push("-c");const k=`${l(t)}; echo; read -p "${y.WAIT_MESSAGE}" -n1;`;p.push(`''${k}''`);const D=Object.assign({},o(process),u);Object.keys(D).filter(q=>D[q]===null).forEach(q=>delete D[q]);const A={cwd:S,env:D};let O="";const U=P.spawn(C,p,A);U.on("error",q=>{a(g(q))}),U.stderr.on("data",q=>{O+=q.toString()}),U.on("exit",q=>{if(q===0)i(void 0);else if(O){const se=O.split(`
`,1);a(new Error(se[0]))}else a(new Error(c.localize(4,null,C,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!y._DEFAULT_TERMINAL_LINUX_READY)if(!_.isLinux)y._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const E=await I.Promises.exists("/etc/debian_version");y._DEFAULT_TERMINAL_LINUX_READY=new Promise(S=>{E?S("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?S("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?S("konsole"):process.env.COLORTERM?S(process.env.COLORTERM):process.env.TERM?S(process.env.TERM):S("xterm")})}return y._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(E,S,t){const u=S.linuxExec?Promise.resolve(S.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((r,n)=>{u.then(i=>{const a=o(process),p=E.spawn(i,[],{cwd:t,env:a});p.on("error",n),p.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=y;function o(v){const E={...v.env};return(0,M.sanitizeProcessEnvironment)(E),E}function g(v){return"errno"in v&&v.errno==="ENOENT"&&"path"in v&&typeof v.path=="string"?new Error(c.localize(5,null,v.path)):v}function l(v){let E="";for(const S of v)S.indexOf(" ")>=0?E+='"'+S+'"':E+=S,E+=" ";return E}}),define(te[16],ie([0,1,58,9,25,10,7,174,6,4,15]),function(j,e,P,L,s,_,M,I,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function f(B){return B.create===!0}e.isFileOpenForWriteOptions=f;var w;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var d;(function(B){B[B.Readonly=1]="Readonly",B[B.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var b;(function(B){B[B.None=0]="None",B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileAtomicWrite=32768]="FileAtomicWrite",B[B.FileAtomicDelete=65536]="FileAtomicDelete",B[B.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function y(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=y;function o(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=o;function g(B){return!!(B.capabilities&131072)}e.hasFileCloneCapability=g;function l(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function v(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=v;function E(B){return y(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=E;function S(B){return y(B)?!!(B.capabilities&32768):!1}e.hasFileAtomicWriteCapability=S;function t(B){return!!(B.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;function u(B){return!!(B.capabilities&2048)}e.hasReadonlyCapability=u;var r;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsStorageQuota="EntryExceedsStorageQuota",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class n extends Error{static create(V,X){const ce=new n(V.toString(),X);return p(ce,X),ce}constructor(V,X){super(V),this.code=X}}e.FileSystemProviderError=n;function i(B,V){return n.create(B,V)}e.createFileSystemProviderError=i;function a(B){return B||i((0,I.localize)(0,null),r.Unknown)}e.ensureFileSystemProviderError=a;function p(B,V){return B.name=V?`${V} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=p;function C(B){if(!B)return r.Unknown;if(B instanceof n)return B.code;const V=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!V)return r.Unknown;switch(V[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.toFileSystemProviderErrorCode=C;function k(B){if(B instanceof se)return B.fileOperationResult;switch(C(B)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=k;var D;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(D||(e.FileOperation=D={}));class A{constructor(V,X,ce){this.resource=V,this.operation=X,this.target=ce}isOperation(V){return this.operation===V}}e.FileOperationEvent=A;var O;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class U{constructor(V,X){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const oe of V){const T=ce.get(oe.type);switch(T?T.push([oe.resource,oe]):ce.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,T]of ce)switch(oe){case 1:this.added=P.TernarySearchTree.forUris(()=>X),this.added.fill(T);break;case 0:this.updated=P.TernarySearchTree.forUris(()=>X),this.updated.fill(T);break;case 2:this.deleted=P.TernarySearchTree.forUris(()=>X),this.deleted.fill(T);break}}contains(V,...X){return this.doContains(V,{includeChildren:!1},...X)}affects(V,...X){return this.doContains(V,{includeChildren:!0},...X)}doContains(V,X,...ce){if(!V)return!1;const oe=ce.length>0;return!!((!oe||ce.includes(1))&&(this.added?.get(V)||X.includeChildren&&this.added?.findSuperstr(V))||(!oe||ce.includes(0))&&(this.updated?.get(V)||X.includeChildren&&this.updated?.findSuperstr(V))||(!oe||ce.includes(2))&&(this.deleted?.findSubstr(V)||X.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=U;function q(B,V,X){return!B||!V||B===V||V.length>B.length?!1:(V.charAt(V.length-1)!==L.sep&&(V+=L.sep),X?(0,s.startsWithIgnoreCase)(B,V):B.indexOf(V)===0)}e.isParent=q;class se extends Error{constructor(V,X,ce){super(V),this.fileOperationResult=X,this.options=ce}}e.FileOperationError=se;class ne extends se{constructor(V,X,ce,oe){super(V,X,oe),this.fileOperationResult=X,this.size=ce}}e.TooLargeFileOperationError=ne;class ee extends se{constructor(V,X,ce){super(V,2,ce),this.stat=X}}e.NotModifiedSinceFileOperationError=ee;var ae;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ue;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.ETAG_DISABLED="";function G(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=G;async function Y(B,V){if(!V.hasProvider(M.URI.from({scheme:B.scheme})))return new Promise(X=>{const ce=V.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===B.scheme&&oe.added&&(ce.dispose(),X())})})}e.whenProviderRegistered=Y;class F{static{this.KB=1024}static{this.MB=F.KB*F.KB}static{this.GB=F.MB*F.KB}static{this.TB=F.GB*F.KB}static formatSize(V){return(0,_.isNumber)(V)||(V=0),V<F.KB?(0,I.localize)(1,null,V.toFixed(0)):V<F.MB?(0,I.localize)(2,null,(V/F.KB).toFixed(2)):V<F.GB?(0,I.localize)(3,null,(V/F.MB).toFixed(2)):V<F.TB?(0,I.localize)(4,null,(V/F.GB).toFixed(2)):(0,I.localize)(5,null,(V/F.TB).toFixed(2))}}e.ByteSize=F;function N(B){const V=typeof B=="string"||B?.scheme===m.Schemas.vscodeRemote;return typeof B!="string"&&B?.scheme===m.Schemas.file?1024*F.MB:V?10*F.MB:c.isWeb?50*F.MB:1024*F.MB}e.getLargeFileConfirmationLimit=N}),define(te[210],ie([0,1,17,50,13,3,2,56,7,31,16]),function(j,e,P,L,s,_,M,I,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class f extends M.Disposable{constructor(d,b){super(),this.channel=d,this.extraCapabilities=b,this.onDidChangeCapabilities=_.Event.None,this._onDidChange=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,c.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(d){return this.channel.call("stat",[d])}readdir(d){return this.channel.call("readdir",[d])}async readFile(d,b){const{buffer:y}=await this.channel.call("readFile",[d,b]);return y}readFileStream(d,b,y){const o=(0,I.newWriteableStream)(l=>P.VSBuffer.concat(l.map(v=>P.VSBuffer.wrap(v))).buffer),g=this.channel.listen("readFileStream",[d,b])(l=>{if(l instanceof P.VSBuffer)o.write(l.buffer);else{if(l==="end")o.end();else{let v;if(l instanceof Error)v=l;else{const E=l;v=(0,m.createFileSystemProviderError)(E.message??(0,L.toErrorMessage)(E),E.code??m.FileSystemProviderErrorCode.Unknown)}o.error(v),o.end()}g.dispose()}});return y.onCancellationRequested(()=>{o.error((0,s.canceled)()),o.end(),g.dispose()}),o}writeFile(d,b,y){return this.channel.call("writeFile",[d,P.VSBuffer.wrap(b),y])}open(d,b){return this.channel.call("open",[d,b])}close(d){return this.channel.call("close",[d])}async read(d,b,y,o,g){const[l,v]=await this.channel.call("read",[d,b,g]);return y.set(l.buffer.slice(0,v),o),v}write(d,b,y,o,g){return this.channel.call("write",[d,b,P.VSBuffer.wrap(y),o,g])}mkdir(d){return this.channel.call("mkdir",[d])}delete(d,b){return this.channel.call("delete",[d,b])}rename(d,b,y){return this.channel.call("rename",[d,b,y])}copy(d,b,y){return this.channel.call("copy",[d,b,y])}cloneFile(d,b){return this.channel.call("cloneFile",[d,b])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(d=>{if(Array.isArray(d)){const b=d;this._onDidChange.fire(b.map(y=>({resource:h.URI.revive(y.resource),type:y.type})))}else{const b=d;this._onDidWatchError.fire(b)}}))}watch(d,b){const y=(0,c.generateUuid)();return this.channel.call("watch",[this.sessionId,y,d,b]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,y]))}}e.DiskFileSystemProviderClient=f}),define(te[118],ie([0,1,17,13,175,16]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(m,f,w,d,b,y){let o;try{await I(m,f,w,d,b,y)}catch(g){o=g}finally{o&&b.errorTransformer&&(o=b.errorTransformer(o)),typeof o<"u"&&w.error(o),w.end()}}e.readFileIntoStream=M;async function I(m,f,w,d,b,y){h(y);const o=await m.open(f,{create:!1});try{h(y);let g=0,l=0,v=b&&typeof b.length=="number"?b.length:void 0,E=P.VSBuffer.alloc(Math.min(b.bufferSize,typeof v=="number"?v:b.bufferSize)),S=b&&typeof b.position=="number"?b.position:0,t=0;do l=await m.read(o,S,E.buffer,t,E.byteLength-t),S+=l,t+=l,g+=l,typeof v=="number"&&(v-=l),t===E.byteLength&&(await w.write(d(E)),E=P.VSBuffer.alloc(Math.min(b.bufferSize,typeof v=="number"?v:b.bufferSize)),t=0);while(l>0&&(typeof v!="number"||v>0)&&h(y)&&c(g,b));if(t>0){let u=t;typeof v=="number"&&(u=Math.min(t,v)),w.write(d(E.slice(0,u)))}}catch(g){throw(0,_.ensureFileSystemProviderError)(g)}finally{await m.close(o)}}function h(m){if(m.isCancellationRequested)throw(0,L.canceled)();return!0}function c(m,f){if(typeof f?.limits?.size=="number"&&m>f.limits.size)throw(0,_.createFileSystemProviderError)((0,s.localize)(0,null),_.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[77],ie([0,1,104,2,9,4,7,16]),function(j,e,P,L,s,_,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function h(g){return g.recursive===!0}e.isRecursiveWatchRequest=h;class c extends L.Disposable{static{this.MAX_RESTARTS=5}constructor(l,v,E,S){super(),this.onFileChanges=l,this.onLogMessage=v,this.verboseLogging=E,this.options=S,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const l=new L.DisposableStore;this.watcherDisposables.value=l,this.watcher=this.createWatcher(l),this.watcher.setVerboseLogging(this.verboseLogging),l.add(this.watcher.onDidChangeFile(v=>this.onFileChanges(v))),l.add(this.watcher.onDidLogMessage(v=>this.onLogMessage(v))),l.add(this.watcher.onDidError(v=>this.onError(v)))}onError(l){this.options.restartOnError?this.restartCounter<c.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${l}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${l}`):this.error(l)}restart(l){this.restartCounter++,this.init(),this.watch(l)}async watch(l){this.requests=l,await this.watcher?.watch(l)}async setVerboseLogging(l){this.verboseLogging=l,await this.watcher?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${l}`})}trace(l){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${l}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=c;class m extends c{constructor(l,v,E){super(l,v,E,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=m;class f extends c{constructor(l,v,E){super(l,v,E,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=f;function w(g){return g.map(l=>({type:l.type,resource:M.URI.file(l.path)}))}e.toFileChanges=w;function d(g){const l=new o;for(const v of g)l.processEvent(v);return l.coalesce()}e.coalesceEvents=d;function b(g,l){return typeof l=="string"&&!l.startsWith(P.GLOBSTAR)&&!(0,s.isAbsolute)(l)?{base:g,pattern:l}:l}e.normalizeWatcherPattern=b;function y(g,l){const v=[];for(const E of l)v.push((0,P.parse)(b(g,E)));return v}e.parseWatcherPatterns=y;class o{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(l){return _.isLinux?l.path:l.path.toLowerCase()}processEvent(l){const v=this.mapPathToChange.get(this.toKey(l));let E=!1;if(v){const S=v.type,t=l.type;v.path!==l.path&&(l.type===2||l.type===1)?E=!0:S===1&&t===2?(this.mapPathToChange.delete(this.toKey(l)),this.coalesced.delete(v)):S===2&&t===1?v.type=0:S===1&&t===0||(v.type=t)}else E=!0;E&&(this.coalesced.add(l),this.mapPathToChange.set(this.toKey(l),l))}coalesce(){const l=[],v=[];return Array.from(this.coalesced).filter(E=>E.type!==2?(l.push(E),!1):!0).sort((E,S)=>E.path.length-S.path.length).filter(E=>v.some(S=>(0,I.isParent)(E.path,S,!_.isLinux))?!1:(v.push(E.path),!0)).concat(l)}}}),define(te[211],ie([0,1,42,8,21,32,2,86,9,4,105,22,77]),function(j,e,P,L,s,_,M,I,h,c,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends M.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(o,g,l,v){super(),this.request=o,this.onDidFilesChange=g,this.onLogMessage=l,this.verboseLogging=v,this.throttledFileChangesEmitter=this._register(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.onDidFilesChange(E))),this.fileChangesAggregator=this._register(new L.RunOnceWorker(E=>this.handleFileChanges(E),d.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,w.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,w.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new s.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const o=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const g=await f.Promises.stat(o);this._register(await this.doWatch(o,g.isDirectory()))}catch(o){o.code!=="ENOENT"?this.error(o):this.trace(o)}}async normalizePath(o){let g=o.path;try{g=await f.Promises.realpath(o.path),o.path===g&&(g=await(0,m.realcase)(o.path)??o.path),o.path!==g&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${o.path}, real: ${g})`)}catch{}return g}async doWatch(o,g){if(c.isMacintosh&&(0,_.isEqualOrParent)(o,"/Volumes/",!0))return this.error(`Refusing to watch ${o} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const l=new s.CancellationTokenSource(this.cts.token),v=new M.DisposableStore;try{const E=(0,h.basename)(o),S=(0,P.watch)(o);v.add((0,M.toDisposable)(()=>{S.removeAllListeners(),S.close()})),this.trace(`Started watching: '${o}'`);const t=new Set;if(g)try{for(const r of await f.Promises.readdir(o))t.add(r)}catch(r){this.error(r)}const u=new Map;v.add((0,M.toDisposable)(()=>{for(const[,r]of u)r.dispose();u.clear()})),S.on("error",(r,n)=>{this.error(`Failed to watch ${o} for changes using fs.watch() (${r}, ${n})`),this.dispose()}),S.on("change",(r,n)=>{if(l.token.isCancellationRequested)return;this.trace(`[raw] ["${r}"] ${n}`);let i="";if(n&&(i=n.toString(),c.isMacintosh&&(i=(0,I.normalizeNFC)(i))),!(!i||r!=="change"&&r!=="rename"))if(g)if(r==="rename"){u.get(i)?.dispose();const a=setTimeout(async()=>{if(u.delete(i),i===E&&!await f.Promises.exists(o)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const p=await this.existsChildStrictCase((0,h.join)(o,i));if(l.token.isCancellationRequested)return;let C;p?t.has(i)?C=0:(C=1,t.add(i)):(t.delete(i),C=2),this.onFileChange({path:(0,h.join)(this.request.path,i),type:C})},d.FILE_DELETE_HANDLER_DELAY);u.set(i,(0,M.toDisposable)(()=>clearTimeout(a)))}else{let a;t.has(i)?a=0:(a=1,t.add(i)),this.onFileChange({path:(0,h.join)(this.request.path,i),type:a})}else if(r==="rename"||i!==E){const a=setTimeout(async()=>{const p=await f.Promises.exists(o);l.token.isCancellationRequested||(p?(this.onFileChange({path:this.request.path,type:0},!0),v.add(await this.doWatch(o,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},d.FILE_DELETE_HANDLER_DELAY);v.clear(),v.add((0,M.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(E){await f.Promises.exists(o)&&!l.token.isCancellationRequested&&this.error(`Failed to watch ${o} for changes using fs.watch() (${E.toString()})`)}return(0,M.toDisposable)(()=>{l.dispose(!0),v.dispose()})}onFileChange(o,g=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`),!g&&this.excludes.some(l=>l(o.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${o.path}`):!g&&this.includes&&this.includes.length>0&&!this.includes.some(l=>l(o.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${o.path}`):this.fileChangesAggregator.work(o))}handleFileChanges(o){const g=(0,w.coalesceEvents)(o);if(g.length>0){if(this.verboseLogging)for(const v of g)this.trace(`>> normalized ${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`);this.throttledFileChangesEmitter.work(g)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(o){if(c.isLinux)return f.Promises.exists(o);try{const g=(0,h.basename)(o);return(await f.Promises.readdir((0,h.dirname)(o))).some(v=>v===g)}catch(g){return this.trace(g),!1}}setVerboseLogging(o){this.verboseLogging=o}error(o){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${o}`})}warn(o){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${o}`})}trace(o){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${o}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=d;async function b(y,o,g,l,v=512){const E=await f.Promises.open(y,"r"),S=Buffer.allocUnsafe(v),t=new s.CancellationTokenSource(l);let u,r=!1;const n={path:y,excludes:[],recursive:!1},i=new d(n,a=>{(async()=>{for(const{type:p}of a)if(p===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:C}=await f.Promises.read(E,S,0,v,null);if(!C||t.token.isCancellationRequested)break;o(S.slice(0,C))}}catch(C){u=new Error(C),t.dispose(!0)}finally{r=!1}}})()});return await i.ready,g(),new Promise((a,p)=>{t.token.onCancellationRequested(async()=>{i.dispose();try{await f.Promises.close(E)}catch(C){u=new Error(C)}u?p(u):a()})})}e.watchFileContents=b}),define(te[212],ie([0,1,3,104,2,4,211]),function(j,e,P,L,s,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends s.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new P.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=P.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(c){const m=this.normalizeRequests(c),f=m.filter(d=>{const b=this.watchers.get(d.path);return b?!(0,L.patternsEquals)(b.request.excludes,d.excludes)||!(0,L.patternsEquals)(b.request.includes,d.includes):!0}),w=Array.from(this.watchers.values()).filter(({request:d})=>!m.find(b=>b.path===d.path&&(0,L.patternsEquals)(b.excludes,d.excludes)&&(0,L.patternsEquals)(b.includes,d.includes))).map(({request:d})=>d.path);f.length&&this.trace(`Request to start watching: ${f.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),w.length&&this.trace(`Request to stop watching: ${w.join(",")}`);for(const d of w)this.stopWatching(d);for(const d of f)this.startWatching(d)}startWatching(c){const m=new M.NodeJSFileWatcherLibrary(c,w=>this._onDidChangeFile.fire(w),w=>this._onDidLogMessage.fire(w),this.verboseLogging),f={request:c,instance:m};this.watchers.set(c.path,f)}async stop(){for(const[c]of this.watchers)this.stopWatching(c);this.watchers.clear()}stopWatching(c){const m=this.watchers.get(c);m&&(this.watchers.delete(c),m.instance.dispose())}normalizeRequests(c){const m=new Map;for(const f of c){const w=_.isLinux?f.path:f.path.toLowerCase();m.set(w,f)}return Array.from(m.values())}async setVerboseLogging(c){this.verboseLogging=c;for(const[,m]of this.watchers)m.instance.setVerboseLogging(c)}trace(c){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(c)})}toMessage(c,m){return m?`[File Watcher (node.js)] ${c} (path: ${m.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=I}),define(te[213],ie([0,1,77,212]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class s extends P.AbstractNonRecursiveWatcherClient{constructor(M,I,h){super(M,I,h),this.init()}createWatcher(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=s}),define(te[214],ie([0,1,15,43,158,77]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends _.AbstractUniversalWatcherClient{constructor(h,c,m){super(h,c,m),this.init()}createWatcher(h){const c=h.add(new s.Client(P.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:m,signal:f})=>this.onError(`terminated by itself with code ${m}, signal: ${f}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(te[93],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class P{constructor(...s){this._entries=new Map;for(const[_,M]of s)this.set(_,M)}set(s,_){const M=this._entries.get(s);return this._entries.set(s,_),M}has(s){return this._entries.has(s)}get(s){return this._entries.get(s)}}e.ServiceCollection=P}),define(te[215],ie([0,1,8,13,2,75,206,6,93,101]),function(j,e,P,L,s,_,M,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const m=!1;class f extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class w{constructor(o=new h.ServiceCollection,g=!1,l,v=m){this._services=o,this._strict=g,this._parent=l,this._enableTracing=v,this._activeInstantiations=new Set,this._services.set(I.IInstantiationService,this),this._globalGraph=v?l?._globalGraph??new M.Graph(E=>E):void 0}createChild(o){return new w(o,this._strict,this,this._enableTracing)}invokeFunction(o,...g){const l=b.traceInvocation(this._enableTracing,o);let v=!1;try{return o({get:S=>{if(v)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(S,l);if(!t)throw new Error(`[invokeFunction] unknown service '${S}'`);return t}},...g)}finally{v=!0,l.stop()}}createInstance(o,...g){let l,v;return o instanceof _.SyncDescriptor?(l=b.traceCreation(this._enableTracing,o.ctor),v=this._createInstance(o.ctor,o.staticArguments.concat(g),l)):(l=b.traceCreation(this._enableTracing,o),v=this._createInstance(o,g,l)),l.stop(),v}_createInstance(o,g=[],l){const v=I._util.getServiceDependencies(o).sort((t,u)=>t.index-u.index),E=[];for(const t of v){const u=this._getOrCreateServiceInstance(t.id,l);u||this._throwIfStrict(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(u)}const S=v.length>0?v[0].index:g.length;if(g.length!==S){console.trace(`[createInstance] First service dependency of ${o.name} at position ${S+1} conflicts with ${g.length} static arguments`);const t=S-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,S)}return Reflect.construct(o,g.concat(E))}_setServiceInstance(o,g){if(this._services.get(o)instanceof _.SyncDescriptor)this._services.set(o,g);else if(this._parent)this._parent._setServiceInstance(o,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){const g=this._services.get(o);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):g}_getOrCreateServiceInstance(o,g){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(o));const l=this._getServiceInstanceOrDescriptor(o);return l instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,l,g.branch(o,!0)):(g.branch(o,!1),l)}_safeCreateAndCacheServiceInstance(o,g,l){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,g,l)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,g,l){const v=new M.Graph(t=>t.id.toString());let E=0;const S=[{id:o,desc:g,_trace:l}];for(;S.length;){const t=S.pop();if(v.lookupOrInsertNode(t),E++>1e3)throw new f(v);for(const u of I._util.getServiceDependencies(t.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(u.id);if(r||this._throwIfStrict(`[createInstance] ${o} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(u.id)),r instanceof _.SyncDescriptor){const n={id:u.id,desc:r,_trace:t._trace.branch(u.id,!0)};v.insertEdge(t,n),S.push(n)}}}for(;;){const t=v.roots();if(t.length===0){if(!v.isEmpty())throw new f(v);break}for(const{data:u}of t){if(this._getServiceInstanceOrDescriptor(u.id)instanceof _.SyncDescriptor){const n=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,n)}v.removeNode(u)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,g,l=[],v,E){if(this._services.get(o)instanceof _.SyncDescriptor)return this._createServiceInstance(o,g,l,v,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,g,l,v,E);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(o,g,l=[],v,E){if(v){const S=new w(void 0,this._strict,this,this._enableTracing);S._globalGraphImplicitDependency=String(o);const t=new Map,u=new P.IdleValue(()=>{const r=S._createInstance(g,l,E);for(const[n,i]of t){const a=r[n];if(typeof a=="function")for(const p of i)a.apply(r,p)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,n){if(!u.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let p=t.get(n);return p||(p=new c.LinkedList,t.set(n,p)),(k,D,A)=>{const O=p.push([k,D,A]);return(0,s.toDisposable)(O)}}if(n in r)return r[n];const i=u.value;let a=i[n];return typeof a!="function"||(a=a.bind(i),r[n]=a),a},set(r,n,i){return u.value[n]=i,!0},getPrototypeOf(r){return g.prototype}})}else return this._createInstance(g,l,E)}_throwIfStrict(o,g){if(g&&console.warn(o),this._strict)throw new Error(o)}}e.InstantiationService=w;var d;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(d||(d={}));class b{static{this.all=new Set}static{this._None=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,g){return o?new b(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b._None}static traceCreation(o,g){return o?new b(1,g.name):b._None}static{this._totals=0}constructor(o,g){this.type=o,this.name=g,this._start=Date.now(),this._dep=[]}branch(o,g){const l=new b(3,o.toString());return this._dep.push([o,g,l]),l}stop(){const o=Date.now()-this._start;b._totals+=o;let g=!1;function l(E,S){const t=[],u=new Array(E+1).join("	");for(const[r,n,i]of S._dep)if(n&&i){g=!0,t.push(`${u}CREATES -> ${r}`);const a=l(E+1,i);a&&t.push(a)}else t.push(`${u}uses -> ${r}`);return t.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(o>2||g)&&b.all.add(v.join(`
`))}}e.Trace=b}),define(te[216],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueType=void 0;var L;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(L||(e.IssueType=L={})),e.IIssueMainService=(0,P.createDecorator)("issueService")}),define(te[5],ie([0,1,50,3,57,2,35,4,19,10,7,114,6]),function(j,e,P,L,s,_,M,I,h,c,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function d(){return new Date().toISOString()}function b(k){return(0,c.isNumber)(k)}e.isLogLevel=b;var y;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(y||(e.LogLevel=y={})),e.DEFAULT_LOG_LEVEL=y.Info;function o(k,D,A){switch(D){case y.Trace:k.trace(A);break;case y.Debug:k.debug(A);break;case y.Info:k.info(A);break;case y.Warning:k.warn(A);break;case y.Error:k.error(A);break;case y.Off:break;default:throw new Error(`Invalid log level ${D}`)}}e.log=o;function g(k,D=!1){let A="";for(let O=0;O<k.length;O++){let U=k[O];if(U instanceof Error&&(U=(0,P.toErrorMessage)(U,D)),typeof U=="object")try{U=JSON.stringify(U)}catch{}A+=(O>0?" ":"")+U}return A}class l extends _.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(D){this.level!==D&&(this.level=D,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(D){return this.level!==y.Off&&this.level<=D}}e.AbstractLogger=l;class v extends l{constructor(D){super(),this.logAlways=D}checkLogLevel(D){return this.logAlways||super.checkLogLevel(D)}trace(D,...A){this.checkLogLevel(y.Trace)&&this.log(y.Trace,g([D,...A],!0))}debug(D,...A){this.checkLogLevel(y.Debug)&&this.log(y.Debug,g([D,...A]))}info(D,...A){this.checkLogLevel(y.Info)&&this.log(y.Info,g([D,...A]))}warn(D,...A){this.checkLogLevel(y.Warning)&&this.log(y.Warning,g([D,...A]))}error(D,...A){if(this.checkLogLevel(y.Error))if(D instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=D.stack,this.log(y.Error,g(O))}else this.log(y.Error,g([D,...A]))}flush(){}}e.AbstractMessageLogger=v;class E extends l{constructor(D=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(D),this.useColors=!I.isWindows}trace(D,...A){this.checkLogLevel(y.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,D,...A):console.log(`[main ${d()}]`,D,...A))}debug(D,...A){this.checkLogLevel(y.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,D,...A):console.log(`[main ${d()}]`,D,...A))}info(D,...A){this.checkLogLevel(y.Info)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,D,...A):console.log(`[main ${d()}]`,D,...A))}warn(D,...A){this.checkLogLevel(y.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,D,...A):console.warn(`[main ${d()}]`,D,...A))}error(D,...A){this.checkLogLevel(y.Error)&&(this.useColors?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,D,...A):console.error(`[main ${d()}]`,D,...A))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class S extends l{constructor(D=e.DEFAULT_LOG_LEVEL,A=!0){super(),this.useColors=A,this.setLevel(D)}trace(D,...A){this.checkLogLevel(y.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",D,...A):console.log(D,...A))}debug(D,...A){this.checkLogLevel(y.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",D,...A):console.log(D,...A))}info(D,...A){this.checkLogLevel(y.Info)&&(this.useColors?console.log("%c INFO","color: #33f",D,...A):console.log(D,...A))}warn(D,...A){this.checkLogLevel(y.Warning)&&(this.useColors?console.log("%c WARN","color: #993",D,...A):console.log(D,...A))}error(D,...A){this.checkLogLevel(y.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",D,...A):console.error(D,...A))}dispose(){}flush(){}}e.ConsoleLogger=S;class t extends l{constructor(D,A=e.DEFAULT_LOG_LEVEL){super(),this.adapter=D,this.setLevel(A)}trace(D,...A){this.checkLogLevel(y.Trace)&&this.adapter.log(y.Trace,[this.extractMessage(D),...A])}debug(D,...A){this.checkLogLevel(y.Debug)&&this.adapter.log(y.Debug,[this.extractMessage(D),...A])}info(D,...A){this.checkLogLevel(y.Info)&&this.adapter.log(y.Info,[this.extractMessage(D),...A])}warn(D,...A){this.checkLogLevel(y.Warning)&&this.adapter.log(y.Warning,[this.extractMessage(D),...A])}error(D,...A){this.checkLogLevel(y.Error)&&this.adapter.log(y.Error,[this.extractMessage(D),...A])}extractMessage(D){return typeof D=="string"?D:(0,P.toErrorMessage)(D,this.checkLogLevel(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class u extends l{constructor(D){super(),this.loggers=D,D.length&&this.setLevel(D[0].getLevel())}setLevel(D){for(const A of this.loggers)A.setLevel(D);super.setLevel(D)}trace(D,...A){for(const O of this.loggers)O.trace(D,...A)}debug(D,...A){for(const O of this.loggers)O.debug(D,...A)}info(D,...A){for(const O of this.loggers)O.info(D,...A)}warn(D,...A){for(const O of this.loggers)O.warn(D,...A)}error(D,...A){for(const O of this.loggers)O.error(D,...A)}flush(){for(const D of this.loggers)D.flush()}dispose(){for(const D of this.loggers)D.dispose()}}e.MultiplexLogger=u;class r extends _.Disposable{constructor(D,A,O){if(super(),this.logLevel=D,this.logsHome=A,this._loggers=new M.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,O)for(const U of O)this._loggers.set(U.resource,{logger:void 0,info:U})}getLoggerEntry(D){return(0,c.isString)(D)?[...this._loggers.values()].find(A=>A.info.id===D):this._loggers.get(D)}getLogger(D){return this.getLoggerEntry(D)?.logger}createLogger(D,A){const O=this.toResource(D),U=(0,c.isString)(D)?D:A?.id??(0,s.hash)(O.toString()).toString(16);let q=this._loggers.get(O)?.logger;const se=A?.logLevel==="always"?y.Trace:A?.logLevel;q||(q=this.doCreateLogger(O,se??this.getLogLevel(O)??this.logLevel,{...A,id:U}));const ne={logger:q,info:{resource:O,id:U,logLevel:se,name:A?.name,hidden:A?.hidden,extensionId:A?.extensionId,when:A?.when}};return this.registerLogger(ne.info),this._loggers.set(O,ne),q}toResource(D){return(0,c.isString)(D)?(0,h.joinPath)(this.logsHome,`${D}.log`):D}setLogLevel(D,A){if(m.URI.isUri(D)){const O=D,U=A,q=this._loggers.get(O);q&&U!==q.info.logLevel&&(q.info.logLevel=U===this.logLevel?void 0:U,q.logger?.setLevel(U),this._loggers.set(q.info.resource,q),this._onDidChangeLogLevel.fire([O,U]))}else{this.logLevel=D;for(const[O,U]of this._loggers.entries())this._loggers.get(O)?.info.logLevel===void 0&&U.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(D,A){const O=this.getLoggerEntry(D);O&&A!==!O.info.hidden&&(O.info.hidden=!A,this._loggers.set(O.info.resource,O),this._onDidChangeVisibility.fire([O.info.resource,A]))}getLogLevel(D){let A;return D&&(A=this._loggers.get(D)?.info.logLevel),A??this.logLevel}registerLogger(D){const A=this._loggers.get(D.resource);A?A.info.hidden!==D.hidden&&this.setVisibility(D.resource,!D.hidden):(this._loggers.set(D.resource,{info:D,logger:void 0}),this._onDidChangeLoggers.fire({added:[D],removed:[]}))}deregisterLogger(D){const A=this._loggers.get(D);A&&(A.logger&&A.logger.dispose(),this._loggers.delete(D),this._onDidChangeLoggers.fire({added:[],removed:[A.info]}))}*getRegisteredLoggers(){for(const D of this._loggers.values())yield D.info}getRegisteredLogger(D){return this._loggers.get(D)?.info}dispose(){this._loggers.forEach(D=>D.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=r;class n{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(D){}getLevel(){return y.Info}trace(D,...A){}debug(D,...A){}info(D,...A){}warn(D,...A){}error(D,...A){}critical(D,...A){}dispose(){}flush(){}}e.NullLogger=n;class i extends n{}e.NullLogService=i;function a(k){if(k.verbose)return y.Trace;if(typeof k.logLevel=="string"){const D=C(k.logLevel.toLowerCase());if(D!==void 0)return D}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function p(k){switch(k){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=p;function C(k){switch(k){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=C,e.CONTEXT_LOG_LEVEL=new f.RawContextKey("logLevel",p(y.Info))});var J=this&&this.__param||function(j,e){return function(P,L){e(P,L,j)}};define(te[217],ie([0,1,76,3,2,5,4,8]),function(j,e,P,L,s,_,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let h=class ut extends s.Disposable{static{this.MAX_PASSWORD_LENGTH=2500}static{this.PASSWORD_CHUNK_SIZE=ut.MAX_PASSWORD_LENGTH-100}constructor(m){super(),this.logService=m,this._onDidChangePassword=this._register(new L.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this._sequencer=new I.SequencerByKey}async getPassword(m,f){this.logService.trace("Going to get password from keytar:",m,f);let w;try{w=await this.withKeytar()}catch{return null}return await this._sequencer.queue(m+f,()=>this.doGetPassword(w,m,f))}async doGetPassword(m,f,w){this.logService.trace("Doing get password from keytar:",f,w);const d=await(0,I.retry)(()=>m.getPassword(f,w),50,3);if(!d)return this.logService.trace("Did not get a password from keytar for account:",w),d;let b,y;try{const o=JSON.parse(d);b=o.content,y=o.hasNextChunk}catch{}if(!b||!y)return this.logService.trace("Got password from keytar for account:",w),d;try{let o=1;for(;y;){const g=await(0,I.retry)(()=>m.getPassword(f,`${w}-${o}`),50,3),l=JSON.parse(g);b+=l.content,y=l.hasNextChunk,o++}return this.logService.trace(`Got ${o}-chunked password from keytar for account:`,w),b}catch(o){return this.logService.error(o),d}}async setPassword(m,f,w){this.logService.trace("Going to set password using keytar:",m,f);let d;try{d=await this.withKeytar()}catch(b){throw this.surfaceKeytarLoadError?.(b),b}await this._sequencer.queue(m+f,()=>this.doSetPassword(d,m,f,w)),this._onDidChangePassword.fire({service:m,account:f})}async doSetPassword(m,f,w,d){if(this.logService.trace("Doing set password from keytar:",f,w),!M.isWindows){await(0,I.retry)(()=>m.setPassword(f,w,d),50,3),this.logService.trace("Set password from keytar for account:",w);return}if(await this.doDeletePassword(m,f,w),d.length<=ut.PASSWORD_CHUNK_SIZE){await(0,I.retry)(()=>m.setPassword(f,w,d),50,3),this.logService.trace("Set password from keytar for account:",w);return}let b=0,y=0,o=!0;for(;o;){const g=d.substring(b,b+ut.PASSWORD_CHUNK_SIZE);b+=ut.PASSWORD_CHUNK_SIZE,o=d.length-b>0;const l={content:g,hasNextChunk:o};await(0,I.retry)(()=>m.setPassword(f,y?`${w}-${y}`:w,JSON.stringify(l)),50,3),y++}this.logService.trace(`Set${y?` ${y}-chunked`:""} password from keytar for account:`,w)}async deletePassword(m,f){this.logService.trace("Going to delete password using keytar:",m,f);let w;try{w=await this.withKeytar()}catch(b){throw this.surfaceKeytarLoadError?.(b),b}const d=await this._sequencer.queue(m+f,()=>this.doDeletePassword(w,m,f));return d&&this._onDidChangePassword.fire({service:m,account:f}),d}async doDeletePassword(m,f,w){this.logService.trace("Doing delete password from keytar:",f,w);const d=await m.getPassword(f,w);if(!d)return this.logService.trace("Did not get a password to delete from keytar for account:",w),!1;let b,y;try{const g=JSON.parse(d);b=g.content,y=g.hasNextChunk}catch{}let o=0;if(b&&y)try{for(o++;y;){const g=`${w}-${o}`,l=await m.getPassword(f,g);await m.deletePassword(f,g),y=JSON.parse(l).hasNextChunk,o++}}catch(g){this.logService.error(g)}return await m.deletePassword(f,w)?(this.logService.trace(`Deleted${o?` ${o}-chunked`:""} password from keytar for account:`,w),!0):(this.logService.trace(`Keytar failed to delete${o?` ${o}-chunked`:""} password for account:`,w),!1)}async findPassword(m){let f;try{f=await this.withKeytar()}catch{return null}return await f.findPassword(m)}async findCredentials(m){let f;try{f=await this.withKeytar()}catch{return[]}return await f.findCredentials(m)}clear(){return this._keytarCache instanceof P.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};e.BaseCredentialsMainService=h,e.BaseCredentialsMainService=h=Se([J(0,_.ILogService)],h)}),define(te[218],ie([0,1,14,4,5]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;const _=P.safeStorage;let M=class{constructor(h,c){this.machineId=h,this.logService=c,P.app.commandLine.getSwitchValue("password-store")==="basic"&&_.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.logService.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(_.encryptString(h));return this.logService.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.logService.error(c),c}}async decrypt(h){let c;try{if(c=JSON.parse(h),!c.data)return this.logService.trace("[EncryptionMainService] Unable to parse encrypted value. Attempting old decryption."),this.oldDecrypt(h)}catch(f){return this.logService.trace("[EncryptionMainService] Unable to parse encrypted value. Attempting old decryption.",f),this.oldDecrypt(h)}const m=Buffer.from(c.data);this.logService.trace("[EncryptionMainService] Decrypting value.");try{const f=_.decryptString(m);return this.logService.trace("[EncryptionMainService] Decrypted value."),f}catch(f){throw this.logService.error(f),f}}isEncryptionAvailable(){return Promise.resolve(_.isEncryptionAvailable())}getKeyStorageProvider(){if(L.isWindows)return Promise.resolve("dpapi");if(L.isMacintosh)return Promise.resolve("keychain_access");if(_.getSelectedStorageBackend)try{const h=_.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.logService.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(L.isWindows)throw new Error("Setting plain text encryption is not supported on Windows.");if(L.isMacintosh)throw new Error("Setting plain text encryption is not supported on macOS.");if(!_.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");_.setUsePlainTextEncryption(!0)}async oldDecrypt(h){let c;try{c=await new Promise((m,f)=>j(["vscode-encrypt"],m,f))}catch{return h}try{return c.decrypt(this.machineId,h)}catch(m){return this.logService.error(m),h}}};e.EncryptionMainService=M,e.EncryptionMainService=M=Se([J(1,s.ILogService)],M)}),define(te[219],ie([0,1,24,8,13,3,2,9,77,5]),function(j,e,P,L,s,_,M,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class m extends M.Disposable{constructor(w,d){super(),this.logService=w,this.options=d,this._onDidChangeFile=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new L.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(w,d){return d.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(w,d):this.watchNonRecursive(w,d)}watchUniversal(w,d){const b={path:this.toFilePath(w),excludes:d.excludes,includes:d.includes,recursive:d.recursive},y=(0,P.insert)(this.universalPathsToWatch,b);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(w=>(0,s.onUnexpectedError)(w))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(d=>this._onDidChangeFile.fire((0,h.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===c.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)})));const w=this.options?.watcher?.recursive?.usePolling;if(w===!0)for(const d of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const d of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(d)&&w.includes(d.path)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(w,d){const b={path:this.toFilePath(w),excludes:d.excludes,includes:d.includes,recursive:!1},y=(0,P.insert)(this.nonRecursivePathsToWatch,b);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(w=>(0,s.onUnexpectedError)(w))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(w=>this._onDidChangeFile.fire((0,h.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===c.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(w){w.type==="error"&&this._onDidWatchError.fire(w.message),this.logService[w.type](w.message)}toFilePath(w){return(0,I.normalize)(w.fsPath)}}e.AbstractDiskFileSystemProvider=m}),define(te[220],ie([0,1,24,8,17,21,3,57,68,2,58,15,65,19,56,173,16,118,5,13]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o,g,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let E=class extends c.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(t,u){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${t}`);const r=new c.DisposableStore;return this.provider.set(t,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:u}),r.add(u.onDidChangeFile(n=>this._onDidFilesChange.fire(new o.FileChangesEvent(n,!this.isPathCaseSensitive(u))))),typeof u.onDidWatchError=="function"&&r.add(u.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),r.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:t}))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:u}),this.provider.delete(t),(0,c.dispose)(r)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(r){u.push(r)}}),!this.provider.has(t)&&await L.Promises.settled(u)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,u){const r=this.provider.get(t.scheme);return!!(r&&r.capabilities&u)}listCapabilities(){return h.Iterable.map(this.provider,([t,u])=>({scheme:t,capabilities:u.capabilities}))}async withProvider(t){if(!(0,d.isAbsolutePath)(t))throw new o.FileOperationError((0,y.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const u=this.provider.get(t.scheme);if(!u){const r=new v.ErrorNoTelemetry;throw r.message=(0,y.localize)(1,null,t.toString()),r}return u}async withReadProvider(t){const u=await this.withProvider(t);if((0,o.hasOpenReadWriteCloseCapability)(u)||(0,o.hasReadWriteCapability)(u)||(0,o.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const u=await this.withProvider(t);if((0,o.hasOpenReadWriteCloseCapability)(u)||(0,o.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,u){try{return await this.doResolveFile(t,u)}catch(r){throw(0,o.toFileSystemProviderErrorCode)(r)===o.FileSystemProviderErrorCode.FileNotFound?new o.FileOperationError((0,y.localize)(2,null,this.resourceForError(t)),1):(0,o.ensureFileSystemProviderError)(r)}}async doResolveFile(t,u){const r=await this.withProvider(t),n=this.isPathCaseSensitive(r),i=u?.resolveTo,a=u?.resolveSingleChildDescendants,p=u?.resolveMetadata,C=await r.stat(t);let k;return this.toFileStat(r,t,C,void 0,!!p,(D,A)=>(k||(k=m.TernarySearchTree.forUris(()=>!n),k.set(t,!0),i&&k.fill(!0,i)),k.get(D.resource)||k.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&a?A===1:!1))}async toFileStat(t,u,r,n,i,a){const{providerExtUri:p}=this.getExtUri(t),C={resource:u,name:p.basename(u),isFile:(r.type&o.FileType.File)!==0,isDirectory:(r.type&o.FileType.Directory)!==0,isSymbolicLink:(r.type&o.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&o.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((r.permissions??0)&o.FilePermission.Locked),etag:(0,o.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(C.isDirectory&&a(C,n)){try{const k=await t.readdir(u),D=await L.Promises.settled(k.map(async([A,O])=>{try{const U=p.joinPath(u,A),q=i?await t.stat(U):{type:O};return await this.toFileStat(t,U,q,k.length,i,a)}catch(U){return this.logService.trace(U),null}}));C.children=(0,P.coalesce)(D)}catch(k){this.logService.trace(k),C.children=[]}return C}return C}async resolveAll(t){return L.Promises.settled(t.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const u=await this.withProvider(t),r=await u.stat(t);return this.toFileStat(u,t,r,void 0,!0,()=>!1)}async exists(t){const u=await this.withProvider(t);try{return!!await u.stat(t)}catch{return!1}}async canCreateFile(t,u){try{await this.doValidateCreateFile(t,u)}catch(r){return r}return!0}async doValidateCreateFile(t,u){if(!u?.overwrite&&await this.exists(t))throw new o.FileOperationError((0,y.localize)(3,null,this.resourceForError(t)),3,u)}async createFile(t,u=s.VSBuffer.fromString(""),r){await this.doValidateCreateFile(t,r);const n=await this.writeFile(t,u);return this._onDidRunOperation.fire(new o.FileOperationEvent(t,0,n)),n}async writeFile(t,u,r){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:i}=this.getExtUri(n);try{await this.validateWriteFile(n,t,r)||await this.mkdirp(n,i.dirname(t));let p;if((0,o.hasReadWriteCapability)(n)&&!(u instanceof s.VSBuffer))if((0,b.isReadableStream)(u)){const C=await(0,b.peekStream)(u,3);C.ended?p=s.VSBuffer.concat(C.buffer):p=C}else p=(0,b.peekReadable)(u,C=>s.VSBuffer.concat(C),3);else p=u;if(!(0,o.hasOpenReadWriteCloseCapability)(n)||(0,o.hasReadWriteCapability)(n)&&p instanceof s.VSBuffer)await this.doWriteUnbuffered(n,t,r,p);else{const C=p instanceof s.VSBuffer?(0,s.bufferToReadable)(p):p;r?.atomic!==!1&&r?.atomic?.postfix?await this.doWriteBufferedAtomic(n,t,(0,d.joinPath)((0,d.dirname)(t),`${(0,d.basename)(t)}${r.atomic.postfix}`),r,C):await this.doWriteBuffered(n,t,r,C)}this._onDidRunOperation.fire(new o.FileOperationEvent(t,4))}catch(a){throw new o.FileOperationError((0,y.localize)(4,null,this.resourceForError(t),(0,o.ensureFileSystemProviderError)(a).toString()),(0,o.toFileOperationResult)(a),r)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,u,r){const n=!!r?.unlock;if(n&&!(t.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(u)));if(!!r?.atomic){if(!(t.capabilities&32768))throw new Error((0,y.localize)(6,null,this.resourceForError(u)));if(n)throw new Error((0,y.localize)(7,null,this.resourceForError(u)))}let a;try{a=await t.stat(u)}catch{return}if(a.type&o.FileType.Directory)throw new o.FileOperationError((0,y.localize)(8,null,this.resourceForError(u)),0,r);if(this.throwIfFileIsReadonly(u,a),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==o.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&r.mtime<a.mtime&&r.etag!==(0,o.etag)({mtime:r.mtime,size:a.size}))throw new o.FileOperationError((0,y.localize)(9,null),3,r);return a}async readFile(t,u,r){const n=await this.withReadProvider(t);return u?.atomic?this.doReadFileAtomic(n,t,u,r):this.doReadFile(n,t,u,r)}async doReadFileAtomic(t,u,r,n){return new Promise((i,a)=>{this.writeQueue.queueFor(u,this.getExtUri(t).providerExtUri).queue(async()=>{try{const p=await this.doReadFile(t,u,r,n);i(p)}catch(p){a(p)}})})}async doReadFile(t,u,r,n){const i=await this.doReadFileStream(t,u,{...r,preferUnbuffered:!0},n);return{...i,value:await(0,s.streamToBuffer)(i.value)}}async readFileStream(t,u,r){const n=await this.withReadProvider(t);return this.doReadFileStream(n,t,u,r)}async doReadFileStream(t,u,r,n){const i=new _.CancellationTokenSource(n),a=this.validateReadFile(u,r).then(C=>C,C=>{throw i.cancel(),C});let p;try{return typeof r?.etag=="string"&&r.etag!==o.ETAG_DISABLED&&await a,r?.atomic&&(0,o.hasFileAtomicReadCapability)(t)||!((0,o.hasOpenReadWriteCloseCapability)(t)||(0,o.hasFileReadStreamCapability)(t))||(0,o.hasReadWriteCapability)(t)&&r?.preferUnbuffered?p=this.readFileUnbuffered(t,u,r):(0,o.hasFileReadStreamCapability)(t)?p=this.readFileStreamed(t,u,i.token,r):p=this.readFileBuffered(t,u,i.token,r),{...await a,value:p}}catch(C){throw p&&await(0,b.consumeStream)(p),this.restoreReadError(C,u,r)}}restoreReadError(t,u,r){const n=(0,y.localize)(10,null,this.resourceForError(u),(0,o.ensureFileSystemProviderError)(t).toString());return t instanceof o.NotModifiedSinceFileOperationError?new o.NotModifiedSinceFileOperationError(n,t.stat,r):t instanceof o.TooLargeFileOperationError?new o.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new o.FileOperationError(n,(0,o.toFileOperationResult)(t),r)}readFileStreamed(t,u,r,n=Object.create(null)){const i=t.readFileStream(u,n,r);return(0,b.transform)(i,{data:a=>a instanceof s.VSBuffer?a:s.VSBuffer.wrap(a),error:a=>this.restoreReadError(a,u,n)},a=>s.VSBuffer.concat(a))}readFileBuffered(t,u,r,n=Object.create(null)){const i=(0,s.newWriteableBufferStream)();return(0,g.readFileIntoStream)(t,u,i,a=>a,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>this.restoreReadError(a,u,n)},r),i}readFileUnbuffered(t,u,r){const n=(0,b.newWriteableStream)(i=>s.VSBuffer.concat(i));return(async()=>{try{let i;r?.atomic&&(0,o.hasFileAtomicReadCapability)(t)?i=await t.readFile(u,{atomic:!0}):i=await t.readFile(u),typeof r?.position=="number"&&(i=i.slice(r.position)),typeof r?.length=="number"&&(i=i.slice(0,r.length)),this.validateReadFileLimits(u,i.byteLength,r),n.end(s.VSBuffer.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async validateReadFile(t,u){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new o.FileOperationError((0,y.localize)(11,null,this.resourceForError(t)),0,u);if(typeof u?.etag=="string"&&u.etag!==o.ETAG_DISABLED&&u.etag===r.etag)throw new o.NotModifiedSinceFileOperationError((0,y.localize)(12,null),r,u);return this.validateReadFileLimits(t,r.size,u),r}validateReadFileLimits(t,u,r){if(typeof r?.limits?.size=="number"&&u>r.limits.size)throw new o.TooLargeFileOperationError((0,y.localize)(13,null,this.resourceForError(t)),7,u,r)}async canMove(t,u,r){return this.doCanMoveCopy(t,u,"move",r)}async canCopy(t,u,r){return this.doCanMoveCopy(t,u,"copy",r)}async doCanMoveCopy(t,u,r,n){if(t.toString()!==u.toString())try{const i=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(i,t,a,u,r,n)}catch(i){return i}return!0}async move(t,u,r){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),a=await this.doMoveCopy(n,t,i,u,"move",!!r),p=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new o.FileOperationEvent(t,a==="move"?2:3,p)),p}async copy(t,u,r){const n=await this.withReadProvider(t),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),a=await this.doMoveCopy(n,t,i,u,"copy",!!r),p=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new o.FileOperationEvent(t,a==="copy"?3:2,p)),p}async doMoveCopy(t,u,r,n,i,a){if(u.toString()===n.toString())return i;const{exists:p,isSameResourceWithDifferentPathCase:C}=await this.doValidateMoveCopy(t,u,r,n,i,a);if(p&&!C&&a&&await this.del(n,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(n)),i==="copy"){if(t===r&&(0,o.hasFileFolderCopyCapability)(t))await t.copy(u,n,{overwrite:a});else{const k=await this.resolve(u);k.isDirectory?await this.doCopyFolder(t,k,r,n):await this.doCopyFile(t,u,r,n)}return i}else return t===r?(await t.rename(u,n,{overwrite:a}),i):(await this.doMoveCopy(t,u,r,n,"copy",a),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(t,u,r,n){if((0,o.hasOpenReadWriteCloseCapability)(t)&&(0,o.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(t,u,r,n);if((0,o.hasOpenReadWriteCloseCapability)(t)&&(0,o.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(t,u,r,n);if((0,o.hasReadWriteCapability)(t)&&(0,o.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(t,u,r,n);if((0,o.hasReadWriteCapability)(t)&&(0,o.hasReadWriteCapability)(r))return this.doPipeUnbuffered(t,u,r,n)}async doCopyFolder(t,u,r,n){await r.mkdir(n),Array.isArray(u.children)&&await L.Promises.settled(u.children.map(async i=>{const a=this.getExtUri(r).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.doCopyFolder(t,await this.resolve(i.resource),r,a):this.doCopyFile(t,i.resource,r,a)}))}async doValidateMoveCopy(t,u,r,n,i,a){let p=!1;if(t===r){const{providerExtUri:k,isPathCaseSensitive:D}=this.getExtUri(t);if(D||(p=k.isEqual(u,n)),p&&i==="copy")throw new Error((0,y.localize)(14,null,this.resourceForError(u),this.resourceForError(n)));if(!p&&k.isEqualOrParent(n,u))throw new Error((0,y.localize)(15,null,this.resourceForError(u),this.resourceForError(n)))}const C=await this.exists(n);if(C&&!p){if(!a)throw new o.FileOperationError((0,y.localize)(16,null,this.resourceForError(u),this.resourceForError(n)),4);if(t===r){const{providerExtUri:k}=this.getExtUri(t);if(k.isEqualOrParent(u,n))throw new Error((0,y.localize)(17,null,this.resourceForError(u),this.resourceForError(n)))}}return{exists:C,isSameResourceWithDifferentPathCase:p}}getExtUri(t){const u=this.isPathCaseSensitive(t);return{providerExtUri:u?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(u,t);const r=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new o.FileOperationEvent(t,0,r)),r}async mkdirp(t,u){const r=[],{providerExtUri:n}=this.getExtUri(t);for(;!n.isEqual(u,n.dirname(u));)try{if(!((await t.stat(u)).type&o.FileType.Directory))throw new Error((0,y.localize)(18,null,this.resourceForError(u)));break}catch(i){if((0,o.toFileSystemProviderErrorCode)(i)!==o.FileSystemProviderErrorCode.FileNotFound)throw i;r.push(n.basename(u)),u=n.dirname(u)}for(let i=r.length-1;i>=0;i--){u=n.joinPath(u,r[i]);try{await t.mkdir(u)}catch(a){if((0,o.toFileSystemProviderErrorCode)(a)!==o.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(t,u){try{await this.doValidateDelete(t,u)}catch(r){return r}return!0}async doValidateDelete(t,u){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t),n=!!u?.useTrash;if(n&&!(r.capabilities&4096))throw new Error((0,y.localize)(19,null,this.resourceForError(t)));const i=u?.atomic;if(i&&!(r.capabilities&65536))throw new Error((0,y.localize)(20,null,this.resourceForError(t)));if(n&&i)throw new Error((0,y.localize)(21,null,this.resourceForError(t)));let a;try{a=await r.stat(t)}catch{}if(a)this.throwIfFileIsReadonly(t,a);else throw new o.FileOperationError((0,y.localize)(22,null,this.resourceForError(t)),1);if(!!!u?.recursive){const C=await this.resolve(t);if(C.isDirectory&&Array.isArray(C.children)&&C.children.length>0)throw new Error((0,y.localize)(23,null,this.resourceForError(t)))}return r}async del(t,u){const r=await this.doValidateDelete(t,u),n=!!u?.useTrash,i=!!u?.recursive,a=u?.atomic??!1;await r.delete(t,{recursive:i,useTrash:n,atomic:a}),this._onDidRunOperation.fire(new o.FileOperationEvent(t,1))}async cloneFile(t,u){const r=await this.withProvider(t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);if(r===n&&this.getExtUri(r).providerExtUri.isEqual(t,u))return;if(r===n&&(0,o.hasFileCloneCapability)(r))return r.cloneFile(t,u);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(u));const i=this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri);return r===n&&(0,o.hasFileFolderCopyCapability)(r)?i.queue(()=>r.copy(t,u,{overwrite:!0})):i.queue(()=>this.doCopyFile(r,t,n,u))}watch(t,u={recursive:!1,excludes:[]}){const r=new c.DisposableStore;let n=!1,i=()=>{n=!0};return r.add((0,c.toDisposable)(()=>i())),(async()=>{try{const a=await this.doWatch(t,u);n?(0,c.dispose)(a):i=()=>(0,c.dispose)(a)}catch(a){this.logService.error(a)}})(),r}async doWatch(t,u){const r=await this.withProvider(t),n=(0,I.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(t),u]);let i=this.activeWatchers.get(n);return i||(i={count:0,disposable:r.watch(t,u)},this.activeWatchers.set(n,i)),i.count+=1,(0,c.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,c.dispose)(i.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,c.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBufferedAtomic(t,u,r,n,i){await this.doWriteBuffered(t,r,n,i);try{await t.rename(r,u,{overwrite:!0})}catch(a){try{await t.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async doWriteBuffered(t,u,r,n){return this.writeQueue.queueFor(u,this.getExtUri(t).providerExtUri).queue(async()=>{const i=await t.open(u,{create:!0,unlock:r?.unlock??!1});try{(0,b.isReadableStream)(n)||(0,b.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(t,i,n):await this.doWriteReadableBufferedQueued(t,i,n)}catch(a){throw(0,o.ensureFileSystemProviderError)(a)}finally{await t.close(i)}})}async doWriteStreamBufferedQueued(t,u,r){let n=0,i;if((0,b.isReadableBufferedStream)(r)){if(r.buffer.length>0){const a=s.VSBuffer.concat(r.buffer);await this.doWriteBuffer(t,u,a,a.byteLength,n,0),n+=a.byteLength}if(r.ended)return;i=r.stream}else i=r;return new Promise((a,p)=>{(0,b.listenStream)(i,{onData:async C=>{i.pause();try{await this.doWriteBuffer(t,u,C,C.byteLength,n,0)}catch(k){return p(k)}n+=C.byteLength,setTimeout(()=>i.resume())},onError:C=>p(C),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(t,u,r){let n=0,i;for(;(i=r.read())!==null;)await this.doWriteBuffer(t,u,i,i.byteLength,n,0),n+=i.byteLength}async doWriteBuffer(t,u,r,n,i,a){let p=0;for(;p<n;){const C=await t.write(u,i+p,r.buffer,a+p,n-p);p+=C}}async doWriteUnbuffered(t,u,r,n){return this.writeQueue.queueFor(u,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,u,r,n))}async doWriteUnbufferedQueued(t,u,r,n){let i;n instanceof s.VSBuffer?i=n:(0,b.isReadableStream)(n)?i=await(0,s.streamToBuffer)(n):(0,b.isReadableBufferedStream)(n)?i=await(0,s.bufferedStreamToBuffer)(n):i=(0,s.readableToBuffer)(n),await t.writeFile(u,i.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async doPipeBuffered(t,u,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,u,r,n))}async doPipeBufferedQueued(t,u,r,n){let i,a;try{i=await t.open(u,{create:!1}),a=await r.open(n,{create:!0,unlock:!1});const p=s.VSBuffer.alloc(this.BUFFER_SIZE);let C=0,k=0,D=0;do D=await t.read(i,C,p.buffer,k,p.byteLength-k),await this.doWriteBuffer(r,a,p,D,C,k),C+=D,k+=D,k===p.byteLength&&(k=0);while(D>0)}catch(p){throw(0,o.ensureFileSystemProviderError)(p)}finally{await L.Promises.settled([typeof i=="number"?t.close(i):Promise.resolve(),typeof a=="number"?r.close(a):Promise.resolve()])}}async doPipeUnbuffered(t,u,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,u,r,n))}async doPipeUnbufferedQueued(t,u,r,n){return r.writeFile(n,await t.readFile(u),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(t,u,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,u,r,n))}async doPipeUnbufferedToBufferedQueued(t,u,r,n){const i=await r.open(n,{create:!0,unlock:!1});try{const a=await t.readFile(u);await this.doWriteBuffer(r,i,s.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,o.ensureFileSystemProviderError)(a)}finally{await r.close(i)}}async doPipeBufferedToUnbuffered(t,u,r,n){const i=await(0,s.streamToBuffer)(this.readFileBuffered(t,u,_.CancellationToken.None));await this.doWriteUnbuffered(r,n,void 0,i)}throwIfFileSystemIsReadonly(t,u){if(t.capabilities&2048)throw new o.FileOperationError((0,y.localize)(24,null,this.resourceForError(u)),6);return t}throwIfFileIsReadonly(t,u){if((u.permissions??0)&o.FilePermission.Readonly)throw new o.FileOperationError((0,y.localize)(25,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===f.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=E,e.FileService=E=Se([J(0,l.ILogService)],E)}),define(te[94],ie([0,1,42,309,8,35,17,3,32,2,9,4,19,56,22,177,16,118,219,50,214,213]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o,g,l,v,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(P)}catch(u){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(u)}`)}})();class t extends l.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(r,n){super(r,n),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new _.ResourceMap(i=>w.extUriBiasedIgnorePathCase.getComparisonKey(i)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,f.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:n,symbolicLink:i}=await b.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(n,i),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:o.FilePermission.Locked}}catch(n){throw this.toFileSystemProviderError(n)}}async statIgnoreError(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const n=await b.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),i=[];return await Promise.all(n.map(async a=>{try{let p;a.isSymbolicLink()?p=(await this.stat((0,w.joinPath)(r,a.name))).type:p=this.toType(a),i.push([a.name,p])}catch(p){this.logService.trace(p)}})),i}catch(n){throw this.toFileSystemProviderError(n)}}toType(r,n){let i;return n?.dangling?i=o.FileType.Unknown:r.isFile()?i=o.FileType.File:r.isDirectory()?i=o.FileType.Directory:i=o.FileType.Unknown,n&&(i|=o.FileType.SymbolicLink),i}async createResourceLock(r){const n=this.toFilePath(r);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let i;for(;i=this.resourceLocks.get(r);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await i.wait();const a=new s.Barrier;return this.resourceLocks.set(r,a),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,c.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(r)===a&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(r)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(r,n){let i;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),i=await this.createResourceLock(r));const a=this.toFilePath(r);return await b.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{i?.dispose()}}traceLock(r){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(r)}readFileStream(r,n,i){const a=(0,d.newWriteableStream)(p=>M.VSBuffer.concat(p.map(C=>M.VSBuffer.wrap(C))).buffer);return(0,g.readFileIntoStream)(this,r,a,p=>p.buffer,{...n,bufferSize:256*1024},i),a}async writeFile(r,n,i){return i?.atomic!==!1&&i?.atomic?.postfix?this.doWriteFileAtomic(r,(0,w.joinPath)((0,w.dirname)(r),`${(0,w.basename)(r)}${i.atomic.postfix}`),n,i):this.doWriteFile(r,n,i)}async doWriteFileAtomic(r,n,i,a){await this.doWriteFile(n,i,a);try{await this.rename(n,r,{overwrite:!0})}catch(p){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw p}}async doWriteFile(r,n,i){let a;try{const p=this.toFilePath(r);if(!i.create||!i.overwrite){if(await b.Promises.exists(p)){if(!i.overwrite)throw(0,o.createFileSystemProviderError)((0,y.localize)(0,null),o.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,o.createFileSystemProviderError)((0,y.localize)(1,null),o.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(r,{create:!0,unlock:i.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(p){throw await this.toFileSystemProviderWriteError(r,p)}finally{typeof a=="number"&&await this.close(a)}}static{this.canFlush=!0}static configureFlushOnWrite(r){t.canFlush=r}async open(r,n){const i=this.toFilePath(r);let a;(0,o.isFileOpenForWriteOptions)(n)&&(a=await this.createResourceLock(r));let p;try{if((0,o.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:k}=await b.SymlinkSupport.stat(i);k.mode&128||await b.Promises.chmod(i,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}let C;if((0,o.isFileOpenForWriteOptions)(n)){if(f.isWindows)try{await b.Promises.truncate(i,0),C="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}C||(C="w")}else C="r";p=await b.Promises.open(i,C)}catch(C){throw a?.dispose(),(0,o.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(r,C):this.toFileSystemProviderError(C)}if(this.mapHandleToPos.set(p,0),(0,o.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(p,r),a){const C=this.mapHandleToLock.get(p);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${p} (${i})`),this.mapHandleToLock.set(p,a),C&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${p} (${i})`),C.dispose())}return p}async close(r){const n=this.mapHandleToLock.get(r);try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&t.canFlush)try{await b.Promises.fdatasync(r)}catch(i){t.configureFlushOnWrite(!1),this.logService.error(i)}return await b.Promises.close(r)}catch(i){throw this.toFileSystemProviderError(i)}finally{n&&(this.mapHandleToLock.get(r)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.mapHandleToLock.delete(r)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),n.dispose())}}async read(r,n,i,a,p){const C=this.normalizePos(r,n);let k=null;try{k=(await b.Promises.read(r,i,a,p,C)).bytesRead}catch(D){throw this.toFileSystemProviderError(D)}finally{this.updatePos(r,C,k)}return k}normalizePos(r,n){return n===this.mapHandleToPos.get(r)?null:n}updatePos(r,n,i){const a=this.mapHandleToPos.get(r);typeof a=="number"&&(typeof n=="number"||(typeof i=="number"?this.mapHandleToPos.set(r,a+i):this.mapHandleToPos.delete(r)))}async write(r,n,i,a,p){return(0,s.retry)(()=>this.doWrite(r,n,i,a,p),100,3)}async doWrite(r,n,i,a,p){const C=this.normalizePos(r,n);let k=null;try{k=(await b.Promises.write(r,i,a,p,C)).bytesWritten}catch(D){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),D)}finally{this.updatePos(r,C,k)}return k}async mkdir(r){try{await b.Promises.mkdir(this.toFilePath(r))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(r,n){try{const i=this.toFilePath(r);if(n.recursive){let a;n?.atomic!==!1&&n.atomic.postfix&&(a=(0,m.join)((0,m.dirname)(i),`${(0,m.basename)(i)}${n.atomic.postfix}`)),await b.Promises.rm(i,b.RimRafMode.MOVE,a)}else try{await b.Promises.unlink(i)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let p=!1;try{const{stat:C,symbolicLink:k}=await b.SymlinkSupport.stat(i);p=C.isDirectory()&&!k}catch{}if(p)await b.Promises.rmdir(i);else throw a}else throw a}}catch(i){throw this.toFileSystemProviderError(i)}}async rename(r,n,i){const a=this.toFilePath(r),p=this.toFilePath(n);if(a!==p)try{await this.validateMoveCopy(r,n,"move",i.overwrite),await b.Promises.move(a,p)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,y.localize)(2,null,(0,m.basename)(a),(0,m.basename)((0,m.dirname)(p)),C.toString()))),this.toFileSystemProviderError(C)}}async copy(r,n,i){const a=this.toFilePath(r),p=this.toFilePath(n);if(a!==p)try{await this.validateMoveCopy(r,n,"copy",i.overwrite),await b.Promises.copy(a,p,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,y.localize)(3,null,(0,m.basename)(a),(0,m.basename)((0,m.dirname)(p)),C.toString()))),this.toFileSystemProviderError(C)}}async validateMoveCopy(r,n,i,a){const p=this.toFilePath(r),C=this.toFilePath(n);let k=!1;if(!!(this.capabilities&1024)||(k=(0,h.isEqual)(p,C,!0)),k){if(i==="copy")throw(0,o.createFileSystemProviderError)((0,y.localize)(4,null),o.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const A=await this.statIgnoreError(r);if(!A)throw(0,o.createFileSystemProviderError)((0,y.localize)(5,null),o.FileSystemProviderErrorCode.FileNotFound);const O=await this.statIgnoreError(n);if(O){if(!a)throw(0,o.createFileSystemProviderError)((0,y.localize)(6,null),o.FileSystemProviderErrorCode.FileExists);A.type&o.FileType.File&&O.type&o.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,n){return this.doCloneFile(r,n,!1)}async doCloneFile(r,n,i){const a=this.toFilePath(r),p=this.toFilePath(n),C=!!(this.capabilities&1024);if((0,h.isEqual)(a,p,!C))return;const k=new c.DisposableStore;try{const[D,A]=await Promise.all([this.createResourceLock(r),this.createResourceLock(n)]);k.add(D),k.add(A),i&&await b.Promises.mkdir((0,m.dirname)(p),{recursive:!0}),await b.Promises.copyFile(a,p)}catch(D){if(D.code==="ENOENT"&&!i)return this.doCloneFile(r,n,!0);throw this.toFileSystemProviderError(D)}finally{k.dispose()}}createUniversalWatcher(r,n,i){return new E.UniversalWatcherClient(a=>r(a),a=>n(a),i)}createNonRecursiveWatcher(r,n,i){return new S.NodeJSWatcherClient(a=>r(a),a=>n(a),i)}toFileSystemProviderError(r){if(r instanceof o.FileSystemProviderError)return r;let n=r,i;switch(r.code){case"ENOENT":i=o.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=o.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=o.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=o.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=o.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=o.FileSystemProviderErrorCode.Unknown;break;default:i=o.FileSystemProviderErrorCode.Unknown}return(0,o.createFileSystemProviderError)(n,i)}async toFileSystemProviderWriteError(r,n){let i=this.toFileSystemProviderError(n);if(r&&i.code===o.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await b.SymlinkSupport.stat(this.toFilePath(r));a.mode&128||(i=(0,o.createFileSystemProviderError)(n,o.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return i}}e.DiskFileSystemProvider=t}),define(te[221],ie([0,1,3,94,2,17,56,21]),function(j,e,P,L,s,_,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class h extends s.Disposable{constructor(f,w){super(),this.provider=f,this.logService=w,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(f,w,d){const b=this.getUriTransformer(f);switch(w){case"stat":return this.stat(b,d[0]);case"readdir":return this.readdir(b,d[0]);case"open":return this.open(b,d[0],d[1]);case"close":return this.close(d[0]);case"read":return this.read(d[0],d[1],d[2]);case"readFile":return this.readFile(b,d[0],d[1]);case"write":return this.write(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.writeFile(b,d[0],d[1],d[2]);case"rename":return this.rename(b,d[0],d[1],d[2]);case"copy":return this.copy(b,d[0],d[1],d[2]);case"cloneFile":return this.cloneFile(b,d[0],d[1]);case"mkdir":return this.mkdir(b,d[0]);case"delete":return this.delete(b,d[0],d[1]);case"watch":return this.watch(b,d[0],d[1],d[2],d[3]);case"unwatch":return this.unwatch(d[0],d[1])}throw new Error(`IPC Command ${w} not found`)}listen(f,w,d){const b=this.getUriTransformer(f);switch(w){case"fileChange":return this.onFileChange(b,d[0]);case"readFileStream":return this.onReadFileStream(b,d[0],d[1])}throw new Error(`Unknown event ${w}`)}stat(f,w){const d=this.transformIncoming(f,w,!0);return this.provider.stat(d)}readdir(f,w){const d=this.transformIncoming(f,w);return this.provider.readdir(d)}async readFile(f,w,d){const b=this.transformIncoming(f,w,!0),y=await this.provider.readFile(b,d);return _.VSBuffer.wrap(y)}onReadFileStream(f,w,d){const b=this.transformIncoming(f,w,!0),y=new I.CancellationTokenSource,o=new P.Emitter({onDidRemoveLastListener:()=>{y.cancel()}}),g=this.provider.readFileStream(b,d,y.token);return(0,M.listenStream)(g,{onData:l=>o.fire(_.VSBuffer.wrap(l)),onError:l=>o.fire(l),onEnd:()=>{o.fire("end"),o.dispose(),y.dispose()}}),o.event}writeFile(f,w,d,b){const y=this.transformIncoming(f,w);return this.provider.writeFile(y,d.buffer,b)}open(f,w,d){const b=this.transformIncoming(f,w,!0);return this.provider.open(b,d)}close(f){return this.provider.close(f)}async read(f,w,d){const b=_.VSBuffer.alloc(d),y=0,o=await this.provider.read(f,w,b.buffer,y,d);return[b,o]}write(f,w,d,b,y){return this.provider.write(f,w,d.buffer,b,y)}mkdir(f,w){const d=this.transformIncoming(f,w);return this.provider.mkdir(d)}delete(f,w,d){const b=this.transformIncoming(f,w);return this.provider.delete(b,d)}rename(f,w,d,b){const y=this.transformIncoming(f,w),o=this.transformIncoming(f,d);return this.provider.rename(y,o,b)}copy(f,w,d,b){const y=this.transformIncoming(f,w),o=this.transformIncoming(f,d);return this.provider.copy(y,o,b)}cloneFile(f,w,d){const b=this.transformIncoming(f,w),y=this.transformIncoming(f,d);return this.provider.cloneFile(b,y)}onFileChange(f,w){const d=new P.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(w,this.createSessionFileWatcher(f,d))},onDidRemoveLastListener:()=>{(0,s.dispose)(this.sessionToWatcher.get(w)),this.sessionToWatcher.delete(w)}});return d.event}async watch(f,w,d,b,y){const o=this.sessionToWatcher.get(w);if(o){const g=this.transformIncoming(f,b),l=o.watch(d,g,y);this.watchRequests.set(w+d,l)}}async unwatch(f,w){const d=f+w,b=this.watchRequests.get(d);b&&((0,s.dispose)(b),this.watchRequests.delete(d))}dispose(){super.dispose();for(const[,f]of this.watchRequests)f.dispose();this.watchRequests.clear();for(const[,f]of this.sessionToWatcher)f.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=h;class c extends s.Disposable{constructor(f,w,d,b){super(),this.uriTransformer=f,this.logService=d,this.environmentService=b,this.watcherRequests=new Map,this.fileWatcher=this._register(new L.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(w)}registerListeners(f){const w=this._register(new P.Emitter);this._register(w.event(d=>{f.fire(d.map(b=>({resource:this.uriTransformer.transformOutgoingURI(b.resource),type:b.type})))})),this._register(this.fileWatcher.onDidChangeFile(d=>w.fire(d))),this._register(this.fileWatcher.onDidWatchError(d=>f.fire(d)))}getRecursiveWatcherOptions(f){}getExtraExcludes(f){}watch(f,w,d){const b=this.getExtraExcludes(this.environmentService);return Array.isArray(b)&&(d.excludes=[...d.excludes,...b]),this.watcherRequests.set(f,this.fileWatcher.watch(w,d)),(0,s.toDisposable)(()=>{(0,s.dispose)(this.watcherRequests.get(f)),this.watcherRequests.delete(f)})}dispose(){super.dispose();for(const[,f]of this.watcherRequests)f.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=c}),define(te[222],ie([0,1,14,176,4,7,16,9,221,154]),function(j,e,P,L,s,_,M,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class m extends h.AbstractDiskFileSystemProviderChannel{constructor(d,b,y){super(d,b),this.environmentService=y}getUriTransformer(d){return c.DefaultURITransformer}transformIncoming(d,b){return _.URI.revive(b)}async delete(d,b,y){if(!y.useTrash)return super.delete(d,b,y);const o=this.transformIncoming(d,b),g=(0,I.normalize)(o.fsPath);try{await P.shell.trashItem(g)}catch{throw(0,M.createFileSystemProviderError)(s.isWindows?(0,L.localize)(0,null,(0,I.basename)(g)):(0,L.localize)(1,null,(0,I.basename)(g)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(d,b){return new f(d,b,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=m;class f extends h.AbstractSessionFileWatcher{watch(d,b,y){if(y.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(d,b,y)}}}),define(te[223],ie([0,1,5]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class L extends P.AbstractMessageLogger{constructor(_=P.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(_),this._register(this.onDidChangeLogLevel(M=>{this._logger?.setLevel(M)}))}set logger(_){this._logger=_;for(const{level:M,message:I}of this.buffer)(0,P.log)(_,M,I);this.buffer=[]}log(_,M){this._logger?(0,P.log)(this._logger,_,M):this.getLevel()<=_&&this.buffer.push({level:_,message:M})}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=L}),define(te[224],ie([0,1,7,3,5,2]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class M extends s.AbstractLoggerService{constructor(f,w,d,b,y){super(w,d,b),this.windowId=f,this.channel=y,this._register(y.listen("onDidChangeLogLevel",f)(o=>{(0,s.isLogLevel)(o)?super.setLogLevel(o):super.setLogLevel(P.URI.revive(o[0]),o[1])})),this._register(y.listen("onDidChangeVisibility",f)(([o,g])=>super.setVisibility(P.URI.revive(o),g))),this._register(y.listen("onDidChangeLoggers",f)(({added:o,removed:g})=>{for(const l of o)super.registerLogger({...l,resource:P.URI.revive(l.resource)});for(const l of g)super.deregisterLogger(l.resource)}))}createConsoleMainLogger(){return new s.AdapterLogger({log:(f,w)=>{this.channel.call("consoleLog",[f,w])}})}registerLogger(f){super.registerLogger(f),this.channel.call("registerLogger",[f,this.windowId])}deregisterLogger(f){super.deregisterLogger(f),this.channel.call("deregisterLogger",[f,this.windowId])}setLogLevel(f,w){super.setLogLevel(f,w),this.channel.call("setLogLevel",[f,w])}setVisibility(f,w){super.setVisibility(f,w),this.channel.call("setVisibility",[this.toResource(f),w])}doCreateLogger(f,w,d){return new I(this.channel,f,w,d,this.windowId)}static setLogLevel(f,w,d){return f.call("setLogLevel",[w,d])}}e.LoggerChannelClient=M;class I extends s.AbstractMessageLogger{constructor(f,w,d,b,y){super(b?.logLevel==="always"),this.channel=f,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[w,b,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,w){const d=[[f,w]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(f){this.channel.call("log",[this.file,f])}}class h{constructor(f,w){this.loggerService=f,this.getUriTransformer=w}listen(f,w){const d=this.getUriTransformer(f);switch(w){case"onDidChangeLoggers":return L.Event.map(this.loggerService.onDidChangeLoggers,b=>({added:[...b.added].map(y=>this.transformLogger(y,d)),removed:[...b.removed].map(y=>this.transformLogger(y,d))}));case"onDidChangeVisibility":return L.Event.map(this.loggerService.onDidChangeVisibility,b=>[d.transformOutgoingURI(b[0]),b[1]]);case"onDidChangeLogLevel":return L.Event.map(this.loggerService.onDidChangeLogLevel,b=>(0,s.isLogLevel)(b)?b:[d.transformOutgoingURI(b[0]),b[1]])}throw new Error(`Event not found: ${w}`)}async call(f,w,d){const b=this.getUriTransformer(f);switch(w){case"setLogLevel":return(0,s.isLogLevel)(d[0])?this.loggerService.setLogLevel(d[0]):this.loggerService.setLogLevel(P.URI.revive(b.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(y=>this.transformLogger(y,b)))}throw new Error(`Call not found: ${w}`)}transformLogger(f,w){return{...f,resource:w.transformOutgoingURI(f.resource)}}}e.LoggerChannel=h;class c extends _.Disposable{constructor(f,w){super(),w.call("setLogLevel",[f.getLogLevel()]),this._register(f.onDidChangeLogLevel(d=>w.call("setLogLevel",[d]))),w.call("getRegisteredLoggers").then(d=>{for(const b of d)f.registerLogger({...b,resource:P.URI.revive(b.resource)})}),this._register(w.listen("onDidChangeVisibility")(([d,b])=>f.setVisibility(P.URI.revive(d),b))),this._register(w.listen("onDidChangeLoggers")(({added:d,removed:b})=>{for(const y of d)f.registerLogger({...y,resource:P.URI.revive(y.resource)});for(const y of b)f.deregisterLogger(y.resource)}))}}e.RemoteLoggerChannelClient=c}),define(te[225],ie([0,1,2,5]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class s extends P.Disposable{constructor(M,I=[]){super(),this.logger=new L.MultiplexLogger([M,...I]),this._register(M.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(M){this.logger.setLevel(M)}getLevel(){return this.logger.getLevel()}trace(M,...I){this.logger.trace(M,...I)}debug(M,...I){this.logger.debug(M,...I)}info(M,...I){this.logger.info(M,...I)}warn(M,...I){this.logger.warn(M,...I)}error(M,...I){this.logger.error(M,...I)}flush(){this.logger.flush()}}e.LogService=s}),define(te[226],ie([0,1,35,7,5]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class _{constructor(I){this.loggerService=I,this.loggers=new P.ResourceMap}listen(I,h,c){switch(h){case"onDidChangeLoggers":return c?this.loggerService.getOnDidChangeLoggersEvent(c):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.loggerService.getOnDidChangeLogLevelEvent(c):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.loggerService.getOnDidChangeVisibilityEvent(c):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(I,h,c){switch(h){case"createLogger":this.createLogger(L.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.log(L.URI.revive(c[0]),c[1]);case"consoleLog":return this.consoleLog(c[0],c[1]);case"setLogLevel":return(0,s.isLogLevel)(c[0])?this.loggerService.setLogLevel(c[0]):this.loggerService.setLogLevel(L.URI.revive(c[0]),c[1]);case"setVisibility":return this.loggerService.setVisibility(L.URI.revive(c[0]),c[1]);case"registerLogger":return this.loggerService.registerLogger({...c[0],resource:L.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(L.URI.revive(c[0]))}throw new Error(`Call not found: ${h}`)}createLogger(I,h,c){this.loggers.set(I,this.loggerService.createLogger(I,h,c))}consoleLog(I,h){let c=console.log;switch(I){case s.LogLevel.Error:c=console.error;break;case s.LogLevel.Warning:c=console.warn;break;case s.LogLevel.Info:c=console.info;break}c.call(console,...h)}log(I,h){const c=this.loggers.get(I);if(!c)throw new Error("Create the logger before logging");for(const[m,f]of h)(0,s.log)(c,m,f)}}e.LoggerChannel=_}),define(te[227],ie([0,1,16,5]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var s;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(s||(s={}));async function _(c,m,f,w,d){try{const b=await new Promise((o,g)=>{j(["@vscode/spdlog"],o,g)});b.setFlushOn(s.Trace);const y=await b.createAsyncRotatingLogger(c,m,f,w);return d?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(b){console.error(b)}return null}function M(c,m,f){switch(m){case L.LogLevel.Trace:c.trace(f);break;case L.LogLevel.Debug:c.debug(f);break;case L.LogLevel.Info:c.info(f);break;case L.LogLevel.Warning:c.warn(f);break;case L.LogLevel.Error:c.error(f);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function I(c,m){switch(m){case L.LogLevel.Trace:c.setLevel(s.Trace);break;case L.LogLevel.Debug:c.setLevel(s.Debug);break;case L.LogLevel.Info:c.setLevel(s.Info);break;case L.LogLevel.Warning:c.setLevel(s.Warning);break;case L.LogLevel.Error:c.setLevel(s.Error);break;case L.LogLevel.Off:c.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class h extends L.AbstractMessageLogger{constructor(m,f,w,d,b){super(),this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(m,f,w,d),this._register(this.onDidChangeLogLevel(y=>{this._logger&&I(this._logger,y)}))}async _createSpdLogLogger(m,f,w,d){const b=w?6:1,y=30/b*P.ByteSize.MB,o=await _(m,f,y,b,d);if(o){this._logger=o,I(this._logger,this.getLevel());for(const{level:g,message:l}of this.buffer)M(this._logger,g,l);this.buffer=[]}}log(m,f){this._logger?M(this._logger,m,f):this.getLevel()<=m&&this.buffer.push({level:m,message:f})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=h}),define(te[228],ie([0,1,31,5,227]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class _ extends L.AbstractLoggerService{doCreateLogger(I,h,c){return new s.SpdLogLogger((0,P.generateUuid)(),I.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.LoggerService=_}),define(te[66],ie([0,1,35,3,6,5,228]),function(j,e,P,L,s,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,s.refineServiceDecorator)(_.ILoggerService);class I extends M.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new P.ResourceMap}createLogger(c,m,f){f!==void 0&&this.loggerResourcesByWindow.set(this.toResource(c),f);try{return super.createLogger(c,m)}catch(w){throw this.loggerResourcesByWindow.delete(this.toResource(c)),w}}registerLogger(c,m){m!==void 0&&this.loggerResourcesByWindow.set(c.resource,m),super.registerLogger(c)}deregisterLogger(c){this.loggerResourcesByWindow.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const m=[];for(const f of super.getRegisteredLoggers())c===this.loggerResourcesByWindow.get(f.resource)&&m.push(f);return m}getOnDidChangeLogLevelEvent(c){return L.Event.filter(this.onDidChangeLogLevel,m=>(0,_.isLogLevel)(m)||this.isInterestedLoggerResource(m[0],c))}getOnDidChangeVisibilityEvent(c){return L.Event.filter(this.onDidChangeVisibility,([m])=>this.isInterestedLoggerResource(m,c))}getOnDidChangeLoggersEvent(c){return L.Event.filter(L.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter(w=>this.isInterestedLoggerResource(w.resource,c)),removed:[...m.removed].filter(w=>this.isInterestedLoggerResource(w.resource,c))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(c){for(const[m,f]of this.loggerResourcesByWindow)f===c&&this.deregisterLogger(m)}isInterestedLoggerResource(c,m){const f=this.loggerResourcesByWindow.get(c);return f===void 0||f===m}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=I}),define(te[229],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function P(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=P;function L(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function s(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=s;function _(M){return!P(M)&&!L(M)&&!s(M)}e.isMenubarMenuItemAction=_}),define(te[39],ie([0,1,3,68,2,6]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,_.createDecorator)("policy");class M extends s.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(c){const m=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...c,...this.policyDefinitions},m!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(c),L.Iterable.reduce(this.policies.entries(),(f,[w,d])=>({...f,[w]:d}),{})}getPolicyValue(c){return this.policies.get(c)}serialize(){return L.Iterable.reduce(Object.entries(this.policyDefinitions),(c,[m,f])=>({...c,[m]:{definition:f,value:this.policies.get(m)}}),{})}}e.AbstractPolicyService=M;class I{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(te[230],ie([0,1,8,3,68,10,16,5,39]),function(j,e,P,L,s,_,M,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(f,w){const d=[];for(const b of new Set(s.Iterable.concat(f.keys(),w.keys())))f.get(b)!==w.get(b)&&d.push(b);return d}let m=class extends h.AbstractPolicyService{constructor(w,d,b){super(),this.file=w,this.fileService=d,this.logService=b,this.throttledDelayer=this._register(new P.ThrottledDelayer(500));const y=L.Event.filter(d.onDidFilesChange,o=>o.affects(w));this._register(d.watch(w)),this._register(y(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const w=new Map;try{const d=await this.fileService.readFile(this.file),b=JSON.parse(d.value.toString());if(!(0,_.isObject)(b))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(b))this.policyDefinitions[y]&&w.set(y,b[y])}catch(d){d.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",d)}return w}async refresh(){const w=await this.read(),d=c(this.policies,w);this.policies=w,d.length>0&&this._onDidChange.fire(d)}};e.FilePolicyService=m,e.FilePolicyService=m=Se([J(1,M.IFileService),J(2,I.ILogService)],m)}),define(te[231],ie([0,1,3,2,39]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class _{constructor(h){this.service=h,this.disposables=new L.DisposableStore}listen(h,c){switch(c){case"onDidChange":return P.Event.map(this.service.onDidChange,m=>m.reduce((f,w)=>({...f,[w]:this.service.getPolicyValue(w)??null}),{}),this.disposables)}throw new Error(`Event not found: ${c}`)}call(h,c,m){switch(c){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${c}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=_;class M extends s.AbstractPolicyService{constructor(h,c){super(),this.channel=c;for(const m in h){const{definition:f,value:w}=h[m];this.policyDefinitions[m]=f,w!==void 0&&this.policies.set(m,w)}this.channel.listen("onDidChange")(m=>{for(const f in m){const w=m[f];w===null?this.policies.delete(f):this.policies.set(f,w)}this._onDidChange.fire(Object.keys(m))})}async _updatePolicyDefinitions(h){const c=await this.channel.call("updatePolicyDefinitions",h);for(const m in c)this.policies.set(m,c[m])}}e.PolicyChannelClient=M}),define(te[232],ie([0,1,39,8,310,2,5]),function(j,e,P,L,s,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let I=class extends P.AbstractPolicyService{constructor(c,m){super(),this.logService=c,this.productName=m,this.throttler=new L.Throttler,this.watcher=this._register(new _.MutableDisposable)}async _updatePolicyDefinitions(c){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.throttler.queue(()=>new Promise((m,f)=>{try{this.watcher.value=(0,s.createWatcher)(this.productName,c,w=>{this._onDidPolicyChange(w),m()})}catch(w){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",w),f(w)}}))}_onDidPolicyChange(c){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const m in c){const f=c[m];f===void 0?this.policies.delete(m):this.policies.set(m,f)}this._onDidChange.fire(Object.keys(c))}};e.NativePolicyService=I,e.NativePolicyService=I=Se([J(0,M.ILogService)],I)}),define(te[78],ie([0,1,4,36]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof P.globals.vscode<"u"&&typeof P.globals.vscode.context<"u"){const _=P.globals.vscode.context.configuration();if(_)s=_.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){s=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:_,searchUrl:M,itemUrl:I,controlUrl:h}=s.extensionsGallery||{};Object.assign(s,{extensionsGallery:{serviceUrl:L.env.VSCODE_GALLERY_SERVICE_URL||_,searchUrl:L.env.VSCODE_GALLERY_SEARCH_URL||M,itemUrl:L.env.VSCODE_GALLERY_ITEM_URL||I,controlUrl:L.env.VSCODE_GALLERY_CONTROL_URL||h}});try{const c=(...f)=>f.reduce((w,d)=>(Object.keys(d).forEach(b=>{Array.isArray(w[b])&&Array.isArray(d[b])?w[b]=d[b]:typeof w[b]=="object"&&typeof d[b]=="object"?w[b]=c(w[b],d[b]):w[b]=d[b]}),w),{}),m=globalThis._VSCODE_USER_PRODUCT_JSON||{};s=c(s,m)}catch{}if(L.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const c=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:c.version,release:c.release})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.80.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(te[23],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,P.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[233],ie([0,1,72,5,23]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let _=class{constructor(I,h){this.productService=I,this.logService=h,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(I,h){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const c=/^(.*)#([^#]+)$/.exec(h);if(!c)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,m,f]=c;let w=this.trustedExtensionUrlPublicKeys.get(I);if(!w){if(w=this.productService.trustedExtensionUrlPublicKeys[I],!w||w.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.trustedExtensionUrlPublicKeys.set(I,[...w])}const d=Buffer.from(decodeURIComponent(f),"base64");if(d.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const b=d.slice(0,6),y=d.readUIntBE(0,6),o=Date.now()-y;if(o<0||o>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const g=d.slice(6),l=P.createVerify("SHA256");l.write(b),l.write(Buffer.from(m)),l.end();for(let v=0;v<w.length;v++){let E=w[v];if(E!==null){if(typeof E=="string")try{E=P.createPublicKey({key:Buffer.from(E,"base64"),format:"der",type:"spki"}),w[v]=E}catch(S){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${v+1} for ${I}:`,S),w[v]=null;continue}if(l.verify(E,g))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};e.ExtensionUrlTrustService=_,e.ExtensionUrlTrustService=_=Se([J(0,s.IProductService),J(1,L.ILogService)],_)}),define(te[234],ie([0,1,8,5]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let s=class{constructor(M,I,h){this._window=M,this._sessionId=I,this._logService=h}async inspect(M){await this._connect();const I=this._window.webContents.debugger;await I.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,P.timeout)(M);const h=await I.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),h.profile}async _connect(){const M=this._window.webContents.debugger;M.attach(),await M.sendCommand("Profiler.enable")}async _disconnect(){const M=this._window.webContents.debugger;await M.sendCommand("Profiler.disable"),M.detach()}};e.WindowProfiler=s,e.WindowProfiler=s=Se([J(2,L.ILogService)],s)}),define(te[79],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,P.createDecorator)("protocolMainService")}),define(te[44],ie([0,1,135,10]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class s{constructor(){this.data=new Map}add(M,I){P.ok(L.isString(M)),P.ok(L.isObject(I)),P.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,I)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new s}),define(te[235],ie([0,1,3,44]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function s(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class _{constructor(){this._onDidChangeSchema=new P.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,c){this.schemasById[s(h)]=c,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new _;L.Registry.add(e.Extensions.JSONContribution,M)}),define(te[59],ie([0,1,24,3,10,161,18,235,44]),function(j,e,P,L,s,_,M,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const f=h.Registry.as(I.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const r=new Set;this.doRegisterConfigurations(t,u,r),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(t){const u=new Set;this.doDeregisterConfigurations(t,u),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:t,remove:u}){const r=new Set;this.doDeregisterConfigurations(u,r),this.doRegisterConfigurations(t,!1,r),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}registerDefaultConfigurations(t){const u=new Set;this.doRegisterDefaultConfigurations(t,u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,u){const r=[];for(const{overrides:n,source:i}of t)for(const a in n)if(u.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const p=this.configurationDefaultsOverrides.get(a),C=p?.valuesSources??new Map;if(i)for(const O of Object.keys(n[a]))C.set(O,i);const k={...p?.value||{},...n[a]};this.configurationDefaultsOverrides.set(a,{source:i,value:k,valuesSources:C});const D=(0,M.getLanguageTagSettingPlainKey)(a),A={type:"object",default:k,description:_.localize(1,null,D),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:k,source:s.isString(i)?void 0:i,defaultValueSource:i};r.push(...y(a)),this.configurationProperties[a]=A,this.defaultLanguageConfigurationOverridesNode.properties[a]=A}else{this.configurationDefaultsOverrides.set(a,{value:n[a],source:i});const p=this.configurationProperties[a];p&&(this.updatePropertyDefaultValue(a,p),this.updateSchema(a,p))}this.doRegisterOverrideIdentifiers(r)}deregisterDefaultConfigurations(t){const u=new Set;this.doDeregisterDefaultConfigurations(t,u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,u){for(const{overrides:r,source:n}of t)for(const i in r){const a=this.configurationDefaultsOverrides.get(i),p=s.isString(n)?n:n?.id,C=s.isString(a?.source)?a?.source:a?.source?.id;if(p===C)if(u.add(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const k=this.configurationProperties[i];k&&(this.updatePropertyDefaultValue(i,k),this.updateSchema(i,k))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let u=!1;const r=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,r),u=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,r),u=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,r),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const u of t)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,u,r){t.forEach(n=>{this.validateAndRegisterProperties(n,u,n.extensionInfo,n.restrictedProperties,void 0,r),this.configurationContributors.push(n),this.registerJSONConfiguration(n)})}doDeregisterConfigurations(t,u){const r=n=>{if(n.properties)for(const i in n.properties){u.add(i);const a=this.configurationProperties[i];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[i],this.removeFromSchema(i,n.properties[i])}n.allOf?.forEach(i=>r(i))};for(const n of t){r(n);const i=this.configurationContributors.indexOf(n);i!==-1&&this.configurationContributors.splice(i,1)}}validateAndRegisterProperties(t,u=!0,r,n,i=3,a){i=s.isUndefinedOrNull(t.scope)?i:t.scope;const p=t.properties;if(p)for(const k in p){const D=p[k];if(u&&v(k,D)){delete p[k];continue}if(D.source=r,D.defaultDefaultValue=p[k].default,this.updatePropertyDefaultValue(k,D),e.OVERRIDE_PROPERTY_REGEX.test(k)?D.scope=void 0:(D.scope=s.isUndefinedOrNull(D.scope)?i:D.scope,D.restricted=s.isUndefinedOrNull(D.restricted)?!!n?.includes(k):D.restricted),p[k].hasOwnProperty("included")&&!p[k].included){this.excludedConfigurationProperties[k]=p[k],delete p[k];continue}else this.configurationProperties[k]=p[k],p[k].policy?.name&&this.policyConfigurations.set(p[k].policy.name,k);!p[k].deprecationMessage&&p[k].markdownDeprecationMessage&&(p[k].deprecationMessage=p[k].markdownDeprecationMessage),a.add(k)}const C=t.allOf;if(C)for(const k of C)this.validateAndRegisterProperties(k,u,r,n,i,a)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const u=r=>{const n=r.properties;if(n)for(const a in n)this.updateSchema(a,n[a]);r.allOf?.forEach(u)};u(t)}updateSchema(t,u){switch(e.allSettings.properties[t]=u,u.scope){case 1:e.applicationSettings.properties[t]=u;break;case 2:e.machineSettings.properties[t]=u;break;case 6:e.machineOverridableSettings.properties[t]=u;break;case 3:e.windowSettings.properties[t]=u;break;case 4:e.resourceSettings.properties[t]=u;break;case 5:e.resourceSettings.properties[t]=u,this.resourceLanguageSettingsSchema.properties[t]=u;break}}removeFromSchema(t,u){switch(delete e.allSettings.properties[t],u.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const u=`[${t}]`,r={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,r),e.allSettings.properties[u]=r,e.applicationSettings.properties[u]=r,e.machineSettings.properties[u]=r,e.machineOverridableSettings.properties[u]=r,e.windowSettings.properties[u]=r,e.resourceSettings.properties[u]=r}}registerOverridePropertyPatternKey(){const t={type:"object",description:_.localize(4,null),errorMessage:_.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,u){const r=this.configurationDefaultsOverrides.get(t);let n=r?.value,i=r?.source;s.isUndefined(n)&&(n=u.defaultDefaultValue,i=void 0),s.isUndefined(n)&&(n=g(u.type)),u.default=n,u.defaultValueSource=i}}const d="\\[([^\\]]+)\\]",b=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(S){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(S)){let u=b.exec(S);for(;u?.length;){const r=u[1].trim();r&&t.push(r),u=b.exec(S)}}return(0,P.distinct)(t)}e.overrideIdentifiersFromKey=y;function o(S){return S.reduce((t,u)=>`${t}[${u}]`,"")}e.keyFromOverrideIdentifiers=o;function g(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const l=new w;h.Registry.add(e.Extensions.Configuration,l);function v(S,t){return S.trim()?e.OVERRIDE_PROPERTY_REGEX.test(S)?_.localize(7,null,S):l.getConfigurationProperties()[S]!==void 0?_.localize(8,null,S):t.policy?.name&&l.getPolicyConfigurations().get(t.policy?.name)!==void 0?_.localize(9,null,S,t.policy?.name,l.getPolicyConfigurations().get(t.policy?.name)):null:_.localize(6,null)}e.validateProperty=v;function E(){const S=[],t=l.getConfigurationProperties();for(const u of Object.keys(t))S.push([u,t[u].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=E}),define(te[119],ie([0,1,24,3,45,2,35,37,10,7,18,59,44]),function(j,e,P,L,s,_,M,I,h,c,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(u){return Object.isFrozen(u)?u:I.deepFreeze(u)}class b{constructor(r={},n=[],i=[],a){this._contents=r,this._keys=n,this._overrides=i,this.raw=a,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(n=>{if(n instanceof b)return n;const i=new y("");return i.parseRaw(n),i.configurationModel});this._rawConfiguration=r.reduce((n,i)=>i===n?i:n.merge(i),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,m.getConfigurationValue)(this.contents,r):this.contents}inspect(r,n){const i=this.rawConfiguration.getValue(r),a=n?this.rawConfiguration.getOverrideValue(r,n):void 0,p=n?this.rawConfiguration.override(n).getValue(r):i;return{value:i,override:a,merged:p}}getOverrideValue(r,n){const i=this.getContentsForOverrideIdentifer(n);return i?r?(0,m.getConfigurationValue)(i,r):i:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const i of this.overrides)i.identifiers.includes(r)&&n.push(...i.keys);return P.distinct(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return P.distinct(r)}override(r){let n=this.overrideConfigurations.get(r);return n||(n=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,n)),n}merge(...r){const n=I.deepClone(this.contents),i=I.deepClone(this.overrides),a=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const C of r)if(p.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.mergeContents(n,C.contents);for(const k of C.overrides){const[D]=i.filter(A=>P.equals(A.identifiers,k.identifiers));D?(this.mergeContents(D.contents,k.contents),D.keys.push(...k.keys),D.keys=P.distinct(D.keys)):i.push(I.deepClone(k))}for(const k of C.keys)a.indexOf(k)===-1&&a.push(k)}return new b(n,a,i,p.every(C=>C instanceof b)?void 0:p)}createOverrideConfigurationModel(r){const n=this.getContentsForOverrideIdentifer(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const a of P.distinct([...Object.keys(this.contents),...Object.keys(n)])){let p=this.contents[a];const C=n[a];C&&(typeof p=="object"&&typeof C=="object"?(p=I.deepClone(p),this.mergeContents(p,C)):p=C),i[a]=p}return new b(i,this.keys,this.overrides)}mergeContents(r,n){for(const i of Object.keys(n)){if(i in r&&h.isObject(r[i])&&h.isObject(n[i])){this.mergeContents(r[i],n[i]);continue}r[i]=I.deepClone(n[i])}}getContentsForOverrideIdentifer(r){let n=null,i=null;const a=p=>{p&&(i?this.mergeContents(i,p):i=I.deepClone(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===r?n=p.contents:p.identifiers.includes(r)&&a(p.contents);return a(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,n){this.updateValue(r,n,!0)}setValue(r,n){this.updateValue(r,n,!1)}removeValue(r){const n=this.keys.indexOf(r);n!==-1&&(this.keys.splice(n,1),(0,m.removeFromValueTree)(this.contents,r),f.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(i=>P.equals(i.identifiers,(0,f.overrideIdentifiersFromKey)(r))),1))}updateValue(r,n,i){(0,m.addToValueTree)(this.contents,r,n,a=>console.error(a)),i=i||this.keys.indexOf(r)===-1,i&&this.keys.push(r),f.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,f.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,m.toValuesTree)(this.contents[r],a=>console.error(a))})}}e.ConfigurationModel=b;class y{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,n){if(!h.isUndefinedOrNull(r)){const i=this.doParseContent(r);this.parseRaw(i,n)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,n){this._raw=r;const{contents:i,keys:a,overrides:p,restricted:C,hasExcludedProperties:k}=this.doParseRaw(r,n);this._configurationModel=new b(i,a,p,k?[r]:void 0),this._restrictedConfigurations=C||[]}doParseContent(r){let n={},i=null,a=[];const p=[],C=[];function k(A){Array.isArray(a)?a.push(A):i!==null&&(a[i]=A)}const D={onObjectBegin:()=>{const A={};k(A),p.push(a),a=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{a=p.pop()},onArrayBegin:()=>{const A=[];k(A),p.push(a),a=A,i=null},onArrayEnd:()=>{a=p.pop()},onLiteralValue:k,onError:(A,O,U)=>{C.push({error:A,offset:O,length:U})}};if(r)try{s.visit(r,D),n=a[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return n}doParseRaw(r,n){const i=w.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),a=this.filter(r,i,!0,n);r=a.raw;const p=(0,m.toValuesTree)(r,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),C=Object.keys(r),k=this.toOverrides(r,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:p,keys:C,overrides:k,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}filter(r,n,i,a){let p=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:p};const C={},k=[];for(const D in r)if(f.OVERRIDE_PROPERTY_REGEX.test(D)&&i){const A=this.filter(r[D],n,!1,a);C[D]=A.raw,p=p||A.hasExcludedProperties,k.push(...A.restricted)}else{const A=n[D],O=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&k.push(D),!a.exclude?.includes(D)&&(a.include?.includes(D)||(O===void 0||a.scopes===void 0||a.scopes.includes(O))&&!(a.skipRestricted&&A?.restricted))?C[D]=r[D]:p=!0}return{raw:C,restricted:k,hasExcludedProperties:p}}toOverrides(r,n){const i=[];for(const a of Object.keys(r))if(f.OVERRIDE_PROPERTY_REGEX.test(a)){const p={};for(const C in r[a])p[C]=r[a][C];i.push({identifiers:(0,f.overrideIdentifiersFromKey)(a),keys:Object.keys(p),contents:(0,m.toValuesTree)(p,n)})}return i}}e.ConfigurationModelParser=y;class o extends _.Disposable{constructor(r,n,i,a){super(),this.userSettingsResource=r,this.parseOptions=n,this.fileService=a,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.any(L.Event.filter(this.fileService.onDidFilesChange,p=>p.contains(this.userSettingsResource)),L.Event.filter(this.fileService.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&i.isEqual(p.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new b}}reparse(r){return r&&(this.parseOptions=r),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=o;class g{constructor(r,n,i,a,p,C,k,D,A,O,U,q,se){this.key=r,this.overrides=n,this._value=i,this.overrideIdentifiers=a,this.defaultConfiguration=p,this.policyConfiguration=C,this.applicationConfiguration=k,this.userConfiguration=D,this.localUserConfiguration=A,this.remoteUserConfiguration=O,this.workspaceConfiguration=U,this.folderConfigurationModel=q,this.memoryConfigurationModel=se}get value(){return d(this._value)}inspect(r,n,i){const a=r.inspect(n,i);return{get value(){return d(a.value)},get override(){return d(a.override)},get merged(){return d(a.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class l{constructor(r,n,i,a,p=new b,C=new b,k=new M.ResourceMap,D=new b,A=new M.ResourceMap){this._defaultConfiguration=r,this._policyConfiguration=n,this._applicationConfiguration=i,this._localUserConfiguration=a,this._remoteUserConfiguration=p,this._workspaceConfiguration=C,this._folderConfigurations=k,this._memoryConfiguration=D,this._memoryConfigurationByResource=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(r,n,i){return this.getConsolidatedConfigurationModel(r,n,i).getValue(r)}updateValue(r,n,i={}){let a;i.resource?(a=this._memoryConfigurationByResource.get(i.resource),a||(a=new b,this._memoryConfigurationByResource.set(i.resource,a))):a=this._memoryConfiguration,n===void 0?a.removeValue(r):a.setValue(r,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,n,i){const a=this.getConsolidatedConfigurationModel(r,n,i),p=this.getFolderConfigurationModelForResource(n.resource,i),C=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,k=new Set;for(const D of a.overrides)for(const A of D.identifiers)a.getOverrideValue(r,A)!==void 0&&k.add(A);return new g(r,n,a.getValue(r),k.size?[...k]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this._workspaceConfiguration:void 0,p||void 0,C)}keys(r){const n=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,n){this._folderConfigurations.set(r,n),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const i=[];if(!n){const{added:a,updated:p,removed:C}=S(this._defaultConfiguration,r);n=[...a,...p,...C]}for(const a of n)for(const p of(0,f.overrideIdentifiersFromKey)(a)){const C=this._defaultConfiguration.getKeysForOverrideIdentifier(p),k=r.getKeysForOverrideIdentifier(p),D=[...k.filter(A=>C.indexOf(A)===-1),...C.filter(A=>k.indexOf(A)===-1),...C.filter(A=>!I.equals(this._defaultConfiguration.override(p).getValue(A),r.override(p).getValue(A)))];i.push([p,D])}return this.updateDefaultConfiguration(r),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(r){const{added:n,updated:i,removed:a}=S(this._policyConfiguration,r),p=[...n,...i,...a];return p.length&&this.updatePolicyConfiguration(r),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:n,updated:i,removed:a,overrides:p}=S(this.applicationConfiguration,r),C=[...n,...i,...a];return C.length&&this.updateApplicationConfiguration(r),{keys:C,overrides:p}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:i,removed:a,overrides:p}=S(this.localUserConfiguration,r),C=[...n,...i,...a];return C.length&&this.updateLocalUserConfiguration(r),{keys:C,overrides:p}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:i,removed:a,overrides:p}=S(this.remoteUserConfiguration,r),C=[...n,...i,...a];return C.length&&this.updateRemoteUserConfiguration(r),{keys:C,overrides:p}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:i,removed:a,overrides:p}=S(this.workspaceConfiguration,r),C=[...n,...i,...a];return C.length&&this.updateWorkspaceConfiguration(r),{keys:C,overrides:p}}compareAndUpdateFolderConfiguration(r,n){const i=this.folderConfigurations.get(r),{added:a,updated:p,removed:C,overrides:k}=S(i,n),D=[...a,...p,...C];return(D.length||!i)&&this.updateFolderConfiguration(r,n),{keys:D,overrides:k}}compareAndDeleteFolderConfiguration(r){const n=this.folderConfigurations.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:i,updated:a,removed:p,overrides:C}=S(n,void 0);return{keys:[...i,...a,...p],overrides:C}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,n,i){let a=this.getConsolidatedConfigurationModelForResource(n,i);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(a=a.merge(this._policyConfiguration)),a}getConsolidatedConfigurationModelForResource({resource:r},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&r){const a=n.getFolder(r);a&&(i=this.getFolderConsolidatedConfiguration(a.uri)||i);const p=this._memoryConfigurationByResource.get(r);p&&(i=i.merge(p))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let n=this._foldersConsolidatedConfigurations.get(r);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(r);a?(n=i.merge(a),this._foldersConsolidatedConfigurations.set(r,n)):n=i}return n}getFolderConfigurationModelForResource(r,n){if(n&&r){const i=n.getFolder(r);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,n)=>{const{contents:i,overrides:a,keys:p}=this._folderConfigurations.get(n);return r.push([n,{contents:i,overrides:a,keys:p}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(n=>r.add(n)),this.userConfiguration.keys.forEach(n=>r.add(n)),this._workspaceConfiguration.keys.forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(i=>r.add(i))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(i=>r.add(i))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(r).forEach(a=>n.add(a))),[...n.values()]}static parse(r){const n=this.parseConfigurationModel(r.defaults),i=this.parseConfigurationModel(r.policy),a=this.parseConfigurationModel(r.application),p=this.parseConfigurationModel(r.user),C=this.parseConfigurationModel(r.workspace),k=r.folders.reduce((D,A)=>(D.set(c.URI.revive(A[0]),this.parseConfigurationModel(A[1])),D),new M.ResourceMap);return new l(n,i,a,p,new b,C,k,new b,new M.ResourceMap)}static parseConfigurationModel(r){return new b(r.contents,r.keys,r.overrides)}}e.Configuration=l;function v(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const r=new Set,n=new Map;for(const a of u)a.keys.forEach(p=>r.add(p)),a.overrides.forEach(([p,C])=>{const k=(0,M.getOrSet)(n,p,new Set);C.forEach(D=>k.add(D))});const i=[];return n.forEach((a,p)=>i.push([p,[...a.values()]])),{keys:[...r.values()],overrides:i}}e.mergeChanges=v;class E{constructor(r,n,i,a){this.change=r,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=a,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const p of r.keys)this.affectedKeys.add(p);for(const[,p]of r.overrides)for(const C of p)this.affectedKeys.add(C);this._affectsConfigStr=this._marker;for(const p of this.affectedKeys)this._affectsConfigStr+=p+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=l.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,n){const i=this._marker+r,a=this._affectsConfigStr.indexOf(i);if(a<0)return!1;const p=a+i.length;if(p>=this._affectsConfigStr.length)return!1;const C=this._affectsConfigStr.charCodeAt(p);if(C!==this._markerCode1&&C!==this._markerCode2)return!1;if(n){const k=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.previous?.workspace):void 0,D=this.currentConfiguraiton.getValue(r,n,this.currentWorkspace);return!I.equals(k,D)}return!0}}e.ConfigurationChangeEvent=E;function S(u,r){const{added:n,removed:i,updated:a}=t(r?.rawConfiguration,u?.rawConfiguration),p=[],C=u?.getAllOverrideIdentifiers()||[],k=r?.getAllOverrideIdentifiers()||[];if(r){const D=k.filter(A=>!C.includes(A));for(const A of D)p.push([A,r.getKeysForOverrideIdentifier(A)])}if(u){const D=C.filter(A=>!k.includes(A));for(const A of D)p.push([A,u.getKeysForOverrideIdentifier(A)])}if(r&&u){for(const D of C)if(k.includes(D)){const A=t({contents:u.getOverrideValue(void 0,D)||{},keys:u.getKeysForOverrideIdentifier(D)},{contents:r.getOverrideValue(void 0,D)||{},keys:r.getKeysForOverrideIdentifier(D)});p.push([D,[...A.added,...A.removed,...A.updated]])}}return{added:n,removed:i,updated:a,overrides:p}}function t(u,r){const n=u?r?u.keys.filter(p=>r.keys.indexOf(p)===-1):[...u.keys]:[],i=r?u?r.keys.filter(p=>u.keys.indexOf(p)===-1):[...r.keys]:[],a=[];if(u&&r){for(const p of r.keys)if(u.keys.indexOf(p)!==-1){const C=(0,m.getConfigurationValue)(r.contents,p),k=(0,m.getConfigurationValue)(u.contents,p);I.equals(C,k)||a.push(p)}}return{added:n,removed:i,updated:a}}}),define(te[236],ie([0,1,24,3,2,37,10,119,59,5,39,44]),function(j,e,P,L,s,_,M,I,h,c,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class w extends s.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(f.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:o,defaultsOverrides:g})=>this.onDidUpdateConfiguration(Array.from(o),g))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(o,g){this.updateConfigurationModel(o,f.Registry.as(h.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:o})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new I.ConfigurationModel;const o=f.Registry.as(h.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(o),o)}updateConfigurationModel(o,g){const l=this.getConfigurationDefaultOverrides();for(const v of o){const E=l[v],S=g[v];E!==void 0?this._configurationModel.addValue(v,E):S?this._configurationModel.addValue(v,S.default):this._configurationModel.removeValue(v)}}}e.DefaultConfiguration=w;class d{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let b=class extends s.Disposable{get configurationModel(){return this._configurationModel}constructor(o,g,l){super(),this.defaultConfiguration=o,this.policyService=g,this.logService=l,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(o=>this.onDidChangePolicies(o))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:o})=>this.update(await this.updatePolicyDefinitions(o),!0))),this._configurationModel}async updatePolicyDefinitions(o){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",o);const g={},l=[],v=f.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const E of o){const S=v[E];if(!S){l.push(E);continue}if(S.policy){if(S.type!=="string"&&S.type!=="number"){this.logService.warn(`Policy ${S.policy.name} has unsupported type ${S.type}`);continue}l.push(E),g[S.policy.name]={type:S.type}}}return(0,M.isEmptyObject)(g)||await this.policyService.updatePolicyDefinitions(g),l}onDidChangePolicies(o){this.logService.trace("PolicyConfiguration#onDidChangePolicies",o);const g=f.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),l=(0,P.coalesce)(o.map(v=>g.get(v)));this.update(l,!0)}update(o,g){this.logService.trace("PolicyConfiguration#update",o);const l=f.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),v=[],E=this._configurationModel.isEmpty();for(const S of o){const t=l[S]?.policy?.name;if(t){const u=this.policyService.getPolicyValue(t);(E?u!==void 0:!(0,_.equals)(this._configurationModel.getValue(S),u))&&v.push([S,u])}else this._configurationModel.getValue(S)!==void 0&&v.push([S,void 0])}if(v.length){this.logService.trace("PolicyConfiguration#changed",v);const S=this._configurationModel;this._configurationModel=new I.ConfigurationModel;for(const t of S.keys)this._configurationModel.setValue(t,S.getValue(t));for(const[t,u]of v)u===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,u);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=b,e.PolicyConfiguration=b=Se([J(1,m.IPolicyService),J(2,c.ILogService)],b)}),define(te[237],ie([0,1,8,3,2,19,18,119,236,39]),function(j,e,P,L,s,_,M,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class m extends s.Disposable{constructor(w,d,b,y){super(),this.settingsResource=w,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new h.DefaultConfiguration),this.policyConfiguration=b instanceof c.NullPolicyService?new h.NullPolicyConfiguration:this._register(new h.PolicyConfiguration(this.defaultConfiguration,b,y)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,{},_.extUriBiasedIgnorePathCase,d)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new P.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:o,properties:g})=>this.onDidDefaultConfigurationChange(o,g))),this._register(this.policyConfiguration.onDidChangeConfiguration(o=>this.onDidPolicyConfigurationChange(o))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[w,d,b]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(w,d,new I.ConfigurationModel,b)}getConfigurationData(){return this.configuration.toData()}getValue(w,d){const b=typeof w=="string"?w:void 0,y=(0,M.isConfigurationOverrides)(w)?w:(0,M.isConfigurationOverrides)(d)?d:{};return this.configuration.getValue(b,y,void 0)}updateValue(w,d,b,y){return Promise.reject(new Error("not supported"))}inspect(w){return this.configuration.inspect(w,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const w=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(w)}onDidChangeUserConfiguration(w){const d=this.configuration.toData(),b=this.configuration.compareAndUpdateLocalUserConfiguration(w);this.trigger(b,d,2)}onDidDefaultConfigurationChange(w,d){const b=this.configuration.toData(),y=this.configuration.compareAndUpdateDefaultConfiguration(w,d);this.trigger(y,b,7)}onDidPolicyConfigurationChange(w){const d=this.configuration.toData(),b=this.configuration.compareAndUpdatePolicyConfiguration(w);this.trigger(b,d,7)}trigger(w,d,b){const y=new I.ConfigurationChangeEvent(w,{data:d},this.configuration);y.source=b,y.sourceConfig=this.getTargetConfiguration(b),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(w){switch(w){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=m}),define(te[238],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeRemoteResourceRouter=e.NODE_REMOTE_RESOURCE_CHANNEL_NAME=e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME=void 0,e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME="request",e.NODE_REMOTE_RESOURCE_CHANNEL_NAME="remoteResourceHandler";class P{async routeCall(s,_,M){if(_!==e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME)throw new Error(`Call not found: ${_}`);const I=M[0];if(I?.authority){const h=s.connections.find(c=>c.ctx===I.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(s,_){throw new Error(`Event not found: ${_}`)}}e.NodeRemoteResourceRouter=P}),define(te[239],ie([0,1,13,6]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var s;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class _{constructor(f){this.id=f,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=_;class M{constructor(f,w){this.host=f,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=M;var I;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound",m.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class h extends P.ErrorNoTelemetry{static isNotAvailable(f){return f instanceof h&&f._code===I.NotAvailable}static isTemporarilyNotAvailable(f){return f instanceof h&&f._code===I.TemporarilyNotAvailable}static isNoResolverFound(f){return f instanceof h&&f._code===I.NoResolverFound}static isInvalidAuthority(f){return f instanceof h&&f._code===I.InvalidAuthority}static isHandled(f){return f instanceof h&&f.isHandled}constructor(f,w=I.Unknown,d){super(f),this._message=f,this._code=w,this._detail=d,this.isHandled=w===I.NotAvailable&&d===!0,Object.setPrototypeOf(this,h.prototype)}}e.RemoteAuthorityResolverError=h;function c(m){const f=m.indexOf("+");return f===-1?m:m.substring(0,f)}e.getRemoteAuthorityPrefix=c}),define(te[60],ie([0,1,15]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(c){return c.scheme===P.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=L;function s(c){if(!c)return;const m=c.indexOf("+");return m<0?c:c.substr(0,m)}e.getRemoteName=s;function _(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=_;function M(c){const{host:m,port:f}=h(c);if(typeof f>"u")throw new Error("Remote authority doesn't contain a port!");return{host:m,port:f}}e.parseAuthorityWithPort=M;function I(c,m){let{host:f,port:w}=h(c);return typeof w>"u"&&(w=m),{host:f,port:w}}e.parseAuthorityWithOptionalPort=I;function h(c){const m=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const f=c.match(/^(\[[0-9a-z:]+\])$/);if(f)return{host:f[1],port:void 0};const w=c.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:c,port:void 0}}}),define(te[120],ie([0,1,25,6,60]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.getWorkspaceSupportTypeMessage=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var M;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(M||(e.ExtensionType=M={}));var I;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.LINUX_PPC64LE="linux-ppc64le",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class h{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,g){if(typeof o>"u"||o===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof o=="string"||typeof g=="string"){const l=typeof o=="string"?o:o.value,v=typeof g=="string"?g:g.value;return P.equalsIgnoreCase(l,v)}return o._lower===g._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.ExtensionIdentifier=h;class c{get size(){return this._set.size}constructor(o){if(this._set=new Set,o)for(const g of o)this.add(g)}add(o){this._set.add(h.toKey(o))}delete(o){return this._set.delete(h.toKey(o))}has(o){return this._set.has(h.toKey(o))}}e.ExtensionIdentifierSet=c;class m{constructor(){this._map=new Map}clear(){this._map.clear()}delete(o){this._map.delete(h.toKey(o))}get(o){return this._map.get(h.toKey(o))}has(o){return this._map.has(h.toKey(o))}set(o,g){this._map.set(h.toKey(o),g)}values(){return this._map.values()}forEach(o){this._map.forEach(o)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=m;function f(y){return w(y)}e.isApplicationScopedExtension=f;function w(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function d(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function b(y,o){if(o){const g=`onResolveRemoteAuthority:${(0,s.getRemoteName)(o)}`;return!!y.activationEvents?.includes(g)}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[240],ie([0,1,8,17,21,13,3,2,65,69,31,109,239,60]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var y;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function o(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(T){const R=new s.CancellationTokenSource;return setTimeout(()=>R.cancel(),T),R.token}function l(T,R){if(T.isCancellationRequested||R.isCancellationRequested)return s.CancellationToken.Cancelled;const W=new s.CancellationTokenSource;return T.onCancellationRequested(()=>W.cancel()),R.onCancellationRequested(()=>W.cancel()),W.token}class v{get didTimeout(){return this._state==="timedout"}constructor(R){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((W,H)=>{this._resolvePromise=W,this._rejectPromise=H}),R.isCancellationRequested?this._timeout():this._disposables.add(R.onCancellationRequested(()=>this._timeout()))}registerDisposable(R){this._state==="pending"?this._disposables.add(R):R.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const R=new Error("Time limit reached");return R.code="ETIMEDOUT",R.syscall="connect",R}resolve(R){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(R))}reject(R){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(R))}}function E(T,R){const W=new v(R);return W.registerDisposable(T.onControlMessage(H=>{const x=JSON.parse(H.toString()),z=N(x);z?W.reject(z):W.resolve(x)})),W.promise}function S(T,R,W,H,x,z,$,K){const re=new v(K),le=c.StopWatch.create(!1);return T.info(`Creating a socket (${$})...`),h.mark(`code/willCreateSocket/${z}`),R.connect(W,H,x,$).then(ge=>{re.didTimeout?(h.mark(`code/didCreateSocketError/${z}`),T.info(`Creating a socket (${$}) finished after ${le.elapsed()} ms, but this is too late and has timed out already.`),ge?.dispose()):(h.mark(`code/didCreateSocketOK/${z}`),T.info(`Creating a socket (${$}) was successful after ${le.elapsed()} ms.`),re.resolve(ge))},ge=>{h.mark(`code/didCreateSocketError/${z}`),T.info(`Creating a socket (${$}) returned an error after ${le.elapsed()} ms.`),T.error(ge),re.reject(ge)}),re.promise}function t(T,R){const W=new v(R);return T.then(H=>{W.didTimeout||W.resolve(H)},H=>{W.didTimeout||W.reject(H)}),W.promise}async function u(T,R,W,H){const x=ce(T,R);T.logService.trace(`${x} 1/6. invoking socketFactory.connect().`);let z;try{z=await S(T.logService,T.remoteSocketFactoryService,T.connectTo,(0,d.getRemoteServerRootPath)(T),`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,o(R),`renderer-${o(R)}-${T.reconnectionToken}`,H)}catch(ge){throw T.logService.error(`${x} socketFactory.connect() failed or timed out. Error:`),T.logService.error(ge),ge}T.logService.trace(`${x} 2/6. socketFactory.connect() was successful.`);let $,K;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection(z,null),$=T.reconnectionProtocol,K=!1):($=new f.PersistentProtocol({socket:z}),K=!0),T.logService.trace(`${x} 3/6. sending AuthRequest control message.`);const re=await t(T.signService.createNewMessage((0,m.generateUuid)()),H),le={type:"auth",auth:T.connectionToken||"00000000000000000000",data:re.data};$.sendControl(L.VSBuffer.fromString(JSON.stringify(le)));try{const ge=await E($,l(H,g(1e4)));if(ge.type!=="sign"||typeof ge.data!="string"){const Oe=new Error("Unexpected handshake message");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}if(T.logService.trace(`${x} 4/6. received SignRequest control message.`),!await t(T.signService.validate(re,ge.signedData),H)){const Oe=new Error("Refused to connect to unsupported server");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}const Me=await t(T.signService.sign(ge.data),H),Re={type:"connectionType",commit:T.commit,signedData:Me,desiredConnectionType:R};return W&&(Re.args=W),T.logService.trace(`${x} 5/6. sending ConnectionTypeRequest control message.`),$.sendControl(L.VSBuffer.fromString(JSON.stringify(Re))),{protocol:$,ownsProtocol:K}}catch(ge){throw ge&&ge.code==="ETIMEDOUT"&&(T.logService.error(`${x} the handshake timed out. Error:`),T.logService.error(ge)),ge&&ge.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${x} received error control message when negotiating connection. Error:`),T.logService.error(ge)),K&&F($),ge}}async function r(T,R,W,H){const x=Date.now(),z=ce(T,R),{protocol:$,ownsProtocol:K}=await u(T,R,W,H),re=new v(H);return re.registerDisposable($.onControlMessage(le=>{const ge=JSON.parse(le.toString()),Ce=N(ge);Ce?(T.logService.error(`${z} received error control message when negotiating connection. Error:`),T.logService.error(Ce),K&&F($),re.reject(Ce)):(T.reconnectionProtocol?.endAcceptReconnection(),T.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${oe(x)}!`),re.resolve({protocol:$,firstMessage:ge}))})),re.promise}async function n(T,R){const{protocol:W}=await r(T,1,void 0,R);return{protocol:W}}async function i(T,R,W){const{protocol:H,firstMessage:x}=await r(T,2,R,W),z=x&&x.debugPort;return{protocol:H,debugPort:z}}async function a(T,R,W){const H=Date.now(),x=ce(T,3),{protocol:z}=await u(T,3,R,W);return T.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${oe(H)}!`),z}async function p(T,R,W){const{connectTo:H,connectionToken:x}=await T.addressProvider.getAddress();return{commit:T.commit,quality:T.quality,connectTo:H,connectionToken:x,reconnectionToken:R,reconnectionProtocol:W,remoteSocketFactoryService:T.remoteSocketFactoryService,signService:T.signService,logService:T.logService}}async function C(T,R,W){return D(T,async H=>{const{protocol:x}=await n(H,s.CancellationToken.None);return new G(T,R,W,H.reconnectionToken,x)})}e.connectRemoteAgentManagement=C;async function k(T,R){return D(T,async W=>{const{protocol:H,debugPort:x}=await i(W,R,s.CancellationToken.None);return new Y(T,R,W.reconnectionToken,H,x)})}e.connectRemoteAgentExtensionHost=k;async function D(T,R){for(let H=1;;H++)try{const x=(0,m.generateUuid)(),z=await p(T,x,null);return await R(z)}catch(x){if(H<5)T.logService.error(`[remote-connection][attempt ${H}] An error occurred in initial connection! Will retry... Error:`),T.logService.error(x);else throw T.logService.error(`[remote-connection][attempt ${H}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),T.logService.error(x),ue.triggerPermanentFailure(0,0,w.RemoteAuthorityResolverError.isHandled(x)),x}}async function A(T,R,W){const H=await p(T,(0,m.generateUuid)(),null);return await a(H,{host:R,port:W},s.CancellationToken.None)}e.connectRemoteAgentTunnel=A;function O(T){return(0,P.createCancelablePromise)(R=>new Promise((W,H)=>{const x=setTimeout(W,T*1e3);R.onCancellationRequested(()=>{clearTimeout(x),W()})}))}var U;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class q{constructor(R,W){this.reconnectionToken=R,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=q;class se{constructor(R,W,H,x){this.reconnectionToken=R,this.millisSinceLastIncomingData=W,this.durationSeconds=H,this.cancellableTimer=x,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=se;class ne{constructor(R,W,H){this.reconnectionToken=R,this.millisSinceLastIncomingData=W,this.attempt=H,this.type=2}}e.ReconnectionRunningEvent=ne;class ee{constructor(R,W,H){this.reconnectionToken=R,this.millisSinceLastIncomingData=W,this.attempt=H,this.type=4}}e.ConnectionGainEvent=ee;class ae{constructor(R,W,H,x){this.reconnectionToken=R,this.millisSinceLastIncomingData=W,this.attempt=H,this.handled=x,this.type=3}}e.ReconnectionPermanentFailureEvent=ae;class ue extends I.Disposable{static triggerPermanentFailure(R,W,H){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=R,this._permanentFailureAttempt=W,this._permanentFailureHandled=H,this._instances.forEach(x=>x._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(R=>R._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(R=>R._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||ue._permanentFailure}constructor(R,W,H,x,z){super(),this._connectionType=R,this._options=W,this.reconnectionToken=H,this.protocol=x,this._reconnectionFailureIsFatal=z,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new ee(this.reconnectionToken,0,0)),this._register(x.onSocketClose($=>{const K=X(this._connectionType,this.reconnectionToken,!0);$?$.type===0?(this._options.logService.info(`${K} received socket close event (hadError: ${$.hadError}).`),$.error&&this._options.logService.error($.error)):(this._options.logService.info(`${K} received socket close event (wasClean: ${$.wasClean}, code: ${$.code}, reason: ${$.reason}).`),$.event&&this._options.logService.error($.event)):this._options.logService.info(`${K} received socket close event.`),this._beginReconnecting()})),this._register(x.onSocketTimeout($=>{const K=X(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${K} received socket timeout event (unacknowledgedMsgCount: ${$.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${$.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${$.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),ue._instances.push(this),this._register((0,I.toDisposable)(()=>{const $=ue._instances.indexOf(this);$>=0&&ue._instances.splice($,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ue._permanentFailureMillisSinceLastIncomingData,ue._permanentFailureAttempt,ue._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const R=X(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${R} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let H=-1;do{H++;const x=H<W.length?W[H]:W[W.length-1];try{if(x>0){const $=O(x);this._onDidStateChange.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x,$)),this._options.logService.info(`${R} waiting for ${x} seconds before reconnecting...`);try{await $}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${R} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1)),this._options.logService.info(`${R} resolving connection...`);const z=await p(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${R} connecting to ${z.connectTo}...`),await this._reconnect(z,g(b)),this._options.logService.info(`${R} reconnected!`),this._onDidStateChange.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${R} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(H>360){this._options.logService.error(`${R} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(w.RemoteAuthorityResolverError.isTemporarilyNotAvailable(z)){this._options.logService.info(`${R} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this._options.logService.info(`${R} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((0,_.isCancellationError)(z)){this._options.logService.info(`${R} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if(z instanceof w.RemoteAuthorityResolverError){this._options.logService.error(`${R} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,w.RemoteAuthorityResolverError.isHandled(z));break}this._options.logService.error(`${R} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(R,W,H){this._reconnectionFailureIsFatal?ue.triggerPermanentFailure(R,W,H):this._gotoPermanentFailure(R,W,H)}_gotoPermanentFailure(R,W,H){this._onDidStateChange.fire(new ae(this.reconnectionToken,R,W,H)),F(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ue;class G extends ue{constructor(R,W,H,x,z){super(1,R,x,z,!0),this.client=this._register(new f.Client(z,{remoteAuthority:W,clientId:H},R.ipcLogger))}async _reconnect(R,W){await n(R,W)}}e.ManagementPersistentConnection=G;class Y extends ue{constructor(R,W,H,x,z){super(2,R,H,x,!1),this._startArguments=W,this.debugPort=z}async _reconnect(R,W){await i(R,this._startArguments,W)}}e.ExtensionHostPersistentConnection=Y;function F(T){try{T.acceptDisconnect();const R=T.getSocket();T.dispose(),R.dispose()}catch(R){(0,_.onUnexpectedError)(R)}}function N(T){if(T&&T.type==="error"){const R=new Error(`Connection error: ${T.reason}`);return R.code="VSCODE_CONNECTION_ERROR",R}return null}function B(T,R){for(;T.length<R;)T+=" ";return T}function V(T,R){return`[remote-connection][${B(o(T),13)}][${R.substr(0,5)}\u2026]`}function X(T,R,W){return`${V(T,R)}[${W?"reconnect":"initial"}]`}function ce(T,R){return`${X(R,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.connectTo}]`}function oe(T){return`${Date.now()-T} ms`}}),define(te[241],ie([0,1,2,6]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,L.createDecorator)("remoteSocketFactoryService");class s{constructor(){this.factories={}}register(M,I){return this.factories[M]??=[],this.factories[M].push(I),(0,P.toDisposable)(()=>{const h=this.factories[M]?.indexOf(I);typeof h=="number"&&h>=0&&this.factories[M]?.splice(h,1)})}getSocketFactory(M){return(this.factories[M.type]||[]).find(h=>h.supports(M))}connect(M,I,h,c){const m=this.getSocketFactory(M);if(!m)throw new Error(`No socket factory found for ${M}`);return m.connect(M,I,h,c)}}e.RemoteSocketFactoryService=s}),define(te[242],ie([0,1,27,47,42,113]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let M;async function I(d=!1){return(M===void 0||d)&&(M=h()),M}e.hasWSLFeatureInstalled=I;async function h(){const d=c();if(d===void 0)return!1;if(d>=22e3){const b=f();if(b)return new Promise(y=>{L.execFile(b,["--status"],o=>y(!o))})}else{const b=w();if(b)try{if((await s.promises.stat(b)).isFile())return!0}catch{}}return!1}function c(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(d)return parseInt(d[3])}function m(d){const b=process.env.SystemRoot;if(b){const y=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return _.join(b,y?"Sysnative":"System32",d)}}function f(){return m("wsl.exe")}function w(){return m("lxss\\LxssManager.dll")}}),define(te[51],ie([0,1,17,13,2,181,59,6,5,44]),function(j,e,P,L,s,_,M,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,I.createDecorator)("requestService");class m{constructor(S){this.original=S}toJSON(){if(!this.headers){const S=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?S[t]="*****":S[t]=this.original[t];this.headers=S}return this.headers}}class f extends s.Disposable{constructor(S){super(),this.counter=0,this.logger=S.createLogger("network",{name:(0,_.localize)(0,null),when:h.CONTEXT_LOG_LEVEL.isEqualTo((0,h.LogLevelToString)(h.LogLevel.Trace)).serialize()})}async logAndRequest(S,t,u){const r=`${S} #${++this.counter}: ${t.url}`;this.logger.trace(`${r} - begin`,t.type,new m(t.headers??{}));try{const n=await u();return this.logger.trace(`${r} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.logger.error(`${r} - error`,t.type,(0,L.getErrorMessage)(n)),n}}}e.AbstractRequestService=f;function w(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.isSuccess=w;function d(E){return E.res.statusCode===204}async function b(E){return d(E)?null:(await(0,P.streamToBuffer)(E.stream)).toString()}e.asText=b;async function y(E){if(!w(E))throw new Error("Server returned "+E.res.statusCode);return b(E)}e.asTextOrError=y;async function o(E){if(!w(E))throw new Error("Server returned "+E.res.statusCode);if(d(E))return null;const t=(await(0,P.streamToBuffer)(E.stream)).toString();try{return JSON.parse(t)}catch(u){throw u.message+=`:
`+t,u}}e.asJson=o;function g(E){v(E)}e.updateProxyConfigurationsScope=g;let l;function v(E){const S=c.Registry.as(M.Extensions.Configuration),t=l;l={id:"http",order:15,title:(0,_.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,_.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,_.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,_.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,_.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,_.localize)(6,null),(0,_.localize)(7,null),(0,_.localize)(8,null),(0,_.localize)(9,null)],default:"override",description:(0,_.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,_.localize)(11,null),restricted:!0}}},S.updateConfigurations({add:[l],remove:t?[t]:[]})}v(1)}),define(te[243],ie([0,1,17,21]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class s{constructor(I){this.service=I}listen(I,h){throw new Error("Invalid listen")}call(I,h,c,m=L.CancellationToken.None){switch(h){case"request":return this.service.request(c[0],m).then(async({res:f,stream:w})=>{const d=await(0,P.streamToBuffer)(w);return[{statusCode:f.statusCode,headers:f.headers},d]});case"resolveProxy":return this.service.resolveProxy(c[0])}throw new Error("Invalid call")}}e.RequestChannel=s;class _{constructor(I){this.channel=I}async request(I,h){const[c,m]=await this.channel.call("request",[I],h);return{res:c,stream:(0,P.bufferToStream)(m)}}async resolveProxy(I){return this.channel.call("resolveProxy",[I])}}e.RequestChannelClient=_}),define(te[244],ie([0,1,245,10]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function s(M,I){return M.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:M.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function _(M,I,h={}){const c=(0,P.parse)(M),m=h.proxyUrl||s(c,I);if(!m)return null;const f=(0,P.parse)(m);if(!/^https?:$/.test(f.protocol||""))return null;const w={host:f.hostname||"",port:f.port||(f.protocol==="https"?"443":"80"),auth:f.auth,rejectUnauthorized:(0,L.isBoolean)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((d,b)=>{j(["http-proxy-agent"],d,b)}))(w):new(await new Promise((d,b)=>{j(["https-proxy-agent"],d,b)}))(w)}e.getProxyAgent=_}),define(te[95],ie([0,1,47,9,182,21,50,13,4,31,108,63,8,138]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let b;async function y(g,l,v,E){return v["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,f.isLaunchedFromCli)(E)&&!v["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,f.isLaunchedFromCli)(E)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=w.Promises.withAsyncBody(async(S,t)=>{const u=new _.CancellationTokenSource;let r=1e4;const n=g.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(r=(0,d.clamp)(n,1,120)*1e3);const i=setTimeout(()=>{u.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{S(await o(l,u.token))}catch(a){!(0,I.isCancellationError)(a)&&!u.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,M.toErrorMessage)(a)))):S({})}finally{clearTimeout(i),u.dispose()}})),b)}e.getResolvedShellEnv=y;async function o(g,l){const v=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",v);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",E);const S=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(S+"({.*})"+S),u={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",u);const r=await(0,m.getSystemShell)(h.OS,u);return g.trace("getUnixShellEnvironment#shell",r),new Promise((n,i)=>{if(l.isCancellationRequested)return i(new I.CancellationError);const a=(0,L.basename)(r);let p,C;const k=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(p=`& '${process.execPath}' ${k} -p '''${S}'' + JSON.stringify(process.env) + ''${S}'''`,C=["-Login","-Command"]):a==="nu"?(p=`^'${process.execPath}' ${k} -p '"${S}" + JSON.stringify(process.env) + "${S}"'`,C=["-i","-l","-c"]):(p=`'${process.execPath}' ${k} -p '"${S}" + JSON.stringify(process.env) + "${S}"'`,a==="tcsh"||a==="csh"?C=["-ic"]:C=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(C),p);const D=(0,P.spawn)(r,[...C,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:u});l.onCancellationRequested(()=>(D.kill(),i(new I.CancellationError))),D.on("error",U=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(U)),i(U)});const A=[];D.stdout.on("data",U=>A.push(U));const O=[];D.stderr.on("data",U=>O.push(U)),D.on("close",(U,q)=>{const se=Buffer.concat(A).toString("utf8");g.trace("getUnixShellEnvironment#raw",se);const ne=Buffer.concat(O).toString("utf8");if(ne.trim()&&g.trace("getUnixShellEnvironment#stderr",ne),U||q)return i(new Error((0,s.localize)(2,null,U,q)));const ee=t.exec(se),ae=ee?ee[1]:"{}";try{const ue=JSON.parse(ae);v?ue.ELECTRON_RUN_AS_NODE=v:delete ue.ELECTRON_RUN_AS_NODE,E?ue.ELECTRON_NO_ATTACH_CONSOLE=E:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ue),n(ue)}catch(ue){g.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(ue)),i(ue)}})})}}),define(te[246],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class P{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(s){try{const _=await this.getValidator();if(_){const M=String(P._nextId++);return this.validators.set(M,_),{id:M,data:_.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,_){if(!s.id)return!0;const M=this.validators.get(s.id);if(!M)return!1;this.validators.delete(s.id);try{return M.validate(_)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(s){try{return await this.signValue(s)}catch{}return s}}e.AbstractSignService=P}),define(te[96],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,P.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[247],ie([0,1,246]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L extends P.AbstractSignService{getValidator(){return this.vsda().then(_=>new _.validator)}signValue(_){return this.vsda().then(M=>new M.signer().sign(_))}vsda(){return new Promise((_,M)=>j(["vsda"],_,M))}}e.SignService=L}),define(te[34],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,P.createDecorator)("stateReadService"),e.IStateService=(0,P.createDecorator)("stateService")}),define(te[121],ie([0,1,8,17,10,33,16,5]),function(j,e,P,L,s,_,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var h;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(h||(e.SaveStrategy=h={}));class c{constructor(d,b,y,o){this.storagePath=d,this.logService=y,this.fileService=o,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=b===0?void 0:new P.ThrottledDelayer(100)}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(d){d.fileOperationResult!==1&&this.logService.error(d)}}getItem(d,b){const y=this.storage[d];return(0,s.isUndefinedOrNull)(y)?b:y}setItem(d,b){this.setItems([{key:d,data:b}])}setItems(d){let b=!1;for(const{key:y,data:o}of d)this.storage[y]!==o&&((0,s.isUndefinedOrNull)(o)?(0,s.isUndefined)(this.storage[y])||(this.storage[y]=void 0,b=!0):(this.storage[y]=o,b=!0));b&&this.save()}removeItem(d){(0,s.isUndefined)(this.storage[d])||(this.storage[d]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const d=JSON.stringify(this.storage,null,4);if(d!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(d),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=d}catch(b){this.logService.error(b)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=c;let m=class{constructor(d,b,y,o){this.fileStorage=new c(b.stateResource,d,y,o)}async init(){await this.fileStorage.init()}getItem(d,b){return this.fileStorage.getItem(d,b)}};e.StateReadonlyService=m,e.StateReadonlyService=m=Se([J(1,_.IEnvironmentService),J(2,I.ILogService),J(3,M.IFileService)],m);class f extends m{setItem(d,b){this.fileStorage.setItem(d,b)}setItems(d){this.fileStorage.setItems(d)}removeItem(d){this.fileStorage.removeItem(d)}close(){return this.fileStorage.close()}}e.StateService=f}),define(te[122],ie([0,1,4,36,31]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function _(h){if(P.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function M(h,c,m,f,w,d,b,y){const o=Object.create(null);o["common.machineId"]=d,o.sessionID=(0,s.generateUuid)()+Date.now(),o.commitHash=f,o.version=w,o["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,P.PlatformToString)(P.platform),o["common.nodePlatform"]=L.platform,o["common.nodeArch"]=m,o["common.product"]=y||"desktop",b&&(o["common.msftInternal"]=b);let g=0;const l=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),P.isLinuxSnap&&(o["common.snap"]="true");const v=_(c);return v&&(o["common.platformDetail"]=v),o}e.resolveCommonProperties=M;function I(h){const c=L.env.USERDNSDOMAIN;if(!c)return!1;const m=c.toLowerCase();return h.some(f=>m===f)}e.verifyMicrosoftInternalDomain=I}),define(te[26],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,P.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,P.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(_){_[_.NONE=0]="NONE",_[_.CRASH=1]="CRASH",_[_.ERROR=2]="ERROR",_[_.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var s;(function(_){_.OFF="off",_.CRASH="crash",_.ERROR="error",_.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(te[248],ie([0,1,27,8,45,15,9,4,7,87,22,107,91,16,23,26]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const o=new Map;async function g(t,u){const r=`${t}::${u.join(":")}`,n=o.get(r);if(n)return n;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,p=new Map,C=2e4;function k(A,O,U,q){const se=O.substring(A.length+1);return L.Promises.withAsyncBody(async ne=>{let ee;try{ee=await m.Promises.readdir(O,{withFileTypes:!0})}catch{ne();return}if(q.count>=C){q.count+=ee.length,q.maxReached=!0,ne();return}let ae=ee.length;if(ae===0){ne();return}let ue=ee;q.count+ee.length>C&&(q.maxReached=!0,ae=C-q.count,ue=ee.slice(0,ae)),q.count+=ee.length;for(const G of ue)if(G.isDirectory()){if(U.includes(G.name)||await k(A,(0,M.join)(O,G.name),U,q),--ae===0){ne();return}}else{const Y=G.name.lastIndexOf(".");if(Y>=0){const F=G.name.substring(Y+1);F&&a.set(F,(a.get(F)??0)+1)}for(const F of i)F.relativePathPattern?.test(se)!==!1&&F.filePattern.test(G.name)&&p.set(F.tag,(p.get(F.tag)??0)+1);if(--ae===0){ne();return}}})}const D=L.Promises.withAsyncBody(async A=>{const O={count:0,maxReached:!1};await k(t,t,u,O);const U=await E(t);A({configFiles:l(p),fileTypes:l(a),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:U})});return o.set(r,D),D}e.collectWorkspaceStats=g;function l(t){return Array.from(t.entries(),([u,r])=>({name:u,count:r})).sort((u,r)=>r.count-u.count)}function v(){const t={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(P.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.virtualMachineHint.value()*100)}%`},u=P.cpus();return u&&u.length>0&&(t.cpus=`${u[0].model} (${u.length} x ${u[0].speed})`),t}e.getMachineInfo=v;async function E(t){try{const u=new Map,r=(0,M.join)(t,".vscode","launch.json"),n=await m.Promises.readFile(r),i=[],a=(0,s.parse)(n.toString(),i);if(i.length)return console.log(`Unable to parse ${r}`),[];if((0,s.getNodeType)(a)==="object"&&a.configurations)for(const p of a.configurations){const C=p.type;C&&(u.has(C)?u.set(C,u.get(C)+1):u.set(C,1))}return l(u)}catch{return[]}}e.collectLaunchConfigs=E;let S=class{constructor(u,r){this.telemetryService=u,this.productService=r}formatMachineInfo(u){const r=[];return r.push(`OS Version:       ${u.os}`),r.push(`CPUs:             ${u.cpus}`),r.push(`Memory (System):  ${u.memory}`),r.push(`VM:               ${u.vmHint}`),r.join(`
`)}formatEnvironment(u){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const n=P.cpus();return n&&n.length>0&&r.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),r.push(`Memory (System):  ${(P.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(P.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||r.push(`Load (avg):       ${P.loadavg().map(i=>Math.round(i)).join(", ")}`),r.push(`VM:               ${Math.round(c.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${u.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${u.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(u.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(u,r){return Promise.all([(0,f.listProcesses)(u.mainPID),this.formatWorkspaceMetadata(u)]).then(async n=>{let[i,a]=n,p=this.formatProcessList(u,i);return r.forEach(C=>{if((0,w.isRemoteDiagnosticError)(C))p+=`
${C.errorMessage}`,a+=`
${C.errorMessage}`;else if(p+=`

Remote: ${C.hostName}`,C.processes&&(p+=`
${this.formatProcessList(u,C.processes)}`),C.workspaceMetadata){a+=`
|  Remote: ${C.hostName}`;for(const k of Object.keys(C.workspaceMetadata)){const D=C.workspaceMetadata[k];let A=`${D.fileCount} files`;D.maxFilesReached&&(A=`more than ${A}`),a+=`|    Folder (${k}): ${A}`,a+=this.formatWorkspaceStats(D)}}}),{processInfo:p,workspaceInfo:a}})}async getSystemInfo(u,r){const{memory:n,vmHint:i,os:a,cpus:p}=v(),C={os:a,memory:n,cpus:p,vmHint:i,processArgs:`${u.mainArguments.join(" ")}`,gpuStatus:u.gpuFeatureStatus,screenReader:`${u.screenReader?"yes":"no"}`,remoteData:r};return I.isWindows||(C.load=`${P.loadavg().map(k=>Math.round(k)).join(", ")}`),I.isLinux&&(C.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(C)}async getDiagnostics(u,r){const n=[];return(0,f.listProcesses)(u.mainPID).then(async i=>(n.push(""),n.push(this.formatEnvironment(u)),n.push(""),n.push(this.formatProcessList(u,i)),u.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(u))),r.forEach(a=>{if((0,w.isRemoteDiagnosticError)(a))n.push(`
${a.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${a.hostName}`),n.push(this.formatMachineInfo(a.machineInfo)),a.processes&&n.push(this.formatProcessList(u,a.processes)),a.workspaceMetadata)for(const p of Object.keys(a.workspaceMetadata)){const C=a.workspaceMetadata[p];let k=`${C.fileCount} files`;C.maxFilesReached&&(k=`more than ${k}`),n.push(`Folder (${p}): ${k}`),n.push(this.formatWorkspaceStats(C))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(u){const r=[];let i=0;const a=(D,A)=>{const O=` ${D}(${A})`;i+O.length>60?(r.push(p),p="|                 ",i=p.length):i+=O.length,p+=O};let p="|      File types:";const C=10,k=u.fileTypes.length>C?C:u.fileTypes.length;for(let D=0;D<k;D++){const A=u.fileTypes[D];a(A.name,A.count)}if(r.push(p),u.configFiles.length>=0&&(p="|      Conf files:",i=0,u.configFiles.forEach(D=>{a(D.name,D.count)}),r.push(p)),u.launchConfigFiles.length>0){let D="|      Launch Configs:";u.launchConfigFiles.forEach(A=>{const O=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`;D+=O}),r.push(D)}return r.join(`
`)}expandGPUFeatures(u){const r=Math.max(...Object.keys(u).map(n=>n.length));return Object.keys(u).map(n=>`${n}:  ${" ".repeat(r-n.length)}  ${u[n]}`).join(`
                  `)}formatWorkspaceMetadata(u){const r=[],n=[];return u.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(r.push(`|  Window (${i.title})`),i.folderURIs.forEach(a=>{const p=h.URI.revive(a);if(p.scheme===_.Schemas.file){const C=p.fsPath;n.push(g(C,["node_modules",".git"]).then(k=>{let D=`${k.fileCount} files`;k.maxFilesReached&&(D=`more than ${D}`),r.push(`|    Folder (${(0,M.basename)(C)}): ${D}`),r.push(this.formatWorkspaceStats(k))}).catch(k=>{r.push(`|      Error: Unable to collect workspace stats for folder ${C} (${k.toString()})`)}))}else r.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(i=>r.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}formatProcessList(u,r){const n=new Map;u.windows.forEach(a=>n.set(a.pid,`window [${a.id}] (${a.title})`)),u.pidToNames.forEach(({pid:a,name:p})=>n.set(a,p));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(u.mainPID,n,i,r,0),i.join(`
`)}formatProcessItem(u,r,n,i,a){const p=a===0;let C;p?C=i.pid===u?`${this.productService.applicationName} main`:"remote agent":r.has(i.pid)?C=r.get(i.pid):C=`${"  ".repeat(a)} ${i.name}`;const k=process.platform==="win32"?i.mem:P.totalmem()*(i.mem/100);n.push(`${i.load.toFixed(0).padStart(5," ")}	${(k/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${C}`),Array.isArray(i.children)&&i.children.forEach(D=>this.formatProcessItem(u,r,n,D,a+1))}async getWorkspaceFileExtensions(u){const r=new Set;for(const{uri:n}of u.folders){const i=h.URI.revive(n);if(i.scheme!==_.Schemas.file)continue;const a=i.fsPath;try{(await g(a,["node_modules",".git"])).fileTypes.forEach(C=>r.add(C.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(u){for(const{uri:r}of u.folders){const n=h.URI.revive(r);if(n.scheme!==_.Schemas.file)continue;const i=n.fsPath;try{const a=await g(i,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":u.telemetryId,rendererSessionId:u.rendererSessionId}),a.fileTypes.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:u.rendererSessionId,type:p.name,count:p.count})}),a.launchConfigFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:u.rendererSessionId,type:p.name,count:p.count})}),a.configFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:u.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};e.DiagnosticsService=S,e.DiagnosticsService=S=Se([J(0,y.ITelemetryService),J(1,b.IProductService)],S)}),define(te[249],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class P{constructor(_){this.appenders=_}listen(_,M){throw new Error(`Event not found: ${M}`)}call(_,M,{eventName:I,data:h}){return this.appenders.forEach(c=>c.log(I,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=P;class L{constructor(_){this.channel=_}log(_,M){return this.channel.call("log",{eventName:_,data:M}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(te[52],ie([0,1,37,10,3,18,60,122,26]),function(j,e,P,L,s,_,M,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class c{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=c;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=m,e.NullTelemetryService=new m;class f{async publicLog(i,a,p){}async publicLogError(i,a,p){}}e.NullEndpointTelemetryService=f,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(n,i){return s.Event.debounce(i.onDidChangeConfiguration,(p,C)=>{const k=p?new Set([...p.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:k}},1e3,!0)(p=>{p.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,_.ConfigurationTargetToString)(p.source),configurationKeys:Array.from(p.affectedKeys)})})}e.configurationTelemetry=w;function d(n,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!n.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=d;function b(n,i){return!(i.isBuilt||i.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.isLoggingOnly=b;function y(n){const i=n.getValue(h.TELEMETRY_SETTING_ID),a=n.getValue(h.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(n.getValue(h.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function o(n){const i={},a={},p={};v(n,p);for(let C in p){C=C.length>150?C.substr(C.length-149):C;const k=p[C];typeof k=="number"?a[C]=k:typeof k=="boolean"?a[C]=k?1:0:typeof k=="string"?(k.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${k.length}`),i[C]=k.substring(0,8191)):typeof k<"u"&&k!==null&&(i[C]=k)}return{properties:i,measurements:a}}e.validateTelemetryData=o;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(n){if(!n)return"none";const i=(0,M.getRemoteName)(n);return g.has(i)?i:"other"}e.cleanRemoteAuthority=l;function v(n,i,a=0,p){if(n)for(const C of Object.getOwnPropertyNames(n)){const k=n[C],D=p?p+C:C;Array.isArray(k)?i[D]=(0,P.safeStringify)(k):k instanceof Date?i[D]=k.toISOString():(0,L.isObject)(k)?a<2?v(k,i,a+1,D+"."):i[D]=(0,P.safeStringify)(k):i[D]=k}}function E(n,i){const a=n.msftInternalDomains||[],p=i.getValue("telemetry.internalTesting");return(0,I.verifyMicrosoftInternalDomain)(a)||p}e.isInternalTelemetry=E;function S(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=S;function t(n,i){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let a=n;const p=[];for(const A of i)for(;;){const O=A.exec(n);if(!O)break;p.push([O.index,A.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,k=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(a="";;){const A=k.exec(n);if(!A)break;const O=p.some(([U,q])=>A.index<q&&U<k.lastIndex);!C.test(A[0])&&!O&&(a+=n.substring(D,A.index)+"<REDACTED: user-file-path>",D=k.lastIndex)}return D<n.length&&(a+=n.substr(D)),a}function u(n){if(!n)return n;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of i)if(a.regex.test(n))return`<REDACTED: ${a.label}>`;return n}function r(n,i){return(0,P.cloneAndChange)(n,a=>{if(a instanceof c||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let p=a.replaceAll("%20"," ");p=t(p,i);for(const C of i)p=p.replace(C,"");return p=u(p),p}})}e.cleanData=r}),define(te[123],ie([0,1,25,116,120,4,7,13,36,52]),function(j,e,P,L,s,_,M,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function m(r,n){return r.uuid&&n.uuid?r.uuid===n.uuid:r.id===n.id?!0:(0,P.compareIgnoreCase)(r.id,n.id)===0}e.areSameExtensions=m;const f=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(n){const i=n.manifest?n.manifest.version:n.version,a=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new w(n.identifier,i,a)}static parse(n){const i=f.exec(n);return i&&i[1]&&i[2]?new w({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,a="undefined"){this.version=i,this.targetPlatform=a,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof w?m(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=w;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(r){const n=d.exec(r);return n&&n[1]?[o(n[1]),n[2]]:[o(r),void 0]}e.getIdAndVersion=b;function y(r,n){return`${r}.${n}`}e.getExtensionId=y;function o(r){return r.toLowerCase()}e.adoptToGalleryExtensionId=o;function g(r,n){return o(y(r??s.UNDEFINED_PUBLISHER,n))}e.getGalleryExtensionId=g;function l(r,n){const i=[],a=p=>{for(const C of i)if(C.some(k=>m(n(k),n(p))))return C;return null};for(const p of r){const C=a(p);C?C.push(p):i.push([p])}return i}e.groupByExtension=l;function v(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function E(r){return{id:new c.TelemetryTrustedValue(r.identifier.id),name:new c.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new s.ExtensionIdentifier("pprice.better-merge");function S(r,n){const i=[],a=n.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const p=a.shift();if(p&&i.every(C=>!m(C.identifier,{id:p}))){const C=r.filter(k=>m(k.identifier,{id:p}));C.length===1&&(i.push(C[0]),a.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=S;async function t(r,n){if(!_.isLinux)return!1;let i;try{i=(await r.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await r.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){n.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(p))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(r,n){const i=await t(r,n),a=(0,L.getTargetPlatform)(i?"alpine":_.platform,h.arch);return n.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=u}),define(te[250],ie([0,1,204,52]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function s(_,M,I,h,c,m,f){const w={"X-Market-Client-Id":`VSCode ${_}`,"User-Agent":`VSCode ${_} (${M.nameShort})`};if((0,L.supportsTelemetry)(M,I)&&(0,L.getTelemetryLevel)(h)===3){const d=await(0,P.getServiceMachineId)(I,c,m);w["X-Market-User-Id"]=d,w["VSCode-SessionId"]=f.machineId||d}return w}e.resolveMarketplaceHeaders=s}),define(te[251],ie([0,1,2,37,4,25,183,18,59,78,23,44,26,52]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,l,v){this._configurationService=l,this._productService=v,this._experimentProperties={},this._disposables=new P.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,_.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,_.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(E=>{(E.affectsConfiguration(w.TELEMETRY_SETTING_ID)||E.affectsConfiguration(w.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(w.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(g,l){this._experimentProperties[g]=l}_updateTelemetryLevel(){let g=(0,d.getTelemetryLevel)(this._configurationService);const l=this._productService.enabledTelemetryLevels;if(l){this._sendErrorTelemetry=this.sendErrorTelemetry?l.error:!1;const v=l.usage?3:l.error?2:0;g=Math.min(g,v)}this._telemetryLevel=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(g,l,v){this._telemetryLevel<l||(v=(0,L.mixin)(v,this._experimentProperties),v=(0,d.cleanData)(v,this._cleanupPatterns),v=(0,L.mixin)(v,this._commonProperties),this._appenders.forEach(E=>E.log(g,v)))}publicLog(g,l){this._log(g,3,l)}publicLog2(g,l){this.publicLog(g,l)}publicLogError(g,l){this._sendErrorTelemetry&&this._log(g,2,l)}publicLogError2(g,l){this.publicLogError(g,l)}};e.TelemetryService=b,e.TelemetryService=b=Se([J(1,I.IConfigurationService),J(2,m.IProductService)],b);function y(){const o=(0,M.localize)(0,null,c.default.nameLong),g=c.default.privacyStatementUrl?(0,M.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,M.localize)(1,null,"https://aka.ms/vscode-telemetry"),l=s.isWeb?"":(0,M.localize)(3,null),v=(0,M.localize)(4,null),E=(0,M.localize)(5,null),S=(0,M.localize)(6,null),t=(0,M.localize)(7,null),u=`
|       | ${v} | ${E} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,M.localize)(8,null);return`
${o} ${g} ${l}

&nbsp;

${t}
${u}

&nbsp;

${r}
`}f.Registry.as(h.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,M.localize)(9,null),properties:{[w.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,M.localize)(10,null),(0,M.localize)(11,null),(0,M.localize)(12,null),(0,M.localize)(13,null)],markdownDescription:y(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),f.Registry.as(h.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(14,null),properties:{[w.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,M.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,M.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,M.localize)(17,null,`\`#${w.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[252],ie([0,1,4,87,26]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function _(M,I){let h=M.getItem(s.machineIdKey);return(typeof h!="string"||P.isMacintosh&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,L.getMachineId)(I.error.bind(I))),h}e.resolveMachineId=_}),define(te[253],ie([0,1,26,252]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function s(_,M){const I=await(0,L.resolveMachineId)(_,M);return _.setItem(P.machineIdKey,I),I}e.resolveMachineId=s}),define(te[124],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var P;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(P||(e.EnvironmentVariableMutatorType=P={}))}),define(te[254],ie([0,1,4,124]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const s=new Map([[L.EnvironmentVariableMutatorType.Append,"APPEND"],[L.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[L.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class _{constructor(m){this.collections=m,this.map=new Map,this.descriptionMap=new Map,m.forEach((f,w)=>{this.populateDescriptionMap(f,w);const d=f.map.entries();let b=d.next();for(;!b.done;){const y=b.value[1],o=b.value[0];let g=this.map.get(o);if(g||(g=[],this.map.set(o,g)),g.length>0&&g[0].type===L.EnvironmentVariableMutatorType.Replace){b=d.next();continue}const l={extensionIdentifier:w,value:y.value,type:y.type,scope:y.scope,variable:y.variable,options:y.options};l.scope||delete l.scope,g.unshift(l),b=d.next()}})}async applyToProcessEnvironment(m,f,w){let d;P.isWindows&&(d={},Object.keys(m).forEach(b=>d[b.toLowerCase()]=b));for(const[b,y]of this.getVariableMap(f)){const o=P.isWindows&&d[b.toLowerCase()]||b;for(const g of y){const l=w?await w(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case L.EnvironmentVariableMutatorType.Append:m[o]=(m[o]||"")+l;break;case L.EnvironmentVariableMutatorType.Prepend:m[o]=l+(m[o]||"");break;case L.EnvironmentVariableMutatorType.Replace:m[o]=l;break}if(g.options?.applyAtShellIntegration??!1){const v=`VSCODE_ENV_${s.get(g.type)}`;m[v]=(m[v]?m[v]+":":"")+b+"="+this._encodeColons(l)}}}}_encodeColons(m){return m.replaceAll(":","\\x3a")}diff(m,f){const w=new Map,d=new Map,b=new Map;if(m.getVariableMap(f).forEach((y,o)=>{const g=this.getVariableMap(f).get(o),l=I(y,g);l&&w.set(o,l)}),this.getVariableMap(f).forEach((y,o)=>{const g=m.getVariableMap(f).get(o),l=I(y,g);l&&b.set(o,l)}),this.getVariableMap(f).forEach((y,o)=>{const g=m.getVariableMap(f).get(o),l=h(y,g);l&&d.set(o,l)}),!(w.size===0&&d.size===0&&b.size===0))return{added:w,changed:d,removed:b}}getVariableMap(m){const f=new Map;for(const w of this.map.values()){const d=w.filter(b=>M(b,m));d.length>0&&f.set(d[0].variable,d)}return f}getDescriptionMap(m){const f=new Map;for(const w of this.descriptionMap.values()){const d=w.filter(b=>M(b,m,!0));for(const b of d)f.set(b.extensionIdentifier,b.description)}return f}populateDescriptionMap(m,f){if(!m.descriptionMap)return;const w=m.descriptionMap.entries();let d=w.next();for(;!d.done;){const b=d.value[1],y=d.value[0];let o=this.descriptionMap.get(y);o||(o=[],this.descriptionMap.set(y,o));const g={extensionIdentifier:f,scope:b.scope,description:b.description};g.scope||delete g.scope,o.push(g),d=w.next()}}}e.MergedEnvironmentVariableCollection=_;function M(c,m,f=!1){return c.scope?!!(c.scope.workspaceFolder&&m?.workspaceFolder&&c.scope.workspaceFolder.index===m.workspaceFolder.index):f?m===c.scope:!0}function I(c,m){if(!m)return c;const f=new Set;m.forEach(d=>f.add(d.extensionIdentifier));const w=[];return c.forEach(d=>{f.has(d.extensionIdentifier)||w.push(d)}),w.length===0?void 0:w}function h(c,m){if(!m)return;const f=new Map;m.forEach(d=>f.set(d.extensionIdentifier,d));const w=[];return c.forEach(d=>{const b=f.get(d.extensionIdentifier);b&&(d.type!==b.type||d.value!==b.value||d.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index)&&w.push(b)}),w.length===0?void 0:w}}),define(te[255],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function P(h){return[...h.entries()]}e.serializeEnvironmentVariableCollection=P;function L(h){return h?[...h.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function s(h){return new Map(h)}e.deserializeEnvironmentVariableCollection=s;function _(h){return new Map(h??[])}e.deserializeEnvironmentDescriptionMap=_;function M(h){return Array.from(h.entries()).map(c=>[c[0],P(c[1].map),L(c[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=M;function I(h){return new Map(h.map(c=>[c[0],{map:s(c[1]),descriptionMap:_(c[2])}]))}e.deserializeEnvironmentVariableCollections=I}),define(te[256],ie([0,1,8,21,3,2,5]),function(j,e,P,L,s,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=class extends _.Disposable{constructor(c,m){super(),this._logService=m,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new s.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=c===void 0?15e3:c}createRequest(c){return new Promise((m,f)=>{const w=++this._lastRequestId;this._pendingRequests.set(w,m),this._onCreateRequest.fire({requestId:w,...c});const d=new L.CancellationTokenSource;(0,P.timeout)(this._timeout,d.token).then(()=>f(`Request ${w} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(w,[(0,_.toDisposable)(()=>d.cancel())])})}acceptReply(c,m){const f=this._pendingRequests.get(c);f?(this._pendingRequests.delete(c),(0,_.dispose)(this._pendingRequestDisposables.get(c)||[]),this._pendingRequestDisposables.delete(c),f(m)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.RequestStore=I,e.RequestStore=I=Se([J(1,M.ILogService)],I)}),define(te[125],ie([0,1,6,114,44]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new L.RawContextKey("terminalTabFocusMode",!1,!0);var _;(function(S){S.DefaultProfile="terminal.integrated.defaultProfile.",S.Profiles="terminal.integrated.profiles."})(_||(e.TerminalSettingPrefix=_={}));var M;(function(S){S.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",S.AutomationProfileLinux="terminal.integrated.automationProfile.linux",S.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",S.AutomationProfileWindows="terminal.integrated.automationProfile.windows",S.ProfilesWindows="terminal.integrated.profiles.windows",S.ProfilesMacOs="terminal.integrated.profiles.osx",S.ProfilesLinux="terminal.integrated.profiles.linux",S.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",S.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",S.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",S.UseWslProfiles="terminal.integrated.useWslProfiles",S.TabsDefaultColor="terminal.integrated.tabs.defaultColor",S.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",S.TabsEnabled="terminal.integrated.tabs.enabled",S.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",S.TabsHideCondition="terminal.integrated.tabs.hideCondition",S.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",S.TabsShowActions="terminal.integrated.tabs.showActions",S.TabsLocation="terminal.integrated.tabs.location",S.TabsFocusMode="terminal.integrated.tabs.focusMode",S.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",S.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",S.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",S.CopyOnSelection="terminal.integrated.copyOnSelection",S.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",S.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",S.FontFamily="terminal.integrated.fontFamily",S.FontSize="terminal.integrated.fontSize",S.LetterSpacing="terminal.integrated.letterSpacing",S.LineHeight="terminal.integrated.lineHeight",S.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",S.TabStopWidth="terminal.integrated.tabStopWidth",S.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",S.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",S.BellDuration="terminal.integrated.bellDuration",S.FontWeight="terminal.integrated.fontWeight",S.FontWeightBold="terminal.integrated.fontWeightBold",S.CursorBlinking="terminal.integrated.cursorBlinking",S.CursorStyle="terminal.integrated.cursorStyle",S.CursorWidth="terminal.integrated.cursorWidth",S.Scrollback="terminal.integrated.scrollback",S.DetectLocale="terminal.integrated.detectLocale",S.DefaultLocation="terminal.integrated.defaultLocation",S.GpuAcceleration="terminal.integrated.gpuAcceleration",S.TerminalTitleSeparator="terminal.integrated.tabs.separator",S.TerminalTitle="terminal.integrated.tabs.title",S.TerminalDescription="terminal.integrated.tabs.description",S.RightClickBehavior="terminal.integrated.rightClickBehavior",S.Cwd="terminal.integrated.cwd",S.ConfirmOnExit="terminal.integrated.confirmOnExit",S.ConfirmOnKill="terminal.integrated.confirmOnKill",S.EnableBell="terminal.integrated.enableBell",S.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",S.AllowChords="terminal.integrated.allowChords",S.AllowMnemonics="terminal.integrated.allowMnemonics",S.TabFocusMode="terminal.integrated.tabFocusMode",S.EnvMacOs="terminal.integrated.env.osx",S.EnvLinux="terminal.integrated.env.linux",S.EnvWindows="terminal.integrated.env.windows",S.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",S.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",S.ShowExitAlert="terminal.integrated.showExitAlert",S.SplitCwd="terminal.integrated.splitCwd",S.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",S.WordSeparators="terminal.integrated.wordSeparators",S.EnableFileLinks="terminal.integrated.enableFileLinks",S.UnicodeVersion="terminal.integrated.unicodeVersion",S.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",S.LocalEchoEnabled="terminal.integrated.localEchoEnabled",S.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",S.LocalEchoStyle="terminal.integrated.localEchoStyle",S.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",S.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",S.CustomGlyphs="terminal.integrated.customGlyphs",S.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",S.InheritEnv="terminal.integrated.inheritEnv",S.ShowLinkHover="terminal.integrated.showLinkHover",S.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",S.AutoReplies="terminal.integrated.autoReplies",S.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",S.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",S.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",S.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",S.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",S.EnableImages="terminal.integrated.enableImages",S.SmoothScrolling="terminal.integrated.smoothScrolling",S.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",S.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay"})(M||(e.TerminalSettingId=M={}));var I;(function(S){S.PowerShell="pwsh",S.Bash="bash",S.Fish="fish",S.Sh="sh",S.Csh="csh",S.Ksh="ksh",S.Zsh="zsh"})(I||(e.PosixShellType=I={}));var h;(function(S){S.CommandPrompt="cmd",S.PowerShell="pwsh",S.Wsl="wsl",S.GitBash="gitbash"})(h||(e.WindowsShellType=h={}));var c;(function(S){S[S.Api=0]="Api",S[S.Process=1]="Process",S[S.Sequence=2]="Sequence",S[S.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var m;(function(S){S.LocalPty="localPty",S.PtyHost="ptyHost",S.PtyHostWindow="ptyHostWindow",S.Logger="logger",S.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={}));var f;(function(S){S.Cwd="cwd",S.InitialCwd="initialCwd",S.FixedDimensions="fixedDimensions",S.Title="title",S.ShellType="shellType",S.HasChildProcesses="hasChildProcesses",S.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",S.OverrideDimensions="overrideDimensions",S.FailedShellIntegrationActivation="failedShellIntegrationActivation",S.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(f||(e.ProcessPropertyType=f={})),e.IPtyService=(0,P.createDecorator)("ptyService");var w;(function(S){S[S.BeatInterval=5e3]="BeatInterval",S[S.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",S[S.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",S[S.SecondWaitMultiplier=1]="SecondWaitMultiplier",S[S.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w||(e.HeartbeatConstants=w={}));var d;(function(S){S[S.Panel=1]="Panel",S[S.Editor=2]="Editor"})(d||(e.TerminalLocation=d={}));var b;(function(S){S.TerminalView="view",S.Editor="editor"})(b||(e.TerminalLocationString=b={}));var y;(function(S){S[S.GraceTime=6e4]="GraceTime",S[S.ShortGraceTime=6e3]="ShortGraceTime"})(y||(e.LocalReconnectConstants=y={}));var o;(function(S){S[S.HighWatermarkChars=1e5]="HighWatermarkChars",S[S.LowWatermarkChars=5e3]="LowWatermarkChars",S[S.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var g;(function(S){S.GitBash="Git Bash",S.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var l;(function(S){S[S.Off=0]="Off",S[S.FinalTerm=1]="FinalTerm",S[S.VSCode=2]="VSCode"})(l||(e.ShellIntegrationStatus=l={}));var v;(function(S){S[S.Unknown=0]="Unknown",S[S.Shutdown=1]="Shutdown",S[S.Process=2]="Process",S[S.User=3]="User",S[S.Extension=4]="Extension"})(v||(e.TerminalExitReason=v={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(t){const u=this._sanitizeRemoteAuthority(t.remoteAuthority);if(this._backends.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this._backends.set(u,t)}getTerminalBackend(t){return this._backends.get(this._sanitizeRemoteAuthority(t))}_sanitizeRemoteAuthority(t){return t?.toLowerCase()??""}}s.Registry.add(e.TerminalExtensions.Backend,new E),e.ILocalPtyService=(0,P.createDecorator)("localPtyService"),e.ITerminalLogService=(0,P.createDecorator)("terminalLogService")}),define(te[257],ie([0,1,71,7,185,102]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function M(w,d){const b=[{name:null,description:(0,s.localize)(0,null)}];return b.push(...w.map(y=>({name:y.profileName,description:I(y)}))),d&&b.push(...d.map(y=>({name:y.title,description:h(y)}))),{values:b.map(y=>y.name),markdownDescriptions:b.map(y=>y.description)}}e.createProfileSchemaEnums=M;function I(w){let d=`$(${_.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:P.Codicon.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?d+=`
- args: "${w.args}"`:d+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(d+=`
- overrideName: ${w.overrideName}`),w.color&&(d+=`
- color: ${w.color}`),w.env&&(d+=`
- env: ${JSON.stringify(w.env)}`),d}function h(w){return`$(${_.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:P.Codicon.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function c(w,d){if(!w&&!d)return!0;if(typeof w=="string"&&typeof d=="string")return w===d;if(Array.isArray(w)&&Array.isArray(d)){if(w.length!==d.length)return!1;for(let b=0;b<w.length;b++)if(w[b]!==d[b])return!1;return!0}return!1}e.terminalProfileArgsMatch=c;function m(w,d){if(!w&&!d)return!0;if(!w||!d)return!1;if(_.ThemeIcon.isThemeIcon(w)&&_.ThemeIcon.isThemeIcon(d))return w.id===d.id&&w.color===d.color;if(typeof w=="object"&&"light"in w&&"dark"in w&&typeof d=="object"&&"light"in d&&"dark"in d){const b=w,y=d;if((L.URI.isUri(b.light)||f(b.light))&&(L.URI.isUri(b.dark)||f(b.dark))&&(L.URI.isUri(y.light)||f(y.light))&&(L.URI.isUri(y.dark)||f(y.dark)))return b.light.path===y.light.path&&b.dark.path===y.dark.path}if(L.URI.isUri(w)&&L.URI.isUri(d)||f(w)||f(d)){const b=w,y=d;return b.path===y.path&&b.scheme===y.scheme}return!1}e.terminalIconsEqual=m;function f(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}e.isUriComponents=f}),define(te[258],ie([0,1,71,4,184,59,44,257]),function(j,e,P,L,s,_,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,P.getAllCodicons)(),o=>o.id),markdownEnumDescriptions:Array.from((0,P.getAllCodicons)(),o=>`$(${o.id})`)};const h={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.terminalIconSchema},color:{description:(0,s.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},m={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function f(o){const g=o===2?"linux":o===1?"osx":"windows";return(0,s.localize)(7,null,(0,L.PlatformToString)(o),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:f(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...h}},{type:"null"},c]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:f(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...h}},{type:"null"},c]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:f(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...h}},{type:"null"},c]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,s.localize)(26,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){M.Registry.as(_.Extensions.Configuration).registerConfiguration(w),y()}e.registerTerminalPlatformConfiguration=d;let b;function y(o,g){const l=M.Registry.as(_.Extensions.Configuration);let v;o&&(v=(0,I.createProfileSchemaEnums)(o?.profiles,g));const E=b;b={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:o?.os===3?v?.values:void 0,markdownEnumDescriptions:o?.os===3?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:o?.os===2?v?.values:void 0,markdownEnumDescriptions:o?.os===2?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:o?.os===1?v?.values:void 0,markdownEnumDescriptions:o?.os===1?v?.markdownDescriptions:void 0}}},l.updateConfigurations({add:[b],remove:E?[E]:[]})}e.registerTerminalDefaultProfileConfiguration=y}),define(te[259],ie([0,1,27,15,37,9,4,36,25,10,22,124,255,254]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());let i=0;return n&&n.length===4&&(i=parseInt(n[3])),i}e.getWindowsBuildNumber=b;async function y(n,i,a,p=I.env,C=m.Promises.exists){if(_.isAbsolute(n))return await C(n)?n:void 0;if(i===void 0&&(i=I.cwd()),_.dirname(n)!=="."){const O=_.join(i,n);return await C(O)?O:void 0}const D=(0,s.getCaseInsensitive)(p,"PATH");if(a===void 0&&(0,c.isString)(D)&&(a=D.split(_.delimiter)),a===void 0||a.length===0){const O=_.join(i,n);return await C(O)?O:void 0}for(const O of a){let U;if(_.isAbsolute(O)?U=_.join(O,n):U=_.join(i,O,n),await C(U))return U;if(M.isWindows){let q=U+".com";if(await C(q)||(q=U+".exe",await C(q)))return q}}const A=_.join(i,n);return await C(A)?A:void 0}e.findExecutable=y;function o(n,i,a,p,C){const k=M.isWindows&&(!i.windowsEnableConpty||b()<18309);if(!i.shellIntegration.enabled||!n.executable||n.isFeatureTerminal||n.hideFromUser||n.ignoreShellIntegration||k)return;const D=n.args,A=I.platform==="win32"?_.basename(n.executable).toLowerCase():_.basename(n.executable),O=_.dirname(L.FileAccess.asFileUri("").fsPath);let U;const q={VSCODE_INJECTION:"1"};if(i.shellIntegration.nonce&&(q.VSCODE_NONCE=i.shellIntegration.nonce),M.isWindows){if(A==="pwsh.exe"||A==="powershell.exe")return!D||u(D)?U=v.get(l.WindowsPwsh):t(D)&&(U=v.get(l.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,h.format)(U[U.length-1],O,""),{newArgs:U,envMixin:q}):void 0;p.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args);return}switch(A){case"bash":return!D||D.length===0?U=v.get(l.Bash):r(D)&&(q.VSCODE_SHELL_LOGIN="1",g(i,q),U=v.get(l.Bash)),U?(U=[...U],U[U.length-1]=(0,h.format)(U[U.length-1],O),{newArgs:U,envMixin:q}):void 0;case"fish":{const se=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ne=_.join(O,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return q.XDG_DATA_DIRS=`${se}:${ne}`,g(i,q),{newArgs:void 0,envMixin:q}}case"pwsh":return!D||u(D)?U=v.get(l.Pwsh):t(D)&&(U=v.get(l.PwshLogin)),U?(U=[...U],U[U.length-1]=(0,h.format)(U[U.length-1],O,""),{newArgs:U,envMixin:q}):void 0;case"zsh":{if(!D||D.length===0?U=v.get(l.Zsh):r(D)?(U=v.get(l.ZshLogin),g(i,q)):(D===v.get(l.Zsh)||D===v.get(l.ZshLogin))&&(U=D),!U)return;U=[...U],U[U.length-1]=(0,h.format)(U[U.length-1],O);let se;try{se=P.userInfo().username}catch{se="unknown"}const ne=_.join(P.tmpdir(),`${se}-${C.applicationName}-zsh`);q.ZDOTDIR=ne;const ee=a?.ZDOTDIR??P.homedir()??"~";q.USER_ZDOTDIR=ee;const ae=[];return ae.push({source:_.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:_.join(ne,".zshrc")}),ae.push({source:_.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:_.join(ne,".zprofile")}),ae.push({source:_.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:_.join(ne,".zshenv")}),ae.push({source:_.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:_.join(ne,".zlogin")}),{newArgs:U,envMixin:q,filesToCopy:ae}}}p.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args)}e.getShellIntegrationInjection=o;function g(n,i){if(M.isMacintosh&&n.environmentVariableCollections){const a=(0,w.deserializeEnvironmentVariableCollections)(n.environmentVariableCollections),C=new d.MergedEnvironmentVariableCollection(a).getVariableMap({workspaceFolder:n.workspaceFolder}).get("PATH"),k=[];if(C)for(const D of C)D.type===f.EnvironmentVariableMutatorType.Prepend&&k.push(D.value);k.length>0&&(i.VSCODE_PATH_PREFIX=k.join(""))}}var l;(function(n){n.WindowsPwsh="windows-pwsh",n.WindowsPwshLogin="windows-pwsh-login",n.Pwsh="pwsh",n.PwshLogin="pwsh-login",n.Zsh="zsh",n.ZshLogin="zsh-login",n.Bash="bash"})(l||(l={}));const v=new Map;v.set(l.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(l.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(l.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),v.set(l.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),v.set(l.Zsh,["-i"]),v.set(l.ZshLogin,["-il"]),v.set(l.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],S=["-nol","-nologo"];function t(n){return typeof n=="string"?E.includes(n.toLowerCase()):n.length===1&&E.includes(n[0].toLowerCase())||n.length===2&&(E.includes(n[0].toLowerCase())||E.includes(n[1].toLowerCase()))&&(S.includes(n[0].toLowerCase())||S.includes(n[1].toLowerCase()))}function u(n){return typeof n=="string"?S.includes(n.toLowerCase()):n.length===0||n?.length===1&&S.includes(n[0].toLowerCase())}function r(n){return n==="string"&&E.includes(n.toLowerCase())||typeof n!="string"&&n.length===1&&E.includes(n[0].toLowerCase())}}),define(te[260],ie([0,1,47,71,9,4,10,22,106,259,113]),function(j,e,P,L,s,_,M,I,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let f,w=!0;function d(i,a,p,C,k=process.env,D,A,O,U){return D=D||{existsFile:I.SymlinkSupport.existsFile,readFile:I.Promises.readFile},_.isWindows?b(p,D,k,A,C.getValue("terminal.integrated.useWslProfiles")!==!1,i&&typeof i=="object"?{...i}:C.getValue("terminal.integrated.profiles.windows"),typeof a=="string"?a:C.getValue("terminal.integrated.defaultProfile.windows"),U,O):u(D,A,p,i&&typeof i=="object"?{...i}:C.getValue(_.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof a=="string"?a:C.getValue(_.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),U,O,k)}e.detectAvailableProfiles=d;async function b(i,a,p,C,k,D,A,O,U){const q=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),se=`${process.env.windir}\\${q?"Sysnative":"System32"}`;let ne=!1;(0,c.getWindowsBuildNumber)()>=16299&&(ne=!0),await l(O);const ee=new Map;if(i){ee.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),ee.set("Windows PowerShell",{path:`${se}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),ee.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ee.set("Command Prompt",{path:`${se}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0}),ee.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ee.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:L.Codicon.terminalBash,isAutoDetected:!0});const ue=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ee.set("Cmder",{path:`${se}\\cmd.exe`,args:["/K",ue],requiresPath:process.env.CMDER_ROOT?ue:{path:ue,isUnsafe:!0},isAutoDetected:!0})}r(D,ee);const ae=await y(ee.entries(),A,a,p,C,U);if(i&&k)try{const ue=await S(`${se}\\${ne?"wsl":"bash"}.exe`,A);for(const G of ue)(!D||!(G.profileName in D))&&ae.push(G)}catch{w&&(C?.info("WSL is not installed, so could not detect WSL profiles"),w=!1)}return ae}async function y(i,a,p,C=process.env,k,D){const A=[];for(const[O,U]of i)A.push(o(O,U,a,p,C,k,D));return(await Promise.all(A)).filter(O=>!!O)}async function o(i,a,p,C,k=process.env,D,A){if(a===null)return;let O,U,q;if("source"in a&&!("path"in a)){const ae=f?.get(a.source);if(!ae)return;O=ae.paths,U=a.args||ae.args,a.icon?q=g(a.icon):ae.icon&&(q=ae.icon)}else O=Array.isArray(a.path)?a.path:[a.path],U=_.isWindows||Array.isArray(a.args)?a.args:void 0,q=g(a.icon);let se;if(A){const ae=O.map(G=>typeof G=="string"?G:G.path),ue=await A(ae);se=new Array(O.length);for(let G=0;G<O.length;G++)typeof O[G]=="string"?se[G]=ue[G]:se[G]={path:ue[G],isUnsafe:!0}}else se=O.slice();let ne;if(a.requiresPath){let ae;if((0,M.isString)(a.requiresPath)?ae=a.requiresPath:(ae=a.requiresPath.path,a.requiresPath.isUnsafe&&(ne=ae)),!await C.existsFile(ae))return}const ee=await n(i,p,se,C,k,U,a.env,a.overrideName,a.isAutoDetected,ne);if(!ee){D?.debug("Terminal profile not validated",i,O);return}return ee.isAutoDetected=a.isAutoDetected,ee.icon=q,ee.color=a.color,ee}function g(i){return typeof i=="string"?{id:i}:i}async function l(i){if(f&&!i)return;const[a,p]=await Promise.all([v(),i||E()]);f=new Map,f.set("Git Bash",{profileName:"Git Bash",paths:a,args:["--login","-i"]}),f.set("PowerShell",{profileName:"PowerShell",paths:p,icon:L.Codicon.terminalPowershell})}async function v(){const i=new Set,a=await(0,c.findExecutable)("git.exe");if(a){const k=(0,m.dirname)(a);i.add((0,m.resolve)(k,"../.."))}function p(k,D){D&&k.add(D)}p(i,process.env.ProgramW6432),p(i,process.env.ProgramFiles),p(i,process.env["ProgramFiles(X86)"]),p(i,`${process.env.LocalAppData}\\Program`);const C=[];for(const k of i)C.push(`${k}\\Git\\bin\\bash.exe`,`${k}\\Git\\usr\\bin\\bash.exe`,`${k}\\usr\\bin\\bash.exe`);return C.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),C}async function E(){const i=[];for await(const a of(0,h.enumeratePowerShellInstallations)())i.push(a.exePath);return i}async function S(i,a){const p=[],C=await new Promise((A,O)=>{P.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(U,q)=>{if(U)return O("Problem occurred when getting wsl distros");A(q)})});if(!C)return[];const k=new RegExp(/[\r?\n]/),D=C.split(k).filter(A=>A.trim().length>0&&A!=="");for(const A of D){if(A===""||A.startsWith("docker-desktop"))continue;const O=`${A} (WSL)`,U={profileName:O,path:i,args:["-d",`${A}`],isDefault:O===a,icon:t(A),isAutoDetected:!1};p.push(U)}return p}function t(i){return i.includes("Ubuntu")?L.Codicon.terminalUbuntu:i.includes("Debian")?L.Codicon.terminalDebian:L.Codicon.terminalLinux}async function u(i,a,p,C,k,D,A,O){const U=new Map;if(p){const q=(await i.readFile("/etc/shells")).toString(),se=(D||q.split(`
`)).map(ee=>{const ae=ee.indexOf("#");return ae===-1?ee:ee.substring(0,ae)}).filter(ee=>ee.trim().length>0),ne=new Map;for(const ee of se){let ae=(0,s.basename)(ee),ue=ne.get(ae)||0;ue++,ue>1&&(ae=`${ae} (${ue})`),ne.set(ae,ue),U.set(ae,{path:ee,isAutoDetected:!0})}}return r(C,U),await y(U.entries(),k,i,O,a,A)}function r(i,a){if(i)for(const[p,C]of Object.entries(i))C===null||typeof C!="object"||!("path"in C)&&!("source"in C)?a.delete(p):(C.icon=C.icon||a.get(p)?.icon,a.set(p,C))}async function n(i,a,p,C,k,D,A,O,U,q){if(p.length===0)return Promise.resolve(void 0);const se=p.shift();if(se==="")return n(i,a,p,C,k,D,A,O,U);const ne=typeof se!="string"&&se.isUnsafe,ee=typeof se=="string"?se:se.path,ae={profileName:i,path:ee,args:D,env:A,overrideName:O,isAutoDetected:U,isDefault:i===a,isUnsafePath:ne,requiresUnsafePath:q};if((0,s.basename)(ee)===ee){const G=k.PATH?k.PATH.split(s.delimiter):void 0,Y=await(0,c.findExecutable)(ee,void 0,G,void 0,C.existsFile);return Y?(ae.path=Y,ae.isFromPath=!0,ae):n(i,a,p,C,k,D)}return await C.existsFile((0,s.normalize)(ee))?ae:n(i,a,p,C,k,D,A,O,U)}}),define(te[261],ie([0,1,3,2,4,43,18,5,224,95,256,125,258,260,108,69]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var o;(function(l){l[l.MaxRestarts=5]="MaxRestarts"})(o||(o={}));let g=class extends L.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}get _optionalProxy(){return this.__proxy}_ensurePtyHost(){this.__connection||this._startPtyHost()}constructor(v,E,S,t){super(),this._ptyHostStarter=v,this._configurationService=E,this._logService=S,this._loggerService=t,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new P.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new P.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new P.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new P.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new P.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new P.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new P.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new P.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new P.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new P.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new P.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new P.Emitter),this.onProcessExit=this._onProcessExit.event,(0,w.registerTerminalPlatformConfiguration)(),this._register(this._ptyHostStarter),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new m.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),this._ptyHostStarter.onRequestConnection&&P.Event.once(this._ptyHostStarter.onRequestConnection)(()=>this._ensurePtyHost()),this._ptyHostStarter.onWillShutdown?.(()=>this._wasQuitRequested=!0)}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._optionalProxy?.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(s.isWindows)return process.env;try{return await(0,c.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(v){return this._logService.error("ptyHost was unable to resolve shell environment",v),{}}}_startPtyHost(){const v=this._ptyHostStarter.start(),E=v.client;this._logService.getLevel()===I.LogLevel.Trace&&this._logService.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),_.ProxyChannel.toService(E.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(!0),this._register(v.onDidProcessExit(u=>{this._onPtyHostExit.fire(u.code),!this._wasQuitRequested&&!this._isDisposed&&(this._restartCount<=o.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}, giving up`))}));const t=_.ProxyChannel.toService(E.getChannel(f.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(u=>this._onProcessData.fire(u))),this._register(t.onProcessReady(u=>this._onProcessReady.fire(u))),this._register(t.onProcessExit(u=>this._onProcessExit.fire(u))),this._register(t.onDidChangeProperty(u=>this._onDidChangeProperty.fire(u))),this._register(t.onProcessReplay(u=>this._onProcessReplay.fire(u))),this._register(t.onProcessOrphanQuestion(u=>this._onProcessOrphanQuestion.fire(u))),this._register(t.onDidRequestDetach(u=>this._onDidRequestDetach.fire(u))),this._register(new h.RemoteLoggerChannelClient(this._loggerService,E.getChannel(f.TerminalIpcChannels.Logger))),this.__connection=v,this.__proxy=t,this._onPtyHostStart.fire(),this._register(this._configurationService.onDidChangeConfiguration(async u=>{u.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[v,t]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(v,E,S,t,u,r,n,i,a,p,C){const k=setTimeout(()=>this._handleUnresponsiveCreateProcess(),f.HeartbeatConstants.CreateProcessTimeout),D=await this._proxy.createProcess(v,E,S,t,u,r,n,i,a,p,C);return clearTimeout(k),D}updateTitle(v,E,S){return this._proxy.updateTitle(v,E,S)}updateIcon(v,E,S,t){return this._proxy.updateIcon(v,E,S,t)}attachToProcess(v){return this._proxy.attachToProcess(v)}detachFromProcess(v,E){return this._proxy.detachFromProcess(v,E)}shutdownAll(){return this._proxy.shutdownAll()}listProcesses(){return this._proxy.listProcesses()}async getPerformanceMarks(){return this._optionalProxy?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this._optionalProxy?.reduceConnectionGraceTime()}start(v){return this._proxy.start(v)}shutdown(v,E){return this._proxy.shutdown(v,E)}input(v,E){return this._proxy.input(v,E)}processBinary(v,E){return this._proxy.processBinary(v,E)}resize(v,E,S){return this._proxy.resize(v,E,S)}clearBuffer(v){return this._proxy.clearBuffer(v)}acknowledgeDataEvent(v,E){return this._proxy.acknowledgeDataEvent(v,E)}setUnicodeVersion(v,E){return this._proxy.setUnicodeVersion(v,E)}getInitialCwd(v){return this._proxy.getInitialCwd(v)}getCwd(v){return this._proxy.getCwd(v)}async getLatency(){const v=new y.StopWatch,E=await this._proxy.getLatency();return v.stop(),[{label:"ptyhostservice<->ptyhost",latency:v.elapsed()},...E]}orphanQuestionReply(v){return this._proxy.orphanQuestionReply(v)}installAutoReply(v,E){return this._proxy.installAutoReply(v,E)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(v){return this._proxy.uninstallAutoReply(v)}getDefaultSystemShell(v){return this._optionalProxy?.getDefaultSystemShell(v)??(0,b.getSystemShell)(v??s.OS,process.env)}async getProfiles(v,E,S,t=!1){const u=await this._resolveShellEnv();return(0,d.detectAvailableProfiles)(E,S,t,this._configurationService,u,void 0,this._logService,this._resolveVariables.bind(this,v))}async getEnvironment(){return this.__proxy?this._proxy.getEnvironment():{...process.env}}getWslPath(v,E){return this._proxy.getWslPath(v,E)}getRevivedPtyNewId(v,E){return this._proxy.getRevivedPtyNewId(v,E)}setTerminalLayoutInfo(v){return this._proxy.setTerminalLayoutInfo(v)}async getTerminalLayoutInfo(v){return this._optionalProxy?.getTerminalLayoutInfo(v)}async requestDetachInstance(v,E){return this._proxy.requestDetachInstance(v,E)}async acceptDetachInstanceReply(v,E){return this._proxy.acceptDetachInstanceReply(v,E)}async freePortKillProcess(v){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(v)}async serializeTerminalState(v){return this._proxy.serializeTerminalState(v)}async reviveTerminalProcesses(v,E,S){return this._proxy.reviveTerminalProcesses(v,E,S)}async refreshProperty(v,E){return this._proxy.refreshProperty(v,E)}async updateProperty(v,E,S){return this._proxy.updateProperty(v,E,S)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll(),this._connection.store.dispose()}_handleHeartbeat(v){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),v?f.HeartbeatConstants.ConnectingBeatInterval:f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(v,E){return this._resolveVariablesRequestStore.createRequest({workspaceId:v,originalText:E})}async acceptPtyHostResolvedVariables(v,E){this._resolveVariablesRequestStore.acceptReply(v,E)}};e.PtyHostService=g,e.PtyHostService=g=Se([J(1,M.IConfigurationService),J(2,I.ILogService),J(3,I.ILoggerService)],g)}),define(te[80],ie([0,1,14,3,2,4,18,6,34]),function(j,e,P,L,s,_,M,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const c="#FFFFFF",m="#1E1E1E",f="#000000",w="#FFFFFF",d="theme",b="themeBackground",y="windowSplash";e.IThemeMainService=(0,I.createDecorator)("themeMainService");let o=class extends s.Disposable{constructor(l,v){super(),this.stateService=l,this.configurationService=v,this._onDidChangeColorScheme=this._register(new L.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,P.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(_.isWindows){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(_.isMacintosh){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(_.isLinux&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const l=this.getColorScheme();if(l.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return l.dark?f:w;let v=this.stateService.getItem(b,null);if(!v)switch(this.stateService.getItem(d,"vs-dark").split(" ")[0]){case"vs":v=c;break;case"hc-black":v=f;break;case"hc-light":v=w;break;default:v=m}return _.isMacintosh&&v.toUpperCase()===m&&(v="#171717"),v}saveWindowSplash(l,v){this.stateService.setItems([{key:d,data:v.baseTheme},{key:b,data:v.colorInfo.background},{key:y,data:v}]),typeof l=="number"&&this.updateBackgroundColor(l,v)}updateBackgroundColor(l,v){for(const E of P.BrowserWindow.getAllWindows())if(E.id===l){E.setBackgroundColor(v.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(y)}};e.ThemeMainService=o,e.ThemeMainService=o=Se([J(0,h.IStateService),J(1,M.IConfigurationService)],o)}),define(te[126],ie([0,1,3,18,6,5]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,s.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,s.createDecorator)("sharedTunnelsService");var M;(function(o){o.Http="http",o.Https="https"})(M||(e.TunnelProtocol=M={}));var I;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(I||(e.TunnelPrivacyId=I={}));function h(o){return!!o.forwardPort}e.isTunnelProvider=h;var c;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(c||(e.ProvidedOnAutoForward=c={}));function m(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function f(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.isLocalhost=f,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}e.isAllInterfaces=w;function d(o,g,l,v){if(l===1)return!1;if(l===2&&w(g)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(E?.length===4&&parseInt(E[1])>=18)return!1}return o<1024}e.isPortPrivileged=d;class b{constructor(g,l,v){this.remoteAddress=g,this.localAddress=l,this._dispose=v,this._onDispose=new P.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=b;let y=class{constructor(g,l){this.logService=g,this.configurationService=l,this._onTunnelOpened=new P.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new P.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new P.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this._tunnelProvider=g,g?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],l=Array.from(this._tunnels.values());for(const v of l){const E=Array.from(v.values());for(const S of E){const t=await S.value;t&&g.push(t)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:l}of g.values())await l.then(v=>v?.dispose());g.clear()}this._tunnels.clear()}setEnvironmentTunnel(g,l,v,E,S){this.addTunnelToMap(g,l,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:l,localAddress:v,privacy:E,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,l){(w(g)||f(g))&&(g=e.LOCALHOST_ADDRESSES[0]);const v=this.getTunnelFromMap(g,l);if(v)return++v.refcount,v.value}openTunnel(g,l,v,E,S,t=!1,u,r){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${v} on local port ${S}.`);const n=this._tunnelProvider??g;if(!n)return;if(l||(l="localhost"),E||(E=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.retainOrCreateTunnel(n,l,v,E,S,t,u,r);return i?i.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(l,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.makeTunnel(a);return(a.tunnelRemoteHost!==l||a.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),u&&a.privacy!==u&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(p),p}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const l=this._tunnels.get(g.tunnelRemoteHost);if(l){const v=l.get(g.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,v))}}}}async tryDisposeTunnel(g,l,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${l}.`);const E=v.value.then(async S=>{S&&(await S.dispose(!0),this._onTunnelClosed.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(l),E}}async closeTunnel(g,l){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${l} `);const v=this._tunnels.get(g);if(v&&v.has(l)){const E=v.get(l);E.refcount=0,await this.tryDisposeTunnel(g,l,E)}}addTunnelToMap(g,l,v){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(l,{refcount:1,value:v})}async removeEmptyTunnelFromMap(g,l){const v=this._tunnels.get(g);if(v){const E=v.get(l);(E?await E.value:void 0)||v.delete(l),v.size===0&&this._tunnels.delete(g)}}getTunnelFromMap(g,l){const v=[g];f(g)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):w(g)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const E=v.map(S=>this._tunnels.get(S));for(const S of E){const t=S?.get(l);if(t)return t}}canTunnel(g){return!!m(g)}createWithProvider(g,l,v,E,S,t,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${v} on local port ${E}.`);const r=v;this._factoryInProgress.add(r);const n=E===void 0?v:E,i={elevationRequired:S?this.isPortPrivileged(n):!1},a={remoteAddress:{host:l,port:v},localAddressPort:E,privacy:t,public:t?t!==I.Private:void 0,protocol:u},p=g.forwardPort(a,i);return p?(this.addTunnelToMap(l,v,p),p.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),p}};e.AbstractTunnelService=y,e.AbstractTunnelService=y=Se([J(0,_.ILogService),J(1,L.IConfigurationService)],y)}),define(te[262],ie([0,1,88,27,103,8,2,18,5,23,240,126,96,4,241]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(E,S,t,u,r){let n;for(let i=3;i&&(n?.dispose(),n=await new o(E,S,t,u,r).waitForReady(),!(r&&s.BROWSER_RESTRICTED_PORTS[r]||!s.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));i--);return n}class o extends M.Disposable{constructor(S,t,u,r,n){super(),this.defaultTunnelHost=t,this.suggestedLocalPort=n,this.privacy=f.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=S,this._server=P.createServer(),this._barrier=new _.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(t=>{t()})}async waitForReady(){const S=this.suggestedLocalPort??this.tunnelRemotePort,t=(0,f.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let u=await(0,s.findFreePortFaster)(S,2,1e3,t),r=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),r=this._server.address(),r||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),r=this._server.address()),this.tunnelLocalPort=r.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${r.port}`,this}async _onConnection(S){S.pause();const t=(0,f.isLocalhost)(this.tunnelRemoteHost)||(0,f.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,m.connectRemoteAgentTunnel)(this._options,t,this.tunnelRemotePort),r=u.getSocket().socket,n=u.readEntireBuffer();u.dispose(),n.byteLength>0&&S.write(n.buffer),S.on("end",()=>{S.localAddress&&this._socketsDispose.delete(S.localAddress),r.end()}),S.on("close",()=>r.end()),S.on("error",()=>{S.localAddress&&this._socketsDispose.delete(S.localAddress),r.destroy()}),r.on("end",()=>S.end()),r.on("close",()=>S.end()),r.on("error",()=>{S.destroy()}),S.pipe(r),r.pipe(S),S.localAddress&&this._socketsDispose.set(S.localAddress,()=>{S.end(),r.end()})}}let g=class extends f.AbstractTunnelService{constructor(S,t,u,r,n){super(t,n),this.remoteSocketFactoryService=S,this.signService=u,this.productService=r}isPortPrivileged(S){return(0,f.isPortPrivileged)(S,this.defaultTunnelHost,d.OS,L.release())}retainOrCreateTunnel(S,t,u,r,n,i,a,p){const C=this.getTunnelFromMap(t,u);if(C)return++C.refcount,C.value;if((0,f.isTunnelProvider)(S))return this.createWithProvider(S,t,u,n,i,a,p);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${u} on local port ${n}.`);const k={commit:this.productService.commit,quality:this.productService.quality,addressProvider:S,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},D=y(k,r,t,u,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(t,u,D),D}}};e.BaseTunnelService=g,e.BaseTunnelService=g=Se([J(0,b.IRemoteSocketFactoryService),J(1,h.ILogService),J(2,w.ISignService),J(3,c.IProductService),J(4,I.IConfigurationService)],g);let l=class extends g{constructor(S,t,u,r,n){super(S,t,u,r,n)}};e.TunnelService=l,e.TunnelService=l=Se([J(0,b.IRemoteSocketFactoryService),J(1,h.ILogService),J(2,w.ISignService),J(3,c.IProductService),J(4,I.IConfigurationService)],l);let v=class extends M.Disposable{constructor(S,t,u,r,n){super(),this.remoteSocketFactoryService=S,this.logService=t,this.productService=u,this.signService=r,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(S,t,u,r,n,i,a,p,C){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${r} on local port ${i}.`),!this._tunnelServices.has(S)){const k=new l(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(k),this._tunnelServices.set(S,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this._tunnelServices.delete(S))})}return this._tunnelServices.get(S).openTunnel(t,u,r,n,i,a,p,C)}};e.SharedTunnelsService=v,e.SharedTunnelsService=v=Se([J(0,b.IRemoteSocketFactoryService),J(1,h.ILogService),J(2,c.IProductService),J(3,w.ISignService),J(4,I.IConfigurationService)],v)}),define(te[48],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.DisablementReason=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.Disabled="disabled",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L||(e.StateType=L={}));var s;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap",M[M.WindowsInstaller=3]="WindowsInstaller"})(s||(e.UpdateType=s={}));var _;(function(M){M[M.NotBuilt=0]="NotBuilt",M[M.DisabledByEnvironment=1]="DisabledByEnvironment",M[M.ManuallyDisabled=2]="ManuallyDisabled",M[M.MissingConfiguration=3]="MissingConfiguration",M[M.InvalidConfiguration=4]="InvalidConfiguration",M[M.RunningAsAdmin=5]="RunningAsAdmin"})(_||(e.DisablementReason=_={})),e.State={Uninitialized:{type:"uninitialized"},Disabled:M=>({type:"disabled",reason:M}),Idle:(M,I)=>({type:"idle",updateType:M,error:I}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,P.createDecorator)("updateService")}),define(te[263],ie([0,1,4,186,59,44]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),_.Registry.as(s.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:P.isWindows&&!P.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[264],ie([0,1,3,48]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class s{constructor(I){this.service=I}listen(I,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(I,h,c){switch(h){case"checkForUpdates":return this.service.checkForUpdates(c);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(c)}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=s;class _{get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}constructor(I){this.channel=I,this._onStateChange=new P.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(I){return this.channel.call("_applySpecificUpdate",I)}}e.UpdateChannelClient=_}),define(te[40],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,P.createDecorator)("IUriIdentityService")}),define(te[265],ie([0,1,40,205,16,19,139,3,2]),function(j,e,P,L,s,_,M,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{static{this._clock=0}constructor(w){this.uri=w,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let m=class{constructor(w){this._fileService=w,this._dispooables=new h.DisposableStore,this._limit=2**16;const d=new Map,b=y=>{let o=d.get(y.scheme);return o===void 0&&(o=w.hasProvider(y)&&!this._fileService.hasCapability(y,1024),d.set(y.scheme,o)),o};this._dispooables.add(I.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(y=>{d.delete(y.scheme)})),this.extUri=new _.ExtUri(b),this._canonicalUris=new M.SkipList((y,o)=>this.extUri.compare(y,o,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(w){this._fileService.hasProvider(w)&&(w=(0,_.normalizePath)(w));const d=this._canonicalUris.get(w);return d?d.touch().uri.with({fragment:w.fragment}):(this._canonicalUris.set(w,new c(w)),this._checkTrim(),w)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const w=[...this._canonicalUris.entries()].sort((b,y)=>b[1].time<y[1].time?1:b[1].time>y[1].time?-1:0);c._clock=0,this._canonicalUris.clear();const d=this._limit*.5;for(let b=0;b<d;b++)this._canonicalUris.set(w[b][0],w[b][1].touch())}};e.UriIdentityService=m,e.UriIdentityService=m=Se([J(0,s.IFileService)],m),(0,L.registerSingleton)(P.IUriIdentityService,m,1)}),define(te[127],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,P.createDecorator)("urlService")}),define(te[266],ie([0,1,7]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(I){this.handler=I}listen(I,h){throw new Error(`Event not found: ${h}`)}call(I,h,c){switch(h){case"handleURL":return this.handler.handleURL(P.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=L;class s{constructor(I){this.channel=I}handleURL(I,h){return this.channel.call("handleURL",[I.toJSON(),h])}}e.URLHandlerChannelClient=s;class _{constructor(I,h){this.next=I,this.logService=h}async routeCall(I,h,c,m){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(c)&&c.length>0){const f=P.URI.revive(c[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",f.toString(!0)),f.query){const w=/\bwindowId=(\d+)/.exec(f.query);if(w){const d=w[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${d}"`,f.toString(!0));const b=new RegExp(`window:${d}`),y=I.connections.find(o=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",o.ctx),b.test(o.ctx)));if(y)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",f.toString(!0)),y;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",f.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",f.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(I,h,c,m)}routeEvent(I,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=_}),define(te[267],ie([0,1,8,2,7,23]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends L.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(c,m){const f=[...this.handlers.values()];return(0,P.first)(f.map(w=>()=>w.handleURL(c,m)),void 0,!1).then(w=>w||!1)}registerHandler(c){return this.handlers.add(c),(0,L.toDisposable)(()=>this.handlers.delete(c))}}e.AbstractURLService=M;let I=class extends M{constructor(c){super(),this.productService=c}create(c){let{authority:m,path:f,query:w,fragment:d}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&f&&f.indexOf("/")!==0&&(f=`/${f}`),s.URI.from({scheme:this.productService.urlProtocol,authority:m,path:f,query:w,fragment:d})}};e.NativeURLService=I,e.NativeURLService=I=Se([J(0,_.IProductService)],I)}),define(te[268],ie([0,1,14,8,3,2,4,7]),function(j,e,P,L,s,_,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class h{constructor(m,f,w,d,b,y){if(this.urlService=f,this.logService=y,this.uris=[],this.retryCount=0,this.flushDisposable=_.Disposable.None,this.disposables=new _.DisposableStore,m&&(y.trace("ElectronURLListener initialUrisToHandle:",m.map(l=>l.originalUrl)),this.uris=m),M.isWindows){const l=d.isBuilt?[]:[`"${d.appRoot}"`];l.push("--open-url","--"),P.app.setAsDefaultProtocolClient(b.urlProtocol,process.execPath,l)}const o=s.Event.map(s.Event.fromNodeEventEmitter(P.app,"open-url",(l,v)=>({event:l,url:v})),({event:l,url:v})=>(l.preventDefault(),v));this.disposables.add(o(l=>{const v=this.uriFromRawUrl(l);v&&this.urlService.open(v,{originalUrl:l})})),w.getWindows().filter(l=>l.isReady).length>0?(y.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(y.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),s.Event.once(w.onDidSignalReadyWindow)(this.flush,this,this.disposables))}uriFromRawUrl(m){try{return I.URI.parse(m)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const f of this.uris)await this.urlService.open(f.uri,{originalUrl:f.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",f.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",f.originalUrl),m.push(f));m.length!==0&&(this.uris=m,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=h}),define(te[269],ie([0,1,3,2,16,56,58,17]),function(j,e,P,L,s,_,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class h extends L.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(m,f,w,d){super(),this.fileSystemScheme=m,this.fileSystemProvider=f,this.userDataScheme=w,this.logService=d,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=M.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(b=>this.handleFileChanges(b)))}watch(m,f){this.watchResources.set(m,m);const w=this.fileSystemProvider.watch(this.toFileSystemResource(m),f);return(0,L.toDisposable)(()=>{this.watchResources.delete(m),w.dispose()})}stat(m){return this.fileSystemProvider.stat(this.toFileSystemResource(m))}mkdir(m){return this.fileSystemProvider.mkdir(this.toFileSystemResource(m))}rename(m,f,w){return this.fileSystemProvider.rename(this.toFileSystemResource(m),this.toFileSystemResource(f),w)}readFile(m){return this.fileSystemProvider.readFile(this.toFileSystemResource(m),{atomic:!0})}readFileStream(m,f,w){const d=(0,_.newWriteableStream)(b=>I.VSBuffer.concat(b.map(y=>I.VSBuffer.wrap(y))).buffer);return(async()=>{try{const b=await this.readFile(m);d.end(b)}catch(b){d.error(b),d.end()}})(),d}readdir(m){return this.fileSystemProvider.readdir(this.toFileSystemResource(m))}writeFile(m,f,w){return this.fileSystemProvider.writeFile(this.toFileSystemResource(m),f,w)}delete(m,f){return this.fileSystemProvider.delete(this.toFileSystemResource(m),f)}copy(m,f,w){if((0,s.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(m),this.toFileSystemResource(f),w);throw new Error("copy not supported")}handleFileChanges(m){const f=[];for(const w of m){if(w.resource.scheme!==this.fileSystemScheme)continue;const d=this.toUserDataResource(w.resource);this.watchResources.findSubstr(d)&&f.push({resource:d,type:w.type})}f.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(f))}toFileSystemResource(m){return m.with({scheme:this.fileSystemScheme})}toUserDataResource(m){return m.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=h}),define(te[270],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(te[271],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,P.createDecorator)("webviewManagerService")}),define(te[272],ie([0,1,14,2,15,7]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends L.Disposable{static{this.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.handleWebviewRequest.bind(this);P.protocol.registerFileProtocol(s.Schemas.vscodeWebview,h)}handleWebviewRequest(h,c){try{const m=_.URI.parse(h.url),f=M.validWebviewFilePaths.get(m.path);if(typeof f=="string"){const w=`vs/workbench/contrib/webview/browser/pre/${f}`,d=s.FileAccess.asFileUri(w);return c({path:d.fsPath,headers:{...s.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.WebviewProtocolProvider=M}),define(te[81],ie([0,1,4]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(m){return!!m.workspaceUri}e.isWorkspaceToOpen=L;function s(m){return!!m.folderUri}e.isFolderToOpen=s;function _(m){return!!m.fileUri}e.isFileToOpen=_;function M(m){const f=I(m),w=m.getValue("window.menuBarVisibility");return w==="default"||f==="native"&&w==="compact"||P.isMacintosh&&P.isNative?"classic":w}e.getMenuBarVisibility=M;function I(m){if(P.isWeb)return"custom";const f=m.getValue("window");if(f){if(P.isMacintosh&&f.nativeTabs===!0||P.isMacintosh&&f.nativeFullScreen===!1)return"native";const b=f.titleBarStyle;if(b==="native"||b==="custom")return b}return P.isLinux?"native":"custom"}e.getTitleBarStyle=I;function h(m){if(!P.isWindows||P.isWeb||I(m)==="native")return!1;const f=m.getValue("window.experimental.windowControlsOverlay.enabled");return typeof f=="boolean"?f:!0}e.useWindowControlsOverlay=h;function c(m=0){return Math.pow(1.2,m)}e.zoomLevelToZoomFactor=c}),define(te[128],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var P;(function(I){I[I.INITIAL=1]="INITIAL",I[I.LOAD=2]="LOAD",I[I.RELOAD=3]="RELOAD"})(P||(e.LoadReason=P={}));var L;(function(I){I[I.CLOSE=1]="CLOSE",I[I.QUIT=2]="QUIT",I[I.RELOAD=3]="RELOAD",I[I.LOAD=4]="LOAD"})(L||(e.UnloadReason=L={}));const s=function(I=1){return{width:1024,height:768,mode:I}};e.defaultWindowState=s;var _;(function(I){I[I.Maximized=0]="Maximized",I[I.Normal=1]="Normal",I[I.Minimized=2]="Minimized",I[I.Fullscreen=3]="Fullscreen"})(_||(e.WindowMode=_={}));var M;(function(I){I[I.UNRESPONSIVE=1]="UNRESPONSIVE",I[I.PROCESS_GONE=2]="PROCESS_GONE",I[I.LOAD=3]="LOAD"})(M||(e.WindowError=M={}))}),define(te[29],ie([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,P.createDecorator)("windowsMainService");var L;(function(s){s[s.CLI=0]="CLI",s[s.DOCK=1]="DOCK",s[s.MENU=2]="MENU",s[s.DIALOG=3]="DIALOG",s[s.DESKTOP=4]="DESKTOP",s[s.API=5]="API"})(L||(e.OpenContext=L={}))}),define(te[273],ie([0,1,76,5,33,23,29,217]),function(j,e,P,L,s,_,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let h=class extends I.BaseCredentialsMainService{constructor(m,f,w,d){super(m),this.environmentMainService=f,this.productService=w,this.windowsMainService=d,this.surfaceKeytarLoadError=b=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",b.message??b)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new P.InMemoryCredentialsProvider,this._keytarCache;const m=await new Promise((f,w)=>{j(["keytar"],f,w)});return await m.findCredentials("test-keytar-loads"),this._keytarCache=m,this._keytarCache}};e.CredentialsNativeMainService=h,e.CredentialsNativeMainService=h=Se([J(0,L.ILogService),J(1,s.INativeEnvironmentService),J(2,_.IProductService),J(3,M.IWindowsMainService)],h)}),define(te[274],ie([0,1,14,24,4,7,22,18,63,6,5,127,29]),function(j,e,P,L,s,_,M,I,h,c,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,c.createDecorator)(e.ID);let d=class{constructor(y,o,g,l){this.logService=y,this.windowsMainService=o,this.urlService=g,this.configurationService=l}async start(y,o){this.logService.trace("Received data from other instance: ",y,o),s.isMacintosh&&P.app.focus({steal:!0});const g=this.parseOpenUrl(y);if(g.length){let l=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const v=(0,L.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));v&&(l=v.ready())}l.then(()=>{for(const{uri:v,originalUrl:E}of g)this.urlService.open(v,{originalUrl:E})})}else return this.startOpenWindow(y,o)}parseOpenUrl(y){return y["open-url"]&&y._urls&&y._urls.length>0?(0,L.coalesce)(y._urls.map(o=>{try{return{uri:_.URI.parse(o),originalUrl:o}}catch{return null}})):[]}async startOpenWindow(y,o){const g=(0,h.isLaunchedFromCli)(o)?0:4;let l=[];const v=y.wait&&y.waitMarkerFilePath?_.URI.file(y.waitMarkerFilePath):void 0,E=y.remote||void 0,S={context:g,cli:y,userEnv:o,waitMarkerFileURI:v,remoteAuthority:E,forceProfile:y.profile,forceTempProfile:y["profile-temp"]};if(y.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(y.extensionDevelopmentPath,S);else if(!y._.length&&!y["folder-uri"]&&!y["file-uri"]){let t=!1;if(y["new-window"]||y["unity-launch"]||S.forceProfile||S.forceTempProfile)t=!0;else if(y["reuse-window"])t=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.isMacintosh}if(t)l=await this.windowsMainService.open({...S,forceNewWindow:!0,forceEmpty:!0});else{const u=this.windowsMainService.getLastActiveWindow();u?(this.windowsMainService.openExistingWindow(u,S),l=[u]):l=await this.windowsMainService.open({...S,forceEmpty:!0})}}else l=await this.windowsMainService.open({...S,forceNewWindow:y["new-window"],preferNewWindow:!y["reuse-window"]&&!y.wait,forceReuseWindow:y["reuse-window"],diffMode:y.diff,mergeMode:y.merge,addMode:y.add,noRecentEntry:!!y["skip-add-to-recently-opened"],gotoLineMode:y.goto});if(v&&l.length===1&&l[0])return Promise.race([l[0].whenClosedOrLoaded,(0,M.whenDeleted)(v.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=d,e.LaunchMainService=d=Se([J(0,m.ILogService),J(1,w.IWindowsMainService),J(2,f.IURLService),J(3,I.IConfigurationService)],d)}),define(te[275],ie([0,1,14,3,2,272,29]),function(j,e,P,L,s,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends s.Disposable{constructor(c){super(),this.windowsMainService=c,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new _.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(c,m){let f;if(typeof c.windowId=="number"){const{windowId:w}=c,d=this.windowsMainService.getWindowById(w);if(!d?.win)throw new Error(`Invalid windowId: ${w}`);f=d.win.webContents}else{const{webContentsId:w}=c;if(f=P.webContents.fromId(w),!f)throw new Error(`Invalid webContentsId: ${w}`)}f.isDestroyed()||f.setIgnoreMenuShortcuts(m)}async findInFrame(c,m,f,w){const b=this.getFrameByName(c,m);if(typeof b.findInFrame=="function"){b.findInFrame(f,{findNext:w.findNext,forward:w.forward});const y=(o,g)=>{g.finalUpdate&&(this._onFoundInFrame.fire(g),b.removeListener("found-in-frame",y))};b.on("found-in-frame",y)}}async stopFindInFrame(c,m,f){const d=this.getFrameByName(c,m);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(f.keepSelection?"keepSelection":"clearSelection")}getFrameByName(c,m){const f=this.windowsMainService.getWindowById(c.windowId);if(!f?.win)throw new Error(`Invalid windowId: ${c}`);const w=f.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===m);if(!w)throw new Error(`Unknown frame: ${m}`);return w}};e.WebviewMainService=I,e.WebviewMainService=I=Se([J(0,M.IWindowsMainService)],I)}),define(te[276],ie([0,1,8,3,2]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class _ extends s.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:h,getActiveWindowId:c}){super(),this.disposables=this._register(new s.DisposableStore),L.Event.latch(L.Event.any(I,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,P.createCancelablePromise)(()=>c()),(async()=>{try{const f=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:f}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=_}),define(te[30],ie([0,1,190,9,58,19,7,6,15]),function(j,e,P,L,s,_,M,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function c(n){const i=n;return typeof i?.id=="string"&&M.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=c;function m(n){return typeof n?.id=="string"&&!c(n)&&!w(n)}e.isEmptyWorkspaceIdentifier=m,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function f(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,L.basename)(n)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const a=n;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.toWorkspaceIdentifier=f;function w(n){const i=n;return typeof i?.id=="string"&&M.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=w;function d(n){const i=n;if(i?.uri)return{id:i.id,uri:M.URI.revive(i.uri)};const a=n;if(a?.configPath)return{id:a.id,configPath:M.URI.revive(a.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=d;var b;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function y(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=y;function o(n){const i=n;return!!(i&&typeof i=="object"&&M.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=o;class g{constructor(i,a,p,C,k){this._id=i,this._transient=p,this._configuration=C,this._ignorePathCasing=k,this._foldersMap=s.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=a}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=s.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class l{constructor(i,a){this.raw=a,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,_.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function v(n){return new l({uri:n,index:0,name:(0,_.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(n,i){return _.extUriBiasedIgnorePathCase.isEqualOrParent(n,i.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function S(n){let i;return M.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=S,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function u(n,i){return!E(n,i)&&!S(n)}e.isSavedWorkspace=u;function r(n){return(typeof n=="string"?(0,L.extname)(n):(0,_.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(te[61],ie([0,1,14,8,57,46,2,86,4,10,22,165,92,6,5,23,30]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,d.createDecorator)("dialogMainService");let g=class{constructor(v,E){this.logService=v,this.productService=E,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(v,E){return this.doPick({...v,pickFolders:!0,pickFiles:!0,title:(0,f.localize)(0,null)},E)}pickFolder(v,E){return this.doPick({...v,pickFolders:!0,title:(0,f.localize)(1,null)},E)}pickFile(v,E){return this.doPick({...v,pickFiles:!0,title:(0,f.localize)(2,null)},E)}pickWorkspace(v,E){const S=(0,f.localize)(3,null),t=(0,_.mnemonicButtonLabel)((0,f.localize)(4,null)),u=o.WORKSPACE_FILTER;return this.doPick({...v,pickFiles:!0,title:S,filters:u,buttonLabel:t},E)}async doPick(v,E){const S={title:v.title,buttonLabel:v.buttonLabel,filters:v.filters,defaultPath:v.defaultPath};(typeof v.pickFiles=="boolean"||typeof v.pickFolders=="boolean")&&(S.properties=void 0,v.pickFiles&&v.pickFolders&&(S.properties=["multiSelections","openDirectory","openFile","createDirectory"])),S.properties||(S.properties=["multiSelections",v.pickFolders?"openDirectory":"openFile","createDirectory"]),h.isMacintosh&&S.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(S,(0,c.withNullAsUndefined)(E||P.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}getWindowDialogQueue(v){if(v){let E=this.windowDialogQueues.get(v.id);return E||(E=new L.Queue,this.windowDialogQueues.set(v.id,E)),E}else return this.noWindowDialogueQueue}showMessageBox(v,E){return this.getWindowDialogQueue(E).queue(async()=>{const{options:S,buttonIndeces:t}=(0,w.massageMessageBoxOptions)(v,this.productService);let u;return E?u=await P.dialog.showMessageBox(E,S):u=await P.dialog.showMessageBox(S),{response:t[u.response],checkboxChecked:u.checkboxChecked}})}async showSaveDialog(v,E){const S=this.acquireFileDialogLock(v,E);if(!S)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(E).queue(async()=>{let t;return E?t=await P.dialog.showSaveDialog(E,v):t=await P.dialog.showSaveDialog(v),t.filePath=this.normalizePath(t.filePath),t})}finally{(0,M.dispose)(S)}}normalizePath(v){return v&&h.isMacintosh&&(v=(0,I.normalizeNFC)(v)),v}normalizePaths(v){return v.map(E=>this.normalizePath(E))}async showOpenDialog(v,E){v.defaultPath&&(await m.Promises.exists(v.defaultPath)||(v.defaultPath=void 0));const S=this.acquireFileDialogLock(v,E);if(!S)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(E).queue(async()=>{let t;return E?t=await P.dialog.showOpenDialog(E,v):t=await P.dialog.showOpenDialog(v),t.filePaths=this.normalizePaths(t.filePaths),t})}finally{(0,M.dispose)(S)}}acquireFileDialogLock(v,E){if(!E)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",v);let S=this.windowFileDialogLocks.get(E.id);S||(S=new Set,this.windowFileDialogLocks.set(E.id,S));const t=(0,s.hash)(v);if(!S.has(t))return this.logService.trace("[DialogMainService]: new file dialog lock created",v),S.add(t),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",v),S?.delete(t),S?.size===0&&this.windowFileDialogLocks.delete(E.id)})}};e.DialogMainService=g,e.DialogMainService=g=Se([J(0,b.ILogService),J(1,y.IProductService)],g)}),define(te[277],ie([0,1,3,2,74,30]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{static{this.STORAGE_CHANGE_DEBOUNCE_TIME=100}constructor(h,c){super(),this.logService=h,this.storageMainService=c,this.onDidChangeApplicationStorageEmitter=this._register(new P.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(c.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(h,c){this._register(P.Event.debounce(h.onDidChangeStorage,(m,f)=>(m?m.push(f):m=[f],m),M.STORAGE_CHANGE_DEBOUNCE_TIME)(m=>{m.length&&c.fire(this.serializeStorageChangeEvents(m,h))}))}serializeStorageChangeEvents(h,c){const m=new Map,f=new Set;return h.forEach(w=>{const d=c.get(w.key);typeof d=="string"?m.set(w.key,d):f.add(w.key)}),{changed:Array.from(m.entries()),deleted:Array.from(f.values())}}listen(h,c,m){switch(c){case"onDidChangeStorage":{const f=m.profile?(0,s.revive)(m.profile):void 0;if(!f)return this.onDidChangeApplicationStorageEmitter.event;let w=this.mapProfileToOnDidChangeProfileStorageEmitter.get(f.id);return w||(w=this._register(new P.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(f),w),this.mapProfileToOnDidChangeProfileStorageEmitter.set(f.id,w)),w.event}}throw new Error(`Event not found: ${c}`)}async call(h,c,m){const f=m.profile?(0,s.revive)(m.profile):void 0,w=(0,_.reviveIdentifier)(m.workspace),d=await this.withStorageInitialized(f,w);switch(c){case"getItems":return Array.from(d.items.entries());case"updateItems":{const b=m;if(b.insert)for(const[y,o]of b.insert)d.set(y,o);b.delete?.forEach(y=>d.delete(y));break}case"isUsed":{const b=m.payload;if(typeof b=="string")return this.storageMainService.isUsed(b)}default:throw new Error(`Call not found: ${c}`)}}async withStorageInitialized(h,c){let m;c?m=this.storageMainService.workspaceStorage(c):h?m=this.storageMainService.profileStorage(h):m=this.storageMainService.applicationStorage;try{await m.init()}catch(f){this.logService.error(`StorageIPC#init: Unable to init ${c?"workspace":h?"profile":"application"} storage due to ${f}`)}return m}}e.StorageDatabaseChannel=M}),define(te[41],ie([0,1,57,3,2,19,7,187,33,16,6,5,30,35,40,8,31,25,10]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var v;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(v||(e.ProfileResourceType=v={}));function E(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&M.URI.isUri(i.location)&&M.URI.isUri(i.globalStorageHome)&&M.URI.isUri(i.settingsResource)&&M.URI.isUri(i.keybindingsResource)&&M.URI.isUri(i.tasksResource)&&M.URI.isUri(i.snippetsHome)&&M.URI.isUri(i.extensionsResource))}e.isUserDataProfile=E,e.IUserDataProfilesService=(0,m.createDecorator)("IUserDataProfilesService");function S(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:M.URI.revive(n.location).with({scheme:i}),globalStorageHome:M.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:M.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:M.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:M.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:M.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:M.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:M.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=S;function t(n,i,a,p,C,k){return{id:n,name:i,location:a,isDefault:!1,shortName:C?.shortName,globalStorageHome:k&&C?.useDefaultFlags?.globalState?k.globalStorageHome:(0,_.joinPath)(a,"globalStorage"),settingsResource:k&&C?.useDefaultFlags?.settings?k.settingsResource:(0,_.joinPath)(a,"settings.json"),keybindingsResource:k&&C?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,_.joinPath)(a,"keybindings.json"),tasksResource:k&&C?.useDefaultFlags?.tasks?k.tasksResource:(0,_.joinPath)(a,"tasks.json"),snippetsHome:k&&C?.useDefaultFlags?.snippets?k.snippetsHome:(0,_.joinPath)(a,"snippets"),extensionsResource:k&&C?.useDefaultFlags?.extensions?k.extensionsResource:(0,_.joinPath)(a,"extensions.json"),cacheHome:(0,_.joinPath)(p,n),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}e.toUserDataProfile=t;let u=class extends s.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,a,p,C){super(),this.environmentService=i,this.fileService=a,this.uriIdentityService=p,this.logService=C,this.enabled=!0,this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new L.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new L.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new L.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,_.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,_.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const i=this.createDefaultProfile(),a=[i];if(this.enabled)try{for(const k of this.getStoredProfiles()){if(!k.name||!(0,l.isString)(k.name)||!k.location){this.logService.warn("Skipping the invalid stored profile",k.location||k.name);continue}a.push(t((0,_.basename)(k.location),k.name,k.location,this.profilesCacheHome,{shortName:k.shortName,useDefaultFlags:k.useDefaultFlags},i))}}catch(k){this.logService.error(k)}const p=new d.ResourceMap,C=new Map;if(a.length)try{const k=this.getStoredProfileAssociations();if(k.workspaces)for(const[D,A]of Object.entries(k.workspaces)){const O=M.URI.parse(D),U=a.find(q=>q.id===A);U&&p.set(O,U)}if(k.emptyWindows)for(const[D,A]of Object.entries(k.emptyWindows)){const O=a.find(U=>U.id===A);O&&C.set(D,O)}}catch(k){this.logService.error(k)}this._profilesObject={profiles:a,workspaces:p,emptyWindows:C}}return this._profilesObject}createDefaultProfile(){const i=t("__default__profile__",(0,I.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...i,extensionsResource:this.getDefaultProfileExtensionsLocation()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const a="Temp",p=new RegExp(`${(0,g.escapeRegExpCharacters)(a)}\\s(\\d+)`);let C=0;for(const D of this.profiles){const A=p.exec(D.name),O=A?parseInt(A[1]):0;C=O>C?O:C}const k=`${a} ${C+1}`;return this.createProfile((0,P.hash)((0,o.generateUuid)()).toString(16),k,{transient:!0},i)}async createNamedProfile(i,a,p){return this.createProfile((0,P.hash)((0,o.generateUuid)()).toString(16),i,a,p)}async createProfile(i,a,p,C){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const k=await this.doCreateProfile(i,a,p);return C&&await this.setProfileForWorkspace(C,k),k}async doCreateProfile(i,a,p){if(!(0,l.isString)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.profileCreationPromises.get(a);return C||(C=(async()=>{try{const k=this.profiles.find(O=>O.name===a||O.id===i);if(k)return k;const D=t(i,a,(0,_.joinPath)(this.profilesHome,i),this.profilesCacheHome,p,this.defaultProfile);await this.fileService.createFolder(D.location);const A=[];return this._onWillCreateProfile.fire({profile:D,join(O){A.push(O)}}),await y.Promises.settled(A),this.updateProfiles([D],[],[]),D}finally{this.profileCreationPromises.delete(a)}})(),this.profileCreationPromises.set(a,C)),C}async updateProfile(i,a){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(C=>C.id===i.id);if(!p)throw new Error(`Profile '${i.name}' does not exist`);return p=t(p.id,a.name??p.name,p.location,this.profilesCacheHome,{shortName:a.shortName??p.shortName,transient:a.transient??p.isTransient,useDefaultFlags:a.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[p]),p}async removeProfile(i){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(C=>C.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);const p=[];this._onWillRemoveProfile.fire({profile:a,join(C){p.push(C)}});try{await Promise.allSettled(p)}catch(C){this.logService.error(C)}for(const C of[...this.profilesObject.emptyWindows.keys()])a.id===this.profilesObject.emptyWindows.get(C)?.id&&this.profilesObject.emptyWindows.delete(C);for(const C of[...this.profilesObject.workspaces.keys()])a.id===this.profilesObject.workspaces.get(C)?.id&&this.profilesObject.workspaces.delete(C);this.updateStoredProfileAssociations(),this.updateProfiles([],[a],[]);try{await this.fileService.del(a.cacheHome,{recursive:!0})}catch(C){(0,c.toFileOperationResult)(C)!==1&&this.logService.error(C)}}async setProfileForWorkspace(i,a){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(C=>C.id===a.id);if(!p)throw new Error(`Profile '${a.name}' does not exist`);this.updateWorkspaceAssociation(i,p)}unsetWorkspace(i,a){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(i,void 0,a)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(a=>a.isDirectory&&this.profiles.every(p=>!this.uriIdentityService.extUri.isEqual(p.location,a.resource))).map(a=>this.fileService.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(a=>!this.isProfileAssociatedToWorkspace(a));await Promise.allSettled(i.map(a=>this.removeProfile(a)))}getProfileForWorkspace(i){const a=this.getWorkspace(i);return M.URI.isUri(a)?this.transientProfilesObject.workspaces.get(a)??this.profilesObject.workspaces.get(a):this.transientProfilesObject.emptyWindows.get(a)??this.profilesObject.emptyWindows.get(a)}getWorkspace(i){return(0,w.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,w.isWorkspaceIdentifier)(i)?i.configPath:i.id}isProfileAssociatedToWorkspace(i){return!!([...this.transientProfilesObject.emptyWindows.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,i.location))||[...this.transientProfilesObject.workspaces.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,i.location))||[...this.profilesObject.emptyWindows.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,i.location))||[...this.profilesObject.workspaces.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,i.location)))}updateProfiles(i,a,p){const C=[...this.profiles,...i],k=[];this.transientProfilesObject.profiles=[];for(let D of C)D.isDefault||a.some(A=>D.id===A.id)||(D=p.find(A=>D.id===A.id)??D,D.isTransient?this.transientProfilesObject.profiles.push(D):k.push({location:D.location,name:D.name,shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}));this.saveStoredProfiles(k),this._profilesObject=void 0,this.triggerProfilesChanges(i,a,p)}triggerProfilesChanges(i,a,p){this._onDidChangeProfiles.fire({added:i,removed:a,updated:p,all:this.profiles})}updateWorkspaceAssociation(i,a,p){p=a?.isTransient?!0:p,p||this.updateWorkspaceAssociation(i,void 0,!0);const C=this.getWorkspace(i),k=p?this.transientProfilesObject:this.profilesObject;M.URI.isUri(C)?(k.workspaces.delete(C),a&&k.workspaces.set(C,a)):(k.emptyWindows.delete(C),a&&k.emptyWindows.set(C,a)),p||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[p,C]of this.profilesObject.workspaces.entries())i[p.toString()]=C.id;const a={};for(const[p,C]of this.profilesObject.emptyWindows.entries())a[p.toString()]=C.id;this.saveStoredProfileAssociations({workspaces:i,emptyWindows:a}),this._profilesObject=void 0}migrateStoredProfileAssociations(i){const a={},p=this.createDefaultProfile();if(i.workspaces)for(const[k,D]of Object.entries(i.workspaces)){const A=M.URI.parse(D);a[k]=this.uriIdentityService.extUri.isEqual(A,p.location)?p.id:this.uriIdentityService.extUri.basename(A)}const C={};if(i.emptyWindows)for(const[k,D]of Object.entries(i.emptyWindows)){const A=M.URI.parse(D);C[k]=this.uriIdentityService.extUri.isEqual(A,p.location)?p.id:this.uriIdentityService.extUri.basename(A)}return{workspaces:a,emptyWindows:C}}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=u,e.UserDataProfilesService=u=Se([J(0,h.IEnvironmentService),J(1,c.IFileService),J(2,b.IUriIdentityService),J(3,f.ILogService)],u);class r extends u{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=r}),define(te[82],ie([0,1,8,17,2,3,35,7,116,123,16,6,5,41,40,10,13,26]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var l;(function(u){u.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",u.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(l||(e.ExtensionsProfileScanningErrorCode=l={}));class v extends Error{constructor(r,n){super(r),this.code=n}}e.ExtensionsProfileScanningError=v,e.IExtensionsProfileScannerService=(0,f.createDecorator)("IExtensionsProfileScannerService");let E=class extends s.Disposable{constructor(r,n,i,a,p,C){super(),this.extensionsLocation=r,this.fileService=n,this.userDataProfilesService=i,this.uriIdentityService=a,this.telemetryService=p,this.logService=C,this._onAddExtensions=this._register(new _.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new _.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new _.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new _.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new M.ResourceMap}scanProfileExtensions(r,n){return this.withProfileExtensions(r,void 0,n)}async addExtensionsToProfile(r,n){const i=[],a=[];try{return await this.withProfileExtensions(n,p=>{const C=[];for(const k of p)r.some(([D])=>(0,c.areSameExtensions)(D.identifier,k.identifier)&&D.manifest.version!==k.version)?i.push(k):C.push(k);for(const[k,D]of r)if(!C.some(A=>(0,c.areSameExtensions)(A.identifier,k.identifier)&&A.version===k.manifest.version)){const A={identifier:k.identifier,version:k.manifest.version,location:k.location,metadata:D};a.push(A),C.push(A)}return a.length&&this._onAddExtensions.fire({extensions:a,profileLocation:n}),i.length&&this._onRemoveExtensions.fire({extensions:i,profileLocation:n}),C}),a.length&&this._onDidAddExtensions.fire({extensions:a,profileLocation:n}),i.length&&this._onDidRemoveExtensions.fire({extensions:i,profileLocation:n}),a}catch(p){throw a.length&&this._onDidAddExtensions.fire({extensions:a,error:p,profileLocation:n}),i.length&&this._onDidRemoveExtensions.fire({extensions:i,error:p,profileLocation:n}),p}}async updateMetadata(r,n){const i=[];return await this.withProfileExtensions(n,a=>{const p=[];for(const C of a){const k=r.find(([D])=>(0,c.areSameExtensions)(D.identifier,C.identifier)&&D.manifest.version===C.version);k&&(C.metadata={...C.metadata,...k[1]},i.push(C)),p.push(C)}return p}),i}async removeExtensionFromProfile(r,n){const i=[];this._onRemoveExtensions.fire({extensions:i,profileLocation:n});try{await this.withProfileExtensions(n,a=>{const p=[];for(const C of a)(0,c.areSameExtensions)(C.identifier,r.identifier)?i.push(C):p.push(C);return i.length&&this._onRemoveExtensions.fire({extensions:i,profileLocation:n}),p}),i.length&&this._onDidRemoveExtensions.fire({extensions:i,profileLocation:n})}catch(a){throw i.length&&this._onDidRemoveExtensions.fire({extensions:i,error:a,profileLocation:n}),a}}async withProfileExtensions(r,n,i){return this.getResourceAccessQueue(r).queue(async()=>{let a=[],p;try{const C=await this.fileService.readFile(r);p=JSON.parse(C.value.toString().trim()||"[]")}catch(C){if((0,m.toFileOperationResult)(C)!==1)throw C;if(this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)&&(p=await this.migrateFromOldDefaultProfileExtensionsLocation()),!p&&i?.bailOutWhenFileNotFound)throw new v((0,o.getErrorMessage)(C),"ERROR_PROFILE_NOT_FOUND")}if(p){Array.isArray(p)||this.reportAndThrowInvalidConentError(r);let C=!1;for(const k of p){S(k)||this.reportAndThrowInvalidConentError(r);let D;if((0,y.isString)(k.relativeLocation)&&k.relativeLocation)D=this.resolveExtensionLocation(k.relativeLocation);else if((0,y.isString)(k.location))D=this.resolveExtensionLocation(k.location),C=!0,k.relativeLocation=k.location,k.location=D.toJSON();else{D=I.URI.revive(k.location);const A=this.toRelativePath(D);A&&(C=!0,k.relativeLocation=A)}a.push({identifier:k.identifier,location:D,version:k.version,metadata:k.metadata})}C&&await this.fileService.writeFile(r,L.VSBuffer.fromString(JSON.stringify(p)))}if(n){a=n(a);const C=a.map(k=>({identifier:k.identifier,version:k.version,location:k.location.toJSON(),relativeLocation:this.toRelativePath(k.location),metadata:k.metadata}));await this.fileService.writeFile(r,L.VSBuffer.fromString(JSON.stringify(C)))}return a})}reportAndThrowInvalidConentError(r){const n=new v(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}toRelativePath(r){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(r),this.extensionsLocation)?this.uriIdentityService.extUri.basename(r):void 0}resolveExtensionLocation(r){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,r)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const r=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),n=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let i;try{i=(await this.fileService.readFile(r)).value.toString()}catch(p){if((0,m.toFileOperationResult)(p)===1)return;throw p}this.logService.info("Migrating extensions from old default profile location",r.toString());let a;try{const p=JSON.parse(i);Array.isArray(p)&&p.every(C=>S(C))?a=p:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",p)}catch(p){this.logService.error(p)}if(a)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(a)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",r.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(p){if((0,m.toFileOperationResult)(p)===3)this.logService.info("Migration from old default profile location to new location is done by another window",r.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw p}try{await this.fileService.del(r)}catch(p){(0,m.toFileOperationResult)(p)!==1&&this.logService.error(p)}try{await this.fileService.del(n)}catch(p){(0,m.toFileOperationResult)(p)!==1&&this.logService.error(p)}return a})()),this._migrationPromise}getResourceAccessQueue(r){let n=this.resourcesAccessQueueMap.get(r);return n||(n=new P.Queue,this.resourcesAccessQueueMap.set(r,n)),n}};e.AbstractExtensionsProfileScannerService=E,e.AbstractExtensionsProfileScannerService=E=Se([J(1,m.IFileService),J(2,d.IUserDataProfilesService),J(3,b.IUriIdentityService),J(4,g.ITelemetryService),J(5,w.ILogService)],E);function S(u){return(0,y.isObject)(u)&&(0,h.isIExtensionIdentifier)(u.identifier)&&(t(u.location)||(0,y.isString)(u.location)&&u.location)&&((0,y.isUndefined)(u.relativeLocation)||(0,y.isString)(u.relativeLocation))&&u.version&&(0,y.isString)(u.version)}function t(u){return u?(0,y.isString)(u.path)&&(0,y.isString)(u.scheme):!1}}),define(te[129],ie([0,1,24,8,37,17,13,45,151,2,15,9,4,19,203,70,10,7,170,33,123,120,202,16,6,5,23,3,74,82,41,40,201]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o,g,l,v,E,S,t,u,r,n,i,a,p,C,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var O;(function(ue){function G(Y,F){if(Y===F)return!0;const N=Object.keys(Y),B=new Set;for(const V of Object.keys(F))B.add(V);if(N.length!==B.size)return!1;for(const V of N){if(Y[V]!==F[V])return!1;B.delete(V)}return B.size===0}ue.equals=G})(O||(e.Translations=O={})),e.IExtensionsScannerService=(0,r.createDecorator)("IExtensionsScannerService");let U=class extends c.Disposable{constructor(G,Y,F,N,B,V,X,ce,oe,T,R,W){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=Y,this.extensionsControlLocation=F,this.currentProfile=N,this.userDataProfilesService=B,this.extensionsProfileScannerService=V,this.fileService=X,this.logService=ce,this.environmentService=oe,this.productService=T,this.uriIdentityService=R,this.instantiationService=W,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ne,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ne,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(se,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,E.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(G,Y,F){const[N,B]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(Y)]),V=F?await this.scanExtensionsUnderDevelopment(G,[...N,...B]):[];return this.dedupExtensions(N,B,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const Y=[];Y.push(this.scanDefaultSystemExtensions(!!G.useCache,G.language)),Y.push(this.scanDevSystemExtensions(G.language,!!G.checkControlFile));const[F,N]=await Promise.all(Y);return this.applyScanOptions([...F,...N],0,G,!1)}async scanUserExtensions(G){const Y=G.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",Y);const F=this.uriIdentityService.extUri.isEqual(G.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,N=await this.createExtensionScannerInput(Y,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,F),B=G.useCache&&!N.devMode&&N.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let V;try{V=await B.scanExtensions(N)}catch(X){if(X instanceof C.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),V=await B.scanExtensions(N);else throw X}return V=await this.applyScanOptions(V,1,G,!0),this.logService.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(G,Y){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const F=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(N=>N.scheme===m.Schemas.file).map(async N=>{const B=await this.createExtensionScannerInput(N,!1,1,!0,G.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(B)).map(X=>(X.type=Y.find(ce=>(0,E.areSameExtensions)(ce.identifier,X.identifier))?.type??X.type,this.extensionsScanner.validate(X,B)))}))).flat();return this.applyScanOptions(F,"development",G,!0)}return[]}async scanExistingExtension(G,Y,F){const N=await this.createExtensionScannerInput(G,!1,Y,!0,F.language,!0,void 0),B=await this.extensionsScanner.scanExtension(N);return!B||!F.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(G,Y,F){const N=await this.createExtensionScannerInput(G,!1,Y,!0,F.language,!0,void 0),B=await this.extensionsScanner.scanOneOrMultipleExtensions(N);return this.applyScanOptions(B,Y,F,!0)}async scanMetadata(G){const Y=(0,d.joinPath)(G,"package.json"),F=(await this.fileService.readFile(Y)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(G,Y){const F=(0,d.joinPath)(G,"package.json"),N=(await this.fileService.readFile(F)).value.toString(),B=JSON.parse(N);Y.isMachineScoped=Y.isMachineScoped||void 0,Y.isBuiltin=Y.isBuiltin||void 0,B.__metadata={...B.__metadata,...Y},await this.fileService.writeFile((0,d.joinPath)(G,"package.json"),_.VSBuffer.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof C.ExtensionsProfileScanningError&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw G}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.extensionsProfileScannerService.addExtensionsToProfile(G.map(Y=>[Y,Y.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,_.VSBuffer.fromString(JSON.stringify([])))}catch(Y){(0,u.toFileOperationResult)(Y)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,M.getErrorMessage)(Y))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.logService.error(G)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(G,Y,F,N){return F.includeAllVersions||(G=this.dedupExtensions(Y===0?G:void 0,Y===1?G:void 0,Y==="development"?G:void 0,await this.getTargetPlatform(),N)),F.includeInvalid||(G=G.filter(B=>B.isValid)),G.sort((B,V)=>{const X=f.basename(B.location.fsPath),ce=f.basename(V.location.fsPath);return X<ce?-1:X>ce?1:0})}dedupExtensions(G,Y,F,N,B){const V=(ce,oe,T)=>{if(ce.isValid&&!oe.isValid)return!1;if(ce.isValid===oe.isValid){if(B&&b.gt(ce.manifest.version,oe.manifest.version))return this.logService.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${ce.location.path} with version ${ce.manifest.version}`),!1;if(b.eq(ce.manifest.version,oe.manifest.version)){if(ce.type===0)return this.logService.debug(`Skipping extension ${oe.location.path} in favour of system extension ${ce.location.path} with same version`),!1;if(ce.targetPlatform===N)return this.logService.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return T?this.logService.warn(`Overwriting user extension ${ce.location.path} with ${oe.location.path}.`):this.logService.debug(`Overwriting user extension ${ce.location.path} with ${oe.location.path}.`),!0},X=new S.ExtensionIdentifierMap;return G?.forEach(ce=>{const oe=X.get(ce.identifier.id);(!oe||V(oe,ce,!1))&&X.set(ce.identifier.id,ce)}),Y?.forEach(ce=>{const oe=X.get(ce.identifier.id);if(!oe&&G&&ce.type===0){this.logService.debug(`Skipping obsolete system extension ${ce.location.path}.`);return}(!oe||V(oe,ce,!1))&&X.set(ce.identifier.id,ce)}),F?.forEach(ce=>{const oe=X.get(ce.identifier.id);(!oe||V(oe,ce,!0))&&X.set(ce.identifier.id,ce),X.set(ce.identifier.id,ce)}),[...X.values()]}async scanDefaultSystemExtensions(G,Y){this.logService.trace("Started scanning system extensions");const F=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),B=await(G&&!F.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return this.logService.trace("Scanned system extensions:",B.length),B}async scanDevSystemExtensions(G,Y){const F=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!F?.length)return[];this.logService.trace("Started scanning dev system extensions");const N=Y?await this.getBuiltInExtensionControl():{},B=[],V=g.URI.file(f.normalize(f.join(m.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ce of F){const oe=N[ce.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":B.push((0,d.joinPath)(V,ce.name));break;default:B.push(g.URI.file(oe));break}}const X=await Promise.all(B.map(async ce=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ce,!1,0,!0,G,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",X.length),(0,P.coalesce)(X)}async getBuiltInExtensionControl(){try{const G=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(G.value.toString())}catch{return{}}}async createExtensionScannerInput(G,Y,F,N,B,V,X){const ce=await this.getTranslations(B??w.language),oe=await this.getMtime(G),T=Y&&!this.uriIdentityService.extUri.isEqual(G,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,R=T?await this.getMtime(T):void 0;return new q(G,oe,T,R,Y,X,F,N,V,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,B,ce)}async getMtime(G){try{const Y=await this.fileService.stat(G);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};e.AbstractExtensionsScannerService=U,e.AbstractExtensionsScannerService=U=Se([J(4,k.IUserDataProfilesService),J(5,C.IExtensionsProfileScannerService),J(6,u.IFileService),J(7,n.ILogService),J(8,v.IEnvironmentService),J(9,i.IProductService),J(10,D.IUriIdentityService),J(11,r.IInstantiationService)],U);class q{constructor(G,Y,F,N,B,V,X,ce,oe,T,R,W,H,x,z){this.location=G,this.mtime=Y,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=N,this.profile=B,this.profileScanOptions=V,this.type=X,this.excludeObsolete=ce,this.validate=oe,this.productVersion=T,this.productDate=R,this.productCommit=W,this.devMode=H,this.language=x,this.translations=z}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,Y){return(0,d.isEqual)(G.location,Y.location)&&G.mtime===Y.mtime&&(0,d.isEqual)(G.applicationExtensionslocation,Y.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&G.profile===Y.profile&&s.equals(G.profileScanOptions,Y.profileScanOptions)&&G.type===Y.type&&G.excludeObsolete===Y.excludeObsolete&&G.validate===Y.validate&&G.productVersion===Y.productVersion&&G.productDate===Y.productDate&&G.productCommit===Y.productCommit&&G.devMode===Y.devMode&&G.language===Y.language&&O.equals(G.translations,Y.translations)}}e.ExtensionScannerInput=q;let se=class extends c.Disposable{constructor(G,Y,F,N,B){super(),this.obsoleteFile=G,this.extensionsProfileScannerService=Y,this.uriIdentityService=F,this.fileService=N,this.logService=B}async scanExtensions(G){const Y=G.profile?await this.scanExtensionsFromProfile(G):await this.scanExtensionsFromLocation(G);let F={};if(G.excludeObsolete&&G.type===1)try{const N=(await this.fileService.readFile(this.obsoleteFile)).value.toString();F=JSON.parse(N)}catch{}return(0,o.isEmptyObject)(F)?Y:Y.filter(N=>!F[E.ExtensionKey.create(N).toString()])}async scanExtensionsFromLocation(G){const Y=await this.fileService.resolve(G.location);if(!Y.children?.length)return[];const F=await Promise.all(Y.children.map(async N=>{if(!N.isDirectory||G.type===1&&(0,d.basename)(N.resource).indexOf(".")===0)return null;const B=new q(N.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(B)}));return(0,P.coalesce)(F).sort((N,B)=>N.location.path<B.location.path?-1:1)}async scanExtensionsFromProfile(G){let Y=await this.scanExtensionsFromProfileResource(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(G.location,G.applicationExtensionslocation)){Y=Y.filter(N=>!N.metadata?.isApplicationScoped);const F=await this.scanExtensionsFromProfileResource(G.applicationExtensionslocation,N=>!!N.metadata?.isBuiltin||!!N.metadata?.isApplicationScoped,G);Y.push(...F)}return Y}async scanExtensionsFromProfileResource(G,Y,F){const N=await this.extensionsProfileScannerService.scanProfileExtensions(G,F.profileScanOptions);if(!N.length)return[];const B=await Promise.all(N.map(async V=>{if(Y(V)){const X=new q(V.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.profileScanOptions,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(X,V.metadata)}return null}));return(0,P.coalesce)(B)}async scanOneOrMultipleExtensions(G){try{if(await this.fileService.exists((0,d.joinPath)(G.location,"package.json"))){const Y=await this.scanExtension(G);return Y?[Y]:[]}else return await this.scanExtensions(G)}catch(Y){return this.logService.error(`Error scanning extensions at ${G.location.path}:`,(0,M.getErrorMessage)(Y)),[]}}async scanExtension(G,Y){try{let F=await this.scanExtensionManifest(G.location);if(F){F.publisher||(F.publisher=S.UNDEFINED_PUBLISHER),Y=Y??F.__metadata,delete F.__metadata;const N=(0,E.getGalleryExtensionId)(F.publisher,F.name),B=Y?.id?{id:N,uuid:Y.id}:{id:N},V=Y?.isSystem?0:G.type,X=V===0||!!Y?.isBuiltin;F=await this.translateManifest(G.location,F,q.createNlsConfiguration(G));const ce={type:V,identifier:B,manifest:F,location:G.location,isBuiltin:X,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return G.validate?this.validate(ce,G):ce}}catch(F){G.type!==0&&this.logService.error(F)}return null}validate(G,Y){let F=!0;const N=(0,t.validateExtensionManifest)(Y.productVersion,Y.productDate,Y.location,G.manifest,G.isBuiltin);for(const[B,V]of N)B===y.default.Error&&(F=!1,this.logService.error(this.formatMessage(Y.location,V)));return G.isValid=F,G.validations=N,G}async scanExtensionManifest(G){const Y=(0,d.joinPath)(G,"package.json");let F;try{F=(await this.fileService.readFile(Y)).value.toString()}catch(B){return(0,u.toFileOperationResult)(B)!==1&&this.logService.error(this.formatMessage(G,(0,l.localize)(0,null,Y.path,B.message))),null}let N;try{N=JSON.parse(F)}catch{const V=[];(0,I.parse)(F,V);for(const X of V)this.logService.error(this.formatMessage(G,(0,l.localize)(1,null,Y.path,X.offset,X.length,(0,h.getParseErrorMessage)(X.error))));return null}return(0,I.getNodeType)(N)!=="object"?(this.logService.error(this.formatMessage(G,(0,l.localize)(2,null,Y.path))),null):N}async translateManifest(G,Y,F){const N=await this.getLocalizedMessages(G,Y,F);if(N)try{const B=[],V=await this.resolveOriginalMessageBundle(N.default,B);if(B.length>0)return B.forEach(ce=>{this.logService.error(this.formatMessage(G,(0,l.localize)(3,null,N.default?.path,(0,h.getParseErrorMessage)(ce.error))))}),Y;if((0,I.getNodeType)(N)!=="object")return this.logService.error(this.formatMessage(G,(0,l.localize)(4,null,N.default?.path))),Y;const X=N.values||Object.create(null);return(0,A.localizeManifest)(Y,X,V)}catch{}return Y}async getLocalizedMessages(G,Y,F){const N=(0,d.joinPath)(G,"package.nls.json"),B=(oe,T)=>{T.forEach(R=>{this.logService.error(this.formatMessage(G,(0,l.localize)(5,null,oe?.path,(0,h.getParseErrorMessage)(R.error))))})},V=oe=>{this.logService.error(this.formatMessage(G,(0,l.localize)(6,null,oe?.path)))},X=`${Y.publisher}.${Y.name}`,ce=F.translations[X];if(ce)try{const oe=g.URI.file(ce),T=(await this.fileService.readFile(oe)).value.toString(),R=[],W=(0,I.parse)(T,R);return R.length>0?(B(oe,R),{values:void 0,default:N}):(0,I.getNodeType)(W)!=="object"?(V(oe),{values:void 0,default:N}):{values:W.contents?W.contents.package:void 0,default:N}}catch{return{values:void 0,default:N}}else{if(!await this.fileService.exists(N))return;let T;try{T=await this.findMessageBundles(G,F)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const R=(await this.fileService.readFile(T.localized)).value.toString(),W=[],H=(0,I.parse)(R,W);return W.length>0?(B(T.localized,W),{values:void 0,default:T.original}):(0,I.getNodeType)(H)!=="object"?(V(T.localized),{values:void 0,default:T.original}):{values:H,default:T.original}}catch{return{values:void 0,default:T.original}}}}async resolveOriginalMessageBundle(G,Y){if(G)try{const F=(await this.fileService.readFile(G)).value.toString();return(0,I.parse)(F,Y)}catch{}}findMessageBundles(G,Y){return new Promise((F,N)=>{const B=V=>{const X=(0,d.joinPath)(G,`package.nls.${V}.json`);this.fileService.exists(X).then(ce=>{ce&&F({localized:X,original:(0,d.joinPath)(G,"package.nls.json")});const oe=V.lastIndexOf("-");oe===-1?F({localized:(0,d.joinPath)(G,"package.nls.json"),original:null}):(V=V.substring(0,oe),B(V))})};if(Y.devMode||Y.pseudo||!Y.language)return F({localized:(0,d.joinPath)(G,"package.nls.json"),original:null});B(Y.language)})}formatMessage(G,Y){return`[${G.path}]: ${Y}`}};se=Se([J(1,C.IExtensionsProfileScannerService),J(2,D.IUriIdentityService),J(3,u.IFileService),J(4,n.ILogService)],se);let ne=class extends se{constructor(G,Y,F,N,B,V,X){super(Y,N,B,V,X),this.currentProfile=G,this.userDataProfilesService=F,this.cacheValidatorThrottler=this._register(new L.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(G){const Y=this.getCacheFile(G),F=await this.readExtensionCache(Y);if(this.input=G,F&&F.input&&q.equals(F.input,this.input))return this.logService.debug("Using cached extensions scan result",G.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),F.result.map(B=>(B.location=g.URI.revive(B.location),B));const N=await super.scanExtensions(G);return await this.writeExtensionCache(Y,{input:G,result:N}),N}async readExtensionCache(G){try{const Y=await this.fileService.readFile(G),F=JSON.parse(Y.value.toString());return{result:F.result,input:(0,p.revive)(F.input)}}catch(Y){this.logService.debug("Error while reading the extension cache file:",G.path,(0,M.getErrorMessage)(Y))}return null}async writeExtensionCache(G,Y){try{await this.fileService.writeFile(G,_.VSBuffer.fromString(JSON.stringify(Y)))}catch(F){this.logService.debug("Error while writing the extension cache file:",G.path,(0,M.getErrorMessage)(F))}}async validateCache(){if(!this.input)return;const G=this.getCacheFile(this.input),Y=await this.readExtensionCache(G);if(!Y)return;const F=Y.result,N=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!s.equals(N,F))try{this.logService.info("Invalidating Cache",F,N),await this.fileService.del(G),this._onDidChangeCache.fire()}catch(B){this.logService.error(B)}}getCacheFile(G){const Y=this.getProfile(G);return this.uriIdentityService.extUri.joinPath(Y.cacheHome,G.type===0?S.BUILTIN_MANIFEST_CACHE_FILE:S.USER_MANIFEST_CACHE_FILE)}getProfile(G){return G.type===0?this.userDataProfilesService.defaultProfile:G.profile?this.uriIdentityService.extUri.isEqual(G.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(Y=>this.uriIdentityService.extUri.isEqual(G.location,Y.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};ne=Se([J(2,k.IUserDataProfilesService),J(3,C.IExtensionsProfileScannerService),J(4,D.IUriIdentityService),J(5,u.IFileService),J(6,n.ILogService)],ne);function ee(ue,G){const Y=(0,E.getExtensionId)(ue.manifest.publisher,ue.manifest.name);return{id:Y,identifier:new S.ExtensionIdentifier(Y),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:G,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.toExtensionDescription=ee;class ae extends U{constructor(G,Y,F,N,B,V,X,ce,oe,T,R,W){super(G,Y,(0,d.joinPath)(F,".vscode-oss-dev","extensions","control.json"),N,B,V,X,ce,oe,T,R,W),this.translationsPromise=(async()=>{if(w.translationsConfigFile)try{const H=await this.fileService.readFile(g.URI.file(w.translationsConfigFile));return JSON.parse(H.value.toString())}catch{}return Object.create(null)})()}getTranslations(G){return this.translationsPromise}}e.NativeExtensionsScannerService=ae}),define(te[278],ie([0,1,5,41,40,26,82,16,33,7]),function(j,e,P,L,s,_,M,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let m=class extends M.AbstractExtensionsProfileScannerService{constructor(w,d,b,y,o,g){super(c.URI.file(w.extensionsPath),d,b,y,o,g)}};e.ExtensionsProfileScannerService=m,e.ExtensionsProfileScannerService=m=Se([J(0,h.INativeEnvironmentService),J(1,I.IFileService),J(2,L.IUserDataProfilesService),J(3,s.IUriIdentityService),J(4,_.ITelemetryService),J(5,P.ILogService)],m)}),define(te[279],ie([0,1,7,33,82,129,16,6,5,23,40,41]),function(j,e,P,L,s,_,M,I,h,c,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let w=class extends _.NativeExtensionsScannerService{constructor(b,y,o,g,l,v,E,S){super(P.URI.file(l.builtinExtensionsPath),P.URI.file(l.extensionsPath),l.userHome,b.defaultProfile,b,y,o,g,l,v,E,S)}};e.ExtensionsScannerService=w,e.ExtensionsScannerService=w=Se([J(0,f.IUserDataProfilesService),J(1,s.IExtensionsProfileScannerService),J(2,M.IFileService),J(3,h.ILogService),J(4,L.INativeEnvironmentService),J(5,c.IProductService),J(6,m.IUriIdentityService),J(7,I.IInstantiationService)],w)}),define(te[280],ie([0,1,14,2,15,9,4,58,7,31,38,33,5,41]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let b=class extends L.Disposable{constructor(o,g,l){super(),this.environmentService=o,this.logService=l,this.validRoots=I.TernarySearchTree.forPaths(!M.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(o.appRoot),this.addValidFileRoot(o.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(o.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:o}=P.session;o.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(g,l)=>this.handleResourceRequest(g,l)),o.protocol.interceptFileProtocol(s.Schemas.file,(g,l)=>this.handleFileRequest(g,l)),this._register((0,L.toDisposable)(()=>{o.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),o.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(o){const g=(0,_.normalize)(o);return this.validRoots.get(g)?L.Disposable.None:(this.validRoots.set(g,!0),(0,L.toDisposable)(()=>this.validRoots.delete(g)))}handleFileRequest(o,g){const l=h.URI.parse(o.url);return this.logService.error(`Refused to load resource ${l.fsPath} from ${s.Schemas.file}: protocol (original URL: ${o.url})`),g({error:-3})}handleResourceRequest(o,g){const l=this.requestToNormalizedFilePath(o);let v;return this.environmentService.crossOriginIsolated&&((0,_.basename)(l)==="workbench.html"||(0,_.basename)(l)==="workbench-dev.html"?v=s.COI.CoopAndCoep:v=s.COI.getHeadersFromQuery(o.url)),this.validRoots.findSubstr(l)?g({path:l,headers:v}):this.validExtensions.has((0,_.extname)(l).toLowerCase())?g({path:l}):(this.logService.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${l} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${o.url})`),g({error:-3}))}requestToNormalizedFilePath(o){const g=h.URI.parse(o.url),l=s.FileAccess.uriToFileUri(g);return(0,_.normalize)(l.fsPath)}createIPCObjectUrl(){let o;const g=h.URI.from({scheme:"vscode",path:(0,c.generateUuid)()}),l=g.toString(),v=async()=>o;return m.validatedIpcMain.handle(l,v),this.logService.trace(`IPC Object URL: Registered new channel ${l}.`),{resource:g,update:E=>o=E,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${l}.`),m.validatedIpcMain.removeHandler(l)}}}};e.ProtocolMainService=b,e.ProtocolMainService=b=Se([J(0,f.INativeEnvironmentService),J(1,d.IUserDataProfilesService),J(2,w.ILogService)],b)}),define(te[97],ie([0,1,8,3,2,65,10,111,6,41]),function(j,e,P,L,s,_,M,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,h.createDecorator)("storageService");var m;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var f;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(f||(e.StorageScope=f={}));var w;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function d(l){const v=l.get(e.TARGET_KEY);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}e.loadKeyTargets=d;class b extends s.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(v={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super(),this.options=v,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new P.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new s.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,P.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,s.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,_.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,_.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,E){const{key:S,external:t}=E;if(S===e.TARGET_KEY){switch(v){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:v})}else this._onDidChangeValue.fire({scope:v,key:S,target:this.getKeyTargets(v)[S],external:t})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,E,S){return this.getStorage(E)?.get(v,S)}getBoolean(v,E,S){return this.getStorage(E)?.getBoolean(v,S)}getNumber(v,E,S){return this.getStorage(E)?.getNumber(v,S)}getObject(v,E,S){return this.getStorage(E)?.getObject(v,S)}storeAll(v,E){this.withPausedEmitters(()=>{for(const S of v)this.store(S.key,S.value,S.scope,S.target,E)})}store(v,E,S,t,u=!1){if((0,M.isUndefinedOrNull)(E)){this.remove(v,S,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,S,t),this.getStorage(S)?.set(v,E,u)})}remove(v,E,S=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(v,E,void 0),this.getStorage(E)?.delete(v,S)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,E){const S=[],t=this.getKeyTargets(v);for(const u of Object.keys(t))t[u]===E&&S.push(u);return S}updateKeyTarget(v,E,S,t=!1){const u=this.getKeyTargets(E);typeof S=="number"?u[v]!==S&&(u[v]=S,this.getStorage(E)?.set(e.TARGET_KEY,JSON.stringify(u),t)):typeof u[v]=="number"&&(delete u[v],this.getStorage(E)?.set(e.TARGET_KEY,JSON.stringify(u),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(v){switch(v){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(v){const E=this.getStorage(v);return E?d(E):Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=m.NONE){this._onWillSaveState.fire({reason:v});const E=this.getStorage(-1),S=this.getStorage(0),t=this.getStorage(1);switch(v){case m.NONE:await P.Promises.settled([E?.whenFlushed()??Promise.resolve(),S?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await P.Promises.settled([E?.flush(0)??Promise.resolve(),S?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.getStorage(-1)?.items??new Map,E=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return g(v,E,S,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(v,E){return this.emitWillSaveState(m.NONE),(0,c.isUserDataProfile)(v)?this.switchToProfile(v,E):this.switchToWorkspace(v,E)}canSwitchProfile(v,E){return!(v.id===E.id||y(E)&&y(v))}switchData(v,E,S){this.withPausedEmitters(()=>{const t=new Set;for(const[u,r]of v)t.add(u),E.get(u)!==r&&this.emitDidChangeValue(S,{key:u,external:!0});for(const[u]of E.items)t.has(u)||this.emitDidChangeValue(S,{key:u,external:!0})})}}e.AbstractStorageService=b;function y(l){return l.isDefault||!!l.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=y;class o extends b{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.profileStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),this._register(this.applicationStorage.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v)))}getStorage(v){switch(v){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(v){return!1}}e.InMemoryStorageService=o;async function g(l,v,E,S,t,u){const r=O=>{try{return JSON.parse(O)}catch{return O}},n=new Map,i=new Map;l.forEach((O,U)=>{n.set(U,O),i.set(U,r(O))});const a=new Map,p=new Map;v.forEach((O,U)=>{a.set(U,O),p.set(U,r(O))});const C=new Map,k=new Map;E.forEach((O,U)=>{C.set(U,O),k.set(U,r(O))}),console.group(S!==t?`Storage: Application (path: ${S})`:`Storage: Application & Profile (path: ${S}, default profile)`);const D=[];if(n.forEach((O,U)=>{D.push({key:U,value:O})}),console.table(D),console.groupEnd(),console.log(i),S!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const O=[];a.forEach((U,q)=>{O.push({key:q,value:U})}),console.table(O),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${u})`);const A=[];C.forEach((O,U)=>{A.push({key:U,value:O})}),console.table(A),console.groupEnd(),console.log(k)}e.logStorage=g}),define(te[281],ie([0,1,24,8,3,2,9,69,7,22,111,159,5,97,26,30]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class o extends _.Disposable{static{this.LOG_SLOW_CLOSE_THRESHOLD=2e3}get storage(){return this._storage}constructor(u,r){super(),this.logService=u,this.fileService=r,this._onDidChangeStorage=this._register(new s.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new s.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new m.Storage(new m.InMemoryStorageDatabase,{hint:m.StorageHint.STORAGE_IN_MEMORY}),this.initializePromise=void 0,this.whenInitPromise=new L.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=m.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===m.StorageState.None)try{const u=await this.doCreate();this._storage.dispose(),this._storage=u,this._register(u.onDidChangeStorage(n=>this._onDidChangeStorage.fire(n))),await this.doInit(u);const r=u.getBoolean(d.IS_NEW_KEY);r===void 0?u.set(d.IS_NEW_KEY,!0):r&&u.set(d.IS_NEW_KEY,!1)}catch(u){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${u}`)}finally{this.state=m.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?u=>this.logService.trace(u):void 0,logError:u=>this.logService.error(u)}}doInit(u){return u.init()}get items(){return this._storage.items}get(u,r){return this._storage.get(u,r)}set(u,r){return this._storage.set(u,r)}delete(u){return this._storage.delete(u)}async close(){const u=new I.StopWatch(!1);await this.doClose(),u.stop(),u.elapsed()>o.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(u),this._onDidCloseStorage.fire()}async logSlowClose(u){if(this.path)try{const r=(0,P.top)(Array.from(this._storage.items.entries()).map(([i,a])=>({key:i,length:a.length})),(i,a)=>a.length-i.length,5).map(i=>`${i.key}:${i.length}`).join(", "),n=(await this.fileService.stat(h.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${u.elapsed()}ms, DB size: ${n}b, Large Keys: ${r}`)}catch(r){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",r)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=m.StorageState.Closed,await this._storage.close()}}class g extends o{static{this.STORAGE_NAME="state.vscdb"}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.profile.globalStorageHome.fsPath,g.STORAGE_NAME)}constructor(u,r,n,i){super(n,i),this.profile=u,this.options=r}async doCreate(){return new m.Storage(new f.SQLiteStorageDatabase(this.path??f.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:m.StorageHint.STORAGE_IN_MEMORY})}}class l extends g{constructor(u,r,n,i){super(u,r,n,i)}}e.ProfileStorageMain=l;class v extends g{constructor(u,r,n,i){super(r.defaultProfile,u,n,i)}async doInit(u){await super.doInit(u),this.updateTelemetryState(u)}updateTelemetryState(u){u.get(b.firstSessionDateStorageKey,void 0)===void 0&&u.set(b.firstSessionDateStorageKey,new Date().toUTCString());const n=u.get(b.currentSessionDateStorageKey,void 0),i=new Date().toUTCString();u.set(b.lastSessionDateStorageKey,typeof n>"u"?null:n),u.set(b.currentSessionDateStorageKey,i)}}e.ApplicationStorageMain=v;class E extends o{static{this.WORKSPACE_STORAGE_NAME="state.vscdb"}static{this.WORKSPACE_META_NAME="workspace.json"}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,E.WORKSPACE_STORAGE_NAME)}constructor(u,r,n,i,a){super(n,a),this.workspace=u,this.options=r,this.environmentService=i}async doCreate(){const{storageFilePath:u,wasCreated:r}=await this.prepareWorkspaceStorageFolder();return new m.Storage(new f.SQLiteStorageDatabase(u,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?m.StorageHint.STORAGE_IN_MEMORY:r?m.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const u=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),r=(0,M.join)(u,E.WORKSPACE_STORAGE_NAME);return await c.Promises.exists(u)?{storageFilePath:r,wasCreated:!1}:(await c.Promises.mkdir(u,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(u),{storageFilePath:r,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(u){let r;if((0,y.isSingleFolderWorkspaceIdentifier)(this.workspace)?r={folder:this.workspace.uri.toString()}:(0,y.isWorkspaceIdentifier)(this.workspace)&&(r={workspace:this.workspace.configPath.toString()}),r)try{const n=(0,M.join)(u,E.WORKSPACE_META_NAME);await c.Promises.exists(n)||await c.Promises.writeFile(n,JSON.stringify(r,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=E;class S extends o{get path(){}async doCreate(){return new m.Storage(new m.InMemoryStorageDatabase,{hint:m.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=S}),define(te[282],ie([0,1,3,2,97]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class _ extends L.Disposable{constructor(I,h,c){super(),this.storageMainService=I,this.userDataProfilesService=h,this.logService=c;const m=this._register(new L.MutableDisposable);this._onDidChange=this._register(new P.Emitter({onWillAddFirstListener:()=>m.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>m.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new L.DisposableStore;return I.add(P.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(h,c)=>(h?h.push(c.key):h=[c.key],h),100)(h=>this.onDidChangeApplicationStorage(h))),I.add(P.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(h,c)=>{h||(h=new Map);let m=h.get(c.profile.id);return m||h.set(c.profile.id,m={profile:c.profile,keys:[],storage:c.storage}),m.keys.push(c.key),h},100)(h=>this.onDidChangeProfileStorage(h))),I}onDidChangeApplicationStorage(I){const h=I.includes(s.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],c=[];if(I=I.filter(m=>m!==s.TARGET_KEY),I.length){const m=(0,s.loadKeyTargets)(this.storageMainService.applicationStorage.storage);c.push({profile:this.userDataProfilesService.defaultProfile,changes:I.map(f=>({key:f,scope:0,target:m[f]}))})}this.triggerEvents(h,c)}onDidChangeProfileStorage(I){const h=[],c=new Map;for(const[m,f]of I.entries()){f.keys.includes(s.TARGET_KEY)&&h.push(f.profile);const w=f.keys.filter(d=>d!==s.TARGET_KEY);if(w.length){const d=(0,s.loadKeyTargets)(f.storage.storage);c.set(m,{profile:f.profile,changes:w.map(b=>({key:b,scope:0,target:d[b]}))})}}this.triggerEvents(h,[...c.values()])}triggerEvents(I,h){(I.length||h.length)&&this._onDidChange.fire({valueChanges:h,targetChanges:I})}listen(I,h,c){switch(h){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${h}`)}async call(I,h){throw new Error(`Call not found: ${h}`)}}e.ProfileStorageChangesListenerChannel=_}),define(te[283],ie([0,1,7,33,16,5,34,40,41,10,121]),function(j,e,P,L,s,_,M,I,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let f=class ht extends h.UserDataProfilesService{static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(y,o,g,l,v){super(g,l,o,v),this.stateReadonlyService=y,this.nativeEnvironmentService=g}getStoredProfiles(){return this.stateReadonlyService.getItem(ht.PROFILES_KEY,[]).map(o=>({...o,location:(0,c.isString)(o.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,o.location):P.URI.revive(o.location)}))}getStoredProfileAssociations(){const y=this.stateReadonlyService.getItem(ht.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(ht.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?y:this.migrateStoredProfileAssociations(y)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(P.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=f,e.UserDataProfilesReadonlyService=f=Se([J(0,M.IStateReadService),J(1,I.IUriIdentityService),J(2,L.INativeEnvironmentService),J(3,s.IFileService),J(4,_.ILogService)],f);let w=class st extends f{constructor(y,o,g,l,v){super(y,o,g,l,v),this.stateService=y}saveStoredProfiles(y){y.length?this.stateService.setItem(st.PROFILES_KEY,y.map(o=>({...o,location:this.uriIdentityService.extUri.basename(o.location)}))):this.stateService.removeItem(st.PROFILES_KEY)}getStoredProfiles(){const y=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(y),this.stateService.setItem("userDataProfilesMigration",!0)),y}saveStoredProfileAssociations(y){y.emptyWindows||y.workspaces?this.stateService.setItem(st.PROFILE_ASSOCIATIONS_KEY,y):this.stateService.removeItem(st.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const y="workspaceAndProfileInfo",o=this.stateService.getItem(y,void 0);if(o){this.stateService.removeItem(y);const l=o.reduce((v,{workspace:E,profile:S})=>(v[P.URI.revive(E).toString()]=P.URI.revive(S).toString(),v),{});this.stateService.setItem(st.PROFILE_ASSOCIATIONS_KEY,{workspaces:l})}const g=super.getStoredProfileAssociations();return this.stateService.getItem(st.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(g),this.stateService.setItem(st.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),g}};e.UserDataProfilesService=w,e.UserDataProfilesService=w=Se([J(0,M.IStateService),J(1,I.IUriIdentityService),J(2,L.INativeEnvironmentService),J(3,s.IFileService),J(4,_.ILogService)],w);let d=class extends w{constructor(y,o,g,l){super(new m.StateService(0,o,l,g),y,o,g,l)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=d,e.ServerUserDataProfilesService=d=Se([J(0,I.IUriIdentityService),J(1,L.INativeEnvironmentService),J(2,s.IFileService),J(3,_.ILogService)],d)}),define(te[53],ie([0,1,33,16,6,5,40,41,283,34]),function(j,e,P,L,s,_,M,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,s.refineServiceDecorator)(I.IUserDataProfilesService);let m=class extends h.UserDataProfilesService{constructor(w,d,b,y,o){super(w,d,b,y,o)}getAssociatedEmptyWindows(){const w=[];for(const d of this.profilesObject.emptyWindows.keys())w.push({id:d});return w}};e.UserDataProfilesMainService=m,e.UserDataProfilesMainService=m=Se([J(0,c.IStateService),J(1,M.IUriIdentityService),J(2,P.INativeEnvironmentService),J(3,L.IFileService),J(4,_.ILogService)],m)}),define(te[130],ie([0,1,19,7,30]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function _(h,c,m){for(const w of h){const d=w.openedWorkspace;if((0,s.isWorkspaceIdentifier)(d)){const b=await m(d);if(b){if(b.folders.some(y=>P.extUriBiasedIgnorePathCase.isEqualOrParent(c,y.uri)))return w}else if(P.extUriBiasedIgnorePathCase.isEqualOrParent(c,d.configPath))return w}}const f=h.filter(w=>(0,s.isSingleFolderWorkspaceIdentifier)(w.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqualOrParent(c,w.openedWorkspace.uri));if(f.length)return f.sort((w,d)=>-(w.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=_;function M(h,c){for(const m of h)if((0,s.isWorkspaceIdentifier)(m.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(m.openedWorkspace.configPath,c)||(0,s.isSingleFolderWorkspaceIdentifier)(m.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(m.openedWorkspace.uri,c))return m}e.findWindowOnWorkspaceOrFolder=M;function I(h,c){const m=f=>c.some(w=>P.extUriBiasedIgnorePathCase.isEqual(L.URI.file(w),L.URI.file(f)));for(const f of h)if(f.config?.extensionDevelopmentPath?.some(w=>m(w)))return f}e.findWindowOnExtensionDevelopmentPath=I}),define(te[98],ie([0,1,32,45,137,46,15,9,4,19,7,6,60,30]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,f.createDecorator)("workspacesService");function b(k){return k.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function y(k){return k.hasOwnProperty("folderUri")}e.isRecentFolder=y;function o(k){return k.hasOwnProperty("fileUri")}e.isRecentFile=o;function g(k){return l(k)||v(k)}e.isStoredWorkspaceFolder=g;function l(k){const D=k;return typeof D?.path=="string"&&(!D.name||typeof D.name=="string")}function v(k){const D=k;return typeof D?.uri=="string"&&(!D.name||typeof D.name=="string")}function E(k,D,A,O,U){if(k.scheme!==O.scheme)return{name:A,uri:k.toString(!0)};let q=D?void 0:U.relativePath(O,k);if(q!==void 0)q.length===0?q=".":h.isWindows&&(q=S(q));else if(k.scheme===M.Schemas.file)q=k.fsPath,h.isWindows&&(q=S(q));else if(U.isEqualAuthority(k.authority,O.authority))q=k.path;else return{name:A,uri:k.toString(!0)};return{name:A,path:q}}e.getStoredWorkspaceFolder=E;function S(k){return k=(0,_.normalizeDriveLetter)(k),(0,P.isUNC)(k)||(k=(0,P.toSlashes)(k)),k}function t(k,D,A){const O=[],U=new Set,q=A.dirname(D);for(const se of k){let ne;if(l(se))se.path&&(ne=A.resolvePath(q,se.path));else if(v(se))try{ne=m.URI.parse(se.uri),ne.path[0]!==I.posix.sep&&(ne=ne.with({path:I.posix.sep+ne.path}))}catch(ee){console.warn(ee)}if(ne){const ee=A.getComparisonKey(ne);if(!U.has(ee)){U.add(ee);const ae=se.name||A.basenameOrAuthority(ne);O.push(new d.WorkspaceFolder({uri:ne,name:ae,index:O.length},se))}}}return O}e.toWorkspaceFolders=t;function u(k,D,A,O,U){const q=r(D,k),se=U.dirname(D),ne=U.dirname(O),ee=[];for(const Y of q.folders){const F=l(Y)?U.resolvePath(se,Y.path):m.URI.parse(Y.uri);let N;A?N=!1:N=!l(Y)||(0,I.isAbsolute)(Y.path),ee.push(E(F,N,Y.name,ne,U))}const ae={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},ue=s.setProperty(k,["folders"],ee,ae);let G=s.applyEdits(k,ue);return(0,c.isEqualAuthority)(q.remoteAuthority,(0,w.getRemoteAuthority)(O))&&(G=s.applyEdits(G,s.removeProperty(G,["remoteAuthority"],ae))),G}e.rewriteWorkspaceFileForNewLocation=u;function r(k,D){const A=L.parse(D);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(O=>g(O));else throw new Error(`${k} looks like an invalid workspace file.`);return A}function n(k){return k.workspace&&typeof k.workspace=="object"&&typeof k.workspace.id=="string"&&typeof k.workspace.configPath=="string"}function i(k){return typeof k.folderUri=="string"}function a(k){return typeof k.fileUri=="string"}function p(k,D){const A={workspaces:[],files:[]};if(k){const O=function(q,se){for(let ne=0;ne<q.length;ne++)try{se(q[ne],ne)}catch(ee){D.warn(`Error restoring recent entry ${JSON.stringify(q[ne])}: ${ee.toString()}. Skip entry.`)}},U=k;Array.isArray(U.entries)&&O(U.entries,q=>{const se=q.label,ne=q.remoteAuthority;n(q)?A.workspaces.push({label:se,remoteAuthority:ne,workspace:{id:q.workspace.id,configPath:m.URI.parse(q.workspace.configPath)}}):i(q)?A.workspaces.push({label:se,remoteAuthority:ne,folderUri:m.URI.parse(q.folderUri)}):a(q)&&A.files.push({label:se,remoteAuthority:ne,fileUri:m.URI.parse(q.fileUri)})})}return A}e.restoreRecentlyOpened=p;function C(k){const D={entries:[]};for(const A of k.workspaces)y(A)?D.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):D.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of k.files)D.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return D}e.toStoreData=C}),define(te[99],ie([0,1,72,15,4,19]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function M(c){function m(){let f=c.scheme===L.Schemas.file?(0,_.originalFSPath)(c):c.toString();return s.isLinux||(f=f.toLowerCase()),(0,P.createHash)("md5").update(f).digest("hex")}return{id:m(),configPath:c}}e.getWorkspaceIdentifier=M;function I(c,m){function f(){if(c.scheme!==L.Schemas.file)return(0,P.createHash)("md5").update(c.toString()).digest("hex");if(!m)return;let d;return s.isLinux?d=m.ino:s.isMacintosh?d=m.birthtime.getTime():s.isWindows&&(typeof m.birthtimeMs=="number"?d=Math.floor(m.birthtimeMs):d=m.birthtime.getTime()),(0,P.createHash)("md5").update(c.fsPath).update(d?String(d):"").digest("hex")}const w=f();if(typeof w=="string")return{id:w,uri:c}}e.getSingleFolderWorkspaceIdentifier=I;function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=h}),define(te[131],ie([0,1,72,88,27,284,17,13,3,2,9,4,31,43,109]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class y{traceSocketEvent(D,A){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,D,A)}constructor(D,A=""){this._canWrite=!0,this.debugLabel=A,this.socket=D,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,I.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener),this._closeListener=O=>{this.traceSocketEvent("close",{hadError:O}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(D){const A=O=>{this.traceSocketEvent("read",O),D(M.VSBuffer.wrap(O))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(D){const A=O=>{D({type:0,hadError:O,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(D){const A=()=>{D()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(D){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",D),this.socket.write(D.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,I.onUnexpectedError)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,I.onUnexpectedError)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((D,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),D();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),D()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=y;var o;(function(k){k[k.MinHeaderByteSize=2]="MinHeaderByteSize",k[k.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(o||(o={}));var g;(function(k){k[k.PeekHeader=1]="PeekHeader",k[k.ReadHeader=2]="ReadHeader",k[k.ReadBody=3]="ReadBody",k[k.Fin=4]="Fin"})(g||(g={}));class l extends c.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(D,A){this.socket.traceSocketEvent(D,A)}constructor(D,A,O,U){super(),this._onData=this._register(new h.Emitter),this._onClose=this._register(new h.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=D,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:O?.byteLength||0,recordInflateBytes:U}),this._flowManager=this._register(new v(this,A,O,U,this._onData,(q,se)=>this._write(q,se))),this._register(this._flowManager.onError(q=>{console.error(q),(0,I.onUnexpectedError)(q),this._onClose.fire({type:0,hadError:!0,error:q})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(q=>this._acceptChunk(q))),this._register(this.socket.onClose(async q=>{this._flowManager.isProcessingReadQueue()&&await h.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(q)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(D){return this._onData.event(D)}onClose(D){return this._onClose.event(D)}onEnd(D){return this.socket.onEnd(D)}write(D){let A=0;for(;A<D.byteLength;)this._flowManager.writeMessage(D.slice(A,Math.min(A+262144,D.byteLength))),A+=262144}_write(D,A){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",D);let O=2;D.byteLength<126?O+=0:D.byteLength<2**16?O+=2:O+=8;const U=M.VSBuffer.alloc(O);if(A?U.writeUInt8(194,0):U.writeUInt8(130,0),D.byteLength<126)U.writeUInt8(D.byteLength,1);else if(D.byteLength<2**16){U.writeUInt8(126,1);let q=1;U.writeUInt8(D.byteLength>>>8&255,++q),U.writeUInt8(D.byteLength>>>0&255,++q)}else{U.writeUInt8(127,1);let q=1;U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(D.byteLength>>>24&255,++q),U.writeUInt8(D.byteLength>>>16&255,++q),U.writeUInt8(D.byteLength>>>8&255,++q),U.writeUInt8(D.byteLength>>>0&255,++q)}this.socket.write(M.VSBuffer.concat([U,D]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(D){if(D.byteLength!==0){for(this._incomingData.acceptChunk(D);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),O=A.readUInt8(0),U=(O&128)>>>7,q=(O&64)>>>6,se=A.readUInt8(1),ne=(se&128)>>>7,ee=se&127;this._state.state=2,this._state.readLen=2+(ne?4:0)+(ee===126?2:0)+(ee===127?8:0),this._state.fin=U,this._state.firstFrameOfMessage&&(this._state.compressed=!!q),this._state.firstFrameOfMessage=!!U,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),O=A.readUInt8(1),U=(O&128)>>>7;let q=O&127,se=1;q===126?q=A.readUInt8(++se)*2**8+A.readUInt8(++se):q===127&&(q=A.readUInt8(++se)*0+A.readUInt8(++se)*0+A.readUInt8(++se)*0+A.readUInt8(++se)*0+A.readUInt8(++se)*2**24+A.readUInt8(++se)*2**16+A.readUInt8(++se)*2**8+A.readUInt8(++se));let ne=0;U&&(ne=A.readUInt8(++se)*2**24+A.readUInt8(++se)*2**16+A.readUInt8(++se)*2**8+A.readUInt8(++se)),this._state.state=3,this._state.readLen=q,this._state.mask=ne,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),t(A,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(A,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await h.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=l;class v extends c.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:M.VSBuffer.alloc(0)}constructor(D,A,O,U,q,se){super(),this._tracer=D,this._onData=q,this._writeFn=se,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new h.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new h.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,A?(this._zlibInflateStream=this._register(new E(this._tracer,U,O,{windowBits:15})),this._zlibDeflateStream=this._register(new S(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(ne=>this._onError.fire(ne))),this._register(this._zlibDeflateStream.onError(ne=>this._onError.fire(ne)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(D){this._writeQueue.push(D),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const D=this._writeQueue.shift();if(this._zlibDeflateStream){const A=await this._deflateMessage(this._zlibDeflateStream,D);this._writeFn(A,!0)}else this._writeFn(D,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(D,A){return new Promise((O,U)=>{D.write(A),D.flush(q=>O(q))})}acceptFrame(D,A,O){this._readQueue.push({data:D,isCompressed:A,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const D=this._readQueue.shift();if(this._zlibInflateStream&&D.isCompressed){const A=await this._inflateFrame(this._zlibInflateStream,D.data,D.isLastFrameOfMessage);this._onData.fire(A)}else this._onData.fire(D.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(D,A,O){return new Promise((U,q)=>{D.write(A),O&&D.write(M.VSBuffer.fromByteArray([0,0,255,255])),D.flush(se=>U(se))})}}class E extends c.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.concat(this._recordedInflateBytes):M.VSBuffer.alloc(0)}constructor(D,A,O,U){super(),this._tracer=D,this._recordInflateBytes=A,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,_.createInflateRaw)(U),this._zlibInflate.on("error",q=>{this._tracer.traceSocketEvent("zlibInflateError",{message:q?.message,code:q?.code}),this._onError.fire(q)}),this._zlibInflate.on("data",q=>{this._tracer.traceSocketEvent("zlibInflateData",q),this._pendingInflateData.push(M.VSBuffer.wrap(q))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(D){this._recordInflateBytes&&this._recordedInflateBytes.push(D.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",D),this._zlibInflate.write(D.buffer)}flush(D){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const A=M.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,D(A)})}}class S extends c.Disposable{constructor(D,A){super(),this._tracer=D,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,_.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(M.VSBuffer.wrap(O))})}write(D){this._tracer.traceSocketEvent("zlibDeflateWrite",D.buffer),this._zlibDeflate.write(D.buffer)}flush(D){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let A=M.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.byteLength-4),D(A)})}}function t(k,D){if(D===0)return;const A=k.byteLength>>>2;for(let ee=0;ee<A;ee++){const ae=k.readUInt32BE(ee*4);k.writeUInt32BE(ae^D,ee*4)}const O=A*4,U=k.byteLength-O,q=D>>>24&255,se=D>>>16&255,ne=D>>>8&255;U>=1&&k.writeUInt8(k.readUInt8(O)^q,O),U>=2&&k.writeUInt8(k.readUInt8(O+1)^se,O+1),U>=3&&k.writeUInt8(k.readUInt8(O+2)^ne,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function r(){const k=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${k}-sock`;const D=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,s.tmpdir)(),A=(0,m.join)(D,`vscode-ipc-${k}.sock`);return i(A),A}e.createRandomIPCHandle=r;function n(k,D,A){const O=(0,P.createHash)("md5").update(k).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${A}-${D}-sock`;const U=A.substr(0,4),q=D.substr(0,6),se=O.substr(0,8);let ne;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?ne=(0,m.join)(e.XDG_RUNTIME_DIR,`vscode-${se}-${U}-${q}.sock`):ne=(0,m.join)(k,`${U}-${q}.sock`),i(ne),ne}e.createStaticIPCHandle=n;function i(k){const D=u[f.platform];typeof D=="number"&&k.length>=D&&console.warn(`WARNING: IPC handle "${k}" is longer than ${D} chars, try a shorter --user-data-dir`)}class a extends d.IPCServer{static toClientConnectionEvent(D){const A=h.Event.fromNodeEventEmitter(D,"connection");return h.Event.map(A,O=>({protocol:new b.Protocol(new y(O,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(O,"close"))}))}constructor(D){super(a.toClientConnectionEvent(D)),this.server=D}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=a;function p(k){return new Promise((D,A)=>{const O=(0,L.createServer)();O.on("error",A),O.listen(k,()=>{O.removeListener("error",A),D(new a(O))})})}e.serve=p;function C(k,D){return new Promise((A,O)=>{const U=(0,L.createConnection)(k,()=>{U.removeListener("error",O),A(b.Client.fromSocket(new y(U,`ipc-client${D}`),D))});U.once("error",O)})}e.connect=C}),define(te[28],ie([0,1,55,9,4,131,33,90,6]),function(j,e,P,L,s,_,M,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,h.refineServiceDecorator)(M.IEnvironmentService);class c extends I.NativeEnvironmentService{constructor(){super(...arguments),this._snapEnv={}}get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,_.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.isLinux){for(const f in process.env)if(f.endsWith("_VSCODE_SNAP_ORIG")){const w=f.slice(0,-17);if(this._snapEnv[w])continue;process.env[w]&&(this._snapEnv[w]=process.env[w]),process.env[f]?process.env[w]=process.env[f]:delete process.env[w]}}}restoreSnapExportedVariables(){if(s.isLinux)for(const f in this._snapEnv)process.env[f]=this._snapEnv[f],delete this._snapEnv[f]}}e.EnvironmentMainService=c,Se([P.memoize],c.prototype,"cachedLanguagesPath",null),Se([P.memoize],c.prototype,"backupHome",null),Se([P.memoize],c.prototype,"mainIPCHandle",null),Se([P.memoize],c.prototype,"mainLockfile",null),Se([P.memoize],c.prototype,"disableUpdates",null),Se([P.memoize],c.prototype,"disableKeytar",null),Se([P.memoize],c.prototype,"crossOriginIsolated",null),Se([P.memoize],c.prototype,"codeCachePath",null),Se([P.memoize],c.prototype,"useCodeCache",null)}),define(te[285],ie([0,1,72,32,15,9,4,19,22,194,18,28,34,16,5,193,30,99]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let l=class yt{static{this.backupWorkspacesMetadataStorageKey="backupWorkspaces"}constructor(E,S,t,u){this.environmentMainService=E,this.configurationService=S,this.logService=t,this.stateService=u,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=I.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(r,n)=>(0,L.isEqual)(r,n,!M.isLinux)}}async initialize(){const E=this.stateService.getItem(yt.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(E.emptyWindows),this.workspaces=await this.validateWorkspaces((0,c.deserializeWorkspaceInfos)(E)),this.folders=await this.validateFolders((0,c.deserializeFolderInfos)(E)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(E,S){this.workspaces.some(u=>E.workspace.id===u.workspace.id)||(this.workspaces.push(E),this.storeWorkspacesMetadata());const t=(0,_.join)(this.backupHome,E.workspace.id);return S?this.moveBackupFolder(t,S).then(()=>t):t}async moveBackupFolder(E,S){if(await h.Promises.exists(E)&&await this.convertToEmptyWindowBackup(E),await h.Promises.exists(S))try{await h.Promises.rename(S,E)}catch(t){this.logService.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(E){return this.folders.some(S=>this.backupUriComparer.isEqual(E.folderUri,S.folderUri))||(this.folders.push(E),this.storeWorkspacesMetadata()),(0,_.join)(this.backupHome,this.getFolderHash(E))}registerEmptyWindowBackup(E){return this.emptyWindows.some(S=>!!S.backupFolder&&this.backupPathComparer.isEqual(S.backupFolder,E.backupFolder))||(this.emptyWindows.push(E),this.storeWorkspacesMetadata()),(0,_.join)(this.backupHome,E.backupFolder)}async validateWorkspaces(E){if(!Array.isArray(E))return[];const S=new Set,t=[];for(const u of E){const r=u.workspace;if(!(0,o.isWorkspaceIdentifier)(r))return[];if(!S.has(r.id)){S.add(r.id);const n=(0,_.join)(this.backupHome,r.id);await this.doHasBackups(n)?r.configPath.scheme!==s.Schemas.file||await h.Promises.exists(r.configPath.fsPath)?t.push(u):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return t}async validateFolders(E){if(!Array.isArray(E))return[];const S=[],t=new Set;for(const u of E){const r=u.folderUri,n=this.backupUriComparer.getComparisonKey(r);if(!t.has(n)){t.add(n);const i=(0,_.join)(this.backupHome,this.getFolderHash(u));await this.doHasBackups(i)?r.scheme!==s.Schemas.file||await h.Promises.exists(r.fsPath)?S.push(u):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return S}async validateEmptyWorkspaces(E){if(!Array.isArray(E))return[];const S=[],t=new Set;for(const u of E){const r=u.backupFolder;if(typeof r!="string")return[];if(!t.has(r)){t.add(r);const n=(0,_.join)(this.backupHome,r);await this.doHasBackups(n)?S.push(u):await this.deleteStaleBackup(n)}}return S}async deleteStaleBackup(E){try{await h.Promises.rm(E,h.RimRafMode.MOVE)}catch(S){this.logService.error(`Backup: Could not delete stale backup: ${S.toString()}`)}}prepareNewEmptyWindowBackup(){let E=(0,g.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(S=>!!S.backupFolder&&this.backupPathComparer.isEqual(S.backupFolder,E.id));)E=(0,g.createEmptyWorkspaceIdentifier)();return{backupFolder:E.id}}async convertToEmptyWindowBackup(E){const S=this.prepareNewEmptyWindowBackup(),t=(0,_.join)(this.backupHome,S.backupFolder);try{await h.Promises.rename(E,t)}catch(u){return this.logService.error(`Backup: Could not rename backup folder: ${u.toString()}`),!1}return this.emptyWindows.push(S),!0}async getDirtyWorkspaces(){const E=[];for(const S of this.workspaces)await this.hasBackups(S)&&E.push(S);for(const S of this.folders)await this.hasBackups(S)&&E.push(S);return E}hasBackups(E){let S;return(0,c.isEmptyWindowBackupInfo)(E)?S=(0,_.join)(this.backupHome,E.backupFolder):(0,y.isFolderBackupInfo)(E)?S=(0,_.join)(this.backupHome,this.getFolderHash(E)):S=(0,_.join)(this.backupHome,E.workspace.id),this.doHasBackups(S)}async doHasBackups(E){try{const S=await h.Promises.readdir(E);for(const t of S)try{if((await h.Promises.readdir((0,_.join)(E,t))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const E={workspaces:this.workspaces.map(({workspace:S,remoteAuthority:t})=>{const u={id:S.id,configURIPath:S.configPath.toString()};return t&&(u.remoteAuthority=t),u}),folders:this.folders.map(({folderUri:S,remoteAuthority:t})=>{const u={folderUri:S.toString()};return t&&(u.remoteAuthority=t),u}),emptyWindows:this.emptyWindows.map(({backupFolder:S,remoteAuthority:t})=>{const u={backupFolder:S};return t&&(u.remoteAuthority=t),u})};this.stateService.setItem(yt.backupWorkspacesMetadataStorageKey,E)}getFolderHash(E){const S=E.folderUri;let t;return S.scheme===s.Schemas.file?t=M.isLinux?S.fsPath:S.fsPath.toLowerCase():t=S.toString().toLowerCase(),(0,P.createHash)("md5").update(t).digest("hex")}};e.BackupMainService=l,e.BackupMainService=l=Se([J(0,f.IEnvironmentMainService),J(1,m.IConfigurationService),J(2,b.ILogService),J(3,w.IStateService)],l)}),define(te[20],ie([0,1,14,38,8,3,2,4,36,10,6,5,34,28]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,m.createDecorator)("lifecycleMainService");var b;(function(g){g[g.QUIT=1]="QUIT",g[g.KILL=2]="KILL"})(b||(e.ShutdownReason=b={}));var y;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen",g[g.Eventually=4]="Eventually"})(y||(e.LifecycleMainPhase=y={}));let o=class ft extends M.Disposable{static{this.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart"}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(l,v,E){super(),this.logService=l,this.stateService=v,this.environmentMainService=E,this._onBeforeShutdown=this._register(new _.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new _.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new _.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new _.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(ft.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(ft.QUIT_AND_RESTART_KEY)}registerListeners(){const l=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),I.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};P.app.addListener("before-quit",l);const v=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!I.isMacintosh)&&P.app.quit()};P.app.addListener("window-all-closed",v),P.app.once("will-quit",E=>{this.trace("Lifecycle#app.on(will-quit) - begin"),E.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),P.app.removeListener("before-quit",l),P.app.removeListener("window-all-closed",v),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}fireOnWillShutdown(l){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const v=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this._onWillShutdown.fire({reason:l,join(S,t){v.trace(`Lifecycle#onWillShutdown - begin '${S}'`),E.push(t.finally(()=>{v.trace(`Lifecycle#onWillShutdown - end '${S}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await s.Promises.settled(E)}catch(S){this.logService.error(S)}try{await this.stateService.close()}catch(S){this.logService.error(S)}})(),this.pendingWillShutdownPromise}set phase(l){if(l<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===l)return;this.trace(`lifecycle (main): phase changed (value: ${l})`),this._phase=l;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(l){if(l<=this._phase)return;let v=this.phaseWhen.get(l);v||(v=new s.Barrier,this.phaseWhen.set(l,v)),await v.wait()}registerWindow(l){const v=new M.DisposableStore;this.windowCounter++,v.add(l.onWillLoad(S=>this._onWillLoadWindow.fire({window:l,workspace:S.workspace,reason:S.reason})));const E=(0,c.assertIsDefined)(l.win);E.on("close",S=>{const t=l.id;if(this.windowToCloseRequest.has(t)){this.windowToCloseRequest.delete(t);return}this.trace(`Lifecycle#window.on('close') - window ID ${l.id}`),S.preventDefault(),this.unload(l,1).then(u=>{if(u){this.windowToCloseRequest.delete(t);return}this.windowToCloseRequest.add(t),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this._onBeforeCloseWindow.fire(l),l.close()})}),E.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${l.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!I.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(l,v){await this.unload(l,3)||l.reload(v)}unload(l,v){const E=this.mapWindowIdToPendingUnload.get(l.id);if(E)return E;const S=this.doUnload(l,v).finally(()=>{this.mapWindowIdToPendingUnload.delete(l.id)});return this.mapWindowIdToPendingUnload.set(l.id,S),S}async doUnload(l,v){if(!l.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${l.id}`);const E=this._quitRequested?2:v,S=await this.onBeforeUnloadWindowInRenderer(l,E);return S?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${l.id})`),this.handleWindowUnloadVeto(S)):(await this.onWillUnloadWindowInRenderer(l,E),!1)}handleWindowUnloadVeto(l){return l?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(l){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(l),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(l,v){return new Promise(E=>{const S=this.oneTimeListenerTokenGenerator++,t=`vscode:ok${S}`,u=`vscode:cancel${S}`;L.validatedIpcMain.once(t,()=>{E(!1)}),L.validatedIpcMain.once(u,()=>{E(!0)}),l.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:u,reason:v})})}onWillUnloadWindowInRenderer(l,v){return new Promise(E=>{const t=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;L.validatedIpcMain.once(t,()=>E()),l.send("vscode:onWillUnload",{replyChannel:t,reason:v})})}quit(l){return this.trace(`Lifecycle#quit() - begin (willRestart: ${l})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(l&&this.stateService.setItem(ft.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.trace("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.pendingQuitPromise)}trace(l){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(l):this.logService.trace(l)}async relaunch(l){this.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(l?.addArgs&&v.push(...l.addArgs),l?.removeArgs)for(const t of l.removeArgs){const u=v.indexOf(t);u>=0&&v.splice(u,1)}const E=()=>{try{if(I.isWindows){const t=(0,h.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.logService.error(t)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:v})};P.app.once("quit",E),await this.quit(!0)&&P.app.removeListener("quit",E)}async kill(l){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,s.timeout)(1e3),(async()=>{for(const v of P.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let E;v.webContents&&!v.webContents.isDestroyed()?E=new Promise(S=>v.once("closed",S)):E=Promise.resolve(),v.destroy(),await E}})()]),P.app.exit(l)}};e.LifecycleMainService=o,e.LifecycleMainService=o=Se([J(0,f.ILogService),J(1,w.IStateService),J(2,d.IEnvironmentMainService)],o)}),define(te[286],ie([0,1,4,3,2,6,20]),function(j,e,P,L,s,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,_.createDecorator)("keyboardLayoutMainService");let I=class extends s.Disposable{constructor(m){super(),this._onDidChangeKeyboardLayout=this._register(new L.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,m.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const m=await new Promise((f,w)=>{j(["native-keymap"],f,w)});this._keyboardLayoutData=h(m),P.isCI||m.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=h(m),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=I,e.KeyboardLayoutMainService=I=Se([J(0,M.ILifecycleMainService)],I);function h(c){const m=c.getKeyMap(),f=c.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:f}}}),define(te[287],ie([0,1,245,8,17,13,10,18,33,95,5,51,244,284]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let b=class extends f.AbstractRequestService{constructor(l,v,E,S){super(S),this.configurationService=l,this.environmentService=v,this.logService=E,this.configure(),this._register(l.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const l=this.configurationService.getValue("http");this.proxyUrl=l?.proxy,this.strictSSL=!!l?.proxyStrictSSL,this.authorization=l?.proxyAuthorization}async request(l,v){const{proxyUrl:E,strictSSL:S}=this;let t;try{t=await(0,c.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,_.getErrorMessage)(n)))}const u={...process.env,...t},r=l.agent?l.agent:await(0,w.getProxyAgent)(l.url||"",u,{proxyUrl:E,strictSSL:S});return l.agent=r,l.strictSSL=S,this.authorization&&(l.headers={...l.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(l.isChromiumNetwork?"electron":"node",l,()=>o(l,v))}async resolveProxy(l){}};e.RequestService=b,e.RequestService=b=Se([J(0,I.IConfigurationService),J(1,h.INativeEnvironmentService),J(2,m.ILogService),J(3,m.ILoggerService)],b);async function y(g){return((0,P.parse)(g.url).protocol==="https:"?await new Promise((E,S)=>{j(["https"],E,S)}):await new Promise((E,S)=>{j(["http"],E,S)})).request}async function o(g,l){return L.Promises.withAsyncBody(async(v,E)=>{const S=(0,P.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await y(g),u={hostname:S.hostname,port:S.port?parseInt(S.port):S.protocol==="https:"?443:80,protocol:S.protocol,path:S.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,M.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(u.auth=g.user+":"+g.password);const r=t(u,n=>{const i=(0,M.isNumber)(g.followRedirects)?g.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)o({...g,url:n.headers.location,followRedirects:i-1},l).then(v,E);else{let a=n;!g.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(a=n.pipe((0,d.createGunzip)())),v({res:n,stream:(0,s.streamToBufferReadableStream)(a)})}});r.on("error",E),g.timeout&&r.setTimeout(g.timeout),g.isChromiumNetwork&&r.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&r.write(g.data),r.end(),l.onCancellationRequested(()=>{r.abort(),E(new _.CancellationError)})})}e.nodeRequest=o}),define(te[288],ie([0,1,14,287]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function s(M){return P.net.request}class _ extends L.RequestService{request(I,h){return super.request({...I||{},getRawRequest:s,isChromiumNetwork:!0},h)}}e.RequestMainService=_}),define(te[83],ie([0,1,7,49,3,2,33,16,6,20,5,97,281,41,53,40]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,h.createDecorator)("storageMainService");let o=class extends _.Disposable{constructor(v,E,S,t,u,r){super(),this.logService=v,this.environmentService=E,this.userDataProfilesService=S,this.lifecycleMainService=t,this.fileService=u,this.uriIdentityService=r,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new s.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(v=>{v.window.profile&&this.profileStorage(v.window.profile).init(),v.workspace&&this.workspaceStorage(v.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(v=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=v.reason,v.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.mapProfileToStorage)v.join("profileStorage",E.close());for(const[,E]of this.mapWorkspaceToStorage)v.join("workspaceStorage",E.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(v=>{v.join((async()=>{await this.fileService.exists(v.profile.globalStorageHome)||await this.fileService.createFolder(v.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(v=>{const E=this.mapProfileToStorage.get(v.profile.id);E&&v.join(E.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const v=new w.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,L.once)(v.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),v}profileStorage(v){if((0,f.isProfileUsingDefaultStorage)(v))return this.applicationStorage;let E=this.mapProfileToStorage.get(v.id);if(!E){this.logService.trace(`StorageMainService: creating profile storage (${v.name})`),E=this.createProfileStorage(v),this.mapProfileToStorage.set(v.id,E);const S=this._register(E.onDidChangeStorage(t=>this._onDidChangeProfileStorage.fire({...t,storage:E,profile:v})));(0,L.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${v.name})`),this.mapProfileToStorage.delete(v.id),S.dispose()})}return E}createProfileStorage(v){return this.shutdownReason===2?new w.InMemoryStorageMain(this.logService,this.fileService):new w.ProfileStorageMain(v,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(v){let E=this.mapWorkspaceToStorage.get(v.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${v.id})`),E=this.createWorkspaceStorage(v),this.mapWorkspaceToStorage.set(v.id,E),(0,L.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${v.id})`),this.mapWorkspaceToStorage.delete(v.id)})),E}createWorkspaceStorage(v){return this.shutdownReason===2?new w.InMemoryStorageMain(this.logService,this.fileService):new w.WorkspaceStorageMain(v,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(v){const E=P.URI.file(v);for(const S of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(S.path&&this.uriIdentityService.extUri.isEqualOrParent(P.URI.file(S.path),E))return!0;return!1}};e.StorageMainService=o,e.StorageMainService=o=Se([J(0,m.ILogService),J(1,M.IEnvironmentService),J(2,b.IUserDataProfilesMainService),J(3,c.ILifecycleMainService),J(4,I.IFileService),J(5,y.IUriIdentityService)],o),e.IApplicationStorageMainService=(0,h.createDecorator)("applicationStorageMainService");let g=class extends f.AbstractStorageService{constructor(v,E){super(),this.userDataProfilesService=v,this.storageMainService=E,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(v){if(v===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(v){if(v===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=g,e.ApplicationStorageMainService=g=Se([J(0,d.IUserDataProfilesService),J(1,e.IStorageMainService)],g)}),define(te[289],ie([0,1,14,21,3,57,2,10,31,76,115,5,23,83,29]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let o=class extends M.Disposable{constructor(l,v,E,S,t,u){super(),this.logService=l,this.windowsMainService=v,this.credentialsService=E,this.encryptionMainService=S,this.applicationStorageMainService=t,this.productService=u,this.OLD_PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.PROXY_CREDENTIALS_SERVICE_KEY="proxy-credentials://",this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const l=s.Event.fromNodeEventEmitter(P.app,"login",(v,E,S,t,u)=>({event:v,webContents:E,req:S,authInfo:t,callback:u}));this._register(l(this.onLogin,this))}async onLogin({event:l,authInfo:v,req:E,callback:S}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&E.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}l.preventDefault();let t;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),t=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{t=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}S(t?.username,t?.password)}async resolveProxyCredentials(l){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(l);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async getAndMigrateProxyCredentials(l){try{let v=this.applicationStorageMainService.get(this.PROXY_CREDENTIALS_SERVICE_KEY+l,-1),E;if(v||(v=(0,I.withNullAsUndefined)(await this.credentialsService.getPassword(this.OLD_PROXY_CREDENTIALS_SERVICE_KEY,l)),v&&(E=await this.encryptionMainService.decrypt(v),v=await this.encryptionMainService.encrypt(E),this.applicationStorageMainService.store(this.PROXY_CREDENTIALS_SERVICE_KEY+l,v,-1,1),await this.credentialsService.deletePassword(this.OLD_PROXY_CREDENTIALS_SERVICE_KEY,l))),v){const S=JSON.parse(E??await this.encryptionMainService.decrypt(v));return{storedUsername:S.username,storedPassword:S.password}}}catch(v){this.logService.error(v)}return{storedUsername:void 0,storedPassword:void 0}}async doResolveProxyCredentials(l){this.logService.trace("auth#doResolveProxyCredentials - enter",l);const v=String((0,_.hash)({scheme:l.scheme,host:l.host,port:l.port})),{storedUsername:E,storedPassword:S}=await this.getAndMigrateProxyCredentials(v);if(this.state!==y.StoredCredentialsUsed&&typeof E=="string"&&typeof S=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:E,password:S};const t=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!t){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${t.id} to handle proxy login`);const u={authInfo:l,username:this.sessionCredentials?.username??E,password:this.sessionCredentials?.password??S,replyChannel:`vscode:proxyAuthResponse:${(0,h.generateUuid)()}`};t.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,u),this.state=y.LoginDialogShown;const r=await new Promise(n=>{const i=async(a,p,C)=>{if(p===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${t.id}`),t.win?.webContents.off("ipc-message",i),C){const k={username:C.username,password:C.password};try{if(C.remember){const D=await this.encryptionMainService.encrypt(JSON.stringify(k));this.applicationStorageMainService.store(this.PROXY_CREDENTIALS_SERVICE_KEY+v,D,-1,1)}else this.applicationStorageMainService.remove(this.PROXY_CREDENTIALS_SERVICE_KEY+v,-1)}catch(D){this.logService.error(D)}n({username:k.username,password:k.password})}else n(void 0)};t.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=r,r}};e.ProxyAuthHandler=o,e.ProxyAuthHandler=o=Se([J(0,f.ILogService),J(1,b.IWindowsMainService),J(2,c.ICredentialsMainService),J(3,m.IEncryptionMainService),J(4,d.IApplicationStorageMainService),J(5,w.IProductService)],o)}),define(te[100],ie([0,1,8,21,3,18,28,20,5,23,51,48]),function(j,e,P,L,s,_,M,I,h,c,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function w(b,y,o){return`${o.updateUrl}/api/update/${b}/${y}/${o.commit}`}e.createUpdateURL=w;let d=class{get state(){return this._state}setState(y){this.logService.info("update#setState",y.type),this._state=y,this._onStateChange.fire(y)}constructor(y,o,g,l,v,E){this.lifecycleMainService=y,this.configurationService=o,this.environmentMainService=g,this.requestService=l,this.logService=v,this.productService=E,this._state=f.State.Uninitialized,this._onStateChange=new s.Emitter,this.onStateChange=this._onStateChange.event,y.when(3).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt){this.setState(f.State.Disabled(0));return}if(this.environmentMainService.disableUpdates){this.setState(f.State.Disabled(1)),this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.setState(f.State.Disabled(3)),this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const y=this.configurationService.getValue("update.mode"),o=this.getProductQuality(y);if(!o){this.setState(f.State.Disabled(2)),this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(o),!this.url){this.setState(f.State.Disabled(4)),this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(f.State.Idle(this.getUpdateType())),y==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}y==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,g=>this.logService.error(g))}getProductQuality(y){return y==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(y=60*60*1e3){return(0,P.timeout)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(y){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(y)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(y){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(y=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}catch(o){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(o);return}}async _applySpecificUpdate(y){}getUpdateType(){return 1}doQuitAndInstall(){}};e.AbstractUpdateService=d,e.AbstractUpdateService=d=Se([J(0,I.ILifecycleMainService),J(1,_.IConfigurationService),J(2,M.IEnvironmentMainService),J(3,m.IRequestService),J(4,h.ILogService),J(5,c.IProductService)],d)}),define(te[290],ie([0,1,14,55,3,2,18,28,20,5,23,51,26,48,100]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let y=class extends b.AbstractUpdateService{get onRawError(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"error",(g,l)=>l)}get onRawUpdateNotAvailable(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",(g,l,v)=>({url:l,version:v,productVersion:v}))}get onRawUpdateDownloaded(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",(g,l,v,E)=>({releaseNotes:l,version:v,productVersion:v,date:E}))}constructor(g,l,v,E,S,t,u){super(g,l,E,S,t,u),this.telemetryService=v,this.disposables=new _.DisposableStore}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(g){this.logService.error("UpdateService error:",g);const l=this.state.type==="checking for updates"&&this.state.explicit?g:void 0;this.setState(d.State.Idle(1,l))}buildUpdateFeedUrl(g){let l;this.productService.darwinUniversalAssetId?l=this.productService.darwinUniversalAssetId:l=process.arch==="x64"?"darwin":"darwin-arm64";const v=(0,b.createUpdateURL)(l,g,this.productService);try{P.autoUpdater.setFeedURL({url:v})}catch(E){this.logService.error("Failed to set update feed URL",E);return}return v}doCheckForUpdates(g){this.setState(d.State.CheckingForUpdates(g)),P.autoUpdater.checkForUpdates()}onUpdateAvailable(g){this.state.type==="checking for updates"&&this.setState(d.State.Downloading(g))}onUpdateDownloaded(g){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:g.version}),this.setState(d.State.Ready(g)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(d.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};e.DarwinUpdateService=y,Se([L.memoize],y.prototype,"onRawError",null),Se([L.memoize],y.prototype,"onRawUpdateNotAvailable",null),Se([L.memoize],y.prototype,"onRawUpdateAvailable",null),Se([L.memoize],y.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=y=Se([J(0,h.ILifecycleMainService),J(1,M.IConfigurationService),J(2,w.ITelemetryService),J(3,I.IEnvironmentMainService),J(4,f.IRequestService),J(5,c.ILogService),J(6,m.IProductService)],y)}),define(te[291],ie([0,1,47,42,8,3,9,28,20,5,26,48]),function(j,e,P,L,s,_,M,I,h,c,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let w=class{get state(){return this._state}setState(y){this.logService.info("update#setState",y.type),this._state=y,this._onStateChange.fire(y)}constructor(y,o,g){if(this.lifecycleMainService=y,this.logService=g,this._state=f.State.Uninitialized,this._onStateChange=new _.Emitter,this.onStateChange=this._onStateChange.event,o.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(f.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,l=>this.logService.error(l))}scheduleCheckForUpdates(y=60*60*1e3){return(0,s.timeout)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(y){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(y)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(y){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(y=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(y){}};w=Se([J(0,h.ILifecycleMainService),J(1,I.IEnvironmentMainService),J(2,c.ILogService)],w);let d=class extends w{constructor(y,o,g,l,v,E){super(g,l,v),this.snap=y,this.snapRevision=o,this.telemetryService=E;const S=(0,L.watch)(M.dirname(this.snap)),t=_.Event.fromNodeEventEmitter(S,"change",(i,a)=>a),u=_.Event.filter(t,i=>i==="current"),n=_.Event.debounce(u,(i,a)=>a,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{n.dispose(),S.close()})}doCheckForUpdates(){this.setState(f.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(y=>{y?this.setState(f.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(f.State.Idle(2)))},y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(f.State.Idle(2,y.message||y))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const y=await new Promise((g,l)=>(0,L.realpath)(`${M.dirname(this.snap)}/current`,(v,E)=>v?l(v):g(E))),o=M.basename(y);return this.snapRevision!==o}isLatestVersion(){return this.isUpdateAvailable().then(void 0,y=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=d,e.SnapUpdateService=d=Se([J(2,h.ILifecycleMainService),J(3,I.IEnvironmentMainService),J(4,c.ILogService),J(5,m.ITelemetryService)],d)}),define(te[292],ie([0,1,2,20,53,30,8,29]),function(j,e,P,L,s,_,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let h=class extends P.Disposable{constructor(m,f,w){super(),this.userDataProfilesService=f,this.windowsMainService=w,this._register(m.onWillLoadWindow(d=>{d.reason===2&&this.unsetProfileForWorkspace(d.window)})),this._register(m.onBeforeCloseWindow(d=>this.unsetProfileForWorkspace(d))),this._register(new M.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(m){const f=this.getWorkspace(m),w=this.userDataProfilesService.getProfileForWorkspace(f);w?.isTransient&&(this.userDataProfilesService.unsetWorkspace(f,w.isTransient),w.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(m){return m.openedWorkspace??(0,_.toWorkspaceIdentifier)(m.backupPath,m.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const m=this.userDataProfilesService.getAssociatedEmptyWindows();if(m.length===0)return;const f=this.windowsMainService.getWindows().map(w=>this.getWorkspace(w));for(const w of m)f.some(d=>d.id===w.id)||this.userDataProfilesService.unsetWorkspace(w,!1)}};e.UserDataProfilesHandler=h,e.UserDataProfilesHandler=h=Se([J(0,L.ILifecycleMainService),J(1,s.IUserDataProfilesMainService),J(2,I.IWindowsMainService)],h)}),define(te[62],ie([0,1,14,2,3,5,311,8,15,29,70,26,20,73,37,4,132]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function g(E){return typeof E.responseWindowId=="number"}let l=class dt extends L.Disposable{static{this.ID_COUNTER=0}static{this.all=new Map}static getAll(){return Array.from(dt.all.values())}constructor(S,t,u){super(),this.logService=S,this.telemetryService=t,this.lifecycleMainService=u,this.id=String(++dt.ID_COUNTER),this._onStdout=this._register(new s.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new s.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new s.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new s.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new s.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0}log(S,t){let u;switch(this.configuration?.correlationId?u=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${S}`:u=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${S}`,t){case m.default.Error:this.logService.error(u);break;case m.default.Warning:this.logService.warn(u);break;case m.default.Info:this.logService.trace(u);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(S){const t=this.doStart(S);return t&&S.payload&&this.postMessage(S.payload),t}doStart(S){if(!this.validateCanStart())return!1;this.configuration=S;const t=`${this.configuration.type}-${this.id}`,u=h.FileAccess.asFileUri("bootstrap-fork.js").fsPath,r=this.configuration.args??[],n=this.configuration.execArgv??[],i=this.configuration.allowLoadingUnsignedLibraries,a=this.configuration.forceAllocationsToV8Sandbox,p="pipe",C=this.createEnv(S);return this.log("creating new...",m.default.Info),this.process=P.utilityProcess.fork(u,r,{serviceName:t,env:C,execArgv:n,allowLoadingUnsignedLibraries:i,forceAllocationsToV8Sandbox:a,stdio:p}),this.registerListeners(this.process,this.configuration,t),!0}createEnv(S){const t=S.env?{...S.env}:{...(0,b.deepClone)(process.env)};t.VSCODE_AMD_ENTRYPOINT=S.entryPoint,typeof S.parentLifecycleBound=="number"&&(t.VSCODE_PARENT_PID=String(S.parentLifecycleBound)),t.VSCODE_CRASH_REPORTER_PROCESS_TYPE=S.type,y.isWindows&&((0,o.isUNCAccessRestrictionsDisabled)()?t.NODE_DISABLE_UNC_ACCESS_CHECKS="1":t.NODE_UNC_HOST_ALLOWLIST=(0,o.getUNCHostAllowlist)().join("\\")),(0,d.removeDangerousEnvVariables)(t);for(const u of Object.keys(t))t[u]=String(t[u]);return t}registerListeners(S,t,u){if(S.stdout){const r=new M.StringDecoder("utf-8");this._register(s.Event.fromNodeEventEmitter(S.stdout,"data")(n=>this._onStdout.fire(typeof n=="string"?n:r.write(n))))}if(S.stderr){const r=new M.StringDecoder("utf-8");this._register(s.Event.fromNodeEventEmitter(S.stderr,"data")(n=>this._onStderr.fire(typeof n=="string"?n:r.write(n))))}this._register(s.Event.fromNodeEventEmitter(S,"message")(r=>this._onMessage.fire(r))),this._register(s.Event.fromNodeEventEmitter(S,"spawn")(()=>{this.processPid=S.pid,typeof S.pid=="number"&&dt.all.set(S.pid,{pid:S.pid,name:g(t)?`${t.type} [${t.responseWindowId}]`:t.type}),this.log("successfully created",m.default.Info)})),this._register(s.Event.fromNodeEventEmitter(S,"exit")(r=>{this.log(`received exit event with code ${r}`,m.default.Info),this._onExit.fire({pid:this.processPid,code:r,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(s.Event.fromNodeEventEmitter(P.app,"child-process-gone",(r,n)=>({event:r,details:n}))(({details:r})=>{r.type==="Utility"&&r.name===u&&(this.log(`crashed with code ${r.exitCode} and reason '${r.reason}'`,m.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:t.type,reason:r.reason,code:r.exitCode}),this._onCrash.fire({pid:this.processPid,code:r.exitCode,reason:r.reason}),this.onDidExitOrCrashOrKill())}))}once(S,t){const u=this._register(this._onMessage.event(r=>{r===S&&(u.dispose(),t())}))}postMessage(S,t){this.process&&this.process.postMessage(S,t)}connect(S){const{port1:t,port2:u}=new P.MessageChannelMain;return this.postMessage(S,[u]),t}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",m.default.Info);const S=process;return typeof S._debugProcess=="function"?(S._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",m.default.Info),this.process.kill()?(this.log("successfully killed the process",m.default.Info),this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",m.default.Warning)}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&dt.all.delete(this.processPid),this.process=void 0}async waitForExit(S){this.process&&(this.log("waiting to exit...",m.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,I.timeout)(S)]),this.process&&(this.log(`did not exit within ${S}ms, will kill it now...`,m.default.Info),this.kill()))}};e.UtilityProcess=l,e.UtilityProcess=l=Se([J(0,_.ILogService),J(1,f.ITelemetryService),J(2,w.ILifecycleMainService)],l);let v=class extends l{constructor(S,t,u,r){super(S,u,r),this.windowsMainService=t}start(S){const t=this.windowsMainService.getWindowById(S.responseWindowId);if(!t?.win||t.win.isDestroyed()||t.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.doStart(S))return!1;this.registerWindowListeners(t.win,S);const r=this.connect(S.payload);return t.win.webContents.postMessage(S.responseChannel,S.responseNonce,[r]),!0}registerWindowListeners(S,t){t.windowLifecycleBound&&(this._register(s.Event.filter(this.lifecycleMainService.onWillLoadWindow,u=>u.window.win===S)(()=>this.kill())),this._register(s.Event.fromNodeEventEmitter(S,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=v,e.WindowUtilityProcess=v=Se([J(0,_.ILogService),J(1,c.IWindowsMainService),J(2,f.ITelemetryService),J(3,w.ILifecycleMainService)],v)}),define(te[293],ie([0,1,13,5,20,8,62,29,26]),function(j,e,P,L,s,_,M,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let c=class Mt{static{this._lastId=0}constructor(f,w,d,b){this._logService=f,this._lifecycleMainService=w,this._windowsMainService=d,this._telemetryService=b,this._extHosts=new Map,this._shutdown=!1,this._lifecycleMainService.onWillShutdown(y=>{this._shutdown=!0,y.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}_getExtHost(f){const w=this._extHosts.get(f);if(!w)throw new Error("Unknown extension host!");return w}onDynamicStdout(f){return this._getExtHost(f).onStdout}onDynamicStderr(f){return this._getExtHost(f).onStderr}onDynamicMessage(f){return this._getExtHost(f).onMessage}onDynamicExit(f){return this._getExtHost(f).onExit}async createExtensionHost(){if(this._shutdown)throw(0,P.canceled)();const f=String(++Mt._lastId),w=new M.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);return this._extHosts.set(f,w),w.onExit(({pid:d,code:b,signal:y})=>{this._logService.info(`Extension host with pid ${d} exited with code: ${b}, signal: ${y}.`),setTimeout(()=>{w.dispose(),this._extHosts.delete(f)})}),{id:f}}async start(f,w){if(this._shutdown)throw(0,P.canceled)();this._getExtHost(f).start({...w,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:w.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:f})}async enableInspectPort(f){if(this._shutdown)throw(0,P.canceled)();const w=this._extHosts.get(f);return w?w.enableInspectPort():!1}async kill(f){if(this._shutdown)throw(0,P.canceled)();const w=this._extHosts.get(f);w&&w.kill()}async _killAllNow(){for(const[,f]of this._extHosts)f.kill()}async _waitForAllExit(f){const w=[];for(const[,d]of this._extHosts)w.push(d.waitForExit(f));return _.Promises.settled(w).then(()=>{})}};e.ExtensionHostStarter=c,e.ExtensionHostStarter=c=Se([J(0,L.ILogService),J(1,s.ILifecycleMainService),J(2,I.IWindowsMainService),J(3,h.ITelemetryService)],c)}),define(te[294],ie([0,1,38,8,2,28,20,5,41,39,66,62,52,90,10]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let y=class extends s.Disposable{constructor(g,l,v,E,S,t,u){super(),this.machineId=g,this.environmentMainService=l,this.userDataProfilesService=v,this.lifecycleMainService=E,this.logService=S,this.loggerMainService=t,this.policyService=u,this.firstWindowConnectionBarrier=new L.Barrier,this.utilityProcess=void 0,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){P.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(g,l)=>this.onWindowConnection(g,l)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(g,l){this.logService.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const v=await this.connect();if(g.sender.isDestroyed())return v.close();g.sender.postMessage("vscode:createSharedProcessMessageChannelResult",l,[v])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage("vscode:electron-main->shared-process=exit"),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const g=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once("vscode:shared-process->electron-main=init-done",()=>g.complete()):P.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>g.complete()),await g.p,this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const g=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once("vscode:shared-process->electron-main=ipc-ready",()=>g.complete()):P.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>g.complete()),await g.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new f.UtilityProcess(this.logService,w.NullTelemetryService,this.lifecycleMainService));const g=(0,d.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let l;g.port&&(l=["--nolazy"],g.break?l.push(`--inspect-brk=${g.port}`):l.push(`--inspect=${g.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:l})}createSharedProcessConfiguration(){return{machineId:this.machineId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(){return await this.whenIpcReady,(0,b.assertIsDefined)(this.utilityProcess).connect()}};e.SharedProcess=y,e.SharedProcess=y=Se([J(1,_.IEnvironmentMainService),J(2,h.IUserDataProfilesService),J(3,M.ILifecycleMainService),J(4,I.ILogService),J(5,m.ILoggerMainService),J(6,c.IPolicyService)],y)}),define(te[295],ie([0,1,28,90,20,5,52,62,110,38,2,3,37,18]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let b=class extends m.Disposable{constructor(o,g,l,v,E){super(),this._reconnectConstants=o,this._configurationService=g,this._environmentMainService=l,this._lifecycleMainService=v,this._logService=E,this.utilityProcess=void 0,this._onRequestConnection=new f.Emitter,this.onRequestConnection=this._onRequestConnection.event,this._onWillShutdown=new f.Emitter,this.onWillShutdown=this._onWillShutdown.event,this._lifecycleMainService.onWillShutdown(()=>this._onWillShutdown.fire()),c.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(S,t)=>this._onWindowConnection(S,t)),this._register((0,m.toDisposable)(()=>{c.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.utilityProcess=new I.UtilityProcess(this._logService,M.NullTelemetryService,this._lifecycleMainService);const o=(0,L.parsePtyHostDebugPort)(this._environmentMainService.args,this._environmentMainService.isBuilt),g=o.port?["--nolazy",`--inspect${o.break?"-brk":""}=${o.port}`]:void 0;this.utilityProcess.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:g,args:["--logsPath",this._environmentMainService.logsHome.fsPath],env:this._createPtyHostConfiguration()});const l=this.utilityProcess.connect(),v=new h.Client(l,"ptyHost"),E=new m.DisposableStore;return E.add(v),E.add((0,m.toDisposable)(()=>{this.utilityProcess?.kill(),this.utilityProcess?.dispose(),this.utilityProcess=void 0})),{client:v,store:E,onDidProcessExit:this.utilityProcess.onExit}}_createPtyHostConfiguration(){this._environmentMainService.unsetSnapExportedVariables();const o={...(0,w.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this._reconnectConstants.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this._reconnectConstants.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this._reconnectConstants.scrollback)},g=this._configurationService.getValue("terminal.integrated.developer.ptyHost.latency");g&&typeof g=="number"&&(o.VSCODE_LATENCY=String(g));const l=this._configurationService.getValue("terminal.integrated.developer.ptyHost.startupDelay");return l&&typeof l=="number"&&(o.VSCODE_STARTUP_DELAY=String(l)),this._environmentMainService.restoreSnapExportedVariables(),o}_onWindowConnection(o,g){this._onRequestConnection.fire();const l=this.utilityProcess.connect();if(o.sender.isDestroyed()){l.close();return}o.sender.postMessage("vscode:createPtyHostMessageChannelResult",g,[l])}};e.ElectronPtyHostStarter=b,e.ElectronPtyHostStarter=b=Se([J(1,d.IConfigurationService),J(2,P.IEnvironmentMainService),J(3,s.ILifecycleMainService),J(4,_.ILogService)],b)}),define(te[296],ie([0,1,2,6,5,29,62,26,57,3,8,20]),function(j,e,P,L,s,_,M,I,h,c,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,L.createDecorator)("utilityProcessWorker");let w=class extends P.Disposable{constructor(y,o,g,l){super(),this.logService=y,this.windowsMainService=o,this.telemetryService=g,this.lifecycleMainService=l,this.workers=new Map}async createWorker(y){const o=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${o})`);const g=this.hash(y);this.workers.has(g)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${o})`),this.disposeWorker(y));const l=new d(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,y);if(!l.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(g,l);const v=new m.DeferredPromise;return c.Event.once(l.onDidTerminate)(E=>{E.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.workers.delete(g),v.complete({reason:E})}),v.p}hash(y){return(0,h.hash)({moduleId:y.process.moduleId,windowId:y.reply.windowId})}async disposeWorker(y){const o=this.hash(y),g=this.workers.get(o);g&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),g.kill(),this.workers.delete(o))}};e.UtilityProcessWorkerMainService=w,e.UtilityProcessWorkerMainService=w=Se([J(0,s.ILogService),J(1,_.IWindowsMainService),J(2,I.ITelemetryService),J(3,f.ILifecycleMainService)],w);let d=class extends P.Disposable{constructor(y,o,g,l,v){super(),this.logService=y,this.windowsMainService=o,this.telemetryService=g,this.lifecycleMainService=l,this.configuration=v,this._onDidTerminate=this._register(new c.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=new M.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(y=>this._onDidTerminate.fire({code:y.code,signal:y.signal}))),this._register(this.utilityProcess.onCrash(y=>this._onDidTerminate.fire({code:y.code,signal:"ECRASH"})))}spawn(){const o=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:o,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};d=Se([J(0,s.ILogService),J(1,_.IWindowsMainService),J(2,I.ITelemetryService),J(3,f.ILifecycleMainService)],d)}),define(te[297],ie([0,1,14,2,4,19,7,18,20,5,34,29,128,30]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let b=class bt extends L.Disposable{static{this.windowsStateStorageKey="windowsState"}get state(){return this._state}constructor(E,S,t,u,r){super(),this.windowsMainService=E,this.stateService=S,this.lifecycleMainService=t,this.logService=u,this.configurationService=r,this._state=y(this.stateService.getItem(bt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){P.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(E=>this.onBeforeCloseWindow(E)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(E=>{E.newCount-E.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(E=>this.onBeforeCloseWindow(E))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const E=new Set,S={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!S.lastActiveWindow){let r=this.windowsMainService.getLastActiveWindow();(!r||r.isExtensionDevelopmentHost)&&(r=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),r&&(S.lastActiveWindow=this.toWindowState(r),S.lastActiveWindow.uiState.mode===3&&E.add(S.lastActiveWindow.uiState.display))}const t=this.windowsMainService.getWindows().find(r=>r.isExtensionDevelopmentHost&&!r.isExtensionTestHost);t&&(S.lastPluginDevelopmentHostWindow=this.toWindowState(t),S.lastPluginDevelopmentHostWindow.uiState.mode===3&&(E.has(S.lastPluginDevelopmentHostWindow.uiState.display)?s.isMacintosh&&!t.win?.isSimpleFullScreen()&&(S.lastPluginDevelopmentHostWindow.uiState.mode=1):E.add(S.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(S.openedWindows=this.windowsMainService.getWindows().filter(r=>!r.isExtensionDevelopmentHost).map(r=>{const n=this.toWindowState(r);return n.uiState.mode===3&&(E.has(n.uiState.display)?s.isMacintosh&&n.windowId!==S.lastActiveWindow?.windowId&&!r.win?.isSimpleFullScreen()&&(n.uiState.mode=1):E.add(n.uiState.display)),n}));const u=g(S);this.stateService.setItem(bt.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(E){if(this.lifecycleMainService.quitRequested)return;const S=this.toWindowState(E);E.isExtensionDevelopmentHost&&!E.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=S:!E.isExtensionDevelopmentHost&&E.openedWorkspace&&this._state.openedWindows.forEach(t=>{const u=(0,d.isWorkspaceIdentifier)(E.openedWorkspace)&&t.workspace?.id===E.openedWorkspace.id,r=(0,d.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&t.folderUri&&_.extUriBiasedIgnorePathCase.isEqual(t.folderUri,E.openedWorkspace.uri);(u||r)&&(t.uiState=S.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=S)}toWindowState(E){return{windowId:E.id,workspace:(0,d.isWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace:void 0,folderUri:(0,d.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace.uri:void 0,backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.serializeWindowState()}}getNewWindowState(E){const S=this.doGetNewWindowState(E),t=this.configurationService.getValue("window");if(S.mode===3){let u;S.hasDefaultState?u=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):u=!!(this.lifecycleMainService.wasRestarted||t?.restoreFullscreen),u||(S.mode=1)}return S}doGetNewWindowState(E){const S=this.windowsMainService.getLastActiveWindow();if(!E.extensionTestsPath){if(E.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=E.workspace;if((0,d.isWorkspaceIdentifier)(a)){const C=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===a.id).map(k=>k.uiState);if(C.length)return C[0]}if((0,d.isSingleFolderWorkspaceIdentifier)(a)){const C=this.state.openedWindows.filter(k=>k.folderUri&&_.extUriBiasedIgnorePathCase.isEqual(k.folderUri,a.uri)).map(k=>k.uiState);if(C.length)return C[0]}else if(E.backupPath){const C=this.state.openedWindows.filter(k=>k.backupPath===E.backupPath).map(k=>k.uiState);if(C.length)return C[0]}const p=this.lastClosedState||this.state.lastActiveWindow;if(!S&&p)return p.uiState}let t;const u=P.screen.getAllDisplays();if(u.length===1)t=u[0];else{if(s.isMacintosh){const a=P.screen.getCursorScreenPoint();t=P.screen.getDisplayNearestPoint(a)}!t&&S&&(t=P.screen.getDisplayMatching(S.getBounds())),t||(t=P.screen.getPrimaryDisplay()||u[0])}let r=(0,w.defaultWindowState)();r.x=Math.round(t.bounds.x+t.bounds.width/2-r.width/2),r.y=Math.round(t.bounds.y+t.bounds.height/2-r.height/2);const n=this.configurationService.getValue("window");let i=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")r.mode=0,i=!1;else if(n.newWindowDimensions==="fullscreen")r.mode=3,i=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&S){const a=S.serializeWindowState();a.mode===3?r.mode=3:r=a,i=r.mode!==3&&n.newWindowDimensions==="offset"}}return i&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(E){if(this.windowsMainService.getWindows().length===0)return E;E.x=typeof E.x=="number"?E.x:0,E.y=typeof E.y=="number"?E.y:0;const S=this.windowsMainService.getWindows().map(t=>t.getBounds());for(;S.some(t=>t.x===E.x||t.y===E.y);)E.x+=30,E.y+=30;return E}};e.WindowsStateHandler=b,e.WindowsStateHandler=b=Se([J(0,f.IWindowsMainService),J(1,m.IStateService),J(2,h.ILifecycleMainService),J(3,c.ILogService),J(4,I.IConfigurationService)],b);function y(v){const E={openedWindows:[]},S=v||{openedWindows:[]};return S.lastActiveWindow&&(E.lastActiveWindow=o(S.lastActiveWindow)),S.lastPluginDevelopmentHostWindow&&(E.lastPluginDevelopmentHostWindow=o(S.lastPluginDevelopmentHostWindow)),Array.isArray(S.openedWindows)&&(E.openedWindows=S.openedWindows.map(t=>o(t))),E}e.restoreWindowsState=y;function o(v){const E={uiState:v.uiState};return v.backupPath&&(E.backupPath=v.backupPath),v.remoteAuthority&&(E.remoteAuthority=v.remoteAuthority),v.folder&&(E.folderUri=M.URI.parse(v.folder)),v.workspaceIdentifier&&(E.workspace={id:v.workspaceIdentifier.id,configPath:M.URI.parse(v.workspaceIdentifier.configURIPath)}),E}function g(v){return{lastActiveWindow:v.lastActiveWindow&&l(v.lastActiveWindow),lastPluginDevelopmentHostWindow:v.lastPluginDevelopmentHostWindow&&l(v.lastPluginDevelopmentHostWindow),openedWindows:v.openedWindows.map(E=>l(E))}}e.getWindowsStateStoreData=g;function l(v){return{workspaceIdentifier:v.workspace&&{id:v.workspace.id,configURIPath:v.workspace.configPath.toString()},folder:v.folderUri&&v.folderUri.toString(),backupPath:v.backupPath,remoteAuthority:v.remoteAuthority,uiState:v.uiState}}}),define(te[54],ie([0,1,14,3,45,2,15,9,19,10,22,192,64,61,28,6,5,53,130,30,98,99]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o,g,l,v,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,y.createDecorator)("workspacesManagementMainService");let t=class extends _.Disposable{constructor(r,n,i,a,p){super(),this.environmentMainService=r,this.logService=n,this.userDataProfilesMainService=i,this.backupMainService=a,this.dialogMainService=p,this._onDidDeleteUntitledWorkspace=this._register(new L.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new L.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const r=(await m.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(n=>(0,h.joinPath)(this.untitledWorkspacesHome,n,v.UNTITLED_WORKSPACE_NAME));for(const n of r){const i=(0,S.getWorkspaceIdentifier)(n),a=await this.resolveLocalWorkspace(n);a?this.untitledWorkspaces.push({workspace:i,remoteAuthority:a.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(r){r.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${r}).`)}}resolveLocalWorkspace(r){return this.doResolveLocalWorkspace(r,n=>m.Promises.readFile(n,"utf8"))}doResolveLocalWorkspace(r,n){if(this.isWorkspacePath(r)&&r.scheme===M.Schemas.file)try{const i=n(r.fsPath);return i instanceof Promise?i.then(a=>this.doResolveWorkspace(r,a),a=>{}):this.doResolveWorkspace(r,i)}catch{return}}isWorkspacePath(r){return(0,v.isUntitledWorkspace)(r,this.environmentMainService)||(0,v.hasWorkspaceFileExtension)(r)}doResolveWorkspace(r,n){try{const i=this.doParseStoredWorkspace(r,n),a=(0,S.getWorkspaceIdentifier)(r);return{id:a.id,configPath:a.configPath,folders:(0,E.toWorkspaceFolders)(i.folders,a.configPath,h.extUriBiasedIgnorePathCase),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.logService.warn(i.toString())}}doParseStoredWorkspace(r,n){const i=(0,s.parse)(n);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(a=>(0,E.isStoredWorkspaceFolder)(a));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(r,n){const{workspace:i,storedWorkspace:a}=this.newUntitledWorkspace(r,n),p=i.configPath.fsPath;return await m.Promises.mkdir((0,I.dirname)(p),{recursive:!0}),await m.Promises.writeFile(p,JSON.stringify(a,null,"	")),this.untitledWorkspaces.push({workspace:i,remoteAuthority:n}),i}newUntitledWorkspace(r=[],n){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),a=(0,h.joinPath)(this.untitledWorkspacesHome,i),p=(0,h.joinPath)(a,v.UNTITLED_WORKSPACE_NAME),C=[];for(const k of r)C.push((0,E.getStoredWorkspaceFolder)(k.uri,!0,k.name,a,h.extUriBiasedIgnorePathCase));return{workspace:(0,S.getWorkspaceIdentifier)(p),storedWorkspace:{folders:C,remoteAuthority:n}}}async getWorkspaceIdentifier(r){return(0,S.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,v.isUntitledWorkspace)(r.configPath,this.environmentMainService)}async deleteUntitledWorkspace(r){this.isUntitledWorkspace(r)&&(await this.doDeleteUntitledWorkspace(r),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(r),this._onDidDeleteUntitledWorkspace.fire(r))}async doDeleteUntitledWorkspace(r){const n=(0,h.originalFSPath)(r.configPath);try{await m.Promises.rm((0,I.dirname)(n));const i=(0,I.join)(this.environmentMainService.workspaceStorageHome.fsPath,r.id);await m.Promises.exists(i)&&await m.Promises.writeFile((0,I.join)(i,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(a=>a.workspace.id!==r.id)}catch(i){this.logService.warn(`Unable to delete untitled workspace ${n} (${i}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(r,n,i){if(!r||!r.win||!r.isReady||!await this.isValidTargetWorkspacePath(r,n,i))return;const p=await this.doEnterWorkspace(r,(0,S.getWorkspaceIdentifier)(i));if(p)return this._onDidEnterWorkspace.fire({window:r,workspace:p.workspace}),p}async isValidTargetWorkspacePath(r,n,i){return i?(0,v.isWorkspaceIdentifier)(r.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,i)?!1:(0,l.findWindowOnWorkspaceOrFolder)(n,i)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,f.localize)(0,null)],message:(0,f.localize)(1,null,(0,h.basename)(i)),detail:(0,f.localize)(2,null)},(0,c.withNullAsUndefined)(P.BrowserWindow.getFocusedWindow())),!1):!0:!0}async doEnterWorkspace(r,n){if(!r.config)return;r.focus();let i;return r.config.extensionDevelopmentPath||(r.config.backupPath?i=await this.backupMainService.registerWorkspaceBackup({workspace:n,remoteAuthority:r.remoteAuthority},r.config.backupPath):i=this.backupMainService.registerWorkspaceBackup({workspace:n,remoteAuthority:r.remoteAuthority})),(0,v.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&await this.deleteUntitledWorkspace(r.openedWorkspace),r.config.workspace=n,r.config.backupPath=i,{workspace:n,backupPath:i}}};e.WorkspacesManagementMainService=t,e.WorkspacesManagementMainService=t=Se([J(0,b.IEnvironmentMainService),J(1,o.ILogService),J(2,g.IUserDataProfilesMainService),J(3,w.IBackupMainService),J(4,d.IDialogMainService)],t)}),define(te[133],ie([0,1,14,38,21,6,29,30,54,10,5,62]),function(j,e,P,L,s,_,M,I,h,c,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,_.createDecorator)(e.ID);let w=class{constructor(b,y,o){this.windowsMainService=b,this.workspacesManagementMainService=y,this.logService=o}async getRemoteDiagnostics(b){const y=this.windowsMainService.getWindows();return(await Promise.all(y.map(async g=>{const l=g.remoteAuthority;if(!l)return;const v=`vscode:getDiagnosticInfoResponse${g.id}`,E={includeProcesses:b.includeProcesses,folders:b.includeWorkspaceMetadata?await this.getFolderURIs(g):void 0};return new Promise(S=>{g.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:v,args:E}),L.validatedIpcMain.once(v,(t,u)=>{u||S({hostName:l,errorMessage:`Unable to resolve connection to '${l}'.`}),S(u)}),setTimeout(()=>{S({hostName:l,errorMessage:`Connection to '${l}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const b=[];for(const o of P.BrowserWindow.getAllWindows()){const g=this.windowsMainService.getWindowById(o.id);g?b.push(await this.codeWindowToInfo(g)):b.push(this.browserWindowToInfo(o))}const y=[];for(const{pid:o,name:g}of f.UtilityProcess.getAll())y.push({pid:o,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:b,pidToNames:y,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async codeWindowToInfo(b){const y=await this.getFolderURIs(b),o=(0,c.assertIsDefined)(b.win);return this.browserWindowToInfo(o,y,b.remoteAuthority)}browserWindowToInfo(b,y=[],o){return{id:b.id,pid:b.webContents.getOSProcessId(),title:b.getTitle(),folderURIs:y,remoteAuthority:o}}async getFolderURIs(b){const y=[],o=b.openedWorkspace;if((0,I.isSingleFolderWorkspaceIdentifier)(o))y.push(o.uri);else if((0,I.isWorkspaceIdentifier)(o)){const g=await this.workspacesManagementMainService.resolveLocalWorkspace(o.configPath);g&&g.folders.forEach(v=>{y.push(v.uri)})}return y}};e.DiagnosticsMainService=w,e.DiagnosticsMainService=w=Se([J(0,M.IWindowsMainService),J(1,h.IWorkspacesManagementMainService),J(2,m.ILogService)],w)}),define(te[67],ie([0,1,47,14,27,155,55,3,2,15,9,4,7,105,87,22,103,180,61,28,6,20,5,23,80,29,30,54,17,242,234]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o,g,l,v,E,S,t,u,r,n,i,a,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,E.createDecorator)("nativeHostMainService");let D=class extends h.Disposable{constructor(O,U,q,se,ne,ee,ae,ue){super(),this.windowsMainService=O,this.dialogMainService=U,this.lifecycleMainService=q,this.environmentMainService=se,this.logService=ne,this.productService=ee,this.themeMainService=ae,this.workspacesManagementMainService=ue,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,G=>G.id),this.onDidTriggerSystemContextMenu=I.Event.filter(I.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:G,x:Y,y:F})=>({windowId:G.id,x:Y,y:F})),({windowId:G})=>!!this.windowsMainService.getWindowById(G)),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(G,Y)=>Y.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(G,Y)=>Y.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(G,Y)=>Y.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),G=>!!G),G=>G.id),I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(G,Y)=>Y.id),G=>!!this.windowsMainService.getWindowById(G))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(G,Y,F)=>F),G=>!(Array.isArray(G)&&G.length===1&&G[0]==="workArea")),I.Event.fromNodeEventEmitter(L.screen,"display-added"),I.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace??(0,i.toWorkspaceIdentifier)(U.backupPath,U.isExtensionDevelopmentHost),title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(O){return this.windowsMainService.getWindowCount()}async getActiveWindowId(O){const U=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(U)return U.id}openWindow(O,U,q){return Array.isArray(U)?this.doOpenWindow(O,U,q):this.doOpenEmptyWindow(O,U)}async doOpenWindow(O,U,q=Object.create(null)){U.length>0&&await this.windowsMainService.open({context:5,contextWindowId:O,urisToOpen:U,cli:this.environmentMainService.args,forceNewWindow:q.forceNewWindow,forceReuseWindow:q.forceReuseWindow,preferNewWindow:q.preferNewWindow,diffMode:q.diffMode,mergeMode:q.mergeMode,addMode:q.addMode,gotoLineMode:q.gotoLineMode,noRecentEntry:q.noRecentEntry,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:q.remoteAuthority||void 0,forceProfile:q.forceProfile,forceTempProfile:q.forceTempProfile})}async doOpenEmptyWindow(O,U){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:O},U)}async toggleFullScreen(O){this.windowById(O)?.toggleFullScreen()}async handleTitleDoubleClick(O){this.windowById(O)?.handleTitleDoubleClick()}async isMaximized(O){const U=this.windowById(O);return U?.win?U.win.isMaximized():!1}async maximizeWindow(O){const U=this.windowById(O);U?.win&&U.win.maximize()}async unmaximizeWindow(O){const U=this.windowById(O);U?.win&&U.win.unmaximize()}async minimizeWindow(O){const U=this.windowById(O);U?.win&&U.win.minimize()}async updateWindowControls(O,U){const q=this.windowById(O);q&&q.updateWindowControls(U)}async focusWindow(O,U){U&&typeof U.windowId=="number"&&(O=U.windowId),this.windowById(O)?.focus({force:U?.force??!1})}async setMinimumSize(O,U,q){const se=this.windowById(O);if(se?.win){const[ne,ee]=se.win.getSize(),[ae,ue]=se.win.getMinimumSize(),[G,Y]=[U??ae,q??ue],[F,N]=[Math.max(ne,G),Math.max(ee,Y)];(ae!==G||ue!==Y)&&se.win.setMinimumSize(G,Y),(ne!==F||ee!==N)&&se.win.setSize(F,N)}}async saveWindowSplash(O,U){this.themeMainService.saveWindowSplash(O,U)}async installShellCommand(O){const{source:U,target:q}=await this.getShellCommandLink();try{const{symbolicLink:se}=await y.SymlinkSupport.stat(U);if(se&&!se.dangling){const ne=await(0,d.realpath)(U);if(q===ne)return}await y.Promises.unlink(U)}catch(se){if(se.code!=="ENOENT")throw se}try{await y.Promises.symlink(q,U)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:ne}=await this.showMessageBox(O,{type:"info",message:(0,g.localize)(0,null,this.productService.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(ne===0)try{const ee=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${q}' '${U}'\\" with administrator privileges"`;await(0,_.promisify)(P.exec)(ee)}catch{throw new Error((0,g.localize)(3,null,U))}}}async uninstallShellCommand(O){const{source:U}=await this.getShellCommandLink();try{await y.Promises.unlink(U)}catch(q){switch(q.code){case"EACCES":{const{response:se}=await this.showMessageBox(O,{type:"info",message:(0,g.localize)(4,null,this.productService.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(se===0)try{const ne=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,_.promisify)(P.exec)(ne)}catch{throw new Error((0,g.localize)(7,null,U))}break}case"ENOENT":break;default:throw q}}}async getShellCommandLink(){const O=(0,m.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),U=`/usr/local/bin/${this.productService.applicationName}`;if(!await y.Promises.exists(O))throw new Error((0,g.localize)(8,null,O));return{source:U,target:O}}async showMessageBox(O,U){return this.dialogMainService.showMessageBox(U,this.toBrowserWindow(O))}async showSaveDialog(O,U){return this.dialogMainService.showSaveDialog(U,this.toBrowserWindow(O))}async showOpenDialog(O,U){return this.dialogMainService.showOpenDialog(U,this.toBrowserWindow(O))}toBrowserWindow(O){const U=this.windowById(O);if(U?.win)return U.win}async pickFileFolderAndOpen(O,U){const q=await this.dialogMainService.pickFileFolder(U);q&&await this.doOpenPicked(await Promise.all(q.map(async se=>await y.SymlinkSupport.existsDirectory(se)?{folderUri:w.URI.file(se)}:{fileUri:w.URI.file(se)})),U,O)}async pickFolderAndOpen(O,U){const q=await this.dialogMainService.pickFolder(U);q&&await this.doOpenPicked(q.map(se=>({folderUri:w.URI.file(se)})),U,O)}async pickFileAndOpen(O,U){const q=await this.dialogMainService.pickFile(U);q&&await this.doOpenPicked(q.map(se=>({fileUri:w.URI.file(se)})),U,O)}async pickWorkspaceAndOpen(O,U){const q=await this.dialogMainService.pickWorkspace(U);q&&await this.doOpenPicked(q.map(se=>({workspaceUri:w.URI.file(se)})),U,O)}async doOpenPicked(O,U,q){await this.windowsMainService.open({context:3,contextWindowId:q,cli:this.environmentMainService.args,urisToOpen:O,forceNewWindow:U.forceNewWindow})}async showItemInFolder(O,U){L.shell.showItemInFolder(U)}async setRepresentedFilename(O,U){this.windowById(O)?.setRepresentedFilename(U)}async setDocumentEdited(O,U){this.windowById(O)?.setDocumentEdited(U)}async openExternal(O,U){return this.environmentMainService.unsetSnapExportedVariables(),L.shell.openExternal(U),this.environmentMainService.restoreSnapExportedVariables(),!0}moveItemToTrash(O,U){return L.shell.trashItem(U)}async isAdmin(){let O;return f.isWindows?O=(await new Promise((U,q)=>{j(["native-is-elevated"],U,q)}))():O=process.getuid()===0,O}async writeElevated(O,U,q,se){const ne=await new Promise((ee,ae)=>{j(["@vscode/sudo-prompt"],ee,ae)});return new Promise((ee,ae)=>{const ue=[`"${this.cliPath}"`];se?.unlock&&ue.push("--file-chmod"),ue.push("--file-write",`"${U.fsPath}"`,`"${q.fsPath}"`);const G={name:this.productService.nameLong.replace("-",""),icns:f.isMacintosh&&this.environmentMainService.isBuilt?(0,m.join)((0,m.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ne.exec(ue.join(" "),G,(Y,F,N)=>{F&&this.logService.trace(`[sudo-prompt] received stdout: ${F}`),N&&this.logService.trace(`[sudo-prompt] received stderr: ${N}`),Y?ae(Y):ee(void 0)})})}async isRunningUnderARM64Translation(){return f.isLinux||f.isWindows?!1:L.app.runningUnderARM64Translation}get cliPath(){return f.isWindows?this.environmentMainService.isBuilt?(0,m.join)((0,m.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,m.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):f.isLinux?this.environmentMainService.isBuilt?(0,m.join)((0,m.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,m.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,m.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,m.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return b.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return f.isWindows&&(0,C.hasWSLFeatureInstalled)()}async killProcess(O,U,q){process.kill(U,q)}async readClipboardText(O,U){return L.clipboard.readText(U)}async writeClipboardText(O,U,q){return L.clipboard.writeText(U,q)}async readClipboardFindText(O){return L.clipboard.readFindText()}async writeClipboardFindText(O,U){return L.clipboard.writeFindText(U)}async writeClipboardBuffer(O,U,q,se){return L.clipboard.writeBuffer(U,Buffer.from(q.buffer),se)}async readClipboardBuffer(O,U){return p.VSBuffer.wrap(L.clipboard.readBuffer(U))}async hasClipboard(O,U,q){return L.clipboard.has(U,q)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(O,U){this.windowById(O)?.updateTouchBar(U)}async notifyReady(O){this.windowById(O)?.setReady()}async relaunch(O,U){return this.lifecycleMainService.relaunch(U)}async reload(O,U){const q=this.windowById(O);if(q){if((0,i.isWorkspaceIdentifier)(q.openedWorkspace)){const se=q.openedWorkspace.configPath;if(se.scheme===c.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(se))?.transient)return this.openWindow(q.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(q,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(O){this.closeWindowById(O,O)}async closeWindowById(O,U){const q=this.windowById(U);if(q?.win)return q.win.close()}async quit(O){const U=this.windowsMainService.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&U.win?U.win.close():this.lifecycleMainService.quit()}async exit(O,U){await this.lifecycleMainService.kill(U)}async resolveProxy(O,U){return this.windowById(O)?.win?.webContents?.session?.resolveProxy(U)}findFreePort(O,U,q,se,ne=1){return(0,o.findFreePort)(U,q,se,ne)}async openDevTools(O,U){const q=this.windowById(O);q?.win&&q.win.webContents.openDevTools(U)}async toggleDevTools(O){const U=this.windowById(O);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(O,U){const q=this.windowById(O);q?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&q.win.webContents.sendInputEvent(U)}async profileRenderer(O,U,q){const se=this.windowById(O);if(!se||!se.win)throw new Error;return await new k.WindowProfiler(se.win,U,this.logService).inspect(q)}async windowsGetStringRegKey(O,U,q,se){if(!f.isWindows)return;const ne=await new Promise((ee,ae)=>{j(["@vscode/windows-registry"],ee,ae)});try{return ne.GetStringRegKey(U,q,se)}catch{return}}windowById(O){if(typeof O=="number")return this.windowsMainService.getWindowById(O)}};e.NativeHostMainService=D,Se([M.memoize],D.prototype,"cliPath",null),e.NativeHostMainService=D=Se([J(0,n.IWindowsMainService),J(1,l.IDialogMainService),J(2,S.ILifecycleMainService),J(3,v.IEnvironmentMainService),J(4,t.ILogService),J(5,u.IProductService),J(6,r.IThemeMainService),J(7,a.IWorkspacesManagementMainService)],D)}),define(te[298],ie([0,1,14,38,27,2,15,4,107,178,91,133,61,28,5,67,78,23,79,81,32,10,34,62,21,7,29,8]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o,g,l,v,E,S,t,u,r,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const p="issue.processExplorerWindowState";let C=class Rt{static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(A,O,U,q,se,ne,ee,ae,ue,G,Y){this.userEnv=A,this.environmentMainService=O,this.logService=U,this.diagnosticsService=q,this.diagnosticsMainService=se,this.dialogMainService=ne,this.nativeHostMainService=ee,this.protocolMainService=ae,this.productService=ue,this.stateService=G,this.windowsMainService=Y,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){L.validatedIpcMain.on("vscode:listProcesses",async A=>{const O=[];try{O.push({name:(0,c.localize)(0,null),rootProcess:await(0,h.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(q=>{(0,m.isRemoteDiagnosticError)(q)?O.push({name:q.hostName,rootProcess:q}):q.processes&&O.push({name:q.hostName,rootProcess:q.processes})})}catch(U){this.logService.error(`Listing processes failed: ${U}`)}this.safeSend(A,"vscode:listProcessesResponse",O)}),L.validatedIpcMain.on("vscode:workbenchCommand",(A,O)=>{const{id:U,from:q,args:se}=O;let ne;switch(q){case"processExplorer":ne=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${q}`)}ne?.webContents.send("vscode:runAction",{id:U,from:q,args:se})}),L.validatedIpcMain.on("vscode:closeProcessExplorer",A=>{this.processExplorerWindow?.close()}),L.validatedIpcMain.on("vscode:pidToNameRequest",async A=>{const O=await this.diagnosticsMainService.getMainDiagnostics(),U=[];for(const q of O.windows)U.push([q.pid,`window [${q.id}] (${q.title})`]);for(const{pid:q,name:se}of u.UtilityProcess.getAll())U.push([q,se]);this.safeSend(A,"vscode:pidToNameResponse",U)})}async openReporter(A){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=P.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const O=new _.DisposableStore,U=O.add(this.protocolMainService.createIPCObjectUrl()),q=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(q,U,{backgroundColor:A.styles.backgroundColor,title:(0,c.localize)(1,null),zoomLevel:A.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:A,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:o.default}),this.issueReporterWindow.loadURL(M.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,O.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,O.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(A){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=P.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const O=new _.DisposableStore,U=O.add(this.protocolMainService.createIPCObjectUrl()),q=this.stateService.getItem(p,void 0),se=k(q)?q:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(se,U,{backgroundColor:A.styles.backgroundColor,title:(0,c.localize)(2,null),zoomLevel:A.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:A,product:o.default}),this.processExplorerWindow.loadURL(M.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,O.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,O.dispose())});const ne=()=>{if(!this.processExplorerWindow)return;const ee=this.processExplorerWindow.getSize(),ae=this.processExplorerWindow.getPosition();if(!ee||!ae)return;const ue={width:ee[0],height:ee[1],x:ae[0],y:ae[1]};this.stateService.setItem(p,ue)};this.processExplorerWindow.on("moved",ne),this.processExplorerWindow.on("resized",ne)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}async stopTracing(){if(!this.environmentMainService.args.trace)return;const A=await P.contentTracing.stopRecording(`${(0,E.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,c.localize)(3,null),detail:(0,c.localize)(4,null,A),buttons:[(0,c.localize)(5,null)]},(0,S.withNullAsUndefined)(P.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,A)}async getSystemStatus(){const[A,O]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(A,O)}async $getSystemInfo(){const[A,O]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(A,O)}async $getPerformanceInfo(){try{const[A,O]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(A,O)}catch(A){throw this.logService.warn("issueService#getPerformanceInfo ",A.message),A}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(A){this.logService.error(A)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:A}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,c.localize)(6,null),buttons:[(0,c.localize)(7,null),(0,c.localize)(8,null)]},this.issueReporterWindow);A===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:A}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,c.localize)(9,null),buttons:[(0,c.localize)(10,null),(0,c.localize)(11,null)]},this.issueReporterWindow);return A===0}return!1}async $getIssueReporterUri(A){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const O=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!O)throw new Error("Window not found");const U=`vscode:triggerIssueUriRequestHandlerResponse${O.id}`;return a.Promises.withAsyncBody(async(q,se)=>{const ne=new r.CancellationTokenSource;O.sendWhenReady("vscode:triggerIssueUriRequestHandler",ne.token,{replyChannel:U,extensionId:A}),L.validatedIpcMain.once(U,(ee,ae)=>{q(n.URI.parse(ae))});try{await(0,a.timeout)(5e3),ne.cancel(),se(new Error("Timed out waiting for issue reporter URI"))}finally{L.validatedIpcMain.removeHandler(U)}})}async $closeReporter(){this.issueReporterWindow?.close()}async closeProcessExplorer(){this.processExplorerWindow?.close()}focusWindow(A){A.isMinimized()&&A.restore(),A.focus()}safeSend(A,O,...U){A.sender.isDestroyed()||A.sender.send(O,...U)}createBrowserWindow(A,O,U,q){const se=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:A.width,height:A.height,minWidth:300,minHeight:200,x:A.x,y:A.y,title:U.title,backgroundColor:U.backgroundColor||Rt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${O.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,v.zoomLevelToZoomFactor)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return se.setMenuBarVisibility(!1),se}getWindowPosition(A,O,U){let q;const se=P.screen.getAllDisplays();if(se.length===1)q=se[0];else{if(I.isMacintosh){const ae=P.screen.getCursorScreenPoint();q=P.screen.getDisplayNearestPoint(ae)}!q&&A&&(q=P.screen.getDisplayMatching(A.getBounds())),q||(q=P.screen.getPrimaryDisplay()||se[0])}const ne=q.bounds,ee={width:O,height:U,x:ne.x+ne.width/2-O/2,y:ne.y+ne.height/2-U/2};return ne.width>0&&ne.height>0&&(ee.x<ne.x&&(ee.x=ne.x),ee.y<ne.y&&(ee.y=ne.y),ee.x>ne.x+ne.width&&(ee.x=ne.x),ee.y>ne.y+ne.height&&(ee.y=ne.y),ee.width>ne.width&&(ee.width=ne.width),ee.height>ne.height&&(ee.height=ne.height)),ee}};e.IssueMainService=C,e.IssueMainService=C=Se([J(1,d.IEnvironmentMainService),J(2,b.ILogService),J(3,m.IDiagnosticsService),J(4,f.IDiagnosticsMainService),J(5,w.IDialogMainService),J(6,y.INativeHostMainService),J(7,l.IProtocolMainService),J(8,g.IProductService),J(9,t.IStateService),J(10,i.IWindowsMainService)],C);function k(D){return typeof D!="object"||D===null?!1:"x"in D&&"y"in D&&"width"in D&&"height"in D}}),define(te[299],ie([0,1,21,18,28,20,5,67,23,51,26,48,100]),function(j,e,P,L,s,_,M,I,h,c,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let d=class extends w.AbstractUpdateService{constructor(y,o,g,l,v,E,S,t){super(y,o,l,v,E,t),this.telemetryService=g,this.nativeHostMainService=S}buildUpdateFeedUrl(y){return(0,w.createUpdateURL)(`linux-${process.arch}`,y,this.productService)}doCheckForUpdates(y){this.url&&(this.setState(f.State.CheckingForUpdates(y)),this.requestService.request({url:this.url},P.CancellationToken.None).then(c.asJson).then(o=>{!o||!o.url||!o.version||!o.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!y}),this.setState(f.State.Idle(1))):this.setState(f.State.AvailableForDownload(o))}).then(void 0,o=>{this.logService.error(o),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!y});const g=y?o.message||o:void 0;this.setState(f.State.Idle(1,g))}))}async doDownloadUpdate(y){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):y.update.url&&this.nativeHostMainService.openExternal(void 0,y.update.url),this.setState(f.State.Idle(1))}};e.LinuxUpdateService=d,e.LinuxUpdateService=d=Se([J(0,_.ILifecycleMainService),J(1,L.IConfigurationService),J(2,m.ITelemetryService),J(3,s.IEnvironmentMainService),J(4,c.IRequestService),J(5,M.ILogService),J(6,I.INativeHostMainService),J(7,h.IProductService)],d)}),define(te[300],ie([0,1,47,42,27,8,21,55,9,7,142,22,18,28,16,20,5,67,23,51,26,48,100]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o,g,l,v,E,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function u(a,p=1e3){for(;!a();)await(0,_.timeout)(p)}let r;function n(){return typeof r>"u"&&(L.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?r=0:h.basename(h.normalize(h.join(process.execPath,"..","..")))==="Program Files"?r=3:r=1),r}let i=class extends t.AbstractUpdateService{get cachePath(){const p=h.join((0,s.tmpdir)(),`${this.productService.applicationName}-${this.productService.quality}-${this.productService.target}-${process.arch}`);return f.Promises.mkdir(p,{recursive:!0}).then(()=>p)}constructor(p,C,k,D,A,O,U,q,se){super(p,C,D,A,O,se),this.telemetryService=k,this.fileService=U,this.nativeHostMainService=q}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.setState(S.State.Disabled(5)),this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(p){let C="win32";switch(process.arch!=="ia32"&&(C+=`-${process.arch}`),n()){case 1:C+="-archive";break;case 3:C+="-msi";break;default:this.productService.target==="user"&&(C+="-user")}return(0,t.createUpdateURL)(C,p,this.productService)}doCheckForUpdates(p){this.url&&(this.setState(S.State.CheckingForUpdates(p)),this.requestService.request({url:this.url},M.CancellationToken.None).then(v.asJson).then(C=>{const k=n();return!C||!C.url||!C.version||!C.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p}),this.setState(S.State.Idle(k)),Promise.resolve(null)):k===1?(this.setState(S.State.AvailableForDownload(C)),Promise.resolve(null)):(this.setState(S.State.Downloading(C)),this.cleanup(C.version).then(()=>this.getUpdatePackagePath(C.version).then(D=>f.Promises.exists(D).then(A=>{if(A)return Promise.resolve(D);const O=C.url,U=C.hash,q=`${D}.tmp`;return this.requestService.request({url:O},M.CancellationToken.None).then(se=>this.fileService.writeFile(c.URI.file(q),se.stream)).then(U?()=>(0,m.checksum)(q,C.hash):()=>{}).then(()=>f.Promises.rename(q,D)).then(()=>D)})).then(D=>{const A=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:D},A?this.productService.target==="user"?this.doApplyUpdate():this.setState(S.State.Downloaded(C)):this.setState(S.State.Ready(C))})))}).then(void 0,C=>{this.logService.error(C),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p});const k=p?C.message||C:void 0;this.setState(S.State.Idle(n(),k))}))}async doDownloadUpdate(p){p.update.url&&this.nativeHostMainService.openExternal(void 0,p.update.url),this.setState(S.State.Idle(n()))}async getUpdatePackagePath(p){const C=await this.cachePath;return h.join(C,`CodeSetup-${this.productService.quality}-${p}.exe`)}async cleanup(p=null){const C=p?O=>!new RegExp(`${this.productService.quality}-${p}\\.exe$`).test(O):()=>!0,k=await this.cachePath,A=(await f.Promises.readdir(k)).filter(C).map(async O=>{try{await f.Promises.unlink(h.join(k,O))}catch{}});await Promise.all(A)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const p=this.state.update;this.setState(S.State.Updating(p));const C=await this.cachePath;this.availableUpdate.updateFilePath=h.join(C,`CodeSetup-${this.productService.quality}-${p.version}.flag`),await f.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,P.spawn)(this.availableUpdate.packagePath,["/verysilent","/log",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(S.State.Idle(n()))});const D=`${this.productService.win32MutexName}-ready`,A=await new Promise((O,U)=>{j(["@vscode/windows-mutex"],O,U)});u(()=>A.isActive(D)).then(()=>this.setState(S.State.Ready(p)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):n()==3?(0,P.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,P.spawn)(this.availableUpdate.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}async _applySpecificUpdate(p){if(this.state.type!=="idle")return;const C=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),k={version:"unknown",productVersion:"unknown"};this.setState(S.State.Downloading(k)),this.availableUpdate={packagePath:p},C?this.productService.target==="user"?this.doApplyUpdate():this.setState(S.State.Downloaded(k)):this.setState(S.State.Ready(k))}};e.Win32UpdateService=i,Se([I.memoize],i.prototype,"cachePath",null),e.Win32UpdateService=i=Se([J(0,y.ILifecycleMainService),J(1,w.IConfigurationService),J(2,E.ITelemetryService),J(3,d.IEnvironmentMainService),J(4,v.IRequestService),J(5,o.ILogService),J(6,b.IFileService),J(7,g.INativeHostMainService),J(8,l.IProductService)],i)}),define(te[301],ie([0,1,14,8,21,50,3,2,15,9,65,4,7,188,64,18,61,28,63,16,20,5,23,79,250,83,26,102,80,81,29,30,54,128,134,39,34,53,66,24]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o,g,l,v,E,S,t,u,r,n,i,a,p,C,k,D,A,O,U,q,se,ne,ee,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ue;(function(Y){Y[Y.NONE=0]="NONE",Y[Y.NAVIGATING=1]="NAVIGATING",Y[Y.READY=2]="READY"})(ue||(ue={}));let G=class Et extends I.Disposable{static{this.windowControlHeightStateStorageKey="windowControlHeight"}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const F=this.userDataProfilesService.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&F?F:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,D.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(F,N,B,V,X,ce,oe,T,R,W,H,x,z,$,K,re,le,ge,Ce,Me){super(),this.logService=N,this.loggerMainService=B,this.environmentMainService=V,this.policyService=X,this.userDataProfilesService=ce,this.fileService=oe,this.applicationStorageMainService=T,this.storageMainService=R,this.configurationService=W,this.themeMainService=H,this.workspacesManagementMainService=x,this.backupMainService=z,this.telemetryService=$,this.dialogMainService=K,this.lifecycleMainService=re,this.productService=le,this.protocolMainService=ge,this.windowsMainService=Ce,this.stateService=Me,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new M.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Re,Oe]=this.restoreWindowState(F.state);this.windowState=Re,this.logService.trace("window#ctor: using window state",Re);const He=this.windowState.mode===0||this.windowState.mode===3,pe=this.configurationService.getValue("window"),ve={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:C.WindowMinimumSize.WIDTH,minHeight:C.WindowMinimumSize.HEIGHT,show:!He,title:this.productService.nameLong,webPreferences:{preload:h.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,C.zoomLevelToZoomFactor)(pe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};f.isLinux?ve.icon=(0,c.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):f.isWindows&&!this.environmentMainService.isBuilt&&(ve.icon=(0,c.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),f.isMacintosh&&!this.useNativeFullScreen()&&(ve.fullscreenable=!1),f.isMacintosh&&(ve.acceptFirstMouse=!0,pe?.clickThroughInactive===!1&&(ve.acceptFirstMouse=!1));const Z=f.isMacintosh&&pe?.nativeTabs===!0;Z&&(ve.tabbingIdentifier=this.productService.nameShort);const de=(0,C.getTitleBarStyle)(this.configurationService)==="custom";if(de&&(ve.titleBarStyle="hidden",f.isMacintosh||(ve.frame=!1),(0,C.useWindowControlsOverlay)(this.configurationService))){const fe=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Ie=U.Color.fromHex(fe).isDarker()?"#FFFFFF":"#000000";ve.titleBarOverlay={height:29,color:fe,symbolColor:Ie},this.hasWindowControlOverlay=!0}if((0,m.mark)("code/willCreateCodeBrowserWindow"),this._win=new P.BrowserWindow(ve),(0,m.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,f.isMacintosh&&de&&this._win.setSheetOffset(22),de&&(f.isWindows&&(0,C.useWindowControlsOverlay)(this.configurationService)||f.isMacintosh)){const fe=this.stateService.getItem(Et.windowControlHeightStateStorageKey);fe&&this.updateWindowControls({height:fe})}f.isWindows&&de&&this._win.hookWindowMessage(278,()=>{const[Ie,Le]=this._win.getPosition(),Te=P.screen.getCursorScreenPoint(),Ae=Te.x-Ie,Be=Te.y-Le;return(()=>!(Ae>30&&Be>=0&&Be<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Ae,y:Be})),0}),(f.isMacintosh||f.isWindows)&&Oe&&(!Z||P.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(fe=>typeof fe=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),He&&((0,m.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,m.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setRepresentedFilename(F){f.isMacintosh?this._win.setRepresentedFilename(F):this.representedFilename=F}getRepresentedFilename(){return f.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(F){f.isMacintosh&&this._win.setDocumentEdited(F),this.documentEdited=F}isDocumentEdited(){return f.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(F){f.isMacintosh&&F?.force&&P.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(F=>{if(this.isReady)return F(this);this.whenReadyCallbacks.push(F)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(F=>{function N(){B.dispose(),V.dispose(),F()}const B=this.onDidClose(()=>N()),V=this.onWillLoad(()=>N())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(N,B)=>this.onWindowError(2,{...B})),this._win.webContents.on("did-fail-load",(N,B,V)=>this.onWindowError(3,{reason:V,exitCode:B})),this._win.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",N=>{this._config&&(this._config.maximized=!0),P.app.emit("browser-window-maximize",N,this._win)}),this._win.on("unmaximize",N=>{this._config&&(this._config.maximized=!1),P.app.emit("browser-window-unmaximize",N,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(N=>this.onConfigurationUpdated(N))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(N=>this.onDidDeleteUntitledWorkspace(N)));const F=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:F},async(N,B)=>{const V=await this.getMarketplaceHeaders();B({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,V)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,r.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(F,N){switch(F){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:F,reason:N?.reason,code:N?.exitCode}),F){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(F===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:B,checkboxChecked:V}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,d.localize)(0,null),(0,d.localize)(1,null),(0,d.localize)(2,null)],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),checkboxLabel:this._config?.workspace?(0,d.localize)(5,null):void 0},this._win);if(B!==2){const X=B===0;await this.destroyWindow(X,V)}}else if(F===2){let B;N?B=(0,d.localize)(7,null,N.reason,N.exitCode??"<unknown>"):B=(0,d.localize)(6,null);const{response:V,checkboxChecked:X}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,d.localize)(8,null):(0,d.localize)(9,null),(0,d.localize)(10,null)],message:B,detail:this._config?.workspace?(0,d.localize)(11,null):(0,d.localize)(12,null),checkboxLabel:this._config?.workspace?(0,d.localize)(13,null):void 0},this._win),ce=V===0;await this.destroyWindow(ce,X)}break}}async destroyWindow(F,N){const B=this._config?.workspace;if(N&&B)try{const V=this.storageMainService.workspaceStorage(B);await V.init(),V.delete("memento/workbench.parts.editor"),await V.close()}catch(V){this.logService.error(V)}if(this._onDidDestroy.fire(),this._win?.destroy(),F&&this._config){let V,X;(0,D.isSingleFolderWorkspaceIdentifier)(B)?V={folderUri:B.uri}:(0,D.isWorkspaceIdentifier)(B)?V={workspaceUri:B.configPath}:X=!0,(0,ae.firstOrDefault)(await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:V?[V]:void 0,forceEmpty:X,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}onDidDeleteUntitledWorkspace(F){this._config?.workspace?.id===F.id&&(this._config.workspace=void 0)}onConfigurationUpdated(F){if(!F||F.affectsConfiguration("window.menuBarVisibility")){const N=this.getMenuBarVisibility();N!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=N,this.setMenuBarVisibility(N))}if(!F||F.affectsConfiguration("http.proxy")){let N=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const B=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.currentHttpProxy||B!==this.currentNoProxy)){this.currentHttpProxy=N,this.currentNoProxy=B;const V=N||"",X=B?`${B},<local>`:"<local>";this.logService.trace(`Setting proxy to '${V}', bypassing '${X}'`),this._win.webContents.session.setProxy({proxyRules:V,proxyBypassRules:X,pacScript:""})}}}addTabbedWindow(F){f.isMacintosh&&F.win&&this._win.addTabbedWindow(F.win)}load(F,N=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!N.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(F,N),this.readyState===0?this._config=F:this.pendingLoadConfig=F,this.readyState=1,this._win.loadURL(h.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const B=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:F.workspace,reason:N.isReload?3:B?2:1})}updateConfiguration(F,N){const B=(this._config??this.pendingLoadConfig)?.userEnv;if(B){const V=(0,l.isLaunchedFromCli)(B)&&!(0,l.isLaunchedFromCli)(F.userEnv),X=this.isExtensionDevelopmentHost;(V||X)&&(F.userEnv={...B,...F.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(F.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(F["disable-extensions"]=N.disableExtensions),F.fullscreen=this.isFullScreen,F.maximized=this._win.isMaximized(),F.partsSplash=this.themeMainService.getWindowSplash(),(0,m.mark)("code/willOpenNewWindow"),F.perfMarks=(0,m.getMarks)(),this.configObjectUrl.update(F)}async reload(F){const N=Object.assign({},this._config);N.workspace=await this.validateWorkspaceBeforeReload(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&F&&(N.verbose=F.verbose,N.debugId=F.debugId,N.extensionEnvironment=F.extensionEnvironment,N["inspect-extensions"]=F["inspect-extensions"],N["inspect-brk-extensions"]=F["inspect-brk-extensions"],N["extensions-dir"]=F["extensions-dir"]),N.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.policyService.serialize(),N.continueOn=this.environmentMainService.continueOn,N.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},N.logLevel=this.loggerMainService.getLogLevel(),N.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:F?.["disable-extensions"]})}async validateWorkspaceBeforeReload(F){if((0,D.isWorkspaceIdentifier)(F.workspace)){const N=F.workspace.configPath;if(N.scheme===h.Schemas.file&&!await this.fileService.exists(N))return}else if((0,D.isSingleFolderWorkspaceIdentifier)(F.workspace)){const N=F.workspace.uri;if(N.scheme===h.Schemas.file&&!await this.fileService.exists(N))return}return F.workspace}serializeWindowState(){if(!this._win)return(0,O.defaultWindowState)();if(this.isFullScreen){let B;try{B=P.screen.getDisplayMatching(this.getBounds())}catch{}const V=(0,O.defaultWindowState)();return{mode:3,display:B?B.id:void 0,width:this.windowState.width||V.width,height:this.windowState.height||V.height,x:this.windowState.x||0,y:this.windowState.y||0}}const F=Object.create(null);let N;if(!f.isMacintosh&&this._win.isMaximized()?N=0:N=1,N===0?F.mode=0:F.mode=1,N===1||N===0){let B;N===1?B=this.getBounds():B=this._win.getNormalBounds(),F.x=B.x,F.y=B.y,F.width=B.width,F.height=B.height}return F}updateWindowControls(F){if(F.height&&this.stateService.setItem(Et.windowControlHeightStateStorageKey,F.height),f.isWindows&&this.hasWindowControlOverlay)this._win.setTitleBarOverlay({color:F.backgroundColor?.trim()===""?void 0:F.backgroundColor,symbolColor:F.foregroundColor?.trim()===""?void 0:F.foregroundColor,height:F.height?F.height-1:void 0});else if(f.isMacintosh&&F.height!==void 0){const N=(F.height-15)/2;this._win.setTrafficLightPosition({x:N,y:N})}}restoreWindowState(F){(0,m.mark)("code/willRestoreCodeWindowState");let N=!1;if(F)try{const B=P.screen.getAllDisplays();N=B.length>1,F=this.validateWindowState(F,B)}catch(B){this.logService.warn(`Unexpected error validating window state: ${B}
${B.stack}`)}return(0,m.mark)("code/didRestoreCodeWindowState"),[F||(0,O.defaultWindowState)(),N]}validateWindowState(F,N){if(this.logService.trace(`window#validateWindowState: validating window state on ${N.length} display(s)`,F),typeof F.x!="number"||typeof F.y!="number"||typeof F.width!="number"||typeof F.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(F.width<=0||F.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(N.length===1){const X=this.getWorkingArea(N[0]);if(X){let ce=function(){!F||typeof F.x!="number"||typeof F.y!="number"||!X||(F.x<X.x&&(F.x=X.x),F.y<X.y&&(F.y=X.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",X),ce(),F.width>X.width&&(F.width=X.width),F.height>X.height&&(F.height=X.height),F.x>X.x+X.width-128&&(F.x=X.x+X.width-F.width),F.y>X.y+X.height-128&&(F.y=X.y+X.height-F.height),ce()}return F}if(F.display&&F.mode===3){const X=N.find(ce=>ce.id===F.display);if(X&&typeof X.bounds?.x=="number"&&typeof X.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const ce=(0,O.defaultWindowState)(3);return ce.x=X.bounds.x,ce.y=X.bounds.y,ce}}let B,V;try{B=P.screen.getDisplayMatching({x:F.x,y:F.y,width:F.width,height:F.height}),V=this.getWorkingArea(B)}catch{}if(B&&V&&F.x+F.width>V.x&&F.y+F.height>V.y&&F.x<V.x+V.width&&F.y<V.y+V.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",V),F}getWorkingArea(F){if(F.workArea.width>0&&F.workArea.height>0)return F.workArea;if(F.bounds.width>0&&F.bounds.height>0)return F.bounds}getBounds(){const[F,N]=this._win.getPosition(),[B,V]=this._win.getSize();return{x:F,y:N,width:B,height:V}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(F){this.useNativeFullScreen()?this.setNativeFullScreen(F):this.setSimpleFullScreen(F),this.sendWhenReady(F?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return f.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(F){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(F)}doSetNativeFullScreen(F){f.isMacintosh&&(this.transientIsNativeFullScreen=F,this.joinNativeFullScreenTransition=new L.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,L.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(F)}setSimpleFullScreen(F){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(F),this._win.webContents.focus()}useNativeFullScreen(){const F=this.configurationService.getValue("window");return!F||typeof F.nativeFullScreen!="boolean"||F.nativeTabs?!0:F.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let F=(0,C.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(F)<0&&(F="classic"),F}setMenuBarVisibility(F,N=!0){f.isMacintosh||(F==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,d.localize)(14,null)),F==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(F)}):this.doSetMenuBarVisibility(F))}doSetMenuBarVisibility(F){const N=this.isFullScreen;switch(F){case"classic":this._win.setMenuBarVisibility(!N),this._win.autoHideMenuBar=N;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(f.isMacintosh)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(F,N,...B){this.isReady?this.send(F,...B):this.ready().then(()=>{N.isCancellationRequested||this.send(F,...B)})}send(F,...N){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${F}' for window that is destroyed`);return}try{this._win.webContents.send(F,...N)}catch(B){this.logService.warn(`Error sending IPC message to channel '${F}' of window ${this._id}: ${(0,_.toErrorMessage)(B)}`)}}}updateTouchBar(F){f.isMacintosh&&this.touchBarGroups.forEach((N,B)=>{const V=F[B];N.segments=this.createTouchBarGroupSegments(V)})}createTouchBar(){if(f.isMacintosh){for(let F=0;F<10;F++){const N=this.createTouchBarGroup();this.touchBarGroups.push(N)}this._win.setTouchBar(new P.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(F=[]){const N=this.createTouchBarGroupSegments(F),B=new P.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:V=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:B.segments[V].id,from:"touchbar"})}});return B}createTouchBarGroupSegments(F=[]){return F.map(B=>{let V;B.icon&&!a.ThemeIcon.isThemeIcon(B.icon)&&B.icon?.dark?.scheme===h.Schemas.file&&(V=P.nativeImage.createFromPath(w.URI.revive(B.icon.dark).fsPath),V.isEmpty()&&(V=void 0));let X;return typeof B.title=="string"?X=B.title:X=B.title.value,{id:B.id,label:V?void 0:X,icon:V}})}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id),this._win=null}};e.CodeWindow=G,e.CodeWindow=G=Se([J(1,S.ILogService),J(2,ee.ILoggerMainService),J(3,g.IEnvironmentMainService),J(4,q.IPolicyService),J(5,ne.IUserDataProfilesMainService),J(6,v.IFileService),J(7,n.IApplicationStorageMainService),J(8,n.IStorageMainService),J(9,y.IConfigurationService),J(10,p.IThemeMainService),J(11,A.IWorkspacesManagementMainService),J(12,b.IBackupMainService),J(13,i.ITelemetryService),J(14,o.IDialogMainService),J(15,E.ILifecycleMainService),J(16,t.IProductService),J(17,u.IProtocolMainService),J(18,k.IWindowsMainService),J(19,se.IStateService)],G)}),define(te[84],ie([0,1,14,24,8,3,46,2,15,4,19,7,22,191,6,20,5,83,98,30,54,35]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o,g,l,v,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,b.createDecorator)("workspacesHistoryMainService");let t=class nt extends I.Disposable{static{this.MAX_TOTAL_RECENT_ENTRIES=500}static{this.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList"}constructor(r,n,i,a){super(),this.logService=r,this.workspacesManagementMainService=n,this.lifecycleMainService=i,this.applicationStorageMainService=a,this._onDidChangeRecentlyOpened=this._register(new _.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new s.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){let n=[],i=[];for(const p of r)if((0,l.isRecentWorkspace)(p))!this.workspacesManagementMainService.isUntitledWorkspace(p.workspace)&&!this.containsWorkspace(n,p.workspace)&&n.push(p);else if((0,l.isRecentFolder)(p))this.containsFolder(n,p.folderUri)||n.push(p);else{const C=this.containsFile(i,p.fileUri),k=p.fileUri.scheme===h.Schemas.file&&nt.COMMON_FILES_FILTER.indexOf((0,m.basename)(p.fileUri))>=0;!C&&!k&&(i.push(p),c.isWindows&&p.fileUri.scheme===h.Schemas.file&&P.app.addRecentDocument(p.fileUri.fsPath))}const a=await this.mergeEntriesFromStorage({workspaces:n,files:i});n=a.workspaces,i=a.files,n.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(n.length=nt.MAX_TOTAL_RECENT_ENTRIES),i.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(i.length=nt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:n,files:i}),this._onDidChangeRecentlyOpened.fire(),c.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(r){const n=C=>{const k=this.location(C);for(const D of r)if(m.extUriBiasedIgnorePathCase.isEqual(D,k))return!1;return!0},i=await this.getRecentlyOpened(),a=i.workspaces.filter(n),p=i.files.filter(n);(a.length!==i.workspaces.length||p.length!==i.files.length)&&(await this.saveRecentlyOpened({files:p,workspaces:a}),this._onDidChangeRecentlyOpened.fire(),c.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(r){const n=new S.ResourceMap(p=>m.extUriBiasedIgnorePathCase.getComparisonKey(p));if(r?.workspaces)for(const p of r.workspaces)n.set(this.location(p),p);const i=new S.ResourceMap(p=>m.extUriBiasedIgnorePathCase.getComparisonKey(p));if(r?.files)for(const p of r.files)i.set(this.location(p),p);const a=await this.getRecentlyOpenedFromStorage();for(const p of a.workspaces){const C=n.get(this.location(p));C?C.label=C.label??p.label:n.set(this.location(p),p)}for(const p of a.files){const C=i.get(this.location(p));C?C.label=C.label??p.label:i.set(this.location(p),p)}return{workspaces:[...n.values()],files:[...i.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let r;const n=this.applicationStorageMainService.get(nt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof n=="string")try{r=JSON.parse(n)}catch(i){this.logService.error("Unexpected error parsing opened paths list",i)}return(0,l.restoreRecentlyOpened)(r,this.logService)}async saveRecentlyOpened(r){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(nt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,l.toStoreData)(r)),-1,1)}location(r){return(0,l.isRecentFolder)(r)?r.folderUri:(0,l.isRecentFile)(r)?r.fileUri:r.workspace.configPath}containsWorkspace(r,n){return!!r.find(i=>(0,l.isRecentWorkspace)(i)&&i.workspace.id===n.id)}containsFolder(r,n){return!!r.find(i=>(0,l.isRecentFolder)(i)&&m.extUriBiasedIgnorePathCase.isEqual(i.folderUri,n))}containsFile(r,n){return!!r.find(i=>m.extUriBiasedIgnorePathCase.isEqual(i.fileUri,n))}static{this.MAX_MACOS_DOCK_RECENT_WORKSPACES=7}static{this.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10}static{this.MAX_WINDOWS_JUMP_LIST_ENTRIES=7}static{this.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"]}async handleWindowsJumpList(){c.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!c.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(0,null),description:(0,d.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const p of P.app.getJumpListSettings().removedItems){const C=p.args;if(C){const k=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(C);k&&n.push(f.URI.parse(k[2]))}}await this.removeRecentlyOpened(n);let i=!1;const a=(0,L.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,nt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(p=>{const C=(0,l.isRecentWorkspace)(p)?p.workspace:p.folderUri,{title:k,description:D}=this.getWindowsJumpListLabel(C,p.label);let A;return f.URI.isUri(C)?A=`--folder-uri "${C.toString()}"`:(i=!0,A=`--file-uri "${C.configPath.toString()}"`),{type:"task",title:k.substr(0,255),description:D.substr(0,255),program:process.execPath,args:A,iconPath:"explorer.exe",iconIndex:0}}));a.length>0&&r.push({type:"custom",name:i?(0,d.localize)(2,null):(0,d.localize)(3,null),items:a})}r.push({type:"recent"});try{const n=P.app.setJumpList(r);n&&n!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.logService.warn("updateWindowsJumpList#setJumpList",n)}}getWindowsJumpListLabel(r,n){if(n)return{title:(0,M.splitRecentLabel)(n).name,description:n};if(f.URI.isUri(r))return{title:(0,m.basename)(r),description:this.renderJumpListPathDescription(r)};if(this.workspacesManagementMainService.isUntitledWorkspace(r))return{title:(0,d.localize)(4,null),description:""};let i=(0,m.basename)(r.configPath);return i.endsWith(v.WORKSPACE_EXTENSION)&&(i=i.substr(0,i.length-v.WORKSPACE_EXTENSION.length-1)),{title:(0,d.localize)(5,null,i),description:this.renderJumpListPathDescription(r.configPath)}}renderJumpListPathDescription(r){return r.scheme==="file"?(0,M.normalizeDriveLetter)(r.fsPath):r.toString()}async updateMacOSRecentDocuments(){if(!c.isMacintosh)return;P.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),n=[];let i=0;for(let p=0;p<r.workspaces.length&&i<nt.MAX_MACOS_DOCK_RECENT_WORKSPACES;p++){const C=this.location(r.workspaces[p]);if(C.scheme===h.Schemas.file){const k=(0,m.originalFSPath)(C);await w.Promises.exists(k)&&(n.push(k),i++)}}const a=[];for(let p=0;p<r.files.length&&i<nt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;p++){const C=this.location(r.files[p]);if(C.scheme===h.Schemas.file){const k=(0,m.originalFSPath)(C);if(nt.COMMON_FILES_FILTER.includes((0,m.basename)(C))||n.includes(k))continue;await w.Promises.exists(k)&&(a.push(k),i++)}}a.reverse().forEach(p=>P.app.addRecentDocument(p)),n.reverse().forEach(p=>P.app.addRecentDocument(p))}};e.WorkspacesHistoryMainService=t,e.WorkspacesHistoryMainService=t=Se([J(0,o.ILogService),J(1,E.IWorkspacesManagementMainService),J(2,y.ILifecycleMainService),J(3,g.IApplicationStorageMainService)],t)}),define(te[302],ie([0,1,14,8,21,46,4,7,179,18,28,20,5,229,67,23,34,26,48,81,29,84]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o,g,l,v,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let u=class Pt{static{this.lastKnownMenubarStorageKey="lastKnownMenubarData"}constructor(i,a,p,C,k,D,A,O,U,q,se){this.updateService=i,this.configurationService=a,this.windowsMainService=p,this.environmentMainService=C,this.telemetryService=k,this.workspacesHistoryMainService=D,this.stateService=A,this.lifecycleMainService=O,this.logService=U,this.nativeHostMainService=q,this.productService=se,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,v.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const i=this.stateService.getItem(Pt.lastKnownMenubarStorageKey);i&&(i.menus&&(this.menubarMenus=i.menus),i.keybindings&&(this.keybindings=i.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(D,A,O)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:A?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(D,A,O)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:A?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(D,A,O)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(O),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(D,A,O)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(O),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(D,A,O)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(O),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const i=this.productService.twitterUrl;i&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(i,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const p=this.productService.reportIssueUrl;p&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(p,"openReportIssues"));const C=this.productService.licenseUrl;C&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const D=C.indexOf("?")>0?"&":"?";this.openUrl(`${C}${D}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(C,"openLicenseUrl")});const k=this.productService.privacyStatementUrl;k&&C&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(k,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(i=>this.onDidChangeWindowsCount(i)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const i=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof i!="boolean"?!0:i}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;const i=this.configurationService.getValue("window.nativeTabs");return typeof i!="boolean"?!1:i}updateMenu(i,a){this.menubarMenus=i.menus,this.keybindings=i.keybindings,this.stateService.setItem(Pt.lastKnownMenubarStorageKey,i),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(i){M.isMacintosh&&(i.oldCount===0&&i.newCount>0||i.oldCount>0&&i.newCount===0)&&(this.closedLastWindow=i.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){M.isMacintosh&&(this.noActiveWindow=!P.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const i=P.Menu.getApplicationMenu();if(i&&this.oldMenus.push(i),Object.keys(this.menubarMenus).length===0){P.Menu.setApplicationMenu(M.isMacintosh?new P.Menu:null);return}const a=new P.Menu;let p;if(M.isMacintosh){const k=new P.Menu;p=new P.MenuItem({label:this.productService.nameShort,submenu:k}),this.setMacApplicationMenu(k),a.append(p)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const k=new P.Menu;k.append(new P.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),P.app.dock.setMenu(k)}if(this.shouldDrawMenu("File")){const k=new P.Menu,D=new P.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:k});this.setMenuById(k,"File"),a.append(D)}if(this.shouldDrawMenu("Edit")){const k=new P.Menu,D=new P.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:k});this.setMenuById(k,"Edit"),a.append(D)}if(this.shouldDrawMenu("Selection")){const k=new P.Menu,D=new P.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:k});this.setMenuById(k,"Selection"),a.append(D)}if(this.shouldDrawMenu("View")){const k=new P.Menu,D=new P.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:k});this.setMenuById(k,"View"),a.append(D)}if(this.shouldDrawMenu("Go")){const k=new P.Menu,D=new P.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:k});this.setMenuById(k,"Go"),a.append(D)}if(this.shouldDrawMenu("Run")){const k=new P.Menu,D=new P.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:k});this.setMenuById(k,"Run"),a.append(D)}if(this.shouldDrawMenu("Terminal")){const k=new P.Menu,D=new P.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:k});this.setMenuById(k,"Terminal"),a.append(D)}let C;if(this.shouldDrawMenu("Window")){const k=new P.Menu;C=new P.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:k,role:"window"}),this.setMacWindowMenu(k)}if(C&&a.append(C),this.shouldDrawMenu("Help")){const k=new P.Menu,D=new P.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:k,role:"help"});this.setMenuById(k,"Help"),a.append(D)}a.items&&a.items.length>0?P.Menu.setApplicationMenu(a):P.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(i){const a=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),p=this.getUpdateMenuItems();let C;if(this.shouldDrawMenu("Preferences")){const ne=new P.Menu;this.setMenuById(ne,"Preferences"),C=new P.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:ne})}const k=new P.Menu,D=new P.MenuItem({label:h.localize(12,null),role:"services",submenu:k}),A=new P.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),O=new P.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),U=new P.MenuItem({label:h.localize(15,null),role:"unhide"}),q=new P.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:async(ne,ee,ae)=>{const ue=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||P.BrowserWindow.getFocusedWindow()||ue?.isMinimized())&&await this.confirmBeforeQuit(ae)&&this.nativeHostMainService.quit(void 0)}})),se=[a];se.push(...p),C&&se.push(r(),C),se.push(r(),D,r(),A,O,U,r(),q),se.forEach(ne=>i.append(ne))}async confirmBeforeQuit(i){if(this.windowsMainService.getWindowCount()===0)return!0;const a=this.configurationService.getValue("window.confirmBeforeClose");if(a==="always"||a==="keyboardOnly"&&this.isKeyboardEvent(i)){const{response:p}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return p===0}return!0}shouldDrawMenu(i){if(!M.isMacintosh&&(0,v.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(i){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[i];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[i]}}setMenu(i,a){a.forEach(p=>{if((0,d.isMenubarMenuItemSeparator)(p))i.append(r());else if((0,d.isMenubarMenuItemSubmenu)(p)){const C=new P.Menu,k=new P.MenuItem({label:this.mnemonicLabel(p.label),submenu:C});this.setMenu(C,p.submenu.items),i.append(k)}else(0,d.isMenubarMenuItemRecentAction)(p)?i.append(this.createOpenRecentMenuItem(p)):(0,d.isMenubarMenuItemAction)(p)&&(p.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(i),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[p.id]?i.append(new P.MenuItem(this.likeAction(p.id,{label:this.mnemonicLabel(p.label),click:this.fallbackMenuHandlers[p.id]}))):i.append(this.createMenuItem(p.label,p.id,!1,p.checked)):i.append(this.createMenuItem(p.label,p.id,p.enabled!==!1,!!p.checked)):i.append(this.createMenuItem(p.label,p.id,p.enabled!==!1,!!p.checked)))})}setMenuById(i,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(i,this.menubarMenus[a].items)}insertCheckForUpdatesItems(i){const a=this.getUpdateMenuItems();a.length&&(a.forEach(p=>i.append(p)),i.append(r()))}createOpenRecentMenuItem(i){const a=I.URI.revive(i.uri),p=i.id,C=p==="openRecentFile"?{fileUri:a}:p==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new P.MenuItem(this.likeAction(p,{label:i.label,click:async(k,D,A)=>{const O=this.isOptionClick(A);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[C],forceNewWindow:O,gotoLineMode:!1,remoteAuthority:i.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(i){return!!(i&&(!M.isMacintosh&&(i.ctrlKey||i.shiftKey)||M.isMacintosh&&(i.metaKey||i.altKey)))}isKeyboardEvent(i){return!!(i.triggeredByAccelerator||i.altKey||i.ctrlKey||i.metaKey||i.shiftKey)}createRoleMenuItem(i,a,p){const C={label:this.mnemonicLabel(i),role:p,enabled:!0};return new P.MenuItem(this.withKeybinding(a,C))}setMacWindowMenu(i){const a=new P.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),p=new P.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),C=new P.MenuItem({label:h.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),k=this.createMenuItem(h.localize(23,null),"workbench.action.switchWindow"),D=[];this.currentEnableNativeTabs&&(D.push(r()),D.push(this.createMenuItem(h.localize(24,null),"workbench.action.newWindowTab")),D.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),D.push(this.createRoleMenuItem(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),D.push(this.createRoleMenuItem(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),D.push(this.createRoleMenuItem(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,p,r(),k,...D,r(),C].forEach(A=>i.append(A))}getUpdateMenuItems(){switch(this.updateService.state.type){case"idle":return[new P.MenuItem({label:this.mnemonicLabel(h.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.mnemonicLabel(h.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.mnemonicLabel(h.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new P.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.mnemonicLabel(h.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})];default:return[]}}createMenuItem(i,a,p,C){const k=this.mnemonicLabel(i),D=typeof a=="function"?a:(se,ne,ee)=>{const ae=se?se.userSettingsLabel:null;let ue=a;Array.isArray(a)&&(ue=this.isOptionClick(ee)?a[1]:a[0]),ae&&ee.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:ae}):this.runActionInRenderer({type:"commandId",commandId:ue})},A=typeof p=="boolean"?p:this.windowsMainService.getWindowCount()>0,O=typeof C=="boolean"?C:!1,U={label:k,click:D,enabled:A};O&&(U.type="checkbox",U.checked=O);let q;return typeof a=="string"?q=a:Array.isArray(a)&&(q=a[0]),M.isMacintosh&&(q==="editor.action.clipboardCutAction"?U.role="cut":q==="editor.action.clipboardCopyAction"?U.role="copy":q==="editor.action.clipboardPasteAction"&&(U.role="paste"),q==="undo"?U.click=this.makeContextAwareClickHandler(D,{inDevTools:se=>se.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):q==="redo"?U.click=this.makeContextAwareClickHandler(D,{inDevTools:se=>se.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):q==="editor.action.selectAll"&&(U.click=this.makeContextAwareClickHandler(D,{inDevTools:se=>se.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.withKeybinding(q,U))}makeContextAwareClickHandler(i,a){return(p,C,k)=>{const D=P.BrowserWindow.getFocusedWindow();if(!D)return a.inNoWindow();if(D.webContents.isDevToolsFocused()&&D.webContents.devToolsWebContents)return a.inDevTools(D.webContents.devToolsWebContents);i(p,C||D,k)}}runActionInRenderer(i){let a=P.BrowserWindow.getFocusedWindow();if(!a){const C=this.windowsMainService.getLastActiveWindow();C?.isMinimized()&&(a=C.win)}const p=a?this.windowsMainService.getWindowById(a.id):void 0;if(p){if(this.logService.trace("menubar#runActionInRenderer",i),M.isMacintosh&&!this.environmentMainService.isBuilt&&!p.isReady&&(i.type==="commandId"&&i.commandId==="workbench.action.toggleDevTools"||i.type!=="commandId"&&i.userSettingsLabel==="alt+cmd+i"))return;if(i.type==="commandId"){const C={id:i.commandId,from:"menu"};p.sendWhenReady("vscode:runAction",s.CancellationToken.None,C)}else{const C={userSettingsLabel:i.userSettingsLabel};p.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,C)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",i)}withKeybinding(i,a){const p=typeof i=="string"?this.keybindings[i]:void 0;if(p?.label){if(p.isNative!==!1)a.accelerator=p.label,a.userSettingsLabel=p.userSettingsLabel;else if(typeof a.label=="string"){const C=a.label.indexOf("[");C>=0?a.label=`${a.label.substr(0,C)} [${p.label}]`:a.label=`${a.label} [${p.label}]`}}else a.accelerator=void 0;return a}likeAction(i,a,p=!a.accelerator){p&&(a=this.withKeybinding(i,a));const C=a.click;return a.click=(k,D,A)=>{this.reportMenuActionTelemetry(i),C?.(k,D,A)},a}openUrl(i,a){this.nativeHostMainService.openExternal(void 0,i),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(i){this.telemetryService.publicLog2("workbenchActionExecuted",{id:i,from:t})}mnemonicLabel(i){return(0,_.mnemonicMenuLabel)(i,!this.currentEnableMenuBarMnemonics)}};e.Menubar=u,e.Menubar=u=Se([J(0,l.IUpdateService),J(1,c.IConfigurationService),J(2,E.IWindowsMainService),J(3,m.IEnvironmentMainService),J(4,g.ITelemetryService),J(5,S.IWorkspacesHistoryMainService),J(6,o.IStateService),J(7,f.ILifecycleMainService),J(8,w.ILogService),J(9,b.INativeHostMainService),J(10,y.IProductService)],u);function r(){return new P.MenuItem({type:"separator"})}}),define(te[303],ie([0,1,6,20,5,302]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,P.createDecorator)("menubarMainService");let M=class{constructor(h,c,m){this.instantiationService=h,this.lifecycleMainService=c,this.logService=m,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(_.Menubar)}async updateMenubar(h,c){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(c,h)}};e.MenubarMainService=M,e.MenubarMainService=M=Se([J(0,P.IInstantiationService),J(1,L.ILifecycleMainService),J(2,s.ILogService)],M)}),define(te[304],ie([0,1,14,22,132,27,24,21,3,32,49,46,2,15,9,65,4,36,19,10,7,189,64,18,61,28,16,6,20,5,78,79,60,34,81,301,130,297,30,99,84,54,80,39,53,66]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o,g,l,v,E,S,t,u,r,n,i,a,p,C,k,D,A,O,U,q,se,ne,ee,ae,ue,G,Y,F,N,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function V(oe){return(0,ee.isWorkspaceIdentifier)(oe?.workspace)}function X(oe){return(0,ee.isSingleFolderWorkspaceIdentifier)(oe?.workspace)}let ce=class at extends w.Disposable{static{this.WINDOWS=[]}constructor(T,R,W,H,x,z,$,K,re,le,ge,Ce,Me,Re,Oe,He,pe,ve){super(),this.machineId=T,this.initialUserEnv=R,this.logService=W,this.loggerService=H,this.stateService=x,this.policyService=z,this.environmentMainService=$,this.userDataProfilesMainService=K,this.lifecycleMainService=re,this.backupMainService=le,this.configurationService=ge,this.workspacesHistoryMainService=Ce,this.workspacesManagementMainService=Me,this.instantiationService=Re,this.dialogMainService=Oe,this.fileService=He,this.protocolMainService=pe,this.themeMainService=ve,this._onDidOpenWindow=this._register(new h.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new h.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new h.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new h.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new h.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ne.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(T=>this._onDidSignalReadyWindow.fire(T.window))),this._register(this.onDidSignalReadyWindow(T=>{if(T.config?.extensionDevelopmentPath||T.config?.extensionTestsPath){const R=new w.DisposableStore;if(R.add(h.Event.any(T.onDidClose,T.onDidDestroy)(()=>R.dispose())),T.config.extensionDevelopmentPath)for(const W of T.config.extensionDevelopmentPath)R.add(this.protocolMainService.addValidFileRoot(W));T.config.extensionTestsPath&&R.add(this.protocolMainService.addValidFileRoot(T.config.extensionTestsPath))}}))}openEmptyWindow(T,R){const W=this.environmentMainService.args,H=R?.remoteAuthority||void 0,x=!0,z=R?.forceReuseWindow,$=!z;return this.open({...T,cli:W,forceEmpty:x,forceNewWindow:$,forceReuseWindow:z,remoteAuthority:H})}openExistingWindow(T,R){T.focus(),this.handleWaitMarkerFile(R,[T])}async open(T){this.logService.trace("windowsManager#open"),T.addMode&&(T.initialStartup||!this.getLastActiveWindow())&&(T.addMode=!1);const R=[],W=[],H=[],x=[],z=[];let $,K=0;const re=await this.getPathsToOpen(T);this.logService.trace("windowsManager#open pathsToOpen",re);for(const Re of re)X(Re)?T.addMode?R.push(Re):W.push(Re):V(Re)?H.push(Re):Re.fileUri?($||($={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Re.remoteAuthority}),$.filesToOpenOrCreate.push(Re)):Re.backupPath?z.push({backupFolder:(0,b.basename)(Re.backupPath),remoteAuthority:Re.remoteAuthority}):K++;T.diffMode&&$&&$.filesToOpenOrCreate.length>=2&&($.filesToDiff=$.filesToOpenOrCreate.slice(0,2),$.filesToOpenOrCreate=[]),T.mergeMode&&$&&$.filesToOpenOrCreate.length===4&&($.filesToMerge=$.filesToOpenOrCreate.slice(0,4),$.filesToOpenOrCreate=[],$.filesToDiff=[]),$&&T.waitMarkerFileURI&&($.filesToWait={paths:(0,M.coalesce)([...$.filesToDiff,$.filesToMerge[3],...$.filesToOpenOrCreate]),waitMarkerFileUri:T.waitMarkerFileURI}),T.initialStartup?(x.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),H.push(...x),z.push(...this.backupMainService.getEmptyWindowBackups())):z.length=0;const{windows:le,filesOpenedInWindow:ge}=await this.doOpen(T,H,W,z,K,$,R);if(this.logService.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${H.length}, foldersToOpen: ${W.length}, emptyToRestore: ${z.length}, emptyToOpen: ${K})`),le.length>1)if(ge)ge.focus();else{const Re=this.windowsStateHandler.state.lastActiveWindow&&!T.forceEmpty&&!T.cli._.length&&!T.cli["file-uri"]&&!T.cli["folder-uri"]&&!(T.urisToOpen&&T.urisToOpen.length);let Oe=!0,He=!0;if(Re){const pe=le.filter(ve=>this.windowsStateHandler.state.lastActiveWindow&&ve.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Oe=!1,He=!1)}if(Oe)for(let pe=le.length-1;pe>=0;pe--){const ve=le[pe];if(!(ve.openedWorkspace&&x.some(Z=>ve.openedWorkspace&&Z.workspace.id===ve.openedWorkspace.id)||ve.backupPath&&z.some(Z=>ve.backupPath&&Z.backupFolder===(0,b.basename)(ve.backupPath)))){ve.focus(),He=!1;break}}He&&le[le.length-1].focus()}const Ce=$&&$.filesToDiff.length>0,Me=$&&$.filesToMerge.length>0;if(!le.some(Re=>Re.isExtensionDevelopmentHost)&&!Ce&&!Me&&!T.noRecentEntry){const Re=[];for(const Oe of re)V(Oe)&&!Oe.transient?Re.push({label:Oe.label,workspace:Oe.workspace,remoteAuthority:Oe.remoteAuthority}):X(Oe)?Re.push({label:Oe.label,folderUri:Oe.workspace.uri,remoteAuthority:Oe.remoteAuthority}):Oe.fileUri&&Re.push({label:Oe.label,fileUri:Oe.fileUri,remoteAuthority:Oe.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Re)}return this.handleWaitMarkerFile(T,le),le}handleWaitMarkerFile(T,R){const W=T.waitMarkerFileURI;T.context===0&&W&&R.length===1&&R[0]&&(async()=>{await R[0].whenClosedOrLoaded;try{await this.fileService.del(W)}catch{}})()}async doOpen(T,R,W,H,x,z,$){const K=[];let re;function le(pe,ve){K.push(pe),ve&&(re=pe,z=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:Ce}=this.shouldOpenNewWindow(T);if(!T.initialStartup&&$.length>0){const pe=$[0].remoteAuthority,ve=this.getLastActiveWindowForAuthority(pe);ve&&le(this.doAddFoldersToExistingWindow(ve,$.map(Z=>Z.workspace.uri)))}const Me=W.length+R.length+H.length;if(z&&Me===0){const pe=z.filesToOpenOrCreate[0]||z.filesToDiff[0]||z.filesToMerge[3],ve=this.getWindows().filter(de=>z&&(0,l.isEqualAuthority)(de.remoteAuthority,z.remoteAuthority));let Z;pe?.fileUri&&!Ce&&((T.context===4||T.context===0||T.context===1)&&(Z=await(0,se.findWindowOnFile)(ve,pe.fileUri,async de=>de.configPath.scheme===d.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(de.configPath):void 0)),Z||(Z=this.doGetLastActiveWindow(ve))),Z?(0,ee.isWorkspaceIdentifier)(Z.openedWorkspace)?R.push({workspace:Z.openedWorkspace,remoteAuthority:Z.remoteAuthority}):(0,ee.isSingleFolderWorkspaceIdentifier)(Z.openedWorkspace)?W.push({workspace:Z.openedWorkspace,remoteAuthority:Z.remoteAuthority}):le(this.doOpenFilesInExistingWindow(T,Z,z),!0):le(await this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:z,forceNewWindow:!0,remoteAuthority:z.remoteAuthority,forceNewTabbedWindow:T.forceNewTabbedWindow,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile}),!0)}const Re=(0,M.distinct)(R,pe=>pe.workspace.id);if(Re.length>0){const pe=(0,M.coalesce)(Re.map(ve=>(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve.workspace.configPath)));if(pe.length>0){const ve=pe[0],Z=(0,l.isEqualAuthority)(z?.remoteAuthority,ve.remoteAuthority)?z:void 0;le(this.doOpenFilesInExistingWindow(T,ve,Z),!!Z),ge=!0}for(const ve of Re){if(pe.some(fe=>fe.openedWorkspace&&fe.openedWorkspace.id===ve.workspace.id))continue;const Z=ve.remoteAuthority,de=(0,l.isEqualAuthority)(z?.remoteAuthority,Z)?z:void 0;le(await this.doOpenFolderOrWorkspace(T,ve,ge,de),!!de),ge=!0}}const Oe=(0,M.distinct)(W,pe=>l.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(Oe.length>0){const pe=(0,M.coalesce)(Oe.map(ve=>(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve.workspace.uri)));if(pe.length>0){const ve=pe[0],Z=(0,l.isEqualAuthority)(z?.remoteAuthority,ve.remoteAuthority)?z:void 0;le(this.doOpenFilesInExistingWindow(T,ve,Z),!!Z),ge=!0}for(const ve of Oe){if(pe.some(fe=>(0,ee.isSingleFolderWorkspaceIdentifier)(fe.openedWorkspace)&&l.extUriBiasedIgnorePathCase.isEqual(fe.openedWorkspace.uri,ve.workspace.uri)))continue;const Z=ve.remoteAuthority,de=(0,l.isEqualAuthority)(z?.remoteAuthority,Z)?z:void 0;le(await this.doOpenFolderOrWorkspace(T,ve,ge,de),!!de),ge=!0}}const He=(0,M.distinct)(H,pe=>pe.backupFolder);if(He.length>0)for(const pe of He){const ve=pe.remoteAuthority,Z=(0,l.isEqualAuthority)(z?.remoteAuthority,ve)?z:void 0;le(await this.doOpenEmpty(T,!0,ve,Z,pe),!!Z),ge=!0}if(K.length===0||z){z&&!x&&x++;const pe=z?z.remoteAuthority:T.remoteAuthority;for(let ve=0;ve<x;ve++)le(await this.doOpenEmpty(T,ge,pe,z),!!z),ge=!0}return{windows:(0,M.distinct)(K),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(T,R,W){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),R.focus();const H={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToMerge:W?.filesToMerge,filesToWait:W?.filesToWait,termProgram:T?.userEnv?.TERM_PROGRAM};return R.sendWhenReady("vscode:openFiles",I.CancellationToken.None,H),R}doAddFoldersToExistingWindow(T,R){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:R}),T.focus();const W={foldersToAdd:R};return T.sendWhenReady("vscode:addFolders",I.CancellationToken.None,W),T}doOpenEmpty(T,R,W,H,x){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!x,remoteAuthority:W,filesToOpen:H,forceNewWindow:R});let z;return!R&&typeof T.contextWindowId=="number"&&(z=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:W,forceNewWindow:R,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:H,windowToUse:z,emptyWindowBackupInfo:x,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile})}doOpenFolderOrWorkspace(T,R,W,H,x){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:R,filesToOpen:H}),!W&&!x&&typeof T.contextWindowId=="number"&&(x=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({workspace:R.workspace,userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:R.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:H,windowToUse:x,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile})}async getPathsToOpen(T){let R,W=!1,H=!1;if(T.urisToOpen&&T.urisToOpen.length>0?(R=await this.doExtractPathsFromAPI(T),W=!0):T.forceEmpty?R=[Object.create(null)]:T.cli._.length||T.cli["folder-uri"]||T.cli["file-uri"]?(R=await this.doExtractPathsFromCLI(T.cli),R.length===0&&R.push(Object.create(null)),W=!0):(R=await this.doGetPathsFromLastSession(),R.length===0&&R.push(Object.create(null)),H=!0),!T.addMode&&W){const x=R.filter(z=>X(z));if(x.length>1){const z=x[0].remoteAuthority;if(x.every($=>(0,l.isEqualAuthority)($.remoteAuthority,z))){const $=await this.workspacesManagementMainService.createUntitledWorkspace(x.map(K=>({uri:K.workspace.uri})));R.push({workspace:$,remoteAuthority:z}),R=R.filter(K=>!X(K))}}}if(T.initialStartup&&!H&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const x=await this.doGetPathsFromLastSession();R.unshift(...x.filter(z=>V(z)||X(z)||z.backupPath))}return R}async doExtractPathsFromAPI(T){const R={gotoLineMode:T.gotoLineMode,remoteAuthority:T.remoteAuthority},W=await Promise.all((0,M.coalesce)(T.urisToOpen||[]).map(async H=>{const x=await this.resolveOpenable(H,R);if(x)return x.label=H.label,x;const z=this.resourceFromOpenable(H);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,S.localize)(0,null)],message:z.scheme===d.Schemas.file?(0,S.localize)(1,null):(0,S.localize)(2,null),detail:z.scheme===d.Schemas.file?(0,S.localize)(3,null,(0,f.getPathLabel)(z,{os:o.OS,tildify:this.environmentMainService})):(0,S.localize)(4,null,z.toString(!0))},(0,v.withNullAsUndefined)(P.BrowserWindow.getFocusedWindow()))}));return(0,M.coalesce)(W)}async doExtractPathsFromCLI(T){const R=[],W={ignoreFileNotFound:!0,gotoLineMode:T.goto,remoteAuthority:T.remote||void 0,forceOpenWorkspaceAsFile:T.diff&&T._.length===2||T.merge&&T._.length===4},H=T["folder-uri"];if(H){const $=await Promise.all(H.map(K=>{const re=this.cliArgToUri(K);if(re)return this.resolveOpenable({folderUri:re},W)}));R.push(...(0,M.coalesce)($))}const x=T["file-uri"];if(x){const $=await Promise.all(x.map(K=>{const re=this.cliArgToUri(K);if(re)return this.resolveOpenable((0,ee.hasWorkspaceFileExtension)(K)?{workspaceUri:re}:{fileUri:re},W)}));R.push(...(0,M.coalesce)($))}const z=await Promise.all(T._.map($=>W.remoteAuthority?this.doResolveRemotePath($,W):this.doResolveFilePath($,W)));return R.push(...(0,M.coalesce)(z)),R}cliArgToUri(T){try{const R=E.URI.parse(T);if(!R.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${T}`);return}return R.path?R:R.with({path:"/"})}catch(R){this.logService.error(`Invalid URI input string: ${T}, ${R.message}`)}}async doGetPathsFromLastSession(){const T=this.getRestoreWindowsSetting();switch(T){case"none":return[];case"one":case"all":case"preserve":case"folders":{const R=[];T!=="one"&&R.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&R.push(this.windowsStateHandler.state.lastActiveWindow);const W=await Promise.all(R.map(async H=>{if(H.workspace){const x=await this.resolveOpenable({workspaceUri:H.workspace.configPath},{remoteAuthority:H.remoteAuthority,rejectTransientWorkspaces:!0});if(V(x))return x}else if(H.folderUri){const x=await this.resolveOpenable({folderUri:H.folderUri},{remoteAuthority:H.remoteAuthority});if(X(x))return x}else if(T!=="folders"&&H.backupPath)return{backupPath:H.backupPath,remoteAuthority:H.remoteAuthority}}));return(0,M.coalesce)(W)}}}getRestoreWindowsSetting(){let T;return this.lifecycleMainService.wasRestarted?T="all":(T=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(T)||(T="all")),T}async resolveOpenable(T,R=Object.create(null)){const W=this.resourceFromOpenable(T);return W.scheme===d.Schemas.file?((0,U.isFileToOpen)(T)&&(R={...R,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(W.fsPath,R)):this.doResolveRemoteOpenable(T,R)}doResolveRemoteOpenable(T,R){let W=this.resourceFromOpenable(T);const H=(0,A.getRemoteAuthority)(W)||R.remoteAuthority;if(W=(0,l.removeTrailingPathSeparator)((0,l.normalizePath)(W)),(0,U.isFileToOpen)(T)){if(R.gotoLineMode){const{path:x,line:z,column:$}=(0,c.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:x}),options:{selection:z?{startLineNumber:z,startColumn:$||1}:void 0},remoteAuthority:H}}return{fileUri:W,remoteAuthority:H}}else if((0,U.isWorkspaceToOpen)(T))return{workspace:(0,ae.getWorkspaceIdentifier)(W),remoteAuthority:H};return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:H}}resourceFromOpenable(T){return(0,U.isWorkspaceToOpen)(T)?T.workspaceUri:(0,U.isFolderToOpen)(T)?T.folderUri:T.fileUri}async doResolveFilePath(T,R,W){let H,x;R.gotoLineMode&&({path:T,line:H,column:x}=(0,c.parseLineAndColumnAware)(T)),T=(0,c.sanitizeFilePath)((0,b.normalize)(T),(0,g.cwd)());try{const z=await L.Promises.stat(T);if(z.isFile()){if(!R.forceOpenWorkspaceAsFile){const $=await this.workspacesManagementMainService.resolveLocalWorkspace(E.URI.file(T));if($)return $.transient&&R.rejectTransientWorkspaces?void 0:{workspace:{id:$.id,configPath:$.configPath},type:i.FileType.File,exists:!0,remoteAuthority:$.remoteAuthority,transient:$.transient}}return{fileUri:E.URI.file(T),type:i.FileType.File,exists:!0,options:{selection:H?{startLineNumber:H,startColumn:x||1}:void 0}}}else{if(z.isDirectory())return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(E.URI.file(T),z),type:i.FileType.Directory,exists:!0};if(!o.isWindows&&T==="/dev/null")return{fileUri:E.URI.file(T),type:i.FileType.File,exists:!0}}}catch(z){if(z.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!W)return this.onUNCHostNotAllowed(T,R);const $=E.URI.file(T);if(this.workspacesHistoryMainService.removeRecentlyOpened([$]),R.ignoreFileNotFound)return{fileUri:$,type:i.FileType.File,exists:!1}}}async onUNCHostNotAllowed(T,R){const W=E.URI.file(T),{response:H,checkboxChecked:x}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,S.localize)(5,null),(0,S.localize)(6,null),(0,S.localize)(7,null)],message:(0,S.localize)(8,null,W.authority),detail:(0,S.localize)(9,null,(0,f.getPathLabel)(W,{os:o.OS,tildify:this.environmentMainService})),checkboxLabel:(0,S.localize)(10,null,W.authority),cancelId:1});if(H===0)return(0,s.addUNCHostToAllowlist)(W.authority),x&&this._register(h.Event.once(this.onDidOpenWindow)(z=>{z.sendWhenReady("vscode:configureAllowedUNCHost",I.CancellationToken.None,W.authority)})),this.doResolveFilePath(T,R,!0);if(H===2)return P.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.onUNCHostNotAllowed(T,R)}doResolveRemotePath(T,R){const W=T.charCodeAt(0),H=R.remoteAuthority;let x,z;R.gotoLineMode&&({path:T,line:x,column:z}=(0,c.parseLineAndColumnAware)(T)),W!==47&&((0,c.isWindowsDriveLetter)(W)&&T.charCodeAt(T.charCodeAt(1))===58&&(T=(0,c.toSlashes)(T)),T=`/${T}`);const $=E.URI.from({scheme:d.Schemas.vscodeRemote,authority:H,path:T});if(T.charCodeAt(T.length-1)!==47){if((0,ee.hasWorkspaceFileExtension)(T))return R.forceOpenWorkspaceAsFile?{fileUri:$,options:{selection:x?{startLineNumber:x,startColumn:z||1}:void 0},remoteAuthority:R.remoteAuthority}:{workspace:(0,ae.getWorkspaceIdentifier)($),remoteAuthority:H};if(R.gotoLineMode||b.posix.basename(T).indexOf(".")!==-1)return{fileUri:$,options:{selection:x?{startLineNumber:x,startColumn:z||1}:void 0},remoteAuthority:H}}return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)($),remoteAuthority:H}}shouldOpenNewWindow(T){const R=this.configurationService.getValue("window"),W=R?.openFoldersInNewWindow||"default",H=R?.openFilesInNewWindow||"off";let x=(T.preferNewWindow||T.forceNewWindow)&&!T.forceReuseWindow;!T.forceNewWindow&&!T.forceReuseWindow&&(W==="on"||W==="off")&&(x=W==="on");let z=!1;return T.forceNewWindow||T.forceReuseWindow?z=!!T.forceNewWindow&&!T.forceReuseWindow:(o.isMacintosh?T.context===1&&(z=!0):T.context!==3&&T.context!==2&&!(T.userEnv&&T.userEnv.TERM_PROGRAM==="vscode")&&(z=!0),!T.cli.extensionDevelopmentPath&&(H==="on"||H==="off")&&(z=H==="on")),{openFolderInNewWindow:!!x,openFilesInNewWindow:z}}async openExtensionDevelopmentHostWindow(T,R){const W=(0,se.findWindowOnExtensionDevelopmentPath)(this.getWindows(),T);if(W)return this.lifecycleMainService.reload(W,R.cli),W.focus(),[W];let H=R.cli["folder-uri"]||[],x=R.cli["file-uri"]||[],z=R.cli._;if(!z.length&&!H.length&&!x.length&&!R.cli.extensionTestsPath){const re=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,le=re?.workspace??re?.folderUri;le&&(E.URI.isUri(le)?le.scheme===d.Schemas.file?z=[le.fsPath]:H=[le.toString()]:le.configPath.scheme===d.Schemas.file?z=[(0,l.originalFSPath)(le.configPath)]:x=[le.configPath.toString()])}let $=R.remoteAuthority;for(const re of T)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const le=E.URI.parse(re),ge=(0,A.getRemoteAuthority)(le);ge&&($?(0,l.isEqualAuthority)(ge,$)||this.logService.error("more than one extension development path authority"):$=ge)}z=z.filter(re=>{const le=E.URI.file(re);return(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),le)?!1:(0,l.isEqualAuthority)((0,A.getRemoteAuthority)(le),$)}),H=H.filter(re=>{const le=this.cliArgToUri(re);return le&&(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),le)?!1:le?(0,l.isEqualAuthority)((0,A.getRemoteAuthority)(le),$):!1}),x=x.filter(re=>{const le=this.cliArgToUri(re);return le&&(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),le)?!1:le?(0,l.isEqualAuthority)((0,A.getRemoteAuthority)(le),$):!1}),R.cli._=z,R.cli["folder-uri"]=H,R.cli["file-uri"]=x;const K={context:R.context,cli:R.cli,forceNewWindow:!0,forceEmpty:!z.length&&!H.length&&!x.length,userEnv:R.userEnv,noRecentEntry:!0,waitMarkerFileURI:R.waitMarkerFileURI,remoteAuthority:$,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile};return this.open(K)}async openInBrowserWindow(T){const R=this.configurationService.getValue("window"),W=this.getLastActiveWindow(),H=W?.profile??this.userDataProfilesMainService.defaultProfile;let x;!T.forceNewWindow&&!T.forceNewTabbedWindow&&(x=T.windowToUse||W,x&&x.focus());const z={...this.environmentMainService.args,...T.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:T.emptyWindowBackupInfo?(0,b.join)(this.environmentMainService.backupHome,T.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:H},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:T.remoteAuthority,workspace:T.workspace,userEnv:{...this.initialUserEnv,...T.userEnv},filesToOpenOrCreate:T.filesToOpen?.filesToOpenOrCreate,filesToDiff:T.filesToOpen?.filesToDiff,filesToMerge:T.filesToOpen?.filesToMerge,filesToWait:T.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.fsPath,product:k.default,isInitialStartup:T.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,_.release)(),hostname:(0,_.hostname)()},zoomLevel:typeof R?.zoomLevel=="number"?R.zoomLevel:void 0,autoDetectHighContrast:R?.autoDetectHighContrast??!0,autoDetectColorScheme:R?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if(x){const $=x.config;!z.extensionDevelopmentPath&&$?.extensionDevelopmentPath&&(z.extensionDevelopmentPath=$.extensionDevelopmentPath,z.extensionDevelopmentKind=$.extensionDevelopmentKind,z["enable-proposed-api"]=$["enable-proposed-api"],z.verbose=$.verbose,z["inspect-extensions"]=$["inspect-extensions"],z["inspect-brk-extensions"]=$["inspect-brk-extensions"],z.debugId=$.debugId,z.extensionEnvironment=$.extensionEnvironment,z["extensions-dir"]=$["extensions-dir"],z["disable-extensions"]=$["disable-extensions"]),z.loggers={global:z.loggers.global,window:$?.loggers.window??z.loggers.window}}else{const $=this.windowsStateHandler.getNewWindowState(z);(0,y.mark)("code/willCreateCodeWindow");const K=x=this.instantiationService.createInstance(q.CodeWindow,{state:$,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});(0,y.mark)("code/didCreateCodeWindow"),T.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(K),at.WINDOWS.push(K),this._onDidOpenWindow.fire(K),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(K.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(K)),(0,m.once)(K.onDidClose)(()=>this.onWindowClosed(K)),(0,m.once)(K.onDidDestroy)(()=>this._onDidDestroyWindow.fire(K)),K.onDidTriggerSystemContextMenu(({x:le,y:ge})=>this._onDidTriggerSystemContextMenu.fire({window:K,x:le,y:ge}));const re=(0,v.assertIsDefined)(K.win?.webContents);re.removeAllListeners("devtools-reload-page"),re.on("devtools-reload-page",()=>this.lifecycleMainService.reload(K)),this.lifecycleMainService.registerWindow(K)}return z.windowId=x.id,x.isReady?this.lifecycleMainService.unload(x,4).then(async $=>{$||await this.doOpenInBrowserWindow(x,z,T,H)}):await this.doOpenInBrowserWindow(x,z,T,H),x}async doOpenInBrowserWindow(T,R,W,H){if(R.extensionDevelopmentPath||((0,ee.isWorkspaceIdentifier)(R.workspace)?R.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:R.workspace,remoteAuthority:R.remoteAuthority}):(0,ee.isSingleFolderWorkspaceIdentifier)(R.workspace)?R.backupPath=this.backupMainService.registerFolderBackup({folderUri:R.workspace.uri,remoteAuthority:R.remoteAuthority}):R.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:W.emptyWindowBackupInfo?.backupFolder??(0,ae.createEmptyWorkspaceIdentifier)().id,remoteAuthority:R.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const x=R.workspace??(0,ee.toWorkspaceIdentifier)(R.backupPath,!1),z=this.resolveProfileForBrowserWindow(W,x,H),$=z instanceof Promise?await z:z;R.profiles.profile=$,R.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(x,$)}T.load(R)}resolveProfileForBrowserWindow(T,R,W){return T.forceProfile?this.userDataProfilesMainService.profiles.find(H=>H.name===T.forceProfile)??this.userDataProfilesMainService.createNamedProfile(T.forceProfile):T.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(R)??W}onWindowClosed(T){const R=at.WINDOWS.indexOf(T);at.WINDOWS.splice(R,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const T=P.BrowserWindow.getFocusedWindow();if(T)return this.getWindowById(T.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(T){return this.doGetLastActiveWindow(this.getWindows().filter(R=>(0,l.isEqualAuthority)(R.remoteAuthority,T)))}doGetLastActiveWindow(T){const R=Math.max.apply(Math,T.map(W=>W.lastFocusTime));return T.find(W=>W.lastFocusTime===R)}sendToFocused(T,...R){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(T,I.CancellationToken.None,...R)}sendToAll(T,R,W){for(const H of this.getWindows())W&&W.indexOf(H.id)>=0||H.sendWhenReady(T,I.CancellationToken.None,R)}getWindows(){return at.WINDOWS}getWindowCount(){return at.WINDOWS.length}getWindowById(T){const R=this.getWindows().filter(W=>W.id===T);return(0,M.firstOrDefault)(R)}getWindowByWebContents(T){const R=P.BrowserWindow.fromWebContents(T);if(R)return this.getWindowById(R.id)}};e.WindowsMainService=ce,e.WindowsMainService=ce=Se([J(2,C.ILogService),J(3,B.ILoggerMainService),J(4,O.IStateService),J(5,F.IPolicyService),J(6,n.IEnvironmentMainService),J(7,N.IUserDataProfilesMainService),J(8,p.ILifecycleMainService),J(9,t.IBackupMainService),J(10,u.IConfigurationService),J(11,ue.IWorkspacesHistoryMainService),J(12,G.IWorkspacesManagementMainService),J(13,a.IInstantiationService),J(14,r.IDialogMainService),J(15,i.IFileService),J(16,D.IProtocolMainService),J(17,Y.IThemeMainService)],ce)}),define(te[305],ie([0,1,64,29,84,54]),function(j,e,P,L,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(h,c,m,f){this.workspacesManagementMainService=h,this.windowsMainService=c,this.workspacesHistoryMainService=m,this.backupMainService=f,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,c){const m=this.windowsMainService.getWindowById(h);if(m)return this.workspacesManagementMainService.enterWorkspace(m,this.windowsMainService.getWindows(),c)}createUntitledWorkspace(h,c,m){return this.workspacesManagementMainService.createUntitledWorkspace(c,m)}deleteUntitledWorkspace(h,c){return this.workspacesManagementMainService.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(h,c){return this.workspacesManagementMainService.getWorkspaceIdentifier(c)}getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(h,c){return this.workspacesHistoryMainService.addRecentlyOpened(c)}removeRecentlyOpened(h,c){return this.workspacesHistoryMainService.removeRecentlyOpened(c)}clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=M,e.WorkspacesMainService=M=Se([J(0,_.IWorkspacesManagementMainService),J(1,L.IWindowsMainService),J(2,s.IWorkspacesHistoryMainService),J(3,P.IBackupMainService)],M)}),define(te[306],ie([0,1,14,132,38,27,17,50,13,32,49,45,46,2,15,9,4,10,7,31,146,43,157,110,289,160,64,285,18,76,198,91,133,61,115,218,28,63,95,207,233,208,293,117,209,210,16,222,94,75,6,93,216,298,286,274,20,5,303,67,23,60,294,96,34,277,83,122,26,249,251,52,48,264,290,299,291,300,127,266,267,268,271,275,29,304,276,30,98,84,305,54,273,39,231,53,243,51,82,129,279,292,282,8,253,278,226,66,92,296,270,24,125,295,261,238,85]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o,g,l,v,E,S,t,u,r,n,i,a,p,C,k,D,A,O,U,q,se,ne,ee,ae,ue,G,Y,F,N,B,V,X,ce,oe,T,R,W,H,x,z,$,K,re,le,ge,Ce,Me,Re,Oe,He,pe,ve,Z,de,fe,Ie,Le,Te,Ae,Be,Ne,qe,ze,Q,he,me,be,ye,De,We,$e,je,Je,Ye,Xe,tt,ot,ct,Lt,gt,At,_t,Ot,Tt,Wt,Ft,Ut,mt,Nt,Bt,zt,$t,qt,pt,Ht,It,vt,xt,jt,wt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let St=class extends d.Disposable{constructor(Pe,Ee,we,_e,ke,Ue,Ge,Qe,Fe,xe,Ve,Ke){super(),this.mainProcessNodeIpcServer=Pe,this.userEnv=Ee,this.mainInstantiationService=we,this.logService=_e,this.loggerService=ke,this.environmentMainService=Ue,this.lifecycleMainService=Ge,this.configurationService=Qe,this.stateService=Fe,this.fileService=xe,this.productService=Ve,this.userDataProfilesMainService=Ke,this.configureSession(),this.registerListeners()}configureSession(){const Pe=Fe=>Fe?.startsWith(`${b.Schemas.vscodeWebview}://`),Ee=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((Fe,xe,Ve,Ke)=>Pe(Ke.requestingUrl)?Ve(Ee.has(xe)):Ve(!1)),P.session.defaultSession.setPermissionCheckHandler((Fe,xe,Ve,Ke)=>Pe(Ke.requestingUrl)?Ee.has(xe):!1);const we=new Set([b.Schemas.file,b.Schemas.vscodeFileResource,b.Schemas.vscodeRemoteResource,b.Schemas.vscodeManagedRemoteResource,"devtools"]),_e=Fe=>{for(let xe=Fe;xe;xe=xe.parent)if(xe.url.startsWith(`${b.Schemas.vscodeWebview}://`))return!0;return!1},ke=Fe=>Fe.resourceType==="xhr"||_e(Fe.frame),Ue=Fe=>{const xe=Fe.frame;if(!xe||!this.windowsMainService)return!1;const Ve=P.BrowserWindow.getAllWindows();for(const Ke of Ve)if(xe.processId===Ke.webContents.mainFrame.processId)return!0;return!1},Ge=(Fe,xe)=>{if(Fe.path!=="/index.html")return!0;const Ve=xe.frame;if(!Ve||!this.windowsMainService)return!1;for(const Ke of this.windowsMainService.getWindows())if(Ke.win&&Ve.processId===Ke.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((Fe,xe)=>{const Ve=l.URI.parse(Fe.url);return Ve.scheme===b.Schemas.vscodeWebview&&!Ge(Ve,Fe)?(this.logService.error("Blocked vscode-webview request",Fe.url),xe({cancel:!0})):Ve.scheme===b.Schemas.vscodeFileResource&&!Ue(Fe)?(this.logService.error("Blocked vscode-file request",Fe.url),xe({cancel:!0})):Ve.path.endsWith(".svg")&&!we.has(Ve.scheme)?xe({cancel:!ke(Fe)}):xe({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Fe,xe)=>{const Ve=Fe.responseHeaders,Ke=Ve["content-type"]||Ve["Content-Type"];if(Ke&&Array.isArray(Ke)){const Ze=l.URI.parse(Fe.url);if(Ze.path.endsWith(".svg")&&we.has(Ze.scheme))return Ve["Content-Type"]=["image/svg+xml"],xe({cancel:!1,responseHeaders:Ve});if(!Ze.path.endsWith(b.Schemas.vscodeRemoteResource)&&Ke.some(rt=>rt.toLowerCase().includes("image/svg")))return xe({cancel:!ke(Fe)})}return xe({cancel:!1})});const Qe=P.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Qe.setCodeCachePath((0,y.join)(this.environmentMainService.codeCachePath,"chrome")),o.isWindows&&(this.configurationService.getValue("security.restrictUNCAccess")===!1?(0,L.disableUNCAccessRestrictions)():(0,L.addUNCHostToAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,h.setUnexpectedErrorHandler)(we=>this.onUnexpectedError(we)),process.on("uncaughtException",we=>{(0,h.isSigPipeError)(we)||(0,h.onUnexpectedError)(we)}),process.on("unhandledRejection",we=>(0,h.onUnexpectedError)(we)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,E.registerContextMenuListener)(),P.app.on("accessibility-support-changed",(we,_e)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",_e)}),P.app.on("activate",async(we,_e)=>{this.logService.trace("app#activate"),_e||await this.windowsMainService?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(we,_e)=>{_e.on("will-navigate",ke=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),_e.setWindowOpenHandler(({url:ke})=>(this.nativeHostMainService?.openExternal(void 0,ke),{action:"deny"}))});let Pe=[],Ee;P.app.on("open-file",(we,_e)=>{this.logService.trace("app#open-file: ",_e),we.preventDefault(),Pe.push((0,je.hasWorkspaceFileExtension)(_e)?{workspaceUri:l.URI.file(_e)}:{fileUri:l.URI.file(_e)}),Ee!==void 0&&(clearTimeout(Ee),Ee=void 0),Ee=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Ee=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),s.validatedIpcMain.handle("vscode:fetchShellEnv",we=>{const _e=this.windowsMainService?.getWindowByWebContents(we.sender);let ke,Ue;return _e?.config?(ke=_e.config,Ue={...process.env,..._e.config.userEnv}):(ke=this.environmentMainService.args,Ue=process.env),this.resolveShellEnvironment(ke,Ue,!1)}),s.validatedIpcMain.handle("vscode:writeNlsFile",(we,_e,ke)=>{const Ue=this.validateNlsPath([_e]);if(!Ue||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ue,M.VSBuffer.fromString(ke))}),s.validatedIpcMain.handle("vscode:readNlsFile",async(we,..._e)=>{const ke=this.validateNlsPath(_e);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(ke)).value.toString()}),s.validatedIpcMain.on("vscode:toggleDevTools",we=>we.sender.toggleDevTools()),s.validatedIpcMain.on("vscode:openDevTools",we=>we.sender.openDevTools()),s.validatedIpcMain.on("vscode:reloadWindow",we=>we.sender.reload())}validateNlsPath(Pe){let Ee;for(const we of Pe)typeof we=="string"&&(typeof Ee!="string"?Ee=we:Ee=(0,y.join)(Ee,we));if(!(typeof Ee!="string"||!(0,y.isAbsolute)(Ee)||!(0,c.isEqualOrParent)(Ee,this.environmentMainService.cachedLanguagesPath,!o.isLinux)))return l.URI.file(Ee)}onUnexpectedError(Pe){if(Pe){const Ee={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Ee))}this.logService.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.logService.error(Pe.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Pe=this.productService.win32AppUserModelId;o.isWindows&&Pe&&P.app.setAppUserModelId(Pe);try{o.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Fe){this.logService.error(Fe)}const Ee=new t.Server;this.lifecycleMainService.onWillShutdown(Fe=>{Fe.reason===2&&Ee.dispose()}),this.logService.trace("Resolving machine identifier...");const we=await(0,Nt.resolveMachineId)(this.stateService,this.logService);this.logService.trace(`Resolved machine identifier: ${we}`);const{sharedProcessReady:_e,sharedProcessClient:ke}=this.setupSharedProcess(we),Ue=await this.initServices(we,_e);this._register(Ue.createInstance(r.ProxyAuthHandler)),this._register(Ue.createInstance(Ft.UserDataProfilesHandler)),Ue.invokeFunction(Fe=>this.initChannels(Fe,Ee,ke));const Ge=Ue.invokeFunction(Fe=>this.setupProtocolUrlHandlers(Fe,Ee));this.setupManagedRemoteResourceUrlHandler(Ee),this.lifecycleMainService.phase=2,await Ue.invokeFunction(Fe=>this.openFirstWindow(Fe,Ge)),this.lifecycleMainService.phase=3,this.afterWindowOpen(),this._register(new mt.RunOnceScheduler(()=>{this._register((0,mt.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setupProtocolUrlHandlers(Pe,Ee){const we=this.windowsMainService=Pe.get(De.IWindowsMainService),_e=Pe.get(ze.IURLService),ke=this.nativeHostMainService=Pe.get(le.INativeHostMainService),Ue=this;_e.registerHandler({async handleURL(Ke,Ze){return Ue.handleProtocolUrl(we,_e,Ke,Ze)}});const Ge=this._register(new $e.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Qe=new S.StaticRouter(Ke=>Ge.getActiveClientId().then(Ze=>Ke===Ze)),Fe=new Q.URLHandlerRouter(Qe,this.logService),xe=Ee.getChannel("urlHandler",Fe);_e.registerHandler(new Q.URLHandlerChannelClient(xe));const Ve=this.resolveInitialProtocolUrls();return this._register(new me.ElectronURLListener(Ve?.urls,_e,we,this.environmentMainService,this.productService,this.logService)),Ve}setupManagedRemoteResourceUrlHandler(Pe){const Ee=()=>({statusCode:404,data:"Not found"}),we=new Vt.Lazy(()=>Pe.getChannel(wt.NODE_REMOTE_RESOURCE_CHANNEL_NAME,new wt.NodeRemoteResourceRouter));P.protocol.registerBufferProtocol(b.Schemas.vscodeManagedRemoteResource,(_e,ke)=>{const Ue=l.URI.parse(_e.url);if(!Ue.authority.startsWith("window:"))return ke(Ee());we.value.call(wt.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME,[Ue]).then(Ge=>ke({...Ge,data:Buffer.from(Ge.body,"base64")}),Ge=>{this.logService.warn("error dispatching remote resource call",Ge),ke({statusCode:500,data:String(Ge)})})})}resolveInitialProtocolUrls(){const Pe=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Pe.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Pe);const Ee=global.getOpenUrls()||[];if(Ee.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ee),Pe.length+Ee.length===0)return;const we=[];return{urls:[...Pe,...Ee].map(ke=>{try{return{uri:l.URI.parse(ke),originalUrl:ke}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",ke);return}}).filter(ke=>{if(!ke)return!1;if(this.shouldBlockURI(ke.uri))return this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",ke.uri.toString(!0)),!1;const Ue=this.getWindowOpenableFromProtocolUrl(ke.uri);return Ue?(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",ke.uri.toString(!0),Ue),we.push(Ue),!1):(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",ke.uri.toString(!0)),!0)}),openables:we}}shouldBlockURI(Pe){if(Pe.authority===b.Schemas.file&&o.isWindows){const{options:Ee,buttonIndeces:we}=(0,qt.massageMessageBoxOptions)({type:"warning",buttons:[(0,n.localize)(0,null),(0,n.localize)(1,null)],message:(0,n.localize)(2,null,(0,w.getPathLabel)(Pe,{os:o.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,n.localize)(3,null)},this.productService);if(we[P.dialog.showMessageBoxSync(Ee)]===1)return!0}return!1}getWindowOpenableFromProtocolUrl(Pe){if(Pe.path){if(Pe.authority===b.Schemas.file){const Ee=l.URI.file(Pe.fsPath);return(0,je.hasWorkspaceFileExtension)(Ee)?{workspaceUri:Ee}:{fileUri:Ee}}else if(Pe.authority===b.Schemas.vscodeRemote){const Ee=Pe.path.indexOf(y.posix.sep,1);if(Ee!==-1){const we=Pe.path.substring(1,Ee),_e=Pe.path.substring(Ee),ke=l.URI.from({scheme:b.Schemas.vscodeRemote,authority:we,path:_e,query:Pe.query,fragment:Pe.fragment});return(0,je.hasWorkspaceFileExtension)(_e)?{workspaceUri:ke}:/:[\d]+$/.test(_e)?{fileUri:ke}:{folderUri:ke}}}}}async handleProtocolUrl(Pe,Ee,we,_e){if(this.logService.trace("app#handleProtocolUrl():",we.toString(!0),_e),we.scheme===this.productService.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:l.URI.parse(we.query).path,query:""})),this.shouldBlockURI(we))return this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0;let ke=!1;const Ue=new URLSearchParams(we.query);Ue.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),Ue.delete("windowId"),we=we.with({query:Ue.toString()}),ke=!0):o.isMacintosh&&Pe.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),ke=!0);const Ge=Ue.get("continueOn");Ge!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),Ue.delete("continueOn"),we=we.with({query:Ue.toString()}),this.environmentMainService.continueOn=Ge??void 0);const Qe=this.getWindowOpenableFromProtocolUrl(we);return Qe?(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Qe,we.toString(!0)),(0,It.firstOrDefault)(await Pe.open({context:5,cli:{...this.environmentMainService.args},urisToOpen:[Qe],forceNewWindow:ke,gotoLineMode:!0}))?.focus(),!0):ke?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,It.firstOrDefault)(await Pe.open({context:5,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ce.getRemoteAuthority)(we)}))?.ready(),Ee.open(we,_e)):(this.logService.trace("app#handleProtocolUrl(): not handled",we.toString(!0),_e),!1)}setupSharedProcess(Pe){const Ee=this._register(this.mainInstantiationService.createInstance(Me.SharedProcess,Pe)),we=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await Ee.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new u.Client(ke,"main")})();return{sharedProcessReady:(async()=>(await Ee.whenReady(),we))(),sharedProcessClient:we}}async initServices(Pe,Ee){const we=new R.ServiceCollection;switch(process.platform){case"win32":we.set(Le.IUpdateService,new oe.SyncDescriptor(qe.Win32UpdateService));break;case"linux":o.isLinuxSnap?we.set(Le.IUpdateService,new oe.SyncDescriptor(Ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(Le.IUpdateService,new oe.SyncDescriptor(Be.LinuxUpdateService));break;case"darwin":we.set(Le.IUpdateService,new oe.SyncDescriptor(Ae.DarwinUpdateService));break}we.set(De.IWindowsMainService,new oe.SyncDescriptor(We.WindowsMainService,[Pe,this.userEnv],!1));const _e=new O.DialogMainService(this.logService,this.productService);we.set(O.IDialogMainService,_e),we.set(z.ILaunchMainService,new oe.SyncDescriptor(z.LaunchMainService,void 0,!1)),we.set(A.IDiagnosticsMainService,new oe.SyncDescriptor(A.DiagnosticsMainService,void 0,!1)),we.set(D.IDiagnosticsService,S.ProxyChannel.toService((0,S.getDelayedChannel)(Ee.then(Fe=>Fe.getChannel("diagnostics"))))),we.set(W.IIssueMainService,new oe.SyncDescriptor(H.IssueMainService,[this.userEnv])),we.set(U.IEncryptionMainService,new oe.SyncDescriptor(q.EncryptionMainService,[Pe])),we.set(x.IKeyboardLayoutMainService,new oe.SyncDescriptor(x.KeyboardLayoutMainService)),we.set(le.INativeHostMainService,new oe.SyncDescriptor(le.NativeHostMainService,void 0,!1)),we.set(C.ICredentialsMainService,new oe.SyncDescriptor(ot.CredentialsNativeMainService)),we.set(be.IWebviewManagerService,new oe.SyncDescriptor(ye.WebviewMainService)),we.set(re.IMenubarMainService,new oe.SyncDescriptor(re.MenubarMainService)),we.set(ae.IExtensionUrlTrustService,new oe.SyncDescriptor(ue.ExtensionUrlTrustService)),we.set(G.IExtensionHostStarter,new oe.SyncDescriptor(Y.ExtensionHostStarter)),we.set(pe.IStorageMainService,new oe.SyncDescriptor(pe.StorageMainService)),we.set(pe.IApplicationStorageMainService,new oe.SyncDescriptor(pe.ApplicationStorageMainService));const ke=new xt.ElectronPtyHostStarter({graceTime:6e4,shortGraceTime:6e3,scrollback:this.configurationService.getValue("terminal.integrated.persistentSessionScrollback")??100},this.configurationService,this.environmentMainService,this.lifecycleMainService,this.logService),Ue=new jt.PtyHostService(ke,this.configurationService,this.logService,this.loggerService);we.set(vt.ILocalPtyService,Ue),o.isWindows?we.set(F.IExternalTerminalMainService,new oe.SyncDescriptor(N.WindowsExternalTerminalService)):o.isMacintosh?we.set(F.IExternalTerminalMainService,new oe.SyncDescriptor(N.MacExternalTerminalService)):o.isLinux&&we.set(F.IExternalTerminalMainService,new oe.SyncDescriptor(N.LinuxExternalTerminalService));const Ge=new a.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);we.set(i.IBackupMainService,Ge);const Qe=new tt.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,Ge,_e);if(we.set(tt.IWorkspacesManagementMainService,Qe),we.set(Je.IWorkspacesService,new oe.SyncDescriptor(Xe.WorkspacesMainService,void 0,!1)),we.set(Ye.IWorkspacesHistoryMainService,new oe.SyncDescriptor(Ye.WorkspacesHistoryMainService,void 0,!1)),we.set(ze.IURLService,new oe.SyncDescriptor(he.NativeURLService,void 0,!1)),(0,Ie.supportsTelemetry)(this.productService,this.environmentMainService)){const Fe=(0,Ie.isInternalTelemetry)(this.productService,this.configurationService),xe=(0,S.getDelayedChannel)(Ee.then(it=>it.getChannel("telemetryAppender"))),Ve=new de.TelemetryAppenderClient(xe),Ke=(0,ve.resolveCommonProperties)((0,_.release)(),(0,_.hostname)(),process.arch,this.productService.commit,this.productService.version,Pe,Fe),Ze=(0,Ie.getPiiPathsFromEnvironment)(this.environmentMainService),rt={appenders:[Ve],commonProperties:Ke,piiPaths:Ze,sendErrorTelemetry:!0};we.set(Z.ITelemetryService,new oe.SyncDescriptor(fe.TelemetryService,[rt],!1))}else we.set(Z.ITelemetryService,Ie.NullTelemetryService);return we.set(Ot.IExtensionsProfileScannerService,new oe.SyncDescriptor(Bt.ExtensionsProfileScannerService,void 0,!0)),we.set(Tt.IExtensionsScannerService,new oe.SyncDescriptor(Wt.ExtensionsScannerService,void 0,!0)),we.set(pt.IUtilityProcessWorkerMainService,new oe.SyncDescriptor(pt.UtilityProcessWorkerMainService,void 0,!0)),await mt.Promises.settled([Ge.initialize(),Qe.initialize()]),this.mainInstantiationService.createChild(we)}initChannels(Pe,Ee,we){const _e=S.ProxyChannel.fromService(Pe.get(z.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",_e);const ke=S.ProxyChannel.fromService(Pe.get(A.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",ke);const Ue=new Lt.PolicyChannel(Pe.get(ct.IPolicyService));Ee.registerChannel("policy",Ue),we.then(et=>et.registerChannel("policy",Ue));const Ge=this.fileService.getProvider(b.Schemas.file);(0,g.assertType)(Ge instanceof ce.DiskFileSystemProvider);const Qe=new X.DiskFileSystemProviderChannel(Ge,this.logService,this.environmentMainService);Ee.registerChannel(B.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe),we.then(et=>et.registerChannel(B.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe));const Fe=S.ProxyChannel.fromService(Pe.get(gt.IUserDataProfilesMainService));Ee.registerChannel("userDataProfiles",Fe),we.then(et=>et.registerChannel("userDataProfiles",Fe));const xe=new At.RequestChannel(Pe.get(_t.IRequestService));we.then(et=>et.registerChannel("request",xe));const Ve=new Te.UpdateChannel(Pe.get(Le.IUpdateService));Ee.registerChannel("update",Ve);const Ke=S.ProxyChannel.fromService(Pe.get(W.IIssueMainService));Ee.registerChannel("issue",Ke);const Ze=S.ProxyChannel.fromService(Pe.get(U.IEncryptionMainService));Ee.registerChannel("encryption",Ze);const rt=S.ProxyChannel.fromService(Pe.get(C.ICredentialsMainService));Ee.registerChannel("credentials",rt);const it=S.ProxyChannel.fromService(Pe.get(Re.ISignService));Ee.registerChannel("sign",it);const lt=S.ProxyChannel.fromService(Pe.get(x.IKeyboardLayoutMainService));Ee.registerChannel("keyboardLayout",lt),this.nativeHostMainService=Pe.get(le.INativeHostMainService);const Ct=S.ProxyChannel.fromService(this.nativeHostMainService);Ee.registerChannel("nativeHost",Ct),we.then(et=>et.registerChannel("nativeHost",Ct));const Gt=S.ProxyChannel.fromService(Pe.get(Je.IWorkspacesService));Ee.registerChannel("workspaces",Gt);const Kt=S.ProxyChannel.fromService(Pe.get(re.IMenubarMainService));Ee.registerChannel("menubar",Kt);const Yt=S.ProxyChannel.fromService(Pe.get(ze.IURLService));Ee.registerChannel("url",Yt);const Qt=S.ProxyChannel.fromService(Pe.get(ae.IExtensionUrlTrustService));Ee.registerChannel("extensionUrlTrust",Qt);const Xt=S.ProxyChannel.fromService(Pe.get(be.IWebviewManagerService));Ee.registerChannel("webview",Xt);const kt=this._register(new He.StorageDatabaseChannel(this.logService,Pe.get(pe.IStorageMainService)));Ee.registerChannel("storage",kt),we.then(et=>et.registerChannel("storage",kt));const Jt=this._register(new Ut.ProfileStorageChangesListenerChannel(Pe.get(pe.IStorageMainService),Pe.get(gt.IUserDataProfilesMainService),this.logService));we.then(et=>et.registerChannel("profileStorageListener",Jt));const Zt=S.ProxyChannel.fromService(Pe.get(vt.ILocalPtyService));Ee.registerChannel(vt.TerminalIpcChannels.LocalPty,Zt);const ei=S.ProxyChannel.fromService(Pe.get(F.IExternalTerminalMainService));Ee.registerChannel("externalTerminal",ei);const Dt=new zt.LoggerChannel(Pe.get($t.ILoggerMainService));Ee.registerChannel("logger",Dt),we.then(et=>et.registerChannel("logger",Dt));const ti=new k.ElectronExtensionHostDebugBroadcastChannel(Pe.get(De.IWindowsMainService));Ee.registerChannel("extensionhostdebugservice",ti);const ii=S.ProxyChannel.fromService(Pe.get(G.IExtensionHostStarter));Ee.registerChannel(G.ipcExtensionHostStarterChannelName,ii);const ni=S.ProxyChannel.fromService(Pe.get(pt.IUtilityProcessWorkerMainService));Ee.registerChannel(Ht.ipcUtilityProcessWorkerChannelName,ni)}async openFirstWindow(Pe,Ee){const we=this.windowsMainService=Pe.get(De.IWindowsMainService),_e=(0,ne.isLaunchedFromCli)(process.env)?0:4,ke=this.environmentMainService.args;if(Ee){if(Ee.openables.length>0)return we.open({context:_e,cli:ke,urisToOpen:Ee.openables,gotoLineMode:!0,initialStartup:!0});if(Ee.urls.length>0)for(const it of Ee.urls){const lt=new URLSearchParams(it.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:lt.toString()}),we.open({context:_e,cli:ke,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ue=global.macOpenFiles,Ge=ke._.length,Qe=!!ke["folder-uri"],Fe=!!ke["file-uri"],xe=ke["skip-add-to-recently-opened"]===!0,Ve=ke.wait&&ke.waitMarkerFilePath?l.URI.file(ke.waitMarkerFilePath):void 0,Ke=ke.remote||void 0,Ze=ke.profile,rt=ke["profile-temp"];if(!Ge&&!Qe&&!Fe){if(ke["new-window"]||Ze||rt)return we.open({context:_e,cli:ke,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:xe,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Ke,forceProfile:Ze,forceTempProfile:rt});if(Ue.length)return we.open({context:1,cli:ke,urisToOpen:Ue.map(it=>(0,je.hasWorkspaceFileExtension)(it)?{workspaceUri:l.URI.file(it)}:{fileUri:l.URI.file(it)}),noRecentEntry:xe,waitMarkerFileURI:Ve,initialStartup:!0})}return we.open({context:_e,cli:ke,forceNewWindow:ke["new-window"]||!Ge&&ke["unity-launch"],diffMode:ke.diff,mergeMode:ke.merge,noRecentEntry:xe,waitMarkerFileURI:Ve,gotoLineMode:ke.goto,initialStartup:!0,remoteAuthority:Ke,forceProfile:Ze,forceTempProfile:rt})}afterWindowOpen(){this.installMutex(),P.protocol.registerHttpProtocol(b.Schemas.vscodeRemoteResource,(Pe,Ee)=>{Ee({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement(),o.isMacintosh&&P.app.runningUnderARM64Translation&&this.windowsMainService?.sendToFocused("vscode:showTranslatedBuildWarning")}async installMutex(){const Pe=this.productService.win32MutexName;if(o.isWindows&&Pe)try{const Ee=await new Promise((_e,ke)=>{j(["@vscode/windows-mutex"],_e,ke)}),we=new Ee.Mutex(Pe);(0,m.once)(this.lifecycleMainService.onWillShutdown)(()=>we.release())}catch(Ee){this.logService.error(Ee)}}async resolveShellEnvironment(Pe,Ee,we){try{return await(0,ee.getResolvedShellEnv)(this.configurationService,this.logService,Pe,Ee)}catch(_e){const ke=(0,I.toErrorMessage)(_e);we?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",ke):this.logService.error(ke)}return{}}async updateCrashReporterEnablement(){try{const Ee=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),we=JSON.parse((0,f.stripComments)(Ee)),ke=(0,Ie.getTelemetryLevel)(this.configurationService)>=1;if(we["enable-crash-reporter"]===void 0){const Ue=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.generateUuid)()}"`,"}"],Ge=Ee.substring(0,Ee.length-2).concat(`,
`,Ue.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(Ge))}else{const Ue=Ee.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${ke},`);Ue!==Ee&&await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(Ue))}}catch(Pe){this.logService.error(Pe)}}};e.CodeApplication=St,e.CodeApplication=St=Se([J(2,T.IInstantiationService),J(3,K.ILogService),J(4,K.ILoggerService),J(5,se.IEnvironmentMainService),J(6,$.ILifecycleMainService),J(7,p.IConfigurationService),J(8,Oe.IStateService),J(9,V.IFileService),J(10,ge.IProductService),J(11,gt.IUserDataProfilesMainService)],St)}),define(te[312],ie([0,1,14,42,7,24,8,50,13,32,49,46,15,9,65,4,36,25,22,43,131,306,11,18,237,248,28,63,200,16,220,94,75,215,93,20,223,5,78,23,79,280,126,262,51,288,96,247,34,52,80,53,39,232,230,2,40,265,66,225,92,121,269,263]),function(j,e,P,L,s,_,M,I,h,c,m,f,w,d,b,y,o,g,l,v,E,S,t,u,r,n,i,a,p,C,k,D,A,O,U,q,se,ne,ee,ae,ue,G,Y,F,N,B,V,X,ce,oe,T,R,W,H,x,z,$,K,re,le,ge,Ce,Me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Re{main(){try{this.startup()}catch(pe){console.error(pe.message),P.app.exit(1)}}async startup(){(0,h.setUnexpectedErrorHandler)(Ae=>console.error(Ae));const[pe,ve,Z,de,fe,Ie,Le,Te]=this.createServices();try{try{await this.initServices(Z,Te,de,fe,Le)}catch(Ae){throw this.handleStartupDataDirError(Z,Le,Ae),Ae}await pe.invokeFunction(async Ae=>{const Be=Ae.get(ne.ILogService),Ne=Ae.get(q.ILifecycleMainService),qe=Ae.get(C.IFileService),ze=Ae.get(ne.ILoggerService),Q=await this.claimInstance(Be,Z,Ne,pe,Le,!0);return l.Promises.writeFile(Z.mainLockfile,String(process.pid)).catch(he=>{Be.warn(`app#startup(): Error writing main lockfile: ${he.stack}`)}),Ie.logger=ze.createLogger("main",{name:(0,t.localize)(0,null)}),(0,m.once)(Ne.onWillShutdown)(he=>{qe.dispose(),de.dispose(),he.join("instanceLockfile",l.Promises.unlink(Z.mainLockfile).catch(()=>{}))}),pe.createInstance(S.CodeApplication,Q,ve).startup()})}catch(Ae){pe.invokeFunction(this.quit,Ae)}}createServices(){const pe=new U.ServiceCollection,ve=new z.DisposableStore;process.once("exit",()=>ve.dispose());const Z={_serviceBrand:void 0,...ee.default};pe.set(ae.IProductService,Z);const de=new i.EnvironmentMainService(this.resolveArgs(),Z),fe=this.patchEnvironment(de);pe.set(i.IEnvironmentMainService,de);const Ie=new re.LoggerMainService((0,ne.getLogLevel)(de),de.logsHome);pe.set(re.ILoggerMainService,Ie);const Le=new se.BufferLogger(Ie.getLogLevel()),Te=ve.add(new le.LogService(Le,[new ne.ConsoleMainLogger(Ie.getLogLevel())]));pe.set(ne.ILogService,Te);const Ae=new k.FileService(Te);pe.set(C.IFileService,Ae);const Be=new D.DiskFileSystemProvider(Te);Ae.registerProvider(w.Schemas.file,Be),Ae.registerProvider(w.Schemas.vscodeUserData,new Me.FileUserDataProvider(w.Schemas.file,Be,w.Schemas.vscodeUserData,Te));const Ne=new K.UriIdentityService(Ae);pe.set($.IUriIdentityService,Ne);const qe=new Ce.StateService(1,de,Te,Ae);pe.set(ce.IStateReadService,qe),pe.set(ce.IStateService,qe);const ze=new R.UserDataProfilesMainService(qe,Ne,de,Ae,Te);pe.set(R.IUserDataProfilesMainService,ze);const Q=y.isWindows&&Z.win32RegValueName?ve.add(new H.NativePolicyService(Te,Z.win32RegValueName)):de.policyFile?ve.add(new x.FilePolicyService(de.policyFile,Ae,Te)):new W.NullPolicyService;pe.set(W.IPolicyService,Q);const he=new r.ConfigurationService(ze.defaultProfile.settingsResource,Ae,Q,Te);return pe.set(u.IConfigurationService,he),pe.set(q.ILifecycleMainService,new A.SyncDescriptor(q.LifecycleMainService,void 0,!1)),pe.set(N.IRequestService,new A.SyncDescriptor(B.RequestMainService,void 0,!0)),pe.set(T.IThemeMainService,new A.SyncDescriptor(T.ThemeMainService)),pe.set(V.ISignService,new A.SyncDescriptor(X.SignService,void 0,!1)),pe.set(Y.ITunnelService,new A.SyncDescriptor(F.TunnelService)),pe.set(ue.IProtocolMainService,new G.ProtocolMainService(de,ze,Te)),[new O.InstantiationService(pe,!0),fe,de,he,qe,Le,Z,ze]}patchEnvironment(pe){const ve={VSCODE_IPC_HOOK:pe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Z=>{const de=process.env[Z];typeof de=="string"&&(ve[Z]=de)}),Object.assign(process.env,ve),ve}async initServices(pe,ve,Z,de,fe){await M.Promises.settled([Promise.all([pe.extensionsPath,pe.codeCachePath,pe.logsHome.fsPath,ve.defaultProfile.globalStorageHome.fsPath,pe.workspaceStorageHome.fsPath,pe.localHistoryHome.fsPath,pe.backupHome].map(Ie=>Ie?l.Promises.mkdir(Ie,{recursive:!0}):void 0)),de.init(),Z.initialize()]),ve.init()}async claimInstance(pe,ve,Z,de,fe,Ie){let Le;try{(0,b.mark)("code/willStartMainServer"),Le=await(0,E.serve)(ve.mainIPCHandle),(0,b.mark)("code/didStartMainServer"),(0,m.once)(Z.onWillShutdown)(()=>Le.dispose())}catch(Te){if(Te.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ve,fe,Te),Te;let Ae;try{Ae=await(0,E.connect)(ve.mainIPCHandle,"main")}catch(ze){if(!Ie||y.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.showStartupWarningDialog((0,t.localize)(1,null,fe.nameShort),(0,t.localize)(2,null),fe),ze;try{(0,L.unlinkSync)(ve.mainIPCHandle)}catch(Q){throw pe.warn("Could not delete obsolete instance handle",Q),Q}return this.claimInstance(pe,ve,Z,de,fe,!1)}if(ve.extensionTestsLocationURI&&!ve.debugExtensionHost.break){const ze=`Running extension tests from the command line is currently only supported if no other instance of ${fe.nameShort} is running.`;throw pe.error(ze),Ae.dispose(),new Error(ze)}let Be;!ve.args.wait&&!ve.args.status&&(Be=setTimeout(()=>{this.showStartupWarningDialog((0,t.localize)(3,null,fe.nameShort),(0,t.localize)(4,null),fe)},1e4));const Ne=v.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0}),qe=v.ProxyChannel.toService(Ae.getChannel("diagnostics"),{disableMarshalling:!0});if(ve.args.status)return de.invokeFunction(async()=>{const ze=new n.DiagnosticsService(oe.NullTelemetryService,fe),Q=await qe.getMainDiagnostics(),he=await qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),me=await ze.getDiagnostics(Q,he);throw console.log(me),new h.ExpectedError});throw y.isWindows&&await this.windowsAllowSetForegroundWindow(Ne,pe),pe.trace("Sending env to running instance..."),await Ne.start(ve.args,process.env),Ae.dispose(),Be&&clearTimeout(Be),new h.ExpectedError("Sent env to running instance. Terminating...")}if(ve.args.status)throw console.log((0,t.localize)(5,null,fe.nameShort)),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Le}handleStartupDataDirError(pe,ve,Z){if(Z.code==="EACCES"||Z.code==="EPERM"){const de=(0,_.coalesce)([pe.userDataPath,pe.extensionsPath,E.XDG_RUNTIME_DIR]).map(fe=>(0,f.getPathLabel)(s.URI.file(fe),{os:y.OS,tildify:pe}));this.showStartupWarningDialog((0,t.localize)(6,null),(0,t.localize)(7,null,(0,I.toErrorMessage)(Z),de.join(`
`)),ve)}}showStartupWarningDialog(pe,ve,Z){P.dialog.showMessageBoxSync((0,ge.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(8,null)],message:pe,detail:ve},Z).options)}async windowsAllowSetForegroundWindow(pe,ve){if(y.isWindows){const Z=await pe.getMainProcessId();ve.trace("Sending some foreground love to the running instance:",Z);try{(await new Promise((de,fe)=>{j(["windows-foreground-love"],de,fe)})).allowSetForegroundWindow(Z)}catch(de){ve.error(de)}}}quit(pe,ve){const Z=pe.get(ne.ILogService),de=pe.get(q.ILifecycleMainService);let fe=0;ve&&(ve.isExpected?ve.message&&Z.trace(ve.message):(fe=1,ve.stack?Z.error(ve.stack):Z.error(`Startup error: ${ve.toString()}`))),de.kill(fe)}resolveArgs(){const pe=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(pe.wait&&!pe.waitMarkerFilePath){const ve=(0,p.createWaitMarkerFileSync)(pe.verbose);ve&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",ve),pe.waitMarkerFilePath=ve)}return pe}validatePaths(pe){if(pe["open-url"]&&(pe._urls=pe._,pe._=[]),!pe.remote){const ve=this.doValidatePaths(pe._,pe.goto);pe._=ve}return pe}doValidatePaths(pe,ve){const Z=(0,o.cwd)(),de=pe.map(Le=>{let Te=String(Le),Ae;ve&&(Ae=(0,c.parseLineAndColumnAware)(Te),Te=Ae.path),Te&&(Te=this.preparePath(Z,Te));const Be=(0,c.sanitizeFilePath)(Te,Z),Ne=(0,d.basename)(Be);return Ne&&!(0,c.isValidBasename)(Ne)?null:ve&&Ae?(Ae.path=Be,this.toPath(Ae)):Be}),fe=y.isWindows||y.isMacintosh,Ie=(0,_.distinct)(de,Le=>Le&&fe?Le.toLowerCase():Le||"");return(0,_.coalesce)(Ie)}preparePath(pe,ve){return y.isWindows&&(ve=(0,g.rtrim)(ve,'"')),ve=(0,g.trim)((0,g.trim)(ve," "),"	"),y.isWindows&&(ve=(0,d.resolve)(pe,ve),ve=(0,g.rtrim)(ve,".")),ve}toPath(pe){const ve=[pe.path];return typeof pe.line=="number"&&ve.push(String(pe.line)),typeof pe.column=="number"&&ve.push(String(pe.column)),ve.join(":")}}new Re().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/aef377c42cea6e9aea642829953104f07097abfa/core/vs/code/electron-main/main.js.map
