/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/strings","vs/base/common/uuid","vs/base/common/objects","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/id","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],se=function(q){for(var e=[],x=0,T=q.length;x<T;x++)e[x]=ne[q[x]];return e};define(ne[70],se([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class x{static get(){const L=new Map,N=new Map,A=new Map,E=new Map;function u(f,R){f.has(R.detail)||f.set(R.detail,-R.timestamp)}function l(f,R){const y=f.get(R.detail);y&&(y>=0||f.set(R.detail,y+R.timestamp))}let S=[];typeof q=="function"&&typeof q.getStats=="function"&&(S=q.getStats().slice(0).sort((f,R)=>f.timestamp-R.timestamp));for(const f of S)switch(f.type){case 10:u(L,f);break;case 11:case 12:l(L,f);break;case 21:u(N,f);break;case 22:l(N,f);break;case 33:u(A,f);break;case 34:l(A,f);break;case 31:u(E,f);break;case 32:l(E,f);break}let k=0;A.forEach(f=>k+=f);function g(f){const R=[];return f.forEach((y,m)=>R.push([m,y])),R}return{amdLoad:g(L),amdInvoke:g(N),nodeRequire:g(A),nodeEval:g(E),nodeRequireTotal:k}}static toMarkdownTable(L,N){let A="";const E=[];return L.forEach((u,l)=>{E[l]=u.length}),N.forEach(u=>{u.forEach((l,S)=>{typeof l>"u"&&(l=u[S]="-");const k=l.toString().length;E[S]=Math.max(k,E[S])})}),L.forEach((u,l)=>{A+=`| ${u+" ".repeat(E[l]-u.toString().length)} `}),A+=`|
`,L.forEach((u,l)=>{A+=`| ${"-".repeat(E[l])} `}),A+=`|
`,N.forEach(u=>{u.forEach((l,S)=>{typeof l<"u"&&(A+=`| ${l+" ".repeat(E[S]-l.toString().length)} `)}),A+=`|
`}),A}}e.LoaderStats=x}),define(ne[52],se([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function x(A){return(E,u,l)=>{let S=null,k=null;if(typeof l.value=="function"?(S="value",k=l.value):typeof l.get=="function"&&(S="get",k=l.get),!k)throw new Error("not supported");l[S]=A(k,u)}}function T(A,E,u){let l=null,S=null;if(typeof u.value=="function"?(l="value",S=u.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(l="get",S=u.get),!S)throw new Error("not supported");const k=`$memoize$${E}`;u[l]=function(...g){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,g)}),this[k]}}e.memoize=T;function L(A,E,u){return x((l,S)=>{const k=`$debounce$${S}`,g=`$debounce$result$${S}`;return function(...f){this[g]||(this[g]=u?u():void 0),clearTimeout(this[k]),E&&(this[g]=E(this[g],...f),f=[this[g]]),this[k]=setTimeout(()=>{l.apply(this,f),this[g]=u?u():void 0},A)}})}e.debounce=L;function N(A,E,u){return x((l,S)=>{const k=`$throttle$timer$${S}`,g=`$throttle$result$${S}`,f=`$throttle$lastRun$${S}`,R=`$throttle$pending$${S}`;return function(...y){if(this[g]||(this[g]=u?u():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),E&&(this[g]=E(this[g],...y)),this[R])return;const m=this[f]+A;m<=Date.now()?(this[f]=Date.now(),l.apply(this,[this[g]]),this[g]=u?u():void 0):(this[R]=!0,this[k]=setTimeout(()=>{this[R]=!1,this[f]=Date.now(),l.apply(this,[this[g]]),this[g]=u?u():void 0},m-Date.now()))}})}e.throttle=N}),define(ne[71],se([0,1,9]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function T(u,l){if(!u)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=T;function L(u,l="Unreachable"){throw new Error(l)}e.assertNever=L;function N(u){if(!u)throw new x.BugIndicatingError("Assertion Failed")}e.assert=N;function A(u){if(!u()){debugger;u(),(0,x.onUnexpectedError)(new x.BugIndicatingError("Assertion Failed"))}}e.assertFn=A;function E(u,l){let S=0;for(;S<u.length-1;){const k=u[S],g=u[S+1];if(!l(k,g))return!1;S++}return!0}e.checkAdjacentItems=E}),define(ne[53],se([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var x;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(x||(e.ScanError=x={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(t,a=!1){let i=0;const r=t.length;let n="",o=0,c=16,D=0;function P(Z){let ae=0,le=0;for(;ae<Z;){const te=t.charCodeAt(i);if(te>=48&&te<=57)le=le*16+te-48;else if(te>=65&&te<=70)le=le*16+te-65+10;else if(te>=97&&te<=102)le=le*16+te-97+10;else break;i++,ae++}return ae<Z&&(le=-1),le}function b(Z){i=Z,n="",o=0,c=16,D=0}function O(){const Z=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&l(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&l(t.charCodeAt(i)))for(i++;i<t.length&&l(t.charCodeAt(i));)i++;else return D=3,t.substring(Z,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&l(t.charCodeAt(i))){for(i++;i<t.length&&l(t.charCodeAt(i));)i++;ae=i}else D=3;return t.substring(Z,ae)}function j(){let Z="",ae=i;for(;;){if(i>=r){Z+=t.substring(ae,i),D=2;break}const le=t.charCodeAt(i);if(le===34){Z+=t.substring(ae,i),i++;break}if(le===92){if(Z+=t.substring(ae,i),i++,i>=r){D=2;break}switch(t.charCodeAt(i++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:{const V=P(4);V>=0?Z+=String.fromCharCode(V):D=4;break}default:D=5}ae=i;continue}if(le>=0&&le<=31)if(u(le)){Z+=t.substring(ae,i),D=2;break}else D=6;i++}return Z}function ee(){if(n="",D=0,o=i,i>=r)return o=r,c=17;let Z=t.charCodeAt(i);if(E(Z)){do i++,n+=String.fromCharCode(Z),Z=t.charCodeAt(i);while(E(Z));return c=15}if(u(Z))return i++,n+=String.fromCharCode(Z),Z===13&&t.charCodeAt(i)===10&&(i++,n+=`
`),c=14;switch(Z){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,n=j(),c=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!u(t.charCodeAt(i));)i++;return n=t.substring(ae,i),c=12}if(t.charCodeAt(i+1)===42){i+=2;const le=r-1;let te=!1;for(;i<le;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,te=!0;break}i++}return te||(i++,D=1),n=t.substring(ae,i),c=13}return n+=String.fromCharCode(Z),i++,c=16}case 45:if(n+=String.fromCharCode(Z),i++,i===r||!l(t.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=O(),c=11;default:for(;i<r&&Y(Z);)i++,Z=t.charCodeAt(i);if(o!==i){switch(n=t.substring(o,i),n){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return n+=String.fromCharCode(Z),i++,c=16}}function Y(Z){if(E(Z)||u(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let Z;do Z=ee();while(Z>=12&&Z<=15);return Z}return{setPosition:b,getPosition:()=>i,scan:a?ce:ee,getToken:()=>c,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>D}}e.createScanner=A;function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var S;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(S||(S={}));function k(t,a){const i=[],r=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function D(P,b,O,j){o.value=P,o.offset=b,o.length=O,o.type=j,o.colonOffset=void 0,n=o}try{C(t,{onObjectBegin:(P,b)=>{if(a<=P)throw r;n=void 0,c=a>P,i.push("")},onObjectProperty:(P,b,O)=>{if(a<b||(D(P,b,O,"property"),i[i.length-1]=P,a<=b+O))throw r},onObjectEnd:(P,b)=>{if(a<=P)throw r;n=void 0,i.pop()},onArrayBegin:(P,b)=>{if(a<=P)throw r;n=void 0,i.push(0)},onArrayEnd:(P,b)=>{if(a<=P)throw r;n=void 0,i.pop()},onLiteralValue:(P,b,O)=>{if(a<b||(D(P,b,O,w(P)),a<=b+O))throw r},onSeparator:(P,b,O)=>{if(a<=b)throw r;if(P===":"&&n&&n.type==="property")n.colonOffset=b,c=!1,n=void 0;else if(P===","){const j=i[i.length-1];typeof j=="number"?i[i.length-1]=j+1:(c=!0,i[i.length-1]=""),n=void 0}}})}catch(P){if(P!==r)throw P}return{path:i,previousNode:n,isAtPropertyKey:c,matches:P=>{let b=0;for(let O=0;b<P.length&&O<i.length;O++)if(P[b]===i[O]||P[b]==="*")b++;else if(P[b]!=="**")return!1;return b===P.length}}}e.getLocation=k;function g(t,a=[],i=N.DEFAULT){let r=null,n=[];const o=[];function c(P){Array.isArray(n)?n.push(P):r!==null&&(n[r]=P)}return C(t,{onObjectBegin:()=>{const P={};c(P),o.push(n),n=P,r=null},onObjectProperty:P=>{r=P},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const P=[];c(P),o.push(n),n=P,r=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:c,onError:(P,b,O)=>{a.push({error:P,offset:b,length:O})}},i),n[0]}e.parse=g;function f(t,a=[],i=N.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(P){r.type==="property"&&(r.length=P-r.offset,r=r.parent)}function o(P){return r.children.push(P),P}C(t,{onObjectBegin:P=>{r=o({type:"object",offset:P,length:-1,parent:r,children:[]})},onObjectProperty:(P,b,O)=>{r=o({type:"property",offset:b,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:P,offset:b,length:O,parent:r})},onObjectEnd:(P,b)=>{r.length=P+b-r.offset,r=r.parent,n(P+b)},onArrayBegin:(P,b)=>{r=o({type:"array",offset:P,length:-1,parent:r,children:[]})},onArrayEnd:(P,b)=>{r.length=P+b-r.offset,r=r.parent,n(P+b)},onLiteralValue:(P,b,O)=>{o({type:w(P),offset:b,length:O,parent:r,value:P}),n(b+O)},onSeparator:(P,b,O)=>{r.type==="property"&&(P===":"?r.colonOffset=b:P===","&&n(b))},onError:(P,b,O)=>{a.push({error:P,offset:b,length:O})}},i);const D=r.children[0];return D&&delete D.parent,D}e.parseTree=f;function R(t,a){if(!t)return;let i=t;for(const r of a)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let n=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===r){i=o.children[1],n=!0;break}if(!n)return}else{const n=r;if(i.type!=="array"||n<0||!Array.isArray(i.children)||n>=i.children.length)return;i=i.children[n]}return i}e.findNodeAtLocation=R;function y(t){if(!t.parent||!t.parent.children)return[];const a=y(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.getNodePath=y;function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const a=Object.create(null);for(const i of t.children){const r=i.children[1];r&&(a[i.children[0].value]=m(r))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=m;function d(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.contains=d;function h(t,a,i=!1){if(d(t,a,i)){const r=t.children;if(Array.isArray(r))for(let n=0;n<r.length&&r[n].offset<=a;n++){const o=h(r[n],a,i);if(o)return o}return t}}e.findNodeAtOffset=h;function C(t,a,i=N.DEFAULT){const r=A(t,!1);function n(K){return K?()=>K(r.getTokenOffset(),r.getTokenLength()):()=>!0}function o(K){return K?J=>K(J,r.getTokenOffset(),r.getTokenLength()):()=>!0}const c=n(a.onObjectBegin),D=o(a.onObjectProperty),P=n(a.onObjectEnd),b=n(a.onArrayBegin),O=n(a.onArrayEnd),j=o(a.onLiteralValue),ee=o(a.onSeparator),Y=n(a.onComment),ce=o(a.onError),Z=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function le(){for(;;){const K=r.scan();switch(r.getTokenError()){case 4:te(14);break;case 5:te(15);break;case 3:te(13);break;case 1:Z||te(11);break;case 2:te(12);break;case 6:te(16);break}switch(K){case 12:case 13:Z?te(10):Y();break;case 16:te(1);break;case 15:case 14:break;default:return K}}}function te(K,J=[],oe=[]){if(ce(K),J.length+oe.length>0){let I=r.getToken();for(;I!==17;){if(J.indexOf(I)!==-1){le();break}else if(oe.indexOf(I)!==-1)break;I=le()}}}function V(K){const J=r.getTokenValue();return K?j(J):D(J),le(),!0}function $(){switch(r.getToken()){case 11:{let K=0;try{K=JSON.parse(r.getTokenValue()),typeof K!="number"&&(te(2),K=0)}catch{te(2)}j(K);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return le(),!0}function U(){return r.getToken()!==10?(te(3,[],[2,5]),!1):(V(!1),r.getToken()===6?(ee(":"),le(),G()||te(4,[],[2,5])):te(5,[],[2,5]),!0)}function M(){c(),le();let K=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(K||te(4,[],[]),ee(","),le(),r.getToken()===2&&ae)break}else K&&te(6,[],[]);U()||te(4,[],[2,5]),K=!0}return P(),r.getToken()!==2?te(7,[2],[]):le(),!0}function z(){b(),le();let K=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(K||te(4,[],[]),ee(","),le(),r.getToken()===4&&ae)break}else K&&te(6,[],[]);G()||te(4,[],[4,5]),K=!0}return O(),r.getToken()!==4?te(8,[4],[]):le(),!0}function G(){switch(r.getToken()){case 3:return z();case 1:return M();case 10:return V(!0);default:return $()}}return le(),r.getToken()===17?i.allowEmptyContent?!0:(te(4,[],[]),!1):G()?(r.getToken()!==17&&te(9,[],[]),!0):(te(4,[],[]),!1)}e.visit=C;function p(t,a){const i=A(t),r=[];let n,o=0,c;do switch(c=i.getPosition(),n=i.scan(),n){case 12:case 13:case 17:o!==c&&r.push(t.substring(o,c)),a!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,a)),o=i.getPosition();break}while(n!==17);return r.join("")}e.stripComments=p;function w(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(ne[72],se([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function x(E,u,l){return Math.min(Math.max(E,u),l)}e.clamp=x;function T(E,u){return(u+E%u)%u}e.rot=T;class L{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=L;class N{constructor(){this._n=1,this._val=0}update(u){return this._val=this._val+(u-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=N;class A{constructor(u){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(u),this._values.fill(0,0,u)}update(u){const l=this._values[this._index];return this._values[this._index]=u,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=u,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A}),function(){function q(L){const N=[];typeof L=="number"&&N.push("code/timeOrigin",L);function A(u){N.push(u,Date.now())}function E(){const u=[];for(let l=0;l<N.length;l+=2)u.push({name:N[l],startTime:N[l+1]});return u}return{mark:A,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(L+A.startTime)});return N}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function x(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return x(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=x(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=x(T))}(),function(q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var x=e();for(var T in x)(typeof exports=="object"?exports:q)[T]=x[T]}}(typeof self<"u"?self:this,function(){return function(q){var e={};function x(T){if(e[T])return e[T].exports;var L=e[T]={i:T,l:!1,exports:{}};return q[T].call(L.exports,L,L.exports,x),L.l=!0,L.exports}return x.m=q,x.c=e,x.d=function(T,L,N){x.o(T,L)||Object.defineProperty(T,L,{enumerable:!0,get:N})},x.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},x.t=function(T,L){if(1&L&&(T=x(T)),8&L||4&L&&typeof T=="object"&&T&&T.__esModule)return T;var N=Object.create(null);if(x.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:T}),2&L&&typeof T!="string")for(var A in T)x.d(N,A,function(E){return T[E]}.bind(null,A));return N},x.n=function(T){var L=T&&T.__esModule?function(){return T.default}:function(){return T};return x.d(L,"a",L),L},x.o=function(T,L){return Object.prototype.hasOwnProperty.call(T,L)},x.p="",x(x.s=0)}([function(q,e,x){(function(T){var L;e=q.exports=oe,L=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],u=e.src=[],l=0,S=l++;u[S]="0|[1-9]\\d*";var k=l++;u[k]="[0-9]+";var g=l++;u[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=l++;u[f]="("+u[S]+")\\.("+u[S]+")\\.("+u[S]+")";var R=l++;u[R]="("+u[k]+")\\.("+u[k]+")\\.("+u[k]+")";var y=l++;u[y]="(?:"+u[S]+"|"+u[g]+")";var m=l++;u[m]="(?:"+u[k]+"|"+u[g]+")";var d=l++;u[d]="(?:-("+u[y]+"(?:\\."+u[y]+")*))";var h=l++;u[h]="(?:-?("+u[m]+"(?:\\."+u[m]+")*))";var C=l++;u[C]="[0-9A-Za-z-]+";var p=l++;u[p]="(?:\\+("+u[C]+"(?:\\."+u[C]+")*))";var w=l++,t="v?"+u[f]+u[d]+"?"+u[p]+"?";u[w]="^"+t+"$";var a="[v=\\s]*"+u[R]+u[h]+"?"+u[p]+"?",i=l++;u[i]="^"+a+"$";var r=l++;u[r]="((?:<|>)?=?)";var n=l++;u[n]=u[k]+"|x|X|\\*";var o=l++;u[o]=u[S]+"|x|X|\\*";var c=l++;u[c]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[d]+")?"+u[p]+"?)?)?";var D=l++;u[D]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[h]+")?"+u[p]+"?)?)?";var P=l++;u[P]="^"+u[r]+"\\s*"+u[c]+"$";var b=l++;u[b]="^"+u[r]+"\\s*"+u[D]+"$";var O=l++;u[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=l++;u[j]="(?:~>?)";var ee=l++;u[ee]="(\\s*)"+u[j]+"\\s+",E[ee]=new RegExp(u[ee],"g");var Y=l++;u[Y]="^"+u[j]+u[c]+"$";var ce=l++;u[ce]="^"+u[j]+u[D]+"$";var Z=l++;u[Z]="(?:\\^)";var ae=l++;u[ae]="(\\s*)"+u[Z]+"\\s+",E[ae]=new RegExp(u[ae],"g");var le=l++;u[le]="^"+u[Z]+u[c]+"$";var te=l++;u[te]="^"+u[Z]+u[D]+"$";var V=l++;u[V]="^"+u[r]+"\\s*("+a+")$|^$";var $=l++;u[$]="^"+u[r]+"\\s*("+t+")$|^$";var U=l++;u[U]="(\\s*)"+u[r]+"\\s*("+a+"|"+u[c]+")",E[U]=new RegExp(u[U],"g");var M=l++;u[M]="^\\s*("+u[c]+")\\s+-\\s+("+u[c]+")\\s*$";var z=l++;u[z]="^\\s*("+u[D]+")\\s+-\\s+("+u[D]+")\\s*$";var G=l++;u[G]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)L(K,u[K]),E[K]||(E[K]=new RegExp(u[K]));function J(W,X){if(W instanceof oe)return W;if(typeof W!="string"||W.length>N||!(X?E[i]:E[w]).test(W))return null;try{return new oe(W,X)}catch{return null}}function oe(W,X){if(W instanceof oe){if(W.loose===X)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof oe))return new oe(W,X);L("SemVer",W,X),this.loose=X;var Q=W.trim().match(X?E[i]:E[w]);if(!Q)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var Se=+pe;if(Se>=0&&Se<A)return Se}return pe}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=J,e.valid=function(W,X){var Q=J(W,X);return Q?Q.version:null},e.clean=function(W,X){var Q=J(W.trim().replace(/^[=v]+/,""),X);return Q?Q.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(W){return L("SemVer.compare",this.version,this.loose,W),W instanceof oe||(W=new oe(W,this.loose)),this.compareMain(W)||this.comparePre(W)},oe.prototype.compareMain=function(W){return W instanceof oe||(W=new oe(W,this.loose)),s(this.major,W.major)||s(this.minor,W.minor)||s(this.patch,W.patch)},oe.prototype.comparePre=function(W){if(W instanceof oe||(W=new oe(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var X=0;do{var Q=this.prerelease[X],pe=W.prerelease[X];if(L("prerelease compare",X,Q,pe),Q===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(Q===void 0)return-1;if(Q!==pe)return s(Q,pe)}while(++X)},oe.prototype.inc=function(W,X){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,X,Q,pe){typeof Q=="string"&&(pe=Q,Q=void 0);try{return new oe(W,Q).inc(X,pe).version}catch{return null}},e.diff=function(W,X){if(B(W,X))return null;var Q=J(W),pe=J(X);if(Q.prerelease.length||pe.prerelease.length){for(var Se in Q)if((Se==="major"||Se==="minor"||Se==="patch")&&Q[Se]!==pe[Se])return"pre"+Se;return"prerelease"}for(var Se in Q)if((Se==="major"||Se==="minor"||Se==="patch")&&Q[Se]!==pe[Se])return Se},e.compareIdentifiers=s;var I=/^[0-9]+$/;function s(W,X){var Q=I.test(W),pe=I.test(X);return Q&&pe&&(W=+W,X=+X),Q&&!pe?-1:pe&&!Q?1:W<X?-1:W>X?1:0}function v(W,X,Q){return new oe(W,Q).compare(new oe(X,Q))}function F(W,X,Q){return v(W,X,Q)>0}function _(W,X,Q){return v(W,X,Q)<0}function B(W,X,Q){return v(W,X,Q)===0}function H(W,X,Q){return v(W,X,Q)!==0}function ie(W,X,Q){return v(W,X,Q)>=0}function de(W,X,Q){return v(W,X,Q)<=0}function he(W,X,Q,pe){var Se;switch(X){case"===":typeof W=="object"&&(W=W.version),typeof Q=="object"&&(Q=Q.version),Se=W===Q;break;case"!==":typeof W=="object"&&(W=W.version),typeof Q=="object"&&(Q=Q.version),Se=W!==Q;break;case"":case"=":case"==":Se=B(W,Q,pe);break;case"!=":Se=H(W,Q,pe);break;case">":Se=F(W,Q,pe);break;case">=":Se=ie(W,Q,pe);break;case"<":Se=_(W,Q,pe);break;case"<=":Se=de(W,Q,pe);break;default:throw new TypeError("Invalid operator: "+X)}return Se}function ue(W,X){if(W instanceof ue){if(W.loose===X)return W;W=W.value}if(!(this instanceof ue))return new ue(W,X);L("comparator",W,X),this.loose=X,this.parse(W),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(W,X){return s(X,W)},e.major=function(W,X){return new oe(W,X).major},e.minor=function(W,X){return new oe(W,X).minor},e.patch=function(W,X){return new oe(W,X).patch},e.compare=v,e.compareLoose=function(W,X){return v(W,X,!0)},e.rcompare=function(W,X,Q){return v(X,W,Q)},e.sort=function(W,X){return W.sort(function(Q,pe){return e.compare(Q,pe,X)})},e.rsort=function(W,X){return W.sort(function(Q,pe){return e.rcompare(Q,pe,X)})},e.gt=F,e.lt=_,e.eq=B,e.neq=H,e.gte=ie,e.lte=de,e.cmp=he,e.Comparator=ue;var ge={};function me(W,X){if(W instanceof me)return W.loose===X?W:new me(W.raw,X);if(W instanceof ue)return new me(W.value,X);if(!(this instanceof me))return new me(W,X);if(this.loose=X,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function fe(W){return!W||W.toLowerCase()==="x"||W==="*"}function ye(W,X,Q,pe,Se,ke,Ie,Ne,De,Ae,Fe,Ce,Te){return((X=fe(Q)?"":fe(pe)?">="+Q+".0.0":fe(Se)?">="+Q+"."+pe+".0":">="+X)+" "+(Ne=fe(De)?"":fe(Ae)?"<"+(+De+1)+".0.0":fe(Fe)?"<"+De+"."+(+Ae+1)+".0":Ce?"<="+De+"."+Ae+"."+Fe+"-"+Ce:"<="+Ne)).trim()}function Pe(W,X){for(var Q=0;Q<W.length;Q++)if(!W[Q].test(X))return!1;if(X.prerelease.length){for(Q=0;Q<W.length;Q++)if(L(W[Q].semver),W[Q].semver!==ge&&W[Q].semver.prerelease.length>0){var pe=W[Q].semver;if(pe.major===X.major&&pe.minor===X.minor&&pe.patch===X.patch)return!0}return!1}return!0}function Oe(W,X,Q){try{X=new me(X,Q)}catch{return!1}return X.test(W)}function Me(W,X,Q,pe){var Se,ke,Ie,Ne,De;switch(W=new oe(W,pe),X=new me(X,pe),Q){case">":Se=F,ke=de,Ie=_,Ne=">",De=">=";break;case"<":Se=_,ke=ie,Ie=F,Ne="<",De="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(W,X,pe))return!1;for(var Ae=0;Ae<X.set.length;++Ae){var Fe=X.set[Ae],Ce=null,Te=null;if(Fe.forEach(function(Le){Le.semver===ge&&(Le=new ue(">=0.0.0")),Ce=Ce||Le,Te=Te||Le,Se(Le.semver,Ce.semver,pe)?Ce=Le:Ie(Le.semver,Te.semver,pe)&&(Te=Le)}),Ce.operator===Ne||Ce.operator===De||(!Te.operator||Te.operator===Ne)&&ke(W,Te.semver)||Te.operator===De&&Ie(W,Te.semver))return!1}return!0}ue.prototype.parse=function(W){var X=this.loose?E[V]:E[$],Q=W.match(X);if(!Q)throw new TypeError("Invalid comparator: "+W);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new oe(Q[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(W){return L("Comparator.test",W,this.loose),this.semver===ge||(typeof W=="string"&&(W=new oe(W,this.loose)),he(W,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(W,X){if(!(W instanceof ue))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new me(W.value,X),Oe(this.value,Q,X);if(W.operator==="")return Q=new me(this.value,X),Oe(W.semver,Q,X);var pe=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),ke=this.semver.version===W.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Ne=he(this.semver,"<",W.semver,X)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),De=he(this.semver,">",W.semver,X)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return pe||Se||ke&&Ie||Ne||De},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(W){var X=this.loose;W=W.trim(),L("range",W,X);var Q=X?E[z]:E[M];W=W.replace(Q,ye),L("hyphen replace",W),W=W.replace(E[U],"$1$2$3"),L("comparator trim",W,E[U]),W=(W=(W=W.replace(E[ee],"$1~")).replace(E[ae],"$1^")).split(/\s+/).join(" ");var pe=X?E[V]:E[$],Se=W.split(" ").map(function(ke){return function(Ie,Ne){return L("comp",Ie),Ie=function(De,Ae){return De.trim().split(/\s+/).map(function(Fe){return function(Ce,Te){L("caret",Ce,Te);var Le=Te?E[te]:E[le];return Ce.replace(Le,function(_e,Ee,we,be,Re){var xe;return L("caret",Ce,_e,Ee,we,be,Re),fe(Ee)?xe="":fe(we)?xe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":fe(be)?xe=Ee==="0"?">="+Ee+"."+we+".0 <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+".0 <"+(+Ee+1)+".0.0":Re?(L("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),xe=Ee==="0"?we==="0"?">="+Ee+"."+we+"."+be+Re+" <"+Ee+"."+we+"."+(+be+1):">="+Ee+"."+we+"."+be+Re+" <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+"."+be+Re+" <"+(+Ee+1)+".0.0"):(L("no pr"),xe=Ee==="0"?we==="0"?">="+Ee+"."+we+"."+be+" <"+Ee+"."+we+"."+(+be+1):">="+Ee+"."+we+"."+be+" <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+"."+be+" <"+(+Ee+1)+".0.0"),L("caret return",xe),xe})}(Fe,Ae)}).join(" ")}(Ie,Ne),L("caret",Ie),Ie=function(De,Ae){return De.trim().split(/\s+/).map(function(Fe){return function(Ce,Te){var Le=Te?E[ce]:E[Y];return Ce.replace(Le,function(_e,Ee,we,be,Re){var xe;return L("tilde",Ce,_e,Ee,we,be,Re),fe(Ee)?xe="":fe(we)?xe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":fe(be)?xe=">="+Ee+"."+we+".0 <"+Ee+"."+(+we+1)+".0":Re?(L("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),xe=">="+Ee+"."+we+"."+be+Re+" <"+Ee+"."+(+we+1)+".0"):xe=">="+Ee+"."+we+"."+be+" <"+Ee+"."+(+we+1)+".0",L("tilde return",xe),xe})}(Fe,Ae)}).join(" ")}(Ie,Ne),L("tildes",Ie),Ie=function(De,Ae){return L("replaceXRanges",De,Ae),De.split(/\s+/).map(function(Fe){return function(Ce,Te){Ce=Ce.trim();var Le=Te?E[b]:E[P];return Ce.replace(Le,function(_e,Ee,we,be,Re,xe){L("xRange",Ce,_e,Ee,we,be,Re,xe);var $e=fe(we),Ve=$e||fe(be),We=Ve||fe(Re);return Ee==="="&&We&&(Ee=""),$e?_e=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&We?(Ve&&(be=0),We&&(Re=0),Ee===">"?(Ee=">=",Ve?(we=+we+1,be=0,Re=0):We&&(be=+be+1,Re=0)):Ee==="<="&&(Ee="<",Ve?we=+we+1:be=+be+1),_e=Ee+we+"."+be+"."+Re):Ve?_e=">="+we+".0.0 <"+(+we+1)+".0.0":We&&(_e=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0"),L("xRange return",_e),_e})}(Fe,Ae)}).join(" ")}(Ie,Ne),L("xrange",Ie),Ie=function(De,Ae){return L("replaceStars",De,Ae),De.trim().replace(E[G],"")}(Ie,Ne),L("stars",Ie),Ie}(ke,X)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(ke){return!!ke.match(pe)})),Se=Se.map(function(ke){return new ue(ke,X)})},me.prototype.intersects=function(W,X){if(!(W instanceof me))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(pe){return W.set.some(function(Se){return Se.every(function(ke){return pe.intersects(ke,X)})})})})},e.toComparators=function(W,X){return new me(W,X).set.map(function(Q){return Q.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},me.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new oe(W,this.loose));for(var X=0;X<this.set.length;X++)if(Pe(this.set[X],W))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(W,X,Q){var pe=null,Se=null;try{var ke=new me(X,Q)}catch{return null}return W.forEach(function(Ie){ke.test(Ie)&&(pe&&Se.compare(Ie)!==-1||(Se=new oe(pe=Ie,Q)))}),pe},e.minSatisfying=function(W,X,Q){var pe=null,Se=null;try{var ke=new me(X,Q)}catch{return null}return W.forEach(function(Ie){ke.test(Ie)&&(pe&&Se.compare(Ie)!==1||(Se=new oe(pe=Ie,Q)))}),pe},e.validRange=function(W,X){try{return new me(W,X).range||"*"}catch{return null}},e.ltr=function(W,X,Q){return Me(W,X,"<",Q)},e.gtr=function(W,X,Q){return Me(W,X,">",Q)},e.outside=Me,e.prerelease=function(W,X){var Q=J(W,X);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(W,X,Q){return W=new me(W,Q),X=new me(X,Q),W.intersects(X)},e.coerce=function(W){if(W instanceof oe)return W;if(typeof W!="string")return null;var X=W.match(E[O]);return X==null?null:J((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,x(1))},function(q,e){var x,T,L=q.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function E(m){if(x===setTimeout)return setTimeout(m,0);if((x===N||!x)&&setTimeout)return x=setTimeout,setTimeout(m,0);try{return x(m,0)}catch{try{return x.call(null,m,0)}catch{return x.call(this,m,0)}}}(function(){try{x=typeof setTimeout=="function"?setTimeout:N}catch{x=N}try{T=typeof clearTimeout=="function"?clearTimeout:A}catch{T=A}})();var u,l=[],S=!1,k=-1;function g(){S&&u&&(S=!1,u.length?l=u.concat(l):k=-1,l.length&&f())}function f(){if(!S){var m=E(g);S=!0;for(var d=l.length;d;){for(u=l,l=[];++k<d;)u&&u[k].run();k=-1,d=l.length}u=null,S=!1,function(h){if(T===clearTimeout)return clearTimeout(h);if((T===A||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(h);try{T(h)}catch{try{return T.call(null,h)}catch{return T.call(this,h)}}}(m)}}function R(m,d){this.fun=m,this.array=d}function y(){}L.nextTick=function(m){var d=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)d[h-1]=arguments[h];l.push(new R(m,d)),l.length!==1||S||E(f)},R.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=y,L.addListener=y,L.once=y,L.off=y,L.removeListener=y,L.removeAllListeners=y,L.emit=y,L.prependListener=y,L.prependOnceListener=y,L.listeners=function(m){return[]},L.binding=function(m){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(m){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ne[73],se([0,1]),function(q,e){"use strict";var x;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class T{constructor(E,u,l){this.level=E,this.key=u,this.value=l,this.forward=[]}}const L=void 0;class N{constructor(E,u=2**16){this.comparator=E,this[x]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(u)|0),this._header=new T(this._maxLevel,L,L)}get size(){return this._size}clear(){this._header=new T(this._maxLevel,L,L)}has(E){return!!N._search(this,E,this.comparator)}get(E){return N._search(this,E,this.comparator)?.value}set(E,u){return N._insert(this,E,u,this.comparator)&&(this._size+=1),this}delete(E){const u=N._delete(this,E,this.comparator);return u&&(this._size-=1),u}forEach(E,u){let l=this._header.forward[0];for(;l;)E.call(u,l.value,l.key,this),l=l.forward[0]}[(x=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this._header.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this._header.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this._header.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",u=this._header.forward[0];for(;u;)E+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return E}static _search(E,u,l){let S=E._header;for(let k=E._level-1;k>=0;k--)for(;S.forward[k]&&l(S.forward[k].key,u)<0;)S=S.forward[k];if(S=S.forward[0],S&&l(S.key,u)===0)return S}static _insert(E,u,l,S){const k=[];let g=E._header;for(let f=E._level-1;f>=0;f--){for(;g.forward[f]&&S(g.forward[f].key,u)<0;)g=g.forward[f];k[f]=g}if(g=g.forward[0],g&&S(g.key,u)===0)return g.value=l,!1;{const f=N._randomLevel(E);if(f>E._level){for(let R=E._level;R<f;R++)k[R]=E._header;E._level=f}g=new T(f,u,l);for(let R=0;R<f;R++)g.forward[R]=k[R].forward[R],k[R].forward[R]=g;return!0}}static _randomLevel(E,u=.5){let l=1;for(;Math.random()<u&&l<E._maxLevel;)l+=1;return l}static _delete(E,u,l){const S=[];let k=E._header;for(let g=E._level-1;g>=0;g--){for(;k.forward[g]&&l(k.forward[g].key,u)<0;)k=k.forward[g];S[g]=k}if(k=k.forward[0],!k||l(k.key,u)!==0)return!1;for(let g=0;g<E._level&&S[g].forward[g]===k;g++)S[g].forward[g]=k.forward[g];for(;E._level>0&&E._header.forward[E._level-1]===L;)E._level-=1;return!0}}e.SkipList=N}),define(ne[41],se([0,1,9,2]),function(q,e,x,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function L(p){const w=p;return w?typeof w.read=="function":!1}e.isReadable=L;function N(p){const w=p;return w?[w.on,w.pause,w.resume,w.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=N;function A(p){const w=p;return w?N(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=A;function E(p,w){return new u(p,w)}e.newWriteableStream=E;class u{constructor(w,t){this.reducer=w,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w<"u"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(t=>t(w))}emitError(w){this.listeners.error.length===0?(0,x.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(t=>t(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,t){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(w,t){if(this.state.destroyed)return;let a;switch(w){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(p,w){const t=[];let a;for(;(a=p.read())!==null;)t.push(a);return w(t)}e.consumeReadable=l;function S(p,w,t){const a=[];let i;for(;(i=p.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?w(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const r=i;return i=void 0,r}return p.read()}}}e.peekReadable=S;function k(p,w){return new Promise((t,a)=>{const i=[];g(p,{onData:r=>{w&&i.push(r)},onError:r=>{w?a(r):t(void 0)},onEnd:()=>{t(w?w(i):void 0)}})})}e.consumeStream=k;function g(p,w){let t=!1;return p.on("error",a=>{t||w.onError(a)}),p.on("end",()=>{t||w.onEnd()}),p.on("data",a=>{t||w.onData(a)}),(0,T.toDisposable)(()=>t=!0)}e.listenStream=g;function f(p,w){return new Promise((t,a)=>{const i=new T.DisposableStore,r=[],n=D=>{if(r.push(D),r.length>w)return i.dispose(),p.pause(),t({stream:p,buffer:r,ended:!1})},o=D=>a(D),c=()=>t({stream:p,buffer:r,ended:!0});i.add((0,T.toDisposable)(()=>p.removeListener("error",o))),p.on("error",o),i.add((0,T.toDisposable)(()=>p.removeListener("end",c))),p.on("end",c),i.add((0,T.toDisposable)(()=>p.removeListener("data",n))),p.on("data",n)})}e.peekStream=f;function R(p,w){const t=E(w);return t.end(p),t}e.toStream=R;function y(){const p=E(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=y;function m(p){let w=!1;return{read:()=>w?null:(w=!0,p)}}e.toReadable=m;function d(p,w,t){const a=E(t);return g(p,{onData:i=>a.write(w.data(i)),onError:i=>a.error(w.error?w.error(i):i),onEnd:()=>a.end()}),a}e.transform=d;function h(p,w,t){let a=!1;return{read:()=>{const i=w.read();return a?i:(a=!0,i!==null?t([p,i]):p)}}}e.prefixedReadable=h;function C(p,w,t){let a=!1;const i=E(t);return g(w,{onData:r=>a?i.write(r):(a=!0,i.write(t([p,r]))),onError:r=>i.error(r),onEnd:()=>{a||(a=!0,i.write(p)),i.end()}}),i}e.prefixedStream=C}),define(ne[14],se([0,1,164,41]),function(q,e,x,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const L=typeof Buffer<"u",N=new x.Lazy(()=>new Uint8Array(256));let A,E;class u{static alloc(O){return L?new u(Buffer.allocUnsafe(O)):new u(new Uint8Array(O))}static wrap(O){return L&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new u(O)}static fromString(O,j){return!(j?.dontUseNodeBuffer||!1)&&L?new u(Buffer.from(O)):(A||(A=new TextEncoder),new u(A.encode(O)))}static fromByteArray(O){const j=u.alloc(O.length);for(let ee=0,Y=O.length;ee<Y;ee++)j.buffer[ee]=O[ee];return j}static concat(O,j){if(typeof j>"u"){j=0;for(let ce=0,Z=O.length;ce<Z;ce++)j+=O[ce].byteLength}const ee=u.alloc(j);let Y=0;for(let ce=0,Z=O.length;ce<Z;ce++){const ae=O[ce];ee.set(ae,Y),Y+=ae.byteLength}return ee}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=u.alloc(this.byteLength);return O.set(this),O}toString(){return L?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(O,j){return new u(this.buffer.subarray(O,j))}set(O,j){if(O instanceof u)this.buffer.set(O.buffer,j);else if(O instanceof Uint8Array)this.buffer.set(O,j);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),j);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return g(this.buffer,O)}writeUInt32BE(O,j){f(this.buffer,O,j)}readUInt32LE(O){return R(this.buffer,O)}writeUInt32LE(O,j){y(this.buffer,O,j)}readUInt8(O){return m(this.buffer,O)}writeUInt8(O,j){d(this.buffer,O,j)}indexOf(O,j=0){return l(this.buffer,O instanceof u?O.buffer:O,j)}}e.VSBuffer=u;function l(b,O,j=0){const ee=O.byteLength,Y=b.byteLength;if(ee===0)return 0;if(ee===1)return b.indexOf(O[0]);if(ee>Y-j)return-1;const ce=N.value;ce.fill(O.length);for(let te=0;te<O.length;te++)ce[O[te]]=O.length-te-1;let Z=j+O.length-1,ae=Z,le=-1;for(;Z<Y;)if(b[Z]===O[ae]){if(ae===0){le=Z;break}Z--,ae--}else Z+=Math.max(O.length-ae,ce[b[Z]]),ae=O.length-1;return le}e.binaryIndexOf=l;function S(b,O){return b[O+0]<<0>>>0|b[O+1]<<8>>>0}e.readUInt16LE=S;function k(b,O,j){b[j+0]=O&255,O=O>>>8,b[j+1]=O&255}e.writeUInt16LE=k;function g(b,O){return b[O]*2**24+b[O+1]*2**16+b[O+2]*2**8+b[O+3]}e.readUInt32BE=g;function f(b,O,j){b[j+3]=O,O=O>>>8,b[j+2]=O,O=O>>>8,b[j+1]=O,O=O>>>8,b[j]=O}e.writeUInt32BE=f;function R(b,O){return b[O+0]<<0>>>0|b[O+1]<<8>>>0|b[O+2]<<16>>>0|b[O+3]<<24>>>0}e.readUInt32LE=R;function y(b,O,j){b[j+0]=O&255,O=O>>>8,b[j+1]=O&255,O=O>>>8,b[j+2]=O&255,O=O>>>8,b[j+3]=O&255}e.writeUInt32LE=y;function m(b,O){return b[O]}e.readUInt8=m;function d(b,O,j){b[j]=O}e.writeUInt8=d;function h(b){return T.consumeReadable(b,O=>u.concat(O))}e.readableToBuffer=h;function C(b){return T.toReadable(b)}e.bufferToReadable=C;function p(b){return T.consumeStream(b,O=>u.concat(O))}e.streamToBuffer=p;async function w(b){return b.ended?u.concat(b.buffer):u.concat([...b.buffer,await p(b.stream)])}e.bufferedStreamToBuffer=w;function t(b){return T.toStream(b,O=>u.concat(O))}e.bufferToStream=t;function a(b){return T.transform(b,{data:O=>typeof O=="string"?u.fromString(O):u.wrap(O)},O=>u.concat(O))}e.streamToBufferReadableStream=a;function i(b){return T.newWriteableStream(O=>u.concat(O),b)}e.newWriteableBufferStream=i;function r(b,O){return T.prefixedReadable(b,O,j=>u.concat(j))}e.prefixedBufferReadable=r;function n(b,O){return T.prefixedStream(b,O,j=>u.concat(j))}e.prefixedBufferStream=n;function o(b){let O=0,j=0,ee=0;const Y=new Uint8Array(Math.floor(b.length/4*3)),ce=ae=>{switch(j){case 3:Y[ee++]=O|ae,j=0;break;case 2:Y[ee++]=O|ae>>>2,O=ae<<6,j=3;break;case 1:Y[ee++]=O|ae>>>4,O=ae<<4,j=2;break;default:O=ae<<2,j=1}};for(let ae=0;ae<b.length;ae++){const le=b.charCodeAt(ae);if(le>=65&&le<=90)ce(le-65);else if(le>=97&&le<=122)ce(le-97+26);else if(le>=48&&le<=57)ce(le-48+52);else if(le===43||le===45)ce(62);else if(le===47||le===95)ce(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${b[ae]}`)}}const Z=ee;for(;j>0;)ce(0);return u.wrap(Y).slice(0,Z)}e.decodeBase64=o;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function P({buffer:b},O=!0,j=!1){const ee=j?D:c;let Y="";const ce=b.byteLength%3;let Z=0;for(;Z<b.byteLength-ce;Z+=3){const ae=b[Z+0],le=b[Z+1],te=b[Z+2];Y+=ee[ae>>>2],Y+=ee[(ae<<4|le>>>4)&63],Y+=ee[(le<<2|te>>>6)&63],Y+=ee[te&63]}if(ce===1){const ae=b[Z+0];Y+=ee[ae>>>2],Y+=ee[ae<<4&63],O&&(Y+="==")}else if(ce===2){const ae=b[Z+0],le=b[Z+1];Y+=ee[ae>>>2],Y+=ee[(ae<<4|le>>>4)&63],Y+=ee[le<<2&63],O&&(Y+="=")}return Y}e.encodeBase64=P}),define(ne[42],se([0,1,28]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function T(d){return L(d,0)}e.hash=T;function L(d,h){switch(typeof d){case"object":return d===null?N(349,h):Array.isArray(d)?u(d,h):l(d,h);case"string":return E(d,h);case"boolean":return A(d,h);case"number":return N(d,h);case"undefined":return N(937,h);default:return N(617,h)}}e.doHash=L;function N(d,h){return(h<<5)-h+d|0}e.numberHash=N;function A(d,h){return N(d?433:863,h)}function E(d,h){h=N(149417,h);for(let C=0,p=d.length;C<p;C++)h=N(d.charCodeAt(C),h);return h}e.stringHash=E;function u(d,h){return h=N(104579,h),d.reduce((C,p)=>L(p,C),h)}function l(d,h){return h=N(181387,h),Object.keys(d).sort().reduce((C,p)=>(C=E(p,C),L(d[p],C)),h)}class S{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=L(h,this._value),this._value}}e.Hasher=S;var k;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function g(d,h,C=32){const p=C-h,w=~((1<<p)-1);return(d<<h|(w&d)>>>p)>>>0}function f(d,h=0,C=d.byteLength,p=0){for(let w=0;w<C;w++)d[h+w]=p}function R(d,h,C="0"){for(;d.length<h;)d=C+d;return d}function y(d,h=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(C=>C.toString(16).padStart(2,"0")).join(""):R((d>>>0).toString(16),h/4)}e.toHexString=y;class m{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const C=h.length;if(C===0)return;const p=this._buff;let w=this._buffLen,t=this._leftoverHighSurrogate,a,i;for(t!==0?(a=t,i=-1,t=0):(a=h.charCodeAt(0),i=0);;){let r=a;if(x.isHighSurrogate(a))if(i+1<C){const n=h.charCodeAt(i+1);x.isLowSurrogate(n)?(i++,r=x.computeCodePoint(a,n)):r=65533}else{t=a;break}else x.isLowSurrogate(a)&&(r=65533);if(w=this._push(p,w,r),i++,i<C)a=h.charCodeAt(i);else break}this._buffLen=w,this._leftoverHighSurrogate=t}_push(h,C,p){return p<128?h[C++]=p:p<2048?(h[C++]=192|(p&1984)>>>6,h[C++]=128|(p&63)>>>0):p<65536?(h[C++]=224|(p&61440)>>>12,h[C++]=128|(p&4032)>>>6,h[C++]=128|(p&63)>>>0):(h[C++]=240|(p&1835008)>>>18,h[C++]=128|(p&258048)>>>12,h[C++]=128|(p&4032)>>>6,h[C++]=128|(p&63)>>>0),C>=64&&(this._step(),C-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),C}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=m._bigBlock32,C=this._buffDV;for(let c=0;c<64;c+=4)h.setUint32(c,C.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)h.setUint32(c,g(h.getUint32(c-12,!1)^h.getUint32(c-32,!1)^h.getUint32(c-56,!1)^h.getUint32(c-64,!1),1),!1);let p=this._h0,w=this._h1,t=this._h2,a=this._h3,i=this._h4,r,n,o;for(let c=0;c<80;c++)c<20?(r=w&t|~w&a,n=1518500249):c<40?(r=w^t^a,n=1859775393):c<60?(r=w&t|w&a|t&a,n=2400959708):(r=w^t^a,n=3395469782),o=g(p,5)+r+i+n+h.getUint32(c*4,!1)&4294967295,i=a,a=t,t=g(w,30),w=p,p=o;this._h0=this._h0+p&4294967295,this._h1=this._h1+w&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=m}),define(ne[54],se([0,1,28]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(T||(T={})),function(L){const N="error",A="warning",E="warn",u="info",l="ignore";function S(g){return g?x.equalsIgnoreCase(N,g)?L.Error:x.equalsIgnoreCase(A,g)||x.equalsIgnoreCase(E,g)?L.Warning:x.equalsIgnoreCase(u,g)?L.Info:L.Ignore:L.Ignore}L.fromValue=S;function k(g){switch(g){case L.Error:return N;case L.Warning:return A;case L.Info:return u;default:return l}}L.toString=k}(T||(T={})),e.default=T}),define(ne[30],se([0,1,3]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const h=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([C,p])=>{h[C]=p&&typeof p=="object"?T(p):p}),h}e.deepClone=T;function L(d){if(!d||typeof d!="object")return d;const h=[d];for(;h.length>0;){const C=h.shift();Object.freeze(C);for(const p in C)if(N.call(C,p)){const w=C[p];typeof w=="object"&&!Object.isFrozen(w)&&!(0,x.isTypedArray)(w)&&h.push(w)}}return d}e.deepFreeze=L;const N=Object.prototype.hasOwnProperty;function A(d,h){return E(d,h,new Set)}e.cloneAndChange=A;function E(d,h,C){if((0,x.isUndefinedOrNull)(d))return d;const p=h(d);if(typeof p<"u")return p;if(Array.isArray(d)){const w=[];for(const t of d)w.push(E(t,h,C));return w}if((0,x.isObject)(d)){if(C.has(d))throw new Error("Cannot clone recursive data-structure");C.add(d);const w={};for(const t in d)N.call(d,t)&&(w[t]=E(d[t],h,C));return C.delete(d),w}return d}function u(d,h,C=!0){return(0,x.isObject)(d)?((0,x.isObject)(h)&&Object.keys(h).forEach(p=>{p in d?C&&((0,x.isObject)(d[p])&&(0,x.isObject)(h[p])?u(d[p],h[p],C):d[p]=h[p]):d[p]=h[p]}),d):h}e.mixin=u;function l(d,h){if(d===h)return!0;if(d==null||h===null||h===void 0||typeof d!=typeof h||typeof d!="object"||Array.isArray(d)!==Array.isArray(h))return!1;let C,p;if(Array.isArray(d)){if(d.length!==h.length)return!1;for(C=0;C<d.length;C++)if(!l(d[C],h[C]))return!1}else{const w=[];for(p in d)w.push(p);w.sort();const t=[];for(p in h)t.push(p);if(t.sort(),!l(w,t))return!1;for(C=0;C<w.length;C++)if(!l(d[w[C]],h[w[C]]))return!1}return!0}e.equals=l;function S(d){const h=new Set;return JSON.stringify(d,(C,p)=>{if((0,x.isObject)(p)||Array.isArray(p)){if(h.has(p))return"[Circular]";h.add(p)}return p})}e.safeStringify=S;function k(d,h){const C=Object.create(null);return!d||!h||Object.keys(h).forEach(w=>{const t=d[w],a=h[w];l(t,a)||(C[w]=a)}),C}e.distinct=k;function g(d,h){const C=h.toLowerCase(),p=Object.keys(d).find(w=>w.toLowerCase()===C);return p?d[p]:d[h]}e.getCaseInsensitive=g;function f(d,h){const C=Object.create(null);for(const[p,w]of Object.entries(d))h(p,w)&&(C[p]=w);return C}e.filter=f;function R(d){let h=[];for(;Object.prototype!==d;)h=h.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return h}e.getAllPropertyNames=R;function y(d){const h=[];for(const C of R(d))typeof d[C]=="function"&&h.push(C);return h}e.getAllMethodNames=y;function m(d,h){const C=w=>function(){const t=Array.prototype.slice.call(arguments,0);return h(w,t)},p={};for(const w of d)p[w]=C(w);return p}e.createProxyObject=m}),define(ne[29],se([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const x=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(L){return x.test(L)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(E){for(let u=0;u<E.length;u++)E[u]=Math.floor(Math.random()*256);return E};const N=new Uint8Array(16),A=[];for(let E=0;E<256;E++)A.push(E.toString(16).padStart(2,"0"));return function(){L(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let u=0,l="";return l+=A[N[u++]],l+=A[N[u++]],l+=A[N[u++]],l+=A[N[u++]],l+="-",l+=A[N[u++]],l+=A[N[u++]],l+="-",l+=A[N[u++]],l+=A[N[u++]],l+="-",l+=A[N[u++]],l+=A[N[u++]],l+="-",l+=A[N[u++]],l+=A[N[u++]],l+=A[N[u++]],l+=A[N[u++]],l+=A[N[u++]],l+=A[N[u++]],l}}()}),define(ne[74],se([0,1,32]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const T=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(A){const E=A.replace(/\-/g,":").toLowerCase();return!T.has(E)}function N(){const A=(0,x.networkInterfaces)();for(const E in A){const u=A[E];if(u){for(const{mac:l}of u)if(L(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=N}),define(ne[75],se([0,1,32,46,29,74]),function(q,e,x,T,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(l){return this._virtualMachineOUIs||(this._virtualMachineOUIs=T.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(l)}value(){if(this._value===void 0){let l=0,S=0;const k=(0,x.networkInterfaces)();for(const g in k){const f=k[g];if(f)for(const{mac:R,internal:y}of f)y||(S+=1,this._isVirtualMachineMacAddress(R.toUpperCase())&&(l+=1))}this._value=S>0?l/S:0}return this._value}};let A;async function E(l){return A||(A=(async()=>await u(l)||L.generateUuid())()),A}e.getMachineId=E;async function u(l){try{const S=await new Promise((g,f)=>{q(["crypto"],g,f)}),k=(0,N.getMac)();return S.createHash("sha256").update(k,"utf8").digest("hex")}catch(S){l(S);return}}}),define(ne[76],se([7,5]),function(q,e){return q.create("vs/base/common/date",e)}),define(ne[77],se([0,1,76]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,L=T*60,N=L*24,A=N*7,E=N*30,u=N*365;function l(k,g,f,R){typeof k!="number"&&(k=k.getTime());const y=Math.round((new Date().getTime()-k)/1e3);if(y<-30)return(0,x.localize)(0,null,l(new Date().getTime()+y*1e3,!1));if(!R&&y<30)return(0,x.localize)(1,null);let m;return y<T?(m=y,g?m===1?f?(0,x.localize)(2,null,m):(0,x.localize)(3,null,m):f?(0,x.localize)(4,null,m):(0,x.localize)(5,null,m):m===1?f?(0,x.localize)(6,null,m):(0,x.localize)(7,null,m):f?(0,x.localize)(8,null,m):(0,x.localize)(9,null,m)):y<L?(m=Math.floor(y/T),g?m===1?f?(0,x.localize)(10,null,m):(0,x.localize)(11,null,m):f?(0,x.localize)(12,null,m):(0,x.localize)(13,null,m):m===1?f?(0,x.localize)(14,null,m):(0,x.localize)(15,null,m):f?(0,x.localize)(16,null,m):(0,x.localize)(17,null,m)):y<N?(m=Math.floor(y/L),g?m===1?f?(0,x.localize)(18,null,m):(0,x.localize)(19,null,m):f?(0,x.localize)(20,null,m):(0,x.localize)(21,null,m):m===1?f?(0,x.localize)(22,null,m):(0,x.localize)(23,null,m):f?(0,x.localize)(24,null,m):(0,x.localize)(25,null,m)):y<A?(m=Math.floor(y/N),g?m===1?(0,x.localize)(26,null,m):(0,x.localize)(27,null,m):m===1?(0,x.localize)(28,null,m):(0,x.localize)(29,null,m)):y<E?(m=Math.floor(y/A),g?m===1?f?(0,x.localize)(30,null,m):(0,x.localize)(31,null,m):f?(0,x.localize)(32,null,m):(0,x.localize)(33,null,m):m===1?f?(0,x.localize)(34,null,m):(0,x.localize)(35,null,m):f?(0,x.localize)(36,null,m):(0,x.localize)(37,null,m)):y<u?(m=Math.floor(y/E),g?m===1?f?(0,x.localize)(38,null,m):(0,x.localize)(39,null,m):f?(0,x.localize)(40,null,m):(0,x.localize)(41,null,m):m===1?f?(0,x.localize)(42,null,m):(0,x.localize)(43,null,m):f?(0,x.localize)(44,null,m):(0,x.localize)(45,null,m)):(m=Math.floor(y/u),g?m===1?f?(0,x.localize)(46,null,m):(0,x.localize)(47,null,m):f?(0,x.localize)(48,null,m):(0,x.localize)(49,null,m):m===1?f?(0,x.localize)(50,null,m):(0,x.localize)(51,null,m):f?(0,x.localize)(52,null,m):(0,x.localize)(53,null,m))}e.fromNow=l;function S(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=S}),define(ne[78],se([7,5]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(ne[33],se([0,1,19,3,78]),function(q,e,x,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function N(k,g){return g&&(k.stack||k.stacktrace)?L.localize(0,null,E(k),A(k.stack)||A(k.stacktrace)):E(k)}function A(k){return Array.isArray(k)?k.join(`
`):k}function E(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?L.localize(1,null,k.message):k.message||L.localize(2,null)}function u(k=null,g=!1){if(!k)return L.localize(3,null);if(Array.isArray(k)){const f=x.coalesce(k),R=u(f[0],g);return f.length>1?L.localize(4,null,R,f.length):R}if(T.isString(k))return k;if(k.detail){const f=k.detail;if(f.error)return N(f.error,g);if(f.exception)return N(f.exception,g)}return k.stack?N(k,g):k.message?k.message:L.localize(5,null)}e.toErrorMessage=u;function l(k){const g=k;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=l;function S(k,g){let f;return typeof k=="string"?f=new Error(k):f=k,f.actions=g,f}e.createErrorWithActions=S}),define(ne[79],se([7,5]),function(q,e){return q.create("vs/base/common/jsonErrorMessages",e)}),define(ne[80],se([0,1,79]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function T(L){switch(L){case 1:return(0,x.localize)(0,null);case 2:return(0,x.localize)(1,null);case 3:return(0,x.localize)(2,null);case 4:return(0,x.localize)(3,null);case 5:return(0,x.localize)(4,null);case 6:return(0,x.localize)(5,null);case 7:return(0,x.localize)(6,null);case 8:return(0,x.localize)(7,null);case 9:return(0,x.localize)(8,null);default:return""}}e.getParseErrorMessage=T}),define(ne[55],se([0,1,12]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var T;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(T||(e.Source=T={}));var L;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function N(E,...u){const l=u.reduce((g,f)=>(g[f]=!0,g),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(g=>!l[g]).forEach(g=>{for(let f=0;f<S.length;f++)if(g.search(S[f])!==-1){delete E[g];break}})}e.sanitizeProcessEnvironment=N;function A(E){E&&(delete E.DEBUG,x.isMacintosh&&delete E.DYLD_LIBRARY_PATH,x.isLinux&&delete E.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(ne[81],se([0,1,11]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function T(l){const S=l;return S&&typeof S.type=="string"&&typeof S.severity=="string"}e.isRemoteConsoleLog=T;function L(l){const S=[];let k;try{const g=JSON.parse(l.arguments),f=g[g.length-1];f&&f.__$stack&&(g.pop(),k=f.__$stack),S.push(...g)}catch{S.push("Unable to log remote console arguments",l.arguments)}return{args:S,stack:k}}e.parse=L;function N(l){if(typeof l!="string")return N(L(l).stack);const S=l;if(S){const k=A(S),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(g&&g.length===4)return{uri:x.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=N;function A(l){if(!l)return l;const S=l.indexOf(`
`);return S===-1?l:l.substring(0,S)}function E(l,S){const{args:k,stack:g}=L(l),f=typeof k[0]=="string"&&k.length===1;let R=A(g);R&&(R=`(${R.trim()})`);let y=[];if(typeof k[0]=="string"?R&&f?y=[`%c[${S}] %c${k[0]} %c${R}`,u("blue"),u(""),u("grey")]:y=[`%c[${S}] %c${k[0]}`,u("blue"),u(""),...k.slice(1)]:y=[`%c[${S}]%`,u("blue"),...k],R&&!f&&y.push(R),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,y)}e.log=E;function u(l){return`color: ${l}`}}),define(ne[47],se([0,1,14,28,11]),function(q,e,x,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function N(l){return JSON.stringify(l,E)}e.stringify=N;function A(l){let S=JSON.parse(l);return S=u(S),S}e.parse=A;function E(l,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:(0,T.regExpFlags)(S)}:S}function u(l,S=0){if(!l||S>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return L.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof x.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let k=0;k<l.length;++k)l[k]=u(l[k],S+1);else for(const k in l)Object.hasOwnProperty.call(l,k)&&(l[k]=u(l[k],S+1))}return l}e.revive=u}),define(ne[82],se([0,1,70,15,12,11]),function(q,e,x,T,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class A{constructor(g,f,R){this.id=g,this.dependencies=f,this.callback=R}}class E{static{this.INSTANCE=new E}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(g,f,R)=>{typeof g!="string"&&(R=f,f=g,g=null),(typeof f!="object"||!Array.isArray(f))&&(R=f,f=null),this._defineCalls.push(new A(g,f,R))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this._initialize();const f=await(this._isWebWorker?this._workerLoadScript(g):this._isRenderer?this._rendererLoadScript(g):this._nodeJSLoadScript(g));if(!f)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}_rendererLoadScript(g){return new Promise((f,R)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const m=()=>{y.removeEventListener("load",d),y.removeEventListener("error",h)},d=C=>{m(),f(this._defineCalls.pop())},h=C=>{m(),R(C)};y.addEventListener("load",d),y.addEventListener("error",h),this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),y.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(y)})}_workerLoadScript(g){return new Promise((f,R)=>{try{this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),importScripts(g),f(this._defineCalls.pop())}catch(y){R(y)}})}async _nodeJSLoadScript(g){try{const f=globalThis._VSCODE_NODE_MODULES.fs,R=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,m=N.URI.parse(g).fsPath,d=f.readFileSync(m).toString(),h=y.wrap(d.replace(/^#!.*/,""));return new R.Script(h).runInThisContext().apply(),this._defineCalls.pop()}catch(f){throw f}}}const u=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function S(k,g,f){if(x.isESM){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[k]&&(k=l[k]);const R=`${k}/${g}`;if(u.has(R))return u.get(R);let y;if(/^\w[\w\d+.-]*:\/\//.test(R))y=R;else{const C=`${f&&!L.isWeb?T.nodeModulesAsarPath:T.nodeModulesPath}/${R}`;y=T.FileAccess.asBrowserUri(C).toString(!0)}const m=E.INSTANCE.load(y);return u.set(R,m),m}else return await new Promise((R,y)=>{q([k],R,y)})}e.importAMDNodeModule=S}),define(ne[83],se([0,1,32,16,24]),function(q,e,x,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const N=/^\d+$/,A=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var u;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(u||(u={}));let l;switch(process.arch){case"ia32":case"x32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class k{constructor(w,t,a){this.exePath=w,this.displayName=t,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:p=!1}={}){return p?l===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:p=!1,findPreview:w=!1}={}){const t=g({useAlternateBitness:p});if(!t)return null;const a=T.join(t,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(a))return null;let i=-1,r=null;for(const c of await L.Promises.readdir(a)){let D=-1;if(w){const b=c.indexOf("-");if(b<0)continue;const O=c.substring(0,b);if(!N.test(O)||c.substring(b+1)!=="preview")continue;D=parseInt(O,10)}else{if(!N.test(c))continue;D=parseInt(c,10)}if(D<=i)continue;const P=T.join(a,c,"pwsh.exe");await L.SymlinkSupport.existsFile(P)&&(r=P,i=D)}if(!r)return null;const n=t.includes("x86")?" (x86)":"",o=w?" Preview":"";return new k(r,`PowerShell${o}${n}`,!0)}async function R({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const w=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(w))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=p?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await L.Promises.readdir(w))if(t.test(i)){const r=T.join(w,i,"pwsh.exe");return new k(r,a)}return null}function y(){const p=T.join(x.homedir(),".dotnet","tools","pwsh.exe");return new k(p,".NET Core PowerShell Global Tool")}function m(){const p=T.join(process.env.windir,l===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(p,"Windows PowerShell",!0)}async function*d(){let p=await f();p&&(yield p),p=await f({useAlternateBitness:!0}),p&&(yield p),p=await R(),p&&(yield p),p=y(),p&&(yield p),p=await f({findPreview:!0}),p&&(yield p),p=await R({findPreview:!0}),p&&(yield p),p=await f({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=m(),p&&(yield p)}async function*h(){for await(const p of d())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=h;async function C(){for await(const p of h())return p;return null}e.getFirstAvailablePowerShellInstallation=C}),define(ne[56],se([0,1,16,12,34,55,3,24]),function(q,e,x,T,L,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function u(k=L.env){return k.comspec||"cmd.exe"}e.getWindowsShell=u;function l(k){let g=[],f=!1;const R=function(y){if(f){g.push(y);return}(!k.send(y,d=>{if(d&&console.error(d),f=!1,g.length>0){const h=g.slice(0);g=[],h.forEach(C=>R(C))}})||T.isWindows)&&(f=!0)};return{send:R}}e.createQueuedSender=l;var S;(function(k){async function g(f,R,y){if(x.isAbsolute(f))return f;if(R===void 0&&(R=L.cwd()),x.dirname(f)!=="."||(y===void 0&&A.isString(L.env.PATH)&&(y=L.env.PATH.split(x.delimiter)),y===void 0||y.length===0))return x.join(R,f);async function d(h){if(await E.Promises.exists(h)){let C;try{C=await E.Promises.stat(h)}catch(p){p.message.startsWith("EACCES")&&(C=await E.Promises.lstat(h))}return C?!C.isDirectory():!1}return!1}for(const h of y){let C;if(x.isAbsolute(h)?C=x.join(h,f):C=x.join(R,h,f),await d(C))return C;let p=C+".com";if(await d(p)||(p=C+".exe",await d(p)))return p}return x.join(R,f)}k.findExecutable=g})(S||(e.win32=S={}))}),define(ne[84],se([0,1,32,12,83,56]),function(q,e,x,T,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function A(k,g){return k===1?T.isWindows?S():N.getWindowsShell(g):u(k,g)}e.getSystemShell=A;let E=null;function u(k,g){if(T.isLinux&&k===2||T.isMacintosh&&k===3)return"/bin/bash";if(!E){let f;if(T.isWindows)f="/bin/bash";else{if(f=g.SHELL,!f)try{f=(0,x.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}E=f}return E}let l=null;async function S(){return l||(l=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),l}});var ve=this&&this.__decorate||function(q,e,x,T){var L=arguments.length,N=L<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,x):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(q,e,x,T);else for(var E=q.length-1;E>=0;E--)(A=q[E])&&(N=(L<3?A(N):L>3?A(e,x,N):A(e,x))||N);return L>3&&N&&Object.defineProperty(e,x,N),N};define(ne[57],se([0,1,19,8,14,20,52,9,4,2,47,28,3]),function(q,e,x,T,L,N,A,E,u,l,S,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var f;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(f||(f={}));function R(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(y||(y={}));function m(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(d||(d={}));function h(U){let M=0;for(let z=0;;z+=7){const G=U.read(1);if(M|=(G.buffer[0]&127)<<z,!(G.buffer[0]&128))return M}}const C=i(0);function p(U,M){if(M===0){U.write(C);return}let z=0;for(let K=M;K!==0;K=K>>>7)z++;const G=L.VSBuffer.alloc(z);for(let K=0;M!==0;K++)G.buffer[K]=M&127,M=M>>>7,M>0&&(G.buffer[K]|=128);U.write(G)}class w{constructor(M){this.buffer=M,this.pos=0}read(M){const z=this.buffer.slice(this.pos,this.pos+M);return this.pos+=z.byteLength,z}}e.BufferReader=w;class t{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}e.BufferWriter=t;var a;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object",U[U.Int=6]="Int"})(a||(a={}));function i(U){const M=L.VSBuffer.alloc(1);return M.writeUInt8(U,0),M}const r={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},n=typeof Buffer<"u";function o(U,M){if(typeof M>"u")U.write(r.Undefined);else if(typeof M=="string"){const z=L.VSBuffer.fromString(M);U.write(r.String),p(U,z.byteLength),U.write(z)}else if(n&&Buffer.isBuffer(M)){const z=L.VSBuffer.wrap(M);U.write(r.Buffer),p(U,z.byteLength),U.write(z)}else if(M instanceof L.VSBuffer)U.write(r.VSBuffer),p(U,M.byteLength),U.write(M);else if(Array.isArray(M)){U.write(r.Array),p(U,M.length);for(const z of M)o(U,z)}else if(typeof M=="number"&&(M|0)===M)U.write(r.Uint),p(U,M);else{const z=L.VSBuffer.fromString(JSON.stringify(M));U.write(r.Object),p(U,z.byteLength),U.write(z)}}e.serialize=o;function c(U){switch(U.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return U.read(h(U)).toString();case a.Buffer:return U.read(h(U)).buffer;case a.VSBuffer:return U.read(h(U));case a.Array:{const z=h(U),G=[];for(let K=0;K<z;K++)G.push(c(U));return G}case a.Object:return JSON.parse(U.read(h(U)).toString());case a.Int:return h(U)}}e.deserialize=c;class D{constructor(M,z,G=null,K=1e3){this.protocol=M,this.ctx=z,this.logger=G,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(J=>this.onRawMessage(J)),this.sendResponse({type:200})}registerChannel(M,z){this.channels.set(M,z),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const z=this.send([M.type]);this.logger?.logOutgoing(z,0,1,m(M.type));return}case 201:case 202:case 204:case 203:{const z=this.send([M.type,M.id],M.data);this.logger?.logOutgoing(z,M.id,1,m(M.type),M.data);return}}}send(M,z=void 0){const G=new t;return o(G,M),o(G,z),this.sendBuffer(G.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onRawMessage(M){const z=new w(M),G=c(z),K=c(z),J=G[0];switch(J){case 100:return this.logger?.logIncoming(M.byteLength,G[1],1,`${R(J)}: ${G[2]}.${G[3]}`,K),this.onPromise({type:J,id:G[1],channelName:G[2],name:G[3],arg:K});case 102:return this.logger?.logIncoming(M.byteLength,G[1],1,`${R(J)}: ${G[2]}.${G[3]}`,K),this.onEventListen({type:J,id:G[1],channelName:G[2],name:G[3],arg:K});case 101:return this.logger?.logIncoming(M.byteLength,G[1],1,`${R(J)}`),this.disposeActiveRequest({type:J,id:G[1]});case 103:return this.logger?.logIncoming(M.byteLength,G[1],1,`${R(J)}`),this.disposeActiveRequest({type:J,id:G[1]})}}onPromise(M){const z=this.channels.get(M.channelName);if(!z){this.collectPendingRequest(M);return}const G=new N.CancellationTokenSource;let K;try{K=z.call(this.ctx,M.name,M.arg,G.token)}catch(I){K=Promise.reject(I)}const J=M.id;K.then(I=>{this.sendResponse({id:J,data:I,type:201}),this.activeRequests.delete(M.id)},I=>{I instanceof Error?this.sendResponse({id:J,data:{message:I.message,name:I.name,stack:I.stack?I.stack.split?I.stack.split(`
`):I.stack:void 0},type:202}):this.sendResponse({id:J,data:I,type:203}),this.activeRequests.delete(M.id)});const oe=(0,l.toDisposable)(()=>G.cancel());this.activeRequests.set(M.id,oe)}onEventListen(M){const z=this.channels.get(M.channelName);if(!z){this.collectPendingRequest(M);return}const G=M.id,J=z.listen(this.ctx,M.name,M.arg)(oe=>this.sendResponse({id:G,data:oe,type:204}));this.activeRequests.set(M.id,J)}disposeActiveRequest(M){const z=this.activeRequests.get(M.id);z&&(z.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let z=this.pendingRequests.get(M.channelName);z||(z=[],this.pendingRequests.set(M.channelName,z));const G=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:M,timeoutTimer:G})}flushPendingRequests(M){const z=this.pendingRequests.get(M);if(z){for(const G of z)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=D;var P;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(P||(e.RequestInitiator=P={}));class b{constructor(M,z=null){this.protocol=M,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=z}getChannel(M){const z=this;return{call(G,K,J){return z.isDisposed?Promise.reject(new E.CancellationError):z.requestPromise(M,G,K,J)},listen(G,K){return z.isDisposed?u.Event.None:z.requestEvent(M,G,K)}}}requestPromise(M,z,G,K=N.CancellationToken.None){const J=this.lastRequestId++,I={id:J,type:100,channelName:M,name:z,arg:G};if(K.isCancellationRequested)return Promise.reject(new E.CancellationError);let s;return new Promise((F,_)=>{if(K.isCancellationRequested)return _(new E.CancellationError);const B=()=>{const he=ue=>{switch(ue.type){case 201:this.handlers.delete(J),F(ue.data);break;case 202:{this.handlers.delete(J);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,_(ge);break}case 203:this.handlers.delete(J),_(ue.data);break}};this.handlers.set(J,he),this.sendRequest(I)};let H=null;this.state===d.Idle?B():(H=(0,T.createCancelablePromise)(he=>this.whenInitialized()),H.then(()=>{H=null,B()}));const ie=()=>{H?(H.cancel(),H=null):this.sendRequest({id:J,type:101}),_(new E.CancellationError)},de=K.onCancellationRequested(ie);s=(0,l.combinedDisposable)((0,l.toDisposable)(ie),de),this.activeRequests.add(s)}).finally(()=>{this.activeRequests.delete(s)})}requestEvent(M,z,G){const K=this.lastRequestId++,oe={id:K,type:102,channelName:M,name:z,arg:G};let I=null;const s=new u.Emitter({onWillAddFirstListener:()=>{I=(0,T.createCancelablePromise)(F=>this.whenInitialized()),I.then(()=>{I=null,this.activeRequests.add(s),this.sendRequest(oe)})},onDidRemoveLastListener:()=>{I?(I.cancel(),I=null):(this.activeRequests.delete(s),this.sendRequest({id:K,type:103}))}}),v=F=>s.fire(F.data);return this.handlers.set(K,v),s.event}sendRequest(M){switch(M.type){case 100:case 102:{const z=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger?.logOutgoing(z,M.id,0,`${R(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const z=this.send([M.type,M.id]);this.logger?.logOutgoing(z,M.id,0,R(M.type));return}}}send(M,z=void 0){const G=new t;return o(G,M),o(G,z),this.sendBuffer(G.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onBuffer(M){const z=new w(M),G=c(z),K=c(z),J=G[0];switch(J){case 200:return this.logger?.logIncoming(M.byteLength,0,0,m(J)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(M.byteLength,G[1],0,m(J),K),this.onResponse({type:G[0],id:G[1],data:K})}}onResponse(M){if(M.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get(M.id)?.(M)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=b,ve([A.memoize],b.prototype,"onDidInitializePromise",null);class O{get connections(){const M=[];return this._connections.forEach(z=>M.push(z)),M}constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:z,onDidClientDisconnect:G})=>{u.Event.once(z.onMessage)(J=>{const oe=new w(J),I=c(oe),s=new D(z,I),v=new b(z);this.channels.forEach((_,B)=>s.registerChannel(B,_));const F={channelServer:s,channelClient:v,ctx:I};this._connections.add(F),this._onDidAddConnection.fire(F),G(()=>{s.dispose(),v.dispose(),this._connections.delete(F),this._onDidRemoveConnection.fire(F)})})})}getChannel(M,z){const G=this;return{call(K,J,oe){let I;if((0,g.isFunction)(z)){const v=(0,x.getRandomElement)(G.connections.filter(z));I=v?Promise.resolve(v):u.Event.toPromise(u.Event.filter(G.onDidAddConnection,z))}else I=z.routeCall(G,K,J);const s=I.then(v=>v.channelClient.getChannel(M));return ee(s).call(K,J,oe)},listen(K,J){if((0,g.isFunction)(z))return G.getMulticastEvent(M,z,K,J);const oe=z.routeEvent(G,K,J).then(I=>I.channelClient.getChannel(M));return ee(oe).listen(K,J)}}}getMulticastEvent(M,z,G,K){const J=this;let oe=new l.DisposableStore;const I=new u.Emitter({onWillAddFirstListener:()=>{oe=new l.DisposableStore;const s=new u.EventMultiplexer,v=new Map,F=B=>{const ie=B.channelClient.getChannel(M).listen(G,K),de=s.add(ie);v.set(B,de)},_=B=>{const H=v.get(B);H&&(H.dispose(),v.delete(B))};J.connections.filter(z).forEach(F),u.Event.filter(J.onDidAddConnection,z)(F,void 0,oe),J.onDidRemoveConnection(_,void 0,oe),s.event(I.fire,I,oe),oe.add(s)},onDidRemoveLastListener:()=>{oe.dispose()}});return I.event}registerChannel(M,z){this.channels.set(M,z),this._connections.forEach(G=>{G.channelServer.registerChannel(M,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=O;class j{constructor(M,z,G=null){const K=new t;o(K,z),M.send(K.buffer),this.channelClient=new b(M,G),this.channelServer=new D(M,z,G)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,z){this.channelServer.registerChannel(M,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=j;function ee(U){return{call(M,z,G){return U.then(K=>K.call(M,z,G))},listen(M,z){const G=new u.Relay;return U.then(K=>G.input=K.listen(M,z)),G.event}}}e.getDelayedChannel=ee;function Y(U){let M=!1;return{call(z,G,K){return M?U.call(z,G,K):(0,T.timeout)(0).then(()=>M=!0).then(()=>U.call(z,G,K))},listen(z,G){if(M)return U.listen(z,G);const K=new u.Relay;return(0,T.timeout)(0).then(()=>M=!0).then(()=>K.input=U.listen(z,G)),K.event}}}e.getNextTickChannel=Y;class ce{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const z of M.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await u.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=ce;var Z;(function(U){function M(J,oe){const I=J,s=oe&&oe.disableMarshalling,v=new Map;for(const F in I)G(F)&&v.set(F,u.Event.buffer(I[F],!0));return new class{listen(F,_,B){const H=v.get(_);if(H)return H;if(K(_)){const ie=I[_];if(typeof ie=="function")return ie.call(I,B)}throw new E.ErrorNoTelemetry(`Event not found: ${_}`)}call(F,_,B){const H=I[_];if(typeof H=="function"){if(!s&&Array.isArray(B))for(let ie=0;ie<B.length;ie++)B[ie]=(0,S.revive)(B[ie]);return H.apply(I,B)}throw new E.ErrorNoTelemetry(`Method not found: ${_}`)}}}U.fromService=M;function z(J,oe){const I=oe&&oe.disableMarshalling;return new Proxy({},{get(s,v){if(typeof v=="string")return oe?.properties?.has(v)?oe.properties.get(v):K(v)?function(F){return J.listen(v,F)}:G(v)?J.listen(v):async function(...F){let _;oe&&!(0,g.isUndefinedOrNull)(oe.context)?_=[oe.context,...F]:_=F;const B=await J.call(v,_);return I?B:(0,S.revive)(B)};throw new E.ErrorNoTelemetry(`Property not found: ${String(v)}`)}})}U.toService=z;function G(J){return J[0]==="o"&&J[1]==="n"&&k.isUpperAsciiLetter(J.charCodeAt(2))}function K(J){return/^onDynamic/.test(J)&&k.isUpperAsciiLetter(J.charCodeAt(9))}})(Z||(e.ProxyChannel=Z={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){const M=U.toString();if(M!=="[object Object]")return M}return U}function te(U){return Array.isArray(U)?U.map(le):le(U)}function V(U,M,z,G,K,J,oe){oe=te(oe);const I=ae[K],s=I[G%I.length];let v=[`%c[${U}]%c[${String(M).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${s}`];/\($/.test(J)?(v=v.concat(oe),v.push(")")):v.push(oe),console.log.apply(console,v)}class ${constructor(M,z){this._outgoingPrefix=M,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,z,G,K,J){this._totalOutgoing+=M,V(this._outgoingPrefix,this._totalOutgoing,M,z,G,K,J)}logIncoming(M,z,G,K,J){this._totalIncoming+=M,V(this._incomingPrefix,this._totalIncoming,M,z,G,K,J)}}e.IPCLogger=$}),define(ne[85],se([0,1,58,8,14,20,81,9,4,2,30,56,55,57]),function(q,e,x,T,L,N,A,E,u,l,S,k,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class R extends f.ChannelServer{constructor(d){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",h=>L.VSBuffer.wrap(Buffer.from(h,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.Server=R;class y{constructor(d,h){this.modulePath=d,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const C=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new T.Delayer(C),this.child=null,this._client=null}getChannel(d){const h=this;return{call(C,p,w){return h.requestPromise(d,C,p,w)},listen(C,p){return h.requestEvent(d,C,p)}}}requestPromise(d,h,C,p=N.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const w=this.getCachedChannel(d),t=(0,T.createCancelablePromise)(r=>w.call(h,C,r)),a=p.onCancellationRequested(()=>t.cancel()),i=(0,l.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{a.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(d,h,C){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let p;const w=new u.Emitter({onWillAddFirstListener:()=>{p=this.getCachedChannel(d).listen(h,C)(w.fire,w),this.activeRequests.add(p)},onDidRemoveLastListener:()=>{this.activeRequests.delete(p),p.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return w.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,S.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,g.removeDangerousEnvVariables)(h.env),this.child=(0,x.fork)(this.modulePath,d,h);const C=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,A.isRemoteConsoleLog)(n)){(0,A.log)(n,`IPC Library: ${this.options.serverName}`);return}C.fire(L.VSBuffer.wrap(Buffer.from(n,"base64")))});const w=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,t=n=>this.child&&this.child.connected&&w.send(n.buffer.toString("base64")),a=C.event,i={send:t,onMessage:a};this._client=new f.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,o)=>{process.removeListener("exit",r),this.activeRequests.forEach(c=>(0,l.dispose)(c)),this.activeRequests.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+o),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:o})})}return this._client}getCachedChannel(d){let h=this.channels.get(d);return h||(h=this.client.getChannel(d),this.channels.set(d,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(ne[86],se([0,1,8,4,2,47,3]),function(q,e,x,T,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var E;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function u(g){const f=g;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=u;var l;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(l||(e.StorageState=l={}));class S extends L.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(f,R=Object.create(null)){super(),this.database=f,this.options=R,this._onDidChangeStorage=this._register(new T.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new x.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){this._onDidChangeStorage.pause();try{f.changed?.forEach((R,y)=>this.acceptExternal(y,R)),f.deleted?.forEach(R=>this.acceptExternal(R,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(f,R){if(this.state===l.Closed)return;let y=!1;(0,A.isUndefinedOrNull)(R)?y=this.cache.delete(f):this.cache.get(f)!==R&&(this.cache.set(f,R),y=!0),y&&this._onDidChangeStorage.fire({key:f,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,R){const y=this.cache.get(f);return(0,A.isUndefinedOrNull)(y)?R:y}getBoolean(f,R){const y=this.get(f);return(0,A.isUndefinedOrNull)(y)?R:y==="true"}getNumber(f,R){const y=this.get(f);return(0,A.isUndefinedOrNull)(y)?R:parseInt(y,10)}getObject(f,R){const y=this.get(f);return(0,A.isUndefinedOrNull)(y)?R:(0,N.parse)(y)}async set(f,R,y=!1){if(this.state===l.Closed)return;if((0,A.isUndefinedOrNull)(R))return this.delete(f,y);const m=(0,A.isObject)(R)||Array.isArray(R)?(0,N.stringify)(R):String(R);if(this.cache.get(f)!==m)return this.cache.set(f,m),this.pendingInserts.set(f,m),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire({key:f,external:y}),this.doFlush()}async delete(f,R=!1){if(!(this.state===l.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire({key:f,external:R}),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}isInMemory(){return this.options.hint===E.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=S;class k{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert?.forEach((R,y)=>this.items.set(y,R)),f.delete?.forEach(R=>this.items.delete(R))}async close(){}}e.InMemoryStorageDatabase=k}),define(ne[87],se([7,5]),function(q,e){return q.create("vs/base/node/zip",e)}),define(ne[88],se([7,5]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],se([7,5]),function(q,e){return q.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],se([7,5]),function(q,e){return q.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],se([7,5]),function(q,e){return q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],se([7,5]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],se([7,5]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],se([7,5]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],se([7,5]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],se([7,5]),function(q,e){return q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],se([7,5]),function(q,e){return q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],se([7,5]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],se([7,5]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(ne[100],se([7,5]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(ne[101],se([7,5]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],se([7,5]),function(q,e){return q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],se([7,5]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(ne[104],se([7,5]),function(q,e){return q.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],se([7,5]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],se([7,5]),function(q,e){return q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],se([7,5]),function(q,e){return q.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],se([0,1,9,90]),function(q,e,x,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var L;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(L||(e.TokenType=L={}));function N(...l){switch(l.length){case 1:return(0,T.localize)(0,null,l[0]);case 2:return(0,T.localize)(1,null,l[0],l[1]);case 3:return(0,T.localize)(2,null,l[0],l[1],l[2]);default:return}}const A=(0,T.localize)(3,null),E=(0,T.localize)(4,null);class u{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(S){switch(S.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return S.isTripleEq?"===":"==";case 4:return S.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return S.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return S.lexeme;case 18:return S.lexeme;case 19:return S.lexeme;case 20:return"EOF";default:throw(0,x.illegalState)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(S){return this._input=S,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const k=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:k})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const k=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:k})}else this._match(126)?this._addToken(9):this._error(N("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(N("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(S){return this._isAtEnd()||this._input.charCodeAt(this._current)!==S?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(S){this._tokens.push({type:S,offset:this._start})}_error(S){const k=this._start,g=this._input.substring(this._start,this._current),f={type:19,offset:this._start,lexeme:g};this._errors.push({offset:k,lexeme:g,additionalInfo:S}),this._tokens.push(f)}_string(){this.stringRe.lastIndex=this._start;const S=this.stringRe.exec(this._input);if(S){this._current=this._start+S[0].length;const k=this._input.substring(this._start,this._current),g=u._keywords.get(k);g?this._addToken(g):this._tokens.push({type:17,lexeme:k,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(A);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let S=this._current,k=!1,g=!1;for(;;){if(S>=this._input.length){this._current=S,this._error(E);return}const R=this._input.charCodeAt(S);if(k)k=!1;else if(R===47&&!g){S++;break}else R===91?g=!0:R===92?k=!0:R===93&&(g=!1);S++}for(;S<this._input.length&&u._regexFlags.has(this._input.charCodeAt(S));)S++;this._current=S;const f=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:f,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=u}),define(ne[109],se([0,1,77,52,15,16,34,17,11]),function(q,e,x,T,L,N,A,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,N.dirname)(L.FileAccess.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,N.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,E.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,x.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,N.join)(this.userDataPath,"logs",f)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(u.URI.file((0,N.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=A.env.VSCODE_PORTABLE;return f?u.URI.file((0,N.join)(f,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,N.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,N.resolve)(f):(0,N.normalize)((0,N.join)(L.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?u.URI.file((0,N.resolve)(f)):u.URI.file((0,N.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,N.resolve)(f);const R=A.env.VSCODE_EXTENSIONS;if(R)return R;const y=A.env.VSCODE_PORTABLE;return y?(0,N.join)(y,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(R=>/^[^:/?#]+?:\/\//.test(R)?u.URI.parse(R):u.URI.file((0,N.normalize)(R)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?u.URI.parse(f):u.URI.file((0,N.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const R of this.args.log||[]){const y=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(R);y&&y[1]&&y[2]&&f.push([y[1],y[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,E.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=A.env.VSCODE_PORTABLE;return f?u.URI.file((0,N.join)(f,"policy.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this._args}constructor(f,R,y){this._args=f,this.paths=R,this.productService=y,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=l,ve([T.memoize],l.prototype,"appRoot",null),ve([T.memoize],l.prototype,"userHome",null),ve([T.memoize],l.prototype,"userDataPath",null),ve([T.memoize],l.prototype,"appSettingsHome",null),ve([T.memoize],l.prototype,"tmpDir",null),ve([T.memoize],l.prototype,"cacheHome",null),ve([T.memoize],l.prototype,"stateResource",null),ve([T.memoize],l.prototype,"userRoamingDataHome",null),ve([T.memoize],l.prototype,"userDataSyncHome",null),ve([T.memoize],l.prototype,"sync",null),ve([T.memoize],l.prototype,"machineSettingsResource",null),ve([T.memoize],l.prototype,"workspaceStorageHome",null),ve([T.memoize],l.prototype,"localHistoryHome",null),ve([T.memoize],l.prototype,"keyboardLayoutResource",null),ve([T.memoize],l.prototype,"argvResource",null),ve([T.memoize],l.prototype,"isExtensionDevelopment",null),ve([T.memoize],l.prototype,"untitledWorkspacesHome",null),ve([T.memoize],l.prototype,"builtinExtensionsPath",null),ve([T.memoize],l.prototype,"extensionsPath",null),ve([T.memoize],l.prototype,"extensionDevelopmentLocationURI",null),ve([T.memoize],l.prototype,"extensionDevelopmentKind",null),ve([T.memoize],l.prototype,"extensionTestsLocationURI",null),ve([T.memoize],l.prototype,"debugExtensionHost",null),ve([T.memoize],l.prototype,"logLevel",null),ve([T.memoize],l.prototype,"extensionLogLevel",null),ve([T.memoize],l.prototype,"serviceMachineIdResource",null),ve([T.memoize],l.prototype,"disableTelemetry",null),ve([T.memoize],l.prototype,"disableWorkspaceTrust",null),ve([T.memoize],l.prototype,"policyFile",null);function S(g,f){return k(g["inspect-extensions"],g["inspect-brk-extensions"],5870,f,g.debugId,g.extensionEnvironment)}e.parseExtensionHostDebugPort=S;function k(g,f,R,y,m,d){const C=Number(f||g)||(y?null:R),p=C?!!f:!1;let w;if(d)try{w=JSON.parse(d)}catch{}return{port:C,break:p,debugId:m,env:w}}e.parseDebugParams=k}),function(){"use strict";function q(e,x,T){function L(A,E){const u=N(A,E),l=[u];return e.isAbsolute(u)||l.unshift(T),e.resolve(...l)}function N(A,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,E);const S=A["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(k,"AppData","Roaming")}break;case"darwin":l=e.join(x.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(x.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,E)}return{getUserDataPath:L}}if(typeof define=="function")define(ne[110],se([165,32,34]),function(e,x,T){return q(e,x,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),x=require("os");module.exports=q(e,x,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],se([0,1,32,109,110]),function(q,e,x,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class N extends T.AbstractNativeEnvironmentService{constructor(l,S){super(l,{homeDir:(0,x.homedir)(),tmpDir:(0,x.tmpdir)(),userDataDir:(0,L.getUserDataPath)(l,S.nameShort)},S)}}e.NativeEnvironmentService=N;function A(u,l){return(0,T.parseDebugParams)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,l,u.extensionEnvironment)}e.parsePtyHostDebugPort=A;function E(u,l){return(0,T.parseDebugParams)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,l,u.extensionEnvironment)}e.parseSharedProcessDebugPort=E}),define(ne[112],se([0,1,3,94]),function(q,e,x,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function L(A,E,u){try{N(A,E,u)}catch(l){console.error(l?.message??l)}return A}e.localizeManifest=L;function N(A,E,u){const l=(S,k,g)=>{const f=S[k];if((0,x.isString)(f)){const R=f,y=R.length;if(y>1&&R[0]==="%"&&R[y-1]==="%"){const m=R.substr(1,y-2);let d=E[m];d===void 0&&u&&(d=u[m]);const h=typeof d=="string"?d:d?.message,C=u?.[m],p=typeof C=="string"?C:C?.message;if(!h){p||console.warn(`[${A.name}]: ${(0,T.localize)(0,null,m)}`);return}if(g&&(k==="title"||k==="category")&&p&&p!==h){const w={value:h,original:p};S[k]=w}else S[k]=h}}else if((0,x.isObject)(f))for(const R in f)f.hasOwnProperty(R)&&(R==="commands"?l(f,R,!0):l(f,R,g));else if(Array.isArray(f))for(let R=0;R<f.length;R++)l(f,R,g)};for(const S in A)A.hasOwnProperty(S)&&l(A,S)}}),define(ne[48],se([0,1,17,54,98,43]),function(q,e,x,T,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function u(d){return d=d.trim(),d==="*"||A.test(d)}e.isValidVersionStr=u;function l(d){if(!u(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=d.match(A);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=l;function S(d){if(!d)return null;const h=d.majorBase,C=d.majorMustEqual,p=d.minorBase;let w=d.minorMustEqual;const t=d.patchBase;let a=d.patchMustEqual;d.hasCaret&&(h===0||(w=!1),a=!1);let i=0;if(d.preRelease){const r=E.exec(d.preRelease);if(r){const[,n,o,c]=r;i=Date.UTC(Number(n),Number(o)-1,Number(c))}}return{majorBase:h,majorMustEqual:C,minorBase:p,minorMustEqual:w,patchBase:t,patchMustEqual:a,isMinimum:d.hasGreaterEquals,notBefore:i}}e.normalizeVersion=S;function k(d,h,C){let p;typeof d=="string"?p=S(l(d)):p=d;let w;h instanceof Date?w=h.getTime():typeof h=="string"&&(w=new Date(h).getTime());let t;if(typeof C=="string"?t=S(l(C)):t=C,!p||!t)return!1;const a=p.majorBase,i=p.minorBase,r=p.patchBase;let n=t.majorBase,o=t.minorBase,c=t.patchBase;const D=t.notBefore;let P=t.majorMustEqual,b=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?a>n?!0:a<n?!1:i>o?!0:i<o||w&&w<D?!1:r>=c:(a===1&&n===0&&(!P||!b||!O)&&(n=1,o=0,c=0,P=!0,b=!1,O=!1),a<n?!1:a>n?!P:i<o?!1:i>o?!b:r<c?!1:r>c?!O:!(w&&w<D))}e.isValidVersion=k;function g(d,h,C,p,w){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([T.default.Error,L.localize(0,null)]),t;if(typeof p.name!="string")return t.push([T.default.Error,L.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([T.default.Error,L.localize(2,null,"version")]),t;if(!p.engines)return t.push([T.default.Error,L.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([T.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!m(p.extensionDependencies))return t.push([T.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!m(p.activationEvents))return t.push([T.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([T.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([T.default.Warning,L.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([T.default.Error,L.localize(9,null,"main")]),t;{const r=(0,x.joinPath)(C,p.main);(0,x.isEqualOrParent)(r,C)||t.push([T.default.Warning,L.localize(10,null,r.path,C.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([T.default.Error,L.localize(11,null,"browser")]),t;{const r=(0,x.joinPath)(C,p.browser);(0,x.isEqualOrParent)(r,C)||t.push([T.default.Warning,L.localize(12,null,r.path,C.path)])}}if(!N.valid(p.version))return t.push([T.default.Error,L.localize(13,null)]),t;const a=[];if(!f(d,h,p,w,a))for(const r of a)t.push([T.default.Error,r]);return t}e.validateExtensionManifest=g;function f(d,h,C,p,w){return p||typeof C.main>"u"&&typeof C.browser>"u"?!0:y(d,h,C.engines.vscode,w)}e.isValidExtensionVersion=f;function R(d,h,C){return d==="*"||y(h,C,d)}e.isEngineValid=R;function y(d,h,C,p=[]){const w=S(l(C));if(!w)return p.push(L.localize(14,null,C)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return p.push(L.localize(15,null,C)),!1}else if(!w.majorMustEqual)return p.push(L.localize(16,null,C)),!1;return k(d,h,w)?!0:(p.push(L.localize(17,null,d,C)),!1)}function m(d){if(!Array.isArray(d))return!1;for(let h=0,C=d.length;h<C;h++)if(typeof d[h]!="string")return!1;return!0}}),define(ne[113],se([0,1,14,29]),function(q,e,x,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(N,A,E){let u=E&&E.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const S=(await A.readFile(N.serviceMachineIdResource)).value.toString();u=(0,T.isUUID)(S)?S:null}catch{u=null}if(!u){u=(0,T.generateUuid)();try{await A.writeFile(N.serviceMachineIdResource,x.VSBuffer.fromString(u))}catch{}}return E?.store("storage.serviceMachineId",u,-1,1),u}e.getServiceMachineId=L}),define(ne[49],se([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class x{constructor(L,N=[],A=!1){this.ctor=L,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=x}),define(ne[114],se([0,1,49]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var L;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function N(E,u,l){u instanceof x.SyncDescriptor||(u=new x.SyncDescriptor(u,[],!!l)),T.push([E,u])}e.registerSingleton=N;function A(){return T}e.getSingletonServiceDescriptors=A}),define(ne[115],se([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class x{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=x;class T{constructor(N){this._hashFn=N,this._nodes=new Map}roots(){const N=[];for(const A of this._nodes.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const E=this.lookupOrInsertNode(N),u=this.lookupOrInsertNode(A);E.outgoing.set(u.key,u),u.incoming.set(E.key,E)}removeNode(N){const A=this._hashFn(N);this._nodes.delete(A);for(const E of this._nodes.values())E.outgoing.delete(A),E.incoming.delete(A)}lookupOrInsertNode(N){const A=this._hashFn(N);let E=this._nodes.get(A);return E||(E=new x(A,N),this._nodes.set(A,E)),E}lookup(N){return this._nodes.get(this._hashFn(N))}isEmpty(){return this._nodes.size===0}toString(){const N=[];for(const[A,E]of this._nodes)N.push(`${A}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this._nodes){const E=new Set([N]),u=this._findCycle(A,E);if(u)return u}}_findCycle(N,A){for(const[E,u]of N.outgoing){if(A.has(E))return[...A,E].join(" -> ");A.add(E);const l=this._findCycle(u,A);if(l)return l;A.delete(E)}}}e.Graph=T}),define(ne[25],se([0,1,3,11,10]),function(q,e,x,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function N(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof T.URI)}e.isConfigurationOverrides=N;function A(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=A;var E;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function u(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=u;function l(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}e.isConfigured=l;function S(d,h){const C=Object.create(null);for(const p in d)k(C,p,d[p],h);return C}e.toValuesTree=S;function k(d,h,C,p){const w=h.split("."),t=w.pop();let a=d;for(let i=0;i<w.length;i++){const r=w[i];let n=a[r];switch(typeof n){case"undefined":n=a[r]=Object.create(null);break;case"object":break;default:p(`Ignoring ${h} as ${w.slice(0,i+1).join(".")} is ${JSON.stringify(n)}`);return}a=n}if(typeof a=="object"&&a!==null)try{a[t]=C}catch{p(`Ignoring ${h} as ${w.join(".")} is ${JSON.stringify(a)}`)}else p(`Ignoring ${h} as ${w.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=k;function g(d,h){const C=h.split(".");f(d,C)}e.removeFromValueTree=g;function f(d,h){const C=h.shift();if(h.length===0){delete d[C];return}if(Object.keys(d).indexOf(C)!==-1){const p=d[C];typeof p=="object"&&!Array.isArray(p)&&(f(p,h),Object.keys(p).length===0&&delete d[C])}}function R(d,h,C){function p(a,i){let r=a;for(const n of i){if(typeof r!="object"||r===null)return;r=r[n]}return r}const w=h.split("."),t=p(d,w);return typeof t>"u"?C:t}e.getConfigurationValue=R;function y(d,h,C){Object.keys(h).forEach(p=>{p!=="__proto__"&&(p in d?x.isObject(d[p])&&x.isObject(h[p])?y(d[p],h[p],C):C&&(d[p]=h[p]):d[p]=h[p])})}e.merge=y;function m(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=m}),define(ne[116],se([0,1,12,28,108,10,89,9]),function(q,e,x,T,L,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",x.isMacintosh),u.set("isLinux",x.isLinux),u.set("isWindows",x.isWindows),u.set("isWeb",x.isWeb),u.set("isMacNative",x.isMacintosh&&!x.isWeb),u.set("isEdge",x.isEdge),u.set("isFirefox",x.isFirefox),u.set("isChrome",x.isChrome),u.set("isSafari",x.isSafari);function l(I,s){if(u.get(I)!==void 0)throw(0,E.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(I,s)}e.setConstant=l;const S=Object.prototype.hasOwnProperty;var k;(function(I){I[I.False=0]="False",I[I.True=1]="True",I[I.Defined=2]="Defined",I[I.Not=3]="Not",I[I.Equals=4]="Equals",I[I.NotEquals=5]="NotEquals",I[I.And=6]="And",I[I.Regex=7]="Regex",I[I.NotRegex=8]="NotRegex",I[I.Or=9]="Or",I[I.In=10]="In",I[I.NotIn=11]="NotIn",I[I.Greater=12]="Greater",I[I.GreaterEquals=13]="GreaterEquals",I[I.Smaller=14]="Smaller",I[I.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const g={regexParsingWithErrorRecovery:!0},f=(0,A.localize)(0,null),R=(0,A.localize)(1,null),y=(0,A.localize)(2,null),m=(0,A.localize)(3,null),d=(0,A.localize)(4,null),h=(0,A.localize)(5,null),C=(0,A.localize)(6,null),p=(0,A.localize)(7,null);class w{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(s=g){this._config=s,this._scanner=new L.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(s){if(s===""){this._parsingErrors.push({message:f,offset:0,lexeme:"",additionalInfo:R});return}this._tokens=this._scanner.reset(s).scan(),this._current=0,this._parsingErrors=[];try{const v=this._expr();if(!this._isAtEnd()){const F=this._peek(),_=F.type===17?h:void 0;throw this._parsingErrors.push({message:d,offset:F.offset,lexeme:L.Scanner.getLexeme(F),additionalInfo:_}),w._parseError}return v}catch(v){if(v!==w._parseError)throw v;return}}_expr(){return this._or()}_or(){const s=[this._and()];for(;this._matchOne(16);){const v=this._and();s.push(v)}return s.length===1?s[0]:t.or(...s)}_and(){const s=[this._term()];for(;this._matchOne(15);){const v=this._term();s.push(v)}return s.length===1?s[0]:t.and(...s)}_term(){if(this._matchOne(2)){const s=this._peek();switch(s.type){case 11:return this._advance(),n.INSTANCE;case 12:return this._advance(),o.INSTANCE;case 0:{this._advance();const v=this._expr();return this._consume(1,m),v?.negate()}case 17:return this._advance(),j.create(s.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",s)}}return this._primary()}_primary(){const s=this._peek();switch(s.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const v=this._expr();return this._consume(1,m),v}case 17:{const v=s.lexeme;if(this._advance(),this._matchOne(9)){const _=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),_.type!==10)throw this._errExpectedButGot("REGEX",_);const B=_.lexeme,H=B.lastIndexOf("/"),ie=H===B.length-1?void 0:this._removeFlagsGY(B.substring(H+1));let de;try{de=new RegExp(B.substring(1,H),ie)}catch{throw this._errExpectedButGot("REGEX",_)}return le.create(v,de)}switch(_.type){case 10:case 19:{const B=[_.lexeme];this._advance();let H=this._peek(),ie=0;for(let me=0;me<_.lexeme.length;me++)_.lexeme.charCodeAt(me)===40?ie++:_.lexeme.charCodeAt(me)===41&&ie--;for(;!this._isAtEnd()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let me=0;me<H.lexeme.length;me++)H.lexeme.charCodeAt(me)===40?ie++:_.lexeme.charCodeAt(me)===41&&ie--}if(ie<0)break;B.push(L.Scanner.getLexeme(H)),this._advance(),H=this._peek()}const de=B.join(""),he=de.lastIndexOf("/"),ue=he===de.length-1?void 0:this._removeFlagsGY(de.substring(he+1));let ge;try{ge=new RegExp(de.substring(1,he),ue)}catch{throw this._errExpectedButGot("REGEX",_)}return t.regex(v,ge)}case 18:{const B=_.lexeme;this._advance();let H=null;if(!(0,T.isFalsyOrWhitespace)(B)){const ie=B.indexOf("/"),de=B.lastIndexOf("/");if(ie!==de&&ie>=0){const he=B.slice(ie+1,de),ue=B[de+1]==="i"?"i":"";try{H=new RegExp(he,ue)}catch{throw this._errExpectedButGot("REGEX",_)}}}if(H===null)throw this._errExpectedButGot("REGEX",_);return le.create(v,H)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,y);const _=this._value();return t.notIn(v,_)}switch(this._peek().type){case 3:{this._advance();const _=this._value();if(this._previous().type===18)return t.equals(v,_);switch(_){case"true":return t.has(v);case"false":return t.not(v);default:return t.equals(v,_)}}case 4:{this._advance();const _=this._value();if(this._previous().type===18)return t.notEquals(v,_);switch(_){case"true":return t.not(v);case"false":return t.has(v);default:return t.notEquals(v,_)}}case 5:return this._advance(),Z.create(v,this._value());case 6:return this._advance(),ae.create(v,this._value());case 7:return this._advance(),Y.create(v,this._value());case 8:return this._advance(),ce.create(v,this._value());case 13:return this._advance(),t.in(v,this._value());default:return t.has(v)}}case 20:throw this._parsingErrors.push({message:C,offset:s.offset,lexeme:"",additionalInfo:p}),w._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const s=this._peek();switch(s.type){case 17:case 18:return this._advance(),s.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(s){return s.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(s){return this._check(s)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(s,v){if(this._check(s))return this._advance();throw this._errExpectedButGot(v,this._peek())}_errExpectedButGot(s,v,F){const _=(0,A.localize)(8,null,s,L.Scanner.getLexeme(v)),B=v.offset,H=L.Scanner.getLexeme(v);return this._parsingErrors.push({message:_,offset:B,lexeme:H,additionalInfo:F}),w._parseError}_check(s){return this._peek().type===s}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=w;class t{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(s){return c.create(s)}static equals(s,v){return D.create(s,v)}static notEquals(s,v){return O.create(s,v)}static regex(s,v){return le.create(s,v)}static in(s,v){return P.create(s,v)}static notIn(s,v){return b.create(s,v)}static not(s){return j.create(s)}static and(...s){return $.create(s,null,!0)}static or(...s){return U.create(s,null,!0)}static greater(s,v){return Y.create(s,v)}static greaterEquals(s,v){return ce.create(s,v)}static smaller(s,v){return Z.create(s,v)}static smallerEquals(s,v){return ae.create(s,v)}static{this._parser=new w({regexParsingWithErrorRecovery:!1})}static deserialize(s){return s==null?void 0:this._parser.parse(s)}}e.ContextKeyExpr=t;function a(I){const s=new w({regexParsingWithErrorRecovery:!1});return I.map(v=>(s.parse(v),s.lexingErrors.length>0?s.lexingErrors.map(F=>({errorMessage:F.additionalInfo?(0,A.localize)(9,null,F.additionalInfo):(0,A.localize)(10,null),offset:F.offset,length:F.lexeme.length})):s.parsingErrors.length>0?s.parsingErrors.map(F=>({errorMessage:F.additionalInfo?`${F.message}. ${F.additionalInfo}`:F.message,offset:F.offset,length:F.lexeme.length})):[]))}e.validateWhenClauses=a;function i(I,s){const v=I?I.substituteConstants():void 0,F=s?s.substituteConstants():void 0;return!v&&!F?!0:!v||!F?!1:v.equals(F)}e.expressionsAreEqualWithConstantSubstitution=i;function r(I,s){return I.cmp(s)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}substituteConstants(){return this}evaluate(s){return!1}serialize(){return"false"}keys(){return[]}map(s){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=n;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}substituteConstants(){return this}evaluate(s){return!0}serialize(){return"true"}keys(){return[]}map(s){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=o;class c{static create(s,v=null){const F=u.get(s);return typeof F=="boolean"?F?o.INSTANCE:n.INSTANCE:new c(s,v)}constructor(s,v){this.key=s,this.negated=v,this.type=2}cmp(s){return s.type!==this.type?this.type-s.type:z(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}substituteConstants(){const s=u.get(this.key);return typeof s=="boolean"?s?o.INSTANCE:n.INSTANCE:this}evaluate(s){return!!s.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(s){return s.mapDefined(this.key)}negate(){return this.negated||(this.negated=j.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=c;class D{static create(s,v,F=null){if(typeof v=="boolean")return v?c.create(s,F):j.create(s,F);const _=u.get(s);return typeof _=="boolean"?v===(_?"true":"false")?o.INSTANCE:n.INSTANCE:new D(s,v,F)}constructor(s,v,F){this.key=s,this.value=v,this.negated=F,this.type=4}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){const s=u.get(this.key);if(typeof s=="boolean"){const v=s?"true":"false";return this.value===v?o.INSTANCE:n.INSTANCE}return this}evaluate(s){return s.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(s){return s.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=O.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=D;class P{static create(s,v){return new P(s,v)}constructor(s,v){this.key=s,this.valueKey=v,this.type=10,this.negated=null}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.valueKey,s.key,s.valueKey)}equals(s){return s.type===this.type?this.key===s.key&&this.valueKey===s.valueKey:!1}substituteConstants(){return this}evaluate(s){const v=s.getValue(this.valueKey),F=s.getValue(this.key);return Array.isArray(v)?v.includes(F):typeof F=="string"&&typeof v=="object"&&v!==null?S.call(v,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(s){return s.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=P;class b{static create(s,v){return new b(s,v)}constructor(s,v){this.key=s,this.valueKey=v,this.type=11,this._negated=P.create(s,v)}cmp(s){return s.type!==this.type?this.type-s.type:this._negated.cmp(s._negated)}equals(s){return s.type===this.type?this._negated.equals(s._negated):!1}substituteConstants(){return this}evaluate(s){return!this._negated.evaluate(s)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(s){return s.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=b;class O{static create(s,v,F=null){if(typeof v=="boolean")return v?j.create(s,F):c.create(s,F);const _=u.get(s);return typeof _=="boolean"?v===(_?"true":"false")?n.INSTANCE:o.INSTANCE:new O(s,v,F)}constructor(s,v,F){this.key=s,this.value=v,this.negated=F,this.type=5}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){const s=u.get(this.key);if(typeof s=="boolean"){const v=s?"true":"false";return this.value===v?n.INSTANCE:o.INSTANCE}return this}evaluate(s){return s.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(s){return s.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=O;class j{static create(s,v=null){const F=u.get(s);return typeof F=="boolean"?F?n.INSTANCE:o.INSTANCE:new j(s,v)}constructor(s,v){this.key=s,this.negated=v,this.type=3}cmp(s){return s.type!==this.type?this.type-s.type:z(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}substituteConstants(){const s=u.get(this.key);return typeof s=="boolean"?s?n.INSTANCE:o.INSTANCE:this}evaluate(s){return!s.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(s){return s.mapNot(this.key)}negate(){return this.negated||(this.negated=c.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=j;function ee(I,s){if(typeof I=="string"){const v=parseFloat(I);isNaN(v)||(I=v)}return typeof I=="string"||typeof I=="number"?s(I):n.INSTANCE}class Y{static create(s,v,F=null){return ee(v,_=>new Y(s,_,F))}constructor(s,v,F){this.key=s,this.value=v,this.negated=F,this.type=12}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){return this}evaluate(s){return typeof this.value=="string"?!1:parseFloat(s.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(s){return s.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ae.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=Y;class ce{static create(s,v,F=null){return ee(v,_=>new ce(s,_,F))}constructor(s,v,F){this.key=s,this.value=v,this.negated=F,this.type=13}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){return this}evaluate(s){return typeof this.value=="string"?!1:parseFloat(s.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(s){return s.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Z.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=ce;class Z{static create(s,v,F=null){return ee(v,_=>new Z(s,_,F))}constructor(s,v,F){this.key=s,this.value=v,this.negated=F,this.type=14}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){return this}evaluate(s){return typeof this.value=="string"?!1:parseFloat(s.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(s){return s.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=ce.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=Z;class ae{static create(s,v,F=null){return ee(v,_=>new ae(s,_,F))}constructor(s,v,F){this.key=s,this.value=v,this.negated=F,this.type=15}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){return this}evaluate(s){return typeof this.value=="string"?!1:parseFloat(s.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(s){return s.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Y.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ae;class le{static create(s,v){return new le(s,v)}constructor(s,v){this.key=s,this.regexp=v,this.type=7,this.negated=null}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.key<s.key)return-1;if(this.key>s.key)return 1;const v=this.regexp?this.regexp.source:"",F=s.regexp?s.regexp.source:"";return v<F?-1:v>F?1:0}equals(s){if(s.type===this.type){const v=this.regexp?this.regexp.source:"",F=s.regexp?s.regexp.source:"";return this.key===s.key&&v===F}return!1}substituteConstants(){return this}evaluate(s){const v=s.getValue(this.key);return this.regexp?this.regexp.test(v):!1}serialize(){const s=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${s}`}keys(){return[this.key]}map(s){return s.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=te.create(this)),this.negated}}e.ContextKeyRegexExpr=le;class te{static create(s){return new te(s)}constructor(s){this._actual=s,this.type=8}cmp(s){return s.type!==this.type?this.type-s.type:this._actual.cmp(s._actual)}equals(s){return s.type===this.type?this._actual.equals(s._actual):!1}substituteConstants(){return this}evaluate(s){return!this._actual.evaluate(s)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(s){return new te(this._actual.map(s))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=te;function V(I){let s=null;for(let v=0,F=I.length;v<F;v++){const _=I[v].substituteConstants();if(I[v]!==_&&s===null){s=[];for(let B=0;B<v;B++)s[B]=I[B]}s!==null&&(s[v]=_)}return s===null?I:s}class ${static create(s,v,F){return $._normalizeArr(s,v,F)}constructor(s,v){this.expr=s,this.negated=v,this.type=6}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let v=0,F=this.expr.length;v<F;v++){const _=r(this.expr[v],s.expr[v]);if(_!==0)return _}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let v=0,F=this.expr.length;v<F;v++)if(!this.expr[v].equals(s.expr[v]))return!1;return!0}return!1}substituteConstants(){const s=V(this.expr);return s===this.expr?this:$.create(s,this.negated,!1)}evaluate(s){for(let v=0,F=this.expr.length;v<F;v++)if(!this.expr[v].evaluate(s))return!1;return!0}static _normalizeArr(s,v,F){const _=[];let B=!1;for(const H of s)if(H){if(H.type===1){B=!0;continue}if(H.type===0)return n.INSTANCE;if(H.type===6){_.push(...H.expr);continue}_.push(H)}if(_.length===0&&B)return o.INSTANCE;if(_.length!==0){if(_.length===1)return _[0];_.sort(r);for(let H=1;H<_.length;H++)_[H-1].equals(_[H])&&(_.splice(H,1),H--);if(_.length===1)return _[0];for(;_.length>1;){const H=_[_.length-1];if(H.type!==9)break;_.pop();const ie=_.pop(),de=_.length===0,he=U.create(H.expr.map(ue=>$.create([ue,ie],null,F)),null,de);he&&(_.push(he),_.sort(r))}if(_.length===1)return _[0];if(F){for(let H=0;H<_.length;H++)for(let ie=H+1;ie<_.length;ie++)if(_[H].negate().equals(_[ie]))return n.INSTANCE;if(_.length===1)return _[0]}return new $(_,v)}}serialize(){return this.expr.map(s=>s.serialize()).join(" && ")}keys(){const s=[];for(const v of this.expr)s.push(...v.keys());return s}map(s){return new $(this.expr.map(v=>v.map(s)),null)}negate(){if(!this.negated){const s=[];for(const v of this.expr)s.push(v.negate());this.negated=U.create(s,this,!0)}return this.negated}}e.ContextKeyAndExpr=$;class U{static create(s,v,F){return U._normalizeArr(s,v,F)}constructor(s,v){this.expr=s,this.negated=v,this.type=9}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let v=0,F=this.expr.length;v<F;v++){const _=r(this.expr[v],s.expr[v]);if(_!==0)return _}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let v=0,F=this.expr.length;v<F;v++)if(!this.expr[v].equals(s.expr[v]))return!1;return!0}return!1}substituteConstants(){const s=V(this.expr);return s===this.expr?this:U.create(s,this.negated,!1)}evaluate(s){for(let v=0,F=this.expr.length;v<F;v++)if(this.expr[v].evaluate(s))return!0;return!1}static _normalizeArr(s,v,F){let _=[],B=!1;if(s){for(let H=0,ie=s.length;H<ie;H++){const de=s[H];if(de){if(de.type===0){B=!0;continue}if(de.type===1)return o.INSTANCE;if(de.type===9){_=_.concat(de.expr);continue}_.push(de)}}if(_.length===0&&B)return n.INSTANCE;_.sort(r)}if(_.length!==0){if(_.length===1)return _[0];for(let H=1;H<_.length;H++)_[H-1].equals(_[H])&&(_.splice(H,1),H--);if(_.length===1)return _[0];if(F){for(let H=0;H<_.length;H++)for(let ie=H+1;ie<_.length;ie++)if(_[H].negate().equals(_[ie]))return o.INSTANCE;if(_.length===1)return _[0]}return new U(_,v)}}serialize(){return this.expr.map(s=>s.serialize()).join(" || ")}keys(){const s=[];for(const v of this.expr)s.push(...v.keys());return s}map(s){return new U(this.expr.map(v=>v.map(s)),null)}negate(){if(!this.negated){const s=[];for(const v of this.expr)s.push(v.negate());for(;s.length>1;){const v=s.shift(),F=s.shift(),_=[];for(const B of oe(v))for(const H of oe(F))_.push($.create([B,H],null,!1));s.unshift(U.create(_,null,!1))}this.negated=U.create(s,this,!0)}return this.negated}}e.ContextKeyOrExpr=U;class M extends c{static{this._info=[]}static all(){return M._info.values()}constructor(s,v,F){super(s,null),this._defaultValue=v,typeof F=="object"?M._info.push({...F,key:s}):F!==!0&&M._info.push({key:s,description:F,type:v!=null?typeof v:void 0})}bindTo(s){return s.createKey(this.key,this._defaultValue)}getValue(s){return s.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(s){return D.create(this.key,s)}notEqualsTo(s){return O.create(this.key,s)}}e.RawContextKey=M,e.IContextKeyService=(0,N.createDecorator)("contextKeyService");function z(I,s){return I<s?-1:I>s?1:0}function G(I,s,v,F){return I<v?-1:I>v?1:s<F?-1:s>F?1:0}function K(I,s){if(I.type===0||s.type===1)return!0;if(I.type===9)return s.type===9?J(I.expr,s.expr):!1;if(s.type===9){for(const v of s.expr)if(K(I,v))return!0;return!1}if(I.type===6){if(s.type===6)return J(s.expr,I.expr);for(const v of I.expr)if(K(v,s))return!0;return!1}return I.equals(s)}e.implies=K;function J(I,s){let v=0,F=0;for(;v<I.length&&F<s.length;){const _=I[v].cmp(s[F]);if(_<0)return!1;_===0&&v++,F++}return v===I.length}function oe(I){return I.type===9?I.expr:[I]}}),define(ne[59],se([0,1,10]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,x.createDecorator)("downloadService")}),define(ne[18],se([0,1,10]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,x.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,x.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[21],se([0,1,92,10]),function(q,e,x,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function L(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=L;function N(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=N;function A(h,C){switch(h){case 3:return C==="x64"?"win32-x64":C==="ia32"?"win32-ia32":C==="arm64"?"win32-arm64":"unknown";case 2:return C==="x64"?"linux-x64":C==="arm64"?"linux-arm64":C==="arm"?"linux-armhf":C==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return C==="x64"?"alpine-x64":C==="arm64"?"alpine-arm64":"unknown";case 1:return C==="x64"?"darwin-x64":C==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function E(h,C){return C==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function u(h,C,p){return E(C,p)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===p?!0:l(p).includes(h)}e.isTargetPlatformCompatible=u;function l(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=l;function S(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=S;var k;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var g;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(g||(e.SortOrder=g={}));var f;(function(h){h.Install="install",h.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var R;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(R||(e.InstallOperation=R={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var y;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var m;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(m||(e.ExtensionSignaturetErrorCode=m={}));class d extends Error{constructor(C,p){super(C),this.code=p,this.name=p}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,x.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,x.localize)(1,null),original:"Preferences"}}),define(ne[60],se([0,1,10]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,x.createDecorator)("IExtensionSignatureVerificationService");class T{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((N,A)=>q(["node-vsce-sign"],async E=>N(E),A))),this.moduleLoadingPromise}async verify(N,A,E){let u;try{u=await this.vsceSign()}catch{return!1}return u.verify(N,A,E)}}e.ExtensionSignatureVerificationService=T}),define(ne[61],se([0,1,14,9,100,13]),function(q,e,x,T,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(S,k,g,f,R,y){let m;try{await E(S,k,g,f,R,y)}catch(d){m=d}finally{m&&R.errorTransformer&&(m=R.errorTransformer(m)),typeof m<"u"&&g.error(m),g.end()}}e.readFileIntoStream=A;async function E(S,k,g,f,R,y){u(y);const m=await S.open(k,{create:!1});try{u(y);let d=0,h=0,C=R&&typeof R.length=="number"?R.length:void 0,p=x.VSBuffer.alloc(Math.min(R.bufferSize,typeof C=="number"?C:R.bufferSize)),w=R&&typeof R.position=="number"?R.position:0,t=0;do h=await S.read(m,w,p.buffer,t,p.byteLength-t),w+=h,t+=h,d+=h,typeof C=="number"&&(C-=h),t===p.byteLength&&(await g.write(f(p)),p=x.VSBuffer.alloc(Math.min(R.bufferSize,typeof C=="number"?C:R.bufferSize)),t=0);while(h>0&&(typeof C!="number"||C>0)&&u(y)&&l(d,R));if(t>0){let a=t;typeof C=="number"&&(a=Math.min(t,C)),g.write(f(p.slice(0,a)))}}catch(d){throw(0,N.ensureFileSystemProviderError)(d)}finally{await S.close(m)}}function u(S){if(S.isCancellationRequested)throw(0,T.canceled)();return!0}function l(S,k){if(typeof k?.limits?.size=="number"&&S>k.limits.size)throw(0,N.createFileSystemProviderError)((0,L.localize)(0,null),N.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],se([0,1,4,166,2,12,167]),function(q,e,x,T,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class E extends L.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new x.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new x.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=x.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(l){const S=this.normalizeRequests(l),k=S.filter(f=>{const R=this.watchers.get(f.path);return R?!(0,T.patternsEquals)(R.request.excludes,f.excludes)||!(0,T.patternsEquals)(R.request.includes,f.includes):!0}),g=Array.from(this.watchers.values()).filter(({request:f})=>!S.find(R=>R.path===f.path&&(0,T.patternsEquals)(R.excludes,f.excludes)&&(0,T.patternsEquals)(R.includes,f.includes))).map(({request:f})=>f.path);k.length&&this.trace(`Request to start watching: ${k.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),g.length&&this.trace(`Request to stop watching: ${g.join(",")}`);for(const f of g)this.stopWatching(f);for(const f of k)this.startWatching(f)}startWatching(l){const S=new A.NodeJSFileWatcherLibrary(l,g=>this._onDidChangeFile.fire(g),g=>this._onDidLogMessage.fire(g),this.verboseLogging),k={request:l,instance:S};this.watchers.set(l.path,k)}async stop(){for(const[l]of this.watchers)this.stopWatching(l);this.watchers.clear()}stopWatching(l){const S=this.watchers.get(l);S&&(this.watchers.delete(l),S.instance.dispose())}normalizeRequests(l){const S=new Map;for(const k of l){const g=N.isLinux?k.path:k.path.toLowerCase();S.set(g,k)}return Array.from(S.values())}async setVerboseLogging(l){this.verboseLogging=l;for(const[,S]of this.watchers)S.instance.setVerboseLogging(l)}trace(l){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(l)})}toMessage(l,S){return S?`[File Watcher (node.js)] ${l} (path: ${S.request.path})`:`[File Watcher (node.js)] ${l}`}}e.NodeJSWatcher=E}),define(ne[118],se([0,1,62,117]),function(q,e,x,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends x.AbstractNonRecursiveWatcherClient{constructor(A,E,u){super(A,E,u),this.init()}createWatcher(){return new T.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(ne[119],se([0,1,15,57,85,62]),function(q,e,x,T,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends N.AbstractUniversalWatcherClient{constructor(u,l,S){super(u,l,S),this.init()}createWatcher(u){const l=u.add(new L.Client(x.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(l.onDidProcessExit(({code:S,signal:k})=>this.onError(`terminated by itself with code ${S}, signal: ${k}`))),T.ProxyChannel.toService((0,T.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ne[63],se([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class x{constructor(...L){this._entries=new Map;for(const[N,A]of L)this.set(N,A)}set(L,N){const A=this._entries.get(L);return this._entries.set(L,N),A}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=x}),define(ne[120],se([0,1,8,9,2,49,115,10,63,168]),function(q,e,x,T,L,N,A,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const S=!1;class k extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class g{constructor(m=new u.ServiceCollection,d=!1,h,C=S){this._services=m,this._strict=d,this._parent=h,this._enableTracing=C,this._activeInstantiations=new Set,this._services.set(E.IInstantiationService,this),this._globalGraph=C?h?._globalGraph??new A.Graph(p=>p):void 0}createChild(m){return new g(m,this._strict,this,this._enableTracing)}invokeFunction(m,...d){const h=R.traceInvocation(this._enableTracing,m);let C=!1;try{return m({get:w=>{if(C)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(w,h);if(!t)throw new Error(`[invokeFunction] unknown service '${w}'`);return t}},...d)}finally{C=!0,h.stop()}}createInstance(m,...d){let h,C;return m instanceof N.SyncDescriptor?(h=R.traceCreation(this._enableTracing,m.ctor),C=this._createInstance(m.ctor,m.staticArguments.concat(d),h)):(h=R.traceCreation(this._enableTracing,m),C=this._createInstance(m,d,h)),h.stop(),C}_createInstance(m,d=[],h){const C=E._util.getServiceDependencies(m).sort((t,a)=>t.index-a.index),p=[];for(const t of C){const a=this._getOrCreateServiceInstance(t.id,h);a||this._throwIfStrict(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(a)}const w=C.length>0?C[0].index:d.length;if(d.length!==w){console.trace(`[createInstance] First service dependency of ${m.name} at position ${w+1} conflicts with ${d.length} static arguments`);const t=w-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,w)}return Reflect.construct(m,d.concat(p))}_setServiceInstance(m,d){if(this._services.get(m)instanceof N.SyncDescriptor)this._services.set(m,d);else if(this._parent)this._parent._setServiceInstance(m,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(m){const d=this._services.get(m);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(m):d}_getOrCreateServiceInstance(m,d){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(m));const h=this._getServiceInstanceOrDescriptor(m);return h instanceof N.SyncDescriptor?this._safeCreateAndCacheServiceInstance(m,h,d.branch(m,!0)):(d.branch(m,!1),h)}_safeCreateAndCacheServiceInstance(m,d,h){if(this._activeInstantiations.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this._activeInstantiations.add(m);try{return this._createAndCacheServiceInstance(m,d,h)}finally{this._activeInstantiations.delete(m)}}_createAndCacheServiceInstance(m,d,h){const C=new A.Graph(t=>t.id.toString());let p=0;const w=[{id:m,desc:d,_trace:h}];for(;w.length;){const t=w.pop();if(C.lookupOrInsertNode(t),p++>1e3)throw new k(C);for(const a of E._util.getServiceDependencies(t.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(a.id);if(i||this._throwIfStrict(`[createInstance] ${m} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof N.SyncDescriptor){const r={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};C.insertEdge(t,r),w.push(r)}}}for(;;){const t=C.roots();if(t.length===0){if(!C.isEmpty())throw new k(C);break}for(const{data:a}of t){if(this._getServiceInstanceOrDescriptor(a.id)instanceof N.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}C.removeNode(a)}}return this._getServiceInstanceOrDescriptor(m)}_createServiceInstanceWithOwner(m,d,h=[],C,p){if(this._services.get(m)instanceof N.SyncDescriptor)return this._createServiceInstance(m,d,h,C,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(m,d,h,C,p);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(m,d,h=[],C,p){if(C){const w=new g(void 0,this._strict,this,this._enableTracing);w._globalGraphImplicitDependency=String(m);const t=new Map,a=new x.IdleValue(()=>{const i=w._createInstance(d,h,p);for(const[r,n]of t){const o=i[r];if(typeof o=="function")for(const c of n)o.apply(i,c)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,r){if(!a.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let c=t.get(r);return c||(c=new l.LinkedList,t.set(r,c)),(P,b,O)=>{const j=c.push([P,b,O]);return(0,L.toDisposable)(j)}}if(r in i)return i[r];const n=a.value;let o=n[r];return typeof o!="function"||(o=o.bind(n),i[r]=o),o},set(i,r,n){return a.value[r]=n,!0},getPrototypeOf(i){return d.prototype}})}else return this._createInstance(d,h,p)}_throwIfStrict(m,d){if(d&&console.warn(m),this._strict)throw new Error(m)}}e.InstantiationService=g;var f;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(f||(f={}));class R{static{this.all=new Set}static{this._None=new class extends R{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,d){return m?new R(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):R._None}static traceCreation(m,d){return m?new R(1,d.name):R._None}static{this._totals=0}constructor(m,d){this.type=m,this.name=d,this._start=Date.now(),this._dep=[]}branch(m,d){const h=new R(3,m.toString());return this._dep.push([m,d,h]),h}stop(){const m=Date.now()-this._start;R._totals+=m;let d=!1;function h(p,w){const t=[],a=new Array(p+1).join("	");for(const[i,r,n]of w._dep)if(r&&n){d=!0,t.push(`${a}CREATES -> ${i}`);const o=h(p+1,n);o&&t.push(o)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const C=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${R._totals.toFixed(2)}ms)`];(m>2||d)&&R.all.add(C.join(`
`))}}e.Trace=R});var re=this&&this.__param||function(q,e){return function(x,T){e(x,T,q)}};define(ne[64],se([0,1,20,2,12,102,21,10]),function(q,e,x,T,L,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function u(S){return S.tags.find(k=>k.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=u,e.ILanguagePackService=(0,E.createDecorator)("languagePackService");let l=class extends T.Disposable{constructor(k){super(),this.extensionGalleryService=k}async getAvailableLanguages(){const k=new x.CancellationTokenSource;setTimeout(()=>k.cancel(),1e3);let g;try{g=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},k.token)}catch{return[]}const R=g.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(m=>m.startsWith("lp-"))).map(y=>{const m=y.properties.localizedLanguages?.[0],d=u(y);return{...this.createQuickPickItem(d,m,y),extensionId:y.identifier.id,galleryExtension:y}});return R.push(this.createQuickPickItem("en","English")),R}createQuickPickItem(k,g,f){const R=g??k;let y;if(R!==k&&(y=`(${k})`),k.toLowerCase()===L.language.toLowerCase()&&(y??="",y+=(0,N.localize)(0,null)),f?.installCount){y??="";const m=f.installCount;let d;m>1e6?d=`${Math.floor(m/1e5)/10}M`:m>1e3?d=`${Math.floor(m/1e3)}K`:d=String(m),y+=` $(cloud-download) ${d}`}return{id:k,label:R,description:y}}};e.LanguagePackBaseService=l,e.LanguagePackBaseService=l=ve([re(0,A.IExtensionGalleryService)],l)}),define(ne[6],se([0,1,33,4,42,2,35,12,17,3,11,116,10]),function(q,e,x,T,L,N,A,E,u,l,S,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function f(){return new Date().toISOString()}function R(P){return(0,l.isNumber)(P)}e.isLogLevel=R;var y;(function(P){P[P.Off=0]="Off",P[P.Trace=1]="Trace",P[P.Debug=2]="Debug",P[P.Info=3]="Info",P[P.Warning=4]="Warning",P[P.Error=5]="Error"})(y||(e.LogLevel=y={})),e.DEFAULT_LOG_LEVEL=y.Info;function m(P,b,O){switch(b){case y.Trace:P.trace(O);break;case y.Debug:P.debug(O);break;case y.Info:P.info(O);break;case y.Warning:P.warn(O);break;case y.Error:P.error(O);break;case y.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=m;function d(P,b=!1){let O="";for(let j=0;j<P.length;j++){let ee=P[j];if(ee instanceof Error&&(ee=(0,x.toErrorMessage)(ee,b)),typeof ee=="object")try{ee=JSON.stringify(ee)}catch{}O+=(j>0?" ":"")+ee}return O}class h extends N.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(b){this.level!==b&&(this.level=b,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(b){return this.level!==y.Off&&this.level<=b}}e.AbstractLogger=h;class C extends h{constructor(b){super(),this.logAlways=b}checkLogLevel(b){return this.logAlways||super.checkLogLevel(b)}trace(b,...O){this.checkLogLevel(y.Trace)&&this.log(y.Trace,d([b,...O],!0))}debug(b,...O){this.checkLogLevel(y.Debug)&&this.log(y.Debug,d([b,...O]))}info(b,...O){this.checkLogLevel(y.Info)&&this.log(y.Info,d([b,...O]))}warn(b,...O){this.checkLogLevel(y.Warning)&&this.log(y.Warning,d([b,...O]))}error(b,...O){if(this.checkLogLevel(y.Error))if(b instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=b.stack,this.log(y.Error,d(j))}else this.log(y.Error,d([b,...O]))}flush(){}}e.AbstractMessageLogger=C;class p extends h{constructor(b=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(b),this.useColors=!E.isWindows}trace(b,...O){this.checkLogLevel(y.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,b,...O):console.log(`[main ${f()}]`,b,...O))}debug(b,...O){this.checkLogLevel(y.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,b,...O):console.log(`[main ${f()}]`,b,...O))}info(b,...O){this.checkLogLevel(y.Info)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,b,...O):console.log(`[main ${f()}]`,b,...O))}warn(b,...O){this.checkLogLevel(y.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,b,...O):console.warn(`[main ${f()}]`,b,...O))}error(b,...O){this.checkLogLevel(y.Error)&&(this.useColors?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,b,...O):console.error(`[main ${f()}]`,b,...O))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class w extends h{constructor(b=e.DEFAULT_LOG_LEVEL,O=!0){super(),this.useColors=O,this.setLevel(b)}trace(b,...O){this.checkLogLevel(y.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",b,...O):console.log(b,...O))}debug(b,...O){this.checkLogLevel(y.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",b,...O):console.log(b,...O))}info(b,...O){this.checkLogLevel(y.Info)&&(this.useColors?console.log("%c INFO","color: #33f",b,...O):console.log(b,...O))}warn(b,...O){this.checkLogLevel(y.Warning)&&(this.useColors?console.log("%c WARN","color: #993",b,...O):console.log(b,...O))}error(b,...O){this.checkLogLevel(y.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",b,...O):console.error(b,...O))}dispose(){}flush(){}}e.ConsoleLogger=w;class t extends h{constructor(b,O=e.DEFAULT_LOG_LEVEL){super(),this.adapter=b,this.setLevel(O)}trace(b,...O){this.checkLogLevel(y.Trace)&&this.adapter.log(y.Trace,[this.extractMessage(b),...O])}debug(b,...O){this.checkLogLevel(y.Debug)&&this.adapter.log(y.Debug,[this.extractMessage(b),...O])}info(b,...O){this.checkLogLevel(y.Info)&&this.adapter.log(y.Info,[this.extractMessage(b),...O])}warn(b,...O){this.checkLogLevel(y.Warning)&&this.adapter.log(y.Warning,[this.extractMessage(b),...O])}error(b,...O){this.checkLogLevel(y.Error)&&this.adapter.log(y.Error,[this.extractMessage(b),...O])}extractMessage(b){return typeof b=="string"?b:(0,x.toErrorMessage)(b,this.checkLogLevel(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class a extends h{constructor(b){super(),this.loggers=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const O of this.loggers)O.setLevel(b);super.setLevel(b)}trace(b,...O){for(const j of this.loggers)j.trace(b,...O)}debug(b,...O){for(const j of this.loggers)j.debug(b,...O)}info(b,...O){for(const j of this.loggers)j.info(b,...O)}warn(b,...O){for(const j of this.loggers)j.warn(b,...O)}error(b,...O){for(const j of this.loggers)j.error(b,...O)}flush(){for(const b of this.loggers)b.flush()}dispose(){for(const b of this.loggers)b.dispose()}}e.MultiplexLogger=a;class i extends N.Disposable{constructor(b,O,j){if(super(),this.logLevel=b,this.logsHome=O,this._loggers=new A.ResourceMap,this._onDidChangeLoggers=this._register(new T.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,j)for(const ee of j)this._loggers.set(ee.resource,{logger:void 0,info:ee})}getLoggerEntry(b){return(0,l.isString)(b)?[...this._loggers.values()].find(O=>O.info.id===b):this._loggers.get(b)}getLogger(b){return this.getLoggerEntry(b)?.logger}createLogger(b,O){const j=this.toResource(b),ee=(0,l.isString)(b)?b:O?.id??(0,L.hash)(j.toString()).toString(16);let Y=this._loggers.get(j)?.logger;const ce=O?.logLevel==="always"?y.Trace:O?.logLevel;Y||(Y=this.doCreateLogger(j,ce??this.getLogLevel(j)??this.logLevel,{...O,id:ee}));const Z={logger:Y,info:{resource:j,id:ee,logLevel:ce,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(Z.info),this._loggers.set(j,Z),Y}toResource(b){return(0,l.isString)(b)?(0,u.joinPath)(this.logsHome,`${b}.log`):b}setLogLevel(b,O){if(S.URI.isUri(b)){const j=b,ee=O,Y=this._loggers.get(j);Y&&ee!==Y.info.logLevel&&(Y.info.logLevel=ee===this.logLevel?void 0:ee,Y.logger?.setLevel(ee),this._loggers.set(Y.info.resource,Y),this._onDidChangeLogLevel.fire([j,ee]))}else{this.logLevel=b;for(const[j,ee]of this._loggers.entries())this._loggers.get(j)?.info.logLevel===void 0&&ee.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(b,O){const j=this.getLoggerEntry(b);j&&O!==!j.info.hidden&&(j.info.hidden=!O,this._loggers.set(j.info.resource,j),this._onDidChangeVisibility.fire([j.info.resource,O]))}getLogLevel(b){let O;return b&&(O=this._loggers.get(b)?.info.logLevel),O??this.logLevel}registerLogger(b){const O=this._loggers.get(b.resource);O?O.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this._loggers.set(b.resource,{info:b,logger:void 0}),this._onDidChangeLoggers.fire({added:[b],removed:[]}))}deregisterLogger(b){const O=this._loggers.get(b);O&&(O.logger&&O.logger.dispose(),this._loggers.delete(b),this._onDidChangeLoggers.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const b of this._loggers.values())yield b.info}getRegisteredLogger(b){return this._loggers.get(b)?.info}dispose(){this._loggers.forEach(b=>b.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=i;class r{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(b){}getLevel(){return y.Info}trace(b,...O){}debug(b,...O){}info(b,...O){}warn(b,...O){}error(b,...O){}critical(b,...O){}dispose(){}flush(){}}e.NullLogger=r;class n extends r{}e.NullLogService=n;function o(P){if(P.verbose)return y.Trace;if(typeof P.logLevel=="string"){const b=D(P.logLevel.toLowerCase());if(b!==void 0)return b}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function c(P){switch(P){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=c;function D(P){switch(P){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=D,e.CONTEXT_LOG_LEVEL=new k.RawContextKey("logLevel",c(y.Info))}),define(ne[121],se([0,1,19,8,9,4,2,16,62,6]),function(q,e,x,T,L,N,A,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class S extends A.Disposable{constructor(g,f){super(),this.logService=g,this.options=f,this._onDidChangeFile=this._register(new N.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new N.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new T.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new T.ThrottledDelayer(0))}watch(g,f){return f.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(g,f):this.watchNonRecursive(g,f)}watchUniversal(g,f){const R={path:this.toFilePath(g),excludes:f.excludes,includes:f.includes,recursive:f.recursive},y=(0,x.insert)(this.universalPathsToWatch,R);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(g=>(0,L.onUnexpectedError)(g))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(f=>this._onDidChangeFile.fire((0,u.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)})));const g=this.options?.watcher?.recursive?.usePolling;if(g===!0)for(const f of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const f of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(f)&&g.includes(f.path)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(g,f){const R={path:this.toFilePath(g),excludes:f.excludes,includes:f.includes,recursive:!1},y=(0,x.insert)(this.nonRecursivePathsToWatch,R);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(g=>(0,L.onUnexpectedError)(g))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(g=>this._onDidChangeFile.fire((0,u.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,E.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=S}),define(ne[122],se([0,1,19,8,14,20,4,42,65,2,46,15,123,17,41,99,13,61,6,9]),function(q,e,x,T,L,N,A,E,u,l,S,k,g,f,R,y,m,d,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let p=class extends l.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new T.ResourceQueue)}registerProvider(t,a){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${t}`);const i=new l.DisposableStore;return this.provider.set(t,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(r=>this._onDidFilesChange.fire(new m.FileChangesEvent(r,!this.isPathCaseSensitive(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),i.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:t}))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:a}),this.provider.delete(t),(0,l.dispose)(i)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(i){a.push(i)}}),!this.provider.has(t)&&await T.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,a){const i=this.provider.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return u.Iterable.map(this.provider,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async withProvider(t){if(!(0,f.isAbsolutePath)(t))throw new m.FileOperationError((0,y.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const a=this.provider.get(t.scheme);if(!a){const i=new C.ErrorNoTelemetry;throw i.message=(0,y.localize)(1,null,t.toString()),i}return a}async withReadProvider(t){const a=await this.withProvider(t);if((0,m.hasOpenReadWriteCloseCapability)(a)||(0,m.hasReadWriteCapability)(a)||(0,m.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const a=await this.withProvider(t);if((0,m.hasOpenReadWriteCloseCapability)(a)||(0,m.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.doResolveFile(t,a)}catch(i){throw(0,m.toFileSystemProviderErrorCode)(i)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,y.localize)(2,null,this.resourceForError(t)),1):(0,m.ensureFileSystemProviderError)(i)}}async doResolveFile(t,a){const i=await this.withProvider(t),r=this.isPathCaseSensitive(i),n=a?.resolveTo,o=a?.resolveSingleChildDescendants,c=a?.resolveMetadata,D=await i.stat(t);let P;return this.toFileStat(i,t,D,void 0,!!c,(b,O)=>(P||(P=S.TernarySearchTree.forUris(()=>!r),P.set(t,!0),n&&P.fill(!0,n)),P.get(b.resource)||P.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&o?O===1:!1))}async toFileStat(t,a,i,r,n,o){const{providerExtUri:c}=this.getExtUri(t),D={resource:a,name:c.basename(a),isFile:(i.type&m.FileType.File)!==0,isDirectory:(i.type&m.FileType.Directory)!==0,isSymbolicLink:(i.type&m.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&m.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((i.permissions??0)&m.FilePermission.Locked),etag:(0,m.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(D.isDirectory&&o(D,r)){try{const P=await t.readdir(a),b=await T.Promises.settled(P.map(async([O,j])=>{try{const ee=c.joinPath(a,O),Y=n?await t.stat(ee):{type:j};return await this.toFileStat(t,ee,Y,P.length,n,o)}catch(ee){return this.logService.trace(ee),null}}));D.children=(0,x.coalesce)(b)}catch(P){this.logService.trace(P),D.children=[]}return D}return D}async resolveAll(t){return T.Promises.settled(t.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.withProvider(t),i=await a.stat(t);return this.toFileStat(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.withProvider(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.doValidateCreateFile(t,a)}catch(i){return i}return!0}async doValidateCreateFile(t,a){if(!a?.overwrite&&await this.exists(t))throw new m.FileOperationError((0,y.localize)(3,null,this.resourceForError(t)),3,a)}async createFile(t,a=L.VSBuffer.fromString(""),i){await this.doValidateCreateFile(t,i);const r=await this.writeFile(t,a);return this._onDidRunOperation.fire(new m.FileOperationEvent(t,0,r)),r}async writeFile(t,a,i){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:n}=this.getExtUri(r);try{await this.validateWriteFile(r,t,i)||await this.mkdirp(r,n.dirname(t));let c;if((0,m.hasReadWriteCapability)(r)&&!(a instanceof L.VSBuffer))if((0,R.isReadableStream)(a)){const D=await(0,R.peekStream)(a,3);D.ended?c=L.VSBuffer.concat(D.buffer):c=D}else c=(0,R.peekReadable)(a,D=>L.VSBuffer.concat(D),3);else c=a;if(!(0,m.hasOpenReadWriteCloseCapability)(r)||(0,m.hasReadWriteCapability)(r)&&c instanceof L.VSBuffer)await this.doWriteUnbuffered(r,t,i,c);else{const D=c instanceof L.VSBuffer?(0,L.bufferToReadable)(c):c;i?.atomic!==!1&&i?.atomic?.postfix?await this.doWriteBufferedAtomic(r,t,(0,f.joinPath)((0,f.dirname)(t),`${(0,f.basename)(t)}${i.atomic.postfix}`),i,D):await this.doWriteBuffered(r,t,i,D)}this._onDidRunOperation.fire(new m.FileOperationEvent(t,4))}catch(o){throw new m.FileOperationError((0,y.localize)(4,null,this.resourceForError(t),(0,m.ensureFileSystemProviderError)(o).toString()),(0,m.toFileOperationResult)(o),i)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,a,i){const r=!!i?.unlock;if(r&&!(t.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(a)));if(!!i?.atomic){if(!(t.capabilities&32768))throw new Error((0,y.localize)(6,null,this.resourceForError(a)));if(r)throw new Error((0,y.localize)(7,null,this.resourceForError(a)))}let o;try{o=await t.stat(a)}catch{return}if(o.type&m.FileType.Directory)throw new m.FileOperationError((0,y.localize)(8,null,this.resourceForError(a)),0,i);if(this.throwIfFileIsReadonly(a,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==m.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,m.etag)({mtime:i.mtime,size:o.size}))throw new m.FileOperationError((0,y.localize)(9,null),3,i);return o}async readFile(t,a,i){const r=await this.withReadProvider(t);return a?.atomic?this.doReadFileAtomic(r,t,a,i):this.doReadFile(r,t,a,i)}async doReadFileAtomic(t,a,i,r){return new Promise((n,o)=>{this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(t,a,i,r);n(c)}catch(c){o(c)}})})}async doReadFile(t,a,i,r){const n=await this.doReadFileStream(t,a,{...i,preferUnbuffered:!0},r);return{...n,value:await(0,L.streamToBuffer)(n.value)}}async readFileStream(t,a,i){const r=await this.withReadProvider(t);return this.doReadFileStream(r,t,a,i)}async doReadFileStream(t,a,i,r){const n=new N.CancellationTokenSource(r),o=this.validateReadFile(a,i).then(D=>D,D=>{throw n.cancel(),D});let c;try{return typeof i?.etag=="string"&&i.etag!==m.ETAG_DISABLED&&await o,i?.atomic&&(0,m.hasFileAtomicReadCapability)(t)||!((0,m.hasOpenReadWriteCloseCapability)(t)||(0,m.hasFileReadStreamCapability)(t))||(0,m.hasReadWriteCapability)(t)&&i?.preferUnbuffered?c=this.readFileUnbuffered(t,a,i):(0,m.hasFileReadStreamCapability)(t)?c=this.readFileStreamed(t,a,n.token,i):c=this.readFileBuffered(t,a,n.token,i),{...await o,value:c}}catch(D){throw c&&await(0,R.consumeStream)(c),this.restoreReadError(D,a,i)}}restoreReadError(t,a,i){const r=(0,y.localize)(10,null,this.resourceForError(a),(0,m.ensureFileSystemProviderError)(t).toString());return t instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(r,t.stat,i):t instanceof m.TooLargeFileOperationError?new m.TooLargeFileOperationError(r,t.fileOperationResult,t.size,t.options):new m.FileOperationError(r,(0,m.toFileOperationResult)(t),i)}readFileStreamed(t,a,i,r=Object.create(null)){const n=t.readFileStream(a,r,i);return(0,R.transform)(n,{data:o=>o instanceof L.VSBuffer?o:L.VSBuffer.wrap(o),error:o=>this.restoreReadError(o,a,r)},o=>L.VSBuffer.concat(o))}readFileBuffered(t,a,i,r=Object.create(null)){const n=(0,L.newWriteableBufferStream)();return(0,d.readFileIntoStream)(t,a,n,o=>o,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>this.restoreReadError(o,a,r)},i),n}readFileUnbuffered(t,a,i){const r=(0,R.newWriteableStream)(n=>L.VSBuffer.concat(n));return(async()=>{try{let n;i?.atomic&&(0,m.hasFileAtomicReadCapability)(t)?n=await t.readFile(a,{atomic:!0}):n=await t.readFile(a),typeof i?.position=="number"&&(n=n.slice(i.position)),typeof i?.length=="number"&&(n=n.slice(0,i.length)),this.validateReadFileLimits(a,n.byteLength,i),r.end(L.VSBuffer.wrap(n))}catch(n){r.error(n),r.end()}})(),r}async validateReadFile(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new m.FileOperationError((0,y.localize)(11,null,this.resourceForError(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==m.ETAG_DISABLED&&a.etag===i.etag)throw new m.NotModifiedSinceFileOperationError((0,y.localize)(12,null),i,a);return this.validateReadFileLimits(t,i.size,a),i}validateReadFileLimits(t,a,i){if(typeof i?.limits?.size=="number"&&a>i.limits.size)throw new m.TooLargeFileOperationError((0,y.localize)(13,null,this.resourceForError(t)),7,a,i)}async canMove(t,a,i){return this.doCanMoveCopy(t,a,"move",i)}async canCopy(t,a,i){return this.doCanMoveCopy(t,a,"copy",i)}async doCanMoveCopy(t,a,i,r){if(t.toString()!==a.toString())try{const n=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(n,t,o,a,i,r)}catch(n){return n}return!0}async move(t,a,i){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),o=await this.doMoveCopy(r,t,n,a,"move",!!i),c=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(t,o==="move"?2:3,c)),c}async copy(t,a,i){const r=await this.withReadProvider(t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),o=await this.doMoveCopy(r,t,n,a,"copy",!!i),c=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(t,o==="copy"?3:2,c)),c}async doMoveCopy(t,a,i,r,n,o){if(a.toString()===r.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:D}=await this.doValidateMoveCopy(t,a,i,r,n,o);if(c&&!D&&o&&await this.del(r,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(r)),n==="copy"){if(t===i&&(0,m.hasFileFolderCopyCapability)(t))await t.copy(a,r,{overwrite:o});else{const P=await this.resolve(a);P.isDirectory?await this.doCopyFolder(t,P,i,r):await this.doCopyFile(t,a,i,r)}return n}else return t===i?(await t.rename(a,r,{overwrite:o}),n):(await this.doMoveCopy(t,a,i,r,"copy",o),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(t,a,i,r){if((0,m.hasOpenReadWriteCloseCapability)(t)&&(0,m.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(t,a,i,r);if((0,m.hasOpenReadWriteCloseCapability)(t)&&(0,m.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(t,a,i,r);if((0,m.hasReadWriteCapability)(t)&&(0,m.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(t,a,i,r);if((0,m.hasReadWriteCapability)(t)&&(0,m.hasReadWriteCapability)(i))return this.doPipeUnbuffered(t,a,i,r)}async doCopyFolder(t,a,i,r){await i.mkdir(r),Array.isArray(a.children)&&await T.Promises.settled(a.children.map(async n=>{const o=this.getExtUri(i).providerExtUri.joinPath(r,n.name);return n.isDirectory?this.doCopyFolder(t,await this.resolve(n.resource),i,o):this.doCopyFile(t,n.resource,i,o)}))}async doValidateMoveCopy(t,a,i,r,n,o){let c=!1;if(t===i){const{providerExtUri:P,isPathCaseSensitive:b}=this.getExtUri(t);if(b||(c=P.isEqual(a,r)),c&&n==="copy")throw new Error((0,y.localize)(14,null,this.resourceForError(a),this.resourceForError(r)));if(!c&&P.isEqualOrParent(r,a))throw new Error((0,y.localize)(15,null,this.resourceForError(a),this.resourceForError(r)))}const D=await this.exists(r);if(D&&!c){if(!o)throw new m.FileOperationError((0,y.localize)(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(t===i){const{providerExtUri:P}=this.getExtUri(t);if(P.isEqualOrParent(a,r))throw new Error((0,y.localize)(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:D,isSameResourceWithDifferentPathCase:c}}getExtUri(t){const a=this.isPathCaseSensitive(t);return{providerExtUri:a?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(t,0,i)),i}async mkdirp(t,a){const i=[],{providerExtUri:r}=this.getExtUri(t);for(;!r.isEqual(a,r.dirname(a));)try{if(!((await t.stat(a)).type&m.FileType.Directory))throw new Error((0,y.localize)(18,null,this.resourceForError(a)));break}catch(n){if((0,m.toFileSystemProviderErrorCode)(n)!==m.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(r.basename(a)),a=r.dirname(a)}for(let n=i.length-1;n>=0;n--){a=r.joinPath(a,i[n]);try{await t.mkdir(a)}catch(o){if((0,m.toFileSystemProviderErrorCode)(o)!==m.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,a){try{await this.doValidateDelete(t,a)}catch(i){return i}return!0}async doValidateDelete(t,a){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t),r=!!a?.useTrash;if(r&&!(i.capabilities&4096))throw new Error((0,y.localize)(19,null,this.resourceForError(t)));const n=a?.atomic;if(n&&!(i.capabilities&65536))throw new Error((0,y.localize)(20,null,this.resourceForError(t)));if(r&&n)throw new Error((0,y.localize)(21,null,this.resourceForError(t)));let o;try{o=await i.stat(t)}catch{}if(o)this.throwIfFileIsReadonly(t,o);else throw new m.FileOperationError((0,y.localize)(22,null,this.resourceForError(t)),1);if(!!!a?.recursive){const D=await this.resolve(t);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,y.localize)(23,null,this.resourceForError(t)))}return i}async del(t,a){const i=await this.doValidateDelete(t,a),r=!!a?.useTrash,n=!!a?.recursive,o=a?.atomic??!1;await i.delete(t,{recursive:n,useTrash:r,atomic:o}),this._onDidRunOperation.fire(new m.FileOperationEvent(t,1))}async cloneFile(t,a){const i=await this.withProvider(t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);if(i===r&&this.getExtUri(i).providerExtUri.isEqual(t,a))return;if(i===r&&(0,m.hasFileCloneCapability)(i))return i.cloneFile(t,a);await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(a));const n=this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri);return i===r&&(0,m.hasFileFolderCopyCapability)(i)?n.queue(()=>i.copy(t,a,{overwrite:!0})):n.queue(()=>this.doCopyFile(i,t,r,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new l.DisposableStore;let r=!1,n=()=>{r=!0};return i.add((0,l.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(t,a);r?(0,l.dispose)(o):n=()=>(0,l.dispose)(o)}catch(o){this.logService.error(o)}})(),i}async doWatch(t,a){const i=await this.withProvider(t),r=(0,E.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(t),a]);let n=this.activeWatchers.get(r);return n||(n={count:0,disposable:i.watch(t,a)},this.activeWatchers.set(r,n)),n.count+=1,(0,l.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,l.dispose)(n.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,l.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBufferedAtomic(t,a,i,r,n){await this.doWriteBuffered(t,i,r,n);try{await t.rename(i,a,{overwrite:!0})}catch(o){try{await t.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}async doWriteBuffered(t,a,i,r){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(async()=>{const n=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,R.isReadableStream)(r)||(0,R.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(t,n,r):await this.doWriteReadableBufferedQueued(t,n,r)}catch(o){throw(0,m.ensureFileSystemProviderError)(o)}finally{await t.close(n)}})}async doWriteStreamBufferedQueued(t,a,i){let r=0,n;if((0,R.isReadableBufferedStream)(i)){if(i.buffer.length>0){const o=L.VSBuffer.concat(i.buffer);await this.doWriteBuffer(t,a,o,o.byteLength,r,0),r+=o.byteLength}if(i.ended)return;n=i.stream}else n=i;return new Promise((o,c)=>{(0,R.listenStream)(n,{onData:async D=>{n.pause();try{await this.doWriteBuffer(t,a,D,D.byteLength,r,0)}catch(P){return c(P)}r+=D.byteLength,setTimeout(()=>n.resume())},onError:D=>c(D),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(t,a,i){let r=0,n;for(;(n=i.read())!==null;)await this.doWriteBuffer(t,a,n,n.byteLength,r,0),r+=n.byteLength}async doWriteBuffer(t,a,i,r,n,o){let c=0;for(;c<r;){const D=await t.write(a,n+c,i.buffer,o+c,r-c);c+=D}}async doWriteUnbuffered(t,a,i,r){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,a,i,r))}async doWriteUnbufferedQueued(t,a,i,r){let n;r instanceof L.VSBuffer?n=r:(0,R.isReadableStream)(r)?n=await(0,L.streamToBuffer)(r):(0,R.isReadableBufferedStream)(r)?n=await(0,L.bufferedStreamToBuffer)(r):n=(0,L.readableToBuffer)(r),await t.writeFile(a,n.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async doPipeBuffered(t,a,i,r){return this.writeQueue.queueFor(r,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,a,i,r))}async doPipeBufferedQueued(t,a,i,r){let n,o;try{n=await t.open(a,{create:!1}),o=await i.open(r,{create:!0,unlock:!1});const c=L.VSBuffer.alloc(this.BUFFER_SIZE);let D=0,P=0,b=0;do b=await t.read(n,D,c.buffer,P,c.byteLength-P),await this.doWriteBuffer(i,o,c,b,D,P),D+=b,P+=b,P===c.byteLength&&(P=0);while(b>0)}catch(c){throw(0,m.ensureFileSystemProviderError)(c)}finally{await T.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async doPipeUnbuffered(t,a,i,r){return this.writeQueue.queueFor(r,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,a,i,r))}async doPipeUnbufferedQueued(t,a,i,r){return i.writeFile(r,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(t,a,i,r){return this.writeQueue.queueFor(r,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,a,i,r))}async doPipeUnbufferedToBufferedQueued(t,a,i,r){const n=await i.open(r,{create:!0,unlock:!1});try{const o=await t.readFile(a);await this.doWriteBuffer(i,n,L.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,m.ensureFileSystemProviderError)(o)}finally{await i.close(n)}}async doPipeBufferedToUnbuffered(t,a,i,r){const n=await(0,L.streamToBuffer)(this.readFileBuffered(t,a,N.CancellationToken.None));await this.doWriteUnbuffered(i,r,void 0,n)}throwIfFileSystemIsReadonly(t,a){if(t.capabilities&2048)throw new m.FileOperationError((0,y.localize)(24,null,this.resourceForError(a)),6);return t}throwIfFileIsReadonly(t,a){if((a.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,y.localize)(25,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===k.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=p,e.FileService=p=ve([re(0,h.ILogService)],p)}),define(ne[124],se([0,1,125,169,8,35,14,4,170,2,16,12,17,41,24,101,13,61,121,33,119,118]),function(q,e,x,T,L,N,A,E,u,l,S,k,g,f,R,y,m,d,h,C,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,T.gracefulify)(x)}catch(a){console.error(`Error enabling graceful-fs: ${(0,C.toErrorMessage)(a)}`)}})();class t extends h.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(i,r){super(i,r),this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new N.ResourceMap(n=>g.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:r,symbolicLink:n}=await R.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(r,n),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:m.FilePermission.Locked}}catch(r){throw this.toFileSystemProviderError(r)}}async statIgnoreError(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const r=await R.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),n=[];return await Promise.all(r.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,g.joinPath)(i,o.name))).type:c=this.toType(o),n.push([o.name,c])}catch(c){this.logService.trace(c)}})),n}catch(r){throw this.toFileSystemProviderError(r)}}toType(i,r){let n;return r?.dangling?n=m.FileType.Unknown:i.isFile()?n=m.FileType.File:i.isDirectory()?n=m.FileType.Directory:n=m.FileType.Unknown,r&&(n|=m.FileType.SymbolicLink),n}async createResourceLock(i){const r=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let n;for(;n=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await n.wait();const o=new L.Barrier;return this.resourceLocks.set(i,o),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,l.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(i)===o&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),o.open()})}async readFile(i,r){let n;try{r?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),n=await this.createResourceLock(i));const o=this.toFilePath(i);return await R.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{n?.dispose()}}traceLock(i){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,r,n){const o=(0,f.newWriteableStream)(c=>A.VSBuffer.concat(c.map(D=>A.VSBuffer.wrap(D))).buffer);return(0,d.readFileIntoStream)(this,i,o,c=>c.buffer,{...r,bufferSize:256*1024},n),o}async writeFile(i,r,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.doWriteFileAtomic(i,(0,g.joinPath)((0,g.dirname)(i),`${(0,g.basename)(i)}${n.atomic.postfix}`),r,n):this.doWriteFile(i,r,n)}async doWriteFileAtomic(i,r,n,o){await this.doWriteFile(r,n,o);try{await this.rename(r,i,{overwrite:!0})}catch(c){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}async doWriteFile(i,r,n){let o;try{const c=this.toFilePath(i);if(!n.create||!n.overwrite){if(await R.Promises.exists(c)){if(!n.overwrite)throw(0,m.createFileSystemProviderError)((0,y.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,m.createFileSystemProviderError)((0,y.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:n.unlock}),await this.write(o,0,r,0,r.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(i,c)}finally{typeof o=="number"&&await this.close(o)}}static{this.canFlush=!0}static configureFlushOnWrite(i){t.canFlush=i}async open(i,r){const n=this.toFilePath(i);let o;(0,m.isFileOpenForWriteOptions)(r)&&(o=await this.createResourceLock(i));let c;try{if((0,m.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:P}=await R.SymlinkSupport.stat(n);P.mode&128||await R.Promises.chmod(n,P.mode|128)}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}let D;if((0,m.isFileOpenForWriteOptions)(r)){if(k.isWindows)try{await R.Promises.truncate(n,0),D="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}D||(D="w")}else D="r";c=await R.Promises.open(n,D)}catch(D){throw o?.dispose(),(0,m.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(i,D):this.toFileSystemProviderError(D)}if(this.mapHandleToPos.set(c,0),(0,m.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(c,i),o){const D=this.mapHandleToLock.get(c);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${n})`),this.mapHandleToLock.set(c,o),D&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${n})`),D.dispose())}return c}async close(i){const r=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&t.canFlush)try{await R.Promises.fdatasync(i)}catch(n){t.configureFlushOnWrite(!1),this.logService.error(n)}return await R.Promises.close(i)}catch(n){throw this.toFileSystemProviderError(n)}finally{r&&(this.mapHandleToLock.get(i)===r&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),r.dispose())}}async read(i,r,n,o,c){const D=this.normalizePos(i,r);let P=null;try{P=(await R.Promises.read(i,n,o,c,D)).bytesRead}catch(b){throw this.toFileSystemProviderError(b)}finally{this.updatePos(i,D,P)}return P}normalizePos(i,r){return r===this.mapHandleToPos.get(i)?null:r}updatePos(i,r,n){const o=this.mapHandleToPos.get(i);typeof o=="number"&&(typeof r=="number"||(typeof n=="number"?this.mapHandleToPos.set(i,o+n):this.mapHandleToPos.delete(i)))}async write(i,r,n,o,c){return(0,L.retry)(()=>this.doWrite(i,r,n,o,c),100,3)}async doWrite(i,r,n,o,c){const D=this.normalizePos(i,r);let P=null;try{P=(await R.Promises.write(i,n,o,c,D)).bytesWritten}catch(b){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),b)}finally{this.updatePos(i,D,P)}return P}async mkdir(i){try{await R.Promises.mkdir(this.toFilePath(i))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(i,r){try{const n=this.toFilePath(i);if(r.recursive){let o;r?.atomic!==!1&&r.atomic.postfix&&(o=(0,S.join)((0,S.dirname)(n),`${(0,S.basename)(n)}${r.atomic.postfix}`)),await R.Promises.rm(n,R.RimRafMode.MOVE,o)}else try{await R.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let c=!1;try{const{stat:D,symbolicLink:P}=await R.SymlinkSupport.stat(n);c=D.isDirectory()&&!P}catch{}if(c)await R.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(i,r,n){const o=this.toFilePath(i),c=this.toFilePath(r);if(o!==c)try{await this.validateMoveCopy(i,r,"move",n.overwrite),await R.Promises.move(o,c)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,y.localize)(2,null,(0,S.basename)(o),(0,S.basename)((0,S.dirname)(c)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(i,r,n){const o=this.toFilePath(i),c=this.toFilePath(r);if(o!==c)try{await this.validateMoveCopy(i,r,"copy",n.overwrite),await R.Promises.copy(o,c,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,y.localize)(3,null,(0,S.basename)(o),(0,S.basename)((0,S.dirname)(c)),D.toString()))),this.toFileSystemProviderError(D)}}async validateMoveCopy(i,r,n,o){const c=this.toFilePath(i),D=this.toFilePath(r);let P=!1;if(!!(this.capabilities&1024)||(P=(0,u.isEqual)(c,D,!0)),P){if(n==="copy")throw(0,m.createFileSystemProviderError)((0,y.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const O=await this.statIgnoreError(i);if(!O)throw(0,m.createFileSystemProviderError)((0,y.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const j=await this.statIgnoreError(r);if(j){if(!o)throw(0,m.createFileSystemProviderError)((0,y.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);O.type&m.FileType.File&&j.type&m.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,r){return this.doCloneFile(i,r,!1)}async doCloneFile(i,r,n){const o=this.toFilePath(i),c=this.toFilePath(r),D=!!(this.capabilities&1024);if((0,u.isEqual)(o,c,!D))return;const P=new l.DisposableStore;try{const[b,O]=await Promise.all([this.createResourceLock(i),this.createResourceLock(r)]);P.add(b),P.add(O),n&&await R.Promises.mkdir((0,S.dirname)(c),{recursive:!0}),await R.Promises.copyFile(o,c)}catch(b){if(b.code==="ENOENT"&&!n)return this.doCloneFile(i,r,!0);throw this.toFileSystemProviderError(b)}finally{P.dispose()}}createUniversalWatcher(i,r,n){return new p.UniversalWatcherClient(o=>i(o),o=>r(o),n)}createNonRecursiveWatcher(i,r,n){return new w.NodeJSWatcherClient(o=>i(o),o=>r(o),n)}toFileSystemProviderError(i){if(i instanceof m.FileSystemProviderError)return i;let r=i,n;switch(i.code){case"ENOENT":n=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=m.FileSystemProviderErrorCode.Unknown;break;default:n=m.FileSystemProviderErrorCode.Unknown}return(0,m.createFileSystemProviderError)(r,n)}async toFileSystemProviderWriteError(i,r){let n=this.toFileSystemProviderError(r);if(i&&n.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await R.SymlinkSupport.stat(this.toFilePath(i));o.mode&128||(n=(0,m.createFileSystemProviderError)(r,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return n}}e.DiskFileSystemProvider=t}),define(ne[126],se([0,1,2,6]),function(q,e,x,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class L extends x.Disposable{constructor(A,E=[]){super(),this.logger=new T.MultiplexLogger([A,...E]),this._register(A.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(A){this.logger.setLevel(A)}getLevel(){return this.logger.getLevel()}trace(A,...E){this.logger.trace(A,...E)}debug(A,...E){this.logger.debug(A,...E)}info(A,...E){this.logger.info(A,...E)}warn(A,...E){this.logger.warn(A,...E)}error(A,...E){this.logger.error(A,...E)}flush(){this.logger.flush()}}e.LogService=L}),define(ne[127],se([0,1,13,6]),function(q,e,x,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var L;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(L||(L={}));async function N(l,S,k,g,f){try{const R=await new Promise((m,d)=>{q(["@vscode/spdlog"],m,d)});R.setFlushOn(L.Trace);const y=await R.createAsyncRotatingLogger(l,S,k,g);return f?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(R){console.error(R)}return null}function A(l,S,k){switch(S){case T.LogLevel.Trace:l.trace(k);break;case T.LogLevel.Debug:l.debug(k);break;case T.LogLevel.Info:l.info(k);break;case T.LogLevel.Warning:l.warn(k);break;case T.LogLevel.Error:l.error(k);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function E(l,S){switch(S){case T.LogLevel.Trace:l.setLevel(L.Trace);break;case T.LogLevel.Debug:l.setLevel(L.Debug);break;case T.LogLevel.Info:l.setLevel(L.Info);break;case T.LogLevel.Warning:l.setLevel(L.Warning);break;case T.LogLevel.Error:l.setLevel(L.Error);break;case T.LogLevel.Off:l.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${S}`)}}class u extends T.AbstractMessageLogger{constructor(S,k,g,f,R){super(),this.buffer=[],this.setLevel(R),this._loggerCreationPromise=this._createSpdLogLogger(S,k,g,f),this._register(this.onDidChangeLogLevel(y=>{this._logger&&E(this._logger,y)}))}async _createSpdLogLogger(S,k,g,f){const R=g?6:1,y=30/R*x.ByteSize.MB,m=await N(S,k,y,R,f);if(m){this._logger=m,E(this._logger,this.getLevel());for(const{level:d,message:h}of this.buffer)A(this._logger,d,h);this.buffer=[]}}log(S,k){this._logger?A(this._logger,S,k):this.getLevel()<=S&&this.buffer.push({level:S,message:k})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=u}),define(ne[128],se([0,1,29,6,127]),function(q,e,x,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class N extends T.AbstractLoggerService{doCreateLogger(E,u,l){return new L.SpdLogLogger((0,x.generateUuid)(),E.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,u)}}e.LoggerService=N}),define(ne[38],se([0,1,4,65,2,10]),function(q,e,x,T,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,N.createDecorator)("policy");class A extends L.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new x.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(l){const S=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...l,...this.policyDefinitions},S!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(l),T.Iterable.reduce(this.policies.entries(),(k,[g,f])=>({...k,[g]:f}),{})}getPolicyValue(l){return this.policies.get(l)}serialize(){return T.Iterable.reduce(Object.entries(this.policyDefinitions),(l,[S,k])=>({...l,[S]:{definition:k,value:this.policies.get(S)}}),{})}}e.AbstractPolicyService=A;class E{constructor(){this.onDidChange=x.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=E}),define(ne[129],se([0,1,8,4,65,3,13,6,38]),function(q,e,x,T,L,N,A,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(k,g){const f=[];for(const R of new Set(L.Iterable.concat(k.keys(),g.keys())))k.get(R)!==g.get(R)&&f.push(R);return f}let S=class extends u.AbstractPolicyService{constructor(g,f,R){super(),this.file=g,this.fileService=f,this.logService=R,this.throttledDelayer=this._register(new x.ThrottledDelayer(500));const y=T.Event.filter(f.onDidFilesChange,m=>m.affects(g));this._register(f.watch(g)),this._register(y(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const g=new Map;try{const f=await this.fileService.readFile(this.file),R=JSON.parse(f.value.toString());if(!(0,N.isObject)(R))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(R))this.policyDefinitions[y]&&g.set(y,R[y])}catch(f){f.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",f)}return g}async refresh(){const g=await this.read(),f=l(this.policies,g);this.policies=g,f.length>0&&this._onDidChange.fire(f)}};e.FilePolicyService=S,e.FilePolicyService=S=ve([re(1,A.IFileService),re(2,E.ILogService)],S)}),define(ne[130],se([0,1,38,8,171,2,6]),function(q,e,x,T,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let E=class extends x.AbstractPolicyService{constructor(l,S){super(),this.logService=l,this.productName=S,this.throttler=new T.Throttler,this.watcher=this._register(new N.MutableDisposable)}async _updatePolicyDefinitions(l){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.throttler.queue(()=>new Promise((S,k)=>{try{this.watcher.value=(0,L.createWatcher)(this.productName,l,g=>{this._onDidPolicyChange(g),S()})}catch(g){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),k(g)}}))}_onDidPolicyChange(l){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const S in l){const k=l[S];k===void 0?this.policies.delete(S):this.policies.set(S,k)}this._onDidChange.fire(Object.keys(l))}};e.NativePolicyService=E,e.NativePolicyService=E=ve([re(0,A.ILogService)],E)}),define(ne[31],se([0,1,10]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,x.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[36],se([0,1,71,3]),function(q,e,x,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(A,E){x.ok(T.isString(A)),x.ok(T.isObject(E)),x.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,E)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new L}),define(ne[131],se([0,1,4,36]),function(q,e,x,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class N{constructor(){this._onDidChangeSchema=new x.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,l){this.schemasById[L(u)]=l,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new N;T.Registry.add(e.Extensions.JSONContribution,A)}),define(ne[44],se([0,1,19,4,3,88,25,131,36]),function(q,e,x,T,L,N,A,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var l;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S||(e.ConfigurationScope=S={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=u.Registry.as(E.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.doRegisterConfigurations(t,a,i),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.doDeregisterConfigurations(t,a),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.doDeregisterConfigurations(a,i),this.doRegisterConfigurations(t,!1,i),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.doRegisterDefaultConfigurations(t,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,a){const i=[];for(const{overrides:r,source:n}of t)for(const o in r)if(a.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const c=this.configurationDefaultsOverrides.get(o),D=c?.valuesSources??new Map;if(n)for(const j of Object.keys(r[o]))D.set(j,n);const P={...c?.value||{},...r[o]};this.configurationDefaultsOverrides.set(o,{source:n,value:P,valuesSources:D});const b=(0,A.getLanguageTagSettingPlainKey)(o),O={type:"object",default:P,description:N.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:P,source:L.isString(n)?void 0:n,defaultValueSource:n};i.push(...y(o)),this.configurationProperties[o]=O,this.defaultLanguageConfigurationOverridesNode.properties[o]=O}else{this.configurationDefaultsOverrides.set(o,{value:r[o],source:n});const c=this.configurationProperties[o];c&&(this.updatePropertyDefaultValue(o,c),this.updateSchema(o,c))}this.doRegisterOverrideIdentifiers(i)}deregisterDefaultConfigurations(t){const a=new Set;this.doDeregisterDefaultConfigurations(t,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,a){for(const{overrides:i,source:r}of t)for(const n in i){const o=this.configurationDefaultsOverrides.get(n),c=L.isString(r)?r:r?.id,D=L.isString(o?.source)?o?.source:o?.source?.id;if(c===D)if(a.add(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const P=this.configurationProperties[n];P&&(this.updatePropertyDefaultValue(n,P),this.updateSchema(n,P))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,i),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const a of t)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,a,i){t.forEach(r=>{this.validateAndRegisterProperties(r,a,r.extensionInfo,r.restrictedProperties,void 0,i),this.configurationContributors.push(r),this.registerJSONConfiguration(r)})}doDeregisterConfigurations(t,a){const i=r=>{if(r.properties)for(const n in r.properties){a.add(n);const o=this.configurationProperties[n];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,r.properties[n])}r.allOf?.forEach(n=>i(n))};for(const r of t){i(r);const n=this.configurationContributors.indexOf(r);n!==-1&&this.configurationContributors.splice(n,1)}}validateAndRegisterProperties(t,a=!0,i,r,n=3,o){n=L.isUndefinedOrNull(t.scope)?n:t.scope;const c=t.properties;if(c)for(const P in c){const b=c[P];if(a&&C(P,b)){delete c[P];continue}if(b.source=i,b.defaultDefaultValue=c[P].default,this.updatePropertyDefaultValue(P,b),e.OVERRIDE_PROPERTY_REGEX.test(P)?b.scope=void 0:(b.scope=L.isUndefinedOrNull(b.scope)?n:b.scope,b.restricted=L.isUndefinedOrNull(b.restricted)?!!r?.includes(P):b.restricted),c[P].hasOwnProperty("included")&&!c[P].included){this.excludedConfigurationProperties[P]=c[P],delete c[P];continue}else this.configurationProperties[P]=c[P],c[P].policy?.name&&this.policyConfigurations.set(c[P].policy.name,P);!c[P].deprecationMessage&&c[P].markdownDeprecationMessage&&(c[P].deprecationMessage=c[P].markdownDeprecationMessage),o.add(P)}const D=t.allOf;if(D)for(const P of D)this.validateAndRegisterProperties(P,a,i,r,n,o)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const a=i=>{const r=i.properties;if(r)for(const o in r)this.updateSchema(o,r[o]);i.allOf?.forEach(a)};a(t)}updateSchema(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.resourceLanguageSettingsSchema.properties[t]=a;break}}removeFromSchema(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const a=`[${t}]`,i={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,i),e.allSettings.properties[a]=i,e.applicationSettings.properties[a]=i,e.machineSettings.properties[a]=i,e.machineOverridableSettings.properties[a]=i,e.windowSettings.properties[a]=i,e.resourceSettings.properties[a]=i}}registerOverridePropertyPatternKey(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,a){const i=this.configurationDefaultsOverrides.get(t);let r=i?.value,n=i?.source;L.isUndefined(r)&&(r=a.defaultDefaultValue,n=void 0),L.isUndefined(r)&&(r=d(a.type)),a.default=r,a.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",R=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(w){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let a=R.exec(w);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=R.exec(w)}}return(0,x.distinct)(t)}e.overrideIdentifiersFromKey=y;function m(w){return w.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=m;function d(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const h=new g;u.Registry.add(e.Extensions.Configuration,h);function C(w,t){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?N.localize(7,null,w):h.getConfigurationProperties()[w]!==void 0?N.localize(8,null,w):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,w,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}e.validateProperty=C;function p(){const w=[],t=h.getConfigurationProperties();for(const a of Object.keys(t))w.push([a,t[a].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=p}),define(ne[66],se([0,1,19,4,53,2,35,30,3,11,25,44,36]),function(q,e,x,T,L,N,A,E,u,l,S,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function f(a){return Object.isFrozen(a)?a:E.deepFreeze(a)}class R{constructor(i={},r=[],n=[],o){this._contents=i,this._keys=r,this._overrides=n,this.raw=o,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(r=>{if(r instanceof R)return r;const n=new y("");return n.parseRaw(r),n.configurationModel});this._rawConfiguration=i.reduce((r,n)=>n===r?n:r.merge(n),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,S.getConfigurationValue)(this.contents,i):this.contents}inspect(i,r){const n=this.rawConfiguration.getValue(i),o=r?this.rawConfiguration.getOverrideValue(i,r):void 0,c=r?this.rawConfiguration.override(r).getValue(i):n;return{value:n,override:o,merged:c}}getOverrideValue(i,r){const n=this.getContentsForOverrideIdentifer(r);return n?i?(0,S.getConfigurationValue)(n,i):n:void 0}getKeysForOverrideIdentifier(i){const r=[];for(const n of this.overrides)n.identifiers.includes(i)&&r.push(...n.keys);return x.distinct(r)}getAllOverrideIdentifiers(){const i=[];for(const r of this.overrides)i.push(...r.identifiers);return x.distinct(i)}override(i){let r=this.overrideConfigurations.get(i);return r||(r=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,r)),r}merge(...i){const r=E.deepClone(this.contents),n=E.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const D of i)if(c.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.mergeContents(r,D.contents);for(const P of D.overrides){const[b]=n.filter(O=>x.equals(O.identifiers,P.identifiers));b?(this.mergeContents(b.contents,P.contents),b.keys.push(...P.keys),b.keys=x.distinct(b.keys)):n.push(E.deepClone(P))}for(const P of D.keys)o.indexOf(P)===-1&&o.push(P)}return new R(r,o,n,c.every(D=>D instanceof R)?void 0:c)}createOverrideConfigurationModel(i){const r=this.getContentsForOverrideIdentifer(i);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const n={};for(const o of x.distinct([...Object.keys(this.contents),...Object.keys(r)])){let c=this.contents[o];const D=r[o];D&&(typeof c=="object"&&typeof D=="object"?(c=E.deepClone(c),this.mergeContents(c,D)):c=D),n[o]=c}return new R(n,this.keys,this.overrides)}mergeContents(i,r){for(const n of Object.keys(r)){if(n in i&&u.isObject(i[n])&&u.isObject(r[n])){this.mergeContents(i[n],r[n]);continue}i[n]=E.deepClone(r[n])}}getContentsForOverrideIdentifer(i){let r=null,n=null;const o=c=>{c&&(n?this.mergeContents(n,c):n=E.deepClone(c))};for(const c of this.overrides)c.identifiers.length===1&&c.identifiers[0]===i?r=c.contents:c.identifiers.includes(i)&&o(c.contents);return o(r),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,r){this.updateValue(i,r,!0)}setValue(i,r){this.updateValue(i,r,!1)}removeValue(i){const r=this.keys.indexOf(i);r!==-1&&(this.keys.splice(r,1),(0,S.removeFromValueTree)(this.contents,i),k.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(n=>x.equals(n.identifiers,(0,k.overrideIdentifiersFromKey)(i))),1))}updateValue(i,r,n){(0,S.addToValueTree)(this.contents,i,r,o=>console.error(o)),n=n||this.keys.indexOf(i)===-1,n&&this.keys.push(i),k.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,k.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,S.toValuesTree)(this.contents[i],o=>console.error(o))})}}e.ConfigurationModel=R;class y{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new R}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,r){if(!u.isUndefinedOrNull(i)){const n=this.doParseContent(i);this.parseRaw(n,r)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,r){this._raw=i;const{contents:n,keys:o,overrides:c,restricted:D,hasExcludedProperties:P}=this.doParseRaw(i,r);this._configurationModel=new R(n,o,c,P?[i]:void 0),this._restrictedConfigurations=D||[]}doParseContent(i){let r={},n=null,o=[];const c=[],D=[];function P(O){Array.isArray(o)?o.push(O):n!==null&&(o[n]=O)}const b={onObjectBegin:()=>{const O={};P(O),c.push(o),o=O,n=null},onObjectProperty:O=>{n=O},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const O=[];P(O),c.push(o),o=O,n=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:P,onError:(O,j,ee)=>{D.push({error:O,offset:j,length:ee})}};if(i)try{L.visit(i,b),r=o[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return r}doParseRaw(i,r){const n=g.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,n,!0,r);i=o.raw;const c=(0,S.toValuesTree)(i,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),D=Object.keys(i),P=this.toOverrides(i,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:c,keys:D,overrides:P,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(i,r,n,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:c};const D={},P=[];for(const b in i)if(k.OVERRIDE_PROPERTY_REGEX.test(b)&&n){const O=this.filter(i[b],r,!1,o);D[b]=O.raw,c=c||O.hasExcludedProperties,P.push(...O.restricted)}else{const O=r[b],j=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&P.push(b),!o.exclude?.includes(b)&&(o.include?.includes(b)||(j===void 0||o.scopes===void 0||o.scopes.includes(j))&&!(o.skipRestricted&&O?.restricted))?D[b]=i[b]:c=!0}return{raw:D,restricted:P,hasExcludedProperties:c}}toOverrides(i,r){const n=[];for(const o of Object.keys(i))if(k.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const D in i[o])c[D]=i[o][D];n.push({identifiers:(0,k.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,S.toValuesTree)(c,r)})}return n}}e.ConfigurationModelParser=y;class m extends N.Disposable{constructor(i,r,n,o){super(),this.userSettingsResource=i,this.parseOptions=r,this.fileService=o,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(T.Event.any(T.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),T.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&n.isEqual(c.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new R}}reparse(i){return i&&(this.parseOptions=i),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class d{constructor(i,r,n,o,c,D,P,b,O,j,ee,Y,ce){this.key=i,this.overrides=r,this._value=n,this.overrideIdentifiers=o,this.defaultConfiguration=c,this.policyConfiguration=D,this.applicationConfiguration=P,this.userConfiguration=b,this.localUserConfiguration=O,this.remoteUserConfiguration=j,this.workspaceConfiguration=ee,this.folderConfigurationModel=Y,this.memoryConfigurationModel=ce}get value(){return f(this._value)}inspect(i,r,n){const o=i.inspect(r,n);return{get value(){return f(o.value)},get override(){return f(o.override)},get merged(){return f(o.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class h{constructor(i,r,n,o,c=new R,D=new R,P=new A.ResourceMap,b=new R,O=new A.ResourceMap){this._defaultConfiguration=i,this._policyConfiguration=r,this._applicationConfiguration=n,this._localUserConfiguration=o,this._remoteUserConfiguration=c,this._workspaceConfiguration=D,this._folderConfigurations=P,this._memoryConfiguration=b,this._memoryConfigurationByResource=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(i,r,n){return this.getConsolidatedConfigurationModel(i,r,n).getValue(i)}updateValue(i,r,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new R,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,r===void 0?o.removeValue(i):o.setValue(i,r),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,r,n){const o=this.getConsolidatedConfigurationModel(i,r,n),c=this.getFolderConfigurationModelForResource(r.resource,n),D=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,P=new Set;for(const b of o.overrides)for(const O of b.identifiers)o.getOverrideValue(i,O)!==void 0&&P.add(O);return new d(i,r,o.getValue(i),P.size?[...P]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this._workspaceConfiguration:void 0,c||void 0,D)}keys(i){const r=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:r?r.keys.slice(0):[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,r){this._folderConfigurations.set(i,r),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,r){const n=[];if(!r){const{added:o,updated:c,removed:D}=w(this._defaultConfiguration,i);r=[...o,...c,...D]}for(const o of r)for(const c of(0,k.overrideIdentifiersFromKey)(o)){const D=this._defaultConfiguration.getKeysForOverrideIdentifier(c),P=i.getKeysForOverrideIdentifier(c),b=[...P.filter(O=>D.indexOf(O)===-1),...D.filter(O=>P.indexOf(O)===-1),...D.filter(O=>!E.equals(this._defaultConfiguration.override(c).getValue(O),i.override(c).getValue(O)))];n.push([c,b])}return this.updateDefaultConfiguration(i),{keys:r,overrides:n}}compareAndUpdatePolicyConfiguration(i){const{added:r,updated:n,removed:o}=w(this._policyConfiguration,i),c=[...r,...n,...o];return c.length&&this.updatePolicyConfiguration(i),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:r,updated:n,removed:o,overrides:c}=w(this.applicationConfiguration,i),D=[...r,...n,...o];return D.length&&this.updateApplicationConfiguration(i),{keys:D,overrides:c}}compareAndUpdateLocalUserConfiguration(i){const{added:r,updated:n,removed:o,overrides:c}=w(this.localUserConfiguration,i),D=[...r,...n,...o];return D.length&&this.updateLocalUserConfiguration(i),{keys:D,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:r,updated:n,removed:o,overrides:c}=w(this.remoteUserConfiguration,i),D=[...r,...n,...o];return D.length&&this.updateRemoteUserConfiguration(i),{keys:D,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:r,updated:n,removed:o,overrides:c}=w(this.workspaceConfiguration,i),D=[...r,...n,...o];return D.length&&this.updateWorkspaceConfiguration(i),{keys:D,overrides:c}}compareAndUpdateFolderConfiguration(i,r){const n=this.folderConfigurations.get(i),{added:o,updated:c,removed:D,overrides:P}=w(n,r),b=[...o,...c,...D];return(b.length||!n)&&this.updateFolderConfiguration(i,r),{keys:b,overrides:P}}compareAndDeleteFolderConfiguration(i){const r=this.folderConfigurations.get(i);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:o,removed:c,overrides:D}=w(r,void 0);return{keys:[...n,...o,...c],overrides:D}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,r,n){let o=this.getConsolidatedConfigurationModelForResource(r,n);return r.overrideIdentifier&&(o=o.override(r.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:i},r){let n=this.getWorkspaceConsolidatedConfiguration();if(r&&i){const o=r.getFolder(i);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const c=this._memoryConfigurationByResource.get(i);c&&(n=n.merge(c))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let r=this._foldersConsolidatedConfigurations.get(i);if(!r){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(r=n.merge(o),this._foldersConsolidatedConfigurations.set(i,r)):r=n}return r}getFolderConfigurationModelForResource(i,r){if(r&&i){const n=r.getFolder(i);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,r)=>{const{contents:n,overrides:o,keys:c}=this._folderConfigurations.get(r);return i.push([r,{contents:n,overrides:o,keys:c}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.keys.forEach(r=>i.add(r)),this.userConfiguration.keys.forEach(r=>i.add(r)),this._workspaceConfiguration.keys.forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.keys.forEach(n=>i.add(n))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this.userConfiguration.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getAllOverrideIdentifiers().forEach(n=>i.add(n))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>r.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>r.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(o=>r.add(o))),[...r.values()]}static parse(i){const r=this.parseConfigurationModel(i.defaults),n=this.parseConfigurationModel(i.policy),o=this.parseConfigurationModel(i.application),c=this.parseConfigurationModel(i.user),D=this.parseConfigurationModel(i.workspace),P=i.folders.reduce((b,O)=>(b.set(l.URI.revive(O[0]),this.parseConfigurationModel(O[1])),b),new A.ResourceMap);return new h(r,n,o,c,new R,D,P,new R,new A.ResourceMap)}static parseConfigurationModel(i){return new R(i.contents,i.keys,i.overrides)}}e.Configuration=h;function C(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,r=new Map;for(const o of a)o.keys.forEach(c=>i.add(c)),o.overrides.forEach(([c,D])=>{const P=(0,A.getOrSet)(r,c,new Set);D.forEach(b=>P.add(b))});const n=[];return r.forEach((o,c)=>n.push([c,[...o.values()]])),{keys:[...i.values()],overrides:n}}e.mergeChanges=C;class p{constructor(i,r,n,o){this.change=i,this.previous=r,this.currentConfiguraiton=n,this.currentWorkspace=o,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const c of i.keys)this.affectedKeys.add(c);for(const[,c]of i.overrides)for(const D of c)this.affectedKeys.add(D);this._affectsConfigStr=this._marker;for(const c of this.affectedKeys)this._affectsConfigStr+=c+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,r){const n=this._marker+i,o=this._affectsConfigStr.indexOf(n);if(o<0)return!1;const c=o+n.length;if(c>=this._affectsConfigStr.length)return!1;const D=this._affectsConfigStr.charCodeAt(c);if(D!==this._markerCode1&&D!==this._markerCode2)return!1;if(r){const P=this.previousConfiguration?this.previousConfiguration.getValue(i,r,this.previous?.workspace):void 0,b=this.currentConfiguraiton.getValue(i,r,this.currentWorkspace);return!E.equals(P,b)}return!0}}e.ConfigurationChangeEvent=p;function w(a,i){const{added:r,removed:n,updated:o}=t(i?.rawConfiguration,a?.rawConfiguration),c=[],D=a?.getAllOverrideIdentifiers()||[],P=i?.getAllOverrideIdentifiers()||[];if(i){const b=P.filter(O=>!D.includes(O));for(const O of b)c.push([O,i.getKeysForOverrideIdentifier(O)])}if(a){const b=D.filter(O=>!P.includes(O));for(const O of b)c.push([O,a.getKeysForOverrideIdentifier(O)])}if(i&&a){for(const b of D)if(P.includes(b)){const O=t({contents:a.getOverrideValue(void 0,b)||{},keys:a.getKeysForOverrideIdentifier(b)},{contents:i.getOverrideValue(void 0,b)||{},keys:i.getKeysForOverrideIdentifier(b)});c.push([b,[...O.added,...O.removed,...O.updated]])}}return{added:r,removed:n,updated:o,overrides:c}}function t(a,i){const r=a?i?a.keys.filter(c=>i.keys.indexOf(c)===-1):[...a.keys]:[],n=i?a?i.keys.filter(c=>a.keys.indexOf(c)===-1):[...i.keys]:[],o=[];if(a&&i){for(const c of i.keys)if(a.keys.indexOf(c)!==-1){const D=(0,S.getConfigurationValue)(i.contents,c),P=(0,S.getConfigurationValue)(a.contents,c);E.equals(D,P)||o.push(c)}}return{added:r,removed:n,updated:o}}}),define(ne[132],se([0,1,19,4,2,30,3,66,44,6,38,36]),function(q,e,x,T,L,N,A,E,u,l,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class g extends L.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new E.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(k.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:d})=>this.onDidUpdateConfiguration(Array.from(m),d))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(m,d){this.updateConfigurationModel(m,k.Registry.as(u.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:m})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new E.ConfigurationModel;const m=k.Registry.as(u.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(m),m)}updateConfigurationModel(m,d){const h=this.getConfigurationDefaultOverrides();for(const C of m){const p=h[C],w=d[C];p!==void 0?this._configurationModel.addValue(C,p):w?this._configurationModel.addValue(C,w.default):this._configurationModel.removeValue(C)}}}e.DefaultConfiguration=g;class f{constructor(){this.onDidChangeConfiguration=T.Event.None,this.configurationModel=new E.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let R=class extends L.Disposable{get configurationModel(){return this._configurationModel}constructor(m,d,h){super(),this.defaultConfiguration=m,this.policyService=d,this.logService=h,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new E.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(m=>this.onDidChangePolicies(m))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:m})=>this.update(await this.updatePolicyDefinitions(m),!0))),this._configurationModel}async updatePolicyDefinitions(m){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",m);const d={},h=[],C=k.Registry.as(u.Extensions.Configuration).getConfigurationProperties();for(const p of m){const w=C[p];if(!w){h.push(p);continue}if(w.policy){if(w.type!=="string"&&w.type!=="number"){this.logService.warn(`Policy ${w.policy.name} has unsupported type ${w.type}`);continue}h.push(p),d[w.policy.name]={type:w.type}}}return(0,A.isEmptyObject)(d)||await this.policyService.updatePolicyDefinitions(d),h}onDidChangePolicies(m){this.logService.trace("PolicyConfiguration#onDidChangePolicies",m);const d=k.Registry.as(u.Extensions.Configuration).getPolicyConfigurations(),h=(0,x.coalesce)(m.map(C=>d.get(C)));this.update(h,!0)}update(m,d){this.logService.trace("PolicyConfiguration#update",m);const h=k.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),C=[],p=this._configurationModel.isEmpty();for(const w of m){const t=h[w]?.policy?.name;if(t){const a=this.policyService.getPolicyValue(t);(p?a!==void 0:!(0,N.equals)(this._configurationModel.getValue(w),a))&&C.push([w,a])}else this._configurationModel.getValue(w)!==void 0&&C.push([w,void 0])}if(C.length){this.logService.trace("PolicyConfiguration#changed",C);const w=this._configurationModel;this._configurationModel=new E.ConfigurationModel;for(const t of w.keys)this._configurationModel.setValue(t,w.getValue(t));for(const[t,a]of C)a===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,a);d&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=R,e.PolicyConfiguration=R=ve([re(1,S.IPolicyService),re(2,l.ILogService)],R)}),define(ne[133],se([0,1,8,4,2,17,25,66,132,38]),function(q,e,x,T,L,N,A,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class S extends L.Disposable{constructor(g,f,R,y){super(),this.settingsResource=g,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new u.DefaultConfiguration),this.policyConfiguration=R instanceof l.NullPolicyService?new u.NullPolicyConfiguration:this._register(new u.PolicyConfiguration(this.defaultConfiguration,R,y)),this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,{},N.extUriBiasedIgnorePathCase,f)),this.configuration=new E.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new E.ConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new x.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:m,properties:d})=>this.onDidDefaultConfigurationChange(m,d))),this._register(this.policyConfiguration.onDidChangeConfiguration(m=>this.onDidPolicyConfigurationChange(m))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[g,f,R]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new E.Configuration(g,f,new E.ConfigurationModel,R)}getConfigurationData(){return this.configuration.toData()}getValue(g,f){const R=typeof g=="string"?g:void 0,y=(0,A.isConfigurationOverrides)(g)?g:(0,A.isConfigurationOverrides)(f)?f:{};return this.configuration.getValue(R,y,void 0)}updateValue(g,f,R,y){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const f=this.configuration.toData(),R=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(R,f,2)}onDidDefaultConfigurationChange(g,f){const R=this.configuration.toData(),y=this.configuration.compareAndUpdateDefaultConfiguration(g,f);this.trigger(y,R,7)}onDidPolicyConfigurationChange(g){const f=this.configuration.toData(),R=this.configuration.compareAndUpdatePolicyConfiguration(g);this.trigger(R,f,7)}trigger(g,f,R){const y=new E.ConfigurationChangeEvent(g,{data:f},this.configuration);y.source=R,y.sourceConfig=this.getTargetConfiguration(R),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(g){switch(g){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=S}),define(ne[67],se([0,1,15]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(l){return l.scheme===x.Schemas.vscodeRemote?l.authority:void 0}e.getRemoteAuthority=T;function L(l){if(!l)return;const S=l.indexOf("+");return S<0?l:l.substr(0,S)}e.getRemoteName=L;function N(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.getRemoteServerRootPath=N;function A(l){const{host:S,port:k}=u(l);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:S,port:k}}e.parseAuthorityWithPort=A;function E(l,S){let{host:k,port:g}=u(l);return typeof g>"u"&&(g=S),{host:k,port:g}}e.parseAuthorityWithOptionalPort=E;function u(l){const S=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const k=l.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const g=l.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:l,port:void 0}}}),define(ne[37],se([0,1,28,10,67]),function(q,e,x,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function N(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.getWorkspaceSupportTypeMessage=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(A||(e.ExtensionType=A={}));var E;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.LINUX_PPC64LE="linux-ppc64le",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class u{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,d){if(typeof m>"u"||m===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof m=="string"||typeof d=="string"){const h=typeof m=="string"?m:m.value,C=typeof d=="string"?d:d.value;return x.equalsIgnoreCase(h,C)}return m._lower===d._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=u;class l{get size(){return this._set.size}constructor(m){if(this._set=new Set,m)for(const d of m)this.add(d)}add(m){this._set.add(u.toKey(m))}delete(m){return this._set.delete(u.toKey(m))}has(m){return this._set.has(u.toKey(m))}}e.ExtensionIdentifierSet=l;class S{constructor(){this._map=new Map}clear(){this._map.clear()}delete(m){this._map.delete(u.toKey(m))}get(m){return this._map.get(u.toKey(m))}has(m){return this._map.has(u.toKey(m))}set(m,d){this._map.set(u.toKey(m),d)}values(){return this._map.values()}forEach(m){this._map.forEach(m)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=S;function k(y){return g(y)}e.isApplicationScopedExtension=k;function g(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=g;function f(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function R(y,m){if(m){const d=`onResolveRemoteAuthority:${(0,L.getRemoteName)(m)}`;return!!y.activationEvents?.includes(d)}return!1}e.isResolverExtension=R,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[134],se([0,1,2,37,13]),function(q,e,x,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends x.Disposable{constructor(E,u,l,S,k){super(),this.userDataProfilesService=E,this.fileService=u,this.uriIdentityService=l,this.logService=k,this._register(S.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(S.onDidUninstallExtension(g=>this.onDidUnInstallExtension(g)))}onDidInstallExtensions(E){for(const u of E)u.local&&this.invalidate(u.profileLocation)}onDidUnInstallExtension(E){E.error||this.invalidate(E.profileLocation)}async invalidate(E){if(E)for(const u of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(u.extensionsResource,E)&&await this.deleteUserCacheFile(u);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(E){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(E.cacheHome,T.USER_MANIFEST_CACHE_FILE))}catch(u){(0,L.toFileOperationResult)(u)!==1&&this.logService.error(u)}}}e.ExtensionsManifestCache=N}),define(ne[45],se([0,1,14,9,2,103,44,10,6,36]),function(q,e,x,T,L,N,A,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,E.createDecorator)("requestService");class S{constructor(w){this.original=w}toJSON(){if(!this.headers){const w=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?w[t]="*****":w[t]=this.original[t];this.headers=w}return this.headers}}class k extends L.Disposable{constructor(w){super(),this.counter=0,this.logger=w.createLogger("network",{name:(0,N.localize)(0,null),when:u.CONTEXT_LOG_LEVEL.isEqualTo((0,u.LogLevelToString)(u.LogLevel.Trace)).serialize()})}async logAndRequest(w,t,a){const i=`${w} #${++this.counter}: ${t.url}`;this.logger.trace(`${i} - begin`,t.type,new S(t.headers??{}));try{const r=await a();return this.logger.trace(`${i} - end`,t.type,r.res.statusCode,r.res.headers),r}catch(r){throw this.logger.error(`${i} - error`,t.type,(0,T.getErrorMessage)(r)),r}}}e.AbstractRequestService=k;function g(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=g;function f(p){return p.res.statusCode===204}async function R(p){return f(p)?null:(await(0,x.streamToBuffer)(p.stream)).toString()}e.asText=R;async function y(p){if(!g(p))throw new Error("Server returned "+p.res.statusCode);return R(p)}e.asTextOrError=y;async function m(p){if(!g(p))throw new Error("Server returned "+p.res.statusCode);if(f(p))return null;const t=(await(0,x.streamToBuffer)(p.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.asJson=m;function d(p){C(p)}e.updateProxyConfigurationsScope=d;let h;function C(p){const w=l.Registry.as(A.Extensions.Configuration),t=h;h={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0}}},w.updateConfigurations({add:[h],remove:t?[t]:[]})}C(1)}),define(ne[135],se([0,1,20,15,13,45]),function(q,e,x,T,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(u,l){this.requestService=u,this.fileService=l}async download(u,l,S=x.CancellationToken.None){if(u.scheme===T.Schemas.file||u.scheme===T.Schemas.vscodeRemote){await this.fileService.copy(u,l);return}const k={type:"GET",url:u.toString(!0)},g=await this.requestService.request(k,S);if(g.res.statusCode===200)await this.fileService.writeFile(l,g.stream);else{const f=await(0,N.asTextOrError)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${f}`)}}};e.DownloadService=A,e.DownloadService=A=ve([re(0,N.IRequestService),re(1,L.IFileService)],A)}),define(ne[136],se([0,1,137,3]),function(q,e,x,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function L(A,E){return A.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:A.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function N(A,E,u={}){const l=(0,x.parse)(A),S=u.proxyUrl||L(l,E);if(!S)return null;const k=(0,x.parse)(S);if(!/^https?:$/.test(k.protocol||""))return null;const g={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:(0,T.isBoolean)(u.strictSSL)?u.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((f,R)=>{q(["http-proxy-agent"],f,R)}))(g):new(await new Promise((f,R)=>{q(["https-proxy-agent"],f,R)}))(g)}e.getProxyAgent=N}),define(ne[138],se([0,1,58,16,104,20,33,9,12,29,84,172,8,72]),function(q,e,x,T,L,N,A,E,u,l,S,k,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let R;async function y(d,h,C,p){return C["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.isLaunchedFromCli)(p)&&!C["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.isLaunchedFromCli)(p)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),R||(R=g.Promises.withAsyncBody(async(w,t)=>{const a=new N.CancellationTokenSource;let i=1e4;const r=d.getValue("application.shellEnvironmentResolutionTimeout");typeof r=="number"&&(i=(0,f.clamp)(r,1,120)*1e3);const n=setTimeout(()=>{a.dispose(!0),t(new Error((0,L.localize)(0,null)))},i);try{w(await m(h,a.token))}catch(o){!(0,E.isCancellationError)(o)&&!a.token.isCancellationRequested?t(new Error((0,L.localize)(1,null,(0,A.toErrorMessage)(o)))):w({})}finally{clearTimeout(n),a.dispose()}})),R)}e.getResolvedShellEnv=y;async function m(d,h){const C=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",C);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",p);const w=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(w+"({.*})"+w),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",a);const i=await(0,S.getSystemShell)(u.OS,a);return d.trace("getUnixShellEnvironment#shell",i),new Promise((r,n)=>{if(h.isCancellationRequested)return n(new E.CancellationError);const o=(0,T.basename)(i);let c,D;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${P} -p '''${w}'' + JSON.stringify(process.env) + ''${w}'''`,D=["-Login","-Command"]):o==="nu"?(c=`^'${process.execPath}' ${P} -p '"${w}" + JSON.stringify(process.env) + "${w}"'`,D=["-i","-l","-c"]):(c=`'${process.execPath}' ${P} -p '"${w}" + JSON.stringify(process.env) + "${w}"'`,o==="tcsh"||o==="csh"?D=["-ic"]:D=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),c);const b=(0,x.spawn)(i,[...D,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});h.onCancellationRequested(()=>(b.kill(),n(new E.CancellationError))),b.on("error",ee=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(ee)),n(ee)});const O=[];b.stdout.on("data",ee=>O.push(ee));const j=[];b.stderr.on("data",ee=>j.push(ee)),b.on("close",(ee,Y)=>{const ce=Buffer.concat(O).toString("utf8");d.trace("getUnixShellEnvironment#raw",ce);const Z=Buffer.concat(j).toString("utf8");if(Z.trim()&&d.trace("getUnixShellEnvironment#stderr",Z),ee||Y)return n(new Error((0,L.localize)(2,null,ee,Y)));const ae=t.exec(ce),le=ae?ae[1]:"{}";try{const te=JSON.parse(le);C?te.ELECTRON_RUN_AS_NODE=C:delete te.ELECTRON_RUN_AS_NODE,p?te.ELECTRON_NO_ATTACH_CONSOLE=p:delete te.ELECTRON_NO_ATTACH_CONSOLE,delete te.VSCODE_RESOLVING_ENVIRONMENT,delete te.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",te),r(te)}catch(te){d.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(te)),n(te)}})})}}),define(ne[139],se([0,1,10]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,x.createDecorator)("stateReadService"),e.IStateService=(0,x.createDecorator)("stateService")}),define(ne[68],se([0,1,8,14,3,18,13,6]),function(q,e,x,T,L,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var u;(function(g){g[g.IMMEDIATE=0]="IMMEDIATE",g[g.DELAYED=1]="DELAYED"})(u||(e.SaveStrategy=u={}));class l{constructor(f,R,y,m){this.storagePath=f,this.logService=y,this.fileService=m,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=R===0?void 0:new x.ThrottledDelayer(100)}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(f){f.fileOperationResult!==1&&this.logService.error(f)}}getItem(f,R){const y=this.storage[f];return(0,L.isUndefinedOrNull)(y)?R:y}setItem(f,R){this.setItems([{key:f,data:R}])}setItems(f){let R=!1;for(const{key:y,data:m}of f)this.storage[y]!==m&&((0,L.isUndefinedOrNull)(m)?(0,L.isUndefined)(this.storage[y])||(this.storage[y]=void 0,R=!0):(this.storage[y]=m,R=!0));R&&this.save()}removeItem(f){(0,L.isUndefined)(this.storage[f])||(this.storage[f]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const f=JSON.stringify(this.storage,null,4);if(f!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,T.VSBuffer.fromString(f),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=f}catch(R){this.logService.error(R)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=l;let S=class{constructor(f,R,y,m){this.fileStorage=new l(R.stateResource,f,y,m)}async init(){await this.fileStorage.init()}getItem(f,R){return this.fileStorage.getItem(f,R)}};e.StateReadonlyService=S,e.StateReadonlyService=S=ve([re(1,N.IEnvironmentService),re(2,E.ILogService),re(3,A.IFileService)],S);class k extends S{setItem(f,R){this.fileStorage.setItem(f,R)}setItems(f){this.fileStorage.setItems(f)}removeItem(f){this.fileStorage.removeItem(f)}close(){return this.fileStorage.close()}}e.StateService=k}),define(ne[69],se([0,1,12,34,29]),function(q,e,x,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(u){if(x.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function A(u,l,S,k,g,f,R,y){const m=Object.create(null);m["common.machineId"]=f,m.sessionID=(0,L.generateUuid)()+Date.now(),m.commitHash=k,m.version=g,m["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,x.PlatformToString)(x.platform),m["common.nodePlatform"]=T.platform,m["common.nodeArch"]=S,m["common.product"]=y||"desktop",R&&(m["common.msftInternal"]=R);let d=0;const h=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),x.isLinuxSnap&&(m["common.snap"]="true");const C=N(l);return C&&(m["common.platformDetail"]=C),m}e.resolveCommonProperties=A;function E(u){const l=T.env.USERDNSDOMAIN;if(!l)return!1;const S=l.toLowerCase();return u.some(k=>S===k)}e.verifyMicrosoftInternalDomain=E}),define(ne[26],se([0,1,10]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,x.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,x.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var L;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ne[39],se([0,1,30,3,4,25,67,69,26]),function(q,e,x,T,L,N,A,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class l{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=l;class S{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class k{async publicLog(n,o,c){}async publicLogError(n,o,c){}}e.NullEndpointTelemetryService=k,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(r,n){return L.Event.debounce(n.onDidChangeConfiguration,(c,D)=>{const P=c?new Set([...c.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:P}},1e3,!0)(c=>{c.source!==7&&r.publicLog2("updateConfiguration",{configurationSource:(0,N.ConfigurationTargetToString)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.configurationTelemetry=g;function f(r,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!r.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=f;function R(r,n){return!(n.isBuilt||n.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}e.isLoggingOnly=R;function y(r){const n=r.getValue(u.TELEMETRY_SETTING_ID),o=r.getValue(u.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(r.getValue(u.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function m(r){const n={},o={},c={};C(r,c);for(let D in c){D=D.length>150?D.substr(D.length-149):D;const P=c[D];typeof P=="number"?o[D]=P:typeof P=="boolean"?o[D]=P?1:0:typeof P=="string"?(P.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${P.length}`),n[D]=P.substring(0,8191)):typeof P<"u"&&P!==null&&(n[D]=P)}return{properties:n,measurements:o}}e.validateTelemetryData=m;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(r){if(!r)return"none";const n=(0,A.getRemoteName)(r);return d.has(n)?n:"other"}e.cleanRemoteAuthority=h;function C(r,n,o=0,c){if(r)for(const D of Object.getOwnPropertyNames(r)){const P=r[D],b=c?c+D:D;Array.isArray(P)?n[b]=(0,x.safeStringify)(P):P instanceof Date?n[b]=P.toISOString():(0,T.isObject)(P)?o<2?C(P,n,o+1,b+"."):n[b]=(0,x.safeStringify)(P):n[b]=P}}function p(r,n){const o=r.msftInternalDomains||[],c=n.getValue("telemetry.internalTesting");return(0,E.verifyMicrosoftInternalDomain)(o)||c}e.isInternalTelemetry=p;function w(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}e.getPiiPathsFromEnvironment=w;function t(r,n){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let o=r;const c=[];for(const O of n)for(;;){const j=O.exec(r);if(!j)break;c.push([j.index,O.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,P=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(o="";;){const O=P.exec(r);if(!O)break;const j=c.some(([ee,Y])=>O.index<Y&&ee<P.lastIndex);!D.test(O[0])&&!j&&(o+=r.substring(b,O.index)+"<REDACTED: user-file-path>",b=P.lastIndex)}return b<r.length&&(o+=r.substr(b)),o}function a(r){if(!r)return r;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(r))return`<REDACTED: ${o.label}>`;return r}function i(r,n){return(0,x.cloneAndChange)(r,o=>{if(o instanceof l||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let c=o.replaceAll("%20"," ");c=t(c,n);for(const D of n)c=c.replace(D,"");return c=a(c),c}})}e.cleanData=i}),define(ne[27],se([0,1,28,21,37,12,11,9,34,39]),function(q,e,x,T,L,N,A,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function S(i,r){return i.uuid&&r.uuid?i.uuid===r.uuid:i.id===r.id?!0:(0,x.compareIgnoreCase)(i.id,r.id)===0}e.areSameExtensions=S;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(r){const n=r.manifest?r.manifest.version:r.version,o=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new g(r.identifier,n,o)}static parse(r){const n=k.exec(r);return n&&n[1]&&n[2]?new g({id:n[1]},n[2],n[4]||void 0):null}constructor(r,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof g?S(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=g;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function R(i){const r=f.exec(i);return r&&r[1]?[m(r[1]),r[2]]:[m(i),void 0]}e.getIdAndVersion=R;function y(i,r){return`${i}.${r}`}e.getExtensionId=y;function m(i){return i.toLowerCase()}e.adoptToGalleryExtensionId=m;function d(i,r){return m(y(i??L.UNDEFINED_PUBLISHER,r))}e.getGalleryExtensionId=d;function h(i,r){const n=[],o=c=>{for(const D of n)if(D.some(P=>S(r(P),r(c))))return D;return null};for(const c of i){const D=o(c);D?D.push(c):n.push([c])}return n}e.groupByExtension=h;function C(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=C;function p(i){return{id:new l.TelemetryTrustedValue(i.identifier.id),name:new l.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function w(i,r){const n=[],o=r.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&n.every(D=>!S(D.identifier,{id:c}))){const D=i.filter(P=>S(P.identifier,{id:c}));D.length===1&&(n.push(D[0]),o.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=w;async function t(i,r){if(!N.isLinux)return!1;let n;try{n=(await i.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await i.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){r.debug("Error while getting the os-release file.",(0,E.getErrorMessage)(c))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,r){const n=await t(i,r),o=(0,T.getTargetPlatform)(n?"alpine":N.platform,u.arch);return r.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=a}),define(ne[140],se([0,1,20,9,15,17,43,11,93,21,27,37]),function(q,e,x,T,L,N,A,E,u,l,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const g=m=>(0,u.localize)(0,null,m),f=(0,u.localize)(1,null,"ms-dotnettools.csharp");function R(m,d){return d?`${m.publisher}.${m.name}@${m.version}`:`${m.publisher}.${m.name}`}let y=class{constructor(d,h,C){this.logger=d,this.extensionManagementService=h,this.extensionGalleryService=C}get location(){}async listExtensions(d,h,C){let p=await this.extensionManagementService.getInstalled(1,C);const w=k.EXTENSION_CATEGORIES.map(a=>a.toLowerCase());if(h&&h!==""){if(w.indexOf(h.toLowerCase())<0){this.logger.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(a=>a.manifest.categories?a.manifest.categories.map(r=>r.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){this.logger.info("Possible Categories: "),w.forEach(a=>{this.logger.info(a)});return}this.location&&this.logger.info((0,u.localize)(2,null,this.location)),p=p.sort((a,i)=>a.identifier.id.localeCompare(i.identifier.id));let t;for(const a of p)t!==a.identifier.id&&(t=a.identifier.id,this.logger.info(R(a.manifest,d)))}async installExtensions(d,h,C,p){const w=[];try{const t=[];d.length&&this.logger.info(this.location?(0,u.localize)(3,null,this.location):(0,u.localize)(4,null));const a=[];let i=[];const r=(o,c,D)=>{i.push({id:o,version:c!=="prerelease"?c:void 0,installOptions:{...C,isBuiltin:D,installPreReleaseVersion:c==="prerelease"||C.installPreReleaseVersion}})};for(const o of d)if(o instanceof E.URI)a.push({vsix:o,installOptions:C});else{const[c,D]=(0,S.getIdAndVersion)(o);r(c,D,!1)}for(const o of h)if(o instanceof E.URI)a.push({vsix:o,installOptions:{...C,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[c,D]=(0,S.getIdAndVersion)(o);r(c,D,!0)}const n=await this.extensionManagementService.getInstalled(1,C.profileLocation);if(a.length&&await Promise.all(a.map(async({vsix:o,installOptions:c})=>{try{const D=await this.installVSIX(o,c,p,n);D&&t.push(D)}catch(D){this.logger.error(D),w.push(o.toString())}})),i.length&&(i=i.filter(({id:o,version:c})=>{const D=n.find(P=>(0,S.areSameExtensions)(P.identifier,{id:o}));if(D){if(!p&&(!c||c==="prerelease"&&D.preRelease))return this.logger.info((0,u.localize)(5,null,o,D.manifest.version,o)),!1;if(c&&D.manifest.version===c)return this.logger.info((0,u.localize)(6,null,`${o}@${c}`)),!1}return!0}),i.length)){const o=await this.getGalleryExtensions(i);await Promise.all(i.map(async c=>{const D=o.get(c.id.toLowerCase());if(D)try{const P=await this.installFromGallery(c,D,n);P&&t.push(P)}catch(P){this.logger.error(P.message||P.stack||P),w.push(c.id)}else this.logger.error(`${g(c.version?`${c.id}@${c.version}`:c.id)}
${f}`),w.push(c.id)}))}}catch(t){throw this.logger.error((0,u.localize)(7,null,(0,T.getErrorMessage)(t))),t}if(w.length)throw new Error((0,u.localize)(8,null,w.join(", ")))}async installVSIX(d,h,C,p){const w=await this.extensionManagementService.getManifest(d);if(!w)throw new Error("Invalid vsix");if(await this.validateVSIX(w,C,h.profileLocation,p))try{return await this.extensionManagementService.install(d,h),this.logger.info((0,u.localize)(9,null,(0,N.basename)(d))),w}catch(a){if((0,T.isCancellationError)(a))return this.logger.info((0,u.localize)(10,null,(0,N.basename)(d))),null;throw a}return null}async getGalleryExtensions(d){const h=new Map,C=d.some(t=>t.installOptions.installPreReleaseVersion),p=await this.extensionManagementService.getTargetPlatform(),w=[];for(const t of d)l.EXTENSION_IDENTIFIER_REGEX.test(t.id)&&w.push({...t,preRelease:C});if(w.length){const t=await this.extensionGalleryService.getExtensions(w,{targetPlatform:p},x.CancellationToken.None);for(const a of t)h.set(a.identifier.id.toLowerCase(),a)}return h}async installFromGallery({id:d,version:h,installOptions:C},p,w){const t=await this.extensionGalleryService.getManifest(p,x.CancellationToken.None);if(t&&!this.validateExtensionKind(t))return null;const a=w.find(i=>(0,S.areSameExtensions)(i.identifier,p.identifier));if(a){if(p.version===a.manifest.version)return this.logger.info((0,u.localize)(11,null,h?`${d}@${h}`:d)),null;this.logger.info((0,u.localize)(12,null,d,p.version))}try{C.isBuiltin?this.logger.info(h?(0,u.localize)(13,null,d,h):(0,u.localize)(14,null,d)):this.logger.info(h?(0,u.localize)(15,null,d,h):(0,u.localize)(16,null,d));const i=await this.extensionManagementService.installFromGallery(p,{...C,installGivenVersion:!!h});return this.logger.info((0,u.localize)(17,null,d,i.manifest.version)),t}catch(i){if((0,T.isCancellationError)(i))return this.logger.info((0,u.localize)(18,null,d)),null;throw i}}validateExtensionKind(d){return!0}async validateVSIX(d,h,C,p){if(!h){const w={id:(0,S.getGalleryExtensionId)(d.publisher,d.name)},t=p.find(a=>(0,S.areSameExtensions)(w,a.identifier)&&(0,A.gt)(a.manifest.version,d.version));if(t)return this.logger.info((0,u.localize)(19,null,t.identifier.id,t.manifest.version,d.version)),!1}return this.validateExtensionKind(d)}async uninstallExtensions(d,h,C){const p=async t=>{if(t instanceof E.URI){const a=await this.extensionManagementService.getManifest(t);return R(a)}return t},w=[];for(const t of d){const a=await p(t),r=(await this.extensionManagementService.getInstalled(void 0,C)).filter(n=>(0,S.areSameExtensions)(n.identifier,{id:a}));if(!r.length)throw new Error(`${this.notInstalled(a)}
${f}`);if(r.some(n=>n.type===0)){this.logger.info((0,u.localize)(20,null,a));return}if(!h&&r.some(n=>n.isBuiltin)){this.logger.info((0,u.localize)(21,null,a));return}this.logger.info((0,u.localize)(22,null,a));for(const n of r)await this.extensionManagementService.uninstall(n,{profileLocation:C}),w.push(n);this.location?this.logger.info((0,u.localize)(23,null,a,this.location)):this.logger.info((0,u.localize)(24,null,a))}}async locateExtension(d){const h=await this.extensionManagementService.getInstalled();d.forEach(C=>{h.forEach(p=>{if(p.identifier.id===C&&p.location.scheme===L.Schemas.file){this.logger.info(p.location.fsPath);return}})})}notInstalled(d){return this.location?(0,u.localize)(25,null,d,this.location):(0,u.localize)(26,null,d)}};e.ExtensionManagementCLI=y,e.ExtensionManagementCLI=y=ve([re(1,l.IExtensionManagementService),re(2,l.IExtensionGalleryService)],y)}),define(ne[141],se([0,1,4,2,35,27,37]),function(q,e,x,T,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class E extends T.Disposable{constructor(l,S,k,g,f,R,y){super(),this.extensionManagementService=l,this.extensionsScannerService=S,this.userDataProfilesService=k,this.extensionsProfileScannerService=g,this.uriIdentityService=f,this.fileService=R,this.logService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new x.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new T.DisposableMap),this.initialize().then(null,m=>y.error(m))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(l=>this.onDidChangeProfiles(l.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(l=>this.onAddExtensions(l))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(l=>this.onDidAddExtensions(l))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(l=>this.onRemoveExtensions(l))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(l=>this.onDidRemoveExtensions(l))),this._register(this.fileService.onDidFilesChange(l=>this.onDidFilesChange(l)))}async onDidChangeProfiles(l){try{l.length&&await Promise.all(l.map(S=>(this.extensionsProfileWatchDisposables.set(S.id,(0,T.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(S.extensionsResource)),this.fileService.watch(S.extensionsResource))),this.populateExtensionsFromProfile(S.extensionsResource))))}catch(S){throw this.logService.error(S),S}}async onAddExtensions(l){for(const S of l.extensions)this.addExtensionWithKey(this.getKey(S.identifier,S.version),l.profileLocation)}async onDidAddExtensions(l){for(const S of l.extensions){const k=this.getKey(S.identifier,S.version);l.error?this.removeExtensionWithKey(k,l.profileLocation):this.addExtensionWithKey(k,l.profileLocation)}}async onRemoveExtensions(l){for(const S of l.extensions)this.removeExtensionWithKey(this.getKey(S.identifier,S.version),l.profileLocation)}async onDidRemoveExtensions(l){const S=[],k=[];for(const g of l.extensions){const f=this.getKey(g.identifier,g.version);l.error?this.addExtensionWithKey(f,l.profileLocation):(this.removeExtensionWithKey(f,l.profileLocation),this.allExtensions.has(f)||(this.logService.debug("Extension is removed from all profiles",g.identifier.id,g.version),k.push(this.extensionManagementService.scanInstalledExtensionAtLocation(g.location).then(R=>{R?S.push(R):this.logService.info("Extension not found at the location",g.location.toString())},R=>this.logService.error(R)))))}try{await Promise.all(k),S.length&&await this.uninstallExtensionsNotInProfiles(S)}catch(g){this.logService.error(g)}}onDidFilesChange(l){for(const S of this.userDataProfilesService.profiles)l.contains(S.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(S.extensionsResource)}async onDidExtensionsProfileChange(l){const S=[],k=[],g=await this.extensionsProfileScannerService.scanProfileExtensions(l),f=new Set,R=new Set;for(const[y,m]of this.allExtensions)m.has(l)&&R.add(y);for(const y of g){const m=this.getKey(y.identifier,y.version);f.add(m),R.has(m)||(S.push(y.identifier),this.addExtensionWithKey(m,l))}for(const y of R)if(!f.has(y)){const m=this.fromKey(y);m&&(k.push(m.identifier),this.removeExtensionWithKey(y,l))}(S.length||k.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S.length?{extensions:S,profileLocation:l}:void 0,removed:k.length?{extensions:k,profileLocation:l}:void 0})}async populateExtensionsFromProfile(l){const S=await this.extensionsProfileScannerService.scanProfileExtensions(l);for(const k of S)this.addExtensionWithKey(this.getKey(k.identifier,k.version),l)}async uninstallExtensionsNotInProfiles(l){l||(l=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(k=>!this.allExtensions.has(this.getKey(k.identifier,k.manifest.version)))),l.length&&await this.extensionManagementService.markAsUninstalled(...l)}addExtensionWithKey(l,S){let k=this.allExtensions.get(l);k||this.allExtensions.set(l,k=new L.ResourceSet(g=>this.uriIdentityService.extUri.getComparisonKey(g))),k.add(S)}removeExtensionWithKey(l,S){const k=this.allExtensions.get(l);k&&k.delete(S),k?.size||this.allExtensions.delete(l)}getKey(l,S){return`${A.ExtensionIdentifier.toKey(l.id)}@${S}`}fromKey(l){const[S,k]=(0,N.getIdAndVersion)(l);return k?{identifier:{id:S},version:k}:void 0}}e.ExtensionsWatcher=E}),define(ne[142],se([0,1,113,39]),function(q,e,x,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function L(N,A,E,u,l,S,k){const g={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${A.nameShort})`};if((0,T.supportsTelemetry)(A,E)&&(0,T.getTelemetryLevel)(u)===3){const f=await(0,x.getServiceMachineId)(E,l,S);g["X-Market-User-Id"]=f,g["VSCode-SessionId"]=k.machineId||f}return g}e.resolveMarketplaceHeaders=L}),define(ne[143],se([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(q,e,x,T,L,N,A,E,u,l,S,k,g,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let y=class extends f.LanguagePackBaseService{constructor(C,p,w,t){super(w),this.extensionManagementService=C,this.logService=t,this.cache=this._register(new m(p,t)),this.extensionManagementService.registerParticipant({postInstall:async a=>this.postInstallExtension(a),postUninstall:async a=>this.postUninstallExtension(a)})}async getBuiltInExtensionTranslationsUri(C,p){const t=(await this.cache.getLanguagePacks())[p];if(!t){this.logService.warn(`No language pack found for ${p}`);return}const a=t.translations[C];return a?R.URI.file(a):void 0}async getInstalledLanguages(){const C=await this.cache.getLanguagePacks(),p=Object.keys(C).map(w=>{const t=C[w];return{...this.createQuickPickItem(w,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.createQuickPickItem("en","English")),p.sort((w,t)=>w.label.localeCompare(t.label)),p}async postInstallExtension(C){C&&C.manifest&&C.manifest.contributes&&C.manifest.contributes.localizations&&C.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",C.identifier.id),await this.update())}async postUninstallExtension(C){const p=await this.cache.getLanguagePacks();Object.keys(p).some(w=>p[w]&&p[w].extensions.some(t=>(0,k.areSameExtensions)(t.extensionIdentifier,C.identifier)))&&(this.logService.info("Removing language packs from the extension",C.identifier.id),await this.update())}async update(){const[C,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),w=await this.cache.update(p);return!(0,T.equals)(Object.keys(C),Object.keys(w))}};e.NativeLanguagePackService=y,e.NativeLanguagePackService=y=ve([re(0,S.IExtensionManagementService),re(1,l.INativeEnvironmentService),re(2,S.IExtensionGalleryService),re(3,g.ILogService)],y);let m=class extends N.Disposable{constructor(C,p){super(),this.logService=p,this.languagePacks={},this.languagePacksFilePath=(0,E.join)(C.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(C){return this.withLanguagePacks(p=>{Object.keys(p).forEach(w=>delete p[w]),this.createLanguagePacksFromExtensions(p,...C)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(C,...p){for(const w of p)w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(C,w);Object.keys(C).forEach(w=>this.updateHash(C[w]))}createLanguagePacksFromExtension(C,p){const w=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const a of t)if(p.location.scheme===A.Schemas.file&&d(a)){let i=C[a.languageId];i||(i={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},C[a.languageId]=i);const r=i.extensions.filter(n=>(0,k.areSameExtensions)(n.extensionIdentifier,w))[0];r?r.version=p.manifest.version:i.extensions.push({extensionIdentifier:w,version:p.manifest.version});for(const n of a.translations)i.translations[n.id]=(0,E.join)(p.location.fsPath,n.path)}}updateHash(C){if(C){const p=(0,x.createHash)("md5");for(const w of C.extensions)p.update(w.extensionIdentifier.uuid||w.extensionIdentifier.id).update(w.version);C.hash=p.digest("hex")}}withLanguagePacks(C=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return u.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,w=>w.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(w)).then(w=>{try{return JSON.parse(w)}catch{return{}}}).then(w=>(p=C(w),w)).then(w=>{for(const a of Object.keys(w))w[a]||delete w[a];this.languagePacks=w,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),u.Promises.writeFile(this.languagePacksFilePath,t)}).then(()=>p,w=>this.logService.error(w))})}};m=ve([re(0,l.INativeEnvironmentService),re(1,g.ILogService)],m);function d(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const C of h.translations)if(typeof C.id!="string"||typeof C.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(ne[144],se([0,1,82,9,30,39]),function(q,e,x,T,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://0.0.0.0/OneCollector/1.0",E="https://0.0.0.0/ping";async function u(S,k,g){const f=await(0,x.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),R=await(0,x.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new f.AppInsightsCore,m=new R.PostChannel,d={instrumentationKey:S,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(g){d.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:g};d.extensionConfig[m.identifier]=h}return y.initialize(d,[]),y}class l{constructor(k,g,f,R,y){this._isInternalTelemetry=k,this._eventPrefix=g,this._defaultData=f,this._xhrOverride=y,this.endPointUrl=A,this.endPointHealthUrl=E,this._defaultData||(this._defaultData={}),typeof R=="function"?this._aiCoreOrKey=R():this._aiCoreOrKey=R,this._asyncAiCore=null}_withAIClient(k){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){k(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=u(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(g=>{k(g)},g=>{(0,T.onUnexpectedError)(g),console.error(g)})}}log(k,g){if(!this._aiCoreOrKey)return;g=(0,L.mixin)(g,this._defaultData),g=(0,N.validateTelemetryData)(g);const f=this._eventPrefix+"/"+k;try{this._withAIClient(R=>{R.pluginVersionString=g?.properties.version??"Unknown",R.track({name:f,baseData:{name:f,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(k=>{this._withAIClient(g=>{g.unload(!0,()=>{this._aiCoreOrKey=void 0,k(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=l}),define(ne[145],se([0,1,2,30,12,28,105,25,44,146,31,36,26,39]),function(q,e,x,T,L,N,A,E,u,l,S,k,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let R=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,h,C){this._configurationService=h,this._productService=C,this._experimentProperties={},this._disposables=new x.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=d.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,N.escapeRegExpCharacters)(p),"gi")),p.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,N.escapeRegExpCharacters)(p.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(p=>{(p.affectsConfiguration(g.TELEMETRY_SETTING_ID)||p.affectsConfiguration(g.TELEMETRY_OLD_SETTING_ID)||p.affectsConfiguration(g.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(d,h){this._experimentProperties[d]=h}_updateTelemetryLevel(){let d=(0,f.getTelemetryLevel)(this._configurationService);const h=this._productService.enabledTelemetryLevels;if(h){this._sendErrorTelemetry=this.sendErrorTelemetry?h.error:!1;const C=h.usage?3:h.error?2:0;d=Math.min(d,C)}this._telemetryLevel=d}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(d,h,C){this._telemetryLevel<h||(C=(0,T.mixin)(C,this._experimentProperties),C=(0,f.cleanData)(C,this._cleanupPatterns),C=(0,T.mixin)(C,this._commonProperties),this._appenders.forEach(p=>p.log(d,C)))}publicLog(d,h){this._log(d,3,h)}publicLog2(d,h){this.publicLog(d,h)}publicLogError(d,h){this._sendErrorTelemetry&&this._log(d,2,h)}publicLogError2(d,h){this.publicLogError(d,h)}};e.TelemetryService=R,e.TelemetryService=R=ve([re(1,E.IConfigurationService),re(2,S.IProductService)],R);function y(){const m=(0,A.localize)(0,null,l.default.nameLong),d=l.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=L.isWeb?"":(0,A.localize)(3,null),C=(0,A.localize)(4,null),p=(0,A.localize)(5,null),w=(0,A.localize)(6,null),t=(0,A.localize)(7,null),a=`
|       | ${C} | ${p} | ${w} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,A.localize)(8,null);return`
${m} ${d} ${h}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}k.Registry.as(u.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:y(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),k.Registry.as(u.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,A.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,A.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],se([0,1,14,20,144]),function(q,e,x,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function N(u,l){const S=await l.request(u,T.CancellationToken.None),k=(await(0,x.streamToBuffer)(S.stream)).toString(),g=S.res.statusCode??200;return{headers:S.res.headers,statusCode:g,responseData:k}}function A(u,l){const S={method:u.type,headers:u.headers},k=l.request(u.url??"",S,g=>{g.on("data",function(f){return{headers:g.headers,statusCode:g.statusCode??200,responseData:f.toString()}}),g.on("error",function(f){throw f})});k.write(u.data),k.end()}class E extends L.AbstractOneDataSystemAppender{constructor(l,S,k,g,f){let R;l||(R=q("https"));const y={sendPOST:(m,d)=>{const h=typeof m.data=="string"?m.data:new TextDecoder().decode(m.data),C={type:"POST",headers:{...m.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(m.data).toString()},url:m.urlString,data:h};try{if(l)N(C,l).then(({statusCode:p,headers:w,responseData:t})=>{d(p,w,t)});else{if(!R)throw new Error("https module is undefined");A(C,R)}}catch{d(0,{})}}};super(S,k,g,f,y)}}e.OneDataSystemAppender=E}),define(ne[148],se([0,1,16,24]),function(q,e,x,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function L(N,A){const E=Object.create(null),u=(S,k)=>{const g=JSON.parse(S);E[k]=g};if(A){const S=[],k=await T.Promises.readdir(A);for(const f of k)try{(await T.Promises.stat((0,x.join)(A,f))).isDirectory()&&S.push(f)}catch{}const g=[];for(const f of S)(await T.Promises.readdir((0,x.join)(A,f))).filter(y=>y==="telemetry.json").length===1&&g.push(f);for(const f of g){const R=(await T.Promises.readFile((0,x.join)(A,f,"telemetry.json"))).toString();u(R,f)}}let l=(await T.Promises.readFile((0,x.join)(N,"telemetry-core.json"))).toString();return u(l,"vscode-core"),l=(await T.Promises.readFile((0,x.join)(N,"telemetry-extensions.json"))).toString(),u(l,"vscode-extensions"),JSON.stringify(E,null,4)}e.buildTelemetryMessage=L}),define(ne[149],se([0,1,12,75,26]),function(q,e,x,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function N(A,E){let u=A.getItem(L.machineIdKey);return(typeof u!="string"||x.isMacintosh&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,T.getMachineId)(E.error.bind(E))),u}e.resolveMachineId=N}),define(ne[22],se([0,1,10]),function(q,e,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,x.createDecorator)("IUriIdentityService")}),define(ne[150],se([0,1,22,114,13,17,73,4,2]),function(q,e,x,T,L,N,A,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{static{this._clock=0}constructor(g){this.uri=g,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let S=class{constructor(g){this._fileService=g,this._dispooables=new u.DisposableStore,this._limit=2**16;const f=new Map,R=y=>{let m=f.get(y.scheme);return m===void 0&&(m=g.hasProvider(y)&&!this._fileService.hasCapability(y,1024),f.set(y.scheme,m)),m};this._dispooables.add(E.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(y=>{f.delete(y.scheme)})),this.extUri=new N.ExtUri(R),this._canonicalUris=new A.SkipList((y,m)=>this.extUri.compare(y,m,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,N.normalizePath)(g));const f=this._canonicalUris.get(g);return f?f.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new l(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((R,y)=>R[1].time<y[1].time?1:R[1].time>y[1].time?-1:0);l._clock=0,this._canonicalUris.clear();const f=this._limit*.5;for(let R=0;R<f;R++)this._canonicalUris.set(g[R][0],g[R][1].touch())}};e.UriIdentityService=S,e.UriIdentityService=S=ve([re(0,L.IFileService)],S),(0,T.registerSingleton)(x.IUriIdentityService,S,1)}),define(ne[151],se([0,1,4,2,13,41,46,14]),function(q,e,x,T,L,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class u extends T.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(S,k,g,f){super(),this.fileSystemScheme=S,this.fileSystemProvider=k,this.userDataScheme=g,this.logService=f,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new x.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(R=>this.handleFileChanges(R)))}watch(S,k){this.watchResources.set(S,S);const g=this.fileSystemProvider.watch(this.toFileSystemResource(S),k);return(0,T.toDisposable)(()=>{this.watchResources.delete(S),g.dispose()})}stat(S){return this.fileSystemProvider.stat(this.toFileSystemResource(S))}mkdir(S){return this.fileSystemProvider.mkdir(this.toFileSystemResource(S))}rename(S,k,g){return this.fileSystemProvider.rename(this.toFileSystemResource(S),this.toFileSystemResource(k),g)}readFile(S){return this.fileSystemProvider.readFile(this.toFileSystemResource(S),{atomic:!0})}readFileStream(S,k,g){const f=(0,N.newWriteableStream)(R=>E.VSBuffer.concat(R.map(y=>E.VSBuffer.wrap(y))).buffer);return(async()=>{try{const R=await this.readFile(S);f.end(R)}catch(R){f.error(R),f.end()}})(),f}readdir(S){return this.fileSystemProvider.readdir(this.toFileSystemResource(S))}writeFile(S,k,g){return this.fileSystemProvider.writeFile(this.toFileSystemResource(S),k,g)}delete(S,k){return this.fileSystemProvider.delete(this.toFileSystemResource(S),k)}copy(S,k,g){if((0,L.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(S),this.toFileSystemResource(k),g);throw new Error("copy not supported")}handleFileChanges(S){const k=[];for(const g of S){if(g.resource.scheme!==this.fileSystemScheme)continue;const f=this.toUserDataResource(g.resource);this.watchResources.findSubstr(f)&&k.push({resource:f,type:g.type})}k.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(k))}toFileSystemResource(S){return S.with({scheme:this.fileSystemScheme})}toUserDataResource(S){return S.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=u}),define(ne[152],se([0,1,107,16,46,17,11,10,15]),function(q,e,x,T,L,N,A,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,E.createDecorator)("contextService");function l(r){const n=r;return typeof n?.id=="string"&&A.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=l;function S(r){return typeof r?.id=="string"&&!l(r)&&!g(r)}e.isEmptyWorkspaceIdentifier=S,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function k(r,n){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,T.basename)(r)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=r;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=k;function g(r){const n=r;return typeof n?.id=="string"&&A.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=g;function f(r){const n=r;if(n?.uri)return{id:n.id,uri:A.URI.revive(n.uri)};const o=r;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=f;var R;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(R||(e.WorkbenchState=R={}));function y(r){const n=r;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=y;function m(r){const n=r;return!!(n&&typeof n=="object"&&A.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=m;class d{constructor(n,o,c,D,P){this._id=n,this._transient=c,this._configuration=D,this._ignorePathCasing=P,this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class h{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,N.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function C(r){return new h({uri:r,index:0,name:(0,N.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=C,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,x.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(r,n){return N.extUriBiasedIgnorePathCase.isEqualOrParent(r,n.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function w(r){let n;return A.URI.isUri(r)?n=r:n=r.configuration,n?.scheme===u.Schemas.tmp}e.isTemporaryWorkspace=w,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(r){return r.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function a(r,n){return!p(r,n)&&!w(r)}e.isSavedWorkspace=a;function i(r){return(typeof r=="string"?(0,T.extname)(r):(0,N.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ne[23],se([0,1,42,4,2,17,11,106,18,13,10,6,152,35,22,8,29,28,3]),function(q,e,x,T,L,N,A,E,u,l,S,k,g,f,R,y,m,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var C;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState"})(C||(e.ProfileResourceType=C={}));function p(r){const n=r;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&A.URI.isUri(n.location)&&A.URI.isUri(n.globalStorageHome)&&A.URI.isUri(n.settingsResource)&&A.URI.isUri(n.keybindingsResource)&&A.URI.isUri(n.tasksResource)&&A.URI.isUri(n.snippetsHome)&&A.URI.isUri(n.extensionsResource))}e.isUserDataProfile=p,e.IUserDataProfilesService=(0,S.createDecorator)("IUserDataProfilesService");function w(r,n){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:A.URI.revive(r.location).with({scheme:n}),globalStorageHome:A.URI.revive(r.globalStorageHome).with({scheme:n}),settingsResource:A.URI.revive(r.settingsResource).with({scheme:n}),keybindingsResource:A.URI.revive(r.keybindingsResource).with({scheme:n}),tasksResource:A.URI.revive(r.tasksResource).with({scheme:n}),snippetsHome:A.URI.revive(r.snippetsHome).with({scheme:n}),extensionsResource:A.URI.revive(r.extensionsResource).with({scheme:n}),cacheHome:A.URI.revive(r.cacheHome).with({scheme:n}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=w;function t(r,n,o,c,D,P){return{id:r,name:n,location:o,isDefault:!1,shortName:D?.shortName,globalStorageHome:P&&D?.useDefaultFlags?.globalState?P.globalStorageHome:(0,N.joinPath)(o,"globalStorage"),settingsResource:P&&D?.useDefaultFlags?.settings?P.settingsResource:(0,N.joinPath)(o,"settings.json"),keybindingsResource:P&&D?.useDefaultFlags?.keybindings?P.keybindingsResource:(0,N.joinPath)(o,"keybindings.json"),tasksResource:P&&D?.useDefaultFlags?.tasks?P.tasksResource:(0,N.joinPath)(o,"tasks.json"),snippetsHome:P&&D?.useDefaultFlags?.snippets?P.snippetsHome:(0,N.joinPath)(o,"snippets"),extensionsResource:P&&D?.useDefaultFlags?.extensions?P.extensionsResource:(0,N.joinPath)(o,"extensions.json"),cacheHome:(0,N.joinPath)(c,r),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.toUserDataProfile=t;let a=class extends L.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,o,c,D){super(),this.environmentService=n,this.fileService=o,this.uriIdentityService=c,this.logService=D,this.enabled=!0,this._onDidChangeProfiles=this._register(new T.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new T.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new T.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new T.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,N.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,N.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=this.createDefaultProfile(),o=[n];if(this.enabled)try{for(const P of this.getStoredProfiles()){if(!P.name||!(0,h.isString)(P.name)||!P.location){this.logService.warn("Skipping the invalid stored profile",P.location||P.name);continue}o.push(t((0,N.basename)(P.location),P.name,P.location,this.profilesCacheHome,{shortName:P.shortName,useDefaultFlags:P.useDefaultFlags},n))}}catch(P){this.logService.error(P)}const c=new f.ResourceMap,D=new Map;if(o.length)try{const P=this.getStoredProfileAssociations();if(P.workspaces)for(const[b,O]of Object.entries(P.workspaces)){const j=A.URI.parse(b),ee=o.find(Y=>Y.id===O);ee&&c.set(j,ee)}if(P.emptyWindows)for(const[b,O]of Object.entries(P.emptyWindows)){const j=o.find(ee=>ee.id===O);j&&D.set(b,j)}}catch(P){this.logService.error(P)}this._profilesObject={profiles:o,workspaces:c,emptyWindows:D}}return this._profilesObject}createDefaultProfile(){const n=t("__default__profile__",(0,E.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...n,extensionsResource:this.getDefaultProfileExtensionsLocation()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",c=new RegExp(`${(0,d.escapeRegExpCharacters)(o)}\\s(\\d+)`);let D=0;for(const b of this.profiles){const O=c.exec(b.name),j=O?parseInt(O[1]):0;D=j>D?j:D}const P=`${o} ${D+1}`;return this.createProfile((0,x.hash)((0,m.generateUuid)()).toString(16),P,{transient:!0},n)}async createNamedProfile(n,o,c){return this.createProfile((0,x.hash)((0,m.generateUuid)()).toString(16),n,o,c)}async createProfile(n,o,c,D){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const P=await this.doCreateProfile(n,o,c);return D&&await this.setProfileForWorkspace(D,P),P}async doCreateProfile(n,o,c){if(!(0,h.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.profileCreationPromises.get(o);return D||(D=(async()=>{try{const P=this.profiles.find(j=>j.name===o||j.id===n);if(P)return P;const b=t(n,o,(0,N.joinPath)(this.profilesHome,n),this.profilesCacheHome,c,this.defaultProfile);await this.fileService.createFolder(b.location);const O=[];return this._onWillCreateProfile.fire({profile:b,join(j){O.push(j)}}),await y.Promises.settled(O),this.updateProfiles([b],[],[]),b}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,D)),D}async updateProfile(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(D=>D.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);return c=t(c.id,o.name??c.name,c.location,this.profilesCacheHome,{shortName:o.shortName??c.shortName,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[c]),c}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(D=>D.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:o,join(D){c.push(D)}});try{await Promise.allSettled(c)}catch(D){this.logService.error(D)}for(const D of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(D)?.id&&this.profilesObject.emptyWindows.delete(D);for(const D of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(D)?.id&&this.profilesObject.workspaces.delete(D);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{await this.fileService.del(o.cacheHome,{recursive:!0})}catch(D){(0,l.toFileOperationResult)(D)!==1&&this.logService.error(D)}}async setProfileForWorkspace(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(D=>D.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(n,c)}unsetWorkspace(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.getWorkspace(n);return A.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindows.get(o)??this.profilesObject.emptyWindows.get(o)}getWorkspace(n){return(0,g.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,g.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location)))}updateProfiles(n,o,c){const D=[...this.profiles,...n],P=[];this.transientProfilesObject.profiles=[];for(let b of D)b.isDefault||o.some(O=>b.id===O.id)||(b=c.find(O=>b.id===O.id)??b,b.isTransient?this.transientProfilesObject.profiles.push(b):P.push({location:b.location,name:b.name,shortName:b.shortName,useDefaultFlags:b.useDefaultFlags}));this.saveStoredProfiles(P),this._profilesObject=void 0,this.triggerProfilesChanges(n,o,c)}triggerProfilesChanges(n,o,c){this._onDidChangeProfiles.fire({added:n,removed:o,updated:c,all:this.profiles})}updateWorkspaceAssociation(n,o,c){c=o?.isTransient?!0:c,c||this.updateWorkspaceAssociation(n,void 0,!0);const D=this.getWorkspace(n),P=c?this.transientProfilesObject:this.profilesObject;A.URI.isUri(D)?(P.workspaces.delete(D),o&&P.workspaces.set(D,o)):(P.emptyWindows.delete(D),o&&P.emptyWindows.set(D,o)),c||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[c,D]of this.profilesObject.workspaces.entries())n[c.toString()]=D.id;const o={};for(const[c,D]of this.profilesObject.emptyWindows.entries())o[c.toString()]=D.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const o={},c=this.createDefaultProfile();if(n.workspaces)for(const[P,b]of Object.entries(n.workspaces)){const O=A.URI.parse(b);o[P]=this.uriIdentityService.extUri.isEqual(O,c.location)?c.id:this.uriIdentityService.extUri.basename(O)}const D={};if(n.emptyWindows)for(const[P,b]of Object.entries(n.emptyWindows)){const O=A.URI.parse(b);D[P]=this.uriIdentityService.extUri.isEqual(O,c.location)?c.id:this.uriIdentityService.extUri.basename(O)}return{workspaces:o,emptyWindows:D}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=a,e.UserDataProfilesService=a=ve([re(0,u.IEnvironmentService),re(1,l.IFileService),re(2,R.IUriIdentityService),re(3,k.ILogService)],a);class i extends a{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=i}),define(ne[153],se([0,1,19,8,20,9,4,2,12,3,11,91,21,27,37,6,31,26,22,23]),function(q,e,x,T,L,N,A,E,u,l,S,k,g,f,R,y,m,d,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.toExtensionManagementError=e.joinErrors=e.AbstractExtensionManagementService=void 0;let p=class extends E.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(n,o,c,D,P,b){super(),this.galleryService=n,this.telemetryService=o,this.uriIdentityService=c,this.logService=D,this.productService=P,this.userDataProfilesService=b,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this._onDidInstallExtensions=this._register(new A.Emitter),this._onUninstallExtension=this._register(new A.Emitter),this._onDidUninstallExtension=this._register(new A.Emitter),this._onDidUpdateExtensionMetadata=this._register(new A.Emitter),this.participants=[],this._register((0,E.toDisposable)(()=>{this.installingExtensions.forEach(({task:O})=>O.cancel()),this.uninstallingExtensions.forEach(O=>O.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const o=await this.getTargetPlatform();return n.allTargetPlatforms.some(c=>(0,g.isTargetPlatformCompatible)(c,n.allTargetPlatforms,o))}async installFromGallery(n,o={}){try{const D=(await this.installGalleryExtensions([{extension:n,options:o}])).find(({identifier:P})=>(0,f.areSameExtensions)(P,n.identifier));if(D?.local)return D?.local;throw D?.error?D.error:t(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(c){throw t(c)}}async installGalleryExtensions(n){if(!this.galleryService.isEnabled())throw new g.ExtensionManagementError(k.localize(0,null),g.ExtensionManagementErrorCode.Internal);const o=[],c=[];await Promise.allSettled(n.map(async({extension:D,options:P})=>{try{const b=await this.checkAndGetCompatibleVersion(D,!!P?.installGivenVersion,!!P?.installPreReleaseVersion);c.push({...b,options:P})}catch(b){o.push({identifier:D.identifier,operation:2,source:D,error:b})}})),c.length&&o.push(...await this.installExtensions(c));for(const D of o)D.error&&(this.logService.error("Failed to install extension.",D.identifier.id),this.logService.error(D.error),D.source&&!S.URI.isUri(D.source)&&a(this.telemetryService,"extensionGallery:install",{extensionData:(0,f.getGalleryExtensionTelemetryData)(D.source),error:D.error}));return o}async uninstall(n,o={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,o)}async toggleAppliationScope(n,o){if((0,R.isApplicationScopedExtension)(n.manifest))return n;if(n.isApplicationScoped){let c=await this.updateMetadata(n,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)||(c=await this.copyExtension(n,this.userDataProfilesService.defaultProfile.extensionsResource,o));for(const D of this.userDataProfilesService.profiles){const P=(await this.getInstalled(1,D.extensionsResource)).find(b=>(0,f.areSameExtensions)(b.identifier,n.identifier));P?this._onDidUpdateExtensionMetadata.fire(P):this._onDidUninstallExtension.fire({identifier:n.identifier,profileLocation:D.extensionsResource})}return c}else{const c=this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(n,o,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:c.identifier,operation:2,local:c,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),c}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtensions(n){const o=[];return await Promise.allSettled(n.map(async c=>{try{const D=await this.installExtension(c);o.push(...D)}catch(D){o.push({identifier:{id:(0,f.getGalleryExtensionId)(c.manifest.publisher,c.manifest.name)},operation:2,source:c.extension,error:D})}})),this._onDidInstallExtensions.fire(o),o}async installExtension({manifest:n,extension:o,options:c}){const D=c.isApplicationScoped||c.isBuiltin||(0,R.isApplicationScopedExtension)(n),P={...c,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(o)?c.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:D,profileLocation:D?this.userDataProfilesService.defaultProfile.extensionsResource:c.profileLocation??this.getCurrentExtensionsManifestLocation()},b=Z=>`${f.ExtensionKey.create(Z).toString()}${P.profileLocation?`-${P.profileLocation.toString()}`:""}`;if(!S.URI.isUri(o)){const Z=this.installingExtensions.get(b(o));if(Z)return this.logService.info("Extensions is already requested to install",o.identifier.id),await Z.task.waitUntilTaskIsFinished(),[]}const O=[],j=[],ee=[],Y=this.createInstallExtensionTask(n,o,P);S.URI.isUri(o)||this.installingExtensions.set(b(o),{task:Y,waitingTasks:[]}),this._onInstallExtension.fire({identifier:Y.identifier,source:o,profileLocation:P.profileLocation}),this.logService.info("Installing extension:",Y.identifier.id),O.push({task:Y,manifest:n});let ce=!1;try{if(P.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",Y.identifier.id);else try{const ae=await this.getAllDepsAndPackExtensions(Y.identifier,n,!!P.installOnlyNewlyAddedFromExtensionPack,!!P.installPreReleaseVersion,P.profileLocation),le=await this.getInstalled(void 0,P.profileLocation);for(const{gallery:te,manifest:V}of(0,x.distinct)(ae,({gallery:$})=>$.identifier.id)){ce=ce||!!V.extensionDependencies?.some(M=>(0,f.areSameExtensions)({id:M},Y.identifier));const $=b(te),U=this.installingExtensions.get($);if(U){if(this.canWaitForTask(Y,U.task)){const M=U.task.identifier;this.logService.info("Waiting for already requested installing extension",M.id,Y.identifier.id),U.waitingTasks.push(Y),j.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,z=>z.some(G=>(0,f.areSameExtensions)(G.identifier,M)))).then(z=>{if(this.logService.info("Finished waiting for already requested installing extension",M.id,Y.identifier.id),!z.find(K=>(0,f.areSameExtensions)(K.identifier,M))?.local)throw new Error(`Extension ${M.id} is not installed`)}))}}else if(!le.some(({identifier:M})=>(0,f.areSameExtensions)(M,te.identifier))){const M=this.createInstallExtensionTask(V,te,{...P,donotIncludePackAndDependencies:!0});this.installingExtensions.set($,{task:M,waitingTasks:[Y]}),this._onInstallExtension.fire({identifier:M.identifier,source:te,profileLocation:P.profileLocation}),this.logService.info("Installing extension:",M.identifier.id,Y.identifier.id),O.push({task:M,manifest:V})}}}catch(ae){if(S.URI.isUri(Y.source))(0,x.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",Y.identifier.id,ae.message),(0,x.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",Y.identifier.id,ae.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",Y.identifier.id),ae}const Z=O.reduce((ae,{task:le,manifest:te})=>(ae.set(le.identifier.id.toLowerCase(),{task:le,manifest:te}),ae),new Map);for(;Z.size;){let ae;const le=[...Z.values()].filter(({manifest:te})=>!te.extensionDependencies?.some(V=>Z.has(V.toLowerCase())));le.length?ae=Z.size===1?le:le.filter(({task:te})=>!(te===Y&&!ce)):(this.logService.info("Found extensions with circular dependencies",le.map(({task:te})=>te.identifier.id)),ae=[...Z.values()]),await this.joinAllSettled(ae.map(async({task:te})=>{const V=new Date().getTime();try{const $=await te.run();if(await this.joinAllSettled(this.participants.map(U=>U.postInstall($,te.source,P,L.CancellationToken.None))),!S.URI.isUri(te.source)){const U=te.operation===3,M=U?void 0:(new Date().getTime()-te.source.lastUpdated)/1e3;if(a(this.telemetryService,U?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.getGalleryExtensionTelemetryData)(te.source),verificationStatus:te.verificationStatus,duration:new Date().getTime()-V,durationSinceUpdate:M}),u.isWeb&&te.operation!==3)try{await this.galleryService.reportStatistic($.manifest.publisher,$.manifest.name,$.manifest.version,"install")}catch{}}ee.push({local:$,identifier:te.identifier,operation:te.operation,source:te.source,context:P.context,profileLocation:te.profileLocation,applicationScoped:$.isApplicationScoped})}catch($){throw S.URI.isUri(te.source)||a(this.telemetryService,te.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.getGalleryExtensionTelemetryData)(te.source),verificationStatus:te.verificationStatus,duration:new Date().getTime()-V,error:$}),this.logService.error("Error while installing the extension:",te.identifier.id),$}finally{Z.delete(te.identifier.id.toLowerCase())}}))}return j.length&&await this.joinAllSettled(j),ee.forEach(({identifier:ae})=>this.logService.info("Extension installed successfully:",ae.id)),ee}catch(Z){if(O.forEach(({task:ae})=>ae.cancel()),ee.length)try{const ae=await Promise.allSettled(ee.map(({local:le})=>this.createUninstallExtensionTask(le,{versionOnly:!0,profileLocation:P.profileLocation}).run()));for(let le=0;le<ae.length;le++){const te=ae[le],{identifier:V}=ee[le];te.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",V.id):this.logService.warn("Rollback: Error while uninstalling extension",V.id,(0,N.getErrorMessage)(te.reason))}}catch(ae){this.logService.warn("Error while rolling back extensions",(0,N.getErrorMessage)(ae),ee.map(({identifier:le})=>le.id))}return O.map(({task:ae})=>({identifier:ae.identifier,operation:2,source:ae.source,context:P.context,profileLocation:P.profileLocation,error:Z}))}finally{for(const{task:Z}of O)Z.source&&!S.URI.isUri(Z.source)&&this.installingExtensions.delete(b(Z.source))}}canWaitForTask(n,o){for(const[,{task:c,waitingTasks:D}]of this.installingExtensions.entries())if(c===n&&(D.includes(o)||D.some(P=>this.canWaitForTask(P,o)))||c===o&&D[0]&&!this.canWaitForTask(n,D[0]))return!1;return!0}async joinAllSettled(n){const o=[],c=[],D=await Promise.allSettled(n);for(const P of D)P.status==="fulfilled"?o.push(P.value):c.push(P.reason);if(c.length)throw w(c);return o}async getAllDepsAndPackExtensions(n,o,c,D,P){if(!this.galleryService.isEnabled())return[];const b=await this.getInstalled(void 0,P),O=[],j=[],ee=async(Y,ce)=>{O.push(Y);const Z=ce.extensionDependencies||[],ae=[...Z];if(ce.extensionPack){const le=c?b.find(te=>(0,f.areSameExtensions)(te.identifier,Y)):void 0;for(const te of ce.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(V=>(0,f.areSameExtensions)({id:V},{id:te}))||ae.every(V=>!(0,f.areSameExtensions)({id:V},{id:te}))&&ae.push(te)}if(ae.length){const le=ae.filter(te=>O.every(V=>!(0,f.areSameExtensions)(V,{id:te})));if(le.length){const te=await this.galleryService.getExtensions(le.map(V=>({id:V,preRelease:D})),L.CancellationToken.None);for(const V of te){if(O.find(M=>(0,f.areSameExtensions)(M,V.identifier)))continue;const $=Z.some(M=>(0,f.areSameExtensions)({id:M},V.identifier));let U;try{U=await this.checkAndGetCompatibleVersion(V,!1,D)}catch(M){if($)throw M;this.logService.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,N.getErrorMessage)(M));continue}j.push({gallery:U.extension,manifest:U.manifest}),await ee(U.extension.identifier,U.manifest)}}}};return await ee(n,o),j}async checkAndGetCompatibleVersion(n,o,c){let D;const P=await this.getExtensionsControlManifest();if(P.malicious.some(j=>(0,f.areSameExtensions)(n.identifier,j)))throw new g.ExtensionManagementError(k.localize(1,null,n.identifier.id),g.ExtensionManagementErrorCode.Malicious);const b=P.deprecated[n.identifier.id.toLowerCase()];if(b?.extension?.autoMigrate){if(this.logService.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${b.extension.id}' extension instead.`),D=(await this.galleryService.getExtensions([{id:b.extension.id,preRelease:b.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0],!D)throw new g.ExtensionManagementError(k.localize(2,null,n.identifier.id,b.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const j=await this.getTargetPlatform();throw new g.ExtensionManagementError(k.localize(3,null,n.identifier.id,this.productService.nameLong,(0,g.TargetPlatformToString)(j)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(D=await this.getCompatibleVersion(n,o,c),!D)throw!c&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],L.CancellationToken.None))[0]?new g.ExtensionManagementError(k.localize(4,null,n.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.ExtensionManagementError(k.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),g.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",D.identifier.id);const O=await this.galleryService.getManifest(D,L.CancellationToken.None);if(O===null)throw new g.ExtensionManagementError(`Missing manifest for extension ${D.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(O.version!==D.version)throw new g.ExtensionManagementError(`Cannot install '${D.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:D,manifest:O}}async getCompatibleVersion(n,o,c){const D=await this.getTargetPlatform();let P=null;return!o&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==c&&(P=(await this.galleryService.getExtensions([{...n.identifier,preRelease:c}],{targetPlatform:D,compatible:!0},L.CancellationToken.None))[0]||null),!P&&await this.galleryService.isExtensionCompatible(n,c,D)&&(P=n),P||(o?P=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:D,compatible:!0},L.CancellationToken.None))[0]||null:P=await this.galleryService.getCompatibleExtension(n,c,D)),P}async uninstallExtension(n,o){const c={...o,profileLocation:n.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:o.profileLocation??this.getCurrentExtensionsManifestLocation()},D=Y=>`${Y.id.toLowerCase()}${c.versionOnly?`-${n.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,P=this.uninstallingExtensions.get(D(n.identifier));if(P)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),P.waitUntilTaskIsFinished();const b=Y=>{const ce=this.createUninstallExtensionTask(Y,c);return this.uninstallingExtensions.set(D(ce.extension.identifier),ce),c.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,c.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${Y.identifier.id}@${Y.manifest.version}`),this._onUninstallExtension.fire({identifier:Y.identifier,profileLocation:c.profileLocation,applicationScoped:Y.isApplicationScoped}),ce},O=(Y,ce)=>{ce?c.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,c.profileLocation.toString(),ce.message):this.logService.error("Failed to uninstall extension:",`${Y.identifier.id}@${Y.manifest.version}`,ce.message):c.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${Y.identifier.id}@${Y.manifest.version}`,c.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${Y.identifier.id}@${Y.manifest.version}`),a(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,f.getLocalExtensionTelemetryData)(Y),error:ce}),this._onDidUninstallExtension.fire({identifier:Y.identifier,error:ce?.code,profileLocation:c.profileLocation,applicationScoped:Y.isApplicationScoped})},j=[],ee=[];try{j.push(b(n));const Y=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const ce=this.getAllPackExtensionsToUninstall(n,Y);for(const Z of ce)this.uninstallingExtensions.has(D(Z.identifier))?this.logService.info("Extensions is already requested to uninstall",Z.identifier.id):j.push(b(Z))}c.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents(j.map(ce=>ce.extension),Y,n),await this.joinAllSettled(j.map(async ce=>{try{if(await ce.run(),await this.joinAllSettled(this.participants.map(Z=>Z.postUninstall(ce.extension,c,L.CancellationToken.None))),ce.extension.identifier.uuid)try{await this.galleryService.reportStatistic(ce.extension.manifest.publisher,ce.extension.manifest.name,ce.extension.manifest.version,"uninstall")}catch{}O(ce.extension)}catch(Z){const ae=Z instanceof g.ExtensionManagementError?Z:new g.ExtensionManagementError((0,N.getErrorMessage)(Z),g.ExtensionManagementErrorCode.Internal);throw O(ce.extension,ae),ae}finally{ee.push(ce)}}))}catch(Y){const ce=Y instanceof g.ExtensionManagementError?Y:new g.ExtensionManagementError((0,N.getErrorMessage)(Y),g.ExtensionManagementErrorCode.Internal);for(const Z of j){try{Z.cancel()}catch{}ee.includes(Z)||O(Z.extension,ce)}throw ce}finally{for(const Y of j)this.uninstallingExtensions.delete(D(Y.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",Y.extension.identifier.id)}}checkForDependents(n,o,c){for(const D of n){const P=this.getDependents(D,o);if(P.length){const b=P.filter(O=>!n.some(j=>(0,f.areSameExtensions)(j.identifier,O.identifier)));if(b.length)throw new Error(this.getDependentsErrorMessage(D,b,c))}}}getDependentsErrorMessage(n,o,c){return c===n?o.length===1?k.localize(6,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?k.localize(7,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):k.localize(8,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?k.localize(9,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?k.localize(10,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):k.localize(11,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(n,o,c=[]){if(c.indexOf(n)!==-1)return[];c.push(n);const D=n.manifest.extensionPack?n.manifest.extensionPack:[];if(D.length){const P=o.filter(O=>!O.isBuiltin&&D.some(j=>(0,f.areSameExtensions)({id:j},O.identifier))),b=[];for(const O of P)b.push(...this.getAllPackExtensionsToUninstall(O,o,c));return[...P,...b]}return[]}getDependents(n,o){return o.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(D=>(0,f.areSameExtensions)({id:D},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=p,e.AbstractExtensionManagementService=p=ve([re(0,g.IExtensionGalleryService),re(1,d.ITelemetryService),re(2,h.IUriIdentityService),re(3,y.ILogService),re(4,m.IProductService),re(5,C.IUserDataProfilesService)],p);function w(r){const n=Array.isArray(r)?r:[r];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((o,c)=>new Error(`${o.message}${o.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.joinErrors=w;function t(r){if(r instanceof g.ExtensionManagementError)return r;const n=new g.ExtensionManagementError(r.message,g.ExtensionManagementErrorCode.Internal);return n.stack=r.stack,n}e.toExtensionManagementError=t;function a(r,n,{extensionData:o,verificationStatus:c,duration:D,error:P,durationSinceUpdate:b}){let O,j;(0,l.isDefined)(c)&&(c===!0?c="Verified":(c===!1||(O=g.ExtensionManagementErrorCode.Signature,j=c),c="Unverified")),P&&(P instanceof g.ExtensionManagementError?(O=P.code,P.code===g.ExtensionManagementErrorCode.Signature&&(j=P.message)):O=g.ExtensionManagementErrorCode.Internal),r.publicLog(n,{...o,verificationStatus:c,success:!P,duration:D,errorcode:O,errorcodeDetail:j,durationSinceUpdate:b})}class i{constructor(){this.barrier=new T.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(n=>new Promise((o,c)=>{const D=n.onCancellationRequested(()=>{D.dispose(),c(new N.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=i}),define(ne[40],se([0,1,8,14,2,4,35,11,21,27,13,10,6,23,22,3,9,26]),function(q,e,x,T,L,N,A,E,u,l,S,k,g,f,R,y,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class C extends Error{constructor(i,r){super(i),this.code=r}}e.ExtensionsProfileScanningError=C,e.IExtensionsProfileScannerService=(0,k.createDecorator)("IExtensionsProfileScannerService");let p=class extends L.Disposable{constructor(i,r,n,o,c,D){super(),this.extensionsLocation=i,this.fileService=r,this.userDataProfilesService=n,this.uriIdentityService=o,this.telemetryService=c,this.logService=D,this._onAddExtensions=this._register(new N.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new N.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new N.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new N.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new A.ResourceMap}scanProfileExtensions(i,r){return this.withProfileExtensions(i,void 0,r)}async addExtensionsToProfile(i,r){const n=[],o=[];try{return await this.withProfileExtensions(r,c=>{const D=[];for(const P of c)i.some(([b])=>(0,l.areSameExtensions)(b.identifier,P.identifier)&&b.manifest.version!==P.version)?n.push(P):D.push(P);for(const[P,b]of i)if(!D.some(O=>(0,l.areSameExtensions)(O.identifier,P.identifier)&&O.version===P.manifest.version)){const O={identifier:P.identifier,version:P.manifest.version,location:P.location,metadata:b};o.push(O),D.push(O)}return o.length&&this._onAddExtensions.fire({extensions:o,profileLocation:r}),n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:r}),D}),o.length&&this._onDidAddExtensions.fire({extensions:o,profileLocation:r}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:r}),o}catch(c){throw o.length&&this._onDidAddExtensions.fire({extensions:o,error:c,profileLocation:r}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:c,profileLocation:r}),c}}async updateMetadata(i,r){const n=[];return await this.withProfileExtensions(r,o=>{const c=[];for(const D of o){const P=i.find(([b])=>(0,l.areSameExtensions)(b.identifier,D.identifier)&&b.manifest.version===D.version);P&&(D.metadata={...D.metadata,...P[1]},n.push(D)),c.push(D)}return c}),n}async removeExtensionFromProfile(i,r){const n=[];this._onRemoveExtensions.fire({extensions:n,profileLocation:r});try{await this.withProfileExtensions(r,o=>{const c=[];for(const D of o)(0,l.areSameExtensions)(D.identifier,i.identifier)?n.push(D):c.push(D);return n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:r}),c}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:r})}catch(o){throw n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:o,profileLocation:r}),o}}async withProfileExtensions(i,r,n){return this.getResourceAccessQueue(i).queue(async()=>{let o=[],c;try{const D=await this.fileService.readFile(i);c=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,S.toFileOperationResult)(D)!==1)throw D;if(this.uriIdentityService.extUri.isEqual(i,this.userDataProfilesService.defaultProfile.extensionsResource)&&(c=await this.migrateFromOldDefaultProfileExtensionsLocation()),!c&&n?.bailOutWhenFileNotFound)throw new C((0,m.getErrorMessage)(D),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.reportAndThrowInvalidConentError(i);let D=!1;for(const P of c){w(P)||this.reportAndThrowInvalidConentError(i);let b;if((0,y.isString)(P.relativeLocation)&&P.relativeLocation)b=this.resolveExtensionLocation(P.relativeLocation);else if((0,y.isString)(P.location))b=this.resolveExtensionLocation(P.location),D=!0,P.relativeLocation=P.location,P.location=b.toJSON();else{b=E.URI.revive(P.location);const O=this.toRelativePath(b);O&&(D=!0,P.relativeLocation=O)}o.push({identifier:P.identifier,location:b,version:P.version,metadata:P.metadata})}D&&await this.fileService.writeFile(i,T.VSBuffer.fromString(JSON.stringify(c)))}if(r){o=r(o);const D=o.map(P=>({identifier:P.identifier,version:P.version,location:P.location.toJSON(),relativeLocation:this.toRelativePath(P.location),metadata:P.metadata}));await this.fileService.writeFile(i,T.VSBuffer.fromString(JSON.stringify(D)))}return o})}reportAndThrowInvalidConentError(i){const r=new C(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:r.code}),r}toRelativePath(i){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(i),this.extensionsLocation)?this.uriIdentityService.extUri.basename(i):void 0}resolveExtensionLocation(i){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,i)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const i=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),r=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let n;try{n=(await this.fileService.readFile(i)).value.toString()}catch(c){if((0,S.toFileOperationResult)(c)===1)return;throw c}this.logService.info("Migrating extensions from old default profile location",i.toString());let o;try{const c=JSON.parse(n);Array.isArray(c)&&c.every(D=>w(D))?o=c:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.logService.error(c)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,T.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(c){if((0,S.toFileOperationResult)(c)===3)this.logService.info("Migration from old default profile location to new location is done by another window",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw c}try{await this.fileService.del(i)}catch(c){(0,S.toFileOperationResult)(c)!==1&&this.logService.error(c)}try{await this.fileService.del(r)}catch(c){(0,S.toFileOperationResult)(c)!==1&&this.logService.error(c)}return o})()),this._migrationPromise}getResourceAccessQueue(i){let r=this.resourcesAccessQueueMap.get(i);return r||(r=new x.Queue,this.resourcesAccessQueueMap.set(i,r)),r}};e.AbstractExtensionsProfileScannerService=p,e.AbstractExtensionsProfileScannerService=p=ve([re(1,S.IFileService),re(2,f.IUserDataProfilesService),re(3,R.IUriIdentityService),re(4,d.ITelemetryService),re(5,g.ILogService)],p);function w(a){return(0,y.isObject)(a)&&(0,u.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,y.isString)(a.location)&&a.location)&&((0,y.isUndefined)(a.relativeLocation)||(0,y.isString)(a.relativeLocation))&&a.version&&(0,y.isString)(a.version)}function t(a){return a?(0,y.isString)(a.path)&&(0,y.isString)(a.scheme):!1}}),define(ne[50],se([0,1,19,8,30,14,9,53,80,2,15,16,12,17,43,54,3,11,95,18,27,37,48,13,10,6,31,4,47,40,23,22,112]),function(q,e,x,T,L,N,A,E,u,l,S,k,g,f,R,y,m,d,h,C,p,w,t,a,i,r,n,o,c,D,P,b,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var j;(function(te){function V($,U){if($===U)return!0;const M=Object.keys($),z=new Set;for(const G of Object.keys(U))z.add(G);if(M.length!==z.size)return!1;for(const G of M){if($[G]!==U[G])return!1;z.delete(G)}return z.size===0}te.equals=V})(j||(e.Translations=j={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let ee=class extends l.Disposable{constructor(V,$,U,M,z,G,K,J,oe,I,s,v){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=$,this.extensionsControlLocation=U,this.currentProfile=M,this.userDataProfilesService=z,this.extensionsProfileScannerService=G,this.fileService=K,this.logService=J,this.environmentService=oe,this.productService=I,this.uriIdentityService=s,this.instantiationService=v,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Z,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Z,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ce,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,p.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(V,$,U){const[M,z]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions($)]),G=U?await this.scanExtensionsUnderDevelopment(V,[...M,...z]):[];return this.dedupExtensions(M,z,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const $=[];$.push(this.scanDefaultSystemExtensions(!!V.useCache,V.language)),$.push(this.scanDevSystemExtensions(V.language,!!V.checkControlFile));const[U,M]=await Promise.all($);return this.applyScanOptions([...U,...M],0,V,!1)}async scanUserExtensions(V){const $=V.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",$);const U=this.uriIdentityService.extUri.isEqual(V.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.createExtensionScannerInput($,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,U),z=V.useCache&&!M.devMode&&M.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let G;try{G=await z.scanExtensions(M)}catch(K){if(K instanceof D.ExtensionsProfileScanningError&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),G=await z.scanExtensions(M);else throw K}return G=await this.applyScanOptions(G,1,V,!0),this.logService.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(V,$){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const U=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(M=>M.scheme===S.Schemas.file).map(async M=>{const z=await this.createExtensionScannerInput(M,!1,1,!0,V.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(z)).map(K=>(K.type=$.find(J=>(0,p.areSameExtensions)(J.identifier,K.identifier))?.type??K.type,this.extensionsScanner.validate(K,z)))}))).flat();return this.applyScanOptions(U,"development",V,!0)}return[]}async scanExistingExtension(V,$,U){const M=await this.createExtensionScannerInput(V,!1,$,!0,U.language,!0,void 0),z=await this.extensionsScanner.scanExtension(M);return!z||!U.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions(V,$,U){const M=await this.createExtensionScannerInput(V,!1,$,!0,U.language,!0,void 0),z=await this.extensionsScanner.scanOneOrMultipleExtensions(M);return this.applyScanOptions(z,$,U,!0)}async scanMetadata(V){const $=(0,f.joinPath)(V,"package.json"),U=(await this.fileService.readFile($)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(V,$){const U=(0,f.joinPath)(V,"package.json"),M=(await this.fileService.readFile(U)).value.toString(),z=JSON.parse(M);$.isMachineScoped=$.isMachineScoped||void 0,$.isBuiltin=$.isBuiltin||void 0,z.__metadata={...z.__metadata,...$},await this.fileService.writeFile((0,f.joinPath)(V,"package.json"),N.VSBuffer.fromString(JSON.stringify(z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof D.ExtensionsProfileScanningError&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw V}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.extensionsProfileScannerService.addExtensionsToProfile(V.map($=>[$,$.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,N.VSBuffer.fromString(JSON.stringify([])))}catch($){(0,a.toFileOperationResult)($)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.getErrorMessage)($))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.logService.error(V)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(V,$,U,M){return U.includeAllVersions||(V=this.dedupExtensions($===0?V:void 0,$===1?V:void 0,$==="development"?V:void 0,await this.getTargetPlatform(),M)),U.includeInvalid||(V=V.filter(z=>z.isValid)),V.sort((z,G)=>{const K=k.basename(z.location.fsPath),J=k.basename(G.location.fsPath);return K<J?-1:K>J?1:0})}dedupExtensions(V,$,U,M,z){const G=(J,oe,I)=>{if(J.isValid&&!oe.isValid)return!1;if(J.isValid===oe.isValid){if(z&&R.gt(J.manifest.version,oe.manifest.version))return this.logService.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${J.location.path} with version ${J.manifest.version}`),!1;if(R.eq(J.manifest.version,oe.manifest.version)){if(J.type===0)return this.logService.debug(`Skipping extension ${oe.location.path} in favour of system extension ${J.location.path} with same version`),!1;if(J.targetPlatform===M)return this.logService.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return I?this.logService.warn(`Overwriting user extension ${J.location.path} with ${oe.location.path}.`):this.logService.debug(`Overwriting user extension ${J.location.path} with ${oe.location.path}.`),!0},K=new w.ExtensionIdentifierMap;return V?.forEach(J=>{const oe=K.get(J.identifier.id);(!oe||G(oe,J,!1))&&K.set(J.identifier.id,J)}),$?.forEach(J=>{const oe=K.get(J.identifier.id);if(!oe&&V&&J.type===0){this.logService.debug(`Skipping obsolete system extension ${J.location.path}.`);return}(!oe||G(oe,J,!1))&&K.set(J.identifier.id,J)}),U?.forEach(J=>{const oe=K.get(J.identifier.id);(!oe||G(oe,J,!0))&&K.set(J.identifier.id,J),K.set(J.identifier.id,J)}),[...K.values()]}async scanDefaultSystemExtensions(V,$){this.logService.trace("Started scanning system extensions");const U=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,$,!0,void 0),z=await(V&&!U.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(U);return this.logService.trace("Scanned system extensions:",z.length),z}async scanDevSystemExtensions(V,$){const U=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!U?.length)return[];this.logService.trace("Started scanning dev system extensions");const M=$?await this.getBuiltInExtensionControl():{},z=[],G=d.URI.file(k.normalize(k.join(S.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const J of U){const oe=M[J.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":z.push((0,f.joinPath)(G,J.name));break;default:z.push(d.URI.file(oe));break}}const K=await Promise.all(z.map(async J=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(J,!1,0,!0,V,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",K.length),(0,x.coalesce)(K)}async getBuiltInExtensionControl(){try{const V=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(V.value.toString())}catch{return{}}}async createExtensionScannerInput(V,$,U,M,z,G,K){const J=await this.getTranslations(z??g.language),oe=await this.getMtime(V),I=$&&!this.uriIdentityService.extUri.isEqual(V,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,s=I?await this.getMtime(I):void 0;return new Y(V,oe,I,s,$,K,U,M,G,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,z,J)}async getMtime(V){try{const $=await this.fileService.stat(V);if(typeof $.mtime=="number")return $.mtime}catch{}}};e.AbstractExtensionsScannerService=ee,e.AbstractExtensionsScannerService=ee=ve([re(4,P.IUserDataProfilesService),re(5,D.IExtensionsProfileScannerService),re(6,a.IFileService),re(7,r.ILogService),re(8,C.IEnvironmentService),re(9,n.IProductService),re(10,b.IUriIdentityService),re(11,i.IInstantiationService)],ee);class Y{constructor(V,$,U,M,z,G,K,J,oe,I,s,v,F,_,B){this.location=V,this.mtime=$,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=M,this.profile=z,this.profileScanOptions=G,this.type=K,this.excludeObsolete=J,this.validate=oe,this.productVersion=I,this.productDate=s,this.productCommit=v,this.devMode=F,this.language=_,this.translations=B}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,$){return(0,f.isEqual)(V.location,$.location)&&V.mtime===$.mtime&&(0,f.isEqual)(V.applicationExtensionslocation,$.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===$.applicationExtensionslocationMtime&&V.profile===$.profile&&L.equals(V.profileScanOptions,$.profileScanOptions)&&V.type===$.type&&V.excludeObsolete===$.excludeObsolete&&V.validate===$.validate&&V.productVersion===$.productVersion&&V.productDate===$.productDate&&V.productCommit===$.productCommit&&V.devMode===$.devMode&&V.language===$.language&&j.equals(V.translations,$.translations)}}e.ExtensionScannerInput=Y;let ce=class extends l.Disposable{constructor(V,$,U,M,z){super(),this.obsoleteFile=V,this.extensionsProfileScannerService=$,this.uriIdentityService=U,this.fileService=M,this.logService=z}async scanExtensions(V){const $=V.profile?await this.scanExtensionsFromProfile(V):await this.scanExtensionsFromLocation(V);let U={};if(V.excludeObsolete&&V.type===1)try{const M=(await this.fileService.readFile(this.obsoleteFile)).value.toString();U=JSON.parse(M)}catch{}return(0,m.isEmptyObject)(U)?$:$.filter(M=>!U[p.ExtensionKey.create(M).toString()])}async scanExtensionsFromLocation(V){const $=await this.fileService.resolve(V.location);if(!$.children?.length)return[];const U=await Promise.all($.children.map(async M=>{if(!M.isDirectory||V.type===1&&(0,f.basename)(M.resource).indexOf(".")===0)return null;const z=new Y(M.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(z)}));return(0,x.coalesce)(U).sort((M,z)=>M.location.path<z.location.path?-1:1)}async scanExtensionsFromProfile(V){let $=await this.scanExtensionsFromProfileResource(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(V.location,V.applicationExtensionslocation)){$=$.filter(M=>!M.metadata?.isApplicationScoped);const U=await this.scanExtensionsFromProfileResource(V.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,V);$.push(...U)}return $}async scanExtensionsFromProfileResource(V,$,U){const M=await this.extensionsProfileScannerService.scanProfileExtensions(V,U.profileScanOptions);if(!M.length)return[];const z=await Promise.all(M.map(async G=>{if($(G)){const K=new Y(G.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(K,G.metadata)}return null}));return(0,x.coalesce)(z)}async scanOneOrMultipleExtensions(V){try{if(await this.fileService.exists((0,f.joinPath)(V.location,"package.json"))){const $=await this.scanExtension(V);return $?[$]:[]}else return await this.scanExtensions(V)}catch($){return this.logService.error(`Error scanning extensions at ${V.location.path}:`,(0,A.getErrorMessage)($)),[]}}async scanExtension(V,$){try{let U=await this.scanExtensionManifest(V.location);if(U){U.publisher||(U.publisher=w.UNDEFINED_PUBLISHER),$=$??U.__metadata,delete U.__metadata;const M=(0,p.getGalleryExtensionId)(U.publisher,U.name),z=$?.id?{id:M,uuid:$.id}:{id:M},G=$?.isSystem?0:V.type,K=G===0||!!$?.isBuiltin;U=await this.translateManifest(V.location,U,Y.createNlsConfiguration(V));const J={type:G,identifier:z,manifest:U,location:V.location,isBuiltin:K,targetPlatform:$?.targetPlatform??"undefined",metadata:$,isValid:!0,validations:[]};return V.validate?this.validate(J,V):J}}catch(U){V.type!==0&&this.logService.error(U)}return null}validate(V,$){let U=!0;const M=(0,t.validateExtensionManifest)($.productVersion,$.productDate,$.location,V.manifest,V.isBuiltin);for(const[z,G]of M)z===y.default.Error&&(U=!1,this.logService.error(this.formatMessage($.location,G)));return V.isValid=U,V.validations=M,V}async scanExtensionManifest(V){const $=(0,f.joinPath)(V,"package.json");let U;try{U=(await this.fileService.readFile($)).value.toString()}catch(z){return(0,a.toFileOperationResult)(z)!==1&&this.logService.error(this.formatMessage(V,(0,h.localize)(0,null,$.path,z.message))),null}let M;try{M=JSON.parse(U)}catch{const G=[];(0,E.parse)(U,G);for(const K of G)this.logService.error(this.formatMessage(V,(0,h.localize)(1,null,$.path,K.offset,K.length,(0,u.getParseErrorMessage)(K.error))));return null}return(0,E.getNodeType)(M)!=="object"?(this.logService.error(this.formatMessage(V,(0,h.localize)(2,null,$.path))),null):M}async translateManifest(V,$,U){const M=await this.getLocalizedMessages(V,$,U);if(M)try{const z=[],G=await this.resolveOriginalMessageBundle(M.default,z);if(z.length>0)return z.forEach(J=>{this.logService.error(this.formatMessage(V,(0,h.localize)(3,null,M.default?.path,(0,u.getParseErrorMessage)(J.error))))}),$;if((0,E.getNodeType)(M)!=="object")return this.logService.error(this.formatMessage(V,(0,h.localize)(4,null,M.default?.path))),$;const K=M.values||Object.create(null);return(0,O.localizeManifest)($,K,G)}catch{}return $}async getLocalizedMessages(V,$,U){const M=(0,f.joinPath)(V,"package.nls.json"),z=(oe,I)=>{I.forEach(s=>{this.logService.error(this.formatMessage(V,(0,h.localize)(5,null,oe?.path,(0,u.getParseErrorMessage)(s.error))))})},G=oe=>{this.logService.error(this.formatMessage(V,(0,h.localize)(6,null,oe?.path)))},K=`${$.publisher}.${$.name}`,J=U.translations[K];if(J)try{const oe=d.URI.file(J),I=(await this.fileService.readFile(oe)).value.toString(),s=[],v=(0,E.parse)(I,s);return s.length>0?(z(oe,s),{values:void 0,default:M}):(0,E.getNodeType)(v)!=="object"?(G(oe),{values:void 0,default:M}):{values:v.contents?v.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.fileService.exists(M))return;let I;try{I=await this.findMessageBundles(V,U)}catch{return}if(!I.localized)return{values:void 0,default:I.original};try{const s=(await this.fileService.readFile(I.localized)).value.toString(),v=[],F=(0,E.parse)(s,v);return v.length>0?(z(I.localized,v),{values:void 0,default:I.original}):(0,E.getNodeType)(F)!=="object"?(G(I.localized),{values:void 0,default:I.original}):{values:F,default:I.original}}catch{return{values:void 0,default:I.original}}}}async resolveOriginalMessageBundle(V,$){if(V)try{const U=(await this.fileService.readFile(V)).value.toString();return(0,E.parse)(U,$)}catch{}}findMessageBundles(V,$){return new Promise((U,M)=>{const z=G=>{const K=(0,f.joinPath)(V,`package.nls.${G}.json`);this.fileService.exists(K).then(J=>{J&&U({localized:K,original:(0,f.joinPath)(V,"package.nls.json")});const oe=G.lastIndexOf("-");oe===-1?U({localized:(0,f.joinPath)(V,"package.nls.json"),original:null}):(G=G.substring(0,oe),z(G))})};if($.devMode||$.pseudo||!$.language)return U({localized:(0,f.joinPath)(V,"package.nls.json"),original:null});z($.language)})}formatMessage(V,$){return`[${V.path}]: ${$}`}};ce=ve([re(1,D.IExtensionsProfileScannerService),re(2,b.IUriIdentityService),re(3,a.IFileService),re(4,r.ILogService)],ce);let Z=class extends ce{constructor(V,$,U,M,z,G,K){super($,M,z,G,K),this.currentProfile=V,this.userDataProfilesService=U,this.cacheValidatorThrottler=this._register(new T.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(V){const $=this.getCacheFile(V),U=await this.readExtensionCache($);if(this.input=V,U&&U.input&&Y.equals(U.input,this.input))return this.logService.debug("Using cached extensions scan result",V.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),U.result.map(z=>(z.location=d.URI.revive(z.location),z));const M=await super.scanExtensions(V);return await this.writeExtensionCache($,{input:V,result:M}),M}async readExtensionCache(V){try{const $=await this.fileService.readFile(V),U=JSON.parse($.value.toString());return{result:U.result,input:(0,c.revive)(U.input)}}catch($){this.logService.debug("Error while reading the extension cache file:",V.path,(0,A.getErrorMessage)($))}return null}async writeExtensionCache(V,$){try{await this.fileService.writeFile(V,N.VSBuffer.fromString(JSON.stringify($)))}catch(U){this.logService.debug("Error while writing the extension cache file:",V.path,(0,A.getErrorMessage)(U))}}async validateCache(){if(!this.input)return;const V=this.getCacheFile(this.input),$=await this.readExtensionCache(V);if(!$)return;const U=$.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!L.equals(M,U))try{this.logService.info("Invalidating Cache",U,M),await this.fileService.del(V),this._onDidChangeCache.fire()}catch(z){this.logService.error(z)}}getCacheFile(V){const $=this.getProfile(V);return this.uriIdentityService.extUri.joinPath($.cacheHome,V.type===0?w.BUILTIN_MANIFEST_CACHE_FILE:w.USER_MANIFEST_CACHE_FILE)}getProfile(V){return V.type===0?this.userDataProfilesService.defaultProfile:V.profile?this.uriIdentityService.extUri.isEqual(V.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find($=>this.uriIdentityService.extUri.isEqual(V.location,$.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};Z=ve([re(2,P.IUserDataProfilesService),re(3,D.IExtensionsProfileScannerService),re(4,b.IUriIdentityService),re(5,a.IFileService),re(6,r.ILogService)],Z);function ae(te,V){const $=(0,p.getExtensionId)(te.manifest.publisher,te.manifest.name);return{id:$,identifier:new w.ExtensionIdentifier($),isBuiltin:te.type===0,isUserBuiltin:te.type===1&&te.isBuiltin,isUnderDevelopment:V,extensionLocation:te.location,uuid:te.identifier.uuid,targetPlatform:te.targetPlatform,...te.manifest}}e.toExtensionDescription=ae;class le extends ee{constructor(V,$,U,M,z,G,K,J,oe,I,s,v){super(V,$,(0,f.joinPath)(U,".vscode-oss-dev","extensions","control.json"),M,z,G,K,J,oe,I,s,v),this.translationsPromise=(async()=>{if(g.translationsConfigFile)try{const F=await this.fileService.readFile(d.URI.file(g.translationsConfigFile));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}getTranslations(V){return this.translationsPromise}}e.NativeExtensionsScannerService=le}),define(ne[154],se([0,1,58,8,33,4,2,15,16,24,6,23]),function(q,e,x,T,L,N,A,E,u,l,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends A.Disposable{constructor(R,y){super(),this.userDataProfilesService=R,this.logService=y,this.processesLimiter=new T.Limiter(5)}async postUninstall(R){const y=this.parseScript(R,"uninstall");y&&(this.logService.info(R.identifier.id,R.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(y.script,"uninstall",y.args,!0,R),this.logService.info("Finished running post uninstall script",R.identifier.id,R.manifest.version)}catch(m){this.logService.error("Failed to run post uninstall script",R.identifier.id,R.manifest.version),this.logService.error(m)}}));try{await l.Promises.rm(this.getExtensionStoragePath(R))}catch(m){this.logService.error("Error while removing extension storage path",R.identifier.id),this.logService.error(m)}}parseScript(R,y){const m=`vscode:${y}`;if(R.location.scheme===E.Schemas.file&&R.manifest&&R.manifest.scripts&&typeof R.manifest.scripts[m]=="string"){const d=R.manifest.scripts[m].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(R.identifier.id,R.manifest.version,`${m} should be a node script`),null):{script:(0,u.join)(R.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(R,y,m,d,h){return new Promise((C,p)=>{const w=this.start(R,y,m,h);let t;const a=i=>{t&&(clearTimeout(t),t=null),i?p(i):C(void 0)};w.on("error",i=>{a((0,L.toErrorMessage)(i)||"Unknown")}),w.on("exit",(i,r)=>{a(i?`post-${y} process exited with code ${i}`:void 0)}),d&&(t=setTimeout(()=>{t=null,w.kill(),p("timed out")},5e3))})}start(R,y,m,d){const h={silent:!0,execArgv:void 0},C=(0,x.fork)(R,[`--type=extension-post-${y}`,...m],h);C.stdout.setEncoding("utf8"),C.stderr.setEncoding("utf8");const p=N.Event.fromNodeEventEmitter(C.stdout,"data"),w=N.Event.fromNodeEventEmitter(C.stderr,"data");p(i=>this.logService.info(d.identifier.id,d.manifest.version,`post-${y}`,i)),w(i=>this.logService.error(d.identifier.id,d.manifest.version,`post-${y}`,i));const t=N.Event.any(N.Event.map(p,i=>({data:`%c${i}`,format:[""]})),N.Event.map(w,i=>({data:`%c${i}`,format:["color: red"]})));return N.Event.debounce(t,(i,r)=>i?{data:i.data+r.data,format:[...i.format,...r.format]}:{data:r.data,format:r.format},100)(i=>{console.group(d.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),C}getExtensionStoragePath(R){return(0,u.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,R.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=g,e.ExtensionsLifecycle=g=ve([re(0,k.IUserDataProfilesService),re(1,S.ILogService)],g)}),define(ne[155],se([0,1,6,23,22,26,40,13,18,11]),function(q,e,x,T,L,N,A,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let S=class extends A.AbstractExtensionsProfileScannerService{constructor(g,f,R,y,m,d){super(l.URI.file(g.extensionsPath),f,R,y,m,d)}};e.ExtensionsProfileScannerService=S,e.ExtensionsProfileScannerService=S=ve([re(0,u.INativeEnvironmentService),re(1,E.IFileService),re(2,T.IUserDataProfilesService),re(3,L.IUriIdentityService),re(4,N.ITelemetryService),re(5,x.ILogService)],S)}),define(ne[156],se([0,1,11,18,40,50,13,10,6,31,22,23]),function(q,e,x,T,L,N,A,E,u,l,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=class extends N.NativeExtensionsScannerService{constructor(R,y,m,d,h,C,p,w){super(x.URI.file(h.builtinExtensionsPath),x.URI.file(h.extensionsPath),h.userHome,R.defaultProfile,R,y,m,d,h,C,p,w)}};e.ExtensionsScannerService=g,e.ExtensionsScannerService=g=ve([re(0,k.IUserDataProfilesService),re(1,L.IExtensionsProfileScannerService),re(2,A.IFileService),re(3,u.ILogService),re(4,T.INativeEnvironmentService),re(5,l.IProductService),re(6,S.IUriIdentityService),re(7,E.IInstantiationService)],g)}),define(ne[157],se([0,1,8,4,2,123,3,86,10,23]),function(q,e,x,T,L,N,A,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,u.createDecorator)("storageService");var S;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(S||(e.WillSaveStateReason=S={}));var k;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(k||(e.StorageScope=k={}));var g;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function f(h){const C=h.get(e.TARGET_KEY);if(C)try{return JSON.parse(C)}catch{}return Object.create(null)}e.loadKeyTargets=f;class R extends L.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(C={flushInterval:R.DEFAULT_FLUSH_INTERVAL}){super(),this.options=C,this._onDidChangeValue=this._register(new T.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new x.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,x.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,N.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(C,p){const{key:w,external:t}=p;if(w===e.TARGET_KEY){switch(C){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:C})}else this._onDidChangeValue.fire({scope:C,key:w,target:this.getKeyTargets(C)[w],external:t})}emitWillSaveState(C){this._onWillSaveState.fire({reason:C})}get(C,p,w){return this.getStorage(p)?.get(C,w)}getBoolean(C,p,w){return this.getStorage(p)?.getBoolean(C,w)}getNumber(C,p,w){return this.getStorage(p)?.getNumber(C,w)}getObject(C,p,w){return this.getStorage(p)?.getObject(C,w)}storeAll(C,p){this.withPausedEmitters(()=>{for(const w of C)this.store(w.key,w.value,w.scope,w.target,p)})}store(C,p,w,t,a=!1){if((0,A.isUndefinedOrNull)(p)){this.remove(C,w,a);return}this.withPausedEmitters(()=>{this.updateKeyTarget(C,w,t),this.getStorage(w)?.set(C,p,a)})}remove(C,p,w=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(C,p,void 0),this.getStorage(p)?.delete(C,w)})}withPausedEmitters(C){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{C()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(C,p){const w=[],t=this.getKeyTargets(C);for(const a of Object.keys(t))t[a]===p&&w.push(a);return w}updateKeyTarget(C,p,w,t=!1){const a=this.getKeyTargets(p);typeof w=="number"?a[C]!==w&&(a[C]=w,this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(a),t)):typeof a[C]=="number"&&(delete a[C],this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(a),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(C){switch(C){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(C){const p=this.getStorage(C);return p?f(p):Object.create(null)}isNew(C){return this.getBoolean(e.IS_NEW_KEY,C)===!0}async flush(C=S.NONE){this._onWillSaveState.fire({reason:C});const p=this.getStorage(-1),w=this.getStorage(0),t=this.getStorage(1);switch(C){case S.NONE:await x.Promises.settled([p?.whenFlushed()??Promise.resolve(),w?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await x.Promises.settled([p?.flush(0)??Promise.resolve(),w?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const C=this.getStorage(-1)?.items??new Map,p=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return d(C,p,w,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(C,p){return this.emitWillSaveState(S.NONE),(0,l.isUserDataProfile)(C)?this.switchToProfile(C,p):this.switchToWorkspace(C,p)}canSwitchProfile(C,p){return!(C.id===p.id||y(p)&&y(C))}switchData(C,p,w){this.withPausedEmitters(()=>{const t=new Set;for(const[a,i]of C)t.add(a),p.get(a)!==i&&this.emitDidChangeValue(w,{key:a,external:!0});for(const[a]of p.items)t.has(a)||this.emitDidChangeValue(w,{key:a,external:!0})})}}e.AbstractStorageService=R;function y(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=y;class m extends R{constructor(){super(),this.applicationStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(C=>this.emitDidChangeValue(1,C))),this._register(this.profileStorage.onDidChangeStorage(C=>this.emitDidChangeValue(0,C))),this._register(this.applicationStorage.onDidChangeStorage(C=>this.emitDidChangeValue(-1,C)))}getStorage(C){switch(C){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(C){switch(C){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(C){return!1}}e.InMemoryStorageService=m;async function d(h,C,p,w,t,a){const i=j=>{try{return JSON.parse(j)}catch{return j}},r=new Map,n=new Map;h.forEach((j,ee)=>{r.set(ee,j),n.set(ee,i(j))});const o=new Map,c=new Map;C.forEach((j,ee)=>{o.set(ee,j),c.set(ee,i(j))});const D=new Map,P=new Map;p.forEach((j,ee)=>{D.set(ee,j),P.set(ee,i(j))}),console.group(w!==t?`Storage: Application (path: ${w})`:`Storage: Application & Profile (path: ${w}, default profile)`);const b=[];if(r.forEach((j,ee)=>{b.push({key:ee,value:j})}),console.table(b),console.groupEnd(),console.log(n),w!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];o.forEach((ee,Y)=>{j.push({key:Y,value:ee})}),console.table(j),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${a})`);const O=[];D.forEach((j,ee)=>{O.push({key:ee,value:j})}),console.table(O),console.groupEnd(),console.log(P)}e.logStorage=d}),define(ne[158],se([0,1,19,20,9,12,34,3,11,25,18,21,27,48,13,6,31,45,142,157,26]),function(q,e,x,T,L,N,A,E,u,l,S,k,g,f,R,y,m,d,h,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const w=N.isWeb?"web":(0,k.getTargetPlatform)(N.platform,A.arch),t="X-Market-Search-Activity-Id";var a;(function(I){I[I.None=0]="None",I[I.IncludeVersions=1]="IncludeVersions",I[I.IncludeFiles=2]="IncludeFiles",I[I.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",I[I.IncludeSharedAccounts=8]="IncludeSharedAccounts",I[I.IncludeVersionProperties=16]="IncludeVersionProperties",I[I.ExcludeNonValidated=32]="ExcludeNonValidated",I[I.IncludeInstallationTargets=64]="IncludeInstallationTargets",I[I.IncludeAssetUri=128]="IncludeAssetUri",I[I.IncludeStatistics=256]="IncludeStatistics",I[I.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",I[I.Unpublished=4096]="Unpublished",I[I.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(a||(a={}));function i(...I){return String(I.reduce((s,v)=>s|v,0))}var r;(function(I){I[I.Tag=1]="Tag",I[I.ExtensionId=4]="ExtensionId",I[I.Category=5]="Category",I[I.ExtensionName=7]="ExtensionName",I[I.Target=8]="Target",I[I.Featured=9]="Featured",I[I.SearchText=10]="SearchText",I[I.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},D={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class P{constructor(s=D){this.state=s}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(s,v=this.state.pageSize){return new P({...this.state,pageNumber:s,pageSize:v})}withFilter(s,...v){const F=[...this.state.criteria,...v.length?v.map(_=>({filterType:s,value:_})):[{filterType:s}]];return new P({...this.state,criteria:F})}withSortBy(s){return new P({...this.state,sortBy:s})}withSortOrder(s){return new P({...this.state,sortOrder:s})}withFlags(...s){return new P({...this.state,flags:s.reduce((v,F)=>v|F,0)})}withAssetTypes(...s){return new P({...this.state,assetTypes:s})}withSource(s){return new P({...this.state,source:s})}get raw(){const{criteria:s,pageNumber:v,pageSize:F,sortBy:_,sortOrder:B,flags:H,assetTypes:ie}=this.state;return{filters:[{criteria:s,pageNumber:v,pageSize:F,sortBy:_,sortOrder:B}],assetTypes:ie,flags:H}}get searchText(){const s=this.state.criteria.filter(v=>v.filterType===r.SearchText)[0];return s&&s.value?s.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(s=>String(s.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function b(I,s){const v=(I||[]).filter(F=>F.statisticName===s)[0];return v?v.value:0}function O(I){const s="Microsoft.VisualStudio.Code.Translation.";return I.files.filter(F=>F.assetType.indexOf(s)===0).reduce((F,_)=>{const B=Y(I,_.assetType);return B&&F.push([_.assetType.substring(s.length),B]),F},[])}function j(I){if(I.properties){const s=I.properties.filter(_=>_.key===n.Repository),v=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=s.filter(_=>v.test(_.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return Y(I,n.Repository)}function ee(I){return{uri:`${I.fallbackAssetUri}/${n.VSIX}?redirect=true${I.targetPlatform?`&targetPlatform=${I.targetPlatform}`:""}`,fallbackUri:`${I.fallbackAssetUri}/${n.VSIX}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`}}function Y(I,s){return I.files.filter(F=>F.assetType===s)[0]?{uri:`${I.assetUri}/${s}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`,fallbackUri:`${I.fallbackAssetUri}/${s}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`}:null}function ce(I,s){const v=I.properties?I.properties.filter(_=>_.key===s):[],F=v.length>0&&v[0].value;return F?F.split(",").map(_=>(0,g.adoptToGalleryExtensionId)(_)):[]}function Z(I){const s=I.properties?I.properties.filter(v=>v.key===o.Engine):[];return s.length>0&&s[0].value||""}function ae(I){const s=I.properties?I.properties.filter(v=>v.key===o.PreRelease):[];return s.length>0&&s[0].value==="true"}function le(I){const s=I.properties?I.properties.filter(F=>F.key===o.LocalizedLanguages):[],v=s.length>0&&s[0].value||"";return v?v.split(","):[]}function te(I){return I.properties?.find(s=>s.key===o.SponsorLink)?.value}function V(I){return I.indexOf("preview")!==-1}function $(I){return I.targetPlatform?(0,k.toTargetPlatform)(I.targetPlatform):"undefined"}function U(I){const s=(0,x.distinct)(I.versions.map($)),v=!!I.tags?.includes(k.WEB_EXTENSION_TAG),F=s.indexOf("web");return v?F===-1&&s.push("web"):F!==-1&&s.splice(F,1),s}function M(I,s){const v=(0,k.getFallbackTargetPlarforms)(s);for(let F=0;F<I.length;F++){const _=I[F];if(_.version===I[F-1]?.version){let B=F;const H=$(_);if(H===s)for(;B>0&&I[B-1].version===_.version;)B--;else if(v.includes(H))for(;B>0&&I[B-1].version===_.version&&$(I[B-1])!==s;)B--;B!==F&&(I.splice(F,1),I.splice(B,0,_))}}return I}e.sortExtensionVersions=M;function z(I,s,v){I.telemetryData={index:s,querySource:v,queryActivityId:I.queryContext?.[t]}}function G(I,s,v,F){const _=I.versions[0],B={manifest:Y(s,n.Manifest),readme:Y(s,n.Details),changelog:Y(s,n.Changelog),license:Y(s,n.License),repository:j(s),download:ee(s),icon:Y(s,n.Icon),signature:Y(s,n.Signature),coreTranslations:O(s)};return{identifier:{id:(0,g.getGalleryExtensionId)(I.publisher.publisherName,I.extensionName),uuid:I.extensionId},name:I.extensionName,version:s.version,displayName:I.displayName,publisherId:I.publisher.publisherId,publisher:I.publisher.publisherName,publisherDisplayName:I.publisher.displayName,publisherDomain:I.publisher.domain?{link:I.publisher.domain,verified:!!I.publisher.isDomainVerified}:void 0,publisherSponsorLink:te(_),description:I.shortDescription||"",installCount:b(I.statistics,"install"),rating:b(I.statistics,"averagerating"),ratingCount:b(I.statistics,"ratingcount"),categories:I.categories||[],tags:I.tags||[],releaseDate:Date.parse(I.releaseDate),lastUpdated:Date.parse(I.lastUpdated),allTargetPlatforms:v,assets:B,properties:{dependencies:ce(s,o.Dependency),extensionPack:ce(s,o.ExtensionPack),engine:Z(s),localizedLanguages:le(s),targetPlatform:$(s),isPreReleaseVersion:ae(s)},hasPreReleaseVersion:ae(_),hasReleaseVersion:!0,preview:V(I.flags),isSigned:!!B.signature,queryContext:F}}let K=class{constructor(s,v,F,_,B,H,ie,de){this.requestService=v,this.logService=F,this.environmentService=_,this.telemetryService=B,this.fileService=H,this.productService=ie,this.configurationService=de;const he=ie.extensionsGallery,ue=he?.servicePPEUrl&&de.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=ue?he.servicePPEUrl:he?.serviceUrl,this.extensionsGallerySearchUrl=ue?void 0:he?.searchUrl,this.extensionsControlUrl=he?.controlUrl,this.commonHeadersPromise=(0,h.resolveMarketplaceHeaders)(ie.version,ie,this.environmentService,this.configurationService,this.fileService,s,this.telemetryService)}api(s=""){return`${this.extensionsGalleryUrl}${s}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(s,v,F){const _=T.CancellationToken.isCancellationToken(v)?{}:v,B=T.CancellationToken.isCancellationToken(v)?v:F,H=[],ie=[],de=[],he=[];let ue=!0;for(const fe of s){fe.uuid?ie.push(fe.uuid):H.push(fe.id);const ye=!!(fe.version||fe.preRelease);de.push({id:fe.id,uuid:fe.uuid,includePreRelease:ye}),fe.version&&he.push({id:fe.id,uuid:fe.uuid,version:fe.version}),ue=ue&&!!fe.hasPreRelease&&!ye}if(!ie.length&&!H.length)return[];let ge=new P().withPage(1,s.length);ie.length&&(ge=ge.withFilter(r.ExtensionId,...ie)),H.length&&(ge=ge.withFilter(r.ExtensionName,...H)),(_.queryAllVersions||ue)&&(ge=ge.withFlags(ge.flags,a.IncludeVersions)),_.source&&(ge=ge.withSource(_.source));const{extensions:me}=await this.queryGalleryExtensions(ge,{targetPlatform:_.targetPlatform??w,includePreRelease:de,versions:he,compatible:!!_.compatible},B);return _.source&&me.forEach((fe,ye)=>z(fe,ye,_.source)),me}async getCompatibleExtension(s,v,F){if((0,k.isNotWebExtensionInWebTargetPlatform)(s.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(s,v,F))return s;const _=new P().withFlags(a.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,s.identifier.uuid),{extensions:B}=await this.queryGalleryExtensions(_,{targetPlatform:F,compatible:!0,includePreRelease:v},T.CancellationToken.None);return B[0]||null}async isExtensionCompatible(s,v,F){if(!(0,k.isTargetPlatformCompatible)(s.properties.targetPlatform,s.allTargetPlatforms,F)||!v&&s.properties.isPreReleaseVersion)return!1;let _=s.properties.engine;if(!_){const B=await this.getManifest(s,T.CancellationToken.None);if(!B)throw new Error("Manifest was not found");_=B.engines.vscode}return(0,f.isEngineValid)(_,this.productService.version,this.productService.date)}async isValidVersion(s,v,F,_,B){if(!(0,k.isTargetPlatformCompatible)($(s),_,B)||v!=="any"&&ae(s)!==(v==="prerelease"))return!1;if(F)try{const H=await this.getEngine(s);if(!(0,f.isEngineValid)(H,this.productService.version,this.productService.date))return!1}catch(H){return this.logService.error(`Error while getting the engine for the version ${s.version}.`,(0,L.getErrorMessage)(H)),!1}return!0}async query(s,v){let F=s.text||"";const _=s.pageSize??50;let B=new P().withPage(1,_);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ge,me)=>(B=B.withFilter(r.Category,me||ge),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ge,me)=>(B=B.withFilter(r.Tag,me||ge),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(r.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),B=B.withFilter(r.SearchText,F)),B=B.withSortBy(0)):s.ids?B=B.withFilter(r.ExtensionId,...s.ids):s.names?B=B.withFilter(r.ExtensionName,...s.names):B=B.withSortBy(4),typeof s.sortBy=="number"&&(B=B.withSortBy(s.sortBy)),typeof s.sortOrder=="number"&&(B=B.withSortOrder(s.sortOrder)),s.source&&(B=B.withSource(s.source));const H=async(ue,ge)=>{const{extensions:me,total:fe}=await this.queryGalleryExtensions(ue,{targetPlatform:w,compatible:!1,includePreRelease:!!s.includePreRelease},ge);return me.forEach((ye,Pe)=>z(ye,(ue.pageNumber-1)*ue.pageSize+Pe,s.source)),{extensions:me,total:fe}},{extensions:ie,total:de}=await H(B,v),he=async(ue,ge)=>{if(ge.isCancellationRequested)throw new L.CancellationError;const{extensions:me}=await H(B.withPage(ue+1),ge);return me};return{firstPage:ie,total:de,pageSize:B.pageSize,getPage:he}}async queryGalleryExtensions(s,v,F){const _=s.flags;s.flags&a.IncludeLatestVersionOnly&&s.flags&a.IncludeVersions&&(s=s.withFlags(s.flags&~a.IncludeVersions,a.IncludeLatestVersionOnly)),!(s.flags&a.IncludeLatestVersionOnly)&&!(s.flags&a.IncludeVersions)&&(s=s.withFlags(s.flags,a.IncludeLatestVersionOnly)),v.versions?.length&&(s=s.withFlags(s.flags&~a.IncludeLatestVersionOnly,a.IncludeVersions)),s=s.withFlags(s.flags,a.IncludeAssetUri,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeStatistics,a.IncludeVersionProperties);const{galleryExtensions:B,total:H,context:ie}=await this.queryRawGalleryExtensions(s,F);if(!(s.flags&a.IncludeLatestVersionOnly)){const ge=[];for(const me of B){const fe=await this.toGalleryExtensionWithCriteria(me,v,ie);fe&&ge.push(fe)}return{extensions:ge,total:H}}const he=[],ue=new Map;for(let ge=0;ge<B.length;ge++){const me=B[ge],fe={id:(0,g.getGalleryExtensionId)(me.publisher.publisherName,me.extensionName),uuid:me.extensionId},ye=(0,E.isBoolean)(v.includePreRelease)?v.includePreRelease:!!v.includePreRelease.find(Oe=>(0,g.areSameExtensions)(Oe,fe))?.includePreRelease;if(v.compatible&&(0,k.isNotWebExtensionInWebTargetPlatform)(U(me),v.targetPlatform))continue;const Pe=await this.toGalleryExtensionWithCriteria(me,v,ie);!Pe||Pe.properties.isPreReleaseVersion&&(!ye||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==v.targetPlatform&&Pe.hasPreReleaseVersion?ue.set(me.extensionId,ge):he.push([ge,Pe])}if(ue.size){const ge=new Date().getTime(),me=new P().withFlags(_&~a.IncludeLatestVersionOnly,a.IncludeVersions).withPage(1,ue.size).withFilter(r.ExtensionId,...ue.keys()),{extensions:fe}=await this.queryGalleryExtensions(me,v,F);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:ue.size});for(const ye of fe){const Pe=ue.get(ye.identifier.uuid);he.push([Pe,ye])}}return{extensions:he.sort((ge,me)=>ge[0]-me[0]).map(([,ge])=>ge),total:H}}async toGalleryExtensionWithCriteria(s,v,F){const _={id:(0,g.getGalleryExtensionId)(s.publisher.publisherName,s.extensionName),uuid:s.extensionId},B=v.versions?.find(he=>(0,g.areSameExtensions)(he,_))?.version,H=(0,E.isBoolean)(v.includePreRelease)?v.includePreRelease:!!v.includePreRelease.find(he=>(0,g.areSameExtensions)(he,_))?.includePreRelease,ie=U(s),de=M(s.versions,v.targetPlatform);if(v.compatible&&(0,k.isNotWebExtensionInWebTargetPlatform)(ie,v.targetPlatform))return null;for(let he=0;he<de.length;he++){const ue=de[he];if(!(B&&ue.version!==B)){if(await this.isValidVersion(ue,H?"any":"release",v.compatible,ie,v.targetPlatform))return G(s,ue,ie,F);if(B&&ue.version===B)return null}}return B||v.compatible?null:G(s,s.versions[0],ie)}async queryRawGalleryExtensions(s,v){if(!this.isEnabled())throw new Error("No extension gallery service configured.");s=s.withFlags(s.flags,a.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,i(a.Unpublished));const F=await this.commonHeadersPromise,_=JSON.stringify(s.raw),B={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(_.length)},H=new Date().getTime();let ie,de,he=0;try{if(ie=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&s.criteria.some(ge=>ge.filterType===r.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:_,headers:B},v),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:he};const ue=await(0,d.asJson)(ie);if(ue){const ge=ue.results[0],me=ge.extensions,fe=ge.resultMetadata&&ge.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return he=fe&&fe.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:he,context:{[t]:ie.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(ue){throw de=ue,ue}finally{this.telemetryService.publicLog2("galleryService:query",{...s.telemetryData,requestBodySize:String(_.length),duration:new Date().getTime()-H,success:!!ie&&(0,d.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:de?(0,L.isCancellationError)(de)?"canceled":(0,L.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(s,v,F,_){if(!this.isEnabled())return;const B=N.isWeb?this.api(`/itemName/${s}.${v}/version/${F}/statType/${_==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${s}/extensions/${v}/${F}/stats?statType=${_}`),H=N.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",de={...await this.commonHeadersPromise,Accept:H};try{await this.requestService.request({type:"POST",url:B,headers:de},T.CancellationToken.None)}catch{}}async download(s,v,F){this.logService.trace("ExtensionGalleryService#download",s.identifier.id);const _=(0,g.getGalleryExtensionTelemetryData)(s),B=new Date().getTime(),H=ge=>this.telemetryService.publicLog("galleryService:downloadVSIX",{..._,duration:ge}),ie=F===2?"install":F===3?"update":"",de=ie?{uri:`${s.assets.download.uri}${u.URI.parse(s.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${s.assets.download.fallbackUri}${u.URI.parse(s.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:s.assets.download,he=s.queryContext?.[t]?{[t]:s.queryContext[t]}:void 0,ue=await this.getAsset(de,he?{headers:he}:void 0);await this.fileService.writeFile(v,ue.stream),H(new Date().getTime()-B)}async downloadSignatureArchive(s,v){if(!s.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",s.identifier.id);const F=await this.getAsset(s.assets.signature);await this.fileService.writeFile(v,F.stream)}async getReadme(s,v){if(s.assets.readme){const F=await this.getAsset(s.assets.readme,{},v);return await(0,d.asTextOrError)(F)||""}return""}async getManifest(s,v){if(s.assets.manifest){const F=await this.getAsset(s.assets.manifest,{},v),_=await(0,d.asTextOrError)(F);return _?JSON.parse(_):null}return null}async getManifestFromRawExtensionVersion(s,v){const F=Y(s,n.Manifest);if(!F)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},B=await this.getAsset(F,{headers:_});return await(0,d.asJson)(B)}async getCoreTranslation(s,v){const F=s.assets.coreTranslations.filter(_=>_[0]===v.toUpperCase())[0];if(F){const _=await this.getAsset(F[1]),B=await(0,d.asTextOrError)(_);return B?JSON.parse(B):null}return null}async getChangelog(s,v){if(s.assets.changelog){const F=await this.getAsset(s.assets.changelog,{},v);return await(0,d.asTextOrError)(F)||""}return""}async getAllCompatibleVersions(s,v,F){let _=new P().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1);s.identifier.uuid?_=_.withFilter(r.ExtensionId,s.identifier.uuid):_=_.withFilter(r.ExtensionName,s.identifier.id);const{galleryExtensions:B}=await this.queryRawGalleryExtensions(_,T.CancellationToken.None);if(!B.length)return[];const H=U(B[0]);if((0,k.isNotWebExtensionInWebTargetPlatform)(H,F))return[];const ie=[];await Promise.all(B[0].versions.map(async ue=>{try{await this.isValidVersion(ue,v?"any":"release",!0,H,F)&&ie.push(ue)}catch{}}));const de=[],he=new Set;for(const ue of M(ie,F))he.has(ue.version)||(he.add(ue.version),de.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:ae(ue)}));return de}async getAsset(s,v={},F=T.CancellationToken.None){const _=await this.commonHeadersPromise,B={type:"GET"},H={..._,...v.headers||{}};v={...v,...B,headers:H};const ie=s.uri,de=s.fallbackUri,he={...v,url:ie};try{const ue=await this.requestService.request(he,F);if(ue.res.statusCode===200)return ue;const ge=await(0,d.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${ge}`)}catch(ue){if((0,L.isCancellationError)(ue))throw ue;const ge=(0,L.getErrorMessage)(ue);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:ge});const me={...v,url:de};return this.requestService.request(me,F)}}async getEngine(s){let v=Z(s);if(!v){const F=await this.getManifestFromRawExtensionVersion(s,T.CancellationToken.None);if(!F)throw new Error("Manifest was not found");v=F.engines.vscode}return v}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const s=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},T.CancellationToken.None);if(s.res.statusCode!==200)throw new Error("Could not get extensions report.");const v=await(0,d.asJson)(s),F=[],_={},B=[];if(v){for(const H of v.malicious)F.push({id:H});if(v.migrateToPreRelease)for(const[H,ie]of Object.entries(v.migrateToPreRelease))(!ie.engine||(0,f.isEngineValid)(ie.engine,this.productService.version,this.productService.date))&&(_[H.toLowerCase()]={disallowInstall:!0,extension:{id:ie.id,displayName:ie.displayName,autoMigrate:{storage:!!ie.migrateStorage},preRelease:!0}});if(v.deprecated)for(const[H,ie]of Object.entries(v.deprecated))ie&&(_[H.toLowerCase()]=(0,E.isBoolean)(ie)?{}:ie);if(v.search)for(const H of v.search)B.push(H)}return{malicious:F,deprecated:_,search:B}}};K=ve([re(1,d.IRequestService),re(2,y.ILogService),re(3,S.IEnvironmentService),re(4,p.ITelemetryService),re(5,R.IFileService),re(6,m.IProductService),re(7,l.IConfigurationService)],K);let J=class extends K{constructor(s,v,F,_,B,H,ie,de){super(s,v,F,_,B,H,ie,de)}};e.ExtensionGalleryService=J,e.ExtensionGalleryService=J=ve([re(0,C.IStorageService),re(1,d.IRequestService),re(2,y.ILogService),re(3,S.IEnvironmentService),re(4,p.ITelemetryService),re(5,R.IFileService),re(6,m.IProductService),re(7,l.IConfigurationService)],J);let oe=class extends K{constructor(s,v,F,_,B,H,ie){super(void 0,s,v,F,_,B,H,ie)}};e.ExtensionGalleryServiceWithNoStorageService=oe,e.ExtensionGalleryServiceWithNoStorageService=oe=ve([re(0,d.IRequestService),re(1,y.ILogService),re(2,S.IEnvironmentService),re(3,p.ITelemetryService),re(4,R.IFileService),re(5,m.IProductService),re(6,l.IConfigurationService)],oe)}),define(ne[159],se([0,1,11,18,13,6,139,22,23,3,68]),function(q,e,x,T,L,N,A,E,u,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let k=class ze extends u.UserDataProfilesService{static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(y,m,d,h,C){super(d,h,m,C),this.stateReadonlyService=y,this.nativeEnvironmentService=d}getStoredProfiles(){return this.stateReadonlyService.getItem(ze.PROFILES_KEY,[]).map(m=>({...m,location:(0,l.isString)(m.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,m.location):x.URI.revive(m.location)}))}getStoredProfileAssociations(){const y=this.stateReadonlyService.getItem(ze.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(ze.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?y:this.migrateStoredProfileAssociations(y)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(x.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=k,e.UserDataProfilesReadonlyService=k=ve([re(0,A.IStateReadService),re(1,E.IUriIdentityService),re(2,T.INativeEnvironmentService),re(3,L.IFileService),re(4,N.ILogService)],k);let g=class Ue extends k{constructor(y,m,d,h,C){super(y,m,d,h,C),this.stateService=y}saveStoredProfiles(y){y.length?this.stateService.setItem(Ue.PROFILES_KEY,y.map(m=>({...m,location:this.uriIdentityService.extUri.basename(m.location)}))):this.stateService.removeItem(Ue.PROFILES_KEY)}getStoredProfiles(){const y=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(y),this.stateService.setItem("userDataProfilesMigration",!0)),y}saveStoredProfileAssociations(y){y.emptyWindows||y.workspaces?this.stateService.setItem(Ue.PROFILE_ASSOCIATIONS_KEY,y):this.stateService.removeItem(Ue.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const y="workspaceAndProfileInfo",m=this.stateService.getItem(y,void 0);if(m){this.stateService.removeItem(y);const h=m.reduce((C,{workspace:p,profile:w})=>(C[x.URI.revive(p).toString()]=x.URI.revive(w).toString(),C),{});this.stateService.setItem(Ue.PROFILE_ASSOCIATIONS_KEY,{workspaces:h})}const d=super.getStoredProfileAssociations();return this.stateService.getItem(Ue.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(d),this.stateService.setItem(Ue.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),d}};e.UserDataProfilesService=g,e.UserDataProfilesService=g=ve([re(0,A.IStateService),re(1,E.IUriIdentityService),re(2,T.INativeEnvironmentService),re(3,L.IFileService),re(4,N.ILogService)],g);let f=class extends g{constructor(y,m,d,h){super(new S.StateService(0,m,h,d),y,m,d,h)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=f,e.ServerUserDataProfilesService=f=ve([re(0,E.IUriIdentityService),re(1,T.INativeEnvironmentService),re(2,L.IFileService),re(3,N.ILogService)],f)}),define(ne[51],se([0,1,125,8,16,3,24,87,174,175]),function(q,e,x,T,L,N,A,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const S=new RegExp(e.CorruptZipMessage);class k extends Error{constructor(a,i){let r=i.message;switch(a){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=a,this.cause=i}}e.ExtractError=k;function g(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>a&i).reduce((i,r)=>i+r,a&61440)}function f(t){if(t instanceof k)return t;let a;return S.test(t.message)&&(a="CorruptZip"),new k(a,t)}function R(t,a,i,r,n,o){const c=L.dirname(a),D=L.join(r,c);if(!D.startsWith(r))return Promise.reject(new Error(E.localize(0,null,a)));const P=L.join(r,a);let b;return o.onCancellationRequested(()=>{b?.destroy()}),Promise.resolve(A.Promises.mkdir(D,{recursive:!0})).then(()=>new Promise((O,j)=>{if(!o.isCancellationRequested)try{b=(0,x.createWriteStream)(P,{mode:i}),b.once("close",()=>O()),b.once("error",j),t.once("error",j),t.pipe(b)}catch(ee){j(ee)}}))}function y(t,a,i,r){let n=(0,T.createCancelablePromise)(()=>Promise.resolve()),o=0;return r.onCancellationRequested(()=>{n.cancel(),t.close()}),new Promise((c,D)=>{const P=new T.Sequencer,b=O=>{O.isCancellationRequested||(o++,t.readEntry())};t.once("error",D),t.once("close",()=>n.then(()=>{r.isCancellationRequested||t.entryCount===o?c():D(new k("Incomplete",new Error(E.localize(1,null,o,t.entryCount))))},D)),t.readEntry(),t.on("entry",O=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(O.fileName)){b(r);return}const j=O.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(j)){const ce=L.join(a,j);n=(0,T.createCancelablePromise)(Z=>A.Promises.mkdir(ce,{recursive:!0}).then(()=>b(Z)).then(void 0,D));return}const ee=d(t,O),Y=g(O);n=(0,T.createCancelablePromise)(ce=>P.queue(()=>ee.then(Z=>R(Z,j,Y,a,i,ce).then(()=>b(ce)))).then(null,D))})})}function m(t,a=!1){return new Promise((i,r)=>{(0,u.open)(t,a?{lazyEntries:!0}:void 0,(n,o)=>{n?r(f(n)):i((0,N.assertIsDefined)(o))})})}function d(t,a){return new Promise((i,r)=>{t.openReadStream(a,(n,o)=>{n?r(f(n)):i((0,N.assertIsDefined)(o))})})}function h(t,a){return new Promise((i,r)=>{const n=new l.ZipFile;a.forEach(c=>{c.contents?n.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&n.addFile(c.localPath,c.path)}),n.end();const o=(0,x.createWriteStream)(t);n.outputStream.pipe(o),n.outputStream.once("error",r),o.once("error",r),o.once("finish",()=>i(t))})}e.zip=h;function C(t,a,i={},r){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let o=m(t,!0);return i.overwrite&&(o=o.then(c=>A.Promises.rm(a).then(()=>c))),o.then(c=>y(c,a,{sourcePathRegex:n},r))}e.extract=C;function p(t,a){return m(t).then(i=>new Promise((r,n)=>{i.on("entry",o=>{o.fileName===a&&d(i,o).then(c=>r(c),c=>n(c))}),i.once("close",()=>n(new Error(E.localize(2,null,a))))}))}function w(t,a){return p(t,a).then(i=>new Promise((r,n)=>{const o=[];i.once("error",n),i.on("data",c=>o.push(c)),i.on("end",()=>r(Buffer.concat(o)))}))}e.buffer=w}),define(ne[160],se([0,1,8,9,2,15,12,17,43,3,29,24,51,25,18,21,27,60,13,6]),function(q,e,x,T,L,N,A,E,u,l,S,k,g,f,R,y,m,d,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let p=class je extends L.Disposable{static{this.SignatureArchiveExtension=".sigzip"}constructor(t,a,i,r,n,o){super(),this.fileService=a,this.extensionGalleryService=i,this.configurationService=r,this.extensionSignatureVerificationService=n,this.logService=o,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(t,a,i){await this.cleanUpPromise;const r=(0,E.joinPath)(this.extensionsDownloadDir,this.getName(t));try{await this.downloadFile(t,r,o=>this.extensionGalleryService.download(t,o,a))}catch(o){throw new y.ExtensionManagementError(o.message,y.ExtensionManagementErrorCode.Download)}let n=!1;if(i&&this.shouldVerifySignature(t)){const o=await this.downloadSignatureArchive(t);try{n=await this.extensionSignatureVerificationService.verify(r.fsPath,o.fsPath,this.logService.getLevel()===C.LogLevel.Trace)}catch(c){const D=c;if(n=D.code,D.output&&this.logService.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${D.output}`),n===y.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===y.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new y.ExtensionManagementError(g.CorruptZipMessage,y.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(o)}catch(c){this.logService.error(c)}}}return n===!0?this.logService.info(`Extension signature is verified: ${t.identifier.id}`):n===!1?this.logService.info(`Extension signature verification is not done: ${t.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${n}': ${t.identifier.id}`),{location:r,verificationStatus:n}}shouldVerifySignature(t){if(!t.isSigned)return!1;const a=this.configurationService.getValue("extensions.verifySignature");return(0,l.isBoolean)(a)?a:!0}async downloadSignatureArchive(t){await this.cleanUpPromise;const a=(0,E.joinPath)(this.extensionsDownloadDir,`${this.getName(t)}${je.SignatureArchiveExtension}`);return await this.downloadFile(t,a,i=>this.extensionGalleryService.downloadSignatureArchive(t,i)),a}async downloadFile(t,a,i){if(await this.fileService.exists(a))return;if(a.scheme!==N.Schemas.file){await i(a);return}const r=(0,E.joinPath)(this.extensionsDownloadDir,`.${(0,S.generateUuid)()}`);await this.fileService.exists(r)||await i(r);try{await this.rename(r,a,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(r)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(n)}. Deleted the file from downloaded location`,r.path),n}}async delete(t){await this.cleanUpPromise,await this.fileService.del(t)}async rename(t,a,i){try{await k.Promises.rename(t.fsPath,a.fsPath)}catch(r){if(A.isWindows&&r&&r.code==="EPERM"&&Date.now()<i)return this.logService.info(`Failed renaming ${t} to ${a} with 'EPERM' error. Trying again...`),this.rename(t,a,i);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],i=[],r=[];for(const c of t.children)if(c.name.endsWith(je.SignatureArchiveExtension))r.push(c.resource);else{const D=m.ExtensionKey.parse(c.name);D&&i.push([D,c])}const n=(0,m.groupByExtension)(i,([c])=>c),o=[];for(const c of n)c.sort((D,P)=>u.rcompare(D[0].version,P[0].version)),a.push(...c.slice(1).map(D=>D[1].resource)),o.push(c[0][1]);o.sort((c,D)=>c.mtime-D.mtime),a.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(c=>c.resource)),a.push(...r),await x.Promises.settled(a.map(c=>(this.logService.trace("Deleting from cache",c.path),this.fileService.del(c))))}}catch(t){this.logService.error(t)}}getName(t){return this.cache?m.ExtensionKey.create(t).toString().toLowerCase():(0,S.generateUuid)()}};e.ExtensionsDownloader=p,e.ExtensionsDownloader=p=ve([re(0,R.INativeEnvironmentService),re(1,h.IFileService),re(2,y.IExtensionGalleryService),re(3,f.IConfigurationService),re(4,d.IExtensionSignatureVerificationService),re(5,C.ILogService)],p)}),define(ne[161],se([0,1,51,97]),function(q,e,x,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(N){return(0,x.buffer)(N,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,T.localize)(0,null))}})}e.getManifest=L}),define(ne[162],se([0,1,8,14,20,33,9,4,42,2,35,15,16,12,17,43,3,11,29,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,13,10,6,31,26,22,23]),function(q,e,x,T,L,N,A,E,u,l,S,k,g,f,R,y,m,d,h,C,p,w,t,a,i,r,n,o,c,D,P,b,O,j,ee,Y,ce,Z,ae,le,te,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ce.refineServiceDecorator)(r.IExtensionManagementService);const $=".vsctmp";let U=class extends i.AbstractExtensionManagementService{constructor(I,s,v,F,_,B,H,ie,de,he,ue,ge){super(I,s,ue,v,he,ge),this.extensionsScannerService=_,this.extensionsProfileScannerService=B,this.downloadService=H,this.fileService=de,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new S.ResourceSet;const me=this._register(ie.createInstance(P.ExtensionsLifecycle));this.extensionsScanner=this._register(ie.createInstance(M,ye=>me.postUninstall(ye))),this.manifestCache=this._register(new O.ExtensionsManifestCache(ge,de,ue,this,this.logService)),this.extensionsDownloader=this._register(ie.createInstance(D.ExtensionsDownloader));const fe=this._register(new j.ExtensionsWatcher(this,this.extensionsScannerService,ge,B,ue,de,v));this._register(fe.onDidChangeExtensionsByAnotherSource(ye=>this.onDidChangeExtensionsFromAnotherSource(ye))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,n.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(I){this.logService.trace("ExtensionManagementService#zip",I.identifier.id);const s=await this.collectFiles(I),v=await(0,p.zip)((0,R.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,h.generateUuid)()).fsPath,s);return d.URI.file(v)}async unzip(I){return this.logService.trace("ExtensionManagementService#unzip",I.toString()),(await this.install(I)).identifier}async getManifest(I){const{location:s,cleanup:v}=await this.downloadVsix(I),F=g.resolve(s.fsPath);try{return await(0,b.getManifest)(F)}finally{await v()}}getInstalled(I,s=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(I??null,s)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(I){return this.extensionsScanner.scanUserExtensionAtLocation(I)}async install(I,s={}){this.logService.trace("ExtensionManagementService#install",I.toString());const{location:v,cleanup:F}=await this.downloadVsix(I);try{const _=await(0,b.getManifest)(g.resolve(v.fsPath)),B=(0,n.getGalleryExtensionId)(_.publisher,_.name);if(_.engines&&_.engines.vscode&&!(0,ee.isEngineValid)(_.engines.vscode,this.productService.version,this.productService.date))throw new Error(w.localize(0,null,B,this.productService.version));const H=await this.installExtensions([{manifest:_,extension:v,options:s}]);if(H[0]?.local)return H[0]?.local;throw H[0]?.error?H[0].error:(0,i.toExtensionManagementError)(new Error(`Unknown error while installing extension ${B}`))}finally{await F()}}async installFromLocation(I,s){this.logService.trace("ExtensionManagementService#installFromLocation",I.toString());const v=await this.extensionsScanner.scanUserExtensionAtLocation(I);if(!v)throw new Error(`Cannot find a valid extension from the location ${I.toString()}`);return await this.addExtensionsToProfile([[v,void 0]],s),this.logService.info("Successfully installed extension",v.identifier.id,s.toString()),v}async installExtensionsFromProfile(I,s,v){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",I,s.toString(),v.toString());const F=(await this.extensionsScanner.scanExtensions(1,s)).filter(_=>I.some(B=>(0,n.areSameExtensions)(B,_.identifier)));if(F.length){const _=await Promise.all(F.map(B=>this.extensionsScanner.scanMetadata(B,s)));await this.addExtensionsToProfile(F.map((B,H)=>[B,_[H]]),v),this.logService.info("Successfully installed extensions",F.map(B=>B.identifier.id),v.toString())}return F}async updateMetadata(I,s,v=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",I.identifier.id),s.isPreReleaseVersion&&(s.preRelease=!0),s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.pinned=s.pinned||void 0,I=await this.extensionsScanner.updateMetadata(I,s,v),this.manifestCache.invalidate(v),this._onDidUpdateExtensionMetadata.fire(I),I}async reinstallFromGallery(I){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",I.identifier.id),!this.galleryService.isEnabled())throw new Error(w.localize(1,null));const s=await this.getTargetPlatform(),[v]=await this.galleryService.getExtensions([{...I.identifier,preRelease:I.preRelease}],{targetPlatform:s,compatible:!0},L.CancellationToken.None);if(!v)throw new Error(w.localize(2,null));await this.extensionsScanner.setUninstalled(I);try{await this.extensionsScanner.removeUninstalledExtension(I)}catch(F){throw new Error(w.localize(3,null,(0,N.toErrorMessage)(F)))}return this.installFromGallery(v)}copyExtension(I,s,v,F){return this.extensionsScanner.copyExtension(I,s,v,F)}copyExtensions(I,s){return this.extensionsScanner.copyExtensions(I,s)}markAsUninstalled(...I){return this.extensionsScanner.setUninstalled(...I)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(I){this.logService.error(I)}}async download(I,s,v){const{location:F}=await this.extensionsDownloader.download(I,s,!v);return F}async downloadVsix(I){if(I.scheme===k.Schemas.file)return{location:I,async cleanup(){}};this.logService.trace("Downloading extension from",I.toString());const s=(0,R.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,h.generateUuid)());return await this.downloadService.download(I,s),this.logService.info("Downloaded extension to",s.toString()),{location:s,cleanup:async()=>{try{await this.fileService.del(s)}catch(F){this.logService.error(F)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(I,s,v){if(d.URI.isUri(s))return new K(I,s,v,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const F=n.ExtensionKey.create(s).toString();let _=this.installGalleryExtensionsTasks.get(F);return _||(this.installGalleryExtensionsTasks.set(F,_=new G(I,s,v,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),_.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(F))),_}createUninstallExtensionTask(I,s){return new J(I,s.profileLocation,this.extensionsProfileScannerService)}async collectFiles(I){const s=async F=>{let _=await C.Promises.readdir(F);_=_.map(ie=>g.join(F,ie));const B=await Promise.all(_.map(ie=>C.Promises.stat(ie)));let H=Promise.resolve([]);return B.forEach((ie,de)=>{const he=_[de];ie.isFile()&&(H=H.then(ue=>[...ue,he])),ie.isDirectory()&&(H=H.then(ue=>s(he).then(ge=>[...ue,...ge])))}),H};return(await s(I.location.fsPath)).map(F=>({path:`extension/${g.relative(I.location.fsPath,F)}`,localPath:F}))}async onDidChangeExtensionsFromAnotherSource({added:I,removed:s}){if(s)for(const v of s.extensions)this.logService.info("Extensions removed from another source",v.id,s.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:v,profileLocation:s.profileLocation});if(I){const F=(await this.extensionsScanner.scanExtensions(1,I.profileLocation)).filter(_=>I.extensions.some(B=>(0,n.areSameExtensions)(B,_.identifier)));this._onDidInstallExtensions.fire(F.map(_=>(this.logService.info("Extensions added from another source",_.identifier.id,I.profileLocation.toString()),{identifier:_.identifier,local:_,profileLocation:I.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(s=>this.knownDirectories.add(s)));const I=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const s of I.children??[])s.isDirectory&&this.knownDirectories.add(s.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(s=>this.onDidFilesChange(s)))}async onDidFilesChange(I){if(!I.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const s=[];for(const v of I.rawAdded){if(this.knownDirectories.has(v)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(v),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(v,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(v).startsWith(".")||!(await this.fileService.stat(v)).isDirectory)continue;const F=await this.extensionsScanner.scanUserExtensionAtLocation(v);F&&F.installedTimestamp===void 0&&(this.knownDirectories.add(v),s.push(F))}s.length&&(await this.addExtensionsToProfile(s.map(v=>[v,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",s.map(v=>v.identifier.id)))}async addExtensionsToProfile(I,s){const v=I.map(F=>F[0]);await this.setInstalled(v),await this.extensionsProfileScannerService.addExtensionsToProfile(I,s),this._onDidInstallExtensions.fire(v.map(F=>({local:F,identifier:F.identifier,operation:1,profileLocation:s})))}async setInstalled(I){const s=await this.extensionsScanner.getUninstalledExtensions();for(const v of I){const F=n.ExtensionKey.create(v);s[F.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",F.id),await this.extensionsScanner.setInstalled(F),this.logService.info("Removed the extension from uninstalled list:",F.id))}}};e.ExtensionManagementService=U,e.ExtensionManagementService=U=ve([re(0,r.IExtensionGalleryService),re(1,le.ITelemetryService),re(2,Z.ILogService),re(3,a.INativeEnvironmentService),re(4,c.IExtensionsScannerService),re(5,o.IExtensionsProfileScannerService),re(6,t.IDownloadService),re(7,ce.IInstantiationService),re(8,Y.IFileService),re(9,ae.IProductService),re(10,te.IUriIdentityService),re(11,V.IUserDataProfilesService)],U);let M=class extends l.Disposable{constructor(I,s,v,F,_,B){super(),this.beforeRemovingExtension=I,this.fileService=s,this.extensionsScannerService=v,this.extensionsProfileScannerService=F,this.uriIdentityService=_,this.logService=B,this._onExtract=this._register(new E.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,R.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new x.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(I,s){const v={includeInvalid:!0,profileLocation:s};let F=[];return I===null||I===0?F.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},v,!1)):I===1&&F.push(...await this.extensionsScannerService.scanUserExtensions(v)),F=I!==null?F.filter(_=>_.type===I):F,Promise.all(F.map(_=>this.toLocalExtension(_)))}async scanAllUserExtensions(I){const s=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!I,includeInvalid:!0});return Promise.all(s.map(v=>this.toLocalExtension(v)))}async scanUserExtensionAtLocation(I){try{const s=await this.extensionsScannerService.scanExistingExtension(I,1,{includeInvalid:!0});if(s)return await this.toLocalExtension(s)}catch(s){this.logService.error(s)}return null}async extractUserExtension(I,s,v,F,_){const B=I.toString(),H=d.URI.file(g.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,h.generateUuid)()}`)),ie=d.URI.file(g.join(this.extensionsScannerService.userExtensionsLocation.fsPath,B));let de=await this.fileService.exists(ie);if(de&&F){try{await this.deleteExtensionFromLocation(I.id,ie,"removeExisting")}catch{throw new r.ExtensionManagementError(w.localize(4,null,ie.fsPath,I.id),r.ExtensionManagementErrorCode.Delete)}de=!1}if(!de)try{try{this.logService.trace(`Started extracting the extension from ${s} to ${ie.fsPath}`),await(0,p.extract)(s,H.fsPath,{sourcePath:"extension",overwrite:!0},_),this.logService.info(`Extracted extension to ${ie}:`,I.id)}catch(he){let ue=r.ExtensionManagementErrorCode.Extract;throw he instanceof p.ExtractError&&(he.type==="CorruptZip"?ue=r.ExtensionManagementErrorCode.CorruptZip:he.type==="Incomplete"&&(ue=r.ExtensionManagementErrorCode.IncompleteZip)),new r.ExtensionManagementError(he.message,ue)}await this.extensionsScannerService.updateMetadata(H,v);try{this.logService.trace(`Started renaming the extension from ${H.fsPath} to ${ie.fsPath}`),await this.rename(I,H.fsPath,ie.fsPath,Date.now()+2*60*1e3),this.logService.info("Renamed to",ie.fsPath)}catch(he){if(he.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",I.id);else throw this.logService.info(`Rename failed because of ${(0,A.getErrorMessage)(he)}. Deleted from extracted location`,H),he}this._onExtract.fire(ie)}catch(he){try{await this.fileService.del(H,{recursive:!0})}catch{}throw he}return this.scanLocalExtension(ie,1)}async scanMetadata(I,s){return s?(await this.getScannedExtension(I,s))?.metadata:this.extensionsScannerService.scanMetadata(I.location)}async getScannedExtension(I,s){return(await this.extensionsProfileScannerService.scanProfileExtensions(s)).find(F=>(0,n.areSameExtensions)(F.identifier,I.identifier))}async updateMetadata(I,s,v){return v?await this.extensionsProfileScannerService.updateMetadata([[I,s]],v):await this.extensionsScannerService.updateMetadata(I.location,s),this.scanLocalExtension(I.location,I.type,v)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...I){const s=I.map(v=>n.ExtensionKey.create(v));await this.withUninstalledExtensions(v=>s.forEach(F=>{v[F.toString()]=!0,this.logService.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(I){await this.withUninstalledExtensions(s=>delete s[I.toString()])}async removeExtension(I,s){if(this.uriIdentityService.extUri.isEqualOrParent(I.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(I.identifier.id,I.location,s)}async removeUninstalledExtension(I){await this.removeExtension(I,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[n.ExtensionKey.create(I).toString()])}async copyExtension(I,s,v,F){const _=await this.getScannedExtension(I,s),B=await this.getScannedExtension(I,v);return F={..._?.metadata,...F},B?await this.extensionsProfileScannerService.updateMetadata([[I,{...B.metadata,...F}]],v):await this.extensionsProfileScannerService.addExtensionsToProfile([[I,F]],v),this.scanLocalExtension(I.location,I.type,v)}async copyExtensions(I,s){const v=await this.scanExtensions(1,I),F=await Promise.all(v.filter(_=>!_.isApplicationScoped).map(async _=>[_,await this.scanMetadata(_,I)]));await this.extensionsProfileScannerService.addExtensionsToProfile(F,s)}async deleteExtensionFromLocation(I,s,v){this.logService.trace(`Deleting ${v} extension from disk`,I,s.fsPath);const F=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(s),`${this.uriIdentityService.extUri.basename(s)}.${(0,u.hash)((0,h.generateUuid)()).toString(16)}${$}`);await this.rename({id:I},s.fsPath,F.fsPath,Date.now()+2*60*1e3),await this.fileService.del(F,{recursive:!0}),this.logService.info(`Deleted ${v} extension from disk`,I,s.fsPath)}async withUninstalledExtensions(I){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(F){if((0,Y.toFileOperationResult)(F)!==1)throw F}let v={};if(s)try{v=JSON.parse(s)}catch{}return I&&(I(v),Object.keys(v).length?await this.fileService.writeFile(this.uninstalledResource,T.VSBuffer.fromString(JSON.stringify(v))):await this.fileService.del(this.uninstalledResource)),v})}async rename(I,s,v,F){try{await C.Promises.rename(s,v)}catch(_){if(f.isWindows&&_&&_.code==="EPERM"&&Date.now()<F)return this.logService.info(`Failed renaming ${s} to ${v} with 'EPERM' error. Trying again...`,I.id),this.rename(I,s,v,F);throw new r.ExtensionManagementError(_.message||w.localize(5,null,s,v),_.code||r.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(I,s,v){if(v){const _=(await this.extensionsScannerService.scanUserExtensions({profileLocation:v})).find(B=>this.uriIdentityService.extUri.isEqual(B.location,I));if(_)return this.toLocalExtension(_)}else{const F=await this.extensionsScannerService.scanExistingExtension(I,s,{includeInvalid:!0});if(F)return this.toLocalExtension(F)}throw new Error(w.localize(6,null,I.path))}async toLocalExtension(I){const s=await this.fileService.resolve(I.location);let v,F;return s.children&&(v=s.children.find(({name:_})=>/^readme(\.txt|\.md|)$/i.test(_))?.resource,F=s.children.find(({name:_})=>/^changelog(\.txt|\.md|)$/i.test(_))?.resource),{identifier:I.identifier,type:I.type,isBuiltin:I.isBuiltin||!!I.metadata?.isBuiltin,location:I.location,manifest:I.manifest,targetPlatform:I.targetPlatform,validations:I.validations,isValid:I.isValid,readmeUrl:v,changelogUrl:F,publisherDisplayName:I.metadata?.publisherDisplayName||null,publisherId:I.metadata?.publisherId||null,isApplicationScoped:!!I.metadata?.isApplicationScoped,isMachineScoped:!!I.metadata?.isMachineScoped,isPreReleaseVersion:!!I.metadata?.isPreReleaseVersion,preRelease:!!I.metadata?.preRelease,installedTimestamp:I.metadata?.installedTimestamp,updated:!!I.metadata?.updated,pinned:!!I.metadata?.pinned}}async removeUninstalledExtensions(){const I=await this.getUninstalledExtensions();if(Object.keys(I).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(I));const s=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),v=new Set;for(const _ of s)I[n.ExtensionKey.create(_).toString()]||v.add(_.identifier.id.toLowerCase());try{const _=(0,n.groupByExtension)(s,B=>B.identifier);await x.Promises.settled(_.map(async B=>{const H=B.sort((ie,de)=>y.rcompare(ie.manifest.version,de.manifest.version))[0];v.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(H))}))}catch(_){this.logService.error(_)}const F=s.filter(_=>_.metadata&&I[n.ExtensionKey.create(_).toString()]);await Promise.allSettled(F.map(_=>this.removeUninstalledExtension(_)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let I;try{I=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(s){(0,Y.toFileOperationResult)(s)!==1&&this.logService.error(s);return}if(I?.children)try{await Promise.allSettled(I.children.map(async s=>{if(!(!s.isDirectory||!s.name.endsWith($))){this.logService.trace("Deleting the temporarily deleted folder",s.resource.toString());try{await this.fileService.del(s.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",s.resource.toString())}catch(v){(0,Y.toFileOperationResult)(v)!==1&&this.logService.error(v)}}}))}catch{}}};e.ExtensionsScanner=M,e.ExtensionsScanner=M=ve([re(1,Y.IFileService),re(2,c.IExtensionsScannerService),re(3,o.IExtensionsProfileScannerService),re(4,te.IUriIdentityService),re(5,Z.ILogService)],M);class z extends i.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,m.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(I,s,v,F,_,B,H,ie,de){super(),this.identifier=I,this.source=s,this.options=v,this.extensionsScanner=F,this.uriIdentityService=_,this.userDataProfilesService=B,this.extensionsScannerService=H,this.extensionsProfileScannerService=ie,this.logService=de,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(I){const[s,v]=await this.install(I);return this._profileLocation=s.isBuiltin||s.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[s,v]],this._profileLocation),s}async extractExtension({zipPath:I,key:s,metadata:v},F,_){let B=await this.unsetIfUninstalled(s);return B||(this.logService.trace("Extracting extension...",s.id),B=await this.extensionsScanner.extractUserExtension(s,I,v,F,_),this.logService.info("Extracting extension completed.",s.id)),B}async unsetIfUninstalled(I){return await this.isUninstalled(I)?(this.logService.trace("Removing the extension from uninstalled list:",I.id),await this.extensionsScanner.setInstalled(I),this.logService.info("Removed the extension from uninstalled list:",I.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(F=>n.ExtensionKey.create(F).equals(I))):void 0}async isUninstalled(I){return!!(await this.extensionsScanner.getUninstalledExtensions())[I.toString()]}}class G extends z{constructor(I,s,v,F,_,B,H,ie,de,he){super(s.identifier,s,v,_,B,H,ie,de,he),this.gallery=s,this.extensionsDownloader=F}async install(I){const v=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(H=>(0,n.areSameExtensions)(H.identifier,this.gallery.identifier));v&&(this._operation=3);const F={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||v?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||v?.isMachineScoped,isBuiltin:this.options.isBuiltin||v?.isBuiltin,isSystem:v?.type===0?!0:void 0,updated:!!v,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,m.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:v?.preRelease)};if(v?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(v,F),F];const{location:_,verificationStatus:B}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=B,this.validateManifest(_.fsPath),[await this.extractExtension({zipPath:_.fsPath,key:n.ExtensionKey.create(this.gallery),metadata:F},!1,I),F]}catch(H){try{await this.extensionsDownloader.delete(_)}catch(ie){this.logService.warn("Error while deleting the downloaded file",_.toString(),(0,A.getErrorMessage)(ie))}throw H}}async validateManifest(I){try{await(0,b.getManifest)(I)}catch(s){throw new r.ExtensionManagementError((0,i.joinErrors)(s).message,r.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=G;class K extends z{constructor(I,s,v,F,_,B,H,ie,de,he){super({id:(0,n.getGalleryExtensionId)(I.publisher,I.name)},s,v,_,B,H,ie,de,he),this.manifest=I,this.location=s,this.galleryService=F}async doRun(I){const s=await super.doRun(I);return this.updateMetadata(s,I),s}async install(I){const s=new n.ExtensionKey(this.identifier,this.manifest.version),F=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(H=>(0,n.areSameExtensions)(this.identifier,H.identifier)),_={isApplicationScoped:this.options.isApplicationScoped||F?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||F?.isMachineScoped,isBuiltin:this.options.isBuiltin||F?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(F)if(this._operation=3,s.equals(new n.ExtensionKey(F.identifier,F.manifest.version)))try{await this.extensionsScanner.removeExtension(F,"existing")}catch{throw new Error(w.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&y.gt(F.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(F);else{const H=await this.unsetIfUninstalled(s);if(H)try{await this.extensionsScanner.removeExtension(H,"existing")}catch{throw new Error(w.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:g.resolve(this.location.fsPath),key:s,metadata:_},!0,I),_]}async updateMetadata(I,s){try{let[v]=await this.galleryService.getExtensions([{id:I.identifier.id,version:I.manifest.version}],s);if(v||([v]=await this.galleryService.getExtensions([{id:I.identifier.id}],s)),v){const F={id:v.identifier.uuid,publisherDisplayName:v.publisherDisplayName,publisherId:v.publisherId,isPreReleaseVersion:v.properties.isPreReleaseVersion,preRelease:v.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(I,F,this.options.profileLocation)}}catch{}}}class J extends i.AbstractExtensionTask{constructor(I,s,v){super(),this.extension=I,this.profileLocation=s,this.extensionsProfileScannerService=v}async doRun(I){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(ne[163],se([0,1,137,8,14,9,3,25,18,138,6,45,136,176]),function(q,e,x,T,L,N,A,E,u,l,S,k,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let R=class extends k.AbstractRequestService{constructor(h,C,p,w){super(w),this.configurationService=h,this.environmentService=C,this.logService=p,this.configure(),this._register(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const h=this.configurationService.getValue("http");this.proxyUrl=h?.proxy,this.strictSSL=!!h?.proxyStrictSSL,this.authorization=h?.proxyAuthorization}async request(h,C){const{proxyUrl:p,strictSSL:w}=this;let t;try{t=await(0,l.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,N.getErrorMessage)(r)))}const a={...process.env,...t},i=h.agent?h.agent:await(0,g.getProxyAgent)(h.url||"",a,{proxyUrl:p,strictSSL:w});return h.agent=i,h.strictSSL=w,this.authorization&&(h.headers={...h.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(h.isChromiumNetwork?"electron":"node",h,()=>m(h,C))}async resolveProxy(h){}};e.RequestService=R,e.RequestService=R=ve([re(0,E.IConfigurationService),re(1,u.INativeEnvironmentService),re(2,S.ILogService),re(3,S.ILoggerService)],R);async function y(d){return((0,x.parse)(d.url).protocol==="https:"?await new Promise((p,w)=>{q(["https"],p,w)}):await new Promise((p,w)=>{q(["http"],p,w)})).request}async function m(d,h){return T.Promises.withAsyncBody(async(C,p)=>{const w=(0,x.parse)(d.url),t=d.getRawRequest?d.getRawRequest(d):await y(d),a={hostname:w.hostname,port:w.port?parseInt(w.port):w.protocol==="https:"?443:80,protocol:w.protocol,path:w.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,A.isBoolean)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(a.auth=d.user+":"+d.password);const i=t(a,r=>{const n=(0,A.isNumber)(d.followRedirects)?d.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&n>0&&r.headers.location)m({...d,url:r.headers.location,followRedirects:n-1},h).then(C,p);else{let o=r;!d.isChromiumNetwork&&r.headers["content-encoding"]==="gzip"&&(o=r.pipe((0,f.createGunzip)())),C({res:r,stream:(0,L.streamToBufferReadableStream)(o)})}});i.on("error",p),d.timeout&&i.setTimeout(d.timeout),d.isChromiumNetwork&&i.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&i.write(d.data),i.end(),h.onCancellationRequested(()=>{i.abort(),p(new N.CancellationError)})})}e.nodeRequest=m}),define(ne[177],se([0,1,32,8,33,9,2,15,16,12,34,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,13,122,124,49,120,63,64,143,6,129,38,130,146,31,45,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(q,e,x,T,L,N,A,E,u,l,S,k,g,f,R,y,m,d,h,C,p,w,t,a,i,r,n,o,c,D,P,b,O,j,ee,Y,ce,Z,ae,le,te,V,$,U,M,z,G,K,J,oe,I,s,v,F,_,B,H,ie,de,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ue extends A.Disposable{constructor(fe){super(),this.argv=fe,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[fe,ye]=await this.initServices();return fe.invokeFunction(async Pe=>{const Oe=Pe.get(Y.ILogService),Me=Pe.get(o.IFileService),W=Pe.get(d.INativeEnvironmentService),X=Pe.get(v.IUserDataProfilesService);Oe.info("CLI main",this.argv),this.registerErrorHandler(Oe),await this.doRun(W,Me,X,fe),await Promise.all(ye.map(Q=>{(0,T.raceTimeout)(Q.flush(),1e3)}))})}async initServices(){const fe=new O.ServiceCollection,ye={_serviceBrand:void 0,...le.default};fe.set(te.IProductService,ye);const Pe=new h.NativeEnvironmentService(this.argv,ye);fe.set(d.INativeEnvironmentService,Pe),await Promise.all([Pe.appSettingsHome.fsPath,Pe.extensionsPath].map(Le=>Le?g.Promises.mkdir(Le,{recursive:!0}):void 0));const Oe=new ie.LoggerService((0,Y.getLogLevel)(Pe),Pe.logsHome);fe.set(Y.ILoggerService,Oe);const Me=this._register(Oe.createLogger("cli",{name:(0,de.localize)(0,null)})),W=[];Oe.getLogLevel()===Y.LogLevel.Trace&&W.push(new Y.ConsoleLogger(Oe.getLogLevel()));const X=this._register(new H.LogService(Me,W));fe.set(Y.ILogService,X);const Q=this._register(new c.FileService(X));fe.set(o.IFileService,Q);const pe=this._register(new D.DiskFileSystemProvider(X));Q.registerProvider(E.Schemas.file,pe),Q.registerProvider(E.Schemas.vscodeUserData,new he.FileUserDataProvider(E.Schemas.file,pe,E.Schemas.vscodeUserData,X));const Se=new s.UriIdentityService(Q);fe.set(I.IUriIdentityService,Se);const ke=new U.StateReadonlyService(1,Pe,X,Q),Ie=new F.UserDataProfilesReadonlyService(ke,Se,Pe,Q,X);fe.set(v.IUserDataProfilesService,Ie);const Ne=l.isWindows&&ye.win32RegValueName?this._register(new ae.NativePolicyService(X,ye.win32RegValueName)):Pe.policyFile?this._register(new ce.FilePolicyService(Pe.policyFile,Q,X)):new Z.NullPolicyService;fe.set(Z.IPolicyService,Ne);const De=this._register(new R.ConfigurationService(Ie.defaultProfile.settingsResource,Q,Ne,X));fe.set(f.IConfigurationService,De),await Promise.all([ke.init(),De.initialize()]);let Ae;try{Ae=await(0,_.resolveMachineId)(ke,X)}catch(Le){Le.code!=="ENOENT"&&X.error(Le)}Ie.init(),fe.set(I.IUriIdentityService,new s.UriIdentityService(Q));const Fe=new $.RequestService(De,Pe,X,Oe);fe.set(V.IRequestService,Fe),fe.set(y.IDownloadService,new P.SyncDescriptor(m.DownloadService,void 0,!0)),fe.set(a.IExtensionsProfileScannerService,new P.SyncDescriptor(B.ExtensionsProfileScannerService,void 0,!0)),fe.set(i.IExtensionsScannerService,new P.SyncDescriptor(n.ExtensionsScannerService,void 0,!0)),fe.set(w.IExtensionSignatureVerificationService,new P.SyncDescriptor(w.ExtensionSignatureVerificationService,void 0,!0)),fe.set(r.INativeServerExtensionManagementService,new P.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),fe.set(p.IExtensionGalleryService,new P.SyncDescriptor(C.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),fe.set(j.ILanguagePackService,new P.SyncDescriptor(ee.NativeLanguagePackService,void 0,!1));const Ce=[],Te=(0,K.isInternalTelemetry)(ye,De);if((0,K.supportsTelemetry)(ye,Pe)){ye.aiConfig&&ye.aiConfig.ariaKey&&Ce.push(new J.OneDataSystemAppender(Fe,Te,"monacoworkbench",null,ye.aiConfig.ariaKey));const Le={appenders:Ce,sendErrorTelemetry:!1,commonProperties:(0,M.resolveCommonProperties)((0,x.release)(),(0,x.hostname)(),process.arch,ye.commit,ye.version,Ae,Te),piiPaths:(0,K.getPiiPathsFromEnvironment)(Pe)};fe.set(z.ITelemetryService,new P.SyncDescriptor(G.TelemetryService,[Le],!1))}else fe.set(z.ITelemetryService,K.NullTelemetryService);return[new b.InstantiationService(fe),Ce]}registerErrorHandler(fe){(0,N.setUnexpectedErrorHandler)(ye=>{const Pe=(0,L.toErrorMessage)(ye,!0);Pe&&fe.error(`[uncaught exception in CLI]: ${Pe}`)}),process.on("uncaughtException",ye=>{(0,N.isSigPipeError)(ye)||(0,N.onUnexpectedError)(ye)}),process.on("unhandledRejection",ye=>(0,N.onUnexpectedError)(ye))}async doRun(fe,ye,Pe,Oe){let Me;if(fe.args.profile&&(Me=Pe.profiles.find(X=>X.name===fe.args.profile),!Me))throw new Error(`Profile '${fe.args.profile}' not found.`);const W=(Me??Pe.defaultProfile).extensionsResource;if(this.argv["list-extensions"])return Oe.createInstance(t.ExtensionManagementCLI,new Y.ConsoleLogger(Y.LogLevel.Info,!1)).listExtensions(!!this.argv["show-versions"],this.argv.category,W);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const X={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:W};return Oe.createInstance(t.ExtensionManagementCLI,new Y.ConsoleLogger(Y.LogLevel.Info,!1)).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.asExtensionIdOrVSIX(this.argv["install-builtin-extension"]||[]),X,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return Oe.createInstance(t.ExtensionManagementCLI,new Y.ConsoleLogger(Y.LogLevel.Info,!1)).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,W);if(this.argv["locate-extension"])return Oe.createInstance(t.ExtensionManagementCLI,new Y.ConsoleLogger(Y.LogLevel.Info,!1)).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,oe.buildTelemetryMessage)(fe.appRoot,fe.extensionsPath))}}asExtensionIdOrVSIX(fe){return fe.map(ye=>/\.vsix$/i.test(ye)?k.URI.file((0,u.isAbsolute)(ye)?ye:(0,u.join)((0,S.cwd)(),ye)):ye)}}async function ge(me){const fe=new ue(me);try{await fe.run()}finally{fe.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/aef377c42cea6e9aea642829953104f07097abfa/core/vs/code/node/cliProcessMain.js.map
