/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/base/common/types","vs/nls","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/network","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/stream","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/amd","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","stream","util","path","graceful-fs","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(te){for(var e=[],L=0,N=te.length;L<N;L++)e[L]=oe[te[L]];return e};define(oe[122],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class L{static get(){const T=new Map,A=new Map,k=new Map,D=new Map;function P(u,g){u.has(g.detail)||u.set(g.detail,-g.timestamp)}function v(u,g){const w=u.get(g.detail);w&&(w>=0||u.set(g.detail,w+g.timestamp))}let I=[];typeof te=="function"&&typeof te.getStats=="function"&&(I=te.getStats().slice(0).sort((u,g)=>u.timestamp-g.timestamp));for(const u of I)switch(u.type){case 10:P(T,u);break;case 11:case 12:v(T,u);break;case 21:P(A,u);break;case 22:v(A,u);break;case 33:P(k,u);break;case 34:v(k,u);break;case 31:P(D,u);break;case 32:v(D,u);break}let C=0;k.forEach(u=>C+=u);function S(u){const g=[];return u.forEach((w,c)=>g.push([c,w])),g}return{amdLoad:S(T),amdInvoke:S(A),nodeRequire:S(k),nodeEval:S(D),nodeRequireTotal:C}}static toMarkdownTable(T,A){let k="";const D=[];return T.forEach((P,v)=>{D[v]=P.length}),A.forEach(P=>{P.forEach((v,I)=>{typeof v>"u"&&(v=P[I]="-");const C=v.toString().length;D[I]=Math.max(C,D[I])})}),T.forEach((P,v)=>{k+=`| ${P+" ".repeat(D[v]-P.toString().length)} `}),k+=`|
`,T.forEach((P,v)=>{k+=`| ${"-".repeat(D[v])} `}),k+=`|
`,A.forEach(P=>{P.forEach((v,I)=>{typeof v<"u"&&(k+=`| ${v+" ".repeat(D[I]-v.toString().length)} `)}),k+=`|
`}),k}}e.LoaderStats=L}),define(oe[81],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function L(k){return(D,P,v)=>{let I=null,C=null;if(typeof v.value=="function"?(I="value",C=v.value):typeof v.get=="function"&&(I="get",C=v.get),!C)throw new Error("not supported");v[I]=k(C,P)}}function N(k,D,P){let v=null,I=null;if(typeof P.value=="function"?(v="value",I=P.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(v="get",I=P.get),!I)throw new Error("not supported");const C=`$memoize$${D}`;P[v]=function(...S){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,S)}),this[C]}}e.memoize=N;function T(k,D,P){return L((v,I)=>{const C=`$debounce$${I}`,S=`$debounce$result$${I}`;return function(...u){this[S]||(this[S]=P?P():void 0),clearTimeout(this[C]),D&&(this[S]=D(this[S],...u),u=[this[S]]),this[C]=setTimeout(()=>{v.apply(this,u),this[S]=P?P():void 0},k)}})}e.debounce=T;function A(k,D,P){return L((v,I)=>{const C=`$throttle$timer$${I}`,S=`$throttle$result$${I}`,u=`$throttle$lastRun$${I}`,g=`$throttle$pending$${I}`;return function(...w){if(this[S]||(this[S]=P?P():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),D&&(this[S]=D(this[S],...w)),this[g])return;const c=this[u]+k;c<=Date.now()?(this[u]=Date.now(),v.apply(this,[this[S]]),this[S]=P?P():void 0):(this[g]=!0,this[C]=setTimeout(()=>{this[g]=!1,this[u]=Date.now(),v.apply(this,[this[S]]),this[S]=P?P():void 0},c-Date.now()))}})}e.throttle=A}),define(oe[7],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class L{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?E.isErrorNoTelemetry(o)?new E(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(n=>{n(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=L,e.errorHandler=new L;function N(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=N;function T(t){if(!t||typeof t!="object")return!1;const o=t;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=T;function A(t){v(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=A;function k(t){v(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=k;function D(t){if(t instanceof Error){const{name:o,message:n}=t,s=t.stacktrace||t.stack;return{$isError:!0,name:o,message:n,stack:s,noTelemetry:E.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=D;const P="Canceled";function v(t){return t instanceof I?!0:t instanceof Error&&t.name===P&&t.message===P}e.isCancellationError=v;class I extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=I;function C(){const t=new Error(P);return t.name=t.message,t}e.canceled=C;function S(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=S;function u(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=u;function g(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function w(t){const o=new Error(`${t} has been disposed`);return o.name="DISPOSED",o}e.disposed=w;function c(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=c;class l extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=l;class h extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=h;class y extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=y;class E extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof E)return o;const n=new E;return n.message=o.message,n.stack=o.stack,n}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=E;class R extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,R.prototype)}}e.BugIndicatingError=R}),define(oe[21],ae([0,1,7]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function N(W,K=0){return W[W.length-(1+K)]}e.tail=N;function T(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=T;function A(W,K,Z=(se,ue)=>se===ue){if(W===K)return!0;if(!W||!K||W.length!==K.length)return!1;for(let se=0,ue=W.length;se<ue;se++)if(!Z(W[se],K[se]))return!1;return!0}e.equals=A;function k(W,K){const Z=W.length-1;K<Z&&(W[K]=W[Z]),W.pop()}e.removeFastWithoutKeepingOrder=k;function D(W,K,Z){return P(W.length,se=>Z(W[se],K))}e.binarySearch=D;function P(W,K){let Z=0,se=W-1;for(;Z<=se;){const ue=(Z+se)/2|0,he=K(ue);if(he<0)Z=ue+1;else if(he>0)se=ue-1;else return ue}return-(Z+1)}e.binarySearch2=P;function v(W,K){let Z=0,se=W.length;if(se===0)return 0;for(;Z<se;){const ue=Math.floor((Z+se)/2);K(W[ue])?se=ue:Z=ue+1}return Z}e.findFirstInSorted=v;function I(W,K,Z){if(W=W|0,W>=K.length)throw new TypeError("invalid index");const se=K[Math.floor(K.length*Math.random())],ue=[],he=[],Se=[];for(const Ee of K){const be=Z(Ee,se);be<0?ue.push(Ee):be>0?he.push(Ee):Se.push(Ee)}return W<ue.length?I(W,ue,Z):W<ue.length+Se.length?Se[0]:I(W-(ue.length+Se.length),he,Z)}e.quickSelect=I;function C(W,K){const Z=[];let se;for(const ue of W.slice(0).sort(K))!se||K(se[0],ue)!==0?(se=[ue],Z.push(se)):se.push(ue);return Z}e.groupBy=C;function S(W,K,Z){const se=[];function ue(Ee,be,De){if(be===0&&De.length===0)return;const _e=se[se.length-1];_e&&_e.start+_e.deleteCount===Ee?(_e.deleteCount+=be,_e.toInsert.push(...De)):se.push({start:Ee,deleteCount:be,toInsert:De})}let he=0,Se=0;for(;;){if(he===W.length){ue(he,0,K.slice(Se));break}if(Se===K.length){ue(he,W.length-he,[]);break}const Ee=W[he],be=K[Se],De=Z(Ee,be);De===0?(he+=1,Se+=1):De<0?(ue(he,1,[]),he+=1):De>0&&(ue(he,0,[be]),Se+=1)}return se}e.sortedDiff=S;function u(W,K,Z){const se=S(W,K,Z),ue=[],he=[];for(const Se of se)ue.push(...W.slice(Se.start,Se.start+Se.deleteCount)),he.push(...Se.toInsert);return{removed:ue,added:he}}e.delta=u;function g(W,K,Z){if(Z===0)return[];const se=W.slice(0,Z).sort(K);return c(W,K,se,Z,W.length),se}e.top=g;function w(W,K,Z,se,ue){return Z===0?Promise.resolve([]):new Promise((he,Se)=>{(async()=>{const Ee=W.length,be=W.slice(0,Z).sort(K);for(let De=Z,_e=Math.min(Z+se,Ee);De<Ee;De=_e,_e=Math.min(_e+se,Ee)){if(De>Z&&await new Promise($e=>setTimeout($e)),ue&&ue.isCancellationRequested)throw new L.CancellationError;c(W,K,be,De,_e)}return be})().then(he,Se)})}e.topAsync=w;function c(W,K,Z,se,ue){for(const he=Z.length;se<ue;se++){const Se=W[se];if(K(Se,Z[he-1])<0){Z.pop();const Ee=v(Z,be=>K(Se,be)<0);Z.splice(Ee,0,Se)}}}function l(W){return W.filter(K=>!!K)}e.coalesce=l;function h(W){let K=0;for(let Z=0;Z<W.length;Z++)W[Z]&&(W[K]=W[Z],K+=1);W.length=K}e.coalesceInPlace=h;function y(W,K,Z){W.splice(Z,0,W.splice(K,1)[0])}e.move=y;function E(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=E;function R(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=R;function t(W,K=Z=>Z){const Z=new Set;return W.filter(se=>{const ue=K(se);return Z.has(ue)?!1:(Z.add(ue),!0)})}e.distinct=t;function o(W){const K=new Set;return Z=>{const se=W(Z);return K.has(se)?!1:(K.add(se),!0)}}e.uniqueFilter=o;function n(W,K){const Z=s(W,K);if(Z!==-1)return W[Z]}e.findLast=n;function s(W,K){for(let Z=W.length-1;Z>=0;Z--){const se=W[Z];if(K(se))return Z}return-1}e.lastIndex=s;function i(W,K){return W.length>0?W[0]:K}e.firstOrDefault=i;function r(W,K){return W.length>0?W[W.length-1]:K}e.lastOrDefault=r;function a(W,K,Z=(se,ue)=>se===ue){let se=0;for(let ue=0,he=Math.min(W.length,K.length);ue<he&&Z(W[ue],K[ue]);ue++)se++;return se}e.commonPrefixLength=a;function p(W){return[].concat(...W)}e.flatten=p;function m(W,K){let Z=typeof K=="number"?W:0;typeof K=="number"?Z=W:(Z=0,K=W);const se=[];if(Z<=K)for(let ue=Z;ue<K;ue++)se.push(ue);else for(let ue=Z;ue>K;ue--)se.push(ue);return se}e.range=m;function d(W,K,Z){return W.reduce((se,ue)=>(se[K(ue)]=Z?Z(ue):ue,se),Object.create(null))}e.index=d;function b(W,K){return W.push(K),()=>O(W,K)}e.insert=b;function O(W,K){const Z=W.indexOf(K);if(Z>-1)return W.splice(Z,1),K}e.remove=O;function F(W,K,Z){const se=W.slice(0,K),ue=W.slice(K);return se.concat(Z,ue)}e.arrayInsert=F;function M(W,K){let Z;if(typeof K=="number"){let se=K;Z=()=>{const ue=Math.sin(se++)*179426549;return ue-Math.floor(ue)}}else Z=Math.random;for(let se=W.length-1;se>0;se-=1){const ue=Math.floor(Z()*(se+1)),he=W[se];W[se]=W[ue],W[ue]=he}}e.shuffle=M;function q(W,K){const Z=W.indexOf(K);Z>-1&&(W.splice(Z,1),W.unshift(K))}e.pushToStart=q;function j(W,K){const Z=W.indexOf(K);Z>-1&&(W.splice(Z,1),W.push(K))}e.pushToEnd=j;function B(W,K){for(const Z of K)W.push(Z)}e.pushMany=B;function Q(W,K){return Array.isArray(W)?W.map(K):K(W)}e.mapArrayOrNot=Q;function J(W){return Array.isArray(W)?W:[W]}e.asArray=J;function G(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=G;function X(W,K){for(const Z of W){const se=K(Z);if(se!==void 0)return se}}e.mapFind=X;function V(W,K,Z){const se=z(W,K),ue=W.length,he=Z.length;W.length=ue+he;for(let Se=ue-1;Se>=se;Se--)W[Se+he]=W[Se];for(let Se=0;Se<he;Se++)W[Se+se]=Z[Se]}e.insertInto=V;function x(W,K,Z,se){const ue=z(W,K),he=W.splice(ue,Z);return V(W,ue,se),he}e.splice=x;function z(W,K){return K<0?Math.max(K+W.length,0):Math.min(K,W.length)}var ee;(function(W){function K(ue){return ue<0}W.isLessThan=K;function Z(ue){return ue>0}W.isGreaterThan=Z;function se(ue){return ue===0}W.isNeitherLessOrGreaterThan=se,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function ne(W,K){return(Z,se)=>K(W(Z),W(se))}e.compareBy=ne;function ce(...W){return(K,Z)=>{for(const se of W){const ue=se(K,Z);if(!ee.isNeitherLessOrGreaterThan(ue))return ue}return ee.neitherLessOrGreaterThan}}e.tieBreakComparators=ce;const re=(W,K)=>W-K;e.numberComparator=re;function U(W,K){if(W.length===0)return;let Z=W[0];for(let se=1;se<W.length;se++){const ue=W[se];K(ue,Z)>0&&(Z=ue)}return Z}e.findMaxBy=U;function f(W,K){if(W.length===0)return;let Z=W[0];for(let se=1;se<W.length;se++){const ue=W[se];K(ue,Z)>=0&&(Z=ue)}return Z}e.findLastMaxBy=f;function _(W,K){return U(W,(Z,se)=>-K(Z,se))}e.findMinBy=_;class ${constructor(K){this.items=K,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(K){let Z=this.firstIdx;for(;Z<this.items.length&&K(this.items[Z]);)Z++;const se=Z===this.firstIdx?null:this.items.slice(this.firstIdx,Z);return this.firstIdx=Z,se}takeFromEndWhile(K){let Z=this.lastIdx;for(;Z>=0&&K(this.items[Z]);)Z--;const se=Z===this.lastIdx?null:this.items.slice(Z+1,this.lastIdx+1);return this.lastIdx=Z,se}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const K=this.items[this.firstIdx];return this.firstIdx++,K}removeLast(){const K=this.items[this.lastIdx];return this.lastIdx--,K}takeCount(K){const Z=this.items.slice(this.firstIdx,this.firstIdx+K);return this.firstIdx+=K,Z}}e.ArrayQueue=$;class H{static{this.empty=new H(K=>{})}constructor(K){this.iterate=K}forEach(K){this.iterate(Z=>(K(Z),!0))}toArray(){const K=[];return this.iterate(Z=>(K.push(Z),!0)),K}filter(K){return new H(Z=>this.iterate(se=>K(se)?Z(se):!0))}map(K){return new H(Z=>this.iterate(se=>Z(K(se))))}some(K){let Z=!1;return this.iterate(se=>(Z=K(se),!Z)),Z}findFirst(K){let Z;return this.iterate(se=>K(se)?(Z=se,!1):!0),Z}findLast(K){let Z;return this.iterate(se=>(K(se)&&(Z=se),!0)),Z}findLastMaxBy(K){let Z,se=!0;return this.iterate(ue=>((se||ee.isGreaterThan(K(ue,Z)))&&(se=!1,Z=ue),!0)),Z}}e.CallbackIterable=H}),define(oe[123],ae([0,1,7]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function N(P,v){if(!P)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=N;function T(P,v="Unreachable"){throw new Error(v)}e.assertNever=T;function A(P){if(!P)throw new L.BugIndicatingError("Assertion Failed")}e.assert=A;function k(P){if(!P()){debugger;P(),(0,L.onUnexpectedError)(new L.BugIndicatingError("Assertion Failed"))}}e.assertFn=k;function D(P,v){let I=0;for(;I<P.length-1;){const C=P[I],S=P[I+1];if(!v(C,S))return!1;I++}return!0}e.checkAdjacentItems=D}),define(oe[82],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function L(N){const T=this;let A=!1,k;return function(){return A||(A=!0,k=N.apply(T,arguments)),k}}e.once=L}),define(oe[59],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(N){function T(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}N.is=T;const A=Object.freeze([]);function k(){return A}N.empty=k;function*D(E){yield E}N.single=D;function P(E){return T(E)?E:D(E)}N.wrap=P;function v(E){return E||A}N.from=v;function I(E){return!E||E[Symbol.iterator]().next().done===!0}N.isEmpty=I;function C(E){return E[Symbol.iterator]().next().value}N.first=C;function S(E,R){for(const t of E)if(R(t))return!0;return!1}N.some=S;function u(E,R){for(const t of E)if(R(t))return t}N.find=u;function*g(E,R){for(const t of E)R(t)&&(yield t)}N.filter=g;function*w(E,R){let t=0;for(const o of E)yield R(o,t++)}N.map=w;function*c(...E){for(const R of E)for(const t of R)yield t}N.concat=c;function l(E,R,t){let o=t;for(const n of E)o=R(o,n);return o}N.reduce=l;function*h(E,R,t=E.length){for(R<0&&(R+=E.length),t<0?t+=E.length:t>E.length&&(t=E.length);R<t;R++)yield E[R]}N.slice=h;function y(E,R=Number.POSITIVE_INFINITY){const t=[];if(R===0)return[t,E];const o=E[Symbol.iterator]();for(let n=0;n<R;n++){const s=o.next();if(s.done)return[t,N.empty()];t.push(s.value)}return[t,{[Symbol.iterator](){return o}}]}N.consume=y})(L||(e.Iterable=L={}))}),define(oe[34],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T||(e.ParseErrorCode=T={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function k(t,o=!1){let n=0;const s=t.length;let i="",r=0,a=16,p=0;function m(j){let B=0,Q=0;for(;B<j;){const J=t.charCodeAt(n);if(J>=48&&J<=57)Q=Q*16+J-48;else if(J>=65&&J<=70)Q=Q*16+J-65+10;else if(J>=97&&J<=102)Q=Q*16+J-97+10;else break;n++,B++}return B<j&&(Q=-1),Q}function d(j){n=j,i="",r=0,a=16,p=0}function b(){const j=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&v(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&v(t.charCodeAt(n)))for(n++;n<t.length&&v(t.charCodeAt(n));)n++;else return p=3,t.substring(j,n);let B=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&v(t.charCodeAt(n))){for(n++;n<t.length&&v(t.charCodeAt(n));)n++;B=n}else p=3;return t.substring(j,B)}function O(){let j="",B=n;for(;;){if(n>=s){j+=t.substring(B,n),p=2;break}const Q=t.charCodeAt(n);if(Q===34){j+=t.substring(B,n),n++;break}if(Q===92){if(j+=t.substring(B,n),n++,n>=s){p=2;break}switch(t.charCodeAt(n++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const G=m(4);G>=0?j+=String.fromCharCode(G):p=4;break}default:p=5}B=n;continue}if(Q>=0&&Q<=31)if(P(Q)){j+=t.substring(B,n),p=2;break}else p=6;n++}return j}function F(){if(i="",p=0,r=n,n>=s)return r=s,a=17;let j=t.charCodeAt(n);if(D(j)){do n++,i+=String.fromCharCode(j),j=t.charCodeAt(n);while(D(j));return a=15}if(P(j))return n++,i+=String.fromCharCode(j),j===13&&t.charCodeAt(n)===10&&(n++,i+=`
`),a=14;switch(j){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,i=O(),a=10;case 47:{const B=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!P(t.charCodeAt(n));)n++;return i=t.substring(B,n),a=12}if(t.charCodeAt(n+1)===42){n+=2;const Q=s-1;let J=!1;for(;n<Q;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,J=!0;break}n++}return J||(n++,p=1),i=t.substring(B,n),a=13}return i+=String.fromCharCode(j),n++,a=16}case 45:if(i+=String.fromCharCode(j),n++,n===s||!v(t.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=b(),a=11;default:for(;n<s&&M(j);)n++,j=t.charCodeAt(n);if(r!==n){switch(i=t.substring(r,n),i){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return i+=String.fromCharCode(j),n++,a=16}}function M(j){if(D(j)||P(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let j;do j=F();while(j>=12&&j<=15);return j}return{setPosition:d,getPosition:()=>n,scan:o?q:F,getToken:()=>a,getTokenValue:()=>i,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>p}}e.createScanner=k;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function P(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function C(t,o){const n=[],s=new Object;let i;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function p(m,d,b,O){r.value=m,r.offset=d,r.length=b,r.type=O,r.colonOffset=void 0,i=r}try{y(t,{onObjectBegin:(m,d)=>{if(o<=m)throw s;i=void 0,a=o>m,n.push("")},onObjectProperty:(m,d,b)=>{if(o<d||(p(m,d,b,"property"),n[n.length-1]=m,o<=d+b))throw s},onObjectEnd:(m,d)=>{if(o<=m)throw s;i=void 0,n.pop()},onArrayBegin:(m,d)=>{if(o<=m)throw s;i=void 0,n.push(0)},onArrayEnd:(m,d)=>{if(o<=m)throw s;i=void 0,n.pop()},onLiteralValue:(m,d,b)=>{if(o<d||(p(m,d,b,R(m)),o<=d+b))throw s},onSeparator:(m,d,b)=>{if(o<=d)throw s;if(m===":"&&i&&i.type==="property")i.colonOffset=d,a=!1,i=void 0;else if(m===","){const O=n[n.length-1];typeof O=="number"?n[n.length-1]=O+1:(a=!0,n[n.length-1]=""),i=void 0}}})}catch(m){if(m!==s)throw m}return{path:n,previousNode:i,isAtPropertyKey:a,matches:m=>{let d=0;for(let b=0;d<m.length&&b<n.length;b++)if(m[d]===n[b]||m[d]==="*")d++;else if(m[d]!=="**")return!1;return d===m.length}}}e.getLocation=C;function S(t,o=[],n=A.DEFAULT){let s=null,i=[];const r=[];function a(m){Array.isArray(i)?i.push(m):s!==null&&(i[s]=m)}return y(t,{onObjectBegin:()=>{const m={};a(m),r.push(i),i=m,s=null},onObjectProperty:m=>{s=m},onObjectEnd:()=>{i=r.pop()},onArrayBegin:()=>{const m=[];a(m),r.push(i),i=m,s=null},onArrayEnd:()=>{i=r.pop()},onLiteralValue:a,onError:(m,d,b)=>{o.push({error:m,offset:d,length:b})}},n),i[0]}e.parse=S;function u(t,o=[],n=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(m){s.type==="property"&&(s.length=m-s.offset,s=s.parent)}function r(m){return s.children.push(m),m}y(t,{onObjectBegin:m=>{s=r({type:"object",offset:m,length:-1,parent:s,children:[]})},onObjectProperty:(m,d,b)=>{s=r({type:"property",offset:d,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:m,offset:d,length:b,parent:s})},onObjectEnd:(m,d)=>{s.length=m+d-s.offset,s=s.parent,i(m+d)},onArrayBegin:(m,d)=>{s=r({type:"array",offset:m,length:-1,parent:s,children:[]})},onArrayEnd:(m,d)=>{s.length=m+d-s.offset,s=s.parent,i(m+d)},onLiteralValue:(m,d,b)=>{r({type:R(m),offset:d,length:b,parent:s,value:m}),i(d+b)},onSeparator:(m,d,b)=>{s.type==="property"&&(m===":"?s.colonOffset=d:m===","&&i(d))},onError:(m,d,b)=>{o.push({error:m,offset:d,length:b})}},n);const p=s.children[0];return p&&delete p.parent,p}e.parseTree=u;function g(t,o){if(!t)return;let n=t;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],i=!0;break}if(!i)return}else{const i=s;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}e.findNodeAtLocation=g;function w(t){if(!t.parent||!t.parent.children)return[];const o=w(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;o.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&o.push(n)}return o}e.getNodePath=w;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const o=Object.create(null);for(const n of t.children){const s=n.children[1];s&&(o[n.children[0].value]=c(s))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=c;function l(t,o,n=!1){return o>=t.offset&&o<t.offset+t.length||n&&o===t.offset+t.length}e.contains=l;function h(t,o,n=!1){if(l(t,o,n)){const s=t.children;if(Array.isArray(s))for(let i=0;i<s.length&&s[i].offset<=o;i++){const r=h(s[i],o,n);if(r)return r}return t}}e.findNodeAtOffset=h;function y(t,o,n=A.DEFAULT){const s=k(t,!1);function i(ne){return ne?()=>ne(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(ne){return ne?ce=>ne(ce,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=i(o.onObjectBegin),p=r(o.onObjectProperty),m=i(o.onObjectEnd),d=i(o.onArrayBegin),b=i(o.onArrayEnd),O=r(o.onLiteralValue),F=r(o.onSeparator),M=i(o.onComment),q=r(o.onError),j=n&&n.disallowComments,B=n&&n.allowTrailingComma;function Q(){for(;;){const ne=s.scan();switch(s.getTokenError()){case 4:J(14);break;case 5:J(15);break;case 3:J(13);break;case 1:j||J(11);break;case 2:J(12);break;case 6:J(16);break}switch(ne){case 12:case 13:j?J(10):M();break;case 16:J(1);break;case 15:case 14:break;default:return ne}}}function J(ne,ce=[],re=[]){if(q(ne),ce.length+re.length>0){let U=s.getToken();for(;U!==17;){if(ce.indexOf(U)!==-1){Q();break}else if(re.indexOf(U)!==-1)break;U=Q()}}}function G(ne){const ce=s.getTokenValue();return ne?O(ce):p(ce),Q(),!0}function X(){switch(s.getToken()){case 11:{let ne=0;try{ne=JSON.parse(s.getTokenValue()),typeof ne!="number"&&(J(2),ne=0)}catch{J(2)}O(ne);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return Q(),!0}function V(){return s.getToken()!==10?(J(3,[],[2,5]),!1):(G(!1),s.getToken()===6?(F(":"),Q(),ee()||J(4,[],[2,5])):J(5,[],[2,5]),!0)}function x(){a(),Q();let ne=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ne||J(4,[],[]),F(","),Q(),s.getToken()===2&&B)break}else ne&&J(6,[],[]);V()||J(4,[],[2,5]),ne=!0}return m(),s.getToken()!==2?J(7,[2],[]):Q(),!0}function z(){d(),Q();let ne=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ne||J(4,[],[]),F(","),Q(),s.getToken()===4&&B)break}else ne&&J(6,[],[]);ee()||J(4,[],[4,5]),ne=!0}return b(),s.getToken()!==4?J(8,[4],[]):Q(),!0}function ee(){switch(s.getToken()){case 3:return z();case 1:return x();case 10:return G(!0);default:return X()}}return Q(),s.getToken()===17?n.allowEmptyContent?!0:(J(4,[],[]),!1):ee()?(s.getToken()!==17&&J(9,[],[]),!0):(J(4,[],[]),!1)}e.visit=y;function E(t,o){const n=k(t),s=[];let i,r=0,a;do switch(a=n.getPosition(),i=n.scan(),i){case 12:case 13:case 17:r!==a&&s.push(t.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(i!==17);return s.join("")}e.stripComments=E;function R(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=R}),define(oe[41],ae([0,1,34]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function N(v,I,C){let S,u,g,w,c;if(I){for(w=I.offset,c=w+I.length,g=w;g>0&&!P(v,g-1);)g--;let a=c;for(;a<v.length&&!P(v,a);)a++;u=v.substring(g,a),S=k(u,C)}else u=v,S=0,g=0,w=0,c=v.length;const l=D(C,v);let h=!1,y=0,E;C.insertSpaces?E=A(" ",C.tabSize||4):E="	";const R=(0,L.createScanner)(u,!1);let t=!1;function o(){return l+A(E,S+y)}function n(){let a=R.scan();for(h=!1;a===15||a===14;)h=h||a===14,a=R.scan();return t=a===16||R.getTokenError()!==0,a}const s=[];function i(a,p,m){!t&&p<c&&m>w&&v.substring(p,m)!==a&&s.push({offset:p,length:m-p,content:a})}let r=n();if(r!==17){const a=R.getTokenOffset()+g,p=A(E,S);i(p,g,a)}for(;r!==17;){let a=R.getTokenOffset()+R.getTokenLength()+g,p=n(),m="";for(;!h&&(p===12||p===13);){const b=R.getTokenOffset()+g;i(" ",a,b),a=R.getTokenOffset()+R.getTokenLength()+g,m=p===12?o():"",p=n()}if(p===2)r!==1&&(y--,m=o());else if(p===4)r!==3&&(y--,m=o());else{switch(r){case 3:case 1:y++,m=o();break;case 5:case 12:m=o();break;case 13:h?m=o():m=" ";break;case 6:m=" ";break;case 10:if(p===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?m=" ":p!==5&&p!==17&&(t=!0);break;case 16:t=!0;break}h&&(p===12||p===13)&&(m=o())}const d=R.getTokenOffset()+g;i(m,a,d),r=p}return s}e.format=N;function T(v,I){const C=JSON.stringify(v,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?C.replace(/\r\n|\r|\n/g,I.eol):C}e.toFormattedString=T;function A(v,I){let C="";for(let S=0;S<I;S++)C+=v;return C}function k(v,I){let C=0,S=0;const u=I.tabSize||4;for(;C<v.length;){const g=v.charAt(C);if(g===" ")S++;else if(g==="	")S+=u;else break;C++}return Math.floor(S/u)}function D(v,I){for(let C=0;C<I.length;C++){const S=I.charAt(C);if(S==="\r")return C+1<I.length&&I.charAt(C+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return v&&v.eol||`
`}e.getEOL=D;function P(v,I){return`\r
`.indexOf(v.charAt(I))!==-1}e.isEOL=P}),define(oe[83],ae([0,1,34,41]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(v,I,C){return A(v,I,void 0,C)}e.removeProperty=T;function A(v,I,C,S,u){const g=I.slice(),w=[],c=(0,L.parseTree)(v,w);let l,h;for(;g.length>0&&(h=g.pop(),l=(0,L.findNodeAtLocation)(c,g),l===void 0&&C!==void 0);)typeof h=="string"?C={[h]:C}:C=[C];if(l)if(l.type==="object"&&typeof h=="string"&&Array.isArray(l.children)){const y=(0,L.findNodeAtLocation)(l,[h]);if(y!==void 0)if(C===void 0){if(!y.parent)throw new Error("Malformed AST");const E=l.children.indexOf(y.parent);let R,t=y.parent.offset+y.parent.length;if(E>0){const o=l.children[E-1];R=o.offset+o.length}else R=l.offset+1,l.children.length>1&&(t=l.children[1].offset);return k(v,{offset:R,length:t-R,content:""},S)}else return k(v,{offset:y.offset,length:y.length,content:JSON.stringify(C)},S);else{if(C===void 0)return[];const E=`${JSON.stringify(h)}: ${JSON.stringify(C)}`,R=u?u(l.children.map(o=>o.children[0].value)):l.children.length;let t;if(R>0){const o=l.children[R-1];t={offset:o.offset+o.length,length:0,content:","+E}}else l.children.length===0?t={offset:l.offset+1,length:0,content:E}:t={offset:l.offset+1,length:0,content:E+","};return k(v,t,S)}}else if(l.type==="array"&&typeof h=="number"&&Array.isArray(l.children))if(C!==void 0){const y=`${JSON.stringify(C)}`;let E;if(l.children.length===0||h===0)E={offset:l.offset+1,length:0,content:l.children.length===0?y:y+","};else{const R=h===-1||h>l.children.length?l.children.length:h,t=l.children[R-1];E={offset:t.offset+t.length,length:0,content:","+y}}return k(v,E,S)}else{const y=h,E=l.children[y];let R;if(l.children.length===1)R={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===y){const t=l.children[y-1],o=t.offset+t.length,n=l.offset+l.length;R={offset:o,length:n-2-o,content:""}}else R={offset:E.offset,length:l.children[y+1].offset-E.offset,content:""};return k(v,R,S)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${l.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return k(v,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(C)},S)}}e.setProperty=A;function k(v,I,C){let S=D(v,I),u=I.offset,g=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;u>0&&!(0,N.isEOL)(S,u-1);)u--;for(;g<S.length&&!(0,N.isEOL)(S,g);)g++}const w=(0,N.format)(S,{offset:u,length:g-u},C);for(let l=w.length-1;l>=0;l--){const h=w[l];S=D(S,h),u=Math.min(u,h.offset),g=Math.max(g,h.offset+h.length),g+=h.content.length-h.length}const c=v.length-(S.length-g)-u;return[{offset:u,length:c,content:S.substring(u,g)}]}e.withFormatting=k;function D(v,I){return v.substring(0,I.offset)+I.content+v.substring(I.offset+I.length)}e.applyEdit=D;function P(v,I){const C=I.slice(0).sort((u,g)=>{const w=u.offset-g.offset;return w===0?u.length-g.length:w});let S=v.length;for(let u=C.length-1;u>=0;u--){const g=C[u];if(g.offset+g.length<=S)v=D(v,g);else throw new Error("Overlapping edit");S=g.offset}return v}e.applyEdits=P}),define(oe[84],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class L{constructor(T){this.executor=T,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=L}),define(oe[2],ae([0,1,82,59]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const T=!1;let A=null;function k(r){A=r}if(e.setDisposableTracker=k,T){const r="__is_disposable_tracked__";k(new class{trackDisposable(a){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(p)},3e3)}setParent(a,p){if(a&&a!==h.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==h.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function D(r){return A?.trackDisposable(r),r}function P(r){A?.markAsDisposed(r)}function v(r,a){A?.setParent(r,a)}function I(r,a){if(A)for(const p of r)A.setParent(p,a)}function C(r){return A?.markAsSingleton(r),r}e.markAsSingleton=C;function S(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=S;function u(r){if(N.Iterable.is(r)){const a=[];for(const p of r)if(p)try{p.dispose()}catch(m){a.push(m)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=u;function g(r){for(const a of r)S(a)&&a.dispose();return[]}e.disposeIfDisposable=g;function w(...r){const a=c(()=>u(r));return I(r,a),a}e.combinedDisposable=w;function c(r){const a=D({dispose:(0,L.once)(()=>{P(a),r()})});return a}e.toDisposable=c;class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{u(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return v(a,this),this._isDisposed?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=l;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new l,D(this),v(this._store,this)}dispose(){P(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=h;class y{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&v(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,P(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&v(a,null),a}}e.MutableDisposable=y;class E{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=E;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(a){let p=a;return this.unset=()=>p=void 0,this.isset=()=>p!==void 0,this.dispose=()=>{p&&(p(),p=void 0,P(this))},this}}e.SafeDisposable=R;class t{constructor(){this.references=new Map}acquire(a,...p){let m=this.references.get(a);m||(m={counter:0,object:this.createReferencedObject(a,...p)},this.references.set(a,m));const{object:d}=m,b=(0,L.once)(()=>{--m.counter===0&&(this.destroyReferencedObject(a,m.object),this.references.delete(a))});return m.counter++,{object:d,dispose:b}}}e.ReferenceCollection=t;class o{constructor(a){this.referenceCollection=a}async acquire(a,...p){const m=this.referenceCollection.acquire(a,...p);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(d){throw m.dispose(),d}}}e.AsyncReferenceCollection=o;class n{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=n;function s(r){const a=new l;try{r(a)}finally{a.dispose()}}e.disposeOnReturn=s;class i{constructor(){this._store=new Map,this._isDisposed=!1,D(this)}dispose(){P(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{u(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get(a){return this._store.get(a)}set(a,p,m=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),m||this._store.get(a)?.dispose(),this._store.set(a,p)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=i}),define(oe[85],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{static{this.Undefined=new L(void 0)}constructor(A){this.element=A,this.next=L.Undefined,this.prev=L.Undefined}}class N{constructor(){this._first=L.Undefined,this._last=L.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===L.Undefined}clear(){let A=this._first;for(;A!==L.Undefined;){const k=A.next;A.prev=L.Undefined,A.next=L.Undefined,A=k}this._first=L.Undefined,this._last=L.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,k){const D=new L(A);if(this._first===L.Undefined)this._first=D,this._last=D;else if(k){const v=this._last;this._last=D,D.prev=v,v.next=D}else{const v=this._first;this._first=D,D.next=v,v.prev=D}this._size+=1;let P=!1;return()=>{P||(P=!0,this._remove(D))}}shift(){if(this._first!==L.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==L.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==L.Undefined&&A.next!==L.Undefined){const k=A.prev;k.next=A.next,A.next.prev=k}else A.prev===L.Undefined&&A.next===L.Undefined?(this._first=L.Undefined,this._last=L.Undefined):A.next===L.Undefined?(this._last=this._last.prev,this._last.next=L.Undefined):A.prev===L.Undefined&&(this._first=this._first.next,this._first.prev=L.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==L.Undefined;)yield A.element,A=A.next}}e.LinkedList=N}),define(oe[35],ae([0,1]),function(te,e){"use strict";var L,N,T;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(w,c,l){let h=w.get(c);return h===void 0&&(h=l,w.set(c,h)),h}e.getOrSet=A;function k(w){const c=[];return w.forEach((l,h)=>{c.push(`${h} => ${l}`)}),`Map(${w.size}) {${c.join(", ")}}`}e.mapToString=k;function D(w){const c=[];return w.forEach(l=>{c.push(l)}),`Set(${w.size}) {${c.join(", ")}}`}e.setToString=D;class P{constructor(c,l){this.uri=c,this.value=l}}class v{static{this.defaultToKey=c=>c.toString()}constructor(c,l){this[L]="ResourceMap",c instanceof v?(this.map=new Map(c.map),this.toKey=l??v.defaultToKey):(this.map=new Map,this.toKey=c??v.defaultToKey)}set(c,l){return this.map.set(this.toKey(c),new P(c,l)),this}get(c){return this.map.get(this.toKey(c))?.value}has(c){return this.map.has(this.toKey(c))}get size(){return this.map.size}clear(){this.map.clear()}delete(c){return this.map.delete(this.toKey(c))}forEach(c,l){typeof l<"u"&&(c=c.bind(l));for(const[h,y]of this.map)c(y.value,y.uri,this)}*values(){for(const c of this.map.values())yield c.value}*keys(){for(const c of this.map.values())yield c.uri}*entries(){for(const c of this.map.values())yield[c.uri,c.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.map)yield[c.uri,c.value]}}e.ResourceMap=v;class I{constructor(c,l){this[N]="ResourceSet",!c||typeof c=="function"?this._map=new v(c):(this._map=new v(l),c.forEach(this.add,this))}get size(){return this._map.size}add(c){return this._map.set(c,c),this}clear(){this._map.clear()}delete(c){return this._map.delete(c)}forEach(c,l){this._map.forEach((h,y)=>c.call(l,y,y,this))}has(c){return this._map.has(c)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=I;var C;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(C||(e.Touch=C={}));class S{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(c){return this._map.has(c)}get(c,l=0){const h=this._map.get(c);if(h)return l!==0&&this.touch(h,l),h.value}set(c,l,h=0){let y=this._map.get(c);if(y)y.value=l,h!==0&&this.touch(y,h);else{switch(y={key:c,value:l,next:void 0,previous:void 0},h){case 0:this.addItemLast(y);break;case 1:this.addItemFirst(y);break;case 2:this.addItemLast(y);break;default:this.addItemLast(y);break}this._map.set(c,y),this._size++}return this}delete(c){return!!this.remove(c)}remove(c){const l=this._map.get(c);if(l)return this._map.delete(c),this.removeItem(l),this._size--,l.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const c=this._head;return this._map.delete(c.key),this.removeItem(c),this._size--,c.value}forEach(c,l){const h=this._state;let y=this._head;for(;y;){if(l?c.bind(l)(y.value,y.key,this):c(y.value,y.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");y=y.next}}keys(){const c=this,l=this._state;let h=this._head;const y={[Symbol.iterator](){return y},next(){if(c._state!==l)throw new Error("LinkedMap got modified during iteration.");if(h){const E={value:h.key,done:!1};return h=h.next,E}else return{value:void 0,done:!0}}};return y}values(){const c=this,l=this._state;let h=this._head;const y={[Symbol.iterator](){return y},next(){if(c._state!==l)throw new Error("LinkedMap got modified during iteration.");if(h){const E={value:h.value,done:!1};return h=h.next,E}else return{value:void 0,done:!0}}};return y}entries(){const c=this,l=this._state;let h=this._head;const y={[Symbol.iterator](){return y},next(){if(c._state!==l)throw new Error("LinkedMap got modified during iteration.");if(h){const E={value:[h.key,h.value],done:!1};return h=h.next,E}else return{value:void 0,done:!0}}};return y}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(c){if(c>=this.size)return;if(c===0){this.clear();return}let l=this._head,h=this.size;for(;l&&h>c;)this._map.delete(l.key),l=l.next,h--;this._head=l,this._size=h,l&&(l.previous=void 0),this._state++}addItemFirst(c){if(!this._head&&!this._tail)this._tail=c;else if(this._head)c.next=this._head,this._head.previous=c;else throw new Error("Invalid list");this._head=c,this._state++}addItemLast(c){if(!this._head&&!this._tail)this._head=c;else if(this._tail)c.previous=this._tail,this._tail.next=c;else throw new Error("Invalid list");this._tail=c,this._state++}removeItem(c){if(c===this._head&&c===this._tail)this._head=void 0,this._tail=void 0;else if(c===this._head){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this._head=c.next}else if(c===this._tail){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this._tail=c.previous}else{const l=c.next,h=c.previous;if(!l||!h)throw new Error("Invalid list");l.previous=h,h.next=l}c.next=void 0,c.previous=void 0,this._state++}touch(c,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(c===this._head)return;const h=c.next,y=c.previous;c===this._tail?(y.next=void 0,this._tail=y):(h.previous=y,y.next=h),c.previous=void 0,c.next=this._head,this._head.previous=c,this._head=c,this._state++}else if(l===2){if(c===this._tail)return;const h=c.next,y=c.previous;c===this._head?(h.previous=void 0,this._head=h):(h.previous=y,y.next=h),c.next=void 0,c.previous=this._tail,this._tail.next=c,this._tail=c,this._state++}}}toJSON(){const c=[];return this.forEach((l,h)=>{c.push([h,l])}),c}fromJSON(c){this.clear();for(const[l,h]of c)this.set(l,h)}}e.LinkedMap=S;class u extends S{constructor(c,l=1){super(),this._limit=c,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(c){this._limit=c,this.checkTrim()}get ratio(){return this._ratio}set ratio(c){this._ratio=Math.min(Math.max(0,c),1),this.checkTrim()}get(c,l=2){return super.get(c,l)}peek(c){return super.get(c,0)}set(c,l){return super.set(c,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u;class g{constructor(){this.map=new Map}add(c){return this.map.set(c,(this.map.get(c)||0)+1),this}delete(c){let l=this.map.get(c)||0;return l===0?!1:(l--,l===0?this.map.delete(c):this.map.set(c,l),!0)}has(c){return this.map.has(c)}}e.CounterSet=g}),define(oe[86],ae([0,1,35]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const N=new L.LRUCache(1e4);function T(v){return P(v,"NFC",N)}e.normalizeNFC=T;const A=new L.LRUCache(1e4);function k(v){return P(v,"NFD",A)}e.normalizeNFD=k;const D=/[^\u0000-\u0080]/;function P(v,I,C){if(!v)return v;const S=C.get(v);if(S)return S;let u;return D.test(v)?u=v.normalize(I):u=v,C.set(v,u),u}e.removeAccents=function(){const v=/[\u0300-\u036f]/g;return function(I){return k(I).replace(v,"")}}()}),function(){function te(T){const A=[];typeof T=="number"&&A.push("code/timeOrigin",T);function k(P){A.push(P,Date.now())}function D(){const P=[];for(let v=0;v<A.length;v+=2)P.push({name:A[v],startTime:A[v+1]});return P}return{mark:k,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const k of performance.getEntriesByType("mark"))A.push({name:k.name,startTime:Math.round(T+k.startTime)});return A}};if(typeof process=="object"){const T=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function L(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=L(N))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var N in L)(typeof exports=="object"?exports:te)[N]=L[N]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function L(N){if(e[N])return e[N].exports;var T=e[N]={i:N,l:!1,exports:{}};return te[N].call(T.exports,T,T.exports,L),T.l=!0,T.exports}return L.m=te,L.c=e,L.d=function(N,T,A){L.o(N,T)||Object.defineProperty(N,T,{enumerable:!0,get:A})},L.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},L.t=function(N,T){if(1&T&&(N=L(N)),8&T||4&T&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&T&&typeof N!="string")for(var k in N)L.d(A,k,function(D){return N[D]}.bind(null,k));return A},L.n=function(N){var T=N&&N.__esModule?function(){return N.default}:function(){return N};return L.d(T,"a",T),T},L.o=function(N,T){return Object.prototype.hasOwnProperty.call(N,T)},L.p="",L(L.s=0)}([function(te,e,L){(function(N){var T;e=te.exports=re,T=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],P=e.src=[],v=0,I=v++;P[I]="0|[1-9]\\d*";var C=v++;P[C]="[0-9]+";var S=v++;P[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=v++;P[u]="("+P[I]+")\\.("+P[I]+")\\.("+P[I]+")";var g=v++;P[g]="("+P[C]+")\\.("+P[C]+")\\.("+P[C]+")";var w=v++;P[w]="(?:"+P[I]+"|"+P[S]+")";var c=v++;P[c]="(?:"+P[C]+"|"+P[S]+")";var l=v++;P[l]="(?:-("+P[w]+"(?:\\."+P[w]+")*))";var h=v++;P[h]="(?:-?("+P[c]+"(?:\\."+P[c]+")*))";var y=v++;P[y]="[0-9A-Za-z-]+";var E=v++;P[E]="(?:\\+("+P[y]+"(?:\\."+P[y]+")*))";var R=v++,t="v?"+P[u]+P[l]+"?"+P[E]+"?";P[R]="^"+t+"$";var o="[v=\\s]*"+P[g]+P[h]+"?"+P[E]+"?",n=v++;P[n]="^"+o+"$";var s=v++;P[s]="((?:<|>)?=?)";var i=v++;P[i]=P[C]+"|x|X|\\*";var r=v++;P[r]=P[I]+"|x|X|\\*";var a=v++;P[a]="[v=\\s]*("+P[r]+")(?:\\.("+P[r]+")(?:\\.("+P[r]+")(?:"+P[l]+")?"+P[E]+"?)?)?";var p=v++;P[p]="[v=\\s]*("+P[i]+")(?:\\.("+P[i]+")(?:\\.("+P[i]+")(?:"+P[h]+")?"+P[E]+"?)?)?";var m=v++;P[m]="^"+P[s]+"\\s*"+P[a]+"$";var d=v++;P[d]="^"+P[s]+"\\s*"+P[p]+"$";var b=v++;P[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=v++;P[O]="(?:~>?)";var F=v++;P[F]="(\\s*)"+P[O]+"\\s+",D[F]=new RegExp(P[F],"g");var M=v++;P[M]="^"+P[O]+P[a]+"$";var q=v++;P[q]="^"+P[O]+P[p]+"$";var j=v++;P[j]="(?:\\^)";var B=v++;P[B]="(\\s*)"+P[j]+"\\s+",D[B]=new RegExp(P[B],"g");var Q=v++;P[Q]="^"+P[j]+P[a]+"$";var J=v++;P[J]="^"+P[j]+P[p]+"$";var G=v++;P[G]="^"+P[s]+"\\s*("+o+")$|^$";var X=v++;P[X]="^"+P[s]+"\\s*("+t+")$|^$";var V=v++;P[V]="(\\s*)"+P[s]+"\\s*("+o+"|"+P[a]+")",D[V]=new RegExp(P[V],"g");var x=v++;P[x]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var z=v++;P[z]="^\\s*("+P[p]+")\\s+-\\s+("+P[p]+")\\s*$";var ee=v++;P[ee]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)T(ne,P[ne]),D[ne]||(D[ne]=new RegExp(P[ne]));function ce(le,fe){if(le instanceof re)return le;if(typeof le!="string"||le.length>A||!(fe?D[n]:D[R]).test(le))return null;try{return new re(le,fe)}catch{return null}}function re(le,fe){if(le instanceof re){if(le.loose===fe)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof re))return new re(le,fe);T("SemVer",le,fe),this.loose=fe;var ge=le.trim().match(fe?D[n]:D[R]);if(!ge)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Ie=+Pe;if(Ie>=0&&Ie<k)return Ie}return Pe}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=ce,e.valid=function(le,fe){var ge=ce(le,fe);return ge?ge.version:null},e.clean=function(le,fe){var ge=ce(le.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(le){return T("SemVer.compare",this.version,this.loose,le),le instanceof re||(le=new re(le,this.loose)),this.compareMain(le)||this.comparePre(le)},re.prototype.compareMain=function(le){return le instanceof re||(le=new re(le,this.loose)),f(this.major,le.major)||f(this.minor,le.minor)||f(this.patch,le.patch)},re.prototype.comparePre=function(le){if(le instanceof re||(le=new re(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Pe=le.prerelease[fe];if(T("prerelease compare",fe,ge,Pe),ge===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(ge===void 0)return-1;if(ge!==Pe)return f(ge,Pe)}while(++fe)},re.prototype.inc=function(le,fe){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,fe,ge,Pe){typeof ge=="string"&&(Pe=ge,ge=void 0);try{return new re(le,ge).inc(fe,Pe).version}catch{return null}},e.diff=function(le,fe){if(W(le,fe))return null;var ge=ce(le),Pe=ce(fe);if(ge.prerelease.length||Pe.prerelease.length){for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==Pe[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==Pe[Ie])return Ie},e.compareIdentifiers=f;var U=/^[0-9]+$/;function f(le,fe){var ge=U.test(le),Pe=U.test(fe);return ge&&Pe&&(le=+le,fe=+fe),ge&&!Pe?-1:Pe&&!ge?1:le<fe?-1:le>fe?1:0}function _(le,fe,ge){return new re(le,ge).compare(new re(fe,ge))}function $(le,fe,ge){return _(le,fe,ge)>0}function H(le,fe,ge){return _(le,fe,ge)<0}function W(le,fe,ge){return _(le,fe,ge)===0}function K(le,fe,ge){return _(le,fe,ge)!==0}function Z(le,fe,ge){return _(le,fe,ge)>=0}function se(le,fe,ge){return _(le,fe,ge)<=0}function ue(le,fe,ge,Pe){var Ie;switch(fe){case"===":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Ie=le===ge;break;case"!==":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Ie=le!==ge;break;case"":case"=":case"==":Ie=W(le,ge,Pe);break;case"!=":Ie=K(le,ge,Pe);break;case">":Ie=$(le,ge,Pe);break;case">=":Ie=Z(le,ge,Pe);break;case"<":Ie=H(le,ge,Pe);break;case"<=":Ie=se(le,ge,Pe);break;default:throw new TypeError("Invalid operator: "+fe)}return Ie}function he(le,fe){if(le instanceof he){if(le.loose===fe)return le;le=le.value}if(!(this instanceof he))return new he(le,fe);T("comparator",le,fe),this.loose=fe,this.parse(le),this.semver===Se?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(le,fe){return f(fe,le)},e.major=function(le,fe){return new re(le,fe).major},e.minor=function(le,fe){return new re(le,fe).minor},e.patch=function(le,fe){return new re(le,fe).patch},e.compare=_,e.compareLoose=function(le,fe){return _(le,fe,!0)},e.rcompare=function(le,fe,ge){return _(fe,le,ge)},e.sort=function(le,fe){return le.sort(function(ge,Pe){return e.compare(ge,Pe,fe)})},e.rsort=function(le,fe){return le.sort(function(ge,Pe){return e.rcompare(ge,Pe,fe)})},e.gt=$,e.lt=H,e.eq=W,e.neq=K,e.gte=Z,e.lte=se,e.cmp=ue,e.Comparator=he;var Se={};function Ee(le,fe){if(le instanceof Ee)return le.loose===fe?le:new Ee(le.raw,fe);if(le instanceof he)return new Ee(le.value,fe);if(!(this instanceof Ee))return new Ee(le,fe);if(this.loose=fe,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function be(le){return!le||le.toLowerCase()==="x"||le==="*"}function De(le,fe,ge,Pe,Ie,Fe,ke,We,Ae,Ue,Me,ie,de){return((fe=be(ge)?"":be(Pe)?">="+ge+".0.0":be(Ie)?">="+ge+"."+Pe+".0":">="+fe)+" "+(We=be(Ae)?"":be(Ue)?"<"+(+Ae+1)+".0.0":be(Me)?"<"+Ae+"."+(+Ue+1)+".0":ie?"<="+Ae+"."+Ue+"."+Me+"-"+ie:"<="+We)).trim()}function _e(le,fe){for(var ge=0;ge<le.length;ge++)if(!le[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<le.length;ge++)if(T(le[ge].semver),le[ge].semver!==Se&&le[ge].semver.prerelease.length>0){var Pe=le[ge].semver;if(Pe.major===fe.major&&Pe.minor===fe.minor&&Pe.patch===fe.patch)return!0}return!1}return!0}function $e(le,fe,ge){try{fe=new Ee(fe,ge)}catch{return!1}return fe.test(le)}function Be(le,fe,ge,Pe){var Ie,Fe,ke,We,Ae;switch(le=new re(le,Pe),fe=new Ee(fe,Pe),ge){case">":Ie=$,Fe=se,ke=H,We=">",Ae=">=";break;case"<":Ie=H,Fe=Z,ke=$,We="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(le,fe,Pe))return!1;for(var Ue=0;Ue<fe.set.length;++Ue){var Me=fe.set[Ue],ie=null,de=null;if(Me.forEach(function(me){me.semver===Se&&(me=new he(">=0.0.0")),ie=ie||me,de=de||me,Ie(me.semver,ie.semver,Pe)?ie=me:ke(me.semver,de.semver,Pe)&&(de=me)}),ie.operator===We||ie.operator===Ae||(!de.operator||de.operator===We)&&Fe(le,de.semver)||de.operator===Ae&&ke(le,de.semver))return!1}return!0}he.prototype.parse=function(le){var fe=this.loose?D[G]:D[X],ge=le.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+le);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new re(ge[2],this.loose):this.semver=Se},he.prototype.toString=function(){return this.value},he.prototype.test=function(le){return T("Comparator.test",le,this.loose),this.semver===Se||(typeof le=="string"&&(le=new re(le,this.loose)),ue(le,this.operator,this.semver,this.loose))},he.prototype.intersects=function(le,fe){if(!(le instanceof he))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Ee(le.value,fe),$e(this.value,ge,fe);if(le.operator==="")return ge=new Ee(this.value,fe),$e(le.semver,ge,fe);var Pe=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Fe=this.semver.version===le.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),We=ue(this.semver,"<",le.semver,fe)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Ae=ue(this.semver,">",le.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Pe||Ie||Fe&&ke||We||Ae},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(le){var fe=this.loose;le=le.trim(),T("range",le,fe);var ge=fe?D[z]:D[x];le=le.replace(ge,De),T("hyphen replace",le),le=le.replace(D[V],"$1$2$3"),T("comparator trim",le,D[V]),le=(le=(le=le.replace(D[F],"$1~")).replace(D[B],"$1^")).split(/\s+/).join(" ");var Pe=fe?D[G]:D[X],Ie=le.split(" ").map(function(Fe){return function(ke,We){return T("comp",ke),ke=function(Ae,Ue){return Ae.trim().split(/\s+/).map(function(Me){return function(ie,de){T("caret",ie,de);var me=de?D[J]:D[Q];return ie.replace(me,function(ye,pe,Ce,Re,Le){var Te;return T("caret",ie,ye,pe,Ce,Re,Le),be(pe)?Te="":be(Ce)?Te=">="+pe+".0.0 <"+(+pe+1)+".0.0":be(Re)?Te=pe==="0"?">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0":">="+pe+"."+Ce+".0 <"+(+pe+1)+".0.0":Le?(T("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Te=pe==="0"?Ce==="0"?">="+pe+"."+Ce+"."+Re+Le+" <"+pe+"."+Ce+"."+(+Re+1):">="+pe+"."+Ce+"."+Re+Le+" <"+pe+"."+(+Ce+1)+".0":">="+pe+"."+Ce+"."+Re+Le+" <"+(+pe+1)+".0.0"):(T("no pr"),Te=pe==="0"?Ce==="0"?">="+pe+"."+Ce+"."+Re+" <"+pe+"."+Ce+"."+(+Re+1):">="+pe+"."+Ce+"."+Re+" <"+pe+"."+(+Ce+1)+".0":">="+pe+"."+Ce+"."+Re+" <"+(+pe+1)+".0.0"),T("caret return",Te),Te})}(Me,Ue)}).join(" ")}(ke,We),T("caret",ke),ke=function(Ae,Ue){return Ae.trim().split(/\s+/).map(function(Me){return function(ie,de){var me=de?D[q]:D[M];return ie.replace(me,function(ye,pe,Ce,Re,Le){var Te;return T("tilde",ie,ye,pe,Ce,Re,Le),be(pe)?Te="":be(Ce)?Te=">="+pe+".0.0 <"+(+pe+1)+".0.0":be(Re)?Te=">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0":Le?(T("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Te=">="+pe+"."+Ce+"."+Re+Le+" <"+pe+"."+(+Ce+1)+".0"):Te=">="+pe+"."+Ce+"."+Re+" <"+pe+"."+(+Ce+1)+".0",T("tilde return",Te),Te})}(Me,Ue)}).join(" ")}(ke,We),T("tildes",ke),ke=function(Ae,Ue){return T("replaceXRanges",Ae,Ue),Ae.split(/\s+/).map(function(Me){return function(ie,de){ie=ie.trim();var me=de?D[d]:D[m];return ie.replace(me,function(ye,pe,Ce,Re,Le,Te){T("xRange",ie,ye,pe,Ce,Re,Le,Te);var xe=be(Ce),Ne=xe||be(Re),je=Ne||be(Le);return pe==="="&&je&&(pe=""),xe?ye=pe===">"||pe==="<"?"<0.0.0":"*":pe&&je?(Ne&&(Re=0),je&&(Le=0),pe===">"?(pe=">=",Ne?(Ce=+Ce+1,Re=0,Le=0):je&&(Re=+Re+1,Le=0)):pe==="<="&&(pe="<",Ne?Ce=+Ce+1:Re=+Re+1),ye=pe+Ce+"."+Re+"."+Le):Ne?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":je&&(ye=">="+Ce+"."+Re+".0 <"+Ce+"."+(+Re+1)+".0"),T("xRange return",ye),ye})}(Me,Ue)}).join(" ")}(ke,We),T("xrange",ke),ke=function(Ae,Ue){return T("replaceStars",Ae,Ue),Ae.trim().replace(D[ee],"")}(ke,We),T("stars",ke),ke}(Fe,fe)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Fe){return!!Fe.match(Pe)})),Ie=Ie.map(function(Fe){return new he(Fe,fe)})},Ee.prototype.intersects=function(le,fe){if(!(le instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Pe){return le.set.some(function(Ie){return Ie.every(function(Fe){return Pe.intersects(Fe,fe)})})})})},e.toComparators=function(le,fe){return new Ee(le,fe).set.map(function(ge){return ge.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new re(le,this.loose));for(var fe=0;fe<this.set.length;fe++)if(_e(this.set[fe],le))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(le,fe,ge){var Pe=null,Ie=null;try{var Fe=new Ee(fe,ge)}catch{return null}return le.forEach(function(ke){Fe.test(ke)&&(Pe&&Ie.compare(ke)!==-1||(Ie=new re(Pe=ke,ge)))}),Pe},e.minSatisfying=function(le,fe,ge){var Pe=null,Ie=null;try{var Fe=new Ee(fe,ge)}catch{return null}return le.forEach(function(ke){Fe.test(ke)&&(Pe&&Ie.compare(ke)!==1||(Ie=new re(Pe=ke,ge)))}),Pe},e.validRange=function(le,fe){try{return new Ee(le,fe).range||"*"}catch{return null}},e.ltr=function(le,fe,ge){return Be(le,fe,"<",ge)},e.gtr=function(le,fe,ge){return Be(le,fe,">",ge)},e.outside=Be,e.prerelease=function(le,fe){var ge=ce(le,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(le,fe,ge){return le=new Ee(le,ge),fe=new Ee(fe,ge),le.intersects(fe)},e.coerce=function(le){if(le instanceof re)return le;if(typeof le!="string")return null;var fe=le.match(D[b]);return fe==null?null:ce((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,L(1))},function(te,e){var L,N,T=te.exports={};function A(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function D(c){if(L===setTimeout)return setTimeout(c,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout(c,0);try{return L(c,0)}catch{try{return L.call(null,c,0)}catch{return L.call(this,c,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{N=typeof clearTimeout=="function"?clearTimeout:k}catch{N=k}})();var P,v=[],I=!1,C=-1;function S(){I&&P&&(I=!1,P.length?v=P.concat(v):C=-1,v.length&&u())}function u(){if(!I){var c=D(S);I=!0;for(var l=v.length;l;){for(P=v,v=[];++C<l;)P&&P[C].run();C=-1,l=v.length}P=null,I=!1,function(h){if(N===clearTimeout)return clearTimeout(h);if((N===k||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(h);try{N(h)}catch{try{return N.call(null,h)}catch{return N.call(this,h)}}}(c)}}function g(c,l){this.fun=c,this.array=l}function w(){}T.nextTick=function(c){var l=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)l[h-1]=arguments[h];v.push(new g(c,l)),v.length!==1||I||D(u)},g.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=w,T.addListener=w,T.once=w,T.off=w,T.removeListener=w,T.removeAllListeners=w,T.emit=w,T.prependListener=w,T.prependOnceListener=w,T.listeners=function(c){return[]},T.binding=function(c){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(c){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(oe[124],ae([0,1]),function(te,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class N{constructor(D,P,v){this.level=D,this.key=P,this.value=v,this.forward=[]}}const T=void 0;class A{constructor(D,P=2**16){this.comparator=D,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(P)|0),this._header=new N(this._maxLevel,T,T)}get size(){return this._size}clear(){this._header=new N(this._maxLevel,T,T)}has(D){return!!A._search(this,D,this.comparator)}get(D){return A._search(this,D,this.comparator)?.value}set(D,P){return A._insert(this,D,P,this.comparator)&&(this._size+=1),this}delete(D){const P=A._delete(this,D,this.comparator);return P&&(this._size-=1),P}forEach(D,P){let v=this._header.forward[0];for(;v;)D.call(P,v.value,v.key,this),v=v.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let D=this._header.forward[0];for(;D;)yield[D.key,D.value],D=D.forward[0]}*keys(){let D=this._header.forward[0];for(;D;)yield D.key,D=D.forward[0]}*values(){let D=this._header.forward[0];for(;D;)yield D.value,D=D.forward[0]}toString(){let D="[SkipList]:",P=this._header.forward[0];for(;P;)D+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return D}static _search(D,P,v){let I=D._header;for(let C=D._level-1;C>=0;C--)for(;I.forward[C]&&v(I.forward[C].key,P)<0;)I=I.forward[C];if(I=I.forward[0],I&&v(I.key,P)===0)return I}static _insert(D,P,v,I){const C=[];let S=D._header;for(let u=D._level-1;u>=0;u--){for(;S.forward[u]&&I(S.forward[u].key,P)<0;)S=S.forward[u];C[u]=S}if(S=S.forward[0],S&&I(S.key,P)===0)return S.value=v,!1;{const u=A._randomLevel(D);if(u>D._level){for(let g=D._level;g<u;g++)C[g]=D._header;D._level=u}S=new N(u,P,v);for(let g=0;g<u;g++)S.forward[g]=C[g].forward[g],C[g].forward[g]=S;return!0}}static _randomLevel(D,P=.5){let v=1;for(;Math.random()<P&&v<D._maxLevel;)v+=1;return v}static _delete(D,P,v){const I=[];let C=D._header;for(let S=D._level-1;S>=0;S--){for(;C.forward[S]&&v(C.forward[S].key,P)<0;)C=C.forward[S];I[S]=C}if(C=C.forward[0],!C||v(C.key,P)!==0)return!1;for(let S=0;S<D._level&&I[S].forward[S]===C;S++)I[S].forward[S]=C.forward[S];for(;D._level>0&&D._header.forward[D._level-1]===T;)D._level-=1;return!0}}e.SkipList=A}),define(oe[87],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(A){return new N(A)}constructor(A){this._now=L&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=N}),define(oe[3],ae([0,1,7,82,2,85,87]),function(te,e,L,N,T,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const D=!1,P=!1;var v;(function(p){p.None=()=>T.Disposable.None;function m(W){if(P){const{onDidAddListener:K}=W,Z=g.create();let se=0;W.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Z.print()),K?.()}}}function d(W,K){return J(W,()=>{},0,void 0,!0,void 0,K)}p.defer=d;function b(W){return(K,Z=null,se)=>{let ue=!1,he;return he=W(Se=>{if(!ue)return he?he.dispose():ue=!0,K.call(Z,Se)},null,se),ue&&he.dispose(),he}}p.once=b;function O(W,K,Z){return Q((se,ue=null,he)=>W(Se=>se.call(ue,K(Se)),null,he),Z)}p.map=O;function F(W,K,Z){return Q((se,ue=null,he)=>W(Se=>{K(Se),se.call(ue,Se)},null,he),Z)}p.forEach=F;function M(W,K,Z){return Q((se,ue=null,he)=>W(Se=>K(Se)&&se.call(ue,Se),null,he),Z)}p.filter=M;function q(W){return W}p.signal=q;function j(...W){return(K,Z=null,se)=>(0,T.combinedDisposable)(...W.map(ue=>ue(he=>K.call(Z,he),null,se)))}p.any=j;function B(W,K,Z,se){let ue=Z;return O(W,he=>(ue=K(ue,he),ue),se)}p.reduce=B;function Q(W,K){let Z;const se={onWillAddFirstListener(){Z=W(ue.fire,ue)},onDidRemoveLastListener(){Z?.dispose()}};K||m(se);const ue=new y(se);return K?.add(ue),ue.event}function J(W,K,Z=100,se=!1,ue=!1,he,Se){let Ee,be,De,_e=0,$e;const Be={leakWarningThreshold:he,onWillAddFirstListener(){Ee=W(fe=>{_e++,be=K(be,fe),se&&!De&&(le.fire(be),be=void 0),$e=()=>{const ge=be;be=void 0,De=void 0,(!se||_e>1)&&le.fire(ge),_e=0},typeof Z=="number"?(clearTimeout(De),De=setTimeout($e,Z)):De===void 0&&(De=0,queueMicrotask($e))})},onWillRemoveListener(){ue&&_e>0&&$e?.()},onDidRemoveLastListener(){$e=void 0,Ee.dispose()}};Se||m(Be);const le=new y(Be);return Se?.add(le),le.event}p.debounce=J;function G(W,K=0,Z){return p.debounce(W,(se,ue)=>se?(se.push(ue),se):[ue],K,void 0,!0,void 0,Z)}p.accumulate=G;function X(W,K=(se,ue)=>se===ue,Z){let se=!0,ue;return M(W,he=>{const Se=se||!K(he,ue);return se=!1,ue=he,Se},Z)}p.latch=X;function V(W,K,Z){return[p.filter(W,K,Z),p.filter(W,se=>!K(se),Z)]}p.split=V;function x(W,K=!1,Z=[]){let se=Z.slice(),ue=W(Ee=>{se?se.push(Ee):Se.fire(Ee)});const he=()=>{se?.forEach(Ee=>Se.fire(Ee)),se=null},Se=new y({onWillAddFirstListener(){ue||(ue=W(Ee=>Se.fire(Ee)))},onDidAddFirstListener(){se&&(K?setTimeout(he):he())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return Se.event}p.buffer=x;class z{constructor(K){this.event=K,this.disposables=new T.DisposableStore}map(K){return new z(O(this.event,K,this.disposables))}forEach(K){return new z(F(this.event,K,this.disposables))}filter(K){return new z(M(this.event,K,this.disposables))}reduce(K,Z){return new z(B(this.event,K,Z,this.disposables))}latch(){return new z(X(this.event,void 0,this.disposables))}debounce(K,Z=100,se=!1,ue=!1,he){return new z(J(this.event,K,Z,se,ue,he,this.disposables))}on(K,Z,se){return this.event(K,Z,se)}once(K,Z,se){return b(this.event)(K,Z,se)}dispose(){this.disposables.dispose()}}function ee(W){return new z(W)}p.chain=ee;function ne(W,K,Z=se=>se){const se=(...Ee)=>Se.fire(Z(...Ee)),ue=()=>W.on(K,se),he=()=>W.removeListener(K,se),Se=new y({onWillAddFirstListener:ue,onDidRemoveLastListener:he});return Se.event}p.fromNodeEventEmitter=ne;function ce(W,K,Z=se=>se){const se=(...Ee)=>Se.fire(Z(...Ee)),ue=()=>W.addEventListener(K,se),he=()=>W.removeEventListener(K,se),Se=new y({onWillAddFirstListener:ue,onDidRemoveLastListener:he});return Se.event}p.fromDOMEventEmitter=ce;function re(W){return new Promise(K=>b(W)(K))}p.toPromise=re;function U(W,K){return K(void 0),W(Z=>K(Z))}p.runAndSubscribe=U;function f(W,K){let Z=null;function se(he){Z?.dispose(),Z=new T.DisposableStore,K(he,Z)}se(void 0);const ue=W(he=>se(he));return(0,T.toDisposable)(()=>{ue.dispose(),Z?.dispose()})}p.runAndSubscribeWithStore=f;class _{constructor(K,Z){this._observable=K,this._counter=0,this._hasChanged=!1;const se={onWillAddFirstListener:()=>{K.addObserver(this)},onDidRemoveLastListener:()=>{K.removeObserver(this)}};Z||m(se),this.emitter=new y(se),Z&&Z.add(this.emitter)}beginUpdate(K){this._counter++}handlePossibleChange(K){}handleChange(K,Z){this._hasChanged=!0}endUpdate(K){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function $(W,K){return new _(W,K).emitter.event}p.fromObservable=$;function H(W){return K=>{let Z=0,se=!1;const ue={beginUpdate(){Z++},endUpdate(){Z--,Z===0&&(W.reportChanges(),se&&(se=!1,K()))},handlePossibleChange(){},handleChange(){se=!0}};return W.addObserver(ue),W.reportChanges(),{dispose(){W.removeObserver(ue)}}}}p.fromObservableLight=H})(v||(e.Event=v={}));class I{static{this.all=new Set}static{this._idPool=0}constructor(m){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${m}_${I._idPool++}`,I.all.add(this)}start(m){this._stopWatch=new k.StopWatch,this.listenerCount=m}stop(){if(this._stopWatch){const m=this._stopWatch.elapsed();this.durations.push(m),this.elapsedOverall+=m,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=I;let C=-1;function S(p){const m=C;return C=p,{dispose(){C=m}}}e.setGlobalLeakWarningThreshold=S;class u{constructor(m,d=Math.random().toString(18).slice(2,5)){this.threshold=m,this.name=d,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(m,d){const b=this.threshold;if(b<=0||d<b)return;this._stacks||(this._stacks=new Map);const O=this._stacks.get(m.value)||0;if(this._stacks.set(m.value,O+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=b*.5;let F,M=0;for(const[q,j]of this._stacks)(!F||M<j)&&(F=q,M=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${M}):`),console.warn(F)}return()=>{const F=this._stacks.get(m.value)||0;this._stacks.set(m.value,F-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(m){this.value=m}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class c{constructor(m){this.value=m,this.id=w++}}const l=2,h=(p,m)=>{if(p instanceof c)m(p);else for(let d=0;d<p.length;d++){const b=p[d];b&&m(b)}};class y{constructor(m){this._size=0,this._options=m,this._leakageMon=C>0||this._options?.leakWarningThreshold?new u(this._options?.leakWarningThreshold??C):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(D){const m=this._listeners;queueMicrotask(()=>{h(m,d=>d.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(m,d,b)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),T.Disposable.None;if(this._disposed)return T.Disposable.None;d&&(m=m.bind(d));const O=new c(m);let F,M;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(O.stack=g.create(),F=this._leakageMon.check(O.stack,this._size+1)),D&&(O.stack=M??g.create()),this._listeners?this._listeners instanceof c?(this._deliveryQueue??=new R,this._listeners=[this._listeners,O]):this._listeners.push(O):(this._options?.onWillAddFirstListener?.(this),this._listeners=O,this._options?.onDidAddFirstListener?.(this)),this._size++;const q=(0,T.toDisposable)(()=>{F?.(),this._removeListener(O)});return b instanceof T.DisposableStore?b.add(q):Array.isArray(b)&&b.push(q),q},this._event}_removeListener(m){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const d=this._listeners,b=d.indexOf(m);if(b===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,d[b]=void 0;const O=this._deliveryQueue.current===this;if(this._size*l<=d.length){let F=0;for(let M=0;M<d.length;M++)d[M]?d[F++]=d[M]:O&&(this._deliveryQueue.end--,F<this._deliveryQueue.i&&this._deliveryQueue.i--);d.length=F}}_deliver(m,d){if(!m)return;const b=this._options?.onListenerError||L.onUnexpectedError;if(!b){m.value(d);return}try{m.value(d)}catch(O){b(O)}}_deliverQueue(m){const d=m.current._listeners;for(;m.i<m.end;)this._deliver(d[m.i++],m.value);m.reset()}fire(m){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof c)this._deliver(this._listeners,m);else{const d=this._deliveryQueue;d.enqueue(this,m,this._listeners.length),this._deliverQueue(d)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=y;const E=()=>new R;e.createEventDeliveryQueue=E;class R{constructor(){this.i=-1,this.end=0}enqueue(m,d,b){this.i=0,this.end=b,this.current=m,this.value=d}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends y{async fireAsync(m,d,b){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList),h(this._listeners,O=>this._asyncDeliveryQueue.push([O.value,m]));this._asyncDeliveryQueue.size>0&&!d.isCancellationRequested;){const[O,F]=this._asyncDeliveryQueue.shift(),M=[],q={...F,token:d,waitUntil:j=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");b&&(j=b(j,O)),M.push(j)}};try{O(q)}catch(j){(0,L.onUnexpectedError)(j);continue}Object.freeze(M),await Promise.allSettled(M).then(j=>{for(const B of j)B.status==="rejected"&&(0,L.onUnexpectedError)(B.reason)})}}}e.AsyncEmitter=t;class o extends y{get isPaused(){return this._isPaused!==0}constructor(m){super(m),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=m?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const m=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(m))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(m){this._size&&(this._isPaused!==0?this._eventQueue.push(m):super.fire(m))}}e.PauseableEmitter=o;class n extends o{constructor(m){super(m),this._delay=m.delay??100}fire(m){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(m)}}e.DebounceEmitter=n;class s extends y{constructor(m){super(m),this._queuedEvents=[],this._mergeFn=m?.merge}fire(m){this.hasListeners()&&(this._queuedEvents.push(m),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(d=>super.fire(d)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=s;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(m){const d={event:m,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const b=()=>{this.hasListeners&&this.unhook(d);const O=this.events.indexOf(d);this.events.splice(O,1)};return(0,T.toDisposable)((0,N.once)(b))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(m=>this.hook(m))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(m=>this.unhook(m))}hook(m){m.listener=m.event(d=>this.emitter.fire(d))}unhook(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class r{constructor(){this.buffers=[]}wrapEvent(m){return(d,b,O)=>m(F=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>d.call(b,F)):d.call(b,F)},void 0,O)}bufferEvents(m){const d=[];this.buffers.push(d);const b=m();return this.buffers.pop(),d.forEach(O=>O()),b}}e.EventBufferer=r;class a{constructor(){this.listening=!1,this.inputEvent=v.None,this.inputEventListener=T.Disposable.None,this.emitter=new y({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(m){this.inputEvent=m,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=m(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(oe[25],ae([0,1,3]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const N=Object.freeze(function(D,P){const v=setTimeout(D.bind(P),0);return{dispose(){clearTimeout(v)}}});var T;(function(D){function P(v){return v===D.None||v===D.Cancelled||v instanceof A?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}D.isCancellationToken=P,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(T||(e.CancellationToken=T={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?N:(this._emitter||(this._emitter=new L.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(P){this._token=void 0,this._parentListener=void 0,this._parentListener=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=T.Cancelled}dispose(P=!1){P&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=k}),define(oe[125],ae([0,1,25]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class N{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new L.CancellationTokenSource,P=this.task(D.token);return this.result={promise:P,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}e.Cache=N;class T{constructor(D){this.fn=D,this.lastCache=void 0,this.lastArgKey=void 0}get(D){const P=JSON.stringify(D);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.fn(D)),this.lastCache}}e.LRUCachedFunction=T;class A{get cachedValues(){return this._map}constructor(D){this.fn=D,this._map=new Map}get(D){if(this._map.has(D))return this._map.get(D);const P=this.fn(D);return this._map.set(D,P),P}}e.CachedFunction=A}),define(oe[42],ae([0,1,7,2]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function T(E){const R=E;return R?typeof R.read=="function":!1}e.isReadable=T;function A(E){const R=E;return R?[R.on,R.pause,R.resume,R.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function k(E){const R=E;return R?A(R.stream)&&Array.isArray(R.buffer)&&typeof R.ended=="boolean":!1}e.isReadableBufferedStream=k;function D(E,R){return new P(E,R)}e.newWriteableStream=D;class P{constructor(R,t){this.reducer=R,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(R){if(!this.state.destroyed){if(this.state.flowing)this.emitData(R);else if(this.buffer.data.push(R),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(R){this.state.destroyed||(this.state.flowing?this.emitError(R):this.buffer.error.push(R))}end(R){this.state.destroyed||(typeof R<"u"&&this.write(R),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(R){this.listeners.data.slice(0).forEach(t=>t(R))}emitError(R){this.listeners.error.length===0?(0,L.onUnexpectedError)(R):this.listeners.error.slice(0).forEach(t=>t(R))}emitEnd(){this.listeners.end.slice(0).forEach(R=>R())}on(R,t){if(!this.state.destroyed)switch(R){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(R,t){if(this.state.destroyed)return;let o;switch(R){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(t);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const R=this.reducer(this.buffer.data);this.emitData(R),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const R of this.buffer.error)this.emitError(R);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function v(E,R){const t=[];let o;for(;(o=E.read())!==null;)t.push(o);return R(t)}e.consumeReadable=v;function I(E,R,t){const o=[];let n;for(;(n=E.read())!==null&&o.length<t;)o.push(n);return n===null&&o.length>0?R(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return E.read()}}}e.peekReadable=I;function C(E,R){return new Promise((t,o)=>{const n=[];S(E,{onData:s=>{R&&n.push(s)},onError:s=>{R?o(s):t(void 0)},onEnd:()=>{t(R?R(n):void 0)}})})}e.consumeStream=C;function S(E,R){let t=!1;return E.on("error",o=>{t||R.onError(o)}),E.on("end",()=>{t||R.onEnd()}),E.on("data",o=>{t||R.onData(o)}),(0,N.toDisposable)(()=>t=!0)}e.listenStream=S;function u(E,R){return new Promise((t,o)=>{const n=new N.DisposableStore,s=[],i=p=>{if(s.push(p),s.length>R)return n.dispose(),E.pause(),t({stream:E,buffer:s,ended:!1})},r=p=>o(p),a=()=>t({stream:E,buffer:s,ended:!0});n.add((0,N.toDisposable)(()=>E.removeListener("error",r))),E.on("error",r),n.add((0,N.toDisposable)(()=>E.removeListener("end",a))),E.on("end",a),n.add((0,N.toDisposable)(()=>E.removeListener("data",i))),E.on("data",i)})}e.peekStream=u;function g(E,R){const t=D(R);return t.end(E),t}e.toStream=g;function w(){const E=D(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=w;function c(E){let R=!1;return{read:()=>R?null:(R=!0,E)}}e.toReadable=c;function l(E,R,t){const o=D(t);return S(E,{onData:n=>o.write(R.data(n)),onError:n=>o.error(R.error?R.error(n):n),onEnd:()=>o.end()}),o}e.transform=l;function h(E,R,t){let o=!1;return{read:()=>{const n=R.read();return o?n:(o=!0,n!==null?t([E,n]):E)}}}e.prefixedReadable=h;function y(E,R,t){let o=!1;const n=D(t);return S(R,{onData:s=>o?n.write(s):(o=!0,n.write(t([E,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(E)),n.end()}}),n}e.prefixedStream=y}),define(oe[14],ae([0,1,84,42]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const T=typeof Buffer<"u",A=new L.Lazy(()=>new Uint8Array(256));let k,D;class P{static alloc(b){return T?new P(Buffer.allocUnsafe(b)):new P(new Uint8Array(b))}static wrap(b){return T&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new P(b)}static fromString(b,O){return!(O?.dontUseNodeBuffer||!1)&&T?new P(Buffer.from(b)):(k||(k=new TextEncoder),new P(k.encode(b)))}static fromByteArray(b){const O=P.alloc(b.length);for(let F=0,M=b.length;F<M;F++)O.buffer[F]=b[F];return O}static concat(b,O){if(typeof O>"u"){O=0;for(let q=0,j=b.length;q<j;q++)O+=b[q].byteLength}const F=P.alloc(O);let M=0;for(let q=0,j=b.length;q<j;q++){const B=b[q];F.set(B,M),M+=B.byteLength}return F}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=P.alloc(this.byteLength);return b.set(this),b}toString(){return T?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(b,O){return new P(this.buffer.subarray(b,O))}set(b,O){if(b instanceof P)this.buffer.set(b.buffer,O);else if(b instanceof Uint8Array)this.buffer.set(b,O);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),O);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return S(this.buffer,b)}writeUInt32BE(b,O){u(this.buffer,b,O)}readUInt32LE(b){return g(this.buffer,b)}writeUInt32LE(b,O){w(this.buffer,b,O)}readUInt8(b){return c(this.buffer,b)}writeUInt8(b,O){l(this.buffer,b,O)}indexOf(b,O=0){return v(this.buffer,b instanceof P?b.buffer:b,O)}}e.VSBuffer=P;function v(d,b,O=0){const F=b.byteLength,M=d.byteLength;if(F===0)return 0;if(F===1)return d.indexOf(b[0]);if(F>M-O)return-1;const q=A.value;q.fill(b.length);for(let J=0;J<b.length;J++)q[b[J]]=b.length-J-1;let j=O+b.length-1,B=j,Q=-1;for(;j<M;)if(d[j]===b[B]){if(B===0){Q=j;break}j--,B--}else j+=Math.max(b.length-B,q[d[j]]),B=b.length-1;return Q}e.binaryIndexOf=v;function I(d,b){return d[b+0]<<0>>>0|d[b+1]<<8>>>0}e.readUInt16LE=I;function C(d,b,O){d[O+0]=b&255,b=b>>>8,d[O+1]=b&255}e.writeUInt16LE=C;function S(d,b){return d[b]*2**24+d[b+1]*2**16+d[b+2]*2**8+d[b+3]}e.readUInt32BE=S;function u(d,b,O){d[O+3]=b,b=b>>>8,d[O+2]=b,b=b>>>8,d[O+1]=b,b=b>>>8,d[O]=b}e.writeUInt32BE=u;function g(d,b){return d[b+0]<<0>>>0|d[b+1]<<8>>>0|d[b+2]<<16>>>0|d[b+3]<<24>>>0}e.readUInt32LE=g;function w(d,b,O){d[O+0]=b&255,b=b>>>8,d[O+1]=b&255,b=b>>>8,d[O+2]=b&255,b=b>>>8,d[O+3]=b&255}e.writeUInt32LE=w;function c(d,b){return d[b]}e.readUInt8=c;function l(d,b,O){d[O]=b}e.writeUInt8=l;function h(d){return N.consumeReadable(d,b=>P.concat(b))}e.readableToBuffer=h;function y(d){return N.toReadable(d)}e.bufferToReadable=y;function E(d){return N.consumeStream(d,b=>P.concat(b))}e.streamToBuffer=E;async function R(d){return d.ended?P.concat(d.buffer):P.concat([...d.buffer,await E(d.stream)])}e.bufferedStreamToBuffer=R;function t(d){return N.toStream(d,b=>P.concat(b))}e.bufferToStream=t;function o(d){return N.transform(d,{data:b=>typeof b=="string"?P.fromString(b):P.wrap(b)},b=>P.concat(b))}e.streamToBufferReadableStream=o;function n(d){return N.newWriteableStream(b=>P.concat(b),d)}e.newWriteableBufferStream=n;function s(d,b){return N.prefixedReadable(d,b,O=>P.concat(O))}e.prefixedBufferReadable=s;function i(d,b){return N.prefixedStream(d,b,O=>P.concat(O))}e.prefixedBufferStream=i;function r(d){let b=0,O=0,F=0;const M=new Uint8Array(Math.floor(d.length/4*3)),q=B=>{switch(O){case 3:M[F++]=b|B,O=0;break;case 2:M[F++]=b|B>>>2,b=B<<6,O=3;break;case 1:M[F++]=b|B>>>4,b=B<<4,O=2;break;default:b=B<<2,O=1}};for(let B=0;B<d.length;B++){const Q=d.charCodeAt(B);if(Q>=65&&Q<=90)q(Q-65);else if(Q>=97&&Q<=122)q(Q-97+26);else if(Q>=48&&Q<=57)q(Q-48+52);else if(Q===43||Q===45)q(62);else if(Q===47||Q===95)q(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${d[B]}`)}}const j=F;for(;O>0;)q(0);return P.wrap(M).slice(0,j)}e.decodeBase64=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:d},b=!0,O=!1){const F=O?p:a;let M="";const q=d.byteLength%3;let j=0;for(;j<d.byteLength-q;j+=3){const B=d[j+0],Q=d[j+1],J=d[j+2];M+=F[B>>>2],M+=F[(B<<4|Q>>>4)&63],M+=F[(Q<<2|J>>>6)&63],M+=F[J&63]}if(q===1){const B=d[j+0];M+=F[B>>>2],M+=F[B<<4&63],b&&(M+="==")}else if(q===2){const B=d[j+0],Q=d[j+1];M+=F[B>>>2],M+=F[(B<<4|Q>>>4)&63],M+=F[Q<<2&63],b&&(M+="=")}return M}e.encodeBase64=m}),define(oe[27],ae([0,1,125,84]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function k(ie,...de){return de.length===0?ie:ie.replace(A,function(me,ye){const pe=parseInt(ye,10);return isNaN(pe)||pe<0||pe>=de.length?me:de[pe]})}e.format=k;const D=/{([^}]+)}/g;function P(ie,de){return ie.replace(D,(me,ye)=>de[ye]??me)}e.format2=P;function v(ie){return ie.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}e.escape=v;function I(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function C(ie,de){let me=0;const ye=de.charCodeAt(0);for(let pe=ie.length-1;pe>=0;pe--)ie.charCodeAt(pe)===ye&&me++;return me}e.count=C;function S(ie,de,me="\u2026"){return ie.length<=de?ie:`${ie.substr(0,de)}${me}`}e.truncate=S;function u(ie,de=" "){const me=g(ie,de);return w(me,de)}e.trim=u;function g(ie,de){if(!ie||!de)return ie;const me=de.length;if(me===0||ie.length===0)return ie;let ye=0;for(;ie.indexOf(de,ye)===ye;)ye=ye+me;return ie.substring(ye)}e.ltrim=g;function w(ie,de){if(!ie||!de)return ie;const me=de.length,ye=ie.length;if(me===0||ye===0)return ie;let pe=ye,Ce=-1;for(;Ce=ie.lastIndexOf(de,pe-1),!(Ce===-1||Ce+me!==pe);){if(Ce===0)return"";pe=Ce}return ie.substring(0,pe)}e.rtrim=w;function c(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function l(ie){return ie.replace(/\*/g,"")}e.stripWildcards=l;function h(ie,de,me={}){if(!ie)throw new Error("Cannot create regex from empty string");de||(ie=I(ie)),me.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let ye="";return me.global&&(ye+="g"),me.matchCase||(ye+="i"),me.multiline&&(ye+="m"),me.unicode&&(ye+="u"),new RegExp(ie,ye)}e.createRegExp=h;function y(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function E(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function R(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.regExpFlags=R;function t(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=t;function o(ie){for(let de=0,me=ie.length;de<me;de++){const ye=ie.charCodeAt(de);if(ye!==32&&ye!==9)return de}return-1}e.firstNonWhitespaceIndex=o;function n(ie,de=0,me=ie.length){for(let ye=de;ye<me;ye++){const pe=ie.charCodeAt(ye);if(pe!==32&&pe!==9)return ie.substring(de,ye)}return ie.substring(de,me)}e.getLeadingWhitespace=n;function s(ie,de=ie.length-1){for(let me=de;me>=0;me--){const ye=ie.charCodeAt(me);if(ye!==32&&ye!==9)return me}return-1}e.lastNonWhitespaceIndex=s;function i(ie,de,me){const ye=[];let pe=0;for(const Ce of ie.matchAll(de)){if(ye.push(ie.slice(pe,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");pe=Ce.index+Ce[0].length,ye.push(me(Ce[0],...Ce.slice(1),Ce.index,ie,Ce.groups))}return ye.push(ie.slice(pe)),Promise.all(ye).then(Ce=>Ce.join(""))}e.replaceAsync=i;function r(ie,de){return ie<de?-1:ie>de?1:0}e.compare=r;function a(ie,de,me=0,ye=ie.length,pe=0,Ce=de.length){for(;me<ye&&pe<Ce;me++,pe++){const Te=ie.charCodeAt(me),xe=de.charCodeAt(pe);if(Te<xe)return-1;if(Te>xe)return 1}const Re=ye-me,Le=Ce-pe;return Re<Le?-1:Re>Le?1:0}e.compareSubstring=a;function p(ie,de){return m(ie,de,0,ie.length,0,de.length)}e.compareIgnoreCase=p;function m(ie,de,me=0,ye=ie.length,pe=0,Ce=de.length){for(;me<ye&&pe<Ce;me++,pe++){let Te=ie.charCodeAt(me),xe=de.charCodeAt(pe);if(Te===xe)continue;if(Te>=128||xe>=128)return a(ie.toLowerCase(),de.toLowerCase(),me,ye,pe,Ce);b(Te)&&(Te-=32),b(xe)&&(xe-=32);const Ne=Te-xe;if(Ne!==0)return Ne}const Re=ye-me,Le=Ce-pe;return Re<Le?-1:Re>Le?1:0}e.compareSubstringIgnoreCase=m;function d(ie){return ie>=48&&ie<=57}e.isAsciiDigit=d;function b(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=b;function O(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=O;function F(ie,de){return ie.length===de.length&&m(ie,de)===0}e.equalsIgnoreCase=F;function M(ie,de){const me=de.length;return de.length>ie.length?!1:m(ie,de,0,me)===0}e.startsWithIgnoreCase=M;function q(ie,de){const me=Math.min(ie.length,de.length);let ye;for(ye=0;ye<me;ye++)if(ie.charCodeAt(ye)!==de.charCodeAt(ye))return ye;return me}e.commonPrefixLength=q;function j(ie,de){const me=Math.min(ie.length,de.length);let ye;const pe=ie.length-1,Ce=de.length-1;for(ye=0;ye<me;ye++)if(ie.charCodeAt(pe-ye)!==de.charCodeAt(Ce-ye))return ye;return me}e.commonSuffixLength=j;function B(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=B;function Q(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=Q;function J(ie,de){return(ie-55296<<10)+(de-56320)+65536}e.computeCodePoint=J;function G(ie,de,me){const ye=ie.charCodeAt(me);if(B(ye)&&me+1<de){const pe=ie.charCodeAt(me+1);if(Q(pe))return J(ye,pe)}return ye}e.getNextCodePoint=G;function X(ie,de){const me=ie.charCodeAt(de-1);if(Q(me)&&de>1){const ye=ie.charCodeAt(de-2);if(B(ye))return J(ye,me)}return me}class V{get offset(){return this._offset}constructor(de,me=0){this._str=de,this._len=de.length,this._offset=me}setOffset(de){this._offset=de}prevCodePoint(){const de=X(this._str,this._offset);return this._offset-=de>=65536?2:1,de}nextCodePoint(){const de=G(this._str,this._len,this._offset);return this._offset+=de>=65536?2:1,de}eol(){return this._offset>=this._len}}e.CodePointIterator=V;class x{get offset(){return this._iterator.offset}constructor(de,me=0){this._iterator=new V(de,me)}nextGraphemeLength(){const de=Pe.getInstance(),me=this._iterator,ye=me.offset;let pe=de.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ce=me.offset,Re=de.getGraphemeBreakType(me.nextCodePoint());if(fe(pe,Re)){me.setOffset(Ce);break}pe=Re}return me.offset-ye}prevGraphemeLength(){const de=Pe.getInstance(),me=this._iterator,ye=me.offset;let pe=de.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ce=me.offset,Re=de.getGraphemeBreakType(me.prevCodePoint());if(fe(Re,pe)){me.setOffset(Ce);break}pe=Re}return ye-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=x;function z(ie,de){return new x(ie,de).nextGraphemeLength()}e.nextCharLength=z;function ee(ie,de){return new x(ie,de).prevGraphemeLength()}e.prevCharLength=ee;function ne(ie,de){de>0&&Q(ie.charCodeAt(de))&&de--;const me=de+z(ie,de);return[me-ee(ie,me),me]}e.getCharContainingOffset=ne;function ce(ie){const de=new x(ie);let me=0;for(;!de.eol();)me++,de.nextGraphemeLength();return me}e.charCount=ce;let re;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function f(ie){return re||(re=U()),re.test(ie)}e.containsRTL=f;const _=/^[\t\n\r\x20-\x7E]*$/;function $(ie){return _.test(ie)}e.isBasicASCII=$,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=H;function W(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=W;function K(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=K;function Z(ie,de){if(ie.length<de)return ie;const me=/\b/g;let ye=0;for(;me.test(ie)&&!(ie.length-me.lastIndex<de);)ye=me.lastIndex,me.lastIndex+=1;return ie.substring(ye).replace(/^\s/,"")}e.lcut=Z;const se=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ue=/\x1b\].*?\x07/g;function he(ie){return ie&&(ie=ie.replace(se,"").replace(ue,"")),ie}e.removeAnsiEscapeCodes=he,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Se(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Se;function Ee(ie){return Se(ie)?ie.substr(1):ie}e.stripUTF8BOM=Ee;function be(ie,de){if(!ie||!de||ie.length<de.length)return!1;const me=de.length,ye=ie.toLowerCase();let pe=0,Ce=-1;for(;pe<me;){const Re=ye.indexOf(de[pe],Ce+1);if(Re<0)return!1;Ce=Re,pe++}return!0}e.fuzzyContains=be;function De(ie,de=!1){return ie?(de&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=De;function _e(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=_e;function $e(ie,de=1){if(de===0)return"";let me=-1;do me=ie.indexOf(`
`,me+1),de--;while(de>0&&me>=0);return me===-1?ie:(ie[me-1]==="\r"&&me--,ie.substr(0,me))}e.getNLines=$e;function Be(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.singleLetterHash=Be;function le(ie){return Pe.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=le;function fe(ie,de){return ie===0?de!==5&&de!==7:ie===2&&de===3?!1:ie===4||ie===2||ie===3||de===4||de===2||de===3?!0:!(ie===8&&(de===8||de===9||de===11||de===12)||(ie===11||ie===9)&&(de===9||de===10)||(ie===12||ie===10)&&de===10||de===5||de===13||de===7||ie===1||ie===13&&de===14||ie===6&&de===6)}var ge;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(e.GraphemeBreakType=ge={}));class Pe{static{this._INSTANCE=null}static getInstance(){return Pe._INSTANCE||(Pe._INSTANCE=new Pe),Pe._INSTANCE}constructor(){this._data=Ie()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const me=this._data,ye=me.length/3;let pe=1;for(;pe<=ye;)if(de<me[3*pe])pe=2*pe;else if(de>me[3*pe+1])pe=2*pe+1;else return me[3*pe+2];return 0}}function Ie(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(ie,de){if(ie===0)return 0;const me=ke(ie,de);if(me!==void 0)return me;const ye=new V(de,ie);return ye.prevCodePoint(),ye.offset}e.getLeftDeleteOffset=Fe;function ke(ie,de){const me=new V(de,ie);let ye=me.prevCodePoint();for(;We(ye)||ye===65039||ye===8419;){if(me.offset===0)return;ye=me.prevCodePoint()}if(!K(ye))return;let pe=me.offset;return pe>0&&me.prevCodePoint()===8205&&(pe=me.offset),pe}function We(ie){return 127995<=ie&&ie<=127999}var Ae;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={})),e.noBreakWhitespace="\xA0";class Ue{static{this.ambiguousCharacterData=new N.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new L.LRUCachedFunction(de=>{function me(Ne){const je=new Map;for(let qe=0;qe<Ne.length;qe+=2)je.set(Ne[qe],Ne[qe+1]);return je}function ye(Ne,je){const qe=new Map(Ne);for(const[Ze,nt]of je)qe.set(Ze,nt);return qe}function pe(Ne,je){if(!Ne)return je;const qe=new Map;for(const[Ze,nt]of Ne)je.has(Ze)&&qe.set(Ze,nt);return qe}const Ce=this.ambiguousCharacterData.value;let Re=de.filter(Ne=>!Ne.startsWith("_")&&Ne in Ce);Re.length===0&&(Re=["_default"]);let Le;for(const Ne of Re){const je=me(Ce[Ne]);Le=pe(Le,je)}const Te=me(Ce._common),xe=ye(Te,Le);return new Ue(xe)})}static getInstance(de){return Ue.cache.get(Array.from(de))}static{this._locales=new N.Lazy(()=>Object.keys(Ue.ambiguousCharacterData.value).filter(de=>!de.startsWith("_")))}static getLocales(){return Ue._locales.value}constructor(de){this.confusableDictionary=de}isAmbiguous(de){return this.confusableDictionary.has(de)}getPrimaryConfusable(de){return this.confusableDictionary.get(de)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ue;class Me{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Me.getRawData())),this._data}static isInvisibleCharacter(de){return Me.getData().has(de)}static get codePoints(){return Me.getData()}}e.InvisibleCharacters=Me}),define(oe[51],ae([0,1,27]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function N(l){return T(l,0)}e.hash=N;function T(l,h){switch(typeof l){case"object":return l===null?A(349,h):Array.isArray(l)?P(l,h):v(l,h);case"string":return D(l,h);case"boolean":return k(l,h);case"number":return A(l,h);case"undefined":return A(937,h);default:return A(617,h)}}e.doHash=T;function A(l,h){return(h<<5)-h+l|0}e.numberHash=A;function k(l,h){return A(l?433:863,h)}function D(l,h){h=A(149417,h);for(let y=0,E=l.length;y<E;y++)h=A(l.charCodeAt(y),h);return h}e.stringHash=D;function P(l,h){return h=A(104579,h),l.reduce((y,E)=>T(E,y),h)}function v(l,h){return h=A(181387,h),Object.keys(l).sort().reduce((y,E)=>(y=D(E,y),T(l[E],y)),h)}class I{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=T(h,this._value),this._value}}e.Hasher=I;var C;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function S(l,h,y=32){const E=y-h,R=~((1<<E)-1);return(l<<h|(R&l)>>>E)>>>0}function u(l,h=0,y=l.byteLength,E=0){for(let R=0;R<y;R++)l[h+R]=E}function g(l,h,y="0"){for(;l.length<h;)l=y+l;return l}function w(l,h=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(y=>y.toString(16).padStart(2,"0")).join(""):g((l>>>0).toString(16),h/4)}e.toHexString=w;class c{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const y=h.length;if(y===0)return;const E=this._buff;let R=this._buffLen,t=this._leftoverHighSurrogate,o,n;for(t!==0?(o=t,n=-1,t=0):(o=h.charCodeAt(0),n=0);;){let s=o;if(L.isHighSurrogate(o))if(n+1<y){const i=h.charCodeAt(n+1);L.isLowSurrogate(i)?(n++,s=L.computeCodePoint(o,i)):s=65533}else{t=o;break}else L.isLowSurrogate(o)&&(s=65533);if(R=this._push(E,R,s),n++,n<y)o=h.charCodeAt(n);else break}this._buffLen=R,this._leftoverHighSurrogate=t}_push(h,y,E){return E<128?h[y++]=E:E<2048?(h[y++]=192|(E&1984)>>>6,h[y++]=128|(E&63)>>>0):E<65536?(h[y++]=224|(E&61440)>>>12,h[y++]=128|(E&4032)>>>6,h[y++]=128|(E&63)>>>0):(h[y++]=240|(E&1835008)>>>18,h[y++]=128|(E&258048)>>>12,h[y++]=128|(E&4032)>>>6,h[y++]=128|(E&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,u(this._buff,this._buffLen),this._buffLen>56&&(this._step(),u(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=c._bigBlock32,y=this._buffDV;for(let a=0;a<64;a+=4)h.setUint32(a,y.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)h.setUint32(a,S(h.getUint32(a-12,!1)^h.getUint32(a-32,!1)^h.getUint32(a-56,!1)^h.getUint32(a-64,!1),1),!1);let E=this._h0,R=this._h1,t=this._h2,o=this._h3,n=this._h4,s,i,r;for(let a=0;a<80;a++)a<20?(s=R&t|~R&o,i=1518500249):a<40?(s=R^t^o,i=1859775393):a<60?(s=R&t|R&o|t&o,i=2400959708):(s=R^t^o,i=3395469782),r=S(E,5)+s+n+i+h.getUint32(a*4,!1)&4294967295,n=o,o=t,t=S(R,30),R=E,E=r;this._h0=this._h0+E&4294967295,this._h1=this._h1+R&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=c}),define(oe[88],ae([0,1,27]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(N||(N={})),function(T){const A="error",k="warning",D="warn",P="info",v="ignore";function I(S){return S?L.equalsIgnoreCase(A,S)?T.Error:L.equalsIgnoreCase(k,S)||L.equalsIgnoreCase(D,S)?T.Warning:L.equalsIgnoreCase(P,S)?T.Info:T.Ignore:T.Ignore}T.fromValue=I;function C(S){switch(S){case T.Error:return A;case T.Warning:return k;case T.Info:return P;default:return v}}T.toString=C}(N||(N={})),e.default=N}),define(oe[126],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(oe[47],ae([0,1,21,27]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class T{constructor(){this._value="",this._pos=0}reset(u){return this._value=u,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(u){const g=u.charCodeAt(0),w=this._value.charCodeAt(this._pos);return g-w}value(){return this._value[this._pos]}}e.StringIterator=T;class A{constructor(u=!0){this._caseSensitive=u}reset(u){return this._value=u,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(u)this._from++;else break;else u=!1;return this}cmp(u){return this._caseSensitive?(0,N.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,N.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class k{constructor(u=!0,g=!0){this._splitOnBackslash=u,this._caseSensitive=g}reset(u){this._from=0,this._to=0,this._value=u,this._valueLen=u.length;for(let g=u.length-1;g>=0;g--,this._valueLen--){const w=this._value.charCodeAt(g);if(!(w===47||this._splitOnBackslash&&w===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let u=!0;for(;this._to<this._valueLen;this._to++){const g=this._value.charCodeAt(this._to);if(g===47||this._splitOnBackslash&&g===92)if(u)this._from++;else break;else u=!1}return this}cmp(u){return this._caseSensitive?(0,N.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,N.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var D;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(D||(D={}));class P{constructor(u,g){this._ignorePathCasing=u,this._ignoreQueryAndFragment=g,this._states=[],this._stateIdx=0}reset(u){return this._value=u,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(u)),this._pathIterator.reset(u.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(u)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(u){if(this._states[this._stateIdx]===1)return(0,N.compareIgnoreCase)(u,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,N.compareIgnoreCase)(u,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(u);if(this._states[this._stateIdx]===4)return(0,N.compare)(u,this._value.query);if(this._states[this._stateIdx]===5)return(0,N.compare)(u,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=P;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(I||(I={}));class C{static forUris(u=()=>!1,g=()=>!1){return new C(new P(u,g))}static forPaths(u=!1){return new C(new k(void 0,!u))}static forStrings(){return new C(new T)}static forConfigKeys(){return new C(new A)}constructor(u){this._iter=u}clear(){this._root=void 0}fill(u,g){if(g){const w=g.slice(0);(0,L.shuffle)(w);for(const c of w)this.set(c,u)}else{const w=u.slice(0);(0,L.shuffle)(w);for(const c of w)this.set(c[0],c[1])}}set(u,g){const w=this._iter.reset(u);let c;this._root||(this._root=new v,this._root.segment=w.value());const l=[];for(c=this._root;;){const y=w.cmp(c.segment);if(y>0)c.left||(c.left=new v,c.left.segment=w.value()),l.push([-1,c]),c=c.left;else if(y<0)c.right||(c.right=new v,c.right.segment=w.value()),l.push([1,c]),c=c.right;else if(w.hasNext())w.next(),c.mid||(c.mid=new v,c.mid.segment=w.value()),l.push([0,c]),c=c.mid;else break}const h=c.value;c.value=g,c.key=u;for(let y=l.length-1;y>=0;y--){const E=l[y][1];E.updateHeight();const R=E.balanceFactor();if(R<-1||R>1){const t=l[y][0],o=l[y+1][0];if(t===1&&o===1)l[y][1]=E.rotateLeft();else if(t===-1&&o===-1)l[y][1]=E.rotateRight();else if(t===1&&o===-1)E.right=l[y+1][1]=l[y+1][1].rotateRight(),l[y][1]=E.rotateLeft();else if(t===-1&&o===1)E.left=l[y+1][1]=l[y+1][1].rotateLeft(),l[y][1]=E.rotateRight();else throw new Error;if(y>0)switch(l[y-1][0]){case-1:l[y-1][1].left=l[y][1];break;case 1:l[y-1][1].right=l[y][1];break;case 0:l[y-1][1].mid=l[y][1];break}else this._root=l[0][1]}}return h}get(u){return this._getNode(u)?.value}_getNode(u){const g=this._iter.reset(u);let w=this._root;for(;w;){const c=g.cmp(w.segment);if(c>0)w=w.left;else if(c<0)w=w.right;else if(g.hasNext())g.next(),w=w.mid;else break}return w}has(u){const g=this._getNode(u);return!(g?.value===void 0&&g?.mid===void 0)}delete(u){return this._delete(u,!1)}deleteSuperstr(u){return this._delete(u,!0)}_delete(u,g){const w=this._iter.reset(u),c=[];let l=this._root;for(;l;){const h=w.cmp(l.segment);if(h>0)c.push([-1,l]),l=l.left;else if(h<0)c.push([1,l]),l=l.right;else if(w.hasNext())w.next(),c.push([0,l]),l=l.mid;else break}if(l){if(g?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const h=this._min(l.right);if(h.key){const{key:y,value:E,segment:R}=h;this._delete(h.key,!1),l.key=y,l.value=E,l.segment=R}}else{const h=l.left??l.right;if(c.length>0){const[y,E]=c[c.length-1];switch(y){case-1:E.left=h;break;case 0:E.mid=h;break;case 1:E.right=h;break}}else this._root=h}for(let h=c.length-1;h>=0;h--){const y=c[h][1];y.updateHeight();const E=y.balanceFactor();if(E>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),c[h][1]=y.rotateLeft()):E<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),c[h][1]=y.rotateRight()),h>0)switch(c[h-1][0]){case-1:c[h-1][1].left=c[h][1];break;case 1:c[h-1][1].right=c[h][1];break;case 0:c[h-1][1].mid=c[h][1];break}else this._root=c[0][1]}}}_min(u){for(;u.left;)u=u.left;return u}findSubstr(u){const g=this._iter.reset(u);let w=this._root,c;for(;w;){const l=g.cmp(w.segment);if(l>0)w=w.left;else if(l<0)w=w.right;else if(g.hasNext())g.next(),c=w.value||c,w=w.mid;else break}return w&&w.value||c}findSuperstr(u){return this._findSuperstrOrElement(u,!1)}_findSuperstrOrElement(u,g){const w=this._iter.reset(u);let c=this._root;for(;c;){const l=w.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(w.hasNext())w.next(),c=c.mid;else return c.mid?this._entries(c.mid):g?c.value:void 0}}hasElementOrSubtree(u){return this._findSuperstrOrElement(u,!0)!==void 0}forEach(u){for(const[g,w]of this)u(w,g)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(u){const g=[];return this._dfsEntries(u,g),g[Symbol.iterator]()}_dfsEntries(u,g){u&&(u.left&&this._dfsEntries(u.left,g),u.value&&g.push([u.key,u.value]),u.mid&&this._dfsEntries(u.mid,g),u.right&&this._dfsEntries(u.right,g))}_isBalanced(){const u=g=>{if(!g)return!0;const w=g.balanceFactor();return w<-1||w>1?!1:u(g.left)&&u(g.right)};return u(this._root)}}e.TernarySearchTree=C}),define(oe[11],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function L(o){return typeof o=="string"}e.isString=L;function N(o){return Array.isArray(o)&&o.every(n=>L(n))}e.isStringArray=N;function T(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=T;function A(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}e.isTypedArray=A;function k(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=k;function D(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=D;function P(o){return o===!0||o===!1}e.isBoolean=P;function v(o){return typeof o>"u"}e.isUndefined=v;function I(o){return!C(o)}e.isDefined=I;function C(o){return v(o)||o===null}e.isUndefinedOrNull=C;function S(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=S;function u(o){if(C(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=u;function g(...o){const n=[];for(let s=0;s<o.length;s++){const i=o[s];if(C(i))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(i)}return n}e.assertAllDefined=g;const w=Object.prototype.hasOwnProperty;function c(o){if(!T(o))return!1;for(const n in o)if(w.call(o,n))return!1;return!0}e.isEmptyObject=c;function l(o){return typeof o=="function"}e.isFunction=l;function h(...o){return o.length>0&&o.every(l)}e.areFunctions=h;function y(o,n){const s=Math.min(o.length,n.length);for(let i=0;i<s;i++)E(o[i],n[i])}e.validateConstraints=y;function E(o,n){if(L(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(l(n)){try{if(o instanceof n)return}catch{}if(!C(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E;function R(o){return o===null?void 0:o}e.withNullAsUndefined=R;function t(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=t}),define(oe[30],ae([0,1,11]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function N(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const h=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([y,E])=>{h[y]=E&&typeof E=="object"?N(E):E}),h}e.deepClone=N;function T(l){if(!l||typeof l!="object")return l;const h=[l];for(;h.length>0;){const y=h.shift();Object.freeze(y);for(const E in y)if(A.call(y,E)){const R=y[E];typeof R=="object"&&!Object.isFrozen(R)&&!(0,L.isTypedArray)(R)&&h.push(R)}}return l}e.deepFreeze=T;const A=Object.prototype.hasOwnProperty;function k(l,h){return D(l,h,new Set)}e.cloneAndChange=k;function D(l,h,y){if((0,L.isUndefinedOrNull)(l))return l;const E=h(l);if(typeof E<"u")return E;if(Array.isArray(l)){const R=[];for(const t of l)R.push(D(t,h,y));return R}if((0,L.isObject)(l)){if(y.has(l))throw new Error("Cannot clone recursive data-structure");y.add(l);const R={};for(const t in l)A.call(l,t)&&(R[t]=D(l[t],h,y));return y.delete(l),R}return l}function P(l,h,y=!0){return(0,L.isObject)(l)?((0,L.isObject)(h)&&Object.keys(h).forEach(E=>{E in l?y&&((0,L.isObject)(l[E])&&(0,L.isObject)(h[E])?P(l[E],h[E],y):l[E]=h[E]):l[E]=h[E]}),l):h}e.mixin=P;function v(l,h){if(l===h)return!0;if(l==null||h===null||h===void 0||typeof l!=typeof h||typeof l!="object"||Array.isArray(l)!==Array.isArray(h))return!1;let y,E;if(Array.isArray(l)){if(l.length!==h.length)return!1;for(y=0;y<l.length;y++)if(!v(l[y],h[y]))return!1}else{const R=[];for(E in l)R.push(E);R.sort();const t=[];for(E in h)t.push(E);if(t.sort(),!v(R,t))return!1;for(y=0;y<R.length;y++)if(!v(l[R[y]],h[R[y]]))return!1}return!0}e.equals=v;function I(l){const h=new Set;return JSON.stringify(l,(y,E)=>{if((0,L.isObject)(E)||Array.isArray(E)){if(h.has(E))return"[Circular]";h.add(E)}return E})}e.safeStringify=I;function C(l,h){const y=Object.create(null);return!l||!h||Object.keys(h).forEach(R=>{const t=l[R],o=h[R];v(t,o)||(y[R]=o)}),y}e.distinct=C;function S(l,h){const y=h.toLowerCase(),E=Object.keys(l).find(R=>R.toLowerCase()===y);return E?l[E]:l[h]}e.getCaseInsensitive=S;function u(l,h){const y=Object.create(null);for(const[E,R]of Object.entries(l))h(E,R)&&(y[E]=R);return y}e.filter=u;function g(l){let h=[];for(;Object.prototype!==l;)h=h.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return h}e.getAllPropertyNames=g;function w(l){const h=[];for(const y of g(l))typeof l[y]=="function"&&h.push(y);return h}e.getAllMethodNames=w;function c(l,h){const y=R=>function(){const t=Array.prototype.slice.call(arguments,0);return h(R,t)},E={};for(const R of l)E[R]=y(R);return E}e.createProxyObject=c}),define(oe[32],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(T){return L.test(T)}e.isUUID=N,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(D){for(let P=0;P<D.length;P++)D[P]=Math.floor(Math.random()*256);return D};const A=new Uint8Array(16),k=[];for(let D=0;D<256;D++)k.push(D.toString(16).padStart(2,"0"));return function(){T(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let P=0,v="";return v+=k[A[P++]],v+=k[A[P++]],v+=k[A[P++]],v+=k[A[P++]],v+="-",v+=k[A[P++]],v+=k[A[P++]],v+="-",v+=k[A[P++]],v+=k[A[P++]],v+="-",v+=k[A[P++]],v+=k[A[P++]],v+="-",v+=k[A[P++]],v+=k[A[P++]],v+=k[A[P++]],v+=k[A[P++]],v+=k[A[P++]],v+=k[A[P++]],v}}()}),define(oe[127],ae([0,1,36]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function T(k){const D=k.replace(/\-/g,":").toLowerCase();return!N.has(D)}function A(){const k=(0,L.networkInterfaces)();for(const D in k){const P=k[D];if(P){for(const{mac:v}of P)if(T(v))return v}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(oe[128],ae([0,1,36,47,32,127]),function(te,e,L,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(v){return this._virtualMachineOUIs||(this._virtualMachineOUIs=N.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(v)}value(){if(this._value===void 0){let v=0,I=0;const C=(0,L.networkInterfaces)();for(const S in C){const u=C[S];if(u)for(const{mac:g,internal:w}of u)w||(I+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(v+=1))}this._value=I>0?v/I:0}return this._value}};let k;async function D(v){return k||(k=(async()=>await P(v)||T.generateUuid())()),k}e.getMachineId=D;async function P(v){try{const I=await new Promise((S,u)=>{te(["crypto"],S,u)}),C=(0,A.getMac)();return I.createHash("sha256").update(C,"utf8").digest("hex")}catch(I){v(I);return}}}),define(oe[129],ae([0,1,263,14]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StreamSplitter=void 0;class T extends L.Transform{constructor(k){if(super(),typeof k=="number")this.splitter=k,this.spitterLen=1;else{const D=Buffer.isBuffer(k)?k:Buffer.from(k);this.splitter=D.length===1?D[0]:D,this.spitterLen=D.length}}_transform(k,D,P){this.buffer?this.buffer=Buffer.concat([this.buffer,k]):this.buffer=k;let v=0;for(;v<this.buffer.length;){const I=typeof this.splitter=="number"?this.buffer.indexOf(this.splitter,v):(0,N.binaryIndexOf)(this.buffer,this.splitter,v);if(I===-1)break;this.push(this.buffer.slice(v,I+this.spitterLen)),v=I+this.spitterLen}this.buffer=v===this.buffer.length?void 0:this.buffer.slice(v),P()}_flush(k){this.buffer&&this.push(this.buffer),k()}}e.StreamSplitter=T}),define(oe[130],ae([0,1,60]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function N(D,P,v,I=1){let C=!1;return new Promise(S=>{const u=setTimeout(()=>{if(!C)return C=!0,S(0)},v);T(D,P,I,g=>{if(!C)return C=!0,clearTimeout(u),S(g)})})}e.findFreePort=N;function T(D,P,v,I){if(P===0)return I(0);const C=new L.Socket;C.once("connect",()=>(k(C),T(D+v,P-1,v,I))),C.once("data",()=>{}),C.once("error",S=>(k(C),S.code!=="ECONNREFUSED"?T(D+v,P-1,v,I):I(D))),C.connect(D,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(D,P,v,I="127.0.0.1"){let C=!1,S,u=1;const g=L.createServer({pauseOnConnect:!0});function w(c,l){C||(C=!0,g.removeAllListeners(),g.close(),S&&clearTimeout(S),l(c))}return new Promise(c=>{S=setTimeout(()=>{w(0,c)},v),g.on("listening",()=>{w(D,c)}),g.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&u<P?(D++,u++,g.listen(D,I)):w(0,c)}),g.on("close",()=>{w(0,c)}),g.listen(D,I)})}e.findFreePortFaster=A;function k(D){try{D.removeAllListeners("connect"),D.removeAllListeners("error"),D.end(),D.destroy(),D.unref()}catch(P){console.error(P)}}}),define(oe[131],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function L(N){return!!N.parentPort}e.isUtilityProcess=L}),define(oe[132],ae([12,9]),function(te,e){return te.create("vs/base/common/date",e)}),define(oe[61],ae([0,1,132]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const N=60,T=N*60,A=T*24,k=A*7,D=A*30,P=A*365;function v(C,S,u,g){typeof C!="number"&&(C=C.getTime());const w=Math.round((new Date().getTime()-C)/1e3);if(w<-30)return(0,L.localize)(0,null,v(new Date().getTime()+w*1e3,!1));if(!g&&w<30)return(0,L.localize)(1,null);let c;return w<N?(c=w,S?c===1?u?(0,L.localize)(2,null,c):(0,L.localize)(3,null,c):u?(0,L.localize)(4,null,c):(0,L.localize)(5,null,c):c===1?u?(0,L.localize)(6,null,c):(0,L.localize)(7,null,c):u?(0,L.localize)(8,null,c):(0,L.localize)(9,null,c)):w<T?(c=Math.floor(w/N),S?c===1?u?(0,L.localize)(10,null,c):(0,L.localize)(11,null,c):u?(0,L.localize)(12,null,c):(0,L.localize)(13,null,c):c===1?u?(0,L.localize)(14,null,c):(0,L.localize)(15,null,c):u?(0,L.localize)(16,null,c):(0,L.localize)(17,null,c)):w<A?(c=Math.floor(w/T),S?c===1?u?(0,L.localize)(18,null,c):(0,L.localize)(19,null,c):u?(0,L.localize)(20,null,c):(0,L.localize)(21,null,c):c===1?u?(0,L.localize)(22,null,c):(0,L.localize)(23,null,c):u?(0,L.localize)(24,null,c):(0,L.localize)(25,null,c)):w<k?(c=Math.floor(w/A),S?c===1?(0,L.localize)(26,null,c):(0,L.localize)(27,null,c):c===1?(0,L.localize)(28,null,c):(0,L.localize)(29,null,c)):w<D?(c=Math.floor(w/k),S?c===1?u?(0,L.localize)(30,null,c):(0,L.localize)(31,null,c):u?(0,L.localize)(32,null,c):(0,L.localize)(33,null,c):c===1?u?(0,L.localize)(34,null,c):(0,L.localize)(35,null,c):u?(0,L.localize)(36,null,c):(0,L.localize)(37,null,c)):w<P?(c=Math.floor(w/D),S?c===1?u?(0,L.localize)(38,null,c):(0,L.localize)(39,null,c):u?(0,L.localize)(40,null,c):(0,L.localize)(41,null,c):c===1?u?(0,L.localize)(42,null,c):(0,L.localize)(43,null,c):u?(0,L.localize)(44,null,c):(0,L.localize)(45,null,c)):(c=Math.floor(w/P),S?c===1?u?(0,L.localize)(46,null,c):(0,L.localize)(47,null,c):u?(0,L.localize)(48,null,c):(0,L.localize)(49,null,c):c===1?u?(0,L.localize)(50,null,c):(0,L.localize)(51,null,c):u?(0,L.localize)(52,null,c):(0,L.localize)(53,null,c))}e.fromNow=v;function I(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(oe[133],ae([12,9]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,21,11,133]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(C,S){return S&&(C.stack||C.stacktrace)?T.localize(0,null,D(C),k(C.stack)||k(C.stacktrace)):D(C)}function k(C){return Array.isArray(C)?C.join(`
`):C}function D(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?T.localize(1,null,C.message):C.message||T.localize(2,null)}function P(C=null,S=!1){if(!C)return T.localize(3,null);if(Array.isArray(C)){const u=L.coalesce(C),g=P(u[0],S);return u.length>1?T.localize(4,null,g,u.length):g}if(N.isString(C))return C;if(C.detail){const u=C.detail;if(u.error)return A(u.error,S);if(u.exception)return A(u.exception,S)}return C.stack?A(C,S):C.message?C.message:T.localize(5,null)}e.toErrorMessage=P;function v(C){const S=C;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=v;function I(C,S){let u;return typeof C=="string"?u=new Error(C):u=C,u.actions=S,u}e.createErrorWithActions=I}),define(oe[134],ae([12,9]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(oe[135],ae([0,1,134]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function N(T){switch(T){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.getParseErrorMessage=N}),define(oe[136],ae([12,9]),function(te,e){return te.create("vs/base/common/platform",e)}),define(oe[5],ae([0,1,136]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let N=!1,T=!1,A=!1,k=!1,D=!1,P=!1,v=!1,I=!1,C=!1,S=!1,u,g=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT,c,l;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const y=typeof h?.versions?.electron=="string",E=y&&h?.type==="renderer";if(typeof navigator=="object"&&!E)l=navigator.userAgent,N=l.indexOf("Windows")>=0,T=l.indexOf("Macintosh")>=0,I=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=l.indexOf("Linux")>=0,S=l?.indexOf("Mobi")>=0,P=!0,u=L.getConfiguredDefaultLocale(L.localize(0,null))||e.LANGUAGE_DEFAULT,g=u,w=navigator.language;else if(typeof h=="object"){N=h.platform==="win32",T=h.platform==="darwin",A=h.platform==="linux",k=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,v=y,C=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.LANGUAGE_DEFAULT,g=e.LANGUAGE_DEFAULT;const p=h.env.VSCODE_NLS_CONFIG;if(p)try{const m=JSON.parse(p),d=m.availableLanguages["*"];u=m.locale,w=m.osLocale,g=d||e.LANGUAGE_DEFAULT,c=m._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var R;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(R||(e.Platform=R={}));function t(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let o=0;T?o=1:N?o=3:A&&(o=2),e.isWindows=N,e.isMacintosh=T,e.isLinux=A,e.isLinuxSnap=k,e.isNative=D,e.isElectron=v,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isMobile=S,e.isCI=C,e.platform=o,e.userAgent=l,e.language=g;var n;(function(p){function m(){return e.language}p.value=m;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}p.isDefaultVariant=d;function b(){return e.language==="en"}p.isDefault=b})(n||(e.Language=n={})),e.locale=u,e.platformLocale=w,e.translationsConfigFile=c,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const p=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let b=0,O=p.length;b<O;b++){const F=p[b];if(F.id===d.data.vscodeScheduleAsyncWork){p.splice(b,1),F.callback();return}}});let m=0;return d=>{const b=++m;p.push({id:b,callback:d}),e.globals.postMessage({vscodeScheduleAsyncWork:b},"*")}}return p=>setTimeout(p)})();var s;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=T||I?2:N?1:3;let i=!0,r=!1;function a(){if(!r){r=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,i=new Uint16Array(p.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[37],ae([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let N;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.process<"u"){const T=L.globals.vscode.process;N={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.platform=N.platform,e.arch=N.arch}),define(oe[16],ae([0,1,37]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const N=65,T=97,A=90,k=122,D=46,P=47,v=92,I=58,C=63;class S extends Error{constructor(o,n,s){let i;typeof n=="string"&&n.indexOf("not ")===0?(i="must not be",n=n.replace(/^not /,"")):i="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${i} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function u(t,o){if(t===null||typeof t!="object")throw new S(o,"Object",t)}function g(t,o){if(typeof t!="string")throw new S(o,"string",t)}const w=L.platform==="win32";function c(t){return t===P||t===v}function l(t){return t===P}function h(t){return t>=N&&t<=A||t>=T&&t<=k}function y(t,o,n,s){let i="",r=0,a=-1,p=0,m=0;for(let d=0;d<=t.length;++d){if(d<t.length)m=t.charCodeAt(d);else{if(s(m))break;m=P}if(s(m)){if(!(a===d-1||p===1))if(p===2){if(i.length<2||r!==2||i.charCodeAt(i.length-1)!==D||i.charCodeAt(i.length-2)!==D){if(i.length>2){const b=i.lastIndexOf(n);b===-1?(i="",r=0):(i=i.slice(0,b),r=i.length-1-i.lastIndexOf(n)),a=d,p=0;continue}else if(i.length!==0){i="",r=0,a=d,p=0;continue}}o&&(i+=i.length>0?`${n}..`:"..",r=2)}else i.length>0?i+=`${n}${t.slice(a+1,d)}`:i=t.slice(a+1,d),r=d-a-1;a=d,p=0}else m===D&&p!==-1?++p:p=-1}return i}function E(t,o){u(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${t}${s}`:s}e.win32={resolve(...t){let o="",n="",s=!1;for(let i=t.length-1;i>=-1;i--){let r;if(i>=0){if(r=t[i],g(r,"path"),r.length===0)continue}else o.length===0?r=L.cwd():(r=L.env[`=${o}`]||L.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===v)&&(r=`${o}\\`));const a=r.length;let p=0,m="",d=!1;const b=r.charCodeAt(0);if(a===1)c(b)&&(p=1,d=!0);else if(c(b))if(d=!0,c(r.charCodeAt(1))){let O=2,F=O;for(;O<a&&!c(r.charCodeAt(O));)O++;if(O<a&&O!==F){const M=r.slice(F,O);for(F=O;O<a&&c(r.charCodeAt(O));)O++;if(O<a&&O!==F){for(F=O;O<a&&!c(r.charCodeAt(O));)O++;(O===a||O!==F)&&(m=`\\\\${M}\\${r.slice(F,O)}`,p=O)}}}else p=1;else h(b)&&r.charCodeAt(1)===I&&(m=r.slice(0,2),p=2,a>2&&c(r.charCodeAt(2))&&(d=!0,p=3));if(m.length>0)if(o.length>0){if(m.toLowerCase()!==o.toLowerCase())continue}else o=m;if(s){if(o.length>0)break}else if(n=`${r.slice(p)}\\${n}`,s=d,d&&o.length>0)break}return n=y(n,!s,"\\",c),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(t){g(t,"path");const o=t.length;if(o===0)return".";let n=0,s,i=!1;const r=t.charCodeAt(0);if(o===1)return l(r)?"\\":t;if(c(r))if(i=!0,c(t.charCodeAt(1))){let p=2,m=p;for(;p<o&&!c(t.charCodeAt(p));)p++;if(p<o&&p!==m){const d=t.slice(m,p);for(m=p;p<o&&c(t.charCodeAt(p));)p++;if(p<o&&p!==m){for(m=p;p<o&&!c(t.charCodeAt(p));)p++;if(p===o)return`\\\\${d}\\${t.slice(m)}\\`;p!==m&&(s=`\\\\${d}\\${t.slice(m,p)}`,n=p)}}}else n=1;else h(r)&&t.charCodeAt(1)===I&&(s=t.slice(0,2),n=2,o>2&&c(t.charCodeAt(2))&&(i=!0,n=3));let a=n<o?y(t.slice(n),!i,"\\",c):"";return a.length===0&&!i&&(a="."),a.length>0&&c(t.charCodeAt(o-1))&&(a+="\\"),s===void 0?i?`\\${a}`:a:i?`${s}\\${a}`:`${s}${a}`},isAbsolute(t){g(t,"path");const o=t.length;if(o===0)return!1;const n=t.charCodeAt(0);return c(n)||o>2&&h(n)&&t.charCodeAt(1)===I&&c(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,n;for(let r=0;r<t.length;++r){const a=t[r];g(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,i=0;if(typeof n=="string"&&c(n.charCodeAt(0))){++i;const r=n.length;r>1&&c(n.charCodeAt(1))&&(++i,r>2&&(c(n.charCodeAt(2))?++i:s=!1))}if(s){for(;i<o.length&&c(o.charCodeAt(i));)i++;i>=2&&(o=`\\${o.slice(i)}`)}return e.win32.normalize(o)},relative(t,o){if(g(t,"from"),g(o,"to"),t===o)return"";const n=e.win32.resolve(t),s=e.win32.resolve(o);if(n===s||(t=n.toLowerCase(),o=s.toLowerCase(),t===o))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===v;)i++;let r=t.length;for(;r-1>i&&t.charCodeAt(r-1)===v;)r--;const a=r-i;let p=0;for(;p<o.length&&o.charCodeAt(p)===v;)p++;let m=o.length;for(;m-1>p&&o.charCodeAt(m-1)===v;)m--;const d=m-p,b=a<d?a:d;let O=-1,F=0;for(;F<b;F++){const q=t.charCodeAt(i+F);if(q!==o.charCodeAt(p+F))break;q===v&&(O=F)}if(F!==b){if(O===-1)return s}else{if(d>b){if(o.charCodeAt(p+F)===v)return s.slice(p+F+1);if(F===2)return s.slice(p+F)}a>b&&(t.charCodeAt(i+F)===v?O=F:F===2&&(O=3)),O===-1&&(O=0)}let M="";for(F=i+O+1;F<=r;++F)(F===r||t.charCodeAt(F)===v)&&(M+=M.length===0?"..":"\\..");return p+=O,M.length>0?`${M}${s.slice(p,m)}`:(s.charCodeAt(p)===v&&++p,s.slice(p,m))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.win32.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===v){if(o.charCodeAt(1)===v){const n=o.charCodeAt(2);if(n!==C&&n!==D)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(h(o.charCodeAt(0))&&o.charCodeAt(1)===I&&o.charCodeAt(2)===v)return`\\\\?\\${o}`;return t},dirname(t){g(t,"path");const o=t.length;if(o===0)return".";let n=-1,s=0;const i=t.charCodeAt(0);if(o===1)return c(i)?t:".";if(c(i)){if(n=s=1,c(t.charCodeAt(1))){let p=2,m=p;for(;p<o&&!c(t.charCodeAt(p));)p++;if(p<o&&p!==m){for(m=p;p<o&&c(t.charCodeAt(p));)p++;if(p<o&&p!==m){for(m=p;p<o&&!c(t.charCodeAt(p));)p++;if(p===o)return t;p!==m&&(n=s=p+1)}}}}else h(i)&&t.charCodeAt(1)===I&&(n=o>2&&c(t.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let p=o-1;p>=s;--p)if(c(t.charCodeAt(p))){if(!a){r=p;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return t.slice(0,r)},basename(t,o){o!==void 0&&g(o,"ext"),g(t,"path");let n=0,s=-1,i=!0,r;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===I&&(n=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let a=o.length-1,p=-1;for(r=t.length-1;r>=n;--r){const m=t.charCodeAt(r);if(c(m)){if(!i){n=r+1;break}}else p===-1&&(i=!1,p=r+1),a>=0&&(m===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=p))}return n===s?s=p:s===-1&&(s=t.length),t.slice(n,s)}for(r=t.length-1;r>=n;--r)if(c(t.charCodeAt(r))){if(!i){n=r+1;break}}else s===-1&&(i=!1,s=r+1);return s===-1?"":t.slice(n,s)},extname(t){g(t,"path");let o=0,n=-1,s=0,i=-1,r=!0,a=0;t.length>=2&&t.charCodeAt(1)===I&&h(t.charCodeAt(0))&&(o=s=2);for(let p=t.length-1;p>=o;--p){const m=t.charCodeAt(p);if(c(m)){if(!r){s=p+1;break}continue}i===-1&&(r=!1,i=p+1),m===D?n===-1?n=p:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||i===-1||a===0||a===1&&n===i-1&&n===s+1?"":t.slice(n,i)},format:E.bind(null,"\\"),parse(t){g(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.length;let s=0,i=t.charCodeAt(0);if(n===1)return c(i)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(c(i)){if(s=1,c(t.charCodeAt(1))){let O=2,F=O;for(;O<n&&!c(t.charCodeAt(O));)O++;if(O<n&&O!==F){for(F=O;O<n&&c(t.charCodeAt(O));)O++;if(O<n&&O!==F){for(F=O;O<n&&!c(t.charCodeAt(O));)O++;O===n?s=O:O!==F&&(s=O+1)}}}}else if(h(i)&&t.charCodeAt(1)===I){if(n<=2)return o.root=o.dir=t,o;if(s=2,c(t.charCodeAt(2))){if(n===3)return o.root=o.dir=t,o;s=3}}s>0&&(o.root=t.slice(0,s));let r=-1,a=s,p=-1,m=!0,d=t.length-1,b=0;for(;d>=s;--d){if(i=t.charCodeAt(d),c(i)){if(!m){a=d+1;break}continue}p===-1&&(m=!1,p=d+1),i===D?r===-1?r=d:b!==1&&(b=1):r!==-1&&(b=-1)}return p!==-1&&(r===-1||b===0||b===1&&r===p-1&&r===a+1?o.base=o.name=t.slice(a,p):(o.name=t.slice(a,r),o.base=t.slice(a,p),o.ext=t.slice(r,p))),a>0&&a!==s?o.dir=t.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const R=(()=>{if(w){const t=/\\/g;return()=>{const o=L.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>L.cwd()})();e.posix={resolve(...t){let o="",n=!1;for(let s=t.length-1;s>=-1&&!n;s--){const i=s>=0?t[s]:R();g(i,"path"),i.length!==0&&(o=`${i}/${o}`,n=i.charCodeAt(0)===P)}return o=y(o,!n,"/",l),n?`/${o}`:o.length>0?o:"."},normalize(t){if(g(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===P,n=t.charCodeAt(t.length-1)===P;return t=y(t,!o,"/",l),t.length===0?o?"/":n?"./":".":(n&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return g(t,"path"),t.length>0&&t.charCodeAt(0)===P},join(...t){if(t.length===0)return".";let o;for(let n=0;n<t.length;++n){const s=t[n];g(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.posix.normalize(o)},relative(t,o){if(g(t,"from"),g(o,"to"),t===o||(t=e.posix.resolve(t),o=e.posix.resolve(o),t===o))return"";const n=1,s=t.length,i=s-n,r=1,a=o.length-r,p=i<a?i:a;let m=-1,d=0;for(;d<p;d++){const O=t.charCodeAt(n+d);if(O!==o.charCodeAt(r+d))break;O===P&&(m=d)}if(d===p)if(a>p){if(o.charCodeAt(r+d)===P)return o.slice(r+d+1);if(d===0)return o.slice(r+d)}else i>p&&(t.charCodeAt(n+d)===P?m=d:d===0&&(m=0));let b="";for(d=n+m+1;d<=s;++d)(d===s||t.charCodeAt(d)===P)&&(b+=b.length===0?"..":"/..");return`${b}${o.slice(r+m)}`},toNamespacedPath(t){return t},dirname(t){if(g(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===P;let n=-1,s=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===P){if(!s){n=i;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":t.slice(0,n)},basename(t,o){o!==void 0&&g(o,"ext"),g(t,"path");let n=0,s=-1,i=!0,r;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let a=o.length-1,p=-1;for(r=t.length-1;r>=0;--r){const m=t.charCodeAt(r);if(m===P){if(!i){n=r+1;break}}else p===-1&&(i=!1,p=r+1),a>=0&&(m===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=p))}return n===s?s=p:s===-1&&(s=t.length),t.slice(n,s)}for(r=t.length-1;r>=0;--r)if(t.charCodeAt(r)===P){if(!i){n=r+1;break}}else s===-1&&(i=!1,s=r+1);return s===-1?"":t.slice(n,s)},extname(t){g(t,"path");let o=-1,n=0,s=-1,i=!0,r=0;for(let a=t.length-1;a>=0;--a){const p=t.charCodeAt(a);if(p===P){if(!i){n=a+1;break}continue}s===-1&&(i=!1,s=a+1),p===D?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":t.slice(o,s)},format:E.bind(null,"/"),parse(t){g(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.charCodeAt(0)===P;let s;n?(o.root="/",s=1):s=0;let i=-1,r=0,a=-1,p=!0,m=t.length-1,d=0;for(;m>=s;--m){const b=t.charCodeAt(m);if(b===P){if(!p){r=m+1;break}continue}a===-1&&(p=!1,a=m+1),b===D?i===-1?i=m:d!==1&&(d=1):i!==-1&&(d=-1)}if(a!==-1){const b=r===0&&n?1:r;i===-1||d===0||d===1&&i===a-1&&i===r+1?o.base=o.name=t.slice(b,a):(o.name=t.slice(b,i),o.base=t.slice(b,a),o.ext=t.slice(i,a))}return r>0?o.dir=t.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w?e.win32.normalize:e.posix.normalize,e.isAbsolute=w?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w?e.win32.join:e.posix.join,e.resolve=w?e.win32.resolve:e.posix.resolve,e.relative=w?e.win32.relative:e.posix.relative,e.dirname=w?e.win32.dirname:e.posix.dirname,e.basename=w?e.win32.basename:e.posix.basename,e.extname=w?e.win32.extname:e.posix.extname,e.format=w?e.win32.format:e.posix.format,e.parse=w?e.win32.parse:e.posix.parse,e.toNamespacedPath=w?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w?e.win32.sep:e.posix.sep,e.delimiter=w?e.win32.delimiter:e.posix.delimiter}),define(oe[48],ae([0,1,16,5,27,11]),function(te,e,L,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function D(r){return r.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=D;function P(r){return r.indexOf("/")===-1&&(r=D(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=P;function v(r,a=L.posix.sep){if(!r)return"";const p=r.length,m=r.charCodeAt(0);if(k(m)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let b=3;const O=b;for(;b<p&&!k(r.charCodeAt(b));b++);if(O!==b&&!k(r.charCodeAt(b+1))){for(b+=1;b<p;b++)if(k(r.charCodeAt(b)))return r.slice(0,b+1).replace(/[\\/]/g,a)}}return a}else if(l(m)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let d=r.indexOf("://");if(d!==-1){for(d+=3;d<p;d++)if(k(r.charCodeAt(d)))return r.slice(0,d+1)}return""}e.getRoot=v;function I(r){if(!N.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let p=2;const m=p;for(;p<r.length&&(a=r.charCodeAt(p),a!==92);p++);return!(m===p||(a=r.charCodeAt(p+1),isNaN(a)||a===92))}e.isUNC=I;const C=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,a=N.isWindows){const p=a?C:S;return!(!r||r.length===0||/^\s+$/.test(r)||(p.lastIndex=0,p.test(r))||a&&u.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=g;function w(r,a,p){const m=r===a;return!p||m?m:!r||!a?!1:(0,T.equalsIgnoreCase)(r,a)}e.isEqual=w;function c(r,a,p,m=L.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(p){if(!(0,T.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let b=a.length;return a.charAt(a.length-1)===m&&b--,r.charAt(b)===m}return a.charAt(a.length-1)!==m&&(a+=m),r.indexOf(a)===0}e.isEqualOrParent=c;function l(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=l;function h(r,a){return N.isWindows&&r.endsWith(":")&&(r+=L.sep),(0,L.isAbsolute)(r)||(r=(0,L.join)(a,r)),r=(0,L.normalize)(r),N.isWindows?(r=(0,T.rtrim)(r,L.sep),r.endsWith(":")&&(r+=L.sep)):(r=(0,T.rtrim)(r,L.sep),r||(r=L.sep)),r}e.sanitizeFilePath=h;function y(r){const a=(0,L.normalize)(r);return N.isWindows?r.length>3?!1:E(a)&&(r.length===2||a.charCodeAt(2)===92):a===L.posix.sep}e.isRootOrDriveLetter=y;function E(r,a=N.isWindows){return a?l(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function R(r,a=N.isWindows){return E(r,a)?r[0]:void 0}e.getDriveLetter=R;function t(r,a,p){return a.length>r.length?-1:r===a?0:(p&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=t;function o(r){const a=r.split(":");let p,m,d;for(const b of a){const O=Number(b);(0,A.isNumber)(O)?m===void 0?m=O:d===void 0&&(d=O):p=p?[p,b].join(":"):b}if(!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:m!==void 0?m:void 0,column:d!==void 0?d:m!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(r,a,p=8){let m="";for(let b=0;b<p;b++){let O;b===0&&N.isWindows&&!a&&(p===3||p===4)?O=s:O=n,m+=O.charAt(Math.floor(Math.random()*O.length))}let d;return a?d=`${a}-${m}`:d=m,r?(0,L.join)(r,d):d}e.randomPath=i}),define(oe[137],ae([0,1,16]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(I){const C=(0,L.extname)(I),S=N[C.toLowerCase()];return S!==void 0?S:k(I)}e.getMediaOrTextMime=A;function k(I){const C=(0,L.extname)(I);return T[C.toLowerCase()]}e.getMediaMime=k;function D(I){for(const C in T)if(T[C]===I)return C}e.getExtensionForMimeType=D;const P=/^(.+)\/(.+?)(;.+)?$/;function v(I,C){const S=P.exec(I);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:C?void 0:I}e.normalizeMimeType=v}),define(oe[89],ae([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var N;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(N||(e.Source=N={}));var T;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(T||(e.TerminateResponseCode=T={}));function A(D,...P){const v=P.reduce((S,u)=>(S[u]=!0,S),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(S=>!v[S]).forEach(S=>{for(let u=0;u<I.length;u++)if(S.search(I[u])!==-1){delete D[S];break}})}e.sanitizeProcessEnvironment=A;function k(D){D&&(delete D.DEBUG,L.isMacintosh&&delete D.DYLD_LIBRARY_PATH,L.isLinux&&delete D.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),define(oe[10],ae([0,1,16,5]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,A=/^\//,k=/^\/\//;function D(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!T.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(s,i){return!s&&!i?"file":s}function v(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const I="",C="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(i){return i instanceof u?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,r,a,p,m,d=!1){typeof i=="object"?(this.scheme=i.scheme||I,this.authority=i.authority||I,this.path=i.path||I,this.query=i.query||I,this.fragment=i.fragment||I):(this.scheme=P(i,d),this.authority=r||I,this.path=v(this.scheme,a||I),this.query=p||I,this.fragment=m||I,D(this,d))}get fsPath(){return E(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:a,path:p,query:m,fragment:d}=i;return r===void 0?r=this.scheme:r===null&&(r=I),a===void 0?a=this.authority:a===null&&(a=I),p===void 0?p=this.path:p===null&&(p=I),m===void 0?m=this.query:m===null&&(m=I),d===void 0?d=this.fragment:d===null&&(d=I),r===this.scheme&&a===this.authority&&p===this.path&&m===this.query&&d===this.fragment?this:new c(r,a,p,m,d)}static parse(i,r=!1){const a=S.exec(i);return a?new c(a[2]||I,n(a[4]||I),n(a[5]||I),n(a[7]||I),n(a[9]||I),r):new c(I,I,I,I,I)}static file(i){let r=I;if(N.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const a=i.indexOf(C,2);a===-1?(r=i.substring(2),i=C):(r=i.substring(2,a),i=i.substring(a)||C)}return new c("file",r,i,I,I)}static from(i,r){return new c(i.scheme,i.authority,i.path,i.query,i.fragment,r)}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.isWindows&&i.scheme==="file"?a=u.file(L.win32.join(E(i,!0),...r)).path:a=L.posix.join(i.path,...r),i.with({path:a})}toString(i=!1){return R(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof u)return i;{const r=new c(i);return r._formatted=i.external??null,r._fsPath=i._sep===w?i.fsPath??null:null,r}}else return i}}e.URI=u;function g(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.isUriComponents=g;const w=N.isWindows?1:void 0;class c extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(i=!1){return i?R(this,!0):(this._formatted||(this._formatted=R(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=w),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const l={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(s,i,r){let a,p=-1;for(let m=0;m<s.length;m++){const d=s.charCodeAt(m);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||i&&d===47||r&&d===91||r&&d===93||r&&d===58)p!==-1&&(a+=encodeURIComponent(s.substring(p,m)),p=-1),a!==void 0&&(a+=s.charAt(m));else{a===void 0&&(a=s.substr(0,m));const b=l[d];b!==void 0?(p!==-1&&(a+=encodeURIComponent(s.substring(p,m)),p=-1),a+=b):p===-1&&(p=m)}}return p!==-1&&(a+=encodeURIComponent(s.substring(p))),a!==void 0?a:s}function y(s){let i;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(i===void 0&&(i=s.substr(0,r)),i+=l[a]):i!==void 0&&(i+=s[r])}return i!==void 0?i:s}function E(s,i){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,N.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=E;function R(s,i){const r=i?y:h;let a="",{scheme:p,authority:m,path:d,query:b,fragment:O}=s;if(p&&(a+=p,a+=":"),(m||p==="file")&&(a+=C,a+=C),m){let F=m.indexOf("@");if(F!==-1){const M=m.substr(0,F);m=m.substr(F+1),F=M.lastIndexOf(":"),F===-1?a+=r(M,!1,!1):(a+=r(M.substr(0,F),!1,!1),a+=":",a+=r(M.substr(F+1),!1,!0)),a+="@"}m=m.toLowerCase(),F=m.lastIndexOf(":"),F===-1?a+=r(m,!1,!0):(a+=r(m.substr(0,F),!1,!0),a+=m.substr(F))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const F=d.charCodeAt(1);F>=65&&F<=90&&(d=`/${String.fromCharCode(F+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const F=d.charCodeAt(0);F>=65&&F<=90&&(d=`${String.fromCharCode(F+32)}:${d.substr(2)}`)}a+=r(d,!0,!1)}return b&&(a+="?",a+=r(b,!1,!1)),O&&(a+="#",a+=i?O:h(O,!1,!1)),a}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,i=>t(i)):s}}),define(oe[138],ae([0,1,10]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function N(v){const I=v;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=N;function T(v){const I=[];let C;try{const S=JSON.parse(v.arguments),u=S[S.length-1];u&&u.__$stack&&(S.pop(),C=u.__$stack),I.push(...S)}catch{I.push("Unable to log remote console arguments",v.arguments)}return{args:I,stack:C}}e.parse=T;function A(v){if(typeof v!="string")return A(T(v).stack);const I=v;if(I){const C=k(I),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(S&&S.length===4)return{uri:L.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=A;function k(v){if(!v)return v;const I=v.indexOf(`
`);return I===-1?v:v.substring(0,I)}function D(v,I){const{args:C,stack:S}=T(v),u=typeof C[0]=="string"&&C.length===1;let g=k(S);g&&(g=`(${g.trim()})`);let w=[];if(typeof C[0]=="string"?g&&u?w=[`%c[${I}] %c${C[0]} %c${g}`,P("blue"),P(""),P("grey")]:w=[`%c[${I}] %c${C[0]}`,P("blue"),P(""),...C.slice(1)]:w=[`%c[${I}]%`,P("blue"),...C],g&&!u&&w.push(g),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,w)}e.log=D;function P(v){return`color: ${v}`}}),define(oe[62],ae([0,1,14,27,10]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(v){return JSON.stringify(v,D)}e.stringify=A;function k(v){let I=JSON.parse(v);return I=P(I),I}e.parse=k;function D(v,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,N.regExpFlags)(I)}:I}function P(v,I=0){if(!v||I>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return T.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 16:return new Date(v.source)}if(v instanceof L.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let C=0;C<v.length;++C)v[C]=P(v[C],I+1);else for(const C in v)Object.hasOwnProperty.call(v,C)&&(v[C]=P(v[C],I+1))}return v}e.revive=P}),define(oe[26],ae([0,1,7,5,10]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(I){this._preferredWebSchema=I}setDelegate(I){this._delegate=I}setServerRootPath(I){this._remoteResourcesPath=`${I}/${A.vscodeRemoteResource}`}set(I,C,S){this._hosts[I]=C,this._ports[I]=S}setConnectionToken(I,C){this._connectionTokens[I]=C}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(I){if(this._delegate)try{return this._delegate(I)}catch(c){return L.onUnexpectedError(c),I}const C=I.authority;let S=this._hosts[C];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const u=this._ports[C],g=this._connectionTokens[C];let w=`path=${encodeURIComponent(I.path)}`;return typeof g=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),T.URI.from({scheme:N.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${S}:${u}`,path:this._remoteResourcesPath,query:w})}}e.RemoteAuthorities=new k,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class D{static{this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(I){const C=this.toUri(I,te);return this.uriToBrowserUri(C)}uriToBrowserUri(I){return I.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===A.file&&(N.isNative||N.isWebWorker&&N.globals.origin===`${A.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?I.with({scheme:A.vscodeFileResource,authority:I.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(I){const C=this.toUri(I,te);return this.uriToFileUri(C)}uriToFileUri(I){return I.scheme===A.vscodeFileResource?I.with({scheme:A.file,authority:I.authority!==D.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(I,C){return T.URI.isUri(I)?I:T.URI.parse(C.toUrl(I))}}e.FileAccess=new D;var P;(function(v){const I=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(I.get("3"));const C="vscode-coi";function S(g){let w;typeof g=="string"?w=new URL(g).searchParams:g instanceof URL?w=g.searchParams:T.URI.isUri(g)&&(w=new URL(g.toString(!0)).searchParams);const c=w?.get(C);if(c)return I.get(c)}v.getHeadersFromQuery=S;function u(g,w,c){if(!globalThis.crossOriginIsolated)return;const l=w&&c?"3":c?"2":"1";g instanceof URLSearchParams?g.set(C,l):g[C]=l}v.addSearchParam=u})(P||(e.COI=P={}))}),define(oe[139],ae([0,1,122,26,5,10]),function(te,e,L,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class k{constructor(S,u,g){this.id=S,this.dependencies=u,this.callback=g}}class D{static{this.INSTANCE=new D}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(S,u,g)=>{typeof S!="string"&&(g=u,u=S,S=null),(typeof u!="object"||!Array.isArray(u))&&(g=u,u=null),this._defineCalls.push(new k(S,u,g))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(S){if(S.startsWith(window.location.origin)||S.startsWith("vscode-file://vscode-app"))return S;throw new Error(`[trusted_script_src] Invalid script url: ${S}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(S){return S}})))}async load(S){this._initialize();const u=await(this._isWebWorker?this._workerLoadScript(S):this._isRenderer?this._rendererLoadScript(S):this._nodeJSLoadScript(S));if(!u)throw new Error(`Did not receive a define call from script ${S}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${S}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}_rendererLoadScript(S){return new Promise((u,g)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const c=()=>{w.removeEventListener("load",l),w.removeEventListener("error",h)},l=y=>{c(),u(this._defineCalls.pop())},h=y=>{c(),g(y)};w.addEventListener("load",l),w.addEventListener("error",h),this._amdPolicy&&(S=this._amdPolicy.createScriptURL(S)),w.setAttribute("src",S),document.getElementsByTagName("head")[0].appendChild(w)})}_workerLoadScript(S){return new Promise((u,g)=>{try{this._amdPolicy&&(S=this._amdPolicy.createScriptURL(S)),importScripts(S),u(this._defineCalls.pop())}catch(w){g(w)}})}async _nodeJSLoadScript(S){try{const u=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,c=A.URI.parse(S).fsPath,l=u.readFileSync(c).toString(),h=w.wrap(l.replace(/^#!.*/,""));return new g.Script(h).runInThisContext().apply(),this._defineCalls.pop()}catch(u){throw u}}}const P=new Map;let v={};typeof globalThis.require=="object"&&(v=globalThis.require.paths??{});async function I(C,S,u){if(L.isESM){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),v[C]&&(C=v[C]);const g=`${C}/${S}`;if(P.has(g))return P.get(g);let w;if(/^\w[\w\d+.-]*:\/\//.test(g))w=g;else{const y=`${u&&!T.isWeb?N.nodeModulesAsarPath:N.nodeModulesPath}/${g}`;w=N.FileAccess.asBrowserUri(y).toString(!0)}const c=D.INSTANCE.load(w);return P.set(g,c),c}else return await new Promise((g,w)=>{te([C],g,w)})}e.importAMDNodeModule=I}),define(oe[22],ae([0,1,48,26,16,5,27,10]),function(te,e,L,N,T,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function P(u){return(0,D.uriToFsPath)(u,!0)}e.originalFSPath=P;class v{constructor(g){this._ignorePathCasing=g}compare(g,w,c=!1){return g===w?0:(0,k.compare)(this.getComparisonKey(g,c),this.getComparisonKey(w,c))}isEqual(g,w,c=!1){return g===w?!0:!g||!w?!1:this.getComparisonKey(g,c)===this.getComparisonKey(w,c)}getComparisonKey(g,w=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,w,c=!1){if(g.scheme===w.scheme){if(g.scheme===N.Schemas.file)return L.isEqualOrParent(P(g),P(w),this._ignorePathCasing(g))&&g.query===w.query&&(c||g.fragment===w.fragment);if((0,e.isEqualAuthority)(g.authority,w.authority))return L.isEqualOrParent(g.path,w.path,this._ignorePathCasing(g),"/")&&g.query===w.query&&(c||g.fragment===w.fragment)}return!1}joinPath(g,...w){return D.URI.joinPath(g,...w)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return T.posix.basename(g.path)}extname(g){return T.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let w;return g.scheme===N.Schemas.file?w=D.URI.file(T.dirname(P(g))).path:(w=T.posix.dirname(g.path),g.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),w="/")),g.with({path:w})}normalizePath(g){if(!g.path.length)return g;let w;return g.scheme===N.Schemas.file?w=D.URI.file(T.normalize(P(g))).path:w=T.posix.normalize(g.path),g.with({path:w})}relativePath(g,w){if(g.scheme!==w.scheme||!(0,e.isEqualAuthority)(g.authority,w.authority))return;if(g.scheme===N.Schemas.file){const h=T.relative(P(g),P(w));return A.isWindows?L.toSlashes(h):h}let c=g.path||"/";const l=w.path||"/";if(this._ignorePathCasing(g)){let h=0;for(const y=Math.min(c.length,l.length);h<y&&!(c.charCodeAt(h)!==l.charCodeAt(h)&&c.charAt(h).toLowerCase()!==l.charAt(h).toLowerCase());h++);c=l.substr(0,h)+c.substr(h)}return T.posix.relative(c,l)}resolvePath(g,w){if(g.scheme===N.Schemas.file){const c=D.URI.file(T.resolve(P(g),w));return g.with({authority:c.authority,path:c.path})}return w=L.toPosixPath(w),g.with({path:T.posix.resolve(g.path,w)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,w){return g===w||g!==void 0&&w!==void 0&&(0,k.equalsIgnoreCase)(g,w)}hasTrailingPathSeparator(g,w=T.sep){if(g.scheme===N.Schemas.file){const c=P(g);return c.length>L.getRoot(c).length&&c[c.length-1]===w}else{const c=g.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,w=T.sep){return(0,e.hasTrailingPathSeparator)(g,w)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,w=T.sep){let c=!1;if(g.scheme===N.Schemas.file){const l=P(g);c=l!==void 0&&l.length===L.getRoot(l).length&&l[l.length-1]===w}else{w="/";const l=g.path;c=l.length===1&&l.charCodeAt(l.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(g,w)?g.with({path:g.path+"/"}):g}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(u=>u.scheme===N.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new v(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(u,g){const w=[];for(let c=0;c<u.length;c++){const l=g(u[c]);u.some((h,y)=>y===c?!1:(0,e.isEqualOrParent)(l,g(h)))||w.push(u[c])}return w}e.distinctParents=I;var C;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function g(w){const c=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(y=>{const[E,R]=y.split(":");E&&R&&c.set(E,R)});const h=w.path.substring(0,w.path.indexOf(";"));return h&&c.set(u.META_DATA_MIME,h),c}u.parseMetaData=g})(C||(e.DataUri=C={}));function S(u,g,w){if(g){let c=u.path;return c&&c[0]!==T.posix.sep&&(c=T.posix.sep+c),u.with({scheme:w,authority:g,path:c})}return u.with({scheme:w})}e.toLocalResource=S}),define(oe[6],ae([0,1,25,7,3,2,22,5,126]),function(te,e,L,N,T,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(U){return!!U&&typeof U.then=="function"}e.isThenable=v;function I(U){const f=new L.CancellationTokenSource,_=U(f.token),$=new Promise((H,W)=>{const K=f.token.onCancellationRequested(()=>{K.dispose(),f.dispose(),W(new N.CancellationError)});Promise.resolve(_).then(Z=>{K.dispose(),f.dispose(),H(Z)},Z=>{K.dispose(),f.dispose(),W(Z)})});return new class{cancel(){f.cancel()}then(H,W){return $.then(H,W)}catch(H){return this.then(void 0,H)}finally(H){return $.finally(H)}}}e.createCancelablePromise=I;function C(U,f,_){return new Promise(($,H)=>{const W=f.onCancellationRequested(()=>{W.dispose(),$(_)});U.then($,H).finally(()=>W.dispose())})}e.raceCancellation=C;function S(U,f){return new Promise((_,$)=>{const H=f.onCancellationRequested(()=>{H.dispose(),$(new N.CancellationError)});U.then(_,$).finally(()=>H.dispose())})}e.raceCancellationError=S;async function u(U){let f=-1;const _=U.map(($,H)=>$.then(W=>(f=H,W)));try{return await Promise.race(_)}finally{U.forEach(($,H)=>{H!==f&&$.cancel()})}}e.raceCancellablePromises=u;function g(U,f,_){let $;const H=setTimeout(()=>{$?.(void 0),_?.()},f);return Promise.race([U.finally(()=>clearTimeout(H)),new Promise(W=>$=W)])}e.raceTimeout=g;function w(U){return new Promise((f,_)=>{const $=U();v($)?$.then(f,_):f($)})}e.asPromise=w;class c{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(f){if(this.isDisposed)throw new Error("Throttler is disposed");if(this.activePromise){if(this.queuedPromiseFactory=f,!this.queuedPromise){const _=()=>{if(this.queuedPromise=null,this.isDisposed)return;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(_,_).then($)})}return new Promise((_,$)=>{this.queuedPromise.then(_,$)})}return this.activePromise=f(),new Promise((_,$)=>{this.activePromise.then(H=>{this.activePromise=null,_(H)},H=>{this.activePromise=null,$(H)})})}dispose(){this.isDisposed=!0}}e.Throttler=c;class l{constructor(){this.current=Promise.resolve(null)}queue(f){return this.current=this.current.then(()=>f(),()=>f())}}e.Sequencer=l;class h{constructor(){this.promiseMap=new Map}queue(f,_){const H=(this.promiseMap.get(f)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.promiseMap.get(f)===H&&this.promiseMap.delete(f)});return this.promiseMap.set(f,H),H}}e.SequencerByKey=h;const y=(U,f)=>{let _=!0;const $=setTimeout(()=>{_=!1,f()},U);return{isTriggered:()=>_,dispose:()=>{clearTimeout($),_=!1}}},E=U=>{let f=!0;return queueMicrotask(()=>{f&&(f=!1,U())}),{isTriggered:()=>f,dispose:()=>{f=!1}}};class R{constructor(f){this.defaultDelay=f,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(f,_=this.defaultDelay){this.task=f,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((H,W)=>{this.doResolve=H,this.doReject=W}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const H=this.task;return this.task=null,H()}}));const $=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=_===P.MicrotaskDelay?E($):y(_,$),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new N.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=R;class t{constructor(f){this.delayer=new R(f),this.throttler=new c}trigger(f,_){return this.delayer.trigger(()=>this.throttler.queue(f),_)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=t;class o{constructor(){this._isOpen=!1,this._promise=new Promise((f,_)=>{this._completePromise=f})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class n extends o{constructor(f){super(),this._timeout=setTimeout(()=>this.open(),f)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=n;function s(U,f){return f?new Promise((_,$)=>{const H=setTimeout(()=>{W.dispose(),_()},U),W=f.onCancellationRequested(()=>{clearTimeout(H),W.dispose(),$(new N.CancellationError)})}):I(_=>s(U,_))}e.timeout=s;function i(U,f=0){const _=setTimeout(U,f);return(0,A.toDisposable)(()=>clearTimeout(_))}e.disposableTimeout=i;function r(U){const f=[];let _=0;const $=U.length;function H(){return _<$?U[_++]():null}function W(K){K!=null&&f.push(K);const Z=H();return Z?Z.then(W):Promise.resolve(f)}return Promise.resolve(null).then(W)}e.sequence=r;function a(U,f=$=>!!$,_=null){let $=0;const H=U.length,W=()=>{if($>=H)return Promise.resolve(_);const K=U[$++];return Promise.resolve(K()).then(se=>f(se)?Promise.resolve(se):W())};return W()}e.first=a;function p(U,f=$=>!!$,_=null){if(U.length===0)return Promise.resolve(_);let $=U.length;const H=()=>{$=-1;for(const W of U)W.cancel?.()};return new Promise((W,K)=>{for(const Z of U)Z.then(se=>{--$>=0&&f(se)?(H(),W(se)):$===0&&W(_)}).catch(se=>{--$>=0&&(H(),K(se))})})}e.firstParallel=p;class m{constructor(f){this._size=0,this.maxDegreeOfParalellism=f,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new T.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(f){return this._size++,new Promise((_,$)=>{this.outstandingPromises.push({factory:f,c:_,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const f=this.outstandingPromises.shift();this.runningPromises++;const _=f.factory();_.then(f.c,f.e),_.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=m;class d extends m{constructor(){super(1)}}e.Queue=d;class b{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const f=new x;return this.drainers.add(f),f.p}isDrained(){for(const[,f]of this.queues)if(f.size>0)return!1;return!0}queueFor(f,_=k.extUri){const $=_.getComparisonKey(f);let H=this.queues.get($);return H||(H=new d,T.Event.once(H.onDrained)(()=>{H?.dispose(),this.queues.delete($),this.onDidQueueDrain()}),this.queues.set($,H)),H}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const f of this.drainers)f.complete();this.drainers.clear()}dispose(){for(const[,f]of this.queues)f.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=b;class O{constructor(f,_){this._token=-1,typeof f=="function"&&typeof _=="number"&&this.setIfNotSet(f,_)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(f,_){this.cancel(),this._token=setTimeout(()=>{this._token=-1,f()},_)}setIfNotSet(f,_){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,f()},_))}}e.TimeoutTimer=O;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(f,_){this.cancel(),this._token=setInterval(()=>{f()},_)}}e.IntervalTimer=F;class M{constructor(f,_){this.timeoutToken=-1,this.runner=f,this.timeout=_,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(f=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,f)}get delay(){return this.timeout}set delay(f){this.timeout=f}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=M;class q{constructor(f,_){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.runner=f,this.timeout=_,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(f=this.timeout){f%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${f}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(f/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=q;class j extends M{constructor(f,_){super(f,_),this.units=[]}work(f){this.units.push(f),this.isScheduled()||this.schedule()}doRun(){const f=this.units;this.units=[],this.runner?.(f)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=j;class B extends A.Disposable{constructor(f,_){super(),this.options=f,this.handler=_,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(f){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+f.length>this.options.maxBufferedWork)return!1}else if(this.pending+f.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const _ of f)this.pendingWork.push(_);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=U=>{(0,D.setTimeout0)(()=>{if(f)return;const _=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,_-Date.now())}}))});let f=!1;return{dispose(){f||(f=!0)}}}:e.runWhenIdle=(U,f)=>{const _=requestIdleCallback(U,typeof f=="number"?{timeout:f}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(_))}}}}();class Q{constructor(f){this._didRun=!1,this._executor=()=>{try{this._value=f()}catch(_){this._error=_}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=Q;async function J(U,f,_){let $;for(let H=0;H<_;H++)try{return await U()}catch(W){$=W,await s(f)}throw $}e.retry=J;class G{hasPending(f){return this._pending?typeof f=="number"?this._pending.taskId===f:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(f,_,$){return this._pending={taskId:f,cancel:()=>$?.(),promise:_},_.then(()=>this.donePending(f),()=>this.donePending(f)),_}donePending(f){this._pending&&f===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const f=this._next;this._next=void 0,f.run().then(f.promiseResolve,f.promiseReject)}}setNext(f){if(this._next)this._next.run=f;else{let _,$;const H=new Promise((W,K)=>{_=W,$=K});this._next={run:f,promise:H,promiseResolve:_,promiseReject:$}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=G;class X{constructor(f,_=()=>Date.now()){this.interval=f,this.nowFn=_,this.lastIncrementTime=0,this.value=0}increment(){const f=this.nowFn();return f-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=f,this.value=0),this.value++,this.value}}e.IntervalCounter=X;var V;(function(U){U[U.Resolved=0]="Resolved",U[U.Rejected=1]="Rejected"})(V||(V={}));class x{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((f,_)=>{this.completeCallback=f,this.errorCallback=_})}complete(f){return new Promise(_=>{this.completeCallback(f),this.outcome={outcome:0,value:f},_()})}error(f){return new Promise(_=>{this.errorCallback(f),this.outcome={outcome:1,value:f},_()})}cancel(){return this.error(new N.CancellationError)}}e.DeferredPromise=x;var z;(function(U){async function f($){let H;const W=await Promise.all($.map(K=>K.then(Z=>Z,Z=>{H||(H=Z)})));if(typeof H<"u")throw H;return W}U.settled=f;function _($){return new Promise(async(H,W)=>{try{await $(H,W)}catch(K){W(K)}})}U.withAsyncBody=_})(z||(e.Promises=z={}));var ee;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(ee||(ee={}));class ne{static fromArray(f){return new ne(_=>{_.emitMany(f)})}static fromPromise(f){return new ne(async _=>{_.emitMany(await f)})}static fromPromises(f){return new ne(async _=>{await Promise.all(f.map(async $=>_.emitOne(await $)))})}static merge(f){return new ne(async _=>{await Promise.all(f.map(async $=>{for await(const H of $)_.emitOne(H)}))})}static{this.EMPTY=ne.fromArray([])}constructor(f){this._state=0,this._results=[],this._error=null,this._onStateChanged=new T.Emitter,queueMicrotask(async()=>{const _={emitOne:$=>this.emitOne($),emitMany:$=>this.emitMany($),reject:$=>this.reject($)};try{await Promise.resolve(f(_)),this.resolve()}catch($){this.reject($)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}[Symbol.asyncIterator](){let f=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(f<this._results.length)return{done:!1,value:this._results[f++]};if(this._state===1)return{done:!0,value:void 0};await T.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(f,_){return new ne(async $=>{for await(const H of f)$.emitOne(_(H))})}map(f){return ne.map(this,f)}static filter(f,_){return new ne(async $=>{for await(const H of f)_(H)&&$.emitOne(H)})}filter(f){return ne.filter(this,f)}static coalesce(f){return ne.filter(f,_=>!!_)}coalesce(){return ne.coalesce(this)}static async toPromise(f){const _=[];for await(const $ of f)_.push($);return _}toPromise(){return ne.toPromise(this)}emitOne(f){this._state===0&&(this._results.push(f),this._onStateChanged.fire())}emitMany(f){this._state===0&&(this._results=this._results.concat(f),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(f){this._state===0&&(this._state=2,this._error=f,this._onStateChanged.fire())}}e.AsyncIterableObject=ne;class ce extends ne{constructor(f,_){super(_),this._source=f}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function re(U){const f=new L.CancellationTokenSource,_=U(f.token);return new ce(f,async $=>{const H=f.token.onCancellationRequested(()=>{H.dispose(),f.dispose(),$.reject(new N.CancellationError)});try{for await(const W of _){if(f.token.isCancellationRequested)return;$.emitOne(W)}H.dispose(),f.dispose()}catch(W){H.dispose(),f.dispose(),$.reject(W)}})}e.createCancelableAsyncIterable=re}),define(oe[90],ae([0,1,21,6,48,35,16,5,27]),function(te,e,L,N,T,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function v(){return Object.create(null)}e.getEmptyExpression=v,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",C="[^/\\\\]",S=/\//g;function u(X,V){switch(X){case 0:return"";case 1:return`${C}*?`;default:return`(?:${I}|${C}+${I}${V?`|${I}${C}+`:""})*?`}}function g(X,V){if(!X)return[];const x=[];let z=!1,ee=!1,ne="";for(const ce of X){switch(ce){case V:if(!z&&!ee){x.push(ne),ne="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}ne+=ce}return ne&&x.push(ne),x}e.splitGlobAware=g;function w(X){if(!X)return"";let V="";const x=g(X,e.GLOB_SPLIT);if(x.every(z=>z===e.GLOBSTAR))V=".*";else{let z=!1;x.forEach((ee,ne)=>{if(ee===e.GLOBSTAR){if(z)return;V+=u(2,ne===x.length-1)}else{let ce=!1,re="",U=!1,f="";for(const _ of ee){if(_!=="}"&&ce){re+=_;continue}if(U&&(_!=="]"||!f)){let $;_==="-"?$=_:(_==="^"||_==="!")&&!f?$="^":_===e.GLOB_SPLIT?$="":$=(0,P.escapeRegExpCharacters)(_),f+=$;continue}switch(_){case"{":ce=!0;continue;case"[":U=!0;continue;case"}":{const H=`(?:${g(re,",").map(W=>w(W)).join("|")})`;V+=H,ce=!1,re="";break}case"]":{V+="["+f+"]",U=!1,f="";break}case"?":V+=C;continue;case"*":V+=u(1);continue;default:V+=(0,P.escapeRegExpCharacters)(_)}}ne<x.length-1&&(x[ne+1]!==e.GLOBSTAR||ne+2<x.length)&&(V+=I)}z=ee===e.GLOBSTAR})}return V}const c=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,R=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),o=function(){return!1},n=function(){return null};function s(X,V){if(!X)return n;let x;typeof X!="string"?x=X.pattern:x=X,x=x.trim();const z=`${x}_${!!V.trimForExclusions}`;let ee=t.get(z);if(ee)return i(ee,X);let ne;return c.test(x)?ee=a(x.substr(4),x):(ne=l.exec(r(x,V)))?ee=p(ne[1],x):(V.trimForExclusions?y:h).test(x)?ee=m(x,V):(ne=E.exec(r(x,V)))?ee=d(ne[1].substr(1),x,!0):(ne=R.exec(r(x,V)))?ee=d(ne[1],x,!1):ee=b(x),t.set(z,ee),i(ee,X)}function i(X,V){if(typeof V=="string")return X;const x=function(z,ee){return(0,T.isEqualOrParent)(z,V.base,!D.isLinux)?X((0,P.ltrim)(z.substr(V.base.length),k.sep),ee):null};return x.allBasenames=X.allBasenames,x.allPaths=X.allPaths,x.basenames=X.basenames,x.patterns=X.patterns,x}function r(X,V){return V.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function a(X,V){return function(x,z){return typeof x=="string"&&x.endsWith(X)?V:null}}function p(X,V){const x=`/${X}`,z=`\\${X}`,ee=function(ce,re){return typeof ce!="string"?null:re?re===X?V:null:ce===X||ce.endsWith(x)||ce.endsWith(z)?V:null},ne=[X];return ee.basenames=ne,ee.patterns=[V],ee.allBasenames=ne,ee}function m(X,V){const x=J(X.slice(1,-1).split(",").map(re=>s(re,V)).filter(re=>re!==n),X),z=x.length;if(!z)return n;if(z===1)return x[0];const ee=function(re,U){for(let f=0,_=x.length;f<_;f++)if(x[f](re,U))return X;return null},ne=x.find(re=>!!re.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const ce=x.reduce((re,U)=>U.allPaths?re.concat(U.allPaths):re,[]);return ce.length&&(ee.allPaths=ce),ee}function d(X,V,x){const z=k.sep===k.posix.sep,ee=z?X:X.replace(S,k.sep),ne=k.sep+ee,ce=k.posix.sep+X;let re;return x?re=function(U,f){return typeof U=="string"&&(U===ee||U.endsWith(ne)||!z&&(U===X||U.endsWith(ce)))?V:null}:re=function(U,f){return typeof U=="string"&&(U===ee||!z&&U===X)?V:null},re.allPaths=[(x?"*/":"./")+X],re}function b(X){try{const V=new RegExp(`^${w(X)}$`);return function(x){return V.lastIndex=0,typeof x=="string"&&V.test(x)?X:null}}catch{return n}}function O(X,V,x){return!X||typeof V!="string"?!1:F(X)(V,void 0,x)}e.match=O;function F(X,V={}){if(!X)return o;if(typeof X=="string"||M(X)){const x=s(X,V);if(x===n)return o;const z=function(ee,ne){return!!x(ee,ne)};return x.allBasenames&&(z.allBasenames=x.allBasenames),x.allPaths&&(z.allPaths=x.allPaths),z}return B(X,V)}e.parse=F;function M(X){const V=X;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=M;function q(X){return X.allBasenames||[]}e.getBasenameTerms=q;function j(X){return X.allPaths||[]}e.getPathTerms=j;function B(X,V){const x=J(Object.getOwnPropertyNames(X).map(re=>Q(re,X[re],V)).filter(re=>re!==n)),z=x.length;if(!z)return n;if(!x.some(re=>!!re.requiresSiblings)){if(z===1)return x[0];const re=function(_,$){let H;for(let W=0,K=x.length;W<K;W++){const Z=x[W](_,$);if(typeof Z=="string")return Z;(0,N.isThenable)(Z)&&(H||(H=[]),H.push(Z))}return H?(async()=>{for(const W of H){const K=await W;if(typeof K=="string")return K}return null})():null},U=x.find(_=>!!_.allBasenames);U&&(re.allBasenames=U.allBasenames);const f=x.reduce((_,$)=>$.allPaths?_.concat($.allPaths):_,[]);return f.length&&(re.allPaths=f),re}const ee=function(re,U,f){let _,$;for(let H=0,W=x.length;H<W;H++){const K=x[H];K.requiresSiblings&&f&&(U||(U=(0,k.basename)(re)),_||(_=U.substr(0,U.length-(0,k.extname)(re).length)));const Z=K(re,U,_,f);if(typeof Z=="string")return Z;(0,N.isThenable)(Z)&&($||($=[]),$.push(Z))}return $?(async()=>{for(const H of $){const W=await H;if(typeof W=="string")return W}return null})():null},ne=x.find(re=>!!re.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const ce=x.reduce((re,U)=>U.allPaths?re.concat(U.allPaths):re,[]);return ce.length&&(ee.allPaths=ce),ee}function Q(X,V,x){if(V===!1)return n;const z=s(X,x);if(z===n)return n;if(typeof V=="boolean")return z;if(V){const ee=V.when;if(typeof ee=="string"){const ne=(ce,re,U,f)=>{if(!f||!z(ce,re))return null;const _=ee.replace("$(basename)",()=>U),$=f(_);return(0,N.isThenable)($)?$.then(H=>H?X:null):$?X:null};return ne.requiresSiblings=!0,ne}}return z}function J(X,V){const x=X.filter(re=>!!re.basenames);if(x.length<2)return X;const z=x.reduce((re,U)=>{const f=U.basenames;return f?re.concat(f):re},[]);let ee;if(V){ee=[];for(let re=0,U=z.length;re<U;re++)ee.push(V)}else ee=x.reduce((re,U)=>{const f=U.patterns;return f?re.concat(f):re},[]);const ne=function(re,U){if(typeof re!="string")return null;if(!U){let _;for(_=re.length;_>0;_--){const $=re.charCodeAt(_-1);if($===47||$===92)break}U=re.substr(_)}const f=z.indexOf(U);return f!==-1?ee[f]:null};ne.basenames=z,ne.patterns=ee,ne.allBasenames=z;const ce=X.filter(re=>!re.basenames);return ce.push(ne),ce}function G(X,V){return(0,L.equals)(X,V,(x,z)=>typeof x=="string"&&typeof z=="string"?x===z:typeof x!="string"&&typeof z!="string"?x.base===z.base&&x.pattern===z.pattern:!1)}e.patternsEquals=G}),define(oe[91],ae([0,1,14,10]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(C){return C.toJSON()}class A{constructor(S){this._uriTransformer=S}transformIncoming(S){const u=this._uriTransformer.transformIncoming(S);return u===S?S:T(N.URI.from(u))}transformOutgoing(S){const u=this._uriTransformer.transformOutgoing(S);return u===S?S:T(N.URI.from(u))}transformOutgoingURI(S){const u=this._uriTransformer.transformOutgoing(S);return u===S?S:N.URI.from(u)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function k(C,S,u){if(!C||u>200)return null;if(typeof C=="object"){if(C instanceof N.URI)return S.transformOutgoing(C);for(const g in C)if(Object.hasOwnProperty.call(C,g)){const w=k(C[g],S,u+1);w!==null&&(C[g]=w)}}return null}function D(C,S){const u=k(C,S,0);return u===null?C:u}e.transformOutgoingURIs=D;function P(C,S,u,g){if(!C||g>200)return null;if(typeof C=="object"){if(C.$mid===1)return u?N.URI.revive(S.transformIncoming(C)):S.transformIncoming(C);if(C instanceof L.VSBuffer)return null;for(const w in C)if(Object.hasOwnProperty.call(C,w)){const c=P(C[w],S,u,g+1);c!==null&&(C[w]=c)}}return null}function v(C,S){const u=P(C,S,!1,0);return u===null?C:u}e.transformIncomingURIs=v;function I(C,S){const u=P(C,S,!0,0);return u===null?C:u}e.transformAndReviveIncomingURIs=I}),define(oe[31],ae([0,1,52,36,264,6,48,86,16,5,22,10]),function(te,e,L,N,T,A,k,D,P,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(S||(e.RimRafMode=S={}));async function u(B,Q=S.UNLINK,J){if((0,k.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return Q===S.UNLINK?w(B):g(B,J)}async function g(B,Q=(0,k.randomPath)((0,N.tmpdir)())){try{try{await L.promises.rename(B,Q)}catch(J){return J.code==="ENOENT"?void 0:w(B)}w(Q).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function w(B){return(0,T.promisify)(L.rm)(B,{recursive:!0,force:!0,maxRetries:3})}function c(B){if((0,k.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");L.rmSync(B,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function l(B,Q){return E(await(Q?h(B):(0,T.promisify)(L.readdir)(B)))}async function h(B){try{return await(0,T.promisify)(L.readdir)(B,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const Q=[],J=await l(B);for(const G of J){let X=!1,V=!1,x=!1;try{const z=await e.Promises.lstat((0,P.join)(B,G));X=z.isFile(),V=z.isDirectory(),x=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}Q.push({name:G,isFile:()=>X,isDirectory:()=>V,isSymbolicLink:()=>x})}return Q}function y(B){return E(L.readdirSync(B))}e.readdirSync=y;function E(B){return B.map(Q=>typeof Q=="string"?v.isMacintosh?(0,D.normalizeNFC)(Q):Q:(Q.name=v.isMacintosh?(0,D.normalizeNFC)(Q.name):Q.name,Q))}async function R(B){const Q=await l(B),J=[];for(const G of Q)await o.existsDirectory((0,P.join)(B,G))&&J.push(G);return J}function t(B,Q=1e3){return new Promise(J=>{let G=!1;const X=setInterval(()=>{G||(G=!0,L.access(B,V=>{G=!1,V&&(clearInterval(X),J(void 0))}))},Q)})}e.whenDeleted=t;var o;(function(B){async function Q(X){let V;try{if(V=await e.Promises.lstat(X),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(v.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw z}throw x}}B.stat=Q;async function J(X){try{const{stat:V,symbolicLink:x}=await B.stat(X);return V.isFile()&&x?.dangling!==!0}catch{}return!1}B.existsFile=J;async function G(X){try{const{stat:V,symbolicLink:x}=await B.stat(X);return V.isDirectory()&&x?.dangling!==!0}catch{}return!1}B.existsDirectory=G})(o||(e.SymlinkSupport=o={}));const n=new A.ResourceQueue;function s(B,Q,J){return n.queueFor(C.URI.file(B),I.extUriBiasedIgnorePathCase).queue(()=>{const G=m(J);return new Promise((X,V)=>a(B,Q,G,x=>x?V(x):X()))})}let i=!0;function r(B){i=B}e.configureFlushOnWrite=r;function a(B,Q,J,G){if(!i)return L.writeFile(B,Q,{mode:J.mode,flag:J.flag},G);L.open(B,J.flag,J.mode,(X,V)=>{if(X)return G(X);L.writeFile(V,Q,x=>{if(x)return L.close(V,()=>G(x));L.fdatasync(V,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),r(!1)),L.close(V,ee=>G(ee))))})})}function p(B,Q,J){const G=m(J);if(!i)return L.writeFileSync(B,Q,{mode:G.mode,flag:G.flag});const X=L.openSync(B,G.flag,G.mode);try{L.writeFileSync(X,Q);try{L.fdatasyncSync(X)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),r(!1)}}finally{L.closeSync(X)}}e.writeFileSync=p;function m(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function d(B,Q){if(B!==Q)try{await e.Promises.rename(B,Q)}catch(J){if(B.toLowerCase()!==Q.toLowerCase()&&J.code==="EXDEV"||B.endsWith("."))await b(B,Q,{preserveSymlinks:!1}),await u(B,S.MOVE);else throw J}}async function b(B,Q,J){return F(B,Q,{root:{source:B,target:Q},options:J,handledSourcePaths:new Set})}const O=511;async function F(B,Q,J){if(J.handledSourcePaths.has(B))return;J.handledSourcePaths.add(B);const{stat:G,symbolicLink:X}=await o.stat(B);if(X){if(J.options.preserveSymlinks)try{return await j(B,Q,J)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(X.dangling)return}return G.isDirectory()?M(B,Q,G.mode&O,J):q(B,Q,G.mode&O)}async function M(B,Q,J,G){await e.Promises.mkdir(Q,{recursive:!0,mode:J});const X=await l(B);for(const V of X)await F((0,P.join)(B,V),(0,P.join)(Q,V),G)}async function q(B,Q,J){await e.Promises.copyFile(B,Q),await e.Promises.chmod(Q,J)}async function j(B,Q,J){let G=await e.Promises.readlink(B);(0,k.isEqualOrParent)(G,J.root.source,!v.isLinux)&&(G=(0,P.join)(J.root.target,G.substr(J.root.source.length+1))),await e.Promises.symlink(G,Q)}e.Promises=new class{get access(){return(0,T.promisify)(L.access)}get stat(){return(0,T.promisify)(L.stat)}get lstat(){return(0,T.promisify)(L.lstat)}get utimes(){return(0,T.promisify)(L.utimes)}get read(){return(B,Q,J,G,X)=>new Promise((V,x)=>{L.read(B,Q,J,G,X,(z,ee,ne)=>z?x(z):V({bytesRead:ee,buffer:ne}))})}get readFile(){return(0,T.promisify)(L.readFile)}get write(){return(B,Q,J,G,X)=>new Promise((V,x)=>{L.write(B,Q,J,G,X,(z,ee,ne)=>z?x(z):V({bytesWritten:ee,buffer:ne}))})}get appendFile(){return(0,T.promisify)(L.appendFile)}get fdatasync(){return(0,T.promisify)(L.fdatasync)}get truncate(){return(0,T.promisify)(L.truncate)}get rename(){return(0,T.promisify)(L.rename)}get copyFile(){return(0,T.promisify)(L.copyFile)}get open(){return(0,T.promisify)(L.open)}get close(){return(0,T.promisify)(L.close)}get symlink(){return(0,T.promisify)(L.symlink)}get readlink(){return(0,T.promisify)(L.readlink)}get chmod(){return(0,T.promisify)(L.chmod)}get mkdir(){return(0,T.promisify)(L.mkdir)}get unlink(){return(0,T.promisify)(L.unlink)}get rmdir(){return(0,T.promisify)(L.rmdir)}get realpath(){return(0,T.promisify)(L.realpath)}async exists(B){try{return await e.Promises.access(B),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return R}get writeFile(){return s}get rm(){return u}get move(){return d}get copy(){return b}}}),define(oe[140],ae([0,1,52,16,5,27,31]),function(te,e,L,N,T,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(S){if(T.isLinux)return S;const u=(0,N.dirname)(S);if(S===u)return S;const g=((0,N.basename)(S)||S).toLowerCase();try{const c=(0,k.readdirSync)(u).filter(l=>l.toLowerCase()===g);if(c.length===1){const l=D(u);if(l)return(0,N.join)(l,c[0])}else if(c.length>1){const l=c.indexOf(g);if(l>=0){const h=D(u);if(h)return(0,N.join)(h,c[l])}}}catch{}return null}e.realcaseSync=D;async function P(S){if(T.isLinux)return S;const u=(0,N.dirname)(S);if(S===u)return S;const g=((0,N.basename)(S)||S).toLowerCase();try{const c=(await k.Promises.readdir(u)).filter(l=>l.toLowerCase()===g);if(c.length===1){const l=await P(u);if(l)return(0,N.join)(l,c[0])}else if(c.length>1){const l=c.indexOf(g);if(l>=0){const h=await P(u);if(h)return(0,N.join)(h,c[l])}}}catch{}return null}e.realcase=P;async function v(S){try{return await k.Promises.realpath(S)}catch{const g=C(S);return await k.Promises.access(g,L.constants.R_OK),g}}e.realpath=v;function I(S){try{return L.realpathSync(S)}catch{const g=C(S);return L.accessSync(g,L.constants.R_OK),g}}e.realpathSync=I;function C(S){return(0,A.rtrim)((0,N.normalize)(S),N.sep)}}),define(oe[141],ae([0,1,16,5,37,89,11,31]),function(te,e,L,N,T,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function P(C=T.env){return C.comspec||"cmd.exe"}e.getWindowsShell=P;function v(C){let S=[],u=!1;const g=function(w){if(u){S.push(w);return}(!C.send(w,l=>{if(l&&console.error(l),u=!1,S.length>0){const h=S.slice(0);S=[],h.forEach(y=>g(y))}})||N.isWindows)&&(u=!0)};return{send:g}}e.createQueuedSender=v;var I;(function(C){async function S(u,g,w){if(L.isAbsolute(u))return u;if(g===void 0&&(g=T.cwd()),L.dirname(u)!=="."||(w===void 0&&k.isString(T.env.PATH)&&(w=T.env.PATH.split(L.delimiter)),w===void 0||w.length===0))return L.join(g,u);async function l(h){if(await D.Promises.exists(h)){let y;try{y=await D.Promises.stat(h)}catch(E){E.message.startsWith("EACCES")&&(y=await D.Promises.lstat(h))}return y?!y.isDirectory():!1}return!1}for(const h of w){let y;if(L.isAbsolute(h)?y=L.join(h,u):y=L.join(g,h,u),await l(y))return y;let E=y+".com";if(await l(E)||(E=y+".exe",await l(E)))return E}return L.join(g,u)}C.findExecutable=S})(I||(e.win32=I={}))}),define(oe[142],ae([0,1,63,26]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function T(k){return new Promise((D,P)=>{let v;const I=new Map;function C(u,g,w,c,l){const h=I.get(g);if(u===k||h){const y={name:S(w),cmd:w,pid:u,ppid:g,load:c,mem:l};I.set(u,y),u===k&&(v=y),h&&(h.children||(h.children=[]),h.children.push(y),h.children.length>1&&(h.children=h.children.sort((E,R)=>E.pid-R.pid)))}}function S(u){const g=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,c=/--crashes-directory/i,l=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,y=/--type=([a-zA-Z-]+)/;if(c.exec(u))return"electron-crash-reporter";if(l.exec(u))return"winpty-agent";if(h.exec(u))return"conpty-agent";let E=y.exec(u);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?g.exec(u)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const R=/[a-zA-Z-]+\.js/g;let t="";do E=R.exec(u),E&&(t+=E+" ");while(E);return t&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${t})`:w.exec(u)?`electron-nodejs (${u})`:u}if(process.platform==="win32"){const u=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,w)=>{te(["@vscode/windows-process-tree"],g,w)}).then(g=>{g.getProcessList(k,w=>{if(!w){P(new Error(`Root process ${k} not found`));return}g.getProcessCpuUsage(w,c=>{const l=new Map;c.forEach(h=>{const y=u(h.commandLine||"");l.set(h.pid,{name:S(y),cmd:y,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),v=l.get(k),v?(l.forEach(h=>{const y=l.get(h.ppid);y&&(y.children||(y.children=[]),y.children.push(h))}),l.forEach(h=>{h.children&&(h.children=h.children.sort((y,E)=>y.pid-E.pid))}),D(v)):P(new Error(`Root process ${k} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let u=function(){let g=[v];const w=[];for(;g.length;){const l=g.shift();l&&(w.push(l.pid),l.children&&(g=g.concat(l.children)))}let c=JSON.stringify(N.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+w.join(" "),(0,L.exec)(c,{},(l,h,y)=>{if(l||y)P(l||new Error(y.toString()));else{const E=h.toString().split(`
`);for(let R=0;R<w.length;R++){const t=I.get(w[R]);t.load=parseFloat(E[R])}if(!v){P(new Error(`Root process ${k} not found`));return}D(v)}})};(0,L.exec)("which ps",{},(g,w,c)=>{if(g||c)if(process.platform!=="linux")P(g||new Error(c.toString()));else{const l=JSON.stringify(N.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,L.exec)(l,{},(h,y,E)=>{h||E?P(h||new Error(E.toString())):(A(y,C),u())})}else{const l=w.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${l} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,E,R)=>{y||R&&!R.includes("screen size is bogus")?P(y||new Error(R.toString())):(A(E,C),process.platform==="linux"?u():v?D(v):P(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=T;function A(k,D){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=k.toString().split(`
`);for(const I of v){const C=P.exec(I.trim());C&&C.length===6&&D(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}});var ve=this&&this.__decorate||function(te,e,L,N){var T=arguments.length,A=T<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,L):N,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(te,e,L,N);else for(var D=te.length-1;D>=0;D--)(k=te[D])&&(A=(T<3?k(A):T>3?k(e,L,A):k(e,L))||A);return T>3&&A&&Object.defineProperty(e,L,A),A};define(oe[43],ae([0,1,21,6,14,25,81,7,3,2,62,27,11]),function(te,e,L,N,T,A,k,D,P,v,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var u;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(u||(u={}));function g(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(w||(w={}));function c(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(l||(l={}));function h(V){let x=0;for(let z=0;;z+=7){const ee=V.read(1);if(x|=(ee.buffer[0]&127)<<z,!(ee.buffer[0]&128))return x}}const y=n(0);function E(V,x){if(x===0){V.write(y);return}let z=0;for(let ne=x;ne!==0;ne=ne>>>7)z++;const ee=T.VSBuffer.alloc(z);for(let ne=0;x!==0;ne++)ee.buffer[ne]=x&127,x=x>>>7,x>0&&(ee.buffer[ne]|=128);V.write(ee)}class R{constructor(x){this.buffer=x,this.pos=0}read(x){const z=this.buffer.slice(this.pos,this.pos+x);return this.pos+=z.byteLength,z}}e.BufferReader=R;class t{constructor(){this.buffers=[]}get buffer(){return T.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}e.BufferWriter=t;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function n(V){const x=T.VSBuffer.alloc(1);return x.writeUInt8(V,0),x}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},i=typeof Buffer<"u";function r(V,x){if(typeof x>"u")V.write(s.Undefined);else if(typeof x=="string"){const z=T.VSBuffer.fromString(x);V.write(s.String),E(V,z.byteLength),V.write(z)}else if(i&&Buffer.isBuffer(x)){const z=T.VSBuffer.wrap(x);V.write(s.Buffer),E(V,z.byteLength),V.write(z)}else if(x instanceof T.VSBuffer)V.write(s.VSBuffer),E(V,x.byteLength),V.write(x);else if(Array.isArray(x)){V.write(s.Array),E(V,x.length);for(const z of x)r(V,z)}else if(typeof x=="number"&&(x|0)===x)V.write(s.Uint),E(V,x);else{const z=T.VSBuffer.fromString(JSON.stringify(x));V.write(s.Object),E(V,z.byteLength),V.write(z)}}e.serialize=r;function a(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(h(V)).toString();case o.Buffer:return V.read(h(V)).buffer;case o.VSBuffer:return V.read(h(V));case o.Array:{const z=h(V),ee=[];for(let ne=0;ne<z;ne++)ee.push(a(V));return ee}case o.Object:return JSON.parse(V.read(h(V)).toString());case o.Int:return h(V)}}e.deserialize=a;class p{constructor(x,z,ee=null,ne=1e3){this.protocol=x,this.ctx=z,this.logger=ee,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ce=>this.onRawMessage(ce)),this.sendResponse({type:200})}registerChannel(x,z){this.channels.set(x,z),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const z=this.send([x.type]);this.logger?.logOutgoing(z,0,1,c(x.type));return}case 201:case 202:case 204:case 203:{const z=this.send([x.type,x.id],x.data);this.logger?.logOutgoing(z,x.id,1,c(x.type),x.data);return}}}send(x,z=void 0){const ee=new t;return r(ee,x),r(ee,z),this.sendBuffer(ee.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onRawMessage(x){const z=new R(x),ee=a(z),ne=a(z),ce=ee[0];switch(ce){case 100:return this.logger?.logIncoming(x.byteLength,ee[1],1,`${g(ce)}: ${ee[2]}.${ee[3]}`,ne),this.onPromise({type:ce,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 102:return this.logger?.logIncoming(x.byteLength,ee[1],1,`${g(ce)}: ${ee[2]}.${ee[3]}`,ne),this.onEventListen({type:ce,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 101:return this.logger?.logIncoming(x.byteLength,ee[1],1,`${g(ce)}`),this.disposeActiveRequest({type:ce,id:ee[1]});case 103:return this.logger?.logIncoming(x.byteLength,ee[1],1,`${g(ce)}`),this.disposeActiveRequest({type:ce,id:ee[1]})}}onPromise(x){const z=this.channels.get(x.channelName);if(!z){this.collectPendingRequest(x);return}const ee=new A.CancellationTokenSource;let ne;try{ne=z.call(this.ctx,x.name,x.arg,ee.token)}catch(U){ne=Promise.reject(U)}const ce=x.id;ne.then(U=>{this.sendResponse({id:ce,data:U,type:201}),this.activeRequests.delete(x.id)},U=>{U instanceof Error?this.sendResponse({id:ce,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.sendResponse({id:ce,data:U,type:203}),this.activeRequests.delete(x.id)});const re=(0,v.toDisposable)(()=>ee.cancel());this.activeRequests.set(x.id,re)}onEventListen(x){const z=this.channels.get(x.channelName);if(!z){this.collectPendingRequest(x);return}const ee=x.id,ce=z.listen(this.ctx,x.name,x.arg)(re=>this.sendResponse({id:ee,data:re,type:204}));this.activeRequests.set(x.id,ce)}disposeActiveRequest(x){const z=this.activeRequests.get(x.id);z&&(z.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let z=this.pendingRequests.get(x.channelName);z||(z=[],this.pendingRequests.set(x.channelName,z));const ee=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:x,timeoutTimer:ee})}flushPendingRequests(x){const z=this.pendingRequests.get(x);if(z){for(const ee of z)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.onPromise(ee.request);break;case 102:this.onEventListen(ee.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=p;var m;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class d{constructor(x,z=null){this.protocol=x,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new P.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ee=>this.onBuffer(ee)),this.logger=z}getChannel(x){const z=this;return{call(ee,ne,ce){return z.isDisposed?Promise.reject(new D.CancellationError):z.requestPromise(x,ee,ne,ce)},listen(ee,ne){return z.isDisposed?P.Event.None:z.requestEvent(x,ee,ne)}}}requestPromise(x,z,ee,ne=A.CancellationToken.None){const ce=this.lastRequestId++,U={id:ce,type:100,channelName:x,name:z,arg:ee};if(ne.isCancellationRequested)return Promise.reject(new D.CancellationError);let f;return new Promise(($,H)=>{if(ne.isCancellationRequested)return H(new D.CancellationError);const W=()=>{const ue=he=>{switch(he.type){case 201:this.handlers.delete(ce),$(he.data);break;case 202:{this.handlers.delete(ce);const Se=new Error(he.data.message);Se.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,Se.name=he.data.name,H(Se);break}case 203:this.handlers.delete(ce),H(he.data);break}};this.handlers.set(ce,ue),this.sendRequest(U)};let K=null;this.state===l.Idle?W():(K=(0,N.createCancelablePromise)(ue=>this.whenInitialized()),K.then(()=>{K=null,W()}));const Z=()=>{K?(K.cancel(),K=null):this.sendRequest({id:ce,type:101}),H(new D.CancellationError)},se=ne.onCancellationRequested(Z);f=(0,v.combinedDisposable)((0,v.toDisposable)(Z),se),this.activeRequests.add(f)}).finally(()=>{this.activeRequests.delete(f)})}requestEvent(x,z,ee){const ne=this.lastRequestId++,re={id:ne,type:102,channelName:x,name:z,arg:ee};let U=null;const f=new P.Emitter({onWillAddFirstListener:()=>{U=(0,N.createCancelablePromise)($=>this.whenInitialized()),U.then(()=>{U=null,this.activeRequests.add(f),this.sendRequest(re)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.activeRequests.delete(f),this.sendRequest({id:ne,type:103}))}}),_=$=>f.fire($.data);return this.handlers.set(ne,_),f.event}sendRequest(x){switch(x.type){case 100:case 102:{const z=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger?.logOutgoing(z,x.id,0,`${g(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const z=this.send([x.type,x.id]);this.logger?.logOutgoing(z,x.id,0,g(x.type));return}}}send(x,z=void 0){const ee=new t;return r(ee,x),r(ee,z),this.sendBuffer(ee.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onBuffer(x){const z=new R(x),ee=a(z),ne=a(z),ce=ee[0];switch(ce){case 200:return this.logger?.logIncoming(x.byteLength,0,0,c(ce)),this.onResponse({type:ee[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(x.byteLength,ee[1],0,c(ce),ne),this.onResponse({type:ee[0],id:ee[1],data:ne})}}onResponse(x){if(x.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}this.handlers.get(x.id)?.(x)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=d,ve([k.memoize],d.prototype,"onDidInitializePromise",null);class b{get connections(){const x=[];return this._connections.forEach(z=>x.push(z)),x}constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new P.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new P.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:z,onDidClientDisconnect:ee})=>{P.Event.once(z.onMessage)(ce=>{const re=new R(ce),U=a(re),f=new p(z,U),_=new d(z);this.channels.forEach((H,W)=>f.registerChannel(W,H));const $={channelServer:f,channelClient:_,ctx:U};this._connections.add($),this._onDidAddConnection.fire($),ee(()=>{f.dispose(),_.dispose(),this._connections.delete($),this._onDidRemoveConnection.fire($)})})})}getChannel(x,z){const ee=this;return{call(ne,ce,re){let U;if((0,S.isFunction)(z)){const _=(0,L.getRandomElement)(ee.connections.filter(z));U=_?Promise.resolve(_):P.Event.toPromise(P.Event.filter(ee.onDidAddConnection,z))}else U=z.routeCall(ee,ne,ce);const f=U.then(_=>_.channelClient.getChannel(x));return F(f).call(ne,ce,re)},listen(ne,ce){if((0,S.isFunction)(z))return ee.getMulticastEvent(x,z,ne,ce);const re=z.routeEvent(ee,ne,ce).then(U=>U.channelClient.getChannel(x));return F(re).listen(ne,ce)}}}getMulticastEvent(x,z,ee,ne){const ce=this;let re=new v.DisposableStore;const U=new P.Emitter({onWillAddFirstListener:()=>{re=new v.DisposableStore;const f=new P.EventMultiplexer,_=new Map,$=W=>{const Z=W.channelClient.getChannel(x).listen(ee,ne),se=f.add(Z);_.set(W,se)},H=W=>{const K=_.get(W);K&&(K.dispose(),_.delete(W))};ce.connections.filter(z).forEach($),P.Event.filter(ce.onDidAddConnection,z)($,void 0,re),ce.onDidRemoveConnection(H,void 0,re),f.event(U.fire,U,re),re.add(f)},onDidRemoveLastListener:()=>{re.dispose()}});return U.event}registerChannel(x,z){this.channels.set(x,z),this._connections.forEach(ee=>{ee.channelServer.registerChannel(x,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=b;class O{constructor(x,z,ee=null){const ne=new t;r(ne,z),x.send(ne.buffer),this.channelClient=new d(x,ee),this.channelServer=new p(x,z,ee)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,z){this.channelServer.registerChannel(x,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function F(V){return{call(x,z,ee){return V.then(ne=>ne.call(x,z,ee))},listen(x,z){const ee=new P.Relay;return V.then(ne=>ee.input=ne.listen(x,z)),ee.event}}}e.getDelayedChannel=F;function M(V){let x=!1;return{call(z,ee,ne){return x?V.call(z,ee,ne):(0,N.timeout)(0).then(()=>x=!0).then(()=>V.call(z,ee,ne))},listen(z,ee){if(x)return V.listen(z,ee);const ne=new P.Relay;return(0,N.timeout)(0).then(()=>x=!0).then(()=>ne.input=V.listen(z,ee)),ne.event}}}e.getNextTickChannel=M;class q{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const z of x.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await P.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=q;var j;(function(V){function x(ce,re){const U=ce,f=re&&re.disableMarshalling,_=new Map;for(const $ in U)ee($)&&_.set($,P.Event.buffer(U[$],!0));return new class{listen($,H,W){const K=_.get(H);if(K)return K;if(ne(H)){const Z=U[H];if(typeof Z=="function")return Z.call(U,W)}throw new D.ErrorNoTelemetry(`Event not found: ${H}`)}call($,H,W){const K=U[H];if(typeof K=="function"){if(!f&&Array.isArray(W))for(let Z=0;Z<W.length;Z++)W[Z]=(0,I.revive)(W[Z]);return K.apply(U,W)}throw new D.ErrorNoTelemetry(`Method not found: ${H}`)}}}V.fromService=x;function z(ce,re){const U=re&&re.disableMarshalling;return new Proxy({},{get(f,_){if(typeof _=="string")return re?.properties?.has(_)?re.properties.get(_):ne(_)?function($){return ce.listen(_,$)}:ee(_)?ce.listen(_):async function(...$){let H;re&&!(0,S.isUndefinedOrNull)(re.context)?H=[re.context,...$]:H=$;const W=await ce.call(_,H);return U?W:(0,I.revive)(W)};throw new D.ErrorNoTelemetry(`Property not found: ${String(_)}`)}})}V.toService=z;function ee(ce){return ce[0]==="o"&&ce[1]==="n"&&C.isUpperAsciiLetter(ce.charCodeAt(2))}function ne(ce){return/^onDynamic/.test(ce)&&C.isUpperAsciiLetter(ce.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const x=V.toString();if(x!=="[object Object]")return x}return V}function J(V){return Array.isArray(V)?V.map(Q):Q(V)}function G(V,x,z,ee,ne,ce,re){re=J(re);const U=B[ne],f=U[ee%U.length];let _=[`%c[${V}]%c[${String(x).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${f}`];/\($/.test(ce)?(_=_.concat(re),_.push(")")):_.push(re),console.log.apply(console,_)}class X{constructor(x,z){this._outgoingPrefix=x,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,z,ee,ne,ce){this._totalOutgoing+=x,G(this._outgoingPrefix,this._totalOutgoing,x,z,ee,ne,ce)}logIncoming(x,z,ee,ne,ce){this._totalIncoming+=x,G(this._incomingPrefix,this._totalIncoming,x,z,ee,ne,ce)}}e.IPCLogger=X}),define(oe[92],ae([0,1,14,3,2,43]),function(te,e,L,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(k||(e.SocketDiagnosticsEventType=k={}));var D;(function(s){s.enableDiagnostics=!1,s.records=[];const i=new WeakMap;let r=0;function a(m,d){if(!i.has(m)){const b=String(++r);i.set(m,b)}return i.get(m)}function p(m,d,b,O){if(!s.enableDiagnostics)return;const F=a(m,d);if(O instanceof L.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const M=L.VSBuffer.alloc(O.byteLength);M.set(O),s.records.push({timestamp:Date.now(),id:F,label:d,type:b,buff:M})}else s.records.push({timestamp:Date.now(),id:F,label:d,type:b,data:O})}s.traceSocketEvent=p})(D||(e.SocketDiagnostics=D={}));var P;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P||(e.SocketCloseEventType=P={}));let v=null;function I(){return v||(v=L.VSBuffer.alloc(0)),v}class C{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,r){if(i===0)return I();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const d=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=i),d}if(this._chunks[0].byteLength>i){const d=this._chunks[0].slice(0,i);return r&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),d}const a=L.VSBuffer.alloc(i);let p=0,m=0;for(;i>0;){const d=this._chunks[m];if(d.byteLength>i){const b=d.slice(0,i);a.set(b,p),p+=i,r&&(this._chunks[m]=d.slice(i),this._totalLength-=i),i-=i}else a.set(d,p),p+=d.byteLength,r?(this._chunks.shift(),this._totalLength-=d.byteLength):m++,i-=d.byteLength}return a}}e.ChunkStream=C;var S;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(S||(S={}));function u(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class w{constructor(i,r,a,p){this.type=i,this.id=r,this.ack=a,this.data=p,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends T.Disposable{constructor(i){super(),this._onMessage=this._register(new N.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:u(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,p=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",r),this._onMessage.fire(new w(a,p,m,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class l{constructor(i){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=L.VSBuffer.alloc(13);r.writeUInt8(i.type,0),r.writeUInt32BE(i.id,1),r.writeUInt32BE(i.ack,5),r.writeUInt32BE(i.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:u(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",i.data),this._writeSoon(r,i.data)}_bufferAdd(i,r){const a=this._totalLength===0;return this._data.push(i,r),this._totalLength+=i.byteLength+r.byteLength,a}_bufferTake(){const i=L.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,r){this._bufferAdd(i,r)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const i=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this._socket.write(i)}}class h extends T.Disposable{constructor(i){super(),this._onMessage=new N.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new N.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new l(this._socket)),this._socketReader=this._register(new c(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new w(1,0,0,i))}}e.Protocol=h;class y extends A.IPCClient{static fromSocket(i,r){return new y(new h(i),r)}get onDidDispose(){return this.protocol.onDidDispose}constructor(i,r,a=null){super(i,r,a),this.protocol=i}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=y;class E{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new N.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=E;class R{constructor(i){this.data=i,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let i=0,r=this._first;for(;r;)r=r.next,i++;return i}peek(){return this._first?this._first.data:null}toArray(){const i=[];let r=0,a=this._first;for(;a;)i[r++]=a.data,a=a.next;return i}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const r=new R(i);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class o{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const i=Date.now();for(let r=0;r<o._HISTORY_LENGTH;r++)this.lastRuns[r]=i-1e3*r;setInterval(()=>{for(let r=o._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}load(){const i=Date.now(),r=(1+o._HISTORY_LENGTH)*1e3;let a=0;for(let p=0;p<o._HISTORY_LENGTH;p++)i-this.lastRuns[p]<=r&&a++;return 1-a/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(i){this._onControlMessage=new E,this.onControlMessage=this._onControlMessage.event,this._onMessage=new E,this.onMessage=this._onMessage.event,this._onDidDispose=new E,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new E,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new E,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=i.loadEstimator??o.getInstance(),this._shouldSendKeepAlive=i.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new T.DisposableStore,this._socket=i.socket,this._socketWriter=this._socketDisposables.add(new l(this._socket)),this._socketReader=this._socketDisposables.add(new c(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(r=>this._receiveMessage(r))),this._socketDisposables.add(this._socket.onClose(r=>this._onSocketClose.fire(r))),i.initialChunk&&this._socketReader.acceptChunk(i.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new w(5,0,0,I());this._socketWriter.write(i),this._socketWriter.flush()}sendPause(){const i=new w(7,0,0,I());this._socketWriter.write(i)}sendResume(){const i=new w(8,0,0,I());this._socketWriter.write(i)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,r){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new T.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=i,this._socketWriter=this._socketDisposables.add(new l(this._socket)),this._socketReader=this._socketDisposables.add(new c(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.add(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const i=new w(3,0,this._incomingAckId,I());this._socketWriter.write(i);const r=this._outgoingUnackMsg.toArray();for(let a=0,p=r.length;a<p;a++)this._socketWriter.write(r[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new w(6,0,0,I())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data);break}case 2:{this._onControlMessage.fire(i.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const r=this._outgoingUnackMsg.toArray();for(let a=0,p=r.length;a<p;a++)this._socketWriter.write(r[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new w(1,r,this._incomingAckId,i);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(i){const r=new w(2,0,0,i);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),r=Date.now()-i.writtenTime,a=Date.now()-this._socketReader.lastReadTime,p=Date.now()-this._lastSocketTimeoutTime;if(r>=2e4&&a>=2e4&&p>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const m=Math.max(2e4-r,2e4-a,2e4-p,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},m)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new w(3,0,this._incomingAckId,I());this._socketWriter.write(i)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const i=new w(9,0,this._incomingAckId,I());this._socketWriter.write(i)}}e.PersistentProtocol=n}),define(oe[93],ae([0,1,63,6,14,25,138,7,3,2,30,141,89,43]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends u.ChannelServer{constructor(l){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",h=>T.VSBuffer.wrap(Buffer.from(h,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=g;class w{constructor(l,h){this.modulePath=l,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new N.Delayer(y),this.child=null,this._client=null}getChannel(l){const h=this;return{call(y,E,R){return h.requestPromise(l,y,E,R)},listen(y,E){return h.requestEvent(l,y,E)}}}requestPromise(l,h,y,E=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(D.canceled());this.disposeDelayer.cancel();const R=this.getCachedChannel(l),t=(0,N.createCancelablePromise)(s=>R.call(h,y,s)),o=E.onCancellationRequested(()=>t.cancel()),n=(0,v.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(l,h,y){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let E;const R=new P.Emitter({onWillAddFirstListener:()=>{E=this.getCachedChannel(l).listen(h,y)(R.fire,R),this.activeRequests.add(E)},onDidRemoveLastListener:()=>{this.activeRequests.delete(E),E.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return R.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,S.removeDangerousEnvVariables)(h.env),this.child=(0,L.fork)(this.modulePath,l,h);const y=new P.Emitter;P.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,k.isRemoteConsoleLog)(i)){(0,k.log)(i,`IPC Library: ${this.options.serverName}`);return}y.fire(T.VSBuffer.wrap(Buffer.from(i,"base64")))});const R=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,t=i=>this.child&&this.child.connected&&R.send(i.buffer.toString("base64")),o=y.event,n={send:t,onMessage:o};this._client=new u.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,r)=>{process.removeListener("exit",s),this.activeRequests.forEach(a=>(0,v.dispose)(a)),this.activeRequests.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+r),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:r})})}return this._client}getCachedChannel(l){let h=this.channels.get(l);return h||(h=this.client.getChannel(l),this.channels.set(l,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(oe[143],ae([0,1,131,14,43,3,11,21]),function(te,e,L,N,T,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class P{constructor(S){this.port=S,this.onMessage=A.Event.fromNodeEventEmitter(this.port,"message",u=>N.VSBuffer.wrap(u.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}class v extends T.IPCServer{static getOnDidClientConnect(){(0,k.assertType)((0,L.isUtilityProcess)(process),"Electron Utility Process");const S=new A.Emitter;return process.parentPort.on("message",u=>{const g=(0,D.firstOrDefault)(u.ports);g&&S.fire(g)}),A.Event.map(S.event,u=>({protocol:new P(u),onDidClientDisconnect:A.Event.fromNodeEventEmitter(u,"close")}))}constructor(){super(v.getOnDidClientConnect())}}e.Server=v;function I(C,S,u){const g=w=>{w.data===S&&(C.removeListener("message",g),u())};C.on("message",g)}e.once=I}),define(oe[64],ae([0,1,6,3,2,62,11]),function(te,e,L,N,T,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D||(e.StorageHint=D={}));function P(S){const u=S;return u?.changed instanceof Map||u?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var v;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(v||(e.StorageState=v={}));class I extends T.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(u,g=Object.create(null)){super(),this.database=u,this.options=g,this._onDidChangeStorage=this._register(new N.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=v.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(u=>this.onDidChangeItemsExternal(u)))}onDidChangeItemsExternal(u){this._onDidChangeStorage.pause();try{u.changed?.forEach((g,w)=>this.acceptExternal(w,g)),u.deleted?.forEach(g=>this.acceptExternal(g,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(u,g){if(this.state===v.Closed)return;let w=!1;(0,k.isUndefinedOrNull)(g)?w=this.cache.delete(u):this.cache.get(u)!==g&&(this.cache.set(u,g),w=!0),w&&this._onDidChangeStorage.fire({key:u,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===v.None&&(this.state=v.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(u,g){const w=this.cache.get(u);return(0,k.isUndefinedOrNull)(w)?g:w}getBoolean(u,g){const w=this.get(u);return(0,k.isUndefinedOrNull)(w)?g:w==="true"}getNumber(u,g){const w=this.get(u);return(0,k.isUndefinedOrNull)(w)?g:parseInt(w,10)}getObject(u,g){const w=this.get(u);return(0,k.isUndefinedOrNull)(w)?g:(0,A.parse)(w)}async set(u,g,w=!1){if(this.state===v.Closed)return;if((0,k.isUndefinedOrNull)(g))return this.delete(u,w);const c=(0,k.isObject)(g)||Array.isArray(g)?(0,A.stringify)(g):String(g);if(this.cache.get(u)!==c)return this.cache.set(u,c),this.pendingInserts.set(u,c),this.pendingDeletes.delete(u),this._onDidChangeStorage.fire({key:u,external:w}),this.doFlush()}async delete(u,g=!1){if(!(this.state===v.Closed||!this.cache.delete(u)))return this.pendingDeletes.has(u)||this.pendingDeletes.add(u),this.pendingInserts.delete(u),this._onDidChangeStorage.fire({key:u,external:g}),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=v.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const u={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(u).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(u){if(this.hasPending)return this.doFlush(u)}async doFlush(u){return this.flushDelayer.trigger(()=>this.flushPending(),u)}async whenFlushed(){if(this.hasPending)return new Promise(u=>this.whenFlushedCallbacks.push(u))}isInMemory(){return this.options.hint===D.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=I;class C{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(u){u.insert?.forEach((g,w)=>this.items.set(w,g)),u.delete?.forEach(g=>this.items.delete(g))}async close(){}}e.InMemoryStorageDatabase=C}),define(oe[144],ae([12,9]),function(te,e){return te.create("vs/base/node/zip",e)}),define(oe[145],ae([12,9]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[146],ae([12,9]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[147],ae([12,9]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(oe[148],ae([12,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[149],ae([12,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[150],ae([12,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[151],ae([12,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[152],ae([12,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[153],ae([12,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[154],ae([12,9]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[155],ae([12,9]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(oe[156],ae([12,9]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(oe[157],ae([12,9]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(oe[158],ae([12,9]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[159],ae([12,9]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[160],ae([12,9]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[161],ae([12,9]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[162],ae([12,9]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(oe[163],ae([12,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[164],ae([12,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[165],ae([12,9]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[166],ae([12,9]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[167],ae([12,9]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[168],ae([12,9]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[169],ae([12,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[170],ae([12,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[171],ae([12,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[172],ae([12,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[173],ae([12,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[174],ae([12,9]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(oe[175],ae([0,1,7,147]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var T;(function(v){v[v.LParen=0]="LParen",v[v.RParen=1]="RParen",v[v.Neg=2]="Neg",v[v.Eq=3]="Eq",v[v.NotEq=4]="NotEq",v[v.Lt=5]="Lt",v[v.LtEq=6]="LtEq",v[v.Gt=7]="Gt",v[v.GtEq=8]="GtEq",v[v.RegexOp=9]="RegexOp",v[v.RegexStr=10]="RegexStr",v[v.True=11]="True",v[v.False=12]="False",v[v.In=13]="In",v[v.Not=14]="Not",v[v.And=15]="And",v[v.Or=16]="Or",v[v.Str=17]="Str",v[v.QuotedStr=18]="QuotedStr",v[v.Error=19]="Error",v[v.EOF=20]="EOF"})(T||(e.TokenType=T={}));function A(...v){switch(v.length){case 1:return(0,N.localize)(0,null,v[0]);case 2:return(0,N.localize)(1,null,v[0],v[1]);case 3:return(0,N.localize)(2,null,v[0],v[1],v[2]);default:return}}const k=(0,N.localize)(3,null),D=(0,N.localize)(4,null);class P{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(I){switch(I.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return I.isTripleEq?"===":"==";case 4:return I.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return I.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return I.lexeme;case 18:return I.lexeme;case 19:return I.lexeme;case 20:return"EOF";default:throw(0,L.illegalState)(`unhandled token type: ${JSON.stringify(I)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(I=>I.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(I){return this._input=I,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const C=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:C})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const C=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:C})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(I){return this._isAtEnd()||this._input.charCodeAt(this._current)!==I?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(I){this._tokens.push({type:I,offset:this._start})}_error(I){const C=this._start,S=this._input.substring(this._start,this._current),u={type:19,offset:this._start,lexeme:S};this._errors.push({offset:C,lexeme:S,additionalInfo:I}),this._tokens.push(u)}_string(){this.stringRe.lastIndex=this._start;const I=this.stringRe.exec(this._input);if(I){this._current=this._start+I[0].length;const C=this._input.substring(this._start,this._current),S=P._keywords.get(C);S?this._addToken(S):this._tokens.push({type:17,lexeme:C,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(k);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let I=this._current,C=!1,S=!1;for(;;){if(I>=this._input.length){this._current=I,this._error(D);return}const g=this._input.charCodeAt(I);if(C)C=!1;else if(g===47&&!S){I++;break}else g===91?S=!0:g===92?C=!0:g===93&&(S=!1);I++}for(;I<this._input.length&&P._regexFlags.has(this._input.charCodeAt(I));)I++;this._current=I;const u=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:u,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=P}),define(oe[176],ae([0,1,61,81,26,16,37,22,10]),function(te,e,L,N,T,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class v{get appRoot(){return(0,A.dirname)(T.FileAccess.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,D.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:T.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,D.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",u)}return P.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,D.joinPath)(P.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,D.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,D.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=k.env.VSCODE_PORTABLE;return u?P.URI.file((0,A.join)(u,"argv.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,A.resolve)(u):(0,A.normalize)((0,A.join)(T.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?P.URI.file((0,A.resolve)(u)):P.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,A.resolve)(u);const g=k.env.VSCODE_EXTENSIONS;if(g)return g;const w=k.env.VSCODE_PORTABLE;return w?(0,A.join)(w,"extensions"):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(g=>/^[^:/?#]+?:\/\//.test(g)?P.URI.parse(g):P.URI.file((0,A.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?P.URI.parse(u):P.URI.file((0,A.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(u))}get extensionLogLevel(){const u=[];for(const g of this.args.log||[]){const w=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(g);w&&w[1]&&w[2]&&u.push([w[1],w[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,D.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=k.env.VSCODE_PORTABLE;return u?P.URI.file((0,A.join)(u,"policy.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this._args}constructor(u,g,w){this._args=u,this.paths=g,this.productService=w,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=v,ve([N.memoize],v.prototype,"appRoot",null),ve([N.memoize],v.prototype,"userHome",null),ve([N.memoize],v.prototype,"userDataPath",null),ve([N.memoize],v.prototype,"appSettingsHome",null),ve([N.memoize],v.prototype,"tmpDir",null),ve([N.memoize],v.prototype,"cacheHome",null),ve([N.memoize],v.prototype,"stateResource",null),ve([N.memoize],v.prototype,"userRoamingDataHome",null),ve([N.memoize],v.prototype,"userDataSyncHome",null),ve([N.memoize],v.prototype,"sync",null),ve([N.memoize],v.prototype,"machineSettingsResource",null),ve([N.memoize],v.prototype,"workspaceStorageHome",null),ve([N.memoize],v.prototype,"localHistoryHome",null),ve([N.memoize],v.prototype,"keyboardLayoutResource",null),ve([N.memoize],v.prototype,"argvResource",null),ve([N.memoize],v.prototype,"isExtensionDevelopment",null),ve([N.memoize],v.prototype,"untitledWorkspacesHome",null),ve([N.memoize],v.prototype,"builtinExtensionsPath",null),ve([N.memoize],v.prototype,"extensionsPath",null),ve([N.memoize],v.prototype,"extensionDevelopmentLocationURI",null),ve([N.memoize],v.prototype,"extensionDevelopmentKind",null),ve([N.memoize],v.prototype,"extensionTestsLocationURI",null),ve([N.memoize],v.prototype,"debugExtensionHost",null),ve([N.memoize],v.prototype,"logLevel",null),ve([N.memoize],v.prototype,"extensionLogLevel",null),ve([N.memoize],v.prototype,"serviceMachineIdResource",null),ve([N.memoize],v.prototype,"disableTelemetry",null),ve([N.memoize],v.prototype,"disableWorkspaceTrust",null),ve([N.memoize],v.prototype,"policyFile",null);function I(S,u){return C(S["inspect-extensions"],S["inspect-brk-extensions"],5870,u,S.debugId,S.extensionEnvironment)}e.parseExtensionHostDebugPort=I;function C(S,u,g,w,c,l){const y=Number(u||S)||(w?null:g),E=y?!!u:!1;let R;if(l)try{R=JSON.parse(l)}catch{}return{port:y,break:E,debugId:c,env:R}}e.parseDebugParams=C}),function(){"use strict";function te(e,L,N){function T(k,D){const P=A(k,D),v=[P];return e.isAbsolute(P)||v.unshift(N),e.resolve(...v)}function A(k,D){process.env.VSCODE_DEV&&(D="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return e.join(v,D);const I=k["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=e.join(C,"AppData","Roaming")}break;case"darwin":v=e.join(L.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(v,D)}return{getUserDataPath:T}}if(typeof define=="function")define(oe[177],ae([265,36,37]),function(e,L,N){return te(e,L,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=te(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[178],ae([0,1,36,176,177]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends N.AbstractNativeEnvironmentService{constructor(v,I){super(v,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,T.getUserDataPath)(v,I.nameShort)},I)}}e.NativeEnvironmentService=A;function k(P,v){return(0,N.parseDebugParams)(P["inspect-ptyhost"],P["inspect-brk-ptyhost"],5877,v,P.extensionEnvironment)}e.parsePtyHostDebugPort=k;function D(P,v){return(0,N.parseDebugParams)(P["inspect-sharedprocess"],P["inspect-brk-sharedprocess"],5879,v,P.extensionEnvironment)}e.parseSharedProcessDebugPort=D}),define(oe[179],ae([0,1,11,150]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function T(k,D,P){try{A(k,D,P)}catch(v){console.error(v?.message??v)}return k}e.localizeManifest=T;function A(k,D,P){const v=(I,C,S)=>{const u=I[C];if((0,L.isString)(u)){const g=u,w=g.length;if(w>1&&g[0]==="%"&&g[w-1]==="%"){const c=g.substr(1,w-2);let l=D[c];l===void 0&&P&&(l=P[c]);const h=typeof l=="string"?l:l?.message,y=P?.[c],E=typeof y=="string"?y:y?.message;if(!h){E||console.warn(`[${k.name}]: ${(0,N.localize)(0,null,c)}`);return}if(S&&(C==="title"||C==="category")&&E&&E!==h){const R={value:h,original:E};I[C]=R}else I[C]=h}}else if((0,L.isObject)(u))for(const g in u)u.hasOwnProperty(g)&&(g==="commands"?v(u,g,!0):v(u,g,S));else if(Array.isArray(u))for(let g=0;g<u.length;g++)v(u,g,S)};for(const I in k)k.hasOwnProperty(I)&&v(k,I)}}),define(oe[180],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(A){this.channel=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.channel.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class N{constructor(A){this.service=A}listen(A,k){throw new Error(`Event not found: ${k}`)}call(A,k,D){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(D[0])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=N}),define(oe[65],ae([0,1,22,88,154,53]),function(te,e,L,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function P(l){return l=l.trim(),l==="*"||k.test(l)}e.isValidVersionStr=P;function v(l){if(!P(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=l.match(k);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=v;function I(l){if(!l)return null;const h=l.majorBase,y=l.majorMustEqual,E=l.minorBase;let R=l.minorMustEqual;const t=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(h===0||(R=!1),o=!1);let n=0;if(l.preRelease){const s=D.exec(l.preRelease);if(s){const[,i,r,a]=s;n=Date.UTC(Number(i),Number(r)-1,Number(a))}}return{majorBase:h,majorMustEqual:y,minorBase:E,minorMustEqual:R,patchBase:t,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:n}}e.normalizeVersion=I;function C(l,h,y){let E;typeof l=="string"?E=I(v(l)):E=l;let R;h instanceof Date?R=h.getTime():typeof h=="string"&&(R=new Date(h).getTime());let t;if(typeof y=="string"?t=I(v(y)):t=y,!E||!t)return!1;const o=E.majorBase,n=E.minorBase,s=E.patchBase;let i=t.majorBase,r=t.minorBase,a=t.patchBase;const p=t.notBefore;let m=t.majorMustEqual,d=t.minorMustEqual,b=t.patchMustEqual;return t.isMinimum?o>i?!0:o<i?!1:n>r?!0:n<r||R&&R<p?!1:s>=a:(o===1&&i===0&&(!m||!d||!b)&&(i=1,r=0,a=0,m=!0,d=!1,b=!1),o<i?!1:o>i?!m:n<r?!1:n>r?!d:s<a?!1:s>a?!b:!(R&&R<p))}e.isValidVersion=C;function S(l,h,y,E,R){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([N.default.Error,T.localize(0,null)]),t;if(typeof E.name!="string")return t.push([N.default.Error,T.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([N.default.Error,T.localize(2,null,"version")]),t;if(!E.engines)return t.push([N.default.Error,T.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([N.default.Error,T.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!c(E.extensionDependencies))return t.push([N.default.Error,T.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!c(E.activationEvents))return t.push([N.default.Error,T.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([N.default.Error,T.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([N.default.Warning,T.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([N.default.Error,T.localize(9,null,"main")]),t;{const s=(0,L.joinPath)(y,E.main);(0,L.isEqualOrParent)(s,y)||t.push([N.default.Warning,T.localize(10,null,s.path,y.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([N.default.Error,T.localize(11,null,"browser")]),t;{const s=(0,L.joinPath)(y,E.browser);(0,L.isEqualOrParent)(s,y)||t.push([N.default.Warning,T.localize(12,null,s.path,y.path)])}}if(!A.valid(E.version))return t.push([N.default.Error,T.localize(13,null)]),t;const o=[];if(!u(l,h,E,R,o))for(const s of o)t.push([N.default.Error,s]);return t}e.validateExtensionManifest=S;function u(l,h,y,E,R){return E||typeof y.main>"u"&&typeof y.browser>"u"?!0:w(l,h,y.engines.vscode,R)}e.isValidExtensionVersion=u;function g(l,h,y){return l==="*"||w(h,y,l)}e.isEngineValid=g;function w(l,h,y,E=[]){const R=I(v(y));if(!R)return E.push(T.localize(14,null,y)),!1;if(R.majorBase===0){if(!R.majorMustEqual||!R.minorMustEqual)return E.push(T.localize(15,null,y)),!1}else if(!R.majorMustEqual)return E.push(T.localize(16,null,y)),!1;return C(l,h,R)?!0:(E.push(T.localize(17,null,l,y)),!1)}function c(l){if(!Array.isArray(l))return!1;for(let h=0,y=l.length;h<y;h++)if(typeof l[h]!="string")return!1;return!0}}),define(oe[44],ae([0,1,14,32]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function T(A,k,D){let P=D&&D.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const I=(await k.readFile(A.serviceMachineIdResource)).value.toString();P=(0,N.isUUID)(I)?I:null}catch{P=null}if(!P){P=(0,N.generateUuid)();try{await k.writeFile(A.serviceMachineIdResource,L.VSBuffer.fromString(P))}catch{}}return D?.store("storage.serviceMachineId",P,-1,1),P}e.getServiceMachineId=T}),define(oe[66],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(T,A=[],k=!1){this.ctor=T,this.staticArguments=A,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=L}),define(oe[181],ae([0,1,66]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const N=[];var T;(function(D){D[D.Eager=0]="Eager",D[D.Delayed=1]="Delayed"})(T||(e.InstantiationType=T={}));function A(D,P,v){P instanceof L.SyncDescriptor||(P=new L.SyncDescriptor(P,[],!!v)),N.push([D,P])}e.registerSingleton=A;function k(){return N}e.getSingletonServiceDescriptors=k}),define(oe[182],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(A,k){this.key=A,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=L;class N{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const k of this._nodes.values())k.outgoing.size===0&&A.push(k);return A}insertEdge(A,k){const D=this.lookupOrInsertNode(A),P=this.lookupOrInsertNode(k);D.outgoing.set(P.key,P),P.incoming.set(D.key,D)}removeNode(A){const k=this._hashFn(A);this._nodes.delete(k);for(const D of this._nodes.values())D.outgoing.delete(k),D.incoming.delete(k)}lookupOrInsertNode(A){const k=this._hashFn(A);let D=this._nodes.get(k);return D||(D=new L(k,A),this._nodes.set(k,D)),D}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[k,D]of this._nodes)A.push(`${k}
	(-> incoming)[${[...D.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...D.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,k]of this._nodes){const D=new Set([A]),P=this._findCycle(k,D);if(P)return P}}_findCycle(A,k){for(const[D,P]of A.outgoing){if(k.has(D))return[...k,D].join(" -> ");k.add(D);const v=this._findCycle(P,k);if(v)return v;k.delete(D)}}}e.Graph=N}),define(oe[4],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var L;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function D(P){return P[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=D})(L||(e._util=L={})),e.IInstantiationService=T("instantiationService");function N(k,D,P){D[L.DI_TARGET]===D?D[L.DI_DEPENDENCIES].push({id:k,index:P}):(D[L.DI_DEPENDENCIES]=[{id:k,index:P}],D[L.DI_TARGET]=D)}function T(k){if(L.serviceIds.has(k))return L.serviceIds.get(k);const D=function(P,v,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(D,P,I)};return D.toString=()=>k,L.serviceIds.set(k,D),D}e.createDecorator=T;function A(k){return k}e.refineServiceDecorator=A}),define(oe[183],ae([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(oe[18],ae([0,1,11,10,4]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof N.URI)}e.isConfigurationOverrides=A;function k(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof N.URI)}e.isConfigurationUpdateOverrides=k;var D;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(D||(e.ConfigurationTarget=D={}));function P(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=P;function v(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.isConfigured=v;function I(l,h){const y=Object.create(null);for(const E in l)C(y,E,l[E],h);return y}e.toValuesTree=I;function C(l,h,y,E){const R=h.split("."),t=R.pop();let o=l;for(let n=0;n<R.length;n++){const s=R[n];let i=o[s];switch(typeof i){case"undefined":i=o[s]=Object.create(null);break;case"object":break;default:E(`Ignoring ${h} as ${R.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[t]=y}catch{E(`Ignoring ${h} as ${R.join(".")} is ${JSON.stringify(o)}`)}else E(`Ignoring ${h} as ${R.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=C;function S(l,h){const y=h.split(".");u(l,y)}e.removeFromValueTree=S;function u(l,h){const y=h.shift();if(h.length===0){delete l[y];return}if(Object.keys(l).indexOf(y)!==-1){const E=l[y];typeof E=="object"&&!Array.isArray(E)&&(u(E,h),Object.keys(E).length===0&&delete l[y])}}function g(l,h,y){function E(o,n){let s=o;for(const i of n){if(typeof s!="object"||s===null)return;s=s[i]}return s}const R=h.split("."),t=E(l,R);return typeof t>"u"?y:t}e.getConfigurationValue=g;function w(l,h,y){Object.keys(h).forEach(E=>{E!=="__proto__"&&(E in l?L.isObject(l[E])&&L.isObject(h[E])?w(l[E],h[E],y):y&&(l[E]=h[E]):l[E]=h[E])})}e.merge=w;function c(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=c}),define(oe[94],ae([0,1,5,27,175,4,146,7]),function(te,e,L,N,T,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",L.isMacintosh),P.set("isLinux",L.isLinux),P.set("isWindows",L.isWindows),P.set("isWeb",L.isWeb),P.set("isMacNative",L.isMacintosh&&!L.isWeb),P.set("isEdge",L.isEdge),P.set("isFirefox",L.isFirefox),P.set("isChrome",L.isChrome),P.set("isSafari",L.isSafari);function v(U,f){if(P.get(U)!==void 0)throw(0,D.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");P.set(U,f)}e.setConstant=v;const I=Object.prototype.hasOwnProperty;var C;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const S={regexParsingWithErrorRecovery:!0},u=(0,k.localize)(0,null),g=(0,k.localize)(1,null),w=(0,k.localize)(2,null),c=(0,k.localize)(3,null),l=(0,k.localize)(4,null),h=(0,k.localize)(5,null),y=(0,k.localize)(6,null),E=(0,k.localize)(7,null);class R{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(f=S){this._config=f,this._scanner=new T.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(f){if(f===""){this._parsingErrors.push({message:u,offset:0,lexeme:"",additionalInfo:g});return}this._tokens=this._scanner.reset(f).scan(),this._current=0,this._parsingErrors=[];try{const _=this._expr();if(!this._isAtEnd()){const $=this._peek(),H=$.type===17?h:void 0;throw this._parsingErrors.push({message:l,offset:$.offset,lexeme:T.Scanner.getLexeme($),additionalInfo:H}),R._parseError}return _}catch(_){if(_!==R._parseError)throw _;return}}_expr(){return this._or()}_or(){const f=[this._and()];for(;this._matchOne(16);){const _=this._and();f.push(_)}return f.length===1?f[0]:t.or(...f)}_and(){const f=[this._term()];for(;this._matchOne(15);){const _=this._term();f.push(_)}return f.length===1?f[0]:t.and(...f)}_term(){if(this._matchOne(2)){const f=this._peek();switch(f.type){case 11:return this._advance(),i.INSTANCE;case 12:return this._advance(),r.INSTANCE;case 0:{this._advance();const _=this._expr();return this._consume(1,c),_?.negate()}case 17:return this._advance(),O.create(f.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",f)}}return this._primary()}_primary(){const f=this._peek();switch(f.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const _=this._expr();return this._consume(1,c),_}case 17:{const _=f.lexeme;if(this._advance(),this._matchOne(9)){const H=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),H.type!==10)throw this._errExpectedButGot("REGEX",H);const W=H.lexeme,K=W.lastIndexOf("/"),Z=K===W.length-1?void 0:this._removeFlagsGY(W.substring(K+1));let se;try{se=new RegExp(W.substring(1,K),Z)}catch{throw this._errExpectedButGot("REGEX",H)}return Q.create(_,se)}switch(H.type){case 10:case 19:{const W=[H.lexeme];this._advance();let K=this._peek(),Z=0;for(let Ee=0;Ee<H.lexeme.length;Ee++)H.lexeme.charCodeAt(Ee)===40?Z++:H.lexeme.charCodeAt(Ee)===41&&Z--;for(;!this._isAtEnd()&&K.type!==15&&K.type!==16;){switch(K.type){case 0:Z++;break;case 1:Z--;break;case 10:case 18:for(let Ee=0;Ee<K.lexeme.length;Ee++)K.lexeme.charCodeAt(Ee)===40?Z++:H.lexeme.charCodeAt(Ee)===41&&Z--}if(Z<0)break;W.push(T.Scanner.getLexeme(K)),this._advance(),K=this._peek()}const se=W.join(""),ue=se.lastIndexOf("/"),he=ue===se.length-1?void 0:this._removeFlagsGY(se.substring(ue+1));let Se;try{Se=new RegExp(se.substring(1,ue),he)}catch{throw this._errExpectedButGot("REGEX",H)}return t.regex(_,Se)}case 18:{const W=H.lexeme;this._advance();let K=null;if(!(0,N.isFalsyOrWhitespace)(W)){const Z=W.indexOf("/"),se=W.lastIndexOf("/");if(Z!==se&&Z>=0){const ue=W.slice(Z+1,se),he=W[se+1]==="i"?"i":"";try{K=new RegExp(ue,he)}catch{throw this._errExpectedButGot("REGEX",H)}}}if(K===null)throw this._errExpectedButGot("REGEX",H);return Q.create(_,K)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,w);const H=this._value();return t.notIn(_,H)}switch(this._peek().type){case 3:{this._advance();const H=this._value();if(this._previous().type===18)return t.equals(_,H);switch(H){case"true":return t.has(_);case"false":return t.not(_);default:return t.equals(_,H)}}case 4:{this._advance();const H=this._value();if(this._previous().type===18)return t.notEquals(_,H);switch(H){case"true":return t.not(_);case"false":return t.has(_);default:return t.notEquals(_,H)}}case 5:return this._advance(),j.create(_,this._value());case 6:return this._advance(),B.create(_,this._value());case 7:return this._advance(),M.create(_,this._value());case 8:return this._advance(),q.create(_,this._value());case 13:return this._advance(),t.in(_,this._value());default:return t.has(_)}}case 20:throw this._parsingErrors.push({message:y,offset:f.offset,lexeme:"",additionalInfo:E}),R._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const f=this._peek();switch(f.type){case 17:case 18:return this._advance(),f.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(f){return f.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(f){return this._check(f)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(f,_){if(this._check(f))return this._advance();throw this._errExpectedButGot(_,this._peek())}_errExpectedButGot(f,_,$){const H=(0,k.localize)(8,null,f,T.Scanner.getLexeme(_)),W=_.offset,K=T.Scanner.getLexeme(_);return this._parsingErrors.push({message:H,offset:W,lexeme:K,additionalInfo:$}),R._parseError}_check(f){return this._peek().type===f}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=R;class t{static false(){return i.INSTANCE}static true(){return r.INSTANCE}static has(f){return a.create(f)}static equals(f,_){return p.create(f,_)}static notEquals(f,_){return b.create(f,_)}static regex(f,_){return Q.create(f,_)}static in(f,_){return m.create(f,_)}static notIn(f,_){return d.create(f,_)}static not(f){return O.create(f)}static and(...f){return X.create(f,null,!0)}static or(...f){return V.create(f,null,!0)}static greater(f,_){return M.create(f,_)}static greaterEquals(f,_){return q.create(f,_)}static smaller(f,_){return j.create(f,_)}static smallerEquals(f,_){return B.create(f,_)}static{this._parser=new R({regexParsingWithErrorRecovery:!1})}static deserialize(f){return f==null?void 0:this._parser.parse(f)}}e.ContextKeyExpr=t;function o(U){const f=new R({regexParsingWithErrorRecovery:!1});return U.map(_=>(f.parse(_),f.lexingErrors.length>0?f.lexingErrors.map($=>({errorMessage:$.additionalInfo?(0,k.localize)(9,null,$.additionalInfo):(0,k.localize)(10,null),offset:$.offset,length:$.lexeme.length})):f.parsingErrors.length>0?f.parsingErrors.map($=>({errorMessage:$.additionalInfo?`${$.message}. ${$.additionalInfo}`:$.message,offset:$.offset,length:$.lexeme.length})):[]))}e.validateWhenClauses=o;function n(U,f){const _=U?U.substituteConstants():void 0,$=f?f.substituteConstants():void 0;return!_&&!$?!0:!_||!$?!1:_.equals($)}e.expressionsAreEqualWithConstantSubstitution=n;function s(U,f){return U.cmp(f)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return r.INSTANCE}}e.ContextKeyFalseExpr=i;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return i.INSTANCE}}e.ContextKeyTrueExpr=r;class a{static create(f,_=null){const $=P.get(f);return typeof $=="boolean"?$?r.INSTANCE:i.INSTANCE:new a(f,_)}constructor(f,_){this.key=f,this.negated=_,this.type=2}cmp(f){return f.type!==this.type?this.type-f.type:z(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}substituteConstants(){const f=P.get(this.key);return typeof f=="boolean"?f?r.INSTANCE:i.INSTANCE:this}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return this.negated||(this.negated=O.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=a;class p{static create(f,_,$=null){if(typeof _=="boolean")return _?a.create(f,$):O.create(f,$);const H=P.get(f);return typeof H=="boolean"?_===(H?"true":"false")?r.INSTANCE:i.INSTANCE:new p(f,_,$)}constructor(f,_,$){this.key=f,this.value=_,this.negated=$,this.type=4}cmp(f){return f.type!==this.type?this.type-f.type:ee(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}substituteConstants(){const f=P.get(this.key);if(typeof f=="boolean"){const _=f?"true":"false";return this.value===_?r.INSTANCE:i.INSTANCE}return this}evaluate(f){return f.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(f){return f.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class m{static create(f,_){return new m(f,_)}constructor(f,_){this.key=f,this.valueKey=_,this.type=10,this.negated=null}cmp(f){return f.type!==this.type?this.type-f.type:ee(this.key,this.valueKey,f.key,f.valueKey)}equals(f){return f.type===this.type?this.key===f.key&&this.valueKey===f.valueKey:!1}substituteConstants(){return this}evaluate(f){const _=f.getValue(this.valueKey),$=f.getValue(this.key);return Array.isArray(_)?_.includes($):typeof $=="string"&&typeof _=="object"&&_!==null?I.call(_,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(f){return f.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=m;class d{static create(f,_){return new d(f,_)}constructor(f,_){this.key=f,this.valueKey=_,this.type=11,this._negated=m.create(f,_)}cmp(f){return f.type!==this.type?this.type-f.type:this._negated.cmp(f._negated)}equals(f){return f.type===this.type?this._negated.equals(f._negated):!1}substituteConstants(){return this}evaluate(f){return!this._negated.evaluate(f)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(f){return f.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=d;class b{static create(f,_,$=null){if(typeof _=="boolean")return _?O.create(f,$):a.create(f,$);const H=P.get(f);return typeof H=="boolean"?_===(H?"true":"false")?i.INSTANCE:r.INSTANCE:new b(f,_,$)}constructor(f,_,$){this.key=f,this.value=_,this.negated=$,this.type=5}cmp(f){return f.type!==this.type?this.type-f.type:ee(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}substituteConstants(){const f=P.get(this.key);if(typeof f=="boolean"){const _=f?"true":"false";return this.value===_?i.INSTANCE:r.INSTANCE}return this}evaluate(f){return f.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(f){return f.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class O{static create(f,_=null){const $=P.get(f);return typeof $=="boolean"?$?i.INSTANCE:r.INSTANCE:new O(f,_)}constructor(f,_){this.key=f,this.negated=_,this.type=3}cmp(f){return f.type!==this.type?this.type-f.type:z(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}substituteConstants(){const f=P.get(this.key);return typeof f=="boolean"?f?i.INSTANCE:r.INSTANCE:this}evaluate(f){return!f.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(f){return f.mapNot(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=O;function F(U,f){if(typeof U=="string"){const _=parseFloat(U);isNaN(_)||(U=_)}return typeof U=="string"||typeof U=="number"?f(U):i.INSTANCE}class M{static create(f,_,$=null){return F(_,H=>new M(f,H,$))}constructor(f,_,$){this.key=f,this.value=_,this.negated=$,this.type=12}cmp(f){return f.type!==this.type?this.type-f.type:ee(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}substituteConstants(){return this}evaluate(f){return typeof this.value=="string"?!1:parseFloat(f.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=B.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=M;class q{static create(f,_,$=null){return F(_,H=>new q(f,H,$))}constructor(f,_,$){this.key=f,this.value=_,this.negated=$,this.type=13}cmp(f){return f.type!==this.type?this.type-f.type:ee(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}substituteConstants(){return this}evaluate(f){return typeof this.value=="string"?!1:parseFloat(f.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=j.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=q;class j{static create(f,_,$=null){return F(_,H=>new j(f,H,$))}constructor(f,_,$){this.key=f,this.value=_,this.negated=$,this.type=14}cmp(f){return f.type!==this.type?this.type-f.type:ee(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}substituteConstants(){return this}evaluate(f){return typeof this.value=="string"?!1:parseFloat(f.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=q.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=j;class B{static create(f,_,$=null){return F(_,H=>new B(f,H,$))}constructor(f,_,$){this.key=f,this.value=_,this.negated=$,this.type=15}cmp(f){return f.type!==this.type?this.type-f.type:ee(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}substituteConstants(){return this}evaluate(f){return typeof this.value=="string"?!1:parseFloat(f.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=B;class Q{static create(f,_){return new Q(f,_)}constructor(f,_){this.key=f,this.regexp=_,this.type=7,this.negated=null}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.key<f.key)return-1;if(this.key>f.key)return 1;const _=this.regexp?this.regexp.source:"",$=f.regexp?f.regexp.source:"";return _<$?-1:_>$?1:0}equals(f){if(f.type===this.type){const _=this.regexp?this.regexp.source:"",$=f.regexp?f.regexp.source:"";return this.key===f.key&&_===$}return!1}substituteConstants(){return this}evaluate(f){const _=f.getValue(this.key);return this.regexp?this.regexp.test(_):!1}serialize(){const f=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${f}`}keys(){return[this.key]}map(f){return f.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=J.create(this)),this.negated}}e.ContextKeyRegexExpr=Q;class J{static create(f){return new J(f)}constructor(f){this._actual=f,this.type=8}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}substituteConstants(){return this}evaluate(f){return!this._actual.evaluate(f)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(f){return new J(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=J;function G(U){let f=null;for(let _=0,$=U.length;_<$;_++){const H=U[_].substituteConstants();if(U[_]!==H&&f===null){f=[];for(let W=0;W<_;W++)f[W]=U[W]}f!==null&&(f[_]=H)}return f===null?U:f}class X{static create(f,_,$){return X._normalizeArr(f,_,$)}constructor(f,_){this.expr=f,this.negated=_,this.type=6}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let _=0,$=this.expr.length;_<$;_++){const H=s(this.expr[_],f.expr[_]);if(H!==0)return H}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let _=0,$=this.expr.length;_<$;_++)if(!this.expr[_].equals(f.expr[_]))return!1;return!0}return!1}substituteConstants(){const f=G(this.expr);return f===this.expr?this:X.create(f,this.negated,!1)}evaluate(f){for(let _=0,$=this.expr.length;_<$;_++)if(!this.expr[_].evaluate(f))return!1;return!0}static _normalizeArr(f,_,$){const H=[];let W=!1;for(const K of f)if(K){if(K.type===1){W=!0;continue}if(K.type===0)return i.INSTANCE;if(K.type===6){H.push(...K.expr);continue}H.push(K)}if(H.length===0&&W)return r.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(s);for(let K=1;K<H.length;K++)H[K-1].equals(H[K])&&(H.splice(K,1),K--);if(H.length===1)return H[0];for(;H.length>1;){const K=H[H.length-1];if(K.type!==9)break;H.pop();const Z=H.pop(),se=H.length===0,ue=V.create(K.expr.map(he=>X.create([he,Z],null,$)),null,se);ue&&(H.push(ue),H.sort(s))}if(H.length===1)return H[0];if($){for(let K=0;K<H.length;K++)for(let Z=K+1;Z<H.length;Z++)if(H[K].negate().equals(H[Z]))return i.INSTANCE;if(H.length===1)return H[0]}return new X(H,_)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(const _ of this.expr)f.push(..._.keys());return f}map(f){return new X(this.expr.map(_=>_.map(f)),null)}negate(){if(!this.negated){const f=[];for(const _ of this.expr)f.push(_.negate());this.negated=V.create(f,this,!0)}return this.negated}}e.ContextKeyAndExpr=X;class V{static create(f,_,$){return V._normalizeArr(f,_,$)}constructor(f,_){this.expr=f,this.negated=_,this.type=9}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let _=0,$=this.expr.length;_<$;_++){const H=s(this.expr[_],f.expr[_]);if(H!==0)return H}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let _=0,$=this.expr.length;_<$;_++)if(!this.expr[_].equals(f.expr[_]))return!1;return!0}return!1}substituteConstants(){const f=G(this.expr);return f===this.expr?this:V.create(f,this.negated,!1)}evaluate(f){for(let _=0,$=this.expr.length;_<$;_++)if(this.expr[_].evaluate(f))return!0;return!1}static _normalizeArr(f,_,$){let H=[],W=!1;if(f){for(let K=0,Z=f.length;K<Z;K++){const se=f[K];if(se){if(se.type===0){W=!0;continue}if(se.type===1)return r.INSTANCE;if(se.type===9){H=H.concat(se.expr);continue}H.push(se)}}if(H.length===0&&W)return i.INSTANCE;H.sort(s)}if(H.length!==0){if(H.length===1)return H[0];for(let K=1;K<H.length;K++)H[K-1].equals(H[K])&&(H.splice(K,1),K--);if(H.length===1)return H[0];if($){for(let K=0;K<H.length;K++)for(let Z=K+1;Z<H.length;Z++)if(H[K].negate().equals(H[Z]))return r.INSTANCE;if(H.length===1)return H[0]}return new V(H,_)}}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(const _ of this.expr)f.push(..._.keys());return f}map(f){return new V(this.expr.map(_=>_.map(f)),null)}negate(){if(!this.negated){const f=[];for(const _ of this.expr)f.push(_.negate());for(;f.length>1;){const _=f.shift(),$=f.shift(),H=[];for(const W of re(_))for(const K of re($))H.push(X.create([W,K],null,!1));f.unshift(V.create(H,null,!1))}this.negated=V.create(f,this,!0)}return this.negated}}e.ContextKeyOrExpr=V;class x extends a{static{this._info=[]}static all(){return x._info.values()}constructor(f,_,$){super(f,null),this._defaultValue=_,typeof $=="object"?x._info.push({...$,key:f}):$!==!0&&x._info.push({key:f,description:$,type:_!=null?typeof _:void 0})}bindTo(f){return f.createKey(this.key,this._defaultValue)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(f){return p.create(this.key,f)}notEqualsTo(f){return b.create(this.key,f)}}e.RawContextKey=x,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function z(U,f){return U<f?-1:U>f?1:0}function ee(U,f,_,$){return U<_?-1:U>_?1:f<$?-1:f>$?1:0}function ne(U,f){if(U.type===0||f.type===1)return!0;if(U.type===9)return f.type===9?ce(U.expr,f.expr):!1;if(f.type===9){for(const _ of f.expr)if(ne(U,_))return!0;return!1}if(U.type===6){if(f.type===6)return ce(f.expr,U.expr);for(const _ of U.expr)if(ne(_,f))return!0;return!1}return U.equals(f)}e.implies=ne;function ce(U,f){let _=0,$=0;for(;_<U.length&&$<f.length;){const H=U[_].cmp(f[$]);if(H<0)return!1;H===0&&_++,$++}return _===U.length}function re(U){return U.type===9?U.expr:[U]}}),define(oe[95],ae([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function N(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=N;class T{async getPerformanceInfo(k,D){return{}}async getSystemInfo(k,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,D){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=T}),define(oe[96],ae([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(oe[15],ae([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[29],ae([0,1,149,4]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function T(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function k(h,y){switch(h){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":y==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function D(h,y){return y==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function P(h,y,E){return D(y,E)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===E?!0:v(E).includes(h)}e.isTargetPlatformCompatible=P;function v(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=v;function I(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=I;var C;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var S;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var u;(function(h){h.Install="install",h.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var g;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.IExtensionGalleryService=(0,N.createDecorator)("extensionGalleryService");var w;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var c;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class l extends Error{constructor(y,E){super(y),this.code=E,this.name=E}}e.ExtensionManagementError=l,e.IExtensionManagementService=(0,N.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,N.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,N.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,L.localize)(1,null),original:"Preferences"}}),define(oe[184],ae([0,1,3,2,30,10,91,29]),function(te,e,L,N,T,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(c,l){return c?A.URI.revive(l?l.transformIncoming(c):c):void 0}function v(c,l){return l?l.transformOutgoingURI(c):c}function I(c,l){l=l||k.DefaultURITransformer;const h=c.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...c,manifest:void 0},l),manifest:h}}function C(c,l){return c?.profileLocation?(0,k.transformAndReviveIncomingURIs)(c,l??k.DefaultURITransformer):c}function S(c,l){return l?(0,T.cloneAndChange)(c,h=>h instanceof A.URI?l.transformOutgoingURI(h):void 0):c}class u{constructor(l,h){this.service=l,this.getUriTransformer=h,this.onInstallExtension=L.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=L.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,h){const y=this.getUriTransformer(l);switch(h){case"onInstallExtension":return L.Event.map(this.onInstallExtension,E=>({...E,profileLocation:E.profileLocation?v(E.profileLocation,y):E.profileLocation}));case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,E=>E.map(R=>({...R,local:R.local?S(R.local,y):R.local,profileLocation:R.profileLocation?v(R.profileLocation,y):R.profileLocation})));case"onUninstallExtension":return L.Event.map(this.onUninstallExtension,E=>({...E,profileLocation:E.profileLocation?v(E.profileLocation,y):E.profileLocation}));case"onDidUninstallExtension":return L.Event.map(this.onDidUninstallExtension,E=>({...E,profileLocation:E.profileLocation?v(E.profileLocation,y):E.profileLocation}));case"onDidUpdateExtensionMetadata":return L.Event.map(this.onDidUpdateExtensionMetadata,E=>S(E,y))}throw new Error("Invalid listen")}async call(l,h,y){const E=this.getUriTransformer(l);switch(h){case"zip":{const R=I(y[0],E),t=await this.service.zip(R);return v(t,E)}case"unzip":return this.service.unzip(P(y[0],E));case"install":return this.service.install(P(y[0],E),C(y[1],E));case"installFromLocation":return this.service.installFromLocation(P(y[0],E),P(y[1],E));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(y[0],P(y[1],E),P(y[2],E));case"getManifest":return this.service.getManifest(P(y[0],E));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(y[0]);case"installFromGallery":return this.service.installFromGallery(y[0],C(y[1],E));case"installGalleryExtensions":{const R=y[0];return this.service.installGalleryExtensions(R.map(({extension:t,options:o})=>({extension:t,options:C(o,E)??{}})))}case"uninstall":return this.service.uninstall(I(y[0],E),C(y[1],E));case"reinstallFromGallery":return this.service.reinstallFromGallery(I(y[0],E));case"getInstalled":return(await this.service.getInstalled(y[0],P(y[1],E))).map(t=>S(t,E));case"toggleAppliationScope":{const R=await this.service.toggleAppliationScope(I(y[0],E),P(y[1],E));return S(R,E)}case"copyExtensions":return this.service.copyExtensions(P(y[0],E),P(y[1],E));case"updateMetadata":{const R=await this.service.updateMetadata(I(y[0],E),y[1],P(y[2],E));return S(R,E)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(y[0],y[1],y[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=u;class g extends N.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(l){super(),this.channel=l,this._onInstallExtension=this._register(new L.Emitter),this._onDidInstallExtensions=this._register(new L.Emitter),this._onUninstallExtension=this._register(new L.Emitter),this._onDidUninstallExtension=this._register(new L.Emitter),this._onDidUpdateExtensionMetadata=this._register(new L.Emitter),this._register(this.channel.listen("onInstallExtension")(h=>this.fireEvent(this._onInstallExtension,{...h,source:this.isUriComponents(h.source)?A.URI.revive(h.source):h.source,profileLocation:A.URI.revive(h.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(h=>this.fireEvent(this._onDidInstallExtensions,h.map(y=>({...y,local:y.local?I(y.local,null):y.local,source:this.isUriComponents(y.source)?A.URI.revive(y.source):y.source,profileLocation:A.URI.revive(y.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(h=>this.fireEvent(this._onUninstallExtension,{...h,profileLocation:A.URI.revive(h.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(h=>this.fireEvent(this._onDidUninstallExtension,{...h,profileLocation:A.URI.revive(h.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(h=>this._onDidUpdateExtensionMetadata.fire(I(h,null))))}fireEvent(l,h){l.fire(h)}isUriComponents(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(l){const h=await this.getTargetPlatform();return l.allTargetPlatforms.some(y=>(0,D.isTargetPlatformCompatible)(y,l.allTargetPlatforms,h))}zip(l){return Promise.resolve(this.channel.call("zip",[l]).then(h=>A.URI.revive(h)))}unzip(l){return Promise.resolve(this.channel.call("unzip",[l]))}install(l,h){return Promise.resolve(this.channel.call("install",[l,h])).then(y=>I(y,null))}installFromLocation(l,h){return Promise.resolve(this.channel.call("installFromLocation",[l,h])).then(y=>I(y,null))}async installExtensionsFromProfile(l,h,y){return(await this.channel.call("installExtensionsFromProfile",[l,h,y])).map(R=>I(R,null))}getManifest(l){return Promise.resolve(this.channel.call("getManifest",[l]))}installFromGallery(l,h){return Promise.resolve(this.channel.call("installFromGallery",[l,h])).then(y=>I(y,null))}async installGalleryExtensions(l){return(await this.channel.call("installGalleryExtensions",[l])).map(y=>({...y,local:y.local?I(y.local,null):y.local,source:this.isUriComponents(y.source)?A.URI.revive(y.source):y.source,profileLocation:A.URI.revive(y.profileLocation)}))}uninstall(l,h){return Promise.resolve(this.channel.call("uninstall",[l,h]))}reinstallFromGallery(l){return Promise.resolve(this.channel.call("reinstallFromGallery",[l])).then(h=>I(h,null))}getInstalled(l=null,h){return Promise.resolve(this.channel.call("getInstalled",[l,h])).then(y=>y.map(E=>I(E,null)))}updateMetadata(l,h,y){return Promise.resolve(this.channel.call("updateMetadata",[l,h,y])).then(E=>I(E,null))}toggleAppliationScope(l,h){return this.channel.call("toggleAppliationScope",[l,h]).then(y=>I(y,null))}copyExtensions(l,h){return this.channel.call("copyExtensions",[l,h])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(l,h,y){const E=await this.channel.call("download",[l,h,y]);return A.URI.revive(E)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=g;class w{constructor(l){this.service=l}listen(l,h){throw new Error("Invalid listen")}call(l,h,y){switch(h){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(y[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=w}),define(oe[97],ae([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,L.createDecorator)("IExtensionSignatureVerificationService");class N{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((A,k)=>te(["node-vsce-sign"],async D=>A(D),k))),this.moduleLoadingPromise}async verify(A,k,D){let P;try{P=await this.vsceSign()}catch{return!1}return P.verify(A,k,D)}}e.ExtensionSignatureVerificationService=N}),define(oe[98],ae([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var N;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function T(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=T;var A;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[13],ae([0,1,47,16,27,11,10,156,4,5,26]),function(te,e,L,N,T,A,k,D,P,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function C(z){return z.create===!0}e.isFileOpenForWriteOptions=C;var S;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var u;(function(z){z[z.Readonly=1]="Readonly",z[z.Locked=2]="Locked"})(u||(e.FilePermission=u={}));var g;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileAtomicWrite=32768]="FileAtomicWrite",z[z.FileAtomicDelete=65536]="FileAtomicDelete",z[z.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function w(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=w;function c(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=c;function l(z){return!!(z.capabilities&131072)}e.hasFileCloneCapability=l;function h(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function y(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=y;function E(z){return w(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=E;function R(z){return w(z)?!!(z.capabilities&32768):!1}e.hasFileAtomicWriteCapability=R;function t(z){return!!(z.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;function o(z){return!!(z.capabilities&2048)}e.hasReadonlyCapability=o;var n;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsStorageQuota="EntryExceedsStorageQuota",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class s extends Error{static create(ee,ne){const ce=new s(ee.toString(),ne);return a(ce,ne),ce}constructor(ee,ne){super(ee),this.code=ne}}e.FileSystemProviderError=s;function i(z,ee){return s.create(z,ee)}e.createFileSystemProviderError=i;function r(z){return z||i((0,D.localize)(0,null),n.Unknown)}e.ensureFileSystemProviderError=r;function a(z,ee){return z.name=ee?`${ee} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=a;function p(z){if(!z)return n.Unknown;if(z instanceof s)return z.code;const ee=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!ee)return n.Unknown;switch(ee[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.toFileSystemProviderErrorCode=p;function m(z){if(z instanceof q)return z.fileOperationResult;switch(p(z)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=m;var d;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(d||(e.FileOperation=d={}));class b{constructor(ee,ne,ce){this.resource=ee,this.operation=ne,this.target=ce}isOperation(ee){return this.operation===ee}}e.FileOperationEvent=b;var O;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class F{constructor(ee,ne){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const re of ee){const U=ce.get(re.type);switch(U?U.push([re.resource,re]):ce.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,U]of ce)switch(re){case 1:this.added=L.TernarySearchTree.forUris(()=>ne),this.added.fill(U);break;case 0:this.updated=L.TernarySearchTree.forUris(()=>ne),this.updated.fill(U);break;case 2:this.deleted=L.TernarySearchTree.forUris(()=>ne),this.deleted.fill(U);break}}contains(ee,...ne){return this.doContains(ee,{includeChildren:!1},...ne)}affects(ee,...ne){return this.doContains(ee,{includeChildren:!0},...ne)}doContains(ee,ne,...ce){if(!ee)return!1;const re=ce.length>0;return!!((!re||ce.includes(1))&&(this.added?.get(ee)||ne.includeChildren&&this.added?.findSuperstr(ee))||(!re||ce.includes(0))&&(this.updated?.get(ee)||ne.includeChildren&&this.updated?.findSuperstr(ee))||(!re||ce.includes(2))&&(this.deleted?.findSubstr(ee)||ne.includeChildren&&this.deleted?.findSuperstr(ee)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=F;function M(z,ee,ne){return!z||!ee||z===ee||ee.length>z.length?!1:(ee.charAt(ee.length-1)!==N.sep&&(ee+=N.sep),ne?(0,T.startsWithIgnoreCase)(z,ee):z.indexOf(ee)===0)}e.isParent=M;class q extends Error{constructor(ee,ne,ce){super(ee),this.fileOperationResult=ne,this.options=ce}}e.FileOperationError=q;class j extends q{constructor(ee,ne,ce,re){super(ee,ne,re),this.fileOperationResult=ne,this.size=ce}}e.TooLargeFileOperationError=j;class B extends q{constructor(ee,ne,ce){super(ee,2,ce),this.stat=ne}}e.NotModifiedSinceFileOperationError=B;var Q;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var J;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(J||(e.FileKind=J={})),e.ETAG_DISABLED="";function G(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=G;async function X(z,ee){if(!ee.hasProvider(k.URI.from({scheme:z.scheme})))return new Promise(ne=>{const ce=ee.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===z.scheme&&re.added&&(ce.dispose(),ne())})})}e.whenProviderRegistered=X;class V{static{this.KB=1024}static{this.MB=V.KB*V.KB}static{this.GB=V.MB*V.KB}static{this.TB=V.GB*V.KB}static formatSize(ee){return(0,A.isNumber)(ee)||(ee=0),ee<V.KB?(0,D.localize)(1,null,ee.toFixed(0)):ee<V.MB?(0,D.localize)(2,null,(ee/V.KB).toFixed(2)):ee<V.GB?(0,D.localize)(3,null,(ee/V.MB).toFixed(2)):ee<V.TB?(0,D.localize)(4,null,(ee/V.GB).toFixed(2)):(0,D.localize)(5,null,(ee/V.TB).toFixed(2))}}e.ByteSize=V;function x(z){const ee=typeof z=="string"||z?.scheme===I.Schemas.vscodeRemote;return typeof z!="string"&&z?.scheme===I.Schemas.file?1024*V.MB:ee?10*V.MB:v.isWeb?50*V.MB:1024*V.MB}e.getLargeFileConfirmationLimit=x});var Y=this&&this.__param||function(te,e){return function(L,N){e(L,N,te)}};define(oe[185],ae([0,1,67,42,13]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(D){this.fileService=D}async checksum(D){const P=(await this.fileService.readFileStream(D)).value;return new Promise((v,I)=>{const C=(0,L.createHash)("md5");(0,N.listenStream)(P,{onData:S=>C.update(S.buffer),onError:S=>I(S),onEnd:()=>v(C.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=A,e.ChecksumService=A=ve([Y(0,T.IFileService)],A)}),define(oe[186],ae([0,1,14,38,7,3,2,42,10,32,13]),function(te,e,L,N,T,A,k,D,P,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends k.Disposable{constructor(u,g){super(),this.channel=u,this.extraCapabilities=g,this.onDidChangeCapabilities=A.Event.None,this._onDidChange=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,v.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(u){return this.channel.call("stat",[u])}readdir(u){return this.channel.call("readdir",[u])}async readFile(u,g){const{buffer:w}=await this.channel.call("readFile",[u,g]);return w}readFileStream(u,g,w){const c=(0,D.newWriteableStream)(h=>L.VSBuffer.concat(h.map(y=>L.VSBuffer.wrap(y))).buffer),l=this.channel.listen("readFileStream",[u,g])(h=>{if(h instanceof L.VSBuffer)c.write(h.buffer);else{if(h==="end")c.end();else{let y;if(h instanceof Error)y=h;else{const E=h;y=(0,I.createFileSystemProviderError)(E.message??(0,N.toErrorMessage)(E),E.code??I.FileSystemProviderErrorCode.Unknown)}c.error(y),c.end()}l.dispose()}});return w.onCancellationRequested(()=>{c.error((0,T.canceled)()),c.end(),l.dispose()}),c}writeFile(u,g,w){return this.channel.call("writeFile",[u,L.VSBuffer.wrap(g),w])}open(u,g){return this.channel.call("open",[u,g])}close(u){return this.channel.call("close",[u])}async read(u,g,w,c,l){const[h,y]=await this.channel.call("read",[u,g,l]);return w.set(h.buffer.slice(0,y),c),y}write(u,g,w,c,l){return this.channel.call("write",[u,g,L.VSBuffer.wrap(w),c,l])}mkdir(u){return this.channel.call("mkdir",[u])}delete(u,g){return this.channel.call("delete",[u,g])}rename(u,g,w){return this.channel.call("rename",[u,g,w])}copy(u,g,w){return this.channel.call("copy",[u,g,w])}cloneFile(u,g){return this.channel.call("cloneFile",[u,g])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(u=>{if(Array.isArray(u)){const g=u;this._onDidChange.fire(g.map(w=>({resource:P.URI.revive(w.resource),type:w.type})))}else{const g=u;this._onDidWatchError.fire(g)}}))}watch(u,g){const w=(0,v.generateUuid)();return this.channel.call("watch",[this.sessionId,w,u,g]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,w]))}}e.DiskFileSystemProviderClient=C}),define(oe[99],ae([0,1,14,7,157,13]),function(te,e,L,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(I,C,S,u,g,w){let c;try{await D(I,C,S,u,g,w)}catch(l){c=l}finally{c&&g.errorTransformer&&(c=g.errorTransformer(c)),typeof c<"u"&&S.error(c),S.end()}}e.readFileIntoStream=k;async function D(I,C,S,u,g,w){P(w);const c=await I.open(C,{create:!1});try{P(w);let l=0,h=0,y=g&&typeof g.length=="number"?g.length:void 0,E=L.VSBuffer.alloc(Math.min(g.bufferSize,typeof y=="number"?y:g.bufferSize)),R=g&&typeof g.position=="number"?g.position:0,t=0;do h=await I.read(c,R,E.buffer,t,E.byteLength-t),R+=h,t+=h,l+=h,typeof y=="number"&&(y-=h),t===E.byteLength&&(await S.write(u(E)),E=L.VSBuffer.alloc(Math.min(g.bufferSize,typeof y=="number"?y:g.bufferSize)),t=0);while(h>0&&(typeof y!="number"||y>0)&&P(w)&&v(l,g));if(t>0){let o=t;typeof y=="number"&&(o=Math.min(t,y)),S.write(u(E.slice(0,o)))}}catch(l){throw(0,A.ensureFileSystemProviderError)(l)}finally{await I.close(c)}}function P(I){if(I.isCancellationRequested)throw(0,N.canceled)();return!0}function v(I,C){if(typeof C?.limits?.size=="number"&&I>C.limits.size)throw(0,A.createFileSystemProviderError)((0,T.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[54],ae([0,1,90,2,16,5,10,13]),function(te,e,L,N,T,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function P(l){return l.recursive===!0}e.isRecursiveWatchRequest=P;class v extends N.Disposable{static{this.MAX_RESTARTS=5}constructor(h,y,E,R){super(),this.onFileChanges=h,this.onLogMessage=y,this.verboseLogging=E,this.options=R,this.watcherDisposables=this._register(new N.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const h=new N.DisposableStore;this.watcherDisposables.value=h,this.watcher=this.createWatcher(h),this.watcher.setVerboseLogging(this.verboseLogging),h.add(this.watcher.onDidChangeFile(y=>this.onFileChanges(y))),h.add(this.watcher.onDidLogMessage(y=>this.onLogMessage(y))),h.add(this.watcher.onDidError(y=>this.onError(y)))}onError(h){this.options.restartOnError?this.restartCounter<v.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${h}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${h}`):this.error(h)}restart(h){this.restartCounter++,this.init(),this.watch(h)}async watch(h){this.requests=h,await this.watcher?.watch(h)}async setVerboseLogging(h){this.verboseLogging=h,await this.watcher?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${h}`})}trace(h){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${h}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=v;class I extends v{constructor(h,y,E){super(h,y,E,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class C extends v{constructor(h,y,E){super(h,y,E,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function S(l){return l.map(h=>({type:h.type,resource:k.URI.file(h.path)}))}e.toFileChanges=S;function u(l){const h=new c;for(const y of l)h.processEvent(y);return h.coalesce()}e.coalesceEvents=u;function g(l,h){return typeof h=="string"&&!h.startsWith(L.GLOBSTAR)&&!(0,T.isAbsolute)(h)?{base:l,pattern:h}:h}e.normalizeWatcherPattern=g;function w(l,h){const y=[];for(const E of h)y.push((0,L.parse)(g(l,E)));return y}e.parseWatcherPatterns=w;class c{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(h){return A.isLinux?h.path:h.path.toLowerCase()}processEvent(h){const y=this.mapPathToChange.get(this.toKey(h));let E=!1;if(y){const R=y.type,t=h.type;y.path!==h.path&&(h.type===2||h.type===1)?E=!0:R===1&&t===2?(this.mapPathToChange.delete(this.toKey(h)),this.coalesced.delete(y)):R===2&&t===1?y.type=0:R===1&&t===0||(y.type=t)}else E=!0;E&&(this.coalesced.add(h),this.mapPathToChange.set(this.toKey(h),h))}coalesce(){const h=[],y=[];return Array.from(this.coalesced).filter(E=>E.type!==2?(h.push(E),!1):!0).sort((E,R)=>E.path.length-R.path.length).filter(E=>y.some(R=>(0,D.isParent)(E.path,R,!A.isLinux))?!1:(y.push(E.path),!0)).concat(h)}}}),define(oe[187],ae([0,1,52,6,25,48,2,86,16,5,140,31,54]),function(te,e,L,N,T,A,k,D,P,v,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends k.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(c,l,h,y){super(),this.request=c,this.onDidFilesChange=l,this.onLogMessage=h,this.verboseLogging=y,this.throttledFileChangesEmitter=this._register(new N.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.onDidFilesChange(E))),this.fileChangesAggregator=this._register(new N.RunOnceWorker(E=>this.handleFileChanges(E),u.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new T.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const c=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const l=await C.Promises.stat(c);this._register(await this.doWatch(c,l.isDirectory()))}catch(c){c.code!=="ENOENT"?this.error(c):this.trace(c)}}async normalizePath(c){let l=c.path;try{l=await C.Promises.realpath(c.path),c.path===l&&(l=await(0,I.realcase)(c.path)??c.path),c.path!==l&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${l})`)}catch{}return l}async doWatch(c,l){if(v.isMacintosh&&(0,A.isEqualOrParent)(c,"/Volumes/",!0))return this.error(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const h=new T.CancellationTokenSource(this.cts.token),y=new k.DisposableStore;try{const E=(0,P.basename)(c),R=(0,L.watch)(c);y.add((0,k.toDisposable)(()=>{R.removeAllListeners(),R.close()})),this.trace(`Started watching: '${c}'`);const t=new Set;if(l)try{for(const n of await C.Promises.readdir(c))t.add(n)}catch(n){this.error(n)}const o=new Map;y.add((0,k.toDisposable)(()=>{for(const[,n]of o)n.dispose();o.clear()})),R.on("error",(n,s)=>{this.error(`Failed to watch ${c} for changes using fs.watch() (${n}, ${s})`),this.dispose()}),R.on("change",(n,s)=>{if(h.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${s}`);let i="";if(s&&(i=s.toString(),v.isMacintosh&&(i=(0,D.normalizeNFC)(i))),!(!i||n!=="change"&&n!=="rename"))if(l)if(n==="rename"){o.get(i)?.dispose();const r=setTimeout(async()=>{if(o.delete(i),i===E&&!await C.Promises.exists(c)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,P.join)(c,i));if(h.token.isCancellationRequested)return;let p;a?t.has(i)?p=0:(p=1,t.add(i)):(t.delete(i),p=2),this.onFileChange({path:(0,P.join)(this.request.path,i),type:p})},u.FILE_DELETE_HANDLER_DELAY);o.set(i,(0,k.toDisposable)(()=>clearTimeout(r)))}else{let r;t.has(i)?r=0:(r=1,t.add(i)),this.onFileChange({path:(0,P.join)(this.request.path,i),type:r})}else if(n==="rename"||i!==E){const r=setTimeout(async()=>{const a=await C.Promises.exists(c);h.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),y.add(await this.doWatch(c,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},u.FILE_DELETE_HANDLER_DELAY);y.clear(),y.add((0,k.toDisposable)(()=>clearTimeout(r)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(E){await C.Promises.exists(c)&&!h.token.isCancellationRequested&&this.error(`Failed to watch ${c} for changes using fs.watch() (${E.toString()})`)}return(0,k.toDisposable)(()=>{h.dispose(!0),y.dispose()})}onFileChange(c,l=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`),!l&&this.excludes.some(h=>h(c.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${c.path}`):!l&&this.includes&&this.includes.length>0&&!this.includes.some(h=>h(c.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${c.path}`):this.fileChangesAggregator.work(c))}handleFileChanges(c){const l=(0,S.coalesceEvents)(c);if(l.length>0){if(this.verboseLogging)for(const y of l)this.trace(`>> normalized ${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`);this.throttledFileChangesEmitter.work(l)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(c){if(v.isLinux)return C.Promises.exists(c);try{const l=(0,P.basename)(c);return(await C.Promises.readdir((0,P.dirname)(c))).some(y=>y===l)}catch(l){return this.trace(l),!1}}setVerboseLogging(c){this.verboseLogging=c}error(c){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}warn(c){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}trace(c){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u;async function g(w,c,l,h,y=512){const E=await C.Promises.open(w,"r"),R=Buffer.allocUnsafe(y),t=new T.CancellationTokenSource(h);let o,n=!1;const s={path:w,excludes:[],recursive:!1},i=new u(s,r=>{(async()=>{for(const{type:a}of r)if(a===0){if(n)return;n=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:p}=await C.Promises.read(E,R,0,y,null);if(!p||t.token.isCancellationRequested)break;c(R.slice(0,p))}}catch(p){o=new Error(p),t.dispose(!0)}finally{n=!1}}})()});return await i.ready,l(),new Promise((r,a)=>{t.token.onCancellationRequested(async()=>{i.dispose();try{await C.Promises.close(E)}catch(p){o=new Error(p)}o?a(o):r()})})}e.watchFileContents=g}),define(oe[188],ae([0,1,3,90,2,5,187]),function(te,e,L,N,T,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class D extends T.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new L.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=L.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(v){const I=this.normalizeRequests(v),C=I.filter(u=>{const g=this.watchers.get(u.path);return g?!(0,N.patternsEquals)(g.request.excludes,u.excludes)||!(0,N.patternsEquals)(g.request.includes,u.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:u})=>!I.find(g=>g.path===u.path&&(0,N.patternsEquals)(g.excludes,u.excludes)&&(0,N.patternsEquals)(g.includes,u.includes))).map(({request:u})=>u.path);C.length&&this.trace(`Request to start watching: ${C.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const u of S)this.stopWatching(u);for(const u of C)this.startWatching(u)}startWatching(v){const I=new k.NodeJSFileWatcherLibrary(v,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),C={request:v,instance:I};this.watchers.set(v.path,C)}async stop(){for(const[v]of this.watchers)this.stopWatching(v);this.watchers.clear()}stopWatching(v){const I=this.watchers.get(v);I&&(this.watchers.delete(v),I.instance.dispose())}normalizeRequests(v){const I=new Map;for(const C of v){const S=A.isLinux?C.path:C.path.toLowerCase();I.set(S,C)}return Array.from(I.values())}async setVerboseLogging(v){this.verboseLogging=v;for(const[,I]of this.watchers)I.instance.setVerboseLogging(v)}trace(v){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(v)})}toMessage(v,I){return I?`[File Watcher (node.js)] ${v} (path: ${I.request.path})`:`[File Watcher (node.js)] ${v}`}}e.NodeJSWatcher=D}),define(oe[189],ae([0,1,54,188]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class T extends L.AbstractNonRecursiveWatcherClient{constructor(k,D,P){super(k,D,P),this.init()}createWatcher(){return new N.NodeJSWatcher}}e.NodeJSWatcherClient=T}),define(oe[190],ae([0,1,26,43,93,54]),function(te,e,L,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends A.AbstractUniversalWatcherClient{constructor(P,v,I){super(P,v,I),this.init()}createWatcher(P){const v=P.add(new T.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(v.onDidProcessExit(({code:I,signal:C})=>this.onError(`terminated by itself with code ${I}, signal: ${C}`))),N.ProxyChannel.toService((0,N.getNextTickChannel)(v.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(oe[68],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...T){this._entries=new Map;for(const[A,k]of T)this.set(A,k)}set(T,A){const k=this._entries.get(T);return this._entries.set(T,A),k}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=L}),define(oe[191],ae([0,1,6,7,2,66,182,4,68,85]),function(te,e,L,N,T,A,k,D,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class C extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class S{constructor(c=new P.ServiceCollection,l=!1,h,y=I){this._services=c,this._strict=l,this._parent=h,this._enableTracing=y,this._activeInstantiations=new Set,this._services.set(D.IInstantiationService,this),this._globalGraph=y?h?._globalGraph??new k.Graph(E=>E):void 0}createChild(c){return new S(c,this._strict,this,this._enableTracing)}invokeFunction(c,...l){const h=g.traceInvocation(this._enableTracing,c);let y=!1;try{return c({get:R=>{if(y)throw(0,N.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(R,h);if(!t)throw new Error(`[invokeFunction] unknown service '${R}'`);return t}},...l)}finally{y=!0,h.stop()}}createInstance(c,...l){let h,y;return c instanceof A.SyncDescriptor?(h=g.traceCreation(this._enableTracing,c.ctor),y=this._createInstance(c.ctor,c.staticArguments.concat(l),h)):(h=g.traceCreation(this._enableTracing,c),y=this._createInstance(c,l,h)),h.stop(),y}_createInstance(c,l=[],h){const y=D._util.getServiceDependencies(c).sort((t,o)=>t.index-o.index),E=[];for(const t of y){const o=this._getOrCreateServiceInstance(t.id,h);o||this._throwIfStrict(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(o)}const R=y.length>0?y[0].index:l.length;if(l.length!==R){console.trace(`[createInstance] First service dependency of ${c.name} at position ${R+1} conflicts with ${l.length} static arguments`);const t=R-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,R)}return Reflect.construct(c,l.concat(E))}_setServiceInstance(c,l){if(this._services.get(c)instanceof A.SyncDescriptor)this._services.set(c,l);else if(this._parent)this._parent._setServiceInstance(c,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){const l=this._services.get(c);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):l}_getOrCreateServiceInstance(c,l){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(c));const h=this._getServiceInstanceOrDescriptor(c);return h instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,h,l.branch(c,!0)):(l.branch(c,!1),h)}_safeCreateAndCacheServiceInstance(c,l,h){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,l,h)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,l,h){const y=new k.Graph(t=>t.id.toString());let E=0;const R=[{id:c,desc:l,_trace:h}];for(;R.length;){const t=R.pop();if(y.lookupOrInsertNode(t),E++>1e3)throw new C(y);for(const o of D._util.getServiceDependencies(t.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(o.id);if(n||this._throwIfStrict(`[createInstance] ${c} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),n instanceof A.SyncDescriptor){const s={id:o.id,desc:n,_trace:t._trace.branch(o.id,!0)};y.insertEdge(t,s),R.push(s)}}}for(;;){const t=y.roots();if(t.length===0){if(!y.isEmpty())throw new C(y);break}for(const{data:o}of t){if(this._getServiceInstanceOrDescriptor(o.id)instanceof A.SyncDescriptor){const s=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,s)}y.removeNode(o)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,l,h=[],y,E){if(this._services.get(c)instanceof A.SyncDescriptor)return this._createServiceInstance(c,l,h,y,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,l,h,y,E);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(c,l,h=[],y,E){if(y){const R=new S(void 0,this._strict,this,this._enableTracing);R._globalGraphImplicitDependency=String(c);const t=new Map,o=new L.IdleValue(()=>{const n=R._createInstance(l,h,E);for(const[s,i]of t){const r=n[s];if(typeof r=="function")for(const a of i)r.apply(n,a)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=t.get(s);return a||(a=new v.LinkedList,t.set(s,a)),(m,d,b)=>{const O=a.push([m,d,b]);return(0,T.toDisposable)(O)}}if(s in n)return n[s];const i=o.value;let r=i[s];return typeof r!="function"||(r=r.bind(i),n[s]=r),r},set(n,s,i){return o.value[s]=i,!0},getPrototypeOf(n){return l.prototype}})}else return this._createInstance(l,h,E)}_throwIfStrict(c,l){if(l&&console.warn(c),this._strict)throw new Error(c)}}e.InstantiationService=S;var u;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(u||(u={}));class g{static{this.all=new Set}static{this._None=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,l){return c?new g(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(c,l){return c?new g(1,l.name):g._None}static{this._totals=0}constructor(c,l){this.type=c,this.name=l,this._start=Date.now(),this._dep=[]}branch(c,l){const h=new g(3,c.toString());return this._dep.push([c,l,h]),h}stop(){const c=Date.now()-this._start;g._totals+=c;let l=!1;function h(E,R){const t=[],o=new Array(E+1).join("	");for(const[n,s,i]of R._dep)if(s&&i){l=!0,t.push(`${o}CREATES -> ${n}`);const r=h(E+1,i);r&&t.push(r)}else t.push(`${o}uses -> ${n}`);return t.join(`
`)}const y=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(c>2||l)&&g.all.add(y.join(`
`))}}e.Trace=g}),define(oe[69],ae([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,L.createDecorator)("mainProcessService");class N{constructor(A,k){this.server=A,this.router=k}getChannel(A){return this.server.getChannel(A,this.router)}registerChannel(A,k){this.server.registerChannel(A,k)}}e.MainProcessService=N}),define(oe[70],ae([0,1,25,2,5,159,29,4]),function(te,e,L,N,T,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function P(I){return I.tags.find(C=>C.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=P,e.ILanguagePackService=(0,D.createDecorator)("languagePackService");let v=class extends N.Disposable{constructor(C){super(),this.extensionGalleryService=C}async getAvailableLanguages(){const C=new L.CancellationTokenSource;setTimeout(()=>C.cancel(),1e3);let S;try{S=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},C.token)}catch{return[]}const g=S.firstPage.filter(w=>w.properties.localizedLanguages?.length&&w.tags.some(c=>c.startsWith("lp-"))).map(w=>{const c=w.properties.localizedLanguages?.[0],l=P(w);return{...this.createQuickPickItem(l,c,w),extensionId:w.identifier.id,galleryExtension:w}});return g.push(this.createQuickPickItem("en","English")),g}createQuickPickItem(C,S,u){const g=S??C;let w;if(g!==C&&(w=`(${C})`),C.toLowerCase()===T.language.toLowerCase()&&(w??="",w+=(0,A.localize)(0,null)),u?.installCount){w??="";const c=u.installCount;let l;c>1e6?l=`${Math.floor(c/1e5)/10}M`:c>1e3?l=`${Math.floor(c/1e3)}K`:l=String(c),w+=` $(cloud-download) ${l}`}return{id:C,label:g,description:w}}};e.LanguagePackBaseService=v,e.LanguagePackBaseService=v=ve([Y(0,k.IExtensionGalleryService)],v)}),define(oe[192],ae([0,1,2,70]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let T=class extends L.Disposable{constructor(k){super(),this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=T,e.LocalizationsUpdater=T=ve([Y(0,N.ILanguagePackService)],T)}),define(oe[8],ae([0,1,38,3,51,2,35,5,22,11,10,94,4]),function(te,e,L,N,T,A,k,D,P,v,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function u(){return new Date().toISOString()}function g(m){return(0,v.isNumber)(m)}e.isLogLevel=g;var w;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(w||(e.LogLevel=w={})),e.DEFAULT_LOG_LEVEL=w.Info;function c(m,d,b){switch(d){case w.Trace:m.trace(b);break;case w.Debug:m.debug(b);break;case w.Info:m.info(b);break;case w.Warning:m.warn(b);break;case w.Error:m.error(b);break;case w.Off:break;default:throw new Error(`Invalid log level ${d}`)}}e.log=c;function l(m,d=!1){let b="";for(let O=0;O<m.length;O++){let F=m[O];if(F instanceof Error&&(F=(0,L.toErrorMessage)(F,d)),typeof F=="object")try{F=JSON.stringify(F)}catch{}b+=(O>0?" ":"")+F}return b}class h extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new N.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(d){this.level!==d&&(this.level=d,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(d){return this.level!==w.Off&&this.level<=d}}e.AbstractLogger=h;class y extends h{constructor(d){super(),this.logAlways=d}checkLogLevel(d){return this.logAlways||super.checkLogLevel(d)}trace(d,...b){this.checkLogLevel(w.Trace)&&this.log(w.Trace,l([d,...b],!0))}debug(d,...b){this.checkLogLevel(w.Debug)&&this.log(w.Debug,l([d,...b]))}info(d,...b){this.checkLogLevel(w.Info)&&this.log(w.Info,l([d,...b]))}warn(d,...b){this.checkLogLevel(w.Warning)&&this.log(w.Warning,l([d,...b]))}error(d,...b){if(this.checkLogLevel(w.Error))if(d instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=d.stack,this.log(w.Error,l(O))}else this.log(w.Error,l([d,...b]))}flush(){}}e.AbstractMessageLogger=y;class E extends h{constructor(d=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(d),this.useColors=!D.isWindows}trace(d,...b){this.checkLogLevel(w.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,d,...b):console.log(`[main ${u()}]`,d,...b))}debug(d,...b){this.checkLogLevel(w.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,d,...b):console.log(`[main ${u()}]`,d,...b))}info(d,...b){this.checkLogLevel(w.Info)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,d,...b):console.log(`[main ${u()}]`,d,...b))}warn(d,...b){this.checkLogLevel(w.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,d,...b):console.warn(`[main ${u()}]`,d,...b))}error(d,...b){this.checkLogLevel(w.Error)&&(this.useColors?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,d,...b):console.error(`[main ${u()}]`,d,...b))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class R extends h{constructor(d=e.DEFAULT_LOG_LEVEL,b=!0){super(),this.useColors=b,this.setLevel(d)}trace(d,...b){this.checkLogLevel(w.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",d,...b):console.log(d,...b))}debug(d,...b){this.checkLogLevel(w.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",d,...b):console.log(d,...b))}info(d,...b){this.checkLogLevel(w.Info)&&(this.useColors?console.log("%c INFO","color: #33f",d,...b):console.log(d,...b))}warn(d,...b){this.checkLogLevel(w.Warning)&&(this.useColors?console.log("%c WARN","color: #993",d,...b):console.log(d,...b))}error(d,...b){this.checkLogLevel(w.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",d,...b):console.error(d,...b))}dispose(){}flush(){}}e.ConsoleLogger=R;class t extends h{constructor(d,b=e.DEFAULT_LOG_LEVEL){super(),this.adapter=d,this.setLevel(b)}trace(d,...b){this.checkLogLevel(w.Trace)&&this.adapter.log(w.Trace,[this.extractMessage(d),...b])}debug(d,...b){this.checkLogLevel(w.Debug)&&this.adapter.log(w.Debug,[this.extractMessage(d),...b])}info(d,...b){this.checkLogLevel(w.Info)&&this.adapter.log(w.Info,[this.extractMessage(d),...b])}warn(d,...b){this.checkLogLevel(w.Warning)&&this.adapter.log(w.Warning,[this.extractMessage(d),...b])}error(d,...b){this.checkLogLevel(w.Error)&&this.adapter.log(w.Error,[this.extractMessage(d),...b])}extractMessage(d){return typeof d=="string"?d:(0,L.toErrorMessage)(d,this.checkLogLevel(w.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class o extends h{constructor(d){super(),this.loggers=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const b of this.loggers)b.setLevel(d);super.setLevel(d)}trace(d,...b){for(const O of this.loggers)O.trace(d,...b)}debug(d,...b){for(const O of this.loggers)O.debug(d,...b)}info(d,...b){for(const O of this.loggers)O.info(d,...b)}warn(d,...b){for(const O of this.loggers)O.warn(d,...b)}error(d,...b){for(const O of this.loggers)O.error(d,...b)}flush(){for(const d of this.loggers)d.flush()}dispose(){for(const d of this.loggers)d.dispose()}}e.MultiplexLogger=o;class n extends A.Disposable{constructor(d,b,O){if(super(),this.logLevel=d,this.logsHome=b,this._loggers=new k.ResourceMap,this._onDidChangeLoggers=this._register(new N.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new N.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new N.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,O)for(const F of O)this._loggers.set(F.resource,{logger:void 0,info:F})}getLoggerEntry(d){return(0,v.isString)(d)?[...this._loggers.values()].find(b=>b.info.id===d):this._loggers.get(d)}getLogger(d){return this.getLoggerEntry(d)?.logger}createLogger(d,b){const O=this.toResource(d),F=(0,v.isString)(d)?d:b?.id??(0,T.hash)(O.toString()).toString(16);let M=this._loggers.get(O)?.logger;const q=b?.logLevel==="always"?w.Trace:b?.logLevel;M||(M=this.doCreateLogger(O,q??this.getLogLevel(O)??this.logLevel,{...b,id:F}));const j={logger:M,info:{resource:O,id:F,logLevel:q,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(j.info),this._loggers.set(O,j),M}toResource(d){return(0,v.isString)(d)?(0,P.joinPath)(this.logsHome,`${d}.log`):d}setLogLevel(d,b){if(I.URI.isUri(d)){const O=d,F=b,M=this._loggers.get(O);M&&F!==M.info.logLevel&&(M.info.logLevel=F===this.logLevel?void 0:F,M.logger?.setLevel(F),this._loggers.set(M.info.resource,M),this._onDidChangeLogLevel.fire([O,F]))}else{this.logLevel=d;for(const[O,F]of this._loggers.entries())this._loggers.get(O)?.info.logLevel===void 0&&F.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(d,b){const O=this.getLoggerEntry(d);O&&b!==!O.info.hidden&&(O.info.hidden=!b,this._loggers.set(O.info.resource,O),this._onDidChangeVisibility.fire([O.info.resource,b]))}getLogLevel(d){let b;return d&&(b=this._loggers.get(d)?.info.logLevel),b??this.logLevel}registerLogger(d){const b=this._loggers.get(d.resource);b?b.info.hidden!==d.hidden&&this.setVisibility(d.resource,!d.hidden):(this._loggers.set(d.resource,{info:d,logger:void 0}),this._onDidChangeLoggers.fire({added:[d],removed:[]}))}deregisterLogger(d){const b=this._loggers.get(d);b&&(b.logger&&b.logger.dispose(),this._loggers.delete(d),this._onDidChangeLoggers.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const d of this._loggers.values())yield d.info}getRegisteredLogger(d){return this._loggers.get(d)?.info}dispose(){this._loggers.forEach(d=>d.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class s{constructor(){this.onDidChangeLogLevel=new N.Emitter().event}setLevel(d){}getLevel(){return w.Info}trace(d,...b){}debug(d,...b){}info(d,...b){}warn(d,...b){}error(d,...b){}critical(d,...b){}dispose(){}flush(){}}e.NullLogger=s;class i extends s{}e.NullLogService=i;function r(m){if(m.verbose)return w.Trace;if(typeof m.logLevel=="string"){const d=p(m.logLevel.toLowerCase());if(d!==void 0)return d}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function a(m){switch(m){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.LogLevelToString=a;function p(m){switch(m){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.parseLogLevel=p,e.CONTEXT_LOG_LEVEL=new C.RawContextKey("logLevel",a(w.Info))}),define(oe[193],ae([0,1,6,7,2,22,31,15,8]),function(te,e,L,N,T,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let v=class extends T.Disposable{constructor(C,S){super(),this.environmentService=C,this.logService=S,this._register(new L.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,A.basename)(this.environmentService.logsHome),S=(0,A.dirname)(this.environmentService.logsHome),w=(await k.Promises.readdir(S.fsPath)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==C),c=w.slice(0,Math.max(0,w.length-9));c.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${c.join(", ")}'`),await Promise.all(c.map(l=>k.Promises.rm((0,A.joinPath)(S,l).fsPath))))}catch(C){(0,N.onUnexpectedError)(C)}}};e.LogsDataCleaner=v,e.LogsDataCleaner=v=ve([Y(0,D.IEnvironmentService),Y(1,P.ILogService)],v)}),define(oe[194],ae([0,1,21,6,7,3,2,16,54,8]),function(te,e,L,N,T,A,k,D,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends k.Disposable{constructor(S,u){super(),this.logService=S,this.options=u,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new N.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new N.ThrottledDelayer(0))}watch(S,u){return u.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,u):this.watchNonRecursive(S,u)}watchUniversal(S,u){const g={path:this.toFilePath(S),excludes:u.excludes,includes:u.includes,recursive:u.recursive},w=(0,L.insert)(this.universalPathsToWatch,g);return this.refreshUniversalWatchers(),(0,k.toDisposable)(()=>{w(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,T.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(u=>this._onDidChangeFile.fire((0,P.toFileChanges)(u)),u=>this.onWatcherLogMessage(u),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const u of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(u)&&(u.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const u of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(u)&&S.includes(u.path)&&(u.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,u){const g={path:this.toFilePath(S),excludes:u.excludes,includes:u.includes,recursive:!1},w=(0,L.insert)(this.nonRecursivePathsToWatch,g);return this.refreshNonRecursiveWatchers(),(0,k.toDisposable)(()=>{w(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,T.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,P.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,D.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(oe[195],ae([0,1,21,6,14,25,3,51,59,2,47,26,100,22,42,155,13,99,8,7]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let E=class extends v.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new N.ResourceQueue)}registerProvider(t,o){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${t}`);const n=new v.DisposableStore;return this.provider.set(t,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:o}),n.add(o.onDidChangeFile(s=>this._onDidFilesChange.fire(new c.FileChangesEvent(s,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&n.add(o.onDidWatchError(s=>this._onDidWatchError.fire(new Error(s)))),n.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:t}))),(0,v.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:o}),this.provider.delete(t),(0,v.dispose)(n)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(n){o.push(n)}}),!this.provider.has(t)&&await N.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,o){const n=this.provider.get(t.scheme);return!!(n&&n.capabilities&o)}listCapabilities(){return P.Iterable.map(this.provider,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async withProvider(t){if(!(0,u.isAbsolutePath)(t))throw new c.FileOperationError((0,w.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const o=this.provider.get(t.scheme);if(!o){const n=new y.ErrorNoTelemetry;throw n.message=(0,w.localize)(1,null,t.toString()),n}return o}async withReadProvider(t){const o=await this.withProvider(t);if((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasReadWriteCapability)(o)||(0,c.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const o=await this.withProvider(t);if((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.doResolveFile(t,o)}catch(n){throw(0,c.toFileSystemProviderErrorCode)(n)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,w.localize)(2,null,this.resourceForError(t)),1):(0,c.ensureFileSystemProviderError)(n)}}async doResolveFile(t,o){const n=await this.withProvider(t),s=this.isPathCaseSensitive(n),i=o?.resolveTo,r=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,p=await n.stat(t);let m;return this.toFileStat(n,t,p,void 0,!!a,(d,b)=>(m||(m=I.TernarySearchTree.forUris(()=>!s),m.set(t,!0),i&&m.fill(!0,i)),m.get(d.resource)||m.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&r?b===1:!1))}async toFileStat(t,o,n,s,i,r){const{providerExtUri:a}=this.getExtUri(t),p={resource:o,name:a.basename(o),isFile:(n.type&c.FileType.File)!==0,isDirectory:(n.type&c.FileType.Directory)!==0,isSymbolicLink:(n.type&c.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&c.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((n.permissions??0)&c.FilePermission.Locked),etag:(0,c.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(p.isDirectory&&r(p,s)){try{const m=await t.readdir(o),d=await N.Promises.settled(m.map(async([b,O])=>{try{const F=a.joinPath(o,b),M=i?await t.stat(F):{type:O};return await this.toFileStat(t,F,M,m.length,i,r)}catch(F){return this.logService.trace(F),null}}));p.children=(0,L.coalesce)(d)}catch(m){this.logService.trace(m),p.children=[]}return p}return p}async resolveAll(t){return N.Promises.settled(t.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.withProvider(t),n=await o.stat(t);return this.toFileStat(o,t,n,void 0,!0,()=>!1)}async exists(t){const o=await this.withProvider(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.doValidateCreateFile(t,o)}catch(n){return n}return!0}async doValidateCreateFile(t,o){if(!o?.overwrite&&await this.exists(t))throw new c.FileOperationError((0,w.localize)(3,null,this.resourceForError(t)),3,o)}async createFile(t,o=T.VSBuffer.fromString(""),n){await this.doValidateCreateFile(t,n);const s=await this.writeFile(t,o);return this._onDidRunOperation.fire(new c.FileOperationEvent(t,0,s)),s}async writeFile(t,o,n){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:i}=this.getExtUri(s);try{await this.validateWriteFile(s,t,n)||await this.mkdirp(s,i.dirname(t));let a;if((0,c.hasReadWriteCapability)(s)&&!(o instanceof T.VSBuffer))if((0,g.isReadableStream)(o)){const p=await(0,g.peekStream)(o,3);p.ended?a=T.VSBuffer.concat(p.buffer):a=p}else a=(0,g.peekReadable)(o,p=>T.VSBuffer.concat(p),3);else a=o;if(!(0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s)&&a instanceof T.VSBuffer)await this.doWriteUnbuffered(s,t,n,a);else{const p=a instanceof T.VSBuffer?(0,T.bufferToReadable)(a):a;n?.atomic!==!1&&n?.atomic?.postfix?await this.doWriteBufferedAtomic(s,t,(0,u.joinPath)((0,u.dirname)(t),`${(0,u.basename)(t)}${n.atomic.postfix}`),n,p):await this.doWriteBuffered(s,t,n,p)}this._onDidRunOperation.fire(new c.FileOperationEvent(t,4))}catch(r){throw new c.FileOperationError((0,w.localize)(4,null,this.resourceForError(t),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),n)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,o,n){const s=!!n?.unlock;if(s&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.resourceForError(o)));if(!!n?.atomic){if(!(t.capabilities&32768))throw new Error((0,w.localize)(6,null,this.resourceForError(o)));if(s)throw new Error((0,w.localize)(7,null,this.resourceForError(o)))}let r;try{r=await t.stat(o)}catch{return}if(r.type&c.FileType.Directory)throw new c.FileOperationError((0,w.localize)(8,null,this.resourceForError(o)),0,n);if(this.throwIfFileIsReadonly(o,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==c.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,c.etag)({mtime:n.mtime,size:r.size}))throw new c.FileOperationError((0,w.localize)(9,null),3,n);return r}async readFile(t,o,n){const s=await this.withReadProvider(t);return o?.atomic?this.doReadFileAtomic(s,t,o,n):this.doReadFile(s,t,o,n)}async doReadFileAtomic(t,o,n,s){return new Promise((i,r)=>{this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(t,o,n,s);i(a)}catch(a){r(a)}})})}async doReadFile(t,o,n,s){const i=await this.doReadFileStream(t,o,{...n,preferUnbuffered:!0},s);return{...i,value:await(0,T.streamToBuffer)(i.value)}}async readFileStream(t,o,n){const s=await this.withReadProvider(t);return this.doReadFileStream(s,t,o,n)}async doReadFileStream(t,o,n,s){const i=new A.CancellationTokenSource(s),r=this.validateReadFile(o,n).then(p=>p,p=>{throw i.cancel(),p});let a;try{return typeof n?.etag=="string"&&n.etag!==c.ETAG_DISABLED&&await r,n?.atomic&&(0,c.hasFileAtomicReadCapability)(t)||!((0,c.hasOpenReadWriteCloseCapability)(t)||(0,c.hasFileReadStreamCapability)(t))||(0,c.hasReadWriteCapability)(t)&&n?.preferUnbuffered?a=this.readFileUnbuffered(t,o,n):(0,c.hasFileReadStreamCapability)(t)?a=this.readFileStreamed(t,o,i.token,n):a=this.readFileBuffered(t,o,i.token,n),{...await r,value:a}}catch(p){throw a&&await(0,g.consumeStream)(a),this.restoreReadError(p,o,n)}}restoreReadError(t,o,n){const s=(0,w.localize)(10,null,this.resourceForError(o),(0,c.ensureFileSystemProviderError)(t).toString());return t instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(s,t.stat,n):t instanceof c.TooLargeFileOperationError?new c.TooLargeFileOperationError(s,t.fileOperationResult,t.size,t.options):new c.FileOperationError(s,(0,c.toFileOperationResult)(t),n)}readFileStreamed(t,o,n,s=Object.create(null)){const i=t.readFileStream(o,s,n);return(0,g.transform)(i,{data:r=>r instanceof T.VSBuffer?r:T.VSBuffer.wrap(r),error:r=>this.restoreReadError(r,o,s)},r=>T.VSBuffer.concat(r))}readFileBuffered(t,o,n,s=Object.create(null)){const i=(0,T.newWriteableBufferStream)();return(0,l.readFileIntoStream)(t,o,i,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>this.restoreReadError(r,o,s)},n),i}readFileUnbuffered(t,o,n){const s=(0,g.newWriteableStream)(i=>T.VSBuffer.concat(i));return(async()=>{try{let i;n?.atomic&&(0,c.hasFileAtomicReadCapability)(t)?i=await t.readFile(o,{atomic:!0}):i=await t.readFile(o),typeof n?.position=="number"&&(i=i.slice(n.position)),typeof n?.length=="number"&&(i=i.slice(0,n.length)),this.validateReadFileLimits(o,i.byteLength,n),s.end(T.VSBuffer.wrap(i))}catch(i){s.error(i),s.end()}})(),s}async validateReadFile(t,o){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new c.FileOperationError((0,w.localize)(11,null,this.resourceForError(t)),0,o);if(typeof o?.etag=="string"&&o.etag!==c.ETAG_DISABLED&&o.etag===n.etag)throw new c.NotModifiedSinceFileOperationError((0,w.localize)(12,null),n,o);return this.validateReadFileLimits(t,n.size,o),n}validateReadFileLimits(t,o,n){if(typeof n?.limits?.size=="number"&&o>n.limits.size)throw new c.TooLargeFileOperationError((0,w.localize)(13,null,this.resourceForError(t)),7,o,n)}async canMove(t,o,n){return this.doCanMoveCopy(t,o,"move",n)}async canCopy(t,o,n){return this.doCanMoveCopy(t,o,"copy",n)}async doCanMoveCopy(t,o,n,s){if(t.toString()!==o.toString())try{const i=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,t,r,o,n,s)}catch(i){return i}return!0}async move(t,o,n){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,t,i,o,"move",!!n),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(t,r==="move"?2:3,a)),a}async copy(t,o,n){const s=await this.withReadProvider(t),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,t,i,o,"copy",!!n),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(t,r==="copy"?3:2,a)),a}async doMoveCopy(t,o,n,s,i,r){if(o.toString()===s.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:p}=await this.doValidateMoveCopy(t,o,n,s,i,r);if(a&&!p&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(s)),i==="copy"){if(t===n&&(0,c.hasFileFolderCopyCapability)(t))await t.copy(o,s,{overwrite:r});else{const m=await this.resolve(o);m.isDirectory?await this.doCopyFolder(t,m,n,s):await this.doCopyFile(t,o,n,s)}return i}else return t===n?(await t.rename(o,s,{overwrite:r}),i):(await this.doMoveCopy(t,o,n,s,"copy",r),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(t,o,n,s){if((0,c.hasOpenReadWriteCloseCapability)(t)&&(0,c.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(t,o,n,s);if((0,c.hasOpenReadWriteCloseCapability)(t)&&(0,c.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(t,o,n,s);if((0,c.hasReadWriteCapability)(t)&&(0,c.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(t,o,n,s);if((0,c.hasReadWriteCapability)(t)&&(0,c.hasReadWriteCapability)(n))return this.doPipeUnbuffered(t,o,n,s)}async doCopyFolder(t,o,n,s){await n.mkdir(s),Array.isArray(o.children)&&await N.Promises.settled(o.children.map(async i=>{const r=this.getExtUri(n).providerExtUri.joinPath(s,i.name);return i.isDirectory?this.doCopyFolder(t,await this.resolve(i.resource),n,r):this.doCopyFile(t,i.resource,n,r)}))}async doValidateMoveCopy(t,o,n,s,i,r){let a=!1;if(t===n){const{providerExtUri:m,isPathCaseSensitive:d}=this.getExtUri(t);if(d||(a=m.isEqual(o,s)),a&&i==="copy")throw new Error((0,w.localize)(14,null,this.resourceForError(o),this.resourceForError(s)));if(!a&&m.isEqualOrParent(s,o))throw new Error((0,w.localize)(15,null,this.resourceForError(o),this.resourceForError(s)))}const p=await this.exists(s);if(p&&!a){if(!r)throw new c.FileOperationError((0,w.localize)(16,null,this.resourceForError(o),this.resourceForError(s)),4);if(t===n){const{providerExtUri:m}=this.getExtUri(t);if(m.isEqualOrParent(o,s))throw new Error((0,w.localize)(17,null,this.resourceForError(o),this.resourceForError(s)))}}return{exists:p,isSameResourceWithDifferentPathCase:a}}getExtUri(t){const o=this.isPathCaseSensitive(t);return{providerExtUri:o?u.extUri:u.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(o,t);const n=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(t,0,n)),n}async mkdirp(t,o){const n=[],{providerExtUri:s}=this.getExtUri(t);for(;!s.isEqual(o,s.dirname(o));)try{if(!((await t.stat(o)).type&c.FileType.Directory))throw new Error((0,w.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,c.toFileSystemProviderErrorCode)(i)!==c.FileSystemProviderErrorCode.FileNotFound)throw i;n.push(s.basename(o)),o=s.dirname(o)}for(let i=n.length-1;i>=0;i--){o=s.joinPath(o,n[i]);try{await t.mkdir(o)}catch(r){if((0,c.toFileSystemProviderErrorCode)(r)!==c.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,o){try{await this.doValidateDelete(t,o)}catch(n){return n}return!0}async doValidateDelete(t,o){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t),s=!!o?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,w.localize)(19,null,this.resourceForError(t)));const i=o?.atomic;if(i&&!(n.capabilities&65536))throw new Error((0,w.localize)(20,null,this.resourceForError(t)));if(s&&i)throw new Error((0,w.localize)(21,null,this.resourceForError(t)));let r;try{r=await n.stat(t)}catch{}if(r)this.throwIfFileIsReadonly(t,r);else throw new c.FileOperationError((0,w.localize)(22,null,this.resourceForError(t)),1);if(!!!o?.recursive){const p=await this.resolve(t);if(p.isDirectory&&Array.isArray(p.children)&&p.children.length>0)throw new Error((0,w.localize)(23,null,this.resourceForError(t)))}return n}async del(t,o){const n=await this.doValidateDelete(t,o),s=!!o?.useTrash,i=!!o?.recursive,r=o?.atomic??!1;await n.delete(t,{recursive:i,useTrash:s,atomic:r}),this._onDidRunOperation.fire(new c.FileOperationEvent(t,1))}async cloneFile(t,o){const n=await this.withProvider(t),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);if(n===s&&this.getExtUri(n).providerExtUri.isEqual(t,o))return;if(n===s&&(0,c.hasFileCloneCapability)(n))return n.cloneFile(t,o);await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(o));const i=this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri);return n===s&&(0,c.hasFileFolderCopyCapability)(n)?i.queue(()=>n.copy(t,o,{overwrite:!0})):i.queue(()=>this.doCopyFile(n,t,s,o))}watch(t,o={recursive:!1,excludes:[]}){const n=new v.DisposableStore;let s=!1,i=()=>{s=!0};return n.add((0,v.toDisposable)(()=>i())),(async()=>{try{const r=await this.doWatch(t,o);s?(0,v.dispose)(r):i=()=>(0,v.dispose)(r)}catch(r){this.logService.error(r)}})(),n}async doWatch(t,o){const n=await this.withProvider(t),s=(0,D.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(t),o]);let i=this.activeWatchers.get(s);return i||(i={count:0,disposable:n.watch(t,o)},this.activeWatchers.set(s,i)),i.count+=1,(0,v.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,v.dispose)(i.disposable),this.activeWatchers.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,v.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBufferedAtomic(t,o,n,s,i){await this.doWriteBuffered(t,n,s,i);try{await t.rename(n,o,{overwrite:!0})}catch(r){try{await t.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}async doWriteBuffered(t,o,n,s){return this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri).queue(async()=>{const i=await t.open(o,{create:!0,unlock:n?.unlock??!1});try{(0,g.isReadableStream)(s)||(0,g.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(t,i,s):await this.doWriteReadableBufferedQueued(t,i,s)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await t.close(i)}})}async doWriteStreamBufferedQueued(t,o,n){let s=0,i;if((0,g.isReadableBufferedStream)(n)){if(n.buffer.length>0){const r=T.VSBuffer.concat(n.buffer);await this.doWriteBuffer(t,o,r,r.byteLength,s,0),s+=r.byteLength}if(n.ended)return;i=n.stream}else i=n;return new Promise((r,a)=>{(0,g.listenStream)(i,{onData:async p=>{i.pause();try{await this.doWriteBuffer(t,o,p,p.byteLength,s,0)}catch(m){return a(m)}s+=p.byteLength,setTimeout(()=>i.resume())},onError:p=>a(p),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(t,o,n){let s=0,i;for(;(i=n.read())!==null;)await this.doWriteBuffer(t,o,i,i.byteLength,s,0),s+=i.byteLength}async doWriteBuffer(t,o,n,s,i,r){let a=0;for(;a<s;){const p=await t.write(o,i+a,n.buffer,r+a,s-a);a+=p}}async doWriteUnbuffered(t,o,n,s){return this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,o,n,s))}async doWriteUnbufferedQueued(t,o,n,s){let i;s instanceof T.VSBuffer?i=s:(0,g.isReadableStream)(s)?i=await(0,T.streamToBuffer)(s):(0,g.isReadableBufferedStream)(s)?i=await(0,T.bufferedStreamToBuffer)(s):i=(0,T.readableToBuffer)(s),await t.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async doPipeBuffered(t,o,n,s){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,o,n,s))}async doPipeBufferedQueued(t,o,n,s){let i,r;try{i=await t.open(o,{create:!1}),r=await n.open(s,{create:!0,unlock:!1});const a=T.VSBuffer.alloc(this.BUFFER_SIZE);let p=0,m=0,d=0;do d=await t.read(i,p,a.buffer,m,a.byteLength-m),await this.doWriteBuffer(n,r,a,d,p,m),p+=d,m+=d,m===a.byteLength&&(m=0);while(d>0)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await N.Promises.settled([typeof i=="number"?t.close(i):Promise.resolve(),typeof r=="number"?n.close(r):Promise.resolve()])}}async doPipeUnbuffered(t,o,n,s){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,o,n,s))}async doPipeUnbufferedQueued(t,o,n,s){return n.writeFile(s,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(t,o,n,s){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,o,n,s))}async doPipeUnbufferedToBufferedQueued(t,o,n,s){const i=await n.open(s,{create:!0,unlock:!1});try{const r=await t.readFile(o);await this.doWriteBuffer(n,i,T.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await n.close(i)}}async doPipeBufferedToUnbuffered(t,o,n,s){const i=await(0,T.streamToBuffer)(this.readFileBuffered(t,o,A.CancellationToken.None));await this.doWriteUnbuffered(n,s,void 0,i)}throwIfFileSystemIsReadonly(t,o){if(t.capabilities&2048)throw new c.FileOperationError((0,w.localize)(24,null,this.resourceForError(o)),6);return t}throwIfFileIsReadonly(t,o){if((o.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,w.localize)(25,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===C.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=E,e.FileService=E=ve([Y(0,h.ILogService)],E)}),define(oe[196],ae([0,1,52,266,6,35,14,3,48,2,16,5,22,42,31,158,13,99,194,38,190,189]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h,y,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,N.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(o)}`)}})();class t extends h.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=D.Event.None,this.resourceLocks=new A.ResourceMap(i=>S.extUriBiasedIgnorePathCase.getComparisonKey(i)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:i}=await g.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,i),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:c.FilePermission.Locked}}catch(s){throw this.toFileSystemProviderError(s)}}async statIgnoreError(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await g.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),i=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,S.joinPath)(n,r.name))).type:a=this.toType(r),i.push([r.name,a])}catch(a){this.logService.trace(a)}})),i}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let i;return s?.dangling?i=c.FileType.Unknown:n.isFile()?i=c.FileType.File:n.isDirectory()?i=c.FileType.Directory:i=c.FileType.Unknown,s&&(i|=c.FileType.SymbolicLink),i}async createResourceLock(n){const s=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let i;for(;i=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await i.wait();const r=new T.Barrier;return this.resourceLocks.set(n,r),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,v.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(n)===r&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let i;try{s?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),i=await this.createResourceLock(n));const r=this.toFilePath(n);return await g.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}finally{i?.dispose()}}traceLock(n){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,s,i){const r=(0,u.newWriteableStream)(a=>k.VSBuffer.concat(a.map(p=>k.VSBuffer.wrap(p))).buffer);return(0,l.readFileIntoStream)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},i),r}async writeFile(n,s,i){return i?.atomic!==!1&&i?.atomic?.postfix?this.doWriteFileAtomic(n,(0,S.joinPath)((0,S.dirname)(n),`${(0,S.basename)(n)}${i.atomic.postfix}`),s,i):this.doWriteFile(n,s,i)}async doWriteFileAtomic(n,s,i,r){await this.doWriteFile(s,i,r);try{await this.rename(s,n,{overwrite:!0})}catch(a){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async doWriteFile(n,s,i){let r;try{const a=this.toFilePath(n);if(!i.create||!i.overwrite){if(await g.Promises.exists(a)){if(!i.overwrite)throw(0,c.createFileSystemProviderError)((0,w.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,c.createFileSystemProviderError)((0,w.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(n,{create:!0,unlock:i.unlock}),await this.write(r,0,s,0,s.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(n,a)}finally{typeof r=="number"&&await this.close(r)}}static{this.canFlush=!0}static configureFlushOnWrite(n){t.canFlush=n}async open(n,s){const i=this.toFilePath(n);let r;(0,c.isFileOpenForWriteOptions)(s)&&(r=await this.createResourceLock(n));let a;try{if((0,c.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:m}=await g.SymlinkSupport.stat(i);m.mode&128||await g.Promises.chmod(i,m.mode|128)}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}let p;if((0,c.isFileOpenForWriteOptions)(s)){if(C.isWindows)try{await g.Promises.truncate(i,0),p="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}p||(p="w")}else p="r";a=await g.Promises.open(i,p)}catch(p){throw r?.dispose(),(0,c.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(n,p):this.toFileSystemProviderError(p)}if(this.mapHandleToPos.set(a,0),(0,c.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(a,n),r){const p=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${i})`),this.mapHandleToLock.set(a,r),p&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${i})`),p.dispose())}return a}async close(n){const s=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&t.canFlush)try{await g.Promises.fdatasync(n)}catch(i){t.configureFlushOnWrite(!1),this.logService.error(i)}return await g.Promises.close(n)}catch(i){throw this.toFileSystemProviderError(i)}finally{s&&(this.mapHandleToLock.get(n)===s&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,i,r,a){const p=this.normalizePos(n,s);let m=null;try{m=(await g.Promises.read(n,i,r,a,p)).bytesRead}catch(d){throw this.toFileSystemProviderError(d)}finally{this.updatePos(n,p,m)}return m}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,i){const r=this.mapHandleToPos.get(n);typeof r=="number"&&(typeof s=="number"||(typeof i=="number"?this.mapHandleToPos.set(n,r+i):this.mapHandleToPos.delete(n)))}async write(n,s,i,r,a){return(0,T.retry)(()=>this.doWrite(n,s,i,r,a),100,3)}async doWrite(n,s,i,r,a){const p=this.normalizePos(n,s);let m=null;try{m=(await g.Promises.write(n,i,r,a,p)).bytesWritten}catch(d){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),d)}finally{this.updatePos(n,p,m)}return m}async mkdir(n){try{await g.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const i=this.toFilePath(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,I.join)((0,I.dirname)(i),`${(0,I.basename)(i)}${s.atomic.postfix}`)),await g.Promises.rm(i,g.RimRafMode.MOVE,r)}else try{await g.Promises.unlink(i)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:p,symbolicLink:m}=await g.SymlinkSupport.stat(i);a=p.isDirectory()&&!m}catch{}if(a)await g.Promises.rmdir(i);else throw r}else throw r}}catch(i){throw this.toFileSystemProviderError(i)}}async rename(n,s,i){const r=this.toFilePath(n),a=this.toFilePath(s);if(r!==a)try{await this.validateMoveCopy(n,s,"move",i.overwrite),await g.Promises.move(r,a)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,w.localize)(2,null,(0,I.basename)(r),(0,I.basename)((0,I.dirname)(a)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(n,s,i){const r=this.toFilePath(n),a=this.toFilePath(s);if(r!==a)try{await this.validateMoveCopy(n,s,"copy",i.overwrite),await g.Promises.copy(r,a,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,w.localize)(3,null,(0,I.basename)(r),(0,I.basename)((0,I.dirname)(a)),p.toString()))),this.toFileSystemProviderError(p)}}async validateMoveCopy(n,s,i,r){const a=this.toFilePath(n),p=this.toFilePath(s);let m=!1;if(!!(this.capabilities&1024)||(m=(0,P.isEqual)(a,p,!0)),m){if(i==="copy")throw(0,c.createFileSystemProviderError)((0,w.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const b=await this.statIgnoreError(n);if(!b)throw(0,c.createFileSystemProviderError)((0,w.localize)(5,null),c.FileSystemProviderErrorCode.FileNotFound);const O=await this.statIgnoreError(s);if(O){if(!r)throw(0,c.createFileSystemProviderError)((0,w.localize)(6,null),c.FileSystemProviderErrorCode.FileExists);b.type&c.FileType.File&&O.type&c.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.doCloneFile(n,s,!1)}async doCloneFile(n,s,i){const r=this.toFilePath(n),a=this.toFilePath(s),p=!!(this.capabilities&1024);if((0,P.isEqual)(r,a,!p))return;const m=new v.DisposableStore;try{const[d,b]=await Promise.all([this.createResourceLock(n),this.createResourceLock(s)]);m.add(d),m.add(b),i&&await g.Promises.mkdir((0,I.dirname)(a),{recursive:!0}),await g.Promises.copyFile(r,a)}catch(d){if(d.code==="ENOENT"&&!i)return this.doCloneFile(n,s,!0);throw this.toFileSystemProviderError(d)}finally{m.dispose()}}createUniversalWatcher(n,s,i){return new E.UniversalWatcherClient(r=>n(r),r=>s(r),i)}createNonRecursiveWatcher(n,s,i){return new R.NodeJSWatcherClient(r=>n(r),r=>s(r),i)}toFileSystemProviderError(n){if(n instanceof c.FileSystemProviderError)return n;let s=n,i;switch(n.code){case"ENOENT":i=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=c.FileSystemProviderErrorCode.Unknown;break;default:i=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(s,i)}async toFileSystemProviderWriteError(n,s){let i=this.toFileSystemProviderError(s);if(n&&i.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await g.SymlinkSupport.stat(this.toFilePath(n));r.mode&128||(i=(0,c.createFileSystemProviderError)(s,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.logService.trace(r)}return i}}e.DiskFileSystemProvider=t}),define(oe[101],ae([0,1,3,2,4,8]),function(te,e,L,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,T.createDecorator)("sharedProcessLifecycleService");let k=class extends N.Disposable{constructor(P){super(),this.logService=P,this._onWillShutdown=this._register(new L.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};e.SharedProcessLifecycleService=k,e.SharedProcessLifecycleService=k=ve([Y(0,A.ILogService)],k)}),define(oe[197],ae([0,1,10,3,8,2]),function(te,e,L,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class k extends T.AbstractLoggerService{constructor(C,S,u,g,w){super(S,u,g),this.windowId=C,this.channel=w,this._register(w.listen("onDidChangeLogLevel",C)(c=>{(0,T.isLogLevel)(c)?super.setLogLevel(c):super.setLogLevel(L.URI.revive(c[0]),c[1])})),this._register(w.listen("onDidChangeVisibility",C)(([c,l])=>super.setVisibility(L.URI.revive(c),l))),this._register(w.listen("onDidChangeLoggers",C)(({added:c,removed:l})=>{for(const h of c)super.registerLogger({...h,resource:L.URI.revive(h.resource)});for(const h of l)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new T.AdapterLogger({log:(C,S)=>{this.channel.call("consoleLog",[C,S])}})}registerLogger(C){super.registerLogger(C),this.channel.call("registerLogger",[C,this.windowId])}deregisterLogger(C){super.deregisterLogger(C),this.channel.call("deregisterLogger",[C,this.windowId])}setLogLevel(C,S){super.setLogLevel(C,S),this.channel.call("setLogLevel",[C,S])}setVisibility(C,S){super.setVisibility(C,S),this.channel.call("setVisibility",[this.toResource(C),S])}doCreateLogger(C,S,u){return new D(this.channel,C,S,u,this.windowId)}static setLogLevel(C,S,u){return C.call("setLogLevel",[S,u])}}e.LoggerChannelClient=k;class D extends T.AbstractMessageLogger{constructor(C,S,u,g,w){super(g?.logLevel==="always"),this.channel=C,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[S,g,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(C,S){const u=[[C,S]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(C){this.channel.call("log",[this.file,C])}}class P{constructor(C,S){this.loggerService=C,this.getUriTransformer=S}listen(C,S){const u=this.getUriTransformer(C);switch(S){case"onDidChangeLoggers":return N.Event.map(this.loggerService.onDidChangeLoggers,g=>({added:[...g.added].map(w=>this.transformLogger(w,u)),removed:[...g.removed].map(w=>this.transformLogger(w,u))}));case"onDidChangeVisibility":return N.Event.map(this.loggerService.onDidChangeVisibility,g=>[u.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return N.Event.map(this.loggerService.onDidChangeLogLevel,g=>(0,T.isLogLevel)(g)?g:[u.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${S}`)}async call(C,S,u){const g=this.getUriTransformer(C);switch(S){case"setLogLevel":return(0,T.isLogLevel)(u[0])?this.loggerService.setLogLevel(u[0]):this.loggerService.setLogLevel(L.URI.revive(g.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(w=>this.transformLogger(w,g)))}throw new Error(`Call not found: ${S}`)}transformLogger(C,S){return{...C,resource:S.transformOutgoingURI(C.resource)}}}e.LoggerChannel=P;class v extends A.Disposable{constructor(C,S){super(),S.call("setLogLevel",[C.getLogLevel()]),this._register(C.onDidChangeLogLevel(u=>S.call("setLogLevel",[u]))),S.call("getRegisteredLoggers").then(u=>{for(const g of u)C.registerLogger({...g,resource:L.URI.revive(g.resource)})}),this._register(S.listen("onDidChangeVisibility")(([u,g])=>C.setVisibility(L.URI.revive(u),g))),this._register(S.listen("onDidChangeLoggers")(({added:u,removed:g})=>{for(const w of u)C.registerLogger({...w,resource:L.URI.revive(w.resource)});for(const w of g)C.deregisterLogger(w.resource)}))}}e.RemoteLoggerChannelClient=v}),define(oe[198],ae([0,1,2,8]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class T extends L.Disposable{constructor(k,D=[]){super(),this.logger=new N.MultiplexLogger([k,...D]),this._register(k.onDidChangeLogLevel(P=>this.setLevel(P)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(k){this.logger.setLevel(k)}getLevel(){return this.logger.getLevel()}trace(k,...D){this.logger.trace(k,...D)}debug(k,...D){this.logger.debug(k,...D)}info(k,...D){this.logger.info(k,...D)}warn(k,...D){this.logger.warn(k,...D)}error(k,...D){this.logger.error(k,...D)}flush(){this.logger.flush()}}e.LogService=T}),define(oe[55],ae([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(oe[56],ae([0,1,3,59,2,4]),function(te,e,L,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class k extends T.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(v){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...v,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(v),N.Iterable.reduce(this.policies.entries(),(C,[S,u])=>({...C,[S]:u}),{})}getPolicyValue(v){return this.policies.get(v)}serialize(){return N.Iterable.reduce(Object.entries(this.policyDefinitions),(v,[I,C])=>({...v,[I]:{definition:C,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=k;class D{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=D}),define(oe[199],ae([0,1,3,2,56]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(P){this.service=P,this.disposables=new N.DisposableStore}listen(P,v){switch(v){case"onDidChange":return L.Event.map(this.service.onDidChange,I=>I.reduce((C,S)=>({...C,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${v}`)}call(P,v,I){switch(v){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(I)}throw new Error(`Call not found: ${v}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=A;class k extends T.AbstractPolicyService{constructor(P,v){super(),this.channel=v;for(const I in P){const{definition:C,value:S}=P[I];this.policyDefinitions[I]=C,S!==void 0&&this.policies.set(I,S)}this.channel.listen("onDidChange")(I=>{for(const C in I){const S=I[C];S===null?this.policies.delete(C):this.policies.set(C,S)}this._onDidChange.fire(Object.keys(I))})}async _updatePolicyDefinitions(P){const v=await this.channel.call("updatePolicyDefinitions",P);for(const I in v)this.policies.set(I,v[I])}}e.PolicyChannelClient=k}),define(oe[102],ae([0,1,5,37]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.context<"u"){const A=L.globals.vscode.context.configuration();if(A)T=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){T=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:A,searchUrl:k,itemUrl:D,controlUrl:P}=T.extensionsGallery||{};Object.assign(T,{extensionsGallery:{serviceUrl:N.env.VSCODE_GALLERY_SERVICE_URL||A,searchUrl:N.env.VSCODE_GALLERY_SEARCH_URL||k,itemUrl:N.env.VSCODE_GALLERY_ITEM_URL||D,controlUrl:N.env.VSCODE_GALLERY_CONTROL_URL||P}});try{const v=(...C)=>C.reduce((S,u)=>(Object.keys(u).forEach(g=>{Array.isArray(S[g])&&Array.isArray(u[g])?S[g]=u[g]:typeof S[g]=="object"&&typeof u[g]=="object"?S[g]=v(S[g],u[g]):S[g]=u[g]}),S),{}),I=globalThis._VSCODE_USER_PRODUCT_JSON||{};T=v(T,I)}catch{}if(N.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const v=globalThis._VSCODE_PACKAGE_JSON;Object.assign(T,{version:v.version,release:v.release})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.80.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(oe[24],ae([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[200],ae([0,1,6,7,2,16,31,8,24]),function(te,e,L,N,T,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let v=class extends T.Disposable{constructor(C,S,u){super(),this.productService=S,this.logService=u,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},3e4)).schedule()}async cleanUpCodeCaches(C){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const S=Date.now(),u=(0,A.dirname)(C),g=(0,A.basename)(C),w=await k.Promises.readdir(u);await Promise.all(w.map(async c=>{if(c===g)return;const l=(0,A.join)(u,c),h=await k.Promises.stat(l);if(h.isDirectory()&&S-h.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${c}.`),k.Promises.rm(l)}))}catch(S){(0,N.onUnexpectedError)(S)}}};e.CodeCacheCleaner=v,e.CodeCacheCleaner=v=ve([Y(1,P.IProductService),Y(2,D.ILogService)],v)}),define(oe[201],ae([0,1,6,7,2,16,31,15,8,24]),function(te,e,L,N,T,A,k,D,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends T.Disposable{constructor(S,u,g){super(),this.environmentService=S,this.logService=u,this.productService=g,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const S=Object.create(null),u=JSON.parse(await k.Promises.readFile((0,A.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const h of Object.keys(u)){const y=u[h];S[`${y.hash}.${h}`]=!0}const g=(0,A.join)(this.environmentService.userDataPath,"clp");if(!await k.Promises.exists(g))return;const c=await k.Promises.readdir(g);for(const h of c){if(S[h]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${h}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${h}`),await k.Promises.rm((0,A.join)(g,h))}const l=Date.now();for(const h of Object.keys(S)){const y=(0,A.join)(g,h),E=await k.Promises.readdir(y);for(const R of E){if(R==="tcf.json")continue;const t=(0,A.join)(y,R),o=await k.Promises.stat(t);o.isDirectory()&&l-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(h,R)}`),await k.Promises.rm(t))}}}catch(S){(0,N.onUnexpectedError)(S)}}};e.LanguagePackCachedDataCleaner=I,e.LanguagePackCachedDataCleaner=I=ve([Y(0,D.INativeEnvironmentService),Y(1,P.ILogService),Y(2,v.IProductService)],I)}),define(oe[202],ae([0,1,16,4]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,N.createDecorator)("IV8InspectProfilingService");var T;(function(A){function k(P){return!!(P.samples&&P.timeDeltas)}A.isValidProfile=k;function D(P,v="noAbsolutePaths"){for(const I of P.nodes)I.callFrame&&I.callFrame.url&&((0,L.isAbsolute)(I.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(I.callFrame.url))&&(I.callFrame.url=(0,L.join)(v,(0,L.basename)(I.callFrame.url)));return P}A.rewriteAbsolutePaths=D})(T||(e.Utils=T={}))}),define(oe[203],ae([0,1,32]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class N{constructor(){this._sessions=new Map}async startProfiling(A){const D=await(await new Promise((v,I)=>{te(["v8-inspect-profiler"],v,I)})).startProfiling({port:A.port,checkForPaused:!0}),P=(0,L.generateUuid)();return this._sessions.set(P,D),P}async stopProfiling(A){const k=this._sessions.get(A);if(!k)throw new Error(`UNKNOWN session '${A}'`);const D=await k.stop();return this._sessions.delete(A),D.profile}}e.InspectProfilingService=N}),define(oe[40],ae([0,1,123,11]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(k,D){L.ok(N.isString(k)),L.ok(N.isObject(D)),L.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,D)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new T}),define(oe[103],ae([0,1,3,40]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class A{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(P,v){this.schemasById[T(P)]=v,this._onDidChangeSchema.fire(P)}notifySchemaChanged(P){this._onDidChangeSchema.fire(P)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new A;N.Registry.add(e.Extensions.JSONContribution,k)}),define(oe[49],ae([0,1,21,3,11,145,18,103,40]),function(te,e,L,N,T,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var v;(function(R){R.Multiline="multilineText",R.Singleline="singlelineText"})(v||(e.EditPresentationTypes=v={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(R){R[R.APPLICATION=1]="APPLICATION",R[R.MACHINE=2]="MACHINE",R[R.WINDOW=3]="WINDOW",R[R.RESOURCE=4]="RESOURCE",R[R.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",R[R.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=P.Registry.as(D.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new N.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new N.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const n=new Set;this.doRegisterConfigurations(t,o,n),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(t){const o=new Set;this.doDeregisterConfigurations(t,o),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:t,remove:o}){const n=new Set;this.doDeregisterConfigurations(o,n),this.doRegisterConfigurations(t,!1,n),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}registerDefaultConfigurations(t){const o=new Set;this.doRegisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,o){const n=[];for(const{overrides:s,source:i}of t)for(const r in s)if(o.add(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const a=this.configurationDefaultsOverrides.get(r),p=a?.valuesSources??new Map;if(i)for(const O of Object.keys(s[r]))p.set(O,i);const m={...a?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:i,value:m,valuesSources:p});const d=(0,k.getLanguageTagSettingPlainKey)(r),b={type:"object",default:m,description:A.localize(1,null,d),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:T.isString(i)?void 0:i,defaultValueSource:i};n.push(...w(r)),this.configurationProperties[r]=b,this.defaultLanguageConfigurationOverridesNode.properties[r]=b}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:i});const a=this.configurationProperties[r];a&&(this.updatePropertyDefaultValue(r,a),this.updateSchema(r,a))}this.doRegisterOverrideIdentifiers(n)}deregisterDefaultConfigurations(t){const o=new Set;this.doDeregisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,o){for(const{overrides:n,source:s}of t)for(const i in n){const r=this.configurationDefaultsOverrides.get(i),a=T.isString(s)?s:s?.id,p=T.isString(r?.source)?r?.source:r?.source?.id;if(a===p)if(o.add(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const m=this.configurationProperties[i];m&&(this.updatePropertyDefaultValue(i,m),this.updateSchema(i,m))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let o=!1;const n=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,n),o=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,n),o=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,n),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const o of t)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,o,n){t.forEach(s=>{this.validateAndRegisterProperties(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.configurationContributors.push(s),this.registerJSONConfiguration(s)})}doDeregisterConfigurations(t,o){const n=s=>{if(s.properties)for(const i in s.properties){o.add(i);const r=this.configurationProperties[i];r?.policy?.name&&this.policyConfigurations.delete(r.policy.name),delete this.configurationProperties[i],this.removeFromSchema(i,s.properties[i])}s.allOf?.forEach(i=>n(i))};for(const s of t){n(s);const i=this.configurationContributors.indexOf(s);i!==-1&&this.configurationContributors.splice(i,1)}}validateAndRegisterProperties(t,o=!0,n,s,i=3,r){i=T.isUndefinedOrNull(t.scope)?i:t.scope;const a=t.properties;if(a)for(const m in a){const d=a[m];if(o&&y(m,d)){delete a[m];continue}if(d.source=n,d.defaultDefaultValue=a[m].default,this.updatePropertyDefaultValue(m,d),e.OVERRIDE_PROPERTY_REGEX.test(m)?d.scope=void 0:(d.scope=T.isUndefinedOrNull(d.scope)?i:d.scope,d.restricted=T.isUndefinedOrNull(d.restricted)?!!s?.includes(m):d.restricted),a[m].hasOwnProperty("included")&&!a[m].included){this.excludedConfigurationProperties[m]=a[m],delete a[m];continue}else this.configurationProperties[m]=a[m],a[m].policy?.name&&this.policyConfigurations.set(a[m].policy.name,m);!a[m].deprecationMessage&&a[m].markdownDeprecationMessage&&(a[m].deprecationMessage=a[m].markdownDeprecationMessage),r.add(m)}const p=t.allOf;if(p)for(const m of p)this.validateAndRegisterProperties(m,o,n,s,i,r)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const o=n=>{const s=n.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);n.allOf?.forEach(o)};o(t)}updateSchema(t,o){switch(e.allSettings.properties[t]=o,o.scope){case 1:e.applicationSettings.properties[t]=o;break;case 2:e.machineSettings.properties[t]=o;break;case 6:e.machineOverridableSettings.properties[t]=o;break;case 3:e.windowSettings.properties[t]=o;break;case 4:e.resourceSettings.properties[t]=o;break;case 5:e.resourceSettings.properties[t]=o,this.resourceLanguageSettingsSchema.properties[t]=o;break}}removeFromSchema(t,o){switch(delete e.allSettings.properties[t],o.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const o=`[${t}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}}registerOverridePropertyPatternKey(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,o){const n=this.configurationDefaultsOverrides.get(t);let s=n?.value,i=n?.source;T.isUndefined(s)&&(s=o.defaultDefaultValue,i=void 0),T.isUndefined(s)&&(s=l(o.type)),o.default=s,o.defaultValueSource=i}}const u="\\[([^\\]]+)\\]",g=new RegExp(u,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(R){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(R)){let o=g.exec(R);for(;o?.length;){const n=o[1].trim();n&&t.push(n),o=g.exec(R)}}return(0,L.distinct)(t)}e.overrideIdentifiersFromKey=w;function c(R){return R.reduce((t,o)=>`${t}[${o}]`,"")}e.keyFromOverrideIdentifiers=c;function l(R){switch(Array.isArray(R)?R[0]:R){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const h=new S;P.Registry.add(e.Extensions.Configuration,h);function y(R,t){return R.trim()?e.OVERRIDE_PROPERTY_REGEX.test(R)?A.localize(7,null,R):h.getConfigurationProperties()[R]!==void 0?A.localize(8,null,R):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,R,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=y;function E(){const R=[],t=h.getConfigurationProperties();for(const o of Object.keys(t))R.push([o,t[o].scope]);return R.push(["launch",4]),R.push(["task",4]),R}e.getScopes=E}),define(oe[71],ae([0,1,21,3,34,2,35,30,11,10,18,49,40]),function(te,e,L,N,T,A,k,D,P,v,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function u(o){return Object.isFrozen(o)?o:D.deepFreeze(o)}class g{constructor(n={},s=[],i=[],r){this._contents=n,this._keys=s,this._overrides=i,this.raw=r,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof g)return s;const i=new w("");return i.parseRaw(s),i.configurationModel});this._rawConfiguration=n.reduce((s,i)=>i===s?i:s.merge(i),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}inspect(n,s){const i=this.rawConfiguration.getValue(n),r=s?this.rawConfiguration.getOverrideValue(n,s):void 0,a=s?this.rawConfiguration.override(s).getValue(n):i;return{value:i,override:r,merged:a}}getOverrideValue(n,s){const i=this.getContentsForOverrideIdentifer(s);return i?n?(0,I.getConfigurationValue)(i,n):i:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const i of this.overrides)i.identifiers.includes(n)&&s.push(...i.keys);return L.distinct(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return L.distinct(n)}override(n){let s=this.overrideConfigurations.get(n);return s||(s=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,s)),s}merge(...n){const s=D.deepClone(this.contents),i=D.deepClone(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const p of n)if(a.push(...p.raw?.length?p.raw:[p]),!p.isEmpty()){this.mergeContents(s,p.contents);for(const m of p.overrides){const[d]=i.filter(b=>L.equals(b.identifiers,m.identifiers));d?(this.mergeContents(d.contents,m.contents),d.keys.push(...m.keys),d.keys=L.distinct(d.keys)):i.push(D.deepClone(m))}for(const m of p.keys)r.indexOf(m)===-1&&r.push(m)}return new g(s,r,i,a.every(p=>p instanceof g)?void 0:a)}createOverrideConfigurationModel(n){const s=this.getContentsForOverrideIdentifer(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const i={};for(const r of L.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const p=s[r];p&&(typeof a=="object"&&typeof p=="object"?(a=D.deepClone(a),this.mergeContents(a,p)):a=p),i[r]=a}return new g(i,this.keys,this.overrides)}mergeContents(n,s){for(const i of Object.keys(s)){if(i in n&&P.isObject(n[i])&&P.isObject(s[i])){this.mergeContents(n[i],s[i]);continue}n[i]=D.deepClone(s[i])}}getContentsForOverrideIdentifer(n){let s=null,i=null;const r=a=>{a&&(i?this.mergeContents(i,a):i=D.deepClone(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.updateValue(n,s,!0)}setValue(n,s){this.updateValue(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,I.removeFromValueTree)(this.contents,n),C.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(i=>L.equals(i.identifiers,(0,C.overrideIdentifiersFromKey)(n))),1))}updateValue(n,s,i){(0,I.addToValueTree)(this.contents,n,s,r=>console.error(r)),i=i||this.keys.indexOf(n)===-1,i&&this.keys.push(n),C.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,C.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,I.toValuesTree)(this.contents[n],r=>console.error(r))})}}e.ConfigurationModel=g;class w{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,s){if(!P.isUndefinedOrNull(n)){const i=this.doParseContent(n);this.parseRaw(i,s)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,s){this._raw=n;const{contents:i,keys:r,overrides:a,restricted:p,hasExcludedProperties:m}=this.doParseRaw(n,s);this._configurationModel=new g(i,r,a,m?[n]:void 0),this._restrictedConfigurations=p||[]}doParseContent(n){let s={},i=null,r=[];const a=[],p=[];function m(b){Array.isArray(r)?r.push(b):i!==null&&(r[i]=b)}const d={onObjectBegin:()=>{const b={};m(b),a.push(r),r=b,i=null},onObjectProperty:b=>{i=b},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const b=[];m(b),a.push(r),r=b,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:m,onError:(b,O,F)=>{p.push({error:b,offset:O,length:F})}};if(n)try{T.visit(n,d),s=r[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return s}doParseRaw(n,s){const i=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),r=this.filter(n,i,!0,s);n=r.raw;const a=(0,I.toValuesTree)(n,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),p=Object.keys(n),m=this.toOverrides(n,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:a,keys:p,overrides:m,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}filter(n,s,i,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const p={},m=[];for(const d in n)if(C.OVERRIDE_PROPERTY_REGEX.test(d)&&i){const b=this.filter(n[d],s,!1,r);p[d]=b.raw,a=a||b.hasExcludedProperties,m.push(...b.restricted)}else{const b=s[d],O=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&m.push(d),!r.exclude?.includes(d)&&(r.include?.includes(d)||(O===void 0||r.scopes===void 0||r.scopes.includes(O))&&!(r.skipRestricted&&b?.restricted))?p[d]=n[d]:a=!0}return{raw:p,restricted:m,hasExcludedProperties:a}}toOverrides(n,s){const i=[];for(const r of Object.keys(n))if(C.OVERRIDE_PROPERTY_REGEX.test(r)){const a={};for(const p in n[r])a[p]=n[r][p];i.push({identifiers:(0,C.overrideIdentifiersFromKey)(r),keys:Object.keys(a),contents:(0,I.toValuesTree)(a,s)})}return i}}e.ConfigurationModelParser=w;class c extends A.Disposable{constructor(n,s,i,r){super(),this.userSettingsResource=n,this.parseOptions=s,this.fileService=r,this._onDidChange=this._register(new N.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(N.Event.any(N.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),N.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&i.isEqual(a.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(n){return n&&(this.parseOptions=n),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=c;class l{constructor(n,s,i,r,a,p,m,d,b,O,F,M,q){this.key=n,this.overrides=s,this._value=i,this.overrideIdentifiers=r,this.defaultConfiguration=a,this.policyConfiguration=p,this.applicationConfiguration=m,this.userConfiguration=d,this.localUserConfiguration=b,this.remoteUserConfiguration=O,this.workspaceConfiguration=F,this.folderConfigurationModel=M,this.memoryConfigurationModel=q}get value(){return u(this._value)}inspect(n,s,i){const r=n.inspect(s,i);return{get value(){return u(r.value)},get override(){return u(r.override)},get merged(){return u(r.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class h{constructor(n,s,i,r,a=new g,p=new g,m=new k.ResourceMap,d=new g,b=new k.ResourceMap){this._defaultConfiguration=n,this._policyConfiguration=s,this._applicationConfiguration=i,this._localUserConfiguration=r,this._remoteUserConfiguration=a,this._workspaceConfiguration=p,this._folderConfigurations=m,this._memoryConfiguration=d,this._memoryConfigurationByResource=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(n,s,i){return this.getConsolidatedConfigurationModel(n,s,i).getValue(n)}updateValue(n,s,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new g,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(n):r.setValue(n,s),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,s,i){const r=this.getConsolidatedConfigurationModel(n,s,i),a=this.getFolderConfigurationModelForResource(s.resource,i),p=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,m=new Set;for(const d of r.overrides)for(const b of d.identifiers)r.getOverrideValue(n,b)!==void 0&&m.add(b);return new l(n,s,r.getValue(n),m.size?[...m]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this._workspaceConfiguration:void 0,a||void 0,p)}keys(n){const s=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,s){this._folderConfigurations.set(n,s),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const i=[];if(!s){const{added:r,updated:a,removed:p}=R(this._defaultConfiguration,n);s=[...r,...a,...p]}for(const r of s)for(const a of(0,C.overrideIdentifiersFromKey)(r)){const p=this._defaultConfiguration.getKeysForOverrideIdentifier(a),m=n.getKeysForOverrideIdentifier(a),d=[...m.filter(b=>p.indexOf(b)===-1),...p.filter(b=>m.indexOf(b)===-1),...p.filter(b=>!D.equals(this._defaultConfiguration.override(a).getValue(b),n.override(a).getValue(b)))];i.push([a,d])}return this.updateDefaultConfiguration(n),{keys:s,overrides:i}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:i,removed:r}=R(this._policyConfiguration,n),a=[...s,...i,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:i,removed:r,overrides:a}=R(this.applicationConfiguration,n),p=[...s,...i,...r];return p.length&&this.updateApplicationConfiguration(n),{keys:p,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:i,removed:r,overrides:a}=R(this.localUserConfiguration,n),p=[...s,...i,...r];return p.length&&this.updateLocalUserConfiguration(n),{keys:p,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:i,removed:r,overrides:a}=R(this.remoteUserConfiguration,n),p=[...s,...i,...r];return p.length&&this.updateRemoteUserConfiguration(n),{keys:p,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:i,removed:r,overrides:a}=R(this.workspaceConfiguration,n),p=[...s,...i,...r];return p.length&&this.updateWorkspaceConfiguration(n),{keys:p,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const i=this.folderConfigurations.get(n),{added:r,updated:a,removed:p,overrides:m}=R(i,s),d=[...r,...a,...p];return(d.length||!i)&&this.updateFolderConfiguration(n,s),{keys:d,overrides:m}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:r,removed:a,overrides:p}=R(s,void 0);return{keys:[...i,...r,...a],overrides:p}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,s,i){let r=this.getConsolidatedConfigurationModelForResource(s,i);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:n},s){let i=this.getWorkspaceConsolidatedConfiguration();if(s&&n){const r=s.getFolder(n);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const a=this._memoryConfigurationByResource.get(n);a&&(i=i.merge(a))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let s=this._foldersConsolidatedConfigurations.get(n);if(!s){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(n);r?(s=i.merge(r),this._foldersConsolidatedConfigurations.set(n,s)):s=i}return s}getFolderConfigurationModelForResource(n,s){if(s&&n){const i=s.getFolder(n);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,s)=>{const{contents:i,overrides:r,keys:a}=this._folderConfigurations.get(s);return n.push([s,{contents:i,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this._workspaceConfiguration.keys.forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(i=>n.add(i))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(i=>n.add(i))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.parseConfigurationModel(n.defaults),i=this.parseConfigurationModel(n.policy),r=this.parseConfigurationModel(n.application),a=this.parseConfigurationModel(n.user),p=this.parseConfigurationModel(n.workspace),m=n.folders.reduce((d,b)=>(d.set(v.URI.revive(b[0]),this.parseConfigurationModel(b[1])),d),new k.ResourceMap);return new h(s,i,r,a,new g,p,m,new g,new k.ResourceMap)}static parseConfigurationModel(n){return new g(n.contents,n.keys,n.overrides)}}e.Configuration=h;function y(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,p])=>{const m=(0,k.getOrSet)(s,a,new Set);p.forEach(d=>m.add(d))});const i=[];return s.forEach((r,a)=>i.push([a,[...r.values()]])),{keys:[...n.values()],overrides:i}}e.mergeChanges=y;class E{constructor(n,s,i,r){this.change=n,this.previous=s,this.currentConfiguraiton=i,this.currentWorkspace=r,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const p of a)this.affectedKeys.add(p);this._affectsConfigStr=this._marker;for(const a of this.affectedKeys)this._affectsConfigStr+=a+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,s){const i=this._marker+n,r=this._affectsConfigStr.indexOf(i);if(r<0)return!1;const a=r+i.length;if(a>=this._affectsConfigStr.length)return!1;const p=this._affectsConfigStr.charCodeAt(a);if(p!==this._markerCode1&&p!==this._markerCode2)return!1;if(s){const m=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.previous?.workspace):void 0,d=this.currentConfiguraiton.getValue(n,s,this.currentWorkspace);return!D.equals(m,d)}return!0}}e.ConfigurationChangeEvent=E;function R(o,n){const{added:s,removed:i,updated:r}=t(n?.rawConfiguration,o?.rawConfiguration),a=[],p=o?.getAllOverrideIdentifiers()||[],m=n?.getAllOverrideIdentifiers()||[];if(n){const d=m.filter(b=>!p.includes(b));for(const b of d)a.push([b,n.getKeysForOverrideIdentifier(b)])}if(o){const d=p.filter(b=>!m.includes(b));for(const b of d)a.push([b,o.getKeysForOverrideIdentifier(b)])}if(n&&o){for(const d of p)if(m.includes(d)){const b=t({contents:o.getOverrideValue(void 0,d)||{},keys:o.getKeysForOverrideIdentifier(d)},{contents:n.getOverrideValue(void 0,d)||{},keys:n.getKeysForOverrideIdentifier(d)});a.push([d,[...b.added,...b.removed,...b.updated]])}}return{added:s,removed:i,updated:r,overrides:a}}function t(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],i=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const p=(0,I.getConfigurationValue)(n.contents,a),m=(0,I.getConfigurationValue)(o.contents,a);D.equals(p,m)||r.push(a)}}return{added:s,removed:i,updated:r}}}),define(oe[204],ae([0,1,21,3,2,30,11,71,49,8,56,40]),function(te,e,L,N,T,A,k,D,P,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class S extends T.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new N.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new D.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(C.Registry.as(P.Extensions.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:l})=>this.onDidUpdateConfiguration(Array.from(c),l))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(c,l){this.updateConfigurationModel(c,C.Registry.as(P.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:c})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new D.ConfigurationModel;const c=C.Registry.as(P.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(c),c)}updateConfigurationModel(c,l){const h=this.getConfigurationDefaultOverrides();for(const y of c){const E=h[y],R=l[y];E!==void 0?this._configurationModel.addValue(y,E):R?this._configurationModel.addValue(y,R.default):this._configurationModel.removeValue(y)}}}e.DefaultConfiguration=S;class u{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new D.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=u;let g=class extends T.Disposable{get configurationModel(){return this._configurationModel}constructor(c,l,h){super(),this.defaultConfiguration=c,this.policyService=l,this.logService=h,this._onDidChangeConfiguration=this._register(new N.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new D.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(c=>this.onDidChangePolicies(c))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:c})=>this.update(await this.updatePolicyDefinitions(c),!0))),this._configurationModel}async updatePolicyDefinitions(c){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",c);const l={},h=[],y=C.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(const E of c){const R=y[E];if(!R){h.push(E);continue}if(R.policy){if(R.type!=="string"&&R.type!=="number"){this.logService.warn(`Policy ${R.policy.name} has unsupported type ${R.type}`);continue}h.push(E),l[R.policy.name]={type:R.type}}}return(0,k.isEmptyObject)(l)||await this.policyService.updatePolicyDefinitions(l),h}onDidChangePolicies(c){this.logService.trace("PolicyConfiguration#onDidChangePolicies",c);const l=C.Registry.as(P.Extensions.Configuration).getPolicyConfigurations(),h=(0,L.coalesce)(c.map(y=>l.get(y)));this.update(h,!0)}update(c,l){this.logService.trace("PolicyConfiguration#update",c);const h=C.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),y=[],E=this._configurationModel.isEmpty();for(const R of c){const t=h[R]?.policy?.name;if(t){const o=this.policyService.getPolicyValue(t);(E?o!==void 0:!(0,A.equals)(this._configurationModel.getValue(R),o))&&y.push([R,o])}else this._configurationModel.getValue(R)!==void 0&&y.push([R,void 0])}if(y.length){this.logService.trace("PolicyConfiguration#changed",y);const R=this._configurationModel;this._configurationModel=new D.ConfigurationModel;for(const t of R.keys)this._configurationModel.setValue(t,R.getValue(t));for(const[t,o]of y)o===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,o);l&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=g,e.PolicyConfiguration=g=ve([Y(1,I.IPolicyService),Y(2,v.ILogService)],g)}),define(oe[205],ae([0,1,6,3,2,22,18,71,204,56]),function(te,e,L,N,T,A,k,D,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends T.Disposable{constructor(S,u,g,w){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new N.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new P.DefaultConfiguration),this.policyConfiguration=g instanceof v.NullPolicyService?new P.NullPolicyConfiguration:this._register(new P.PolicyConfiguration(this.defaultConfiguration,g,w)),this.userConfiguration=this._register(new D.UserSettings(this.settingsResource,{},A.extUriBiasedIgnorePathCase,u)),this.configuration=new D.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new D.ConfigurationModel,new D.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:c,properties:l})=>this.onDidDefaultConfigurationChange(c,l))),this._register(this.policyConfiguration.onDidChangeConfiguration(c=>this.onDidPolicyConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,u,g]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new D.Configuration(S,u,new D.ConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(S,u){const g=typeof S=="string"?S:void 0,w=(0,k.isConfigurationOverrides)(S)?S:(0,k.isConfigurationOverrides)(u)?u:{};return this.configuration.getValue(g,w,void 0)}updateValue(S,u,g,w){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const u=this.configuration.toData(),g=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(g,u,2)}onDidDefaultConfigurationChange(S,u){const g=this.configuration.toData(),w=this.configuration.compareAndUpdateDefaultConfiguration(S,u);this.trigger(w,g,7)}onDidPolicyConfigurationChange(S){const u=this.configuration.toData(),g=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(g,u,7)}trigger(S,u,g){const w=new D.ConfigurationChangeEvent(S,{data:u},this.configuration);w.source=g,w.sourceConfig=this.getTargetConfiguration(g),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(oe[206],ae([0,1,14]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const N=(T,A,k)=>{const D=new Uint8Array(16);for(let I=0;I<16;I++)D[I]=Math.round(Math.random()*256);const P=(0,L.encodeBase64)(L.VSBuffer.wrap(D));return[`GET ws://localhost${T}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=N,e.socketRawEndHeaderSequence=L.VSBuffer.fromString(`\r
\r
`)}),define(oe[207],ae([0,1,7,4]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,N.createDecorator)("remoteAuthorityResolverService");var T;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(T||(e.RemoteConnectionType=T={}));class A{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=A;class k{constructor(C,S){this.host=C,this.port=S,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=k;var D;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(D||(e.RemoteAuthorityResolverErrorCode=D={}));class P extends L.ErrorNoTelemetry{static isNotAvailable(C){return C instanceof P&&C._code===D.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof P&&C._code===D.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof P&&C._code===D.NoResolverFound}static isInvalidAuthority(C){return C instanceof P&&C._code===D.InvalidAuthority}static isHandled(C){return C instanceof P&&C.isHandled}constructor(C,S=D.Unknown,u){super(C),this._message=C,this._code=S,this._detail=u,this.isHandled=S===D.NotAvailable&&u===!0,Object.setPrototypeOf(this,P.prototype)}}e.RemoteAuthorityResolverError=P;function v(I){const C=I.indexOf("+");return C===-1?I:I.substring(0,C)}e.getRemoteAuthorityPrefix=v}),define(oe[72],ae([0,1,26]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function N(v){return v.scheme===L.Schemas.vscodeRemote?v.authority:void 0}e.getRemoteAuthority=N;function T(v){if(!v)return;const I=v.indexOf("+");return I<0?v:v.substr(0,I)}e.getRemoteName=T;function A(v){return`/${v.quality??"oss"}-${v.commit??"dev"}`}e.getRemoteServerRootPath=A;function k(v){const{host:I,port:C}=P(v);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:C}}e.parseAuthorityWithPort=k;function D(v,I){let{host:C,port:S}=P(v);return typeof S>"u"&&(S=I),{host:C,port:S}}e.parseAuthorityWithOptionalPort=D;function P(v){const I=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const C=v.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const S=v.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:v,port:void 0}}}),define(oe[45],ae([0,1,27,4,72]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(k||(e.ExtensionType=k={}));var D;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.LINUX_PPC64LE="linux-ppc64le",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(D||(e.TargetPlatform=D={}));class P{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,l){if(typeof c>"u"||c===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof c=="string"||typeof l=="string"){const h=typeof c=="string"?c:c.value,y=typeof l=="string"?l:l.value;return L.equalsIgnoreCase(h,y)}return c._lower===l._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.ExtensionIdentifier=P;class v{get size(){return this._set.size}constructor(c){if(this._set=new Set,c)for(const l of c)this.add(l)}add(c){this._set.add(P.toKey(c))}delete(c){return this._set.delete(P.toKey(c))}has(c){return this._set.has(P.toKey(c))}}e.ExtensionIdentifierSet=v;class I{constructor(){this._map=new Map}clear(){this._map.clear()}delete(c){this._map.delete(P.toKey(c))}get(c){return this._map.get(P.toKey(c))}has(c){return this._map.has(P.toKey(c))}set(c,l){this._map.set(P.toKey(c),l)}values(){return this._map.values()}forEach(c){this._map.forEach(c)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=I;function C(w){return S(w)}e.isApplicationScopedExtension=C;function S(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function u(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=u;function g(w,c){if(c){const l=`onResolveRemoteAuthority:${(0,T.getRemoteName)(c)}`;return!!w.activationEvents?.includes(l)}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,N.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[208],ae([0,1,2,45,13]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends L.Disposable{constructor(D,P,v,I,C){super(),this.userDataProfilesService=D,this.fileService=P,this.uriIdentityService=v,this.logService=C,this._register(I.onDidInstallExtensions(S=>this.onDidInstallExtensions(S))),this._register(I.onDidUninstallExtension(S=>this.onDidUnInstallExtension(S)))}onDidInstallExtensions(D){for(const P of D)P.local&&this.invalidate(P.profileLocation)}onDidUnInstallExtension(D){D.error||this.invalidate(D.profileLocation)}async invalidate(D){if(D)for(const P of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(P.extensionsResource,D)&&await this.deleteUserCacheFile(P);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(D){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(D.cacheHome,N.USER_MANIFEST_CACHE_FILE))}catch(P){(0,T.toFileOperationResult)(P)!==1&&this.logService.error(P)}}}e.ExtensionsManifestCache=A}),define(oe[209],ae([0,1,6,14,25,7,3,2,100,87,32,92,207,72]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const g=30*1e3;var w;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function c(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(U){const f=new T.CancellationTokenSource;return setTimeout(()=>f.cancel(),U),f.token}function h(U,f){if(U.isCancellationRequested||f.isCancellationRequested)return T.CancellationToken.Cancelled;const _=new T.CancellationTokenSource;return U.onCancellationRequested(()=>_.cancel()),f.onCancellationRequested(()=>_.cancel()),_.token}class y{get didTimeout(){return this._state==="timedout"}constructor(f){this._state="pending",this._disposables=new D.DisposableStore,this.promise=new Promise((_,$)=>{this._resolvePromise=_,this._rejectPromise=$}),f.isCancellationRequested?this._timeout():this._disposables.add(f.onCancellationRequested(()=>this._timeout()))}registerDisposable(f){this._state==="pending"?this._disposables.add(f):f.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const f=new Error("Time limit reached");return f.code="ETIMEDOUT",f.syscall="connect",f}resolve(f){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(f))}reject(f){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(f))}}function E(U,f){const _=new y(f);return _.registerDisposable(U.onControlMessage($=>{const H=JSON.parse($.toString()),W=x(H);W?_.reject(W):_.resolve(H)})),_.promise}function R(U,f,_,$,H,W,K,Z){const se=new y(Z),ue=v.StopWatch.create(!1);return U.info(`Creating a socket (${K})...`),P.mark(`code/willCreateSocket/${W}`),f.connect(_,$,H,K).then(he=>{se.didTimeout?(P.mark(`code/didCreateSocketError/${W}`),U.info(`Creating a socket (${K}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(P.mark(`code/didCreateSocketOK/${W}`),U.info(`Creating a socket (${K}) was successful after ${ue.elapsed()} ms.`),se.resolve(he))},he=>{P.mark(`code/didCreateSocketError/${W}`),U.info(`Creating a socket (${K}) returned an error after ${ue.elapsed()} ms.`),U.error(he),se.reject(he)}),se.promise}function t(U,f){const _=new y(f);return U.then($=>{_.didTimeout||_.resolve($)},$=>{_.didTimeout||_.reject($)}),_.promise}async function o(U,f,_,$){const H=ce(U,f);U.logService.trace(`${H} 1/6. invoking socketFactory.connect().`);let W;try{W=await R(U.logService,U.remoteSocketFactoryService,U.connectTo,(0,u.getRemoteServerRootPath)(U),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,c(f),`renderer-${c(f)}-${U.reconnectionToken}`,$)}catch(he){throw U.logService.error(`${H} socketFactory.connect() failed or timed out. Error:`),U.logService.error(he),he}U.logService.trace(`${H} 2/6. socketFactory.connect() was successful.`);let K,Z;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(W,null),K=U.reconnectionProtocol,Z=!1):(K=new C.PersistentProtocol({socket:W}),Z=!0),U.logService.trace(`${H} 3/6. sending AuthRequest control message.`);const se=await t(U.signService.createNewMessage((0,I.generateUuid)()),$),ue={type:"auth",auth:U.connectionToken||"00000000000000000000",data:se.data};K.sendControl(N.VSBuffer.fromString(JSON.stringify(ue)));try{const he=await E(K,h($,l(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(U.logService.trace(`${H} 4/6. received SignRequest control message.`),!await t(U.signService.validate(se,he.signedData),$)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Ee=await t(U.signService.sign(he.data),$),be={type:"connectionType",commit:U.commit,signedData:Ee,desiredConnectionType:f};return _&&(be.args=_),U.logService.trace(`${H} 5/6. sending ConnectionTypeRequest control message.`),K.sendControl(N.VSBuffer.fromString(JSON.stringify(be))),{protocol:K,ownsProtocol:Z}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(U.logService.error(`${H} the handshake timed out. Error:`),U.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${H} received error control message when negotiating connection. Error:`),U.logService.error(he)),Z&&V(K),he}}async function n(U,f,_,$){const H=Date.now(),W=ce(U,f),{protocol:K,ownsProtocol:Z}=await o(U,f,_,$),se=new y($);return se.registerDisposable(K.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),Se=x(he);Se?(U.logService.error(`${W} received error control message when negotiating connection. Error:`),U.logService.error(Se),Z&&V(K),se.reject(Se)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${re(H)}!`),se.resolve({protocol:K,firstMessage:he}))})),se.promise}async function s(U,f){const{protocol:_}=await n(U,1,void 0,f);return{protocol:_}}async function i(U,f,_){const{protocol:$,firstMessage:H}=await n(U,2,f,_),W=H&&H.debugPort;return{protocol:$,debugPort:W}}async function r(U,f,_){const $=Date.now(),H=ce(U,3),{protocol:W}=await o(U,3,f,_);return U.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${re($)}!`),W}async function a(U,f,_){const{connectTo:$,connectionToken:H}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,connectTo:$,connectionToken:H,reconnectionToken:f,reconnectionProtocol:_,remoteSocketFactoryService:U.remoteSocketFactoryService,signService:U.signService,logService:U.logService}}async function p(U,f,_){return d(U,async $=>{const{protocol:H}=await s($,T.CancellationToken.None);return new G(U,f,_,$.reconnectionToken,H)})}e.connectRemoteAgentManagement=p;async function m(U,f){return d(U,async _=>{const{protocol:$,debugPort:H}=await i(_,f,T.CancellationToken.None);return new X(U,f,_.reconnectionToken,$,H)})}e.connectRemoteAgentExtensionHost=m;async function d(U,f){for(let $=1;;$++)try{const H=(0,I.generateUuid)(),W=await a(U,H,null);return await f(W)}catch(H){if($<5)U.logService.error(`[remote-connection][attempt ${$}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(H);else throw U.logService.error(`[remote-connection][attempt ${$}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(H),J.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled(H)),H}}async function b(U,f,_){const $=await a(U,(0,I.generateUuid)(),null);return await r($,{host:f,port:_},T.CancellationToken.None)}e.connectRemoteAgentTunnel=b;function O(U){return(0,L.createCancelablePromise)(f=>new Promise((_,$)=>{const H=setTimeout(_,U*1e3);f.onCancellationRequested(()=>{clearTimeout(H),_()})}))}var F;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class M{constructor(f,_){this.reconnectionToken=f,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=M;class q{constructor(f,_,$,H){this.reconnectionToken=f,this.millisSinceLastIncomingData=_,this.durationSeconds=$,this.cancellableTimer=H,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=q;class j{constructor(f,_,$){this.reconnectionToken=f,this.millisSinceLastIncomingData=_,this.attempt=$,this.type=2}}e.ReconnectionRunningEvent=j;class B{constructor(f,_,$){this.reconnectionToken=f,this.millisSinceLastIncomingData=_,this.attempt=$,this.type=4}}e.ConnectionGainEvent=B;class Q{constructor(f,_,$,H){this.reconnectionToken=f,this.millisSinceLastIncomingData=_,this.attempt=$,this.handled=H,this.type=3}}e.ReconnectionPermanentFailureEvent=Q;class J extends D.Disposable{static triggerPermanentFailure(f,_,$){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=f,this._permanentFailureAttempt=_,this._permanentFailureHandled=$,this._instances.forEach(H=>H._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(f=>f._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(f=>f._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||J._permanentFailure}constructor(f,_,$,H,W){super(),this._connectionType=f,this._options=_,this.reconnectionToken=$,this.protocol=H,this._reconnectionFailureIsFatal=W,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new B(this.reconnectionToken,0,0)),this._register(H.onSocketClose(K=>{const Z=ne(this._connectionType,this.reconnectionToken,!0);K?K.type===0?(this._options.logService.info(`${Z} received socket close event (hadError: ${K.hadError}).`),K.error&&this._options.logService.error(K.error)):(this._options.logService.info(`${Z} received socket close event (wasClean: ${K.wasClean}, code: ${K.code}, reason: ${K.reason}).`),K.event&&this._options.logService.error(K.event)):this._options.logService.info(`${Z} received socket close event.`),this._beginReconnecting()})),this._register(H.onSocketTimeout(K=>{const Z=ne(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} received socket timeout event (unacknowledgedMsgCount: ${K.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${K.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${K.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),J._instances.push(this),this._register((0,D.toDisposable)(()=>{const K=J._instances.indexOf(this);K>=0&&J._instances.splice(K,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(J._permanentFailureMillisSinceLastIncomingData,J._permanentFailureAttempt,J._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const f=ne(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${f} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let $=-1;do{$++;const H=$<_.length?_[$]:_[_.length-1];try{if(H>0){const K=O(H);this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H,K)),this._options.logService.info(`${f} waiting for ${H} seconds before reconnecting...`);try{await K}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${f} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$+1)),this._options.logService.info(`${f} resolving connection...`);const W=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${f} connecting to ${W.connectTo}...`),await this._reconnect(W,l(g)),this._options.logService.info(`${f} reconnected!`),this._onDidStateChange.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$+1));break}catch(W){if(W.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${f} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(W),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}if($>360){this._options.logService.error(`${f} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(W),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable(W)){this._options.logService.info(`${f} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(W);continue}if((W.code==="ETIMEDOUT"||W.code==="ENETUNREACH"||W.code==="ECONNREFUSED"||W.code==="ECONNRESET")&&W.syscall==="connect"){this._options.logService.info(`${f} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(W);continue}if((0,A.isCancellationError)(W)){this._options.logService.info(`${f} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(W);continue}if(W instanceof S.RemoteAuthorityResolverError){this._options.logService.error(`${f} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(W),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,S.RemoteAuthorityResolverError.isHandled(W));break}this._options.logService.error(`${f} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(W),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(f,_,$){this._reconnectionFailureIsFatal?J.triggerPermanentFailure(f,_,$):this._gotoPermanentFailure(f,_,$)}_gotoPermanentFailure(f,_,$){this._onDidStateChange.fire(new Q(this.reconnectionToken,f,_,$)),V(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=J;class G extends J{constructor(f,_,$,H,W){super(1,f,H,W,!0),this.client=this._register(new C.Client(W,{remoteAuthority:_,clientId:$},f.ipcLogger))}async _reconnect(f,_){await s(f,_)}}e.ManagementPersistentConnection=G;class X extends J{constructor(f,_,$,H,W){super(2,f,$,H,!1),this._startArguments=_,this.debugPort=W}async _reconnect(f,_){await i(f,this._startArguments,_)}}e.ExtensionHostPersistentConnection=X;function V(U){try{U.acceptDisconnect();const f=U.getSocket();U.dispose(),f.dispose()}catch(f){(0,A.onUnexpectedError)(f)}}function x(U){if(U&&U.type==="error"){const f=new Error(`Connection error: ${U.reason}`);return f.code="VSCODE_CONNECTION_ERROR",f}return null}function z(U,f){for(;U.length<f;)U+=" ";return U}function ee(U,f){return`[remote-connection][${z(c(U),13)}][${f.substr(0,5)}\u2026]`}function ne(U,f,_){return`${ee(U,f)}[${_?"reconnect":"initial"}]`}function ce(U,f){return`${ne(f,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.connectTo}]`}function re(U){return`${Date.now()-U} ms`}}),define(oe[104],ae([0,1,2,4]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,N.createDecorator)("remoteSocketFactoryService");class T{constructor(){this.factories={}}register(k,D){return this.factories[k]??=[],this.factories[k].push(D),(0,L.toDisposable)(()=>{const P=this.factories[k]?.indexOf(D);typeof P=="number"&&P>=0&&this.factories[k]?.splice(P,1)})}getSocketFactory(k){return(this.factories[k.type]||[]).find(P=>P.supports(k))}connect(k,D,P,v){const I=this.getSocketFactory(k);if(!I)throw new Error(`No socket factory found for ${k}`);return I.connect(k,D,P,v)}}e.RemoteSocketFactoryService=T}),define(oe[210],ae([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[105],ae([0,1,4,160]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.INACTIVE_TUNNEL_MODE=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,L.createDecorator)("IRemoteTunnelService"),e.INACTIVE_TUNNEL_MODE={active:!1};var T;(function(A){A.disconnected=k=>({type:"disconnected",onTokenFailed:k}),A.connected=(k,D)=>({type:"connected",info:k,serviceInstallFailed:D}),A.connecting=k=>({type:"connecting",progress:k}),A.uninitialized={type:"uninitialized"}})(T||(e.TunnelStates=T={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,N.localize)(0,null)}),define(oe[57],ae([0,1,14,7,2,162,49,4,8,40]),function(te,e,L,N,T,A,k,D,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");class I{constructor(R){this.original=R}toJSON(){if(!this.headers){const R=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?R[t]="*****":R[t]=this.original[t];this.headers=R}return this.headers}}class C extends T.Disposable{constructor(R){super(),this.counter=0,this.logger=R.createLogger("network",{name:(0,A.localize)(0,null),when:P.CONTEXT_LOG_LEVEL.isEqualTo((0,P.LogLevelToString)(P.LogLevel.Trace)).serialize()})}async logAndRequest(R,t,o){const n=`${R} #${++this.counter}: ${t.url}`;this.logger.trace(`${n} - begin`,t.type,new I(t.headers??{}));try{const s=await o();return this.logger.trace(`${n} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.logger.error(`${n} - error`,t.type,(0,N.getErrorMessage)(s)),s}}}e.AbstractRequestService=C;function S(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.isSuccess=S;function u(E){return E.res.statusCode===204}async function g(E){return u(E)?null:(await(0,L.streamToBuffer)(E.stream)).toString()}e.asText=g;async function w(E){if(!S(E))throw new Error("Server returned "+E.res.statusCode);return g(E)}e.asTextOrError=w;async function c(E){if(!S(E))throw new Error("Server returned "+E.res.statusCode);if(u(E))return null;const t=(await(0,L.streamToBuffer)(E.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.asJson=c;function l(E){y(E)}e.updateProxyConfigurationsScope=l;let h;function y(E){const R=v.Registry.as(k.Extensions.Configuration),t=h;h={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},R.updateConfigurations({add:[h],remove:t?[t]:[]})}y(1)}),define(oe[211],ae([0,1,25,26,13,57]),function(te,e,L,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(P,v){this.requestService=P,this.fileService=v}async download(P,v,I=L.CancellationToken.None){if(P.scheme===N.Schemas.file||P.scheme===N.Schemas.vscodeRemote){await this.fileService.copy(P,v);return}const C={type:"GET",url:P.toString(!0)},S=await this.requestService.request(C,I);if(S.res.statusCode===200)await this.fileService.writeFile(v,S.stream);else{const u=await(0,A.asTextOrError)(S);throw new Error(`Expected 200, got back ${S.res.statusCode} instead.

${u}`)}}};e.DownloadService=k,e.DownloadService=k=ve([Y(0,A.IRequestService),Y(1,T.IFileService)],k)}),define(oe[212],ae([0,1,14,25]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class T{constructor(D){this.service=D}listen(D,P){throw new Error("Invalid listen")}call(D,P,v,I=N.CancellationToken.None){switch(P){case"request":return this.service.request(v[0],I).then(async({res:C,stream:S})=>{const u=await(0,L.streamToBuffer)(S);return[{statusCode:C.statusCode,headers:C.headers},u]});case"resolveProxy":return this.service.resolveProxy(v[0])}throw new Error("Invalid call")}}e.RequestChannel=T;class A{constructor(D){this.channel=D}async request(D,P){const[v,I]=await this.channel.call("request",[D],P);return{res:v,stream:(0,L.bufferToStream)(I)}}async resolveProxy(D){return this.channel.call("resolveProxy",[D])}}e.RequestChannelClient=A}),define(oe[213],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class L{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(T){try{const A=await this.getValidator();if(A){const k=String(L._nextId++);return this.validators.set(k,A),{id:k,data:A.createNewMessage(T)}}}catch{}return{id:"",data:T}}async validate(T,A){if(!T.id)return!0;const k=this.validators.get(T.id);if(!k)return!1;this.validators.delete(T.id);try{return k.validate(A)==="ok"}catch{return!1}finally{k.dispose?.()}}async sign(T){try{return await this.signValue(T)}catch{}return T}}e.AbstractSignService=L}),define(oe[106],ae([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[214],ae([0,1,213]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class N extends L.AbstractSignService{getValidator(){return this.vsda().then(A=>new A.validator)}signValue(A){return this.vsda().then(k=>new k.signer().sign(A))}vsda(){return new Promise((A,k)=>te(["vsda"],A,k))}}e.SignService=N}),define(oe[73],ae([0,1,3,2]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class T extends N.Disposable{constructor(C,S,u){super(),this.channel=C,this.profile=S,this.workspace=u}async getItems(){const C={profile:this.profile,workspace:this.workspace},S=await this.channel.call("getItems",C);return new Map(S)}updateItems(C){const S={profile:this.profile,workspace:this.workspace};return C.insert&&(S.insert=Array.from(C.insert.entries())),C.delete&&(S.delete=Array.from(C.delete.values())),this.channel.call("updateItems",S)}}class A extends T{constructor(C,S){super(C,S,void 0),this._onDidChangeItemsExternal=this._register(new L.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(C=>this.onDidChangeStorage(C)))}onDidChangeStorage(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this._onDidChangeItemsExternal.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}}class k extends A{constructor(C){super(C,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=k;class D extends A{constructor(C,S){super(C,S)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=D;class P extends T{constructor(C,S){super(C,void 0,S),this.onDidChangeItemsExternal=L.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=P;class v{constructor(C){this.channel=C}isUsed(C){const S={payload:C,profile:void 0,workspace:void 0};return this.channel.call("isUsed",S)}}e.StorageClient=v}),define(oe[107],ae([0,1,5,37,32]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(P){if(L.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}function k(P,v,I,C,S,u,g,w){const c=Object.create(null);c["common.machineId"]=u,c.sessionID=(0,T.generateUuid)()+Date.now(),c.commitHash=C,c.version=S,c["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,L.PlatformToString)(L.platform),c["common.nodePlatform"]=N.platform,c["common.nodeArch"]=I,c["common.product"]=w||"desktop",g&&(c["common.msftInternal"]=g);let l=0;const h=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),L.isLinuxSnap&&(c["common.snap"]="true");const y=A(v);return y&&(c["common.platformDetail"]=y),c}e.resolveCommonProperties=k;function D(P){const v=N.env.USERDNSDOMAIN;if(!v)return!1;const I=v.toLowerCase();return P.some(C=>I===C)}e.verifyMicrosoftInternalDomain=D}),define(oe[20],ae([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var T;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(T||(e.TelemetryConfiguration=T={}))}),define(oe[215],ae([0,1,36,6,34,26,16,5,10,128,31,142,95,13,24,20]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const c=new Map;async function l(t,o){const n=`${t}::${o.join(":")}`,s=c.get(n);if(s)return s;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,p=2e4;function m(b,O,F,M){const q=O.substring(b.length+1);return N.Promises.withAsyncBody(async j=>{let B;try{B=await I.Promises.readdir(O,{withFileTypes:!0})}catch{j();return}if(M.count>=p){M.count+=B.length,M.maxReached=!0,j();return}let Q=B.length;if(Q===0){j();return}let J=B;M.count+B.length>p&&(M.maxReached=!0,Q=p-M.count,J=B.slice(0,Q)),M.count+=B.length;for(const G of J)if(G.isDirectory()){if(F.includes(G.name)||await m(b,(0,k.join)(O,G.name),F,M),--Q===0){j();return}}else{const X=G.name.lastIndexOf(".");if(X>=0){const V=G.name.substring(X+1);V&&r.set(V,(r.get(V)??0)+1)}for(const V of i)V.relativePathPattern?.test(q)!==!1&&V.filePattern.test(G.name)&&a.set(V.tag,(a.get(V.tag)??0)+1);if(--Q===0){j();return}}})}const d=N.Promises.withAsyncBody(async b=>{const O={count:0,maxReached:!1};await m(t,t,o,O);const F=await E(t);b({configFiles:h(a),fileTypes:h(r),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:F})});return c.set(n,d),d}e.collectWorkspaceStats=l;function h(t){return Array.from(t.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function y(){const t={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(v.virtualMachineHint.value()*100)}%`},o=L.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.getMachineInfo=y;async function E(t){try{const o=new Map,n=(0,k.join)(t,".vscode","launch.json"),s=await I.Promises.readFile(n),i=[],r=(0,T.parse)(s.toString(),i);if(i.length)return console.log(`Unable to parse ${n}`),[];if((0,T.getNodeType)(r)==="object"&&r.configurations)for(const a of r.configurations){const p=a.type;p&&(o.has(p)?o.set(p,o.get(p)+1):o.set(p,1))}return h(o)}catch{return[]}}e.collectLaunchConfigs=E;let R=class{constructor(o,n){this.telemetryService=o,this.productService=n}formatMachineInfo(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}formatEnvironment(o){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const s=L.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(L.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),D.isWindows||n.push(`Load (avg):       ${L.loadavg().map(i=>Math.round(i)).join(", ")}`),n.push(`VM:               ${Math.round(v.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,C.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async s=>{let[i,r]=s,a=this.formatProcessList(o,i);return n.forEach(p=>{if((0,S.isRemoteDiagnosticError)(p))a+=`
${p.errorMessage}`,r+=`
${p.errorMessage}`;else if(a+=`

Remote: ${p.hostName}`,p.processes&&(a+=`
${this.formatProcessList(o,p.processes)}`),p.workspaceMetadata){r+=`
|  Remote: ${p.hostName}`;for(const m of Object.keys(p.workspaceMetadata)){const d=p.workspaceMetadata[m];let b=`${d.fileCount} files`;d.maxFilesReached&&(b=`more than ${b}`),r+=`|    Folder (${m}): ${b}`,r+=this.formatWorkspaceStats(d)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:i,os:r,cpus:a}=y(),p={os:r,memory:s,cpus:a,vmHint:i,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return D.isWindows||(p.load=`${L.loadavg().map(m=>Math.round(m)).join(", ")}`),D.isLinux&&(p.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(p)}async getDiagnostics(o,n){const s=[];return(0,C.listProcesses)(o.mainPID).then(async i=>(s.push(""),s.push(this.formatEnvironment(o)),s.push(""),s.push(this.formatProcessList(o,i)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(o))),n.forEach(r=>{if((0,S.isRemoteDiagnosticError)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.formatMachineInfo(r.machineInfo)),r.processes&&s.push(this.formatProcessList(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const p=r.workspaceMetadata[a];let m=`${p.fileCount} files`;p.maxFilesReached&&(m=`more than ${m}`),s.push(`Folder (${a}): ${m}`),s.push(this.formatWorkspaceStats(p))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(o){const n=[];let i=0;const r=(d,b)=>{const O=` ${d}(${b})`;i+O.length>60?(n.push(a),a="|                 ",i=a.length):i+=O.length,a+=O};let a="|      File types:";const p=10,m=o.fileTypes.length>p?p:o.fileTypes.length;for(let d=0;d<m;d++){const b=o.fileTypes[d];r(b.name,b.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",i=0,o.configFiles.forEach(d=>{r(d.name,d.count)}),n.push(a)),o.launchConfigFiles.length>0){let d="|      Launch Configs:";o.launchConfigFiles.forEach(b=>{const O=b.count>1?` ${b.name}(${b.count})`:` ${b.name}`;d+=O}),n.push(d)}return n.join(`
`)}expandGPUFeatures(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}formatWorkspaceMetadata(o){const n=[],s=[];return o.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(n.push(`|  Window (${i.title})`),i.folderURIs.forEach(r=>{const a=P.URI.revive(r);if(a.scheme===A.Schemas.file){const p=a.fsPath;s.push(l(p,["node_modules",".git"]).then(m=>{let d=`${m.fileCount} files`;m.maxFilesReached&&(d=`more than ${d}`),n.push(`|    Folder (${(0,k.basename)(p)}): ${d}`),n.push(this.formatWorkspaceStats(m))}).catch(m=>{n.push(`|      Error: Unable to collect workspace stats for folder ${p} (${m.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(i=>n.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}formatProcessList(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(o.mainPID,s,i,n,0),i.join(`
`)}formatProcessItem(o,n,s,i,r){const a=r===0;let p;a?p=i.pid===o?`${this.productService.applicationName} main`:"remote agent":n.has(i.pid)?p=n.get(i.pid):p=`${"  ".repeat(r)} ${i.name}`;const m=process.platform==="win32"?i.mem:L.totalmem()*(i.mem/100);s.push(`${i.load.toFixed(0).padStart(5," ")}	${(m/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${p}`),Array.isArray(i.children)&&i.children.forEach(d=>this.formatProcessItem(o,n,s,d,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const i=P.URI.revive(s);if(i.scheme!==A.Schemas.file)continue;const r=i.fsPath;try{(await l(r,["node_modules",".git"])).fileTypes.forEach(p=>n.add(p.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=P.URI.revive(n);if(s.scheme!==A.Schemas.file)continue;const i=s.fsPath;try{const r=await l(i,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.DiagnosticsService=R,e.DiagnosticsService=R=ve([Y(0,w.ITelemetryService),Y(1,g.IProductService)],R)}),define(oe[108],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(A){this.appenders=A}listen(A,k){throw new Error(`Event not found: ${k}`)}call(A,k,{eventName:D,data:P}){return this.appenders.forEach(v=>v.log(D,P)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class N{constructor(A){this.channel=A}log(A,k){return this.channel.call("log",{eventName:A,data:k}).then(void 0,D=>`Failed to log telemetry: ${console.warn(D)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=N}),define(oe[46],ae([0,1,30,11,3,18,72,107,20]),function(te,e,L,N,T,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class v{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=v;class I{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class C{async publicLog(i,r,a){}async publicLogError(i,r,a){}}e.NullEndpointTelemetryService=C,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(s,i){return T.Event.debounce(i.onDidChangeConfiguration,(a,p)=>{const m=a?new Set([...a.affectedKeys,...p.affectedKeys]):p.affectedKeys;return{...p,affectedKeys:m}},1e3,!0)(a=>{a.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.configurationTelemetry=S;function u(s,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!s.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=u;function g(s,i){return!(i.isBuilt||i.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=g;function w(s){const i=s.getValue(P.TELEMETRY_SETTING_ID),r=s.getValue(P.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(s.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function c(s){const i={},r={},a={};y(s,a);for(let p in a){p=p.length>150?p.substr(p.length-149):p;const m=a[p];typeof m=="number"?r[p]=m:typeof m=="boolean"?r[p]=m?1:0:typeof m=="string"?(m.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${m.length}`),i[p]=m.substring(0,8191)):typeof m<"u"&&m!==null&&(i[p]=m)}return{properties:i,measurements:r}}e.validateTelemetryData=c;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(s){if(!s)return"none";const i=(0,k.getRemoteName)(s);return l.has(i)?i:"other"}e.cleanRemoteAuthority=h;function y(s,i,r=0,a){if(s)for(const p of Object.getOwnPropertyNames(s)){const m=s[p],d=a?a+p:p;Array.isArray(m)?i[d]=(0,L.safeStringify)(m):m instanceof Date?i[d]=m.toISOString():(0,N.isObject)(m)?r<2?y(m,i,r+1,d+"."):i[d]=(0,L.safeStringify)(m):i[d]=m}}function E(s,i){const r=s.msftInternalDomains||[],a=i.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(r)||a}e.isInternalTelemetry=E;function R(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=R;function t(s,i){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let r=s;const a=[];for(const b of i)for(;;){const O=b.exec(s);if(!O)break;a.push([O.index,b.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(r="";;){const b=m.exec(s);if(!b)break;const O=a.some(([F,M])=>b.index<M&&F<m.lastIndex);!p.test(b[0])&&!O&&(r+=s.substring(d,b.index)+"<REDACTED: user-file-path>",d=m.lastIndex)}return d<s.length&&(r+=s.substr(d)),r}function o(s){if(!s)return s;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of i)if(r.regex.test(s))return`<REDACTED: ${r.label}>`;return s}function n(s,i){return(0,L.cloneAndChange)(s,r=>{if(r instanceof v||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=t(a,i);for(const p of i)a=a.replace(p,"");return a=o(a),a}})}e.cleanData=n}),define(oe[33],ae([0,1,27,29,45,5,10,7,37,46]),function(te,e,L,N,T,A,k,D,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,L.compareIgnoreCase)(n.id,s.id)===0}e.areSameExtensions=I;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(s){const i=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new S(s.identifier,i,r)}static parse(s){const i=C.exec(s);return i&&i[1]&&i[2]?new S({id:i[1]},i[2],i[4]||void 0):null}constructor(s,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof S?I(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=S;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(n){const s=u.exec(n);return s&&s[1]?[c(s[1]),s[2]]:[c(n),void 0]}e.getIdAndVersion=g;function w(n,s){return`${n}.${s}`}e.getExtensionId=w;function c(n){return n.toLowerCase()}e.adoptToGalleryExtensionId=c;function l(n,s){return c(w(n??T.UNDEFINED_PUBLISHER,s))}e.getGalleryExtensionId=l;function h(n,s){const i=[],r=a=>{for(const p of i)if(p.some(m=>I(s(m),s(a))))return p;return null};for(const a of n){const p=r(a);p?p.push(a):i.push([a])}return i}e.groupByExtension=h;function y(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function E(n){return{id:new v.TelemetryTrustedValue(n.identifier.id),name:new v.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function R(n,s){const i=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&i.every(p=>!I(p.identifier,{id:a}))){const p=n.filter(m=>I(m.identifier,{id:a}));p.length===1&&(i.push(p[0]),r.push(...p[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=R;async function t(n,s){if(!A.isLinux)return!1;let i;try{i=(await n.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await n.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const i=await t(n,s),r=(0,N.getTargetPlatform)(i?"alpine":A.platform,P.arch);return s.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=o}),define(oe[216],ae([0,1,21,2,22,10,13,24,6,3,16,5,37,33]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let g=class extends N.Disposable{constructor(y,E){super(),this.fileService=y,this.productService=E,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,R])=>this.allConfigBasedTips.set(R.configPath,R))}getConfigBasedTips(y){return this.getValidConfigBasedTips(y)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(y){const E=[];for(const[R,t]of this.allConfigBasedTips)if(!(t.configScheme&&t.configScheme!==y.scheme))try{const o=(await this.fileService.readFile((0,T.joinPath)(y,R))).value.toString();for(const[n,s]of Object.entries(t.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&E.push({extensionId:n,extensionName:s.name,configName:t.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return E}};e.ExtensionTipsService=g,e.ExtensionTipsService=g=ve([Y(0,k.IFileService),Y(1,D.IProductService)],g);const w="extensionTips/promptedExecutableTips",c="extensionTips/lastPromptedMediumImpExeTime";class l extends g{constructor(y,E,R,t,o,n,s,i){super(s,i),this.userHome=y,this.windowEvents=E,this.telemetryService=R,this.extensionManagementService=t,this.storageService=o,this.extensionRecommendationNotificationService=n,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([r,a])=>{const p=[],m=[],d=[];Object.entries(a.recommendations).forEach(([b,O])=>{O.important?a.important?p.push({extensionId:b,extensionName:O.name,isExtensionPack:!!O.isExtensionPack}):m.push({extensionId:b,extensionName:O.name,isExtensionPack:!!O.isExtensionPack}):d.push({extensionId:b,extensionName:O.name,isExtensionPack:!!O.isExtensionPack})}),p.length&&this.highImportanceExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:p}),m.length&&this.mediumImportanceExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:m}),d.length&&this.allOtherExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:d})}),(0,P.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const y=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),E=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...y,...E]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const y=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),E=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),R=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(y,R),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(E,R)}groupImportantTipsByExe(y,E){const R=new Map;y.forEach(i=>R.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:o}=this.groupByInstalled([...R.keys()],E);for(const i of t){const r=R.get(i);r&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:r.exeName})}for(const i of o){const r=R.get(i);r&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:r.exeName})}const n=this.getPromptedExecutableTips(),s=new Map;for(const i of o){const r=R.get(i);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[y,E]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(E).then(R=>{switch(R){case"reacted":this.addToRecommendedExecutables(E[0].exeName,E);break;case"ignored":this.highImportanceTipsByExe.delete(y);break;case"incompatibleWindow":{const t=v.Event.once(v.Event.latch(v.Event.any(this.windowEvents.onDidOpenWindow,this.windowEvents.onDidFocusWindow)));this._register(t(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const t=this._register((0,P.disposableTimeout)(()=>{t.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const y=this.getLastPromptedMediumExeTime(),E=Date.now()-y,R=7*24*60*60*1e3;if(E<R){const n=this._register((0,P.disposableTimeout)(()=>{n.dispose(),this.promptMediumImportanceExeBasedTip()},R-E));return}const[t,o]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(n=>{switch(n){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(t),this.addToRecommendedExecutables(o[0].exeName,o);const s=this._register((0,P.disposableTimeout)(()=>{s.dispose(),this.promptMediumImportanceExeBasedTip()},R));break}case"ignored":this.mediumImportanceTipsByExe.delete(t),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const s=v.Event.once(v.Event.latch(v.Event.any(this.windowEvents.onDidOpenWindow,this.windowEvents.onDidFocusWindow)));this._register(s(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const s=this._register((0,P.disposableTimeout)(()=>{s.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(y){const E=await this.extensionManagementService.getInstalled(1),R=y.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(o=>E.every(n=>!(0,u.areSameExtensions)(n.identifier,{id:o})))).map(({extensionId:t})=>t.toLowerCase());return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification({extensions:R,source:3,name:y[0].exeFriendlyName,searchValue:`@exe:"${y[0].exeName}"`})}getLastPromptedMediumExeTime(){let y=this.storageService.getNumber(c,-1);return y||(y=Date.now(),this.updateLastPromptedMediumExeTime(y)),y}updateLastPromptedMediumExeTime(y){this.storageService.store(c,y,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(w,-1,"{}"))}addToRecommendedExecutables(y,E){const R=this.getPromptedExecutableTips();R[y]=E.map(({extensionId:t})=>t.toLowerCase()),this.storageService.store(w,JSON.stringify(R),-1,0)}groupByInstalled(y,E){const R=[],t=[],o=E.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return y.forEach(n=>{o.has(n.toLowerCase())?R.push(n):t.push(n)}),{installed:R,uninstalled:t}}async getValidExecutableBasedExtensionTips(y){const E=[],R=new Map;for(const t of y.keys()){const o=y.get(t);if(!o||!(0,L.isNonEmptyArray)(o.recommendations))continue;const n=[];C.isWindows?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>S.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>S.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>S.env.ProgramFiles).replace("%APPDATA%",()=>S.env.APPDATA).replace("%WINDIR%",()=>S.env.WINDIR)):(n.push((0,I.join)("/usr/local/bin",t)),n.push((0,I.join)("/usr/bin",t)),n.push((0,I.join)(this.userHome.fsPath,t)));for(const s of n){let i=R.get(s);if(i===void 0&&(i=await this.fileService.exists(A.URI.file(s)),R.set(s,i)),i)for(const{extensionId:r,extensionName:a,isExtensionPack:p,whenNotInstalled:m}of o.recommendations)E.push({extensionId:r,extensionName:a,isExtensionPack:p,exeName:t,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:m})}}return E}}e.AbstractNativeExtensionTipsService=l}),define(oe[217],ae([0,1,25,33]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function T(A,k,D,P,v){try{const I=await A.getExtensionsControlManifest();if(!I.deprecated)return;const C=await A.getInstalled(1);for(const[S,u]of Object.entries(I.deprecated)){if(!u?.extension)continue;const{id:g,autoMigrate:w,preRelease:c}=u.extension;if(!w)continue;const l=C.find(y=>(0,N.areSameExtensions)(y.identifier,{id:S}));if(!l)continue;const h=(await k.getExtensions([{id:g,preRelease:c}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0];if(!h){v.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${g}' extension is not found`);continue}try{v.info(`Migrating '${l.identifier.id}' extension to '${g}' extension...`);const y=!P.getDisabledExtensions().some(R=>(0,N.areSameExtensions)(R,l.identifier));await A.uninstall(l),v.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let E=C.find(R=>(0,N.areSameExtensions)(R.identifier,{id:g}));(!E||!E.isPreReleaseVersion&&y)&&(E=await A.installFromGallery(h,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),v.info(`Installed the pre-release extension '${E.identifier.id}'`),y||(await P.disableExtension(E.identifier),v.info(`Disabled the pre-release extension '${E.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),w.storage&&(D.addToMigrationList((0,N.getExtensionId)(l.manifest.publisher,l.manifest.name),(0,N.getExtensionId)(E.manifest.publisher,E.manifest.name)),v.info("Added pre-release extension to the storage migration list"))),v.info(`Migrated '${l.identifier.id}' extension to '${g}' extension.`)}catch(y){v.error(y)}}}catch(I){v.error(I)}}e.migrateUnsupportedExtensions=T}),define(oe[218],ae([0,1,3,2,35,33,45]),function(te,e,L,N,T,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class D extends N.Disposable{constructor(v,I,C,S,u,g,w){super(),this.extensionManagementService=v,this.extensionsScannerService=I,this.userDataProfilesService=C,this.extensionsProfileScannerService=S,this.uriIdentityService=u,this.fileService=g,this.logService=w,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new N.DisposableMap),this.initialize().then(null,c=>w.error(c))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(v=>this.onDidChangeProfiles(v.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(v=>this.onAddExtensions(v))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(v=>this.onDidAddExtensions(v))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(v=>this.onRemoveExtensions(v))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(v=>this.onDidRemoveExtensions(v))),this._register(this.fileService.onDidFilesChange(v=>this.onDidFilesChange(v)))}async onDidChangeProfiles(v){try{v.length&&await Promise.all(v.map(I=>(this.extensionsProfileWatchDisposables.set(I.id,(0,N.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(I.extensionsResource)),this.fileService.watch(I.extensionsResource))),this.populateExtensionsFromProfile(I.extensionsResource))))}catch(I){throw this.logService.error(I),I}}async onAddExtensions(v){for(const I of v.extensions)this.addExtensionWithKey(this.getKey(I.identifier,I.version),v.profileLocation)}async onDidAddExtensions(v){for(const I of v.extensions){const C=this.getKey(I.identifier,I.version);v.error?this.removeExtensionWithKey(C,v.profileLocation):this.addExtensionWithKey(C,v.profileLocation)}}async onRemoveExtensions(v){for(const I of v.extensions)this.removeExtensionWithKey(this.getKey(I.identifier,I.version),v.profileLocation)}async onDidRemoveExtensions(v){const I=[],C=[];for(const S of v.extensions){const u=this.getKey(S.identifier,S.version);v.error?this.addExtensionWithKey(u,v.profileLocation):(this.removeExtensionWithKey(u,v.profileLocation),this.allExtensions.has(u)||(this.logService.debug("Extension is removed from all profiles",S.identifier.id,S.version),C.push(this.extensionManagementService.scanInstalledExtensionAtLocation(S.location).then(g=>{g?I.push(g):this.logService.info("Extension not found at the location",S.location.toString())},g=>this.logService.error(g)))))}try{await Promise.all(C),I.length&&await this.uninstallExtensionsNotInProfiles(I)}catch(S){this.logService.error(S)}}onDidFilesChange(v){for(const I of this.userDataProfilesService.profiles)v.contains(I.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(I.extensionsResource)}async onDidExtensionsProfileChange(v){const I=[],C=[],S=await this.extensionsProfileScannerService.scanProfileExtensions(v),u=new Set,g=new Set;for(const[w,c]of this.allExtensions)c.has(v)&&g.add(w);for(const w of S){const c=this.getKey(w.identifier,w.version);u.add(c),g.has(c)||(I.push(w.identifier),this.addExtensionWithKey(c,v))}for(const w of g)if(!u.has(w)){const c=this.fromKey(w);c&&(C.push(c.identifier),this.removeExtensionWithKey(w,v))}(I.length||C.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:I.length?{extensions:I,profileLocation:v}:void 0,removed:C.length?{extensions:C,profileLocation:v}:void 0})}async populateExtensionsFromProfile(v){const I=await this.extensionsProfileScannerService.scanProfileExtensions(v);for(const C of I)this.addExtensionWithKey(this.getKey(C.identifier,C.version),v)}async uninstallExtensionsNotInProfiles(v){v||(v=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(C=>!this.allExtensions.has(this.getKey(C.identifier,C.manifest.version)))),v.length&&await this.extensionManagementService.markAsUninstalled(...v)}addExtensionWithKey(v,I){let C=this.allExtensions.get(v);C||this.allExtensions.set(v,C=new T.ResourceSet(S=>this.uriIdentityService.extUri.getComparisonKey(S))),C.add(I)}removeExtensionWithKey(v,I){const C=this.allExtensions.get(v);C&&C.delete(I),C?.size||this.allExtensions.delete(v)}getKey(v,I){return`${k.ExtensionIdentifier.toKey(v.id)}@${I}`}fromKey(v){const[I,C]=(0,A.getIdAndVersion)(v);return C?{identifier:{id:I},version:C}:void 0}}e.ExtensionsWatcher=D}),define(oe[219],ae([0,1,44,46]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function T(A,k,D,P,v,I,C){const S={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${k.nameShort})`};if((0,N.supportsTelemetry)(k,D)&&(0,N.getTelemetryLevel)(P)===3){const u=await(0,L.getServiceMachineId)(D,v,I);S["X-Market-User-Id"]=u,S["VSCode-SessionId"]=C.machineId||u}return S}e.resolveMarketplaceHeaders=T}),define(oe[220],ae([0,1,67,21,6,2,26,16,31,15,29,33,8,70,10]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let w=class extends u.LanguagePackBaseService{constructor(y,E,R,t){super(R),this.extensionManagementService=y,this.logService=t,this.cache=this._register(new c(E,t)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getBuiltInExtensionTranslationsUri(y,E){const t=(await this.cache.getLanguagePacks())[E];if(!t){this.logService.warn(`No language pack found for ${E}`);return}const o=t.translations[y];return o?g.URI.file(o):void 0}async getInstalledLanguages(){const y=await this.cache.getLanguagePacks(),E=Object.keys(y).map(R=>{const t=y[R];return{...this.createQuickPickItem(R,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return E.push(this.createQuickPickItem("en","English")),E.sort((R,t)=>R.label.localeCompare(t.label)),E}async postInstallExtension(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",y.identifier.id),await this.update())}async postUninstallExtension(y){const E=await this.cache.getLanguagePacks();Object.keys(E).some(R=>E[R]&&E[R].extensions.some(t=>(0,C.areSameExtensions)(t.extensionIdentifier,y.identifier)))&&(this.logService.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,E]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),R=await this.cache.update(E);return!(0,N.equals)(Object.keys(y),Object.keys(R))}};e.NativeLanguagePackService=w,e.NativeLanguagePackService=w=ve([Y(0,I.IExtensionManagementService),Y(1,v.INativeEnvironmentService),Y(2,I.IExtensionGalleryService),Y(3,S.ILogService)],w);let c=class extends A.Disposable{constructor(y,E){super(),this.logService=E,this.languagePacks={},this.languagePacksFilePath=(0,D.join)(y.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new T.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(y){return this.withLanguagePacks(E=>{Object.keys(E).forEach(R=>delete E[R]),this.createLanguagePacksFromExtensions(E,...y)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(y,...E){for(const R of E)R&&R.manifest&&R.manifest.contributes&&R.manifest.contributes.localizations&&R.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(y,R);Object.keys(y).forEach(R=>this.updateHash(y[R]))}createLanguagePacksFromExtension(y,E){const R=E.identifier,t=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const o of t)if(E.location.scheme===k.Schemas.file&&l(o)){let n=y[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},y[o.languageId]=n);const s=n.extensions.filter(i=>(0,C.areSameExtensions)(i.extensionIdentifier,R))[0];s?s.version=E.manifest.version:n.extensions.push({extensionIdentifier:R,version:E.manifest.version});for(const i of o.translations)n.translations[i.id]=(0,D.join)(E.location.fsPath,i.path)}}updateHash(y){if(y){const E=(0,L.createHash)("md5");for(const R of y.extensions)E.update(R.extensionIdentifier.uuid||R.extensionIdentifier.id).update(R.version);y.hash=E.digest("hex")}}withLanguagePacks(y=()=>null){return this.languagePacksFileLimiter.queue(()=>{let E=null;return P.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,R=>R.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(R)).then(R=>{try{return JSON.parse(R)}catch{return{}}}).then(R=>(E=y(R),R)).then(R=>{for(const o of Object.keys(R))R[o]||delete R[o];this.languagePacks=R,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),P.Promises.writeFile(this.languagePacksFilePath,t)}).then(()=>E,R=>this.logService.error(R))})}};c=ve([Y(0,v.INativeEnvironmentService),Y(1,S.ILogService)],c);function l(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const y of h.translations)if(typeof y.id!="string"||typeof y.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(oe[221],ae([0,1,139,7,30,46]),function(te,e,L,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://0.0.0.0/OneCollector/1.0",D="https://0.0.0.0/ping";async function P(I,C,S){const u=await(0,L.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,L.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),w=new u.AppInsightsCore,c=new g.PostChannel,l={instrumentationKey:I,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[c]]};if(S){l.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:S};l.extensionConfig[c.identifier]=h}return w.initialize(l,[]),w}class v{constructor(C,S,u,g,w){this._isInternalTelemetry=C,this._eventPrefix=S,this._defaultData=u,this._xhrOverride=w,this.endPointUrl=k,this.endPointHealthUrl=D,this._defaultData||(this._defaultData={}),typeof g=="function"?this._aiCoreOrKey=g():this._aiCoreOrKey=g,this._asyncAiCore=null}_withAIClient(C){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){C(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=P(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(S=>{C(S)},S=>{(0,N.onUnexpectedError)(S),console.error(S)})}}log(C,S){if(!this._aiCoreOrKey)return;S=(0,T.mixin)(S,this._defaultData),S=(0,A.validateTelemetryData)(S);const u=this._eventPrefix+"/"+C;try{this._withAIClient(g=>{g.pluginVersionString=S?.properties.version??"Unknown",g.track({name:u,baseData:{name:u,properties:S?.properties,measurements:S?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(C=>{this._withAIClient(S=>{S.unload(!0,()=>{this._aiCoreOrKey=void 0,C(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=v}),define(oe[109],ae([0,1,2,163,15,8,24,46]),function(te,e,L,N,T,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let P=class extends L.Disposable{constructor(I,C,S,u,g=""){super(),this.prefix=g;const w=C.getLogger(D.telemetryLogId);if(w)this.logger=this._register(w);else{const l=(0,D.isLoggingOnly)(u,S)?" (Not Sent)":"",h=()=>(0,D.supportsTelemetry)(u,S)&&I.getLevel()===A.LogLevel.Trace;this.logger=this._register(C.createLogger(D.telemetryLogId,{name:(0,N.localize)(0,null,l),hidden:!h()})),this._register(I.onDidChangeLogLevel(()=>C.setVisibility(D.telemetryLogId,h()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(I,C){this.logger.trace(`${this.prefix}telemetry/${I}`,(0,D.validateTelemetryData)(C))}};e.TelemetryLogAppender=P,e.TelemetryLogAppender=P=ve([Y(0,A.ILogService),Y(1,A.ILoggerService),Y(2,T.IEnvironmentService),Y(3,k.IProductService)],P)}),define(oe[110],ae([0,1,2,30,5,27,164,18,49,102,24,40,20,46]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,h,y){this._configurationService=h,this._productService=y,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=l.appenders,this._commonProperties=l.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=l.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(E=>{(E.affectsConfiguration(S.TELEMETRY_SETTING_ID)||E.affectsConfiguration(S.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(S.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(l,h){this._experimentProperties[l]=h}_updateTelemetryLevel(){let l=(0,u.getTelemetryLevel)(this._configurationService);const h=this._productService.enabledTelemetryLevels;if(h){this._sendErrorTelemetry=this.sendErrorTelemetry?h.error:!1;const y=h.usage?3:h.error?2:0;l=Math.min(l,y)}this._telemetryLevel=l}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(l,h,y){this._telemetryLevel<h||(y=(0,N.mixin)(y,this._experimentProperties),y=(0,u.cleanData)(y,this._cleanupPatterns),y=(0,N.mixin)(y,this._commonProperties),this._appenders.forEach(E=>E.log(l,y)))}publicLog(l,h){this._log(l,3,h)}publicLog2(l,h){this.publicLog(l,h)}publicLogError(l,h){this._sendErrorTelemetry&&this._log(l,2,h)}publicLogError2(l,h){this.publicLogError(l,h)}};e.TelemetryService=g,e.TelemetryService=g=ve([Y(1,D.IConfigurationService),Y(2,I.IProductService)],g);function w(){const c=(0,k.localize)(0,null,v.default.nameLong),l=v.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",v.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=T.isWeb?"":(0,k.localize)(3,null),y=(0,k.localize)(4,null),E=(0,k.localize)(5,null),R=(0,k.localize)(6,null),t=(0,k.localize)(7,null),o=`
|       | ${y} | ${E} | ${R} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,k.localize)(8,null);return`
${c} ${l} ${h}

&nbsp;

${t}
${o}

&nbsp;

${n}
`}C.Registry.as(P.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,k.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:w(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(P.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,k.localize)(16,null,v.default.nameLong,v.default.privacyStatementUrl):(0,k.localize)(15,null,v.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[222],ae([0,1,14,25,221]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function A(P,v){const I=await v.request(P,N.CancellationToken.None),C=(await(0,L.streamToBuffer)(I.stream)).toString(),S=I.res.statusCode??200;return{headers:I.res.headers,statusCode:S,responseData:C}}function k(P,v){const I={method:P.type,headers:P.headers},C=v.request(P.url??"",I,S=>{S.on("data",function(u){return{headers:S.headers,statusCode:S.statusCode??200,responseData:u.toString()}}),S.on("error",function(u){throw u})});C.write(P.data),C.end()}class D extends T.AbstractOneDataSystemAppender{constructor(v,I,C,S,u){let g;v||(g=te("https"));const w={sendPOST:(c,l)=>{const h=typeof c.data=="string"?c.data:new TextDecoder().decode(c.data),y={type:"POST",headers:{...c.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(c.data).toString()},url:c.urlString,data:h};try{if(v)A(y,v).then(({statusCode:E,headers:R,responseData:t})=>{l(E,R,t)});else{if(!g)throw new Error("https module is undefined");k(y,g)}}catch{l(0,{})}}};super(I,C,S,u,w)}}e.OneDataSystemAppender=D}),define(oe[223],ae([0,1,26,93,18,15,8,24,20,108,109,110]),function(te,e,L,N,T,A,k,D,P,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let S=class{constructor(g,w,c,l,h,y){this.configurationService=g,this.telemetryService=w,this.logService=c,this.loggerService=l,this.environmentService=h,this.productService=y,this.customTelemetryServices=new Map}getCustomTelemetryService(g){if(!this.customTelemetryServices.has(g.id)){const w=Object.create(null);w["common.vscodemachineid"]=this.telemetryService.machineId,w["common.vscodesessionid"]=this.telemetryService.sessionId;const c=[g.id,JSON.stringify(w),g.aiKey],h=new N.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:c,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),y=[new v.TelemetryAppenderClient(h),new I.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${g.id}] `)];this.customTelemetryServices.set(g.id,new C.TelemetryService({appenders:y,sendErrorTelemetry:g.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(g.id)}publicLog(g,w,c){this.getCustomTelemetryService(g).publicLog(w,c)}publicLogError(g,w,c){this.getCustomTelemetryService(g).publicLogError(w,c)}};e.CustomEndpointTelemetryService=S,e.CustomEndpointTelemetryService=S=ve([Y(0,T.IConfigurationService),Y(1,P.ITelemetryService),Y(2,k.ILogService),Y(3,k.ILoggerService),Y(4,A.IEnvironmentService),Y(5,D.IProductService)],S)}),define(oe[74],ae([0,1,3,18,4,8]),function(te,e,L,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,T.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,T.createDecorator)("sharedTunnelsService");var k;(function(c){c.Http="http",c.Https="https"})(k||(e.TunnelProtocol=k={}));var D;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(D||(e.TunnelPrivacyId=D={}));function P(c){return!!c.forwardPort}e.isTunnelProvider=P;var v;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(v||(e.ProvidedOnAutoForward=v={}));function I(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(c){return e.LOCALHOST_ADDRESSES.indexOf(c)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(c){return e.ALL_INTERFACES_ADDRESSES.indexOf(c)>=0}e.isAllInterfaces=S;function u(c,l,h,y){if(h===1)return!1;if(h===2&&S(l)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(y);if(E?.length===4&&parseInt(E[1])>=18)return!1}return c<1024}e.isPortPrivileged=u;class g{constructor(l,h,y){this.remoteAddress=l,this.localAddress=h,this._dispose=y,this._onDispose=new L.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=g;let w=class{constructor(l,h){this.logService=l,this.configurationService=h,this._onTunnelOpened=new L.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new L.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new L.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const l=this.configurationService.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this._tunnelProvider=l,l?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this._canElevate=l.elevation,this._privacyOptions=l.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const l=[],h=Array.from(this._tunnels.values());for(const y of h){const E=Array.from(y.values());for(const R of E){const t=await R.value;t&&l.push(t)}}return l}async dispose(){for(const l of this._tunnels.values()){for(const{value:h}of l.values())await h.then(y=>y?.dispose());l.clear()}this._tunnels.clear()}setEnvironmentTunnel(l,h,y,E,R){this.addTunnelToMap(l,h,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:h,localAddress:y,privacy:E,protocol:R,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,h){(S(l)||C(l))&&(l=e.LOCALHOST_ADDRESSES[0]);const y=this.getTunnelFromMap(l,h);if(y)return++y.refcount,y.value}openTunnel(l,h,y,E,R,t=!1,o,n){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${y} on local port ${R}.`);const s=this._tunnelProvider??l;if(!s)return;if(h||(h="localhost"),E||(E=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(y)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.retainOrCreateTunnel(s,h,y,E,R,t,o,n);return i?i.then(r=>{if(!r){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,y);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(r);return(r.tunnelRemoteHost!==h||r.tunnelRemotePort!==y)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const h=this._tunnels.get(l.tunnelRemoteHost);if(h){const y=h.get(l.tunnelRemotePort);y&&(y.refcount--,await this.tryDisposeTunnel(l.tunnelRemoteHost,l.tunnelRemotePort,y))}}}}async tryDisposeTunnel(l,h,y){if(y.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${h}.`);const E=y.value.then(async R=>{R&&(await R.dispose(!0),this._onTunnelClosed.fire({host:R.tunnelRemoteHost,port:R.tunnelRemotePort}))});return this._tunnels.has(l)&&this._tunnels.get(l).delete(h),E}}async closeTunnel(l,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${h} `);const y=this._tunnels.get(l);if(y&&y.has(h)){const E=y.get(h);E.refcount=0,await this.tryDisposeTunnel(l,h,E)}}addTunnelToMap(l,h,y){this._tunnels.has(l)||this._tunnels.set(l,new Map),this._tunnels.get(l).set(h,{refcount:1,value:y})}async removeEmptyTunnelFromMap(l,h){const y=this._tunnels.get(l);if(y){const E=y.get(h);(E?await E.value:void 0)||y.delete(h),y.size===0&&this._tunnels.delete(l)}}getTunnelFromMap(l,h){const y=[l];C(l)?(y.push(...e.LOCALHOST_ADDRESSES),y.push(...e.ALL_INTERFACES_ADDRESSES)):S(l)&&y.push(...e.ALL_INTERFACES_ADDRESSES);const E=y.map(R=>this._tunnels.get(R));for(const R of E){const t=R?.get(h);if(t)return t}}canTunnel(l){return!!I(l)}createWithProvider(l,h,y,E,R,t,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${y} on local port ${E}.`);const n=y;this._factoryInProgress.add(n);const s=E===void 0?y:E,i={elevationRequired:R?this.isPortPrivileged(s):!1},r={remoteAddress:{host:h,port:y},localAddressPort:E,privacy:t,public:t?t!==D.Private:void 0,protocol:o},a=l.forwardPort(r,i);return a?(this.addTunnelToMap(h,y,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(n)})):this._factoryInProgress.delete(n),a}};e.AbstractTunnelService=w,e.AbstractTunnelService=w=ve([Y(0,A.ILogService),Y(1,N.IConfigurationService)],w)}),define(oe[224],ae([0,1,8,74,2,7,6]),function(te,e,L,N,T,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class D extends T.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new k.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let P=class bt extends T.Disposable{static{this._lastId=0}constructor(I,C){super(),this._tunnelService=I,this._logService=C,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++bt._lastId)}}async startTunnel(I,C,S,u,g,w,c){const l=new D,h=await Promise.resolve(this._tunnelService.openTunnel(I,l,S,u,g,w,c));if(!h)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${S}:${u} (remote).`),l.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(C))throw this._disposedTunnels.delete(C),l.dispose(),await h.dispose(),(0,A.canceled)();return l.setTunnel(h),this._tunnels.set(C,l),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${C}: ${h.localAddress} (local) to ${S}:${u} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(I,C){const S=this._tunnels.get(I);S&&S.setAddress(C)}async destroyTunnel(I){const C=this._tunnels.get(I);if(C){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await C.dispose();return}this._disposedTunnels.add(I)}};e.SharedProcessTunnelService=P,e.SharedProcessTunnelService=P=ve([Y(0,N.ISharedTunnelsService),Y(1,L.ILogService)],P)}),define(oe[225],ae([0,1,60,36,130,6,2,18,8,24,209,74,106,5,104]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(E,R,t,o,n){let s;for(let i=3;i&&(s?.dispose(),s=await new c(E,R,t,o,n).waitForReady(),!(n&&T.BROWSER_RESTRICTED_PORTS[n]||!T.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));i--);return s}class c extends k.Disposable{constructor(R,t,o,n,s){super(),this.defaultTunnelHost=t,this.suggestedLocalPort=s,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=R,this._server=L.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(t=>{t()})}async waitForReady(){const R=this.suggestedLocalPort??this.tunnelRemotePort,t=(0,C.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let o=await(0,T.findFreePortFaster)(R,2,1e3,t),n=null;return this._server.listen(o,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address(),n||(o=0,this._server.listen(o,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async _onConnection(R){R.pause();const t=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,I.connectRemoteAgentTunnel)(this._options,t,this.tunnelRemotePort),n=o.getSocket().socket,s=o.readEntireBuffer();o.dispose(),s.byteLength>0&&R.write(s.buffer),R.on("end",()=>{R.localAddress&&this._socketsDispose.delete(R.localAddress),n.end()}),R.on("close",()=>n.end()),R.on("error",()=>{R.localAddress&&this._socketsDispose.delete(R.localAddress),n.destroy()}),n.on("end",()=>R.end()),n.on("close",()=>R.end()),n.on("error",()=>{R.destroy()}),R.pipe(n),n.pipe(R),R.localAddress&&this._socketsDispose.set(R.localAddress,()=>{R.end(),n.end()})}}let l=class extends C.AbstractTunnelService{constructor(R,t,o,n,s){super(t,s),this.remoteSocketFactoryService=R,this.signService=o,this.productService=n}isPortPrivileged(R){return(0,C.isPortPrivileged)(R,this.defaultTunnelHost,u.OS,N.release())}retainOrCreateTunnel(R,t,o,n,s,i,r,a){const p=this.getTunnelFromMap(t,o);if(p)return++p.refcount,p.value;if((0,C.isTunnelProvider)(R))return this.createWithProvider(R,t,o,s,i,r,a);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${o} on local port ${s}.`);const m={commit:this.productService.commit,quality:this.productService.quality,addressProvider:R,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},d=w(m,n,t,o,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(t,o,d),d}}};e.BaseTunnelService=l,e.BaseTunnelService=l=ve([Y(0,g.IRemoteSocketFactoryService),Y(1,P.ILogService),Y(2,S.ISignService),Y(3,v.IProductService),Y(4,D.IConfigurationService)],l);let h=class extends l{constructor(R,t,o,n,s){super(R,t,o,n,s)}};e.TunnelService=h,e.TunnelService=h=ve([Y(0,g.IRemoteSocketFactoryService),Y(1,P.ILogService),Y(2,S.ISignService),Y(3,v.IProductService),Y(4,D.IConfigurationService)],h);let y=class extends k.Disposable{constructor(R,t,o,n,s){super(),this.remoteSocketFactoryService=R,this.logService=t,this.productService=o,this.signService=n,this.configurationService=s,this._tunnelServices=new Map}async openTunnel(R,t,o,n,s,i,r,a,p){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${n} on local port ${i}.`),!this._tunnelServices.has(R)){const m=new h(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(m),this._tunnelServices.set(R,m),m.onTunnelClosed(async()=>{(await m.tunnels).length===0&&(m.dispose(),this._tunnelServices.delete(R))})}return this._tunnelServices.get(R).openTunnel(t,o,n,s,i,r,a,p)}};e.SharedTunnelsService=y,e.SharedTunnelsService=y=ve([Y(0,g.IRemoteSocketFactoryService),Y(1,P.ILogService),Y(2,v.IProductService),Y(3,S.ISignService),Y(4,D.IConfigurationService)],y)}),define(oe[28],ae([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(oe[226],ae([0,1,28,181,13,22,124,3,2]),function(te,e,L,N,T,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class v{static{this._clock=0}constructor(S){this.uri=S,this.time=v._clock++}touch(){return this.time=v._clock++,this}}let I=class{constructor(S){this._fileService=S,this._dispooables=new P.DisposableStore,this._limit=2**16;const u=new Map,g=w=>{let c=u.get(w.scheme);return c===void 0&&(c=S.hasProvider(w)&&!this._fileService.hasCapability(w,1024),u.set(w.scheme,c)),c};this._dispooables.add(D.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(w=>{u.delete(w.scheme)})),this.extUri=new A.ExtUri(g),this._canonicalUris=new k.SkipList((w,c)=>this.extUri.compare(w,c,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,A.normalizePath)(S));const u=this._canonicalUris.get(S);return u?u.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new v(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((g,w)=>g[1].time<w[1].time?1:g[1].time>w[1].time?-1:0);v._clock=0,this._canonicalUris.clear();const u=this._limit*.5;for(let g=0;g<u;g++)this._canonicalUris.set(S[g][0],S[g][1].touch())}};e.UriIdentityService=I,e.UriIdentityService=I=ve([Y(0,T.IFileService)],I),(0,N.registerSingleton)(L.IUriIdentityService,I,1)}),define(oe[227],ae([0,1,3,2,13,42,47,14]),function(te,e,L,N,T,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends N.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(I,C,S,u){super(),this.fileSystemScheme=I,this.fileSystemProvider=C,this.userDataScheme=S,this.logService=u,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=k.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(g=>this.handleFileChanges(g)))}watch(I,C){this.watchResources.set(I,I);const S=this.fileSystemProvider.watch(this.toFileSystemResource(I),C);return(0,N.toDisposable)(()=>{this.watchResources.delete(I),S.dispose()})}stat(I){return this.fileSystemProvider.stat(this.toFileSystemResource(I))}mkdir(I){return this.fileSystemProvider.mkdir(this.toFileSystemResource(I))}rename(I,C,S){return this.fileSystemProvider.rename(this.toFileSystemResource(I),this.toFileSystemResource(C),S)}readFile(I){return this.fileSystemProvider.readFile(this.toFileSystemResource(I),{atomic:!0})}readFileStream(I,C,S){const u=(0,A.newWriteableStream)(g=>D.VSBuffer.concat(g.map(w=>D.VSBuffer.wrap(w))).buffer);return(async()=>{try{const g=await this.readFile(I);u.end(g)}catch(g){u.error(g),u.end()}})(),u}readdir(I){return this.fileSystemProvider.readdir(this.toFileSystemResource(I))}writeFile(I,C,S){return this.fileSystemProvider.writeFile(this.toFileSystemResource(I),C,S)}delete(I,C){return this.fileSystemProvider.delete(this.toFileSystemResource(I),C)}copy(I,C,S){if((0,T.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(I),this.toFileSystemResource(C),S);throw new Error("copy not supported")}handleFileChanges(I){const C=[];for(const S of I){if(S.resource.scheme!==this.fileSystemScheme)continue;const u=this.toUserDataResource(S.resource);this.watchResources.findSubstr(u)&&C.push({resource:u,type:S.type})}C.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(C))}toFileSystemResource(I){return I.with({scheme:this.fileSystemScheme})}toUserDataResource(I){return I.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(oe[75],ae([0,1,83]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function N(k,D,P,v){const I=(0,L.setProperty)(k,D,P,v)[0];return I&&(k=k.substring(0,I.offset)+I.content+k.substring(I.offset+I.length)),k}e.edit=N;function T(k,D,P){let v=P;for(;v>=0;){if(k.charAt(v)===D.charAt(D.length-1)&&D.length===1)return v+1;if(v--,D.length===2&&v>=0&&k.charAt(v)===D.charAt(0))return v+2}return 0}e.getLineStartOffset=T;function A(k,D,P){let v=P;for(;v>=0;)if(k.charAt(v)===D.charAt(D.length-1)&&D.length===1||(v++,D.length===2&&v>=0&&k.charAt(v)===D.charAt(1)))return v;return k.length-1}e.getLineEndOffset=A}),define(oe[228],ae([0,1,30,53,11]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(u,g,w,c,l,h){const y=[],E=[],R=[];if(!g){const j=u.filter(({identifier:B})=>l.every(Q=>Q.toLowerCase()!==B.id.toLowerCase()));return{local:{added:y,removed:E,updated:R},remote:j.length>0?{added:j,updated:[],removed:[],all:j}:null}}u=u.map(C),g=g.map(C),w=w?w.map(C):null;const t=new Map,o=j=>{j.uuid&&t.set(j.id.toLowerCase(),j.uuid)};u.forEach(({identifier:j})=>o(j)),g.forEach(({identifier:j})=>o(j)),w?.forEach(({identifier:j})=>o(j));const n=j=>{const B=j.identifier.uuid||t.get(j.identifier.id.toLowerCase());return B?`uuid:${B}`:`id:${j.identifier.id.toLowerCase()}`},s=(j,B)=>(j.set(n(B),B),j),i=u.reduce(s,new Map),r=g.reduce(s,new Map),a=g.reduce((j,B)=>s(j,(0,L.deepClone)(B)),new Map),p=w?w.reduce(s,new Map):null,m=c.reduce(s,new Map),d=l.reduce((j,B)=>{const Q=t.get(B.toLowerCase());return j.add(Q?`uuid:${Q}`:`id:${B.toLowerCase()}`)},new Set),b=h?h.reduce((j,{id:B,uuid:Q})=>(Q=Q??t.get(B.toLowerCase()),j.add(Q?`uuid:${Q}`:`id:${B.toLowerCase()}`)),new Set):null,O=k(i,r,d,!1);if(O.added.size>0||O.removed.size>0||O.updated.size>0){const j=k(p,i,d,!1),B=k(p,r,d,!0),Q=(J,G,X,V)=>{let x,z,ee;return G.installed?(x=V.pinned,ee=V.preRelease,x&&(z=V.version)):(x=X.pinned,ee=X.preRelease,x&&(z=X.version)),x===void 0&&(x=G.pinned,x&&(z=G.version)),ee===void 0&&(ee=G.preRelease),{...V,installed:G.installed||X.installed,pinned:x,preRelease:ee,version:z??(X.version&&(!G.installed||N.gt(X.version,G.version))?X.version:G.version),state:P(G,X,p?.get(J))}};for(const J of B.removed.values()){const G=i.get(J);if(!G)continue;const X=(0,T.assertIsDefined)(p?.get(J)),V=b&&!b.has(J)&&X.installed;G.installed&&V?E.push(G.identifier):a.set(J,G)}for(const J of B.added.values()){const G=(0,T.assertIsDefined)(r.get(J)),X=i.get(J);if(X){if(O.updated.has(J)){const V=Q(J,X,G,G);D(X,G,!1,!1)||R.push(S(V,J)),a.set(J,V)}}else G.installed&&y.push(S(G,J))}for(const J of B.updated.values()){const G=(0,T.assertIsDefined)(r.get(J)),X=(0,T.assertIsDefined)(p?.get(J)),V=i.get(J);if(V)if(b&&!b.has(J)&&X.installed&&V.installed&&!G.installed)E.push(V.identifier);else{const z=Q(J,V,G,G);R.push(S(z,J)),a.set(J,z)}else G.installed&&y.push(S(G,J))}for(const J of j.added.values())B.added.has(J)||a.set(J,(0,T.assertIsDefined)(i.get(J)));for(const J of j.updated.values()){if(B.removed.has(J)||B.updated.has(J))continue;const G=(0,T.assertIsDefined)(i.get(J)),X=(0,T.assertIsDefined)(r.get(J));a.set(J,Q(J,G,X,G))}for(const J of j.removed.values())B.updated.has(J)||B.removed.has(J)||m.has(J)||(0,T.assertIsDefined)(r.get(J)).installed&&b&&(b.has(J)||!(0,T.assertIsDefined)(p?.get(J)).installed||a.delete(J))}const F=[],M=k(r,a,new Set,!0),q=M.added.size>0||M.updated.size>0||M.removed.size>0;return q&&a.forEach((j,B)=>F.push(S(j,B))),{local:{added:y,removed:E,updated:R},remote:q?{added:[...M.added].map(j=>a.get(j)),updated:[...M.updated].map(j=>a.get(j)),removed:[...M.removed].map(j=>r.get(j)),all:F}:null}}e.merge=A;function k(u,g,w,c){const l=u?[...u.keys()].filter(t=>!w.has(t)):[],h=[...g.keys()].filter(t=>!w.has(t)),y=h.filter(t=>!l.includes(t)).reduce((t,o)=>(t.add(o),t),new Set),E=l.filter(t=>!h.includes(t)).reduce((t,o)=>(t.add(o),t),new Set),R=new Set;for(const t of l){if(E.has(t))continue;const o=u.get(t),n=g.get(t);(!n||!D(o,n,c,!0))&&R.add(t)}return{added:y,removed:E,updated:R}}function D(u,g,w,c){return!(u.disabled!==g.disabled||!!u.isApplicationScoped!=!!g.isApplicationScoped||c&&u.installed!==g.installed||u.installed&&g.installed&&(u.preRelease!==g.preRelease||u.pinned!==g.pinned||g.pinned&&u.version!==g.version)||!I(u.state,g.state)||w&&u.version!==g.version)}function P(u,g,w){const c=u.state,l=g.state,h=w?.state;if(!g.version||c&&N.gt(u.version,g.version))return c;if(l&&N.gt(g.version,u.version)||!c)return l;if(!l)return c;const y=(0,L.deepClone)(c),E=h?v(h,l):{added:Object.keys(l).reduce((t,o)=>(t.add(o),t),new Set),removed:new Set,updated:new Set},R=h?v(h,c):{added:Object.keys(c).reduce((t,o)=>(t.add(o),t),new Set),removed:new Set,updated:new Set};for(const t of[...E.added.values(),...E.updated.values()])y[t]=l[t];for(const t of E.removed.values())R.updated.has(t)||delete y[t];return y}function v(u,g){const w=Object.keys(u),c=Object.keys(g),l=c.filter(E=>!w.includes(E)).reduce((E,R)=>(E.add(R),E),new Set),h=w.filter(E=>!c.includes(E)).reduce((E,R)=>(E.add(R),E),new Set),y=new Set;for(const E of w){if(h.has(E))continue;const R=u[E],t=g[E];(0,L.equals)(R,t)||y.add(E)}return{added:l,removed:h,updated:y}}function I(u={},g={}){const{added:w,removed:c,updated:l}=v(u,g);return w.size===0&&c.size===0&&l.size===0}function C(u){return{...u,disabled:!!u.disabled,installed:!!u.installed}}function S(u,g){const w={...u,identifier:{id:u.identifier.id,uuid:g.startsWith("uuid:")?g.substring(5):void 0},preRelease:!!u.preRelease,pinned:!!u.pinned};return u.disabled||delete w.disabled,u.installed||delete w.installed,u.state||delete w.state,u.isApplicationScoped||delete w.isApplicationScoped,w}}),define(oe[111],ae([0,1,21,18,4]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,T.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(D){this.configurationService=D}hasToNeverSyncExtension(D){return this.getConfiguredIgnoredExtensions().includes(D.toLowerCase())}hasToAlwaysSyncExtension(D){return this.getConfiguredIgnoredExtensions().includes(`-${D.toLowerCase()}`)}updateIgnoredExtensions(D,P){let v=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return v=v.filter(I=>I!==D&&I!==`-${D}`),P&&v.push(D.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,2)}updateSynchronizedExtensions(D,P){let v=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return v=v.filter(I=>I!==D&&I!==`-${D}`),P&&v.push(`-${D.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,2)}getIgnoredExtensions(D){const P=D.filter(S=>S.isMachineScoped).map(S=>S.identifier.id.toLowerCase()),v=this.getConfiguredIgnoredExtensions().map(S=>S.toLowerCase()),I=[],C=[];if(Array.isArray(v))for(const S of v)S.startsWith("-")?C.push(S.substring(1)):I.push(S);return(0,L.distinct)([...P,...I].filter(S=>!C.includes(S)))}getConfiguredIgnoredExtensions(){let D=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return D!==void 0||(D=this.configurationService.inspect("sync.ignoredExtensions").userValue,D!==void 0)?D:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};e.IgnoredExtensionsManagementService=A,e.IgnoredExtensionsManagementService=A=ve([Y(0,N.IConfigurationService)],A)}),define(oe[229],ae([0,1,21,34,30,94,75]),function(te,e,L,N,T,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(E){return(0,N.parse)(E)||[]}async function P(E,R,t,o,n){const s=D(E),i=D(R),r=t?D(t):null,a=[...s,...i,...r||[]].map(Q=>Q.key),p=await n.resolveUserBindings(a),m=I(s,i,r,p);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:E,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:R,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:E,hasChanges:!0,hasConflicts:!1};const d=S(s),b=S(i),O=r?S(r):null,F=g(d,b,p),M=O?g(O,d,p):{added:[...d.keys()].reduce((Q,J)=>(Q.add(J),Q),new Set),removed:new Set,updated:new Set},q=O?g(O,b,p):{added:[...b.keys()].reduce((Q,J)=>(Q.add(J),Q),new Set),removed:new Set,updated:new Set},j=v(F,M,q);let B=E;for(const Q of j.removed.values())j.conflicts.has(Q)||(B=h(B,Q,o));for(const Q of j.added.values()){if(j.conflicts.has(Q))continue;const J=b.get(Q);if(J.some(G=>G.command!==`-${Q}`&&m.conflicts.has(p[G.key]))){j.conflicts.add(Q);continue}B=l(B,J,o)}for(const Q of j.updated.values()){if(j.conflicts.has(Q))continue;const J=b.get(Q);if(J.some(G=>G.command!==`-${Q}`&&m.conflicts.has(p[G.key]))){j.conflicts.add(Q);continue}B=y(B,Q,J,o)}return{mergeContent:B,hasChanges:!0,hasConflicts:j.conflicts.size>0}}e.merge=P;function v(E,R,t){const o=new Set,n=new Set,s=new Set,i=new Set;for(const r of R.removed.values())t.updated.has(r)&&i.add(r);for(const r of t.removed.values())i.has(r)||(R.updated.has(r)?i.add(r):n.add(r));for(const r of R.added.values())i.has(r)||t.added.has(r)&&E.updated.has(r)&&i.add(r);for(const r of t.added.values())i.has(r)||(R.added.has(r)?E.updated.has(r)&&i.add(r):o.add(r));for(const r of R.updated.values())i.has(r)||t.updated.has(r)&&E.updated.has(r)&&i.add(r);for(const r of t.updated.values())i.has(r)||(R.updated.has(r)?E.updated.has(r)&&i.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:i}}function I(E,R,t,o){const n=new Set,s=C(E,o),i=C(R,o),r=t?C(t,o):null,a=u(s,i);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const p=r?u(r,s):{added:[...s.keys()].reduce((M,q)=>(M.add(q),M),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const m=r?u(r,i):{added:[...i.keys()].reduce((M,q)=>(M.add(q),M),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:d,removed:b,updated:O,conflicts:F}=v(a,p,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:d,removed:b,updated:O,conflicts:F}}function C(E,R){const t=new Map;for(const o of E){const n=R[o.key];let s=t.get(n);s||(s=[],t.set(n,s)),s.push(o)}return t}function S(E){const R=new Map;for(const t of E){const o=t.command[0]==="-"?t.command.substring(1):t.command;let n=R.get(o);n||(n=[],R.set(o,n)),n.push(t)}return R}function u(E,R){const t=[...E.keys()],o=[...R.keys()],n=o.filter(r=>!t.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=t.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),i=new Set;for(const r of t){if(s.has(r))continue;const a=E.get(r).map(m=>({...m,key:r})),p=R.get(r).map(m=>({...m,key:r}));(0,L.equals)(a,p,(m,d)=>c(m,d))||i.add(r)}return{added:n,removed:s,updated:i}}function g(E,R,t){const o=[...E.keys()],n=[...R.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,p)=>(a.add(p),a),new Set),i=o.filter(a=>!n.includes(a)).reduce((a,p)=>(a.add(p),a),new Set),r=new Set;for(const a of o){if(i.has(a))continue;const p=E.get(a).map(d=>({...d,key:t[d.key]})),m=R.get(a).map(d=>({...d,key:t[d.key]}));w(p,m)||r.add(a)}return{added:s,removed:i,updated:r}}function w(E,R){return!(!(0,L.equals)(E.filter(({command:t})=>t[0]!=="-"),R.filter(({command:t})=>t[0]!=="-"),(t,o)=>c(t,o))||!(0,L.equals)(E.filter(({command:t})=>t[0]==="-"),R.filter(({command:t})=>t[0]==="-"),(t,o)=>c(t,o)))}function c(E,R){if(E.command!==R.command||E.key!==R.key)return!1;const t=A.ContextKeyExpr.deserialize(E.when),o=A.ContextKeyExpr.deserialize(R.when);return!(t&&!o||!t&&o||t&&o&&!t.equals(o)||!T.equals(E.args,R.args))}function l(E,R,t){for(const o of R)E=k.edit(E,[-1],o,t);return E}function h(E,R,t){const o=D(E);for(let n=o.length-1;n>=0;n--)(o[n].command===R||o[n].command===`-${R}`)&&(E=k.edit(E,[n],void 0,t));return E}function y(E,R,t,o){const n=D(E),s=n.findIndex(i=>i.command===R||i.command===`-${R}`);for(let i=n.length-1;i>=0;i--)(n[i].command===R||n[i].command===`-${R}`)&&(E=k.edit(E,[i],void 0,o));for(let i=t.length-1;i>=0;i--)E=k.edit(E,[s],t[i],o);return E}}),define(oe[230],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function L(A,k,D){const P={},v={},I=new Set;if(!k)return{local:{added:P,updated:v,removed:[...I.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const C=N(A,k);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:P,updated:v,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const S=N(D,A),u=N(D,k),g={},w={},c=new Set,l=new Set;for(const h of S.removed.values())u.updated.has(h)?P[h]=k[h]:c.add(h);for(const h of u.removed.values())l.has(h)||(S.updated.has(h)?l.add(h):I.add(h));for(const h of S.updated.values())l.has(h)||(u.updated.has(h)?C.updated.has(h)&&l.add(h):w[h]=A[h]);for(const h of u.updated.values())l.has(h)||(S.updated.has(h)?C.updated.has(h)&&l.add(h):A[h]!==void 0&&(v[h]=k[h]));for(const h of S.added.values())l.has(h)||(u.added.has(h)?C.updated.has(h)&&l.add(h):g[h]=A[h]);for(const h of u.added.values())l.has(h)||(S.added.has(h)?C.updated.has(h)&&l.add(h):P[h]=k[h]);return{local:{added:P,removed:[...I.values()],updated:v},remote:{added:g,removed:[...c.values()],updated:w},conflicts:[...l.values()]}}e.merge=L;function N(A,k){const D=A?Object.keys(A):[],P=k?Object.keys(k):[],v=P.filter(S=>!D.includes(S)).reduce((S,u)=>(S.add(u),S),new Set),I=D.filter(S=>!P.includes(S)).reduce((S,u)=>(S.add(u),S),new Set),C=new Set;for(const S of D){if(I.has(S))continue;const u=A[S],g=k[S];u!==g&&C.add(S)}return{added:v,removed:I,updated:C}}function T(A,k){const{added:D,removed:P,updated:v}=N(A,k);return D.size===0&&P.size===0&&v.size===0}e.areSame=T}),define(oe[231],ae([0,1,30]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function N(A,k,D,P){const v={added:[],removed:[],updated:[]};let I={added:[],removed:[],updated:[]};if(!k){const S=A.filter(({id:u})=>!P.includes(u));return S.length?I.added=S:I=null,{local:v,remote:I}}const C=T(A,k,P);if(C.added.length>0||C.removed.length>0||C.updated.length>0){const S=T(D,A,P),u=T(D,k,P);for(const g of u.removed){const w=A.find(c=>c.id===g);w&&v.removed.push(w)}for(const g of u.added){const w=k.find(c=>c.id===g);S.added.includes(g)?C.updated.includes(g)&&v.updated.push(w):v.added.push(w)}for(const g of u.updated)v.updated.push(k.find(w=>w.id===g));for(const g of S.added)u.added.includes(g)||I.added.push(A.find(w=>w.id===g));for(const g of S.updated)u.removed.includes(g)||u.updated.includes(g)||I.updated.push(A.find(w=>w.id===g));for(const g of S.removed){const w=k.find(c=>c.id===g);w&&I.removed.push(w)}}return I.added.length===0&&I.removed.length===0&&I.updated.length===0&&(I=null),{local:v,remote:I}}e.merge=N;function T(A,k,D){A=A?A.filter(({id:u})=>!D.includes(u)):[],k=k.filter(({id:u})=>!D.includes(u));const P=A.map(({id:u})=>u),v=k.map(({id:u})=>u),I=v.filter(u=>!P.includes(u)),C=P.filter(u=>!v.includes(u)),S=[];for(const{id:u,name:g,shortName:w,useDefaultFlags:c}of A){if(C.includes(u))continue;const l=k.find(h=>h.id===u);(!l||l.name!==g||l.shortName!==w||!(0,L.equals)(l.useDefaultFlags,c))&&S.push(u)}return{added:I,removed:C,updated:S}}}),define(oe[23],ae([0,1,21,11,170,49,29,4,103,40]),function(te,e,L,N,T,A,k,D,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=void 0;function I(){const i=v.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(i).filter(r=>!!i[r].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function C(){const i=v.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(i).filter(m=>!!i[m].ignoreSync),a=Object.keys(i).filter(m=>i[m].scope===2||i[m].scope===6),p=I();return(0,L.distinct)([...r,...a,...p])}e.getDefaultIgnoredSettings=C,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function S(){const i="vscode://schemas/ignoredSettings",r=v.Registry.as(A.Extensions.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=v.Registry.as(P.Extensions.JSONContribution),p=()=>{const m=I(),d=C(),b=Object.keys(A.allSettings.properties).filter(M=>!d.includes(M)),O=d.filter(M=>!m.includes(M)),F={items:{type:"string",enum:[...b,...O.map(M=>`-${M}`)]}};a.registerSchema(i,F)};return r.onDidUpdateConfiguration(()=>p())}e.registerConfiguration=S;function u(i){return i&&(0,N.isObject)(i)&&(0,N.isString)(i.id)&&Array.isArray(i.scopes)}e.isAuthenticationProvider=u;var g;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(g||(e.SyncResource=g={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function w(i,...r){return i?[i,...r]:r}e.getPathSegments=w;function c(i,r,a,p){return p.joinPath(a.userDataSyncHome,...w(i,r,`lastSync${r}.json`))}e.getLastSyncResourceUri=c,e.IUserDataSyncStoreManagementService=(0,D.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,D.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,D.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function l(i){const r={};return r[e.HEADER_EXECUTION_ID]=i,r}e.createSyncHeaders=l;var h;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(h||(e.UserDataSyncErrorCode=h={}));class y extends Error{constructor(r,a,p,m){super(r),this.code=a,this.resource=p,this.operationId=m,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=y;class E extends y{constructor(r,a,p,m,d){super(r,p,void 0,d),this.url=a,this.serverCode=m}}e.UserDataSyncStoreError=E;class R extends y{constructor(r,a){super(r,a)}}e.UserDataAutoSyncError=R,function(i){function r(a){if(a instanceof i)return a;const p=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(p&&p[1]){const m=p[2]==="unknown"?void 0:p[2],d=p[3]==="unknown"?void 0:p[3];return new i(a.message,p[1],m,d)}return new i(a.message,"Unknown")}i.toUserDataSyncError=r}(y||(e.UserDataSyncError=y={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var o;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(n||(e.MergeState=n={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(i){return`sync.enable.${i}`}e.getEnablementKey=s,e.IUserDataSyncEnablementService=(0,D.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,D.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,D.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,D.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,D.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,D.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(oe[232],ae([0,1,30,23]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(k,D,P,v,I){if(!D)return{remote:{added:Object.keys(k),removed:[],updated:[],all:Object.keys(k).length>0?k:null},local:{added:{},removed:[],updated:{}}};const C=A(k,D);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const S=P?A(P,D):{added:Object.keys(D).reduce((h,y)=>(h.add(y),h),new Set),removed:new Set,updated:new Set},u=P?A(P,k):{added:Object.keys(k).reduce((h,y)=>(h.add(y),h),new Set),removed:new Set,updated:new Set},g={added:{},removed:[],updated:{}},w=L.deepClone(D),c=!P;for(const h of u.added.values())h!==N.SYNC_SERVICE_URL_TYPE&&c&&S.added.has(h)||(w[h]=k[h]);for(const h of u.updated.values())w[h]=k[h];for(const h of u.removed.values())v.unregistered.includes(h)||delete w[h];for(const h of S.added.values()){const y=D[h];if(v.machine.includes(h)){I.info(`GlobalState: Skipped adding ${h} in local storage because it is declared as machine scoped.`);continue}if(P&&u.added.has(h))continue;const E=k[h];E&&E.value===y.value||h===N.SYNC_SERVICE_URL_TYPE&&c&&u.added.has(h)||(E?g.updated[h]=y:g.added[h]=y)}for(const h of S.updated.values()){const y=D[h];if(v.machine.includes(h)){I.info(`GlobalState: Skipped updating ${h} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(h)||u.removed.has(h))continue;const E=k[h];E&&E.value===y.value||(g.updated[h]=y)}for(const h of S.removed.values()){if(v.machine.includes(h)){I.trace(`GlobalState: Skipped removing ${h} in local storage because it is declared as machine scoped.`);continue}u.updated.has(h)||u.removed.has(h)||g.removed.push(h)}const l=A(D,w);return{local:g,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:w}}}e.merge=T;function A(k,D){const P=Object.keys(k),v=Object.keys(D),I=v.filter(u=>!P.includes(u)).reduce((u,g)=>(u.add(g),u),new Set),C=P.filter(u=>!v.includes(u)).reduce((u,g)=>(u.add(g),u),new Set),S=new Set;for(const u of P){if(C.has(u))continue;const g=k[u],w=D[u];L.equals(g,w)||S.add(u)}return{added:I,removed:C,updated:S}}}),define(oe[233],ae([0,1,21,34,83,41,30,75,23]),function(te,e,L,N,T,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function v(a,p,m){let d=[];m?d=C(m):d=I(p);const b=[],O=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(d))for(const F of d)F.startsWith("-")?O.push(F.substring(1)):b.push(F);return(0,L.distinct)([...a,...b].filter(F=>!O.includes(F)))}e.getIgnoredSettings=v;function I(a){let p=a.inspect("settingsSync.ignoredSettings").userValue;return p!==void 0||(p=a.inspect("sync.ignoredSettings").userValue,p!==void 0)?p:a.getValue("settingsSync.ignoredSettings")||[]}function C(a){const p=(0,N.parse)(a);return p?p["settingsSync.ignoredSettings"]||p["sync.ignoredSettings"]||[]:[]}function S(a,p){const m=(0,N.parse)(a)||{};let d="{}";for(const b of Object.keys(m)){const O=(0,T.setProperty)(d,[b],m[b],p);d=(0,T.applyEdits)(d,O)}return d}e.removeComments=S;function u(a,p,m,d){if(m.length){const b=r(p),O=(0,N.parse)(p)||{},F=(0,N.parse)(a);if(!F)return a;const M=[];for(const q of m){const j=O[q],B=F[q];j===void 0?a=D.edit(a,[q],void 0,d):B!==void 0?a=D.edit(a,[q],j,d):M.push(t(q,b))}M.sort((q,j)=>q.startOffset-j.startOffset),M.forEach(q=>a=h(q.setting.key,p,a,d))}return a}e.updateIgnoredSettings=u;function g(a,p,m,d,b,O){const F=u(a,p,d,O),M=m!==F,q=m!==p;if(!M&&!q)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!q)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(q&&!M)return{conflictsSettings:[],localContent:u(p,a,d,O),remoteContent:null,hasConflicts:!1};if(m===null&&c(a)){const _=w(a,p,d)?null:u(p,a,d,O);return{conflictsSettings:[],localContent:_,remoteContent:null,hasConflicts:!1}}let j=a,B=p;const Q=(0,N.parse)(a),J=(0,N.parse)(p),G=m?(0,N.parse)(m):null,X=d.reduce((_,$)=>(_.add($),_),new Set),V=l(Q,J,X),x=l(G,Q,X),z=l(G,J,X),ee=new Map,ne=new Set,ce=_=>{ne.add(_);const $=b.filter(({key:H})=>H===_)[0];$?(j=D.edit(j,[_],$.value,O),B=D.edit(B,[_],$.value,O)):ee.set(_,{key:_,localValue:Q[_],remoteValue:J[_]})};for(const _ of x.removed.values())z.updated.has(_)?ce(_):B=D.edit(B,[_],void 0,O);for(const _ of z.removed.values())ne.has(_)||(x.updated.has(_)?ce(_):j=D.edit(j,[_],void 0,O));for(const _ of x.updated.values())ne.has(_)||(z.updated.has(_)?V.updated.has(_)&&ce(_):B=D.edit(B,[_],Q[_],O));for(const _ of z.updated.values())ne.has(_)||(x.updated.has(_)?V.updated.has(_)&&ce(_):j=D.edit(j,[_],J[_],O));for(const _ of x.added.values())ne.has(_)||(z.added.has(_)?V.updated.has(_)&&ce(_):B=h(_,j,B,O));for(const _ of z.added.values())ne.has(_)||(x.added.has(_)?V.updated.has(_)&&ce(_):j=h(_,B,j,O));const re=ee.size>0||!w(j,B,d),U=re||!w(j,a,[]),f=re||!w(B,p,[]);return{localContent:U?j:null,remoteContent:f?B:null,conflictsSettings:[...ee.values()],hasConflicts:re}}e.merge=g;function w(a,p,m){if(a===p)return!0;const d=(0,N.parse)(a),b=(0,N.parse)(p),O=m.reduce((q,j)=>(q.add(j),q),new Set),F=r(a).filter(q=>!(q.setting&&O.has(q.setting.key))),M=r(p).filter(q=>!(q.setting&&O.has(q.setting.key)));if(F.length!==M.length)return!1;for(let q=0;q<F.length;q++){const j=F[q],B=M[q];if(j.setting&&B.setting){if(j.setting.key!==B.setting.key||!k.equals(d[j.setting.key],b[j.setting.key]))return!1}else if(!j.setting&&!B.setting){if(j.value!==B.value)return!1}else return!1}return!0}function c(a){return a?r(a).length===0:!0}e.isEmpty=c;function l(a,p,m){const d=a?Object.keys(a).filter(q=>!m.has(q)):[],b=Object.keys(p).filter(q=>!m.has(q)),O=b.filter(q=>!d.includes(q)).reduce((q,j)=>(q.add(j),q),new Set),F=d.filter(q=>!b.includes(q)).reduce((q,j)=>(q.add(j),q),new Set),M=new Set;if(a)for(const q of d){if(F.has(q))continue;const j=a[q],B=p[q];k.equals(j,B)||M.add(q)}return{added:O,removed:F,updated:M}}function h(a,p,m,d){const b=(0,N.parse)(p),O=r(p),F=r(m),M=y(a,O,F);return E(m,a,b[a],M,F,d)}e.addSetting=h;function y(a,p,m){const d=p.findIndex(O=>O.setting?.key===a),b=p[d-1];if(b){if(b.setting){const F=t(b.setting.key,m);if(F)return{index:m.indexOf(F),insertAfter:!0}}else{const F=o(d,p);if(F){const M=t(F.setting.key,m);if(M){const q=n(m.indexOf(M),m),j=s(p,F,p[d]);if(q){const B=s(m,M,q),Q=i(j,B);return Q?{index:m.indexOf(Q),insertAfter:!0}:{index:m.indexOf(q),insertAfter:!1}}else{const B=s(m,M,m[m.length-1]),Q=i(j,B);return Q?{index:m.indexOf(Q),insertAfter:!0}:{index:m.length-1,insertAfter:!0}}}}}const O=p[d+1];if(O)if(O.setting){const F=t(O.setting.key,m);if(F)return{index:m.indexOf(F),insertAfter:!1}}else{const F=n(d,p);if(F){const M=t(F.setting.key,m);if(M){const q=o(m.indexOf(M),m),j=s(p,p[d],F);if(q){const B=s(m,q,M),Q=i(j.reverse(),B.reverse());return Q?{index:m.indexOf(Q),insertAfter:!1}:{index:m.indexOf(q),insertAfter:!0}}else{const B=s(m,m[0],M),Q=i(j.reverse(),B.reverse());return Q?{index:m.indexOf(Q),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:m.length-1,insertAfter:!0}}function E(a,p,m,d,b,O){let F;return d.index===-1?F=(0,T.setProperty)(a,[p],m,O):F=R(a,p,m,d,b,O).map(M=>(0,T.withFormatting)(a,M,O)[0]),(0,T.applyEdits)(a,F)}function R(a,p,m,d,b,O){const F=`${JSON.stringify(p)}: ${JSON.stringify(m)}`,M=(0,A.getEOL)(O,a),q=b[d.index];if(d.insertAfter){const j=[];if(q.setting)j.push({offset:q.endOffset,length:0,content:","+F});else{const B=n(d.index,b),Q=o(d.index,b),J=Q?.setting?.commaOffset;Q&&J===void 0&&j.push({offset:Q.endOffset,length:0,content:","});const G=J!==void 0&&J>q.endOffset;j.push({offset:G?J+1:q.endOffset,length:0,content:B?M+F+",":M+F})}return j}else{if(q.setting)return[{offset:q.startOffset,length:0,content:F+","}];const j=(b[d.index-1]&&!b[d.index-1].setting?M:"")+F+(n(d.index,b)?",":"")+M;return[{offset:q.startOffset,length:0,content:j}]}}function t(a,p){return p.filter(m=>m.setting?.key===a)[0]}function o(a,p){for(let m=a-1;m>=0;m--)if(p[m].setting)return p[m]}function n(a,p){for(let m=a+1;m<p.length;m++)if(p[m].setting)return p[m]}function s(a,p,m){const d=a.indexOf(p),b=a.indexOf(m);return a.filter((O,F)=>d<F&&F<b)}function i(a,p){if(a.length&&p.length){let m=0;for(;m<p.length&&m<a.length;m++)if(a[m].value!==p[m].value)return p[m-1];return p[m-1]}}function r(a){const p=[];let m=-1,d,b;const O={onObjectBegin:F=>{m++},onObjectProperty:(F,M,q)=>{m===0&&(d=M,b=F)},onObjectEnd:(F,M)=>{m--,m===0&&p.push({startOffset:d,endOffset:F+M,value:a.substring(d,F+M),setting:{key:b,commaOffset:void 0}})},onArrayBegin:(F,M)=>{m++},onArrayEnd:(F,M)=>{m--,m===0&&p.push({startOffset:d,endOffset:F+M,value:a.substring(d,F+M),setting:{key:b,commaOffset:void 0}})},onLiteralValue:(F,M,q)=>{m===0&&p.push({startOffset:d,endOffset:M+q,value:a.substring(d,M+q),setting:{key:b,commaOffset:void 0}})},onSeparator:(F,M,q)=>{if(m===0&&F===","){let j=p.length-1;for(;j>=0&&!p[j].setting;j--);const B=p[j];B&&p.splice(j,1,{startOffset:B.startOffset,endOffset:B.endOffset,value:B.value,setting:{key:B.setting.key,commaOffset:M}})}},onComment:(F,M)=>{m===0&&p.push({startOffset:F,endOffset:F+M,value:a.substring(F,F+M)})}};return(0,N.visit)(a,O),p}}),define(oe[76],ae([0,1,3,2,4,23]),function(te,e,L,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,T.createDecorator)("IUserDataSyncAccountService");let k=class extends N.Disposable{get account(){return this._account}constructor(P,v){super(),this.userDataSyncStoreService=P,this.logService=v,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(P.onTokenFailed(I=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed,I),this.updateAccount(void 0),I==="Forbidden"?this._onTokenFailed.fire(!0):this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(P.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(P){(P&&this._account?P.token!==this._account.token||P.authenticationProviderId!==this._account.authenticationProviderId:P!==this._account)&&(this._account=P,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(P))}};e.UserDataSyncAccountService=k,e.UserDataSyncAccountService=k=ve([Y(0,A.IUserDataSyncStoreService),Y(1,A.IUserDataSyncLogService)],k)}),define(oe[234],ae([0,1,2,10]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class T{constructor(S){this.service=S}listen(S,u){switch(u){case"onError":return this.service.onError}throw new Error(`Event not found: ${u}`)}call(S,u,g){switch(u){case"triggerSync":return this.service.triggerSync(g[0],g[1],g[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(g[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=T;class A{constructor(S){this.service=S}listen(S,u){throw new Error(`Event not found: ${u}`)}call(S,u,g){switch(u){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(g[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(N.URI.revive(g[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class k{constructor(S){this.channel=S}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(S){return this.channel.call("resolveUserKeybindings",[S])}async resolveFormattingOptions(S){return this.channel.call("resolveFormattingOptions",[S])}}e.UserDataSyncUtilServiceClient=k;class D{constructor(S){this.service=S}listen(S,u){switch(u){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${u}`)}async call(S,u,g){switch(u){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(g[0],g[1]);case"setEnablements":return this.service.setEnablements(g)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=D;class P{constructor(S){this.service=S}listen(S,u){switch(u){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${u}`)}call(S,u,g){switch(u){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(g)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=P;class v{constructor(S){this.service=S}listen(S,u){switch(u){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${u}`)}call(S,u,g){switch(u){case"switch":return this.service.switch(g[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=v;class I extends L.Disposable{constructor(S){super(),this.channel=S,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(S){return this.channel.call("switch",[S])}async getPreviousUserDataSyncStore(){const S=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(S)}revive(S){return{url:N.URI.revive(S.url),type:S.type,defaultUrl:N.URI.revive(S.defaultUrl),insidersUrl:N.URI.revive(S.insidersUrl),stableUrl:N.URI.revive(S.stableUrl),canSwitch:S.canSwitch,authenticationProviders:S.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(oe[235],ae([0,1,171,8,23]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let A=class extends N.AbstractLogger{constructor(D){super(),this.logger=this._register(D.createLogger(T.USER_DATA_SYNC_LOG_ID,{name:(0,L.localize)(0,null)}))}trace(D,...P){this.logger.trace(D,...P)}debug(D,...P){this.logger.debug(D,...P)}info(D,...P){this.logger.info(D,...P)}warn(D,...P){this.logger.warn(D,...P)}error(D,...P){this.logger.error(D,...P)}flush(){this.logger.flush()}};e.UserDataSyncLogService=A,e.UserDataSyncLogService=A=ve([Y(0,N.ILoggerService)],A)}),define(oe[236],ae([0,1,6,3,2]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends T.Disposable{constructor({onDidOpenWindow:D,onDidFocusWindow:P,getActiveWindowId:v}){super(),this.disposables=this._register(new T.DisposableStore),N.Event.latch(N.Event.any(D,P))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>v()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(D){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=D}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(oe[112],ae([0,1,174,16,47,22,10,4,26]),function(te,e,L,N,T,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function v(s){const i=s;return typeof i?.id=="string"&&k.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=v;function I(s){return typeof s?.id=="string"&&!v(s)&&!S(s)}e.isEmptyWorkspaceIdentifier=I,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function C(s,i){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,N.basename)(s)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=C;function S(s){const i=s;return typeof i?.id=="string"&&k.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=S;function u(s){const i=s;if(i?.uri)return{id:i.id,uri:k.URI.revive(i.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:k.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=u;var g;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function w(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=w;function c(s){const i=s;return!!(i&&typeof i=="object"&&k.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=c;class l{constructor(i,r,a,p,m){this._id=i,this._transient=a,this._configuration=p,this._ignorePathCasing=m,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class h{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,A.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function y(s){return new h({uri:s,index:0,name:(0,A.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(s,i){return A.extUriBiasedIgnorePathCase.isEqualOrParent(s,i.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function R(s){let i;return k.URI.isUri(s)?i=s:i=s.configuration,i?.scheme===P.Schemas.tmp}e.isTemporaryWorkspace=R,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function o(s,i){return!E(s,i)&&!R(s)}e.isSavedWorkspace=o;function n(s){return(typeof s=="string"?(0,N.extname)(s):(0,A.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(oe[17],ae([0,1,51,3,2,22,10,165,15,13,4,8,112,35,28,6,32,27,11]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var y;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(y||(e.ProfileResourceType=y={}));function E(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&k.URI.isUri(i.location)&&k.URI.isUri(i.globalStorageHome)&&k.URI.isUri(i.settingsResource)&&k.URI.isUri(i.keybindingsResource)&&k.URI.isUri(i.tasksResource)&&k.URI.isUri(i.snippetsHome)&&k.URI.isUri(i.extensionsResource))}e.isUserDataProfile=E,e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function R(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,location:k.URI.revive(s.location).with({scheme:i}),globalStorageHome:k.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:k.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:k.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:k.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:k.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:k.URI.revive(s.extensionsResource).with({scheme:i}),cacheHome:k.URI.revive(s.cacheHome).with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.reviveProfile=R;function t(s,i,r,a,p,m){return{id:s,name:i,location:r,isDefault:!1,shortName:p?.shortName,globalStorageHome:m&&p?.useDefaultFlags?.globalState?m.globalStorageHome:(0,A.joinPath)(r,"globalStorage"),settingsResource:m&&p?.useDefaultFlags?.settings?m.settingsResource:(0,A.joinPath)(r,"settings.json"),keybindingsResource:m&&p?.useDefaultFlags?.keybindings?m.keybindingsResource:(0,A.joinPath)(r,"keybindings.json"),tasksResource:m&&p?.useDefaultFlags?.tasks?m.tasksResource:(0,A.joinPath)(r,"tasks.json"),snippetsHome:m&&p?.useDefaultFlags?.snippets?m.snippetsHome:(0,A.joinPath)(r,"snippets"),extensionsResource:m&&p?.useDefaultFlags?.extensions?m.extensionsResource:(0,A.joinPath)(r,"extensions.json"),cacheHome:(0,A.joinPath)(a,s),useDefaultFlags:p?.useDefaultFlags,isTransient:p?.transient}}e.toUserDataProfile=t;let o=class extends T.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,r,a,p){super(),this.environmentService=i,this.fileService=r,this.uriIdentityService=a,this.logService=p,this.enabled=!0,this._onDidChangeProfiles=this._register(new N.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new N.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new N.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new N.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new u.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const i=this.createDefaultProfile(),r=[i];if(this.enabled)try{for(const m of this.getStoredProfiles()){if(!m.name||!(0,h.isString)(m.name)||!m.location){this.logService.warn("Skipping the invalid stored profile",m.location||m.name);continue}r.push(t((0,A.basename)(m.location),m.name,m.location,this.profilesCacheHome,{shortName:m.shortName,useDefaultFlags:m.useDefaultFlags},i))}}catch(m){this.logService.error(m)}const a=new u.ResourceMap,p=new Map;if(r.length)try{const m=this.getStoredProfileAssociations();if(m.workspaces)for(const[d,b]of Object.entries(m.workspaces)){const O=k.URI.parse(d),F=r.find(M=>M.id===b);F&&a.set(O,F)}if(m.emptyWindows)for(const[d,b]of Object.entries(m.emptyWindows)){const O=r.find(F=>F.id===b);O&&p.set(d,O)}}catch(m){this.logService.error(m)}this._profilesObject={profiles:r,workspaces:a,emptyWindows:p}}return this._profilesObject}createDefaultProfile(){const i=t("__default__profile__",(0,D.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...i,extensionsResource:this.getDefaultProfileExtensionsLocation()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const r="Temp",a=new RegExp(`${(0,l.escapeRegExpCharacters)(r)}\\s(\\d+)`);let p=0;for(const d of this.profiles){const b=a.exec(d.name),O=b?parseInt(b[1]):0;p=O>p?O:p}const m=`${r} ${p+1}`;return this.createProfile((0,L.hash)((0,c.generateUuid)()).toString(16),m,{transient:!0},i)}async createNamedProfile(i,r,a){return this.createProfile((0,L.hash)((0,c.generateUuid)()).toString(16),i,r,a)}async createProfile(i,r,a,p){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const m=await this.doCreateProfile(i,r,a);return p&&await this.setProfileForWorkspace(p,m),m}async doCreateProfile(i,r,a){if(!(0,h.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let p=this.profileCreationPromises.get(r);return p||(p=(async()=>{try{const m=this.profiles.find(O=>O.name===r||O.id===i);if(m)return m;const d=t(i,r,(0,A.joinPath)(this.profilesHome,i),this.profilesCacheHome,a,this.defaultProfile);await this.fileService.createFolder(d.location);const b=[];return this._onWillCreateProfile.fire({profile:d,join(O){b.push(O)}}),await w.Promises.settled(b),this.updateProfiles([d],[],[]),d}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,p)),p}async updateProfile(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(p=>p.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=t(a.id,r.name??a.name,a.location,this.profilesCacheHome,{shortName:r.shortName??a.shortName,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[a]),a}async removeProfile(i){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(p=>p.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this._onWillRemoveProfile.fire({profile:r,join(p){a.push(p)}});try{await Promise.allSettled(a)}catch(p){this.logService.error(p)}for(const p of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(p)?.id&&this.profilesObject.emptyWindows.delete(p);for(const p of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(p)?.id&&this.profilesObject.workspaces.delete(p);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{await this.fileService.del(r.cacheHome,{recursive:!0})}catch(p){(0,v.toFileOperationResult)(p)!==1&&this.logService.error(p)}}async setProfileForWorkspace(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(p=>p.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(i,a)}unsetWorkspace(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(i,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.uriIdentityService.extUri.isEqual(a.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.getWorkspace(i);return k.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindows.get(r)??this.profilesObject.emptyWindows.get(r)}getWorkspace(i){return(0,S.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,S.isWorkspaceIdentifier)(i)?i.configPath:i.id}isProfileAssociatedToWorkspace(i){return!!([...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location)))}updateProfiles(i,r,a){const p=[...this.profiles,...i],m=[];this.transientProfilesObject.profiles=[];for(let d of p)d.isDefault||r.some(b=>d.id===b.id)||(d=a.find(b=>d.id===b.id)??d,d.isTransient?this.transientProfilesObject.profiles.push(d):m.push({location:d.location,name:d.name,shortName:d.shortName,useDefaultFlags:d.useDefaultFlags}));this.saveStoredProfiles(m),this._profilesObject=void 0,this.triggerProfilesChanges(i,r,a)}triggerProfilesChanges(i,r,a){this._onDidChangeProfiles.fire({added:i,removed:r,updated:a,all:this.profiles})}updateWorkspaceAssociation(i,r,a){a=r?.isTransient?!0:a,a||this.updateWorkspaceAssociation(i,void 0,!0);const p=this.getWorkspace(i),m=a?this.transientProfilesObject:this.profilesObject;k.URI.isUri(p)?(m.workspaces.delete(p),r&&m.workspaces.set(p,r)):(m.emptyWindows.delete(p),r&&m.emptyWindows.set(p,r)),a||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[a,p]of this.profilesObject.workspaces.entries())i[a.toString()]=p.id;const r={};for(const[a,p]of this.profilesObject.emptyWindows.entries())r[a.toString()]=p.id;this.saveStoredProfileAssociations({workspaces:i,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(i){const r={},a=this.createDefaultProfile();if(i.workspaces)for(const[m,d]of Object.entries(i.workspaces)){const b=k.URI.parse(d);r[m]=this.uriIdentityService.extUri.isEqual(b,a.location)?a.id:this.uriIdentityService.extUri.basename(b)}const p={};if(i.emptyWindows)for(const[m,d]of Object.entries(i.emptyWindows)){const b=k.URI.parse(d);p[m]=this.uriIdentityService.extUri.isEqual(b,a.location)?a.id:this.uriIdentityService.extUri.basename(b)}return{workspaces:r,emptyWindows:p}}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=o,e.UserDataProfilesService=o=ve([Y(0,P.IEnvironmentService),Y(1,v.IFileService),Y(2,g.IUriIdentityService),Y(3,C.ILogService)],o);class n extends o{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=n}),define(oe[237],ae([0,1,6,2,17]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let A=class extends N.Disposable{constructor(D){super(),this._register(new L.RunOnceScheduler(()=>{D.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=A,e.UserDataProfilesCleaner=A=ve([Y(0,T.IUserDataProfilesService)],A)}),define(oe[238],ae([0,1,21,6,25,7,3,2,5,11,10,148,29,33,45,8,24,20,28,17]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.toExtensionManagementError=e.joinErrors=e.AbstractExtensionManagementService=void 0;let E=class extends D.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(i,r,a,p,m,d){super(),this.galleryService=i,this.telemetryService=r,this.uriIdentityService=a,this.logService=p,this.productService=m,this.userDataProfilesService=d,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this._onDidInstallExtensions=this._register(new k.Emitter),this._onUninstallExtension=this._register(new k.Emitter),this._onDidUninstallExtension=this._register(new k.Emitter),this._onDidUpdateExtensionMetadata=this._register(new k.Emitter),this.participants=[],this._register((0,D.toDisposable)(()=>{this.installingExtensions.forEach(({task:b})=>b.cancel()),this.uninstallingExtensions.forEach(b=>b.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(a=>(0,S.isTargetPlatformCompatible)(a,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{const p=(await this.installGalleryExtensions([{extension:i,options:r}])).find(({identifier:m})=>(0,u.areSameExtensions)(m,i.identifier));if(p?.local)return p?.local;throw p?.error?p.error:t(new Error(`Unknown error while installing extension ${i.identifier.id}`))}catch(a){throw t(a)}}async installGalleryExtensions(i){if(!this.galleryService.isEnabled())throw new S.ExtensionManagementError(C.localize(0,null),S.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(i.map(async({extension:p,options:m})=>{try{const d=await this.checkAndGetCompatibleVersion(p,!!m?.installGivenVersion,!!m?.installPreReleaseVersion);a.push({...d,options:m})}catch(d){r.push({identifier:p.identifier,operation:2,source:p,error:d})}})),a.length&&r.push(...await this.installExtensions(a));for(const p of r)p.error&&(this.logService.error("Failed to install extension.",p.identifier.id),this.logService.error(p.error),p.source&&!I.URI.isUri(p.source)&&o(this.telemetryService,"extensionGallery:install",{extensionData:(0,u.getGalleryExtensionTelemetryData)(p.source),error:p.error}));return r}async uninstall(i,r={}){return this.logService.trace("ExtensionManagementService#uninstall",i.identifier.id),this.uninstallExtension(i,r)}async toggleAppliationScope(i,r){if((0,g.isApplicationScopedExtension)(i.manifest))return i;if(i.isApplicationScoped){let a=await this.updateMetadata(i,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)||(a=await this.copyExtension(i,this.userDataProfilesService.defaultProfile.extensionsResource,r));for(const p of this.userDataProfilesService.profiles){const m=(await this.getInstalled(1,p.extensionsResource)).find(d=>(0,u.areSameExtensions)(d.identifier,i.identifier));m?this._onDidUpdateExtensionMetadata.fire(m):this._onDidUninstallExtension.fire({identifier:i.identifier,profileLocation:p.extensionsResource})}return a}else{const a=this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(i,r,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.extensionsControlManifest||i-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=i),this.extensionsControlManifest}registerParticipant(i){this.participants.push(i)}async installExtensions(i){const r=[];return await Promise.allSettled(i.map(async a=>{try{const p=await this.installExtension(a);r.push(...p)}catch(p){r.push({identifier:{id:(0,u.getGalleryExtensionId)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:p})}})),this._onDidInstallExtensions.fire(r),r}async installExtension({manifest:i,extension:r,options:a}){const p=a.isApplicationScoped||a.isBuiltin||(0,g.isApplicationScopedExtension)(i),m={...a,installOnlyNewlyAddedFromExtensionPack:I.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:p,profileLocation:p?this.userDataProfilesService.defaultProfile.extensionsResource:a.profileLocation??this.getCurrentExtensionsManifestLocation()},d=j=>`${u.ExtensionKey.create(j).toString()}${m.profileLocation?`-${m.profileLocation.toString()}`:""}`;if(!I.URI.isUri(r)){const j=this.installingExtensions.get(d(r));if(j)return this.logService.info("Extensions is already requested to install",r.identifier.id),await j.task.waitUntilTaskIsFinished(),[]}const b=[],O=[],F=[],M=this.createInstallExtensionTask(i,r,m);I.URI.isUri(r)||this.installingExtensions.set(d(r),{task:M,waitingTasks:[]}),this._onInstallExtension.fire({identifier:M.identifier,source:r,profileLocation:m.profileLocation}),this.logService.info("Installing extension:",M.identifier.id),b.push({task:M,manifest:i});let q=!1;try{if(m.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",M.identifier.id);else try{const B=await this.getAllDepsAndPackExtensions(M.identifier,i,!!m.installOnlyNewlyAddedFromExtensionPack,!!m.installPreReleaseVersion,m.profileLocation),Q=await this.getInstalled(void 0,m.profileLocation);for(const{gallery:J,manifest:G}of(0,L.distinct)(B,({gallery:X})=>X.identifier.id)){q=q||!!G.extensionDependencies?.some(x=>(0,u.areSameExtensions)({id:x},M.identifier));const X=d(J),V=this.installingExtensions.get(X);if(V){if(this.canWaitForTask(M,V.task)){const x=V.task.identifier;this.logService.info("Waiting for already requested installing extension",x.id,M.identifier.id),V.waitingTasks.push(M),O.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,z=>z.some(ee=>(0,u.areSameExtensions)(ee.identifier,x)))).then(z=>{if(this.logService.info("Finished waiting for already requested installing extension",x.id,M.identifier.id),!z.find(ne=>(0,u.areSameExtensions)(ne.identifier,x))?.local)throw new Error(`Extension ${x.id} is not installed`)}))}}else if(!Q.some(({identifier:x})=>(0,u.areSameExtensions)(x,J.identifier))){const x=this.createInstallExtensionTask(G,J,{...m,donotIncludePackAndDependencies:!0});this.installingExtensions.set(X,{task:x,waitingTasks:[M]}),this._onInstallExtension.fire({identifier:x.identifier,source:J,profileLocation:m.profileLocation}),this.logService.info("Installing extension:",x.identifier.id,M.identifier.id),b.push({task:x,manifest:G})}}}catch(B){if(I.URI.isUri(M.source))(0,L.isNonEmptyArray)(i.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",M.identifier.id,B.message),(0,L.isNonEmptyArray)(i.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",M.identifier.id,B.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",M.identifier.id),B}const j=b.reduce((B,{task:Q,manifest:J})=>(B.set(Q.identifier.id.toLowerCase(),{task:Q,manifest:J}),B),new Map);for(;j.size;){let B;const Q=[...j.values()].filter(({manifest:J})=>!J.extensionDependencies?.some(G=>j.has(G.toLowerCase())));Q.length?B=j.size===1?Q:Q.filter(({task:J})=>!(J===M&&!q)):(this.logService.info("Found extensions with circular dependencies",Q.map(({task:J})=>J.identifier.id)),B=[...j.values()]),await this.joinAllSettled(B.map(async({task:J})=>{const G=new Date().getTime();try{const X=await J.run();if(await this.joinAllSettled(this.participants.map(V=>V.postInstall(X,J.source,m,T.CancellationToken.None))),!I.URI.isUri(J.source)){const V=J.operation===3,x=V?void 0:(new Date().getTime()-J.source.lastUpdated)/1e3;if(o(this.telemetryService,V?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,u.getGalleryExtensionTelemetryData)(J.source),verificationStatus:J.verificationStatus,duration:new Date().getTime()-G,durationSinceUpdate:x}),P.isWeb&&J.operation!==3)try{await this.galleryService.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}}F.push({local:X,identifier:J.identifier,operation:J.operation,source:J.source,context:m.context,profileLocation:J.profileLocation,applicationScoped:X.isApplicationScoped})}catch(X){throw I.URI.isUri(J.source)||o(this.telemetryService,J.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,u.getGalleryExtensionTelemetryData)(J.source),verificationStatus:J.verificationStatus,duration:new Date().getTime()-G,error:X}),this.logService.error("Error while installing the extension:",J.identifier.id),X}finally{j.delete(J.identifier.id.toLowerCase())}}))}return O.length&&await this.joinAllSettled(O),F.forEach(({identifier:B})=>this.logService.info("Extension installed successfully:",B.id)),F}catch(j){if(b.forEach(({task:B})=>B.cancel()),F.length)try{const B=await Promise.allSettled(F.map(({local:Q})=>this.createUninstallExtensionTask(Q,{versionOnly:!0,profileLocation:m.profileLocation}).run()));for(let Q=0;Q<B.length;Q++){const J=B[Q],{identifier:G}=F[Q];J.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",G.id):this.logService.warn("Rollback: Error while uninstalling extension",G.id,(0,A.getErrorMessage)(J.reason))}}catch(B){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(B),F.map(({identifier:Q})=>Q.id))}return b.map(({task:B})=>({identifier:B.identifier,operation:2,source:B.source,context:m.context,profileLocation:m.profileLocation,error:j}))}finally{for(const{task:j}of b)j.source&&!I.URI.isUri(j.source)&&this.installingExtensions.delete(d(j.source))}}canWaitForTask(i,r){for(const[,{task:a,waitingTasks:p}]of this.installingExtensions.entries())if(a===i&&(p.includes(r)||p.some(m=>this.canWaitForTask(m,r)))||a===r&&p[0]&&!this.canWaitForTask(i,p[0]))return!1;return!0}async joinAllSettled(i){const r=[],a=[],p=await Promise.allSettled(i);for(const m of p)m.status==="fulfilled"?r.push(m.value):a.push(m.reason);if(a.length)throw R(a);return r}async getAllDepsAndPackExtensions(i,r,a,p,m){if(!this.galleryService.isEnabled())return[];const d=await this.getInstalled(void 0,m),b=[],O=[],F=async(M,q)=>{b.push(M);const j=q.extensionDependencies||[],B=[...j];if(q.extensionPack){const Q=a?d.find(J=>(0,u.areSameExtensions)(J.identifier,M)):void 0;for(const J of q.extensionPack)Q&&Q.manifest.extensionPack&&Q.manifest.extensionPack.some(G=>(0,u.areSameExtensions)({id:G},{id:J}))||B.every(G=>!(0,u.areSameExtensions)({id:G},{id:J}))&&B.push(J)}if(B.length){const Q=B.filter(J=>b.every(G=>!(0,u.areSameExtensions)(G,{id:J})));if(Q.length){const J=await this.galleryService.getExtensions(Q.map(G=>({id:G,preRelease:p})),T.CancellationToken.None);for(const G of J){if(b.find(x=>(0,u.areSameExtensions)(x,G.identifier)))continue;const X=j.some(x=>(0,u.areSameExtensions)({id:x},G.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(G,!1,p)}catch(x){if(X)throw x;this.logService.info("Skipping the packed extension as it cannot be installed",G.identifier.id,(0,A.getErrorMessage)(x));continue}O.push({gallery:V.extension,manifest:V.manifest}),await F(V.extension.identifier,V.manifest)}}}};return await F(i,r),O}async checkAndGetCompatibleVersion(i,r,a){let p;const m=await this.getExtensionsControlManifest();if(m.malicious.some(O=>(0,u.areSameExtensions)(i.identifier,O)))throw new S.ExtensionManagementError(C.localize(1,null,i.identifier.id),S.ExtensionManagementErrorCode.Malicious);const d=m.deprecated[i.identifier.id.toLowerCase()];if(d?.extension?.autoMigrate){if(this.logService.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${d.extension.id}' extension instead.`),p=(await this.galleryService.getExtensions([{id:d.extension.id,preRelease:d.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},T.CancellationToken.None))[0],!p)throw new S.ExtensionManagementError(C.localize(2,null,i.identifier.id,d.extension.id),S.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const O=await this.getTargetPlatform();throw new S.ExtensionManagementError(C.localize(3,null,i.identifier.id,this.productService.nameLong,(0,S.TargetPlatformToString)(O)),S.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(p=await this.getCompatibleVersion(i,r,a),!p)throw!a&&i.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([i.identifier],T.CancellationToken.None))[0]?new S.ExtensionManagementError(C.localize(4,null,i.identifier.id),S.ExtensionManagementErrorCode.ReleaseVersionNotFound):new S.ExtensionManagementError(C.localize(5,null,i.identifier.id,this.productService.nameLong,this.productService.version),S.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",p.identifier.id);const b=await this.galleryService.getManifest(p,T.CancellationToken.None);if(b===null)throw new S.ExtensionManagementError(`Missing manifest for extension ${p.identifier.id}`,S.ExtensionManagementErrorCode.Invalid);if(b.version!==p.version)throw new S.ExtensionManagementError(`Cannot install '${p.identifier.id}' extension because of version mismatch in Marketplace`,S.ExtensionManagementErrorCode.Invalid);return{extension:p,manifest:b}}async getCompatibleVersion(i,r,a){const p=await this.getTargetPlatform();let m=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==a&&(m=(await this.galleryService.getExtensions([{...i.identifier,preRelease:a}],{targetPlatform:p,compatible:!0},T.CancellationToken.None))[0]||null),!m&&await this.galleryService.isExtensionCompatible(i,a,p)&&(m=i),m||(r?m=(await this.galleryService.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:p,compatible:!0},T.CancellationToken.None))[0]||null:m=await this.galleryService.getCompatibleExtension(i,a,p)),m}async uninstallExtension(i,r){const a={...r,profileLocation:i.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},p=M=>`${M.id.toLowerCase()}${a.versionOnly?`-${i.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,m=this.uninstallingExtensions.get(p(i.identifier));if(m)return this.logService.info("Extensions is already requested to uninstall",i.identifier.id),m.waitUntilTaskIsFinished();const d=M=>{const q=this.createUninstallExtensionTask(M,a);return this.uninstallingExtensions.set(p(q.extension.identifier),q),a.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this._onUninstallExtension.fire({identifier:M.identifier,profileLocation:a.profileLocation,applicationScoped:M.isApplicationScoped}),q},b=(M,q)=>{q?a.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString(),q.message):this.logService.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,q.message):a.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),o(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,u.getLocalExtensionTelemetryData)(M),error:q}),this._onDidUninstallExtension.fire({identifier:M.identifier,error:q?.code,profileLocation:a.profileLocation,applicationScoped:M.isApplicationScoped})},O=[],F=[];try{O.push(d(i));const M=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const q=this.getAllPackExtensionsToUninstall(i,M);for(const j of q)this.uninstallingExtensions.has(p(j.identifier))?this.logService.info("Extensions is already requested to uninstall",j.identifier.id):O.push(d(j))}a.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.checkForDependents(O.map(q=>q.extension),M,i),await this.joinAllSettled(O.map(async q=>{try{if(await q.run(),await this.joinAllSettled(this.participants.map(j=>j.postUninstall(q.extension,a,T.CancellationToken.None))),q.extension.identifier.uuid)try{await this.galleryService.reportStatistic(q.extension.manifest.publisher,q.extension.manifest.name,q.extension.manifest.version,"uninstall")}catch{}b(q.extension)}catch(j){const B=j instanceof S.ExtensionManagementError?j:new S.ExtensionManagementError((0,A.getErrorMessage)(j),S.ExtensionManagementErrorCode.Internal);throw b(q.extension,B),B}finally{F.push(q)}}))}catch(M){const q=M instanceof S.ExtensionManagementError?M:new S.ExtensionManagementError((0,A.getErrorMessage)(M),S.ExtensionManagementErrorCode.Internal);for(const j of O){try{j.cancel()}catch{}F.includes(j)||b(j.extension,q)}throw q}finally{for(const M of O)this.uninstallingExtensions.delete(p(M.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}checkForDependents(i,r,a){for(const p of i){const m=this.getDependents(p,r);if(m.length){const d=m.filter(b=>!i.some(O=>(0,u.areSameExtensions)(O.identifier,b.identifier)));if(d.length)throw new Error(this.getDependentsErrorMessage(p,d,a))}}}getDependentsErrorMessage(i,r,a){return a===i?r.length===1?C.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?C.localize(9,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(10,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(11,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(i,r,a=[]){if(a.indexOf(i)!==-1)return[];a.push(i);const p=i.manifest.extensionPack?i.manifest.extensionPack:[];if(p.length){const m=r.filter(b=>!b.isBuiltin&&p.some(O=>(0,u.areSameExtensions)({id:O},b.identifier))),d=[];for(const b of m)d.push(...this.getAllPackExtensionsToUninstall(b,r,a));return[...m,...d]}return[]}getDependents(i,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(p=>(0,u.areSameExtensions)({id:p},i.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const i=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=E,e.AbstractExtensionManagementService=E=ve([Y(0,S.IExtensionGalleryService),Y(1,l.ITelemetryService),Y(2,h.IUriIdentityService),Y(3,w.ILogService),Y(4,c.IProductService),Y(5,y.IUserDataProfilesService)],E);function R(s){const i=Array.isArray(s)?s:[s];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=R;function t(s){if(s instanceof S.ExtensionManagementError)return s;const i=new S.ExtensionManagementError(s.message,S.ExtensionManagementErrorCode.Internal);return i.stack=s.stack,i}e.toExtensionManagementError=t;function o(s,i,{extensionData:r,verificationStatus:a,duration:p,error:m,durationSinceUpdate:d}){let b,O;(0,v.isDefined)(a)&&(a===!0?a="Verified":(a===!1||(b=S.ExtensionManagementErrorCode.Signature,O=a),a="Unverified")),m&&(m instanceof S.ExtensionManagementError?(b=m.code,m.code===S.ExtensionManagementErrorCode.Signature&&(O=m.message)):b=S.ExtensionManagementErrorCode.Internal),s.publicLog(i,{...r,verificationStatus:a,success:!m,duration:p,errorcode:b,errorcodeDetail:O,durationSinceUpdate:d})}class n{constructor(){this.barrier=new N.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,N.createCancelablePromise)(i=>this.doRun(i))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,N.createCancelablePromise)(i=>new Promise((r,a)=>{const p=i.onCancellationRequested(()=>{p.dispose(),a(new A.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=n}),define(oe[50],ae([0,1,6,14,2,3,35,10,29,33,13,4,8,17,28,11,7,20]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class y extends Error{constructor(n,s){super(n),this.code=s}}e.ExtensionsProfileScanningError=y,e.IExtensionsProfileScannerService=(0,C.createDecorator)("IExtensionsProfileScannerService");let E=class extends T.Disposable{constructor(n,s,i,r,a,p){super(),this.extensionsLocation=n,this.fileService=s,this.userDataProfilesService=i,this.uriIdentityService=r,this.telemetryService=a,this.logService=p,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(n,s){return this.withProfileExtensions(n,void 0,s)}async addExtensionsToProfile(n,s){const i=[],r=[];try{return await this.withProfileExtensions(s,a=>{const p=[];for(const m of a)n.some(([d])=>(0,v.areSameExtensions)(d.identifier,m.identifier)&&d.manifest.version!==m.version)?i.push(m):p.push(m);for(const[m,d]of n)if(!p.some(b=>(0,v.areSameExtensions)(b.identifier,m.identifier)&&b.version===m.manifest.version)){const b={identifier:m.identifier,version:m.manifest.version,location:m.location,metadata:d};r.push(b),p.push(b)}return r.length&&this._onAddExtensions.fire({extensions:r,profileLocation:s}),i.length&&this._onRemoveExtensions.fire({extensions:i,profileLocation:s}),p}),r.length&&this._onDidAddExtensions.fire({extensions:r,profileLocation:s}),i.length&&this._onDidRemoveExtensions.fire({extensions:i,profileLocation:s}),r}catch(a){throw r.length&&this._onDidAddExtensions.fire({extensions:r,error:a,profileLocation:s}),i.length&&this._onDidRemoveExtensions.fire({extensions:i,error:a,profileLocation:s}),a}}async updateMetadata(n,s){const i=[];return await this.withProfileExtensions(s,r=>{const a=[];for(const p of r){const m=n.find(([d])=>(0,v.areSameExtensions)(d.identifier,p.identifier)&&d.manifest.version===p.version);m&&(p.metadata={...p.metadata,...m[1]},i.push(p)),a.push(p)}return a}),i}async removeExtensionFromProfile(n,s){const i=[];this._onRemoveExtensions.fire({extensions:i,profileLocation:s});try{await this.withProfileExtensions(s,r=>{const a=[];for(const p of r)(0,v.areSameExtensions)(p.identifier,n.identifier)?i.push(p):a.push(p);return i.length&&this._onRemoveExtensions.fire({extensions:i,profileLocation:s}),a}),i.length&&this._onDidRemoveExtensions.fire({extensions:i,profileLocation:s})}catch(r){throw i.length&&this._onDidRemoveExtensions.fire({extensions:i,error:r,profileLocation:s}),r}}async withProfileExtensions(n,s,i){return this.getResourceAccessQueue(n).queue(async()=>{let r=[],a;try{const p=await this.fileService.readFile(n);a=JSON.parse(p.value.toString().trim()||"[]")}catch(p){if((0,I.toFileOperationResult)(p)!==1)throw p;if(this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)&&(a=await this.migrateFromOldDefaultProfileExtensionsLocation()),!a&&i?.bailOutWhenFileNotFound)throw new y((0,c.getErrorMessage)(p),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.reportAndThrowInvalidConentError(n);let p=!1;for(const m of a){R(m)||this.reportAndThrowInvalidConentError(n);let d;if((0,w.isString)(m.relativeLocation)&&m.relativeLocation)d=this.resolveExtensionLocation(m.relativeLocation);else if((0,w.isString)(m.location))d=this.resolveExtensionLocation(m.location),p=!0,m.relativeLocation=m.location,m.location=d.toJSON();else{d=D.URI.revive(m.location);const b=this.toRelativePath(d);b&&(p=!0,m.relativeLocation=b)}r.push({identifier:m.identifier,location:d,version:m.version,metadata:m.metadata})}p&&await this.fileService.writeFile(n,N.VSBuffer.fromString(JSON.stringify(a)))}if(s){r=s(r);const p=r.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),relativeLocation:this.toRelativePath(m.location),metadata:m.metadata}));await this.fileService.writeFile(n,N.VSBuffer.fromString(JSON.stringify(p)))}return r})}reportAndThrowInvalidConentError(n){const s=new y(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}toRelativePath(n){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(n),this.extensionsLocation)?this.uriIdentityService.extUri.basename(n):void 0}resolveExtensionLocation(n){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,n)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const n=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),s=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let i;try{i=(await this.fileService.readFile(n)).value.toString()}catch(a){if((0,I.toFileOperationResult)(a)===1)return;throw a}this.logService.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(i);Array.isArray(a)&&a.every(p=>R(p))?r=a:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.logService.error(a)}if(r)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,N.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(a){if((0,I.toFileOperationResult)(a)===3)this.logService.info("Migration from old default profile location to new location is done by another window",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw a}try{await this.fileService.del(n)}catch(a){(0,I.toFileOperationResult)(a)!==1&&this.logService.error(a)}try{await this.fileService.del(s)}catch(a){(0,I.toFileOperationResult)(a)!==1&&this.logService.error(a)}return r})()),this._migrationPromise}getResourceAccessQueue(n){let s=this.resourcesAccessQueueMap.get(n);return s||(s=new L.Queue,this.resourcesAccessQueueMap.set(n,s)),s}};e.AbstractExtensionsProfileScannerService=E,e.AbstractExtensionsProfileScannerService=E=ve([Y(1,I.IFileService),Y(2,u.IUserDataProfilesService),Y(3,g.IUriIdentityService),Y(4,l.ITelemetryService),Y(5,S.ILogService)],E);function R(o){return(0,w.isObject)(o)&&(0,P.isIExtensionIdentifier)(o.identifier)&&(t(o.location)||(0,w.isString)(o.location)&&o.location)&&((0,w.isUndefined)(o.relativeLocation)||(0,w.isString)(o.relativeLocation))&&o.version&&(0,w.isString)(o.version)}function t(o){return o?(0,w.isString)(o.path)&&(0,w.isString)(o.scheme):!1}}),define(oe[77],ae([0,1,21,6,30,14,7,34,135,2,26,16,5,22,53,88,11,10,151,15,33,45,65,13,4,8,24,3,62,50,17,28,179]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h,y,E,R,t,o,n,s,i,r,a,p,m,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var O;(function(J){function G(X,V){if(X===V)return!0;const x=Object.keys(X),z=new Set;for(const ee of Object.keys(V))z.add(ee);if(x.length!==z.size)return!1;for(const ee of x){if(X[ee]!==V[ee])return!1;z.delete(ee)}return z.size===0}J.equals=G})(O||(e.Translations=O={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let F=class extends v.Disposable{constructor(G,X,V,x,z,ee,ne,ce,re,U,f,_){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=X,this.extensionsControlLocation=V,this.currentProfile=x,this.userDataProfilesService=z,this.extensionsProfileScannerService=ee,this.fileService=ne,this.logService=ce,this.environmentService=re,this.productService=U,this.uriIdentityService=f,this.instantiationService=_,this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,u.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(j,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(j,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(q,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,E.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(G,X,V){const[x,z]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(X)]),ee=V?await this.scanExtensionsUnderDevelopment(G,[...x,...z]):[];return this.dedupExtensions(x,z,ee,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const X=[];X.push(this.scanDefaultSystemExtensions(!!G.useCache,G.language)),X.push(this.scanDevSystemExtensions(G.language,!!G.checkControlFile));const[V,x]=await Promise.all(X);return this.applyScanOptions([...V,...x],0,G,!1)}async scanUserExtensions(G){const X=G.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",X);const V=this.uriIdentityService.extUri.isEqual(G.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,x=await this.createExtensionScannerInput(X,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,V),z=G.useCache&&!x.devMode&&x.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let ee;try{ee=await z.scanExtensions(x)}catch(ne){if(ne instanceof p.ExtensionsProfileScanningError&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),ee=await z.scanExtensions(x);else throw ne}return ee=await this.applyScanOptions(ee,1,G,!0),this.logService.trace("Scanned user extensions:",ee.length),ee}async scanExtensionsUnderDevelopment(G,X){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const V=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(x=>x.scheme===I.Schemas.file).map(async x=>{const z=await this.createExtensionScannerInput(x,!1,1,!0,G.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(z)).map(ne=>(ne.type=X.find(ce=>(0,E.areSameExtensions)(ce.identifier,ne.identifier))?.type??ne.type,this.extensionsScanner.validate(ne,z)))}))).flat();return this.applyScanOptions(V,"development",G,!0)}return[]}async scanExistingExtension(G,X,V){const x=await this.createExtensionScannerInput(G,!1,X,!0,V.language,!0,void 0),z=await this.extensionsScanner.scanExtension(x);return!z||!V.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions(G,X,V){const x=await this.createExtensionScannerInput(G,!1,X,!0,V.language,!0,void 0),z=await this.extensionsScanner.scanOneOrMultipleExtensions(x);return this.applyScanOptions(z,X,V,!0)}async scanMetadata(G){const X=(0,u.joinPath)(G,"package.json"),V=(await this.fileService.readFile(X)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(G,X){const V=(0,u.joinPath)(G,"package.json"),x=(await this.fileService.readFile(V)).value.toString(),z=JSON.parse(x);X.isMachineScoped=X.isMachineScoped||void 0,X.isBuiltin=X.isBuiltin||void 0,z.__metadata={...z.__metadata,...X},await this.fileService.writeFile((0,u.joinPath)(G,"package.json"),A.VSBuffer.fromString(JSON.stringify(z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof p.ExtensionsProfileScanningError&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw G}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.extensionsProfileScannerService.addExtensionsToProfile(G.map(X=>[X,X.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(X){(0,o.toFileOperationResult)(X)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(X))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.logService.error(G)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(G,X,V,x){return V.includeAllVersions||(G=this.dedupExtensions(X===0?G:void 0,X===1?G:void 0,X==="development"?G:void 0,await this.getTargetPlatform(),x)),V.includeInvalid||(G=G.filter(z=>z.isValid)),G.sort((z,ee)=>{const ne=C.basename(z.location.fsPath),ce=C.basename(ee.location.fsPath);return ne<ce?-1:ne>ce?1:0})}dedupExtensions(G,X,V,x,z){const ee=(ce,re,U)=>{if(ce.isValid&&!re.isValid)return!1;if(ce.isValid===re.isValid){if(z&&g.gt(ce.manifest.version,re.manifest.version))return this.logService.debug(`Skipping extension ${re.location.path} with lower version ${re.manifest.version} in favour of ${ce.location.path} with version ${ce.manifest.version}`),!1;if(g.eq(ce.manifest.version,re.manifest.version)){if(ce.type===0)return this.logService.debug(`Skipping extension ${re.location.path} in favour of system extension ${ce.location.path} with same version`),!1;if(ce.targetPlatform===x)return this.logService.debug(`Skipping extension ${re.location.path} from different target platform ${re.targetPlatform}`),!1}}return U?this.logService.warn(`Overwriting user extension ${ce.location.path} with ${re.location.path}.`):this.logService.debug(`Overwriting user extension ${ce.location.path} with ${re.location.path}.`),!0},ne=new R.ExtensionIdentifierMap;return G?.forEach(ce=>{const re=ne.get(ce.identifier.id);(!re||ee(re,ce,!1))&&ne.set(ce.identifier.id,ce)}),X?.forEach(ce=>{const re=ne.get(ce.identifier.id);if(!re&&G&&ce.type===0){this.logService.debug(`Skipping obsolete system extension ${ce.location.path}.`);return}(!re||ee(re,ce,!1))&&ne.set(ce.identifier.id,ce)}),V?.forEach(ce=>{const re=ne.get(ce.identifier.id);(!re||ee(re,ce,!0))&&ne.set(ce.identifier.id,ce),ne.set(ce.identifier.id,ce)}),[...ne.values()]}async scanDefaultSystemExtensions(G,X){this.logService.trace("Started scanning system extensions");const V=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),z=await(G&&!V.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(V);return this.logService.trace("Scanned system extensions:",z.length),z}async scanDevSystemExtensions(G,X){const V=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!V?.length)return[];this.logService.trace("Started scanning dev system extensions");const x=X?await this.getBuiltInExtensionControl():{},z=[],ee=l.URI.file(C.normalize(C.join(I.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ce of V){const re=x[ce.name]||"marketplace";switch(re){case"disabled":break;case"marketplace":z.push((0,u.joinPath)(ee,ce.name));break;default:z.push(l.URI.file(re));break}}const ne=await Promise.all(z.map(async ce=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ce,!1,0,!0,G,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",ne.length),(0,L.coalesce)(ne)}async getBuiltInExtensionControl(){try{const G=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(G.value.toString())}catch{return{}}}async createExtensionScannerInput(G,X,V,x,z,ee,ne){const ce=await this.getTranslations(z??S.language),re=await this.getMtime(G),U=X&&!this.uriIdentityService.extUri.isEqual(G,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,f=U?await this.getMtime(U):void 0;return new M(G,re,U,f,X,ne,V,x,ee,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,z,ce)}async getMtime(G){try{const X=await this.fileService.stat(G);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.AbstractExtensionsScannerService=F,e.AbstractExtensionsScannerService=F=ve([Y(4,m.IUserDataProfilesService),Y(5,p.IExtensionsProfileScannerService),Y(6,o.IFileService),Y(7,s.ILogService),Y(8,y.IEnvironmentService),Y(9,i.IProductService),Y(10,d.IUriIdentityService),Y(11,n.IInstantiationService)],F);class M{constructor(G,X,V,x,z,ee,ne,ce,re,U,f,_,$,H,W){this.location=G,this.mtime=X,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=x,this.profile=z,this.profileScanOptions=ee,this.type=ne,this.excludeObsolete=ce,this.validate=re,this.productVersion=U,this.productDate=f,this.productCommit=_,this.devMode=$,this.language=H,this.translations=W}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,X){return(0,u.isEqual)(G.location,X.location)&&G.mtime===X.mtime&&(0,u.isEqual)(G.applicationExtensionslocation,X.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&G.profile===X.profile&&T.equals(G.profileScanOptions,X.profileScanOptions)&&G.type===X.type&&G.excludeObsolete===X.excludeObsolete&&G.validate===X.validate&&G.productVersion===X.productVersion&&G.productDate===X.productDate&&G.productCommit===X.productCommit&&G.devMode===X.devMode&&G.language===X.language&&O.equals(G.translations,X.translations)}}e.ExtensionScannerInput=M;let q=class extends v.Disposable{constructor(G,X,V,x,z){super(),this.obsoleteFile=G,this.extensionsProfileScannerService=X,this.uriIdentityService=V,this.fileService=x,this.logService=z}async scanExtensions(G){const X=G.profile?await this.scanExtensionsFromProfile(G):await this.scanExtensionsFromLocation(G);let V={};if(G.excludeObsolete&&G.type===1)try{const x=(await this.fileService.readFile(this.obsoleteFile)).value.toString();V=JSON.parse(x)}catch{}return(0,c.isEmptyObject)(V)?X:X.filter(x=>!V[E.ExtensionKey.create(x).toString()])}async scanExtensionsFromLocation(G){const X=await this.fileService.resolve(G.location);if(!X.children?.length)return[];const V=await Promise.all(X.children.map(async x=>{if(!x.isDirectory||G.type===1&&(0,u.basename)(x.resource).indexOf(".")===0)return null;const z=new M(x.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(z)}));return(0,L.coalesce)(V).sort((x,z)=>x.location.path<z.location.path?-1:1)}async scanExtensionsFromProfile(G){let X=await this.scanExtensionsFromProfileResource(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(G.location,G.applicationExtensionslocation)){X=X.filter(x=>!x.metadata?.isApplicationScoped);const V=await this.scanExtensionsFromProfileResource(G.applicationExtensionslocation,x=>!!x.metadata?.isBuiltin||!!x.metadata?.isApplicationScoped,G);X.push(...V)}return X}async scanExtensionsFromProfileResource(G,X,V){const x=await this.extensionsProfileScannerService.scanProfileExtensions(G,V.profileScanOptions);if(!x.length)return[];const z=await Promise.all(x.map(async ee=>{if(X(ee)){const ne=new M(ee.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(ne,ee.metadata)}return null}));return(0,L.coalesce)(z)}async scanOneOrMultipleExtensions(G){try{if(await this.fileService.exists((0,u.joinPath)(G.location,"package.json"))){const X=await this.scanExtension(G);return X?[X]:[]}else return await this.scanExtensions(G)}catch(X){return this.logService.error(`Error scanning extensions at ${G.location.path}:`,(0,k.getErrorMessage)(X)),[]}}async scanExtension(G,X){try{let V=await this.scanExtensionManifest(G.location);if(V){V.publisher||(V.publisher=R.UNDEFINED_PUBLISHER),X=X??V.__metadata,delete V.__metadata;const x=(0,E.getGalleryExtensionId)(V.publisher,V.name),z=X?.id?{id:x,uuid:X.id}:{id:x},ee=X?.isSystem?0:G.type,ne=ee===0||!!X?.isBuiltin;V=await this.translateManifest(G.location,V,M.createNlsConfiguration(G));const ce={type:ee,identifier:z,manifest:V,location:G.location,isBuiltin:ne,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return G.validate?this.validate(ce,G):ce}}catch(V){G.type!==0&&this.logService.error(V)}return null}validate(G,X){let V=!0;const x=(0,t.validateExtensionManifest)(X.productVersion,X.productDate,X.location,G.manifest,G.isBuiltin);for(const[z,ee]of x)z===w.default.Error&&(V=!1,this.logService.error(this.formatMessage(X.location,ee)));return G.isValid=V,G.validations=x,G}async scanExtensionManifest(G){const X=(0,u.joinPath)(G,"package.json");let V;try{V=(await this.fileService.readFile(X)).value.toString()}catch(z){return(0,o.toFileOperationResult)(z)!==1&&this.logService.error(this.formatMessage(G,(0,h.localize)(0,null,X.path,z.message))),null}let x;try{x=JSON.parse(V)}catch{const ee=[];(0,D.parse)(V,ee);for(const ne of ee)this.logService.error(this.formatMessage(G,(0,h.localize)(1,null,X.path,ne.offset,ne.length,(0,P.getParseErrorMessage)(ne.error))));return null}return(0,D.getNodeType)(x)!=="object"?(this.logService.error(this.formatMessage(G,(0,h.localize)(2,null,X.path))),null):x}async translateManifest(G,X,V){const x=await this.getLocalizedMessages(G,X,V);if(x)try{const z=[],ee=await this.resolveOriginalMessageBundle(x.default,z);if(z.length>0)return z.forEach(ce=>{this.logService.error(this.formatMessage(G,(0,h.localize)(3,null,x.default?.path,(0,P.getParseErrorMessage)(ce.error))))}),X;if((0,D.getNodeType)(x)!=="object")return this.logService.error(this.formatMessage(G,(0,h.localize)(4,null,x.default?.path))),X;const ne=x.values||Object.create(null);return(0,b.localizeManifest)(X,ne,ee)}catch{}return X}async getLocalizedMessages(G,X,V){const x=(0,u.joinPath)(G,"package.nls.json"),z=(re,U)=>{U.forEach(f=>{this.logService.error(this.formatMessage(G,(0,h.localize)(5,null,re?.path,(0,P.getParseErrorMessage)(f.error))))})},ee=re=>{this.logService.error(this.formatMessage(G,(0,h.localize)(6,null,re?.path)))},ne=`${X.publisher}.${X.name}`,ce=V.translations[ne];if(ce)try{const re=l.URI.file(ce),U=(await this.fileService.readFile(re)).value.toString(),f=[],_=(0,D.parse)(U,f);return f.length>0?(z(re,f),{values:void 0,default:x}):(0,D.getNodeType)(_)!=="object"?(ee(re),{values:void 0,default:x}):{values:_.contents?_.contents.package:void 0,default:x}}catch{return{values:void 0,default:x}}else{if(!await this.fileService.exists(x))return;let U;try{U=await this.findMessageBundles(G,V)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const f=(await this.fileService.readFile(U.localized)).value.toString(),_=[],$=(0,D.parse)(f,_);return _.length>0?(z(U.localized,_),{values:void 0,default:U.original}):(0,D.getNodeType)($)!=="object"?(ee(U.localized),{values:void 0,default:U.original}):{values:$,default:U.original}}catch{return{values:void 0,default:U.original}}}}async resolveOriginalMessageBundle(G,X){if(G)try{const V=(await this.fileService.readFile(G)).value.toString();return(0,D.parse)(V,X)}catch{}}findMessageBundles(G,X){return new Promise((V,x)=>{const z=ee=>{const ne=(0,u.joinPath)(G,`package.nls.${ee}.json`);this.fileService.exists(ne).then(ce=>{ce&&V({localized:ne,original:(0,u.joinPath)(G,"package.nls.json")});const re=ee.lastIndexOf("-");re===-1?V({localized:(0,u.joinPath)(G,"package.nls.json"),original:null}):(ee=ee.substring(0,re),z(ee))})};if(X.devMode||X.pseudo||!X.language)return V({localized:(0,u.joinPath)(G,"package.nls.json"),original:null});z(X.language)})}formatMessage(G,X){return`[${G.path}]: ${X}`}};q=ve([Y(1,p.IExtensionsProfileScannerService),Y(2,d.IUriIdentityService),Y(3,o.IFileService),Y(4,s.ILogService)],q);let j=class extends q{constructor(G,X,V,x,z,ee,ne){super(X,x,z,ee,ne),this.currentProfile=G,this.userDataProfilesService=V,this.cacheValidatorThrottler=this._register(new N.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(G){const X=this.getCacheFile(G),V=await this.readExtensionCache(X);if(this.input=G,V&&V.input&&M.equals(V.input,this.input))return this.logService.debug("Using cached extensions scan result",G.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),V.result.map(z=>(z.location=l.URI.revive(z.location),z));const x=await super.scanExtensions(G);return await this.writeExtensionCache(X,{input:G,result:x}),x}async readExtensionCache(G){try{const X=await this.fileService.readFile(G),V=JSON.parse(X.value.toString());return{result:V.result,input:(0,a.revive)(V.input)}}catch(X){this.logService.debug("Error while reading the extension cache file:",G.path,(0,k.getErrorMessage)(X))}return null}async writeExtensionCache(G,X){try{await this.fileService.writeFile(G,A.VSBuffer.fromString(JSON.stringify(X)))}catch(V){this.logService.debug("Error while writing the extension cache file:",G.path,(0,k.getErrorMessage)(V))}}async validateCache(){if(!this.input)return;const G=this.getCacheFile(this.input),X=await this.readExtensionCache(G);if(!X)return;const V=X.result,x=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!T.equals(x,V))try{this.logService.info("Invalidating Cache",V,x),await this.fileService.del(G),this._onDidChangeCache.fire()}catch(z){this.logService.error(z)}}getCacheFile(G){const X=this.getProfile(G);return this.uriIdentityService.extUri.joinPath(X.cacheHome,G.type===0?R.BUILTIN_MANIFEST_CACHE_FILE:R.USER_MANIFEST_CACHE_FILE)}getProfile(G){return G.type===0?this.userDataProfilesService.defaultProfile:G.profile?this.uriIdentityService.extUri.isEqual(G.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(X=>this.uriIdentityService.extUri.isEqual(G.location,X.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};j=ve([Y(2,m.IUserDataProfilesService),Y(3,p.IExtensionsProfileScannerService),Y(4,d.IUriIdentityService),Y(5,o.IFileService),Y(6,s.ILogService)],j);function B(J,G){const X=(0,E.getExtensionId)(J.manifest.publisher,J.manifest.name);return{id:X,identifier:new R.ExtensionIdentifier(X),isBuiltin:J.type===0,isUserBuiltin:J.type===1&&J.isBuiltin,isUnderDevelopment:G,extensionLocation:J.location,uuid:J.identifier.uuid,targetPlatform:J.targetPlatform,...J.manifest}}e.toExtensionDescription=B;class Q extends F{constructor(G,X,V,x,z,ee,ne,ce,re,U,f,_){super(G,X,(0,u.joinPath)(V,".vscode-oss-dev","extensions","control.json"),x,z,ee,ne,ce,re,U,f,_),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const $=await this.fileService.readFile(l.URI.file(S.translationsConfigFile));return JSON.parse($.value.toString())}catch{}return Object.create(null)})()}getTranslations(G){return this.translationsPromise}}e.NativeExtensionsScannerService=Q}),define(oe[239],ae([0,1,63,6,38,3,2,26,16,31,8,17]),function(te,e,L,N,T,A,k,D,P,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let S=class extends k.Disposable{constructor(g,w){super(),this.userDataProfilesService=g,this.logService=w,this.processesLimiter=new N.Limiter(5)}async postUninstall(g){const w=this.parseScript(g,"uninstall");w&&(this.logService.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(w.script,"uninstall",w.args,!0,g),this.logService.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(c){this.logService.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.logService.error(c)}}));try{await v.Promises.rm(this.getExtensionStoragePath(g))}catch(c){this.logService.error("Error while removing extension storage path",g.identifier.id),this.logService.error(c)}}parseScript(g,w){const c=`vscode:${w}`;if(g.location.scheme===D.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[c]=="string"){const l=g.manifest.scripts[c].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.logService.warn(g.identifier.id,g.manifest.version,`${c} should be a node script`),null):{script:(0,P.join)(g.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}runLifecycleHook(g,w,c,l,h){return new Promise((y,E)=>{const R=this.start(g,w,c,h);let t;const o=n=>{t&&(clearTimeout(t),t=null),n?E(n):y(void 0)};R.on("error",n=>{o((0,T.toErrorMessage)(n)||"Unknown")}),R.on("exit",(n,s)=>{o(n?`post-${w} process exited with code ${n}`:void 0)}),l&&(t=setTimeout(()=>{t=null,R.kill(),E("timed out")},5e3))})}start(g,w,c,l){const h={silent:!0,execArgv:void 0},y=(0,L.fork)(g,[`--type=extension-post-${w}`,...c],h);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const E=A.Event.fromNodeEventEmitter(y.stdout,"data"),R=A.Event.fromNodeEventEmitter(y.stderr,"data");E(n=>this.logService.info(l.identifier.id,l.manifest.version,`post-${w}`,n)),R(n=>this.logService.error(l.identifier.id,l.manifest.version,`post-${w}`,n));const t=A.Event.any(A.Event.map(E,n=>({data:`%c${n}`,format:[""]})),A.Event.map(R,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),y}getExtensionStoragePath(g){return(0,P.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=S,e.ExtensionsLifecycle=S=ve([Y(0,C.IUserDataProfilesService),Y(1,I.ILogService)],S)}),define(oe[240],ae([0,1,8,17,28,20,50,13,15,10]),function(te,e,L,N,T,A,k,D,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let I=class extends k.AbstractExtensionsProfileScannerService{constructor(S,u,g,w,c,l){super(v.URI.file(S.extensionsPath),u,g,w,c,l)}};e.ExtensionsProfileScannerService=I,e.ExtensionsProfileScannerService=I=ve([Y(0,P.INativeEnvironmentService),Y(1,D.IFileService),Y(2,N.IUserDataProfilesService),Y(3,T.IUriIdentityService),Y(4,A.ITelemetryService),Y(5,L.ILogService)],I)}),define(oe[241],ae([0,1,10,15,50,77,13,4,8,24,28,17]),function(te,e,L,N,T,A,k,D,P,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let S=class extends A.NativeExtensionsScannerService{constructor(g,w,c,l,h,y,E,R){super(L.URI.file(h.builtinExtensionsPath),L.URI.file(h.extensionsPath),h.userHome,g.defaultProfile,g,w,c,l,h,y,E,R)}};e.ExtensionsScannerService=S,e.ExtensionsScannerService=S=ve([Y(0,C.IUserDataProfilesService),Y(1,T.IExtensionsProfileScannerService),Y(2,k.IFileService),Y(3,P.ILogService),Y(4,N.INativeEnvironmentService),Y(5,v.IProductService),Y(6,I.IUriIdentityService),Y(7,D.IInstantiationService)],S)}),define(oe[19],ae([0,1,6,3,2,100,11,64,4,17]),function(te,e,L,N,T,A,k,D,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,P.createDecorator)("storageService");var I;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var C;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var S;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(S||(e.StorageTarget=S={}));function u(h){const y=h.get(e.TARGET_KEY);if(y)try{return JSON.parse(y)}catch{}return Object.create(null)}e.loadKeyTargets=u;class g extends T.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(y={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super(),this.options=y,this._onDidChangeValue=this._register(new N.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new N.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new N.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new T.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,T.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,E){const{key:R,external:t}=E;if(R===e.TARGET_KEY){switch(y){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:y})}else this._onDidChangeValue.fire({scope:y,key:R,target:this.getKeyTargets(y)[R],external:t})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,E,R){return this.getStorage(E)?.get(y,R)}getBoolean(y,E,R){return this.getStorage(E)?.getBoolean(y,R)}getNumber(y,E,R){return this.getStorage(E)?.getNumber(y,R)}getObject(y,E,R){return this.getStorage(E)?.getObject(y,R)}storeAll(y,E){this.withPausedEmitters(()=>{for(const R of y)this.store(R.key,R.value,R.scope,R.target,E)})}store(y,E,R,t,o=!1){if((0,k.isUndefinedOrNull)(E)){this.remove(y,R,o);return}this.withPausedEmitters(()=>{this.updateKeyTarget(y,R,t),this.getStorage(R)?.set(y,E,o)})}remove(y,E,R=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(y,E,void 0),this.getStorage(E)?.delete(y,R)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,E){const R=[],t=this.getKeyTargets(y);for(const o of Object.keys(t))t[o]===E&&R.push(o);return R}updateKeyTarget(y,E,R,t=!1){const o=this.getKeyTargets(E);typeof R=="number"?o[y]!==R&&(o[y]=R,this.getStorage(E)?.set(e.TARGET_KEY,JSON.stringify(o),t)):typeof o[y]=="number"&&(delete o[y],this.getStorage(E)?.set(e.TARGET_KEY,JSON.stringify(o),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(y){switch(y){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(y){const E=this.getStorage(y);return E?u(E):Object.create(null)}isNew(y){return this.getBoolean(e.IS_NEW_KEY,y)===!0}async flush(y=I.NONE){this._onWillSaveState.fire({reason:y});const E=this.getStorage(-1),R=this.getStorage(0),t=this.getStorage(1);switch(y){case I.NONE:await L.Promises.settled([E?.whenFlushed()??Promise.resolve(),R?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await L.Promises.settled([E?.flush(0)??Promise.resolve(),R?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const y=this.getStorage(-1)?.items??new Map,E=this.getStorage(0)?.items??new Map,R=this.getStorage(1)?.items??new Map;return l(y,E,R,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(y,E){return this.emitWillSaveState(I.NONE),(0,v.isUserDataProfile)(y)?this.switchToProfile(y,E):this.switchToWorkspace(y,E)}canSwitchProfile(y,E){return!(y.id===E.id||w(E)&&w(y))}switchData(y,E,R){this.withPausedEmitters(()=>{const t=new Set;for(const[o,n]of y)t.add(o),E.get(o)!==n&&this.emitDidChangeValue(R,{key:o,external:!0});for(const[o]of E.items)t.has(o)||this.emitDidChangeValue(R,{key:o,external:!0})})}}e.AbstractStorageService=g;function w(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=w;class c extends g{constructor(){super(),this.applicationStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.profileStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y))),this._register(this.applicationStorage.onDidChangeStorage(y=>this.emitDidChangeValue(-1,y)))}getStorage(y){switch(y){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(y){switch(y){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(y){return!1}}e.InMemoryStorageService=c;async function l(h,y,E,R,t,o){const n=O=>{try{return JSON.parse(O)}catch{return O}},s=new Map,i=new Map;h.forEach((O,F)=>{s.set(F,O),i.set(F,n(O))});const r=new Map,a=new Map;y.forEach((O,F)=>{r.set(F,O),a.set(F,n(O))});const p=new Map,m=new Map;E.forEach((O,F)=>{p.set(F,O),m.set(F,n(O))}),console.group(R!==t?`Storage: Application (path: ${R})`:`Storage: Application & Profile (path: ${R}, default profile)`);const d=[];if(s.forEach((O,F)=>{d.push({key:F,value:O})}),console.table(d),console.groupEnd(),console.log(i),R!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const O=[];r.forEach((F,M)=>{O.push({key:M,value:F})}),console.table(O),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const b=[];p.forEach((O,F)=>{b.push({key:F,value:O})}),console.table(b),console.groupEnd(),console.log(m)}e.logStorage=l}),define(oe[113],ae([0,1,3,2,11,29,33,19]),function(te,e,L,N,T,A,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let P=class extends N.Disposable{constructor(C,S){super(),this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new v(C)),this._register(this.storageManger.onDidChange(u=>this._onDidChangeEnablement.fire({extensions:u,source:"storage"}))),this._register(S.onDidInstallExtensions(u=>u.forEach(({local:g,operation:w})=>{g&&w===4&&this._removeFromDisabledExtensions(g.identifier)})))}async enableExtension(C,S){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:S}),!0):!1}async disableExtension(C,S){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:S}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){const S=this.getDisabledExtensions();return S.every(u=>!(0,k.areSameExtensions)(u,C))?(S.push(C),this._setDisabledExtensions(S),!0):!1}_removeFromDisabledExtensions(C){const S=this.getDisabledExtensions();for(let u=0;u<S.length;u++){const g=S[u];if((0,k.areSameExtensions)(g,C))return S.splice(u,1),this._setDisabledExtensions(S),!0}return!1}_setDisabledExtensions(C){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,S){this.storageManger.set(C,S,0)}};e.GlobalExtensionEnablementService=P,e.GlobalExtensionEnablementService=P=ve([Y(0,D.IStorageService),Y(1,A.IExtensionManagementService)],P);class v extends N.Disposable{constructor(C){super(),this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(S=>this.onDidStorageChange(S)))}get(C,S){let u;return S===0?((0,T.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,S)),u=this.storage[C]):u=this._get(C,S),JSON.parse(u)}set(C,S,u){const g=JSON.stringify(S.map(({id:c,uuid:l})=>({id:c,uuid:l})));this._get(C,u)!==g&&(u===0&&(S.length?this.storage[C]=g:delete this.storage[C]),this._set(C,S.length?g:void 0,u))}onDidStorageChange(C){if(C.scope===0&&!(0,T.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const u=this.get(C.key,C.scope);delete this.storage[C.key];const g=this.get(C.key,C.scope),w=u.filter(l=>!g.some(h=>(0,k.areSameExtensions)(l,h))),c=g.filter(l=>!u.some(h=>(0,k.areSameExtensions)(h,l)));(w.length||c.length)&&this._onDidChange.fire([...w,...c])}}_get(C,S){return this.storageService.get(C,S,"[]")}_set(C,S,u){S?this.storageService.store(C,S,u,1):this.storageService.remove(C,u)}}e.StorageManager=v}),define(oe[242],ae([0,1,21,25,7,5,37,11,10,18,15,29,33,65,13,8,24,57,219,19,20]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const R=A.isWeb?"web":(0,C.getTargetPlatform)(A.platform,k.arch),t="X-Market-Search-Activity-Id";var o;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function n(...U){return String(U.reduce((f,_)=>f|_,0))}var s;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},p={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class m{constructor(f=p){this.state=f}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(f,_=this.state.pageSize){return new m({...this.state,pageNumber:f,pageSize:_})}withFilter(f,..._){const $=[...this.state.criteria,..._.length?_.map(H=>({filterType:f,value:H})):[{filterType:f}]];return new m({...this.state,criteria:$})}withSortBy(f){return new m({...this.state,sortBy:f})}withSortOrder(f){return new m({...this.state,sortOrder:f})}withFlags(...f){return new m({...this.state,flags:f.reduce((_,$)=>_|$,0)})}withAssetTypes(...f){return new m({...this.state,assetTypes:f})}withSource(f){return new m({...this.state,source:f})}get raw(){const{criteria:f,pageNumber:_,pageSize:$,sortBy:H,sortOrder:W,flags:K,assetTypes:Z}=this.state;return{filters:[{criteria:f,pageNumber:_,pageSize:$,sortBy:H,sortOrder:W}],assetTypes:Z,flags:K}}get searchText(){const f=this.state.criteria.filter(_=>_.filterType===s.SearchText)[0];return f&&f.value?f.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(f=>String(f.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function d(U,f){const _=(U||[]).filter($=>$.statisticName===f)[0];return _?_.value:0}function b(U){const f="Microsoft.VisualStudio.Code.Translation.";return U.files.filter($=>$.assetType.indexOf(f)===0).reduce(($,H)=>{const W=M(U,H.assetType);return W&&$.push([H.assetType.substring(f.length),W]),$},[])}function O(U){if(U.properties){const f=U.properties.filter(H=>H.key===i.Repository),_=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),$=f.filter(H=>_.test(H.value))[0];return $?{uri:$.value,fallbackUri:$.value}:null}return M(U,i.Repository)}function F(U){return{uri:`${U.fallbackAssetUri}/${i.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${i.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function M(U,f){return U.files.filter($=>$.assetType===f)[0]?{uri:`${U.assetUri}/${f}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${f}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function q(U,f){const _=U.properties?U.properties.filter(H=>H.key===f):[],$=_.length>0&&_[0].value;return $?$.split(",").map(H=>(0,S.adoptToGalleryExtensionId)(H)):[]}function j(U){const f=U.properties?U.properties.filter(_=>_.key===r.Engine):[];return f.length>0&&f[0].value||""}function B(U){const f=U.properties?U.properties.filter(_=>_.key===r.PreRelease):[];return f.length>0&&f[0].value==="true"}function Q(U){const f=U.properties?U.properties.filter($=>$.key===r.LocalizedLanguages):[],_=f.length>0&&f[0].value||"";return _?_.split(","):[]}function J(U){return U.properties?.find(f=>f.key===r.SponsorLink)?.value}function G(U){return U.indexOf("preview")!==-1}function X(U){return U.targetPlatform?(0,C.toTargetPlatform)(U.targetPlatform):"undefined"}function V(U){const f=(0,L.distinct)(U.versions.map(X)),_=!!U.tags?.includes(C.WEB_EXTENSION_TAG),$=f.indexOf("web");return _?$===-1&&f.push("web"):$!==-1&&f.splice($,1),f}function x(U,f){const _=(0,C.getFallbackTargetPlarforms)(f);for(let $=0;$<U.length;$++){const H=U[$];if(H.version===U[$-1]?.version){let W=$;const K=X(H);if(K===f)for(;W>0&&U[W-1].version===H.version;)W--;else if(_.includes(K))for(;W>0&&U[W-1].version===H.version&&X(U[W-1])!==f;)W--;W!==$&&(U.splice($,1),U.splice(W,0,H))}}return U}e.sortExtensionVersions=x;function z(U,f,_){U.telemetryData={index:f,querySource:_,queryActivityId:U.queryContext?.[t]}}function ee(U,f,_,$){const H=U.versions[0],W={manifest:M(f,i.Manifest),readme:M(f,i.Details),changelog:M(f,i.Changelog),license:M(f,i.License),repository:O(f),download:F(f),icon:M(f,i.Icon),signature:M(f,i.Signature),coreTranslations:b(f)};return{identifier:{id:(0,S.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:f.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(H),description:U.shortDescription||"",installCount:d(U.statistics,"install"),rating:d(U.statistics,"averagerating"),ratingCount:d(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:_,assets:W,properties:{dependencies:q(f,r.Dependency),extensionPack:q(f,r.ExtensionPack),engine:j(f),localizedLanguages:Q(f),targetPlatform:X(f),isPreReleaseVersion:B(f)},hasPreReleaseVersion:B(H),hasReleaseVersion:!0,preview:G(U.flags),isSigned:!!W.signature,queryContext:$}}let ne=class{constructor(f,_,$,H,W,K,Z,se){this.requestService=_,this.logService=$,this.environmentService=H,this.telemetryService=W,this.fileService=K,this.productService=Z,this.configurationService=se;const ue=Z.extensionsGallery,he=ue?.servicePPEUrl&&se.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=he?ue.servicePPEUrl:ue?.serviceUrl,this.extensionsGallerySearchUrl=he?void 0:ue?.searchUrl,this.extensionsControlUrl=ue?.controlUrl,this.commonHeadersPromise=(0,h.resolveMarketplaceHeaders)(Z.version,Z,this.environmentService,this.configurationService,this.fileService,f,this.telemetryService)}api(f=""){return`${this.extensionsGalleryUrl}${f}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(f,_,$){const H=N.CancellationToken.isCancellationToken(_)?{}:_,W=N.CancellationToken.isCancellationToken(_)?_:$,K=[],Z=[],se=[],ue=[];let he=!0;for(const be of f){be.uuid?Z.push(be.uuid):K.push(be.id);const De=!!(be.version||be.preRelease);se.push({id:be.id,uuid:be.uuid,includePreRelease:De}),be.version&&ue.push({id:be.id,uuid:be.uuid,version:be.version}),he=he&&!!be.hasPreRelease&&!De}if(!Z.length&&!K.length)return[];let Se=new m().withPage(1,f.length);Z.length&&(Se=Se.withFilter(s.ExtensionId,...Z)),K.length&&(Se=Se.withFilter(s.ExtensionName,...K)),(H.queryAllVersions||he)&&(Se=Se.withFlags(Se.flags,o.IncludeVersions)),H.source&&(Se=Se.withSource(H.source));const{extensions:Ee}=await this.queryGalleryExtensions(Se,{targetPlatform:H.targetPlatform??R,includePreRelease:se,versions:ue,compatible:!!H.compatible},W);return H.source&&Ee.forEach((be,De)=>z(be,De,H.source)),Ee}async getCompatibleExtension(f,_,$){if((0,C.isNotWebExtensionInWebTargetPlatform)(f.allTargetPlatforms,$))return null;if(await this.isExtensionCompatible(f,_,$))return f;const H=new m().withFlags(o.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,f.identifier.uuid),{extensions:W}=await this.queryGalleryExtensions(H,{targetPlatform:$,compatible:!0,includePreRelease:_},N.CancellationToken.None);return W[0]||null}async isExtensionCompatible(f,_,$){if(!(0,C.isTargetPlatformCompatible)(f.properties.targetPlatform,f.allTargetPlatforms,$)||!_&&f.properties.isPreReleaseVersion)return!1;let H=f.properties.engine;if(!H){const W=await this.getManifest(f,N.CancellationToken.None);if(!W)throw new Error("Manifest was not found");H=W.engines.vscode}return(0,u.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion(f,_,$,H,W){if(!(0,C.isTargetPlatformCompatible)(X(f),H,W)||_!=="any"&&B(f)!==(_==="prerelease"))return!1;if($)try{const K=await this.getEngine(f);if(!(0,u.isEngineValid)(K,this.productService.version,this.productService.date))return!1}catch(K){return this.logService.error(`Error while getting the engine for the version ${f.version}.`,(0,T.getErrorMessage)(K)),!1}return!0}async query(f,_){let $=f.text||"";const H=f.pageSize??50;let W=new m().withPage(1,H);$?($=$.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,Se,Ee)=>(W=W.withFilter(s.Category,Ee||Se),"")),$=$.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,Se,Ee)=>(W=W.withFilter(s.Tag,Ee||Se),"")),$=$.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(s.Featured),"")),$=$.trim(),$&&($=$.length<200?$:$.substring(0,200),W=W.withFilter(s.SearchText,$)),W=W.withSortBy(0)):f.ids?W=W.withFilter(s.ExtensionId,...f.ids):f.names?W=W.withFilter(s.ExtensionName,...f.names):W=W.withSortBy(4),typeof f.sortBy=="number"&&(W=W.withSortBy(f.sortBy)),typeof f.sortOrder=="number"&&(W=W.withSortOrder(f.sortOrder)),f.source&&(W=W.withSource(f.source));const K=async(he,Se)=>{const{extensions:Ee,total:be}=await this.queryGalleryExtensions(he,{targetPlatform:R,compatible:!1,includePreRelease:!!f.includePreRelease},Se);return Ee.forEach((De,_e)=>z(De,(he.pageNumber-1)*he.pageSize+_e,f.source)),{extensions:Ee,total:be}},{extensions:Z,total:se}=await K(W,_),ue=async(he,Se)=>{if(Se.isCancellationRequested)throw new T.CancellationError;const{extensions:Ee}=await K(W.withPage(he+1),Se);return Ee};return{firstPage:Z,total:se,pageSize:W.pageSize,getPage:ue}}async queryGalleryExtensions(f,_,$){const H=f.flags;f.flags&o.IncludeLatestVersionOnly&&f.flags&o.IncludeVersions&&(f=f.withFlags(f.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(f.flags&o.IncludeLatestVersionOnly)&&!(f.flags&o.IncludeVersions)&&(f=f.withFlags(f.flags,o.IncludeLatestVersionOnly)),_.versions?.length&&(f=f.withFlags(f.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),f=f.withFlags(f.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:W,total:K,context:Z}=await this.queryRawGalleryExtensions(f,$);if(!(f.flags&o.IncludeLatestVersionOnly)){const Se=[];for(const Ee of W){const be=await this.toGalleryExtensionWithCriteria(Ee,_,Z);be&&Se.push(be)}return{extensions:Se,total:K}}const ue=[],he=new Map;for(let Se=0;Se<W.length;Se++){const Ee=W[Se],be={id:(0,S.getGalleryExtensionId)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},De=(0,D.isBoolean)(_.includePreRelease)?_.includePreRelease:!!_.includePreRelease.find($e=>(0,S.areSameExtensions)($e,be))?.includePreRelease;if(_.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(V(Ee),_.targetPlatform))continue;const _e=await this.toGalleryExtensionWithCriteria(Ee,_,Z);!_e||_e.properties.isPreReleaseVersion&&(!De||!_e.hasReleaseVersion)||!_e.properties.isPreReleaseVersion&&_e.properties.targetPlatform!==_.targetPlatform&&_e.hasPreReleaseVersion?he.set(Ee.extensionId,Se):ue.push([Se,_e])}if(he.size){const Se=new Date().getTime(),Ee=new m().withFlags(H&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,he.size).withFilter(s.ExtensionId,...he.keys()),{extensions:be}=await this.queryGalleryExtensions(Ee,_,$);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-Se,count:he.size});for(const De of be){const _e=he.get(De.identifier.uuid);ue.push([_e,De])}}return{extensions:ue.sort((Se,Ee)=>Se[0]-Ee[0]).map(([,Se])=>Se),total:K}}async toGalleryExtensionWithCriteria(f,_,$){const H={id:(0,S.getGalleryExtensionId)(f.publisher.publisherName,f.extensionName),uuid:f.extensionId},W=_.versions?.find(ue=>(0,S.areSameExtensions)(ue,H))?.version,K=(0,D.isBoolean)(_.includePreRelease)?_.includePreRelease:!!_.includePreRelease.find(ue=>(0,S.areSameExtensions)(ue,H))?.includePreRelease,Z=V(f),se=x(f.versions,_.targetPlatform);if(_.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(Z,_.targetPlatform))return null;for(let ue=0;ue<se.length;ue++){const he=se[ue];if(!(W&&he.version!==W)){if(await this.isValidVersion(he,K?"any":"release",_.compatible,Z,_.targetPlatform))return ee(f,he,Z,$);if(W&&he.version===W)return null}}return W||_.compatible?null:ee(f,f.versions[0],Z)}async queryRawGalleryExtensions(f,_){if(!this.isEnabled())throw new Error("No extension gallery service configured.");f=f.withFlags(f.flags,o.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(o.Unpublished));const $=await this.commonHeadersPromise,H=JSON.stringify(f.raw),W={...$,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},K=new Date().getTime();let Z,se,ue=0;try{if(Z=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&f.criteria.some(Se=>Se.filterType===s.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:H,headers:W},_),Z.res.statusCode&&Z.res.statusCode>=400&&Z.res.statusCode<500)return{galleryExtensions:[],total:ue};const he=await(0,l.asJson)(Z);if(he){const Se=he.results[0],Ee=Se.extensions,be=Se.resultMetadata&&Se.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return ue=be&&be.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:ue,context:{[t]:Z.res.headers.activityid}}}return{galleryExtensions:[],total:ue}}catch(he){throw se=he,he}finally{this.telemetryService.publicLog2("galleryService:query",{...f.telemetryData,requestBodySize:String(H.length),duration:new Date().getTime()-K,success:!!Z&&(0,l.isSuccess)(Z),responseBodySize:Z?.res.headers["Content-Length"],statusCode:Z?String(Z.res.statusCode):void 0,errorCode:se?(0,T.isCancellationError)(se)?"canceled":(0,T.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(f,_,$,H){if(!this.isEnabled())return;const W=A.isWeb?this.api(`/itemName/${f}.${_}/version/${$}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${f}/extensions/${_}/${$}/stats?statType=${H}`),K=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.commonHeadersPromise,Accept:K};try{await this.requestService.request({type:"POST",url:W,headers:se},N.CancellationToken.None)}catch{}}async download(f,_,$){this.logService.trace("ExtensionGalleryService#download",f.identifier.id);const H=(0,S.getGalleryExtensionTelemetryData)(f),W=new Date().getTime(),K=Se=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:Se}),Z=$===2?"install":$===3?"update":"",se=Z?{uri:`${f.assets.download.uri}${P.URI.parse(f.assets.download.uri).query?"&":"?"}${Z}=true`,fallbackUri:`${f.assets.download.fallbackUri}${P.URI.parse(f.assets.download.fallbackUri).query?"&":"?"}${Z}=true`}:f.assets.download,ue=f.queryContext?.[t]?{[t]:f.queryContext[t]}:void 0,he=await this.getAsset(se,ue?{headers:ue}:void 0);await this.fileService.writeFile(_,he.stream),K(new Date().getTime()-W)}async downloadSignatureArchive(f,_){if(!f.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",f.identifier.id);const $=await this.getAsset(f.assets.signature);await this.fileService.writeFile(_,$.stream)}async getReadme(f,_){if(f.assets.readme){const $=await this.getAsset(f.assets.readme,{},_);return await(0,l.asTextOrError)($)||""}return""}async getManifest(f,_){if(f.assets.manifest){const $=await this.getAsset(f.assets.manifest,{},_),H=await(0,l.asTextOrError)($);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(f,_){const $=M(f,i.Manifest);if(!$)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},W=await this.getAsset($,{headers:H});return await(0,l.asJson)(W)}async getCoreTranslation(f,_){const $=f.assets.coreTranslations.filter(H=>H[0]===_.toUpperCase())[0];if($){const H=await this.getAsset($[1]),W=await(0,l.asTextOrError)(H);return W?JSON.parse(W):null}return null}async getChangelog(f,_){if(f.assets.changelog){const $=await this.getAsset(f.assets.changelog,{},_);return await(0,l.asTextOrError)($)||""}return""}async getAllCompatibleVersions(f,_,$){let H=new m().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);f.identifier.uuid?H=H.withFilter(s.ExtensionId,f.identifier.uuid):H=H.withFilter(s.ExtensionName,f.identifier.id);const{galleryExtensions:W}=await this.queryRawGalleryExtensions(H,N.CancellationToken.None);if(!W.length)return[];const K=V(W[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(K,$))return[];const Z=[];await Promise.all(W[0].versions.map(async he=>{try{await this.isValidVersion(he,_?"any":"release",!0,K,$)&&Z.push(he)}catch{}}));const se=[],ue=new Set;for(const he of x(Z,$))ue.has(he.version)||(ue.add(he.version),se.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:B(he)}));return se}async getAsset(f,_={},$=N.CancellationToken.None){const H=await this.commonHeadersPromise,W={type:"GET"},K={...H,..._.headers||{}};_={..._,...W,headers:K};const Z=f.uri,se=f.fallbackUri,ue={..._,url:Z};try{const he=await this.requestService.request(ue,$);if(he.res.statusCode===200)return he;const Se=await(0,l.asTextOrError)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${Se}`)}catch(he){if((0,T.isCancellationError)(he))throw he;const Se=(0,T.getErrorMessage)(he);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Z,message:Se});const Ee={..._,url:se};return this.requestService.request(Ee,$)}}async getEngine(f){let _=j(f);if(!_){const $=await this.getManifestFromRawExtensionVersion(f,N.CancellationToken.None);if(!$)throw new Error("Manifest was not found");_=$.engines.vscode}return _}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const f=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},N.CancellationToken.None);if(f.res.statusCode!==200)throw new Error("Could not get extensions report.");const _=await(0,l.asJson)(f),$=[],H={},W=[];if(_){for(const K of _.malicious)$.push({id:K});if(_.migrateToPreRelease)for(const[K,Z]of Object.entries(_.migrateToPreRelease))(!Z.engine||(0,u.isEngineValid)(Z.engine,this.productService.version,this.productService.date))&&(H[K.toLowerCase()]={disallowInstall:!0,extension:{id:Z.id,displayName:Z.displayName,autoMigrate:{storage:!!Z.migrateStorage},preRelease:!0}});if(_.deprecated)for(const[K,Z]of Object.entries(_.deprecated))Z&&(H[K.toLowerCase()]=(0,D.isBoolean)(Z)?{}:Z);if(_.search)for(const K of _.search)W.push(K)}return{malicious:$,deprecated:H,search:W}}};ne=ve([Y(1,l.IRequestService),Y(2,w.ILogService),Y(3,I.IEnvironmentService),Y(4,E.ITelemetryService),Y(5,g.IFileService),Y(6,c.IProductService),Y(7,v.IConfigurationService)],ne);let ce=class extends ne{constructor(f,_,$,H,W,K,Z,se){super(f,_,$,H,W,K,Z,se)}};e.ExtensionGalleryService=ce,e.ExtensionGalleryService=ce=ve([Y(0,y.IStorageService),Y(1,l.IRequestService),Y(2,w.ILogService),Y(3,I.IEnvironmentService),Y(4,E.ITelemetryService),Y(5,g.IFileService),Y(6,c.IProductService),Y(7,v.IConfigurationService)],ce);let re=class extends ne{constructor(f,_,$,H,W,K,Z){super(void 0,f,_,$,H,W,K,Z)}};e.ExtensionGalleryServiceWithNoStorageService=re,e.ExtensionGalleryServiceWithNoStorageService=re=ve([Y(0,l.IRequestService),Y(1,w.ILogService),Y(2,I.IEnvironmentService),Y(3,E.ITelemetryService),Y(4,g.IFileService),Y(5,c.IProductService),Y(6,v.IConfigurationService)],re)}),define(oe[78],ae([0,1,4,3,2,19,33,24,21,8,11]),function(te,e,L,N,T,A,k,D,P,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,L.createDecorator)("IExtensionStorageService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let S=class Je extends T.Disposable{static{this.LARGE_STATE_WARNING_THRESHOLD=512*1024}static toKey(g){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(g.id)}@${g.version}`}static fromKey(g){const w=C.exec(g);if(w&&w[1])return{id:w[1],version:w[2]}}static async removeOutdatedExtensionVersions(g,w){const c=await g.getInstalled(),l=[];for(const[h,y]of Je.readAllExtensionsWithKeysForSync(w)){const E=c.find(R=>(0,k.areSameExtensions)(R.identifier,{id:h}))?.manifest.version;for(const R of y)E!==R&&l.push(Je.toKey({id:h,version:R}))}for(const h of l)w.remove(h,0)}static readAllExtensionsWithKeysForSync(g){const w=new Map,c=g.keys(0,1);for(const l of c){const h=Je.fromKey(l);if(h){let y=w.get(h.id.toLowerCase());y||w.set(h.id.toLowerCase(),y=[]),y.push(h.version)}}return w}constructor(g,w,c){super(),this.storageService=g,this.productService=w,this.logService=c,this._onDidChangeExtensionStorageToSync=this._register(new N.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Je.readAllExtensionsWithKeysForSync(g),this._register(this.storageService.onDidChangeValue(l=>this.onDidChangeStorageValue(l)))}onDidChangeStorageValue(g){if(g.scope!==0)return;if(this.extensionsWithKeysForSync.has(g.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const w=Je.fromKey(g.key);if(w){if(this.storageService.get(g.key,0)===void 0)this.extensionsWithKeysForSync.delete(w.id.toLowerCase());else{let c=this.extensionsWithKeysForSync.get(w.id.toLowerCase());c||this.extensionsWithKeysForSync.set(w.id.toLowerCase(),c=[]),c.push(w.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(g){if((0,I.isString)(g))return g;const w=g.manifest?g.manifest.publisher:g.publisher,c=g.manifest?g.manifest.name:g.name;return(0,k.getExtensionId)(w,c)}getExtensionState(g,w){const c=this.getExtensionId(g),l=this.getExtensionStateRaw(g,w);if(l)try{return JSON.parse(l)}catch(h){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${c}, global: ${w}): ${h}`)}}getExtensionStateRaw(g,w){const c=this.getExtensionId(g),l=this.storageService.get(c,w?0:1);return l&&l?.length>Je.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${c}, global: ${w}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState(g,w,c){const l=this.getExtensionId(g);w===void 0?this.storageService.remove(l,c?0:1):this.storageService.store(l,JSON.stringify(w),c?0:1,1)}setKeysForSync(g,w){this.storageService.store(Je.toKey(g),JSON.stringify(w),0,1)}getKeysForSync(g){const w=this.productService.extensionSyncedKeys?.[g.id.toLowerCase()],c=this.storageService.get(Je.toKey(g),0),l=c?JSON.parse(c):void 0;return l&&w?(0,P.distinct)([...l,...w]):l||w}addToMigrationList(g,w){if(g!==w){const c=this.migrationList.filter(l=>!l.includes(g)&&!l.includes(w));c.push([g,w]),this.migrationList=c}}getSourceExtensionToMigrate(g){const w=this.migrationList.find(([,c])=>g===c);return w?w[0]:void 0}get migrationList(){const g=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const w=JSON.parse(g);if(Array.isArray(w))return w}catch{}return[]}set migrationList(g){g.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(g),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};e.ExtensionStorageService=S,e.ExtensionStorageService=S=ve([Y(0,A.IStorageService),Y(1,D.IProductService),Y(2,v.ILogService)],S)}),define(oe[243],ae([0,1,29,13,24,15,98,55,19,20,216]),function(te,e,L,N,T,A,k,D,P,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let C=class extends I.AbstractNativeExtensionTipsService{constructor(u,g,w,c,l,h,y,E){super(u.userHome,l,g,w,c,h,y,E)}};e.ExtensionTipsService=C,e.ExtensionTipsService=C=ve([Y(0,A.INativeEnvironmentService),Y(1,v.ITelemetryService),Y(2,L.IExtensionManagementService),Y(3,P.IStorageService),Y(4,D.INativeHostService),Y(5,k.IExtensionRecommendationNotificationService),Y(6,N.IFileService),Y(7,T.IProductService)],C)}),define(oe[244],ae([0,1,105,3,20,15,2,8,16,63,24,5,6,101,18,161,36,19,11,129]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const E=[L.CONFIGURATION_KEY_HOST_NAME,L.CONFIGURATION_KEY_PREVENT_SLEEP],R="remoteTunnelSession",t="remoteTunnelIsService";let o=class extends k.Disposable{constructor(r,a,p,m,d,b,O){super(),this.telemetryService=r,this.productService=a,this.environmentService=p,this.configurationService=b,this.storageService=O,this._onDidTokenFailedEmitter=new N.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new N.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeModeEmitter=new N.Emitter,this.onDidChangeMode=this._onDidChangeModeEmitter.event,this._mode=L.INACTIVE_TUNNEL_MODE,this._initialized=!1,this.defaultOnOutput=(F,M)=>{M?this._logger.error(F):this._logger.info(F)},this._logger=this._register(m.createLogger(L.LOG_ID,{name:L.LOGGER_NAME})),this._startTunnelProcessDelayer=new S.Delayer(100),this._register(this._logger.onDidChangeLogLevel(F=>this._logger.info("Log level changed to "+(0,D.LogLevelToString)(F)))),this._register(d.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(b.onDidChangeConfiguration(F=>{E.some(M=>F.affectsConfiguration(M))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())})),this._mode=this._restoreMode(),this._tunnelStatus=L.TunnelStates.uninitialized}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(r){this._tunnelStatus=r,this._onDidChangeTunnelStatusEmitter.fire(r)}setMode(r){s(this._mode,r)||(this._mode=r,this._storeMode(r),this._onDidChangeModeEmitter.fire(this._mode),r.active?(this._logger.info(`Session updated: ${r.session.accountLabel} (${r.session.providerId}) (service=${r.asService})`),r.session.token&&this._logger.info(`Session token updated: ${r.session.accountLabel} (${r.session.providerId})`)):this._logger.info("Session reset"))}getMode(){return Promise.resolve(this._mode)}async initialize(r){if(this._initialized)return this._tunnelStatus;this._initialized=!0,this.setMode(r);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(a){this._logger.error(a)}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let r;C.isMacintosh?r=this.environmentService.appRoot:r=(0,P.dirname)((0,P.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,P.join)(r,"bin",`${this.productService.tunnelApplicationName}${C.isWindows?".exe":""}`)}return this._tunnelCommand}async startTunnel(r){if(s(this._mode,r)&&this._tunnelStatus.type!=="disconnected")return this._tunnelStatus;this.setMode(r);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(a){this._logger.error(a)}return this._tunnelStatus}async stopTunnel(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),!this._mode.active)return;const r=this._mode.asService;this.setMode(L.INACTIVE_TUNNEL_MODE);try{r&&this.runCodeTunnelCommand("uninstallService",["service","uninstall"])}catch(a){this._logger.error(a)}try{await this.runCodeTunnelCommand("stop",["kill"])}catch(a){this._logger.error(a)}this.setTunnelStatus(L.TunnelStates.disconnected())}async updateTunnelProcess(){this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:this._mode.active,service:this._mode.active&&this._mode.asService}),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);let r="",a=!1;const p=(M,q)=>{q?this._logger.error(M):r+=M,!this.environmentService.isBuilt&&M.startsWith("   Compiling")&&this.setTunnelStatus(L.TunnelStates.connecting((0,w.localize)(0,null)))},m=this.runCodeTunnelCommand("status",["status"],p);this._tunnelProcess=m;try{if(await m,this._tunnelProcess!==m)return;const M=JSON.parse(r.trim().split(`
`).find(q=>q.startsWith("{")));if(a=M.service_installed,this._logger.info(M.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!M.tunnel&&!this._mode.active){this.setTunnelStatus(L.TunnelStates.disconnected());return}}catch(M){this._logger.error(M),this.setTunnelStatus(L.TunnelStates.disconnected());return}finally{this._tunnelProcess===m&&(this._tunnelProcess=void 0)}const d=this._mode.active?this._mode.session:void 0;if(d&&d.token){const M=d.token;this.setTunnelStatus(L.TunnelStates.connecting((0,w.localize)(1,null,d.accountLabel,d.providerId)));const q=(B,Q)=>{B=B.replaceAll(M,"*".repeat(4)),p(B,Q)},j=this.runCodeTunnelCommand("login",["user","login","--provider",d.providerId,"--access-token",M,"--log",(0,D.LogLevelToString)(this._logger.getLevel())],q);this._tunnelProcess=j;try{if(await j,this._tunnelProcess!==j)return}catch(B){this._logger.error(B),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(d),this.setTunnelStatus(L.TunnelStates.disconnected(d));return}}const b=this._getTunnelName();b?this.setTunnelStatus(L.TunnelStates.connecting((0,w.localize)(2,null,b))):this.setTunnelStatus(L.TunnelStates.connecting((0,w.localize)(3,null)));const O=["--accept-server-license-terms","--log",(0,D.LogLevelToString)(this._logger.getLevel())];b?O.push("--name",b):O.push("--random-name");let F=!1;return this._mode.active&&this._mode.asService&&!a&&(F=await this.installTunnelService(O)===!1),this.serverOrAttachTunnel(d,O,F)}async installTunnelService(r){let a;try{a=await this.runCodeTunnelCommand("serviceInstall",["service","install",...r])}catch(p){this._logger.error(p),a=1}if(a!==0){const p=(0,w.localize)(4,null);return this._logger.warn(p),this.setTunnelStatus(L.TunnelStates.connecting(p)),!1}return!0}async serverOrAttachTunnel(r,a,p){a.push("--parent-process-id",String(process.pid)),this._preventSleep()&&a.push("--no-sleep");let m=!1;const d=this.runCodeTunnelCommand("tunnel",a,(b,O)=>{O?this._logger.error(b):this._logger.info(b),b.includes("Connected to an existing tunnel process")&&(m=!0);const F=b.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const M={link:F[1],domain:F[2],tunnelName:F[4],isAttached:m};this.setTunnelStatus(L.TunnelStates.connected(M,p))}else b.match(/error refreshing token/)&&(d.cancel(),this._onDidTokenFailedEmitter.fire(r),this.setTunnelStatus(L.TunnelStates.disconnected(r)))});this._tunnelProcess=d,d.finally(()=>{d===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._mode=L.INACTIVE_TUNNEL_MODE,this.setTunnelStatus(L.TunnelStates.disconnected()))})}runCodeTunnelCommand(r,a,p=this.defaultOnOutput){return(0,S.createCancelablePromise)(m=>new Promise((d,b)=>{m.isCancellationRequested&&d(-1);let O;const F=["ignore","pipe","pipe"];if(m.onCancellationRequested(()=>{O&&(this._logger.info(`${r} terminating(${O.pid})`),O.kill())}),!this.environmentService.isBuilt)p(`Building tunnel CLI from sources and run
`,!1),p(`${r} Spawning: cargo run -- tunnel ${a.join(" ")}
`,!1),O=(0,v.spawn)("cargo",["run","--","tunnel",...a],{cwd:(0,P.join)(this.environmentService.appRoot,"cli"),stdio:F});else{p(`Running tunnel CLI
`,!1);const M=this.getTunnelCommandLocation();p(`${r} Spawning: ${M} tunnel ${a.join(" ")}
`,!1),O=(0,v.spawn)(M,["tunnel",...a],{cwd:(0,c.homedir)(),stdio:F})}O.stdout.pipe(new y.StreamSplitter(`
`)).on("data",M=>{if(O){const q=M.toString();p(q,!1)}}),O.stderr.pipe(new y.StreamSplitter(`
`)).on("data",M=>{if(O){const q=M.toString();p(q,!0)}}),O.on("exit",M=>{O&&(p(`${r} exit(${O.pid}): + ${M} `,!1),O=void 0,d(M||0))}),O.on("error",M=>{O&&(p(`${r} error(${O.pid}): + ${M} `,!0),O=void 0,b())})}))}async getTunnelName(){return this._getTunnelName()}_preventSleep(){return!!this.configurationService.getValue(L.CONFIGURATION_KEY_PREVENT_SLEEP)}_getTunnelName(){let r=this.configurationService.getValue(L.CONFIGURATION_KEY_HOST_NAME)||(0,c.hostname)();return r=r.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),r||void 0}_restoreMode(){try{const r=this.storageService.get(R,-1),a=this.storageService.getBoolean(t,-1,!1);if(r){const p=JSON.parse(r);if(p&&(0,h.isString)(p.accountLabel)&&(0,h.isString)(p.sessionId)&&(0,h.isString)(p.providerId))return{active:!0,session:p,asService:a};this._logger.error("Problems restoring session from storage, invalid format",p)}}catch(r){this._logger.error("Problems restoring session from storage",r)}return L.INACTIVE_TUNNEL_MODE}_storeMode(r){if(r.active){const a={providerId:r.session.providerId,sessionId:r.session.sessionId,accountLabel:r.session.accountLabel};this.storageService.store(R,JSON.stringify(a),-1,1),this.storageService.store(t,r.asService,-1,1)}else this.storageService.remove(R,-1),this.storageService.remove(t,-1)}};e.RemoteTunnelService=o,e.RemoteTunnelService=o=ve([Y(0,T.ITelemetryService),Y(1,I.IProductService),Y(2,A.INativeEnvironmentService),Y(3,D.ILoggerService),Y(4,u.ISharedProcessLifecycleService),Y(5,g.IConfigurationService),Y(6,l.IStorageService)],o);function n(i,r){return i&&r?i.sessionId===r.sessionId&&i.providerId===r.providerId&&i.token===r.token:i===r}const s=(i,r)=>i.active!==r.active?!1:i.active&&r.active?i.asService===r.asService&&n(i.session,r.session):!0}),define(oe[245],ae([0,1,6,2,22,64,19,73,17]),function(te,e,L,N,T,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class v extends k.AbstractStorageService{constructor(C,S,u,g){super(),this.initialWorkspace=C,this.initialProfiles=S,this.remoteService=u,this.environmentService=g,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new N.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new N.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const C=this._register(new D.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),S=this._register(new A.Storage(C));return this._register(S.onDidChangeStorage(u=>this.emitDidChangeValue(-1,u))),S}createProfileStorage(C){this.profileStorageDisposables.clear(),this.profileStorageProfile=C;let S;if((0,k.isProfileUsingDefaultStorage)(C))S=this.applicationStorage;else{const u=this.profileStorageDisposables.add(new D.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),C));S=this.profileStorageDisposables.add(new A.Storage(u))}return this.profileStorageDisposables.add(S.onDidChangeStorage(u=>this.emitDidChangeValue(0,u))),S}createWorkspaceStorage(C){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=C?.id;let S;if(C){const u=this.workspaceStorageDisposables.add(new D.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),C));S=this.workspaceStorageDisposables.add(new A.Storage(u)),this.workspaceStorageDisposables.add(S.onDidChangeStorage(g=>this.emitDidChangeValue(1,g)))}return S}async doInitialize(){await L.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(C){switch(C){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(C){switch(C){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(k.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(C){if(!this.canSwitchProfile(this.profileStorageProfile,C))return;const S=this.profileStorage,u=S.items;S!==this.applicationStorage&&await S.close(),this.profileStorage=this.createProfileStorage(C),await this.profileStorage.init(),this.switchData(u,this.profileStorage,0)}async switchToWorkspace(C,S){const u=this.workspaceStorage,g=u?.items??new Map;await u?.close(),this.workspaceStorage=this.createWorkspaceStorage(C),await this.workspaceStorage.init(),this.switchData(g,this.workspaceStorage,1)}hasScope(C){return(0,P.isUserDataProfile)(C)?this.profileStorageProfile.id===C.id:this.workspaceStorageId===C.id}}e.RemoteStorageService=v}),define(oe[246],ae([0,1,3,2,17,91]),function(te,e,L,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class k{constructor(v,I){this.service=v,this.getUriTransformer=I}listen(v,I){const C=this.getUriTransformer(v);switch(I){case"onDidChangeProfiles":return L.Event.map(this.service.onDidChangeProfiles,S=>({all:S.all.map(u=>(0,A.transformOutgoingURIs)({...u},C)),added:S.added.map(u=>(0,A.transformOutgoingURIs)({...u},C)),removed:S.removed.map(u=>(0,A.transformOutgoingURIs)({...u},C)),updated:S.updated.map(u=>(0,A.transformOutgoingURIs)({...u},C))}))}throw new Error(`Invalid listen ${I}`)}async call(v,I,C){const S=this.getUriTransformer(v);switch(I){case"createProfile":{const u=await this.service.createProfile(C[0],C[1],C[2]);return(0,A.transformOutgoingURIs)({...u},S)}case"updateProfile":{let u=(0,T.reviveProfile)((0,A.transformIncomingURIs)(C[0],S),this.service.profilesHome.scheme);return u=await this.service.updateProfile(u,C[1]),(0,A.transformOutgoingURIs)({...u},S)}case"removeProfile":{const u=(0,T.reviveProfile)((0,A.transformIncomingURIs)(C[0],S),this.service.profilesHome.scheme);return this.service.removeProfile(u)}}throw new Error(`Invalid call ${I}`)}}e.RemoteUserDataProfilesServiceChannel=k;class D extends N.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(v,I,C){super(),this.profilesHome=I,this.channel=C,this._profiles=[],this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=v.map(S=>(0,T.reviveProfile)(S,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(S=>{const u=S.added.map(c=>(0,T.reviveProfile)(c,this.profilesHome.scheme)),g=S.removed.map(c=>(0,T.reviveProfile)(c,this.profilesHome.scheme)),w=S.updated.map(c=>(0,T.reviveProfile)(c,this.profilesHome.scheme));this._profiles=S.all.map(c=>(0,T.reviveProfile)(c,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:u,removed:g,updated:w,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(v){this.enabled=v}isEnabled(){return this.enabled}async createNamedProfile(v,I,C){const S=await this.channel.call("createNamedProfile",[v,I,C]);return(0,T.reviveProfile)(S,this.profilesHome.scheme)}async createProfile(v,I,C,S){const u=await this.channel.call("createProfile",[v,I,C,S]);return(0,T.reviveProfile)(u,this.profilesHome.scheme)}async createTransientProfile(v){const I=await this.channel.call("createTransientProfile",[v]);return(0,T.reviveProfile)(I,this.profilesHome.scheme)}async setProfileForWorkspace(v,I){await this.channel.call("setProfileForWorkspace",[v,I])}removeProfile(v){return this.channel.call("removeProfile",[v])}async updateProfile(v,I){const C=await this.channel.call("updateProfile",[v,I]);return(0,T.reviveProfile)(C,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=D}),define(oe[58],ae([0,1,2,64,4,19,3,73,17]),function(te,e,L,N,T,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,T.createDecorator)("IUserDataProfileStorageService");let v=class extends L.Disposable{constructor(u){super(),this.storageService=u}async readStorageData(u){return this.withProfileScopedStorageService(u,async g=>this.getItems(g))}async updateStorageData(u,g,w){return this.withProfileScopedStorageService(u,async c=>this.writeItems(c,g,w))}async withProfileScopedStorageService(u,g){if(this.storageService.hasScope(u))return g(this.storageService);const w=await this.createStorageDatabase(u),c=new C(w);try{await c.initialize();const l=await g(c);return await c.flush(),l}finally{c.dispose(),await this.closeAndDispose(w)}}getItems(u){const g=new Map,w=c=>{for(const l of u.keys(0,c))g.set(l,{value:u.get(l,0),target:c})};return w(0),w(1),g}writeItems(u,g,w){u.storeAll(Array.from(g.entries()).map(([c,l])=>({key:c,value:l,scope:0,target:w})),!0)}async closeAndDispose(u){try{await u.close()}finally{(0,L.isDisposable)(u)&&u.dispose()}}};e.AbstractUserDataProfileStorageService=v,e.AbstractUserDataProfileStorageService=v=ve([Y(0,A.IStorageService)],v);class I extends v{constructor(u,g,w,c){super(w),this.remoteService=u;const l=u.getChannel("profileStorageListener"),h=this._register(new L.MutableDisposable);this._onDidChange=this._register(new k.Emitter({onWillAddFirstListener:()=>{h.value=l.listen("onDidChange")(y=>{c.trace("profile storage changes",y),this._onDidChange.fire({targetChanges:y.targetChanges.map(E=>(0,P.reviveProfile)(E,g.profilesHome.scheme)),valueChanges:y.valueChanges.map(E=>({...E,profile:(0,P.reviveProfile)(E.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>h.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(u){const g=this.remoteService.getChannel("storage");return(0,A.isProfileUsingDefaultStorage)(u)?new D.ApplicationStorageDatabaseClient(g):new D.ProfileStorageDatabaseClient(g,u)}}e.RemoteUserDataProfileStorageService=I;class C extends A.AbstractStorageService{constructor(u){super({flushInterval:100}),this.profileStorage=this._register(new N.Storage(u))}doInitialize(){return this.profileStorage.init()}getStorage(u){return u===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(oe[247],ae([0,1,19,8,17,69,58]),function(te,e,L,N,T,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let D=class extends k.RemoteUserDataProfileStorageService{constructor(v,I,C,S){super(v,I,C,S)}};e.NativeUserDataProfileStorageService=D,e.NativeUserDataProfileStorageService=D=ve([Y(0,A.IMainProcessService),Y(1,T.IUserDataProfilesService),Y(2,L.IStorageService),Y(3,N.ILogService)],D)}),define(oe[39],ae([0,1,21,6,14,25,3,34,2,27,11,166,18,15,13,8,44,19,20,28,23,17]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h,y,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function t(p){return!!(p&&p.ref!==void 0&&typeof p.ref=="string"&&p.ref!==""&&p.syncData!==void 0&&(p.syncData===null||o(p.syncData)))}e.isRemoteUserData=t;function o(p){return!!(p&&p.version!==void 0&&typeof p.version=="number"&&p.content!==void 0&&typeof p.content=="string"&&(Object.keys(p).length===2||Object.keys(p).length===3&&p.machineId!==void 0&&typeof p.machineId=="string"))}e.isSyncData=o;function n(p,m){return`${(0,v.uppercaseFirstLetter)(p)}${m.isDefault?"":` (${m.name})`}`}e.getSyncResourceLogLabel=n;let s=class extends P.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(m,d,b,O,F,M,q,j,B,Q,J,G){super(),this.syncResource=m,this.collection=d,this.fileService=b,this.environmentService=O,this.storageService=F,this.userDataSyncStoreService=M,this.userDataSyncBackupStoreService=q,this.userDataSyncEnablementService=j,this.telemetryService=B,this.logService=Q,this.configurationService=J,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new N.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=n(m.syncResource,m.profile),this.extUri=G.extUri,this.syncFolder=this.extUri.joinPath(O.userDataSyncHome,...(0,E.getPathSegments)(m.profile.isDefault?void 0:m.profile.id,m.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,E.PREVIEW_DIR_NAME),this.lastSyncResource=(0,E.getLastSyncResourceUri)(m.profile.isDefault?void 0:m.profile.id,m.syncResource,O,this.extUri),this.currentMachineIdPromise=(0,c.getServiceMachineId)(O,b,F)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const m=await this.syncPreviewPromise;this.syncPreviewPromise=null;const d=await this.performSync(m.remoteUserData,m.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(d)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const m=await this.getLastSyncUserData();(m?await this.hasRemoteChanged(m):!0)&&this._onDidChangeLocal.fire()}}setStatus(m){this._status!==m&&(this._status=m,this._onDidChangStatus.fire(m))}async sync(m,d={}){await this._sync(m,!0,this.getUserDataSyncConfiguration(),d)}async preview(m,d,b={}){return this._sync(m,!1,d,b)}async apply(m,d={}){try{this.syncHeaders={...d};const b=await this.doApply(m);return this.setStatus(b),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(m,d,b,O){try{if(this.syncHeaders={...O},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let F="idle";try{const M=await this.getLastSyncUserData(),q=await this.getLatestRemoteUserData(m,M);return F=await this.performSync(q,M,d,b),F==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(F)}}finally{this.syncHeaders={}}}async replace(m){const d=this.parseSyncData(m);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const b=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(null,b),F=await this.isRemoteDataFromCurrentMachine(O),M=await this.generateSyncPreview({ref:O.ref,syncData:d},b,F,this.getUserDataSyncConfiguration(),A.CancellationToken.None),q=[];for(const j of M){const B=await this.getAcceptResult(j,j.remoteResource,void 0,A.CancellationToken.None),{remoteChange:Q}=await this.getAcceptResult(j,j.previewResource,j.remoteContent,A.CancellationToken.None);q.push([j,{...B,remoteChange:Q!==0?Q:2}])}await this.applyResult(O,b,q,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(m){const d=await this.currentMachineIdPromise;return!!m.syncData?.machineId&&m.syncData.machineId===d}async getLatestRemoteUserData(m,d){if(d){const b=m?m[this.resource]:void 0;if(d.ref===b||b===void 0&&d.syncData===null)return d}return this.getRemoteUserData(d)}async performSync(m,d,b,O){if(m.syncData&&m.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new E.UserDataSyncError((0,C.localize)(0,null,this.resource,this.version,m.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(m,d,b,O)}catch(F){if(F instanceof E.UserDataSyncError)switch(F.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(m,d,b,O);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),m=await this.getRemoteUserData(null),d=await this.getLastSyncUserData(),this.performSync(m,d,b,O)}throw F}}async doSync(m,d,b,O){try{const F=await this.isRemoteDataFromCurrentMachine(m),M=!F&&d===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,q=b&&!M;this.syncPreviewPromise||(this.syncPreviewPromise=(0,N.createCancelablePromise)(B=>this.doGenerateSyncResourcePreview(m,d,F,q,O,B)));let j=await this.syncPreviewPromise;if(b&&M){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const B of j.resourcePreviews)j=await this.accept(B.remoteResource)||j}return this.updateConflicts(j.resourcePreviews),j.resourcePreviews.some(({mergeState:B})=>B==="conflict")?"hasConflicts":b?await this.doApply(!1):"syncing"}catch(F){throw this.syncPreviewPromise=null,F}}async merge(m){return await this.updateSyncResourcePreview(m,async d=>{const b=await this.getMergeResult(d,A.CancellationToken.None);await this.fileService.writeFile(d.previewResource,T.VSBuffer.fromString(b?.content||""));const O=b&&!b.hasConflicts?await this.getAcceptResult(d,d.previewResource,void 0,A.CancellationToken.None):void 0;return d.acceptResult=O,d.mergeState=b.hasConflicts?"conflict":O?"accepted":"preview",d.localChange=O?O.localChange:b.localChange,d.remoteChange=O?O.remoteChange:b.remoteChange,d}),this.syncPreviewPromise}async accept(m,d){return await this.updateSyncResourcePreview(m,async b=>{const O=await this.getAcceptResult(b,m,d,A.CancellationToken.None);return b.acceptResult=O,b.mergeState="accepted",b.localChange=O.localChange,b.remoteChange=O.remoteChange,b}),this.syncPreviewPromise}async discard(m){return await this.updateSyncResourcePreview(m,async d=>{const b=await this.getMergeResult(d,A.CancellationToken.None);return await this.fileService.writeFile(d.previewResource,T.VSBuffer.fromString(b.content||"")),d.acceptResult=void 0,d.mergeState="preview",d.localChange=b.localChange,d.remoteChange=b.remoteChange,d}),this.syncPreviewPromise}async updateSyncResourcePreview(m,d){if(!this.syncPreviewPromise)return;let b=await this.syncPreviewPromise;const O=b.resourcePreviews.findIndex(({localResource:F,remoteResource:M,previewResource:q})=>this.extUri.isEqual(F,m)||this.extUri.isEqual(M,m)||this.extUri.isEqual(q,m));O!==-1&&(this.syncPreviewPromise=(0,N.createCancelablePromise)(async F=>{const M=[...b.resourcePreviews];return M[O]=await d(M[O]),{...b,resourcePreviews:M}}),b=await this.syncPreviewPromise,this.updateConflicts(b.resourcePreviews),b.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(m){if(!this.syncPreviewPromise)return"idle";const d=await this.syncPreviewPromise;return d.resourcePreviews.some(({mergeState:b})=>b==="conflict")?"hasConflicts":d.resourcePreviews.some(({mergeState:b})=>b!=="accepted")?"syncing":(await this.applyResult(d.remoteUserData,d.lastSyncUserData,d.resourcePreviews.map(b=>[b,b.acceptResult]),m),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(m){const d=m.filter(({mergeState:b})=>b==="conflict");(0,L.equals)(this._conflicts,d,(b,O)=>this.extUri.isEqual(b.previewResource,O.previewResource))||(this._conflicts=d,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const m=await this.getLastSyncUserData();return!!m&&m.syncData!==null}async resolvePreviewContent(m){const d=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(d)for(const b of d.resourcePreviews){if(this.extUri.isEqual(b.acceptedResource,m))return b.acceptResult?b.acceptResult.content:null;if(this.extUri.isEqual(b.remoteResource,m))return b.remoteContent;if(this.extUri.isEqual(b.localResource,m))return b.localContent;if(this.extUri.isEqual(b.baseResource,m))return b.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,-1);try{await this.fileService.del(this.lastSyncResource)}catch(m){(0,g.toFileOperationResult)(m)!==1&&this.logService.error(m)}}async doGenerateSyncResourcePreview(m,d,b,O,F,M){const q=await this.generateSyncPreview(m,d,b,F,M),j=[];for(const B of q){const Q=B.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(B.localChange===0&&B.remoteChange===0)j.push({...B,acceptedResource:Q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const J=O?await this.getMergeResult(B,M):void 0;if(M.isCancellationRequested)break;await this.fileService.writeFile(B.previewResource,T.VSBuffer.fromString(J?.content||""));const G=J&&!J.hasConflicts?await this.getAcceptResult(B,B.previewResource,void 0,M):void 0;j.push({...B,acceptResult:G,mergeState:J?.hasConflicts?"conflict":G?"accepted":"preview",localChange:G?G.localChange:J?J.localChange:B.localChange,remoteChange:G?G.remoteChange:J?J.remoteChange:B.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:m,lastSyncUserData:d,resourcePreviews:j,isLastSyncFromCurrentMachine:b}}async getLastSyncUserData(){let m=this.getStoredLastSyncUserDataStateContent();if(m||(m=await this.migrateLastSyncUserData()),!m)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const d=JSON.parse(m),b=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!d.version&&!!b&&d.version!==b,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${d.version} is not compatible with current sync state version ${b}.`),await this.resetLocal(),null;let O,F=1;for(;O===void 0&&F++<6;)try{const M=await this.readLastSyncStoredRemoteUserData();M&&(M.ref===d.ref?O=M.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof g.FileOperationError&&M.fileOperationResult===1){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(M instanceof E.UserDataSyncError)throw M;this.logService.error(M,F)}}if(O===void 0)try{const M=await this.userDataSyncStoreService.resolveResourceContent(this.resource,d.ref,this.collection,this.syncHeaders);O=M===null?null:this.parseSyncData(M),await this.writeLastSyncStoredRemoteUserData({ref:d.ref,syncData:O})}catch(M){if(M instanceof E.UserDataSyncError&&M.code==="NotFound")this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw M}return O===void 0?null:{...d,syncData:O}}async updateLastSyncUserData(m,d={}){if(d.ref||d.version)throw new Error("Cannot have core properties as additional");const b=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),O={ref:m.ref,version:b,...d};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(O),-1,1),await this.writeLastSyncStoredRemoteUserData(m)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async readLastSyncStoredRemoteUserData(){const m=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const d=m?JSON.parse(m):void 0;if(t(d))return d}catch(d){this.logService.error(d)}}async writeLastSyncStoredRemoteUserData(m){await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(m)))}async migrateLastSyncUserData(){try{const m=await this.fileService.readFile(this.lastSyncResource),d=JSON.parse(m.value.toString());await this.fileService.del(this.lastSyncResource),d.ref&&d.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...d,content:void 0}),-1,1),await this.writeLastSyncStoredRemoteUserData({ref:d.ref,syncData:d.content===null?null:JSON.parse(d.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,d)}catch(m){m instanceof g.FileOperationError&&m.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(m)}return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async getRemoteUserData(m){const{ref:d,content:b}=await this.getUserData(m);let O=null;return b!==null&&(O=this.parseSyncData(b)),{ref:d,syncData:O}}parseSyncData(m){try{const d=JSON.parse(m);if(o(d))return d}catch(d){this.logService.error(d)}throw new E.UserDataSyncError((0,C.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(m){const d=m?{ref:m.ref,content:m.syncData?JSON.stringify(m.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,d,this.collection,this.syncHeaders)}async updateRemoteUserData(m,d){const b=await this.currentMachineIdPromise,O={version:this.version,machineId:b,content:m};try{return d=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(O),d,this.collection,this.syncHeaders),{ref:d,syncData:O}}catch(F){throw F instanceof E.UserDataSyncError&&F.code==="TooLarge"&&(F=new E.UserDataSyncError(F.message,F.code,this.resource)),F}}async backupLocal(m){const d={version:this.version,content:m};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(d))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(E.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=s,e.AbstractSynchroniser=s=ve([Y(2,g.IFileService),Y(3,u.IEnvironmentService),Y(4,l.IStorageService),Y(5,E.IUserDataSyncStoreService),Y(6,E.IUserDataSyncBackupStoreService),Y(7,E.IUserDataSyncEnablementService),Y(8,h.ITelemetryService),Y(9,E.IUserDataSyncLogService),Y(10,S.IConfigurationService),Y(11,y.IUriIdentityService)],s);let i=class extends s{constructor(m,d,b,O,F,M,q,j,B,Q,J,G,X){super(d,b,O,F,M,q,j,B,Q,J,G,X),this.file=m,this._register(this.fileService.watch(this.extUri.dirname(m))),this._register(this.fileService.onDidFilesChange(V=>this.onFileChanges(V)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(m,d,b){try{d?await this.fileService.writeFile(this.file,T.VSBuffer.fromString(m),b?void 0:d):await this.fileService.createFile(this.file,T.VSBuffer.fromString(m),{overwrite:b})}catch(O){throw O instanceof g.FileOperationError&&O.fileOperationResult===1||O instanceof g.FileOperationError&&O.fileOperationResult===3?new E.UserDataSyncError(O.message,"LocalPreconditionFailed"):O}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(m){if(!(m instanceof g.FileOperationError&&m.fileOperationResult===1))throw m}}onFileChanges(m){m.contains(this.file)&&this.triggerLocalChange()}};e.AbstractFileSynchroniser=i,e.AbstractFileSynchroniser=i=ve([Y(3,g.IFileService),Y(4,u.IEnvironmentService),Y(5,l.IStorageService),Y(6,E.IUserDataSyncStoreService),Y(7,E.IUserDataSyncBackupStoreService),Y(8,E.IUserDataSyncEnablementService),Y(9,h.ITelemetryService),Y(10,E.IUserDataSyncLogService),Y(11,S.IConfigurationService),Y(12,y.IUriIdentityService)],i);let r=class extends i{constructor(m,d,b,O,F,M,q,j,B,Q,J,G,X,V){super(m,d,b,O,F,M,q,j,B,Q,J,X,V),this.userDataSyncUtilService=G,this._formattingOptions=void 0}hasErrors(m,d){const b=[],O=(0,D.parse)(m,b,{allowEmptyContent:!0,allowTrailingComma:!0});return b.length>0||!(0,I.isUndefined)(O)&&d!==Array.isArray(O)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=r,e.AbstractJsonFileSynchroniser=r=ve([Y(3,g.IFileService),Y(4,u.IEnvironmentService),Y(5,l.IStorageService),Y(6,E.IUserDataSyncStoreService),Y(7,E.IUserDataSyncBackupStoreService),Y(8,E.IUserDataSyncEnablementService),Y(9,h.ITelemetryService),Y(10,E.IUserDataSyncLogService),Y(11,E.IUserDataSyncUtilService),Y(12,S.IConfigurationService),Y(13,y.IUriIdentityService)],r);let a=class{constructor(m,d,b,O,F,M,q){this.resource=m,this.userDataProfilesService=d,this.environmentService=b,this.logService=O,this.fileService=F,this.storageService=M,this.extUri=q.extUri,this.lastSyncResource=(0,E.getLastSyncResourceUri)(void 0,this.resource,b,this.extUri)}async initialize({ref:m,content:d}){if(!d){this.logService.info("Remote content does not exist.",this.resource);return}const b=this.parseSyncData(d);if(b)try{await this.doInitialize({ref:m,syncData:b})}catch(O){this.logService.error(O)}}parseSyncData(m){try{const d=JSON.parse(m);if(o(d))return d}catch(d){this.logService.error(d)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(m,d={}){if(d.ref||d.version)throw new Error("Cannot have core properties as additional");const b={ref:m.ref,version:void 0,...d};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(b),-1,1),await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(m)))}};e.AbstractInitializer=a,e.AbstractInitializer=a=ve([Y(1,R.IUserDataProfilesService),Y(2,u.IEnvironmentService),Y(3,w.ILogService),Y(4,g.IFileService),Y(5,l.IStorageService),Y(6,y.IUriIdentityService)],a)}),define(oe[114],ae([0,1,6,25,7,3,41,2,27,18,15,113,29,33,78,45,13,4,68,8,19,20,28,17,39,228,111,23,58]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h,y,E,R,t,o,n,s,i,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function p(M,q){const j=JSON.parse(M.content);if(M.version===1||M.version===2){const B=(await q.getInstalled(0)).filter(Q=>Q.isBuiltin);for(const Q of j)M.version===1&&(Q.enabled===!1&&(Q.disabled=!0),delete Q.enabled),M.version===2&&B.every(J=>!(0,u.areSameExtensions)(J.identifier,Q.identifier))&&(Q.installed=!0)}return j}function m(M){return JSON.parse(M.content)}e.parseExtensions=m;function d(M,q){return M.sort((j,B)=>!j.identifier.uuid&&B.identifier.uuid?-1:j.identifier.uuid&&!B.identifier.uuid?1:(0,P.compare)(j.identifier.id,B.identifier.id)),q?(0,k.toFormattedString)(M,{}):JSON.stringify(M)}e.stringify=d;let b=class extends n.AbstractSynchroniser{constructor(q,j,B,Q,J,G,X,V,x,z,ee,ne,ce,re,U,f,_){super({syncResource:"extensions",profile:q},j,Q,B,J,G,X,ne,ce,z,ee,U),this.extensionManagementService=V,this.ignoredExtensionsManagementService=x,this.instantiationService=_,this.version=6,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(O),this._register(A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,$=>$.some(({local:H})=>!!H)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,$=>!$.error),A.Event.filter(f.onDidChange,$=>$.valueChanges.some(({profile:H,changes:W})=>this.syncResource.profile.id===H.id&&W.some(K=>K.key===S.DISABLED_EXTENSIONS_STORAGE_PATH))),re.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(q,j){const B=q.syncData?await p(q.syncData,this.extensionManagementService):null,Q=j?.skippedExtensions??[],J=j?.builtinExtensions??null,G=j?.syncData?await p(j.syncData,this.extensionManagementService):null,{localExtensions:X,ignoredExtensions:V}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);B?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:x,remote:z}=(0,s.merge)(X,B,G,Q,V,J),ee={local:x,remote:z,content:this.getPreviewContent(X,x.added,x.updated,x.removed),localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:z!==null?2:0},ne=this.stringify(X,!1);return[{skippedExtensions:Q,builtinExtensions:J,baseResource:this.baseResource,baseContent:G?this.stringify(G,!1):ne,localResource:this.localResource,localContent:ne,localExtensions:X,remoteResource:this.remoteResource,remoteExtensions:B,remoteContent:B?this.stringify(B,!1):null,previewResource:this.previewResource,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(q){const j=q.syncData?await p(q.syncData,this.extensionManagementService):null,{localExtensions:B,ignoredExtensions:Q}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:J}=(0,s.merge)(B,j,j,q.skippedExtensions||[],Q,q.builtinExtensions||[]);return J!==null}getPreviewContent(q,j,B,Q){const J=[...j,...B],G=new Set,X=V=>{G.add(V.id.toLowerCase()),V.uuid&&G.add(V.uuid)};J.forEach(({identifier:V})=>X(V)),Q.forEach(X);for(const V of q)G.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&G.has(V.identifier.uuid)||J.push(V);return this.stringify(J,!1)}async getMergeResult(q,j){return{...q.previewResult,hasConflicts:!1}}async getAcceptResult(q,j,B,Q){if(this.extUri.isEqual(j,this.localResource))return this.acceptLocal(q);if(this.extUri.isEqual(j,this.remoteResource))return this.acceptRemote(q);if(this.extUri.isEqual(j,this.previewResource))return q.previewResult;throw new Error(`Invalid Resource: ${j.toString()}`)}async acceptLocal(q){const j=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),B=this.ignoredExtensionsManagementService.getIgnoredExtensions(j),Q=(0,s.merge)(q.localExtensions,null,null,q.skippedExtensions,B,q.builtinExtensions),{local:J,remote:G}=Q;return{content:q.localContent,local:J,remote:G,localChange:J.added.length>0||J.removed.length>0||J.updated.length>0?2:0,remoteChange:G!==null?2:0}}async acceptRemote(q){const j=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),B=this.ignoredExtensionsManagementService.getIgnoredExtensions(j),Q=q.remoteContent?JSON.parse(q.remoteContent):null;if(Q!==null){const J=(0,s.merge)(q.localExtensions,Q,q.localExtensions,[],B,q.builtinExtensions),{local:G,remote:X}=J;return{content:q.remoteContent,local:G,remote:X,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:X!==null?2:0}}else return{content:q.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(q,j,B,Q){let{skippedExtensions:J,builtinExtensions:G,localExtensions:X}=B[0][0];const{local:V,remote:x,localChange:z,remoteChange:ee}=B[0][1];if(z===0&&ee===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),z!==0&&(await this.backupLocal(JSON.stringify(X)),J=await this.localExtensionsProvider.updateLocalExtensions(V.added,V.removed,V.updated,J,this.syncResource.profile)),x){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const ne=JSON.stringify(x.all);q=await this.updateRemoteUserData(ne,Q?null:q.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${x.added.length?` Added: ${JSON.stringify(x.added.map(ce=>ce.identifier.id))}.`:""}${x.updated.length?` Updated: ${JSON.stringify(x.updated.map(ce=>ce.identifier.id))}.`:""}${x.removed.length?` Removed: ${JSON.stringify(x.removed.map(ce=>ce.identifier.id))}.`:""}`)}j?.ref!==q.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),G=this.computeBuiltinExtensions(X,G),await this.updateLastSyncUserData(q,{skippedExtensions:J,builtinExtensions:G}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${J.length?` Skipped: ${JSON.stringify(J.map(ne=>ne.identifier.id))}.`:""}`))}computeBuiltinExtensions(q,j){const B=new Set,Q=[];for(const J of q)B.add(J.identifier.id.toLowerCase()),J.installed||Q.push(J.identifier);if(j)for(const J of j)B.has(J.id.toLowerCase())||Q.push(J);return Q}async resolveContent(q){if(this.extUri.isEqual(this.remoteResource,q)||this.extUri.isEqual(this.baseResource,q)||this.extUri.isEqual(this.localResource,q)||this.extUri.isEqual(this.acceptedResource,q)){const j=await this.resolvePreviewContent(q);return j&&this.stringify(JSON.parse(j),!0)}return null}stringify(q,j){return d(q,j)}async hasLocalData(){try{const{localExtensions:q}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(q.some(j=>j.installed||j.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=b,e.ExtensionsSynchroniser=b=ve([Y(2,I.IEnvironmentService),Y(3,c.IFileService),Y(4,E.IStorageService),Y(5,r.IUserDataSyncStoreService),Y(6,r.IUserDataSyncBackupStoreService),Y(7,S.IExtensionManagementService),Y(8,i.IIgnoredExtensionsManagementService),Y(9,r.IUserDataSyncLogService),Y(10,v.IConfigurationService),Y(11,r.IUserDataSyncEnablementService),Y(12,R.ITelemetryService),Y(13,g.IExtensionStorageService),Y(14,t.IUriIdentityService),Y(15,a.IUserDataProfileStorageService),Y(16,l.IInstantiationService)],b);let O=class{constructor(q,j,B,Q,J,G){this.extensionManagementService=q,this.userDataProfileStorageService=j,this.extensionGalleryService=B,this.ignoredExtensionsManagementService=Q,this.instantiationService=J,this.logService=G}async getLocalExtensions(q){const j=await this.extensionManagementService.getInstalled(void 0,q.extensionsResource),B=this.ignoredExtensionsManagementService.getIgnoredExtensions(j);return{localExtensions:await this.withProfileScopedServices(q,async(J,G)=>{const X=J.getDisabledExtensions();return j.map(V=>{const{identifier:x,isBuiltin:z,manifest:ee,preRelease:ne,pinned:ce,isApplicationScoped:re}=V,U={identifier:x,preRelease:ne,version:ee.version,pinned:!!ce};re&&!(0,w.isApplicationScopedExtension)(ee)&&(U.isApplicationScoped=re),X.some(f=>(0,u.areSameExtensions)(f,x))&&(U.disabled=!0),z||(U.installed=!0);try{const f=G.getKeysForSync({id:x.id,version:ee.version});if(f){const _=G.getExtensionState(V,!0)||{};U.state=Object.keys(_).reduce(($,H)=>(f.includes(H)&&($[H]=_[H]),$),{})}}catch(f){this.logService.info(`${(0,n.getSyncResourceLogLabel)("extensions",q)}: Error while parsing extension state`,(0,T.getErrorMessage)(f))}return U})}),ignoredExtensions:B}}async updateLocalExtensions(q,j,B,Q,J){const G=(0,n.getSyncResourceLogLabel)("extensions",J),X=[],V=new Map,x=[],z=[],ee=await this.extensionManagementService.getInstalled(void 0,J.extensionsResource);if((q.length||B.length)&&await this.withProfileScopedServices(J,async(re,U)=>{await L.Promises.settled([...q,...B].map(async f=>{const _=ee.find(W=>(0,u.areSameExtensions)(W.identifier,f.identifier));if(_&&_.isBuiltin){f.state&&_.manifest.version===f.version&&this.updateExtensionState(f.state,_,_.manifest.version,U),re.getDisabledExtensions().some(K=>(0,u.areSameExtensions)(K,f.identifier))!==!!f.disabled&&(f.disabled?(this.logService.trace(`${G}: Disabling extension...`,f.identifier.id),await re.disableExtension(f.identifier),this.logService.info(`${G}: Disabled extension`,f.identifier.id)):(this.logService.trace(`${G}: Enabling extension...`,f.identifier.id),await re.enableExtension(f.identifier),this.logService.info(`${G}: Enabled extension`,f.identifier.id))),x.push(f.identifier);return}const $=f.pinned?f.version:void 0,H=(await this.extensionGalleryService.getExtensions([{...f.identifier,version:$,preRelease:$?void 0:f.preRelease}],N.CancellationToken.None))[0];if(f.state&&(_?_.manifest.version===f.version:H)&&this.updateExtensionState(f.state,_||H,_?.manifest.version,U),H)try{re.getDisabledExtensions().some(K=>(0,u.areSameExtensions)(K,f.identifier))!==!!f.disabled&&(f.disabled?(this.logService.trace(`${G}: Disabling extension...`,f.identifier.id,H.version),await re.disableExtension(H.identifier),this.logService.info(`${G}: Disabled extension`,f.identifier.id,H.version)):(this.logService.trace(`${G}: Enabling extension...`,f.identifier.id,H.version),await re.enableExtension(H.identifier),this.logService.info(`${G}: Enabled extension`,f.identifier.id,H.version))),(!_||_.preRelease!==f.preRelease||_.pinned!==f.pinned||$&&_.manifest.version!==$)&&(await this.extensionManagementService.canInstall(H)?(X.push({extension:H,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:f.pinned&&!!f.version,installPreReleaseVersion:f.preRelease,profileLocation:J.extensionsResource,isApplicationScoped:f.isApplicationScoped,context:{[S.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[S.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}}),V.set(H.identifier.id.toLowerCase(),f)):(this.logService.info(`${G}: Skipped synchronizing extension because it cannot be installed.`,H.displayName||H.identifier.id),z.push(f)))}catch(W){z.push(f),this.logService.error(W),this.logService.info(`${G}: Skipped synchronizing extension`,H.displayName||H.identifier.id)}else z.push(f),this.logService.info(`${G}: Skipped synchronizing extension because the extension is not found.`,f.identifier.id)}))}),j.length){const re=ee.filter(({identifier:U,isBuiltin:f})=>!f&&j.some(_=>(0,u.areSameExtensions)(U,_)));await L.Promises.settled(re.map(async U=>{this.logService.trace(`${G}: Uninstalling local extension...`,U.identifier.id),await this.extensionManagementService.uninstall(U,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:J.extensionsResource}),this.logService.info(`${G}: Uninstalled local extension.`,U.identifier.id),x.push(U.identifier)}))}const ne=await this.extensionManagementService.installGalleryExtensions(X);for(const{identifier:re,local:U,error:f,source:_}of ne){const $=_;if(U)this.logService.info(`${G}: Installed extension.`,re.id,$.version),x.push(re);else{const H=V.get(re.id.toLowerCase());H&&(z.push(H),this.logService.info(`${G}: Skipped synchronizing extension`,$.displayName||$.identifier.id)),f instanceof S.ExtensionManagementError&&[S.ExtensionManagementErrorCode.Incompatible,S.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(f.code)?this.logService.info(`${G}: Skipped synchronizing extension because the compatible extension is not found.`,$.displayName||$.identifier.id):f&&this.logService.error(f)}}const ce=[];for(const re of Q)x.some(U=>(0,u.areSameExtensions)(U,re.identifier))||ce.push(re);for(const re of z)ce.some(U=>(0,u.areSameExtensions)(U.identifier,re.identifier))||ce.push(re);return ce}updateExtensionState(q,j,B,Q){const J=Q.getExtensionState(j,!0)||{},G=B?Q.getKeysForSync({id:j.identifier.id,version:B}):void 0;G?G.forEach(X=>{J[X]=q[X]}):Object.keys(q).forEach(X=>J[X]=q[X]),Q.setExtensionState(j,J,!0)}async withProfileScopedServices(q,j){return this.userDataProfileStorageService.withProfileScopedStorageService(q,async B=>{const Q=new D.DisposableStore,J=this.instantiationService.createChild(new h.ServiceCollection([E.IStorageService,B])),G=Q.add(J.createInstance(C.GlobalExtensionEnablementService)),X=Q.add(J.createInstance(g.ExtensionStorageService));try{return await j(G,X)}finally{Q.dispose()}})}};e.LocalExtensionsProvider=O,e.LocalExtensionsProvider=O=ve([Y(0,S.IExtensionManagementService),Y(1,a.IUserDataProfileStorageService),Y(2,S.IExtensionGalleryService),Y(3,i.IIgnoredExtensionsManagementService),Y(4,l.IInstantiationService),Y(5,r.IUserDataSyncLogService)],O);let F=class extends n.AbstractInitializer{constructor(q,j,B,Q,J,G,X,V){super("extensions",Q,J,G,B,X,V),this.extensionManagementService=q,this.ignoredExtensionsManagementService=j}async parseExtensions(q){return q.syncData?await p(q.syncData,this.extensionManagementService):null}generatePreview(q,j){const B=[],Q=[],J=[];for(const G of q){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(G.identifier.id))continue;const X=j.find(V=>(0,u.areSameExtensions)(V.identifier,G.identifier));X?(B.push(X),G.disabled&&J.push(G.identifier)):G.installed&&(Q.push({...G.identifier,preRelease:!!G.preRelease}),G.disabled&&J.push(G.identifier))}return{installedExtensions:B,newExtensions:Q,disabledExtensions:J,remoteExtensions:q}}};e.AbstractExtensionsInitializer=F,e.AbstractExtensionsInitializer=F=ve([Y(0,S.IExtensionManagementService),Y(1,i.IIgnoredExtensionsManagementService),Y(2,c.IFileService),Y(3,o.IUserDataProfilesService),Y(4,I.IEnvironmentService),Y(5,y.ILogService),Y(6,E.IStorageService),Y(7,t.IUriIdentityService)],F)}),define(oe[115],ae([0,1,14,7,3,34,41,5,32,18,15,13,8,44,19,20,28,39,75,232,23,17,58,4]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h,y,E,R,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const n="globalState.argv.",s=["locale"];function i(b,O){const F=b.storage?Object.keys(b.storage).sort():[],M={};return F.forEach(q=>M[q]=b.storage[q]),b.storage=M,O?(0,k.toFormattedString)(b,{}):JSON.stringify(b)}e.stringify=i;const r=1;let a=class extends l.AbstractSynchroniser{constructor(O,F,M,q,j,B,Q,J,G,X,V,x,z,ee){super({syncResource:"globalState",profile:O},F,q,J,x,j,B,G,X,Q,V,z),this.userDataProfileStorageService=M,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=ee.createInstance(p),this._register(q.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(T.Event.any(T.Event.filter(q.onDidFilesChange,ne=>ne.contains(this.environmentService.argvResource)),T.Event.filter(M.onDidChange,ne=>!!(ne.targetChanges.some(ce=>this.syncResource.profile.id===ce.id)||ne.valueChanges.some(({profile:ce,changes:re})=>this.syncResource.profile.id===ce.id&&re.some(U=>U.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(O,F,M){const q=O.syncData?JSON.parse(O.syncData.content):null;F=F===null&&M?O:F;const j=F&&F.syncData?JSON.parse(F.syncData.content):null,B=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);q?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Q=await this.getStorageKeys(j),{local:J,remote:G}=(0,y.merge)(B.storage,q?q.storage:null,j?j.storage:null,Q,this.logService),X={content:null,local:J,remote:G,localChange:Object.keys(J.added).length>0||Object.keys(J.updated).length>0||J.removed.length>0?2:0,remoteChange:G.all!==null?2:0},V=i(B,!1);return[{baseResource:this.baseResource,baseContent:j?i(j,!1):V,localResource:this.localResource,localContent:V,localUserData:B,remoteResource:this.remoteResource,remoteContent:q?i(q,!1):null,previewResource:this.previewResource,previewResult:X,localChange:X.localChange,remoteChange:X.remoteChange,acceptedResource:this.acceptedResource,storageKeys:Q}]}async hasRemoteChanged(O){const F=O.syncData?JSON.parse(O.syncData.content):null;if(F===null)return!0;const M=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),q=await this.getStorageKeys(F),{remote:j}=(0,y.merge)(M.storage,F.storage,F.storage,q,this.logService);return j.all!==null}async getMergeResult(O,F){return{...O.previewResult,hasConflicts:!1}}async getAcceptResult(O,F,M,q){if(this.extUri.isEqual(F,this.localResource))return this.acceptLocal(O);if(this.extUri.isEqual(F,this.remoteResource))return this.acceptRemote(O);if(this.extUri.isEqual(F,this.previewResource))return O.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async acceptLocal(O){return{content:O.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(O.localUserData.storage),removed:[],updated:[],all:O.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(O){if(O.remoteContent!==null){const F=JSON.parse(O.remoteContent),{local:M,remote:q}=(0,y.merge)(O.localUserData.storage,F.storage,null,O.storageKeys,this.logService);return{content:O.remoteContent,local:M,remote:q,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:q!==null?2:0}}else return{content:O.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(O,F,M,q){const{localUserData:j}=M[0][0],{local:B,remote:Q,localChange:J,remoteChange:G}=M[0][1];if(J===0&&G===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),J!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(j)),await this.localGlobalStateProvider.writeLocalGlobalState(B,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),G!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const X=JSON.stringify({storage:Q.all});O=await this.updateRemoteUserData(X,q?null:O.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${Q.added.length?` Added: ${Q.added}.`:""}${Q.updated.length?` Updated: ${Q.updated}.`:""}${Q.removed.length?` Removed: ${Q.removed}.`:""}`)}F?.ref!==O.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(O),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(O){if(this.extUri.isEqual(this.remoteResource,O)||this.extUri.isEqual(this.baseResource,O)||this.extUri.isEqual(this.localResource,O)||this.extUri.isEqual(this.acceptedResource,O)){const F=await this.resolvePreviewContent(O);return F&&i(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:O}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(O).length>1||O[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(O){const F=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),M=[],q=[];for(const[Q,J]of F)J.target===0?M.push(Q):J.target===1&&q.push(Q);const j=[...M,...q],B=O?.storage?Object.keys(O.storage).filter(Q=>!Q.startsWith(n)&&!j.includes(Q)&&F.get(Q)!==void 0):[];if(!D.isWeb){const Q=[...E.ALL_SYNC_RESOURCES.map(J=>(0,E.getEnablementKey)(J)),E.SYNC_SERVICE_URL_TYPE];B.push(...Q),q.push(...Q)}return{user:M,machine:q,unregistered:B}}};e.GlobalStateSynchroniser=a,e.GlobalStateSynchroniser=a=ve([Y(2,t.IUserDataProfileStorageService),Y(3,C.IFileService),Y(4,E.IUserDataSyncStoreService),Y(5,E.IUserDataSyncBackupStoreService),Y(6,E.IUserDataSyncLogService),Y(7,I.IEnvironmentService),Y(8,E.IUserDataSyncEnablementService),Y(9,w.ITelemetryService),Y(10,v.IConfigurationService),Y(11,g.IStorageService),Y(12,c.IUriIdentityService),Y(13,o.IInstantiationService)],a);let p=class{constructor(O,F,M,q){this.fileService=O,this.environmentService=F,this.userDataProfileStorageService=M,this.logService=q}async getLocalGlobalState(O){const F={};if(O.isDefault){const q=await this.getLocalArgvContent(),j=(0,A.parse)(q);for(const B of s)j[B]!==void 0&&(F[`${n}${B}`]={version:1,value:j[B]})}const M=await this.userDataProfileStorageService.readStorageData(O);for(const[q,j]of M)j.value&&j.target===0&&(F[q]={version:1,value:j.value});return{storage:F}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const O=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),O.value.toString()}catch(O){this.logService.debug((0,N.getErrorMessage)(O))}return"{}"}async writeLocalGlobalState({added:O,removed:F,updated:M},q){const j=(0,l.getSyncResourceLogLabel)("globalState",q),B={},Q=new Map,J=await this.userDataProfileStorageService.readStorageData(q),G=(X,V)=>{for(const x of X){if(x.startsWith(n)){B[x.substring(n.length)]=V?V[x].value:void 0;continue}if(V){const z=V[x];z.value!==J.get(x)?.value&&Q.set(x,z.value)}else J.get(x)!==void 0&&Q.set(x,void 0)}};if(G(Object.keys(O),O),G(Object.keys(M),M),G(F),Object.keys(B).length){this.logService.trace(`${j}: Updating locale...`);const X=await this.getLocalArgvContent();let V=X;for(const x of Object.keys(B))V=(0,h.edit)(V,[x],B[x],{});X!==V&&(this.logService.trace(`${j}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(V)),this.logService.info(`${j}: Updated locale.`)),this.logService.info(`${j}: Updated locale`)}Q.size&&(this.logService.trace(`${j}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(q,Q,0),this.logService.info(`${j}: Updated global state`,[...Q.keys()]))}};e.LocalGlobalStateProvider=p,e.LocalGlobalStateProvider=p=ve([Y(0,C.IFileService),Y(1,I.IEnvironmentService),Y(2,t.IUserDataProfileStorageService),Y(3,E.IUserDataSyncLogService)],p);let m=class extends l.AbstractInitializer{constructor(O,F,M,q,j,B){super("globalState",M,q,j,F,O,B)}async doInitialize(O){const F=O.syncData?JSON.parse(O.syncData.content):null;if(!F){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const M={},q={};for(const j of Object.keys(F.storage))j.startsWith(n)?M[j.substring(n.length)]=F.storage[j].value:this.storageService.get(j,0)===void 0&&(q[j]=F.storage[j].value);if(Object.keys(M).length){let j="{}";try{j=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const B of Object.keys(M))j=(0,h.edit)(j,[B],M[B],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(j))}if(Object.keys(q).length){const j=[];for(const B of Object.keys(q))j.push({key:B,value:q[B],scope:0,target:0});this.storageService.storeAll(j,!0)}}};e.GlobalStateInitializer=m,e.GlobalStateInitializer=m=ve([Y(0,g.IStorageService),Y(1,C.IFileService),Y(2,R.IUserDataProfilesService),Y(3,I.IEnvironmentService),Y(4,E.IUserDataSyncLogService),Y(5,c.IUriIdentityService)],m);let d=class{constructor(O,F,M,q,j){this.userDataSyncStoreClient=O,this.storageService=F,this.environmentService=M,this.fileService=q,this.logService=j}getSyncStoreType(O){return this.parseGlobalState(O)?.storage[E.SYNC_SERVICE_URL_TYPE]?.value}async sync(O){const F=(0,E.createSyncHeaders)((0,P.generateUuid)());try{return await this.doSync(O,F)}catch(M){if(M instanceof E.UserDataSyncError)switch(M.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(O,F)}throw M}}async doSync(O,F){const M=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,F),q=this.parseGlobalState(M)||{storage:{}};q.storage[E.SYNC_SERVICE_URL_TYPE]={value:O,version:r};const j=await(0,u.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),B={version:r,machineId:j,content:i(q,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(B),M.ref,void 0,F)}parseGlobalState({content:O}){if(!O)return null;const F=JSON.parse(O);if((0,l.isSyncData)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=d,e.UserDataSyncStoreTypeSynchronizer=d=ve([Y(1,g.IStorageService),Y(2,I.IEnvironmentService),Y(3,C.IFileService),Y(4,S.ILogService)],d)}),define(oe[116],ae([0,1,21,14,3,34,5,11,167,18,15,13,19,20,28,17,39,229,23]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function y(t,o,n){try{const s=JSON.parse(t);if(!o)return(0,D.isUndefined)(s.all)?null:s.all;switch(k.OS){case 2:return(0,D.isUndefined)(s.mac)?null:s.mac;case 3:return(0,D.isUndefined)(s.linux)?null:s.linux;case 1:return(0,D.isUndefined)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}e.getKeybindingsContentFromSyncContent=y;let E=class extends c.AbstractJsonFileSynchroniser{constructor(o,n,s,i,r,a,p,m,d,b,O,F,M){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,m,d,b,s,i,p,F,r,O,a,M),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.filter(a.onDidChangeConfiguration,q=>q.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,n,s,i){const r=o.syncData?y(o.syncData.content,i.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;n=n===null&&s?o:n;const a=n?this.getKeybindingsContentFromLastSyncUserData(n):null,p=await this.getLocalFileContent(),m=await this.getFormattingOptions();let d=null,b=!1,O=!1,F=!1;if(r){let j=p?p.value.toString():"[]";if(j=j||"[]",this.hasErrors(j,!0))throw new h.UserDataSyncError((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==j||a!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const B=await(0,l.merge)(j,r,a,m,this.userDataSyncUtilService);B.hasChanges&&(d=B.mergeContent,F=B.hasConflicts,b=F||B.mergeContent!==j,O=F||B.mergeContent!==r)}}else p&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=p.value.toString(),O=!0);const M={content:F?a:d,localChange:b?p?2:1:0,remoteChange:O?2:0,hasConflicts:F},q=p?p.value.toString():null;return[{fileContent:p,baseResource:this.baseResource,baseContent:a,localResource:this.localResource,localContent:q,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const n=this.getKeybindingsContentFromLastSyncUserData(o);if(n===null)return!0;const s=await this.getLocalFileContent(),i=s?s.value.toString():"",r=await this.getFormattingOptions(),a=await(0,l.merge)(i||"[]",n,n,r,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==n}async getMergeResult(o,n){return o.previewResult}async getAcceptResult(o,n,s,i){if(this.extUri.isEqual(n,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(o,n,s,i){const{fileContent:r}=s[0][0];let{content:a,localChange:p,remoteChange:m}=s[0][1];if(p===0&&m===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new h.UserDataSyncError((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(p!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(a||"[]",r,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),m!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(a||"[]",o.syncData?.content);o=await this.updateRemoteUserData(d,i?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const n=(0,A.parse)(o.value.toString());if((0,L.isNonEmptyArray)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)?this.resolvePreviewContent(o):null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:y(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=o,k.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(h.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=E,e.KeybindingsSynchroniser=E=ve([Y(2,h.IUserDataSyncStoreService),Y(3,h.IUserDataSyncBackupStoreService),Y(4,h.IUserDataSyncLogService),Y(5,v.IConfigurationService),Y(6,h.IUserDataSyncEnablementService),Y(7,C.IFileService),Y(8,I.IEnvironmentService),Y(9,S.IStorageService),Y(10,h.IUserDataSyncUtilService),Y(11,u.ITelemetryService),Y(12,g.IUriIdentityService)],E);let R=class extends c.AbstractInitializer{constructor(o,n,s,i,r,a){super("keybindings",n,s,i,o,r,a)}async doInitialize(o){const n=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!n){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,N.VSBuffer.fromString(n)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),n=(0,A.parse)(o.value.toString());return!(0,L.isNonEmptyArray)(n)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return y(o,!0,this.logService)}catch(n){return this.logService.error(n),null}}};e.KeybindingsInitializer=R,e.KeybindingsInitializer=R=ve([Y(0,C.IFileService),Y(1,w.IUserDataProfilesService),Y(2,I.IEnvironmentService),Y(3,h.IUserDataSyncLogService),Y(4,S.IStorageService),Y(5,g.IUriIdentityService)],R)}),define(oe[117],ae([0,1,14,3,168,18,71,15,29,13,19,20,28,17,39,233,23]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function l(R){return R&&R.settings&&typeof R.settings=="string"&&Object.keys(R).length===1}function h(R){const t=JSON.parse(R);return l(t)?t:{settings:R}}e.parseSettingsSyncContent=h;let y=class extends g.AbstractJsonFileSynchroniser{constructor(t,o,n,s,i,r,a,p,m,d,b,O,F,M){super(t.settingsResource,{syncResource:"settings",profile:t},o,n,s,i,r,a,b,O,p,m,d,M),this.extensionManagementService=F,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(t){const o=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(t,o),s=this.getSettingsSyncContent(n),i=new k.ConfigurationModelParser(c.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&i.parse(s.settings),i.configurationModel.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(t,o,n){const s=await this.getLocalFileContent(),i=await this.getFormattingOptions(),r=this.getSettingsSyncContent(t);o=o===null&&n?t:o;const a=o?this.getSettingsSyncContent(o):null,p=await this.getIgnoredSettings();let m=null,d=!1,b=!1,O=!1;if(r){let j=s?s.value.toString().trim():"{}";j=j||"{}",this.validateContent(j),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const B=(0,w.merge)(j,r.settings,a?a.settings:null,p,[],i);m=B.localContent||B.remoteContent,d=B.localContent!==null,b=B.remoteContent!==null,O=B.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),m=s.value.toString().trim()||"{}",this.validateContent(m),b=!0);const F=s?s.value.toString():null,M=a?.settings??null,q={content:O?M:m,localChange:d?2:0,remoteChange:b?2:0,hasConflicts:O};return[{fileContent:s,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:F,localChange:q.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:q.remoteChange,previewResource:this.previewResource,previewResult:q,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(t){const o=this.getSettingsSyncContent(t);if(o===null)return!0;const n=await this.getLocalFileContent(),s=n?n.value.toString().trim():"",i=await this.getIgnoredSettings(),r=await this.getFormattingOptions();return(0,w.merge)(s||"{}",o.settings,o.settings,i,[],r).remoteContent!==null}async getMergeResult(t,o){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,w.updateIgnoredSettings)(t.previewResult.content,"{}",s,n):null}}async getAcceptResult(t,o,n,s){const i=await this.getFormattingOptions(),r=await this.getIgnoredSettings();if(this.extUri.isEqual(o,this.localResource))return{content:t.fileContent?(0,w.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",r,i):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(o,this.remoteResource))return{content:t.remoteContent!==null?(0,w.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(o,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,w.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async applyResult(t,o,n,s){const{fileContent:i}=n[0][0];let{content:r,localChange:a,remoteChange:p}=n[0][1];if(a===0&&p===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.validateContent(r),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),i&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(i.value.toString()))),await this.updateLocalFileContent(r,i,s),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),p!==0){const m=await this.getFormattingOptions(),d=this.getSettingsSyncContent(t),b=await this.getIgnoredSettings(r);r=(0,w.updateIgnoredSettings)(r,d?d.settings:"{}",b,m),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(r)),s?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}o?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t)return!(0,w.isEmpty)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t)||this.extUri.isEqual(this.baseResource,t)?this.resolvePreviewContent(t):null}async resolvePreviewContent(t){let o=await super.resolvePreviewContent(t);if(o){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();o=(0,w.updateIgnoredSettings)(o,"{}",s,n)}return o}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return h(t)}catch(o){this.logService.error(o)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=N.Event.any(N.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:i})=>!!i)),N.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const o=await this._defaultIgnoredSettings;return(0,w.getIgnoredSettings)(o,this.configurationService,t)}validateContent(t){if(this.hasErrors(t,!1))throw new c.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}};e.SettingsSynchroniser=y,e.SettingsSynchroniser=y=ve([Y(2,v.IFileService),Y(3,D.IEnvironmentService),Y(4,I.IStorageService),Y(5,c.IUserDataSyncStoreService),Y(6,c.IUserDataSyncBackupStoreService),Y(7,c.IUserDataSyncLogService),Y(8,c.IUserDataSyncUtilService),Y(9,A.IConfigurationService),Y(10,c.IUserDataSyncEnablementService),Y(11,C.ITelemetryService),Y(12,P.IExtensionManagementService),Y(13,S.IUriIdentityService)],y);let E=class extends g.AbstractInitializer{constructor(t,o,n,s,i,r){super("settings",o,n,s,t,i,r)}async doInitialize(t){const o=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!o){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,L.VSBuffer.fromString(o.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,w.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return h(t)}catch(o){this.logService.error(o)}return null}};e.SettingsInitializer=E,e.SettingsInitializer=E=ve([Y(0,v.IFileService),Y(1,u.IUserDataProfilesService),Y(2,D.IEnvironmentService),Y(3,c.IUserDataSyncLogService),Y(4,I.IStorageService),Y(5,S.IUriIdentityService)],E)}),define(oe[118],ae([0,1,14,3,30,18,15,13,19,20,28,17,39,230,23]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function w(h){return JSON.parse(h.content)}e.parseSnippets=w;let c=class extends S.AbstractSynchroniser{constructor(y,E,R,t,o,n,s,i,r,a,p,m){super({syncResource:"snippets",profile:y},E,t,R,o,n,s,a,p,i,r,m),this.version=1,this.snippetsFolder=y.snippetsHome,this._register(this.fileService.watch(R.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(N.Event.filter(this.fileService.onDidFilesChange,d=>d.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(y,E,R){const t=await this.getSnippetsFileContents(),o=this.toSnippetsContents(t),n=y.syncData?this.parseSnippets(y.syncData):null;E=E===null&&R?y:E;const s=E&&E.syncData?this.parseSnippets(E.syncData):null;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,u.merge)(o,n,s);return this.getResourcePreviews(i,t,n||{},s||{})}async hasRemoteChanged(y){const E=y.syncData?this.parseSnippets(y.syncData):null;if(E===null)return!0;const R=await this.getSnippetsFileContents(),t=this.toSnippetsContents(R),o=(0,u.merge)(t,E,E);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async getMergeResult(y,E){return y.previewResult}async getAcceptResult(y,E,R,t){if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:y.fileContent?y.fileContent.value.toString():null,localChange:0,remoteChange:y.fileContent?y.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:y.remoteContent,localChange:y.remoteContent!==null?y.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder))return R===void 0?{content:y.previewResult.content,localChange:y.previewResult.localChange,remoteChange:y.previewResult.remoteChange}:{content:R,localChange:R===null?y.fileContent!==null?3:0:2,remoteChange:R===null?y.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${E.toString()}`)}async applyResult(y,E,R,t){const o=R.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,t)),o.some(({remoteChange:n})=>n!==0)&&(y=await this.updateRemoteSnippets(o,y,t)),E?.ref!==y.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(y),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.fileService.del(n)}catch{}}getResourcePreviews(y,E,R,t){const o=new Map;for(const n of Object.keys(y.local.added)){const s={content:y.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(y.local.updated)){const s={content:y.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},i=E[n]?E[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[n],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of y.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=E[n]?E[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[n],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(y.remote.added)){const s={content:y.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},i=E[n]?E[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[n],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(y.remote.updated)){const s={content:y.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},i=E[n]?E[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[n],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of y.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of y.conflicts){const s={content:t[n]??null,hasConflicts:!0,localChange:E[n]?2:1,remoteChange:R[n]?2:1},i=E[n]?E[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[n]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(E))if(!o.has(n)){const s={content:E[n]?E[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=E[n]?E[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[n]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async resolveContent(y){return this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(y):null}async hasLocalData(){try{const y=await this.getSnippetsFileContents();if(Object.keys(y).length)return!0}catch{}return!1}async updateLocalBackup(y){const E={};for(const R of y)R.fileContent&&(E[this.extUri.basename(R.localResource)]=R.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(E)))}async updateLocalSnippets(y,E){for(const{fileContent:R,acceptResult:t,localResource:o,remoteResource:n,localChange:s}of y)if(s!==0){const i=n?this.extUri.basename(n):this.extUri.basename(o),r=this.extUri.joinPath(this.snippetsFolder,i);s===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):s===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,L.VSBuffer.fromString(t.content),{overwrite:E}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,L.VSBuffer.fromString(t.content),E?void 0:R),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(y,E,R){const t=E.syncData?this.parseSnippets(E.syncData):{},o=(0,T.deepClone)(t);for(const{acceptResult:n,localResource:s,remoteResource:i,remoteChange:r}of y)if(r!==0){const a=s?this.extUri.basename(s):this.extUri.basename(i);r===3?delete o[a]:o[a]=n.content}return(0,u.areSame)(t,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),E=await this.updateRemoteUserData(JSON.stringify(o),R?null:E.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),E}parseSnippets(y){return w(y)}toSnippetsContents(y){const E={};for(const R of Object.keys(y))E[R]=y[R].value.toString();return E}async getSnippetsFileContents(){const y={};let E;try{E=await this.fileService.resolve(this.snippetsFolder)}catch(R){if(R instanceof D.FileOperationError&&R.fileOperationResult===1)return y;throw R}for(const R of E.children||[]){const t=R.resource,o=this.extUri.extname(t);if(o===".json"||o===".code-snippets"){const n=this.extUri.relativePath(this.snippetsFolder,t),s=await this.fileService.readFile(t);y[n]=s}}return y}};e.SnippetsSynchroniser=c,e.SnippetsSynchroniser=c=ve([Y(2,k.IEnvironmentService),Y(3,D.IFileService),Y(4,P.IStorageService),Y(5,g.IUserDataSyncStoreService),Y(6,g.IUserDataSyncBackupStoreService),Y(7,g.IUserDataSyncLogService),Y(8,A.IConfigurationService),Y(9,g.IUserDataSyncEnablementService),Y(10,v.ITelemetryService),Y(11,I.IUriIdentityService)],c);let l=class extends S.AbstractInitializer{constructor(y,E,R,t,o,n){super("snippets",E,R,t,y,o,n)}async doInitialize(y){const E=y.syncData?JSON.parse(y.syncData.content):null;if(!E){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(E)){const o=E[t];if(o){const n=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,t);await this.fileService.createFile(n,L.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(n))}}await this.updateLastSyncUserData(y)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(y){return y.fileOperationResult===1}}};e.SnippetsInitializer=l,e.SnippetsInitializer=l=ve([Y(0,D.IFileService),Y(1,C.IUserDataProfilesService),Y(2,k.IEnvironmentService),Y(3,g.IUserDataSyncLogService),Y(4,P.IStorageService),Y(5,I.IUriIdentityService)],l)}),define(oe[119],ae([0,1,14,18,15,13,19,20,28,17,39,23]),function(te,e,L,N,T,A,k,D,P,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function S(c,l){try{return JSON.parse(c).tasks??null}catch(h){return l.error(h),null}}e.getTasksContentFromSyncContent=S;let u=class extends I.AbstractFileSynchroniser{constructor(l,h,y,E,R,t,o,n,s,i,r,a){super(l.tasksResource,{syncResource:"tasks",profile:l},h,n,s,i,y,E,o,r,R,t,a),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(l,h,y,E){const R=l.syncData?S(l.syncData.content,this.logService):null;h=h===null&&y?l:h;const t=h?.syncData?S(h.syncData.content,this.logService):null,o=await this.getLocalFileContent();let n=null,s=!1,i=!1,r=!1;if(l.syncData){const m=o?o.value.toString():null;if(!t||t!==m||t!==R){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const d=w(m,R,t);n=d.content,r=d.hasConflicts,s=d.hasLocalChanged,i=d.hasRemoteChanged}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),i=!0);const a={content:r?t:n,localChange:s?o?2:1:0,remoteChange:i?2:0,hasConflicts:r},p=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:t,localResource:this.localResource,localContent:p,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:R,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(l){const h=l?.syncData?S(l.syncData.content,this.logService):null;if(h===null)return!0;const y=await this.getLocalFileContent(),E=y?y.value.toString():null,R=w(E,h,h);return R.hasLocalChanged||R.hasRemoteChanged}async getMergeResult(l,h){return l.previewResult}async getAcceptResult(l,h,y,E){if(this.extUri.isEqual(h,this.localResource))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(h,this.remoteResource))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(h,this.previewResource))return y===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:y,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${h.toString()}`)}async applyResult(l,h,y,E){const{fileContent:R}=y[0][0],{content:t,localChange:o,remoteChange:n}=y[0][1];if(o===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),R&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(R.value.toString()))),t?await this.updateLocalFileContent(t,R,E):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const s=JSON.stringify(this.toTasksSyncContent(t));l=await this.updateRemoteUserData(s,E?null:l.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}h?.ref!==l.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(l),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(l){return this.extUri.isEqual(this.remoteResource,l)||this.extUri.isEqual(this.baseResource,l)||this.extUri.isEqual(this.localResource,l)||this.extUri.isEqual(this.acceptedResource,l)?this.resolvePreviewContent(l):null}toTasksSyncContent(l){return l?{tasks:l}:{}}};e.TasksSynchroniser=u,e.TasksSynchroniser=u=ve([Y(2,C.IUserDataSyncStoreService),Y(3,C.IUserDataSyncBackupStoreService),Y(4,C.IUserDataSyncLogService),Y(5,N.IConfigurationService),Y(6,C.IUserDataSyncEnablementService),Y(7,A.IFileService),Y(8,T.IEnvironmentService),Y(9,k.IStorageService),Y(10,D.ITelemetryService),Y(11,P.IUriIdentityService)],u);let g=class extends I.AbstractInitializer{constructor(l,h,y,E,R,t){super("tasks",h,y,E,l,R,t),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(l){const h=l.syncData?S(l.syncData.content,this.logService):null;if(!h){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,L.VSBuffer.fromString(h)),await this.updateLastSyncUserData(l)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=g,e.TasksInitializer=g=ve([Y(0,A.IFileService),Y(1,v.IUserDataProfilesService),Y(2,T.IEnvironmentService),Y(3,C.IUserDataSyncLogService),Y(4,k.IStorageService),Y(5,P.IUriIdentityService)],g);function w(c,l,h){if(c===null&&l===null&&h===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(c===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const y=h!==c,E=h!==l;return!y&&!E?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:y&&!E?{content:c,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:E&&!y?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:c,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[120],ae([0,1,41,18,15,13,19,20,28,17,39,231,23]),function(te,e,L,N,T,A,k,D,P,v,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let u=class extends I.AbstractSynchroniser{constructor(l,h,y,E,R,t,o,n,s,i,r,a,p){super({syncResource:"profiles",profile:l},h,E,R,t,o,n,r,a,s,i,p),this.userDataProfilesService=y,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(y.onDidChangeProfiles(()=>this.triggerLocalChange()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?w(l.syncData):null}async getRemoteSyncedProfiles(l){const h=await this.getLastSyncUserData(),y=await this.getLatestRemoteUserData(l,h);return y?.syncData?w(y.syncData):null}async generateSyncPreview(l,h,y){if(!this.userDataProfilesService.isEnabled())throw new S.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const E=l.syncData?w(l.syncData):null,R=h?.syncData?w(h.syncData):null,t=this.getLocalUserDataProfiles(),{local:o,remote:n}=(0,C.merge)(t,E,R,[]),s={local:o,remote:n,content:R?this.stringifyRemoteProfiles(R):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},i=g(t,!1);return[{baseResource:this.baseResource,baseContent:R?this.stringifyRemoteProfiles(R):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:E?this.stringifyRemoteProfiles(E):null,remoteProfiles:E,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(l){const h=l?.syncData?w(l.syncData):null,y=this.getLocalUserDataProfiles(),{remote:E}=(0,C.merge)(y,h,h,[]);return!!E?.added.length||!!E?.removed.length||!!E?.updated.length}async getMergeResult(l,h){return{...l.previewResult,hasConflicts:!1}}async getAcceptResult(l,h,y,E){if(this.extUri.isEqual(h,this.localResource))return this.acceptLocal(l);if(this.extUri.isEqual(h,this.remoteResource))return this.acceptRemote(l);if(this.extUri.isEqual(h,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${h.toString()}`)}async acceptLocal(l){const h=this.getLocalUserDataProfiles(),y=(0,C.merge)(h,null,null,[]),{local:E,remote:R}=y;return{content:l.localContent,local:E,remote:R,localChange:E.added.length>0||E.removed.length>0||E.updated.length>0?2:0,remoteChange:R!==null?2:0}}async acceptRemote(l){const h=l.remoteContent?JSON.parse(l.remoteContent):null,y=[],E=[];for(const R of this.getLocalUserDataProfiles()){const t=h?.find(o=>o.id===R.id);t&&(y.push({id:R.id,name:R.name,collection:t.collection}),E.push(R))}if(h!==null){const R=(0,C.merge)(E,h,y,[]),{local:t,remote:o}=R;return{content:l.remoteContent,local:t,remote:o,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(l,h,y,E){const{local:R,remote:t,localChange:o,remoteChange:n}=y[0][1];o===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const s=y[0][0].remoteProfiles||[];if(s.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new S.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.backupLocal(g(this.getLocalUserDataProfiles(),!1));const i=[];for(const r of R.added)i.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${r.name}' profile...`),await this.userDataProfilesService.createProfile(r.id,r.name,{shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${r.name}'.`)})());for(const r of R.removed)i.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${r.name}' profile...`),await this.userDataProfilesService.removeProfile(r),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${r.name}'.`)})());for(const r of R.updated){const a=this.userDataProfilesService.profiles.find(p=>p.id===r.id);a?i.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Updating '${r.name}' profile...`),await this.userDataProfilesService.updateProfile(a,{name:r.name,shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${r.name}'.`)})()):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(i)}if(n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const i=[],r=s.length+(t?.added.length??0)<=20;if(r)for(const a of t?.added||[]){const p=await this.userDataSyncStoreService.createCollection(this.syncHeaders);i.push(p),s.push({id:a.id,name:a.name,collection:p,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const a of t?.removed||[])s.splice(s.findIndex(({id:p})=>a.id===p),1);for(const a of t?.updated||[]){const p=s.find(({id:m})=>a.id===m);p&&s.splice(s.indexOf(p),1,{...p,id:a.id,name:a.name,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(s,E?null:l.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${r&&t?.added.length?` Added: ${JSON.stringify(t.added.map(a=>a.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(a=>a.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(a=>a.name))}.`:""}`)}catch(a){if(i.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const p of i)await this.userDataSyncStoreService.deleteCollection(p,this.syncHeaders)}throw a}for(const a of t?.removed||[])await this.userDataSyncStoreService.deleteCollection(a.collection,this.syncHeaders)}h?.ref!==l.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(l),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,h){return this.updateRemoteUserData(this.stringifyRemoteProfiles(l),h)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(l){if(this.extUri.isEqual(this.remoteResource,l)||this.extUri.isEqual(this.baseResource,l)||this.extUri.isEqual(this.localResource,l)||this.extUri.isEqual(this.acceptedResource,l)){const h=await this.resolvePreviewContent(l);return h&&(0,L.toFormattedString)(JSON.parse(h),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(l=>!l.isDefault&&!l.isTransient)}stringifyRemoteProfiles(l){return JSON.stringify([...l].sort((h,y)=>h.name.localeCompare(y.name)))}};e.UserDataProfilesManifestSynchroniser=u,e.UserDataProfilesManifestSynchroniser=u=ve([Y(2,v.IUserDataProfilesService),Y(3,A.IFileService),Y(4,T.IEnvironmentService),Y(5,k.IStorageService),Y(6,S.IUserDataSyncStoreService),Y(7,S.IUserDataSyncBackupStoreService),Y(8,S.IUserDataSyncLogService),Y(9,N.IConfigurationService),Y(10,S.IUserDataSyncEnablementService),Y(11,D.ITelemetryService),Y(12,P.IUriIdentityService)],u);function g(c,l){const h=[...c].sort((y,E)=>y.name.localeCompare(E.name)).map(y=>({id:y.id,name:y.name}));return l?(0,L.toFormattedString)(h,{}):JSON.stringify(h)}e.stringifyLocalProfiles=g;function w(c){return JSON.parse(c.content)}e.parseUserDataProfilesManifest=w}),define(oe[248],ae([0,1,6,14,61,2,22,18,15,13,17,23]),function(te,e,L,N,T,A,k,D,P,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let S=class extends A.Disposable{constructor(g,w,c,l,h){super(),this.environmentService=g,this.fileService=w,this.configurationService=c,this.logService=l,this.userDataProfilesService=h,this.cleanUp()}async cleanUp(){for(const w of this.userDataProfilesService.profiles)for(const c of C.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(w,c))}catch(l){this.logService.error(l)}let g;try{g=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(w){(0,v.toFileOperationResult)(w)!==1&&this.logService.error(w);return}if(g.children){for(const w of g.children)if(w.isDirectory&&!this.userDataProfilesService.profiles.some(c=>c.id===w.name))try{this.logService.info("Deleting non existing profile from backup",w.resource.path),await this.fileService.del(w.resource,{recursive:!0})}catch(c){this.logService.error(c)}}}async getAllRefs(g,w){const c=this.getResourceBackupHome(g,w);try{const l=await this.fileService.resolve(c);if(l.children)return l.children.filter(y=>y.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(y.name)).sort().reverse().map(y=>({ref:y.name,created:this.getCreationTime(y)}))}catch(l){if((0,v.toFileOperationResult)(l)!==1)throw l}return[]}async resolveContent(g,w,c){const l=this.getResourceBackupHome(g,w),h=(0,k.joinPath)(l,c);try{return(await this.fileService.readFile(h)).value.toString()}catch(y){return this.logService.error(y),null}}async backup(g,w,c){const l=this.getResourceBackupHome(g,w),h=(0,k.joinPath)(l,`${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(h,N.VSBuffer.fromString(c))}catch(y){this.logService.error(y)}try{this.cleanUpBackup(l)}catch{}}getResourceBackupHome(g,w){return(0,k.joinPath)(this.environmentService.userDataSyncHome,...g.isDefault?[w]:[g.id,w])}async cleanUpBackup(g){try{try{if(!await this.fileService.exists(g))return}catch{return}const w=await this.fileService.resolve(g);if(w.children){const c=w.children.filter(E=>E.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(E.name)).sort(),l=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let h=c.filter(E=>Date.now()-this.getCreationTime(E)>l);const y=c.length-h.length;y<10&&(h=h.slice(10-y)),await L.Promises.settled(h.map(async E=>{this.logService.info("Deleting from backup",E.resource.path),await this.fileService.del(E.resource)}))}}catch(w){this.logService.error(w)}}getCreationTime(g){return g.ctime||new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};e.UserDataSyncBackupStoreService=S,e.UserDataSyncBackupStoreService=S=ve([Y(0,P.IEnvironmentService),Y(1,v.IFileService),Y(2,D.IConfigurationService),Y(3,C.IUserDataSyncLogService),Y(4,I.IUserDataProfilesService)],S)}),define(oe[249],ae([0,1,3,2,5,15,19,20,23]),function(te,e,L,N,T,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const v="sync.enable";let I=class extends N.Disposable{constructor(S,u,g,w){super(),this.storageService=S,this.telemetryService=u,this.environmentService=g,this.userDataSyncStoreManagementService=w,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(S.onDidChangeValue(c=>this.onDidStorageChange(c)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(v,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(S){S&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(v,{enabled:S}),this.storageService.store(v,S,-1,1))}isResourceEnabled(S){return this.storageService.getBoolean((0,P.getEnablementKey)(S),-1,!0)}setResourceEnablement(S,u){if(this.isResourceEnabled(S)!==u){const g=(0,P.getEnablementKey)(S);this.storeResourceEnablement(g,u)}}getResourceSyncStateVersion(S){}storeResourceEnablement(S,u){this.storageService.store(S,u,-1,T.isWeb?0:1)}onDidStorageChange(S){if(S.scope!==-1)return;if(v===S.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const u=P.ALL_SYNC_RESOURCES.filter(g=>(0,P.getEnablementKey)(g)===S.key)[0];if(u){this._onDidChangeResourceEnablement.fire([u,this.isResourceEnabled(u)]);return}}};e.UserDataSyncEnablementService=I,e.UserDataSyncEnablementService=I=ve([Y(0,k.IStorageService),Y(1,D.ITelemetryService),Y(2,A.IEnvironmentService),Y(3,P.IUserDataSyncStoreManagementService)],I)}),define(oe[79],ae([0,1,3,2,5,27,172,15,13,4,24,44,19,23]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,v.createDecorator)("IUserDataSyncMachinesService");const g="sync.currentMachineName",w="Safari",c="Chrome",l="Edge",h="Firefox",y="Android";function E(o){switch(o){case w:case c:case l:case h:case y:case(0,T.PlatformToString)(0):return!0}return!1}e.isWebPlatform=E;function R(){return T.isSafari?w:T.isChrome?c:T.isEdge?l:T.isFirefox?h:T.isAndroid?y:(0,T.PlatformToString)(T.isWeb?0:T.platform)}let t=class it extends N.Disposable{static{this.VERSION=1}static{this.RESOURCE="machines"}constructor(n,s,i,r,a,p){super(),this.storageService=i,this.userDataSyncStoreService=r,this.logService=a,this.productService=p,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(n,s,i)}async getMachines(n){const s=await this.currentMachineIdPromise;return(await this.readMachinesData(n)).machines.map(r=>({...r,isCurrent:r.id===s}))}async addCurrentMachine(n){const s=await this.currentMachineIdPromise,i=await this.readMachinesData(n);i.machines.some(({id:r})=>r===s)||(i.machines.push({id:s,name:this.computeCurrentMachineName(i.machines),platform:R()}),await this.writeMachinesData(i))}async removeCurrentMachine(n){const s=await this.currentMachineIdPromise,i=await this.readMachinesData(n),r=i.machines.filter(({id:a})=>a!==s);r.length!==i.machines.length&&(i.machines=r,await this.writeMachinesData(i))}async renameMachine(n,s,i){const r=await this.readMachinesData(i),a=r.machines.find(({id:p})=>p===n);if(a){a.name=s,await this.writeMachinesData(r);const p=await this.currentMachineIdPromise;n===p&&this.storageService.store(g,s,-1,1)}}async setEnablements(n){const s=await this.readMachinesData();for(const[i,r]of n){const a=s.machines.find(p=>p.id===i);a&&(a.disabled=r?void 0:!0)}await this.writeMachinesData(s)}computeCurrentMachineName(n){const s=this.storageService.get(g,-1);if(s)return s;const i=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${R()} (${this.productService.nameShort})`,r=new RegExp(`${(0,A.escapeRegExpCharacters)(i)}\\s#(\\d+)`);let a=0;for(const p of n){const m=r.exec(p.name),d=m?parseInt(m[1]):0;a=d>a?d:a}return`${i} #${a+1}`}async readMachinesData(n){this.userData=await this.readUserData(n);const s=this.parse(this.userData);if(s.version!==it.VERSION)throw new Error((0,k.localize)(0,null,this.productService.nameLong));return s}async writeMachinesData(n){const s=JSON.stringify(n),i=await this.userDataSyncStoreService.writeResource(it.RESOURCE,s,this.userData?.ref||null);this.userData={ref:i,content:s},this._onDidChange.fire()}async readUserData(n){if(this.userData){const s=n&&n.latest?n.latest[it.RESOURCE]:void 0;if(this.userData.ref===s)return this.userData;if(s===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(it.RESOURCE,this.userData)}parse(n){if(n.content!==null)try{return JSON.parse(n.content)}catch(s){this.logService.error(s)}return{version:it.VERSION,machines:[]}}};e.UserDataSyncMachinesService=t,e.UserDataSyncMachinesService=t=ve([Y(0,D.IEnvironmentService),Y(1,P.IFileService),Y(2,S.IStorageService),Y(3,u.IUserDataSyncStoreService),Y(4,u.IUserDataSyncLogService),Y(5,I.IProductService)],t)}),define(oe[250],ae([0,1,6,61,38,7,3,2,5,22,10,169,24,19,20,23,76,79]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const h="sync.disableMachineEventually",y="sync.sessionId",E="sync.storeUrl",R="sync.productQuality";let t=class extends D.Disposable{get syncUrl(){const s=this.storageService.get(E,-1);return s?I.URI.parse(s):void 0}set syncUrl(s){s?this.storageService.store(E,s.toString(),-1,1):this.storageService.remove(E,-1)}get productQuality(){return this.storageService.get(R,-1)}set productQuality(s){s?this.storageService.store(R,s,-1,1):this.storageService.remove(R,-1)}constructor(s,i,r,a,p,m,d,b,O,F){super(),this.userDataSyncStoreManagementService=i,this.userDataSyncStoreService=r,this.userDataSyncEnablementService=a,this.userDataSyncService=p,this.logService=m,this.userDataSyncAccountService=d,this.telemetryService=b,this.userDataSyncMachinesService=O,this.storageService=F,this.autoSync=this._register(new D.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new L.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=i.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=s.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(i.onDidChangeUserDataSyncStore(()=>{(0,v.isEqual)(this.syncUrl,i.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=i.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(d.onDidChangeAccount(()=>this.updateAutoSync())),this._register(r.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(p.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this._register(k.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:s,message:i}=this.isAutoSyncEnabled();s?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.telemetryService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(r=>this.onDidFinishSync(r))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(i&&this.logService.info(i),this.autoSync.clear()):i&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(i))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(s,i,r){try{this.userDataSyncAccountService.account&&!r&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(y,-1),s?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(this.logService.error(a),i)this.updateEnablement(!1);else throw a}}updateEnablement(s){this.userDataSyncEnablementService.isEnabled()!==s&&(this.userDataSyncEnablementService.setEnablement(s),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(s){if(!s){this.successiveFailures=0;return}const i=w.UserDataSyncError.toUserDataSyncError(s);i instanceof w.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:i.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?P.isWeb&&i.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(i),this.successiveFailures++),this._onError.fire(i)}async disableMachineEventually(){this.storageService.store(h,!0,-1,1),await(0,L.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(h,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(h,-1)}async triggerSync(s,i,r){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(i&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...s),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const a=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:a}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",r)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=t,e.UserDataAutoSyncService=t=ve([Y(0,S.IProductService),Y(1,w.IUserDataSyncStoreManagementService),Y(2,w.IUserDataSyncStoreService),Y(3,w.IUserDataSyncEnablementService),Y(4,w.IUserDataSyncService),Y(5,w.IUserDataSyncLogService),Y(6,c.IUserDataSyncAccountService),Y(7,g.ITelemetryService),Y(8,l.IUserDataSyncMachinesService),Y(9,u.IStorageService)],t);class o extends D.Disposable{static{this.INTERVAL_SYNCING="Interval"}constructor(s,i,r,a,p,m,d,b,O){super(),this.lastSyncUrl=s,this.interval=i,this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=a,this.userDataSyncService=p,this.userDataSyncMachinesService=m,this.logService=d,this.telemetryService=b,this.storageService=O,this.intervalHandler=this._register(new D.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,D.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,L.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(s,i){const r=(0,L.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(p){if((0,A.isCancellationError)(p))return}return this.doSync(s,i,a)});return this.syncPromise=r,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,v.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const s=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),i=this.userDataSyncStoreManagementService.userDataSyncStore;return!!i&&!!s&&(!(0,v.isEqual)(i.defaultUrl,s.defaultUrl)||!(0,v.isEqual)(i.insidersUrl,s.insidersUrl)||!(0,v.isEqual)(i.stableUrl,s.stableUrl))}async doSync(s,i,r){this.logService.info(`Auto Sync: Triggered by ${s}`),this._onDidStartSync.fire();let a;try{await this.createAndRunSyncTask(i,r)}catch(p){if(this.logService.error(p),a=p,w.UserDataSyncError.toUserDataSyncError(p).code==="MethodNotFound")try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(i,r),a=void 0}catch(m){this.logService.error(m),a=m}}this._onDidFinishSync.fire(a)}async createAndRunSyncTask(s,i){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),i.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new w.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new w.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new w.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const r=this.storageService.get(y,-1);if(r&&this.manifest&&r!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new w.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new w.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new w.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const a=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(i.isCancellationRequested)return;const p=a.find(d=>d.isCurrent);if(p?.disabled)throw new w.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");const m=new Date().getTime();if(await this.syncTask.run(),this.telemetryService.publicLog2("settingsSync:sync",{duration:new Date().getTime()-m}),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(d){throw new w.UserDataAutoSyncError((0,T.toErrorMessage)(d),d instanceof w.UserDataSyncError?d.code:"Unknown")}this.manifest&&this.manifest.session!==r&&this.storageService.store(y,this.manifest.session,-1,1),!i.isCancellationRequested&&(p||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(s){return super._register(s)}}}),define(oe[251],ae([0,1,10,173,15,13,44,19,28,23,17,39,118,117,116,18,119,114,115,4,120,41]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h,y,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let t=class ze{static{this.NOT_EXISTING_RESOURCE="not-existing-resource"}static{this.REMOTE_BACKUP_AUTHORITY="remote-backup"}static{this.LOCAL_BACKUP_AUTHORITY="local-backup"}constructor(n,s,i,r,a,p,m,d,b,O){this.userDataSyncStoreService=n,this.userDataSyncBackupStoreService=s,this.logService=i,this.environmentService=a,this.storageService=p,this.fileService=m,this.userDataProfilesService=d,this.configurationService=b,this.instantiationService=O,this.extUri=r.extUri}async getRemoteSyncedProfiles(){const n=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(n.content){const s=this.parseSyncData(n.content,"profiles");return(0,E.parseUserDataProfilesManifest)(s)}return[]}async getRemoteSyncResourceHandles(n,s){return(await this.userDataSyncStoreService.getAllResourceRefs(n,s?.collection)).map(({created:r,ref:a})=>({created:r,uri:this.toUri({remote:!0,syncResource:n,profile:s?.id??this.userDataProfilesService.defaultProfile.id,collection:s?.collection,ref:a,node:void 0})}))}async getLocalSyncResourceHandles(n,s){return(await this.userDataSyncBackupStoreService.getAllRefs(s,n)).map(({created:r,ref:a})=>({created:r,uri:this.toUri({remote:!1,syncResource:n,profile:s.id,collection:void 0,ref:a,node:void 0})}))}resolveUserDataSyncResource({uri:n}){const s=this.resolveUri(n),i=s?this.userDataProfilesService.profiles.find(r=>r.id===s.profile):void 0;return s&&i?{profile:i,syncResource:s?.syncResource}:void 0}async getAssociatedResources({uri:n}){const s=this.resolveUri(n);if(!s)return[];const i=this.userDataProfilesService.profiles.find(r=>r.id===s.profile);switch(s.syncResource){case"settings":return this.getSettingsAssociatedResources(n,i);case"keybindings":return this.getKeybindingsAssociatedResources(n,i);case"tasks":return this.getTasksAssociatedResources(n,i);case"snippets":return this.getSnippetsAssociatedResources(n,i);case"globalState":return this.getGlobalStateAssociatedResources(n,i);case"extensions":return this.getExtensionsAssociatedResources(n,i);case"profiles":return this.getProfilesAssociatedResources(n,i);case"workspaceState":return[]}}async getMachineId({uri:n}){const s=this.resolveUri(n);if(s){if(s.remote){if(s.ref){const{content:i}=await this.getUserData(s.syncResource,s.ref,s.collection);if(i)return this.parseSyncData(i,s.syncResource)?.machineId}return}return(0,k.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(n){const s=this.resolveUri(n);if(!s||s.node===ze.NOT_EXISTING_RESOURCE)return null;if(s.ref){const i=await this.getContentFromStore(s.remote,s.syncResource,s.profile,s.collection,s.ref);return s.node&&i?this.resolveNodeContent(s.syncResource,i,s.node):i}return!s.remote&&!s.node?this.resolveLatestContent(s.syncResource,s.profile):null}async getContentFromStore(n,s,i,r,a){if(n){const{content:m}=await this.getUserData(s,a,r);return m}const p=this.userDataProfilesService.profiles.find(m=>m.id===i);return p?this.userDataSyncBackupStoreService.resolveContent(p,s,a):null}resolveNodeContent(n,s,i){const r=this.parseSyncData(s,n);switch(n){case"settings":return this.resolveSettingsNodeContent(r,i);case"keybindings":return this.resolveKeybindingsNodeContent(r,i);case"tasks":return this.resolveTasksNodeContent(r,i);case"snippets":return this.resolveSnippetsNodeContent(r,i);case"globalState":return this.resolveGlobalStateNodeContent(r,i);case"extensions":return this.resolveExtensionsNodeContent(r,i);case"profiles":return this.resolveProfileNodeContent(r,i);case"workspaceState":return null}}async resolveLatestContent(n,s){const i=this.userDataProfilesService.profiles.find(r=>r.id===s);if(!i)return null;switch(n){case"globalState":return this.resolveLatestGlobalStateContent(i);case"extensions":return this.resolveLatestExtensionsContent(i);case"profiles":return this.resolveLatestProfilesContent(i);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}getSettingsAssociatedResources(n,s){const i=this.extUri.joinPath(n,"settings.json"),r=s?s.settingsResource:this.extUri.joinPath(n,ze.NOT_EXISTING_RESOURCE);return[{resource:i,comparableResource:r}]}resolveSettingsNodeContent(n,s){switch(s){case"settings.json":return(0,u.parseSettingsSyncContent)(n.content).settings}return null}getKeybindingsAssociatedResources(n,s){const i=this.extUri.joinPath(n,"keybindings.json"),r=s?s.keybindingsResource:this.extUri.joinPath(n,ze.NOT_EXISTING_RESOURCE);return[{resource:i,comparableResource:r}]}resolveKeybindingsNodeContent(n,s){switch(s){case"keybindings.json":return(0,g.getKeybindingsContentFromSyncContent)(n.content,!!this.configurationService.getValue(v.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(n,s){const i=this.extUri.joinPath(n,"tasks.json"),r=s?s.tasksResource:this.extUri.joinPath(n,ze.NOT_EXISTING_RESOURCE);return[{resource:i,comparableResource:r}]}resolveTasksNodeContent(n,s){switch(s){case"tasks.json":return(0,c.getTasksContentFromSyncContent)(n.content,this.logService)}return null}async getSnippetsAssociatedResources(n,s){const i=await this.resolveContent(n);if(i){const r=this.parseSyncData(i,"snippets");if(r){const a=(0,S.parseSnippets)(r),p=[];for(const m of Object.keys(a)){const d=this.extUri.joinPath(n,m),b=s?this.extUri.joinPath(s.snippetsHome,m):this.extUri.joinPath(n,ze.NOT_EXISTING_RESOURCE);p.push({resource:d,comparableResource:b})}return p}}return[]}resolveSnippetsNodeContent(n,s){return(0,S.parseSnippets)(n)[s]||null}getExtensionsAssociatedResources(n,s){const i=this.extUri.joinPath(n,"extensions.json"),r=s?this.toUri({remote:!1,syncResource:"extensions",profile:s.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(n,ze.NOT_EXISTING_RESOURCE);return[{resource:i,comparableResource:r}]}resolveExtensionsNodeContent(n,s){switch(s){case"extensions.json":return(0,l.stringify)((0,l.parseExtensions)(n),!0)}return null}async resolveLatestExtensionsContent(n){const{localExtensions:s}=await this.instantiationService.createInstance(l.LocalExtensionsProvider).getLocalExtensions(n);return(0,l.stringify)(s,!0)}getGlobalStateAssociatedResources(n,s){const i=this.extUri.joinPath(n,"globalState.json"),r=s?this.toUri({remote:!1,syncResource:"globalState",profile:s.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(n,ze.NOT_EXISTING_RESOURCE);return[{resource:i,comparableResource:r}]}resolveGlobalStateNodeContent(n,s){switch(s){case"globalState.json":return(0,h.stringify)(JSON.parse(n.content),!0)}return null}async resolveLatestGlobalStateContent(n){const s=await this.instantiationService.createInstance(h.LocalGlobalStateProvider).getLocalGlobalState(n);return(0,h.stringify)(s,!0)}getProfilesAssociatedResources(n,s){const i=this.extUri.joinPath(n,"profiles.json"),r=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:i,comparableResource:r}]}resolveProfileNodeContent(n,s){switch(s){case"profiles.json":return(0,R.toFormattedString)(JSON.parse(n.content),{})}return null}async resolveLatestProfilesContent(n){return(0,E.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(s=>!s.isDefault&&!s.isTransient),!0)}toUri(n){const s=n.remote?ze.REMOTE_BACKUP_AUTHORITY:ze.LOCAL_BACKUP_AUTHORITY,i=[n.syncResource,n.profile];return n.collection&&i.push(`collection:${n.collection}`),n.ref&&i.push(`ref:${n.ref}`),n.node&&i.push(n.node),this.extUri.joinPath(L.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:s,path:"/"}),...i)}resolveUri(n){if(n.scheme!==v.USER_DATA_SYNC_SCHEME||n.authority!==ze.LOCAL_BACKUP_AUTHORITY&&n.authority!==ze.REMOTE_BACKUP_AUTHORITY)return;const s=[];for(;n.path!=="/";)s.unshift(this.extUri.basename(n)),n=this.extUri.dirname(n);if(s.length<2)return;const i=n.authority===ze.REMOTE_BACKUP_AUTHORITY,r=s.shift(),a=s.shift();let p,m,d;for(;s.length;){const b=s.shift();b.startsWith("collection:")?p=b.substring(11):b.startsWith("ref:")?m=b.substring(4):d=b}return{remote:i,syncResource:r,profile:a,collection:p,ref:m,node:d}}parseSyncData(n,s){try{const i=JSON.parse(n);if((0,C.isSyncData)(i))return i}catch(i){this.logService.error(i)}throw new v.UserDataSyncError((0,N.localize)(0,null),"IncompatibleRemoteContent",s)}async getUserData(n,s,i){const r=await this.userDataSyncStoreService.resolveResourceContent(n,s,i);return{ref:s,content:r}}};e.UserDataSyncResourceProviderService=t,e.UserDataSyncResourceProviderService=t=ve([Y(0,v.IUserDataSyncStoreService),Y(1,v.IUserDataSyncBackupStoreService),Y(2,v.IUserDataSyncLogService),Y(3,P.IUriIdentityService),Y(4,T.IEnvironmentService),Y(5,D.IStorageService),Y(6,A.IFileService),Y(7,I.IUserDataProfilesService),Y(8,w.IConfigurationService),Y(9,y.IInstantiationService)],t)}),define(oe[252],ae([0,1,21,6,25,38,3,2,22,11,32,18,29,4,19,20,17,114,115,116,117,118,119,120,23]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h,y,E,R,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const s="sync.lastSyncTime";let i=class extends D.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(d,b,O,F,M,q,j,B,Q){super(),this.userDataSyncStoreService=d,this.userDataSyncStoreManagementService=b,this.instantiationService=O,this.logService=F,this.telemetryService=M,this.storageService=q,this.userDataSyncEnablementService=j,this.userDataProfilesService=B,this.userDataSyncResourceProviderService=Q,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=b.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(s,-1,void 0),this._register((0,D.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(d,b){this.checkEnablement(),this.logService.info("Sync started.");const O=new Date().getTime(),F=(0,I.generateUuid)();try{const B=(0,n.createSyncHeaders)(F);b&&(B["Cache-Control"]="no-cache"),d=await this.userDataSyncStoreService.manifest(d,B)}catch(B){const Q=n.UserDataSyncError.toUserDataSyncError(B);throw p(Q,F,this.userDataSyncStoreManagementService,this.telemetryService),Q}const M=!1,q=this;let j;return{manifest:d,async run(){if(M)throw new Error("Can run a task only once");j=(0,N.createCancelablePromise)(B=>q.sync(d,!1,F,B)),await j.finally(()=>j=void 0),q.logService.info(`Sync done. Took ${new Date().getTime()-O}ms`),q.updateLastSyncTime()},stop(){return j?.cancel(),q.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new n.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const d=new Date().getTime(),b=(0,I.generateUuid)(),O=(0,n.createSyncHeaders)(b);let F;try{F=await this.userDataSyncStoreService.manifest(null,O)}catch(j){const B=n.UserDataSyncError.toUserDataSyncError(j);throw p(B,b,this.userDataSyncStoreManagementService,this.telemetryService),B}await this.resetLocal();const M=this,q=new T.CancellationTokenSource;return{id:b,async merge(){return M.sync(F,!0,b,q.token)},async apply(){try{try{await M.applyManualSync(F,b,q.token)}catch(j){if(n.UserDataSyncError.toUserDataSyncError(j).code==="MethodNotFound")M.logService.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.logService.info("Applying manual sync again..."),await M.applyManualSync(F,b,q.token);else throw j}}catch(j){throw M.logService.error(j),j}M.logService.info(`Sync done. Took ${new Date().getTime()-d}ms`),M.updateLastSyncTime()},async stop(){q.cancel(),await M.stop(),await M.resetLocal()}}}async sync(d,b,O,F){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(M,d,b,O,F));const q=M.enabled.find(j=>j.resource==="profiles");if(q){const j=await q.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.syncRemoteProfiles(j,d,b,O,F)}}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(d,b,O,F,M){for(const q of d){if(M.isCancellationRequested)return;const j=this.userDataProfilesService.profiles.find(Q=>Q.id===q.id);if(!j){this.logService.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",q.name);const B=this.getOrCreateActiveProfileSynchronizer(j,q);this._syncErrors.push(...await this.syncProfile(B,b,O,F,M))}for(const[q,j]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(B=>B.id===j[0].profile.id)||(j[1].dispose(),this.activeProfileSynchronizers.delete(q))}async applyManualSync(d,b,O){const F=this.getActiveProfileSynchronizers();for(const Q of F){if(O.isCancellationRequested)return;await Q.apply(b,O)}const M=F.find(Q=>Q.profile.isDefault);if(!M)return;const q=M.enabled.find(Q=>Q.resource==="profiles");if(!q)return;const B=(await q.getRemoteSyncedProfiles(d?.latest??null)||[]).filter(Q=>F.every(J=>J.profile.id!==Q.id));B.length&&await this.syncRemoteProfiles(B,d,!1,b,O)}async syncProfile(d,b,O,F,M){return(await d.sync(b,O,F,M)).map(([j,B])=>({profile:d.profile,syncResource:j,error:B}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(d=>d.stop()))}async resolveContent(d){const b=await this.userDataSyncResourceProviderService.resolveContent(d);if(b)return b;for(const O of this.getActiveProfileSynchronizers())for(const F of O.enabled){const M=await F.resolveContent(d);if(M)return M}return null}async replace(d){this.checkEnablement();const b=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(d);if(!b)return;const O=await this.resolveContent(d.uri);O&&await this.performAction(b.profile,async F=>{if(b.syncResource===F.resource)return await F.replace(O),!0})}async accept(d,b,O,F){this.checkEnablement(),await this.performAction(d.profile,async M=>{if(d.syncResource===M.resource)return await M.accept(b,O),F&&await M.apply((0,v.isBoolean)(F)?!1:F.force,(0,n.createSyncHeaders)((0,I.generateUuid)())),!0})}getRemoteProfiles(){return this.userDataSyncResourceProviderService.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(d,b){return this.userDataSyncResourceProviderService.getRemoteSyncResourceHandles(d,b)}async getLocalSyncResourceHandles(d,b){return this.userDataSyncResourceProviderService.getLocalSyncResourceHandles(d,b??this.userDataProfilesService.defaultProfile)}async getAssociatedResources(d){return this.userDataSyncResourceProviderService.getAssociatedResources(d)}async getMachineId(d){return this.userDataSyncResourceProviderService.getMachineId(d)}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async b=>{if(b.resource!=="globalState"&&await b.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async b=>{if(await b.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(d){this.logService.error(d)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(s,-1);for(const[d]of this.activeProfileSynchronizers.values())try{await d.resetLocal()}catch(b){this.logService.error(b)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpRemoteData(){const d=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),b=d.map(q=>q.collection),O=await this.userDataSyncStoreService.getAllCollections(),F=O.filter(q=>!b.includes(q));F.length&&(this.logService.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(q=>this.userDataSyncStoreService.deleteCollection(q))),this.logService.info("Deleted redundant collections on server"));const M=d.filter(q=>O.includes(q.collection));if(M.length!==d.length){const q=this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{this.logService.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.logService.info("Did reset the last synced state of profiles"),this.logService.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(M,null),this.logService.info("Updated remote profiles on server")}finally{q.dispose()}}}async performAction(d,b){const O=new D.DisposableStore;try{const F=this.activeProfileSynchronizers.get(d.id);if(F){const Q=await this.performActionWithProfileSynchronizer(F[0],b,O);return(0,v.isUndefined)(Q)?null:Q}if(d.isDefault){const Q=O.add(this.instantiationService.createInstance(r,d,void 0)),J=await this.performActionWithProfileSynchronizer(Q,b,O);return(0,v.isUndefined)(J)?null:J}if(this.userDataProfilesService.isEnabled())return null;const M=O.add(this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,d,void 0)),q=await this.userDataSyncStoreService.manifest(null),B=(await M.getRemoteSyncedProfiles(q?.latest??null)||[]).find(Q=>Q.id===d.id);if(B){const Q=O.add(this.instantiationService.createInstance(r,d,B.collection)),J=await this.performActionWithProfileSynchronizer(Q,b,O);return(0,v.isUndefined)(J)?null:J}return null}finally{O.dispose()}}async performActionWithProfileSynchronizer(d,b,O){const F=[...d.enabled,...d.disabled.reduce((M,q)=>(q!=="workspaceState"&&M.push(O.add(d.createSynchronizer(q))),M),[])];for(const M of F){const q=await b(M);if(!(0,v.isUndefined)(q))return q}}setStatus(d){const b=this._status;this._status!==d&&(this._status=d,this._onDidChangeStatus.fire(d),b==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const d=this.getActiveProfileSynchronizers().map(b=>b.conflicts).flat();(0,L.equals)(this._conflicts,d,(b,O)=>b.profile.id===O.profile.id&&b.syncResource===O.syncResource&&(0,L.equals)(b.conflicts,O.conflicts,(F,M)=>(0,P.isEqual)(F.previewResource,M.previewResource)))||(this._conflicts=d,this._onDidChangeConflicts.fire(d))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(s,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(d,b){let O=this.activeProfileSynchronizers.get(d.id);if(O&&O[0].collection!==b?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),O[1].dispose(),O=void 0,this.activeProfileSynchronizers.delete(d.id)),!O){const F=new D.DisposableStore,M=F.add(this.instantiationService.createInstance(r,d,b?.collection));F.add(M.onDidChangeStatus(q=>this.setStatus(q))),F.add(M.onDidChangeConflicts(q=>this.updateConflicts())),F.add(M.onDidChangeLocal(q=>this._onDidChangeLocal.fire(q))),this.activeProfileSynchronizers.set(d.id,O=[M,F])}return O[0]}getActiveProfileSynchronizers(){const d=[];for(const[b]of this.activeProfileSynchronizers.values())d.push(b);return d}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,d])=>d.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=i,e.UserDataSyncService=i=ve([Y(0,n.IUserDataSyncStoreService),Y(1,n.IUserDataSyncStoreManagementService),Y(2,u.IInstantiationService),Y(3,n.IUserDataSyncLogService),Y(4,w.ITelemetryService),Y(5,g.IStorageService),Y(6,n.IUserDataSyncEnablementService),Y(7,c.IUserDataProfilesService),Y(8,n.IUserDataSyncResourceProviderService)],i);let r=class extends D.Disposable{get enabled(){return this._enabled.sort((d,b)=>d[1]-b[1]).map(([d])=>d)}get disabled(){return n.ALL_SYNC_RESOURCES.filter(d=>!this.userDataSyncEnablementService.isResourceEnabled(d))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(d,b,O,F,M,q,j,B,Q,J){super(),this.profile=d,this.collection=b,this.userDataSyncEnablementService=O,this.instantiationService=F,this.extensionGalleryService=M,this.userDataSyncStoreManagementService=q,this.telemetryService=j,this.logService=B,this.userDataProfilesService=Q,this.configurationService=J,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(O.onDidChangeResourceEnablement(([G,X])=>this.onDidChangeResourceEnablement(G,X))),this._register((0,D.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,G])=>G.dispose())));for(const G of n.ALL_SYNC_RESOURCES)O.isResourceEnabled(G)&&this.registerSynchronizer(G)}onDidChangeResourceEnablement(d,b){b?this.registerSynchronizer(d):this.deRegisterSynchronizer(d)}registerSynchronizer(d){if(this._enabled.some(([M])=>M.resource===d))return;if(d==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(d==="profiles"&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled())||d==="workspaceState")return;if(d!=="profiles"&&this.profile.useDefaultFlags?.[d]){this.logService.debug(`Skipping syncing ${d} in ${this.profile.name} because it is already synced by default profile`);return}const b=new D.DisposableStore,O=b.add(this.createSynchronizer(d));b.add(O.onDidChangeStatus(()=>this.updateStatus())),b.add(O.onDidChangeConflicts(()=>this.updateConflicts())),b.add(O.onDidChangeLocal(()=>this._onDidChangeLocal.fire(d)));const F=this.getOrder(d);this._enabled.push([O,F,b])}deRegisterSynchronizer(d){const b=this._enabled.findIndex(([O])=>O.resource===d);if(b!==-1){const[[O,,F]]=this._enabled.splice(b,1);F.dispose(),this.updateStatus(),Promise.allSettled([O.stop(),O.resetLocal()]).then(null,M=>this.logService.error(M))}}createSynchronizer(d){switch(d){case"settings":return this.instantiationService.createInstance(E.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.instantiationService.createInstance(y.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.instantiationService.createInstance(R.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.instantiationService.createInstance(t.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.instantiationService.createInstance(h.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.instantiationService.createInstance(l.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(d,b,O,F){if(F.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const q=[],j=(0,n.createSyncHeaders)(O),B=(this.collection?d?.collections?.[this.collection]?.latest:d?.latest)??null,Q=b?await this.getUserDataSyncConfiguration(B):{};for(const J of M){if(F.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(J.resource))return[];try{if(b){const G=await J.preview(B,Q,j);if(G)for(const X of G.resourcePreviews)(X.localChange!==0||X.remoteChange!==0)&&X.mergeState==="preview"&&await J.merge(X.previewResource)}else await J.sync(B,j)}catch(G){const X=n.UserDataSyncError.toUserDataSyncError(G);if(p(X,O,this.userDataSyncStoreManagementService,this.telemetryService),a(G))throw X;this.logService.error(G),this.logService.error(`${J.resource}: ${(0,A.toErrorMessage)(G)}`),q.push([J.resource,X])}}return q}finally{this.updateStatus()}}async apply(d,b){const O=(0,n.createSyncHeaders)(d);for(const F of this.enabled){if(b.isCancellationRequested)return;try{await F.apply(!1,O)}catch(M){const q=n.UserDataSyncError.toUserDataSyncError(M);if(p(q,d,this.userDataSyncStoreManagementService,this.telemetryService),a(M))throw q;this.logService.error(M),this.logService.error(`${F.resource}: ${(0,A.toErrorMessage)(M)}`)}}}async stop(){for(const d of this.enabled)try{d.status!=="idle"&&await d.stop()}catch(b){this.logService.error(b)}}async resetLocal(){for(const d of this.enabled)try{await d.resetLocal()}catch(b){this.logService.error(`${d.resource}: ${(0,A.toErrorMessage)(b)}`),this.logService.error(b)}}async getUserDataSyncConfiguration(d){if(!this.profile.isDefault)return{};const b=this.configurationService.getValue(n.USER_DATA_SYNC_CONFIGURATION_SCOPE),O=this.enabled.find(F=>F instanceof E.SettingsSynchroniser);if(O){const F=await O.getRemoteUserDataSyncConfiguration(d);return{...b,...F}}return b}setStatus(d){this._status!==d&&(this._status=d,this._onDidChangeStatus.fire(d))}updateStatus(){return this.updateConflicts(),this.enabled.some(d=>d.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(d=>d.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const d=this.enabled.filter(b=>b.status==="hasConflicts").filter(b=>b.conflicts.conflicts.length>0).map(b=>b.conflicts);(0,L.equals)(this._conflicts,d,(b,O)=>b.syncResource===O.syncResource&&(0,L.equals)(b.conflicts,O.conflicts,(F,M)=>(0,P.isEqual)(F.previewResource,M.previewResource)))||(this._conflicts=d,this._onDidChangeConflicts.fire(d))}getOrder(d){switch(d){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};r=ve([Y(2,n.IUserDataSyncEnablementService),Y(3,u.IInstantiationService),Y(4,S.IExtensionGalleryService),Y(5,n.IUserDataSyncStoreManagementService),Y(6,w.ITelemetryService),Y(7,n.IUserDataSyncLogService),Y(8,c.IUserDataProfilesService),Y(9,C.IConfigurationService)],r);function a(m){if(m instanceof n.UserDataSyncError)switch(m.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function p(m,d,b,O){O.publicLog2("sync/error",{code:m.code,serverCode:m instanceof n.UserDataSyncStoreError?String(m.serverCode):void 0,url:m instanceof n.UserDataSyncStoreError?m.url:void 0,resource:m.resource,executionId:d,service:b.userDataSyncStore.url.toString()})}}),define(oe[253],ae([0,1,3,2,10,17,23]),function(te,e,L,N,T,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function D(S,u){return{...S,profile:(0,A.reviveProfile)(S.profile,u.profilesHome.scheme)}}function P(S){return{created:S.created,uri:T.URI.revive(S.uri)}}class v{constructor(u,g,w){this.service=u,this.userDataProfilesService=g,this.logService=w,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new L.Emitter}listen(u,g){switch(g){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${g}`)}async call(u,g,w){try{return await this._call(u,g,w)}catch(c){throw this.logService.error(c),c}}async _call(u,g,w){switch(g){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(T.URI.revive(w[0]));case"accept":return this.service.accept(D(w[0],this.userDataProfilesService),T.URI.revive(w[1]),w[2],w[3]);case"getRemoteProfiles":return this.service.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(w[0],w[1]?(0,A.reviveProfile)(w[1],this.userDataProfilesService.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(w[0],w[1]);case"replace":return this.service.replace(P(w[0]));case"getAssociatedResources":return this.service.getAssociatedResources(P(w[0]));case"getMachineId":return this.service.getMachineId(P(w[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"createManualSyncTask":return this.createManualSyncTask()}if(g.startsWith("manualSync/")){const c=g.substring(11),l=w[0],h=this.getManualSyncTask(l);switch(w=w.slice(1),c){case"merge":return h.merge();case"apply":return h.apply().then(()=>this.manualSyncTasks.delete(this.createKey(h.id)));case"stop":return h.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(h.id)))}}throw new Error("Invalid call")}getManualSyncTask(u){const g=this.manualSyncTasks.get(this.createKey(u));if(!g)throw new Error(`Manual sync taks not found: ${u}`);return g}async createManualSyncTask(){const u=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(u.id),u),u.id}createKey(u){return`manualSyncTask-${u}`}}e.UserDataSyncChannel=v;let I=class extends N.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(u,g){super(),this.userDataProfilesService=g,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(w,c,l){return u.call(w,c,l).then(null,h=>{throw k.UserDataSyncError.toUserDataSyncError(h)})},listen(w,c){return u.listen(w,c)}},this.channel.call("_getInitialData").then(([w,c,l])=>{this.updateStatus(w),this.updateConflicts(c),l&&this.updateLastSyncTime(l),this._register(this.channel.listen("onDidChangeStatus")(h=>this.updateStatus(h))),this._register(this.channel.listen("onDidChangeLastSyncTime")(h=>this.updateLastSyncTime(h)))}),this._register(this.channel.listen("onDidChangeConflicts")(w=>this.updateConflicts(w))),this._register(this.channel.listen("onSyncErrors")(w=>this._onSyncErrors.fire(w.map(c=>({...c,error:k.UserDataSyncError.toUserDataSyncError(c.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const u=await this.channel.call("createManualSyncTask"),g=this;return new C(u,{async call(c,l,h){return g.channel.call(`manualSync/${c}`,[u,...Array.isArray(l)?l:[l]],h)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(u,g,w,c){return this.channel.call("accept",[u,g,w,c])}resolveContent(u){return this.channel.call("resolveContent",[u])}getRemoteProfiles(){return this.channel.call("getRemoteProfiles")}async getLocalSyncResourceHandles(u,g){return(await this.channel.call("getLocalSyncResourceHandles",[u,g])).map(({created:c,uri:l})=>({created:c,uri:T.URI.revive(l)}))}async getRemoteSyncResourceHandles(u,g){return(await this.channel.call("getRemoteSyncResourceHandles",[u,g])).map(({created:c,uri:l})=>({created:c,uri:T.URI.revive(l)}))}async getAssociatedResources(u){return(await this.channel.call("getAssociatedResources",[u])).map(({resource:w,comparableResource:c})=>({resource:T.URI.revive(w),comparableResource:T.URI.revive(c)}))}getMachineId(u){return this.channel.call("getMachineId",[u])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(u){return this.channel.call("replace",[u])}async updateStatus(u){this._status=u,this._onDidChangeStatus.fire(u)}async updateConflicts(u){this._conflicts=u.map(g=>({syncResource:g.syncResource,profile:(0,A.reviveProfile)(g.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:g.conflicts.map(w=>({...w,baseResource:T.URI.revive(w.baseResource),localResource:T.URI.revive(w.localResource),remoteResource:T.URI.revive(w.remoteResource),previewResource:T.URI.revive(w.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(u){this._lastSyncTime!==u&&(this._lastSyncTime=u,this._onDidChangeLastSyncTime.fire(u))}};e.UserDataSyncChannelClient=I,e.UserDataSyncChannelClient=I=ve([Y(1,A.IUserDataProfilesService)],I);class C extends N.Disposable{constructor(u,g){super(),this.id=u,this.channel=g}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(oe[254],ae([0,1,6,25,7,3,2,137,5,22,11,10,32,18,15,13,24,57,44,19,23]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const R="configurationSync.store",t="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",i=100,r=1e3*60*5;let a=class extends k.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(E.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(F){this.storageService.store(E.SYNC_SERVICE_URL_TYPE,F,-1,P.isWeb?0:1)}constructor(F,M,q){super(),this.productService=F,this.configurationService=M,this.storageService=q,this._onDidChangeUserDataSyncStore=this._register(new A.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(A.Event.filter(q.onDidChangeValue,j=>j.key===E.SYNC_SERVICE_URL_TYPE&&j.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[R]),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(F){if(F&&(F=P.isWeb&&F.web?{...F,...F.web}:F,(0,I.isString)(F.url)&&(0,I.isObject)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(M=>Array.isArray(F.authenticationProviders[M].scopes)))){const M=F,q=!!M.canSwitch,j=M.url===M.insidersUrl?"insiders":"stable",B=(q?this.userDataSyncStoreType:void 0)||j,Q=B==="insiders"?M.insidersUrl:B==="stable"?M.stableUrl:M.url;return{url:C.URI.parse(Q),type:B,defaultType:j,defaultUrl:C.URI.parse(M.url),stableUrl:C.URI.parse(M.stableUrl),insidersUrl:C.URI.parse(M.insidersUrl),canSwitch:q,authenticationProviders:Object.keys(M.authenticationProviders).reduce((J,G)=>(J.push({id:G,scopes:M.authenticationProviders[G].scopes}),J),[])}}}};e.AbstractUserDataSyncStoreManagementService=a,e.AbstractUserDataSyncStoreManagementService=a=ve([Y(0,c.IProductService),Y(1,u.IConfigurationService),Y(2,y.IStorageService)],a);let p=class extends a{constructor(F,M,q){super(F,M,q);const j=this.storageService.get(t,-1);j&&(this.previousConfigurationSyncStore=JSON.parse(j));const B=this.productService[R];B?this.storageService.store(t,JSON.stringify(B),-1,1):this.storageService.remove(t,-1)}async switch(F){F!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=F,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=p,e.UserDataSyncStoreManagementService=p=ve([Y(0,c.IProductService),Y(1,u.IConfigurationService),Y(2,y.IStorageService)],p);let m=class extends k.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(F,M,q,j,B,Q,J){super(),this.requestService=q,this.logService=j,this.storageService=J,this._onTokenFailed=this._register(new A.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new A.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(F),this.commonHeadersPromise=(0,h.getServiceMachineId)(B,Q,J).then(G=>{const X={"X-Client-Name":`${M.applicationName}${P.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(X["X-Client-Commit"]=M.commit),X}),this.session=new b(i,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(F,M){this.authToken={token:F,type:M}}updateUserDataSyncStoreUrl(F){this.userDataSyncStoreUrl=F?(0,v.joinPath)(F,"v1"):void 0}initDonotMakeRequestsUntil(){const F=this.storageService.getNumber(o,-1);F&&Date.now()<F&&this.setDonotMakeRequestsUntil(new Date(F))}setDonotMakeRequestsUntil(F){this._donotMakeRequestsUntil?.getTime()!==F?.getTime()&&(this._donotMakeRequestsUntil=F,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(o,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,L.createCancelablePromise)(M=>(0,L.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),M).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,M=>null)):this.storageService.remove(o,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,v.joinPath)(this.userDataSyncStoreUrl,"collection").toString();F={...F},F["Content-Type"]="application/json";const q=await this.request(M,{type:"GET",headers:F},[],N.CancellationToken.None);return(await(0,l.asJson)(q))?.map(({id:j})=>j)||[]}async createCollection(F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,v.joinPath)(this.userDataSyncStoreUrl,"collection").toString();F={...F},F["Content-Type"]=D.Mimes.text;const q=await this.request(M,{type:"POST",headers:F},[],N.CancellationToken.None),j=await(0,l.asTextOrError)(q);if(!j)throw new E.UserDataSyncStoreError("Server did not return the collection id",M,"NoCollection",q.res.statusCode,q.res.headers[E.HEADER_OPERATION_ID]);return j}async deleteCollection(F,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=F?(0,v.joinPath)(this.userDataSyncStoreUrl,"collection",F).toString():(0,v.joinPath)(this.userDataSyncStoreUrl,"collection").toString();M={...M},await this.request(q,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async getAllResourceRefs(F,M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=this.getResourceUrl(this.userDataSyncStoreUrl,M,F),j={},B=await this.request(q.toString(),{type:"GET",headers:j},[],N.CancellationToken.None);return(await(0,l.asJson)(B)||[]).map(({url:J,created:G})=>({ref:(0,v.relativePath)(q,q.with({path:J})),created:G*1e3}))}async resolveResourceContent(F,M,q,j={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=(0,v.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,q,F),M).toString();j={...j},j["Cache-Control"]="no-cache";const Q=await this.request(B,{type:"GET",headers:j},[],N.CancellationToken.None);return await(0,l.asTextOrError)(Q)}async deleteResource(F,M,q){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=M!==null?(0,v.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,q,F),M).toString():this.getResourceUrl(this.userDataSyncStoreUrl,q,F).toString(),B={};await this.request(j,{type:"DELETE",headers:B},[],N.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,v.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),M={"Content-Type":D.Mimes.text};await this.request(F,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async readResource(F,M,q,j={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=(0,v.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,q,F),"latest").toString();j={...j},j["Cache-Control"]="no-cache",M&&(j["If-None-Match"]=M.ref);const Q=await this.request(B,{type:"GET",headers:j},[304],N.CancellationToken.None);let J=null;if(Q.res.statusCode===304&&(J=M),J===null){const G=Q.res.headers.etag;if(!G)throw new E.UserDataSyncStoreError("Server did not return the ref",B,"NoRef",Q.res.statusCode,Q.res.headers[E.HEADER_OPERATION_ID]);const X=await(0,l.asTextOrError)(Q);if(!X&&Q.res.statusCode===304)throw new E.UserDataSyncStoreError("Empty response",B,"EmptyResponse",Q.res.statusCode,Q.res.headers[E.HEADER_OPERATION_ID]);J={ref:G,content:X}}return J}async writeResource(F,M,q,j,B={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const Q=this.getResourceUrl(this.userDataSyncStoreUrl,j,F).toString();B={...B},B["Content-Type"]=D.Mimes.text,q&&(B["If-Match"]=q);const J=await this.request(Q,{type:"POST",data:M,headers:B},[],N.CancellationToken.None),G=J.res.headers.etag;if(!G)throw new E.UserDataSyncStoreError("Server did not return the ref",Q,"NoRef",J.res.statusCode,J.res.headers[E.HEADER_OPERATION_ID]);return G}async manifest(F,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,v.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();M={...M},M["Content-Type"]="application/json",F&&(M["If-None-Match"]=F.ref);const j=await this.request(q,{type:"GET",headers:M},[304],N.CancellationToken.None);let B=null;if(j.res.statusCode===304&&(B=F),!B){const J=j.res.headers.etag;if(!J)throw new E.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",j.res.statusCode,j.res.headers[E.HEADER_OPERATION_ID]);const G=await(0,l.asTextOrError)(j);if(!G&&j.res.statusCode===304)throw new E.UserDataSyncStoreError("Empty response",q,"EmptyResponse",j.res.statusCode,j.res.headers[E.HEADER_OPERATION_ID]);G&&(B={...JSON.parse(G),ref:J})}const Q=this.storageService.get(n,-1);return Q&&B&&Q!==B.session&&this.clearSession(),B===null&&Q&&this.clearSession(),B&&this.storageService.store(n,B.session,-1,1),B}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}getResourceUrl(F,M,q){return M?(0,v.joinPath)(F,"collection",M,"resource",q):(0,v.joinPath)(F,"resource",q)}clearSession(){this.storageService.remove(n,-1),this.storageService.remove(s,-1)}async request(F,M,q,j){if(!this.authToken)throw new E.UserDataSyncStoreError("No Auth Token Available",F,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new E.UserDataSyncStoreError(`${M.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const B=await this.commonHeadersPromise;M.headers={...M.headers||{},...B,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(M.headers),this.logService.trace("Sending request to server",{url:F,type:M.type,headers:{...M.headers,authorization:void 0}});let Q;try{Q=await this.session.request(F,M,j)}catch(x){if(!(x instanceof E.UserDataSyncStoreError)){let z="RequestFailed";const ee=(0,T.getErrorMessage)(x).toLowerCase();ee.includes("xhr timeout")?z="RequestTimeout":ee.includes("protocol")&&ee.includes("not supported")?z="RequestProtocolNotSupported":ee.includes("request path contains unescaped characters")?z="RequestPathNotEscaped":ee.includes("headers must be an object")?z="RequestHeadersNotObject":(0,T.isCancellationError)(x)&&(z="RequestCanceled"),x=new E.UserDataSyncStoreError(`Connection refused for the request '${F}'.`,F,z,void 0,void 0)}throw this.logService.info("Request failed",F),x}const J=Q.res.headers[E.HEADER_OPERATION_ID],G={url:F,status:Q.res.statusCode,"execution-id":M.headers[E.HEADER_EXECUTION_ID],"operation-id":J},X=(0,l.isSuccess)(Q)||Q.res.statusCode&&q.includes(Q.res.statusCode);let V="";if(X?this.logService.trace("Request succeeded",G):(V=await(0,l.asText)(Q)||"",this.logService.info("Request failed",G,V)),Q.res.statusCode===401||Q.res.statusCode===403){if(this.authToken=void 0,Q.res.statusCode===401)throw this._onTokenFailed.fire("Unauthorized"),new E.UserDataSyncStoreError(`${M.type} request '${F}' failed because of Unauthorized (401).`,F,"Unauthorized",Q.res.statusCode,J);if(Q.res.statusCode===403)throw this._onTokenFailed.fire("Forbidden"),new E.UserDataSyncStoreError(`${M.type} request '${F}' failed because the access is forbidden (403).`,F,"Forbidden",Q.res.statusCode,J)}if(this._onTokenSucceed.fire(),Q.res.statusCode===404)throw new E.UserDataSyncStoreError(`${M.type} request '${F}' failed because the requested resource is not found (404).`,F,"NotFound",Q.res.statusCode,J);if(Q.res.statusCode===405)throw new E.UserDataSyncStoreError(`${M.type} request '${F}' failed because the requested endpoint is not found (405). ${V}`,F,"MethodNotFound",Q.res.statusCode,J);if(Q.res.statusCode===409)throw new E.UserDataSyncStoreError(`${M.type} request '${F}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,F,"Conflict",Q.res.statusCode,J);if(Q.res.statusCode===410)throw new E.UserDataSyncStoreError(`${M.type} request '${F}' failed because the requested resource is not longer available (410).`,F,"Gone",Q.res.statusCode,J);if(Q.res.statusCode===412)throw new E.UserDataSyncStoreError(`${M.type} request '${F}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,F,"PreconditionFailed",Q.res.statusCode,J);if(Q.res.statusCode===413)throw new E.UserDataSyncStoreError(`${M.type} request '${F}' failed because of too large payload (413).`,F,"TooLarge",Q.res.statusCode,J);if(Q.res.statusCode===426)throw new E.UserDataSyncStoreError(`${M.type} request '${F}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,F,"UpgradeRequired",Q.res.statusCode,J);if(Q.res.statusCode===429){const x=Q.res.headers["retry-after"];throw x?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(x)*1e3)),new E.UserDataSyncStoreError(`${M.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",Q.res.statusCode,J)):new E.UserDataSyncStoreError(`${M.type} request '${F}' failed because of too many requests (429).`,F,"RemoteTooManyRequests",Q.res.statusCode,J)}if(!X)throw new E.UserDataSyncStoreError("Server returned "+Q.res.statusCode,F,"Unknown",Q.res.statusCode,J);return Q}addSessionHeaders(F){let M=this.storageService.get(s,-1);M===void 0&&(M=(0,S.generateUuid)(),this.storageService.store(s,M,-1,1)),F["X-Machine-Session-Id"]=M;const q=this.storageService.get(n,-1);q!==void 0&&(F["X-User-Session-Id"]=q)}};e.UserDataSyncStoreClient=m,e.UserDataSyncStoreClient=m=ve([Y(1,c.IProductService),Y(2,l.IRequestService),Y(3,E.IUserDataSyncLogService),Y(4,g.IEnvironmentService),Y(5,w.IFileService),Y(6,y.IStorageService)],m);let d=class extends m{constructor(F,M,q,j,B,Q,J){super(F.userDataSyncStore?.url,M,q,j,B,Q,J),this._register(F.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(F.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=d,e.UserDataSyncStoreService=d=ve([Y(0,E.IUserDataSyncStoreManagementService),Y(1,c.IProductService),Y(2,l.IRequestService),Y(3,E.IUserDataSyncLogService),Y(4,g.IEnvironmentService),Y(5,w.IFileService),Y(6,y.IStorageService)],d);class b{constructor(F,M,q,j){this.limit=F,this.interval=M,this.requestService=q,this.logService=j,this.requests=[],this.startTime=void 0}request(F,M,q){if(this.isExpired()&&this.reset(),M.url=F,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new E.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,F,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(F),this.requestService.request(M,q)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=b}),define(oe[255],ae([0,1,3,55,24,19,20,250,23,76,79]),function(te,e,L,N,T,A,k,D,P,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends D.UserDataAutoSyncService{constructor(u,g,w,c,l,h,y,E,R,t,o){super(u,g,w,c,l,y,E,R,t,o),this._register(L.Event.debounce(L.Event.any(L.Event.map(h.onDidFocusWindow,()=>"windowFocus"),L.Event.map(h.onDidOpenWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.UserDataAutoSyncService=C,e.UserDataAutoSyncService=C=ve([Y(0,T.IProductService),Y(1,P.IUserDataSyncStoreManagementService),Y(2,P.IUserDataSyncStoreService),Y(3,P.IUserDataSyncEnablementService),Y(4,P.IUserDataSyncService),Y(5,N.INativeHostService),Y(6,P.IUserDataSyncLogService),Y(7,v.IUserDataSyncAccountService),Y(8,k.ITelemetryService),Y(9,I.IUserDataSyncMachinesService),Y(10,A.IStorageService)],C)}),define(oe[256],ae([0,1,67,26,5,22]),function(te,e,L,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function k(v){function I(){let C=v.scheme===N.Schemas.file?(0,A.originalFSPath)(v):v.toString();return T.isLinux||(C=C.toLowerCase()),(0,L.createHash)("md5").update(C).digest("hex")}return{id:I(),configPath:v}}e.getWorkspaceIdentifier=k;function D(v,I){function C(){if(v.scheme!==N.Schemas.file)return(0,L.createHash)("md5").update(v.toString()).digest("hex");if(!I)return;let u;return T.isLinux?u=I.ino:T.isMacintosh?u=I.birthtime.getTime():T.isWindows&&(typeof I.birthtimeMs=="number"?u=Math.floor(I.birthtimeMs):u=I.birthtime.getTime()),(0,L.createHash)("md5").update(v.fsPath).update(u?String(u):"").digest("hex")}const S=C();if(typeof S=="string")return{id:S,uri:v}}e.getSingleFolderWorkspaceIdentifier=D;function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=P}),define(oe[257],ae([0,1,6,7,2,16,31,15,8,73,112,256,55,69]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let g=class extends T.Disposable{constructor(c,l,h,y){super(),this.environmentService=c,this.logService=l,this.nativeHostService=h,this.mainProcessService=y,this._register(new L.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const c=await k.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),l=new v.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(c.map(async h=>{const y=(0,A.join)(this.environmentService.workspaceStorageHome.fsPath,h);h.length===C.NON_EMPTY_WORKSPACE_ID_LENGTH||h===I.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(t=>t.workspace?.id===h)||await l.isUsed(y)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${h} as it seems to be an unused empty workspace.`),await k.Promises.rm(y))}))}catch(c){(0,N.onUnexpectedError)(c)}}};e.UnusedWorkspaceStorageDataCleaner=g,e.UnusedWorkspaceStorageDataCleaner=g=ve([Y(0,D.INativeEnvironmentService),Y(1,P.ILogService),Y(2,S.INativeHostService),Y(3,u.IMainProcessService)],g)}),define(oe[80],ae([0,1,52,6,16,11,31,144,267,268]),function(te,e,L,N,T,A,k,D,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const I=new RegExp(e.CorruptZipMessage);class C extends Error{constructor(o,n){let s=n.message;switch(o){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=o,this.cause=n}}e.ExtractError=C;function S(t){const o=t.externalFileAttributes>>16||33188;return[448,56,7].map(n=>o&n).reduce((n,s)=>n+s,o&61440)}function u(t){if(t instanceof C)return t;let o;return I.test(t.message)&&(o="CorruptZip"),new C(o,t)}function g(t,o,n,s,i,r){const a=T.dirname(o),p=T.join(s,a);if(!p.startsWith(s))return Promise.reject(new Error(D.localize(0,null,o)));const m=T.join(s,o);let d;return r.onCancellationRequested(()=>{d?.destroy()}),Promise.resolve(k.Promises.mkdir(p,{recursive:!0})).then(()=>new Promise((b,O)=>{if(!r.isCancellationRequested)try{d=(0,L.createWriteStream)(m,{mode:n}),d.once("close",()=>b()),d.once("error",O),t.once("error",O),t.pipe(d)}catch(F){O(F)}}))}function w(t,o,n,s){let i=(0,N.createCancelablePromise)(()=>Promise.resolve()),r=0;return s.onCancellationRequested(()=>{i.cancel(),t.close()}),new Promise((a,p)=>{const m=new N.Sequencer,d=b=>{b.isCancellationRequested||(r++,t.readEntry())};t.once("error",p),t.once("close",()=>i.then(()=>{s.isCancellationRequested||t.entryCount===r?a():p(new C("Incomplete",new Error(D.localize(1,null,r,t.entryCount))))},p)),t.readEntry(),t.on("entry",b=>{if(s.isCancellationRequested)return;if(!n.sourcePathRegex.test(b.fileName)){d(s);return}const O=b.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(O)){const q=T.join(o,O);i=(0,N.createCancelablePromise)(j=>k.Promises.mkdir(q,{recursive:!0}).then(()=>d(j)).then(void 0,p));return}const F=l(t,b),M=S(b);i=(0,N.createCancelablePromise)(q=>m.queue(()=>F.then(j=>g(j,O,M,o,n,q).then(()=>d(q)))).then(null,p))})})}function c(t,o=!1){return new Promise((n,s)=>{(0,P.open)(t,o?{lazyEntries:!0}:void 0,(i,r)=>{i?s(u(i)):n((0,A.assertIsDefined)(r))})})}function l(t,o){return new Promise((n,s)=>{t.openReadStream(o,(i,r)=>{i?s(u(i)):n((0,A.assertIsDefined)(r))})})}function h(t,o){return new Promise((n,s)=>{const i=new v.ZipFile;o.forEach(a=>{a.contents?i.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&i.addFile(a.localPath,a.path)}),i.end();const r=(0,L.createWriteStream)(t);i.outputStream.pipe(r),i.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>n(t))})}e.zip=h;function y(t,o,n={},s){const i=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=c(t,!0);return n.overwrite&&(r=r.then(a=>k.Promises.rm(o).then(()=>a))),r.then(a=>w(a,o,{sourcePathRegex:i},s))}e.extract=y;function E(t,o){return c(t).then(n=>new Promise((s,i)=>{n.on("entry",r=>{r.fileName===o&&l(n,r).then(a=>s(a),a=>i(a))}),n.once("close",()=>i(new Error(D.localize(2,null,o))))}))}function R(t,o){return E(t,o).then(n=>new Promise((s,i)=>{const r=[];n.once("error",i),n.on("data",a=>r.push(a)),n.on("end",()=>s(Buffer.concat(r)))}))}e.buffer=R}),define(oe[258],ae([0,1,6,7,2,26,5,22,53,11,32,31,80,18,15,29,33,97,13,8]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let E=class gt extends T.Disposable{static{this.SignatureArchiveExtension=".sigzip"}constructor(t,o,n,s,i,r){super(),this.fileService=o,this.extensionGalleryService=n,this.configurationService=s,this.extensionSignatureVerificationService=i,this.logService=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(t,o,n){await this.cleanUpPromise;const s=(0,D.joinPath)(this.extensionsDownloadDir,this.getName(t));try{await this.downloadFile(t,s,r=>this.extensionGalleryService.download(t,r,o))}catch(r){throw new w.ExtensionManagementError(r.message,w.ExtensionManagementErrorCode.Download)}let i=!1;if(n&&this.shouldVerifySignature(t)){const r=await this.downloadSignatureArchive(t);try{i=await this.extensionSignatureVerificationService.verify(s.fsPath,r.fsPath,this.logService.getLevel()===y.LogLevel.Trace)}catch(a){const p=a;if(i=p.code,p.output&&this.logService.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${p.output}`),i===w.ExtensionSignaturetErrorCode.PackageIsInvalidZip||i===w.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new w.ExtensionManagementError(S.CorruptZipMessage,w.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(a){this.logService.error(a)}}}return i===!0?this.logService.info(`Extension signature is verified: ${t.identifier.id}`):i===!1?this.logService.info(`Extension signature verification is not done: ${t.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${i}': ${t.identifier.id}`),{location:s,verificationStatus:i}}shouldVerifySignature(t){if(!t.isSigned)return!1;const o=this.configurationService.getValue("extensions.verifySignature");return(0,v.isBoolean)(o)?o:!0}async downloadSignatureArchive(t){await this.cleanUpPromise;const o=(0,D.joinPath)(this.extensionsDownloadDir,`${this.getName(t)}${gt.SignatureArchiveExtension}`);return await this.downloadFile(t,o,n=>this.extensionGalleryService.downloadSignatureArchive(t,n)),o}async downloadFile(t,o,n){if(await this.fileService.exists(o))return;if(o.scheme!==A.Schemas.file){await n(o);return}const s=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.fileService.exists(s)||await n(s);try{await this.rename(s,o,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(s)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,o.path);else throw this.logService.info(`Rename failed because of ${(0,N.getErrorMessage)(i)}. Deleted the file from downloaded location`,s.path),i}}async delete(t){await this.cleanUpPromise,await this.fileService.del(t)}async rename(t,o,n){try{await C.Promises.rename(t.fsPath,o.fsPath)}catch(s){if(k.isWindows&&s&&s.code==="EPERM"&&Date.now()<n)return this.logService.info(`Failed renaming ${t} to ${o} with 'EPERM' error. Trying again...`),this.rename(t,o,n);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const o=[],n=[],s=[];for(const a of t.children)if(a.name.endsWith(gt.SignatureArchiveExtension))s.push(a.resource);else{const p=c.ExtensionKey.parse(a.name);p&&n.push([p,a])}const i=(0,c.groupByExtension)(n,([a])=>a),r=[];for(const a of i)a.sort((p,m)=>P.rcompare(p[0].version,m[0].version)),o.push(...a.slice(1).map(p=>p[1].resource)),r.push(a[0][1]);r.sort((a,p)=>a.mtime-p.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(a=>a.resource)),o.push(...s),await L.Promises.settled(o.map(a=>(this.logService.trace("Deleting from cache",a.path),this.fileService.del(a))))}}catch(t){this.logService.error(t)}}getName(t){return this.cache?c.ExtensionKey.create(t).toString().toLowerCase():(0,I.generateUuid)()}};e.ExtensionsDownloader=E,e.ExtensionsDownloader=E=ve([Y(0,g.INativeEnvironmentService),Y(1,h.IFileService),Y(2,w.IExtensionGalleryService),Y(3,u.IConfigurationService),Y(4,l.IExtensionSignatureVerificationService),Y(5,y.ILogService)],E)}),define(oe[259],ae([0,1,80,153]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function T(A){return(0,L.buffer)(A,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.getManifest=T}),define(oe[121],ae([0,1,6,14,25,38,7,3,51,2,35,26,16,5,22,53,11,10,32,31,80,152,96,15,238,29,33,50,77,258,239,259,208,218,65,13,4,8,24,20,28,17]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h,y,E,R,t,o,n,s,i,r,a,p,m,d,b,O,F,M,q,j,B,Q,J,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,q.refineServiceDecorator)(s.IExtensionManagementService);const X=".vsctmp";let V=class extends n.AbstractExtensionManagementService{constructor(U,f,_,$,H,W,K,Z,se,ue,he,Se){super(U,f,he,_,ue,Se),this.extensionsScannerService=H,this.extensionsProfileScannerService=W,this.downloadService=K,this.fileService=se,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new I.ResourceSet;const Ee=this._register(Z.createInstance(m.ExtensionsLifecycle));this.extensionsScanner=this._register(Z.createInstance(x,De=>Ee.postUninstall(De))),this.manifestCache=this._register(new b.ExtensionsManifestCache(Se,se,he,this,this.logService)),this.extensionsDownloader=this._register(Z.createInstance(p.ExtensionsDownloader));const be=this._register(new O.ExtensionsWatcher(this,this.extensionsScannerService,Se,W,he,se,_));this._register(be.onDidChangeExtensionsByAnotherSource(De=>this.onDidChangeExtensionsFromAnotherSource(De))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,i.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const f=await this.collectFiles(U),_=await(0,E.zip)((0,g.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,h.generateUuid)()).fsPath,f);return l.URI.file(_)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:f,cleanup:_}=await this.downloadVsix(U),$=S.resolve(f.fsPath);try{return await(0,d.getManifest)($)}finally{await _()}}getInstalled(U,f=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(U??null,f)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(U){return this.extensionsScanner.scanUserExtensionAtLocation(U)}async install(U,f={}){this.logService.trace("ExtensionManagementService#install",U.toString());const{location:_,cleanup:$}=await this.downloadVsix(U);try{const H=await(0,d.getManifest)(S.resolve(_.fsPath)),W=(0,i.getGalleryExtensionId)(H.publisher,H.name);if(H.engines&&H.engines.vscode&&!(0,F.isEngineValid)(H.engines.vscode,this.productService.version,this.productService.date))throw new Error(R.localize(0,null,W,this.productService.version));const K=await this.installExtensions([{manifest:H,extension:_,options:f}]);if(K[0]?.local)return K[0]?.local;throw K[0]?.error?K[0].error:(0,n.toExtensionManagementError)(new Error(`Unknown error while installing extension ${W}`))}finally{await $()}}async installFromLocation(U,f){this.logService.trace("ExtensionManagementService#installFromLocation",U.toString());const _=await this.extensionsScanner.scanUserExtensionAtLocation(U);if(!_)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.addExtensionsToProfile([[_,void 0]],f),this.logService.info("Successfully installed extension",_.identifier.id,f.toString()),_}async installExtensionsFromProfile(U,f,_){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",U,f.toString(),_.toString());const $=(await this.extensionsScanner.scanExtensions(1,f)).filter(H=>U.some(W=>(0,i.areSameExtensions)(W,H.identifier)));if($.length){const H=await Promise.all($.map(W=>this.extensionsScanner.scanMetadata(W,f)));await this.addExtensionsToProfile($.map((W,K)=>[W,H[K]]),_),this.logService.info("Successfully installed extensions",$.map(W=>W.identifier.id),_.toString())}return $}async updateMetadata(U,f,_=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id),f.isPreReleaseVersion&&(f.preRelease=!0),f.isMachineScoped=f.isMachineScoped||void 0,f.isBuiltin=f.isBuiltin||void 0,f.pinned=f.pinned||void 0,U=await this.extensionsScanner.updateMetadata(U,f,_),this.manifestCache.invalidate(_),this._onDidUpdateExtensionMetadata.fire(U),U}async reinstallFromGallery(U){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.galleryService.isEnabled())throw new Error(R.localize(1,null));const f=await this.getTargetPlatform(),[_]=await this.galleryService.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:f,compatible:!0},T.CancellationToken.None);if(!_)throw new Error(R.localize(2,null));await this.extensionsScanner.setUninstalled(U);try{await this.extensionsScanner.removeUninstalledExtension(U)}catch($){throw new Error(R.localize(3,null,(0,A.toErrorMessage)($)))}return this.installFromGallery(_)}copyExtension(U,f,_,$){return this.extensionsScanner.copyExtension(U,f,_,$)}copyExtensions(U,f){return this.extensionsScanner.copyExtensions(U,f)}markAsUninstalled(...U){return this.extensionsScanner.setUninstalled(...U)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(U){this.logService.error(U)}}async download(U,f,_){const{location:$}=await this.extensionsDownloader.download(U,f,!_);return $}async downloadVsix(U){if(U.scheme===C.Schemas.file)return{location:U,async cleanup(){}};this.logService.trace("Downloading extension from",U.toString());const f=(0,g.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,h.generateUuid)());return await this.downloadService.download(U,f),this.logService.info("Downloaded extension to",f.toString()),{location:f,cleanup:async()=>{try{await this.fileService.del(f)}catch($){this.logService.error($)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(U,f,_){if(l.URI.isUri(f))return new ne(U,f,_,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const $=i.ExtensionKey.create(f).toString();let H=this.installGalleryExtensionsTasks.get($);return H||(this.installGalleryExtensionsTasks.set($,H=new ee(U,f,_,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),H.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete($))),H}createUninstallExtensionTask(U,f){return new ce(U,f.profileLocation,this.extensionsProfileScannerService)}async collectFiles(U){const f=async $=>{let H=await y.Promises.readdir($);H=H.map(Z=>S.join($,Z));const W=await Promise.all(H.map(Z=>y.Promises.stat(Z)));let K=Promise.resolve([]);return W.forEach((Z,se)=>{const ue=H[se];Z.isFile()&&(K=K.then(he=>[...he,ue])),Z.isDirectory()&&(K=K.then(he=>f(ue).then(Se=>[...he,...Se])))}),K};return(await f(U.location.fsPath)).map($=>({path:`extension/${S.relative(U.location.fsPath,$)}`,localPath:$}))}async onDidChangeExtensionsFromAnotherSource({added:U,removed:f}){if(f)for(const _ of f.extensions)this.logService.info("Extensions removed from another source",_.id,f.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:_,profileLocation:f.profileLocation});if(U){const $=(await this.extensionsScanner.scanExtensions(1,U.profileLocation)).filter(H=>U.extensions.some(W=>(0,i.areSameExtensions)(W,H.identifier)));this._onDidInstallExtensions.fire($.map(H=>(this.logService.info("Extensions added from another source",H.identifier.id,U.profileLocation.toString()),{identifier:H.identifier,local:H,profileLocation:U.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(f=>this.knownDirectories.add(f)));const U=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const f of U.children??[])f.isDirectory&&this.knownDirectories.add(f.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(f=>this.onDidFilesChange(f)))}async onDidFilesChange(U){if(!U.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const f=[];for(const _ of U.rawAdded){if(this.knownDirectories.has(_)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(_),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(_,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(_).startsWith(".")||!(await this.fileService.stat(_)).isDirectory)continue;const $=await this.extensionsScanner.scanUserExtensionAtLocation(_);$&&$.installedTimestamp===void 0&&(this.knownDirectories.add(_),f.push($))}f.length&&(await this.addExtensionsToProfile(f.map(_=>[_,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",f.map(_=>_.identifier.id)))}async addExtensionsToProfile(U,f){const _=U.map($=>$[0]);await this.setInstalled(_),await this.extensionsProfileScannerService.addExtensionsToProfile(U,f),this._onDidInstallExtensions.fire(_.map($=>({local:$,identifier:$.identifier,operation:1,profileLocation:f})))}async setInstalled(U){const f=await this.extensionsScanner.getUninstalledExtensions();for(const _ of U){const $=i.ExtensionKey.create(_);f[$.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",$.id),await this.extensionsScanner.setInstalled($),this.logService.info("Removed the extension from uninstalled list:",$.id))}}};e.ExtensionManagementService=V,e.ExtensionManagementService=V=ve([Y(0,s.IExtensionGalleryService),Y(1,Q.ITelemetryService),Y(2,j.ILogService),Y(3,o.INativeEnvironmentService),Y(4,a.IExtensionsScannerService),Y(5,r.IExtensionsProfileScannerService),Y(6,t.IDownloadService),Y(7,q.IInstantiationService),Y(8,M.IFileService),Y(9,B.IProductService),Y(10,J.IUriIdentityService),Y(11,G.IUserDataProfilesService)],V);let x=class extends v.Disposable{constructor(U,f,_,$,H,W){super(),this.beforeRemovingExtension=U,this.fileService=f,this.extensionsScannerService=_,this.extensionsProfileScannerService=$,this.uriIdentityService=H,this.logService=W,this._onExtract=this._register(new D.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,g.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(U,f){const _={includeInvalid:!0,profileLocation:f};let $=[];return U===null||U===0?$.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},_,!1)):U===1&&$.push(...await this.extensionsScannerService.scanUserExtensions(_)),$=U!==null?$.filter(H=>H.type===U):$,Promise.all($.map(H=>this.toLocalExtension(H)))}async scanAllUserExtensions(U){const f=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(f.map(_=>this.toLocalExtension(_)))}async scanUserExtensionAtLocation(U){try{const f=await this.extensionsScannerService.scanExistingExtension(U,1,{includeInvalid:!0});if(f)return await this.toLocalExtension(f)}catch(f){this.logService.error(f)}return null}async extractUserExtension(U,f,_,$,H){const W=U.toString(),K=l.URI.file(S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,h.generateUuid)()}`)),Z=l.URI.file(S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,W));let se=await this.fileService.exists(Z);if(se&&$){try{await this.deleteExtensionFromLocation(U.id,Z,"removeExisting")}catch{throw new s.ExtensionManagementError(R.localize(4,null,Z.fsPath,U.id),s.ExtensionManagementErrorCode.Delete)}se=!1}if(!se)try{try{this.logService.trace(`Started extracting the extension from ${f} to ${Z.fsPath}`),await(0,E.extract)(f,K.fsPath,{sourcePath:"extension",overwrite:!0},H),this.logService.info(`Extracted extension to ${Z}:`,U.id)}catch(ue){let he=s.ExtensionManagementErrorCode.Extract;throw ue instanceof E.ExtractError&&(ue.type==="CorruptZip"?he=s.ExtensionManagementErrorCode.CorruptZip:ue.type==="Incomplete"&&(he=s.ExtensionManagementErrorCode.IncompleteZip)),new s.ExtensionManagementError(ue.message,he)}await this.extensionsScannerService.updateMetadata(K,_);try{this.logService.trace(`Started renaming the extension from ${K.fsPath} to ${Z.fsPath}`),await this.rename(U,K.fsPath,Z.fsPath,Date.now()+2*60*1e3),this.logService.info("Renamed to",Z.fsPath)}catch(ue){if(ue.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(ue)}. Deleted from extracted location`,K),ue}this._onExtract.fire(Z)}catch(ue){try{await this.fileService.del(K,{recursive:!0})}catch{}throw ue}return this.scanLocalExtension(Z,1)}async scanMetadata(U,f){return f?(await this.getScannedExtension(U,f))?.metadata:this.extensionsScannerService.scanMetadata(U.location)}async getScannedExtension(U,f){return(await this.extensionsProfileScannerService.scanProfileExtensions(f)).find($=>(0,i.areSameExtensions)($.identifier,U.identifier))}async updateMetadata(U,f,_){return _?await this.extensionsProfileScannerService.updateMetadata([[U,f]],_):await this.extensionsScannerService.updateMetadata(U.location,f),this.scanLocalExtension(U.location,U.type,_)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...U){const f=U.map(_=>i.ExtensionKey.create(_));await this.withUninstalledExtensions(_=>f.forEach($=>{_[$.toString()]=!0,this.logService.info("Marked extension as uninstalled",$.toString())}))}async setInstalled(U){await this.withUninstalledExtensions(f=>delete f[U.toString()])}async removeExtension(U,f){if(this.uriIdentityService.extUri.isEqualOrParent(U.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(U.identifier.id,U.location,f)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.withUninstalledExtensions(f=>delete f[i.ExtensionKey.create(U).toString()])}async copyExtension(U,f,_,$){const H=await this.getScannedExtension(U,f),W=await this.getScannedExtension(U,_);return $={...H?.metadata,...$},W?await this.extensionsProfileScannerService.updateMetadata([[U,{...W.metadata,...$}]],_):await this.extensionsProfileScannerService.addExtensionsToProfile([[U,$]],_),this.scanLocalExtension(U.location,U.type,_)}async copyExtensions(U,f){const _=await this.scanExtensions(1,U),$=await Promise.all(_.filter(H=>!H.isApplicationScoped).map(async H=>[H,await this.scanMetadata(H,U)]));await this.extensionsProfileScannerService.addExtensionsToProfile($,f)}async deleteExtensionFromLocation(U,f,_){this.logService.trace(`Deleting ${_} extension from disk`,U,f.fsPath);const $=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(f),`${this.uriIdentityService.extUri.basename(f)}.${(0,P.hash)((0,h.generateUuid)()).toString(16)}${X}`);await this.rename({id:U},f.fsPath,$.fsPath,Date.now()+2*60*1e3),await this.fileService.del($,{recursive:!0}),this.logService.info(`Deleted ${_} extension from disk`,U,f.fsPath)}async withUninstalledExtensions(U){return this.uninstalledFileLimiter.queue(async()=>{let f;try{f=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch($){if((0,M.toFileOperationResult)($)!==1)throw $}let _={};if(f)try{_=JSON.parse(f)}catch{}return U&&(U(_),Object.keys(_).length?await this.fileService.writeFile(this.uninstalledResource,N.VSBuffer.fromString(JSON.stringify(_))):await this.fileService.del(this.uninstalledResource)),_})}async rename(U,f,_,$){try{await y.Promises.rename(f,_)}catch(H){if(u.isWindows&&H&&H.code==="EPERM"&&Date.now()<$)return this.logService.info(`Failed renaming ${f} to ${_} with 'EPERM' error. Trying again...`,U.id),this.rename(U,f,_,$);throw new s.ExtensionManagementError(H.message||R.localize(5,null,f,_),H.code||s.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(U,f,_){if(_){const H=(await this.extensionsScannerService.scanUserExtensions({profileLocation:_})).find(W=>this.uriIdentityService.extUri.isEqual(W.location,U));if(H)return this.toLocalExtension(H)}else{const $=await this.extensionsScannerService.scanExistingExtension(U,f,{includeInvalid:!0});if($)return this.toLocalExtension($)}throw new Error(R.localize(6,null,U.path))}async toLocalExtension(U){const f=await this.fileService.resolve(U.location);let _,$;return f.children&&(_=f.children.find(({name:H})=>/^readme(\.txt|\.md|)$/i.test(H))?.resource,$=f.children.find(({name:H})=>/^changelog(\.txt|\.md|)$/i.test(H))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:_,changelogUrl:$,publisherDisplayName:U.metadata?.publisherDisplayName||null,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned}}async removeUninstalledExtensions(){const U=await this.getUninstalledExtensions();if(Object.keys(U).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(U));const f=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=new Set;for(const H of f)U[i.ExtensionKey.create(H).toString()]||_.add(H.identifier.id.toLowerCase());try{const H=(0,i.groupByExtension)(f,W=>W.identifier);await L.Promises.settled(H.map(async W=>{const K=W.sort((Z,se)=>w.rcompare(Z.manifest.version,se.manifest.version))[0];_.has(K.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(K))}))}catch(H){this.logService.error(H)}const $=f.filter(H=>H.metadata&&U[i.ExtensionKey.create(H).toString()]);await Promise.allSettled($.map(H=>this.removeUninstalledExtension(H)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let U;try{U=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(f){(0,M.toFileOperationResult)(f)!==1&&this.logService.error(f);return}if(U?.children)try{await Promise.allSettled(U.children.map(async f=>{if(!(!f.isDirectory||!f.name.endsWith(X))){this.logService.trace("Deleting the temporarily deleted folder",f.resource.toString());try{await this.fileService.del(f.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",f.resource.toString())}catch(_){(0,M.toFileOperationResult)(_)!==1&&this.logService.error(_)}}}))}catch{}}};e.ExtensionsScanner=x,e.ExtensionsScanner=x=ve([Y(1,M.IFileService),Y(2,a.IExtensionsScannerService),Y(3,r.IExtensionsProfileScannerService),Y(4,J.IUriIdentityService),Y(5,j.ILogService)],x);class z extends n.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,c.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(U,f,_,$,H,W,K,Z,se){super(),this.identifier=U,this.source=f,this.options=_,this.extensionsScanner=$,this.uriIdentityService=H,this.userDataProfilesService=W,this.extensionsScannerService=K,this.extensionsProfileScannerService=Z,this.logService=se,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(U){const[f,_]=await this.install(U);return this._profileLocation=f.isBuiltin||f.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[f,_]],this._profileLocation),f}async extractExtension({zipPath:U,key:f,metadata:_},$,H){let W=await this.unsetIfUninstalled(f);return W||(this.logService.trace("Extracting extension...",f.id),W=await this.extensionsScanner.extractUserExtension(f,U,_,$,H),this.logService.info("Extracting extension completed.",f.id)),W}async unsetIfUninstalled(U){return await this.isUninstalled(U)?(this.logService.trace("Removing the extension from uninstalled list:",U.id),await this.extensionsScanner.setInstalled(U),this.logService.info("Removed the extension from uninstalled list:",U.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find($=>i.ExtensionKey.create($).equals(U))):void 0}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.toString()]}}class ee extends z{constructor(U,f,_,$,H,W,K,Z,se,ue){super(f.identifier,f,_,H,W,K,Z,se,ue),this.gallery=f,this.extensionsDownloader=$}async install(U){const _=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(K=>(0,i.areSameExtensions)(K.identifier,this.gallery.identifier));_&&(this._operation=3);const $={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||_?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||_?.isMachineScoped,isBuiltin:this.options.isBuiltin||_?.isBuiltin,isSystem:_?.type===0?!0:void 0,updated:!!_,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,c.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:_?.preRelease)};if(_?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(_,$),$];const{location:H,verificationStatus:W}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=W,this.validateManifest(H.fsPath),[await this.extractExtension({zipPath:H.fsPath,key:i.ExtensionKey.create(this.gallery),metadata:$},!1,U),$]}catch(K){try{await this.extensionsDownloader.delete(H)}catch(Z){this.logService.warn("Error while deleting the downloaded file",H.toString(),(0,k.getErrorMessage)(Z))}throw K}}async validateManifest(U){try{await(0,d.getManifest)(U)}catch(f){throw new s.ExtensionManagementError((0,n.joinErrors)(f).message,s.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=ee;class ne extends z{constructor(U,f,_,$,H,W,K,Z,se,ue){super({id:(0,i.getGalleryExtensionId)(U.publisher,U.name)},f,_,H,W,K,Z,se,ue),this.manifest=U,this.location=f,this.galleryService=$}async doRun(U){const f=await super.doRun(U);return this.updateMetadata(f,U),f}async install(U){const f=new i.ExtensionKey(this.identifier,this.manifest.version),$=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(K=>(0,i.areSameExtensions)(this.identifier,K.identifier)),H={isApplicationScoped:this.options.isApplicationScoped||$?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||$?.isMachineScoped,isBuiltin:this.options.isBuiltin||$?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if($)if(this._operation=3,f.equals(new i.ExtensionKey($.identifier,$.manifest.version)))try{await this.extensionsScanner.removeExtension($,"existing")}catch{throw new Error(R.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&w.gt($.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled($);else{const K=await this.unsetIfUninstalled(f);if(K)try{await this.extensionsScanner.removeExtension(K,"existing")}catch{throw new Error(R.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:S.resolve(this.location.fsPath),key:f,metadata:H},!0,U),H]}async updateMetadata(U,f){try{let[_]=await this.galleryService.getExtensions([{id:U.identifier.id,version:U.manifest.version}],f);if(_||([_]=await this.galleryService.getExtensions([{id:U.identifier.id}],f)),_){const $={id:_.identifier.uuid,publisherDisplayName:_.publisherDisplayName,publisherId:_.publisherId,isPreReleaseVersion:_.properties.isPreReleaseVersion,preRelease:_.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(U,$,this.options.profileLocation)}}catch{}}}class ce extends n.AbstractExtensionTask{constructor(U,f,_){super(),this.extension=U,this.profileLocation=f,this.extensionsProfileScannerService=_}async doRun(U){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(oe[260],ae([0,1,2,29,78,217,121,8,19]),function(te,e,L,N,T,A,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let v=class extends L.Disposable{constructor(C,S,u,g,w,c){super(),C.cleanUp(),(0,A.migrateUnsupportedExtensions)(C,S,u,g,c),T.ExtensionStorageService.removeOutdatedExtensionVersions(C,w)}};e.ExtensionsContributions=v,e.ExtensionsContributions=v=ve([Y(0,k.INativeServerExtensionManagementService),Y(1,N.IExtensionGalleryService),Y(2,T.IExtensionStorageService),Y(3,N.IGlobalExtensionEnablementService),Y(4,P.IStorageService),Y(5,D.ILogService)],v)}),define(oe[261],ae([0,1,67,60,36,269,14,7,3,2,16,5,32,43,92]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{traceSocketEvent(d,b){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,d,b)}constructor(d,b=""){this._canWrite=!0,this.debugLabel=b,this.socket=d,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,D.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener),this._closeListener=O=>{this.traceSocketEvent("close",{hadError:O}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(d){const b=O=>{this.traceSocketEvent("read",O),d(k.VSBuffer.wrap(O))};return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(d){const b=O=>{d({type:0,hadError:O,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(d){const b=()=>{d()};return this.socket.on("end",b),{dispose:()=>this.socket.off("end",b)}}write(d){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",d),this.socket.write(d.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,D.onUnexpectedError)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,D.onUnexpectedError)(b)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((d,b)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),d();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),d()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=w;var c;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(c||(c={}));var l;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(l||(l={}));class h extends v.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(d,b){this.socket.traceSocketEvent(d,b)}constructor(d,b,O,F){super(),this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=d,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:b,inflateBytesLength:O?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new y(this,b,O,F,this._onData,(M,q)=>this._write(M,q))),this._register(this._flowManager.onError(M=>{console.error(M),(0,D.onUnexpectedError)(M),this._onClose.fire({type:0,hadError:!0,error:M})})),this._incomingData=new g.ChunkStream,this._register(this.socket.onData(M=>this._acceptChunk(M))),this._register(this.socket.onClose(async M=>{this._flowManager.isProcessingReadQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(M)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){let b=0;for(;b<d.byteLength;)this._flowManager.writeMessage(d.slice(b,Math.min(b+262144,d.byteLength))),b+=262144}_write(d,b){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",d);let O=2;d.byteLength<126?O+=0:d.byteLength<2**16?O+=2:O+=8;const F=k.VSBuffer.alloc(O);if(b?F.writeUInt8(194,0):F.writeUInt8(130,0),d.byteLength<126)F.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){F.writeUInt8(126,1);let M=1;F.writeUInt8(d.byteLength>>>8&255,++M),F.writeUInt8(d.byteLength>>>0&255,++M)}else{F.writeUInt8(127,1);let M=1;F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(d.byteLength>>>24&255,++M),F.writeUInt8(d.byteLength>>>16&255,++M),F.writeUInt8(d.byteLength>>>8&255,++M),F.writeUInt8(d.byteLength>>>0&255,++M)}this.socket.write(k.VSBuffer.concat([F,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const b=this._incomingData.peek(this._state.readLen),O=b.readUInt8(0),F=(O&128)>>>7,M=(O&64)>>>6,q=b.readUInt8(1),j=(q&128)>>>7,B=q&127;this._state.state=2,this._state.readLen=2+(j?4:0)+(B===126?2:0)+(B===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=!!M),this._state.firstFrameOfMessage=!!F,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const b=this._incomingData.read(this._state.readLen),O=b.readUInt8(1),F=(O&128)>>>7;let M=O&127,q=1;M===126?M=b.readUInt8(++q)*2**8+b.readUInt8(++q):M===127&&(M=b.readUInt8(++q)*0+b.readUInt8(++q)*0+b.readUInt8(++q)*0+b.readUInt8(++q)*0+b.readUInt8(++q)*2**24+b.readUInt8(++q)*2**16+b.readUInt8(++q)*2**8+b.readUInt8(++q));let j=0;F&&(j=b.readUInt8(++q)*2**24+b.readUInt8(++q)*2**16+b.readUInt8(++q)*2**8+b.readUInt8(++q)),this._state.state=3,this._state.readLen=M,this._state.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const b=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",b),t(b,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",b),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(b,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=h;class y extends v.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:k.VSBuffer.alloc(0)}constructor(d,b,O,F,M,q){super(),this._tracer=d,this._onData=M,this._writeFn=q,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new P.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new P.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,b?(this._zlibInflateStream=this._register(new E(this._tracer,F,O,{windowBits:15})),this._zlibDeflateStream=this._register(new R(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(j=>this._onError.fire(j))),this._register(this._zlibDeflateStream.onError(j=>this._onError.fire(j)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(d){this._writeQueue.push(d),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const d=this._writeQueue.shift();if(this._zlibDeflateStream){const b=await this._deflateMessage(this._zlibDeflateStream,d);this._writeFn(b,!0)}else this._writeFn(d,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(d,b){return new Promise((O,F)=>{d.write(b),d.flush(M=>O(M))})}acceptFrame(d,b,O){this._readQueue.push({data:d,isCompressed:b,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const d=this._readQueue.shift();if(this._zlibInflateStream&&d.isCompressed){const b=await this._inflateFrame(this._zlibInflateStream,d.data,d.isLastFrameOfMessage);this._onData.fire(b)}else this._onData.fire(d.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(d,b,O){return new Promise((F,M)=>{d.write(b),O&&d.write(k.VSBuffer.fromByteArray([0,0,255,255])),d.flush(q=>F(q))})}}class E extends v.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.concat(this._recordedInflateBytes):k.VSBuffer.alloc(0)}constructor(d,b,O,F){super(),this._tracer=d,this._recordInflateBytes=b,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,A.createInflateRaw)(F),this._zlibInflate.on("error",M=>{this._tracer.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibInflate.on("data",M=>{this._tracer.traceSocketEvent("zlibInflateData",M),this._pendingInflateData.push(k.VSBuffer.wrap(M))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(d){this._recordInflateBytes&&this._recordedInflateBytes.push(d.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",d),this._zlibInflate.write(d.buffer)}flush(d){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const b=k.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,d(b)})}}class R extends v.Disposable{constructor(d,b){super(),this._tracer=d,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,A.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(k.VSBuffer.wrap(O))})}write(d){this._tracer.traceSocketEvent("zlibDeflateWrite",d.buffer),this._zlibDeflate.write(d.buffer)}flush(d){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let b=k.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.byteLength-4),d(b)})}}function t(m,d){if(d===0)return;const b=m.byteLength>>>2;for(let B=0;B<b;B++){const Q=m.readUInt32BE(B*4);m.writeUInt32BE(Q^d,B*4)}const O=b*4,F=m.byteLength-O,M=d>>>24&255,q=d>>>16&255,j=d>>>8&255;F>=1&&m.writeUInt8(m.readUInt8(O)^M,O),F>=2&&m.writeUInt8(m.readUInt8(O+1)^q,O+1),F>=3&&m.writeUInt8(m.readUInt8(O+2)^j,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function n(){const m=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const d=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,T.tmpdir)(),b=(0,I.join)(d,`vscode-ipc-${m}.sock`);return i(b),b}e.createRandomIPCHandle=n;function s(m,d,b){const O=(0,L.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${b}-${d}-sock`;const F=b.substr(0,4),M=d.substr(0,6),q=O.substr(0,8);let j;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?j=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${q}-${F}-${M}.sock`):j=(0,I.join)(m,`${F}-${M}.sock`),i(j),j}e.createStaticIPCHandle=s;function i(m){const d=o[C.platform];typeof d=="number"&&m.length>=d&&console.warn(`WARNING: IPC handle "${m}" is longer than ${d} chars, try a shorter --user-data-dir`)}class r extends u.IPCServer{static toClientConnectionEvent(d){const b=P.Event.fromNodeEventEmitter(d,"connection");return P.Event.map(b,O=>({protocol:new g.Protocol(new w(O,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(O,"close"))}))}constructor(d){super(r.toClientConnectionEvent(d)),this.server=d}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function a(m){return new Promise((d,b)=>{const O=(0,N.createServer)();O.on("error",b),O.listen(m,()=>{O.removeListener("error",b),d(new r(O))})})}e.serve=a;function p(m,d){return new Promise((b,O)=>{const F=(0,N.createConnection)(m,()=>{F.removeListener("error",O),b(g.Client.fromSocket(new w(F,`ipc-client${d}`),d))});F.once("error",O)})}e.connect=p}),define(oe[262],ae([0,1,60,261,206]),function(te,e,L,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{supports(A){return!0}connect({host:A,port:k},D,P,v){return new Promise((I,C)=>{const S=L.createConnection({host:A,port:k},()=>{S.removeListener("error",C),S.write((0,T.makeRawSocketHeaders)(D,P,v));const u=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(S.off("data",u),I(new N.NodeSocket(S,v)))};S.on("data",u)});S.setNoDelay(!0),S.once("error",C)})}}}),define(oe[270],ae([0,1,36,38,7,2,26,10,43,143,200,201,192,193,257,183,185,18,205,95,215,96,211,15,113,242,29,97,184,121,98,13,195,196,66,4,191,68,70,220,8,197,102,24,57,19,107,20,108,109,110,46,223,78,111,23,76,248,234,235,79,249,252,253,254,58,247,236,106,214,74,225,210,224,28,226,5,227,186,203,202,77,241,17,50,199,56,246,222,237,105,251,260,9,198,101,244,240,212,180,55,255,243,69,245,104,262,178]),function(te,e,L,N,T,A,k,D,P,v,I,C,S,u,g,w,c,l,h,y,E,R,t,o,n,s,i,r,a,p,m,d,b,O,F,M,q,j,B,Q,J,G,X,V,x,z,ee,ne,ce,re,U,f,_,$,H,W,K,Z,se,ue,he,Se,Ee,be,De,_e,$e,Be,le,fe,ge,Pe,Ie,Fe,ke,We,Ae,Ue,Me,ie,de,me,ye,pe,Ce,Re,Le,Te,xe,Ne,je,qe,Ze,nt,Pt,mt,It,Dt,Rt,Lt,kt,_t,Tt,St,At,vt,Ut,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Nt extends A.Disposable{constructor(we){super(),this.configuration=we,this.server=this._register(new v.Server),this.lifecycleService=void 0,this.registerListeners()}registerListeners(){let we=!1;const Oe=()=>{we||(we=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};process.once("exit",Oe),(0,v.once)(process.parentPort,"vscode:electron-main->shared-process=exit",Oe)}async init(){const we=await this.initServices();(0,W.registerConfiguration)(),we.invokeFunction(Oe=>{const Ye=Oe.get(J.ILogService);Ye.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(Ye)}),this._register((0,A.combinedDisposable)(we.createInstance(I.CodeCacheCleaner,this.configuration.codeCachePath),we.createInstance(C.LanguagePackCachedDataCleaner),we.createInstance(g.UnusedWorkspaceStorageDataCleaner),we.createInstance(u.LogsDataCleaner),we.createInstance(S.LocalizationsUpdater),we.createInstance(Ze.ExtensionsContributions),we.createInstance(Ne.UserDataProfilesCleaner)))}async initServices(){const we=new j.ServiceCollection,Oe={_serviceBrand:void 0,...X.default};we.set(V.IProductService,Oe);const Ye=new P.StaticRouter(Ve=>Ve==="main"),He=new St.MainProcessService(this.server,Ye);we.set(St.IMainProcessService,He);const at=this.configuration.policiesData?new Re.PolicyChannelClient(this.configuration.policiesData,He.getChannel("policy")):new Le.NullPolicyService;we.set(Le.IPolicyService,at);const Ge=new Ot.NativeEnvironmentService(this.configuration.args,Oe);we.set(o.INativeEnvironmentService,Ge);const et=new G.LoggerChannelClient(void 0,this.configuration.logLevel,Ge.logsHome,this.configuration.loggers.map(Ve=>({...Ve,resource:D.URI.revive(Ve.resource)})),He.getChannel("logger"));we.set(J.ILoggerService,et);const ct=this._register(et.createLogger("sharedprocess",{name:(0,nt.localize)(0,null)})),ht=this._register(new J.ConsoleLogger(ct.getLevel())),Ke=this._register(new Pt.LogService(ct,[ht]));we.set(J.ILogService,Ke),this.lifecycleService=this._register(new mt.SharedProcessLifecycleService(Ke)),we.set(mt.ISharedProcessLifecycleService,this.lifecycleService);const Qe=this._register(new b.FileService(Ke));we.set(d.IFileService,Qe);const dt=this._register(new O.DiskFileSystemProvider(Ke));Qe.registerProvider(k.Schemas.file,dt);const ft=this._register(new Ue.FileUserDataProvider(k.Schemas.file,this._register(new Me.DiskFileSystemProviderClient(He.getChannel(Me.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Ae.isLinux})),k.Schemas.vscodeUserData,Ke));Qe.registerProvider(k.Schemas.vscodeUserData,ft);const tt=this._register(new Te.UserDataProfilesService(this.configuration.profiles.all,D.URI.revive(this.configuration.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),He.getChannel("userDataProfiles")));we.set(pe.IUserDataProfilesService,tt);const Xe=this._register(new h.ConfigurationService(tt.defaultProfile.settingsResource,Qe,at,Ke));we.set(l.IConfigurationService,Xe);const st=new At.RemoteStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},He,Ge);we.set(z.IStorageService,st),this._register((0,A.toDisposable)(()=>st.flush())),await Promise.all([Xe.initialize(),st.initialize()]);const Ft=new We.UriIdentityService(Qe);we.set(ke.IUriIdentityService,Ft);const yt=new Rt.RequestChannelClient(He.getChannel("request"));we.set(x.IRequestService,yt),we.set(w.IChecksumService,new F.SyncDescriptor(c.ChecksumService,void 0,!1)),we.set(de.IV8InspectProfilingService,new F.SyncDescriptor(ie.InspectProfilingService,void 0,!1));const Et=P.ProxyChannel.toService(He.getChannel("nativeHost"));we.set(kt.INativeHostService,Et),we.set(R.IDownloadService,new F.SyncDescriptor(t.DownloadService,void 0,!0));const Mt=this._register(new Be.ActiveWindowManager(Et)),$t=new P.StaticRouter(Ve=>Mt.getActiveClientId().then(ut=>Ve===ut));we.set(m.IExtensionRecommendationNotificationService,new Lt.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",$t)));let lt;const rt=[],wt=(0,f.isInternalTelemetry)(Oe,Xe);if((0,f.supportsTelemetry)(Oe,Ge)){const Ve=new re.TelemetryLogAppender(Ke,et,Ge,Oe);if(rt.push(Ve),Oe.aiConfig?.ariaKey){const ut=new xe.OneDataSystemAppender(yt,wt,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,A.toDisposable)(()=>ut.flush())),rt.push(ut)}lt=new U.TelemetryService({appenders:rt,commonProperties:(0,ee.resolveCommonProperties)((0,L.release)(),(0,L.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,wt),sendErrorTelemetry:!0,piiPaths:(0,f.getPiiPathsFromEnvironment)(Ge)},Xe,Oe)}else{lt=f.NullTelemetryService;const Ve=f.NullAppender;rt.push(Ve)}this.server.registerChannel("telemetryAppender",new ce.TelemetryAppenderChannel(rt)),we.set(ne.ITelemetryService,lt);const Wt=new _.CustomEndpointTelemetryService(Xe,lt,Ke,et,Ge,Oe);we.set(ne.ICustomEndpointTelemetryService,Wt),we.set(Ce.IExtensionsProfileScannerService,new F.SyncDescriptor(Dt.ExtensionsProfileScannerService,void 0,!0)),we.set(me.IExtensionsScannerService,new F.SyncDescriptor(ye.ExtensionsScannerService,void 0,!0)),we.set(r.IExtensionSignatureVerificationService,new F.SyncDescriptor(r.ExtensionSignatureVerificationService,void 0,!0)),we.set(p.INativeServerExtensionManagementService,new F.SyncDescriptor(p.ExtensionManagementService,void 0,!0)),we.set(i.IExtensionGalleryService,new F.SyncDescriptor(s.ExtensionGalleryService,void 0,!0)),we.set(i.IExtensionTipsService,new F.SyncDescriptor(Tt.ExtensionTipsService,void 0,!1)),we.set(B.ILanguagePackService,new F.SyncDescriptor(Q.NativeLanguagePackService,void 0,!1)),we.set(y.IDiagnosticsService,new F.SyncDescriptor(E.DiagnosticsService,void 0,!1)),we.set(K.IUserDataSyncAccountService,new F.SyncDescriptor(K.UserDataSyncAccountService,void 0,!0)),we.set(W.IUserDataSyncLogService,new F.SyncDescriptor(ue.UserDataSyncLogService,void 0,!0)),we.set(W.IUserDataSyncUtilService,new se.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ve=>Ve.ctx!=="main"))),we.set(i.IGlobalExtensionEnablementService,new F.SyncDescriptor(n.GlobalExtensionEnablementService,void 0,!1)),we.set(H.IIgnoredExtensionsManagementService,new F.SyncDescriptor(H.IgnoredExtensionsManagementService,void 0,!0)),we.set($.IExtensionStorageService,new F.SyncDescriptor($.ExtensionStorageService)),we.set(W.IUserDataSyncStoreManagementService,new F.SyncDescriptor(De.UserDataSyncStoreManagementService,void 0,!0)),we.set(W.IUserDataSyncStoreService,new F.SyncDescriptor(De.UserDataSyncStoreService,void 0,!0)),we.set(he.IUserDataSyncMachinesService,new F.SyncDescriptor(he.UserDataSyncMachinesService,void 0,!0)),we.set(W.IUserDataSyncBackupStoreService,new F.SyncDescriptor(Z.UserDataSyncBackupStoreService,void 0,!1)),we.set(W.IUserDataSyncEnablementService,new F.SyncDescriptor(Se.UserDataSyncEnablementService,void 0,!0)),we.set(W.IUserDataSyncService,new F.SyncDescriptor(Ee.UserDataSyncService,void 0,!1)),we.set(_e.IUserDataProfileStorageService,new F.SyncDescriptor($e.NativeUserDataProfileStorageService,void 0,!0)),we.set(W.IUserDataSyncResourceProviderService,new F.SyncDescriptor(qe.UserDataSyncResourceProviderService,void 0,!0)),we.set(le.ISignService,new F.SyncDescriptor(fe.SignService,void 0,!1));const Ct=new vt.RemoteSocketFactoryService;return we.set(vt.IRemoteSocketFactoryService,Ct),Ct.register(0,Ut.nodeSocketFactory),we.set(ge.ISharedTunnelsService,new F.SyncDescriptor(Pe.SharedTunnelsService)),we.set(Ie.ISharedProcessTunnelService,new F.SyncDescriptor(Fe.SharedProcessTunnelService)),we.set(je.IRemoteTunnelService,new F.SyncDescriptor(It.RemoteTunnelService)),new q.InstantiationService(we)}initChannels(we){const Oe=new a.ExtensionManagementChannel(we.get(i.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const Ye=P.ProxyChannel.fromService(we.get(B.ILanguagePackService));this.server.registerChannel("languagePacks",Ye);const He=P.ProxyChannel.fromService(we.get(y.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const at=new a.ExtensionTipsChannel(we.get(i.IExtensionTipsService));this.server.registerChannel("extensionTipsService",at);const Ge=P.ProxyChannel.fromService(we.get(w.IChecksumService));this.server.registerChannel("checksum",Ge);const et=P.ProxyChannel.fromService(we.get(de.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",et);const ct=new se.UserDataSyncMachinesServiceChannel(we.get(he.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ct);const ht=P.ProxyChannel.fromService(we.get(ne.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",ht);const Ke=new se.UserDataSyncAccountServiceChannel(we.get(K.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ke);const Qe=new se.UserDataSyncStoreManagementServiceChannel(we.get(W.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Qe);const dt=new be.UserDataSyncChannel(we.get(W.IUserDataSyncService),we.get(pe.IUserDataProfilesService),we.get(J.ILogService));this.server.registerChannel("userDataSync",dt);const ft=this._register(we.get(M.IInstantiationService).createInstance(_t.UserDataAutoSyncService)),tt=new se.UserDataAutoSyncChannel(ft);this.server.registerChannel("userDataAutoSync",tt);const Xe=P.ProxyChannel.fromService(we.get(Ie.ISharedProcessTunnelService));this.server.registerChannel(Ie.ipcSharedProcessTunnelChannelName,Xe);const st=P.ProxyChannel.fromService(we.get(je.IRemoteTunnelService));this.server.registerChannel("remoteTunnel",st)}registerErrorHandler(we){process.on("uncaughtException",Oe=>(0,T.onUnexpectedError)(Oe)),process.on("unhandledRejection",Oe=>(0,T.onUnexpectedError)(Oe)),(0,T.setUnexpectedErrorHandler)(Oe=>{const Ye=(0,N.toErrorMessage)(Oe,!0);Ye&&we.error(`[uncaught exception in sharedProcess]: ${Ye}`)})}}async function pt(ot){const we=new Nt(ot);process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"),await we.init(),process.parentPort.postMessage("vscode:shared-process->electron-main=init-done")}e.main=pt,process.parentPort.once("message",ot=>{pt(ot.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/aef377c42cea6e9aea642829953104f07097abfa/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
