/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/event","vs/base/common/lifecycle","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/strings","vs/base/common/path","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/process","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","child_process","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","fs","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/htmlContent","os","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/labels","vs/base/common/uriIpc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(me){for(var e=[],_=0,L=me.length;_<L;_++)e[_]=De[me[_]];return e};define(De[150],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class _{static get(){const d=new Map,A=new Map,T=new Map,m=new Map;function y(C,D){C.has(D.detail)||C.set(D.detail,-D.timestamp)}function v(C,D){const b=C.get(D.detail);b&&(b>=0||C.set(D.detail,b+D.timestamp))}let R=[];typeof me=="function"&&typeof me.getStats=="function"&&(R=me.getStats().slice(0).sort((C,D)=>C.timestamp-D.timestamp));for(const C of R)switch(C.type){case 10:y(d,C);break;case 11:case 12:v(d,C);break;case 21:y(A,C);break;case 22:v(A,C);break;case 33:y(T,C);break;case 34:v(T,C);break;case 31:y(m,C);break;case 32:v(m,C);break}let k=0;T.forEach(C=>k+=C);function p(C){const D=[];return C.forEach((b,r)=>D.push([r,b])),D}return{amdLoad:p(d),amdInvoke:p(A),nodeRequire:p(T),nodeEval:p(m),nodeRequireTotal:k}}static toMarkdownTable(d,A){let T="";const m=[];return d.forEach((y,v)=>{m[v]=y.length}),A.forEach(y=>{y.forEach((v,R)=>{typeof v>"u"&&(v=y[R]="-");const k=v.toString().length;m[R]=Math.max(k,m[R])})}),d.forEach((y,v)=>{T+=`| ${y+" ".repeat(m[v]-y.toString().length)} `}),T+=`|
`,d.forEach((y,v)=>{T+=`| ${"-".repeat(m[v])} `}),T+=`|
`,A.forEach(y=>{y.forEach((v,R)=>{typeof v<"u"&&(T+=`| ${v+" ".repeat(m[R]-v.toString().length)} `)}),T+=`|
`}),T}}e.LoaderStats=_}),define(De[65],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function _(T,m){const y=Object.create(null);for(const v of T){const R=m(v);let k=y[R];k||(k=y[R]=[]),k.push(v)}return y}e.groupBy=_;function L(T,m){const y=[],v=[];for(const R of T)m.has(R)||y.push(R);for(const R of m)T.has(R)||v.push(R);return{removed:y,added:v}}e.diffSets=L;function d(T,m){const y=[],v=[];for(const[R,k]of T)m.has(R)||y.push(k);for(const[R,k]of m)T.has(R)||v.push(k);return{removed:y,added:v}}e.diffMaps=d;class A{constructor(){this.map=new Map}add(m,y){let v=this.map.get(m);v||(v=new Set,this.map.set(m,v)),v.add(y)}delete(m,y){const v=this.map.get(m);v&&(v.delete(y),v.size===0&&this.map.delete(m))}forEach(m,y){const v=this.map.get(m);v&&v.forEach(y)}get(m){const y=this.map.get(m);return y?new Set(y):new Set}}e.SetMap=A}),define(De[66],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function _(T){return(m,y,v)=>{let R=null,k=null;if(typeof v.value=="function"?(R="value",k=v.value):typeof v.get=="function"&&(R="get",k=v.get),!k)throw new Error("not supported");v[R]=T(k,y)}}function L(T,m,y){let v=null,R=null;if(typeof y.value=="function"?(v="value",R=y.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(v="get",R=y.get),!R)throw new Error("not supported");const k=`$memoize$${m}`;y[v]=function(...p){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,p)}),this[k]}}e.memoize=L;function d(T,m,y){return _((v,R)=>{const k=`$debounce$${R}`,p=`$debounce$result$${R}`;return function(...C){this[p]||(this[p]=y?y():void 0),clearTimeout(this[k]),m&&(this[p]=m(this[p],...C),C=[this[p]]),this[k]=setTimeout(()=>{v.apply(this,C),this[p]=y?y():void 0},T)}})}e.debounce=d;function A(T,m,y){return _((v,R)=>{const k=`$throttle$timer$${R}`,p=`$throttle$result$${R}`,C=`$throttle$lastRun$${R}`,D=`$throttle$pending$${R}`;return function(...b){if(this[p]||(this[p]=y?y():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),m&&(this[p]=m(this[p],...b)),this[D])return;const r=this[C]+T;r<=Date.now()?(this[C]=Date.now(),v.apply(this,[this[p]]),this[p]=y?y():void 0):(this[D]=!0,this[k]=setTimeout(()=>{this[D]=!1,this[C]=Date.now(),v.apply(this,[this[p]]),this[p]=y?y():void 0},r-Date.now()))}})}e.throttle=A}),define(De[8],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?S.isErrorNoTelemetry(a)?new S(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(n=>{n(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=_,e.errorHandler=new _;function L(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=L;function d(i){if(!i||typeof i!="object")return!1;const a=i;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=d;function A(i){v(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=A;function T(i){v(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=T;function m(i){if(i instanceof Error){const{name:a,message:n}=i,t=i.stacktrace||i.stack;return{$isError:!0,name:a,message:n,stack:t,noTelemetry:S.isErrorNoTelemetry(i)}}return i}e.transformErrorForSerialization=m;const y="Canceled";function v(i){return i instanceof R?!0:i instanceof Error&&i.name===y&&i.message===y}e.isCancellationError=v;class R extends Error{constructor(){super(y),this.name=this.message}}e.CancellationError=R;function k(){const i=new Error(y);return i.name=i.message,i}e.canceled=k;function p(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=p;function C(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=C;function D(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=D;function b(i){const a=new Error(`${i} has been disposed`);return a.name="DISPOSED",a}e.disposed=b;function r(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=r;class s extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.NotImplementedError=s;class c extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.NotSupportedError=c;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=f;class S extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof S)return a;const n=new S;return n.message=a.message,n.stack=a.stack,n}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.ErrorNoTelemetry=S;class I extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,I.prototype)}}e.BugIndicatingError=I}),define(De[19],Ie([1,0,8]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L(ne,ee=0){return ne[ne.length-(1+ee)]}e.tail=L;function d(ne){if(ne.length===0)throw new Error("Invalid tail call");return[ne.slice(0,ne.length-1),ne[ne.length-1]]}e.tail2=d;function A(ne,ee,de=(K,le)=>K===le){if(ne===ee)return!0;if(!ne||!ee||ne.length!==ee.length)return!1;for(let K=0,le=ne.length;K<le;K++)if(!de(ne[K],ee[K]))return!1;return!0}e.equals=A;function T(ne,ee){const de=ne.length-1;ee<de&&(ne[ee]=ne[de]),ne.pop()}e.removeFastWithoutKeepingOrder=T;function m(ne,ee,de){return y(ne.length,K=>de(ne[K],ee))}e.binarySearch=m;function y(ne,ee){let de=0,K=ne-1;for(;de<=K;){const le=(de+K)/2|0,oe=ee(le);if(oe<0)de=le+1;else if(oe>0)K=le-1;else return le}return-(de+1)}e.binarySearch2=y;function v(ne,ee){let de=0,K=ne.length;if(K===0)return 0;for(;de<K;){const le=Math.floor((de+K)/2);ee(ne[le])?K=le:de=le+1}return de}e.findFirstInSorted=v;function R(ne,ee,de){if(ne=ne|0,ne>=ee.length)throw new TypeError("invalid index");const K=ee[Math.floor(ee.length*Math.random())],le=[],oe=[],ue=[];for(const Ee of ee){const M=de(Ee,K);M<0?le.push(Ee):M>0?oe.push(Ee):ue.push(Ee)}return ne<le.length?R(ne,le,de):ne<le.length+ue.length?ue[0]:R(ne-(le.length+ue.length),oe,de)}e.quickSelect=R;function k(ne,ee){const de=[];let K;for(const le of ne.slice(0).sort(ee))!K||ee(K[0],le)!==0?(K=[le],de.push(K)):K.push(le);return de}e.groupBy=k;function p(ne,ee,de){const K=[];function le(Ee,M,q){if(M===0&&q.length===0)return;const G=K[K.length-1];G&&G.start+G.deleteCount===Ee?(G.deleteCount+=M,G.toInsert.push(...q)):K.push({start:Ee,deleteCount:M,toInsert:q})}let oe=0,ue=0;for(;;){if(oe===ne.length){le(oe,0,ee.slice(ue));break}if(ue===ee.length){le(oe,ne.length-oe,[]);break}const Ee=ne[oe],M=ee[ue],q=de(Ee,M);q===0?(oe+=1,ue+=1):q<0?(le(oe,1,[]),oe+=1):q>0&&(le(oe,0,[M]),ue+=1)}return K}e.sortedDiff=p;function C(ne,ee,de){const K=p(ne,ee,de),le=[],oe=[];for(const ue of K)le.push(...ne.slice(ue.start,ue.start+ue.deleteCount)),oe.push(...ue.toInsert);return{removed:le,added:oe}}e.delta=C;function D(ne,ee,de){if(de===0)return[];const K=ne.slice(0,de).sort(ee);return r(ne,ee,K,de,ne.length),K}e.top=D;function b(ne,ee,de,K,le){return de===0?Promise.resolve([]):new Promise((oe,ue)=>{(async()=>{const Ee=ne.length,M=ne.slice(0,de).sort(ee);for(let q=de,G=Math.min(de+K,Ee);q<Ee;q=G,G=Math.min(G+K,Ee)){if(q>de&&await new Promise(J=>setTimeout(J)),le&&le.isCancellationRequested)throw new _.CancellationError;r(ne,ee,M,q,G)}return M})().then(oe,ue)})}e.topAsync=b;function r(ne,ee,de,K,le){for(const oe=de.length;K<le;K++){const ue=ne[K];if(ee(ue,de[oe-1])<0){de.pop();const Ee=v(de,M=>ee(ue,M)<0);de.splice(Ee,0,ue)}}}function s(ne){return ne.filter(ee=>!!ee)}e.coalesce=s;function c(ne){let ee=0;for(let de=0;de<ne.length;de++)ne[de]&&(ne[ee]=ne[de],ee+=1);ne.length=ee}e.coalesceInPlace=c;function f(ne,ee,de){ne.splice(de,0,ne.splice(ee,1)[0])}e.move=f;function S(ne){return!Array.isArray(ne)||ne.length===0}e.isFalsyOrEmpty=S;function I(ne){return Array.isArray(ne)&&ne.length>0}e.isNonEmptyArray=I;function i(ne,ee=de=>de){const de=new Set;return ne.filter(K=>{const le=ee(K);return de.has(le)?!1:(de.add(le),!0)})}e.distinct=i;function a(ne){const ee=new Set;return de=>{const K=ne(de);return ee.has(K)?!1:(ee.add(K),!0)}}e.uniqueFilter=a;function n(ne,ee){const de=t(ne,ee);if(de!==-1)return ne[de]}e.findLast=n;function t(ne,ee){for(let de=ne.length-1;de>=0;de--){const K=ne[de];if(ee(K))return de}return-1}e.lastIndex=t;function o(ne,ee){return ne.length>0?ne[0]:ee}e.firstOrDefault=o;function g(ne,ee){return ne.length>0?ne[ne.length-1]:ee}e.lastOrDefault=g;function l(ne,ee,de=(K,le)=>K===le){let K=0;for(let le=0,oe=Math.min(ne.length,ee.length);le<oe&&de(ne[le],ee[le]);le++)K++;return K}e.commonPrefixLength=l;function h(ne){return[].concat(...ne)}e.flatten=h;function w(ne,ee){let de=typeof ee=="number"?ne:0;typeof ee=="number"?de=ne:(de=0,ee=ne);const K=[];if(de<=ee)for(let le=de;le<ee;le++)K.push(le);else for(let le=de;le>ee;le--)K.push(le);return K}e.range=w;function u(ne,ee,de){return ne.reduce((K,le)=>(K[ee(le)]=de?de(le):le,K),Object.create(null))}e.index=u;function E(ne,ee){return ne.push(ee),()=>P(ne,ee)}e.insert=E;function P(ne,ee){const de=ne.indexOf(ee);if(de>-1)return ne.splice(de,1),ee}e.remove=P;function O(ne,ee,de){const K=ne.slice(0,ee),le=ne.slice(ee);return K.concat(de,le)}e.arrayInsert=O;function N(ne,ee){let de;if(typeof ee=="number"){let K=ee;de=()=>{const le=Math.sin(K++)*179426549;return le-Math.floor(le)}}else de=Math.random;for(let K=ne.length-1;K>0;K-=1){const le=Math.floor(de()*(K+1)),oe=ne[K];ne[K]=ne[le],ne[le]=oe}}e.shuffle=N;function F(ne,ee){const de=ne.indexOf(ee);de>-1&&(ne.splice(de,1),ne.unshift(ee))}e.pushToStart=F;function x(ne,ee){const de=ne.indexOf(ee);de>-1&&(ne.splice(de,1),ne.push(ee))}e.pushToEnd=x;function B(ne,ee){for(const de of ee)ne.push(de)}e.pushMany=B;function U(ne,ee){return Array.isArray(ne)?ne.map(ee):ee(ne)}e.mapArrayOrNot=U;function X(ne){return Array.isArray(ne)?ne:[ne]}e.asArray=X;function j(ne){return ne[Math.floor(Math.random()*ne.length)]}e.getRandomElement=j;function ge(ne,ee){for(const de of ne){const K=ee(de);if(K!==void 0)return K}}e.mapFind=ge;function ie(ne,ee,de){const K=$(ne,ee),le=ne.length,oe=de.length;ne.length=le+oe;for(let ue=le-1;ue>=K;ue--)ne[ue+oe]=ne[ue];for(let ue=0;ue<oe;ue++)ne[ue+K]=de[ue]}e.insertInto=ie;function te(ne,ee,de,K){const le=$(ne,ee),oe=ne.splice(le,de);return ie(ne,le,K),oe}e.splice=te;function $(ne,ee){return ee<0?Math.max(ee+ne.length,0):Math.min(ee,ne.length)}var H;(function(ne){function ee(le){return le<0}ne.isLessThan=ee;function de(le){return le>0}ne.isGreaterThan=de;function K(le){return le===0}ne.isNeitherLessOrGreaterThan=K,ne.greaterThan=1,ne.lessThan=-1,ne.neitherLessOrGreaterThan=0})(H||(e.CompareResult=H={}));function ce(ne,ee){return(de,K)=>ee(ne(de),ne(K))}e.compareBy=ce;function re(...ne){return(ee,de)=>{for(const K of ne){const le=K(ee,de);if(!H.isNeitherLessOrGreaterThan(le))return le}return H.neitherLessOrGreaterThan}}e.tieBreakComparators=re;const fe=(ne,ee)=>ne-ee;e.numberComparator=fe;function he(ne,ee){if(ne.length===0)return;let de=ne[0];for(let K=1;K<ne.length;K++){const le=ne[K];ee(le,de)>0&&(de=le)}return de}e.findMaxBy=he;function z(ne,ee){if(ne.length===0)return;let de=ne[0];for(let K=1;K<ne.length;K++){const le=ne[K];ee(le,de)>=0&&(de=le)}return de}e.findLastMaxBy=z;function Z(ne,ee){return he(ne,(de,K)=>-ee(de,K))}e.findMinBy=Z;class ye{constructor(ee){this.items=ee,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ee){let de=this.firstIdx;for(;de<this.items.length&&ee(this.items[de]);)de++;const K=de===this.firstIdx?null:this.items.slice(this.firstIdx,de);return this.firstIdx=de,K}takeFromEndWhile(ee){let de=this.lastIdx;for(;de>=0&&ee(this.items[de]);)de--;const K=de===this.lastIdx?null:this.items.slice(de+1,this.lastIdx+1);return this.lastIdx=de,K}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ee=this.items[this.firstIdx];return this.firstIdx++,ee}removeLast(){const ee=this.items[this.lastIdx];return this.lastIdx--,ee}takeCount(ee){const de=this.items.slice(this.firstIdx,this.firstIdx+ee);return this.firstIdx+=ee,de}}e.ArrayQueue=ye;class Re{static{this.empty=new Re(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(de=>(ee(de),!0))}toArray(){const ee=[];return this.iterate(de=>(ee.push(de),!0)),ee}filter(ee){return new Re(de=>this.iterate(K=>ee(K)?de(K):!0))}map(ee){return new Re(de=>this.iterate(K=>de(ee(K))))}some(ee){let de=!1;return this.iterate(K=>(de=ee(K),!de)),de}findFirst(ee){let de;return this.iterate(K=>ee(K)?(de=K,!1):!0),de}findLast(ee){let de;return this.iterate(K=>(ee(K)&&(de=K),!0)),de}findLastMaxBy(ee){let de,K=!0;return this.iterate(le=>((K||H.isGreaterThan(ee(le,de)))&&(K=!1,de=le),!0)),de}}e.CallbackIterable=Re}),define(De[53],Ie([1,0,8]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(y,v){if(!y)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=L;function d(y,v="Unreachable"){throw new Error(v)}e.assertNever=d;function A(y){if(!y)throw new _.BugIndicatingError("Assertion Failed")}e.assert=A;function T(y){if(!y()){debugger;y(),(0,_.onUnexpectedError)(new _.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function m(y,v){let R=0;for(;R<y.length-1;){const k=y[R],p=y[R+1];if(!v(k,p))return!1;R++}return!0}e.checkAdjacentItems=m}),define(De[67],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(L){const d=this;let A=!1,T;return function(){return A||(A=!0,T=L.apply(d,arguments)),T}}e.once=_}),define(De[111],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class _{constructor(d){this._prefix=d,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=_,e.defaultGenerator=new _("id#")}),define(De[48],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(L){function d(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}L.is=d;const A=Object.freeze([]);function T(){return A}L.empty=T;function*m(S){yield S}L.single=m;function y(S){return d(S)?S:m(S)}L.wrap=y;function v(S){return S||A}L.from=v;function R(S){return!S||S[Symbol.iterator]().next().done===!0}L.isEmpty=R;function k(S){return S[Symbol.iterator]().next().value}L.first=k;function p(S,I){for(const i of S)if(I(i))return!0;return!1}L.some=p;function C(S,I){for(const i of S)if(I(i))return i}L.find=C;function*D(S,I){for(const i of S)I(i)&&(yield i)}L.filter=D;function*b(S,I){let i=0;for(const a of S)yield I(a,i++)}L.map=b;function*r(...S){for(const I of S)for(const i of I)yield i}L.concat=r;function s(S,I,i){let a=i;for(const n of S)a=I(a,n);return a}L.reduce=s;function*c(S,I,i=S.length){for(I<0&&(I+=S.length),i<0?i+=S.length:i>S.length&&(i=S.length);I<i;I++)yield S[I]}L.slice=c;function f(S,I=Number.POSITIVE_INFINITY){const i=[];if(I===0)return[i,S];const a=S[Symbol.iterator]();for(let n=0;n<I;n++){const t=a.next();if(t.done)return[i,L.empty()];i.push(t.value)}return[i,{[Symbol.iterator](){return a}}]}L.consume=f})(_||(e.Iterable=_={}))}),define(De[151],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(_||(e.ScanError=_={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var d;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(d||(e.ParseErrorCode=d={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function T(i,a=!1){let n=0;const t=i.length;let o="",g=0,l=16,h=0;function w(x){let B=0,U=0;for(;B<x;){const X=i.charCodeAt(n);if(X>=48&&X<=57)U=U*16+X-48;else if(X>=65&&X<=70)U=U*16+X-65+10;else if(X>=97&&X<=102)U=U*16+X-97+10;else break;n++,B++}return B<x&&(U=-1),U}function u(x){n=x,o="",g=0,l=16,h=0}function E(){const x=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&v(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&v(i.charCodeAt(n)))for(n++;n<i.length&&v(i.charCodeAt(n));)n++;else return h=3,i.substring(x,n);let B=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&v(i.charCodeAt(n))){for(n++;n<i.length&&v(i.charCodeAt(n));)n++;B=n}else h=3;return i.substring(x,B)}function P(){let x="",B=n;for(;;){if(n>=t){x+=i.substring(B,n),h=2;break}const U=i.charCodeAt(n);if(U===34){x+=i.substring(B,n),n++;break}if(U===92){if(x+=i.substring(B,n),n++,n>=t){h=2;break}switch(i.charCodeAt(n++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const j=w(4);j>=0?x+=String.fromCharCode(j):h=4;break}default:h=5}B=n;continue}if(U>=0&&U<=31)if(y(U)){x+=i.substring(B,n),h=2;break}else h=6;n++}return x}function O(){if(o="",h=0,g=n,n>=t)return g=t,l=17;let x=i.charCodeAt(n);if(m(x)){do n++,o+=String.fromCharCode(x),x=i.charCodeAt(n);while(m(x));return l=15}if(y(x))return n++,o+=String.fromCharCode(x),x===13&&i.charCodeAt(n)===10&&(n++,o+=`
`),l=14;switch(x){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,o=P(),l=10;case 47:{const B=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<t&&!y(i.charCodeAt(n));)n++;return o=i.substring(B,n),l=12}if(i.charCodeAt(n+1)===42){n+=2;const U=t-1;let X=!1;for(;n<U;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,X=!0;break}n++}return X||(n++,h=1),o=i.substring(B,n),l=13}return o+=String.fromCharCode(x),n++,l=16}case 45:if(o+=String.fromCharCode(x),n++,n===t||!v(i.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=E(),l=11;default:for(;n<t&&N(x);)n++,x=i.charCodeAt(n);if(g!==n){switch(o=i.substring(g,n),o){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return o+=String.fromCharCode(x),n++,l=16}}function N(x){if(m(x)||y(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let x;do x=O();while(x>=12&&x<=15);return x}return{setPosition:u,getPosition:()=>n,scan:a?F:O,getToken:()=>l,getTokenValue:()=>o,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>h}}e.createScanner=T;function m(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function y(i){return i===10||i===13||i===8232||i===8233}function v(i){return i>=48&&i<=57}var R;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(R||(R={}));function k(i,a){const n=[],t=new Object;let o;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function h(w,u,E,P){g.value=w,g.offset=u,g.length=E,g.type=P,g.colonOffset=void 0,o=g}try{f(i,{onObjectBegin:(w,u)=>{if(a<=w)throw t;o=void 0,l=a>w,n.push("")},onObjectProperty:(w,u,E)=>{if(a<u||(h(w,u,E,"property"),n[n.length-1]=w,a<=u+E))throw t},onObjectEnd:(w,u)=>{if(a<=w)throw t;o=void 0,n.pop()},onArrayBegin:(w,u)=>{if(a<=w)throw t;o=void 0,n.push(0)},onArrayEnd:(w,u)=>{if(a<=w)throw t;o=void 0,n.pop()},onLiteralValue:(w,u,E)=>{if(a<u||(h(w,u,E,I(w)),a<=u+E))throw t},onSeparator:(w,u,E)=>{if(a<=u)throw t;if(w===":"&&o&&o.type==="property")o.colonOffset=u,l=!1,o=void 0;else if(w===","){const P=n[n.length-1];typeof P=="number"?n[n.length-1]=P+1:(l=!0,n[n.length-1]=""),o=void 0}}})}catch(w){if(w!==t)throw w}return{path:n,previousNode:o,isAtPropertyKey:l,matches:w=>{let u=0;for(let E=0;u<w.length&&E<n.length;E++)if(w[u]===n[E]||w[u]==="*")u++;else if(w[u]!=="**")return!1;return u===w.length}}}e.getLocation=k;function p(i,a=[],n=A.DEFAULT){let t=null,o=[];const g=[];function l(w){Array.isArray(o)?o.push(w):t!==null&&(o[t]=w)}return f(i,{onObjectBegin:()=>{const w={};l(w),g.push(o),o=w,t=null},onObjectProperty:w=>{t=w},onObjectEnd:()=>{o=g.pop()},onArrayBegin:()=>{const w=[];l(w),g.push(o),o=w,t=null},onArrayEnd:()=>{o=g.pop()},onLiteralValue:l,onError:(w,u,E)=>{a.push({error:w,offset:u,length:E})}},n),o[0]}e.parse=p;function C(i,a=[],n=A.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(w){t.type==="property"&&(t.length=w-t.offset,t=t.parent)}function g(w){return t.children.push(w),w}f(i,{onObjectBegin:w=>{t=g({type:"object",offset:w,length:-1,parent:t,children:[]})},onObjectProperty:(w,u,E)=>{t=g({type:"property",offset:u,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:w,offset:u,length:E,parent:t})},onObjectEnd:(w,u)=>{t.length=w+u-t.offset,t=t.parent,o(w+u)},onArrayBegin:(w,u)=>{t=g({type:"array",offset:w,length:-1,parent:t,children:[]})},onArrayEnd:(w,u)=>{t.length=w+u-t.offset,t=t.parent,o(w+u)},onLiteralValue:(w,u,E)=>{g({type:I(w),offset:u,length:E,parent:t,value:w}),o(u+E)},onSeparator:(w,u,E)=>{t.type==="property"&&(w===":"?t.colonOffset=u:w===","&&o(u))},onError:(w,u,E)=>{a.push({error:w,offset:u,length:E})}},n);const h=t.children[0];return h&&delete h.parent,h}e.parseTree=C;function D(i,a){if(!i)return;let n=i;for(const t of a)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let o=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===t){n=g.children[1],o=!0;break}if(!o)return}else{const o=t;if(n.type!=="array"||o<0||!Array.isArray(n.children)||o>=n.children.length)return;n=n.children[o]}return n}e.findNodeAtLocation=D;function b(i){if(!i.parent||!i.parent.children)return[];const a=b(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;a.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&a.push(n)}return a}e.getNodePath=b;function r(i){switch(i.type){case"array":return i.children.map(r);case"object":{const a=Object.create(null);for(const n of i.children){const t=n.children[1];t&&(a[n.children[0].value]=r(t))}return a}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=r;function s(i,a,n=!1){return a>=i.offset&&a<i.offset+i.length||n&&a===i.offset+i.length}e.contains=s;function c(i,a,n=!1){if(s(i,a,n)){const t=i.children;if(Array.isArray(t))for(let o=0;o<t.length&&t[o].offset<=a;o++){const g=c(t[o],a,n);if(g)return g}return i}}e.findNodeAtOffset=c;function f(i,a,n=A.DEFAULT){const t=T(i,!1);function o(ce){return ce?()=>ce(t.getTokenOffset(),t.getTokenLength()):()=>!0}function g(ce){return ce?re=>ce(re,t.getTokenOffset(),t.getTokenLength()):()=>!0}const l=o(a.onObjectBegin),h=g(a.onObjectProperty),w=o(a.onObjectEnd),u=o(a.onArrayBegin),E=o(a.onArrayEnd),P=g(a.onLiteralValue),O=g(a.onSeparator),N=o(a.onComment),F=g(a.onError),x=n&&n.disallowComments,B=n&&n.allowTrailingComma;function U(){for(;;){const ce=t.scan();switch(t.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:x||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(ce){case 12:case 13:x?X(10):N();break;case 16:X(1);break;case 15:case 14:break;default:return ce}}}function X(ce,re=[],fe=[]){if(F(ce),re.length+fe.length>0){let he=t.getToken();for(;he!==17;){if(re.indexOf(he)!==-1){U();break}else if(fe.indexOf(he)!==-1)break;he=U()}}}function j(ce){const re=t.getTokenValue();return ce?P(re):h(re),U(),!0}function ge(){switch(t.getToken()){case 11:{let ce=0;try{ce=JSON.parse(t.getTokenValue()),typeof ce!="number"&&(X(2),ce=0)}catch{X(2)}P(ce);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return U(),!0}function ie(){return t.getToken()!==10?(X(3,[],[2,5]),!1):(j(!1),t.getToken()===6?(O(":"),U(),H()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function te(){l(),U();let ce=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(ce||X(4,[],[]),O(","),U(),t.getToken()===2&&B)break}else ce&&X(6,[],[]);ie()||X(4,[],[2,5]),ce=!0}return w(),t.getToken()!==2?X(7,[2],[]):U(),!0}function $(){u(),U();let ce=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(ce||X(4,[],[]),O(","),U(),t.getToken()===4&&B)break}else ce&&X(6,[],[]);H()||X(4,[],[4,5]),ce=!0}return E(),t.getToken()!==4?X(8,[4],[]):U(),!0}function H(){switch(t.getToken()){case 3:return $();case 1:return te();case 10:return j(!0);default:return ge()}}return U(),t.getToken()===17?n.allowEmptyContent?!0:(X(4,[],[]),!1):H()?(t.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=f;function S(i,a){const n=T(i),t=[];let o,g=0,l;do switch(l=n.getPosition(),o=n.scan(),o){case 12:case 13:case 17:g!==l&&t.push(i.substring(g,l)),a!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,a)),g=n.getPosition();break}while(o!==17);return t.join("")}e.stripComments=S;function I(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=I}),define(De[54],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(d){this.executor=d,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(d){this._error=d}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=_}),define(De[4],Ie([1,0,67,48]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const d=!1;let A=null;function T(g){A=g}if(e.setDisposableTracker=T,d){const g="__is_disposable_tracked__";T(new class{trackDisposable(l){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[g]||console.log(h)},3e3)}setParent(l,h){if(l&&l!==c.None)try{l[g]=!0}catch{}}markAsDisposed(l){if(l&&l!==c.None)try{l[g]=!0}catch{}}markAsSingleton(l){}})}function m(g){return A?.trackDisposable(g),g}function y(g){A?.markAsDisposed(g)}function v(g,l){A?.setParent(g,l)}function R(g,l){if(A)for(const h of g)A.setParent(h,l)}function k(g){return A?.markAsSingleton(g),g}e.markAsSingleton=k;function p(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.isDisposable=p;function C(g){if(L.Iterable.is(g)){const l=[];for(const h of g)if(h)try{h.dispose()}catch(w){l.push(w)}if(l.length===1)throw l[0];if(l.length>1)throw new AggregateError(l,"Encountered errors while disposing of store");return Array.isArray(g)?[]:g}else if(g)return g.dispose(),g}e.dispose=C;function D(g){for(const l of g)p(l)&&l.dispose();return[]}e.disposeIfDisposable=D;function b(...g){const l=r(()=>C(g));return R(g,l),l}e.combinedDisposable=b;function r(g){const l=m({dispose:(0,_.once)(()=>{y(l),g()})});return l}e.toDisposable=r;class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,m(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{C(this._toDispose)}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return v(l,this),this._isDisposed?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=s;class c{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new s,m(this),v(this._store,this)}dispose(){y(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=c;class f{constructor(){this._isDisposed=!1,m(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){this._isDisposed||l===this._value||(this._value?.dispose(),l&&v(l,this),this._value=l)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const l=this._value;return this._value=void 0,l&&v(l,null),l}}e.MutableDisposable=f;class S{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=S;class I{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(l){let h=l;return this.unset=()=>h=void 0,this.isset=()=>h!==void 0,this.dispose=()=>{h&&(h(),h=void 0,y(this))},this}}e.SafeDisposable=I;class i{constructor(){this.references=new Map}acquire(l,...h){let w=this.references.get(l);w||(w={counter:0,object:this.createReferencedObject(l,...h)},this.references.set(l,w));const{object:u}=w,E=(0,_.once)(()=>{--w.counter===0&&(this.destroyReferencedObject(l,w.object),this.references.delete(l))});return w.counter++,{object:u,dispose:E}}}e.ReferenceCollection=i;class a{constructor(l){this.referenceCollection=l}async acquire(l,...h){const w=this.referenceCollection.acquire(l,...h);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(u){throw w.dispose(),u}}}e.AsyncReferenceCollection=a;class n{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=n;function t(g){const l=new s;try{g(l)}finally{l.dispose()}}e.disposeOnReturn=t;class o{constructor(){this._store=new Map,this._isDisposed=!1,m(this)}dispose(){y(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{C(this._store.values())}finally{this._store.clear()}}has(l){return this._store.has(l)}get(l){return this._store.get(l)}set(l,h,w=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),w||this._store.get(l)?.dispose(),this._store.set(l,h)}deleteAndDispose(l){this._store.get(l)?.dispose(),this._store.delete(l)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=o}),define(De[68],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{static{this.Undefined=new _(void 0)}constructor(A){this.element=A,this.next=_.Undefined,this.prev=_.Undefined}}class L{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){let A=this._first;for(;A!==_.Undefined;){const T=A.next;A.prev=_.Undefined,A.next=_.Undefined,A=T}this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,T){const m=new _(A);if(this._first===_.Undefined)this._first=m,this._last=m;else if(T){const v=this._last;this._last=m,m.prev=v,v.next=m}else{const v=this._first;this._first=m,m.next=v,v.prev=m}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(m))}}shift(){if(this._first!==_.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==_.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==_.Undefined&&A.next!==_.Undefined){const T=A.prev;T.next=A.next,A.next.prev=T}else A.prev===_.Undefined&&A.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):A.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):A.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==_.Undefined;)yield A.element,A=A.next}}e.LinkedList=L}),define(De[28],Ie([1,0]),function(me,e){"use strict";var _,L,d;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(b,r,s){let c=b.get(r);return c===void 0&&(c=s,b.set(r,c)),c}e.getOrSet=A;function T(b){const r=[];return b.forEach((s,c)=>{r.push(`${c} => ${s}`)}),`Map(${b.size}) {${r.join(", ")}}`}e.mapToString=T;function m(b){const r=[];return b.forEach(s=>{r.push(s)}),`Set(${b.size}) {${r.join(", ")}}`}e.setToString=m;class y{constructor(r,s){this.uri=r,this.value=s}}class v{static{this.defaultToKey=r=>r.toString()}constructor(r,s){this[_]="ResourceMap",r instanceof v?(this.map=new Map(r.map),this.toKey=s??v.defaultToKey):(this.map=new Map,this.toKey=r??v.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),new y(r,s)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[c,f]of this.map)r(f.value,f.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=v;class R{constructor(r,s){this[L]="ResourceSet",!r||typeof r=="function"?this._map=new v(r):(this._map=new v(s),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,s){this._map.forEach((c,f)=>r.call(s,f,f,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=R;var k;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class p{constructor(){this[d]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const c=this._map.get(r);if(c)return s!==0&&this.touch(c,s),c.value}set(r,s,c=0){let f=this._map.get(r);if(f)f.value=s,c!==0&&this.touch(f,c);else{switch(f={key:r,value:s,next:void 0,previous:void 0},c){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(r,f),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const c=this._state;let f=this._head;for(;f;){if(s?r.bind(s)(f.value,f.key,this):r(f.value,f.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,s=this._state;let c=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:c.key,done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return f}values(){const r=this,s=this._state;let c=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:c.value,done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return f}entries(){const r=this,s=this._state;let c=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:[c.key,c.value],done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return f}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,c=this.size;for(;s&&c>r;)this._map.delete(s.key),s=s.next,c--;this._head=s,this._size=c,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,c=r.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const c=r.next,f=r.previous;r===this._tail?(f.next=void 0,this._tail=f):(c.previous=f,f.next=c),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const c=r.next,f=r.previous;r===this._head?(c.previous=void 0,this._head=c):(c.previous=f,f.next=c),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,c)=>{r.push([c,s])}),r}fromJSON(r){this.clear();for(const[s,c]of r)this.set(s,c)}}e.LinkedMap=p;class C extends p{constructor(r,s=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=C;class D{constructor(){this.map=new Map}add(r){return this.map.set(r,(this.map.get(r)||0)+1),this}delete(r){let s=this.map.get(r)||0;return s===0?!1:(s--,s===0?this.map.delete(r):this.map.set(r,s),!0)}has(r){return this.map.has(r)}}e.CounterSet=D}),function(me,e){typeof define=="function"&&define.amd?define(De[152],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(ne,ee){for(var de=0;de<ee.length;de++){var K=ee[de];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(ne,K.key,K)}}function _(ne,ee,de){return ee&&e(ne.prototype,ee),de&&e(ne,de),Object.defineProperty(ne,"prototype",{writable:!1}),ne}function L(ne,ee){if(ne){if(typeof ne=="string")return d(ne,ee);var de=Object.prototype.toString.call(ne).slice(8,-1);if(de==="Object"&&ne.constructor&&(de=ne.constructor.name),de==="Map"||de==="Set")return Array.from(ne);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return d(ne,ee)}}function d(ne,ee){(ee==null||ee>ne.length)&&(ee=ne.length);for(var de=0,K=new Array(ee);de<ee;de++)K[de]=ne[de];return K}function A(ne,ee){var de=typeof Symbol<"u"&&ne[Symbol.iterator]||ne["@@iterator"];if(de)return(de=de.call(ne)).next.bind(de);if(Array.isArray(ne)||(de=L(ne))||ee&&ne&&typeof ne.length=="number"){de&&(ne=de);var K=0;return function(){return K>=ne.length?{done:!0}:{done:!1,value:ne[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=T();function m(ne){me.defaults=ne}var y=/[&<>"']/,v=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(ee){return p[ee]};function D(ne,ee){if(ee){if(y.test(ne))return ne.replace(v,C)}else if(R.test(ne))return ne.replace(k,C);return ne}var b=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(ne){return ne.replace(b,function(ee,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var s=/(^|[^\[])\^/g;function c(ne,ee){ne=typeof ne=="string"?ne:ne.source,ee=ee||"";var de={replace:function(le,oe){return oe=oe.source||oe,oe=oe.replace(s,"$1"),ne=ne.replace(le,oe),de},getRegex:function(){return new RegExp(ne,ee)}};return de}var f=/[^\w:]/g,S=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function I(ne,ee,de){if(ne){var K;try{K=decodeURIComponent(r(de)).replace(f,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}ee&&!S.test(de)&&(de=o(ee,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var i={},a=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(ne,ee){i[" "+ne]||(a.test(ne)?i[" "+ne]=ne+"/":i[" "+ne]=w(ne,"/",!0)),ne=i[" "+ne];var de=ne.indexOf(":")===-1;return ee.substring(0,2)==="//"?de?ee:ne.replace(n,"$1")+ee:ee.charAt(0)==="/"?de?ee:ne.replace(t,"$1")+ee:ne+ee}var g={exec:function(){}};function l(ne){for(var ee=1,de,K;ee<arguments.length;ee++){de=arguments[ee];for(K in de)Object.prototype.hasOwnProperty.call(de,K)&&(ne[K]=de[K])}return ne}function h(ne,ee){var de=ne.replace(/\|/g,function(oe,ue,Ee){for(var M=!1,q=ue;--q>=0&&Ee[q]==="\\";)M=!M;return M?"|":" |"}),K=de.split(/ \|/),le=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>ee)K.splice(ee);else for(;K.length<ee;)K.push("");for(;le<K.length;le++)K[le]=K[le].trim().replace(/\\\|/g,"|");return K}function w(ne,ee,de){var K=ne.length;if(K===0)return"";for(var le=0;le<K;){var oe=ne.charAt(K-le-1);if(oe===ee&&!de)le++;else if(oe!==ee&&de)le++;else break}return ne.slice(0,K-le)}function u(ne,ee){if(ne.indexOf(ee[1])===-1)return-1;for(var de=ne.length,K=0,le=0;le<de;le++)if(ne[le]==="\\")le++;else if(ne[le]===ee[0])K++;else if(ne[le]===ee[1]&&(K--,K<0))return le;return-1}function E(ne){ne&&ne.sanitize&&!ne.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ne,ee){if(ee<1)return"";for(var de="";ee>1;)ee&1&&(de+=ne),ee>>=1,ne+=ne;return de+ne}function O(ne,ee,de,K){var le=ee.href,oe=ee.title?D(ee.title):null,ue=ne[1].replace(/\\([\[\]])/g,"$1");if(ne[0].charAt(0)!=="!"){K.state.inLink=!0;var Ee={type:"link",raw:de,href:le,title:oe,text:ue,tokens:K.inlineTokens(ue)};return K.state.inLink=!1,Ee}return{type:"image",raw:de,href:le,title:oe,text:D(ue)}}function N(ne,ee){var de=ne.match(/^(\s+)(?:```)/);if(de===null)return ee;var K=de[1];return ee.split(`
`).map(function(le){var oe=le.match(/^\s+/);if(oe===null)return le;var ue=oe[0];return ue.length>=K.length?le.slice(K.length):le}).join(`
`)}var F=function(){function ne(de){this.options=de||me.defaults}var ee=ne.prototype;return ee.space=function(K){var le=this.rules.block.newline.exec(K);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},ee.code=function(K){var le=this.rules.block.code.exec(K);if(le){var oe=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:w(oe,`
`)}}},ee.fences=function(K){var le=this.rules.block.fences.exec(K);if(le){var oe=le[0],ue=N(oe,le[3]||"");return{type:"code",raw:oe,lang:le[2]?le[2].trim():le[2],text:ue}}},ee.heading=function(K){var le=this.rules.block.heading.exec(K);if(le){var oe=le[2].trim();if(/#$/.test(oe)){var ue=w(oe,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(oe=ue.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:oe,tokens:this.lexer.inline(oe)}}},ee.hr=function(K){var le=this.rules.block.hr.exec(K);if(le)return{type:"hr",raw:le[0]}},ee.blockquote=function(K){var le=this.rules.block.blockquote.exec(K);if(le){var oe=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(oe,[]),text:oe}}},ee.list=function(K){var le=this.rules.block.list.exec(K);if(le){var oe,ue,Ee,M,q,G,J,be,se,we,ke,Ue,He=le[1].trim(),Je=He.length>1,Ge={type:"list",raw:"",ordered:Je,start:Je?+He.slice(0,-1):"",loose:!1,items:[]};He=Je?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=Je?He:"[*+-]");for(var et=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(Ue=!1,!(!(le=et.exec(K))||this.rules.block.hr.test(K)));){if(oe=le[0],K=K.substring(oe.length),be=le[2].split(`
`,1)[0],se=K.split(`
`,1)[0],this.options.pedantic?(M=2,ke=be.trimLeft()):(M=le[2].search(/[^ ]/),M=M>4?1:M,ke=be.slice(M),M+=le[1].length),G=!1,!be&&/^ *$/.test(se)&&(oe+=se+`
`,K=K.substring(se.length+1),Ue=!0),!Ue)for(var Qe=new RegExp("^ {0,"+Math.min(3,M-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,M-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,M-1)+"}(?:```|~~~)"),Pe=new RegExp("^ {0,"+Math.min(3,M-1)+"}#");K&&(we=K.split(`
`,1)[0],be=we,this.options.pedantic&&(be=be.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(be)||Pe.test(be)||Qe.test(be)||st.test(K)));){if(be.search(/[^ ]/)>=M||!be.trim())ke+=`
`+be.slice(M);else if(!G)ke+=`
`+be;else break;!G&&!be.trim()&&(G=!0),oe+=we+`
`,K=K.substring(we.length+1)}Ge.loose||(J?Ge.loose=!0:/\n *\n *$/.test(oe)&&(J=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(ke),ue&&(Ee=ue[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:oe,task:!!ue,checked:Ee,loose:!1,text:ke}),Ge.raw+=oe}Ge.items[Ge.items.length-1].raw=oe.trimRight(),Ge.items[Ge.items.length-1].text=ke.trimRight(),Ge.raw=Ge.raw.trimRight();var _e=Ge.items.length;for(q=0;q<_e;q++){this.lexer.state.top=!1,Ge.items[q].tokens=this.lexer.blockTokens(Ge.items[q].text,[]);var ze=Ge.items[q].tokens.filter(function(Q){return Q.type==="space"}),Y=ze.every(function(Q){for(var Se=Q.raw.split(""),Be=0,Me=A(Se),Xe;!(Xe=Me()).done;){var Ze=Xe.value;if(Ze===`
`&&(Be+=1),Be>1)return!0}return!1});!Ge.loose&&ze.length&&Y&&(Ge.loose=!0,Ge.items[q].loose=!0)}return Ge}},ee.html=function(K){var le=this.rules.block.html.exec(K);if(le){var oe={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(le[0]):D(le[0]);oe.type="paragraph",oe.text=ue,oe.tokens=this.lexer.inline(ue)}return oe}},ee.def=function(K){var le=this.rules.block.def.exec(K);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var oe=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:oe,raw:le[0],href:le[2],title:le[3]}}},ee.table=function(K){var le=this.rules.block.table.exec(K);if(le){var oe={type:"table",header:h(le[1]).map(function(J){return{text:J}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=le[0];var ue=oe.align.length,Ee,M,q,G;for(Ee=0;Ee<ue;Ee++)/^ *-+: *$/.test(oe.align[Ee])?oe.align[Ee]="right":/^ *:-+: *$/.test(oe.align[Ee])?oe.align[Ee]="center":/^ *:-+ *$/.test(oe.align[Ee])?oe.align[Ee]="left":oe.align[Ee]=null;for(ue=oe.rows.length,Ee=0;Ee<ue;Ee++)oe.rows[Ee]=h(oe.rows[Ee],oe.header.length).map(function(J){return{text:J}});for(ue=oe.header.length,M=0;M<ue;M++)oe.header[M].tokens=this.lexer.inline(oe.header[M].text);for(ue=oe.rows.length,M=0;M<ue;M++)for(G=oe.rows[M],q=0;q<G.length;q++)G[q].tokens=this.lexer.inline(G[q].text);return oe}}},ee.lheading=function(K){var le=this.rules.block.lheading.exec(K);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},ee.paragraph=function(K){var le=this.rules.block.paragraph.exec(K);if(le){var oe=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:oe,tokens:this.lexer.inline(oe)}}},ee.text=function(K){var le=this.rules.block.text.exec(K);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},ee.escape=function(K){var le=this.rules.inline.escape.exec(K);if(le)return{type:"escape",raw:le[0],text:D(le[1])}},ee.tag=function(K){var le=this.rules.inline.tag.exec(K);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):D(le[0]):le[0]}},ee.link=function(K){var le=this.rules.inline.link.exec(K);if(le){var oe=le[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var ue=w(oe.slice(0,-1),"\\");if((oe.length-ue.length)%2===0)return}else{var Ee=u(le[2],"()");if(Ee>-1){var M=le[0].indexOf("!")===0?5:4,q=M+le[1].length+Ee;le[2]=le[2].substring(0,Ee),le[0]=le[0].substring(0,q).trim(),le[3]=""}}var G=le[2],J="";if(this.options.pedantic){var be=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(G);be&&(G=be[1],J=be[3])}else J=le[3]?le[3].slice(1,-1):"";return G=G.trim(),/^</.test(G)&&(this.options.pedantic&&!/>$/.test(oe)?G=G.slice(1):G=G.slice(1,-1)),O(le,{href:G&&G.replace(this.rules.inline._escapes,"$1"),title:J&&J.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},ee.reflink=function(K,le){var oe;if((oe=this.rules.inline.reflink.exec(K))||(oe=this.rules.inline.nolink.exec(K))){var ue=(oe[2]||oe[1]).replace(/\s+/g," ");if(ue=le[ue.toLowerCase()],!ue||!ue.href){var Ee=oe[0].charAt(0);return{type:"text",raw:Ee,text:Ee}}return O(oe,ue,oe[0],this.lexer)}},ee.emStrong=function(K,le,oe){oe===void 0&&(oe="");var ue=this.rules.inline.emStrong.lDelim.exec(K);if(ue&&!(ue[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ee=ue[1]||ue[2]||"";if(!Ee||Ee&&(oe===""||this.rules.inline.punctuation.exec(oe))){var M=ue[0].length-1,q,G,J=M,be=0,se=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(se.lastIndex=0,le=le.slice(-1*K.length+M);(ue=se.exec(le))!=null;)if(q=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!q){if(G=q.length,ue[3]||ue[4]){J+=G;continue}else if((ue[5]||ue[6])&&M%3&&!((M+G)%3)){be+=G;continue}if(J-=G,!(J>0)){if(G=Math.min(G,G+J+be),Math.min(M,G)%2){var we=K.slice(1,M+ue.index+G);return{type:"em",raw:K.slice(0,M+ue.index+G+1),text:we,tokens:this.lexer.inlineTokens(we)}}var ke=K.slice(2,M+ue.index+G-1);return{type:"strong",raw:K.slice(0,M+ue.index+G+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},ee.codespan=function(K){var le=this.rules.inline.code.exec(K);if(le){var oe=le[2].replace(/\n/g," "),ue=/[^ ]/.test(oe),Ee=/^ /.test(oe)&&/ $/.test(oe);return ue&&Ee&&(oe=oe.substring(1,oe.length-1)),oe=D(oe,!0),{type:"codespan",raw:le[0],text:oe}}},ee.br=function(K){var le=this.rules.inline.br.exec(K);if(le)return{type:"br",raw:le[0]}},ee.del=function(K){var le=this.rules.inline.del.exec(K);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},ee.autolink=function(K,le){var oe=this.rules.inline.autolink.exec(K);if(oe){var ue,Ee;return oe[2]==="@"?(ue=D(this.options.mangle?le(oe[1]):oe[1]),Ee="mailto:"+ue):(ue=D(oe[1]),Ee=ue),{type:"link",raw:oe[0],text:ue,href:Ee,tokens:[{type:"text",raw:ue,text:ue}]}}},ee.url=function(K,le){var oe;if(oe=this.rules.inline.url.exec(K)){var ue,Ee;if(oe[2]==="@")ue=D(this.options.mangle?le(oe[0]):oe[0]),Ee="mailto:"+ue;else{var M;do M=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(M!==oe[0]);ue=D(oe[0]),oe[1]==="www."?Ee="http://"+ue:Ee=ue}return{type:"link",raw:oe[0],text:ue,href:Ee,tokens:[{type:"text",raw:ue,text:ue}]}}},ee.inlineText=function(K,le){var oe=this.rules.inline.text.exec(K);if(oe){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):D(oe[0]):oe[0]:ue=D(this.options.smartypants?le(oe[0]):oe[0]),{type:"text",raw:oe[0],text:ue}}},ne}(),x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=c(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.listItemStart=c(/^( *)(bull) */).replace("bull",x.bullet).getRegex(),x.list=c(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=c(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=c(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.blockquote=c(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=l({},x),x.gfm=l({},x.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.table=c(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.gfm.paragraph=c(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",x.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.pedantic=l({},x.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:c(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=c(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=c(x._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=c(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=c(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=c(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=c(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=c(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=c(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=c(B.reflink).replace("label",B._label).replace("ref",x._label).getRegex(),B.nolink=c(B.nolink).replace("ref",x._label).getRegex(),B.reflinkSearch=c(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=l({},B),B.pedantic=l({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=l({},B.normal,{escape:c(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=c(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=l({},B.gfm,{br:c(B.br).replace("{2,}","*").getRegex(),text:c(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(ne){return ne.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function X(ne){var ee="",de,K,le=ne.length;for(de=0;de<le;de++)K=ne.charCodeAt(de),Math.random()>.5&&(K="x"+K.toString(16)),ee+="&#"+K+";";return ee}var j=function(){function ne(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||me.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:x.normal,inline:B.normal};this.options.pedantic?(K.block=x.pedantic,K.inline=B.pedantic):this.options.gfm&&(K.block=x.gfm,this.options.breaks?K.inline=B.breaks:K.inline=B.gfm),this.tokenizer.rules=K}ne.lex=function(K,le){var oe=new ne(le);return oe.lex(K)},ne.lexInline=function(K,le){var oe=new ne(le);return oe.inlineTokens(K)};var ee=ne.prototype;return ee.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},ee.blockTokens=function(K,le){var oe=this;le===void 0&&(le=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(J,be,se){return be+"    ".repeat(se.length)});for(var ue,Ee,M,q;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(J){return(ue=J.call({lexer:oe},K,le))?(K=K.substring(ue.raw.length),le.push(ue),!0):!1}))){if(ue=this.tokenizer.space(K)){K=K.substring(ue.raw.length),ue.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(ue);continue}if(ue=this.tokenizer.code(K)){K=K.substring(ue.raw.length),Ee=le[le.length-1],Ee&&(Ee.type==="paragraph"||Ee.type==="text")?(Ee.raw+=`
`+ue.raw,Ee.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):le.push(ue);continue}if(ue=this.tokenizer.fences(K)){K=K.substring(ue.raw.length),le.push(ue);continue}if(ue=this.tokenizer.heading(K)){K=K.substring(ue.raw.length),le.push(ue);continue}if(ue=this.tokenizer.hr(K)){K=K.substring(ue.raw.length),le.push(ue);continue}if(ue=this.tokenizer.blockquote(K)){K=K.substring(ue.raw.length),le.push(ue);continue}if(ue=this.tokenizer.list(K)){K=K.substring(ue.raw.length),le.push(ue);continue}if(ue=this.tokenizer.html(K)){K=K.substring(ue.raw.length),le.push(ue);continue}if(ue=this.tokenizer.def(K)){K=K.substring(ue.raw.length),Ee=le[le.length-1],Ee&&(Ee.type==="paragraph"||Ee.type==="text")?(Ee.raw+=`
`+ue.raw,Ee.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(K)){K=K.substring(ue.raw.length),le.push(ue);continue}if(ue=this.tokenizer.lheading(K)){K=K.substring(ue.raw.length),le.push(ue);continue}if(M=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var J=1/0,be=K.slice(1),se=void 0;oe.options.extensions.startBlock.forEach(function(we){se=we.call({lexer:this},be),typeof se=="number"&&se>=0&&(J=Math.min(J,se))}),J<1/0&&J>=0&&(M=K.substring(0,J+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(M))){Ee=le[le.length-1],q&&Ee.type==="paragraph"?(Ee.raw+=`
`+ue.raw,Ee.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):le.push(ue),q=M.length!==K.length,K=K.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(K)){K=K.substring(ue.raw.length),Ee=le[le.length-1],Ee&&Ee.type==="text"?(Ee.raw+=`
`+ue.raw,Ee.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):le.push(ue);continue}if(K){var G="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return this.state.top=!0,le},ee.inline=function(K,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:K,tokens:le}),le},ee.inlineTokens=function(K,le){var oe=this;le===void 0&&(le=[]);var ue,Ee,M,q=K,G,J,be;if(this.tokens.links){var se=Object.keys(this.tokens.links);if(se.length>0)for(;(G=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)se.includes(G[0].slice(G[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,G.index)+"["+P("a",G[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(G=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,G.index)+"["+P("a",G[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(G=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,G.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(J||(be=""),J=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(ue=ke.call({lexer:oe},K,le))?(K=K.substring(ue.raw.length),le.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(K)){K=K.substring(ue.raw.length),le.push(ue);continue}if(ue=this.tokenizer.tag(K)){K=K.substring(ue.raw.length),Ee=le[le.length-1],Ee&&ue.type==="text"&&Ee.type==="text"?(Ee.raw+=ue.raw,Ee.text+=ue.text):le.push(ue);continue}if(ue=this.tokenizer.link(K)){K=K.substring(ue.raw.length),le.push(ue);continue}if(ue=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(ue.raw.length),Ee=le[le.length-1],Ee&&ue.type==="text"&&Ee.type==="text"?(Ee.raw+=ue.raw,Ee.text+=ue.text):le.push(ue);continue}if(ue=this.tokenizer.emStrong(K,q,be)){K=K.substring(ue.raw.length),le.push(ue);continue}if(ue=this.tokenizer.codespan(K)){K=K.substring(ue.raw.length),le.push(ue);continue}if(ue=this.tokenizer.br(K)){K=K.substring(ue.raw.length),le.push(ue);continue}if(ue=this.tokenizer.del(K)){K=K.substring(ue.raw.length),le.push(ue);continue}if(ue=this.tokenizer.autolink(K,X)){K=K.substring(ue.raw.length),le.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(K,X))){K=K.substring(ue.raw.length),le.push(ue);continue}if(M=K,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,Ue=K.slice(1),He=void 0;oe.options.extensions.startInline.forEach(function(Je){He=Je.call({lexer:this},Ue),typeof He=="number"&&He>=0&&(ke=Math.min(ke,He))}),ke<1/0&&ke>=0&&(M=K.substring(0,ke+1))}(),ue=this.tokenizer.inlineText(M,U)){K=K.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(be=ue.raw.slice(-1)),J=!0,Ee=le[le.length-1],Ee&&Ee.type==="text"?(Ee.raw+=ue.raw,Ee.text+=ue.text):le.push(ue);continue}if(K){var we="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return le},_(ne,null,[{key:"rules",get:function(){return{block:x,inline:B}}}]),ne}(),ge=function(){function ne(de){this.options=de||me.defaults}var ee=ne.prototype;return ee.code=function(K,le,oe){var ue=(le||"").match(/\S*/)[0];if(this.options.highlight){var Ee=this.options.highlight(K,ue);Ee!=null&&Ee!==K&&(oe=!0,K=Ee)}return K=K.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+D(ue,!0)+'">'+(oe?K:D(K,!0))+`</code></pre>
`:"<pre><code>"+(oe?K:D(K,!0))+`</code></pre>
`},ee.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},ee.html=function(K){return K},ee.heading=function(K,le,oe,ue){if(this.options.headerIds){var Ee=this.options.headerPrefix+ue.slug(oe);return"<h"+le+' id="'+Ee+'">'+K+"</h"+le+`>
`}return"<h"+le+">"+K+"</h"+le+`>
`},ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ee.list=function(K,le,oe){var ue=le?"ol":"ul",Ee=le&&oe!==1?' start="'+oe+'"':"";return"<"+ue+Ee+`>
`+K+"</"+ue+`>
`},ee.listitem=function(K){return"<li>"+K+`</li>
`},ee.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ee.paragraph=function(K){return"<p>"+K+`</p>
`},ee.table=function(K,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+le+`</table>
`},ee.tablerow=function(K){return`<tr>
`+K+`</tr>
`},ee.tablecell=function(K,le){var oe=le.header?"th":"td",ue=le.align?"<"+oe+' align="'+le.align+'">':"<"+oe+">";return ue+K+("</"+oe+`>
`)},ee.strong=function(K){return"<strong>"+K+"</strong>"},ee.em=function(K){return"<em>"+K+"</em>"},ee.codespan=function(K){return"<code>"+K+"</code>"},ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},ee.del=function(K){return"<del>"+K+"</del>"},ee.link=function(K,le,oe){if(K=I(this.options.sanitize,this.options.baseUrl,K),K===null)return oe;var ue='<a href="'+D(K)+'"';return le&&(ue+=' title="'+le+'"'),ue+=">"+oe+"</a>",ue},ee.image=function(K,le,oe){if(K=I(this.options.sanitize,this.options.baseUrl,K),K===null)return oe;var ue='<img src="'+K+'" alt="'+oe+'"';return le&&(ue+=' title="'+le+'"'),ue+=this.options.xhtml?"/>":">",ue},ee.text=function(K){return K},ne}(),ie=function(){function ne(){}var ee=ne.prototype;return ee.strong=function(K){return K},ee.em=function(K){return K},ee.codespan=function(K){return K},ee.del=function(K){return K},ee.html=function(K){return K},ee.text=function(K){return K},ee.link=function(K,le,oe){return""+oe},ee.image=function(K,le,oe){return""+oe},ee.br=function(){return""},ne}(),te=function(){function ne(){this.seen={}}var ee=ne.prototype;return ee.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ee.getNextSafeSlug=function(K,le){var oe=K,ue=0;if(this.seen.hasOwnProperty(oe)){ue=this.seen[K];do ue++,oe=K+"-"+ue;while(this.seen.hasOwnProperty(oe))}return le||(this.seen[K]=ue,this.seen[oe]=0),oe},ee.slug=function(K,le){le===void 0&&(le={});var oe=this.serialize(K);return this.getNextSafeSlug(oe,le.dryrun)},ne}(),$=function(){function ne(de){this.options=de||me.defaults,this.options.renderer=this.options.renderer||new ge,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ie,this.slugger=new te}ne.parse=function(K,le){var oe=new ne(le);return oe.parse(K)},ne.parseInline=function(K,le){var oe=new ne(le);return oe.parseInline(K)};var ee=ne.prototype;return ee.parse=function(K,le){le===void 0&&(le=!0);var oe="",ue,Ee,M,q,G,J,be,se,we,ke,Ue,He,Je,Ge,et,Qe,st,tt,Pe,_e=K.length;for(ue=0;ue<_e;ue++){if(ke=K[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(Pe=this.options.extensions.renderers[ke.type].call({parser:this},ke),Pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){oe+=Pe||"";continue}switch(ke.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,r(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(se="",be="",q=ke.header.length,Ee=0;Ee<q;Ee++)be+=this.renderer.tablecell(this.parseInline(ke.header[Ee].tokens),{header:!0,align:ke.align[Ee]});for(se+=this.renderer.tablerow(be),we="",q=ke.rows.length,Ee=0;Ee<q;Ee++){for(J=ke.rows[Ee],be="",G=J.length,M=0;M<G;M++)be+=this.renderer.tablecell(this.parseInline(J[M].tokens),{header:!1,align:ke.align[M]});we+=this.renderer.tablerow(be)}oe+=this.renderer.table(se,we);continue}case"blockquote":{we=this.parse(ke.tokens),oe+=this.renderer.blockquote(we);continue}case"list":{for(Ue=ke.ordered,He=ke.start,Je=ke.loose,q=ke.items.length,we="",Ee=0;Ee<q;Ee++)et=ke.items[Ee],Qe=et.checked,st=et.task,Ge="",et.task&&(tt=this.renderer.checkbox(Qe),Je?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=tt+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=tt+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:tt}):Ge+=tt),Ge+=this.parse(et.tokens,Je),we+=this.renderer.listitem(Ge,st,Qe);oe+=this.renderer.list(we,Ue,He);continue}case"html":{oe+=this.renderer.html(ke.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(we=ke.tokens?this.parseInline(ke.tokens):ke.text;ue+1<_e&&K[ue+1].type==="text";)ke=K[++ue],we+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);oe+=le?this.renderer.paragraph(we):we;continue}default:{var ze='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(ze);return}else throw new Error(ze)}}}return oe},ee.parseInline=function(K,le){le=le||this.renderer;var oe="",ue,Ee,M,q=K.length;for(ue=0;ue<q;ue++){if(Ee=K[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(M=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),M!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ee.type))){oe+=M||"";continue}switch(Ee.type){case"escape":{oe+=le.text(Ee.text);break}case"html":{oe+=le.html(Ee.text);break}case"link":{oe+=le.link(Ee.href,Ee.title,this.parseInline(Ee.tokens,le));break}case"image":{oe+=le.image(Ee.href,Ee.title,Ee.text);break}case"strong":{oe+=le.strong(this.parseInline(Ee.tokens,le));break}case"em":{oe+=le.em(this.parseInline(Ee.tokens,le));break}case"codespan":{oe+=le.codespan(Ee.text);break}case"br":{oe+=le.br();break}case"del":{oe+=le.del(this.parseInline(Ee.tokens,le));break}case"text":{oe+=le.text(Ee.text);break}default:{var G='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(G);return}else throw new Error(G)}}}return oe},ne}();function H(ne,ee,de){if(typeof ne>"u"||ne===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");if(typeof ee=="function"&&(de=ee,ee=null),ee=l({},H.defaults,ee||{}),E(ee),de){var K=ee.highlight,le;try{le=j.lex(ne,ee)}catch(q){return de(q)}var oe=function(G){var J;if(!G)try{ee.walkTokens&&H.walkTokens(le,ee.walkTokens),J=$.parse(le,ee)}catch(be){G=be}return ee.highlight=K,G?de(G):de(null,J)};if(!K||K.length<3||(delete ee.highlight,!le.length))return oe();var ue=0;H.walkTokens(le,function(q){q.type==="code"&&(ue++,setTimeout(function(){K(q.text,q.lang,function(G,J){if(G)return oe(G);J!=null&&J!==q.text&&(q.text=J,q.escaped=!0),ue--,ue===0&&oe()})},0))}),ue===0&&oe();return}function Ee(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,ee.silent)return"<p>An error occurred:</p><pre>"+D(q.message+"",!0)+"</pre>";throw q}try{var M=j.lex(ne,ee);if(ee.walkTokens){if(ee.async)return Promise.all(H.walkTokens(M,ee.walkTokens)).then(function(){return $.parse(M,ee)}).catch(Ee);H.walkTokens(M,ee.walkTokens)}return $.parse(M,ee)}catch(q){Ee(q)}}H.options=H.setOptions=function(ne){return l(H.defaults,ne),m(H.defaults),H},H.getDefaults=T,H.defaults=me.defaults,H.use=function(){for(var ne=arguments.length,ee=new Array(ne),de=0;de<ne;de++)ee[de]=arguments[de];var K=l.apply(void 0,[{}].concat(ee)),le=H.defaults.extensions||{renderers:{},childTokens:{}},oe;ee.forEach(function(ue){if(ue.extensions&&(oe=!0,ue.extensions.forEach(function(M){if(!M.name)throw new Error("extension name required");if(M.renderer){var q=le.renderers?le.renderers[M.name]:null;q?le.renderers[M.name]=function(){for(var G=arguments.length,J=new Array(G),be=0;be<G;be++)J[be]=arguments[be];var se=M.renderer.apply(this,J);return se===!1&&(se=q.apply(this,J)),se}:le.renderers[M.name]=M.renderer}if(M.tokenizer){if(!M.level||M.level!=="block"&&M.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[M.level]?le[M.level].unshift(M.tokenizer):le[M.level]=[M.tokenizer],M.start&&(M.level==="block"?le.startBlock?le.startBlock.push(M.start):le.startBlock=[M.start]:M.level==="inline"&&(le.startInline?le.startInline.push(M.start):le.startInline=[M.start]))}M.childTokens&&(le.childTokens[M.name]=M.childTokens)})),ue.renderer&&function(){var M=H.defaults.renderer||new ge,q=function(be){var se=M[be];M[be]=function(){for(var we=arguments.length,ke=new Array(we),Ue=0;Ue<we;Ue++)ke[Ue]=arguments[Ue];var He=ue.renderer[be].apply(M,ke);return He===!1&&(He=se.apply(M,ke)),He}};for(var G in ue.renderer)q(G);K.renderer=M}(),ue.tokenizer&&function(){var M=H.defaults.tokenizer||new F,q=function(be){var se=M[be];M[be]=function(){for(var we=arguments.length,ke=new Array(we),Ue=0;Ue<we;Ue++)ke[Ue]=arguments[Ue];var He=ue.tokenizer[be].apply(M,ke);return He===!1&&(He=se.apply(M,ke)),He}};for(var G in ue.tokenizer)q(G);K.tokenizer=M}(),ue.walkTokens){var Ee=H.defaults.walkTokens;K.walkTokens=function(M){var q=[];return q.push(ue.walkTokens.call(this,M)),Ee&&(q=q.concat(Ee.call(this,M))),q}}oe&&(K.extensions=le),H.setOptions(K)})},H.walkTokens=function(ne,ee){for(var de=[],K=function(){var Ee=oe.value;switch(de=de.concat(ee.call(H,Ee)),Ee.type){case"table":{for(var M=A(Ee.header),q;!(q=M()).done;){var G=q.value;de=de.concat(H.walkTokens(G.tokens,ee))}for(var J=A(Ee.rows),be;!(be=J()).done;)for(var se=be.value,we=A(se),ke;!(ke=we()).done;){var Ue=ke.value;de=de.concat(H.walkTokens(Ue.tokens,ee))}break}case"list":{de=de.concat(H.walkTokens(Ee.items,ee));break}default:H.defaults.extensions&&H.defaults.extensions.childTokens&&H.defaults.extensions.childTokens[Ee.type]?H.defaults.extensions.childTokens[Ee.type].forEach(function(He){de=de.concat(H.walkTokens(Ee[He],ee))}):Ee.tokens&&(de=de.concat(H.walkTokens(Ee.tokens,ee)))}},le=A(ne),oe;!(oe=le()).done;)K();return de},H.parseInline=function(ne,ee){if(typeof ne>"u"||ne===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");ee=l({},H.defaults,ee||{}),E(ee);try{var de=j.lexInline(ne,ee);return ee.walkTokens&&H.walkTokens(de,ee.walkTokens),$.parseInline(de,ee)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,ee.silent)return"<p>An error occurred:</p><pre>"+D(K.message+"",!0)+"</pre>";throw K}},H.Parser=$,H.parser=$.parse,H.Renderer=ge,H.TextRenderer=ie,H.Lexer=j,H.lexer=j.lex,H.Tokenizer=F,H.Slugger=te,H.parse=H;var ce=H.options,re=H.setOptions,fe=H.use,he=H.walkTokens,z=H.parseInline,Z=H,ye=$.parse,Re=j.lex;me.Lexer=j,me.Parser=$,me.Renderer=ge,me.Slugger=te,me.TextRenderer=ie,me.Tokenizer=F,me.getDefaults=T,me.lexer=Re,me.marked=H,me.options=ce,me.parse=Z,me.parseInline=z,me.parser=ye,me.setOptions=re,me.use=fe,me.walkTokens=he,Object.defineProperty(me,"__esModule",{value:!0})}),define(De[69],Ie([1,0,28]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new _.LRUCache(1e4);function d(v){return y(v,"NFC",L)}e.normalizeNFC=d;const A=new _.LRUCache(1e4);function T(v){return y(v,"NFD",A)}e.normalizeNFD=T;const m=/[^\u0000-\u0080]/;function y(v,R,k){if(!v)return v;const p=k.get(v);if(p)return p;let C;return m.test(v)?C=v.normalize(R):C=v,k.set(v,C),C}e.removeAccents=function(){const v=/[\u0300-\u036f]/g;return function(R){return T(R).replace(v,"")}}()}),define(De[112],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function _(m,y,v){return Math.min(Math.max(m,y),v)}e.clamp=_;function L(m,y){return(y+m%y)%y}e.rot=L;class d{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=d;class A{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class T{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const v=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=v,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function me(d){const A=[];typeof d=="number"&&A.push("code/timeOrigin",d);function T(y){A.push(y,Date.now())}function m(){const y=[];for(let v=0;v<A.length;v+=2)y.push({name:A[v],startTime:A[v+1]});return y}return{mark:T,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(d){performance.mark(d)},getMarks(){let d=performance.timeOrigin;typeof d!="number"&&(d=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(d)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(d+T.startTime)});return A}};if(typeof process=="object"){const d=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(d)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function _(d){return d.MonacoPerformanceMarks||(d.MonacoPerformanceMarks=e()),d.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=_(L))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var _=e();for(var L in _)(typeof exports=="object"?exports:me)[L]=_[L]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function _(L){if(e[L])return e[L].exports;var d=e[L]={i:L,l:!1,exports:{}};return me[L].call(d.exports,d,d.exports,_),d.l=!0,d.exports}return _.m=me,_.c=e,_.d=function(L,d,A){_.o(L,d)||Object.defineProperty(L,d,{enumerable:!0,get:A})},_.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},_.t=function(L,d){if(1&d&&(L=_(L)),8&d||4&d&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(_.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&d&&typeof L!="string")for(var T in L)_.d(A,T,function(m){return L[m]}.bind(null,T));return A},_.n=function(L){var d=L&&L.__esModule?function(){return L.default}:function(){return L};return _.d(d,"a",d),d},_.o=function(L,d){return Object.prototype.hasOwnProperty.call(L,d)},_.p="",_(_.s=0)}([function(me,e,_){(function(L){var d;e=me.exports=fe,d=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var se=Array.prototype.slice.call(arguments,0);se.unshift("SEMVER"),console.log.apply(console,se)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],y=e.src=[],v=0,R=v++;y[R]="0|[1-9]\\d*";var k=v++;y[k]="[0-9]+";var p=v++;y[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=v++;y[C]="("+y[R]+")\\.("+y[R]+")\\.("+y[R]+")";var D=v++;y[D]="("+y[k]+")\\.("+y[k]+")\\.("+y[k]+")";var b=v++;y[b]="(?:"+y[R]+"|"+y[p]+")";var r=v++;y[r]="(?:"+y[k]+"|"+y[p]+")";var s=v++;y[s]="(?:-("+y[b]+"(?:\\."+y[b]+")*))";var c=v++;y[c]="(?:-?("+y[r]+"(?:\\."+y[r]+")*))";var f=v++;y[f]="[0-9A-Za-z-]+";var S=v++;y[S]="(?:\\+("+y[f]+"(?:\\."+y[f]+")*))";var I=v++,i="v?"+y[C]+y[s]+"?"+y[S]+"?";y[I]="^"+i+"$";var a="[v=\\s]*"+y[D]+y[c]+"?"+y[S]+"?",n=v++;y[n]="^"+a+"$";var t=v++;y[t]="((?:<|>)?=?)";var o=v++;y[o]=y[k]+"|x|X|\\*";var g=v++;y[g]=y[R]+"|x|X|\\*";var l=v++;y[l]="[v=\\s]*("+y[g]+")(?:\\.("+y[g]+")(?:\\.("+y[g]+")(?:"+y[s]+")?"+y[S]+"?)?)?";var h=v++;y[h]="[v=\\s]*("+y[o]+")(?:\\.("+y[o]+")(?:\\.("+y[o]+")(?:"+y[c]+")?"+y[S]+"?)?)?";var w=v++;y[w]="^"+y[t]+"\\s*"+y[l]+"$";var u=v++;y[u]="^"+y[t]+"\\s*"+y[h]+"$";var E=v++;y[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=v++;y[P]="(?:~>?)";var O=v++;y[O]="(\\s*)"+y[P]+"\\s+",m[O]=new RegExp(y[O],"g");var N=v++;y[N]="^"+y[P]+y[l]+"$";var F=v++;y[F]="^"+y[P]+y[h]+"$";var x=v++;y[x]="(?:\\^)";var B=v++;y[B]="(\\s*)"+y[x]+"\\s+",m[B]=new RegExp(y[B],"g");var U=v++;y[U]="^"+y[x]+y[l]+"$";var X=v++;y[X]="^"+y[x]+y[h]+"$";var j=v++;y[j]="^"+y[t]+"\\s*("+a+")$|^$";var ge=v++;y[ge]="^"+y[t]+"\\s*("+i+")$|^$";var ie=v++;y[ie]="(\\s*)"+y[t]+"\\s*("+a+"|"+y[l]+")",m[ie]=new RegExp(y[ie],"g");var te=v++;y[te]="^\\s*("+y[l]+")\\s+-\\s+("+y[l]+")\\s*$";var $=v++;y[$]="^\\s*("+y[h]+")\\s+-\\s+("+y[h]+")\\s*$";var H=v++;y[H]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)d(ce,y[ce]),m[ce]||(m[ce]=new RegExp(y[ce]));function re(se,we){if(se instanceof fe)return se;if(typeof se!="string"||se.length>A||!(we?m[n]:m[I]).test(se))return null;try{return new fe(se,we)}catch{return null}}function fe(se,we){if(se instanceof fe){if(se.loose===we)return se;se=se.version}else if(typeof se!="string")throw new TypeError("Invalid Version: "+se);if(se.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof fe))return new fe(se,we);d("SemVer",se,we),this.loose=we;var ke=se.trim().match(we?m[n]:m[I]);if(!ke)throw new TypeError("Invalid Version: "+se);if(this.raw=se,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(Ue){if(/^[0-9]+$/.test(Ue)){var He=+Ue;if(He>=0&&He<T)return He}return Ue}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=re,e.valid=function(se,we){var ke=re(se,we);return ke?ke.version:null},e.clean=function(se,we){var ke=re(se.trim().replace(/^[=v]+/,""),we);return ke?ke.version:null},e.SemVer=fe,fe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},fe.prototype.toString=function(){return this.version},fe.prototype.compare=function(se){return d("SemVer.compare",this.version,this.loose,se),se instanceof fe||(se=new fe(se,this.loose)),this.compareMain(se)||this.comparePre(se)},fe.prototype.compareMain=function(se){return se instanceof fe||(se=new fe(se,this.loose)),z(this.major,se.major)||z(this.minor,se.minor)||z(this.patch,se.patch)},fe.prototype.comparePre=function(se){if(se instanceof fe||(se=new fe(se,this.loose)),this.prerelease.length&&!se.prerelease.length)return-1;if(!this.prerelease.length&&se.prerelease.length)return 1;if(!this.prerelease.length&&!se.prerelease.length)return 0;var we=0;do{var ke=this.prerelease[we],Ue=se.prerelease[we];if(d("prerelease compare",we,ke,Ue),ke===void 0&&Ue===void 0)return 0;if(Ue===void 0)return 1;if(ke===void 0)return-1;if(ke!==Ue)return z(ke,Ue)}while(++we)},fe.prototype.inc=function(se,we){switch(se){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",we);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",we);break;case"prepatch":this.prerelease.length=0,this.inc("patch",we),this.inc("pre",we);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",we),this.inc("pre",we);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}we&&(this.prerelease[0]===we?isNaN(this.prerelease[1])&&(this.prerelease=[we,0]):this.prerelease=[we,0]);break;default:throw new Error("invalid increment argument: "+se)}return this.format(),this.raw=this.version,this},e.inc=function(se,we,ke,Ue){typeof ke=="string"&&(Ue=ke,ke=void 0);try{return new fe(se,ke).inc(we,Ue).version}catch{return null}},e.diff=function(se,we){if(ne(se,we))return null;var ke=re(se),Ue=re(we);if(ke.prerelease.length||Ue.prerelease.length){for(var He in ke)if((He==="major"||He==="minor"||He==="patch")&&ke[He]!==Ue[He])return"pre"+He;return"prerelease"}for(var He in ke)if((He==="major"||He==="minor"||He==="patch")&&ke[He]!==Ue[He])return He},e.compareIdentifiers=z;var he=/^[0-9]+$/;function z(se,we){var ke=he.test(se),Ue=he.test(we);return ke&&Ue&&(se=+se,we=+we),ke&&!Ue?-1:Ue&&!ke?1:se<we?-1:se>we?1:0}function Z(se,we,ke){return new fe(se,ke).compare(new fe(we,ke))}function ye(se,we,ke){return Z(se,we,ke)>0}function Re(se,we,ke){return Z(se,we,ke)<0}function ne(se,we,ke){return Z(se,we,ke)===0}function ee(se,we,ke){return Z(se,we,ke)!==0}function de(se,we,ke){return Z(se,we,ke)>=0}function K(se,we,ke){return Z(se,we,ke)<=0}function le(se,we,ke,Ue){var He;switch(we){case"===":typeof se=="object"&&(se=se.version),typeof ke=="object"&&(ke=ke.version),He=se===ke;break;case"!==":typeof se=="object"&&(se=se.version),typeof ke=="object"&&(ke=ke.version),He=se!==ke;break;case"":case"=":case"==":He=ne(se,ke,Ue);break;case"!=":He=ee(se,ke,Ue);break;case">":He=ye(se,ke,Ue);break;case">=":He=de(se,ke,Ue);break;case"<":He=Re(se,ke,Ue);break;case"<=":He=K(se,ke,Ue);break;default:throw new TypeError("Invalid operator: "+we)}return He}function oe(se,we){if(se instanceof oe){if(se.loose===we)return se;se=se.value}if(!(this instanceof oe))return new oe(se,we);d("comparator",se,we),this.loose=we,this.parse(se),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,d("comp",this)}e.rcompareIdentifiers=function(se,we){return z(we,se)},e.major=function(se,we){return new fe(se,we).major},e.minor=function(se,we){return new fe(se,we).minor},e.patch=function(se,we){return new fe(se,we).patch},e.compare=Z,e.compareLoose=function(se,we){return Z(se,we,!0)},e.rcompare=function(se,we,ke){return Z(we,se,ke)},e.sort=function(se,we){return se.sort(function(ke,Ue){return e.compare(ke,Ue,we)})},e.rsort=function(se,we){return se.sort(function(ke,Ue){return e.rcompare(ke,Ue,we)})},e.gt=ye,e.lt=Re,e.eq=ne,e.neq=ee,e.gte=de,e.lte=K,e.cmp=le,e.Comparator=oe;var ue={};function Ee(se,we){if(se instanceof Ee)return se.loose===we?se:new Ee(se.raw,we);if(se instanceof oe)return new Ee(se.value,we);if(!(this instanceof Ee))return new Ee(se,we);if(this.loose=we,this.raw=se,this.set=se.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+se);this.format()}function M(se){return!se||se.toLowerCase()==="x"||se==="*"}function q(se,we,ke,Ue,He,Je,Ge,et,Qe,st,tt,Pe,_e){return((we=M(ke)?"":M(Ue)?">="+ke+".0.0":M(He)?">="+ke+"."+Ue+".0":">="+we)+" "+(et=M(Qe)?"":M(st)?"<"+(+Qe+1)+".0.0":M(tt)?"<"+Qe+"."+(+st+1)+".0":Pe?"<="+Qe+"."+st+"."+tt+"-"+Pe:"<="+et)).trim()}function G(se,we){for(var ke=0;ke<se.length;ke++)if(!se[ke].test(we))return!1;if(we.prerelease.length){for(ke=0;ke<se.length;ke++)if(d(se[ke].semver),se[ke].semver!==ue&&se[ke].semver.prerelease.length>0){var Ue=se[ke].semver;if(Ue.major===we.major&&Ue.minor===we.minor&&Ue.patch===we.patch)return!0}return!1}return!0}function J(se,we,ke){try{we=new Ee(we,ke)}catch{return!1}return we.test(se)}function be(se,we,ke,Ue){var He,Je,Ge,et,Qe;switch(se=new fe(se,Ue),we=new Ee(we,Ue),ke){case">":He=ye,Je=K,Ge=Re,et=">",Qe=">=";break;case"<":He=Re,Je=de,Ge=ye,et="<",Qe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(J(se,we,Ue))return!1;for(var st=0;st<we.set.length;++st){var tt=we.set[st],Pe=null,_e=null;if(tt.forEach(function(ze){ze.semver===ue&&(ze=new oe(">=0.0.0")),Pe=Pe||ze,_e=_e||ze,He(ze.semver,Pe.semver,Ue)?Pe=ze:Ge(ze.semver,_e.semver,Ue)&&(_e=ze)}),Pe.operator===et||Pe.operator===Qe||(!_e.operator||_e.operator===et)&&Je(se,_e.semver)||_e.operator===Qe&&Ge(se,_e.semver))return!1}return!0}oe.prototype.parse=function(se){var we=this.loose?m[j]:m[ge],ke=se.match(we);if(!ke)throw new TypeError("Invalid comparator: "+se);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new fe(ke[2],this.loose):this.semver=ue},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(se){return d("Comparator.test",se,this.loose),this.semver===ue||(typeof se=="string"&&(se=new fe(se,this.loose)),le(se,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(se,we){if(!(se instanceof oe))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new Ee(se.value,we),J(this.value,ke,we);if(se.operator==="")return ke=new Ee(this.value,we),J(se.semver,ke,we);var Ue=!(this.operator!==">="&&this.operator!==">"||se.operator!==">="&&se.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||se.operator!=="<="&&se.operator!=="<"),Je=this.semver.version===se.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||se.operator!==">="&&se.operator!=="<="),et=le(this.semver,"<",se.semver,we)&&(this.operator===">="||this.operator===">")&&(se.operator==="<="||se.operator==="<"),Qe=le(this.semver,">",se.semver,we)&&(this.operator==="<="||this.operator==="<")&&(se.operator===">="||se.operator===">");return Ue||He||Je&&Ge||et||Qe},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(se){return se.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(se){var we=this.loose;se=se.trim(),d("range",se,we);var ke=we?m[$]:m[te];se=se.replace(ke,q),d("hyphen replace",se),se=se.replace(m[ie],"$1$2$3"),d("comparator trim",se,m[ie]),se=(se=(se=se.replace(m[O],"$1~")).replace(m[B],"$1^")).split(/\s+/).join(" ");var Ue=we?m[j]:m[ge],He=se.split(" ").map(function(Je){return function(Ge,et){return d("comp",Ge),Ge=function(Qe,st){return Qe.trim().split(/\s+/).map(function(tt){return function(Pe,_e){d("caret",Pe,_e);var ze=_e?m[X]:m[U];return Pe.replace(ze,function(Y,Q,Se,Be,Me){var Xe;return d("caret",Pe,Y,Q,Se,Be,Me),M(Q)?Xe="":M(Se)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":M(Be)?Xe=Q==="0"?">="+Q+"."+Se+".0 <"+Q+"."+(+Se+1)+".0":">="+Q+"."+Se+".0 <"+(+Q+1)+".0.0":Me?(d("replaceCaret pr",Me),Me.charAt(0)!=="-"&&(Me="-"+Me),Xe=Q==="0"?Se==="0"?">="+Q+"."+Se+"."+Be+Me+" <"+Q+"."+Se+"."+(+Be+1):">="+Q+"."+Se+"."+Be+Me+" <"+Q+"."+(+Se+1)+".0":">="+Q+"."+Se+"."+Be+Me+" <"+(+Q+1)+".0.0"):(d("no pr"),Xe=Q==="0"?Se==="0"?">="+Q+"."+Se+"."+Be+" <"+Q+"."+Se+"."+(+Be+1):">="+Q+"."+Se+"."+Be+" <"+Q+"."+(+Se+1)+".0":">="+Q+"."+Se+"."+Be+" <"+(+Q+1)+".0.0"),d("caret return",Xe),Xe})}(tt,st)}).join(" ")}(Ge,et),d("caret",Ge),Ge=function(Qe,st){return Qe.trim().split(/\s+/).map(function(tt){return function(Pe,_e){var ze=_e?m[F]:m[N];return Pe.replace(ze,function(Y,Q,Se,Be,Me){var Xe;return d("tilde",Pe,Y,Q,Se,Be,Me),M(Q)?Xe="":M(Se)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":M(Be)?Xe=">="+Q+"."+Se+".0 <"+Q+"."+(+Se+1)+".0":Me?(d("replaceTilde pr",Me),Me.charAt(0)!=="-"&&(Me="-"+Me),Xe=">="+Q+"."+Se+"."+Be+Me+" <"+Q+"."+(+Se+1)+".0"):Xe=">="+Q+"."+Se+"."+Be+" <"+Q+"."+(+Se+1)+".0",d("tilde return",Xe),Xe})}(tt,st)}).join(" ")}(Ge,et),d("tildes",Ge),Ge=function(Qe,st){return d("replaceXRanges",Qe,st),Qe.split(/\s+/).map(function(tt){return function(Pe,_e){Pe=Pe.trim();var ze=_e?m[u]:m[w];return Pe.replace(ze,function(Y,Q,Se,Be,Me,Xe){d("xRange",Pe,Y,Q,Se,Be,Me,Xe);var Ze=M(Se),rt=Ze||M(Be),ft=rt||M(Me);return Q==="="&&ft&&(Q=""),Ze?Y=Q===">"||Q==="<"?"<0.0.0":"*":Q&&ft?(rt&&(Be=0),ft&&(Me=0),Q===">"?(Q=">=",rt?(Se=+Se+1,Be=0,Me=0):ft&&(Be=+Be+1,Me=0)):Q==="<="&&(Q="<",rt?Se=+Se+1:Be=+Be+1),Y=Q+Se+"."+Be+"."+Me):rt?Y=">="+Se+".0.0 <"+(+Se+1)+".0.0":ft&&(Y=">="+Se+"."+Be+".0 <"+Se+"."+(+Be+1)+".0"),d("xRange return",Y),Y})}(tt,st)}).join(" ")}(Ge,et),d("xrange",Ge),Ge=function(Qe,st){return d("replaceStars",Qe,st),Qe.trim().replace(m[H],"")}(Ge,et),d("stars",Ge),Ge}(Je,we)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(Je){return!!Je.match(Ue)})),He=He.map(function(Je){return new oe(Je,we)})},Ee.prototype.intersects=function(se,we){if(!(se instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(Ue){return se.set.some(function(He){return He.every(function(Je){return Ue.intersects(Je,we)})})})})},e.toComparators=function(se,we){return new Ee(se,we).set.map(function(ke){return ke.map(function(Ue){return Ue.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(se){if(!se)return!1;typeof se=="string"&&(se=new fe(se,this.loose));for(var we=0;we<this.set.length;we++)if(G(this.set[we],se))return!0;return!1},e.satisfies=J,e.maxSatisfying=function(se,we,ke){var Ue=null,He=null;try{var Je=new Ee(we,ke)}catch{return null}return se.forEach(function(Ge){Je.test(Ge)&&(Ue&&He.compare(Ge)!==-1||(He=new fe(Ue=Ge,ke)))}),Ue},e.minSatisfying=function(se,we,ke){var Ue=null,He=null;try{var Je=new Ee(we,ke)}catch{return null}return se.forEach(function(Ge){Je.test(Ge)&&(Ue&&He.compare(Ge)!==1||(He=new fe(Ue=Ge,ke)))}),Ue},e.validRange=function(se,we){try{return new Ee(se,we).range||"*"}catch{return null}},e.ltr=function(se,we,ke){return be(se,we,"<",ke)},e.gtr=function(se,we,ke){return be(se,we,">",ke)},e.outside=be,e.prerelease=function(se,we){var ke=re(se,we);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(se,we,ke){return se=new Ee(se,ke),we=new Ee(we,ke),se.intersects(we)},e.coerce=function(se){if(se instanceof fe)return se;if(typeof se!="string")return null;var we=se.match(m[E]);return we==null?null:re((we[1]||"0")+"."+(we[2]||"0")+"."+(we[3]||"0"))}}).call(this,_(1))},function(me,e){var _,L,d=me.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function m(r){if(_===setTimeout)return setTimeout(r,0);if((_===A||!_)&&setTimeout)return _=setTimeout,setTimeout(r,0);try{return _(r,0)}catch{try{return _.call(null,r,0)}catch{return _.call(this,r,0)}}}(function(){try{_=typeof setTimeout=="function"?setTimeout:A}catch{_=A}try{L=typeof clearTimeout=="function"?clearTimeout:T}catch{L=T}})();var y,v=[],R=!1,k=-1;function p(){R&&y&&(R=!1,y.length?v=y.concat(v):k=-1,v.length&&C())}function C(){if(!R){var r=m(p);R=!0;for(var s=v.length;s;){for(y=v,v=[];++k<s;)y&&y[k].run();k=-1,s=v.length}y=null,R=!1,function(c){if(L===clearTimeout)return clearTimeout(c);if((L===T||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(c);try{L(c)}catch{try{return L.call(null,c)}catch{return L.call(this,c)}}}(r)}}function D(r,s){this.fun=r,this.array=s}function b(){}d.nextTick=function(r){var s=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)s[c-1]=arguments[c];v.push(new D(r,s)),v.length!==1||R||m(C)},D.prototype.run=function(){this.fun.apply(null,this.array)},d.title="browser",d.browser=!0,d.env={},d.argv=[],d.version="",d.versions={},d.on=b,d.addListener=b,d.once=b,d.off=b,d.removeListener=b,d.removeAllListeners=b,d.emit=b,d.prependListener=b,d.prependOnceListener=b,d.listeners=function(r){return[]},d.binding=function(r){throw new Error("process.binding is not supported")},d.cwd=function(){return"/"},d.chdir=function(r){throw new Error("process.chdir is not supported")},d.umask=function(){return 0}}])}),define(De[39],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const _=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(A){return new L(A)}constructor(A){this._now=_&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=L}),define(De[3],Ie([1,0,8,67,4,68,39]),function(me,e,_,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const m=!1,y=!1;var v;(function(h){h.None=()=>d.Disposable.None;function w(ne){if(y){const{onDidAddListener:ee}=ne,de=D.create();let K=0;ne.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),ee?.()}}}function u(ne,ee){return X(ne,()=>{},0,void 0,!0,void 0,ee)}h.defer=u;function E(ne){return(ee,de=null,K)=>{let le=!1,oe;return oe=ne(ue=>{if(!le)return oe?oe.dispose():le=!0,ee.call(de,ue)},null,K),le&&oe.dispose(),oe}}h.once=E;function P(ne,ee,de){return U((K,le=null,oe)=>ne(ue=>K.call(le,ee(ue)),null,oe),de)}h.map=P;function O(ne,ee,de){return U((K,le=null,oe)=>ne(ue=>{ee(ue),K.call(le,ue)},null,oe),de)}h.forEach=O;function N(ne,ee,de){return U((K,le=null,oe)=>ne(ue=>ee(ue)&&K.call(le,ue),null,oe),de)}h.filter=N;function F(ne){return ne}h.signal=F;function x(...ne){return(ee,de=null,K)=>(0,d.combinedDisposable)(...ne.map(le=>le(oe=>ee.call(de,oe),null,K)))}h.any=x;function B(ne,ee,de,K){let le=de;return P(ne,oe=>(le=ee(le,oe),le),K)}h.reduce=B;function U(ne,ee){let de;const K={onWillAddFirstListener(){de=ne(le.fire,le)},onDidRemoveLastListener(){de?.dispose()}};ee||w(K);const le=new f(K);return ee?.add(le),le.event}function X(ne,ee,de=100,K=!1,le=!1,oe,ue){let Ee,M,q,G=0,J;const be={leakWarningThreshold:oe,onWillAddFirstListener(){Ee=ne(we=>{G++,M=ee(M,we),K&&!q&&(se.fire(M),M=void 0),J=()=>{const ke=M;M=void 0,q=void 0,(!K||G>1)&&se.fire(ke),G=0},typeof de=="number"?(clearTimeout(q),q=setTimeout(J,de)):q===void 0&&(q=0,queueMicrotask(J))})},onWillRemoveListener(){le&&G>0&&J?.()},onDidRemoveLastListener(){J=void 0,Ee.dispose()}};ue||w(be);const se=new f(be);return ue?.add(se),se.event}h.debounce=X;function j(ne,ee=0,de){return h.debounce(ne,(K,le)=>K?(K.push(le),K):[le],ee,void 0,!0,void 0,de)}h.accumulate=j;function ge(ne,ee=(K,le)=>K===le,de){let K=!0,le;return N(ne,oe=>{const ue=K||!ee(oe,le);return K=!1,le=oe,ue},de)}h.latch=ge;function ie(ne,ee,de){return[h.filter(ne,ee,de),h.filter(ne,K=>!ee(K),de)]}h.split=ie;function te(ne,ee=!1,de=[]){let K=de.slice(),le=ne(Ee=>{K?K.push(Ee):ue.fire(Ee)});const oe=()=>{K?.forEach(Ee=>ue.fire(Ee)),K=null},ue=new f({onWillAddFirstListener(){le||(le=ne(Ee=>ue.fire(Ee)))},onDidAddFirstListener(){K&&(ee?setTimeout(oe):oe())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return ue.event}h.buffer=te;class ${constructor(ee){this.event=ee,this.disposables=new d.DisposableStore}map(ee){return new $(P(this.event,ee,this.disposables))}forEach(ee){return new $(O(this.event,ee,this.disposables))}filter(ee){return new $(N(this.event,ee,this.disposables))}reduce(ee,de){return new $(B(this.event,ee,de,this.disposables))}latch(){return new $(ge(this.event,void 0,this.disposables))}debounce(ee,de=100,K=!1,le=!1,oe){return new $(X(this.event,ee,de,K,le,oe,this.disposables))}on(ee,de,K){return this.event(ee,de,K)}once(ee,de,K){return E(this.event)(ee,de,K)}dispose(){this.disposables.dispose()}}function H(ne){return new $(ne)}h.chain=H;function ce(ne,ee,de=K=>K){const K=(...Ee)=>ue.fire(de(...Ee)),le=()=>ne.on(ee,K),oe=()=>ne.removeListener(ee,K),ue=new f({onWillAddFirstListener:le,onDidRemoveLastListener:oe});return ue.event}h.fromNodeEventEmitter=ce;function re(ne,ee,de=K=>K){const K=(...Ee)=>ue.fire(de(...Ee)),le=()=>ne.addEventListener(ee,K),oe=()=>ne.removeEventListener(ee,K),ue=new f({onWillAddFirstListener:le,onDidRemoveLastListener:oe});return ue.event}h.fromDOMEventEmitter=re;function fe(ne){return new Promise(ee=>E(ne)(ee))}h.toPromise=fe;function he(ne,ee){return ee(void 0),ne(de=>ee(de))}h.runAndSubscribe=he;function z(ne,ee){let de=null;function K(oe){de?.dispose(),de=new d.DisposableStore,ee(oe,de)}K(void 0);const le=ne(oe=>K(oe));return(0,d.toDisposable)(()=>{le.dispose(),de?.dispose()})}h.runAndSubscribeWithStore=z;class Z{constructor(ee,de){this._observable=ee,this._counter=0,this._hasChanged=!1;const K={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};de||w(K),this.emitter=new f(K),de&&de.add(this.emitter)}beginUpdate(ee){this._counter++}handlePossibleChange(ee){}handleChange(ee,de){this._hasChanged=!0}endUpdate(ee){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ye(ne,ee){return new Z(ne,ee).emitter.event}h.fromObservable=ye;function Re(ne){return ee=>{let de=0,K=!1;const le={beginUpdate(){de++},endUpdate(){de--,de===0&&(ne.reportChanges(),K&&(K=!1,ee()))},handlePossibleChange(){},handleChange(){K=!0}};return ne.addObserver(le),ne.reportChanges(),{dispose(){ne.removeObserver(le)}}}}h.fromObservableLight=Re})(v||(e.Event=v={}));class R{static{this.all=new Set}static{this._idPool=0}constructor(w){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${w}_${R._idPool++}`,R.all.add(this)}start(w){this._stopWatch=new T.StopWatch,this.listenerCount=w}stop(){if(this._stopWatch){const w=this._stopWatch.elapsed();this.durations.push(w),this.elapsedOverall+=w,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=R;let k=-1;function p(h){const w=k;return k=h,{dispose(){k=w}}}e.setGlobalLeakWarningThreshold=p;class C{constructor(w,u=Math.random().toString(18).slice(2,5)){this.threshold=w,this.name=u,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(w,u){const E=this.threshold;if(E<=0||u<E)return;this._stacks||(this._stacks=new Map);const P=this._stacks.get(w.value)||0;if(this._stacks.set(w.value,P+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=E*.5;let O,N=0;for(const[F,x]of this._stacks)(!O||N<x)&&(O=F,N=x);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${N}):`),console.warn(O)}return()=>{const O=this._stacks.get(w.value)||0;this._stacks.set(w.value,O-1)}}}class D{static create(){return new D(new Error().stack??"")}constructor(w){this.value=w}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let b=0;class r{constructor(w){this.value=w,this.id=b++}}const s=2,c=(h,w)=>{if(h instanceof r)w(h);else for(let u=0;u<h.length;u++){const E=h[u];E&&w(E)}};class f{constructor(w){this._size=0,this._options=w,this._leakageMon=k>0||this._options?.leakWarningThreshold?new C(this._options?.leakWarningThreshold??k):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(m){const w=this._listeners;queueMicrotask(()=>{c(w,u=>u.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(w,u,E)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),d.Disposable.None;if(this._disposed)return d.Disposable.None;u&&(w=w.bind(u));const P=new r(w);let O,N;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(P.stack=D.create(),O=this._leakageMon.check(P.stack,this._size+1)),m&&(P.stack=N??D.create()),this._listeners?this._listeners instanceof r?(this._deliveryQueue??=new I,this._listeners=[this._listeners,P]):this._listeners.push(P):(this._options?.onWillAddFirstListener?.(this),this._listeners=P,this._options?.onDidAddFirstListener?.(this)),this._size++;const F=(0,d.toDisposable)(()=>{O?.(),this._removeListener(P)});return E instanceof d.DisposableStore?E.add(F):Array.isArray(E)&&E.push(F),F},this._event}_removeListener(w){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const u=this._listeners,E=u.indexOf(w);if(E===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,u[E]=void 0;const P=this._deliveryQueue.current===this;if(this._size*s<=u.length){let O=0;for(let N=0;N<u.length;N++)u[N]?u[O++]=u[N]:P&&(this._deliveryQueue.end--,O<this._deliveryQueue.i&&this._deliveryQueue.i--);u.length=O}}_deliver(w,u){if(!w)return;const E=this._options?.onListenerError||_.onUnexpectedError;if(!E){w.value(u);return}try{w.value(u)}catch(P){E(P)}}_deliverQueue(w){const u=w.current._listeners;for(;w.i<w.end;)this._deliver(u[w.i++],w.value);w.reset()}fire(w){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof r)this._deliver(this._listeners,w);else{const u=this._deliveryQueue;u.enqueue(this,w,this._listeners.length),this._deliverQueue(u)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=f;const S=()=>new I;e.createEventDeliveryQueue=S;class I{constructor(){this.i=-1,this.end=0}enqueue(w,u,E){this.i=0,this.end=E,this.current=w,this.value=u}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends f{async fireAsync(w,u,E){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList),c(this._listeners,P=>this._asyncDeliveryQueue.push([P.value,w]));this._asyncDeliveryQueue.size>0&&!u.isCancellationRequested;){const[P,O]=this._asyncDeliveryQueue.shift(),N=[],F={...O,token:u,waitUntil:x=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");E&&(x=E(x,P)),N.push(x)}};try{P(F)}catch(x){(0,_.onUnexpectedError)(x);continue}Object.freeze(N),await Promise.allSettled(N).then(x=>{for(const B of x)B.status==="rejected"&&(0,_.onUnexpectedError)(B.reason)})}}}e.AsyncEmitter=i;class a extends f{get isPaused(){return this._isPaused!==0}constructor(w){super(w),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=w?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const w=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(w))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(w){this._size&&(this._isPaused!==0?this._eventQueue.push(w):super.fire(w))}}e.PauseableEmitter=a;class n extends a{constructor(w){super(w),this._delay=w.delay??100}fire(w){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(w)}}e.DebounceEmitter=n;class t extends f{constructor(w){super(w),this._queuedEvents=[],this._mergeFn=w?.merge}fire(w){this.hasListeners()&&(this._queuedEvents.push(w),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(u=>super.fire(u)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=t;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(w){const u={event:w,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const E=()=>{this.hasListeners&&this.unhook(u);const P=this.events.indexOf(u);this.events.splice(P,1)};return(0,d.toDisposable)((0,L.once)(E))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(w=>this.hook(w))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(w=>this.unhook(w))}hook(w){w.listener=w.event(u=>this.emitter.fire(u))}unhook(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=o;class g{constructor(){this.buffers=[]}wrapEvent(w){return(u,E,P)=>w(O=>{const N=this.buffers[this.buffers.length-1];N?N.push(()=>u.call(E,O)):u.call(E,O)},void 0,P)}bufferEvents(w){const u=[];this.buffers.push(u);const E=w();return this.buffers.pop(),u.forEach(P=>P()),E}}e.EventBufferer=g;class l{constructor(){this.listening=!1,this.inputEvent=v.None,this.inputEventListener=d.Disposable.None,this.emitter=new f({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(w){this.inputEvent=w,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=w(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=l}),define(De[21],Ie([1,0,3]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(m,y){const v=setTimeout(m.bind(y),0);return{dispose(){clearTimeout(v)}}});var d;(function(m){function y(v){return v===m.None||v===m.Cancelled||v instanceof A?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}m.isCancellationToken=y,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(d||(e.CancellationToken=d={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=d.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=d.None}}e.CancellationTokenSource=T}),define(De[153],Ie([1,0,21]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(m){this.task=m,this.result=null}get(){if(this.result)return this.result;const m=new _.CancellationTokenSource,y=this.task(m.token);return this.result={promise:y,dispose:()=>{this.result=null,m.cancel(),m.dispose()}},this.result}}e.Cache=L;class d{constructor(m){this.fn=m,this.lastCache=void 0,this.lastArgKey=void 0}get(m){const y=JSON.stringify(m);return this.lastArgKey!==y&&(this.lastArgKey=y,this.lastCache=this.fn(m)),this.lastCache}}e.LRUCachedFunction=d;class A{get cachedValues(){return this._map}constructor(m){this.fn=m,this._map=new Map}get(m){if(this._map.has(m))return this._map.get(m);const y=this.fn(m);return this._map.set(m,y),y}}e.CachedFunction=A}),define(De[92],Ie([1,0,8,4]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function d(S){const I=S;return I?typeof I.read=="function":!1}e.isReadable=d;function A(S){const I=S;return I?[I.on,I.pause,I.resume,I.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=A;function T(S){const I=S;return I?A(I.stream)&&Array.isArray(I.buffer)&&typeof I.ended=="boolean":!1}e.isReadableBufferedStream=T;function m(S,I){return new y(S,I)}e.newWriteableStream=m;class y{constructor(I,i){this.reducer=I,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(I){if(!this.state.destroyed){if(this.state.flowing)this.emitData(I);else if(this.buffer.data.push(I),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(I){this.state.destroyed||(this.state.flowing?this.emitError(I):this.buffer.error.push(I))}end(I){this.state.destroyed||(typeof I<"u"&&this.write(I),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(I){this.listeners.data.slice(0).forEach(i=>i(I))}emitError(I){this.listeners.error.length===0?(0,_.onUnexpectedError)(I):this.listeners.error.slice(0).forEach(i=>i(I))}emitEnd(){this.listeners.end.slice(0).forEach(I=>I())}on(I,i){if(!this.state.destroyed)switch(I){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(I,i){if(this.state.destroyed)return;let a;switch(I){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const n=a.indexOf(i);n>=0&&a.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const I=this.reducer(this.buffer.data);this.emitData(I),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const I of this.buffer.error)this.emitError(I);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function v(S,I){const i=[];let a;for(;(a=S.read())!==null;)i.push(a);return I(i)}e.consumeReadable=v;function R(S,I,i){const a=[];let n;for(;(n=S.read())!==null&&a.length<i;)a.push(n);return n===null&&a.length>0?I(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const t=n;return n=void 0,t}return S.read()}}}e.peekReadable=R;function k(S,I){return new Promise((i,a)=>{const n=[];p(S,{onData:t=>{I&&n.push(t)},onError:t=>{I?a(t):i(void 0)},onEnd:()=>{i(I?I(n):void 0)}})})}e.consumeStream=k;function p(S,I){let i=!1;return S.on("error",a=>{i||I.onError(a)}),S.on("end",()=>{i||I.onEnd()}),S.on("data",a=>{i||I.onData(a)}),(0,L.toDisposable)(()=>i=!0)}e.listenStream=p;function C(S,I){return new Promise((i,a)=>{const n=new L.DisposableStore,t=[],o=h=>{if(t.push(h),t.length>I)return n.dispose(),S.pause(),i({stream:S,buffer:t,ended:!1})},g=h=>a(h),l=()=>i({stream:S,buffer:t,ended:!0});n.add((0,L.toDisposable)(()=>S.removeListener("error",g))),S.on("error",g),n.add((0,L.toDisposable)(()=>S.removeListener("end",l))),S.on("end",l),n.add((0,L.toDisposable)(()=>S.removeListener("data",o))),S.on("data",o)})}e.peekStream=C;function D(S,I){const i=m(I);return i.end(S),i}e.toStream=D;function b(){const S=m(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=b;function r(S){let I=!1;return{read:()=>I?null:(I=!0,S)}}e.toReadable=r;function s(S,I,i){const a=m(i);return p(S,{onData:n=>a.write(I.data(n)),onError:n=>a.error(I.error?I.error(n):n),onEnd:()=>a.end()}),a}e.transform=s;function c(S,I,i){let a=!1;return{read:()=>{const n=I.read();return a?n:(a=!0,n!==null?i([S,n]):S)}}}e.prefixedReadable=c;function f(S,I,i){let a=!1;const n=m(i);return p(I,{onData:t=>a?n.write(t):(a=!0,n.write(i([S,t]))),onError:t=>n.error(t),onEnd:()=>{a||(a=!0,n.write(S)),n.end()}}),n}e.prefixedStream=f}),define(De[22],Ie([1,0,54,92]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const d=typeof Buffer<"u",A=new _.Lazy(()=>new Uint8Array(256));let T,m;class y{static alloc(E){return d?new y(Buffer.allocUnsafe(E)):new y(new Uint8Array(E))}static wrap(E){return d&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new y(E)}static fromString(E,P){return!(P?.dontUseNodeBuffer||!1)&&d?new y(Buffer.from(E)):(T||(T=new TextEncoder),new y(T.encode(E)))}static fromByteArray(E){const P=y.alloc(E.length);for(let O=0,N=E.length;O<N;O++)P.buffer[O]=E[O];return P}static concat(E,P){if(typeof P>"u"){P=0;for(let F=0,x=E.length;F<x;F++)P+=E[F].byteLength}const O=y.alloc(P);let N=0;for(let F=0,x=E.length;F<x;F++){const B=E[F];O.set(B,N),N+=B.byteLength}return O}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=y.alloc(this.byteLength);return E.set(this),E}toString(){return d?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(E,P){return new y(this.buffer.subarray(E,P))}set(E,P){if(E instanceof y)this.buffer.set(E.buffer,P);else if(E instanceof Uint8Array)this.buffer.set(E,P);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),P);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return p(this.buffer,E)}writeUInt32BE(E,P){C(this.buffer,E,P)}readUInt32LE(E){return D(this.buffer,E)}writeUInt32LE(E,P){b(this.buffer,E,P)}readUInt8(E){return r(this.buffer,E)}writeUInt8(E,P){s(this.buffer,E,P)}indexOf(E,P=0){return v(this.buffer,E instanceof y?E.buffer:E,P)}}e.VSBuffer=y;function v(u,E,P=0){const O=E.byteLength,N=u.byteLength;if(O===0)return 0;if(O===1)return u.indexOf(E[0]);if(O>N-P)return-1;const F=A.value;F.fill(E.length);for(let X=0;X<E.length;X++)F[E[X]]=E.length-X-1;let x=P+E.length-1,B=x,U=-1;for(;x<N;)if(u[x]===E[B]){if(B===0){U=x;break}x--,B--}else x+=Math.max(E.length-B,F[u[x]]),B=E.length-1;return U}e.binaryIndexOf=v;function R(u,E){return u[E+0]<<0>>>0|u[E+1]<<8>>>0}e.readUInt16LE=R;function k(u,E,P){u[P+0]=E&255,E=E>>>8,u[P+1]=E&255}e.writeUInt16LE=k;function p(u,E){return u[E]*2**24+u[E+1]*2**16+u[E+2]*2**8+u[E+3]}e.readUInt32BE=p;function C(u,E,P){u[P+3]=E,E=E>>>8,u[P+2]=E,E=E>>>8,u[P+1]=E,E=E>>>8,u[P]=E}e.writeUInt32BE=C;function D(u,E){return u[E+0]<<0>>>0|u[E+1]<<8>>>0|u[E+2]<<16>>>0|u[E+3]<<24>>>0}e.readUInt32LE=D;function b(u,E,P){u[P+0]=E&255,E=E>>>8,u[P+1]=E&255,E=E>>>8,u[P+2]=E&255,E=E>>>8,u[P+3]=E&255}e.writeUInt32LE=b;function r(u,E){return u[E]}e.readUInt8=r;function s(u,E,P){u[P]=E}e.writeUInt8=s;function c(u){return L.consumeReadable(u,E=>y.concat(E))}e.readableToBuffer=c;function f(u){return L.toReadable(u)}e.bufferToReadable=f;function S(u){return L.consumeStream(u,E=>y.concat(E))}e.streamToBuffer=S;async function I(u){return u.ended?y.concat(u.buffer):y.concat([...u.buffer,await S(u.stream)])}e.bufferedStreamToBuffer=I;function i(u){return L.toStream(u,E=>y.concat(E))}e.bufferToStream=i;function a(u){return L.transform(u,{data:E=>typeof E=="string"?y.fromString(E):y.wrap(E)},E=>y.concat(E))}e.streamToBufferReadableStream=a;function n(u){return L.newWriteableStream(E=>y.concat(E),u)}e.newWriteableBufferStream=n;function t(u,E){return L.prefixedReadable(u,E,P=>y.concat(P))}e.prefixedBufferReadable=t;function o(u,E){return L.prefixedStream(u,E,P=>y.concat(P))}e.prefixedBufferStream=o;function g(u){let E=0,P=0,O=0;const N=new Uint8Array(Math.floor(u.length/4*3)),F=B=>{switch(P){case 3:N[O++]=E|B,P=0;break;case 2:N[O++]=E|B>>>2,E=B<<6,P=3;break;case 1:N[O++]=E|B>>>4,E=B<<4,P=2;break;default:E=B<<2,P=1}};for(let B=0;B<u.length;B++){const U=u.charCodeAt(B);if(U>=65&&U<=90)F(U-65);else if(U>=97&&U<=122)F(U-97+26);else if(U>=48&&U<=57)F(U-48+52);else if(U===43||U===45)F(62);else if(U===47||U===95)F(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${u[B]}`)}}const x=O;for(;P>0;)F(0);return y.wrap(N).slice(0,x)}e.decodeBase64=g;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:u},E=!0,P=!1){const O=P?h:l;let N="";const F=u.byteLength%3;let x=0;for(;x<u.byteLength-F;x+=3){const B=u[x+0],U=u[x+1],X=u[x+2];N+=O[B>>>2],N+=O[(B<<4|U>>>4)&63],N+=O[(U<<2|X>>>6)&63],N+=O[X&63]}if(F===1){const B=u[x+0];N+=O[B>>>2],N+=O[B<<4&63],E&&(N+="==")}else if(F===2){const B=u[x+0],U=u[x+1];N+=O[B>>>2],N+=O[(B<<4|U>>>4)&63],N+=O[U<<2&63],E&&(N+="=")}return N}e.encodeBase64=w}),define(De[12],Ie([1,0,153,54]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function d(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}e.isFalsyOrWhitespace=d;const A=/{(\d+)}/g;function T(Pe,..._e){return _e.length===0?Pe:Pe.replace(A,function(ze,Y){const Q=parseInt(Y,10);return isNaN(Q)||Q<0||Q>=_e.length?ze:_e[Q]})}e.format=T;const m=/{([^}]+)}/g;function y(Pe,_e){return Pe.replace(m,(ze,Y)=>_e[Y]??ze)}e.format2=y;function v(Pe){return Pe.replace(/[<>&]/g,function(_e){switch(_e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return _e}})}e.escape=v;function R(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=R;function k(Pe,_e){let ze=0;const Y=_e.charCodeAt(0);for(let Q=Pe.length-1;Q>=0;Q--)Pe.charCodeAt(Q)===Y&&ze++;return ze}e.count=k;function p(Pe,_e,ze="\u2026"){return Pe.length<=_e?Pe:`${Pe.substr(0,_e)}${ze}`}e.truncate=p;function C(Pe,_e=" "){const ze=D(Pe,_e);return b(ze,_e)}e.trim=C;function D(Pe,_e){if(!Pe||!_e)return Pe;const ze=_e.length;if(ze===0||Pe.length===0)return Pe;let Y=0;for(;Pe.indexOf(_e,Y)===Y;)Y=Y+ze;return Pe.substring(Y)}e.ltrim=D;function b(Pe,_e){if(!Pe||!_e)return Pe;const ze=_e.length,Y=Pe.length;if(ze===0||Y===0)return Pe;let Q=Y,Se=-1;for(;Se=Pe.lastIndexOf(_e,Q-1),!(Se===-1||Se+ze!==Q);){if(Se===0)return"";Q=Se}return Pe.substring(0,Q)}e.rtrim=b;function r(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=r;function s(Pe){return Pe.replace(/\*/g,"")}e.stripWildcards=s;function c(Pe,_e,ze={}){if(!Pe)throw new Error("Cannot create regex from empty string");_e||(Pe=R(Pe)),ze.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Y="";return ze.global&&(Y+="g"),ze.matchCase||(Y+="i"),ze.multiline&&(Y+="m"),ze.unicode&&(Y+="u"),new RegExp(Pe,Y)}e.createRegExp=c;function f(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function S(Pe){return!!Pe.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function I(Pe){return(Pe.global?"g":"")+(Pe.ignoreCase?"i":"")+(Pe.multiline?"m":"")+(Pe.unicode?"u":"")}e.regExpFlags=I;function i(Pe){return Pe.split(/\r\n|\r|\n/)}e.splitLines=i;function a(Pe){for(let _e=0,ze=Pe.length;_e<ze;_e++){const Y=Pe.charCodeAt(_e);if(Y!==32&&Y!==9)return _e}return-1}e.firstNonWhitespaceIndex=a;function n(Pe,_e=0,ze=Pe.length){for(let Y=_e;Y<ze;Y++){const Q=Pe.charCodeAt(Y);if(Q!==32&&Q!==9)return Pe.substring(_e,Y)}return Pe.substring(_e,ze)}e.getLeadingWhitespace=n;function t(Pe,_e=Pe.length-1){for(let ze=_e;ze>=0;ze--){const Y=Pe.charCodeAt(ze);if(Y!==32&&Y!==9)return ze}return-1}e.lastNonWhitespaceIndex=t;function o(Pe,_e,ze){const Y=[];let Q=0;for(const Se of Pe.matchAll(_e)){if(Y.push(Pe.slice(Q,Se.index)),Se.index===void 0)throw new Error("match.index should be defined");Q=Se.index+Se[0].length,Y.push(ze(Se[0],...Se.slice(1),Se.index,Pe,Se.groups))}return Y.push(Pe.slice(Q)),Promise.all(Y).then(Se=>Se.join(""))}e.replaceAsync=o;function g(Pe,_e){return Pe<_e?-1:Pe>_e?1:0}e.compare=g;function l(Pe,_e,ze=0,Y=Pe.length,Q=0,Se=_e.length){for(;ze<Y&&Q<Se;ze++,Q++){const Xe=Pe.charCodeAt(ze),Ze=_e.charCodeAt(Q);if(Xe<Ze)return-1;if(Xe>Ze)return 1}const Be=Y-ze,Me=Se-Q;return Be<Me?-1:Be>Me?1:0}e.compareSubstring=l;function h(Pe,_e){return w(Pe,_e,0,Pe.length,0,_e.length)}e.compareIgnoreCase=h;function w(Pe,_e,ze=0,Y=Pe.length,Q=0,Se=_e.length){for(;ze<Y&&Q<Se;ze++,Q++){let Xe=Pe.charCodeAt(ze),Ze=_e.charCodeAt(Q);if(Xe===Ze)continue;if(Xe>=128||Ze>=128)return l(Pe.toLowerCase(),_e.toLowerCase(),ze,Y,Q,Se);E(Xe)&&(Xe-=32),E(Ze)&&(Ze-=32);const rt=Xe-Ze;if(rt!==0)return rt}const Be=Y-ze,Me=Se-Q;return Be<Me?-1:Be>Me?1:0}e.compareSubstringIgnoreCase=w;function u(Pe){return Pe>=48&&Pe<=57}e.isAsciiDigit=u;function E(Pe){return Pe>=97&&Pe<=122}e.isLowerAsciiLetter=E;function P(Pe){return Pe>=65&&Pe<=90}e.isUpperAsciiLetter=P;function O(Pe,_e){return Pe.length===_e.length&&w(Pe,_e)===0}e.equalsIgnoreCase=O;function N(Pe,_e){const ze=_e.length;return _e.length>Pe.length?!1:w(Pe,_e,0,ze)===0}e.startsWithIgnoreCase=N;function F(Pe,_e){const ze=Math.min(Pe.length,_e.length);let Y;for(Y=0;Y<ze;Y++)if(Pe.charCodeAt(Y)!==_e.charCodeAt(Y))return Y;return ze}e.commonPrefixLength=F;function x(Pe,_e){const ze=Math.min(Pe.length,_e.length);let Y;const Q=Pe.length-1,Se=_e.length-1;for(Y=0;Y<ze;Y++)if(Pe.charCodeAt(Q-Y)!==_e.charCodeAt(Se-Y))return Y;return ze}e.commonSuffixLength=x;function B(Pe){return 55296<=Pe&&Pe<=56319}e.isHighSurrogate=B;function U(Pe){return 56320<=Pe&&Pe<=57343}e.isLowSurrogate=U;function X(Pe,_e){return(Pe-55296<<10)+(_e-56320)+65536}e.computeCodePoint=X;function j(Pe,_e,ze){const Y=Pe.charCodeAt(ze);if(B(Y)&&ze+1<_e){const Q=Pe.charCodeAt(ze+1);if(U(Q))return X(Y,Q)}return Y}e.getNextCodePoint=j;function ge(Pe,_e){const ze=Pe.charCodeAt(_e-1);if(U(ze)&&_e>1){const Y=Pe.charCodeAt(_e-2);if(B(Y))return X(Y,ze)}return ze}class ie{get offset(){return this._offset}constructor(_e,ze=0){this._str=_e,this._len=_e.length,this._offset=ze}setOffset(_e){this._offset=_e}prevCodePoint(){const _e=ge(this._str,this._offset);return this._offset-=_e>=65536?2:1,_e}nextCodePoint(){const _e=j(this._str,this._len,this._offset);return this._offset+=_e>=65536?2:1,_e}eol(){return this._offset>=this._len}}e.CodePointIterator=ie;class te{get offset(){return this._iterator.offset}constructor(_e,ze=0){this._iterator=new ie(_e,ze)}nextGraphemeLength(){const _e=Ue.getInstance(),ze=this._iterator,Y=ze.offset;let Q=_e.getGraphemeBreakType(ze.nextCodePoint());for(;!ze.eol();){const Se=ze.offset,Be=_e.getGraphemeBreakType(ze.nextCodePoint());if(we(Q,Be)){ze.setOffset(Se);break}Q=Be}return ze.offset-Y}prevGraphemeLength(){const _e=Ue.getInstance(),ze=this._iterator,Y=ze.offset;let Q=_e.getGraphemeBreakType(ze.prevCodePoint());for(;ze.offset>0;){const Se=ze.offset,Be=_e.getGraphemeBreakType(ze.prevCodePoint());if(we(Be,Q)){ze.setOffset(Se);break}Q=Be}return Y-ze.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=te;function $(Pe,_e){return new te(Pe,_e).nextGraphemeLength()}e.nextCharLength=$;function H(Pe,_e){return new te(Pe,_e).prevGraphemeLength()}e.prevCharLength=H;function ce(Pe,_e){_e>0&&U(Pe.charCodeAt(_e))&&_e--;const ze=_e+$(Pe,_e);return[ze-H(Pe,ze),ze]}e.getCharContainingOffset=ce;function re(Pe){const _e=new te(Pe);let ze=0;for(;!_e.eol();)ze++,_e.nextGraphemeLength();return ze}e.charCount=re;let fe;function he(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function z(Pe){return fe||(fe=he()),fe.test(Pe)}e.containsRTL=z;const Z=/^[\t\n\r\x20-\x7E]*$/;function ye(Pe){return Z.test(Pe)}e.isBasicASCII=ye,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Re(Pe){return e.UNUSUAL_LINE_TERMINATORS.test(Pe)}e.containsUnusualLineTerminators=Re;function ne(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}e.isFullWidthCharacter=ne;function ee(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}e.isEmojiImprecise=ee;function de(Pe,_e){if(Pe.length<_e)return Pe;const ze=/\b/g;let Y=0;for(;ze.test(Pe)&&!(Pe.length-ze.lastIndex<_e);)Y=ze.lastIndex,ze.lastIndex+=1;return Pe.substring(Y).replace(/^\s/,"")}e.lcut=de;const K=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,le=/\x1b\].*?\x07/g;function oe(Pe){return Pe&&(Pe=Pe.replace(K,"").replace(le,"")),Pe}e.removeAnsiEscapeCodes=oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ue(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ue;function Ee(Pe){return ue(Pe)?Pe.substr(1):Pe}e.stripUTF8BOM=Ee;function M(Pe,_e){if(!Pe||!_e||Pe.length<_e.length)return!1;const ze=_e.length,Y=Pe.toLowerCase();let Q=0,Se=-1;for(;Q<ze;){const Be=Y.indexOf(_e[Q],Se+1);if(Be<0)return!1;Se=Be,Q++}return!0}e.fuzzyContains=M;function q(Pe,_e=!1){return Pe?(_e&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}e.containsUppercaseCharacter=q;function G(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}e.uppercaseFirstLetter=G;function J(Pe,_e=1){if(_e===0)return"";let ze=-1;do ze=Pe.indexOf(`
`,ze+1),_e--;while(_e>0&&ze>=0);return ze===-1?Pe:(Pe[ze-1]==="\r"&&ze--,Pe.substr(0,ze))}e.getNLines=J;function be(Pe){return Pe=Pe%(2*26),Pe<26?String.fromCharCode(97+Pe):String.fromCharCode(65+Pe-26)}e.singleLetterHash=be;function se(Pe){return Ue.getInstance().getGraphemeBreakType(Pe)}e.getGraphemeBreakType=se;function we(Pe,_e){return Pe===0?_e!==5&&_e!==7:Pe===2&&_e===3?!1:Pe===4||Pe===2||Pe===3||_e===4||_e===2||_e===3?!0:!(Pe===8&&(_e===8||_e===9||_e===11||_e===12)||(Pe===11||Pe===9)&&(_e===9||_e===10)||(Pe===12||Pe===10)&&_e===10||_e===5||_e===13||_e===7||Pe===1||Pe===13&&_e===14||Pe===6&&_e===6)}var ke;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(ke||(e.GraphemeBreakType=ke={}));class Ue{static{this._INSTANCE=null}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}constructor(){this._data=He()}getGraphemeBreakType(_e){if(_e<32)return _e===10?3:_e===13?2:4;if(_e<127)return 0;const ze=this._data,Y=ze.length/3;let Q=1;for(;Q<=Y;)if(_e<ze[3*Q])Q=2*Q;else if(_e>ze[3*Q+1])Q=2*Q+1;else return ze[3*Q+2];return 0}}function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(Pe,_e){if(Pe===0)return 0;const ze=Ge(Pe,_e);if(ze!==void 0)return ze;const Y=new ie(_e,Pe);return Y.prevCodePoint(),Y.offset}e.getLeftDeleteOffset=Je;function Ge(Pe,_e){const ze=new ie(_e,Pe);let Y=ze.prevCodePoint();for(;et(Y)||Y===65039||Y===8419;){if(ze.offset===0)return;Y=ze.prevCodePoint()}if(!ee(Y))return;let Q=ze.offset;return Q>0&&ze.prevCodePoint()===8205&&(Q=ze.offset),Q}function et(Pe){return 127995<=Pe&&Pe<=127999}var Qe;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class st{static{this.ambiguousCharacterData=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new _.LRUCachedFunction(_e=>{function ze(rt){const ft=new Map;for(let wt=0;wt<rt.length;wt+=2)ft.set(rt[wt],rt[wt+1]);return ft}function Y(rt,ft){const wt=new Map(rt);for(const[Lt,At]of ft)wt.set(Lt,At);return wt}function Q(rt,ft){if(!rt)return ft;const wt=new Map;for(const[Lt,At]of rt)ft.has(Lt)&&wt.set(Lt,At);return wt}const Se=this.ambiguousCharacterData.value;let Be=_e.filter(rt=>!rt.startsWith("_")&&rt in Se);Be.length===0&&(Be=["_default"]);let Me;for(const rt of Be){const ft=ze(Se[rt]);Me=Q(Me,ft)}const Xe=ze(Se._common),Ze=Y(Xe,Me);return new st(Ze)})}static getInstance(_e){return st.cache.get(Array.from(_e))}static{this._locales=new L.Lazy(()=>Object.keys(st.ambiguousCharacterData.value).filter(_e=>!_e.startsWith("_")))}static getLocales(){return st._locales.value}constructor(_e){this.confusableDictionary=_e}isAmbiguous(_e){return this.confusableDictionary.has(_e)}getPrimaryConfusable(_e){return this.confusableDictionary.get(_e)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=st;class tt{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(tt.getRawData())),this._data}static isInvisibleCharacter(_e){return tt.getData().has(_e)}static get codePoints(){return tt.getData()}}e.InvisibleCharacters=tt}),define(De[113],Ie([1,0,28,12]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function d(...oe){return function(ue,Ee){for(let M=0,q=oe.length;M<q;M++){const G=oe[M](ue,Ee);if(G)return G}return null}}e.or=d,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(oe,ue,Ee){if(!Ee||Ee.length<ue.length)return null;let M;return oe?M=L.startsWithIgnoreCase(Ee,ue):M=Ee.indexOf(ue)===0,M?ue.length>0?[{start:0,end:ue.length}]:[]:null}function T(oe,ue){const Ee=ue.toLowerCase().indexOf(oe.toLowerCase());return Ee===-1?null:[{start:Ee,end:Ee+oe.length}]}e.matchesContiguousSubString=T;function m(oe,ue){return y(oe.toLowerCase(),ue.toLowerCase(),0,0)}e.matchesSubString=m;function y(oe,ue,Ee,M){if(Ee===oe.length)return[];if(M===ue.length)return null;if(oe[Ee]===ue[M]){let q=null;return(q=y(oe,ue,Ee+1,M+1))?s({start:M,end:M+1},q):null}return y(oe,ue,Ee,M+1)}function v(oe){return 97<=oe&&oe<=122}function R(oe){return 65<=oe&&oe<=90}e.isUpper=R;function k(oe){return 48<=oe&&oe<=57}function p(oe){return oe===32||oe===9||oe===10||oe===13}const C=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(oe=>C.add(oe.charCodeAt(0)));function D(oe){return p(oe)||C.has(oe)}function b(oe,ue){return oe===ue||D(oe)&&D(ue)}function r(oe){return v(oe)||R(oe)||k(oe)}function s(oe,ue){return ue.length===0?ue=[oe]:oe.end===ue[0].start?ue[0].start=oe.start:ue.unshift(oe),ue}function c(oe,ue){for(let Ee=ue;Ee<oe.length;Ee++){const M=oe.charCodeAt(Ee);if(R(M)||k(M)||Ee>0&&!r(oe.charCodeAt(Ee-1)))return Ee}return oe.length}function f(oe,ue,Ee,M){if(Ee===oe.length)return[];if(M===ue.length)return null;if(oe[Ee]!==ue[M].toLowerCase())return null;{let q=null,G=M+1;for(q=f(oe,ue,Ee+1,M+1);!q&&(G=c(ue,G))<ue.length;)q=f(oe,ue,Ee+1,G),G++;return q===null?null:s({start:M,end:M+1},q)}}function S(oe){let ue=0,Ee=0,M=0,q=0,G=0;for(let ke=0;ke<oe.length;ke++)G=oe.charCodeAt(ke),R(G)&&ue++,v(G)&&Ee++,r(G)&&M++,k(G)&&q++;const J=ue/oe.length,be=Ee/oe.length,se=M/oe.length,we=q/oe.length;return{upperPercent:J,lowerPercent:be,alphaPercent:se,numericPercent:we}}function I(oe){const{upperPercent:ue,lowerPercent:Ee}=oe;return Ee===0&&ue>.6}function i(oe){const{upperPercent:ue,lowerPercent:Ee,alphaPercent:M,numericPercent:q}=oe;return Ee>.2&&ue<.8&&M>.6&&q<.2}function a(oe){let ue=0,Ee=0,M=0,q=0;for(let G=0;G<oe.length;G++)M=oe.charCodeAt(G),R(M)&&ue++,v(M)&&Ee++,p(M)&&q++;return(ue===0||Ee===0)&&q===0?oe.length<=30:ue<=5}function n(oe,ue){if(!ue||(ue=ue.trim(),ue.length===0)||!a(oe)||ue.length>60)return null;const Ee=S(ue);if(!i(Ee)){if(!I(Ee))return null;ue=ue.toLowerCase()}let M=null,q=0;for(oe=oe.toLowerCase();q<ue.length&&(M=f(oe,ue,0,q))===null;)q=c(ue,q+1);return M}e.matchesCamelCase=n;function t(oe,ue,Ee=!1){if(!ue||ue.length===0)return null;let M=null,q=0;for(oe=oe.toLowerCase(),ue=ue.toLowerCase();q<ue.length&&(M=o(oe,ue,0,q,Ee))===null;)q=g(ue,q+1);return M}e.matchesWords=t;function o(oe,ue,Ee,M,q){if(Ee===oe.length)return[];if(M===ue.length)return null;if(b(oe.charCodeAt(Ee),ue.charCodeAt(M))){let G=null,J=M+1;if(G=o(oe,ue,Ee+1,M+1,q),!q)for(;!G&&(J=g(ue,J))<ue.length;)G=o(oe,ue,Ee+1,J,q),J++;return G?oe.charCodeAt(Ee)!==ue.charCodeAt(M)?G:s({start:M,end:M+1},G):null}else return null}function g(oe,ue){for(let Ee=ue;Ee<oe.length;Ee++)if(D(oe.charCodeAt(Ee))||Ee>0&&D(oe.charCodeAt(Ee-1)))return Ee;return oe.length}const l=d(e.matchesPrefix,n,T),h=d(e.matchesPrefix,n,m),w=new _.LRUCache(1e4);function u(oe,ue,Ee=!1){if(typeof oe!="string"||typeof ue!="string")return null;let M=w.get(oe);M||(M=new RegExp(L.convertSimple2RegExpPattern(oe),"i"),w.set(oe,M));const q=M.exec(ue);return q?[{start:q.index,end:q.index+q[0].length}]:Ee?h(oe,ue):l(oe,ue)}e.matchesFuzzy=u;function E(oe,ue){const Ee=ye(oe,oe.toLowerCase(),0,ue,ue.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ee?O(Ee):null}e.matchesFuzzy2=E;function P(oe,ue,Ee,M,q,G){const J=Math.min(13,oe.length);for(;Ee<J;Ee++){const be=ye(oe,ue,Ee,M,q,G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(be)return be}return[0,G]}e.anyScore=P;function O(oe){if(typeof oe>"u")return[];const ue=[],Ee=oe[1];for(let M=oe.length-1;M>1;M--){const q=oe[M]+Ee,G=ue[ue.length-1];G&&G.end===q?G.end=q+1:ue.push({start:q,end:q+1})}return ue}e.createMatches=O;const N=128;function F(){const oe=[],ue=[];for(let Ee=0;Ee<=N;Ee++)ue[Ee]=0;for(let Ee=0;Ee<=N;Ee++)oe.push(ue.slice(0));return oe}function x(oe){const ue=[];for(let Ee=0;Ee<=oe;Ee++)ue[Ee]=0;return ue}const B=x(2*N),U=x(2*N),X=F(),j=F(),ge=F(),ie=!1;function te(oe,ue,Ee,M,q){function G(be,se,we=" "){for(;be.length<se;)be=we+be;return be}let J=` |   |${M.split("").map(be=>G(be,3)).join("|")}
`;for(let be=0;be<=Ee;be++)be===0?J+=" |":J+=`${ue[be-1]}|`,J+=oe[be].slice(0,q+1).map(se=>G(se.toString(),3)).join("|")+`
`;return J}function $(oe,ue,Ee,M){oe=oe.substr(ue),Ee=Ee.substr(M),console.log(te(j,oe,oe.length,Ee,Ee.length)),console.log(te(ge,oe,oe.length,Ee,Ee.length)),console.log(te(X,oe,oe.length,Ee,Ee.length))}function H(oe,ue){if(ue<0||ue>=oe.length)return!1;const Ee=oe.codePointAt(ue);switch(Ee){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(Ee)}}function ce(oe,ue){if(ue<0||ue>=oe.length)return!1;switch(oe.charCodeAt(ue)){case 32:case 9:return!0;default:return!1}}function re(oe,ue,Ee){return ue[oe]!==Ee[oe]}function fe(oe,ue,Ee,M,q,G,J=!1){for(;ue<Ee&&q<G;)oe[ue]===M[q]&&(J&&(B[ue]=q),ue+=1),q+=1;return ue===Ee}e.isPatternInWord=fe;var he;(function(oe){oe[oe.Diag=1]="Diag",oe[oe.Left=2]="Left",oe[oe.LeftLeft=3]="LeftLeft"})(he||(he={}));var z;(function(oe){oe.Default=[-100,0];function ue(Ee){return!Ee||Ee.length===2&&Ee[0]===-100&&Ee[1]===0}oe.isDefault=ue})(z||(e.FuzzyScore=z={}));class Z{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ue,Ee){this.firstMatchCanBeWeak=ue,this.boostFullMatch=Ee}}e.FuzzyScoreOptions=Z;function ye(oe,ue,Ee,M,q,G,J=Z.default){const be=oe.length>N?N:oe.length,se=M.length>N?N:M.length;if(Ee>=be||G>=se||be-Ee>se-G||!fe(ue,Ee,be,q,G,se,!0))return;Re(be,se,Ee,G,ue,q);let we=1,ke=1,Ue=Ee,He=G;const Je=[!1];for(we=1,Ue=Ee;Ue<be;we++,Ue++){const tt=B[Ue],Pe=U[Ue],_e=Ue+1<be?U[Ue+1]:se;for(ke=tt-G+1,He=tt;He<_e;ke++,He++){let ze=Number.MIN_SAFE_INTEGER,Y=!1;He<=Pe&&(ze=ne(oe,ue,Ue,Ee,M,q,He,se,G,X[we-1][ke-1]===0,Je));let Q=0;ze!==Number.MAX_SAFE_INTEGER&&(Y=!0,Q=ze+j[we-1][ke-1]);const Se=He>tt,Be=Se?j[we][ke-1]+(X[we][ke-1]>0?-5:0):0,Me=He>tt+1&&X[we][ke-1]>0,Xe=Me?j[we][ke-2]+(X[we][ke-2]>0?-5:0):0;if(Me&&(!Se||Xe>=Be)&&(!Y||Xe>=Q))j[we][ke]=Xe,ge[we][ke]=3,X[we][ke]=0;else if(Se&&(!Y||Be>=Q))j[we][ke]=Be,ge[we][ke]=2,X[we][ke]=0;else if(Y)j[we][ke]=Q,ge[we][ke]=1,X[we][ke]=X[we-1][ke-1]+1;else throw new Error("not possible")}}if(ie&&$(oe,Ee,M,G),!Je[0]&&!J.firstMatchCanBeWeak)return;we--,ke--;const Ge=[j[we][ke],G];let et=0,Qe=0;for(;we>=1;){let tt=ke;do{const Pe=ge[we][tt];if(Pe===3)tt=tt-2;else if(Pe===2)tt=tt-1;else break}while(tt>=1);et>1&&ue[Ee+we-1]===q[G+ke-1]&&!re(tt+G-1,M,q)&&et+1>X[we][tt]&&(tt=ke),tt===ke?et++:et=1,Qe||(Qe=tt),we--,ke=tt-1,Ge.push(ke)}se===be&&J.boostFullMatch&&(Ge[0]+=2);const st=Qe-be;return Ge[0]-=st,Ge}e.fuzzyScore=ye;function Re(oe,ue,Ee,M,q,G){let J=oe-1,be=ue-1;for(;J>=Ee&&be>=M;)q[J]===G[be]&&(U[J]=be,J--),be--}function ne(oe,ue,Ee,M,q,G,J,be,se,we,ke){if(ue[Ee]!==G[J])return Number.MIN_SAFE_INTEGER;let Ue=1,He=!1;return J===Ee-M?Ue=oe[Ee]===q[J]?7:5:re(J,q,G)&&(J===0||!re(J-1,q,G))?(Ue=oe[Ee]===q[J]?7:5,He=!0):H(G,J)&&(J===0||!H(G,J-1))?Ue=5:(H(G,J-1)||ce(G,J-1))&&(Ue=5,He=!0),Ue>1&&Ee===M&&(ke[0]=!0),He||(He=re(J,q,G)||H(G,J-1)||ce(G,J-1)),Ee===M?J>se&&(Ue-=He?3:5):we?Ue+=He?2:0:Ue+=He?0:1,J+1===be&&(Ue-=He?3:5),Ue}function ee(oe,ue,Ee,M,q,G,J){return K(oe,ue,Ee,M,q,G,!0,J)}e.fuzzyScoreGracefulAggressive=ee;function de(oe,ue,Ee,M,q,G,J){return K(oe,ue,Ee,M,q,G,!1,J)}e.fuzzyScoreGraceful=de;function K(oe,ue,Ee,M,q,G,J,be){let se=ye(oe,ue,Ee,M,q,G,be);if(se&&!J)return se;if(oe.length>=3){const we=Math.min(7,oe.length-1);for(let ke=Ee+1;ke<we;ke++){const Ue=le(oe,ke);if(Ue){const He=ye(Ue,Ue.toLowerCase(),Ee,M,q,G,be);He&&(He[0]-=3,(!se||He[0]>se[0])&&(se=He))}}}return se}function le(oe,ue){if(ue+1>=oe.length)return;const Ee=oe[ue],M=oe[ue+1];if(Ee!==M)return oe.slice(0,ue)+M+Ee+oe.slice(ue+2)}}),define(De[70],Ie([1,0,12]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(s){return d(s,0)}e.hash=L;function d(s,c){switch(typeof s){case"object":return s===null?A(349,c):Array.isArray(s)?y(s,c):v(s,c);case"string":return m(s,c);case"boolean":return T(s,c);case"number":return A(s,c);case"undefined":return A(937,c);default:return A(617,c)}}e.doHash=d;function A(s,c){return(c<<5)-c+s|0}e.numberHash=A;function T(s,c){return A(s?433:863,c)}function m(s,c){c=A(149417,c);for(let f=0,S=s.length;f<S;f++)c=A(s.charCodeAt(f),c);return c}e.stringHash=m;function y(s,c){return c=A(104579,c),s.reduce((f,S)=>d(S,f),c)}function v(s,c){return c=A(181387,c),Object.keys(s).sort().reduce((f,S)=>(f=m(S,f),d(s[S],f)),c)}class R{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=d(c,this._value),this._value}}e.Hasher=R;var k;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function p(s,c,f=32){const S=f-c,I=~((1<<S)-1);return(s<<c|(I&s)>>>S)>>>0}function C(s,c=0,f=s.byteLength,S=0){for(let I=0;I<f;I++)s[c+I]=S}function D(s,c,f="0"){for(;s.length<c;)s=f+s;return s}function b(s,c=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(f=>f.toString(16).padStart(2,"0")).join(""):D((s>>>0).toString(16),c/4)}e.toHexString=b;class r{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const f=c.length;if(f===0)return;const S=this._buff;let I=this._buffLen,i=this._leftoverHighSurrogate,a,n;for(i!==0?(a=i,n=-1,i=0):(a=c.charCodeAt(0),n=0);;){let t=a;if(_.isHighSurrogate(a))if(n+1<f){const o=c.charCodeAt(n+1);_.isLowSurrogate(o)?(n++,t=_.computeCodePoint(a,o)):t=65533}else{i=a;break}else _.isLowSurrogate(a)&&(t=65533);if(I=this._push(S,I,t),n++,n<f)a=c.charCodeAt(n);else break}this._buffLen=I,this._leftoverHighSurrogate=i}_push(c,f,S){return S<128?c[f++]=S:S<2048?(c[f++]=192|(S&1984)>>>6,c[f++]=128|(S&63)>>>0):S<65536?(c[f++]=224|(S&61440)>>>12,c[f++]=128|(S&4032)>>>6,c[f++]=128|(S&63)>>>0):(c[f++]=240|(S&1835008)>>>18,c[f++]=128|(S&258048)>>>12,c[f++]=128|(S&4032)>>>6,c[f++]=128|(S&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,C(this._buff,this._buffLen),this._buffLen>56&&(this._step(),C(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=r._bigBlock32,f=this._buffDV;for(let l=0;l<64;l+=4)c.setUint32(l,f.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)c.setUint32(l,p(c.getUint32(l-12,!1)^c.getUint32(l-32,!1)^c.getUint32(l-56,!1)^c.getUint32(l-64,!1),1),!1);let S=this._h0,I=this._h1,i=this._h2,a=this._h3,n=this._h4,t,o,g;for(let l=0;l<80;l++)l<20?(t=I&i|~I&a,o=1518500249):l<40?(t=I^i^a,o=1859775393):l<60?(t=I&i|I&a|i&a,o=2400959708):(t=I^i^a,o=3395469782),g=p(S,5)+t+n+o+c.getUint32(l*4,!1)&4294967295,n=a,a=i,i=p(I,30),I=S,S=g;this._h0=this._h0+S&4294967295,this._h1=this._h1+I&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=r}),define(De[40],Ie([1,0,12]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(d){d[d.Ignore=0]="Ignore",d[d.Info=1]="Info",d[d.Warning=2]="Warning",d[d.Error=3]="Error"})(L||(L={})),function(d){const A="error",T="warning",m="warn",y="info",v="ignore";function R(p){return p?_.equalsIgnoreCase(A,p)?d.Error:_.equalsIgnoreCase(T,p)||_.equalsIgnoreCase(m,p)?d.Warning:_.equalsIgnoreCase(y,p)?d.Info:d.Ignore:d.Ignore}d.fromValue=R;function k(p){switch(p){case d.Error:return A;case d.Warning:return T;case d.Info:return y;default:return v}}d.toString=k}(L||(L={})),e.default=L}),define(De[154],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(De[71],Ie([1,0,19,12]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class d{constructor(){this._value="",this._pos=0}reset(C){return this._value=C,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(C){const D=C.charCodeAt(0),b=this._value.charCodeAt(this._pos);return D-b}value(){return this._value[this._pos]}}e.StringIterator=d;class A{constructor(C=!0){this._caseSensitive=C}reset(C){return this._value=C,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let C=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(C)this._from++;else break;else C=!1;return this}cmp(C){return this._caseSensitive?(0,L.compareSubstring)(C,this._value,0,C.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(C,this._value,0,C.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class T{constructor(C=!0,D=!0){this._splitOnBackslash=C,this._caseSensitive=D}reset(C){this._from=0,this._to=0,this._value=C,this._valueLen=C.length;for(let D=C.length-1;D>=0;D--,this._valueLen--){const b=this._value.charCodeAt(D);if(!(b===47||this._splitOnBackslash&&b===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let C=!0;for(;this._to<this._valueLen;this._to++){const D=this._value.charCodeAt(this._to);if(D===47||this._splitOnBackslash&&D===92)if(C)this._from++;else break;else C=!1}return this}cmp(C){return this._caseSensitive?(0,L.compareSubstring)(C,this._value,0,C.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(C,this._value,0,C.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var m;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(m||(m={}));class y{constructor(C,D){this._ignorePathCasing=C,this._ignoreQueryAndFragment=D,this._states=[],this._stateIdx=0}reset(C){return this._value=C,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(C)),this._pathIterator.reset(C.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(C)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(C){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(C,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(C,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(C);if(this._states[this._stateIdx]===4)return(0,L.compare)(C,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(C,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=y;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const C=this.right;return this.right=C.left,C.left=this,this.updateHeight(),C.updateHeight(),C}rotateRight(){const C=this.left;return this.left=C.right,C.right=this,this.updateHeight(),C.updateHeight(),C}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(R||(R={}));class k{static forUris(C=()=>!1,D=()=>!1){return new k(new y(C,D))}static forPaths(C=!1){return new k(new T(void 0,!C))}static forStrings(){return new k(new d)}static forConfigKeys(){return new k(new A)}constructor(C){this._iter=C}clear(){this._root=void 0}fill(C,D){if(D){const b=D.slice(0);(0,_.shuffle)(b);for(const r of b)this.set(r,C)}else{const b=C.slice(0);(0,_.shuffle)(b);for(const r of b)this.set(r[0],r[1])}}set(C,D){const b=this._iter.reset(C);let r;this._root||(this._root=new v,this._root.segment=b.value());const s=[];for(r=this._root;;){const f=b.cmp(r.segment);if(f>0)r.left||(r.left=new v,r.left.segment=b.value()),s.push([-1,r]),r=r.left;else if(f<0)r.right||(r.right=new v,r.right.segment=b.value()),s.push([1,r]),r=r.right;else if(b.hasNext())b.next(),r.mid||(r.mid=new v,r.mid.segment=b.value()),s.push([0,r]),r=r.mid;else break}const c=r.value;r.value=D,r.key=C;for(let f=s.length-1;f>=0;f--){const S=s[f][1];S.updateHeight();const I=S.balanceFactor();if(I<-1||I>1){const i=s[f][0],a=s[f+1][0];if(i===1&&a===1)s[f][1]=S.rotateLeft();else if(i===-1&&a===-1)s[f][1]=S.rotateRight();else if(i===1&&a===-1)S.right=s[f+1][1]=s[f+1][1].rotateRight(),s[f][1]=S.rotateLeft();else if(i===-1&&a===1)S.left=s[f+1][1]=s[f+1][1].rotateLeft(),s[f][1]=S.rotateRight();else throw new Error;if(f>0)switch(s[f-1][0]){case-1:s[f-1][1].left=s[f][1];break;case 1:s[f-1][1].right=s[f][1];break;case 0:s[f-1][1].mid=s[f][1];break}else this._root=s[0][1]}}return c}get(C){return this._getNode(C)?.value}_getNode(C){const D=this._iter.reset(C);let b=this._root;for(;b;){const r=D.cmp(b.segment);if(r>0)b=b.left;else if(r<0)b=b.right;else if(D.hasNext())D.next(),b=b.mid;else break}return b}has(C){const D=this._getNode(C);return!(D?.value===void 0&&D?.mid===void 0)}delete(C){return this._delete(C,!1)}deleteSuperstr(C){return this._delete(C,!0)}_delete(C,D){const b=this._iter.reset(C),r=[];let s=this._root;for(;s;){const c=b.cmp(s.segment);if(c>0)r.push([-1,s]),s=s.left;else if(c<0)r.push([1,s]),s=s.right;else if(b.hasNext())b.next(),r.push([0,s]),s=s.mid;else break}if(s){if(D?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const c=this._min(s.right);if(c.key){const{key:f,value:S,segment:I}=c;this._delete(c.key,!1),s.key=f,s.value=S,s.segment=I}}else{const c=s.left??s.right;if(r.length>0){const[f,S]=r[r.length-1];switch(f){case-1:S.left=c;break;case 0:S.mid=c;break;case 1:S.right=c;break}}else this._root=c}for(let c=r.length-1;c>=0;c--){const f=r[c][1];f.updateHeight();const S=f.balanceFactor();if(S>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),r[c][1]=f.rotateLeft()):S<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),r[c][1]=f.rotateRight()),c>0)switch(r[c-1][0]){case-1:r[c-1][1].left=r[c][1];break;case 1:r[c-1][1].right=r[c][1];break;case 0:r[c-1][1].mid=r[c][1];break}else this._root=r[0][1]}}}_min(C){for(;C.left;)C=C.left;return C}findSubstr(C){const D=this._iter.reset(C);let b=this._root,r;for(;b;){const s=D.cmp(b.segment);if(s>0)b=b.left;else if(s<0)b=b.right;else if(D.hasNext())D.next(),r=b.value||r,b=b.mid;else break}return b&&b.value||r}findSuperstr(C){return this._findSuperstrOrElement(C,!1)}_findSuperstrOrElement(C,D){const b=this._iter.reset(C);let r=this._root;for(;r;){const s=b.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(b.hasNext())b.next(),r=r.mid;else return r.mid?this._entries(r.mid):D?r.value:void 0}}hasElementOrSubtree(C){return this._findSuperstrOrElement(C,!0)!==void 0}forEach(C){for(const[D,b]of this)C(b,D)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(C){const D=[];return this._dfsEntries(C,D),D[Symbol.iterator]()}_dfsEntries(C,D){C&&(C.left&&this._dfsEntries(C.left,D),C.value&&D.push([C.key,C.value]),C.mid&&this._dfsEntries(C.mid,D),C.right&&this._dfsEntries(C.right,D))}_isBalanced(){const C=D=>{if(!D)return!0;const b=D.balanceFactor();return b<-1||b>1?!1:C(D.left)&&C(D.right)};return C(this._root)}}e.TernarySearchTree=k}),define(De[14],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function _(a){return typeof a=="string"}e.isString=_;function L(a){return Array.isArray(a)&&a.every(n=>_(n))}e.isStringArray=L;function d(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=d;function A(a){const n=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof n}e.isTypedArray=A;function T(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=T;function m(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=m;function y(a){return a===!0||a===!1}e.isBoolean=y;function v(a){return typeof a>"u"}e.isUndefined=v;function R(a){return!k(a)}e.isDefined=R;function k(a){return v(a)||a===null}e.isUndefinedOrNull=k;function p(a,n){if(!a)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=p;function C(a){if(k(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=C;function D(...a){const n=[];for(let t=0;t<a.length;t++){const o=a[t];if(k(o))throw new Error(`Assertion Failed: argument at index ${t} is undefined or null`);n.push(o)}return n}e.assertAllDefined=D;const b=Object.prototype.hasOwnProperty;function r(a){if(!d(a))return!1;for(const n in a)if(b.call(a,n))return!1;return!0}e.isEmptyObject=r;function s(a){return typeof a=="function"}e.isFunction=s;function c(...a){return a.length>0&&a.every(s)}e.areFunctions=c;function f(a,n){const t=Math.min(a.length,n.length);for(let o=0;o<t;o++)S(a[o],n[o])}e.validateConstraints=f;function S(a,n){if(_(n)){if(typeof a!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(s(n)){try{if(a instanceof n)return}catch{}if(!k(a)&&a.constructor===n||n.length===1&&n.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function I(a){return a===null?void 0:a}e.withNullAsUndefined=I;function i(a){return typeof a>"u"?null:a}e.withUndefinedAsNull=i}),define(De[72],Ie([1,0,14]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function d(m,y){if((0,_.isString)(y)){const v=L[y];if(v===void 0)throw new Error(`${m} references an unknown codicon: ${y}`);y=v}return L[m]=y,{id:m}}function A(){return L}e.getCodiconFontCharacters=A;function T(){return Object.values(e.Codicon)}e.getAllCodicons=T,e.Codicon={add:d("add",6e4),plus:d("plus",6e4),gistNew:d("gist-new",6e4),repoCreate:d("repo-create",6e4),lightbulb:d("lightbulb",60001),lightBulb:d("light-bulb",60001),repo:d("repo",60002),repoDelete:d("repo-delete",60002),gistFork:d("gist-fork",60003),repoForked:d("repo-forked",60003),gitPullRequest:d("git-pull-request",60004),gitPullRequestAbandoned:d("git-pull-request-abandoned",60004),recordKeys:d("record-keys",60005),keyboard:d("keyboard",60005),tag:d("tag",60006),tagAdd:d("tag-add",60006),tagRemove:d("tag-remove",60006),person:d("person",60007),personFollow:d("person-follow",60007),personOutline:d("person-outline",60007),personFilled:d("person-filled",60007),gitBranch:d("git-branch",60008),gitBranchCreate:d("git-branch-create",60008),gitBranchDelete:d("git-branch-delete",60008),sourceControl:d("source-control",60008),mirror:d("mirror",60009),mirrorPublic:d("mirror-public",60009),star:d("star",60010),starAdd:d("star-add",60010),starDelete:d("star-delete",60010),starEmpty:d("star-empty",60010),comment:d("comment",60011),commentAdd:d("comment-add",60011),alert:d("alert",60012),warning:d("warning",60012),search:d("search",60013),searchSave:d("search-save",60013),logOut:d("log-out",60014),signOut:d("sign-out",60014),logIn:d("log-in",60015),signIn:d("sign-in",60015),eye:d("eye",60016),eyeUnwatch:d("eye-unwatch",60016),eyeWatch:d("eye-watch",60016),circleFilled:d("circle-filled",60017),primitiveDot:d("primitive-dot",60017),closeDirty:d("close-dirty",60017),debugBreakpoint:d("debug-breakpoint",60017),debugBreakpointDisabled:d("debug-breakpoint-disabled",60017),debugHint:d("debug-hint",60017),primitiveSquare:d("primitive-square",60018),edit:d("edit",60019),pencil:d("pencil",60019),info:d("info",60020),issueOpened:d("issue-opened",60020),gistPrivate:d("gist-private",60021),gitForkPrivate:d("git-fork-private",60021),lock:d("lock",60021),mirrorPrivate:d("mirror-private",60021),close:d("close",60022),removeClose:d("remove-close",60022),x:d("x",60022),repoSync:d("repo-sync",60023),sync:d("sync",60023),clone:d("clone",60024),desktopDownload:d("desktop-download",60024),beaker:d("beaker",60025),microscope:d("microscope",60025),vm:d("vm",60026),deviceDesktop:d("device-desktop",60026),file:d("file",60027),fileText:d("file-text",60027),more:d("more",60028),ellipsis:d("ellipsis",60028),kebabHorizontal:d("kebab-horizontal",60028),mailReply:d("mail-reply",60029),reply:d("reply",60029),organization:d("organization",60030),organizationFilled:d("organization-filled",60030),organizationOutline:d("organization-outline",60030),newFile:d("new-file",60031),fileAdd:d("file-add",60031),newFolder:d("new-folder",60032),fileDirectoryCreate:d("file-directory-create",60032),trash:d("trash",60033),trashcan:d("trashcan",60033),history:d("history",60034),clock:d("clock",60034),folder:d("folder",60035),fileDirectory:d("file-directory",60035),symbolFolder:d("symbol-folder",60035),logoGithub:d("logo-github",60036),markGithub:d("mark-github",60036),github:d("github",60036),terminal:d("terminal",60037),console:d("console",60037),repl:d("repl",60037),zap:d("zap",60038),symbolEvent:d("symbol-event",60038),error:d("error",60039),stop:d("stop",60039),variable:d("variable",60040),symbolVariable:d("symbol-variable",60040),array:d("array",60042),symbolArray:d("symbol-array",60042),symbolModule:d("symbol-module",60043),symbolPackage:d("symbol-package",60043),symbolNamespace:d("symbol-namespace",60043),symbolObject:d("symbol-object",60043),symbolMethod:d("symbol-method",60044),symbolFunction:d("symbol-function",60044),symbolConstructor:d("symbol-constructor",60044),symbolBoolean:d("symbol-boolean",60047),symbolNull:d("symbol-null",60047),symbolNumeric:d("symbol-numeric",60048),symbolNumber:d("symbol-number",60048),symbolStructure:d("symbol-structure",60049),symbolStruct:d("symbol-struct",60049),symbolParameter:d("symbol-parameter",60050),symbolTypeParameter:d("symbol-type-parameter",60050),symbolKey:d("symbol-key",60051),symbolText:d("symbol-text",60051),symbolReference:d("symbol-reference",60052),goToFile:d("go-to-file",60052),symbolEnum:d("symbol-enum",60053),symbolValue:d("symbol-value",60053),symbolRuler:d("symbol-ruler",60054),symbolUnit:d("symbol-unit",60054),activateBreakpoints:d("activate-breakpoints",60055),archive:d("archive",60056),arrowBoth:d("arrow-both",60057),arrowDown:d("arrow-down",60058),arrowLeft:d("arrow-left",60059),arrowRight:d("arrow-right",60060),arrowSmallDown:d("arrow-small-down",60061),arrowSmallLeft:d("arrow-small-left",60062),arrowSmallRight:d("arrow-small-right",60063),arrowSmallUp:d("arrow-small-up",60064),arrowUp:d("arrow-up",60065),bell:d("bell",60066),bold:d("bold",60067),book:d("book",60068),bookmark:d("bookmark",60069),debugBreakpointConditionalUnverified:d("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:d("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:d("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:d("debug-breakpoint-data-unverified",60072),debugBreakpointData:d("debug-breakpoint-data",60073),debugBreakpointDataDisabled:d("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:d("debug-breakpoint-log-unverified",60074),debugBreakpointLog:d("debug-breakpoint-log",60075),debugBreakpointLogDisabled:d("debug-breakpoint-log-disabled",60075),briefcase:d("briefcase",60076),broadcast:d("broadcast",60077),browser:d("browser",60078),bug:d("bug",60079),calendar:d("calendar",60080),caseSensitive:d("case-sensitive",60081),check:d("check",60082),checklist:d("checklist",60083),chevronDown:d("chevron-down",60084),dropDownButton:d("drop-down-button",60084),chevronLeft:d("chevron-left",60085),chevronRight:d("chevron-right",60086),chevronUp:d("chevron-up",60087),chromeClose:d("chrome-close",60088),chromeMaximize:d("chrome-maximize",60089),chromeMinimize:d("chrome-minimize",60090),chromeRestore:d("chrome-restore",60091),circle:d("circle",60092),circleOutline:d("circle-outline",60092),debugBreakpointUnverified:d("debug-breakpoint-unverified",60092),circleSlash:d("circle-slash",60093),circuitBoard:d("circuit-board",60094),clearAll:d("clear-all",60095),clippy:d("clippy",60096),closeAll:d("close-all",60097),cloudDownload:d("cloud-download",60098),cloudUpload:d("cloud-upload",60099),code:d("code",60100),collapseAll:d("collapse-all",60101),colorMode:d("color-mode",60102),commentDiscussion:d("comment-discussion",60103),compareChanges:d("compare-changes",60157),creditCard:d("credit-card",60105),dash:d("dash",60108),dashboard:d("dashboard",60109),database:d("database",60110),debugContinue:d("debug-continue",60111),debugDisconnect:d("debug-disconnect",60112),debugPause:d("debug-pause",60113),debugRestart:d("debug-restart",60114),debugStart:d("debug-start",60115),debugStepInto:d("debug-step-into",60116),debugStepOut:d("debug-step-out",60117),debugStepOver:d("debug-step-over",60118),debugStop:d("debug-stop",60119),debug:d("debug",60120),deviceCameraVideo:d("device-camera-video",60121),deviceCamera:d("device-camera",60122),deviceMobile:d("device-mobile",60123),diffAdded:d("diff-added",60124),diffIgnored:d("diff-ignored",60125),diffModified:d("diff-modified",60126),diffRemoved:d("diff-removed",60127),diffRenamed:d("diff-renamed",60128),diff:d("diff",60129),discard:d("discard",60130),editorLayout:d("editor-layout",60131),emptyWindow:d("empty-window",60132),exclude:d("exclude",60133),extensions:d("extensions",60134),eyeClosed:d("eye-closed",60135),fileBinary:d("file-binary",60136),fileCode:d("file-code",60137),fileMedia:d("file-media",60138),filePdf:d("file-pdf",60139),fileSubmodule:d("file-submodule",60140),fileSymlinkDirectory:d("file-symlink-directory",60141),fileSymlinkFile:d("file-symlink-file",60142),fileZip:d("file-zip",60143),files:d("files",60144),filter:d("filter",60145),flame:d("flame",60146),foldDown:d("fold-down",60147),foldUp:d("fold-up",60148),fold:d("fold",60149),folderActive:d("folder-active",60150),folderOpened:d("folder-opened",60151),gear:d("gear",60152),gift:d("gift",60153),gistSecret:d("gist-secret",60154),gist:d("gist",60155),gitCommit:d("git-commit",60156),gitCompare:d("git-compare",60157),gitMerge:d("git-merge",60158),githubAction:d("github-action",60159),githubAlt:d("github-alt",60160),globe:d("globe",60161),grabber:d("grabber",60162),graph:d("graph",60163),gripper:d("gripper",60164),heart:d("heart",60165),home:d("home",60166),horizontalRule:d("horizontal-rule",60167),hubot:d("hubot",60168),inbox:d("inbox",60169),issueClosed:d("issue-closed",60324),issueReopened:d("issue-reopened",60171),issues:d("issues",60172),italic:d("italic",60173),jersey:d("jersey",60174),json:d("json",60175),bracket:d("bracket",60175),kebabVertical:d("kebab-vertical",60176),key:d("key",60177),law:d("law",60178),lightbulbAutofix:d("lightbulb-autofix",60179),linkExternal:d("link-external",60180),link:d("link",60181),listOrdered:d("list-ordered",60182),listUnordered:d("list-unordered",60183),liveShare:d("live-share",60184),loading:d("loading",60185),location:d("location",60186),mailRead:d("mail-read",60187),mail:d("mail",60188),markdown:d("markdown",60189),megaphone:d("megaphone",60190),mention:d("mention",60191),milestone:d("milestone",60192),mortarBoard:d("mortar-board",60193),move:d("move",60194),multipleWindows:d("multiple-windows",60195),mute:d("mute",60196),noNewline:d("no-newline",60197),note:d("note",60198),octoface:d("octoface",60199),openPreview:d("open-preview",60200),package_:d("package",60201),paintcan:d("paintcan",60202),pin:d("pin",60203),play:d("play",60204),run:d("run",60204),plug:d("plug",60205),preserveCase:d("preserve-case",60206),preview:d("preview",60207),project:d("project",60208),pulse:d("pulse",60209),question:d("question",60210),quote:d("quote",60211),radioTower:d("radio-tower",60212),reactions:d("reactions",60213),references:d("references",60214),refresh:d("refresh",60215),regex:d("regex",60216),remoteExplorer:d("remote-explorer",60217),remote:d("remote",60218),remove:d("remove",60219),replaceAll:d("replace-all",60220),replace:d("replace",60221),repoClone:d("repo-clone",60222),repoForcePush:d("repo-force-push",60223),repoPull:d("repo-pull",60224),repoPush:d("repo-push",60225),report:d("report",60226),requestChanges:d("request-changes",60227),rocket:d("rocket",60228),rootFolderOpened:d("root-folder-opened",60229),rootFolder:d("root-folder",60230),rss:d("rss",60231),ruby:d("ruby",60232),saveAll:d("save-all",60233),saveAs:d("save-as",60234),save:d("save",60235),screenFull:d("screen-full",60236),screenNormal:d("screen-normal",60237),searchStop:d("search-stop",60238),server:d("server",60240),settingsGear:d("settings-gear",60241),settings:d("settings",60242),shield:d("shield",60243),smiley:d("smiley",60244),sortPrecedence:d("sort-precedence",60245),splitHorizontal:d("split-horizontal",60246),splitVertical:d("split-vertical",60247),squirrel:d("squirrel",60248),starFull:d("star-full",60249),starHalf:d("star-half",60250),symbolClass:d("symbol-class",60251),symbolColor:d("symbol-color",60252),symbolCustomColor:d("symbol-customcolor",60252),symbolConstant:d("symbol-constant",60253),symbolEnumMember:d("symbol-enum-member",60254),symbolField:d("symbol-field",60255),symbolFile:d("symbol-file",60256),symbolInterface:d("symbol-interface",60257),symbolKeyword:d("symbol-keyword",60258),symbolMisc:d("symbol-misc",60259),symbolOperator:d("symbol-operator",60260),symbolProperty:d("symbol-property",60261),wrench:d("wrench",60261),wrenchSubaction:d("wrench-subaction",60261),symbolSnippet:d("symbol-snippet",60262),tasklist:d("tasklist",60263),telescope:d("telescope",60264),textSize:d("text-size",60265),threeBars:d("three-bars",60266),thumbsdown:d("thumbsdown",60267),thumbsup:d("thumbsup",60268),tools:d("tools",60269),triangleDown:d("triangle-down",60270),triangleLeft:d("triangle-left",60271),triangleRight:d("triangle-right",60272),triangleUp:d("triangle-up",60273),twitter:d("twitter",60274),unfold:d("unfold",60275),unlock:d("unlock",60276),unmute:d("unmute",60277),unverified:d("unverified",60278),verified:d("verified",60279),versions:d("versions",60280),vmActive:d("vm-active",60281),vmOutline:d("vm-outline",60282),vmRunning:d("vm-running",60283),watch:d("watch",60284),whitespace:d("whitespace",60285),wholeWord:d("whole-word",60286),window:d("window",60287),wordWrap:d("word-wrap",60288),zoomIn:d("zoom-in",60289),zoomOut:d("zoom-out",60290),listFilter:d("list-filter",60291),listFlat:d("list-flat",60292),listSelection:d("list-selection",60293),selection:d("selection",60293),listTree:d("list-tree",60294),debugBreakpointFunctionUnverified:d("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:d("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:d("debug-breakpoint-function-disabled",60296),debugStackframeActive:d("debug-stackframe-active",60297),circleSmallFilled:d("circle-small-filled",60298),debugStackframeDot:d("debug-stackframe-dot",60298),debugStackframe:d("debug-stackframe",60299),debugStackframeFocused:d("debug-stackframe-focused",60299),debugBreakpointUnsupported:d("debug-breakpoint-unsupported",60300),symbolString:d("symbol-string",60301),debugReverseContinue:d("debug-reverse-continue",60302),debugStepBack:d("debug-step-back",60303),debugRestartFrame:d("debug-restart-frame",60304),callIncoming:d("call-incoming",60306),callOutgoing:d("call-outgoing",60307),menu:d("menu",60308),expandAll:d("expand-all",60309),feedback:d("feedback",60310),groupByRefType:d("group-by-ref-type",60311),ungroupByRefType:d("ungroup-by-ref-type",60312),account:d("account",60313),bellDot:d("bell-dot",60314),debugConsole:d("debug-console",60315),library:d("library",60316),output:d("output",60317),runAll:d("run-all",60318),syncIgnored:d("sync-ignored",60319),pinned:d("pinned",60320),githubInverted:d("github-inverted",60321),debugAlt:d("debug-alt",60305),serverProcess:d("server-process",60322),serverEnvironment:d("server-environment",60323),pass:d("pass",60324),stopCircle:d("stop-circle",60325),playCircle:d("play-circle",60326),record:d("record",60327),debugAltSmall:d("debug-alt-small",60328),vmConnect:d("vm-connect",60329),cloud:d("cloud",60330),merge:d("merge",60331),exportIcon:d("export",60332),graphLeft:d("graph-left",60333),magnet:d("magnet",60334),notebook:d("notebook",60335),redo:d("redo",60336),checkAll:d("check-all",60337),pinnedDirty:d("pinned-dirty",60338),passFilled:d("pass-filled",60339),circleLargeFilled:d("circle-large-filled",60340),circleLarge:d("circle-large",60341),circleLargeOutline:d("circle-large-outline",60341),combine:d("combine",60342),gather:d("gather",60342),table:d("table",60343),variableGroup:d("variable-group",60344),typeHierarchy:d("type-hierarchy",60345),typeHierarchySub:d("type-hierarchy-sub",60346),typeHierarchySuper:d("type-hierarchy-super",60347),gitPullRequestCreate:d("git-pull-request-create",60348),runAbove:d("run-above",60349),runBelow:d("run-below",60350),notebookTemplate:d("notebook-template",60351),debugRerun:d("debug-rerun",60352),workspaceTrusted:d("workspace-trusted",60353),workspaceUntrusted:d("workspace-untrusted",60354),workspaceUnspecified:d("workspace-unspecified",60355),terminalCmd:d("terminal-cmd",60356),terminalDebian:d("terminal-debian",60357),terminalLinux:d("terminal-linux",60358),terminalPowershell:d("terminal-powershell",60359),terminalTmux:d("terminal-tmux",60360),terminalUbuntu:d("terminal-ubuntu",60361),terminalBash:d("terminal-bash",60362),arrowSwap:d("arrow-swap",60363),copy:d("copy",60364),personAdd:d("person-add",60365),filterFilled:d("filter-filled",60366),wand:d("wand",60367),debugLineByLine:d("debug-line-by-line",60368),inspect:d("inspect",60369),layers:d("layers",60370),layersDot:d("layers-dot",60371),layersActive:d("layers-active",60372),compass:d("compass",60373),compassDot:d("compass-dot",60374),compassActive:d("compass-active",60375),azure:d("azure",60376),issueDraft:d("issue-draft",60377),gitPullRequestClosed:d("git-pull-request-closed",60378),gitPullRequestDraft:d("git-pull-request-draft",60379),debugAll:d("debug-all",60380),debugCoverage:d("debug-coverage",60381),runErrors:d("run-errors",60382),folderLibrary:d("folder-library",60383),debugContinueSmall:d("debug-continue-small",60384),beakerStop:d("beaker-stop",60385),graphLine:d("graph-line",60386),graphScatter:d("graph-scatter",60387),pieChart:d("pie-chart",60388),bracketDot:d("bracket-dot",60389),bracketError:d("bracket-error",60390),lockSmall:d("lock-small",60391),azureDevops:d("azure-devops",60392),verifiedFilled:d("verified-filled",60393),newLine:d("newline",60394),layout:d("layout",60395),layoutActivitybarLeft:d("layout-activitybar-left",60396),layoutActivitybarRight:d("layout-activitybar-right",60397),layoutPanelLeft:d("layout-panel-left",60398),layoutPanelCenter:d("layout-panel-center",60399),layoutPanelJustify:d("layout-panel-justify",60400),layoutPanelRight:d("layout-panel-right",60401),layoutPanel:d("layout-panel",60402),layoutSidebarLeft:d("layout-sidebar-left",60403),layoutSidebarRight:d("layout-sidebar-right",60404),layoutStatusbar:d("layout-statusbar",60405),layoutMenubar:d("layout-menubar",60406),layoutCentered:d("layout-centered",60407),layoutSidebarRightOff:d("layout-sidebar-right-off",60416),layoutPanelOff:d("layout-panel-off",60417),layoutSidebarLeftOff:d("layout-sidebar-left-off",60418),target:d("target",60408),indent:d("indent",60409),recordSmall:d("record-small",60410),errorSmall:d("error-small",60411),arrowCircleDown:d("arrow-circle-down",60412),arrowCircleLeft:d("arrow-circle-left",60413),arrowCircleRight:d("arrow-circle-right",60414),arrowCircleUp:d("arrow-circle-up",60415),heartFilled:d("heart-filled",60420),map:d("map",60421),mapFilled:d("map-filled",60422),circleSmall:d("circle-small",60423),bellSlash:d("bell-slash",60424),bellSlashDot:d("bell-slash-dot",60425),commentUnresolved:d("comment-unresolved",60426),gitPullRequestGoToChanges:d("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:d("git-pull-request-new-changes",60428),searchFuzzy:d("search-fuzzy",60429),commentDraft:d("comment-draft",60430),send:d("send",60431),sparkle:d("sparkle",60432),insert:d("insert",60433),dialogError:d("dialog-error","error"),dialogWarning:d("dialog-warning","warning"),dialogInfo:d("dialog-info","info"),dialogClose:d("dialog-close","close"),treeItemExpanded:d("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:d("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:d("tree-filter-on-type-off","list-selection"),treeFilterClear:d("tree-filter-clear","close"),treeItemLoading:d("tree-item-loading","loading"),menuSelection:d("menu-selection","check"),menuSubmenu:d("menu-submenu","chevron-right"),menuBarMore:d("menubar-more","more"),scrollbarButtonLeft:d("scrollbar-button-left","triangle-left"),scrollbarButtonRight:d("scrollbar-button-right","triangle-right"),scrollbarButtonUp:d("scrollbar-button-up","triangle-up"),scrollbarButtonDown:d("scrollbar-button-down","triangle-down"),toolBarMore:d("toolbar-more","more"),quickInputBack:d("quick-input-back","arrow-left")}}),define(De[23],Ie([1,0,14]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const c=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([f,S])=>{c[f]=S&&typeof S=="object"?L(S):S}),c}e.deepClone=L;function d(s){if(!s||typeof s!="object")return s;const c=[s];for(;c.length>0;){const f=c.shift();Object.freeze(f);for(const S in f)if(A.call(f,S)){const I=f[S];typeof I=="object"&&!Object.isFrozen(I)&&!(0,_.isTypedArray)(I)&&c.push(I)}}return s}e.deepFreeze=d;const A=Object.prototype.hasOwnProperty;function T(s,c){return m(s,c,new Set)}e.cloneAndChange=T;function m(s,c,f){if((0,_.isUndefinedOrNull)(s))return s;const S=c(s);if(typeof S<"u")return S;if(Array.isArray(s)){const I=[];for(const i of s)I.push(m(i,c,f));return I}if((0,_.isObject)(s)){if(f.has(s))throw new Error("Cannot clone recursive data-structure");f.add(s);const I={};for(const i in s)A.call(s,i)&&(I[i]=m(s[i],c,f));return f.delete(s),I}return s}function y(s,c,f=!0){return(0,_.isObject)(s)?((0,_.isObject)(c)&&Object.keys(c).forEach(S=>{S in s?f&&((0,_.isObject)(s[S])&&(0,_.isObject)(c[S])?y(s[S],c[S],f):s[S]=c[S]):s[S]=c[S]}),s):c}e.mixin=y;function v(s,c){if(s===c)return!0;if(s==null||c===null||c===void 0||typeof s!=typeof c||typeof s!="object"||Array.isArray(s)!==Array.isArray(c))return!1;let f,S;if(Array.isArray(s)){if(s.length!==c.length)return!1;for(f=0;f<s.length;f++)if(!v(s[f],c[f]))return!1}else{const I=[];for(S in s)I.push(S);I.sort();const i=[];for(S in c)i.push(S);if(i.sort(),!v(I,i))return!1;for(f=0;f<I.length;f++)if(!v(s[I[f]],c[I[f]]))return!1}return!0}e.equals=v;function R(s){const c=new Set;return JSON.stringify(s,(f,S)=>{if((0,_.isObject)(S)||Array.isArray(S)){if(c.has(S))return"[Circular]";c.add(S)}return S})}e.safeStringify=R;function k(s,c){const f=Object.create(null);return!s||!c||Object.keys(c).forEach(I=>{const i=s[I],a=c[I];v(i,a)||(f[I]=a)}),f}e.distinct=k;function p(s,c){const f=c.toLowerCase(),S=Object.keys(s).find(I=>I.toLowerCase()===f);return S?s[S]:s[c]}e.getCaseInsensitive=p;function C(s,c){const f=Object.create(null);for(const[S,I]of Object.entries(s))c(S,I)&&(f[S]=I);return f}e.filter=C;function D(s){let c=[];for(;Object.prototype!==s;)c=c.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return c}e.getAllPropertyNames=D;function b(s){const c=[];for(const f of D(s))typeof s[f]=="function"&&c.push(f);return c}e.getAllMethodNames=b;function r(s,c){const f=I=>function(){const i=Array.prototype.slice.call(arguments,0);return c(I,i)},S={};for(const I of s)S[I]=f(I);return S}e.createProxyObject=r}),define(De[55],Ie([1,0,72]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(T){function m(y){return y&&typeof y=="object"&&typeof y.id=="string"}T.isThemeColor=m})(L||(e.ThemeColor=L={}));function d(T){return{id:T}}e.themeColorFromId=d;var A;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function y(c){const f=m.exec(c.id);if(!f)return y(_.Codicon.error);const[,S,I]=f,i=["codicon","codicon-"+S];return I&&i.push("codicon-modifier-"+I.substring(1)),i}T.asClassNameArray=y;function v(c){return y(c).join(" ")}T.asClassName=v;function R(c){return"."+y(c).join(".")}T.asCSSSelector=R;function k(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||L.isThemeColor(c.color))}T.isThemeIcon=k;const p=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function C(c){const f=p.exec(c);if(!f)return;const[,S]=f;return{id:S}}T.fromString=C;function D(c){return{id:c}}T.fromId=D;function b(c,f){let S=c.id;const I=S.lastIndexOf("~");return I!==-1&&(S=S.substring(0,I)),f&&(S=`${S}~${f}`),{id:S}}T.modify=b;function r(c){const f=c.id.lastIndexOf("~");if(f!==-1)return c.id.substring(f+1)}T.getModifier=r;function s(c,f){return c.id===f.id&&c.color?.id===f.color?.id}T.isEqual=s})(A||(e.ThemeIcon=A={}))}),define(De[155],Ie([1,0,113,12,55]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const A="$(",T=new RegExp(`\\$\\(${d.ThemeIcon.iconNameExpression}(?:${d.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${T.source}`,"g");function y(s){return s.replace(m,(c,f)=>f?c:`\\${c}`)}e.escapeIcons=y;const v=new RegExp(`\\\\${T.source}`,"g");function R(s){return s.replace(v,c=>`\\${c}`)}e.markdownEscapeEscapedIcons=R;const k=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function p(s){return s.indexOf(A)===-1?s:s.replace(k,(c,f,S,I)=>S?c:f||I||"")}e.stripIcons=p;function C(s){return s?s.replace(/\$\((.*?)\)/g,(c,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=C;const D=new RegExp(`\\$\\(${d.ThemeIcon.iconNameCharacter}+\\)`,"g");function b(s){D.lastIndex=0;let c="";const f=[];let S=0;for(;;){const I=D.lastIndex,i=D.exec(s),a=s.substring(I,i?.index);if(a.length>0){c+=a;for(let n=0;n<a.length;n++)f.push(S)}if(!i)break;S+=i[0].length}return{text:c,iconOffsets:f}}e.parseLabelWithIcons=b;function r(s,c,f=!1){const{text:S,iconOffsets:I}=c;if(!I||I.length===0)return(0,_.matchesFuzzy)(s,S,f);const i=(0,L.ltrim)(S," "),a=S.length-i.length,n=(0,_.matchesFuzzy)(s,i,f);if(n)for(const t of n){const o=I[t.start+a]+a;t.start+=o,t.end+=o}return n}e.matchesFuzzyIconAware=r}),define(De[114],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var _;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_||(e.Constants=_={}));function L(A){return A<0?0:A>255?255:A|0}e.toUint8=L;function d(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=d}),define(De[32],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(d){return _.test(d)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let d;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?d=crypto.getRandomValues.bind(crypto):d=function(m){for(let y=0;y<m.length;y++)m[y]=Math.floor(Math.random()*256);return m};const A=new Uint8Array(16),T=[];for(let m=0;m<256;m++)T.push(m.toString(16).padStart(2,"0"));return function(){d(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let y=0,v="";return v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v+="-",v+=T[A[y++]],v+=T[A[y++]],v+="-",v+=T[A[y++]],v+=T[A[y++]],v+="-",v+=T[A[y++]],v+=T[A[y++]],v+="-",v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v}}()}),define(De[156],Ie([1,0,19,48,32]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function A(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.createStringDataTransferItem=A;function T(k,p,C){const D={id:(0,d.generateUuid)(),name:k,uri:p,data:C};return{asString:async()=>"",asFile:()=>D,value:void 0}}e.createFileDataTransferItem=T;class m{constructor(){this._entries=new Map}get size(){let p=0;for(const C of this._entries)p++;return p}has(p){return this._entries.has(this.toKey(p))}matches(p){const C=[...this._entries.keys()];return L.Iterable.some(this,([D,b])=>b.asFile())&&C.push("files"),R(y(p),C)}get(p){return this._entries.get(this.toKey(p))?.[0]}append(p,C){const D=this._entries.get(p);D?D.push(C):this._entries.set(this.toKey(p),[C])}replace(p,C){this._entries.set(this.toKey(p),[C])}delete(p){this._entries.delete(this.toKey(p))}*[Symbol.iterator](){for(const[p,C]of this._entries)for(const D of C)yield[p,D]}toKey(p){return y(p)}}e.VSDataTransfer=m;function y(k){return k.toLowerCase()}function v(k,p){return R(y(k),p.map(y))}e.matchesMimeType=v;function R(k,p){if(k==="*/*")return p.length>0;if(p.includes(k))return!0;const C=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!C)return!1;const[D,b,r]=C;return r==="*"?p.some(s=>s.startsWith(b+"/")):!1}e.UriList=Object.freeze({create:k=>(0,_.distinct)(k.map(p=>p.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.UriList.split(k).filter(p=>!p.startsWith("#"))})}),define(De[115],Ie([1,0,114]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(m){const y=(0,_.toUint8)(m);this._defaultValue=y,this._asciiMap=L._createAsciiMap(y),this._map=new Map}static _createAsciiMap(m){const y=new Uint8Array(256);return y.fill(m),y}set(m,y){const v=(0,_.toUint8)(y);m>=0&&m<256?this._asciiMap[m]=v:this._map.set(m,v)}get(m){return m>=0&&m<256?this._asciiMap[m]:this._map.get(m)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=L;var d;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(d||(d={}));class A{constructor(){this._actual=new L(0)}add(m){this._actual.set(m,1)}has(m){return this._actual.get(m)===1}clear(){return this._actual.clear()}}e.CharacterSet=A}),define(De[56],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(d,A){this.lineNumber=d,this.column=A}with(d=this.lineNumber,A=this.column){return d===this.lineNumber&&A===this.column?this:new _(d,A)}delta(d=0,A=0){return this.with(this.lineNumber+d,this.column+A)}equals(d){return _.equals(this,d)}static equals(d,A){return!d&&!A?!0:!!d&&!!A&&d.lineNumber===A.lineNumber&&d.column===A.column}isBefore(d){return _.isBefore(this,d)}static isBefore(d,A){return d.lineNumber<A.lineNumber?!0:A.lineNumber<d.lineNumber?!1:d.column<A.column}isBeforeOrEqual(d){return _.isBeforeOrEqual(this,d)}static isBeforeOrEqual(d,A){return d.lineNumber<A.lineNumber?!0:A.lineNumber<d.lineNumber?!1:d.column<=A.column}static compare(d,A){const T=d.lineNumber|0,m=A.lineNumber|0;if(T===m){const y=d.column|0,v=A.column|0;return y-v}return T-m}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(d){return new _(d.lineNumber,d.column)}static isIPosition(d){return d&&typeof d.lineNumber=="number"&&typeof d.column=="number"}}e.Position=_}),define(De[33],Ie([1,0,56]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(A,T,m,y){A>m||A===m&&T>y?(this.startLineNumber=m,this.startColumn=y,this.endLineNumber=A,this.endColumn=T):(this.startLineNumber=A,this.startColumn=T,this.endLineNumber=m,this.endColumn=y)}isEmpty(){return L.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return L.containsPosition(this,A)}static containsPosition(A,T){return!(T.lineNumber<A.startLineNumber||T.lineNumber>A.endLineNumber||T.lineNumber===A.startLineNumber&&T.column<A.startColumn||T.lineNumber===A.endLineNumber&&T.column>A.endColumn)}static strictContainsPosition(A,T){return!(T.lineNumber<A.startLineNumber||T.lineNumber>A.endLineNumber||T.lineNumber===A.startLineNumber&&T.column<=A.startColumn||T.lineNumber===A.endLineNumber&&T.column>=A.endColumn)}containsRange(A){return L.containsRange(this,A)}static containsRange(A,T){return!(T.startLineNumber<A.startLineNumber||T.endLineNumber<A.startLineNumber||T.startLineNumber>A.endLineNumber||T.endLineNumber>A.endLineNumber||T.startLineNumber===A.startLineNumber&&T.startColumn<A.startColumn||T.endLineNumber===A.endLineNumber&&T.endColumn>A.endColumn)}strictContainsRange(A){return L.strictContainsRange(this,A)}static strictContainsRange(A,T){return!(T.startLineNumber<A.startLineNumber||T.endLineNumber<A.startLineNumber||T.startLineNumber>A.endLineNumber||T.endLineNumber>A.endLineNumber||T.startLineNumber===A.startLineNumber&&T.startColumn<=A.startColumn||T.endLineNumber===A.endLineNumber&&T.endColumn>=A.endColumn)}plusRange(A){return L.plusRange(this,A)}static plusRange(A,T){let m,y,v,R;return T.startLineNumber<A.startLineNumber?(m=T.startLineNumber,y=T.startColumn):T.startLineNumber===A.startLineNumber?(m=T.startLineNumber,y=Math.min(T.startColumn,A.startColumn)):(m=A.startLineNumber,y=A.startColumn),T.endLineNumber>A.endLineNumber?(v=T.endLineNumber,R=T.endColumn):T.endLineNumber===A.endLineNumber?(v=T.endLineNumber,R=Math.max(T.endColumn,A.endColumn)):(v=A.endLineNumber,R=A.endColumn),new L(m,y,v,R)}intersectRanges(A){return L.intersectRanges(this,A)}static intersectRanges(A,T){let m=A.startLineNumber,y=A.startColumn,v=A.endLineNumber,R=A.endColumn;const k=T.startLineNumber,p=T.startColumn,C=T.endLineNumber,D=T.endColumn;return m<k?(m=k,y=p):m===k&&(y=Math.max(y,p)),v>C?(v=C,R=D):v===C&&(R=Math.min(R,D)),m>v||m===v&&y>R?null:new L(m,y,v,R)}equalsRange(A){return L.equalsRange(this,A)}static equalsRange(A,T){return!A&&!T?!0:!!A&&!!T&&A.startLineNumber===T.startLineNumber&&A.startColumn===T.startColumn&&A.endLineNumber===T.endLineNumber&&A.endColumn===T.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(A){return new _.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(A){return new _.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,T){return new L(this.startLineNumber,this.startColumn,A,T)}setStartPosition(A,T){return new L(A,T,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(A){return new L(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return L.collapseToEnd(this)}static collapseToEnd(A){return new L(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new L(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,T=A){return new L(A.lineNumber,A.column,T.lineNumber,T.column)}static lift(A){return A?new L(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,T){return!(A.endLineNumber<T.startLineNumber||A.endLineNumber===T.startLineNumber&&A.endColumn<T.startColumn||T.endLineNumber<A.startLineNumber||T.endLineNumber===A.startLineNumber&&T.endColumn<A.startColumn)}static areIntersecting(A,T){return!(A.endLineNumber<T.startLineNumber||A.endLineNumber===T.startLineNumber&&A.endColumn<=T.startColumn||T.endLineNumber<A.startLineNumber||T.endLineNumber===A.startLineNumber&&T.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,T){if(A&&T){const v=A.startLineNumber|0,R=T.startLineNumber|0;if(v===R){const k=A.startColumn|0,p=T.startColumn|0;if(k===p){const C=A.endLineNumber|0,D=T.endLineNumber|0;if(C===D){const b=A.endColumn|0,r=T.endColumn|0;return b-r}return C-D}return k-p}return v-R}return(A?1:0)-(T?1:0)}static compareRangesUsingEnds(A,T){return A.endLineNumber===T.endLineNumber?A.endColumn===T.endColumn?A.startLineNumber===T.startLineNumber?A.startColumn-T.startColumn:A.startLineNumber-T.startLineNumber:A.endColumn-T.endColumn:A.endLineNumber-T.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=L}),define(De[157],Ie([1,0,33]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditOperation=void 0;class L{static insert(A,T){return{range:new _.Range(A.lineNumber,A.column,A.lineNumber,A.column),text:T,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,T){return{range:A,text:T}}static replaceMove(A,T){return{range:A,text:T,forceMoveMarkers:!0}}}e.EditOperation=L}),define(De[158],Ie([1,0,56,33]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var d;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(d||(e.SelectionDirection=d={}));class A extends L.Range{constructor(m,y,v,R){super(m,y,v,R),this.selectionStartLineNumber=m,this.selectionStartColumn=y,this.positionLineNumber=v,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return A.selectionsEqual(this,m)}static selectionsEqual(m,y){return m.selectionStartLineNumber===y.selectionStartLineNumber&&m.selectionStartColumn===y.selectionStartColumn&&m.positionLineNumber===y.positionLineNumber&&m.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,y){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,m,y):new A(m,y,this.startLineNumber,this.startColumn)}getPosition(){return new _.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new _.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,y){return this.getDirection()===0?new A(m,y,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,m,y)}static fromPositions(m,y=m){return new A(m.lineNumber,m.column,y.lineNumber,y.column)}static fromRange(m,y){return y===0?new A(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new A(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new A(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,y){if(m&&!y||!m&&y)return!1;if(!m&&!y)return!0;if(m.length!==y.length)return!1;for(let v=0,R=m.length;v<R;v++)if(!this.selectionsEqual(m[v],y[v]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,y,v,R,k){return k===0?new A(m,y,v,R):new A(v,R,m,y)}}e.Selection=A}),define(De[159],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[160],Ie([1,0,115]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(L||(e.WordCharacterClass=L={}));class d extends _.CharacterClassifier{constructor(m){super(0);for(let y=0,v=m.length;y<v;y++)this.set(m.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=d;function A(T){const m={};return y=>(m.hasOwnProperty(y)||(m[y]=T(y)),m[y])}e.getMapForWordSeparators=A(T=>new d(T))}),define(De[116],Ie([1,0,48,4,68]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(k=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)k.indexOf(C)>=0||(p+="\\"+C);return p+="\\s]+)",new RegExp(p,"g")}e.DEFAULT_WORD_REGEXP=A();function T(k){let p=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)p=k;else{let C="g";k.ignoreCase&&(C+="i"),k.multiline&&(C+="m"),k.unicode&&(C+="u"),p=new RegExp(k.source,C)}return p.lastIndex=0,p}e.ensureValidWordDefinition=T;const m=new d.LinkedList;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(k){const p=m.unshift(k);return(0,L.toDisposable)(p)}e.setDefaultGetWordAtTextConfig=y;function v(k,p,C,D,b){if(b||(b=_.Iterable.first(m)),C.length>b.maxLen){let S=k-b.maxLen/2;return S<0?S=0:D+=S,C=C.substring(S,k+b.maxLen/2),v(k,p,C,D,b)}const r=Date.now(),s=k-1-D;let c=-1,f=null;for(let S=1;!(Date.now()-r>=b.timeBudget);S++){const I=s-b.windowSize*S;p.lastIndex=Math.max(0,I);const i=R(p,C,s,c);if(!i&&f||(f=i,I<=0))break;c=I}if(f){const S={word:f[0],startColumn:D+1+f.index,endColumn:D+1+f.index+f[0].length};return p.lastIndex=0,S}return null}e.getWordAtText=v;function R(k,p,C,D){let b;for(;b=k.exec(p);){const r=b.index||0;if(r<=C&&k.lastIndex>=C)return b;if(D>0&&r>D)return null}return null}}),define(De[161],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var _;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(_||(e.IndentAction=_={}));class L{constructor(m){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=m.open,this.close=m.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(m.notIn))for(let y=0,v=m.notIn.length;y<v;y++)switch(m.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(m,y){if(m.getTokenCount()===0)return!0;const v=m.findTokenIndexAtOffset(y-2),R=m.getStandardTokenType(v);return this.isOK(R)}_findNeutralCharacterInRange(m,y){for(let v=m;v<=y;v++){const R=String.fromCharCode(v);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=L;class d{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of m)A(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),A(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),A(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),A(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&A(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=d;function A(T,m,y){T.has(m)?T.get(m).push(y):T.set(m,[y])}}),define(De[162],Ie([1,0,115]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var L;(function(C){C[C.Invalid=0]="Invalid",C[C.Start=1]="Start",C[C.H=2]="H",C[C.HT=3]="HT",C[C.HTT=4]="HTT",C[C.HTTP=5]="HTTP",C[C.F=6]="F",C[C.FI=7]="FI",C[C.FIL=8]="FIL",C[C.BeforeColon=9]="BeforeColon",C[C.AfterColon=10]="AfterColon",C[C.AlmostThere=11]="AlmostThere",C[C.End=12]="End",C[C.Accept=13]="Accept",C[C.LastKnownState=14]="LastKnownState"})(L||(e.State=L={}));class d{constructor(D,b,r){const s=new Uint8Array(D*b);for(let c=0,f=D*b;c<f;c++)s[c]=r;this._data=s,this.rows=D,this.cols=b}get(D,b){return this._data[D*this.cols+b]}set(D,b,r){this._data[D*this.cols+b]=r}}class A{constructor(D){let b=0,r=0;for(let c=0,f=D.length;c<f;c++){const[S,I,i]=D[c];I>b&&(b=I),S>r&&(r=S),i>r&&(r=i)}b++,r++;const s=new d(r,b,0);for(let c=0,f=D.length;c<f;c++){const[S,I,i]=D[c];s.set(S,I,i)}this._states=s,this._maxCharCode=b}nextState(D,b){return b<0||b>=this._maxCharCode?0:this._states.get(D,b)}}e.StateMachine=A;let T=null;function m(){return T===null&&(T=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var y;(function(C){C[C.None=0]="None",C[C.ForceTermination=1]="ForceTermination",C[C.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let v=null;function R(){if(v===null){v=new _.CharacterClassifier(0);const C=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let b=0;b<C.length;b++)v.set(C.charCodeAt(b),1);const D=".,;:";for(let b=0;b<D.length;b++)v.set(D.charCodeAt(b),2)}return v}class k{static _createLink(D,b,r,s,c){let f=c-1;do{const S=b.charCodeAt(f);if(D.get(S)!==2)break;f--}while(f>s);if(s>0){const S=b.charCodeAt(s-1),I=b.charCodeAt(f);(S===40&&I===41||S===91&&I===93||S===123&&I===125)&&f--}return{range:{startLineNumber:r,startColumn:s+1,endLineNumber:r,endColumn:f+2},url:b.substring(s,f+1)}}static computeLinks(D,b=m()){const r=R(),s=[];for(let c=1,f=D.getLineCount();c<=f;c++){const S=D.getLineContent(c),I=S.length;let i=0,a=0,n=0,t=1,o=!1,g=!1,l=!1,h=!1;for(;i<I;){let w=!1;const u=S.charCodeAt(i);if(t===13){let E;switch(u){case 40:o=!0,E=0;break;case 41:E=o?0:1;break;case 91:l=!0,g=!0,E=0;break;case 93:l=!1,E=g?0:1;break;case 123:h=!0,E=0;break;case 125:E=h?0:1;break;case 39:case 34:case 96:n===u?E=1:n===39||n===34||n===96?E=0:E=1;break;case 42:E=n===42?1:0;break;case 124:E=n===124?1:0;break;case 32:E=l?0:1;break;default:E=r.get(u)}E===1&&(s.push(k._createLink(r,S,c,a,i)),w=!0)}else if(t===12){let E;u===91?(g=!0,E=0):E=r.get(u),E===1?w=!0:t=13}else t=b.nextState(t,u),t===0&&(w=!0);w&&(t=1,o=!1,g=!1,h=!1,a=i+1,n=u),i++}t===13&&s.push(k._createLink(r,S,c,a,I))}return s}}e.LinkComputer=k;function p(C){return!C||typeof C.getLineCount!="function"||typeof C.getLineContent!="function"?[]:k.computeLinks(C)}e.computeLinks=p}),define(De[117],Ie([1,0,23]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var L;(function(S){S[S.Left=1]="Left",S[S.Center=2]="Center",S[S.Right=4]="Right",S[S.Full=7]="Full"})(L||(e.OverviewRulerLane=L={}));var d;(function(S){S[S.Left=1]="Left",S[S.Right=2]="Right"})(d||(e.GlyphMarginLane=d={}));var A;(function(S){S[S.Inline=1]="Inline",S[S.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var T;(function(S){S[S.Both=0]="Both",S[S.Right=1]="Right",S[S.Left=2]="Left",S[S.None=3]="None"})(T||(e.InjectedTextCursorStops=T={}));var m;(function(S){S[S.TextDefined=0]="TextDefined",S[S.LF=1]="LF",S[S.CRLF=2]="CRLF"})(m||(e.EndOfLinePreference=m={}));var y;(function(S){S[S.LF=1]="LF",S[S.CRLF=2]="CRLF"})(y||(e.DefaultEndOfLine=y={}));var v;(function(S){S[S.LF=0]="LF",S[S.CRLF=1]="CRLF"})(v||(e.EndOfLineSequence=v={}));class R{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(I){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,I.tabSize|0),I.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,I.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!I.insertSpaces,this.defaultEOL=I.defaultEOL|0,this.trimAutoWhitespace=!!I.trimAutoWhitespace,this.bracketPairColorizationOptions=I.bracketPairColorizationOptions}equals(I){return this.tabSize===I.tabSize&&this._indentSizeIsTabSize===I._indentSizeIsTabSize&&this.indentSize===I.indentSize&&this.insertSpaces===I.insertSpaces&&this.defaultEOL===I.defaultEOL&&this.trimAutoWhitespace===I.trimAutoWhitespace&&(0,_.equals)(this.bracketPairColorizationOptions,I.bracketPairColorizationOptions)}createChangeEvent(I){return{tabSize:this.tabSize!==I.tabSize,indentSize:this.indentSize!==I.indentSize,insertSpaces:this.insertSpaces!==I.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==I.trimAutoWhitespace}}}e.TextModelResolvedOptions=R;class k{constructor(I,i){this._findMatchBrand=void 0,this.range=I,this.matches=i}}e.FindMatch=k;var p;(function(S){S[S.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",S[S.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",S[S.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",S[S.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(p||(e.TrackedRangeStickiness=p={}));function C(S){return S&&typeof S.read=="function"}e.isITextSnapshot=C;var D;(function(S){S[S.Left=0]="Left",S[S.Right=1]="Right",S[S.None=2]="None",S[S.LeftOfInjectedText=3]="LeftOfInjectedText",S[S.RightOfInjectedText=4]="RightOfInjectedText"})(D||(e.PositionAffinity=D={}));var b;(function(S){S[S.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(b||(e.ModelConstants=b={}));class r{constructor(I,i,a,n,t,o){this.identifier=I,this.range=i,this.text=a,this.forceMoveMarkers=n,this.isAutoWhitespaceEdit=t,this._isTracked=o}}e.ValidAnnotatedEditOperation=r;class s{constructor(I,i,a){this.regex=I,this.wordSeparators=i,this.simpleSearch=a}}e.SearchData=s;class c{constructor(I,i,a){this.reverseEdits=I,this.changes=i,this.trimAutoWhitespaceLineNumbers=a}}e.ApplyEditsResult=c;function f(S){return!S.isTooLargeForSyncing()&&!S.isForSimpleWidget}e.shouldSynchronizeModel=f}),define(De[163],Ie([1,0,19,114]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class d{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,v){y=(0,L.toUint32)(y);const R=this.values,k=this.prefixSum,p=v.length;return p===0?!1:(this.values=new Uint32Array(R.length+p),this.values.set(R.subarray(0,y),0),this.values.set(R.subarray(y),y+p),this.values.set(v,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(y,v){return y=(0,L.toUint32)(y),v=(0,L.toUint32)(v),this.values[y]===v?!1:(this.values[y]=v,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,v){y=(0,L.toUint32)(y),v=(0,L.toUint32)(v);const R=this.values,k=this.prefixSum;if(y>=R.length)return!1;const p=R.length-y;return v>=p&&(v=p),v===0?!1:(this.values=new Uint32Array(R.length-v),this.values.set(R.subarray(0,y),0),this.values.set(R.subarray(y+v),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(y){return y<0?0:(y=(0,L.toUint32)(y),this._getPrefixSum(y))}_getPrefixSum(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let v=this.prefixSumValidIndex[0]+1;v===0&&(this.prefixSum[0]=this.values[0],v++),y>=this.values.length&&(y=this.values.length-1);for(let R=v;R<=y;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let v=0,R=this.values.length-1,k=0,p=0,C=0;for(;v<=R;)if(k=v+(R-v)/2|0,p=this.prefixSum[k],C=p-this.values[k],y<C)R=k-1;else if(y>=p)v=k+1;else break;return new T(k,y-C)}}e.PrefixSumComputer=d;class A{constructor(y){this._values=y,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(y){return this._ensureValid(),y===0?0:this._prefixSum[y-1]}getIndexOf(y){this._ensureValid();const v=this._indexBySum[y],R=v>0?this._prefixSum[v-1]:0;return new T(v,y-R)}removeValues(y,v){this._values.splice(y,v),this._invalidate(y)}insertValues(y,v){this._values=(0,_.arrayInsert)(this._values,y,v),this._invalidate(y)}_invalidate(y){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,y-1)}_ensureValid(){if(!this._isValid){for(let y=this._validEndIndex+1,v=this._values.length;y<v;y++){const R=this._values[y],k=y>0?this._prefixSum[y-1]:0;this._prefixSum[y]=k+R;for(let p=0;p<R;p++)this._indexBySum[k+p]=y}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(y,v){this._values[y]!==v&&(this._values[y]=v,this._invalidate(y))}}e.ConstantTimePrefixSumComputer=A;class T{constructor(y,v){this.index=y,this.remainder=v,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=v}}e.PrefixSumIndexOfResult=T}),define(De[164],Ie([1,0,12,56,163]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(m,y,v,R){this._uri=m,this._lines=y,this._eol=v,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(m){m.eol&&m.eol!==this._eol&&(this._eol=m.eol,this._lineStarts=null);const y=m.changes;for(const v of y)this._acceptDeleteRange(v.range),this._acceptInsertText(new L.Position(v.range.startLineNumber,v.range.startColumn),v.text);this._versionId=m.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const m=this._eol.length,y=this._lines.length,v=new Uint32Array(y);for(let R=0;R<y;R++)v[R]=this._lines[R].length+m;this._lineStarts=new d.PrefixSumComputer(v)}}_setLineText(m,y){this._lines[m]=y,this._lineStarts&&this._lineStarts.setValue(m,this._lines[m].length+this._eol.length)}_acceptDeleteRange(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this._setLineText(m.startLineNumber-1,this._lines[m.startLineNumber-1].substring(0,m.startColumn-1)+this._lines[m.startLineNumber-1].substring(m.endColumn-1));return}this._setLineText(m.startLineNumber-1,this._lines[m.startLineNumber-1].substring(0,m.startColumn-1)+this._lines[m.endLineNumber-1].substring(m.endColumn-1)),this._lines.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}_acceptInsertText(m,y){if(y.length===0)return;const v=(0,_.splitLines)(y);if(v.length===1){this._setLineText(m.lineNumber-1,this._lines[m.lineNumber-1].substring(0,m.column-1)+v[0]+this._lines[m.lineNumber-1].substring(m.column-1));return}v[v.length-1]+=this._lines[m.lineNumber-1].substring(m.column-1),this._setLineText(m.lineNumber-1,this._lines[m.lineNumber-1].substring(0,m.column-1)+v[0]);const R=new Uint32Array(v.length-1);for(let k=1;k<v.length;k++)this._lines.splice(m.lineNumber+k-1,0,v[k]),R[k-1]=v[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(m.lineNumber,R)}}e.MirrorTextModel=A}),define(De[165],Ie([1,0,12,160,56,33,117]),function(me,e,_,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const m=999;class y{constructor(c,f,S,I){this.searchString=c,this.isRegex=f,this.matchCase=S,this.wordSeparators=I}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=v(this.searchString):c=this.searchString.indexOf(`
`)>=0;let f=null;try{f=_.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch{return null}if(!f)return null;let S=!this.isRegex&&!c;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new T.SearchData(f,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}e.SearchParams=y;function v(s){if(!s||s.length===0)return!1;for(let c=0,f=s.length;c<f;c++){const S=s.charCodeAt(c);if(S===10)return!0;if(S===92){if(c++,c>=f)break;const I=s.charCodeAt(c);if(I===110||I===114||I===87)return!0}}return!1}e.isMultilineRegexSource=v;function R(s,c,f){if(!f)return new T.FindMatch(s,null);const S=[];for(let I=0,i=c.length;I<i;I++)S[I]=c[I];return new T.FindMatch(s,S)}e.createFindMatch=R;class k{constructor(c){const f=[];let S=0;for(let I=0,i=c.length;I<i;I++)c.charCodeAt(I)===10&&(f[S++]=I);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(c){const f=this._lineFeedsOffsets;let S=0,I=f.length-1;if(I===-1||c<=f[0])return 0;for(;S<I;){const i=S+((I-S)/2>>0);f[i]>=c?I=i-1:f[i+1]>=c?(S=i,I=i):S=i+1}return S+1}}class p{static findMatches(c,f,S,I,i){const a=f.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(c,S,new r(a.wordSeparators,a.regex),I,i):this._doFindMatchesLineByLine(c,S,a,I,i):[]}static _getMultilineMatchRange(c,f,S,I,i,a){let n,t=0;I?(t=I.findLineFeedCountBeforeOffset(i),n=f+i+t):n=f+i;let o;if(I){const w=I.findLineFeedCountBeforeOffset(i+a.length)-t;o=n+a.length+w}else o=n+a.length;const g=c.getPositionAt(n),l=c.getPositionAt(o);return new A.Range(g.lineNumber,g.column,l.lineNumber,l.column)}static _doFindMatchesMultiline(c,f,S,I,i){const a=c.getOffsetAt(f.getStartPosition()),n=c.getValueInRange(f,1),t=c.getEOL()===`\r
`?new k(n):null,o=[];let g=0,l;for(S.reset(0);l=S.next(n);)if(o[g++]=R(this._getMultilineMatchRange(c,a,n,t,l.index,l[0]),l,I),g>=i)return o;return o}static _doFindMatchesLineByLine(c,f,S,I,i){const a=[];let n=0;if(f.startLineNumber===f.endLineNumber){const o=c.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return n=this._findMatchesInLine(S,o,f.startLineNumber,f.startColumn-1,n,a,I,i),a}const t=c.getLineContent(f.startLineNumber).substring(f.startColumn-1);n=this._findMatchesInLine(S,t,f.startLineNumber,f.startColumn-1,n,a,I,i);for(let o=f.startLineNumber+1;o<f.endLineNumber&&n<i;o++)n=this._findMatchesInLine(S,c.getLineContent(o),o,0,n,a,I,i);if(n<i){const o=c.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);n=this._findMatchesInLine(S,o,f.endLineNumber,0,n,a,I,i)}return a}static _findMatchesInLine(c,f,S,I,i,a,n,t){const o=c.wordSeparators;if(!n&&c.simpleSearch){const h=c.simpleSearch,w=h.length,u=f.length;let E=-w;for(;(E=f.indexOf(h,E+w))!==-1;)if((!o||b(o,f,u,E,w))&&(a[i++]=new T.FindMatch(new A.Range(S,E+1+I,S,E+1+w+I),null),i>=t))return i;return i}const g=new r(c.wordSeparators,c.regex);let l;g.reset(0);do if(l=g.next(f),l&&(a[i++]=R(new A.Range(S,l.index+1+I,S,l.index+1+l[0].length+I),l,n),i>=t))return i;while(l);return i}static findNextMatch(c,f,S,I){const i=f.parseSearchRequest();if(!i)return null;const a=new r(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(c,S,a,I):this._doFindNextMatchLineByLine(c,S,a,I)}static _doFindNextMatchMultiline(c,f,S,I){const i=new d.Position(f.lineNumber,1),a=c.getOffsetAt(i),n=c.getLineCount(),t=c.getValueInRange(new A.Range(i.lineNumber,i.column,n,c.getLineMaxColumn(n)),1),o=c.getEOL()===`\r
`?new k(t):null;S.reset(f.column-1);const g=S.next(t);return g?R(this._getMultilineMatchRange(c,a,t,o,g.index,g[0]),g,I):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(c,new d.Position(1,1),S,I):null}static _doFindNextMatchLineByLine(c,f,S,I){const i=c.getLineCount(),a=f.lineNumber,n=c.getLineContent(a),t=this._findFirstMatchInLine(S,n,a,f.column,I);if(t)return t;for(let o=1;o<=i;o++){const g=(a+o-1)%i,l=c.getLineContent(g+1),h=this._findFirstMatchInLine(S,l,g+1,1,I);if(h)return h}return null}static _findFirstMatchInLine(c,f,S,I,i){c.reset(I-1);const a=c.next(f);return a?R(new A.Range(S,a.index+1,S,a.index+1+a[0].length),a,i):null}static findPreviousMatch(c,f,S,I){const i=f.parseSearchRequest();if(!i)return null;const a=new r(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(c,S,a,I):this._doFindPreviousMatchLineByLine(c,S,a,I)}static _doFindPreviousMatchMultiline(c,f,S,I){const i=this._doFindMatchesMultiline(c,new A.Range(1,1,f.lineNumber,f.column),S,I,10*m);if(i.length>0)return i[i.length-1];const a=c.getLineCount();return f.lineNumber!==a||f.column!==c.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(c,new d.Position(a,c.getLineMaxColumn(a)),S,I):null}static _doFindPreviousMatchLineByLine(c,f,S,I){const i=c.getLineCount(),a=f.lineNumber,n=c.getLineContent(a).substring(0,f.column-1),t=this._findLastMatchInLine(S,n,a,I);if(t)return t;for(let o=1;o<=i;o++){const g=(i+a-o-1)%i,l=c.getLineContent(g+1),h=this._findLastMatchInLine(S,l,g+1,I);if(h)return h}return null}static _findLastMatchInLine(c,f,S,I){let i=null,a;for(c.reset(0);a=c.next(f);)i=R(new A.Range(S,a.index+1,S,a.index+1+a[0].length),a,I);return i}}e.TextModelSearch=p;function C(s,c,f,S,I){if(S===0)return!0;const i=c.charCodeAt(S-1);if(s.get(i)!==0||i===13||i===10)return!0;if(I>0){const a=c.charCodeAt(S);if(s.get(a)!==0)return!0}return!1}function D(s,c,f,S,I){if(S+I===f)return!0;const i=c.charCodeAt(S+I);if(s.get(i)!==0||i===13||i===10)return!0;if(I>0){const a=c.charCodeAt(S+I-1);if(s.get(a)!==0)return!0}return!1}function b(s,c,f,S,I){return C(s,c,f,S,I)&&D(s,c,f,S,I)}e.isValidMatch=b;class r{constructor(c,f){this._wordSeparators=c,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const f=c.length;let S;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(S=this._searchRegex.exec(c),!S))return null;const I=S.index,i=S[0].length;if(I===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){_.getNextCodePoint(c,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=I,this._prevMatchLength=i,!this._wordSeparators||b(this._wordSeparators,c,f,I,i))return S}while(S);return null}}e.Searcher=r}),define(De[166],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class _{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(A){if(A&&this._dragOperations.has(A)){const T=this._dragOperations.get(A);return this._dragOperations.delete(A),T}}addDragOperationTransfer(A,T){this._dragOperations.set(A,T)}}e.TreeViewsDnDService=_;class L{constructor(A){this.identifier=A}}e.DraggedTreeItemsIdentifier=L}),define(De[167],Ie([1,0,3,4]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class d{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(m){this._onDidChange.fire({changedLanguages:m,changedColorMap:!1})}register(m,y){return this._tokenizationSupports.set(m,y),this.handleChange([m]),(0,L.toDisposable)(()=>{this._tokenizationSupports.get(m)===y&&(this._tokenizationSupports.delete(m),this.handleChange([m]))})}get(m){return this._tokenizationSupports.get(m)||null}registerFactory(m,y){this._factories.get(m)?.dispose();const v=new A(this,m,y);return this._factories.set(m,v),(0,L.toDisposable)(()=>{const R=this._factories.get(m);!R||R!==v||(this._factories.delete(m),R.dispose())})}async getOrCreate(m){const y=this.get(m);if(y)return y;const v=this._factories.get(m);return!v||v.isResolved?null:(await v.resolve(),this.get(m))}isResolved(m){if(this.get(m))return!0;const v=this._factories.get(m);return!!(!v||v.isResolved)}setColorMap(m){this._colorMap=m,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=d;class A extends L.Disposable{get isResolved(){return this._isResolved}constructor(m,y,v){super(),this._registry=m,this._languageId=y,this._factory=v,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const m=await this._factory.tokenizationSupport;this._isResolved=!0,m&&!this._isDisposed&&this._register(this._registry.register(this._languageId,m))}}}),define(De[168],Ie([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(De[169],Ie([1,0,3,4,168]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class A extends L.Disposable{constructor(p,C="",D="",b=!0,r){super(),this._onDidChange=this._register(new _.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=p,this._label=C,this._cssClass=D,this._enabled=b,this._actionCallback=r}get id(){return this._id}get label(){return this._label}set label(p){this._setLabel(p)}_setLabel(p){this._label!==p&&(this._label=p,this._onDidChange.fire({label:p}))}get tooltip(){return this._tooltip||""}set tooltip(p){this._setTooltip(p)}_setTooltip(p){this._tooltip!==p&&(this._tooltip=p,this._onDidChange.fire({tooltip:p}))}get class(){return this._cssClass}set class(p){this._setClass(p)}_setClass(p){this._cssClass!==p&&(this._cssClass=p,this._onDidChange.fire({class:p}))}get enabled(){return this._enabled}set enabled(p){this._setEnabled(p)}_setEnabled(p){this._enabled!==p&&(this._enabled=p,this._onDidChange.fire({enabled:p}))}get checked(){return this._checked}set checked(p){this._setChecked(p)}_setChecked(p){this._checked!==p&&(this._checked=p,this._onDidChange.fire({checked:p}))}async run(p,C){this._actionCallback&&await this._actionCallback(p)}}e.Action=A;class T extends L.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new _.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new _.Emitter),this.onDidRun=this._onDidRun.event}async run(p,C){if(!p.enabled)return;this._onWillRun.fire({action:p});let D;try{await this.runAction(p,C)}catch(b){D=b}this._onDidRun.fire({action:p,error:D})}async runAction(p,C){await p.run(C)}}e.ActionRunner=T;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let C=[];for(const D of p)D.length&&(C.length?C=[...C,new m,...D]:C=D);return C}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=m;class y{get actions(){return this._actions}constructor(p,C,D,b){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=C,this.class=b,this._actions=D}async run(){}}e.SubmenuAction=y;class v extends A{static{this.ID="vs.actions.empty"}constructor(){super(v.ID,d.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=v;function R(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async()=>k.run(),tooltip:k.label}}e.toAction=R}),define(De[170],Ie([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(De[171],Ie([1,0,170]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,d=L*60,A=d*24,T=A*7,m=A*30,y=A*365;function v(k,p,C,D){typeof k!="number"&&(k=k.getTime());const b=Math.round((new Date().getTime()-k)/1e3);if(b<-30)return(0,_.localize)(0,null,v(new Date().getTime()+b*1e3,!1));if(!D&&b<30)return(0,_.localize)(1,null);let r;return b<L?(r=b,p?r===1?C?(0,_.localize)(2,null,r):(0,_.localize)(3,null,r):C?(0,_.localize)(4,null,r):(0,_.localize)(5,null,r):r===1?C?(0,_.localize)(6,null,r):(0,_.localize)(7,null,r):C?(0,_.localize)(8,null,r):(0,_.localize)(9,null,r)):b<d?(r=Math.floor(b/L),p?r===1?C?(0,_.localize)(10,null,r):(0,_.localize)(11,null,r):C?(0,_.localize)(12,null,r):(0,_.localize)(13,null,r):r===1?C?(0,_.localize)(14,null,r):(0,_.localize)(15,null,r):C?(0,_.localize)(16,null,r):(0,_.localize)(17,null,r)):b<A?(r=Math.floor(b/d),p?r===1?C?(0,_.localize)(18,null,r):(0,_.localize)(19,null,r):C?(0,_.localize)(20,null,r):(0,_.localize)(21,null,r):r===1?C?(0,_.localize)(22,null,r):(0,_.localize)(23,null,r):C?(0,_.localize)(24,null,r):(0,_.localize)(25,null,r)):b<T?(r=Math.floor(b/A),p?r===1?(0,_.localize)(26,null,r):(0,_.localize)(27,null,r):r===1?(0,_.localize)(28,null,r):(0,_.localize)(29,null,r)):b<m?(r=Math.floor(b/T),p?r===1?C?(0,_.localize)(30,null,r):(0,_.localize)(31,null,r):C?(0,_.localize)(32,null,r):(0,_.localize)(33,null,r):r===1?C?(0,_.localize)(34,null,r):(0,_.localize)(35,null,r):C?(0,_.localize)(36,null,r):(0,_.localize)(37,null,r)):b<y?(r=Math.floor(b/m),p?r===1?C?(0,_.localize)(38,null,r):(0,_.localize)(39,null,r):C?(0,_.localize)(40,null,r):(0,_.localize)(41,null,r):r===1?C?(0,_.localize)(42,null,r):(0,_.localize)(43,null,r):C?(0,_.localize)(44,null,r):(0,_.localize)(45,null,r)):(r=Math.floor(b/y),p?r===1?C?(0,_.localize)(46,null,r):(0,_.localize)(47,null,r):C?(0,_.localize)(48,null,r):(0,_.localize)(49,null,r):r===1?C?(0,_.localize)(50,null,r):(0,_.localize)(51,null,r):C?(0,_.localize)(52,null,r):(0,_.localize)(53,null,r))}e.fromNow=v;function R(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(De[172],Ie([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(De[45],Ie([1,0,19,14,172]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(k,p){return p&&(k.stack||k.stacktrace)?d.localize(0,null,m(k),T(k.stack)||T(k.stacktrace)):m(k)}function T(k){return Array.isArray(k)?k.join(`
`):k}function m(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?d.localize(1,null,k.message):k.message||d.localize(2,null)}function y(k=null,p=!1){if(!k)return d.localize(3,null);if(Array.isArray(k)){const C=_.coalesce(k),D=y(C[0],p);return C.length>1?d.localize(4,null,D,C.length):D}if(L.isString(k))return k;if(k.detail){const C=k.detail;if(C.error)return A(C.error,p);if(C.exception)return A(C.exception,p)}return k.stack?A(k,p):k.message?k.message:d.localize(5,null)}e.toErrorMessage=y;function v(k){const p=k;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=v;function R(k,p){let C;return typeof k=="string"?C=new Error(k):C=k,C.actions=p,C}e.createErrorWithActions=R}),define(De[173],Ie([9,10]),function(me,e){return me.create("vs/base/common/platform",e)}),define(De[11],Ie([1,0,173]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,d=!1,A=!1,T=!1,m=!1,y=!1,v=!1,R=!1,k=!1,p=!1,C,D=e.LANGUAGE_DEFAULT,b=e.LANGUAGE_DEFAULT,r,s;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?c=e.globals.vscode.process:typeof process<"u"&&(c=process);const f=typeof c?.versions?.electron=="string",S=f&&c?.type==="renderer";if(typeof navigator=="object"&&!S)s=navigator.userAgent,L=s.indexOf("Windows")>=0,d=s.indexOf("Macintosh")>=0,R=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=s.indexOf("Linux")>=0,p=s?.indexOf("Mobi")>=0,y=!0,C=_.getConfiguredDefaultLocale(_.localize(0,null))||e.LANGUAGE_DEFAULT,D=C,b=navigator.language;else if(typeof c=="object"){L=c.platform==="win32",d=c.platform==="darwin",A=c.platform==="linux",T=A&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,v=f,k=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=e.LANGUAGE_DEFAULT,D=e.LANGUAGE_DEFAULT;const h=c.env.VSCODE_NLS_CONFIG;if(h)try{const w=JSON.parse(h),u=w.availableLanguages["*"];C=w.locale,b=w.osLocale,D=u||e.LANGUAGE_DEFAULT,r=w._translationsConfigFile}catch{}m=!0}else console.error("Unable to resolve platform.");var I;(function(h){h[h.Web=0]="Web",h[h.Mac=1]="Mac",h[h.Linux=2]="Linux",h[h.Windows=3]="Windows"})(I||(e.Platform=I={}));function i(h){switch(h){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=i;let a=0;d?a=1:L?a=3:A&&(a=2),e.isWindows=L,e.isMacintosh=d,e.isLinux=A,e.isLinuxSnap=T,e.isNative=m,e.isElectron=v,e.isWeb=y,e.isWebWorker=y&&typeof e.globals.importScripts=="function",e.isIOS=R,e.isMobile=p,e.isCI=k,e.platform=a,e.userAgent=s,e.language=D;var n;(function(h){function w(){return e.language}h.value=w;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}h.isDefaultVariant=u;function E(){return e.language==="en"}h.isDefault=E})(n||(e.Language=n={})),e.locale=C,e.platformLocale=b,e.translationsConfigFile=r,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const h=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let E=0,P=h.length;E<P;E++){const O=h[E];if(O.id===u.data.vscodeScheduleAsyncWork){h.splice(E,1),O.callback();return}}});let w=0;return u=>{const E=++w;h.push({id:E,callback:u}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return h=>setTimeout(h)})();var t;(function(h){h[h.Windows=1]="Windows",h[h.Macintosh=2]="Macintosh",h[h.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=d||R?2:L?1:3;let o=!0,g=!1;function l(){if(!g){g=!0;const h=new Uint8Array(2);h[0]=1,h[1]=2,o=new Uint16Array(h.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[41],Ie([1,0,11]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof _.globals.vscode<"u"&&typeof _.globals.vscode.process<"u"){const d=_.globals.vscode.process;L={get platform(){return d.platform},get arch(){return d.arch},get env(){return d.env},cwd(){return d.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(De[13],Ie([1,0,41]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,d=97,A=90,T=122,m=46,y=47,v=92,R=58,k=63;class p extends Error{constructor(a,n,t){let o;typeof n=="string"&&n.indexOf("not ")===0?(o="must not be",n=n.replace(/^not /,"")):o="must be";const g=a.indexOf(".")!==-1?"property":"argument";let l=`The "${a}" ${g} ${o} of type ${n}`;l+=`. Received type ${typeof t}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function C(i,a){if(i===null||typeof i!="object")throw new p(a,"Object",i)}function D(i,a){if(typeof i!="string")throw new p(a,"string",i)}const b=_.platform==="win32";function r(i){return i===y||i===v}function s(i){return i===y}function c(i){return i>=L&&i<=A||i>=d&&i<=T}function f(i,a,n,t){let o="",g=0,l=-1,h=0,w=0;for(let u=0;u<=i.length;++u){if(u<i.length)w=i.charCodeAt(u);else{if(t(w))break;w=y}if(t(w)){if(!(l===u-1||h===1))if(h===2){if(o.length<2||g!==2||o.charCodeAt(o.length-1)!==m||o.charCodeAt(o.length-2)!==m){if(o.length>2){const E=o.lastIndexOf(n);E===-1?(o="",g=0):(o=o.slice(0,E),g=o.length-1-o.lastIndexOf(n)),l=u,h=0;continue}else if(o.length!==0){o="",g=0,l=u,h=0;continue}}a&&(o+=o.length>0?`${n}..`:"..",g=2)}else o.length>0?o+=`${n}${i.slice(l+1,u)}`:o=i.slice(l+1,u),g=u-l-1;l=u,h=0}else w===m&&h!==-1?++h:h=-1}return o}function S(i,a){C(a,"pathObject");const n=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return n?n===a.root?`${n}${t}`:`${n}${i}${t}`:t}e.win32={resolve(...i){let a="",n="",t=!1;for(let o=i.length-1;o>=-1;o--){let g;if(o>=0){if(g=i[o],D(g,"path"),g.length===0)continue}else a.length===0?g=_.cwd():(g=_.env[`=${a}`]||_.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==a.toLowerCase()&&g.charCodeAt(2)===v)&&(g=`${a}\\`));const l=g.length;let h=0,w="",u=!1;const E=g.charCodeAt(0);if(l===1)r(E)&&(h=1,u=!0);else if(r(E))if(u=!0,r(g.charCodeAt(1))){let P=2,O=P;for(;P<l&&!r(g.charCodeAt(P));)P++;if(P<l&&P!==O){const N=g.slice(O,P);for(O=P;P<l&&r(g.charCodeAt(P));)P++;if(P<l&&P!==O){for(O=P;P<l&&!r(g.charCodeAt(P));)P++;(P===l||P!==O)&&(w=`\\\\${N}\\${g.slice(O,P)}`,h=P)}}}else h=1;else c(E)&&g.charCodeAt(1)===R&&(w=g.slice(0,2),h=2,l>2&&r(g.charCodeAt(2))&&(u=!0,h=3));if(w.length>0)if(a.length>0){if(w.toLowerCase()!==a.toLowerCase())continue}else a=w;if(t){if(a.length>0)break}else if(n=`${g.slice(h)}\\${n}`,t=u,u&&a.length>0)break}return n=f(n,!t,"\\",r),t?`${a}\\${n}`:`${a}${n}`||"."},normalize(i){D(i,"path");const a=i.length;if(a===0)return".";let n=0,t,o=!1;const g=i.charCodeAt(0);if(a===1)return s(g)?"\\":i;if(r(g))if(o=!0,r(i.charCodeAt(1))){let h=2,w=h;for(;h<a&&!r(i.charCodeAt(h));)h++;if(h<a&&h!==w){const u=i.slice(w,h);for(w=h;h<a&&r(i.charCodeAt(h));)h++;if(h<a&&h!==w){for(w=h;h<a&&!r(i.charCodeAt(h));)h++;if(h===a)return`\\\\${u}\\${i.slice(w)}\\`;h!==w&&(t=`\\\\${u}\\${i.slice(w,h)}`,n=h)}}}else n=1;else c(g)&&i.charCodeAt(1)===R&&(t=i.slice(0,2),n=2,a>2&&r(i.charCodeAt(2))&&(o=!0,n=3));let l=n<a?f(i.slice(n),!o,"\\",r):"";return l.length===0&&!o&&(l="."),l.length>0&&r(i.charCodeAt(a-1))&&(l+="\\"),t===void 0?o?`\\${l}`:l:o?`${t}\\${l}`:`${t}${l}`},isAbsolute(i){D(i,"path");const a=i.length;if(a===0)return!1;const n=i.charCodeAt(0);return r(n)||a>2&&c(n)&&i.charCodeAt(1)===R&&r(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,n;for(let g=0;g<i.length;++g){const l=i[g];D(l,"path"),l.length>0&&(a===void 0?a=n=l:a+=`\\${l}`)}if(a===void 0)return".";let t=!0,o=0;if(typeof n=="string"&&r(n.charCodeAt(0))){++o;const g=n.length;g>1&&r(n.charCodeAt(1))&&(++o,g>2&&(r(n.charCodeAt(2))?++o:t=!1))}if(t){for(;o<a.length&&r(a.charCodeAt(o));)o++;o>=2&&(a=`\\${a.slice(o)}`)}return e.win32.normalize(a)},relative(i,a){if(D(i,"from"),D(a,"to"),i===a)return"";const n=e.win32.resolve(i),t=e.win32.resolve(a);if(n===t||(i=n.toLowerCase(),a=t.toLowerCase(),i===a))return"";let o=0;for(;o<i.length&&i.charCodeAt(o)===v;)o++;let g=i.length;for(;g-1>o&&i.charCodeAt(g-1)===v;)g--;const l=g-o;let h=0;for(;h<a.length&&a.charCodeAt(h)===v;)h++;let w=a.length;for(;w-1>h&&a.charCodeAt(w-1)===v;)w--;const u=w-h,E=l<u?l:u;let P=-1,O=0;for(;O<E;O++){const F=i.charCodeAt(o+O);if(F!==a.charCodeAt(h+O))break;F===v&&(P=O)}if(O!==E){if(P===-1)return t}else{if(u>E){if(a.charCodeAt(h+O)===v)return t.slice(h+O+1);if(O===2)return t.slice(h+O)}l>E&&(i.charCodeAt(o+O)===v?P=O:O===2&&(P=3)),P===-1&&(P=0)}let N="";for(O=o+P+1;O<=g;++O)(O===g||i.charCodeAt(O)===v)&&(N+=N.length===0?"..":"\\..");return h+=P,N.length>0?`${N}${t.slice(h,w)}`:(t.charCodeAt(h)===v&&++h,t.slice(h,w))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const a=e.win32.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===v){if(a.charCodeAt(1)===v){const n=a.charCodeAt(2);if(n!==k&&n!==m)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(c(a.charCodeAt(0))&&a.charCodeAt(1)===R&&a.charCodeAt(2)===v)return`\\\\?\\${a}`;return i},dirname(i){D(i,"path");const a=i.length;if(a===0)return".";let n=-1,t=0;const o=i.charCodeAt(0);if(a===1)return r(o)?i:".";if(r(o)){if(n=t=1,r(i.charCodeAt(1))){let h=2,w=h;for(;h<a&&!r(i.charCodeAt(h));)h++;if(h<a&&h!==w){for(w=h;h<a&&r(i.charCodeAt(h));)h++;if(h<a&&h!==w){for(w=h;h<a&&!r(i.charCodeAt(h));)h++;if(h===a)return i;h!==w&&(n=t=h+1)}}}}else c(o)&&i.charCodeAt(1)===R&&(n=a>2&&r(i.charCodeAt(2))?3:2,t=n);let g=-1,l=!0;for(let h=a-1;h>=t;--h)if(r(i.charCodeAt(h))){if(!l){g=h;break}}else l=!1;if(g===-1){if(n===-1)return".";g=n}return i.slice(0,g)},basename(i,a){a!==void 0&&D(a,"ext"),D(i,"path");let n=0,t=-1,o=!0,g;if(i.length>=2&&c(i.charCodeAt(0))&&i.charCodeAt(1)===R&&(n=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let l=a.length-1,h=-1;for(g=i.length-1;g>=n;--g){const w=i.charCodeAt(g);if(r(w)){if(!o){n=g+1;break}}else h===-1&&(o=!1,h=g+1),l>=0&&(w===a.charCodeAt(l)?--l===-1&&(t=g):(l=-1,t=h))}return n===t?t=h:t===-1&&(t=i.length),i.slice(n,t)}for(g=i.length-1;g>=n;--g)if(r(i.charCodeAt(g))){if(!o){n=g+1;break}}else t===-1&&(o=!1,t=g+1);return t===-1?"":i.slice(n,t)},extname(i){D(i,"path");let a=0,n=-1,t=0,o=-1,g=!0,l=0;i.length>=2&&i.charCodeAt(1)===R&&c(i.charCodeAt(0))&&(a=t=2);for(let h=i.length-1;h>=a;--h){const w=i.charCodeAt(h);if(r(w)){if(!g){t=h+1;break}continue}o===-1&&(g=!1,o=h+1),w===m?n===-1?n=h:l!==1&&(l=1):n!==-1&&(l=-1)}return n===-1||o===-1||l===0||l===1&&n===o-1&&n===t+1?"":i.slice(n,o)},format:S.bind(null,"\\"),parse(i){D(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const n=i.length;let t=0,o=i.charCodeAt(0);if(n===1)return r(o)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(r(o)){if(t=1,r(i.charCodeAt(1))){let P=2,O=P;for(;P<n&&!r(i.charCodeAt(P));)P++;if(P<n&&P!==O){for(O=P;P<n&&r(i.charCodeAt(P));)P++;if(P<n&&P!==O){for(O=P;P<n&&!r(i.charCodeAt(P));)P++;P===n?t=P:P!==O&&(t=P+1)}}}}else if(c(o)&&i.charCodeAt(1)===R){if(n<=2)return a.root=a.dir=i,a;if(t=2,r(i.charCodeAt(2))){if(n===3)return a.root=a.dir=i,a;t=3}}t>0&&(a.root=i.slice(0,t));let g=-1,l=t,h=-1,w=!0,u=i.length-1,E=0;for(;u>=t;--u){if(o=i.charCodeAt(u),r(o)){if(!w){l=u+1;break}continue}h===-1&&(w=!1,h=u+1),o===m?g===-1?g=u:E!==1&&(E=1):g!==-1&&(E=-1)}return h!==-1&&(g===-1||E===0||E===1&&g===h-1&&g===l+1?a.base=a.name=i.slice(l,h):(a.name=i.slice(l,g),a.base=i.slice(l,h),a.ext=i.slice(g,h))),l>0&&l!==t?a.dir=i.slice(0,l-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const I=(()=>{if(b){const i=/\\/g;return()=>{const a=_.cwd().replace(i,"/");return a.slice(a.indexOf("/"))}}return()=>_.cwd()})();e.posix={resolve(...i){let a="",n=!1;for(let t=i.length-1;t>=-1&&!n;t--){const o=t>=0?i[t]:I();D(o,"path"),o.length!==0&&(a=`${o}/${a}`,n=o.charCodeAt(0)===y)}return a=f(a,!n,"/",s),n?`/${a}`:a.length>0?a:"."},normalize(i){if(D(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===y,n=i.charCodeAt(i.length-1)===y;return i=f(i,!a,"/",s),i.length===0?a?"/":n?"./":".":(n&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return D(i,"path"),i.length>0&&i.charCodeAt(0)===y},join(...i){if(i.length===0)return".";let a;for(let n=0;n<i.length;++n){const t=i[n];D(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(i,a){if(D(i,"from"),D(a,"to"),i===a||(i=e.posix.resolve(i),a=e.posix.resolve(a),i===a))return"";const n=1,t=i.length,o=t-n,g=1,l=a.length-g,h=o<l?o:l;let w=-1,u=0;for(;u<h;u++){const P=i.charCodeAt(n+u);if(P!==a.charCodeAt(g+u))break;P===y&&(w=u)}if(u===h)if(l>h){if(a.charCodeAt(g+u)===y)return a.slice(g+u+1);if(u===0)return a.slice(g+u)}else o>h&&(i.charCodeAt(n+u)===y?w=u:u===0&&(w=0));let E="";for(u=n+w+1;u<=t;++u)(u===t||i.charCodeAt(u)===y)&&(E+=E.length===0?"..":"/..");return`${E}${a.slice(g+w)}`},toNamespacedPath(i){return i},dirname(i){if(D(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===y;let n=-1,t=!0;for(let o=i.length-1;o>=1;--o)if(i.charCodeAt(o)===y){if(!t){n=o;break}}else t=!1;return n===-1?a?"/":".":a&&n===1?"//":i.slice(0,n)},basename(i,a){a!==void 0&&D(a,"ext"),D(i,"path");let n=0,t=-1,o=!0,g;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let l=a.length-1,h=-1;for(g=i.length-1;g>=0;--g){const w=i.charCodeAt(g);if(w===y){if(!o){n=g+1;break}}else h===-1&&(o=!1,h=g+1),l>=0&&(w===a.charCodeAt(l)?--l===-1&&(t=g):(l=-1,t=h))}return n===t?t=h:t===-1&&(t=i.length),i.slice(n,t)}for(g=i.length-1;g>=0;--g)if(i.charCodeAt(g)===y){if(!o){n=g+1;break}}else t===-1&&(o=!1,t=g+1);return t===-1?"":i.slice(n,t)},extname(i){D(i,"path");let a=-1,n=0,t=-1,o=!0,g=0;for(let l=i.length-1;l>=0;--l){const h=i.charCodeAt(l);if(h===y){if(!o){n=l+1;break}continue}t===-1&&(o=!1,t=l+1),h===m?a===-1?a=l:g!==1&&(g=1):a!==-1&&(g=-1)}return a===-1||t===-1||g===0||g===1&&a===t-1&&a===n+1?"":i.slice(a,t)},format:S.bind(null,"/"),parse(i){D(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const n=i.charCodeAt(0)===y;let t;n?(a.root="/",t=1):t=0;let o=-1,g=0,l=-1,h=!0,w=i.length-1,u=0;for(;w>=t;--w){const E=i.charCodeAt(w);if(E===y){if(!h){g=w+1;break}continue}l===-1&&(h=!1,l=w+1),E===m?o===-1?o=w:u!==1&&(u=1):o!==-1&&(u=-1)}if(l!==-1){const E=g===0&&n?1:g;o===-1||u===0||u===1&&o===l-1&&o===g+1?a.base=a.name=i.slice(E,l):(a.name=i.slice(E,o),a.base=i.slice(E,l),a.ext=i.slice(o,l))}return g>0?a.dir=i.slice(0,g-1):n&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b?e.win32.normalize:e.posix.normalize,e.isAbsolute=b?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b?e.win32.join:e.posix.join,e.resolve=b?e.win32.resolve:e.posix.resolve,e.relative=b?e.win32.relative:e.posix.relative,e.dirname=b?e.win32.dirname:e.posix.dirname,e.basename=b?e.win32.basename:e.posix.basename,e.extname=b?e.win32.extname:e.posix.extname,e.format=b?e.win32.format:e.posix.format,e.parse=b?e.win32.parse:e.posix.parse,e.toNamespacedPath=b?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b?e.win32.sep:e.posix.sep,e.delimiter=b?e.win32.delimiter:e.posix.delimiter}),define(De[118],Ie([1,0,54,13]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const d=new _.Lazy(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),A=new _.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new _.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(h,w,u=!1){const E=h||"",P=w||"",O=d.value.collator.compare(E,P);return d.value.collatorIsNumeric&&O===0&&E!==P?E<P?-1:1:O}e.compareFileNames=m;function y(h,w){const u=A.value.collator;return h=h||"",w=w||"",S(u,h,w)}e.compareFileNamesDefault=y;function v(h,w){const u=A.value.collator;return h=h||"",w=w||"",n(h,w)||S(u,h,w)}e.compareFileNamesUpper=v;function R(h,w){const u=A.value.collator;return h=h||"",w=w||"",a(h,w)||S(u,h,w)}e.compareFileNamesLower=R;function k(h,w){return h=h||"",w=w||"",h===w?0:h<w?-1:1}e.compareFileNamesUnicode=k;function p(h,w){const[u,E]=c(h),[P,O]=c(w);let N=d.value.collator.compare(E,O);if(N===0){if(d.value.collatorIsNumeric&&E!==O)return E<O?-1:1;if(N=d.value.collator.compare(u,P),d.value.collatorIsNumeric&&N===0&&u!==P)return u<P?-1:1}return N}e.compareFileExtensions=p;function C(h,w){h=h||"",w=w||"";const u=f(h),E=f(w),P=A.value.collator,O=T.value.collator;return S(O,u,E)||S(P,h,w)}e.compareFileExtensionsDefault=C;function D(h,w){h=h||"",w=w||"";const u=f(h),E=f(w),P=A.value.collator,O=T.value.collator;return S(O,u,E)||n(h,w)||S(P,h,w)}e.compareFileExtensionsUpper=D;function b(h,w){h=h||"",w=w||"";const u=f(h),E=f(w),P=A.value.collator,O=T.value.collator;return S(O,u,E)||a(h,w)||S(P,h,w)}e.compareFileExtensionsLower=b;function r(h,w){h=h||"",w=w||"";const u=f(h).toLowerCase(),E=f(w).toLowerCase();return u!==E?u<E?-1:1:h!==w?h<w?-1:1:0}e.compareFileExtensionsUnicode=r;const s=/^(.*?)(\.([^.]*))?$/;function c(h,w=!1){const u=h?s.exec(h):[];let E=[u&&u[1]||"",u&&u[3]||""];return w&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function f(h){const w=h?s.exec(h):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function S(h,w,u){const E=h.compare(w,u);return E!==0?E:w.length!==u.length?w.length<u.length?-1:1:0}function I(h){const w=h.charAt(0);return w.toLocaleUpperCase()!==w}function i(h){const w=h.charAt(0);return w.toLocaleLowerCase()!==w}function a(h,w){return I(h)&&i(w)?-1:i(h)&&I(w)?1:0}function n(h,w){return i(h)&&I(w)?-1:I(h)&&i(w)?1:0}function t(h,w,u=!1){return u||(h=h&&h.toLowerCase(),w=w&&w.toLowerCase()),h===w?0:h<w?-1:1}function o(h,w,u=!1){const E=h.split(L.sep),P=w.split(L.sep),O=E.length-1,N=P.length-1;let F,x;for(let B=0;;B++){if(F=O===B,x=N===B,F&&x)return m(E[B],P[B],u);if(F)return-1;if(x)return 1;const U=t(E[B],P[B],u);if(U!==0)return U}}e.comparePaths=o;function g(h,w,u){const E=h.toLowerCase(),P=w.toLowerCase(),O=l(h,w,u);if(O)return O;const N=E.endsWith(u),F=P.endsWith(u);if(N!==F)return N?-1:1;const x=m(E,P);return x!==0?x:E.localeCompare(P)}e.compareAnything=g;function l(h,w,u){const E=h.toLowerCase(),P=w.toLowerCase(),O=E.startsWith(u),N=P.startsWith(u);if(O!==N)return O?-1:1;if(O&&N){if(E.length<P.length)return-1;if(E.length>P.length)return 1}return 0}e.compareByPrefix=l}),define(De[31],Ie([1,0,13,11,12,14]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(g){return g===47||g===92}e.isPathSeparator=T;function m(g){return g.replace(/[\\/]/g,_.posix.sep)}e.toSlashes=m;function y(g){return g.indexOf("/")===-1&&(g=m(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}e.toPosixPath=y;function v(g,l=_.posix.sep){if(!g)return"";const h=g.length,w=g.charCodeAt(0);if(T(w)){if(T(g.charCodeAt(1))&&!T(g.charCodeAt(2))){let E=3;const P=E;for(;E<h&&!T(g.charCodeAt(E));E++);if(P!==E&&!T(g.charCodeAt(E+1))){for(E+=1;E<h;E++)if(T(g.charCodeAt(E)))return g.slice(0,E+1).replace(/[\\/]/g,l)}}return l}else if(s(w)&&g.charCodeAt(1)===58)return T(g.charCodeAt(2))?g.slice(0,2)+l:g.slice(0,2);let u=g.indexOf("://");if(u!==-1){for(u+=3;u<h;u++)if(T(g.charCodeAt(u)))return g.slice(0,u+1)}return""}e.getRoot=v;function R(g){if(!L.isWindows||!g||g.length<5)return!1;let l=g.charCodeAt(0);if(l!==92||(l=g.charCodeAt(1),l!==92))return!1;let h=2;const w=h;for(;h<g.length&&(l=g.charCodeAt(h),l!==92);h++);return!(w===h||(l=g.charCodeAt(h+1),isNaN(l)||l===92))}e.isUNC=R;const k=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(g,l=L.isWindows){const h=l?k:p;return!(!g||g.length===0||/^\s+$/.test(g)||(h.lastIndex=0,h.test(g))||l&&C.test(g)||g==="."||g===".."||l&&g[g.length-1]==="."||l&&g.length!==g.trim().length||g.length>255)}e.isValidBasename=D;function b(g,l,h){const w=g===l;return!h||w?w:!g||!l?!1:(0,d.equalsIgnoreCase)(g,l)}e.isEqual=b;function r(g,l,h,w=_.sep){if(g===l)return!0;if(!g||!l||l.length>g.length)return!1;if(h){if(!(0,d.startsWithIgnoreCase)(g,l))return!1;if(l.length===g.length)return!0;let E=l.length;return l.charAt(l.length-1)===w&&E--,g.charAt(E)===w}return l.charAt(l.length-1)!==w&&(l+=w),g.indexOf(l)===0}e.isEqualOrParent=r;function s(g){return g>=65&&g<=90||g>=97&&g<=122}e.isWindowsDriveLetter=s;function c(g,l){return L.isWindows&&g.endsWith(":")&&(g+=_.sep),(0,_.isAbsolute)(g)||(g=(0,_.join)(l,g)),g=(0,_.normalize)(g),L.isWindows?(g=(0,d.rtrim)(g,_.sep),g.endsWith(":")&&(g+=_.sep)):(g=(0,d.rtrim)(g,_.sep),g||(g=_.sep)),g}e.sanitizeFilePath=c;function f(g){const l=(0,_.normalize)(g);return L.isWindows?g.length>3?!1:S(l)&&(g.length===2||l.charCodeAt(2)===92):l===_.posix.sep}e.isRootOrDriveLetter=f;function S(g,l=L.isWindows){return l?s(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function I(g,l=L.isWindows){return S(g,l)?g[0]:void 0}e.getDriveLetter=I;function i(g,l,h){return l.length>g.length?-1:g===l?0:(h&&(g=g.toLowerCase(),l=l.toLowerCase()),g.indexOf(l))}e.indexOfPath=i;function a(g){const l=g.split(":");let h,w,u;for(const E of l){const P=Number(E);(0,A.isNumber)(P)?w===void 0?w=P:u===void 0&&(u=P):h=h?[h,E].join(":"):E}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:w!==void 0?w:void 0,column:u!==void 0?u:w!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(g,l,h=8){let w="";for(let E=0;E<h;E++){let P;E===0&&L.isWindows&&!l&&(h===3||h===4)?P=t:P=n,w+=P.charAt(Math.floor(Math.random()*P.length))}let u;return l?u=`${l}-${w}`:u=w,g?(0,_.join)(g,u):u}e.randomPath=o}),define(De[119],Ie([1,0,118,113,70,13,11,12]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,v=[y,[]];function R(X,j,ge,ie){if(!X||!j)return v;const te=X.length,$=j.length;if(te<$)return v;const H=X.toLowerCase();return k(j,ge,$,X,H,te,ie)}e.scoreFuzzy=R;function k(X,j,ge,ie,te,$,H){const ce=[],re=[];for(let Z=0;Z<ge;Z++){const ye=Z*$,Re=ye-$,ne=Z>0,ee=X[Z],de=j[Z];for(let K=0;K<$;K++){const le=K>0,oe=ye+K,ue=oe-1,Ee=Re+K-1,M=le?ce[ue]:0,q=ne&&le?ce[Ee]:0,G=ne&&le?re[Ee]:0;let J;!q&&ne?J=0:J=p(ee,de,ie,te,K,G),J&&q+J>=M&&(H||ne||te.startsWith(j,K))?(re[oe]=G+1,ce[oe]=q+J):(re[oe]=y,ce[oe]=M)}}const fe=[];let he=ge-1,z=$-1;for(;he>=0&&z>=0;){const Z=he*$+z;re[Z]===y||(fe.push(z),he--),z--}return[ce[ge*$-1],fe.reverse()]}function p(X,j,ge,ie,te,$){let H=0;if(!C(j,ie[te]))return H;if(H+=1,$>0&&(H+=$*5),X===ge[te]&&(H+=1),te===0)H+=8;else{const ce=D(ge.charCodeAt(te-1));ce?H+=ce:(0,L.isUpper)(ge.charCodeAt(te))&&$===0&&(H+=2)}return H}function C(X,j){return X===j?!0:X==="/"||X==="\\"?j==="/"||j==="\\":!1}function D(X){switch(X){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const b=[void 0,[]];function r(X,j,ge=0,ie=0){const te=j;return te.values&&te.values.length>1?s(X,te.values,ge,ie):c(X,j,ge,ie)}e.scoreFuzzy2=r;function s(X,j,ge,ie){let te=0;const $=[];for(const H of j){const[ce,re]=c(X,H,ge,ie);if(typeof ce!="number")return b;te+=ce,$.push(...re)}return[te,h($)]}function c(X,j,ge,ie){const te=(0,L.fuzzyScore)(j.original,j.originalLowercase,ge,X,X.toLowerCase(),ie,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return te?[te[0],(0,L.createMatches)(te)]:b}const f=Object.freeze({score:0}),S=1<<18,I=1<<17,i=1<<16;function a(X,j,ge,ie){const te=ie.values?ie.values:[ie];return(0,d.hash)({[ie.normalized]:{values:te.map(H=>({value:H.normalized,expectContiguousMatch:H.expectContiguousMatch})),label:X,description:j,allowNonContiguousMatches:ge}})}function n(X,j,ge,ie,te){if(!X||!j.normalized)return f;const $=ie.getItemLabel(X);if(!$)return f;const H=ie.getItemDescription(X),ce=a($,H,ge,j),re=te[ce];if(re)return re;const fe=t($,H,ie.getItemPath(X),j,ge);return te[ce]=fe,fe}e.scoreItemFuzzy=n;function t(X,j,ge,ie,te){const $=!ge||!ie.containsPathSeparator;return ge&&(T.isLinux?ie.pathNormalized===ge:(0,m.equalsIgnoreCase)(ie.pathNormalized,ge))?{score:S,labelMatch:[{start:0,end:X.length}],descriptionMatch:j?[{start:0,end:j.length}]:void 0}:ie.values&&ie.values.length>1?o(X,j,ge,ie.values,$,te):g(X,j,ge,ie,$,te)}function o(X,j,ge,ie,te,$){let H=0;const ce=[],re=[];for(const fe of ie){const{score:he,labelMatch:z,descriptionMatch:Z}=g(X,j,ge,fe,te,$);if(he===y)return f;H+=he,z&&ce.push(...z),Z&&re.push(...Z)}return{score:H,labelMatch:h(ce),descriptionMatch:h(re)}}function g(X,j,ge,ie,te,$){if(te||!j){const[H,ce]=R(X,ie.normalized,ie.normalizedLowercase,$&&!ie.expectContiguousMatch);if(H){const re=(0,L.matchesPrefix)(ie.normalized,X);let fe;if(re){fe=I;const he=Math.round(ie.normalized.length/X.length*100);fe+=he}else fe=i;return{score:fe+H,labelMatch:re||l(ce)}}}if(j){let H=j;ge&&(H=`${j}${A.sep}`);const ce=H.length,re=`${H}${X}`,[fe,he]=R(re,ie.normalized,ie.normalizedLowercase,$&&!ie.expectContiguousMatch);if(fe){const z=l(he),Z=[],ye=[];return z.forEach(Re=>{Re.start<ce&&Re.end>ce?(Z.push({start:0,end:Re.end-ce}),ye.push({start:Re.start,end:ce})):Re.start>=ce?Z.push({start:Re.start-ce,end:Re.end-ce}):ye.push(Re)}),{score:fe,labelMatch:Z,descriptionMatch:ye}}}return f}function l(X){const j=[];if(!X)return j;let ge;for(const ie of X)ge&&ge.end===ie?ge.end+=1:(ge={start:ie,end:ie+1},j.push(ge));return j}function h(X){const j=X.sort((te,$)=>te.start-$.start),ge=[];let ie;for(const te of j)!ie||!w(ie,te)?(ie=te,ge.push(te)):(ie.start=Math.min(ie.start,te.start),ie.end=Math.max(ie.end,te.end));return ge}function w(X,j){return!(X.end<j.start||j.end<X.start)}function u(X,j,ge,ie,te,$){const H=n(X,ge,ie,te,$),ce=n(j,ge,ie,te,$),re=H.score,fe=ce.score;if((re===S||fe===S)&&re!==fe)return re===S?-1:1;if(re>i||fe>i){if(re!==fe)return re>fe?-1:1;if(re<I&&fe<I){const ee=P(H.labelMatch,ce.labelMatch);if(ee!==0)return ee}const Re=te.getItemLabel(X)||"",ne=te.getItemLabel(j)||"";if(Re.length!==ne.length)return Re.length-ne.length}if(re!==fe)return re>fe?-1:1;const he=Array.isArray(H.labelMatch)&&H.labelMatch.length>0,z=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0;if(he&&!z)return-1;if(z&&!he)return 1;const Z=E(X,H,te),ye=E(j,ce,te);return Z&&ye&&Z!==ye?ye>Z?-1:1:O(X,j,ge,te)}e.compareItemsByFuzzyScore=u;function E(X,j,ge){let ie=-1,te=-1;if(j.descriptionMatch&&j.descriptionMatch.length?ie=j.descriptionMatch[0].start:j.labelMatch&&j.labelMatch.length&&(ie=j.labelMatch[0].start),j.labelMatch&&j.labelMatch.length){if(te=j.labelMatch[j.labelMatch.length-1].end,j.descriptionMatch&&j.descriptionMatch.length){const $=ge.getItemDescription(X);$&&(te+=$.length)}}else j.descriptionMatch&&j.descriptionMatch.length&&(te=j.descriptionMatch[j.descriptionMatch.length-1].end);return te-ie}function P(X,j){if(!X&&!j||(!X||!X.length)&&(!j||!j.length))return 0;if(!j||!j.length)return-1;if(!X||!X.length)return 1;const ge=X[0].start,te=X[X.length-1].end-ge,$=j[0].start,ce=j[j.length-1].end-$;return te===ce?0:ce<te?1:-1}function O(X,j,ge,ie){const te=ie.getItemLabel(X)||"",$=ie.getItemLabel(j)||"",H=ie.getItemDescription(X),ce=ie.getItemDescription(j),re=te.length+(H?H.length:0),fe=$.length+(ce?ce.length:0);if(re!==fe)return re-fe;const he=ie.getItemPath(X),z=ie.getItemPath(j);return he&&z&&he.length!==z.length?he.length-z.length:te!==$?(0,_.compareAnything)(te,$,ge.normalized):H&&ce&&H!==ce?(0,_.compareAnything)(H,ce,ge.normalized):he&&z&&he!==z?(0,_.compareAnything)(he,z,ge.normalized):0}function N(X){return X.startsWith('"')&&X.endsWith('"')}const F=" ";function x(X){typeof X!="string"&&(X="");const j=X.toLowerCase(),{pathNormalized:ge,normalized:ie,normalizedLowercase:te}=B(X),$=ge.indexOf(A.sep)>=0,H=N(X);let ce;const re=X.split(F);if(re.length>1)for(const fe of re){const he=N(fe),{pathNormalized:z,normalized:Z,normalizedLowercase:ye}=B(fe);Z&&(ce||(ce=[]),ce.push({original:fe,originalLowercase:fe.toLowerCase(),pathNormalized:z,normalized:Z,normalizedLowercase:ye,expectContiguousMatch:he}))}return{original:X,originalLowercase:j,pathNormalized:ge,normalized:ie,normalizedLowercase:te,values:ce,containsPathSeparator:$,expectContiguousMatch:H}}e.prepareQuery=x;function B(X){let j;T.isWindows?j=X.replace(/\//g,A.sep):j=X.replace(/\\/g,A.sep);const ge=(0,m.stripWildcards)(j).replace(/\s|"/g,"");return{pathNormalized:j,normalized:ge,normalizedLowercase:ge.toLowerCase()}}function U(X){return Array.isArray(X)?x(X.map(j=>j.original).join(F)):x(X.original)}e.pieceToQuery=U}),define(De[93],Ie([1,0,13]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},d={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const k=(0,_.extname)(R),p=L[k.toLowerCase()];return p!==void 0?p:T(R)}e.getMediaOrTextMime=A;function T(R){const k=(0,_.extname)(R);return d[k.toLowerCase()]}e.getMediaMime=T;function m(R){for(const k in d)if(d[k]===R)return k}e.getExtensionForMimeType=m;const y=/^(.+)\/(.+?)(;.+)?$/;function v(R,k){const p=y.exec(R);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:k?void 0:R}e.normalizeMimeType=v}),define(De[94],Ie([1,0,11]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(m){m[m.stdout=0]="stdout",m[m.stderr=1]="stderr"})(L||(e.Source=L={}));var d;(function(m){m[m.Success=0]="Success",m[m.Unknown=1]="Unknown",m[m.AccessDenied=2]="AccessDenied",m[m.ProcessNotFound=3]="ProcessNotFound"})(d||(e.TerminateResponseCode=d={}));function A(m,...y){const v=y.reduce((p,C)=>(p[C]=!0,p),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(m).filter(p=>!v[p]).forEach(p=>{for(let C=0;C<R.length;C++)if(p.search(R[C])!==-1){delete m[p];break}})}e.sanitizeProcessEnvironment=A;function T(m){m&&(delete m.DEBUG,_.isMacintosh&&delete m.DYLD_LIBRARY_PATH,_.isLinux&&delete m.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(De[2],Ie([1,0,13,11]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const d=/^\w[\w\d+.-]*$/,A=/^\//,T=/^\/\//;function m(t,o){if(!t.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!d.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!A.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(t,o){return!t&&!o?"file":t}function v(t,o){switch(t){case"https":case"http":case"file":o?o[0]!==k&&(o=k+o):o=k;break}return o}const R="",k="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{static isUri(o){return o instanceof C?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,g,l,h,w,u=!1){typeof o=="object"?(this.scheme=o.scheme||R,this.authority=o.authority||R,this.path=o.path||R,this.query=o.query||R,this.fragment=o.fragment||R):(this.scheme=y(o,u),this.authority=g||R,this.path=v(this.scheme,l||R),this.query=h||R,this.fragment=w||R,m(this,u))}get fsPath(){return S(this,!1)}with(o){if(!o)return this;let{scheme:g,authority:l,path:h,query:w,fragment:u}=o;return g===void 0?g=this.scheme:g===null&&(g=R),l===void 0?l=this.authority:l===null&&(l=R),h===void 0?h=this.path:h===null&&(h=R),w===void 0?w=this.query:w===null&&(w=R),u===void 0?u=this.fragment:u===null&&(u=R),g===this.scheme&&l===this.authority&&h===this.path&&w===this.query&&u===this.fragment?this:new r(g,l,h,w,u)}static parse(o,g=!1){const l=p.exec(o);return l?new r(l[2]||R,n(l[4]||R),n(l[5]||R),n(l[7]||R),n(l[9]||R),g):new r(R,R,R,R,R)}static file(o){let g=R;if(L.isWindows&&(o=o.replace(/\\/g,k)),o[0]===k&&o[1]===k){const l=o.indexOf(k,2);l===-1?(g=o.substring(2),o=k):(g=o.substring(2,l),o=o.substring(l)||k)}return new r("file",g,o,R,R)}static from(o,g){return new r(o.scheme,o.authority,o.path,o.query,o.fragment,g)}static joinPath(o,...g){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&o.scheme==="file"?l=C.file(_.win32.join(S(o,!0),...g)).path:l=_.posix.join(o.path,...g),o.with({path:l})}toString(o=!1){return I(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof C)return o;{const g=new r(o);return g._formatted=o.external??null,g._fsPath=o._sep===b?o.fsPath??null:null,g}}else return o}}e.URI=C;function D(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.isUriComponents=D;const b=L.isWindows?1:void 0;class r extends C{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=S(this,!1)),this._fsPath}toString(o=!1){return o?I(this,!0):(this._formatted||(this._formatted=I(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=b),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function c(t,o,g){let l,h=-1;for(let w=0;w<t.length;w++){const u=t.charCodeAt(w);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||o&&u===47||g&&u===91||g&&u===93||g&&u===58)h!==-1&&(l+=encodeURIComponent(t.substring(h,w)),h=-1),l!==void 0&&(l+=t.charAt(w));else{l===void 0&&(l=t.substr(0,w));const E=s[u];E!==void 0?(h!==-1&&(l+=encodeURIComponent(t.substring(h,w)),h=-1),l+=E):h===-1&&(h=w)}}return h!==-1&&(l+=encodeURIComponent(t.substring(h))),l!==void 0?l:t}function f(t){let o;for(let g=0;g<t.length;g++){const l=t.charCodeAt(g);l===35||l===63?(o===void 0&&(o=t.substr(0,g)),o+=s[l]):o!==void 0&&(o+=t[g])}return o!==void 0?o:t}function S(t,o){let g;return t.authority&&t.path.length>1&&t.scheme==="file"?g=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?o?g=t.path.substr(1):g=t.path[1].toLowerCase()+t.path.substr(2):g=t.path,L.isWindows&&(g=g.replace(/\//g,"\\")),g}e.uriToFsPath=S;function I(t,o){const g=o?f:c;let l="",{scheme:h,authority:w,path:u,query:E,fragment:P}=t;if(h&&(l+=h,l+=":"),(w||h==="file")&&(l+=k,l+=k),w){let O=w.indexOf("@");if(O!==-1){const N=w.substr(0,O);w=w.substr(O+1),O=N.lastIndexOf(":"),O===-1?l+=g(N,!1,!1):(l+=g(N.substr(0,O),!1,!1),l+=":",l+=g(N.substr(O+1),!1,!0)),l+="@"}w=w.toLowerCase(),O=w.lastIndexOf(":"),O===-1?l+=g(w,!1,!0):(l+=g(w.substr(0,O),!1,!0),l+=w.substr(O))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const O=u.charCodeAt(1);O>=65&&O<=90&&(u=`/${String.fromCharCode(O+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const O=u.charCodeAt(0);O>=65&&O<=90&&(u=`${String.fromCharCode(O+32)}:${u.substr(2)}`)}l+=g(u,!0,!1)}return E&&(l+="?",l+=g(E,!1,!1)),P&&(l+="#",l+=o?P:c(P,!1,!1)),l}function i(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+i(t.substr(3)):t}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(t){return t.match(a)?t.replace(a,o=>i(o)):t}}),define(De[174],Ie([1,0,2]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(v){const R=v;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=L;function d(v){const R=[];let k;try{const p=JSON.parse(v.arguments),C=p[p.length-1];C&&C.__$stack&&(p.pop(),k=C.__$stack),R.push(...p)}catch{R.push("Unable to log remote console arguments",v.arguments)}return{args:R,stack:k}}e.parse=d;function A(v){if(typeof v!="string")return A(d(v).stack);const R=v;if(R){const k=T(R),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(p&&p.length===4)return{uri:_.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=A;function T(v){if(!v)return v;const R=v.indexOf(`
`);return R===-1?v:v.substring(0,R)}function m(v,R){const{args:k,stack:p}=d(v),C=typeof k[0]=="string"&&k.length===1;let D=T(p);D&&(D=`(${D.trim()})`);let b=[];if(typeof k[0]=="string"?D&&C?b=[`%c[${R}] %c${k[0]} %c${D}`,y("blue"),y(""),y("grey")]:b=[`%c[${R}] %c${k[0]}`,y("blue"),y(""),...k.slice(1)]:b=[`%c[${R}]%`,y("blue"),...k],D&&!C&&b.push(D),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,b)}e.log=m;function y(v){return`color: ${v}`}}),define(De[73],Ie([1,0,22,12,2]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(v){return JSON.stringify(v,m)}e.stringify=A;function T(v){let R=JSON.parse(v);return R=y(R),R}e.parse=T;function m(v,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,L.regExpFlags)(R)}:R}function y(v,R=0){if(!v||R>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return d.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 16:return new Date(v.source)}if(v instanceof _.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let k=0;k<v.length;++k)v[k]=y(v[k],R+1);else for(const k in v)Object.hasOwnProperty.call(v,k)&&(v[k]=y(v[k],R+1))}return v}e.revive=y}),define(De[15],Ie([1,0,8,11,2]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(R){this._preferredWebSchema=R}setDelegate(R){this._delegate=R}setServerRootPath(R){this._remoteResourcesPath=`${R}/${A.vscodeRemoteResource}`}set(R,k,p){this._hosts[R]=k,this._ports[R]=p}setConnectionToken(R,k){this._connectionTokens[R]=k}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(R){if(this._delegate)try{return this._delegate(R)}catch(r){return _.onUnexpectedError(r),R}const k=R.authority;let p=this._hosts[k];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const C=this._ports[k],D=this._connectionTokens[k];let b=`path=${encodeURIComponent(R.path)}`;return typeof D=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(D)}`),d.URI.from({scheme:L.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${p}:${C}`,path:this._remoteResourcesPath,query:b})}}e.RemoteAuthorities=new T,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class m{static{this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(R){const k=this.toUri(R,me);return this.uriToBrowserUri(k)}uriToBrowserUri(R){return R.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===A.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${A.vscodeFileResource}://${m.FALLBACK_AUTHORITY}`)?R.with({scheme:A.vscodeFileResource,authority:R.authority||m.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(R){const k=this.toUri(R,me);return this.uriToFileUri(k)}uriToFileUri(R){return R.scheme===A.vscodeFileResource?R.with({scheme:A.file,authority:R.authority!==m.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(R,k){return d.URI.isUri(R)?R:d.URI.parse(k.toUrl(R))}}e.FileAccess=new m;var y;(function(v){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(R.get("3"));const k="vscode-coi";function p(D){let b;typeof D=="string"?b=new URL(D).searchParams:D instanceof URL?b=D.searchParams:d.URI.isUri(D)&&(b=new URL(D.toString(!0)).searchParams);const r=b?.get(k);if(r)return R.get(r)}v.getHeadersFromQuery=p;function C(D,b,r){if(!globalThis.crossOriginIsolated)return;const s=b&&r?"3":r?"2":"1";D instanceof URLSearchParams?D.set(k,s):D[k]=s}v.addSearchParam=C})(y||(e.COI=y={}))}),define(De[175],Ie([1,0,150,15,11,2]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class T{constructor(p,C,D){this.id=p,this.dependencies=C,this.callback=D}}class m{static{this.INSTANCE=new m}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(p,C,D)=>{typeof p!="string"&&(D=C,C=p,p=null),(typeof C!="object"||!Array.isArray(C))&&(D=C,C=null),this._defineCalls.push(new T(p,C,D))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this._initialize();const C=await(this._isWebWorker?this._workerLoadScript(p):this._isRenderer?this._rendererLoadScript(p):this._nodeJSLoadScript(p));if(!C)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(C.dependencies)&&C.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${C.dependencies.join(", ")}`);return typeof C.callback=="function"?C.callback([]):C.callback}_rendererLoadScript(p){return new Promise((C,D)=>{const b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript");const r=()=>{b.removeEventListener("load",s),b.removeEventListener("error",c)},s=f=>{r(),C(this._defineCalls.pop())},c=f=>{r(),D(f)};b.addEventListener("load",s),b.addEventListener("error",c),this._amdPolicy&&(p=this._amdPolicy.createScriptURL(p)),b.setAttribute("src",p),document.getElementsByTagName("head")[0].appendChild(b)})}_workerLoadScript(p){return new Promise((C,D)=>{try{this._amdPolicy&&(p=this._amdPolicy.createScriptURL(p)),importScripts(p),C(this._defineCalls.pop())}catch(b){D(b)}})}async _nodeJSLoadScript(p){try{const C=globalThis._VSCODE_NODE_MODULES.fs,D=globalThis._VSCODE_NODE_MODULES.vm,b=globalThis._VSCODE_NODE_MODULES.module,r=A.URI.parse(p).fsPath,s=C.readFileSync(r).toString(),c=b.wrap(s.replace(/^#!.*/,""));return new D.Script(c).runInThisContext().apply(),this._defineCalls.pop()}catch(C){throw C}}}const y=new Map;let v={};typeof globalThis.require=="object"&&(v=globalThis.require.paths??{});async function R(k,p,C){if(_.isESM){C===void 0&&(C=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),v[k]&&(k=v[k]);const D=`${k}/${p}`;if(y.has(D))return y.get(D);let b;if(/^\w[\w\d+.-]*:\/\//.test(D))b=D;else{const f=`${C&&!d.isWeb?L.nodeModulesAsarPath:L.nodeModulesPath}/${D}`;b=L.FileAccess.asBrowserUri(f).toString(!0)}const r=m.INSTANCE.load(b);return y.set(D,r),r}else return await new Promise((D,b)=>{me([k],D,b)})}e.importAMDNodeModule=R}),define(De[24],Ie([1,0,31,15,13,11,12,2]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(C){return(0,m.uriToFsPath)(C,!0)}e.originalFSPath=y;class v{constructor(D){this._ignorePathCasing=D}compare(D,b,r=!1){return D===b?0:(0,T.compare)(this.getComparisonKey(D,r),this.getComparisonKey(b,r))}isEqual(D,b,r=!1){return D===b?!0:!D||!b?!1:this.getComparisonKey(D,r)===this.getComparisonKey(b,r)}getComparisonKey(D,b=!1){return D.with({path:this._ignorePathCasing(D)?D.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(D){return this._ignorePathCasing(D)}isEqualOrParent(D,b,r=!1){if(D.scheme===b.scheme){if(D.scheme===L.Schemas.file)return _.isEqualOrParent(y(D),y(b),this._ignorePathCasing(D))&&D.query===b.query&&(r||D.fragment===b.fragment);if((0,e.isEqualAuthority)(D.authority,b.authority))return _.isEqualOrParent(D.path,b.path,this._ignorePathCasing(D),"/")&&D.query===b.query&&(r||D.fragment===b.fragment)}return!1}joinPath(D,...b){return m.URI.joinPath(D,...b)}basenameOrAuthority(D){return(0,e.basename)(D)||D.authority}basename(D){return d.posix.basename(D.path)}extname(D){return d.posix.extname(D.path)}dirname(D){if(D.path.length===0)return D;let b;return D.scheme===L.Schemas.file?b=m.URI.file(d.dirname(y(D))).path:(b=d.posix.dirname(D.path),D.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${D.toString})) resulted in a relative path`),b="/")),D.with({path:b})}normalizePath(D){if(!D.path.length)return D;let b;return D.scheme===L.Schemas.file?b=m.URI.file(d.normalize(y(D))).path:b=d.posix.normalize(D.path),D.with({path:b})}relativePath(D,b){if(D.scheme!==b.scheme||!(0,e.isEqualAuthority)(D.authority,b.authority))return;if(D.scheme===L.Schemas.file){const c=d.relative(y(D),y(b));return A.isWindows?_.toSlashes(c):c}let r=D.path||"/";const s=b.path||"/";if(this._ignorePathCasing(D)){let c=0;for(const f=Math.min(r.length,s.length);c<f&&!(r.charCodeAt(c)!==s.charCodeAt(c)&&r.charAt(c).toLowerCase()!==s.charAt(c).toLowerCase());c++);r=s.substr(0,c)+r.substr(c)}return d.posix.relative(r,s)}resolvePath(D,b){if(D.scheme===L.Schemas.file){const r=m.URI.file(d.resolve(y(D),b));return D.with({authority:r.authority,path:r.path})}return b=_.toPosixPath(b),D.with({path:d.posix.resolve(D.path,b)})}isAbsolutePath(D){return!!D.path&&D.path[0]==="/"}isEqualAuthority(D,b){return D===b||D!==void 0&&b!==void 0&&(0,T.equalsIgnoreCase)(D,b)}hasTrailingPathSeparator(D,b=d.sep){if(D.scheme===L.Schemas.file){const r=y(D);return r.length>_.getRoot(r).length&&r[r.length-1]===b}else{const r=D.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(D.fsPath)}}removeTrailingPathSeparator(D,b=d.sep){return(0,e.hasTrailingPathSeparator)(D,b)?D.with({path:D.path.substr(0,D.path.length-1)}):D}addTrailingPathSeparator(D,b=d.sep){let r=!1;if(D.scheme===L.Schemas.file){const s=y(D);r=s!==void 0&&s.length===_.getRoot(s).length&&s[s.length-1]===b}else{b="/";const s=D.path;r=s.length===1&&s.charCodeAt(s.length-1)===47}return!r&&!(0,e.hasTrailingPathSeparator)(D,b)?D.with({path:D.path+"/"}):D}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(C=>C.scheme===L.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new v(C=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(C,D){const b=[];for(let r=0;r<C.length;r++){const s=D(C[r]);C.some((c,f)=>f===r?!1:(0,e.isEqualOrParent)(s,D(c)))||b.push(C[r])}return b}e.distinctParents=R;var k;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function D(b){const r=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(f=>{const[S,I]=f.split(":");S&&I&&r.set(S,I)});const c=b.path.substring(0,b.path.indexOf(";"));return c&&r.set(C.META_DATA_MIME,c),r}C.parseMetaData=D})(k||(e.DataUri=k={}));function p(C,D,b){if(D){let r=C.path;return r&&r[0]!==d.posix.sep&&(r=d.posix.sep+r),C.with({scheme:b,authority:D,path:r})}return C.with({scheme:b})}e.toLocalResource=p}),define(De[17],Ie([1,0,21,8,3,4,24,11,154]),function(me,e,_,L,d,A,T,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(he){return!!he&&typeof he.then=="function"}e.isThenable=v;function R(he){const z=new _.CancellationTokenSource,Z=he(z.token),ye=new Promise((Re,ne)=>{const ee=z.token.onCancellationRequested(()=>{ee.dispose(),z.dispose(),ne(new L.CancellationError)});Promise.resolve(Z).then(de=>{ee.dispose(),z.dispose(),Re(de)},de=>{ee.dispose(),z.dispose(),ne(de)})});return new class{cancel(){z.cancel()}then(Re,ne){return ye.then(Re,ne)}catch(Re){return this.then(void 0,Re)}finally(Re){return ye.finally(Re)}}}e.createCancelablePromise=R;function k(he,z,Z){return new Promise((ye,Re)=>{const ne=z.onCancellationRequested(()=>{ne.dispose(),ye(Z)});he.then(ye,Re).finally(()=>ne.dispose())})}e.raceCancellation=k;function p(he,z){return new Promise((Z,ye)=>{const Re=z.onCancellationRequested(()=>{Re.dispose(),ye(new L.CancellationError)});he.then(Z,ye).finally(()=>Re.dispose())})}e.raceCancellationError=p;async function C(he){let z=-1;const Z=he.map((ye,Re)=>ye.then(ne=>(z=Re,ne)));try{return await Promise.race(Z)}finally{he.forEach((ye,Re)=>{Re!==z&&ye.cancel()})}}e.raceCancellablePromises=C;function D(he,z,Z){let ye;const Re=setTimeout(()=>{ye?.(void 0),Z?.()},z);return Promise.race([he.finally(()=>clearTimeout(Re)),new Promise(ne=>ye=ne)])}e.raceTimeout=D;function b(he){return new Promise((z,Z)=>{const ye=he();v(ye)?ye.then(z,Z):z(ye)})}e.asPromise=b;class r{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(z){if(this.isDisposed)throw new Error("Throttler is disposed");if(this.activePromise){if(this.queuedPromiseFactory=z,!this.queuedPromise){const Z=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ye=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ye};this.queuedPromise=new Promise(ye=>{this.activePromise.then(Z,Z).then(ye)})}return new Promise((Z,ye)=>{this.queuedPromise.then(Z,ye)})}return this.activePromise=z(),new Promise((Z,ye)=>{this.activePromise.then(Re=>{this.activePromise=null,Z(Re)},Re=>{this.activePromise=null,ye(Re)})})}dispose(){this.isDisposed=!0}}e.Throttler=r;class s{constructor(){this.current=Promise.resolve(null)}queue(z){return this.current=this.current.then(()=>z(),()=>z())}}e.Sequencer=s;class c{constructor(){this.promiseMap=new Map}queue(z,Z){const Re=(this.promiseMap.get(z)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.promiseMap.get(z)===Re&&this.promiseMap.delete(z)});return this.promiseMap.set(z,Re),Re}}e.SequencerByKey=c;const f=(he,z)=>{let Z=!0;const ye=setTimeout(()=>{Z=!1,z()},he);return{isTriggered:()=>Z,dispose:()=>{clearTimeout(ye),Z=!1}}},S=he=>{let z=!0;return queueMicrotask(()=>{z&&(z=!1,he())}),{isTriggered:()=>z,dispose:()=>{z=!1}}};class I{constructor(z){this.defaultDelay=z,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(z,Z=this.defaultDelay){this.task=z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Re,ne)=>{this.doResolve=Re,this.doReject=ne}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Re=this.task;return this.task=null,Re()}}));const ye=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Z===y.MicrotaskDelay?S(ye):f(Z,ye),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=I;class i{constructor(z){this.delayer=new I(z),this.throttler=new r}trigger(z,Z){return this.delayer.trigger(()=>this.throttler.queue(z),Z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=i;class a{constructor(){this._isOpen=!1,this._promise=new Promise((z,Z)=>{this._completePromise=z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class n extends a{constructor(z){super(),this._timeout=setTimeout(()=>this.open(),z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=n;function t(he,z){return z?new Promise((Z,ye)=>{const Re=setTimeout(()=>{ne.dispose(),Z()},he),ne=z.onCancellationRequested(()=>{clearTimeout(Re),ne.dispose(),ye(new L.CancellationError)})}):R(Z=>t(he,Z))}e.timeout=t;function o(he,z=0){const Z=setTimeout(he,z);return(0,A.toDisposable)(()=>clearTimeout(Z))}e.disposableTimeout=o;function g(he){const z=[];let Z=0;const ye=he.length;function Re(){return Z<ye?he[Z++]():null}function ne(ee){ee!=null&&z.push(ee);const de=Re();return de?de.then(ne):Promise.resolve(z)}return Promise.resolve(null).then(ne)}e.sequence=g;function l(he,z=ye=>!!ye,Z=null){let ye=0;const Re=he.length,ne=()=>{if(ye>=Re)return Promise.resolve(Z);const ee=he[ye++];return Promise.resolve(ee()).then(K=>z(K)?Promise.resolve(K):ne())};return ne()}e.first=l;function h(he,z=ye=>!!ye,Z=null){if(he.length===0)return Promise.resolve(Z);let ye=he.length;const Re=()=>{ye=-1;for(const ne of he)ne.cancel?.()};return new Promise((ne,ee)=>{for(const de of he)de.then(K=>{--ye>=0&&z(K)?(Re(),ne(K)):ye===0&&ne(Z)}).catch(K=>{--ye>=0&&(Re(),ee(K))})})}e.firstParallel=h;class w{constructor(z){this._size=0,this.maxDegreeOfParalellism=z,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new d.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(z){return this._size++,new Promise((Z,ye)=>{this.outstandingPromises.push({factory:z,c:Z,e:ye}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const z=this.outstandingPromises.shift();this.runningPromises++;const Z=z.factory();Z.then(z.c,z.e),Z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=w;class u extends w{constructor(){super(1)}}e.Queue=u;class E{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const z=new te;return this.drainers.add(z),z.p}isDrained(){for(const[,z]of this.queues)if(z.size>0)return!1;return!0}queueFor(z,Z=T.extUri){const ye=Z.getComparisonKey(z);let Re=this.queues.get(ye);return Re||(Re=new u,d.Event.once(Re.onDrained)(()=>{Re?.dispose(),this.queues.delete(ye),this.onDidQueueDrain()}),this.queues.set(ye,Re)),Re}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const z of this.drainers)z.complete();this.drainers.clear()}dispose(){for(const[,z]of this.queues)z.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=E;class P{constructor(z,Z){this._token=-1,typeof z=="function"&&typeof Z=="number"&&this.setIfNotSet(z,Z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(z,Z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,z()},Z)}setIfNotSet(z,Z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,z()},Z))}}e.TimeoutTimer=P;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(z,Z){this.cancel(),this._token=setInterval(()=>{z()},Z)}}e.IntervalTimer=O;class N{constructor(z,Z){this.timeoutToken=-1,this.runner=z,this.timeout=Z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,z)}get delay(){return this.timeout}set delay(z){this.timeout=z}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=N;class F{constructor(z,Z){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.runner=z,this.timeout=Z,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(z=this.timeout){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=F;class x extends N{constructor(z,Z){super(z,Z),this.units=[]}work(z){this.units.push(z),this.isScheduled()||this.schedule()}doRun(){const z=this.units;this.units=[],this.runner?.(z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class B extends A.Disposable{constructor(z,Z){super(),this.options=z,this.handler=Z,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(z){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+z.length>this.options.maxBufferedWork)return!1}else if(this.pending+z.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const Z of z)this.pendingWork.push(Z);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new N(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=he=>{(0,m.setTimeout0)(()=>{if(z)return;const Z=Date.now()+15;he(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Z-Date.now())}}))});let z=!1;return{dispose(){z||(z=!0)}}}:e.runWhenIdle=(he,z)=>{const Z=requestIdleCallback(he,typeof z=="number"?{timeout:z}:void 0);let ye=!1;return{dispose(){ye||(ye=!0,cancelIdleCallback(Z))}}}}();class U{constructor(z){this._didRun=!1,this._executor=()=>{try{this._value=z()}catch(Z){this._error=Z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=U;async function X(he,z,Z){let ye;for(let Re=0;Re<Z;Re++)try{return await he()}catch(ne){ye=ne,await t(z)}throw ye}e.retry=X;class j{hasPending(z){return this._pending?typeof z=="number"?this._pending.taskId===z:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(z,Z,ye){return this._pending={taskId:z,cancel:()=>ye?.(),promise:Z},Z.then(()=>this.donePending(z),()=>this.donePending(z)),Z}donePending(z){this._pending&&z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const z=this._next;this._next=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}setNext(z){if(this._next)this._next.run=z;else{let Z,ye;const Re=new Promise((ne,ee)=>{Z=ne,ye=ee});this._next={run:z,promise:Re,promiseResolve:Z,promiseReject:ye}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=j;class ge{constructor(z,Z=()=>Date.now()){this.interval=z,this.nowFn=Z,this.lastIncrementTime=0,this.value=0}increment(){const z=this.nowFn();return z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=z,this.value=0),this.value++,this.value}}e.IntervalCounter=ge;var ie;(function(he){he[he.Resolved=0]="Resolved",he[he.Rejected=1]="Rejected"})(ie||(ie={}));class te{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((z,Z)=>{this.completeCallback=z,this.errorCallback=Z})}complete(z){return new Promise(Z=>{this.completeCallback(z),this.outcome={outcome:0,value:z},Z()})}error(z){return new Promise(Z=>{this.errorCallback(z),this.outcome={outcome:1,value:z},Z()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=te;var $;(function(he){async function z(ye){let Re;const ne=await Promise.all(ye.map(ee=>ee.then(de=>de,de=>{Re||(Re=de)})));if(typeof Re<"u")throw Re;return ne}he.settled=z;function Z(ye){return new Promise(async(Re,ne)=>{try{await ye(Re,ne)}catch(ee){ne(ee)}})}he.withAsyncBody=Z})($||(e.Promises=$={}));var H;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(H||(H={}));class ce{static fromArray(z){return new ce(Z=>{Z.emitMany(z)})}static fromPromise(z){return new ce(async Z=>{Z.emitMany(await z)})}static fromPromises(z){return new ce(async Z=>{await Promise.all(z.map(async ye=>Z.emitOne(await ye)))})}static merge(z){return new ce(async Z=>{await Promise.all(z.map(async ye=>{for await(const Re of ye)Z.emitOne(Re)}))})}static{this.EMPTY=ce.fromArray([])}constructor(z){this._state=0,this._results=[],this._error=null,this._onStateChanged=new d.Emitter,queueMicrotask(async()=>{const Z={emitOne:ye=>this.emitOne(ye),emitMany:ye=>this.emitMany(ye),reject:ye=>this.reject(ye)};try{await Promise.resolve(z(Z)),this.resolve()}catch(ye){this.reject(ye)}finally{Z.emitOne=void 0,Z.emitMany=void 0,Z.reject=void 0}})}[Symbol.asyncIterator](){let z=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(z<this._results.length)return{done:!1,value:this._results[z++]};if(this._state===1)return{done:!0,value:void 0};await d.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(z,Z){return new ce(async ye=>{for await(const Re of z)ye.emitOne(Z(Re))})}map(z){return ce.map(this,z)}static filter(z,Z){return new ce(async ye=>{for await(const Re of z)Z(Re)&&ye.emitOne(Re)})}filter(z){return ce.filter(this,z)}static coalesce(z){return ce.filter(z,Z=>!!Z)}coalesce(){return ce.coalesce(this)}static async toPromise(z){const Z=[];for await(const ye of z)Z.push(ye);return Z}toPromise(){return ce.toPromise(this)}emitOne(z){this._state===0&&(this._results.push(z),this._onStateChanged.fire())}emitMany(z){this._state===0&&(this._results=this._results.concat(z),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(z){this._state===0&&(this._state=2,this._error=z,this._onStateChanged.fire())}}e.AsyncIterableObject=ce;class re extends ce{constructor(z,Z){super(Z),this._source=z}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=re;function fe(he){const z=new _.CancellationTokenSource,Z=he(z.token);return new re(z,async ye=>{const Re=z.token.onCancellationRequested(()=>{Re.dispose(),z.dispose(),ye.reject(new L.CancellationError)});try{for await(const ne of Z){if(z.token.isCancellationRequested)return;ye.emitOne(ne)}Re.dispose(),z.dispose()}catch(ne){Re.dispose(),z.dispose(),ye.reject(ne)}})}e.createCancelableAsyncIterable=fe}),define(De[34],Ie([1,0,19,17,31,28,13,11,12]),function(me,e,_,L,d,A,T,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function v(){return Object.create(null)}e.getEmptyExpression=v,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",k="[^/\\\\]",p=/\//g;function C(ge,ie){switch(ge){case 0:return"";case 1:return`${k}*?`;default:return`(?:${R}|${k}+${R}${ie?`|${R}${k}+`:""})*?`}}function D(ge,ie){if(!ge)return[];const te=[];let $=!1,H=!1,ce="";for(const re of ge){switch(re){case ie:if(!$&&!H){te.push(ce),ce="";continue}break;case"{":$=!0;break;case"}":$=!1;break;case"[":H=!0;break;case"]":H=!1;break}ce+=re}return ce&&te.push(ce),te}e.splitGlobAware=D;function b(ge){if(!ge)return"";let ie="";const te=D(ge,e.GLOB_SPLIT);if(te.every($=>$===e.GLOBSTAR))ie=".*";else{let $=!1;te.forEach((H,ce)=>{if(H===e.GLOBSTAR){if($)return;ie+=C(2,ce===te.length-1)}else{let re=!1,fe="",he=!1,z="";for(const Z of H){if(Z!=="}"&&re){fe+=Z;continue}if(he&&(Z!=="]"||!z)){let ye;Z==="-"?ye=Z:(Z==="^"||Z==="!")&&!z?ye="^":Z===e.GLOB_SPLIT?ye="":ye=(0,y.escapeRegExpCharacters)(Z),z+=ye;continue}switch(Z){case"{":re=!0;continue;case"[":he=!0;continue;case"}":{const Re=`(?:${D(fe,",").map(ne=>b(ne)).join("|")})`;ie+=Re,re=!1,fe="";break}case"]":{ie+="["+z+"]",he=!1,z="";break}case"?":ie+=k;continue;case"*":ie+=C(1);continue;default:ie+=(0,y.escapeRegExpCharacters)(Z)}}ce<te.length-1&&(te[ce+1]!==e.GLOBSTAR||ce+2<te.length)&&(ie+=R)}$=H===e.GLOBSTAR})}return ie}const r=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,I=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new A.LRUCache(1e4),a=function(){return!1},n=function(){return null};function t(ge,ie){if(!ge)return n;let te;typeof ge!="string"?te=ge.pattern:te=ge,te=te.trim();const $=`${te}_${!!ie.trimForExclusions}`;let H=i.get($);if(H)return o(H,ge);let ce;return r.test(te)?H=l(te.substr(4),te):(ce=s.exec(g(te,ie)))?H=h(ce[1],te):(ie.trimForExclusions?f:c).test(te)?H=w(te,ie):(ce=S.exec(g(te,ie)))?H=u(ce[1].substr(1),te,!0):(ce=I.exec(g(te,ie)))?H=u(ce[1],te,!1):H=E(te),i.set($,H),o(H,ge)}function o(ge,ie){if(typeof ie=="string")return ge;const te=function($,H){return(0,d.isEqualOrParent)($,ie.base,!m.isLinux)?ge((0,y.ltrim)($.substr(ie.base.length),T.sep),H):null};return te.allBasenames=ge.allBasenames,te.allPaths=ge.allPaths,te.basenames=ge.basenames,te.patterns=ge.patterns,te}function g(ge,ie){return ie.trimForExclusions&&ge.endsWith("/**")?ge.substr(0,ge.length-2):ge}function l(ge,ie){return function(te,$){return typeof te=="string"&&te.endsWith(ge)?ie:null}}function h(ge,ie){const te=`/${ge}`,$=`\\${ge}`,H=function(re,fe){return typeof re!="string"?null:fe?fe===ge?ie:null:re===ge||re.endsWith(te)||re.endsWith($)?ie:null},ce=[ge];return H.basenames=ce,H.patterns=[ie],H.allBasenames=ce,H}function w(ge,ie){const te=X(ge.slice(1,-1).split(",").map(fe=>t(fe,ie)).filter(fe=>fe!==n),ge),$=te.length;if(!$)return n;if($===1)return te[0];const H=function(fe,he){for(let z=0,Z=te.length;z<Z;z++)if(te[z](fe,he))return ge;return null},ce=te.find(fe=>!!fe.allBasenames);ce&&(H.allBasenames=ce.allBasenames);const re=te.reduce((fe,he)=>he.allPaths?fe.concat(he.allPaths):fe,[]);return re.length&&(H.allPaths=re),H}function u(ge,ie,te){const $=T.sep===T.posix.sep,H=$?ge:ge.replace(p,T.sep),ce=T.sep+H,re=T.posix.sep+ge;let fe;return te?fe=function(he,z){return typeof he=="string"&&(he===H||he.endsWith(ce)||!$&&(he===ge||he.endsWith(re)))?ie:null}:fe=function(he,z){return typeof he=="string"&&(he===H||!$&&he===ge)?ie:null},fe.allPaths=[(te?"*/":"./")+ge],fe}function E(ge){try{const ie=new RegExp(`^${b(ge)}$`);return function(te){return ie.lastIndex=0,typeof te=="string"&&ie.test(te)?ge:null}}catch{return n}}function P(ge,ie,te){return!ge||typeof ie!="string"?!1:O(ge)(ie,void 0,te)}e.match=P;function O(ge,ie={}){if(!ge)return a;if(typeof ge=="string"||N(ge)){const te=t(ge,ie);if(te===n)return a;const $=function(H,ce){return!!te(H,ce)};return te.allBasenames&&($.allBasenames=te.allBasenames),te.allPaths&&($.allPaths=te.allPaths),$}return B(ge,ie)}e.parse=O;function N(ge){const ie=ge;return ie?typeof ie.base=="string"&&typeof ie.pattern=="string":!1}e.isRelativePattern=N;function F(ge){return ge.allBasenames||[]}e.getBasenameTerms=F;function x(ge){return ge.allPaths||[]}e.getPathTerms=x;function B(ge,ie){const te=X(Object.getOwnPropertyNames(ge).map(fe=>U(fe,ge[fe],ie)).filter(fe=>fe!==n)),$=te.length;if(!$)return n;if(!te.some(fe=>!!fe.requiresSiblings)){if($===1)return te[0];const fe=function(Z,ye){let Re;for(let ne=0,ee=te.length;ne<ee;ne++){const de=te[ne](Z,ye);if(typeof de=="string")return de;(0,L.isThenable)(de)&&(Re||(Re=[]),Re.push(de))}return Re?(async()=>{for(const ne of Re){const ee=await ne;if(typeof ee=="string")return ee}return null})():null},he=te.find(Z=>!!Z.allBasenames);he&&(fe.allBasenames=he.allBasenames);const z=te.reduce((Z,ye)=>ye.allPaths?Z.concat(ye.allPaths):Z,[]);return z.length&&(fe.allPaths=z),fe}const H=function(fe,he,z){let Z,ye;for(let Re=0,ne=te.length;Re<ne;Re++){const ee=te[Re];ee.requiresSiblings&&z&&(he||(he=(0,T.basename)(fe)),Z||(Z=he.substr(0,he.length-(0,T.extname)(fe).length)));const de=ee(fe,he,Z,z);if(typeof de=="string")return de;(0,L.isThenable)(de)&&(ye||(ye=[]),ye.push(de))}return ye?(async()=>{for(const Re of ye){const ne=await Re;if(typeof ne=="string")return ne}return null})():null},ce=te.find(fe=>!!fe.allBasenames);ce&&(H.allBasenames=ce.allBasenames);const re=te.reduce((fe,he)=>he.allPaths?fe.concat(he.allPaths):fe,[]);return re.length&&(H.allPaths=re),H}function U(ge,ie,te){if(ie===!1)return n;const $=t(ge,te);if($===n)return n;if(typeof ie=="boolean")return $;if(ie){const H=ie.when;if(typeof H=="string"){const ce=(re,fe,he,z)=>{if(!z||!$(re,fe))return null;const Z=H.replace("$(basename)",()=>he),ye=z(Z);return(0,L.isThenable)(ye)?ye.then(Re=>Re?ge:null):ye?ge:null};return ce.requiresSiblings=!0,ce}}return $}function X(ge,ie){const te=ge.filter(fe=>!!fe.basenames);if(te.length<2)return ge;const $=te.reduce((fe,he)=>{const z=he.basenames;return z?fe.concat(z):fe},[]);let H;if(ie){H=[];for(let fe=0,he=$.length;fe<he;fe++)H.push(ie)}else H=te.reduce((fe,he)=>{const z=he.patterns;return z?fe.concat(z):fe},[]);const ce=function(fe,he){if(typeof fe!="string")return null;if(!he){let Z;for(Z=fe.length;Z>0;Z--){const ye=fe.charCodeAt(Z-1);if(ye===47||ye===92)break}he=fe.substr(Z)}const z=$.indexOf(he);return z!==-1?H[z]:null};ce.basenames=$,ce.patterns=H,ce.allBasenames=$;const re=ge.filter(fe=>!fe.basenames);return re.push(ce),re}function j(ge,ie){return(0,_.equals)(ge,ie,(te,$)=>typeof te=="string"&&typeof $=="string"?te===$:typeof te!="string"&&typeof $!="string"?te.base===$.base&&te.pattern===$.pattern:!1)}e.patternsEquals=j}),define(De[74],Ie([1,0,8,155,24,12,2]),function(me,e,_,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class y{constructor(s="",c=!1){if(this.value=s,typeof this.value!="string")throw(0,_.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(s,c=0){return this.value+=p(this.supportThemeIcons?(0,L.escapeIcons)(s):s).replace(/([ \t]+)/g,(f,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,c){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(s,c,f){return this.value+="[",this.value+=this._escape(c,"]"),this.value+="](",this.value+=this._escape(String(s),")"),f&&(this.value+=` "${this._escape(this._escape(f,'"'),")")}"`),this.value+=")",this}_escape(s,c){const f=new RegExp((0,A.escapeRegExpCharacters)(c),"g");return s.replace(f,(S,I)=>s.charAt(I-1)!=="\\"?`\\${S}`:S)}}e.MarkdownString=y;function v(r){return R(r)?!r.value:Array.isArray(r)?r.every(v):!0}e.isEmptyMarkdownString=v;function R(r){return r instanceof y?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function k(r,s){return r===s?!0:!r||!s?!1:r.value===s.value&&r.isTrusted===s.isTrusted&&r.supportThemeIcons===s.supportThemeIcons&&r.supportHtml===s.supportHtml&&(r.baseUri===s.baseUri||!!r.baseUri&&!!s.baseUri&&(0,d.isEqual)(T.URI.from(r.baseUri),T.URI.from(s.baseUri)))}e.markdownStringEqual=k;function p(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=p;function C(r){return r.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=C;function D(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=D;function b(r){const s=[],c=r.split("|").map(S=>S.trim());r=c[0];const f=c[1];if(f){const S=/height=(\d+)/.exec(f),I=/width=(\d+)/.exec(f),i=S?S[1]:"",a=I?I[1]:"",n=isFinite(parseInt(a)),t=isFinite(parseInt(i));n&&s.push(`width="${a}"`),t&&s.push(`height="${i}"`)}return{href:r,dimensions:s}}e.parseHrefAndDimensions=b}),define(De[120],Ie([1,0,19,31,13,11,24,12]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(t,o){const{os:g,tildify:l,relative:h}=o;if(h){const E=v(t,h,g);if(typeof E=="string")return E}let w=t.fsPath;if(g===1&&!A.isWindows?w=w.replace(/\//g,"\\"):g!==1&&A.isWindows&&(w=w.replace(/\\/g,"/")),g!==1&&l?.userHome){const E=l.userHome.fsPath;let P;t.scheme!==l.userHome.scheme&&t.path.startsWith(d.posix.sep)?P=l.userHome.with({path:t.path}).fsPath:P=t.fsPath,w=p(P,E,g)}return(g===1?d.win32:d.posix).normalize(R(w,g===1))}e.getPathLabel=y;function v(t,o,g){const l=g===1?d.win32:d.posix,h=g===3?T.extUri:T.extUriIgnorePathCase,w=o.getWorkspace(),u=(0,_.firstOrDefault)(w.folders);if(!u)return;t.scheme!==u.uri.scheme&&t.path.startsWith(d.posix.sep)&&(t=u.uri.with({path:t.path}));const E=o.getWorkspaceFolder(t);if(!E)return;let P;if(h.isEqual(E.uri,t)?P="":P=h.relativePath(E.uri,t)??"",P&&(P=l.normalize(P)),w.folders.length>1&&!o.noPrefix){const O=E.name?E.name:h.basenameOrAuthority(E.uri);P=P?`${O} \u2022 ${P}`:O}return P}function R(t,o=A.isWindows){return(0,L.hasDriveLetter)(t,o)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=R;let k=Object.create(null);function p(t,o,g=A.OS){if(g===1||!t||!o)return t;let l=k.original===o?k.normalized:void 0;l||(l=o,A.isWindows&&(l=(0,L.toSlashes)(l)),l=`${(0,m.rtrim)(l,d.posix.sep)}${d.posix.sep}`,k={original:o,normalized:l});let h=t;return A.isWindows&&(h=(0,L.toSlashes)(h)),(g===3?h.startsWith(l):(0,m.startsWithIgnoreCase)(h,l))?`~/${h.substr(l.length)}`:t}e.tildify=p;function C(t,o){return t.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=C;const D="\u2026",b="\\\\",r="~";function s(t,o=d.sep){const g=new Array(t.length);let l=!1;for(let h=0;h<t.length;h++){const w=t[h];if(w===""){g[h]=`.${o}`;continue}if(!w){g[h]=w;continue}l=!0;let u="",E=w;E.indexOf(b)===0?(u=E.substr(0,E.indexOf(b)+b.length),E=E.substr(E.indexOf(b)+b.length)):E.indexOf(o)===0?(u=E.substr(0,E.indexOf(o)+o.length),E=E.substr(E.indexOf(o)+o.length)):E.indexOf(r)===0&&(u=E.substr(0,E.indexOf(r)+r.length),E=E.substr(E.indexOf(r)+r.length));const P=E.split(o);for(let O=1;l&&O<=P.length;O++)for(let N=P.length-O;l&&N>=0;N--){l=!1;let F=P.slice(N,N+O).join(o);for(let x=0;!l&&x<t.length;x++)if(x!==h&&t[x]&&t[x].indexOf(F)>-1){const B=N+O===P.length,U=N>0&&t[x].indexOf(o)>-1?o+F:F,X=t[x].endsWith(U);l=!B||X}if(!l){let x="";(P[0].endsWith(":")||u!=="")&&(N===1&&(N=0,O++,F=P[0]+o+F),N>0&&(x=P[0]+o),x=u+x),N>0&&(x=x+D+o),x=x+F,N+O<P.length&&(x=x+o+D),g[h]=x}}l&&(g[h]=w)}return g}e.shorten=s;var c;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function f(t,o=Object.create(null)){const g=[];let l=!1,h="";for(const w of t)if(w==="$"||l&&w==="{")h&&g.push({value:h,type:c.TEXT}),h="",l=!0;else if(w==="}"&&l){const u=o[h];if(typeof u=="string")u.length&&g.push({value:u,type:c.VARIABLE});else if(u){const E=g[g.length-1];(!E||E.type!==c.SEPARATOR)&&g.push({value:u.label,type:c.SEPARATOR})}h="",l=!1}else h+=w;return h&&!l&&g.push({value:h,type:c.TEXT}),g.filter((w,u)=>{if(w.type===c.SEPARATOR){const E=g[u-1],P=g[u+1];return[E,P].every(O=>O&&(O.type===c.VARIABLE||O.type===c.TEXT)&&O.value.length>0)}return!0}).map(w=>w.value).join("")}e.template=f;function S(t,o){return A.isMacintosh||o?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):t.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function I(t,o){return A.isMacintosh||o?t.replace(/\(&&\w\)|&&/g,""):A.isWindows?t.replace(/&&|&/g,g=>g==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=I;function i(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=i;function a(t){if(t.endsWith("]")){const o=t.lastIndexOf(" [",t.length-2);if(o!==-1){const g=n(t.substring(0,o));return{name:g.name,parentPath:g.parentPath+t.substring(o)}}}return n(t)}e.splitRecentLabel=a;function n(t){const o=t.indexOf("/")!==-1?d.posix:d.win32,g=o.basename(t),l=o.dirname(t);return g.length?{name:g,parentPath:l}:{name:l,parentPath:""}}}),define(De[121],Ie([1,0,22,2]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function d(k){return k.toJSON()}class A{constructor(p){this._uriTransformer=p}transformIncoming(p){const C=this._uriTransformer.transformIncoming(p);return C===p?p:d(L.URI.from(C))}transformOutgoing(p){const C=this._uriTransformer.transformOutgoing(p);return C===p?p:d(L.URI.from(C))}transformOutgoingURI(p){const C=this._uriTransformer.transformOutgoing(p);return C===p?p:L.URI.from(C)}transformOutgoingScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function T(k,p,C){if(!k||C>200)return null;if(typeof k=="object"){if(k instanceof L.URI)return p.transformOutgoing(k);for(const D in k)if(Object.hasOwnProperty.call(k,D)){const b=T(k[D],p,C+1);b!==null&&(k[D]=b)}}return null}function m(k,p){const C=T(k,p,0);return C===null?k:C}e.transformOutgoingURIs=m;function y(k,p,C,D){if(!k||D>200)return null;if(typeof k=="object"){if(k.$mid===1)return C?L.URI.revive(p.transformIncoming(k)):p.transformIncoming(k);if(k instanceof _.VSBuffer)return null;for(const b in k)if(Object.hasOwnProperty.call(k,b)){const r=y(k[b],p,C,D+1);r!==null&&(k[b]=r)}}return null}function v(k,p){const C=y(k,p,!1,0);return C===null?k:C}e.transformIncomingURIs=v;function R(k,p){const C=y(k,p,!0,0);return C===null?k:C}e.transformAndReviveIncomingURIs=R}),define(De[29],Ie([1,0,49,75,350,17,31,69,13,11,24,2]),function(me,e,_,L,d,A,T,m,y,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function C(B,U=p.UNLINK,X){if((0,T.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return U===p.UNLINK?b(B):D(B,X)}async function D(B,U=(0,T.randomPath)((0,L.tmpdir)())){try{try{await _.promises.rename(B,U)}catch(X){return X.code==="ENOENT"?void 0:b(B)}b(U).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function b(B){return(0,d.promisify)(_.rm)(B,{recursive:!0,force:!0,maxRetries:3})}function r(B){if((0,T.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");_.rmSync(B,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=r;async function s(B,U){return S(await(U?c(B):(0,d.promisify)(_.readdir)(B)))}async function c(B){try{return await(0,d.promisify)(_.readdir)(B,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const U=[],X=await s(B);for(const j of X){let ge=!1,ie=!1,te=!1;try{const $=await e.Promises.lstat((0,y.join)(B,j));ge=$.isFile(),ie=$.isDirectory(),te=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}U.push({name:j,isFile:()=>ge,isDirectory:()=>ie,isSymbolicLink:()=>te})}return U}function f(B){return S(_.readdirSync(B))}e.readdirSync=f;function S(B){return B.map(U=>typeof U=="string"?v.isMacintosh?(0,m.normalizeNFC)(U):U:(U.name=v.isMacintosh?(0,m.normalizeNFC)(U.name):U.name,U))}async function I(B){const U=await s(B),X=[];for(const j of U)await a.existsDirectory((0,y.join)(B,j))&&X.push(j);return X}function i(B,U=1e3){return new Promise(X=>{let j=!1;const ge=setInterval(()=>{j||(j=!0,_.access(B,ie=>{j=!1,ie&&(clearInterval(ge),X(void 0))}))},U)})}e.whenDeleted=i;var a;(function(B){async function U(ge){let ie;try{if(ie=await e.Promises.lstat(ge),!ie.isSymbolicLink())return{stat:ie}}catch{}try{return{stat:await e.Promises.stat(ge),symbolicLink:ie?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};if(v.isWindows&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ge)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};throw $}throw te}}B.stat=U;async function X(ge){try{const{stat:ie,symbolicLink:te}=await B.stat(ge);return ie.isFile()&&te?.dangling!==!0}catch{}return!1}B.existsFile=X;async function j(ge){try{const{stat:ie,symbolicLink:te}=await B.stat(ge);return ie.isDirectory()&&te?.dangling!==!0}catch{}return!1}B.existsDirectory=j})(a||(e.SymlinkSupport=a={}));const n=new A.ResourceQueue;function t(B,U,X){return n.queueFor(k.URI.file(B),R.extUriBiasedIgnorePathCase).queue(()=>{const j=w(X);return new Promise((ge,ie)=>l(B,U,j,te=>te?ie(te):ge()))})}let o=!0;function g(B){o=B}e.configureFlushOnWrite=g;function l(B,U,X,j){if(!o)return _.writeFile(B,U,{mode:X.mode,flag:X.flag},j);_.open(B,X.flag,X.mode,(ge,ie)=>{if(ge)return j(ge);_.writeFile(ie,U,te=>{if(te)return _.close(ie,()=>j(te));_.fdatasync(ie,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),g(!1)),_.close(ie,H=>j(H))))})})}function h(B,U,X){const j=w(X);if(!o)return _.writeFileSync(B,U,{mode:j.mode,flag:j.flag});const ge=_.openSync(B,j.flag,j.mode);try{_.writeFileSync(ge,U);try{_.fdatasyncSync(ge)}catch(ie){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",ie),g(!1)}}finally{_.closeSync(ge)}}e.writeFileSync=h;function w(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function u(B,U){if(B!==U)try{await e.Promises.rename(B,U)}catch(X){if(B.toLowerCase()!==U.toLowerCase()&&X.code==="EXDEV"||B.endsWith("."))await E(B,U,{preserveSymlinks:!1}),await C(B,p.MOVE);else throw X}}async function E(B,U,X){return O(B,U,{root:{source:B,target:U},options:X,handledSourcePaths:new Set})}const P=511;async function O(B,U,X){if(X.handledSourcePaths.has(B))return;X.handledSourcePaths.add(B);const{stat:j,symbolicLink:ge}=await a.stat(B);if(ge){if(X.options.preserveSymlinks)try{return await x(B,U,X)}catch(ie){console.warn("[node.js fs] copy of symlink failed: ",ie)}if(ge.dangling)return}return j.isDirectory()?N(B,U,j.mode&P,X):F(B,U,j.mode&P)}async function N(B,U,X,j){await e.Promises.mkdir(U,{recursive:!0,mode:X});const ge=await s(B);for(const ie of ge)await O((0,y.join)(B,ie),(0,y.join)(U,ie),j)}async function F(B,U,X){await e.Promises.copyFile(B,U),await e.Promises.chmod(U,X)}async function x(B,U,X){let j=await e.Promises.readlink(B);(0,T.isEqualOrParent)(j,X.root.source,!v.isLinux)&&(j=(0,y.join)(X.root.target,j.substr(X.root.source.length+1))),await e.Promises.symlink(j,U)}e.Promises=new class{get access(){return(0,d.promisify)(_.access)}get stat(){return(0,d.promisify)(_.stat)}get lstat(){return(0,d.promisify)(_.lstat)}get utimes(){return(0,d.promisify)(_.utimes)}get read(){return(B,U,X,j,ge)=>new Promise((ie,te)=>{_.read(B,U,X,j,ge,($,H,ce)=>$?te($):ie({bytesRead:H,buffer:ce}))})}get readFile(){return(0,d.promisify)(_.readFile)}get write(){return(B,U,X,j,ge)=>new Promise((ie,te)=>{_.write(B,U,X,j,ge,($,H,ce)=>$?te($):ie({bytesWritten:H,buffer:ce}))})}get appendFile(){return(0,d.promisify)(_.appendFile)}get fdatasync(){return(0,d.promisify)(_.fdatasync)}get truncate(){return(0,d.promisify)(_.truncate)}get rename(){return(0,d.promisify)(_.rename)}get copyFile(){return(0,d.promisify)(_.copyFile)}get open(){return(0,d.promisify)(_.open)}get close(){return(0,d.promisify)(_.close)}get symlink(){return(0,d.promisify)(_.symlink)}get readlink(){return(0,d.promisify)(_.readlink)}get chmod(){return(0,d.promisify)(_.chmod)}get mkdir(){return(0,d.promisify)(_.mkdir)}get unlink(){return(0,d.promisify)(_.unlink)}get rmdir(){return(0,d.promisify)(_.rmdir)}get realpath(){return(0,d.promisify)(_.realpath)}async exists(B){try{return await e.Promises.access(B),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return I}get writeFile(){return t}get rm(){return C}get move(){return u}get copy(){return E}}}),define(De[95],Ie([1,0,49,13,11,12,29]),function(me,e,_,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function m(p){if(d.isLinux)return p;const C=(0,L.dirname)(p);if(p===C)return p;const D=((0,L.basename)(p)||p).toLowerCase();try{const r=(0,T.readdirSync)(C).filter(s=>s.toLowerCase()===D);if(r.length===1){const s=m(C);if(s)return(0,L.join)(s,r[0])}else if(r.length>1){const s=r.indexOf(D);if(s>=0){const c=m(C);if(c)return(0,L.join)(c,r[s])}}}catch{}return null}e.realcaseSync=m;async function y(p){if(d.isLinux)return p;const C=(0,L.dirname)(p);if(p===C)return p;const D=((0,L.basename)(p)||p).toLowerCase();try{const r=(await T.Promises.readdir(C)).filter(s=>s.toLowerCase()===D);if(r.length===1){const s=await y(C);if(s)return(0,L.join)(s,r[0])}else if(r.length>1){const s=r.indexOf(D);if(s>=0){const c=await y(C);if(c)return(0,L.join)(c,r[s])}}}catch{}return null}e.realcase=y;async function v(p){try{return await T.Promises.realpath(p)}catch{const D=k(p);return await T.Promises.access(D,_.constants.R_OK),D}}e.realpath=v;function R(p){try{return _.realpathSync(p)}catch{const D=k(p);return _.accessSync(D,_.constants.R_OK),D}}e.realpathSync=R;function k(p){return(0,A.rtrim)((0,L.normalize)(p),L.sep)}}),define(De[96],Ie([1,0,13,11,41,94,14,29]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function y(k=d.env){return k.comspec||"cmd.exe"}e.getWindowsShell=y;function v(k){let p=[],C=!1;const D=function(b){if(C){p.push(b);return}(!k.send(b,s=>{if(s&&console.error(s),C=!1,p.length>0){const c=p.slice(0);p=[],c.forEach(f=>D(f))}})||L.isWindows)&&(C=!0)};return{send:D}}e.createQueuedSender=v;var R;(function(k){async function p(C,D,b){if(_.isAbsolute(C))return C;if(D===void 0&&(D=d.cwd()),_.dirname(C)!=="."||(b===void 0&&T.isString(d.env.PATH)&&(b=d.env.PATH.split(_.delimiter)),b===void 0||b.length===0))return _.join(D,C);async function s(c){if(await m.Promises.exists(c)){let f;try{f=await m.Promises.stat(c)}catch(S){S.message.startsWith("EACCES")&&(f=await m.Promises.lstat(c))}return f?!f.isDirectory():!1}return!1}for(const c of b){let f;if(_.isAbsolute(c)?f=_.join(c,C):f=_.join(D,c,C),await s(f))return f;let S=f+".com";if(await s(S)||(S=f+".exe",await s(S)))return S}return _.join(D,C)}k.findExecutable=p})(R||(e.win32=R={}))});var Ve=this&&this.__decorate||function(me,e,_,L){var d=arguments.length,A=d<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,_):L,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(me,e,_,L);else for(var m=me.length-1;m>=0;m--)(T=me[m])&&(A=(d<3?T(A):d>3?T(e,_,A):T(e,_))||A);return d>3&&A&&Object.defineProperty(e,_,A),A};define(De[76],Ie([1,0,19,17,22,21,66,8,3,4,73,12,14]),function(me,e,_,L,d,A,T,m,y,v,R,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var C;(function(ie){ie[ie.Promise=100]="Promise",ie[ie.PromiseCancel=101]="PromiseCancel",ie[ie.EventListen=102]="EventListen",ie[ie.EventDispose=103]="EventDispose"})(C||(C={}));function D(ie){switch(ie){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(ie){ie[ie.Initialize=200]="Initialize",ie[ie.PromiseSuccess=201]="PromiseSuccess",ie[ie.PromiseError=202]="PromiseError",ie[ie.PromiseErrorObj=203]="PromiseErrorObj",ie[ie.EventFire=204]="EventFire"})(b||(b={}));function r(ie){switch(ie){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(ie){ie[ie.Uninitialized=0]="Uninitialized",ie[ie.Idle=1]="Idle"})(s||(s={}));function c(ie){let te=0;for(let $=0;;$+=7){const H=ie.read(1);if(te|=(H.buffer[0]&127)<<$,!(H.buffer[0]&128))return te}}const f=n(0);function S(ie,te){if(te===0){ie.write(f);return}let $=0;for(let ce=te;ce!==0;ce=ce>>>7)$++;const H=d.VSBuffer.alloc($);for(let ce=0;te!==0;ce++)H.buffer[ce]=te&127,te=te>>>7,te>0&&(H.buffer[ce]|=128);ie.write(H)}class I{constructor(te){this.buffer=te,this.pos=0}read(te){const $=this.buffer.slice(this.pos,this.pos+te);return this.pos+=$.byteLength,$}}e.BufferReader=I;class i{constructor(){this.buffers=[]}get buffer(){return d.VSBuffer.concat(this.buffers)}write(te){this.buffers.push(te)}}e.BufferWriter=i;var a;(function(ie){ie[ie.Undefined=0]="Undefined",ie[ie.String=1]="String",ie[ie.Buffer=2]="Buffer",ie[ie.VSBuffer=3]="VSBuffer",ie[ie.Array=4]="Array",ie[ie.Object=5]="Object",ie[ie.Int=6]="Int"})(a||(a={}));function n(ie){const te=d.VSBuffer.alloc(1);return te.writeUInt8(ie,0),te}const t={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object),Uint:n(a.Int)},o=typeof Buffer<"u";function g(ie,te){if(typeof te>"u")ie.write(t.Undefined);else if(typeof te=="string"){const $=d.VSBuffer.fromString(te);ie.write(t.String),S(ie,$.byteLength),ie.write($)}else if(o&&Buffer.isBuffer(te)){const $=d.VSBuffer.wrap(te);ie.write(t.Buffer),S(ie,$.byteLength),ie.write($)}else if(te instanceof d.VSBuffer)ie.write(t.VSBuffer),S(ie,te.byteLength),ie.write(te);else if(Array.isArray(te)){ie.write(t.Array),S(ie,te.length);for(const $ of te)g(ie,$)}else if(typeof te=="number"&&(te|0)===te)ie.write(t.Uint),S(ie,te);else{const $=d.VSBuffer.fromString(JSON.stringify(te));ie.write(t.Object),S(ie,$.byteLength),ie.write($)}}e.serialize=g;function l(ie){switch(ie.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return ie.read(c(ie)).toString();case a.Buffer:return ie.read(c(ie)).buffer;case a.VSBuffer:return ie.read(c(ie));case a.Array:{const $=c(ie),H=[];for(let ce=0;ce<$;ce++)H.push(l(ie));return H}case a.Object:return JSON.parse(ie.read(c(ie)).toString());case a.Int:return c(ie)}}e.deserialize=l;class h{constructor(te,$,H=null,ce=1e3){this.protocol=te,this.ctx=$,this.logger=H,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(re=>this.onRawMessage(re)),this.sendResponse({type:200})}registerChannel(te,$){this.channels.set(te,$),setTimeout(()=>this.flushPendingRequests(te),0)}sendResponse(te){switch(te.type){case 200:{const $=this.send([te.type]);this.logger?.logOutgoing($,0,1,r(te.type));return}case 201:case 202:case 204:case 203:{const $=this.send([te.type,te.id],te.data);this.logger?.logOutgoing($,te.id,1,r(te.type),te.data);return}}}send(te,$=void 0){const H=new i;return g(H,te),g(H,$),this.sendBuffer(H.buffer)}sendBuffer(te){try{return this.protocol.send(te),te.byteLength}catch{return 0}}onRawMessage(te){const $=new I(te),H=l($),ce=l($),re=H[0];switch(re){case 100:return this.logger?.logIncoming(te.byteLength,H[1],1,`${D(re)}: ${H[2]}.${H[3]}`,ce),this.onPromise({type:re,id:H[1],channelName:H[2],name:H[3],arg:ce});case 102:return this.logger?.logIncoming(te.byteLength,H[1],1,`${D(re)}: ${H[2]}.${H[3]}`,ce),this.onEventListen({type:re,id:H[1],channelName:H[2],name:H[3],arg:ce});case 101:return this.logger?.logIncoming(te.byteLength,H[1],1,`${D(re)}`),this.disposeActiveRequest({type:re,id:H[1]});case 103:return this.logger?.logIncoming(te.byteLength,H[1],1,`${D(re)}`),this.disposeActiveRequest({type:re,id:H[1]})}}onPromise(te){const $=this.channels.get(te.channelName);if(!$){this.collectPendingRequest(te);return}const H=new A.CancellationTokenSource;let ce;try{ce=$.call(this.ctx,te.name,te.arg,H.token)}catch(he){ce=Promise.reject(he)}const re=te.id;ce.then(he=>{this.sendResponse({id:re,data:he,type:201}),this.activeRequests.delete(te.id)},he=>{he instanceof Error?this.sendResponse({id:re,data:{message:he.message,name:he.name,stack:he.stack?he.stack.split?he.stack.split(`
`):he.stack:void 0},type:202}):this.sendResponse({id:re,data:he,type:203}),this.activeRequests.delete(te.id)});const fe=(0,v.toDisposable)(()=>H.cancel());this.activeRequests.set(te.id,fe)}onEventListen(te){const $=this.channels.get(te.channelName);if(!$){this.collectPendingRequest(te);return}const H=te.id,re=$.listen(this.ctx,te.name,te.arg)(fe=>this.sendResponse({id:H,data:fe,type:204}));this.activeRequests.set(te.id,re)}disposeActiveRequest(te){const $=this.activeRequests.get(te.id);$&&($.dispose(),this.activeRequests.delete(te.id))}collectPendingRequest(te){let $=this.pendingRequests.get(te.channelName);$||($=[],this.pendingRequests.set(te.channelName,$));const H=setTimeout(()=>{console.error(`Unknown channel: ${te.channelName}`),te.type===100&&this.sendResponse({id:te.id,data:{name:"Unknown channel",message:`Channel name '${te.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);$.push({request:te,timeoutTimer:H})}flushPendingRequests(te){const $=this.pendingRequests.get(te);if($){for(const H of $)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(te)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=h;var w;(function(ie){ie[ie.LocalSide=0]="LocalSide",ie[ie.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class u{constructor(te,$=null){this.protocol=te,this.isDisposed=!1,this.state=s.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=$}getChannel(te){const $=this;return{call(H,ce,re){return $.isDisposed?Promise.reject(new m.CancellationError):$.requestPromise(te,H,ce,re)},listen(H,ce){return $.isDisposed?y.Event.None:$.requestEvent(te,H,ce)}}}requestPromise(te,$,H,ce=A.CancellationToken.None){const re=this.lastRequestId++,he={id:re,type:100,channelName:te,name:$,arg:H};if(ce.isCancellationRequested)return Promise.reject(new m.CancellationError);let z;return new Promise((ye,Re)=>{if(ce.isCancellationRequested)return Re(new m.CancellationError);const ne=()=>{const le=oe=>{switch(oe.type){case 201:this.handlers.delete(re),ye(oe.data);break;case 202:{this.handlers.delete(re);const ue=new Error(oe.data.message);ue.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,ue.name=oe.data.name,Re(ue);break}case 203:this.handlers.delete(re),Re(oe.data);break}};this.handlers.set(re,le),this.sendRequest(he)};let ee=null;this.state===s.Idle?ne():(ee=(0,L.createCancelablePromise)(le=>this.whenInitialized()),ee.then(()=>{ee=null,ne()}));const de=()=>{ee?(ee.cancel(),ee=null):this.sendRequest({id:re,type:101}),Re(new m.CancellationError)},K=ce.onCancellationRequested(de);z=(0,v.combinedDisposable)((0,v.toDisposable)(de),K),this.activeRequests.add(z)}).finally(()=>{this.activeRequests.delete(z)})}requestEvent(te,$,H){const ce=this.lastRequestId++,fe={id:ce,type:102,channelName:te,name:$,arg:H};let he=null;const z=new y.Emitter({onWillAddFirstListener:()=>{he=(0,L.createCancelablePromise)(ye=>this.whenInitialized()),he.then(()=>{he=null,this.activeRequests.add(z),this.sendRequest(fe)})},onDidRemoveLastListener:()=>{he?(he.cancel(),he=null):(this.activeRequests.delete(z),this.sendRequest({id:ce,type:103}))}}),Z=ye=>z.fire(ye.data);return this.handlers.set(ce,Z),z.event}sendRequest(te){switch(te.type){case 100:case 102:{const $=this.send([te.type,te.id,te.channelName,te.name],te.arg);this.logger?.logOutgoing($,te.id,0,`${D(te.type)}: ${te.channelName}.${te.name}`,te.arg);return}case 101:case 103:{const $=this.send([te.type,te.id]);this.logger?.logOutgoing($,te.id,0,D(te.type));return}}}send(te,$=void 0){const H=new i;return g(H,te),g(H,$),this.sendBuffer(H.buffer)}sendBuffer(te){try{return this.protocol.send(te),te.byteLength}catch{return 0}}onBuffer(te){const $=new I(te),H=l($),ce=l($),re=H[0];switch(re){case 200:return this.logger?.logIncoming(te.byteLength,0,0,r(re)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(te.byteLength,H[1],0,r(re),ce),this.onResponse({type:H[0],id:H[1],data:ce})}}onResponse(te){if(te.type===200){this.state=s.Idle,this._onDidInitialize.fire();return}this.handlers.get(te.id)?.(te)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=u,Ve([T.memoize],u.prototype,"onDidInitializePromise",null);class E{get connections(){const te=[];return this._connections.forEach($=>te.push($)),te}constructor(te){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,te(({protocol:$,onDidClientDisconnect:H})=>{y.Event.once($.onMessage)(re=>{const fe=new I(re),he=l(fe),z=new h($,he),Z=new u($);this.channels.forEach((Re,ne)=>z.registerChannel(ne,Re));const ye={channelServer:z,channelClient:Z,ctx:he};this._connections.add(ye),this._onDidAddConnection.fire(ye),H(()=>{z.dispose(),Z.dispose(),this._connections.delete(ye),this._onDidRemoveConnection.fire(ye)})})})}getChannel(te,$){const H=this;return{call(ce,re,fe){let he;if((0,p.isFunction)($)){const Z=(0,_.getRandomElement)(H.connections.filter($));he=Z?Promise.resolve(Z):y.Event.toPromise(y.Event.filter(H.onDidAddConnection,$))}else he=$.routeCall(H,ce,re);const z=he.then(Z=>Z.channelClient.getChannel(te));return O(z).call(ce,re,fe)},listen(ce,re){if((0,p.isFunction)($))return H.getMulticastEvent(te,$,ce,re);const fe=$.routeEvent(H,ce,re).then(he=>he.channelClient.getChannel(te));return O(fe).listen(ce,re)}}}getMulticastEvent(te,$,H,ce){const re=this;let fe=new v.DisposableStore;const he=new y.Emitter({onWillAddFirstListener:()=>{fe=new v.DisposableStore;const z=new y.EventMultiplexer,Z=new Map,ye=ne=>{const de=ne.channelClient.getChannel(te).listen(H,ce),K=z.add(de);Z.set(ne,K)},Re=ne=>{const ee=Z.get(ne);ee&&(ee.dispose(),Z.delete(ne))};re.connections.filter($).forEach(ye),y.Event.filter(re.onDidAddConnection,$)(ye,void 0,fe),re.onDidRemoveConnection(Re,void 0,fe),z.event(he.fire,he,fe),fe.add(z)},onDidRemoveLastListener:()=>{fe.dispose()}});return he.event}registerChannel(te,$){this.channels.set(te,$),this._connections.forEach(H=>{H.channelServer.registerChannel(te,$)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class P{constructor(te,$,H=null){const ce=new i;g(ce,$),te.send(ce.buffer),this.channelClient=new u(te,H),this.channelServer=new h(te,$,H)}getChannel(te){return this.channelClient.getChannel(te)}registerChannel(te,$){this.channelServer.registerChannel(te,$)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=P;function O(ie){return{call(te,$,H){return ie.then(ce=>ce.call(te,$,H))},listen(te,$){const H=new y.Relay;return ie.then(ce=>H.input=ce.listen(te,$)),H.event}}}e.getDelayedChannel=O;function N(ie){let te=!1;return{call($,H,ce){return te?ie.call($,H,ce):(0,L.timeout)(0).then(()=>te=!0).then(()=>ie.call($,H,ce))},listen($,H){if(te)return ie.listen($,H);const ce=new y.Relay;return(0,L.timeout)(0).then(()=>te=!0).then(()=>ce.input=ie.listen($,H)),ce.event}}}e.getNextTickChannel=N;class F{constructor(te){this.fn=te}routeCall(te){return this.route(te)}routeEvent(te){return this.route(te)}async route(te){for(const $ of te.connections)if(await Promise.resolve(this.fn($.ctx)))return Promise.resolve($);return await y.Event.toPromise(te.onDidAddConnection),await this.route(te)}}e.StaticRouter=F;var x;(function(ie){function te(re,fe){const he=re,z=fe&&fe.disableMarshalling,Z=new Map;for(const ye in he)H(ye)&&Z.set(ye,y.Event.buffer(he[ye],!0));return new class{listen(ye,Re,ne){const ee=Z.get(Re);if(ee)return ee;if(ce(Re)){const de=he[Re];if(typeof de=="function")return de.call(he,ne)}throw new m.ErrorNoTelemetry(`Event not found: ${Re}`)}call(ye,Re,ne){const ee=he[Re];if(typeof ee=="function"){if(!z&&Array.isArray(ne))for(let de=0;de<ne.length;de++)ne[de]=(0,R.revive)(ne[de]);return ee.apply(he,ne)}throw new m.ErrorNoTelemetry(`Method not found: ${Re}`)}}}ie.fromService=te;function $(re,fe){const he=fe&&fe.disableMarshalling;return new Proxy({},{get(z,Z){if(typeof Z=="string")return fe?.properties?.has(Z)?fe.properties.get(Z):ce(Z)?function(ye){return re.listen(Z,ye)}:H(Z)?re.listen(Z):async function(...ye){let Re;fe&&!(0,p.isUndefinedOrNull)(fe.context)?Re=[fe.context,...ye]:Re=ye;const ne=await re.call(Z,Re);return he?ne:(0,R.revive)(ne)};throw new m.ErrorNoTelemetry(`Property not found: ${String(Z)}`)}})}ie.toService=$;function H(re){return re[0]==="o"&&re[1]==="n"&&k.isUpperAsciiLetter(re.charCodeAt(2))}function ce(re){return/^onDynamic/.test(re)&&k.isUpperAsciiLetter(re.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(ie){if(Array.isArray(ie))return ie;if(ie&&typeof ie=="object"&&typeof ie.toString=="function"){const te=ie.toString();if(te!=="[object Object]")return te}return ie}function X(ie){return Array.isArray(ie)?ie.map(U):U(ie)}function j(ie,te,$,H,ce,re,fe){fe=X(fe);const he=B[ce],z=he[H%he.length];let Z=[`%c[${ie}]%c[${String(te).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${z}`];/\($/.test(re)?(Z=Z.concat(fe),Z.push(")")):Z.push(fe),console.log.apply(console,Z)}class ge{constructor(te,$){this._outgoingPrefix=te,this._incomingPrefix=$,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(te,$,H,ce,re){this._totalOutgoing+=te,j(this._outgoingPrefix,this._totalOutgoing,te,$,H,ce,re)}logIncoming(te,$,H,ce,re){this._totalIncoming+=te,j(this._incomingPrefix,this._totalIncoming,te,$,H,ce,re)}}e.IPCLogger=ge}),define(De[122],Ie([1,0,22,3,4,76]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var m;(function(t){t.enableDiagnostics=!1,t.records=[];const o=new WeakMap;let g=0;function l(w,u){if(!o.has(w)){const E=String(++g);o.set(w,E)}return o.get(w)}function h(w,u,E,P){if(!t.enableDiagnostics)return;const O=l(w,u);if(P instanceof _.VSBuffer||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const N=_.VSBuffer.alloc(P.byteLength);N.set(P),t.records.push({timestamp:Date.now(),id:O,label:u,type:E,buff:N})}else t.records.push({timestamp:Date.now(),id:O,label:u,type:E,data:P})}t.traceSocketEvent=h})(m||(e.SocketDiagnostics=m={}));var y;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y||(e.SocketCloseEventType=y={}));let v=null;function R(){return v||(v=_.VSBuffer.alloc(0)),v}class k{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,g){if(o===0)return R();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const u=this._chunks[0];return g&&(this._chunks.shift(),this._totalLength-=o),u}if(this._chunks[0].byteLength>o){const u=this._chunks[0].slice(0,o);return g&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),u}const l=_.VSBuffer.alloc(o);let h=0,w=0;for(;o>0;){const u=this._chunks[w];if(u.byteLength>o){const E=u.slice(0,o);l.set(E,h),h+=o,g&&(this._chunks[w]=u.slice(o),this._totalLength-=o),o-=o}else l.set(u,h),h+=u.byteLength,g?(this._chunks.shift(),this._totalLength-=u.byteLength):w++,o-=u.byteLength}return l}}e.ChunkStream=k;var p;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(p||(p={}));function C(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var D;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(D||(e.ProtocolConstants=D={}));class b{constructor(o,g,l,h){this.type=o,this.id=g,this.ack=l,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class r extends d.Disposable{constructor(o){super(),this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(g=>this.acceptChunk(g))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const g=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=g.readUInt32BE(9),this._state.messageType=g.readUInt8(0),this._state.id=g.readUInt32BE(1),this._state.ack=g.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:C(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,h=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",g),this._onMessage.fire(new b(l,h,w,g)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class s{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const g=_.VSBuffer.alloc(13);g.writeUInt8(o.type,0),g.writeUInt32BE(o.id,1),g.writeUInt32BE(o.ack,5),g.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:C(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(g,o.data)}_bufferAdd(o,g){const l=this._totalLength===0;return this._data.push(o,g),this._totalLength+=o.byteLength+g.byteLength,l}_bufferTake(){const o=_.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,g){this._bufferAdd(o,g)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class c extends d.Disposable{constructor(o){super(),this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new s(this._socket)),this._socketReader=this._register(new r(this._socket)),this._register(this._socketReader.onMessage(g=>{g.type===1&&this._onMessage.fire(g.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new b(1,0,0,o))}}e.Protocol=c;class f extends A.IPCClient{static fromSocket(o,g){return new f(new c(o),g)}get onDidDispose(){return this.protocol.onDidDispose}constructor(o,g,l=null){super(o,g,l),this.protocol=o}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=f;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class I{constructor(o){this.data=o,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let o=0,g=this._first;for(;g;)g=g.next,o++;return o}peek(){return this._first?this._first.data:null}toArray(){const o=[];let g=0,l=this._first;for(;l;)o[g++]=l.data,l=l.next;return o}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const g=new I(o);if(!this._first){this._first=g,this._last=g;return}this._last.next=g,this._last=g}}class a{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}constructor(){this.lastRuns=[];const o=Date.now();for(let g=0;g<a._HISTORY_LENGTH;g++)this.lastRuns[g]=o-1e3*g;setInterval(()=>{for(let g=a._HISTORY_LENGTH;g>=1;g--)this.lastRuns[g]=this.lastRuns[g-1];this.lastRuns[0]=Date.now()},1e3)}load(){const o=Date.now(),g=(1+a._HISTORY_LENGTH)*1e3;let l=0;for(let h=0;h<a._HISTORY_LENGTH;h++)o-this.lastRuns[h]<=g&&l++;return 1-l/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(o){this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o.loadEstimator??a.getInstance(),this._shouldSendKeepAlive=o.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new d.DisposableStore,this._socket=o.socket,this._socketWriter=this._socketDisposables.add(new s(this._socket)),this._socketReader=this._socketDisposables.add(new r(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.add(this._socket.onClose(g=>this._onSocketClose.fire(g))),o.initialChunk&&this._socketReader.acceptChunk(o.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new b(5,0,0,R());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new b(7,0,0,R());this._socketWriter.write(o)}sendResume(){const o=new b(8,0,0,R());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,g){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new d.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=this._socketDisposables.add(new s(this._socket)),this._socketReader=this._socketDisposables.add(new r(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.add(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(g)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new b(3,0,this._incomingAckId,R());this._socketWriter.write(o);const g=this._outgoingUnackMsg.toArray();for(let l=0,h=g.length;l<h;l++)this._socketWriter.write(g[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const g=this._outgoingUnackMsg.peek();if(g&&g.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const g=Date.now();g-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=g,this._socketWriter.write(new b(6,0,0,R())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const g=this._outgoingUnackMsg.toArray();for(let l=0,h=g.length;l<h;l++)this._socketWriter.write(g[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const g=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new b(1,g,this._incomingAckId,o);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(o){const g=new b(2,0,0,o);this._socketWriter.write(g)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),g=Date.now()-o.writtenTime,l=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(g>=2e4&&l>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:g,timeSinceLastReceivedSomeData:l});return}const w=Math.max(2e4-g,2e4-l,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},w)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new b(3,0,this._incomingAckId,R());this._socketWriter.write(o)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const o=new b(9,0,this._incomingAckId,R());this._socketWriter.write(o)}}e.PersistentProtocol=n}),define(De[176],Ie([1,0,46,17,22,21,174,8,3,4,23,96,94,76]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class D extends C.ChannelServer{constructor(s){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",c=>d.VSBuffer.wrap(Buffer.from(c,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.Server=D;class b{constructor(s,c){this.modulePath=s,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new y.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new L.Delayer(f),this.child=null,this._client=null}getChannel(s){const c=this;return{call(f,S,I){return c.requestPromise(s,f,S,I)},listen(f,S){return c.requestEvent(s,f,S)}}}requestPromise(s,c,f,S=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(m.canceled());this.disposeDelayer.cancel();const I=this.getCachedChannel(s),i=(0,L.createCancelablePromise)(t=>I.call(c,f,t)),a=S.onCancellationRequested(()=>i.cancel()),n=(0,v.toDisposable)(()=>i.cancel());return this.activeRequests.add(n),i.finally(()=>{a.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(s,c,f){if(!this.disposeDelayer)return y.Event.None;this.disposeDelayer.cancel();let S;const I=new y.Emitter({onWillAddFirstListener:()=>{S=this.getCachedChannel(s).listen(c,f)(I.fire,I),this.activeRequests.add(S)},onDidRemoveLastListener:()=>{this.activeRequests.delete(S),S.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return I.event}get client(){if(!this._client){const s=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env={...(0,R.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(c.env={...c.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,p.removeDangerousEnvVariables)(c.env),this.child=(0,_.fork)(this.modulePath,s,c);const f=new y.Emitter;y.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,T.isRemoteConsoleLog)(o)){(0,T.log)(o,`IPC Library: ${this.options.serverName}`);return}f.fire(d.VSBuffer.wrap(Buffer.from(o,"base64")))});const I=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,i=o=>this.child&&this.child.connected&&I.send(o.buffer.toString("base64")),a=f.event,n={send:i,onMessage:a};this._client=new C.ChannelClient(n);const t=()=>this.disposeClient();process.once("exit",t),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,g)=>{process.removeListener("exit",t),this.activeRequests.forEach(l=>(0,v.dispose)(l)),this.activeRequests.clear(),o!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+g),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:g})})}return this._client}getCachedChannel(s){let c=this.channels.get(s);return c||(c=this.client.getChannel(s),this.channels.set(s,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=b}),define(De[177],Ie([1,0,34,13]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function d(A,T,m,y,v,R){if(Array.isArray(A)){let k=0;for(const p of A){const C=d(p,T,m,y,v,R);if(C===10)return C;C>k&&(k=C)}return k}else{if(typeof A=="string")return y?A==="*"?5:A===m?10:0:0;if(A){const{language:k,pattern:p,scheme:C,hasAccessToAllModels:D,notebookType:b}=A;if(!y&&!D)return 0;b&&v&&(T=v);let r=0;if(C)if(C===T.scheme)r=10;else if(C==="*")r=5;else return 0;if(k)if(k===m)r=10;else if(k==="*")r=Math.max(r,5);else return 0;if(b)if(b===R)r=10;else if(b==="*"&&R!==void 0)r=Math.max(r,5);else return 0;if(p){let s;if(typeof p=="string"?s=p:s={...p,base:(0,L.normalize)(p.base)},s===T.fsPath||(0,_.match)(s,T.fsPath))r=10;else return 0}return r}else return 0}}e.score=d}),define(De[123],Ie([1,0,22,11]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var d;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(d||(d={}));function A(k){for(let p=0,C=k.length;p<C;p+=4){const D=k[p+0],b=k[p+1],r=k[p+2],s=k[p+3];k[p+0]=s,k[p+1]=r,k[p+2]=b,k[p+3]=D}}function T(k){const p=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return L.isLittleEndian()||A(p),_.VSBuffer.wrap(p)}function m(k){const p=k.buffer;if(L.isLittleEndian()||A(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const C=new Uint8Array(p.byteLength);return C.set(p),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function y(k){const p=new Uint32Array(v(k));let C=0;if(p[C++]=k.id,k.type==="full")p[C++]=1,p[C++]=k.data.length,p.set(k.data,C),C+=k.data.length;else{p[C++]=2,p[C++]=k.deltas.length;for(const D of k.deltas)p[C++]=D.start,p[C++]=D.deleteCount,D.data?(p[C++]=D.data.length,p.set(D.data,C),C+=D.data.length):p[C++]=0}return T(p)}e.encodeSemanticTokensDto=y;function v(k){let p=0;if(p+=1+1,k.type==="full")p+=1+k.data.length;else{p+=1,p+=(1+1+1)*k.deltas.length;for(const C of k.deltas)C.data&&(p+=C.data.length)}return p}function R(k){const p=m(k);let C=0;const D=p[C++];if(p[C++]===1){const c=p[C++],f=p.subarray(C,C+c);return C+=c,{id:D,type:"full",data:f}}const r=p[C++],s=[];for(let c=0;c<r;c++){const f=p[C++],S=p[C++],I=p[C++];let i;I>0&&(i=p.subarray(C,C+I),C+=I),s[c]={start:f,deleteCount:S,data:i}}return{id:D,type:"delta",deltas:s}}e.decodeSemanticTokensDto=R}),define(De[178],Ie([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(De[124],Ie([1,0,19,23,11,159,116,178]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class v{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=v;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class k{constructor(Q,Se,Be,Me){this.id=Q,this.name=Se,this.defaultValue=Be,this.schema=Me}applyUpdate(Q,Se){return C(Q,Se)}compute(Q,Se,Be){return Be}}class p{constructor(Q,Se){this.newValue=Q,this.didChange=Se}}e.ApplyUpdateResult=p;function C(Y,Q){if(typeof Y!="object"||typeof Q!="object"||!Y||!Q)return new p(Q,Y!==Q);if(Array.isArray(Y)||Array.isArray(Q)){const Be=Array.isArray(Y)&&Array.isArray(Q)&&_.equals(Y,Q);return new p(Q,!Be)}let Se=!1;for(const Be in Q)if(Q.hasOwnProperty(Be)){const Me=C(Y[Be],Q[Be]);Me.didChange&&(Y[Be]=Me.newValue,Se=!0)}return new p(Y,Se)}class D{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,Se){return C(Q,Se)}validate(Q){return this.defaultValue}}class b{constructor(Q,Se,Be,Me){this.id=Q,this.name=Se,this.defaultValue=Be,this.schema=Me}applyUpdate(Q,Se){return C(Q,Se)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,Se,Be){return Be}}function r(Y,Q){return typeof Y>"u"?Q:Y==="false"?!1:!!Y}e.boolean=r;class s extends b{constructor(Q,Se,Be,Me=void 0){typeof Me<"u"&&(Me.type="boolean",Me.default=Be),super(Q,Se,Be,Me)}validate(Q){return r(Q,this.defaultValue)}}function c(Y,Q,Se,Be){if(typeof Y>"u")return Q;let Me=parseInt(Y,10);return isNaN(Me)?Q:(Me=Math.max(Se,Me),Me=Math.min(Be,Me),Me|0)}e.clampedInt=c;class f extends b{static clampedInt(Q,Se,Be,Me){return c(Q,Se,Be,Me)}constructor(Q,Se,Be,Me,Xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="integer",Ze.default=Be,Ze.minimum=Me,Ze.maximum=Xe),super(Q,Se,Be,Ze),this.minimum=Me,this.maximum=Xe}validate(Q){return f.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function S(Y,Q,Se,Be){if(typeof Y>"u")return Q;const Me=I.float(Y,Q);return I.clamp(Me,Se,Be)}e.clampedFloat=S;class I extends b{static clamp(Q,Se,Be){return Q<Se?Se:Q>Be?Be:Q}static float(Q,Se){if(typeof Q=="number")return Q;if(typeof Q>"u")return Se;const Be=parseFloat(Q);return isNaN(Be)?Se:Be}constructor(Q,Se,Be,Me,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Be),super(Q,Se,Be,Xe),this.validationFn=Me}validate(Q){return this.validationFn(I.float(Q,this.defaultValue))}}class i extends b{static string(Q,Se){return typeof Q!="string"?Se:Q}constructor(Q,Se,Be,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.default=Be),super(Q,Se,Be,Me)}validate(Q){return i.string(Q,this.defaultValue)}}function a(Y,Q,Se,Be){return typeof Y!="string"?Q:Be&&Y in Be?Be[Y]:Se.indexOf(Y)===-1?Q:Y}e.stringSet=a;class n extends b{constructor(Q,Se,Be,Me,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Me,Xe.default=Be),super(Q,Se,Be,Xe),this._allowedValues=Me}validate(Q){return a(Q,this.defaultValue,this._allowedValues)}}class t extends k{constructor(Q,Se,Be,Me,Xe,Ze,rt=void 0){typeof rt<"u"&&(rt.type="string",rt.enum=Xe,rt.default=Me),super(Q,Se,Be,rt),this._allowedValues=Xe,this._convert=Ze}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function o(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,Se,Be){return Be===0?Q.accessibilitySupport:Be}}class l extends k{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(22,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:m.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{insertSpace:r(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var h;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(h||(e.TextEditorCursorBlinkingStyle=h={}));function w(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(u||(e.TextEditorCursorStyle=u={}));function E(Y){switch(Y){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function P(Y){switch(Y){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class O extends D{constructor(){super(139)}compute(Q,Se,Be){const Me=["monaco-editor"];return Se.get(38)&&Me.push(Se.get(38)),Q.extraEditorClassName&&Me.push(Q.extraEditorClassName),Se.get(72)==="default"?Me.push("mouse-default"):Se.get(72)==="copy"&&Me.push("mouse-copy"),Se.get(109)&&Me.push("showUnused"),Se.get(137)&&Me.push("showDeprecated"),Me.join(" ")}}class N extends s{constructor(){super(36,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(Q,Se,Be){return Be&&Q.emptySelectionClipboard}}class F extends k{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(40,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:m.localize(16,null),included:d.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:m.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{cursorMoveOnType:r(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":a(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":a(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r(Se.loop,this.defaultValue.loop)}}}class x extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(50,"fontLigatures",x.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?x.OFF:Q==="true"?x.ON:Q:Q?x.ON:x.OFF}}e.EditorFontLigatures=x;class B extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(53,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?B.OFF:Q==="true"?B.TRANSLATE:Q:Q?B.TRANSLATE:B.OFF}compute(Q,Se,Be){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=B;class U extends D{constructor(){super(49)}compute(Q,Se,Be){return Q.fontInfo}}class X extends b{constructor(){super(51,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(Q){const Se=I.float(Q,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:I.clamp(Se,6,100)}compute(Q,Se,Be){return Q.fontInfo.fontSize}}class j extends k{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(52,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:j.MINIMUM_VALUE,maximum:j.MAXIMUM_VALUE,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:j.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(f.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,j.MINIMUM_VALUE,j.MAXIMUM_VALUE))}}class ge extends k{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(57,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...Se},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...Se},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Be,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Be,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Be,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Be,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Be,description:m.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{multiple:a(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??a(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??a(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??a(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??a(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??a(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ie extends k{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(59,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:m.localize(44,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:m.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:r(Se.enabled,this.defaultValue.enabled),delay:f.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:r(Se.sticky,this.defaultValue.sticky),above:r(Se.above,this.defaultValue.above)}}}var te;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(te||(e.RenderMinimap=te={}));class $ extends D{constructor(){super(142)}compute(Q,Se,Be){return $.computeLayout(Se,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const Se=Q.height/Q.lineHeight,Be=Math.floor(Q.paddingTop/Q.lineHeight);let Me=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(Me=Math.max(Me,Se-1));const Xe=(Be+Q.viewLineCount+Me)/(Q.pixelRatio*Q.height),Ze=Math.floor(Q.viewLineCount/Xe);return{typicalViewportLineCount:Se,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Me,desiredRatio:Xe,minimapLineCount:Ze}}static _computeMinimapLayout(Q,Se){const Be=Q.outerWidth,Me=Q.outerHeight,Xe=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Me),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Me};const Ze=Se.stableMinimapLayoutInput,rt=Ze&&Q.outerHeight===Ze.outerHeight&&Q.lineHeight===Ze.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ze.pixelRatio&&Q.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&Q.paddingTop===Ze.paddingTop&&Q.paddingBottom===Ze.paddingBottom&&Q.minimap.enabled===Ze.minimap.enabled&&Q.minimap.side===Ze.minimap.side&&Q.minimap.size===Ze.minimap.size&&Q.minimap.showSlider===Ze.minimap.showSlider&&Q.minimap.renderCharacters===Ze.minimap.renderCharacters&&Q.minimap.maxColumn===Ze.minimap.maxColumn&&Q.minimap.scale===Ze.minimap.scale&&Q.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&Q.isViewportWrapping===Ze.isViewportWrapping,ft=Q.lineHeight,wt=Q.typicalHalfwidthCharacterWidth,Lt=Q.scrollBeyondLastLine,At=Q.minimap.renderCharacters;let yt=Xe>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Ft=Q.minimap.maxColumn,Ot=Q.minimap.size,xt=Q.minimap.side,zt=Q.verticalScrollbarWidth,Nt=Q.viewLineCount,at=Q.remainingWidth,ht=Q.isViewportWrapping,Wt=At?2:3;let Mt=Math.floor(Xe*Me);const Ct=Mt/Xe;let ct=!1,Tt=!1,Ut=Wt*yt,Fe=yt/Xe,Ae=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:it,extraLinesBeforeFirstLine:Et,extraLinesBeyondLastLine:Dt,desiredRatio:It,minimapLineCount:bt}=$.computeContainedMinimapLineCount({viewLineCount:Nt,scrollBeyondLastLine:Lt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:Me,lineHeight:ft,pixelRatio:Xe});if(Nt/bt>1)ct=!0,Tt=!0,yt=1,Ut=1,Fe=yt/Xe;else{let dt=!1,vt=yt+1;if(Ot==="fit"){const gt=Math.ceil((Et+Nt+Dt)*Ut);ht&&rt&&at<=Se.stableFitRemainingWidth?(dt=!0,vt=Se.stableFitMaxMinimapScale):dt=gt>Mt}if(Ot==="fill"||dt){ct=!0;const gt=yt;Ut=Math.min(ft*Xe,Math.max(1,Math.floor(1/It))),ht&&rt&&at<=Se.stableFitRemainingWidth&&(vt=Se.stableFitMaxMinimapScale),yt=Math.min(vt,Math.max(1,Math.floor(Ut/Wt))),yt>gt&&(Ae=Math.min(2,yt/gt)),Fe=yt/Xe/Ae,Mt=Math.ceil(Math.max(it,Et+Nt+Dt)*Ut),ht?(Se.stableMinimapLayoutInput=Q,Se.stableFitRemainingWidth=at,Se.stableFitMaxMinimapScale=yt):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const Te=Math.floor(Ft*Fe),ae=Math.min(Te,Math.max(0,Math.floor((at-zt-2)*Fe/(wt+Fe)))+e.MINIMAP_GUTTER_WIDTH);let Oe=Math.floor(Xe*ae);const We=Oe/Xe;Oe=Math.floor(Oe*Ae);const Ke=At?1:2,je=xt==="left"?0:Be-ae-zt;return{renderMinimap:Ke,minimapLeft:je,minimapWidth:ae,minimapHeightIsEditorHeight:ct,minimapIsSampling:Tt,minimapScale:yt,minimapLineHeight:Ut,minimapCanvasInnerWidth:Oe,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:We,minimapCanvasOuterHeight:Ct}}static computeLayout(Q,Se){const Be=Se.outerWidth|0,Me=Se.outerHeight|0,Xe=Se.lineHeight|0,Ze=Se.lineNumbersDigitCount|0,rt=Se.typicalHalfwidthCharacterWidth,ft=Se.maxDigitWidth,wt=Se.pixelRatio,Lt=Se.viewLineCount,At=Q.get(134),yt=At==="inherit"?Q.get(133):At,Ft=yt==="inherit"?Q.get(129):yt,Ot=Q.get(132),xt=Se.isDominatedByLongLines,zt=Q.get(56),Nt=Q.get(66).renderType!==0,at=Q.get(67),ht=Q.get(103),Wt=Q.get(82),Mt=Q.get(71),Ct=Q.get(101),ct=Ct.verticalScrollbarSize,Tt=Ct.verticalHasArrows,Ut=Ct.arrowSize,Fe=Ct.horizontalScrollbarSize,Ae=Q.get(42),Te=Q.get(108)!=="never";let ae=Q.get(64);Ae&&Te&&(ae+=16);let Oe=0;if(Nt){const $t=Math.max(Ze,at);Oe=Math.round($t*ft)}let We=0;zt&&(We=Xe*Se.glyphMarginDecorationLaneCount);let Ke=0,je=Ke+We,it=je+Oe,Et=it+ae;const Dt=Be-We-Oe-ae;let It=!1,bt=!1,pt=-1;yt==="inherit"&&xt?(It=!0,bt=!0):Ft==="on"||Ft==="bounded"?bt=!0:Ft==="wordWrapColumn"&&(pt=Ot);const dt=$._computeMinimapLayout({outerWidth:Be,outerHeight:Me,lineHeight:Xe,typicalHalfwidthCharacterWidth:rt,pixelRatio:wt,scrollBeyondLastLine:ht,paddingTop:Wt.top,paddingBottom:Wt.bottom,minimap:Mt,verticalScrollbarWidth:ct,viewLineCount:Lt,remainingWidth:Dt,isViewportWrapping:bt},Se.memory||new R);dt.renderMinimap!==0&&dt.minimapLeft===0&&(Ke+=dt.minimapWidth,je+=dt.minimapWidth,it+=dt.minimapWidth,Et+=dt.minimapWidth);const vt=Dt-dt.minimapWidth,gt=Math.max(1,Math.floor((vt-ct-2)/rt)),Qt=Tt?Ut:0;return bt&&(pt=Math.max(1,gt),Ft==="bounded"&&(pt=Math.min(pt,Ot))),{width:Be,height:Me,glyphMarginLeft:Ke,glyphMarginWidth:We,glyphMarginDecorationLaneCount:Se.glyphMarginDecorationLaneCount,lineNumbersLeft:je,lineNumbersWidth:Oe,decorationsLeft:it,decorationsWidth:ae,contentLeft:Et,contentWidth:vt,minimap:dt,viewportColumn:gt,isWordWrapMinified:It,isViewportWrapping:bt,wrappingColumn:pt,verticalScrollbarWidth:ct,horizontalScrollbarHeight:Fe,overviewRuler:{top:Qt,width:ct,height:Me-2*Qt,right:0}}}}e.EditorLayoutInfoComputer=$;class H extends k{constructor(){super(136,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(46,null),m.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(48,null)}})}validate(Q){return a(Q,"simple",["simple","advanced"])}compute(Q,Se,Be){return Se.get(2)===2?"advanced":Be}}class ce extends k{constructor(){const Q={enabled:!0};super(63,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:m.localize(49,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:r(Q.enabled,this.defaultValue.enabled)}}}class re extends k{constructor(){const Q={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(113,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:m.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:m.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:m.localize(52,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:r(Se.enabled,this.defaultValue.enabled),maxLineCount:f.clampedInt(Se.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:a(Se.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class fe extends k{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(138,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:m.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(54,null),m.localize(55,null,d.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),m.localize(56,null,d.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),m.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:m.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:m.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:m.localize(60,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return typeof Se.enabled=="boolean"&&(Se.enabled=Se.enabled?"on":"off"),{enabled:a(Se.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:f.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(Se.fontFamily,this.defaultValue.fontFamily),padding:r(Se.padding,this.defaultValue.padding)}}}class he extends k{constructor(){super(64,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):f.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,Se,Be){return Be<0?f.clampedInt(-Be*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class z extends I{constructor(){super(65,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>I.clamp(Q,0,150),{markdownDescription:m.localize(61,null)})}compute(Q,Se,Be){return Q.fontInfo.lineHeight}}class Z extends k{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(71,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:m.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:m.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(64,null),m.localize(65,null),m.localize(66,null)],default:Q.size,description:m.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:m.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:m.localize(69,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:m.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:m.localize(72,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:r(Se.enabled,this.defaultValue.enabled),autohide:r(Se.autohide,this.defaultValue.autohide),size:a(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(Se.side,this.defaultValue.side,["right","left"]),showSlider:a(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r(Se.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(Se.scale,1,1,3),maxColumn:f.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ye(Y){return Y==="ctrlCmd"?d.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Re extends k{constructor(){super(82,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(74,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{top:f.clampedInt(Se.top,0,0,1e3),bottom:f.clampedInt(Se.bottom,0,0,1e3)}}}class ne extends k{constructor(){const Q={enabled:!0,cycle:!0};super(84,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:m.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:m.localize(76,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:r(Se.enabled,this.defaultValue.enabled),cycle:r(Se.cycle,this.defaultValue.cycle)}}}class ee extends D{constructor(){super(140)}compute(Q,Se,Be){return Q.pixelRatio}}class de extends k{constructor(){const Q={other:"on",comments:"off",strings:"off"},Se=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(77,null),m.localize(78,null),m.localize(79,null)]}];super(87,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Se,default:Q.strings,description:m.localize(80,null)},comments:{anyOf:Se,default:Q.comments,description:m.localize(81,null)},other:{anyOf:Se,default:Q.other,description:m.localize(82,null)}},default:Q,markdownDescription:m.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const wt=Q?"on":"off";return{comments:wt,strings:wt,other:wt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:Se,comments:Be,strings:Me}=Q,Xe=["on","inline","off"];let Ze,rt,ft;return typeof Se=="boolean"?Ze=Se?"on":"off":Ze=a(Se,this.defaultValue.other,Xe),typeof Be=="boolean"?rt=Be?"on":"off":rt=a(Be,this.defaultValue.comments,Xe),typeof Me=="boolean"?ft=Me?"on":"off":ft=a(Me,this.defaultValue.strings,Xe),{other:Ze,comments:rt,strings:ft}}}var K;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(K||(e.RenderLineNumbersType=K={}));class le extends k{constructor(){super(66,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(84,null),m.localize(85,null),m.localize(86,null),m.localize(87,null)],default:"on",description:m.localize(88,null)})}validate(Q){let Se=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(Se=4,Be=Q):Q==="interval"?Se=3:Q==="relative"?Se=2:Q==="on"?Se=1:Se=0),{renderType:Se,renderFn:Be}}}function oe(Y){const Q=Y.get(96);return Q==="editable"?Y.get(89):Q!=="on"}e.filterValidationDecorations=oe;class ue extends k{constructor(){const Q=[],Se={type:"number",description:m.localize(89,null)};super(100,"rulers",Q,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:m.localize(90,null),format:"color-hex"}}}]},default:Q,description:m.localize(91,null)})}validate(Q){if(Array.isArray(Q)){const Se=[];for(const Be of Q)if(typeof Be=="number")Se.push({column:f.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Me=Be;Se.push({column:f.clampedInt(Me.column,0,0,1e4),color:Me.color})}return Se.sort((Be,Me)=>Be.column-Me.column),Se}return this.defaultValue}}class Ee extends k{constructor(){super(90,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function M(Y,Q){if(typeof Y!="string")return Q;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends k{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(101,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(92,null),m.localize(93,null),m.localize(94,null)],default:"auto",description:m.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(96,null),m.localize(97,null),m.localize(98,null)],default:"auto",description:m.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:m.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:m.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:m.localize(102,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q,Be=f.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Me=f.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:M(Se.vertical,this.defaultValue.vertical),horizontal:M(Se.horizontal,this.defaultValue.horizontal),useShadows:r(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:r(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:f.clampedInt(Se.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Me,verticalSliderSize:f.clampedInt(Se.verticalSliderSize,Me,0,1e3),scrollByPage:r(Se.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends k{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(123,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:m.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:m.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:m.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:m.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:m.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:m.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:m.localize(109,null)}})}applyUpdate(Q,Se){let Be=!1;Se.allowedCharacters&&Q&&(L.equals(Q.allowedCharacters,Se.allowedCharacters)||(Q={...Q,allowedCharacters:Se.allowedCharacters},Be=!0)),Se.allowedLocales&&Q&&(L.equals(Q.allowedLocales,Se.allowedLocales)||(Q={...Q,allowedLocales:Se.allowedLocales},Be=!0));const Me=super.applyUpdate(Q,Se);return Be?new p(Me.newValue,!0):Me}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{nonBasicASCII:we(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:r(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:r(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:we(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:we(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,Se){if(typeof Q!="object"||!Q)return Se;const Be={};for(const[Me,Xe]of Object.entries(Q))Xe===!0&&(Be[Me]=!0);return Be}}class J extends k{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(61,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:m.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[m.localize(111,null),m.localize(112,null)],description:m.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:m.localize(114,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:r(Se.enabled,this.defaultValue.enabled),mode:a(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:a(Se.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:r(Se.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:r(Se.keepOnBlur,this.defaultValue.keepOnBlur)}}}class be extends k{constructor(){const Q={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(14,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:m.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:m.localize(116,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:r(Se.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:r(Se.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class se extends k{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(15,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],default:Q.bracketPairs,description:m.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(121,null),m.localize(122,null),m.localize(123,null)],default:Q.bracketPairsHorizontal,description:m.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:m.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:m.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(127,null),m.localize(128,null),m.localize(129,null)],default:Q.highlightActiveIndentation,description:m.localize(130,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{bracketPairs:we(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:we(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:r(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:r(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:we(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function we(Y,Q,Se){const Be=Se.indexOf(Y);return Be===-1?Q:Se[Be]}class ke extends k{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(116,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(131,null),m.localize(132,null)],default:Q.insertMode,description:m.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:m.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:m.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:m.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(137,null),m.localize(138,null),m.localize(139,null),m.localize(140,null)],default:Q.selectionMode,markdownDescription:m.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:m.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:m.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:m.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:m.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:m.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{insertMode:a(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:a(Se.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:r(Se.showIcons,this.defaultValue.showIcons),showStatusBar:r(Se.showStatusBar,this.defaultValue.showStatusBar),preview:r(Se.preview,this.defaultValue.preview),previewMode:a(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r(Se.showMethods,this.defaultValue.showMethods),showFunctions:r(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:r(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:r(Se.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:r(Se.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:r(Se.showFields,this.defaultValue.showFields),showVariables:r(Se.showVariables,this.defaultValue.showVariables),showClasses:r(Se.showClasses,this.defaultValue.showClasses),showStructs:r(Se.showStructs,this.defaultValue.showStructs),showInterfaces:r(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:r(Se.showModules,this.defaultValue.showModules),showProperties:r(Se.showProperties,this.defaultValue.showProperties),showEvents:r(Se.showEvents,this.defaultValue.showEvents),showOperators:r(Se.showOperators,this.defaultValue.showOperators),showUnits:r(Se.showUnits,this.defaultValue.showUnits),showValues:r(Se.showValues,this.defaultValue.showValues),showConstants:r(Se.showConstants,this.defaultValue.showConstants),showEnums:r(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:r(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r(Se.showKeywords,this.defaultValue.showKeywords),showWords:r(Se.showWords,this.defaultValue.showWords),showColors:r(Se.showColors,this.defaultValue.showColors),showFiles:r(Se.showFiles,this.defaultValue.showFiles),showReferences:r(Se.showReferences,this.defaultValue.showReferences),showFolders:r(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:r(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r(Se.showSnippets,this.defaultValue.showSnippets),showUsers:r(Se.showUsers,this.defaultValue.showUsers),showIssues:r(Se.showIssues,this.defaultValue.showIssues)}}}class Ue extends k{constructor(){super(111,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(179,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(180,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:r(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Je extends k{constructor(){super(135,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(181,null),m.localize(182,null),m.localize(183,null),m.localize(184,null)],description:m.localize(185,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,Se,Be){return Se.get(2)===2?0:Be}}class Ge extends D{constructor(){super(143)}compute(Q,Se,Be){const Me=Se.get(142);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Me.isWordWrapMinified,isViewportWrapping:Me.isViewportWrapping,wrappingColumn:Me.wrappingColumn}}}class et extends k{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(35,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:m.localize(186,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(187,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(188,null),m.localize(189,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:r(Se.enabled,this.defaultValue.enabled),showDropSelector:a(Se.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Qe extends k{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(83,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:m.localize(190,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(191,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(192,null),m.localize(193,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:r(Se.enabled,this.defaultValue.enabled),showPasteSelector:a(Se.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const st="Consolas, 'Courier New', monospace",tt="Menlo, Monaco, 'Courier New', monospace",Pe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:d.isMacintosh?tt:d.isLinux?Pe:st,fontWeight:"normal",fontSize:d.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function _e(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var ze;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=8]="autoClosingDelete",Y[Y.autoClosingOvertype=9]="autoClosingOvertype",Y[Y.autoClosingQuotes=10]="autoClosingQuotes",Y[Y.autoIndent=11]="autoIndent",Y[Y.automaticLayout=12]="automaticLayout",Y[Y.autoSurround=13]="autoSurround",Y[Y.bracketPairColorization=14]="bracketPairColorization",Y[Y.guides=15]="guides",Y[Y.codeLens=16]="codeLens",Y[Y.codeLensFontFamily=17]="codeLensFontFamily",Y[Y.codeLensFontSize=18]="codeLensFontSize",Y[Y.colorDecorators=19]="colorDecorators",Y[Y.colorDecoratorsLimit=20]="colorDecoratorsLimit",Y[Y.columnSelection=21]="columnSelection",Y[Y.comments=22]="comments",Y[Y.contextmenu=23]="contextmenu",Y[Y.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=25]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=27]="cursorStyle",Y[Y.cursorSurroundingLines=28]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=30]="cursorWidth",Y[Y.disableLayerHinting=31]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",Y[Y.domReadOnly=33]="domReadOnly",Y[Y.dragAndDrop=34]="dragAndDrop",Y[Y.dropIntoEditor=35]="dropIntoEditor",Y[Y.emptySelectionClipboard=36]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=38]="extraEditorClassName",Y[Y.fastScrollSensitivity=39]="fastScrollSensitivity",Y[Y.find=40]="find",Y[Y.fixedOverflowWidgets=41]="fixedOverflowWidgets",Y[Y.folding=42]="folding",Y[Y.foldingStrategy=43]="foldingStrategy",Y[Y.foldingHighlight=44]="foldingHighlight",Y[Y.foldingImportsByDefault=45]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=46]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=48]="fontFamily",Y[Y.fontInfo=49]="fontInfo",Y[Y.fontLigatures=50]="fontLigatures",Y[Y.fontSize=51]="fontSize",Y[Y.fontWeight=52]="fontWeight",Y[Y.fontVariations=53]="fontVariations",Y[Y.formatOnPaste=54]="formatOnPaste",Y[Y.formatOnType=55]="formatOnType",Y[Y.glyphMargin=56]="glyphMargin",Y[Y.gotoLocation=57]="gotoLocation",Y[Y.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",Y[Y.hover=59]="hover",Y[Y.inDiffEditor=60]="inDiffEditor",Y[Y.inlineSuggest=61]="inlineSuggest",Y[Y.letterSpacing=62]="letterSpacing",Y[Y.lightbulb=63]="lightbulb",Y[Y.lineDecorationsWidth=64]="lineDecorationsWidth",Y[Y.lineHeight=65]="lineHeight",Y[Y.lineNumbers=66]="lineNumbers",Y[Y.lineNumbersMinChars=67]="lineNumbersMinChars",Y[Y.linkedEditing=68]="linkedEditing",Y[Y.links=69]="links",Y[Y.matchBrackets=70]="matchBrackets",Y[Y.minimap=71]="minimap",Y[Y.mouseStyle=72]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=74]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=76]="multiCursorModifier",Y[Y.multiCursorPaste=77]="multiCursorPaste",Y[Y.multiCursorLimit=78]="multiCursorLimit",Y[Y.occurrencesHighlight=79]="occurrencesHighlight",Y[Y.overviewRulerBorder=80]="overviewRulerBorder",Y[Y.overviewRulerLanes=81]="overviewRulerLanes",Y[Y.padding=82]="padding",Y[Y.pasteAs=83]="pasteAs",Y[Y.parameterHints=84]="parameterHints",Y[Y.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=87]="quickSuggestions",Y[Y.quickSuggestionsDelay=88]="quickSuggestionsDelay",Y[Y.readOnly=89]="readOnly",Y[Y.readOnlyMessage=90]="readOnlyMessage",Y[Y.renameOnType=91]="renameOnType",Y[Y.renderControlCharacters=92]="renderControlCharacters",Y[Y.renderFinalNewline=93]="renderFinalNewline",Y[Y.renderLineHighlight=94]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=96]="renderValidationDecorations",Y[Y.renderWhitespace=97]="renderWhitespace",Y[Y.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",Y[Y.roundedSelection=99]="roundedSelection",Y[Y.rulers=100]="rulers",Y[Y.scrollbar=101]="scrollbar",Y[Y.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=103]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=104]="scrollPredominantAxis",Y[Y.selectionClipboard=105]="selectionClipboard",Y[Y.selectionHighlight=106]="selectionHighlight",Y[Y.selectOnLineNumbers=107]="selectOnLineNumbers",Y[Y.showFoldingControls=108]="showFoldingControls",Y[Y.showUnused=109]="showUnused",Y[Y.snippetSuggestions=110]="snippetSuggestions",Y[Y.smartSelect=111]="smartSelect",Y[Y.smoothScrolling=112]="smoothScrolling",Y[Y.stickyScroll=113]="stickyScroll",Y[Y.stickyTabStops=114]="stickyTabStops",Y[Y.stopRenderingLineAfter=115]="stopRenderingLineAfter",Y[Y.suggest=116]="suggest",Y[Y.suggestFontSize=117]="suggestFontSize",Y[Y.suggestLineHeight=118]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",Y[Y.suggestSelection=120]="suggestSelection",Y[Y.tabCompletion=121]="tabCompletion",Y[Y.tabIndex=122]="tabIndex",Y[Y.unicodeHighlighting=123]="unicodeHighlighting",Y[Y.unusualLineTerminators=124]="unusualLineTerminators",Y[Y.useShadowDOM=125]="useShadowDOM",Y[Y.useTabStops=126]="useTabStops",Y[Y.wordBreak=127]="wordBreak",Y[Y.wordSeparators=128]="wordSeparators",Y[Y.wordWrap=129]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=132]="wordWrapColumn",Y[Y.wordWrapOverride1=133]="wordWrapOverride1",Y[Y.wordWrapOverride2=134]="wordWrapOverride2",Y[Y.wrappingIndent=135]="wrappingIndent",Y[Y.wrappingStrategy=136]="wrappingStrategy",Y[Y.showDeprecated=137]="showDeprecated",Y[Y.inlayHints=138]="inlayHints",Y[Y.editorClassName=139]="editorClassName",Y[Y.pixelRatio=140]="pixelRatio",Y[Y.tabFocusMode=141]="tabFocusMode",Y[Y.layoutInfo=142]="layoutInfo",Y[Y.wrappingInfo=143]="wrappingInfo",Y[Y.defaultColorDecorators=144]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn"})(ze||(e.EditorOption=ze={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(194,null)})),acceptSuggestionOnEnter:_e(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(195,null),""],markdownDescription:m.localize(196,null)})),accessibilitySupport:_e(new g),accessibilityPageSize:_e(new f(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(197,null),tags:["accessibility"]})),ariaLabel:_e(new i(4,"ariaLabel",m.localize(198,null))),ariaRequired:_e(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:_e(new s(7,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(199,null),tags:["accessibility"]})),autoClosingBrackets:_e(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(200,null),m.localize(201,null),""],description:m.localize(202,null)})),autoClosingDelete:_e(new n(8,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(203,null),""],description:m.localize(204,null)})),autoClosingOvertype:_e(new n(9,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(205,null),""],description:m.localize(206,null)})),autoClosingQuotes:_e(new n(10,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(207,null),m.localize(208,null),""],description:m.localize(209,null)})),autoIndent:_e(new t(11,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[m.localize(210,null),m.localize(211,null),m.localize(212,null),m.localize(213,null),m.localize(214,null)],description:m.localize(215,null)})),automaticLayout:_e(new s(12,"automaticLayout",!1)),autoSurround:_e(new n(13,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(216,null),m.localize(217,null),m.localize(218,null),""],description:m.localize(219,null)})),bracketPairColorization:_e(new be),bracketPairGuides:_e(new se),stickyTabStops:_e(new s(114,"stickyTabStops",!1,{description:m.localize(220,null)})),codeLens:_e(new s(16,"codeLens",!0,{description:m.localize(221,null)})),codeLensFontFamily:_e(new i(17,"codeLensFontFamily","",{description:m.localize(222,null)})),codeLensFontSize:_e(new f(18,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(223,null)})),colorDecorators:_e(new s(19,"colorDecorators",!0,{description:m.localize(224,null)})),colorDecoratorActivatedOn:_e(new n(145,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(225,null),m.localize(226,null),m.localize(227,null)],description:m.localize(228,null)})),colorDecoratorsLimit:_e(new f(20,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(229,null)})),columnSelection:_e(new s(21,"columnSelection",!1,{description:m.localize(230,null)})),comments:_e(new l),contextmenu:_e(new s(23,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new s(24,"copyWithSyntaxHighlighting",!0,{description:m.localize(231,null)})),cursorBlinking:_e(new t(25,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:m.localize(232,null)})),cursorSmoothCaretAnimation:_e(new n(26,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(233,null),m.localize(234,null),m.localize(235,null)],description:m.localize(236,null)})),cursorStyle:_e(new t(27,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:m.localize(237,null)})),cursorSurroundingLines:_e(new f(28,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(238,null)})),cursorSurroundingLinesStyle:_e(new n(29,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(239,null),m.localize(240,null)],description:m.localize(241,null)})),cursorWidth:_e(new f(30,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(242,null)})),disableLayerHinting:_e(new s(31,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new s(32,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new s(33,"domReadOnly",!1)),dragAndDrop:_e(new s(34,"dragAndDrop",!0,{description:m.localize(243,null)})),emptySelectionClipboard:_e(new N),dropIntoEditor:_e(new et),stickyScroll:_e(new re),experimentalWhitespaceRendering:_e(new n(37,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),extraEditorClassName:_e(new i(38,"extraEditorClassName","")),fastScrollSensitivity:_e(new I(39,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:m.localize(248,null)})),find:_e(new F),fixedOverflowWidgets:_e(new s(41,"fixedOverflowWidgets",!1)),folding:_e(new s(42,"folding",!0,{description:m.localize(249,null)})),foldingStrategy:_e(new n(43,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(250,null),m.localize(251,null)],description:m.localize(252,null)})),foldingHighlight:_e(new s(44,"foldingHighlight",!0,{description:m.localize(253,null)})),foldingImportsByDefault:_e(new s(45,"foldingImportsByDefault",!1,{description:m.localize(254,null)})),foldingMaximumRegions:_e(new f(46,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(255,null)})),unfoldOnClickAfterEndOfLine:_e(new s(47,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(256,null)})),fontFamily:_e(new i(48,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(257,null)})),fontInfo:_e(new U),fontLigatures2:_e(new x),fontSize:_e(new X),fontWeight:_e(new j),fontVariations:_e(new B),formatOnPaste:_e(new s(54,"formatOnPaste",!1,{description:m.localize(258,null)})),formatOnType:_e(new s(55,"formatOnType",!1,{description:m.localize(259,null)})),glyphMargin:_e(new s(56,"glyphMargin",!0,{description:m.localize(260,null)})),gotoLocation:_e(new ge),hideCursorInOverviewRuler:_e(new s(58,"hideCursorInOverviewRuler",!1,{description:m.localize(261,null)})),hover:_e(new ie),inDiffEditor:_e(new s(60,"inDiffEditor",!1)),letterSpacing:_e(new I(62,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>I.clamp(Y,-5,20),{description:m.localize(262,null)})),lightbulb:_e(new ce),lineDecorationsWidth:_e(new he),lineHeight:_e(new z),lineNumbers:_e(new le),lineNumbersMinChars:_e(new f(67,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new s(68,"linkedEditing",!1,{description:m.localize(263,null)})),links:_e(new s(69,"links",!0,{description:m.localize(264,null)})),matchBrackets:_e(new n(70,"matchBrackets","always",["always","near","never"],{description:m.localize(265,null)})),minimap:_e(new Z),mouseStyle:_e(new n(72,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new I(73,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:m.localize(266,null)})),mouseWheelZoom:_e(new s(74,"mouseWheelZoom",!1,{markdownDescription:m.localize(267,null)})),multiCursorMergeOverlapping:_e(new s(75,"multiCursorMergeOverlapping",!0,{description:m.localize(268,null)})),multiCursorModifier:_e(new t(76,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ye,{markdownEnumDescriptions:[m.localize(269,null),m.localize(270,null)],markdownDescription:m.localize(271,null)})),multiCursorPaste:_e(new n(77,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(272,null),m.localize(273,null)],markdownDescription:m.localize(274,null)})),multiCursorLimit:_e(new f(78,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(275,null)})),occurrencesHighlight:_e(new s(79,"occurrencesHighlight",!0,{description:m.localize(276,null)})),overviewRulerBorder:_e(new s(80,"overviewRulerBorder",!0,{description:m.localize(277,null)})),overviewRulerLanes:_e(new f(81,"overviewRulerLanes",3,0,3)),padding:_e(new Re),pasteAs:_e(new Qe),parameterHints:_e(new ne),peekWidgetDefaultFocus:_e(new n(85,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(278,null),m.localize(279,null)],description:m.localize(280,null)})),definitionLinkOpensInPeek:_e(new s(86,"definitionLinkOpensInPeek",!1,{description:m.localize(281,null)})),quickSuggestions:_e(new de),quickSuggestionsDelay:_e(new f(88,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(282,null)})),readOnly:_e(new s(89,"readOnly",!1)),readOnlyMessage:_e(new Ee),renameOnType:_e(new s(91,"renameOnType",!1,{description:m.localize(283,null),markdownDeprecationMessage:m.localize(284,null)})),renderControlCharacters:_e(new s(92,"renderControlCharacters",!0,{description:m.localize(285,null),restricted:!0})),renderFinalNewline:_e(new n(93,"renderFinalNewline",d.isLinux?"dimmed":"on",["off","on","dimmed"],{description:m.localize(286,null)})),renderLineHighlight:_e(new n(94,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(287,null)],description:m.localize(288,null)})),renderLineHighlightOnlyWhenFocus:_e(new s(95,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(289,null)})),renderValidationDecorations:_e(new n(96,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new n(97,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(290,null),m.localize(291,null),m.localize(292,null),""],description:m.localize(293,null)})),revealHorizontalRightPadding:_e(new f(98,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:_e(new s(99,"roundedSelection",!0,{description:m.localize(294,null)})),rulers:_e(new ue),scrollbar:_e(new q),scrollBeyondLastColumn:_e(new f(102,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(295,null)})),scrollBeyondLastLine:_e(new s(103,"scrollBeyondLastLine",!0,{description:m.localize(296,null)})),scrollPredominantAxis:_e(new s(104,"scrollPredominantAxis",!0,{description:m.localize(297,null)})),selectionClipboard:_e(new s(105,"selectionClipboard",!0,{description:m.localize(298,null),included:d.isLinux})),selectionHighlight:_e(new s(106,"selectionHighlight",!0,{description:m.localize(299,null)})),selectOnLineNumbers:_e(new s(107,"selectOnLineNumbers",!0)),showFoldingControls:_e(new n(108,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(300,null),m.localize(301,null),m.localize(302,null)],description:m.localize(303,null)})),showUnused:_e(new s(109,"showUnused",!0,{description:m.localize(304,null)})),showDeprecated:_e(new s(137,"showDeprecated",!0,{description:m.localize(305,null)})),inlayHints:_e(new fe),snippetSuggestions:_e(new n(110,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(306,null),m.localize(307,null),m.localize(308,null),m.localize(309,null)],description:m.localize(310,null)})),smartSelect:_e(new Ue),smoothScrolling:_e(new s(112,"smoothScrolling",!1,{description:m.localize(311,null)})),stopRenderingLineAfter:_e(new f(115,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new ke),inlineSuggest:_e(new J),suggestFontSize:_e(new f(117,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(312,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:_e(new f(118,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(313,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:_e(new s(119,"suggestOnTriggerCharacters",!0,{description:m.localize(314,null)})),suggestSelection:_e(new n(120,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(315,null),m.localize(316,null),m.localize(317,null)],description:m.localize(318,null)})),tabCompletion:_e(new n(121,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(319,null),m.localize(320,null),m.localize(321,null)],description:m.localize(322,null)})),tabIndex:_e(new f(122,"tabIndex",0,-1,1073741824)),unicodeHighlight:_e(new G),unusualLineTerminators:_e(new n(124,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(323,null),m.localize(324,null),m.localize(325,null)],description:m.localize(326,null)})),useShadowDOM:_e(new s(125,"useShadowDOM",!0)),useTabStops:_e(new s(126,"useTabStops",!0,{description:m.localize(327,null)})),wordBreak:_e(new n(127,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(328,null),m.localize(329,null)],description:m.localize(330,null)})),wordSeparators:_e(new i(128,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:m.localize(331,null)})),wordWrap:_e(new n(129,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(332,null),m.localize(333,null),m.localize(334,null),m.localize(335,null)],description:m.localize(336,null)})),wordWrapBreakAfterCharacters:_e(new i(130,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new i(131,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new f(132,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(337,null)})),wordWrapOverride1:_e(new n(133,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new n(134,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:_e(new O),defaultColorDecorators:_e(new s(144,"defaultColorDecorators",!1,{markdownDescription:m.localize(338,null)})),pixelRatio:_e(new ee),tabFocusMode:_e(new s(141,"tabFocusMode",!1,{markdownDescription:m.localize(339,null)})),layoutInfo:_e(new $),wrappingInfo:_e(new Ge),wrappingIndent:_e(new Je),wrappingStrategy:_e(new H)}}),define(De[179],Ie([9,10]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(De[77],Ie([1,0,72,2,157,33,167,179]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.TextEdit=e.SymbolKinds=e.SymbolTag=e.getAriaLabelForSymbol=e.symbolKindNames=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class y{constructor(x,B,U){this.offset=x,this.type=B,this.language=U,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=y;class v{constructor(x,B){this.tokens=x,this.endState=B,this._tokenizationResultBrand=void 0}}e.TokenizationResult=v;class R{constructor(x,B){this.tokens=x,this.endState=B,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=R;var k;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(k||(e.CompletionItemKind=k={}));var p;(function(F){const x=new Map;x.set(0,_.Codicon.symbolMethod),x.set(1,_.Codicon.symbolFunction),x.set(2,_.Codicon.symbolConstructor),x.set(3,_.Codicon.symbolField),x.set(4,_.Codicon.symbolVariable),x.set(5,_.Codicon.symbolClass),x.set(6,_.Codicon.symbolStruct),x.set(7,_.Codicon.symbolInterface),x.set(8,_.Codicon.symbolModule),x.set(9,_.Codicon.symbolProperty),x.set(10,_.Codicon.symbolEvent),x.set(11,_.Codicon.symbolOperator),x.set(12,_.Codicon.symbolUnit),x.set(13,_.Codicon.symbolValue),x.set(15,_.Codicon.symbolEnum),x.set(14,_.Codicon.symbolConstant),x.set(15,_.Codicon.symbolEnum),x.set(16,_.Codicon.symbolEnumMember),x.set(17,_.Codicon.symbolKeyword),x.set(27,_.Codicon.symbolSnippet),x.set(18,_.Codicon.symbolText),x.set(19,_.Codicon.symbolColor),x.set(20,_.Codicon.symbolFile),x.set(21,_.Codicon.symbolReference),x.set(22,_.Codicon.symbolCustomColor),x.set(23,_.Codicon.symbolFolder),x.set(24,_.Codicon.symbolTypeParameter),x.set(25,_.Codicon.account),x.set(26,_.Codicon.issues);function B(j){let ge=x.get(j);return ge||(console.info("No codicon found for CompletionItemKind "+j),ge=_.Codicon.symbolProperty),ge}F.toIcon=B;const U=new Map;U.set("method",0),U.set("function",1),U.set("constructor",2),U.set("field",3),U.set("variable",4),U.set("class",5),U.set("struct",6),U.set("interface",7),U.set("module",8),U.set("property",9),U.set("event",10),U.set("operator",11),U.set("unit",12),U.set("value",13),U.set("constant",14),U.set("enum",15),U.set("enum-member",16),U.set("enumMember",16),U.set("keyword",17),U.set("snippet",27),U.set("text",18),U.set("color",19),U.set("file",20),U.set("reference",21),U.set("customcolor",22),U.set("folder",23),U.set("type-parameter",24),U.set("typeParameter",24),U.set("account",25),U.set("issue",26);function X(j,ge){let ie=U.get(j);return typeof ie>"u"&&!ge&&(ie=9),ie}F.fromString=X})(p||(e.CompletionItemKinds=p={}));var C;(function(F){F[F.Deprecated=1]="Deprecated"})(C||(e.CompletionItemTag=C={}));var D;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(D||(e.CompletionItemInsertTextRule=D={}));var b;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b||(e.CompletionTriggerKind=b={}));var r;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(r||(e.InlineCompletionTriggerKind=r={}));class s{constructor(x,B,U,X){this.range=x,this.text=B,this.completionKind=U,this.isSnippetText=X}equals(x){return A.Range.lift(this.range).equalsRange(x.range)&&this.text===x.text&&this.completionKind===x.completionKind&&this.isSnippetText===x.isSnippetText}}e.SelectedSuggestionInfo=s;var c;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(c||(e.CodeActionTriggerType=c={}));var f;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(f||(e.SignatureHelpTriggerKind=f={}));var S;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(S||(e.DocumentHighlightKind=S={}));function I(F){return F&&L.URI.isUri(F.uri)&&A.Range.isIRange(F.range)&&(A.Range.isIRange(F.originSelectionRange)||A.Range.isIRange(F.targetSelectionRange))}e.isLocationLink=I;var i;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(i||(e.SymbolKind=i={})),e.symbolKindNames={[17]:(0,m.localize)(0,null),[16]:(0,m.localize)(1,null),[4]:(0,m.localize)(2,null),[13]:(0,m.localize)(3,null),[8]:(0,m.localize)(4,null),[9]:(0,m.localize)(5,null),[21]:(0,m.localize)(6,null),[23]:(0,m.localize)(7,null),[7]:(0,m.localize)(8,null),[0]:(0,m.localize)(9,null),[11]:(0,m.localize)(10,null),[10]:(0,m.localize)(11,null),[19]:(0,m.localize)(12,null),[5]:(0,m.localize)(13,null),[1]:(0,m.localize)(14,null),[2]:(0,m.localize)(15,null),[20]:(0,m.localize)(16,null),[15]:(0,m.localize)(17,null),[18]:(0,m.localize)(18,null),[24]:(0,m.localize)(19,null),[3]:(0,m.localize)(20,null),[6]:(0,m.localize)(21,null),[14]:(0,m.localize)(22,null),[22]:(0,m.localize)(23,null),[25]:(0,m.localize)(24,null),[12]:(0,m.localize)(25,null)};function a(F,x){return(0,m.localize)(26,null,F,e.symbolKindNames[x])}e.getAriaLabelForSymbol=a;var n;(function(F){F[F.Deprecated=1]="Deprecated"})(n||(e.SymbolTag=n={}));var t;(function(F){const x=new Map;x.set(0,_.Codicon.symbolFile),x.set(1,_.Codicon.symbolModule),x.set(2,_.Codicon.symbolNamespace),x.set(3,_.Codicon.symbolPackage),x.set(4,_.Codicon.symbolClass),x.set(5,_.Codicon.symbolMethod),x.set(6,_.Codicon.symbolProperty),x.set(7,_.Codicon.symbolField),x.set(8,_.Codicon.symbolConstructor),x.set(9,_.Codicon.symbolEnum),x.set(10,_.Codicon.symbolInterface),x.set(11,_.Codicon.symbolFunction),x.set(12,_.Codicon.symbolVariable),x.set(13,_.Codicon.symbolConstant),x.set(14,_.Codicon.symbolString),x.set(15,_.Codicon.symbolNumber),x.set(16,_.Codicon.symbolBoolean),x.set(17,_.Codicon.symbolArray),x.set(18,_.Codicon.symbolObject),x.set(19,_.Codicon.symbolKey),x.set(20,_.Codicon.symbolNull),x.set(21,_.Codicon.symbolEnumMember),x.set(22,_.Codicon.symbolStruct),x.set(23,_.Codicon.symbolEvent),x.set(24,_.Codicon.symbolOperator),x.set(25,_.Codicon.symbolTypeParameter);function B(U){let X=x.get(U);return X||(console.info("No codicon found for SymbolKind "+U),X=_.Codicon.symbolProperty),X}F.toIcon=B})(t||(e.SymbolKinds=t={}));class o{static asEditOperation(x){return d.EditOperation.replace(A.Range.lift(x.range),x.text)}}e.TextEdit=o;class g{static{this.Comment=new g("comment")}static{this.Imports=new g("imports")}static{this.Region=new g("region")}static fromValue(x){switch(x){case"comment":return g.Comment;case"imports":return g.Imports;case"region":return g.Region}return new g(x)}constructor(x){this.value=x}}e.FoldingRangeKind=g;var l;(function(F){function x(B){return!B||typeof B!="object"?!1:typeof B.id=="string"&&typeof B.title=="string"}F.is=x})(l||(e.Command=l={}));var h;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(h||(e.CommentThreadCollapsibleState=h={}));var w;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(w||(e.CommentThreadState=w={}));var u;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(u||(e.CommentMode=u={}));var E;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(E||(e.CommentState=E={}));var P;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class O{constructor(x){this.createSupport=x,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(x=>{x&&x.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=O,e.TokenizationRegistry=new T.TokenizationRegistry;var N;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(N||(e.ExternalUriOpenerPriority=N={}))}),define(De[180],Ie([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[181],Ie([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(De[182],Ie([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(De[183],Ie([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[184],Ie([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[185],Ie([9,10]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[186],Ie([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(De[187],Ie([9,10]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(De[188],Ie([9,10]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[189],Ie([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(De[190],Ie([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(De[191],Ie([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(De[192],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChat",e)}),define(De[193],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[194],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[195],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[196],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(De[197],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[198],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(De[199],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[200],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[201],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[202],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[203],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[204],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[205],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[206],Ie([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(De[207],Ie([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(De[208],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[209],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[210],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[211],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[212],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[213],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[214],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[215],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[216],Ie([1,0,8,182]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var d;(function(v){v[v.LParen=0]="LParen",v[v.RParen=1]="RParen",v[v.Neg=2]="Neg",v[v.Eq=3]="Eq",v[v.NotEq=4]="NotEq",v[v.Lt=5]="Lt",v[v.LtEq=6]="LtEq",v[v.Gt=7]="Gt",v[v.GtEq=8]="GtEq",v[v.RegexOp=9]="RegexOp",v[v.RegexStr=10]="RegexStr",v[v.True=11]="True",v[v.False=12]="False",v[v.In=13]="In",v[v.Not=14]="Not",v[v.And=15]="And",v[v.Or=16]="Or",v[v.Str=17]="Str",v[v.QuotedStr=18]="QuotedStr",v[v.Error=19]="Error",v[v.EOF=20]="EOF"})(d||(e.TokenType=d={}));function A(...v){switch(v.length){case 1:return(0,L.localize)(0,null,v[0]);case 2:return(0,L.localize)(1,null,v[0],v[1]);case 3:return(0,L.localize)(2,null,v[0],v[1],v[2]);default:return}}const T=(0,L.localize)(3,null),m=(0,L.localize)(4,null);class y{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,_.illegalState)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(R){return this._input=R,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const k=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:k})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const k=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:k})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(R){return this._isAtEnd()||this._input.charCodeAt(this._current)!==R?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(R){this._tokens.push({type:R,offset:this._start})}_error(R){const k=this._start,p=this._input.substring(this._start,this._current),C={type:19,offset:this._start,lexeme:p};this._errors.push({offset:k,lexeme:p,additionalInfo:R}),this._tokens.push(C)}_string(){this.stringRe.lastIndex=this._start;const R=this.stringRe.exec(this._input);if(R){this._current=this._start+R[0].length;const k=this._input.substring(this._start,this._current),p=y._keywords.get(k);p?this._addToken(p):this._tokens.push({type:17,lexeme:k,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let R=this._current,k=!1,p=!1;for(;;){if(R>=this._input.length){this._current=R,this._error(m);return}const D=this._input.charCodeAt(R);if(k)k=!1;else if(D===47&&!p){R++;break}else D===91?p=!0:D===92?k=!0:D===93&&(p=!1);R++}for(;R<this._input.length&&y._regexFlags.has(this._input.charCodeAt(R));)R++;this._current=R;const C=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:C,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=y}),define(De[217],Ie([1,0,24,40,184,351]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function y(s){return s=s.trim(),s==="*"||T.test(s)}e.isValidVersionStr=y;function v(s){if(!y(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=s.match(T);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.parseVersion=v;function R(s){if(!s)return null;const c=s.majorBase,f=s.majorMustEqual,S=s.minorBase;let I=s.minorMustEqual;const i=s.patchBase;let a=s.patchMustEqual;s.hasCaret&&(c===0||(I=!1),a=!1);let n=0;if(s.preRelease){const t=m.exec(s.preRelease);if(t){const[,o,g,l]=t;n=Date.UTC(Number(o),Number(g)-1,Number(l))}}return{majorBase:c,majorMustEqual:f,minorBase:S,minorMustEqual:I,patchBase:i,patchMustEqual:a,isMinimum:s.hasGreaterEquals,notBefore:n}}e.normalizeVersion=R;function k(s,c,f){let S;typeof s=="string"?S=R(v(s)):S=s;let I;c instanceof Date?I=c.getTime():typeof c=="string"&&(I=new Date(c).getTime());let i;if(typeof f=="string"?i=R(v(f)):i=f,!S||!i)return!1;const a=S.majorBase,n=S.minorBase,t=S.patchBase;let o=i.majorBase,g=i.minorBase,l=i.patchBase;const h=i.notBefore;let w=i.majorMustEqual,u=i.minorMustEqual,E=i.patchMustEqual;return i.isMinimum?a>o?!0:a<o?!1:n>g?!0:n<g||I&&I<h?!1:t>=l:(a===1&&o===0&&(!w||!u||!E)&&(o=1,g=0,l=0,w=!0,u=!1,E=!1),a<o?!1:a>o?!w:n<g?!1:n>g?!u:t<l?!1:t>l?!E:!(I&&I<h))}e.isValidVersion=k;function p(s,c,f,S,I){const i=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return i.push([L.default.Error,d.localize(0,null)]),i;if(typeof S.name!="string")return i.push([L.default.Error,d.localize(1,null,"name")]),i;if(typeof S.version!="string")return i.push([L.default.Error,d.localize(2,null,"version")]),i;if(!S.engines)return i.push([L.default.Error,d.localize(3,null,"engines")]),i;if(typeof S.engines.vscode!="string")return i.push([L.default.Error,d.localize(4,null,"engines.vscode")]),i;if(typeof S.extensionDependencies<"u"&&!r(S.extensionDependencies))return i.push([L.default.Error,d.localize(5,null,"extensionDependencies")]),i;if(typeof S.activationEvents<"u"){if(!r(S.activationEvents))return i.push([L.default.Error,d.localize(6,null,"activationEvents")]),i;if(typeof S.main>"u"&&typeof S.browser>"u")return i.push([L.default.Error,d.localize(7,null,"activationEvents","main","browser")]),i}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&i.push([L.default.Warning,d.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return i.push([L.default.Error,d.localize(9,null,"main")]),i;{const t=(0,_.joinPath)(f,S.main);(0,_.isEqualOrParent)(t,f)||i.push([L.default.Warning,d.localize(10,null,t.path,f.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return i.push([L.default.Error,d.localize(11,null,"browser")]),i;{const t=(0,_.joinPath)(f,S.browser);(0,_.isEqualOrParent)(t,f)||i.push([L.default.Warning,d.localize(12,null,t.path,f.path)])}}if(!A.valid(S.version))return i.push([L.default.Error,d.localize(13,null)]),i;const a=[];if(!C(s,c,S,I,a))for(const t of a)i.push([L.default.Error,t]);return i}e.validateExtensionManifest=p;function C(s,c,f,S,I){return S||typeof f.main>"u"&&typeof f.browser>"u"?!0:b(s,c,f.engines.vscode,I)}e.isValidExtensionVersion=C;function D(s,c,f){return s==="*"||b(c,f,s)}e.isEngineValid=D;function b(s,c,f,S=[]){const I=R(v(f));if(!I)return S.push(d.localize(14,null,f)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return S.push(d.localize(15,null,f)),!1}else if(!I.majorMustEqual)return S.push(d.localize(16,null,f)),!1;return k(s,c,I)?!0:(S.push(d.localize(17,null,s,f)),!1)}function r(s){if(!Array.isArray(s))return!1;for(let c=0,f=s.length;c<f;c++)if(typeof s[c]!="string")return!1;return!0}}),define(De[97],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class _{constructor(d,A=[],T=!1){this.ctor=d,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=_}),define(De[98],Ie([1,0,97]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var d;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(d||(e.InstantiationType=d={}));function A(m,y,v){y instanceof _.SyncDescriptor||(y=new _.SyncDescriptor(y,[],!!v)),L.push([m,y])}e.registerSingleton=A;function T(){return L}e.getSingletonServiceDescriptors=T}),define(De[218],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(A,T){this.key=A,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=_;class L{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const T of this._nodes.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const m=this.lookupOrInsertNode(A),y=this.lookupOrInsertNode(T);m.outgoing.set(y.key,y),y.incoming.set(m.key,m)}removeNode(A){const T=this._hashFn(A);this._nodes.delete(T);for(const m of this._nodes.values())m.outgoing.delete(T),m.incoming.delete(T)}lookupOrInsertNode(A){const T=this._hashFn(A);let m=this._nodes.get(T);return m||(m=new _(T,A),this._nodes.set(T,m)),m}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[T,m]of this._nodes)A.push(`${T}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,T]of this._nodes){const m=new Set([A]),y=this._findCycle(T,m);if(y)return y}}_findCycle(A,T){for(const[m,y]of A.outgoing){if(T.has(m))return[...T,m].join(" -> ");T.add(m);const v=this._findCycle(y,T);if(v)return v;T.delete(m)}}}e.Graph=L}),define(De[5],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function m(y){return y[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=m})(_||(e._util=_={})),e.IInstantiationService=d("instantiationService");function L(T,m,y){m[_.DI_TARGET]===m?m[_.DI_DEPENDENCIES].push({id:T,index:y}):(m[_.DI_DEPENDENCIES]=[{id:T,index:y}],m[_.DI_TARGET]=m)}function d(T){if(_.serviceIds.has(T))return _.serviceIds.get(T);const m=function(y,v,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(m,y,R)};return m.toString=()=>T,_.serviceIds.set(T,m),m}e.createDecorator=d;function A(T){return T}e.refineServiceDecorator=A}),define(De[57],Ie([1,0,14,2,5]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,d.createDecorator)("configurationService");function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof L.URI)}e.isConfigurationOverrides=A;function T(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=T;var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function y(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function v(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.isConfigured=v;function R(s,c){const f=Object.create(null);for(const S in s)k(f,S,s[S],c);return f}e.toValuesTree=R;function k(s,c,f,S){const I=c.split("."),i=I.pop();let a=s;for(let n=0;n<I.length;n++){const t=I[n];let o=a[t];switch(typeof o){case"undefined":o=a[t]=Object.create(null);break;case"object":break;default:S(`Ignoring ${c} as ${I.slice(0,n+1).join(".")} is ${JSON.stringify(o)}`);return}a=o}if(typeof a=="object"&&a!==null)try{a[i]=f}catch{S(`Ignoring ${c} as ${I.join(".")} is ${JSON.stringify(a)}`)}else S(`Ignoring ${c} as ${I.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=k;function p(s,c){const f=c.split(".");C(s,f)}e.removeFromValueTree=p;function C(s,c){const f=c.shift();if(c.length===0){delete s[f];return}if(Object.keys(s).indexOf(f)!==-1){const S=s[f];typeof S=="object"&&!Array.isArray(S)&&(C(S,c),Object.keys(S).length===0&&delete s[f])}}function D(s,c,f){function S(a,n){let t=a;for(const o of n){if(typeof t!="object"||t===null)return;t=t[o]}return t}const I=c.split("."),i=S(s,I);return typeof i>"u"?f:i}e.getConfigurationValue=D;function b(s,c,f){Object.keys(c).forEach(S=>{S!=="__proto__"&&(S in s?_.isObject(s[S])&&_.isObject(c[S])?b(s[S],c[S],f):f&&(s[S]=c[S]):s[S]=c[S])})}e.merge=b;function r(s){return s.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=r}),define(De[47],Ie([1,0,11,12,216,5,181,8]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",_.isMacintosh),y.set("isLinux",_.isLinux),y.set("isWindows",_.isWindows),y.set("isWeb",_.isWeb),y.set("isMacNative",_.isMacintosh&&!_.isWeb),y.set("isEdge",_.isEdge),y.set("isFirefox",_.isFirefox),y.set("isChrome",_.isChrome),y.set("isSafari",_.isSafari);function v(he,z){if(y.get(he)!==void 0)throw(0,m.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(he,z)}e.setConstant=v;const R=Object.prototype.hasOwnProperty;var k;(function(he){he[he.False=0]="False",he[he.True=1]="True",he[he.Defined=2]="Defined",he[he.Not=3]="Not",he[he.Equals=4]="Equals",he[he.NotEquals=5]="NotEquals",he[he.And=6]="And",he[he.Regex=7]="Regex",he[he.NotRegex=8]="NotRegex",he[he.Or=9]="Or",he[he.In=10]="In",he[he.NotIn=11]="NotIn",he[he.Greater=12]="Greater",he[he.GreaterEquals=13]="GreaterEquals",he[he.Smaller=14]="Smaller",he[he.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const p={regexParsingWithErrorRecovery:!0},C=(0,T.localize)(0,null),D=(0,T.localize)(1,null),b=(0,T.localize)(2,null),r=(0,T.localize)(3,null),s=(0,T.localize)(4,null),c=(0,T.localize)(5,null),f=(0,T.localize)(6,null),S=(0,T.localize)(7,null);class I{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(z=p){this._config=z,this._scanner=new d.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(z){if(z===""){this._parsingErrors.push({message:C,offset:0,lexeme:"",additionalInfo:D});return}this._tokens=this._scanner.reset(z).scan(),this._current=0,this._parsingErrors=[];try{const Z=this._expr();if(!this._isAtEnd()){const ye=this._peek(),Re=ye.type===17?c:void 0;throw this._parsingErrors.push({message:s,offset:ye.offset,lexeme:d.Scanner.getLexeme(ye),additionalInfo:Re}),I._parseError}return Z}catch(Z){if(Z!==I._parseError)throw Z;return}}_expr(){return this._or()}_or(){const z=[this._and()];for(;this._matchOne(16);){const Z=this._and();z.push(Z)}return z.length===1?z[0]:i.or(...z)}_and(){const z=[this._term()];for(;this._matchOne(15);){const Z=this._term();z.push(Z)}return z.length===1?z[0]:i.and(...z)}_term(){if(this._matchOne(2)){const z=this._peek();switch(z.type){case 11:return this._advance(),o.INSTANCE;case 12:return this._advance(),g.INSTANCE;case 0:{this._advance();const Z=this._expr();return this._consume(1,r),Z?.negate()}case 17:return this._advance(),P.create(z.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",z)}}return this._primary()}_primary(){const z=this._peek();switch(z.type){case 11:return this._advance(),i.true();case 12:return this._advance(),i.false();case 0:{this._advance();const Z=this._expr();return this._consume(1,r),Z}case 17:{const Z=z.lexeme;if(this._advance(),this._matchOne(9)){const Re=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Re.type!==10)throw this._errExpectedButGot("REGEX",Re);const ne=Re.lexeme,ee=ne.lastIndexOf("/"),de=ee===ne.length-1?void 0:this._removeFlagsGY(ne.substring(ee+1));let K;try{K=new RegExp(ne.substring(1,ee),de)}catch{throw this._errExpectedButGot("REGEX",Re)}return U.create(Z,K)}switch(Re.type){case 10:case 19:{const ne=[Re.lexeme];this._advance();let ee=this._peek(),de=0;for(let Ee=0;Ee<Re.lexeme.length;Ee++)Re.lexeme.charCodeAt(Ee)===40?de++:Re.lexeme.charCodeAt(Ee)===41&&de--;for(;!this._isAtEnd()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:de++;break;case 1:de--;break;case 10:case 18:for(let Ee=0;Ee<ee.lexeme.length;Ee++)ee.lexeme.charCodeAt(Ee)===40?de++:Re.lexeme.charCodeAt(Ee)===41&&de--}if(de<0)break;ne.push(d.Scanner.getLexeme(ee)),this._advance(),ee=this._peek()}const K=ne.join(""),le=K.lastIndexOf("/"),oe=le===K.length-1?void 0:this._removeFlagsGY(K.substring(le+1));let ue;try{ue=new RegExp(K.substring(1,le),oe)}catch{throw this._errExpectedButGot("REGEX",Re)}return i.regex(Z,ue)}case 18:{const ne=Re.lexeme;this._advance();let ee=null;if(!(0,L.isFalsyOrWhitespace)(ne)){const de=ne.indexOf("/"),K=ne.lastIndexOf("/");if(de!==K&&de>=0){const le=ne.slice(de+1,K),oe=ne[K+1]==="i"?"i":"";try{ee=new RegExp(le,oe)}catch{throw this._errExpectedButGot("REGEX",Re)}}}if(ee===null)throw this._errExpectedButGot("REGEX",Re);return U.create(Z,ee)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,b);const Re=this._value();return i.notIn(Z,Re)}switch(this._peek().type){case 3:{this._advance();const Re=this._value();if(this._previous().type===18)return i.equals(Z,Re);switch(Re){case"true":return i.has(Z);case"false":return i.not(Z);default:return i.equals(Z,Re)}}case 4:{this._advance();const Re=this._value();if(this._previous().type===18)return i.notEquals(Z,Re);switch(Re){case"true":return i.not(Z);case"false":return i.has(Z);default:return i.notEquals(Z,Re)}}case 5:return this._advance(),x.create(Z,this._value());case 6:return this._advance(),B.create(Z,this._value());case 7:return this._advance(),N.create(Z,this._value());case 8:return this._advance(),F.create(Z,this._value());case 13:return this._advance(),i.in(Z,this._value());default:return i.has(Z)}}case 20:throw this._parsingErrors.push({message:f,offset:z.offset,lexeme:"",additionalInfo:S}),I._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const z=this._peek();switch(z.type){case 17:case 18:return this._advance(),z.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(z){return z.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(z){return this._check(z)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(z,Z){if(this._check(z))return this._advance();throw this._errExpectedButGot(Z,this._peek())}_errExpectedButGot(z,Z,ye){const Re=(0,T.localize)(8,null,z,d.Scanner.getLexeme(Z)),ne=Z.offset,ee=d.Scanner.getLexeme(Z);return this._parsingErrors.push({message:Re,offset:ne,lexeme:ee,additionalInfo:ye}),I._parseError}_check(z){return this._peek().type===z}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=I;class i{static false(){return o.INSTANCE}static true(){return g.INSTANCE}static has(z){return l.create(z)}static equals(z,Z){return h.create(z,Z)}static notEquals(z,Z){return E.create(z,Z)}static regex(z,Z){return U.create(z,Z)}static in(z,Z){return w.create(z,Z)}static notIn(z,Z){return u.create(z,Z)}static not(z){return P.create(z)}static and(...z){return ge.create(z,null,!0)}static or(...z){return ie.create(z,null,!0)}static greater(z,Z){return N.create(z,Z)}static greaterEquals(z,Z){return F.create(z,Z)}static smaller(z,Z){return x.create(z,Z)}static smallerEquals(z,Z){return B.create(z,Z)}static{this._parser=new I({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this._parser.parse(z)}}e.ContextKeyExpr=i;function a(he){const z=new I({regexParsingWithErrorRecovery:!1});return he.map(Z=>(z.parse(Z),z.lexingErrors.length>0?z.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,T.localize)(9,null,ye.additionalInfo):(0,T.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.validateWhenClauses=a;function n(he,z){const Z=he?he.substituteConstants():void 0,ye=z?z.substituteConstants():void 0;return!Z&&!ye?!0:!Z||!ye?!1:Z.equals(ye)}e.expressionsAreEqualWithConstantSubstitution=n;function t(he,z){return he.cmp(z)}class o{static{this.INSTANCE=new o}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=o;class g{static{this.INSTANCE=new g}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return o.INSTANCE}}e.ContextKeyTrueExpr=g;class l{static create(z,Z=null){const ye=y.get(z);return typeof ye=="boolean"?ye?g.INSTANCE:o.INSTANCE:new l(z,Z)}constructor(z,Z){this.key=z,this.negated=Z,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:$(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=y.get(this.key);return typeof z=="boolean"?z?g.INSTANCE:o.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.negated||(this.negated=P.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=l;class h{static create(z,Z,ye=null){if(typeof Z=="boolean")return Z?l.create(z,ye):P.create(z,ye);const Re=y.get(z);return typeof Re=="boolean"?Z===(Re?"true":"false")?g.INSTANCE:o.INSTANCE:new h(z,Z,ye)}constructor(z,Z,ye){this.key=z,this.value=Z,this.negated=ye,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:H(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){const z=y.get(this.key);if(typeof z=="boolean"){const Z=z?"true":"false";return this.value===Z?g.INSTANCE:o.INSTANCE}return this}evaluate(z){return z.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(z){return z.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class w{static create(z,Z){return new w(z,Z)}constructor(z,Z){this.key=z,this.valueKey=Z,this.type=10,this.negated=null}cmp(z){return z.type!==this.type?this.type-z.type:H(this.key,this.valueKey,z.key,z.valueKey)}equals(z){return z.type===this.type?this.key===z.key&&this.valueKey===z.valueKey:!1}substituteConstants(){return this}evaluate(z){const Z=z.getValue(this.valueKey),ye=z.getValue(this.key);return Array.isArray(Z)?Z.includes(ye):typeof ye=="string"&&typeof Z=="object"&&Z!==null?R.call(Z,ye):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(z){return z.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=u.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=w;class u{static create(z,Z){return new u(z,Z)}constructor(z,Z){this.key=z,this.valueKey=Z,this.type=11,this._negated=w.create(z,Z)}cmp(z){return z.type!==this.type?this.type-z.type:this._negated.cmp(z._negated)}equals(z){return z.type===this.type?this._negated.equals(z._negated):!1}substituteConstants(){return this}evaluate(z){return!this._negated.evaluate(z)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(z){return z.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=u;class E{static create(z,Z,ye=null){if(typeof Z=="boolean")return Z?P.create(z,ye):l.create(z,ye);const Re=y.get(z);return typeof Re=="boolean"?Z===(Re?"true":"false")?o.INSTANCE:g.INSTANCE:new E(z,Z,ye)}constructor(z,Z,ye){this.key=z,this.value=Z,this.negated=ye,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:H(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){const z=y.get(this.key);if(typeof z=="boolean"){const Z=z?"true":"false";return this.value===Z?o.INSTANCE:g.INSTANCE}return this}evaluate(z){return z.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(z){return z.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=E;class P{static create(z,Z=null){const ye=y.get(z);return typeof ye=="boolean"?ye?o.INSTANCE:g.INSTANCE:new P(z,Z)}constructor(z,Z){this.key=z,this.negated=Z,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:$(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=y.get(this.key);return typeof z=="boolean"?z?o.INSTANCE:g.INSTANCE:this}evaluate(z){return!z.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(z){return z.mapNot(this.key)}negate(){return this.negated||(this.negated=l.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=P;function O(he,z){if(typeof he=="string"){const Z=parseFloat(he);isNaN(Z)||(he=Z)}return typeof he=="string"||typeof he=="number"?z(he):o.INSTANCE}class N{static create(z,Z,ye=null){return O(Z,Re=>new N(z,Re,ye))}constructor(z,Z,ye){this.key=z,this.value=Z,this.negated=ye,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:H(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(z){return z.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=B.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=N;class F{static create(z,Z,ye=null){return O(Z,Re=>new F(z,Re,ye))}constructor(z,Z,ye){this.key=z,this.value=Z,this.negated=ye,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:H(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(z){return z.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=F;class x{static create(z,Z,ye=null){return O(Z,Re=>new x(z,Re,ye))}constructor(z,Z,ye){this.key=z,this.value=Z,this.negated=ye,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:H(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(z){return z.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=x;class B{static create(z,Z,ye=null){return O(Z,Re=>new B(z,Re,ye))}constructor(z,Z,ye){this.key=z,this.value=Z,this.negated=ye,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:H(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(z){return z.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=B;class U{static create(z,Z){return new U(z,Z)}constructor(z,Z){this.key=z,this.regexp=Z,this.type=7,this.negated=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.key<z.key)return-1;if(this.key>z.key)return 1;const Z=this.regexp?this.regexp.source:"",ye=z.regexp?z.regexp.source:"";return Z<ye?-1:Z>ye?1:0}equals(z){if(z.type===this.type){const Z=this.regexp?this.regexp.source:"",ye=z.regexp?z.regexp.source:"";return this.key===z.key&&Z===ye}return!1}substituteConstants(){return this}evaluate(z){const Z=z.getValue(this.key);return this.regexp?this.regexp.test(Z):!1}serialize(){const z=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${z}`}keys(){return[this.key]}map(z){return z.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=X.create(this)),this.negated}}e.ContextKeyRegexExpr=U;class X{static create(z){return new X(z)}constructor(z){this._actual=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this._actual.cmp(z._actual)}equals(z){return z.type===this.type?this._actual.equals(z._actual):!1}substituteConstants(){return this}evaluate(z){return!this._actual.evaluate(z)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(z){return new X(this._actual.map(z))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=X;function j(he){let z=null;for(let Z=0,ye=he.length;Z<ye;Z++){const Re=he[Z].substituteConstants();if(he[Z]!==Re&&z===null){z=[];for(let ne=0;ne<Z;ne++)z[ne]=he[ne]}z!==null&&(z[Z]=Re)}return z===null?he:z}class ge{static create(z,Z,ye){return ge._normalizeArr(z,Z,ye)}constructor(z,Z){this.expr=z,this.negated=Z,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let Z=0,ye=this.expr.length;Z<ye;Z++){const Re=t(this.expr[Z],z.expr[Z]);if(Re!==0)return Re}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let Z=0,ye=this.expr.length;Z<ye;Z++)if(!this.expr[Z].equals(z.expr[Z]))return!1;return!0}return!1}substituteConstants(){const z=j(this.expr);return z===this.expr?this:ge.create(z,this.negated,!1)}evaluate(z){for(let Z=0,ye=this.expr.length;Z<ye;Z++)if(!this.expr[Z].evaluate(z))return!1;return!0}static _normalizeArr(z,Z,ye){const Re=[];let ne=!1;for(const ee of z)if(ee){if(ee.type===1){ne=!0;continue}if(ee.type===0)return o.INSTANCE;if(ee.type===6){Re.push(...ee.expr);continue}Re.push(ee)}if(Re.length===0&&ne)return g.INSTANCE;if(Re.length!==0){if(Re.length===1)return Re[0];Re.sort(t);for(let ee=1;ee<Re.length;ee++)Re[ee-1].equals(Re[ee])&&(Re.splice(ee,1),ee--);if(Re.length===1)return Re[0];for(;Re.length>1;){const ee=Re[Re.length-1];if(ee.type!==9)break;Re.pop();const de=Re.pop(),K=Re.length===0,le=ie.create(ee.expr.map(oe=>ge.create([oe,de],null,ye)),null,K);le&&(Re.push(le),Re.sort(t))}if(Re.length===1)return Re[0];if(ye){for(let ee=0;ee<Re.length;ee++)for(let de=ee+1;de<Re.length;de++)if(Re[ee].negate().equals(Re[de]))return o.INSTANCE;if(Re.length===1)return Re[0]}return new ge(Re,Z)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const Z of this.expr)z.push(...Z.keys());return z}map(z){return new ge(this.expr.map(Z=>Z.map(z)),null)}negate(){if(!this.negated){const z=[];for(const Z of this.expr)z.push(Z.negate());this.negated=ie.create(z,this,!0)}return this.negated}}e.ContextKeyAndExpr=ge;class ie{static create(z,Z,ye){return ie._normalizeArr(z,Z,ye)}constructor(z,Z){this.expr=z,this.negated=Z,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let Z=0,ye=this.expr.length;Z<ye;Z++){const Re=t(this.expr[Z],z.expr[Z]);if(Re!==0)return Re}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let Z=0,ye=this.expr.length;Z<ye;Z++)if(!this.expr[Z].equals(z.expr[Z]))return!1;return!0}return!1}substituteConstants(){const z=j(this.expr);return z===this.expr?this:ie.create(z,this.negated,!1)}evaluate(z){for(let Z=0,ye=this.expr.length;Z<ye;Z++)if(this.expr[Z].evaluate(z))return!0;return!1}static _normalizeArr(z,Z,ye){let Re=[],ne=!1;if(z){for(let ee=0,de=z.length;ee<de;ee++){const K=z[ee];if(K){if(K.type===0){ne=!0;continue}if(K.type===1)return g.INSTANCE;if(K.type===9){Re=Re.concat(K.expr);continue}Re.push(K)}}if(Re.length===0&&ne)return o.INSTANCE;Re.sort(t)}if(Re.length!==0){if(Re.length===1)return Re[0];for(let ee=1;ee<Re.length;ee++)Re[ee-1].equals(Re[ee])&&(Re.splice(ee,1),ee--);if(Re.length===1)return Re[0];if(ye){for(let ee=0;ee<Re.length;ee++)for(let de=ee+1;de<Re.length;de++)if(Re[ee].negate().equals(Re[de]))return g.INSTANCE;if(Re.length===1)return Re[0]}return new ie(Re,Z)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const Z of this.expr)z.push(...Z.keys());return z}map(z){return new ie(this.expr.map(Z=>Z.map(z)),null)}negate(){if(!this.negated){const z=[];for(const Z of this.expr)z.push(Z.negate());for(;z.length>1;){const Z=z.shift(),ye=z.shift(),Re=[];for(const ne of fe(Z))for(const ee of fe(ye))Re.push(ge.create([ne,ee],null,!1));z.unshift(ie.create(Re,null,!1))}this.negated=ie.create(z,this,!0)}return this.negated}}e.ContextKeyOrExpr=ie;class te extends l{static{this._info=[]}static all(){return te._info.values()}constructor(z,Z,ye){super(z,null),this._defaultValue=Z,typeof ye=="object"?te._info.push({...ye,key:z}):ye!==!0&&te._info.push({key:z,description:ye,type:Z!=null?typeof Z:void 0})}bindTo(z){return z.createKey(this.key,this._defaultValue)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return h.create(this.key,z)}notEqualsTo(z){return E.create(this.key,z)}}e.RawContextKey=te,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function $(he,z){return he<z?-1:he>z?1:0}function H(he,z,Z,ye){return he<Z?-1:he>Z?1:z<ye?-1:z>ye?1:0}function ce(he,z){if(he.type===0||z.type===1)return!0;if(he.type===9)return z.type===9?re(he.expr,z.expr):!1;if(z.type===9){for(const Z of z.expr)if(ce(he,Z))return!0;return!1}if(he.type===6){if(z.type===6)return re(z.expr,he.expr);for(const Z of he.expr)if(ce(Z,z))return!0;return!1}return he.equals(z)}e.implies=ce;function re(he,z){let Z=0,ye=0;for(;Z<he.length&&ye<z.length;){const Re=he[Z].cmp(z[ye]);if(Re<0)return!1;Re===0&&Z++,ye++}return Z===he.length}function fe(he){return he.type===9?he.expr:[he]}}),define(De[219],Ie([1,0,5]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(De[125],Ie([1,0,183,5]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function d(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=d;function A(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function T(c,f){switch(c){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":f==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function m(c,f){return f==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=m;function y(c,f,S){return m(f,S)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===S?!0:v(S).includes(c)}e.isTargetPlatformCompatible=y;function v(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=v;function R(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=R;var k;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var p;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var C;(function(c){c.Install="install",c.Uninstall="uninstall"})(C||(e.StatisticType=C={}));var D;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(D||(e.InstallOperation=D={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var b;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var r;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class s extends Error{constructor(f,S){super(f),this.code=S,this.name=S}}e.ExtensionManagementError=s,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,_.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,_.localize)(1,null),original:"Preferences"}}),define(De[220],Ie([1,0,5]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,_.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,_.createDecorator)("externalTerminal")}),define(De[221],Ie([1,0,46,15,13,11,94,29,96,185,220]),function(me,e,_,L,d,A,T,m,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=v.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:C.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class C extends p{static{this.CMD="cmd.exe"}openTerminal(S,I){return this.spawnTerminal(_,S,y.getWindowsShell(),I)}spawnTerminal(S,I,i,a){const n=I.windowsExec||C.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const t=d.basename(n,".exe").toLowerCase();if(t==="cmder")return S.spawn(n,a?[a]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return n.indexOf(" ")>=0&&o.push('""'),o.push(n),t==="wt"&&o.push("-d ."),new Promise((g,l)=>{const h=r(process),w=S.spawn(i,o,{cwd:a,env:h});w.on("error",l),w.on("exit",()=>g())})}runInTerminal(S,I,i,a,n){const t="windowsExec"in n&&n.windowsExec?n.windowsExec:C.getDefaultTerminalWindows();return new Promise((o,g)=>{const l=`"${I} - ${k}"`,h=`""${i.join('" "')}" & pause"`,w=Object.assign({},r(process),a);Object.keys(w).filter(N=>w[N]===null).forEach(N=>delete w[N]);const u={cwd:I,env:w,windowsVerbatimArguments:!0};let E,P;d.basename(t,".exe")==="wt"?(E=t,P=["-d",".",C.CMD,"/c",h]):(E=C.CMD,P=["/c","start",l,"/wait",t,"/c",h]),_.spawn(E,P,u).on("error",N=>{g(s(N))}),o(void 0)})}static getDefaultTerminalWindows(){if(!C._DEFAULT_TERMINAL_WINDOWS){const S=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");C._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${S?"Sysnative":"System32"}\\cmd.exe`}return C._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=C;class D extends p{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(S,I){return this.spawnTerminal(_,S,I)}runInTerminal(S,I,i,a,n){const t=n.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((o,g)=>{if(t===R.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const l=t===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",w=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`).fsPath,"-t",S||k,"-w",I];for(const P of i)w.push("-a"),w.push(P);if(a){const P=Object.assign({},r(process),a);for(const O in P){const N=P[O];N===null?(w.push("-u"),w.push(O)):(w.push("-e"),w.push(`${O}=${N}`))}}let u="";const E=_.spawn(D.OSASCRIPT,w);E.on("error",P=>{g(s(P))}),E.stderr.on("data",P=>{u+=P.toString()}),E.on("exit",P=>{if(P===0)o(void 0);else if(u){const O=u.split(`
`,1);g(new Error(O[0]))}else g(new Error(v.localize(1,null,l,P)))})}else g(new Error(v.localize(2,null,t)))})}spawnTerminal(S,I,i){const a=I.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((n,t)=>{const o=["-a",a];i&&o.push(i);const g=r(process),l=S.spawn("/usr/bin/open",o,{cwd:i,env:g});l.on("error",t),l.on("exit",()=>n())})}}e.MacExternalTerminalService=D;class b extends p{static{this.WAIT_MESSAGE=v.localize(3,null)}openTerminal(S,I){return this.spawnTerminal(_,S,I)}runInTerminal(S,I,i,a,n){const t=n.linuxExec?Promise.resolve(n.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((o,g)=>{const l=[];t.then(h=>{h.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const w=`${c(i)}; echo; read -p "${b.WAIT_MESSAGE}" -n1;`;l.push(`''${w}''`);const u=Object.assign({},r(process),a);Object.keys(u).filter(N=>u[N]===null).forEach(N=>delete u[N]);const E={cwd:I,env:u};let P="";const O=_.spawn(h,l,E);O.on("error",N=>{g(s(N))}),O.stderr.on("data",N=>{P+=N.toString()}),O.on("exit",N=>{if(N===0)o(void 0);else if(P){const F=P.split(`
`,1);g(new Error(F[0]))}else g(new Error(v.localize(4,null,h,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!b._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)b._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const S=await m.Promises.exists("/etc/debian_version");b._DEFAULT_TERMINAL_LINUX_READY=new Promise(I=>{S?I("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?I("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?I("konsole"):process.env.COLORTERM?I(process.env.COLORTERM):process.env.TERM?I(process.env.TERM):I("xterm")})}return b._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(S,I,i){const a=I.linuxExec?Promise.resolve(I.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((n,t)=>{a.then(o=>{const g=r(process),l=S.spawn(o,[],{cwd:i,env:g});l.on("error",t),l.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=b;function r(f){const S={...f.env};return(0,T.sanitizeProcessEnvironment)(S),S}function s(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(v.localize(5,null,f.path)):f}function c(f){let S="";for(const I of f)I.indexOf(" ")>=0?S+='"'+I+'"':S+=I,S+=" ";return S}}),define(De[30],Ie([1,0,71,13,12,14,2,186,5,11,15]),function(me,e,_,L,d,A,T,m,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function k($){return $.create===!0}e.isFileOpenForWriteOptions=k;var p;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var C;(function($){$[$.Readonly=1]="Readonly",$[$.Locked=2]="Locked"})(C||(e.FilePermission=C={}));var D;(function($){$[$.None=0]="None",$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileAtomicWrite=32768]="FileAtomicWrite",$[$.FileAtomicDelete=65536]="FileAtomicDelete",$[$.FileClone=131072]="FileClone"})(D||(e.FileSystemProviderCapabilities=D={}));function b($){return!!($.capabilities&2)}e.hasReadWriteCapability=b;function r($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=r;function s($){return!!($.capabilities&131072)}e.hasFileCloneCapability=s;function c($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function f($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=f;function S($){return b($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;function I($){return b($)?!!($.capabilities&32768):!1}e.hasFileAtomicWriteCapability=I;function i($){return!!($.capabilities&65536)}e.hasFileAtomicDeleteCapability=i;function a($){return!!($.capabilities&2048)}e.hasReadonlyCapability=a;var n;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsStorageQuota="EntryExceedsStorageQuota",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class t extends Error{static create(H,ce){const re=new t(H.toString(),ce);return l(re,ce),re}constructor(H,ce){super(H),this.code=ce}}e.FileSystemProviderError=t;function o($,H){return t.create($,H)}e.createFileSystemProviderError=o;function g($){return $||o((0,m.localize)(0,null),n.Unknown)}e.ensureFileSystemProviderError=g;function l($,H){return $.name=H?`${H} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=l;function h($){if(!$)return n.Unknown;if($ instanceof t)return $.code;const H=/^(.+) \(FileSystemError\)$/.exec($.name);if(!H)return n.Unknown;switch(H[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.toFileSystemProviderErrorCode=h;function w($){if($ instanceof F)return $.fileOperationResult;switch(h($)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=w;var u;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(u||(e.FileOperation=u={}));class E{constructor(H,ce,re){this.resource=H,this.operation=ce,this.target=re}isOperation(H){return this.operation===H}}e.FileOperationEvent=E;var P;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(P||(e.FileChangeType=P={}));class O{constructor(H,ce){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const re=new Map;for(const fe of H){const he=re.get(fe.type);switch(he?he.push([fe.resource,fe]):re.set(fe.type,[[fe.resource,fe]]),fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}}for(const[fe,he]of re)switch(fe){case 1:this.added=_.TernarySearchTree.forUris(()=>ce),this.added.fill(he);break;case 0:this.updated=_.TernarySearchTree.forUris(()=>ce),this.updated.fill(he);break;case 2:this.deleted=_.TernarySearchTree.forUris(()=>ce),this.deleted.fill(he);break}}contains(H,...ce){return this.doContains(H,{includeChildren:!1},...ce)}affects(H,...ce){return this.doContains(H,{includeChildren:!0},...ce)}doContains(H,ce,...re){if(!H)return!1;const fe=re.length>0;return!!((!fe||re.includes(1))&&(this.added?.get(H)||ce.includeChildren&&this.added?.findSuperstr(H))||(!fe||re.includes(0))&&(this.updated?.get(H)||ce.includeChildren&&this.updated?.findSuperstr(H))||(!fe||re.includes(2))&&(this.deleted?.findSubstr(H)||ce.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=O;function N($,H,ce){return!$||!H||$===H||H.length>$.length?!1:(H.charAt(H.length-1)!==L.sep&&(H+=L.sep),ce?(0,d.startsWithIgnoreCase)($,H):$.indexOf(H)===0)}e.isParent=N;class F extends Error{constructor(H,ce,re){super(H),this.fileOperationResult=ce,this.options=re}}e.FileOperationError=F;class x extends F{constructor(H,ce,re,fe){super(H,ce,fe),this.fileOperationResult=ce,this.size=re}}e.TooLargeFileOperationError=x;class B extends F{constructor(H,ce,re){super(H,2,re),this.stat=ce}}e.NotModifiedSinceFileOperationError=B;var U;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(U||(e.FileOperationResult=U={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var X;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.ETAG_DISABLED="";function j($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=j;async function ge($,H){if(!H.hasProvider(T.URI.from({scheme:$.scheme})))return new Promise(ce=>{const re=H.onDidChangeFileSystemProviderRegistrations(fe=>{fe.scheme===$.scheme&&fe.added&&(re.dispose(),ce())})})}e.whenProviderRegistered=ge;class ie{static{this.KB=1024}static{this.MB=ie.KB*ie.KB}static{this.GB=ie.MB*ie.KB}static{this.TB=ie.GB*ie.KB}static formatSize(H){return(0,A.isNumber)(H)||(H=0),H<ie.KB?(0,m.localize)(1,null,H.toFixed(0)):H<ie.MB?(0,m.localize)(2,null,(H/ie.KB).toFixed(2)):H<ie.GB?(0,m.localize)(3,null,(H/ie.MB).toFixed(2)):H<ie.TB?(0,m.localize)(4,null,(H/ie.GB).toFixed(2)):(0,m.localize)(5,null,(H/ie.TB).toFixed(2))}}e.ByteSize=ie;function te($){const H=typeof $=="string"||$?.scheme===R.Schemas.vscodeRemote;return typeof $!="string"&&$?.scheme===R.Schemas.file?1024*ie.MB:H?10*ie.MB:v.isWeb?50*ie.MB:1024*ie.MB}e.getLargeFileConfirmationLimit=te}),define(De[222],Ie([1,0,22,8,187,30]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(R,k,p,C,D,b){let r;try{await m(R,k,p,C,D,b)}catch(s){r=s}finally{r&&D.errorTransformer&&(r=D.errorTransformer(r)),typeof r<"u"&&p.error(r),p.end()}}e.readFileIntoStream=T;async function m(R,k,p,C,D,b){y(b);const r=await R.open(k,{create:!1});try{y(b);let s=0,c=0,f=D&&typeof D.length=="number"?D.length:void 0,S=_.VSBuffer.alloc(Math.min(D.bufferSize,typeof f=="number"?f:D.bufferSize)),I=D&&typeof D.position=="number"?D.position:0,i=0;do c=await R.read(r,I,S.buffer,i,S.byteLength-i),I+=c,i+=c,s+=c,typeof f=="number"&&(f-=c),i===S.byteLength&&(await p.write(C(S)),S=_.VSBuffer.alloc(Math.min(D.bufferSize,typeof f=="number"?f:D.bufferSize)),i=0);while(c>0&&(typeof f!="number"||f>0)&&y(b)&&v(s,D));if(i>0){let a=i;typeof f=="number"&&(a=Math.min(i,f)),p.write(C(S.slice(0,a)))}}catch(s){throw(0,A.ensureFileSystemProviderError)(s)}finally{await R.close(r)}}function y(R){if(R.isCancellationRequested)throw(0,L.canceled)();return!0}function v(R,k){if(typeof k?.limits?.size=="number"&&R>k.limits.size)throw(0,A.createFileSystemProviderError)((0,d.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[78],Ie([1,0,34,4,13,11,2,30]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function y(s){return s.recursive===!0}e.isRecursiveWatchRequest=y;class v extends L.Disposable{static{this.MAX_RESTARTS=5}constructor(c,f,S,I){super(),this.onFileChanges=c,this.onLogMessage=f,this.verboseLogging=S,this.options=I,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const c=new L.DisposableStore;this.watcherDisposables.value=c,this.watcher=this.createWatcher(c),this.watcher.setVerboseLogging(this.verboseLogging),c.add(this.watcher.onDidChangeFile(f=>this.onFileChanges(f))),c.add(this.watcher.onDidLogMessage(f=>this.onLogMessage(f))),c.add(this.watcher.onDidError(f=>this.onError(f)))}onError(c){this.options.restartOnError?this.restartCounter<v.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${c}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${c}`):this.error(c)}restart(c){this.restartCounter++,this.init(),this.watch(c)}async watch(c){this.requests=c,await this.watcher?.watch(c)}async setVerboseLogging(c){this.verboseLogging=c,await this.watcher?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${c}`})}trace(c){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${c}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=v;class R extends v{constructor(c,f,S){super(c,f,S,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=R;class k extends v{constructor(c,f,S){super(c,f,S,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=k;function p(s){return s.map(c=>({type:c.type,resource:T.URI.file(c.path)}))}e.toFileChanges=p;function C(s){const c=new r;for(const f of s)c.processEvent(f);return c.coalesce()}e.coalesceEvents=C;function D(s,c){return typeof c=="string"&&!c.startsWith(_.GLOBSTAR)&&!(0,d.isAbsolute)(c)?{base:s,pattern:c}:c}e.normalizeWatcherPattern=D;function b(s,c){const f=[];for(const S of c)f.push((0,_.parse)(D(s,S)));return f}e.parseWatcherPatterns=b;class r{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(c){return A.isLinux?c.path:c.path.toLowerCase()}processEvent(c){const f=this.mapPathToChange.get(this.toKey(c));let S=!1;if(f){const I=f.type,i=c.type;f.path!==c.path&&(c.type===2||c.type===1)?S=!0:I===1&&i===2?(this.mapPathToChange.delete(this.toKey(c)),this.coalesced.delete(f)):I===2&&i===1?f.type=0:I===1&&i===0||(f.type=i)}else S=!0;S&&(this.coalesced.add(c),this.mapPathToChange.set(this.toKey(c),c))}coalesce(){const c=[],f=[];return Array.from(this.coalesced).filter(S=>S.type!==2?(c.push(S),!1):!0).sort((S,I)=>S.path.length-I.path.length).filter(S=>f.some(I=>(0,m.isParent)(S.path,I,!A.isLinux))?!1:(f.push(S.path),!0)).concat(c)}}}),define(De[223],Ie([1,0,49,17,21,31,4,69,13,11,95,29,78]),function(me,e,_,L,d,A,T,m,y,v,R,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class C extends T.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(r,s,c,f){super(),this.request=r,this.onDidFilesChange=s,this.onLogMessage=c,this.verboseLogging=f,this.throttledFileChangesEmitter=this._register(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},S=>this.onDidFilesChange(S))),this.fileChangesAggregator=this._register(new L.RunOnceWorker(S=>this.handleFileChanges(S),C.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,p.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,p.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new d.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const r=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const s=await k.Promises.stat(r);this._register(await this.doWatch(r,s.isDirectory()))}catch(r){r.code!=="ENOENT"?this.error(r):this.trace(r)}}async normalizePath(r){let s=r.path;try{s=await k.Promises.realpath(r.path),r.path===s&&(s=await(0,R.realcase)(r.path)??r.path),r.path!==s&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${s})`)}catch{}return s}async doWatch(r,s){if(v.isMacintosh&&(0,A.isEqualOrParent)(r,"/Volumes/",!0))return this.error(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const c=new d.CancellationTokenSource(this.cts.token),f=new T.DisposableStore;try{const S=(0,y.basename)(r),I=(0,_.watch)(r);f.add((0,T.toDisposable)(()=>{I.removeAllListeners(),I.close()})),this.trace(`Started watching: '${r}'`);const i=new Set;if(s)try{for(const n of await k.Promises.readdir(r))i.add(n)}catch(n){this.error(n)}const a=new Map;f.add((0,T.toDisposable)(()=>{for(const[,n]of a)n.dispose();a.clear()})),I.on("error",(n,t)=>{this.error(`Failed to watch ${r} for changes using fs.watch() (${n}, ${t})`),this.dispose()}),I.on("change",(n,t)=>{if(c.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${t}`);let o="";if(t&&(o=t.toString(),v.isMacintosh&&(o=(0,m.normalizeNFC)(o))),!(!o||n!=="change"&&n!=="rename"))if(s)if(n==="rename"){a.get(o)?.dispose();const g=setTimeout(async()=>{if(a.delete(o),o===S&&!await k.Promises.exists(r)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.existsChildStrictCase((0,y.join)(r,o));if(c.token.isCancellationRequested)return;let h;l?i.has(o)?h=0:(h=1,i.add(o)):(i.delete(o),h=2),this.onFileChange({path:(0,y.join)(this.request.path,o),type:h})},C.FILE_DELETE_HANDLER_DELAY);a.set(o,(0,T.toDisposable)(()=>clearTimeout(g)))}else{let g;i.has(o)?g=0:(g=1,i.add(o)),this.onFileChange({path:(0,y.join)(this.request.path,o),type:g})}else if(n==="rename"||o!==S){const g=setTimeout(async()=>{const l=await k.Promises.exists(r);c.token.isCancellationRequested||(l?(this.onFileChange({path:this.request.path,type:0},!0),f.add(await this.doWatch(r,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},C.FILE_DELETE_HANDLER_DELAY);f.clear(),f.add((0,T.toDisposable)(()=>clearTimeout(g)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(S){await k.Promises.exists(r)&&!c.token.isCancellationRequested&&this.error(`Failed to watch ${r} for changes using fs.watch() (${S.toString()})`)}return(0,T.toDisposable)(()=>{c.dispose(!0),f.dispose()})}onFileChange(r,s=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`),!s&&this.excludes.some(c=>c(r.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${r.path}`):!s&&this.includes&&this.includes.length>0&&!this.includes.some(c=>c(r.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${r.path}`):this.fileChangesAggregator.work(r))}handleFileChanges(r){const s=(0,p.coalesceEvents)(r);if(s.length>0){if(this.verboseLogging)for(const f of s)this.trace(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.throttledFileChangesEmitter.work(s)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${s[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(r){if(v.isLinux)return k.Promises.exists(r);try{const s=(0,y.basename)(r);return(await k.Promises.readdir((0,y.dirname)(r))).some(f=>f===s)}catch(s){return this.trace(s),!1}}setVerboseLogging(r){this.verboseLogging=r}error(r){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}warn(r){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}trace(r){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=C;async function D(b,r,s,c,f=512){const S=await k.Promises.open(b,"r"),I=Buffer.allocUnsafe(f),i=new d.CancellationTokenSource(c);let a,n=!1;const t={path:b,excludes:[],recursive:!1},o=new C(t,g=>{(async()=>{for(const{type:l}of g)if(l===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:h}=await k.Promises.read(S,I,0,f,null);if(!h||i.token.isCancellationRequested)break;r(I.slice(0,h))}}catch(h){a=new Error(h),i.dispose(!0)}finally{n=!1}}})()});return await o.ready,s(),new Promise((g,l)=>{i.token.onCancellationRequested(async()=>{o.dispose();try{await k.Promises.close(S)}catch(h){a=new Error(h)}a?l(a):g()})})}e.watchFileContents=D}),define(De[224],Ie([1,0,3,34,4,11,223]),function(me,e,_,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class m extends d.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new _.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=_.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(v){const R=this.normalizeRequests(v),k=R.filter(C=>{const D=this.watchers.get(C.path);return D?!(0,L.patternsEquals)(D.request.excludes,C.excludes)||!(0,L.patternsEquals)(D.request.includes,C.includes):!0}),p=Array.from(this.watchers.values()).filter(({request:C})=>!R.find(D=>D.path===C.path&&(0,L.patternsEquals)(D.excludes,C.excludes)&&(0,L.patternsEquals)(D.includes,C.includes))).map(({request:C})=>C.path);k.length&&this.trace(`Request to start watching: ${k.map(C=>`${C.path} (excludes: ${C.excludes.length>0?C.excludes:"<none>"}, includes: ${C.includes&&C.includes.length>0?JSON.stringify(C.includes):"<all>"})`).join(",")}`),p.length&&this.trace(`Request to stop watching: ${p.join(",")}`);for(const C of p)this.stopWatching(C);for(const C of k)this.startWatching(C)}startWatching(v){const R=new T.NodeJSFileWatcherLibrary(v,p=>this._onDidChangeFile.fire(p),p=>this._onDidLogMessage.fire(p),this.verboseLogging),k={request:v,instance:R};this.watchers.set(v.path,k)}async stop(){for(const[v]of this.watchers)this.stopWatching(v);this.watchers.clear()}stopWatching(v){const R=this.watchers.get(v);R&&(this.watchers.delete(v),R.instance.dispose())}normalizeRequests(v){const R=new Map;for(const k of v){const p=A.isLinux?k.path:k.path.toLowerCase();R.set(p,k)}return Array.from(R.values())}async setVerboseLogging(v){this.verboseLogging=v;for(const[,R]of this.watchers)R.instance.setVerboseLogging(v)}trace(v){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(v)})}toMessage(v,R){return R?`[File Watcher (node.js)] ${v} (path: ${R.request.path})`:`[File Watcher (node.js)] ${v}`}}e.NodeJSWatcher=m}),define(De[225],Ie([1,0,78,224]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class d extends _.AbstractNonRecursiveWatcherClient{constructor(T,m,y){super(T,m,y),this.init()}createWatcher(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=d}),define(De[226],Ie([1,0,15,76,176,78]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends A.AbstractUniversalWatcherClient{constructor(y,v,R){super(y,v,R),this.init()}createWatcher(y){const v=y.add(new d.Client(_.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(v.onDidProcessExit(({code:R,signal:k})=>this.onError(`terminated by itself with code ${R}, signal: ${k}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(v.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(De[99],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...d){this._entries=new Map;for(const[A,T]of d)this.set(A,T)}set(d,A){const T=this._entries.get(d);return this._entries.set(d,A),T}has(d){return this._entries.has(d)}get(d){return this._entries.get(d)}}e.ServiceCollection=_}),define(De[227],Ie([1,0,17,8,4,97,218,5,99,68]),function(me,e,_,L,d,A,T,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class k extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class p{constructor(r=new y.ServiceCollection,s=!1,c,f=R){this._services=r,this._strict=s,this._parent=c,this._enableTracing=f,this._activeInstantiations=new Set,this._services.set(m.IInstantiationService,this),this._globalGraph=f?c?._globalGraph??new T.Graph(S=>S):void 0}createChild(r){return new p(r,this._strict,this,this._enableTracing)}invokeFunction(r,...s){const c=D.traceInvocation(this._enableTracing,r);let f=!1;try{return r({get:I=>{if(f)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(I,c);if(!i)throw new Error(`[invokeFunction] unknown service '${I}'`);return i}},...s)}finally{f=!0,c.stop()}}createInstance(r,...s){let c,f;return r instanceof A.SyncDescriptor?(c=D.traceCreation(this._enableTracing,r.ctor),f=this._createInstance(r.ctor,r.staticArguments.concat(s),c)):(c=D.traceCreation(this._enableTracing,r),f=this._createInstance(r,s,c)),c.stop(),f}_createInstance(r,s=[],c){const f=m._util.getServiceDependencies(r).sort((i,a)=>i.index-a.index),S=[];for(const i of f){const a=this._getOrCreateServiceInstance(i.id,c);a||this._throwIfStrict(`[createInstance] ${r.name} depends on UNKNOWN service ${i.id}.`,!1),S.push(a)}const I=f.length>0?f[0].index:s.length;if(s.length!==I){console.trace(`[createInstance] First service dependency of ${r.name} at position ${I+1} conflicts with ${s.length} static arguments`);const i=I-s.length;i>0?s=s.concat(new Array(i)):s=s.slice(0,I)}return Reflect.construct(r,s.concat(S))}_setServiceInstance(r,s){if(this._services.get(r)instanceof A.SyncDescriptor)this._services.set(r,s);else if(this._parent)this._parent._setServiceInstance(r,s);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){const s=this._services.get(r);return!s&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):s}_getOrCreateServiceInstance(r,s){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(r));const c=this._getServiceInstanceOrDescriptor(r);return c instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,c,s.branch(r,!0)):(s.branch(r,!1),c)}_safeCreateAndCacheServiceInstance(r,s,c){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,s,c)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,s,c){const f=new T.Graph(i=>i.id.toString());let S=0;const I=[{id:r,desc:s,_trace:c}];for(;I.length;){const i=I.pop();if(f.lookupOrInsertNode(i),S++>1e3)throw new k(f);for(const a of m._util.getServiceDependencies(i.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(a.id);if(n||this._throwIfStrict(`[createInstance] ${r} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(a.id)),n instanceof A.SyncDescriptor){const t={id:a.id,desc:n,_trace:i._trace.branch(a.id,!0)};f.insertEdge(i,t),I.push(t)}}}for(;;){const i=f.roots();if(i.length===0){if(!f.isEmpty())throw new k(f);break}for(const{data:a}of i){if(this._getServiceInstanceOrDescriptor(a.id)instanceof A.SyncDescriptor){const t=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,t)}f.removeNode(a)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,s,c=[],f,S){if(this._services.get(r)instanceof A.SyncDescriptor)return this._createServiceInstance(r,s,c,f,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,s,c,f,S);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}_createServiceInstance(r,s,c=[],f,S){if(f){const I=new p(void 0,this._strict,this,this._enableTracing);I._globalGraphImplicitDependency=String(r);const i=new Map,a=new _.IdleValue(()=>{const n=I._createInstance(s,c,S);for(const[t,o]of i){const g=n[t];if(typeof g=="function")for(const l of o)g.apply(n,l)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,t){if(!a.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let l=i.get(t);return l||(l=new v.LinkedList,i.set(t,l)),(w,u,E)=>{const P=l.push([w,u,E]);return(0,d.toDisposable)(P)}}if(t in n)return n[t];const o=a.value;let g=o[t];return typeof g!="function"||(g=g.bind(o),n[t]=g),g},set(n,t,o){return a.value[t]=o,!0},getPrototypeOf(n){return s.prototype}})}else return this._createInstance(s,c,S)}_throwIfStrict(r,s){if(s&&console.warn(r),this._strict)throw new Error(r)}}e.InstantiationService=p;var C;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(C||(C={}));class D{static{this.all=new Set}static{this._None=new class extends D{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(r,s){return r?new D(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):D._None}static traceCreation(r,s){return r?new D(1,s.name):D._None}static{this._totals=0}constructor(r,s){this.type=r,this.name=s,this._start=Date.now(),this._dep=[]}branch(r,s){const c=new D(3,r.toString());return this._dep.push([r,s,c]),c}stop(){const r=Date.now()-this._start;D._totals+=r;let s=!1;function c(S,I){const i=[],a=new Array(S+1).join("	");for(const[n,t,o]of I._dep)if(t&&o){s=!0,i.push(`${a}CREATES -> ${n}`);const g=c(S+1,o);g&&i.push(g)}else i.push(`${a}uses -> ${n}`);return i.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${D._totals.toFixed(2)}ms)`];(r>2||s)&&D.all.add(f.join(`
`))}}e.Trace=D}),define(De[18],Ie([1,0,45,3,70,4,28,11,24,14,2,47,5]),function(me,e,_,L,d,A,T,m,y,v,R,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function C(){return new Date().toISOString()}function D(w){return(0,v.isNumber)(w)}e.isLogLevel=D;var b;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(b||(e.LogLevel=b={})),e.DEFAULT_LOG_LEVEL=b.Info;function r(w,u,E){switch(u){case b.Trace:w.trace(E);break;case b.Debug:w.debug(E);break;case b.Info:w.info(E);break;case b.Warning:w.warn(E);break;case b.Error:w.error(E);break;case b.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=r;function s(w,u=!1){let E="";for(let P=0;P<w.length;P++){let O=w[P];if(O instanceof Error&&(O=(0,_.toErrorMessage)(O,u)),typeof O=="object")try{O=JSON.stringify(O)}catch{}E+=(P>0?" ":"")+O}return E}class c extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(u){this.level!==u&&(this.level=u,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(u){return this.level!==b.Off&&this.level<=u}}e.AbstractLogger=c;class f extends c{constructor(u){super(),this.logAlways=u}checkLogLevel(u){return this.logAlways||super.checkLogLevel(u)}trace(u,...E){this.checkLogLevel(b.Trace)&&this.log(b.Trace,s([u,...E],!0))}debug(u,...E){this.checkLogLevel(b.Debug)&&this.log(b.Debug,s([u,...E]))}info(u,...E){this.checkLogLevel(b.Info)&&this.log(b.Info,s([u,...E]))}warn(u,...E){this.checkLogLevel(b.Warning)&&this.log(b.Warning,s([u,...E]))}error(u,...E){if(this.checkLogLevel(b.Error))if(u instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=u.stack,this.log(b.Error,s(P))}else this.log(b.Error,s([u,...E]))}flush(){}}e.AbstractMessageLogger=f;class S extends c{constructor(u=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(u),this.useColors=!m.isWindows}trace(u,...E){this.checkLogLevel(b.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,u,...E):console.log(`[main ${C()}]`,u,...E))}debug(u,...E){this.checkLogLevel(b.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,u,...E):console.log(`[main ${C()}]`,u,...E))}info(u,...E){this.checkLogLevel(b.Info)&&(this.useColors?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,u,...E):console.log(`[main ${C()}]`,u,...E))}warn(u,...E){this.checkLogLevel(b.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${C()}]\x1B[0m`,u,...E):console.warn(`[main ${C()}]`,u,...E))}error(u,...E){this.checkLogLevel(b.Error)&&(this.useColors?console.error(`\x1B[91m[main ${C()}]\x1B[0m`,u,...E):console.error(`[main ${C()}]`,u,...E))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class I extends c{constructor(u=e.DEFAULT_LOG_LEVEL,E=!0){super(),this.useColors=E,this.setLevel(u)}trace(u,...E){this.checkLogLevel(b.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",u,...E):console.log(u,...E))}debug(u,...E){this.checkLogLevel(b.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",u,...E):console.log(u,...E))}info(u,...E){this.checkLogLevel(b.Info)&&(this.useColors?console.log("%c INFO","color: #33f",u,...E):console.log(u,...E))}warn(u,...E){this.checkLogLevel(b.Warning)&&(this.useColors?console.log("%c WARN","color: #993",u,...E):console.log(u,...E))}error(u,...E){this.checkLogLevel(b.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",u,...E):console.error(u,...E))}dispose(){}flush(){}}e.ConsoleLogger=I;class i extends c{constructor(u,E=e.DEFAULT_LOG_LEVEL){super(),this.adapter=u,this.setLevel(E)}trace(u,...E){this.checkLogLevel(b.Trace)&&this.adapter.log(b.Trace,[this.extractMessage(u),...E])}debug(u,...E){this.checkLogLevel(b.Debug)&&this.adapter.log(b.Debug,[this.extractMessage(u),...E])}info(u,...E){this.checkLogLevel(b.Info)&&this.adapter.log(b.Info,[this.extractMessage(u),...E])}warn(u,...E){this.checkLogLevel(b.Warning)&&this.adapter.log(b.Warning,[this.extractMessage(u),...E])}error(u,...E){this.checkLogLevel(b.Error)&&this.adapter.log(b.Error,[this.extractMessage(u),...E])}extractMessage(u){return typeof u=="string"?u:(0,_.toErrorMessage)(u,this.checkLogLevel(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=i;class a extends c{constructor(u){super(),this.loggers=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const E of this.loggers)E.setLevel(u);super.setLevel(u)}trace(u,...E){for(const P of this.loggers)P.trace(u,...E)}debug(u,...E){for(const P of this.loggers)P.debug(u,...E)}info(u,...E){for(const P of this.loggers)P.info(u,...E)}warn(u,...E){for(const P of this.loggers)P.warn(u,...E)}error(u,...E){for(const P of this.loggers)P.error(u,...E)}flush(){for(const u of this.loggers)u.flush()}dispose(){for(const u of this.loggers)u.dispose()}}e.MultiplexLogger=a;class n extends A.Disposable{constructor(u,E,P){if(super(),this.logLevel=u,this.logsHome=E,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,P)for(const O of P)this._loggers.set(O.resource,{logger:void 0,info:O})}getLoggerEntry(u){return(0,v.isString)(u)?[...this._loggers.values()].find(E=>E.info.id===u):this._loggers.get(u)}getLogger(u){return this.getLoggerEntry(u)?.logger}createLogger(u,E){const P=this.toResource(u),O=(0,v.isString)(u)?u:E?.id??(0,d.hash)(P.toString()).toString(16);let N=this._loggers.get(P)?.logger;const F=E?.logLevel==="always"?b.Trace:E?.logLevel;N||(N=this.doCreateLogger(P,F??this.getLogLevel(P)??this.logLevel,{...E,id:O}));const x={logger:N,info:{resource:P,id:O,logLevel:F,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(x.info),this._loggers.set(P,x),N}toResource(u){return(0,v.isString)(u)?(0,y.joinPath)(this.logsHome,`${u}.log`):u}setLogLevel(u,E){if(R.URI.isUri(u)){const P=u,O=E,N=this._loggers.get(P);N&&O!==N.info.logLevel&&(N.info.logLevel=O===this.logLevel?void 0:O,N.logger?.setLevel(O),this._loggers.set(N.info.resource,N),this._onDidChangeLogLevel.fire([P,O]))}else{this.logLevel=u;for(const[P,O]of this._loggers.entries())this._loggers.get(P)?.info.logLevel===void 0&&O.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(u,E){const P=this.getLoggerEntry(u);P&&E!==!P.info.hidden&&(P.info.hidden=!E,this._loggers.set(P.info.resource,P),this._onDidChangeVisibility.fire([P.info.resource,E]))}getLogLevel(u){let E;return u&&(E=this._loggers.get(u)?.info.logLevel),E??this.logLevel}registerLogger(u){const E=this._loggers.get(u.resource);E?E.info.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this._loggers.set(u.resource,{info:u,logger:void 0}),this._onDidChangeLoggers.fire({added:[u],removed:[]}))}deregisterLogger(u){const E=this._loggers.get(u);E&&(E.logger&&E.logger.dispose(),this._loggers.delete(u),this._onDidChangeLoggers.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const u of this._loggers.values())yield u.info}getRegisteredLogger(u){return this._loggers.get(u)?.info}dispose(){this._loggers.forEach(u=>u.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class t{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(u){}getLevel(){return b.Info}trace(u,...E){}debug(u,...E){}info(u,...E){}warn(u,...E){}error(u,...E){}critical(u,...E){}dispose(){}flush(){}}e.NullLogger=t;class o extends t{}e.NullLogService=o;function g(w){if(w.verbose)return b.Trace;if(typeof w.logLevel=="string"){const u=h(w.logLevel.toLowerCase());if(u!==void 0)return u}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function l(w){switch(w){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=l;function h(w){switch(w){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=h,e.CONTEXT_LOG_LEVEL=new k.RawContextKey("logLevel",l(b.Info))}),define(De[228],Ie([1,0,19,17,8,3,4,13,78,18]),function(me,e,_,L,d,A,T,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class R extends T.Disposable{constructor(p,C){super(),this.logService=p,this.options=C,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new L.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(p,C){return C.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,C):this.watchNonRecursive(p,C)}watchUniversal(p,C){const D={path:this.toFilePath(p),excludes:C.excludes,includes:C.includes,recursive:C.recursive},b=(0,_.insert)(this.universalPathsToWatch,D);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{b(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,d.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(C=>this._onDidChangeFile.fire((0,y.toFileChanges)(C)),C=>this.onWatcherLogMessage(C),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const C of this.universalPathsToWatch)(0,y.isRecursiveWatchRequest)(C)&&(C.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const C of this.universalPathsToWatch)(0,y.isRecursiveWatchRequest)(C)&&p.includes(C.path)&&(C.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(p,C){const D={path:this.toFilePath(p),excludes:C.excludes,includes:C.includes,recursive:!1},b=(0,_.insert)(this.nonRecursivePathsToWatch,D);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{b(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,d.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,y.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,m.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=R}),define(De[229],Ie([1,0,49,352,17,28,22,3,31,4,13,11,24,92,29,188,30,222,228,45,226,225]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c,f,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(_)}catch(a){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(a)}`)}})();class i extends c.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(n,t){super(n,t),this.onDidChangeCapabilities=m.Event.None,this.resourceLocks=new A.ResourceMap(o=>p.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:t,symbolicLink:o}=await D.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(t,o),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:r.FilePermission.Locked}}catch(t){throw this.toFileSystemProviderError(t)}}async statIgnoreError(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const t=await D.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),o=[];return await Promise.all(t.map(async g=>{try{let l;g.isSymbolicLink()?l=(await this.stat((0,p.joinPath)(n,g.name))).type:l=this.toType(g),o.push([g.name,l])}catch(l){this.logService.trace(l)}})),o}catch(t){throw this.toFileSystemProviderError(t)}}toType(n,t){let o;return t?.dangling?o=r.FileType.Unknown:n.isFile()?o=r.FileType.File:n.isDirectory()?o=r.FileType.Directory:o=r.FileType.Unknown,t&&(o|=r.FileType.SymbolicLink),o}async createResourceLock(n){const t=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let o;for(;o=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await o.wait();const g=new d.Barrier;return this.resourceLocks.set(n,g),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,v.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.resourceLocks.get(n)===g&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),g.open()})}async readFile(n,t){let o;try{t?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),o=await this.createResourceLock(n));const g=this.toFilePath(n);return await D.Promises.readFile(g)}catch(g){throw this.toFileSystemProviderError(g)}finally{o?.dispose()}}traceLock(n){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,t,o){const g=(0,C.newWriteableStream)(l=>T.VSBuffer.concat(l.map(h=>T.VSBuffer.wrap(h))).buffer);return(0,s.readFileIntoStream)(this,n,g,l=>l.buffer,{...t,bufferSize:256*1024},o),g}async writeFile(n,t,o){return o?.atomic!==!1&&o?.atomic?.postfix?this.doWriteFileAtomic(n,(0,p.joinPath)((0,p.dirname)(n),`${(0,p.basename)(n)}${o.atomic.postfix}`),t,o):this.doWriteFile(n,t,o)}async doWriteFileAtomic(n,t,o,g){await this.doWriteFile(t,o,g);try{await this.rename(t,n,{overwrite:!0})}catch(l){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}async doWriteFile(n,t,o){let g;try{const l=this.toFilePath(n);if(!o.create||!o.overwrite){if(await D.Promises.exists(l)){if(!o.overwrite)throw(0,r.createFileSystemProviderError)((0,b.localize)(0,null),r.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,r.createFileSystemProviderError)((0,b.localize)(1,null),r.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(n,{create:!0,unlock:o.unlock}),await this.write(g,0,t,0,t.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(n,l)}finally{typeof g=="number"&&await this.close(g)}}static{this.canFlush=!0}static configureFlushOnWrite(n){i.canFlush=n}async open(n,t){const o=this.toFilePath(n);let g;(0,r.isFileOpenForWriteOptions)(t)&&(g=await this.createResourceLock(n));let l;try{if((0,r.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:w}=await D.SymlinkSupport.stat(o);w.mode&128||await D.Promises.chmod(o,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}let h;if((0,r.isFileOpenForWriteOptions)(t)){if(k.isWindows)try{await D.Promises.truncate(o,0),h="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}h||(h="w")}else h="r";l=await D.Promises.open(o,h)}catch(h){throw g?.dispose(),(0,r.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(n,h):this.toFileSystemProviderError(h)}if(this.mapHandleToPos.set(l,0),(0,r.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(l,n),g){const h=this.mapHandleToLock.get(l);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${o})`),this.mapHandleToLock.set(l,g),h&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${o})`),h.dispose())}return l}async close(n){const t=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&i.canFlush)try{await D.Promises.fdatasync(n)}catch(o){i.configureFlushOnWrite(!1),this.logService.error(o)}return await D.Promises.close(n)}catch(o){throw this.toFileSystemProviderError(o)}finally{t&&(this.mapHandleToLock.get(n)===t&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),t.dispose())}}async read(n,t,o,g,l){const h=this.normalizePos(n,t);let w=null;try{w=(await D.Promises.read(n,o,g,l,h)).bytesRead}catch(u){throw this.toFileSystemProviderError(u)}finally{this.updatePos(n,h,w)}return w}normalizePos(n,t){return t===this.mapHandleToPos.get(n)?null:t}updatePos(n,t,o){const g=this.mapHandleToPos.get(n);typeof g=="number"&&(typeof t=="number"||(typeof o=="number"?this.mapHandleToPos.set(n,g+o):this.mapHandleToPos.delete(n)))}async write(n,t,o,g,l){return(0,d.retry)(()=>this.doWrite(n,t,o,g,l),100,3)}async doWrite(n,t,o,g,l){const h=this.normalizePos(n,t);let w=null;try{w=(await D.Promises.write(n,o,g,l,h)).bytesWritten}catch(u){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),u)}finally{this.updatePos(n,h,w)}return w}async mkdir(n){try{await D.Promises.mkdir(this.toFilePath(n))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(n,t){try{const o=this.toFilePath(n);if(t.recursive){let g;t?.atomic!==!1&&t.atomic.postfix&&(g=(0,R.join)((0,R.dirname)(o),`${(0,R.basename)(o)}${t.atomic.postfix}`)),await D.Promises.rm(o,D.RimRafMode.MOVE,g)}else try{await D.Promises.unlink(o)}catch(g){if(g.code==="EPERM"||g.code==="EISDIR"){let l=!1;try{const{stat:h,symbolicLink:w}=await D.SymlinkSupport.stat(o);l=h.isDirectory()&&!w}catch{}if(l)await D.Promises.rmdir(o);else throw g}else throw g}}catch(o){throw this.toFileSystemProviderError(o)}}async rename(n,t,o){const g=this.toFilePath(n),l=this.toFilePath(t);if(g!==l)try{await this.validateMoveCopy(n,t,"move",o.overwrite),await D.Promises.move(g,l)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,b.localize)(2,null,(0,R.basename)(g),(0,R.basename)((0,R.dirname)(l)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(n,t,o){const g=this.toFilePath(n),l=this.toFilePath(t);if(g!==l)try{await this.validateMoveCopy(n,t,"copy",o.overwrite),await D.Promises.copy(g,l,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,b.localize)(3,null,(0,R.basename)(g),(0,R.basename)((0,R.dirname)(l)),h.toString()))),this.toFileSystemProviderError(h)}}async validateMoveCopy(n,t,o,g){const l=this.toFilePath(n),h=this.toFilePath(t);let w=!1;if(!!(this.capabilities&1024)||(w=(0,y.isEqual)(l,h,!0)),w){if(o==="copy")throw(0,r.createFileSystemProviderError)((0,b.localize)(4,null),r.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const E=await this.statIgnoreError(n);if(!E)throw(0,r.createFileSystemProviderError)((0,b.localize)(5,null),r.FileSystemProviderErrorCode.FileNotFound);const P=await this.statIgnoreError(t);if(P){if(!g)throw(0,r.createFileSystemProviderError)((0,b.localize)(6,null),r.FileSystemProviderErrorCode.FileExists);E.type&r.FileType.File&&P.type&r.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,t){return this.doCloneFile(n,t,!1)}async doCloneFile(n,t,o){const g=this.toFilePath(n),l=this.toFilePath(t),h=!!(this.capabilities&1024);if((0,y.isEqual)(g,l,!h))return;const w=new v.DisposableStore;try{const[u,E]=await Promise.all([this.createResourceLock(n),this.createResourceLock(t)]);w.add(u),w.add(E),o&&await D.Promises.mkdir((0,R.dirname)(l),{recursive:!0}),await D.Promises.copyFile(g,l)}catch(u){if(u.code==="ENOENT"&&!o)return this.doCloneFile(n,t,!0);throw this.toFileSystemProviderError(u)}finally{w.dispose()}}createUniversalWatcher(n,t,o){return new S.UniversalWatcherClient(g=>n(g),g=>t(g),o)}createNonRecursiveWatcher(n,t,o){return new I.NodeJSWatcherClient(g=>n(g),g=>t(g),o)}toFileSystemProviderError(n){if(n instanceof r.FileSystemProviderError)return n;let t=n,o;switch(n.code){case"ENOENT":o=r.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=r.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=r.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=r.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=r.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=r.FileSystemProviderErrorCode.Unknown;break;default:o=r.FileSystemProviderErrorCode.Unknown}return(0,r.createFileSystemProviderError)(t,o)}async toFileSystemProviderWriteError(n,t){let o=this.toFileSystemProviderError(t);if(n&&o.code===r.FileSystemProviderErrorCode.NoPermissions)try{const{stat:g}=await D.SymlinkSupport.stat(this.toFilePath(n));g.mode&128||(o=(0,r.createFileSystemProviderError)(t,r.FileSystemProviderErrorCode.FileWriteLocked))}catch(g){this.logService.trace(g)}return o}}e.DiskFileSystemProvider=i}),define(De[230],Ie([1,0,4,18]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class d extends _.Disposable{constructor(T,m=[]){super(),this.logger=new L.MultiplexLogger([T,...m]),this._register(T.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...m){this.logger.trace(T,...m)}debug(T,...m){this.logger.debug(T,...m)}info(T,...m){this.logger.info(T,...m)}warn(T,...m){this.logger.warn(T,...m)}error(T,...m){this.logger.error(T,...m)}flush(){this.logger.flush()}}e.LogService=d}),define(De[231],Ie([1,0,30,18]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var d;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(d||(d={}));async function A(v,R,k,p,C){try{const D=await new Promise((r,s)=>{me(["@vscode/spdlog"],r,s)});D.setFlushOn(d.Trace);const b=await D.createAsyncRotatingLogger(v,R,k,p);return C?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(D){console.error(D)}return null}function T(v,R,k){switch(R){case L.LogLevel.Trace:v.trace(k);break;case L.LogLevel.Debug:v.debug(k);break;case L.LogLevel.Info:v.info(k);break;case L.LogLevel.Warning:v.warn(k);break;case L.LogLevel.Error:v.error(k);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function m(v,R){switch(R){case L.LogLevel.Trace:v.setLevel(d.Trace);break;case L.LogLevel.Debug:v.setLevel(d.Debug);break;case L.LogLevel.Info:v.setLevel(d.Info);break;case L.LogLevel.Warning:v.setLevel(d.Warning);break;case L.LogLevel.Error:v.setLevel(d.Error);break;case L.LogLevel.Off:v.setLevel(d.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class y extends L.AbstractMessageLogger{constructor(R,k,p,C,D){super(),this.buffer=[],this.setLevel(D),this._loggerCreationPromise=this._createSpdLogLogger(R,k,p,C),this._register(this.onDidChangeLogLevel(b=>{this._logger&&m(this._logger,b)}))}async _createSpdLogLogger(R,k,p,C){const D=p?6:1,b=30/D*_.ByteSize.MB,r=await A(R,k,b,D,C);if(r){this._logger=r,m(this._logger,this.getLevel());for(const{level:s,message:c}of this.buffer)T(this._logger,s,c);this.buffer=[]}}log(R,k){this._logger?T(this._logger,R,k):this.getLevel()<=R&&this.buffer.push({level:R,message:k})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=y}),define(De[126],Ie([1,0,40,189,5]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var T;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function(y){function v(D,b){return b-D}y.compare=v;const R=Object.create(null);R[y.Error]=(0,L.localize)(0,null),R[y.Warning]=(0,L.localize)(1,null),R[y.Info]=(0,L.localize)(2,null);function k(D){return R[D]||""}y.toString=k;function p(D){switch(D){case _.default.Error:return y.Error;case _.default.Warning:return y.Warning;case _.default.Info:return y.Info;case _.default.Ignore:return y.Hint}}y.fromSeverity=p;function C(D){switch(D){case y.Error:return _.default.Error;case y.Warning:return _.default.Warning;case y.Info:return _.default.Info;case y.Hint:return _.default.Ignore}}y.toSeverity=C}(T||(e.MarkerSeverity=T={}));var m;(function(y){const v="";function R(p){return k(p,!0)}y.makeKey=R;function k(p,C){const D=[v];return p.source?D.push(p.source.replace("\xA6","\\\xA6")):D.push(v),p.code?typeof p.code=="string"?D.push(p.code.replace("\xA6","\\\xA6")):D.push(p.code.value.replace("\xA6","\\\xA6")):D.push(v),p.severity!==void 0&&p.severity!==null?D.push(T.toString(p.severity)):D.push(v),p.message&&C?D.push(p.message.replace("\xA6","\\\xA6")):D.push(v),p.startLineNumber!==void 0&&p.startLineNumber!==null?D.push(p.startLineNumber.toString()):D.push(v),p.startColumn!==void 0&&p.startColumn!==null?D.push(p.startColumn.toString()):D.push(v),p.endLineNumber!==void 0&&p.endLineNumber!==null?D.push(p.endLineNumber.toString()):D.push(v),p.endColumn!==void 0&&p.endColumn!==null?D.push(p.endColumn.toString()):D.push(v),D.push(v),D.join("\xA6")}y.makeKeyOptionalMessage=k})(m||(e.IMarkerData=m={})),e.IMarkerService=(0,d.createDecorator)("markerService")}),define(De[232],Ie([1,0,3,40,5]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,d.createDecorator)("notificationService");var A;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var T;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));var m;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(m||(e.NotificationsFilter=m={}));class y{constructor(){this.progress=new v,this.onDidClose=_.Event.None,this.onDidChangeVisibility=_.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.NoOpNotification=y;class v{infinite(){}done(){}total(k){}worked(k){}}e.NoOpProgress=v}),define(De[127],Ie([1,0,12,2,5]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,d.createDecorator)("openerService");function A(v,R){return L.URI.isUri(v)?(0,_.equalsIgnoreCase)(v.scheme,R):(0,_.startsWithIgnoreCase)(v,R+":")}e.matchesScheme=A;function T(v,...R){return R.some(k=>A(v,k))}e.matchesSomeScheme=T;function m(v,R){return v.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.withSelection=m;function y(v){let R;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(v.fragment);return k&&(R={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},v=v.with({fragment:""})),{selection:R,uri:v}}e.extractSelection=y}),define(De[233],Ie([1,0,11,41]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let d;if(typeof _.globals.vscode<"u"&&typeof _.globals.vscode.context<"u"){const A=_.globals.vscode.context.configuration();if(A)d=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){d=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:A,searchUrl:T,itemUrl:m,controlUrl:y}=d.extensionsGallery||{};Object.assign(d,{extensionsGallery:{serviceUrl:L.env.VSCODE_GALLERY_SERVICE_URL||A,searchUrl:L.env.VSCODE_GALLERY_SEARCH_URL||T,itemUrl:L.env.VSCODE_GALLERY_ITEM_URL||m,controlUrl:L.env.VSCODE_GALLERY_CONTROL_URL||y}});try{const v=(...k)=>k.reduce((p,C)=>(Object.keys(C).forEach(D=>{Array.isArray(p[D])&&Array.isArray(C[D])?p[D]=C[D]:typeof p[D]=="object"&&typeof C[D]=="object"?p[D]=v(p[D],C[D]):p[D]=C[D]}),p),{}),R=globalThis._VSCODE_USER_PRODUCT_JSON||{};d=v(d,R)}catch{}if(L.env.VSCODE_DEV&&Object.assign(d,{nameShort:`${d.nameShort} Dev`,nameLong:`${d.nameLong} Dev`,dataFolderName:`${d.dataFolderName}-dev`,serverDataFolderName:d.serverDataFolderName?`${d.serverDataFolderName}-dev`:void 0}),!d.version){const v=globalThis._VSCODE_PACKAGE_JSON;Object.assign(d,{version:v.version,release:v.release})}}else d={},Object.keys(d).length===0&&Object.assign(d,{version:"1.80.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=d}),define(De[234],Ie([1,0,5]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,_.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__param||function(me,e){return function(_,L){e(_,L,me)}};define(De[128],Ie([1,0,17,21,4,5]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var T;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(k,p){this.callback=k,this.report=p?.async?this._reportAsync.bind(this):this._reportSync.bind(this)}_reportSync(k){this._value=k,this.callback(this._value)}_reportAsync(k){Promise.resolve(this._lastTask).finally(()=>{this._value=k;const p=this.callback(this._value);this._lastTask=Promise.resolve(p).finally(()=>this._lastTask=void 0)})}}e.Progress=m;let y=class extends d.Disposable{constructor(k,p){super(),this.deferred=new _.DeferredPromise,p.withProgress(k,C=>(this.reporter=C,this.lastStep&&C.report(this.lastStep),this.deferred.p)),this._register((0,d.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};e.UnmanagedProgress=y,e.UnmanagedProgress=y=Ve([$e(1,e.IProgressService)],y);class v extends d.Disposable{constructor(k){super(),this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new d.DisposableStore)}start(k){this.stop();const p=++this.currentOperationId,C=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{p===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,d.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,d.toDisposable)(()=>C.cancel())),this.currentOperationDisposables.add((0,d.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:p,token:C.token,stop:()=>this.doStop(p),isCurrent:()=>this.currentOperationId===p}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=v,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(De[42],Ie([1,0,53,14]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class d{constructor(){this.data=new Map}add(T,m){_.ok(L.isString(T)),_.ok(L.isObject(m)),_.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,m)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new d}),define(De[100],Ie([1,0,3,42]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function d(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class A{constructor(){this._onDidChangeSchema=new _.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,v){this.schemasById[d(y)]=v,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new A;L.Registry.add(e.Extensions.JSONContribution,T)}),define(De[129],Ie([1,0,19,3,14,180,57,100,42]),function(me,e,_,L,d,A,T,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var v;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(v||(e.EditPresentationTypes=v={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=y.Registry.as(m.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,a=!0){this.registerConfigurations([i],a)}registerConfigurations(i,a=!0){const n=new Set;this.doRegisterConfigurations(i,a,n),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(i){const a=new Set;this.doDeregisterConfigurations(i,a),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:i,remove:a}){const n=new Set;this.doDeregisterConfigurations(a,n),this.doRegisterConfigurations(i,!1,n),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}registerDefaultConfigurations(i){const a=new Set;this.doRegisterDefaultConfigurations(i,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,a){const n=[];for(const{overrides:t,source:o}of i)for(const g in t)if(a.add(g),e.OVERRIDE_PROPERTY_REGEX.test(g)){const l=this.configurationDefaultsOverrides.get(g),h=l?.valuesSources??new Map;if(o)for(const P of Object.keys(t[g]))h.set(P,o);const w={...l?.value||{},...t[g]};this.configurationDefaultsOverrides.set(g,{source:o,value:w,valuesSources:h});const u=(0,T.getLanguageTagSettingPlainKey)(g),E={type:"object",default:w,description:A.localize(1,null,u),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:d.isString(o)?void 0:o,defaultValueSource:o};n.push(...b(g)),this.configurationProperties[g]=E,this.defaultLanguageConfigurationOverridesNode.properties[g]=E}else{this.configurationDefaultsOverrides.set(g,{value:t[g],source:o});const l=this.configurationProperties[g];l&&(this.updatePropertyDefaultValue(g,l),this.updateSchema(g,l))}this.doRegisterOverrideIdentifiers(n)}deregisterDefaultConfigurations(i){const a=new Set;this.doDeregisterDefaultConfigurations(i,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,a){for(const{overrides:n,source:t}of i)for(const o in n){const g=this.configurationDefaultsOverrides.get(o),l=d.isString(t)?t:t?.id,h=d.isString(g?.source)?g?.source:g?.source?.id;if(l===h)if(a.add(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const w=this.configurationProperties[o];w&&(this.updatePropertyDefaultValue(o,w),this.updateSchema(o,w))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let a=!1;const n=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,n),a=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,n),a=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,n),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const a of i)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,a,n){i.forEach(t=>{this.validateAndRegisterProperties(t,a,t.extensionInfo,t.restrictedProperties,void 0,n),this.configurationContributors.push(t),this.registerJSONConfiguration(t)})}doDeregisterConfigurations(i,a){const n=t=>{if(t.properties)for(const o in t.properties){a.add(o);const g=this.configurationProperties[o];g?.policy?.name&&this.policyConfigurations.delete(g.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,t.properties[o])}t.allOf?.forEach(o=>n(o))};for(const t of i){n(t);const o=this.configurationContributors.indexOf(t);o!==-1&&this.configurationContributors.splice(o,1)}}validateAndRegisterProperties(i,a=!0,n,t,o=3,g){o=d.isUndefinedOrNull(i.scope)?o:i.scope;const l=i.properties;if(l)for(const w in l){const u=l[w];if(a&&f(w,u)){delete l[w];continue}if(u.source=n,u.defaultDefaultValue=l[w].default,this.updatePropertyDefaultValue(w,u),e.OVERRIDE_PROPERTY_REGEX.test(w)?u.scope=void 0:(u.scope=d.isUndefinedOrNull(u.scope)?o:u.scope,u.restricted=d.isUndefinedOrNull(u.restricted)?!!t?.includes(w):u.restricted),l[w].hasOwnProperty("included")&&!l[w].included){this.excludedConfigurationProperties[w]=l[w],delete l[w];continue}else this.configurationProperties[w]=l[w],l[w].policy?.name&&this.policyConfigurations.set(l[w].policy.name,w);!l[w].deprecationMessage&&l[w].markdownDeprecationMessage&&(l[w].deprecationMessage=l[w].markdownDeprecationMessage),g.add(w)}const h=i.allOf;if(h)for(const w of h)this.validateAndRegisterProperties(w,a,n,t,o,g)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const a=n=>{const t=n.properties;if(t)for(const g in t)this.updateSchema(g,t[g]);n.allOf?.forEach(a)};a(i)}updateSchema(i,a){switch(e.allSettings.properties[i]=a,a.scope){case 1:e.applicationSettings.properties[i]=a;break;case 2:e.machineSettings.properties[i]=a;break;case 6:e.machineOverridableSettings.properties[i]=a;break;case 3:e.windowSettings.properties[i]=a;break;case 4:e.resourceSettings.properties[i]=a;break;case 5:e.resourceSettings.properties[i]=a,this.resourceLanguageSettingsSchema.properties[i]=a;break}}removeFromSchema(i,a){switch(delete e.allSettings.properties[i],a.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const a=`[${i}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,n),e.allSettings.properties[a]=n,e.applicationSettings.properties[a]=n,e.machineSettings.properties[a]=n,e.machineOverridableSettings.properties[a]=n,e.windowSettings.properties[a]=n,e.resourceSettings.properties[a]=n}}registerOverridePropertyPatternKey(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,a){const n=this.configurationDefaultsOverrides.get(i);let t=n?.value,o=n?.source;d.isUndefined(t)&&(t=a.defaultDefaultValue,o=void 0),d.isUndefined(t)&&(t=s(a.type)),a.default=t,a.defaultValueSource=o}}const C="\\[([^\\]]+)\\]",D=new RegExp(C,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${C})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(I){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(I)){let a=D.exec(I);for(;a?.length;){const n=a[1].trim();n&&i.push(n),a=D.exec(I)}}return(0,_.distinct)(i)}e.overrideIdentifiersFromKey=b;function r(I){return I.reduce((i,a)=>`${i}[${a}]`,"")}e.keyFromOverrideIdentifiers=r;function s(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=s;const c=new p;y.Registry.add(e.Extensions.Configuration,c);function f(I,i){return I.trim()?e.OVERRIDE_PROPERTY_REGEX.test(I)?A.localize(7,null,I):c.getConfigurationProperties()[I]!==void 0?A.localize(8,null,I):i.policy?.name&&c.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,I,i.policy?.name,c.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}e.validateProperty=f;function S(){const I=[],i=c.getConfigurationProperties();for(const a of Object.keys(i))I.push([a,i[a].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=S}),define(De[235],Ie([1,0,19,3,151,4,28,23,14,2,57,129,42]),function(me,e,_,L,d,A,T,m,y,v,R,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function C(a){return Object.isFrozen(a)?a:m.deepFreeze(a)}class D{constructor(n={},t=[],o=[],g){this._contents=n,this._keys=t,this._overrides=o,this.raw=g,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(t=>{if(t instanceof D)return t;const o=new b("");return o.parseRaw(t),o.configurationModel});this._rawConfiguration=n.reduce((t,o)=>o===t?o:t.merge(o),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,R.getConfigurationValue)(this.contents,n):this.contents}inspect(n,t){const o=this.rawConfiguration.getValue(n),g=t?this.rawConfiguration.getOverrideValue(n,t):void 0,l=t?this.rawConfiguration.override(t).getValue(n):o;return{value:o,override:g,merged:l}}getOverrideValue(n,t){const o=this.getContentsForOverrideIdentifer(t);return o?n?(0,R.getConfigurationValue)(o,n):o:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const o of this.overrides)o.identifiers.includes(n)&&t.push(...o.keys);return _.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return _.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=m.deepClone(this.contents),o=m.deepClone(this.overrides),g=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const h of n)if(l.push(...h.raw?.length?h.raw:[h]),!h.isEmpty()){this.mergeContents(t,h.contents);for(const w of h.overrides){const[u]=o.filter(E=>_.equals(E.identifiers,w.identifiers));u?(this.mergeContents(u.contents,w.contents),u.keys.push(...w.keys),u.keys=_.distinct(u.keys)):o.push(m.deepClone(w))}for(const w of h.keys)g.indexOf(w)===-1&&g.push(w)}return new D(t,g,o,l.every(h=>h instanceof D)?void 0:l)}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const o={};for(const g of _.distinct([...Object.keys(this.contents),...Object.keys(t)])){let l=this.contents[g];const h=t[g];h&&(typeof l=="object"&&typeof h=="object"?(l=m.deepClone(l),this.mergeContents(l,h)):l=h),o[g]=l}return new D(o,this.keys,this.overrides)}mergeContents(n,t){for(const o of Object.keys(t)){if(o in n&&y.isObject(n[o])&&y.isObject(t[o])){this.mergeContents(n[o],t[o]);continue}n[o]=m.deepClone(t[o])}}getContentsForOverrideIdentifer(n){let t=null,o=null;const g=l=>{l&&(o?this.mergeContents(o,l):o=m.deepClone(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===n?t=l.contents:l.identifiers.includes(n)&&g(l.contents);return g(t),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,t){this.updateValue(n,t,!0)}setValue(n,t){this.updateValue(n,t,!1)}removeValue(n){const t=this.keys.indexOf(n);t!==-1&&(this.keys.splice(t,1),(0,R.removeFromValueTree)(this.contents,n),k.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(o=>_.equals(o.identifiers,(0,k.overrideIdentifiersFromKey)(n))),1))}updateValue(n,t,o){(0,R.addToValueTree)(this.contents,n,t,g=>console.error(g)),o=o||this.keys.indexOf(n)===-1,o&&this.keys.push(n),k.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,k.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,R.toValuesTree)(this.contents[n],g=>console.error(g))})}}e.ConfigurationModel=D;class b{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new D}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!y.isUndefinedOrNull(n)){const o=this.doParseContent(n);this.parseRaw(o,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:o,keys:g,overrides:l,restricted:h,hasExcludedProperties:w}=this.doParseRaw(n,t);this._configurationModel=new D(o,g,l,w?[n]:void 0),this._restrictedConfigurations=h||[]}doParseContent(n){let t={},o=null,g=[];const l=[],h=[];function w(E){Array.isArray(g)?g.push(E):o!==null&&(g[o]=E)}const u={onObjectBegin:()=>{const E={};w(E),l.push(g),g=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{g=l.pop()},onArrayBegin:()=>{const E=[];w(E),l.push(g),g=E,o=null},onArrayEnd:()=>{g=l.pop()},onLiteralValue:w,onError:(E,P,O)=>{h.push({error:E,offset:P,length:O})}};if(n)try{d.visit(n,u),t=g[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return t}doParseRaw(n,t){const o=p.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),g=this.filter(n,o,!0,t);n=g.raw;const l=(0,R.toValuesTree)(n,u=>console.error(`Conflict in settings file ${this._name}: ${u}`)),h=Object.keys(n),w=this.toOverrides(n,u=>console.error(`Conflict in settings file ${this._name}: ${u}`));return{contents:l,keys:h,overrides:w,restricted:g.restricted,hasExcludedProperties:g.hasExcludedProperties}}filter(n,t,o,g){let l=!1;if(!g?.scopes&&!g?.skipRestricted&&!g?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:l};const h={},w=[];for(const u in n)if(k.OVERRIDE_PROPERTY_REGEX.test(u)&&o){const E=this.filter(n[u],t,!1,g);h[u]=E.raw,l=l||E.hasExcludedProperties,w.push(...E.restricted)}else{const E=t[u],P=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&w.push(u),!g.exclude?.includes(u)&&(g.include?.includes(u)||(P===void 0||g.scopes===void 0||g.scopes.includes(P))&&!(g.skipRestricted&&E?.restricted))?h[u]=n[u]:l=!0}return{raw:h,restricted:w,hasExcludedProperties:l}}toOverrides(n,t){const o=[];for(const g of Object.keys(n))if(k.OVERRIDE_PROPERTY_REGEX.test(g)){const l={};for(const h in n[g])l[h]=n[g][h];o.push({identifiers:(0,k.overrideIdentifiersFromKey)(g),keys:Object.keys(l),contents:(0,R.toValuesTree)(l,t)})}return o}}e.ConfigurationModelParser=b;class r extends A.Disposable{constructor(n,t,o,g){super(),this.userSettingsResource=n,this.parseOptions=t,this.fileService=g,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new b(this.userSettingsResource.toString()),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.any(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),L.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&o.isEqual(l.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new D}}reparse(n){return n&&(this.parseOptions=n),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=r;class s{constructor(n,t,o,g,l,h,w,u,E,P,O,N,F){this.key=n,this.overrides=t,this._value=o,this.overrideIdentifiers=g,this.defaultConfiguration=l,this.policyConfiguration=h,this.applicationConfiguration=w,this.userConfiguration=u,this.localUserConfiguration=E,this.remoteUserConfiguration=P,this.workspaceConfiguration=O,this.folderConfigurationModel=N,this.memoryConfigurationModel=F}get value(){return C(this._value)}inspect(n,t,o){const g=n.inspect(t,o);return{get value(){return C(g.value)},get override(){return C(g.override)},get merged(){return C(g.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class c{constructor(n,t,o,g,l=new D,h=new D,w=new T.ResourceMap,u=new D,E=new T.ResourceMap){this._defaultConfiguration=n,this._policyConfiguration=t,this._applicationConfiguration=o,this._localUserConfiguration=g,this._remoteUserConfiguration=l,this._workspaceConfiguration=h,this._folderConfigurations=w,this._memoryConfiguration=u,this._memoryConfigurationByResource=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(n,t,o){return this.getConsolidatedConfigurationModel(n,t,o).getValue(n)}updateValue(n,t,o={}){let g;o.resource?(g=this._memoryConfigurationByResource.get(o.resource),g||(g=new D,this._memoryConfigurationByResource.set(o.resource,g))):g=this._memoryConfiguration,t===void 0?g.removeValue(n):g.setValue(n,t),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,o){const g=this.getConsolidatedConfigurationModel(n,t,o),l=this.getFolderConfigurationModelForResource(t.resource,o),h=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,w=new Set;for(const u of g.overrides)for(const E of u.identifiers)g.getOverrideValue(n,E)!==void 0&&w.add(E);return new s(n,t,g.getValue(n),w.size?[...w]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this._workspaceConfiguration:void 0,l||void 0,h)}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const o=[];if(!t){const{added:g,updated:l,removed:h}=I(this._defaultConfiguration,n);t=[...g,...l,...h]}for(const g of t)for(const l of(0,k.overrideIdentifiersFromKey)(g)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(l),w=n.getKeysForOverrideIdentifier(l),u=[...w.filter(E=>h.indexOf(E)===-1),...h.filter(E=>w.indexOf(E)===-1),...h.filter(E=>!m.equals(this._defaultConfiguration.override(l).getValue(E),n.override(l).getValue(E)))];o.push([l,u])}return this.updateDefaultConfiguration(n),{keys:t,overrides:o}}compareAndUpdatePolicyConfiguration(n){const{added:t,updated:o,removed:g}=I(this._policyConfiguration,n),l=[...t,...o,...g];return l.length&&this.updatePolicyConfiguration(n),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:t,updated:o,removed:g,overrides:l}=I(this.applicationConfiguration,n),h=[...t,...o,...g];return h.length&&this.updateApplicationConfiguration(n),{keys:h,overrides:l}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:o,removed:g,overrides:l}=I(this.localUserConfiguration,n),h=[...t,...o,...g];return h.length&&this.updateLocalUserConfiguration(n),{keys:h,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:o,removed:g,overrides:l}=I(this.remoteUserConfiguration,n),h=[...t,...o,...g];return h.length&&this.updateRemoteUserConfiguration(n),{keys:h,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:o,removed:g,overrides:l}=I(this.workspaceConfiguration,n),h=[...t,...o,...g];return h.length&&this.updateWorkspaceConfiguration(n),{keys:h,overrides:l}}compareAndUpdateFolderConfiguration(n,t){const o=this.folderConfigurations.get(n),{added:g,updated:l,removed:h,overrides:w}=I(o,t),u=[...g,...l,...h];return(u.length||!o)&&this.updateFolderConfiguration(n,t),{keys:u,overrides:w}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:o,updated:g,removed:l,overrides:h}=I(t,void 0);return{keys:[...o,...g,...l],overrides:h}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,t,o){let g=this.getConsolidatedConfigurationModelForResource(t,o);return t.overrideIdentifier&&(g=g.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(g=g.merge(this._policyConfiguration)),g}getConsolidatedConfigurationModelForResource({resource:n},t){let o=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const g=t.getFolder(n);g&&(o=this.getFolderConsolidatedConfiguration(g.uri)||o);const l=this._memoryConfigurationByResource.get(n);l&&(o=o.merge(l))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const o=this.getWorkspaceConsolidatedConfiguration(),g=this._folderConfigurations.get(n);g?(t=o.merge(g),this._foldersConsolidatedConfigurations.set(n,t)):t=o}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const o=t.getFolder(n);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:o,overrides:g,keys:l}=this._folderConfigurations.get(t);return n.push([t,{contents:o,overrides:g,keys:l}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(t=>n.add(t)),this.userConfiguration.keys.forEach(t=>n.add(t)),this._workspaceConfiguration.keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.keys.forEach(o=>n.add(o))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.getAllOverrideIdentifiers().forEach(o=>n.add(o))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(n).forEach(g=>t.add(g))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),o=this.parseConfigurationModel(n.policy),g=this.parseConfigurationModel(n.application),l=this.parseConfigurationModel(n.user),h=this.parseConfigurationModel(n.workspace),w=n.folders.reduce((u,E)=>(u.set(v.URI.revive(E[0]),this.parseConfigurationModel(E[1])),u),new T.ResourceMap);return new c(t,o,g,l,new D,h,w,new D,new T.ResourceMap)}static parseConfigurationModel(n){return new D(n.contents,n.keys,n.overrides)}}e.Configuration=c;function f(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,t=new Map;for(const g of a)g.keys.forEach(l=>n.add(l)),g.overrides.forEach(([l,h])=>{const w=(0,T.getOrSet)(t,l,new Set);h.forEach(u=>w.add(u))});const o=[];return t.forEach((g,l)=>o.push([l,[...g.values()]])),{keys:[...n.values()],overrides:o}}e.mergeChanges=f;class S{constructor(n,t,o,g){this.change=n,this.previous=t,this.currentConfiguraiton=o,this.currentWorkspace=g,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const l of n.keys)this.affectedKeys.add(l);for(const[,l]of n.overrides)for(const h of l)this.affectedKeys.add(h);this._affectsConfigStr=this._marker;for(const l of this.affectedKeys)this._affectsConfigStr+=l+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=c.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){const o=this._marker+n,g=this._affectsConfigStr.indexOf(o);if(g<0)return!1;const l=g+o.length;if(l>=this._affectsConfigStr.length)return!1;const h=this._affectsConfigStr.charCodeAt(l);if(h!==this._markerCode1&&h!==this._markerCode2)return!1;if(t){const w=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,u=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!m.equals(w,u)}return!0}}e.ConfigurationChangeEvent=S;function I(a,n){const{added:t,removed:o,updated:g}=i(n?.rawConfiguration,a?.rawConfiguration),l=[],h=a?.getAllOverrideIdentifiers()||[],w=n?.getAllOverrideIdentifiers()||[];if(n){const u=w.filter(E=>!h.includes(E));for(const E of u)l.push([E,n.getKeysForOverrideIdentifier(E)])}if(a){const u=h.filter(E=>!w.includes(E));for(const E of u)l.push([E,a.getKeysForOverrideIdentifier(E)])}if(n&&a){for(const u of h)if(w.includes(u)){const E=i({contents:a.getOverrideValue(void 0,u)||{},keys:a.getKeysForOverrideIdentifier(u)},{contents:n.getOverrideValue(void 0,u)||{},keys:n.getKeysForOverrideIdentifier(u)});l.push([u,[...E.added,...E.removed,...E.updated]])}}return{added:t,removed:o,updated:g,overrides:l}}function i(a,n){const t=a?n?a.keys.filter(l=>n.keys.indexOf(l)===-1):[...a.keys]:[],o=n?a?n.keys.filter(l=>a.keys.indexOf(l)===-1):[...n.keys]:[],g=[];if(a&&n){for(const l of n.keys)if(a.keys.indexOf(l)!==-1){const h=(0,R.getConfigurationValue)(n.contents,l),w=(0,R.getConfigurationValue)(a.contents,l);m.equals(h,w)||g.push(l)}}return{added:t,removed:o,updated:g}}}),define(De[130],Ie([1,0,8,5]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var d;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(d||(e.RemoteConnectionType=d={}));class A{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=A;class T{constructor(k,p){this.host=k,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=T;var m;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class y extends _.ErrorNoTelemetry{static isNotAvailable(k){return k instanceof y&&k._code===m.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof y&&k._code===m.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof y&&k._code===m.NoResolverFound}static isInvalidAuthority(k){return k instanceof y&&k._code===m.InvalidAuthority}static isHandled(k){return k instanceof y&&k.isHandled}constructor(k,p=m.Unknown,C){super(k),this._message=k,this._code=p,this._detail=C,this.isHandled=p===m.NotAvailable&&C===!0,Object.setPrototypeOf(this,y.prototype)}}e.RemoteAuthorityResolverError=y;function v(R){const k=R.indexOf("+");return k===-1?R:R.substring(0,k)}e.getRemoteAuthorityPrefix=v}),define(De[79],Ie([1,0,15]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(v){return v.scheme===_.Schemas.vscodeRemote?v.authority:void 0}e.getRemoteAuthority=L;function d(v){if(!v)return;const R=v.indexOf("+");return R<0?v:v.substr(0,R)}e.getRemoteName=d;function A(v){return`/${v.quality??"oss"}-${v.commit??"dev"}`}e.getRemoteServerRootPath=A;function T(v){const{host:R,port:k}=y(v);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:k}}e.parseAuthorityWithPort=T;function m(v,R){let{host:k,port:p}=y(v);return typeof p>"u"&&(p=R),{host:k,port:p}}e.parseAuthorityWithOptionalPort=m;function y(v){const R=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const k=v.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const p=v.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:v,port:void 0}}}),define(De[25],Ie([1,0,12,5,79]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(T||(e.ExtensionType=T={}));var m;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.LINUX_PPC64LE="linux-ppc64le",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class y{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,s){if(typeof r>"u"||r===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof r=="string"||typeof s=="string"){const c=typeof r=="string"?r:r.value,f=typeof s=="string"?s:s.value;return _.equalsIgnoreCase(c,f)}return r._lower===s._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.ExtensionIdentifier=y;class v{get size(){return this._set.size}constructor(r){if(this._set=new Set,r)for(const s of r)this.add(s)}add(r){this._set.add(y.toKey(r))}delete(r){return this._set.delete(y.toKey(r))}has(r){return this._set.has(y.toKey(r))}}e.ExtensionIdentifierSet=v;class R{constructor(){this._map=new Map}clear(){this._map.clear()}delete(r){this._map.delete(y.toKey(r))}get(r){return this._map.get(y.toKey(r))}has(r){return this._map.has(y.toKey(r))}set(r,s){this._map.set(y.toKey(r),s)}values(){return this._map.values()}forEach(r){this._map.forEach(r)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=R;function k(b){return p(b)}e.isApplicationScopedExtension=k;function p(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function C(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=C;function D(b,r){if(r){const s=`onResolveRemoteAuthority:${(0,d.getRemoteName)(r)}`;return!!b.activationEvents?.includes(s)}return!1}e.isResolverExtension=D,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[131],Ie([1,0,8,25]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class d{constructor(){this._generators=new Map,this._cache=new WeakMap}register(T,m){this._generators.set(T,m)}readActivationEvents(T){return this._cache.has(T)||this._cache.set(T,this._readActivationEvents(T)),this._cache.get(T)}createActivationEventsMap(T){const m=Object.create(null);for(const y of T){const v=this.readActivationEvents(y);v.length>0&&(m[L.ExtensionIdentifier.toKey(y.identifier)]=v)}return m}_readActivationEvents(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const m=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];if(!T.contributes)return m;for(const y in T.contributes){const v=this._generators.get(y);if(!v)continue;const R=T.contributes[y],k=Array.isArray(R)?R:[R];try{v(k,m)}catch(p){(0,_.onUnexpectedError)(p)}}return m}}e.ImplicitActivationEventsImpl=d,e.ImplicitActivationEvents=new d}),define(De[236],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class _{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(d){try{const A=await this.getValidator();if(A){const T=String(_._nextId++);return this.validators.set(T,A),{id:T,data:A.createNewMessage(d)}}}catch{}return{id:"",data:d}}async validate(d,A){if(!d.id)return!0;const T=this.validators.get(d.id);if(!T)return!1;this.validators.delete(d.id);try{return T.validate(A)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(d){try{return await this.signValue(d)}catch{}return d}}e.AbstractSignService=_}),define(De[237],Ie([1,0,236]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L extends _.AbstractSignService{getValidator(){return this.vsda().then(A=>new A.validator)}signValue(A){return this.vsda().then(T=>new T.signer().sign(A))}vsda(){return new Promise((A,T)=>me(["vsda"],A,T))}}e.SignService=L}),define(De[238],Ie([1,0,11,41,32]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(y){if(_.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}function T(y,v,R,k,p,C,D,b){const r=Object.create(null);r["common.machineId"]=C,r.sessionID=(0,d.generateUuid)()+Date.now(),r.commitHash=k,r.version=p,r["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,_.PlatformToString)(_.platform),r["common.nodePlatform"]=L.platform,r["common.nodeArch"]=R,r["common.product"]=b||"desktop",D&&(r["common.msftInternal"]=D);let s=0;const c=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),_.isLinuxSnap&&(r["common.snap"]="true");const f=A(v);return f&&(r["common.platformDetail"]=f),r}e.resolveCommonProperties=T;function m(y){const v=L.env.USERDNSDOMAIN;if(!v)return!1;const R=v.toLowerCase();return y.some(k=>R===k)}e.verifyMicrosoftInternalDomain=m}),define(De[239],Ie([1,0,5]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,_.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,_.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var d;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(d||(e.TelemetryConfiguration=d={}))}),define(De[80],Ie([1,0,23,14,3,57,79,238,239]),function(me,e,_,L,d,A,T,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class v{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=v;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=R,e.NullTelemetryService=new R;class k{async publicLog(o,g,l){}async publicLogError(o,g,l){}}e.NullEndpointTelemetryService=k,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(t,o){return d.Event.debounce(o.onDidChangeConfiguration,(l,h)=>{const w=l?new Set([...l.affectedKeys,...h.affectedKeys]):h.affectedKeys;return{...h,affectedKeys:w}},1e3,!0)(l=>{l.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.configurationTelemetry=p;function C(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=C;function D(t,o){return!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.isLoggingOnly=D;function b(t){const o=t.getValue(y.TELEMETRY_SETTING_ID),g=t.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||g===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function r(t){const o={},g={},l={};f(t,l);for(let h in l){h=h.length>150?h.substr(h.length-149):h;const w=l[h];typeof w=="number"?g[h]=w:typeof w=="boolean"?g[h]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${w.length}`),o[h]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(o[h]=w)}return{properties:o,measurements:g}}e.validateTelemetryData=r;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const o=(0,T.getRemoteName)(t);return s.has(o)?o:"other"}e.cleanRemoteAuthority=c;function f(t,o,g=0,l){if(t)for(const h of Object.getOwnPropertyNames(t)){const w=t[h],u=l?l+h:h;Array.isArray(w)?o[u]=(0,_.safeStringify)(w):w instanceof Date?o[u]=w.toISOString():(0,L.isObject)(w)?g<2?f(w,o,g+1,u+"."):o[u]=(0,_.safeStringify)(w):o[u]=w}}function S(t,o){const g=t.msftInternalDomains||[],l=o.getValue("telemetry.internalTesting");return(0,m.verifyMicrosoftInternalDomain)(g)||l}e.isInternalTelemetry=S;function I(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=I;function i(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let g=t;const l=[];for(const E of o)for(;;){const P=E.exec(t);if(!P)break;l.push([P.index,E.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(g="";;){const E=w.exec(t);if(!E)break;const P=l.some(([O,N])=>E.index<N&&O<w.lastIndex);!h.test(E[0])&&!P&&(g+=t.substring(u,E.index)+"<REDACTED: user-file-path>",u=w.lastIndex)}return u<t.length&&(g+=t.substr(u)),g}function a(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of o)if(g.regex.test(t))return`<REDACTED: ${g.label}>`;return t}function n(t,o){return(0,_.cloneAndChange)(t,g=>{if(g instanceof v||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let l=g.replaceAll("%20"," ");l=i(l,o);for(const h of o)l=l.replace(h,"");return l=a(l),l}})}e.cleanData=n}),define(De[240],Ie([1,0,12,125,25,11,2,8,41,80]),function(me,e,_,L,d,A,T,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function R(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,_.compareIgnoreCase)(n.id,t.id)===0}e.areSameExtensions=R;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(t){const o=t.manifest?t.manifest.version:t.version,g=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new p(t.identifier,o,g)}static parse(t){const o=k.exec(t);return o&&o[1]&&o[2]?new p({id:o[1]},o[2],o[4]||void 0):null}constructor(t,o,g="undefined"){this.version=o,this.targetPlatform=g,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof p?R(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=p;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function D(n){const t=C.exec(n);return t&&t[1]?[r(t[1]),t[2]]:[r(n),void 0]}e.getIdAndVersion=D;function b(n,t){return`${n}.${t}`}e.getExtensionId=b;function r(n){return n.toLowerCase()}e.adoptToGalleryExtensionId=r;function s(n,t){return r(b(n??d.UNDEFINED_PUBLISHER,t))}e.getGalleryExtensionId=s;function c(n,t){const o=[],g=l=>{for(const h of o)if(h.some(w=>R(t(w),t(l))))return h;return null};for(const l of n){const h=g(l);h?h.push(l):o.push([l])}return o}e.groupByExtension=c;function f(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=f;function S(n){return{id:new v.TelemetryTrustedValue(n.identifier.id),name:new v.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new d.ExtensionIdentifier("pprice.better-merge");function I(n,t){const o=[],g=t.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const l=g.shift();if(l&&o.every(h=>!R(h.identifier,{id:l}))){const h=n.filter(w=>R(w.identifier,{id:l}));h.length===1&&(o.push(h[0]),g.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=I;async function i(n,t){if(!A.isLinux)return!1;let o;try{o=(await n.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await n.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){t.debug("Error while getting the os-release file.",(0,m.getErrorMessage)(l))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(n,t){const o=await i(n,t),g=(0,L.getTargetPlatform)(o?"alpine":A.platform,y.arch);return t.debug("ComputeTargetPlatform:",g),g}e.computeTargetPlatform=a}),define(De[241],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function _(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=_;function L(y){return y?[...y.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function d(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=d;function A(y){return new Map(y??[])}e.deserializeEnvironmentDescriptionMap=A;function T(y){return Array.from(y.entries()).map(v=>[v[0],_(v[1].map),L(v[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=T;function m(y){return new Map(y.map(v=>[v[0],{map:d(v[1]),descriptionMap:A(v[2])}]))}e.deserializeEnvironmentVariableCollections=m}),define(De[242],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class _{constructor(d){this._callback=d,this._terminalBufferMap=new Map}dispose(){for(const d of this._terminalBufferMap.values())d.dispose()}startBuffering(d,A,T=5){const m=A(y=>{const v=typeof y=="string"?y:y.data;let R=this._terminalBufferMap.get(d);if(R){R.data.push(v);return}const k=setTimeout(()=>this.flushBuffer(d),T);R={data:[v],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(d),m.dispose()}},this._terminalBufferMap.set(d,R)});return m}stopBuffering(d){this._terminalBufferMap.get(d)?.dispose()}flushBuffer(d){const A=this._terminalBufferMap.get(d);A&&(this._terminalBufferMap.delete(d),this._callback(d,A.data.join("")))}}e.TerminalDataBufferer=_}),define(De[243],Ie([1,0,17,72,55,3,14,2,190,100,42]),function(me,e,_,L,d,A,T,m,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var k;(function(S){function I(i,a){let n=i.defaults;for(;d.ThemeIcon.isThemeIcon(n);){const t=D.getIcon(n.id);if(!t)return;n=t.defaults}return n}S.getDefinition=I})(k||(e.IconContribution=k={}));var p;(function(S){function I(a){return{weight:a.weight,style:a.style,src:a.src.map(n=>({format:n.format,location:n.location.toString()}))}}S.toJSONObject=I;function i(a){const n=t=>(0,T.isString)(t)?t:void 0;if(a&&Array.isArray(a.src)&&a.src.every(t=>(0,T.isString)(t.format)&&(0,T.isString)(t.location)))return{weight:n(a.weight),style:n(a.style),src:a.src.map(t=>({format:t.format,location:m.URI.parse(t.location)}))}}S.fromJSONObject=i})(p||(e.IconFontDefinition=p={}));class C{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${d.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(I,i,a,n){const t=this.iconsById[I];if(t){if(a&&!t.description){t.description=a,this.iconSchema.properties[I].markdownDescription=`${a} $(${I})`;const l=this.iconReferenceSchema.enum.indexOf(I);l!==-1&&(this.iconReferenceSchema.enumDescriptions[l]=a),this._onDidChange.fire()}return t}const o={id:I,description:a,defaults:i,deprecationMessage:n};this.iconsById[I]=o;const g={$ref:"#/definitions/icons"};return n&&(g.deprecationMessage=n),a&&(g.markdownDescription=`${a}: $(${I})`),this.iconSchema.properties[I]=g,this.iconReferenceSchema.enum.push(I),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:I}}deregisterIcon(I){delete this.iconsById[I],delete this.iconSchema.properties[I];const i=this.iconReferenceSchema.enum.indexOf(I);i!==-1&&(this.iconReferenceSchema.enum.splice(i,1),this.iconReferenceSchema.enumDescriptions.splice(i,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(I=>this.iconsById[I])}getIcon(I){return this.iconsById[I]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(I,i){const a=this.iconFontsById[I];return a||(this.iconFontsById[I]=i,this._onDidChange.fire(),i)}deregisterIconFont(I){delete this.iconFontsById[I]}getIconFont(I){return this.iconFontsById[I]}toString(){const I=(t,o)=>t.id.localeCompare(o.id),i=t=>{for(;d.ThemeIcon.isThemeIcon(t.defaults);)t=this.iconsById[t.defaults.id];return`codicon codicon-${t?t.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.iconsById).map(t=>this.iconsById[t]);for(const t of n.filter(o=>!!o.description).sort(I))a.push(`|<i class="${i(t)}"></i>|${t.id}|${d.ThemeIcon.isThemeIcon(t.defaults)?t.defaults.id:t.id}|${t.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const t of n.filter(o=>!d.ThemeIcon.isThemeIcon(o.defaults)).sort(I))a.push(`|<i class="${i(t)}"></i>|${t.id}|`);return a.join(`
`)}}const D=new C;R.Registry.add(e.Extensions.IconContribution,D);function b(S,I,i,a){return D.registerIcon(S,I,i,a)}e.registerIcon=b;function r(){return D}e.getIconRegistry=r;function s(){const S=(0,L.getCodiconFontCharacters)();for(const I in S){const i="\\"+S[I].toString(16);D.registerIcon(I,{fontCharacter:i})}}s(),e.iconsSchemaId="vscode://schemas/icons";const c=R.Registry.as(v.Extensions.JSONContribution);c.registerSchema(e.iconsSchemaId,D.getIconSchema());const f=new _.RunOnceScheduler(()=>c.notifySchemaChanged(e.iconsSchemaId),200);D.onDidChange(()=>{f.isScheduled()||f.schedule()}),e.widgetClose=b("widget-close",L.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=b("goto-previous-location",L.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=b("goto-next-location",L.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=d.ThemeIcon.modify(L.Codicon.sync,"spin"),e.spinningLoading=d.ThemeIcon.modify(L.Codicon.loading,"spin")}),define(De[132],Ie([1,0,3,57,5,18]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,d.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,d.createDecorator)("sharedTunnelsService");var T;(function(r){r.Http="http",r.Https="https"})(T||(e.TunnelProtocol=T={}));var m;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(m||(e.TunnelPrivacyId=m={}));function y(r){return!!r.forwardPort}e.isTunnelProvider=y;var v;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(v||(e.ProvidedOnAutoForward=v={}));function R(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(s)return{address:s[1],port:+s[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(r){return e.LOCALHOST_ADDRESSES.indexOf(r)>=0}e.isLocalhost=k,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(r){return e.ALL_INTERFACES_ADDRESSES.indexOf(r)>=0}e.isAllInterfaces=p;function C(r,s,c,f){if(c===1)return!1;if(c===2&&p(s)){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(S?.length===4&&parseInt(S[1])>=18)return!1}return r<1024}e.isPortPrivileged=C;class D{constructor(s,c,f){this.remoteAddress=s,this.localAddress=c,this._dispose=f,this._onDispose=new _.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=D;let b=class{constructor(s,c){this.logService=s,this.configurationService=c,this._onTunnelOpened=new _.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new _.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new _.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const s=this.configurationService.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this._tunnelProvider=s,s?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this._canElevate=s.elevation,this._privacyOptions=s.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const s=[],c=Array.from(this._tunnels.values());for(const f of c){const S=Array.from(f.values());for(const I of S){const i=await I.value;i&&s.push(i)}}return s}async dispose(){for(const s of this._tunnels.values()){for(const{value:c}of s.values())await c.then(f=>f?.dispose());s.clear()}this._tunnels.clear()}setEnvironmentTunnel(s,c,f,S,I){this.addTunnelToMap(s,c,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:c,localAddress:f,privacy:S,protocol:I,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,c){(p(s)||k(s))&&(s=e.LOCALHOST_ADDRESSES[0]);const f=this.getTunnelFromMap(s,c);if(f)return++f.refcount,f.value}openTunnel(s,c,f,S,I,i=!1,a,n){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${f} on local port ${I}.`);const t=this._tunnelProvider??s;if(!t)return;if(c||(c="localhost"),S||(S=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(f)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(t,c,f,S,I,i,a,n);return o?o.then(g=>{if(!g){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(c,f);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.makeTunnel(g);return(g.tunnelRemoteHost!==c||g.tunnelRemotePort!==f)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&g.privacy!==a&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(l),l}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const c=this._tunnels.get(s.tunnelRemoteHost);if(c){const f=c.get(s.tunnelRemotePort);f&&(f.refcount--,await this.tryDisposeTunnel(s.tunnelRemoteHost,s.tunnelRemotePort,f))}}}}async tryDisposeTunnel(s,c,f){if(f.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${c}.`);const S=f.value.then(async I=>{I&&(await I.dispose(!0),this._onTunnelClosed.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this._tunnels.has(s)&&this._tunnels.get(s).delete(c),S}}async closeTunnel(s,c){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${c} `);const f=this._tunnels.get(s);if(f&&f.has(c)){const S=f.get(c);S.refcount=0,await this.tryDisposeTunnel(s,c,S)}}addTunnelToMap(s,c,f){this._tunnels.has(s)||this._tunnels.set(s,new Map),this._tunnels.get(s).set(c,{refcount:1,value:f})}async removeEmptyTunnelFromMap(s,c){const f=this._tunnels.get(s);if(f){const S=f.get(c);(S?await S.value:void 0)||f.delete(c),f.size===0&&this._tunnels.delete(s)}}getTunnelFromMap(s,c){const f=[s];k(s)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):p(s)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const S=f.map(I=>this._tunnels.get(I));for(const I of S){const i=I?.get(c);if(i)return i}}canTunnel(s){return!!R(s)}createWithProvider(s,c,f,S,I,i,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${f} on local port ${S}.`);const n=f;this._factoryInProgress.add(n);const t=S===void 0?f:S,o={elevationRequired:I?this.isPortPrivileged(t):!1},g={remoteAddress:{host:c,port:f},localAddressPort:S,privacy:i,public:i?i!==m.Private:void 0,protocol:a},l=s.forwardPort(g,o);return l?(this.addTunnelToMap(c,f,l),l.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(n)})):this._factoryInProgress.delete(n),l}};e.AbstractTunnelService=b,e.AbstractTunnelService=b=Ve([$e(0,A.ILogService),$e(1,L.IConfigurationService)],b)}),define(De[244],Ie([1,0,5]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,_.createDecorator)("editSessionIdentityService");var L;(function(d){d[d.Complete=100]="Complete",d[d.Partial=50]="Partial",d[d.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(De[245],Ie([1,0,15]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function L(y){return y.scheme!==_.Schemas.file&&y.scheme!==_.Schemas.vscodeRemote}e.isVirtualResource=L;function d(y){if(y.folders.length)return y.folders.every(v=>L(v.uri))?y.folders[0].uri:void 0;if(y.configuration&&L(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=d;function A(y){return d(y)?.scheme}e.getVirtualWorkspaceScheme=A;function T(y){return d(y)?.authority}e.getVirtualWorkspaceAuthority=T;function m(y){return d(y)!==void 0}e.isVirtualWorkspace=m}),define(De[50],Ie([1,0,191,13,71,24,2,5,15]),function(me,e,_,L,d,A,T,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,m.createDecorator)("contextService");function v(t){const o=t;return typeof o?.id=="string"&&T.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=v;function R(t){return typeof t?.id=="string"&&!v(t)&&!p(t)}e.isEmptyWorkspaceIdentifier=R,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function k(t,o){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,L.basename)(t)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const g=t;return g.configuration?{id:g.id,configPath:g.configuration}:g.folders.length===1?{id:g.id,uri:g.folders[0].uri}:{id:g.id}}e.toWorkspaceIdentifier=k;function p(t){const o=t;return typeof o?.id=="string"&&T.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=p;function C(t){const o=t;if(o?.uri)return{id:o.id,uri:T.URI.revive(o.uri)};const g=t;if(g?.configPath)return{id:g.id,configPath:T.URI.revive(g.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=C;var D;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(D||(e.WorkbenchState=D={}));function b(t){const o=t;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=b;function r(t){const o=t;return!!(o&&typeof o=="object"&&T.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=r;class s{constructor(o,g,l,h,w){this._id=o,this._transient=l,this._configuration=h,this._ignorePathCasing=w,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=g}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o)||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=s;class c{constructor(o,g){this.raw=g,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,A.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=c;function f(t){return new c({uri:t,index:0,name:(0,A.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=f,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,_.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(t,o){return A.extUriBiasedIgnorePathCase.isEqualOrParent(t,o.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function I(t){let o;return T.URI.isUri(t)?o=t:o=t.configuration,o?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=I,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function a(t,o){return!S(t,o)&&!I(t)}e.isSavedWorkspace=a;function n(t){return(typeof t=="string"?(0,L.extname)(t):(0,A.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(De[81],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class _{static{this.enableDebugLogging=!1}constructor(d){this.id=d,this._data=new Map,this._idPool=1}add(d){const A=this._idPool++;return this._data.set(A,d),this.logDebugInfo(),A}get(d,A){return this._data.has(d)?this._data.get(d)[A]:void 0}delete(d){this._data.delete(d),this.logDebugInfo()}logDebugInfo(){_.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=_}),define(De[51],Ie([1,0,15,24,5]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(_.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(m=>{const y=this._providerInfo.get(m.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(m,y){y===null?this._providerInfo.delete(m.scheme):this._providerInfo.set(m.scheme,y)}isFreeScheme(m){return!this._providerInfo.has(m)&&!this._systemSchemes.has(m)}getCapabilities(m){return this._providerInfo.get(m)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,d.createDecorator)("IExtHostFileSystemInfo")}),define(De[26],Ie([1,0,5]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,_.createDecorator)("IExtHostInitDataService")}),define(De[246],Ie([1,0,196,18,230,26]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends d.LogService{constructor(y,v,R){const k=R.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",p=R.remote.isRemote?(0,_.localize)(0,null):y?(0,_.localize)(1,null):(0,_.localize)(2,null);super(v.createLogger(k,{name:p}))}};e.ExtHostLogService=T,e.ExtHostLogService=T=Ve([$e(1,L.ILoggerService),$e(2,A.IExtHostInitDataService)],T)}),define(De[247],Ie([1,0,17]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(T,m,y){this._deferredPromises=new Map,this._id=T,this._shared=m,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(v=>(this._value=v,this)),this._storageListener=this._storage.onDidChangeStorage(v=>{v.shared===this._shared&&v.key===this._id&&(this._value=v.value)}),this._scheduler=new _.RunOnceScheduler(()=>{const v=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of v.values())R.complete()}catch(R){for(const k of v.values())k.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,m){let y=this._value[T];return typeof y>"u"&&(y=m),y}update(T,m){this._value[T]=m;const y=this._deferredPromises.get(T);if(y!==void 0)return y.p;const v=new _.DeferredPromise;return this._deferredPromises.set(T,v),this._scheduler.isScheduled()||this._scheduler.schedule(),v.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class d extends L{setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}constructor(T,m){super(T.identifier.value,!0,m),this._extension=T}}e.ExtensionGlobalMemento=d}),define(De[248],Ie([1,0,3,2]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class d{constructor(T){this._notebooksAndEditors=T,this._onDidSaveNotebookDocument=new _.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new _.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(T,m,y,v){const k=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(T)).acceptModelChanged(m.value,y,v);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(T,m){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(T)).acceptDirty(m)}$acceptModelSaved(T){const m=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(T));this._onDidSaveNotebookDocument.fire(m.apiNotebook)}}e.ExtHostNotebookDocuments=d}),define(De[20],Ie([1,0,5]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class L{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=L}),define(De[249],Ie([1,0,25,3]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class d{#e;constructor(T,m){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=_.ExtensionIdentifier.toKey(T.identifier),this.#e=m,this.#e.onDidChangePassword(y=>{y.extensionId===this._id&&this._onDidChange.fire({key:y.key})})}get(T){return this.#e.get(this._id,T)}store(T,m){return this.#e.store(this._id,T,m)}delete(T){return this.#e.delete(this._id,T)}}e.ExtensionSecrets=d}),define(De[58],Ie([1,0,5]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,_.createDecorator)("IURITransformerService");class L{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=L}),define(De[250],Ie([1,0,22]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(y){let v=this.buffers.indexOf(y);return v<0&&(v=this.buffers.length,this.buffers.push(y)),v}}function d(m,y){if(y.serializeBuffersForPostMessage){const v=new L,k=JSON.stringify(m,(C,D)=>{if(D instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:v.add(D)};if(ArrayBuffer.isView(D)){const b=A(D);if(b)return{$$vscode_array_buffer_reference$$:!0,index:v.add(D.buffer),view:{type:b,byteLength:D.byteLength,byteOffset:D.byteOffset}}}return D}),p=v.buffers.map(C=>{const D=new Uint8Array(C);return _.VSBuffer.wrap(D)});return{message:k,buffers:p}}else return{message:JSON.stringify(m),buffers:[]}}e.serializeWebviewMessage=d;function A(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(m,y){const v=y.map(p=>{const C=new ArrayBuffer(p.byteLength);return new Uint8Array(C).set(p.buffer),C}),R=y.length?(p,C)=>{if(C&&typeof C=="object"&&C.$$vscode_array_buffer_reference$$){const D=C,{index:b}=D,r=v[b];if(D.view)switch(D.view.type){case 1:return new Int8Array(r,D.view.byteOffset,D.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(r,D.view.byteOffset,D.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(r,D.view.byteOffset,D.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(r,D.view.byteOffset,D.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(r,D.view.byteOffset,D.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(r,D.view.byteOffset,D.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(r,D.view.byteOffset,D.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(r,D.view.byteOffset,D.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(r,D.view.byteOffset,D.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(r,D.view.byteOffset,D.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(r,D.view.byteOffset,D.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return r}return C}:void 0;return{message:JSON.parse(m,R),arrayBuffers:v}}e.deserializeWebviewMessage=T}),define(De[251],Ie([1,0,252,353,354,101,2,355]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;const y=!1;function v(c,f,S,I,i,a){const n=a.environment.useHostProxy,t=typeof n=="boolean"?n:!a.remote.isRemote,o={resolveProxy:h=>c.resolveProxy(h),lookupProxyAuthorization:b.bind(void 0,I,i,f,{},a.remote.isRemote),getProxyURL:()=>f.getConfiguration("http").get("proxy"),getProxySupport:()=>f.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>k(f),getSystemCertificatesV2:()=>p(f),log:(h,w,...u)=>{switch(h){case m.LogLevel.Trace:I.trace(w,...u);break;case m.LogLevel.Debug:I.debug(w,...u);break;case m.LogLevel.Info:I.info(w,...u);break;case m.LogLevel.Warning:I.warn(w,...u);break;case m.LogLevel.Error:I.error(w,...u);break;case m.LogLevel.Critical:I.error(w,...u);break;case m.LogLevel.Off:break;default:E(h,w,u);break}function E(P,O,...N){I.error("Unknown log level",P),I.error(O,...N)}},getLogLevel:()=>I.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:t,addCertificates:[],env:process.env},g=(0,m.createProxyResolver)(o),l=R(o,g);return D(S,l)}e.connectProxyResolver=v;function R(c,f){return{http:Object.assign(_,(0,m.createHttpPatch)(c,_,f)),https:Object.assign(L,(0,m.createHttpPatch)(c,L,f)),net:Object.assign(A,(0,m.createNetPatch)(c,A)),tls:Object.assign(d,(0,m.createTlsPatch)(c,d))}}function k(c){const f=c.getConfiguration("http");return!f.get("experimental.systemCertificatesV2",y)&&!!f.get("systemCertificates")}function p(c){const f=c.getConfiguration("http");return!!f.get("experimental.systemCertificatesV2",y)&&!!f.get("systemCertificates")}const C=new Map;function D(c,f){return c.getExtensionPathIndex().then(S=>{const I=globalThis._VSCODE_NODE_MODULES.module,i=I._load;I._load=function(n,t,o){if(n==="net")return f.net;if(n==="tls")return f.tls;if(n!=="http"&&n!=="https")return i.apply(this,arguments);const g=S.findSubstr(T.URI.file(t.filename));let l=C.get(g);if(l||C.set(g,l={}),!l[n]){const h=f[n];l[n]={...h}}return l[n]}})}async function b(c,f,S,I,i,a,n,t){const o=I[a];n&&(I[a]=n),c.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${a}`,`proxyAuthenticate:${n}`,`proxyAuthenticateCache:${o}`);const g=n||o,l=Array.isArray(g)?g:typeof g=="string"?[g]:[];if(s(f,l,i),l.some(h=>/^(Negotiate|Kerberos)( |$)/i.test(h))&&!t.kerberosRequested)try{t.kerberosRequested=!0;const h=await new Promise((O,N)=>{me(["kerberos"],O,N)}),w=new URL(a),u=S.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${w.hostname}`:`HTTP@${w.hostname}`);return c.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${a}`,`spn:${u}`),"Negotiate "+await(await h.initializeClient(u)).step("")}catch(h){c.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",h)}}let r=!1;function s(c,f,S){r||!f.length||(r=!0,c.$publicLog2("proxyAuthenticationRequest",{authenticationType:f.map(I=>I.split(" ")[0]).join(","),extensionHostType:S?"remote":"local"}))}}),define(De[253],Ie([1,0,121]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function L(A){return{transformIncoming:T=>T.scheme==="vscode-remote"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="file"?{scheme:"vscode-local",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoing:T=>T.scheme==="file"?{scheme:"vscode-remote",authority:A,path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="vscode-local"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoingScheme:T=>T==="file"?"vscode-remote":T==="vscode-local"?"file":T}}function d(A){return new _.URITransformer(L(A))}e.createURITransformer=d}),define(De[133],Ie([1,0,206,14,2,4,5,42,30,15,45,169,40]),function(me,e,_,L,d,A,T,m,y,v,R,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,_.localize)(0,null),providerDisplayName:(0,_.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var C;(function(H){H[H.PROGRAMMATIC=1]="PROGRAMMATIC",H[H.USER=2]="USER",H[H.EDIT=3]="EDIT",H[H.NAVIGATION=4]="NAVIGATION",H[H.JUMP=5]="JUMP"})(C||(e.EditorPaneSelectionChangeReason=C={}));var D;(function(H){H[H.IDENTICAL=1]="IDENTICAL",H[H.SIMILAR=2]="SIMILAR",H[H.DIFFERENT=3]="DIFFERENT"})(D||(e.EditorPaneSelectionCompareResult=D={}));function b(H){const ce=H;return!!ce&&typeof ce.getSelection=="function"&&!!ce.onDidChangeSelection}e.isEditorPaneWithSelection=b;function r(H,ce,re){for(const fe of re.visibleEditorPanes)if(fe.group.id===ce&&H.matches(fe.input))return fe.getViewState()}e.findViewStateForEditor=r;function s(H){if(g(H))return!1;const ce=H;return d.URI.isUri(ce?.resource)}e.isResourceEditorInput=s;function c(H){if(g(H))return!1;const ce=H;return ce?.original!==void 0&&ce.modified!==void 0}e.isResourceDiffEditorInput=c;function f(H){if(g(H)||c(H))return!1;const ce=H;return ce?.primary!==void 0&&ce.secondary!==void 0}e.isResourceSideBySideEditorInput=f;function S(H){if(g(H))return!1;const ce=H;return ce?ce.resource===void 0||ce.resource.scheme===v.Schemas.untitled||ce.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=S;function I(H){if(g(H))return!1;const ce=H;return d.URI.isUri(ce?.base?.resource)&&d.URI.isUri(ce?.input1?.resource)&&d.URI.isUri(ce?.input2?.resource)&&d.URI.isUri(ce?.result?.resource)}e.isResourceMergeEditorInput=I;var i;(function(H){H[H.SHORT=0]="SHORT",H[H.MEDIUM=1]="MEDIUM",H[H.LONG=2]="LONG"})(i||(e.Verbosity=i={}));var a;(function(H){H[H.EXPLICIT=1]="EXPLICIT",H[H.AUTO=2]="AUTO",H[H.FOCUS_CHANGE=3]="FOCUS_CHANGE",H[H.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class n{constructor(){this.mapIdToSaveSource=new Map}registerSource(ce,re){let fe=this.mapIdToSaveSource.get(ce);return fe||(fe={source:ce,label:re},this.mapIdToSaveSource.set(ce,fe)),fe.source}getSourceLabel(ce){return this.mapIdToSaveSource.get(ce)?.label??ce}}e.SaveSourceRegistry=new n;var t;(function(H){H[H.None=0]="None",H[H.Readonly=2]="Readonly",H[H.Untitled=4]="Untitled",H[H.Singleton=8]="Singleton",H[H.RequiresTrust=16]="RequiresTrust",H[H.CanSplitInGroup=32]="CanSplitInGroup",H[H.ForceDescription=64]="ForceDescription",H[H.CanDropIntoEditor=128]="CanDropIntoEditor",H[H.MultipleEditors=256]="MultipleEditors",H[H.Scratchpad=512]="Scratchpad"})(t||(e.EditorInputCapabilities=t={}));class o extends A.Disposable{}e.AbstractEditorInput=o;function g(H){return H instanceof o}e.isEditorInput=g;function l(H){const ce=H;return d.URI.isUri(ce?.preferredResource)}function h(H){const ce=H;return g(ce?.primary)&&g(ce?.secondary)}e.isSideBySideEditorInput=h;function w(H){const ce=H;return g(ce?.modified)&&g(ce?.original)}e.isDiffEditorInput=w;function u(H,ce,re,fe,he){return $(fe,[(0,k.toAction)({id:"workbench.action.openLargeFile",label:(0,_.localize)(2,null),run:()=>{const z={...re,limits:{size:Number.MAX_VALUE}};H.openEditor(ce,z)}}),(0,k.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,_.localize)(3,null),run:()=>he.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}e.createTooLargeFileError=u;function E(H){return g(H?.editor)}e.isEditorInputWithOptions=E;function P(H){const ce=H;return E(H)&&ce?.group!==void 0}e.isEditorInputWithOptionsAndGroup=P;function O(H){const ce=H;return typeof ce?.groupId=="number"&&g(ce.editor)}e.isEditorIdentifier=O;var N;(function(H){H[H.UNKNOWN=0]="UNKNOWN",H[H.REPLACE=1]="REPLACE",H[H.MOVE=2]="MOVE",H[H.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var F;(function(H){H[H.GROUP_ACTIVE=0]="GROUP_ACTIVE",H[H.GROUP_INDEX=1]="GROUP_INDEX",H[H.GROUP_LOCKED=2]="GROUP_LOCKED",H[H.EDITOR_OPEN=3]="EDITOR_OPEN",H[H.EDITOR_CLOSE=4]="EDITOR_CLOSE",H[H.EDITOR_MOVE=5]="EDITOR_MOVE",H[H.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",H[H.EDITOR_LABEL=7]="EDITOR_LABEL",H[H.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",H[H.EDITOR_PIN=9]="EDITOR_PIN",H[H.EDITOR_STICKY=10]="EDITOR_STICKY",H[H.EDITOR_DIRTY=11]="EDITOR_DIRTY",H[H.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var x;(function(H){H[H.PRIMARY=1]="PRIMARY",H[H.SECONDARY=2]="SECONDARY",H[H.BOTH=3]="BOTH",H[H.ANY=4]="ANY"})(x||(e.SideBySideEditor=x={}));class B{getOriginalUri(ce,re){if(!ce)return;if(I(ce))return e.EditorResourceAccessor.getOriginalUri(ce.result,re);if(re?.supportSideBySide){const{primary:he,secondary:z}=this.getSideEditors(ce);if(he&&z){if(re?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(he,{filterByScheme:re.filterByScheme}),secondary:this.getOriginalUri(z,{filterByScheme:re.filterByScheme})};if(re?.supportSideBySide===x.ANY)return this.getOriginalUri(he,{filterByScheme:re.filterByScheme})??this.getOriginalUri(z,{filterByScheme:re.filterByScheme});ce=re.supportSideBySide===x.PRIMARY?he:z}}if(c(ce)||f(ce)||I(ce))return;const fe=l(ce)?ce.preferredResource:ce.resource;return!fe||!re||!re.filterByScheme?fe:this.filterUri(fe,re.filterByScheme)}getSideEditors(ce){return h(ce)||f(ce)?{primary:ce.primary,secondary:ce.secondary}:w(ce)||c(ce)?{primary:ce.modified,secondary:ce.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ce,re){if(!ce)return;if(I(ce))return e.EditorResourceAccessor.getCanonicalUri(ce.result,re);if(re?.supportSideBySide){const{primary:he,secondary:z}=this.getSideEditors(ce);if(he&&z){if(re?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(he,{filterByScheme:re.filterByScheme}),secondary:this.getCanonicalUri(z,{filterByScheme:re.filterByScheme})};if(re?.supportSideBySide===x.ANY)return this.getCanonicalUri(he,{filterByScheme:re.filterByScheme})??this.getCanonicalUri(z,{filterByScheme:re.filterByScheme});ce=re.supportSideBySide===x.PRIMARY?he:z}}if(c(ce)||f(ce)||I(ce))return;const fe=ce.resource;return!fe||!re||!re.filterByScheme?fe:this.filterUri(fe,re.filterByScheme)}filterUri(ce,re){if(Array.isArray(re)){if(re.some(fe=>ce.scheme===fe))return ce}else if(re===ce.scheme)return ce}}e.EditorResourceAccessor=new B;var U;(function(H){H[H.LEFT=0]="LEFT",H[H.RIGHT=1]="RIGHT"})(U||(e.CloseDirection=U={}));class X{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(ce){const re=this.instantiationService=ce.get(T.IInstantiationService);for(const[fe,he]of this.editorSerializerConstructors)this.createEditorSerializer(fe,he,re);this.editorSerializerConstructors.clear()}createEditorSerializer(ce,re,fe){const he=fe.createInstance(re);this.editorSerializerInstances.set(ce,he)}registerFileEditorFactory(ce){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=ce}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(ce,re){if(this.editorSerializerConstructors.has(ce)||this.editorSerializerInstances.has(ce))throw new Error(`A editor serializer with type ID '${ce}' was already registered.`);return this.instantiationService?this.createEditorSerializer(ce,re,this.instantiationService):this.editorSerializerConstructors.set(ce,re),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(ce),this.editorSerializerInstances.delete(ce)})}getEditorSerializer(ce){return this.editorSerializerInstances.get(typeof ce=="string"?ce:ce.typeId)}}m.Registry.add(e.EditorExtensions.EditorFactory,new X);async function j(H,ce,re){return!H||!H.length?[]:await Promise.all(H.map(async fe=>{const he=d.URI.revive(fe.fileUri);if(!he){re.info("Cannot resolve the path because it is not valid.",fe);return}if(!await ce.canHandleResource(he)){re.info("Cannot resolve the path because it cannot be handled",fe);return}let Z=fe.exists,ye=fe.type;if(typeof Z!="boolean"||typeof ye!="number")try{ye=(await ce.stat(he)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Z=!0}catch(ne){re.error(ne),Z=!1}if(!Z&&fe.openOnlyIfExists){re.info("Cannot resolve the path because it does not exist",fe);return}if(ye===y.FileType.Directory){re.info("Cannot resolve the path because it is a directory",fe);return}const Re={...fe.options,pinned:!0};return Z?{resource:he,options:Re}:{resource:he,options:Re,forceUntitled:!0}}))}e.pathsToEditors=j;var ge;(function(H){H[H.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",H[H.SEQUENTIAL=1]="SEQUENTIAL"})(ge||(e.EditorsOrder=ge={}));function ie(H){const ce=H;if(!ce)return!1;const re=ce;if(re.modified)return ie(re.modified);const fe=ce;return!!(fe.contributionsState&&fe.viewState&&Array.isArray(fe.cursorState))}e.isTextEditorViewState=ie;function te(H){return(0,R.isErrorWithActions)(H)}e.isEditorOpenError=te;function $(H,ce,re){const fe=(0,R.createErrorWithActions)(H,ce);return fe.forceMessage=re?.forceMessage,fe.forceSeverity=re?.forceSeverity,fe.allowDialog=re?.allowDialog,fe}e.createEditorOpenError=$}),define(De[254],Ie([1,0,3,207,5,4,28,42,19,65,23,72,243]),function(me,e,_,L,d,A,T,m,y,v,R,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,p.registerIcon)("default-view-icon",k.Codicon.window,(0,L.localize)(0,null));var C;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(C||(e.Extensions=C={}));var D;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(D||(e.ViewContainerLocation=D={})),e.ViewContainerLocations=[0,1,2];function b(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=b;class r extends A.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new _.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new _.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,y.flatten)([...this.viewContainers.values()])}registerViewContainer(t,o,g){const l=this.get(t.id);if(l)return l;const h=t;return h.openCommandActionDescriptor=g?.doNotRegisterOpenCommand?void 0:h.openCommandActionDescriptor??{id:h.id},(0,T.getOrSet)(this.viewContainers,o,[]).push(h),g?.isDefault&&this.defaultViewContainers.push(h),this._onDidRegister.fire({viewContainer:h,viewContainerLocation:o}),h}deregisterViewContainer(t){for(const o of this.viewContainers.keys()){const g=this.viewContainers.get(o),l=g?.indexOf(t);if(l!==-1){g?.splice(l,1),g.length===0&&this.viewContainers.delete(o),this._onDidDeregister.fire({viewContainer:t,viewContainerLocation:o});return}}}get(t){return this.all.filter(o=>o.id===t)[0]}getViewContainers(t){return[...this.viewContainers.get(t)||[]]}getViewContainerLocation(t){return[...this.viewContainers.keys()].filter(o=>this.getViewContainers(o).filter(g=>g?.id===t.id).length>0)[0]}getDefaultViewContainer(t){return this.defaultViewContainers.find(o=>this.getViewContainerLocation(o)===t)}}m.Registry.add(C.ViewContainersRegistry,new r);var s;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(s||(e.ViewContentGroups=s={}));function c(n,t){const o=n.group??s.More,g=t.group??s.More;return o!==g?o.localeCompare(g):(n.order??5)-(t.order??5)}class f extends A.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new _.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new _.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new _.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new _.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new v.SetMap}registerViews(t,o){this.registerViews2([{views:t,viewContainer:o}])}registerViews2(t){t.forEach(({views:o,viewContainer:g})=>this.addViews(o,g)),this._onViewsRegistered.fire(t)}deregisterViews(t,o){const g=this.removeViews(t,o);g.length&&this._onViewsDeregistered.fire({views:g,viewContainer:o})}moveViews(t,o){for(const g of this._views.keys())if(g!==o){const l=this.removeViews(t,g);l.length&&(this.addViews(l,o),this._onDidChangeContainer.fire({views:l,from:g,to:o}))}}getViews(t){return this._views.get(t)||[]}getView(t){for(const o of this._viewContainers){const g=(this._views.get(o)||[]).filter(l=>l.id===t)[0];if(g)return g}return null}getViewContainer(t){for(const o of this._viewContainers)if((this._views.get(o)||[]).filter(l=>l.id===t)[0])return o;return null}registerViewWelcomeContent(t,o){return this._viewWelcomeContents.add(t,o),this._onDidChangeViewWelcomeContent.fire(t),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(t,o),this._onDidChangeViewWelcomeContent.fire(t)})}registerViewWelcomeContent2(t,o){const g=new Map;for(const[l,h]of o)this._viewWelcomeContents.add(t,h),g.set(l,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(t,h),this._onDidChangeViewWelcomeContent.fire(t)}));return this._onDidChangeViewWelcomeContent.fire(t),g}getViewWelcomeContent(t){const o=[];return this._viewWelcomeContents.forEach(t,g=>o.push(g)),o.sort(c)}addViews(t,o){let g=this._views.get(o);g||(g=[],this._views.set(o,g),this._viewContainers.push(o));for(const l of t){if(this.getView(l.id)!==null)throw new Error((0,L.localize)(1,null,l.id));g.push(l)}}removeViews(t,o){const g=this._views.get(o);if(!g)return[];const l=[],h=[];for(const w of g)t.includes(w)?l.push(w):h.push(w);return l.length&&(h.length?this._views.set(o,h):(this._views.delete(o),this._viewContainers.splice(this._viewContainers.indexOf(o),1))),l}}m.Registry.add(C.ViewsRegistry,new f),e.IViewsService=(0,d.createDecorator)("viewsService"),e.IViewDescriptorService=(0,d.createDecorator)("viewDescriptorService");var S;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(S||(e.ViewVisibilityState=S={}));var I;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(I||(e.TreeItemCollapsibleState=I={}));class i{constructor(t,o){this.resolved=!1,this._hasResolve=!1,(0,R.mixin)(this,t),this._hasResolve=!!o,this.resolve=async g=>{if(o&&!this.resolved){const l=await o(g);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}g.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class a extends Error{constructor(t){super((0,L.localize)(2,null,t)),this.name="NoTreeViewError"}static is(t){return t.name==="NoTreeViewError"}}e.NoTreeViewError=a}),define(De[134],Ie([1,0,3,17,208]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new _.Emitter,this._onExit=new _.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(m){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=m}onEvent(m){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=m}onRequest(m){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=m}sendResponse(m){m.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.internalSend("response",m)}sendRequest(m,y,v,R){const k={command:m};if(y&&Object.keys(y).length>0&&(k.arguments=y),this.internalSend("request",k),typeof R=="number"){const p=setTimeout(()=>{clearTimeout(p);const C=this.pendingRequests.get(k.seq);if(C){this.pendingRequests.delete(k.seq);const D={type:"response",seq:0,request_seq:k.seq,success:!1,command:m,message:(0,d.localize)(0,null,R,m)};C(D)}},R)}return v&&this.pendingRequests.set(k.seq,v),k.seq}acceptMessage(m){this.messageCallback?this.messageCallback(m):(this.queue.push(m),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(m,y){return m.type!=="event"||y.type!=="event"}async processQueue(){let m;for(;this.queue.length;){if((!m||this.needsTaskBoundaryBetween(this.queue[0],m))&&await(0,L.timeout)(0),m=this.queue.shift(),!m)return;switch(m.type){case"event":this.eventCallback?.(m);break;case"request":this.requestCallback?.(m);break;case"response":{const y=m,v=this.pendingRequests.get(y.request_seq);v&&(this.pendingRequests.delete(y.request_seq),v(y));break}}}}internalSend(m,y){y.type=m,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const m=new Map;this.pendingRequests.forEach((y,v)=>m.set(v,y)),await(0,L.timeout)(500),m.forEach((y,v)=>{y({type:"response",seq:0,request_seq:v,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(v)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(De[255],Ie([1,0,209,47,5]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new L.RawContextKey("debugType",void 0,{type:"string",description:_.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new L.RawContextKey("debugConfigurationType",void 0,{type:"string",description:_.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new L.RawContextKey("debugState","inactive",{type:"string",description:_.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new L.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:_.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new L.RawContextKey("hasDebugged",!1,{type:"boolean",description:_.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new L.RawContextKey("inDebugMode",!1,{type:"boolean",description:_.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new L.RawContextKey("inDebugRepl",!1,{type:"boolean",description:_.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new L.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:_.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new L.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:_.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new L.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:_.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new L.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:_.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new L.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:_.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new L.RawContextKey("variablesFocused",!0,{type:"boolean",description:_.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new L.RawContextKey("expressionSelected",!1,{type:"boolean",description:_.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new L.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:_.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new L.RawContextKey("callStackItemType",void 0,{type:"string",description:_.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new L.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:_.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new L.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:_.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new L.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:_.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new L.RawContextKey("watchItemType",void 0,{type:"string",description:_.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new L.RawContextKey("canViewMemory",void 0,{type:"boolean",description:_.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new L.RawContextKey("breakpointItemType",void 0,{type:"string",description:_.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new L.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:_.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new L.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:_.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new L.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:_.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new L.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:_.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new L.RawContextKey("stepBackSupported",!1,{type:"boolean",description:_.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new L.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:_.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new L.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:_.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new L.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:_.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new L.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:_.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new L.RawContextKey("breakpointsExist",!1,{type:"boolean",description:_.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new L.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:_.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new L.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:_.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new L.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:_.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new L.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:_.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new L.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:_.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new L.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:_.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new L.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:_.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new L.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:_.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new L.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:_.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new L.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:_.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new L.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:_.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new L.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:_.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new L.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:_.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new L.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:_.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new L.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:_.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new L.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:_.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new L.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:_.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new L.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:_.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new L.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:_.localize(50,null)});const A=p=>_.localize(51,null,p);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:_.localize(52,null)};var T;(function(p){p[p.Inactive=0]="Inactive",p[p.Initializing=1]="Initializing",p[p.Stopped=2]="Stopped",p[p.Running=3]="Running"})(T||(e.State=T={}));function m(p){switch(p){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=m;var y;(function(p){p[p.Valid=0]="Valid",p[p.Unreadable=1]="Unreadable",p[p.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var v;(function(p){p[p.Initial=1]="Initial",p[p.Dynamic=2]="Dynamic"})(v||(e.DebugConfigurationProviderTriggerKind=v={}));var R;(function(p){p.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.IDebugService=(0,d.createDecorator)("debugService");var k;(function(p){p[p.CONDITION=0]="CONDITION",p[p.HIT_COUNT=1]="HIT_COUNT",p[p.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(De[256],Ie([1,0,12,2,13,23,15,33,21,19]),function(me,e,_,L,d,A,T,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function k(l,h,w){return l.replace(R,function(u,E){return h&&E.length>0&&E[0]!=="_"?u:w&&w.hasOwnProperty(E)?w[E]:u})}e.formatPII=k;function p(l){const h={};for(const w of Object.keys(l))w.startsWith("!")||(h[w]=l[w]);return h}e.filterExceptionsFromTelemetry=p;function C(l){return l.configuration.request==="attach"&&!D(l)&&(!l.parentSession||C(l.parentSession))}e.isSessionAttach=C;function D(l){let h=l.configuration.type;if(h)return h==="vslsShare"&&(h=l.configuration.adapterProxy.configuration.type),(0,_.equalsIgnoreCase)(h,"extensionhost")||(0,_.equalsIgnoreCase)(h,"pwa-extensionhost")?l:l.parentSession?D(l.parentSession):void 0}e.getExtensionHostDebugSession=D;function b(l){return l.type&&(l.label||l.program||l.runtime)}e.isDebuggerMainContribution=b;function r(l,h,w){let u,E=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=P.exec(l);){const N=O.index+1,F=N+O[0].length;if(N<=h&&F>=w){u=O[0],E=N;break}}if(u){const N=/\w+/g;let F=null;for(;(F=N.exec(u))&&!(F.index+1+E+F[0].length>=w););F&&(u=u.substring(0,N.lastIndex))}return u?{start:E,end:E+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=r;async function s(l,h,w,u){if(l.evaluatableExpressionProvider.has(h)){const E=l.evaluatableExpressionProvider.ordered(h),P=(0,v.coalesce)(await Promise.all(E.map(async O=>{try{return await O.provideEvaluatableExpression(h,w,u??y.CancellationToken.None)}catch{return}})));if(P.length>0){let O=P[0].expression;const N=P[0].range;return O||(O=h.getLineContent(w.lineNumber).substring(N.startColumn-1,N.endColumn-1)),{range:N,matchingExpression:O}}}else{const E=h.getLineContent(w.lineNumber),{start:P,end:O}=r(E,w.column,w.column),N=E.substring(P-1,O);return{matchingExpression:N,range:new m.Range(w.lineNumber,P,w.lineNumber,P+N.length)}}return null}e.getEvaluatableExpressionAtPosition=s;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function f(l){return!!(l&&l.match(c))}e.isUri=f;function S(l){if(typeof l.path=="string"&&!(typeof l.sourceReference=="number"&&l.sourceReference>0)){if(f(l.path))return L.URI.parse(l.path);if((0,d.isAbsolute)(l.path))return L.URI.file(l.path)}return l.path}function I(l){if(typeof l.path=="object"){const h=L.URI.revive(l.path);if(h)return h.scheme===T.Schemas.file?h.fsPath:h.toString()}return l.path}function i(l,h){const w=h?S:I,u=(0,A.deepClone)(l);return n(u,(E,P)=>{E&&P&&(P.path=w(P))}),u}e.convertToDAPaths=i;function a(l,h){const w=h?S:I,u=(0,A.deepClone)(l);return n(u,(E,P)=>{!E&&P&&(P.path=w(P))}),u}e.convertToVSCPaths=a;function n(l,h){switch(l.type){case"event":{const w=l;switch(w.event){case"output":h(!1,w.body.source);break;case"loadedSource":h(!1,w.body.source);break;case"breakpoint":h(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=l;switch(w.command){case"setBreakpoints":h(!0,w.arguments.source);break;case"breakpointLocations":h(!0,w.arguments.source);break;case"source":h(!0,w.arguments.source);break;case"gotoTargets":h(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(u=>h(!1,u));break;default:break}break}case"response":{const w=l;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(u=>h(!1,u.source));break;case"loadedSources":w.body.sources.forEach(u=>h(!1,u));break;case"scopes":w.body.scopes.forEach(u=>h(!1,u.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(u=>h(!1,u.source));break;case"setBreakpoints":w.body.breakpoints.forEach(u=>h(!1,u.source));break;case"disassemble":w.body?.instructions.forEach(E=>h(!1,E.location));break;default:break}break}}}function t(l){return l.filter(h=>!h.presentation?.hidden).sort((h,w)=>h.presentation?w.presentation?h.presentation.group?w.presentation.group?h.presentation.group!==w.presentation.group?h.presentation.group.localeCompare(w.presentation.group):o(h.presentation.order,w.presentation.order):-1:w.presentation.group?1:o(h.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.getVisibleAndSorted=t;function o(l,h){return typeof l!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:l-h}async function g(l,h){const w=l.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(w!=="none"&&(await h.saveAll(),w==="allEditorsInActiveGroup")){const u=h.activeEditorPane;u&&u.input.resource?.scheme===T.Schemas.untitled&&await h.save({editor:u.input,groupId:u.group.id})}await l.reloadConfiguration()}e.saveAllBeforeDebugStart=g}),define(De[257],Ie([1,0,46,101,23,13,11,12,29,210,134]),function(me,e,_,L,d,A,T,m,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends R.AbstractDebugAdapter{static{this.TWO_CRLF=`\r
\r
`}static{this.HEADER_LINESEPARATOR=/\r?\n/}static{this.HEADER_FIELDSEPARATOR=/: */}constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(s,c){this.outputStream=c,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,s.on("data",f=>this.handleData(f))}sendMessage(s){if(this.outputStream){const c=JSON.stringify(s);this.outputStream.write(`Content-Length: ${Buffer.byteLength(c,"utf8")}${k.TWO_CRLF}${c}`,"utf8")}}handleData(s){for(this.rawData=Buffer.concat([this.rawData,s]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const c=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,c.length>0)try{this.acceptMessage(JSON.parse(c))}catch(f){this._onError.fire(new Error((f.message||f)+`
`+c))}continue}}else{const c=this.rawData.indexOf(k.TWO_CRLF);if(c!==-1){const S=this.rawData.toString("utf8",0,c).split(k.HEADER_LINESEPARATOR);for(const I of S){const i=I.split(k.HEADER_FIELDSEPARATOR);i[0]==="Content-Length"&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(c+k.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=k;class p extends k{startSession(){return new Promise((s,c)=>{let f=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),s(),f=!0}),this.socket.on("close",()=>{f?this._onError.fire(new Error("connection closed")):c(new Error("connection closed"))}),this.socket.on("error",S=>{f?this._onError.fire(S):c(S)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=p;class C extends p{constructor(s){super(),this.adapterServer=s}createConnection(s){return L.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",s)}}e.SocketDebugAdapter=C;class D extends p{constructor(s){super(),this.adapterServer=s}createConnection(s){return L.createConnection(this.adapterServer.path,s)}}e.NamedPipeDebugAdapter=D;class b extends k{constructor(s,c){super(),this.adapterExecutable=s,this.debugType=c}async startSession(){const s=this.adapterExecutable.command,c=this.adapterExecutable.args,f=this.adapterExecutable.options||{};try{if(s)if(A.isAbsolute(s)){if(!await y.Promises.exists(s))throw new Error(v.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(v.localize(1,null,this.debugType));let S=process.env;if(f.env&&Object.keys(f.env).length>0&&(S=d.mixin(d.deepClone(process.env),f.env)),s==="node")if(Array.isArray(c)&&c.length>0){const I=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:S,execArgv:I?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};f.cwd&&(i.cwd=f.cwd);const a=_.fork(c[0],c.slice(1),i);if(!a.pid)throw new Error(v.localize(2,null,c[0]));this.serverProcess=a}else throw new Error(v.localize(3,null));else{const I={env:S};f.cwd&&(I.cwd=f.cwd),this.serverProcess=_.spawn(s,c,I)}this.serverProcess.on("error",I=>{this._onError.fire(I)}),this.serverProcess.on("exit",(I,i)=>{this._onExit.fire(I)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",I=>{this._onError.fire(I)}),this.serverProcess.stdin.on("error",I=>{this._onError.fire(I)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(S){this._onError.fire(S)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),T.isWindows?new Promise((s,c)=>{const f=_.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(S,I,i){if(S)return c(S)});f.on("exit",s),f.on("error",c)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(s,c){if(!s)return;const f=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?f.runtime=A.join(c,s.runtime):f.runtime=s.runtime),s.runtimeArgs&&(f.runtimeArgs=s.runtimeArgs),s.program&&(A.isAbsolute(s.program)?f.program=s.program:f.program=A.join(c,s.program)),s.args&&(f.args=s.args);const S=s;return S.win&&(f.win=b.extract(S.win,c)),S.winx86&&(f.winx86=b.extract(S.winx86,c)),S.windows&&(f.windows=b.extract(S.windows,c)),S.osx&&(f.osx=b.extract(S.osx,c)),S.linux&&(f.linux=b.extract(S.linux,c)),f}static platformAdapterExecutable(s,c){let f=Object.create(null);c=c.toLowerCase();for(const t of s)if(t.contributes){const o=t.contributes.debuggers;o&&o.length>0&&o.filter(g=>typeof g.type=="string"&&m.equalsIgnoreCase(g.type,c)).forEach(g=>{const l=b.extract(g,t.extensionLocation.fsPath);f=d.mixin(f,l,t.isBuiltin)})}let S;T.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?S=f.winx86||f.win||f.windows:T.isWindows?S=f.win||f.windows:T.isMacintosh?S=f.osx:T.isLinux&&(S=f.linux),S=S||f;const I=S.program||f.program,i=S.args||f.args,a=S.runtime||f.runtime,n=S.runtimeArgs||f.runtimeArgs;if(a)return{type:"executable",command:a,args:(n||[]).concat(typeof I=="string"?[I]:[]).concat(i||[])};if(I)return{type:"executable",command:I,args:i||[]}}}e.ExecutableDebugAdapter=b}),define(De[258],Ie([1,0,46,31,11]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(v,R){return new Promise((k,p)=>{let C="";const D=_.spawn(v,R);D.pid&&D.stdout.on("data",b=>{C+=b.toString()}),D.on("error",b=>{p(b)}),D.on("close",b=>{k(C)})})}async function T(v){if(v)if(d.isWindows){const R=await new Promise((k,p)=>{me(["@vscode/windows-process-tree"],k,p)});return new Promise(k=>{R.getProcessTree(v,p=>{k(!!p&&p.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(v)]).then(R=>{const k=R.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.hasChildProcesses=T;var m;(function(v){v[v.cmd=0]="cmd",v[v.powershell=1]="powershell",v[v.bash=2]="bash"})(m||(m={}));function y(v,R,k,p,C){v=v.trim().toLowerCase();let D;v.indexOf("powershell")>=0||v.indexOf("pwsh")>=0?D=1:v.indexOf("cmd.exe")>=0?D=0:v.indexOf("bash")>=0?D=2:d.isWindows?D=0:D=2;let b,r=" ";switch(D){case 1:if(b=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),p){const s=(0,L.getDriveLetter)(p);s&&(r+=`${s}:; `),r+=`cd ${b(p)}; `}if(C)for(const s in C){const c=C[s];c===null?r+=`Remove-Item env:${s}; `:r+=`\${env:${s}}='${c}'; `}if(R.length>0){const s=R.shift(),c=k?s:b(s);r+=c[0]==="'"?`& ${c} `:`${c} `;for(const f of R)r+=f==="<"||f===">"||k?f:b(f),r+=" "}break;case 0:if(b=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(c=>s.includes(c))||s.length===0?`"${s}"`:s),p){const s=(0,L.getDriveLetter)(p);s&&(r+=`${s}: && `),r+=`cd ${b(p)} && `}if(C){r+='cmd /C "';for(const s in C){let c=C[s];c===null?r+=`set "${s}=" && `:(c=c.replace(/[&^|<>]/g,f=>`^${f}`),r+=`set "${s}=${c}" && `)}}for(const s of R)r+=s==="<"||s===">"||k?s:b(s),r+=" ";C&&(r+='"');break;case 2:{b=c=>(c=c.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),c.length===0?'""':c);const s=c=>/[^\w@%\/+=,.:^-]/.test(c)?`'${c.replace(/'/g,"'\\''")}'`:c;if(p&&(r+=`cd ${b(p)} ; `),C){r+="/usr/bin/env";for(const c in C){const f=C[c];f===null?r+=` -u ${s(c)}`:r+=` ${s(`${c}=${f}`)}`}r+=" "}for(const c of R)r+=c==="<"||c===">"||k?c:b(c),r+=" ";break}}return r}e.prepareCommand=y}),define(De[102],Ie([1,0,22,34,48,93,15,13,11,47]),function(me,e,_,L,d,A,T,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var R;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(R||(e.CellKind=R={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var p;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(p||(e.NotebookCellExecutionState=p={}));var C;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(C||(e.NotebookExecutionState=C={}));var D;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(D||(e.NotebookRendererMatch=D={}));var b;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(b||(e.RendererMessagingSpec=b={}));var r;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var s;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var c;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var f;(function(U){U.scheme=T.Schemas.vscodeNotebookCell;const X=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${X.join("")}]+`),ge=7;function ie(fe,he){const z=he.toString(ge),ye=`${z.length<X.length?X[z.length-1]:"z"}${z}s${(0,_.encodeBase64)(_.VSBuffer.fromString(fe.scheme),!0,!0)}`;return fe.with({scheme:U.scheme,fragment:ye})}U.generate=ie;function te(fe){if(fe.scheme!==U.scheme)return;const he=fe.fragment.indexOf("s");if(he<0)return;const z=parseInt(fe.fragment.substring(0,he).replace(j,""),ge),Z=(0,_.decodeBase64)(fe.fragment.substring(he+1)).toString();if(!isNaN(z))return{handle:z,notebook:fe.with({scheme:Z,fragment:null})}}U.parse=te;function $(fe,he){return fe.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${he??""},${fe.scheme!==T.Schemas.file?fe.scheme:""}`})}U.generateCellOutputUri=$;function H(fe){if(fe.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const he=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(fe.fragment);if(!he)return;const z=he[1]&&he[1]!==""?he[1]:void 0,Z=he[2];return{outputId:z,notebook:fe.with({scheme:Z||T.Schemas.file,fragment:null})}}U.parseCellOutputUri=H;function ce(fe,he,z){return U.generate(fe,he).with({scheme:z})}U.generateCellPropertyUri=ce;function re(fe,he){if(fe.scheme===he)return U.parse(fe.with({scheme:U.scheme}))}U.parseCellPropertyUri=re})(f||(e.CellUri=f={}));const S=U=>y.isWindows?U.replace(/\//g,"\\"):U;class I{constructor(X=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=j,this.order=[...new Set(X)].map(ge=>({pattern:ge,matches:L.parse(S(ge))}))}sort(X){const j=new Map(d.Iterable.map(X,ie=>[ie,S(ie)]));let ge=[];for(const{matches:ie}of this.order)for(const[te,$]of j)if(ie($)){ge.push(te),j.delete(te);break}return j.size&&(ge=ge.concat([...j.keys()].sort((ie,te)=>this.defaultOrder.indexOf(ie)-this.defaultOrder.indexOf(te)))),ge}prioritize(X,j){const ge=this.findIndex(X);if(ge===-1){this.order.unshift({pattern:X,matches:L.parse(S(X))});return}const ie=new Set(j.map($=>this.findIndex($,ge)));ie.delete(-1);const te=Array.from(ie).sort();this.order.splice(ge+1,0,...te.map($=>this.order[$]));for(let $=te.length-1;$>=0;$--)this.order.splice(te[$],1)}toArray(){return this.order.map(X=>X.pattern)}findIndex(X,j=this.order.length){const ge=S(X);for(let ie=0;ie<j;ie++)if(this.order[ie].matches(ge))return ie;return-1}}e.MimeTypeDisplayOrder=I;function i(U,X,j,ge=(ie,te)=>ie===te){const ie=[];function te(ce,re,fe){if(re===0&&fe.length===0)return;const he=ie[ie.length-1];he&&he.start+he.deleteCount===ce?(he.deleteCount+=re,he.toInsert.push(...fe)):ie.push({start:ce,deleteCount:re,toInsert:fe})}let $=0,H=0;for(;;){if($===U.length){te($,0,X.slice(H));break}if(H===X.length){te($,U.length-$,[]);break}const ce=U[$],re=X[H];if(ge(ce,re)){$+=1,H+=1;continue}j(re)?(te($,1,[]),$+=1):(te($,0,[re]),H+=1)}return ie}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new v.RawContextKey("notebookEditorCursorAtBoundary","none");var a;(function(U){U.default="default",U.option="option"})(a||(e.NotebookEditorPriority=a={}));function n(U){const X=U;return!!((typeof X.include=="string"||L.isRelativePattern(X.include))&&(typeof X.exclude=="string"||L.isRelativePattern(X.exclude)))}e.isDocumentExcludePattern=n;function t(U,X,j){if(Array.isArray(U.viewType)&&U.viewType.indexOf(X)>=0||U.viewType===X)return!0;if(U.filenamePattern){const ge=n(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,ie=n(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(L.match(ge,(0,m.basename)(j.fsPath).toLowerCase()))return!(ie&&L.match(ie,(0,m.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=t,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var o;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(o||(e.CellStatusbarAlignment=o={}));class g{static{this._prefix="notebook/"}static create(X){return`${g._prefix}${X}`}static parse(X){if(X.startsWith(g._prefix))return X.substring(g._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=g;function l(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.isTextStreamMime=l;const h=new TextDecoder;function w(U){const X=[];let j=!1;for(const $ of U)(X.length===0||j)&&(X.push($),j=!0);let ge=P(X);const ie=_.VSBuffer.concat(X.map($=>_.VSBuffer.wrap($))),te=B(ie);return ge=ge||te.byteLength!==ie.byteLength,{data:te,didCompression:ge}}e.compressOutputItemStreams=w,e.MOVE_CURSOR_1_LINE_COMMAND=`${String.fromCharCode(27)}[A`;const u=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(U=>U.charCodeAt(0)),E=10;function P(U){let X=!1;return U.forEach((j,ge)=>{if(ge===0||j.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const ie=U[ge-1],te=j.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(te[0]===u[0]&&te[1]===u[1]&&te[2]===u[2]){const $=ie.lastIndexOf(E);if($===-1)return;X=!0,U[ge-1]=ie.subarray(0,$),U[ge]=j.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),X}function O(U){let X=U;do U=X,X=U.replace(/[^\n]\x08/gm,"");while(X.length<U.length);return U}function N(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const X=U.match(/^(.*)\r+/m)[1];let j=U.match(/\r+(.*)$/m)[1];j=j+X.slice(j.length,X.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return U}const F="\b".charCodeAt(0),x="\r".charCodeAt(0);function B(U){return!U.buffer.includes(F)&&!U.buffer.includes(x)?U:_.VSBuffer.fromString(N(O(h.decode(U.buffer))))}}),define(De[7],Ie([1,0,19,8,74,28,93,12,14,2,32,25,30,130,102]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D){"use strict";var b,r,s,c,f,S,I,i,a,n,t,o,g,l,h,w,u,E;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.NotebookCodeActionKind=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(V){return Object.assign(V,{apply:function(){const ve=arguments.length===1?[]:arguments[1];return Reflect.construct(V,ve,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(V,[]);{const[ve,...Le]=arguments;return Reflect.construct(V,Le,ve.constructor)}}})}var O;(function(V){V[V.Top=0]="Top",V[V.Bottom=1]="Bottom"})(O||(e.TerminalOutputAnchor=O={}));var N;(function(V){V[V.Command=0]="Command",V[V.Opener=1]="Opener"})(N||(e.TerminalQuickFixType=N={}));let F=b=class{static from(...W){let ve=W;return new b(function(){if(ve){for(const Le of ve)Le&&typeof Le.dispose=="function"&&Le.dispose();ve=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=F,e.Disposable=F=b=Ve([P],F);let x=r=class{static Min(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Le=1;Le<W.length;Le++){const qe=W[Le];qe.isBefore(ve)&&(ve=qe)}return ve}static Max(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Le=1;Le<W.length;Le++){const qe=W[Le];qe.isAfter(ve)&&(ve=qe)}return ve}static isPosition(W){if(!W)return!1;if(W instanceof r)return!0;const{line:ve,character:Le}=W;return typeof ve=="number"&&typeof Le=="number"}static of(W){if(W instanceof r)return W;if(this.isPosition(W))return new r(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(W,ve){if(W<0)throw(0,L.illegalArgument)("line must be non-negative");if(ve<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=W,this._character=ve}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,ve=0){if(W===null||ve===null)throw(0,L.illegalArgument)();let Le;return typeof W>"u"?Le=0:typeof W=="number"?Le=W:(Le=typeof W.lineDelta=="number"?W.lineDelta:0,ve=typeof W.characterDelta=="number"?W.characterDelta:0),Le===0&&ve===0?this:new r(this.line+Le,this.character+ve)}with(W,ve=this.character){if(W===null||ve===null)throw(0,L.illegalArgument)();let Le;return typeof W>"u"?Le=this.line:typeof W=="number"?Le=W:(Le=typeof W.line=="number"?W.line:this.line,ve=typeof W.character=="number"?W.character:this.character),Le===this.line&&ve===this.character?this:new r(Le,ve)}toJSON(){return{line:this.line,character:this.character}}};e.Position=x,e.Position=x=r=Ve([P],x);let B=s=class{static isRange(W){return W instanceof s?!0:W?x.isPosition(W.start)&&x.isPosition(W.end):!1}static of(W){if(W instanceof s)return W;if(this.isRange(W))return new s(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(W,ve,Le,qe){let Ye,ot;if(typeof W=="number"&&typeof ve=="number"&&typeof Le=="number"&&typeof qe=="number"?(Ye=new x(W,ve),ot=new x(Le,qe)):x.isPosition(W)&&x.isPosition(ve)&&(Ye=x.of(W),ot=x.of(ve)),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this._start=Ye,this._end=ot):(this._start=ot,this._end=Ye)}contains(W){return s.isRange(W)?this.contains(W.start)&&this.contains(W.end):x.isPosition(W)?!(x.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const ve=x.Max(W.start,this._start),Le=x.Min(W.end,this._end);if(!ve.isAfter(Le))return new s(ve,Le)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ve=x.Min(W.start,this._start),Le=x.Max(W.end,this.end);return new s(ve,Le)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,ve=this.end){if(W===null||ve===null)throw(0,L.illegalArgument)();let Le;return W?x.isPosition(W)?Le=W:(Le=W.start||this.start,ve=W.end||this.end):Le=this.start,Le.isEqual(this._start)&&ve.isEqual(this.end)?this:new s(Le,ve)}toJSON(){return[this.start,this.end]}};e.Range=B,e.Range=B=s=Ve([P],B);let U=c=class extends B{static isSelection(W){return W instanceof c?!0:W?B.isRange(W)&&x.isPosition(W.anchor)&&x.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(W,ve,Le,qe){let Ye,ot;if(typeof W=="number"&&typeof ve=="number"&&typeof Le=="number"&&typeof qe=="number"?(Ye=new x(W,ve),ot=new x(Le,qe)):x.isPosition(W)&&x.isPosition(ve)&&(Ye=x.of(W),ot=x.of(ve)),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot),this._anchor=Ye,this._active=ot}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=U,e.Selection=U=c=Ve([P],U);const X=V=>{if(typeof V!="string"||V.length===0||!/^[0-9A-Za-z_\-]+$/.test(V))throw(0,L.illegalArgument)("connectionToken")};class j{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve,Le){if(typeof W!="string"||W.length===0)throw(0,L.illegalArgument)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,L.illegalArgument)("port");typeof Le<"u"&&X(Le),this.host=W,this.port=Math.round(ve),this.connectionToken=Le}}e.ResolvedAuthority=j;class ge{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve){this.makeConnection=W,this.connectionToken=ve,typeof ve<"u"&&X(ve)}}e.ManagedResolvedAuthority=ge;class ie extends Error{static NotAvailable(W,ve){return new ie(W,C.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(W){return new ie(W,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ve=C.RemoteAuthorityResolverErrorCode.Unknown,Le){super(W),this._message=W,this._code=ve,this._detail=Le,Object.setPrototypeOf(this,ie.prototype)}}e.RemoteAuthorityResolverError=ie;var te;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(te||(e.EndOfLine=te={}));var $;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})($||(e.EnvironmentVariableMutatorType=$={}));let H=f=class{static isTextEdit(W){return W instanceof f?!0:W?B.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ve){return new f(W,ve)}static insert(W,ve){return f.replace(new B(W,W),ve)}static delete(W){return f.replace(W,"")}static setEndOfLine(W){const ve=new f(new B(new x(0,0),new x(0,0)),"");return ve.newEol=W,ve}get range(){return this._range}set range(W){if(W&&!B.isRange(W))throw(0,L.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,L.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,L.illegalArgument)("newEol");this._newEol=W}constructor(W,ve){this._range=W,this._newText=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=H,e.TextEdit=H=f=Ve([P],H);let ce=S=class{static isNotebookCellEdit(W){return W instanceof S?!0:W?Kt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ve){return new S(W,ve)}static insertCells(W,ve){return new S(new Kt(W,W),ve)}static deleteCells(W){return new S(W,[])}static updateCellMetadata(W,ve){const Le=new S(new Kt(W,W),[]);return Le.newCellMetadata=ve,Le}static updateNotebookMetadata(W){const ve=new S(new Kt(0,0),[]);return ve.newNotebookMetadata=W,ve}constructor(W,ve){this.range=W,this.newCells=ve}};e.NotebookEdit=ce,e.NotebookEdit=ce=S=Ve([P],ce);class re{static isSnippetTextEdit(W){return W instanceof re?!0:W?B.isRange(W.range)&&z.isSnippetString(W.snippet):!1}static replace(W,ve){return new re(W,ve)}static insert(W,ve){return re.replace(new B(W,W),ve)}constructor(W,ve){this.range=W,this.snippet=ve}}e.SnippetTextEdit=re;var fe;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace",V[V.Snippet=6]="Snippet"})(fe||(e.FileEditType=fe={}));let he=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,ve,Le,qe){this._edits.push({_type:1,from:W,to:ve,options:Le,metadata:qe})}createFile(W,ve,Le){this._edits.push({_type:1,from:void 0,to:W,options:ve,metadata:Le})}deleteFile(W,ve,Le){this._edits.push({_type:1,from:W,to:void 0,options:ve,metadata:Le})}replaceNotebookMetadata(W,ve,Le){this._edits.push({_type:3,metadata:Le,uri:W,edit:{editType:5,metadata:ve},notebookMetadata:ve})}replaceNotebookCells(W,ve,Le,qe){const Ye=ve.start,ot=ve.end;(Ye!==ot||Le.length>0)&&this._edits.push({_type:5,uri:W,index:Ye,count:ot-Ye,cells:Le,metadata:qe})}replaceNotebookCellMetadata(W,ve,Le,qe){this._edits.push({_type:3,metadata:qe,uri:W,edit:{editType:3,index:ve,metadata:Le}})}replace(W,ve,Le,qe){this._edits.push({_type:2,uri:W,edit:new H(ve,Le),metadata:qe})}insert(W,ve,Le,qe){this.replace(W,new B(ve,ve),Le,qe)}delete(W,ve,Le){this.replace(W,ve,"",Le)}has(W){return this._edits.some(ve=>ve._type===2&&ve.uri.toString()===W.toString())}set(W,ve){if(ve)for(const Le of ve){if(!Le)continue;let qe,Ye;Array.isArray(Le)?(qe=Le[0],Ye=Le[1]):qe=Le,ce.isNotebookCellEdit(qe)?qe.newCellMetadata?this.replaceNotebookCellMetadata(W,qe.range.start,qe.newCellMetadata,Ye):qe.newNotebookMetadata?this.replaceNotebookMetadata(W,qe.newNotebookMetadata,Ye):this.replaceNotebookCells(W,qe.range,qe.newCells,Ye):re.isSnippetTextEdit(qe)?this._edits.push({_type:6,uri:W,range:qe.range,edit:qe.snippet,metadata:Ye}):this._edits.push({_type:2,uri:W,edit:qe,metadata:Ye})}else{for(let Le=0;Le<this._edits.length;Le++){const qe=this._edits[Le];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===W.toString()&&(this._edits[Le]=void 0);break}}(0,_.coalesceInPlace)(this._edits)}}get(W){const ve=[];for(const Le of this._edits)Le._type===2&&Le.uri.toString()===W.toString()&&ve.push(Le.edit);return ve}entries(){const W=new A.ResourceMap;for(const ve of this._edits)if(ve._type===2){let Le=W.get(ve.uri);Le||(Le=[ve.uri,[]],W.set(ve.uri,Le)),Le[1].push(ve.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=he,e.WorkspaceEdit=he=Ve([P],he);let z=I=class{static isSnippetString(W){return W instanceof I?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this._tabstop=1,this.value=W||""}appendText(W){return this.value+=I._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ve=this._tabstop++){if(typeof W=="function"){const Le=new I;Le._tabstop=this._tabstop,W(Le),this._tabstop=Le._tabstop,W=Le.value}else W=I._escape(W);return this.value+="${",this.value+=ve,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ve=this._tabstop++){const Le=W.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(W,ve){if(typeof ve=="function"){const Le=new I;Le._tabstop=this._tabstop,ve(Le),this._tabstop=Le._tabstop,ve=Le.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.SnippetString=z,e.SnippetString=z=I=Ve([P],z);var Z;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(Z||(e.DiagnosticTag=Z={}));var ye;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(ye||(e.DiagnosticSeverity=ye={}));let Re=i=class{static isLocation(W){return W instanceof i?!0:W?B.isRange(W.range)&&v.URI.isUri(W.uri):!1}constructor(W,ve){if(this.uri=W,ve)if(B.isRange(ve))this.range=B.of(ve);else if(x.isPosition(ve))this.range=new B(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=Re,e.Location=Re=i=Ve([P],Re);let ne=class{static is(W){return W?typeof W.message=="string"&&W.location&&B.isRange(W.location.range)&&v.URI.isUri(W.location.uri):!1}constructor(W,ve){this.location=W,this.message=ve}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.location.range.isEqual(ve.location.range)&&W.location.uri.toString()===ve.location.uri.toString()}};e.DiagnosticRelatedInformation=ne,e.DiagnosticRelatedInformation=ne=Ve([P],ne);let ee=class{constructor(W,ve,Le=ye.Error){if(!B.isRange(W))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=W,this.message=ve,this.severity=Le}toJSON(){return{severity:ye[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.severity===ve.severity&&W.code===ve.code&&W.severity===ve.severity&&W.source===ve.source&&W.range.isEqual(ve.range)&&(0,_.equals)(W.tags,ve.tags)&&(0,_.equals)(W.relatedInformation,ve.relatedInformation,ne.isEqual)}};e.Diagnostic=ee,e.Diagnostic=ee=Ve([P],ee);let de=class{constructor(W,ve){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ve}};e.Hover=de,e.Hover=de=Ve([P],de);var K;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(K||(e.DocumentHighlightKind=K={}));let le=class{constructor(W,ve=K.Text){this.range=W,this.kind=ve}toJSON(){return{range:this.range,kind:K[this.kind]}}};e.DocumentHighlight=le,e.DocumentHighlight=le=Ve([P],le);var oe;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(oe||(e.SymbolKind=oe={}));var ue;(function(V){V[V.Deprecated=1]="Deprecated"})(ue||(e.SymbolTag=ue={}));let Ee=a=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ve,Le,qe,Ye){this.name=W,this.kind=ve,this.containerName=Ye,typeof Le=="string"&&(this.containerName=Le),qe instanceof Re?this.location=qe:Le instanceof B&&(this.location=new Re(qe,Le)),a.validate(this)}toJSON(){return{name:this.name,kind:oe[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Ee,e.SymbolInformation=Ee=a=Ve([P],Ee);let M=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(n.validate)}constructor(W,ve,Le,qe,Ye){this.name=W,this.detail=ve,this.kind=Le,this.range=qe,this.selectionRange=Ye,this.children=[],n.validate(this)}};e.DocumentSymbol=M,e.DocumentSymbol=M=n=Ve([P],M);var q;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(q||(e.CodeActionTriggerKind=q={}));let G=class{constructor(W,ve){this.title=W,this.kind=ve}};e.CodeAction=G,e.CodeAction=G=Ve([P],G);let J=class{static{t=this}static{this.sep="."}constructor(W){this.value=W}append(W){return new t(this.value?this.value+t.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+t.sep)}};e.CodeActionKind=J,e.CodeActionKind=J=t=Ve([P],J);class be extends J{constructor(W){super(W),this.value=W}}e.NotebookCodeActionKind=be,J.Empty=new J(""),J.QuickFix=J.Empty.append("quickfix"),J.Refactor=J.Empty.append("refactor"),J.RefactorExtract=J.Refactor.append("extract"),J.RefactorInline=J.Refactor.append("inline"),J.RefactorMove=J.Refactor.append("move"),J.RefactorRewrite=J.Refactor.append("rewrite"),J.Source=J.Empty.append("source"),J.SourceOrganizeImports=J.Source.append("organizeImports"),J.SourceFixAll=J.Source.append("fixAll"),J.Notebook=J.Empty.append("notebook");let se=class{constructor(W,ve){if(this.range=W,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=se,e.SelectionRange=se=Ve([P],se);class we{constructor(W,ve,Le,qe,Ye,ot){this.kind=W,this.name=ve,this.detail=Le,this.uri=qe,this.range=Ye,this.selectionRange=ot}}e.CallHierarchyItem=we;class ke{constructor(W,ve){this.fromRanges=ve,this.from=W}}e.CallHierarchyIncomingCall=ke;class Ue{constructor(W,ve){this.fromRanges=ve,this.to=W}}e.CallHierarchyOutgoingCall=Ue;var He;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(He||(e.LanguageStatusSeverity=He={}));let Je=class{constructor(W,ve){this.range=W,this.command=ve}get isResolved(){return!!this.command}};e.CodeLens=Je,e.CodeLens=Je=Ve([P],Je);let Ge=o=class{#e;static isMarkdownString(W){return W instanceof o?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ve=!1){this.#e=new d.MarkdownString(W,{supportThemeIcons:ve})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,ve){return this.#e.appendCodeblock(ve??"",W),this}};e.MarkdownString=Ge,e.MarkdownString=Ge=o=Ve([P],Ge);let et=class{constructor(W,ve){this.label=W,this.documentation=ve}};e.ParameterInformation=et,e.ParameterInformation=et=Ve([P],et);let Qe=class{constructor(W,ve){this.label=W,this.documentation=ve,this.parameters=[]}};e.SignatureInformation=Qe,e.SignatureInformation=Qe=Ve([P],Qe);let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=st,e.SignatureHelp=st=Ve([P],st);var tt;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var Pe;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(Pe||(e.InlayHintKind=Pe={}));let _e=class{constructor(W){this.value=W}};e.InlayHintLabelPart=_e,e.InlayHintLabelPart=_e=Ve([P],_e);let ze=class{constructor(W,ve,Le){this.position=W,this.label=ve,this.kind=Le}};e.InlayHint=ze,e.InlayHint=ze=Ve([P],ze);var Y;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Y||(e.CompletionTriggerKind=Y={}));var Q;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(Q||(e.CompletionItemKind=Q={}));var Se;(function(V){V[V.Deprecated=1]="Deprecated"})(Se||(e.CompletionItemTag=Se={}));let Be=class{constructor(W,ve){this.label=W,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&Q[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Be,e.CompletionItem=Be=Ve([P],Be);let Me=class{constructor(W=[],ve=!1){this.items=W,this.isIncomplete=ve}};e.CompletionList=Me,e.CompletionList=Me=Ve([P],Me);let Xe=class{constructor(W,ve,Le){this.insertText=W,this.range=ve,this.command=Le}};e.InlineSuggestion=Xe,e.InlineSuggestion=Xe=Ve([P],Xe);let Ze=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.InlineSuggestionList=Ze,e.InlineSuggestionList=Ze=Ve([P],Ze);var rt;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var ft;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(ft||(e.StatusBarAlignment=ft={}));function wt(V,W){return`${k.ExtensionIdentifier.toKey(V)}.${W}`}e.asStatusBarItemIdentifier=wt;var Lt;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(Lt||(e.TextEditorLineNumbersStyle=Lt={}));var At;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(At||(e.TextDocumentSaveReason=At={}));var yt;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(yt||(e.TextEditorRevealType=yt={}));var Ft;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(Ft||(e.TextEditorSelectionChangeKind=Ft={}));var Ot;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(Ot||(e.TextDocumentChangeReason=Ot={}));var xt;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(xt||(e.DecorationRangeBehavior=xt={})),function(V){function W(ve){switch(ve){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=W}(Ft||(e.TextEditorSelectionChangeKind=Ft={}));let zt=class{constructor(W,ve){if(ve&&!v.URI.isUri(ve))throw(0,L.illegalArgument)("target");if(!B.isRange(W)||W.isEmpty)throw(0,L.illegalArgument)("range");this.range=W,this.target=ve}};e.DocumentLink=zt,e.DocumentLink=zt=Ve([P],zt);let Nt=class{constructor(W,ve,Le,qe){this.red=W,this.green=ve,this.blue=Le,this.alpha=qe}};e.Color=Nt,e.Color=Nt=Ve([P],Nt);let at=class{constructor(W,ve){if(ve&&!(ve instanceof Nt))throw(0,L.illegalArgument)("color");if(!B.isRange(W)||W.isEmpty)throw(0,L.illegalArgument)("range");this.range=W,this.color=ve}};e.ColorInformation=at,e.ColorInformation=at=Ve([P],at);let ht=class{constructor(W){if(!W||typeof W!="string")throw(0,L.illegalArgument)("label");this.label=W}};e.ColorPresentation=ht,e.ColorPresentation=ht=Ve([P],ht);var Wt;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(Wt||(e.ColorFormat=Wt={}));var Mt;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Mt||(e.SourceControlInputBoxValidationType=Mt={}));var Ct;(function(V){V[V.Unknown=0]="Unknown",V[V.Shutdown=1]="Shutdown",V[V.Process=2]="Process",V[V.User=3]="User",V[V.Extension=4]="Extension"})(Ct||(e.TerminalExitReason=Ct={}));class ct{constructor(W,ve,Le){if(this.startIndex=W,this.length=ve,this.tooltip=Le,typeof W!="number"||W<0)throw(0,L.illegalArgument)("startIndex");if(typeof ve!="number"||ve<1)throw(0,L.illegalArgument)("length");if(Le!==void 0&&typeof Le!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=ct;class Tt{constructor(W){this.uri=W}}e.TerminalQuickFixOpener=Tt;class Ut{constructor(W){this.terminalCommand=W}}e.TerminalQuickFixCommand=Ut;var Fe;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(Fe||(e.TerminalLocation=Fe={}));class Ae{constructor(W){if(this.options=W,typeof W!="object")throw(0,L.illegalArgument)("options")}}e.TerminalProfile=Ae;var Te;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(Te||(e.TaskRevealKind=Te={}));var ae;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(ae||(e.TaskPanelKind=ae={}));let Oe=class{static{g=this}static{this.Clean=new g("clean","Clean")}static{this.Build=new g("build","Build")}static{this.Rebuild=new g("rebuild","Rebuild")}static{this.Test=new g("test","Test")}static from(W){switch(W){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}constructor(W,ve){if(this.label=ve,typeof W!="string"||typeof ve!="string")throw(0,L.illegalArgument)("name");this._id=W}get id(){return this._id}};e.TaskGroup=Oe,e.TaskGroup=Oe=g=Ve([P],Oe);function We(V){let W="";for(let ve=0;ve<V.length;ve++)W+=V[ve].replace(/,/g,",,")+",";return W}let Ke=class{constructor(W,ve,Le){if(typeof W!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=W,ve!==void 0&&(Array.isArray(ve)?(this._args=ve,this._options=Le):this._options=ve)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,L.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const ve of this._args)W.push(ve);return We(W)}};e.ProcessExecution=Ke,e.ProcessExecution=Ke=Ve([P],Ke);let je=class{constructor(W,ve,Le){if(this._args=[],Array.isArray(ve)){if(!W)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,L.illegalArgument)("command");this._command=W,this._args=ve,this._options=Le}else{if(typeof W!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=W,this._options=ve}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,L.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ve of this._args)W.push(typeof ve=="string"?ve:ve.value);return We(W)}};e.ShellExecution=je,e.ShellExecution=je=Ve([P],je);var it;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(it||(e.ShellQuoting=it={}));var Et;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(Et||(e.TaskScope=Et={}));class Dt{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Dt;let It=class{static{l=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(W,ve,Le,qe,Ye,ot){this.__deprecated=!1,this._definition=this.definition=W;let ut;typeof ve=="string"?(this._name=this.name=ve,this._source=this.source=Le,this.execution=qe,ut=Ye,this.__deprecated=!0):ve===Et.Global||ve===Et.Workspace?(this.target=ve,this._name=this.name=Le,this._source=this.source=qe,this.execution=Ye,ut=ot):(this.target=ve,this._name=this.name=Le,this._source=this.source=qe,this.execution=Ye,ut=ot),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ke?this._definition={type:l.ProcessType,id:this._execution.computeId()}:this._execution instanceof je?this._definition={type:l.ShellType,id:this._execution.computeId()}:this._execution instanceof Dt?this._definition={type:l.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:l.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const ve=this._definition.type;(l.EmptyType===ve||l.ProcessType===ve||l.ShellType===ve||l.ExtensionCallbackType===ve)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};e.Task=It,e.Task=It=l=Ve([P],It);var bt;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(bt||(e.ProgressLocation=bt={}));var pt;(function(V){function W(ve){const Le=ve;return(0,y.isNumber)(Le.value)?Le.tooltip&&!(0,y.isString)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}V.isViewBadge=W})(pt||(e.ViewBadge=pt={}));let dt=h=class{static isTreeItem(W,ve){const Le=W;if(Le.checkboxState!==void 0){const qe=(0,y.isNumber)(Le.checkboxState)?Le.checkboxState:(0,y.isObject)(Le.checkboxState)&&(0,y.isNumber)(Le.checkboxState.state)?Le.checkboxState.state:void 0,Ye=!(0,y.isNumber)(Le.checkboxState)&&(0,y.isObject)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(qe===void 0||qe!==gt.Checked&&qe!==gt.Unchecked||Ye!==void 0&&!(0,y.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(W instanceof h)return!0;if(Le.label!==void 0&&!(0,y.isString)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,y.isString)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,y.isString)(Le.iconPath)&&!v.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,y.isString)(Le.iconPath.id))){const qe=Le.iconPath;if(!qe||!(0,y.isString)(qe.light)&&!v.URI.isUri(qe.light)&&!(0,y.isString)(qe.dark)&&!v.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,y.isString)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!v.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,y.isString)(Le.tooltip)&&!(Le.tooltip instanceof Ge)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<vt.None&&Le.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,y.isString)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(W,ve=vt.None){this.collapsibleState=ve,v.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.TreeItem=dt,e.TreeItem=dt=h=Ve([P],dt);var vt;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var gt;(function(V){V[V.Unchecked=0]="Unchecked",V[V.Checked=1]="Checked"})(gt||(e.TreeItemCheckboxState=gt={}));let Qt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.DataTransferItem=Qt,e.DataTransferItem=Qt=Ve([P],Qt);class $t extends Qt{}e.InternalDataTransferItem=$t;class Yi extends $t{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.InternalFileDataTransferItem=Yi;class di{constructor(W,ve,Le,qe){this.name=W,this.uri=ve,this._itemId=Le,this._getData=qe}data(){return this._getData()}}e.DataTransferFile=di;let hi=class{#e=new Map;constructor(W){for(const[ve,Le]of W??[]){const qe=this.#e.get(this.#t(ve));qe?qe.push(Le):this.#e.set(this.#t(ve),[Le])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,ve){this.#e.set(this.#t(W),[ve])}forEach(W,ve){for(const[Le,qe]of this.#e)for(const Ye of qe)W.call(ve,Ye,Le,this)}*[Symbol.iterator](){for(const[W,ve]of this.#e)for(const Le of ve)yield[W,Le]}#t(W){return W.toLowerCase()}};e.DataTransfer=hi,e.DataTransfer=hi=Ve([P],hi);let kt=class{constructor(W){this.insertText=W}};e.DocumentDropEdit=kt,e.DocumentDropEdit=kt=Ve([P],kt);let Si=class{constructor(W,ve,Le){this.id=ve,this.label=Le,this.insertText=W}};e.DocumentPasteEdit=Si,e.DocumentPasteEdit=Si=Ve([P],Si);let jt=class{constructor(W,ve){this.id=W,this.color=ve}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.ThemeIcon=jt,e.ThemeIcon=jt=Ve([P],jt),jt.File=new jt("file"),jt.Folder=new jt("folder");let _t=class{constructor(W){this.id=W}};e.ThemeColor=_t,e.ThemeColor=_t=Ve([P],_t);var yi;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(yi||(e.ConfigurationTarget=yi={}));let fi=class{get base(){return this._base}set base(W){this._base=W,this._baseUri=v.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}constructor(W,ve){if(typeof W!="string"&&(!W||!v.URI.isUri(W)&&!v.URI.isUri(W.uri)))throw(0,L.illegalArgument)("base");if(typeof ve!="string")throw(0,L.illegalArgument)("pattern");typeof W=="string"?this.baseUri=v.URI.file(W):v.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=fi,e.RelativePattern=fi=Ve([P],fi);const ai=new WeakMap;function Ji(V,W){ai.set(V,W)}e.setBreakpointId=Ji;let ni=class{constructor(W,ve,Le,qe){this.enabled=typeof W=="boolean"?W:!0,typeof ve=="string"&&(this.condition=ve),typeof Le=="string"&&(this.hitCondition=Le),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=ai.get(this)??(0,R.generateUuid)()),this._id}};e.Breakpoint=ni,e.Breakpoint=ni=Ve([P],ni);let Rt=class extends ni{constructor(W,ve,Le,qe,Ye){if(super(ve,Le,qe,Ye),W===null)throw(0,L.illegalArgument)("location");this.location=W}};e.SourceBreakpoint=Rt,e.SourceBreakpoint=Rt=Ve([P],Rt);let mi=class extends ni{constructor(W,ve,Le,qe,Ye){super(ve,Le,qe,Ye),this.functionName=W}};e.FunctionBreakpoint=mi,e.FunctionBreakpoint=mi=Ve([P],mi);let _i=class extends ni{constructor(W,ve,Le,qe,Ye,ot,ut){if(super(qe,Ye,ot,ut),!ve)throw(0,L.illegalArgument)("dataId");this.label=W,this.dataId=ve,this.canPersist=Le}};e.DataBreakpoint=_i,e.DataBreakpoint=_i=Ve([P],_i);let ri=class{constructor(W,ve,Le){this.command=W,this.args=ve||[],this.options=Le}};e.DebugAdapterExecutable=ri,e.DebugAdapterExecutable=ri=Ve([P],ri);let si=class{constructor(W,ve){this.port=W,this.host=ve}};e.DebugAdapterServer=si,e.DebugAdapterServer=si=Ve([P],si);let lt=class{constructor(W){this.path=W}};e.DebugAdapterNamedPipeServer=lt,e.DebugAdapterNamedPipeServer=lt=Ve([P],lt);let Ci=class{constructor(W){this.implementation=W}};e.DebugAdapterInlineImplementation=Ci,e.DebugAdapterInlineImplementation=Ci=Ve([P],Ci);let qt=class{constructor(W,ve,Le){this.session=W,this.threadId=ve,this.frameId=Le}};e.StackFrameFocus=qt,e.StackFrameFocus=qt=Ve([P],qt);let Zt=class{constructor(W,ve){this.session=W,this.threadId=ve}};e.ThreadFocus=Zt,e.ThreadFocus=Zt=Ve([P],Zt);let gi=class{constructor(W,ve){this.range=W,this.expression=ve}};e.EvaluatableExpression=gi,e.EvaluatableExpression=gi=Ve([P],gi);var xi;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(xi||(e.InlineCompletionTriggerKind=xi={}));let Di=class{constructor(W,ve){this.range=W,this.text=ve}};e.InlineValueText=Di,e.InlineValueText=Di=Ve([P],Di);let Ii=class{constructor(W,ve,Le=!0){this.range=W,this.variableName=ve,this.caseSensitiveLookup=Le}};e.InlineValueVariableLookup=Ii,e.InlineValueVariableLookup=Ii=Ve([P],Ii);let pi=class{constructor(W,ve){this.range=W,this.expression=ve}};e.InlineValueEvaluatableExpression=pi,e.InlineValueEvaluatableExpression=pi=Ve([P],pi);let ki=class{constructor(W,ve){this.frameId=W,this.stoppedLocation=ve}};e.InlineValueContext=ki,e.InlineValueContext=ki=Ve([P],ki);var Pi;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Pi||(e.FileChangeType=Pi={}));let ei=w=class extends Error{static FileExists(W){return new w(W,p.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(W){return new w(W,p.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(W){return new w(W,p.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(W){return new w(W,p.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(W){return new w(W,p.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(W){return new w(W,p.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}constructor(W,ve=p.FileSystemProviderErrorCode.Unknown,Le){super(v.URI.isUri(W)?W.toString(!0):W),this.code=Le?.name??"Unknown",(0,p.markAsFileSystemProviderError)(this,ve),Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.FileSystemError=ei,e.FileSystemError=ei=w=Ve([P],ei);let Ti=class{constructor(W,ve,Le){this.start=W,this.end=ve,this.kind=Le}};e.FoldingRange=Ti,e.FoldingRange=Ti=Ve([P],Ti);var vi;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(vi||(e.FoldingRangeKind=vi={}));var bi;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(bi||(e.CommentThreadCollapsibleState=bi={}));var Ui;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(Ui||(e.CommentMode=Ui={}));var Bi;(function(V){V[V.Published=0]="Published",V[V.Draft=1]="Draft"})(Bi||(e.CommentState=Bi={}));var oi;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(oi||(e.CommentThreadState=oi={}));class Zi{constructor(W,ve=[]){this.tokenTypes=W,this.tokenModifiers=ve}}e.SemanticTokensLegend=Zi;function en(V){return typeof V>"u"||(0,y.isStringArray)(V)}class Ai{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let ve=0,Le=W.tokenTypes.length;ve<Le;ve++)this._tokenTypeStrToInt.set(W.tokenTypes[ve],ve);for(let ve=0,Le=W.tokenModifiers.length;ve<Le;ve++)this._tokenModifierStrToInt.set(W.tokenModifiers[ve],ve)}}push(W,ve,Le,qe,Ye){if(typeof W=="number"&&typeof ve=="number"&&typeof Le=="number"&&typeof qe=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this._pushEncoded(W,ve,Le,qe,Ye);if(B.isRange(W)&&typeof ve=="string"&&en(Le))return this._push(W,ve,Le);throw(0,L.illegalArgument)()}_push(W,ve,Le){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ve))throw new Error("`tokenType` is not in the provided legend");const qe=W.start.line,Ye=W.start.character,ot=W.end.character-W.start.character,ut=this._tokenTypeStrToInt.get(ve);let Bt=0;if(Le)for(const Vt of Le){if(!this._tokenModifierStrToInt.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const Xt=this._tokenModifierStrToInt.get(Vt);Bt|=1<<Xt>>>0}this._pushEncoded(qe,Ye,ot,ut,Bt)}_pushEncoded(W,ve,Le,qe,Ye){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&ve<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Bt=this._data.length/5|0;let Vt=0,Xt=0;for(let Jt=0;Jt<Bt;Jt++){let ti=this._data[5*Jt],Ni=this._data[5*Jt+1];ti===0?(ti=Vt,Ni+=Xt):ti+=Vt,this._data[5*Jt]=ti,this._data[5*Jt+1]=Ni,Vt=ti,Xt=Ni}}let ot=W,ut=ve;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Le,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Ye,this._prevLine=W,this._prevChar=ve}static _sortAndDeltaEncode(W){const ve=[],Le=W.length/5|0;for(let ut=0;ut<Le;ut++)ve[ut]=ut;ve.sort((ut,Bt)=>{const Vt=W[5*ut],Xt=W[5*Bt];if(Vt===Xt){const Jt=W[5*ut+1],ti=W[5*Bt+1];return Jt-ti}return Vt-Xt});const qe=new Uint32Array(W.length);let Ye=0,ot=0;for(let ut=0;ut<Le;ut++){const Bt=5*ve[ut],Vt=W[Bt+0],Xt=W[Bt+1],Jt=W[Bt+2],ti=W[Bt+3],Ni=W[Bt+4],Sn=Vt-Ye,Mn=Sn===0?Xt-ot:Xt,Mi=5*ut;qe[Mi+0]=Sn,qe[Mi+1]=Mn,qe[Mi+2]=Jt,qe[Mi+3]=ti,qe[Mi+4]=Ni,Ye=Vt,ot=Xt}return qe}build(W){return this._dataIsSortedAndDeltaEncoded?new Yt(new Uint32Array(this._data),W):new Yt(Ai._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=Ai;class Yt{constructor(W,ve){this.resultId=ve,this.data=W}}e.SemanticTokens=Yt;class tn{constructor(W,ve,Le){this.start=W,this.deleteCount=ve,this.data=Le}}e.SemanticTokensEdit=tn;class nn{constructor(W,ve){this.resultId=ve,this.edits=W}}e.SemanticTokensEdits=nn;var Ri;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(Ri||(e.DebugConsoleMode=Ri={}));let Li=class{static{this.Back={iconPath:new jt("arrow-left")}}constructor(){}};e.QuickInputButtons=Li,e.QuickInputButtons=Li=Ve([P],Li);var zi;(function(V){V[V.Separator=-1]="Separator",V[V.Default=0]="Default"})(zi||(e.QuickPickItemKind=zi={}));var Wi;(function(V){V[V.Info=1]="Info",V[V.Warning=2]="Warning",V[V.Error=3]="Error"})(Wi||(e.InputBoxValidationSeverity=Wi={}));var Ei;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(Ei||(e.ExtensionKind=Ei={}));class $i{static validate(W){if(typeof W.badge=="string"){let ve=(0,m.nextCharLength)(W.badge,0);if(ve<W.badge.length&&(ve+=(0,m.nextCharLength)(W.badge,ve)),W.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!jt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ve,Le){this.badge=W,this.tooltip=ve,this.color=Le}}e.FileDecoration=$i;let xe=class{constructor(W){this.kind=W}};e.ColorTheme=xe,e.ColorTheme=xe=Ve([P],xe);var Gt;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast",V[V.HighContrastLight=4]="HighContrastLight"})(Gt||(e.ColorThemeKind=Gt={}));class Kt{static isNotebookRange(W){return W instanceof Kt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(W,ve){if(W<0)throw(0,L.illegalArgument)("start must be positive");if(ve<0)throw(0,L.illegalArgument)("end must be positive");W<=ve?(this._start=W,this._end=ve):(this._start=ve,this._end=W)}with(W){let ve=this._start,Le=this._end;return W.start!==void 0&&(ve=W.start),W.end!==void 0&&(Le=W.end),ve===this._start&&Le===this._end?this:new Kt(ve,Le)}}e.NotebookRange=Kt;class mt{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ve=>mt.isNotebookCellData(ve))}static isNotebookCellData(W){return!0}constructor(W,ve,Le,qe,Ye,ot,ut){this.kind=W,this.value=ve,this.languageId=Le,this.mime=qe,this.outputs=Ye??[],this.metadata=ot,this.executionSummary=ut,mt.validate(this)}}e.NotebookCellData=mt;class rn{constructor(W){this.cells=W}}e.NotebookData=rn;class Ht{static isNotebookCellOutputItem(W){return W instanceof Ht?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ve={name:W.name,message:W.message,stack:W.stack};return Ht.json(ve,"application/vnd.code.notebook.error")}static stdout(W){return Ht.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Ht.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ve="application/octet-stream"){return new Ht(W,ve)}static#e=new TextEncoder;static text(W,ve=T.Mimes.text){const Le=Ht.#e.encode(String(W));return new Ht(Le,ve)}static json(W,ve="text/x-json"){const Le=JSON.stringify(W,void 0,"	");return Ht.text(Le,ve)}constructor(W,ve){this.data=W,this.mime=ve;const Le=(0,T.normalizeMimeType)(ve,!0);if(!Le)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.NotebookCellOutputItem=Ht;class ci{static isNotebookCellOutput(W){return W instanceof ci?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ve=!1){const Le=new Set,qe=new Set;for(let Ye=0;Ye<W.length;Ye++){const ot=W[Ye],ut=(0,T.normalizeMimeType)(ot.mime);if(!Le.has(ut)||(0,D.isTextStreamMime)(ut)){Le.add(ut);continue}qe.add(Ye),ve&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return qe.size===0?W:W.filter((Ye,ot)=>!qe.has(ot))}constructor(W,ve,Le){this.items=ci.ensureUniqueMimeTypes(W,!0),typeof ve=="string"?(this.id=ve,this.metadata=Le):(this.id=(0,R.generateUuid)(),this.metadata=ve??Le)}}e.NotebookCellOutput=ci;var Hi;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(Hi||(e.NotebookCellKind=Hi={}));var li;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(li||(e.NotebookCellExecutionState=li={}));var Vi;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(Vi||(e.NotebookCellStatusBarAlignment=Vi={}));var ji;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(ji||(e.NotebookEditorRevealType=ji={}));class sn{constructor(W,ve){this.text=W,this.alignment=ve}}e.NotebookCellStatusBarItem=sn;var Fi;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(Fi||(e.NotebookControllerAffinity=Fi={}));var qi;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred",V[V.Hidden=-1]="Hidden"})(qi||(e.NotebookControllerAffinity2=qi={}));class on{constructor(W,ve=[]){this.uri=W,this.provides=(0,_.asArray)(ve)}}e.NotebookRendererScript=on;class an{constructor(W){this.label=W}}e.NotebookKernelSourceAction=an;let Oi=class{constructor(W,ve){this.label=W,this.timestamp=ve}};e.TimelineItem=Oi,e.TimelineItem=Oi=Ve([P],Oi);var Gi;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(Gi||(e.ExtensionMode=Gi={}));var Ki;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(Ki||(e.ExtensionRuntime=Ki={}));var Xi;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(Xi||(e.StandardTokenType=Xi={}));class cn{constructor(W,ve){this.ranges=W,this.wordPattern=ve}}e.LinkedEditingRanges=cn;class ln{constructor(W){this._autoForwardAction=W}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ln;var pe;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(pe||(e.TestResultState=pe={}));var Ce;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(Ce||(e.TestRunProfileKind=Ce={}));let Ne=class{constructor(W=void 0,ve=void 0,Le=void 0,qe=!1){this.include=W,this.exclude=ve,this.profile=Le,this.continuous=qe}};e.TestRunRequest=Ne,e.TestRunRequest=Ne=Ve([P],Ne);let nt=class extends Ne{};e.TestRunRequest2=nt,e.TestRunRequest2=nt=Ve([P],nt);let St=u=class{static diff(W,ve,Le){const qe=new u(W);return qe.expectedOutput=ve,qe.actualOutput=Le,qe}constructor(W){this.message=W}};e.TestMessage=St,e.TestMessage=St=u=Ve([P],St);let Pt=class{constructor(W){this.id=W}};e.TestTag=Pt,e.TestTag=Pt=Ve([P],Pt);let wi=class{constructor(W,ve){this.covered=W,this.total=ve}};e.CoveredCount=wi,e.CoveredCount=wi=Ve([P],wi);let un=E=class{static fromDetails(W,ve){const Le=new wi(0,0),qe=new wi(0,0),Ye=new wi(0,0);for(const ut of ve)if("branches"in ut){Le.total+=1,Le.covered+=ut.executionCount>0?1:0;for(const Bt of ut.branches)qe.total+=1,qe.covered+=Bt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=ut.executionCount>0?1:0;const ot=new E(W,Le,qe.total>0?qe:void 0,Ye.total>0?Ye:void 0);return ot.detailedCoverage=ve,ot}constructor(W,ve,Le,qe){this.uri=W,this.statementCoverage=ve,this.branchCoverage=Le,this.functionCoverage=qe}};e.FileCoverage=un,e.FileCoverage=un=E=Ve([P],un);let dn=class{constructor(W,ve,Le=[]){this.executionCount=W,this.location=ve,this.branches=Le}};e.StatementCoverage=dn,e.StatementCoverage=dn=Ve([P],dn);let hn=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.BranchCoverage=hn,e.BranchCoverage=hn=Ve([P],hn);let fn=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.FunctionCoverage=fn,e.FunctionCoverage=fn=Ve([P],fn);var gn;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(gn||(e.ExternalUriOpenerPriority=gn={}));var pn;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(pn||(e.WorkspaceTrustState=pn={}));var vn;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(vn||(e.PortAutoForwardAction=vn={}));class In{constructor(W,ve,Le,qe,Ye,ot){this.kind=W,this.name=ve,this.detail=Le,this.uri=qe,this.range=Ye,this.selectionRange=ot}}e.TypeHierarchyItem=In;class kn{constructor(W){this.uri=W}}e.TextTabInput=kn;class Pn{constructor(W,ve){this.original=W,this.modified=ve}}e.TextDiffTabInput=Pn;class Tn{constructor(W,ve,Le,qe){this.base=W,this.input1=ve,this.input2=Le,this.result=qe}}e.TextMergeTabInput=Tn;class An{constructor(W,ve){this.uri=W,this.viewType=ve}}e.CustomEditorTabInput=An;class Rn{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=Rn;class Ln{constructor(W,ve){this.uri=W,this.notebookType=ve}}e.NotebookEditorTabInput=Ln;class Fn{constructor(W,ve,Le){this.original=W,this.modified=ve,this.notebookType=Le}}e.NotebookDiffEditorTabInput=Fn;class On{constructor(){}}e.TerminalEditorTabInput=On;class Nn{constructor(W,ve){this.uri=W,this.inputBoxUri=ve}}e.InteractiveWindowInput=Nn;var bn;(function(V){V[V.Up=1]="Up",V[V.Down=2]="Down"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var En;(function(V){V[V.Action=1]="Action",V[V.Toolbar=2]="Toolbar"})(En||(e.InteractiveSessionCopyKind=En={}));var wn;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful",V[V.Undone=2]="Undone",V[V.Accepted=3]="Accepted"})(wn||(e.InteractiveEditorResponseFeedbackKind=wn={}))}),define(De[135],Ie([1,0,53,15,12,164,116,7,19]),function(me,e,_,L,d,A,T,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const v=new Map;function R(D,b){b?v.set(D,b):v.delete(D)}e.setWordDefinitionFor=R;function k(D){return v.get(D)}class p extends A.MirrorTextModel{constructor(b,r,s,c,f,S,I,i){super(r,s,c,f),this._proxy=b,this._languageId=S,this._isDirty=I,this.notebook=i,this._isDisposed=!1}dispose(){(0,_.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(b){return(0,y.equals)(this._lines,b)}get document(){if(!this._document){const b=this;this._document={get uri(){return b._uri},get fileName(){return b._uri.fsPath},get isUntitled(){return b._uri.scheme===L.Schemas.untitled},get languageId(){return b._languageId},get version(){return b._versionId},get isClosed(){return b._isDisposed},get isDirty(){return b._isDirty},save(){return b._save()},getText(r){return r?b._getTextInRange(r):b.getText()},get eol(){return b._eol===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return b._lines.length},lineAt(r){return b._lineAt(r)},offsetAt(r){return b._offsetAt(r)},positionAt(r){return b._positionAt(r)},validateRange(r){return b._validateRange(r)},validatePosition(r){return b._validatePosition(r)},getWordRangeAtPosition(r,s){return b._getWordRangeAtPosition(r,s)}}}return Object.freeze(this._document)}_acceptLanguageId(b){(0,_.ok)(!this._isDisposed),this._languageId=b}_acceptIsDirty(b){(0,_.ok)(!this._isDisposed),this._isDirty=b}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(b){const r=this._validateRange(b);if(r.isEmpty)return"";if(r.isSingleLine)return this._lines[r.start.line].substring(r.start.character,r.end.character);const s=this._eol,c=r.start.line,f=r.end.line,S=[];S.push(this._lines[c].substring(r.start.character));for(let I=c+1;I<f;I++)S.push(this._lines[I]);return S.push(this._lines[f].substring(0,r.end.character)),S.join(s)}_lineAt(b){let r;if(b instanceof m.Position?r=b.line:typeof b=="number"&&(r=b),typeof r!="number"||r<0||r>=this._lines.length||Math.floor(r)!==r)throw new Error("Illegal value for `line`");return new C(r,this._lines[r],r===this._lines.length-1)}_offsetAt(b){return b=this._validatePosition(b),this._ensureLineStarts(),this._lineStarts.getPrefixSum(b.line-1)+b.character}_positionAt(b){b=Math.floor(b),b=Math.max(0,b),this._ensureLineStarts();const r=this._lineStarts.getIndexOf(b),s=this._lines[r.index].length;return new m.Position(r.index,Math.min(r.remainder,s))}_validateRange(b){if(!(b instanceof m.Range))throw new Error("Invalid argument");const r=this._validatePosition(b.start),s=this._validatePosition(b.end);return r===b.start&&s===b.end?b:new m.Range(r.line,r.character,s.line,s.character)}_validatePosition(b){if(!(b instanceof m.Position))throw new Error("Invalid argument");if(this._lines.length===0)return b.with(0,0);let{line:r,character:s}=b,c=!1;if(r<0)r=0,s=0,c=!0;else if(r>=this._lines.length)r=this._lines.length-1,s=this._lines[r].length,c=!0;else{const f=this._lines[r].length;s<0?(s=0,c=!0):s>f&&(s=f,c=!0)}return c?new m.Position(r,s):b}_getWordRangeAtPosition(b,r){const s=this._validatePosition(b);if(!r)r=k(this._languageId);else if((0,d.regExpLeadsToEndlessLoop)(r))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${r.source}' because it matches the empty string.`);const c=(0,T.getWordAtText)(s.character+1,(0,T.ensureValidWordDefinition)(r),this._lines[s.line],0);if(c)return new m.Range(s.line,c.startColumn-1,s.line,c.endColumn-1)}}e.ExtHostDocumentData=p;class C{constructor(b,r,s){this._line=b,this._text=r,this._isLastLine=s}get lineNumber(){return this._line}get text(){return this._text}get range(){return new m.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new m.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=C}),define(De[259],Ie([1,0,7,20,3]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(m){this._actual=new _.ColorTheme(_.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new d.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(m){let y;switch(m){case"light":y=_.ColorThemeKind.Light;break;case"hcDark":y=_.ColorThemeKind.HighContrast;break;case"hcLight":y=_.ColorThemeKind.HighContrastLight;break;default:y=_.ColorThemeKind.Dark}this._actual=new _.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=A,e.ExtHostTheming=A=Ve([$e(0,L.IExtHostRpcService)],A)}),define(De[260],Ie([1,0,5]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(d){d[d.Output=1]="Output",d[d.OutputItems=2]="OutputItems",d[d.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.INotebookExecutionService=(0,_.createDecorator)("INotebookExecutionService")}),define(De[59],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var _;(function(A){A.Delimiter="\0"})(_||(e.TestIdPathParts=_={}));var L;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class d{static fromExtHostTestItem(T,m,y=T.parent){if(T._isRoot)return new d([m]);const v=[T.id];for(let R=y;R&&R.id!==m;R=R.parent)v.push(R.id);return v.push(m),new d(v.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const m=T.indexOf("\0");return m===-1?T:T.slice(0,m)}static fromString(T){return new d(T.split("\0"))}static join(T,m){return new d([...T.path,m])}static joinToString(T,m){return T.toString()+"\0"+m}static parentId(T){const m=T.lastIndexOf("\0");return m===-1?void 0:T.slice(0,m)}static localId(T){const m=T.lastIndexOf("\0");return m===-1?T:T.slice(m+1)}static isChild(T,m){return m.startsWith(T)&&m[T.length]==="\0"}static compare(T,m){return T===m?0:d.isChild(T,m)?2:d.isChild(m,T)?3:1}constructor(T,m=T.length){if(this.path=T,this.viewEnd=m,T.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new d(this.path,1)}get parentId(){return this.viewEnd>1?new d(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new d(this.path,T)}*idsToRoot(){for(let T=this.viewEnd;T>0;T--)yield new d(this.path,T)}compare(T){if(typeof T=="string")return d.compare(this.toString(),T);for(let m=0;m<T.viewEnd&&m<this.viewEnd;m++)if(T.path[m]!==this.path[m])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=d}),define(De[82],Ie([1,0,2,33,59]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(h){h[h.Unset=0]="Unset",h[h.Queued=1]="Queued",h[h.Running=2]="Running",h[h.Passed=3]="Passed",h[h.Failed=4]="Failed",h[h.Skipped=5]="Skipped",h[h.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var T;(function(h){h[h.Run=1]="Run",h[h.Debug=2]="Debug",h[h.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var m;(function(h){h[h.Run=2]="Run",h[h.Debug=4]="Debug",h[h.Coverage=8]="Coverage",h[h.HasNonDefaultProfile=16]="HasNonDefaultProfile",h[h.HasConfigurable=32]="HasConfigurable",h[h.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const y=h=>"runId"in h;e.isStartControllerTests=y;var v;(function(h){h.serialize=w=>({range:w.range.toJSON(),uri:w.uri.toJSON()}),h.deserialize=w=>({range:L.Range.lift(w.range),uri:_.URI.revive(w.uri)})})(v||(e.IRichLocation=v={}));var R;(function(h){h[h.Error=0]="Error",h[h.Output=1]="Output"})(R||(e.TestMessageType=R={}));var k;(function(h){h.serialize=w=>({message:w.message,type:0,expected:w.expected,actual:w.actual,location:w.location&&v.serialize(w.location)}),h.deserialize=w=>({message:w.message,type:0,expected:w.expected,actual:w.actual,location:w.location&&v.deserialize(w.location)})})(k||(e.ITestErrorMessage=k={}));const p=(h,w)=>`${w?"s":"e"}${h}`;e.getMarkId=p;var C;(function(h){h.serialize=w=>({message:w.message,type:1,offset:w.offset,length:w.length,location:w.location&&v.serialize(w.location)}),h.deserialize=w=>({message:w.message,type:1,offset:w.offset,length:w.length,location:w.location&&v.deserialize(w.location)})})(C||(e.ITestOutputMessage=C={}));var D;(function(h){h.serialize=w=>w.type===0?k.serialize(w):C.serialize(w),h.deserialize=w=>w.type===0?k.deserialize(w):C.deserialize(w)})(D||(e.ITestMessage=D={}));var b;(function(h){h.serializeWithoutMessages=w=>({state:w.state,duration:w.duration,messages:[]}),h.serialize=w=>({state:w.state,duration:w.duration,messages:w.messages.map(D.serialize)}),h.deserialize=w=>({state:w.state,duration:w.duration,messages:w.messages.map(D.deserialize)})})(b||(e.ITestTaskState=b={}));const r="\0",s=(h,w)=>h+r+w;e.namespaceTestTag=s;const c=h=>{const w=h.indexOf(r);return{ctrlId:h.slice(0,w),tagId:h.slice(w+1)}};e.denamespaceTestTag=c;var f;(function(h){h.serialize=w=>({extId:w.extId,label:w.label,tags:w.tags,busy:w.busy,children:void 0,uri:w.uri?.toJSON(),range:w.range?.toJSON()||null,description:w.description,error:w.error,sortText:w.sortText}),h.deserialize=w=>({extId:w.extId,label:w.label,tags:w.tags,busy:w.busy,children:void 0,uri:w.uri?_.URI.revive(w.uri):void 0,range:w.range?L.Range.lift(w.range):null,description:w.description,error:w.error,sortText:w.sortText})})(f||(e.ITestItem=f={}));var S;(function(h){h[h.NotExpandable=0]="NotExpandable",h[h.Expandable=1]="Expandable",h[h.BusyExpanding=2]="BusyExpanding",h[h.Expanded=3]="Expanded"})(S||(e.TestItemExpandState=S={}));var I;(function(h){h.serialize=w=>({expand:w.expand,item:f.serialize(w.item)}),h.deserialize=w=>({controllerId:d.TestId.root(w.item.extId),expand:w.expand,item:f.deserialize(w.item)})})(I||(e.InternalTestItem=I={}));var i;(function(h){h.serialize=w=>{let u;return w.item&&(u={},w.item.label!==void 0&&(u.label=w.item.label),w.item.tags!==void 0&&(u.tags=w.item.tags),w.item.busy!==void 0&&(u.busy=w.item.busy),w.item.uri!==void 0&&(u.uri=w.item.uri?.toJSON()),w.item.range!==void 0&&(u.range=w.item.range?.toJSON()),w.item.description!==void 0&&(u.description=w.item.description),w.item.error!==void 0&&(u.error=w.item.error),w.item.sortText!==void 0&&(u.sortText=w.item.sortText)),{extId:w.extId,expand:w.expand,item:u}},h.deserialize=w=>{let u;return w.item&&(u={},w.item.label!==void 0&&(u.label=w.item.label),w.item.tags!==void 0&&(u.tags=w.item.tags),w.item.busy!==void 0&&(u.busy=w.item.busy),w.item.range!==void 0&&(u.range=w.item.range?L.Range.lift(w.item.range):null),w.item.description!==void 0&&(u.description=w.item.description),w.item.error!==void 0&&(u.error=w.item.error),w.item.sortText!==void 0&&(u.sortText=w.item.sortText)),{extId:w.extId,expand:w.expand,item:u}}})(i||(e.ITestItemUpdate=i={}));const a=(h,w)=>{w.expand!==void 0&&(h.expand=w.expand),w.item!==void 0&&(h.item=h.item?Object.assign(h.item,w.item):w.item)};e.applyTestItemUpdate=a;var n;(function(h){h.serializeWithoutMessages=w=>({...I.serialize(w),ownComputedState:w.ownComputedState,computedState:w.computedState,tasks:w.tasks.map(b.serializeWithoutMessages)}),h.serialize=w=>({...I.serialize(w),ownComputedState:w.ownComputedState,computedState:w.computedState,tasks:w.tasks.map(b.serialize)}),h.deserialize=w=>({...I.deserialize(w),ownComputedState:w.ownComputedState,computedState:w.computedState,tasks:w.tasks.map(b.deserialize),retired:!0})})(n||(e.TestResultItem=n={}));var t;(function(h){h[h.Function=0]="Function",h[h.Statement=1]="Statement"})(t||(e.DetailType=t={}));var o;(function(h){h[h.Add=0]="Add",h[h.Update=1]="Update",h[h.DocumentSynced=2]="DocumentSynced",h[h.Remove=3]="Remove",h[h.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",h[h.Retire=5]="Retire",h[h.AddTag=6]="AddTag",h[h.RemoveTag=7]="RemoveTag"})(o||(e.TestDiffOpType=o={}));var g;(function(h){h.deserialize=w=>w.op===0?{op:w.op,item:I.deserialize(w.item)}:w.op===1?{op:w.op,item:i.deserialize(w.item)}:w.op===2?{op:w.op,uri:_.URI.revive(w.uri),docv:w.docv}:w,h.serialize=w=>w.op===0?{op:w.op,item:I.serialize(w.item)}:w.op===1?{op:w.op,item:i.serialize(w.item)}:w})(g||(e.TestsDiffOp=g={}));class l{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(w){const u=this.createChangeCollector();for(const E of w)switch(E.op){case 0:this.add(I.deserialize(E.item),u);break;case 1:this.update(i.deserialize(E.item),u);break;case 3:this.remove(E.itemId,u);break;case 5:this.retireTest(E.itemId);break;case 4:this.updatePendingRoots(E.amount);break;case 6:this._tags.set(E.tag.id,E.tag);break;case 7:this._tags.delete(E.id);break}u.complete?.()}add(w,u){const E=d.TestId.parentId(w.item.extId)?.toString();let P;if(!E)P=this.createItem(w),this.roots.add(P),this.items.set(w.item.extId,P);else if(this.items.has(E)){const O=this.items.get(E);O.children.add(w.item.extId),P=this.createItem(w,O),this.items.set(w.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(w)}`);return}return u.add?.(P),w.expand===2&&this.busyControllerCount++,P}update(w,u){const E=this.items.get(w.extId);if(E)return w.expand!==void 0&&(E.expand===2&&this.busyControllerCount--,w.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(E,w),u.update?.(E),E}remove(w,u){const E=this.items.get(w);if(!E)return;const P=d.TestId.parentId(E.item.extId)?.toString();P?this.items.get(P).children.delete(E.item.extId):this.roots.delete(E);const O=[[w]];for(;O.length;)for(const N of O.pop()){const F=this.items.get(N);F&&(O.push(F.children),this.items.delete(N),u.remove?.(F,F!==E),F.expand===2&&this.busyControllerCount--)}}retireTest(w){}updatePendingRoots(w){this.pendingRootCount+=w}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=l}),define(De[103],Ie([1,0,17,3,4,53,82,59]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const v=(c,f)=>c===f,k=Object.entries({range:(c,f)=>c===f?!0:!c||!f?!1:c.equalsRange(f),busy:v,label:v,description:v,error:v,sortText:v,tags:(c,f)=>!(c.length!==f.length||c.some(S=>!f.includes(S)))}),p=(c,f)=>{let S;for(const[I,i]of k)i(c[I],f[I])||(S?S[I]=f[I]:S={[I]:f[I]});return S};class C extends d.Disposable{get root(){return this.options.root}constructor(f){super(),this.options=f,this.debounceSendDiff=this._register(new _.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(f){this._resolveHandler=f;for(const S of this.tree.values())this.updateExpandability(S)}get resolveHandler(){return this._resolveHandler}collectDiff(){const f=this.diff;return this.diff=[],f}pushDiff(f){switch(f.op){case 2:{for(const S of this.diff)if(S.op===2&&S.uri===f.uri){S.docv=f.docv;return}break}case 1:{const S=this.diff[this.diff.length-1];if(S){if(S.op===1&&S.item.extId===f.item.extId){(0,T.applyTestItemUpdate)(S.item,f.item);return}if(S.op===0&&S.item.item.extId===f.item.extId){(0,T.applyTestItemUpdate)(S.item,f.item);return}}break}}this.diff.push(f),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(f,S){const I=this.tree.get(f);if(I){if((I.expandLevels===void 0||S>I.expandLevels)&&(I.expandLevels=S),I.expand===1){const i=this.resolveChildren(I);return i.isOpen()?this.expandChildren(I,S-1):i.wait().then(()=>this.expandChildren(I,S-1))}else if(I.expand===3)return I.resolveBarrier?.isOpen()===!1?I.resolveBarrier.wait().then(()=>this.expandChildren(I,S-1)):this.expandChildren(I,S-1)}}dispose(){for(const f of this.tree.values())this.options.getApiFor(f.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(f,S){switch(S.op){case 3:this.removeItem(m.TestId.joinToString(f.fullId,S.id));break;case 0:this.upsertItem(S.item,f);break;case 5:for(const I of S.ops)this.onTestItemEvent(f,I);break;case 1:this.diffTagRefs(S.new,S.old,f.fullId.toString());break;case 2:this.updateExpandability(f);break;case 4:this.pushDiff({op:1,item:{extId:f.fullId.toString(),item:S.update}});break;case 6:this.documentSynced(f.actual.uri);break;default:(0,A.assertNever)(S)}}documentSynced(f){f&&this.pushDiff({op:2,uri:f,docv:this.options.getDocumentVersion(f)})}upsertItem(f,S){const I=m.TestId.fromExtHostTestItem(f,this.root.id,S?.actual),i=this.options.getApiFor(f);i.parent&&i.parent!==S?.actual&&this.options.getChildren(i.parent).delete(f.id);let a=this.tree.get(I.toString());if(!a){a={fullId:I,actual:f,expandLevels:S?.expandLevels?S.expandLevels-1:void 0,expand:0},f.tags.forEach(this.incrementTagRefs,this),this.tree.set(a.fullId.toString(),a),this.setItemParent(f,S),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:a.expand,item:this.options.toITestItem(f)}}),this.connectItemAndChildren(f,a,S);return}if(a.actual===f){this.connectItem(f,a,S);return}if(a.actual.uri?.toString()!==f.uri?.toString())return this.removeItem(I.toString()),this.upsertItem(f,S);const n=this.options.getChildren(a.actual),t=a.actual,o=p(this.options.toITestItem(t),this.options.toITestItem(f));this.options.getApiFor(t).listener=void 0,a.actual=f,a.expand=0,o&&(o.hasOwnProperty("tags")&&(this.diffTagRefs(f.tags,t.tags,I.toString()),delete o.tags),this.onTestItemEvent(a,{op:4,update:o})),this.connectItemAndChildren(f,a,S);for(const[g,l]of n)this.options.getChildren(f).get(l.id)||this.removeItem(m.TestId.joinToString(I,l.id));this.documentSynced(a.actual.uri)}diffTagRefs(f,S,I){const i=new Set(S.map(a=>a.id));for(const a of f)i.delete(a.id)||this.incrementTagRefs(a);this.pushDiff({op:1,item:{extId:I,item:{tags:f.map(a=>(0,T.namespaceTestTag)(this.options.controllerId,a.id))}}}),i.forEach(this.decrementTagRefs,this)}incrementTagRefs(f){const S=this.tags.get(f.id);S?S.refCount++:(this.tags.set(f.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,T.namespaceTestTag)(this.options.controllerId,f.id)}}))}decrementTagRefs(f){const S=this.tags.get(f);S&&!--S.refCount&&(this.tags.delete(f),this.pushDiff({op:7,id:(0,T.namespaceTestTag)(this.options.controllerId,f)}))}setItemParent(f,S){this.options.getApiFor(f).parent=S&&S.actual!==this.root?S.actual:void 0}connectItem(f,S,I){this.setItemParent(f,I);const i=this.options.getApiFor(f);i.parent=I?.actual,i.listener=a=>this.onTestItemEvent(S,a),this.updateExpandability(S)}connectItemAndChildren(f,S,I){this.connectItem(f,S,I);for(const[i,a]of this.options.getChildren(f))this.upsertItem(a,S)}updateExpandability(f){let S;this._resolveHandler?f.resolveBarrier?S=f.resolveBarrier.isOpen()?3:2:S=f.actual.canResolveChildren?1:0:S=0,S!==f.expand&&(f.expand=S,this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:S}}),S===1&&f.expandLevels!==void 0&&this.resolveChildren(f))}expandChildren(f,S){if(S<0)return;const I=[];for(const[i,a]of this.options.getChildren(f.actual)){const n=this.expand(m.TestId.joinToString(f.fullId,a.id),S);(0,_.isThenable)(n)&&I.push(n)}if(I.length)return Promise.all(I).then(()=>{})}resolveChildren(f){if(f.resolveBarrier)return f.resolveBarrier;if(!this._resolveHandler){const a=new _.Barrier;return a.open(),a}f.expand=2,this.pushExpandStateUpdate(f);const S=f.resolveBarrier=new _.Barrier,I=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,a)};let i;try{i=this._resolveHandler(f.actual===this.root?void 0:f.actual)}catch(a){I(a)}return(0,_.isThenable)(i)?i.catch(I).then(()=>{S.open(),this.updateExpandability(f)}):(S.open(),this.updateExpandability(f)),f.resolveBarrier}pushExpandStateUpdate(f){this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:f.expand}})}removeItem(f){const S=this.tree.get(f);if(!S)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:f});const I=[S];for(;I.length;){const i=I.pop();if(i){this.options.getApiFor(i.actual).listener=void 0;for(const a of i.actual.tags)this.decrementTagRefs(a.id);this.tree.delete(i.fullId.toString());for(const[a,n]of this.options.getChildren(i.actual))I.push(this.tree.get(m.TestId.joinToString(i.fullId,n.id)))}}}flushDiff(){const f=this.collectDiff();f.length&&this.diffOpEmitter.fire(f)}}e.TestItemCollection=C;class D extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=D;class b extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class r extends Error{constructor(f,S,I){super(`TestItem with ID "${f}" is from controller "${S}" and cannot be added as a child of an item from controller "${I}".`)}}e.MixedTestItemController=r;const s=(c,f,S)=>{let I=new Map;return{get size(){return I.size},forEach(i,a){for(const n of I.values())i.call(a,n,this)},[Symbol.iterator](){return I.entries()},replace(i){const a=new Map,n=new Set(I.keys()),t={op:5,ops:[]};for(const o of i){if(!(o instanceof S))throw new b(o.id);const g=f(o).controllerId;if(g!==c.controllerId)throw new r(o.id,g,c.controllerId);if(a.has(o.id))throw new D(o.id);a.set(o.id,o),n.delete(o.id),t.ops.push({op:0,item:o})}for(const o of n.keys())t.ops.push({op:3,id:o});c.listener?.(t),I=a},add(i){if(!(i instanceof S))throw new b(i.id);I.set(i.id,i),c.listener?.({op:0,item:i})},delete(i){I.delete(i)&&c.listener?.({op:3,id:i})},get(i){return I.get(i)},toJSON(){return Array.from(I.values())}}};e.createTestItemChildren=s}),define(De[136],Ie([1,0,103]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const L=new WeakMap,d=(T,m)=>{const y={controllerId:m};return L.set(T,y),y};e.createPrivateApiFor=d;const A=T=>{const m=L.get(T);if(!m)throw new _.InvalidTestItemError(T?.id||"<unknown>");return m};e.getPrivateApiFor=A}),define(De[104],Ie([1,0,15,2]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function d(m,y){return m.scheme===_.Schemas.http||m.scheme===_.Schemas.https?m:(y&&y.authority&&y.isRemote&&m.scheme===_.Schemas.file&&(m=L.URI.from({scheme:_.Schemas.vscodeRemote,authority:y.authority,path:m.path})),L.URI.from({scheme:_.Schemas.https,authority:`${m.scheme}+${A(m.authority)}.${e.webviewRootResourceAuthority}`,path:m.path,fragment:m.fragment,query:m.query}))}e.asWebviewUri=d;function A(m){return m.replace(/./g,y=>{const v=y.charCodeAt(0);return v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57?y:"-"+v.toString(16).padStart(4,"0")})}function T(m){return m.replace(/-([0-9a-f]{4})/g,(y,v)=>String.fromCharCode(parseInt(v,16)))}e.decodeAuthority=T}),define(De[261],Ie([1,0,3,4,104]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(m,y,v){this._proxy=m,this._editors=y,this._remoteInfo=v,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const R=y.getVisibleTextEditors();for(const k of this._insets.values())R.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(m=>m.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(m,y,v,R,k){let p;for(const f of this._editors.getVisibleTextEditors(!0))if(f.value===m){p=f;break}if(!p)throw new Error("not a visible editor");const C=this,D=this._handlePool++,b=new _.Emitter,r=new _.Emitter,s=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(f){return(0,d.asWebviewUri)(f,C._remoteInfo)}get cspSource(){return d.webviewGenericCspSource}set options(f){this._options=f,C._proxy.$setOptions(D,f)}get options(){return this._options}set html(f){this._html=f,C._proxy.$setHtml(D,f)}get html(){return this._html}get onDidReceiveMessage(){return b.event}postMessage(f){return C._proxy.$postMessage(D,f)}},c=new class{constructor(){this.editor=m,this.line=y,this.height=v,this.webview=s,this.onDidDispose=r.event}dispose(){C._insets.has(D)&&(C._insets.delete(D),C._proxy.$disposeEditorInset(D),r.fire(),r.dispose(),b.dispose())}};return this._proxy.$createEditorInset(D,p.id,p.value.document.uri,y+1,v,R||{},k.identifier,k.extensionLocation),this._insets.set(D,{editor:m,inset:c,onDidReceiveMessage:b}),c}$onDidDispose(m){const y=this._insets.get(m);y&&y.inset.dispose()}$onDidReceiveMessage(m,y){this._insets.get(m)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=A}),define(De[262],Ie([1,0,5]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,_.createDecorator)("configurationResolverService");var L;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(L||(e.VariableKind=L={}));class d extends Error{constructor(T,m){super(m),this.variable=T}}e.VariableError=d}),define(De[263],Ie([1,0,13,41,14,23,11,120,213,262,12]),function(me,e,_,L,d,A,T,m,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(C,D,b,r){this._contributedVariables=new Map,this._context=C,this._labelService=D,this._userHomePromise=b,r&&(this._envVariablesPromise=r.then(s=>this.prepareEnv(s)))}prepareEnv(C){if(T.isWindows){const D=Object.create(null);return Object.keys(C).forEach(b=>{D[b.toLowerCase()]=C[b]}),D}return C}resolveWithEnvironment(C,D,b){return this.recursiveResolve({env:this.prepareEnv(C),userHome:void 0},D?D.uri:void 0,b)}async resolveAsync(C,D){const b={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(b,C?C.uri:void 0,D)}async resolveAnyBase(C,D,b,r){const s=A.deepClone(D);T.isWindows&&s.windows?Object.keys(s.windows).forEach(f=>s[f]=s.windows[f]):T.isMacintosh&&s.osx?Object.keys(s.osx).forEach(f=>s[f]=s.osx[f]):T.isLinux&&s.linux&&Object.keys(s.linux).forEach(f=>s[f]=s.linux[f]),delete s.windows,delete s.osx,delete s.linux;const c={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(c,C?C.uri:void 0,s,b,r)}async resolveAnyAsync(C,D,b){return this.resolveAnyBase(C,D,b)}async resolveAnyMap(C,D,b){const r=new Map;return{newConfig:await this.resolveAnyBase(C,D,b,r),resolvedVariables:r}}resolveWithInteractionReplace(C,D,b,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,D,b,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,D){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,D)}async recursiveResolve(C,D,b,r,s){if(d.isString(b))return this.resolveString(C,D,b,r,s);if(Array.isArray(b))return Promise.all(b.map(c=>this.recursiveResolve(C,D,c,r,s)));if(d.isObject(b)){const c=Object.create(null),f=await Promise.all(Object.keys(b).map(async S=>[await this.resolveString(C,D,S,r,s),await this.recursiveResolve(C,D,b[S],r,s)]));for(const[S,I]of f)c[S]=I;return c}return b}resolveString(C,D,b,r,s){return(0,R.replaceAsync)(b,k.VARIABLE_REGEXP,async(c,f)=>{if(f.includes(k.VARIABLE_LHS))return c;let S=await this.evaluateSingleVariable(C,c,f,D,r);return s?.set(f,S),S!==c&&d.isString(S)&&S.match(k.VARIABLE_REGEXP)&&(S=await this.resolveString(C,D,S,r,s)),S})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}async evaluateSingleVariable(C,D,b,r,s){let c;const f=b.split(":");f.length>1&&(b=f[0],c=f[1]);const S=a=>{const n=this._context.getFilePath();if(n)return(0,m.normalizeDriveLetter)(n);throw new v.VariableError(a,(0,y.localize)(0,null,D))},I=a=>{const n=S(a);if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return(0,m.normalizeDriveLetter)(t)}throw new v.VariableError(a,(0,y.localize)(1,null,D,_.basename(n)))},i=a=>{if(c){const n=this._context.getFolderUri(c);if(n)return n;throw new v.VariableError(a,(0,y.localize)(2,null,D,c))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new v.VariableError(a,(0,y.localize)(3,null,D)):new v.VariableError(a,(0,y.localize)(4,null,D))};switch(b){case"env":if(c){if(C.env){const a=C.env[T.isWindows?c.toLowerCase():c];if(d.isString(a))return a}return""}throw new v.VariableError(v.VariableKind.Env,(0,y.localize)(5,null,D));case"config":if(c){const a=this._context.getConfigurationValue(r,c);if(d.isUndefinedOrNull(a))throw new v.VariableError(v.VariableKind.Config,(0,y.localize)(6,null,D,c));if(d.isObject(a))throw new v.VariableError(v.VariableKind.Config,(0,y.localize)(7,null,D,c));return a}throw new v.VariableError(v.VariableKind.Config,(0,y.localize)(8,null,D));case"command":return this.resolveFromMap(v.VariableKind.Command,D,c,s,"command");case"input":return this.resolveFromMap(v.VariableKind.Input,D,c,s,"input");case"extensionInstallFolder":if(c){const a=await this._context.getExtension(c);if(!a)throw new v.VariableError(v.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,D,c));return this.fsPath(a.extensionLocation)}throw new v.VariableError(v.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,D));default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,m.normalizeDriveLetter)(this.fsPath(i(v.VariableKind.WorkspaceFolder)));case"cwd":return r||c?(0,m.normalizeDriveLetter)(this.fsPath(i(v.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.normalizeDriveLetter)(_.basename(this.fsPath(i(v.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(C.userHome)return C.userHome;throw new v.VariableError(v.VariableKind.UserHome,(0,y.localize)(11,null,D))}case"lineNumber":{const a=this._context.getLineNumber();if(a)return a;throw new v.VariableError(v.VariableKind.LineNumber,(0,y.localize)(12,null,D))}case"selectedText":{const a=this._context.getSelectedText();if(a)return a;throw new v.VariableError(v.VariableKind.SelectedText,(0,y.localize)(13,null,D))}case"file":return S(v.VariableKind.File);case"fileWorkspaceFolder":return I(v.VariableKind.FileWorkspaceFolder);case"relativeFile":return r||c?_.relative(this.fsPath(i(v.VariableKind.RelativeFile)),S(v.VariableKind.RelativeFile)):S(v.VariableKind.RelativeFile);case"relativeFileDirname":{const a=_.dirname(S(v.VariableKind.RelativeFileDirname));if(r||c){const n=_.relative(this.fsPath(i(v.VariableKind.RelativeFileDirname)),a);return n.length===0?".":n}return a}case"fileDirname":return _.dirname(S(v.VariableKind.FileDirname));case"fileExtname":return _.extname(S(v.VariableKind.FileExtname));case"fileBasename":return _.basename(S(v.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=_.basename(S(v.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-_.extname(a).length)}case"fileDirnameBasename":return _.basename(_.dirname(S(v.VariableKind.FileDirnameBasename)));case"execPath":{const a=this._context.getExecPath();return a||D}case"execInstallFolder":{const a=this._context.getAppRoot();return a||D}case"pathSeparator":return _.sep;default:try{const a=c?`${b}:${c}`:b;return this.resolveFromMap(v.VariableKind.Unknown,D,a,s,void 0)}catch{return D}}}}resolveFromMap(C,D,b,r,s){if(b&&r){const c=s===void 0?r[b]:r[s+":"+b];if(typeof c=="string")return c;throw new v.VariableError(C,(0,y.localize)(14,null,D))}return D}}e.AbstractVariableResolverService=k}),define(De[137],Ie([1,0,5,133]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var d;(function(D){D[D.UP=0]="UP",D[D.DOWN=1]="DOWN",D[D.LEFT=2]="LEFT",D[D.RIGHT=3]="RIGHT"})(d||(e.GroupDirection=d={}));var A;(function(D){D[D.HORIZONTAL=0]="HORIZONTAL",D[D.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var T;(function(D){D[D.FIRST=0]="FIRST",D[D.LAST=1]="LAST",D[D.NEXT=2]="NEXT",D[D.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var m;(function(D){D[D.MAXIMIZE=0]="MAXIMIZE",D[D.EVEN=1]="EVEN",D[D.TOGGLE=2]="TOGGLE"})(m||(e.GroupsArrangement=m={}));var y;(function(D){D[D.COPY_EDITORS=0]="COPY_EDITORS",D[D.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function v(D){const b=D;return(0,L.isEditorInput)(b?.editor)&&(0,L.isEditorInput)(b?.replacement)}e.isEditorReplacement=v;var R;(function(D){D[D.CREATION_TIME=0]="CREATION_TIME",D[D.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",D[D.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var k;(function(D){D[D.NEW_EDITOR=1]="NEW_EDITOR",D[D.MOVE_EDITOR=2]="MOVE_EDITOR",D[D.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function p(D){const b=D;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=p;function C(D){return D.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(De[264],Ie([1,0,5,137]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function d(A){const T=A;return typeof A=="number"||(0,L.isEditorGroup)(T)}e.isPreferredGroup=d}),define(De[16],Ie([1,0,19,22,156,67,74,28,152,73,93,23,14,2,33,77,126,136,133,102,59,82,264,7]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c,f,S,I,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Fe){function Ae(ae){const{selectionStartLineNumber:Oe,selectionStartColumn:We,positionLineNumber:Ke,positionColumn:je}=ae,it=new a.Position(Oe-1,We-1),Et=new a.Position(Ke-1,je-1);return new a.Selection(it,Et)}Fe.to=Ae;function Te(ae){const{anchor:Oe,active:We}=ae;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Fe.from=Te})(n||(e.Selection=n={}));var t;(function(Fe){function Ae(ae){if(!ae)return;const{start:Oe,end:We}=ae;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Fe.from=Ae;function Te(ae){if(!ae)return;const{startLineNumber:Oe,startColumn:We,endLineNumber:Ke,endColumn:je}=ae;return new a.Range(Oe-1,We-1,Ke-1,je-1)}Fe.to=Te})(t||(e.Range=t={}));var o;(function(Fe){function Ae(Te){switch(Te){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Fe.to=Ae})(o||(e.TokenType=o={}));var g;(function(Fe){function Ae(ae){return new a.Position(ae.lineNumber-1,ae.column-1)}Fe.to=Ae;function Te(ae){return{lineNumber:ae.line+1,column:ae.character+1}}Fe.from=Te})(g||(e.Position=g={}));var l;(function(Fe){function Ae(Oe,We,Ke){return(0,_.coalesce)((0,_.asArray)(Oe).map(je=>Te(je,We,Ke)))}Fe.from=Ae;function Te(Oe,We,Ke){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:Ke?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:ae(Oe.scheme,We),pattern:ze.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:Ke?.isBuiltin}}function ae(Oe,We){return We&&typeof Oe=="string"?We.transformOutgoingScheme(Oe):Oe}})(l||(e.DocumentSelector=l={}));var h;(function(Fe){function Ae(ae){switch(ae){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Fe.from=Ae;function Te(ae){switch(ae){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Fe.to=Te})(h||(e.DiagnosticTag=h={}));var w;(function(Fe){function Ae(ae){let Oe;return ae.code&&((0,p.isString)(ae.code)||(0,p.isNumber)(ae.code)?Oe=String(ae.code):Oe={value:String(ae.code.value),target:ae.code.target}),{...t.from(ae.range),message:ae.message,source:ae.source,code:Oe,severity:E.from(ae.severity),relatedInformation:ae.relatedInformation&&ae.relatedInformation.map(u.from),tags:Array.isArray(ae.tags)?(0,_.coalesce)(ae.tags.map(h.from)):void 0}}Fe.from=Ae;function Te(ae){const Oe=new a.Diagnostic(t.to(ae),ae.message,E.to(ae.severity));return Oe.source=ae.source,Oe.code=(0,p.isString)(ae.code)?ae.code:ae.code?.value,Oe.relatedInformation=ae.relatedInformation&&ae.relatedInformation.map(u.to),Oe.tags=ae.tags&&(0,_.coalesce)(ae.tags.map(h.to)),Oe}Fe.to=Te})(w||(e.Diagnostic=w={}));var u;(function(Fe){function Ae(ae){return{...t.from(ae.location.range),message:ae.message,resource:ae.location.uri}}Fe.from=Ae;function Te(ae){return new a.DiagnosticRelatedInformation(new a.Location(ae.resource,t.to(ae)),ae.message)}Fe.to=Te})(u||(e.DiagnosticRelatedInformation=u={}));var E;(function(Fe){function Ae(ae){switch(ae){case a.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}Fe.from=Ae;function Te(ae){switch(ae){case r.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Fe.to=Te})(E||(e.DiagnosticSeverity=E={}));var P;(function(Fe){function Ae(ae){return typeof ae=="number"&&ae>=a.ViewColumn.One?ae-1:ae===a.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Fe.from=Ae;function Te(ae){if(typeof ae=="number"&&ae>=0)return ae+1;throw new Error("invalid 'EditorGroupColumn'")}Fe.to=Te})(P||(e.ViewColumn=P={}));function O(Fe){return typeof Fe.range<"u"}function N(Fe){return Fe.length===0?!0:!!O(Fe[0])}e.isDecorationOptionsArr=N;var F;(function(Fe){function Ae(je){return je.map(Fe.from)}Fe.fromMany=Ae;function Te(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function ae(je){let it;if(Te(je)){const{language:bt,value:pt}=je;it={value:"```"+bt+`
`+pt+"\n```\n"}}else a.MarkdownString.isMarkdownString(je)?it={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?it={value:je}:it={value:""};const Et=Object.create(null);it.uris=Et;const Dt=bt=>{try{let pt=C.URI.parse(bt,!0);pt=pt.with({query:Oe(pt.query,Et)}),Et[bt]=pt}catch{}return""},It=new y.marked.Renderer;return It.link=Dt,It.image=bt=>typeof bt=="string"?Dt(T.parseHrefAndDimensions(bt).href):"",(0,y.marked)(it.value,{renderer:It}),it}Fe.from=ae;function Oe(je,it){if(!je)return je;let Et;try{Et=(0,v.parse)(je)}catch{}if(!Et)return je;let Dt=!1;return Et=(0,k.cloneAndChange)(Et,It=>{if(C.URI.isUri(It)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[bt]=It,Dt=!0,bt}else return}),Dt?JSON.stringify(Et):je}function We(je){const it=new a.MarkdownString(je.value,je.supportThemeIcons);return it.isTrusted=je.isTrusted,it.supportHtml=je.supportHtml,it.baseUri=je.baseUri?C.URI.from(je.baseUri):void 0,it}Fe.to=We;function Ke(je){if(je)return typeof je=="string"?je:Fe.from(je)}Fe.fromStrict=Ke})(F||(e.MarkdownString=F={}));function x(Fe){return N(Fe)?Fe.map(Ae=>({range:t.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?F.fromMany(Ae.hoverMessage):Ae.hoverMessage?F.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):Fe.map(Ae=>({range:t.from(Ae)}))}e.fromRangeOrRangeWithMessage=x;function B(Fe){return typeof Fe>"u"?Fe:typeof Fe=="string"?C.URI.file(Fe):Fe}e.pathOrURIToURI=B;var U;(function(Fe){function Ae(Te){return typeof Te>"u"?Te:{contentText:Te.contentText,contentIconPath:Te.contentIconPath?B(Te.contentIconPath):void 0,border:Te.border,borderColor:Te.borderColor,fontStyle:Te.fontStyle,fontWeight:Te.fontWeight,textDecoration:Te.textDecoration,color:Te.color,backgroundColor:Te.backgroundColor,margin:Te.margin,width:Te.width,height:Te.height}}Fe.from=Ae})(U||(e.ThemableDecorationAttachmentRenderOptions=U={}));var X;(function(Fe){function Ae(Te){return typeof Te>"u"?Te:{backgroundColor:Te.backgroundColor,outline:Te.outline,outlineColor:Te.outlineColor,outlineStyle:Te.outlineStyle,outlineWidth:Te.outlineWidth,border:Te.border,borderColor:Te.borderColor,borderRadius:Te.borderRadius,borderSpacing:Te.borderSpacing,borderStyle:Te.borderStyle,borderWidth:Te.borderWidth,fontStyle:Te.fontStyle,fontWeight:Te.fontWeight,textDecoration:Te.textDecoration,cursor:Te.cursor,color:Te.color,opacity:Te.opacity,letterSpacing:Te.letterSpacing,gutterIconPath:Te.gutterIconPath?B(Te.gutterIconPath):void 0,gutterIconSize:Te.gutterIconSize,overviewRulerColor:Te.overviewRulerColor,before:Te.before?U.from(Te.before):void 0,after:Te.after?U.from(Te.after):void 0}}Fe.from=Ae})(X||(e.ThemableDecorationRenderOptions=X={}));var j;(function(Fe){function Ae(Te){if(typeof Te>"u")return Te;switch(Te){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Fe.from=Ae})(j||(e.DecorationRangeBehavior=j={}));var ge;(function(Fe){function Ae(Te){return{isWholeLine:Te.isWholeLine,rangeBehavior:Te.rangeBehavior?j.from(Te.rangeBehavior):void 0,overviewRulerLane:Te.overviewRulerLane,light:Te.light?X.from(Te.light):void 0,dark:Te.dark?X.from(Te.dark):void 0,backgroundColor:Te.backgroundColor,outline:Te.outline,outlineColor:Te.outlineColor,outlineStyle:Te.outlineStyle,outlineWidth:Te.outlineWidth,border:Te.border,borderColor:Te.borderColor,borderRadius:Te.borderRadius,borderSpacing:Te.borderSpacing,borderStyle:Te.borderStyle,borderWidth:Te.borderWidth,fontStyle:Te.fontStyle,fontWeight:Te.fontWeight,textDecoration:Te.textDecoration,cursor:Te.cursor,color:Te.color,opacity:Te.opacity,letterSpacing:Te.letterSpacing,gutterIconPath:Te.gutterIconPath?B(Te.gutterIconPath):void 0,gutterIconSize:Te.gutterIconSize,overviewRulerColor:Te.overviewRulerColor,before:Te.before?U.from(Te.before):void 0,after:Te.after?U.from(Te.after):void 0}}Fe.from=Ae})(ge||(e.DecorationRenderOptions=ge={}));var ie;(function(Fe){function Ae(ae){return{text:ae.newText,eol:ae.newEol&&Qe.from(ae.newEol),range:t.from(ae.range)}}Fe.from=Ae;function Te(ae){const Oe=new a.TextEdit(t.to(ae.range),ae.text);return Oe.newEol=typeof ae.eol>"u"?void 0:Qe.to(ae.eol),Oe}Fe.to=Te})(ie||(e.TextEdit=ie={}));var te;(function(Fe){function Ae(ae,Oe){const We={edits:[]};if(ae instanceof a.WorkspaceEdit){const Ke=new m.ResourceSet;for(const je of ae._allEntries())je._type===1&&C.URI.isUri(je.to)&&je.from===void 0&&Ke.add(je.to);for(const je of ae._allEntries())if(je._type===1){let it;je.options?.contents&&(ArrayBuffer.isView(je.options.contents)?it={type:"base64",value:(0,L.encodeBase64)(L.VSBuffer.wrap(je.options.contents))}:it={type:"dataTransferItem",id:je.options.contents._itemId}),We.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contents:it},metadata:je.metadata})}else je._type===2?We.edits.push({resource:je.uri,textEdit:ie.from(je.edit),versionId:Ke.has(je.uri)?void 0:Oe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===6?We.edits.push({resource:je.uri,textEdit:{range:t.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:Ke.has(je.uri)?void 0:Oe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?We.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(je.uri)}):je._type===5&&We.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(Ze.from)}})}return We}Fe.from=Ae;function Te(ae){const Oe=new a.WorkspaceEdit,We=new m.ResourceMap;for(const Ke of ae.edits)if(Ke.textEdit){const je=Ke,it=C.URI.revive(je.resource),Et=t.to(je.textEdit.range),Dt=je.textEdit.text,It=je.textEdit.insertAsSnippet;let bt;It?bt=a.SnippetTextEdit.replace(Et,new a.SnippetString(Dt)):bt=a.TextEdit.replace(Et,Dt);const pt=We.get(it);pt?pt.push(bt):We.set(it,[bt])}else Oe.renameFile(C.URI.revive(Ke.oldResource),C.URI.revive(Ke.newResource),Ke.options);for(const[Ke,je]of We)Oe.set(Ke,je);return Oe}Fe.to=Te})(te||(e.WorkspaceEdit=te={}));var $;(function(Fe){const Ae=Object.create(null);Ae[a.SymbolKind.File]=0,Ae[a.SymbolKind.Module]=1,Ae[a.SymbolKind.Namespace]=2,Ae[a.SymbolKind.Package]=3,Ae[a.SymbolKind.Class]=4,Ae[a.SymbolKind.Method]=5,Ae[a.SymbolKind.Property]=6,Ae[a.SymbolKind.Field]=7,Ae[a.SymbolKind.Constructor]=8,Ae[a.SymbolKind.Enum]=9,Ae[a.SymbolKind.Interface]=10,Ae[a.SymbolKind.Function]=11,Ae[a.SymbolKind.Variable]=12,Ae[a.SymbolKind.Constant]=13,Ae[a.SymbolKind.String]=14,Ae[a.SymbolKind.Number]=15,Ae[a.SymbolKind.Boolean]=16,Ae[a.SymbolKind.Array]=17,Ae[a.SymbolKind.Object]=18,Ae[a.SymbolKind.Key]=19,Ae[a.SymbolKind.Null]=20,Ae[a.SymbolKind.EnumMember]=21,Ae[a.SymbolKind.Struct]=22,Ae[a.SymbolKind.Event]=23,Ae[a.SymbolKind.Operator]=24,Ae[a.SymbolKind.TypeParameter]=25;function Te(Oe){return typeof Ae[Oe]=="number"?Ae[Oe]:6}Fe.from=Te;function ae(Oe){for(const We in Ae)if(Ae[We]===Oe)return Number(We);return a.SymbolKind.Property}Fe.to=ae})($||(e.SymbolKind=$={}));var H;(function(Fe){function Ae(ae){switch(ae){case a.SymbolTag.Deprecated:return 1}}Fe.from=Ae;function Te(ae){switch(ae){case 1:return a.SymbolTag.Deprecated}}Fe.to=Te})(H||(e.SymbolTag=H={}));var ce;(function(Fe){function Ae(ae){return{name:ae.name,kind:$.from(ae.kind),tags:ae.tags&&ae.tags.map(H.from),containerName:ae.containerName,location:Z.from(ae.location)}}Fe.from=Ae;function Te(ae){const Oe=new a.SymbolInformation(ae.name,$.to(ae.kind),ae.containerName,Z.to(ae.location));return Oe.tags=ae.tags&&ae.tags.map(H.to),Oe}Fe.to=Te})(ce||(e.WorkspaceSymbol=ce={}));var re;(function(Fe){function Ae(ae){const Oe={name:ae.name||"!!MISSING: name!!",detail:ae.detail,range:t.from(ae.range),selectionRange:t.from(ae.selectionRange),kind:$.from(ae.kind),tags:ae.tags?.map(H.from)??[]};return ae.children&&(Oe.children=ae.children.map(Ae)),Oe}Fe.from=Ae;function Te(ae){const Oe=new a.DocumentSymbol(ae.name,ae.detail,$.to(ae.kind),t.to(ae.range),t.to(ae.selectionRange));return(0,_.isNonEmptyArray)(ae.tags)&&(Oe.tags=ae.tags.map(H.to)),ae.children&&(Oe.children=ae.children.map(Te)),Oe}Fe.to=Te})(re||(e.DocumentSymbol=re={}));var fe;(function(Fe){function Ae(ae){const Oe=new a.CallHierarchyItem($.to(ae.kind),ae.name,ae.detail||"",C.URI.revive(ae.uri),t.to(ae.range),t.to(ae.selectionRange));return Oe._sessionId=ae._sessionId,Oe._itemId=ae._itemId,Oe}Fe.to=Ae;function Te(ae,Oe,We){if(Oe=Oe??ae._sessionId,We=We??ae._itemId,Oe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:We,name:ae.name,detail:ae.detail,kind:$.from(ae.kind),uri:ae.uri,range:t.from(ae.range),selectionRange:t.from(ae.selectionRange),tags:ae.tags?.map(H.from)}}Fe.from=Te})(fe||(e.CallHierarchyItem=fe={}));var he;(function(Fe){function Ae(Te){return new a.CallHierarchyIncomingCall(fe.to(Te.from),Te.fromRanges.map(ae=>t.to(ae)))}Fe.to=Ae})(he||(e.CallHierarchyIncomingCall=he={}));var z;(function(Fe){function Ae(Te){return new a.CallHierarchyOutgoingCall(fe.to(Te.to),Te.fromRanges.map(ae=>t.to(ae)))}Fe.to=Ae})(z||(e.CallHierarchyOutgoingCall=z={}));var Z;(function(Fe){function Ae(ae){return{range:ae.range&&t.from(ae.range),uri:ae.uri}}Fe.from=Ae;function Te(ae){return new a.Location(C.URI.revive(ae.uri),t.to(ae.range))}Fe.to=Te})(Z||(e.location=Z={}));var ye;(function(Fe){function Ae(ae){const Oe=ae,We=ae;return{originSelectionRange:Oe.originSelectionRange?t.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:We.uri,range:t.from(Oe.targetRange?Oe.targetRange:We.range),targetSelectionRange:Oe.targetSelectionRange?t.from(Oe.targetSelectionRange):void 0}}Fe.from=Ae;function Te(ae){return{targetUri:C.URI.revive(ae.uri),targetRange:t.to(ae.range),targetSelectionRange:ae.targetSelectionRange?t.to(ae.targetSelectionRange):void 0,originSelectionRange:ae.originSelectionRange?t.to(ae.originSelectionRange):void 0}}Fe.to=Te})(ye||(e.DefinitionLink=ye={}));var Re;(function(Fe){function Ae(ae){return{range:t.from(ae.range),contents:F.fromMany(ae.contents)}}Fe.from=Ae;function Te(ae){return new a.Hover(ae.contents.map(F.to),t.to(ae.range))}Fe.to=Te})(Re||(e.Hover=Re={}));var ne;(function(Fe){function Ae(ae){return{range:t.from(ae.range),expression:ae.expression}}Fe.from=Ae;function Te(ae){return new a.EvaluatableExpression(t.to(ae.range),ae.expression)}Fe.to=Te})(ne||(e.EvaluatableExpression=ne={}));var ee;(function(Fe){function Ae(ae){if(ae instanceof a.InlineValueText)return{type:"text",range:t.from(ae.range),text:ae.text};if(ae instanceof a.InlineValueVariableLookup)return{type:"variable",range:t.from(ae.range),variableName:ae.variableName,caseSensitiveLookup:ae.caseSensitiveLookup};if(ae instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:t.from(ae.range),expression:ae.expression};throw new Error("Unknown 'InlineValue' type")}Fe.from=Ae;function Te(ae){switch(ae.type){case"text":return{range:t.to(ae.range),text:ae.text};case"variable":return{range:t.to(ae.range),variableName:ae.variableName,caseSensitiveLookup:ae.caseSensitiveLookup};case"expression":return{range:t.to(ae.range),expression:ae.expression}}}Fe.to=Te})(ee||(e.InlineValue=ee={}));var de;(function(Fe){function Ae(ae){return{frameId:ae.frameId,stoppedLocation:t.from(ae.stoppedLocation)}}Fe.from=Ae;function Te(ae){return new a.InlineValueContext(ae.frameId,t.to(ae.stoppedLocation))}Fe.to=Te})(de||(e.InlineValueContext=de={}));var K;(function(Fe){function Ae(ae){return{range:t.from(ae.range),kind:ae.kind}}Fe.from=Ae;function Te(ae){return new a.DocumentHighlight(t.to(ae.range),ae.kind)}Fe.to=Te})(K||(e.DocumentHighlight=K={}));var le;(function(Fe){function Ae(Te){switch(Te){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Fe.to=Ae})(le||(e.CompletionTriggerKind=le={}));var oe;(function(Fe){function Ae(Te){return{triggerKind:le.to(Te.triggerKind),triggerCharacter:Te.triggerCharacter}}Fe.to=Ae})(oe||(e.CompletionContext=oe={}));var ue;(function(Fe){function Ae(ae){switch(ae){case a.CompletionItemTag.Deprecated:return 1}}Fe.from=Ae;function Te(ae){switch(ae){case 1:return a.CompletionItemTag.Deprecated}}Fe.to=Te})(ue||(e.CompletionItemTag=ue={}));var Ee;(function(Fe){const Ae=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function Te(We){return Ae.get(We)??9}Fe.from=Te;const ae=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Oe(We){return ae.get(We)??a.CompletionItemKind.Property}Fe.to=Oe})(Ee||(e.CompletionItemKind=Ee={}));var M;(function(Fe){function Ae(Te,ae){const Oe=new a.CompletionItem(Te.label);return Oe.insertText=Te.insertText,Oe.kind=Ee.to(Te.kind),Oe.tags=Te.tags?.map(ue.to),Oe.detail=Te.detail,Oe.documentation=T.isMarkdownString(Te.documentation)?F.to(Te.documentation):Te.documentation,Oe.sortText=Te.sortText,Oe.filterText=Te.filterText,Oe.preselect=Te.preselect,Oe.commitCharacters=Te.commitCharacters,D.Range.isIRange(Te.range)?Oe.range=t.to(Te.range):typeof Te.range=="object"&&(Oe.range={inserting:t.to(Te.range.insert),replacing:t.to(Te.range.replace)}),Oe.keepWhitespace=typeof Te.insertTextRules>"u"?!1:!!(Te.insertTextRules&1),typeof Te.insertTextRules<"u"&&Te.insertTextRules&4?Oe.insertText=new a.SnippetString(Te.insertText):(Oe.insertText=Te.insertText,Oe.textEdit=Oe.range instanceof a.Range?new a.TextEdit(Oe.range,Oe.insertText):void 0),Te.additionalTextEdits&&Te.additionalTextEdits.length>0&&(Oe.additionalTextEdits=Te.additionalTextEdits.map(We=>ie.to(We))),Oe.command=ae&&Te.command?ae.fromInternal(Te.command):void 0,Oe}Fe.to=Ae})(M||(e.CompletionItem=M={}));var q;(function(Fe){function Ae(ae){if(typeof ae.label!="string"&&!Array.isArray(ae.label))throw new TypeError("Invalid label");return{label:ae.label,documentation:F.fromStrict(ae.documentation)}}Fe.from=Ae;function Te(ae){return{label:ae.label,documentation:T.isMarkdownString(ae.documentation)?F.to(ae.documentation):ae.documentation}}Fe.to=Te})(q||(e.ParameterInformation=q={}));var G;(function(Fe){function Ae(ae){return{label:ae.label,documentation:F.fromStrict(ae.documentation),parameters:Array.isArray(ae.parameters)?ae.parameters.map(q.from):[],activeParameter:ae.activeParameter}}Fe.from=Ae;function Te(ae){return{label:ae.label,documentation:T.isMarkdownString(ae.documentation)?F.to(ae.documentation):ae.documentation,parameters:Array.isArray(ae.parameters)?ae.parameters.map(q.to):[],activeParameter:ae.activeParameter}}Fe.to=Te})(G||(e.SignatureInformation=G={}));var J;(function(Fe){function Ae(ae){return{activeSignature:ae.activeSignature,activeParameter:ae.activeParameter,signatures:Array.isArray(ae.signatures)?ae.signatures.map(G.from):[]}}Fe.from=Ae;function Te(ae){return{activeSignature:ae.activeSignature,activeParameter:ae.activeParameter,signatures:Array.isArray(ae.signatures)?ae.signatures.map(G.to):[]}}Fe.to=Te})(J||(e.SignatureHelp=J={}));var be;(function(Fe){function Ae(Te,ae){const Oe=new a.InlayHint(g.to(ae.position),typeof ae.label=="string"?ae.label:ae.label.map(se.to.bind(void 0,Te)),ae.kind&&we.to(ae.kind));return Oe.textEdits=ae.textEdits&&ae.textEdits.map(ie.to),Oe.tooltip=T.isMarkdownString(ae.tooltip)?F.to(ae.tooltip):ae.tooltip,Oe.paddingLeft=ae.paddingLeft,Oe.paddingRight=ae.paddingRight,Oe}Fe.to=Ae})(be||(e.InlayHint=be={}));var se;(function(Fe){function Ae(Te,ae){const Oe=new a.InlayHintLabelPart(ae.label);return Oe.tooltip=T.isMarkdownString(ae.tooltip)?F.to(ae.tooltip):ae.tooltip,b.Command.is(ae.command)&&(Oe.command=Te.fromInternal(ae.command)),ae.location&&(Oe.location=Z.to(ae.location)),Oe}Fe.to=Ae})(se||(e.InlayHintLabelPart=se={}));var we;(function(Fe){function Ae(ae){return ae}Fe.from=Ae;function Te(ae){return ae}Fe.to=Te})(we||(e.InlayHintKind=we={}));var ke;(function(Fe){function Ae(ae){return{range:t.from(ae.range),url:ae.target,tooltip:ae.tooltip}}Fe.from=Ae;function Te(ae){let Oe;if(ae.url)try{Oe=typeof ae.url=="string"?C.URI.parse(ae.url,!0):C.URI.revive(ae.url)}catch{}return new a.DocumentLink(t.to(ae.range),Oe)}Fe.to=Te})(ke||(e.DocumentLink=ke={}));var Ue;(function(Fe){function Ae(ae){const Oe=new a.ColorPresentation(ae.label);return ae.textEdit&&(Oe.textEdit=ie.to(ae.textEdit)),ae.additionalTextEdits&&(Oe.additionalTextEdits=ae.additionalTextEdits.map(We=>ie.to(We))),Oe}Fe.to=Ae;function Te(ae){return{label:ae.label,textEdit:ae.textEdit?ie.from(ae.textEdit):void 0,additionalTextEdits:ae.additionalTextEdits?ae.additionalTextEdits.map(Oe=>ie.from(Oe)):void 0}}Fe.from=Te})(Ue||(e.ColorPresentation=Ue={}));var He;(function(Fe){function Ae(ae){return new a.Color(ae[0],ae[1],ae[2],ae[3])}Fe.to=Ae;function Te(ae){return[ae.red,ae.green,ae.blue,ae.alpha]}Fe.from=Te})(He||(e.Color=He={}));var Je;(function(Fe){function Ae(ae){return{range:t.from(ae.range)}}Fe.from=Ae;function Te(ae){return new a.SelectionRange(t.to(ae.range))}Fe.to=Te})(Je||(e.SelectionRange=Je={}));var Ge;(function(Fe){function Ae(Te){switch(Te){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Fe.to=Ae})(Ge||(e.TextDocumentSaveReason=Ge={}));var et;(function(Fe){function Ae(ae){switch(ae){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Fe.from=Ae;function Te(ae){switch(ae){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Fe.to=Te})(et||(e.TextEditorLineNumbersStyle=et={}));var Qe;(function(Fe){function Ae(ae){if(ae===a.EndOfLine.CRLF)return 1;if(ae===a.EndOfLine.LF)return 0}Fe.from=Ae;function Te(ae){if(ae===1)return a.EndOfLine.CRLF;if(ae===0)return a.EndOfLine.LF}Fe.to=Te})(Qe||(e.EndOfLine=Qe={}));var st;(function(Fe){function Ae(Te){if(typeof Te=="object")return Te.viewId;switch(Te){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Fe.from=Ae})(st||(e.ProgressLocation=st={}));var tt;(function(Fe){function Ae(ae){const Oe={start:ae.start+1,end:ae.end+1};return ae.kind&&(Oe.kind=Pe.from(ae.kind)),Oe}Fe.from=Ae;function Te(ae){const Oe={start:ae.start-1,end:ae.end-1};return ae.kind&&(Oe.kind=Pe.to(ae.kind)),Oe}Fe.to=Te})(tt||(e.FoldingRange=tt={}));var Pe;(function(Fe){function Ae(ae){if(ae)switch(ae){case a.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}Fe.from=Ae;function Te(ae){if(ae)switch(ae.value){case b.FoldingRangeKind.Comment.value:return a.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports.value:return a.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region.value:return a.FoldingRangeKind.Region}}Fe.to=Te})(Pe||(e.FoldingRangeKind=Pe={}));var _e;(function(Fe){function Ae(Te){if(Te)return{pinned:typeof Te.preview=="boolean"?!Te.preview:void 0,inactive:Te.background,preserveFocus:Te.preserveFocus,selection:typeof Te.selection=="object"?t.from(Te.selection):void 0,override:typeof Te.override=="boolean"?c.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Fe.from=Ae})(_e||(e.TextEditorOpenOptions=_e={}));var ze;(function(Fe){function Ae(We){return We instanceof a.RelativePattern?We.toJSON():typeof We=="string"?We:Te(We)||ae(We)?new a.RelativePattern(We.baseUri??We.base,We.pattern).toJSON():We}Fe.from=Ae;function Te(We){const Ke=We;return Ke?C.URI.isUri(Ke.baseUri)&&typeof Ke.pattern=="string":!1}function ae(We){const Ke=We;return Ke?typeof Ke.base=="string"&&typeof Ke.pattern=="string":!1}function Oe(We){return typeof We=="string"?We:new a.RelativePattern(C.URI.revive(We.baseUri),We.pattern)}Fe.to=Oe})(ze||(e.GlobPattern=ze={}));var Y;(function(Fe){function Ae(Te){if(Te){if(Array.isArray(Te))return Te.map(Ae);if(typeof Te=="string")return Te;{const ae=Te;return{language:ae.language,scheme:ae.scheme,pattern:ze.from(ae.pattern),exclusive:ae.exclusive,notebookType:ae.notebookType}}}else return}Fe.from=Ae})(Y||(e.LanguageSelector=Y={}));var Q;(function(Fe){function Ae(ae){return{start:ae.start,end:ae.end}}Fe.from=Ae;function Te(ae){return new a.NotebookRange(ae.start,ae.end)}Fe.to=Te})(Q||(e.NotebookRange=Q={}));var Se;(function(Fe){function Ae(ae){return{timing:typeof ae.runStartTime=="number"&&typeof ae.runEndTime=="number"?{startTime:ae.runStartTime,endTime:ae.runEndTime}:void 0,executionOrder:ae.executionOrder,success:ae.lastRunSuccess}}Fe.to=Ae;function Te(ae){return{lastRunSuccess:ae.success,runStartTime:ae.timing?.startTime,runEndTime:ae.timing?.endTime,executionOrder:ae.executionOrder}}Fe.from=Te})(Se||(e.NotebookCellExecutionSummary=Se={}));var Be;(function(Fe){function Ae(Te){if(Te===f.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(Te===f.NotebookCellExecutionState.Pending)return;if(Te===f.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Te}`)}Fe.to=Ae})(Be||(e.NotebookCellExecutionState=Be={}));var Me;(function(Fe){function Ae(ae){switch(ae){case a.NotebookCellKind.Markup:return f.CellKind.Markup;case a.NotebookCellKind.Code:default:return f.CellKind.Code}}Fe.from=Ae;function Te(ae){switch(ae){case f.CellKind.Markup:return a.NotebookCellKind.Markup;case f.CellKind.Code:default:return a.NotebookCellKind.Code}}Fe.to=Te})(Me||(e.NotebookCellKind=Me={}));var Xe;(function(Fe){function Ae(ae){const Oe={metadata:ae.metadata??Object.create(null),cells:[]};for(const We of ae.cells)a.NotebookCellData.validate(We),Oe.cells.push(Ze.from(We));return Oe}Fe.from=Ae;function Te(ae){const Oe=new a.NotebookData(ae.cells.map(Ze.to));return(0,p.isEmptyObject)(ae.metadata)||(Oe.metadata=ae.metadata),Oe}Fe.to=Te})(Xe||(e.NotebookData=Xe={}));var Ze;(function(Fe){function Ae(ae){return{cellKind:Me.from(ae.kind),language:ae.languageId,mime:ae.mime,source:ae.value,metadata:ae.metadata,internalMetadata:Se.from(ae.executionSummary??{}),outputs:ae.outputs?ae.outputs.map(ft.from):[]}}Fe.from=Ae;function Te(ae){return new a.NotebookCellData(Me.to(ae.cellKind),ae.source,ae.language,ae.mime,ae.outputs?ae.outputs.map(ft.to):void 0,ae.metadata,ae.internalMetadata?Se.to(ae.internalMetadata):void 0)}Fe.to=Te})(Ze||(e.NotebookCellData=Ze={}));var rt;(function(Fe){function Ae(ae){return{mime:ae.mime,valueBytes:L.VSBuffer.wrap(ae.data)}}Fe.from=Ae;function Te(ae){return new a.NotebookCellOutputItem(ae.valueBytes.buffer,ae.mime)}Fe.to=Te})(rt||(e.NotebookCellOutputItem=rt={}));var ft;(function(Fe){function Ae(ae){return{outputId:ae.id,items:ae.items.map(rt.from),metadata:ae.metadata}}Fe.from=Ae;function Te(ae){const Oe=ae.items.map(rt.to);return new a.NotebookCellOutput(Oe,ae.outputId,ae.metadata)}Fe.to=Te})(ft||(e.NotebookCellOutput=ft={}));var wt;(function(Fe){function Ae(Oe){return ae(Oe)?{include:(0,p.withNullAsUndefined)(ze.from(Oe.include)),exclude:(0,p.withNullAsUndefined)(ze.from(Oe.exclude))}:(0,p.withNullAsUndefined)(ze.from(Oe))}Fe.from=Ae;function Te(Oe){return ae(Oe)?{include:ze.to(Oe.include),exclude:ze.to(Oe.exclude)}:ze.to(Oe)}Fe.to=Te;function ae(Oe){const We=Oe;return We?!(0,p.isUndefinedOrNull)(We.include)&&!(0,p.isUndefinedOrNull)(We.exclude):!1}})(wt||(e.NotebookExclusiveDocumentPattern=wt={}));var Lt;(function(Fe){function Ae(Te,ae,Oe){const We=typeof Te.command=="string"?{title:"",command:Te.command}:Te.command;return{alignment:Te.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:ae.toInternal(We,Oe),text:Te.text,tooltip:Te.tooltip,accessibilityInformation:Te.accessibilityInformation,priority:Te.priority}}Fe.from=Ae})(Lt||(e.NotebookStatusBarItem=Lt={}));var At;(function(Fe){function Ae(Te,ae,Oe){const We=typeof Te.command=="string"?{title:"",command:Te.command}:Te.command;return{command:ae.toInternal(We,Oe),label:Te.label,description:Te.description,detail:Te.detail,documentation:Te.documentation}}Fe.from=Ae})(At||(e.NotebookKernelSourceAction=At={}));var yt;(function(Fe){function Ae(Te){return{transientOutputs:Te?.transientOutputs??!1,transientCellMetadata:Te?.transientCellMetadata??{},transientDocumentMetadata:Te?.transientDocumentMetadata??{},cellContentMetadata:Te?.cellContentMetadata??{}}}Fe.from=Ae})(yt||(e.NotebookDocumentContentOptions=yt={}));var Ft;(function(Fe){function Ae(ae){return{uri:ae.uri,provides:ae.provides}}Fe.from=Ae;function Te(ae){return new a.NotebookRendererScript(C.URI.revive(ae.uri),ae.provides)}Fe.to=Te})(Ft||(e.NotebookRendererScript=Ft={}));var Ot;(function(Fe){function Ae(ae){return{message:F.fromStrict(ae.message)||"",type:0,expected:ae.expectedOutput,actual:ae.actualOutput,location:ae.location&&{range:t.from(ae.location.range),uri:ae.location.uri}}}Fe.from=Ae;function Te(ae){const Oe=new a.TestMessage(typeof ae.message=="string"?ae.message:F.to(ae.message));return Oe.actualOutput=ae.actual,Oe.expectedOutput=ae.expected,Oe.location=ae.location?Z.to(ae.location):void 0,Oe}Fe.to=Te})(Ot||(e.TestMessage=Ot={}));var xt;(function(Fe){Fe.namespace=I.namespaceTestTag,Fe.denamespace=I.denamespaceTestTag})(xt||(e.TestTag=xt={}));var zt;(function(Fe){function Ae(ae){const Oe=(0,s.getPrivateApiFor)(ae).controllerId;return{extId:S.TestId.fromExtHostTestItem(ae,Oe).toString(),label:ae.label,uri:C.URI.revive(ae.uri),busy:ae.busy,tags:ae.tags.map(We=>xt.namespace(Oe,We.id)),range:D.Range.lift(t.from(ae.range)),description:ae.description||null,sortText:ae.sortText||null,error:ae.error&&F.fromStrict(ae.error)||null}}Fe.from=Ae;function Te(ae){return{parent:void 0,error:void 0,id:S.TestId.fromString(ae.extId).localId,label:ae.label,uri:C.URI.revive(ae.uri),tags:(ae.tags||[]).map(Oe=>{const{tagId:We}=xt.denamespace(Oe);return new a.TestTag(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:t.to(ae.range||void 0),canResolveChildren:!1,busy:ae.busy,description:ae.description||void 0,sortText:ae.sortText||void 0}}Fe.toPlain=Te})(zt||(e.TestItem=zt={})),function(Fe){function Ae(ae){return{id:ae.id}}Fe.from=Ae;function Te(ae){return new a.TestTag(ae.id)}Fe.to=Te}(xt||(e.TestTag=xt={}));var Nt;(function(Fe){const Ae=(ae,Oe)=>{const We=[];for(const[je,it]of Oe)S.TestId.compare(it.item.extId,je)===2&&(Oe.delete(je),We.push(it));const Ke={...zt.toPlain(ae.item),parent:void 0,taskStates:ae.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(it=>it.type===0).map(Ot.to)})),children:We.map(je=>Ae(je,Oe))};for(const je of Ke.children)je.parent=Ke;return Ke};function Te(ae){const Oe=[],We=new Map;for(const Ke of ae.items){We.set(Ke.item.extId,Ke);const je=S.TestId.root(Ke.item.extId);ae.request.targets.some(it=>it.controllerId===je&&it.testIds.includes(Ke.item.extId))&&Oe.push(Ke)}return{completedAt:ae.completedAt,results:Oe.map(Ke=>Ae(Ke,We))}}Fe.to=Te})(Nt||(e.TestResults=Nt={}));var at;(function(Fe){function Ae(We){return{covered:We.covered,total:We.covered}}function Te(We){return"line"in We?g.from(We):t.from(We)}function ae(We){return"branches"in We?{count:We.executionCount,location:Te(We.location),type:1,branches:We.branches.length?We.branches.map(Ke=>({count:Ke.executionCount,location:Ke.location&&Te(Ke.location)})):void 0}:{type:0,count:We.executionCount,location:Te(We.location)}}Fe.fromDetailed=ae;function Oe(We){return{uri:We.uri,statement:Ae(We.statementCoverage),branch:We.branchCoverage&&Ae(We.branchCoverage),function:We.functionCoverage&&Ae(We.functionCoverage),details:We.detailedCoverage?.map(ae)}}Fe.fromFile=Oe})(at||(e.TestCoverage=at={}));var ht;(function(Fe){function Ae(Te){switch(Te){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Fe.to=Ae})(ht||(e.CodeActionTriggerKind=ht={}));var Wt;(function(Fe){function Ae(ae){const Oe=new a.TypeHierarchyItem($.to(ae.kind),ae.name,ae.detail||"",C.URI.revive(ae.uri),t.to(ae.range),t.to(ae.selectionRange));return Oe._sessionId=ae._sessionId,Oe._itemId=ae._itemId,Oe}Fe.to=Ae;function Te(ae,Oe,We){if(Oe=Oe??ae._sessionId,We=We??ae._itemId,Oe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:We,kind:$.from(ae.kind),name:ae.name,detail:ae.detail??"",uri:ae.uri,range:t.from(ae.range),selectionRange:t.from(ae.selectionRange),tags:ae.tags?.map(H.from)}}Fe.from=Te})(Wt||(e.TypeHierarchyItem=Wt={}));var Mt;(function(Fe){function Ae(Te){if(Te)return{value:Te.value,tooltip:Te.tooltip}}Fe.from=Ae})(Mt||(e.ViewBadge=Mt={}));var Ct;(function(Fe){function Ae(We,Ke,je){const it=Ke.fileData;return it?new a.InternalFileDataTransferItem(new a.DataTransferFile(it.name,C.URI.revive(it.uri),it.id,(0,A.once)(()=>je(it.id)))):We===R.Mimes.uriList&&Ke.uriListData?new a.InternalDataTransferItem(Oe(Ke.uriListData)):new a.InternalDataTransferItem(Ke.asString)}Fe.to=Ae;async function Te(We,Ke){const je=await Ke.asString();if(We===R.Mimes.uriList)return{asString:je,fileData:void 0,uriListData:ae(je)};const it=Ke.asFile();return{asString:je,fileData:it?{name:it.name,uri:it.uri,id:it._itemId??it.id}:void 0}}Fe.from=Te;function ae(We){return d.UriList.split(We).map(Ke=>{if(Ke.startsWith("#"))return Ke;try{return C.URI.parse(Ke)}catch{}return Ke})}function Oe(We){return d.UriList.create(We.map(Ke=>typeof Ke=="string"?Ke:C.URI.revive(Ke)))}})(Ct||(e.DataTransferItem=Ct={}));var ct;(function(Fe){function Ae(ae,Oe){const We=ae.items.map(([Ke,je])=>[Ke,Ct.to(Ke,je,Oe)]);return new a.DataTransfer(We)}Fe.toDataTransfer=Ae;async function Te(ae){const Oe={items:[]},We=[];for(const[Ke,je]of ae)We.push((async()=>{Oe.items.push([Ke,await Ct.from(Ke,je)])})());return await Promise.all(We),Oe}Fe.from=Te})(ct||(e.DataTransfer=ct={}));var Tt;(function(Fe){function Ae(ae){return{message:ae.message,metadata:ae.metadata,title:ae.title,tooltip:ae.tooltip}}Fe.to=Ae;function Te(ae){return{kind:"reply",message:ae.message,metadata:ae.metadata,title:ae.title,tooltip:ae.tooltip}}Fe.from=Te})(Tt||(e.ChatReplyFollowup=Tt={}));var Ut;(function(Fe){function Ae(Te){return typeof Te=="string"?{title:Te,message:Te,kind:"reply"}:"commandId"in Te?{kind:"command",title:Te.title??"",commandId:Te.commandId??"",args:Te.args}:Tt.from(Te)}Fe.from=Ae})(Ut||(e.ChatFollowup=Ut={}))}),define(De[265],Ie([1,0,2,8,7,16,68]),function(me,e,_,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class m{constructor(v,R,k,p={timeout:1500,errors:3}){this._logService=v,this._documents=R,this._mainThreadBulkEdits=k,this._thresholds=p,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(v){return(R,k,p)=>{const D={dispose:this._callbacks.push([R,k,v])};return Array.isArray(p)&&p.push(D),D}}async $participateInSave(v,R){const k=_.URI.revive(v);let p=!1;const C=setTimeout(()=>p=!0,this._thresholds.timeout),D=[];try{for(const b of[...this._callbacks]){if(p)break;const r=this._documents.getDocument(k),s=await this._deliverEventAsyncAndBlameBadListeners(b,{document:r,reason:A.TextDocumentSaveReason.to(R)});D.push(s)}}finally{clearTimeout(C)}return D}_deliverEventAsyncAndBlameBadListeners([v,R,k],p){const C=this._badListeners.get(v);return typeof C=="number"&&C>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,v,R,p).then(()=>!0,D=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(D),!(D instanceof Error)||D.message!=="concurrent_edits"){const b=this._badListeners.get(v);this._badListeners.set(v,b?b+1:1),typeof b=="number"&&b>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(v,R,k,p){const C=[],D=Date.now(),{document:b,reason:r}=p,{version:s}=b,c=Object.freeze({document:b,reason:r,waitUntil(f){if(Object.isFrozen(C))throw(0,L.illegalState)("waitUntil can not be called async");C.push(Promise.resolve(f))}});try{R.apply(k,[c])}catch(f){return Promise.reject(f)}return Object.freeze(C),new Promise((f,S)=>{const I=setTimeout(()=>S(new Error("timeout")),this._thresholds.timeout);return Promise.all(C).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' finished after ${Date.now()-D}ms`),clearTimeout(I),f(i)}).catch(i=>{clearTimeout(I),S(i)})}).then(f=>{const S={edits:[]};for(const I of f)if(Array.isArray(I)&&I.every(i=>i instanceof d.TextEdit))for(const{newText:i,newEol:a,range:n}of I)S.edits.push({resource:b.uri,versionId:void 0,textEdit:{range:n&&A.Range.from(n),text:i,eol:a&&A.EndOfLine.from(a)}});if(S.edits.length!==0)return s===b.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(S):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=m}),define(De[266],Ie([1,0,15,2,16,7,102]),function(me,e,_,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class m{constructor(k,p,C,D){this.start=k,this.deletedCount=p,this.deletedItems=C,this.items=D}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(k,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,p,C){this.notebook=k,this._extHostDocument=p,this._cellData=C,this.handle=C.handle,this.uri=L.URI.revive(C.uri),this.cellKind=C.cellKind,this._outputs=C.outputs.map(d.NotebookCellOutput.to),this._internalMetadata=C.internalMetadata??{},this._metadata=Object.freeze(C.metadata??{}),this._previousResult=Object.freeze(d.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:d.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get mime(){return k._mime},set mime(D){k._mime=D},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(C)}return this._apiCell}setOutputs(k){this._outputs=k.map(d.NotebookCellOutput.to)}setOutputItems(k,p,C){const D=C.map(d.NotebookCellOutputItem.to),b=this._outputs.find(r=>r.id===k);if(b&&(p||(b.items.length=0),b.items.push(...D),b.items.length>1&&b.items.every(r=>T.isTextStreamMime(r.mime)))){const r=new Map,s=[];b.items.forEach(c=>{let f;r.has(c.mime)?f=r.get(c.mime):(f=[],r.set(c.mime,f),s.push(c.mime)),f.push(c.data)}),b.items.length=0,s.forEach(c=>{const f=T.compressOutputItemStreams(r.get(c));b.items.push({mime:c,data:f.data.buffer})})}}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(d.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=y;class v{static{this._handlePool=0}constructor(k,p,C,D,b){this._proxy=k,this._textDocumentsAndEditors=p,this._textDocuments=C,this.uri=D,this.handle=v._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=Object.freeze(b.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,b.cells]],!0,void 0),this._versionId=b.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const k=this,p={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===_.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(C){return C=k._validateIndex(C),k._cells[C].apiCell},getCells(C){return(C?k._getCells(C):k._cells).map(b=>b.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(p)}return this._notebook}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,p,C){this._versionId=k.versionId,this._isDirty=p,this.acceptDocumentPropertiesChanged({metadata:C});const D={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},b=[];for(const s of k.rawEvents)s.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1,D.contentChanges):s.kind===T.NotebookCellsChangeType.Move?this._moveCells(s.index,s.length,s.newIdx,D.contentChanges):s.kind===T.NotebookCellsChangeType.Output?(this._setCellOutputs(s.index,s.outputs),b.push({cell:this._cells[s.index].apiCell,outputs:this._cells[s.index].apiCell.outputs})):s.kind===T.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(s.index,s.outputId,s.append,s.outputItems),b.push({cell:this._cells[s.index].apiCell,outputs:this._cells[s.index].apiCell.outputs})):s.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(s.index,s.language),b.push({cell:this._cells[s.index].apiCell,document:this._cells[s.index].apiCell.document})):s.kind===T.NotebookCellsChangeType.ChangeCellContent?b.push({cell:this._cells[s.index].apiCell,document:this._cells[s.index].apiCell.document}):s.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(s.index,s.mime):s.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(s.index,s.metadata),b.push({cell:this._cells[s.index].apiCell,metadata:this._cells[s.index].apiCell.metadata})):s.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(s.index,s.internalMetadata),b.push({cell:this._cells[s.index].apiCell,executionSummary:this._cells[s.index].apiCell.executionSummary}));const r=new Map;for(let s=0;s<b.length;s++){const c=b[s],f=r.get(c.cell);if(f===void 0){const S=D.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});r.set(c.cell,S-1)}else D.cellChanges[f]={...D.cellChanges[f],...c}}return Object.freeze(D),Object.freeze(D.cellChanges),Object.freeze(D.contentChanges),D}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let p=k.start|0,C=k.end|0;return p<0&&(p=0),C>this._cells.length&&(C=this._cells.length),k.with({start:p,end:C})}_getCells(k){k=this._validateRange(k);const p=[];for(let C=k.start;C<k.end;C++)p.push(this._cells[C]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,p,C){if(this._disposed)return;const D=[],b=[],r=[];if(k.reverse().forEach(s=>{const f=s[2].map(i=>{const a=new y(this,this._textDocumentsAndEditors,i);return p||b.push(y.asModelAddData(this.apiNotebook,i)),a}),S=new m(s[0],s[1],[],f),I=this._cells.splice(s[0],s[1],...f);for(const i of I)r.push(i.uri),S.deletedItems.push(i.apiCell);D.push(S)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:b,removedDocuments:r}),C)for(const s of D)C.push(s.asApiEvent())}_moveCells(k,p,C,D){const b=this._cells.splice(k,p);this._cells.splice(C,0,...b);const r=[new m(k,p,b.map(s=>s.apiCell),[]),new m(C,0,[],b)];for(const s of r)D.push(s.asApiEvent())}_setCellOutputs(k,p){this._cells[k].setOutputs(p)}_setCellOutputItems(k,p,C,D){this._cells[k].setOutputItems(p,C,D)}_changeCellLanguage(k,p){const C=this._cells[k];C.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelLanguageChanged(C.uri,p)}_changeCellMime(k,p){const C=this._cells[k];C.apiCell.mime=p}_changeCellMetadata(k,p){this._cells[k].setMetadata(p)}_changeCellInternalMetadata(k,p){this._cells[k].setInternalMetadata(p)}getCellFromApiCell(k){return this._cells.find(p=>p.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(p=>p.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=v}),define(De[267],Ie([1,0,3,2,16,7]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class T{constructor(y,v,R,k={timeout:1500,errors:3}){this._logService=y,this._notebooksAndEditors=v,this._mainThreadBulkEdits=R,this._thresholds=k,this._onWillSaveNotebookDocumentEvent=new _.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(v,R,k)=>{const p=function(D){v.call(R,D)};return p.extension=y,this._onWillSaveNotebookDocumentEvent.event(p,void 0,k)}}async $participateInSave(y,v,R){const k=L.URI.revive(y),p=this._notebooksAndEditors.getNotebookDocument(k);if(!p)throw new Error("Unable to resolve notebook document");const C=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:p.apiNotebook,reason:d.TextDocumentSaveReason.to(v)},R,async(b,r)=>{const s=Date.now(),c=await await Promise.resolve(b);Date.now()-s>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier),!R.isCancellationRequested&&c&&(c instanceof A.WorkspaceEdit?C.push(c):this._logService.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(C.length===0)return!0;const D={edits:[]};for(const b of C){const{edits:r}=d.WorkspaceEdit.from(b);D.edits=D.edits.concat(r)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(D)}}e.ExtHostNotebookDocumentSaveParticipant=T}),define(De[138],Ie([1,0,8,16,7]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,y,v,R,k,p){this.id=m,this._proxy=y,this.notebookData=v,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=k,this._visibleRanges=R,this._viewColumn=p}get apiEditor(){if(!this._editor){const m=this;this._editor={get notebook(){return m.notebookData.apiNotebook},get selection(){return m._selections[0]},set selection(y){this.selections=[y]},get selections(){return m._selections},set selections(y){if(!Array.isArray(y)||!y.every(d.NotebookRange.isNotebookRange))throw(0,_.illegalArgument)("selections");m._selections=y,m._trySetSelections(y)},get visibleRanges(){return m._visibleRanges},revealRange(y,v){m._proxy.$tryRevealRange(m.id,L.NotebookRange.from(y),v??d.NotebookEditorRevealType.Default)},get viewColumn(){return m._viewColumn}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(m){this._visible=m}_acceptVisibleRanges(m){this._visibleRanges=m}_acceptSelections(m){this._selections=m}_trySetSelections(m){this._proxy.$trySetSelections(this.id,m.map(L.NotebookRange.from))}_acceptViewColumn(m){this._viewColumn=m}}e.ExtHostNotebookEditor=A}),define(De[268],Ie([1,0,8,3,18,16]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let T=class{constructor(y,v){this._logService=y,this._notebooksAndEditors=v,this._onDidChangeNotebookEditorSelection=new L.Emitter({onListenerError:_.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new L.Emitter({onListenerError:_.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(y,v){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,v);const R=this._notebooksAndEditors.getEditorById(y);v.visibleRanges&&R._acceptVisibleRanges(v.visibleRanges.ranges.map(A.NotebookRange.to)),v.selections&&R._acceptSelections(v.selections.selections.map(A.NotebookRange.to)),v.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),v.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const v in y)this._notebooksAndEditors.getEditorById(v)._acceptViewColumn(A.ViewColumn.to(y[v]))}};e.ExtHostNotebookEditors=T,e.ExtHostNotebookEditors=T=Ve([$e(0,d.ILogService)],T)}),define(De[269],Ie([1,0,16,128,198,21,66,8]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(p){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=p}async withProgress(p,C,D){const b=this._handles++,{title:r,location:s,cancellable:c}=C,f={label:(0,d.localize)(0,null,p.displayName||p.name),id:p.identifier.value};return this._proxy.$startProgress(b,{location:_.ProgressLocation.from(s),title:r,source:f,cancellable:c},p.isUnderDevelopment?void 0:p.identifier.value).catch(m.onUnexpectedExternalError),this._withProgress(b,D,!!c)}_withProgress(p,C,D){let b;D&&(b=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(p,b));const r=c=>{this._proxy.$progressEnd(c),this._mapHandleToCancellationSource.delete(c),b?.dispose()};let s;try{s=C(new R(this._proxy,p),D&&b?b.token:A.CancellationToken.None)}catch(c){throw r(p),c}return s.then(c=>r(p),c=>r(p)),s}$acceptProgressCanceled(p){const C=this._mapHandleToCancellationSource.get(p);C&&(C.cancel(),this._mapHandleToCancellationSource.delete(p))}}e.ExtHostProgress=y;function v(k,p){return k.message=p.message,typeof p.increment=="number"&&(typeof k.increment=="number"?k.increment+=p.increment:k.increment=p.increment),k}class R extends L.Progress{constructor(p,C){super(D=>this.throttledReport(D)),this._proxy=p,this._handle=C}throttledReport(p){this._proxy.$progressReport(this._handle,p)}}Ve([(0,T.throttle)(100,(k,p)=>v(k,p),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(De[139],Ie([1,0,33,136,59,103,82,16,2]),function(me,e,_,L,d,A,T,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const v=(f,S,I,i)=>{let a=S;return{enumerable:!0,configurable:!1,get(){return a},set(n){if(!I(a,n)){const t=a;a=n,f.listener?.(i(n,t))}}}},R=(f,S)=>f===S,k={range:(f,S)=>f===S?!0:!f||!S?!1:f.isEqual(S),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(f,S)=>!(f.length!==S.length||f.some(I=>!S.find(i=>I.id===i.id)))},p=f=>S=>({op:4,update:f(S)}),C=(f,S)=>({range:(()=>{let I;const i=p(a=>({range:_.Range.lift(m.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return I},set(a){f.listener?.({op:6}),k.range(I,a)||(I=a,f.listener?.(i(a)))}}})(),label:v(f,S,k.label,p(I=>({label:I}))),description:v(f,void 0,k.description,p(I=>({description:I}))),sortText:v(f,void 0,k.sortText,p(I=>({sortText:I}))),canResolveChildren:v(f,!1,k.canResolveChildren,I=>({op:2,state:I})),busy:v(f,!1,k.busy,p(I=>({busy:I}))),error:v(f,void 0,k.error,p(I=>({error:m.MarkdownString.fromStrict(I)||null}))),tags:v(f,[],k.tags,(I,i)=>({op:1,new:I.map(m.TestTag.from),old:i.map(m.TestTag.from)}))}),D=f=>{const S=d.TestId.fromString(f.extId),I=new r(S.controllerId,S.localId,f.label,y.URI.revive(f.uri)||void 0);return I.range=m.Range.to(f.range||void 0),I.description=f.description||void 0,I.sortText=f.sortText||void 0,I.tags=f.tags.map(i=>m.TestTag.to({id:(0,T.denamespaceTestTag)(i).tagId})),I},b=f=>{let S;for(const I of f.tests){const i=D(I.item);(0,L.getPrivateApiFor)(i).parent=S,S=i}return S};e.toItemFromContext=b;class r{constructor(S,I,i,a){if(I.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(I)} symbol`);const n=(0,L.createPrivateApiFor)(this,S);Object.defineProperties(this,{id:{value:I,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof s?void 0:n.parent}},children:{value:(0,A.createTestItemChildren)(n,L.getPrivateApiFor,r),enumerable:!0,writable:!1},...C(n,i)})}}e.TestItemImpl=r;class s extends r{constructor(S,I){super(S,S,I,void 0),this._isRoot=!0}}e.TestItemRootImpl=s;class c extends A.TestItemCollection{constructor(S,I,i){super({controllerId:S,getDocumentVersion:a=>a&&i.getDocument(a)?.version,getApiFor:L.getPrivateApiFor,getChildren:a=>a.children,root:new s(S,I),toITestItem:m.TestItem.from})}}e.ExtHostTestItemCollection=c}),define(De[140],Ie([1,0,53,8,111,16,7]),function(me,e,_,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class m{static{this._Keys=new d.IdGenerator("TextEditorDecorationType")}constructor(p,C,D){const b=m._Keys.nextId();p.$registerTextEditorDecorationType(C.identifier,b,A.DecorationRenderOptions.from(D)),this.value=Object.freeze({key:b,dispose(){p.$removeTextEditorDecorationType(b)}})}}e.TextEditorDecorationType=m;class y{constructor(p,C){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=p,this._documentVersionId=p.version,this._undoStopBefore=C.undoStopBefore,this._undoStopAfter=C.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(p,C){this._throwIfFinalized();let D=null;if(p instanceof T.Position)D=new T.Range(p,p);else if(p instanceof T.Range)D=p;else throw new Error("Unrecognized location");this._pushEdit(D,C,!1)}insert(p,C){this._throwIfFinalized(),this._pushEdit(new T.Range(p,p),C,!0)}delete(p){this._throwIfFinalized();let C=null;if(p instanceof T.Range)C=p;else throw new Error("Unrecognized location");this._pushEdit(C,null,!0)}_pushEdit(p,C,D){const b=this._document.validateRange(p);this._collectedEdits.push({range:b,text:C,forceMoveMarkers:D})}setEndOfLine(p){if(this._throwIfFinalized(),p!==T.EndOfLine.LF&&p!==T.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=p}}class v{constructor(p,C,D,b){this._proxy=p,this._id=C,this._accept(D),this._logService=b;const r=this;this.value={get tabSize(){return r._tabSize},set tabSize(s){r._setTabSize(s)},get indentSize(){return r._indentSize},set indentSize(s){r._setIndentSize(s)},get insertSpaces(){return r._insertSpaces},set insertSpaces(s){r._setInsertSpaces(s)},get cursorStyle(){return r._cursorStyle},set cursorStyle(s){r._setCursorStyle(s)},get lineNumbers(){return r._lineNumbers},set lineNumbers(s){r._setLineNumbers(s)}}}_accept(p){this._tabSize=p.tabSize,this._indentSize=p.indentSize,this._insertSpaces=p.insertSpaces,this._cursorStyle=p.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(p.lineNumbers)}_validateTabSize(p){if(p==="auto")return"auto";if(typeof p=="number"){const C=Math.floor(p);return C>0?C:null}if(typeof p=="string"){const C=parseInt(p,10);return isNaN(C)?null:C>0?C:null}return null}_setTabSize(p){const C=this._validateTabSize(p);if(C!==null){if(typeof C=="number"){if(this._tabSize===C)return;this._tabSize=C}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:C}))}}_validateIndentSize(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const C=Math.floor(p);return C>0?C:null}if(typeof p=="string"){const C=parseInt(p,10);return isNaN(C)?null:C>0?C:null}return null}_setIndentSize(p){const C=this._validateIndentSize(p);if(C!==null){if(typeof C=="number"){if(this._indentSize===C)return;this._indentSize=C}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:C}))}}_validateInsertSpaces(p){return p==="auto"?"auto":p==="false"?!1:!!p}_setInsertSpaces(p){const C=this._validateInsertSpaces(p);if(typeof C=="boolean"){if(this._insertSpaces===C)return;this._insertSpaces=C}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:C}))}_setCursorStyle(p){this._cursorStyle!==p&&(this._cursorStyle=p,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:p})))}_setLineNumbers(p){this._lineNumbers!==p&&(this._lineNumbers=p,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(p)})))}assign(p){const C={};let D=!1;if(typeof p.tabSize<"u"){const b=this._validateTabSize(p.tabSize);b==="auto"?(D=!0,C.tabSize=b):typeof b=="number"&&this._tabSize!==b&&(this._tabSize=b,D=!0,C.tabSize=b)}if(typeof p.indentSize<"u"){const b=this._validateIndentSize(p.indentSize);b==="tabSize"?(D=!0,C.indentSize=b):typeof b=="number"&&this._indentSize!==b&&(this._indentSize=b,D=!0,C.indentSize=b)}if(typeof p.insertSpaces<"u"){const b=this._validateInsertSpaces(p.insertSpaces);b==="auto"?(D=!0,C.insertSpaces=b):this._insertSpaces!==b&&(this._insertSpaces=b,D=!0,C.insertSpaces=b)}typeof p.cursorStyle<"u"&&this._cursorStyle!==p.cursorStyle&&(this._cursorStyle=p.cursorStyle,D=!0,C.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this._lineNumbers!==p.lineNumbers&&(this._lineNumbers=p.lineNumbers,D=!0,C.lineNumbers=A.TextEditorLineNumbersStyle.from(p.lineNumbers)),D&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,C))}_warnOnError(p,C){C.catch(D=>{this._logService.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this._logService.warn(D)})}}e.ExtHostTextEditorOptions=v;class R{constructor(p,C,D,b,r,s,c,f){this.id=p,this._proxy=C,this._logService=D,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=r,this._options=new v(this._proxy,this.id,s,D),this._visibleRanges=c,this._viewColumn=f;const S=this;this.value=Object.freeze({get document(){return b.value},set document(I){throw(0,L.readonly)("document")},get selection(){return S._selections&&S._selections[0]},set selection(I){if(!(I instanceof T.Selection))throw(0,L.illegalArgument)("selection");S._selections=[I],S._trySetSelection()},get selections(){return S._selections},set selections(I){if(!Array.isArray(I)||I.some(i=>!(i instanceof T.Selection)))throw(0,L.illegalArgument)("selections");S._selections=I,S._trySetSelection()},get visibleRanges(){return S._visibleRanges},set visibleRanges(I){throw(0,L.readonly)("visibleRanges")},get options(){return S._options.value},set options(I){S._disposed||S._options.assign(I)},get viewColumn(){return S._viewColumn},set viewColumn(I){throw(0,L.readonly)("viewColumn")},edit(I,i={undoStopBefore:!0,undoStopAfter:!0}){if(S._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new y(b.value,i);return I(a),S._applyEdit(a)},insertSnippet(I,i,a={undoStopBefore:!0,undoStopAfter:!0}){if(S._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!i||Array.isArray(i)&&i.length===0)n=S._selections.map(t=>A.Range.from(t));else if(i instanceof T.Position){const{lineNumber:t,column:o}=A.Position.from(i);n=[{startLineNumber:t,startColumn:o,endLineNumber:t,endColumn:o}]}else if(i instanceof T.Range)n=[A.Range.from(i)];else{n=[];for(const t of i)if(t instanceof T.Range)n.push(A.Range.from(t));else{const{lineNumber:o,column:g}=A.Position.from(t);n.push({startLineNumber:o,startColumn:g,endLineNumber:o,endColumn:g})}}return C.$tryInsertSnippet(p,b.value.version,I.value,n,a)},setDecorations(I,i){const a=i.length===0;a&&!S._hasDecorationsForKey.has(I.key)||(a?S._hasDecorationsForKey.delete(I.key):S._hasDecorationsForKey.add(I.key),S._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return C.$trySetDecorations(p,I.key,A.fromRangeOrRangeWithMessage(i));{const n=new Array(4*i.length);for(let t=0,o=i.length;t<o;t++){const g=i[t];n[4*t]=g.start.line+1,n[4*t+1]=g.start.character+1,n[4*t+2]=g.end.line+1,n[4*t+3]=g.end.character+1}return C.$trySetDecorationsFast(p,I.key,n)}}))},revealRange(I,i){S._runOnProxy(()=>C.$tryRevealRange(p,A.Range.from(I),i||T.TextEditorRevealType.Default))},show(I){C.$tryShowEditor(p,A.ViewColumn.from(I))},hide(){C.$tryHideEditor(p)}})}dispose(){(0,_.ok)(!this._disposed),this._disposed=!0}_acceptOptions(p){(0,_.ok)(!this._disposed),this._options._accept(p)}_acceptVisibleRanges(p){(0,_.ok)(!this._disposed),this._visibleRanges=p}_acceptViewColumn(p){(0,_.ok)(!this._disposed),this._viewColumn=p}_acceptSelections(p){(0,_.ok)(!this._disposed),this._selections=p}async _trySetSelection(){const p=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,p)),this.value}_applyEdit(p){const C=p.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const D=C.edits.map(r=>r.range);D.sort((r,s)=>r.end.line===s.end.line?r.end.character===s.end.character?r.start.line===s.start.line?r.start.character-s.start.character:r.start.line-s.start.line:r.end.character-s.end.character:r.end.line-s.end.line);for(let r=0,s=D.length-1;r<s;r++){const c=D[r].end;if(D[r+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const b=C.edits.map(r=>({range:A.Range.from(r.range),text:r.text,forceMoveMarkers:r.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,b,{setEndOfLine:typeof C.setEndOfLine=="number"?A.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}_runOnProxy(p){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this._logService.warn(C),null))}}e.ExtHostTextEditor=R}),define(De[270],Ie([1,0,5,219]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,_.refineServiceDecorator)(L.IEnvironmentService)}),define(De[141],Ie([1,0,25,3,13,4]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(r){this.removedDueToLooping=r}}e.DeltaExtensionsResult=T;class m{static isHostExtension(r,s,c){if(s.getExtensionDescription(r))return!1;const f=c.getExtensionDescription(r);return f?!!((f.main||f.browser)&&f.api==="none"):!1}constructor(r,s){this._activationEventsReader=r,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=s,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new _.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const r of this._extensionDescriptions){if(this._extensionsMap.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this._extensionsMap.set(r.identifier,r),this._extensionsArr.push(r);const s=this._activationEventsReader.readActivationEvents(r);if(Array.isArray(s))for(let c of s)c==="onUri"&&(c=`onUri:${_.ExtensionIdentifier.toKey(r.identifier)}`),this._activationMap.has(c)||this._activationMap.set(c,[]),this._activationMap.get(c).push(r)}}set(r){this._extensionDescriptions=r,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(r,s){this._extensionDescriptions=D(this._extensionDescriptions,s),this._extensionDescriptions=this._extensionDescriptions.concat(r);const c=m._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=D(this._extensionDescriptions,c.map(f=>f.identifier)),this._initialize(),this._onDidChange.fire(void 0),new T(c)}static _findLoopingExtensions(r){const s=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(i){this._nodesSet.has(i)||(this._nodesSet.add(i),this._nodesArr.push(i))}addArc(i,a){this.addNode(i),this.addNode(a),this._arcs.has(i)?this._arcs.get(i).push(a):this._arcs.set(i,[a])}getArcs(i){return this._arcs.has(i)?this._arcs.get(i):[]}hasOnlyGoodArcs(i,a){const n=s.getArcs(i);for(let t=0;t<n.length;t++)if(!a.has(n[t]))return!1;return!0}getNodes(){return this._nodesArr}},c=new _.ExtensionIdentifierMap;for(const i of r)if(c.set(i.identifier,i),i.extensionDependencies)for(const a of i.extensionDependencies)s.addArc(_.ExtensionIdentifier.toKey(i.identifier),_.ExtensionIdentifier.toKey(a));const f=new Set;s.getNodes().filter(i=>s.getArcs(i).length===0).forEach(i=>f.add(i));const S=s.getNodes().filter(i=>!f.has(i));let I;do{I=!1;for(let i=0;i<S.length;i++){const a=S[i];s.hasOnlyGoodArcs(a,f)&&(S.splice(i,1),i--,f.add(a),I=!0)}}while(I);return S.map(i=>c.get(i))}containsActivationEvent(r){return this._activationMap.has(r)}containsExtension(r){return this._extensionsMap.has(r)}getExtensionDescriptionsForActivationEvent(r){const s=this._activationMap.get(r);return s?s.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(r){const s=this._extensionsMap.get(r);return s||void 0}getExtensionDescriptionByUUID(r){for(const s of this._extensionsArr)if(s.uuid===r)return s}getExtensionDescriptionByIdOrUUID(r,s){return this.getExtensionDescription(r)??(s?this.getExtensionDescriptionByUUID(s):void 0)}}e.ExtensionDescriptionRegistry=m,e.basicActivationEventsReader={readActivationEvents:b=>b.activationEvents};class y{constructor(r){this._lock=new k,this._actual=new m(r,[])}async acquireLock(r){const s=await this._lock.acquire(r);return new v(this,s)}deltaExtensions(r,s,c){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(s,c)}containsActivationEvent(r){return this._actual.containsActivationEvent(r)}containsExtension(r){return this._actual.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this._actual.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getExtensionDescription(r){return this._actual.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this._actual.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,s){return this._actual.getExtensionDescriptionByIdOrUUID(r,s)}}e.LockableExtensionDescriptionRegistry=y;class v extends A.Disposable{constructor(r,s){super(),this._registry=r,this._isDisposed=!1,this._register(s)}isAcquiredFor(r){return!this._isDisposed&&this._registry===r}}e.ExtensionDescriptionRegistryLock=v;class R{constructor(r){this.name=r,this.promise=new Promise((s,c)=>{this._resolve=s})}resolve(r){this._resolve(r)}}class k{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(r){const s=new R(r);return this._pendingCustomers.push(s),this._advance(),s.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const r=this._pendingCustomers.shift();this._isLocked=!0;let s=!0;const c=setTimeout(()=>{s&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),f=()=>{s&&(clearTimeout(c),s=!1,this._isLocked=!1,this._advance())};r.resolve((0,A.toDisposable)(f))}}var p;(function(b){b[b.Builtin=0]="Builtin",b[b.User=1]="User",b[b.Dev=2]="Dev"})(p||(p={}));function C(b,r){const s=b.isBuiltin?0:b.isUnderDevelopment?2:1,c=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(s!==c)return s-c;const f=d.posix.basename(b.extensionLocation.path),S=d.posix.basename(r.extensionLocation.path);return f<S?-1:f>S?1:0}function D(b,r){const s=new _.ExtensionIdentifierSet(r);return b.filter(c=>!s.has(c.identifier))}}),define(De[271],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var _;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(_||(e.ExtHostConnectionType=_={}));class L{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(k){this.pipeName=k,this.type=1}serialize(k){k[L.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=L;class d{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(k){k[d.ENV_KEY]="1"}}e.SocketExtHostConnection=d;class A{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(k){k[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A;function T(R){delete R[L.ENV_KEY],delete R[d.ENV_KEY],delete R[A.ENV_KEY]}function m(R,k){T(k),R.serialize(k)}e.writeExtHostConnection=m;function y(R){if(R[L.ENV_KEY])return v(R,new L(R[L.ENV_KEY]));if(R[d.ENV_KEY])return v(R,new d);if(R[A.ENV_KEY])return v(R,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function v(R,k){return T(R),k}}),define(De[105],Ie([1,0,22]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(v){v[v.Desktop=1]="Desktop",v[v.Web=2]="Web"})(L||(e.UIKind=L={}));var d;(function(v){v[v.VersionMismatch=55]="VersionMismatch",v[v.UnexpectedError=81]="UnexpectedError"})(d||(e.ExtensionHostExitCode=d={}));var A;(function(v){v[v.Initialized=0]="Initialized",v[v.Ready=1]="Ready",v[v.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function T(v){const R=_.VSBuffer.alloc(1);switch(v){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=T;function m(v,R){if(v.byteLength!==1)return!1;switch(v.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=m;var y;(function(v){v.Start="START_NATIVE_LOG",v.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(De[83],Ie([1,0,5,3,18,26,105,79,80,23,2,4,200]),function(me,e,_,L,d,A,T,m,y,v,R,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let C=class extends k.Disposable{constructor(s,c){super(),this.initData=s,this.loggerService=c,this._onDidChangeTelemetryEnabled=this._register(new L.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new L.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=R.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=c.createLogger(this.extHostTelemetryLogFile,{id:y.extensionTelemetryLogChannelId,name:(0,p.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(c.onDidChangeLogLevel(f=>{(0,d.isLogLevel)(f)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===d.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(s,c,f){const S=this.getTelemetryDetails(),I=new D(c,f,s,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(s),{isUsageEnabled:S.isUsageEnabled,isErrorsEnabled:S.isErrorsEnabled}),i=this._telemetryLoggers.get(s.identifier.value)??[];return this._telemetryLoggers.set(s.identifier.value,[...i,I]),I.apiTelemetryLogger}$initializeTelemetryLevel(s,c,f){this._level=s,this._telemetryIsSupported=c,this._productConfig=f??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(s){const c=Object.create(null);switch(c["common.extname"]=`${s.publisher}.${s.name}`,c["common.extversion"]=s.version,c["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,c["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,c["common.vscodeversion"]=this.initData.version,c["common.isnewappinstall"]=b(this.initData.telemetryInfo.firstSessionDate),c["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case T.UIKind.Web:c["common.uikind"]="web";break;case T.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,m.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),c}$onDidChangeTelemetryLevel(s){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=s;const c=this.getTelemetryDetails();this._telemetryLoggers.forEach((f,S)=>{const I=f.filter(i=>!i.isDisposed);I.length===0?this._telemetryLoggers.delete(S):this._telemetryLoggers.set(S,I)}),this._telemetryLoggers.forEach(f=>{for(const S of f)S.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(s,c){const S=this._telemetryLoggers.get(s.value)?.filter(i=>!i.isDisposed);if(!S)return this._telemetryLoggers.delete(s.value),!1;let I=!1;for(const i of S)i.ignoreUnhandledExtHostErrors||(i.logError(c),I=!0);return I}};e.ExtHostTelemetry=C,e.ExtHostTelemetry=C=Ve([$e(0,A.IExtHostInitDataService),$e(1,d.ILoggerService)],C);class D{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,c,f,S,I,i,a){this._extension=f,this._logger=S,this._inLoggingOnlyMode=I,this._commonProperties=i,this._onDidChangeEnableStates=new L.Emitter,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=c?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=c?.additionalCommonProperties,this._sender=s,this._telemetryEnablements={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(s,c){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:s,isErrorsEnabled:c},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(s){let c="properties"in s?s.properties??{}:s;return c=(0,y.cleanData)(c,[]),this._additionalCommonProperties&&(c=(0,v.mixin)(c,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(c=(0,v.mixin)(c,this._commonProperties)),"properties"in s?s.properties=c:s=c,s}logEvent(s,c){this._sender&&(this._extension.publisher==="vscode"?s=this._extension.name+"/"+s:s=this._extension.identifier.value+"/"+s,c=this.mixInCommonPropsAndCleanData(c||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(s,c),this._logger.trace(s,c))}logUsage(s,c){this._telemetryEnablements.isUsageEnabled&&this.logEvent(s,c)}logError(s,c){!this._telemetryEnablements.isErrorsEnabled||!this._sender||(typeof s=="string"?this.logEvent(s,c):this._sender.sendErrorData(s,c))}get apiTelemetryLogger(){if(!this._apiObject){const s=this,c={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return s._telemetryEnablements.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s._onDidChangeEnableStates.event.bind(s)};this._apiObject=Object.freeze(c)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let s=this._sender;this._sender=void 0,Promise.resolve(s.flush()).then(s=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=D;function b(r){const s=Date.now()-new Date(r).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.isNewAppInstall=b,e.IExtHostTelemetry=(0,_.createDecorator)("IExtHostTelemetry")}),define(De[27],Ie([1,0,3,2,240,131,25,5]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,m.createDecorator)("extensionService");class y{constructor(I){this.dependency=I}}e.MissingExtensionDependency=y;var v;(function(S){S[S.EagerAutoStart=1]="EagerAutoStart",S[S.EagerManualStart=2]="EagerManualStart",S[S.Lazy=3]="Lazy"})(v||(e.ExtensionHostStartup=v={}));class R{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,addActivationEvents:A.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions),myToRemove:[],myToAdd:this._myExtensions}}set(I,i){const a=[],n=[],t=[],o=[],g=k(this._allExtensions),l=k(I),h=(O,N)=>O.extensionLocation.toString()===N.extensionLocation.toString()||O.isBuiltin===N.isBuiltin||O.isUserBuiltin===N.isUserBuiltin||O.isUnderDevelopment===N.isUnderDevelopment;for(const O of this._allExtensions){const N=l.get(O.identifier);if(!N){a.push(O.identifier),g.delete(O.identifier);continue}if(!h(O,N)){a.push(O.identifier),g.delete(O.identifier);continue}}for(const O of I){const N=g.get(O.identifier);if(!N){n.push(O);continue}if(!h(N,O)){a.push(N.identifier),g.delete(N.identifier);continue}}const w=new T.ExtensionIdentifierSet(this._myExtensions),u=new T.ExtensionIdentifierSet(i);for(const O of this._myExtensions)u.has(O)||t.push(O);for(const O of i)w.has(O)||o.push(O);const E=A.ImplicitActivationEvents.createActivationEventsMap(n),P={toRemove:a,toAdd:n,addActivationEvents:E,myToRemove:t,myToAdd:o};return this.delta(P),P}delta(I){const{toRemove:i,toAdd:a,myToRemove:n,myToAdd:t}=I,o=new T.ExtensionIdentifierSet(i),g=new T.ExtensionIdentifierSet(n);for(let l=0;l<this._allExtensions.length;l++)o.has(this._allExtensions[l].identifier)&&(this._allExtensions.splice(l,1),l--);for(let l=0;l<this._myExtensions.length;l++)g.has(this._myExtensions[l])&&(this._myExtensions.splice(l,1),l--);for(const l of a)this._allExtensions.push(l);for(const l of t)this._myExtensions.push(l)}containsExtension(I){for(const i of this._myExtensions)if(T.ExtensionIdentifier.equals(i,I))return!0;return!1}}e.ExtensionHostExtensions=R;function k(S){const I=new T.ExtensionIdentifierMap;for(const i of S)I.set(i.identifier,i);return I}function p(S,I){return S.enabledApiProposals?S.enabledApiProposals.includes(I):!1}e.isProposedApiEnabled=p;function C(S,I){if(!p(S,I))throw new Error(`Extension '${S.identifier.value}' CANNOT use API proposal: ${I}.
Its package.json#enabledApiProposals-property declares: ${S.enabledApiProposals?.join(", ")??"[]"} but NOT ${I}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${S.identifier.value}`)}e.checkProposedApiEnabled=C;class D{constructor(I,i,a,n){this.codeLoadingTime=I,this.activateCallTime=i,this.activateResolvedTime=a,this.activationReason=n}}e.ActivationTimes=D;class b{constructor(I,i){this.description=I,this.value=i}}e.ExtensionPointContribution=b;var r;(function(S){S[S.Normal=0]="Normal",S[S.Immediate=1]="Immediate"})(r||(e.ActivationKind=r={}));function s(S){return{type:S.isBuiltin?0:1,isBuiltin:S.isBuiltin||S.isUserBuiltin,identifier:{id:(0,d.getGalleryExtensionId)(S.publisher,S.name),uuid:S.uuid},manifest:S,location:S.extensionLocation,targetPlatform:S.targetPlatform,validations:[],isValid:!0}}e.toExtension=s;function c(S,I){return{identifier:new T.ExtensionIdentifier((0,d.getExtensionId)(S.manifest.publisher,S.manifest.name)),isBuiltin:S.type===0,isUserBuiltin:S.type===1&&S.isBuiltin,isUnderDevelopment:!!I,extensionLocation:S.location,...S.manifest,uuid:S.identifier.uuid,targetPlatform:S.targetPlatform}}e.toExtensionDescription=c;class f{constructor(){this.onDidRegisterExtensions=_.Event.None,this.onDidChangeExtensionsStatus=_.Event.None,this.onDidChangeExtensions=_.Event.None,this.onWillActivateByEvent=_.Event.None,this.onDidChangeResponsiveChange=_.Event.None,this.onWillStop=_.Event.None,this.extensions=[]}activateByEvent(I){return Promise.resolve(void 0)}activationEventIsDone(I){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(I){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(I,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(I){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=f}),define(De[272],Ie([1,0,8,141,25,27,18,17]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{static{this.NONE=new y(!1,-1,-1,-1)}constructor(s,c,f,S){this.startup=s,this.codeLoadingTime=c,this.activateCallTime=f,this.activateResolvedTime=S}}e.ExtensionActivationTimes=y;class v{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,c){return s===-1||c===-1?-1:c-s}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=v;class R{constructor(s,c,f,S,I,i){this.activationFailed=s,this.activationFailedError=c,this.activationTimes=f,this.module=S,this.exports=I,this.subscriptions=i}}e.ActivatedExtension=R;class k extends R{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class p extends R{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=p;class C extends R{constructor(s){super(!0,s,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let D=class{constructor(s,c,f,S){this._logService=S,this._registry=s,this._globalRegistry=c,this._host=f,this._operations=new d.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[s,c]of this._operations)c.dispose()}async waitForActivatingExtensions(){const s=[];for(const[c,f]of this._operations)s.push(f.wait());await Promise.all(s)}isActivated(s){const c=this._operations.get(s);return!!(c&&c.value)}getActivatedExtension(s){const c=this._operations.get(s);if(!c||!c.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return c.value}async activateByEvent(s,c){if(this._alreadyActivatedEvents[s])return;const f=this._registry.getExtensionDescriptionsForActivationEvent(s);await this._activateExtensions(f.map(S=>({id:S.identifier,reason:{startup:c,extensionId:S.identifier,activationEvent:s}}))),this._alreadyActivatedEvents[s]=!0}activateById(s,c){const f=this._registry.getExtensionDescription(s);if(!f)throw new Error(`Extension '${s}' is not known`);return this._activateExtensions([{id:f.identifier,reason:c}])}async _activateExtensions(s){const c=s.filter(f=>!this.isActivated(f.id)).map(f=>this._handleActivationRequest(f));await Promise.all(c.map(f=>f.wait()))}_handleActivationRequest(s){if(this._operations.has(s.id))return this._operations.get(s.id);if(this._isHostExtension(s.id))return this._createAndSaveOperation(s,null,[],null);const c=this._registry.getExtensionDescription(s.id);if(!c){const I=new Error(`Cannot activate unknown extension '${s.id.value}'`),i=this._createAndSaveOperation(s,null,[],new C(I));return this._host.onExtensionActivationError(s.id,I,new A.MissingExtensionDependency(s.id.value)),i}const f=[],S=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const I of S){if(this._isResolvedExtension(I))continue;const i=this._operations.get(I);if(i){f.push(i);continue}if(this._isHostExtension(I)){f.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(I).identifier,reason:s.reason}));continue}const a=this._registry.getExtensionDescription(I);if(a){if(!a.main&&!a.browser)continue;f.push(this._handleActivationRequest({id:a.identifier,reason:s.reason}));continue}const n=c.displayName||c.identifier.value,t=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${I}'`),o=this._createAndSaveOperation(s,c.displayName,[],new C(t));return this._host.onExtensionActivationError(c.identifier,t,new A.MissingExtensionDependency(I)),o}return this._createAndSaveOperation(s,c.displayName,f,null)}_createAndSaveOperation(s,c,f,S){const I=new b(s.id,c,s.reason,f,S,this._host,this._logService);return this._operations.set(s.id,I),I}_isHostExtension(s){return L.ExtensionDescriptionRegistry.isHostExtension(s,this._registry,this._globalRegistry)}_isResolvedExtension(s){const c=this._globalRegistry.getExtensionDescription(s);return c?!c.main&&!c.browser:!1}};e.ExtensionsActivator=D,e.ExtensionsActivator=D=Ve([$e(3,T.ILogService)],D);let b=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(s,c,f,S,I,i,a){this._id=s,this._displayName=c,this._reason=f,this._deps=S,this._value=I,this._host=i,this._logService=a,this._barrier=new m.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let s=0;s<this._deps.length;s++){const c=this._deps[s];if(c.value&&!c.value.activationFailed){this._deps.splice(s,1),s--;continue}if(c.value&&c.value.activationFailed){const f=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);f.detail=c.value.activationFailedError,this._value=new C(f),this._host.onExtensionActivationError(this._id,f,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(s=>s.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(s){const c=new Error;if(s&&s.name&&(c.name=s.name),s&&s.message?c.message=`Activating extension '${this._id.value}' failed: ${s.message}.`:c.message=`Activating extension '${this._id.value}' failed: ${s}.`,s&&s.stack&&(c.stack=s.stack),this._value=new C(c),this._isDisposed&&_.isCancellationError(s))return;this._host.onExtensionActivationError(this._id,c,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(s)}}};b=Ve([$e(6,T.ILogService)],b)}),define(De[273],Ie([1,0,202,7,24,2,3,4,254,17,7,14,19,16,74,21,166,27]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function c(I,i){if((0,k.isString)(I))return{label:I};if(I&&typeof I=="object"&&typeof I.label=="string"){let a;return Array.isArray(I.highlights)&&(a=I.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),a=a.length?a:void 0),{label:I.label,highlights:a}}}class f{constructor(i,a,n){this._proxy=i,this.commands=a,this.logService=n,this.treeViews=new Map,this.treeDragAndDropService=new r.TreeViewsDnDService;function t(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}a.registerArgumentProcessor({processArgument:o=>t(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(g=>t(g)?this.convertArgument(g):g):o})}registerTreeDataProvider(i,a,n){const t=this.createTreeView(i,{treeDataProvider:a},n);return{dispose:()=>t.dispose()}}createTreeView(i,a,n){if(!a||!a.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=a.dragAndDropController?.dropMimeTypes??[],o=a.dragAndDropController?.dragMimeTypes??[],g=!!a.dragAndDropController?.handleDrag,l=!!a.dragAndDropController?.handleDrop,h=this.createExtHostTreeView(i,a,n),w={showCollapseAll:!!a.showCollapseAll,canSelectMany:!!a.canSelectMany,dropMimeTypes:t,dragMimeTypes:o,hasHandleDrag:g,hasHandleDrop:l,manuallyManageCheckboxes:!!a.manageCheckboxStateManually},u=this._proxy.$registerTreeViewDataProvider(i,w);return{get onDidCollapseElement(){return h.onDidCollapseElement},get onDidExpandElement(){return h.onDidExpandElement},get selection(){return h.selectedElements},get onDidChangeSelection(){return h.onDidChangeSelection},get activeItem(){return(0,s.checkProposedApiEnabled)(n,"treeViewActiveItem"),h.focusedElement},get onDidChangeActiveItem(){return(0,s.checkProposedApiEnabled)(n,"treeViewActiveItem"),h.onDidChangeActiveItem},get visible(){return h.visible},get onDidChangeVisibility(){return h.onDidChangeVisibility},get onDidChangeCheckboxState(){return h.onDidChangeCheckboxState},get message(){return h.message},set message(P){(0,D.isMarkdownString)(P)&&(0,s.checkProposedApiEnabled)(n,"treeViewMarkdownMessage"),h.message=P},get title(){return h.title},set title(P){h.title=P},get description(){return h.description},set description(P){h.description=P},get badge(){return h.badge},set badge(P){P!==void 0&&R.ViewBadge.isViewBadge(P)?h.badge={value:Math.floor(Math.abs(P.value)),tooltip:P.tooltip}:P===void 0&&(h.badge=void 0)},reveal:(P,O)=>h.reveal(P,O),dispose:async()=>{await u,this.treeViews.delete(i),h.dispose()}}}$getChildren(i,a){const n=this.treeViews.get(i);return n?n.getChildren(a):Promise.reject(new y.NoTreeViewError(i))}async $handleDrop(i,a,n,t,o,g,l,h){const w=this.treeViews.get(i);if(!w)return Promise.reject(new y.NoTreeViewError(i));const u=C.DataTransfer.toDataTransfer(n,async E=>(await this._proxy.$resolveDropFileData(i,a,E)).buffer);return l===i&&h&&await this.addAdditionalTransferItems(u,w,h,o,g),w.onDrop(u,t,o)}async addAdditionalTransferItems(i,a,n,t,o){const g=this.treeDragAndDropService.removeDragOperationTransfer(o);if(g)(await g)?.forEach((l,h)=>{l&&i.set(h,l)});else if(o&&a.handleDrag){const l=a.handleDrag(n,i,t);this.treeDragAndDropService.addDragOperationTransfer(o,l),await l}return i}async $handleDrag(i,a,n,t){const o=this.treeViews.get(i);if(!o)return Promise.reject(new y.NoTreeViewError(i));const g=await this.addAdditionalTransferItems(new L.DataTransfer,o,a,t,n);if(!(!g||t.isCancellationRequested))return C.DataTransfer.from(g)}async $hasResolve(i){const a=this.treeViews.get(i);if(!a)throw new y.NoTreeViewError(i);return a.hasResolve}$resolve(i,a,n){const t=this.treeViews.get(i);if(!t)throw new y.NoTreeViewError(i);return t.resolveTreeItem(a,n)}$setExpanded(i,a,n){const t=this.treeViews.get(i);if(!t)throw new y.NoTreeViewError(i);t.setExpanded(a,n)}$setSelectionAndFocus(i,a,n){const t=this.treeViews.get(i);if(!t)throw new y.NoTreeViewError(i);t.setSelectionAndFocus(a,n)}$setVisible(i,a){const n=this.treeViews.get(i);if(!n)throw new y.NoTreeViewError(i);n.setVisible(a)}$changeCheckboxState(i,a){const n=this.treeViews.get(i);if(!n)throw new y.NoTreeViewError(i);n.setCheckboxState(a)}createExtHostTreeView(i,a,n){const t=new S(i,a,this._proxy,this.commands.converter,this.logService,n);return this.treeViews.set(i,t),t}convertArgument(i){const a=this.treeViews.get(i.$treeViewId);return a&&"$treeItemHandle"in i?a.getExtensionElement(i.$treeItemHandle):a&&"$focusedTreeItem"in i&&i.$focusedTreeItem?a.focusedElement:null}}e.ExtHostTreeViews=f;class S extends m.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(i=>this.getExtensionElement(i)).filter(i=>!(0,k.isUndefinedOrNull)(i))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(i,a,n,t,o,g){if(super(),this.viewId=i,this.proxy=n,this.commands=t,this.logService=o,this.extension=g,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new T.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new T.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new b.CancellationTokenSource,g.contributes&&g.contributes.views)for(const w in g.contributes.views)for(const u of g.contributes.views[w])u.id===i&&(this._title=u.name);this.dataProvider=a.treeDataProvider,this.dndController=a.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(w=>this._onDidChangeData.fire({message:!1,element:w})));let l,h;this._register(T.Event.debounce(this._onDidChangeData.event,(w,u)=>(w||(w={message:!1,elements:[]}),u.element!==!1&&(l||(l=new Promise(E=>h=E),this.refreshPromise=this.refreshPromise.then(()=>l)),Array.isArray(u.element)?w.elements.push(...u.element):w.elements.push(u.element)),u.message&&(w.message=!0),w),200,!0)(({message:w,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const E=h;return l=null,this.refresh(u).then(()=>E())})),w&&this.proxy.$setMessage(this.viewId,C.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(i){const a=i?this.getExtensionElement(i):void 0;if(i&&!a)return this.logService.error(`No tree item with id '${i}' found.`),Promise.resolve([]);let n=this.getChildrenNodes(i);return n||(n=await this.fetchChildrenNodes(a)),n?n.map(t=>t.item):void 0}getExtensionElement(i){return this.elements.get(i)}reveal(i,a){a=a||{select:!0,focus:!1};const n=(0,k.isUndefinedOrNull)(a.select)?!0:a.select,t=(0,k.isUndefinedOrNull)(a.focus)?!1:a.focus,o=(0,k.isUndefinedOrNull)(a.expand)?!1:a.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):i?this.refreshPromise.then(()=>this.resolveUnknownParentChain(i)).then(g=>this.resolveTreeNode(i,g[g.length-1]).then(l=>this.proxy.$reveal(this.viewId,{item:l.item,parentChain:g.map(h=>h.item)},{select:n,focus:t,expand:o})),g=>this.logService.error(g)):this.proxy.$reveal(this.viewId,void 0,{select:n,focus:t,expand:o})}get message(){return this._message}set message(i){this._message=i,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(i){this._title=i,this.proxy.$setTitle(this.viewId,i,this._description)}get description(){return this._description}set description(i){this._description=i,this.proxy.$setTitle(this.viewId,this._title,i)}get badge(){return this._badge}set badge(i){this._badge?.value===i?.value&&this._badge?.tooltip===i?.tooltip||(this._badge=C.ViewBadge.from(i),this.proxy.$setBadge(this.viewId,i))}setExpanded(i,a){const n=this.getExtensionElement(i);n&&(a?this._onDidExpandElement.fire(Object.freeze({element:n})):this._onDidCollapseElement.fire(Object.freeze({element:n})))}setSelectionAndFocus(i,a){const n=!(0,p.equals)(this._selectedHandles,i);this._selectedHandles=i;const t=this._focusedHandle!==a;this._focusedHandle=a,n&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),t&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(i){i!==this._visible&&(this._visible=i,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(i){const a=(await Promise.all(i.map(async n=>{const t=this.getExtensionElement(n.treeItemHandle);return t?{extensionItem:t,treeItem:await this.dataProvider.getTreeItem(t),newState:n.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);a.forEach(n=>{n.treeItem.checkboxState=n.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:a.map(n=>[n.extensionItem,n.newState])})}async handleDrag(i,a,n){const t=[];for(const o of i){const g=this.getExtensionElement(o);g&&t.push(g)}if(!(!this.dndController?.handleDrag||t.length===0))return await this.dndController.handleDrag(t,a,n),a}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(i,a,n){const t=a?this.getExtensionElement(a):void 0;if(!(!t&&a||!this.dndController?.handleDrop))return(0,v.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(t,i,n):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(i,a){if(!this.dataProvider.resolveTreeItem)return;const n=this.elements.get(i);if(n){const t=this.nodes.get(n);if(t){const o=await this.dataProvider.resolveTreeItem(t.extensionItem,n,a)??t.extensionItem;return this.validateTreeItem(o),t.item.tooltip=this.getTooltip(o.tooltip),t.item.command=this.getCommand(t.disposableStore,o.command),t.item}}}resolveUnknownParentChain(i){return this.resolveParent(i).then(a=>a?this.resolveUnknownParentChain(a).then(n=>this.resolveTreeNode(a,n[n.length-1]).then(t=>(n.push(t),n))):Promise.resolve([]))}resolveParent(i){const a=this.nodes.get(i);return a?Promise.resolve(a.parent?this.elements.get(a.parent.item.handle):void 0):(0,v.asPromise)(()=>this.dataProvider.getParent(i))}resolveTreeNode(i,a){const n=this.nodes.get(i);return n?Promise.resolve(n):(0,v.asPromise)(()=>this.dataProvider.getTreeItem(i)).then(t=>this.createHandle(i,t,a,!0)).then(t=>this.getChildren(a?a.item.handle:void 0).then(()=>{const o=this.getExtensionElement(t);if(o){const g=this.nodes.get(o);if(g)return Promise.resolve(g)}throw new Error(`Cannot resolve tree item for element ${t} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(i){if(i){let a;if(typeof i=="string"){const n=this.getExtensionElement(i);a=n?this.nodes.get(n):void 0}else a=i;return a&&a.children||void 0}return this.roots}async fetchChildrenNodes(i){this.clearChildren(i);const a=new b.CancellationTokenSource(this._refreshCancellationSource.token);try{const n=i?this.nodes.get(i):void 0,t=await this.dataProvider.getChildren(i);if(a.token.isCancellationRequested)return;const o=await Promise.all((0,p.coalesce)(t||[]).map(async g=>{const l=await this.dataProvider.getTreeItem(g);return l&&!a.token.isCancellationRequested?this.createAndRegisterTreeNode(g,l,n):null}));return a.token.isCancellationRequested?void 0:(0,p.coalesce)(o)}finally{a.dispose()}}refresh(i){if(i.some(n=>!n))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new b.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const n=this.getHandlesToRefresh(i);if(n.length)return this.refreshHandles(n)}return Promise.resolve(void 0)}getHandlesToRefresh(i){const a=new Set,n=i.map(o=>this.nodes.get(o));for(const o of n)if(o&&!a.has(o.item.handle)){let g=o;for(;g&&g.parent&&n.findIndex(l=>g&&g.parent&&l&&l.item.handle===g.parent.item.handle)===-1;){const l=this.elements.get(g.parent.item.handle);g=l?this.nodes.get(l):void 0}g&&!g.parent&&a.add(o.item.handle)}const t=[];return a.forEach(o=>{const g=this.elements.get(o);if(g){const l=this.nodes.get(g);l&&(!l.parent||!a.has(l.parent.item.handle))&&t.push(o)}}),t}refreshHandles(i){const a={};return Promise.all(i.map(n=>this.refreshNode(n).then(t=>{t&&(a[n]=t.item)}))).then(()=>Object.keys(a).length?this.proxy.$refresh(this.viewId,a):void 0)}refreshNode(i){const a=this.getExtensionElement(i);if(a){const n=this.nodes.get(a);if(n)return this.clearChildren(a),(0,v.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(t=>{if(t){const o=this.createTreeNode(a,t,n.parent);return this.updateNodeCache(a,o,n,n.parent),n.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(i,a,n){const t=this.createTreeNode(i,a,n);if(a.id&&this.elements.has(t.item.handle))throw new Error((0,_.localize)(0,null,a.id));return this.addNodeToCache(i,t),this.addNodeToParentCache(t,n),t}getTooltip(i){return R.MarkdownString.isMarkdownString(i)?C.MarkdownString.from(i):i}getCommand(i,a){return a?{...this.commands.toInternal(a,i),originalId:a.command}:void 0}getCheckbox(i){if(i.checkboxState===void 0)return;let a,n,t;return typeof i.checkboxState=="number"?a=i.checkboxState:(a=i.checkboxState.state,n=i.checkboxState.tooltip,t=i.checkboxState.accessibilityInformation),{isChecked:a===R.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:t}}validateTreeItem(i){if(!R.TreeItem.isTreeItem(i,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(i,a,n){this.validateTreeItem(a);const t=new m.DisposableStore,o=this.createHandle(i,a,n),g=this.getLightIconPath(a);return{item:{handle:o,parentHandle:n?n.item.handle:void 0,label:c(a.label,this.extension),description:a.description,resourceUri:a.resourceUri,tooltip:this.getTooltip(a.tooltip),command:this.getCommand(t,a.command),contextValue:a.contextValue,icon:g,iconDark:this.getDarkIconPath(a)||g,themeIcon:this.getThemeIcon(a),collapsibleState:(0,k.isUndefinedOrNull)(a.collapsibleState)?R.TreeItemCollapsibleState.None:a.collapsibleState,accessibilityInformation:a.accessibilityInformation,checkbox:this.getCheckbox(a)},extensionItem:a,parent:n,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(i){return i.iconPath instanceof R.ThemeIcon?i.iconPath:void 0}createHandle(i,{id:a,label:n,resourceUri:t},o,g){if(a)return`${S.ID_HANDLE_PREFIX}/${a}`;const l=c(n,this.extension),h=o?o.item.handle:S.LABEL_HANDLE_PREFIX;let w=l?l.label:t?(0,d.basename)(t):"";w=w.indexOf("/")!==-1?w.replace("/","//"):w;const u=this.nodes.has(i)?this.nodes.get(i).item.handle:void 0,E=this.getChildrenNodes(o)||[];let P,O=0;do{if(P=`${h}/${O}:${w}`,g||!this.elements.has(P)||u===P)break;O++}while(O<=E.length);return P}getLightIconPath(i){if(i.iconPath&&!(i.iconPath instanceof R.ThemeIcon))return typeof i.iconPath=="string"||A.URI.isUri(i.iconPath)?this.getIconPath(i.iconPath):this.getIconPath(i.iconPath.light)}getDarkIconPath(i){if(i.iconPath&&!(i.iconPath instanceof R.ThemeIcon)&&i.iconPath.dark)return this.getIconPath(i.iconPath.dark)}getIconPath(i){return A.URI.isUri(i)?i:A.URI.file(i)}addNodeToCache(i,a){this.elements.set(a.item.handle,i),this.nodes.set(i,a)}updateNodeCache(i,a,n,t){this.elements.delete(a.item.handle),this.nodes.delete(i),a.item.handle!==n.item.handle&&this.elements.delete(n.item.handle),this.addNodeToCache(i,a);const o=this.getChildrenNodes(t)||[],g=o.filter(l=>l.item.handle===n.item.handle)[0];g&&o.splice(o.indexOf(g),1,a)}addNodeToParentCache(i,a){a?(a.children||(a.children=[]),a.children.push(i)):(this.roots||(this.roots=[]),this.roots.push(i))}clearChildren(i){if(i){const a=this.nodes.get(i);if(a){if(a.children)for(const n of a.children){const t=this.elements.get(n.item.handle);t&&this.clear(t)}a.children=void 0}}else this.clearAll()}clear(i){const a=this.nodes.get(i);if(a){if(a.children)for(const n of a.children){const t=this.elements.get(n.item.handle);t&&this.clear(t)}this.nodes.delete(i),this.elements.delete(a.item.handle),a.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(i=>i.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(De[274],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionOptions.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveSlashCommands.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[275],Ie([1,0,214,8,40,125,100,42,25,274,234,131]),function(me,e,_,L,d,A,T,m,y,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const p=m.Registry.as(T.Extensions.JSONContribution);class C{constructor(I,i,a){this._messageHandler=I,this._extension=i,this._extensionPointId=a}_msg(I,i){this._messageHandler({type:I,message:i,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(I){this._msg(d.default.Error,I)}warn(I){this._msg(d.default.Warning,I)}info(I){this._msg(d.default.Info,I)}}e.ExtensionMessageCollector=C;class D{static _toSet(I){const i=new y.ExtensionIdentifierSet;for(let a=0,n=I.length;a<n;a++)i.add(I[a].description.identifier);return i}static compute(I,i){if(!I||!I.length)return new D(i,[]);if(!i||!i.length)return new D([],I);const a=this._toSet(I),n=this._toSet(i),t=i.filter(g=>!a.has(g.description.identifier)),o=I.filter(g=>!n.has(g.description.identifier));return new D(t,o)}constructor(I,i){this.added=I,this.removed=i}}e.ExtensionPointUserDelta=D;class b{constructor(I,i){this.name=I,this.defaultExtensionKind=i,this._handler=null,this._users=null,this._delta=null}setHandler(I){if(this._handler!==null)throw new Error("Handler already set!");this._handler=I,this._handle()}acceptUsers(I){this._delta=D.compute(this._users,I),this._users=I,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(I){(0,L.onUnexpectedError)(I)}}}e.ExtensionPoint=b;const r={type:"string",enum:["ui","workspace"],enumDescriptions:[_.localize(0,null),_.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:_.localize(2,null),properties:{vscode:{type:"string",description:_.localize(3,null),default:"^1.22.0"}}},publisher:{description:_.localize(4,null),type:"string"},displayName:{description:_.localize(5,null),type:"string"},categories:{description:_.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:_.localize(7,null)}]}},galleryBanner:{type:"object",description:_.localize(8,null),properties:{color:{description:_.localize(9,null),type:"string"},theme:{description:_.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:_.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:_.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:_.localize(13,null)},enabledApiProposals:{markdownDescription:_.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals)}},api:{markdownDescription:_.localize(15,null),type:"string",enum:["none"],enumDescriptions:[_.localize(16,null)]},activationEvents:{description:_.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:_.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:_.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:_.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:_.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:_.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:_.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:_.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:_.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:_.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:_.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:_.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:_.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:_.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:_.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:_.localize(32,null)},{label:"onUri",body:"onUri",description:_.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:_.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:_.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:_.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:_.localize(37,null)},{label:"onRenderer",description:_.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:_.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:_.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:_.localize(41,null)},{label:"*",description:_.localize(42,null),body:"*"}]}},badges:{type:"array",description:_.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:_.localize(44,null)},href:{type:"string",description:_.localize(45,null)},description:{type:"string",description:_.localize(46,null)}}}},markdown:{type:"string",description:_.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:_.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:_.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:_.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:_.localize(51,null),type:"array",items:r,default:["workspace"],defaultSnippets:[{body:["ui"],description:_.localize(52,null)},{body:["workspace"],description:_.localize(53,null)},{body:["ui","workspace"],description:_.localize(54,null)},{body:["workspace","ui"],description:_.localize(55,null)},{body:[],description:_.localize(56,null)}]},capabilities:{description:_.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:_.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:_.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[_.localize(60,null),_.localize(61,null),_.localize(62,null)]},description:{type:"string",markdownDescription:_.localize(63,null)}}},untrustedWorkspaces:{description:_.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:_.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[_.localize(66,null),_.localize(67,null),_.localize(68,null)]},restrictedConfigurations:{description:_.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:_.localize(70,null)}}}}},sponsor:{description:_.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:_.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:_.localize(73,null),type:"string"},"vscode:uninstall":{description:_.localize(74,null),type:"string"}}},icon:{type:"string",description:_.localize(75,null)},l10n:{type:"string",description:_.localize(76,null)}}};class c{constructor(){this._extensionPoints=new Map}registerExtensionPoint(I){if(this._extensionPoints.has(I.extensionPoint))throw new Error("Duplicate extension point: "+I.extensionPoint);const i=new b(I.extensionPoint,I.defaultExtensionKind);return this._extensionPoints.set(I.extensionPoint,i),I.activationEventsGenerator&&k.ImplicitActivationEvents.register(I.extensionPoint,I.activationEventsGenerator),e.schema.properties.contributes.properties[I.extensionPoint]=I.jsonSchema,p.registerSchema(s,e.schema),i}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=c;const f={ExtensionsRegistry:"ExtensionsRegistry"};m.Registry.add(f.ExtensionsRegistry,new c),e.ExtensionsRegistry=m.Registry.as(f.ExtensionsRegistry),p.registerSchema(s,e.schema),p.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:_.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals)}}]}}}})}),define(De[276],Ie([1,0,211,14,23,275,47,3]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:_.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:_.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:_.localize(2,null),default:""}}};var v;(function(p){function C(D,b,r){if(!D)return;const s=L.isString(D.type)?D.type:void 0;if(!s||s.length===0){r.error(_.localize(3,null));return}const c=[];if(Array.isArray(D.required))for(const f of D.required)L.isString(f)&&c.push(f);return{extensionId:b.value,taskType:s,required:c,properties:D.properties?d.deepClone(D.properties):{},when:D.when?T.ContextKeyExpr.deserialize(D.when):void 0}}p.from=C})(v||(v={}));const R=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,C)=>{for(const D of p)D.type&&C.push(`onTaskType:${D.type}`)},jsonSchema:{description:_.localize(4,null),type:"array",items:y}});class k{constructor(){this._onDefinitionsChanged=new m.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((C,D)=>{R.setHandler((b,r)=>{this._schema=void 0;try{for(const s of r.removed){const c=s.value;for(const f of c)this.taskTypes&&f.type&&this.taskTypes[f.type]&&delete this.taskTypes[f.type]}for(const s of r.added){const c=s.value;for(const f of c){const S=v.from(f,s.description.identifier,s.collector);S&&(this.taskTypes[S.taskType]=S)}}(r.removed.length>0||r.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}C(void 0)})})}onReady(){return this.readyPromise}get(C){return this.taskTypes[C]}all(){return Object.keys(this.taskTypes).map(C=>this.taskTypes[C])}getJsonSchema(){if(this._schema===void 0){const C=[];for(const D of this.all()){const b={type:"object",additionalProperties:!1};D.required.length>0&&(b.required=D.required.slice(0)),D.properties!==void 0?b.properties=d.deepClone(D.properties):b.properties=Object.create(null),b.properties.type={type:"string",enum:[D.taskType]},C.push(b)}this._schema={oneOf:C}}return this._schema}}e.TaskDefinitionRegistry=new k}),define(De[277],Ie([1,0,212,14,24,23,47,276]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new T.RawContextKey("taskRunning",!1,_.localize(0,null)),e.TASKS_CATEGORY={value:_.localize(1,null),original:"Tasks"};var y;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(y||(e.ShellQuoting=y={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(B){function U(X){if(!X)return B.Strong;switch(X.toLowerCase()){case"escape":return B.Escape;case"strong":return B.Strong;case"weak":return B.Weak;default:return B.Strong}}B.from=U}(y||(e.ShellQuoting=y={}));var v;(function(B){B.defaults={cwd:"${workspaceFolder}"}})(v||(e.CommandOptions=v={}));var R;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(R||(e.RevealKind=R={})),function(B){function U(X){switch(X.toLowerCase()){case"always":return B.Always;case"silent":return B.Silent;case"never":return B.Never;default:return B.Always}}B.fromString=U}(R||(e.RevealKind=R={}));var k;(function(B){B[B.Never=1]="Never",B[B.OnProblem=2]="OnProblem",B[B.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(B){function U(X){switch(X.toLowerCase()){case"always":return B.Always;case"never":return B.Never;case"onproblem":return B.OnProblem;default:return B.OnProblem}}B.fromString=U}(k||(e.RevealProblemKind=k={}));var p;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(p||(e.PanelKind=p={})),function(B){function U(X){switch(X.toLowerCase()){case"shared":return B.Shared;case"dedicated":return B.Dedicated;case"new":return B.New;default:return B.Shared}}B.fromString=U}(p||(e.PanelKind=p={}));var C;(function(B){B.defaults={echo:!0,reveal:R.Always,revealProblems:k.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(C||(e.PresentationOptions=C={}));var D;(function(B){B[B.Shell=1]="Shell",B[B.Process=2]="Process",B[B.CustomExecution=3]="CustomExecution"})(D||(e.RuntimeType=D={})),function(B){function U(j){switch(j.toLowerCase()){case"shell":return B.Shell;case"process":return B.Process;case"customExecution":return B.CustomExecution;default:return B.Process}}B.fromString=U;function X(j){switch(j){case B.Shell:return"shell";case B.Process:return"process";case B.CustomExecution:return"customExecution";default:return"process"}}B.toString=X}(D||(e.RuntimeType=D={}));var b;(function(B){function U(X){return L.isString(X)?X:X.value}B.value=U})(b||(e.CommandString=b={}));var r;(function(B){B.Clean={_id:"clean",isDefault:!1},B.Build={_id:"build",isDefault:!1},B.Rebuild={_id:"rebuild",isDefault:!1},B.Test={_id:"test",isDefault:!1};function U(j){return j===B.Clean._id||j===B.Build._id||j===B.Rebuild._id||j===B.Test._id}B.is=U;function X(j){if(j!==void 0)return L.isString(j)?U(j)?{_id:j,isDefault:!1}:void 0:j}B.from=X})(r||(e.TaskGroup=r={}));var s;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var c;(function(B){B.Workspace="workspace",B.Extension="extension",B.InMemory="inMemory",B.WorkspaceFile="workspaceFile",B.User="user";function U(X){switch(X){case B.User:return 2;case B.WorkspaceFile:return 5;default:return 6}}B.toConfigurationTarget=U})(c||(e.TaskSourceKind=c={}));var f;(function(B){B.parallel="parallel",B.sequence="sequence"})(f||(e.DependsOrder=f={}));var S;(function(B){B[B.default=1]="default",B[B.folderOpen=2]="folderOpen"})(S||(e.RunOnOptions=S={}));var I;(function(B){B.defaults={reevaluateOnRerun:!0,runOn:S.default,instanceLimit:1}})(I||(e.RunOptions=I={}));class i{constructor(U,X,j,ge,ie,te){this._label="",this._id=U,X&&(this._label=X),j&&(this.type=j),this.runOptions=ge,this.configurationProperties=ie,this._source=te}getDefinition(U){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const U={folder:this.getFolderId(),id:this._id};return JSON.stringify(U)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,X=!1){if(U===void 0)return!1;if(L.isString(U))return U===this._label||U===this.configurationProperties.identifier||X&&U===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),U&&(this._taskLoadMessages=this._taskLoadMessages.concat(U))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=i;class a extends i{constructor(U,X,j,ge,ie,te,$,H){super(U,j,void 0,$,H,X),this.command={},this._source=X,this.hasDefinedMatchers=te,ie&&(this.command=ie)}clone(){return new a(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let X;switch(this.command?this.command.runtime:void 0){case D.Shell:X="shell";break;case D.Process:X="process";break;case D.CustomExecution:X="customExecution";break;case void 0:X="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:X,_key:this._id,id:this._id}}}static is(U){return U instanceof a}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===c.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const U=this.getFolderId();if(!U)return;let X=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(X+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:X};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(U){return new a(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.CustomTask=a;class n extends i{constructor(U,X,j,ge,ie,te,$){super(U,j,ge,te,$,X),this._source=X,this.configures=ie}static is(U){return U instanceof n}fromObject(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===c.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const U=this.getFolderId();if(!U)return;let X=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(X+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:X};return JSON.stringify(j)}}e.ConfiguringTask=n;class t extends i{constructor(U,X,j,ge,ie,te,$,H,ce){super(U,j,ge,H,ce,X),this.defines=ie,this.hasDefinedMatchers=$,this.command=te,this.icon=ce.icon,this.hide=ce.hide}clone(){return new t(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof t}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.getFolderId(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(U){return new t(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.ContributedTask=t;class o extends i{constructor(U,X,j,ge,ie,te){super(U,j,ge,ie,te,X),this._source=X}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(U){return new o(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.InMemoryTask=o;var g;(function(B){B[B.Process=1]="Process",B[B.Terminal=2]="Terminal"})(g||(e.ExecutionEngine=g={})),function(B){B._default=B.Terminal}(g||(e.ExecutionEngine=g={}));var l;(function(B){B[B.V0_1_0=1]="V0_1_0",B[B.V2_0_0=2]="V2_0_0"})(l||(e.JsonSchemaVersion=l={}));class h{constructor(U){this._order=new Map;for(let X=0;X<U.length;X++)this._order.set(U[X].uri.toString(),X)}compare(U,X){const j=U.getWorkspaceFolder(),ge=X.getWorkspaceFolder();if(j&&ge){let ie=this._order.get(j.uri.toString());ie=ie===void 0?0:ie+1;let te=this._order.get(ge.uri.toString());return te=te===void 0?0:te+1,ie===te?U._label.localeCompare(X._label):ie-te}else return!j&&ge?-1:j&&!ge?1:0}}e.TaskSorter=h;var w;(function(B){B.DependsOnStarted="dependsOnStarted",B.AcquiredInput="acquiredInput",B.Start="start",B.ProcessStarted="processStarted",B.Active="active",B.Inactive="inactive",B.Changed="changed",B.Terminated="terminated",B.ProcessEnded="processEnded",B.End="end"})(w||(e.TaskEventKind=w={}));var u;(function(B){B.SingleRun="singleRun",B.Background="background"})(u||(e.TaskRunType=u={}));var E;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.FolderOpen=2]="FolderOpen",B[B.ConfigurationChange=3]="ConfigurationChange",B[B.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var P;(function(B){function U(X,j,ge,ie){if(j){const te={kind:X,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:ge,__task:j};return X==="start"?te.resolvedVariables=ie:X==="processStarted"?te.processId=ie:X==="processEnded"&&(te.exitCode=ie),Object.freeze(te)}else return Object.freeze({kind:"changed"})}B.create=U})(P||(e.TaskEvent=P={}));var O;(function(B){function U(j){const ge=Object.keys(j).sort();let ie="";for(const te of ge){let $=j[te];$ instanceof Object?$=U($):typeof $=="string"&&($=$.replace(/,/g,",,")),ie+=te+","+$+","}return ie}function X(j){const ie={_key:U(j),type:j.taskType};return Object.assign(ie,j),ie}B.create=X})(O||(e.KeyedTaskIdentifier=O={}));var N;(function(B){B.AutoDetect="task.autoDetect",B.SaveBeforeRun="task.saveBeforeRun",B.ShowDecorations="task.showDecorations",B.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",B.SlowProviderWarning="task.slowProviderWarning",B.QuickOpenHistory="task.quickOpen.history",B.QuickOpenDetail="task.quickOpen.detail",B.QuickOpenSkip="task.quickOpen.skip",B.QuickOpenShowAll="task.quickOpen.showAll",B.AllowAutomaticTasks="task.allowAutomaticTasks",B.Reconnection="task.reconnection"})(N||(e.TaskSettingId=N={}));var F;(function(B){B.Tasks="tasks",B.SuppressTaskName="tasks.suppressTaskName",B.Windows="tasks.windows",B.Osx="tasks.osx",B.Linux="tasks.linux",B.ShowOutput="tasks.showOutput",B.IsShellCommand="tasks.isShellCommand",B.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var x;(function(B){function U(X,j){const ge=m.TaskDefinitionRegistry.get(X.type);if(ge===void 0){const H=A.deepClone(X);return delete H._key,O.create(H)}const ie=Object.create(null);ie.type=ge.taskType;const te=new Set;ge.required.forEach(H=>te.add(H));const $=ge.properties;for(const H of Object.keys($)){const ce=X[H];if(ce!=null)ie[H]=ce;else if(te.has(H)){const re=$[H];if(re.default!==void 0)ie[H]=A.deepClone(re.default);else switch(re.type){case"boolean":ie[H]=!1;break;case"number":case"integer":ie[H]=0;break;case"string":ie[H]="";break;default:j.error(_.localize(2,null,JSON.stringify(X,void 0,0),H));return}}}return O.create(ie)}B.createTaskIdentifier=U})(x||(e.TaskDefinition=x={}))}),define(De[278],Ie([1,0,8]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,m)=>{this._actualOk=T,this._actualErr=m,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,_.onUnexpectedError)(T))}then(T,m){return this._ensureActual().then(T,m)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=L;class d extends L{constructor(){super(),this._hasErr=!0,this._err=new _.CancellationError}}e.CanceledLazyPromise=d}),define(De[60],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class _{static{this.count=0}constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++_.count}}e.ProxyIdentifier=_;const L=[];function d(m){const y=new _(m);return L[y.nid]=y,y}e.createProxyIdentifier=d;function A(m){return L[m].sid}e.getStringIdentifierForProxy=A;class T{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=T}),define(De[6],Ie([1,0,60]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var d;(function(b){b[b.UnknownInput=0]="UnknownInput",b[b.TextInput=1]="TextInput",b[b.TextDiffInput=2]="TextDiffInput",b[b.TextMergeInput=3]="TextMergeInput",b[b.NotebookInput=4]="NotebookInput",b[b.NotebookDiffInput=5]="NotebookDiffInput",b[b.CustomEditorInput=6]="CustomEditorInput",b[b.WebviewEditorInput=7]="WebviewEditorInput",b[b.TerminalEditorInput=8]="TerminalEditorInput",b[b.InteractiveEditorInput=9]="InteractiveEditorInput"})(d||(e.TabInputKind=d={}));var A;(function(b){b[b.TAB_OPEN=0]="TAB_OPEN",b[b.TAB_CLOSE=1]="TAB_CLOSE",b[b.TAB_UPDATE=2]="TAB_UPDATE",b[b.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var T;(function(b){b[b.Editable=0]="Editable",b[b.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var m;(function(b){b[b.Int8Array=1]="Int8Array",b[b.Uint8Array=2]="Uint8Array",b[b.Uint8ClampedArray=3]="Uint8ClampedArray",b[b.Int16Array=4]="Int16Array",b[b.Uint16Array=5]="Uint16Array",b[b.Int32Array=6]="Int32Array",b[b.Uint32Array=7]="Uint32Array",b[b.Float32Array=8]="Float32Array",b[b.Float64Array=9]="Float64Array",b[b.BigInt64Array=10]="BigInt64Array",b[b.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var y;(function(b){b[b.Text=1]="Text",b[b.Error=2]="Error",b[b.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var v;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(v||(e.NotebookEditorRevealType=v={}));var R;(function(b){b[b.None=0]="None",b[b.Process=1]="Process",b[b.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class k{static{this._n=0}static mixin(r){return r._id=k._n++,r}}e.IdObject=k;var p;(function(b){b.label="a",b.kind="b",b.detail="c",b.documentation="d",b.sortText="e",b.filterText="f",b.preselect="g",b.insertText="h",b.insertTextRules="i",b.range="j",b.commitCharacters="k",b.additionalTextEdits="l",b.kindModifier="m",b.commandIdent="n",b.commandId="o",b.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var C;(function(b){b.defaultRanges="a",b.completions="b",b.isIncomplete="c",b.duration="d"})(C||(e.ISuggestResultDtoField=C={}));var D;(function(b){b[b.Workspace=0]="Workspace",b[b.TextDocument=1]="TextDocument"})(D||(e.ExtHostTestingResource=D={})),e.MainContext={MainThreadAuthentication:(0,_.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,_.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,_.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,_.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,_.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,_.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,_.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,_.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,_.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,_.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,_.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,_.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,_.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,_.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,_.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,_.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,_.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,_.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,_.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,_.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,_.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,_.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,_.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,_.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,_.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,_.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,_.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,_.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,_.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,_.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,_.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,_.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,_.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,_.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,_.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,_.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,_.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,_.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,_.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,_.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,_.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,_.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,_.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,_.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,_.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,_.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,_.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,_.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,_.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,_.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,_.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,_.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,_.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,_.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,_.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,_.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,_.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,_.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,_.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,_.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,_.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,_.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,_.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,_.createProxyIdentifier)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,_.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,_.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,_.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,_.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,_.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,_.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,_.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,_.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,_.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,_.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,_.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,_.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,_.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,_.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,_.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,_.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,_.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,_.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,_.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,_.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,_.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,_.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,_.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,_.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,_.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,_.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,_.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,_.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,_.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,_.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,_.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,_.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,_.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,_.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,_.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,_.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,_.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,_.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,_.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,_.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,_.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,_.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,_.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,_.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,_.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,_.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,_.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,_.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,_.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,_.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,_.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,_.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,_.createProxyIdentifier)("ExtHostChat"),ExtHostSemanticSimilarity:(0,_.createProxyIdentifier)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,_.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,_.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,_.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,_.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,_.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,_.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,_.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,_.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,_.createProxyIdentifier)("ExtHostIssueReporter")}}),define(De[84],Ie([1,0,5,18,6,20]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,_.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(y,v){this._extHostLogService=v,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(d.MainContext.MainThreadTelemetry)}report(y,v,R){const k=this.getUsageKey(y,v);this._reportedUsages.has(k)||(this._reportedUsages.add(k),v.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:v.identifier.value,apiId:y}))}getUsageKey(y,v){return`${y}-${v.identifier.value}`}};e.ExtHostApiDeprecationService=T,e.ExtHostApiDeprecationService=T=Ve([$e(0,A.IExtHostRpcService),$e(1,L.ILogService)],T),e.NullApiDeprecationService=Object.freeze(new class{report(m,y,v){}})}),define(De[279],Ie([1,0,3,6,7,25]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(v){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new _.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new m,this._getSessionsTaskSingler=new m,this._proxy=v.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(v){return this._providers=v,Promise.resolve()}async getSession(v,R,k,p={}){const C=A.ExtensionIdentifier.toKey(v.identifier),D=[...k].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${C} ${R} ${D}`,async()=>{await this._proxy.$ensureProvider(R);const b=v.displayName||v.name;return this._proxy.$getSession(R,k,C,b,p)})}async getSessions(v,R,k){const p=A.ExtensionIdentifier.toKey(v.identifier),C=[...k].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${p} ${C}`,async()=>{await this._proxy.$ensureProvider(R);const D=v.displayName||v.name;return this._proxy.$getSessions(R,k,p,D)})}async removeSession(v,R){const k=this._authenticationProviders.get(v);return k?k.provider.removeSession(R):this._proxy.$removeSession(v,R)}registerAuthenticationProvider(v,R,k,p){if(this._authenticationProviders.get(v))throw new Error(`An authentication provider with id '${v}' is already registered.`);this._authenticationProviders.set(v,{label:R,provider:k,options:p??{supportsMultipleAccounts:!1}}),this._providers.find(D=>D.id===v)||this._providers.push({id:v,label:R});const C=k.onDidChangeSessions(D=>{this._proxy.$sendDidChangeSessions(v,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this._proxy.$registerAuthenticationProvider(v,R,p?.supportsMultipleAccounts??!1),new d.Disposable(()=>{C.dispose(),this._authenticationProviders.delete(v);const D=this._providers.findIndex(b=>b.id===v);D>-1&&this._providers.splice(D),this._proxy.$unregisterAuthenticationProvider(v)})}$createSession(v,R,k){const p=this._authenticationProviders.get(v);if(p)return Promise.resolve(p.provider.createSession(R,k));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$removeSession(v,R){const k=this._authenticationProviders.get(v);if(k)return Promise.resolve(k.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$getSessions(v,R){const k=this._authenticationProviders.get(v);if(k)return Promise.resolve(k.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$onDidChangeAuthenticationSessions(v,R){return this._onDidChangeSessions.fire({provider:{id:v,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=T;class m{constructor(){this._inFlightPromises=new Map}getOrCreate(v,R){const k=this._inFlightPromises.get(v);if(k)return k;const p=R().finally(()=>this._inFlightPromises.delete(v));return this._inFlightPromises.set(v,p),p}}}),define(De[280],Ie([1,0,6,20,16]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(m,y){this._proxy=m.getProxy(_.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:v=>y.getDocument(v)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,y,v){const R=d.WorkspaceEdit.from(m,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(R,void 0,v?.isRefactoring??!1)}};e.ExtHostBulkEdits=A,e.ExtHostBulkEdits=A=Ve([$e(0,L.IExtHostRpcService)],A)}),define(De[281],Ie([1,0,17,3,48,4,39,14,192,6,16]),function(me,e,_,L,d,A,T,m,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class k{static{this._pool=0}constructor(D,b){this.extension=D,this.provider=b,this.handle=k._pool++}}class p{static{this._nextId=0}constructor(D,b){this.logService=b,this._chatProvider=new Map,this._slashCommandProvider=new Map,this._chatSessions=new Map,this._onDidPerformUserAction=new L.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=D.getProxy(v.MainContext.MainThreadChat)}registerChatProvider(D,b,r){const s=new k(D,r);return this._chatProvider.set(s.handle,s),this._proxy.$registerChatProvider(s.handle,b),(0,A.toDisposable)(()=>{this._proxy.$unregisterChatProvider(s.handle),this._chatProvider.delete(s.handle)})}transferChatSession(D,b){const r=d.Iterable.find(this._chatSessions.keys(),s=>this._chatSessions.get(s)===D)??0;typeof r=="number"&&this._proxy.$transferChatSession(r,b)}addChatRequest(D){this._proxy.$addRequest(D)}sendInteractiveRequestToProvider(D,b){this._proxy.$sendRequestToProvider(D,b)}async $prepareChat(D,b,r){const s=this._chatProvider.get(D);if(!s)return;const c=await s.provider.prepareSession(b,r);if(!c)return;const f=p._nextId++;return this._chatSessions.set(f,c),{id:f,requesterUsername:c.requester?.name,requesterAvatarIconUri:c.requester?.icon,responderUsername:c.responder?.name,responderAvatarIconUri:c.responder?.icon,inputPlaceholder:c.inputPlaceholder}}async $resolveRequest(D,b,r,s){const c=this._chatProvider.get(D);if(!c)return;const f=this._chatSessions.get(b);if(!f||!c.provider.resolveRequest)return;const S=await c.provider.resolveRequest(f,r,s);if(S)return{message:typeof S.message=="string"?S.message:R.ChatReplyFollowup.from(S.message)}}async $provideWelcomeMessage(D,b){const r=this._chatProvider.get(D);if(!r||!r.provider.provideWelcomeMessage)return;const s=await r.provider.provideWelcomeMessage(b);if(s)return s.map(c=>typeof c=="string"?c:c.map(f=>R.ChatReplyFollowup.from(f)))}async $provideFollowups(D,b,r){const s=this._chatProvider.get(D);if(!s)return;const c=this._chatSessions.get(b);return!c||!s.provider.provideFollowups?void 0:(await s.provider.provideFollowups(c,r))?.map(S=>R.ChatFollowup.from(S))}$removeRequest(D,b,r){const s=this._chatProvider.get(D);if(!s)return;const c=this._chatSessions.get(b);c&&s.provider.removeRequest&&s.provider.removeRequest(c,r)}async $provideReply(D,b,r,s){const c=this._chatProvider.get(D);if(!c)return;const f=this._chatSessions.get(b);if(!f)return;const S={session:f,message:typeof r.message=="string"?r.message:R.ChatReplyFollowup.to(r.message)},I=T.StopWatch.create(!1);let i;const a={report:o=>{if(!s.isCancellationRequested)if(typeof i>"u"&&(i=I.elapsed()),"responseId"in o)this._proxy.$acceptResponseProgress(D,b,{requestId:o.responseId});else if("placeholder"in o&&"resolvedContent"in o){const g=Promise.all([this._proxy.$acceptResponseProgress(D,b,{placeholder:o.placeholder}),o.resolvedContent]);(0,_.raceCancellation)(g,s).then(l=>{if(!l)return;const[h,w]=l;this._proxy.$acceptResponseProgress(D,b,w,h??void 0)})}else this._proxy.$acceptResponseProgress(D,b,o)}};let n;try{n=await c.provider.provideResponseWithProgress(S,a,s),n||(n={errorDetails:{message:(0,y.localize)(0,null)}})}catch(o){n={errorDetails:{message:(0,y.localize)(1,null,o.message),responseIsIncomplete:!0}},this.logService.error(o)}try{if(f.saveState&&this._chatSessions.has(b)){const o=f.saveState();this._proxy.$acceptChatState(b,o)}}catch(o){this.logService.warn(o)}const t={firstProgress:i??0,totalElapsed:I.elapsed()};return{errorDetails:n.errorDetails,timings:t}}async $provideSlashCommands(D,b,r){const s=this._chatProvider.get(D);if(!s)return;const c=this._chatSessions.get(b);return!c||!s.provider.provideSlashCommands?void 0:(await s.provider.provideSlashCommands(c,r))?.map(S=>({...S,kind:R.CompletionItemKind.from(S.kind)}))}$releaseSession(D){this._chatSessions.delete(D)}async $onDidPerformUserAction(D){this._onDidPerformUserAction.fire(D)}registerSlashCommandProvider(D,b,r){const s=new k(D,r);return this._slashCommandProvider.set(s.handle,s),this._proxy.$registerSlashCommandProvider(s.handle,b),(0,A.toDisposable)(()=>{this._proxy.$unregisterSlashCommandProvider(s.handle),this._slashCommandProvider.delete(s.handle)})}async $provideProviderSlashCommands(D,b){const r=this._slashCommandProvider.get(D);return r?(await r.provider.provideSlashCommands(b))?.map(c=>({...c,kind:R.CompletionItemKind.from(c.kind)})):void 0}async $resolveSlashCommand(D,b,r){const s=this._slashCommandProvider.get(D);if(!s)return;const c=await s.provider.resolveSlashCommand(b,r);return(0,m.withNullAsUndefined)(c)}}e.ExtHostChat=p}),define(De[282],Ie([1,0,6]),function(me,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(A){const T=A.getProxy(_.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(m){return T.$writeText(m)}})}}e.ExtHostClipboard=L}),define(De[36],Ie([1,0,14,7,16,23,6,19,18,73,33,56,2,4,5,20,139,22,60,45,39,80,83]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c,f,S,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{#e;#t;#i;constructor(h,w,u){this._commands=new Map,this._apiCommands=new Map,this.#e=h.getProxy(T.MainContext.MainThreadCommands),this._logService=w,this.#i=u,this.#t=h.getProxy(T.MainContext.MainThreadTelemetry),this.converter=new n(this,E=>{const P=this._apiCommands.get(E);return P?.result===o.Void?P:void 0},w),this._argumentProcessors=[{processArgument(E){return(0,v.revive)(E)}},{processArgument(E){return(0,A.cloneAndChange)(E,function(P){if(R.Range.isIRange(P))return d.Range.to(P);if(k.Position.isIPosition(P))return d.Position.to(P);if(R.Range.isIRange(P.range)&&p.URI.isUri(P.uri))return d.location.to(P);if(P instanceof s.VSBuffer)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(h){this._argumentProcessors.push(h)}registerApiCommand(h){const w=this.registerCommand(!1,h.id,async(...u)=>{const E=h.args.map((O,N)=>{if(!O.validate(u[N]))throw new Error(`Invalid argument '${O.name}' when running '${h.id}', received: ${u[N]}`);return O.convert(u[N])}),P=await this.executeCommand(h.internalId,...E);return h.result.convert(P,u,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this._apiCommands.set(h.id,h),new L.Disposable(()=>{w.dispose(),this._apiCommands.delete(h.id)})}registerCommand(h,w,u,E,P,O){if(this._logService.trace("ExtHostCommands#registerCommand",w),!w.trim().length)throw new Error("invalid id");if(this._commands.has(w))throw new Error(`command '${w}' already exists`);return this._commands.set(w,{callback:u,thisArg:E,description:P,extension:O}),h&&this.#e.$registerCommand(w),new L.Disposable(()=>{this._commands.delete(w)&&h&&this.#e.$unregisterCommand(w)})}executeCommand(h,...w){return this._logService.trace("ExtHostCommands#executeCommand",h),this._doExecuteCommand(h,w,!0)}async _doExecuteCommand(h,w,u){if(this._commands.has(h))return this.#e.$fireCommandActivationEvent(h),this._executeContributedCommand(h,w,!1);{let E=!1;const P=(0,A.cloneAndChange)(w,function(O){if(O instanceof L.Position)return d.Position.from(O);if(O instanceof L.Range)return d.Range.from(O);if(O instanceof L.Location)return d.location.from(O);if(L.NotebookRange.isNotebookRange(O))return d.NotebookRange.from(O);if(O instanceof ArrayBuffer)return E=!0,s.VSBuffer.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return E=!0,s.VSBuffer.wrap(O);if(O instanceof s.VSBuffer)return E=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(h,E?new c.SerializableObjectWithBuffers(P):P,u);return(0,v.revive)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this._doExecuteCommand(h,w,!1);throw O}}}async _executeContributedCommand(h,w,u){const E=this._commands.get(h);if(!E)throw new Error("Unknown command");const{callback:P,thisArg:O,description:N}=E;if(N)for(let x=0;x<N.args.length;x++)try{(0,_.validateConstraint)(w[x],N.args[x].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${N.args[x].name}' - ${N.args[x].description}`)}const F=S.StopWatch.create();try{return await P.apply(O,w)}catch(x){if(h===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...w);B&&(h=B.command)}if(this._logService.error(x,h,E.extension?.identifier),!u)throw x;if(E.extension?.identifier){const B=this.#i.onExtensionError(E.extension.identifier,x);this._logService.trace("forwarded error to extension?",B,E.extension?.identifier)}throw new class extends Error{constructor(){super((0,f.toErrorMessage)(x)),this.id=h,this.source=E.extension?.displayName??E.extension?.name}}}finally{this._reportTelemetry(E,h,F.elapsed())}}_reportTelemetry(h,w,u){h.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new I.TelemetryTrustedValue(w),duration:u})}$executeContributedCommand(h,...w){this._logService.trace("ExtHostCommands#$executeContributedCommand",h);const u=this._commands.get(h);return u?(w=w.map(E=>this._argumentProcessors.reduce((P,O)=>O.processArgument(P,u.extension?.identifier),E)),this._executeContributedCommand(h,w,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this._logService.trace("ExtHostCommands#getCommands",h),this.#e.$getCommands().then(w=>(h&&(w=w.filter(u=>u[0]!=="_")),w))}$getContributedCommandHandlerDescriptions(){const h=Object.create(null);for(const[w,u]of this._commands){const{description:E}=u;E&&(h[w]=E)}return Promise.resolve(h)}};e.ExtHostCommands=a,e.ExtHostCommands=a=Ve([$e(0,b.IExtHostRpcService),$e(1,y.ILogService),$e(2,i.IExtHostTelemetry)],a),e.IExtHostCommands=(0,D.createDecorator)("IExtHostCommands");class n{constructor(h,w,u){this._commands=h,this._lookupApiCommand=w,this._logService=u,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(h,w){if(!h)return;const u={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return u;const E=this._lookupApiCommand(h.command);if(E)u.id=E.internalId,u.arguments=E.args.map((P,O)=>P.convert(h.arguments&&h.arguments[O]));else if((0,m.isNonEmptyArray)(h.arguments)){const P=`${h.command}/${++this._cachIdPool}`;this._cache.set(P,h),w.add((0,C.toDisposable)(()=>{this._cache.delete(P),this._logService.trace("CommandsConverter#DISPOSE",P)})),u.$ident=P,u.id=this.delegatingCommandId,u.arguments=[P],this._logService.trace("CommandsConverter#CREATE",h.command,P)}return u}fromInternal(h){return typeof h.$ident=="string"?this._cache.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this._cache.get(h[0])}_executeConvertedCommand(...h){const w=this.getActualCommand(...h);return this._logService.trace("CommandsConverter#EXECUTE",h[0],w?w.command:"MISSING"),w?this._commands.executeCommand(w.command,...w.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.CommandsConverter=n;class t{static{this.Uri=new t("uri","Uri of a text document",h=>p.URI.isUri(h),h=>h)}static{this.Position=new t("position","A position in a text document",h=>L.Position.isPosition(h),d.Position.from)}static{this.Range=new t("range","A range in a text document",h=>L.Range.isRange(h),d.Range.from)}static{this.Selection=new t("selection","A selection in a text document",h=>L.Selection.isSelection(h),d.Selection.from)}static{this.Number=new t("number","",h=>typeof h=="number",h=>h)}static{this.String=new t("string","",h=>typeof h=="string",h=>h)}static{this.CallHierarchyItem=new t("item","A call hierarchy item",h=>h instanceof L.CallHierarchyItem,d.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new t("item","A type hierarchy item",h=>h instanceof L.TypeHierarchyItem,d.TypeHierarchyItem.from)}static{this.TestItem=new t("testItem","A VSCodium TestItem",h=>h instanceof r.TestItemImpl,d.TestItem.from)}constructor(h,w,u,E){this.name=h,this.description=w,this.validate=u,this.convert=E}optional(){return new t(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,w){return new t(h??this.name,w??this.description,this.validate,this.convert)}}e.ApiCommandArgument=t;class o{static{this.Void=new o("no result",h=>h)}constructor(h,w){this.description=h,this.convert=w}}e.ApiCommandResult=o;class g{constructor(h,w,u,E,P){this.id=h,this.internalId=w,this.description=u,this.args=E,this.result=P}}e.ApiCommand=g}),define(De[283],Ie([1,0,19,15,2,77,123,47,127,36,16,7]),function(me,e,_,L,d,A,T,m,y,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const p=[new v.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",D(R.DocumentHighlight.to))),new v.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,s)=>{if((0,_.isFalsyOrEmpty)(r))return;class c extends k.SymbolInformation{static to(S){const I=new c(S.name,R.SymbolKind.to(S.kind),S.containerName||"",new k.Location(s[0],R.Range.to(S.range)));return I.detail=S.detail,I.range=I.location.range,I.selectionRange=R.Range.to(S.selectionRange),I.children=S.children?S.children.map(c.to):[],I}}return r.map(c.to)})),new v.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(R.TextEdit.to))),new v.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(R.TextEdit.to))),new v.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,new v.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new v.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(R.TextEdit.to))),new v.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new v.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new v.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new v.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new v.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location-instances.",D(R.location.to))),new v.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Hover-instances.",D(R.Hover.to))),new v.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(s=>k.Position.isPosition(s)),r=>r.map(R.Position.from))],new v.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(s=>{let c;for(const f of s.reverse())c=new k.SelectionRange(R.Range.to(f),c);return c}))),new v.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[v.ApiCommandArgument.String.with("query","Search string")],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(R.WorkspaceSymbol.to))),new v.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(R.CallHierarchyItem.to))),new v.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(R.CallHierarchyIncomingCall.to))),new v.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(R.CallHierarchyOutgoingCall.to))),new v.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:R.Range.to(r.range),placeholder:r.text}})),new v.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("newName","The new symbol name")],new v.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return R.WorkspaceEdit.to(r)}})),new v.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new v.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(R.DocumentLink.to))),new v.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new k.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,T.decodeSemanticTokensDto)(r);if(s.type==="full")return new k.SemanticTokens(s.data,void 0)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range.optional()],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new k.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,T.decodeSemanticTokensDto)(r);if(s.type==="full")return new k.SemanticTokens(s.data,void 0)})),new v.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new v.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,s,c)=>{if(!r)return new k.CompletionList([]);const f=r.suggestions.map(S=>R.CompletionItem.to(S,c));return new k.CompletionList(f,r.incomplete)})),new v.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new v.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return R.SignatureHelp.to(r)})),new v.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new v.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,s,c)=>D(f=>new k.CodeLens(R.Range.to(f.range),f.command&&c.fromInternal(f.command)))(r))),new v.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>k.Range.isRange(r),r=>k.Selection.isSelection(r)?R.Selection.from(r):R.Range.from(r)),v.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new v.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,s,c)=>D(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(f.command)}else{const S=new k.CodeAction(f.title,f.kind?new k.CodeActionKind(f.kind):void 0);return f.edit&&(S.edit=R.WorkspaceEdit.to(f.edit)),f.command&&(S.command=c.fromInternal(f.command)),S.isPreferred=f.isPreferred,S}})(r))),new v.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(s=>new k.ColorInformation(R.Range.to(s.range),R.Color.to(s.color))):[])),new v.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new v.ApiCommandArgument("color","The color to show and insert",r=>r instanceof k.Color,R.Color.from),new v.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:R.Range.from(r.range)}))],new v.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(R.ColorPresentation.to):[])),new v.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to an array of Inlay objects",(r,s,c)=>r.map(R.InlayHint.to.bind(void 0,c)))),new v.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(r,s)=>{if(r)return r.map(R.FoldingRange.to)})),new v.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new v.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",D(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(s=>R.NotebookExclusiveDocumentPattern.to(s))})))),new v.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(R.InlineValue.to))),new v.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new v.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",r=>d.URI.isUri(r)||typeof r=="string"&&(0,y.matchesSomeScheme)(r,L.Schemas.http,L.Schemas.https),r=>r),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[R.ViewColumn.from(r),void 0]:[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)])).optional(),v.ApiCommandArgument.String.with("label","").optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[v.ApiCommandArgument.Uri.with("resource","Resource to open"),v.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VSCodium's default editor"),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[R.ViewColumn.from(r),void 0]:[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)])).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[v.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),v.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),v.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)]).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(R.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(R.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(R.TypeHierarchyItem.to))),new v.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[v.ApiCommandArgument.TestItem],v.ApiCommandResult.Void),new v.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[v.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],v.ApiCommandResult.Void),new v.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[v.ApiCommandArgument.String.with("name","The context key name"),new v.ApiCommandArgument("value","The context key value",()=>!0,r=>r)],v.ApiCommandResult.Void)];class C{static register(s){p.forEach(s.registerApiCommand,s),this._registerValidateWhenClausesCommand(s)}static _registerValidateWhenClausesCommand(s){s.registerCommand(!1,"_validateWhenClauses",m.validateWhenClauses)}}e.ExtHostApiCommands=C;function D(r){return s=>{if(Array.isArray(s))return s.map(r)}}function b(r){if(!Array.isArray(r))return;const s=[];for(const c of r)A.isLocationLink(c)?s.push(R.DefinitionLink.to(c)):s.push(R.location.to(c));return s}}),define(De[284],Ie([1,0,17,66,3,4,2,77,25,16,7,6,27,14]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function D(b,r,s){const c=b.getProxy(k.MainContext.MainThreadComments);class f{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new y.ExtensionIdentifierMap,r.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const h=this._commentControllers.get(l.handle);return h?h.value:l}else if(l&&l.$mid===7){const h=this._commentControllers.get(l.commentControlHandle);if(!h)return l;const w=h.getCommentThread(l.commentThreadHandle);return w?w.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const h=this._commentControllers.get(l.thread.commentControlHandle);if(!h)return l;const w=h.getCommentThread(l.thread.commentThreadHandle);return w?l.$mid===8?w.value:{thread:w.value,text:l.text}:l}else if(l&&l.$mid===10){const h=this._commentControllers.get(l.thread.commentControlHandle);if(!h)return l;const w=h.getCommentThread(l.thread.commentThreadHandle);if(!w)return l;const u=l.commentUniqueId,E=w.getCommentByUniqueId(u);return E||l}else if(l&&l.$mid===11){const h=this._commentControllers.get(l.thread.commentControlHandle);if(!h)return l;const w=h.getCommentThread(l.thread.commentThreadHandle);if(!w)return l;const u=l.text,E=l.commentUniqueId,P=w.getCommentByUniqueId(E);return P?(typeof P.body=="string"?P.body=u:P.body=new R.MarkdownString(u),P):l}return l}})}createCommentController(l,h,w){const u=f.handlePool++,E=new I(l,u,h,w);this._commentControllers.set(E.handle,E);const P=this._commentControllersByExtension.get(l.identifier)||[];return P.push(E),this._commentControllersByExtension.set(l.identifier,P),E.value}$createCommentThreadTemplate(l,h,w){const u=this._commentControllers.get(l);u&&u.$createCommentThreadTemplate(h,w)}async $updateCommentThreadTemplate(l,h,w){const u=this._commentControllers.get(l);u&&u.$updateCommentThreadTemplate(h,w)}$deleteCommentThread(l,h){this._commentControllers.get(l)?.$deleteCommentThread(h)}$provideCommentingRanges(l,h,w){const u=this._commentControllers.get(l);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const E=s.getDocument(T.URI.revive(h));return(0,_.asPromise)(async()=>{const P=await u.commentingRangeProvider.provideCommentingRanges(E,w);let O;return Array.isArray(P)?O={ranges:P,fileComments:!1}:P?O={ranges:P.ranges||[],fileComments:P.fileComments||!1}:O=(0,C.withNullAsUndefined)(P),O}).then(P=>{let O;return P&&(O={ranges:P.ranges.map(N=>v.Range.from(N)),fileComments:P.fileComments}),O})}$toggleReaction(l,h,w,u,E){const P=this._commentControllers.get(l);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,_.asPromise)(()=>{const O=P.getCommentThread(h);if(O){const N=O.getCommentByUniqueId(u.uniqueIdInThread);if(P!==void 0&&N&&P.reactionHandler)return P.reactionHandler(N,n(E))}return Promise.resolve(void 0)})}}class S{static{this._handlePool=0}set threadId(l){this._id=l}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(l){(l===void 0!=(this._range===void 0)||!l||!this._range||!l.isEqual(this._range))&&(this._range=l,this.modifications.range=l,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(l){this._canReply!==l&&(this._canReply=l,this.modifications.canReply=l,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(l){this._label=l,this.modifications.label=l,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(l){this._contextValue=l,this.modifications.contextValue=l,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(l){this._comments=l,this.modifications.comments=l,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(l){this._collapseState=l,this.modifications.collapsibleState=l,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(l){this._state=l,this.modifications.state=l,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(l,h,w,u,E,P,O,N){this._commentControllerHandle=h,this._id=w,this._uri=u,this._range=E,this._comments=P,this.extensionDescription=O,this._isTemplate=N,this.handle=S._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new d.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${l}.${this.handle}`),c.$createCommentThread(h,this.handle,this._id,this._uri,v.Range.from(this._range),O.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this._localDisposables.push({dispose:()=>{c.$deleteCommentThread(h,this.handle)}});const F=this;this.value={get uri(){return F.uri},get range(){return F.range},set range(x){F.range=x},get comments(){return F.comments},set comments(x){F.comments=x},get collapsibleState(){return F.collapsibleState},set collapsibleState(x){F.collapsibleState=x},get canReply(){return F.canReply},set canReply(x){F.canReply=x},get contextValue(){return F.contextValue},set contextValue(x){F.contextValue=x},get label(){return F.label},set label(x){F.label=x},get state(){return F.state},set state(x){F.state=x},dispose:()=>{F.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const l=w=>Object.prototype.hasOwnProperty.call(this.modifications,w),h={};l("range")&&(h.range=v.Range.from(this._range)),l("label")&&(h.label=this.label),l("contextValue")&&(h.contextValue=this.contextValue??null),l("comments")&&(h.comments=this._comments.map(w=>i(this,w,this._commentsMap,this.extensionDescription))),l("collapsibleState")&&(h.collapseState=t(this._collapseState)),l("canReply")&&(h.canReply=this.canReply),l("state")&&(h.state=o(this._state)),l("isTemplate")&&(h.isTemplate=this._isTemplate),this.modifications={},c.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,h)}getCommentByUniqueId(l){for(const h of this._commentsMap){const w=h[0],u=h[1];if(l===u)return w}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(l=>l.dispose())}}Ve([(0,L.debounce)(100)],S.prototype,"eventuallyUpdateCommentThread",null);class I{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(l){this._commentingRangeProvider=l,c.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(l){this._reactionHandler=l,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this._options}set options(l){this._options=l,c.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(l,h,w,u){this._extension=l,this._handle=h,this._id=w,this._label=u,this._threads=new Map,c.$registerCommentController(this.handle,w,u);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(P){E.options=P},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(P){E.commentingRangeProvider=P},get reactionHandler(){return E.reactionHandler},set reactionHandler(P){E.reactionHandler=P},createCommentThread(P,O,N){return E.createCommentThread(P,O,N).value},dispose:()=>{E.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(l,h,w){h===void 0&&(0,p.checkProposedApiEnabled)(this._extension,"fileComments");const u=new S(this.id,this.handle,void 0,l,h,w,this._extension,!1);return this._threads.set(u.handle,u),u}$createCommentThreadTemplate(l,h){const w=new S(this.id,this.handle,void 0,T.URI.revive(l),v.Range.to(h),[],this._extension,!0);return w.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this._threads.set(w.handle,w),w}$updateCommentThreadTemplate(l,h){const w=this._threads.get(l);w&&(w.range=v.Range.to(h))}$deleteCommentThread(l){this._threads.get(l)?.dispose(),this._threads.delete(l)}getCommentThread(l){return this._threads.get(l)}dispose(){this._threads.forEach(l=>{l.dispose()}),this._localDisposables.forEach(l=>l.dispose())}}function i(g,l,h,w){let u=h.get(l);return u||(u=++g.commentHandle,h.set(l,u)),l.state!==void 0&&(0,p.checkProposedApiEnabled)(w,"commentsDraftState"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:u,body:typeof l.body=="string"?l.body:v.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(E=>a(E)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function a(g){return{label:g.label,iconPath:g.iconPath?v.pathOrURIToURI(g.iconPath):void 0,count:g.count,hasReacted:g.authorHasReacted}}function n(g){return{label:g.label||"",count:g.count||0,iconPath:g.iconPath?T.URI.revive(g.iconPath):"",authorHasReacted:g.hasReacted||!1}}function t(g){if(g!==void 0)switch(g){case R.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function o(g){if(g!==void 0)switch(g){case R.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new f}e.createExtHostComments=D}),define(De[285],Ie([1,0,23,6,26,20]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let T=class{constructor(R,k){this._mainThreadConsole=R.getProxy(L.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,k){const p=this,C=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){p._handleConsoleCall(R,k,C,arguments)}})}_handleConsoleCall(R,k,p,C){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:y(C,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,p,C)}};e.AbstractExtHostConsoleForwarder=T,e.AbstractExtHostConsoleForwarder=T=Ve([$e(0,A.IExtHostRpcService),$e(1,d.IExtHostInitDataService)],T);const m=1e5;function y(v,R){const k=[];if(v.length)for(let p=0;p<v.length;p++){let C=v[p];if(typeof C>"u")C="undefined";else if(C instanceof Error){const D=C;D.stack?C=D.stack:C=D.toString()}k.push(C)}if(R){const p=new Error().stack;p&&k.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,_.safeStringify)(k);return p.length>m?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(De[142],Ie([1,0,2,6,7,5,20,18,19,12,13,27]),function(me,e,_,L,d,A,T,m,y,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let p=class Qi{static{this._handlePool=0}static{this._maxEventSize=250}constructor(D,b){this._logService=b,this._provider=new Map,this._proxy=D.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(D,b){const r=Qi._handlePool++;this._provider.set(r,{provider:D,extensionDescription:b}),this._proxy.$registerDecorationProvider(r,b.identifier.value);const s=D.onDidChangeFileDecorations&&D.onDidChangeFileDecorations(c=>{if(!c){this._proxy.$onDidChange(r,null);return}const f=(0,y.asArray)(c);if(f.length<=Qi._maxEventSize){this._proxy.$onDidChange(r,f);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",b.identifier.value,f.length);const S=f.map(a=>({uri:a,rank:(0,v.count)(a.path,"/")})),I=(0,y.groupBy)(S,(a,n)=>a.rank-n.rank||(0,v.compare)(a.uri.path,n.uri.path)),i=[];e:for(const a of I){let n;for(const t of a){const o=(0,R.dirname)(t.uri.path);if(n!==o&&(n=o,i.push(t.uri)>=Qi._maxEventSize))break e}}this._proxy.$onDidChange(r,i)});return new d.Disposable(()=>{s?.dispose(),this._proxy.$unregisterDecorationProvider(r),this._provider.delete(r)})}async $provideDecorations(D,b,r){if(!this._provider.has(D))return Object.create(null);const s=Object.create(null),{provider:c,extensionDescription:f}=this._provider.get(D);return await Promise.all(b.map(async S=>{try{const{uri:I,id:i}=S,a=await Promise.resolve(c.provideFileDecoration(_.URI.revive(I),r));if(!a)return;try{d.FileDecoration.validate(a),a.badge&&typeof a.badge!="string"&&(0,k.checkProposedApiEnabled)(f,"codiconDecoration"),s[i]=[a.propagate,a.tooltip,a.badge,a.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${f.identifier.value}': ${n}`)}}catch(I){this._logService.error(I)}})),s}};e.ExtHostDecorations=p,e.ExtHostDecorations=p=Ve([$e(0,T.IExtHostRpcService),$e(1,m.ILogService)],p),e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(De[286],Ie([1,0,193,126,2,6,7,16,3,18,28,51]),function(me,e,_,L,d,A,T,m,y,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class p{#e;#t;#i;constructor(b,r,s,c,f,S,I,i){this._name=b,this._owner=r,this._maxDiagnosticsTotal=s,this._maxDiagnosticsPerFile=c,this._modelVersionIdProvider=f,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(c,s),this.#i=new R.ResourceMap(a=>S.getComparisonKey(a)),this.#e=I,this.#t=i}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,r){if(!b){this.clear();return}this._checkDisposed();let s=[];if(d.URI.isUri(b)){if(!r){this.delete(b);return}this.#i.set(b,r.slice()),s=[b]}else if(Array.isArray(b)){s=[];let S;b=[...b].sort(p._compareIndexedTuplesByUri);for(const I of b){const[i,a]=I;if((!S||i.toString()!==S.toString())&&(S&&this.#i.get(S).length===0&&this.#i.delete(S),S=i,s.push(i),this.#i.set(i,[])),a)this.#i.get(i)?.push(...a);else{const n=this.#i.get(i);n&&(n.length=0)}}}if(this.#t.fire(s),!this.#e)return;const c=[];let f=0;for(const S of s){let I=[];const i=this.#i.get(S);if(i)if(i.length>this._maxDiagnosticsPerFile){I=[];const a=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(const t of i)if(t.severity===a[n]&&I.push({...m.Diagnostic.from(t),modelVersionId:this._modelVersionIdProvider(S)})===this._maxDiagnosticsPerFile)break e;I.push({severity:L.MarkerSeverity.Info,message:(0,_.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:I[I.length-1].startLineNumber,startColumn:I[I.length-1].startColumn,endLineNumber:I[I.length-1].endLineNumber,endColumn:I[I.length-1].endColumn})}else I=i.map(a=>({...m.Diagnostic.from(a),modelVersionId:this._modelVersionIdProvider(S)}));if(c.push([S,I]),f+=I.length,f>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,c)}delete(b){this._checkDisposed(),this.#t.fire([b]),this.#i.delete(b),this.#e?.$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(b,r){this._checkDisposed();for(const[s,c]of this)b.call(r,s,c,this)}*[Symbol.iterator](){this._checkDisposed();for(const b of this.#i.keys())yield[b,this.get(b)]}get(b){this._checkDisposed();const r=this.#i.get(b);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(this.#i.get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,r){return b[0].toString()<r[0].toString()?-1:b[0].toString()>r[0].toString()?1:0}}e.DiagnosticCollection=p;let C=class ui{static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*ui._maxDiagnosticsPerFile}static _mapper(b){const r=new R.ResourceMap;for(const s of b)r.set(s,s);return{uris:Object.freeze(Array.from(r.values()))}}constructor(b,r,s,c){this._logService=r,this._fileSystemInfoService=s,this._extHostDocumentsAndEditors=c,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:f=>f.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,ui._mapper),this._proxy=b.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(b,r){const{_collections:s,_proxy:c,_onDidChangeDiagnostics:f,_logService:S,_fileSystemInfoService:I,_extHostDocumentsAndEditors:i}=this,a=new class{$changeMany(o,g){c.$changeMany(o,g),S.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,o,g.length===0?"CLEARING":g)}$clear(o){c.$clear(o),S.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,o)}dispose(){c.dispose()}};let n;if(!r)r="_generated_diagnostic_collection_name_#"+ui._idPool++,n=r;else if(!s.has(r))n=r;else{this._logService.warn(`DiagnosticCollection with name '${r}' does already exist.`);do n=r+ui._idPool++;while(s.has(n))}return new class extends p{constructor(){super(r,n,ui._maxDiagnosticsTotal,ui._maxDiagnosticsPerFile,o=>i.getDocument(o)?.version,I.extUri,a,f),s.set(n,this)}dispose(){super.dispose(),s.delete(n)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const r=new Map,s=[];for(const c of this._collections.values())c.forEach((f,S)=>{let I=r.get(f.toString());typeof I>"u"&&(I=s.length,r.set(f.toString(),I),s.push([f,[]])),s[I][1]=s[I][1].concat(...S)});return s}}_getDiagnostics(b){let r=[];for(const s of this._collections.values())s.has(b)&&(r=r.concat(s.get(b)));return r}$acceptMarkersChange(b){if(!this._mirrorCollection){const r="_generated_mirror",s=new p(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,c=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(r,s),this._mirrorCollection=s}for(const[r,s]of b)this._mirrorCollection.set(d.URI.revive(r),s.map(m.Diagnostic.to))}};e.ExtHostDiagnostics=C,e.ExtHostDiagnostics=C=Ve([$e(1,v.ILogService),$e(2,k.IExtHostFileSystemInfo)],C)}),define(De[287],Ie([1,0,2,6,27]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(m){this._proxy=m.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(m,y){return y?.allowUIResources&&(0,d.checkProposedApiEnabled)(m,"showLocal"),this._proxy.$showOpenDialog(y).then(v=>v?v.map(R=>_.URI.revive(R)):void 0)}showSaveDialog(m){return this._proxy.$showSaveDialog(m).then(y=>y?_.URI.revive(y):void 0)}}e.ExtHostDialogs=A}),define(De[288],Ie([1,0,8,2,7,6,15,21,12]),function(me,e,_,L,d,A,T,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class v{static{this._handlePool=0}constructor(k,p,C){this._documentsAndEditors=p,this._logService=C,this._documentContentProviders=new Map,this._proxy=k.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,p){if(Object.keys(T.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const C=v._handlePool++;this._documentContentProviders.set(C,p),this._proxy.$registerTextContentProvider(C,k);let D;return typeof p.onDidChange=="function"&&(D=p.onDidChange(b=>{if(b.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${b.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(b)&&this.$provideTextDocumentContent(C,b).then(r=>{if(!r&&typeof r!="string")return;const s=this._documentsAndEditors.getDocument(b);if(!s)return;const c=(0,y.splitLines)(r);if(!s.equalLines(c))return this._proxy.$onVirtualDocumentChange(b,r)},_.onUnexpectedError)})),new d.Disposable(()=>{this._documentContentProviders.delete(C)&&this._proxy.$unregisterTextContentProvider(C),D&&(D.dispose(),D=void 0)})}$provideTextDocumentContent(k,p){const C=this._documentContentProviders.get(k);return C?Promise.resolve(C.provideTextDocumentContent(L.URI.revive(p),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.ExtHostDocumentContentProvider=v}),define(De[289],Ie([1,0,3,4,2,6,135,16,14,23,7,8]),function(me,e,_,L,d,A,T,m,y,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class p{constructor(D,b){this._onDidAddDocument=new _.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidRemoveDocument=new _.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidChangeDocument=new _.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidSaveDocument=new _.Emitter({onListenerError:k.onUnexpectedExternalError}),this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=b,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const s of r)this._onDidRemoveDocument.fire(s.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const s of r)this._onDidAddDocument.fire(s.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(D){if(!D)return;const b=this._documentsAndEditors.getDocument(D);if(b)return b}getDocument(D){const b=this.getDocumentData(D);if(!b?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return b.document}ensureDocumentData(D){const b=this._documentsAndEditors.getDocument(D);if(b)return Promise.resolve(b);let r=this._documentLoader.get(D.toString());return r||(r=this._proxy.$tryOpenDocument(D).then(s=>{this._documentLoader.delete(D.toString());const c=d.URI.revive(s);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(c))},s=>(this._documentLoader.delete(D.toString()),Promise.reject(s))),this._documentLoader.set(D.toString(),r)),r}createDocumentData(D){return this._proxy.$tryCreateDocument(D).then(b=>d.URI.revive(b))}$acceptModelLanguageChanged(D,b){const r=d.URI.revive(D),s=this._documentsAndEditors.getDocument(r);if(!s)throw new Error("unknown document");this._onDidRemoveDocument.fire(s.document),s._acceptLanguageId(b),this._onDidAddDocument.fire(s.document)}$acceptModelSaved(D){const b=d.URI.revive(D),r=this._documentsAndEditors.getDocument(b);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(D,b){const r=d.URI.revive(D),s=this._documentsAndEditors.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(b),this._onDidChangeDocument.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,b,r){const s=d.URI.revive(D),c=this._documentsAndEditors.getDocument(s);if(!c)throw new Error("unknown document");c._acceptIsDirty(r),c.onEvents(b);let f;b.isUndoing?f=R.TextDocumentChangeReason.Undo:b.isRedoing&&(f=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,v.deepFreeze)({document:c.document,contentChanges:b.changes.map(S=>({range:m.Range.to(S.range),rangeOffset:S.rangeOffset,rangeLength:S.rangeLength,text:S.text})),reason:f}))}setWordDefinitionFor(D,b){(0,T.setWordDefinitionFor)(D,b)}}e.ExtHostDocuments=p}),define(De[61],Ie([1,0,53,3,4,2,5,6,135,20,140,16,18,28,15,48,54]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class s{constructor(S){this.value=S,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let c=class{constructor(S,I){this._extHostRpc=S,this._logService=I,this._activeEditorId=null,this._editors=new Map,this._documents=new C.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(S){this.acceptDocumentsAndEditorsDelta(S)}acceptDocumentsAndEditorsDelta(S){const I=[],i=[],a=[];if(S.removedDocuments)for(const n of S.removedDocuments){const t=A.URI.revive(n),o=this._documents.get(t);o?.unref()&&(this._documents.delete(t),I.push(o.value))}if(S.addedDocuments)for(const n of S.addedDocuments){const t=A.URI.revive(n.uri);let o=this._documents.get(t);if(o&&t.scheme!==D.Schemas.vscodeNotebookCell&&t.scheme!==D.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);o||(o=new s(new y.ExtHostDocumentData(this._extHostRpc.getProxy(m.MainContext.MainThreadDocuments),t,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(t,o),i.push(o.value)),o.ref()}if(S.removedEditors)for(const n of S.removedEditors){const t=this._editors.get(n);this._editors.delete(n),t&&a.push(t)}if(S.addedEditors)for(const n of S.addedEditors){const t=A.URI.revive(n.documentUri);_.ok(this._documents.has(t),`document '${t}' does not exist`),_.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const o=this._documents.get(t).value,g=new R.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(m.MainContext.MainThreadTextEditors),this._logService,new r.Lazy(()=>o.document),n.selections.map(k.Selection.to),n.options,n.visibleRanges.map(l=>k.Range.to(l)),typeof n.editorPosition=="number"?k.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,g)}S.newActiveEditor!==void 0&&(_.ok(S.newActiveEditor===null||this._editors.has(S.newActiveEditor),`active editor '${S.newActiveEditor}' does not exist`),this._activeEditorId=S.newActiveEditor),(0,d.dispose)(I),(0,d.dispose)(a),S.removedDocuments&&this._onDidRemoveDocuments.fire(I),S.addedDocuments&&this._onDidAddDocuments.fire(i),(S.removedEditors||S.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),S.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(S){return this._documents.get(S)?.value}allDocuments(){return b.Iterable.map(this._documents.values(),S=>S.value)}getEditor(S){return this._editors.get(S)}activeEditor(S){if(!this._activeEditorId)return;const I=this._editors.get(this._activeEditorId);return S?I:I?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=c,e.ExtHostDocumentsAndEditors=c=Ve([$e(0,v.IExtHostRpcService),$e(1,p.ILogService)],c),e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[62],Ie([1,0,16,6,2,3,5,7,20,14,65]),function(me,e,_,L,d,A,T,m,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");class k{constructor(r,s,c){this._activeTabIdGetter=c,this._parentGroup=s,this.acceptDtoUpdate(r)}get apiObject(){if(!this._apiObject){const r=this,s={get isActive(){return r._dto.id===r._activeTabIdGetter()},get label(){return r._dto.label},get input(){return r._input},get isDirty(){return r._dto.isDirty},get isPinned(){return r._dto.isPinned},get isPreview(){return r._dto.isPreview},get group(){return r._parentGroup.apiObject}};this._apiObject=Object.freeze(s)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(r){this._dto=r,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new m.TextTabInput(d.URI.revive(this._dto.input.uri));case 2:return new m.TextDiffTabInput(d.URI.revive(this._dto.input.original),d.URI.revive(this._dto.input.modified));case 3:return new m.TextMergeTabInput(d.URI.revive(this._dto.input.base),d.URI.revive(this._dto.input.input1),d.URI.revive(this._dto.input.input2),d.URI.revive(this._dto.input.result));case 6:return new m.CustomEditorTabInput(d.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new m.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new m.NotebookEditorTabInput(d.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new m.NotebookDiffEditorTabInput(d.URI.revive(this._dto.input.original),d.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new m.TerminalEditorTabInput;case 9:return new m.InteractiveWindowInput(d.URI.revive(this._dto.input.uri),d.URI.revive(this._dto.input.inputBoxUri));default:return}}}class p{constructor(r,s){this._tabs=[],this._activeTabId="",this._dto=r,this._activeGroupIdGetter=s;for(const c of r.tabs)c.isActive&&(this._activeTabId=c.id),this._tabs.push(new k(c,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const r=this,s={get isActive(){return r._dto.groupId===r._activeGroupIdGetter()},get viewColumn(){return _.ViewColumn.to(r._dto.viewColumn)},get activeTab(){return r._tabs.find(c=>c.tabId===r._activeTabId)?.apiObject},get tabs(){return Object.freeze(r._tabs.map(c=>c.apiObject))}};this._apiObject=Object.freeze(s)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(r){this._dto=r}acceptTabOperation(r){if(r.kind===0){const c=new k(r.tabDto,this,()=>this.activeTabId());return this._tabs.splice(r.index,0,c),r.tabDto.isActive&&(this._activeTabId=c.tabId),c}else if(r.kind===1){const c=this._tabs.splice(r.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${r.index} which does not exist`);return c.tabId===this._activeTabId&&(this._activeTabId=""),c}else if(r.kind===3){if(r.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this._tabs.splice(r.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${r.oldIndex} which does not exist`);return this._tabs.splice(r.index,0,c),c}const s=this._tabs.find(c=>c.tabId===r.tabDto.id);if(!s)throw new Error("INVALID tab");return r.tabDto.isActive?this._activeTabId=r.tabDto.id:this._activeTabId===r.tabDto.id&&!r.tabDto.isActive&&(this._activeTabId=""),s.acceptDtoUpdate(r.tabDto),s}activeTabId(){return this._activeTabId}}let C=class{constructor(r){this._onDidChangeTabs=new A.Emitter,this._onDidChangeTabGroups=new A.Emitter,this._extHostTabGroups=[],this._proxy=r.getProxy(L.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const r=this,s={onDidChangeTabGroups:r._onDidChangeTabGroups.event,onDidChangeTabs:r._onDidChangeTabs.event,get all(){return Object.freeze(r._extHostTabGroups.map(c=>c.apiObject))},get activeTabGroup(){const c=r._activeGroupId;return(0,v.assertIsDefined)(r._extHostTabGroups.find(S=>S.groupId===c)?.apiObject)},close:async(c,f)=>{const S=Array.isArray(c)?c:[c];return S.length?D(S[0])?this._closeGroups(S,f):this._closeTabs(S,f):!0}};this._apiObject=Object.freeze(s)}return this._apiObject}$acceptEditorTabModel(r){const s=new Set(this._extHostTabGroups.map(n=>n.groupId)),c=new Set(r.map(n=>n.groupId)),f=(0,R.diffSets)(s,c),S=this._extHostTabGroups.filter(n=>f.removed.includes(n.groupId)).map(n=>n.apiObject),I=[],i=[];this._extHostTabGroups=r.map(n=>{const t=new p(n,()=>this._activeGroupId);return f.added.includes(t.groupId)?I.push(t.apiObject):i.push(t.apiObject),t});const a=(0,v.assertIsDefined)(r.find(n=>n.isActive===!0)?.groupId);a!==void 0&&this._activeGroupId!==a&&(this._activeGroupId=a),this._onDidChangeTabGroups.fire(Object.freeze({opened:I,closed:S,changed:i}))}$acceptTabGroupUpdate(r){const s=this._extHostTabGroups.find(c=>c.groupId===r.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(r),r.isActive&&(this._activeGroupId=r.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(r){const s=this._extHostTabGroups.find(f=>f.groupId===r.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const c=s.acceptTabOperation(r);switch(r.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}_findExtHostTabFromApi(r){for(const s of this._extHostTabGroups)for(const c of s.tabs)if(c.apiObject===r)return c}_findExtHostTabGroupFromApi(r){return this._extHostTabGroups.find(s=>s.apiObject===r)}async _closeTabs(r,s){const c=[];for(const f of r){const S=this._findExtHostTabFromApi(f);if(!S)throw new Error("Tab close: Invalid tab not found!");c.push(S.tabId)}return this._proxy.$closeTab(c,s)}async _closeGroups(r,s){const c=[];for(const f of r){const S=this._findExtHostTabGroupFromApi(f);if(!S)throw new Error("Group close: Invalid group not found!");c.push(S.groupId)}return this._proxy.$closeGroup(c,s)}};e.ExtHostEditorTabs=C,e.ExtHostEditorTabs=C=Ve([$e(0,y.IExtHostRpcService)],C);function D(b){return b.tabs!==void 0}}),define(De[290],Ie([1,0,2,6,4,7,16,162,12,22,27,74]),function(me,e,_,L,d,A,T,m,y,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class p{constructor(){this._schemes=[]}add(b){this._stateMachine=void 0,this._schemes.push(b)}delete(b){const r=this._schemes.indexOf(b);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const b=this._schemes.sort(),r=[];let s,c,f=14,S=14;for(const I of b){let i=s?(0,y.commonPrefixLength)(s,I):0;for(i===0?c=1:c=S;i<I.length;i++)i+1===I.length?(f=S,S=9):S+=1,r.push([c,I.toUpperCase().charCodeAt(i),S]),r.push([c,I.toLowerCase().charCodeAt(i),S]),c=S;s=I,S=f}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new m.StateMachine(r)}}provideDocumentLinks(b){this._initStateMachine();const r=[],s=m.LinkComputer.computeLinks({getLineContent(c){return b.lineAt(c-1).text},getLineCount(){return b.lineCount}},this._stateMachine);for(const c of s){const f=T.DocumentLink.to(c);f.target&&r.push(f)}return r}}class C{constructor(b,r){this._extHostLanguageFeatures=r,this._linkProvider=new p,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=b.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(b,r,s,c={}){if(C._validateFileSystemProvider(s),this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(b,"*",this._linkProvider));const f=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(f,s);let S=2;c.isCaseSensitive&&(S+=1024),c.isReadonly&&(S+=2048),typeof s.copy=="function"&&(S+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,R.checkProposedApiEnabled)(b,"fsChunks"),S+=4);let I;c.isReadonly&&(0,k.isMarkdownString)(c.isReadonly)&&((0,R.checkProposedApiEnabled)(b,"readonlyMessage"),I={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this._proxy.$registerFileSystemProvider(f,r,S,I).catch(a=>{console.error(`FAILED to register filesystem provider of ${b.identifier.value}-extension for the scheme ${r}`),console.error(a)});const i=s.onDidChangeFile(a=>{const n=[];for(const t of a){const{uri:o,type:g}=t;if(o.scheme!==r)continue;let l;switch(g){case A.FileChangeType.Changed:l=0;break;case A.FileChangeType.Created:l=1;break;case A.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:o,type:l})}this._proxy.$onFileSystemChange(f,n)});return(0,d.toDisposable)(()=>{i.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(f),this._proxy.$unregisterProvider(f)})}static _validateFileSystemProvider(b){if(!b)throw new Error("MISSING provider");if(typeof b.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof b.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof b.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof b.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof b.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof b.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof b.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof b.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(b){const{type:r,ctime:s,mtime:c,size:f,permissions:S}=b;return{type:r,ctime:s,mtime:c,size:f,permissions:S}}$stat(b,r){return Promise.resolve(this._getFsProvider(b).stat(_.URI.revive(r))).then(s=>C._asIStat(s))}$readdir(b,r){return Promise.resolve(this._getFsProvider(b).readDirectory(_.URI.revive(r)))}$readFile(b,r){return Promise.resolve(this._getFsProvider(b).readFile(_.URI.revive(r))).then(s=>v.VSBuffer.wrap(s))}$writeFile(b,r,s,c){return Promise.resolve(this._getFsProvider(b).writeFile(_.URI.revive(r),s.buffer,c))}$delete(b,r,s){return Promise.resolve(this._getFsProvider(b).delete(_.URI.revive(r),s))}$rename(b,r,s,c){return Promise.resolve(this._getFsProvider(b).rename(_.URI.revive(r),_.URI.revive(s),c))}$copy(b,r,s,c){const f=this._getFsProvider(b);if(!f.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(f.copy(_.URI.revive(r),_.URI.revive(s),c))}$mkdir(b,r){return Promise.resolve(this._getFsProvider(b).createDirectory(_.URI.revive(r)))}$watch(b,r,s,c){const f=this._getFsProvider(b).watch(_.URI.revive(s),c);this._watches.set(r,f)}$unwatch(b,r){const s=this._watches.get(r);s&&(s.dispose(),this._watches.delete(r))}$open(b,r,s){const c=this._getFsProvider(b);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(_.URI.revive(r),s))}$close(b,r){const s=this._getFsProvider(b);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(r))}$read(b,r,s,c){const f=this._getFsProvider(b);if(!f.read)throw new Error('FileSystemProvider does not implement "read"');const S=v.VSBuffer.alloc(c);return Promise.resolve(f.read(r,s,S.buffer,0,c)).then(I=>S.slice(0,I))}$write(b,r,s,c){const f=this._getFsProvider(b);if(!f.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(f.write(r,s,c.buffer,0,c.byteLength))}_getFsProvider(b){const r=this._fsProvider.get(b);if(!r){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return r}}e.ExtHostFileSystem=C}),define(De[63],Ie([1,0,6,30,7,22,5,20,51,4,17,24,15]),function(me,e,_,L,d,A,T,m,y,v,R,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class ii{constructor(b,r){this._fileSystemProvider=new Map,this._writeQueue=new R.ResourceQueue,this._proxy=b.getProxy(_.MainContext.MainThreadFileSystem);const s=this;this.value=Object.freeze({async stat(c){try{let f;const S=s._fileSystemProvider.get(c.scheme);return S?(await s._proxy.$ensureActivation(c.scheme),f=await S.impl.stat(c)):f=await s._proxy.$stat(c),{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions===L.FilePermission.Readonly?1:void 0}}catch(f){ii._handleError(f)}},async readDirectory(c){try{const f=s._fileSystemProvider.get(c.scheme);return f?(await s._proxy.$ensureActivation(c.scheme),(await f.impl.readDirectory(c)).slice()):await s._proxy.$readdir(c)}catch(f){return ii._handleError(f)}},async createDirectory(c){try{const f=s._fileSystemProvider.get(c.scheme);return f&&!f.isReadonly?(await s._proxy.$ensureActivation(c.scheme),await s.mkdirp(f.impl,f.extUri,c)):await s._proxy.$mkdir(c)}catch(f){return ii._handleError(f)}},async readFile(c){try{const f=s._fileSystemProvider.get(c.scheme);return f?(await s._proxy.$ensureActivation(c.scheme),(await f.impl.readFile(c)).slice()):(await s._proxy.$readFile(c)).buffer}catch(f){return ii._handleError(f)}},async writeFile(c,f){try{const S=s._fileSystemProvider.get(c.scheme);return S&&!S.isReadonly?(await s._proxy.$ensureActivation(c.scheme),await s.mkdirp(S.impl,S.extUri,S.extUri.dirname(c)),await s._writeQueue.queueFor(c).queue(()=>Promise.resolve(S.impl.writeFile(c,f,{create:!0,overwrite:!0})))):await s._proxy.$writeFile(c,A.VSBuffer.wrap(f))}catch(S){return ii._handleError(S)}},async delete(c,f){try{const S=s._fileSystemProvider.get(c.scheme);return S&&!S.isReadonly?(await s._proxy.$ensureActivation(c.scheme),await S.impl.delete(c,{recursive:!1,...f})):await s._proxy.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...f})}catch(S){return ii._handleError(S)}},async rename(c,f,S){try{return await s._proxy.$rename(c,f,{overwrite:!1,...S})}catch(I){return ii._handleError(I)}},async copy(c,f,S){try{return await s._proxy.$copy(c,f,{overwrite:!1,...S})}catch(I){return ii._handleError(I)}},isWritableFileSystem(c){const f=r.getCapabilities(c);if(typeof f=="number")return!(f&2048)}})}async mkdirp(b,r,s){const c=[];for(;!r.isEqual(s,r.dirname(s));)try{if(!((await b.stat(s)).type&L.FileType.Directory))throw d.FileSystemError.FileExists(`Unable to create folder '${s.scheme===p.Schemas.file?s.fsPath:s.toString(!0)}' that already exists but is not a directory`);break}catch(f){if(L.toFileSystemProviderErrorCode(f)!==L.FileSystemProviderErrorCode.FileNotFound)throw f;c.push(r.basename(s)),s=r.dirname(s)}for(let f=c.length-1;f>=0;f--){s=r.joinPath(s,c[f]);try{await b.createDirectory(s)}catch(S){if(L.toFileSystemProviderErrorCode(S)!==L.FileSystemProviderErrorCode.FileExists)throw S}}}static _handleError(b){if(b instanceof d.FileSystemError)throw b;if(b instanceof L.FileSystemProviderError)switch(b.code){case L.FileSystemProviderErrorCode.FileExists:throw d.FileSystemError.FileExists(b.message);case L.FileSystemProviderErrorCode.FileNotFound:throw d.FileSystemError.FileNotFound(b.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw d.FileSystemError.FileNotADirectory(b.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw d.FileSystemError.FileIsADirectory(b.message);case L.FileSystemProviderErrorCode.NoPermissions:throw d.FileSystemError.NoPermissions(b.message);case L.FileSystemProviderErrorCode.Unavailable:throw d.FileSystemError.Unavailable(b.message);default:throw new d.FileSystemError(b.message,b.name)}if(!(b instanceof Error))throw new d.FileSystemError(String(b));if(b.name==="ENOPRO"||b.message.includes("ENOPRO"))throw d.FileSystemError.Unavailable(b.message);switch(b.name){case L.FileSystemProviderErrorCode.FileExists:throw d.FileSystemError.FileExists(b.message);case L.FileSystemProviderErrorCode.FileNotFound:throw d.FileSystemError.FileNotFound(b.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw d.FileSystemError.FileNotADirectory(b.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw d.FileSystemError.FileIsADirectory(b.message);case L.FileSystemProviderErrorCode.NoPermissions:throw d.FileSystemError.NoPermissions(b.message);case L.FileSystemProviderErrorCode.Unavailable:throw d.FileSystemError.Unavailable(b.message);default:throw new d.FileSystemError(b.message,b.name)}}addFileSystemProvider(b,r,s){return this._fileSystemProvider.set(b,{impl:r,extUri:s?.isCaseSensitive?k.extUri:k.extUriIgnorePathCase,isReadonly:!!s?.isReadonly}),(0,v.toDisposable)(()=>this._fileSystemProvider.delete(b))}getFileSystemProviderExtUri(b){return this._fileSystemProvider.get(b)?.extUri??k.extUri}};e.ExtHostConsumerFileSystem=C,e.ExtHostConsumerFileSystem=C=Ve([$e(0,m.IExtHostRpcService),$e(1,y.IExtHostFileSystemInfo)],C),e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(De[291],Ie([1,0,3,34,2,6,16,7]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(k,p,C,D,b,r,s,c){this._onDidCreate=new _.Emitter,this._onDidChange=new _.Emitter,this._onDidDelete=new _.Emitter;const f=this.ensureWatching(k,C,b);this._config=0,r&&(this._config+=1),s&&(this._config+=2),c&&(this._config+=4);const S=(0,L.parse)(b),I=typeof b=="string",i=D(a=>{if(!r)for(const n of a.created){const t=d.URI.revive(n);S(t.fsPath)&&(!I||p.getWorkspaceFolder(t))&&this._onDidCreate.fire(t)}if(!s)for(const n of a.changed){const t=d.URI.revive(n);S(t.fsPath)&&(!I||p.getWorkspaceFolder(t))&&this._onDidChange.fire(t)}if(!c)for(const n of a.deleted){const t=d.URI.revive(n);S(t.fsPath)&&(!I||p.getWorkspaceFolder(t))&&this._onDidDelete.fire(t)}});this._disposable=m.Disposable.from(f,this._onDidCreate,this._onDidChange,this._onDidDelete,i)}ensureWatching(k,p,C){const D=m.Disposable.from();if(typeof C=="string")return D;const b=k.getProxy(A.MainContext.MainThreadFileSystem);let r=!1;(C.pattern.includes(L.GLOBSTAR)||C.pattern.includes(L.GLOB_SPLIT))&&(r=!0);const s=Math.random();return b.$watch(p.identifier.value,s,C.baseUri,{recursive:r,excludes:[]}),m.Disposable.from({dispose:()=>b.$unwatch(s)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class v{constructor(k,p,C){this._mainContext=k,this._logService=p,this._extHostDocumentsAndEditors=C,this._onFileSystemEvent=new _.Emitter,this._onDidRenameFile=new _.Emitter,this._onDidCreateFile=new _.Emitter,this._onDidDeleteFile=new _.Emitter,this._onWillRenameFile=new _.AsyncEmitter,this._onWillCreateFile=new _.AsyncEmitter,this._onWillDeleteFile=new _.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,p,C,D,b,r){return new y(this._mainContext,k,p,this._onFileSystemEvent.event,T.GlobPattern.from(C),D,b,r)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,p){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:p.map(C=>({oldUri:d.URI.revive(C.source),newUri:d.URI.revive(C.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:p.map(C=>d.URI.revive(C.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:p.map(C=>d.URI.revive(C.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,p){return(C,D,b)=>{const r=function(c){C.call(D,c)};return r.extension=k,p.event(r,void 0,b)}}async $onWillRunFileOperation(k,p,C,D){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:p.map(b=>({oldUri:d.URI.revive(b.source),newUri:d.URI.revive(b.target)}))},C,D);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:p.map(b=>d.URI.revive(b.target))},C,D);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:p.map(b=>d.URI.revive(b.target))},C,D)}}async _fireWillEvent(k,p,C,D){const b=new Set,r=[];if(await k.fireAsync(p,D,async(c,f)=>{const S=Date.now(),I=await Promise.resolve(c);I instanceof m.WorkspaceEdit&&(r.push([f.extension,I]),b.add(f.extension.displayName??f.extension.identifier.value)),Date.now()-S>C&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),D.isCancellationRequested||r.length===0)return;const s={edits:[]};for(const[,c]of r){const{edits:f}=T.WorkspaceEdit.from(c,{getTextDocumentVersion:S=>this._extHostDocumentsAndEditors.getDocument(S)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(f)}return{edit:s,extensionNames:Array.from(b)}}}e.ExtHostFileSystemEventService=v}),define(De[292],Ie([1,0,4,2,6,16,7,36]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class y{static{this._pool=0}constructor(p,C){this.extension=p,this.provider=C,this.handle=y._pool++}}class v{constructor(p){this.session=p,this.responses=[]}}class R{static{this._nextId=0}constructor(p,C,D,b){this._documents=D,this._logService=b,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=p.getProxy(d.MainContext.MainThreadInlineChat),C.registerApiCommand(new m.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.ApiCommandArgument("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?A.Range.from(r.initialRange):void 0,message:r.message,autoSend:r.autoSend,position:r.position?A.Position.from(r.position):void 0}})],m.ApiCommandResult.Void))}registerProvider(p,C){const D=new y(p,C);return this._inputProvider.set(D.handle,D),this._proxy.$registerInteractiveEditorProvider(D.handle,p.identifier.value,typeof C.handleInteractiveEditorResponseFeedback=="function"),(0,_.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(D.handle),this._inputProvider.delete(D.handle)})}async $prepareSession(p,C,D,b){const r=this._inputProvider.get(p);if(!r){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const s=this._documents.getDocument(L.URI.revive(C)),c=A.Selection.to(D),f=await r.provider.prepareInteractiveEditorSession({document:s,selection:c},b);if(!f)return;if(f.wholeRange&&!f.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const S=R._nextId++;return this._inputSessions.set(S,new v(f)),{id:S,placeholder:f.placeholder,slashCommands:f.slashCommands?.map(I=>({command:I.command,detail:I.detail,refer:I.refer,executeImmediately:I.executeImmediately})),wholeRange:A.Range.from(f.wholeRange),message:f.message}}async $provideResponse(p,C,D,b){const r=this._inputProvider.get(p);if(!r)return;const s=this._inputSessions.get(C.id);if(!s)return;const c={session:s.session,prompt:D.prompt,selection:A.Selection.to(D.selection),wholeRange:A.Range.to(D.wholeRange),attempt:D.attempt,live:D.live};let f=!1;const S={report:a=>{if(!D.live)throw new Error("Progress reporting is only supported for live sessions");f||b.isCancellationRequested||!a.message&&!a.edits||this._proxy.$handleProgressChunk(D.requestId,{message:a.message,edits:a.edits?.map(A.TextEdit.from)})}},I=typeof r.provider.provideInteractiveEditorResponse2=="function"?r.provider.provideInteractiveEditorResponse2(c,S,b):r.provider.provideInteractiveEditorResponse(c,b);Promise.resolve(I).finally(()=>f=!0);const i=await I;if(i){const a=s.responses.push(i)-1,n={wholeRange:A.Range.from(i.wholeRange),placeholder:i.placeholder};if(R._isMessageResponse(i))return{...n,id:a,type:"message",message:A.MarkdownString.from(i.contents)};const{edits:t}=i;if(t instanceof T.WorkspaceEdit)return{...n,id:a,type:"bulkEdit",edits:A.WorkspaceEdit.from(t)};if(Array.isArray(t))return{...n,id:a,type:"editorEdit",edits:t.map(A.TextEdit.from)}}}$handleFeedback(p,C,D,b){const r=this._inputProvider.get(p),s=this._inputSessions.get(C),c=s?.responses[D];if(r&&c){let f;switch(b){case 1:f=T.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:f=T.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:f=T.InteractiveEditorResponseFeedbackKind.Undone;break;case 3:f=T.InteractiveEditorResponseFeedbackKind.Accepted;break}r.provider.handleInteractiveEditorResponseFeedback?.(s.session,c,f)}}$releaseSession(p,C){const D=this._inputSessions.get(C),b=this._inputProvider.get(p);D&&b&&b.provider.releaseInteractiveEditorSession?.(D.session),this._inputSessions.delete(C)}static _isMessageResponse(p){return typeof p=="object"&&typeof p.contents=="object"}}e.ExtHostInteractiveEditor=R}),define(De[293],Ie([1,0,2,36]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class d{constructor(T,m,y,v,R){this._extHostNotebooks=m,this._textDocumentsAndEditors=y,this._commands=v;const k=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",p=>!0,p=>p),new L.ApiCommandArgument("resource","Interactive resource Uri",p=>!0,p=>p),new L.ApiCommandArgument("controllerId","Notebook controller Id",p=>!0,p=>p),new L.ApiCommandArgument("title","Interactive editor title",p=>!0,p=>p)],new L.ApiCommandResult("Notebook and input URI",p=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const C=this._extHostNotebooks.getEditorById(p.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:_.URI.revive(p.notebookUri),inputUri:_.URI.revive(p.inputUri),notebookEditor:C.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:_.URI.revive(p.notebookUri),inputUri:_.URI.revive(p.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(T,m,y,v){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:y,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(_.URI.revive(v))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,m){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=d}),define(De[294],Ie([1,0,6,7]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class d{constructor(T){this._IssueUriRequestHandlers=new Map,this._proxy=T.getProxy(_.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(T,m){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const y=this._IssueUriRequestHandlers.get(T);if(!y)throw new Error("Issue request handler not found");const v=await y.handleIssueUrlRequest();if(!v)throw new Error("Issue request handler returned no result");return v}registerIssueUriRequestHandler(T,m){const y=T.identifier.value;return this._IssueUriRequestHandlers.set(y,m),this._proxy.$registerIssueUriRequestHandler(y),new L.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(y),this._IssueUriRequestHandlers.delete(y)})}}e.ExtHostIssueReporter=d}),define(De[295],Ie([1,0,4,6]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class d{constructor(T){this._handlePool=0,this._proxy=T.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const m=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(m,T),(0,_.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(m)})}}e.ExtHostLabelService=d}),define(De[296],Ie([1,0,2,23,16,7,77,6,12,33,19,14,158,21,25,4,123,111,81,39,8,17,27,195]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c,f,S,I,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class n{constructor(M,q){this._documents=M,this._provider=q}async provideDocumentSymbols(M,q){const G=this._documents.getDocument(M),J=await this._provider.provideDocumentSymbols(G,q);if(!(0,R.isFalsyOrEmpty)(J))return J[0]instanceof A.DocumentSymbol?J.map(d.DocumentSymbol.from):n._asDocumentSymbolTree(J)}static _asDocumentSymbolTree(M){M=M.slice(0).sort((J,be)=>{let se=J.location.range.start.compareTo(be.location.range.start);return se===0&&(se=be.location.range.end.compareTo(J.location.range.end)),se});const q=[],G=[];for(const J of M){const be={name:J.name||"!!MISSING: name!!",kind:d.SymbolKind.from(J.kind),tags:J.tags?.map(d.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:d.Range.from(J.location.range),selectionRange:d.Range.from(J.location.range),children:[]};for(;;){if(G.length===0){G.push(be),q.push(be);break}const se=G[G.length-1];if(v.Range.containsRange(se.range,be.range)&&!v.Range.equalsRange(se.range,be.range)){se.children?.push(be),G.push(be);break}G.pop()}}return q}}class t{static{this._badCmd={command:"missing",title:"!!MISSING: command!!"}}constructor(M,q,G){this._documents=M,this._commands=q,this._provider=G,this._cache=new c.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(M,q){const G=this._documents.getDocument(M),J=await this._provider.provideCodeLenses(G,q);if(!J||q.isCancellationRequested)return;const be=this._cache.add(J),se=new b.DisposableStore;this._disposables.set(be,se);const we={cacheId:be,lenses:[]};for(let ke=0;ke<J.length;ke++)we.lenses.push({cacheId:[be,ke],range:d.Range.from(J[ke].range),command:this._commands.toInternal(J[ke].command,se)});return we}async resolveCodeLens(M,q){const G=M.cacheId&&this._cache.get(...M.cacheId);if(!G)return;let J;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?J=G:J=await this._provider.resolveCodeLens(G,q),J||(J=G),q.isCancellationRequested)return;const be=M.cacheId&&this._disposables.get(M.cacheId[0]);if(be)return M.command=this._commands.toInternal(J.command??t._badCmd,be),M}releaseCodeLenses(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}}function o(Ee){return Array.isArray(Ee)?Ee.map(d.DefinitionLink.from):Ee?[d.DefinitionLink.from(Ee)]:[]}class g{constructor(M,q){this._documents=M,this._provider=q}async provideDefinition(M,q,G){const J=this._documents.getDocument(M),be=d.Position.to(q),se=await this._provider.provideDefinition(J,be,G);return o(se)}}class l{constructor(M,q){this._documents=M,this._provider=q}async provideDeclaration(M,q,G){const J=this._documents.getDocument(M),be=d.Position.to(q),se=await this._provider.provideDeclaration(J,be,G);return o(se)}}class h{constructor(M,q){this._documents=M,this._provider=q}async provideImplementation(M,q,G){const J=this._documents.getDocument(M),be=d.Position.to(q),se=await this._provider.provideImplementation(J,be,G);return o(se)}}class w{constructor(M,q){this._documents=M,this._provider=q}async provideTypeDefinition(M,q,G){const J=this._documents.getDocument(M),be=d.Position.to(q),se=await this._provider.provideTypeDefinition(J,be,G);return o(se)}}class u{constructor(M,q){this._documents=M,this._provider=q}async provideHover(M,q,G){const J=this._documents.getDocument(M),be=d.Position.to(q),se=await this._provider.provideHover(J,be,G);if(!(!se||(0,R.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=J.getWordRangeAtPosition(be)),se.range||(se.range=new A.Range(be,be)),d.Hover.from(se)}}class E{constructor(M,q){this._documents=M,this._provider=q}async provideEvaluatableExpression(M,q,G){const J=this._documents.getDocument(M),be=d.Position.to(q),se=await this._provider.provideEvaluatableExpression(J,be,G);if(se)return d.EvaluatableExpression.from(se)}}class P{constructor(M,q){this._documents=M,this._provider=q}async provideInlineValues(M,q,G,J){const be=this._documents.getDocument(M),se=await this._provider.provideInlineValues(be,d.Range.to(q),d.InlineValueContext.to(G),J);if(Array.isArray(se))return se.map(we=>d.InlineValue.from(we))}}class O{constructor(M,q){this._documents=M,this._provider=q}async provideDocumentHighlights(M,q,G){const J=this._documents.getDocument(M),be=d.Position.to(q),se=await this._provider.provideDocumentHighlights(J,be,G);if(Array.isArray(se))return se.map(d.DocumentHighlight.from)}}class N{constructor(M,q){this._documents=M,this._provider=q}async provideLinkedEditingRanges(M,q,G){const J=this._documents.getDocument(M),be=d.Position.to(q),se=await this._provider.provideLinkedEditingRanges(J,be,G);if(se&&Array.isArray(se.ranges))return{ranges:(0,R.coalesce)(se.ranges.map(d.Range.from)),wordPattern:se.wordPattern}}}class F{constructor(M,q){this._documents=M,this._provider=q}async provideReferences(M,q,G,J){const be=this._documents.getDocument(M),se=d.Position.to(q),we=await this._provider.provideReferences(be,se,G,J);if(Array.isArray(we))return we.map(d.location.from)}}class x{static{this._maxCodeActionsPerFile=1e3}constructor(M,q,G,J,be,se,we){this._documents=M,this._commands=q,this._diagnostics=G,this._provider=J,this._logService=be,this._extension=se,this._apiDeprecation=we,this._cache=new c.Cache("CodeAction"),this._disposables=new Map,this.nbKind=new A.CodeActionKind("notebook")}async provideCodeActions(M,q,G,J){const be=this._documents.getDocument(M),se=p.Selection.isISelection(q)?d.Selection.to(q):d.Range.to(q),we=[];for(const et of this._diagnostics.getDiagnostics(M))if(se.intersection(et.range)&&we.push(et)>x._maxCodeActionsPerFile)break;const ke={diagnostics:we,only:G.only?new A.CodeActionKind(G.only):void 0,triggerKind:d.CodeActionTriggerKind.to(G.trigger)},Ue=await this._provider.provideCodeActions(be,se,ke,J);if(!(0,R.isNonEmptyArray)(Ue)||J.isCancellationRequested)return;const He=this._cache.add(Ue),Je=new b.DisposableStore;this._disposables.set(He,Je);const Ge=[];for(let et=0;et<Ue.length;et++){const Qe=Ue[et];if(Qe)if(x._isCommand(Qe))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:Qe.title,command:this._commands.toInternal(Qe,Je)});else{if(ke.triggerKind!==A.CodeActionTriggerKind.Invoke&&Qe.kind&&this.nbKind.contains(Qe.kind))continue;ke.only&&(Qe.kind?ke.only.contains(Qe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ke.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ke.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[He,et],title:Qe.title,command:Qe.command&&this._commands.toInternal(Qe.command,Je),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(d.Diagnostic.from),edit:Qe.edit&&d.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})}}return{cacheId:He,actions:Ge}}async resolveCodeAction(M,q){const[G,J]=M,be=this._cache.get(G,J);if(!be||x._isCommand(be))return{};if(!this._provider.resolveCodeAction)return{};const se=await this._provider.resolveCodeAction(be,q)??be;let we;se.edit&&(we=d.WorkspaceEdit.from(se.edit,void 0));let ke;if(se.command){const Ue=this._disposables.get(G);Ue&&(ke=this._commands.toInternal(se.command,Ue))}return{edit:we,command:ke}}releaseCodeActions(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}static _isCommand(M){return typeof M.command=="string"&&typeof M.title=="string"}}class B{constructor(M,q,G,J,be){this._proxy=M,this._documents=q,this._provider=G,this._handle=J,this._extension=be}async prepareDocumentPaste(M,q,G,J){if(!this._provider.prepareDocumentPaste)return;const be=this._documents.getDocument(M),se=q.map(Ue=>d.Range.to(Ue)),we=d.DataTransfer.toDataTransfer(G,()=>{throw new S.NotImplementedError});if(await this._provider.prepareDocumentPaste(be,se,we,J),J.isCancellationRequested)return;const ke=Array.from(we).filter(([,Ue])=>!(Ue instanceof A.InternalDataTransferItem));return d.DataTransfer.from(ke)}async providePasteEdits(M,q,G,J,be){if(!this._provider.provideDocumentPasteEdits)return;const se=this._documents.getDocument(q),we=G.map(He=>d.Range.to(He)),ke=d.DataTransfer.toDataTransfer(J,async He=>(await this._proxy.$resolvePasteFileData(this._handle,M,He)).buffer),Ue=await this._provider.provideDocumentPasteEdits(se,we,ke,be);if(Ue)return{id:Ue.id?this._extension.identifier.value+"."+Ue.id:this._extension.identifier.value,label:Ue.label??(0,a.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,priority:Ue.priority??0,insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?d.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class U{constructor(M,q){this._documents=M,this._provider=q}async provideDocumentFormattingEdits(M,q,G){const J=this._documents.getDocument(M),be=await this._provider.provideDocumentFormattingEdits(J,q,G);if(Array.isArray(be))return be.map(d.TextEdit.from)}}class X{constructor(M,q){this._documents=M,this._provider=q}async provideDocumentRangeFormattingEdits(M,q,G,J){const be=this._documents.getDocument(M),se=d.Range.to(q),we=await this._provider.provideDocumentRangeFormattingEdits(be,se,G,J);if(Array.isArray(we))return we.map(d.TextEdit.from)}async provideDocumentRangesFormattingEdits(M,q,G,J){(0,k.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const be=this._documents.getDocument(M),se=q.map(d.Range.to),we=await this._provider.provideDocumentRangesFormattingEdits(be,se,G,J);if(Array.isArray(we))return we.map(d.TextEdit.from)}}class j{constructor(M,q){this._documents=M,this._provider=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,q,G,J,be){const se=this._documents.getDocument(M),we=d.Position.to(q),ke=await this._provider.provideOnTypeFormattingEdits(se,we,G,J,be);if(Array.isArray(ke))return ke.map(d.TextEdit.from)}}class ge{constructor(M,q){this._provider=M,this._logService=q,this._cache=new c.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(M,q){const G=await this._provider.provideWorkspaceSymbols(M,q);if(!(0,R.isNonEmptyArray)(G))return{symbols:[]};const J=this._cache.add(G),be={cacheId:J,symbols:[]};for(let se=0;se<G.length;se++){const we=G[se];if(!we||!we.name){this._logService.warn("INVALID SymbolInformation",we);continue}be.symbols.push({...d.WorkspaceSymbol.from(we),cacheId:[J,se]})}return be}async resolveWorkspaceSymbol(M,q){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const G=this._cache.get(...M.cacheId);if(G){const J=await this._provider.resolveWorkspaceSymbol(G,q);return J&&(0,L.mixin)(M,d.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(M){this._cache.delete(M)}}class ie{static supportsResolving(M){return typeof M.prepareRename=="function"}constructor(M,q,G){this._documents=M,this._provider=q,this._logService=G}async provideRenameEdits(M,q,G,J){const be=this._documents.getDocument(M),se=d.Position.to(q);try{const we=await this._provider.provideRenameEdits(be,se,G,J);return we?d.WorkspaceEdit.from(we):void 0}catch(we){const ke=ie._asMessage(we);return ke?{rejectReason:ke,edits:void 0}:Promise.reject(we)}}async resolveRenameLocation(M,q,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const J=this._documents.getDocument(M),be=d.Position.to(q);try{const se=await this._provider.prepareRename(J,be,G);let we,ke;if(A.Range.isRange(se)?(we=se,ke=J.getText(se)):(0,k.isObject)(se)&&(we=se.range,ke=se.placeholder),!we||!ke)return;if(we.start.line>be.line||we.end.line<be.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:d.Range.from(we),text:ke}}catch(se){const we=ie._asMessage(se);return we?{rejectReason:we,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class te{constructor(M,q){this.resultId=M,this.tokens=q}}class ${constructor(M,q){this._documents=M,this._provider=q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(M,q,G){const J=this._documents.getDocument(M),be=q!==0?this._previousResults.get(q):null;let se=typeof be?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(J,be.resultId,G):await this._provider.provideDocumentSemanticTokens(J,G);return be&&this._previousResults.delete(q),se?(se=$._fixProvidedSemanticTokens(se),this._send($._convertToEdits(be,se),se)):null}async releaseDocumentSemanticColoring(M){this._previousResults.delete(M)}static _fixProvidedSemanticTokens(M){return $._isSemanticTokens(M)?$._isCorrectSemanticTokens(M)?M:new A.SemanticTokens(new Uint32Array(M.data),M.resultId):$._isSemanticTokensEdits(M)?$._isCorrectSemanticTokensEdits(M)?M:new A.SemanticTokensEdits(M.edits.map(q=>new A.SemanticTokensEdit(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),M.resultId):M}static _isSemanticTokens(M){return M&&!!M.data}static _isCorrectSemanticTokens(M){return M.data instanceof Uint32Array}static _isSemanticTokensEdits(M){return M&&Array.isArray(M.edits)}static _isCorrectSemanticTokensEdits(M){for(const q of M.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(M,q){if(!$._isSemanticTokens(q)||!M||!M.tokens)return q;const G=M.tokens,J=G.length,be=q.data,se=be.length;let we=0;const ke=Math.min(J,se);for(;we<ke&&G[we]===be[we];)we++;if(we===J&&we===se)return new A.SemanticTokensEdits([],q.resultId);let Ue=0;const He=ke-we;for(;Ue<He&&G[J-Ue-1]===be[se-Ue-1];)Ue++;return new A.SemanticTokensEdits([{start:we,deleteCount:J-we-Ue,data:be.subarray(we,se-Ue)}],q.resultId)}_send(M,q){if($._isSemanticTokens(M)){const G=this._nextResultId++;return this._previousResults.set(G,new te(M.resultId,M.data)),(0,r.encodeSemanticTokensDto)({id:G,type:"full",data:M.data})}if($._isSemanticTokensEdits(M)){const G=this._nextResultId++;return $._isSemanticTokens(q)?this._previousResults.set(G,new te(q.resultId,q.data)):this._previousResults.set(G,new te(M.resultId)),(0,r.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(M.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class H{constructor(M,q){this._documents=M,this._provider=q}async provideDocumentRangeSemanticTokens(M,q,G){const J=this._documents.getDocument(M),be=await this._provider.provideDocumentRangeSemanticTokens(J,d.Range.to(q),G);return be?this._send(be):null}_send(M){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:M.data})}}class ce{static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}constructor(M,q,G,J,be){this._documents=M,this._commands=q,this._provider=G,this._apiDeprecation=J,this._extension=be,this._cache=new c.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(M,q,G,J){const be=this._documents.getDocument(M),se=d.Position.to(q),we=be.getWordRangeAtPosition(se)||new A.Range(se,se),ke=we.with({end:se}),Ue=new f.StopWatch,He=await this._provider.provideCompletionItems(be,se,J,d.CompletionContext.to(G));if(!He||J.isCancellationRequested)return;const Je=Array.isArray(He)?new A.CompletionList(He):He,Ge=ce.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),et=new b.DisposableStore;this._disposables.set(Ge,et);const Qe=[],st={x:Ge,b:Qe,a:{replace:d.Range.from(we),insert:d.Range.from(ke)},c:Je.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<Je.items.length;tt++){const Pe=Je.items[tt],_e=this._convertCompletionItem(Pe,[Ge,tt],ke,we);Qe.push(_e)}return st}async resolveCompletionItem(M,q){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...M);if(!G)return;const J=this._convertCompletionItem(G,M),be=await this._provider.resolveCompletionItem(G,q);if(!be)return;const se=this._convertCompletionItem(be,M);return(J.h!==se.h||J.i!==se.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==se.n||J.o!==se.o||!(0,L.equals)(J.p,se.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:se.d,c:se.c,l:se.l,h:se.h,i:se.i,n:se.n,o:se.o,p:se.p}}releaseCompletionItems(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}_convertCompletionItem(M,q,G,J){const be=this._disposables.get(q[0]);if(!be)throw Error("DisposableStore is missing...");const se=this._commands.toInternal(M.command,be),we={x:q,a:M.label,b:M.kind!==void 0?d.CompletionItemKind.from(M.kind):void 0,m:M.tags&&M.tags.map(d.CompletionItemTag.from),c:M.detail,d:typeof M.documentation>"u"?void 0:d.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters?.join(""),l:M.additionalTextEdits&&M.additionalTextEdits.map(d.TextEdit.from),n:se?.$ident,o:se?.id,p:se?.$ident?void 0:se?.arguments};M.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),we.h=M.textEdit.newText):typeof M.insertText=="string"?we.h=M.insertText:M.insertText instanceof A.SnippetString&&(we.h=M.insertText.value,we.i|=4);let ke;return M.textEdit?ke=M.textEdit.range:M.range&&(ke=M.range),A.Range.isRange(ke)?we.j=d.Range.from(ke):ke&&(!G?.isEqual(ke.inserting)||!J?.isEqual(ke.replacing))&&(we.j={insert:d.Range.from(ke.inserting),replace:d.Range.from(ke.replacing)}),we}}class re{async provideInlineCompletions(M,q,G,J){}disposeCompletions(M){}handleDidShowCompletionItem(M,q,G){}handlePartialAccept(M,q,G){}}class fe extends re{constructor(M,q,G,J){super(),this._extension=M,this._documents=q,this._provider=G,this._commands=J,this._references=new he,this._isAdditionsProposedApiEnabled=(0,i.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[T.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[T.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(M,q,G,J){const be=this._documents.getDocument(M),se=d.Position.to(q),we=await this._provider.provideInlineCompletionItems(be,se,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:d.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},J);if(!we||J.isCancellationRequested)return;const ke=Array.isArray(we)?we:we.items,Ue=this._isAdditionsProposedApiEnabled?Array.isArray(we)?[]:we.commands||[]:[],He=this._isAdditionsProposedApiEnabled&&!Array.isArray(we)?we.suppressSuggestions:void 0,Je=this._isAdditionsProposedApiEnabled&&!Array.isArray(we)?we.enableForwardStability:void 0;let Ge;return{pid:this._references.createReferenceId({dispose(){Ge?.dispose()},items:ke}),items:ke.map((Qe,st)=>{let tt;Qe.command&&(Ge||(Ge=new b.DisposableStore),tt=this._commands.toInternal(Qe.command,Ge));const Pe=Qe.insertText;return{insertText:typeof Pe=="string"?Pe:{snippet:Pe.value},filterText:Qe.filterText,range:Qe.range?d.Range.from(Qe.range):void 0,command:tt,idx:st,completeBracketPairs:this._isAdditionsProposedApiEnabled?Qe.completeBracketPairs:!1}}),commands:Ue.map(Qe=>(Ge||(Ge=new b.DisposableStore),this._commands.toInternal(Qe,Ge))),suppressSuggestions:He,enableForwardStability:Je}}disposeCompletions(M){this._references.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,q,G){const J=this._references.get(M)?.items[q];J&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(J,G)}handlePartialAccept(M,q,G){const J=this._references.get(M)?.items[q];J&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(J,G)}}class he{constructor(){this._references=new Map,this._idPool=1}createReferenceId(M){const q=this._idPool++;return this._references.set(q,M),q}disposeReferenceId(M){const q=this._references.get(M);return this._references.delete(M),q}get(M){return this._references.get(M)}}class z{constructor(M,q){this._documents=M,this._provider=q,this._cache=new c.Cache("SignatureHelp")}async provideSignatureHelp(M,q,G,J){const be=this._documents.getDocument(M),se=d.Position.to(q),we=this.reviveContext(G),ke=await this._provider.provideSignatureHelp(be,se,J,we);if(ke){const Ue=this._cache.add([ke]);return{...d.SignatureHelp.from(ke),id:Ue}}}reviveContext(M){let q;if(M.activeSignatureHelp){const G=d.SignatureHelp.to(M.activeSignatureHelp),J=this._cache.get(M.activeSignatureHelp.id,0);J?(q=J,q.activeSignature=G.activeSignature,q.activeParameter=G.activeParameter):q=G}return{...M,activeSignatureHelp:q}}releaseSignatureHelp(M){this._cache.delete(M)}}class Z{constructor(M,q,G,J,be){this._documents=M,this._commands=q,this._provider=G,this._logService=J,this._extension=be,this._cache=new c.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(M,q,G){const J=this._documents.getDocument(M),be=d.Range.to(q),se=await this._provider.provideInlayHints(J,be,G);if(!Array.isArray(se)||se.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${q}`);return}if(G.isCancellationRequested)return;const we=this._cache.add(se);this._disposables.set(we,new b.DisposableStore);const ke={hints:[],cacheId:we};for(let Ue=0;Ue<se.length;Ue++)this._isValidInlayHint(se[Ue],be)&&ke.hints.push(this._convertInlayHint(se[Ue],[we,Ue]));return this._logService.trace(`[InlayHints] ${ke.hints.length} inlay hints from '${this._extension.identifier.value}' for ${q}`),ke}async resolveInlayHint(M,q){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...M);if(!G)return;const J=await this._provider.resolveInlayHint(G,q);if(J&&this._isValidInlayHint(J))return this._convertInlayHint(J,M)}releaseHints(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}_isValidInlayHint(M,q){return M.label.length===0||Array.isArray(M.label)&&M.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(q&&!q.contains(M.position))}_convertInlayHint(M,q){const G=this._disposables.get(q[0]);if(!G)throw Error("DisposableStore is missing...");const J={label:"",cacheId:q,tooltip:d.MarkdownString.fromStrict(M.tooltip),position:d.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(d.TextEdit.from),kind:M.kind&&d.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};return typeof M.label=="string"?J.label=M.label:J.label=M.label.map(be=>{const se={label:be.value};return se.tooltip=d.MarkdownString.fromStrict(be.tooltip),A.Location.isLocation(be.location)&&(se.location=d.location.from(be.location)),be.command&&(se.command=this._commands.toInternal(be.command,G)),se}),J}}class ye{constructor(M,q){this._documents=M,this._provider=q,this._cache=new c.Cache("DocumentLink")}async provideLinks(M,q){const G=this._documents.getDocument(M),J=await this._provider.provideDocumentLinks(G,q);if(!(!Array.isArray(J)||J.length===0)&&!q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:J.filter(ye._validateLink).map(d.DocumentLink.from)};{const be=this._cache.add(J),se={links:[],cacheId:be};for(let we=0;we<J.length;we++){if(!ye._validateLink(J[we]))continue;const ke=d.DocumentLink.from(J[we]);ke.cacheId=[be,we],se.links.push(ke)}return se}}}static _validateLink(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,q){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...M);if(!G)return;const J=await this._provider.resolveDocumentLink(G,q);if(!(!J||!ye._validateLink(J)))return d.DocumentLink.from(J)}releaseLinks(M){this._cache.delete(M)}}class Re{constructor(M,q){this._documents=M,this._provider=q}async provideColors(M,q){const G=this._documents.getDocument(M),J=await this._provider.provideDocumentColors(G,q);return Array.isArray(J)?J.map(se=>({color:d.Color.from(se.color),range:d.Range.from(se.range)})):[]}async provideColorPresentations(M,q,G){const J=this._documents.getDocument(M),be=d.Range.to(q.range),se=d.Color.to(q.color),we=await this._provider.provideColorPresentations(se,{document:J,range:be},G);if(Array.isArray(we))return we.map(d.ColorPresentation.from)}}class ne{constructor(M,q){this._documents=M,this._provider=q}async provideFoldingRanges(M,q,G){const J=this._documents.getDocument(M),be=await this._provider.provideFoldingRanges(J,q,G);if(Array.isArray(be))return be.map(d.FoldingRange.from)}}class ee{constructor(M,q,G){this._documents=M,this._provider=q,this._logService=G}async provideSelectionRanges(M,q,G){const J=this._documents.getDocument(M),be=q.map(d.Position.to),se=await this._provider.provideSelectionRanges(J,be,G);if(!(0,R.isNonEmptyArray)(se))return[];if(se.length!==be.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const we=[];for(let ke=0;ke<be.length;ke++){const Ue=[];we.push(Ue);let He=be[ke],Je=se[ke];for(;;){if(!Je.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(d.SelectionRange.from(Je)),!Je.parent)break;He=Je.range,Je=Je.parent}}return we}}class de{constructor(M,q){this._documents=M,this._provider=q,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(M,q,G){const J=this._documents.getDocument(M),be=d.Position.to(q),se=await this._provider.prepareCallHierarchy(J,be,G);if(!se)return;const we=this._idPool.nextId();return this._cache.set(we,new Map),Array.isArray(se)?se.map(ke=>this._cacheAndConvertItem(we,ke)):[this._cacheAndConvertItem(we,se)]}async provideCallsTo(M,q,G){const J=this._itemFromCache(M,q);if(!J)throw new Error("missing call hierarchy item");const be=await this._provider.provideCallHierarchyIncomingCalls(J,G);if(be)return be.map(se=>({from:this._cacheAndConvertItem(M,se.from),fromRanges:se.fromRanges.map(we=>d.Range.from(we))}))}async provideCallsFrom(M,q,G){const J=this._itemFromCache(M,q);if(!J)throw new Error("missing call hierarchy item");const be=await this._provider.provideCallHierarchyOutgoingCalls(J,G);if(be)return be.map(se=>({to:this._cacheAndConvertItem(M,se.to),fromRanges:se.fromRanges.map(we=>d.Range.from(we))}))}releaseSession(M){this._cache.delete(M)}_cacheAndConvertItem(M,q){const G=this._cache.get(M),J=d.CallHierarchyItem.from(q,M,G.size.toString(36));return G.set(J._itemId,q),J}_itemFromCache(M,q){return this._cache.get(M)?.get(q)}}class K{constructor(M,q){this._documents=M,this._provider=q,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(M,q,G){const J=this._documents.getDocument(M),be=d.Position.to(q),se=await this._provider.prepareTypeHierarchy(J,be,G);if(!se)return;const we=this._idPool.nextId();return this._cache.set(we,new Map),Array.isArray(se)?se.map(ke=>this._cacheAndConvertItem(we,ke)):[this._cacheAndConvertItem(we,se)]}async provideSupertypes(M,q,G){const J=this._itemFromCache(M,q);if(!J)throw new Error("missing type hierarchy item");const be=await this._provider.provideTypeHierarchySupertypes(J,G);if(be)return be.map(se=>this._cacheAndConvertItem(M,se))}async provideSubtypes(M,q,G){const J=this._itemFromCache(M,q);if(!J)throw new Error("missing type hierarchy item");const be=await this._provider.provideTypeHierarchySubtypes(J,G);if(be)return be.map(se=>this._cacheAndConvertItem(M,se))}releaseSession(M){this._cache.delete(M)}_cacheAndConvertItem(M,q){const G=this._cache.get(M),J=d.TypeHierarchyItem.from(q,M,G.size.toString(36));return G.set(J._itemId,q),J}_itemFromCache(M,q){return this._cache.get(M)?.get(q)}}class le{constructor(M,q,G,J,be){this._proxy=M,this._documents=q,this._provider=G,this._handle=J,this._extension=be}async provideDocumentOnDropEdits(M,q,G,J,be){const se=this._documents.getDocument(q),we=d.Position.to(G),ke=d.DataTransfer.toDataTransfer(J,async He=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,M,He)).buffer),Ue=await this._provider.provideDocumentDropEdits(se,we,ke,be);if(Ue)return{id:Ue.id?this._extension.identifier.value+"."+Ue.id:this._extension.identifier.value,label:Ue.label??(0,a.localize)(1,null,this._extension.displayName||this._extension.name),priority:Ue.priority??0,insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?d.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class oe{constructor(M,q){this.adapter=M,this.extension=q}}class ue{static{this._handlePool=0}constructor(M,q,G,J,be,se,we,ke){this._uriTransformer=q,this._documents=G,this._commands=J,this._diagnostics=be,this._logService=se,this._apiDeprecation=we,this._extensionTelemetry=ke,this._adapter=new Map,this._proxy=M.getProxy(m.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(M,q){return d.DocumentSelector.from(M,this._uriTransformer,q)}_createDisposable(M){return new A.Disposable(()=>{this._adapter.delete(M),this._proxy.$unregister(M)})}_nextHandle(){return ue._handlePool++}async _withAdapter(M,q,G,J,be,se=!1){const we=this._adapter.get(M);if(!we||!(we.adapter instanceof q))return J;const ke=Date.now();se||this._logService.trace(`[${we.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ue=G(we.adapter,we.extension);return Promise.resolve(Ue).catch(He=>{(0,S.isCancellationError)(He)||(this._logService.error(`[${we.extension.identifier.value}] provider FAILED`),this._logService.error(He),this._extensionTelemetry.onExtensionError(we.extension.identifier,He))}).finally(()=>{se||this._logService.trace(`[${we.extension.identifier.value}] provider DONE after ${Date.now()-ke}ms`)}),C.CancellationToken.isCancellationToken(be)?(0,I.raceCancellationError)(Ue,be):Ue}_addNewAdapter(M,q){const G=this._nextHandle();return this._adapter.set(G,new oe(M,q)),G}static _extLabel(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,q,G,J){const be=this._addNewAdapter(new n(this._documents,G),M),se=J&&J.label||ue._extLabel(M);return this._proxy.$registerDocumentSymbolProvider(be,this._transformDocumentSelector(q,M),se),this._createDisposable(be)}$provideDocumentSymbols(M,q,G){return this._withAdapter(M,n,J=>J.provideDocumentSymbols(_.URI.revive(q),G),void 0,G)}registerCodeLensProvider(M,q,G){const J=this._nextHandle(),be=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(J,new oe(new t(this._documents,this._commands.converter,G),M)),this._proxy.$registerCodeLensSupport(J,this._transformDocumentSelector(q,M),be);let se=this._createDisposable(J);if(be!==void 0){const we=G.onDidChangeCodeLenses(ke=>this._proxy.$emitCodeLensEvent(be));se=A.Disposable.from(se,we)}return se}$provideCodeLenses(M,q,G){return this._withAdapter(M,t,J=>J.provideCodeLenses(_.URI.revive(q),G),void 0,G)}$resolveCodeLens(M,q,G){return this._withAdapter(M,t,J=>J.resolveCodeLens(q,G),void 0,void 0)}$releaseCodeLenses(M,q){this._withAdapter(M,t,G=>Promise.resolve(G.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(M,q,G){const J=this._addNewAdapter(new g(this._documents,G),M);return this._proxy.$registerDefinitionSupport(J,this._transformDocumentSelector(q,M)),this._createDisposable(J)}$provideDefinition(M,q,G,J){return this._withAdapter(M,g,be=>be.provideDefinition(_.URI.revive(q),G,J),[],J)}registerDeclarationProvider(M,q,G){const J=this._addNewAdapter(new l(this._documents,G),M);return this._proxy.$registerDeclarationSupport(J,this._transformDocumentSelector(q,M)),this._createDisposable(J)}$provideDeclaration(M,q,G,J){return this._withAdapter(M,l,be=>be.provideDeclaration(_.URI.revive(q),G,J),[],J)}registerImplementationProvider(M,q,G){const J=this._addNewAdapter(new h(this._documents,G),M);return this._proxy.$registerImplementationSupport(J,this._transformDocumentSelector(q,M)),this._createDisposable(J)}$provideImplementation(M,q,G,J){return this._withAdapter(M,h,be=>be.provideImplementation(_.URI.revive(q),G,J),[],J)}registerTypeDefinitionProvider(M,q,G){const J=this._addNewAdapter(new w(this._documents,G),M);return this._proxy.$registerTypeDefinitionSupport(J,this._transformDocumentSelector(q,M)),this._createDisposable(J)}$provideTypeDefinition(M,q,G,J){return this._withAdapter(M,w,be=>be.provideTypeDefinition(_.URI.revive(q),G,J),[],J)}registerHoverProvider(M,q,G,J){const be=this._addNewAdapter(new u(this._documents,G),M);return this._proxy.$registerHoverProvider(be,this._transformDocumentSelector(q,M)),this._createDisposable(be)}$provideHover(M,q,G,J){return this._withAdapter(M,u,be=>be.provideHover(_.URI.revive(q),G,J),void 0,J)}registerEvaluatableExpressionProvider(M,q,G,J){const be=this._addNewAdapter(new E(this._documents,G),M);return this._proxy.$registerEvaluatableExpressionProvider(be,this._transformDocumentSelector(q,M)),this._createDisposable(be)}$provideEvaluatableExpression(M,q,G,J){return this._withAdapter(M,E,be=>be.provideEvaluatableExpression(_.URI.revive(q),G,J),void 0,J)}registerInlineValuesProvider(M,q,G,J){const be=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new P(this._documents,G),M);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(q,M),be);let we=this._createDisposable(se);if(be!==void 0){const ke=G.onDidChangeInlineValues(Ue=>this._proxy.$emitInlineValuesEvent(be));we=A.Disposable.from(we,ke)}return we}$provideInlineValues(M,q,G,J,be){return this._withAdapter(M,P,se=>se.provideInlineValues(_.URI.revive(q),G,J,be),void 0,be)}registerDocumentHighlightProvider(M,q,G){const J=this._addNewAdapter(new O(this._documents,G),M);return this._proxy.$registerDocumentHighlightProvider(J,this._transformDocumentSelector(q,M)),this._createDisposable(J)}$provideDocumentHighlights(M,q,G,J){return this._withAdapter(M,O,be=>be.provideDocumentHighlights(_.URI.revive(q),G,J),void 0,J)}registerLinkedEditingRangeProvider(M,q,G){const J=this._addNewAdapter(new N(this._documents,G),M);return this._proxy.$registerLinkedEditingRangeProvider(J,this._transformDocumentSelector(q,M)),this._createDisposable(J)}$provideLinkedEditingRanges(M,q,G,J){return this._withAdapter(M,N,async be=>{const se=await be.provideLinkedEditingRanges(_.URI.revive(q),G,J);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?ue._serializeRegExp(se.wordPattern):void 0}},void 0,J)}registerReferenceProvider(M,q,G){const J=this._addNewAdapter(new F(this._documents,G),M);return this._proxy.$registerReferenceSupport(J,this._transformDocumentSelector(q,M)),this._createDisposable(J)}$provideReferences(M,q,G,J,be){return this._withAdapter(M,F,se=>se.provideReferences(_.URI.revive(q),G,J,be),void 0,be)}registerCodeActionProvider(M,q,G,J){const be=new b.DisposableStore,se=this._addNewAdapter(new x(this._documents,this._commands.converter,this._diagnostics,G,this._logService,M,this._apiDeprecation),M);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(q,M),{providedKinds:J?.providedCodeActionKinds?.map(we=>we.value),documentation:J?.documentation?.map(we=>({kind:we.kind.value,command:this._commands.converter.toInternal(we.command,be)}))},ue._extLabel(M),!!G.resolveCodeAction),be.add(this._createDisposable(se)),be}$provideCodeActions(M,q,G,J,be){return this._withAdapter(M,x,se=>se.provideCodeActions(_.URI.revive(q),G,J,be),void 0,be)}$resolveCodeAction(M,q,G){return this._withAdapter(M,x,J=>J.resolveCodeAction(q,G),{},void 0)}$releaseCodeActions(M,q){this._withAdapter(M,x,G=>Promise.resolve(G.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(M,q,G){const J=this._addNewAdapter(new U(this._documents,G),M);return this._proxy.$registerDocumentFormattingSupport(J,this._transformDocumentSelector(q,M),M.identifier,M.displayName||M.name),this._createDisposable(J)}$provideDocumentFormattingEdits(M,q,G,J){return this._withAdapter(M,U,be=>be.provideDocumentFormattingEdits(_.URI.revive(q),G,J),void 0,J)}registerDocumentRangeFormattingEditProvider(M,q,G){const J=typeof G.provideDocumentRangesFormattingEdits=="function";J&&(0,i.checkProposedApiEnabled)(M,"formatMultipleRanges");const be=this._addNewAdapter(new X(this._documents,G),M);return this._proxy.$registerRangeFormattingSupport(be,this._transformDocumentSelector(q,M),M.identifier,M.displayName||M.name,J),this._createDisposable(be)}$provideDocumentRangeFormattingEdits(M,q,G,J,be){return this._withAdapter(M,X,se=>se.provideDocumentRangeFormattingEdits(_.URI.revive(q),G,J,be),void 0,be)}$provideDocumentRangesFormattingEdits(M,q,G,J,be){return this._withAdapter(M,X,se=>se.provideDocumentRangesFormattingEdits(_.URI.revive(q),G,J,be),void 0,be)}registerOnTypeFormattingEditProvider(M,q,G,J){const be=this._addNewAdapter(new j(this._documents,G),M);return this._proxy.$registerOnTypeFormattingSupport(be,this._transformDocumentSelector(q,M),J,M.identifier),this._createDisposable(be)}$provideOnTypeFormattingEdits(M,q,G,J,be,se){return this._withAdapter(M,j,we=>we.provideOnTypeFormattingEdits(_.URI.revive(q),G,J,be,se),void 0,se)}registerWorkspaceSymbolProvider(M,q){const G=this._addNewAdapter(new ge(q,this._logService),M);return this._proxy.$registerNavigateTypeSupport(G,typeof q.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(M,q,G){return this._withAdapter(M,ge,J=>J.provideWorkspaceSymbols(q,G),{symbols:[]},G)}$resolveWorkspaceSymbol(M,q,G){return this._withAdapter(M,ge,J=>J.resolveWorkspaceSymbol(q,G),void 0,void 0)}$releaseWorkspaceSymbols(M,q){this._withAdapter(M,ge,G=>G.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(M,q,G){const J=this._addNewAdapter(new ie(this._documents,G,this._logService),M);return this._proxy.$registerRenameSupport(J,this._transformDocumentSelector(q,M),ie.supportsResolving(G)),this._createDisposable(J)}$provideRenameEdits(M,q,G,J,be){return this._withAdapter(M,ie,se=>se.provideRenameEdits(_.URI.revive(q),G,J,be),void 0,be)}$resolveRenameLocation(M,q,G,J){return this._withAdapter(M,ie,be=>be.resolveRenameLocation(_.URI.revive(q),G,J),void 0,J)}registerDocumentSemanticTokensProvider(M,q,G,J){const be=this._addNewAdapter(new $(this._documents,G),M),se=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(be,this._transformDocumentSelector(q,M),J,se);let we=this._createDisposable(be);if(se){const ke=G.onDidChangeSemanticTokens(Ue=>this._proxy.$emitDocumentSemanticTokensEvent(se));we=A.Disposable.from(we,ke)}return we}$provideDocumentSemanticTokens(M,q,G,J){return this._withAdapter(M,$,be=>be.provideDocumentSemanticTokens(_.URI.revive(q),G,J),null,J)}$releaseDocumentSemanticTokens(M,q){this._withAdapter(M,$,G=>G.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,q,G,J){const be=this._addNewAdapter(new H(this._documents,G),M);return this._proxy.$registerDocumentRangeSemanticTokensProvider(be,this._transformDocumentSelector(q,M),J),this._createDisposable(be)}$provideDocumentRangeSemanticTokens(M,q,G,J){return this._withAdapter(M,H,be=>be.provideDocumentRangeSemanticTokens(_.URI.revive(q),G,J),null,J)}registerCompletionItemProvider(M,q,G,J){const be=this._addNewAdapter(new ce(this._documents,this._commands.converter,G,this._apiDeprecation,M),M);return this._proxy.$registerCompletionsProvider(be,this._transformDocumentSelector(q,M),J,ce.supportsResolving(G),M.identifier),this._createDisposable(be)}$provideCompletionItems(M,q,G,J,be){return this._withAdapter(M,ce,se=>se.provideCompletionItems(_.URI.revive(q),G,J,be),void 0,be)}$resolveCompletionItem(M,q,G){return this._withAdapter(M,ce,J=>J.resolveCompletionItem(q,G),void 0,G)}$releaseCompletionItems(M,q){this._withAdapter(M,ce,G=>G.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(M,q,G,J){const be=new fe(M,this._documents,G,this._commands.converter),se=this._addNewAdapter(be,M);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(q,M),be.supportsHandleEvents,D.ExtensionIdentifier.toKey(M.identifier.value),J?.yieldTo?.map(we=>D.ExtensionIdentifier.toKey(we))||[]),this._createDisposable(se)}$provideInlineCompletions(M,q,G,J,be){return this._withAdapter(M,re,se=>se.provideInlineCompletions(_.URI.revive(q),G,J,be),void 0,be)}$handleInlineCompletionDidShow(M,q,G,J){this._withAdapter(M,re,async be=>{be.handleDidShowCompletionItem(q,G,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(M,q,G,J){this._withAdapter(M,re,async be=>{be.handlePartialAccept(q,G,J)},void 0,void 0)}$freeInlineCompletionsList(M,q){this._withAdapter(M,re,async G=>{G.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(M,q,G,J){const be=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,se=this._addNewAdapter(new z(this._documents,G),M);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(q,M),be),this._createDisposable(se)}$provideSignatureHelp(M,q,G,J,be){return this._withAdapter(M,z,se=>se.provideSignatureHelp(_.URI.revive(q),G,J,be),void 0,be)}$releaseSignatureHelp(M,q){this._withAdapter(M,z,G=>G.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(M,q,G){const J=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,be=this._addNewAdapter(new Z(this._documents,this._commands.converter,G,this._logService,M),M);this._proxy.$registerInlayHintsProvider(be,this._transformDocumentSelector(q,M),typeof G.resolveInlayHint=="function",J,ue._extLabel(M));let se=this._createDisposable(be);if(J!==void 0){const we=G.onDidChangeInlayHints(ke=>this._proxy.$emitInlayHintsEvent(J));se=A.Disposable.from(se,we)}return se}$provideInlayHints(M,q,G,J){return this._withAdapter(M,Z,be=>be.provideInlayHints(_.URI.revive(q),G,J),void 0,J)}$resolveInlayHint(M,q,G){return this._withAdapter(M,Z,J=>J.resolveInlayHint(q,G),void 0,G)}$releaseInlayHints(M,q){this._withAdapter(M,Z,G=>G.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(M,q,G){const J=this._addNewAdapter(new ye(this._documents,G),M);return this._proxy.$registerDocumentLinkProvider(J,this._transformDocumentSelector(q,M),typeof G.resolveDocumentLink=="function"),this._createDisposable(J)}$provideDocumentLinks(M,q,G){return this._withAdapter(M,ye,J=>J.provideLinks(_.URI.revive(q),G),void 0,G,q.scheme==="output")}$resolveDocumentLink(M,q,G){return this._withAdapter(M,ye,J=>J.resolveLink(q,G),void 0,void 0,!0)}$releaseDocumentLinks(M,q){this._withAdapter(M,ye,G=>G.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(M,q,G){const J=this._addNewAdapter(new Re(this._documents,G),M);return this._proxy.$registerDocumentColorProvider(J,this._transformDocumentSelector(q,M)),this._createDisposable(J)}$provideDocumentColors(M,q,G){return this._withAdapter(M,Re,J=>J.provideColors(_.URI.revive(q),G),[],G)}$provideColorPresentations(M,q,G,J){return this._withAdapter(M,Re,be=>be.provideColorPresentations(_.URI.revive(q),G,J),void 0,J)}registerFoldingRangeProvider(M,q,G){const J=this._nextHandle(),be=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(J,new oe(new ne(this._documents,G),M)),this._proxy.$registerFoldingRangeProvider(J,this._transformDocumentSelector(q,M),M.identifier,be);let se=this._createDisposable(J);if(be!==void 0){const we=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(be));se=A.Disposable.from(se,we)}return se}$provideFoldingRanges(M,q,G,J){return this._withAdapter(M,ne,be=>be.provideFoldingRanges(_.URI.revive(q),G,J),void 0,J)}registerSelectionRangeProvider(M,q,G){const J=this._addNewAdapter(new ee(this._documents,G,this._logService),M);return this._proxy.$registerSelectionRangeProvider(J,this._transformDocumentSelector(q,M)),this._createDisposable(J)}$provideSelectionRanges(M,q,G,J){return this._withAdapter(M,ee,be=>be.provideSelectionRanges(_.URI.revive(q),G,J),[],J)}registerCallHierarchyProvider(M,q,G){const J=this._addNewAdapter(new de(this._documents,G),M);return this._proxy.$registerCallHierarchyProvider(J,this._transformDocumentSelector(q,M)),this._createDisposable(J)}$prepareCallHierarchy(M,q,G,J){return this._withAdapter(M,de,be=>Promise.resolve(be.prepareSession(_.URI.revive(q),G,J)),void 0,J)}$provideCallHierarchyIncomingCalls(M,q,G,J){return this._withAdapter(M,de,be=>be.provideCallsTo(q,G,J),void 0,J)}$provideCallHierarchyOutgoingCalls(M,q,G,J){return this._withAdapter(M,de,be=>be.provideCallsFrom(q,G,J),void 0,J)}$releaseCallHierarchy(M,q){this._withAdapter(M,de,G=>Promise.resolve(G.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(M,q,G){const J=this._addNewAdapter(new K(this._documents,G),M);return this._proxy.$registerTypeHierarchyProvider(J,this._transformDocumentSelector(q,M)),this._createDisposable(J)}$prepareTypeHierarchy(M,q,G,J){return this._withAdapter(M,K,be=>Promise.resolve(be.prepareSession(_.URI.revive(q),G,J)),void 0,J)}$provideTypeHierarchySupertypes(M,q,G,J){return this._withAdapter(M,K,be=>be.provideSupertypes(q,G,J),void 0,J)}$provideTypeHierarchySubtypes(M,q,G,J){return this._withAdapter(M,K,be=>be.provideSubtypes(q,G,J),void 0,J)}$releaseTypeHierarchy(M,q){this._withAdapter(M,K,G=>Promise.resolve(G.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(M,q,G,J){const be=this._nextHandle();return this._adapter.set(be,new oe(new le(this._proxy,this._documents,G,be,M),M)),this._proxy.$registerDocumentOnDropEditProvider(be,this._transformDocumentSelector(q,M),(0,i.isProposedApiEnabled)(M,"dropMetadata")?J:void 0),this._createDisposable(be)}$provideDocumentOnDropEdits(M,q,G,J,be,se){return this._withAdapter(M,le,we=>Promise.resolve(we.provideDocumentOnDropEdits(q,_.URI.revive(G),J,be,se)),void 0,void 0)}registerDocumentPasteEditProvider(M,q,G,J){const be=this._nextHandle();return this._adapter.set(be,new oe(new B(this._proxy,this._documents,G,be,M),M)),this._proxy.$registerPasteEditProvider(be,this._transformDocumentSelector(q,M),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this._createDisposable(be)}$prepareDocumentPaste(M,q,G,J,be){return this._withAdapter(M,B,se=>se.prepareDocumentPaste(_.URI.revive(q),G,J,be),void 0,be)}$providePasteEdits(M,q,G,J,be,se){return this._withAdapter(M,B,we=>we.providePasteEdits(q,_.URI.revive(G),J,be,se),void 0,se)}static _serializeRegExp(M){return{pattern:M.source,flags:(0,y.regExpFlags)(M)}}static _serializeIndentationRule(M){return{decreaseIndentPattern:ue._serializeRegExp(M.decreaseIndentPattern),increaseIndentPattern:ue._serializeRegExp(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?ue._serializeRegExp(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?ue._serializeRegExp(M.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(M){return{beforeText:ue._serializeRegExp(M.beforeText),afterText:M.afterText?ue._serializeRegExp(M.afterText):void 0,previousLineText:M.previousLineText?ue._serializeRegExp(M.previousLineText):void 0,action:M.action}}static _serializeOnEnterRules(M){return M.map(ue._serializeOnEnterRule)}setLanguageConfiguration(M,q,G){const{wordPattern:J}=G;if(J&&(0,y.regExpLeadsToEndlessLoop)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this._documents.setWordDefinitionFor(q,J):this._documents.setWordDefinitionFor(q,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",M,"Do not use."),G.autoClosingPairs&&(0,i.checkProposedApiEnabled)(M,"languageConfigurationAutoClosingPairs");const be=this._nextHandle(),se={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ue._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?ue._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ue._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs};return this._proxy.$setLanguageConfiguration(be,q,se),this._createDisposable(be)}$setWordDefinitions(M){for(const q of M)this._documents.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.ExtHostLanguageFeatures=ue}),define(De[297],Ie([1,0,6,16,7,40,17,4]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(R,k,p,C){this._documents=k,this._commands=p,this._uriTransformer=C,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(_.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,k){await this._proxy.$changeLanguage(R,k);const p=this._documents.getDocumentData(R);if(!p)throw new Error(`document '${R.toString()}' NOT found`);return p.document}async tokenAtPosition(R,k){const p=R.version,C=L.Position.from(k),D=await this._proxy.$tokensAtPosition(R.uri,C),b={type:d.StandardTokenType.Other,range:R.getWordRangeAtPosition(k)??new d.Range(k.line,k.character,k.line,k.character)};if(!D)return b;const r={range:L.Range.to(D.range),type:L.TokenType.to(D.type)};return!r.range.contains(k)||p!==R.version?b:r}createLanguageStatusItem(R,k,p){const C=this._handlePool++,D=this._proxy,b=this._ids,r=`${R.identifier.value}/${k}`;if(b.has(r))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);b.add(r);const s={selector:p,id:k,name:R.displayName??R.name,severity:d.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const f=new m.DisposableStore,S=()=>{if(c?.dispose(),!b.has(r)){console.warn(`LanguageStatusItem (${k}) from ${R.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,T.disposableTimeout)(()=>{f.clear(),this._proxy.$setLanguageStatus(C,{id:r,name:s.name??R.displayName??R.name,source:R.displayName??R.name,selector:L.DocumentSelector.from(s.selector,this._uriTransformer),label:s.text,detail:s.detail??"",severity:s.severity===d.LanguageStatusSeverity.Error?A.default.Error:s.severity===d.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:s.command&&this._commands.toInternal(s.command,f),accessibilityInfo:s.accessibilityInformation,busy:s.busy})},0)},I={dispose(){f.dispose(),c?.dispose(),D.$removeLanguageStatus(C),b.delete(r)},get id(){return s.id},get name(){return s.name},set name(i){s.name=i,S()},get selector(){return s.selector},set selector(i){s.selector=i,S()},get text(){return s.text},set text(i){s.text=i,S()},get detail(){return s.detail},set detail(i){s.detail=i,S()},get severity(){return s.severity},set severity(i){s.severity=i,S()},get accessibilityInformation(){return s.accessibilityInformation},set accessibilityInformation(i){s.accessibilityInformation=i,S()},get command(){return s.command},set command(i){s.command=i,S()},get busy(){return s.busy},set busy(i){s.busy=i,S()}};return S(),I}}e.ExtHostLanguages=y}),define(De[106],Ie([1,0,11,12,2,5,18,6,26,20]),function(me,e,_,L,d,A,T,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(p,C,D){this.logService=D,this.bundleCache=new Map,this._proxy=C.getProxy(m.MainContext.MainThreadLocalization),this.currentLanguage=p.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===_.LANGUAGE_DEFAULT}getMessage(p,C){const{message:D,args:b,comment:r}=C;if(this.isDefaultLanguage)return(0,L.format2)(D,b??{});let s=D;r&&r.length>0&&(s+=`/${Array.isArray(r)?r.join(""):r}`);const c=this.bundleCache.get(p)?.contents[s];return c||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,L.format2)(c??D,b??{})}getBundle(p){return this.bundleCache.get(p)?.contents}getBundleUri(p){return this.bundleCache.get(p)?.uri}async initializeLocalizedMessages(p){if(this.isDefaultLanguage||!p.l10n&&!p.isBuiltin||this.bundleCache.has(p.identifier.value))return;let C;const D=await this.getBundleLocation(p);if(!D){this.logService.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const b=await this._proxy.$fetchBundleContents(D),r=JSON.parse(b);C=p.isBuiltin?r.contents?.bundle:r}catch(b){this.logService.error(`Failed to load translations for ${p.identifier.value} from ${D}: ${b.message}`);return}C&&this.bundleCache.set(p.identifier.value,{contents:C,uri:D})}async getBundleLocation(p){if(p.isBuiltin){const C=await this._proxy.$fetchBuiltInBundleUri(p.identifier.value,this.currentLanguage);return d.URI.revive(C)}return p.l10n?d.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=R,e.ExtHostLocalizationService=R=Ve([$e(0,y.IExtHostInitDataService),$e(1,v.IExtHostRpcService),$e(2,T.ILogService)],R),e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(De[143],Ie([1,0,18,6,26,20,2,73]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends _.AbstractLoggerService{constructor(k,p){super(p.logLevel,p.logsLocation,p.loggers.map(C=>(0,m.revive)(C))),this._proxy=k.getProxy(L.MainContext.MainThreadLogger)}$setLogLevel(k,p){p?this.setLogLevel(T.URI.revive(p),k):this.setLogLevel(k)}setVisibility(k,p){super.setVisibility(k,p),this._proxy.$setVisibility(k,p)}doCreateLogger(k,p,C){return new v(this._proxy,k,p,C)}};e.ExtHostLoggerService=y,e.ExtHostLoggerService=y=Ve([$e(0,A.IExtHostRpcService),$e(1,d.IExtHostInitDataService)],y);class v extends _.AbstractMessageLogger{constructor(k,p,C,D){super(D?.logLevel==="always"),this.proxy=k,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(C),this.proxy.$createLogger(p,D).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(k,p){const C=[[k,p]];this.isLoggerCreated?this.doLog(C):this.buffer.push(...C)}doLog(k){this.proxy.$log(this.file,k)}flush(){this.proxy.$flush(this.file)}}}),define(De[107],Ie([1,0,6,5,4,20,22]),function(me,e,_,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,L.createDecorator)("IExtHostManagedSockets");let m=class{constructor(k){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=k.getProxy(_.MainContext.MainThreadManagedSockets)}setFactory(k,p){for(const C of this._managedRemoteSockets.values())C.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new y(k,p),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(k){if(!this._factory||this._factory.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const p=++this._remoteSocketIdCounter,C=await this._factory.makeConnection(),D=new d.DisposableStore;return this._managedRemoteSockets.set(p,new v(p,C,D)),D.add((0,d.toDisposable)(()=>this._managedRemoteSockets.delete(p))),D.add(C.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(p),D.dispose()})),D.add(C.onDidClose(b=>{this._proxy.$onDidManagedSocketClose(p,b?.stack??b?.message),D.dispose()})),D.add(C.onDidReceiveMessage(b=>this._proxy.$onDidManagedSocketHaveData(p,T.VSBuffer.wrap(b)))),p}$remoteSocketWrite(k,p){this._managedRemoteSockets.get(k)?.actual.send(p.buffer)}$remoteSocketEnd(k){const p=this._managedRemoteSockets.get(k);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(k){await this._managedRemoteSockets.get(k)?.actual.drain?.()}};e.ExtHostManagedSockets=m,e.ExtHostManagedSockets=m=Ve([$e(0,A.IExtHostRpcService)],m);class y{constructor(k,p){this.socketFactoryId=k,this.makeConnection=p}}class v extends d.Disposable{constructor(k,p,C){super(),this.socketId=k,this.actual=p,this._register(C)}}}),define(De[298],Ie([1,0,6,18,27]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(m){return m&&m.title}let T=class{constructor(y,v){this._logService=v,this._proxy=y.getProxy(_.MainContext.MainThreadMessageService)}showMessage(y,v,R,k,p){const C={source:{identifier:y.identifier,label:y.displayName||y.name}};let D;typeof k=="string"||A(k)?D=[k,...p]:(C.modal=k?.modal,C.useCustom=k?.useCustom,C.detail=k?.detail,D=p),C.useCustom&&(0,d.checkProposedApiEnabled)(y,"resolvers");const b=[];for(let r=0;r<D.length;r++){const s=D[r];if(typeof s=="string")b.push({title:s,handle:r,isCloseAffordance:!1});else if(typeof s=="object"){const{title:c,isCloseAffordance:f}=s;b.push({title:c,isCloseAffordance:!!f,handle:r})}else this._logService.warn("Invalid message item:",s)}return this._proxy.$showMessage(v,R,C,b).then(r=>{if(typeof r=="number")return D[r]})}};e.ExtHostMessageService=T,e.ExtHostMessageService=T=Ve([$e(1,L.ILogService)],T)}),define(De[299],Ie([1,0,197,22,3,4,28,12,14,2,30,81,6,36,16,7,60,266,138,8,23,15]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c,f,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class i{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(n=>n.apiEditor)}constructor(n,t,o,g,l){this._textDocumentsAndEditors=o,this._textDocuments=g,this._extHostFileSystem=l,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new d.Emitter({onListenerError:f.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new d.Emitter({onListenerError:f.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new d.Emitter({onListenerError:f.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new d.Emitter({onListenerError:f.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new k.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=n.getProxy(p.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=n.getProxy(p.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=n.getProxy(p.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===13){const w=h.notebookEditor?.notebookUri,u=h.cell.handle,P=this._documents.get(w)?.getCell(u);if(P)return P.apiCell}if(h&&h.$mid===14){const w=h.uri,u=this._documents.get(w);if(u)return u.apiNotebook}return h}}),i._registerApiCommands(t)}getEditorById(n){const t=this._editors.get(n);if(!t)throw new Error(`unknown text editor: ${n}. known editors: ${[...this._editors.keys()]} `);return t}getIdByEditor(n){for(const[t,o]of this._editors)if(o.apiEditor===n)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(n,t){const o=this._documents.get(n);if(!o&&!t)throw new Error(`NO notebook document for '${n}'`);return o}static _convertNotebookRegistrationData(n,t){if(!t)return;const o=t.filenamePattern.map(g=>D.NotebookExclusiveDocumentPattern.from(g)).filter(g=>g!==void 0);if(t.filenamePattern&&!o){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:n.identifier,providerDisplayName:n.displayName||n.name,displayName:t.displayName,filenamePattern:o,exclusive:t.exclusive||!1}}registerNotebookCellStatusBarItemProvider(n,t,o){const g=i._notebookStatusBarItemProviderHandlePool++,l=typeof o.onDidChangeCellStatusBarItems=="function"?i._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(g,o),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(g,l,t);let h;return l!==void 0&&(h=o.onDidChangeCellStatusBarItems(w=>this._notebookProxy.$emitCellStatusBarEvent(l))),new b.Disposable(()=>{this._notebookStatusBarItemProviders.delete(g),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(g,l),h?.dispose()})}async createNotebookDocument(n){const t=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:n.viewType,content:n.content&&D.NotebookData.from(n.content)});return v.URI.revive(t)}async openNotebookDocument(n){const t=this._documents.get(n);if(t)return t.apiNotebook;const o=await this._notebookDocumentsProxy.$tryOpenNotebook(n),g=this._documents.get(v.URI.revive(o));return(0,y.assertIsDefined)(g?.apiNotebook)}async showNotebookDocument(n,t){v.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let o;typeof t=="object"?o={position:D.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(D.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:o={preserveFocus:!1};const g=await this._notebookEditorsProxy.$tryShowNotebookDocument(n.uri,n.notebookType,o),l=g&&this._editors.get(g)?.apiEditor;if(l)return l;throw g?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(n,t,o,g){const l=this._notebookStatusBarItemProviders.get(n),h=v.URI.revive(t),w=this._documents.get(h);if(!w||!l)return;const u=w.getCellFromIndex(o);if(!u)return;const E=await l.provideCellStatusBarItems(u.apiCell,g);if(!E)return;const P=new A.DisposableStore,O=this._statusBarCache.add([P]),F=(Array.isArray(E)?E:[E]).map(x=>D.NotebookStatusBarItem.from(x,this._commandsConverter,P));return{cacheId:O,items:F}}$releaseNotebookCellStatusBarItems(n){this._statusBarCache.delete(n)}registerNotebookSerializer(n,t,o,g,l){if((0,m.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");const h=this._handlePool++;return this._notebookSerializer.set(h,{viewType:t,serializer:o,options:g}),this._notebookProxy.$registerNotebookSerializer(h,{id:n.identifier,location:n.extensionLocation},t,D.NotebookDocumentContentOptions.from(g),i._convertNotebookRegistrationData(n,l)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(h)})}async $dataToNotebook(n,t,o){const g=this._notebookSerializer.get(n);if(!g)throw new Error("NO serializer found");const l=await g.serializer.deserializeNotebook(t.buffer,o);return new r.SerializableObjectWithBuffers(D.NotebookData.from(l))}async $notebookToData(n,t,o){const g=this._notebookSerializer.get(n);if(!g)throw new Error("NO serializer found");const l=await g.serializer.serializeNotebook(D.NotebookData.to(t.value),o);return L.VSBuffer.wrap(l)}async $saveNotebook(n,t,o,g,l){const h=v.URI.revive(t),w=this._notebookSerializer.get(n);if(!w)throw new Error("NO serializer found");const u=this._documents.get(h);if(!u)throw new Error("Document NOT found");if(u.versionId!==o)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(h.scheme))throw new R.FileOperationError((0,_.localize)(0,null,this._resourceForError(h)),6);await this._validateWriteFile(h,g);const E={metadata:(0,S.filter)(u.apiNotebook.metadata,x=>!(w.options?.transientDocumentMetadata??{})[x]),cells:[]};for(const x of u.apiNotebook.getCells()){const B=new b.NotebookCellData(x.kind,x.document.getText(),x.document.languageId,x.mime,w.options?.transientOutputs?[]:[...x.outputs],x.metadata,x.executionSummary);B.metadata=(0,S.filter)(x.metadata,U=>!(w.options?.transientCellMetadata??{})[U]),E.cells.push(B)}const P=await w.serializer.serializeNotebook(E,l);await this._extHostFileSystem.value.writeFile(h,P);const O=this._extHostFileSystem.getFileSystemProviderExtUri(h.scheme),N=await this._extHostFileSystem.value.stat(h);return{name:O.basename(h),isFile:(N.type&R.FileType.File)!==0,isDirectory:(N.type&R.FileType.Directory)!==0,isSymbolicLink:(N.type&R.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&R.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(h.scheme),locked:!!((N.permissions??0)&R.FilePermission.Locked),etag:R.etag({mtime:N.mtime,size:N.size}),children:void 0}}async _validateWriteFile(n,t){const o=await this._extHostFileSystem.value.stat(n);if(typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==R.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==R.etag({mtime:t.mtime,size:o.size}))throw new R.FileOperationError((0,_.localize)(1,null),3,t)}_resourceForError(n){return n.scheme===I.Schemas.file?n.fsPath:n.toString()}_createExtHostEditor(n,t,o){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const g=new c.ExtHostNotebookEditor(t,this._notebookEditorsProxy,n,o.visibleRanges.map(D.NotebookRange.to),o.selections.map(D.NotebookRange.to),typeof o.viewColumn=="number"?D.ViewColumn.to(o.viewColumn):void 0);this._editors.set(t,g)}$acceptDocumentAndEditorsDelta(n){if(n.value.removedDocuments)for(const o of n.value.removedDocuments){const g=v.URI.revive(o),l=this._documents.get(g);l&&(l.dispose(),this._documents.delete(g),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:l.apiNotebook.getCells().map(h=>h.document.uri)}),this._onDidCloseNotebookDocument.fire(l.apiNotebook));for(const h of this._editors.values())h.notebookData.uri.toString()===g.toString()&&this._editors.delete(h.id)}if(n.value.addedDocuments){const o=[];for(const g of n.value.addedDocuments){const l=v.URI.revive(g.uri);if(this._documents.has(l))throw new Error(`adding EXISTING notebook ${l} `);const h=new s.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,l,g);o.push(...g.cells.map(w=>s.ExtHostCell.asModelAddData(h.apiNotebook,w))),this._documents.get(l)?.dispose(),this._documents.set(l,h),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:o}),this._onDidOpenNotebookDocument.fire(h.apiNotebook)}}if(n.value.addedEditors)for(const o of n.value.addedEditors){if(this._editors.has(o.id))return;const g=v.URI.revive(o.documentUri),l=this._documents.get(g);l&&this._createExtHostEditor(l,o.id,o)}const t=[];if(n.value.removedEditors)for(const o of n.value.removedEditors){const g=this._editors.get(o);g&&(this._editors.delete(o),this._activeNotebookEditor?.id===g.id&&(this._activeNotebookEditor=void 0),t.push(g))}if(n.value.visibleEditors){this._visibleNotebookEditors=n.value.visibleEditors.map(g=>this._editors.get(g)).filter(g=>!!g);const o=new Set;this._visibleNotebookEditors.forEach(g=>o.add(g.id));for(const g of this._editors.values()){const l=o.has(g.id);g._acceptVisibility(l)}this._visibleNotebookEditors=[...this._editors.values()].map(g=>g).filter(g=>g.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}n.value.newActiveEditor===null?this._activeNotebookEditor=void 0:n.value.newActiveEditor&&(this._editors.get(n.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${n.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(n.value.newActiveEditor)),n.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(n){const t=C.ApiCommandArgument.String.with("notebookType","A notebook type"),o=new C.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[t,new C.ApiCommandArgument("data","Bytes to convert to data",l=>l instanceof Uint8Array,l=>L.VSBuffer.wrap(l))],new C.ApiCommandResult("Notebook Data",l=>D.NotebookData.to(l.value))),g=new C.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[t,new C.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",l=>!0,l=>new r.SerializableObjectWithBuffers(D.NotebookData.from(l)))],new C.ApiCommandResult("Bytes",l=>l.buffer));n.registerApiCommand(o),n.registerApiCommand(g)}}e.ExtHostNotebookController=i}),define(De[300],Ie([1,0,19,17,21,3,4,28,2,25,18,81,6,36,16,7,104,260,27,60]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let S=class{constructor(l,h,w,u,E){this._initData=h,this._extHostNotebook=w,this._commands=u,this._logService=E,this._activeExecutions=new m.ResourceMap,this._activeNotebookExecutions=new m.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new k.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=l.getProxy(p.MainContext.MainThreadNotebookKernels);const P=new C.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new C.ApiCommandArgument("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const N=this._extHostNotebook.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:N}}else if(O&&"notebookEditor"in O){const N=this._extHostNotebook.getIdByEditor(O.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return O})],C.ApiCommandResult.Void);this._commands.registerApiCommand(P)}createNotebookController(l,h,w,u,E,P){for(const re of this._kernelData.values())if(re.controller.id===h&&v.ExtensionIdentifier.equals(l.identifier,re.extensionId))throw new Error(`notebook controller with id '${h}' ALREADY exist`);const O=this._handlePool++,N=this;this._logService.trace(`NotebookController[${O}], CREATED by ${l.identifier.value}, ${h}`);const F=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${l.identifier}'`);let x=!1;const B=new T.DisposableStore,U=new A.Emitter,X=new A.Emitter,j={id:o(l.identifier,h),notebookType:w,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:u||l.identifier.value,preloads:P?P.map(D.NotebookRendererScript.from):[]};let ge=E??F,ie;this._proxy.$addKernel(O,j).catch(re=>{console.log(re),x=!0});let te=0;const $=()=>{if(x)return;const re=++te;Promise.resolve().then(()=>{re===te&&this._proxy.$updateKernel(O,j)})},H=new m.ResourceMap,ce={get id(){return h},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return j.label},set label(re){j.label=re??l.displayName??l.name,$()},get detail(){return j.detail??""},set detail(re){j.detail=re,$()},get description(){return j.description??""},set description(re){j.description=re,$()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(re){j.supportedLanguages=re,$()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(re){j.supportsExecutionOrder=re,$()},get rendererScripts(){return j.preloads?j.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return ge},set executeHandler(re){ge=re??F},get interruptHandler(){return ie},set interruptHandler(re){ie=re,j.supportsInterrupt=!!re,$()},createNotebookCellExecution(re){if(x)throw new Error("notebook controller is DISPOSED");if(!H.has(re.notebook.uri))throw N._logService.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(fe=>fe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return N._createNotebookCellExecution(re,o(l.identifier,this.id))},createNotebookExecution(re){if((0,c.checkProposedApiEnabled)(l,"notebookExecution"),x)throw new Error("notebook controller is DISPOSED");if(!H.has(re.uri))throw N._logService.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(fe=>fe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.uri.toString()}`);return N._createNotebookExecution(re,o(l.identifier,this.id))},dispose:()=>{x||(this._logService.trace(`NotebookController[${O}], DISPOSED`),x=!0,this._kernelData.delete(O),B.dispose(),U.dispose(),X.dispose(),this._proxy.$removeKernel(O))},updateNotebookAffinity(re,fe){fe===b.NotebookControllerAffinity2.Hidden&&(0,c.checkProposedApiEnabled)(l,"notebookControllerAffinityHidden"),N._proxy.$updateNotebookPriority(O,re.uri,fe)},onDidReceiveMessage:X.event,postMessage(re,fe){return(0,c.checkProposedApiEnabled)(l,"notebookMessaging"),N._proxy.$postMessage(O,fe&&N._extHostNotebook.getIdByEditor(fe),re)},asWebviewUri(re){return(0,c.checkProposedApiEnabled)(l,"notebookMessaging"),(0,r.asWebviewUri)(re,N._initData.remote)}};return this._kernelData.set(O,{extensionId:l.identifier,controller:ce,onDidReceiveMessage:X,onDidChangeSelection:U,associatedNotebooks:H}),ce}getIdByController(l){for(const[h,w]of this._kernelData)if(w.controller===l)return o(w.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,h){const w=this._kernelDetectionTaskHandlePool++,u=this;this._logService.trace(`NotebookControllerDetectionTask[${w}], CREATED by ${l.identifier.value}`),this._proxy.$addKernelDetectionTask(w,h);const E={dispose:()=>{this._kernelDetectionTask.delete(w),u._proxy.$removeKernelDetectionTask(w)}};return this._kernelDetectionTask.set(w,E),E}registerKernelSourceActionProvider(l,h,w){const u=this._kernelSourceActionProviderHandlePool++,E=typeof w.onDidChangeNotebookKernelSourceActions=="function"?u:void 0,P=this;this._kernelSourceActionProviders.set(u,w),this._logService.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${l.identifier.value}`),this._proxy.$addKernelSourceActionProvider(u,u,h);let O;return E!==void 0&&(O=w.onDidChangeNotebookKernelSourceActions(N=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(E))),{dispose:()=>{this._kernelSourceActionProviders.delete(u),P._proxy.$removeKernelSourceActionProvider(u,u),O?.dispose()}}}async $provideKernelSourceActions(l,h){const w=this._kernelSourceActionProviders.get(l);if(w){const u=new T.DisposableStore;return this._kernelSourceActionProviderCache.add([u]),(await w.provideNotebookKernelSourceActions(h)??[]).map(P=>D.NotebookKernelSourceAction.from(P,this._commands.converter,u))}return[]}$acceptNotebookAssociation(l,h,w){const u=this._kernelData.get(l);if(u){const E=this._extHostNotebook.getNotebookDocument(y.URI.revive(h));w?u.associatedNotebooks.set(E.uri,!0):u.associatedNotebooks.delete(E.uri),this._logService.trace(`NotebookController[${l}] ASSOCIATE notebook`,E.uri.toString(),w),u.onDidChangeSelection.fire({selected:w,notebook:E.apiNotebook})}}async $executeCells(l,h,w){const u=this._kernelData.get(l);if(!u)return;const E=this._extHostNotebook.getNotebookDocument(y.URI.revive(h)),P=[];for(const O of w){const N=E.getCell(O);N&&P.push(N.apiCell)}try{this._logService.trace(`NotebookController[${l}] EXECUTE cells`,E.uri.toString(),P.length),await u.controller.executeHandler.call(u.controller,P,E.apiNotebook,u.controller)}catch(O){this._logService.error(`NotebookController[${l}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(l,h,w){const u=this._kernelData.get(l);if(!u)return;const E=this._extHostNotebook.getNotebookDocument(y.URI.revive(h));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,E.apiNotebook);else for(const P of w){const O=E.getCell(P);O&&this._activeExecutions.get(O.uri)?.cancel()}if(u.controller.interruptHandler){const P=this._activeNotebookExecutions.get(E.uri);w.length&&Array.isArray(P)&&P.length&&P.forEach(O=>O.dispose())}}$acceptKernelMessageFromRenderer(l,h,w){const u=this._kernelData.get(l);if(!u)return;const E=this._extHostNotebook.getEditorById(h);u.onDidReceiveMessage.fire(Object.freeze({editor:E.apiEditor,message:w}))}$cellExecutionChanged(l,h,w){const E=this._extHostNotebook.getNotebookDocument(y.URI.revive(l)).getCell(h);if(E){const P=w?D.NotebookCellExecutionState.to(w):b.NotebookCellExecutionState.Idle;P!==void 0&&this._onDidChangeCellExecutionState.fire({cell:E.apiCell,state:P})}}_createNotebookCellExecution(l,h){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this._extHostNotebook.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!u)throw new Error("invalid cell");if(this._activeExecutions.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const E=new i(h,u,this._proxy);this._activeExecutions.set(u.uri,E);const P=E.onDidChangeState(()=>{E.state===I.Resolved&&(E.dispose(),P.dispose(),this._activeExecutions.delete(u.uri))});return E.asApiObject()}_createNotebookExecution(l,h){const w=this._extHostNotebook.getNotebookDocument(l.uri),u=l.getCells().find(O=>{const N=w.getCellFromApiCell(O);return N&&this._activeExecutions.has(N.uri)});if(u)throw new Error(`duplicate cell execution for ${u.document.uri}`);if(this._activeNotebookExecutions.has(w.uri))throw new Error(`duplicate notebook execution for ${w.uri}`);const E=new n(h,w,this._proxy),P=E.onDidChangeState(()=>{E.state===a.Resolved&&(E.dispose(),P.dispose(),this._activeNotebookExecutions.delete(w.uri))});return this._activeNotebookExecutions.set(w.uri,[E,P]),E.asApiObject()}};e.ExtHostNotebookKernels=S,e.ExtHostNotebookKernels=S=Ve([$e(4,R.ILogService)],S);var I;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(I||(I={}));class i extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(l,h,w){super(),this._cell=h,this._proxy=w,this._handle=i.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=I.Init,this._tokenSource=this._register(new d.CancellationTokenSource),this._collector=new t(10,u=>this.update(u)),this._executionOrder=h.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,l,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(l){await this._collector.addItem(l)}async update(l){const h=Array.isArray(l)?l:[l];return this._proxy.$updateExecution(this._handle,new f.SerializableObjectWithBuffers(h))}verifyStateForOutput(){if(this._state===I.Init)throw new Error("Must call start before modifying cell output");if(this._state===I.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(l){let h=this._cell;if(l&&(h=this._cell.notebook.getCellFromApiCell(l)),!h)throw new Error("INVALID cell");return h.handle}validateAndConvertOutputs(l){return l.map(h=>{const w=b.NotebookCellOutput.ensureUniqueMimeTypes(h.items,!0);return w===h.items?D.NotebookCellOutput.from(h):D.NotebookCellOutput.from({items:w,id:h.id,metadata:h.metadata})})}async updateOutputs(l,h,w){const u=this.cellIndexToHandle(h),E=this.validateAndConvertOutputs((0,_.asArray)(l));return this.updateSoon({editType:s.CellExecutionUpdateType.Output,cellHandle:u,append:w,outputs:E})}async updateOutputItems(l,h,w){return l=b.NotebookCellOutput.ensureUniqueMimeTypes((0,_.asArray)(l),!0),this.updateSoon({editType:s.CellExecutionUpdateType.OutputItems,items:l.map(D.NotebookCellOutputItem.from),outputId:h.id,append:w})}asApiObject(){const l=this;return Object.freeze({get token(){return l._tokenSource.token},get cell(){return l._cell.apiCell},get executionOrder(){return l._executionOrder},set executionOrder(w){l._executionOrder=w,l.update([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:l._executionOrder}])},start(w){if(l._state===I.Resolved||l._state===I.Started)throw new Error("Cannot call start again");l._state=I.Started,l._onDidChangeState.fire(),l.update({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:w})},end(w,u){if(l._state===I.Resolved)throw new Error("Cannot call resolve twice");l._state=I.Resolved,l._onDidChangeState.fire(),l._collector.flush(),l._proxy.$completeExecution(l._handle,new f.SerializableObjectWithBuffers({runEndTime:u,lastRunSuccess:w}))},clearOutput(w){return l.verifyStateForOutput(),l.updateOutputs([],w,!1)},appendOutput(w,u){return l.verifyStateForOutput(),l.updateOutputs(w,u,!0)},replaceOutput(w,u){return l.verifyStateForOutput(),l.updateOutputs(w,u,!1)},appendOutputItems(w,u){return l.verifyStateForOutput(),l.updateOutputItems(w,u,!0)},replaceOutputItems(w,u){return l.verifyStateForOutput(),l.updateOutputItems(w,u,!1)}})}}var a;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(a||(a={}));class n extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(l,h,w){super(),this._notebook=h,this._proxy=w,this._handle=n.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new d.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,l,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===a.Resolved||this._state===a.Started)throw new Error("Cannot call start again");this._state=a.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===a.Resolved)throw new Error("Cannot call resolve twice");this._state=a.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class t{constructor(l,h){this.delay=l,this.callback=h,this.batch=[],this.startedTimer=Date.now()}addItem(l){return this.batch.push(l),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const l=this.currentDeferred;this.currentDeferred=void 0;const h=this.batch;return this.batch=[],this.callback(h).finally(()=>l.complete())}}function o(g,l){return`${g.value}/${l}`}e.createKernelId=o}),define(De[301],Ie([1,0,3,6,138]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(m,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=m.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(m,y,v){const R=this._extHostNotebook.getEditorById(m);this._rendererMessageEmitters.get(y)?.fire({editor:R.apiEditor,message:v})}createRendererMessaging(m,y){if(!m.contributes?.notebookRenderer?.some(R=>R.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(R,k,p)=>this.getOrCreateEmitterFor(y).event(R,k,p),postMessage:(R,k)=>{d.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,k]=[k,R]);const p=k&&d.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(p?.id,y,R)}}}getOrCreateEmitterFor(m){let y=this._rendererMessageEmitters.get(m);return y||(y=new _.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this._rendererMessageEmitters.delete(m)}}),this._rendererMessageEmitters.set(m,y),y)}}e.ExtHostNotebookRenderers=A}),define(De[302],Ie([1,0,4,14,2,27,6]),function(me,e,_,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class m{constructor(v){this.handlers=new Map,this.proxy=v.getProxy(T.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(v,R,k){if((0,A.checkProposedApiEnabled)(v,"profileContentHandlers"),this.handlers.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.handlers.set(R,k),this.proxy.$registerProfileContentHandler(R,k.name,k.description,v.identifier.value),(0,_.toDisposable)(()=>{this.handlers.delete(R),this.proxy.$unregisterProfileContentHandler(R)})}async $saveProfile(v,R,k,p){const C=this.handlers.get(v);if(!C)throw new Error(`Unknown handler with id: ${v}`);return C.saveProfile(R,k,p)}async $readProfile(v,R,k){const p=this.handlers.get(v);if(!p)throw new Error(`Unknown handler with id: ${v}`);return p.readProfile((0,L.isString)(R)?R:d.URI.revive(R),k)}}e.ExtHostProfileContentHandlers=m}),define(De[303],Ie([1,0,2,6,17,16]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class T{static{this.handlePool=0}constructor(y,v){this.uriTransformer=v,this.providers=new Map,this.proxy=y.getProxy(L.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,v,R){const k=_.URI.revive(v),p=this.providers.get(y);return p?(0,d.asPromise)(()=>p.provideOriginalResource(k,R)).then(C=>C||null):Promise.resolve(null)}registerQuickDiffProvider(y,v,R,k){const p=T.handlePool++;return this.providers.set(p,v),this.proxy.$registerQuickDiffProvider(p,A.DocumentSelector.from(y,this.uriTransformer),R,k),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(p),this.providers.delete(p)}}}}e.ExtHostQuickDiff=T}),define(De[304],Ie([1,0,21,3,4,6,2,7,8,19,40,55,27,16]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function D(b,r,s){const c=b.getProxy(A.MainContext.MainThreadQuickOpen);class f{constructor(l,h){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=h}showQuickPick(l,h,w,u=_.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(h),P=++this._instances,O=c.$show(P,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},u),N={},F=O.then(()=>N);return Promise.race([F,E]).then(x=>{if(x===N)return;const B=(0,p.isProposedApiEnabled)(l,"quickPickItemTooltip");return E.then(U=>{const X=[];for(let j=0;j<U.length;j++){const ge=U[j];if(typeof ge=="string")X.push({label:ge,handle:j});else if(ge.kind===m.QuickPickItemKind.Separator)X.push({type:"separator",label:ge.label});else{ge.tooltip&&!B&&console.warn(`Extension '${l.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`);const ie=ge.iconPath?n(ge.iconPath):void 0;X.push({label:ge.label,iconPath:ie?.iconPath,iconClass:ie?.iconClass,description:ge.description,detail:ge.detail,picked:ge.picked,alwaysShow:ge.alwaysShow,tooltip:B?C.MarkdownString.fromStrict(ge.tooltip):void 0,handle:j})}}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=j=>{w.onDidSelectItem(U[j])}),c.$setItems(P,X),O.then(j=>{if(typeof j=="number")return U[j];if(Array.isArray(j))return j.map(ge=>U[ge])})})}).then(void 0,x=>{if(!(0,y.isCancellationError)(x))return c.$setError(P,x),Promise.reject(x)})}$onItemSelected(l){this._onDidSelectItem?.(l)}showInput(l,h=_.CancellationToken.None){return this._validateInput=l?.validateInput,c.$input(l,typeof this._validateInput=="function",h).then(void 0,w=>{if(!(0,y.isCancellationError)(w))return Promise.reject(w)})}async $validateInput(l){if(!this._validateInput)return;const h=await this._validateInput(l);if(!h||typeof h=="string")return h;let w;switch(h.severity){case m.InputBoxValidationSeverity.Info:w=R.default.Info;break;case m.InputBoxValidationSeverity.Warning:w=R.default.Warning;break;case m.InputBoxValidationSeverity.Error:w=R.default.Error;break;default:w=h.message?R.default.Error:R.default.Ignore;break}return{content:h.message,severity:w}}async showWorkspaceFolderPick(l,h=_.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!w)return;const u=await this._workspace.getWorkspaceFolders2();if(u)return u.find(E=>E.uri.toString()===w.uri.toString())}createQuickPick(l){const h=new t(l,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(l){const h=new o(l,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}$onDidChangeValue(l,h){this._sessions.get(l)?._fireDidChangeValue(h)}$onDidAccept(l){this._sessions.get(l)?._fireDidAccept()}$onDidChangeActive(l,h){const w=this._sessions.get(l);w instanceof t&&w._fireDidChangeActive(h)}$onDidChangeSelection(l,h){const w=this._sessions.get(l);w instanceof t&&w._fireDidChangeSelection(h)}$onDidTriggerButton(l,h){this._sessions.get(l)?._fireDidTriggerButton(h)}$onDidTriggerItemButton(l,h,w){const u=this._sessions.get(l);u instanceof t&&u._fireDidTriggerItemButton(h,w)}$onDidHide(l){this._sessions.get(l)?._fireDidHide()}}class S{static{this._nextId=1}constructor(l,h){this._extensionId=l,this._onDidDispose=h,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new L.Emitter,this._onDidChangeValueEmitter=new L.Emitter,this._onDidTriggerButtonEmitter=new L.Emitter,this._onDidHideEmitter=new L.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((h,w)=>{const u=h===m.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(u,h)}),this.update({buttons:l.map((h,w)=>({...n(h.iconPath),tooltip:h.tooltip,handle:h===m.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const h=this._handlesToButtons.get(l);h&&this._onDidTriggerButtonEmitter.fire(h)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,d.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),c.$dispose(this._id))}update(l){if(!this._disposed){for(const h of Object.keys(l)){const w=l[h];this._pendingUpdate[h]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){c.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function I(g){if(g instanceof m.ThemeIcon)return{id:g.id};const l=a(g),h=i(g);return{dark:typeof l=="string"?T.URI.file(l):l,light:typeof h=="string"?T.URI.file(h):h}}function i(g){return typeof g=="object"&&"light"in g?g.light:g}function a(g){return typeof g=="object"&&"dark"in g?g.dark:g}function n(g){const l=I(g);let h,w;return"id"in l?w=k.ThemeIcon.asClassName(l):h=l,{iconPath:h,iconClass:w}}class t extends S{constructor(l,h){super(l.identifier,h),this.extension=l,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new L.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new L.Emitter,this._onDidTriggerItemButtonEmitter=new L.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((u,E)=>{this._handlesToItems.set(E,u),this._itemsToHandles.set(u,E)});const h=(0,p.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),w=[];for(let u=0;u<l.length;u++){const E=l[u];if(E.kind===m.QuickPickItemKind.Separator)w.push({type:"separator",label:E.label});else{E.tooltip&&!h&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const P=E.iconPath?n(E.iconPath):void 0;w.push({handle:u,label:E.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:h?C.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((O,N)=>({...n(O.iconPath),tooltip:O.tooltip,handle:N}))})}}this.update({items:w})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(h=>this._itemsToHandles.has(h)),this.update({activeItems:this._activeItems.map(h=>this._itemsToHandles.get(h))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(h=>this._itemsToHandles.has(h)),this.update({selectedItems:this._selectedItems.map(h=>this._itemsToHandles.get(h))})}_fireDidChangeActive(l){const h=(0,v.coalesce)(l.map(w=>this._handlesToItems.get(w)));this._activeItems=h,this._onDidChangeActiveEmitter.fire(h)}_fireDidChangeSelection(l){const h=(0,v.coalesce)(l.map(w=>this._handlesToItems.get(w)));this._selectedItems=h,this._onDidChangeSelectionEmitter.fire(h)}_fireDidTriggerItemButton(l,h){const w=this._handlesToItems.get(l);if(!w||!w.buttons||!w.buttons.length)return;const u=w.buttons[h];u&&this._onDidTriggerItemButtonEmitter.fire({button:u,item:w})}}class o extends S{constructor(l,h){super(l.identifier,h),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get valueSelection(){return this._valueSelection}set valueSelection(l){this._valueSelection=l,this.update({valueSelection:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,l?typeof l=="string"?this.update({validationMessage:l,severity:R.default.Error}):this.update({validationMessage:l.message,severity:l.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new f(r,s)}e.createExtHostQuickOpen=D}),define(De[305],Ie([1,0,2,3,66,4,17,6,19,118,18,25,55,16,27,15]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function r(l){if(l)return typeof l.iconPath=="string"?_.URI.file(l.iconPath):_.URI.isUri(l.iconPath)||p.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function s(l,h){if(!l.iconPath&&!h.iconPath)return 0;if(l.iconPath){if(!h.iconPath)return 1}else return-1;const w=typeof l.iconPath=="string"?l.iconPath:_.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,u=typeof h.iconPath=="string"?h.iconPath:_.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,v.comparePaths)(w,u)}function c(l,h){let w=0;if(l.strikeThrough!==h.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==h.faded)return l.faded?1:-1;if(l.tooltip!==h.tooltip)return(l.tooltip||"").localeCompare(h.tooltip||"");if(w=s(l,h),w!==0)return w;if(l.light&&h.light)w=s(l.light,h.light);else{if(l.light)return 1;if(h.light)return-1}if(w!==0)return w;if(l.dark&&h.dark)w=s(l.dark,h.dark);else{if(l.dark)return 1;if(h.dark)return-1}return w}function f(l,h){if(l.command!==h.command)return l.command<h.command?-1:1;if(l.title!==h.title)return l.title<h.title?-1:1;if(l.tooltip!==h.tooltip){if(l.tooltip!==void 0&&h.tooltip!==void 0)return l.tooltip<h.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(l.arguments===h.arguments)return 0;if(l.arguments)if(h.arguments){if(l.arguments.length!==h.arguments.length)return l.arguments.length-h.arguments.length}else return 1;else return-1;for(let w=0;w<l.arguments.length;w++){const u=l.arguments[w],E=h.arguments[w];if(u!==E)return u<E?-1:1}return 0}function S(l,h){let w=(0,v.comparePaths)(l.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(w!==0)return w;if(l.command&&h.command)w=f(l.command,h.command);else{if(l.command)return 1;if(h.command)return-1}if(w!==0)return w;if(l.decorations&&h.decorations)w=c(l.decorations,h.decorations);else{if(l.decorations)return 1;if(h.decorations)return-1}return w}function I(l,h){for(let w=0;w<l.length;w++)if(l[w]!==h[w])return!1;return!0}function i(l,h){return l.command===h.command&&l.title===h.title&&l.tooltip===h.tooltip&&(l.arguments&&h.arguments?I(l.arguments,h.arguments):l.arguments===h.arguments)}function a(l,h){return(0,y.equals)(l,h,i)}class n{#e;#t;get value(){return this._value}set value(h){h=h??"",this.#e.$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,D.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,D.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get enabled(){return this._enabled}set enabled(h){h=!!h,this._enabled!==h&&(this._enabled=h,this.#e.$setInputBoxEnablement(this._sourceControlHandle,h))}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,this.#e.$setInputBoxVisibility(this._sourceControlHandle,h))}get document(){return(0,D.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(h,w,u,E,P){this._extension=h,this._sourceControlHandle=E,this._documentUri=P,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=w,this.#e=u}showValidationMessage(h,w){(0,D.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,h,w)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=n;class t{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}constructor(h,w,u,E,P){this._proxy=h,this._commands=w,this._sourceControlHandle=u,this._id=E,this._label=P,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,w){const u=this._resourceStatesCommandsMap.get(h);return u?(0,T.asPromise)(()=>this._commands.executeCommand(u.command,...u.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(S),u=(0,y.sortedDiff)(this._resourceSnapshot,h,S).map(O=>{const N=O.toInsert.map(F=>{const x=this._resourceHandlePool++;this._resourceStatesMap.set(x,F);const B=F.resourceUri;let U;if(F.command)if(F.command.command==="vscode.open"||F.command.command==="vscode.diff"){const fe=new A.DisposableStore;U=this._commands.converter.toInternal(F.command,fe),this._resourceStatesDisposablesMap.set(x,fe)}else this._resourceStatesCommandsMap.set(x,F.command);const X=r(F.decorations),j=F.decorations&&r(F.decorations.light)||X,ge=F.decorations&&r(F.decorations.dark)||X,ie=[j,ge],te=F.decorations&&F.decorations.tooltip||"",$=F.decorations&&!!F.decorations.strikeThrough,H=F.decorations&&!!F.decorations.faded,ce=F.contextValue||"";return{rawResource:[x,B,ie,te,$,H,ce,U],handle:x}});return{start:O.start,deleteCount:O.deleteCount,toInsert:N}}),E=u.map(({start:O,deleteCount:N,toInsert:F})=>[O,N,F.map(x=>x.rawResource)]),P=u.reverse();for(const{start:O,deleteCount:N,toInsert:F}of P){const x=F.map(U=>U.handle),B=this._handlesSnapshot.splice(O,N,...x);for(const U of B)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=h,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class o{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,this.#e.$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h;let w;(0,D.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(w=h?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h,quickDiffLabel:w})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,this.#e.$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=h;const w=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:w})}get actionButton(){return(0,D.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,D.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=h;const w=h!==void 0?{command:this._commands.converter.toInternal(h.command,this._actionButtonDisposables.value),secondaryCommands:h.secondaryCommands?.map(u=>u.map(E=>this._commands.converter.toInternal(E,this._actionButtonDisposables.value))),description:h.description,enabled:h.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:w??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&a(this._statusBarCommands,h))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=h;const w=(h||[]).map(u=>this._commands.converter.toInternal(u,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}constructor(h,w,u,E,P,O,N){this._extension=h,this._commands=E,this._id=P,this._label=O,this._rootUri=N,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=o._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=u;const F=_.URI.from({scheme:b.Schemas.vscodeSourceControl,path:`${P}/scm${this.handle}/input`,query:N?`rootUri=${encodeURIComponent(N.toString())}`:void 0});this._inputBox=new n(h,w,this.#e,this.handle,F),this.#e.$registerSourceControl(this.handle,P,O,N,F)}createResourceGroup(h,w){const u=new t(this.#e,this._commands,this.handle,h,w),E=L.Event.once(u.onDidDispose)(()=>this.createdResourceGroups.delete(u));return this.createdResourceGroups.set(u,E),this.eventuallyAddResourceGroups(),u}eventuallyAddResourceGroups(){const h=[],w=[];for(const[u,E]of this.createdResourceGroups){E.dispose();const P=u.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(u),this.eventuallyUpdateResourceStates()});L.Event.once(u.onDidDispose)(()=>{this.updatedResourceGroups.delete(u),P.dispose(),this._groups.delete(u.handle),this.#e.$unregisterGroup(this.handle,u.handle)}),h.push([u.handle,u.id,u.label,u.features]);const O=u._takeResourceStateSnapshot();O.length>0&&w.push([u.handle,O]),this._groups.set(u.handle,u)}this.#e.$registerGroups(this.handle,h,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(w=>{const u=w._takeResourceStateSnapshot();u.length!==0&&h.push([w.handle,u])}),h.length>0&&this.#e.$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Ve([(0,d.debounce)(100)],o.prototype,"eventuallyAddResourceGroups",null),Ve([(0,d.debounce)(100)],o.prototype,"eventuallyUpdateResourceStates",null);let g=class yn{static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(h,w,u,E){this._commands=w,this._extHostDocuments=u,this.logService=E,this._sourceControls=new Map,this._sourceControlsByExtension=new k.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=h.getProxy(m.MainContext.MainThreadSCM),this._telemetry=h.getProxy(m.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const O=this._sourceControls.get(P.sourceControlHandle);if(!O)return P;const N=O.getResourceGroup(P.groupHandle);return N?N.getResourceState(P.handle):P}else if(P&&P.$mid===4){const O=this._sourceControls.get(P.sourceControlHandle);return O?O.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const O=this._sourceControls.get(P.handle);return O||P}return P}})}createSourceControl(h,w,u,E){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,w,u,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const P=yn._handlePool++,O=new o(h,this._extHostDocuments,this._proxy,this._commands,w,u,E);this._sourceControls.set(P,O);const N=this._sourceControlsByExtension.get(h.identifier)||[];return N.push(O),this._sourceControlsByExtension.set(h.identifier,N),O}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const w=this._sourceControlsByExtension.get(h.identifier),u=w&&w[w.length-1];return u&&u.inputBox}$provideOriginalResource(h,w,u){const E=_.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,E.toString());const P=this._sourceControls.get(h);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>P.quickDiffProvider.provideOriginalResource(E,u)).then(O=>O||null)}$onInputBoxValueChange(h,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const u=this._sourceControls.get(h);return u&&u.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(h,w,u,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,w,u);const P=this._sourceControls.get(h);if(!P)return Promise.resolve(void 0);const O=P.getResourceGroup(w);return O?O.$executeResourceCommand(u,E):Promise.resolve(void 0)}$validateInput(h,w,u){this.logService.trace("ExtHostSCM#$validateInput",h);const E=this._sourceControls.get(h);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>E.inputBox.validateInput(w,u)).then(P=>{if(!P)return Promise.resolve(void 0);const O=C.MarkdownString.fromStrict(P.message);return O?Promise.resolve([O,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};e.ExtHostSCM=g,e.ExtHostSCM=g=Ve([$e(3,R.ILogService)],g)}),define(De[108],Ie([1,0,6,3,5]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(m){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=m.getProxy(_.MainContext.MainThreadSecretState)}async $onDidChangePassword(m){this._onDidChangePassword.fire(m)}get(m,y){return this._proxy.$getPassword(m,y)}store(m,y,v){return this._proxy.$setPassword(m,y,v)}delete(m,y){return this._proxy.$deletePassword(m,y)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,d.createDecorator)("IExtHostSecretState")}),define(De[306],Ie([1,0,6,7]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSemanticSimilarity=void 0;class d{constructor(T){this._semanticSimilarityProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(_.MainContext.MainThreadSemanticSimilarity)}async $provideSimilarityScore(T,m,y,v){if(this._semanticSimilarityProviders.size===0)throw new Error("No semantic similarity providers registered");const R=this._semanticSimilarityProviders.get(T);if(!R)throw new Error("Semantic similarity provider not found");return await R.provideSimilarityScore(m,y,v)}registerSemanticSimilarityProvider(T,m){const y=this._nextHandle;return this._nextHandle++,this._semanticSimilarityProviders.set(y,m),this._proxy.$registerSemanticSimilarityProvider(y),new L.Disposable(()=>{this._proxy.$unregisterSemanticSimilarityProvider(y),this._semanticSimilarityProviders.delete(y)})}}e.ExtHostSemanticSimilarity=d}),define(De[307],Ie([1,0,6,16,2]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class A{static{this.handlePool=0}constructor(m,y){this.uriTransformer=y,this.providers=new Map,this.proxy=m.getProxy(_.MainContext.MainThreadShare)}async $provideShare(m,y,v){return await this.providers.get(m)?.provideShare({selection:L.Range.to(y.selection),resourceUri:d.URI.revive(y.resourceUri)},v)??void 0}registerShareProvider(m,y){const v=A.handlePool++;return this.providers.set(v,y),this.proxy.$registerShareProvider(v,L.DocumentSelector.from(m,this.uriTransformer),y.id,y.label,y.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(v),this.providers.delete(v)}}}}e.ExtHostShare=A}),define(De[308],Ie([1,0,7,6,199,4,16,14]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new _.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new _.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(p,C,D,b,r,s=_.StatusBarAlignment.Left,c){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new A.DisposableStore,this.#e=p,this.#t=C,r&&b){this._entryId=(0,_.asStatusBarItemIdentifier)(b.identifier,r);const f=D.get(this._entryId);f&&(s=f.alignLeft?_.StatusBarAlignment.Left:_.StatusBarAlignment.Right,c=f.priority,this._visible=!0,this.name=f.name,this.text=f.text,this.tooltip=f.tooltip,this.command=f.command,this.accessibilityInformation=f.accessibilityInformation)}else this._entryId=String(y.ID_GEN++);this._extension=b,this._id=r,this._alignment=s,this._priority=this.validatePriority(c)}validatePriority(p){if((0,m.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set name(p){this._name=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!y.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){this._command?.fromApi!==p&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new A.DisposableStore,typeof p=="string"?this._command={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this._latestCommandRegistration)}:p?this._command={fromApi:p,internal:this.#t.toInternal(p,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let C;this._name?C=this._name:C=(0,d.localize)(0,null,this._extension.displayName||this._extension.name);let D=this._color;this._backgroundColor&&(D=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const b=T.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,p,this._extension?.identifier.value,C,this._text,b,this._command?.internal,D,this._backgroundColor,this._alignment===_.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y;class v{constructor(p){this._messages=[],this._item=p.createStatusBarEntry(void 0,"status.extensionMessage",_.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,d.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const C={message:p};return this._messages.unshift(C),this._update(),new _.Disposable(()=>{const D=this._messages.indexOf(C);D>=0&&(this._messages.splice(D,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class R{constructor(p,C){this._existingItems=new Map,this._proxy=p.getProxy(L.MainContext.MainThreadStatusBar),this._commands=C,this._statusMessage=new v(this)}$acceptStaticEntries(p){for(const C of p)this._existingItems.set(C.entryId,C)}createStatusBarEntry(p,C,D,b){return new y(this._proxy,this._commands,this._existingItems,p,C,D,b)}setStatusBarMessage(p,C){const D=this._statusMessage.setMessage(p);let b;return typeof C=="number"?b=setTimeout(()=>D.dispose(),C):typeof C<"u"&&C.then(()=>D.dispose(),()=>D.dispose()),new _.Disposable(()=>{D.dispose(),clearTimeout(b)})}}e.ExtHostStatusBar=R}),define(De[109],Ie([1,0,6,3,5]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(m,y){this._logService=y,this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=m.getProxy(_.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(m,y){this._proxy.$registerExtensionStorageKeysToSync(m,y)}async initializeExtensionStorage(m,y,v){const R=await this._proxy.$initializeExtensionStorage(m,y);let k;return R&&(k=this.safeParseValue(m,y,R)),k||v}setValue(m,y,v){return this._proxy.$setValue(m,y,v)}$acceptValue(m,y,v){const R=this.safeParseValue(m,y,v);R&&this._onDidChangeStorage.fire({shared:m,key:y,value:R})}safeParseValue(m,y,v){try{return JSON.parse(v)}catch(R){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${m}): ${R}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,d.createDecorator)("IExtHostStorage")}),define(De[85],Ie([1,0,5,26,18,63,2]),function(me,e,_,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,_.createDecorator)("IExtensionStoragePaths");let m=class{constructor(v,R,k){this._logService=R,this._extHostFileSystem=k,this._workspace=v.workspace??void 0,this._environment=v.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(p=>this._value=p)}async _getWorkspaceStorageURI(v){return T.URI.joinPath(this._environment.workspaceStorageHome,v)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const v=this._workspace.id,R=await this._getWorkspaceStorageURI(v);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(v){if(this._value)return T.URI.joinPath(this._value,v.identifier.value)}globalValue(v){return T.URI.joinPath(this._environment.globalStorageHome,v.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=m,e.ExtensionStoragePaths=m=Ve([$e(0,L.IExtHostInitDataService),$e(1,d.ILogService),$e(2,A.IExtHostConsumerFileSystem)],m)}),define(De[43],Ie([1,0,3,6,5,2,20,4,7,201,8,241,21,32,242,55,14,17,16,27]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,d.createDecorator)("IExtHostTerminalService");class S{constructor(u,E,P,O){this._proxy=u,this._id=E,this._creationOptions=P,this._name=O,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(F=>this._pidPromiseComplete=F);const N=this;this.value={get name(){return N._name||""},get processId(){return N._pidPromise},get creationOptions(){return N._creationOptions},get exitStatus(){return N._exitStatus},get state(){return N._state},get selection(){return N._selection},sendText(F,x=!0){N._checkDisposed(),N._proxy.$sendText(N._id,F,x)},show(F){N._checkDisposed(),N._proxy.$show(N._id,F)},hide(){N._checkDisposed(),N._proxy.$hide(N._id)},dispose(){N._disposed||(N._disposed=!0,N._proxy.$dispose(N._id))},get dimensions(){if(!(N._cols===void 0||N._rows===void 0))return{columns:N._cols,rows:N._rows}}}}async create(u,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:u.name,shellPath:(0,r.withNullAsUndefined)(u.shellPath),shellArgs:(0,r.withNullAsUndefined)(u.shellArgs),cwd:(0,r.withNullAsUndefined)(u.cwd),env:(0,r.withNullAsUndefined)(u.env),icon:(0,r.withNullAsUndefined)(g(u.iconPath)),color:b.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,r.withNullAsUndefined)(u.message),strictEnv:(0,r.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,r.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,r.withNullAsUndefined)(E?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,r.withNullAsUndefined)(E?.useShellEnvironment),location:E?.location||this._serializeParentTerminal(u.location,E?.resolvedExtHostIdentifier),isTransient:(0,r.withNullAsUndefined)(u.isTransient)})}async createExtensionTerminal(u,E,P,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:P,color:b.ThemeColor.isThemeColor(O)?O.id:void 0,location:this._serializeParentTerminal(u,E),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(u,E){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in u?{viewColumn:c.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(u){this._name=u}setExitStatus(u,E){this._exitStatus=Object.freeze({code:u,reason:E})}setDimensions(u,E){return u===this._cols&&E===this._rows||u===0||E===0?!1:(this._cols=u,this._rows=E,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(u){this._selection=u}_setProcessId(u){this._pidPromiseComplete?(this._pidPromiseComplete(u),this._pidPromiseComplete=void 0):this._pidPromise.then(E=>{E!==u&&(this._pidPromise=Promise.resolve(u))})}}e.ExtHostTerminal=S;class I{get onProcessReady(){return this._onProcessReady.event}constructor(u){this._pty=u,this.id=0,this.shouldPersist=!1,this._onProcessData=new _.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new _.Emitter,this._onDidChangeProperty=new _.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new _.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${E}`)}async start(){}shutdown(){this._pty.close()}input(u){this._pty.handleInput?.(u)}resize(u,E){this._pty.setDimensions?.({columns:u,rows:E})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this._pty.onDidWrite(E=>this._onProcessData.fire(E)),this._pty.onDidClose?.((E=void 0)=>{this._onProcessExit.fire(E===void 0?void 0:E)}),this._pty.onDidOverrideDimensions?.(E=>{E&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this._pty.onDidChangeName?.(E=>{this._onDidChangeProperty.fire({type:"title",value:E})}),this._pty.open(u||void 0),u&&this._pty.setDimensions?.(u),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let i=1,a=class extends m.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(u=>u.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(u,E){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new _.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new _.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new _.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new _.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new _.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new _.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=E.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new D.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new _.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(u),this._register({dispose:()=>{for(const[P,O]of this._terminalProcesses)O.shutdown(!0)}})}getDefaultShell(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(u,E){const P=new S(this._proxy,(0,C.generateUuid)(),u,u.name),O=new I(u.pty);return P.createExtensionTerminal(u.location,this._serializeParentTerminal(u,E).resolvedExtHostIdentifier,g(u.iconPath),l(u.color)).then(N=>{const F=this._setupExtHostProcessListeners(N,O);this._terminalProcessDisposables[N]=F}),this._terminals.push(P),P.value}_serializeParentTerminal(u,E){if(E=E||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const P=u.location.parentTerminal;if(P){const O=this._terminals.find(N=>N.value===P);O&&(E.resolvedExtHostIdentifier=O._id)}}else u.location&&typeof u.location!="object"?E.location=u.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(u,E){if(!this._getTerminalById(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const O=new I(E),N=this._setupExtHostProcessListeners(u,O);this._terminalProcessDisposables[u]=N}async $acceptActiveTerminalChanged(u){const E=this._activeTerminal;if(u===null){this._activeTerminal=void 0,E!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const P=this._getTerminalById(u);P&&(this._activeTerminal=P,E!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(u,E){const P=this._getTerminalById(u);P&&this._onDidWriteTerminalData.fire({terminal:P.value,data:E})}async $acceptTerminalDimensions(u,E,P){const O=this._getTerminalById(u);O&&O.setDimensions(E,P)&&this._onDidChangeTerminalDimensions.fire({terminal:O.value,dimensions:O.value.dimensions})}async $acceptTerminalMaximumDimensions(u,E,P){this._terminalProcesses.get(u)?.resize(E,P)}async $acceptTerminalTitleChange(u,E){const P=this._getTerminalById(u);P&&(P.name=E)}async $acceptTerminalClosed(u,E,P){const O=this._getTerminalObjectIndexById(this._terminals,u);if(O!==null){const N=this._terminals.splice(O,1)[0];N.setExitStatus(E,P),this._onDidCloseTerminal.fire(N.value)}}$acceptTerminalOpened(u,E,P,O){if(E){const x=this._getTerminalObjectIndexById(this._terminals,E);if(x!==null){this._terminals[x]._id=u,this._onDidOpenTerminal.fire(this.terminals[x]),this._terminals[x].isOpen=!0;return}}const N={name:O.name,shellPath:O.executable,shellArgs:O.args,cwd:typeof O.cwd=="string"?O.cwd:A.URI.revive(O.cwd),env:O.env,hideFromUser:O.hideFromUser},F=new S(this._proxy,u,N,P);this._terminals.push(F),this._onDidOpenTerminal.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(u,E){this._getTerminalById(u)?._setProcessId(E)}async $startExtensionTerminal(u,E){const P=this._getTerminalById(u);if(!P)return{message:(0,v.localize)(0,null,u)};P.isOpen||await new Promise(N=>{const F=this.onDidOpenTerminal(async x=>{x===P.value&&(F.dispose(),N())})});const O=this._terminalProcesses.get(u);O?O.startSendingEvents(E):this._extensionTerminalAwaitingStart[u]={initialDimensions:E}}_setupExtHostProcessListeners(u,E){const P=new m.DisposableStore;P.add(E.onProcessReady(N=>this._proxy.$sendProcessReady(u,N.pid,N.cwd,N.windowsPty))),P.add(E.onDidChangeProperty(N=>this._proxy.$sendProcessProperty(u,N))),this._bufferer.startBuffering(u,E.onProcessData),P.add(E.onProcessExit(N=>this._onProcessExit(u,N))),this._terminalProcesses.set(u,E);const O=this._extensionTerminalAwaitingStart[u];return O&&E instanceof I&&(E.startSendingEvents(O.initialDimensions),delete this._extensionTerminalAwaitingStart[u]),P}$acceptProcessAckDataEvent(u,E){this._terminalProcesses.get(u)?.acknowledgeDataEvent(E)}$acceptProcessInput(u,E){this._terminalProcesses.get(u)?.input(E)}$acceptTerminalInteraction(u){const E=this._getTerminalById(u);E?.setInteractedWith()&&this._onDidChangeTerminalState.fire(E.value)}$acceptTerminalSelection(u,E){this._getTerminalById(u)?.setSelection(E)}$acceptProcessResize(u,E,P){try{this._terminalProcesses.get(u)?.resize(E,P)}catch(O){if(O.code!=="EPIPE"&&O.code!=="ERR_IPC_CHANNEL_CLOSED")throw O}}$acceptProcessShutdown(u,E){this._terminalProcesses.get(u)?.shutdown(E)}$acceptProcessRequestInitialCwd(u){this._terminalProcesses.get(u)?.getInitialCwd().then(E=>this._proxy.$sendProcessProperty(u,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(u){this._terminalProcesses.get(u)?.getCwd().then(E=>this._proxy.$sendProcessProperty(u,{type:"cwd",value:E}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this._linkProviders.add(u),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(u),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(u,E,P){if(this._profileProviders.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this._profileProviders.set(E,P),this._proxy.$registerProfileProvider(E,u.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(E),this._proxy.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(u,E,P){if(this._quickFixProviders.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this._quickFixProviders.set(u,P),this._proxy.$registerQuickFixProvider(u,E),new y.Disposable(()=>{this._quickFixProviders.delete(u),this._proxy.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,E){const P=new p.CancellationTokenSource().token;if(P.isCancellationRequested)return;const O=this._quickFixProviders.get(u);if(!O)return;const N=await O.provideTerminalQuickFixes(E,P);if(N!==null)return N}async $createContributedProfileTerminal(u,E){const P=new p.CancellationTokenSource().token;let O=await this._profileProviders.get(u)?.provideTerminalProfile(P);if(!P.isCancellationRequested){if(O&&!("options"in O)&&(O={options:O}),!O||!("options"in O))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in O.options){this.createExtensionTerminal(O.options,E);return}this.createTerminalFromOptions(O.options,E)}}async $provideLinks(u,E){const P=this._getTerminalById(u);if(!P)return[];this._terminalLinkCache.delete(u),this._terminalLinkCancellationSource.get(u)?.dispose(!0);const N=new p.CancellationTokenSource;this._terminalLinkCancellationSource.set(u,N);const F=[],x={terminal:P.value,line:E},B=[];for(const j of this._linkProviders)B.push(s.Promises.withAsyncBody(async ge=>{N.token.onCancellationRequested(()=>ge({provider:j,links:[]}));const ie=await j.provideTerminalLinks(x,N.token)||[];N.token.isCancellationRequested||ge({provider:j,links:ie})}));const U=await Promise.all(B);if(N.token.isCancellationRequested)return[];const X=new Map;for(const j of U)j&&j.links.length>0&&F.push(...j.links.map(ge=>{const ie={id:i++,startIndex:ge.startIndex,length:ge.length,label:ge.tooltip};return X.set(ie.id,{provider:j.provider,link:ge}),ie}));return this._terminalLinkCache.set(u,X),F}$activateLink(u,E){const P=this._terminalLinkCache.get(u)?.get(E);P&&P.provider.handleTerminalLink(P.link)}_onProcessExit(u,E){this._bufferer.stopBuffering(u),this._terminalProcesses.delete(u),delete this._extensionTerminalAwaitingStart[u];const P=this._terminalProcessDisposables[u];P&&(P.dispose(),delete this._terminalProcessDisposables[u]),this._proxy.$sendProcessExit(u,E)}_getTerminalById(u){return this._getTerminalObjectById(this._terminals,u)}_getTerminalObjectById(u,E){const P=this._getTerminalObjectIndexById(u,E);return P!==null?u[P]:null}_getTerminalObjectIndexById(u,E){const P=u.findIndex(O=>O._id===E);return P===-1?null:P}getEnvironmentVariableCollection(u){let E=this._environmentVariableCollections.get(u.identifier.value);return E||(E=new n(u),this._setEnvironmentVariableCollection(u.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(u,E){const P=(0,k.serializeEnvironmentVariableCollection)(E.map),O=(0,k.serializeEnvironmentDescriptionMap)(E.descriptionMap);this._proxy.$setEnvironmentVariableCollection(u,E.persistent,P.length===0?void 0:P,O)}$initEnvironmentVariableCollections(u){u.forEach(E=>{const P=E[0],O=new n(void 0,E[1]);this._setEnvironmentVariableCollection(P,O)})}$acceptDefaultProfile(u,E){const P=this._defaultProfile;this._defaultProfile=u,this._defaultAutomationProfile=E,P?.path!==u.path&&this._onDidChangeShell.fire(u.path)}_setEnvironmentVariableCollection(u,E){this._environmentVariableCollections.set(u,E),E.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(u,E)})}};e.BaseExtHostTerminalService=a,e.BaseExtHostTerminalService=a=Ve([$e(1,T.IExtHostRpcService)],a);class n{get persistent(){return this._persistent}set persistent(u){this._persistent=u,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(u,E){this._extension=u,this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new _.Emitter,this.map=new Map(E)}getScopedEnvironmentVariableCollection(u){this._extension&&u&&(0,f.checkProposedApiEnabled)(this._extension,"envCollectionWorkspace");const E=this.getScopeKey(u);let P=this.scopedCollections.get(E);return P||(P=new t(this,u),this.scopedCollections.set(E,P),P.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),P}replace(u,E,P,O){this._extension&&P&&(0,f.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(u,{value:E,type:y.EnvironmentVariableMutatorType.Replace,options:P??{},scope:O})}append(u,E,P,O){this._extension&&P&&(0,f.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(u,{value:E,type:y.EnvironmentVariableMutatorType.Append,options:P??{},scope:O})}prepend(u,E,P,O){this._extension&&P&&(0,f.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(u,{value:E,type:y.EnvironmentVariableMutatorType.Prepend,options:P??{},scope:O})}_setIfDiffers(u,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const P=this.getKey(u,E.scope),O=this.map.get(P);if(!O||O.value!==E.value||O.type!==E.type||O.options?.applyAtProcessCreation!==(E.options.applyAtProcessCreation??!0)||O.options?.applyAtShellIntegration!==(E.options.applyAtShellIntegration??!1)||O.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const N=this.getKey(u,E.scope),F={variable:u,...E,options:{applyAtProcessCreation:E.options.applyAtProcessCreation??!0,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}};this.map.set(N,F),this._onDidChangeCollection.fire()}}get(u,E){const P=this.getKey(u,E),O=this.map.get(P);return O?h(O):void 0}getKey(u,E){const P=this.getScopeKey(E);return P.length?`${u}:::${P}`:u}getScopeKey(u){return this.getWorkspaceKey(u?.workspaceFolder)??""}getWorkspaceKey(u){return u?u.uri.toString():void 0}getVariableMap(u){const E=new Map;for(const[P,O]of this.map)this.getScopeKey(O.scope)===this.getScopeKey(u)&&E.set(O.variable,h(O));return E}delete(u,E){const P=this.getKey(u,E);this.map.delete(P),this._onDidChangeCollection.fire()}clear(u){if(u?.workspaceFolder){for(const[E,P]of this.map)P.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(E);this.clearDescription(u)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(u,E){const P=this.getScopeKey(E),O=this.descriptionMap.get(P);if(!O||O.description!==u){let N;typeof u=="string"?N=u:N=u?.value.split(`

`)[0];const F={description:N,scope:E};this.descriptionMap.set(P,F),this._onDidChangeCollection.fire()}}getDescription(u){const E=this.getScopeKey(u);return this.descriptionMap.get(E)?.description}clearDescription(u){const E=this.getScopeKey(u);this.descriptionMap.delete(E)}}class t{get persistent(){return this.collection.persistent}set persistent(u){this.collection.persistent=u}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(u,E){this.collection=u,this.scope=E,this._onDidChangeCollection=new _.Emitter}getScopedEnvironmentVariableCollection(u){return this.collection.getScopedEnvironmentVariableCollection(u)}replace(u,E,P){this.collection.replace(u,E,P,this.scope)}append(u,E,P){this.collection.append(u,E,P,this.scope)}prepend(u,E,P){this.collection.prepend(u,E,P,this.scope)}get(u){return this.collection.get(u,this.scope)}forEach(u,E){this.collection.getVariableMap(this.scope).forEach((P,O)=>u.call(E,O,P,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(u){this.collection.delete(u,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(u){this.collection.setDescription(u,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let o=class extends a{constructor(u){super(!1,u)}createTerminal(u,E,P){throw new R.NotSupportedError}createTerminalFromOptions(u,E){throw new R.NotSupportedError}};e.WorkerExtHostTerminalService=o,e.WorkerExtHostTerminalService=o=Ve([$e(0,T.IExtHostRpcService)],o);function g(w){if(!(!w||typeof w=="string"))return"id"in w?{id:w.id,color:w.color}:w}function l(w){return b.ThemeColor.isThemeColor(w)?w:void 0}function h(w){const u={...w};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(De[309],Ie([1,0,19,17,22,21,3,67,70,4,23,14,32,6,20,139,16,7,59,103,82]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let I=class{constructor(N,F,x){this.editors=x,this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=N.getProxy(C.MainContext.MainThreadTesting),this.observer=new u(this.proxy),this.runTracker=new t(this.proxy),F.registerArgumentProcessor({processArgument:B=>{if(B?.$mid!==15)return B;const U=B,X=U.tests[U.tests.length-1].item.extId;return this.controllers.get(c.TestId.root(X))?.collection.tree.get(X)?.actual??(0,b.toItemFromContext)(B)}}),F.registerCommand(!1,"testing.getExplorerSelection",async()=>{const B=await F.executeCommand("_testing.getExplorerSelection"),U=X=>{const j=this.controllers.get(c.TestId.root(X));if(j)return c.TestId.isRoot(X)?j.controller:j.collection.tree.get(X)?.actual};return{include:B?.include.map(U).filter(k.isDefined)||[],exclude:B?.exclude.map(U).filter(k.isDefined)||[]}})}createTestController(N,F,x,B){if(this.controllers.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const U=new v.DisposableStore,X=U.add(new b.ExtHostTestItemCollection(F,x,this.editors));X.root.label=x;const j=new Map,ge=this.proxy,ie={items:X.root.children,get label(){return x},set label($){x=$,X.root.label=$,ge.$updateController(F,{label:x})},get refreshHandler(){return B},set refreshHandler($){B=$,ge.$updateController(F,{canRefresh:!!$})},get id(){return F},createRunProfile:($,H,ce,re,fe,he)=>{let z=(0,y.hash)($);for(;j.has(z);)z++;return new E(this.proxy,j,F,z,$,H,ce,re,fe,he)},createTestItem($,H,ce){return new b.TestItemImpl(F,$,H,ce)},createTestRun:($,H,ce=!0)=>this.runTracker.createTestRun(F,X,$,H,ce),invalidateTestResults:$=>{if($===void 0)this.proxy.$markTestRetired(void 0);else{const H=$ instanceof Array?$:[$];this.proxy.$markTestRetired(H.map(ce=>c.TestId.fromExtHostTestItem(ce,F).toString()))}},set resolveHandler($){X.resolveHandler=$},get resolveHandler(){return X.resolveHandler},dispose:()=>{U.dispose()}};ge.$registerTestController(F,x,!!B),U.add((0,v.toDisposable)(()=>ge.$unregisterTestController(F)));const te={controller:ie,collection:X,profiles:j};return this.controllers.set(F,te),U.add((0,v.toDisposable)(()=>this.controllers.delete(F))),U.add(X.onDidGenerateDiff($=>ge.$publishDiff(F,$.map(S.TestsDiffOp.serialize)))),ie}createTestObserver(){return this.observer.checkout()}async runTests(N,F=A.CancellationToken.None){const x=o(N);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.controllers.get(x.controllerId);if(!B)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(U=>c.TestId.fromExtHostTestItem(U,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:P[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:N.exclude?.map(U=>U.id)},F)}$syncTests(){for(const{collection:N}of this.controllers.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,F,x){return(0,_.mapFind)(this.runTracker.trackers,U=>U.id===N?U.getCoverage(F):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(N,F,x,B){return(0,_.mapFind)(this.runTracker.trackers,X=>X.id===N?X.getCoverage(F):void 0)?.resolveFileCoverage(x,B)??Promise.resolve([])}$configureRunProfile(N,F){this.controllers.get(N)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(N,F){await this.controllers.get(N)?.controller.refreshHandler?.(F)}$publishTestResults(N){this.results=Object.freeze(N.map(F=>(0,R.deepFreeze)(r.TestResults.to(F))).concat(this.results).sort((F,x)=>x.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(N,F){const x=this.controllers.get(c.TestId.fromString(N).controllerId)?.collection;x&&(await x.expand(N,F<0?1/0:F),x.flushDiff())}$acceptDiff(N){this.observer.applyDiff(N.map(S.TestsDiffOp.deserialize))}async $runControllerTests(N,F){return Promise.all(N.map(x=>this.runControllerTestRequest(x,!1,F)))}async $startContinuousRun(N,F){const x=new A.CancellationTokenSource(F),B=await Promise.all(N.map(U=>this.runControllerTestRequest(U,!0,x.token)));return!F.isCancellationRequested&&!B.some(U=>U.error)&&await new Promise(U=>F.onCancellationRequested(U)),x.dispose(!0),B}async runControllerTestRequest(N,F,x){const B=this.controllers.get(N.controllerId);if(!B)return{};const{collection:U,profiles:X}=B,j=X.get(N.profileId);if(!j)return{};const ge=N.testIds.map(H=>U.tree.get(H)).filter(k.isDefined),ie=N.excludeExtIds.map(H=>B.collection.tree.get(H)).filter(k.isDefined).filter(H=>ge.some(ce=>ce.fullId.compare(H.fullId)===2));if(!ge.length)return{};const te=new s.TestRunRequest(ge.some(H=>H.actual instanceof b.TestItemRootImpl)?void 0:ge.map(H=>H.actual),ie.map(H=>H.actual),j,F),$=(0,S.isStartControllerTests)(N)&&this.runTracker.prepareForMainThreadTestRun(te,g.fromInternal(N,B.collection),x);try{return await j.runHandler(te,x),{}}catch(H){return{error:String(H)}}finally{$&&($.hasRunningTasks&&!x.isCancellationRequested&&await T.Event.toPromise($.onEnd),$.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(N)}};e.ExtHostTesting=I,e.ExtHostTesting=I=Ve([$e(0,D.IExtHostRpcService)],I);const i=1e4;var a;(function(O){O[O.Running=0]="Running",O[O.Cancelling=1]="Cancelling",O[O.Ended=2]="Ended"})(a||(a={}));class n extends v.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(N,F,x){super(),this.dto=N,this.proxy=F,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new A.CancellationTokenSource(x));const B=this._register(new L.RunOnceScheduler(()=>this.forciblyEndTasks(),i));this._register(this.cts.token.onCancellationRequested(()=>B.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(N){return this.tasks.get(N)?.coverage}createRun(N){const F=this.dto.id,x=this.dto.controllerId,B=(0,p.generateUuid)(),U=new l(this.proxy,F,B),X=te=>($,...H)=>{if(ge){console.warn(`Setting the state of test "${$.id}" is a no-op after the run ends.`);return}this.dto.isIncluded($)&&(this.ensureTestIsKnown($),te($,...H))},j=(te,$)=>{const H=$ instanceof Array?$.map(r.TestMessage.from):[r.TestMessage.from($)];if(te.uri&&te.range){const ce={range:r.Range.from(te.range),uri:te.uri};for(const re of H)re.location=re.location||ce}this.proxy.$appendTestMessagesInRun(F,B,c.TestId.fromExtHostTestItem(te,x).toString(),H)};let ge=!1;const ie={isPersisted:this.dto.isPersisted,token:this.cts.token,name:N,get coverageProvider(){return U.coverageProvider},set coverageProvider(te){U.coverageProvider=te},enqueued:X(te=>{this.proxy.$updateTestStateInRun(F,B,c.TestId.fromExtHostTestItem(te,x).toString(),1)}),skipped:X(te=>{this.proxy.$updateTestStateInRun(F,B,c.TestId.fromExtHostTestItem(te,x).toString(),5)}),started:X(te=>{this.proxy.$updateTestStateInRun(F,B,c.TestId.fromExtHostTestItem(te,x).toString(),2)}),errored:X((te,$,H)=>{j(te,$),this.proxy.$updateTestStateInRun(F,B,c.TestId.fromExtHostTestItem(te,x).toString(),6,H)}),failed:X((te,$,H)=>{j(te,$),this.proxy.$updateTestStateInRun(F,B,c.TestId.fromExtHostTestItem(te,x).toString(),4,H)}),passed:X((te,$)=>{this.proxy.$updateTestStateInRun(F,B,c.TestId.fromExtHostTestItem(te,this.dto.controllerId).toString(),3,$)}),appendOutput:(te,$,H)=>{ge||(H&&(this.dto.isIncluded(H)?this.ensureTestIsKnown(H):H=void 0),this.proxy.$appendOutputToRun(F,B,d.VSBuffer.fromString(te),$&&r.location.from($),H&&c.TestId.fromExtHostTestItem(H,x).toString()))},end:()=>{ge||(ge=!0,this.proxy.$finishedTestRunTask(F,B),this.tasks.delete(B),this.tasks.size||this.markEnded())}};return this.tasks.set(B,{run:ie,coverage:U}),this.proxy.$startedTestRunTask(F,{id:B,name:N,running:!0}),ie}forciblyEndTasks(){for(const{run:N}of this.tasks.values())N.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(N){if(!(N instanceof b.TestItemImpl))throw new f.InvalidTestItemError(N.id);if(this.sharedTestIds.has(c.TestId.fromExtHostTestItem(N,this.dto.controllerId).toString()))return;const F=[],x=this.dto.colllection.root;for(;;){const B=r.TestItem.from(N);if(F.unshift(B),this.sharedTestIds.has(B.extId)||(this.sharedTestIds.add(B.extId),N===x))break;N=N.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,F)}}class t{get trackers(){return this.tracked.values()}constructor(N){this.proxy=N,this.tracked=new Map}prepareForMainThreadTestRun(N,F,x){return this.getTracker(N,F,x)}cancelRunById(N){for(const F of this.tracked.values())if(F.id===N){F.cancel();return}}cancelAllRuns(){for(const N of this.tracked.values())N.cancel()}createTestRun(N,F,x,B,U){const X=this.tracked.get(x);if(X)return X.createRun(B);const j=g.fromPublic(N,F,x,U),ge=o(x);this.proxy.$startedExtensionTestRun({controllerId:N,continuous:!!x.continuous,profile:ge&&{group:P[ge.kind],id:ge.profileId},exclude:x.exclude?.map(te=>c.TestId.fromExtHostTestItem(te,F.root.id).toString())??[],id:j.id,include:x.include?.map(te=>c.TestId.fromExtHostTestItem(te,F.root.id).toString())??[F.root.id],persist:U});const ie=this.getTracker(x,j);return ie.onEnd(()=>{this.proxy.$finishedExtensionTestRun(j.id),ie.dispose()}),ie.createRun(B)}getTracker(N,F,x){const B=new n(F,this.proxy,x);return this.tracked.set(N,B),B.onEnd(()=>this.tracked.delete(N)),B}}e.TestRunCoordinator=t;const o=O=>{if(O.profile){if(!(O.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return O.profile}};class g{static fromPublic(N,F,x,B){return new g(N,(0,p.generateUuid)(),x.include?.map(U=>c.TestId.fromExtHostTestItem(U,N).toString())??[N],x.exclude?.map(U=>c.TestId.fromExtHostTestItem(U,N).toString())??[],B,F)}static fromInternal(N,F){return new g(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,F)}constructor(N,F,x,B,U,X){this.controllerId=N,this.id=F,this.isPersisted=U,this.colllection=X,this.includePrefix=x.map(j=>j+"\0"),this.excludePrefix=B.map(j=>j+"\0")}isIncluded(N){const F=c.TestId.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(F===x||F.startsWith(x))return!1;for(const x of this.includePrefix)if(F===x||F.startsWith(x))return!0;return!1}}e.TestRunDto=g;class l{set coverageProvider(N){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");N&&(this._coverageProvider=N,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(N,F,x){this.proxy=N,this.runId=F,this.taskId=x}async provideFileCoverage(N){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(N))());try{return(await this.fileCoverage)?.map(r.TestCoverage.fromFile)??[]}catch(F){throw this.fileCoverage=void 0,F}}async resolveFileCoverage(N,F){const x=await this.fileCoverage;let B=x?.[N];return!this._coverageProvider||!x||!B?[]:(B.detailedCoverage||(B=x[N]=await this._coverageProvider.resolveFileCoverage?.(B,F)??B),B.detailedCoverage?.map(r.TestCoverage.fromDetailed)??[])}}class h{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(N){this.emitter=N,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(N){this.added.add(N)}update(N){Object.assign(N.revived,r.TestItem.toPlain(N.item)),this.added.has(N)||this.updated.add(N)}remove(N){if(this.added.has(N)){this.added.delete(N);return}this.updated.delete(N);const F=c.TestId.parentId(N.item.extId);if(F&&this.alreadyRemoved.has(F.toString())){this.alreadyRemoved.add(N.item.extId);return}this.removed.add(N)}getChangeEvent(){const{added:N,updated:F,removed:x}=this;return{get added(){return[...N].map(B=>B.revived)},get updated(){return[...F].map(B=>B.revived)},get removed(){return[...x].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class w extends S.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(N){return this.items.get(N)}getMirroredTestDataByReference(N){return this.items.get(N.id)}createItem(N,F){return{...N,revived:r.TestItem.toPlain(N.item),depth:F?F.depth+1:0,children:new Set}}createChangeCollector(){return new h(this.changeEmitter)}}class u{constructor(N){this.proxy=N}checkout(){this.current||(this.current=this.createObserverData());const N=this.current;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(F=>F.revived)},dispose:(0,m.once)(()=>{--N.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(N){return this.current?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.current?.tests.apply(N)}createObserverData(){const N=new w;return this.proxy.$subscribeToDiffs(),{observers:0,tests:N}}}class E{#e;#t;get label(){return this._label}set label(N){N!==this._label&&(this._label=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(N){N!==this._supportsContinuousRun&&(this._supportsContinuousRun=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this._isDefault}set isDefault(N){N!==this._isDefault&&(this._isDefault=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?r.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(N){N!==this._configureHandler&&(this._configureHandler=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}constructor(N,F,x,B,U,X,j,ge=!1,ie=void 0,te=!1){this.controllerId=x,this.profileId=B,this._label=U,this.kind=X,this.runHandler=j,this._isDefault=ge,this._tag=ie,this._supportsContinuousRun=te,this.#e=N,this.#t=F,F.set(B,this);const $=P[X];if(typeof $!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);this.#e.$publishTestRunProfile({profileId:B,controllerId:x,tag:ie?r.TestTag.namespace(this.controllerId,ie.id):null,label:U,group:$,isDefault:ge,hasConfigurationHandler:!1,supportsContinuousRun:te})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=E;const P={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(De[310],Ie([1,0,19,8,3,6,140,16,7]),function(me,e,_,L,d,A,T,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class v{constructor(k,p){this._extHostDocumentsAndEditors=p,this._onDidChangeTextEditorSelection=new d.Emitter({onListenerError:L.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new d.Emitter({onListenerError:L.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new d.Emitter({onListenerError:L.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new d.Emitter({onListenerError:L.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new d.Emitter({onListenerError:L.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new d.Emitter({onListenerError:L.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=k.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(C=>this._onDidChangeVisibleTextEditors.fire(C)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(C=>this._onDidChangeActiveTextEditor.fire(C))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(k){const p=this._extHostDocumentsAndEditors.allEditors();return k?p:p.map(C=>C.value)}async showTextDocument(k,p,C){let D;typeof p=="number"?D={position:m.ViewColumn.from(p),preserveFocus:C}:typeof p=="object"?D={position:m.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selection:typeof p.selection=="object"?m.Range.from(p.selection):void 0,pinned:typeof p.preview=="boolean"?!p.preview:void 0}:D={preserveFocus:!1};const b=await this._proxy.$tryShowTextDocument(k.uri,D),r=b&&this._extHostDocumentsAndEditors.getEditor(b);if(r)return r.value;throw b?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,p){return new T.TextEditorDecorationType(this._proxy,k,p).value}$acceptEditorPropertiesChanged(k,p){const C=this._extHostDocumentsAndEditors.getEditor(k);if(!C)throw new Error("unknown text editor");if(p.options&&C._acceptOptions(p.options),p.selections){const D=p.selections.selections.map(m.Selection.to);C._acceptSelections(D)}if(p.visibleRanges){const D=_.coalesce(p.visibleRanges.map(m.Range.to));C._acceptVisibleRanges(D)}if(p.options&&this._onDidChangeTextEditorOptions.fire({textEditor:C.value,options:{...p.options,lineNumbers:m.TextEditorLineNumbersStyle.to(p.options.lineNumbers)}}),p.selections){const D=y.TextEditorSelectionChangeKind.fromValue(p.selections.source),b=p.selections.selections.map(m.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:C.value,selections:b,kind:D})}if(p.visibleRanges){const D=_.coalesce(p.visibleRanges.map(m.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:C.value,visibleRanges:D})}}$acceptEditorPositionData(k){for(const p in k){const C=this._extHostDocumentsAndEditors.getEditor(p);if(!C)throw new Error("Unknown text editor");const D=m.ViewColumn.to(k[p]);C.value.viewColumn!==D&&(C._acceptViewColumn(D),this._onDidChangeTextEditorViewColumn.fire({textEditor:C.value,viewColumn:D}))}}getDiffInformation(k){return Promise.resolve(this._proxy.$getDiffInformation(k))}}e.ExtHostEditors=v}),define(De[311],Ie([1,0,2,5,6,4,7,16,25,14]),function(me,e,_,L,d,A,T,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class R{constructor(C,D){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=C.getProxy(d.MainContext.MainThreadTimeline),D.registerArgumentProcessor({processArgument:(b,r)=>{if(b&&b.$mid===12)if(this._providers.get(b.source)&&y.ExtensionIdentifier.equals(r,this._providers.get(b.source)?.extension)){const s=b.uri===void 0?void 0:_.URI.revive(b.uri);return this._itemsBySourceAndUriMap.get(b.source)?.get(k(s))?.get(b.handle)}else return;return b}})}async $getTimeline(C,D,b,r){return this._providers.get(C)?.provider.provideTimeline(_.URI.revive(D),b,r)}registerTimelineProvider(C,D,b,r){const s=new A.DisposableStore,c=this.convertTimelineItem(D.id,r,s).bind(this);let f;D.onDidChange&&(f=D.onDidChange(I=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...I,id:D.id}),this));const S=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...D,scheme:C,onDidChange:void 0,async provideTimeline(I,i,a){i?.resetCache&&(s.clear(),S.get(D.id)?.clear());const n=await D.provideTimeline(I,i,a);if(n==null)return;const t=c(I,i);return{...n,source:D.id,items:n.items.map(t)}},dispose(){for(const I of S.values())I.get(D.id)?.clear();f?.dispose(),s.dispose()}},b)}convertTimelineItem(C,D,b){return(r,s)=>{let c;if(s?.cacheResults){let f=this._itemsBySourceAndUriMap.get(C);f===void 0&&(f=new Map,this._itemsBySourceAndUriMap.set(C,f));const S=k(r);c=f.get(S),c===void 0&&(c=new Map,f.set(S,c))}return f=>{const{iconPath:S,...I}=f,i=`${C}|${f.id??f.timestamp}`;c?.set(i,f);let a,n,t;f.iconPath&&(S instanceof T.ThemeIcon?t={id:S.id,color:S.color}:_.URI.isUri(S)?(a=S,n=S):{light:a,dark:n}=S);let o;return T.MarkdownString.isMarkdownString(I.tooltip)?o=m.MarkdownString.from(I.tooltip):(0,v.isString)(I.tooltip)?o=I.tooltip:T.MarkdownString.isMarkdownString(I.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=m.MarkdownString.from(I.detail)):(0,v.isString)(I.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=I.detail),{...I,id:I.id??void 0,handle:i,source:C,command:f.command?D.toInternal(f.command,b):void 0,icon:a,iconDark:n,themeIcon:t,tooltip:o,accessibilityInformation:f.accessibilityInformation}}}}registerTimelineProviderCore(C,D){if(this._providers.get(C.id))throw new Error(`Timeline Provider ${C.id} already exists.`);return this._proxy.$registerTimelineProvider({id:C.id,label:C.label,scheme:C.scheme}),this._providers.set(C.id,{provider:C,extension:D}),(0,A.toDisposable)(()=>{for(const r of this._itemsBySourceAndUriMap.values())r.get(C.id)?.clear();this._providers.delete(C.id),this._proxy.$unregisterTimelineProvider(C.id),C.dispose()})}}e.ExtHostTimeline=R;function k(p){return p?.toString()}}),define(De[64],Ie([1,0,21,3,4,203,5,18,132,6,26,20,7]),function(me,e,_,L,d,A,T,m,y,v,R,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class C extends y.DisposableTunnel{}var D;(function(r){function s(f){return{remoteAddress:f.remoteAddress,localAddress:f.localAddress,public:!!f.public,privacy:f.privacy??(f.public?y.TunnelPrivacyId.Public:y.TunnelPrivacyId.Private),protocol:f.protocol}}r.fromApiTunnel=s;function c(f){return{remoteAddress:{host:f.tunnelRemoteHost,port:f.tunnelRemotePort},localAddress:f.localAddress,public:f.privacy!==y.TunnelPrivacyId.ConstantPrivate&&f.privacy!==y.TunnelPrivacyId.ConstantPrivate,privacy:f.privacy,protocol:f.protocol}}r.fromServiceTunnel=c})(D||(e.TunnelDtoConverter=D={})),e.IExtHostTunnelService=(0,T.createDecorator)("IExtHostTunnelService");let b=class extends d.Disposable{constructor(s,c,f){super(),this.logService=f,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new L.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=s.getProxy(v.MainContext.MainThreadTunnelService)}async openTunnel(s,c){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const f=await this._proxy.$openTunnel(c,s.displayName);if(f){const S=new C(f.remoteAddress,f.localAddress,()=>this._proxy.$closeTunnel(f.remoteAddress));return this._register(S),S}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(s,c){const f=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(f,{selector:s,provider:c}),this._proxy.$registerPortsAttributesProvider(s,f),new p.Disposable(()=>{this._portAttributesProviders.delete(f),this._proxy.$unregisterPortsAttributesProvider(f)})}async $providePortAttributes(s,c,f,S,I){const i=[];for(const n of s){const t=this._portAttributesProviders.get(n);if(!t)return[];i.push(...await Promise.all(c.map(async o=>({providedAttributes:await t.provider.providePortAttributes(o,f,S,I),port:o}))))}const a=i.filter(n=>!!n.providedAttributes);return a.length>0?a.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,c){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(S,I)=>await s.provideTunnel(S,I,new _.CancellationTokenSource().token)??void 0;const f=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this._proxy.$setTunnelProvider(f),Promise.resolve((0,d.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(s){if(s){if(s.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this._showCandidatePort=s.showCandidatePort,this._proxy.$setCandidateFilter()),s.tunnelFactory){this._forwardPortProvider=s.tunnelFactory;let c=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const f=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:c}:void 0;this._proxy.$setTunnelProvider(f)}}else this._forwardPortProvider=void 0;return(0,d.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(s,c){if(this._extensionTunnels.has(s.host)){const f=this._extensionTunnels.get(s.host);f.has(s.port)&&(c&&f.get(s.port).disposeListener.dispose(),await f.get(s.port).tunnel.dispose(),f.delete(s.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(s,c){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const f=this._forwardPortProvider(s,c);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),f!==void 0){const S=await f;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),S===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(s.remoteAddress.host)||this._extensionTunnels.set(s.remoteAddress.host,new Map);const I=this._register(S.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(S.remoteAddress))));return this._extensionTunnels.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:S,disposeListener:I}),D.fromApiTunnel(S)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(s){const c=await Promise.all(s.map(S=>this._showCandidatePort(S.host,S.port,S.detail??""))),f=s.filter((S,I)=>c[I]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(S=>S.port).join(", ")} to ${f.map(S=>S.port).join(", ")}`),f}};e.ExtHostTunnelService=b,e.ExtHostTunnelService=b=Ve([$e(0,k.IExtHostRpcService),$e(1,R.IExtHostInitDataService),$e(2,m.ILogService)],b)}),define(De[312],Ie([1,0,4,15,2,6]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{static{this.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}constructor(y){this._openers=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,v,R,k){if(this._openers.has(v))throw new Error(`Opener with id '${v}' already registered`);const p=k.schemes.find(C=>!T.supportedSchemes.has(C));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this._openers.set(v,R),this._proxy.$registerUriOpener(v,k.schemes,y,k.label),(0,_.toDisposable)(()=>{this._openers.delete(v),this._proxy.$unregisterUriOpener(v)})}async $canOpenUri(y,v,R){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener with id: ${y}`);const p=d.URI.revive(v);return k.canOpenExternalUri(p,R)}async $openUri(y,v,R){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener id: '${y}'`);return k.openExternalUri(d.URI.revive(v.resolvedUri),{sourceUri:d.URI.revive(v.sourceUri)},R)}}e.ExtHostUriOpeners=T}),define(De[313],Ie([1,0,6,2,4,8,25]),function(me,e,_,L,d,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class m{static{this.HandlePool=0}constructor(v){this.handles=new T.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=v.getProxy(_.MainContext.MainThreadUrls)}registerUriHandler(v,R){const k=v.identifier;if(this.handles.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const p=m.HandlePool++;return this.handles.add(k),this.handlers.set(p,R),this._proxy.$registerUriHandler(p,k,v.displayName||v.name),(0,d.toDisposable)(()=>{this.handles.delete(k),this.handlers.delete(p),this._proxy.$unregisterUriHandler(p)})}$handleExternalUri(v,R){const k=this.handlers.get(v);if(!k)return Promise.resolve(void 0);try{k.handleUri(L.URI.revive(R))}catch(p){(0,A.onUnexpectedError)(p)}return Promise.resolve(void 0)}async createAppUri(v){return L.URI.revive(await this._proxy.$createAppUri(v))}}e.ExtHostUrls=m}),define(De[86],Ie([1,0,3,15,23,2,217,250,104,6]),function(me,e,_,L,d,A,T,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class R{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;constructor(f,S,I,i,a,n,t){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new _.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new _.Emitter,this._onDidDispose=this.#d.event,this.#e=f,this.#t=S,this.#r=I,this.#u=i,this.#l=a,this.#n=n,this.#c=k(n),this.#h=p(n),this.#i=t}#d;dispose(){this.#o=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return this.#a=!0,(0,y.asWebviewUri)(f,this.#u)}get cspSource(){const f=this.#n.extensionLocation;if(f.scheme===L.Schemas.https||f.scheme===L.Schemas.http){let S=f.toString();return S.endsWith("/")||(S+="/"),S+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#s}set html(f){this.assertNotDisposed(),this.#s!==f&&(this.#s=f,this.#h&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(f)))}get options(){return this.assertNotDisposed(),this.#r}set options(f){this.assertNotDisposed(),d.equals(this.#r,f)||this.#t.$setOptions(this.#e,b(this.#n,this.#l,f)),this.#r=f}async postMessage(f){if(this.#o)return!1;const S=(0,m.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,S.message,...S.buffers)}assertNotDisposed(){if(this.#o)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(f){if(!this.#h)return f;const S=this.#n.extensionLocation?.scheme===L.Schemas.vscodeRemote,I=this.#n.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return f.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(i,a,n,t,o,g)=>{const l=A.URI.from({scheme:t||"file",path:decodeURIComponent(o)}),h=(0,y.asWebviewUri)(l,{isRemote:S,authority:I}).toString();return`${a}${h}${g}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(i,a,n,t,o,g)=>{const l=A.URI.from({scheme:t||"file",path:decodeURIComponent(o)}),h=(0,y.asWebviewUri)(l,{isRemote:S,authority:I}).toString();return`${a}${h}${g}`})}}e.ExtHostWebview=R;function k(c){try{const f=(0,T.normalizeVersion)((0,T.parseVersion)(c.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=k;function p(c){try{const f=(0,T.normalizeVersion)((0,T.parseVersion)(c.engines.vscode));return f?f.majorBase<1||f.majorBase===1&&f.minorBase<60:!1}catch{return!1}}class C{constructor(f,S,I,i,a){this.remoteInfo=S,this.workspace=I,this._logService=i,this._deprecationService=a,this._webviews=new Map,this._webviewProxy=f.getProxy(v.MainContext.MainThreadWebviews)}$onMessage(f,S,I){const i=this.getWebview(f);if(i){const{message:a}=(0,m.deserializeWebviewMessage)(S,I.value);i._onMessageEmitter.fire(a)}}$onMissingCsp(f,S){this._logService.warn(`${S} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,S,I){const i=new R(f,this._webviewProxy,r(S),this.remoteInfo,this.workspace,I,this._deprecationService);return this._webviews.set(f,i),i._onDidDispose(()=>{this._webviews.delete(f)}),i}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=C;function D(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=D;function b(c,f,S){return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,enableForms:S.enableForms,portMapping:S.portMapping,localResourceRoots:S.localResourceRoots||s(c,f)}}e.serializeWebviewOptions=b;function r(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(f=>A.URI.from(f))}}function s(c,f){return[...(f?.getWorkspaceFolders()||[]).map(S=>S.uri),c.extensionLocation]}}),define(De[314],Ie([1,0,21,70,4,15,24,2,16,86,81,6,7]),function(me,e,_,L,d,A,T,m,y,v,R,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class C{constructor(a,n){this.document=a,this._storagePath=n,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,n){await this.getEdit(a).undo(),n||this.disposeBackup()}async redo(a,n){await this.getEdit(a).redo(),n||this.disposeBackup()}disposeEdits(a){for(const n of a)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=I(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const n=this._edits.get(a,0);if(!n)throw new Error("No edit found");return n}}class D{constructor(){this._documents=new Map}get(a,n){return this._documents.get(this.key(a,n))}add(a,n,t){const o=this.key(a,n.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${a} resource:${n.uri}`);const g=new C(n,t);return this._documents.set(o,g),g}delete(a,n){const t=this.key(a,n.uri);this._documents.delete(t)}key(a,n){return`${a}@@@${n}`}}var b;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(b||(b={}));class r{constructor(){this._providers=new Map}addTextProvider(a,n,t){return this.add(0,a,n,t)}addCustomProvider(a,n,t){return this.add(1,a,n,t)}get(a){return this._providers.get(a)}add(a,n,t,o){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:a,extension:t,provider:o}),new p.Disposable(()=>this._providers.delete(n))}}class s{constructor(a,n,t,o,g){this._extHostDocuments=n,this._extensionStoragePaths=t,this._extHostWebview=o,this._extHostWebviewPanels=g,this._editorProviders=new r,this._documents=new D,this._proxy=a.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,n,t,o){const g=new d.DisposableStore;return f(t)?(g.add(this._editorProviders.addTextProvider(n,a,t)),this._proxy.$registerTextEditorProvider((0,v.toExtensionData)(a),n,o.webviewOptions||{},{supportsMove:!!t.moveCustomTextEditor},(0,v.shouldSerializeBuffersForPostMessage)(a))):(g.add(this._editorProviders.addCustomProvider(n,a,t)),c(t)&&g.add(t.onDidChangeCustomDocument(l=>{const h=this.getCustomDocumentEntry(n,l.document.uri);if(S(l)){const w=h.addEdit(l);this._proxy.$onDidEdit(l.document.uri,n,w,l.label)}else this._proxy.$onContentChange(l.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,v.toExtensionData)(a),n,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,v.shouldSerializeBuffersForPostMessage)(a))),p.Disposable.from(g,new p.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(a,n,t,o,g){const l=this._editorProviders.get(n);if(!l)throw new Error(`No provider found for '${n}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${n}'`);const h=m.URI.revive(a),w=await l.provider.openCustomDocument(h,{backupId:t,untitledDocumentData:o?.buffer},g);let u;return c(l.provider)&&this._extensionStoragePaths&&(u=this._extensionStoragePaths.workspaceValue(l.extension)??this._extensionStoragePaths.globalValue(l.extension)),this._documents.add(n,w,u),{editable:c(l.provider)}}async $disposeCustomDocument(a,n){const t=this._editorProviders.get(n);if(!t)throw new Error(`No provider found for '${n}'`);if(t.type!==1)throw new Error(`Invalid provider type for '${n}'`);const o=m.URI.revive(a),{document:g}=this.getCustomDocumentEntry(n,o);this._documents.delete(n,g),g.dispose()}async $resolveCustomEditor(a,n,t,o,g,l){const h=this._editorProviders.get(t);if(!h)throw new Error(`No provider found for '${t}'`);const w=y.ViewColumn.to(g),u=this._extHostWebview.createNewWebview(n,o.contentOptions,h.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(n,t,o.title,w,o.options,u,o.active),P=m.URI.revive(a);switch(h.type){case 1:{const{document:O}=this.getCustomDocumentEntry(t,P);return h.provider.resolveCustomEditor(O,E,l)}case 0:{const O=this._extHostDocuments.getDocument(P);return h.provider.resolveCustomTextEditor(O,E,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,n,t){this.getCustomDocumentEntry(n,a).disposeEdits(t)}async $onMoveCustomEditor(a,n,t){const o=this._editorProviders.get(t);if(!o)throw new Error(`No provider found for '${t}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${t}'`);const g=this._extHostWebviewPanels.getWebviewPanel(a);if(!g)throw new Error("No webview found");const l=m.URI.revive(n),h=this._extHostDocuments.getDocument(l);await o.provider.moveCustomTextEditor(h,g,_.CancellationToken.None)}async $undo(a,n,t,o){return this.getCustomDocumentEntry(n,a).undo(t,o)}async $redo(a,n,t,o){return this.getCustomDocumentEntry(n,a).redo(t,o)}async $revert(a,n,t){const o=this.getCustomDocumentEntry(n,a);await this.getCustomEditorProvider(n).revertCustomDocument(o.document,t),o.disposeBackup()}async $onSave(a,n,t){const o=this.getCustomDocumentEntry(n,a);await this.getCustomEditorProvider(n).saveCustomDocument(o.document,t),o.disposeBackup()}async $onSaveAs(a,n,t,o){const g=this.getCustomDocumentEntry(n,a);return this.getCustomEditorProvider(n).saveCustomDocumentAs(g.document,m.URI.revive(t),o)}async $backup(a,n,t){const o=this.getCustomDocumentEntry(n,a),l=await this.getCustomEditorProvider(n).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},t);return o.updateBackup(l),l.id}getCustomDocumentEntry(a,n){const t=this._documents.get(a,m.URI.revive(n));if(!t)throw new Error("No custom document found");return t}getCustomEditorProvider(a){const t=this._editorProviders.get(a)?.provider;if(!t||!c(t))throw new Error("Custom document is not editable");return t}}e.ExtHostCustomEditors=s;function c(i){return!!i.onDidChangeCustomDocument}function f(i){return typeof i.resolveCustomTextEditor=="function"}function S(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function I(i){const a=i.scheme===A.Schemas.file||i.scheme===A.Schemas.untitled?i.fsPath:i.toString();return(0,L.hash)(a)+""}}),define(De[315],Ie([1,0,3,4,2,32,16,86,6,7]),function(me,e,_,L,d,A,T,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class R extends L.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;#d;constructor(D,b,r,s){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#h=this._register(new _.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new _.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=D,this.#t=b,this.#u=r,this.#i=s.viewType,this.#l=s.panelOptions,this.#r=s.viewColumn,this.#n=s.title,this.#a=s.active}dispose(){this.#c||(this.#c=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#u.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#u}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#n}set title(D){this.assertNotDisposed(),this.#n!==D&&(this.#n=D,this.#t.$setTitle(this.#e,D))}get iconPath(){return this.assertNotDisposed(),this.#s}set iconPath(D){this.assertNotDisposed(),this.#s!==D&&(this.#s=D,this.#t.$setIconPath(this.#e,d.URI.isUri(D)?{light:D,dark:D}:D))}get options(){return this.#l}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.assertNotDisposed(),this.#a}get visible(){return this.assertNotDisposed(),this.#o}_updateViewState(D){this.#c||(this.active!==D.active||this.visible!==D.visible||this.viewColumn!==D.viewColumn)&&(this.#a=D.active,this.#o=D.visible,this.#r=D.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(D,b){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof D>"u"?void 0:T.ViewColumn.from(D),preserveFocus:!!b})}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}}class k{static newHandle(){return(0,A.generateUuid)()}constructor(D,b,r){this.webviews=b,this.workspace=r,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=D.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(D,b,r,s,c={}){const f=typeof s=="object"?s.viewColumn:s,S={viewColumn:T.ViewColumn.from(f),preserveFocus:typeof s=="object"&&!!s.preserveFocus},I=(0,m.shouldSerializeBuffersForPostMessage)(D),i=k.newHandle();this._proxy.$createWebviewPanel((0,m.toExtensionData)(D),i,b,{title:r,panelOptions:p(c),webviewOptions:(0,m.serializeWebviewOptions)(D,this.workspace,c),serializeBuffersForPostMessage:I},S);const a=this.webviews.createNewWebview(i,c,D);return this.createNewWebviewPanel(i,b,r,f,c,a,!0)}$onDidChangeWebviewPanelViewStates(D){const b=Object.keys(D);b.sort((r,s)=>{const c=D[r],f=D[s];return c.active?1:f.active?-1:+c.visible-+f.visible});for(const r of b){const s=this.getWebviewPanel(r);if(!s)continue;const c=D[r];s._updateViewState({active:c.active,visible:c.visible,viewColumn:T.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel(D){this.getWebviewPanel(D)?.dispose(),this._webviewPanels.delete(D),this.webviews.deleteWebview(D)}registerWebviewPanelSerializer(D,b,r){if(this._serializers.has(b))throw new Error(`Serializer for '${b}' already registered`);return this._serializers.set(b,{serializer:r,extension:D}),this._proxy.$registerSerializer(b,{serializeBuffersForPostMessage:(0,m.shouldSerializeBuffersForPostMessage)(D)}),new v.Disposable(()=>{this._serializers.delete(b),this._proxy.$unregisterSerializer(b)})}async $deserializeWebviewPanel(D,b,r,s){const c=this._serializers.get(b);if(!c)throw new Error(`No serializer found for '${b}'`);const{serializer:f,extension:S}=c,I=this.webviews.createNewWebview(D,r.webviewOptions,S),i=this.createNewWebviewPanel(D,b,r.title,s,r.panelOptions,I,r.active);await f.deserializeWebviewPanel(i,r.state)}createNewWebviewPanel(D,b,r,s,c,f,S){const I=new R(D,this._proxy,f,{viewType:b,title:r,viewColumn:s,panelOptions:c,active:S});return this._webviewPanels.set(D,I),I}getWebviewPanel(D){return this._webviewPanels.get(D)}}e.ExtHostWebviewPanels=k;function p(C){return{enableFindWidget:C.enableFindWidget,retainContextWhenHidden:C.retainContextWhenHidden}}}),define(De[316],Ie([1,0,3,4,86,16,6,7]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class y extends L.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;constructor(k,p,C,D,b,r){super(),this.#l=!1,this.#a=this._register(new _.Emitter),this.onDidChangeVisibility=this.#a.event,this.#c=this._register(new _.Emitter),this.onDidDispose=this.#c.event,this.#i=C,this.#s=D,this.#e=k,this.#t=p,this.#u=b,this.#n=r}dispose(){this.#l||(this.#l=!0,this.#c.fire(),this.#u.dispose(),super.dispose())}#a;#c;get title(){return this.assertNotDisposed(),this.#s}set title(k){this.assertNotDisposed(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.assertNotDisposed(),this.#r}set description(k){this.assertNotDisposed(),this.#r!==k&&(this.#r=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#u}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#l||(this.#n=k,this.#a.fire())}get badge(){return this.assertNotDisposed(),this.#o}set badge(k){this.assertNotDisposed(),!(k?.value===this.#o?.value&&k?.tooltip===this.#o?.tooltip)&&(this.#o=A.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.assertNotDisposed(),this.#t.$show(this.#e,!!k)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}}class v{constructor(k,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=k.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(k,p,C,D){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:C,extension:k}),this._proxy.$registerWebviewViewProvider((0,d.toExtensionData)(k),p,{retainContextWhenHidden:D?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,d.shouldSerializeBuffersForPostMessage)(k)}),new m.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(k,p,C,D,b){const r=this._viewProviders.get(p);if(!r)throw new Error(`No view provider found for '${p}'`);const{provider:s,extension:c}=r,f=this._extHostWebview.createNewWebview(k,{},c),S=new y(k,this._proxy,p,C,f,!0);this._webviewViews.set(k,S),await s.resolveWebviewView(S,{state:D},b)}async $onDidChangeWebviewViewVisibility(k,p){this.getWebviewView(k)._setVisible(p)}async $disposeWebviewView(k){const p=this.getWebviewView(k);this._webviewViews.delete(k),p.dispose(),this._extHostWebview.deleteWebview(k)}getWebviewView(k){const p=this._webviewViews.get(k);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=v}),define(De[144],Ie([1,0,3,6,2,15,12,5,20,27]),function(me,e,_,L,d,A,T,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let R=class _n{static{this.InitialState={focused:!0,active:!0}}getState(p){const C=this._state;return{get focused(){return C.focused},get active(){return(0,v.checkProposedApiEnabled)(p,"windowActivity"),C.active}}}constructor(p){this._onDidChangeWindowState=new _.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=_n.InitialState,this._proxy=p.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:C,isActive:D})=>{this.onDidChangeWindowProperty("focused",C),this.onDidChangeWindowProperty("active",D)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,C){C!==this._state[p]&&(this._state={...this._state,[p]:C},this._onDidChangeWindowState.fire(this._state))}openUri(p,C){let D;if(typeof p=="string"){D=p;try{p=d.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,T.isFalsyOrWhitespace)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this._proxy.$openUri(p,D,C)}async asExternalUri(p,C){if((0,T.isFalsyOrWhitespace)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const D=await this._proxy.$asExternalUri(p,C);return d.URI.from(D)}};e.ExtHostWindow=R,e.ExtHostWindow=R=Ve([$e(0,y.IExtHostRpcService)],R),e.IExtHostWindow=(0,m.createDecorator)("IExtHostWindow")}),define(De[317],Ie([1,0,285,26,20]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const A=1024*1024;let T=class extends _.AbstractExtHostConsoleForwarder{constructor(y,v){super(y,v),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(y,v,R){const k=y==="error"||y==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),v.apply(console,R),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(y,v){const R=process[y],k=R.write;let p="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(C,D,b)=>{if(!this._isMakingConsoleCall){p+=C.toString(D);const r=p.length>A?p.length:p.lastIndexOf(`
`);r!==-1&&(console[v](p.slice(0,r)),p=p.slice(r+1))}k.call(R,C,D,b)}})}};e.ExtHostConsoleForwarder=T,e.ExtHostConsoleForwarder=T=Ve([$e(0,d.IExtHostRpcService),$e(1,L.IExtHostInitDataService)],T)}),define(De[318],Ie([1,0,63,15,18,229,30,11]),function(me,e,_,L,d,A,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let y=class{constructor(k,p){k.addFileSystemProvider(L.Schemas.file,new v(p),{isCaseSensitive:m.isLinux})}};e.ExtHostDiskFileSystemProvider=y,e.ExtHostDiskFileSystemProvider=y=Ve([$e(0,_.IExtHostConsumerFileSystem),$e(1,d.ILogService)],y);class v{constructor(k){this.logService=k,this.impl=new A.DiskFileSystemProvider(this.logService)}async stat(k){const p=await this.impl.stat(k);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===T.FilePermission.Readonly?1:void 0}}readDirectory(k){return this.impl.readdir(k)}createDirectory(k){return this.impl.mkdir(k)}readFile(k){return this.impl.readFile(k)}writeFile(k,p,C){return this.impl.writeFile(k,p,{...C,unlock:!1,atomic:!1})}delete(k,p){return this.impl.delete(k,{...p,useTrash:!1,atomic:!1})}rename(k,p,C){return this.impl.rename(k,p,C)}copy(k,p,C){return this.impl.copy(k,p,C)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(k,p){throw new Error("Method not implemented.")}}}),define(De[319],Ie([1,0,13,75,32,36,4,6,2,20]),function(me,e,_,L,d,A,T,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends T.Disposable{constructor(p,C){super();const D=p.getProxy(m.MainContext.MainThreadDownloadService);C.registerCommand(!1,"_workbench.downloadResource",async b=>{const r=y.URI.file((0,_.join)((0,L.tmpdir)(),(0,d.generateUuid)()));return await D.$download(b,r),r})}};e.ExtHostDownloadService=R,e.ExtHostDownloadService=R=Ve([$e(0,v.IExtHostRpcService),$e(1,A.IExtHostCommands)],R)}),define(De[320],Ie([1,0,143,15,231,32]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class T extends _.ExtHostLoggerService{doCreateLogger(y,v,R){return y.scheme===L.Schemas.file?new d.SpdLogLogger(R?.name||(0,A.generateUuid)(),y.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,v):super.doCreateLogger(y,v,R)}registerLogger(y){super.registerLogger(y),this._proxy.$registerLogger(y)}deregisterLogger(y){super.deregisterLogger(y),this._proxy.$deregisterLogger(y)}}e.ExtHostLoggerService=T}),define(De[321],Ie([1,0,49,13,2,85,4,15,17,29]),function(me,e,_,L,d,A,T,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends A.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(i){const a=await super._getWorkspaceStorageURI(i);if(a.scheme!==m.Schemas.file)return a;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${a.fsPath}.`),a;const n=a.fsPath;let t=0;do{let o;t===0?o=n:o=/[/\\]$/.test(n)?`${n.substr(0,n.length-1)}-${t}`:`${n}-${t}`,await k(o);const g=L.join(o,"vscode.lock"),l=await b(this._logService,g,!1);if(l)return this._workspaceStorageLock=l,process.on("exit",()=>{l.dispose()}),d.URI.file(o);t++}while(t<10);return a}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function k(I){try{await v.Promises.stat(I);return}catch{}try{await v.Promises.mkdir(I,{recursive:!0})}catch{}}const p=1e3,C=10*60*1e3;class D extends T.Disposable{constructor(i,a){super(),this.logService=i,this.filename=a,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const n=await r(i,a);(!n||n.pid!==process.pid)&&(i.info(`Lock '${a}': The lock was lost unexpectedly.`),this._timer.cancel());try{await v.Promises.utimes(a,new Date,new Date)}catch(t){i.error(t),i.info(`Lock '${a}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{_.unlinkSync(this.filename)}catch{}}async setWillRelease(i){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const a={pid:process.pid,willReleaseAt:Date.now()+i};await v.Promises.writeFile(this.filename,JSON.stringify(a),{flag:"w"})}catch(a){this.logService.error(a)}}}async function b(I,i,a){try{const t={pid:process.pid,willReleaseAt:0};await v.Promises.writeFile(i,JSON.stringify(t),{flag:"wx"})}catch(t){I.error(t)}const n=await r(I,i);return!n||n.pid!==process.pid?a?(I.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(I.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),f(I,i)):(I.info(`Lock '${i}': Lock acquired.`),new D(I,i))}async function r(I,i){let a;try{a=await v.Promises.readFile(i)}catch(n){return I.error(n),null}try{return JSON.parse(String(a))}catch(n){return I.error(n),null}}async function s(I,i){let a;try{a=await v.Promises.stat(i)}catch(n){return I.error(n),0}return a.mtime.getTime()}function c(I){try{return process.kill(I,0),!0}catch{return!1}}async function f(I,i){const a=await r(I,i);if(!a)return I.info(`Lock '${i}': Could not read pid of lock holder.`),S(I,i);if(a.willReleaseAt){let l=a.willReleaseAt-Date.now();if(l<5e3){for(l>0?I.info(`Lock '${i}': The lockfile is scheduled to be released in ${l} ms.`):I.info(`Lock '${i}': The lockfile is scheduled to have been released.`);l>0;){if(await(0,y.timeout)(Math.min(100,l)),await s(I,i)===0)return S(I,i);l=a.willReleaseAt-Date.now()}return S(I,i)}}if(!c(a.pid))return I.info(`Lock '${i}': The pid ${a.pid} appears to be gone.`),S(I,i);const n=await s(I,i),t=Date.now()-n;if(t<=C)return I.info(`Lock '${i}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;I.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const o=await s(I,i),g=Date.now()-o;return g<=C?(I.info(`Lock '${i}': The lock does not look stale, elapsed: ${g} ms, giving up.`),null):(I.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),S(I,i))}async function S(I,i){I.info(`Lock '${i}': Deleting a stale lock.`);try{await v.Promises.unlink(i)}catch{}return b(I,i,!0)}}),define(De[322],Ie([1,0,32,20,43]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends d.BaseExtHostTerminalService{constructor(m){super(!0,m)}createTerminal(m,y,v){return this.createTerminalFromOptions({name:m,shellPath:y,shellArgs:v})}createTerminalFromOptions(m,y){const v=new d.ExtHostTerminal(this._proxy,(0,_.generateUuid)(),m,m.name);return this._terminals.push(v),v.create(m,this._serializeParentTerminal(m,y)),v.value}};e.ExtHostTerminalService=A,e.ExtHostTerminalService=A=Ve([$e(0,L.IExtHostRpcService)],A)}),define(De[323],Ie([1,0,46,112,11,24,2,29,18,132,26,20,64]),function(me,e,_,L,d,A,T,m,y,v,R,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;function C(i){const a=i.trim().split(`
`),n=[];return a.forEach(o=>{const g=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(o);g&&g.length>=3&&n.push({pid:parseInt(g[1],10),socket:parseInt(g[2],10)})}),n.reduce((o,g)=>(o[g.socket]=g,o),{})}e.getSockets=C;function D(...i){const a=[].concat(...i.map(r));return[...new Map(a.filter(n=>n.st==="0A").map(n=>{const t=n.local_address.split(":");return{socket:parseInt(n.inode,10),ip:b(t[0]),port:parseInt(t[1],16)}}).map(n=>[n.ip+":"+n.port,n])).values()]}e.loadListeningPorts=D;function b(i){let a="";if(i.length===8)for(let n=i.length-2;n>=0;n-=2)a+=parseInt(i.substr(n,2),16),n!==0&&(a+=".");else for(let n=0;n<i.length;n+=8){const t=i.substring(n,n+8);let o="";for(let g=8;g>=2;g-=2)o+=t.substring(g-2,g),(g===6||g===2)&&(o=parseInt(o,16).toString(16),a+=`${o}`,o="",n+g!==i.length-6&&(a+=":"))}return a}e.parseIpAddress=b;function r(i){const a=i.trim().split(`
`),n=a.shift().trim().split(/\s+/).filter(o=>o!=="rx_queue"&&o!=="tm->when");return a.map(o=>o.trim().split(/\s+/).reduce((g,l,h)=>(g[n[h]||h]=l,g),{}))}e.loadConnectionTable=r;function s(i){return!!i.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||i.indexOf("out/server-main.js")!==-1||i.indexOf("_productName=VSCode")!==-1}function c(i){const a=i.trim().split(`
`),n=[];return a.forEach(t=>{const o=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(t);o&&o.length>=4&&n.push({pid:parseInt(o[1],10),ppid:parseInt(o[2]),cmd:o[3]})}),n}e.getRootProcesses=c;async function f(i,a,n){const t=n.reduce((g,l)=>(g[l.pid]=l,g),{}),o=[];return i.forEach(({socket:g,ip:l,port:h})=>{const w=a[g]?a[g].pid:void 0,u=w?t[w]?.cmd:void 0;w&&u&&!s(u)&&o.push({host:l,port:h,detail:u,pid:w})}),o}e.findPorts=f;function S(i,a,n){const t=new Map,o=c(a);for(const g of i){const l=n.get(g.port);if(l){t.set(g.port,l);continue}const h=o.find(w=>w.cmd.includes(`${g.port}`));if(h){let w=h,u;do u=o.find(E=>E.ppid===w.pid),u&&(w=u);while(u);t.set(g.port,{host:g.ip,port:g.port,pid:w.pid,detail:w.cmd,ppid:w.ppid})}else t.set(g.port,{host:g.ip,port:g.port,ppid:Number.MAX_VALUE})}return t}e.tryFindRootPorts=S;let I=class extends p.ExtHostTunnelService{constructor(a,n,t){super(a,n,t),this._initialCandidates=void 0,this._foundRootPorts=new Map,this._candidateFindingEnabled=!1,d.isLinux&&n.remote.isRemote&&n.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async $registerCandidateFinder(a){if(a&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=a;let n;this._initialCandidates&&(n=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const t=new L.MovingAverage;let o=0;for(;this._candidateFindingEnabled;){const g=new Date().getTime(),l=(await this.findCandidatePorts()).filter(u=>(0,v.isLocalhost)(u.host)||(0,v.isAllInterfaces)(u.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${l.map(u=>u.port).join(", ")}`);const h=new Date().getTime()-g;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${h} ms.`),o++>3&&t.update(h),(!n||JSON.stringify(n)!==JSON.stringify(l))&&(n=l,await this._proxy.$onFoundNewCandidates(n));const w=this.calculateDelay(t.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${w} ms.`),await new Promise(u=>setTimeout(()=>u(),w))}}calculateDelay(a){return Math.max(a*20,2e3)}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(a=>a.port).join(", ")}`)}async findCandidatePorts(){let a="",n="";try{a=await m.Promises.readFile("/proc/net/tcp","utf8"),n=await m.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const t=D(a,n),o=await new Promise(O=>{(0,_.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(N,F,x)=>{O(F)})}),g=C(o),l=await m.Promises.readdir("/proc"),h=[];for(const O of l)try{const N=Number(O),F=A.joinPath(T.URI.file("/proc"),O);if((await m.Promises.stat(F.fsPath)).isDirectory()&&!isNaN(N)){const B=await m.Promises.readlink(A.joinPath(F,"cwd").fsPath),U=await m.Promises.readFile(A.joinPath(F,"cmdline").fsPath,"utf8");h.push({pid:N,cwd:B,cmd:U})}}catch{}const w=[],u=t.filter(O=>{const N=g[O.socket];return N||w.push(O),N}),E=f(u,g,h);let P;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${w.length}`),w.length>0){const O=await new Promise(N=>{(0,_.exec)("ps -F -A -l | grep root",(F,x,B)=>{N(x)})});this._foundRootPorts=S(w,O,this._foundRootPorts),P=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${P.map(N=>N.port).join(", ")}`)}return E.then(O=>P?O.concat(P):O)}};e.NodeExtHostTunnelService=I,e.NodeExtHostTunnelService=I=Ve([$e(0,k.IExtHostRpcService),$e(1,R.IExtHostInitDataService),$e(2,y.ILogService)],I)}),define(De[324],Ie([1,0,17,22,21,8,3,4,121,278,60]),function(me,e,_,L,d,A,T,m,y,v,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function p(u,E){try{return JSON.stringify(u,E)}catch{return"null"}}const C="$$ref$$",D={[C]:-1};class b{constructor(E,P){this.jsonString=E,this.referencedBuffers=P}}function r(u,E=null,P=!1){const O=[];return{jsonString:(P?p:JSON.stringify)(u,(F,x)=>{if(typeof x>"u")return D;if(typeof x=="object"){if(x instanceof L.VSBuffer){const B=O.push(x)-1;return{[C]:B}}if(E)return E(F,x)}return x}),referencedBuffers:O}}e.stringifyJsonWithBufferRefs=r;function s(u,E,P){return JSON.parse(u,(O,N)=>{if(N){const F=N[C];if(typeof F=="number")return E[F];if(P&&N.$mid===1)return P.transformIncoming(N)}return N})}e.parseJsonAndRestoreBufferRefs=s;function c(u,E){return JSON.stringify(u,E)}function f(u){return u?(E,P)=>P&&P.$mid===1?u.transformOutgoing(P):P:null}var S;(function(u){u[u.LocalSide=0]="LocalSide",u[u.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));var I;(function(u){u[u.Responsive=0]="Responsive",u[u.Unresponsive=1]="Unresponsive"})(I||(e.ResponsiveState=I={}));const i=()=>{},a=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class t extends m.Disposable{static{k=a}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(E,P=null,O=null){super(),this[k]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=E,this._logger=P,this._uriTransformer=O,this._uriReplacer=f(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let N=0,F=R.ProxyIdentifier.count;N<F;N++)this._locals[N]=null,this._proxies[N]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new _.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(N=>this._receiveOneMessage(N))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(E=>{this._pendingRPCReplies[E].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(E){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(E){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(E){this._responsiveState!==E&&(this._responsiveState=E,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(E){return this._uriTransformer?(0,y.transformIncomingURIs)(E,this._uriTransformer):E}getProxy(E){const{nid:P,sid:O}=E;return this._proxies[P]||(this._proxies[P]=this._createProxy(P,O)),this._proxies[P]}_createProxy(E,P){const O={get:(N,F)=>(typeof F=="string"&&!N[F]&&F.charCodeAt(0)===36&&(N[F]=(...x)=>this._remoteCall(E,F,x)),F===n?P:N[F])};return new Proxy(Object.create(null),O)}set(E,P){return this._locals[E.nid]=P,P}assertRegistered(E){for(let P=0,O=E.length;P<O;P++){const N=E[P];if(!this._locals[N.nid])throw new Error(`Missing proxy instance ${N.sid}`)}}_receiveOneMessage(E){if(this._isDisposed)return;const P=E.byteLength,O=o.read(E,0),N=O.readUInt8(),F=O.readUInt32();switch(N){case 1:case 2:{let{rpcId:x,method:B,args:U}=l.deserializeRequestJSONArgs(O);this._uriTransformer&&(U=(0,y.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(P,F,x,B,U,N===2);break}case 3:case 4:{let{rpcId:x,method:B,args:U}=l.deserializeRequestMixedArgs(O);this._uriTransformer&&(U=(0,y.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(P,F,x,B,U,N===4);break}case 5:{this._logger?.logIncoming(P,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(P,F);break}case 7:{this._receiveReply(P,F,void 0);break}case 9:{let x=l.deserializeReplyOKJSON(O);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(P,F,x);break}case 10:{const x=l.deserializeReplyOKJSONWithBuffers(O,this._uriTransformer);this._receiveReply(P,F,x);break}case 8:{const x=l.deserializeReplyOKVSBuffer(O);this._receiveReply(P,F,x);break}case 11:{let x=l.deserializeReplyErrError(O);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(P,F,x);break}case 12:{this._receiveReplyErr(P,F,void 0);break}default:console.error("received unexpected message"),console.error(E)}}_receiveRequest(E,P,O,N,F,x){this._logger?.logIncoming(E,P,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(O)}.${N}(`,F);const B=String(P);let U,X;if(x){const ge=new d.CancellationTokenSource;F.push(ge.token),U=this._invokeHandler(O,N,F),X=()=>ge.cancel()}else U=this._invokeHandler(O,N,F),X=i;this._cancelInvokedHandlers[B]=X;const j=l.serializeAcknowledged(P);this._logger?.logOutgoing(j.byteLength,P,1,"ack"),this._protocol.send(j),U.then(ge=>{delete this._cancelInvokedHandlers[B];const ie=l.serializeReplyOK(P,ge,this._uriReplacer);this._logger?.logOutgoing(ie.byteLength,P,1,"reply:",ge),this._protocol.send(ie)},ge=>{delete this._cancelInvokedHandlers[B];const ie=l.serializeReplyErr(P,ge);this._logger?.logOutgoing(ie.byteLength,P,1,"replyErr:",ge),this._protocol.send(ie)})}_receiveCancel(E,P){this._logger?.logIncoming(E,P,1,"receiveCancel");const O=String(P);this._cancelInvokedHandlers[O]?.()}_receiveReply(E,P,O){this._logger?.logIncoming(E,P,0,"receiveReply:",O);const N=String(P);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const F=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N],F.resolveOk(O)}_receiveReplyErr(E,P,O){this._logger?.logIncoming(E,P,0,"receiveReplyErr:",O);const N=String(P);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const F=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N];let x;O&&(O.$isError?(x=new Error,x.name=O.name,x.message=O.message,x.stack=O.stack):x=O),F.resolveErr(x)}_invokeHandler(E,P,O){try{return Promise.resolve(this._doInvokeHandler(E,P,O))}catch(N){return Promise.reject(N)}}_doInvokeHandler(E,P,O){const N=this._locals[E];if(!N)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(E));const F=N[P];if(typeof F!="function")throw new Error("Unknown method "+P+" on actor "+(0,R.getStringIdentifierForProxy)(E));return F.apply(N,O)}_remoteCall(E,P,O){if(this._isDisposed)return new v.CanceledLazyPromise;let N=null;if(O.length>0&&d.CancellationToken.isCancellationToken(O[O.length-1])&&(N=O.pop()),N&&N.isCancellationRequested)return Promise.reject(A.canceled());const F=l.serializeRequestArguments(O,this._uriReplacer),x=++this._lastMessageId,B=String(x),U=new v.LazyPromise;N&&N.onCancellationRequested(()=>{const j=l.serializeCancel(x);this._logger?.logOutgoing(j.byteLength,x,0,"cancel"),this._protocol.send(l.serializeCancel(x))}),this._pendingRPCReplies[B]=U,this._onWillSendRequest(x);const X=l.serializeRequest(x,E,P,F,!!N);return this._logger?.logOutgoing(X.byteLength,x,0,`request: ${(0,R.getStringIdentifierForProxy)(E)}.${P}(`,O),this._protocol.send(X),U}}e.RPCProtocol=t;class o{static alloc(E,P,O){const N=new o(L.VSBuffer.alloc(O+1+4),0);return N.writeUInt8(E),N.writeUInt32(P),N}static read(E,P){return new o(E,P)}get buffer(){return this._buff}constructor(E,P){this._buff=E,this._offset=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(E){this._buff.writeUInt8(E,this._offset),this._offset+=1}readUInt8(){const E=this._buff.readUInt8(this._offset);return this._offset+=1,E}writeUInt32(E){this._buff.writeUInt32BE(E,this._offset),this._offset+=4}readUInt32(){const E=this._buff.readUInt32BE(this._offset);return this._offset+=4,E}static sizeShortString(E){return 1+E.byteLength}writeShortString(E){this._buff.writeUInt8(E.byteLength,this._offset),this._offset+=1,this._buff.set(E,this._offset),this._offset+=E.byteLength}readShortString(){const E=this._buff.readUInt8(this._offset);this._offset+=1;const O=this._buff.slice(this._offset,this._offset+E).toString();return this._offset+=E,O}static sizeLongString(E){return 4+E.byteLength}writeLongString(E){this._buff.writeUInt32BE(E.byteLength,this._offset),this._offset+=4,this._buff.set(E,this._offset),this._offset+=E.byteLength}readLongString(){const E=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+E).toString();return this._offset+=E,O}writeBuffer(E){this._buff.writeUInt32BE(E.byteLength,this._offset),this._offset+=4,this._buff.set(E,this._offset),this._offset+=E.byteLength}static sizeVSBuffer(E){return 4+E.byteLength}writeVSBuffer(E){this._buff.writeUInt32BE(E.byteLength,this._offset),this._offset+=4,this._buff.set(E,this._offset),this._offset+=E.byteLength}readVSBuffer(){const E=this._buff.readUInt32BE(this._offset);this._offset+=4;const P=this._buff.slice(this._offset,this._offset+E);return this._offset+=E,P}static sizeMixedArray(E){let P=0;P+=1;for(let O=0,N=E.length;O<N;O++){const F=E[O];switch(P+=1,F.type){case 1:P+=this.sizeLongString(F.value);break;case 2:P+=this.sizeVSBuffer(F.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(F.value);for(let x=0;x<F.buffers.length;++x)P+=this.sizeVSBuffer(F.buffers[x]);break;case 4:break}}return P}writeMixedArray(E){this._buff.writeUInt8(E.length,this._offset),this._offset+=1;for(let P=0,O=E.length;P<O;P++){const N=E[P];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let F=0;F<N.buffers.length;++F)this.writeBuffer(N.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const E=this._buff.readUInt8(this._offset);this._offset+=1;const P=new Array(E);for(let O=0;O<E;O++)switch(this.readUInt8()){case 1:P[O]=this.readLongString();break;case 2:P[O]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),x=this.readLongString(),B=[];for(let U=0;U<F;++U)B.push(this.readVSBuffer());P[O]=new R.SerializableObjectWithBuffers(s(x,B,null));break}case 4:P[O]=void 0;break}return P}}var g;(function(u){u[u.Simple=0]="Simple",u[u.Mixed=1]="Mixed"})(g||(g={}));class l{static _useMixedArgSerialization(E){for(let P=0,O=E.length;P<O;P++)if(E[P]instanceof L.VSBuffer||E[P]instanceof R.SerializableObjectWithBuffers||typeof E[P]>"u")return!0;return!1}static serializeRequestArguments(E,P){if(this._useMixedArgSerialization(E)){const O=[];for(let N=0,F=E.length;N<F;N++){const x=E[N];if(x instanceof L.VSBuffer)O[N]={type:2,value:x};else if(typeof x>"u")O[N]={type:4};else if(x instanceof R.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:U}=r(x.value,P);O[N]={type:3,value:L.VSBuffer.fromString(B),buffers:U}}else O[N]={type:1,value:L.VSBuffer.fromString(c(x,P))}}return{type:1,args:O}}return{type:0,args:c(E,P)}}static serializeRequest(E,P,O,N,F){switch(N.type){case 0:return this._requestJSONArgs(E,P,O,N.args,F);case 1:return this._requestMixedArgs(E,P,O,N.args,F)}}static _requestJSONArgs(E,P,O,N,F){const x=L.VSBuffer.fromString(O),B=L.VSBuffer.fromString(N);let U=0;U+=o.sizeUInt8(),U+=o.sizeShortString(x),U+=o.sizeLongString(B);const X=o.alloc(F?2:1,E,U);return X.writeUInt8(P),X.writeShortString(x),X.writeLongString(B),X.buffer}static deserializeRequestJSONArgs(E){const P=E.readUInt8(),O=E.readShortString(),N=E.readLongString();return{rpcId:P,method:O,args:JSON.parse(N)}}static _requestMixedArgs(E,P,O,N,F){const x=L.VSBuffer.fromString(O);let B=0;B+=o.sizeUInt8(),B+=o.sizeShortString(x),B+=o.sizeMixedArray(N);const U=o.alloc(F?4:3,E,B);return U.writeUInt8(P),U.writeShortString(x),U.writeMixedArray(N),U.buffer}static deserializeRequestMixedArgs(E){const P=E.readUInt8(),O=E.readShortString(),N=E.readMixedArray(),F=new Array(N.length);for(let x=0,B=N.length;x<B;x++){const U=N[x];typeof U=="string"?F[x]=JSON.parse(U):F[x]=U}return{rpcId:P,method:O,args:F}}static serializeAcknowledged(E){return o.alloc(5,E,0).buffer}static serializeCancel(E){return o.alloc(6,E,0).buffer}static serializeReplyOK(E,P,O){if(typeof P>"u")return this._serializeReplyOKEmpty(E);if(P instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(E,P);if(P instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:F}=r(P.value,O,!0);return this._serializeReplyOKJSONWithBuffers(E,N,F)}else return this._serializeReplyOKJSON(E,p(P,O))}static _serializeReplyOKEmpty(E){return o.alloc(7,E,0).buffer}static _serializeReplyOKVSBuffer(E,P){let O=0;O+=o.sizeVSBuffer(P);const N=o.alloc(8,E,O);return N.writeVSBuffer(P),N.buffer}static deserializeReplyOKVSBuffer(E){return E.readVSBuffer()}static _serializeReplyOKJSON(E,P){const O=L.VSBuffer.fromString(P);let N=0;N+=o.sizeLongString(O);const F=o.alloc(9,E,N);return F.writeLongString(O),F.buffer}static _serializeReplyOKJSONWithBuffers(E,P,O){const N=L.VSBuffer.fromString(P);let F=0;F+=o.sizeUInt32,F+=o.sizeLongString(N);for(const B of O)F+=o.sizeVSBuffer(B);const x=o.alloc(10,E,F);x.writeUInt32(O.length),x.writeLongString(N);for(const B of O)x.writeBuffer(B);return x.buffer}static deserializeReplyOKJSON(E){const P=E.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(E,P){const O=E.readUInt32(),N=E.readLongString(),F=[];for(let x=0;x<O;++x)F.push(E.readVSBuffer());return new R.SerializableObjectWithBuffers(s(N,F,P))}static serializeReplyErr(E,P){const O=P?p(A.transformErrorForSerialization(P),null):void 0;if(typeof O!="string")return this._serializeReplyErrEmpty(E);const N=L.VSBuffer.fromString(O);let F=0;F+=o.sizeLongString(N);const x=o.alloc(11,E,F);return x.writeLongString(N),x.buffer}static deserializeReplyErrError(E){const P=E.readLongString();return JSON.parse(P)}static _serializeReplyErrEmpty(E){return o.alloc(12,E,0).buffer}}var h;(function(u){u[u.RequestJSONArgs=1]="RequestJSONArgs",u[u.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",u[u.RequestMixedArgs=3]="RequestMixedArgs",u[u.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",u[u.Acknowledged=5]="Acknowledged",u[u.Cancel=6]="Cancel",u[u.ReplyOKEmpty=7]="ReplyOKEmpty",u[u.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",u[u.ReplyOKJSON=9]="ReplyOKJSON",u[u.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",u[u.ReplyErrError=11]="ReplyErrError",u[u.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var w;(function(u){u[u.String=1]="String",u[u.VSBuffer=2]="VSBuffer",u[u.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",u[u.Undefined=4]="Undefined"})(w||(w={}))}),define(De[325],Ie([1,0,3,42,47,5]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new d.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new d.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new d.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)("outputService");var T;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.channels=new Map,this._onDidRegisterChannel=new _.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new _.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(v){this.channels.has(v.id)||(this.channels.set(v.id,v),this._onDidRegisterChannel.fire(v.id))}getChannels(){const v=[];return this.channels.forEach(R=>v.push(R)),v}getChannel(v){return this.channels.get(v)}removeChannel(v){this.channels.delete(v),this._onDidRemoveChannel.fire(v)}}L.Registry.add(e.Extensions.OutputChannels,new m),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new d.RawContextKey("activeOutputChannel","")}),define(De[145],Ie([1,0,6,5,20,25,18,325,63,26,51,171,22,14,30,3,4]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class s extends T.AbstractMessageLogger{get disposed(){return this._disposed}constructor(I,i,a,n,t){super(),this.id=I,this.name=i,this.logger=a,this.proxy=n,this.extension=t,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(a.getLevel()),this._register(a.onDidChangeLogLevel(o=>this.setLevel(o)))}get logLevel(){return this.getLevel()}appendLine(I){this.append(I+`
`)}append(I){this.info(I)}clear(){const I=this.offset;this.logger.flush(),this.proxy.$update(this.id,m.OutputChannelUpdateMode.Clear,I)}replace(I){const i=this.offset;this.info(I),this.proxy.$update(this.id,m.OutputChannelUpdateMode.Replace,i),this.visible&&this.logger.flush()}show(I,i){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof I=="boolean"?I:i))}hide(){this.proxy.$close(this.id)}log(I,i){this.offset+=p.VSBuffer.fromString(i).byteLength,(0,T.log)(this.logger,I,i),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class c extends s{appendLine(I){this.append(I)}}let f=class{constructor(I,i,a,n,t,o){this.initData=i,this.extHostFileSystem=a,this.extHostFileSystemInfo=n,this.loggerService=t,this.logService=o,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=I.getProxy(_.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(i.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(I){this.visibleChannelId=I;for(const[i,a]of this.channels)a.visible=i===this.visibleChannelId}createOutputChannel(I,i,a){if(I=I.trim(),!I)throw new Error("illegal argument `name`. must not be falsy");const n=typeof i=="object"&&i.log,t=(0,C.isString)(i)?i:void 0;if((0,C.isString)(t)&&!t.trim())throw new Error("illegal argument `languageId`. must not be empty");let o;const g=this.initData.environment.extensionLogLevel?.find(([h])=>A.ExtensionIdentifier.equals(a.identifier,h))?.[1];g&&(o=(0,T.parseLogLevel)(g));const l=n?this.doCreateLogOutputChannel(I,o,a):this.doCreateOutputChannel(I,t,a);return l.then(h=>{this.channels.set(h.id,h),h.visible=h.id===this.visibleChannelId}),n?this.createExtHostLogOutputChannel(I,o??this.logService.getLevel(),l):this.createExtHostOutputChannel(I,l)}async doCreateOutputChannel(I,i,a){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const n=await this.outputDirectoryPromise,t=this.extHostFileSystemInfo.extUri.joinPath(n,`${this.namePool++}-${I.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.loggerService.createLogger(t,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),g=await this.proxy.$register(I,t,i,a.identifier.value);return new s(g,I,o,this.proxy,a)}async doCreateLogOutputChannel(I,i,a){const n=await this.createExtensionLogDirectory(a),t=I.replace(/[\\/:\*\?"<>\|]/g,""),o=this.extHostFileSystemInfo.extUri.joinPath(n,`${t}.log`),g=`${a.identifier.value}.${t}`,l=this.loggerService.createLogger(o,{id:g,name:I,logLevel:i,extensionId:a.identifier.value});return new c(g,I,l,this.proxy,a)}createExtensionLogDirectory(I){let i=this.extensionLogDirectoryPromise.get(I.identifier.value);if(!i){const a=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,I.identifier.value);this.extensionLogDirectoryPromise.set(I.identifier.value,i=(async()=>{try{await this.extHostFileSystem.value.createDirectory(a)}catch(n){if((0,D.toFileSystemProviderErrorCode)(n)!==D.FileSystemProviderErrorCode.FileExists)throw n}return a})())}return i}createExtHostOutputChannel(I,i){let a=!1;const n=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return I},append(t){n(),i.then(o=>o.append(t))},appendLine(t){n(),i.then(o=>o.appendLine(t))},clear(){n(),i.then(t=>t.clear())},replace(t){n(),i.then(o=>o.replace(t))},show(t,o){n(),i.then(g=>g.show(t,o))},hide(){n(),i.then(t=>t.hide())},dispose(){a=!0,i.then(t=>t.dispose())}}}createExtHostLogOutputChannel(I,i,a){const n=new r.DisposableStore,t=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},o=n.add(new b.Emitter);function g(l){i=l,o.fire(l)}return a.then(l=>{n.add(l),l.logLevel!==i&&g(l.logLevel),n.add(l.onDidChangeLogLevel(h=>g(h)))}),{...this.createExtHostOutputChannel(I,a),get logLevel(){return i},onDidChangeLogLevel:o.event,trace(l,...h){t(),a.then(w=>w.trace(l,...h))},debug(l,...h){t(),a.then(w=>w.debug(l,...h))},info(l,...h){t(),a.then(w=>w.info(l,...h))},warn(l,...h){t(),a.then(w=>w.warn(l,...h))},error(l,...h){t(),a.then(w=>w.error(l,...h))},dispose(){n.dispose()}}}};e.ExtHostOutputService=f,e.ExtHostOutputService=f=Ve([$e(0,d.IExtHostRpcService),$e(1,v.IExtHostInitDataService),$e(2,y.IExtHostConsumerFileSystem),$e(3,R.IExtHostFileSystemInfo),$e(4,T.ILoggerService),$e(5,T.ILogService)],f),e.IExtHostOutputService=(0,L.createDecorator)("IExtHostOutputService")}),define(De[326],Ie([1,0,5,17]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(d){let A=1/0;for(let m=0;m<this.maxSampleCount;m++){const y=await d.getRoundTripTime();if(y===void 0)return;A=Math.min(A,y/2),await(0,L.timeout)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(A):T=this.initial.reduce((m,y)=>m+y,0)/this.initial.length,this.lastMeasurement={initial:T,current:A,average:this.average.reduce((m,y)=>m+y,0)/this.average.length,high:(()=>typeof T>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>T*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(De[327],Ie([1,0,31,15,13,11,24,2,5,245,50,270,326]),function(me,e,_,L,d,A,T,m,y,v,R,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let C=class Cn{constructor(b,r,s,c){this.localUserHome=b,this.remoteAgentService=r,this.environmentService=s,this.contextService=c,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=f?.userHome??b})()}hasValidBasename(b,r,s){return typeof r=="string"||typeof r>"u"?this.resolveOS.then(c=>this.doHasValidBasename(b,c,r)):this.doHasValidBasename(b,r,s)}doHasValidBasename(b,r,s){return b.scheme===L.Schemas.file||b.scheme===L.Schemas.vscodeRemote?(0,_.isValidBasename)(s??(0,T.basename)(b),r===1):!0}get defaultUriScheme(){return Cn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(b,r){if(b.remoteAuthority)return L.Schemas.vscodeRemote;const s=(0,v.getVirtualWorkspaceScheme)(r.getWorkspace());if(s)return s;const c=r.getWorkspace().folders[0];if(c)return c.uri.scheme;const f=r.getWorkspace().configuration;return f?f.scheme:L.Schemas.file}userHome(b){return b?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(b=>b===1?d.win32:d.posix)}async fileURI(b){let r="";if(await this.resolveOS===1&&(b=b.replace(/\\/g,"/")),b[0]==="/"&&b[1]==="/"){const c=b.indexOf("/",2);c===-1?(r=b.substring(2),b="/"):(r=b.substring(2,c),b=b.substring(c)||"/")}return m.URI.from({scheme:L.Schemas.file,authority:r,path:b,query:"",fragment:""})}};e.AbstractPathService=C,e.AbstractPathService=C=Ve([$e(1,p.IRemoteAgentService),$e(2,k.IWorkbenchEnvironmentService),$e(3,R.IWorkspaceContextService)],C)}),define(De[87],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class _{constructor(T,m){this.line=T,this.character=m}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,m){return new _(0,0)}with(T){return new _(0,0)}}e.Position=_;class L{constructor(T,m,y,v){this.isEmpty=!1,this.isSingleLine=!1,this.start=new _(T,m),this.end=new _(y,v)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new L(0,0,0,0)}with(T){return new L(0,0,0,0)}}e.Range=L;var d;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(d||(e.TextSearchCompleteMessageType=d={}))}),define(De[35],Ie([1,0,19,34,23,31,12,5,13,8,87,17]),function(me,e,_,L,d,A,T,m,y,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const p="\u27EA ",C=" characters skipped \u27EB",D=(p.length+C.length+5)*2;e.ISearchService=(0,m.createDecorator)("searchService");var b;(function($){$[$.file=0]="file",$[$.text=1]="text"})(b||(e.SearchProviderType=b={}));var r;(function($){$[$.File=1]="File",$[$.Text=2]="Text"})(r||(e.QueryType=r={}));function s($){return!!$.preview}e.resultIsMatch=s;function c($){return!!$.resource}e.isFileMatch=c;function f($){return!!$.message}e.isProgressMessage=f;var S;(function($){$[$.Normal=0]="Normal",$[$.NewSearchStarted=1]="NewSearchStarted"})(S||(e.SearchCompletionExitCode=S={}));class I{constructor(H){this.resource=H,this.results=[]}}e.FileMatch=I;class i{constructor(H,ce,re,fe){this.ranges=ce,this.webviewIndex=fe;const he=Array.isArray(ce)?ce:[ce];if(re&&re.matchLines===1&&a(he)){H=(0,T.getNLines)(H,re.matchLines);let z="",Z=0,ye=0;const Re=Math.floor(re.charsPerLine/5),ne=[];for(const ee of he){const de=Math.max(ee.startColumn-Re,0),K=ee.startColumn+re.charsPerLine;if(de>ye+Re+D){const le=p+(de-ye)+C;z+=le+H.slice(de,K),Z+=de-(ye+le.length)}else z+=H.slice(ye,K);ne.push(new t(0,ee.startColumn-Z,ee.endColumn-Z)),ye=K}this.preview={text:z,matches:Array.isArray(this.ranges)?ne:ne[0]}}else{const z=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:H,matches:(0,_.mapArrayOrNot)(ce,Z=>new n(Z.startLineNumber-z,Z.startColumn,Z.endLineNumber-z,Z.endColumn))}}}}e.TextSearchMatch=i;function a($){const H=$[0].startLineNumber;for(const ce of $)if(ce.startLineNumber!==H||ce.endLineNumber!==H)return!1;return!0}class n{constructor(H,ce,re,fe){this.startLineNumber=H,this.startColumn=ce,this.endLineNumber=re,this.endColumn=fe}}e.SearchRange=n;class t extends n{constructor(H,ce,re){super(H,ce,H,re)}}e.OneLineRange=t;var o;(function($){$.List="list",$.Tree="tree"})(o||(e.ViewMode=o={}));var g;(function($){$.Default="default",$.FileNames="fileNames",$.Type="type",$.Modified="modified",$.CountDescending="countDescending",$.CountAscending="countAscending"})(g||(e.SearchSortOrder=g={}));function l($,H=!0){const ce=$&&$.files&&$.files.exclude,re=H&&$&&$.search&&$.search.exclude;if(!ce&&!re)return;if(!ce||!re)return ce||re;let fe=Object.create(null);return fe=d.mixin(fe,d.deepClone(ce)),fe=d.mixin(fe,d.deepClone(re),!0),fe}e.getExcludes=l;function h($,H){return $.excludePattern&&L.match($.excludePattern,H)?!1:$.includePattern||$.usingSearchPaths?$.includePattern&&L.match($.includePattern,H)?!0:$.usingSearchPaths?!!$.folderQueries&&$.folderQueries.some(ce=>{const re=ce.folder.fsPath;if(A.isEqualOrParent(H,re)){const fe=y.relative(re,H);return!ce.includePattern||!!L.match(ce.includePattern,fe)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var w;(function($){$[$.unknownEncoding=1]="unknownEncoding",$[$.regexParseError=2]="regexParseError",$[$.globParseError=3]="globParseError",$[$.invalidLiteral=4]="invalidLiteral",$[$.rgProcessError=5]="rgProcessError",$[$.other=6]="other",$[$.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class u extends Error{constructor(H,ce){super(H),this.code=ce}}e.SearchError=u;function E($){const H=$.message;if((0,v.isCancellationError)($))return new u(H,w.canceled);try{const ce=JSON.parse(H);return new u(ce.message,ce.code)}catch{return new u(H,w.other)}}e.deserializeSearchError=E;function P($){const H={message:$.message,code:$.code};return new Error(JSON.stringify(H))}e.serializeSearchError=P;function O($){return $.type==="error"?!0:$.type==="success"}e.isSerializedSearchComplete=O;function N($){return $.type==="success"}e.isSerializedSearchSuccess=N;function F($){return!!$.path}e.isSerializedFileMatch=F;function x($,H){const ce=$.searchPath?$.searchPath:$.relativePath;return(0,T.fuzzyContains)(ce,H)}e.isFilePatternMatch=x;class B{constructor(H){this.path=H,this.results=[]}addMatch(H){this.results.push(H)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=B;function U($,H){const ce={...$||{},...H||{}};return Object.keys(ce).filter(re=>{const fe=ce[re];return typeof fe=="boolean"&&fe})}e.resolvePatternsForProvider=U;class X{constructor(H,ce){this._parsedIncludeExpression=null,this._excludeExpression={...H.excludePattern||{},...ce.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let re=H.includePattern;ce.includePattern&&(re?re={...re,...ce.includePattern}:re=ce.includePattern),re&&(this._parsedIncludeExpression=L.parse(re))}matchesExcludesSync(H,ce,re){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(H,ce,re))}includedInQuerySync(H,ce,re){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(H,ce,re)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(H,ce,re))}includedInQuery(H,ce,re){const fe=this._parsedExcludeExpression(H,ce,re),he=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(H,ce,re):!0;return(0,k.isThenable)(fe)?fe.then(z=>z?!1:he()):he()}hasSiblingExcludeClauses(){return j(this._excludeExpression)}}e.QueryGlobTester=X;function j($){for(const H in $)if(typeof $[H]!="boolean")return!0;return!1}function ge($){if(!$)return;let H;return ce=>(H||(H=($()||Promise.resolve([])).then(re=>re?te(re):{})),H.then(re=>!!re[ce]))}e.hasSiblingPromiseFn=ge;function ie($){if(!$)return;let H;return ce=>{if(!H){const re=$();H=re?te(re):{}}return!!H[ce]}}e.hasSiblingFn=ie;function te($){const H={};for(const ce of $)H[ce]=!0;return H}}),define(De[37],Ie([1,0,19,17,21,3,4,71,15,112,24,12,14,2,204,5,18,232,50,51,26,20,16,7,58,35,6]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c,f,S,I,i,a,n,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function g(N,F,x){return new R.ExtUri(B=>u(B,x)).isEqual(N,F)}function l(N,F,x){return g(N.uri,F.uri,x)?0:(0,k.compare)(N.uri.toString(),F.uri.toString())}function h(N,F,x){return N.index!==F.index?N.index<F.index?-1:1:g(N.uri,F.uri,x)?(0,k.compare)(N.name,F.name):(0,k.compare)(N.uri.toString(),F.uri.toString())}function w(N,F,x,B){const U=N.slice(0).sort((j,ge)=>x(j,ge,B)),X=F.slice(0).sort((j,ge)=>x(j,ge,B));return(0,_.delta)(U,X,(j,ge)=>x(j,ge,B))}function u(N,F){const x=F.getCapabilities(N.scheme);return!(x&&x&1024)}class E extends c.Workspace{static toExtHostWorkspace(F,x,B,U){if(!F)return{workspace:null,added:[],removed:[]};const{id:X,name:j,folders:ge,configuration:ie,transient:te,isUntitled:$}=F,H=[],ce=x;x?ge.forEach((z,Z)=>{const ye=C.URI.revive(z.uri),Re=E._findFolder(B||x,ye,U);Re?(Re.name=z.name,Re.index=z.index,H.push(Re)):H.push({uri:ye,name:z.name,index:Z})}):H.push(...ge.map(({uri:z,name:Z,index:ye})=>({uri:C.URI.revive(z),name:Z,index:ye}))),H.sort((z,Z)=>z.index<Z.index?-1:1);const re=new E(X,j,H,!!te,ie?C.URI.revive(ie):null,!!$,z=>u(z,U)),{added:fe,removed:he}=w(ce?ce.workspaceFolders:[],re.workspaceFolders,l,U);return{workspace:re,added:fe,removed:he}}static _findFolder(F,x,B){for(let U=0;U<F.folders.length;U++){const X=F.workspaceFolders[U];if(g(X.uri,x,B))return X}}constructor(F,x,B,U,X,j,ge){super(F,B.map(ie=>new c.WorkspaceFolder(ie)),U,X,ge),this._name=x,this._isUntitled=j,this._workspaceFolders=[],this._structure=m.TernarySearchTree.forUris(ge),B.forEach(ie=>{this._workspaceFolders.push(ie),this._structure.set(ie.uri,ie)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,x){return x&&this._structure.get(F)&&(F=(0,R.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let P=class{constructor(F,x,B,U,X){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new A.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=U,this._extHostFileSystemInfo=B,this._uriTransformerService=X,this._requestIdProvider=new v.Counter,this._barrier=new L.Barrier,this._proxy=F.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(o.MainContext.MainThreadMessageService);const j=x.workspace;this._confirmedWorkspace=j?new E(j.id,j.name,[],!!j.transient,j.configuration?C.URI.revive(j.configuration):null,!!j.isUntitled,ge=>u(ge,B)):void 0}$initializeWorkspace(F,x){this._trusted=x,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?C.URI.from({scheme:y.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,x,B,...U){const X=[];if(Array.isArray(U)&&U.forEach($=>{C.URI.isUri($.uri)&&!X.some(H=>g(H.uri,$.uri,this._extHostFileSystemInfo))&&X.push({uri:$.uri,name:$.name||(0,R.basenameOrAuthority)($.uri)})}),this._unconfirmedWorkspace||[x,B].some($=>typeof $!="number"||$<0)||B===0&&X.length===0)return!1;const j=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+B>j.length)return!1;const ge=j.slice(0);ge.splice(x,B,...X.map($=>({uri:$.uri,name:$.name||(0,R.basenameOrAuthority)($.uri),index:void 0})));for(let $=0;$<ge.length;$++){const H=ge[$];if(ge.some((ce,re)=>re!==$&&g(H.uri,ce.uri,this._extHostFileSystemInfo)))return!1}ge.forEach(($,H)=>$.index=H);const{added:ie,removed:te}=w(j,ge,h,this._extHostFileSystemInfo);if(ie.length===0&&te.length===0)return!1;if(this._proxy){const $=F.displayName||F.name;this._proxy.$updateWorkspaceFolders($,x,B,X).then(void 0,H=>{this._unconfirmedWorkspace=void 0;const ce={source:{identifier:F.identifier,label:F.displayName||F.name}};this._messageService.$showMessage(s.Severity.Error,(0,D.localize)(0,null,$,H.toString()),ce,[])})}return this.trySetWorkspaceFolders(ge),!0}getWorkspaceFolder(F,x){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async getWorkspaceFolder2(F,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!this._actualWorkspace)return;const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,x){let B,U="";if(typeof F=="string"?(B=C.URI.file(F),U=F):typeof F<"u"&&(B=F,U=F.fsPath),!B)return U;const X=this.getWorkspaceFolder(B,!0);if(!X)return U;typeof x>"u"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let j=(0,R.relativePath)(X.uri,B);return x&&X.name&&(j=`${X.name}/${j}`),j}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=E.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:x,added:B,removed:U}=E.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:U}))}findFiles(F,x,B,U,X=d.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let j;if(x===null?j=!1:x&&(typeof x=="string"?j=x:j=x.pattern),X&&X.isCancellationRequested)return Promise.resolve([]);const{includePattern:ge,folder:ie}=O(i.GlobPattern.from(F));return this._proxy.$startFileSearch((0,p.withUndefinedAsNull)(ge),(0,p.withUndefinedAsNull)(ie),(0,p.withUndefinedAsNull)(j),(0,p.withUndefinedAsNull)(B),X).then(te=>Array.isArray(te)?te.map($=>C.URI.revive($)):[])}async findTextInFiles(F,x,B,U,X=d.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const j=this._requestIdProvider.getNext(),ge=typeof x.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:ie,folder:te}=O(i.GlobPattern.from(x.include)),$=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,H={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof x.useParentIgnoreFiles=="boolean"?!x.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:ge,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:ie,excludePattern:$},ce=!1;if(this._activeSearchCallbacks[j]=re=>{if(ce)return;const fe=C.URI.revive(re.resource);re.results.forEach(he=>{(0,t.resultIsMatch)(he)?B({uri:fe,preview:{text:he.preview.text,matches:(0,_.mapArrayOrNot)(he.preview.matches,z=>new a.Range(z.startLineNumber,z.startColumn,z.endLineNumber,z.endColumn))},ranges:(0,_.mapArrayOrNot)(he.ranges,z=>new a.Range(z.startLineNumber,z.startColumn,z.endLineNumber,z.endColumn))}):B({uri:fe,text:he.text,lineNumber:he.lineNumber})})},X.isCancellationRequested)return{};try{const re=await this._proxy.$startTextSearch(F,(0,p.withUndefinedAsNull)(te),H,j,X);return delete this._activeSearchCallbacks[j],re||{}}catch(re){throw delete this._activeSearchCallbacks[j],re}}$handleTextSearchResult(F,x){this._activeSearchCallbacks[x]?.(F)}async save(F){const x=await this._proxy.$save(F,{saveAs:!1});return C.URI.revive(x)}async saveAs(F){const x=await this._proxy.$save(F,{saveAs:!0});return C.URI.revive(x)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(F,x){if(this._editSessionIdentityProviders.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this._editSessionIdentityProviders.set(F,x);const B=this._uriTransformerService.transformOutgoingScheme(F),U=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(U,B),(0,T.toDisposable)(()=>{this._editSessionIdentityProviders.delete(F),this._proxy.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(F,x){this._logService.info("Getting edit session identifier for workspaceFolder",F);const B=await this.resolveWorkspaceFolder(C.URI.revive(F));if(!B){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const U=this._editSessionIdentityProviders.get(B.uri.scheme);if(this._logService.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!U),!U)return;const X=await U.provideEditSessionIdentity(B,x);if(this._logService.info("Provider returned edit session identifier: ",X),!!X)return X}async $provideEditSessionIdentityMatch(F,x,B,U){this._logService.info("Getting edit session identifier for workspaceFolder",F);const X=await this.resolveWorkspaceFolder(C.URI.revive(F));if(!X){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",X);const j=this._editSessionIdentityProviders.get(X.uri.scheme);if(this._logService.info(`Provider for scheme ${X.uri.scheme} is defined: `,!!j),!j)return;const ge=await j.provideEditSessionIdentityMatch?.(x,B,U);if(this._logService.info("Provider returned edit session identifier match result: ",ge),!!ge)return ge}getOnWillCreateEditSessionIdentityEvent(F){return(x,B,U)=>{const X=function(ge){x.call(B,ge)};return X.extension=F,this._onWillCreateEditSessionIdentityEvent.event(X,void 0,U)}}async $onWillCreateEditSessionIdentity(F,x,B){const U=await this.resolveWorkspaceFolder(C.URI.revive(F));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:U},x,async(X,j)=>{const ge=Date.now();await Promise.resolve(X),Date.now()-ge>B&&this._logService.warn("SLOW edit session create-participant",j.extension.identifier)}),x.isCancellationRequested}registerCanonicalUriProvider(F,x){if(this._canonicalUriProviders.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this._canonicalUriProviders.set(F,x);const B=this._uriTransformerService.transformOutgoingScheme(F),U=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(U,B),(0,T.toDisposable)(()=>{this._canonicalUriProviders.delete(F),this._proxy.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(F,x,B){const U=this._canonicalUriProviders.get(F.scheme);if(!U)return;const X=await U.provideCanonicalUri?.(C.URI.revive(F),x,B);if(X)return X}async $provideCanonicalUri(F,x,B){return this.provideCanonicalUri(C.URI.revive(F),{targetScheme:x},B)}};e.ExtHostWorkspace=P,e.ExtHostWorkspace=P=Ve([$e(0,I.IExtHostRpcService),$e(1,S.IExtHostInitDataService),$e(2,f.IExtHostFileSystemInfo),$e(3,r.ILogService),$e(4,n.IURITransformerService)],P),e.IExtHostWorkspace=(0,b.createDecorator)("IExtHostWorkspace");function O(N){let F,x;return N&&(typeof N=="string"?F=N:(F=N.pattern,x=C.URI.revive(N.baseUri))),{includePattern:F,folder:x}}}),define(De[38],Ie([1,0,23,3,37,6,7,235,129,14,17,5,20,18,2]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function b(a,n){if(n){const t=n.split(".");let o=a;for(let g=0;o&&g<t.length;g++)o=o[t[g]];return o}}function r(a){return a instanceof D.URI}function s(a){return a&&a.uri instanceof D.URI&&a.languageId&&typeof a.languageId=="string"}function c(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function f(a){return a&&a.uri instanceof D.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function S(a){if(r(a))return{resource:a};if(s(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(c(a))return{overrideIdentifier:a.languageId};if(f(a))return{resource:a.uri};if(a===null)return{resource:null}}let I=class{constructor(n,t,o){this._proxy=n.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=o,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new i(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,t){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(n,t))}};e.ExtHostConfiguration=I,e.ExtHostConfiguration=I=Ve([$e(0,p.IExtHostRpcService),$e(1,d.IExtHostWorkspace),$e(2,C.ILogService)],I);class i{constructor(n,t,o,g){this._onDidChangeConfiguration=new L.Emitter,this._proxy=n,this._logService=g,this._extHostWorkspace=t,this._configuration=m.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,t){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=m.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,o))}getConfiguration(n,t,o){const g=S(t)||{},l=this._toReadonlyValue(n?b(this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,g,o?.identifier);function h(u){if(u==null)return null;if(typeof u=="boolean")return u?2:5;switch(u){case T.ConfigurationTarget.Global:return 2;case T.ConfigurationTarget.Workspace:return 5;case T.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(u){return typeof b(l,u)<"u"},get:(u,E)=>{this._validateConfigurationAccess(n?`${n}.${u}`:u,g,o?.identifier);let P=b(l,u);if(typeof P>"u")P=E;else{let O;const N=(F,x)=>{if((0,v.isObject)(F)){let B;const U=()=>{O=O||(0,_.deepClone)(l),B=B||b(O,x)};return new Proxy(F,{get:(X,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return U(),()=>B;if(O)return B=B||b(O,x),B[j];const ge=X[j];return typeof j=="string"?N(ge,`${x}.${j}`):ge},set:(X,j,ge)=>(U(),B&&(B[j]=ge),!0),deleteProperty:(X,j)=>(U(),B&&delete B[j],!0),defineProperty:(X,j,ge)=>(U(),B&&Object.defineProperty(B,j,ge),!0)})}return Array.isArray(F)?(0,_.deepClone)(F):F};P=N(P,u)}return P},update:(u,E,P,O)=>{u=n?`${n}.${u}`:u;const N=h(P);return E!==void 0?this._proxy.$updateConfigurationOption(N,u,E,g,O):this._proxy.$removeConfigurationOption(N,u,g,O)},inspect:u=>{u=n?`${n}.${u}`:u;const E=this._configuration.inspect(u,g,this._extHostWorkspace.workspace);if(E)return{key:u,defaultValue:(0,_.deepClone)(E.policy?.value??E.default?.value),globalValue:(0,_.deepClone)(E.user?.value??E.application?.value),workspaceValue:(0,_.deepClone)(E.workspace?.value),workspaceFolderValue:(0,_.deepClone)(E.workspaceFolder?.value),defaultLanguageValue:(0,_.deepClone)(E.default?.override),globalLanguageValue:(0,_.deepClone)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,_.deepClone)(E.workspace?.override),workspaceFolderLanguageValue:(0,_.deepClone)(E.workspaceFolder?.override),languageIds:(0,_.deepClone)(E.overrideIdentifiers)}}};return typeof l=="object"&&(0,_.mixin)(w,l,!1),Object.freeze(w)}_toReadonlyValue(n){const t=o=>(0,v.isObject)(o)?new Proxy(o,{get:(g,l)=>t(g[l]),set:(g,l,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(g,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(g,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return t(n)}_validateConfigurationAccess(n,t,o){const g=y.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),l=o?`[${o.value}] `:"";if(g===4){typeof t?.resource>"u"&&this._logService.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){t?.resource&&this._logService.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,t){const o=new m.ConfigurationChangeEvent(n,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(g,l)=>o.affectsConfiguration(g,S(l))})}_toMap(n){return n.reduce((t,o)=>(t.set(o[0],o[1]),t),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")}),define(De[88],Ie([1,0,2,17,3,6,7,37,61,38,21,43,20,26,5,15,11,18,84,277,8]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var I;(function(N){function F(B){if(B!=null)return B}N.from=F;function x(B){if(B!=null)return B}N.to=x})(I||(I={}));var i;(function(N){function F(B){if(B!=null)return B}N.from=F;function x(B){if(B!=null)return B}N.to=x})(i||(i={}));var a;(function(N){function F(B){if(B!=null)return B}N.from=F;function x(B){if(B!=null)return B}N.to=x})(a||(a={}));var n;(function(N){function F(U){if(U){const X=U;return X&&!!X.process}else return!1}N.is=F;function x(U){if(U==null)return;const X={process:U.process,args:U.args};return U.options&&(X.options=a.from(U.options)),X}N.from=x;function B(U){if(U!=null)return new T.ProcessExecution(U.process,U.args,U.options)}N.to=B})(n||(n={}));var t;(function(N){function F(B){if(B!=null)return B}N.from=F;function x(B){if(B!=null)return B}N.to=x})(t||(t={}));var o;(function(N){function F(U){if(U){const X=U;return X&&(!!X.commandLine||!!X.command)}else return!1}N.is=F;function x(U){if(U==null)return;const X={};return U.commandLine!==void 0?X.commandLine=U.commandLine:(X.command=U.command,X.args=U.args),U.options&&(X.options=t.from(U.options)),X}N.from=x;function B(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new T.ShellExecution(U.commandLine,U.options):new T.ShellExecution(U.command,U.args?U.args:[],U.options)}N.to=B})(o||(o={}));var g;(function(N){function F(U){if(U){const X=U;return X&&X.customExecution==="customExecution"}else return!1}N.is=F;function x(U){return{customExecution:"customExecution"}}N.from=x;function B(U,X){return X.get(U)}N.to=B})(g||(e.CustomExecutionDTO=g={}));var l;(function(N){function F(x,B){let U;return x.scope!==void 0&&typeof x.scope!="number"?U=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===T.TaskScope.Workspace&&B&&B.workspaceFile?U=B.workspaceFile:U=f.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:U}}N.from=F})(l||(e.TaskHandleDTO=l={}));var h;(function(N){function F(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}N.from=F})(h||(h={}));var w;(function(N){function F(U,X){if(U==null)return[];const j=[];for(const ge of U){const ie=x(ge,X);ie&&j.push(ie)}return j}N.fromMany=F;function x(U,X){if(U==null)return;let j;U.execution instanceof T.ProcessExecution?j=n.from(U.execution):U.execution instanceof T.ShellExecution?j=o.from(U.execution):U.execution&&U.execution instanceof T.CustomExecution&&(j=g.from(U.execution));const ge=I.from(U.definition);let ie;return U.scope?typeof U.scope=="number"?ie=U.scope:ie=U.scope.uri:ie=T.TaskScope.Workspace,!ge||!ie?void 0:{_id:U._id,definition:ge,name:U.name,source:{extensionId:X.identifier.value,label:U.source,scope:ie},execution:j,isBackground:U.isBackground,group:h.from(U.group),presentationOptions:i.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}N.from=x;async function B(U,X,j){if(U==null)return;let ge;n.is(U.execution)?ge=n.to(U.execution):o.is(U.execution)?ge=o.to(U.execution):g.is(U.execution)&&(ge=g.to(U._id,j));const ie=I.to(U.definition);let te;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?te=U.source.scope:te=await X.resolveWorkspaceFolder(_.URI.revive(U.source.scope)):te=T.TaskScope.Workspace),!ie||!te)return;const $=new T.Task(ie,te,U.name,U.source.label,ge,U.problemMatchers);return U.isBackground!==void 0&&($.isBackground=U.isBackground),U.group!==void 0&&($.group=T.TaskGroup.from(U.group._id),$.group&&U.group.isDefault&&($.group=new T.TaskGroup($.group.id,$.group.label),U.group.isDefault===!0&&($.group.isDefault=U.group.isDefault))),U.presentationOptions&&($.presentationOptions=i.to(U.presentationOptions)),U._id&&($._id=U._id),U.detail&&($.detail=U.detail),$}N.to=B})(w||(e.TaskDTO=w={}));var u;(function(N){function F(B){return B}N.from=F;function x(B){if(B)return Object.assign(Object.create(null),B)}N.to=x})(u||(u={}));class E{#e;constructor(F,x,B){this._id=x,this._task=B,this.#e=F}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let P=class{constructor(F,x,B,U,X,j,ge,ie){this._onDidExecuteTask=new d.Emitter,this._onDidTerminateTask=new d.Emitter,this._onDidTaskProcessStarted=new d.Emitter,this._onDidTaskProcessEnded=new d.Emitter,this._proxy=F.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=B,this._editorService=U,this._configurationService=X,this._terminalService=j,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ge,this._deprecationService=ie,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(F,x,B){if(!B)return new T.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:x,provider:B,extension:F}),this._proxy.$registerTaskProvider(U,x),new T.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(F,x){this._proxy.$registerTaskSystem(F,x)}fetchTasks(F){return this._proxy.$fetchTasks(u.from(F)).then(async x=>{const B=[];for(const U of x){const X=await w.to(U,this._workspaceProvider,this._providedCustomExecutions2);X&&B.push(X)}return B})}get taskExecutions(){const F=[];return this._taskExecutions.forEach(x=>F.push(x)),F}terminateTask(F){if(!(F instanceof E))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(F._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(F,x,B){const U=this._providedCustomExecutions2.get(F.id);U&&(this._activeCustomExecutions2.set(F.id,U),this._terminalService.attachPtyToTerminal(x,await U.callback(B))),this._lastStartedTask=F.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(F)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(F){const x=await this.getTaskExecution(F);this._taskExecutionPromises.delete(F.id),this._taskExecutions.delete(F.id),this.customExecutionComplete(F),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(F){const x=await this.getTaskExecution(F.id);this._onDidTaskProcessStarted.fire({execution:x,processId:F.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(F){const x=await this.getTaskExecution(F.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:F.exitCode})}$provideTasks(F,x){const B=this._handlers.get(F);if(!B)return Promise.reject(new Error("no handler found"));const U=[],X=(0,L.asPromise)(()=>B.provider.provideTasks(R.CancellationToken.None)).then(j=>this.provideTasksInternal(x,U,B,j));return new Promise(j=>{X.then(ge=>{Promise.all(U).then(()=>{j(ge)})})})}async $resolveTask(F,x){const B=this._handlers.get(F);if(!B)return Promise.reject(new Error("no handler found"));if(x.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${B.type}].`);const U=await w.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const X=await B.provider.resolveTask(U,R.CancellationToken.None);if(!X)return;this.checkDeprecation(X,B);const j=w.from(X,B.extension);if(!j)throw new Error("Unexpected: Task cannot be resolved.");if(X.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(j.execution)&&await this.addCustomExecution(j,X,!0),await this.resolveTaskInternal(j)}nextHandle(){return this._handleCounter++}async addCustomExecution(F,x,B){const U=await this._proxy.$createTaskId(F);!B&&!this._providedCustomExecutions2.has(U)&&(this._notProvidedCustomExecutions.add(U),this._activeCustomExecutions2.set(U,x.execution)),this._providedCustomExecutions2.set(U,x.execution)}async getTaskExecution(F,x){if(typeof F=="string"){const X=this._taskExecutionPromises.get(F);if(!X)throw new S.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return X}const B=this._taskExecutionPromises.get(F.id);if(B)return B;const U=new Promise((X,j)=>{function ge(ie,te,$){$?X(new E(ie,te.id,$)):j("Unexpected: Task does not exist.")}x?ge(this,F,x):w.to(F.task,this._workspaceProvider,this._providedCustomExecutions2).then(ie=>ge(this,F,ie))});return this._taskExecutionPromises.set(F.id,U),U.then(X=>(this._taskExecutions.set(F.id,X),X),X=>Promise.reject(X))}checkDeprecation(F,x){F._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(F){this._activeCustomExecutions2.get(F.id)&&this._activeCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.has(F.id)&&this._lastStartedTask!==F.id&&(this._providedCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.delete(F.id));const B=this._notProvidedCustomExecutions.values();let U=B.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=B.next()}};e.ExtHostTaskBase=P,e.ExtHostTaskBase=P=Ve([$e(0,p.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,m.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,v.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,s.ILogService),$e(7,c.IExtHostApiDeprecationService)],P);let O=class extends P{constructor(F,x,B,U,X,j,ge,ie){super(F,x,B,U,X,j,ge,ie),this.registerTaskSystem(b.Schemas.vscodeRemote,{scheme:b.Schemas.vscodeRemote,authority:"",platform:r.PlatformToString(0)})}async executeTask(F,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const B=w.from(x,F);if(B===void 0)throw new Error("Task is not valid");if(g.is(B.execution))await this.addCustomExecution(B,x,!1);else throw new S.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(B),x);return this._proxy.$executeTask(B).catch(X=>{throw new Error(X)}),U}provideTasksInternal(F,x,B,U){const X=[];if(U)for(const j of U){this.checkDeprecation(j,B),(!j.definition||!F[j.definition.type])&&this._logService.warn(`The task [${j.source}, ${j.name}] uses an undefined task type. The task will be ignored in the future.`);const ge=w.from(j,B.extension);ge&&g.is(ge.execution)?(X.push(ge),x.push(this.addCustomExecution(ge,j,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:X,extension:B.extension}}async resolveTaskInternal(F){if(g.is(F.execution))return F;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(F,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,x,B){}};e.WorkerExtHostTask=O,e.WorkerExtHostTask=O=Ve([$e(0,p.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,m.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,v.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,s.ILogService),$e(7,c.IExtHostApiDeprecationService)],O),e.IExtHostTask=(0,D.createDecorator)("IExtHostTask")}),define(De[328],Ie([1,0,13,21,45,34,24,39,35]),function(me,e,_,L,d,A,T,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class v{constructor(p,C,D){this.config=p,this.provider=C,this.sessionToken=D,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=p.filePattern,this.includePattern=p.includePattern&&A.parse(p.includePattern),this.maxResults=p.maxResults||void 0,this.exists=p.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=p.excludePattern&&A.parse(p.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(p=>p.cancel()),this.activeCancellationTokens=new Set}search(p){const C=this.config.folderQueries||[];return new Promise((D,b)=>{const r=s=>{this.resultCount++,p(s)};if(this.isCanceled)return D({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(s=>{const c=s.toString(),f=_.basename(c);this.globalExcludePattern&&this.globalExcludePattern(c,f)||this.matchFile(r,{base:s,basename:f})}),Promise.all(C.map(s=>this.searchInFolder(s,r))).then(s=>{D({limitHit:this.isLimitHit,stats:s[0]||void 0})},s=>{b(new Error((0,d.toErrorMessage)(s)))})})}async searchInFolder(p,C){const D=new L.CancellationTokenSource,b=this.getSearchOptionsForFolder(p),r=this.initDirectoryTree(),s=new y.QueryGlobTester(this.config,p),c=!s.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(D),f=m.StopWatch.create();const S=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},b,D.token),I=f.elapsed(),i=m.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(S&&S.forEach(a=>{const n=_.posix.relative(p.folder.path,a.path);if(c){const t=_.basename(a.path);this.matchFile(C,{base:p.folder,relativePath:n,basename:t});return}this.addDirectoryEntries(r,p.folder,n,C)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(r,s,C),{providerTime:I,postProcessTime:i.elapsed()})}finally{D.dispose(),this.activeCancellationTokens.delete(D)}}getSearchOptionsForFolder(p){const C=(0,y.resolvePatternsForProvider)(this.config.includePattern,p.includePattern),D=(0,y.resolvePatternsForProvider)(this.config.excludePattern,p.excludePattern);return{folder:p.folder,excludes:D,includes:C,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}addDirectoryEntries({pathToEntries:p},C,D,b){if(D===this.filePattern){const s=_.basename(this.filePattern);this.matchFile(b,{base:C,relativePath:this.filePattern,basename:s})}function r(s){const c=_.basename(s),f=_.dirname(s);let S=p[f];S||(S=p[f]=[],r(f)),S.push({base:C,relativePath:s,basename:c})}r(D)}matchDirectoryTree({rootEntries:p,pathToEntries:C},D,b){const r=this,s=this.filePattern;function c(f){const S=(0,y.hasSiblingFn)(()=>f.map(I=>I.basename));for(let I=0,i=f.length;I<i;I++){const a=f[I],{relativePath:n,basename:t}=a;if(D.matchesExcludesSync(n,t,s!==t?S:void 0))continue;const o=C[n];if(o)c(o);else{if(n===s)continue;r.matchFile(b,a)}if(r.isLimitHit)break}}c(p)}matchFile(p,C){(!this.includePattern||C.relativePath&&this.includePattern(C.relativePath,C.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||p(C))}}class R{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(p,C,D,b){const r=this.getSessionTokenSource(p.cacheKey),s=new v(p,C,r&&r.token);let c=0;const f=S=>{c+=S.length,D(S.map(I=>this.rawMatchToSearchItem(I)))};return this.doSearch(s,R.BATCH_SIZE,f,b).then(S=>({limitHit:S.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:S.stats}}))}clearCache(p){this.getSessionTokenSource(p)?.cancel()}getSessionTokenSource(p){if(p)return this.sessions.has(p)||this.sessions.set(p,new L.CancellationTokenSource),this.sessions.get(p)}rawMatchToSearchItem(p){return p.relativePath?{resource:T.joinPath(p.base,p.relativePath)}:{resource:p.base}}doSearch(p,C,D,b){b.onCancellationRequested(()=>{p.cancel()});const r=c=>{c&&(s.push(c),C>0&&s.length>=C&&(D(s),s=[]))};let s=[];return p.search(r).then(c=>(s.length&&D(s),c),c=>(s.length&&D(s),Promise.reject(c)))}}e.FileSearchManager=R}),define(De[329],Ie([1,0,19,65,34,120,28,15,13,24,12,14,2,165,215,57,18,50,137,327,35]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let I=class{constructor(u,E,P,O,N){this.configurationService=u,this.workspaceContextService=E,this.editorGroupsService=P,this.logService=O,this.pathService=N}text(u,E,P={}){u=this.getContentPattern(u,P);const O=this.configurationService.getValue(),N=E&&E.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(E?.map(s.toWorkspaceFolder),P),type:2,contentPattern:u,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:O.search.usePCRE2||N||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}getContentPattern(u,E){const P=this.configurationService.getValue();u.isRegExp&&(u.pattern=u.pattern.replace(/\r?\n/g,"\\n"));const O={...u,wordSeparators:P.editor.wordSeparators};return this.isCaseSensitive(u,E)&&(O.isCaseSensitive=!0),this.isMultiline(u)&&(O.isMultiline=!0),E.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=E.notebookSearchConfig.includeMarkupInput),E.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=E.notebookSearchConfig.includeMarkupPreview),E.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=E.notebookSearchConfig.includeCodeInput),E.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=E.notebookSearchConfig.includeOutput),O}file(u,E={}){return{...this.commonQuery(u,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}handleIncludeExclude(u,E){return u?(u=Array.isArray(u)?u.map(o):o(u),E?this.parseSearchPaths(u):{pattern:a(...Array.isArray(u)?u:[u])}):{}}commonQuery(u=[],E={}){const P=this.handleIncludeExclude(E.includePattern,E.expandPatterns),O=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),N=u.length>1,F=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,E,O)):u.map(U=>this.getFolderQueryForRoot(U,E,O,N))).filter(U=>!!U),x={_reason:E._reason,folderQueries:F,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:O.pattern,includePattern:P.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const U=_.coalesce(_.flatten(this.editorGroupsService.groups.map(ge=>ge.editors.map(ie=>ie.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const X=U.filter(ge=>(0,S.pathIncludedInQuery)(x,ge.fsPath)),j=this.commonQueryFromFileList(X);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(j)),{...x,...j}}const B=E.extraFileResources&&E.extraFileResources.filter(U=>(0,S.pathIncludedInQuery)(x,U.fsPath));return x.extraFileResources=B&&B.length?B:void 0,x}commonQueryFromFileList(u){const E=[],P=new T.ResourceMap,O={};let N=!1;return u.forEach(F=>{if(F.scheme===m.Schemas.walkThrough)return;if((0,v.isAbsolutePath)(F)){const B=this.workspaceContextService.getWorkspaceFolder(F)?.uri??F.with({path:y.dirname(F.fsPath)});let U=P.get(B);U||(N=!0,U={folder:B,includePattern:{}},E.push(U),P.set(B,U));const X=y.relative(B.fsPath,F.fsPath);(0,k.assertIsDefined)(U.includePattern)[X.replace(/\\/g,"/")]=!0}else F.fsPath&&(N=!0,O[F.fsPath]=!0)}),{folderQueries:E,includePattern:O,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(u,E){if(E.isSmartCase){if(u.isRegExp){if(R.containsUppercaseCharacter(u.pattern,!0))return!0}else if(R.containsUppercaseCharacter(u.pattern))return!0}return!!u.isCaseSensitive}isMultiline(u){return u.isMultiline||u.isRegExp&&(0,C.isMultilineRegexSource)(u.pattern)||u.pattern.indexOf(`
`)>=0?!0:!!u.isMultiline}parseSearchPaths(u){const E=j=>y.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),O=(Array.isArray(u)?u:n(u)).map(j=>{const ge=this.pathService.resolvedUserHome;return ge?(0,A.untildify)(j,ge.scheme===m.Schemas.file?ge.fsPath:ge.path):j}),N=L.groupBy(O,j=>E(j)?"searchPaths":"exprSegments"),F=(N.exprSegments||[]).map(j=>R.rtrim(j,"/")).map(j=>R.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),t(j))),x={},B=this.expandSearchPathPatterns(N.searchPaths||[]);B&&B.length&&(x.searchPaths=B);const U=_.flatten(F),X=a(...U);return X&&(x.pattern=X),x}getExcludesForFolder(u,E){return E.disregardExcludeSettings?void 0:(0,S.getExcludes)(u,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(u){if(!u||!u.length)return[];const E=u.flatMap(O=>{let{pathPortion:N,globPortion:F}=i(O);return F&&(F=g(F)),this.expandOneSearchPath(N).flatMap(B=>this.resolveOneSearchPathPattern(B,F))}),P=new Map;return E.forEach(O=>{const N=O.searchPath.toString(),F=P.get(N);F?O.pattern&&(F.pattern=F.pattern||{},F.pattern[O.pattern]=!0):P.set(N,{searchPath:O.searchPath,pattern:O.pattern?a(O.pattern):void 0})}),Array.from(P.values())}expandOneSearchPath(u){if(y.isAbsolute(u)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==m.Schemas.file?[{searchPath:E[0].uri.with({path:u})}]:[{searchPath:p.URI.file(y.normalize(u))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(u=o(u),u.startsWith("../")||u===".."){const O=y.posix.resolve(E.path,u);return[{searchPath:E.with({path:O})}]}const P=g(u);return[{searchPath:E,pattern:P}]}else{if(u==="./"||u===".\\")return[];{const E=u.replace(/^\.[\/\\]/,""),O=this.workspaceContextService.getWorkspace().folders.map(N=>{const F=E.match(new RegExp(`^${R.escapeRegExpCharacters(N.name)}(?:/(.*)|$)`));return F?{match:F,folder:N}:null}).filter(k.isDefined);if(O.length)return O.map(N=>{const F=N.match[1];return{searchPath:N.folder.uri,pattern:F&&g(F)}});{const N=u.match(/\.[\/\\](.+)[\/\\]?/),F=N?N[1]:u,x=D.localize(0,null,F);throw new Error(x)}}}}resolveOneSearchPathPattern(u,E){const P=u.pattern&&E?`${u.pattern}/${E}`:u.pattern||E,O=[{searchPath:u.searchPath,pattern:P}];return P&&!P.endsWith("**")&&O.push({searchPath:u.searchPath,pattern:P+"/**"}),O}getFolderQueryForSearchPath(u,E,P){const O=this.getFolderQueryForRoot((0,s.toWorkspaceFolder)(u.searchPath),E,P,!1);return O?{...O,includePattern:u.pattern}:null}getFolderQueryForRoot(u,E,P,O){let N;const F=p.URI.isUri(u)?u:u.uri;if(P.searchPaths){const j=P.searchPaths.filter(ge=>(0,v.isEqual)(ge.searchPath,F))[0];if(j&&!j.pattern)return null;j&&(N=j.pattern)}const x=this.configurationService.getValue({resource:F}),U={...this.getExcludesForFolder(x,E)||{},...N||{}},X=p.URI.isUri(u)?(0,v.basename)(u):u.name;return{folder:F,folderName:O?X:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!x.search.followSymlinks}}};e.QueryBuilder=I,e.QueryBuilder=I=Ve([$e(0,b.IConfigurationService),$e(1,s.IWorkspaceContextService),$e(2,c.IEditorGroupsService),$e(3,r.ILogService),$e(4,f.IPathService)],I);function i(w){const u=w.match(/[\*\{\}\(\)\[\]\?]/);if(u){const E=u.index,P=w.substr(0,E).match(/[/|\\][^/\\]*$/);if(P){let O=w.substr(0,P.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:w.substr((P.index||0)+1)}}}return{pathPortion:w}}function a(...w){return w.length?w.reduce((u,E)=>(u[E]=!0,u),Object.create(null)):void 0}function n(w){return d.splitGlobAware(w,",").map(u=>u.trim()).filter(u=>!!u.length)}function t(w){return[`**/${w}/**`,`**/${w}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function o(w){return w.replace(/\\/g,"/")}function g(w){return o(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(w){return w.replace(/([?*[\]])/g,"[$1]")}function h(w,u){w=_.distinct(w,O=>O.toString());const E=[],P=u.getWorkspace();return w&&w.forEach(O=>{let N;if(u.getWorkbenchState()===2)N=(0,v.relativePath)(P.folders[0].uri,O),N&&N!=="."&&(N="./"+N);else{const F=u.getWorkspaceFolder(O);if(F){const x=F.name;if(P.folders.filter(U=>U.name===x).length===1){const U=(0,v.relativePath)(F.uri,O);U===""?N=`./${F.name}`:N=`./${F.name}/${U}`}else N=O.fsPath}}N&&E.push(l(N))}),E}e.resolveResourcesForSearchIncludes=h}),define(De[330],Ie([1,0,24,2,21,8,5,329,35,50]),function(me,e,_,L,d,A,T,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function k(b,r){const s=r.activationEvents;if(!s)return Promise.resolve(void 0);const c=[],f=[];for(const t of s)if(/^workspaceContains:/.test(t)){const o=t.substr(18);o.indexOf("*")>=0||o.indexOf("?")>=0||b.forceUsingSearch?f.push(o):c.push(o)}if(c.length===0&&f.length===0)return Promise.resolve(void 0);let S;const I=new Promise((t,o)=>{S=t}),i=t=>S({activationEvent:t}),a=Promise.all(c.map(t=>p(b,t,i))).then(()=>{}),n=C(b,r.identifier,f,i);return Promise.all([a,n]).then(()=>{S(void 0)}),I}e.checkActivateWorkspaceContainsExtension=k;async function p(b,r,s){for(const c of b.folders)if(await b.exists(_.joinPath(L.URI.revive(c),r))){s(`workspaceContains:${r}`);return}}async function C(b,r,s,c){if(s.length===0)return Promise.resolve(void 0);const f=new d.CancellationTokenSource,S=b.checkExists(b.folders,s,f.token),I=setTimeout(async()=>{f.cancel(),b.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},R);let i=!1;try{i=await S}catch(a){A.isCancellationError(a)||A.onUnexpectedError(a)}f.dispose(),clearTimeout(I),i&&c(`workspaceContains:${s.join(",")}`)}function D(b,r,s,c){const f=b.get(T.IInstantiationService),S=b.get(y.ISearchService),i=f.createInstance(m.QueryBuilder).file(r.map(a=>(0,v.toWorkspaceFolder)(L.URI.revive(a))),{_reason:"checkExists",includePattern:s,exists:!0});return S.fileSearch(i,c).then(a=>!!a.limitHit,a=>A.isCancellationError(a)?!1:Promise.reject(a))}e.checkGlobFileExists=D}),define(De[44],Ie([1,0,194,13,89,24,17,4,71,2,18,6,38,272,109,37,27,141,8,25,22,247,7,130,5,26,85,20,99,64,43,3,330,108,249,15,106,39,11,107]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c,f,S,I,i,a,n,t,o,g,l,h,w,u,E,P,O,N,F,x,B,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let X=class Dn extends m.Disposable{constructor(re,fe,he,z,Z,ye,Re,ne,ee,de,K,le){super(),this._extHostManagedSockets=le,this._onDidChangeRemoteConnectionData=this._register(new u.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=fe,this._extHostContext=he,this._initData=Re,this._extHostWorkspace=z,this._extHostConfiguration=Z,this._logService=ye,this._extHostTunnelService=ee,this._extHostTerminalService=de,this._extHostLocalizationService=K,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._activationEventsReader=new H(this._initData.activationEvents),this._globalRegistry=new s.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.allExtensions);const oe=new f.ExtensionIdentifierSet(this._initData.myExtensions);this._myRegistry=new s.ExtensionDescriptionRegistry(this._activationEventsReader,te(this._globalRegistry,oe)),this._storage=new D.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new P.ExtHostSecretState(this._extHostContext),this._storagePath=ne,this._instaService=re.createChild(new l.ServiceCollection([D.IExtHostStorage,this._storage],[P.IExtHostSecretState,this._secretState])),this._activator=this._register(new C.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(ue,Ee,M)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ue,c.transformErrorForSerialization(Ee),M)},actualActivateExtension:async(ue,Ee)=>{if(s.ExtensionDescriptionRegistry.isHostExtension(ue,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(ue,Ee),new C.HostExtension;const M=this._myRegistry.getExtensionDescription(ue);return this._activateExtension(M,Ee)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),d.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(re){c.onUnexpectedError(re)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let re=[];try{re=this._myRegistry.getAllExtensionDescriptions().map(Z=>Z.identifier).filter(Z=>this.isActivated(Z)).map(Z=>this._deactivate(Z))}catch{}await Promise.all(re)}terminate(re,fe=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${re}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),c.setUnexpectedErrorHandler(z=>{this._logService.error(z)}),this._extHostContext.dispose();const he=this._deactivateAll();Promise.race([(0,T.timeout)(5e3),he]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${fe}`):this._logService.info(`Extension host exiting with code ${fe}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(fe)})}isActivated(re){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(re):!1}async getExtension(re){const fe=await this._mainThreadExtensionsProxy.$getExtension(re);return fe&&{...fe,identifier:new f.ExtensionIdentifier(fe.identifier.value),extensionLocation:v.URI.revive(fe.extensionLocation)}}_activateByEvent(re,fe){return this._activator.activateByEvent(re,fe)}_activateById(re,fe){return this._activator.activateById(re,fe)}activateByIdWithErrors(re,fe){return this._activateById(re,fe).then(()=>{const he=this._activator.getActivatedExtension(re);if(he.activationFailed)return Promise.reject(he.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(re=>this._myRegistry)}getExtensionExports(re){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(re).exports;try{return this._activator.getActivatedExtension(re).exports}catch{return null}}async _realPathExtensionUri(re){if(re.scheme===N.Schemas.file&&this._hostUtils.fsRealpath){const fe=await this._hostUtils.fsRealpath(re.fsPath);return v.URI.file(fe)}return re}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(re=>new $(re))),this._extensionPathIndex}async _createExtensionPathIndex(re){const fe=y.TernarySearchTree.forUris(he=>A.extUriBiasedIgnorePathCase.ignorePathCasing(he));return await Promise.all(re.map(async he=>{if(this._getEntryPoint(he)){const z=await this._realPathExtensionUri(he.extensionLocation);fe.set(z,he)}})),fe}_deactivate(re){let fe=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(re))return fe;const he=this._activator.getActivatedExtension(re);if(!he)return fe;try{typeof he.module.deactivate=="function"&&(fe=Promise.resolve(he.module.deactivate()).then(void 0,z=>(this._logService.error(z),Promise.resolve(void 0))))}catch(z){this._logService.error(`An error occurred when deactivating the extension '${re.value}':`),this._logService.error(z)}try{(0,m.dispose)(he.subscriptions)}catch(z){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${re.value}':`),this._logService.error(z)}return fe}async _activateExtension(re,fe){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(re.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(re.identifier),this._doActivateExtension(re,fe).then(he=>{const z=he.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(re.identifier,z.codeLoadingTime,z.activateCallTime,z.activateResolvedTime,fe),this._logExtensionActivationTimes(re,fe,"success",z),he},he=>{throw this._logExtensionActivationTimes(re,fe,"failure"),he})}_logExtensionActivationTimes(re,fe,he,z){const Z=ge(re,fe);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Z,...z||{},outcome:he})}_doActivateExtension(re,fe){const he=ge(re,fe);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",he);const z=this._getEntryPoint(re);if(!z)return Promise.resolve(new C.EmptyExtension(C.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${re.identifier.value}, startup: ${fe.startup}, activationEvent: '${fe.activationEvent}'${re.identifier.value!==fe.extensionId.value?`, root cause: ${fe.extensionId.value}`:""}`),this._logService.flush();const Z=new C.ExtensionActivationTimesBuilder(fe.startup);return Promise.all([this._loadCommonJSModule(re,(0,A.joinPath)(re.extensionLocation,z),Z),this._loadExtensionContext(re)]).then(ye=>(d.mark(`code/extHost/willActivateExtension/${re.identifier.value}`),Dn._callActivate(this._logService,re.identifier,ye[0],ye[1],Z))).then(ye=>(d.mark(`code/extHost/didActivateExtension/${re.identifier.value}`),ye))}_loadExtensionContext(re){const fe=new I.ExtensionGlobalMemento(re,this._storage),he=new I.ExtensionMemento(re.identifier.value,!1,this._storage),z=new O.ExtensionSecrets(re,this._secretState),Z=re.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ye=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${re.identifier.value}`),Promise.all([fe.whenReady,he.whenReady,this._storagePath.whenReady]).then(()=>{const Re=this;let ne,ee;const de=(0,r.isProposedApiEnabled)(re,"ipc")?this._initData.messagePorts?.get(f.ExtensionIdentifier.toKey(re.identifier)):void 0;return Object.freeze({globalState:fe,workspaceState:he,secrets:z,subscriptions:[],get extensionUri(){return re.extensionLocation},get extensionPath(){return re.extensionLocation.fsPath},asAbsolutePath(K){return L.join(re.extensionLocation.fsPath,K)},get storagePath(){return Re._storagePath.workspaceValue(re)?.fsPath},get globalStoragePath(){return Re._storagePath.globalValue(re).fsPath},get logPath(){return L.join(Re._initData.logsLocation.fsPath,re.identifier.value)},get logUri(){return v.URI.joinPath(Re._initData.logsLocation,re.identifier.value)},get storageUri(){return Re._storagePath.workspaceValue(re)},get globalStorageUri(){return Re._storagePath.globalValue(re)},get extensionMode(){return Z},get extension(){return ne===void 0&&(ne=new ie(Re,re.identifier,re,ye,!1)),ne},get extensionRuntime(){return(0,r.checkProposedApiEnabled)(re,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re._extHostTerminalService.getEnvironmentVariableCollection(re)},get messagePassingProtocol(){if(!ee){if(!de)return;const K=u.Event.buffer(u.Event.fromDOMEventEmitter(de,"message",le=>le.data));de.start(),ee={onDidReceiveMessage:K,postMessage:de.postMessage.bind(de)}}return ee}})})}static _callActivate(re,fe,he,z,Z){return he=he||{activate:void 0,deactivate:void 0},this._callActivateOptional(re,fe,he,z,Z).then(ye=>new C.ActivatedExtension(!1,null,Z.build(),he,ye,z.subscriptions))}static _callActivateOptional(re,fe,he,z,Z){if(typeof he.activate=="function")try{Z.activateCallStart(),re.trace(`ExtensionService#_callActivateOptional ${fe.value}`);const ye=typeof global=="object"?global:self,Re=he.activate.apply(ye,[z]);return Z.activateCallStop(),Z.activateResolveStart(),Promise.resolve(Re).then(ne=>(Z.activateResolveStop(),ne))}catch(ye){return Promise.reject(ye)}else return Promise.resolve(he)}_activateOneStartupFinished(re,fe){this._activateById(re.identifier,{startup:!1,extensionId:re.identifier,activationEvent:fe}).then(void 0,he=>{this._logService.error(he)})}_activateAllStartupFinishedDeferred(re,fe=0){const z=Date.now();(0,B.setTimeout0)(()=>{for(let Z=fe;Z<re.length;Z+=1){const ye=re[Z];for(const Re of ye.activationEvents??[])if(Re==="onStartupFinished")if(Date.now()-z>50){this._activateAllStartupFinishedDeferred(re,Z);break}else this._activateOneStartupFinished(ye,Re)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(d.getMarks()),this._extHostConfiguration.getConfigProvider().then(re=>{const fe=re.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),he=this._myRegistry.getAllExtensionDescriptions();if(fe)this._activateAllStartupFinishedDeferred(he);else for(const z of he)if(z.activationEvents)for(const Z of z.activationEvents)Z==="onStartupFinished"&&this._activateOneStartupFinished(z,Z)})}_handleEagerExtensions(){const re=this._activateByEvent("*",!0).then(void 0,ye=>{this._logService.error(ye)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ye=>this._handleWorkspaceContainsEagerExtensions(ye.added)));const fe=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],he=this._handleWorkspaceContainsEagerExtensions(fe),z=this._handleRemoteResolverEagerExtensions(),Z=Promise.all([z,re,he]).then(()=>{});return Promise.race([Z,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Z}_handleWorkspaceContainsEagerExtensions(re){return re.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(fe=>this._handleWorkspaceContainsEagerExtension(re,fe))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(re,fe){if(this.isActivated(fe.identifier))return;const he=!this._initData.remote.isRemote&&!!this._initData.remote.authority,z={logService:this._logService,folders:re.map(ye=>ye.uri),forceUsingSearch:he||!this._hostUtils.fsExists,exists:ye=>this._hostUtils.fsExists(ye.fsPath),checkExists:(ye,Re,ne)=>this._mainThreadWorkspaceProxy.$checkExists(ye,Re,ne)},Z=await(0,E.checkActivateWorkspaceContainsExtension)(z,fe);if(Z)return this._activateById(fe.identifier,{startup:!0,extensionId:fe.identifier,activationEvent:Z.activationEvent}).then(void 0,ye=>this._logService.error(ye))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(re){throw console.error(re),re}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:re,extensionTestsLocationURI:fe}=this._initData.environment;if(!re||!fe)throw new Error(_.localize(0,null));const he=await this._loadCommonJSModule(null,fe,new C.ExtensionActivationTimesBuilder(!1));if(!he||typeof he.run!="function")throw new Error(_.localize(1,null,fe.toString()));return new Promise((z,Z)=>{const ye=(ee,de)=>{ee?Z(ee):z(typeof de=="number"&&de>0?1:0)},Re=(0,A.originalFSPath)(fe),ne=he.run(Re,ye);ne&&ne.then&&ne.then(()=>{z(0)}).catch(ee=>{Z(ee instanceof Error&&ee.stack?ee.stack:String(ee))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,T.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(re,fe){return this._resolvers[re]=fe,(0,m.toDisposable)(()=>{delete this._resolvers[re]})}async getRemoteExecServer(re){const{resolver:fe}=await this._activateAndGetResolver(re);return fe?.resolveExecServer?.(re,{resolveAttempt:0})}async _activateAndGetResolver(re){const fe=re.indexOf("+");if(fe===-1)throw new i.RemoteAuthorityResolverError("Not an authority that can be resolved!",a.RemoteAuthorityResolverErrorCode.InvalidAuthority);const he=re.substr(0,fe);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${he}`,!1),{authorityPrefix:he,resolver:this._resolvers[he]}}async $resolveAuthority(re,fe){const he=x.StopWatch.create(!1),z=()=>`[resolveAuthority(${(0,a.getRemoteAuthorityPrefix)(re)},${fe})][${he.elapsed()}ms] `,Z=G=>this._logService.info(`${z()}${G}`),ye=G=>this._logService.warn(`${z()}${G}`),Re=(G,J=void 0)=>this._logService.error(`${z()}${G}`,J),ne=G=>{if(G instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G},ee=async G=>{Z(`activating resolver for ${G}...`);const{resolver:J,authorityPrefix:be}=await this._activateAndGetResolver(G);if(!J)throw Re(`no resolver for ${be}`),new i.RemoteAuthorityResolverError(`No remote extension installed to resolve ${be}.`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:be,remoteAuthority:G}},de=re.split(/@|%40/g).reverse();Z(`activating remote resolvers ${de.join(" -> ")}`);let K;try{K=await Promise.all(de.map(ee)).catch(async G=>{if(!(G instanceof i.RemoteAuthorityResolverError)||G._code!==a.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw G;return ye(`resolving nested authorities failed: ${G.message}`),[await ee(re)]})}catch(G){return ne(G)}const le=new T.IntervalTimer;le.cancelAndSet(()=>Z("waiting..."),1e3);let oe,ue;for(const[G,{authorityPrefix:J,resolver:be,remoteAuthority:se}]of K.entries())try{if(G===K.length-1)Z("invoking final resolve()..."),d.mark(`code/extHost/willResolveAuthority/${J}`),oe=await be.resolve(se,{resolveAttempt:fe,execServer:ue}),d.mark(`code/extHost/didResolveAuthorityOK/${J}`),Z("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(be));else{if(Z(`invoking resolveExecServer() for ${se}`),d.mark(`code/extHost/willResolveExecServer/${J}`),ue=await be.resolveExecServer?.(se,{resolveAttempt:fe,execServer:ue}),!ue)throw new i.RemoteAuthorityResolverError(`Exec server was not available for ${se}`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);d.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(we){return d.mark(`code/extHost/didResolveAuthorityError/${J}`),Re("returned an error",we),le.dispose(),ne(we)}le.dispose();const Ee={environmentTunnels:oe.environmentTunnels,features:oe.tunnelFeatures},M={extensionHostEnv:oe.extensionHostEnv,isTrusted:oe.isTrusted,authenticationSession:oe.authenticationSessionForInitializingExtensions?{id:oe.authenticationSessionForInitializingExtensions.id,providerId:oe.authenticationSessionForInitializingExtensions.providerId}:void 0};Z(`returned ${i.ManagedResolvedAuthority.isManagedResolvedAuthority(oe)?"managed authority":`${oe.host}:${oe.port}`}`);let q;if(i.ManagedResolvedAuthority.isManagedResolvedAuthority(oe)){const G=fe;this._extHostManagedSockets.setFactory(G,oe.makeConnection),q={authority:re,connectTo:new a.ManagedRemoteConnection(G),connectionToken:oe.connectionToken}}else q={authority:re,connectTo:new a.WebSocketRemoteConnection(oe.host,oe.port),connectionToken:oe.connectionToken};return{type:"ok",value:{authority:q,options:M,tunnelInformation:Ee}}}async $getCanonicalURI(re,fe){this._logService.info(`$getCanonicalURI invoked for authority (${(0,a.getRemoteAuthorityPrefix)(re)})`);const{resolver:he}=await this._activateAndGetResolver(re);if(!he)return null;const z=v.URI.revive(fe);if(typeof he.getCanonicalURI>"u")return z;const Z=await(0,T.asPromise)(()=>he.getCanonicalURI(z));return Z||z}$startExtensionHost(re){re.toAdd.forEach(z=>z.extensionLocation=v.URI.revive(z.extensionLocation));const{globalRegistry:fe,myExtensions:he}=j(this._activationEventsReader,this._globalRegistry,this._myRegistry,re);return this._globalRegistry.set(fe.getAllExtensionDescriptions()),this._myRegistry.set(he),this._startExtensionHost()}$activateByEvent(re,fe){return fe===1?this._almostReadyToRunExtensions.wait().then(he=>this._activateByEvent(re,!1)):this._readyToRunExtensions.wait().then(he=>this._activateByEvent(re,!1))}async $activate(re,fe){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(re)?(await this._activateById(re,fe),!0):!1}async $deltaExtensions(re){re.toAdd.forEach(ye=>ye.extensionLocation=v.URI.revive(ye.extensionLocation));const{globalRegistry:fe,myExtensions:he}=j(this._activationEventsReader,this._globalRegistry,this._myRegistry,re),z=await this._createExtensionPathIndex(he);return(await this.getExtensionPathIndex()).setSearchTree(z),this._globalRegistry.set(fe.getAllExtensionDescriptions()),this._myRegistry.set(he),Promise.resolve(void 0)}async $test_latency(re){return re}async $test_up(re){return re.byteLength}async $test_down(re){const fe=S.VSBuffer.alloc(re),he=Math.random()%256;for(let z=0;z<re;z++)fe.writeUInt8(he,z);return fe}async $updateRemoteConnectionData(re){this._remoteConnectionData=re,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=X,e.AbstractExtHostExtensionService=X=Ve([$e(0,n.IInstantiationService),$e(1,e.IHostUtils),$e(2,g.IExtHostRpcService),$e(3,b.IExtHostWorkspace),$e(4,p.IExtHostConfiguration),$e(5,R.ILogService),$e(6,t.IExtHostInitDataService),$e(7,o.IExtensionStoragePaths),$e(8,h.IExtHostTunnelService),$e(9,w.IExtHostTerminalService),$e(10,F.IExtHostLocalizationService),$e(11,U.IExtHostManagedSockets)],X);function j(ce,re,fe,he){ce.addActivationEvents(he.addActivationEvents);const z=new s.ExtensionDescriptionRegistry(ce,re.getAllExtensionDescriptions());z.deltaExtensions(he.toAdd,he.toRemove);const Z=new f.ExtensionIdentifierSet(fe.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of he.myToRemove)Z.delete(Re);for(const Re of he.myToAdd)Z.add(Re);const ye=te(z,Z);return{globalRegistry:z,myExtensions:ye}}function ge(ce,re){return{id:ce.identifier.value,name:ce.name,extensionVersion:ce.version,publisherDisplayName:ce.publisher,activationEvents:ce.activationEvents?ce.activationEvents.join(","):null,isBuiltin:ce.isBuiltin,reason:re.activationEvent,reasonId:re.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class ie{#e;#t;#i;constructor(re,fe,he,z,Z){this.#e=re,this.#t=fe,this.#i=he.identifier,this.id=he.identifier.value,this.extensionUri=he.extensionLocation,this.extensionPath=L.normalize((0,A.originalFSPath)(he.extensionLocation)),this.packageJSON=he,this.extensionKind=z,this.isFromDifferentExtensionHost=Z}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=ie;function te(ce,re){return ce.getAllExtensionDescriptions().filter(fe=>re.has(fe.identifier))}class ${constructor(re){this._searchTree=re}setSearchTree(re){this._searchTree=re}findSubstr(re){return this._searchTree.findSubstr(re)}forEach(re){return this._searchTree.forEach(re)}}e.ExtensionPaths=$;class H{constructor(re){this._map=new f.ExtensionIdentifierMap,this.addActivationEvents(re)}readActivationEvents(re){return this._map.get(re.identifier)}addActivationEvents(re){for(const fe of Object.keys(re))this._map.set(fe,re[fe])}}}),define(De[331],Ie([1,0,89,2,6,38,27,25,20,26,5,44,41,18,12]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let b=class{constructor(I,i,a,n,t,o,g){this._apiFactory=I,this._extensionRegistry=i,this._instaService=a,this._extHostConfiguration=n,this._extHostExtensionService=t,this._initData=o,this._logService=g,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),_.mark("code/extHost/willWaitForConfig");const I=await this._extHostConfiguration.getConfigProvider();_.mark("code/extHost/didWaitForConfig");const i=await this._extHostExtensionService.getExtensionPathIndex();this.register(new s(this._apiFactory,i,this._extensionRegistry,I,this._logService)),this.register(this._instaService.createInstance(c,i)),this.register(this._instaService.createInstance(r)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(f,i,this._initData.environment.appUriScheme))}register(I){if("nodeModuleName"in I)if(Array.isArray(I.nodeModuleName))for(const i of I.nodeModuleName)this._factories.set(i,I);else this._factories.set(I.nodeModuleName,I);typeof I.alternativeModuleName=="function"&&this._alternatives.push(i=>I.alternativeModuleName(i))}};e.RequireInterceptor=b,e.RequireInterceptor=b=Ve([$e(2,R.IInstantiationService),$e(3,A.IExtHostConfiguration),$e(4,k.IExtHostExtensionService),$e(5,v.IExtHostInitDataService),$e(6,C.ILogService)],b);let r=class mn{static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(I){if(I.environment.appRoot&&mn.aliased.size){const i=(0,D.escapeRegExpCharacters)(this.forceForwardSlashes(I.environment.appRoot.fsPath)),a="[a-z0-9_.-]",n=`@${a}+\\/${a}+|${a}+`,t="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${i}/${t}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(I){if(!this.re)return;const i=this.re.exec(this.forceForwardSlashes(I));if(!i)return;const[,a,n,t]=i,o=mn.aliased.get(n);if(o!==void 0)return console.warn(`${n} as been renamed to ${o}, please update your imports`),a+o+t}forceForwardSlashes(I){return I.replace(/\\/g,"/")}};r=Ve([$e(0,v.IExtHostInitDataService)],r);class s{constructor(I,i,a,n,t){this._apiFactory=I,this._extensionPaths=i,this._extensionRegistry=a,this._configProvider=n,this._logService=t,this.nodeModuleName="vscode",this._extApiImpl=new m.ExtensionIdentifierMap}load(I,i){const a=this._extensionPaths.findSubstr(i);if(a){let n=this._extApiImpl.get(a.identifier);return n||(n=this._apiFactory(a,this._extensionRegistry,this._configProvider),this._extApiImpl.set(a.identifier,n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((t,o)=>n+=`	${o} -> ${t.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let c=class{constructor(I,i,a){this._extensionPaths=I,this.nodeModuleName="keytar",this._mainThreadTelemetry=i.getProxy(d.MainContext.MainThreadTelemetry);const{environment:n}=a,t=i.getProxy(d.MainContext.MainThreadKeytar);if(n.appRoot){let o=n.appRoot.fsPath;p.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${o}/node_modules.asar/keytar`),this.alternativeNames.add(`${o}/node_modules/keytar`)}this._impl={getPassword:(o,g)=>t.$getPassword(o,g),setPassword:(o,g,l)=>t.$setPassword(o,g,l),deletePassword:(o,g)=>t.$deletePassword(o,g),findPassword:o=>t.$findPassword(o),findCredentials(o){return t.$findCredentials(o)}}}load(I,i){const a=this._extensionPaths.findSubstr(i);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:a?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(I){const i=I.length;if(i<=7||!this.alternativeNames)return;const a=i-7;if((I.charAt(a)==="/"||I.charAt(a)==="\\")&&I.endsWith("keytar")&&(I=I.replace(/\\/g,"/"),this.alternativeNames.has(I)))return"keytar"}};c=Ve([$e(1,y.IExtHostRpcService),$e(2,v.IExtHostInitDataService)],c);let f=class{constructor(I,i,a){this._extensionPaths=I,this._appUriScheme=i,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=a.getProxy(d.MainContext.MainThreadTelemetry);const n=a.getProxy(d.MainContext.MainThreadWindow);this._impl=(t,o)=>{const g=L.URI.parse(t);return o?this.callOriginal(t,o):g.scheme==="http"||g.scheme==="https"?n.$openUri(g,t,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this._appUriScheme?n.$openUri(g,t,{}):this.callOriginal(t,o)}}load(I,i,a){const n=this._extensionPaths.findSubstr(i);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=a(I),this._impl}callOriginal(I,i){return this.sendNoForwardTelemetry(),this._original(I,i)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};f=Ve([$e(2,y.IExtHostRpcService)],f)}),define(De[52],Ie([1,0,54,4,13,41,5,61,62,44,7,37,263,38]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,T.createDecorator)("IExtHostVariableResolverProvider");class D extends p.AbstractVariableResolverService{constructor(s,c,f,S,I,i,a){function n(){if(f){const t=f.activeEditor();if(t)return t.document.uri;const o=S.tabGroups.all.find(g=>g.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof R.TextDiffTabInput||o.input instanceof R.NotebookDiffEditorTabInput)return o.input.modified;if(o.input instanceof R.TextTabInput||o.input instanceof R.NotebookEditorTabInput||o.input instanceof R.CustomEditorTabInput)return o.input.uri}}}super({getFolderUri:t=>{const o=i.folders.filter(g=>g.name===t);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(t,o)=>I.getConfiguration(void 0,t).get(o),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const t=n();if(t)return d.normalize(t.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const t=n();if(t){const o=c.getWorkspaceFolder(t);if(o)return d.normalize(o.uri.fsPath)}}},getSelectedText:()=>{if(f){const t=f.activeEditor();if(t&&!t.selection.isEmpty)return t.document.getText(t.selection)}},getLineNumber:()=>{if(f){const t=f.activeEditor();if(t)return String(t.selection.end.line+1)}},getExtension:t=>s.getExtension(t)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(A.env))}}let b=class extends L.Disposable{constructor(s,c,f,S,I){super(),this.extensionService=s,this.workspaceService=c,this.editorService=f,this.configurationService=S,this.editorTabs=I,this._resolver=new _.Lazy(async()=>{const i=await this.configurationService.getConfigProvider(),n={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async t=>{n.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new D(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,i,n,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=b,e.ExtHostVariableResolverProviderService=b=Ve([$e(0,v.IExtHostExtensionService),$e(1,k.IExtHostWorkspace),$e(2,m.IExtHostDocumentsAndEditors),$e(3,C.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs)],b)}),define(De[90],Ie([1,0,17,3,14,2,5,6,62,44,20,7,37,134,256,38,52]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,T.createDecorator)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(n,t,o,g,l,h){this._workspaceService=t,this._extensionService=o,this._configurationService=g,this._editorTabs=l,this._variableResolver=h,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new L.Emitter,this._onDidTerminateDebugSession=new L.Emitter,this._onDidChangeActiveDebugSession=new L.Emitter,this._onDidReceiveDebugSessionCustomEvent=new L.Emitter,this._debugServiceProxy=n.getProxy(m.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new L.Emitter,this._onDidChangeStackFrameFocus=new L.Emitter,this._activeDebugConsole=new f(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(w=>{w.onDidChange(u=>{this.registerAllDebugTypes(w)}),this.registerAllDebugTypes(w)})}asDebugSourceUri(n,t){const o=n;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let g=`debug:${encodeURIComponent(o.path||"")}`,l="?";return t&&(g+=`${l}session=${encodeURIComponent(t.id)}`,l="&"),g+=`${l}ref=${o.sourceReference}`,A.URI.parse(g)}else{if(o.path)return A.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const t=[];for(const o of n.getAllExtensionDescriptions())if(o.contributes){const g=o.contributes.debuggers;if(g&&g.length>0)for(const l of g)(0,D.isDebuggerMainContribution)(l)&&t.push(l.type)}this._debugServiceProxy.$registerDebugTypes(t)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const n=[];return this._breakpoints.forEach(t=>n.push(t)),n}addBreakpoints(n){const t=n.filter(l=>{const h=l.id;return this._breakpoints.has(h)?!1:(this._breakpoints.set(h,l),!0)});this.fireBreakpointChanges(t,[],[]);const o=[],g=new Map;for(const l of t)if(l instanceof k.SourceBreakpoint){let h=g.get(l.location.uri.toString());h||(h={type:"sourceMulti",uri:l.location.uri,lines:[]},g.set(l.location.uri.toString(),h),o.push(h)),h.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof k.FunctionBreakpoint&&o.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this._debugServiceProxy.$registerBreakpoints(o)}removeBreakpoints(n){const t=n.filter(h=>this._breakpoints.delete(h.id));this.fireBreakpointChanges([],t,[]);const o=t.filter(h=>h instanceof k.SourceBreakpoint).map(h=>h.id),g=t.filter(h=>h instanceof k.FunctionBreakpoint).map(h=>h.id),l=t.filter(h=>h instanceof k.DataBreakpoint).map(h=>h.id);return this._debugServiceProxy.$unregisterBreakpoints(o,g,l)}startDebugging(n,t,o){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,t,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,t,o){if(!t)return new k.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:g,provider:t}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,o,!!t.provideDebugConfigurations,!!t.resolveDebugConfiguration,!!t.resolveDebugConfigurationWithSubstitutedVariables,g),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(l=>l.provider!==t),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(n,t,o){if(!o)return new k.Disposable(()=>{});if(!this.definesDebugType(n,t))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${t}' debugger.`);if(this.getAdapterDescriptorFactoryByType(t))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:t,handle:g,factory:o}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(t,g),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(l=>l.factory!==o),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(n,t){if(!t)return new k.Disposable(()=>{});const o=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:o,factory:t}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==t)})}async $runInTerminal(n,t){return Promise.resolve(void 0)}async $substituteVariables(n,t){let o;const g=await this.getFolder(n);return g&&(o={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(o,t)}createDebugAdapter(n,t){if(n.type==="implementation")return new I(n.implementation)}createSignService(){}async $startDASession(n,t){const o=this,g=await this.getSession(t);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const h=this.convertToDto(l),w=this.createDebugAdapter(h,g);if(!w)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const u=w;return this._debugAdapters.set(n,u),this.getDebugAdapterTrackers(g).then(E=>(E&&this._debugAdaptersTrackers.set(n,E),u.onMessage(async P=>{if(P.type==="request"&&P.command==="handshake"){const O=P,N={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(O.arguments.value);N.body={signature:F},u.sendResponse(N)}else throw new Error("no signer")}catch(F){N.success=!1,N.message=F.message,u.sendResponse(N)}}else E&&E.onDidSendMessage&&E.onDidSendMessage(P),P=(0,D.convertToVSCPaths)(P,!0),o._debugServiceProxy.$acceptDAMessage(n,P)}),u.onError(P=>{E&&E.onError&&E.onError(P),this._debugServiceProxy.$acceptDAError(n,P.name,P.message,P.stack)}),u.onExit(P=>{E&&E.onExit&&E.onExit((0,d.withNullAsUndefined)(P),void 0),this._debugServiceProxy.$acceptDAExit(n,(0,d.withNullAsUndefined)(P),void 0)}),E&&E.onWillStartSession&&E.onWillStartSession(),u.startSession()))})}$sendDAMessage(n,t){t=(0,D.convertToDAPaths)(t,!1);const o=this._debugAdaptersTrackers.get(n);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(t),this._debugAdapters.get(n)?.sendMessage(t)}$stopDASession(n){const t=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),t&&t.onWillStopSession&&t.onWillStopSession();const o=this._debugAdapters.get(n);return this._debugAdapters.delete(n),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const t=[],o=[],g=[];if(n.added)for(const l of n.added){const h=l.id;if(h&&!this._breakpoints.has(h)){let w;if(l.type==="function")w=new k.FunctionBreakpoint(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")w=new k.DataBreakpoint(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const u=A.URI.revive(l.uri);w=new k.SourceBreakpoint(new k.Location(u,new k.Position(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}(0,k.setBreakpointId)(w,h),this._breakpoints.set(h,w),t.push(w)}}if(n.removed)for(const l of n.removed){const h=this._breakpoints.get(l);h&&(this._breakpoints.delete(l),o.push(h))}if(n.changed){for(const l of n.changed)if(l.id){const h=this._breakpoints.get(l.id);if(h){if(h instanceof k.FunctionBreakpoint&&l.type==="function"){const w=h;w.enabled=l.enabled,w.condition=l.condition,w.hitCondition=l.hitCondition,w.logMessage=l.logMessage,w.functionName=l.functionName}else if(h instanceof k.SourceBreakpoint&&l.type==="source"){const w=h;w.enabled=l.enabled,w.condition=l.condition,w.hitCondition=l.hitCondition,w.logMessage=l.logMessage,w.location=new k.Location(A.URI.revive(l.uri),new k.Position(l.line,l.character))}g.push(h)}}}this.fireBreakpointChanges(t,o,g)}async $acceptStackFrameFocus(n){let t;const o=n.sessionId?await this.getSession(n.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?t=new k.ThreadFocus(o,n.threadId):t=new k.StackFrameFocus(o,n.threadId,n.frameId),this._stackFrameFocus=t,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(n,t,o){return(0,_.asPromise)(async()=>{const g=this.getConfigProviderByHandle(n);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.getFolder(t);return g.provideDebugConfigurations(l,o)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(n,t,o,g){return(0,_.asPromise)(async()=>{const l=this.getConfigProviderByHandle(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const h=await this.getFolder(t);return l.resolveDebugConfiguration(h,o,g)})}$resolveDebugConfigurationWithSubstitutedVariables(n,t,o,g){return(0,_.asPromise)(async()=>{const l=this.getConfigProviderByHandle(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const h=await this.getFolder(t);return l.resolveDebugConfigurationWithSubstitutedVariables(h,o,g)})}async $provideDebugAdapter(n,t){const o=this.getAdapterDescriptorFactoryByHandle(n);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(t);return this.getAdapterDescriptor(o,g).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(l)})}async $acceptDebugSessionStarted(n){const t=await this.getSession(n);this._onDidStartDebugSession.fire(t)}async $acceptDebugSessionTerminated(n){const t=await this.getSession(n);t&&(this._onDidTerminateDebugSession.fire(t),this._debugSessions.delete(t.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,t){(await this.getSession(n))?._acceptNameChanged(t)}async $acceptDebugSessionCustomEvent(n,t){const g={session:await this.getSession(n),event:t.event,body:t.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(n){if(n instanceof k.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof k.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const t=this._adapterFactories.filter(o=>o.type===n);if(t.length>0)return t[0].factory}getAdapterDescriptorFactoryByHandle(n){const t=this._adapterFactories.filter(o=>o.handle===n);if(t.length>0)return t[0].factory}getConfigProviderByHandle(n){const t=this._configProviders.filter(o=>o.handle===n);if(t.length>0)return t[0].provider}definesDebugType(n,t){if(n.contributes){const o=n.contributes.debuggers;if(o&&o.length>0){for(const g of o)if(g.label&&g.type&&g.type===t)return!0}}return!1}getDebugAdapterTrackers(n){const o=n.configuration.type,g=this._trackerFactories.filter(l=>l.type===o||l.type==="*").map(l=>(0,_.asPromise)(()=>l.factory.createDebugAdapterTracker(n)).then(h=>h,h=>null));return Promise.race([Promise.all(g).then(l=>{const h=l.filter(w=>!!w);if(h.length>0)return new S(h)}),new Promise(l=>setTimeout(()=>l(void 0),1e3))]).catch(l=>{})}async getAdapterDescriptor(n,t){const o=t.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new k.DebugAdapterServer(o));if(n){const l=await this._extensionService.getExtensionRegistry();return(0,_.asPromise)(()=>n.createDebugAdapterDescriptor(t,this.daExecutableFromPackage(t,l))).then(h=>{if(h)return h})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(t,g))}daExecutableFromPackage(n,t){}fireBreakpointChanges(n,t,o){(n.length>0||t.length>0||o.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:t,changed:o}))}async getSession(n){if(n)if(typeof n=="string"){const t=this._debugSessions.get(n);if(t)return t}else{let t=this._debugSessions.get(n.id);if(!t){const o=await this.getFolder(n.folderUri),g=n.parent?this._debugSessions.get(n.parent):void 0;t=new c(this._debugServiceProxy,n.id,n.type,n.name,o,n.configuration,g),this._debugSessions.set(t.id,t),this._debugServiceProxy.$sessionCached(t.id)}return t}throw new Error("cannot find session")}getFolder(n){if(n){const t=A.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(t)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=s,e.ExtHostDebugServiceBase=s=Ve([$e(0,R.IExtHostRpcService),$e(1,p.IExtHostWorkspace),$e(2,v.IExtHostExtensionService),$e(3,b.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs),$e(5,r.IExtHostVariableResolverProvider)],s);class c{constructor(n,t,o,g,l,h,w){this._debugServiceProxy=n,this._id=t,this._type=o,this._name=g,this._workspaceFolder=l,this._configuration=h,this._parentSession=w}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}get parentSession(){return this._parentSession}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,t){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,t)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=c;class f{constructor(n){this.value=Object.freeze({append(t){n.$appendDebugConsole(t)},appendLine(t){this.append(t+`
`)}})}}e.ExtHostDebugConsole=f;class S{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(t=>t.onWillReceiveMessage?t.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(t=>t.onDidSendMessage?t.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(t=>t.onError?t.onError(n):void 0)}onExit(n,t){this.trackers.forEach(o=>o.onExit?o.onExit(n,t):void 0)}}class I extends C.AbstractDebugAdapter{constructor(n){super(),this.implementation=n,n.onDidSendMessage(t=>{this.acceptMessage(t)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=class extends s{constructor(n,t,o,g,l,h){super(n,t,o,g,l,h)}};e.WorkerExtHostDebugService=i,e.WorkerExtHostDebugService=i=Ve([$e(0,R.IExtHostRpcService),$e(1,p.IExtHostWorkspace),$e(2,v.IExtHostExtensionService),$e(3,b.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs),$e(5,r.IExtHostVariableResolverProvider)],i)}),define(De[332],Ie([1,0,8,89,2,6,324,18,98,99,26,227,20,58,44,83]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class r{static async installEarlyHandler(f){Error.stackTraceLimit=100;const S=f.get(m.ILogService),i=f.get(p.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);_.setUnexpectedErrorHandler(a=>{S.error(a);const n=_.transformErrorForSerialization(a);i.$onUnexpectedError(n)})}static async installFullHandler(f){const S=f.get(m.ILogService),I=f.get(p.IExtHostRpcService),i=f.get(D.IExtHostExtensionService),a=f.get(b.IExtHostTelemetry),n=I.getProxy(A.MainContext.MainThreadExtensionService),t=I.getProxy(A.MainContext.MainThreadErrors),o=await i.getExtensionPathIndex(),g=new WeakMap;function l(u,E){if(g.has(u))return g.get(u).stack;let P="",O,N;for(const x of E)P+=`
	at ${x.toString()}`,N=x.getFileName(),!O&&N&&(O=o.findSubstr(d.URI.file(N)));const F=`${u.name||"Error"}: ${u.message||""}${P}`;return g.set(u,{extensionIdentifier:O?.identifier,stack:F}),F}const h=Symbol("prepareStackTrace wrapped");let w=l;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return w},set(u){if(u===l||u[h]){w=u;return}w=function(E,P){return l(E,P),u.call(Error,E,P)},Object.assign(w,{[h]:!0})}}),_.setUnexpectedErrorHandler(u=>{S.error(u);const E=_.transformErrorForSerialization(u),P=g.get(u);if(!P?.extensionIdentifier){t.$onUnexpectedError(E);return}n.$onExtensionRuntimeError(P.extensionIdentifier,E);const O=a.onExtensionError(P.extensionIdentifier,u);S.trace("forwarded error to extension?",O,P)})}}e.ErrorHandler=r;class s{constructor(f,S,I,i,a){this._hostUtils=I,this._rpcProtocol=new T.RPCProtocol(f,null,i),S=s._transform(S,this._rpcProtocol);const n=new v.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());n.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...S,messagePorts:a}),n.set(p.IExtHostRpcService,new p.ExtHostRpcService(this._rpcProtocol)),n.set(C.IURITransformerService,new C.URITransformerService(i)),n.set(D.IHostUtils,I);const t=new k.InstantiationService(n,!0);t.invokeFunction(r.installEarlyHandler),this._logService=t.invokeFunction(o=>o.get(m.ILogService)),L.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",S),this._extensionService=t.invokeFunction(o=>o.get(D.IExtHostExtensionService)),this._extensionService.initialize(),t.invokeFunction(r.installFullHandler)}async asBrowserUri(f){const S=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return d.URI.revive(await S.$asBrowserUri(f))}terminate(f){this._extensionService.terminate(f)}static _transform(f,S){f.allExtensions.forEach(i=>{i.extensionLocation=d.URI.revive(S.transformIncomingURIs(i.extensionLocation))}),f.environment.appRoot=d.URI.revive(S.transformIncomingURIs(f.environment.appRoot));const I=f.environment.extensionDevelopmentLocationURI;return I&&(f.environment.extensionDevelopmentLocationURI=I.map(i=>d.URI.revive(S.transformIncomingURIs(i)))),f.environment.extensionTestsLocationURI=d.URI.revive(S.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=d.URI.revive(S.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=d.URI.revive(S.transformIncomingURIs(f.environment.workspaceStorageHome)),f.environment.extensionTelemetryLogResource=d.URI.revive(S.transformIncomingURIs(f.environment.extensionTelemetryLogResource)),f.nlsBaseUrl=d.URI.revive(S.transformIncomingURIs(f.nlsBaseUrl)),f.logsLocation=d.URI.revive(S.transformIncomingURIs(f.logsLocation)),f.workspace=S.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=s}),define(De[333],Ie([1,0,17,11,205,221,237,90,62,44,20,43,7,52,37,257,258,38]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let c=class extends m.ExtHostDebugServiceBase{constructor(a,n,t,o,g,l,h){super(a,n,t,o,l,h),this._terminalService=g,this._integratedTerminalInstances=new I}createDebugAdapter(a,n){switch(a.type){case"server":return new b.SocketDebugAdapter(a);case"pipeServer":return new b.NamedPipeDebugAdapter(a);case"executable":return new b.ExecutableDebugAdapter(a,n.type)}return super.createDebugAdapter(a,n)}daExecutableFromPackage(a,n){const t=b.ExecutableDebugAdapter.platformAdapterExecutable(n.getAllExtensionDescriptions(),a.type);if(t)return new p.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new T.SignService}async $runInTerminal(a,n){if(a.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(F=>{this._integratedTerminalInstances.onTerminalClosed(F)}));const t=await this._configurationService.getConfigProvider(),o=this._terminalService.getDefaultShell(!0),g=this._terminalService.getDefaultShellArgs(!0),l=a.title||d.localize(0,null),h=JSON.stringify({shell:o,shellArgs:g});let w=await this._integratedTerminalInstances.checkout(h,l),u,E=!1;if(w)u=a.cwd;else{const F={shellPath:o,shellArgs:g,cwd:a.cwd,name:l,iconPath:new p.ThemeIcon("debug")};E=!0,w=this._terminalService.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(w,h)}w.show(!0);const P=await w.processId;E?await new Promise(F=>setTimeout(F,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(o.indexOf("powershell")>=0||o.indexOf("pwsh")>=0||o.indexOf("cmd.exe")>=0?w.sendText("cls"):o.indexOf("bash")>=0?w.sendText("clear"):L.isWindows?w.sendText("cls"):w.sendText("clear"));const O=(0,r.prepareCommand)(o,a.args,!!a.argsCanBeInterpretedByShell,u,a.env);w.sendText(O);const N=this.onDidTerminateDebugSession(F=>{F.id===n&&(this._integratedTerminalInstances.free(w),N.dispose())});return P}else if(a.kind==="external")return S(a,await this._configurationService.getConfigProvider());return super.$runInTerminal(a,n)}};e.ExtHostDebugService=c,e.ExtHostDebugService=c=Ve([$e(0,R.IExtHostRpcService),$e(1,D.IExtHostWorkspace),$e(2,v.IExtHostExtensionService),$e(3,s.IExtHostConfiguration),$e(4,k.IExtHostTerminalService),$e(5,y.IExtHostEditorTabs),$e(6,C.IExtHostVariableResolverProvider)],c);let f;function S(i,a){if(!f)if(L.isWindows)f=new A.WindowsExternalTerminalService;else if(L.isMacintosh)f=new A.MacExternalTerminalService;else if(L.isLinux)f=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const n=a.getConfiguration("terminal");return f.runInTerminal(i.title,i.cwd,i.args,i.env||{},n.external||{})}class I{constructor(){this._terminalInstances=new Map}static{this.minUseDelay=1e3}async checkout(a,n){const o=[...this._terminalInstances.entries()].map(([g,l])=>(0,_.createCancelablePromise)(async h=>{if(g.name!==n||l.lastUsedAt!==-1&&await(0,r.hasChildProcesses)(await g.processId))return null;const w=Date.now();return l.lastUsedAt+I.minUseDelay>w||h.isCancellationRequested||l.config!==a?null:(l.lastUsedAt=w,g)}));return await(0,_.firstParallel)(o,g=>!!g)}insert(a,n){this._terminalInstances.set(a,{lastUsedAt:Date.now(),config:n})}free(a){const n=this._terminalInstances.get(a);n&&(n.lastUsedAt=-1)}onTerminalClosed(a){this._terminalInstances.delete(a)}}}),define(De[334],Ie([1,0,13,2,96,37,61,38,50,43,20,26,88,15,18,84,24,75,52]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let f=class extends p.ExtHostTaskBase{constructor(I,i,a,n,t,o,g,l,h){super(I,i,a,n,t,o,g,l),this.workspaceService=a,this.variableResolver=h,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(C.Schemas.vscodeRemote,{scheme:C.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(C.Schemas.file,{scheme:C.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(I,i){const a=i;if(!i.execution&&a._id===void 0)throw new Error("Tasks to execute must include an execution");if(a._id!==void 0){const n=p.TaskHandleDTO.from(a,this.workspaceService),t=await this._proxy.$getTaskExecution(n);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const o=await this.getTaskExecution(t,i);return this._proxy.$executeTask(n).catch(()=>{}),o}else{const n=p.TaskDTO.from(i,I);if(n===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(n.execution)&&await this.addCustomExecution(n,i,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(n),i);return this._proxy.$executeTask(n).catch(()=>{}),t}}provideTasksInternal(I,i,a,n){const t=[];if(n)for(const o of n){this.checkDeprecation(o,a),(!o.definition||!I[o.definition.type])&&this._logService.warn(`The task [${o.source}, ${o.name}] uses an undefined task type. The task will be ignored in the future.`);const g=p.TaskDTO.from(o,a.extension);g&&(t.push(g),p.CustomExecutionDTO.is(g.execution)&&i.push(this.addCustomExecution(g,o,!0)))}return{tasks:t,extension:a.extension}}async resolveTaskInternal(I){return I}async getAFolder(I){let i=I&&I.length>0?I[0]:void 0;if(!i){const a=L.URI.file((0,s.homedir)());i=new y.WorkspaceFolder({uri:a,name:r.basename(a),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(I,i){const a=L.URI.revive(I),n={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(a),o=await this._workspaceProvider.getWorkspaceFolders2()??[],g=await this.variableResolver.getResolver(),l=t?{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(o);for(const h of i.variables)n.variables[h]=await g.resolveAsync(l,h);if(i.process!==void 0){let h;if(i.process.path!==void 0){h=i.process.path.split(_.delimiter);for(let w=0;w<h.length;w++)h[w]=await g.resolveAsync(l,h[w])}n.process=await d.win32.findExecutable(await g.resolveAsync(l,i.process.name),i.process.cwd!==void 0?await g.resolveAsync(l,i.process.cwd):void 0,h)}return n}async $jsonTasksSupported(){return!0}async $findExecutable(I,i,a){return d.win32.findExecutable(I,i,a)}};e.ExtHostTask=f,e.ExtHostTask=f=Ve([$e(0,R.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,T.IExtHostDocumentsAndEditors),$e(4,m.IExtHostConfiguration),$e(5,v.IExtHostTerminalService),$e(6,D.ILogService),$e(7,b.IExtHostApiDeprecationService),$e(8,c.IExtHostVariableResolverProvider)],f)}),define(De[335],Ie([1,0,75,52]),function(me,e,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class d extends L.ExtHostVariableResolverProviderService{homeDir(){return(0,_.homedir)()}}e.NodeExtHostVariableResolverProviderService=d}),define(De[146],Ie([1,0,19,17,21,45,15,13,24,2,35]),function(me,e,_,L,d,A,T,m,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(c,f,S,I){this.query=c,this.provider=f,this.fileUtils=S,this.processType=I,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,f){const S=this.query.folderQueries||[],I=new d.CancellationTokenSource;return f.onCancellationRequested(()=>I.cancel()),new Promise((i,a)=>{this.collector=new C(c);let n=!1;const t=(o,g)=>{if(!n&&!this.isLimitHit){const l=this.resultSize(o);b(o)&&typeof this.query.maxResults=="number"&&this.resultCount+l>this.query.maxResults&&(this.isLimitHit=!0,n=!0,I.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const h=this.resultSize(o);this.resultCount+=h,(h>0||!b(o))&&this.collector.add(o,g)}};Promise.all(S.map((o,g)=>this.searchInFolder(o,l=>t(l,g),I.token))).then(o=>{I.dispose(),this.collector.flush();const g=o.some(l=>!!l&&!!l.limitHit);i({limitHit:this.isLimitHit||g,messages:(0,_.flatten)(o.map(l=>l?.message?Array.isArray(l.message)?l.message:[l.message]:[])),stats:{type:this.processType}})},o=>{I.dispose();const g=(0,A.toErrorMessage)(o);a(new Error(g))})})}resultSize(c){return b(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,f){const S=Array.isArray(c.ranges)?c.ranges:[c.ranges],I=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:S.slice(0,f),preview:{matches:I.slice(0,f),text:c.preview.text},uri:c.uri}}async searchInFolder(c,f,S){const I=new R.QueryGlobTester(this.query,c),i=[],a={report:o=>{if(!this.validateProviderResult(o))return;const g=c.folder.scheme===T.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(o.uri))):void 0,l=y.relativePath(c.folder,o.uri);if(l){const h=I.includedInQuery(l,m.basename(l),g);(0,L.isThenable)(h)?i.push(h.then(w=>{w&&f(o)})):h&&f(o)}}},n=this.getSearchOptionsForFolder(c),t=await this.provider.provideTextSearchResults(p(this.query.contentPattern),n,a,S);return i.length&&await Promise.all(i),t}validateProviderResult(c){if(b(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const f=(0,R.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),S=(0,R.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),I={folder:v.URI.from(c.folder),excludes:S,includes:f,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return I.usePCRE2=this.query.usePCRE2,I}}e.TextSearchManager=k;function p(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class C{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new r(512,f=>this.sendItems(f))}add(c,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!y.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(D(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=C;function D(s){return b(s)?{preview:{matches:(0,_.mapArrayOrNot)(s.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:s.preview.text},ranges:(0,_.mapArrayOrNot)(s.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function b(s){return!!s.preview}e.extensionResultIsMatch=b;class r{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(c,f){this.maxBatchSize=c,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,f){c&&this.addItemToBatch(c,f)}addItems(c,f){c&&this.addItemsToBatch(c,f)}addItemToBatch(c,f){this.batch.push(c),this.batchSize+=f,this.onUpdate()}addItemsToBatch(c,f){this.batch=this.batch.concat(c),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<r.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},r.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=r}),define(De[91],Ie([1,0,4,6,5,328,20,58,18,2,146]),function(me,e,_,L,d,A,T,m,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,d.createDecorator)("IExtHostSearch");let k=class{constructor(b,r,s){this.extHostRpc=b,this._uriTransformer=r,this._logService=s,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}registerTextSearchProvider(b,r){if(this._textSearchUsedSchemes.has(b))throw new Error(`a text search provider for the scheme '${b}' is already registered`);this._textSearchUsedSchemes.add(b);const s=this._handlePool++;return this._textSearchProvider.set(s,r),this._proxy.$registerTextSearchProvider(s,this._transformScheme(b)),(0,_.toDisposable)(()=>{this._textSearchUsedSchemes.delete(b),this._textSearchProvider.delete(s),this._proxy.$unregisterProvider(s)})}registerFileSearchProvider(b,r){if(this._fileSearchUsedSchemes.has(b))throw new Error(`a file search provider for the scheme '${b}' is already registered`);this._fileSearchUsedSchemes.add(b);const s=this._handlePool++;return this._fileSearchProvider.set(s,r),this._proxy.$registerFileSearchProvider(s,this._transformScheme(b)),(0,_.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(b),this._fileSearchProvider.delete(s),this._proxy.$unregisterProvider(s)})}$provideFileSearchResults(b,r,s,c){const f=p(s),S=this._fileSearchProvider.get(b);if(S)return this._fileSearchManager.fileSearch(f,S,I=>{this._proxy.$handleFileMatch(b,r,I.map(i=>i.resource))},c);throw new Error("unknown provider: "+b)}$clearCache(b){return this._fileSearchManager.clearCache(b),Promise.resolve(void 0)}$provideTextSearchResults(b,r,s,c){const f=this._textSearchProvider.get(b);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${b}`);const S=p(s);return this.createTextSearchManager(S,f).search(i=>this._proxy.$handleTextMatch(b,r,i),c)}$enableExtensionHostSearch(){}createTextSearchManager(b,r){return new R.TextSearchManager(b,r,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.ExtHostSearch=k,e.ExtHostSearch=k=Ve([$e(0,T.IExtHostRpcService),$e(1,m.IURITransformerService),$e(2,y.ILogService)],k);function p(D){return{...D,folderQueries:D.folderQueries&&D.folderQueries.map(C),extraFileResources:D.extraFileResources&&D.extraFileResources.map(b=>v.URI.revive(b))}}e.reviveQuery=p;function C(D){return{...D,folder:v.URI.revive(D.folder)}}}),define(De[336],Ie([1,0,21,8,3,40,2,124,117,161,177,30,6,105,283,282,36,284,38,286,287,288,265,289,61,44,290,291,296,297,298,145,269,304,305,308,109,43,310,273,16,7,80,313,86,144,37,25,261,295,79,142,88,90,91,18,58,20,26,299,259,64,84,279,311,85,63,316,314,315,280,51,309,312,108,62,83,300,87,301,15,127,268,248,293,4,27,255,106,244,302,303,281,292,267,306,294,107,307]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c,f,S,I,i,a,n,t,o,g,l,h,w,u,E,P,O,N,F,x,B,U,X,j,ge,ie,te,$,H,ce,re,fe,he,z,Z,ye,Re,ne,ee,de,K,le,oe,ue,Ee,M,q,G,J,be,se,we,ke,Ue,He,Je,Ge,et,Qe,st,tt,Pe,_e,ze,Y,Q,Se,Be,Me,Xe,Ze,rt,ft,wt,Lt,At,yt,Ft,Ot,xt,zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Nt(at){const ht=at.get(K.IExtHostInitDataService),Wt=at.get(Ue.IExtHostFileSystemInfo),Mt=at.get(J.IExtHostConsumerFileSystem),Ct=at.get(t.IExtHostExtensionService),ct=at.get(H.IExtHostWorkspace),Tt=at.get(Qe.IExtHostTelemetry),Ut=at.get(c.IExtHostConfiguration),Fe=at.get(ee.IURITransformerService),Ae=at.get(de.IExtHostRpcService),Te=at.get(F.IExtHostStorage),ae=at.get(G.IExtensionStoragePaths),Oe=at.get(ne.ILoggerService),We=at.get(ne.ILogService),Ke=at.get(ue.IExtHostTunnelService),je=at.get(Ee.IExtHostApiDeprecationService),it=at.get($.IExtHostWindow),Et=at.get(Ge.IExtHostSecretState),Dt=at.get(et.IExtHostEditorTabs),It=at.get(xt.IExtHostManagedSockets);Ae.set(p.ExtHostContext.ExtHostFileSystemInfo,Wt),Ae.set(p.ExtHostContext.ExtHostLogLevelServiceShape,Oe),Ae.set(p.ExtHostContext.ExtHostWorkspace,ct),Ae.set(p.ExtHostContext.ExtHostConfiguration,Ut),Ae.set(p.ExtHostContext.ExtHostExtensionService,Ct),Ae.set(p.ExtHostContext.ExtHostStorage,Te),Ae.set(p.ExtHostContext.ExtHostTunnelService,Ke),Ae.set(p.ExtHostContext.ExtHostWindow,it),Ae.set(p.ExtHostContext.ExtHostSecretState,Et),Ae.set(p.ExtHostContext.ExtHostTelemetry,Tt),Ae.set(p.ExtHostContext.ExtHostEditorTabs,Dt),Ae.set(p.ExtHostContext.ExtHostManagedSockets,It);const bt=Ae.set(p.ExtHostContext.ExtHostDecorations,at.get(z.IExtHostDecorations)),pt=Ae.set(p.ExtHostContext.ExtHostDocumentsAndEditors,at.get(n.IExtHostDocumentsAndEditors)),dt=Ae.set(p.ExtHostContext.ExtHostCommands,at.get(r.IExtHostCommands)),vt=Ae.set(p.ExtHostContext.ExtHostTerminalService,at.get(x.IExtHostTerminalService)),gt=Ae.set(p.ExtHostContext.ExtHostDebugService,at.get(ye.IExtHostDebugService)),Qt=Ae.set(p.ExtHostContext.ExtHostSearch,at.get(Re.IExtHostSearch)),$t=Ae.set(p.ExtHostContext.ExtHostTask,at.get(Z.IExtHostTask)),Yi=Ae.set(p.ExtHostContext.ExtHostOutputService,at.get(u.IExtHostOutputService)),di=Ae.set(p.ExtHostContext.ExtHostLocalization,at.get(Ze.IExtHostLocalizationService)),hi=Ae.set(p.ExtHostContext.ExtHostUrls,new ie.ExtHostUrls(Ae)),kt=Ae.set(p.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(Ae,pt)),Si=Ae.set(p.ExtHostContext.ExtHostDocumentContentProviders,new I.ExtHostDocumentContentProvider(Ae,pt,We)),jt=Ae.set(p.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(We,kt,Ae.getProxy(p.MainContext.MainThreadBulkEdits))),_t=Ae.set(p.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(Ae,dt,pt,kt,Mt)),yi=Ae.set(p.ExtHostContext.ExtHostNotebookDocuments,new Q.ExtHostNotebookDocuments(_t)),fi=Ae.set(p.ExtHostContext.ExtHostNotebookEditors,new Y.ExtHostNotebookEditors(We,_t)),ai=Ae.set(p.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(Ae,ht,_t,dt,We)),Ji=Ae.set(p.ExtHostContext.ExtHostNotebookRenderers,new Pe.ExtHostNotebookRenderers(Ae,_t)),ni=Ae.set(p.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new yt.ExtHostNotebookDocumentSaveParticipant(We,_t,Ae.getProxy(p.MainContext.MainThreadBulkEdits))),Rt=Ae.set(p.ExtHostContext.ExtHostEditors,new B.ExtHostEditors(Ae,pt)),mi=Ae.set(p.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(Ae.getProxy(p.MainContext.MainThreadTreeViews),dt,We)),_i=Ae.set(p.ExtHostContext.ExtHostEditorInsets,new re.ExtHostEditorInsets(Ae.getProxy(p.MainContext.MainThreadEditorInsets),Rt,ht.remote)),ri=Ae.set(p.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(Ae,We,Wt,pt)),si=Ae.set(p.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(Ae,kt,dt.converter,Fe)),lt=Ae.set(p.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(Ae,Fe,kt,dt,ri,We,je,Tt)),Ci=Ae.set(p.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(Ae,lt)),qt=Ae.set(p.ExtHostContext.ExtHostFileSystemEventService,new g.ExtHostFileSystemEventService(Ae,We,pt)),Zt=Ae.set(p.ExtHostContext.ExtHostQuickOpen,(0,P.createExtHostQuickOpen)(Ae,ct,dt)),gi=Ae.set(p.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(Ae,dt,kt,We)),xi=Ae.set(p.ExtHostContext.ExtHostQuickDiff,new wt.ExtHostQuickDiff(Ae,Fe)),Di=Ae.set(p.ExtHostContext.ExtHostShare,new zt.ExtHostShare(Ae,Fe)),Ii=Ae.set(p.ExtHostContext.ExtHostComments,(0,s.createExtHostComments)(Ae,dt,kt)),pi=Ae.set(p.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(Ae.getProxy(p.MainContext.MainThreadProgress))),ki=Ae.set(p.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(Ae)),Pi=Ae.set(p.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(Ae)),ei=Ae.set(p.ExtHostContext.ExtHostAuthentication,new M.ExtHostAuthentication(Ae)),Ti=Ae.set(p.ExtHostContext.ExtHostTimeline,new q.ExtHostTimeline(Ae,dt)),vi=Ae.set(p.ExtHostContext.ExtHostWebviews,new te.ExtHostWebviews(Ae,ht.remote,ct,We,je)),bi=Ae.set(p.ExtHostContext.ExtHostWebviewPanels,new we.ExtHostWebviewPanels(Ae,vi,ct)),Ui=Ae.set(p.ExtHostContext.ExtHostCustomEditors,new se.ExtHostCustomEditors(Ae,kt,ae,vi,bi)),Bi=Ae.set(p.ExtHostContext.ExtHostWebviewViews,new be.ExtHostWebviewViews(Ae,vi)),oi=Ae.set(p.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(Ae,dt,pt)),Zi=Ae.set(p.ExtHostContext.ExtHostUriOpeners,new Je.ExtHostUriOpeners(Ae)),en=Ae.set(p.ExtHostContext.ExtHostProfileContentHandlers,new ft.ExtHostProfileContentHandlers(Ae));Ae.set(p.ExtHostContext.ExtHostInteractive,new Se.ExtHostInteractive(Ae,_t,pt,dt,We));const Ai=Ae.set(p.ExtHostContext.ExtHostInlineChat,new At.ExtHostInteractiveEditor(Ae,dt,kt,We)),Yt=Ae.set(p.ExtHostContext.ExtHostChat,new Lt.ExtHostChat(Ae,We)),tn=Ae.set(p.ExtHostContext.ExtHostSemanticSimilarity,new Ft.ExtHostSemanticSimilarity(Ae)),nn=Ae.set(p.ExtHostContext.ExtHostIssueReporter,new Ot.ExtHostIssueReporter(Ae)),Ri=Ae.set(p.ExtHostContext.ExtHostStatusBar,new N.ExtHostStatusBar(Ae,dt.converter)),Li=Object.values(p.ExtHostContext);Ae.assertRegistered(Li);const zi=new ke.ExtHostBulkEdits(Ae,pt),Wi=new b.ExtHostClipboard(Ae),Ei=new w.ExtHostMessageService(Ae,We),$i=new S.ExtHostDialogs(Ae);return D.ExtHostApiCommands.register(dt),function(xe,Gt,Kt){const mt=function(){let pe=!xe.isUnderDevelopment;function Ce(){pe||(We.info(`Extension '${xe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function Ne(nt){if(Array.isArray(nt))nt.forEach(Ne);else if(typeof nt=="string")Ce();else{const St=nt;typeof St.scheme>"u"&&Ce(),typeof St.exclusive=="boolean"&&(0,Me.checkProposedApiEnabled)(xe,"documentFiltersExclusive")}return nt}}(),rn={getSession(pe,Ce,Ne){return ei.getSession(xe,pe,Ce,Ne)},getSessions(pe,Ce){return(0,Me.checkProposedApiEnabled)(xe,"authGetSessions"),ei.getSessions(xe,pe,Ce)},async hasSession(pe,Ce){return(0,Me.checkProposedApiEnabled)(xe,"authSession"),!!await ei.getSession(xe,pe,Ce,{silent:!0})},get onDidChangeSessions(){return ei.onDidChangeSessions},registerAuthenticationProvider(pe,Ce,Ne,nt){return ei.registerAuthenticationProvider(pe,Ce,Ne,nt)}},Ht={registerCommand(pe,Ce,Ne){return dt.registerCommand(!0,pe,Ce,Ne,void 0,xe)},registerTextEditorCommand(pe,Ce,Ne){return dt.registerCommand(!0,pe,(...nt)=>{const St=Rt.getActiveTextEditor();if(!St){We.warn("Cannot execute "+pe+" because there is no active text editor.");return}return St.edit(Pt=>{Ce.apply(Ne,[St,Pt,...nt])}).then(Pt=>{Pt||We.warn("Edits from command "+pe+" were not applied.")},Pt=>{We.warn("An error occurred while running command "+pe,Pt)})},void 0,void 0,xe)},registerDiffInformationCommand:(pe,Ce,Ne)=>((0,Me.checkProposedApiEnabled)(xe,"diffCommand"),dt.registerCommand(!0,pe,async(...nt)=>{const St=pt.activeEditor(!0);if(!St){We.warn("Cannot execute "+pe+" because there is no active text editor.");return}const Pt=await Rt.getDiffInformation(St.id);Ce.apply(Ne,[Pt,...nt])},void 0,void 0,xe)),executeCommand(pe,...Ce){return dt.executeCommand(pe,...Ce)},getCommands(pe=!1){return dt.getCommands(pe)}},ci={get machineId(){return ht.telemetryInfo.machineId},get sessionId(){return ht.telemetryInfo.sessionId},get language(){return ht.environment.appLanguage},get appName(){return ht.environment.appName},get appRoot(){return ht.environment.appRoot?.fsPath??""},get appHost(){return ht.environment.appHost},get uriScheme(){return ht.environment.appUriScheme},get clipboard(){return Wi.value},get shell(){return vt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Me.checkProposedApiEnabled)(xe,"envShellEvent"),vt.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Me.checkProposedApiEnabled)(xe,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Me.checkProposedApiEnabled)(xe,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Qe.isNewAppInstall)(ht.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe,Ce){return Qe.ExtHostTelemetryLogger.validateSender(pe),Tt.instantiateLogger(xe,pe,Ce)},openExternal(pe,Ce){return it.openUri(pe,{allowTunneling:!!ht.remote.authority,allowContributedOpeners:Ce?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===ht.environment.appUriScheme)return hi.createAppUri(pe);try{return await it.asExternalUri(pe,{allowTunneling:!!ht.remote.authority})}catch(Ce){if((0,ze.matchesScheme)(pe,_e.Schemas.http)||(0,ze.matchesScheme)(pe,_e.Schemas.https))return pe;throw Ce}},get remoteName(){return(0,he.getRemoteName)(ht.remote.authority)},get remoteAuthority(){return(0,Me.checkProposedApiEnabled)(xe,"resolvers"),ht.remote.authority},get uiKind(){return ht.uiKind},get logLevel(){return We.getLevel()},get onDidChangeLogLevel(){return We.onDidChangeLogLevel},registerIssueUriRequestHandler(pe){return(0,Me.checkProposedApiEnabled)(xe,"handleIssueUri"),nn.registerIssueUriRequestHandler(xe,pe)},get appQuality(){return(0,Me.checkProposedApiEnabled)(xe,"resolvers"),ht.quality},get appCommit(){return(0,Me.checkProposedApiEnabled)(xe,"resolvers"),ht.commit}};ht.environment.extensionTestsLocationURI||Object.freeze(ci);const Hi={createTestController(pe,Ce,Ne){return oi.createTestController(xe,pe,Ce,Ne)},createTestObserver(){return(0,Me.checkProposedApiEnabled)(xe,"testObserver"),oi.createTestObserver()},runTests(pe){return(0,Me.checkProposedApiEnabled)(xe,"testObserver"),oi.runTests(pe)},get onDidChangeTestResults(){return(0,Me.checkProposedApiEnabled)(xe,"testObserver"),oi.onResultsChanged},get testResults(){return(0,Me.checkProposedApiEnabled)(xe,"testObserver"),oi.results}},li=ht.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,Vi={getExtension(pe,Ce){(0,Me.isProposedApiEnabled)(xe,"extensionsAny")||(Ce=!1);const Ne=Gt.mine.getExtensionDescription(pe);if(Ne)return new t.Extension(Ct,xe.identifier,Ne,li,!1);if(Ce){const nt=Gt.all.getExtensionDescription(pe);if(nt)return new t.Extension(Ct,xe.identifier,nt,li,!0)}},get all(){const pe=[];for(const Ce of Gt.mine.getAllExtensionDescriptions())pe.push(new t.Extension(Ct,xe.identifier,Ce,li,!1));return pe},get allAcrossExtensionHosts(){(0,Me.checkProposedApiEnabled)(xe,"extensionsAny");const pe=new ce.ExtensionIdentifierSet(Gt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),Ce=[];for(const Ne of Gt.all.getAllExtensionDescriptions()){const nt=!pe.has(Ne.identifier);Ce.push(new t.Extension(Ct,xe.identifier,Ne,li,nt))}return Ce},get onDidChange(){return(0,Me.isProposedApiEnabled)(xe,"extensionsAny")?d.Event.any(Gt.mine.onDidChange,Gt.all.onDidChange):Gt.mine.onDidChange}},ji={createDiagnosticCollection(pe){return ri.createDiagnosticCollection(xe.identifier,pe)},get onDidChangeDiagnostics(){return ri.onDidChangeDiagnostics},getDiagnostics:pe=>ri.getDiagnostics(pe),getLanguages(){return si.getLanguages()},setTextDocumentLanguage(pe,Ce){return si.changeLanguage(pe.uri,Ce)},match(pe,Ce){const Ne=kt.getDocumentData(Ce.uri)?.notebook;return(0,R.score)(X.LanguageSelector.from(pe),Ce.uri,Ce.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(pe,Ce,Ne){return lt.registerCodeActionProvider(xe,mt(pe),Ce,Ne)},registerDocumentPasteEditProvider(pe,Ce,Ne){return(0,Me.checkProposedApiEnabled)(xe,"documentPaste"),lt.registerDocumentPasteEditProvider(xe,mt(pe),Ce,Ne)},registerCodeLensProvider(pe,Ce){return lt.registerCodeLensProvider(xe,mt(pe),Ce)},registerDefinitionProvider(pe,Ce){return lt.registerDefinitionProvider(xe,mt(pe),Ce)},registerDeclarationProvider(pe,Ce){return lt.registerDeclarationProvider(xe,mt(pe),Ce)},registerImplementationProvider(pe,Ce){return lt.registerImplementationProvider(xe,mt(pe),Ce)},registerTypeDefinitionProvider(pe,Ce){return lt.registerTypeDefinitionProvider(xe,mt(pe),Ce)},registerHoverProvider(pe,Ce){return lt.registerHoverProvider(xe,mt(pe),Ce,xe.identifier)},registerEvaluatableExpressionProvider(pe,Ce){return lt.registerEvaluatableExpressionProvider(xe,mt(pe),Ce,xe.identifier)},registerInlineValuesProvider(pe,Ce){return lt.registerInlineValuesProvider(xe,mt(pe),Ce,xe.identifier)},registerDocumentHighlightProvider(pe,Ce){return lt.registerDocumentHighlightProvider(xe,mt(pe),Ce)},registerLinkedEditingRangeProvider(pe,Ce){return lt.registerLinkedEditingRangeProvider(xe,mt(pe),Ce)},registerReferenceProvider(pe,Ce){return lt.registerReferenceProvider(xe,mt(pe),Ce)},registerRenameProvider(pe,Ce){return lt.registerRenameProvider(xe,mt(pe),Ce)},registerDocumentSymbolProvider(pe,Ce,Ne){return lt.registerDocumentSymbolProvider(xe,mt(pe),Ce,Ne)},registerWorkspaceSymbolProvider(pe){return lt.registerWorkspaceSymbolProvider(xe,pe)},registerDocumentFormattingEditProvider(pe,Ce){return lt.registerDocumentFormattingEditProvider(xe,mt(pe),Ce)},registerDocumentRangeFormattingEditProvider(pe,Ce){return lt.registerDocumentRangeFormattingEditProvider(xe,mt(pe),Ce)},registerOnTypeFormattingEditProvider(pe,Ce,Ne,...nt){return lt.registerOnTypeFormattingEditProvider(xe,mt(pe),Ce,[Ne].concat(nt))},registerDocumentSemanticTokensProvider(pe,Ce,Ne){return lt.registerDocumentSemanticTokensProvider(xe,mt(pe),Ce,Ne)},registerDocumentRangeSemanticTokensProvider(pe,Ce,Ne){return lt.registerDocumentRangeSemanticTokensProvider(xe,mt(pe),Ce,Ne)},registerSignatureHelpProvider(pe,Ce,Ne,...nt){return typeof Ne=="object"?lt.registerSignatureHelpProvider(xe,mt(pe),Ce,Ne):lt.registerSignatureHelpProvider(xe,mt(pe),Ce,typeof Ne>"u"?[]:[Ne,...nt])},registerCompletionItemProvider(pe,Ce,...Ne){return lt.registerCompletionItemProvider(xe,mt(pe),Ce,Ne)},registerInlineCompletionItemProvider(pe,Ce,Ne){return Ce.handleDidShowCompletionItem&&(0,Me.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),Ce.handleDidPartiallyAcceptCompletionItem&&(0,Me.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),Ne&&(0,Me.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(xe,mt(pe),Ce,Ne)},registerDocumentLinkProvider(pe,Ce){return lt.registerDocumentLinkProvider(xe,mt(pe),Ce)},registerColorProvider(pe,Ce){return lt.registerColorProvider(xe,mt(pe),Ce)},registerFoldingRangeProvider(pe,Ce){return lt.registerFoldingRangeProvider(xe,mt(pe),Ce)},registerSelectionRangeProvider(pe,Ce){return lt.registerSelectionRangeProvider(xe,pe,Ce)},registerCallHierarchyProvider(pe,Ce){return lt.registerCallHierarchyProvider(xe,pe,Ce)},registerTypeHierarchyProvider(pe,Ce){return lt.registerTypeHierarchyProvider(xe,pe,Ce)},setLanguageConfiguration:(pe,Ce)=>lt.setLanguageConfiguration(xe,pe,Ce),getTokenInformationAtPosition(pe,Ce){return(0,Me.checkProposedApiEnabled)(xe,"tokenInformation"),si.tokenAtPosition(pe,Ce)},registerInlayHintsProvider(pe,Ce){return lt.registerInlayHintsProvider(xe,pe,Ce)},createLanguageStatusItem(pe,Ce){return si.createLanguageStatusItem(xe,pe,Ce)},registerDocumentDropEditProvider(pe,Ce,Ne){return lt.registerDocumentOnDropEditProvider(xe,pe,Ce,(0,Me.isProposedApiEnabled)(xe,"dropMetadata")?Ne:void 0)}},sn={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(pe,Ce,Ne){const nt=await(T.URI.isUri(pe)?Promise.resolve(Fi.openTextDocument(pe)):Promise.resolve(pe));return Rt.showTextDocument(nt,Ce,Ne)},createTextEditorDecorationType(pe){return Rt.createTextEditorDecorationType(xe,pe)},onDidChangeActiveTextEditor(pe,Ce,Ne){return Rt.onDidChangeActiveTextEditor(pe,Ce,Ne)},onDidChangeVisibleTextEditors(pe,Ce,Ne){return Rt.onDidChangeVisibleTextEditors(pe,Ce,Ne)},onDidChangeTextEditorSelection(pe,Ce,Ne){return Rt.onDidChangeTextEditorSelection(pe,Ce,Ne)},onDidChangeTextEditorOptions(pe,Ce,Ne){return Rt.onDidChangeTextEditorOptions(pe,Ce,Ne)},onDidChangeTextEditorVisibleRanges(pe,Ce,Ne){return Rt.onDidChangeTextEditorVisibleRanges(pe,Ce,Ne)},onDidChangeTextEditorViewColumn(pe,Ce,Ne){return Rt.onDidChangeTextEditorViewColumn(pe,Ce,Ne)},onDidCloseTerminal(pe,Ce,Ne){return vt.onDidCloseTerminal(pe,Ce,Ne)},onDidOpenTerminal(pe,Ce,Ne){return vt.onDidOpenTerminal(pe,Ce,Ne)},onDidChangeActiveTerminal(pe,Ce,Ne){return vt.onDidChangeActiveTerminal(pe,Ce,Ne)},onDidChangeTerminalDimensions(pe,Ce,Ne){return(0,Me.checkProposedApiEnabled)(xe,"terminalDimensions"),vt.onDidChangeTerminalDimensions(pe,Ce,Ne)},onDidChangeTerminalState(pe,Ce,Ne){return vt.onDidChangeTerminalState(pe,Ce,Ne)},onDidWriteTerminalData(pe,Ce,Ne){return(0,Me.checkProposedApiEnabled)(xe,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(pe,Ce,Ne)},get state(){return it.getState(xe)},onDidChangeWindowState(pe,Ce,Ne){return it.onDidChangeWindowState(pe,Ce,Ne)},showInformationMessage(pe,...Ce){return Ei.showMessage(xe,A.default.Info,pe,Ce[0],Ce.slice(1))},showWarningMessage(pe,...Ce){return Ei.showMessage(xe,A.default.Warning,pe,Ce[0],Ce.slice(1))},showErrorMessage(pe,...Ce){return Ei.showMessage(xe,A.default.Error,pe,Ce[0],Ce.slice(1))},showQuickPick(pe,Ce,Ne){return Zt.showQuickPick(xe,pe,Ce,Ne)},showWorkspaceFolderPick(pe){return Zt.showWorkspaceFolderPick(pe)},showInputBox(pe,Ce){return Zt.showInput(pe,Ce)},showOpenDialog(pe){return $i.showOpenDialog(xe,pe)},showSaveDialog(pe){return $i.showSaveDialog(pe)},createStatusBarItem(pe,Ce,Ne){let nt,St,Pt;return typeof pe=="string"?(nt=pe,St=Ce,Pt=Ne):(St=pe,Pt=Ce),Ri.createStatusBarEntry(xe,nt,St,Pt)},setStatusBarMessage(pe,Ce){return Ri.setStatusBarMessage(pe,Ce)},withScmProgress(pe){return je.report("window.withScmProgress",xe,"Use 'withProgress' instead."),pi.withProgress(xe,{location:j.ProgressLocation.SourceControl},(Ce,Ne)=>pe({report(nt){}}))},withProgress(pe,Ce){return pi.withProgress(xe,pe,Ce)},createOutputChannel(pe,Ce){return Yi.createOutputChannel(pe,Ce,xe)},createWebviewPanel(pe,Ce,Ne,nt){return bi.createWebviewPanel(xe,pe,Ce,Ne,nt)},createWebviewTextEditorInset(pe,Ce,Ne,nt){return(0,Me.checkProposedApiEnabled)(xe,"editorInsets"),_i.createWebviewEditorInset(pe,Ce,Ne,nt,xe)},createTerminal(pe,Ce,Ne){return typeof pe=="object"?"pty"in pe?vt.createExtensionTerminal(pe):vt.createTerminalFromOptions(pe):vt.createTerminal(pe,Ce,Ne)},registerTerminalLinkProvider(pe){return vt.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,Ce){return vt.registerProfileProvider(xe,pe,Ce)},registerTerminalQuickFixProvider(pe,Ce){return(0,Me.checkProposedApiEnabled)(xe,"terminalQuickFixProvider"),vt.registerTerminalQuickFixProvider(pe,xe.identifier.value,Ce)},registerTreeDataProvider(pe,Ce){return mi.registerTreeDataProvider(pe,Ce,xe)},createTreeView(pe,Ce){return mi.createTreeView(pe,Ce,xe)},registerWebviewPanelSerializer:(pe,Ce)=>bi.registerWebviewPanelSerializer(xe,pe,Ce),registerCustomEditorProvider:(pe,Ce,Ne={})=>Ui.registerCustomEditorProvider(xe,pe,Ce,Ne),registerFileDecorationProvider(pe){return bt.registerFileDecorationProvider(pe,xe)},registerUriHandler(pe){return hi.registerUriHandler(xe,pe)},createQuickPick(){return Zt.createQuickPick(xe)},createInputBox(){return Zt.createInputBox(xe)},get activeColorTheme(){return Pi.activeColorTheme},onDidChangeActiveColorTheme(pe,Ce,Ne){return Pi.onDidChangeActiveColorTheme(pe,Ce,Ne)},registerWebviewViewProvider(pe,Ce,Ne){return Bi.registerWebviewViewProvider(xe,pe,Ce,Ne?.webviewOptions)},get activeNotebookEditor(){return _t.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,Ce,Ne){return _t.onDidChangeActiveNotebookEditor(pe,Ce,Ne)},get visibleNotebookEditors(){return _t.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return _t.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,Ce,Ne){return fi.onDidChangeNotebookEditorSelection(pe,Ce,Ne)},onDidChangeNotebookEditorVisibleRanges(pe,Ce,Ne){return fi.onDidChangeNotebookEditorVisibleRanges(pe,Ce,Ne)},showNotebookDocument(pe,Ce){return _t.showNotebookDocument(pe,Ce)},registerExternalUriOpener(pe,Ce,Ne){return(0,Me.checkProposedApiEnabled)(xe,"externalUriOpener"),Zi.registerExternalUriOpener(xe.identifier,pe,Ce,Ne)},registerProfileContentHandler(pe,Ce){return(0,Me.checkProposedApiEnabled)(xe,"profileContentHandlers"),en.registrProfileContentHandler(xe,pe,Ce)},registerQuickDiffProvider(pe,Ce,Ne,nt){return(0,Me.checkProposedApiEnabled)(xe,"quickDiffProvider"),xi.registerQuickDiffProvider(mt(pe),Ce,Ne,nt)},get tabGroups(){return Dt.tabGroups},registerShareProvider(pe,Ce){return(0,Me.checkProposedApiEnabled)(xe,"shareProvider"),Di.registerShareProvider(mt(pe),Ce)}},Fi={get rootPath(){return je.report("workspace.rootPath",xe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ct.getPath()},set rootPath(pe){throw L.readonly()},getWorkspaceFolder(pe){return ct.getWorkspaceFolder(pe)},get workspaceFolders(){return ct.getWorkspaceFolders()},get name(){return ct.name},set name(pe){throw L.readonly()},get workspaceFile(){return ct.workspaceFile},set workspaceFile(pe){throw L.readonly()},updateWorkspaceFolders:(pe,Ce,...Ne)=>ct.updateWorkspaceFolders(xe,pe,Ce||0,...Ne),onDidChangeWorkspaceFolders:function(pe,Ce,Ne){return ct.onDidChangeWorkspace(pe,Ce,Ne)},asRelativePath:(pe,Ce)=>ct.getRelativePath(pe,Ce),findFiles:(pe,Ce,Ne,nt)=>ct.findFiles(pe,Ce,Ne,xe.identifier,nt),findTextInFiles:(pe,Ce,Ne,nt)=>{(0,Me.checkProposedApiEnabled)(xe,"findTextInFiles");let St,Pt;return typeof Ce=="object"?(St=Ce,Pt=Ne):(St={},Pt=Ce,nt=Ne),ct.findTextInFiles(pe,St||{},Pt,xe.identifier,nt)},save:pe=>((0,Me.checkProposedApiEnabled)(xe,"saveEditor"),ct.save(pe)),saveAs:pe=>((0,Me.checkProposedApiEnabled)(xe,"saveEditor"),ct.saveAs(pe)),saveAll:pe=>ct.saveAll(pe),applyEdit(pe,Ce){return zi.applyWorkspaceEdit(pe,xe,Ce)},createFileSystemWatcher:(pe,Ce,Ne,nt)=>qt.createFileSystemWatcher(ct,xe,pe,Ce,Ne,nt),get textDocuments(){return kt.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw L.readonly()},openTextDocument(pe){let Ce;const Ne=pe;if(typeof pe=="string")Ce=Promise.resolve(T.URI.file(pe));else if(T.URI.isUri(pe))Ce=Promise.resolve(pe);else if(!Ne||typeof Ne=="object")Ce=kt.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ce.then(nt=>kt.ensureDocumentData(nt).then(St=>St.document))},onDidOpenTextDocument:(pe,Ce,Ne)=>kt.onDidAddDocument(pe,Ce,Ne),onDidCloseTextDocument:(pe,Ce,Ne)=>kt.onDidRemoveDocument(pe,Ce,Ne),onDidChangeTextDocument:(pe,Ce,Ne)=>kt.onDidChangeDocument(pe,Ce,Ne),onDidSaveTextDocument:(pe,Ce,Ne)=>kt.onDidSaveDocument(pe,Ce,Ne),onWillSaveTextDocument:(pe,Ce,Ne)=>jt.getOnWillSaveTextDocumentEvent(xe)(pe,Ce,Ne),get notebookDocuments(){return _t.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,Ce){let Ne;if(T.URI.isUri(pe))Ne=pe,await _t.openNotebookDocument(pe);else if(typeof pe=="string")Ne=T.URI.revive(await _t.createNotebookDocument({viewType:pe,content:Ce}));else throw new Error("Invalid arguments");return _t.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(pe,Ce,Ne){return yi.onDidSaveNotebookDocument(pe,Ce,Ne)},onDidChangeNotebookDocument(pe,Ce,Ne){return yi.onDidChangeNotebookDocument(pe,Ce,Ne)},onWillSaveNotebookDocument(pe,Ce,Ne){return ni.getOnWillSaveNotebookDocumentEvent(xe)(pe,Ce,Ne)},get onDidOpenNotebookDocument(){return _t.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return _t.onDidCloseNotebookDocument},registerNotebookSerializer(pe,Ce,Ne,nt){return _t.registerNotebookSerializer(xe,pe,Ce,Ne,(0,Me.isProposedApiEnabled)(xe,"notebookLiveShare")?nt:void 0)},onDidChangeConfiguration:(pe,Ce,Ne)=>Kt.onDidChangeConfiguration(pe,Ce,Ne),getConfiguration(pe,Ce){return Ce=arguments.length===1?void 0:Ce,Kt.getConfiguration(pe,Ce,xe)},registerTextDocumentContentProvider(pe,Ce){return Si.registerTextDocumentContentProvider(pe,Ce)},registerTaskProvider:(pe,Ce)=>(je.report("window.registerTaskProvider",xe,"Use the corresponding function on the 'tasks' namespace instead"),$t.registerTaskProvider(xe,pe,Ce)),registerFileSystemProvider(pe,Ce,Ne){return(0,Be.combinedDisposable)(Ci.registerFileSystemProvider(xe,pe,Ce,Ne),Mt.addFileSystemProvider(pe,Ce,Ne))},get fs(){return Mt.value},registerFileSearchProvider:(pe,Ce)=>((0,Me.checkProposedApiEnabled)(xe,"fileSearchProvider"),Qt.registerFileSearchProvider(pe,Ce)),registerTextSearchProvider:(pe,Ce)=>((0,Me.checkProposedApiEnabled)(xe,"textSearchProvider"),Qt.registerTextSearchProvider(pe,Ce)),registerRemoteAuthorityResolver:(pe,Ce)=>((0,Me.checkProposedApiEnabled)(xe,"resolvers"),Ct.registerRemoteAuthorityResolver(pe,Ce)),registerResourceLabelFormatter:pe=>((0,Me.checkProposedApiEnabled)(xe,"resolvers"),ki.$registerResourceLabelFormatter(pe)),getRemoteExecServer:pe=>((0,Me.checkProposedApiEnabled)(xe,"resolvers"),Ct.getRemoteExecServer(pe)),onDidCreateFiles:(pe,Ce,Ne)=>qt.onDidCreateFile(pe,Ce,Ne),onDidDeleteFiles:(pe,Ce,Ne)=>qt.onDidDeleteFile(pe,Ce,Ne),onDidRenameFiles:(pe,Ce,Ne)=>qt.onDidRenameFile(pe,Ce,Ne),onWillCreateFiles:(pe,Ce,Ne)=>qt.getOnWillCreateFileEvent(xe)(pe,Ce,Ne),onWillDeleteFiles:(pe,Ce,Ne)=>qt.getOnWillDeleteFileEvent(xe)(pe,Ce,Ne),onWillRenameFiles:(pe,Ce,Ne)=>qt.getOnWillRenameFileEvent(xe)(pe,Ce,Ne),openTunnel:pe=>((0,Me.checkProposedApiEnabled)(xe,"tunnels"),Ke.openTunnel(xe,pe).then(Ce=>{if(!Ce)throw new Error("cannot open tunnel");return Ce})),get tunnels(){return(0,Me.checkProposedApiEnabled)(xe,"tunnels"),Ke.getTunnels()},onDidChangeTunnels:(pe,Ce,Ne)=>((0,Me.checkProposedApiEnabled)(xe,"tunnels"),Ke.onDidChangeTunnels(pe,Ce,Ne)),registerPortAttributesProvider:(pe,Ce)=>((0,Me.checkProposedApiEnabled)(xe,"portsAttributes"),Ke.registerPortsAttributesProvider(pe,Ce)),registerTunnelProvider:(pe,Ce)=>((0,Me.checkProposedApiEnabled)(xe,"tunnelFactory"),Ke.registerTunnelProvider(pe,Ce)),registerTimelineProvider:(pe,Ce)=>((0,Me.checkProposedApiEnabled)(xe,"timeline"),Ti.registerTimelineProvider(pe,Ce,xe.identifier,dt.converter)),get isTrusted(){return ct.trusted},requestWorkspaceTrust:pe=>((0,Me.checkProposedApiEnabled)(xe,"workspaceTrust"),ct.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,Ce,Ne)=>ct.onDidGrantWorkspaceTrust(pe,Ce,Ne),registerEditSessionIdentityProvider:(pe,Ce)=>((0,Me.checkProposedApiEnabled)(xe,"editSessionIdentityProvider"),ct.registerEditSessionIdentityProvider(pe,Ce)),onWillCreateEditSessionIdentity:(pe,Ce,Ne)=>((0,Me.checkProposedApiEnabled)(xe,"editSessionIdentityProvider"),ct.getOnWillCreateEditSessionIdentityEvent(xe)(pe,Ce,Ne)),registerCanonicalUriProvider:(pe,Ce)=>((0,Me.checkProposedApiEnabled)(xe,"canonicalUriProvider"),ct.registerCanonicalUriProvider(pe,Ce)),getCanonicalUri:(pe,Ce,Ne)=>((0,Me.checkProposedApiEnabled)(xe,"canonicalUriProvider"),ct.provideCanonicalUri(pe,Ce,Ne))},qi={get inputBox(){return je.report("scm.inputBox",xe,"Use 'SourceControl.inputBox' instead"),gi.getLastInputBox(xe)},createSourceControl(pe,Ce,Ne){return gi.createSourceControl(xe,pe,Ce,Ne)}},on={createCommentController(pe,Ce){return Ii.createCommentController(xe,pe,Ce)}},an={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},get stackFrameFocus(){return gt.stackFrameFocus},onDidStartDebugSession(pe,Ce,Ne){return gt.onDidStartDebugSession(pe,Ce,Ne)},onDidTerminateDebugSession(pe,Ce,Ne){return gt.onDidTerminateDebugSession(pe,Ce,Ne)},onDidChangeActiveDebugSession(pe,Ce,Ne){return gt.onDidChangeActiveDebugSession(pe,Ce,Ne)},onDidReceiveDebugSessionCustomEvent(pe,Ce,Ne){return gt.onDidReceiveDebugSessionCustomEvent(pe,Ce,Ne)},onDidChangeBreakpoints(pe,Ce,Ne){return gt.onDidChangeBreakpoints(pe,Ce,Ne)},onDidChangeStackFrameFocus(pe,Ce,Ne){return(0,Me.checkProposedApiEnabled)(xe,"debugFocus"),gt.onDidChangeStackFrameFocus(pe,Ce,Ne)},registerDebugConfigurationProvider(pe,Ce,Ne){return gt.registerDebugConfigurationProvider(pe,Ce,Ne||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,Ce){return gt.registerDebugAdapterDescriptorFactory(xe,pe,Ce)},registerDebugAdapterTrackerFactory(pe,Ce){return gt.registerDebugAdapterTrackerFactory(pe,Ce)},startDebugging(pe,Ce,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?gt.startDebugging(pe,Ce,{parentSession:Ne}):gt.startDebugging(pe,Ce,Ne||{})},stopDebugging(pe){return gt.stopDebugging(pe)},addBreakpoints(pe){return gt.addBreakpoints(pe)},removeBreakpoints(pe){return gt.removeBreakpoints(pe)},asDebugSourceUri(pe,Ce){return gt.asDebugSourceUri(pe,Ce)}},Oi={registerTaskProvider:(pe,Ce)=>$t.registerTaskProvider(xe,pe,Ce),fetchTasks:pe=>$t.fetchTasks(pe),executeTask:pe=>$t.executeTask(xe,pe),get taskExecutions(){return $t.taskExecutions},onDidStartTask:(pe,Ce,Ne)=>$t.onDidStartTask(pe,Ce,Ne),onDidEndTask:(pe,Ce,Ne)=>$t.onDidEndTask(pe,Ce,Ne),onDidStartTaskProcess:(pe,Ce,Ne)=>$t.onDidStartTaskProcess(pe,Ce,Ne),onDidEndTaskProcess:(pe,Ce,Ne)=>$t.onDidEndTaskProcess(pe,Ce,Ne)},Gi={createNotebookController(pe,Ce,Ne,nt,St){return ai.createNotebookController(xe,pe,Ce,Ne,nt,(0,Me.isProposedApiEnabled)(xe,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(pe,Ce)=>_t.registerNotebookCellStatusBarItemProvider(xe,pe,Ce),createRendererMessaging(pe){return Ji.createRendererMessaging(xe,pe)},createNotebookControllerDetectionTask(pe){return(0,Me.checkProposedApiEnabled)(xe,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(xe,pe)},registerKernelSourceActionProvider(pe,Ce){return(0,Me.checkProposedApiEnabled)(xe,"notebookKernelSource"),ai.registerKernelSourceActionProvider(xe,pe,Ce)},onDidChangeNotebookCellExecutionState(pe,Ce,Ne){return(0,Me.checkProposedApiEnabled)(xe,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState(pe,Ce,Ne)}},Ki={t(...pe){if(typeof pe[0]=="string"){const Ce=pe.shift(),Ne=!pe||typeof pe[0]!="object"?pe:pe[0];return di.getMessage(xe.identifier.value,{message:Ce,args:Ne})}return di.getMessage(xe.identifier.value,pe[0])},get bundle(){return di.getBundle(xe.identifier.value)},get uri(){return di.getBundleUri(xe.identifier.value)}},Xi={_version:1,registerInteractiveEditorSessionProvider(pe){return(0,Me.checkProposedApiEnabled)(xe,"interactive"),Ai.registerProvider(xe,pe)},registerInteractiveSessionProvider(pe,Ce){return(0,Me.checkProposedApiEnabled)(xe,"interactive"),Yt.registerChatProvider(xe,pe,Ce)},addInteractiveRequest(pe){return(0,Me.checkProposedApiEnabled)(xe,"interactive"),Yt.addChatRequest(pe)},sendInteractiveRequestToProvider(pe,Ce){return(0,Me.checkProposedApiEnabled)(xe,"interactive"),Yt.sendInteractiveRequestToProvider(pe,Ce)},get onDidPerformUserAction(){return(0,Me.checkProposedApiEnabled)(xe,"interactiveUserActions"),Yt.onDidPerformUserAction},transferChatSession(pe,Ce){return(0,Me.checkProposedApiEnabled)(xe,"interactive"),Yt.transferChatSession(pe,Ce)}},cn={registerSlashCommandProvider(pe,Ce){return(0,Me.checkProposedApiEnabled)(xe,"interactiveSlashCommands"),Yt.registerSlashCommandProvider(xe,pe,Ce)}},ln={registerSemanticSimilarityProvider(pe){return(0,Me.checkProposedApiEnabled)(xe,"semanticSimilarity"),tn.registerSemanticSimilarityProvider(xe,pe)}};return{version:ht.version,ai:ln,authentication:rn,commands:Ht,comments:on,debug:an,env:ci,extensions:Vi,interactive:Xi,interactiveSlashCommands:cn,l10n:Ki,languages:ji,notebooks:Gi,scm:qi,tasks:Oi,tests:Hi,window:sn,workspace:Fi,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:_.CancellationTokenSource,CandidatePortSource:p.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentState:j.CommentState,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:d.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:v.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:m.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:C.UIKind,Uri:T.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,ManagedResolvedAuthority:j.ManagedResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:tt.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:ge.TelemetryTrustedValue,LogLevel:ne.LogLevel,EditSessionIdentityMatch:rt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:j.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:j.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:j.InteractiveEditorResponseFeedbackKind,StackFrameFocus:j.StackFrameFocus,ThreadFocus:j.ThreadFocus,NotebookCodeActionKind:j.NotebookCodeActionKind}}}e.createApiFactoryAndRegisterActors=Nt}),define(De[337],Ie([1,0,98,145,37,142,38,36,61,43,88,90,91,109,64,84,144,63,51,108,83,62,143,18,52,106,107]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c,f,S,I,i,a,n,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(t.IExtHostLocalizationService,t.ExtHostLocalizationService,1),(0,_.registerSingleton)(a.ILoggerService,i.ExtHostLoggerService,1),(0,_.registerSingleton)(b.IExtHostApiDeprecationService,b.ExtHostApiDeprecationService,1),(0,_.registerSingleton)(m.IExtHostCommands,m.ExtHostCommands,0),(0,_.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration,0),(0,_.registerSingleton)(s.IExtHostConsumerFileSystem,s.ExtHostConsumerFileSystem,0),(0,_.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,0),(0,_.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,0),(0,_.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,_.registerSingleton)(o.IExtHostManagedSockets,o.ExtHostManagedSockets,0),(0,_.registerSingleton)(c.IExtHostFileSystemInfo,c.ExtHostFileSystemInfo,0),(0,_.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService,1),(0,_.registerSingleton)(p.IExtHostSearch,p.ExtHostSearch,0),(0,_.registerSingleton)(C.IExtHostStorage,C.ExtHostStorage,0),(0,_.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,_.registerSingleton)(v.IExtHostTerminalService,v.WorkerExtHostTerminalService,0),(0,_.registerSingleton)(D.IExtHostTunnelService,D.ExtHostTunnelService,0),(0,_.registerSingleton)(r.IExtHostWindow,r.ExtHostWindow,0),(0,_.registerSingleton)(d.IExtHostWorkspace,d.ExtHostWorkspace,0),(0,_.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState,0),(0,_.registerSingleton)(S.IExtHostTelemetry,S.ExtHostTelemetry,0),(0,_.registerSingleton)(I.IExtHostEditorTabs,I.ExtHostEditorTabs,0),(0,_.registerSingleton)(n.IExtHostVariableResolverProvider,n.ExtHostVariableResolverProviderService,0)}),define(De[110],Ie([1,0,19,18,35,87]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=T;function m(k,p,C,D){const b=(0,_.mapArrayOrNot)(C,y),r=new d.TextSearchMatch(p,b,D),s=r.preview.matches;return{ranges:(0,_.mapArrayOrNot)(b,v),uri:k,preview:{text:r.preview.text,matches:(0,_.mapArrayOrNot)(s,v)}}}e.createTextSearchResult=m;function y(k){return new d.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function v(k){return new A.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let R=class{constructor(p,C){this.prefix=p,this.logService=C}appendLine(p){this.logService.debug(`${this.prefix}#search`,p)}};e.OutputChannel=R,e.OutputChannel=R=Ve([$e(1,L.ILogService)],R)}),define(De[338],Ie([1,0,46,13,69,31,11,12,110,339]),function(me,e,_,L,d,A,T,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const R=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(f,S,I,i){const a=p(f,S,I,i),n=S.folder.fsPath;return{cmd:_.spawn(R,a.args,{cwd:n}),rgDiskPath:R,siblingClauses:a.siblingClauses,rgArgs:a,cwd:n}}e.spawnRipgrepCmd=k;function p(f,S,I,i){const a=["--files","--hidden","--case-sensitive","--no-require-git"];D([S],I,!1).forEach(t=>{const o=(0,y.anchorGlob)(t);if(a.push("-g",o),T.isMacintosh){const g=(0,d.normalizeNFD)(o);g!==o&&a.push("-g",g)}});const n=C([S],i,void 0,!1);return n.globArgs.forEach(t=>{const o=`!${(0,y.anchorGlob)(t)}`;if(a.push("-g",o),T.isMacintosh){const g=(0,d.normalizeNFD)(o);g!==o&&a.push("-g",g)}}),S.disregardIgnoreFiles!==!1?a.push("--no-ignore"):S.disregardParentIgnoreFiles!==!1&&a.push("--no-ignore-parent"),S.ignoreSymlinks||a.push("--follow"),f.exists&&a.push("--quiet"),a.push("--no-config"),S.disregardGlobalIgnoreFiles&&a.push("--no-ignore-global"),{args:a,siblingClauses:n.siblingClauses}}function C(f,S,I,i=!0){const a=[];let n={};return f.forEach(t=>{const o=Object.assign({},t.excludePattern||{},S||{}),g=b(o,i?t.folder.fsPath:void 0,I);a.push(...g.globArgs),g.siblingClauses&&(n=Object.assign(n,g.siblingClauses))}),{globArgs:a,siblingClauses:n}}function D(f,S,I=!0){const i=[];return f.forEach(a=>{const n=Object.assign({},S||{},a.includePattern||{}),t=b(n,I?a.folder.fsPath:void 0);i.push(...t.globArgs)}),i}function b(f,S,I){const i=[],a={};return Object.keys(f).forEach(n=>{if(I&&I.has(n)||!n)return;const t=f[n];n=s(S?r(S,n):n),n.startsWith("\\\\")?n="\\\\"+n.substr(2).replace(/\\/g,"/"):n=n.replace(/\\/g,"/"),typeof t=="boolean"&&t?(n.startsWith("\\\\")&&(n+="**"),i.push(c(n))):t&&t.when&&(a[n]=t)}),{globArgs:i,siblingClauses:a}}function r(f,S){return L.isAbsolute(S)?S:L.join(f,S)}e.getAbsoluteGlob=r;function s(f){return f=m.rtrim(f,"\\"),m.rtrim(f,"/")}function c(f){return A.getRoot(f).toLowerCase()==="c:/"?f.replace(/^c:[/\\]/i,"/"):f}e.fixDriveC=c}),define(De[340],Ie([1,0,46,49,13,341,19,45,34,69,31,11,39,12,14,29,35,338,119]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const f=new Set;process.on("exit",()=>{f.forEach(n=>n())});class S{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&y.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,c.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&y.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(o=>{const g=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),l=o.folder.fsPath;t.folderQueries.map(h=>h.folder.fsPath).filter(h=>h!==l).forEach(h=>{(0,R.isEqualOrParent)(h,l)&&(g[d.relative(l,h)]=!0)}),this.folderExcludePatterns.set(l,new i(g,l))})}cancel(){this.isCanceled=!0,f.forEach(t=>t())}walk(t,o,g,l,h){if(this.fileWalkSW=p.StopWatch.create(!1),this.isCanceled)return h(null,this.isLimitHit);o.forEach(w=>{const u=d.basename(w.fsPath);this.globalExcludePattern&&this.globalExcludePattern(w.fsPath,u)||this.matchFile(g,{relativePath:w.fsPath,searchPath:void 0})}),this.cmdSW=p.StopWatch.create(!1),this.parallel(t,(w,u)=>{this.call(this.cmdTraversal,this,w,g,l,E=>{if(E){const P=(0,m.toErrorMessage)(E);console.error(P),this.errors.push(P),u(E,void 0)}else u(null,void 0)})},(w,u)=>{this.fileWalkSW.stop();const E=w?T.coalesce(w)[0]:null;h(E,this.isLimitHit)})}parallel(t,o,g){const l=new Array(t.length),h=new Array(t.length);let w=!1,u=0;if(t.length===0)return g(null,[]);t.forEach((E,P)=>{o(E,(O,N)=>{if(O?(w=!0,l[P]=null,h[P]=O):(l[P]=N,h[P]=null),++u===t.length)return g(w?h:null,l)})})}call(t,o,...g){try{t.apply(o,g)}catch(l){g[g.length-1](l)}}cmdTraversal(t,o,g,l){const h=t.folder.fsPath,w=k.isMacintosh,u=()=>F&&F.kill();f.add(u);let E=X=>{f.delete(u),E=()=>{},l(X)},P="";const O=this.initDirectoryTree(),N=(0,s.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression),F=N.cmd,x=!Object.keys(N.siblingClauses).length,B=N.rgArgs.args.map(X=>X.match(/^-/)?X:`'${X}'`).join(" ");let U=`${N.rgDiskPath} ${B}
 - cwd: ${N.cwd}`;N.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(N.rgArgs.siblingClauses)}`),g({message:U}),this.cmdResultCount=0,this.collectStdout(F,"utf8",g,(X,j,ge)=>{if(X){E(X);return}if(this.isLimitHit){E();return}const te=(P+(w?v.normalizeNFC(j||""):j)).split(`
`);if(ge){const $=te.length;te[$-1]=te[$-1].trim(),te[$-1]||te.pop()}else P=te.pop()||"";if(te.length&&te[0].indexOf(`
`)!==-1){E(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=te.length,x){for(const $ of te)if(this.matchFile(o,{base:h,relativePath:$,searchPath:this.getSearchPath(t,$)}),this.isLimitHit){u();break}(ge||this.isLimitHit)&&E();return}this.addDirectoryEntries(t,O,h,te,o),ge&&(this.matchDirectoryTree(O,h,o),E())})}spawnFindCmd(t){const o=this.folderExcludePatterns.get(t.folder.fsPath),g=o.getBasenameTerms(),l=o.getPathTerms(),h=["-L","."];if(g.length||l.length){h.push("-not","(","(");for(const w of g)h.push("-name",w),h.push("-o");for(const w of l)h.push("-path",w),h.push("-o");h.pop(),h.push(")","-prune",")")}return h.push("-type","f"),_.spawn("find",h,{cwd:t.folder.fsPath})}readStdout(t,o,g){let l="";this.collectStdout(t,o,()=>{},(h,w,u)=>{if(h){g(h);return}l+=w,u&&g(null,l)})}collectStdout(t,o,g,l){let h=(E,P,O)=>{(E||O)&&(h=()=>{},this.cmdSW?.stop()),l(E,P,O)},w=!1;t.stdout?(this.forwardData(t.stdout,o,h),t.stdout.once("data",()=>w=!0)):g({message:"stdout is null"});let u;t.stderr?u=this.collectData(t.stderr):g({message:"stderr is null"}),t.on("error",E=>{h(E)}),t.on("close",E=>{let P;!w&&(P=this.decodeData(u,o))&&a(P)?h(new Error(`command failed with error code ${E}: ${this.decodeData(u,o)}`)):(this.exists&&E===0&&(this.isLimitHit=!0),h(null,"",!0))})}forwardData(t,o,g){const l=new A.StringDecoder(o);return t.on("data",h=>{g(null,l.write(h))}),l}collectData(t){const o=[];return t.on("data",g=>{o.push(g)}),o}decodeData(t,o){const g=new A.StringDecoder(o);return t.map(l=>g.write(l)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:o},g,l,h){l.indexOf(this.filePattern)!==-1&&this.matchFile(h,{base:g,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const w=u=>{const E=d.basename(u),P=d.dirname(u);let O=o[P];O||(O=o[P]=[],w(P)),O.push({base:g,relativePath:u,basename:E,searchPath:this.getSearchPath(t,u)})};l.forEach(w)}matchDirectoryTree({rootEntries:t,pathToEntries:o},g,l){const h=this,w=this.folderExcludePatterns.get(g),u=this.filePattern;function E(P){h.directoriesWalked++;const O=(0,r.hasSiblingFn)(()=>P.map(N=>N.basename));for(let N=0,F=P.length;N<F;N++){const x=P[N],{relativePath:B,basename:U}=x;if(w.test(B,U,u!==U?O:void 0))continue;const X=o[B];if(X)E(X);else{if(h.filesWalked++,B===u)continue;h.matchFile(l,x)}if(h.isLimitHit)break}}E(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,o,g,l,h){const w=t.folder,u=(0,r.hasSiblingFn)(()=>g);this.parallel(g,(E,P)=>{if(this.isCanceled||this.isLimitHit)return P(null);const O=o?[o,E].join(d.sep):E;if(this.folderExcludePatterns.get(t.folder.fsPath).test(O,E,this.config.filePattern!==E?u:void 0))return P(null);const N=[w.fsPath,O].join(d.sep);L.lstat(N,(F,x)=>{if(F||this.isCanceled||this.isLimitHit)return P(null);this.statLinkIfNeeded(N,x,(B,U)=>B||this.isCanceled||this.isLimitHit?P(null):U.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(N,x,(X,j)=>X||this.isCanceled||this.isLimitHit||(j=j||"",this.walkedPaths[j])?P(null):(this.walkedPaths[j]=!0,b.Promises.readdir(N).then(ge=>{if(this.isCanceled||this.isLimitHit)return P(null);this.doWalk(t,O,ge,l,ie=>P(ie||null))},ge=>{P(null)})))):(this.filesWalked++,O===this.filePattern||this.maxFilesize&&D.isNumber(U.size)&&U.size>this.maxFilesize||this.matchFile(l,{base:w.fsPath,relativePath:O,searchPath:this.getSearchPath(t,O)}),P(null,void 0)))})},E=>{const P=E&&T.coalesce(E);return h(P&&P.length>0?P[0]:void 0)})}matchFile(t,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,d.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(o))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,r.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,o,g){return o.isSymbolicLink()?L.stat(t,g):g(null,o)}realPathIfNeeded(t,o,g){return o.isSymbolicLink()?L.realpath(t,(l,h)=>l?g(l):g(null,h)):g(null,t)}getSearchPath(t,o){return t.folderName?d.join(t.folderName,o):o}}e.FileWalker=S;class I{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new S(t)}search(t,o,g){this.walker.walk(this.folderQueries,this.extraFiles,t,o,(l,h)=>{g(l,{limitHit:h,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=I;class i{constructor(t,o){this.expression=t,this.root=o,this.init(t)}init(t){let o,g;Object.keys(t).filter(l=>t[l]).forEach(l=>{d.isAbsolute(l)?(o=o||y.getEmptyExpression(),o[l]=t[l]):(g=g||y.getEmptyExpression(),g[l]=t[l])}),this.absoluteParsedExpr=o&&y.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=g&&y.parse(g,{trimForExclusions:!0})}test(t,o,g){return this.relativeParsedExpr&&this.relativeParsedExpr(t,o,g)||this.absoluteParsedExpr&&this.absoluteParsedExpr(d.join(this.root,t),o,g)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...y.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...y.getPathTerms(this.relativeParsedExpr)),t}}function a(n){const t=n.trim().split(`
`),o=t[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return C.uppercaseFirstLetter(t[t.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}}),define(De[342],Ie([1,0,92,22,175]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function A(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(o=>o===t)}e.isUTFEncoding=A,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const T=512,m=512,y=512*8,v=512*128;var R;(function(t){t[t.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(R||(e.DecodeStreamErrorKind=R={}));class k extends Error{constructor(o,g){super(o),this.decodeStreamErrorKind=g}}e.DecodeStreamError=k;class p{static async create(o){let g;if(o!==e.UTF8)g=(await(0,d.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(r(o));else{const l=new TextDecoder;g={write(h){return l.decode(h,{stream:!0})},end(){return l.decode()}}}return new p(g)}constructor(o){this.iconvLiteDecoder=o}write(o){return this.iconvLiteDecoder.write(o)}end(){return this.iconvLiteDecoder.end()}}function C(t,o){const g=o.minBytesRequiredForDetection??o.guessEncoding?y:m;return new Promise((l,h)=>{const w=(0,_.newWriteableStream)(F=>F.join("")),u=[];let E=0,P;const O=async()=>{try{const F=await n({buffer:L.VSBuffer.concat(u),bytesRead:E},o.guessEncoding);if(F.seemsBinary&&o.acceptTextOnly)throw new k("Stream is binary but only text is accepted for decoding",1);F.encoding=await o.overwriteEncoding(F.encoding),P=await p.create(F.encoding);const x=P.write(L.VSBuffer.concat(u).buffer);w.write(x),u.length=0,E=0,l({stream:w,detected:F})}catch(F){N?.dispose(),w.destroy(),h(F)}},N=(0,_.listenStream)(t,{onData:async F=>{P?w.write(P.write(F.buffer)):(u.push(F),E+=F.byteLength,E>=g&&(t.pause(),await O(),setTimeout(()=>t.resume())))},onError:F=>w.error(F),onEnd:async()=>{P||await O(),w.end(P?.end())}})})}e.toDecodeStream=C;async function D(t,o,g){const h=(await(0,d.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(r(o),g);let w=!1,u=!1;return{read(){if(u)return null;const E=t.read();if(typeof E!="string"){if(u=!0,!w&&g?.addBOM)switch(o){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const P=h.end();return P&&P.length>0?(w=!0,L.VSBuffer.wrap(P)):null}return w=!0,L.VSBuffer.wrap(h.write(E))}}}e.toEncodeReadable=D;async function b(t){return(await(0,d.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(r(t))}e.encodingExists=b;function r(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=r;function s(t,o){if(!t||o<e.UTF16be_BOM.length)return null;const g=t.readUInt8(0),l=t.readUInt8(1);if(g===e.UTF16be_BOM[0]&&l===e.UTF16be_BOM[1])return e.UTF16be;if(g===e.UTF16le_BOM[0]&&l===e.UTF16le_BOM[1])return e.UTF16le;if(o<e.UTF8_BOM.length)return null;const h=t.readUInt8(2);return g===e.UTF8_BOM[0]&&l===e.UTF8_BOM[1]&&h===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=s;const c=["ascii","utf-16","utf-32"];async function f(t){const o=await(0,d.importAMDNodeModule)("jschardet","dist/jschardet.min.js"),g=t.slice(0,v),l=i(g.buffer),h=o.detect(l);if(!h||!h.encoding)return null;const w=h.encoding.toLowerCase();return 0<=c.indexOf(w)?null:I(h.encoding)}const S={ibm866:"cp866",big5:"cp950"};function I(t){const o=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return S[o]||o}function i(t){let o="";for(let g=0;g<t.length;g++)o+=String.fromCharCode(t[g]);return o}function a(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const o=t.match(/windows(\d+)/);return o?"windows-"+o[1]:t}}}e.toCanonicalName=a;function n({buffer:t,bytesRead:o},g){let l=s(t,o),h=!1;if(l!==e.UTF16be&&l!==e.UTF16le&&t){let w=!0,u=!0,E=!1;for(let P=0;P<o&&P<T;P++){const O=P%2===1,N=t.readUInt8(P)===0;if(N&&(E=!0),w&&(O&&!N||!O&&N)&&(w=!1),u&&(O&&N||!O&&!N)&&(u=!1),N&&!w&&!u)break}E&&(w?l=e.UTF16le:u?l=e.UTF16be:h=!0)}return g&&!h&&!l&&t?f(t.slice(0,o)).then(w=>({seemsBinary:!1,encoding:w})):{seemsBinary:h,encoding:l}}e.detectEncodingFromBuffer=n,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[147],Ie([1,0,342,29,146]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends d.TextSearchManager{constructor(m,y,v=L,R="searchProcess"){super(m,y,{readdir:k=>v.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,_.toCanonicalName)(k)},R)}}e.NativeTextSearchManager=A}),define(De[148],Ie([1,0,46,356,341,19,65,34,13,12,2,35,87,357,339,110]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const r=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class s{constructor(E){this.outputChannel=E}provideTextSearchResults(E,P,O,N){return this.outputChannel.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((F,x)=>{N.onCancellationRequested(()=>$());const B=a(E,P),U=P.folder.fsPath,X=B.map(he=>he.match(/^-/)?he:`'${he}'`).join(" ");this.outputChannel.appendLine(`${r} ${X}
 - cwd: ${U}`);let j=_.spawn(r,B,{cwd:U});j.on("error",he=>{console.error(he),this.outputChannel.appendLine("Error: "+(he&&he.message)),x((0,k.serializeSearchError)(new k.SearchError(he&&he.message,k.SearchErrorCode.rgProcessError)))});let ge=!1;const ie=new S(P.maxResults,U,P.previewOptions);ie.on("result",he=>{ge=!0,ce="",O.report(he)});let te=!1;const $=()=>{te=!0,j?.kill(),ie?.cancel()};let H=!1;ie.on("hitLimit",()=>{H=!0,$()});let ce="";j.stdout.on("data",he=>{ie.handleData(he),ge||(ce+=he)});let re=!1;j.stdout.once("data",()=>re=!0);let fe="";j.stderr.on("data",he=>{const z=he.toString();this.outputChannel.appendLine(z),fe.length+z.length<1e6&&(fe+=z)}),j.on("close",()=>{if(this.outputChannel.appendLine(re?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(ge?"Got result from parser":"No result from parser"),ce&&this.outputChannel.appendLine(`Got data without result: ${ce}`),this.outputChannel.appendLine(""),te)F({limitHit:H});else{ie.flush(),j=null;let he;fe&&!re&&(he=c(fe))?x((0,k.serializeSearchError)(new k.SearchError(he.message,he.code))):F({limitHit:H})}})})}}e.RipgrepTextSearchEngine=s;function c(u){const E=u.split(`
`),P=E[0].trim();if(E.some(N=>N.startsWith("regex parse error")))return new k.SearchError(f(E),k.SearchErrorCode.regexParseError);const O=P.match(/grep config error: unknown encoding: (.*)/);if(O)return new k.SearchError(`Unknown encoding: ${O[1]}`,k.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new k.SearchError(P.charAt(0).toUpperCase()+P.substr(1),k.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new k.SearchError(P.charAt(0).toUpperCase()+P.substr(1),k.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(P,k.SearchErrorCode.regexParseError)}function f(u){const E=["Regex parse error"],P=u.filter(O=>O.startsWith("PCRE2:"));if(P.length>=1){const O=P[0].replace("PCRE2:","");if(O.indexOf(":")!==-1&&O.split(":").length>=2){const N=O.split(":")[1];E.push(":"+N)}}return E.join("")}class S extends L.EventEmitter{constructor(E,P,O){super(),this.maxResults=E,this.rootFolder=P,this.previewOptions=O,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new d.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(E,P){return super.on(E,P),this}handleData(E){if(this.isDone)return;const P=typeof E=="string"?E:this.stringDecoder.write(E);this.handleDecodedData(P)}handleDecodedData(E){let P=E.indexOf(`
`);const O=this.remainder+E;if(P>=0)P+=this.remainder.length;else{this.remainder=O;return}let N=0;for(;P>=0;)this.handleLine(O.substring(N,P).trim()),N=P+1,P=O.indexOf(`
`,N);this.remainder=O.substring(N)}handleLine(E){if(this.isDone||!E)return;let P;try{P=JSON.parse(E)}catch{throw new Error(`malformed line from rg: ${E}`)}if(P.type==="match"){const O=I(P.data.path),N=R.URI.file(y.join(this.rootFolder,O)),F=this.createTextSearchMatch(P.data,N);this.onResult(F),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const O=I(P.data.path),N=R.URI.file(y.join(this.rootFolder,O));this.createTextSearchContext(P.data,N).forEach(x=>this.onResult(x))}}createTextSearchMatch(E,P){const O=E.line_number-1,N=I(E.lines),F=Buffer.from(N);let x=0,B=0,U=O;E.submatches.length===0&&E.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const X=(0,A.coalesce)(E.submatches.map((j,ge)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const ie=I(j.match),te=F.slice(x,j.start).toString(),$=i(te),H=$.numLines>0?$.lastLineLength:$.lastLineLength+B,ce=i(ie),re=$.numLines+U,fe=ce.numLines+re,he=ce.numLines>0?ce.lastLineLength:ce.lastLineLength+H;return x=j.end,B=he,U=fe,new p.Range(re,H,fe,he)}));return(0,b.createTextSearchResult)(P,N,X,this.previewOptions)}createTextSearchContext(E,P){const O=I(E.lines),N=E.line_number;return O.replace(/\r?\n$/,"").split(`
`).map((F,x)=>({text:F,uri:P,lineNumber:N+x}))}onResult(E){this.emit("result",E)}}e.RipgrepParser=S;function I(u){return u.bytes?Buffer.from(u.bytes,"base64").toString():u.text}function i(u){const E=/\n/g;let P=0,O=-1,N;for(;N=E.exec(u);)P++,O=N.index;const F=O>=0?u.length-O-1:u.length;return{numLines:P,lastLineLength:F}}function a(u,E){const P=["--hidden","--no-require-git"];P.push(u.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:O,otherIncludes:N}=(0,T.groupBy)(E.includes,x=>x.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const x=new Set;N.forEach(B=>{x.add(B)}),P.push("-g","!*"),x.forEach(B=>{n(B).map(b.anchorGlob).forEach(U=>{P.push("-g",U)})})}O&&O.length&&O.forEach(x=>{P.push("-g",x)}),E.excludes.map(b.anchorGlob).forEach(x=>P.push("-g",`!${x}`)),E.maxFileSize&&P.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?E.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),E.followSymlinks&&P.push("--follow"),E.encoding&&E.encoding!=="utf8"&&P.push("--encoding",E.encoding),u.pattern==="--"&&(u.isRegExp=!0,u.pattern="\\-\\-"),u.isMultiline&&!u.isRegExp&&(u.pattern=(0,v.escapeRegExpCharacters)(u.pattern),u.isRegExp=!0),E.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),u.isRegExp&&(u.pattern=t(u.pattern),P.push("--engine","auto"));let F;if(u.isWordMatch){const B=(0,v.createRegExp)(u.pattern,!!u.isRegExp,{wholeWord:u.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",B)}else if(u.isRegExp){let x=g(u.pattern);x=l(x),P.push("--regexp",x)}else F=u.pattern,P.push("--fixed-strings");return P.push("--no-config"),E.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),u.isMultiline&&P.push("--multiline"),E.beforeContext&&P.push("--before-context",E.beforeContext+""),E.afterContext&&P.push("--after-context",E.afterContext+""),P.push("--"),F&&P.push(F),P.push("."),P}e.getRgArgs=a;function n(u){return w(u).flatMap(P=>{const O=(0,m.splitGlobAware)(P,"/");return O.map((N,F)=>O.slice(0,F+1).join("/"))})}function t(u){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;u.match(E);)u=u.replace(E,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;u.match(P);)u=u.replace(P,"$1\\x{$2}");return u}e.unicodeEscapesToPCRE2=t;const o=u=>u.type==="Assertion"&&u.kind==="lookbehind";function g(u){let E;try{E=new C.RegExpParser().parsePattern(u)}catch{return u}let P="",O=0;const N=(B,U,X)=>{P+=u.slice(O,B)+X,O=U},F=[];return new C.RegExpVisitor({onCharacterEnter(B){if(B.raw!=="\\n")return;const U=F[0];if(!U)N(B.start,B.end,"\\r?\\n");else if(!F.some(o))if(U.type==="CharacterClass")if(U.negate){const X=u.slice(U.start+2,B.start)+u.slice(B.end,U.end-1);U.parent?.type==="Quantifier"?N(U.start,U.end,X?`[^${X}]`:"."):N(U.start,U.end,"(?!\\r?\\n"+(X?`|[${X}]`:"")+")")}else{const X=u.slice(U.start+1,B.start)+u.slice(B.end,U.end-1);N(U.start,U.end,X===""?"\\r?\\n":`(?:[${X}]|\\r?\\n)`)}else U.type==="Quantifier"&&N(B.start,B.end,"(?:\\r?\\n)")},onQuantifierEnter(B){F.unshift(B)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(B){F.unshift(B)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(B){F.unshift(B)},onCharacterClassLeave(){F.shift()},onAssertionEnter(B){o(B)&&F.push(B)},onAssertionLeave(B){F[0]===B&&F.shift()}}).visit(E),P+=u.slice(O),P}e.fixRegexNewline=g;function l(u){return u.replace(/\n/g,"\\r?\\n")}e.fixNewline=l;function h(u){let E=!1,P=!1,O="",N="";for(let F=0;F<u.length;F++){const x=u[F];switch(x){case"\\":P?(E?N+="\\"+x:O+="\\"+x,P=!1):P=!0;break;case"{":if(P)E?N+=x:O+=x,P=!1;else{if(E)return{strInBraces:O+"{"+N+"{"+u.substring(F+1)};E=!0}break;case"}":if(P)E?N+=x:O+=x,P=!1;else{if(E)return{fixedStart:O,strInBraces:N,fixedEnd:u.substring(F+1)};O+=x}break;default:E?N+=(P?"\\":"")+x:O+=(P?"\\":"")+x,P=!1;break}}return{strInBraces:O+(E?"{"+N:"")}}function w(u){const{fixedStart:E,strInBraces:P,fixedEnd:O}=h(u);if(E===void 0||O===void 0)return[P];let N=(0,m.splitGlobAware)(P,",");N.length||(N=[""]);const F=w(O);return N.flatMap(x=>{const B=E+x;return F.map(U=>B+U)})}e.performBraceExpansionForRipgrep=w}),define(De[343],Ie([1,0,21,148,128,15]),function(me,e,_,L,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(v){this.outputChannel=v,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(v,R,k,p){const C=new L.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===A.Schemas.vscodeUserData){const D={...R,folder:R.folder.with({scheme:A.Schemas.file})},b=new d.Progress(r=>k.report({...r,uri:r.uri.with({scheme:R.folder.scheme})}));return this.withToken(p,r=>C.provideTextSearchResults(v,D,b,r))}else return this.withToken(p,D=>C.provideTextSearchResults(v,R,k,D))}async withToken(v,R){const k=m(v);this.inProgress.add(k);const p=await R(k.token);return this.inProgress.delete(k),p}dispose(){this.inProgress.forEach(v=>v.cancel())}}e.RipgrepSearchProvider=T;function m(y){const v=new _.CancellationTokenSource;return y.onCancellationRequested(()=>v.cancel()),v}}),define(De[344],Ie([1,0,29,148,147]),function(me,e,_,L,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(y){this.query=y}search(y,v,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(C){R({message:C})}},p=new d.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(k),_);return new Promise((C,D)=>p.search(b=>{v(b.map(T))},y).then(b=>C({limitHit:b.limitHit,type:"success",stats:b.stats}),D))}}e.TextSearchEngineAdapter=A;function T(m){return{path:m.resource&&m.resource.fsPath,results:m.results,numMatches:(m.results||[]).reduce((y,v)=>{if(v.ranges){const R=v;return y+(Array.isArray(R.ranges)?R.ranges.length:1)}else return y+1},0)}}}),define(De[345],Ie([1,0,19,17,8,3,119,13,39,2,30,35,340,344]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class D{static{this.BATCH_SIZE=512}constructor(S="searchProcess"){this.processType=S,this.caches=Object.create(null)}fileSearch(S){let I;const i=s(S),a=new A.Emitter({onDidAddFirstListener:()=>{I=(0,L.createCancelablePromise)(n=>this.doFileSearchWithEngine(p.Engine,i,t=>a.fire(t),n)),I.then(n=>a.fire(n),n=>a.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onDidRemoveLastListener:()=>{I.cancel()}});return a.event}textSearch(S){let I;const i=s(S),a=new A.Emitter({onDidAddFirstListener:()=>{I=(0,L.createCancelablePromise)(n=>this.ripgrepTextSearch(i,t=>a.fire(t),n)),I.then(n=>a.fire(n),n=>a.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onDidRemoveLastListener:()=>{I.cancel()}});return a.event}ripgrepTextSearch(S,I,i){return S.maxFileSize=this.getPlatformFileLimits().maxFileSize,new C.TextSearchEngineAdapter(S).search(i,I,I)}getPlatformFileLimits(){return{maxFileSize:process.arch==="ia32"?300*R.ByteSize.MB:16*R.ByteSize.GB}}doFileSearch(S,I,i){return this.doFileSearchWithEngine(p.Engine,S,I,i)}doFileSearchWithEngine(S,I,i,a,n=D.BATCH_SIZE){let t=0;const o=l=>{Array.isArray(l)?(t+=l.length,i(l.map(h=>this.rawMatchToSearchItem(h)))):l.relativePath?(t++,i(this.rawMatchToSearchItem(l))):i(l)};if(I.sortByScore){let l=this.trySortedSearchFromCache(I,o,a);if(!l){const h=I.maxResults?Object.assign({},I,{maxResults:null}):I,w=new S(h);l=this.doSortedSearch(w,I,i,o,a)}return new Promise((h,w)=>{l.then(([u,E])=>{const P=E.map(O=>this.rawMatchToSearchItem(O));this.sendProgress(P,i,n),h(u)},w)})}const g=new S(I);return this.doSearch(g,o,n,a).then(l=>({limitHit:l.limitHit,type:"success",stats:{detailStats:l.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(S){return{path:S.base?(0,m.join)(S.base,S.relativePath):S.relativePath}}doSortedSearch(S,I,i,a,n){const t=new A.Emitter;let o=(0,L.createCancelablePromise)(l=>{let h=[];const w=u=>{Array.isArray(u)?h=u:(a(u),t.fire(u))};return this.doSearch(S,w,-1,l).then(u=>[u,h])}),g;if(I.cacheKey){g=this.getOrCreateCache(I.cacheKey);const l={promise:o,event:t.event,resolved:!1};g.resultsToSearchCache[I.filePattern||""]=l,o.then(()=>{l.resolved=!0},h=>{delete g.resultsToSearchCache[I.filePattern||""]}),o=this.preventCancellation(o)}return o.then(([l,h])=>{const w=g?g.scorerCache:Object.create(null),u=(typeof I.maxResults!="number"||I.maxResults>0)&&y.StopWatch.create(!1);return this.sortResults(I,h,w,n).then(E=>{const P=u?u.elapsed():-1;return[{type:"success",stats:{detailStats:l.stats,sortingTime:P,fromCache:!1,type:this.processType,workspaceFolderCount:I.folderQueries.length,resultCount:E.length},messages:l.messages,limitHit:l.limitHit||typeof I.maxResults=="number"&&h.length>I.maxResults},E]})})}getOrCreateCache(S){const I=this.caches[S];return I||(this.caches[S]=new b)}trySortedSearchFromCache(S,I,i){const a=S.cacheKey&&this.caches[S.cacheKey];if(!a)return;const n=this.getResultsFromCache(a,S.filePattern||"",I,i);if(n)return n.then(([t,o,g])=>{const l=y.StopWatch.create(!1);return this.sortResults(S,o,a.scorerCache,i).then(h=>{const w=l.elapsed(),u={fromCache:!0,detailStats:g,type:this.processType,resultCount:o.length,sortingTime:w};return[{type:"success",limitHit:t.limitHit||typeof S.maxResults=="number"&&o.length>S.maxResults,stats:u},h]})})}sortResults(S,I,i,a){const n=(0,T.prepareQuery)(S.filePattern||""),t=(g,l)=>(0,T.compareItemsByFuzzyScore)(g,l,n,!0,r,i),o=typeof S.maxResults=="number"?S.maxResults:Number.MAX_VALUE;return _.topAsync(I,t,o,1e4,a)}sendProgress(S,I,i){if(i&&i>0)for(let a=0;a<S.length;a+=i)I(S.slice(a,a+i));else I(S)}getResultsFromCache(S,I,i,a){const n=y.StopWatch.create(!1),t=I.indexOf(m.sep)>=0;let o;for(const w in S.resultsToSearchCache)if(I.startsWith(w)){if(t&&w.indexOf(m.sep)<0&&w!=="")continue;const u=S.resultsToSearchCache[w];o={promise:this.preventCancellation(u.promise),event:u.event,resolved:u.resolved};break}if(!o)return null;const g=n.elapsed(),l=y.StopWatch.create(!1),h=o.event(i);return a&&a.onCancellationRequested(()=>{h.dispose()}),o.promise.then(([w,u])=>{if(a&&a.isCancellationRequested)throw(0,d.canceled)();const E=[],P=(0,T.prepareQuery)(I).normalizedLowercase;for(const O of u)(0,k.isFilePatternMatch)(O,P)&&E.push(O);return[w,E,{cacheWasResolved:o.resolved,cacheLookupTime:g,cacheFilterTime:l.elapsed(),cacheEntryCount:u.length}]})}doSearch(S,I,i,a){return new Promise((n,t)=>{let o=[];a?.onCancellationRequested(()=>S.cancel()),S.search(g=>{g&&(i?(o.push(g),i>0&&o.length>=i&&(I(o),o=[])):I(g))},g=>{I(g)},(g,l)=>{o.length&&I(o),g?t(g):n(l)})})}clearCache(S){return delete this.caches[S],Promise.resolve(void 0)}preventCancellation(S){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(I,i){return S.then(I,i)}catch(I){return this.then(void 0,I)}finally(I){return S.finally(I)}}}}e.SearchService=D;class b{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const r=new class{getItemLabel(f){return(0,m.basename)(f.relativePath)}getItemDescription(f){return(0,m.dirname)(f.relativePath)}getItemPath(f){return f.relativePath}};function s(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(c),extraFileResources:f.extraFileResources&&f.extraFileResources.map(S=>v.URI.revive(S))}}function c(f){return{...f,folder:v.URI.revive(f.folder)}}}),define(De[346],Ie([1,0,4,15,2,29,18,26,20,91,58,35,345,343,110,147]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let r=class extends v.ExtHostSearch{constructor(c,f,S,I){super(c,S,I),this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const i=new D.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.vscodeUserData,new C.RipgrepSearchProvider(i)),f.remote.isRemote&&f.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const c=new D.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new C.RipgrepSearchProvider(c)),this.registerInternalFileSearchProvider(L.Schemas.file,new p.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(c,f){const S=this._handlePool++;return this._internalFileSearchProvider=f,this._internalFileSearchHandle=S,this._proxy.$registerFileSearchProvider(S,this._transformScheme(c)),(0,_.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(S)})}$provideFileSearchResults(c,f,S,I){const i=(0,v.reviveQuery)(S);return c===this._internalFileSearchHandle?this.doInternalFileSearch(c,f,i,I):super.$provideFileSearchResults(c,f,S,I)}doInternalFileSearch(c,f,S,I){const i=a=>{if((0,k.isSerializedFileMatch)(a)&&(a=[a]),Array.isArray(a)){this._proxy.$handleFileMatch(c,f,a.map(n=>d.URI.file(n.path)));return}a.message&&this._logService.debug("ExtHostSearch",a.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(S,i,I)}$clearCache(c){return this._internalFileSearchProvider?.clearCache(c),super.$clearCache(c)}createTextSearchManager(c,f){return new b.NativeTextSearchManager(c,f,void 0,"textSearchProvider")}};e.NativeExtHostSearch=r,e.NativeExtHostSearch=r=Ve([$e(0,y.IExtHostRpcService),$e(1,m.IExtHostInitDataService),$e(2,R.IURITransformerService),$e(3,T.ILogService)],r)}),define(De[149],Ie([1,0,358,101,75,359,22,8,3,4,13,11,32,76,122]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class b{traceSocketEvent(u,E){D.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,E)}constructor(u,E=""){this._canWrite=!0,this.debugLabel=E,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,m.onUnexpectedError)(P)}},this.socket.on("error",this._errorListener),this._closeListener=P=>{this.traceSocketEvent("close",{hadError:P}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(u){const E=P=>{this.traceSocketEvent("read",P),u(T.VSBuffer.wrap(P))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(u){const E=P=>{u({type:0,hadError:P,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(u){const E=()=>{u()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(u){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,m.onUnexpectedError)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,m.onUnexpectedError)(E)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.NodeSocket=b;var r;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(r||(r={}));var s;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(s||(s={}));class c extends v.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(u,E){this.socket.traceSocketEvent(u,E)}constructor(u,E,P,O){super(),this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:P?.byteLength||0,recordInflateBytes:O}),this._flowManager=this._register(new f(this,E,P,O,this._onData,(N,F)=>this._write(N,F))),this._register(this._flowManager.onError(N=>{console.error(N),(0,m.onUnexpectedError)(N),this._onClose.fire({type:0,hadError:!0,error:N})})),this._incomingData=new D.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(async N=>{this._flowManager.isProcessingReadQueue()&&await y.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(N)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){let E=0;for(;E<u.byteLength;)this._flowManager.writeMessage(u.slice(E,Math.min(E+262144,u.byteLength))),E+=262144}_write(u,E){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let P=2;u.byteLength<126?P+=0:u.byteLength<2**16?P+=2:P+=8;const O=T.VSBuffer.alloc(P);if(E?O.writeUInt8(194,0):O.writeUInt8(130,0),u.byteLength<126)O.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){O.writeUInt8(126,1);let N=1;O.writeUInt8(u.byteLength>>>8&255,++N),O.writeUInt8(u.byteLength>>>0&255,++N)}else{O.writeUInt8(127,1);let N=1;O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(u.byteLength>>>24&255,++N),O.writeUInt8(u.byteLength>>>16&255,++N),O.writeUInt8(u.byteLength>>>8&255,++N),O.writeUInt8(u.byteLength>>>0&255,++N)}this.socket.write(T.VSBuffer.concat([O,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const E=this._incomingData.peek(this._state.readLen),P=E.readUInt8(0),O=(P&128)>>>7,N=(P&64)>>>6,F=E.readUInt8(1),x=(F&128)>>>7,B=F&127;this._state.state=2,this._state.readLen=2+(x?4:0)+(B===126?2:0)+(B===127?8:0),this._state.fin=O,this._state.firstFrameOfMessage&&(this._state.compressed=!!N),this._state.firstFrameOfMessage=!!O,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const E=this._incomingData.read(this._state.readLen),P=E.readUInt8(1),O=(P&128)>>>7;let N=P&127,F=1;N===126?N=E.readUInt8(++F)*2**8+E.readUInt8(++F):N===127&&(N=E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F));let x=0;O&&(x=E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F)),this._state.state=3,this._state.readLen=N,this._state.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const E=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",E),i(E,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",E),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(E,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await y.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=c;class f extends v.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}constructor(u,E,P,O,N,F){super(),this._tracer=u,this._onData=N,this._writeFn=F,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new y.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new y.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,E?(this._zlibInflateStream=this._register(new S(this._tracer,O,P,{windowBits:15})),this._zlibDeflateStream=this._register(new I(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(x=>this._onError.fire(x))),this._register(this._zlibDeflateStream.onError(x=>this._onError.fire(x)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(u){this._writeQueue.push(u),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const u=this._writeQueue.shift();if(this._zlibDeflateStream){const E=await this._deflateMessage(this._zlibDeflateStream,u);this._writeFn(E,!0)}else this._writeFn(u,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(u,E){return new Promise((P,O)=>{u.write(E),u.flush(N=>P(N))})}acceptFrame(u,E,P){this._readQueue.push({data:u,isCompressed:E,isLastFrameOfMessage:P}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const u=this._readQueue.shift();if(this._zlibInflateStream&&u.isCompressed){const E=await this._inflateFrame(this._zlibInflateStream,u.data,u.isLastFrameOfMessage);this._onData.fire(E)}else this._onData.fire(u.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(u,E,P){return new Promise((O,N)=>{u.write(E),P&&u.write(T.VSBuffer.fromByteArray([0,0,255,255])),u.flush(F=>O(F))})}}class S extends v.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}constructor(u,E,P,O){super(),this._tracer=u,this._recordInflateBytes=E,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,A.createInflateRaw)(O),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent("zlibInflateData",N),this._pendingInflateData.push(T.VSBuffer.wrap(N))}),P&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this._zlibInflate.write(P.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(u){this._recordInflateBytes&&this._recordedInflateBytes.push(u.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",u),this._zlibInflate.write(u.buffer)}flush(u){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const E=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,u(E)})}}class I extends v.Disposable{constructor(u,E){super(),this._tracer=u,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,A.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",P=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this._onError.fire(P)}),this._zlibDeflate.on("data",P=>{this._tracer.traceSocketEvent("zlibDeflateData",P),this._pendingDeflateData.push(T.VSBuffer.wrap(P))})}write(u){this._tracer.traceSocketEvent("zlibDeflateWrite",u.buffer),this._zlibDeflate.write(u.buffer)}flush(u){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let E=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,E=E.slice(0,E.byteLength-4),u(E)})}}function i(w,u){if(u===0)return;const E=w.byteLength>>>2;for(let B=0;B<E;B++){const U=w.readUInt32BE(B*4);w.writeUInt32BE(U^u,B*4)}const P=E*4,O=w.byteLength-P,N=u>>>24&255,F=u>>>16&255,x=u>>>8&255;O>=1&&w.writeUInt8(w.readUInt8(P)^N,P),O>=2&&w.writeUInt8(w.readUInt8(P+1)^F,P+1),O>=3&&w.writeUInt8(w.readUInt8(P+2)^x,P+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const w=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const u=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,d.tmpdir)(),E=(0,R.join)(u,`vscode-ipc-${w}.sock`);return o(E),E}e.createRandomIPCHandle=n;function t(w,u,E){const P=(0,_.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${E}-${u}-sock`;const O=E.substr(0,4),N=u.substr(0,6),F=P.substr(0,8);let x;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?x=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-${F}-${O}-${N}.sock`):x=(0,R.join)(w,`${O}-${N}.sock`),o(x),x}e.createStaticIPCHandle=t;function o(w){const u=a[k.platform];typeof u=="number"&&w.length>=u&&console.warn(`WARNING: IPC handle "${w}" is longer than ${u} chars, try a shorter --user-data-dir`)}class g extends C.IPCServer{static toClientConnectionEvent(u){const E=y.Event.fromNodeEventEmitter(u,"connection");return y.Event.map(E,P=>({protocol:new D.Protocol(new b(P,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(P,"close"))}))}constructor(u){super(g.toClientConnectionEvent(u)),this.server=u}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=g;function l(w){return new Promise((u,E)=>{const P=(0,L.createServer)();P.on("error",E),P.listen(w,()=>{P.removeListener("error",E),u(new g(P))})})}e.serve=l;function h(w,u){return new Promise((E,P)=>{const O=(0,L.createConnection)(w,()=>{O.removeListener("error",P),E(D.Client.fromSocket(new b(O,`ipc-client${u}`),u))});O.once("error",P)})}e.connect=h}),define(De[347],Ie([1,0,149,252,49,36,2,18,50]),function(me,e,_,L,d,A,T,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class v{constructor(p,C,D){this._commands=p,this.logService=C,this._ipcHandlePath=D,this._server=L.createServer((b,r)=>this.onRequest(b,r)),this.setup().catch(b=>(C.error(b),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",p=>this.logService.error(p))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(p,C){const D=(r,s)=>{C.writeHead(r,{"content-type":"application/json"}),C.end(JSON.stringify(s||null),c=>c&&this.logService.error(c))},b=[];p.setEncoding("utf8"),p.on("data",r=>b.push(r)),p.on("end",async()=>{try{const r=JSON.parse(b.join(""));let s;switch(r.type){case"open":s=await this.open(r);break;case"openExternal":s=await this.openExternal(r);break;case"status":s=await this.getStatus(r);break;case"extensionManagement":s=await this.manageExtensions(r);break;default:D(404,`Unknown message type: ${r.type}`);break}D(200,s)}catch(r){const s=r instanceof Error?r.message:JSON.stringify(r);D(500,s),this.logService.error("Error while processing pipe request",r)}})}async open(p){const{fileURIs:C,folderURIs:D,forceNewWindow:b,diffMode:r,mergeMode:s,addMode:c,forceReuseWindow:f,gotoLineMode:S,waitMarkerFilePath:I,remoteAuthority:i}=p,a=[];if(Array.isArray(D))for(const g of D)try{a.push({folderUri:T.URI.parse(g)})}catch{}if(Array.isArray(C))for(const g of C)try{(0,y.hasWorkspaceFileExtension)(g)?a.push({workspaceUri:T.URI.parse(g)}):a.push({fileUri:T.URI.parse(g)})}catch{}const n=I?T.URI.file(I):void 0,o={forceNewWindow:b,diffMode:r,mergeMode:s,addMode:c,gotoLineMode:S,forceReuseWindow:f,preferNewWindow:!f&&!n&&!c,waitMarkerFileURI:n,remoteAuthority:i};this._commands.executeCommand("_remoteCLI.windowOpen",a,o)}async openExternal(p){for(const C of p.uris){const D=T.URI.parse(C),b=D.scheme==="file"?D:C;await this._commands.executeCommand("_remoteCLI.openExternal",b)}}async manageExtensions(p){const C=b=>b?.map(r=>/\.vsix$/i.test(r)?T.URI.parse(r):r),D={list:p.list,install:C(p.install),uninstall:C(p.uninstall),force:p.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",D)}async getStatus(p){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&d.existsSync(this._ipcHandlePath)&&d.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=v;let R=class extends v{constructor(p,C){super(p,C,(0,_.createRandomIPCHandle)())}};e.CLIServer=R,e.CLIServer=R=Ve([$e(0,A.IExtHostCommands),$e(1,m.ILogService)],R)}),define(De[348],Ie([1,0,89,336,331,251,44,319,2,15,7,347,95,317,318]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class b extends d.RequireInterceptor{_installInterceptor(){const c=this,f=globalThis._VSCODE_NODE_MODULES.module,S=f._load;f._load=function(n,t,o){return n=i(n),c._factories.has(n)?c._factories.get(n).load(n,y.URI.file((0,p.realpathSync)(t.filename)),g=>S.apply(this,[g,t,o])):S.apply(this,arguments)};const I=f._resolveLookupPaths;f._resolveLookupPaths=(a,n)=>I.call(this,i(a),n);const i=a=>{for(const n of c._alternatives){const t=n(a);if(t){a=t;break}}return a}}}class r extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(C.ExtHostConsoleForwarder);const c=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(m.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const I=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=I.ipcHandlePath}this._instaService.createInstance(D.ExtHostDiskFileSystemProvider),await this._instaService.createInstance(b,c,{mine:this._myRegistry,all:this._globalRegistry}).install(),_.mark("code/extHost/didInitAPI");const S=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,S,this,this._logService,this._mainThreadTelemetryProxy,this._initData),_.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(c){return c.main}async _loadCommonJSModule(c,f,S){if(f.scheme!==v.Schemas.file)throw new Error(`Cannot load URI: '${f}', must be of file-scheme`);let I=null;S.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${f.toString(!0)}`),this._logService.flush();const i=c?.identifier.value;c&&await this._extHostLocalizationService.initializeLocalizedMessages(c);try{i&&_.mark(`code/extHost/willLoadExtensionCode/${i}`),I=me.__$__nodeRequire(f.fsPath)}finally{i&&_.mark(`code/extHost/didLoadExtensionCode/${i}`),S.codeLoadingStop()}return I}async $setRemoteEnvironment(c){if(this._initData.remote.isRemote)for(const f in c){const S=c[f];S===null?delete process.env[f]:process.env[f]=S}}}e.ExtHostExtensionService=r}),define(De[349],Ie([1,0,98,322,334,333,346,348,323,90,44,91,88,43,64,85,321,320,18,335,52,246,97]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s,c,f,S,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(R.IExtHostExtensionService,m.ExtHostExtensionService,0),(0,_.registerSingleton)(c.ILoggerService,s.ExtHostLoggerService,1),(0,_.registerSingleton)(c.ILogService,new i.SyncDescriptor(I.ExtHostLogService,[!1],!0)),(0,_.registerSingleton)(b.IExtensionStoragePaths,r.ExtensionStoragePaths,0),(0,_.registerSingleton)(v.IExtHostDebugService,A.ExtHostDebugService,0),(0,_.registerSingleton)(k.IExtHostSearch,T.NativeExtHostSearch,0),(0,_.registerSingleton)(p.IExtHostTask,d.ExtHostTask,0),(0,_.registerSingleton)(C.IExtHostTerminalService,L.ExtHostTerminalService,0),(0,_.registerSingleton)(D.IExtHostTunnelService,y.NodeExtHostTunnelService,0),(0,_.registerSingleton)(S.IExtHostVariableResolverProvider,f.NodeExtHostVariableResolverProviderService,0)}),define(De[360],Ie([1,0,101,361,89,8,122,149,233,105,332,22,29,95,17,124,253,271,337,349]),function(me,e,_,L,d,A,T,m,y,v,R,k,p,C,D,b,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let g=0;g<process.execArgv.length;g++)process.execArgv[g]==="--inspect-port=0"&&(process.execArgv.splice(g,1),g--)}();const c=L(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const o=globalThis._VSCODE_NODE_MODULES.module,g=o._load;o._load=function(l){if(l==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return g.apply(this,arguments)}})();const f=process.exit.bind(process);function S(o){process.exit=function(g){if(o)f(g);else{const l=new Error("An extension called process.exit() and this was prevented.");console.warn(l.stack)}},process.crash=function(){const g=new Error("An extension called process.crash() and this was prevented.");console.warn(g.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let I=function(o){f()};function i(){const o=(0,s.readExtHostConnection)(process.env);if(o.type===3)return new Promise((g,l)=>{const h=w=>{const u=w[0],E=new T.BufferedEmitter;u.on("message",P=>E.fire(k.VSBuffer.wrap(P.data))),u.on("close",()=>{I("renderer closed the MessagePort")}),u.start(),g({onMessage:E.event,send:P=>u.postMessage(P.buffer)})};process.parentPort.on("message",w=>h(w.ports))});if(o.type===2)return new Promise((g,l)=>{let h=null;const w=setTimeout(()=>{I("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),u=108e5,E=3e5,P=new D.ProcessTimeRunOnceScheduler(()=>I("renderer disconnected for too long (1)"),u),O=new D.ProcessTimeRunOnceScheduler(()=>I("renderer disconnected for too long (2)"),E);process.on("message",(F,x)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){x.setNoDelay(!0);const B=k.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let U;if(F.skipWebSocketFrames)U=new m.NodeSocket(x,"extHost-socket");else{const X=k.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));U=new m.WebSocketNodeSocket(new m.NodeSocket(x,"extHost-socket"),F.permessageDeflate,X,!1)}h?(P.cancel(),O.cancel(),h.beginAcceptReconnection(U,B),h.endAcceptReconnection(),h.sendResume()):(clearTimeout(w),h=new T.PersistentProtocol({socket:U,initialChunk:B}),h.sendResume(),h.onDidDispose(()=>I("renderer disconnected")),g(h),h.onSocketClose(()=>{P.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(O.isScheduled())return;P.isScheduled()&&O.schedule()}});const N={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(N)});{const g=o.pipeName;return new Promise((l,h)=>{const w=_.createConnection(g,()=>{w.removeListener("error",h);const u=new T.PersistentProtocol({socket:new m.NodeSocket(w,"extHost-renderer")});u.sendResume(),l(u)});w.once("error",h),w.on("close",()=>{I("renderer closed the socket")})})}}async function a(){const o=await i();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,o.onMessage(g=>{(0,v.isMessageOfType)(g,2)?(this._terminating=!0,I("received terminate message from renderer")):this._onMessage.fire(g)})}send(g){this._terminating||o.send(g)}async drain(){if(o.drain)return o.drain()}}}function n(o){return new Promise(g=>{const l=o.onMessage(h=>{l.dispose();const w=JSON.parse(h.toString()),u=w.commit,E=y.default.commit;if(u&&E&&u!==E&&f(55),w.parentPid){let P=0;setInterval(function(){try{process.kill(w.parentPid,0),P=0}catch(N){N&&N.code==="EPERM"?(P++,P>=3&&I(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):I(`parent process ${w.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let O;try{O=globalThis._VSCODE_NODE_MODULES["native-watchdog"],O.start(w.parentPid)}catch(N){(0,A.onUnexpectedError)(N)}}o.send((0,v.createMessageOfType)(0)),g({protocol:o,initData:w})});o.send((0,v.createMessageOfType)(1))})}async function t(){const o=[];process.on("unhandledRejection",(P,O)=>{o.push(O),setTimeout(()=>{const N=o.indexOf(O);N>=0&&O.catch(F=>{o.splice(N,1),(0,A.isCancellationError)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),P&&(0,A.onUnexpectedError)(P))})},1e3)}),process.on("rejectionHandled",P=>{const O=o.indexOf(P);O>=0&&o.splice(O,1)}),process.on("uncaughtException",function(P){(0,A.isSigPipeError)(P)||(0,A.onUnexpectedError)(P)}),d.mark("code/extHost/willConnectToRenderer");const g=await a();d.mark("code/extHost/didConnectToRenderer");const l=await n(g);d.mark("code/extHost/didWaitForInitData");const{initData:h}=l;S(!!h.environment.extensionTestsLocationURI),h.environment.useHostProxy=c.useHostProxy!==void 0?c.useHostProxy!=="false":void 0,h.environment.skipWorkspaceStorageLock=(0,b.boolean)(c.skipWorkspaceStorageLock,!1);const w=new class{constructor(){this.pid=process.pid}exit(O){f(O)}fsExists(O){return p.Promises.exists(O)}fsRealpath(O){return(0,C.realpath)(O)}};let u=null;h.remote.authority&&c.transformURIs&&(u=(0,r.createURITransformer)(h.remote.authority));const E=new R.ExtensionHostMain(l.protocol,h,w,u);I=P=>E.terminate(P)}t().catch(o=>console.log(o))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/aef377c42cea6e9aea642829953104f07097abfa/core/vs/workbench/api/node/extensionHostProcess.js.map
