/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ae=function(pe){for(var e=[],w=0,O=pe.length;w<O;w++)e[w]=Pe[pe[w]];return e};define(Pe[65],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function w(T,h){const y=Object.create(null);for(const p of T){const A=h(p);let _=y[A];_||(_=y[A]=[]),_.push(p)}return y}e.groupBy=w;function O(T,h){const y=[],p=[];for(const A of T)h.has(A)||y.push(A);for(const A of h)T.has(A)||p.push(A);return{removed:y,added:p}}e.diffSets=O;function I(T,h){const y=[],p=[];for(const[A,_]of T)h.has(A)||y.push(_);for(const[A,_]of h)T.has(A)||p.push(_);return{removed:y,added:p}}e.diffMaps=I;class M{constructor(){this.map=new Map}add(h,y){let p=this.map.get(h);p||(p=new Set,this.map.set(h,p)),p.add(y)}delete(h,y){const p=this.map.get(h);p&&(p.delete(y),p.size===0&&this.map.delete(h))}forEach(h,y){const p=this.map.get(h);p&&p.forEach(y)}get(h){const y=this.map.get(h);return y?new Set(y):new Set}}e.SetMap=M}),define(Pe[66],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function w(T){return(h,y,p)=>{let A=null,_=null;if(typeof p.value=="function"?(A="value",_=p.value):typeof p.get=="function"&&(A="get",_=p.get),!_)throw new Error("not supported");p[A]=T(_,y)}}function O(T,h,y){let p=null,A=null;if(typeof y.value=="function"?(p="value",A=y.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(p="get",A=y.get),!A)throw new Error("not supported");const _=`$memoize$${h}`;y[p]=function(...c){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,c)}),this[_]}}e.memoize=O;function I(T,h,y){return w((p,A)=>{const _=`$debounce$${A}`,c=`$debounce$result$${A}`;return function(...S){this[c]||(this[c]=y?y():void 0),clearTimeout(this[_]),h&&(this[c]=h(this[c],...S),S=[this[c]]),this[_]=setTimeout(()=>{p.apply(this,S),this[c]=y?y():void 0},T)}})}e.debounce=I;function M(T,h,y){return w((p,A)=>{const _=`$throttle$timer$${A}`,c=`$throttle$result$${A}`,S=`$throttle$lastRun$${A}`,E=`$throttle$pending$${A}`;return function(...o){if(this[c]||(this[c]=y?y():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),h&&(this[c]=h(this[c],...o)),this[E])return;const t=this[S]+T;t<=Date.now()?(this[S]=Date.now(),p.apply(this,[this[c]]),this[c]=y?y():void 0):(this[E]=!0,this[_]=setTimeout(()=>{this[E]=!1,this[S]=Date.now(),p.apply(this,[this[c]]),this[c]=y?y():void 0},t-Date.now()))}})}e.throttle=M}),define(Pe[88],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class w{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=w,e.defaultGenerator=new w("id#")}),define(Pe[115],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var O;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var I;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var M;(function(r){r.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function T(r,d=!1){let n=0;const s=r.length;let v="",D=0,u=16,m=0;function b(x){let U=0,N=0;for(;U<x;){const ae=r.charCodeAt(n);if(ae>=48&&ae<=57)N=N*16+ae-48;else if(ae>=65&&ae<=70)N=N*16+ae-65+10;else if(ae>=97&&ae<=102)N=N*16+ae-97+10;else break;n++,U++}return U<x&&(N=-1),N}function l(x){n=x,v="",D=0,u=16,m=0}function f(){const x=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&p(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&p(r.charCodeAt(n)))for(n++;n<r.length&&p(r.charCodeAt(n));)n++;else return m=3,r.substring(x,n);let U=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&p(r.charCodeAt(n))){for(n++;n<r.length&&p(r.charCodeAt(n));)n++;U=n}else m=3;return r.substring(x,U)}function P(){let x="",U=n;for(;;){if(n>=s){x+=r.substring(U,n),m=2;break}const N=r.charCodeAt(n);if(N===34){x+=r.substring(U,n),n++;break}if(N===92){if(x+=r.substring(U,n),n++,n>=s){m=2;break}switch(r.charCodeAt(n++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const Y=b(4);Y>=0?x+=String.fromCharCode(Y):m=4;break}default:m=5}U=n;continue}if(N>=0&&N<=31)if(y(N)){x+=r.substring(U,n),m=2;break}else m=6;n++}return x}function z(){if(v="",m=0,D=n,n>=s)return D=s,u=17;let x=r.charCodeAt(n);if(h(x)){do n++,v+=String.fromCharCode(x),x=r.charCodeAt(n);while(h(x));return u=15}if(y(x))return n++,v+=String.fromCharCode(x),x===13&&r.charCodeAt(n)===10&&(n++,v+=`
`),u=14;switch(x){case 123:return n++,u=1;case 125:return n++,u=2;case 91:return n++,u=3;case 93:return n++,u=4;case 58:return n++,u=6;case 44:return n++,u=5;case 34:return n++,v=P(),u=10;case 47:{const U=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<s&&!y(r.charCodeAt(n));)n++;return v=r.substring(U,n),u=12}if(r.charCodeAt(n+1)===42){n+=2;const N=s-1;let ae=!1;for(;n<N;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,ae=!0;break}n++}return ae||(n++,m=1),v=r.substring(U,n),u=13}return v+=String.fromCharCode(x),n++,u=16}case 45:if(v+=String.fromCharCode(x),n++,n===s||!p(r.charCodeAt(n)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=f(),u=11;default:for(;n<s&&$(x);)n++,x=r.charCodeAt(n);if(D!==n){switch(v=r.substring(D,n),v){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return v+=String.fromCharCode(x),n++,u=16}}function $(x){if(h(x)||y(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let x;do x=z();while(x>=12&&x<=15);return x}return{setPosition:l,getPosition:()=>n,scan:d?H:z,getToken:()=>u,getTokenValue:()=>v,getTokenOffset:()=>D,getTokenLength:()=>n-D,getTokenError:()=>m}}e.createScanner=T;function h(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function y(r){return r===10||r===13||r===8232||r===8233}function p(r){return r>=48&&r<=57}var A;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(A||(A={}));function _(r,d){const n=[],s=new Object;let v;const D={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function m(b,l,f,P){D.value=b,D.offset=l,D.length=f,D.type=P,D.colonOffset=void 0,v=D}try{g(r,{onObjectBegin:(b,l)=>{if(d<=b)throw s;v=void 0,u=d>b,n.push("")},onObjectProperty:(b,l,f)=>{if(d<l||(m(b,l,f,"property"),n[n.length-1]=b,d<=l+f))throw s},onObjectEnd:(b,l)=>{if(d<=b)throw s;v=void 0,n.pop()},onArrayBegin:(b,l)=>{if(d<=b)throw s;v=void 0,n.push(0)},onArrayEnd:(b,l)=>{if(d<=b)throw s;v=void 0,n.pop()},onLiteralValue:(b,l,f)=>{if(d<l||(m(b,l,f,k(b)),d<=l+f))throw s},onSeparator:(b,l,f)=>{if(d<=l)throw s;if(b===":"&&v&&v.type==="property")v.colonOffset=l,u=!1,v=void 0;else if(b===","){const P=n[n.length-1];typeof P=="number"?n[n.length-1]=P+1:(u=!0,n[n.length-1]=""),v=void 0}}})}catch(b){if(b!==s)throw b}return{path:n,previousNode:v,isAtPropertyKey:u,matches:b=>{let l=0;for(let f=0;l<b.length&&f<n.length;f++)if(b[l]===n[f]||b[l]==="*")l++;else if(b[l]!=="**")return!1;return l===b.length}}}e.getLocation=_;function c(r,d=[],n=M.DEFAULT){let s=null,v=[];const D=[];function u(b){Array.isArray(v)?v.push(b):s!==null&&(v[s]=b)}return g(r,{onObjectBegin:()=>{const b={};u(b),D.push(v),v=b,s=null},onObjectProperty:b=>{s=b},onObjectEnd:()=>{v=D.pop()},onArrayBegin:()=>{const b=[];u(b),D.push(v),v=b,s=null},onArrayEnd:()=>{v=D.pop()},onLiteralValue:u,onError:(b,l,f)=>{d.push({error:b,offset:l,length:f})}},n),v[0]}e.parse=c;function S(r,d=[],n=M.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(b){s.type==="property"&&(s.length=b-s.offset,s=s.parent)}function D(b){return s.children.push(b),b}g(r,{onObjectBegin:b=>{s=D({type:"object",offset:b,length:-1,parent:s,children:[]})},onObjectProperty:(b,l,f)=>{s=D({type:"property",offset:l,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:b,offset:l,length:f,parent:s})},onObjectEnd:(b,l)=>{s.length=b+l-s.offset,s=s.parent,v(b+l)},onArrayBegin:(b,l)=>{s=D({type:"array",offset:b,length:-1,parent:s,children:[]})},onArrayEnd:(b,l)=>{s.length=b+l-s.offset,s=s.parent,v(b+l)},onLiteralValue:(b,l,f)=>{D({type:k(b),offset:l,length:f,parent:s,value:b}),v(l+f)},onSeparator:(b,l,f)=>{s.type==="property"&&(b===":"?s.colonOffset=l:b===","&&v(l))},onError:(b,l,f)=>{d.push({error:b,offset:l,length:f})}},n);const m=s.children[0];return m&&delete m.parent,m}e.parseTree=S;function E(r,d){if(!r)return;let n=r;for(const s of d)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let v=!1;for(const D of n.children)if(Array.isArray(D.children)&&D.children[0].value===s){n=D.children[1],v=!0;break}if(!v)return}else{const v=s;if(n.type!=="array"||v<0||!Array.isArray(n.children)||v>=n.children.length)return;n=n.children[v]}return n}e.findNodeAtLocation=E;function o(r){if(!r.parent||!r.parent.children)return[];const d=o(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;d.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&d.push(n)}return d}e.getNodePath=o;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const d=Object.create(null);for(const n of r.children){const s=n.children[1];s&&(d[n.children[0].value]=t(s))}return d}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=t;function i(r,d,n=!1){return d>=r.offset&&d<r.offset+r.length||n&&d===r.offset+r.length}e.contains=i;function a(r,d,n=!1){if(i(r,d,n)){const s=r.children;if(Array.isArray(s))for(let v=0;v<s.length&&s[v].offset<=d;v++){const D=a(s[v],d,n);if(D)return D}return r}}e.findNodeAtOffset=a;function g(r,d,n=M.DEFAULT){const s=T(r,!1);function v(ue){return ue?()=>ue(s.getTokenOffset(),s.getTokenLength()):()=>!0}function D(ue){return ue?ne=>ue(ne,s.getTokenOffset(),s.getTokenLength()):()=>!0}const u=v(d.onObjectBegin),m=D(d.onObjectProperty),b=v(d.onObjectEnd),l=v(d.onArrayBegin),f=v(d.onArrayEnd),P=D(d.onLiteralValue),z=D(d.onSeparator),$=v(d.onComment),H=D(d.onError),x=n&&n.disallowComments,U=n&&n.allowTrailingComma;function N(){for(;;){const ue=s.scan();switch(s.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:x||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(ue){case 12:case 13:x?ae(10):$();break;case 16:ae(1);break;case 15:case 14:break;default:return ue}}}function ae(ue,ne=[],he=[]){if(H(ue),ne.length+he.length>0){let le=s.getToken();for(;le!==17;){if(ne.indexOf(le)!==-1){N();break}else if(he.indexOf(le)!==-1)break;le=N()}}}function Y(ue){const ne=s.getTokenValue();return ue?P(ne):m(ne),N(),!0}function Ee(){switch(s.getToken()){case 11:{let ue=0;try{ue=JSON.parse(s.getTokenValue()),typeof ue!="number"&&(ae(2),ue=0)}catch{ae(2)}P(ue);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return N(),!0}function ye(){return s.getToken()!==10?(ae(3,[],[2,5]),!1):(Y(!1),s.getToken()===6?(z(":"),N(),Q()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function Re(){u(),N();let ue=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ue||ae(4,[],[]),z(","),N(),s.getToken()===2&&U)break}else ue&&ae(6,[],[]);ye()||ae(4,[],[2,5]),ue=!0}return b(),s.getToken()!==2?ae(7,[2],[]):N(),!0}function K(){l(),N();let ue=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ue||ae(4,[],[]),z(","),N(),s.getToken()===4&&U)break}else ue&&ae(6,[],[]);Q()||ae(4,[],[4,5]),ue=!0}return f(),s.getToken()!==4?ae(8,[4],[]):N(),!0}function Q(){switch(s.getToken()){case 3:return K();case 1:return Re();case 10:return Y(!0);default:return Ee()}}return N(),s.getToken()===17?n.allowEmptyContent?!0:(ae(4,[],[]),!1):Q()?(s.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.visit=g;function C(r,d){const n=T(r),s=[];let v,D=0,u;do switch(u=n.getPosition(),v=n.scan(),v){case 12:case 13:case 17:D!==u&&s.push(r.substring(D,u)),d!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,d)),D=n.getPosition();break}while(v!==17);return s.join("")}e.stripComments=C;function k(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=k}),define(Pe[28],Ae([1,0]),function(pe,e){"use strict";var w,O,I;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(o,t,i){let a=o.get(t);return a===void 0&&(a=i,o.set(t,a)),a}e.getOrSet=M;function T(o){const t=[];return o.forEach((i,a)=>{t.push(`${a} => ${i}`)}),`Map(${o.size}) {${t.join(", ")}}`}e.mapToString=T;function h(o){const t=[];return o.forEach(i=>{t.push(i)}),`Set(${o.size}) {${t.join(", ")}}`}e.setToString=h;class y{constructor(t,i){this.uri=t,this.value=i}}class p{static{this.defaultToKey=t=>t.toString()}constructor(t,i){this[w]="ResourceMap",t instanceof p?(this.map=new Map(t.map),this.toKey=i??p.defaultToKey):(this.map=new Map,this.toKey=t??p.defaultToKey)}set(t,i){return this.map.set(this.toKey(t),new y(t,i)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,i){typeof i<"u"&&(t=t.bind(i));for(const[a,g]of this.map)t(g.value,g.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=p;class A{constructor(t,i){this[O]="ResourceSet",!t||typeof t=="function"?this._map=new p(t):(this._map=new p(i),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,i){this._map.forEach((a,g)=>t.call(i,g,g,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=A;var _;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(_||(e.Touch=_={}));class c{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,i=0){const a=this._map.get(t);if(a)return i!==0&&this.touch(a,i),a.value}set(t,i,a=0){let g=this._map.get(t);if(g)g.value=i,a!==0&&this.touch(g,a);else{switch(g={key:t,value:i,next:void 0,previous:void 0},a){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(t,g),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const i=this._map.get(t);if(i)return this._map.delete(t),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,i){const a=this._state;let g=this._head;for(;g;){if(i?t.bind(i)(g.value,g.key,this):t(g.value,g.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const t=this,i=this._state;let a=this._head;const g={[Symbol.iterator](){return g},next(){if(t._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const C={value:a.key,done:!1};return a=a.next,C}else return{value:void 0,done:!0}}};return g}values(){const t=this,i=this._state;let a=this._head;const g={[Symbol.iterator](){return g},next(){if(t._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const C={value:a.value,done:!1};return a=a.next,C}else return{value:void 0,done:!0}}};return g}entries(){const t=this,i=this._state;let a=this._head;const g={[Symbol.iterator](){return g},next(){if(t._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const C={value:[a.key,a.value],done:!1};return a=a.next,C}else return{value:void 0,done:!0}}};return g}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let i=this._head,a=this.size;for(;i&&a>t;)this._map.delete(i.key),i=i.next,a--;this._head=i,this._size=a,i&&(i.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const i=t.next,a=t.previous;if(!i||!a)throw new Error("Invalid list");i.previous=a,a.next=i}t.next=void 0,t.previous=void 0,this._state++}touch(t,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(t===this._head)return;const a=t.next,g=t.previous;t===this._tail?(g.next=void 0,this._tail=g):(a.previous=g,g.next=a),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(i===2){if(t===this._tail)return;const a=t.next,g=t.previous;t===this._head?(a.previous=void 0,this._head=a):(a.previous=g,g.next=a),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((i,a)=>{t.push([a,i])}),t}fromJSON(t){this.clear();for(const[i,a]of t)this.set(i,a)}}e.LinkedMap=c;class S extends c{constructor(t,i=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,i=2){return super.get(t,i)}peek(t){return super.get(t,0)}set(t,i){return super.set(t,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=S;class E{constructor(){this.map=new Map}add(t){return this.map.set(t,(this.map.get(t)||0)+1),this}delete(t){let i=this.map.get(t)||0;return i===0?!1:(i--,i===0?this.map.delete(t):this.map.set(t,i),!0)}has(t){return this.map.has(t)}}e.CounterSet=E}),function(pe,e){typeof define=="function"&&define.amd?define(Pe[116],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(pe=typeof globalThis<"u"?globalThis:pe||self,e(pe.marked={}))}(this,function(pe){"use strict";function e(Ce,_e){for(var Ie=0;Ie<_e.length;Ie++){var se=_e[Ie];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Ce,se.key,se)}}function w(Ce,_e,Ie){return _e&&e(Ce.prototype,_e),Ie&&e(Ce,Ie),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function O(Ce,_e){if(Ce){if(typeof Ce=="string")return I(Ce,_e);var Ie=Object.prototype.toString.call(Ce).slice(8,-1);if(Ie==="Object"&&Ce.constructor&&(Ie=Ce.constructor.name),Ie==="Map"||Ie==="Set")return Array.from(Ce);if(Ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ie))return I(Ce,_e)}}function I(Ce,_e){(_e==null||_e>Ce.length)&&(_e=Ce.length);for(var Ie=0,se=new Array(_e);Ie<_e;Ie++)se[Ie]=Ce[Ie];return se}function M(Ce,_e){var Ie=typeof Symbol<"u"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(Ie)return(Ie=Ie.call(Ce)).next.bind(Ie);if(Array.isArray(Ce)||(Ie=O(Ce))||_e&&Ce&&typeof Ce.length=="number"){Ie&&(Ce=Ie);var se=0;return function(){return se>=Ce.length?{done:!0}:{done:!1,value:Ce[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}pe.defaults=T();function h(Ce){pe.defaults=Ce}var y=/[&<>"']/,p=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(_e){return c[_e]};function E(Ce,_e){if(_e){if(y.test(Ce))return Ce.replace(p,S)}else if(A.test(Ce))return Ce.replace(_,S);return Ce}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(Ce){return Ce.replace(o,function(_e,Ie){return Ie=Ie.toLowerCase(),Ie==="colon"?":":Ie.charAt(0)==="#"?Ie.charAt(1)==="x"?String.fromCharCode(parseInt(Ie.substring(2),16)):String.fromCharCode(+Ie.substring(1)):""})}var i=/(^|[^\[])\^/g;function a(Ce,_e){Ce=typeof Ce=="string"?Ce:Ce.source,_e=_e||"";var Ie={replace:function(fe,ee){return ee=ee.source||ee,ee=ee.replace(i,"$1"),Ce=Ce.replace(fe,ee),Ie},getRegex:function(){return new RegExp(Ce,_e)}};return Ie}var g=/[^\w:]/g,C=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function k(Ce,_e,Ie){if(Ce){var se;try{se=decodeURIComponent(t(Ie)).replace(g,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}_e&&!C.test(Ie)&&(Ie=v(_e,Ie));try{Ie=encodeURI(Ie).replace(/%25/g,"%")}catch{return null}return Ie}var r={},d=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(Ce,_e){r[" "+Ce]||(d.test(Ce)?r[" "+Ce]=Ce+"/":r[" "+Ce]=b(Ce,"/",!0)),Ce=r[" "+Ce];var Ie=Ce.indexOf(":")===-1;return _e.substring(0,2)==="//"?Ie?_e:Ce.replace(n,"$1")+_e:_e.charAt(0)==="/"?Ie?_e:Ce.replace(s,"$1")+_e:Ce+_e}var D={exec:function(){}};function u(Ce){for(var _e=1,Ie,se;_e<arguments.length;_e++){Ie=arguments[_e];for(se in Ie)Object.prototype.hasOwnProperty.call(Ie,se)&&(Ce[se]=Ie[se])}return Ce}function m(Ce,_e){var Ie=Ce.replace(/\|/g,function(ee,ie,de){for(var R=!1,W=ie;--W>=0&&de[W]==="\\";)R=!R;return R?"|":" |"}),se=Ie.split(/ \|/),fe=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>_e)se.splice(_e);else for(;se.length<_e;)se.push("");for(;fe<se.length;fe++)se[fe]=se[fe].trim().replace(/\\\|/g,"|");return se}function b(Ce,_e,Ie){var se=Ce.length;if(se===0)return"";for(var fe=0;fe<se;){var ee=Ce.charAt(se-fe-1);if(ee===_e&&!Ie)fe++;else if(ee!==_e&&Ie)fe++;else break}return Ce.slice(0,se-fe)}function l(Ce,_e){if(Ce.indexOf(_e[1])===-1)return-1;for(var Ie=Ce.length,se=0,fe=0;fe<Ie;fe++)if(Ce[fe]==="\\")fe++;else if(Ce[fe]===_e[0])se++;else if(Ce[fe]===_e[1]&&(se--,se<0))return fe;return-1}function f(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(Ce,_e){if(_e<1)return"";for(var Ie="";_e>1;)_e&1&&(Ie+=Ce),_e>>=1,Ce+=Ce;return Ie+Ce}function z(Ce,_e,Ie,se){var fe=_e.href,ee=_e.title?E(_e.title):null,ie=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){se.state.inLink=!0;var de={type:"link",raw:Ie,href:fe,title:ee,text:ie,tokens:se.inlineTokens(ie)};return se.state.inLink=!1,de}return{type:"image",raw:Ie,href:fe,title:ee,text:E(ie)}}function $(Ce,_e){var Ie=Ce.match(/^(\s+)(?:```)/);if(Ie===null)return _e;var se=Ie[1];return _e.split(`
`).map(function(fe){var ee=fe.match(/^\s+/);if(ee===null)return fe;var ie=ee[0];return ie.length>=se.length?fe.slice(se.length):fe}).join(`
`)}var H=function(){function Ce(Ie){this.options=Ie||pe.defaults}var _e=Ce.prototype;return _e.space=function(se){var fe=this.rules.block.newline.exec(se);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},_e.code=function(se){var fe=this.rules.block.code.exec(se);if(fe){var ee=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:b(ee,`
`)}}},_e.fences=function(se){var fe=this.rules.block.fences.exec(se);if(fe){var ee=fe[0],ie=$(ee,fe[3]||"");return{type:"code",raw:ee,lang:fe[2]?fe[2].trim():fe[2],text:ie}}},_e.heading=function(se){var fe=this.rules.block.heading.exec(se);if(fe){var ee=fe[2].trim();if(/#$/.test(ee)){var ie=b(ee,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(ee=ie.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:ee,tokens:this.lexer.inline(ee)}}},_e.hr=function(se){var fe=this.rules.block.hr.exec(se);if(fe)return{type:"hr",raw:fe[0]}},_e.blockquote=function(se){var fe=this.rules.block.blockquote.exec(se);if(fe){var ee=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},_e.list=function(se){var fe=this.rules.block.list.exec(se);if(fe){var ee,ie,de,R,W,V,q,oe,j,ce,ve,Ue,$e=fe[1].trim(),Qe=$e.length>1,qe={type:"list",raw:"",ordered:Qe,start:Qe?+$e.slice(0,-1):"",loose:!1,items:[]};$e=Qe?"\\d{1,9}\\"+$e.slice(-1):"\\"+$e,this.options.pedantic&&($e=Qe?$e:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+$e+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(Ue=!1,!(!(fe=Ye.exec(se))||this.rules.block.hr.test(se)));){if(ee=fe[0],se=se.substring(ee.length),oe=fe[2].split(`
`,1)[0],j=se.split(`
`,1)[0],this.options.pedantic?(R=2,ve=oe.trimLeft()):(R=fe[2].search(/[^ ]/),R=R>4?1:R,ve=oe.slice(R),R+=fe[1].length),V=!1,!oe&&/^ *$/.test(j)&&(ee+=j+`
`,se=se.substring(j.length+1),Ue=!0),!Ue)for(var Ke=new RegExp("^ {0,"+Math.min(3,R-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ct=new RegExp("^ {0,"+Math.min(3,R-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ze=new RegExp("^ {0,"+Math.min(3,R-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,R-1)+"}#");se&&(ce=se.split(`
`,1)[0],oe=ce,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ze.test(oe)||tt.test(oe)||Ke.test(oe)||ct.test(se)));){if(oe.search(/[^ ]/)>=R||!oe.trim())ve+=`
`+oe.slice(R);else if(!V)ve+=`
`+oe;else break;!V&&!oe.trim()&&(V=!0),ee+=ce+`
`,se=se.substring(ce.length+1)}qe.loose||(q?qe.loose=!0:/\n *\n *$/.test(ee)&&(q=!0)),this.options.gfm&&(ie=/^\[[ xX]\] /.exec(ve),ie&&(de=ie[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:ee,task:!!ie,checked:de,loose:!1,text:ve}),qe.raw+=ee}qe.items[qe.items.length-1].raw=ee.trimRight(),qe.items[qe.items.length-1].text=ve.trimRight(),qe.raw=qe.raw.trimRight();var Ne=qe.items.length;for(W=0;W<Ne;W++){this.lexer.state.top=!1,qe.items[W].tokens=this.lexer.blockTokens(qe.items[W].text,[]);var nt=qe.items[W].tokens.filter(function(X){return X.type==="space"}),Z=nt.every(function(X){for(var ge=X.raw.split(""),Be=0,Me=M(ge),Ge;!(Ge=Me()).done;){var et=Ge.value;if(et===`
`&&(Be+=1),Be>1)return!0}return!1});!qe.loose&&nt.length&&Z&&(qe.loose=!0,qe.items[W].loose=!0)}return qe}},_e.html=function(se){var fe=this.rules.block.html.exec(se);if(fe){var ee={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var ie=this.options.sanitizer?this.options.sanitizer(fe[0]):E(fe[0]);ee.type="paragraph",ee.text=ie,ee.tokens=this.lexer.inline(ie)}return ee}},_e.def=function(se){var fe=this.rules.block.def.exec(se);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var ee=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:fe[0],href:fe[2],title:fe[3]}}},_e.table=function(se){var fe=this.rules.block.table.exec(se);if(fe){var ee={type:"table",header:m(fe[1]).map(function(q){return{text:q}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=fe[0];var ie=ee.align.length,de,R,W,V;for(de=0;de<ie;de++)/^ *-+: *$/.test(ee.align[de])?ee.align[de]="right":/^ *:-+: *$/.test(ee.align[de])?ee.align[de]="center":/^ *:-+ *$/.test(ee.align[de])?ee.align[de]="left":ee.align[de]=null;for(ie=ee.rows.length,de=0;de<ie;de++)ee.rows[de]=m(ee.rows[de],ee.header.length).map(function(q){return{text:q}});for(ie=ee.header.length,R=0;R<ie;R++)ee.header[R].tokens=this.lexer.inline(ee.header[R].text);for(ie=ee.rows.length,R=0;R<ie;R++)for(V=ee.rows[R],W=0;W<V.length;W++)V[W].tokens=this.lexer.inline(V[W].text);return ee}}},_e.lheading=function(se){var fe=this.rules.block.lheading.exec(se);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},_e.paragraph=function(se){var fe=this.rules.block.paragraph.exec(se);if(fe){var ee=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:ee,tokens:this.lexer.inline(ee)}}},_e.text=function(se){var fe=this.rules.block.text.exec(se);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},_e.escape=function(se){var fe=this.rules.inline.escape.exec(se);if(fe)return{type:"escape",raw:fe[0],text:E(fe[1])}},_e.tag=function(se){var fe=this.rules.inline.tag.exec(se);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):E(fe[0]):fe[0]}},_e.link=function(se){var fe=this.rules.inline.link.exec(se);if(fe){var ee=fe[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var ie=b(ee.slice(0,-1),"\\");if((ee.length-ie.length)%2===0)return}else{var de=l(fe[2],"()");if(de>-1){var R=fe[0].indexOf("!")===0?5:4,W=R+fe[1].length+de;fe[2]=fe[2].substring(0,de),fe[0]=fe[0].substring(0,W).trim(),fe[3]=""}}var V=fe[2],q="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);oe&&(V=oe[1],q=oe[3])}else q=fe[3]?fe[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(ee)?V=V.slice(1):V=V.slice(1,-1)),z(fe,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:q&&q.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},_e.reflink=function(se,fe){var ee;if((ee=this.rules.inline.reflink.exec(se))||(ee=this.rules.inline.nolink.exec(se))){var ie=(ee[2]||ee[1]).replace(/\s+/g," ");if(ie=fe[ie.toLowerCase()],!ie||!ie.href){var de=ee[0].charAt(0);return{type:"text",raw:de,text:de}}return z(ee,ie,ee[0],this.lexer)}},_e.emStrong=function(se,fe,ee){ee===void 0&&(ee="");var ie=this.rules.inline.emStrong.lDelim.exec(se);if(ie&&!(ie[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var de=ie[1]||ie[2]||"";if(!de||de&&(ee===""||this.rules.inline.punctuation.exec(ee))){var R=ie[0].length-1,W,V,q=R,oe=0,j=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,fe=fe.slice(-1*se.length+R);(ie=j.exec(fe))!=null;)if(W=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!W){if(V=W.length,ie[3]||ie[4]){q+=V;continue}else if((ie[5]||ie[6])&&R%3&&!((R+V)%3)){oe+=V;continue}if(q-=V,!(q>0)){if(V=Math.min(V,V+q+oe),Math.min(R,V)%2){var ce=se.slice(1,R+ie.index+V);return{type:"em",raw:se.slice(0,R+ie.index+V+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}var ve=se.slice(2,R+ie.index+V-1);return{type:"strong",raw:se.slice(0,R+ie.index+V+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},_e.codespan=function(se){var fe=this.rules.inline.code.exec(se);if(fe){var ee=fe[2].replace(/\n/g," "),ie=/[^ ]/.test(ee),de=/^ /.test(ee)&&/ $/.test(ee);return ie&&de&&(ee=ee.substring(1,ee.length-1)),ee=E(ee,!0),{type:"codespan",raw:fe[0],text:ee}}},_e.br=function(se){var fe=this.rules.inline.br.exec(se);if(fe)return{type:"br",raw:fe[0]}},_e.del=function(se){var fe=this.rules.inline.del.exec(se);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},_e.autolink=function(se,fe){var ee=this.rules.inline.autolink.exec(se);if(ee){var ie,de;return ee[2]==="@"?(ie=E(this.options.mangle?fe(ee[1]):ee[1]),de="mailto:"+ie):(ie=E(ee[1]),de=ie),{type:"link",raw:ee[0],text:ie,href:de,tokens:[{type:"text",raw:ie,text:ie}]}}},_e.url=function(se,fe){var ee;if(ee=this.rules.inline.url.exec(se)){var ie,de;if(ee[2]==="@")ie=E(this.options.mangle?fe(ee[0]):ee[0]),de="mailto:"+ie;else{var R;do R=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(R!==ee[0]);ie=E(ee[0]),ee[1]==="www."?de="http://"+ie:de=ie}return{type:"link",raw:ee[0],text:ie,href:de,tokens:[{type:"text",raw:ie,text:ie}]}}},_e.inlineText=function(se,fe){var ee=this.rules.inline.text.exec(se);if(ee){var ie;return this.lexer.state.inRawBlock?ie=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):E(ee[0]):ee[0]:ie=E(this.options.smartypants?fe(ee[0]):ee[0]),{type:"text",raw:ee[0],text:ie}}},Ce}(),x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:D,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=a(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.listItemStart=a(/^( *)(bull) */).replace("bull",x.bullet).getRegex(),x.list=a(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=a(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=a(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.blockquote=a(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=u({},x),x.gfm=u({},x.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.table=a(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.gfm.paragraph=a(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",x.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.pedantic=u({},x.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:D,paragraph:a(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:D,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:D,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=a(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=a(x._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=a(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=a(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=a(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=a(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=a(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=a(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=a(U.reflink).replace("label",U._label).replace("ref",x._label).getRegex(),U.nolink=a(U.nolink).replace("ref",x._label).getRegex(),U.reflinkSearch=a(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=u({},U),U.pedantic=u({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=u({},U.normal,{escape:a(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=a(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=u({},U.gfm,{br:a(U.br).replace("{2,}","*").getRegex(),text:a(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ae(Ce){var _e="",Ie,se,fe=Ce.length;for(Ie=0;Ie<fe;Ie++)se=Ce.charCodeAt(Ie),Math.random()>.5&&(se="x"+se.toString(16)),_e+="&#"+se+";";return _e}var Y=function(){function Ce(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||pe.defaults,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:x.normal,inline:U.normal};this.options.pedantic?(se.block=x.pedantic,se.inline=U.pedantic):this.options.gfm&&(se.block=x.gfm,this.options.breaks?se.inline=U.breaks:se.inline=U.gfm),this.tokenizer.rules=se}Ce.lex=function(se,fe){var ee=new Ce(fe);return ee.lex(se)},Ce.lexInline=function(se,fe){var ee=new Ce(fe);return ee.inlineTokens(se)};var _e=Ce.prototype;return _e.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},_e.blockTokens=function(se,fe){var ee=this;fe===void 0&&(fe=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(q,oe,j){return oe+"    ".repeat(j.length)});for(var ie,de,R,W;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(q){return(ie=q.call({lexer:ee},se,fe))?(se=se.substring(ie.raw.length),fe.push(ie),!0):!1}))){if(ie=this.tokenizer.space(se)){se=se.substring(ie.raw.length),ie.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(ie);continue}if(ie=this.tokenizer.code(se)){se=se.substring(ie.raw.length),de=fe[fe.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+ie.raw,de.text+=`
`+ie.text,this.inlineQueue[this.inlineQueue.length-1].src=de.text):fe.push(ie);continue}if(ie=this.tokenizer.fences(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.heading(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.hr(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.blockquote(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.list(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.html(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.def(se)){se=se.substring(ie.raw.length),de=fe[fe.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+ie.raw,de.text+=`
`+ie.raw,this.inlineQueue[this.inlineQueue.length-1].src=de.text):this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.lheading(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(R=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var q=1/0,oe=se.slice(1),j=void 0;ee.options.extensions.startBlock.forEach(function(ce){j=ce.call({lexer:this},oe),typeof j=="number"&&j>=0&&(q=Math.min(q,j))}),q<1/0&&q>=0&&(R=se.substring(0,q+1))}(),this.state.top&&(ie=this.tokenizer.paragraph(R))){de=fe[fe.length-1],W&&de.type==="paragraph"?(de.raw+=`
`+ie.raw,de.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):fe.push(ie),W=R.length!==se.length,se=se.substring(ie.raw.length);continue}if(ie=this.tokenizer.text(se)){se=se.substring(ie.raw.length),de=fe[fe.length-1],de&&de.type==="text"?(de.raw+=`
`+ie.raw,de.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):fe.push(ie);continue}if(se){var V="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,fe},_e.inline=function(se,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:se,tokens:fe}),fe},_e.inlineTokens=function(se,fe){var ee=this;fe===void 0&&(fe=[]);var ie,de,R,W=se,V,q,oe;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(W))!=null;)j.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(W=W.slice(0,V.index)+"["+P("a",V[0].length-2)+"]"+W.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(W))!=null;)W=W.slice(0,V.index)+"["+P("a",V[0].length-2)+"]"+W.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(W))!=null;)W=W.slice(0,V.index)+"++"+W.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(q||(oe=""),q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(ie=ve.call({lexer:ee},se,fe))?(se=se.substring(ie.raw.length),fe.push(ie),!0):!1}))){if(ie=this.tokenizer.escape(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.tag(se)){se=se.substring(ie.raw.length),de=fe[fe.length-1],de&&ie.type==="text"&&de.type==="text"?(de.raw+=ie.raw,de.text+=ie.text):fe.push(ie);continue}if(ie=this.tokenizer.link(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(ie.raw.length),de=fe[fe.length-1],de&&ie.type==="text"&&de.type==="text"?(de.raw+=ie.raw,de.text+=ie.text):fe.push(ie);continue}if(ie=this.tokenizer.emStrong(se,W,oe)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.codespan(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.br(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.del(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.autolink(se,ae)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(!this.state.inLink&&(ie=this.tokenizer.url(se,ae))){se=se.substring(ie.raw.length),fe.push(ie);continue}if(R=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Ue=se.slice(1),$e=void 0;ee.options.extensions.startInline.forEach(function(Qe){$e=Qe.call({lexer:this},Ue),typeof $e=="number"&&$e>=0&&(ve=Math.min(ve,$e))}),ve<1/0&&ve>=0&&(R=se.substring(0,ve+1))}(),ie=this.tokenizer.inlineText(R,N)){se=se.substring(ie.raw.length),ie.raw.slice(-1)!=="_"&&(oe=ie.raw.slice(-1)),q=!0,de=fe[fe.length-1],de&&de.type==="text"?(de.raw+=ie.raw,de.text+=ie.text):fe.push(ie);continue}if(se){var ce="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return fe},w(Ce,null,[{key:"rules",get:function(){return{block:x,inline:U}}}]),Ce}(),Ee=function(){function Ce(Ie){this.options=Ie||pe.defaults}var _e=Ce.prototype;return _e.code=function(se,fe,ee){var ie=(fe||"").match(/\S*/)[0];if(this.options.highlight){var de=this.options.highlight(se,ie);de!=null&&de!==se&&(ee=!0,se=de)}return se=se.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+E(ie,!0)+'">'+(ee?se:E(se,!0))+`</code></pre>
`:"<pre><code>"+(ee?se:E(se,!0))+`</code></pre>
`},_e.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},_e.html=function(se){return se},_e.heading=function(se,fe,ee,ie){if(this.options.headerIds){var de=this.options.headerPrefix+ie.slug(ee);return"<h"+fe+' id="'+de+'">'+se+"</h"+fe+`>
`}return"<h"+fe+">"+se+"</h"+fe+`>
`},_e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_e.list=function(se,fe,ee){var ie=fe?"ol":"ul",de=fe&&ee!==1?' start="'+ee+'"':"";return"<"+ie+de+`>
`+se+"</"+ie+`>
`},_e.listitem=function(se){return"<li>"+se+`</li>
`},_e.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_e.paragraph=function(se){return"<p>"+se+`</p>
`},_e.table=function(se,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+fe+`</table>
`},_e.tablerow=function(se){return`<tr>
`+se+`</tr>
`},_e.tablecell=function(se,fe){var ee=fe.header?"th":"td",ie=fe.align?"<"+ee+' align="'+fe.align+'">':"<"+ee+">";return ie+se+("</"+ee+`>
`)},_e.strong=function(se){return"<strong>"+se+"</strong>"},_e.em=function(se){return"<em>"+se+"</em>"},_e.codespan=function(se){return"<code>"+se+"</code>"},_e.br=function(){return this.options.xhtml?"<br/>":"<br>"},_e.del=function(se){return"<del>"+se+"</del>"},_e.link=function(se,fe,ee){if(se=k(this.options.sanitize,this.options.baseUrl,se),se===null)return ee;var ie='<a href="'+E(se)+'"';return fe&&(ie+=' title="'+fe+'"'),ie+=">"+ee+"</a>",ie},_e.image=function(se,fe,ee){if(se=k(this.options.sanitize,this.options.baseUrl,se),se===null)return ee;var ie='<img src="'+se+'" alt="'+ee+'"';return fe&&(ie+=' title="'+fe+'"'),ie+=this.options.xhtml?"/>":">",ie},_e.text=function(se){return se},Ce}(),ye=function(){function Ce(){}var _e=Ce.prototype;return _e.strong=function(se){return se},_e.em=function(se){return se},_e.codespan=function(se){return se},_e.del=function(se){return se},_e.html=function(se){return se},_e.text=function(se){return se},_e.link=function(se,fe,ee){return""+ee},_e.image=function(se,fe,ee){return""+ee},_e.br=function(){return""},Ce}(),Re=function(){function Ce(){this.seen={}}var _e=Ce.prototype;return _e.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_e.getNextSafeSlug=function(se,fe){var ee=se,ie=0;if(this.seen.hasOwnProperty(ee)){ie=this.seen[se];do ie++,ee=se+"-"+ie;while(this.seen.hasOwnProperty(ee))}return fe||(this.seen[se]=ie,this.seen[ee]=0),ee},_e.slug=function(se,fe){fe===void 0&&(fe={});var ee=this.serialize(se);return this.getNextSafeSlug(ee,fe.dryrun)},Ce}(),K=function(){function Ce(Ie){this.options=Ie||pe.defaults,this.options.renderer=this.options.renderer||new Ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new Re}Ce.parse=function(se,fe){var ee=new Ce(fe);return ee.parse(se)},Ce.parseInline=function(se,fe){var ee=new Ce(fe);return ee.parseInline(se)};var _e=Ce.prototype;return _e.parse=function(se,fe){fe===void 0&&(fe=!0);var ee="",ie,de,R,W,V,q,oe,j,ce,ve,Ue,$e,Qe,qe,Ye,Ke,ct,Ze,tt,Ne=se.length;for(ie=0;ie<Ne;ie++){if(ve=se[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(tt=this.options.extensions.renderers[ve.type].call({parser:this},ve),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){ee+=tt||"";continue}switch(ve.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,t(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(j="",oe="",W=ve.header.length,de=0;de<W;de++)oe+=this.renderer.tablecell(this.parseInline(ve.header[de].tokens),{header:!0,align:ve.align[de]});for(j+=this.renderer.tablerow(oe),ce="",W=ve.rows.length,de=0;de<W;de++){for(q=ve.rows[de],oe="",V=q.length,R=0;R<V;R++)oe+=this.renderer.tablecell(this.parseInline(q[R].tokens),{header:!1,align:ve.align[R]});ce+=this.renderer.tablerow(oe)}ee+=this.renderer.table(j,ce);continue}case"blockquote":{ce=this.parse(ve.tokens),ee+=this.renderer.blockquote(ce);continue}case"list":{for(Ue=ve.ordered,$e=ve.start,Qe=ve.loose,W=ve.items.length,ce="",de=0;de<W;de++)Ye=ve.items[de],Ke=Ye.checked,ct=Ye.task,qe="",Ye.task&&(Ze=this.renderer.checkbox(Ke),Qe?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=Ze+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=Ze+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:Ze}):qe+=Ze),qe+=this.parse(Ye.tokens,Qe),ce+=this.renderer.listitem(qe,ct,Ke);ee+=this.renderer.list(ce,Ue,$e);continue}case"html":{ee+=this.renderer.html(ve.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(ce=ve.tokens?this.parseInline(ve.tokens):ve.text;ie+1<Ne&&se[ie+1].type==="text";)ve=se[++ie],ce+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);ee+=fe?this.renderer.paragraph(ce):ce;continue}default:{var nt='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(nt);return}else throw new Error(nt)}}}return ee},_e.parseInline=function(se,fe){fe=fe||this.renderer;var ee="",ie,de,R,W=se.length;for(ie=0;ie<W;ie++){if(de=se[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(R=this.options.extensions.renderers[de.type].call({parser:this},de),R!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(de.type))){ee+=R||"";continue}switch(de.type){case"escape":{ee+=fe.text(de.text);break}case"html":{ee+=fe.html(de.text);break}case"link":{ee+=fe.link(de.href,de.title,this.parseInline(de.tokens,fe));break}case"image":{ee+=fe.image(de.href,de.title,de.text);break}case"strong":{ee+=fe.strong(this.parseInline(de.tokens,fe));break}case"em":{ee+=fe.em(this.parseInline(de.tokens,fe));break}case"codespan":{ee+=fe.codespan(de.text);break}case"br":{ee+=fe.br();break}case"del":{ee+=fe.del(this.parseInline(de.tokens,fe));break}case"text":{ee+=fe.text(de.text);break}default:{var V='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return ee},Ce}();function Q(Ce,_e,Ie){if(typeof Ce>"u"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof _e=="function"&&(Ie=_e,_e=null),_e=u({},Q.defaults,_e||{}),f(_e),Ie){var se=_e.highlight,fe;try{fe=Y.lex(Ce,_e)}catch(W){return Ie(W)}var ee=function(V){var q;if(!V)try{_e.walkTokens&&Q.walkTokens(fe,_e.walkTokens),q=K.parse(fe,_e)}catch(oe){V=oe}return _e.highlight=se,V?Ie(V):Ie(null,q)};if(!se||se.length<3||(delete _e.highlight,!fe.length))return ee();var ie=0;Q.walkTokens(fe,function(W){W.type==="code"&&(ie++,setTimeout(function(){se(W.text,W.lang,function(V,q){if(V)return ee(V);q!=null&&q!==W.text&&(W.text=q,W.escaped=!0),ie--,ie===0&&ee()})},0))}),ie===0&&ee();return}function de(W){if(W.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+E(W.message+"",!0)+"</pre>";throw W}try{var R=Y.lex(Ce,_e);if(_e.walkTokens){if(_e.async)return Promise.all(Q.walkTokens(R,_e.walkTokens)).then(function(){return K.parse(R,_e)}).catch(de);Q.walkTokens(R,_e.walkTokens)}return K.parse(R,_e)}catch(W){de(W)}}Q.options=Q.setOptions=function(Ce){return u(Q.defaults,Ce),h(Q.defaults),Q},Q.getDefaults=T,Q.defaults=pe.defaults,Q.use=function(){for(var Ce=arguments.length,_e=new Array(Ce),Ie=0;Ie<Ce;Ie++)_e[Ie]=arguments[Ie];var se=u.apply(void 0,[{}].concat(_e)),fe=Q.defaults.extensions||{renderers:{},childTokens:{}},ee;_e.forEach(function(ie){if(ie.extensions&&(ee=!0,ie.extensions.forEach(function(R){if(!R.name)throw new Error("extension name required");if(R.renderer){var W=fe.renderers?fe.renderers[R.name]:null;W?fe.renderers[R.name]=function(){for(var V=arguments.length,q=new Array(V),oe=0;oe<V;oe++)q[oe]=arguments[oe];var j=R.renderer.apply(this,q);return j===!1&&(j=W.apply(this,q)),j}:fe.renderers[R.name]=R.renderer}if(R.tokenizer){if(!R.level||R.level!=="block"&&R.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[R.level]?fe[R.level].unshift(R.tokenizer):fe[R.level]=[R.tokenizer],R.start&&(R.level==="block"?fe.startBlock?fe.startBlock.push(R.start):fe.startBlock=[R.start]:R.level==="inline"&&(fe.startInline?fe.startInline.push(R.start):fe.startInline=[R.start]))}R.childTokens&&(fe.childTokens[R.name]=R.childTokens)})),ie.renderer&&function(){var R=Q.defaults.renderer||new Ee,W=function(oe){var j=R[oe];R[oe]=function(){for(var ce=arguments.length,ve=new Array(ce),Ue=0;Ue<ce;Ue++)ve[Ue]=arguments[Ue];var $e=ie.renderer[oe].apply(R,ve);return $e===!1&&($e=j.apply(R,ve)),$e}};for(var V in ie.renderer)W(V);se.renderer=R}(),ie.tokenizer&&function(){var R=Q.defaults.tokenizer||new H,W=function(oe){var j=R[oe];R[oe]=function(){for(var ce=arguments.length,ve=new Array(ce),Ue=0;Ue<ce;Ue++)ve[Ue]=arguments[Ue];var $e=ie.tokenizer[oe].apply(R,ve);return $e===!1&&($e=j.apply(R,ve)),$e}};for(var V in ie.tokenizer)W(V);se.tokenizer=R}(),ie.walkTokens){var de=Q.defaults.walkTokens;se.walkTokens=function(R){var W=[];return W.push(ie.walkTokens.call(this,R)),de&&(W=W.concat(de.call(this,R))),W}}ee&&(se.extensions=fe),Q.setOptions(se)})},Q.walkTokens=function(Ce,_e){for(var Ie=[],se=function(){var de=ee.value;switch(Ie=Ie.concat(_e.call(Q,de)),de.type){case"table":{for(var R=M(de.header),W;!(W=R()).done;){var V=W.value;Ie=Ie.concat(Q.walkTokens(V.tokens,_e))}for(var q=M(de.rows),oe;!(oe=q()).done;)for(var j=oe.value,ce=M(j),ve;!(ve=ce()).done;){var Ue=ve.value;Ie=Ie.concat(Q.walkTokens(Ue.tokens,_e))}break}case"list":{Ie=Ie.concat(Q.walkTokens(de.items,_e));break}default:Q.defaults.extensions&&Q.defaults.extensions.childTokens&&Q.defaults.extensions.childTokens[de.type]?Q.defaults.extensions.childTokens[de.type].forEach(function($e){Ie=Ie.concat(Q.walkTokens(de[$e],_e))}):de.tokens&&(Ie=Ie.concat(Q.walkTokens(de.tokens,_e)))}},fe=M(Ce),ee;!(ee=fe()).done;)se();return Ie},Q.parseInline=function(Ce,_e){if(typeof Ce>"u"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");_e=u({},Q.defaults,_e||{}),f(_e);try{var Ie=Y.lexInline(Ce,_e);return _e.walkTokens&&Q.walkTokens(Ie,_e.walkTokens),K.parseInline(Ie,_e)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+E(se.message+"",!0)+"</pre>";throw se}},Q.Parser=K,Q.parser=K.parse,Q.Renderer=Ee,Q.TextRenderer=ye,Q.Lexer=Y,Q.lexer=Y.lex,Q.Tokenizer=H,Q.Slugger=Re,Q.parse=Q;var ue=Q.options,ne=Q.setOptions,he=Q.use,le=Q.walkTokens,F=Q.parseInline,J=Q,Se=K.parse,ke=Y.lex;pe.Lexer=Y,pe.Parser=K,pe.Renderer=Ee,pe.Slugger=Re,pe.TextRenderer=ye,pe.Tokenizer=H,pe.getDefaults=T,pe.lexer=ke,pe.marked=Q,pe.options=ue,pe.parse=J,pe.parseInline=F,pe.parser=Se,pe.setOptions=ne,pe.use=he,pe.walkTokens=le,Object.defineProperty(pe,"__esModule",{value:!0})}),define(Pe[117],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function w(h,y,p){return Math.min(Math.max(h,y),p)}e.clamp=w;function O(h,y){return(y+h%y)%y}e.rot=O;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class M{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class T{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const p=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=p,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function pe(I){const M=[];typeof I=="number"&&M.push("code/timeOrigin",I);function T(y){M.push(y,Date.now())}function h(){const y=[];for(let p=0;p<M.length;p+=2)y.push({name:M[p],startTime:M[p+1]});return y}return{mark:T,getMarks:h}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?pe():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const T of performance.getEntriesByType("mark"))M.push({name:T.name,startTime:Math.round(I+T.startTime)});return M}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return pe(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),pe()}function w(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=w(O))}(),function(pe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var O in w)(typeof exports=="object"?exports:pe)[O]=w[O]}}(typeof self<"u"?self:this,function(){return function(pe){var e={};function w(O){if(e[O])return e[O].exports;var I=e[O]={i:O,l:!1,exports:{}};return pe[O].call(I.exports,I,I.exports,w),I.l=!0,I.exports}return w.m=pe,w.c=e,w.d=function(O,I,M){w.o(O,I)||Object.defineProperty(O,I,{enumerable:!0,get:M})},w.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},w.t=function(O,I){if(1&I&&(O=w(O)),8&I||4&I&&typeof O=="object"&&O&&O.__esModule)return O;var M=Object.create(null);if(w.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:O}),2&I&&typeof O!="string")for(var T in O)w.d(M,T,function(h){return O[h]}.bind(null,T));return M},w.n=function(O){var I=O&&O.__esModule?function(){return O.default}:function(){return O};return w.d(I,"a",I),I},w.o=function(O,I){return Object.prototype.hasOwnProperty.call(O,I)},w.p="",w(w.s=0)}([function(pe,e,w){(function(O){var I;e=pe.exports=he,I=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,h=e.re=[],y=e.src=[],p=0,A=p++;y[A]="0|[1-9]\\d*";var _=p++;y[_]="[0-9]+";var c=p++;y[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=p++;y[S]="("+y[A]+")\\.("+y[A]+")\\.("+y[A]+")";var E=p++;y[E]="("+y[_]+")\\.("+y[_]+")\\.("+y[_]+")";var o=p++;y[o]="(?:"+y[A]+"|"+y[c]+")";var t=p++;y[t]="(?:"+y[_]+"|"+y[c]+")";var i=p++;y[i]="(?:-("+y[o]+"(?:\\."+y[o]+")*))";var a=p++;y[a]="(?:-?("+y[t]+"(?:\\."+y[t]+")*))";var g=p++;y[g]="[0-9A-Za-z-]+";var C=p++;y[C]="(?:\\+("+y[g]+"(?:\\."+y[g]+")*))";var k=p++,r="v?"+y[S]+y[i]+"?"+y[C]+"?";y[k]="^"+r+"$";var d="[v=\\s]*"+y[E]+y[a]+"?"+y[C]+"?",n=p++;y[n]="^"+d+"$";var s=p++;y[s]="((?:<|>)?=?)";var v=p++;y[v]=y[_]+"|x|X|\\*";var D=p++;y[D]=y[A]+"|x|X|\\*";var u=p++;y[u]="[v=\\s]*("+y[D]+")(?:\\.("+y[D]+")(?:\\.("+y[D]+")(?:"+y[i]+")?"+y[C]+"?)?)?";var m=p++;y[m]="[v=\\s]*("+y[v]+")(?:\\.("+y[v]+")(?:\\.("+y[v]+")(?:"+y[a]+")?"+y[C]+"?)?)?";var b=p++;y[b]="^"+y[s]+"\\s*"+y[u]+"$";var l=p++;y[l]="^"+y[s]+"\\s*"+y[m]+"$";var f=p++;y[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=p++;y[P]="(?:~>?)";var z=p++;y[z]="(\\s*)"+y[P]+"\\s+",h[z]=new RegExp(y[z],"g");var $=p++;y[$]="^"+y[P]+y[u]+"$";var H=p++;y[H]="^"+y[P]+y[m]+"$";var x=p++;y[x]="(?:\\^)";var U=p++;y[U]="(\\s*)"+y[x]+"\\s+",h[U]=new RegExp(y[U],"g");var N=p++;y[N]="^"+y[x]+y[u]+"$";var ae=p++;y[ae]="^"+y[x]+y[m]+"$";var Y=p++;y[Y]="^"+y[s]+"\\s*("+d+")$|^$";var Ee=p++;y[Ee]="^"+y[s]+"\\s*("+r+")$|^$";var ye=p++;y[ye]="(\\s*)"+y[s]+"\\s*("+d+"|"+y[u]+")",h[ye]=new RegExp(y[ye],"g");var Re=p++;y[Re]="^\\s*("+y[u]+")\\s+-\\s+("+y[u]+")\\s*$";var K=p++;y[K]="^\\s*("+y[m]+")\\s+-\\s+("+y[m]+")\\s*$";var Q=p++;y[Q]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)I(ue,y[ue]),h[ue]||(h[ue]=new RegExp(y[ue]));function ne(j,ce){if(j instanceof he)return j;if(typeof j!="string"||j.length>M||!(ce?h[n]:h[k]).test(j))return null;try{return new he(j,ce)}catch{return null}}function he(j,ce){if(j instanceof he){if(j.loose===ce)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof he))return new he(j,ce);I("SemVer",j,ce),this.loose=ce;var ve=j.trim().match(ce?h[n]:h[k]);if(!ve)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(Ue){if(/^[0-9]+$/.test(Ue)){var $e=+Ue;if($e>=0&&$e<T)return $e}return Ue}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=ne,e.valid=function(j,ce){var ve=ne(j,ce);return ve?ve.version:null},e.clean=function(j,ce){var ve=ne(j.trim().replace(/^[=v]+/,""),ce);return ve?ve.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(j){return I("SemVer.compare",this.version,this.loose,j),j instanceof he||(j=new he(j,this.loose)),this.compareMain(j)||this.comparePre(j)},he.prototype.compareMain=function(j){return j instanceof he||(j=new he(j,this.loose)),F(this.major,j.major)||F(this.minor,j.minor)||F(this.patch,j.patch)},he.prototype.comparePre=function(j){if(j instanceof he||(j=new he(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var ce=0;do{var ve=this.prerelease[ce],Ue=j.prerelease[ce];if(I("prerelease compare",ce,ve,Ue),ve===void 0&&Ue===void 0)return 0;if(Ue===void 0)return 1;if(ve===void 0)return-1;if(ve!==Ue)return F(ve,Ue)}while(++ce)},he.prototype.inc=function(j,ce){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ce),this.inc("pre",ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ce),this.inc("pre",ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}ce&&(this.prerelease[0]===ce?isNaN(this.prerelease[1])&&(this.prerelease=[ce,0]):this.prerelease=[ce,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,ce,ve,Ue){typeof ve=="string"&&(Ue=ve,ve=void 0);try{return new he(j,ve).inc(ce,Ue).version}catch{return null}},e.diff=function(j,ce){if(Ce(j,ce))return null;var ve=ne(j),Ue=ne(ce);if(ve.prerelease.length||Ue.prerelease.length){for(var $e in ve)if(($e==="major"||$e==="minor"||$e==="patch")&&ve[$e]!==Ue[$e])return"pre"+$e;return"prerelease"}for(var $e in ve)if(($e==="major"||$e==="minor"||$e==="patch")&&ve[$e]!==Ue[$e])return $e},e.compareIdentifiers=F;var le=/^[0-9]+$/;function F(j,ce){var ve=le.test(j),Ue=le.test(ce);return ve&&Ue&&(j=+j,ce=+ce),ve&&!Ue?-1:Ue&&!ve?1:j<ce?-1:j>ce?1:0}function J(j,ce,ve){return new he(j,ve).compare(new he(ce,ve))}function Se(j,ce,ve){return J(j,ce,ve)>0}function ke(j,ce,ve){return J(j,ce,ve)<0}function Ce(j,ce,ve){return J(j,ce,ve)===0}function _e(j,ce,ve){return J(j,ce,ve)!==0}function Ie(j,ce,ve){return J(j,ce,ve)>=0}function se(j,ce,ve){return J(j,ce,ve)<=0}function fe(j,ce,ve,Ue){var $e;switch(ce){case"===":typeof j=="object"&&(j=j.version),typeof ve=="object"&&(ve=ve.version),$e=j===ve;break;case"!==":typeof j=="object"&&(j=j.version),typeof ve=="object"&&(ve=ve.version),$e=j!==ve;break;case"":case"=":case"==":$e=Ce(j,ve,Ue);break;case"!=":$e=_e(j,ve,Ue);break;case">":$e=Se(j,ve,Ue);break;case">=":$e=Ie(j,ve,Ue);break;case"<":$e=ke(j,ve,Ue);break;case"<=":$e=se(j,ve,Ue);break;default:throw new TypeError("Invalid operator: "+ce)}return $e}function ee(j,ce){if(j instanceof ee){if(j.loose===ce)return j;j=j.value}if(!(this instanceof ee))return new ee(j,ce);I("comparator",j,ce),this.loose=ce,this.parse(j),this.semver===ie?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(j,ce){return F(ce,j)},e.major=function(j,ce){return new he(j,ce).major},e.minor=function(j,ce){return new he(j,ce).minor},e.patch=function(j,ce){return new he(j,ce).patch},e.compare=J,e.compareLoose=function(j,ce){return J(j,ce,!0)},e.rcompare=function(j,ce,ve){return J(ce,j,ve)},e.sort=function(j,ce){return j.sort(function(ve,Ue){return e.compare(ve,Ue,ce)})},e.rsort=function(j,ce){return j.sort(function(ve,Ue){return e.rcompare(ve,Ue,ce)})},e.gt=Se,e.lt=ke,e.eq=Ce,e.neq=_e,e.gte=Ie,e.lte=se,e.cmp=fe,e.Comparator=ee;var ie={};function de(j,ce){if(j instanceof de)return j.loose===ce?j:new de(j.raw,ce);if(j instanceof ee)return new de(j.value,ce);if(!(this instanceof de))return new de(j,ce);if(this.loose=ce,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function R(j){return!j||j.toLowerCase()==="x"||j==="*"}function W(j,ce,ve,Ue,$e,Qe,qe,Ye,Ke,ct,Ze,tt,Ne){return((ce=R(ve)?"":R(Ue)?">="+ve+".0.0":R($e)?">="+ve+"."+Ue+".0":">="+ce)+" "+(Ye=R(Ke)?"":R(ct)?"<"+(+Ke+1)+".0.0":R(Ze)?"<"+Ke+"."+(+ct+1)+".0":tt?"<="+Ke+"."+ct+"."+Ze+"-"+tt:"<="+Ye)).trim()}function V(j,ce){for(var ve=0;ve<j.length;ve++)if(!j[ve].test(ce))return!1;if(ce.prerelease.length){for(ve=0;ve<j.length;ve++)if(I(j[ve].semver),j[ve].semver!==ie&&j[ve].semver.prerelease.length>0){var Ue=j[ve].semver;if(Ue.major===ce.major&&Ue.minor===ce.minor&&Ue.patch===ce.patch)return!0}return!1}return!0}function q(j,ce,ve){try{ce=new de(ce,ve)}catch{return!1}return ce.test(j)}function oe(j,ce,ve,Ue){var $e,Qe,qe,Ye,Ke;switch(j=new he(j,Ue),ce=new de(ce,Ue),ve){case">":$e=Se,Qe=se,qe=ke,Ye=">",Ke=">=";break;case"<":$e=ke,Qe=Ie,qe=Se,Ye="<",Ke="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(q(j,ce,Ue))return!1;for(var ct=0;ct<ce.set.length;++ct){var Ze=ce.set[ct],tt=null,Ne=null;if(Ze.forEach(function(nt){nt.semver===ie&&(nt=new ee(">=0.0.0")),tt=tt||nt,Ne=Ne||nt,$e(nt.semver,tt.semver,Ue)?tt=nt:qe(nt.semver,Ne.semver,Ue)&&(Ne=nt)}),tt.operator===Ye||tt.operator===Ke||(!Ne.operator||Ne.operator===Ye)&&Qe(j,Ne.semver)||Ne.operator===Ke&&qe(j,Ne.semver))return!1}return!0}ee.prototype.parse=function(j){var ce=this.loose?h[Y]:h[Ee],ve=j.match(ce);if(!ve)throw new TypeError("Invalid comparator: "+j);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new he(ve[2],this.loose):this.semver=ie},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(j){return I("Comparator.test",j,this.loose),this.semver===ie||(typeof j=="string"&&(j=new he(j,this.loose)),fe(j,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(j,ce){if(!(j instanceof ee))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new de(j.value,ce),q(this.value,ve,ce);if(j.operator==="")return ve=new de(this.value,ce),q(j.semver,ve,ce);var Ue=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),$e=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Qe=this.semver.version===j.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Ye=fe(this.semver,"<",j.semver,ce)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),Ke=fe(this.semver,">",j.semver,ce)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return Ue||$e||Qe&&qe||Ye||Ke},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(j){var ce=this.loose;j=j.trim(),I("range",j,ce);var ve=ce?h[K]:h[Re];j=j.replace(ve,W),I("hyphen replace",j),j=j.replace(h[ye],"$1$2$3"),I("comparator trim",j,h[ye]),j=(j=(j=j.replace(h[z],"$1~")).replace(h[U],"$1^")).split(/\s+/).join(" ");var Ue=ce?h[Y]:h[Ee],$e=j.split(" ").map(function(Qe){return function(qe,Ye){return I("comp",qe),qe=function(Ke,ct){return Ke.trim().split(/\s+/).map(function(Ze){return function(tt,Ne){I("caret",tt,Ne);var nt=Ne?h[ae]:h[N];return tt.replace(nt,function(Z,X,ge,Be,Me){var Ge;return I("caret",tt,Z,X,ge,Be,Me),R(X)?Ge="":R(ge)?Ge=">="+X+".0.0 <"+(+X+1)+".0.0":R(Be)?Ge=X==="0"?">="+X+"."+ge+".0 <"+X+"."+(+ge+1)+".0":">="+X+"."+ge+".0 <"+(+X+1)+".0.0":Me?(I("replaceCaret pr",Me),Me.charAt(0)!=="-"&&(Me="-"+Me),Ge=X==="0"?ge==="0"?">="+X+"."+ge+"."+Be+Me+" <"+X+"."+ge+"."+(+Be+1):">="+X+"."+ge+"."+Be+Me+" <"+X+"."+(+ge+1)+".0":">="+X+"."+ge+"."+Be+Me+" <"+(+X+1)+".0.0"):(I("no pr"),Ge=X==="0"?ge==="0"?">="+X+"."+ge+"."+Be+" <"+X+"."+ge+"."+(+Be+1):">="+X+"."+ge+"."+Be+" <"+X+"."+(+ge+1)+".0":">="+X+"."+ge+"."+Be+" <"+(+X+1)+".0.0"),I("caret return",Ge),Ge})}(Ze,ct)}).join(" ")}(qe,Ye),I("caret",qe),qe=function(Ke,ct){return Ke.trim().split(/\s+/).map(function(Ze){return function(tt,Ne){var nt=Ne?h[H]:h[$];return tt.replace(nt,function(Z,X,ge,Be,Me){var Ge;return I("tilde",tt,Z,X,ge,Be,Me),R(X)?Ge="":R(ge)?Ge=">="+X+".0.0 <"+(+X+1)+".0.0":R(Be)?Ge=">="+X+"."+ge+".0 <"+X+"."+(+ge+1)+".0":Me?(I("replaceTilde pr",Me),Me.charAt(0)!=="-"&&(Me="-"+Me),Ge=">="+X+"."+ge+"."+Be+Me+" <"+X+"."+(+ge+1)+".0"):Ge=">="+X+"."+ge+"."+Be+" <"+X+"."+(+ge+1)+".0",I("tilde return",Ge),Ge})}(Ze,ct)}).join(" ")}(qe,Ye),I("tildes",qe),qe=function(Ke,ct){return I("replaceXRanges",Ke,ct),Ke.split(/\s+/).map(function(Ze){return function(tt,Ne){tt=tt.trim();var nt=Ne?h[l]:h[b];return tt.replace(nt,function(Z,X,ge,Be,Me,Ge){I("xRange",tt,Z,X,ge,Be,Me,Ge);var et=R(ge),mt=et||R(Be),wt=mt||R(Me);return X==="="&&wt&&(X=""),et?Z=X===">"||X==="<"?"<0.0.0":"*":X&&wt?(mt&&(Be=0),wt&&(Me=0),X===">"?(X=">=",mt?(ge=+ge+1,Be=0,Me=0):wt&&(Be=+Be+1,Me=0)):X==="<="&&(X="<",mt?ge=+ge+1:Be=+Be+1),Z=X+ge+"."+Be+"."+Me):mt?Z=">="+ge+".0.0 <"+(+ge+1)+".0.0":wt&&(Z=">="+ge+"."+Be+".0 <"+ge+"."+(+Be+1)+".0"),I("xRange return",Z),Z})}(Ze,ct)}).join(" ")}(qe,Ye),I("xrange",qe),qe=function(Ke,ct){return I("replaceStars",Ke,ct),Ke.trim().replace(h[Q],"")}(qe,Ye),I("stars",qe),qe}(Qe,ce)}).join(" ").split(/\s+/);return this.loose&&($e=$e.filter(function(Qe){return!!Qe.match(Ue)})),$e=$e.map(function(Qe){return new ee(Qe,ce)})},de.prototype.intersects=function(j,ce){if(!(j instanceof de))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(Ue){return j.set.some(function($e){return $e.every(function(Qe){return Ue.intersects(Qe,ce)})})})})},e.toComparators=function(j,ce){return new de(j,ce).set.map(function(ve){return ve.map(function(Ue){return Ue.value}).join(" ").trim().split(" ")})},de.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new he(j,this.loose));for(var ce=0;ce<this.set.length;ce++)if(V(this.set[ce],j))return!0;return!1},e.satisfies=q,e.maxSatisfying=function(j,ce,ve){var Ue=null,$e=null;try{var Qe=new de(ce,ve)}catch{return null}return j.forEach(function(qe){Qe.test(qe)&&(Ue&&$e.compare(qe)!==-1||($e=new he(Ue=qe,ve)))}),Ue},e.minSatisfying=function(j,ce,ve){var Ue=null,$e=null;try{var Qe=new de(ce,ve)}catch{return null}return j.forEach(function(qe){Qe.test(qe)&&(Ue&&$e.compare(qe)!==1||($e=new he(Ue=qe,ve)))}),Ue},e.validRange=function(j,ce){try{return new de(j,ce).range||"*"}catch{return null}},e.ltr=function(j,ce,ve){return oe(j,ce,"<",ve)},e.gtr=function(j,ce,ve){return oe(j,ce,">",ve)},e.outside=oe,e.prerelease=function(j,ce){var ve=ne(j,ce);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(j,ce,ve){return j=new de(j,ve),ce=new de(ce,ve),j.intersects(ce)},e.coerce=function(j){if(j instanceof he)return j;if(typeof j!="string")return null;var ce=j.match(h[f]);return ce==null?null:ne((ce[1]||"0")+"."+(ce[2]||"0")+"."+(ce[3]||"0"))}}).call(this,w(1))},function(pe,e){var w,O,I=pe.exports={};function M(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function h(t){if(w===setTimeout)return setTimeout(t,0);if((w===M||!w)&&setTimeout)return w=setTimeout,setTimeout(t,0);try{return w(t,0)}catch{try{return w.call(null,t,0)}catch{return w.call(this,t,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:M}catch{w=M}try{O=typeof clearTimeout=="function"?clearTimeout:T}catch{O=T}})();var y,p=[],A=!1,_=-1;function c(){A&&y&&(A=!1,y.length?p=y.concat(p):_=-1,p.length&&S())}function S(){if(!A){var t=h(c);A=!0;for(var i=p.length;i;){for(y=p,p=[];++_<i;)y&&y[_].run();_=-1,i=p.length}y=null,A=!1,function(a){if(O===clearTimeout)return clearTimeout(a);if((O===T||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(a);try{O(a)}catch{try{return O.call(null,a)}catch{return O.call(this,a)}}}(t)}}function E(t,i){this.fun=t,this.array=i}function o(){}I.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)i[a-1]=arguments[a];p.push(new E(t,i)),p.length!==1||A||h(S)},E.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=o,I.addListener=o,I.once=o,I.off=o,I.removeListener=o,I.removeAllListeners=o,I.emit=o,I.prependListener=o,I.prependOnceListener=o,I.listeners=function(t){return[]},I.binding=function(t){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(t){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Pe[118],Ae([1,0,11,6]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(C){const k=C;return k?typeof k.read=="function":!1}e.isReadable=I;function M(C){const k=C;return k?[k.on,k.pause,k.resume,k.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=M;function T(C){const k=C;return k?M(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.isReadableBufferedStream=T;function h(C,k){return new y(C,k)}e.newWriteableStream=h;class y{constructor(k,r){this.reducer=k,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(k){if(!this.state.destroyed){if(this.state.flowing)this.emitData(k);else if(this.buffer.data.push(k),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(k){this.state.destroyed||(this.state.flowing?this.emitError(k):this.buffer.error.push(k))}end(k){this.state.destroyed||(typeof k<"u"&&this.write(k),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(k){this.listeners.data.slice(0).forEach(r=>r(k))}emitError(k){this.listeners.error.length===0?(0,w.onUnexpectedError)(k):this.listeners.error.slice(0).forEach(r=>r(k))}emitEnd(){this.listeners.end.slice(0).forEach(k=>k())}on(k,r){if(!this.state.destroyed)switch(k){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(k,r){if(this.state.destroyed)return;let d;switch(k){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const n=d.indexOf(r);n>=0&&d.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const k=this.reducer(this.buffer.data);this.emitData(k),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const k of this.buffer.error)this.emitError(k);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(C,k){const r=[];let d;for(;(d=C.read())!==null;)r.push(d);return k(r)}e.consumeReadable=p;function A(C,k,r){const d=[];let n;for(;(n=C.read())!==null&&d.length<r;)d.push(n);return n===null&&d.length>0?k(d):{read:()=>{if(d.length>0)return d.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return C.read()}}}e.peekReadable=A;function _(C,k){return new Promise((r,d)=>{const n=[];c(C,{onData:s=>{k&&n.push(s)},onError:s=>{k?d(s):r(void 0)},onEnd:()=>{r(k?k(n):void 0)}})})}e.consumeStream=_;function c(C,k){let r=!1;return C.on("error",d=>{r||k.onError(d)}),C.on("end",()=>{r||k.onEnd()}),C.on("data",d=>{r||k.onData(d)}),(0,O.toDisposable)(()=>r=!0)}e.listenStream=c;function S(C,k){return new Promise((r,d)=>{const n=new O.DisposableStore,s=[],v=m=>{if(s.push(m),s.length>k)return n.dispose(),C.pause(),r({stream:C,buffer:s,ended:!1})},D=m=>d(m),u=()=>r({stream:C,buffer:s,ended:!0});n.add((0,O.toDisposable)(()=>C.removeListener("error",D))),C.on("error",D),n.add((0,O.toDisposable)(()=>C.removeListener("end",u))),C.on("end",u),n.add((0,O.toDisposable)(()=>C.removeListener("data",v))),C.on("data",v)})}e.peekStream=S;function E(C,k){const r=h(k);return r.end(C),r}e.toStream=E;function o(){const C=h(()=>{throw new Error("not supported")});return C.end(),C}e.emptyStream=o;function t(C){let k=!1;return{read:()=>k?null:(k=!0,C)}}e.toReadable=t;function i(C,k,r){const d=h(r);return c(C,{onData:n=>d.write(k.data(n)),onError:n=>d.error(k.error?k.error(n):n),onEnd:()=>d.end()}),d}e.transform=i;function a(C,k,r){let d=!1;return{read:()=>{const n=k.read();return d?n:(d=!0,n!==null?r([C,n]):C)}}}e.prefixedReadable=a;function g(C,k,r){let d=!1;const n=h(r);return c(k,{onData:s=>d?n.write(s):(d=!0,n.write(r([C,s]))),onError:s=>n.error(s),onEnd:()=>{d||(d=!0,n.write(C)),n.end()}}),n}e.prefixedStream=g}),define(Pe[25],Ae([1,0,67,118]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const I=typeof Buffer<"u",M=new w.Lazy(()=>new Uint8Array(256));let T,h;class y{static alloc(f){return I?new y(Buffer.allocUnsafe(f)):new y(new Uint8Array(f))}static wrap(f){return I&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new y(f)}static fromString(f,P){return!(P?.dontUseNodeBuffer||!1)&&I?new y(Buffer.from(f)):(T||(T=new TextEncoder),new y(T.encode(f)))}static fromByteArray(f){const P=y.alloc(f.length);for(let z=0,$=f.length;z<$;z++)P.buffer[z]=f[z];return P}static concat(f,P){if(typeof P>"u"){P=0;for(let H=0,x=f.length;H<x;H++)P+=f[H].byteLength}const z=y.alloc(P);let $=0;for(let H=0,x=f.length;H<x;H++){const U=f[H];z.set(U,$),$+=U.byteLength}return z}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=y.alloc(this.byteLength);return f.set(this),f}toString(){return I?this.buffer.toString():(h||(h=new TextDecoder),h.decode(this.buffer))}slice(f,P){return new y(this.buffer.subarray(f,P))}set(f,P){if(f instanceof y)this.buffer.set(f.buffer,P);else if(f instanceof Uint8Array)this.buffer.set(f,P);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),P);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return c(this.buffer,f)}writeUInt32BE(f,P){S(this.buffer,f,P)}readUInt32LE(f){return E(this.buffer,f)}writeUInt32LE(f,P){o(this.buffer,f,P)}readUInt8(f){return t(this.buffer,f)}writeUInt8(f,P){i(this.buffer,f,P)}indexOf(f,P=0){return p(this.buffer,f instanceof y?f.buffer:f,P)}}e.VSBuffer=y;function p(l,f,P=0){const z=f.byteLength,$=l.byteLength;if(z===0)return 0;if(z===1)return l.indexOf(f[0]);if(z>$-P)return-1;const H=M.value;H.fill(f.length);for(let ae=0;ae<f.length;ae++)H[f[ae]]=f.length-ae-1;let x=P+f.length-1,U=x,N=-1;for(;x<$;)if(l[x]===f[U]){if(U===0){N=x;break}x--,U--}else x+=Math.max(f.length-U,H[l[x]]),U=f.length-1;return N}e.binaryIndexOf=p;function A(l,f){return l[f+0]<<0>>>0|l[f+1]<<8>>>0}e.readUInt16LE=A;function _(l,f,P){l[P+0]=f&255,f=f>>>8,l[P+1]=f&255}e.writeUInt16LE=_;function c(l,f){return l[f]*2**24+l[f+1]*2**16+l[f+2]*2**8+l[f+3]}e.readUInt32BE=c;function S(l,f,P){l[P+3]=f,f=f>>>8,l[P+2]=f,f=f>>>8,l[P+1]=f,f=f>>>8,l[P]=f}e.writeUInt32BE=S;function E(l,f){return l[f+0]<<0>>>0|l[f+1]<<8>>>0|l[f+2]<<16>>>0|l[f+3]<<24>>>0}e.readUInt32LE=E;function o(l,f,P){l[P+0]=f&255,f=f>>>8,l[P+1]=f&255,f=f>>>8,l[P+2]=f&255,f=f>>>8,l[P+3]=f&255}e.writeUInt32LE=o;function t(l,f){return l[f]}e.readUInt8=t;function i(l,f,P){l[P]=f}e.writeUInt8=i;function a(l){return O.consumeReadable(l,f=>y.concat(f))}e.readableToBuffer=a;function g(l){return O.toReadable(l)}e.bufferToReadable=g;function C(l){return O.consumeStream(l,f=>y.concat(f))}e.streamToBuffer=C;async function k(l){return l.ended?y.concat(l.buffer):y.concat([...l.buffer,await C(l.stream)])}e.bufferedStreamToBuffer=k;function r(l){return O.toStream(l,f=>y.concat(f))}e.bufferToStream=r;function d(l){return O.transform(l,{data:f=>typeof f=="string"?y.fromString(f):y.wrap(f)},f=>y.concat(f))}e.streamToBufferReadableStream=d;function n(l){return O.newWriteableStream(f=>y.concat(f),l)}e.newWriteableBufferStream=n;function s(l,f){return O.prefixedReadable(l,f,P=>y.concat(P))}e.prefixedBufferReadable=s;function v(l,f){return O.prefixedStream(l,f,P=>y.concat(P))}e.prefixedBufferStream=v;function D(l){let f=0,P=0,z=0;const $=new Uint8Array(Math.floor(l.length/4*3)),H=U=>{switch(P){case 3:$[z++]=f|U,P=0;break;case 2:$[z++]=f|U>>>2,f=U<<6,P=3;break;case 1:$[z++]=f|U>>>4,f=U<<4,P=2;break;default:f=U<<2,P=1}};for(let U=0;U<l.length;U++){const N=l.charCodeAt(U);if(N>=65&&N<=90)H(N-65);else if(N>=97&&N<=122)H(N-97+26);else if(N>=48&&N<=57)H(N-48+52);else if(N===43||N===45)H(62);else if(N===47||N===95)H(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${l[U]}`)}}const x=z;for(;P>0;)H(0);return y.wrap($).slice(0,x)}e.decodeBase64=D;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:l},f=!0,P=!1){const z=P?m:u;let $="";const H=l.byteLength%3;let x=0;for(;x<l.byteLength-H;x+=3){const U=l[x+0],N=l[x+1],ae=l[x+2];$+=z[U>>>2],$+=z[(U<<4|N>>>4)&63],$+=z[(N<<2|ae>>>6)&63],$+=z[ae&63]}if(H===1){const U=l[x+0];$+=z[U>>>2],$+=z[U<<4&63],f&&($+="==")}else if(H===2){const U=l[x+0],N=l[x+1];$+=z[U>>>2],$+=z[(U<<4|N>>>4)&63],$+=z[N<<2&63],f&&($+="=")}return $}e.encodeBase64=b}),define(Pe[119],Ae([1,0,28,15]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...ee){return function(ie,de){for(let R=0,W=ee.length;R<W;R++){const V=ee[R](ie,de);if(V)return V}return null}}e.or=I,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(ee,ie,de){if(!de||de.length<ie.length)return null;let R;return ee?R=O.startsWithIgnoreCase(de,ie):R=de.indexOf(ie)===0,R?ie.length>0?[{start:0,end:ie.length}]:[]:null}function T(ee,ie){const de=ie.toLowerCase().indexOf(ee.toLowerCase());return de===-1?null:[{start:de,end:de+ee.length}]}e.matchesContiguousSubString=T;function h(ee,ie){return y(ee.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=h;function y(ee,ie,de,R){if(de===ee.length)return[];if(R===ie.length)return null;if(ee[de]===ie[R]){let W=null;return(W=y(ee,ie,de+1,R+1))?i({start:R,end:R+1},W):null}return y(ee,ie,de,R+1)}function p(ee){return 97<=ee&&ee<=122}function A(ee){return 65<=ee&&ee<=90}e.isUpper=A;function _(ee){return 48<=ee&&ee<=57}function c(ee){return ee===32||ee===9||ee===10||ee===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>S.add(ee.charCodeAt(0)));function E(ee){return c(ee)||S.has(ee)}function o(ee,ie){return ee===ie||E(ee)&&E(ie)}function t(ee){return p(ee)||A(ee)||_(ee)}function i(ee,ie){return ie.length===0?ie=[ee]:ee.end===ie[0].start?ie[0].start=ee.start:ie.unshift(ee),ie}function a(ee,ie){for(let de=ie;de<ee.length;de++){const R=ee.charCodeAt(de);if(A(R)||_(R)||de>0&&!t(ee.charCodeAt(de-1)))return de}return ee.length}function g(ee,ie,de,R){if(de===ee.length)return[];if(R===ie.length)return null;if(ee[de]!==ie[R].toLowerCase())return null;{let W=null,V=R+1;for(W=g(ee,ie,de+1,R+1);!W&&(V=a(ie,V))<ie.length;)W=g(ee,ie,de+1,V),V++;return W===null?null:i({start:R,end:R+1},W)}}function C(ee){let ie=0,de=0,R=0,W=0,V=0;for(let ve=0;ve<ee.length;ve++)V=ee.charCodeAt(ve),A(V)&&ie++,p(V)&&de++,t(V)&&R++,_(V)&&W++;const q=ie/ee.length,oe=de/ee.length,j=R/ee.length,ce=W/ee.length;return{upperPercent:q,lowerPercent:oe,alphaPercent:j,numericPercent:ce}}function k(ee){const{upperPercent:ie,lowerPercent:de}=ee;return de===0&&ie>.6}function r(ee){const{upperPercent:ie,lowerPercent:de,alphaPercent:R,numericPercent:W}=ee;return de>.2&&ie<.8&&R>.6&&W<.2}function d(ee){let ie=0,de=0,R=0,W=0;for(let V=0;V<ee.length;V++)R=ee.charCodeAt(V),A(R)&&ie++,p(R)&&de++,c(R)&&W++;return(ie===0||de===0)&&W===0?ee.length<=30:ie<=5}function n(ee,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!d(ee)||ie.length>60)return null;const de=C(ie);if(!r(de)){if(!k(de))return null;ie=ie.toLowerCase()}let R=null,W=0;for(ee=ee.toLowerCase();W<ie.length&&(R=g(ee,ie,0,W))===null;)W=a(ie,W+1);return R}e.matchesCamelCase=n;function s(ee,ie,de=!1){if(!ie||ie.length===0)return null;let R=null,W=0;for(ee=ee.toLowerCase(),ie=ie.toLowerCase();W<ie.length&&(R=v(ee,ie,0,W,de))===null;)W=D(ie,W+1);return R}e.matchesWords=s;function v(ee,ie,de,R,W){if(de===ee.length)return[];if(R===ie.length)return null;if(o(ee.charCodeAt(de),ie.charCodeAt(R))){let V=null,q=R+1;if(V=v(ee,ie,de+1,R+1,W),!W)for(;!V&&(q=D(ie,q))<ie.length;)V=v(ee,ie,de+1,q,W),q++;return V?ee.charCodeAt(de)!==ie.charCodeAt(R)?V:i({start:R,end:R+1},V):null}else return null}function D(ee,ie){for(let de=ie;de<ee.length;de++)if(E(ee.charCodeAt(de))||de>0&&E(ee.charCodeAt(de-1)))return de;return ee.length}const u=I(e.matchesPrefix,n,T),m=I(e.matchesPrefix,n,h),b=new w.LRUCache(1e4);function l(ee,ie,de=!1){if(typeof ee!="string"||typeof ie!="string")return null;let R=b.get(ee);R||(R=new RegExp(O.convertSimple2RegExpPattern(ee),"i"),b.set(ee,R));const W=R.exec(ie);return W?[{start:W.index,end:W.index+W[0].length}]:de?m(ee,ie):u(ee,ie)}e.matchesFuzzy=l;function f(ee,ie){const de=Se(ee,ee.toLowerCase(),0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return de?z(de):null}e.matchesFuzzy2=f;function P(ee,ie,de,R,W,V){const q=Math.min(13,ee.length);for(;de<q;de++){const oe=Se(ee,ie,de,R,W,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,V]}e.anyScore=P;function z(ee){if(typeof ee>"u")return[];const ie=[],de=ee[1];for(let R=ee.length-1;R>1;R--){const W=ee[R]+de,V=ie[ie.length-1];V&&V.end===W?V.end=W+1:ie.push({start:W,end:W+1})}return ie}e.createMatches=z;const $=128;function H(){const ee=[],ie=[];for(let de=0;de<=$;de++)ie[de]=0;for(let de=0;de<=$;de++)ee.push(ie.slice(0));return ee}function x(ee){const ie=[];for(let de=0;de<=ee;de++)ie[de]=0;return ie}const U=x(2*$),N=x(2*$),ae=H(),Y=H(),Ee=H(),ye=!1;function Re(ee,ie,de,R,W){function V(oe,j,ce=" "){for(;oe.length<j;)oe=ce+oe;return oe}let q=` |   |${R.split("").map(oe=>V(oe,3)).join("|")}
`;for(let oe=0;oe<=de;oe++)oe===0?q+=" |":q+=`${ie[oe-1]}|`,q+=ee[oe].slice(0,W+1).map(j=>V(j.toString(),3)).join("|")+`
`;return q}function K(ee,ie,de,R){ee=ee.substr(ie),de=de.substr(R),console.log(Re(Y,ee,ee.length,de,de.length)),console.log(Re(Ee,ee,ee.length,de,de.length)),console.log(Re(ae,ee,ee.length,de,de.length))}function Q(ee,ie){if(ie<0||ie>=ee.length)return!1;const de=ee.codePointAt(ie);switch(de){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!O.isEmojiImprecise(de)}}function ue(ee,ie){if(ie<0||ie>=ee.length)return!1;switch(ee.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function ne(ee,ie,de){return ie[ee]!==de[ee]}function he(ee,ie,de,R,W,V,q=!1){for(;ie<de&&W<V;)ee[ie]===R[W]&&(q&&(U[ie]=W),ie+=1),W+=1;return ie===de}e.isPatternInWord=he;var le;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(le||(le={}));var F;(function(ee){ee.Default=[-100,0];function ie(de){return!de||de.length===2&&de[0]===-100&&de[1]===0}ee.isDefault=ie})(F||(e.FuzzyScore=F={}));class J{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ie,de){this.firstMatchCanBeWeak=ie,this.boostFullMatch=de}}e.FuzzyScoreOptions=J;function Se(ee,ie,de,R,W,V,q=J.default){const oe=ee.length>$?$:ee.length,j=R.length>$?$:R.length;if(de>=oe||V>=j||oe-de>j-V||!he(ie,de,oe,W,V,j,!0))return;ke(oe,j,de,V,ie,W);let ce=1,ve=1,Ue=de,$e=V;const Qe=[!1];for(ce=1,Ue=de;Ue<oe;ce++,Ue++){const Ze=U[Ue],tt=N[Ue],Ne=Ue+1<oe?N[Ue+1]:j;for(ve=Ze-V+1,$e=Ze;$e<Ne;ve++,$e++){let nt=Number.MIN_SAFE_INTEGER,Z=!1;$e<=tt&&(nt=Ce(ee,ie,Ue,de,R,W,$e,j,V,ae[ce-1][ve-1]===0,Qe));let X=0;nt!==Number.MAX_SAFE_INTEGER&&(Z=!0,X=nt+Y[ce-1][ve-1]);const ge=$e>Ze,Be=ge?Y[ce][ve-1]+(ae[ce][ve-1]>0?-5:0):0,Me=$e>Ze+1&&ae[ce][ve-1]>0,Ge=Me?Y[ce][ve-2]+(ae[ce][ve-2]>0?-5:0):0;if(Me&&(!ge||Ge>=Be)&&(!Z||Ge>=X))Y[ce][ve]=Ge,Ee[ce][ve]=3,ae[ce][ve]=0;else if(ge&&(!Z||Be>=X))Y[ce][ve]=Be,Ee[ce][ve]=2,ae[ce][ve]=0;else if(Z)Y[ce][ve]=X,Ee[ce][ve]=1,ae[ce][ve]=ae[ce-1][ve-1]+1;else throw new Error("not possible")}}if(ye&&K(ee,de,R,V),!Qe[0]&&!q.firstMatchCanBeWeak)return;ce--,ve--;const qe=[Y[ce][ve],V];let Ye=0,Ke=0;for(;ce>=1;){let Ze=ve;do{const tt=Ee[ce][Ze];if(tt===3)Ze=Ze-2;else if(tt===2)Ze=Ze-1;else break}while(Ze>=1);Ye>1&&ie[de+ce-1]===W[V+ve-1]&&!ne(Ze+V-1,R,W)&&Ye+1>ae[ce][Ze]&&(Ze=ve),Ze===ve?Ye++:Ye=1,Ke||(Ke=Ze),ce--,ve=Ze-1,qe.push(ve)}j===oe&&q.boostFullMatch&&(qe[0]+=2);const ct=Ke-oe;return qe[0]-=ct,qe}e.fuzzyScore=Se;function ke(ee,ie,de,R,W,V){let q=ee-1,oe=ie-1;for(;q>=de&&oe>=R;)W[q]===V[oe]&&(N[q]=oe,q--),oe--}function Ce(ee,ie,de,R,W,V,q,oe,j,ce,ve){if(ie[de]!==V[q])return Number.MIN_SAFE_INTEGER;let Ue=1,$e=!1;return q===de-R?Ue=ee[de]===W[q]?7:5:ne(q,W,V)&&(q===0||!ne(q-1,W,V))?(Ue=ee[de]===W[q]?7:5,$e=!0):Q(V,q)&&(q===0||!Q(V,q-1))?Ue=5:(Q(V,q-1)||ue(V,q-1))&&(Ue=5,$e=!0),Ue>1&&de===R&&(ve[0]=!0),$e||($e=ne(q,W,V)||Q(V,q-1)||ue(V,q-1)),de===R?q>j&&(Ue-=$e?3:5):ce?Ue+=$e?2:0:Ue+=$e?0:1,q+1===oe&&(Ue-=$e?3:5),Ue}function _e(ee,ie,de,R,W,V,q){return se(ee,ie,de,R,W,V,!0,q)}e.fuzzyScoreGracefulAggressive=_e;function Ie(ee,ie,de,R,W,V,q){return se(ee,ie,de,R,W,V,!1,q)}e.fuzzyScoreGraceful=Ie;function se(ee,ie,de,R,W,V,q,oe){let j=Se(ee,ie,de,R,W,V,oe);if(j&&!q)return j;if(ee.length>=3){const ce=Math.min(7,ee.length-1);for(let ve=de+1;ve<ce;ve++){const Ue=fe(ee,ve);if(Ue){const $e=Se(Ue,Ue.toLowerCase(),de,R,W,V,oe);$e&&($e[0]-=3,(!j||$e[0]>j[0])&&(j=$e))}}}return j}function fe(ee,ie){if(ie+1>=ee.length)return;const de=ee[ie],R=ee[ie+1];if(de!==R)return ee.slice(0,ie)+R+de+ee.slice(ie+2)}}),define(Pe[29],Ae([1,0,15]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(O||(O={})),function(I){const M="error",T="warning",h="warn",y="info",p="ignore";function A(c){return c?w.equalsIgnoreCase(M,c)?I.Error:w.equalsIgnoreCase(T,c)||w.equalsIgnoreCase(h,c)?I.Warning:w.equalsIgnoreCase(y,c)?I.Info:I.Ignore:I.Ignore}I.fromValue=A;function _(c){switch(c){case I.Error:return M;case I.Warning:return T;case I.Info:return y;default:return p}}I.toString=_}(O||(O={})),e.default=O}),define(Pe[120],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Pe[48],Ae([1,0,18,15]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class I{constructor(){this._value="",this._pos=0}reset(S){return this._value=S,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(S){const E=S.charCodeAt(0),o=this._value.charCodeAt(this._pos);return E-o}value(){return this._value[this._pos]}}e.StringIterator=I;class M{constructor(S=!0){this._caseSensitive=S}reset(S){return this._value=S,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let S=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(S)this._from++;else break;else S=!1;return this}cmp(S){return this._caseSensitive?(0,O.compareSubstring)(S,this._value,0,S.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(S,this._value,0,S.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=M;class T{constructor(S=!0,E=!0){this._splitOnBackslash=S,this._caseSensitive=E}reset(S){this._from=0,this._to=0,this._value=S,this._valueLen=S.length;for(let E=S.length-1;E>=0;E--,this._valueLen--){const o=this._value.charCodeAt(E);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let S=!0;for(;this._to<this._valueLen;this._to++){const E=this._value.charCodeAt(this._to);if(E===47||this._splitOnBackslash&&E===92)if(S)this._from++;else break;else S=!1}return this}cmp(S){return this._caseSensitive?(0,O.compareSubstring)(S,this._value,0,S.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(S,this._value,0,S.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var h;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(h||(h={}));class y{constructor(S,E){this._ignorePathCasing=S,this._ignoreQueryAndFragment=E,this._states=[],this._stateIdx=0}reset(S){return this._value=S,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(S)),this._pathIterator.reset(S.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(S)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(S){if(this._states[this._stateIdx]===1)return(0,O.compareIgnoreCase)(S,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,O.compareIgnoreCase)(S,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(S);if(this._states[this._stateIdx]===4)return(0,O.compare)(S,this._value.query);if(this._states[this._stateIdx]===5)return(0,O.compare)(S,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=y;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(A||(A={}));class _{static forUris(S=()=>!1,E=()=>!1){return new _(new y(S,E))}static forPaths(S=!1){return new _(new T(void 0,!S))}static forStrings(){return new _(new I)}static forConfigKeys(){return new _(new M)}constructor(S){this._iter=S}clear(){this._root=void 0}fill(S,E){if(E){const o=E.slice(0);(0,w.shuffle)(o);for(const t of o)this.set(t,S)}else{const o=S.slice(0);(0,w.shuffle)(o);for(const t of o)this.set(t[0],t[1])}}set(S,E){const o=this._iter.reset(S);let t;this._root||(this._root=new p,this._root.segment=o.value());const i=[];for(t=this._root;;){const g=o.cmp(t.segment);if(g>0)t.left||(t.left=new p,t.left.segment=o.value()),i.push([-1,t]),t=t.left;else if(g<0)t.right||(t.right=new p,t.right.segment=o.value()),i.push([1,t]),t=t.right;else if(o.hasNext())o.next(),t.mid||(t.mid=new p,t.mid.segment=o.value()),i.push([0,t]),t=t.mid;else break}const a=t.value;t.value=E,t.key=S;for(let g=i.length-1;g>=0;g--){const C=i[g][1];C.updateHeight();const k=C.balanceFactor();if(k<-1||k>1){const r=i[g][0],d=i[g+1][0];if(r===1&&d===1)i[g][1]=C.rotateLeft();else if(r===-1&&d===-1)i[g][1]=C.rotateRight();else if(r===1&&d===-1)C.right=i[g+1][1]=i[g+1][1].rotateRight(),i[g][1]=C.rotateLeft();else if(r===-1&&d===1)C.left=i[g+1][1]=i[g+1][1].rotateLeft(),i[g][1]=C.rotateRight();else throw new Error;if(g>0)switch(i[g-1][0]){case-1:i[g-1][1].left=i[g][1];break;case 1:i[g-1][1].right=i[g][1];break;case 0:i[g-1][1].mid=i[g][1];break}else this._root=i[0][1]}}return a}get(S){return this._getNode(S)?.value}_getNode(S){const E=this._iter.reset(S);let o=this._root;for(;o;){const t=E.cmp(o.segment);if(t>0)o=o.left;else if(t<0)o=o.right;else if(E.hasNext())E.next(),o=o.mid;else break}return o}has(S){const E=this._getNode(S);return!(E?.value===void 0&&E?.mid===void 0)}delete(S){return this._delete(S,!1)}deleteSuperstr(S){return this._delete(S,!0)}_delete(S,E){const o=this._iter.reset(S),t=[];let i=this._root;for(;i;){const a=o.cmp(i.segment);if(a>0)t.push([-1,i]),i=i.left;else if(a<0)t.push([1,i]),i=i.right;else if(o.hasNext())o.next(),t.push([0,i]),i=i.mid;else break}if(i){if(E?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const a=this._min(i.right);if(a.key){const{key:g,value:C,segment:k}=a;this._delete(a.key,!1),i.key=g,i.value=C,i.segment=k}}else{const a=i.left??i.right;if(t.length>0){const[g,C]=t[t.length-1];switch(g){case-1:C.left=a;break;case 0:C.mid=a;break;case 1:C.right=a;break}}else this._root=a}for(let a=t.length-1;a>=0;a--){const g=t[a][1];g.updateHeight();const C=g.balanceFactor();if(C>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),t[a][1]=g.rotateLeft()):C<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),t[a][1]=g.rotateRight()),a>0)switch(t[a-1][0]){case-1:t[a-1][1].left=t[a][1];break;case 1:t[a-1][1].right=t[a][1];break;case 0:t[a-1][1].mid=t[a][1];break}else this._root=t[0][1]}}}_min(S){for(;S.left;)S=S.left;return S}findSubstr(S){const E=this._iter.reset(S);let o=this._root,t;for(;o;){const i=E.cmp(o.segment);if(i>0)o=o.left;else if(i<0)o=o.right;else if(E.hasNext())E.next(),t=o.value||t,o=o.mid;else break}return o&&o.value||t}findSuperstr(S){return this._findSuperstrOrElement(S,!1)}_findSuperstrOrElement(S,E){const o=this._iter.reset(S);let t=this._root;for(;t;){const i=o.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(o.hasNext())o.next(),t=t.mid;else return t.mid?this._entries(t.mid):E?t.value:void 0}}hasElementOrSubtree(S){return this._findSuperstrOrElement(S,!0)!==void 0}forEach(S){for(const[E,o]of this)S(o,E)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(S){const E=[];return this._dfsEntries(S,E),E[Symbol.iterator]()}_dfsEntries(S,E){S&&(S.left&&this._dfsEntries(S.left,E),S.value&&E.push([S.key,S.value]),S.mid&&this._dfsEntries(S.mid,E),S.right&&this._dfsEntries(S.right,E))}_isBalanced(){const S=E=>{if(!E)return!0;const o=E.balanceFactor();return o<-1||o>1?!1:S(E.left)&&S(E.right)};return S(this._root)}}e.TernarySearchTree=_}),define(Pe[40],Ae([1,0,89]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var O;(function(T){function h(y){return y&&typeof y=="object"&&typeof y.id=="string"}T.isThemeColor=h})(O||(e.ThemeColor=O={}));function I(T){return{id:T}}e.themeColorFromId=I;var M;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const h=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function y(a){const g=h.exec(a.id);if(!g)return y(w.Codicon.error);const[,C,k]=g,r=["codicon","codicon-"+C];return k&&r.push("codicon-modifier-"+k.substring(1)),r}T.asClassNameArray=y;function p(a){return y(a).join(" ")}T.asClassName=p;function A(a){return"."+y(a).join(".")}T.asCSSSelector=A;function _(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||O.isThemeColor(a.color))}T.isThemeIcon=_;const c=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function S(a){const g=c.exec(a);if(!g)return;const[,C]=g;return{id:C}}T.fromString=S;function E(a){return{id:a}}T.fromId=E;function o(a,g){let C=a.id;const k=C.lastIndexOf("~");return k!==-1&&(C=C.substring(0,k)),g&&(C=`${C}~${g}`),{id:C}}T.modify=o;function t(a){const g=a.id.lastIndexOf("~");if(g!==-1)return a.id.substring(g+1)}T.getModifier=t;function i(a,g){return a.id===g.id&&a.color?.id===g.color?.id}T.isEqual=i})(M||(e.ThemeIcon=M={}))}),define(Pe[121],Ae([1,0,119,15,40]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",T=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),h=new RegExp(`(\\\\)?${T.source}`,"g");function y(i){return i.replace(h,(a,g)=>g?a:`\\${a}`)}e.escapeIcons=y;const p=new RegExp(`\\\\${T.source}`,"g");function A(i){return i.replace(p,a=>`\\${a}`)}e.markdownEscapeEscapedIcons=A;const _=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function c(i){return i.indexOf(M)===-1?i:i.replace(_,(a,g,C,k)=>C?a:g||k||"")}e.stripIcons=c;function S(i){return i?i.replace(/\$\((.*?)\)/g,(a,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=S;const E=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function o(i){E.lastIndex=0;let a="";const g=[];let C=0;for(;;){const k=E.lastIndex,r=E.exec(i),d=i.substring(k,r?.index);if(d.length>0){a+=d;for(let n=0;n<d.length;n++)g.push(C)}if(!r)break;C+=r[0].length}return{text:a,iconOffsets:g}}e.parseLabelWithIcons=o;function t(i,a,g=!1){const{text:C,iconOffsets:k}=a;if(!k||k.length===0)return(0,w.matchesFuzzy)(i,C,g);const r=(0,O.ltrim)(C," "),d=C.length-r.length,n=(0,w.matchesFuzzy)(i,r,g);if(n)for(const s of n){const v=k[s.start+d]+d;s.start+=v,s.end+=v}return n}e.matchesFuzzyIconAware=t}),define(Pe[36],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(I){return w.test(I)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(h){for(let y=0;y<h.length;y++)h[y]=Math.floor(Math.random()*256);return h};const M=new Uint8Array(16),T=[];for(let h=0;h<256;h++)T.push(h.toString(16).padStart(2,"0"));return function(){I(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let y=0,p="";return p+=T[M[y++]],p+=T[M[y++]],p+=T[M[y++]],p+=T[M[y++]],p+="-",p+=T[M[y++]],p+=T[M[y++]],p+="-",p+=T[M[y++]],p+=T[M[y++]],p+="-",p+=T[M[y++]],p+=T[M[y++]],p+="-",p+=T[M[y++]],p+=T[M[y++]],p+=T[M[y++]],p+=T[M[y++]],p+=T[M[y++]],p+=T[M[y++]],p}}()}),define(Pe[122],Ae([1,0,18,68,36]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function M(_){return{asString:async()=>_,asFile:()=>{},value:typeof _=="string"?_:void 0}}e.createStringDataTransferItem=M;function T(_,c,S){const E={id:(0,I.generateUuid)(),name:_,uri:c,data:S};return{asString:async()=>"",asFile:()=>E,value:void 0}}e.createFileDataTransferItem=T;class h{constructor(){this._entries=new Map}get size(){let c=0;for(const S of this._entries)c++;return c}has(c){return this._entries.has(this.toKey(c))}matches(c){const S=[...this._entries.keys()];return O.Iterable.some(this,([E,o])=>o.asFile())&&S.push("files"),A(y(c),S)}get(c){return this._entries.get(this.toKey(c))?.[0]}append(c,S){const E=this._entries.get(c);E?E.push(S):this._entries.set(this.toKey(c),[S])}replace(c,S){this._entries.set(this.toKey(c),[S])}delete(c){this._entries.delete(this.toKey(c))}*[Symbol.iterator](){for(const[c,S]of this._entries)for(const E of S)yield[c,E]}toKey(c){return y(c)}}e.VSDataTransfer=h;function y(_){return _.toLowerCase()}function p(_,c){return A(y(_),c.map(y))}e.matchesMimeType=p;function A(_,c){if(_==="*/*")return c.length>0;if(c.includes(_))return!0;const S=_.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[E,o,t]=S;return t==="*"?c.some(i=>i.startsWith(o+"/")):!1}e.UriList=Object.freeze({create:_=>(0,w.distinct)(_.map(c=>c.toString())).join(`\r
`),split:_=>_.split(`\r
`),parse:_=>e.UriList.split(_).filter(c=>!c.startsWith("#"))})}),define(Pe[123],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[124],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var w;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(w||(e.IndentAction=w={}));class O{constructor(h){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=h.open,this.close=h.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(h.notIn))for(let y=0,p=h.notIn.length;y<p;y++)switch(h.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(h){switch(h){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(h,y){if(h.getTokenCount()===0)return!0;const p=h.findTokenIndexAtOffset(y-2),A=h.getStandardTokenType(p);return this.isOK(A)}_findNeutralCharacterInRange(h,y){for(let p=h;p<=y;p++){const A=String.fromCharCode(p);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=O;class I{constructor(h){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of h)M(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),M(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),M(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),M(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&M(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=I;function M(T,h,y){T.has(h)?T.get(h).push(y):T.set(h,[y])}}),define(Pe[125],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class w{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(M){if(M&&this._dragOperations.has(M)){const T=this._dragOperations.get(M);return this._dragOperations.delete(M),T}}addDragOperationTransfer(M,T){this._dragOperations.set(M,T)}}e.TreeViewsDnDService=w;class O{constructor(M){this.identifier=M}}e.DraggedTreeItemsIdentifier=O}),define(Pe[126],Ae([9,10]),function(pe,e){return pe.create("vs/base/common/actions",e)}),define(Pe[127],Ae([1,0,5,6,126]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class M extends O.Disposable{constructor(c,S="",E="",o=!0,t){super(),this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=c,this._label=S,this._cssClass=E,this._enabled=o,this._actionCallback=t}get id(){return this._id}get label(){return this._label}set label(c){this._setLabel(c)}_setLabel(c){this._label!==c&&(this._label=c,this._onDidChange.fire({label:c}))}get tooltip(){return this._tooltip||""}set tooltip(c){this._setTooltip(c)}_setTooltip(c){this._tooltip!==c&&(this._tooltip=c,this._onDidChange.fire({tooltip:c}))}get class(){return this._cssClass}set class(c){this._setClass(c)}_setClass(c){this._cssClass!==c&&(this._cssClass=c,this._onDidChange.fire({class:c}))}get enabled(){return this._enabled}set enabled(c){this._setEnabled(c)}_setEnabled(c){this._enabled!==c&&(this._enabled=c,this._onDidChange.fire({enabled:c}))}get checked(){return this._checked}set checked(c){this._setChecked(c)}_setChecked(c){this._checked!==c&&(this._checked=c,this._onDidChange.fire({checked:c}))}async run(c,S){this._actionCallback&&await this._actionCallback(c)}}e.Action=M;class T extends O.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new w.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new w.Emitter),this.onDidRun=this._onDidRun.event}async run(c,S){if(!c.enabled)return;this._onWillRun.fire({action:c});let E;try{await this.runAction(c,S)}catch(o){E=o}this._onDidRun.fire({action:c,error:E})}async runAction(c,S){await c.run(S)}}e.ActionRunner=T;class h{constructor(){this.id=h.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let S=[];for(const E of c)E.length&&(S.length?S=[...S,new h,...E]:S=E);return S}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=h;class y{get actions(){return this._actions}constructor(c,S,E,o){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=S,this.class=o,this._actions=E}async run(){}}e.SubmenuAction=y;class p extends M{static{this.ID="vs.actions.empty"}constructor(){super(p.ID,I.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=p;function A(_){return{id:_.id,label:_.label,class:void 0,enabled:_.enabled??!0,checked:_.checked??!1,run:async()=>_.run(),tooltip:_.label}}e.toAction=A}),define(Pe[128],Ae([9,10]),function(pe,e){return pe.create("vs/base/common/date",e)}),define(Pe[129],Ae([1,0,128]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,I=O*60,M=I*24,T=M*7,h=M*30,y=M*365;function p(_,c,S,E){typeof _!="number"&&(_=_.getTime());const o=Math.round((new Date().getTime()-_)/1e3);if(o<-30)return(0,w.localize)(0,null,p(new Date().getTime()+o*1e3,!1));if(!E&&o<30)return(0,w.localize)(1,null);let t;return o<O?(t=o,c?t===1?S?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):S?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t):t===1?S?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):S?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):o<I?(t=Math.floor(o/O),c?t===1?S?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):S?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t):t===1?S?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):S?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):o<M?(t=Math.floor(o/I),c?t===1?S?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):S?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t):t===1?S?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):S?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):o<T?(t=Math.floor(o/M),c?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t)):o<h?(t=Math.floor(o/T),c?t===1?S?(0,w.localize)(30,null,t):(0,w.localize)(31,null,t):S?(0,w.localize)(32,null,t):(0,w.localize)(33,null,t):t===1?S?(0,w.localize)(34,null,t):(0,w.localize)(35,null,t):S?(0,w.localize)(36,null,t):(0,w.localize)(37,null,t)):o<y?(t=Math.floor(o/h),c?t===1?S?(0,w.localize)(38,null,t):(0,w.localize)(39,null,t):S?(0,w.localize)(40,null,t):(0,w.localize)(41,null,t):t===1?S?(0,w.localize)(42,null,t):(0,w.localize)(43,null,t):S?(0,w.localize)(44,null,t):(0,w.localize)(45,null,t)):(t=Math.floor(o/y),c?t===1?S?(0,w.localize)(46,null,t):(0,w.localize)(47,null,t):S?(0,w.localize)(48,null,t):(0,w.localize)(49,null,t):t===1?S?(0,w.localize)(50,null,t):(0,w.localize)(51,null,t):S?(0,w.localize)(52,null,t):(0,w.localize)(53,null,t))}e.fromNow=p;function A(_){return _.getFullYear()+"-"+String(_.getMonth()+1).padStart(2,"0")+"-"+String(_.getDate()).padStart(2,"0")+"T"+String(_.getHours()).padStart(2,"0")+":"+String(_.getMinutes()).padStart(2,"0")+":"+String(_.getSeconds()).padStart(2,"0")+"."+(_.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=A}),define(Pe[130],Ae([9,10]),function(pe,e){return pe.create("vs/base/common/errorMessage",e)}),define(Pe[41],Ae([1,0,18,12,130]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(_,c){return c&&(_.stack||_.stacktrace)?I.localize(0,null,h(_),T(_.stack)||T(_.stacktrace)):h(_)}function T(_){return Array.isArray(_)?_.join(`
`):_}function h(_){return _.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${_.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof _.code=="string"&&typeof _.errno=="number"&&typeof _.syscall=="string"?I.localize(1,null,_.message):_.message||I.localize(2,null)}function y(_=null,c=!1){if(!_)return I.localize(3,null);if(Array.isArray(_)){const S=w.coalesce(_),E=y(S[0],c);return S.length>1?I.localize(4,null,E,S.length):E}if(O.isString(_))return _;if(_.detail){const S=_.detail;if(S.error)return M(S.error,c);if(S.exception)return M(S.exception,c)}return _.stack?M(_,c):_.message?_.message:I.localize(5,null)}e.toErrorMessage=y;function p(_){const c=_;return c instanceof Error&&Array.isArray(c.actions)}e.isErrorWithActions=p;function A(_,c){let S;return typeof _=="string"?S=new Error(_):S=_,S.actions=c,S}e.createErrorWithActions=A}),define(Pe[131],Ae([1,0,67,19]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new w.Lazy(()=>{const m=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:m,collatorIsNumeric:m.resolvedOptions().numeric}}),M=new w.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new w.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function h(m,b,l=!1){const f=m||"",P=b||"",z=I.value.collator.compare(f,P);return I.value.collatorIsNumeric&&z===0&&f!==P?f<P?-1:1:z}e.compareFileNames=h;function y(m,b){const l=M.value.collator;return m=m||"",b=b||"",C(l,m,b)}e.compareFileNamesDefault=y;function p(m,b){const l=M.value.collator;return m=m||"",b=b||"",n(m,b)||C(l,m,b)}e.compareFileNamesUpper=p;function A(m,b){const l=M.value.collator;return m=m||"",b=b||"",d(m,b)||C(l,m,b)}e.compareFileNamesLower=A;function _(m,b){return m=m||"",b=b||"",m===b?0:m<b?-1:1}e.compareFileNamesUnicode=_;function c(m,b){const[l,f]=a(m),[P,z]=a(b);let $=I.value.collator.compare(f,z);if($===0){if(I.value.collatorIsNumeric&&f!==z)return f<z?-1:1;if($=I.value.collator.compare(l,P),I.value.collatorIsNumeric&&$===0&&l!==P)return l<P?-1:1}return $}e.compareFileExtensions=c;function S(m,b){m=m||"",b=b||"";const l=g(m),f=g(b),P=M.value.collator,z=T.value.collator;return C(z,l,f)||C(P,m,b)}e.compareFileExtensionsDefault=S;function E(m,b){m=m||"",b=b||"";const l=g(m),f=g(b),P=M.value.collator,z=T.value.collator;return C(z,l,f)||n(m,b)||C(P,m,b)}e.compareFileExtensionsUpper=E;function o(m,b){m=m||"",b=b||"";const l=g(m),f=g(b),P=M.value.collator,z=T.value.collator;return C(z,l,f)||d(m,b)||C(P,m,b)}e.compareFileExtensionsLower=o;function t(m,b){m=m||"",b=b||"";const l=g(m).toLowerCase(),f=g(b).toLowerCase();return l!==f?l<f?-1:1:m!==b?m<b?-1:1:0}e.compareFileExtensionsUnicode=t;const i=/^(.*?)(\.([^.]*))?$/;function a(m,b=!1){const l=m?i.exec(m):[];let f=[l&&l[1]||"",l&&l[3]||""];return b&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function g(m){const b=m?i.exec(m):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function C(m,b,l){const f=m.compare(b,l);return f!==0?f:b.length!==l.length?b.length<l.length?-1:1:0}function k(m){const b=m.charAt(0);return b.toLocaleUpperCase()!==b}function r(m){const b=m.charAt(0);return b.toLocaleLowerCase()!==b}function d(m,b){return k(m)&&r(b)?-1:r(m)&&k(b)?1:0}function n(m,b){return r(m)&&k(b)?-1:k(m)&&r(b)?1:0}function s(m,b,l=!1){return l||(m=m&&m.toLowerCase(),b=b&&b.toLowerCase()),m===b?0:m<b?-1:1}function v(m,b,l=!1){const f=m.split(O.sep),P=b.split(O.sep),z=f.length-1,$=P.length-1;let H,x;for(let U=0;;U++){if(H=z===U,x=$===U,H&&x)return h(f[U],P[U],l);if(H)return-1;if(x)return 1;const N=s(f[U],P[U],l);if(N!==0)return N}}e.comparePaths=v;function D(m,b,l){const f=m.toLowerCase(),P=b.toLowerCase(),z=u(m,b,l);if(z)return z;const $=f.endsWith(l),H=P.endsWith(l);if($!==H)return $?-1:1;const x=h(f,P);return x!==0?x:f.localeCompare(P)}e.compareAnything=D;function u(m,b,l){const f=m.toLowerCase(),P=b.toLowerCase(),z=f.startsWith(l),$=P.startsWith(l);if(z!==$)return z?-1:1;if(z&&$){if(f.length<P.length)return-1;if(f.length>P.length)return 1}return 0}e.compareByPrefix=u}),define(Pe[42],Ae([1,0,19,22,15,12]),function(pe,e,w,O,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(D){return D===47||D===92}e.isPathSeparator=T;function h(D){return D.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=h;function y(D){return D.indexOf("/")===-1&&(D=h(D)),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D),D}e.toPosixPath=y;function p(D,u=w.posix.sep){if(!D)return"";const m=D.length,b=D.charCodeAt(0);if(T(b)){if(T(D.charCodeAt(1))&&!T(D.charCodeAt(2))){let f=3;const P=f;for(;f<m&&!T(D.charCodeAt(f));f++);if(P!==f&&!T(D.charCodeAt(f+1))){for(f+=1;f<m;f++)if(T(D.charCodeAt(f)))return D.slice(0,f+1).replace(/[\\/]/g,u)}}return u}else if(i(b)&&D.charCodeAt(1)===58)return T(D.charCodeAt(2))?D.slice(0,2)+u:D.slice(0,2);let l=D.indexOf("://");if(l!==-1){for(l+=3;l<m;l++)if(T(D.charCodeAt(l)))return D.slice(0,l+1)}return""}e.getRoot=p;function A(D){if(!O.isWindows||!D||D.length<5)return!1;let u=D.charCodeAt(0);if(u!==92||(u=D.charCodeAt(1),u!==92))return!1;let m=2;const b=m;for(;m<D.length&&(u=D.charCodeAt(m),u!==92);m++);return!(b===m||(u=D.charCodeAt(m+1),isNaN(u)||u===92))}e.isUNC=A;const _=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(D,u=O.isWindows){const m=u?_:c;return!(!D||D.length===0||/^\s+$/.test(D)||(m.lastIndex=0,m.test(D))||u&&S.test(D)||D==="."||D===".."||u&&D[D.length-1]==="."||u&&D.length!==D.trim().length||D.length>255)}e.isValidBasename=E;function o(D,u,m){const b=D===u;return!m||b?b:!D||!u?!1:(0,I.equalsIgnoreCase)(D,u)}e.isEqual=o;function t(D,u,m,b=w.sep){if(D===u)return!0;if(!D||!u||u.length>D.length)return!1;if(m){if(!(0,I.startsWithIgnoreCase)(D,u))return!1;if(u.length===D.length)return!0;let f=u.length;return u.charAt(u.length-1)===b&&f--,D.charAt(f)===b}return u.charAt(u.length-1)!==b&&(u+=b),D.indexOf(u)===0}e.isEqualOrParent=t;function i(D){return D>=65&&D<=90||D>=97&&D<=122}e.isWindowsDriveLetter=i;function a(D,u){return O.isWindows&&D.endsWith(":")&&(D+=w.sep),(0,w.isAbsolute)(D)||(D=(0,w.join)(u,D)),D=(0,w.normalize)(D),O.isWindows?(D=(0,I.rtrim)(D,w.sep),D.endsWith(":")&&(D+=w.sep)):(D=(0,I.rtrim)(D,w.sep),D||(D=w.sep)),D}e.sanitizeFilePath=a;function g(D){const u=(0,w.normalize)(D);return O.isWindows?D.length>3?!1:C(u)&&(D.length===2||u.charCodeAt(2)===92):u===w.posix.sep}e.isRootOrDriveLetter=g;function C(D,u=O.isWindows){return u?i(D.charCodeAt(0))&&D.charCodeAt(1)===58:!1}e.hasDriveLetter=C;function k(D,u=O.isWindows){return C(D,u)?D[0]:void 0}e.getDriveLetter=k;function r(D,u,m){return u.length>D.length?-1:D===u?0:(m&&(D=D.toLowerCase(),u=u.toLowerCase()),D.indexOf(u))}e.indexOfPath=r;function d(D){const u=D.split(":");let m,b,l;for(const f of u){const P=Number(f);(0,M.isNumber)(P)?b===void 0?b=P:l===void 0&&(l=P):m=m?[m,f].join(":"):f}if(!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:b!==void 0?b:void 0,column:l!==void 0?l:b!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(D,u,m=8){let b="";for(let f=0;f<m;f++){let P;f===0&&O.isWindows&&!u&&(m===3||m===4)?P=s:P=n,b+=P.charAt(Math.floor(Math.random()*P.length))}let l;return u?l=`${u}-${b}`:l=b,D?(0,w.join)(D,l):l}e.randomPath=v}),define(Pe[69],Ae([1,0,19]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(A){const _=(0,w.extname)(A),c=O[_.toLowerCase()];return c!==void 0?c:T(A)}e.getMediaOrTextMime=M;function T(A){const _=(0,w.extname)(A);return I[_.toLowerCase()]}e.getMediaMime=T;function h(A){for(const _ in I)if(I[_]===A)return _}e.getExtensionForMimeType=h;const y=/^(.+)\/(.+?)(;.+)?$/;function p(A,_){const c=y.exec(A);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:_?void 0:A}e.normalizeMimeType=p}),define(Pe[70],Ae([1,0,25,15,2]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(p){return JSON.stringify(p,h)}e.stringify=M;function T(p){let A=JSON.parse(p);return A=y(A),A}e.parse=T;function h(p,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,O.regExpFlags)(A)}:A}function y(p,A=0){if(!p||A>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return I.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 16:return new Date(p.source)}if(p instanceof w.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let _=0;_<p.length;++_)p[_]=y(p[_],A+1);else for(const _ in p)Object.hasOwnProperty.call(p,_)&&(p[_]=y(p[_],A+1))}return p}e.revive=y}),define(Pe[13],Ae([1,0,11,22,2]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(A){this._preferredWebSchema=A}setDelegate(A){this._delegate=A}setServerRootPath(A){this._remoteResourcesPath=`${A}/${M.vscodeRemoteResource}`}set(A,_,c){this._hosts[A]=_,this._ports[A]=c}setConnectionToken(A,_){this._connectionTokens[A]=_}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(A){if(this._delegate)try{return this._delegate(A)}catch(t){return w.onUnexpectedError(t),A}const _=A.authority;let c=this._hosts[_];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const S=this._ports[_],E=this._connectionTokens[_];let o=`path=${encodeURIComponent(A.path)}`;return typeof E=="string"&&(o+=`&${e.connectionTokenQueryName}=${encodeURIComponent(E)}`),I.URI.from({scheme:O.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${c}:${S}`,path:this._remoteResourcesPath,query:o})}}e.RemoteAuthorities=new T,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class h{static{this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(A){const _=this.toUri(A,pe);return this.uriToBrowserUri(_)}uriToBrowserUri(A){return A.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(A):A.scheme===M.file&&(O.isNative||O.isWebWorker&&O.globals.origin===`${M.vscodeFileResource}://${h.FALLBACK_AUTHORITY}`)?A.with({scheme:M.vscodeFileResource,authority:A.authority||h.FALLBACK_AUTHORITY,query:null,fragment:null}):A}asFileUri(A){const _=this.toUri(A,pe);return this.uriToFileUri(_)}uriToFileUri(A){return A.scheme===M.vscodeFileResource?A.with({scheme:M.file,authority:A.authority!==h.FALLBACK_AUTHORITY?A.authority:null,query:null,fragment:null}):A}toUri(A,_){return I.URI.isUri(A)?A:I.URI.parse(_.toUrl(A))}}e.FileAccess=new h;var y;(function(p){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(A.get("3"));const _="vscode-coi";function c(E){let o;typeof E=="string"?o=new URL(E).searchParams:E instanceof URL?o=E.searchParams:I.URI.isUri(E)&&(o=new URL(E.toString(!0)).searchParams);const t=o?.get(_);if(t)return A.get(t)}p.getHeadersFromQuery=c;function S(E,o,t){if(!globalThis.crossOriginIsolated)return;const i=o&&t?"3":t?"2":"1";E instanceof URLSearchParams?E.set(_,i):E[_]=i}p.addSearchParam=S})(y||(e.COI=y={}))}),define(Pe[23],Ae([1,0,42,13,19,22,15,2]),function(pe,e,w,O,I,M,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(S){return(0,h.uriToFsPath)(S,!0)}e.originalFSPath=y;class p{constructor(E){this._ignorePathCasing=E}compare(E,o,t=!1){return E===o?0:(0,T.compare)(this.getComparisonKey(E,t),this.getComparisonKey(o,t))}isEqual(E,o,t=!1){return E===o?!0:!E||!o?!1:this.getComparisonKey(E,t)===this.getComparisonKey(o,t)}getComparisonKey(E,o=!1){return E.with({path:this._ignorePathCasing(E)?E.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(E){return this._ignorePathCasing(E)}isEqualOrParent(E,o,t=!1){if(E.scheme===o.scheme){if(E.scheme===O.Schemas.file)return w.isEqualOrParent(y(E),y(o),this._ignorePathCasing(E))&&E.query===o.query&&(t||E.fragment===o.fragment);if((0,e.isEqualAuthority)(E.authority,o.authority))return w.isEqualOrParent(E.path,o.path,this._ignorePathCasing(E),"/")&&E.query===o.query&&(t||E.fragment===o.fragment)}return!1}joinPath(E,...o){return h.URI.joinPath(E,...o)}basenameOrAuthority(E){return(0,e.basename)(E)||E.authority}basename(E){return I.posix.basename(E.path)}extname(E){return I.posix.extname(E.path)}dirname(E){if(E.path.length===0)return E;let o;return E.scheme===O.Schemas.file?o=h.URI.file(I.dirname(y(E))).path:(o=I.posix.dirname(E.path),E.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),o="/")),E.with({path:o})}normalizePath(E){if(!E.path.length)return E;let o;return E.scheme===O.Schemas.file?o=h.URI.file(I.normalize(y(E))).path:o=I.posix.normalize(E.path),E.with({path:o})}relativePath(E,o){if(E.scheme!==o.scheme||!(0,e.isEqualAuthority)(E.authority,o.authority))return;if(E.scheme===O.Schemas.file){const a=I.relative(y(E),y(o));return M.isWindows?w.toSlashes(a):a}let t=E.path||"/";const i=o.path||"/";if(this._ignorePathCasing(E)){let a=0;for(const g=Math.min(t.length,i.length);a<g&&!(t.charCodeAt(a)!==i.charCodeAt(a)&&t.charAt(a).toLowerCase()!==i.charAt(a).toLowerCase());a++);t=i.substr(0,a)+t.substr(a)}return I.posix.relative(t,i)}resolvePath(E,o){if(E.scheme===O.Schemas.file){const t=h.URI.file(I.resolve(y(E),o));return E.with({authority:t.authority,path:t.path})}return o=w.toPosixPath(o),E.with({path:I.posix.resolve(E.path,o)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,o){return E===o||E!==void 0&&o!==void 0&&(0,T.equalsIgnoreCase)(E,o)}hasTrailingPathSeparator(E,o=I.sep){if(E.scheme===O.Schemas.file){const t=y(E);return t.length>w.getRoot(t).length&&t[t.length-1]===o}else{const t=E.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,o=I.sep){return(0,e.hasTrailingPathSeparator)(E,o)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,o=I.sep){let t=!1;if(E.scheme===O.Schemas.file){const i=y(E);t=i!==void 0&&i.length===w.getRoot(i).length&&i[i.length-1]===o}else{o="/";const i=E.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.hasTrailingPathSeparator)(E,o)?E.with({path:E.path+"/"}):E}}e.ExtUri=p,e.extUri=new p(()=>!1),e.extUriBiasedIgnorePathCase=new p(S=>S.scheme===O.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new p(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(S,E){const o=[];for(let t=0;t<S.length;t++){const i=E(S[t]);S.some((a,g)=>g===t?!1:(0,e.isEqualOrParent)(i,E(a)))||o.push(S[t])}return o}e.distinctParents=A;var _;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function E(o){const t=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(g=>{const[C,k]=g.split(":");C&&k&&t.set(C,k)});const a=o.path.substring(0,o.path.indexOf(";"));return a&&t.set(S.META_DATA_MIME,a),t}S.parseMetaData=E})(_||(e.DataUri=_={}));function c(S,E,o){if(E){let t=S.path;return t&&t[0]!==I.posix.sep&&(t=I.posix.sep+t),S.with({scheme:o,authority:E,path:t})}return S.with({scheme:o})}e.toLocalResource=c}),define(Pe[16],Ae([1,0,20,11,5,6,23,22,120]),function(pe,e,w,O,I,M,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function p(le){return!!le&&typeof le.then=="function"}e.isThenable=p;function A(le){const F=new w.CancellationTokenSource,J=le(F.token),Se=new Promise((ke,Ce)=>{const _e=F.token.onCancellationRequested(()=>{_e.dispose(),F.dispose(),Ce(new O.CancellationError)});Promise.resolve(J).then(Ie=>{_e.dispose(),F.dispose(),ke(Ie)},Ie=>{_e.dispose(),F.dispose(),Ce(Ie)})});return new class{cancel(){F.cancel()}then(ke,Ce){return Se.then(ke,Ce)}catch(ke){return this.then(void 0,ke)}finally(ke){return Se.finally(ke)}}}e.createCancelablePromise=A;function _(le,F,J){return new Promise((Se,ke)=>{const Ce=F.onCancellationRequested(()=>{Ce.dispose(),Se(J)});le.then(Se,ke).finally(()=>Ce.dispose())})}e.raceCancellation=_;function c(le,F){return new Promise((J,Se)=>{const ke=F.onCancellationRequested(()=>{ke.dispose(),Se(new O.CancellationError)});le.then(J,Se).finally(()=>ke.dispose())})}e.raceCancellationError=c;async function S(le){let F=-1;const J=le.map((Se,ke)=>Se.then(Ce=>(F=ke,Ce)));try{return await Promise.race(J)}finally{le.forEach((Se,ke)=>{ke!==F&&Se.cancel()})}}e.raceCancellablePromises=S;function E(le,F,J){let Se;const ke=setTimeout(()=>{Se?.(void 0),J?.()},F);return Promise.race([le.finally(()=>clearTimeout(ke)),new Promise(Ce=>Se=Ce)])}e.raceTimeout=E;function o(le){return new Promise((F,J)=>{const Se=le();p(Se)?Se.then(F,J):F(Se)})}e.asPromise=o;class t{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.isDisposed)throw new Error("Throttler is disposed");if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const J=()=>{if(this.queuedPromise=null,this.isDisposed)return;const Se=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Se};this.queuedPromise=new Promise(Se=>{this.activePromise.then(J,J).then(Se)})}return new Promise((J,Se)=>{this.queuedPromise.then(J,Se)})}return this.activePromise=F(),new Promise((J,Se)=>{this.activePromise.then(ke=>{this.activePromise=null,J(ke)},ke=>{this.activePromise=null,Se(ke)})})}dispose(){this.isDisposed=!0}}e.Throttler=t;class i{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=i;class a{constructor(){this.promiseMap=new Map}queue(F,J){const ke=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(J).finally(()=>{this.promiseMap.get(F)===ke&&this.promiseMap.delete(F)});return this.promiseMap.set(F,ke),ke}}e.SequencerByKey=a;const g=(le,F)=>{let J=!0;const Se=setTimeout(()=>{J=!1,F()},le);return{isTriggered:()=>J,dispose:()=>{clearTimeout(Se),J=!1}}},C=le=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,le())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};class k{constructor(F){this.defaultDelay=F,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,J=this.defaultDelay){this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ke,Ce)=>{this.doResolve=ke,this.doReject=Ce}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ke=this.task;return this.task=null,ke()}}));const Se=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=J===y.MicrotaskDelay?C(Se):g(J,Se),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new O.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=k;class r{constructor(F){this.delayer=new k(F),this.throttler=new t}trigger(F,J){return this.delayer.trigger(()=>this.throttler.queue(F),J)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=r;class d{constructor(){this._isOpen=!1,this._promise=new Promise((F,J)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class n extends d{constructor(F){super(),this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=n;function s(le,F){return F?new Promise((J,Se)=>{const ke=setTimeout(()=>{Ce.dispose(),J()},le),Ce=F.onCancellationRequested(()=>{clearTimeout(ke),Ce.dispose(),Se(new O.CancellationError)})}):A(J=>s(le,J))}e.timeout=s;function v(le,F=0){const J=setTimeout(le,F);return(0,M.toDisposable)(()=>clearTimeout(J))}e.disposableTimeout=v;function D(le){const F=[];let J=0;const Se=le.length;function ke(){return J<Se?le[J++]():null}function Ce(_e){_e!=null&&F.push(_e);const Ie=ke();return Ie?Ie.then(Ce):Promise.resolve(F)}return Promise.resolve(null).then(Ce)}e.sequence=D;function u(le,F=Se=>!!Se,J=null){let Se=0;const ke=le.length,Ce=()=>{if(Se>=ke)return Promise.resolve(J);const _e=le[Se++];return Promise.resolve(_e()).then(se=>F(se)?Promise.resolve(se):Ce())};return Ce()}e.first=u;function m(le,F=Se=>!!Se,J=null){if(le.length===0)return Promise.resolve(J);let Se=le.length;const ke=()=>{Se=-1;for(const Ce of le)Ce.cancel?.()};return new Promise((Ce,_e)=>{for(const Ie of le)Ie.then(se=>{--Se>=0&&F(se)?(ke(),Ce(se)):Se===0&&Ce(J)}).catch(se=>{--Se>=0&&(ke(),_e(se))})})}e.firstParallel=m;class b{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new I.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(F){return this._size++,new Promise((J,Se)=>{this.outstandingPromises.push({factory:F,c:J,e:Se}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const J=F.factory();J.then(F.c,F.e),J.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=b;class l extends b{constructor(){super(1)}}e.Queue=l;class f{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const F=new Re;return this.drainers.add(F),F.p}isDrained(){for(const[,F]of this.queues)if(F.size>0)return!1;return!0}queueFor(F,J=T.extUri){const Se=J.getComparisonKey(F);let ke=this.queues.get(Se);return ke||(ke=new l,I.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.queues.delete(Se),this.onDidQueueDrain()}),this.queues.set(Se,ke)),ke}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const F of this.drainers)F.complete();this.drainers.clear()}dispose(){for(const[,F]of this.queues)F.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=f;class P{constructor(F,J){this._token=-1,typeof F=="function"&&typeof J=="number"&&this.setIfNotSet(F,J)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,J){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},J)}setIfNotSet(F,J){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},J))}}e.TimeoutTimer=P;class z{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,J){this.cancel(),this._token=setInterval(()=>{F()},J)}}e.IntervalTimer=z;class ${constructor(F,J){this.timeoutToken=-1,this.runner=F,this.timeout=J,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=$;class H{constructor(F,J){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.runner=F,this.timeout=J,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(F=this.timeout){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(F/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=H;class x extends ${constructor(F,J){super(F,J),this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner?.(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class U extends M.Disposable{constructor(F,J){super(),this.options=F,this.handler=J,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.options.maxBufferedWork)return!1}else if(this.pending+F.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const J of F)this.pendingWork.push(J);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new $(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=le=>{(0,h.setTimeout0)(()=>{if(F)return;const J=Date.now()+15;le(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,J-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(le,F)=>{const J=requestIdleCallback(le,typeof F=="number"?{timeout:F}:void 0);let Se=!1;return{dispose(){Se||(Se=!0,cancelIdleCallback(J))}}}}();class N{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(J){this._error=J}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=N;async function ae(le,F,J){let Se;for(let ke=0;ke<J;ke++)try{return await le()}catch(Ce){Se=Ce,await s(F)}throw Se}e.retry=ae;class Y{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(F,J,Se){return this._pending={taskId:F,cancel:()=>Se?.(),promise:J},J.then(()=>this.donePending(F),()=>this.donePending(F)),J}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let J,Se;const ke=new Promise((Ce,_e)=>{J=Ce,Se=_e});this._next={run:F,promise:ke,promiseResolve:J,promiseReject:Se}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=Y;class Ee{constructor(F,J=()=>Date.now()){this.interval=F,this.nowFn=J,this.lastIncrementTime=0,this.value=0}increment(){const F=this.nowFn();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=Ee;var ye;(function(le){le[le.Resolved=0]="Resolved",le[le.Rejected=1]="Rejected"})(ye||(ye={}));class Re{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((F,J)=>{this.completeCallback=F,this.errorCallback=J})}complete(F){return new Promise(J=>{this.completeCallback(F),this.outcome={outcome:0,value:F},J()})}error(F){return new Promise(J=>{this.errorCallback(F),this.outcome={outcome:1,value:F},J()})}cancel(){return this.error(new O.CancellationError)}}e.DeferredPromise=Re;var K;(function(le){async function F(Se){let ke;const Ce=await Promise.all(Se.map(_e=>_e.then(Ie=>Ie,Ie=>{ke||(ke=Ie)})));if(typeof ke<"u")throw ke;return Ce}le.settled=F;function J(Se){return new Promise(async(ke,Ce)=>{try{await Se(ke,Ce)}catch(_e){Ce(_e)}})}le.withAsyncBody=J})(K||(e.Promises=K={}));var Q;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(Q||(Q={}));class ue{static fromArray(F){return new ue(J=>{J.emitMany(F)})}static fromPromise(F){return new ue(async J=>{J.emitMany(await F)})}static fromPromises(F){return new ue(async J=>{await Promise.all(F.map(async Se=>J.emitOne(await Se)))})}static merge(F){return new ue(async J=>{await Promise.all(F.map(async Se=>{for await(const ke of Se)J.emitOne(ke)}))})}static{this.EMPTY=ue.fromArray([])}constructor(F){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const J={emitOne:Se=>this.emitOne(Se),emitMany:Se=>this.emitMany(Se),reject:Se=>this.reject(Se)};try{await Promise.resolve(F(J)),this.resolve()}catch(Se){this.reject(Se)}finally{J.emitOne=void 0,J.emitMany=void 0,J.reject=void 0}})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(F<this._results.length)return{done:!1,value:this._results[F++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(F,J){return new ue(async Se=>{for await(const ke of F)Se.emitOne(J(ke))})}map(F){return ue.map(this,F)}static filter(F,J){return new ue(async Se=>{for await(const ke of F)J(ke)&&Se.emitOne(ke)})}filter(F){return ue.filter(this,F)}static coalesce(F){return ue.filter(F,J=>!!J)}coalesce(){return ue.coalesce(this)}static async toPromise(F){const J=[];for await(const Se of F)J.push(Se);return J}toPromise(){return ue.toPromise(this)}emitOne(F){this._state===0&&(this._results.push(F),this._onStateChanged.fire())}emitMany(F){this._state===0&&(this._results=this._results.concat(F),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(F){this._state===0&&(this._state=2,this._error=F,this._onStateChanged.fire())}}e.AsyncIterableObject=ue;class ne extends ue{constructor(F,J){super(J),this._source=F}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ne;function he(le){const F=new w.CancellationTokenSource,J=le(F.token);return new ne(F,async Se=>{const ke=F.token.onCancellationRequested(()=>{ke.dispose(),F.dispose(),Se.reject(new O.CancellationError)});try{for await(const Ce of J){if(F.token.isCancellationRequested)return;Se.emitOne(Ce)}ke.dispose(),F.dispose()}catch(Ce){ke.dispose(),F.dispose(),Se.reject(Ce)}})}e.createCancelableAsyncIterable=he}),define(Pe[37],Ae([1,0,18,16,42,28,19,22,15]),function(pe,e,w,O,I,M,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function p(){return Object.create(null)}e.getEmptyExpression=p,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const A="[/\\\\]",_="[^/\\\\]",c=/\//g;function S(Ee,ye){switch(Ee){case 0:return"";case 1:return`${_}*?`;default:return`(?:${A}|${_}+${A}${ye?`|${A}${_}+`:""})*?`}}function E(Ee,ye){if(!Ee)return[];const Re=[];let K=!1,Q=!1,ue="";for(const ne of Ee){switch(ne){case ye:if(!K&&!Q){Re.push(ue),ue="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}ue+=ne}return ue&&Re.push(ue),Re}e.splitGlobAware=E;function o(Ee){if(!Ee)return"";let ye="";const Re=E(Ee,e.GLOB_SPLIT);if(Re.every(K=>K===e.GLOBSTAR))ye=".*";else{let K=!1;Re.forEach((Q,ue)=>{if(Q===e.GLOBSTAR){if(K)return;ye+=S(2,ue===Re.length-1)}else{let ne=!1,he="",le=!1,F="";for(const J of Q){if(J!=="}"&&ne){he+=J;continue}if(le&&(J!=="]"||!F)){let Se;J==="-"?Se=J:(J==="^"||J==="!")&&!F?Se="^":J===e.GLOB_SPLIT?Se="":Se=(0,y.escapeRegExpCharacters)(J),F+=Se;continue}switch(J){case"{":ne=!0;continue;case"[":le=!0;continue;case"}":{const ke=`(?:${E(he,",").map(Ce=>o(Ce)).join("|")})`;ye+=ke,ne=!1,he="";break}case"]":{ye+="["+F+"]",le=!1,F="";break}case"?":ye+=_;continue;case"*":ye+=S(1);continue;default:ye+=(0,y.escapeRegExpCharacters)(J)}}ue<Re.length-1&&(Re[ue+1]!==e.GLOBSTAR||ue+2<Re.length)&&(ye+=A)}K=Q===e.GLOBSTAR})}return ye}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,C=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new M.LRUCache(1e4),d=function(){return!1},n=function(){return null};function s(Ee,ye){if(!Ee)return n;let Re;typeof Ee!="string"?Re=Ee.pattern:Re=Ee,Re=Re.trim();const K=`${Re}_${!!ye.trimForExclusions}`;let Q=r.get(K);if(Q)return v(Q,Ee);let ue;return t.test(Re)?Q=u(Re.substr(4),Re):(ue=i.exec(D(Re,ye)))?Q=m(ue[1],Re):(ye.trimForExclusions?g:a).test(Re)?Q=b(Re,ye):(ue=C.exec(D(Re,ye)))?Q=l(ue[1].substr(1),Re,!0):(ue=k.exec(D(Re,ye)))?Q=l(ue[1],Re,!1):Q=f(Re),r.set(K,Q),v(Q,Ee)}function v(Ee,ye){if(typeof ye=="string")return Ee;const Re=function(K,Q){return(0,I.isEqualOrParent)(K,ye.base,!h.isLinux)?Ee((0,y.ltrim)(K.substr(ye.base.length),T.sep),Q):null};return Re.allBasenames=Ee.allBasenames,Re.allPaths=Ee.allPaths,Re.basenames=Ee.basenames,Re.patterns=Ee.patterns,Re}function D(Ee,ye){return ye.trimForExclusions&&Ee.endsWith("/**")?Ee.substr(0,Ee.length-2):Ee}function u(Ee,ye){return function(Re,K){return typeof Re=="string"&&Re.endsWith(Ee)?ye:null}}function m(Ee,ye){const Re=`/${Ee}`,K=`\\${Ee}`,Q=function(ne,he){return typeof ne!="string"?null:he?he===Ee?ye:null:ne===Ee||ne.endsWith(Re)||ne.endsWith(K)?ye:null},ue=[Ee];return Q.basenames=ue,Q.patterns=[ye],Q.allBasenames=ue,Q}function b(Ee,ye){const Re=ae(Ee.slice(1,-1).split(",").map(he=>s(he,ye)).filter(he=>he!==n),Ee),K=Re.length;if(!K)return n;if(K===1)return Re[0];const Q=function(he,le){for(let F=0,J=Re.length;F<J;F++)if(Re[F](he,le))return Ee;return null},ue=Re.find(he=>!!he.allBasenames);ue&&(Q.allBasenames=ue.allBasenames);const ne=Re.reduce((he,le)=>le.allPaths?he.concat(le.allPaths):he,[]);return ne.length&&(Q.allPaths=ne),Q}function l(Ee,ye,Re){const K=T.sep===T.posix.sep,Q=K?Ee:Ee.replace(c,T.sep),ue=T.sep+Q,ne=T.posix.sep+Ee;let he;return Re?he=function(le,F){return typeof le=="string"&&(le===Q||le.endsWith(ue)||!K&&(le===Ee||le.endsWith(ne)))?ye:null}:he=function(le,F){return typeof le=="string"&&(le===Q||!K&&le===Ee)?ye:null},he.allPaths=[(Re?"*/":"./")+Ee],he}function f(Ee){try{const ye=new RegExp(`^${o(Ee)}$`);return function(Re){return ye.lastIndex=0,typeof Re=="string"&&ye.test(Re)?Ee:null}}catch{return n}}function P(Ee,ye,Re){return!Ee||typeof ye!="string"?!1:z(Ee)(ye,void 0,Re)}e.match=P;function z(Ee,ye={}){if(!Ee)return d;if(typeof Ee=="string"||$(Ee)){const Re=s(Ee,ye);if(Re===n)return d;const K=function(Q,ue){return!!Re(Q,ue)};return Re.allBasenames&&(K.allBasenames=Re.allBasenames),Re.allPaths&&(K.allPaths=Re.allPaths),K}return U(Ee,ye)}e.parse=z;function $(Ee){const ye=Ee;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}e.isRelativePattern=$;function H(Ee){return Ee.allBasenames||[]}e.getBasenameTerms=H;function x(Ee){return Ee.allPaths||[]}e.getPathTerms=x;function U(Ee,ye){const Re=ae(Object.getOwnPropertyNames(Ee).map(he=>N(he,Ee[he],ye)).filter(he=>he!==n)),K=Re.length;if(!K)return n;if(!Re.some(he=>!!he.requiresSiblings)){if(K===1)return Re[0];const he=function(J,Se){let ke;for(let Ce=0,_e=Re.length;Ce<_e;Ce++){const Ie=Re[Ce](J,Se);if(typeof Ie=="string")return Ie;(0,O.isThenable)(Ie)&&(ke||(ke=[]),ke.push(Ie))}return ke?(async()=>{for(const Ce of ke){const _e=await Ce;if(typeof _e=="string")return _e}return null})():null},le=Re.find(J=>!!J.allBasenames);le&&(he.allBasenames=le.allBasenames);const F=Re.reduce((J,Se)=>Se.allPaths?J.concat(Se.allPaths):J,[]);return F.length&&(he.allPaths=F),he}const Q=function(he,le,F){let J,Se;for(let ke=0,Ce=Re.length;ke<Ce;ke++){const _e=Re[ke];_e.requiresSiblings&&F&&(le||(le=(0,T.basename)(he)),J||(J=le.substr(0,le.length-(0,T.extname)(he).length)));const Ie=_e(he,le,J,F);if(typeof Ie=="string")return Ie;(0,O.isThenable)(Ie)&&(Se||(Se=[]),Se.push(Ie))}return Se?(async()=>{for(const ke of Se){const Ce=await ke;if(typeof Ce=="string")return Ce}return null})():null},ue=Re.find(he=>!!he.allBasenames);ue&&(Q.allBasenames=ue.allBasenames);const ne=Re.reduce((he,le)=>le.allPaths?he.concat(le.allPaths):he,[]);return ne.length&&(Q.allPaths=ne),Q}function N(Ee,ye,Re){if(ye===!1)return n;const K=s(Ee,Re);if(K===n)return n;if(typeof ye=="boolean")return K;if(ye){const Q=ye.when;if(typeof Q=="string"){const ue=(ne,he,le,F)=>{if(!F||!K(ne,he))return null;const J=Q.replace("$(basename)",()=>le),Se=F(J);return(0,O.isThenable)(Se)?Se.then(ke=>ke?Ee:null):Se?Ee:null};return ue.requiresSiblings=!0,ue}}return K}function ae(Ee,ye){const Re=Ee.filter(he=>!!he.basenames);if(Re.length<2)return Ee;const K=Re.reduce((he,le)=>{const F=le.basenames;return F?he.concat(F):he},[]);let Q;if(ye){Q=[];for(let he=0,le=K.length;he<le;he++)Q.push(ye)}else Q=Re.reduce((he,le)=>{const F=le.patterns;return F?he.concat(F):he},[]);const ue=function(he,le){if(typeof he!="string")return null;if(!le){let J;for(J=he.length;J>0;J--){const Se=he.charCodeAt(J-1);if(Se===47||Se===92)break}le=he.substr(J)}const F=K.indexOf(le);return F!==-1?Q[F]:null};ue.basenames=K,ue.patterns=Q,ue.allBasenames=K;const ne=Ee.filter(he=>!he.basenames);return ne.push(ue),ne}function Y(Ee,ye){return(0,w.equals)(Ee,ye,(Re,K)=>typeof Re=="string"&&typeof K=="string"?Re===K:typeof Re!="string"&&typeof K!="string"?Re.base===K.base&&Re.pattern===K.pattern:!1)}e.patternsEquals=Y}),define(Pe[49],Ae([1,0,11,121,23,15,2]),function(pe,e,w,O,I,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var h;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(h||(e.MarkdownStringTextNewlineStyle=h={}));class y{constructor(i="",a=!1){if(this.value=i,typeof this.value!="string")throw(0,w.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(i,a=0){return this.value+=c(this.supportThemeIcons?(0,O.escapeIcons)(i):i).replace(/([ \t]+)/g,(g,C)=>"&nbsp;".repeat(C.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,a){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}appendLink(i,a,g){return this.value+="[",this.value+=this._escape(a,"]"),this.value+="](",this.value+=this._escape(String(i),")"),g&&(this.value+=` "${this._escape(this._escape(g,'"'),")")}"`),this.value+=")",this}_escape(i,a){const g=new RegExp((0,M.escapeRegExpCharacters)(a),"g");return i.replace(g,(C,k)=>i.charAt(k-1)!=="\\"?`\\${C}`:C)}}e.MarkdownString=y;function p(t){return A(t)?!t.value:Array.isArray(t)?t.every(p):!0}e.isEmptyMarkdownString=p;function A(t){return t instanceof y?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=A;function _(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,I.isEqual)(T.URI.from(t.baseUri),T.URI.from(i.baseUri)))}e.markdownStringEqual=_;function c(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=c;function S(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=S;function E(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=E;function o(t){const i=[],a=t.split("|").map(C=>C.trim());t=a[0];const g=a[1];if(g){const C=/height=(\d+)/.exec(g),k=/width=(\d+)/.exec(g),r=C?C[1]:"",d=k?k[1]:"",n=isFinite(parseInt(d)),s=isFinite(parseInt(r));n&&i.push(`width="${d}"`),s&&i.push(`height="${r}"`)}return{href:t,dimensions:i}}e.parseHrefAndDimensions=o}),define(Pe[90],Ae([1,0,18,42,19,22,23,15]),function(pe,e,w,O,I,M,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(s,v){const{os:D,tildify:u,relative:m}=v;if(m){const f=p(s,m,D);if(typeof f=="string")return f}let b=s.fsPath;if(D===1&&!M.isWindows?b=b.replace(/\//g,"\\"):D!==1&&M.isWindows&&(b=b.replace(/\\/g,"/")),D!==1&&u?.userHome){const f=u.userHome.fsPath;let P;s.scheme!==u.userHome.scheme&&s.path.startsWith(I.posix.sep)?P=u.userHome.with({path:s.path}).fsPath:P=s.fsPath,b=c(P,f,D)}return(D===1?I.win32:I.posix).normalize(A(b,D===1))}e.getPathLabel=y;function p(s,v,D){const u=D===1?I.win32:I.posix,m=D===3?T.extUri:T.extUriIgnorePathCase,b=v.getWorkspace(),l=(0,w.firstOrDefault)(b.folders);if(!l)return;s.scheme!==l.uri.scheme&&s.path.startsWith(I.posix.sep)&&(s=l.uri.with({path:s.path}));const f=v.getWorkspaceFolder(s);if(!f)return;let P;if(m.isEqual(f.uri,s)?P="":P=m.relativePath(f.uri,s)??"",P&&(P=u.normalize(P)),b.folders.length>1&&!v.noPrefix){const z=f.name?f.name:m.basenameOrAuthority(f.uri);P=P?`${z} \u2022 ${P}`:z}return P}function A(s,v=M.isWindows){return(0,O.hasDriveLetter)(s,v)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=A;let _=Object.create(null);function c(s,v,D=M.OS){if(D===1||!s||!v)return s;let u=_.original===v?_.normalized:void 0;u||(u=v,M.isWindows&&(u=(0,O.toSlashes)(u)),u=`${(0,h.rtrim)(u,I.posix.sep)}${I.posix.sep}`,_={original:v,normalized:u});let m=s;return M.isWindows&&(m=(0,O.toSlashes)(m)),(D===3?m.startsWith(u):(0,h.startsWithIgnoreCase)(m,u))?`~/${m.substr(u.length)}`:s}e.tildify=c;function S(s,v){return s.replace(/^~($|\/|\\)/,`${v}$1`)}e.untildify=S;const E="\u2026",o="\\\\",t="~";function i(s,v=I.sep){const D=new Array(s.length);let u=!1;for(let m=0;m<s.length;m++){const b=s[m];if(b===""){D[m]=`.${v}`;continue}if(!b){D[m]=b;continue}u=!0;let l="",f=b;f.indexOf(o)===0?(l=f.substr(0,f.indexOf(o)+o.length),f=f.substr(f.indexOf(o)+o.length)):f.indexOf(v)===0?(l=f.substr(0,f.indexOf(v)+v.length),f=f.substr(f.indexOf(v)+v.length)):f.indexOf(t)===0&&(l=f.substr(0,f.indexOf(t)+t.length),f=f.substr(f.indexOf(t)+t.length));const P=f.split(v);for(let z=1;u&&z<=P.length;z++)for(let $=P.length-z;u&&$>=0;$--){u=!1;let H=P.slice($,$+z).join(v);for(let x=0;!u&&x<s.length;x++)if(x!==m&&s[x]&&s[x].indexOf(H)>-1){const U=$+z===P.length,N=$>0&&s[x].indexOf(v)>-1?v+H:H,ae=s[x].endsWith(N);u=!U||ae}if(!u){let x="";(P[0].endsWith(":")||l!=="")&&($===1&&($=0,z++,H=P[0]+v+H),$>0&&(x=P[0]+v),x=l+x),$>0&&(x=x+E+v),x=x+H,$+z<P.length&&(x=x+v+E),D[m]=x}}u&&(D[m]=b)}return D}e.shorten=i;var a;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function g(s,v=Object.create(null)){const D=[];let u=!1,m="";for(const b of s)if(b==="$"||u&&b==="{")m&&D.push({value:m,type:a.TEXT}),m="",u=!0;else if(b==="}"&&u){const l=v[m];if(typeof l=="string")l.length&&D.push({value:l,type:a.VARIABLE});else if(l){const f=D[D.length-1];(!f||f.type!==a.SEPARATOR)&&D.push({value:l.label,type:a.SEPARATOR})}m="",u=!1}else m+=b;return m&&!u&&D.push({value:m,type:a.TEXT}),D.filter((b,l)=>{if(b.type===a.SEPARATOR){const f=D[l-1],P=D[l+1];return[f,P].every(z=>z&&(z.type===a.VARIABLE||z.type===a.TEXT)&&z.value.length>0)}return!0}).map(b=>b.value).join("")}e.template=g;function C(s,v){return M.isMacintosh||v?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):s.replace(/&&|&/g,D=>D==="&"?"&&":"&")}e.mnemonicMenuLabel=C;function k(s,v){return M.isMacintosh||v?s.replace(/\(&&\w\)|&&/g,""):M.isWindows?s.replace(/&&|&/g,D=>D==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=k;function r(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=r;function d(s){if(s.endsWith("]")){const v=s.lastIndexOf(" [",s.length-2);if(v!==-1){const D=n(s.substring(0,v));return{name:D.name,parentPath:D.parentPath+s.substring(v)}}}return n(s)}e.splitRecentLabel=d;function n(s){const v=s.indexOf("/")!==-1?I.posix:I.win32,D=v.basename(s),u=v.dirname(s);return D.length?{name:D,parentPath:u}:{name:u,parentPath:""}}}),define(Pe[132],Ae([1,0,25,2]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(_){return _.toJSON()}class M{constructor(c){this._uriTransformer=c}transformIncoming(c){const S=this._uriTransformer.transformIncoming(c);return S===c?c:I(O.URI.from(S))}transformOutgoing(c){const S=this._uriTransformer.transformOutgoing(c);return S===c?c:I(O.URI.from(S))}transformOutgoingURI(c){const S=this._uriTransformer.transformOutgoing(c);return S===c?c:O.URI.from(S)}transformOutgoingScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(_){return _}transformOutgoing(_){return _}transformOutgoingURI(_){return _}transformOutgoingScheme(_){return _}};function T(_,c,S){if(!_||S>200)return null;if(typeof _=="object"){if(_ instanceof O.URI)return c.transformOutgoing(_);for(const E in _)if(Object.hasOwnProperty.call(_,E)){const o=T(_[E],c,S+1);o!==null&&(_[E]=o)}}return null}function h(_,c){const S=T(_,c,0);return S===null?_:S}e.transformOutgoingURIs=h;function y(_,c,S,E){if(!_||E>200)return null;if(typeof _=="object"){if(_.$mid===1)return S?O.URI.revive(c.transformIncoming(_)):c.transformIncoming(_);if(_ instanceof w.VSBuffer)return null;for(const o in _)if(Object.hasOwnProperty.call(_,o)){const t=y(_[o],c,S,E+1);t!==null&&(_[o]=t)}}return null}function p(_,c){const S=y(_,c,!1,0);return S===null?_:S}e.transformIncomingURIs=p;function A(_,c){const S=y(_,c,!0,0);return S===null?_:S}e.transformAndReviveIncomingURIs=A}),define(Pe[133],Ae([1,0,37,19]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(M,T,h,y,p,A){if(Array.isArray(M)){let _=0;for(const c of M){const S=I(c,T,h,y,p,A);if(S===10)return S;S>_&&(_=S)}return _}else{if(typeof M=="string")return y?M==="*"?5:M===h?10:0:0;if(M){const{language:_,pattern:c,scheme:S,hasAccessToAllModels:E,notebookType:o}=M;if(!y&&!E)return 0;o&&p&&(T=p);let t=0;if(S)if(S===T.scheme)t=10;else if(S==="*")t=5;else return 0;if(_)if(_===h)t=10;else if(_==="*")t=Math.max(t,5);else return 0;if(o)if(o===A)t=10;else if(o==="*"&&A!==void 0)t=Math.max(t,5);else return 0;if(c){let i;if(typeof c=="string"?i=c:i={...c,base:(0,O.normalize)(c.base)},i===T.fsPath||(0,w.match)(i,T.fsPath))t=10;else return 0}return t}else return 0}}e.score=I}),define(Pe[91],Ae([1,0,25,22]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(I||(I={}));function M(_){for(let c=0,S=_.length;c<S;c+=4){const E=_[c+0],o=_[c+1],t=_[c+2],i=_[c+3];_[c+0]=i,_[c+1]=t,_[c+2]=o,_[c+3]=E}}function T(_){const c=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return O.isLittleEndian()||M(c),w.VSBuffer.wrap(c)}function h(_){const c=_.buffer;if(O.isLittleEndian()||M(c),c.byteOffset%4===0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const S=new Uint8Array(c.byteLength);return S.set(c),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function y(_){const c=new Uint32Array(p(_));let S=0;if(c[S++]=_.id,_.type==="full")c[S++]=1,c[S++]=_.data.length,c.set(_.data,S),S+=_.data.length;else{c[S++]=2,c[S++]=_.deltas.length;for(const E of _.deltas)c[S++]=E.start,c[S++]=E.deleteCount,E.data?(c[S++]=E.data.length,c.set(E.data,S),S+=E.data.length):c[S++]=0}return T(c)}e.encodeSemanticTokensDto=y;function p(_){let c=0;if(c+=1+1,_.type==="full")c+=1+_.data.length;else{c+=1,c+=(1+1+1)*_.deltas.length;for(const S of _.deltas)S.data&&(c+=S.data.length)}return c}function A(_){const c=h(_);let S=0;const E=c[S++];if(c[S++]===1){const a=c[S++],g=c.subarray(S,S+a);return S+=a,{id:E,type:"full",data:g}}const t=c[S++],i=[];for(let a=0;a<t;a++){const g=c[S++],C=c[S++],k=c[S++];let r;k>0&&(r=c.subarray(S,S+k),S+=k),i[a]={start:g,deleteCount:C,data:r}}return{id:E,type:"delta",deltas:i}}e.decodeSemanticTokensDto=A}),define(Pe[134],Ae([9,10]),function(pe,e){return pe.create("vs/editor/common/config/editorOptions",e)}),define(Pe[135],Ae([1,0,18,24,22,123,136,134]),function(pe,e,w,O,I,M,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class p{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=p;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class _{constructor(X,ge,Be,Me){this.id=X,this.name=ge,this.defaultValue=Be,this.schema=Me}applyUpdate(X,ge){return S(X,ge)}compute(X,ge,Be){return Be}}class c{constructor(X,ge){this.newValue=X,this.didChange=ge}}e.ApplyUpdateResult=c;function S(Z,X){if(typeof Z!="object"||typeof X!="object"||!Z||!X)return new c(X,Z!==X);if(Array.isArray(Z)||Array.isArray(X)){const Be=Array.isArray(Z)&&Array.isArray(X)&&w.equals(Z,X);return new c(X,!Be)}let ge=!1;for(const Be in X)if(X.hasOwnProperty(Be)){const Me=S(Z[Be],X[Be]);Me.didChange&&(Z[Be]=Me.newValue,ge=!0)}return new c(Z,ge)}class E{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,ge){return S(X,ge)}validate(X){return this.defaultValue}}class o{constructor(X,ge,Be,Me){this.id=X,this.name=ge,this.defaultValue=Be,this.schema=Me}applyUpdate(X,ge){return S(X,ge)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,ge,Be){return Be}}function t(Z,X){return typeof Z>"u"?X:Z==="false"?!1:!!Z}e.boolean=t;class i extends o{constructor(X,ge,Be,Me=void 0){typeof Me<"u"&&(Me.type="boolean",Me.default=Be),super(X,ge,Be,Me)}validate(X){return t(X,this.defaultValue)}}function a(Z,X,ge,Be){if(typeof Z>"u")return X;let Me=parseInt(Z,10);return isNaN(Me)?X:(Me=Math.max(ge,Me),Me=Math.min(Be,Me),Me|0)}e.clampedInt=a;class g extends o{static clampedInt(X,ge,Be,Me){return a(X,ge,Be,Me)}constructor(X,ge,Be,Me,Ge,et=void 0){typeof et<"u"&&(et.type="integer",et.default=Be,et.minimum=Me,et.maximum=Ge),super(X,ge,Be,et),this.minimum=Me,this.maximum=Ge}validate(X){return g.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function C(Z,X,ge,Be){if(typeof Z>"u")return X;const Me=k.float(Z,X);return k.clamp(Me,ge,Be)}e.clampedFloat=C;class k extends o{static clamp(X,ge,Be){return X<ge?ge:X>Be?Be:X}static float(X,ge){if(typeof X=="number")return X;if(typeof X>"u")return ge;const Be=parseFloat(X);return isNaN(Be)?ge:Be}constructor(X,ge,Be,Me,Ge){typeof Ge<"u"&&(Ge.type="number",Ge.default=Be),super(X,ge,Be,Ge),this.validationFn=Me}validate(X){return this.validationFn(k.float(X,this.defaultValue))}}class r extends o{static string(X,ge){return typeof X!="string"?ge:X}constructor(X,ge,Be,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.default=Be),super(X,ge,Be,Me)}validate(X){return r.string(X,this.defaultValue)}}function d(Z,X,ge,Be){return typeof Z!="string"?X:Be&&Z in Be?Be[Z]:ge.indexOf(Z)===-1?X:Z}e.stringSet=d;class n extends o{constructor(X,ge,Be,Me,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.enum=Me,Ge.default=Be),super(X,ge,Be,Ge),this._allowedValues=Me}validate(X){return d(X,this.defaultValue,this._allowedValues)}}class s extends _{constructor(X,ge,Be,Me,Ge,et,mt=void 0){typeof mt<"u"&&(mt.type="string",mt.enum=Ge,mt.default=Me),super(X,ge,Be,mt),this._allowedValues=Ge,this._convert=et}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function v(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class D extends _{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",tags:["accessibility"],description:h.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ge,Be){return Be===0?X.accessibilitySupport:Be}}class u extends _{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(22,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:h.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertSpace:t(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var m;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(m||(e.TextEditorCursorBlinkingStyle=m={}));function b(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(l||(e.TextEditorCursorStyle=l={}));function f(Z){switch(Z){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function P(Z){switch(Z){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class z extends E{constructor(){super(139)}compute(X,ge,Be){const Me=["monaco-editor"];return ge.get(38)&&Me.push(ge.get(38)),X.extraEditorClassName&&Me.push(X.extraEditorClassName),ge.get(72)==="default"?Me.push("mouse-default"):ge.get(72)==="copy"&&Me.push("mouse-copy"),ge.get(109)&&Me.push("showUnused"),ge.get(137)&&Me.push("showDeprecated"),Me.join(" ")}}class $ extends i{constructor(){super(36,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(X,ge,Be){return Be&&X.emptySelectionClipboard}}class H extends _{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(40,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:h.localize(16,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:h.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{cursorMoveOnType:t(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":d(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":d(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(ge.loop,this.defaultValue.loop)}}}class x extends _{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(50,"fontLigatures",x.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?x.OFF:X==="true"?x.ON:X:X?x.ON:x.OFF}}e.EditorFontLigatures=x;class U extends _{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(53,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:h.localize(22,null)},{type:"string",description:h.localize(23,null)}],description:h.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?U.OFF:X==="true"?U.TRANSLATE:X:X?U.TRANSLATE:U.OFF}compute(X,ge,Be){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=U;class N extends E{constructor(){super(49)}compute(X,ge,Be){return X.fontInfo}}class ae extends o{constructor(){super(51,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(25,null)})}validate(X){const ge=k.float(X,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:k.clamp(ge,6,100)}compute(X,ge,Be){return X.fontInfo.fontSize}}class Y extends _{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(52,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.MINIMUM_VALUE,maximum:Y.MAXIMUM_VALUE,errorMessage:h.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(g.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.MINIMUM_VALUE,Y.MAXIMUM_VALUE))}}class Ee extends _{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[h.localize(28,null),h.localize(29,null),h.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(57,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:h.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:h.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:h.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Be,description:h.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Be,description:h.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Be,description:h.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Be,description:h.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Be,description:h.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{multiple:d(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??d(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??d(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??d(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??d(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??d(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends _{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(59,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:h.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:h.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:h.localize(44,null)},"editor.hover.above":{type:"boolean",default:X.above,description:h.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:t(ge.enabled,this.defaultValue.enabled),delay:g.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:t(ge.sticky,this.defaultValue.sticky),above:t(ge.above,this.defaultValue.above)}}}var Re;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Re||(e.RenderMinimap=Re={}));class K extends E{constructor(){super(142)}compute(X,ge,Be){return K.computeLayout(ge,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const ge=X.height/X.lineHeight,Be=Math.floor(X.paddingTop/X.lineHeight);let Me=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Me=Math.max(Me,ge-1));const Ge=(Be+X.viewLineCount+Me)/(X.pixelRatio*X.height),et=Math.floor(X.viewLineCount/Ge);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Me,desiredRatio:Ge,minimapLineCount:et}}static _computeMinimapLayout(X,ge){const Be=X.outerWidth,Me=X.outerHeight,Ge=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ge*Me),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Me};const et=ge.stableMinimapLayoutInput,mt=et&&X.outerHeight===et.outerHeight&&X.lineHeight===et.lineHeight&&X.typicalHalfwidthCharacterWidth===et.typicalHalfwidthCharacterWidth&&X.pixelRatio===et.pixelRatio&&X.scrollBeyondLastLine===et.scrollBeyondLastLine&&X.paddingTop===et.paddingTop&&X.paddingBottom===et.paddingBottom&&X.minimap.enabled===et.minimap.enabled&&X.minimap.side===et.minimap.side&&X.minimap.size===et.minimap.size&&X.minimap.showSlider===et.minimap.showSlider&&X.minimap.renderCharacters===et.minimap.renderCharacters&&X.minimap.maxColumn===et.minimap.maxColumn&&X.minimap.scale===et.minimap.scale&&X.verticalScrollbarWidth===et.verticalScrollbarWidth&&X.isViewportWrapping===et.isViewportWrapping,wt=X.lineHeight,Ut=X.typicalHalfwidthCharacterWidth,Vt=X.scrollBeyondLastLine,zt=X.minimap.renderCharacters;let St=Ge>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const At=X.minimap.maxColumn,Rt=X.minimap.size,Lt=X.minimap.side,xt=X.verticalScrollbarWidth,Ot=X.viewLineCount,st=X.remainingWidth,dt=X.isViewportWrapping,Bt=zt?2:3;let Ft=Math.floor(Ge*Me);const yt=Ft/Ge;let ot=!1,Tt=!1,Mt=Bt*St,Te=St/Ge,we=1;if(Rt==="fill"||Rt==="fit"){const{typicalViewportLineCount:Je,extraLinesBeforeFirstLine:Et,extraLinesBeyondLastLine:Dt,desiredRatio:Ct,minimapLineCount:vt}=K.computeContainedMinimapLineCount({viewLineCount:Ot,scrollBeyondLastLine:Vt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Me,lineHeight:wt,pixelRatio:Ge});if(Ot/vt>1)ot=!0,Tt=!0,St=1,Mt=1,Te=St/Ge;else{let ut=!1,pt=St+1;if(Rt==="fit"){const ft=Math.ceil((Et+Ot+Dt)*Mt);dt&&mt&&st<=ge.stableFitRemainingWidth?(ut=!0,pt=ge.stableFitMaxMinimapScale):ut=ft>Ft}if(Rt==="fill"||ut){ot=!0;const ft=St;Mt=Math.min(wt*Ge,Math.max(1,Math.floor(1/Ct))),dt&&mt&&st<=ge.stableFitRemainingWidth&&(pt=ge.stableFitMaxMinimapScale),St=Math.min(pt,Math.max(1,Math.floor(Mt/Bt))),St>ft&&(we=Math.min(2,St/ft)),Te=St/Ge/we,Ft=Math.ceil(Math.max(Je,Et+Ot+Dt)*Mt),dt?(ge.stableMinimapLayoutInput=X,ge.stableFitRemainingWidth=st,ge.stableFitMaxMinimapScale=St):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const be=Math.floor(At*Te),G=Math.min(be,Math.max(0,Math.floor((st-xt-2)*Te/(Ut+Te)))+e.MINIMAP_GUTTER_WIDTH);let Oe=Math.floor(Ge*G);const xe=Oe/Ge;Oe=Math.floor(Oe*we);const je=zt?1:2,ze=Lt==="left"?0:Be-G-xt;return{renderMinimap:je,minimapLeft:ze,minimapWidth:G,minimapHeightIsEditorHeight:ot,minimapIsSampling:Tt,minimapScale:St,minimapLineHeight:Mt,minimapCanvasInnerWidth:Oe,minimapCanvasInnerHeight:Ft,minimapCanvasOuterWidth:xe,minimapCanvasOuterHeight:yt}}static computeLayout(X,ge){const Be=ge.outerWidth|0,Me=ge.outerHeight|0,Ge=ge.lineHeight|0,et=ge.lineNumbersDigitCount|0,mt=ge.typicalHalfwidthCharacterWidth,wt=ge.maxDigitWidth,Ut=ge.pixelRatio,Vt=ge.viewLineCount,zt=X.get(134),St=zt==="inherit"?X.get(133):zt,At=St==="inherit"?X.get(129):St,Rt=X.get(132),Lt=ge.isDominatedByLongLines,xt=X.get(56),Ot=X.get(66).renderType!==0,st=X.get(67),dt=X.get(103),Bt=X.get(82),Ft=X.get(71),yt=X.get(101),ot=yt.verticalScrollbarSize,Tt=yt.verticalHasArrows,Mt=yt.arrowSize,Te=yt.horizontalScrollbarSize,we=X.get(42),be=X.get(108)!=="never";let G=X.get(64);we&&be&&(G+=16);let Oe=0;if(Ot){const $t=Math.max(et,st);Oe=Math.round($t*wt)}let xe=0;xt&&(xe=Ge*ge.glyphMarginDecorationLaneCount);let je=0,ze=je+xe,Je=ze+Oe,Et=Je+G;const Dt=Be-xe-Oe-G;let Ct=!1,vt=!1,gt=-1;St==="inherit"&&Lt?(Ct=!0,vt=!0):At==="on"||At==="bounded"?vt=!0:At==="wordWrapColumn"&&(gt=Rt);const ut=K._computeMinimapLayout({outerWidth:Be,outerHeight:Me,lineHeight:Ge,typicalHalfwidthCharacterWidth:mt,pixelRatio:Ut,scrollBeyondLastLine:dt,paddingTop:Bt.top,paddingBottom:Bt.bottom,minimap:Ft,verticalScrollbarWidth:ot,viewLineCount:Vt,remainingWidth:Dt,isViewportWrapping:vt},ge.memory||new A);ut.renderMinimap!==0&&ut.minimapLeft===0&&(je+=ut.minimapWidth,ze+=ut.minimapWidth,Je+=ut.minimapWidth,Et+=ut.minimapWidth);const pt=Dt-ut.minimapWidth,ft=Math.max(1,Math.floor((pt-ot-2)/mt)),Qt=Tt?Mt:0;return vt&&(gt=Math.max(1,ft),At==="bounded"&&(gt=Math.min(gt,Rt))),{width:Be,height:Me,glyphMarginLeft:je,glyphMarginWidth:xe,glyphMarginDecorationLaneCount:ge.glyphMarginDecorationLaneCount,lineNumbersLeft:ze,lineNumbersWidth:Oe,decorationsLeft:Je,decorationsWidth:G,contentLeft:Et,contentWidth:pt,minimap:ut,viewportColumn:ft,isWordWrapMinified:Ct,isViewportWrapping:vt,wrappingColumn:gt,verticalScrollbarWidth:ot,horizontalScrollbarHeight:Te,overviewRuler:{top:Qt,width:ot,height:Me-2*Qt,right:0}}}}e.EditorLayoutInfoComputer=K;class Q extends _{constructor(){super(136,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[h.localize(46,null),h.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:h.localize(48,null)}})}validate(X){return d(X,"simple",["simple","advanced"])}compute(X,ge,Be){return ge.get(2)===2?"advanced":Be}}class ue extends _{constructor(){const X={enabled:!0};super(63,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:h.localize(49,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:t(X.enabled,this.defaultValue.enabled)}}}class ne extends _{constructor(){const X={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(113,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:h.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:h.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:h.localize(52,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:t(ge.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:d(ge.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class he extends _{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(138,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:h.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[h.localize(54,null),h.localize(55,null,I.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),h.localize(56,null,I.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),h.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:h.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:h.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:h.localize(60,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:d(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(ge.fontFamily,this.defaultValue.fontFamily),padding:t(ge.padding,this.defaultValue.padding)}}}class le extends _{constructor(){super(64,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):g.clampedInt(X,this.defaultValue,0,1e3)}compute(X,ge,Be){return Be<0?g.clampedInt(-Be*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class F extends k{constructor(){super(65,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>k.clamp(X,0,150),{markdownDescription:h.localize(61,null)})}compute(X,ge,Be){return X.fontInfo.lineHeight}}class J extends _{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(71,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:h.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:h.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(64,null),h.localize(65,null),h.localize(66,null)],default:X.size,description:h.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:h.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:h.localize(69,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:h.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:h.localize(72,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:t(ge.enabled,this.defaultValue.enabled),autohide:t(ge.autohide,this.defaultValue.autohide),size:d(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(ge.side,this.defaultValue.side,["right","left"]),showSlider:d(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(ge.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(ge.scale,1,1,3),maxColumn:g.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Se(Z){return Z==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ke extends _{constructor(){super(82,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(74,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{top:g.clampedInt(ge.top,0,0,1e3),bottom:g.clampedInt(ge.bottom,0,0,1e3)}}}class Ce extends _{constructor(){const X={enabled:!0,cycle:!0};super(84,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:h.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:h.localize(76,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:t(ge.enabled,this.defaultValue.enabled),cycle:t(ge.cycle,this.defaultValue.cycle)}}}class _e extends E{constructor(){super(140)}compute(X,ge,Be){return X.pixelRatio}}class Ie extends _{constructor(){const X={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[h.localize(77,null),h.localize(78,null),h.localize(79,null)]}];super(87,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:X.strings,description:h.localize(80,null)},comments:{anyOf:ge,default:X.comments,description:h.localize(81,null)},other:{anyOf:ge,default:X.other,description:h.localize(82,null)}},default:X,markdownDescription:h.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Ut=X?"on":"off";return{comments:Ut,strings:Ut,other:Ut}}if(!X||typeof X!="object")return this.defaultValue;const{other:ge,comments:Be,strings:Me}=X,Ge=["on","inline","off"];let et,mt,wt;return typeof ge=="boolean"?et=ge?"on":"off":et=d(ge,this.defaultValue.other,Ge),typeof Be=="boolean"?mt=Be?"on":"off":mt=d(Be,this.defaultValue.comments,Ge),typeof Me=="boolean"?wt=Me?"on":"off":wt=d(Me,this.defaultValue.strings,Ge),{other:et,comments:mt,strings:wt}}}var se;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(se||(e.RenderLineNumbersType=se={}));class fe extends _{constructor(){super(66,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(84,null),h.localize(85,null),h.localize(86,null),h.localize(87,null)],default:"on",description:h.localize(88,null)})}validate(X){let ge=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(ge=4,Be=X):X==="interval"?ge=3:X==="relative"?ge=2:X==="on"?ge=1:ge=0),{renderType:ge,renderFn:Be}}}function ee(Z){const X=Z.get(96);return X==="editable"?Z.get(89):X!=="on"}e.filterValidationDecorations=ee;class ie extends _{constructor(){const X=[],ge={type:"number",description:h.localize(89,null)};super(100,"rulers",X,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:h.localize(90,null),format:"color-hex"}}}]},default:X,description:h.localize(91,null)})}validate(X){if(Array.isArray(X)){const ge=[];for(const Be of X)if(typeof Be=="number")ge.push({column:g.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Me=Be;ge.push({column:g.clampedInt(Me.column,0,0,1e4),color:Me.color})}return ge.sort((Be,Me)=>Be.column-Me.column),ge}return this.defaultValue}}class de extends _{constructor(){super(90,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function R(Z,X){if(typeof Z!="string")return X;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class W extends _{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(101,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(92,null),h.localize(93,null),h.localize(94,null)],default:"auto",description:h.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(96,null),h.localize(97,null),h.localize(98,null)],default:"auto",description:h.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:h.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:h.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:h.localize(102,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X,Be=g.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Me=g.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:R(ge.vertical,this.defaultValue.vertical),horizontal:R(ge.horizontal,this.defaultValue.horizontal),useShadows:t(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:g.clampedInt(ge.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Me,verticalSliderSize:g.clampedInt(ge.verticalSliderSize,Me,0,1e3),scrollByPage:t(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends _{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(123,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:h.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:h.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:h.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:h.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:h.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:h.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:h.localize(109,null)}})}applyUpdate(X,ge){let Be=!1;ge.allowedCharacters&&X&&(O.equals(X.allowedCharacters,ge.allowedCharacters)||(X={...X,allowedCharacters:ge.allowedCharacters},Be=!0)),ge.allowedLocales&&X&&(O.equals(X.allowedLocales,ge.allowedLocales)||(X={...X,allowedLocales:ge.allowedLocales},Be=!0));const Me=super.applyUpdate(X,ge);return Be?new c(Me.newValue,!0):Me}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{nonBasicASCII:ce(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ce(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ce(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,ge){if(typeof X!="object"||!X)return ge;const Be={};for(const[Me,Ge]of Object.entries(X))Ge===!0&&(Be[Me]=!0);return Be}}class q extends _{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(61,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:h.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[h.localize(111,null),h.localize(112,null)],description:h.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:h.localize(114,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:t(ge.enabled,this.defaultValue.enabled),mode:d(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(ge.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(ge.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(ge.keepOnBlur,this.defaultValue.keepOnBlur)}}}class oe extends _{constructor(){const X={enabled:M.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(14,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:h.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:h.localize(116,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:t(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class j extends _{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(15,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(117,null),h.localize(118,null),h.localize(119,null)],default:X.bracketPairs,description:h.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(121,null),h.localize(122,null),h.localize(123,null)],default:X.bracketPairsHorizontal,description:h.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:h.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:h.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[h.localize(127,null),h.localize(128,null),h.localize(129,null)],default:X.highlightActiveIndentation,description:h.localize(130,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{bracketPairs:ce(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ce(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:ce(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ce(Z,X,ge){const Be=ge.indexOf(Z);return Be===-1?X:ge[Be]}class ve extends _{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(116,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(131,null),h.localize(132,null)],default:X.insertMode,description:h.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:h.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:h.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:h.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[h.localize(137,null),h.localize(138,null),h.localize(139,null),h.localize(140,null)],default:X.selectionMode,markdownDescription:h.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:h.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:h.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:h.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:h.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:h.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:h.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(178,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertMode:d(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(ge.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(ge.showIcons,this.defaultValue.showIcons),showStatusBar:t(ge.showStatusBar,this.defaultValue.showStatusBar),preview:t(ge.preview,this.defaultValue.preview),previewMode:d(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(ge.showMethods,this.defaultValue.showMethods),showFunctions:t(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:t(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(ge.showFields,this.defaultValue.showFields),showVariables:t(ge.showVariables,this.defaultValue.showVariables),showClasses:t(ge.showClasses,this.defaultValue.showClasses),showStructs:t(ge.showStructs,this.defaultValue.showStructs),showInterfaces:t(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:t(ge.showModules,this.defaultValue.showModules),showProperties:t(ge.showProperties,this.defaultValue.showProperties),showEvents:t(ge.showEvents,this.defaultValue.showEvents),showOperators:t(ge.showOperators,this.defaultValue.showOperators),showUnits:t(ge.showUnits,this.defaultValue.showUnits),showValues:t(ge.showValues,this.defaultValue.showValues),showConstants:t(ge.showConstants,this.defaultValue.showConstants),showEnums:t(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:t(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(ge.showKeywords,this.defaultValue.showKeywords),showWords:t(ge.showWords,this.defaultValue.showWords),showColors:t(ge.showColors,this.defaultValue.showColors),showFiles:t(ge.showFiles,this.defaultValue.showFiles),showReferences:t(ge.showReferences,this.defaultValue.showReferences),showFolders:t(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:t(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(ge.showSnippets,this.defaultValue.showSnippets),showUsers:t(ge.showUsers,this.defaultValue.showUsers),showIssues:t(ge.showIssues,this.defaultValue.showIssues)}}}class Ue extends _{constructor(){super(111,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(179,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:h.localize(180,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(X.selectSubwords,this.defaultValue.selectSubwords)}}}var $e;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})($e||(e.WrappingIndent=$e={}));class Qe extends _{constructor(){super(135,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[h.localize(181,null),h.localize(182,null),h.localize(183,null),h.localize(184,null)],description:h.localize(185,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,ge,Be){return ge.get(2)===2?0:Be}}class qe extends E{constructor(){super(143)}compute(X,ge,Be){const Me=ge.get(142);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Me.isWordWrapMinified,isViewportWrapping:Me.isViewportWrapping,wrappingColumn:Me.wrappingColumn}}}class Ye extends _{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(35,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:h.localize(186,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:h.localize(187,null),enum:["afterDrop","never"],enumDescriptions:[h.localize(188,null),h.localize(189,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:t(ge.enabled,this.defaultValue.enabled),showDropSelector:d(ge.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ke extends _{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(83,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:h.localize(190,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:h.localize(191,null),enum:["afterPaste","never"],enumDescriptions:[h.localize(192,null),h.localize(193,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:t(ge.enabled,this.defaultValue.enabled),showPasteSelector:d(ge.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",Ze="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Ze:I.isLinux?tt:ct,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var nt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=8]="autoClosingDelete",Z[Z.autoClosingOvertype=9]="autoClosingOvertype",Z[Z.autoClosingQuotes=10]="autoClosingQuotes",Z[Z.autoIndent=11]="autoIndent",Z[Z.automaticLayout=12]="automaticLayout",Z[Z.autoSurround=13]="autoSurround",Z[Z.bracketPairColorization=14]="bracketPairColorization",Z[Z.guides=15]="guides",Z[Z.codeLens=16]="codeLens",Z[Z.codeLensFontFamily=17]="codeLensFontFamily",Z[Z.codeLensFontSize=18]="codeLensFontSize",Z[Z.colorDecorators=19]="colorDecorators",Z[Z.colorDecoratorsLimit=20]="colorDecoratorsLimit",Z[Z.columnSelection=21]="columnSelection",Z[Z.comments=22]="comments",Z[Z.contextmenu=23]="contextmenu",Z[Z.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=25]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=27]="cursorStyle",Z[Z.cursorSurroundingLines=28]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=30]="cursorWidth",Z[Z.disableLayerHinting=31]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",Z[Z.domReadOnly=33]="domReadOnly",Z[Z.dragAndDrop=34]="dragAndDrop",Z[Z.dropIntoEditor=35]="dropIntoEditor",Z[Z.emptySelectionClipboard=36]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=38]="extraEditorClassName",Z[Z.fastScrollSensitivity=39]="fastScrollSensitivity",Z[Z.find=40]="find",Z[Z.fixedOverflowWidgets=41]="fixedOverflowWidgets",Z[Z.folding=42]="folding",Z[Z.foldingStrategy=43]="foldingStrategy",Z[Z.foldingHighlight=44]="foldingHighlight",Z[Z.foldingImportsByDefault=45]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=46]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=48]="fontFamily",Z[Z.fontInfo=49]="fontInfo",Z[Z.fontLigatures=50]="fontLigatures",Z[Z.fontSize=51]="fontSize",Z[Z.fontWeight=52]="fontWeight",Z[Z.fontVariations=53]="fontVariations",Z[Z.formatOnPaste=54]="formatOnPaste",Z[Z.formatOnType=55]="formatOnType",Z[Z.glyphMargin=56]="glyphMargin",Z[Z.gotoLocation=57]="gotoLocation",Z[Z.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",Z[Z.hover=59]="hover",Z[Z.inDiffEditor=60]="inDiffEditor",Z[Z.inlineSuggest=61]="inlineSuggest",Z[Z.letterSpacing=62]="letterSpacing",Z[Z.lightbulb=63]="lightbulb",Z[Z.lineDecorationsWidth=64]="lineDecorationsWidth",Z[Z.lineHeight=65]="lineHeight",Z[Z.lineNumbers=66]="lineNumbers",Z[Z.lineNumbersMinChars=67]="lineNumbersMinChars",Z[Z.linkedEditing=68]="linkedEditing",Z[Z.links=69]="links",Z[Z.matchBrackets=70]="matchBrackets",Z[Z.minimap=71]="minimap",Z[Z.mouseStyle=72]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=74]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=76]="multiCursorModifier",Z[Z.multiCursorPaste=77]="multiCursorPaste",Z[Z.multiCursorLimit=78]="multiCursorLimit",Z[Z.occurrencesHighlight=79]="occurrencesHighlight",Z[Z.overviewRulerBorder=80]="overviewRulerBorder",Z[Z.overviewRulerLanes=81]="overviewRulerLanes",Z[Z.padding=82]="padding",Z[Z.pasteAs=83]="pasteAs",Z[Z.parameterHints=84]="parameterHints",Z[Z.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=87]="quickSuggestions",Z[Z.quickSuggestionsDelay=88]="quickSuggestionsDelay",Z[Z.readOnly=89]="readOnly",Z[Z.readOnlyMessage=90]="readOnlyMessage",Z[Z.renameOnType=91]="renameOnType",Z[Z.renderControlCharacters=92]="renderControlCharacters",Z[Z.renderFinalNewline=93]="renderFinalNewline",Z[Z.renderLineHighlight=94]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=96]="renderValidationDecorations",Z[Z.renderWhitespace=97]="renderWhitespace",Z[Z.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",Z[Z.roundedSelection=99]="roundedSelection",Z[Z.rulers=100]="rulers",Z[Z.scrollbar=101]="scrollbar",Z[Z.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=103]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=104]="scrollPredominantAxis",Z[Z.selectionClipboard=105]="selectionClipboard",Z[Z.selectionHighlight=106]="selectionHighlight",Z[Z.selectOnLineNumbers=107]="selectOnLineNumbers",Z[Z.showFoldingControls=108]="showFoldingControls",Z[Z.showUnused=109]="showUnused",Z[Z.snippetSuggestions=110]="snippetSuggestions",Z[Z.smartSelect=111]="smartSelect",Z[Z.smoothScrolling=112]="smoothScrolling",Z[Z.stickyScroll=113]="stickyScroll",Z[Z.stickyTabStops=114]="stickyTabStops",Z[Z.stopRenderingLineAfter=115]="stopRenderingLineAfter",Z[Z.suggest=116]="suggest",Z[Z.suggestFontSize=117]="suggestFontSize",Z[Z.suggestLineHeight=118]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",Z[Z.suggestSelection=120]="suggestSelection",Z[Z.tabCompletion=121]="tabCompletion",Z[Z.tabIndex=122]="tabIndex",Z[Z.unicodeHighlighting=123]="unicodeHighlighting",Z[Z.unusualLineTerminators=124]="unusualLineTerminators",Z[Z.useShadowDOM=125]="useShadowDOM",Z[Z.useTabStops=126]="useTabStops",Z[Z.wordBreak=127]="wordBreak",Z[Z.wordSeparators=128]="wordSeparators",Z[Z.wordWrap=129]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=132]="wordWrapColumn",Z[Z.wordWrapOverride1=133]="wordWrapOverride1",Z[Z.wordWrapOverride2=134]="wordWrapOverride2",Z[Z.wrappingIndent=135]="wrappingIndent",Z[Z.wrappingStrategy=136]="wrappingStrategy",Z[Z.showDeprecated=137]="showDeprecated",Z[Z.inlayHints=138]="inlayHints",Z[Z.editorClassName=139]="editorClassName",Z[Z.pixelRatio=140]="pixelRatio",Z[Z.tabFocusMode=141]="tabFocusMode",Z[Z.layoutInfo=142]="layoutInfo",Z[Z.wrappingInfo=143]="wrappingInfo",Z[Z.defaultColorDecorators=144]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn"})(nt||(e.EditorOption=nt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(194,null)})),acceptSuggestionOnEnter:Ne(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(195,null),""],markdownDescription:h.localize(196,null)})),accessibilitySupport:Ne(new D),accessibilityPageSize:Ne(new g(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(197,null),tags:["accessibility"]})),ariaLabel:Ne(new r(4,"ariaLabel",h.localize(198,null))),ariaRequired:Ne(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new i(7,"screenReaderAnnounceInlineSuggestion",!0,{description:h.localize(199,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(200,null),h.localize(201,null),""],description:h.localize(202,null)})),autoClosingDelete:Ne(new n(8,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(203,null),""],description:h.localize(204,null)})),autoClosingOvertype:Ne(new n(9,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(205,null),""],description:h.localize(206,null)})),autoClosingQuotes:Ne(new n(10,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(207,null),h.localize(208,null),""],description:h.localize(209,null)})),autoIndent:Ne(new s(11,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[h.localize(210,null),h.localize(211,null),h.localize(212,null),h.localize(213,null),h.localize(214,null)],description:h.localize(215,null)})),automaticLayout:Ne(new i(12,"automaticLayout",!1)),autoSurround:Ne(new n(13,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(216,null),h.localize(217,null),h.localize(218,null),""],description:h.localize(219,null)})),bracketPairColorization:Ne(new oe),bracketPairGuides:Ne(new j),stickyTabStops:Ne(new i(114,"stickyTabStops",!1,{description:h.localize(220,null)})),codeLens:Ne(new i(16,"codeLens",!0,{description:h.localize(221,null)})),codeLensFontFamily:Ne(new r(17,"codeLensFontFamily","",{description:h.localize(222,null)})),codeLensFontSize:Ne(new g(18,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(223,null)})),colorDecorators:Ne(new i(19,"colorDecorators",!0,{description:h.localize(224,null)})),colorDecoratorActivatedOn:Ne(new n(145,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[h.localize(225,null),h.localize(226,null),h.localize(227,null)],description:h.localize(228,null)})),colorDecoratorsLimit:Ne(new g(20,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:h.localize(229,null)})),columnSelection:Ne(new i(21,"columnSelection",!1,{description:h.localize(230,null)})),comments:Ne(new u),contextmenu:Ne(new i(23,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new i(24,"copyWithSyntaxHighlighting",!0,{description:h.localize(231,null)})),cursorBlinking:Ne(new s(25,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:h.localize(232,null)})),cursorSmoothCaretAnimation:Ne(new n(26,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[h.localize(233,null),h.localize(234,null),h.localize(235,null)],description:h.localize(236,null)})),cursorStyle:Ne(new s(27,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:h.localize(237,null)})),cursorSurroundingLines:Ne(new g(28,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(238,null)})),cursorSurroundingLinesStyle:Ne(new n(29,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(239,null),h.localize(240,null)],description:h.localize(241,null)})),cursorWidth:Ne(new g(30,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(242,null)})),disableLayerHinting:Ne(new i(31,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new i(32,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new i(33,"domReadOnly",!1)),dragAndDrop:Ne(new i(34,"dragAndDrop",!0,{description:h.localize(243,null)})),emptySelectionClipboard:Ne(new $),dropIntoEditor:Ne(new Ye),stickyScroll:Ne(new ne),experimentalWhitespaceRendering:Ne(new n(37,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[h.localize(244,null),h.localize(245,null),h.localize(246,null)],description:h.localize(247,null)})),extraEditorClassName:Ne(new r(38,"extraEditorClassName","")),fastScrollSensitivity:Ne(new k(39,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:h.localize(248,null)})),find:Ne(new H),fixedOverflowWidgets:Ne(new i(41,"fixedOverflowWidgets",!1)),folding:Ne(new i(42,"folding",!0,{description:h.localize(249,null)})),foldingStrategy:Ne(new n(43,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(250,null),h.localize(251,null)],description:h.localize(252,null)})),foldingHighlight:Ne(new i(44,"foldingHighlight",!0,{description:h.localize(253,null)})),foldingImportsByDefault:Ne(new i(45,"foldingImportsByDefault",!1,{description:h.localize(254,null)})),foldingMaximumRegions:Ne(new g(46,"foldingMaximumRegions",5e3,10,65e3,{description:h.localize(255,null)})),unfoldOnClickAfterEndOfLine:Ne(new i(47,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(256,null)})),fontFamily:Ne(new r(48,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(257,null)})),fontInfo:Ne(new N),fontLigatures2:Ne(new x),fontSize:Ne(new ae),fontWeight:Ne(new Y),fontVariations:Ne(new U),formatOnPaste:Ne(new i(54,"formatOnPaste",!1,{description:h.localize(258,null)})),formatOnType:Ne(new i(55,"formatOnType",!1,{description:h.localize(259,null)})),glyphMargin:Ne(new i(56,"glyphMargin",!0,{description:h.localize(260,null)})),gotoLocation:Ne(new Ee),hideCursorInOverviewRuler:Ne(new i(58,"hideCursorInOverviewRuler",!1,{description:h.localize(261,null)})),hover:Ne(new ye),inDiffEditor:Ne(new i(60,"inDiffEditor",!1)),letterSpacing:Ne(new k(62,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>k.clamp(Z,-5,20),{description:h.localize(262,null)})),lightbulb:Ne(new ue),lineDecorationsWidth:Ne(new le),lineHeight:Ne(new F),lineNumbers:Ne(new fe),lineNumbersMinChars:Ne(new g(67,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new i(68,"linkedEditing",!1,{description:h.localize(263,null)})),links:Ne(new i(69,"links",!0,{description:h.localize(264,null)})),matchBrackets:Ne(new n(70,"matchBrackets","always",["always","near","never"],{description:h.localize(265,null)})),minimap:Ne(new J),mouseStyle:Ne(new n(72,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new k(73,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:h.localize(266,null)})),mouseWheelZoom:Ne(new i(74,"mouseWheelZoom",!1,{markdownDescription:h.localize(267,null)})),multiCursorMergeOverlapping:Ne(new i(75,"multiCursorMergeOverlapping",!0,{description:h.localize(268,null)})),multiCursorModifier:Ne(new s(76,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Se,{markdownEnumDescriptions:[h.localize(269,null),h.localize(270,null)],markdownDescription:h.localize(271,null)})),multiCursorPaste:Ne(new n(77,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(272,null),h.localize(273,null)],markdownDescription:h.localize(274,null)})),multiCursorLimit:Ne(new g(78,"multiCursorLimit",1e4,1,1e5,{markdownDescription:h.localize(275,null)})),occurrencesHighlight:Ne(new i(79,"occurrencesHighlight",!0,{description:h.localize(276,null)})),overviewRulerBorder:Ne(new i(80,"overviewRulerBorder",!0,{description:h.localize(277,null)})),overviewRulerLanes:Ne(new g(81,"overviewRulerLanes",3,0,3)),padding:Ne(new ke),pasteAs:Ne(new Ke),parameterHints:Ne(new Ce),peekWidgetDefaultFocus:Ne(new n(85,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(278,null),h.localize(279,null)],description:h.localize(280,null)})),definitionLinkOpensInPeek:Ne(new i(86,"definitionLinkOpensInPeek",!1,{description:h.localize(281,null)})),quickSuggestions:Ne(new Ie),quickSuggestionsDelay:Ne(new g(88,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(282,null)})),readOnly:Ne(new i(89,"readOnly",!1)),readOnlyMessage:Ne(new de),renameOnType:Ne(new i(91,"renameOnType",!1,{description:h.localize(283,null),markdownDeprecationMessage:h.localize(284,null)})),renderControlCharacters:Ne(new i(92,"renderControlCharacters",!0,{description:h.localize(285,null),restricted:!0})),renderFinalNewline:Ne(new n(93,"renderFinalNewline",I.isLinux?"dimmed":"on",["off","on","dimmed"],{description:h.localize(286,null)})),renderLineHighlight:Ne(new n(94,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(287,null)],description:h.localize(288,null)})),renderLineHighlightOnlyWhenFocus:Ne(new i(95,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(289,null)})),renderValidationDecorations:Ne(new n(96,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new n(97,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(290,null),h.localize(291,null),h.localize(292,null),""],description:h.localize(293,null)})),revealHorizontalRightPadding:Ne(new g(98,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new i(99,"roundedSelection",!0,{description:h.localize(294,null)})),rulers:Ne(new ie),scrollbar:Ne(new W),scrollBeyondLastColumn:Ne(new g(102,"scrollBeyondLastColumn",4,0,1073741824,{description:h.localize(295,null)})),scrollBeyondLastLine:Ne(new i(103,"scrollBeyondLastLine",!0,{description:h.localize(296,null)})),scrollPredominantAxis:Ne(new i(104,"scrollPredominantAxis",!0,{description:h.localize(297,null)})),selectionClipboard:Ne(new i(105,"selectionClipboard",!0,{description:h.localize(298,null),included:I.isLinux})),selectionHighlight:Ne(new i(106,"selectionHighlight",!0,{description:h.localize(299,null)})),selectOnLineNumbers:Ne(new i(107,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new n(108,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[h.localize(300,null),h.localize(301,null),h.localize(302,null)],description:h.localize(303,null)})),showUnused:Ne(new i(109,"showUnused",!0,{description:h.localize(304,null)})),showDeprecated:Ne(new i(137,"showDeprecated",!0,{description:h.localize(305,null)})),inlayHints:Ne(new he),snippetSuggestions:Ne(new n(110,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(306,null),h.localize(307,null),h.localize(308,null),h.localize(309,null)],description:h.localize(310,null)})),smartSelect:Ne(new Ue),smoothScrolling:Ne(new i(112,"smoothScrolling",!1,{description:h.localize(311,null)})),stopRenderingLineAfter:Ne(new g(115,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new ve),inlineSuggest:Ne(new q),suggestFontSize:Ne(new g(117,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(312,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new g(118,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(313,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new i(119,"suggestOnTriggerCharacters",!0,{description:h.localize(314,null)})),suggestSelection:Ne(new n(120,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(315,null),h.localize(316,null),h.localize(317,null)],description:h.localize(318,null)})),tabCompletion:Ne(new n(121,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(319,null),h.localize(320,null),h.localize(321,null)],description:h.localize(322,null)})),tabIndex:Ne(new g(122,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new V),unusualLineTerminators:Ne(new n(124,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(323,null),h.localize(324,null),h.localize(325,null)],description:h.localize(326,null)})),useShadowDOM:Ne(new i(125,"useShadowDOM",!0)),useTabStops:Ne(new i(126,"useTabStops",!0,{description:h.localize(327,null)})),wordBreak:Ne(new n(127,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[h.localize(328,null),h.localize(329,null)],description:h.localize(330,null)})),wordSeparators:Ne(new r(128,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:h.localize(331,null)})),wordWrap:Ne(new n(129,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(332,null),h.localize(333,null),h.localize(334,null),h.localize(335,null)],description:h.localize(336,null)})),wordWrapBreakAfterCharacters:Ne(new r(130,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new r(131,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new g(132,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(337,null)})),wordWrapOverride1:Ne(new n(133,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new n(134,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new z),defaultColorDecorators:Ne(new i(144,"defaultColorDecorators",!1,{markdownDescription:h.localize(338,null)})),pixelRatio:Ne(new _e),tabFocusMode:Ne(new i(141,"tabFocusMode",!1,{markdownDescription:h.localize(339,null)})),layoutInfo:Ne(new K),wrappingInfo:Ne(new qe),wrappingIndent:Ne(new Qe),wrappingStrategy:Ne(new Q)}}),define(Pe[137],Ae([9,10]),function(pe,e){return pe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[138],Ae([9,10]),function(pe,e){return pe.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[139],Ae([9,10]),function(pe,e){return pe.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[140],Ae([9,10]),function(pe,e){return pe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[141],Ae([9,10]),function(pe,e){return pe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[142],Ae([9,10]),function(pe,e){return pe.create("vs/platform/files/common/files",e)}),define(Pe[143],Ae([9,10]),function(pe,e){return pe.create("vs/platform/markers/common/markers",e)}),define(Pe[144],Ae([9,10]),function(pe,e){return pe.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[145],Ae([9,10]),function(pe,e){return pe.create("vs/platform/workspace/common/workspace",e)}),define(Pe[146],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostChat",e)}),define(Pe[147],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[148],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[149],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[150],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[151],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[152],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[153],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[154],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[155],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[156],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[157],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[158],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[159],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/common/editor",e)}),define(Pe[160],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/common/views",e)}),define(Pe[161],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[162],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[163],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[164],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[165],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[166],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[167],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[168],Ae([1,0,11,139]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var I;(function(p){p[p.LParen=0]="LParen",p[p.RParen=1]="RParen",p[p.Neg=2]="Neg",p[p.Eq=3]="Eq",p[p.NotEq=4]="NotEq",p[p.Lt=5]="Lt",p[p.LtEq=6]="LtEq",p[p.Gt=7]="Gt",p[p.GtEq=8]="GtEq",p[p.RegexOp=9]="RegexOp",p[p.RegexStr=10]="RegexStr",p[p.True=11]="True",p[p.False=12]="False",p[p.In=13]="In",p[p.Not=14]="Not",p[p.And=15]="And",p[p.Or=16]="Or",p[p.Str=17]="Str",p[p.QuotedStr=18]="QuotedStr",p[p.Error=19]="Error",p[p.EOF=20]="EOF"})(I||(e.TokenType=I={}));function M(...p){switch(p.length){case 1:return(0,O.localize)(0,null,p[0]);case 2:return(0,O.localize)(1,null,p[0],p[1]);case 3:return(0,O.localize)(2,null,p[0],p[1],p[2]);default:return}}const T=(0,O.localize)(3,null),h=(0,O.localize)(4,null);class y{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,w.illegalState)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(A){return this._input=A,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const _=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:_})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const _=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:_})}else this._match(126)?this._addToken(9):this._error(M("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(M("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(A){return this._isAtEnd()||this._input.charCodeAt(this._current)!==A?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(A){this._tokens.push({type:A,offset:this._start})}_error(A){const _=this._start,c=this._input.substring(this._start,this._current),S={type:19,offset:this._start,lexeme:c};this._errors.push({offset:_,lexeme:c,additionalInfo:A}),this._tokens.push(S)}_string(){this.stringRe.lastIndex=this._start;const A=this.stringRe.exec(this._input);if(A){this._current=this._start+A[0].length;const _=this._input.substring(this._start,this._current),c=y._keywords.get(_);c?this._addToken(c):this._tokens.push({type:17,lexeme:_,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let A=this._current,_=!1,c=!1;for(;;){if(A>=this._input.length){this._current=A,this._error(h);return}const E=this._input.charCodeAt(A);if(_)_=!1;else if(E===47&&!c){A++;break}else E===91?c=!0:E===92?_=!0:E===93&&(c=!1);A++}for(;A<this._input.length&&y._regexFlags.has(this._input.charCodeAt(A));)A++;this._current=A;const S=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:S,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=y}),define(Pe[169],Ae([1,0,23,29,141,272]),function(pe,e,w,O,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,h=/^-(\d{4})(\d{2})(\d{2})$/;function y(i){return i=i.trim(),i==="*"||T.test(i)}e.isValidVersionStr=y;function p(i){if(!y(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=i.match(T);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.parseVersion=p;function A(i){if(!i)return null;const a=i.majorBase,g=i.majorMustEqual,C=i.minorBase;let k=i.minorMustEqual;const r=i.patchBase;let d=i.patchMustEqual;i.hasCaret&&(a===0||(k=!1),d=!1);let n=0;if(i.preRelease){const s=h.exec(i.preRelease);if(s){const[,v,D,u]=s;n=Date.UTC(Number(v),Number(D)-1,Number(u))}}return{majorBase:a,majorMustEqual:g,minorBase:C,minorMustEqual:k,patchBase:r,patchMustEqual:d,isMinimum:i.hasGreaterEquals,notBefore:n}}e.normalizeVersion=A;function _(i,a,g){let C;typeof i=="string"?C=A(p(i)):C=i;let k;a instanceof Date?k=a.getTime():typeof a=="string"&&(k=new Date(a).getTime());let r;if(typeof g=="string"?r=A(p(g)):r=g,!C||!r)return!1;const d=C.majorBase,n=C.minorBase,s=C.patchBase;let v=r.majorBase,D=r.minorBase,u=r.patchBase;const m=r.notBefore;let b=r.majorMustEqual,l=r.minorMustEqual,f=r.patchMustEqual;return r.isMinimum?d>v?!0:d<v?!1:n>D?!0:n<D||k&&k<m?!1:s>=u:(d===1&&v===0&&(!b||!l||!f)&&(v=1,D=0,u=0,b=!0,l=!1,f=!1),d<v?!1:d>v?!b:n<D?!1:n>D?!l:s<u?!1:s>u?!f:!(k&&k<m))}e.isValidVersion=_;function c(i,a,g,C,k){const r=[];if(typeof C.publisher<"u"&&typeof C.publisher!="string")return r.push([O.default.Error,I.localize(0,null)]),r;if(typeof C.name!="string")return r.push([O.default.Error,I.localize(1,null,"name")]),r;if(typeof C.version!="string")return r.push([O.default.Error,I.localize(2,null,"version")]),r;if(!C.engines)return r.push([O.default.Error,I.localize(3,null,"engines")]),r;if(typeof C.engines.vscode!="string")return r.push([O.default.Error,I.localize(4,null,"engines.vscode")]),r;if(typeof C.extensionDependencies<"u"&&!t(C.extensionDependencies))return r.push([O.default.Error,I.localize(5,null,"extensionDependencies")]),r;if(typeof C.activationEvents<"u"){if(!t(C.activationEvents))return r.push([O.default.Error,I.localize(6,null,"activationEvents")]),r;if(typeof C.main>"u"&&typeof C.browser>"u")return r.push([O.default.Error,I.localize(7,null,"activationEvents","main","browser")]),r}if(typeof C.extensionKind<"u"&&typeof C.main>"u"&&r.push([O.default.Warning,I.localize(8,null,"extensionKind")]),typeof C.main<"u"){if(typeof C.main!="string")return r.push([O.default.Error,I.localize(9,null,"main")]),r;{const s=(0,w.joinPath)(g,C.main);(0,w.isEqualOrParent)(s,g)||r.push([O.default.Warning,I.localize(10,null,s.path,g.path)])}}if(typeof C.browser<"u"){if(typeof C.browser!="string")return r.push([O.default.Error,I.localize(11,null,"browser")]),r;{const s=(0,w.joinPath)(g,C.browser);(0,w.isEqualOrParent)(s,g)||r.push([O.default.Warning,I.localize(12,null,s.path,g.path)])}}if(!M.valid(C.version))return r.push([O.default.Error,I.localize(13,null)]),r;const d=[];if(!S(i,a,C,k,d))for(const s of d)r.push([O.default.Error,s]);return r}e.validateExtensionManifest=c;function S(i,a,g,C,k){return C||typeof g.main>"u"&&typeof g.browser>"u"?!0:o(i,a,g.engines.vscode,k)}e.isValidExtensionVersion=S;function E(i,a,g){return i==="*"||o(a,g,i)}e.isEngineValid=E;function o(i,a,g,C=[]){const k=A(p(g));if(!k)return C.push(I.localize(14,null,g)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return C.push(I.localize(15,null,g)),!1}else if(!k.majorMustEqual)return C.push(I.localize(16,null,g)),!1;return _(i,a,k)?!0:(C.push(I.localize(17,null,i,g)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let a=0,g=i.length;a<g;a++)if(typeof i[a]!="string")return!1;return!0}}),define(Pe[71],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(I,M=[],T=!1){this.ctor=I,this.staticArguments=M,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=w}),define(Pe[72],Ae([1,0,71]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var I;(function(h){h[h.Eager=0]="Eager",h[h.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function M(h,y,p){y instanceof w.SyncDescriptor||(y=new w.SyncDescriptor(y,[],!!p)),O.push([h,y])}e.registerSingleton=M;function T(){return O}e.getSingletonServiceDescriptors=T}),define(Pe[170],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(M,T){this.key=M,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=w;class O{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(const T of this._nodes.values())T.outgoing.size===0&&M.push(T);return M}insertEdge(M,T){const h=this.lookupOrInsertNode(M),y=this.lookupOrInsertNode(T);h.outgoing.set(y.key,y),y.incoming.set(h.key,h)}removeNode(M){const T=this._hashFn(M);this._nodes.delete(T);for(const h of this._nodes.values())h.outgoing.delete(T),h.incoming.delete(T)}lookupOrInsertNode(M){const T=this._hashFn(M);let h=this._nodes.get(T);return h||(h=new w(T,M),this._nodes.set(T,h)),h}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){const M=[];for(const[T,h]of this._nodes)M.push(`${T}
	(-> incoming)[${[...h.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...h.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,T]of this._nodes){const h=new Set([M]),y=this._findCycle(T,h);if(y)return y}}_findCycle(M,T){for(const[h,y]of M.outgoing){if(T.has(h))return[...T,h].join(" -> ");T.add(h);const p=this._findCycle(y,T);if(p)return p;T.delete(h)}}}e.Graph=O}),define(Pe[3],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function h(y){return y[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=h})(w||(e._util=w={})),e.IInstantiationService=I("instantiationService");function O(T,h,y){h[w.DI_TARGET]===h?h[w.DI_DEPENDENCIES].push({id:T,index:y}):(h[w.DI_DEPENDENCIES]=[{id:T,index:y}],h[w.DI_TARGET]=h)}function I(T){if(w.serviceIds.has(T))return w.serviceIds.get(T);const h=function(y,p,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(h,y,A)};return h.toString=()=>T,w.serviceIds.set(T,h),h}e.createDecorator=I;function M(T){return T}e.refineServiceDecorator=M}),define(Pe[43],Ae([1,0,12,2,3]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function M(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof O.URI)}e.isConfigurationOverrides=M;function T(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=T;var h;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(h||(e.ConfigurationTarget=h={}));function y(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function p(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.isConfigured=p;function A(i,a){const g=Object.create(null);for(const C in i)_(g,C,i[C],a);return g}e.toValuesTree=A;function _(i,a,g,C){const k=a.split("."),r=k.pop();let d=i;for(let n=0;n<k.length;n++){const s=k[n];let v=d[s];switch(typeof v){case"undefined":v=d[s]=Object.create(null);break;case"object":break;default:C(`Ignoring ${a} as ${k.slice(0,n+1).join(".")} is ${JSON.stringify(v)}`);return}d=v}if(typeof d=="object"&&d!==null)try{d[r]=g}catch{C(`Ignoring ${a} as ${k.join(".")} is ${JSON.stringify(d)}`)}else C(`Ignoring ${a} as ${k.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=_;function c(i,a){const g=a.split(".");S(i,g)}e.removeFromValueTree=c;function S(i,a){const g=a.shift();if(a.length===0){delete i[g];return}if(Object.keys(i).indexOf(g)!==-1){const C=i[g];typeof C=="object"&&!Array.isArray(C)&&(S(C,a),Object.keys(C).length===0&&delete i[g])}}function E(i,a,g){function C(d,n){let s=d;for(const v of n){if(typeof s!="object"||s===null)return;s=s[v]}return s}const k=a.split("."),r=C(i,k);return typeof r>"u"?g:r}e.getConfigurationValue=E;function o(i,a,g){Object.keys(a).forEach(C=>{C!=="__proto__"&&(C in i?w.isObject(i[C])&&w.isObject(a[C])?o(i[C],a[C],g):g&&(i[C]=a[C]):i[C]=a[C])})}e.merge=o;function t(i){return i.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=t}),define(Pe[31],Ae([1,0,22,15,168,3,138,11]),function(pe,e,w,O,I,M,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",w.isMacintosh),y.set("isLinux",w.isLinux),y.set("isWindows",w.isWindows),y.set("isWeb",w.isWeb),y.set("isMacNative",w.isMacintosh&&!w.isWeb),y.set("isEdge",w.isEdge),y.set("isFirefox",w.isFirefox),y.set("isChrome",w.isChrome),y.set("isSafari",w.isSafari);function p(le,F){if(y.get(le)!==void 0)throw(0,h.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(le,F)}e.setConstant=p;const A=Object.prototype.hasOwnProperty;var _;(function(le){le[le.False=0]="False",le[le.True=1]="True",le[le.Defined=2]="Defined",le[le.Not=3]="Not",le[le.Equals=4]="Equals",le[le.NotEquals=5]="NotEquals",le[le.And=6]="And",le[le.Regex=7]="Regex",le[le.NotRegex=8]="NotRegex",le[le.Or=9]="Or",le[le.In=10]="In",le[le.NotIn=11]="NotIn",le[le.Greater=12]="Greater",le[le.GreaterEquals=13]="GreaterEquals",le[le.Smaller=14]="Smaller",le[le.SmallerEquals=15]="SmallerEquals"})(_||(e.ContextKeyExprType=_={}));const c={regexParsingWithErrorRecovery:!0},S=(0,T.localize)(0,null),E=(0,T.localize)(1,null),o=(0,T.localize)(2,null),t=(0,T.localize)(3,null),i=(0,T.localize)(4,null),a=(0,T.localize)(5,null),g=(0,T.localize)(6,null),C=(0,T.localize)(7,null);class k{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(F=c){this._config=F,this._scanner=new I.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(F){if(F===""){this._parsingErrors.push({message:S,offset:0,lexeme:"",additionalInfo:E});return}this._tokens=this._scanner.reset(F).scan(),this._current=0,this._parsingErrors=[];try{const J=this._expr();if(!this._isAtEnd()){const Se=this._peek(),ke=Se.type===17?a:void 0;throw this._parsingErrors.push({message:i,offset:Se.offset,lexeme:I.Scanner.getLexeme(Se),additionalInfo:ke}),k._parseError}return J}catch(J){if(J!==k._parseError)throw J;return}}_expr(){return this._or()}_or(){const F=[this._and()];for(;this._matchOne(16);){const J=this._and();F.push(J)}return F.length===1?F[0]:r.or(...F)}_and(){const F=[this._term()];for(;this._matchOne(15);){const J=this._term();F.push(J)}return F.length===1?F[0]:r.and(...F)}_term(){if(this._matchOne(2)){const F=this._peek();switch(F.type){case 11:return this._advance(),v.INSTANCE;case 12:return this._advance(),D.INSTANCE;case 0:{this._advance();const J=this._expr();return this._consume(1,t),J?.negate()}case 17:return this._advance(),P.create(F.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",F)}}return this._primary()}_primary(){const F=this._peek();switch(F.type){case 11:return this._advance(),r.true();case 12:return this._advance(),r.false();case 0:{this._advance();const J=this._expr();return this._consume(1,t),J}case 17:{const J=F.lexeme;if(this._advance(),this._matchOne(9)){const ke=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),ke.type!==10)throw this._errExpectedButGot("REGEX",ke);const Ce=ke.lexeme,_e=Ce.lastIndexOf("/"),Ie=_e===Ce.length-1?void 0:this._removeFlagsGY(Ce.substring(_e+1));let se;try{se=new RegExp(Ce.substring(1,_e),Ie)}catch{throw this._errExpectedButGot("REGEX",ke)}return N.create(J,se)}switch(ke.type){case 10:case 19:{const Ce=[ke.lexeme];this._advance();let _e=this._peek(),Ie=0;for(let de=0;de<ke.lexeme.length;de++)ke.lexeme.charCodeAt(de)===40?Ie++:ke.lexeme.charCodeAt(de)===41&&Ie--;for(;!this._isAtEnd()&&_e.type!==15&&_e.type!==16;){switch(_e.type){case 0:Ie++;break;case 1:Ie--;break;case 10:case 18:for(let de=0;de<_e.lexeme.length;de++)_e.lexeme.charCodeAt(de)===40?Ie++:ke.lexeme.charCodeAt(de)===41&&Ie--}if(Ie<0)break;Ce.push(I.Scanner.getLexeme(_e)),this._advance(),_e=this._peek()}const se=Ce.join(""),fe=se.lastIndexOf("/"),ee=fe===se.length-1?void 0:this._removeFlagsGY(se.substring(fe+1));let ie;try{ie=new RegExp(se.substring(1,fe),ee)}catch{throw this._errExpectedButGot("REGEX",ke)}return r.regex(J,ie)}case 18:{const Ce=ke.lexeme;this._advance();let _e=null;if(!(0,O.isFalsyOrWhitespace)(Ce)){const Ie=Ce.indexOf("/"),se=Ce.lastIndexOf("/");if(Ie!==se&&Ie>=0){const fe=Ce.slice(Ie+1,se),ee=Ce[se+1]==="i"?"i":"";try{_e=new RegExp(fe,ee)}catch{throw this._errExpectedButGot("REGEX",ke)}}}if(_e===null)throw this._errExpectedButGot("REGEX",ke);return N.create(J,_e)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,o);const ke=this._value();return r.notIn(J,ke)}switch(this._peek().type){case 3:{this._advance();const ke=this._value();if(this._previous().type===18)return r.equals(J,ke);switch(ke){case"true":return r.has(J);case"false":return r.not(J);default:return r.equals(J,ke)}}case 4:{this._advance();const ke=this._value();if(this._previous().type===18)return r.notEquals(J,ke);switch(ke){case"true":return r.not(J);case"false":return r.has(J);default:return r.notEquals(J,ke)}}case 5:return this._advance(),x.create(J,this._value());case 6:return this._advance(),U.create(J,this._value());case 7:return this._advance(),$.create(J,this._value());case 8:return this._advance(),H.create(J,this._value());case 13:return this._advance(),r.in(J,this._value());default:return r.has(J)}}case 20:throw this._parsingErrors.push({message:g,offset:F.offset,lexeme:"",additionalInfo:C}),k._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const F=this._peek();switch(F.type){case 17:case 18:return this._advance(),F.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(F){return F.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(F){return this._check(F)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(F,J){if(this._check(F))return this._advance();throw this._errExpectedButGot(J,this._peek())}_errExpectedButGot(F,J,Se){const ke=(0,T.localize)(8,null,F,I.Scanner.getLexeme(J)),Ce=J.offset,_e=I.Scanner.getLexeme(J);return this._parsingErrors.push({message:ke,offset:Ce,lexeme:_e,additionalInfo:Se}),k._parseError}_check(F){return this._peek().type===F}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=k;class r{static false(){return v.INSTANCE}static true(){return D.INSTANCE}static has(F){return u.create(F)}static equals(F,J){return m.create(F,J)}static notEquals(F,J){return f.create(F,J)}static regex(F,J){return N.create(F,J)}static in(F,J){return b.create(F,J)}static notIn(F,J){return l.create(F,J)}static not(F){return P.create(F)}static and(...F){return Ee.create(F,null,!0)}static or(...F){return ye.create(F,null,!0)}static greater(F,J){return $.create(F,J)}static greaterEquals(F,J){return H.create(F,J)}static smaller(F,J){return x.create(F,J)}static smallerEquals(F,J){return U.create(F,J)}static{this._parser=new k({regexParsingWithErrorRecovery:!1})}static deserialize(F){return F==null?void 0:this._parser.parse(F)}}e.ContextKeyExpr=r;function d(le){const F=new k({regexParsingWithErrorRecovery:!1});return le.map(J=>(F.parse(J),F.lexingErrors.length>0?F.lexingErrors.map(Se=>({errorMessage:Se.additionalInfo?(0,T.localize)(9,null,Se.additionalInfo):(0,T.localize)(10,null),offset:Se.offset,length:Se.lexeme.length})):F.parsingErrors.length>0?F.parsingErrors.map(Se=>({errorMessage:Se.additionalInfo?`${Se.message}. ${Se.additionalInfo}`:Se.message,offset:Se.offset,length:Se.lexeme.length})):[]))}e.validateWhenClauses=d;function n(le,F){const J=le?le.substituteConstants():void 0,Se=F?F.substituteConstants():void 0;return!J&&!Se?!0:!J||!Se?!1:J.equals(Se)}e.expressionsAreEqualWithConstantSubstitution=n;function s(le,F){return le.cmp(F)}class v{static{this.INSTANCE=new v}constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return D.INSTANCE}}e.ContextKeyFalseExpr=v;class D{static{this.INSTANCE=new D}constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return v.INSTANCE}}e.ContextKeyTrueExpr=D;class u{static create(F,J=null){const Se=y.get(F);return typeof Se=="boolean"?Se?D.INSTANCE:v.INSTANCE:new u(F,J)}constructor(F,J){this.key=F,this.negated=J,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:K(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=y.get(this.key);return typeof F=="boolean"?F?D.INSTANCE:v.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=P.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=u;class m{static create(F,J,Se=null){if(typeof J=="boolean")return J?u.create(F,Se):P.create(F,Se);const ke=y.get(F);return typeof ke=="boolean"?J===(ke?"true":"false")?D.INSTANCE:v.INSTANCE:new m(F,J,Se)}constructor(F,J,Se){this.key=F,this.value=J,this.negated=Se,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:Q(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=y.get(this.key);if(typeof F=="boolean"){const J=F?"true":"false";return this.value===J?D.INSTANCE:v.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=m;class b{static create(F,J){return new b(F,J)}constructor(F,J){this.key=F,this.valueKey=J,this.type=10,this.negated=null}cmp(F){return F.type!==this.type?this.type-F.type:Q(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const J=F.getValue(this.valueKey),Se=F.getValue(this.key);return Array.isArray(J)?J.includes(Se):typeof Se=="string"&&typeof J=="object"&&J!==null?A.call(J,Se):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=l.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=b;class l{static create(F,J){return new l(F,J)}constructor(F,J){this.key=F,this.valueKey=J,this.type=11,this._negated=b.create(F,J)}cmp(F){return F.type!==this.type?this.type-F.type:this._negated.cmp(F._negated)}equals(F){return F.type===this.type?this._negated.equals(F._negated):!1}substituteConstants(){return this}evaluate(F){return!this._negated.evaluate(F)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(F){return F.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=l;class f{static create(F,J,Se=null){if(typeof J=="boolean")return J?P.create(F,Se):u.create(F,Se);const ke=y.get(F);return typeof ke=="boolean"?J===(ke?"true":"false")?v.INSTANCE:D.INSTANCE:new f(F,J,Se)}constructor(F,J,Se){this.key=F,this.value=J,this.negated=Se,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:Q(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=y.get(this.key);if(typeof F=="boolean"){const J=F?"true":"false";return this.value===J?v.INSTANCE:D.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=f;class P{static create(F,J=null){const Se=y.get(F);return typeof Se=="boolean"?Se?v.INSTANCE:D.INSTANCE:new P(F,J)}constructor(F,J){this.key=F,this.negated=J,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:K(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=y.get(this.key);return typeof F=="boolean"?F?v.INSTANCE:D.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=u.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=P;function z(le,F){if(typeof le=="string"){const J=parseFloat(le);isNaN(J)||(le=J)}return typeof le=="string"||typeof le=="number"?F(le):v.INSTANCE}class ${static create(F,J,Se=null){return z(J,ke=>new $(F,ke,Se))}constructor(F,J,Se){this.key=F,this.value=J,this.negated=Se,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:Q(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=$;class H{static create(F,J,Se=null){return z(J,ke=>new H(F,ke,Se))}constructor(F,J,Se){this.key=F,this.value=J,this.negated=Se,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:Q(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=H;class x{static create(F,J,Se=null){return z(J,ke=>new x(F,ke,Se))}constructor(F,J,Se){this.key=F,this.value=J,this.negated=Se,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:Q(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=x;class U{static create(F,J,Se=null){return z(J,ke=>new U(F,ke,Se))}constructor(F,J,Se){this.key=F,this.value=J,this.negated=Se,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:Q(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=U;class N{static create(F,J){return new N(F,J)}constructor(F,J){this.key=F,this.regexp=J,this.type=7,this.negated=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const J=this.regexp?this.regexp.source:"",Se=F.regexp?F.regexp.source:"";return J<Se?-1:J>Se?1:0}equals(F){if(F.type===this.type){const J=this.regexp?this.regexp.source:"",Se=F.regexp?F.regexp.source:"";return this.key===F.key&&J===Se}return!1}substituteConstants(){return this}evaluate(F){const J=F.getValue(this.key);return this.regexp?this.regexp.test(J):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ae.create(this)),this.negated}}e.ContextKeyRegexExpr=N;class ae{static create(F){return new ae(F)}constructor(F){this._actual=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(F){return new ae(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ae;function Y(le){let F=null;for(let J=0,Se=le.length;J<Se;J++){const ke=le[J].substituteConstants();if(le[J]!==ke&&F===null){F=[];for(let Ce=0;Ce<J;Ce++)F[Ce]=le[Ce]}F!==null&&(F[J]=ke)}return F===null?le:F}class Ee{static create(F,J,Se){return Ee._normalizeArr(F,J,Se)}constructor(F,J){this.expr=F,this.negated=J,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let J=0,Se=this.expr.length;J<Se;J++){const ke=s(this.expr[J],F.expr[J]);if(ke!==0)return ke}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let J=0,Se=this.expr.length;J<Se;J++)if(!this.expr[J].equals(F.expr[J]))return!1;return!0}return!1}substituteConstants(){const F=Y(this.expr);return F===this.expr?this:Ee.create(F,this.negated,!1)}evaluate(F){for(let J=0,Se=this.expr.length;J<Se;J++)if(!this.expr[J].evaluate(F))return!1;return!0}static _normalizeArr(F,J,Se){const ke=[];let Ce=!1;for(const _e of F)if(_e){if(_e.type===1){Ce=!0;continue}if(_e.type===0)return v.INSTANCE;if(_e.type===6){ke.push(..._e.expr);continue}ke.push(_e)}if(ke.length===0&&Ce)return D.INSTANCE;if(ke.length!==0){if(ke.length===1)return ke[0];ke.sort(s);for(let _e=1;_e<ke.length;_e++)ke[_e-1].equals(ke[_e])&&(ke.splice(_e,1),_e--);if(ke.length===1)return ke[0];for(;ke.length>1;){const _e=ke[ke.length-1];if(_e.type!==9)break;ke.pop();const Ie=ke.pop(),se=ke.length===0,fe=ye.create(_e.expr.map(ee=>Ee.create([ee,Ie],null,Se)),null,se);fe&&(ke.push(fe),ke.sort(s))}if(ke.length===1)return ke[0];if(Se){for(let _e=0;_e<ke.length;_e++)for(let Ie=_e+1;Ie<ke.length;Ie++)if(ke[_e].negate().equals(ke[Ie]))return v.INSTANCE;if(ke.length===1)return ke[0]}return new Ee(ke,J)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const J of this.expr)F.push(...J.keys());return F}map(F){return new Ee(this.expr.map(J=>J.map(F)),null)}negate(){if(!this.negated){const F=[];for(const J of this.expr)F.push(J.negate());this.negated=ye.create(F,this,!0)}return this.negated}}e.ContextKeyAndExpr=Ee;class ye{static create(F,J,Se){return ye._normalizeArr(F,J,Se)}constructor(F,J){this.expr=F,this.negated=J,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let J=0,Se=this.expr.length;J<Se;J++){const ke=s(this.expr[J],F.expr[J]);if(ke!==0)return ke}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let J=0,Se=this.expr.length;J<Se;J++)if(!this.expr[J].equals(F.expr[J]))return!1;return!0}return!1}substituteConstants(){const F=Y(this.expr);return F===this.expr?this:ye.create(F,this.negated,!1)}evaluate(F){for(let J=0,Se=this.expr.length;J<Se;J++)if(this.expr[J].evaluate(F))return!0;return!1}static _normalizeArr(F,J,Se){let ke=[],Ce=!1;if(F){for(let _e=0,Ie=F.length;_e<Ie;_e++){const se=F[_e];if(se){if(se.type===0){Ce=!0;continue}if(se.type===1)return D.INSTANCE;if(se.type===9){ke=ke.concat(se.expr);continue}ke.push(se)}}if(ke.length===0&&Ce)return v.INSTANCE;ke.sort(s)}if(ke.length!==0){if(ke.length===1)return ke[0];for(let _e=1;_e<ke.length;_e++)ke[_e-1].equals(ke[_e])&&(ke.splice(_e,1),_e--);if(ke.length===1)return ke[0];if(Se){for(let _e=0;_e<ke.length;_e++)for(let Ie=_e+1;Ie<ke.length;Ie++)if(ke[_e].negate().equals(ke[Ie]))return D.INSTANCE;if(ke.length===1)return ke[0]}return new ye(ke,J)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const J of this.expr)F.push(...J.keys());return F}map(F){return new ye(this.expr.map(J=>J.map(F)),null)}negate(){if(!this.negated){const F=[];for(const J of this.expr)F.push(J.negate());for(;F.length>1;){const J=F.shift(),Se=F.shift(),ke=[];for(const Ce of he(J))for(const _e of he(Se))ke.push(Ee.create([Ce,_e],null,!1));F.unshift(ye.create(ke,null,!1))}this.negated=ye.create(F,this,!0)}return this.negated}}e.ContextKeyOrExpr=ye;class Re extends u{static{this._info=[]}static all(){return Re._info.values()}constructor(F,J,Se){super(F,null),this._defaultValue=J,typeof Se=="object"?Re._info.push({...Se,key:F}):Se!==!0&&Re._info.push({key:F,description:Se,type:J!=null?typeof J:void 0})}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return m.create(this.key,F)}notEqualsTo(F){return f.create(this.key,F)}}e.RawContextKey=Re,e.IContextKeyService=(0,M.createDecorator)("contextKeyService");function K(le,F){return le<F?-1:le>F?1:0}function Q(le,F,J,Se){return le<J?-1:le>J?1:F<Se?-1:F>Se?1:0}function ue(le,F){if(le.type===0||F.type===1)return!0;if(le.type===9)return F.type===9?ne(le.expr,F.expr):!1;if(F.type===9){for(const J of F.expr)if(ue(le,J))return!0;return!1}if(le.type===6){if(F.type===6)return ne(F.expr,le.expr);for(const J of le.expr)if(ue(J,F))return!0;return!1}return le.equals(F)}e.implies=ue;function ne(le,F){let J=0,Se=0;for(;J<le.length&&Se<F.length;){const ke=le[J].cmp(F[Se]);if(ke<0)return!1;ke===0&&J++,Se++}return J===le.length}function he(le){return le.type===9?le.expr:[le]}}),define(Pe[171],Ae([1,0,3]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(Pe[92],Ae([1,0,140,3]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function I(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function M(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function T(a,g){switch(a){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":g==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function h(a,g){return g==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=h;function y(a,g,C){return h(g,C)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===C?!0:p(C).includes(a)}e.isTargetPlatformCompatible=y;function p(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=p;function A(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=A;var _;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(_||(e.SortBy=_={}));var c;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(c||(e.SortOrder=c={}));var S;(function(a){a.Install="install",a.Uninstall="uninstall"})(S||(e.StatisticType=S={}));var E;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var o;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(o||(e.ExtensionManagementErrorCode=o={}));var t;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor(g,C){super(g),this.code=C,this.name=C}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,w.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,w.localize)(1,null),original:"Preferences"}}),define(Pe[38],Ae([1,0,48,19,15,12,2,142,3,22,13]),function(pe,e,w,O,I,M,T,h,y,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function _(K){return K.create===!0}e.isFileOpenForWriteOptions=_;var c;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var S;(function(K){K[K.Readonly=1]="Readonly",K[K.Locked=2]="Locked"})(S||(e.FilePermission=S={}));var E;(function(K){K[K.None=0]="None",K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead",K[K.FileAtomicWrite=32768]="FileAtomicWrite",K[K.FileAtomicDelete=65536]="FileAtomicDelete",K[K.FileClone=131072]="FileClone"})(E||(e.FileSystemProviderCapabilities=E={}));function o(K){return!!(K.capabilities&2)}e.hasReadWriteCapability=o;function t(K){return!!(K.capabilities&8)}e.hasFileFolderCopyCapability=t;function i(K){return!!(K.capabilities&131072)}e.hasFileCloneCapability=i;function a(K){return!!(K.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function g(K){return!!(K.capabilities&16)}e.hasFileReadStreamCapability=g;function C(K){return o(K)?!!(K.capabilities&16384):!1}e.hasFileAtomicReadCapability=C;function k(K){return o(K)?!!(K.capabilities&32768):!1}e.hasFileAtomicWriteCapability=k;function r(K){return!!(K.capabilities&65536)}e.hasFileAtomicDeleteCapability=r;function d(K){return!!(K.capabilities&2048)}e.hasReadonlyCapability=d;var n;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsStorageQuota="EntryExceedsStorageQuota",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class s extends Error{static create(Q,ue){const ne=new s(Q.toString(),ue);return u(ne,ue),ne}constructor(Q,ue){super(Q),this.code=ue}}e.FileSystemProviderError=s;function v(K,Q){return s.create(K,Q)}e.createFileSystemProviderError=v;function D(K){return K||v((0,h.localize)(0,null),n.Unknown)}e.ensureFileSystemProviderError=D;function u(K,Q){return K.name=Q?`${Q} (FileSystemError)`:"FileSystemError",K}e.markAsFileSystemProviderError=u;function m(K){if(!K)return n.Unknown;if(K instanceof s)return K.code;const Q=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!Q)return n.Unknown;switch(Q[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.toFileSystemProviderErrorCode=m;function b(K){if(K instanceof H)return K.fileOperationResult;switch(m(K)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=b;var l;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY",K[K.WRITE=4]="WRITE"})(l||(e.FileOperation=l={}));class f{constructor(Q,ue,ne){this.resource=Q,this.operation=ue,this.target=ne}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=f;var P;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(P||(e.FileChangeType=P={}));class z{constructor(Q,ue){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ne=new Map;for(const he of Q){const le=ne.get(he.type);switch(le?le.push([he.resource,he]):ne.set(he.type,[[he.resource,he]]),he.type){case 1:this.rawAdded.push(he.resource);break;case 0:this.rawUpdated.push(he.resource);break;case 2:this.rawDeleted.push(he.resource);break}}for(const[he,le]of ne)switch(he){case 1:this.added=w.TernarySearchTree.forUris(()=>ue),this.added.fill(le);break;case 0:this.updated=w.TernarySearchTree.forUris(()=>ue),this.updated.fill(le);break;case 2:this.deleted=w.TernarySearchTree.forUris(()=>ue),this.deleted.fill(le);break}}contains(Q,...ue){return this.doContains(Q,{includeChildren:!1},...ue)}affects(Q,...ue){return this.doContains(Q,{includeChildren:!0},...ue)}doContains(Q,ue,...ne){if(!Q)return!1;const he=ne.length>0;return!!((!he||ne.includes(1))&&(this.added?.get(Q)||ue.includeChildren&&this.added?.findSuperstr(Q))||(!he||ne.includes(0))&&(this.updated?.get(Q)||ue.includeChildren&&this.updated?.findSuperstr(Q))||(!he||ne.includes(2))&&(this.deleted?.findSubstr(Q)||ue.includeChildren&&this.deleted?.findSuperstr(Q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=z;function $(K,Q,ue){return!K||!Q||K===Q||Q.length>K.length?!1:(Q.charAt(Q.length-1)!==O.sep&&(Q+=O.sep),ue?(0,I.startsWithIgnoreCase)(K,Q):K.indexOf(Q)===0)}e.isParent=$;class H extends Error{constructor(Q,ue,ne){super(Q),this.fileOperationResult=ue,this.options=ne}}e.FileOperationError=H;class x extends H{constructor(Q,ue,ne,he){super(Q,ue,he),this.fileOperationResult=ue,this.size=ne}}e.TooLargeFileOperationError=x;class U extends H{constructor(Q,ue,ne){super(Q,2,ne),this.stat=ue}}e.NotModifiedSinceFileOperationError=U;var N;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(N||(e.FileOperationResult=N={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ae;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae||(e.FileKind=ae={})),e.ETAG_DISABLED="";function Y(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}e.etag=Y;async function Ee(K,Q){if(!Q.hasProvider(T.URI.from({scheme:K.scheme})))return new Promise(ue=>{const ne=Q.onDidChangeFileSystemProviderRegistrations(he=>{he.scheme===K.scheme&&he.added&&(ne.dispose(),ue())})})}e.whenProviderRegistered=Ee;class ye{static{this.KB=1024}static{this.MB=ye.KB*ye.KB}static{this.GB=ye.MB*ye.KB}static{this.TB=ye.GB*ye.KB}static formatSize(Q){return(0,M.isNumber)(Q)||(Q=0),Q<ye.KB?(0,h.localize)(1,null,Q.toFixed(0)):Q<ye.MB?(0,h.localize)(2,null,(Q/ye.KB).toFixed(2)):Q<ye.GB?(0,h.localize)(3,null,(Q/ye.MB).toFixed(2)):Q<ye.TB?(0,h.localize)(4,null,(Q/ye.GB).toFixed(2)):(0,h.localize)(5,null,(Q/ye.TB).toFixed(2))}}e.ByteSize=ye;function Re(K){const Q=typeof K=="string"||K?.scheme===A.Schemas.vscodeRemote;return typeof K!="string"&&K?.scheme===A.Schemas.file?1024*ye.MB:Q?10*ye.MB:p.isWeb?50*ye.MB:1024*ye.MB}e.getLargeFileConfirmationLimit=Re}),define(Pe[73],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...I){this._entries=new Map;for(const[M,T]of I)this.set(M,T)}set(I,M){const T=this._entries.get(I);return this._entries.set(I,M),T}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=w}),define(Pe[172],Ae([1,0,16,11,6,71,170,3,73,173]),function(pe,e,w,O,I,M,T,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const A=!1;class _ extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class c{constructor(t=new y.ServiceCollection,i=!1,a,g=A){this._services=t,this._strict=i,this._parent=a,this._enableTracing=g,this._activeInstantiations=new Set,this._services.set(h.IInstantiationService,this),this._globalGraph=g?a?._globalGraph??new T.Graph(C=>C):void 0}createChild(t){return new c(t,this._strict,this,this._enableTracing)}invokeFunction(t,...i){const a=E.traceInvocation(this._enableTracing,t);let g=!1;try{return t({get:k=>{if(g)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(k,a);if(!r)throw new Error(`[invokeFunction] unknown service '${k}'`);return r}},...i)}finally{g=!0,a.stop()}}createInstance(t,...i){let a,g;return t instanceof M.SyncDescriptor?(a=E.traceCreation(this._enableTracing,t.ctor),g=this._createInstance(t.ctor,t.staticArguments.concat(i),a)):(a=E.traceCreation(this._enableTracing,t),g=this._createInstance(t,i,a)),a.stop(),g}_createInstance(t,i=[],a){const g=h._util.getServiceDependencies(t).sort((r,d)=>r.index-d.index),C=[];for(const r of g){const d=this._getOrCreateServiceInstance(r.id,a);d||this._throwIfStrict(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),C.push(d)}const k=g.length>0?g[0].index:i.length;if(i.length!==k){console.trace(`[createInstance] First service dependency of ${t.name} at position ${k+1} conflicts with ${i.length} static arguments`);const r=k-i.length;r>0?i=i.concat(new Array(r)):i=i.slice(0,k)}return Reflect.construct(t,i.concat(C))}_setServiceInstance(t,i){if(this._services.get(t)instanceof M.SyncDescriptor)this._services.set(t,i);else if(this._parent)this._parent._setServiceInstance(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){const i=this._services.get(t);return!i&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):i}_getOrCreateServiceInstance(t,i){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(t));const a=this._getServiceInstanceOrDescriptor(t);return a instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,a,i.branch(t,!0)):(i.branch(t,!1),a)}_safeCreateAndCacheServiceInstance(t,i,a){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,i,a)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,i,a){const g=new T.Graph(r=>r.id.toString());let C=0;const k=[{id:t,desc:i,_trace:a}];for(;k.length;){const r=k.pop();if(g.lookupOrInsertNode(r),C++>1e3)throw new _(g);for(const d of h._util.getServiceDependencies(r.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(d.id);if(n||this._throwIfStrict(`[createInstance] ${t} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(d.id)),n instanceof M.SyncDescriptor){const s={id:d.id,desc:n,_trace:r._trace.branch(d.id,!0)};g.insertEdge(r,s),k.push(s)}}}for(;;){const r=g.roots();if(r.length===0){if(!g.isEmpty())throw new _(g);break}for(const{data:d}of r){if(this._getServiceInstanceOrDescriptor(d.id)instanceof M.SyncDescriptor){const s=this._createServiceInstanceWithOwner(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this._setServiceInstance(d.id,s)}g.removeNode(d)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,i,a=[],g,C){if(this._services.get(t)instanceof M.SyncDescriptor)return this._createServiceInstance(t,i,a,g,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,i,a,g,C);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}_createServiceInstance(t,i,a=[],g,C){if(g){const k=new c(void 0,this._strict,this,this._enableTracing);k._globalGraphImplicitDependency=String(t);const r=new Map,d=new w.IdleValue(()=>{const n=k._createInstance(i,a,C);for(const[s,v]of r){const D=n[s];if(typeof D=="function")for(const u of v)D.apply(n,u)}return r.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!d.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let u=r.get(s);return u||(u=new p.LinkedList,r.set(s,u)),(b,l,f)=>{const P=u.push([b,l,f]);return(0,I.toDisposable)(P)}}if(s in n)return n[s];const v=d.value;let D=v[s];return typeof D!="function"||(D=D.bind(v),n[s]=D),D},set(n,s,v){return d.value[s]=v,!0},getPrototypeOf(n){return i.prototype}})}else return this._createInstance(i,a,C)}_throwIfStrict(t,i){if(i&&console.warn(t),this._strict)throw new Error(t)}}e.InstantiationService=c;var S;(function(o){o[o.None=0]="None",o[o.Creation=1]="Creation",o[o.Invocation=2]="Invocation",o[o.Branch=3]="Branch"})(S||(S={}));class E{static{this.all=new Set}static{this._None=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new E(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E._None}static traceCreation(t,i){return t?new E(1,i.name):E._None}static{this._totals=0}constructor(t,i){this.type=t,this.name=i,this._start=Date.now(),this._dep=[]}branch(t,i){const a=new E(3,t.toString());return this._dep.push([t,i,a]),a}stop(){const t=Date.now()-this._start;E._totals+=t;let i=!1;function a(C,k){const r=[],d=new Array(C+1).join("	");for(const[n,s,v]of k._dep)if(s&&v){i=!0,r.push(`${d}CREATES -> ${n}`);const D=a(C+1,v);D&&r.push(D)}else r.push(`${d}uses -> ${n}`);return r.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(t>2||i)&&E.all.add(g.join(`
`))}}e.Trace=E}),define(Pe[14],Ae([1,0,41,5,93,6,28,22,23,12,2,31,3]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,c.createDecorator)("logService"),e.ILoggerService=(0,c.createDecorator)("loggerService");function S(){return new Date().toISOString()}function E(b){return(0,p.isNumber)(b)}e.isLogLevel=E;var o;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(o||(e.LogLevel=o={})),e.DEFAULT_LOG_LEVEL=o.Info;function t(b,l,f){switch(l){case o.Trace:b.trace(f);break;case o.Debug:b.debug(f);break;case o.Info:b.info(f);break;case o.Warning:b.warn(f);break;case o.Error:b.error(f);break;case o.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=t;function i(b,l=!1){let f="";for(let P=0;P<b.length;P++){let z=b[P];if(z instanceof Error&&(z=(0,w.toErrorMessage)(z,l)),typeof z=="object")try{z=JSON.stringify(z)}catch{}f+=(P>0?" ":"")+z}return f}class a extends M.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(l){this.level!==l&&(this.level=l,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(l){return this.level!==o.Off&&this.level<=l}}e.AbstractLogger=a;class g extends a{constructor(l){super(),this.logAlways=l}checkLogLevel(l){return this.logAlways||super.checkLogLevel(l)}trace(l,...f){this.checkLogLevel(o.Trace)&&this.log(o.Trace,i([l,...f],!0))}debug(l,...f){this.checkLogLevel(o.Debug)&&this.log(o.Debug,i([l,...f]))}info(l,...f){this.checkLogLevel(o.Info)&&this.log(o.Info,i([l,...f]))}warn(l,...f){this.checkLogLevel(o.Warning)&&this.log(o.Warning,i([l,...f]))}error(l,...f){if(this.checkLogLevel(o.Error))if(l instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=l.stack,this.log(o.Error,i(P))}else this.log(o.Error,i([l,...f]))}flush(){}}e.AbstractMessageLogger=g;class C extends a{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l),this.useColors=!h.isWindows}trace(l,...f){this.checkLogLevel(o.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,l,...f):console.log(`[main ${S()}]`,l,...f))}debug(l,...f){this.checkLogLevel(o.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,l,...f):console.log(`[main ${S()}]`,l,...f))}info(l,...f){this.checkLogLevel(o.Info)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,l,...f):console.log(`[main ${S()}]`,l,...f))}warn(l,...f){this.checkLogLevel(o.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,l,...f):console.warn(`[main ${S()}]`,l,...f))}error(l,...f){this.checkLogLevel(o.Error)&&(this.useColors?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,l,...f):console.error(`[main ${S()}]`,l,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class k extends a{constructor(l=e.DEFAULT_LOG_LEVEL,f=!0){super(),this.useColors=f,this.setLevel(l)}trace(l,...f){this.checkLogLevel(o.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",l,...f):console.log(l,...f))}debug(l,...f){this.checkLogLevel(o.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",l,...f):console.log(l,...f))}info(l,...f){this.checkLogLevel(o.Info)&&(this.useColors?console.log("%c INFO","color: #33f",l,...f):console.log(l,...f))}warn(l,...f){this.checkLogLevel(o.Warning)&&(this.useColors?console.log("%c WARN","color: #993",l,...f):console.log(l,...f))}error(l,...f){this.checkLogLevel(o.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",l,...f):console.error(l,...f))}dispose(){}flush(){}}e.ConsoleLogger=k;class r extends a{constructor(l,f=e.DEFAULT_LOG_LEVEL){super(),this.adapter=l,this.setLevel(f)}trace(l,...f){this.checkLogLevel(o.Trace)&&this.adapter.log(o.Trace,[this.extractMessage(l),...f])}debug(l,...f){this.checkLogLevel(o.Debug)&&this.adapter.log(o.Debug,[this.extractMessage(l),...f])}info(l,...f){this.checkLogLevel(o.Info)&&this.adapter.log(o.Info,[this.extractMessage(l),...f])}warn(l,...f){this.checkLogLevel(o.Warning)&&this.adapter.log(o.Warning,[this.extractMessage(l),...f])}error(l,...f){this.checkLogLevel(o.Error)&&this.adapter.log(o.Error,[this.extractMessage(l),...f])}extractMessage(l){return typeof l=="string"?l:(0,w.toErrorMessage)(l,this.checkLogLevel(o.Trace))}dispose(){}flush(){}}e.AdapterLogger=r;class d extends a{constructor(l){super(),this.loggers=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const f of this.loggers)f.setLevel(l);super.setLevel(l)}trace(l,...f){for(const P of this.loggers)P.trace(l,...f)}debug(l,...f){for(const P of this.loggers)P.debug(l,...f)}info(l,...f){for(const P of this.loggers)P.info(l,...f)}warn(l,...f){for(const P of this.loggers)P.warn(l,...f)}error(l,...f){for(const P of this.loggers)P.error(l,...f)}flush(){for(const l of this.loggers)l.flush()}dispose(){for(const l of this.loggers)l.dispose()}}e.MultiplexLogger=d;class n extends M.Disposable{constructor(l,f,P){if(super(),this.logLevel=l,this.logsHome=f,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,P)for(const z of P)this._loggers.set(z.resource,{logger:void 0,info:z})}getLoggerEntry(l){return(0,p.isString)(l)?[...this._loggers.values()].find(f=>f.info.id===l):this._loggers.get(l)}getLogger(l){return this.getLoggerEntry(l)?.logger}createLogger(l,f){const P=this.toResource(l),z=(0,p.isString)(l)?l:f?.id??(0,I.hash)(P.toString()).toString(16);let $=this._loggers.get(P)?.logger;const H=f?.logLevel==="always"?o.Trace:f?.logLevel;$||($=this.doCreateLogger(P,H??this.getLogLevel(P)??this.logLevel,{...f,id:z}));const x={logger:$,info:{resource:P,id:z,logLevel:H,name:f?.name,hidden:f?.hidden,extensionId:f?.extensionId,when:f?.when}};return this.registerLogger(x.info),this._loggers.set(P,x),$}toResource(l){return(0,p.isString)(l)?(0,y.joinPath)(this.logsHome,`${l}.log`):l}setLogLevel(l,f){if(A.URI.isUri(l)){const P=l,z=f,$=this._loggers.get(P);$&&z!==$.info.logLevel&&($.info.logLevel=z===this.logLevel?void 0:z,$.logger?.setLevel(z),this._loggers.set($.info.resource,$),this._onDidChangeLogLevel.fire([P,z]))}else{this.logLevel=l;for(const[P,z]of this._loggers.entries())this._loggers.get(P)?.info.logLevel===void 0&&z.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(l,f){const P=this.getLoggerEntry(l);P&&f!==!P.info.hidden&&(P.info.hidden=!f,this._loggers.set(P.info.resource,P),this._onDidChangeVisibility.fire([P.info.resource,f]))}getLogLevel(l){let f;return l&&(f=this._loggers.get(l)?.info.logLevel),f??this.logLevel}registerLogger(l){const f=this._loggers.get(l.resource);f?f.info.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this._loggers.set(l.resource,{info:l,logger:void 0}),this._onDidChangeLoggers.fire({added:[l],removed:[]}))}deregisterLogger(l){const f=this._loggers.get(l);f&&(f.logger&&f.logger.dispose(),this._loggers.delete(l),this._onDidChangeLoggers.fire({added:[],removed:[f.info]}))}*getRegisteredLoggers(){for(const l of this._loggers.values())yield l.info}getRegisteredLogger(l){return this._loggers.get(l)?.info}dispose(){this._loggers.forEach(l=>l.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class s{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(l){}getLevel(){return o.Info}trace(l,...f){}debug(l,...f){}info(l,...f){}warn(l,...f){}error(l,...f){}critical(l,...f){}dispose(){}flush(){}}e.NullLogger=s;class v extends s{}e.NullLogService=v;function D(b){if(b.verbose)return o.Trace;if(typeof b.logLevel=="string"){const l=m(b.logLevel.toLowerCase());if(l!==void 0)return l}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=D;function u(b){switch(b){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}e.LogLevelToString=u;function m(b){switch(b){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.parseLogLevel=m,e.CONTEXT_LOG_LEVEL=new _.RawContextKey("logLevel",u(o.Info))}),define(Pe[174],Ae([1,0,6,14]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class I extends w.Disposable{constructor(T,h=[]){super(),this.logger=new O.MultiplexLogger([T,...h]),this._register(T.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...h){this.logger.trace(T,...h)}debug(T,...h){this.logger.debug(T,...h)}info(T,...h){this.logger.info(T,...h)}warn(T,...h){this.logger.warn(T,...h)}error(T,...h){this.logger.error(T,...h)}flush(){this.logger.flush()}}e.LogService=I}),define(Pe[94],Ae([1,0,29,143,3]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var T;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function(y){function p(E,o){return o-E}y.compare=p;const A=Object.create(null);A[y.Error]=(0,O.localize)(0,null),A[y.Warning]=(0,O.localize)(1,null),A[y.Info]=(0,O.localize)(2,null);function _(E){return A[E]||""}y.toString=_;function c(E){switch(E){case w.default.Error:return y.Error;case w.default.Warning:return y.Warning;case w.default.Info:return y.Info;case w.default.Ignore:return y.Hint}}y.fromSeverity=c;function S(E){switch(E){case y.Error:return w.default.Error;case y.Warning:return w.default.Warning;case y.Info:return w.default.Info;case y.Hint:return w.default.Ignore}}y.toSeverity=S}(T||(e.MarkerSeverity=T={}));var h;(function(y){const p="";function A(c){return _(c,!0)}y.makeKey=A;function _(c,S){const E=[p];return c.source?E.push(c.source.replace("\xA6","\\\xA6")):E.push(p),c.code?typeof c.code=="string"?E.push(c.code.replace("\xA6","\\\xA6")):E.push(c.code.value.replace("\xA6","\\\xA6")):E.push(p),c.severity!==void 0&&c.severity!==null?E.push(T.toString(c.severity)):E.push(p),c.message&&S?E.push(c.message.replace("\xA6","\\\xA6")):E.push(p),c.startLineNumber!==void 0&&c.startLineNumber!==null?E.push(c.startLineNumber.toString()):E.push(p),c.startColumn!==void 0&&c.startColumn!==null?E.push(c.startColumn.toString()):E.push(p),c.endLineNumber!==void 0&&c.endLineNumber!==null?E.push(c.endLineNumber.toString()):E.push(p),c.endColumn!==void 0&&c.endColumn!==null?E.push(c.endColumn.toString()):E.push(p),E.push(p),E.join("\xA6")}y.makeKeyOptionalMessage=_})(h||(e.IMarkerData=h={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(Pe[175],Ae([1,0,5,29,3]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=O.default,e.INotificationService=(0,I.createDecorator)("notificationService");var M;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var T;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));var h;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(h||(e.NotificationsFilter=h={}));class y{constructor(){this.progress=new p,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(_){}updateMessage(_){}updateActions(_){}close(){}}e.NoOpNotification=y;class p{infinite(){}done(){}total(_){}worked(_){}}e.NoOpProgress=p}),define(Pe[95],Ae([1,0,15,2,3]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,I.createDecorator)("openerService");function M(p,A){return O.URI.isUri(p)?(0,w.equalsIgnoreCase)(p.scheme,A):(0,w.startsWithIgnoreCase)(p,A+":")}e.matchesScheme=M;function T(p,...A){return A.some(_=>M(p,_))}e.matchesSomeScheme=T;function h(p,A){return p.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.withSelection=h;function y(p){let A;const _=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(p.fragment);return _&&(A={startLineNumber:parseInt(_[1]),startColumn:_[2]?parseInt(_[2]):1,endLineNumber:_[4]?parseInt(_[4]):void 0,endColumn:_[4]?_[5]?parseInt(_[5]):1:void 0},p=p.with({fragment:""})),{selection:A,uri:p}}e.extractSelection=y}),define(Pe[176],Ae([1,0,3]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__decorate||function(pe,e,w,O){var I=arguments.length,M=I<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,w):O,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(pe,e,w,O);else for(var h=pe.length-1;h>=0;h--)(T=pe[h])&&(M=(I<3?T(M):I>3?T(e,w,M):T(e,w))||M);return I>3&&M&&Object.defineProperty(e,w,M),M},He=this&&this.__param||function(pe,e){return function(w,O){e(w,O,pe)}};define(Pe[177],Ae([1,0,16,20,6,3]),function(pe,e,w,O,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var T;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class h{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(_,c){this.callback=_,this.report=c?.async?this._reportAsync.bind(this):this._reportSync.bind(this)}_reportSync(_){this._value=_,this.callback(this._value)}_reportAsync(_){Promise.resolve(this._lastTask).finally(()=>{this._value=_;const c=this.callback(this._value);this._lastTask=Promise.resolve(c).finally(()=>this._lastTask=void 0)})}}e.Progress=h;let y=class extends I.Disposable{constructor(_,c){super(),this.deferred=new w.DeferredPromise,c.withProgress(_,S=>(this.reporter=S,this.lastStep&&S.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};e.UnmanagedProgress=y,e.UnmanagedProgress=y=We([He(1,e.IProgressService)],y);class p extends I.Disposable{constructor(_){super(),this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(_){this.stop();const c=++this.currentOperationId,S=new O.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>S.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:S.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=p,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Pe[30],Ae([1,0,50,12]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(T,h){w.ok(O.isString(T)),w.ok(O.isObject(h)),w.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,h)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new I}),define(Pe[74],Ae([1,0,5,30]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(h){return h.length>0&&h.charAt(h.length-1)==="#"?h.substring(0,h.length-1):h}class M{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,p){this.schemasById[I(y)]=p,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new M;O.Registry.add(e.Extensions.JSONContribution,T)}),define(Pe[96],Ae([1,0,18,5,12,137,43,74,30]),function(pe,e,w,O,I,M,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var p;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(p||(e.EditPresentationTypes=p={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const _=y.Registry.as(h.Extensions.JSONContribution);class c{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,d=!0){this.registerConfigurations([r],d)}registerConfigurations(r,d=!0){const n=new Set;this.doRegisterConfigurations(r,d,n),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(r){const d=new Set;this.doDeregisterConfigurations(r,d),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:r,remove:d}){const n=new Set;this.doDeregisterConfigurations(d,n),this.doRegisterConfigurations(r,!1,n),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}registerDefaultConfigurations(r){const d=new Set;this.doRegisterDefaultConfigurations(r,d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}doRegisterDefaultConfigurations(r,d){const n=[];for(const{overrides:s,source:v}of r)for(const D in s)if(d.add(D),e.OVERRIDE_PROPERTY_REGEX.test(D)){const u=this.configurationDefaultsOverrides.get(D),m=u?.valuesSources??new Map;if(v)for(const P of Object.keys(s[D]))m.set(P,v);const b={...u?.value||{},...s[D]};this.configurationDefaultsOverrides.set(D,{source:v,value:b,valuesSources:m});const l=(0,T.getLanguageTagSettingPlainKey)(D),f={type:"object",default:b,description:M.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:b,source:I.isString(v)?void 0:v,defaultValueSource:v};n.push(...o(D)),this.configurationProperties[D]=f,this.defaultLanguageConfigurationOverridesNode.properties[D]=f}else{this.configurationDefaultsOverrides.set(D,{value:s[D],source:v});const u=this.configurationProperties[D];u&&(this.updatePropertyDefaultValue(D,u),this.updateSchema(D,u))}this.doRegisterOverrideIdentifiers(n)}deregisterDefaultConfigurations(r){const d=new Set;this.doDeregisterDefaultConfigurations(r,d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(r,d){for(const{overrides:n,source:s}of r)for(const v in n){const D=this.configurationDefaultsOverrides.get(v),u=I.isString(s)?s:s?.id,m=I.isString(D?.source)?D?.source:D?.source?.id;if(u===m)if(d.add(v),this.configurationDefaultsOverrides.delete(v),e.OVERRIDE_PROPERTY_REGEX.test(v))delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v];else{const b=this.configurationProperties[v];b&&(this.updatePropertyDefaultValue(v,b),this.updateSchema(v,b))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(r){let d=!1;const n=new Set;r.removedDefaults&&(this.doDeregisterDefaultConfigurations(r.removedDefaults,n),d=!0),r.addedDefaults&&(this.doRegisterDefaultConfigurations(r.addedDefaults,n),d=!0),r.removedConfigurations&&this.doDeregisterConfigurations(r.removedConfigurations,n),r.addedConfigurations&&this.doRegisterConfigurations(r.addedConfigurations,!1,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){this.doRegisterOverrideIdentifiers(r),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(r){for(const d of r)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,d,n){r.forEach(s=>{this.validateAndRegisterProperties(s,d,s.extensionInfo,s.restrictedProperties,void 0,n),this.configurationContributors.push(s),this.registerJSONConfiguration(s)})}doDeregisterConfigurations(r,d){const n=s=>{if(s.properties)for(const v in s.properties){d.add(v);const D=this.configurationProperties[v];D?.policy?.name&&this.policyConfigurations.delete(D.policy.name),delete this.configurationProperties[v],this.removeFromSchema(v,s.properties[v])}s.allOf?.forEach(v=>n(v))};for(const s of r){n(s);const v=this.configurationContributors.indexOf(s);v!==-1&&this.configurationContributors.splice(v,1)}}validateAndRegisterProperties(r,d=!0,n,s,v=3,D){v=I.isUndefinedOrNull(r.scope)?v:r.scope;const u=r.properties;if(u)for(const b in u){const l=u[b];if(d&&g(b,l)){delete u[b];continue}if(l.source=n,l.defaultDefaultValue=u[b].default,this.updatePropertyDefaultValue(b,l),e.OVERRIDE_PROPERTY_REGEX.test(b)?l.scope=void 0:(l.scope=I.isUndefinedOrNull(l.scope)?v:l.scope,l.restricted=I.isUndefinedOrNull(l.restricted)?!!s?.includes(b):l.restricted),u[b].hasOwnProperty("included")&&!u[b].included){this.excludedConfigurationProperties[b]=u[b],delete u[b];continue}else this.configurationProperties[b]=u[b],u[b].policy?.name&&this.policyConfigurations.set(u[b].policy.name,b);!u[b].deprecationMessage&&u[b].markdownDeprecationMessage&&(u[b].deprecationMessage=u[b].markdownDeprecationMessage),D.add(b)}const m=r.allOf;if(m)for(const b of m)this.validateAndRegisterProperties(b,d,n,s,v,D)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const d=n=>{const s=n.properties;if(s)for(const D in s)this.updateSchema(D,s[D]);n.allOf?.forEach(d)};d(r)}updateSchema(r,d){switch(e.allSettings.properties[r]=d,d.scope){case 1:e.applicationSettings.properties[r]=d;break;case 2:e.machineSettings.properties[r]=d;break;case 6:e.machineOverridableSettings.properties[r]=d;break;case 3:e.windowSettings.properties[r]=d;break;case 4:e.resourceSettings.properties[r]=d;break;case 5:e.resourceSettings.properties[r]=d,this.resourceLanguageSettingsSchema.properties[r]=d;break}}removeFromSchema(r,d){switch(delete e.allSettings.properties[r],d.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const d=`[${r}]`,n={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,n),e.allSettings.properties[d]=n,e.applicationSettings.properties[d]=n,e.machineSettings.properties[d]=n,e.machineOverridableSettings.properties[d]=n,e.windowSettings.properties[d]=n,e.resourceSettings.properties[d]=n}}registerOverridePropertyPatternKey(){const r={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,d){const n=this.configurationDefaultsOverrides.get(r);let s=n?.value,v=n?.source;I.isUndefined(s)&&(s=d.defaultDefaultValue,v=void 0),I.isUndefined(s)&&(s=i(d.type)),d.default=s,d.defaultValueSource=v}}const S="\\[([^\\]]+)\\]",E=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function o(k){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(k)){let d=E.exec(k);for(;d?.length;){const n=d[1].trim();n&&r.push(n),d=E.exec(k)}}return(0,w.distinct)(r)}e.overrideIdentifiersFromKey=o;function t(k){return k.reduce((r,d)=>`${r}[${d}]`,"")}e.keyFromOverrideIdentifiers=t;function i(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=i;const a=new c;y.Registry.add(e.Extensions.Configuration,a);function g(k,r){return k.trim()?e.OVERRIDE_PROPERTY_REGEX.test(k)?M.localize(7,null,k):a.getConfigurationProperties()[k]!==void 0?M.localize(8,null,k):r.policy?.name&&a.getPolicyConfigurations().get(r.policy?.name)!==void 0?M.localize(9,null,k,r.policy?.name,a.getPolicyConfigurations().get(r.policy?.name)):null:M.localize(6,null)}e.validateProperty=g;function C(){const k=[],r=a.getConfigurationProperties();for(const d of Object.keys(r))k.push([d,r[d].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.getScopes=C}),define(Pe[178],Ae([1,0,18,5,115,6,28,24,12,2,43,96,30]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function S(d){return Object.isFrozen(d)?d:h.deepFreeze(d)}class E{constructor(n={},s=[],v=[],D){this._contents=n,this._keys=s,this._overrides=v,this.raw=D,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof E)return s;const v=new o("");return v.parseRaw(s),v.configurationModel});this._rawConfiguration=n.reduce((s,v)=>v===s?v:s.merge(v),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,A.getConfigurationValue)(this.contents,n):this.contents}inspect(n,s){const v=this.rawConfiguration.getValue(n),D=s?this.rawConfiguration.getOverrideValue(n,s):void 0,u=s?this.rawConfiguration.override(s).getValue(n):v;return{value:v,override:D,merged:u}}getOverrideValue(n,s){const v=this.getContentsForOverrideIdentifer(s);return v?n?(0,A.getConfigurationValue)(v,n):v:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const v of this.overrides)v.identifiers.includes(n)&&s.push(...v.keys);return w.distinct(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return w.distinct(n)}override(n){let s=this.overrideConfigurations.get(n);return s||(s=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,s)),s}merge(...n){const s=h.deepClone(this.contents),v=h.deepClone(this.overrides),D=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const m of n)if(u.push(...m.raw?.length?m.raw:[m]),!m.isEmpty()){this.mergeContents(s,m.contents);for(const b of m.overrides){const[l]=v.filter(f=>w.equals(f.identifiers,b.identifiers));l?(this.mergeContents(l.contents,b.contents),l.keys.push(...b.keys),l.keys=w.distinct(l.keys)):v.push(h.deepClone(b))}for(const b of m.keys)D.indexOf(b)===-1&&D.push(b)}return new E(s,D,v,u.every(m=>m instanceof E)?void 0:u)}createOverrideConfigurationModel(n){const s=this.getContentsForOverrideIdentifer(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const v={};for(const D of w.distinct([...Object.keys(this.contents),...Object.keys(s)])){let u=this.contents[D];const m=s[D];m&&(typeof u=="object"&&typeof m=="object"?(u=h.deepClone(u),this.mergeContents(u,m)):u=m),v[D]=u}return new E(v,this.keys,this.overrides)}mergeContents(n,s){for(const v of Object.keys(s)){if(v in n&&y.isObject(n[v])&&y.isObject(s[v])){this.mergeContents(n[v],s[v]);continue}n[v]=h.deepClone(s[v])}}getContentsForOverrideIdentifer(n){let s=null,v=null;const D=u=>{u&&(v?this.mergeContents(v,u):v=h.deepClone(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===n?s=u.contents:u.identifiers.includes(n)&&D(u.contents);return D(s),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.updateValue(n,s,!0)}setValue(n,s){this.updateValue(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,A.removeFromValueTree)(this.contents,n),_.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(v=>w.equals(v.identifiers,(0,_.overrideIdentifiersFromKey)(n))),1))}updateValue(n,s,v){(0,A.addToValueTree)(this.contents,n,s,D=>console.error(D)),v=v||this.keys.indexOf(n)===-1,v&&this.keys.push(n),_.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,_.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,A.toValuesTree)(this.contents[n],D=>console.error(D))})}}e.ConfigurationModel=E;class o{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,s){if(!y.isUndefinedOrNull(n)){const v=this.doParseContent(n);this.parseRaw(v,s)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,s){this._raw=n;const{contents:v,keys:D,overrides:u,restricted:m,hasExcludedProperties:b}=this.doParseRaw(n,s);this._configurationModel=new E(v,D,u,b?[n]:void 0),this._restrictedConfigurations=m||[]}doParseContent(n){let s={},v=null,D=[];const u=[],m=[];function b(f){Array.isArray(D)?D.push(f):v!==null&&(D[v]=f)}const l={onObjectBegin:()=>{const f={};b(f),u.push(D),D=f,v=null},onObjectProperty:f=>{v=f},onObjectEnd:()=>{D=u.pop()},onArrayBegin:()=>{const f=[];b(f),u.push(D),D=f,v=null},onArrayEnd:()=>{D=u.pop()},onLiteralValue:b,onError:(f,P,z)=>{m.push({error:f,offset:P,length:z})}};if(n)try{I.visit(n,l),s=D[0]||{}}catch(f){console.error(`Error while parsing settings file ${this._name}: ${f}`),this._parseErrors=[f]}return s}doParseRaw(n,s){const v=c.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),D=this.filter(n,v,!0,s);n=D.raw;const u=(0,A.toValuesTree)(n,l=>console.error(`Conflict in settings file ${this._name}: ${l}`)),m=Object.keys(n),b=this.toOverrides(n,l=>console.error(`Conflict in settings file ${this._name}: ${l}`));return{contents:u,keys:m,overrides:b,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}filter(n,s,v,D){let u=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:u};const m={},b=[];for(const l in n)if(_.OVERRIDE_PROPERTY_REGEX.test(l)&&v){const f=this.filter(n[l],s,!1,D);m[l]=f.raw,u=u||f.hasExcludedProperties,b.push(...f.restricted)}else{const f=s[l],P=f?typeof f.scope<"u"?f.scope:3:void 0;f?.restricted&&b.push(l),!D.exclude?.includes(l)&&(D.include?.includes(l)||(P===void 0||D.scopes===void 0||D.scopes.includes(P))&&!(D.skipRestricted&&f?.restricted))?m[l]=n[l]:u=!0}return{raw:m,restricted:b,hasExcludedProperties:u}}toOverrides(n,s){const v=[];for(const D of Object.keys(n))if(_.OVERRIDE_PROPERTY_REGEX.test(D)){const u={};for(const m in n[D])u[m]=n[D][m];v.push({identifiers:(0,_.overrideIdentifiersFromKey)(D),keys:Object.keys(u),contents:(0,A.toValuesTree)(u,s)})}return v}}e.ConfigurationModelParser=o;class t extends M.Disposable{constructor(n,s,v,D){super(),this.userSettingsResource=n,this.parseOptions=s,this.fileService=D,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new o(this.userSettingsResource.toString()),this._register(this.fileService.watch(v.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&v.isEqual(u.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(n){return n&&(this.parseOptions=n),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=t;class i{constructor(n,s,v,D,u,m,b,l,f,P,z,$,H){this.key=n,this.overrides=s,this._value=v,this.overrideIdentifiers=D,this.defaultConfiguration=u,this.policyConfiguration=m,this.applicationConfiguration=b,this.userConfiguration=l,this.localUserConfiguration=f,this.remoteUserConfiguration=P,this.workspaceConfiguration=z,this.folderConfigurationModel=$,this.memoryConfigurationModel=H}get value(){return S(this._value)}inspect(n,s,v){const D=n.inspect(s,v);return{get value(){return S(D.value)},get override(){return S(D.override)},get merged(){return S(D.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class a{constructor(n,s,v,D,u=new E,m=new E,b=new T.ResourceMap,l=new E,f=new T.ResourceMap){this._defaultConfiguration=n,this._policyConfiguration=s,this._applicationConfiguration=v,this._localUserConfiguration=D,this._remoteUserConfiguration=u,this._workspaceConfiguration=m,this._folderConfigurations=b,this._memoryConfiguration=l,this._memoryConfigurationByResource=f,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(n,s,v){return this.getConsolidatedConfigurationModel(n,s,v).getValue(n)}updateValue(n,s,v={}){let D;v.resource?(D=this._memoryConfigurationByResource.get(v.resource),D||(D=new E,this._memoryConfigurationByResource.set(v.resource,D))):D=this._memoryConfiguration,s===void 0?D.removeValue(n):D.setValue(n,s),v.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,s,v){const D=this.getConsolidatedConfigurationModel(n,s,v),u=this.getFolderConfigurationModelForResource(s.resource,v),m=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,b=new Set;for(const l of D.overrides)for(const f of l.identifiers)D.getOverrideValue(n,f)!==void 0&&b.add(f);return new i(n,s,D.getValue(n),b.size?[...b]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,v?this._workspaceConfiguration:void 0,u||void 0,m)}keys(n){const s=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,s){this._folderConfigurations.set(n,s),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const v=[];if(!s){const{added:D,updated:u,removed:m}=k(this._defaultConfiguration,n);s=[...D,...u,...m]}for(const D of s)for(const u of(0,_.overrideIdentifiersFromKey)(D)){const m=this._defaultConfiguration.getKeysForOverrideIdentifier(u),b=n.getKeysForOverrideIdentifier(u),l=[...b.filter(f=>m.indexOf(f)===-1),...m.filter(f=>b.indexOf(f)===-1),...m.filter(f=>!h.equals(this._defaultConfiguration.override(u).getValue(f),n.override(u).getValue(f)))];v.push([u,l])}return this.updateDefaultConfiguration(n),{keys:s,overrides:v}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:v,removed:D}=k(this._policyConfiguration,n),u=[...s,...v,...D];return u.length&&this.updatePolicyConfiguration(n),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:v,removed:D,overrides:u}=k(this.applicationConfiguration,n),m=[...s,...v,...D];return m.length&&this.updateApplicationConfiguration(n),{keys:m,overrides:u}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:v,removed:D,overrides:u}=k(this.localUserConfiguration,n),m=[...s,...v,...D];return m.length&&this.updateLocalUserConfiguration(n),{keys:m,overrides:u}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:v,removed:D,overrides:u}=k(this.remoteUserConfiguration,n),m=[...s,...v,...D];return m.length&&this.updateRemoteUserConfiguration(n),{keys:m,overrides:u}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:v,removed:D,overrides:u}=k(this.workspaceConfiguration,n),m=[...s,...v,...D];return m.length&&this.updateWorkspaceConfiguration(n),{keys:m,overrides:u}}compareAndUpdateFolderConfiguration(n,s){const v=this.folderConfigurations.get(n),{added:D,updated:u,removed:m,overrides:b}=k(v,s),l=[...D,...u,...m];return(l.length||!v)&&this.updateFolderConfiguration(n,s),{keys:l,overrides:b}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:v,updated:D,removed:u,overrides:m}=k(s,void 0);return{keys:[...v,...D,...u],overrides:m}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,s,v){let D=this.getConsolidatedConfigurationModelForResource(s,v);return s.overrideIdentifier&&(D=D.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(D=D.merge(this._policyConfiguration)),D}getConsolidatedConfigurationModelForResource({resource:n},s){let v=this.getWorkspaceConsolidatedConfiguration();if(s&&n){const D=s.getFolder(n);D&&(v=this.getFolderConsolidatedConfiguration(D.uri)||v);const u=this._memoryConfigurationByResource.get(n);u&&(v=v.merge(u))}return v}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let s=this._foldersConsolidatedConfigurations.get(n);if(!s){const v=this.getWorkspaceConsolidatedConfiguration(),D=this._folderConfigurations.get(n);D?(s=v.merge(D),this._foldersConsolidatedConfigurations.set(n,s)):s=v}return s}getFolderConfigurationModelForResource(n,s){if(s&&n){const v=s.getFolder(n);if(v)return this._folderConfigurations.get(v.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,s)=>{const{contents:v,overrides:D,keys:u}=this._folderConfigurations.get(s);return n.push([s,{contents:v,overrides:D,keys:u}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this._workspaceConfiguration.keys.forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(v=>n.add(v))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(v=>n.add(v))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(v=>s.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(v=>s.add(v)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(v=>s.add(v)),this._folderConfigurations.forEach(v=>v.getKeysForOverrideIdentifier(n).forEach(D=>s.add(D))),[...s.values()]}static parse(n){const s=this.parseConfigurationModel(n.defaults),v=this.parseConfigurationModel(n.policy),D=this.parseConfigurationModel(n.application),u=this.parseConfigurationModel(n.user),m=this.parseConfigurationModel(n.workspace),b=n.folders.reduce((l,f)=>(l.set(p.URI.revive(f[0]),this.parseConfigurationModel(f[1])),l),new T.ResourceMap);return new a(s,v,D,u,new E,m,b,new E,new T.ResourceMap)}static parseConfigurationModel(n){return new E(n.contents,n.keys,n.overrides)}}e.Configuration=a;function g(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const n=new Set,s=new Map;for(const D of d)D.keys.forEach(u=>n.add(u)),D.overrides.forEach(([u,m])=>{const b=(0,T.getOrSet)(s,u,new Set);m.forEach(l=>b.add(l))});const v=[];return s.forEach((D,u)=>v.push([u,[...D.values()]])),{keys:[...n.values()],overrides:v}}e.mergeChanges=g;class C{constructor(n,s,v,D){this.change=n,this.previous=s,this.currentConfiguraiton=v,this.currentWorkspace=D,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const u of n.keys)this.affectedKeys.add(u);for(const[,u]of n.overrides)for(const m of u)this.affectedKeys.add(m);this._affectsConfigStr=this._marker;for(const u of this.affectedKeys)this._affectsConfigStr+=u+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=a.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,s){const v=this._marker+n,D=this._affectsConfigStr.indexOf(v);if(D<0)return!1;const u=D+v.length;if(u>=this._affectsConfigStr.length)return!1;const m=this._affectsConfigStr.charCodeAt(u);if(m!==this._markerCode1&&m!==this._markerCode2)return!1;if(s){const b=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.previous?.workspace):void 0,l=this.currentConfiguraiton.getValue(n,s,this.currentWorkspace);return!h.equals(b,l)}return!0}}e.ConfigurationChangeEvent=C;function k(d,n){const{added:s,removed:v,updated:D}=r(n?.rawConfiguration,d?.rawConfiguration),u=[],m=d?.getAllOverrideIdentifiers()||[],b=n?.getAllOverrideIdentifiers()||[];if(n){const l=b.filter(f=>!m.includes(f));for(const f of l)u.push([f,n.getKeysForOverrideIdentifier(f)])}if(d){const l=m.filter(f=>!b.includes(f));for(const f of l)u.push([f,d.getKeysForOverrideIdentifier(f)])}if(n&&d){for(const l of m)if(b.includes(l)){const f=r({contents:d.getOverrideValue(void 0,l)||{},keys:d.getKeysForOverrideIdentifier(l)},{contents:n.getOverrideValue(void 0,l)||{},keys:n.getKeysForOverrideIdentifier(l)});u.push([l,[...f.added,...f.removed,...f.updated]])}}return{added:s,removed:v,updated:D,overrides:u}}function r(d,n){const s=d?n?d.keys.filter(u=>n.keys.indexOf(u)===-1):[...d.keys]:[],v=n?d?n.keys.filter(u=>d.keys.indexOf(u)===-1):[...n.keys]:[],D=[];if(d&&n){for(const u of n.keys)if(d.keys.indexOf(u)!==-1){const m=(0,A.getConfigurationValue)(n.contents,u),b=(0,A.getConfigurationValue)(d.contents,u);h.equals(m,b)||D.push(u)}}return{added:s,removed:v,updated:D}}}),define(Pe[97],Ae([1,0,11,3]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,O.createDecorator)("remoteAuthorityResolverService");var I;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class M{constructor(_){this.id=_,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=M;class T{constructor(_,c){this.host=_,this.port=c,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=T;var h;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(h||(e.RemoteAuthorityResolverErrorCode=h={}));class y extends w.ErrorNoTelemetry{static isNotAvailable(_){return _ instanceof y&&_._code===h.NotAvailable}static isTemporarilyNotAvailable(_){return _ instanceof y&&_._code===h.TemporarilyNotAvailable}static isNoResolverFound(_){return _ instanceof y&&_._code===h.NoResolverFound}static isInvalidAuthority(_){return _ instanceof y&&_._code===h.InvalidAuthority}static isHandled(_){return _ instanceof y&&_.isHandled}constructor(_,c=h.Unknown,S){super(_),this._message=_,this._code=c,this._detail=S,this.isHandled=c===h.NotAvailable&&S===!0,Object.setPrototypeOf(this,y.prototype)}}e.RemoteAuthorityResolverError=y;function p(A){const _=A.indexOf("+");return _===-1?A:A.substring(0,_)}e.getRemoteAuthorityPrefix=p}),define(Pe[51],Ae([1,0,13]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(p){return p.scheme===w.Schemas.vscodeRemote?p.authority:void 0}e.getRemoteAuthority=O;function I(p){if(!p)return;const A=p.indexOf("+");return A<0?p:p.substr(0,A)}e.getRemoteName=I;function M(p){return`/${p.quality??"oss"}-${p.commit??"dev"}`}e.getRemoteServerRootPath=M;function T(p){const{host:A,port:_}=y(p);if(typeof _>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:_}}e.parseAuthorityWithPort=T;function h(p,A){let{host:_,port:c}=y(p);return typeof c>"u"&&(c=A),{host:_,port:c}}e.parseAuthorityWithOptionalPort=h;function y(p){const A=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const _=p.match(/^(\[[0-9a-z:]+\])$/);if(_)return{host:_[1],port:void 0};const c=p.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:p,port:void 0}}}),define(Pe[21],Ae([1,0,15,3,51]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(o){if(typeof o=="object"&&o!==null&&o.supported!==!0)return o.description}e.getWorkspaceSupportTypeMessage=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(o){o[o.System=0]="System",o[o.User=1]="User"})(T||(e.ExtensionType=T={}));var h;(function(o){o.WIN32_X64="win32-x64",o.WIN32_IA32="win32-ia32",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.LINUX_PPC64LE="linux-ppc64le",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(h||(e.TargetPlatform=h={}));class y{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const a=typeof t=="string"?t:t.value,g=typeof i=="string"?i:i.value;return w.equalsIgnoreCase(a,g)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.ExtensionIdentifier=y;class p{get size(){return this._set.size}constructor(t){if(this._set=new Set,t)for(const i of t)this.add(i)}add(t){this._set.add(y.toKey(t))}delete(t){return this._set.delete(y.toKey(t))}has(t){return this._set.has(y.toKey(t))}}e.ExtensionIdentifierSet=p;class A{constructor(){this._map=new Map}clear(){this._map.clear()}delete(t){this._map.delete(y.toKey(t))}get(t){return this._map.get(y.toKey(t))}has(t){return this._map.has(y.toKey(t))}set(t,i){this._map.set(y.toKey(t),i)}values(){return this._map.values()}forEach(t){this._map.forEach(t)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=A;function _(o){return c(o)}e.isApplicationScopedExtension=_;function c(o){return o.contributes&&o.contributes.localizations?o.contributes.localizations.length>0:!1}e.isLanguagePackExtension=c;function S(o){return o.contributes&&o.contributes.authentication?o.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function E(o,t){if(t){const i=`onResolveRemoteAuthority:${(0,I.getRemoteName)(t)}`;return!!o.activationEvents?.includes(i)}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(Pe[98],Ae([1,0,11,21]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class I{constructor(){this._generators=new Map,this._cache=new WeakMap}register(T,h){this._generators.set(T,h)}readActivationEvents(T){return this._cache.has(T)||this._cache.set(T,this._readActivationEvents(T)),this._cache.get(T)}createActivationEventsMap(T){const h=Object.create(null);for(const y of T){const p=this.readActivationEvents(y);p.length>0&&(h[O.ExtensionIdentifier.toKey(y.identifier)]=p)}return h}_readActivationEvents(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const h=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];if(!T.contributes)return h;for(const y in T.contributes){const p=this._generators.get(y);if(!p)continue;const A=T.contributes[y],_=Array.isArray(A)?A:[A];try{p(_,h)}catch(c){(0,w.onUnexpectedError)(c)}}return h}}e.ImplicitActivationEventsImpl=I,e.ImplicitActivationEvents=new I}),define(Pe[179],Ae([1,0,22,52,36]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(y){if(w.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}function T(y,p,A,_,c,S,E,o){const t=Object.create(null);t["common.machineId"]=S,t.sessionID=(0,I.generateUuid)()+Date.now(),t.commitHash=_,t.version=c,t["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,w.PlatformToString)(w.platform),t["common.nodePlatform"]=O.platform,t["common.nodeArch"]=A,t["common.product"]=o||"desktop",E&&(t["common.msftInternal"]=E);let i=0;const a=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),w.isLinuxSnap&&(t["common.snap"]="true");const g=M(p);return g&&(t["common.platformDetail"]=g),t}e.resolveCommonProperties=T;function h(y){const p=O.env.USERDNSDOMAIN;if(!p)return!1;const A=p.toLowerCase();return y.some(_=>A===_)}e.verifyMicrosoftInternalDomain=h}),define(Pe[180],Ae([1,0,3]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var I;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Pe[53],Ae([1,0,24,12,5,43,51,179,180]),function(pe,e,w,O,I,M,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class p{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=p;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=A,e.NullTelemetryService=new A;class _{async publicLog(v,D,u){}async publicLogError(v,D,u){}}e.NullEndpointTelemetryService=_,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(s,v){return I.Event.debounce(v.onDidChangeConfiguration,(u,m)=>{const b=u?new Set([...u.affectedKeys,...m.affectedKeys]):m.affectedKeys;return{...m,affectedKeys:b}},1e3,!0)(u=>{u.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(u.source),configurationKeys:Array.from(u.affectedKeys)})})}e.configurationTelemetry=c;function S(s,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!s.enableTelemetry||v.extensionTestsLocationURI)}e.supportsTelemetry=S;function E(s,v){return!(v.isBuilt||v.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=E;function o(s){const v=s.getValue(y.TELEMETRY_SETTING_ID),D=s.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(s.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||D===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=o;function t(s){const v={},D={},u={};g(s,u);for(let m in u){m=m.length>150?m.substr(m.length-149):m;const b=u[m];typeof b=="number"?D[m]=b:typeof b=="boolean"?D[m]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${m} has been trimmed to 8192, the original length is ${b.length}`),v[m]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(v[m]=b)}return{properties:v,measurements:D}}e.validateTelemetryData=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(s){if(!s)return"none";const v=(0,T.getRemoteName)(s);return i.has(v)?v:"other"}e.cleanRemoteAuthority=a;function g(s,v,D=0,u){if(s)for(const m of Object.getOwnPropertyNames(s)){const b=s[m],l=u?u+m:m;Array.isArray(b)?v[l]=(0,w.safeStringify)(b):b instanceof Date?v[l]=b.toISOString():(0,O.isObject)(b)?D<2?g(b,v,D+1,l+"."):v[l]=(0,w.safeStringify)(b):v[l]=b}}function C(s,v){const D=s.msftInternalDomains||[],u=v.getValue("telemetry.internalTesting");return(0,h.verifyMicrosoftInternalDomain)(D)||u}e.isInternalTelemetry=C;function k(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=k;function r(s,v){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let D=s;const u=[];for(const f of v)for(;;){const P=f.exec(s);if(!P)break;u.push([P.index,f.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(D="";;){const f=b.exec(s);if(!f)break;const P=u.some(([z,$])=>f.index<$&&z<b.lastIndex);!m.test(f[0])&&!P&&(D+=s.substring(l,f.index)+"<REDACTED: user-file-path>",l=b.lastIndex)}return l<s.length&&(D+=s.substr(l)),D}function d(s){if(!s)return s;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const D of v)if(D.regex.test(s))return`<REDACTED: ${D.label}>`;return s}function n(s,v){return(0,w.cloneAndChange)(s,D=>{if(D instanceof p||Object.hasOwnProperty.call(D,"isTrustedTelemetryValue"))return D.value;if(typeof D=="string"){let u=D.replaceAll("%20"," ");u=r(u,v);for(const m of v)u=u.replace(m,"");return u=d(u),u}})}e.cleanData=n}),define(Pe[181],Ae([1,0,15,92,21,22,2,11,52,53]),function(pe,e,w,O,I,M,T,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function A(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,w.compareIgnoreCase)(n.id,s.id)===0}e.areSameExtensions=A;const _=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class c{static create(s){const v=s.manifest?s.manifest.version:s.version,D=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new c(s.identifier,v,D)}static parse(s){const v=_.exec(s);return v&&v[1]&&v[2]?new c({id:v[1]},v[2],v[4]||void 0):null}constructor(s,v,D="undefined"){this.version=v,this.targetPlatform=D,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof c?A(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=c;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(n){const s=S.exec(n);return s&&s[1]?[t(s[1]),s[2]]:[t(n),void 0]}e.getIdAndVersion=E;function o(n,s){return`${n}.${s}`}e.getExtensionId=o;function t(n){return n.toLowerCase()}e.adoptToGalleryExtensionId=t;function i(n,s){return t(o(n??I.UNDEFINED_PUBLISHER,s))}e.getGalleryExtensionId=i;function a(n,s){const v=[],D=u=>{for(const m of v)if(m.some(b=>A(s(b),s(u))))return m;return null};for(const u of n){const m=D(u);m?m.push(u):v.push([u])}return v}e.groupByExtension=a;function g(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function C(n){return{id:new p.TelemetryTrustedValue(n.identifier.id),name:new p.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function k(n,s){const v=[],D=s.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const u=D.shift();if(u&&v.every(m=>!A(m.identifier,{id:u}))){const m=n.filter(b=>A(b.identifier,{id:u}));m.length===1&&(v.push(m[0]),D.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=k;async function r(n,s){if(!M.isLinux)return!1;let v;try{v=(await n.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await n.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){s.debug("Error while getting the os-release file.",(0,h.getErrorMessage)(u))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(n,s){const v=await r(n,s),D=(0,O.getTargetPlatform)(v?"alpine":M.platform,y.arch);return s.debug("ComputeTargetPlatform:",D),D}e.computeTargetPlatform=d}),define(Pe[182],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function w(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=w;function O(y){return y?[...y.entries()]:[]}e.serializeEnvironmentDescriptionMap=O;function I(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=I;function M(y){return new Map(y??[])}e.deserializeEnvironmentDescriptionMap=M;function T(y){return Array.from(y.entries()).map(p=>[p[0],w(p[1].map),O(p[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=T;function h(y){return new Map(y.map(p=>[p[0],{map:I(p[1]),descriptionMap:M(p[2])}]))}e.deserializeEnvironmentVariableCollections=h}),define(Pe[183],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class w{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,M,T=5){const h=M(y=>{const p=typeof y=="string"?y:y.data;let A=this._terminalBufferMap.get(I);if(A){A.data.push(p);return}const _=setTimeout(()=>this.flushBuffer(I),T);A={data:[p],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(I),h.dispose()}},this._terminalBufferMap.set(I,A)});return h}stopBuffering(I){this._terminalBufferMap.get(I)?.dispose()}flushBuffer(I){const M=this._terminalBufferMap.get(I);M&&(this._terminalBufferMap.delete(I),this._callback(I,M.data.join("")))}}e.TerminalDataBufferer=w}),define(Pe[184],Ae([1,0,16,89,40,5,12,2,144,74,30]),function(pe,e,w,O,I,M,T,h,y,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var _;(function(C){function k(r,d){let n=r.defaults;for(;I.ThemeIcon.isThemeIcon(n);){const s=E.getIcon(n.id);if(!s)return;n=s.defaults}return n}C.getDefinition=k})(_||(e.IconContribution=_={}));var c;(function(C){function k(d){return{weight:d.weight,style:d.style,src:d.src.map(n=>({format:n.format,location:n.location.toString()}))}}C.toJSONObject=k;function r(d){const n=s=>(0,T.isString)(s)?s:void 0;if(d&&Array.isArray(d.src)&&d.src.every(s=>(0,T.isString)(s.format)&&(0,T.isString)(s.location)))return{weight:n(d.weight),style:n(d.style),src:d.src.map(s=>({format:s.format,location:h.URI.parse(s.location)}))}}C.fromJSONObject=r})(c||(e.IconFontDefinition=c={}));class S{constructor(){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(k,r,d,n){const s=this.iconsById[k];if(s){if(d&&!s.description){s.description=d,this.iconSchema.properties[k].markdownDescription=`${d} $(${k})`;const u=this.iconReferenceSchema.enum.indexOf(k);u!==-1&&(this.iconReferenceSchema.enumDescriptions[u]=d),this._onDidChange.fire()}return s}const v={id:k,description:d,defaults:r,deprecationMessage:n};this.iconsById[k]=v;const D={$ref:"#/definitions/icons"};return n&&(D.deprecationMessage=n),d&&(D.markdownDescription=`${d}: $(${k})`),this.iconSchema.properties[k]=D,this.iconReferenceSchema.enum.push(k),this.iconReferenceSchema.enumDescriptions.push(d||""),this._onDidChange.fire(),{id:k}}deregisterIcon(k){delete this.iconsById[k],delete this.iconSchema.properties[k];const r=this.iconReferenceSchema.enum.indexOf(k);r!==-1&&(this.iconReferenceSchema.enum.splice(r,1),this.iconReferenceSchema.enumDescriptions.splice(r,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(k=>this.iconsById[k])}getIcon(k){return this.iconsById[k]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(k,r){const d=this.iconFontsById[k];return d||(this.iconFontsById[k]=r,this._onDidChange.fire(),r)}deregisterIconFont(k){delete this.iconFontsById[k]}getIconFont(k){return this.iconFontsById[k]}toString(){const k=(s,v)=>s.id.localeCompare(v.id),r=s=>{for(;I.ThemeIcon.isThemeIcon(s.defaults);)s=this.iconsById[s.defaults.id];return`codicon codicon-${s?s.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.iconsById).map(s=>this.iconsById[s]);for(const s of n.filter(v=>!!v.description).sort(k))d.push(`|<i class="${r(s)}"></i>|${s.id}|${I.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const s of n.filter(v=>!I.ThemeIcon.isThemeIcon(v.defaults)).sort(k))d.push(`|<i class="${r(s)}"></i>|${s.id}|`);return d.join(`
`)}}const E=new S;A.Registry.add(e.Extensions.IconContribution,E);function o(C,k,r,d){return E.registerIcon(C,k,r,d)}e.registerIcon=o;function t(){return E}e.getIconRegistry=t;function i(){const C=(0,O.getCodiconFontCharacters)();for(const k in C){const r="\\"+C[k].toString(16);E.registerIcon(k,{fontCharacter:r})}}i(),e.iconsSchemaId="vscode://schemas/icons";const a=A.Registry.as(p.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,E.getIconSchema());const g=new w.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);E.onDidChange(()=>{g.isScheduled()||g.schedule()}),e.widgetClose=o("widget-close",O.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=o("goto-previous-location",O.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=o("goto-next-location",O.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=I.ThemeIcon.modify(O.Codicon.sync,"spin"),e.spinningLoading=I.ThemeIcon.modify(O.Codicon.loading,"spin")}),define(Pe[185],Ae([1,0,5,43,3,14]),function(pe,e,w,O,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var T;(function(t){t.Http="http",t.Https="https"})(T||(e.TunnelProtocol=T={}));var h;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(h||(e.TunnelPrivacyId=h={}));function y(t){return!!t.forwardPort}e.isTunnelProvider=y;var p;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(p||(e.ProvidedOnAutoForward=p={}));function A(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.extractLocalHostUriMetaDataForPortMapping=A,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function _(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=_,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function c(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=c;function S(t,i,a,g){if(a===1)return!1;if(a===2&&c(i)){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(C?.length===4&&parseInt(C[1])>=18)return!1}return t<1024}e.isPortPrivileged=S;class E{constructor(i,a,g){this.remoteAddress=i,this.localAddress=a,this._dispose=g,this._onDispose=new w.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=E;let o=class{constructor(i,a){this.logService=i,this.configurationService=a,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const i=this.configurationService.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this._tunnelProvider=i,i?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this._canElevate=i.elevation,this._privacyOptions=i.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const i=[],a=Array.from(this._tunnels.values());for(const g of a){const C=Array.from(g.values());for(const k of C){const r=await k.value;r&&i.push(r)}}return i}async dispose(){for(const i of this._tunnels.values()){for(const{value:a}of i.values())await a.then(g=>g?.dispose());i.clear()}this._tunnels.clear()}setEnvironmentTunnel(i,a,g,C,k){this.addTunnelToMap(i,a,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:a,localAddress:g,privacy:C,protocol:k,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,a){(c(i)||_(i))&&(i=e.LOCALHOST_ADDRESSES[0]);const g=this.getTunnelFromMap(i,a);if(g)return++g.refcount,g.value}openTunnel(i,a,g,C,k,r=!1,d,n){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${g} on local port ${k}.`);const s=this._tunnelProvider??i;if(!s)return;if(a||(a="localhost"),C||(C=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.retainOrCreateTunnel(s,a,g,C,k,r,d,n);return v?v.then(D=>{if(!D){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(a,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.makeTunnel(D);return(D.tunnelRemoteHost!==a||D.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),d&&D.privacy!==d&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(u),u}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}makeTunnel(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const a=this._tunnels.get(i.tunnelRemoteHost);if(a){const g=a.get(i.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(i.tunnelRemoteHost,i.tunnelRemotePort,g))}}}}async tryDisposeTunnel(i,a,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${a}.`);const C=g.value.then(async k=>{k&&(await k.dispose(!0),this._onTunnelClosed.fire({host:k.tunnelRemoteHost,port:k.tunnelRemotePort}))});return this._tunnels.has(i)&&this._tunnels.get(i).delete(a),C}}async closeTunnel(i,a){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${a} `);const g=this._tunnels.get(i);if(g&&g.has(a)){const C=g.get(a);C.refcount=0,await this.tryDisposeTunnel(i,a,C)}}addTunnelToMap(i,a,g){this._tunnels.has(i)||this._tunnels.set(i,new Map),this._tunnels.get(i).set(a,{refcount:1,value:g})}async removeEmptyTunnelFromMap(i,a){const g=this._tunnels.get(i);if(g){const C=g.get(a);(C?await C.value:void 0)||g.delete(a),g.size===0&&this._tunnels.delete(i)}}getTunnelFromMap(i,a){const g=[i];_(i)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):c(i)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const C=g.map(k=>this._tunnels.get(k));for(const k of C){const r=k?.get(a);if(r)return r}}canTunnel(i){return!!A(i)}createWithProvider(i,a,g,C,k,r,d){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${g} on local port ${C}.`);const n=g;this._factoryInProgress.add(n);const s=C===void 0?g:C,v={elevationRequired:k?this.isPortPrivileged(s):!1},D={remoteAddress:{host:a,port:g},localAddressPort:C,privacy:r,public:r?r!==h.Private:void 0,protocol:d},u=i.forwardPort(D,v);return u?(this.addTunnelToMap(a,g,u),u.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(n)})):this._factoryInProgress.delete(n),u}};e.AbstractTunnelService=o,e.AbstractTunnelService=o=We([He(0,M.ILogService),He(1,O.IConfigurationService)],o)}),define(Pe[186],Ae([1,0,3]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,w.createDecorator)("editSessionIdentityService");var O;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(Pe[187],Ae([1,0,13]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function O(y){return y.scheme!==w.Schemas.file&&y.scheme!==w.Schemas.vscodeRemote}e.isVirtualResource=O;function I(y){if(y.folders.length)return y.folders.every(p=>O(p.uri))?y.folders[0].uri:void 0;if(y.configuration&&O(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=I;function M(y){return I(y)?.scheme}e.getVirtualWorkspaceScheme=M;function T(y){return I(y)?.authority}e.getVirtualWorkspaceAuthority=T;function h(y){return I(y)!==void 0}e.isVirtualWorkspace=h}),define(Pe[54],Ae([1,0,145,19,48,23,2,3,13]),function(pe,e,w,O,I,M,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,h.createDecorator)("contextService");function p(s){const v=s;return typeof v?.id=="string"&&T.URI.isUri(v.uri)}e.isSingleFolderWorkspaceIdentifier=p;function A(s){return typeof s?.id=="string"&&!p(s)&&!c(s)}e.isEmptyWorkspaceIdentifier=A,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function _(s,v){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,O.basename)(s)}:v?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const D=s;return D.configuration?{id:D.id,configPath:D.configuration}:D.folders.length===1?{id:D.id,uri:D.folders[0].uri}:{id:D.id}}e.toWorkspaceIdentifier=_;function c(s){const v=s;return typeof v?.id=="string"&&T.URI.isUri(v.configPath)}e.isWorkspaceIdentifier=c;function S(s){const v=s;if(v?.uri)return{id:v.id,uri:T.URI.revive(v.uri)};const D=s;if(D?.configPath)return{id:D.id,configPath:T.URI.revive(D.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=S;var E;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(E||(e.WorkbenchState=E={}));function o(s){const v=s;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.isWorkspace=o;function t(s){const v=s;return!!(v&&typeof v=="object"&&T.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.isWorkspaceFolder=t;class i{constructor(v,D,u,m,b){this._id=v,this._transient=u,this._configuration=m,this._ignorePathCasing=b,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=D}update(v){this._id=v.id,this._configuration=v.configuration,this._transient=v.transient,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v)||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=i;class a{constructor(v,D){this.raw=D,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,M.joinPath)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=a;function g(s){return new a({uri:s,index:0,name:(0,M.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,w.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function C(s,v){return M.extUriBiasedIgnorePathCase.isEqualOrParent(s,v.untitledWorkspacesHome)}e.isUntitledWorkspace=C;function k(s){let v;return T.URI.isUri(s)?v=s:v=s.configuration,v?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=k,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(s){return s.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=r;function d(s,v){return!C(s,v)&&!k(s)}e.isSavedWorkspace=d;function n(s){return(typeof s=="string"?(0,O.extname)(s):(0,M.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(Pe[55],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class w{static{this.enableDebugLogging=!1}constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const M=this._idPool++;return this._data.set(M,I),this.logDebugInfo(),M}get(I,M){return this._data.has(I)?this._data.get(I)[M]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){w.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=w}),define(Pe[39],Ae([1,0,13,23,3]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this._systemSchemes=new Set(Object.keys(w.Schemas)),this._providerInfo=new Map,this.extUri=new O.ExtUri(h=>{const y=this._providerInfo.get(h.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(h,y){y===null?this._providerInfo.delete(h.scheme):this._providerInfo.set(h.scheme,y)}isFreeScheme(h){return!this._providerInfo.has(h)&&!this._systemSchemes.has(h)}getCapabilities(h){return this._providerInfo.get(h)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(Pe[27],Ae([1,0,3]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,w.createDecorator)("IExtHostInitDataService")}),define(Pe[188],Ae([1,0,150,14,174,27]),function(pe,e,w,O,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends I.LogService{constructor(y,p,A){const _=A.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",c=A.remote.isRemote?(0,w.localize)(0,null):y?(0,w.localize)(1,null):(0,w.localize)(2,null);super(p.createLogger(_,{name:c}))}};e.ExtHostLogService=T,e.ExtHostLogService=T=We([He(1,O.ILoggerService),He(2,M.IExtHostInitDataService)],T)}),define(Pe[189],Ae([1,0,16]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class O{constructor(T,h,y){this._deferredPromises=new Map,this._id=T,this._shared=h,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(p=>(this._value=p,this)),this._storageListener=this._storage.onDidChangeStorage(p=>{p.shared===this._shared&&p.key===this._id&&(this._value=p.value)}),this._scheduler=new w.RunOnceScheduler(()=>{const p=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const A of p.values())A.complete()}catch(A){for(const _ of p.values())_.error(A)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,h){let y=this._value[T];return typeof y>"u"&&(y=h),y}update(T,h){this._value[T]=h;const y=this._deferredPromises.get(T);if(y!==void 0)return y.p;const p=new w.DeferredPromise;return this._deferredPromises.set(T,p),this._scheduler.isScheduled()||this._scheduler.schedule(),p.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=O;class I extends O{setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}constructor(T,h){super(T.identifier.value,!0,h),this._extension=T}}e.ExtensionGlobalMemento=I}),define(Pe[190],Ae([1,0,5,2]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class I{constructor(T){this._notebooksAndEditors=T,this._onDidSaveNotebookDocument=new w.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new w.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(T,h,y,p){const _=this._notebooksAndEditors.getNotebookDocument(O.URI.revive(T)).acceptModelChanged(h.value,y,p);this._onDidChangeNotebookDocument.fire(_)}$acceptDirtyStateChanged(T,h){this._notebooksAndEditors.getNotebookDocument(O.URI.revive(T)).acceptDirty(h)}$acceptModelSaved(T){const h=this._notebooksAndEditors.getNotebookDocument(O.URI.revive(T));this._onDidSaveNotebookDocument.fire(h.apiNotebook)}}e.ExtHostNotebookDocuments=I}),define(Pe[17],Ae([1,0,3]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,w.createDecorator)("IExtHostRpcService");class O{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=O}),define(Pe[191],Ae([1,0,21,5]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class I{#e;constructor(T,h){this._onDidChange=new O.Emitter,this.onDidChange=this._onDidChange.event,this._id=w.ExtensionIdentifier.toKey(T.identifier),this.#e=h,this.#e.onDidChangePassword(y=>{y.extensionId===this._id&&this._onDidChange.fire({key:y.key})})}get(T){return this.#e.get(this._id,T)}store(T,h){return this.#e.store(this._id,T,h)}delete(T){return this.#e.delete(this._id,T)}}e.ExtensionSecrets=I}),define(Pe[56],Ae([1,0,3]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,w.createDecorator)("IURITransformerService");class O{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=O}),define(Pe[192],Ae([1,0,25]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class O{constructor(){this.buffers=[]}add(y){let p=this.buffers.indexOf(y);return p<0&&(p=this.buffers.length,this.buffers.push(y)),p}}function I(h,y){if(y.serializeBuffersForPostMessage){const p=new O,_=JSON.stringify(h,(S,E)=>{if(E instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:p.add(E)};if(ArrayBuffer.isView(E)){const o=M(E);if(o)return{$$vscode_array_buffer_reference$$:!0,index:p.add(E.buffer),view:{type:o,byteLength:E.byteLength,byteOffset:E.byteOffset}}}return E}),c=p.buffers.map(S=>{const E=new Uint8Array(S);return w.VSBuffer.wrap(E)});return{message:_,buffers:c}}else return{message:JSON.stringify(h),buffers:[]}}e.serializeWebviewMessage=I;function M(h){switch(h.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(h,y){const p=y.map(c=>{const S=new ArrayBuffer(c.byteLength);return new Uint8Array(S).set(c.buffer),S}),A=y.length?(c,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const E=S,{index:o}=E,t=p[o];if(E.view)switch(E.view.type){case 1:return new Int8Array(t,E.view.byteOffset,E.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,E.view.byteOffset,E.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,E.view.byteOffset,E.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,E.view.byteOffset,E.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,E.view.byteOffset,E.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,E.view.byteOffset,E.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,E.view.byteOffset,E.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,E.view.byteOffset,E.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,E.view.byteOffset,E.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,E.view.byteOffset,E.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,E.view.byteOffset,E.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return S}:void 0;return{message:JSON.parse(h,A),arrayBuffers:p}}e.deserializeWebviewMessage=T}),define(Pe[99],Ae([1,0,159,12,2,6,3,30,38,13,41,127,29]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var S;(function(Q){Q[Q.PROGRAMMATIC=1]="PROGRAMMATIC",Q[Q.USER=2]="USER",Q[Q.EDIT=3]="EDIT",Q[Q.NAVIGATION=4]="NAVIGATION",Q[Q.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var E;(function(Q){Q[Q.IDENTICAL=1]="IDENTICAL",Q[Q.SIMILAR=2]="SIMILAR",Q[Q.DIFFERENT=3]="DIFFERENT"})(E||(e.EditorPaneSelectionCompareResult=E={}));function o(Q){const ue=Q;return!!ue&&typeof ue.getSelection=="function"&&!!ue.onDidChangeSelection}e.isEditorPaneWithSelection=o;function t(Q,ue,ne){for(const he of ne.visibleEditorPanes)if(he.group.id===ue&&Q.matches(he.input))return he.getViewState()}e.findViewStateForEditor=t;function i(Q){if(D(Q))return!1;const ue=Q;return I.URI.isUri(ue?.resource)}e.isResourceEditorInput=i;function a(Q){if(D(Q))return!1;const ue=Q;return ue?.original!==void 0&&ue.modified!==void 0}e.isResourceDiffEditorInput=a;function g(Q){if(D(Q)||a(Q))return!1;const ue=Q;return ue?.primary!==void 0&&ue.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function C(Q){if(D(Q))return!1;const ue=Q;return ue?ue.resource===void 0||ue.resource.scheme===p.Schemas.untitled||ue.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=C;function k(Q){if(D(Q))return!1;const ue=Q;return I.URI.isUri(ue?.base?.resource)&&I.URI.isUri(ue?.input1?.resource)&&I.URI.isUri(ue?.input2?.resource)&&I.URI.isUri(ue?.result?.resource)}e.isResourceMergeEditorInput=k;var r;(function(Q){Q[Q.SHORT=0]="SHORT",Q[Q.MEDIUM=1]="MEDIUM",Q[Q.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var d;(function(Q){Q[Q.EXPLICIT=1]="EXPLICIT",Q[Q.AUTO=2]="AUTO",Q[Q.FOCUS_CHANGE=3]="FOCUS_CHANGE",Q[Q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class n{constructor(){this.mapIdToSaveSource=new Map}registerSource(ue,ne){let he=this.mapIdToSaveSource.get(ue);return he||(he={source:ue,label:ne},this.mapIdToSaveSource.set(ue,he)),he.source}getSourceLabel(ue){return this.mapIdToSaveSource.get(ue)?.label??ue}}e.SaveSourceRegistry=new n;var s;(function(Q){Q[Q.None=0]="None",Q[Q.Readonly=2]="Readonly",Q[Q.Untitled=4]="Untitled",Q[Q.Singleton=8]="Singleton",Q[Q.RequiresTrust=16]="RequiresTrust",Q[Q.CanSplitInGroup=32]="CanSplitInGroup",Q[Q.ForceDescription=64]="ForceDescription",Q[Q.CanDropIntoEditor=128]="CanDropIntoEditor",Q[Q.MultipleEditors=256]="MultipleEditors",Q[Q.Scratchpad=512]="Scratchpad"})(s||(e.EditorInputCapabilities=s={}));class v extends M.Disposable{}e.AbstractEditorInput=v;function D(Q){return Q instanceof v}e.isEditorInput=D;function u(Q){const ue=Q;return I.URI.isUri(ue?.preferredResource)}function m(Q){const ue=Q;return D(ue?.primary)&&D(ue?.secondary)}e.isSideBySideEditorInput=m;function b(Q){const ue=Q;return D(ue?.modified)&&D(ue?.original)}e.isDiffEditorInput=b;function l(Q,ue,ne,he,le){return K(he,[(0,_.toAction)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const F={...ne,limits:{size:Number.MAX_VALUE}};Q.openEditor(ue,F)}}),(0,_.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>le.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:c.default.Warning})}e.createTooLargeFileError=l;function f(Q){return D(Q?.editor)}e.isEditorInputWithOptions=f;function P(Q){const ue=Q;return f(Q)&&ue?.group!==void 0}e.isEditorInputWithOptionsAndGroup=P;function z(Q){const ue=Q;return typeof ue?.groupId=="number"&&D(ue.editor)}e.isEditorIdentifier=z;var $;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.REPLACE=1]="REPLACE",Q[Q.MOVE=2]="MOVE",Q[Q.UNPIN=3]="UNPIN"})($||(e.EditorCloseContext=$={}));var H;(function(Q){Q[Q.GROUP_ACTIVE=0]="GROUP_ACTIVE",Q[Q.GROUP_INDEX=1]="GROUP_INDEX",Q[Q.GROUP_LOCKED=2]="GROUP_LOCKED",Q[Q.EDITOR_OPEN=3]="EDITOR_OPEN",Q[Q.EDITOR_CLOSE=4]="EDITOR_CLOSE",Q[Q.EDITOR_MOVE=5]="EDITOR_MOVE",Q[Q.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",Q[Q.EDITOR_LABEL=7]="EDITOR_LABEL",Q[Q.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",Q[Q.EDITOR_PIN=9]="EDITOR_PIN",Q[Q.EDITOR_STICKY=10]="EDITOR_STICKY",Q[Q.EDITOR_DIRTY=11]="EDITOR_DIRTY",Q[Q.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(H||(e.GroupModelChangeKind=H={}));var x;(function(Q){Q[Q.PRIMARY=1]="PRIMARY",Q[Q.SECONDARY=2]="SECONDARY",Q[Q.BOTH=3]="BOTH",Q[Q.ANY=4]="ANY"})(x||(e.SideBySideEditor=x={}));class U{getOriginalUri(ue,ne){if(!ue)return;if(k(ue))return e.EditorResourceAccessor.getOriginalUri(ue.result,ne);if(ne?.supportSideBySide){const{primary:le,secondary:F}=this.getSideEditors(ue);if(le&&F){if(ne?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(le,{filterByScheme:ne.filterByScheme}),secondary:this.getOriginalUri(F,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===x.ANY)return this.getOriginalUri(le,{filterByScheme:ne.filterByScheme})??this.getOriginalUri(F,{filterByScheme:ne.filterByScheme});ue=ne.supportSideBySide===x.PRIMARY?le:F}}if(a(ue)||g(ue)||k(ue))return;const he=u(ue)?ue.preferredResource:ue.resource;return!he||!ne||!ne.filterByScheme?he:this.filterUri(he,ne.filterByScheme)}getSideEditors(ue){return m(ue)||g(ue)?{primary:ue.primary,secondary:ue.secondary}:b(ue)||a(ue)?{primary:ue.modified,secondary:ue.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ue,ne){if(!ue)return;if(k(ue))return e.EditorResourceAccessor.getCanonicalUri(ue.result,ne);if(ne?.supportSideBySide){const{primary:le,secondary:F}=this.getSideEditors(ue);if(le&&F){if(ne?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(le,{filterByScheme:ne.filterByScheme}),secondary:this.getCanonicalUri(F,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===x.ANY)return this.getCanonicalUri(le,{filterByScheme:ne.filterByScheme})??this.getCanonicalUri(F,{filterByScheme:ne.filterByScheme});ue=ne.supportSideBySide===x.PRIMARY?le:F}}if(a(ue)||g(ue)||k(ue))return;const he=ue.resource;return!he||!ne||!ne.filterByScheme?he:this.filterUri(he,ne.filterByScheme)}filterUri(ue,ne){if(Array.isArray(ne)){if(ne.some(he=>ue.scheme===he))return ue}else if(ne===ue.scheme)return ue}}e.EditorResourceAccessor=new U;var N;(function(Q){Q[Q.LEFT=0]="LEFT",Q[Q.RIGHT=1]="RIGHT"})(N||(e.CloseDirection=N={}));class ae{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(ue){const ne=this.instantiationService=ue.get(T.IInstantiationService);for(const[he,le]of this.editorSerializerConstructors)this.createEditorSerializer(he,le,ne);this.editorSerializerConstructors.clear()}createEditorSerializer(ue,ne,he){const le=he.createInstance(ne);this.editorSerializerInstances.set(ue,le)}registerFileEditorFactory(ue){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=ue}getFileEditorFactory(){return(0,O.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(ue,ne){if(this.editorSerializerConstructors.has(ue)||this.editorSerializerInstances.has(ue))throw new Error(`A editor serializer with type ID '${ue}' was already registered.`);return this.instantiationService?this.createEditorSerializer(ue,ne,this.instantiationService):this.editorSerializerConstructors.set(ue,ne),(0,M.toDisposable)(()=>{this.editorSerializerConstructors.delete(ue),this.editorSerializerInstances.delete(ue)})}getEditorSerializer(ue){return this.editorSerializerInstances.get(typeof ue=="string"?ue:ue.typeId)}}h.Registry.add(e.EditorExtensions.EditorFactory,new ae);async function Y(Q,ue,ne){return!Q||!Q.length?[]:await Promise.all(Q.map(async he=>{const le=I.URI.revive(he.fileUri);if(!le){ne.info("Cannot resolve the path because it is not valid.",he);return}if(!await ue.canHandleResource(le)){ne.info("Cannot resolve the path because it cannot be handled",he);return}let J=he.exists,Se=he.type;if(typeof J!="boolean"||typeof Se!="number")try{Se=(await ue.stat(le)).isDirectory?y.FileType.Directory:y.FileType.Unknown,J=!0}catch(Ce){ne.error(Ce),J=!1}if(!J&&he.openOnlyIfExists){ne.info("Cannot resolve the path because it does not exist",he);return}if(Se===y.FileType.Directory){ne.info("Cannot resolve the path because it is a directory",he);return}const ke={...he.options,pinned:!0};return J?{resource:le,options:ke}:{resource:le,options:ke,forceUntitled:!0}}))}e.pathsToEditors=Y;var Ee;(function(Q){Q[Q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Q[Q.SEQUENTIAL=1]="SEQUENTIAL"})(Ee||(e.EditorsOrder=Ee={}));function ye(Q){const ue=Q;if(!ue)return!1;const ne=ue;if(ne.modified)return ye(ne.modified);const he=ue;return!!(he.contributionsState&&he.viewState&&Array.isArray(he.cursorState))}e.isTextEditorViewState=ye;function Re(Q){return(0,A.isErrorWithActions)(Q)}e.isEditorOpenError=Re;function K(Q,ue,ne){const he=(0,A.createErrorWithActions)(Q,ue);return he.forceMessage=ne?.forceMessage,he.forceSeverity=ne?.forceSeverity,he.allowDialog=ne?.allowDialog,he}e.createEditorOpenError=K}),define(Pe[193],Ae([1,0,5,160,3,6,28,30,18,65,24,89,184]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,c.registerIcon)("default-view-icon",_.Codicon.window,(0,O.localize)(0,null));var S;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var E;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(E||(e.ViewContainerLocation=E={})),e.ViewContainerLocations=[0,1,2];function o(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=o;class t extends M.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new w.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new w.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,y.flatten)([...this.viewContainers.values()])}registerViewContainer(s,v,D){const u=this.get(s.id);if(u)return u;const m=s;return m.openCommandActionDescriptor=D?.doNotRegisterOpenCommand?void 0:m.openCommandActionDescriptor??{id:m.id},(0,T.getOrSet)(this.viewContainers,v,[]).push(m),D?.isDefault&&this.defaultViewContainers.push(m),this._onDidRegister.fire({viewContainer:m,viewContainerLocation:v}),m}deregisterViewContainer(s){for(const v of this.viewContainers.keys()){const D=this.viewContainers.get(v),u=D?.indexOf(s);if(u!==-1){D?.splice(u,1),D.length===0&&this.viewContainers.delete(v),this._onDidDeregister.fire({viewContainer:s,viewContainerLocation:v});return}}}get(s){return this.all.filter(v=>v.id===s)[0]}getViewContainers(s){return[...this.viewContainers.get(s)||[]]}getViewContainerLocation(s){return[...this.viewContainers.keys()].filter(v=>this.getViewContainers(v).filter(D=>D?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.defaultViewContainers.find(v=>this.getViewContainerLocation(v)===s)}}h.Registry.add(S.ViewContainersRegistry,new t);var i;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(i||(e.ViewContentGroups=i={}));function a(n,s){const v=n.group??i.More,D=s.group??i.More;return v!==D?v.localeCompare(D):(n.order??5)-(s.order??5)}class g extends M.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new w.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new w.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new w.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new w.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new p.SetMap}registerViews(s,v){this.registerViews2([{views:s,viewContainer:v}])}registerViews2(s){s.forEach(({views:v,viewContainer:D})=>this.addViews(v,D)),this._onViewsRegistered.fire(s)}deregisterViews(s,v){const D=this.removeViews(s,v);D.length&&this._onViewsDeregistered.fire({views:D,viewContainer:v})}moveViews(s,v){for(const D of this._views.keys())if(D!==v){const u=this.removeViews(s,D);u.length&&(this.addViews(u,v),this._onDidChangeContainer.fire({views:u,from:D,to:v}))}}getViews(s){return this._views.get(s)||[]}getView(s){for(const v of this._viewContainers){const D=(this._views.get(v)||[]).filter(u=>u.id===s)[0];if(D)return D}return null}getViewContainer(s){for(const v of this._viewContainers)if((this._views.get(v)||[]).filter(u=>u.id===s)[0])return v;return null}registerViewWelcomeContent(s,v){return this._viewWelcomeContents.add(s,v),this._onDidChangeViewWelcomeContent.fire(s),(0,M.toDisposable)(()=>{this._viewWelcomeContents.delete(s,v),this._onDidChangeViewWelcomeContent.fire(s)})}registerViewWelcomeContent2(s,v){const D=new Map;for(const[u,m]of v)this._viewWelcomeContents.add(s,m),D.set(u,(0,M.toDisposable)(()=>{this._viewWelcomeContents.delete(s,m),this._onDidChangeViewWelcomeContent.fire(s)}));return this._onDidChangeViewWelcomeContent.fire(s),D}getViewWelcomeContent(s){const v=[];return this._viewWelcomeContents.forEach(s,D=>v.push(D)),v.sort(a)}addViews(s,v){let D=this._views.get(v);D||(D=[],this._views.set(v,D),this._viewContainers.push(v));for(const u of s){if(this.getView(u.id)!==null)throw new Error((0,O.localize)(1,null,u.id));D.push(u)}}removeViews(s,v){const D=this._views.get(v);if(!D)return[];const u=[],m=[];for(const b of D)s.includes(b)?u.push(b):m.push(b);return u.length&&(m.length?this._views.set(v,m):(this._views.delete(v),this._viewContainers.splice(this._viewContainers.indexOf(v),1))),u}}h.Registry.add(S.ViewsRegistry,new g),e.IViewsService=(0,I.createDecorator)("viewsService"),e.IViewDescriptorService=(0,I.createDecorator)("viewDescriptorService");var C;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(C||(e.ViewVisibilityState=C={}));var k;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(k||(e.TreeItemCollapsibleState=k={}));class r{constructor(s,v){this.resolved=!1,this._hasResolve=!1,(0,A.mixin)(this,s),this._hasResolve=!!v,this.resolve=async D=>{if(v&&!this.resolved){const u=await v(D);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}D.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r;class d extends Error{constructor(s){super((0,O.localize)(2,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.NoTreeViewError=d}),define(Pe[194],Ae([1,0,5,16,161]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new w.Emitter,this._onExit=new w.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(h){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=h}onEvent(h){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=h}onRequest(h){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=h}sendResponse(h){h.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${h.command}`)):this.internalSend("response",h)}sendRequest(h,y,p,A){const _={command:h};if(y&&Object.keys(y).length>0&&(_.arguments=y),this.internalSend("request",_),typeof A=="number"){const c=setTimeout(()=>{clearTimeout(c);const S=this.pendingRequests.get(_.seq);if(S){this.pendingRequests.delete(_.seq);const E={type:"response",seq:0,request_seq:_.seq,success:!1,command:h,message:(0,I.localize)(0,null,A,h)};S(E)}},A)}return p&&this.pendingRequests.set(_.seq,p),_.seq}acceptMessage(h){this.messageCallback?this.messageCallback(h):(this.queue.push(h),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(h,y){return h.type!=="event"||y.type!=="event"}async processQueue(){let h;for(;this.queue.length;){if((!h||this.needsTaskBoundaryBetween(this.queue[0],h))&&await(0,O.timeout)(0),h=this.queue.shift(),!h)return;switch(h.type){case"event":this.eventCallback?.(h);break;case"request":this.requestCallback?.(h);break;case"response":{const y=h,p=this.pendingRequests.get(y.request_seq);p&&(this.pendingRequests.delete(y.request_seq),p(y));break}}}}internalSend(h,y){y.type=h,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const h=new Map;this.pendingRequests.forEach((y,p)=>h.set(p,y)),await(0,O.timeout)(500),h.forEach((y,p)=>{y({type:"response",seq:0,request_seq:p,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(p)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=M}),define(Pe[195],Ae([1,0,162,31,3]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new O.RawContextKey("debugType",void 0,{type:"string",description:w.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new O.RawContextKey("debugConfigurationType",void 0,{type:"string",description:w.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new O.RawContextKey("debugState","inactive",{type:"string",description:w.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new O.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:w.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new O.RawContextKey("hasDebugged",!1,{type:"boolean",description:w.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new O.RawContextKey("inDebugMode",!1,{type:"boolean",description:w.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new O.RawContextKey("inDebugRepl",!1,{type:"boolean",description:w.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new O.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:w.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new O.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:w.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new O.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:w.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new O.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:w.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new O.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:w.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new O.RawContextKey("variablesFocused",!0,{type:"boolean",description:w.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new O.RawContextKey("expressionSelected",!1,{type:"boolean",description:w.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new O.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:w.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new O.RawContextKey("callStackItemType",void 0,{type:"string",description:w.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new O.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:w.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new O.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:w.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new O.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:w.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new O.RawContextKey("watchItemType",void 0,{type:"string",description:w.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new O.RawContextKey("canViewMemory",void 0,{type:"boolean",description:w.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new O.RawContextKey("breakpointItemType",void 0,{type:"string",description:w.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new O.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:w.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new O.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:w.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new O.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:w.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new O.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:w.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new O.RawContextKey("stepBackSupported",!1,{type:"boolean",description:w.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new O.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:w.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new O.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:w.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new O.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:w.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new O.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:w.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new O.RawContextKey("breakpointsExist",!1,{type:"boolean",description:w.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new O.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:w.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new O.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:w.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new O.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:w.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new O.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:w.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new O.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:w.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new O.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:w.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new O.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:w.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new O.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:w.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new O.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:w.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new O.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:w.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new O.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:w.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new O.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:w.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new O.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:w.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new O.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:w.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new O.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:w.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new O.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:w.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new O.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:w.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new O.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:w.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new O.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:w.localize(50,null)});const M=c=>w.localize(51,null,c);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:w.localize(52,null)};var T;(function(c){c[c.Inactive=0]="Inactive",c[c.Initializing=1]="Initializing",c[c.Stopped=2]="Stopped",c[c.Running=3]="Running"})(T||(e.State=T={}));function h(c){switch(c){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=h;var y;(function(c){c[c.Valid=0]="Valid",c[c.Unreadable=1]="Unreadable",c[c.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var p;(function(c){c[c.Initial=1]="Initial",c[c.Dynamic=2]="Dynamic"})(p||(e.DebugConfigurationProviderTriggerKind=p={}));var A;(function(c){c.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.IDebugService=(0,I.createDecorator)("debugService");var _;(function(c){c[c.CONDITION=0]="CONDITION",c[c.HIT_COUNT=1]="HIT_COUNT",c[c.LOG_MESSAGE=2]="LOG_MESSAGE"})(_||(e.BreakpointWidgetContext=_={}))}),define(Pe[196],Ae([1,0,15,2,19,24,13,44,20,18]),function(pe,e,w,O,I,M,T,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function _(u,m,b){return u.replace(A,function(l,f){return m&&f.length>0&&f[0]!=="_"?l:b&&b.hasOwnProperty(f)?b[f]:l})}e.formatPII=_;function c(u){const m={};for(const b of Object.keys(u))b.startsWith("!")||(m[b]=u[b]);return m}e.filterExceptionsFromTelemetry=c;function S(u){return u.configuration.request==="attach"&&!E(u)&&(!u.parentSession||S(u.parentSession))}e.isSessionAttach=S;function E(u){let m=u.configuration.type;if(m)return m==="vslsShare"&&(m=u.configuration.adapterProxy.configuration.type),(0,w.equalsIgnoreCase)(m,"extensionhost")||(0,w.equalsIgnoreCase)(m,"pwa-extensionhost")?u:u.parentSession?E(u.parentSession):void 0}e.getExtensionHostDebugSession=E;function o(u){return u.type&&(u.label||u.program||u.runtime)}e.isDebuggerMainContribution=o;function t(u,m,b){let l,f=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=P.exec(u);){const $=z.index+1,H=$+z[0].length;if($<=m&&H>=b){l=z[0],f=$;break}}if(l){const $=/\w+/g;let H=null;for(;(H=$.exec(l))&&!(H.index+1+f+H[0].length>=b););H&&(l=l.substring(0,$.lastIndex))}return l?{start:f,end:f+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=t;async function i(u,m,b,l){if(u.evaluatableExpressionProvider.has(m)){const f=u.evaluatableExpressionProvider.ordered(m),P=(0,p.coalesce)(await Promise.all(f.map(async z=>{try{return await z.provideEvaluatableExpression(m,b,l??y.CancellationToken.None)}catch{return}})));if(P.length>0){let z=P[0].expression;const $=P[0].range;return z||(z=m.getLineContent(b.lineNumber).substring($.startColumn-1,$.endColumn-1)),{range:$,matchingExpression:z}}}else{const f=m.getLineContent(b.lineNumber),{start:P,end:z}=t(f,b.column,b.column),$=f.substring(P-1,z);return{matchingExpression:$,range:new h.Range(b.lineNumber,P,b.lineNumber,P+$.length)}}return null}e.getEvaluatableExpressionAtPosition=i;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(u){return!!(u&&u.match(a))}e.isUri=g;function C(u){if(typeof u.path=="string"&&!(typeof u.sourceReference=="number"&&u.sourceReference>0)){if(g(u.path))return O.URI.parse(u.path);if((0,I.isAbsolute)(u.path))return O.URI.file(u.path)}return u.path}function k(u){if(typeof u.path=="object"){const m=O.URI.revive(u.path);if(m)return m.scheme===T.Schemas.file?m.fsPath:m.toString()}return u.path}function r(u,m){const b=m?C:k,l=(0,M.deepClone)(u);return n(l,(f,P)=>{f&&P&&(P.path=b(P))}),l}e.convertToDAPaths=r;function d(u,m){const b=m?C:k,l=(0,M.deepClone)(u);return n(l,(f,P)=>{!f&&P&&(P.path=b(P))}),l}e.convertToVSCPaths=d;function n(u,m){switch(u.type){case"event":{const b=u;switch(b.event){case"output":m(!1,b.body.source);break;case"loadedSource":m(!1,b.body.source);break;case"breakpoint":m(!1,b.body.breakpoint.source);break;default:break}break}case"request":{const b=u;switch(b.command){case"setBreakpoints":m(!0,b.arguments.source);break;case"breakpointLocations":m(!0,b.arguments.source);break;case"source":m(!0,b.arguments.source);break;case"gotoTargets":m(!0,b.arguments.source);break;case"launchVSCode":b.arguments.args.forEach(l=>m(!1,l));break;default:break}break}case"response":{const b=u;if(b.success&&b.body)switch(b.command){case"stackTrace":b.body.stackFrames.forEach(l=>m(!1,l.source));break;case"loadedSources":b.body.sources.forEach(l=>m(!1,l));break;case"scopes":b.body.scopes.forEach(l=>m(!1,l.source));break;case"setFunctionBreakpoints":b.body.breakpoints.forEach(l=>m(!1,l.source));break;case"setBreakpoints":b.body.breakpoints.forEach(l=>m(!1,l.source));break;case"disassemble":b.body?.instructions.forEach(f=>m(!1,f.location));break;default:break}break}}}function s(u){return u.filter(m=>!m.presentation?.hidden).sort((m,b)=>m.presentation?b.presentation?m.presentation.group?b.presentation.group?m.presentation.group!==b.presentation.group?m.presentation.group.localeCompare(b.presentation.group):v(m.presentation.order,b.presentation.order):-1:b.presentation.group?1:v(m.presentation.order,b.presentation.order):-1:b.presentation?1:0)}e.getVisibleAndSorted=s;function v(u,m){return typeof u!="number"?typeof m!="number"?0:1:typeof m!="number"?-1:u-m}async function D(u,m){const b=u.getValue("debug.saveBeforeStart",{overrideIdentifier:m.activeTextEditorLanguageId});if(b!=="none"&&(await m.saveAll(),b==="allEditorsInActiveGroup")){const l=m.activeEditorPane;l&&l.input.resource?.scheme===T.Schemas.untitled&&await m.save({editor:l.input,groupId:l.group.id})}await u.reloadConfiguration()}e.saveAllBeforeDebugStart=D}),define(Pe[75],Ae([1,0,25,37,68,69,13,19,22,31]),function(pe,e,w,O,I,M,T,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var A;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(A||(e.CellKind=A={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var _;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(_||(e.NotebookRunState=_={}));var c;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(c||(e.NotebookCellExecutionState=c={}));var S;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var E;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})(E||(e.NotebookRendererMatch=E={}));var o;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var a;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(a||(e.CellEditType=a={}));var g;(function(N){N.scheme=T.Schemas.vscodeNotebookCell;const ae=["W","X","Y","Z","a","b","c","d","e","f"],Y=new RegExp(`^[${ae.join("")}]+`),Ee=7;function ye(he,le){const F=le.toString(Ee),Se=`${F.length<ae.length?ae[F.length-1]:"z"}${F}s${(0,w.encodeBase64)(w.VSBuffer.fromString(he.scheme),!0,!0)}`;return he.with({scheme:N.scheme,fragment:Se})}N.generate=ye;function Re(he){if(he.scheme!==N.scheme)return;const le=he.fragment.indexOf("s");if(le<0)return;const F=parseInt(he.fragment.substring(0,le).replace(Y,""),Ee),J=(0,w.decodeBase64)(he.fragment.substring(le+1)).toString();if(!isNaN(F))return{handle:F,notebook:he.with({scheme:J,fragment:null})}}N.parse=Re;function K(he,le){return he.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${le??""},${he.scheme!==T.Schemas.file?he.scheme:""}`})}N.generateCellOutputUri=K;function Q(he){if(he.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const le=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(he.fragment);if(!le)return;const F=le[1]&&le[1]!==""?le[1]:void 0,J=le[2];return{outputId:F,notebook:he.with({scheme:J||T.Schemas.file,fragment:null})}}N.parseCellOutputUri=Q;function ue(he,le,F){return N.generate(he,le).with({scheme:F})}N.generateCellPropertyUri=ue;function ne(he,le){if(he.scheme===le)return N.parse(he.with({scheme:N.scheme}))}N.parseCellPropertyUri=ne})(g||(e.CellUri=g={}));const C=N=>y.isWindows?N.replace(/\//g,"\\"):N;class k{constructor(ae=[],Y=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=Y,this.order=[...new Set(ae)].map(Ee=>({pattern:Ee,matches:O.parse(C(Ee))}))}sort(ae){const Y=new Map(I.Iterable.map(ae,ye=>[ye,C(ye)]));let Ee=[];for(const{matches:ye}of this.order)for(const[Re,K]of Y)if(ye(K)){Ee.push(Re),Y.delete(Re);break}return Y.size&&(Ee=Ee.concat([...Y.keys()].sort((ye,Re)=>this.defaultOrder.indexOf(ye)-this.defaultOrder.indexOf(Re)))),Ee}prioritize(ae,Y){const Ee=this.findIndex(ae);if(Ee===-1){this.order.unshift({pattern:ae,matches:O.parse(C(ae))});return}const ye=new Set(Y.map(K=>this.findIndex(K,Ee)));ye.delete(-1);const Re=Array.from(ye).sort();this.order.splice(Ee+1,0,...Re.map(K=>this.order[K]));for(let K=Re.length-1;K>=0;K--)this.order.splice(Re[K],1)}toArray(){return this.order.map(ae=>ae.pattern)}findIndex(ae,Y=this.order.length){const Ee=C(ae);for(let ye=0;ye<Y;ye++)if(this.order[ye].matches(Ee))return ye;return-1}}e.MimeTypeDisplayOrder=k;function r(N,ae,Y,Ee=(ye,Re)=>ye===Re){const ye=[];function Re(ue,ne,he){if(ne===0&&he.length===0)return;const le=ye[ye.length-1];le&&le.start+le.deleteCount===ue?(le.deleteCount+=ne,le.toInsert.push(...he)):ye.push({start:ue,deleteCount:ne,toInsert:he})}let K=0,Q=0;for(;;){if(K===N.length){Re(K,0,ae.slice(Q));break}if(Q===ae.length){Re(K,N.length-K,[]);break}const ue=N[K],ne=ae[Q];if(Ee(ue,ne)){K+=1,Q+=1;continue}Y(ne)?(Re(K,1,[]),K+=1):(Re(K,0,[ne]),Q+=1)}return ye}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new p.RawContextKey("notebookEditorCursorAtBoundary","none");var d;(function(N){N.default="default",N.option="option"})(d||(e.NotebookEditorPriority=d={}));function n(N){const ae=N;return!!((typeof ae.include=="string"||O.isRelativePattern(ae.include))&&(typeof ae.exclude=="string"||O.isRelativePattern(ae.exclude)))}e.isDocumentExcludePattern=n;function s(N,ae,Y){if(Array.isArray(N.viewType)&&N.viewType.indexOf(ae)>=0||N.viewType===ae)return!0;if(N.filenamePattern){const Ee=n(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,ye=n(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(O.match(Ee,(0,h.basename)(Y.fsPath).toLowerCase()))return!(ye&&O.match(ye,(0,h.basename)(Y.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var v;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(v||(e.CellStatusbarAlignment=v={}));class D{static{this._prefix="notebook/"}static create(ae){return`${D._prefix}${ae}`}static parse(ae){if(ae.startsWith(D._prefix))return ae.substring(D._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=D;function u(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.isTextStreamMime=u;const m=new TextDecoder;function b(N){const ae=[];let Y=!1;for(const K of N)(ae.length===0||Y)&&(ae.push(K),Y=!0);let Ee=P(ae);const ye=w.VSBuffer.concat(ae.map(K=>w.VSBuffer.wrap(K))),Re=U(ye);return Ee=Ee||Re.byteLength!==ye.byteLength,{data:Re,didCompression:Ee}}e.compressOutputItemStreams=b,e.MOVE_CURSOR_1_LINE_COMMAND=`${String.fromCharCode(27)}[A`;const l=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(N=>N.charCodeAt(0)),f=10;function P(N){let ae=!1;return N.forEach((Y,Ee)=>{if(Ee===0||Y.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const ye=N[Ee-1],Re=Y.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(Re[0]===l[0]&&Re[1]===l[1]&&Re[2]===l[2]){const K=ye.lastIndexOf(f);if(K===-1)return;ae=!0,N[Ee-1]=ye.subarray(0,K),N[Ee]=Y.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),ae}function z(N){let ae=N;do N=ae,ae=N.replace(/[^\n]\x08/gm,"");while(ae.length<N.length);return N}function $(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const ae=N.match(/^(.*)\r+/m)[1];let Y=N.match(/\r+(.*)$/m)[1];Y=Y+ae.slice(Y.length,ae.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return N}const H="\b".charCodeAt(0),x="\r".charCodeAt(0);function U(N){return!N.buffer.includes(H)&&!N.buffer.includes(x)?N:w.VSBuffer.fromString($(z(m.decode(N.buffer))))}}),define(Pe[7],Ae([1,0,18,11,49,28,69,15,12,2,36,21,38,97,75]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E){"use strict";var o,t,i,a,g,C,k,r,d,n,s,v,D,u,m,b,l,f;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.NotebookCodeActionKind=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(B){return Object.assign(B,{apply:function(){const re=arguments.length===1?[]:arguments[1];return Reflect.construct(B,re,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(B,[]);{const[re,...De]=arguments;return Reflect.construct(B,De,re.constructor)}}})}var z;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(z||(e.TerminalOutputAnchor=z={}));var $;(function(B){B[B.Command=0]="Command",B[B.Opener=1]="Opener"})($||(e.TerminalQuickFixType=$={}));let H=o=class{static from(...L){let re=L;return new o(function(){if(re){for(const De of re)De&&typeof De.dispose=="function"&&De.dispose();re=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=H,e.Disposable=H=o=We([P],H);let x=t=class{static Min(...L){if(L.length===0)throw new TypeError;let re=L[0];for(let De=1;De<L.length;De++){const Ve=L[De];Ve.isBefore(re)&&(re=Ve)}return re}static Max(...L){if(L.length===0)throw new TypeError;let re=L[0];for(let De=1;De<L.length;De++){const Ve=L[De];Ve.isAfter(re)&&(re=Ve)}return re}static isPosition(L){if(!L)return!1;if(L instanceof t)return!0;const{line:re,character:De}=L;return typeof re=="number"&&typeof De=="number"}static of(L){if(L instanceof t)return L;if(this.isPosition(L))return new t(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(L,re){if(L<0)throw(0,O.illegalArgument)("line must be non-negative");if(re<0)throw(0,O.illegalArgument)("character must be non-negative");this._line=L,this._character=re}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,re=0){if(L===null||re===null)throw(0,O.illegalArgument)();let De;return typeof L>"u"?De=0:typeof L=="number"?De=L:(De=typeof L.lineDelta=="number"?L.lineDelta:0,re=typeof L.characterDelta=="number"?L.characterDelta:0),De===0&&re===0?this:new t(this.line+De,this.character+re)}with(L,re=this.character){if(L===null||re===null)throw(0,O.illegalArgument)();let De;return typeof L>"u"?De=this.line:typeof L=="number"?De=L:(De=typeof L.line=="number"?L.line:this.line,re=typeof L.character=="number"?L.character:this.character),De===this.line&&re===this.character?this:new t(De,re)}toJSON(){return{line:this.line,character:this.character}}};e.Position=x,e.Position=x=t=We([P],x);let U=i=class{static isRange(L){return L instanceof i?!0:L?x.isPosition(L.start)&&x.isPosition(L.end):!1}static of(L){if(L instanceof i)return L;if(this.isRange(L))return new i(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(L,re,De,Ve){let Xe,rt;if(typeof L=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Ve=="number"?(Xe=new x(L,re),rt=new x(De,Ve)):x.isPosition(L)&&x.isPosition(re)&&(Xe=x.of(L),rt=x.of(re)),!Xe||!rt)throw new Error("Invalid arguments");Xe.isBefore(rt)?(this._start=Xe,this._end=rt):(this._start=rt,this._end=Xe)}contains(L){return i.isRange(L)?this.contains(L.start)&&this.contains(L.end):x.isPosition(L)?!(x.of(L).isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const re=x.Max(L.start,this._start),De=x.Min(L.end,this._end);if(!re.isAfter(De))return new i(re,De)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const re=x.Min(L.start,this._start),De=x.Max(L.end,this.end);return new i(re,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,re=this.end){if(L===null||re===null)throw(0,O.illegalArgument)();let De;return L?x.isPosition(L)?De=L:(De=L.start||this.start,re=L.end||this.end):De=this.start,De.isEqual(this._start)&&re.isEqual(this.end)?this:new i(De,re)}toJSON(){return[this.start,this.end]}};e.Range=U,e.Range=U=i=We([P],U);let N=a=class extends U{static isSelection(L){return L instanceof a?!0:L?U.isRange(L)&&x.isPosition(L.anchor)&&x.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(L,re,De,Ve){let Xe,rt;if(typeof L=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Ve=="number"?(Xe=new x(L,re),rt=new x(De,Ve)):x.isPosition(L)&&x.isPosition(re)&&(Xe=x.of(L),rt=x.of(re)),!Xe||!rt)throw new Error("Invalid arguments");super(Xe,rt),this._anchor=Xe,this._active=rt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=N,e.Selection=N=a=We([P],N);const ae=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,O.illegalArgument)("connectionToken")};class Y{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,re,De){if(typeof L!="string"||L.length===0)throw(0,O.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,O.illegalArgument)("port");typeof De<"u"&&ae(De),this.host=L,this.port=Math.round(re),this.connectionToken=De}}e.ResolvedAuthority=Y;class Ee{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,re){this.makeConnection=L,this.connectionToken=re,typeof re<"u"&&ae(re)}}e.ManagedResolvedAuthority=Ee;class ye extends Error{static NotAvailable(L,re){return new ye(L,S.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(L){return new ye(L,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,re=S.RemoteAuthorityResolverErrorCode.Unknown,De){super(L),this._message=L,this._code=re,this._detail=De,Object.setPrototypeOf(this,ye.prototype)}}e.RemoteAuthorityResolverError=ye;var Re;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(Re||(e.EndOfLine=Re={}));var K;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(K||(e.EnvironmentVariableMutatorType=K={}));let Q=g=class{static isTextEdit(L){return L instanceof g?!0:L?U.isRange(L)&&typeof L.newText=="string":!1}static replace(L,re){return new g(L,re)}static insert(L,re){return g.replace(new U(L,L),re)}static delete(L){return g.replace(L,"")}static setEndOfLine(L){const re=new g(new U(new x(0,0),new x(0,0)),"");return re.newEol=L,re}get range(){return this._range}set range(L){if(L&&!U.isRange(L))throw(0,O.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,O.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,O.illegalArgument)("newEol");this._newEol=L}constructor(L,re){this._range=L,this._newText=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=Q,e.TextEdit=Q=g=We([P],Q);let ue=C=class{static isNotebookCellEdit(L){return L instanceof C?!0:L?Gt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,re){return new C(L,re)}static insertCells(L,re){return new C(new Gt(L,L),re)}static deleteCells(L){return new C(L,[])}static updateCellMetadata(L,re){const De=new C(new Gt(L,L),[]);return De.newCellMetadata=re,De}static updateNotebookMetadata(L){const re=new C(new Gt(0,0),[]);return re.newNotebookMetadata=L,re}constructor(L,re){this.range=L,this.newCells=re}};e.NotebookEdit=ue,e.NotebookEdit=ue=C=We([P],ue);class ne{static isSnippetTextEdit(L){return L instanceof ne?!0:L?U.isRange(L.range)&&F.isSnippetString(L.snippet):!1}static replace(L,re){return new ne(L,re)}static insert(L,re){return ne.replace(new U(L,L),re)}constructor(L,re){this.range=L,this.snippet=re}}e.SnippetTextEdit=ne;var he;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(he||(e.FileEditType=he={}));let le=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,re,De,Ve){this._edits.push({_type:1,from:L,to:re,options:De,metadata:Ve})}createFile(L,re,De){this._edits.push({_type:1,from:void 0,to:L,options:re,metadata:De})}deleteFile(L,re,De){this._edits.push({_type:1,from:L,to:void 0,options:re,metadata:De})}replaceNotebookMetadata(L,re,De){this._edits.push({_type:3,metadata:De,uri:L,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(L,re,De,Ve){const Xe=re.start,rt=re.end;(Xe!==rt||De.length>0)&&this._edits.push({_type:5,uri:L,index:Xe,count:rt-Xe,cells:De,metadata:Ve})}replaceNotebookCellMetadata(L,re,De,Ve){this._edits.push({_type:3,metadata:Ve,uri:L,edit:{editType:3,index:re,metadata:De}})}replace(L,re,De,Ve){this._edits.push({_type:2,uri:L,edit:new Q(re,De),metadata:Ve})}insert(L,re,De,Ve){this.replace(L,new U(re,re),De,Ve)}delete(L,re,De){this.replace(L,re,"",De)}has(L){return this._edits.some(re=>re._type===2&&re.uri.toString()===L.toString())}set(L,re){if(re)for(const De of re){if(!De)continue;let Ve,Xe;Array.isArray(De)?(Ve=De[0],Xe=De[1]):Ve=De,ue.isNotebookCellEdit(Ve)?Ve.newCellMetadata?this.replaceNotebookCellMetadata(L,Ve.range.start,Ve.newCellMetadata,Xe):Ve.newNotebookMetadata?this.replaceNotebookMetadata(L,Ve.newNotebookMetadata,Xe):this.replaceNotebookCells(L,Ve.range,Ve.newCells,Xe):ne.isSnippetTextEdit(Ve)?this._edits.push({_type:6,uri:L,range:Ve.range,edit:Ve.snippet,metadata:Xe}):this._edits.push({_type:2,uri:L,edit:Ve,metadata:Xe})}else{for(let De=0;De<this._edits.length;De++){const Ve=this._edits[De];switch(Ve._type){case 2:case 6:case 3:case 5:Ve.uri.toString()===L.toString()&&(this._edits[De]=void 0);break}}(0,w.coalesceInPlace)(this._edits)}}get(L){const re=[];for(const De of this._edits)De._type===2&&De.uri.toString()===L.toString()&&re.push(De.edit);return re}entries(){const L=new M.ResourceMap;for(const re of this._edits)if(re._type===2){let De=L.get(re.uri);De||(De=[re.uri,[]],L.set(re.uri,De)),De[1].push(re.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=le,e.WorkspaceEdit=le=We([P],le);let F=k=class{static isSnippetString(L){return L instanceof k?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this._tabstop=1,this.value=L||""}appendText(L){return this.value+=k._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,re=this._tabstop++){if(typeof L=="function"){const De=new k;De._tabstop=this._tabstop,L(De),this._tabstop=De._tabstop,L=De.value}else L=k._escape(L);return this.value+="${",this.value+=re,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,re=this._tabstop++){const De=L.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(L,re){if(typeof re=="function"){const De=new k;De._tabstop=this._tabstop,re(De),this._tabstop=De._tabstop,re=De.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.SnippetString=F,e.SnippetString=F=k=We([P],F);var J;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(J||(e.DiagnosticTag=J={}));var Se;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(Se||(e.DiagnosticSeverity=Se={}));let ke=r=class{static isLocation(L){return L instanceof r?!0:L?U.isRange(L.range)&&p.URI.isUri(L.uri):!1}constructor(L,re){if(this.uri=L,re)if(U.isRange(re))this.range=U.of(re);else if(x.isPosition(re))this.range=new U(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=ke,e.Location=ke=r=We([P],ke);let Ce=class{static is(L){return L?typeof L.message=="string"&&L.location&&U.isRange(L.location.range)&&p.URI.isUri(L.location.uri):!1}constructor(L,re){this.location=L,this.message=re}static isEqual(L,re){return L===re?!0:!L||!re?!1:L.message===re.message&&L.location.range.isEqual(re.location.range)&&L.location.uri.toString()===re.location.uri.toString()}};e.DiagnosticRelatedInformation=Ce,e.DiagnosticRelatedInformation=Ce=We([P],Ce);let _e=class{constructor(L,re,De=Se.Error){if(!U.isRange(L))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=L,this.message=re,this.severity=De}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,re){return L===re?!0:!L||!re?!1:L.message===re.message&&L.severity===re.severity&&L.code===re.code&&L.severity===re.severity&&L.source===re.source&&L.range.isEqual(re.range)&&(0,w.equals)(L.tags,re.tags)&&(0,w.equals)(L.relatedInformation,re.relatedInformation,Ce.isEqual)}};e.Diagnostic=_e,e.Diagnostic=_e=We([P],_e);let Ie=class{constructor(L,re){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=re}};e.Hover=Ie,e.Hover=Ie=We([P],Ie);var se;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(se||(e.DocumentHighlightKind=se={}));let fe=class{constructor(L,re=se.Text){this.range=L,this.kind=re}toJSON(){return{range:this.range,kind:se[this.kind]}}};e.DocumentHighlight=fe,e.DocumentHighlight=fe=We([P],fe);var ee;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var ie;(function(B){B[B.Deprecated=1]="Deprecated"})(ie||(e.SymbolTag=ie={}));let de=d=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,re,De,Ve,Xe){this.name=L,this.kind=re,this.containerName=Xe,typeof De=="string"&&(this.containerName=De),Ve instanceof ke?this.location=Ve:De instanceof U&&(this.location=new ke(Ve,De)),d.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=de,e.SymbolInformation=de=d=We([P],de);let R=n=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(n.validate)}constructor(L,re,De,Ve,Xe){this.name=L,this.detail=re,this.kind=De,this.range=Ve,this.selectionRange=Xe,this.children=[],n.validate(this)}};e.DocumentSymbol=R,e.DocumentSymbol=R=n=We([P],R);var W;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(W||(e.CodeActionTriggerKind=W={}));let V=class{constructor(L,re){this.title=L,this.kind=re}};e.CodeAction=V,e.CodeAction=V=We([P],V);let q=class{static{s=this}static{this.sep="."}constructor(L){this.value=L}append(L){return new s(this.value?this.value+s.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+s.sep)}};e.CodeActionKind=q,e.CodeActionKind=q=s=We([P],q);class oe extends q{constructor(L){super(L),this.value=L}}e.NotebookCodeActionKind=oe,q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorMove=q.Refactor.append("move"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll"),q.Notebook=q.Empty.append("notebook");let j=class{constructor(L,re){if(this.range=L,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=j,e.SelectionRange=j=We([P],j);class ce{constructor(L,re,De,Ve,Xe,rt){this.kind=L,this.name=re,this.detail=De,this.uri=Ve,this.range=Xe,this.selectionRange=rt}}e.CallHierarchyItem=ce;class ve{constructor(L,re){this.fromRanges=re,this.from=L}}e.CallHierarchyIncomingCall=ve;class Ue{constructor(L,re){this.fromRanges=re,this.to=L}}e.CallHierarchyOutgoingCall=Ue;var $e;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})($e||(e.LanguageStatusSeverity=$e={}));let Qe=class{constructor(L,re){this.range=L,this.command=re}get isResolved(){return!!this.command}};e.CodeLens=Qe,e.CodeLens=Qe=We([P],Qe);let qe=v=class{#e;static isMarkdownString(L){return L instanceof v?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,re=!1){this.#e=new I.MarkdownString(L,{supportThemeIcons:re})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,re){return this.#e.appendCodeblock(re??"",L),this}};e.MarkdownString=qe,e.MarkdownString=qe=v=We([P],qe);let Ye=class{constructor(L,re){this.label=L,this.documentation=re}};e.ParameterInformation=Ye,e.ParameterInformation=Ye=We([P],Ye);let Ke=class{constructor(L,re){this.label=L,this.documentation=re,this.parameters=[]}};e.SignatureInformation=Ke,e.SignatureInformation=Ke=We([P],Ke);let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=ct,e.SignatureHelp=ct=We([P],ct);var Ze;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(Ze||(e.SignatureHelpTriggerKind=Ze={}));var tt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let Ne=class{constructor(L){this.value=L}};e.InlayHintLabelPart=Ne,e.InlayHintLabelPart=Ne=We([P],Ne);let nt=class{constructor(L,re,De){this.position=L,this.label=re,this.kind=De}};e.InlayHint=nt,e.InlayHint=nt=We([P],nt);var Z;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Z||(e.CompletionTriggerKind=Z={}));var X;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(X||(e.CompletionItemKind=X={}));var ge;(function(B){B[B.Deprecated=1]="Deprecated"})(ge||(e.CompletionItemTag=ge={}));let Be=class{constructor(L,re){this.label=L,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&X[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Be,e.CompletionItem=Be=We([P],Be);let Me=class{constructor(L=[],re=!1){this.items=L,this.isIncomplete=re}};e.CompletionList=Me,e.CompletionList=Me=We([P],Me);let Ge=class{constructor(L,re,De){this.insertText=L,this.range=re,this.command=De}};e.InlineSuggestion=Ge,e.InlineSuggestion=Ge=We([P],Ge);let et=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.InlineSuggestionList=et,e.InlineSuggestionList=et=We([P],et);var mt;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(mt||(e.ViewColumn=mt={}));var wt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(wt||(e.StatusBarAlignment=wt={}));function Ut(B,L){return`${_.ExtensionIdentifier.toKey(B)}.${L}`}e.asStatusBarItemIdentifier=Ut;var Vt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(Vt||(e.TextEditorLineNumbersStyle=Vt={}));var zt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(zt||(e.TextDocumentSaveReason=zt={}));var St;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(St||(e.TextEditorRevealType=St={}));var At;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(At||(e.TextEditorSelectionChangeKind=At={}));var Rt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Rt||(e.TextDocumentChangeReason=Rt={}));var Lt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Lt||(e.DecorationRangeBehavior=Lt={})),function(B){function L(re){switch(re){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=L}(At||(e.TextEditorSelectionChangeKind=At={}));let xt=class{constructor(L,re){if(re&&!p.URI.isUri(re))throw(0,O.illegalArgument)("target");if(!U.isRange(L)||L.isEmpty)throw(0,O.illegalArgument)("range");this.range=L,this.target=re}};e.DocumentLink=xt,e.DocumentLink=xt=We([P],xt);let Ot=class{constructor(L,re,De,Ve){this.red=L,this.green=re,this.blue=De,this.alpha=Ve}};e.Color=Ot,e.Color=Ot=We([P],Ot);let st=class{constructor(L,re){if(re&&!(re instanceof Ot))throw(0,O.illegalArgument)("color");if(!U.isRange(L)||L.isEmpty)throw(0,O.illegalArgument)("range");this.range=L,this.color=re}};e.ColorInformation=st,e.ColorInformation=st=We([P],st);let dt=class{constructor(L){if(!L||typeof L!="string")throw(0,O.illegalArgument)("label");this.label=L}};e.ColorPresentation=dt,e.ColorPresentation=dt=We([P],dt);var Bt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Bt||(e.ColorFormat=Bt={}));var Ft;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Ft||(e.SourceControlInputBoxValidationType=Ft={}));var yt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(yt||(e.TerminalExitReason=yt={}));class ot{constructor(L,re,De){if(this.startIndex=L,this.length=re,this.tooltip=De,typeof L!="number"||L<0)throw(0,O.illegalArgument)("startIndex");if(typeof re!="number"||re<1)throw(0,O.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,O.illegalArgument)("tooltip")}}e.TerminalLink=ot;class Tt{constructor(L){this.uri=L}}e.TerminalQuickFixOpener=Tt;class Mt{constructor(L){this.terminalCommand=L}}e.TerminalQuickFixCommand=Mt;var Te;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Te||(e.TerminalLocation=Te={}));class we{constructor(L){if(this.options=L,typeof L!="object")throw(0,O.illegalArgument)("options")}}e.TerminalProfile=we;var be;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(be||(e.TaskRevealKind=be={}));var G;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(G||(e.TaskPanelKind=G={}));let Oe=class{static{D=this}static{this.Clean=new D("clean","Clean")}static{this.Build=new D("build","Build")}static{this.Rebuild=new D("rebuild","Rebuild")}static{this.Test=new D("test","Test")}static from(L){switch(L){case"clean":return D.Clean;case"build":return D.Build;case"rebuild":return D.Rebuild;case"test":return D.Test;default:return}}constructor(L,re){if(this.label=re,typeof L!="string"||typeof re!="string")throw(0,O.illegalArgument)("name");this._id=L}get id(){return this._id}};e.TaskGroup=Oe,e.TaskGroup=Oe=D=We([P],Oe);function xe(B){let L="";for(let re=0;re<B.length;re++)L+=B[re].replace(/,/g,",,")+",";return L}let je=class{constructor(L,re,De){if(typeof L!="string")throw(0,O.illegalArgument)("process");this._args=[],this._process=L,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=De):this._options=re)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,O.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(const re of this._args)L.push(re);return xe(L)}};e.ProcessExecution=je,e.ProcessExecution=je=We([P],je);let ze=class{constructor(L,re,De){if(this._args=[],Array.isArray(re)){if(!L)throw(0,O.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,O.illegalArgument)("command");this._command=L,this._args=re,this._options=De}else{if(typeof L!="string")throw(0,O.illegalArgument)("commandLine");this._commandLine=L,this._options=re}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,O.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,O.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const re of this._args)L.push(typeof re=="string"?re:re.value);return xe(L)}};e.ShellExecution=ze,e.ShellExecution=ze=We([P],ze);var Je;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Je||(e.ShellQuoting=Je={}));var Et;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Et||(e.TaskScope=Et={}));class Dt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=Dt;let Ct=class{static{u=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(L,re,De,Ve,Xe,rt){this.__deprecated=!1,this._definition=this.definition=L;let lt;typeof re=="string"?(this._name=this.name=re,this._source=this.source=De,this.execution=Ve,lt=Xe,this.__deprecated=!0):re===Et.Global||re===Et.Workspace?(this.target=re,this._name=this.name=De,this._source=this.source=Ve,this.execution=Xe,lt=rt):(this.target=re,this._name=this.name=De,this._source=this.source=Ve,this.execution=Xe,lt=rt),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof je?this._definition={type:u.ProcessType,id:this._execution.computeId()}:this._execution instanceof ze?this._definition={type:u.ShellType,id:this._execution.computeId()}:this._execution instanceof Dt?this._definition={type:u.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:u.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,O.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,O.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const re=this._definition.type;(u.EmptyType===re||u.ProcessType===re||u.ShellType===re||u.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,O.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};e.Task=Ct,e.Task=Ct=u=We([P],Ct);var vt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(vt||(e.ProgressLocation=vt={}));var gt;(function(B){function L(re){const De=re;return(0,y.isNumber)(De.value)?De.tooltip&&!(0,y.isString)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=L})(gt||(e.ViewBadge=gt={}));let ut=m=class{static isTreeItem(L,re){const De=L;if(De.checkboxState!==void 0){const Ve=(0,y.isNumber)(De.checkboxState)?De.checkboxState:(0,y.isObject)(De.checkboxState)&&(0,y.isNumber)(De.checkboxState.state)?De.checkboxState.state:void 0,Xe=!(0,y.isNumber)(De.checkboxState)&&(0,y.isObject)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ve===void 0||Ve!==ft.Checked&&Ve!==ft.Unchecked||Xe!==void 0&&!(0,y.isString)(Xe))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(L instanceof m)return!0;if(De.label!==void 0&&!(0,y.isString)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,y.isString)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,y.isString)(De.iconPath)&&!p.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,y.isString)(De.iconPath.id))){const Ve=De.iconPath;if(!Ve||!(0,y.isString)(Ve.light)&&!p.URI.isUri(Ve.light)&&!(0,y.isString)(Ve.dark)&&!p.URI.isUri(Ve.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,y.isString)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!p.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,y.isString)(De.tooltip)&&!(De.tooltip instanceof qe)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<pt.None&&De.collapsibleState>pt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,y.isString)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(L,re=pt.None){this.collapsibleState=re,p.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.TreeItem=ut,e.TreeItem=ut=m=We([P],ut);var pt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(pt||(e.TreeItemCollapsibleState=pt={}));var ft;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(ft||(e.TreeItemCheckboxState=ft={}));let Qt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.DataTransferItem=Qt,e.DataTransferItem=Qt=We([P],Qt);class $t extends Qt{}e.InternalDataTransferItem=$t;class Yi extends $t{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.InternalFileDataTransferItem=Yi;class di{constructor(L,re,De,Ve){this.name=L,this.uri=re,this._itemId=De,this._getData=Ve}data(){return this._getData()}}e.DataTransferFile=di;let hi=class{#e=new Map;constructor(L){for(const[re,De]of L??[]){const Ve=this.#e.get(this.#t(re));Ve?Ve.push(De):this.#e.set(this.#t(re),[De])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,re){this.#e.set(this.#t(L),[re])}forEach(L,re){for(const[De,Ve]of this.#e)for(const Xe of Ve)L.call(re,Xe,De,this)}*[Symbol.iterator](){for(const[L,re]of this.#e)for(const De of re)yield[L,De]}#t(L){return L.toLowerCase()}};e.DataTransfer=hi,e.DataTransfer=hi=We([P],hi);let It=class{constructor(L){this.insertText=L}};e.DocumentDropEdit=It,e.DocumentDropEdit=It=We([P],It);let Si=class{constructor(L,re,De){this.id=re,this.label=De,this.insertText=L}};e.DocumentPasteEdit=Si,e.DocumentPasteEdit=Si=We([P],Si);let qt=class{constructor(L,re){this.id=L,this.color=re}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.ThemeIcon=qt,e.ThemeIcon=qt=We([P],qt),qt.File=new qt("file"),qt.Folder=new qt("folder");let _t=class{constructor(L){this.id=L}};e.ThemeColor=_t,e.ThemeColor=_t=We([P],_t);var _i;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(_i||(e.ConfigurationTarget=_i={}));let fi=class{get base(){return this._base}set base(L){this._base=L,this._baseUri=p.URI.file(L)}get baseUri(){return this._baseUri}set baseUri(L){this._baseUri=L,this._base=L.fsPath}constructor(L,re){if(typeof L!="string"&&(!L||!p.URI.isUri(L)&&!p.URI.isUri(L.uri)))throw(0,O.illegalArgument)("base");if(typeof re!="string")throw(0,O.illegalArgument)("pattern");typeof L=="string"?this.baseUri=p.URI.file(L):p.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=fi,e.RelativePattern=fi=We([P],fi);const ai=new WeakMap;function Ji(B,L){ai.set(B,L)}e.setBreakpointId=Ji;let ni=class{constructor(L,re,De,Ve){this.enabled=typeof L=="boolean"?L:!0,typeof re=="string"&&(this.condition=re),typeof De=="string"&&(this.hitCondition=De),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=ai.get(this)??(0,A.generateUuid)()),this._id}};e.Breakpoint=ni,e.Breakpoint=ni=We([P],ni);let Pt=class extends ni{constructor(L,re,De,Ve,Xe){if(super(re,De,Ve,Xe),L===null)throw(0,O.illegalArgument)("location");this.location=L}};e.SourceBreakpoint=Pt,e.SourceBreakpoint=Pt=We([P],Pt);let mi=class extends ni{constructor(L,re,De,Ve,Xe){super(re,De,Ve,Xe),this.functionName=L}};e.FunctionBreakpoint=mi,e.FunctionBreakpoint=mi=We([P],mi);let yi=class extends ni{constructor(L,re,De,Ve,Xe,rt,lt){if(super(Ve,Xe,rt,lt),!re)throw(0,O.illegalArgument)("dataId");this.label=L,this.dataId=re,this.canPersist=De}};e.DataBreakpoint=yi,e.DataBreakpoint=yi=We([P],yi);let ri=class{constructor(L,re,De){this.command=L,this.args=re||[],this.options=De}};e.DebugAdapterExecutable=ri,e.DebugAdapterExecutable=ri=We([P],ri);let si=class{constructor(L,re){this.port=L,this.host=re}};e.DebugAdapterServer=si,e.DebugAdapterServer=si=We([P],si);let at=class{constructor(L){this.path=L}};e.DebugAdapterNamedPipeServer=at,e.DebugAdapterNamedPipeServer=at=We([P],at);let Di=class{constructor(L){this.implementation=L}};e.DebugAdapterInlineImplementation=Di,e.DebugAdapterInlineImplementation=Di=We([P],Di);let jt=class{constructor(L,re,De){this.session=L,this.threadId=re,this.frameId=De}};e.StackFrameFocus=jt,e.StackFrameFocus=jt=We([P],jt);let Zt=class{constructor(L,re){this.session=L,this.threadId=re}};e.ThreadFocus=Zt,e.ThreadFocus=Zt=We([P],Zt);let gi=class{constructor(L,re){this.range=L,this.expression=re}};e.EvaluatableExpression=gi,e.EvaluatableExpression=gi=We([P],gi);var Ui;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Ui||(e.InlineCompletionTriggerKind=Ui={}));let Ci=class{constructor(L,re){this.range=L,this.text=re}};e.InlineValueText=Ci,e.InlineValueText=Ci=We([P],Ci);let Ii=class{constructor(L,re,De=!0){this.range=L,this.variableName=re,this.caseSensitiveLookup=De}};e.InlineValueVariableLookup=Ii,e.InlineValueVariableLookup=Ii=We([P],Ii);let pi=class{constructor(L,re){this.range=L,this.expression=re}};e.InlineValueEvaluatableExpression=pi,e.InlineValueEvaluatableExpression=pi=We([P],pi);let ki=class{constructor(L,re){this.frameId=L,this.stoppedLocation=re}};e.InlineValueContext=ki,e.InlineValueContext=ki=We([P],ki);var Ti;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Ti||(e.FileChangeType=Ti={}));let ei=b=class extends Error{static FileExists(L){return new b(L,c.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(L){return new b(L,c.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(L){return new b(L,c.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(L){return new b(L,c.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(L){return new b(L,c.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(L){return new b(L,c.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}constructor(L,re=c.FileSystemProviderErrorCode.Unknown,De){super(p.URI.isUri(L)?L.toString(!0):L),this.code=De?.name??"Unknown",(0,c.markAsFileSystemProviderError)(this,re),Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.FileSystemError=ei,e.FileSystemError=ei=b=We([P],ei);let Pi=class{constructor(L,re,De){this.start=L,this.end=re,this.kind=De}};e.FoldingRange=Pi,e.FoldingRange=Pi=We([P],Pi);var vi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(vi||(e.FoldingRangeKind=vi={}));var Ei;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Ei||(e.CommentThreadCollapsibleState=Ei={}));var xi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(xi||(e.CommentMode=xi={}));var Bi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Bi||(e.CommentState=Bi={}));var oi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(oi||(e.CommentThreadState=oi={}));class Zi{constructor(L,re=[]){this.tokenTypes=L,this.tokenModifiers=re}}e.SemanticTokensLegend=Zi;function en(B){return typeof B>"u"||(0,y.isStringArray)(B)}class Ai{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let re=0,De=L.tokenTypes.length;re<De;re++)this._tokenTypeStrToInt.set(L.tokenTypes[re],re);for(let re=0,De=L.tokenModifiers.length;re<De;re++)this._tokenModifierStrToInt.set(L.tokenModifiers[re],re)}}push(L,re,De,Ve,Xe){if(typeof L=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Ve=="number"&&(typeof Xe=="number"||typeof Xe>"u"))return typeof Xe>"u"&&(Xe=0),this._pushEncoded(L,re,De,Ve,Xe);if(U.isRange(L)&&typeof re=="string"&&en(De))return this._push(L,re,De);throw(0,O.illegalArgument)()}_push(L,re,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Ve=L.start.line,Xe=L.start.character,rt=L.end.character-L.start.character,lt=this._tokenTypeStrToInt.get(re);let Nt=0;if(De)for(const Wt of De){if(!this._tokenModifierStrToInt.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const Xt=this._tokenModifierStrToInt.get(Wt);Nt|=1<<Xt>>>0}this._pushEncoded(Ve,Xe,rt,lt,Nt)}_pushEncoded(L,re,De,Ve,Xe){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Nt=this._data.length/5|0;let Wt=0,Xt=0;for(let Jt=0;Jt<Nt;Jt++){let ti=this._data[5*Jt],Mi=this._data[5*Jt+1];ti===0?(ti=Wt,Mi+=Xt):ti+=Wt,this._data[5*Jt]=ti,this._data[5*Jt+1]=Mi,Wt=ti,Xt=Mi}}let rt=L,lt=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=Xe,this._prevLine=L,this._prevChar=re}static _sortAndDeltaEncode(L){const re=[],De=L.length/5|0;for(let lt=0;lt<De;lt++)re[lt]=lt;re.sort((lt,Nt)=>{const Wt=L[5*lt],Xt=L[5*Nt];if(Wt===Xt){const Jt=L[5*lt+1],ti=L[5*Nt+1];return Jt-ti}return Wt-Xt});const Ve=new Uint32Array(L.length);let Xe=0,rt=0;for(let lt=0;lt<De;lt++){const Nt=5*re[lt],Wt=L[Nt+0],Xt=L[Nt+1],Jt=L[Nt+2],ti=L[Nt+3],Mi=L[Nt+4],Sn=Wt-Xe,Nn=Sn===0?Xt-rt:Xt,Ni=5*lt;Ve[Ni+0]=Sn,Ve[Ni+1]=Nn,Ve[Ni+2]=Jt,Ve[Ni+3]=ti,Ve[Ni+4]=Mi,Xe=Wt,rt=Xt}return Ve}build(L){return this._dataIsSortedAndDeltaEncoded?new Yt(new Uint32Array(this._data),L):new Yt(Ai._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=Ai;class Yt{constructor(L,re){this.resultId=re,this.data=L}}e.SemanticTokens=Yt;class tn{constructor(L,re,De){this.start=L,this.deleteCount=re,this.data=De}}e.SemanticTokensEdit=tn;class nn{constructor(L,re){this.resultId=re,this.edits=L}}e.SemanticTokensEdits=nn;var Ri;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Ri||(e.DebugConsoleMode=Ri={}));let Oi=class{static{this.Back={iconPath:new qt("arrow-left")}}constructor(){}};e.QuickInputButtons=Oi,e.QuickInputButtons=Oi=We([P],Oi);var $i;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})($i||(e.QuickPickItemKind=$i={}));var zi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(zi||(e.InputBoxValidationSeverity=zi={}));var bi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(bi||(e.ExtensionKind=bi={}));class Hi{static validate(L){if(typeof L.badge=="string"){let re=(0,h.nextCharLength)(L.badge,0);if(re<L.badge.length&&(re+=(0,h.nextCharLength)(L.badge,re)),L.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!qt.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,re,De){this.badge=L,this.tooltip=re,this.color=De}}e.FileDecoration=Hi;let Le=class{constructor(L){this.kind=L}};e.ColorTheme=Le,e.ColorTheme=Le=We([P],Le);var Kt;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Kt||(e.ColorThemeKind=Kt={}));class Gt{static isNotebookRange(L){return L instanceof Gt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(L,re){if(L<0)throw(0,O.illegalArgument)("start must be positive");if(re<0)throw(0,O.illegalArgument)("end must be positive");L<=re?(this._start=L,this._end=re):(this._start=re,this._end=L)}with(L){let re=this._start,De=this._end;return L.start!==void 0&&(re=L.start),L.end!==void 0&&(De=L.end),re===this._start&&De===this._end?this:new Gt(re,De)}}e.NotebookRange=Gt;class ht{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(re=>ht.isNotebookCellData(re))}static isNotebookCellData(L){return!0}constructor(L,re,De,Ve,Xe,rt,lt){this.kind=L,this.value=re,this.languageId=De,this.mime=Ve,this.outputs=Xe??[],this.metadata=rt,this.executionSummary=lt,ht.validate(this)}}e.NotebookCellData=ht;class rn{constructor(L){this.cells=L}}e.NotebookData=rn;class Ht{static isNotebookCellOutputItem(L){return L instanceof Ht?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const re={name:L.name,message:L.message,stack:L.stack};return Ht.json(re,"application/vnd.code.notebook.error")}static stdout(L){return Ht.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Ht.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,re="application/octet-stream"){return new Ht(L,re)}static#e=new TextEncoder;static text(L,re=T.Mimes.text){const De=Ht.#e.encode(String(L));return new Ht(De,re)}static json(L,re="text/x-json"){const De=JSON.stringify(L,void 0,"	");return Ht.text(De,re)}constructor(L,re){this.data=L,this.mime=re;const De=(0,T.normalizeMimeType)(re,!0);if(!De)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.NotebookCellOutputItem=Ht;class ci{static isNotebookCellOutput(L){return L instanceof ci?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,re=!1){const De=new Set,Ve=new Set;for(let Xe=0;Xe<L.length;Xe++){const rt=L[Xe],lt=(0,T.normalizeMimeType)(rt.mime);if(!De.has(lt)||(0,E.isTextStreamMime)(lt)){De.add(lt);continue}Ve.add(Xe),re&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return Ve.size===0?L:L.filter((Xe,rt)=>!Ve.has(rt))}constructor(L,re,De){this.items=ci.ensureUniqueMimeTypes(L,!0),typeof re=="string"?(this.id=re,this.metadata=De):(this.id=(0,A.generateUuid)(),this.metadata=re??De)}}e.NotebookCellOutput=ci;var Wi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Wi||(e.NotebookCellKind=Wi={}));var li;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(li||(e.NotebookCellExecutionState=li={}));var Vi;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Vi||(e.NotebookCellStatusBarAlignment=Vi={}));var qi;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(qi||(e.NotebookEditorRevealType=qi={}));class sn{constructor(L,re){this.text=L,this.alignment=re}}e.NotebookCellStatusBarItem=sn;var Fi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Fi||(e.NotebookControllerAffinity=Fi={}));var ji;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(ji||(e.NotebookControllerAffinity2=ji={}));class on{constructor(L,re=[]){this.uri=L,this.provides=(0,w.asArray)(re)}}e.NotebookRendererScript=on;class an{constructor(L){this.label=L}}e.NotebookKernelSourceAction=an;let Li=class{constructor(L,re){this.label=L,this.timestamp=re}};e.TimelineItem=Li,e.TimelineItem=Li=We([P],Li);var Ki;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(Ki||(e.ExtensionMode=Ki={}));var Gi;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(Gi||(e.ExtensionRuntime=Gi={}));var Xi;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Xi||(e.StandardTokenType=Xi={}));class cn{constructor(L,re){this.ranges=L,this.wordPattern=re}}e.LinkedEditingRanges=cn;class ln{constructor(L){this._autoForwardAction=L}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ln;var te;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(te||(e.TestResultState=te={}));var me;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(me||(e.TestRunProfileKind=me={}));let Fe=class{constructor(L=void 0,re=void 0,De=void 0,Ve=!1){this.include=L,this.exclude=re,this.profile=De,this.continuous=Ve}};e.TestRunRequest=Fe,e.TestRunRequest=Fe=We([P],Fe);let it=class extends Fe{};e.TestRunRequest2=it,e.TestRunRequest2=it=We([P],it);let bt=l=class{static diff(L,re,De){const Ve=new l(L);return Ve.expectedOutput=re,Ve.actualOutput=De,Ve}constructor(L){this.message=L}};e.TestMessage=bt,e.TestMessage=bt=l=We([P],bt);let kt=class{constructor(L){this.id=L}};e.TestTag=kt,e.TestTag=kt=We([P],kt);let wi=class{constructor(L,re){this.covered=L,this.total=re}};e.CoveredCount=wi,e.CoveredCount=wi=We([P],wi);let un=f=class{static fromDetails(L,re){const De=new wi(0,0),Ve=new wi(0,0),Xe=new wi(0,0);for(const lt of re)if("branches"in lt){De.total+=1,De.covered+=lt.executionCount>0?1:0;for(const Nt of lt.branches)Ve.total+=1,Ve.covered+=Nt.executionCount>0?1:0}else Xe.total+=1,Xe.covered+=lt.executionCount>0?1:0;const rt=new f(L,De,Ve.total>0?Ve:void 0,Xe.total>0?Xe:void 0);return rt.detailedCoverage=re,rt}constructor(L,re,De,Ve){this.uri=L,this.statementCoverage=re,this.branchCoverage=De,this.functionCoverage=Ve}};e.FileCoverage=un,e.FileCoverage=un=f=We([P],un);let dn=class{constructor(L,re,De=[]){this.executionCount=L,this.location=re,this.branches=De}};e.StatementCoverage=dn,e.StatementCoverage=dn=We([P],dn);let hn=class{constructor(L,re){this.executionCount=L,this.location=re}};e.BranchCoverage=hn,e.BranchCoverage=hn=We([P],hn);let fn=class{constructor(L,re){this.executionCount=L,this.location=re}};e.FunctionCoverage=fn,e.FunctionCoverage=fn=We([P],fn);var gn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(gn||(e.ExternalUriOpenerPriority=gn={}));var pn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(pn||(e.WorkspaceTrustState=pn={}));var vn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(vn||(e.PortAutoForwardAction=vn={}));class In{constructor(L,re,De,Ve,Xe,rt){this.kind=L,this.name=re,this.detail=De,this.uri=Ve,this.range=Xe,this.selectionRange=rt}}e.TypeHierarchyItem=In;class kn{constructor(L){this.uri=L}}e.TextTabInput=kn;class Tn{constructor(L,re){this.original=L,this.modified=re}}e.TextDiffTabInput=Tn;class Pn{constructor(L,re,De,Ve){this.base=L,this.input1=re,this.input2=De,this.result=Ve}}e.TextMergeTabInput=Pn;class An{constructor(L,re){this.uri=L,this.viewType=re}}e.CustomEditorTabInput=An;class Rn{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=Rn;class On{constructor(L,re){this.uri=L,this.notebookType=re}}e.NotebookEditorTabInput=On;class Fn{constructor(L,re,De){this.original=L,this.modified=re,this.notebookType=De}}e.NotebookDiffEditorTabInput=Fn;class Ln{constructor(){}}e.TerminalEditorTabInput=Ln;class Mn{constructor(L,re){this.uri=L,this.inputBoxUri=re}}e.InteractiveWindowInput=Mn;var En;(function(B){B[B.Up=1]="Up",B[B.Down=2]="Down"})(En||(e.InteractiveSessionVoteDirection=En={}));var bn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(bn||(e.InteractiveSessionCopyKind=bn={}));var wn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted"})(wn||(e.InteractiveEditorResponseFeedbackKind=wn={}))}),define(Pe[100],Ae([1,0,50,13,15,273,136,7,18]),function(pe,e,w,O,I,M,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const p=new Map;function A(E,o){o?p.set(E,o):p.delete(E)}e.setWordDefinitionFor=A;function _(E){return p.get(E)}class c extends M.MirrorTextModel{constructor(o,t,i,a,g,C,k,r){super(t,i,a,g),this._proxy=o,this._languageId=C,this._isDirty=k,this.notebook=r,this._isDisposed=!1}dispose(){(0,w.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(o){return(0,y.equals)(this._lines,o)}get document(){if(!this._document){const o=this;this._document={get uri(){return o._uri},get fileName(){return o._uri.fsPath},get isUntitled(){return o._uri.scheme===O.Schemas.untitled},get languageId(){return o._languageId},get version(){return o._versionId},get isClosed(){return o._isDisposed},get isDirty(){return o._isDirty},save(){return o._save()},getText(t){return t?o._getTextInRange(t):o.getText()},get eol(){return o._eol===`
`?h.EndOfLine.LF:h.EndOfLine.CRLF},get lineCount(){return o._lines.length},lineAt(t){return o._lineAt(t)},offsetAt(t){return o._offsetAt(t)},positionAt(t){return o._positionAt(t)},validateRange(t){return o._validateRange(t)},validatePosition(t){return o._validatePosition(t)},getWordRangeAtPosition(t,i){return o._getWordRangeAtPosition(t,i)}}}return Object.freeze(this._document)}_acceptLanguageId(o){(0,w.ok)(!this._isDisposed),this._languageId=o}_acceptIsDirty(o){(0,w.ok)(!this._isDisposed),this._isDirty=o}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(o){const t=this._validateRange(o);if(t.isEmpty)return"";if(t.isSingleLine)return this._lines[t.start.line].substring(t.start.character,t.end.character);const i=this._eol,a=t.start.line,g=t.end.line,C=[];C.push(this._lines[a].substring(t.start.character));for(let k=a+1;k<g;k++)C.push(this._lines[k]);return C.push(this._lines[g].substring(0,t.end.character)),C.join(i)}_lineAt(o){let t;if(o instanceof h.Position?t=o.line:typeof o=="number"&&(t=o),typeof t!="number"||t<0||t>=this._lines.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new S(t,this._lines[t],t===this._lines.length-1)}_offsetAt(o){return o=this._validatePosition(o),this._ensureLineStarts(),this._lineStarts.getPrefixSum(o.line-1)+o.character}_positionAt(o){o=Math.floor(o),o=Math.max(0,o),this._ensureLineStarts();const t=this._lineStarts.getIndexOf(o),i=this._lines[t.index].length;return new h.Position(t.index,Math.min(t.remainder,i))}_validateRange(o){if(!(o instanceof h.Range))throw new Error("Invalid argument");const t=this._validatePosition(o.start),i=this._validatePosition(o.end);return t===o.start&&i===o.end?o:new h.Range(t.line,t.character,i.line,i.character)}_validatePosition(o){if(!(o instanceof h.Position))throw new Error("Invalid argument");if(this._lines.length===0)return o.with(0,0);let{line:t,character:i}=o,a=!1;if(t<0)t=0,i=0,a=!0;else if(t>=this._lines.length)t=this._lines.length-1,i=this._lines[t].length,a=!0;else{const g=this._lines[t].length;i<0?(i=0,a=!0):i>g&&(i=g,a=!0)}return a?new h.Position(t,i):o}_getWordRangeAtPosition(o,t){const i=this._validatePosition(o);if(!t)t=_(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const a=(0,T.getWordAtText)(i.character+1,(0,T.ensureValidWordDefinition)(t),this._lines[i.line],0);if(a)return new h.Range(i.line,a.startColumn-1,i.line,a.endColumn-1)}}e.ExtHostDocumentData=c;class S{constructor(o,t,i){this._line=o,this._text=t,this._isLastLine=i}get lineNumber(){return this._line}get text(){return this._text}get range(){return new h.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new h.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=S}),define(Pe[197],Ae([1,0,7,17,5]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(h){this._actual=new w.ColorTheme(w.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(h){let y;switch(h){case"light":y=w.ColorThemeKind.Light;break;case"hcDark":y=w.ColorThemeKind.HighContrast;break;case"hcLight":y=w.ColorThemeKind.HighContrastLight;break;default:y=w.ColorThemeKind.Dark}this._actual=new w.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=M,e.ExtHostTheming=M=We([He(0,O.IExtHostRpcService)],M)}),define(Pe[198],Ae([1,0,3]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var O;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.INotebookExecutionService=(0,w.createDecorator)("INotebookExecutionService")}),define(Pe[45],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(M){M.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var O;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class I{static fromExtHostTestItem(T,h,y=T.parent){if(T._isRoot)return new I([h]);const p=[T.id];for(let A=y;A&&A.id!==h;A=A.parent)p.push(A.id);return p.push(h),new I(p.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const h=T.indexOf("\0");return h===-1?T:T.slice(0,h)}static fromString(T){return new I(T.split("\0"))}static join(T,h){return new I([...T.path,h])}static joinToString(T,h){return T.toString()+"\0"+h}static parentId(T){const h=T.lastIndexOf("\0");return h===-1?void 0:T.slice(0,h)}static localId(T){const h=T.lastIndexOf("\0");return h===-1?T:T.slice(h+1)}static isChild(T,h){return h.startsWith(T)&&h[T.length]==="\0"}static compare(T,h){return T===h?0:I.isChild(T,h)?2:I.isChild(h,T)?3:1}constructor(T,h=T.length){if(this.path=T,this.viewEnd=h,T.length===0||h<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new I(this.path,T)}*idsToRoot(){for(let T=this.viewEnd;T>0;T--)yield new I(this.path,T)}compare(T){if(typeof T=="string")return I.compare(this.toString(),T);for(let h=0;h<T.viewEnd&&h<this.viewEnd;h++)if(T.path[h]!==this.path[h])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=I}),define(Pe[57],Ae([1,0,2,44,45]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(m){m[m.Unset=0]="Unset",m[m.Queued=1]="Queued",m[m.Running=2]="Running",m[m.Passed=3]="Passed",m[m.Failed=4]="Failed",m[m.Skipped=5]="Skipped",m[m.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var T;(function(m){m[m.Run=1]="Run",m[m.Debug=2]="Debug",m[m.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var h;(function(m){m[m.Run=2]="Run",m[m.Debug=4]="Debug",m[m.Coverage=8]="Coverage",m[m.HasNonDefaultProfile=16]="HasNonDefaultProfile",m[m.HasConfigurable=32]="HasConfigurable",m[m.SupportsContinuousRun=64]="SupportsContinuousRun"})(h||(e.TestRunProfileBitset=h={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const y=m=>"runId"in m;e.isStartControllerTests=y;var p;(function(m){m.serialize=b=>({range:b.range.toJSON(),uri:b.uri.toJSON()}),m.deserialize=b=>({range:O.Range.lift(b.range),uri:w.URI.revive(b.uri)})})(p||(e.IRichLocation=p={}));var A;(function(m){m[m.Error=0]="Error",m[m.Output=1]="Output"})(A||(e.TestMessageType=A={}));var _;(function(m){m.serialize=b=>({message:b.message,type:0,expected:b.expected,actual:b.actual,location:b.location&&p.serialize(b.location)}),m.deserialize=b=>({message:b.message,type:0,expected:b.expected,actual:b.actual,location:b.location&&p.deserialize(b.location)})})(_||(e.ITestErrorMessage=_={}));const c=(m,b)=>`${b?"s":"e"}${m}`;e.getMarkId=c;var S;(function(m){m.serialize=b=>({message:b.message,type:1,offset:b.offset,length:b.length,location:b.location&&p.serialize(b.location)}),m.deserialize=b=>({message:b.message,type:1,offset:b.offset,length:b.length,location:b.location&&p.deserialize(b.location)})})(S||(e.ITestOutputMessage=S={}));var E;(function(m){m.serialize=b=>b.type===0?_.serialize(b):S.serialize(b),m.deserialize=b=>b.type===0?_.deserialize(b):S.deserialize(b)})(E||(e.ITestMessage=E={}));var o;(function(m){m.serializeWithoutMessages=b=>({state:b.state,duration:b.duration,messages:[]}),m.serialize=b=>({state:b.state,duration:b.duration,messages:b.messages.map(E.serialize)}),m.deserialize=b=>({state:b.state,duration:b.duration,messages:b.messages.map(E.deserialize)})})(o||(e.ITestTaskState=o={}));const t="\0",i=(m,b)=>m+t+b;e.namespaceTestTag=i;const a=m=>{const b=m.indexOf(t);return{ctrlId:m.slice(0,b),tagId:m.slice(b+1)}};e.denamespaceTestTag=a;var g;(function(m){m.serialize=b=>({extId:b.extId,label:b.label,tags:b.tags,busy:b.busy,children:void 0,uri:b.uri?.toJSON(),range:b.range?.toJSON()||null,description:b.description,error:b.error,sortText:b.sortText}),m.deserialize=b=>({extId:b.extId,label:b.label,tags:b.tags,busy:b.busy,children:void 0,uri:b.uri?w.URI.revive(b.uri):void 0,range:b.range?O.Range.lift(b.range):null,description:b.description,error:b.error,sortText:b.sortText})})(g||(e.ITestItem=g={}));var C;(function(m){m[m.NotExpandable=0]="NotExpandable",m[m.Expandable=1]="Expandable",m[m.BusyExpanding=2]="BusyExpanding",m[m.Expanded=3]="Expanded"})(C||(e.TestItemExpandState=C={}));var k;(function(m){m.serialize=b=>({expand:b.expand,item:g.serialize(b.item)}),m.deserialize=b=>({controllerId:I.TestId.root(b.item.extId),expand:b.expand,item:g.deserialize(b.item)})})(k||(e.InternalTestItem=k={}));var r;(function(m){m.serialize=b=>{let l;return b.item&&(l={},b.item.label!==void 0&&(l.label=b.item.label),b.item.tags!==void 0&&(l.tags=b.item.tags),b.item.busy!==void 0&&(l.busy=b.item.busy),b.item.uri!==void 0&&(l.uri=b.item.uri?.toJSON()),b.item.range!==void 0&&(l.range=b.item.range?.toJSON()),b.item.description!==void 0&&(l.description=b.item.description),b.item.error!==void 0&&(l.error=b.item.error),b.item.sortText!==void 0&&(l.sortText=b.item.sortText)),{extId:b.extId,expand:b.expand,item:l}},m.deserialize=b=>{let l;return b.item&&(l={},b.item.label!==void 0&&(l.label=b.item.label),b.item.tags!==void 0&&(l.tags=b.item.tags),b.item.busy!==void 0&&(l.busy=b.item.busy),b.item.range!==void 0&&(l.range=b.item.range?O.Range.lift(b.item.range):null),b.item.description!==void 0&&(l.description=b.item.description),b.item.error!==void 0&&(l.error=b.item.error),b.item.sortText!==void 0&&(l.sortText=b.item.sortText)),{extId:b.extId,expand:b.expand,item:l}}})(r||(e.ITestItemUpdate=r={}));const d=(m,b)=>{b.expand!==void 0&&(m.expand=b.expand),b.item!==void 0&&(m.item=m.item?Object.assign(m.item,b.item):b.item)};e.applyTestItemUpdate=d;var n;(function(m){m.serializeWithoutMessages=b=>({...k.serialize(b),ownComputedState:b.ownComputedState,computedState:b.computedState,tasks:b.tasks.map(o.serializeWithoutMessages)}),m.serialize=b=>({...k.serialize(b),ownComputedState:b.ownComputedState,computedState:b.computedState,tasks:b.tasks.map(o.serialize)}),m.deserialize=b=>({...k.deserialize(b),ownComputedState:b.ownComputedState,computedState:b.computedState,tasks:b.tasks.map(o.deserialize),retired:!0})})(n||(e.TestResultItem=n={}));var s;(function(m){m[m.Function=0]="Function",m[m.Statement=1]="Statement"})(s||(e.DetailType=s={}));var v;(function(m){m[m.Add=0]="Add",m[m.Update=1]="Update",m[m.DocumentSynced=2]="DocumentSynced",m[m.Remove=3]="Remove",m[m.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",m[m.Retire=5]="Retire",m[m.AddTag=6]="AddTag",m[m.RemoveTag=7]="RemoveTag"})(v||(e.TestDiffOpType=v={}));var D;(function(m){m.deserialize=b=>b.op===0?{op:b.op,item:k.deserialize(b.item)}:b.op===1?{op:b.op,item:r.deserialize(b.item)}:b.op===2?{op:b.op,uri:w.URI.revive(b.uri),docv:b.docv}:b,m.serialize=b=>b.op===0?{op:b.op,item:k.serialize(b.item)}:b.op===1?{op:b.op,item:r.serialize(b.item)}:b})(D||(e.TestsDiffOp=D={}));class u{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(b){const l=this.createChangeCollector();for(const f of b)switch(f.op){case 0:this.add(k.deserialize(f.item),l);break;case 1:this.update(r.deserialize(f.item),l);break;case 3:this.remove(f.itemId,l);break;case 5:this.retireTest(f.itemId);break;case 4:this.updatePendingRoots(f.amount);break;case 6:this._tags.set(f.tag.id,f.tag);break;case 7:this._tags.delete(f.id);break}l.complete?.()}add(b,l){const f=I.TestId.parentId(b.item.extId)?.toString();let P;if(!f)P=this.createItem(b),this.roots.add(P),this.items.set(b.item.extId,P);else if(this.items.has(f)){const z=this.items.get(f);z.children.add(b.item.extId),P=this.createItem(b,z),this.items.set(b.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(b)}`);return}return l.add?.(P),b.expand===2&&this.busyControllerCount++,P}update(b,l){const f=this.items.get(b.extId);if(f)return b.expand!==void 0&&(f.expand===2&&this.busyControllerCount--,b.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(f,b),l.update?.(f),f}remove(b,l){const f=this.items.get(b);if(!f)return;const P=I.TestId.parentId(f.item.extId)?.toString();P?this.items.get(P).children.delete(f.item.extId):this.roots.delete(f);const z=[[b]];for(;z.length;)for(const $ of z.pop()){const H=this.items.get($);H&&(z.push(H.children),this.items.delete($),l.remove?.(H,H!==f),H.expand===2&&this.busyControllerCount--)}}retireTest(b){}updatePendingRoots(b){this.pendingRootCount+=b}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=u}),define(Pe[76],Ae([1,0,16,5,6,50,57,45]),function(pe,e,w,O,I,M,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const p=(a,g)=>a===g,_=Object.entries({range:(a,g)=>a===g?!0:!a||!g?!1:a.equalsRange(g),busy:p,label:p,description:p,error:p,sortText:p,tags:(a,g)=>!(a.length!==g.length||a.some(C=>!g.includes(C)))}),c=(a,g)=>{let C;for(const[k,r]of _)r(a[k],g[k])||(C?C[k]=g[k]:C={[k]:g[k]});return C};class S extends I.Disposable{get root(){return this.options.root}constructor(g){super(),this.options=g,this.debounceSendDiff=this._register(new w.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new O.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(g){this._resolveHandler=g;for(const C of this.tree.values())this.updateExpandability(C)}get resolveHandler(){return this._resolveHandler}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){switch(g.op){case 2:{for(const C of this.diff)if(C.op===2&&C.uri===g.uri){C.docv=g.docv;return}break}case 1:{const C=this.diff[this.diff.length-1];if(C){if(C.op===1&&C.item.extId===g.item.extId){(0,T.applyTestItemUpdate)(C.item,g.item);return}if(C.op===0&&C.item.item.extId===g.item.extId){(0,T.applyTestItemUpdate)(C.item,g.item);return}}break}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,C){const k=this.tree.get(g);if(k){if((k.expandLevels===void 0||C>k.expandLevels)&&(k.expandLevels=C),k.expand===1){const r=this.resolveChildren(k);return r.isOpen()?this.expandChildren(k,C-1):r.wait().then(()=>this.expandChildren(k,C-1))}else if(k.expand===3)return k.resolveBarrier?.isOpen()===!1?k.resolveBarrier.wait().then(()=>this.expandChildren(k,C-1)):this.expandChildren(k,C-1)}}dispose(){for(const g of this.tree.values())this.options.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,C){switch(C.op){case 3:this.removeItem(h.TestId.joinToString(g.fullId,C.id));break;case 0:this.upsertItem(C.item,g);break;case 5:for(const k of C.ops)this.onTestItemEvent(g,k);break;case 1:this.diffTagRefs(C.new,C.old,g.fullId.toString());break;case 2:this.updateExpandability(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:C.update}});break;case 6:this.documentSynced(g.actual.uri);break;default:(0,M.assertNever)(C)}}documentSynced(g){g&&this.pushDiff({op:2,uri:g,docv:this.options.getDocumentVersion(g)})}upsertItem(g,C){const k=h.TestId.fromExtHostTestItem(g,this.root.id,C?.actual),r=this.options.getApiFor(g);r.parent&&r.parent!==C?.actual&&this.options.getChildren(r.parent).delete(g.id);let d=this.tree.get(k.toString());if(!d){d={fullId:k,actual:g,expandLevels:C?.expandLevels?C.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(d.fullId.toString(),d),this.setItemParent(g,C),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:d.expand,item:this.options.toITestItem(g)}}),this.connectItemAndChildren(g,d,C);return}if(d.actual===g){this.connectItem(g,d,C);return}if(d.actual.uri?.toString()!==g.uri?.toString())return this.removeItem(k.toString()),this.upsertItem(g,C);const n=this.options.getChildren(d.actual),s=d.actual,v=c(this.options.toITestItem(s),this.options.toITestItem(g));this.options.getApiFor(s).listener=void 0,d.actual=g,d.expand=0,v&&(v.hasOwnProperty("tags")&&(this.diffTagRefs(g.tags,s.tags,k.toString()),delete v.tags),this.onTestItemEvent(d,{op:4,update:v})),this.connectItemAndChildren(g,d,C);for(const[D,u]of n)this.options.getChildren(g).get(u.id)||this.removeItem(h.TestId.joinToString(k,u.id));this.documentSynced(d.actual.uri)}diffTagRefs(g,C,k){const r=new Set(C.map(d=>d.id));for(const d of g)r.delete(d.id)||this.incrementTagRefs(d);this.pushDiff({op:1,item:{extId:k,item:{tags:g.map(d=>(0,T.namespaceTestTag)(this.options.controllerId,d.id))}}}),r.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const C=this.tags.get(g.id);C?C.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,T.namespaceTestTag)(this.options.controllerId,g.id)}}))}decrementTagRefs(g){const C=this.tags.get(g);C&&!--C.refCount&&(this.tags.delete(g),this.pushDiff({op:7,id:(0,T.namespaceTestTag)(this.options.controllerId,g)}))}setItemParent(g,C){this.options.getApiFor(g).parent=C&&C.actual!==this.root?C.actual:void 0}connectItem(g,C,k){this.setItemParent(g,k);const r=this.options.getApiFor(g);r.parent=k?.actual,r.listener=d=>this.onTestItemEvent(C,d),this.updateExpandability(C)}connectItemAndChildren(g,C,k){this.connectItem(g,C,k);for(const[r,d]of this.options.getChildren(g))this.upsertItem(d,C)}updateExpandability(g){let C;this._resolveHandler?g.resolveBarrier?C=g.resolveBarrier.isOpen()?3:2:C=g.actual.canResolveChildren?1:0:C=0,C!==g.expand&&(g.expand=C,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:C}}),C===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,C){if(C<0)return;const k=[];for(const[r,d]of this.options.getChildren(g.actual)){const n=this.expand(h.TestId.joinToString(g.fullId,d.id),C);(0,w.isThenable)(n)&&k.push(n)}if(k.length)return Promise.all(k).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const d=new w.Barrier;return d.open(),d}g.expand=2,this.pushExpandStateUpdate(g);const C=g.resolveBarrier=new w.Barrier,k=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,d)};let r;try{r=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(d){k(d)}return(0,w.isThenable)(r)?r.catch(k).then(()=>{C.open(),this.updateExpandability(g)}):(C.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const C=this.tree.get(g);if(!C)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const k=[C];for(;k.length;){const r=k.pop();if(r){this.options.getApiFor(r.actual).listener=void 0;for(const d of r.actual.tags)this.decrementTagRefs(d.id);this.tree.delete(r.fullId.toString());for(const[d,n]of this.options.getChildren(r.actual))k.push(this.tree.get(h.TestId.joinToString(r.fullId,n.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.TestItemCollection=S;class E extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=E;class o extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=o;class t extends Error{constructor(g,C,k){super(`TestItem with ID "${g}" is from controller "${C}" and cannot be added as a child of an item from controller "${k}".`)}}e.MixedTestItemController=t;const i=(a,g,C)=>{let k=new Map;return{get size(){return k.size},forEach(r,d){for(const n of k.values())r.call(d,n,this)},[Symbol.iterator](){return k.entries()},replace(r){const d=new Map,n=new Set(k.keys()),s={op:5,ops:[]};for(const v of r){if(!(v instanceof C))throw new o(v.id);const D=g(v).controllerId;if(D!==a.controllerId)throw new t(v.id,D,a.controllerId);if(d.has(v.id))throw new E(v.id);d.set(v.id,v),n.delete(v.id),s.ops.push({op:0,item:v})}for(const v of n.keys())s.ops.push({op:3,id:v});a.listener?.(s),k=d},add(r){if(!(r instanceof C))throw new o(r.id);k.set(r.id,r),a.listener?.({op:0,item:r})},delete(r){k.delete(r)&&a.listener?.({op:3,id:r})},get(r){return k.get(r)},toJSON(){return Array.from(k.values())}}};e.createTestItemChildren=i}),define(Pe[101],Ae([1,0,76]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const O=new WeakMap,I=(T,h)=>{const y={controllerId:h};return O.set(T,y),y};e.createPrivateApiFor=I;const M=T=>{const h=O.get(T);if(!h)throw new w.InvalidTestItemError(T?.id||"<unknown>");return h};e.getPrivateApiFor=M}),define(Pe[77],Ae([1,0,13,2]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function I(h,y){return h.scheme===w.Schemas.http||h.scheme===w.Schemas.https?h:(y&&y.authority&&y.isRemote&&h.scheme===w.Schemas.file&&(h=O.URI.from({scheme:w.Schemas.vscodeRemote,authority:y.authority,path:h.path})),O.URI.from({scheme:w.Schemas.https,authority:`${h.scheme}+${M(h.authority)}.${e.webviewRootResourceAuthority}`,path:h.path,fragment:h.fragment,query:h.query}))}e.asWebviewUri=I;function M(h){return h.replace(/./g,y=>{const p=y.charCodeAt(0);return p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57?y:"-"+p.toString(16).padStart(4,"0")})}function T(h){return h.replace(/-([0-9a-f]{4})/g,(y,p)=>String.fromCharCode(parseInt(p,16)))}e.decodeAuthority=T}),define(Pe[199],Ae([1,0,5,6,77]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(h,y,p){this._proxy=h,this._editors=y,this._remoteInfo=p,this._handlePool=0,this._disposables=new O.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const A=y.getVisibleTextEditors();for(const _ of this._insets.values())A.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(h=>h.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(h,y,p,A,_){let c;for(const g of this._editors.getVisibleTextEditors(!0))if(g.value===h){c=g;break}if(!c)throw new Error("not a visible editor");const S=this,E=this._handlePool++,o=new w.Emitter,t=new w.Emitter,i=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(g){return(0,I.asWebviewUri)(g,S._remoteInfo)}get cspSource(){return I.webviewGenericCspSource}set options(g){this._options=g,S._proxy.$setOptions(E,g)}get options(){return this._options}set html(g){this._html=g,S._proxy.$setHtml(E,g)}get html(){return this._html}get onDidReceiveMessage(){return o.event}postMessage(g){return S._proxy.$postMessage(E,g)}},a=new class{constructor(){this.editor=h,this.line=y,this.height=p,this.webview=i,this.onDidDispose=t.event}dispose(){S._insets.has(E)&&(S._insets.delete(E),S._proxy.$disposeEditorInset(E),t.fire(),t.dispose(),o.dispose())}};return this._proxy.$createEditorInset(E,c.id,c.value.document.uri,y+1,p,A||{},_.identifier,_.extensionLocation),this._insets.set(E,{editor:h,inset:a,onDidReceiveMessage:o}),a}$onDidDispose(h){const y=this._insets.get(h);y&&y.inset.dispose()}$onDidReceiveMessage(h,y){this._insets.get(h)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=M}),define(Pe[200],Ae([1,0,3]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,w.createDecorator)("configurationResolverService");var O;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(O||(e.VariableKind=O={}));class I extends Error{constructor(T,h){super(h),this.variable=T}}e.VariableError=I}),define(Pe[201],Ae([1,0,19,52,12,24,22,90,165,200,15]),function(pe,e,w,O,I,M,T,h,y,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class _{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,E,o,t){this._contributedVariables=new Map,this._context=S,this._labelService=E,this._userHomePromise=o,t&&(this._envVariablesPromise=t.then(i=>this.prepareEnv(i)))}prepareEnv(S){if(T.isWindows){const E=Object.create(null);return Object.keys(S).forEach(o=>{E[o.toLowerCase()]=S[o]}),E}return S}resolveWithEnvironment(S,E,o){return this.recursiveResolve({env:this.prepareEnv(S),userHome:void 0},E?E.uri:void 0,o)}async resolveAsync(S,E){const o={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(o,S?S.uri:void 0,E)}async resolveAnyBase(S,E,o,t){const i=M.deepClone(E);T.isWindows&&i.windows?Object.keys(i.windows).forEach(g=>i[g]=i.windows[g]):T.isMacintosh&&i.osx?Object.keys(i.osx).forEach(g=>i[g]=i.osx[g]):T.isLinux&&i.linux&&Object.keys(i.linux).forEach(g=>i[g]=i.linux[g]),delete i.windows,delete i.osx,delete i.linux;const a={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(a,S?S.uri:void 0,i,o,t)}async resolveAnyAsync(S,E,o){return this.resolveAnyBase(S,E,o)}async resolveAnyMap(S,E,o){const t=new Map;return{newConfig:await this.resolveAnyBase(S,E,o,t),resolvedVariables:t}}resolveWithInteractionReplace(S,E,o,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,E,o,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,E){if(this._contributedVariables.has(S))throw new Error("Variable "+S+" is contributed twice.");this._contributedVariables.set(S,E)}async recursiveResolve(S,E,o,t,i){if(I.isString(o))return this.resolveString(S,E,o,t,i);if(Array.isArray(o))return Promise.all(o.map(a=>this.recursiveResolve(S,E,a,t,i)));if(I.isObject(o)){const a=Object.create(null),g=await Promise.all(Object.keys(o).map(async C=>[await this.resolveString(S,E,C,t,i),await this.recursiveResolve(S,E,o[C],t,i)]));for(const[C,k]of g)a[C]=k;return a}return o}resolveString(S,E,o,t,i){return(0,A.replaceAsync)(o,_.VARIABLE_REGEXP,async(a,g)=>{if(g.includes(_.VARIABLE_LHS))return a;let C=await this.evaluateSingleVariable(S,a,g,E,t);return i?.set(g,C),C!==a&&I.isString(C)&&C.match(_.VARIABLE_REGEXP)&&(C=await this.resolveString(S,E,C,t,i)),C})}fsPath(S){return this._labelService?this._labelService.getUriLabel(S,{noPrefix:!0}):S.fsPath}async evaluateSingleVariable(S,E,o,t,i){let a;const g=o.split(":");g.length>1&&(o=g[0],a=g[1]);const C=d=>{const n=this._context.getFilePath();if(n)return(0,h.normalizeDriveLetter)(n);throw new p.VariableError(d,(0,y.localize)(0,null,E))},k=d=>{const n=C(d);if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return(0,h.normalizeDriveLetter)(s)}throw new p.VariableError(d,(0,y.localize)(1,null,E,w.basename(n)))},r=d=>{if(a){const n=this._context.getFolderUri(a);if(n)return n;throw new p.VariableError(d,(0,y.localize)(2,null,E,a))}if(t)return t;throw this._context.getWorkspaceFolderCount()>1?new p.VariableError(d,(0,y.localize)(3,null,E)):new p.VariableError(d,(0,y.localize)(4,null,E))};switch(o){case"env":if(a){if(S.env){const d=S.env[T.isWindows?a.toLowerCase():a];if(I.isString(d))return d}return""}throw new p.VariableError(p.VariableKind.Env,(0,y.localize)(5,null,E));case"config":if(a){const d=this._context.getConfigurationValue(t,a);if(I.isUndefinedOrNull(d))throw new p.VariableError(p.VariableKind.Config,(0,y.localize)(6,null,E,a));if(I.isObject(d))throw new p.VariableError(p.VariableKind.Config,(0,y.localize)(7,null,E,a));return d}throw new p.VariableError(p.VariableKind.Config,(0,y.localize)(8,null,E));case"command":return this.resolveFromMap(p.VariableKind.Command,E,a,i,"command");case"input":return this.resolveFromMap(p.VariableKind.Input,E,a,i,"input");case"extensionInstallFolder":if(a){const d=await this._context.getExtension(a);if(!d)throw new p.VariableError(p.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,E,a));return this.fsPath(d.extensionLocation)}throw new p.VariableError(p.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,E));default:switch(o){case"workspaceRoot":case"workspaceFolder":return(0,h.normalizeDriveLetter)(this.fsPath(r(p.VariableKind.WorkspaceFolder)));case"cwd":return t||a?(0,h.normalizeDriveLetter)(this.fsPath(r(p.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,h.normalizeDriveLetter)(w.basename(this.fsPath(r(p.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new p.VariableError(p.VariableKind.UserHome,(0,y.localize)(11,null,E))}case"lineNumber":{const d=this._context.getLineNumber();if(d)return d;throw new p.VariableError(p.VariableKind.LineNumber,(0,y.localize)(12,null,E))}case"selectedText":{const d=this._context.getSelectedText();if(d)return d;throw new p.VariableError(p.VariableKind.SelectedText,(0,y.localize)(13,null,E))}case"file":return C(p.VariableKind.File);case"fileWorkspaceFolder":return k(p.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||a?w.relative(this.fsPath(r(p.VariableKind.RelativeFile)),C(p.VariableKind.RelativeFile)):C(p.VariableKind.RelativeFile);case"relativeFileDirname":{const d=w.dirname(C(p.VariableKind.RelativeFileDirname));if(t||a){const n=w.relative(this.fsPath(r(p.VariableKind.RelativeFileDirname)),d);return n.length===0?".":n}return d}case"fileDirname":return w.dirname(C(p.VariableKind.FileDirname));case"fileExtname":return w.extname(C(p.VariableKind.FileExtname));case"fileBasename":return w.basename(C(p.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=w.basename(C(p.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-w.extname(d).length)}case"fileDirnameBasename":return w.basename(w.dirname(C(p.VariableKind.FileDirnameBasename)));case"execPath":{const d=this._context.getExecPath();return d||E}case"execInstallFolder":{const d=this._context.getAppRoot();return d||E}case"pathSeparator":return w.sep;default:try{const d=a?`${o}:${a}`:o;return this.resolveFromMap(p.VariableKind.Unknown,E,d,i,void 0)}catch{return E}}}}resolveFromMap(S,E,o,t,i){if(o&&t){const a=i===void 0?t[o]:t[i+":"+o];if(typeof a=="string")return a;throw new p.VariableError(S,(0,y.localize)(14,null,E))}return E}}e.AbstractVariableResolverService=_}),define(Pe[102],Ae([1,0,3,99]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,w.createDecorator)("editorGroupsService");var I;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var M;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var T;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var h;(function(E){E[E.MAXIMIZE=0]="MAXIMIZE",E[E.EVEN=1]="EVEN",E[E.TOGGLE=2]="TOGGLE"})(h||(e.GroupsArrangement=h={}));var y;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function p(E){const o=E;return(0,O.isEditorInput)(o?.editor)&&(0,O.isEditorInput)(o?.replacement)}e.isEditorReplacement=p;var A;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var _;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(_||(e.OpenEditorContext=_={}));function c(E){const o=E;return!!o&&typeof o.id=="number"&&Array.isArray(o.editors)}e.isEditorGroup=c;function S(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=S}),define(Pe[202],Ae([1,0,3,102]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,w.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(M){const T=M;return typeof M=="number"||(0,O.isEditorGroup)(T)}e.isPreferredGroup=I}),define(Pe[8],Ae([1,0,18,25,122,203,49,28,116,70,69,24,12,2,44,78,94,101,99,75,45,57,202,7]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t,i,a,g,C,k,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Te){function we(G){const{selectionStartLineNumber:Oe,selectionStartColumn:xe,positionLineNumber:je,positionColumn:ze}=G,Je=new d.Position(Oe-1,xe-1),Et=new d.Position(je-1,ze-1);return new d.Selection(Je,Et)}Te.to=we;function be(G){const{anchor:Oe,active:xe}=G;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:xe.line+1,positionColumn:xe.character+1}}Te.from=be})(n||(e.Selection=n={}));var s;(function(Te){function we(G){if(!G)return;const{start:Oe,end:xe}=G;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:xe.line+1,endColumn:xe.character+1}}Te.from=we;function be(G){if(!G)return;const{startLineNumber:Oe,startColumn:xe,endLineNumber:je,endColumn:ze}=G;return new d.Range(Oe-1,xe-1,je-1,ze-1)}Te.to=be})(s||(e.Range=s={}));var v;(function(Te){function we(be){switch(be){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}Te.to=we})(v||(e.TokenType=v={}));var D;(function(Te){function we(G){return new d.Position(G.lineNumber-1,G.column-1)}Te.to=we;function be(G){return{lineNumber:G.line+1,column:G.character+1}}Te.from=be})(D||(e.Position=D={}));var u;(function(Te){function we(Oe,xe,je){return(0,w.coalesce)((0,w.asArray)(Oe).map(ze=>be(ze,xe,je)))}Te.from=we;function be(Oe,xe,je){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:je?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:G(Oe.scheme,xe),pattern:nt.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:je?.isBuiltin}}function G(Oe,xe){return xe&&typeof Oe=="string"?xe.transformOutgoingScheme(Oe):Oe}})(u||(e.DocumentSelector=u={}));var m;(function(Te){function we(G){switch(G){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}Te.from=we;function be(G){switch(G){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}Te.to=be})(m||(e.DiagnosticTag=m={}));var b;(function(Te){function we(G){let Oe;return G.code&&((0,c.isString)(G.code)||(0,c.isNumber)(G.code)?Oe=String(G.code):Oe={value:String(G.code.value),target:G.code.target}),{...s.from(G.range),message:G.message,source:G.source,code:Oe,severity:f.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(l.from),tags:Array.isArray(G.tags)?(0,w.coalesce)(G.tags.map(m.from)):void 0}}Te.from=we;function be(G){const Oe=new d.Diagnostic(s.to(G),G.message,f.to(G.severity));return Oe.source=G.source,Oe.code=(0,c.isString)(G.code)?G.code:G.code?.value,Oe.relatedInformation=G.relatedInformation&&G.relatedInformation.map(l.to),Oe.tags=G.tags&&(0,w.coalesce)(G.tags.map(m.to)),Oe}Te.to=be})(b||(e.Diagnostic=b={}));var l;(function(Te){function we(G){return{...s.from(G.location.range),message:G.message,resource:G.location.uri}}Te.from=we;function be(G){return new d.DiagnosticRelatedInformation(new d.Location(G.resource,s.to(G)),G.message)}Te.to=be})(l||(e.DiagnosticRelatedInformation=l={}));var f;(function(Te){function we(G){switch(G){case d.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Te.from=we;function be(G){switch(G){case t.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}Te.to=be})(f||(e.DiagnosticSeverity=f={}));var P;(function(Te){function we(G){return typeof G=="number"&&G>=d.ViewColumn.One?G-1:G===d.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}Te.from=we;function be(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Te.to=be})(P||(e.ViewColumn=P={}));function z(Te){return typeof Te.range<"u"}function $(Te){return Te.length===0?!0:!!z(Te[0])}e.isDecorationOptionsArr=$;var H;(function(Te){function we(ze){return ze.map(Te.from)}Te.fromMany=we;function be(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function G(ze){let Je;if(be(ze)){const{language:vt,value:gt}=ze;Je={value:"```"+vt+`
`+gt+"\n```\n"}}else d.MarkdownString.isMarkdownString(ze)?Je={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?Je={value:ze}:Je={value:""};const Et=Object.create(null);Je.uris=Et;const Dt=vt=>{try{let gt=S.URI.parse(vt,!0);gt=gt.with({query:Oe(gt.query,Et)}),Et[vt]=gt}catch{}return""},Ct=new y.marked.Renderer;return Ct.link=Dt,Ct.image=vt=>typeof vt=="string"?Dt(T.parseHrefAndDimensions(vt).href):"",(0,y.marked)(Je.value,{renderer:Ct}),Je}Te.from=G;function Oe(ze,Je){if(!ze)return ze;let Et;try{Et=(0,p.parse)(ze)}catch{}if(!Et)return ze;let Dt=!1;return Et=(0,_.cloneAndChange)(Et,Ct=>{if(S.URI.isUri(Ct)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Je[vt]=Ct,Dt=!0,vt}else return}),Dt?JSON.stringify(Et):ze}function xe(ze){const Je=new d.MarkdownString(ze.value,ze.supportThemeIcons);return Je.isTrusted=ze.isTrusted,Je.supportHtml=ze.supportHtml,Je.baseUri=ze.baseUri?S.URI.from(ze.baseUri):void 0,Je}Te.to=xe;function je(ze){if(ze)return typeof ze=="string"?ze:Te.from(ze)}Te.fromStrict=je})(H||(e.MarkdownString=H={}));function x(Te){return $(Te)?Te.map(we=>({range:s.from(we.range),hoverMessage:Array.isArray(we.hoverMessage)?H.fromMany(we.hoverMessage):we.hoverMessage?H.from(we.hoverMessage):void 0,renderOptions:we.renderOptions})):Te.map(we=>({range:s.from(we)}))}e.fromRangeOrRangeWithMessage=x;function U(Te){return typeof Te>"u"?Te:typeof Te=="string"?S.URI.file(Te):Te}e.pathOrURIToURI=U;var N;(function(Te){function we(be){return typeof be>"u"?be:{contentText:be.contentText,contentIconPath:be.contentIconPath?U(be.contentIconPath):void 0,border:be.border,borderColor:be.borderColor,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,color:be.color,backgroundColor:be.backgroundColor,margin:be.margin,width:be.width,height:be.height}}Te.from=we})(N||(e.ThemableDecorationAttachmentRenderOptions=N={}));var ae;(function(Te){function we(be){return typeof be>"u"?be:{backgroundColor:be.backgroundColor,outline:be.outline,outlineColor:be.outlineColor,outlineStyle:be.outlineStyle,outlineWidth:be.outlineWidth,border:be.border,borderColor:be.borderColor,borderRadius:be.borderRadius,borderSpacing:be.borderSpacing,borderStyle:be.borderStyle,borderWidth:be.borderWidth,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,cursor:be.cursor,color:be.color,opacity:be.opacity,letterSpacing:be.letterSpacing,gutterIconPath:be.gutterIconPath?U(be.gutterIconPath):void 0,gutterIconSize:be.gutterIconSize,overviewRulerColor:be.overviewRulerColor,before:be.before?N.from(be.before):void 0,after:be.after?N.from(be.after):void 0}}Te.from=we})(ae||(e.ThemableDecorationRenderOptions=ae={}));var Y;(function(Te){function we(be){if(typeof be>"u")return be;switch(be){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}Te.from=we})(Y||(e.DecorationRangeBehavior=Y={}));var Ee;(function(Te){function we(be){return{isWholeLine:be.isWholeLine,rangeBehavior:be.rangeBehavior?Y.from(be.rangeBehavior):void 0,overviewRulerLane:be.overviewRulerLane,light:be.light?ae.from(be.light):void 0,dark:be.dark?ae.from(be.dark):void 0,backgroundColor:be.backgroundColor,outline:be.outline,outlineColor:be.outlineColor,outlineStyle:be.outlineStyle,outlineWidth:be.outlineWidth,border:be.border,borderColor:be.borderColor,borderRadius:be.borderRadius,borderSpacing:be.borderSpacing,borderStyle:be.borderStyle,borderWidth:be.borderWidth,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,cursor:be.cursor,color:be.color,opacity:be.opacity,letterSpacing:be.letterSpacing,gutterIconPath:be.gutterIconPath?U(be.gutterIconPath):void 0,gutterIconSize:be.gutterIconSize,overviewRulerColor:be.overviewRulerColor,before:be.before?N.from(be.before):void 0,after:be.after?N.from(be.after):void 0}}Te.from=we})(Ee||(e.DecorationRenderOptions=Ee={}));var ye;(function(Te){function we(G){return{text:G.newText,eol:G.newEol&&Ke.from(G.newEol),range:s.from(G.range)}}Te.from=we;function be(G){const Oe=new d.TextEdit(s.to(G.range),G.text);return Oe.newEol=typeof G.eol>"u"?void 0:Ke.to(G.eol),Oe}Te.to=be})(ye||(e.TextEdit=ye={}));var Re;(function(Te){function we(G,Oe){const xe={edits:[]};if(G instanceof d.WorkspaceEdit){const je=new h.ResourceSet;for(const ze of G._allEntries())ze._type===1&&S.URI.isUri(ze.to)&&ze.from===void 0&&je.add(ze.to);for(const ze of G._allEntries())if(ze._type===1){let Je;ze.options?.contents&&(ArrayBuffer.isView(ze.options.contents)?Je={type:"base64",value:(0,O.encodeBase64)(O.VSBuffer.wrap(ze.options.contents))}:Je={type:"dataTransferItem",id:ze.options.contents._itemId}),xe.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contents:Je},metadata:ze.metadata})}else ze._type===2?xe.edits.push({resource:ze.uri,textEdit:ye.from(ze.edit),versionId:je.has(ze.uri)?void 0:Oe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?xe.edits.push({resource:ze.uri,textEdit:{range:s.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:je.has(ze.uri)?void 0:Oe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?xe.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&xe.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(et.from)}})}return xe}Te.from=we;function be(G){const Oe=new d.WorkspaceEdit,xe=new h.ResourceMap;for(const je of G.edits)if(je.textEdit){const ze=je,Je=S.URI.revive(ze.resource),Et=s.to(ze.textEdit.range),Dt=ze.textEdit.text,Ct=ze.textEdit.insertAsSnippet;let vt;Ct?vt=d.SnippetTextEdit.replace(Et,new d.SnippetString(Dt)):vt=d.TextEdit.replace(Et,Dt);const gt=xe.get(Je);gt?gt.push(vt):xe.set(Je,[vt])}else Oe.renameFile(S.URI.revive(je.oldResource),S.URI.revive(je.newResource),je.options);for(const[je,ze]of xe)Oe.set(je,ze);return Oe}Te.to=be})(Re||(e.WorkspaceEdit=Re={}));var K;(function(Te){const we=Object.create(null);we[d.SymbolKind.File]=0,we[d.SymbolKind.Module]=1,we[d.SymbolKind.Namespace]=2,we[d.SymbolKind.Package]=3,we[d.SymbolKind.Class]=4,we[d.SymbolKind.Method]=5,we[d.SymbolKind.Property]=6,we[d.SymbolKind.Field]=7,we[d.SymbolKind.Constructor]=8,we[d.SymbolKind.Enum]=9,we[d.SymbolKind.Interface]=10,we[d.SymbolKind.Function]=11,we[d.SymbolKind.Variable]=12,we[d.SymbolKind.Constant]=13,we[d.SymbolKind.String]=14,we[d.SymbolKind.Number]=15,we[d.SymbolKind.Boolean]=16,we[d.SymbolKind.Array]=17,we[d.SymbolKind.Object]=18,we[d.SymbolKind.Key]=19,we[d.SymbolKind.Null]=20,we[d.SymbolKind.EnumMember]=21,we[d.SymbolKind.Struct]=22,we[d.SymbolKind.Event]=23,we[d.SymbolKind.Operator]=24,we[d.SymbolKind.TypeParameter]=25;function be(Oe){return typeof we[Oe]=="number"?we[Oe]:6}Te.from=be;function G(Oe){for(const xe in we)if(we[xe]===Oe)return Number(xe);return d.SymbolKind.Property}Te.to=G})(K||(e.SymbolKind=K={}));var Q;(function(Te){function we(G){switch(G){case d.SymbolTag.Deprecated:return 1}}Te.from=we;function be(G){switch(G){case 1:return d.SymbolTag.Deprecated}}Te.to=be})(Q||(e.SymbolTag=Q={}));var ue;(function(Te){function we(G){return{name:G.name,kind:K.from(G.kind),tags:G.tags&&G.tags.map(Q.from),containerName:G.containerName,location:J.from(G.location)}}Te.from=we;function be(G){const Oe=new d.SymbolInformation(G.name,K.to(G.kind),G.containerName,J.to(G.location));return Oe.tags=G.tags&&G.tags.map(Q.to),Oe}Te.to=be})(ue||(e.WorkspaceSymbol=ue={}));var ne;(function(Te){function we(G){const Oe={name:G.name||"!!MISSING: name!!",detail:G.detail,range:s.from(G.range),selectionRange:s.from(G.selectionRange),kind:K.from(G.kind),tags:G.tags?.map(Q.from)??[]};return G.children&&(Oe.children=G.children.map(we)),Oe}Te.from=we;function be(G){const Oe=new d.DocumentSymbol(G.name,G.detail,K.to(G.kind),s.to(G.range),s.to(G.selectionRange));return(0,w.isNonEmptyArray)(G.tags)&&(Oe.tags=G.tags.map(Q.to)),G.children&&(Oe.children=G.children.map(be)),Oe}Te.to=be})(ne||(e.DocumentSymbol=ne={}));var he;(function(Te){function we(G){const Oe=new d.CallHierarchyItem(K.to(G.kind),G.name,G.detail||"",S.URI.revive(G.uri),s.to(G.range),s.to(G.selectionRange));return Oe._sessionId=G._sessionId,Oe._itemId=G._itemId,Oe}Te.to=we;function be(G,Oe,xe){if(Oe=Oe??G._sessionId,xe=xe??G._itemId,Oe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:xe,name:G.name,detail:G.detail,kind:K.from(G.kind),uri:G.uri,range:s.from(G.range),selectionRange:s.from(G.selectionRange),tags:G.tags?.map(Q.from)}}Te.from=be})(he||(e.CallHierarchyItem=he={}));var le;(function(Te){function we(be){return new d.CallHierarchyIncomingCall(he.to(be.from),be.fromRanges.map(G=>s.to(G)))}Te.to=we})(le||(e.CallHierarchyIncomingCall=le={}));var F;(function(Te){function we(be){return new d.CallHierarchyOutgoingCall(he.to(be.to),be.fromRanges.map(G=>s.to(G)))}Te.to=we})(F||(e.CallHierarchyOutgoingCall=F={}));var J;(function(Te){function we(G){return{range:G.range&&s.from(G.range),uri:G.uri}}Te.from=we;function be(G){return new d.Location(S.URI.revive(G.uri),s.to(G.range))}Te.to=be})(J||(e.location=J={}));var Se;(function(Te){function we(G){const Oe=G,xe=G;return{originSelectionRange:Oe.originSelectionRange?s.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:xe.uri,range:s.from(Oe.targetRange?Oe.targetRange:xe.range),targetSelectionRange:Oe.targetSelectionRange?s.from(Oe.targetSelectionRange):void 0}}Te.from=we;function be(G){return{targetUri:S.URI.revive(G.uri),targetRange:s.to(G.range),targetSelectionRange:G.targetSelectionRange?s.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?s.to(G.originSelectionRange):void 0}}Te.to=be})(Se||(e.DefinitionLink=Se={}));var ke;(function(Te){function we(G){return{range:s.from(G.range),contents:H.fromMany(G.contents)}}Te.from=we;function be(G){return new d.Hover(G.contents.map(H.to),s.to(G.range))}Te.to=be})(ke||(e.Hover=ke={}));var Ce;(function(Te){function we(G){return{range:s.from(G.range),expression:G.expression}}Te.from=we;function be(G){return new d.EvaluatableExpression(s.to(G.range),G.expression)}Te.to=be})(Ce||(e.EvaluatableExpression=Ce={}));var _e;(function(Te){function we(G){if(G instanceof d.InlineValueText)return{type:"text",range:s.from(G.range),text:G.text};if(G instanceof d.InlineValueVariableLookup)return{type:"variable",range:s.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Te.from=we;function be(G){switch(G.type){case"text":return{range:s.to(G.range),text:G.text};case"variable":return{range:s.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:s.to(G.range),expression:G.expression}}}Te.to=be})(_e||(e.InlineValue=_e={}));var Ie;(function(Te){function we(G){return{frameId:G.frameId,stoppedLocation:s.from(G.stoppedLocation)}}Te.from=we;function be(G){return new d.InlineValueContext(G.frameId,s.to(G.stoppedLocation))}Te.to=be})(Ie||(e.InlineValueContext=Ie={}));var se;(function(Te){function we(G){return{range:s.from(G.range),kind:G.kind}}Te.from=we;function be(G){return new d.DocumentHighlight(s.to(G.range),G.kind)}Te.to=be})(se||(e.DocumentHighlight=se={}));var fe;(function(Te){function we(be){switch(be){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}Te.to=we})(fe||(e.CompletionTriggerKind=fe={}));var ee;(function(Te){function we(be){return{triggerKind:fe.to(be.triggerKind),triggerCharacter:be.triggerCharacter}}Te.to=we})(ee||(e.CompletionContext=ee={}));var ie;(function(Te){function we(G){switch(G){case d.CompletionItemTag.Deprecated:return 1}}Te.from=we;function be(G){switch(G){case 1:return d.CompletionItemTag.Deprecated}}Te.to=be})(ie||(e.CompletionItemTag=ie={}));var de;(function(Te){const we=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function be(xe){return we.get(xe)??9}Te.from=be;const G=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Oe(xe){return G.get(xe)??d.CompletionItemKind.Property}Te.to=Oe})(de||(e.CompletionItemKind=de={}));var R;(function(Te){function we(be,G){const Oe=new d.CompletionItem(be.label);return Oe.insertText=be.insertText,Oe.kind=de.to(be.kind),Oe.tags=be.tags?.map(ie.to),Oe.detail=be.detail,Oe.documentation=T.isMarkdownString(be.documentation)?H.to(be.documentation):be.documentation,Oe.sortText=be.sortText,Oe.filterText=be.filterText,Oe.preselect=be.preselect,Oe.commitCharacters=be.commitCharacters,E.Range.isIRange(be.range)?Oe.range=s.to(be.range):typeof be.range=="object"&&(Oe.range={inserting:s.to(be.range.insert),replacing:s.to(be.range.replace)}),Oe.keepWhitespace=typeof be.insertTextRules>"u"?!1:!!(be.insertTextRules&1),typeof be.insertTextRules<"u"&&be.insertTextRules&4?Oe.insertText=new d.SnippetString(be.insertText):(Oe.insertText=be.insertText,Oe.textEdit=Oe.range instanceof d.Range?new d.TextEdit(Oe.range,Oe.insertText):void 0),be.additionalTextEdits&&be.additionalTextEdits.length>0&&(Oe.additionalTextEdits=be.additionalTextEdits.map(xe=>ye.to(xe))),Oe.command=G&&be.command?G.fromInternal(be.command):void 0,Oe}Te.to=we})(R||(e.CompletionItem=R={}));var W;(function(Te){function we(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:H.fromStrict(G.documentation)}}Te.from=we;function be(G){return{label:G.label,documentation:T.isMarkdownString(G.documentation)?H.to(G.documentation):G.documentation}}Te.to=be})(W||(e.ParameterInformation=W={}));var V;(function(Te){function we(G){return{label:G.label,documentation:H.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(W.from):[],activeParameter:G.activeParameter}}Te.from=we;function be(G){return{label:G.label,documentation:T.isMarkdownString(G.documentation)?H.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(W.to):[],activeParameter:G.activeParameter}}Te.to=be})(V||(e.SignatureInformation=V={}));var q;(function(Te){function we(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(V.from):[]}}Te.from=we;function be(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(V.to):[]}}Te.to=be})(q||(e.SignatureHelp=q={}));var oe;(function(Te){function we(be,G){const Oe=new d.InlayHint(D.to(G.position),typeof G.label=="string"?G.label:G.label.map(j.to.bind(void 0,be)),G.kind&&ce.to(G.kind));return Oe.textEdits=G.textEdits&&G.textEdits.map(ye.to),Oe.tooltip=T.isMarkdownString(G.tooltip)?H.to(G.tooltip):G.tooltip,Oe.paddingLeft=G.paddingLeft,Oe.paddingRight=G.paddingRight,Oe}Te.to=we})(oe||(e.InlayHint=oe={}));var j;(function(Te){function we(be,G){const Oe=new d.InlayHintLabelPart(G.label);return Oe.tooltip=T.isMarkdownString(G.tooltip)?H.to(G.tooltip):G.tooltip,o.Command.is(G.command)&&(Oe.command=be.fromInternal(G.command)),G.location&&(Oe.location=J.to(G.location)),Oe}Te.to=we})(j||(e.InlayHintLabelPart=j={}));var ce;(function(Te){function we(G){return G}Te.from=we;function be(G){return G}Te.to=be})(ce||(e.InlayHintKind=ce={}));var ve;(function(Te){function we(G){return{range:s.from(G.range),url:G.target,tooltip:G.tooltip}}Te.from=we;function be(G){let Oe;if(G.url)try{Oe=typeof G.url=="string"?S.URI.parse(G.url,!0):S.URI.revive(G.url)}catch{}return new d.DocumentLink(s.to(G.range),Oe)}Te.to=be})(ve||(e.DocumentLink=ve={}));var Ue;(function(Te){function we(G){const Oe=new d.ColorPresentation(G.label);return G.textEdit&&(Oe.textEdit=ye.to(G.textEdit)),G.additionalTextEdits&&(Oe.additionalTextEdits=G.additionalTextEdits.map(xe=>ye.to(xe))),Oe}Te.to=we;function be(G){return{label:G.label,textEdit:G.textEdit?ye.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Oe=>ye.from(Oe)):void 0}}Te.from=be})(Ue||(e.ColorPresentation=Ue={}));var $e;(function(Te){function we(G){return new d.Color(G[0],G[1],G[2],G[3])}Te.to=we;function be(G){return[G.red,G.green,G.blue,G.alpha]}Te.from=be})($e||(e.Color=$e={}));var Qe;(function(Te){function we(G){return{range:s.from(G.range)}}Te.from=we;function be(G){return new d.SelectionRange(s.to(G.range))}Te.to=be})(Qe||(e.SelectionRange=Qe={}));var qe;(function(Te){function we(be){switch(be){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}Te.to=we})(qe||(e.TextDocumentSaveReason=qe={}));var Ye;(function(Te){function we(G){switch(G){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}Te.from=we;function be(G){switch(G){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}Te.to=be})(Ye||(e.TextEditorLineNumbersStyle=Ye={}));var Ke;(function(Te){function we(G){if(G===d.EndOfLine.CRLF)return 1;if(G===d.EndOfLine.LF)return 0}Te.from=we;function be(G){if(G===1)return d.EndOfLine.CRLF;if(G===0)return d.EndOfLine.LF}Te.to=be})(Ke||(e.EndOfLine=Ke={}));var ct;(function(Te){function we(be){if(typeof be=="object")return be.viewId;switch(be){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Te.from=we})(ct||(e.ProgressLocation=ct={}));var Ze;(function(Te){function we(G){const Oe={start:G.start+1,end:G.end+1};return G.kind&&(Oe.kind=tt.from(G.kind)),Oe}Te.from=we;function be(G){const Oe={start:G.start-1,end:G.end-1};return G.kind&&(Oe.kind=tt.to(G.kind)),Oe}Te.to=be})(Ze||(e.FoldingRange=Ze={}));var tt;(function(Te){function we(G){if(G)switch(G){case d.FoldingRangeKind.Comment:return o.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return o.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return o.FoldingRangeKind.Region}}Te.from=we;function be(G){if(G)switch(G.value){case o.FoldingRangeKind.Comment.value:return d.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports.value:return d.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region.value:return d.FoldingRangeKind.Region}}Te.to=be})(tt||(e.FoldingRangeKind=tt={}));var Ne;(function(Te){function we(be){if(be)return{pinned:typeof be.preview=="boolean"?!be.preview:void 0,inactive:be.background,preserveFocus:be.preserveFocus,selection:typeof be.selection=="object"?s.from(be.selection):void 0,override:typeof be.override=="boolean"?a.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Te.from=we})(Ne||(e.TextEditorOpenOptions=Ne={}));var nt;(function(Te){function we(xe){return xe instanceof d.RelativePattern?xe.toJSON():typeof xe=="string"?xe:be(xe)||G(xe)?new d.RelativePattern(xe.baseUri??xe.base,xe.pattern).toJSON():xe}Te.from=we;function be(xe){const je=xe;return je?S.URI.isUri(je.baseUri)&&typeof je.pattern=="string":!1}function G(xe){const je=xe;return je?typeof je.base=="string"&&typeof je.pattern=="string":!1}function Oe(xe){return typeof xe=="string"?xe:new d.RelativePattern(S.URI.revive(xe.baseUri),xe.pattern)}Te.to=Oe})(nt||(e.GlobPattern=nt={}));var Z;(function(Te){function we(be){if(be){if(Array.isArray(be))return be.map(we);if(typeof be=="string")return be;{const G=be;return{language:G.language,scheme:G.scheme,pattern:nt.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Te.from=we})(Z||(e.LanguageSelector=Z={}));var X;(function(Te){function we(G){return{start:G.start,end:G.end}}Te.from=we;function be(G){return new d.NotebookRange(G.start,G.end)}Te.to=be})(X||(e.NotebookRange=X={}));var ge;(function(Te){function we(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Te.to=we;function be(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Te.from=be})(ge||(e.NotebookCellExecutionSummary=ge={}));var Be;(function(Te){function we(be){if(be===g.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;if(be===g.NotebookCellExecutionState.Pending)return;if(be===g.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${be}`)}Te.to=we})(Be||(e.NotebookCellExecutionState=Be={}));var Me;(function(Te){function we(G){switch(G){case d.NotebookCellKind.Markup:return g.CellKind.Markup;case d.NotebookCellKind.Code:default:return g.CellKind.Code}}Te.from=we;function be(G){switch(G){case g.CellKind.Markup:return d.NotebookCellKind.Markup;case g.CellKind.Code:default:return d.NotebookCellKind.Code}}Te.to=be})(Me||(e.NotebookCellKind=Me={}));var Ge;(function(Te){function we(G){const Oe={metadata:G.metadata??Object.create(null),cells:[]};for(const xe of G.cells)d.NotebookCellData.validate(xe),Oe.cells.push(et.from(xe));return Oe}Te.from=we;function be(G){const Oe=new d.NotebookData(G.cells.map(et.to));return(0,c.isEmptyObject)(G.metadata)||(Oe.metadata=G.metadata),Oe}Te.to=be})(Ge||(e.NotebookData=Ge={}));var et;(function(Te){function we(G){return{cellKind:Me.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:ge.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(wt.from):[]}}Te.from=we;function be(G){return new d.NotebookCellData(Me.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(wt.to):void 0,G.metadata,G.internalMetadata?ge.to(G.internalMetadata):void 0)}Te.to=be})(et||(e.NotebookCellData=et={}));var mt;(function(Te){function we(G){return{mime:G.mime,valueBytes:O.VSBuffer.wrap(G.data)}}Te.from=we;function be(G){return new d.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}Te.to=be})(mt||(e.NotebookCellOutputItem=mt={}));var wt;(function(Te){function we(G){return{outputId:G.id,items:G.items.map(mt.from),metadata:G.metadata}}Te.from=we;function be(G){const Oe=G.items.map(mt.to);return new d.NotebookCellOutput(Oe,G.outputId,G.metadata)}Te.to=be})(wt||(e.NotebookCellOutput=wt={}));var Ut;(function(Te){function we(Oe){return G(Oe)?{include:(0,c.withNullAsUndefined)(nt.from(Oe.include)),exclude:(0,c.withNullAsUndefined)(nt.from(Oe.exclude))}:(0,c.withNullAsUndefined)(nt.from(Oe))}Te.from=we;function be(Oe){return G(Oe)?{include:nt.to(Oe.include),exclude:nt.to(Oe.exclude)}:nt.to(Oe)}Te.to=be;function G(Oe){const xe=Oe;return xe?!(0,c.isUndefinedOrNull)(xe.include)&&!(0,c.isUndefinedOrNull)(xe.exclude):!1}})(Ut||(e.NotebookExclusiveDocumentPattern=Ut={}));var Vt;(function(Te){function we(be,G,Oe){const xe=typeof be.command=="string"?{title:"",command:be.command}:be.command;return{alignment:be.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(xe,Oe),text:be.text,tooltip:be.tooltip,accessibilityInformation:be.accessibilityInformation,priority:be.priority}}Te.from=we})(Vt||(e.NotebookStatusBarItem=Vt={}));var zt;(function(Te){function we(be,G,Oe){const xe=typeof be.command=="string"?{title:"",command:be.command}:be.command;return{command:G.toInternal(xe,Oe),label:be.label,description:be.description,detail:be.detail,documentation:be.documentation}}Te.from=we})(zt||(e.NotebookKernelSourceAction=zt={}));var St;(function(Te){function we(be){return{transientOutputs:be?.transientOutputs??!1,transientCellMetadata:be?.transientCellMetadata??{},transientDocumentMetadata:be?.transientDocumentMetadata??{},cellContentMetadata:be?.cellContentMetadata??{}}}Te.from=we})(St||(e.NotebookDocumentContentOptions=St={}));var At;(function(Te){function we(G){return{uri:G.uri,provides:G.provides}}Te.from=we;function be(G){return new d.NotebookRendererScript(S.URI.revive(G.uri),G.provides)}Te.to=be})(At||(e.NotebookRendererScript=At={}));var Rt;(function(Te){function we(G){return{message:H.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,location:G.location&&{range:s.from(G.location.range),uri:G.location.uri}}}Te.from=we;function be(G){const Oe=new d.TestMessage(typeof G.message=="string"?G.message:H.to(G.message));return Oe.actualOutput=G.actual,Oe.expectedOutput=G.expected,Oe.location=G.location?J.to(G.location):void 0,Oe}Te.to=be})(Rt||(e.TestMessage=Rt={}));var Lt;(function(Te){Te.namespace=k.namespaceTestTag,Te.denamespace=k.denamespaceTestTag})(Lt||(e.TestTag=Lt={}));var xt;(function(Te){function we(G){const Oe=(0,i.getPrivateApiFor)(G).controllerId;return{extId:C.TestId.fromExtHostTestItem(G,Oe).toString(),label:G.label,uri:S.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(xe=>Lt.namespace(Oe,xe.id)),range:E.Range.lift(s.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&H.fromStrict(G.error)||null}}Te.from=we;function be(G){return{parent:void 0,error:void 0,id:C.TestId.fromString(G.extId).localId,label:G.label,uri:S.URI.revive(G.uri),tags:(G.tags||[]).map(Oe=>{const{tagId:xe}=Lt.denamespace(Oe);return new d.TestTag(xe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:s.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Te.toPlain=be})(xt||(e.TestItem=xt={})),function(Te){function we(G){return{id:G.id}}Te.from=we;function be(G){return new d.TestTag(G.id)}Te.to=be}(Lt||(e.TestTag=Lt={}));var Ot;(function(Te){const we=(G,Oe)=>{const xe=[];for(const[ze,Je]of Oe)C.TestId.compare(Je.item.extId,ze)===2&&(Oe.delete(ze),xe.push(Je));const je={...xt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Je=>Je.type===0).map(Rt.to)})),children:xe.map(ze=>we(ze,Oe))};for(const ze of je.children)ze.parent=je;return je};function be(G){const Oe=[],xe=new Map;for(const je of G.items){xe.set(je.item.extId,je);const ze=C.TestId.root(je.item.extId);G.request.targets.some(Je=>Je.controllerId===ze&&Je.testIds.includes(je.item.extId))&&Oe.push(je)}return{completedAt:G.completedAt,results:Oe.map(je=>we(je,xe))}}Te.to=be})(Ot||(e.TestResults=Ot={}));var st;(function(Te){function we(xe){return{covered:xe.covered,total:xe.covered}}function be(xe){return"line"in xe?D.from(xe):s.from(xe)}function G(xe){return"branches"in xe?{count:xe.executionCount,location:be(xe.location),type:1,branches:xe.branches.length?xe.branches.map(je=>({count:je.executionCount,location:je.location&&be(je.location)})):void 0}:{type:0,count:xe.executionCount,location:be(xe.location)}}Te.fromDetailed=G;function Oe(xe){return{uri:xe.uri,statement:we(xe.statementCoverage),branch:xe.branchCoverage&&we(xe.branchCoverage),function:xe.functionCoverage&&we(xe.functionCoverage),details:xe.detailedCoverage?.map(G)}}Te.fromFile=Oe})(st||(e.TestCoverage=st={}));var dt;(function(Te){function we(be){switch(be){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}Te.to=we})(dt||(e.CodeActionTriggerKind=dt={}));var Bt;(function(Te){function we(G){const Oe=new d.TypeHierarchyItem(K.to(G.kind),G.name,G.detail||"",S.URI.revive(G.uri),s.to(G.range),s.to(G.selectionRange));return Oe._sessionId=G._sessionId,Oe._itemId=G._itemId,Oe}Te.to=we;function be(G,Oe,xe){if(Oe=Oe??G._sessionId,xe=xe??G._itemId,Oe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:xe,kind:K.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:s.from(G.range),selectionRange:s.from(G.selectionRange),tags:G.tags?.map(Q.from)}}Te.from=be})(Bt||(e.TypeHierarchyItem=Bt={}));var Ft;(function(Te){function we(be){if(be)return{value:be.value,tooltip:be.tooltip}}Te.from=we})(Ft||(e.ViewBadge=Ft={}));var yt;(function(Te){function we(xe,je,ze){const Je=je.fileData;return Je?new d.InternalFileDataTransferItem(new d.DataTransferFile(Je.name,S.URI.revive(Je.uri),Je.id,(0,M.once)(()=>ze(Je.id)))):xe===A.Mimes.uriList&&je.uriListData?new d.InternalDataTransferItem(Oe(je.uriListData)):new d.InternalDataTransferItem(je.asString)}Te.to=we;async function be(xe,je){const ze=await je.asString();if(xe===A.Mimes.uriList)return{asString:ze,fileData:void 0,uriListData:G(ze)};const Je=je.asFile();return{asString:ze,fileData:Je?{name:Je.name,uri:Je.uri,id:Je._itemId??Je.id}:void 0}}Te.from=be;function G(xe){return I.UriList.split(xe).map(je=>{if(je.startsWith("#"))return je;try{return S.URI.parse(je)}catch{}return je})}function Oe(xe){return I.UriList.create(xe.map(je=>typeof je=="string"?je:S.URI.revive(je)))}})(yt||(e.DataTransferItem=yt={}));var ot;(function(Te){function we(G,Oe){const xe=G.items.map(([je,ze])=>[je,yt.to(je,ze,Oe)]);return new d.DataTransfer(xe)}Te.toDataTransfer=we;async function be(G){const Oe={items:[]},xe=[];for(const[je,ze]of G)xe.push((async()=>{Oe.items.push([je,await yt.from(je,ze)])})());return await Promise.all(xe),Oe}Te.from=be})(ot||(e.DataTransfer=ot={}));var Tt;(function(Te){function we(G){return{message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Te.to=we;function be(G){return{kind:"reply",message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Te.from=be})(Tt||(e.ChatReplyFollowup=Tt={}));var Mt;(function(Te){function we(be){return typeof be=="string"?{title:be,message:be,kind:"reply"}:"commandId"in be?{kind:"command",title:be.title??"",commandId:be.commandId??"",args:be.args}:Tt.from(be)}Te.from=we})(Mt||(e.ChatFollowup=Mt={}))}),define(Pe[204],Ae([1,0,2,11,7,8,173]),function(pe,e,w,O,I,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class h{constructor(p,A,_,c={timeout:1500,errors:3}){this._logService=p,this._documents=A,this._mainThreadBulkEdits=_,this._thresholds=c,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(p){return(A,_,c)=>{const E={dispose:this._callbacks.push([A,_,p])};return Array.isArray(c)&&c.push(E),E}}async $participateInSave(p,A){const _=w.URI.revive(p);let c=!1;const S=setTimeout(()=>c=!0,this._thresholds.timeout),E=[];try{for(const o of[...this._callbacks]){if(c)break;const t=this._documents.getDocument(_),i=await this._deliverEventAsyncAndBlameBadListeners(o,{document:t,reason:M.TextDocumentSaveReason.to(A)});E.push(i)}}finally{clearTimeout(S)}return E}_deliverEventAsyncAndBlameBadListeners([p,A,_],c){const S=this._badListeners.get(p);return typeof S=="number"&&S>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,p,A,c).then(()=>!0,E=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(E),!(E instanceof Error)||E.message!=="concurrent_edits"){const o=this._badListeners.get(p);this._badListeners.set(p,o?o+1:1),typeof o=="number"&&o>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(p,A,_,c){const S=[],E=Date.now(),{document:o,reason:t}=c,{version:i}=o,a=Object.freeze({document:o,reason:t,waitUntil(g){if(Object.isFrozen(S))throw(0,O.illegalState)("waitUntil can not be called async");S.push(Promise.resolve(g))}});try{A.apply(_,[a])}catch(g){return Promise.reject(g)}return Object.freeze(S),new Promise((g,C)=>{const k=setTimeout(()=>C(new Error("timeout")),this._thresholds.timeout);return Promise.all(S).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' finished after ${Date.now()-E}ms`),clearTimeout(k),g(r)}).catch(r=>{clearTimeout(k),C(r)})}).then(g=>{const C={edits:[]};for(const k of g)if(Array.isArray(k)&&k.every(r=>r instanceof I.TextEdit))for(const{newText:r,newEol:d,range:n}of k)C.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:n&&M.Range.from(n),text:r,eol:d&&M.EndOfLine.from(d)}});if(C.edits.length!==0)return i===o.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(C):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=h}),define(Pe[205],Ae([1,0,13,2,8,7,75]),function(pe,e,w,O,I,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class h{constructor(_,c,S,E){this.start=_,this.deletedCount=c,this.deletedItems=S,this.items=E}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(_=>_.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(_,c){return{EOL:c.eol,lines:c.source,languageId:c.language,uri:c.uri,isDirty:!1,versionId:1,notebook:_}}constructor(_,c,S){this.notebook=_,this._extHostDocument=c,this._cellData=S,this.handle=S.handle,this.uri=O.URI.revive(S.uri),this.cellKind=S.cellKind,this._outputs=S.outputs.map(I.NotebookCellOutput.to),this._internalMetadata=S.internalMetadata??{},this._metadata=Object.freeze(S.metadata??{}),this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const _=this,c=this._extHostDocument.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return _.notebook.getCellIndex(_)},notebook:_.notebook.apiNotebook,kind:I.NotebookCellKind.to(this._cellData.cellKind),document:c.document,get mime(){return _._mime},set mime(E){_._mime=E},get outputs(){return _._outputs.slice(0)},get metadata(){return _._metadata},get executionSummary(){return _._previousResult}};this._apiCell=Object.freeze(S)}return this._apiCell}setOutputs(_){this._outputs=_.map(I.NotebookCellOutput.to)}setOutputItems(_,c,S){const E=S.map(I.NotebookCellOutputItem.to),o=this._outputs.find(t=>t.id===_);if(o&&(c||(o.items.length=0),o.items.push(...E),o.items.length>1&&o.items.every(t=>T.isTextStreamMime(t.mime)))){const t=new Map,i=[];o.items.forEach(a=>{let g;t.has(a.mime)?g=t.get(a.mime):(g=[],t.set(a.mime,g),i.push(a.mime)),g.push(a.data)}),o.items.length=0,i.forEach(a=>{const g=T.compressOutputItemStreams(t.get(a));o.items.push({mime:a,data:g.data.buffer})})}}setMetadata(_){this._metadata=Object.freeze(_)}setInternalMetadata(_){this._internalMetadata=_,this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(_))}setMime(_){}}e.ExtHostCell=y;class p{static{this._handlePool=0}constructor(_,c,S,E,o){this._proxy=_,this._textDocumentsAndEditors=c,this._textDocuments=S,this.uri=E,this.handle=p._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=o.viewType,this._metadata=Object.freeze(o.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,o.cells]],!0,void 0),this._versionId=o.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const _=this,c={get uri(){return _.uri},get version(){return _._versionId},get notebookType(){return _._notebookType},get isDirty(){return _._isDirty},get isUntitled(){return _.uri.scheme===w.Schemas.untitled},get isClosed(){return _._disposed},get metadata(){return _._metadata},get cellCount(){return _._cells.length},cellAt(S){return S=_._validateIndex(S),_._cells[S].apiCell},getCells(S){return(S?_._getCells(S):_._cells).map(o=>o.apiCell)},save(){return _._save()}};this._notebook=Object.freeze(c)}return this._notebook}acceptDocumentPropertiesChanged(_){_.metadata&&(this._metadata=Object.freeze({...this._metadata,..._.metadata}))}acceptDirty(_){this._isDirty=_}acceptModelChanged(_,c,S){this._versionId=_.versionId,this._isDirty=c,this.acceptDocumentPropertiesChanged({metadata:S});const E={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},o=[];for(const i of _.rawEvents)i.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(i.changes,!1,E.contentChanges):i.kind===T.NotebookCellsChangeType.Move?this._moveCells(i.index,i.length,i.newIdx,E.contentChanges):i.kind===T.NotebookCellsChangeType.Output?(this._setCellOutputs(i.index,i.outputs),o.push({cell:this._cells[i.index].apiCell,outputs:this._cells[i.index].apiCell.outputs})):i.kind===T.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(i.index,i.outputId,i.append,i.outputItems),o.push({cell:this._cells[i.index].apiCell,outputs:this._cells[i.index].apiCell.outputs})):i.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(i.index,i.language),o.push({cell:this._cells[i.index].apiCell,document:this._cells[i.index].apiCell.document})):i.kind===T.NotebookCellsChangeType.ChangeCellContent?o.push({cell:this._cells[i.index].apiCell,document:this._cells[i.index].apiCell.document}):i.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(i.index,i.mime):i.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(i.index,i.metadata),o.push({cell:this._cells[i.index].apiCell,metadata:this._cells[i.index].apiCell.metadata})):i.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(i.index,i.internalMetadata),o.push({cell:this._cells[i.index].apiCell,executionSummary:this._cells[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<o.length;i++){const a=o[i],g=t.get(a.cell);if(g===void 0){const C=E.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...a});t.set(a.cell,C-1)}else E.cellChanges[g]={...E.cellChanges[g],...a}}return Object.freeze(E),Object.freeze(E.cellChanges),Object.freeze(E.contentChanges),E}_validateIndex(_){return _=_|0,_<0?0:_>=this._cells.length?this._cells.length-1:_}_validateRange(_){let c=_.start|0,S=_.end|0;return c<0&&(c=0),S>this._cells.length&&(S=this._cells.length),_.with({start:c,end:S})}_getCells(_){_=this._validateRange(_);const c=[];for(let S=_.start;S<_.end;S++)c.push(this._cells[S]);return c}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(_,c,S){if(this._disposed)return;const E=[],o=[],t=[];if(_.reverse().forEach(i=>{const g=i[2].map(r=>{const d=new y(this,this._textDocumentsAndEditors,r);return c||o.push(y.asModelAddData(this.apiNotebook,r)),d}),C=new h(i[0],i[1],[],g),k=this._cells.splice(i[0],i[1],...g);for(const r of k)t.push(r.uri),C.deletedItems.push(r.apiCell);E.push(C)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:t}),S)for(const i of E)S.push(i.asApiEvent())}_moveCells(_,c,S,E){const o=this._cells.splice(_,c);this._cells.splice(S,0,...o);const t=[new h(_,c,o.map(i=>i.apiCell),[]),new h(S,0,[],o)];for(const i of t)E.push(i.asApiEvent())}_setCellOutputs(_,c){this._cells[_].setOutputs(c)}_setCellOutputItems(_,c,S,E){this._cells[_].setOutputItems(c,S,E)}_changeCellLanguage(_,c){const S=this._cells[_];S.apiCell.document.languageId!==c&&this._textDocuments.$acceptModelLanguageChanged(S.uri,c)}_changeCellMime(_,c){const S=this._cells[_];S.apiCell.mime=c}_changeCellMetadata(_,c){this._cells[_].setMetadata(c)}_changeCellInternalMetadata(_,c){this._cells[_].setInternalMetadata(c)}getCellFromApiCell(_){return this._cells.find(c=>c.apiCell===_)}getCellFromIndex(_){return this._cells[_]}getCell(_){return this._cells.find(c=>c.handle===_)}getCellIndex(_){return this._cells.indexOf(_)}}e.ExtHostNotebookDocument=p}),define(Pe[206],Ae([1,0,5,2,8,7]),function(pe,e,w,O,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class T{constructor(y,p,A,_={timeout:1500,errors:3}){this._logService=y,this._notebooksAndEditors=p,this._mainThreadBulkEdits=A,this._thresholds=_,this._onWillSaveNotebookDocumentEvent=new w.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(p,A,_)=>{const c=function(E){p.call(A,E)};return c.extension=y,this._onWillSaveNotebookDocumentEvent.event(c,void 0,_)}}async $participateInSave(y,p,A){const _=O.URI.revive(y),c=this._notebooksAndEditors.getNotebookDocument(_);if(!c)throw new Error("Unable to resolve notebook document");const S=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:c.apiNotebook,reason:I.TextDocumentSaveReason.to(p)},A,async(o,t)=>{const i=Date.now(),a=await await Promise.resolve(o);Date.now()-i>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!A.isCancellationRequested&&a&&(a instanceof M.WorkspaceEdit?S.push(a):this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(S.length===0)return!0;const E={edits:[]};for(const o of S){const{edits:t}=I.WorkspaceEdit.from(o);E.edits=E.edits.concat(t)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(E)}}e.ExtHostNotebookDocumentSaveParticipant=T}),define(Pe[103],Ae([1,0,11,8,7]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor(h,y,p,A,_,c){this.id=h,this._proxy=y,this.notebookData=p,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=_,this._visibleRanges=A,this._viewColumn=c}get apiEditor(){if(!this._editor){const h=this;this._editor={get notebook(){return h.notebookData.apiNotebook},get selection(){return h._selections[0]},set selection(y){this.selections=[y]},get selections(){return h._selections},set selections(y){if(!Array.isArray(y)||!y.every(I.NotebookRange.isNotebookRange))throw(0,w.illegalArgument)("selections");h._selections=y,h._trySetSelections(y)},get visibleRanges(){return h._visibleRanges},revealRange(y,p){h._proxy.$tryRevealRange(h.id,O.NotebookRange.from(y),p??I.NotebookEditorRevealType.Default)},get viewColumn(){return h._viewColumn}},M.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(h){this._visible=h}_acceptVisibleRanges(h){this._visibleRanges=h}_acceptSelections(h){this._selections=h}_trySetSelections(h){this._proxy.$trySetSelections(this.id,h.map(O.NotebookRange.from))}_acceptViewColumn(h){this._viewColumn=h}}e.ExtHostNotebookEditor=M}),define(Pe[207],Ae([1,0,11,5,14,8]),function(pe,e,w,O,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let T=class{constructor(y,p){this._logService=y,this._notebooksAndEditors=p,this._onDidChangeNotebookEditorSelection=new O.Emitter({onListenerError:w.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new O.Emitter({onListenerError:w.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(y,p){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,p);const A=this._notebooksAndEditors.getEditorById(y);p.visibleRanges&&A._acceptVisibleRanges(p.visibleRanges.ranges.map(M.NotebookRange.to)),p.selections&&A._acceptSelections(p.selections.selections.map(M.NotebookRange.to)),p.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),p.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const p in y)this._notebooksAndEditors.getEditorById(p)._acceptViewColumn(M.ViewColumn.to(y[p]))}};e.ExtHostNotebookEditors=T,e.ExtHostNotebookEditors=T=We([He(0,I.ILogService)],T)}),define(Pe[208],Ae([1,0,8,177,152,20,66,11]),function(pe,e,w,O,I,M,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(c){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=c}async withProgress(c,S,E){const o=this._handles++,{title:t,location:i,cancellable:a}=S,g={label:(0,I.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this._proxy.$startProgress(o,{location:w.ProgressLocation.from(i),title:t,source:g,cancellable:a},c.isUnderDevelopment?void 0:c.identifier.value).catch(h.onUnexpectedExternalError),this._withProgress(o,E,!!a)}_withProgress(c,S,E){let o;E&&(o=new M.CancellationTokenSource,this._mapHandleToCancellationSource.set(c,o));const t=a=>{this._proxy.$progressEnd(a),this._mapHandleToCancellationSource.delete(a),o?.dispose()};let i;try{i=S(new A(this._proxy,c),E&&o?o.token:M.CancellationToken.None)}catch(a){throw t(c),a}return i.then(a=>t(c),a=>t(c)),i}$acceptProgressCanceled(c){const S=this._mapHandleToCancellationSource.get(c);S&&(S.cancel(),this._mapHandleToCancellationSource.delete(c))}}e.ExtHostProgress=y;function p(_,c){return _.message=c.message,typeof c.increment=="number"&&(typeof _.increment=="number"?_.increment+=c.increment:_.increment=c.increment),_}class A extends O.Progress{constructor(c,S){super(E=>this.throttledReport(E)),this._proxy=c,this._handle=S}throttledReport(c){this._proxy.$progressReport(this._handle,c)}}We([(0,T.throttle)(100,(_,c)=>p(_,c),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Pe[104],Ae([1,0,44,101,45,76,57,8,2]),function(pe,e,w,O,I,M,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const p=(g,C,k,r)=>{let d=C;return{enumerable:!0,configurable:!1,get(){return d},set(n){if(!k(d,n)){const s=d;d=n,g.listener?.(r(n,s))}}}},A=(g,C)=>g===C,_={range:(g,C)=>g===C?!0:!g||!C?!1:g.isEqual(C),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(g,C)=>!(g.length!==C.length||g.some(k=>!C.find(r=>k.id===r.id)))},c=g=>C=>({op:4,update:g(C)}),S=(g,C)=>({range:(()=>{let k;const r=c(d=>({range:w.Range.lift(h.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return k},set(d){g.listener?.({op:6}),_.range(k,d)||(k=d,g.listener?.(r(d)))}}})(),label:p(g,C,_.label,c(k=>({label:k}))),description:p(g,void 0,_.description,c(k=>({description:k}))),sortText:p(g,void 0,_.sortText,c(k=>({sortText:k}))),canResolveChildren:p(g,!1,_.canResolveChildren,k=>({op:2,state:k})),busy:p(g,!1,_.busy,c(k=>({busy:k}))),error:p(g,void 0,_.error,c(k=>({error:h.MarkdownString.fromStrict(k)||null}))),tags:p(g,[],_.tags,(k,r)=>({op:1,new:k.map(h.TestTag.from),old:r.map(h.TestTag.from)}))}),E=g=>{const C=I.TestId.fromString(g.extId),k=new t(C.controllerId,C.localId,g.label,y.URI.revive(g.uri)||void 0);return k.range=h.Range.to(g.range||void 0),k.description=g.description||void 0,k.sortText=g.sortText||void 0,k.tags=g.tags.map(r=>h.TestTag.to({id:(0,T.denamespaceTestTag)(r).tagId})),k},o=g=>{let C;for(const k of g.tests){const r=E(k.item);(0,O.getPrivateApiFor)(r).parent=C,C=r}return C};e.toItemFromContext=o;class t{constructor(C,k,r,d){if(k.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(k)} symbol`);const n=(0,O.createPrivateApiFor)(this,C);Object.defineProperties(this,{id:{value:k,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof i?void 0:n.parent}},children:{value:(0,M.createTestItemChildren)(n,O.getPrivateApiFor,t),enumerable:!0,writable:!1},...S(n,r)})}}e.TestItemImpl=t;class i extends t{constructor(C,k){super(C,C,k,void 0),this._isRoot=!0}}e.TestItemRootImpl=i;class a extends M.TestItemCollection{constructor(C,k,r){super({controllerId:C,getDocumentVersion:d=>d&&r.getDocument(d)?.version,getApiFor:O.getPrivateApiFor,getChildren:d=>d.children,root:new i(C,k),toITestItem:h.TestItem.from})}}e.ExtHostTestItemCollection=a}),define(Pe[105],Ae([1,0,50,11,88,8,7]),function(pe,e,w,O,I,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class h{static{this._Keys=new I.IdGenerator("TextEditorDecorationType")}constructor(c,S,E){const o=h._Keys.nextId();c.$registerTextEditorDecorationType(S.identifier,o,M.DecorationRenderOptions.from(E)),this.value=Object.freeze({key:o,dispose(){c.$removeTextEditorDecorationType(o)}})}}e.TextEditorDecorationType=h;class y{constructor(c,S){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=S.undoStopBefore,this._undoStopAfter=S.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,S){this._throwIfFinalized();let E=null;if(c instanceof T.Position)E=new T.Range(c,c);else if(c instanceof T.Range)E=c;else throw new Error("Unrecognized location");this._pushEdit(E,S,!1)}insert(c,S){this._throwIfFinalized(),this._pushEdit(new T.Range(c,c),S,!0)}delete(c){this._throwIfFinalized();let S=null;if(c instanceof T.Range)S=c;else throw new Error("Unrecognized location");this._pushEdit(S,null,!0)}_pushEdit(c,S,E){const o=this._document.validateRange(c);this._collectedEdits.push({range:o,text:S,forceMoveMarkers:E})}setEndOfLine(c){if(this._throwIfFinalized(),c!==T.EndOfLine.LF&&c!==T.EndOfLine.CRLF)throw(0,O.illegalArgument)("endOfLine");this._setEndOfLine=c}}class p{constructor(c,S,E,o){this._proxy=c,this._id=S,this._accept(E),this._logService=o;const t=this;this.value={get tabSize(){return t._tabSize},set tabSize(i){t._setTabSize(i)},get indentSize(){return t._indentSize},set indentSize(i){t._setIndentSize(i)},get insertSpaces(){return t._insertSpaces},set insertSpaces(i){t._setInsertSpaces(i)},get cursorStyle(){return t._cursorStyle},set cursorStyle(i){t._setCursorStyle(i)},get lineNumbers(){return t._lineNumbers},set lineNumbers(i){t._setLineNumbers(i)}}}_accept(c){this._tabSize=c.tabSize,this._indentSize=c.indentSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=M.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const S=Math.floor(c);return S>0?S:null}if(typeof c=="string"){const S=parseInt(c,10);return isNaN(S)?null:S>0?S:null}return null}_setTabSize(c){const S=this._validateTabSize(c);if(S!==null){if(typeof S=="number"){if(this._tabSize===S)return;this._tabSize=S}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:S}))}}_validateIndentSize(c){if(c==="tabSize")return"tabSize";if(typeof c=="number"){const S=Math.floor(c);return S>0?S:null}if(typeof c=="string"){const S=parseInt(c,10);return isNaN(S)?null:S>0?S:null}return null}_setIndentSize(c){const S=this._validateIndentSize(c);if(S!==null){if(typeof S=="number"){if(this._indentSize===S)return;this._indentSize=S}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:S}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:!!c}_setInsertSpaces(c){const S=this._validateInsertSpaces(c);if(typeof S=="boolean"){if(this._insertSpaces===S)return;this._insertSpaces=S}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:S}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:M.TextEditorLineNumbersStyle.from(c)})))}assign(c){const S={};let E=!1;if(typeof c.tabSize<"u"){const o=this._validateTabSize(c.tabSize);o==="auto"?(E=!0,S.tabSize=o):typeof o=="number"&&this._tabSize!==o&&(this._tabSize=o,E=!0,S.tabSize=o)}if(typeof c.indentSize<"u"){const o=this._validateIndentSize(c.indentSize);o==="tabSize"?(E=!0,S.indentSize=o):typeof o=="number"&&this._indentSize!==o&&(this._indentSize=o,E=!0,S.indentSize=o)}if(typeof c.insertSpaces<"u"){const o=this._validateInsertSpaces(c.insertSpaces);o==="auto"?(E=!0,S.insertSpaces=o):this._insertSpaces!==o&&(this._insertSpaces=o,E=!0,S.insertSpaces=o)}typeof c.cursorStyle<"u"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,E=!0,S.cursorStyle=c.cursorStyle),typeof c.lineNumbers<"u"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,E=!0,S.lineNumbers=M.TextEditorLineNumbersStyle.from(c.lineNumbers)),E&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,S))}_warnOnError(c,S){S.catch(E=>{this._logService.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this._logService.warn(E)})}}e.ExtHostTextEditorOptions=p;class A{constructor(c,S,E,o,t,i,a,g){this.id=c,this._proxy=S,this._logService=E,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=t,this._options=new p(this._proxy,this.id,i,E),this._visibleRanges=a,this._viewColumn=g;const C=this;this.value=Object.freeze({get document(){return o.value},set document(k){throw(0,O.readonly)("document")},get selection(){return C._selections&&C._selections[0]},set selection(k){if(!(k instanceof T.Selection))throw(0,O.illegalArgument)("selection");C._selections=[k],C._trySetSelection()},get selections(){return C._selections},set selections(k){if(!Array.isArray(k)||k.some(r=>!(r instanceof T.Selection)))throw(0,O.illegalArgument)("selections");C._selections=k,C._trySetSelection()},get visibleRanges(){return C._visibleRanges},set visibleRanges(k){throw(0,O.readonly)("visibleRanges")},get options(){return C._options.value},set options(k){C._disposed||C._options.assign(k)},get viewColumn(){return C._viewColumn},set viewColumn(k){throw(0,O.readonly)("viewColumn")},edit(k,r={undoStopBefore:!0,undoStopAfter:!0}){if(C._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new y(o.value,r);return k(d),C._applyEdit(d)},insertSnippet(k,r,d={undoStopBefore:!0,undoStopAfter:!0}){if(C._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!r||Array.isArray(r)&&r.length===0)n=C._selections.map(s=>M.Range.from(s));else if(r instanceof T.Position){const{lineNumber:s,column:v}=M.Position.from(r);n=[{startLineNumber:s,startColumn:v,endLineNumber:s,endColumn:v}]}else if(r instanceof T.Range)n=[M.Range.from(r)];else{n=[];for(const s of r)if(s instanceof T.Range)n.push(M.Range.from(s));else{const{lineNumber:v,column:D}=M.Position.from(s);n.push({startLineNumber:v,startColumn:D,endLineNumber:v,endColumn:D})}}return S.$tryInsertSnippet(c,o.value.version,k.value,n,d)},setDecorations(k,r){const d=r.length===0;d&&!C._hasDecorationsForKey.has(k.key)||(d?C._hasDecorationsForKey.delete(k.key):C._hasDecorationsForKey.add(k.key),C._runOnProxy(()=>{if(M.isDecorationOptionsArr(r))return S.$trySetDecorations(c,k.key,M.fromRangeOrRangeWithMessage(r));{const n=new Array(4*r.length);for(let s=0,v=r.length;s<v;s++){const D=r[s];n[4*s]=D.start.line+1,n[4*s+1]=D.start.character+1,n[4*s+2]=D.end.line+1,n[4*s+3]=D.end.character+1}return S.$trySetDecorationsFast(c,k.key,n)}}))},revealRange(k,r){C._runOnProxy(()=>S.$tryRevealRange(c,M.Range.from(k),r||T.TextEditorRevealType.Default))},show(k){S.$tryShowEditor(c,M.ViewColumn.from(k))},hide(){S.$tryHideEditor(c)}})}dispose(){(0,w.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,w.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,w.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,w.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,w.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(M.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const S=c.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const E=S.edits.map(t=>t.range);E.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=E.length-1;t<i;t++){const a=E[t].end;if(E[t+1].start.isBefore(a))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const o=S.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,o,{setEndOfLine:typeof S.setEndOfLine=="number"?M.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this._logService.warn(S),null))}}e.ExtHostTextEditor=A}),define(Pe[209],Ae([1,0,3,171]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,w.refineServiceDecorator)(O.IEnvironmentService)}),define(Pe[106],Ae([1,0,21,5,19,6]),function(pe,e,w,O,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=T;class h{static isHostExtension(t,i,a){if(i.getExtensionDescription(t))return!1;const g=a.getExtensionDescription(t);return g?!!((g.main||g.browser)&&g.api==="none"):!1}constructor(t,i){this._activationEventsReader=t,this._onDidChange=new O.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new w.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this._extensionsMap.set(t.identifier,t),this._extensionsArr.push(t);const i=this._activationEventsReader.readActivationEvents(t);if(Array.isArray(i))for(let a of i)a==="onUri"&&(a=`onUri:${w.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(a)||this._activationMap.set(a,[]),this._activationMap.get(a).push(t)}}set(t){this._extensionDescriptions=t,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,i){this._extensionDescriptions=E(this._extensionDescriptions,i),this._extensionDescriptions=this._extensionDescriptions.concat(t);const a=h._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=E(this._extensionDescriptions,a.map(g=>g.identifier)),this._initialize(),this._onDidChange.fire(void 0),new T(a)}static _findLoopingExtensions(t){const i=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(r){this._nodesSet.has(r)||(this._nodesSet.add(r),this._nodesArr.push(r))}addArc(r,d){this.addNode(r),this.addNode(d),this._arcs.has(r)?this._arcs.get(r).push(d):this._arcs.set(r,[d])}getArcs(r){return this._arcs.has(r)?this._arcs.get(r):[]}hasOnlyGoodArcs(r,d){const n=i.getArcs(r);for(let s=0;s<n.length;s++)if(!d.has(n[s]))return!1;return!0}getNodes(){return this._nodesArr}},a=new w.ExtensionIdentifierMap;for(const r of t)if(a.set(r.identifier,r),r.extensionDependencies)for(const d of r.extensionDependencies)i.addArc(w.ExtensionIdentifier.toKey(r.identifier),w.ExtensionIdentifier.toKey(d));const g=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>g.add(r));const C=i.getNodes().filter(r=>!g.has(r));let k;do{k=!1;for(let r=0;r<C.length;r++){const d=C[r];i.hasOnlyGoodArcs(d,g)&&(C.splice(r,1),r--,g.add(d),k=!0)}}while(k);return C.map(r=>a.get(r))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(t)}getExtensionDescriptionsForActivationEvent(t){const i=this._activationMap.get(t);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const i=this._extensionsMap.get(t);return i||void 0}getExtensionDescriptionByUUID(t){for(const i of this._extensionsArr)if(i.uuid===t)return i}getExtensionDescriptionByIdOrUUID(t,i){return this.getExtensionDescription(t)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.ExtensionDescriptionRegistry=h,e.basicActivationEventsReader={readActivationEvents:o=>o.activationEvents};class y{constructor(t){this._lock=new _,this._actual=new h(t,[])}async acquireLock(t){const i=await this._lock.acquire(t);return new p(this,i)}deltaExtensions(t,i,a){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(i,a)}containsActivationEvent(t){return this._actual.containsActivationEvent(t)}containsExtension(t){return this._actual.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this._actual.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getExtensionDescription(t){return this._actual.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this._actual.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,i){return this._actual.getExtensionDescriptionByIdOrUUID(t,i)}}e.LockableExtensionDescriptionRegistry=y;class p extends M.Disposable{constructor(t,i){super(),this._registry=t,this._isDisposed=!1,this._register(i)}isAcquiredFor(t){return!this._isDisposed&&this._registry===t}}e.ExtensionDescriptionRegistryLock=p;class A{constructor(t){this.name=t,this.promise=new Promise((i,a)=>{this._resolve=i})}resolve(t){this._resolve(t)}}class _{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(t){const i=new A(t);return this._pendingCustomers.push(i),this._advance(),i.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const t=this._pendingCustomers.shift();this._isLocked=!0;let i=!0;const a=setTimeout(()=>{i&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),g=()=>{i&&(clearTimeout(a),i=!1,this._isLocked=!1,this._advance())};t.resolve((0,M.toDisposable)(g))}}var c;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(c||(c={}));function S(o,t){const i=o.isBuiltin?0:o.isUnderDevelopment?2:1,a=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(i!==a)return i-a;const g=I.posix.basename(o.extensionLocation.path),C=I.posix.basename(t.extensionLocation.path);return g<C?-1:g>C?1:0}function E(o,t){const i=new w.ExtensionIdentifierSet(t);return o.filter(a=>!i.has(a.identifier))}}),define(Pe[79],Ae([1,0,25]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var O;(function(p){p[p.Desktop=1]="Desktop",p[p.Web=2]="Web"})(O||(e.UIKind=O={}));var I;(function(p){p[p.VersionMismatch=55]="VersionMismatch",p[p.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var M;(function(p){p[p.Initialized=0]="Initialized",p[p.Ready=1]="Ready",p[p.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function T(p){const A=w.VSBuffer.alloc(1);switch(p){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.createMessageOfType=T;function h(p,A){if(p.byteLength!==1)return!1;switch(p.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.isMessageOfType=h;var y;(function(p){p.Start="START_NATIVE_LOG",p.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(Pe[58],Ae([1,0,3,5,14,27,79,51,53,24,2,6,154]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let S=class extends _.Disposable{constructor(i,a){super(),this.initData=i,this.loggerService=a,this._onDidChangeTelemetryEnabled=this._register(new O.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new O.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=A.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=a.createLogger(this.extHostTelemetryLogFile,{id:y.extensionTelemetryLogChannelId,name:(0,c.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(a.onDidChangeLogLevel(g=>{(0,I.isLogLevel)(g)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(i,a,g){const C=this.getTelemetryDetails(),k=new E(a,g,i,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(i),{isUsageEnabled:C.isUsageEnabled,isErrorsEnabled:C.isErrorsEnabled}),r=this._telemetryLoggers.get(i.identifier.value)??[];return this._telemetryLoggers.set(i.identifier.value,[...r,k]),k.apiTelemetryLogger}$initializeTelemetryLevel(i,a,g){this._level=i,this._telemetryIsSupported=a,this._productConfig=g??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(i){const a=Object.create(null);switch(a["common.extname"]=`${i.publisher}.${i.name}`,a["common.extversion"]=i.version,a["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,a["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,a["common.vscodeversion"]=this.initData.version,a["common.isnewappinstall"]=o(this.initData.telemetryInfo.firstSessionDate),a["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case T.UIKind.Web:a["common.uikind"]="web";break;case T.UIKind.Desktop:a["common.uikind"]="desktop";break;default:a["common.uikind"]="unknown"}return a["common.remotename"]=(0,h.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),a}$onDidChangeTelemetryLevel(i){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=i;const a=this.getTelemetryDetails();this._telemetryLoggers.forEach((g,C)=>{const k=g.filter(r=>!r.isDisposed);k.length===0?this._telemetryLoggers.delete(C):this._telemetryLoggers.set(C,k)}),this._telemetryLoggers.forEach(g=>{for(const C of g)C.updateTelemetryEnablements(a.isUsageEnabled,a.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(i,a){const C=this._telemetryLoggers.get(i.value)?.filter(r=>!r.isDisposed);if(!C)return this._telemetryLoggers.delete(i.value),!1;let k=!1;for(const r of C)r.ignoreUnhandledExtHostErrors||(r.logError(a),k=!0);return k}};e.ExtHostTelemetry=S,e.ExtHostTelemetry=S=We([He(0,M.IExtHostInitDataService),He(1,I.ILoggerService)],S);class E{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,a,g,C,k,r,d){this._extension=g,this._logger=C,this._inLoggingOnlyMode=k,this._commonProperties=r,this._onDidChangeEnableStates=new O.Emitter,this.ignoreUnhandledExtHostErrors=a?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=a?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=a?.additionalCommonProperties,this._sender=i,this._telemetryEnablements={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(i,a){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:i,isErrorsEnabled:a},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(i){let a="properties"in i?i.properties??{}:i;return a=(0,y.cleanData)(a,[]),this._additionalCommonProperties&&(a=(0,p.mixin)(a,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(a=(0,p.mixin)(a,this._commonProperties)),"properties"in i?i.properties=a:i=a,i}logEvent(i,a){this._sender&&(this._extension.publisher==="vscode"?i=this._extension.name+"/"+i:i=this._extension.identifier.value+"/"+i,a=this.mixInCommonPropsAndCleanData(a||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(i,a),this._logger.trace(i,a))}logUsage(i,a){this._telemetryEnablements.isUsageEnabled&&this.logEvent(i,a)}logError(i,a){!this._telemetryEnablements.isErrorsEnabled||!this._sender||(typeof i=="string"?this.logEvent(i,a):this._sender.sendErrorData(i,a))}get apiTelemetryLogger(){if(!this._apiObject){const i=this,a={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return i._telemetryEnablements.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i._onDidChangeEnableStates.event.bind(i)};this._apiObject=Object.freeze(a)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let i=this._sender;this._sender=void 0,Promise.resolve(i.flush()).then(i=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=E;function o(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.isNewAppInstall=o,e.IExtHostTelemetry=(0,w.createDecorator)("IExtHostTelemetry")}),define(Pe[26],Ae([1,0,5,2,181,98,21,3]),function(pe,e,w,O,I,M,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,h.createDecorator)("extensionService");class y{constructor(k){this.dependency=k}}e.MissingExtensionDependency=y;var p;(function(C){C[C.EagerAutoStart=1]="EagerAutoStart",C[C.EagerManualStart=2]="EagerManualStart",C[C.Lazy=3]="Lazy"})(p||(e.ExtensionHostStartup=p={}));class A{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,addActivationEvents:M.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions),myToRemove:[],myToAdd:this._myExtensions}}set(k,r){const d=[],n=[],s=[],v=[],D=_(this._allExtensions),u=_(k),m=(z,$)=>z.extensionLocation.toString()===$.extensionLocation.toString()||z.isBuiltin===$.isBuiltin||z.isUserBuiltin===$.isUserBuiltin||z.isUnderDevelopment===$.isUnderDevelopment;for(const z of this._allExtensions){const $=u.get(z.identifier);if(!$){d.push(z.identifier),D.delete(z.identifier);continue}if(!m(z,$)){d.push(z.identifier),D.delete(z.identifier);continue}}for(const z of k){const $=D.get(z.identifier);if(!$){n.push(z);continue}if(!m($,z)){d.push($.identifier),D.delete($.identifier);continue}}const b=new T.ExtensionIdentifierSet(this._myExtensions),l=new T.ExtensionIdentifierSet(r);for(const z of this._myExtensions)l.has(z)||s.push(z);for(const z of r)b.has(z)||v.push(z);const f=M.ImplicitActivationEvents.createActivationEventsMap(n),P={toRemove:d,toAdd:n,addActivationEvents:f,myToRemove:s,myToAdd:v};return this.delta(P),P}delta(k){const{toRemove:r,toAdd:d,myToRemove:n,myToAdd:s}=k,v=new T.ExtensionIdentifierSet(r),D=new T.ExtensionIdentifierSet(n);for(let u=0;u<this._allExtensions.length;u++)v.has(this._allExtensions[u].identifier)&&(this._allExtensions.splice(u,1),u--);for(let u=0;u<this._myExtensions.length;u++)D.has(this._myExtensions[u])&&(this._myExtensions.splice(u,1),u--);for(const u of d)this._allExtensions.push(u);for(const u of s)this._myExtensions.push(u)}containsExtension(k){for(const r of this._myExtensions)if(T.ExtensionIdentifier.equals(r,k))return!0;return!1}}e.ExtensionHostExtensions=A;function _(C){const k=new T.ExtensionIdentifierMap;for(const r of C)k.set(r.identifier,r);return k}function c(C,k){return C.enabledApiProposals?C.enabledApiProposals.includes(k):!1}e.isProposedApiEnabled=c;function S(C,k){if(!c(C,k))throw new Error(`Extension '${C.identifier.value}' CANNOT use API proposal: ${k}.
Its package.json#enabledApiProposals-property declares: ${C.enabledApiProposals?.join(", ")??"[]"} but NOT ${k}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${C.identifier.value}`)}e.checkProposedApiEnabled=S;class E{constructor(k,r,d,n){this.codeLoadingTime=k,this.activateCallTime=r,this.activateResolvedTime=d,this.activationReason=n}}e.ActivationTimes=E;class o{constructor(k,r){this.description=k,this.value=r}}e.ExtensionPointContribution=o;var t;(function(C){C[C.Normal=0]="Normal",C[C.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(C){return{type:C.isBuiltin?0:1,isBuiltin:C.isBuiltin||C.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(C.publisher,C.name),uuid:C.uuid},manifest:C,location:C.extensionLocation,targetPlatform:C.targetPlatform,validations:[],isValid:!0}}e.toExtension=i;function a(C,k){return{identifier:new T.ExtensionIdentifier((0,I.getExtensionId)(C.manifest.publisher,C.manifest.name)),isBuiltin:C.type===0,isUserBuiltin:C.type===1&&C.isBuiltin,isUnderDevelopment:!!k,extensionLocation:C.location,...C.manifest,uuid:C.identifier.uuid,targetPlatform:C.targetPlatform}}e.toExtensionDescription=a;class g{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(k){return Promise.resolve(void 0)}activationEventIsDone(k){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(k){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(k,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(k){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=g}),define(Pe[210],Ae([1,0,11,106,21,26,14,16]),function(pe,e,w,O,I,M,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{static{this.NONE=new y(!1,-1,-1,-1)}constructor(i,a,g,C){this.startup=i,this.codeLoadingTime=a,this.activateCallTime=g,this.activateResolvedTime=C}}e.ExtensionActivationTimes=y;class p{constructor(i){this._startup=i,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(i,a){return i===-1||a===-1?-1:a-i}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=p;class A{constructor(i,a,g,C,k,r){this.activationFailed=i,this.activationFailedError=a,this.activationTimes=g,this.module=C,this.exports=k,this.subscriptions=r}}e.ActivatedExtension=A;class _ extends A{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=_;class c extends A{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=c;class S extends A{constructor(i){super(!0,i,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let E=class{constructor(i,a,g,C){this._logService=C,this._registry=i,this._globalRegistry=a,this._host=g,this._operations=new I.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[i,a]of this._operations)a.dispose()}async waitForActivatingExtensions(){const i=[];for(const[a,g]of this._operations)i.push(g.wait());await Promise.all(i)}isActivated(i){const a=this._operations.get(i);return!!(a&&a.value)}getActivatedExtension(i){const a=this._operations.get(i);if(!a||!a.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return a.value}async activateByEvent(i,a){if(this._alreadyActivatedEvents[i])return;const g=this._registry.getExtensionDescriptionsForActivationEvent(i);await this._activateExtensions(g.map(C=>({id:C.identifier,reason:{startup:a,extensionId:C.identifier,activationEvent:i}}))),this._alreadyActivatedEvents[i]=!0}activateById(i,a){const g=this._registry.getExtensionDescription(i);if(!g)throw new Error(`Extension '${i}' is not known`);return this._activateExtensions([{id:g.identifier,reason:a}])}async _activateExtensions(i){const a=i.filter(g=>!this.isActivated(g.id)).map(g=>this._handleActivationRequest(g));await Promise.all(a.map(g=>g.wait()))}_handleActivationRequest(i){if(this._operations.has(i.id))return this._operations.get(i.id);if(this._isHostExtension(i.id))return this._createAndSaveOperation(i,null,[],null);const a=this._registry.getExtensionDescription(i.id);if(!a){const k=new Error(`Cannot activate unknown extension '${i.id.value}'`),r=this._createAndSaveOperation(i,null,[],new S(k));return this._host.onExtensionActivationError(i.id,k,new M.MissingExtensionDependency(i.id.value)),r}const g=[],C=typeof a.extensionDependencies>"u"?[]:a.extensionDependencies;for(const k of C){if(this._isResolvedExtension(k))continue;const r=this._operations.get(k);if(r){g.push(r);continue}if(this._isHostExtension(k)){g.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(k).identifier,reason:i.reason}));continue}const d=this._registry.getExtensionDescription(k);if(d){if(!d.main&&!d.browser)continue;g.push(this._handleActivationRequest({id:d.identifier,reason:i.reason}));continue}const n=a.displayName||a.identifier.value,s=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${k}'`),v=this._createAndSaveOperation(i,a.displayName,[],new S(s));return this._host.onExtensionActivationError(a.identifier,s,new M.MissingExtensionDependency(k)),v}return this._createAndSaveOperation(i,a.displayName,g,null)}_createAndSaveOperation(i,a,g,C){const k=new o(i.id,a,i.reason,g,C,this._host,this._logService);return this._operations.set(i.id,k),k}_isHostExtension(i){return O.ExtensionDescriptionRegistry.isHostExtension(i,this._registry,this._globalRegistry)}_isResolvedExtension(i){const a=this._globalRegistry.getExtensionDescription(i);return a?!a.main&&!a.browser:!1}};e.ExtensionsActivator=E,e.ExtensionsActivator=E=We([He(3,T.ILogService)],E);let o=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(i,a,g,C,k,r,d){this._id=i,this._displayName=a,this._reason=g,this._deps=C,this._value=k,this._host=r,this._logService=d,this._barrier=new h.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let i=0;i<this._deps.length;i++){const a=this._deps[i];if(a.value&&!a.value.activationFailed){this._deps.splice(i,1),i--;continue}if(a.value&&a.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);g.detail=a.value.activationFailedError,this._value=new S(g),this._host.onExtensionActivationError(this._id,g,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(i=>i.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(i){const a=new Error;if(i&&i.name&&(a.name=i.name),i&&i.message?a.message=`Activating extension '${this._id.value}' failed: ${i.message}.`:a.message=`Activating extension '${this._id.value}' failed: ${i}.`,i&&i.stack&&(a.stack=i.stack),this._value=new S(a),this._isDisposed&&w.isCancellationError(i))return;this._host.onExtensionActivationError(this._id,a,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(i)}}};o=We([He(6,T.ILogService)],o)}),define(Pe[211],Ae([1,0,156,7,23,2,5,6,193,16,7,12,18,8,49,20,125,26]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(k,r){if((0,_.isString)(k))return{label:k};if(k&&typeof k=="object"&&typeof k.label=="string"){let d;return Array.isArray(k.highlights)&&(d=k.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),d=d.length?d:void 0),{label:k.label,highlights:d}}}class g{constructor(r,d,n){this._proxy=r,this.commands=d,this.logService=n,this.treeViews=new Map,this.treeDragAndDropService=new t.TreeViewsDnDService;function s(v){return v&&v.$treeViewId&&(v.$treeItemHandle||v.$selectedTreeItems||v.$focusedTreeItem)}d.registerArgumentProcessor({processArgument:v=>s(v)?this.convertArgument(v):Array.isArray(v)&&v.length>0?v.map(D=>s(D)?this.convertArgument(D):D):v})}registerTreeDataProvider(r,d,n){const s=this.createTreeView(r,{treeDataProvider:d},n);return{dispose:()=>s.dispose()}}createTreeView(r,d,n){if(!d||!d.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=d.dragAndDropController?.dropMimeTypes??[],v=d.dragAndDropController?.dragMimeTypes??[],D=!!d.dragAndDropController?.handleDrag,u=!!d.dragAndDropController?.handleDrop,m=this.createExtHostTreeView(r,d,n),b={showCollapseAll:!!d.showCollapseAll,canSelectMany:!!d.canSelectMany,dropMimeTypes:s,dragMimeTypes:v,hasHandleDrag:D,hasHandleDrop:u,manuallyManageCheckboxes:!!d.manageCheckboxStateManually},l=this._proxy.$registerTreeViewDataProvider(r,b);return{get onDidCollapseElement(){return m.onDidCollapseElement},get onDidExpandElement(){return m.onDidExpandElement},get selection(){return m.selectedElements},get onDidChangeSelection(){return m.onDidChangeSelection},get activeItem(){return(0,i.checkProposedApiEnabled)(n,"treeViewActiveItem"),m.focusedElement},get onDidChangeActiveItem(){return(0,i.checkProposedApiEnabled)(n,"treeViewActiveItem"),m.onDidChangeActiveItem},get visible(){return m.visible},get onDidChangeVisibility(){return m.onDidChangeVisibility},get onDidChangeCheckboxState(){return m.onDidChangeCheckboxState},get message(){return m.message},set message(P){(0,E.isMarkdownString)(P)&&(0,i.checkProposedApiEnabled)(n,"treeViewMarkdownMessage"),m.message=P},get title(){return m.title},set title(P){m.title=P},get description(){return m.description},set description(P){m.description=P},get badge(){return m.badge},set badge(P){P!==void 0&&A.ViewBadge.isViewBadge(P)?m.badge={value:Math.floor(Math.abs(P.value)),tooltip:P.tooltip}:P===void 0&&(m.badge=void 0)},reveal:(P,z)=>m.reveal(P,z),dispose:async()=>{await l,this.treeViews.delete(r),m.dispose()}}}$getChildren(r,d){const n=this.treeViews.get(r);return n?n.getChildren(d):Promise.reject(new y.NoTreeViewError(r))}async $handleDrop(r,d,n,s,v,D,u,m){const b=this.treeViews.get(r);if(!b)return Promise.reject(new y.NoTreeViewError(r));const l=S.DataTransfer.toDataTransfer(n,async f=>(await this._proxy.$resolveDropFileData(r,d,f)).buffer);return u===r&&m&&await this.addAdditionalTransferItems(l,b,m,v,D),b.onDrop(l,s,v)}async addAdditionalTransferItems(r,d,n,s,v){const D=this.treeDragAndDropService.removeDragOperationTransfer(v);if(D)(await D)?.forEach((u,m)=>{u&&r.set(m,u)});else if(v&&d.handleDrag){const u=d.handleDrag(n,r,s);this.treeDragAndDropService.addDragOperationTransfer(v,u),await u}return r}async $handleDrag(r,d,n,s){const v=this.treeViews.get(r);if(!v)return Promise.reject(new y.NoTreeViewError(r));const D=await this.addAdditionalTransferItems(new O.DataTransfer,v,d,s,n);if(!(!D||s.isCancellationRequested))return S.DataTransfer.from(D)}async $hasResolve(r){const d=this.treeViews.get(r);if(!d)throw new y.NoTreeViewError(r);return d.hasResolve}$resolve(r,d,n){const s=this.treeViews.get(r);if(!s)throw new y.NoTreeViewError(r);return s.resolveTreeItem(d,n)}$setExpanded(r,d,n){const s=this.treeViews.get(r);if(!s)throw new y.NoTreeViewError(r);s.setExpanded(d,n)}$setSelectionAndFocus(r,d,n){const s=this.treeViews.get(r);if(!s)throw new y.NoTreeViewError(r);s.setSelectionAndFocus(d,n)}$setVisible(r,d){const n=this.treeViews.get(r);if(!n)throw new y.NoTreeViewError(r);n.setVisible(d)}$changeCheckboxState(r,d){const n=this.treeViews.get(r);if(!n)throw new y.NoTreeViewError(r);n.setCheckboxState(d)}createExtHostTreeView(r,d,n){const s=new C(r,d,this._proxy,this.commands.converter,this.logService,n);return this.treeViews.set(r,s),s}convertArgument(r){const d=this.treeViews.get(r.$treeViewId);return d&&"$treeItemHandle"in r?d.getExtensionElement(r.$treeItemHandle):d&&"$focusedTreeItem"in r&&r.$focusedTreeItem?d.focusedElement:null}}e.ExtHostTreeViews=g;class C extends h.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(r=>this.getExtensionElement(r)).filter(r=>!(0,_.isUndefinedOrNull)(r))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(r,d,n,s,v,D){if(super(),this.viewId=r,this.proxy=n,this.commands=s,this.logService=v,this.extension=D,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new T.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new T.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new o.CancellationTokenSource,D.contributes&&D.contributes.views)for(const b in D.contributes.views)for(const l of D.contributes.views[b])l.id===r&&(this._title=l.name);this.dataProvider=d.treeDataProvider,this.dndController=d.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(b=>this._onDidChangeData.fire({message:!1,element:b})));let u,m;this._register(T.Event.debounce(this._onDidChangeData.event,(b,l)=>(b||(b={message:!1,elements:[]}),l.element!==!1&&(u||(u=new Promise(f=>m=f),this.refreshPromise=this.refreshPromise.then(()=>u)),Array.isArray(l.element)?b.elements.push(...l.element):b.elements.push(l.element)),l.message&&(b.message=!0),b),200,!0)(({message:b,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=m;return u=null,this.refresh(l).then(()=>f())})),b&&this.proxy.$setMessage(this.viewId,S.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(r){const d=r?this.getExtensionElement(r):void 0;if(r&&!d)return this.logService.error(`No tree item with id '${r}' found.`),Promise.resolve([]);let n=this.getChildrenNodes(r);return n||(n=await this.fetchChildrenNodes(d)),n?n.map(s=>s.item):void 0}getExtensionElement(r){return this.elements.get(r)}reveal(r,d){d=d||{select:!0,focus:!1};const n=(0,_.isUndefinedOrNull)(d.select)?!0:d.select,s=(0,_.isUndefinedOrNull)(d.focus)?!1:d.focus,v=(0,_.isUndefinedOrNull)(d.expand)?!1:d.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):r?this.refreshPromise.then(()=>this.resolveUnknownParentChain(r)).then(D=>this.resolveTreeNode(r,D[D.length-1]).then(u=>this.proxy.$reveal(this.viewId,{item:u.item,parentChain:D.map(m=>m.item)},{select:n,focus:s,expand:v})),D=>this.logService.error(D)):this.proxy.$reveal(this.viewId,void 0,{select:n,focus:s,expand:v})}get message(){return this._message}set message(r){this._message=r,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(r){this._title=r,this.proxy.$setTitle(this.viewId,r,this._description)}get description(){return this._description}set description(r){this._description=r,this.proxy.$setTitle(this.viewId,this._title,r)}get badge(){return this._badge}set badge(r){this._badge?.value===r?.value&&this._badge?.tooltip===r?.tooltip||(this._badge=S.ViewBadge.from(r),this.proxy.$setBadge(this.viewId,r))}setExpanded(r,d){const n=this.getExtensionElement(r);n&&(d?this._onDidExpandElement.fire(Object.freeze({element:n})):this._onDidCollapseElement.fire(Object.freeze({element:n})))}setSelectionAndFocus(r,d){const n=!(0,c.equals)(this._selectedHandles,r);this._selectedHandles=r;const s=this._focusedHandle!==d;this._focusedHandle=d,n&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),s&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(r){r!==this._visible&&(this._visible=r,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(r){const d=(await Promise.all(r.map(async n=>{const s=this.getExtensionElement(n.treeItemHandle);return s?{extensionItem:s,treeItem:await this.dataProvider.getTreeItem(s),newState:n.newState?A.TreeItemCheckboxState.Checked:A.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);d.forEach(n=>{n.treeItem.checkboxState=n.newState?A.TreeItemCheckboxState.Checked:A.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:d.map(n=>[n.extensionItem,n.newState])})}async handleDrag(r,d,n){const s=[];for(const v of r){const D=this.getExtensionElement(v);D&&s.push(D)}if(!(!this.dndController?.handleDrag||s.length===0))return await this.dndController.handleDrag(s,d,n),d}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(r,d,n){const s=d?this.getExtensionElement(d):void 0;if(!(!s&&d||!this.dndController?.handleDrop))return(0,p.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(s,r,n):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(r,d){if(!this.dataProvider.resolveTreeItem)return;const n=this.elements.get(r);if(n){const s=this.nodes.get(n);if(s){const v=await this.dataProvider.resolveTreeItem(s.extensionItem,n,d)??s.extensionItem;return this.validateTreeItem(v),s.item.tooltip=this.getTooltip(v.tooltip),s.item.command=this.getCommand(s.disposableStore,v.command),s.item}}}resolveUnknownParentChain(r){return this.resolveParent(r).then(d=>d?this.resolveUnknownParentChain(d).then(n=>this.resolveTreeNode(d,n[n.length-1]).then(s=>(n.push(s),n))):Promise.resolve([]))}resolveParent(r){const d=this.nodes.get(r);return d?Promise.resolve(d.parent?this.elements.get(d.parent.item.handle):void 0):(0,p.asPromise)(()=>this.dataProvider.getParent(r))}resolveTreeNode(r,d){const n=this.nodes.get(r);return n?Promise.resolve(n):(0,p.asPromise)(()=>this.dataProvider.getTreeItem(r)).then(s=>this.createHandle(r,s,d,!0)).then(s=>this.getChildren(d?d.item.handle:void 0).then(()=>{const v=this.getExtensionElement(s);if(v){const D=this.nodes.get(v);if(D)return Promise.resolve(D)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(r){if(r){let d;if(typeof r=="string"){const n=this.getExtensionElement(r);d=n?this.nodes.get(n):void 0}else d=r;return d&&d.children||void 0}return this.roots}async fetchChildrenNodes(r){this.clearChildren(r);const d=new o.CancellationTokenSource(this._refreshCancellationSource.token);try{const n=r?this.nodes.get(r):void 0,s=await this.dataProvider.getChildren(r);if(d.token.isCancellationRequested)return;const v=await Promise.all((0,c.coalesce)(s||[]).map(async D=>{const u=await this.dataProvider.getTreeItem(D);return u&&!d.token.isCancellationRequested?this.createAndRegisterTreeNode(D,u,n):null}));return d.token.isCancellationRequested?void 0:(0,c.coalesce)(v)}finally{d.dispose()}}refresh(r){if(r.some(n=>!n))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new o.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const n=this.getHandlesToRefresh(r);if(n.length)return this.refreshHandles(n)}return Promise.resolve(void 0)}getHandlesToRefresh(r){const d=new Set,n=r.map(v=>this.nodes.get(v));for(const v of n)if(v&&!d.has(v.item.handle)){let D=v;for(;D&&D.parent&&n.findIndex(u=>D&&D.parent&&u&&u.item.handle===D.parent.item.handle)===-1;){const u=this.elements.get(D.parent.item.handle);D=u?this.nodes.get(u):void 0}D&&!D.parent&&d.add(v.item.handle)}const s=[];return d.forEach(v=>{const D=this.elements.get(v);if(D){const u=this.nodes.get(D);u&&(!u.parent||!d.has(u.parent.item.handle))&&s.push(v)}}),s}refreshHandles(r){const d={};return Promise.all(r.map(n=>this.refreshNode(n).then(s=>{s&&(d[n]=s.item)}))).then(()=>Object.keys(d).length?this.proxy.$refresh(this.viewId,d):void 0)}refreshNode(r){const d=this.getExtensionElement(r);if(d){const n=this.nodes.get(d);if(n)return this.clearChildren(d),(0,p.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(s=>{if(s){const v=this.createTreeNode(d,s,n.parent);return this.updateNodeCache(d,v,n,n.parent),n.dispose(),v}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(r,d,n){const s=this.createTreeNode(r,d,n);if(d.id&&this.elements.has(s.item.handle))throw new Error((0,w.localize)(0,null,d.id));return this.addNodeToCache(r,s),this.addNodeToParentCache(s,n),s}getTooltip(r){return A.MarkdownString.isMarkdownString(r)?S.MarkdownString.from(r):r}getCommand(r,d){return d?{...this.commands.toInternal(d,r),originalId:d.command}:void 0}getCheckbox(r){if(r.checkboxState===void 0)return;let d,n,s;return typeof r.checkboxState=="number"?d=r.checkboxState:(d=r.checkboxState.state,n=r.checkboxState.tooltip,s=r.checkboxState.accessibilityInformation),{isChecked:d===A.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:s}}validateTreeItem(r){if(!A.TreeItem.isTreeItem(r,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(r,d,n){this.validateTreeItem(d);const s=new h.DisposableStore,v=this.createHandle(r,d,n),D=this.getLightIconPath(d);return{item:{handle:v,parentHandle:n?n.item.handle:void 0,label:a(d.label,this.extension),description:d.description,resourceUri:d.resourceUri,tooltip:this.getTooltip(d.tooltip),command:this.getCommand(s,d.command),contextValue:d.contextValue,icon:D,iconDark:this.getDarkIconPath(d)||D,themeIcon:this.getThemeIcon(d),collapsibleState:(0,_.isUndefinedOrNull)(d.collapsibleState)?A.TreeItemCollapsibleState.None:d.collapsibleState,accessibilityInformation:d.accessibilityInformation,checkbox:this.getCheckbox(d)},extensionItem:d,parent:n,children:void 0,disposableStore:s,dispose(){s.dispose()}}}getThemeIcon(r){return r.iconPath instanceof A.ThemeIcon?r.iconPath:void 0}createHandle(r,{id:d,label:n,resourceUri:s},v,D){if(d)return`${C.ID_HANDLE_PREFIX}/${d}`;const u=a(n,this.extension),m=v?v.item.handle:C.LABEL_HANDLE_PREFIX;let b=u?u.label:s?(0,I.basename)(s):"";b=b.indexOf("/")!==-1?b.replace("/","//"):b;const l=this.nodes.has(r)?this.nodes.get(r).item.handle:void 0,f=this.getChildrenNodes(v)||[];let P,z=0;do{if(P=`${m}/${z}:${b}`,D||!this.elements.has(P)||l===P)break;z++}while(z<=f.length);return P}getLightIconPath(r){if(r.iconPath&&!(r.iconPath instanceof A.ThemeIcon))return typeof r.iconPath=="string"||M.URI.isUri(r.iconPath)?this.getIconPath(r.iconPath):this.getIconPath(r.iconPath.light)}getDarkIconPath(r){if(r.iconPath&&!(r.iconPath instanceof A.ThemeIcon)&&r.iconPath.dark)return this.getIconPath(r.iconPath.dark)}getIconPath(r){return M.URI.isUri(r)?r:M.URI.file(r)}addNodeToCache(r,d){this.elements.set(d.item.handle,r),this.nodes.set(r,d)}updateNodeCache(r,d,n,s){this.elements.delete(d.item.handle),this.nodes.delete(r),d.item.handle!==n.item.handle&&this.elements.delete(n.item.handle),this.addNodeToCache(r,d);const v=this.getChildrenNodes(s)||[],D=v.filter(u=>u.item.handle===n.item.handle)[0];D&&v.splice(v.indexOf(D),1,d)}addNodeToParentCache(r,d){d?(d.children||(d.children=[]),d.children.push(r)):(this.roots||(this.roots=[]),this.roots.push(r))}clearChildren(r){if(r){const d=this.nodes.get(r);if(d){if(d.children)for(const n of d.children){const s=this.elements.get(n.item.handle);s&&this.clear(s)}d.children=void 0}}else this.clearAll()}clear(r){const d=this.nodes.get(r);if(d){if(d.children)for(const n of d.children){const s=this.elements.get(n.item.handle);s&&this.clear(s)}this.nodes.delete(r),this.elements.delete(d.item.handle),d.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(r=>r.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Pe[212],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionOptions.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveSlashCommands.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[213],Ae([1,0,166,11,29,92,74,30,21,212,176,98]),function(pe,e,w,O,I,M,T,h,y,p,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const c=h.Registry.as(T.Extensions.JSONContribution);class S{constructor(k,r,d){this._messageHandler=k,this._extension=r,this._extensionPointId=d}_msg(k,r){this._messageHandler({type:k,message:r,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(k){this._msg(I.default.Error,k)}warn(k){this._msg(I.default.Warning,k)}info(k){this._msg(I.default.Info,k)}}e.ExtensionMessageCollector=S;class E{static _toSet(k){const r=new y.ExtensionIdentifierSet;for(let d=0,n=k.length;d<n;d++)r.add(k[d].description.identifier);return r}static compute(k,r){if(!k||!k.length)return new E(r,[]);if(!r||!r.length)return new E([],k);const d=this._toSet(k),n=this._toSet(r),s=r.filter(D=>!d.has(D.description.identifier)),v=k.filter(D=>!n.has(D.description.identifier));return new E(s,v)}constructor(k,r){this.added=k,this.removed=r}}e.ExtensionPointUserDelta=E;class o{constructor(k,r){this.name=k,this.defaultExtensionKind=r,this._handler=null,this._users=null,this._delta=null}setHandler(k){if(this._handler!==null)throw new Error("Handler already set!");this._handler=k,this._handle()}acceptUsers(k){this._delta=E.compute(this._users,k),this._users=k,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(k){(0,O.onUnexpectedError)(k)}}}e.ExtensionPoint=o;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(p.allApiProposals),markdownEnumDescriptions:Object.values(p.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"*",description:w.localize(42,null),body:"*"}]}},badges:{type:"array",description:w.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(44,null)},href:{type:"string",description:w.localize(45,null)},description:{type:"string",description:w.localize(46,null)}}}},markdown:{type:"string",description:w.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:w.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(52,null)},{body:["workspace"],description:w.localize(53,null)},{body:["ui","workspace"],description:w.localize(54,null)},{body:["workspace","ui"],description:w.localize(55,null)},{body:[],description:w.localize(56,null)}]},capabilities:{description:w.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(60,null),w.localize(61,null),w.localize(62,null)]},description:{type:"string",markdownDescription:w.localize(63,null)}}},untrustedWorkspaces:{description:w.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)]},restrictedConfigurations:{description:w.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(70,null)}}}}},sponsor:{description:w.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(73,null),type:"string"},"vscode:uninstall":{description:w.localize(74,null),type:"string"}}},icon:{type:"string",description:w.localize(75,null)},l10n:{type:"string",description:w.localize(76,null)}}};class a{constructor(){this._extensionPoints=new Map}registerExtensionPoint(k){if(this._extensionPoints.has(k.extensionPoint))throw new Error("Duplicate extension point: "+k.extensionPoint);const r=new o(k.extensionPoint,k.defaultExtensionKind);return this._extensionPoints.set(k.extensionPoint,r),k.activationEventsGenerator&&_.ImplicitActivationEvents.register(k.extensionPoint,k.activationEventsGenerator),e.schema.properties.contributes.properties[k.extensionPoint]=k.jsonSchema,c.registerSchema(i,e.schema),r}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=a;const g={ExtensionsRegistry:"ExtensionsRegistry"};h.Registry.add(g.ExtensionsRegistry,new a),e.ExtensionsRegistry=h.Registry.as(g.ExtensionsRegistry),c.registerSchema(i,e.schema),c.registerSchema(A.productSchemaId,{properties:{extensionEnabledApiProposals:{description:w.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(p.allApiProposals),markdownEnumDescriptions:Object.values(p.allApiProposals)}}]}}}})}),define(Pe[214],Ae([1,0,163,12,24,213,31,5]),function(pe,e,w,O,I,M,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var p;(function(c){function S(E,o,t){if(!E)return;const i=O.isString(E.type)?E.type:void 0;if(!i||i.length===0){t.error(w.localize(3,null));return}const a=[];if(Array.isArray(E.required))for(const g of E.required)O.isString(g)&&a.push(g);return{extensionId:o.value,taskType:i,required:a,properties:E.properties?I.deepClone(E.properties):{},when:E.when?T.ContextKeyExpr.deserialize(E.when):void 0}}c.from=S})(p||(p={}));const A=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(c,S)=>{for(const E of c)E.type&&S.push(`onTaskType:${E.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:y}});class _{constructor(){this._onDefinitionsChanged=new h.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((S,E)=>{A.setHandler((o,t)=>{this._schema=void 0;try{for(const i of t.removed){const a=i.value;for(const g of a)this.taskTypes&&g.type&&this.taskTypes[g.type]&&delete this.taskTypes[g.type]}for(const i of t.added){const a=i.value;for(const g of a){const C=p.from(g,i.description.identifier,i.collector);C&&(this.taskTypes[C.taskType]=C)}}(t.removed.length>0||t.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}S(void 0)})})}onReady(){return this.readyPromise}get(S){return this.taskTypes[S]}all(){return Object.keys(this.taskTypes).map(S=>this.taskTypes[S])}getJsonSchema(){if(this._schema===void 0){const S=[];for(const E of this.all()){const o={type:"object",additionalProperties:!1};E.required.length>0&&(o.required=E.required.slice(0)),E.properties!==void 0?o.properties=I.deepClone(E.properties):o.properties=Object.create(null),o.properties.type={type:"string",enum:[E.taskType]},S.push(o)}this._schema={oneOf:S}}return this._schema}}e.TaskDefinitionRegistry=new _}),define(Pe[215],Ae([1,0,164,12,23,24,31,214]),function(pe,e,w,O,I,M,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new T.RawContextKey("taskRunning",!1,w.localize(0,null)),e.TASKS_CATEGORY={value:w.localize(1,null),original:"Tasks"};var y;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(y||(e.ShellQuoting=y={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function N(ae){if(!ae)return U.Strong;switch(ae.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=N}(y||(e.ShellQuoting=y={}));var p;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(p||(e.CommandOptions=p={}));var A;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(A||(e.RevealKind=A={})),function(U){function N(ae){switch(ae.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=N}(A||(e.RevealKind=A={}));var _;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(_||(e.RevealProblemKind=_={})),function(U){function N(ae){switch(ae.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=N}(_||(e.RevealProblemKind=_={}));var c;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(c||(e.PanelKind=c={})),function(U){function N(ae){switch(ae.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=N}(c||(e.PanelKind=c={}));var S;(function(U){U.defaults={echo:!0,reveal:A.Always,revealProblems:_.Never,focus:!1,panel:c.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var E;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(E||(e.RuntimeType=E={})),function(U){function N(Y){switch(Y.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=N;function ae(Y){switch(Y){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=ae}(E||(e.RuntimeType=E={}));var o;(function(U){function N(ae){return O.isString(ae)?ae:ae.value}U.value=N})(o||(e.CommandString=o={}));var t;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function N(Y){return Y===U.Clean._id||Y===U.Build._id||Y===U.Rebuild._id||Y===U.Test._id}U.is=N;function ae(Y){if(Y!==void 0)return O.isString(Y)?N(Y)?{_id:Y,isDefault:!1}:void 0:Y}U.from=ae})(t||(e.TaskGroup=t={}));var i;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var a;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function N(ae){switch(ae){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=N})(a||(e.TaskSourceKind=a={}));var g;(function(U){U.parallel="parallel",U.sequence="sequence"})(g||(e.DependsOrder=g={}));var C;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(C||(e.RunOnOptions=C={}));var k;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:C.default,instanceLimit:1}})(k||(e.RunOptions=k={}));class r{constructor(N,ae,Y,Ee,ye,Re){this._label="",this._id=N,ae&&(this._label=ae),Y&&(this.type=Y),this.runOptions=Ee,this.configurationProperties=ye,this._source=Re}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.getFolderId(),id:this._id};return JSON.stringify(N)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,ae=!1){if(N===void 0)return!1;if(O.isString(N))return N===this._label||N===this.configurationProperties.identifier||ae&&N===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),N&&(this._taskLoadMessages=this._taskLoadMessages.concat(N))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=r;class d extends r{constructor(N,ae,Y,Ee,ye,Re,K,Q){super(N,Y,void 0,K,Q,ae),this.command={},this._source=ae,this.hasDefinedMatchers=Re,ye&&(this.command=ye)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let ae;switch(this.command?this.command.runtime:void 0){case E.Shell:ae="shell";break;case E.Process:ae="process";break;case E.CustomExecution:ae="customExecution";break;case void 0:ae="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ae,_key:this._id,id:this._id}}}static is(N){return N instanceof d}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===a.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.getFolderId();if(!N)return;let ae=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(ae+=this._source.kind);const Y={type:e.CUSTOMIZED_TASK_TYPE,folder:N,id:ae};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(N){return new d(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.CustomTask=d;class n extends r{constructor(N,ae,Y,Ee,ye,Re,K){super(N,Y,Ee,Re,K,ae),this._source=ae,this.configures=ye}static is(N){return N instanceof n}fromObject(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===a.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.getFolderId();if(!N)return;let ae=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(ae+=this._source.kind);const Y={type:e.CUSTOMIZED_TASK_TYPE,folder:N,id:ae};return JSON.stringify(Y)}}e.ConfiguringTask=n;class s extends r{constructor(N,ae,Y,Ee,ye,Re,K,Q,ue){super(N,Y,Ee,Q,ue,ae),this.defines=ye,this.hasDefinedMatchers=K,this.command=Re,this.icon=ue.icon,this.hide=ue.hide}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof s}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.getFolderId(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(N){return new s(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.ContributedTask=s;class v extends r{constructor(N,ae,Y,Ee,ye,Re){super(N,Y,Ee,ye,Re,ae),this._source=ae}clone(){return new v(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof v}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(N){return new v(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.InMemoryTask=v;var D;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(U){U._default=U.Terminal}(D||(e.ExecutionEngine=D={}));var u;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(u||(e.JsonSchemaVersion=u={}));class m{constructor(N){this._order=new Map;for(let ae=0;ae<N.length;ae++)this._order.set(N[ae].uri.toString(),ae)}compare(N,ae){const Y=N.getWorkspaceFolder(),Ee=ae.getWorkspaceFolder();if(Y&&Ee){let ye=this._order.get(Y.uri.toString());ye=ye===void 0?0:ye+1;let Re=this._order.get(Ee.uri.toString());return Re=Re===void 0?0:Re+1,ye===Re?N._label.localeCompare(ae._label):ye-Re}else return!Y&&Ee?-1:Y&&!Ee?1:0}}e.TaskSorter=m;var b;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(b||(e.TaskEventKind=b={}));var l;(function(U){U.SingleRun="singleRun",U.Background="background"})(l||(e.TaskRunType=l={}));var f;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(f||(e.TaskRunSource=f={}));var P;(function(U){function N(ae,Y,Ee,ye){if(Y){const Re={kind:ae,taskId:Y._id,taskName:Y.configurationProperties.name,runType:Y.configurationProperties.isBackground?"background":"singleRun",group:Y.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:Ee,__task:Y};return ae==="start"?Re.resolvedVariables=ye:ae==="processStarted"?Re.processId=ye:ae==="processEnded"&&(Re.exitCode=ye),Object.freeze(Re)}else return Object.freeze({kind:"changed"})}U.create=N})(P||(e.TaskEvent=P={}));var z;(function(U){function N(Y){const Ee=Object.keys(Y).sort();let ye="";for(const Re of Ee){let K=Y[Re];K instanceof Object?K=N(K):typeof K=="string"&&(K=K.replace(/,/g,",,")),ye+=Re+","+K+","}return ye}function ae(Y){const ye={_key:N(Y),type:Y.taskType};return Object.assign(ye,Y),ye}U.create=ae})(z||(e.KeyedTaskIdentifier=z={}));var $;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})($||(e.TaskSettingId=$={}));var H;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(H||(e.TasksSchemaProperties=H={}));var x;(function(U){function N(ae,Y){const Ee=h.TaskDefinitionRegistry.get(ae.type);if(Ee===void 0){const Q=M.deepClone(ae);return delete Q._key,z.create(Q)}const ye=Object.create(null);ye.type=Ee.taskType;const Re=new Set;Ee.required.forEach(Q=>Re.add(Q));const K=Ee.properties;for(const Q of Object.keys(K)){const ue=ae[Q];if(ue!=null)ye[Q]=ue;else if(Re.has(Q)){const ne=K[Q];if(ne.default!==void 0)ye[Q]=M.deepClone(ne.default);else switch(ne.type){case"boolean":ye[Q]=!1;break;case"number":case"integer":ye[Q]=0;break;case"string":ye[Q]="";break;default:Y.error(w.localize(2,null,JSON.stringify(ae,void 0,0),Q));return}}}return z.create(ye)}U.createTaskIdentifier=N})(x||(e.TaskDefinition=x={}))}),define(Pe[216],Ae([1,0,11]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class O{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,h)=>{this._actualOk=T,this._actualErr=h,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,w.onUnexpectedError)(T))}then(T,h){return this._ensureActual().then(T,h)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=O;class I extends O{constructor(){super(),this._hasErr=!0,this._err=new w.CancellationError}}e.CanceledLazyPromise=I}),define(Pe[46],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class w{static{this.count=0}constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++w.count}}e.ProxyIdentifier=w;const O=[];function I(h){const y=new w(h);return O[y.nid]=y,y}e.createProxyIdentifier=I;function M(h){return O[h].sid}e.getStringIdentifierForProxy=M;class T{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=T}),define(Pe[4],Ae([1,0,46]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var I;(function(o){o[o.UnknownInput=0]="UnknownInput",o[o.TextInput=1]="TextInput",o[o.TextDiffInput=2]="TextDiffInput",o[o.TextMergeInput=3]="TextMergeInput",o[o.NotebookInput=4]="NotebookInput",o[o.NotebookDiffInput=5]="NotebookDiffInput",o[o.CustomEditorInput=6]="CustomEditorInput",o[o.WebviewEditorInput=7]="WebviewEditorInput",o[o.TerminalEditorInput=8]="TerminalEditorInput",o[o.InteractiveEditorInput=9]="InteractiveEditorInput"})(I||(e.TabInputKind=I={}));var M;(function(o){o[o.TAB_OPEN=0]="TAB_OPEN",o[o.TAB_CLOSE=1]="TAB_CLOSE",o[o.TAB_UPDATE=2]="TAB_UPDATE",o[o.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var T;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var h;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(h||(e.WebviewMessageArrayBufferViewType=h={}));var y;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var p;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(p||(e.NotebookEditorRevealType=p={}));var A;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class _{static{this._n=0}static mixin(t){return t._id=_._n++,t}}e.IdObject=_;var c;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.kindModifier="m",o.commandIdent="n",o.commandId="o",o.commandArguments="p"})(c||(e.ISuggestDataDtoField=c={}));var S;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var E;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(E||(e.ExtHostTestingResource=E={})),e.MainContext={MainThreadAuthentication:(0,w.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,w.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,w.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,w.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,w.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,w.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,w.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,w.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,w.createProxyIdentifier)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,w.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,w.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,w.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,w.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,w.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,w.createProxyIdentifier)("ExtHostChat"),ExtHostSemanticSimilarity:(0,w.createProxyIdentifier)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,w.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,w.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Pe[80],Ae([1,0,3,14,4,17]),function(pe,e,w,O,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,w.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(y,p){this._extHostLogService=p,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(I.MainContext.MainThreadTelemetry)}report(y,p,A){const _=this.getUsageKey(y,p);this._reportedUsages.has(_)||(this._reportedUsages.add(_),p.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:p.identifier.value,apiId:y}))}getUsageKey(y,p){return`${y}-${p.identifier.value}`}};e.ExtHostApiDeprecationService=T,e.ExtHostApiDeprecationService=T=We([He(0,M.IExtHostRpcService),He(1,O.ILogService)],T),e.NullApiDeprecationService=Object.freeze(new class{report(h,y,p){}})}),define(Pe[217],Ae([1,0,5,4,7,21]),function(pe,e,w,O,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(p){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new w.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new h,this._getSessionsTaskSingler=new h,this._proxy=p.getProxy(O.MainContext.MainThreadAuthentication)}$setProviders(p){return this._providers=p,Promise.resolve()}async getSession(p,A,_,c={}){const S=M.ExtensionIdentifier.toKey(p.identifier),E=[..._].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${S} ${A} ${E}`,async()=>{await this._proxy.$ensureProvider(A);const o=p.displayName||p.name;return this._proxy.$getSession(A,_,S,o,c)})}async getSessions(p,A,_){const c=M.ExtensionIdentifier.toKey(p.identifier),S=[..._].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${c} ${S}`,async()=>{await this._proxy.$ensureProvider(A);const E=p.displayName||p.name;return this._proxy.$getSessions(A,_,c,E)})}async removeSession(p,A){const _=this._authenticationProviders.get(p);return _?_.provider.removeSession(A):this._proxy.$removeSession(p,A)}registerAuthenticationProvider(p,A,_,c){if(this._authenticationProviders.get(p))throw new Error(`An authentication provider with id '${p}' is already registered.`);this._authenticationProviders.set(p,{label:A,provider:_,options:c??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===p)||this._providers.push({id:p,label:A});const S=_.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(p,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(p,A,c?.supportsMultipleAccounts??!1),new I.Disposable(()=>{S.dispose(),this._authenticationProviders.delete(p);const E=this._providers.findIndex(o=>o.id===p);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(p)})}$createSession(p,A,_){const c=this._authenticationProviders.get(p);if(c)return Promise.resolve(c.provider.createSession(A,_));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$removeSession(p,A){const _=this._authenticationProviders.get(p);if(_)return Promise.resolve(_.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$getSessions(p,A){const _=this._authenticationProviders.get(p);if(_)return Promise.resolve(_.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$onDidChangeAuthenticationSessions(p,A){return this._onDidChangeSessions.fire({provider:{id:p,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=T;class h{constructor(){this._inFlightPromises=new Map}getOrCreate(p,A){const _=this._inFlightPromises.get(p);if(_)return _;const c=A().finally(()=>this._inFlightPromises.delete(p));return this._inFlightPromises.set(p,c),c}}}),define(Pe[218],Ae([1,0,4,17,8]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(h,y){this._proxy=h.getProxy(w.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:p=>y.getDocument(p)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(h,y,p){const A=I.WorkspaceEdit.from(h,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(A,void 0,p?.isRefactoring??!1)}};e.ExtHostBulkEdits=M,e.ExtHostBulkEdits=M=We([He(0,O.IExtHostRpcService)],M)}),define(Pe[219],Ae([1,0,16,5,68,6,59,12,146,4,8]),function(pe,e,w,O,I,M,T,h,y,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class _{static{this._pool=0}constructor(E,o){this.extension=E,this.provider=o,this.handle=_._pool++}}class c{static{this._nextId=0}constructor(E,o){this.logService=o,this._chatProvider=new Map,this._slashCommandProvider=new Map,this._chatSessions=new Map,this._onDidPerformUserAction=new O.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=E.getProxy(p.MainContext.MainThreadChat)}registerChatProvider(E,o,t){const i=new _(E,t);return this._chatProvider.set(i.handle,i),this._proxy.$registerChatProvider(i.handle,o),(0,M.toDisposable)(()=>{this._proxy.$unregisterChatProvider(i.handle),this._chatProvider.delete(i.handle)})}transferChatSession(E,o){const t=I.Iterable.find(this._chatSessions.keys(),i=>this._chatSessions.get(i)===E)??0;typeof t=="number"&&this._proxy.$transferChatSession(t,o)}addChatRequest(E){this._proxy.$addRequest(E)}sendInteractiveRequestToProvider(E,o){this._proxy.$sendRequestToProvider(E,o)}async $prepareChat(E,o,t){const i=this._chatProvider.get(E);if(!i)return;const a=await i.provider.prepareSession(o,t);if(!a)return;const g=c._nextId++;return this._chatSessions.set(g,a),{id:g,requesterUsername:a.requester?.name,requesterAvatarIconUri:a.requester?.icon,responderUsername:a.responder?.name,responderAvatarIconUri:a.responder?.icon,inputPlaceholder:a.inputPlaceholder}}async $resolveRequest(E,o,t,i){const a=this._chatProvider.get(E);if(!a)return;const g=this._chatSessions.get(o);if(!g||!a.provider.resolveRequest)return;const C=await a.provider.resolveRequest(g,t,i);if(C)return{message:typeof C.message=="string"?C.message:A.ChatReplyFollowup.from(C.message)}}async $provideWelcomeMessage(E,o){const t=this._chatProvider.get(E);if(!t||!t.provider.provideWelcomeMessage)return;const i=await t.provider.provideWelcomeMessage(o);if(i)return i.map(a=>typeof a=="string"?a:a.map(g=>A.ChatReplyFollowup.from(g)))}async $provideFollowups(E,o,t){const i=this._chatProvider.get(E);if(!i)return;const a=this._chatSessions.get(o);return!a||!i.provider.provideFollowups?void 0:(await i.provider.provideFollowups(a,t))?.map(C=>A.ChatFollowup.from(C))}$removeRequest(E,o,t){const i=this._chatProvider.get(E);if(!i)return;const a=this._chatSessions.get(o);a&&i.provider.removeRequest&&i.provider.removeRequest(a,t)}async $provideReply(E,o,t,i){const a=this._chatProvider.get(E);if(!a)return;const g=this._chatSessions.get(o);if(!g)return;const C={session:g,message:typeof t.message=="string"?t.message:A.ChatReplyFollowup.to(t.message)},k=T.StopWatch.create(!1);let r;const d={report:v=>{if(!i.isCancellationRequested)if(typeof r>"u"&&(r=k.elapsed()),"responseId"in v)this._proxy.$acceptResponseProgress(E,o,{requestId:v.responseId});else if("placeholder"in v&&"resolvedContent"in v){const D=Promise.all([this._proxy.$acceptResponseProgress(E,o,{placeholder:v.placeholder}),v.resolvedContent]);(0,w.raceCancellation)(D,i).then(u=>{if(!u)return;const[m,b]=u;this._proxy.$acceptResponseProgress(E,o,b,m??void 0)})}else this._proxy.$acceptResponseProgress(E,o,v)}};let n;try{n=await a.provider.provideResponseWithProgress(C,d,i),n||(n={errorDetails:{message:(0,y.localize)(0,null)}})}catch(v){n={errorDetails:{message:(0,y.localize)(1,null,v.message),responseIsIncomplete:!0}},this.logService.error(v)}try{if(g.saveState&&this._chatSessions.has(o)){const v=g.saveState();this._proxy.$acceptChatState(o,v)}}catch(v){this.logService.warn(v)}const s={firstProgress:r??0,totalElapsed:k.elapsed()};return{errorDetails:n.errorDetails,timings:s}}async $provideSlashCommands(E,o,t){const i=this._chatProvider.get(E);if(!i)return;const a=this._chatSessions.get(o);return!a||!i.provider.provideSlashCommands?void 0:(await i.provider.provideSlashCommands(a,t))?.map(C=>({...C,kind:A.CompletionItemKind.from(C.kind)}))}$releaseSession(E){this._chatSessions.delete(E)}async $onDidPerformUserAction(E){this._onDidPerformUserAction.fire(E)}registerSlashCommandProvider(E,o,t){const i=new _(E,t);return this._slashCommandProvider.set(i.handle,i),this._proxy.$registerSlashCommandProvider(i.handle,o),(0,M.toDisposable)(()=>{this._proxy.$unregisterSlashCommandProvider(i.handle),this._slashCommandProvider.delete(i.handle)})}async $provideProviderSlashCommands(E,o){const t=this._slashCommandProvider.get(E);return t?(await t.provider.provideSlashCommands(o))?.map(a=>({...a,kind:A.CompletionItemKind.from(a.kind)})):void 0}async $resolveSlashCommand(E,o,t){const i=this._slashCommandProvider.get(E);if(!i)return;const a=await i.provider.resolveSlashCommand(o,t);return(0,h.withNullAsUndefined)(a)}}e.ExtHostChat=c}),define(Pe[220],Ae([1,0,4]),function(pe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class O{constructor(M){const T=M.getProxy(w.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(h){return T.$writeText(h)}})}}e.ExtHostClipboard=O}),define(Pe[32],Ae([1,0,12,7,8,24,4,18,14,70,44,274,2,6,3,17,104,25,46,41,59,53,58]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t,i,a,g,C,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let d=class{#e;#t;#i;constructor(m,b,l){this._commands=new Map,this._apiCommands=new Map,this.#e=m.getProxy(T.MainContext.MainThreadCommands),this._logService=b,this.#i=l,this.#t=m.getProxy(T.MainContext.MainThreadTelemetry),this.converter=new n(this,f=>{const P=this._apiCommands.get(f);return P?.result===v.Void?P:void 0},b),this._argumentProcessors=[{processArgument(f){return(0,p.revive)(f)}},{processArgument(f){return(0,M.cloneAndChange)(f,function(P){if(A.Range.isIRange(P))return I.Range.to(P);if(_.Position.isIPosition(P))return I.Position.to(P);if(A.Range.isIRange(P.range)&&c.URI.isUri(P.uri))return I.location.to(P);if(P instanceof i.VSBuffer)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(m){this._argumentProcessors.push(m)}registerApiCommand(m){const b=this.registerCommand(!1,m.id,async(...l)=>{const f=m.args.map((z,$)=>{if(!z.validate(l[$]))throw new Error(`Invalid argument '${z.name}' when running '${m.id}', received: ${l[$]}`);return z.convert(l[$])}),P=await this.executeCommand(m.internalId,...f);return m.result.convert(P,l,this.converter)},void 0,{description:m.description,args:m.args,returns:m.result.description});return this._apiCommands.set(m.id,m),new O.Disposable(()=>{b.dispose(),this._apiCommands.delete(m.id)})}registerCommand(m,b,l,f,P,z){if(this._logService.trace("ExtHostCommands#registerCommand",b),!b.trim().length)throw new Error("invalid id");if(this._commands.has(b))throw new Error(`command '${b}' already exists`);return this._commands.set(b,{callback:l,thisArg:f,description:P,extension:z}),m&&this.#e.$registerCommand(b),new O.Disposable(()=>{this._commands.delete(b)&&m&&this.#e.$unregisterCommand(b)})}executeCommand(m,...b){return this._logService.trace("ExtHostCommands#executeCommand",m),this._doExecuteCommand(m,b,!0)}async _doExecuteCommand(m,b,l){if(this._commands.has(m))return this.#e.$fireCommandActivationEvent(m),this._executeContributedCommand(m,b,!1);{let f=!1;const P=(0,M.cloneAndChange)(b,function(z){if(z instanceof O.Position)return I.Position.from(z);if(z instanceof O.Range)return I.Range.from(z);if(z instanceof O.Location)return I.location.from(z);if(O.NotebookRange.isNotebookRange(z))return I.NotebookRange.from(z);if(z instanceof ArrayBuffer)return f=!0,i.VSBuffer.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return f=!0,i.VSBuffer.wrap(z);if(z instanceof i.VSBuffer)return f=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(m,f?new a.SerializableObjectWithBuffers(P):P,l);return(0,p.revive)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this._doExecuteCommand(m,b,!1);throw z}}}async _executeContributedCommand(m,b,l){const f=this._commands.get(m);if(!f)throw new Error("Unknown command");const{callback:P,thisArg:z,description:$}=f;if($)for(let x=0;x<$.args.length;x++)try{(0,w.validateConstraint)(b[x],$.args[x].constraint)}catch{throw new Error(`Running the contributed command: '${m}' failed. Illegal argument '${$.args[x].name}' - ${$.args[x].description}`)}const H=C.StopWatch.create();try{return await P.apply(z,b)}catch(x){if(m===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...b);U&&(m=U.command)}if(this._logService.error(x,m,f.extension?.identifier),!l)throw x;if(f.extension?.identifier){const U=this.#i.onExtensionError(f.extension.identifier,x);this._logService.trace("forwarded error to extension?",U,f.extension?.identifier)}throw new class extends Error{constructor(){super((0,g.toErrorMessage)(x)),this.id=m,this.source=f.extension?.displayName??f.extension?.name}}}finally{this._reportTelemetry(f,m,H.elapsed())}}_reportTelemetry(m,b,l){m.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:m.extension.identifier.value,id:new k.TelemetryTrustedValue(b),duration:l})}$executeContributedCommand(m,...b){this._logService.trace("ExtHostCommands#$executeContributedCommand",m);const l=this._commands.get(m);return l?(b=b.map(f=>this._argumentProcessors.reduce((P,z)=>z.processArgument(P,l.extension?.identifier),f)),this._executeContributedCommand(m,b,!0)):Promise.reject(new Error(`Contributed command '${m}' does not exist.`))}getCommands(m=!1){return this._logService.trace("ExtHostCommands#getCommands",m),this.#e.$getCommands().then(b=>(m&&(b=b.filter(l=>l[0]!=="_")),b))}$getContributedCommandHandlerDescriptions(){const m=Object.create(null);for(const[b,l]of this._commands){const{description:f}=l;f&&(m[b]=f)}return Promise.resolve(m)}};e.ExtHostCommands=d,e.ExtHostCommands=d=We([He(0,o.IExtHostRpcService),He(1,y.ILogService),He(2,r.IExtHostTelemetry)],d),e.IExtHostCommands=(0,E.createDecorator)("IExtHostCommands");class n{constructor(m,b,l){this._commands=m,this._lookupApiCommand=b,this._logService=l,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(m,b){if(!m)return;const l={$ident:void 0,id:m.command,title:m.title,tooltip:m.tooltip};if(!m.command)return l;const f=this._lookupApiCommand(m.command);if(f)l.id=f.internalId,l.arguments=f.args.map((P,z)=>P.convert(m.arguments&&m.arguments[z]));else if((0,h.isNonEmptyArray)(m.arguments)){const P=`${m.command}/${++this._cachIdPool}`;this._cache.set(P,m),b.add((0,S.toDisposable)(()=>{this._cache.delete(P),this._logService.trace("CommandsConverter#DISPOSE",P)})),l.$ident=P,l.id=this.delegatingCommandId,l.arguments=[P],this._logService.trace("CommandsConverter#CREATE",m.command,P)}return l}fromInternal(m){return typeof m.$ident=="string"?this._cache.get(m.$ident):{command:m.id,title:m.title,arguments:m.arguments}}getActualCommand(...m){return this._cache.get(m[0])}_executeConvertedCommand(...m){const b=this.getActualCommand(...m);return this._logService.trace("CommandsConverter#EXECUTE",m[0],b?b.command:"MISSING"),b?this._commands.executeCommand(b.command,...b.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${m[0]}`)}}e.CommandsConverter=n;class s{static{this.Uri=new s("uri","Uri of a text document",m=>c.URI.isUri(m),m=>m)}static{this.Position=new s("position","A position in a text document",m=>O.Position.isPosition(m),I.Position.from)}static{this.Range=new s("range","A range in a text document",m=>O.Range.isRange(m),I.Range.from)}static{this.Selection=new s("selection","A selection in a text document",m=>O.Selection.isSelection(m),I.Selection.from)}static{this.Number=new s("number","",m=>typeof m=="number",m=>m)}static{this.String=new s("string","",m=>typeof m=="string",m=>m)}static{this.CallHierarchyItem=new s("item","A call hierarchy item",m=>m instanceof O.CallHierarchyItem,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new s("item","A type hierarchy item",m=>m instanceof O.TypeHierarchyItem,I.TypeHierarchyItem.from)}static{this.TestItem=new s("testItem","A VSCodium TestItem",m=>m instanceof t.TestItemImpl,I.TestItem.from)}constructor(m,b,l,f){this.name=m,this.description=b,this.validate=l,this.convert=f}optional(){return new s(this.name,`(optional) ${this.description}`,m=>m==null||this.validate(m),m=>m===void 0?void 0:m===null?null:this.convert(m))}with(m,b){return new s(m??this.name,b??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s;class v{static{this.Void=new v("no result",m=>m)}constructor(m,b){this.description=m,this.convert=b}}e.ApiCommandResult=v;class D{constructor(m,b,l,f,P){this.id=m,this.internalId=b,this.description=l,this.args=f,this.result=P}}e.ApiCommand=D}),define(Pe[221],Ae([1,0,18,13,2,78,91,31,95,32,8,7]),function(pe,e,w,O,I,M,T,h,y,p,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const c=[new p.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",E(A.DocumentHighlight.to))),new p.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,w.isFalsyOrEmpty)(t))return;class a extends _.SymbolInformation{static to(C){const k=new a(C.name,A.SymbolKind.to(C.kind),C.containerName||"",new _.Location(i[0],A.Range.to(C.range)));return k.detail=C.detail,k.range=k.location.range,k.selectionRange=A.Range.to(C.selectionRange),k.children=C.children?C.children.map(a.to):[],k}}return t.map(a.to)})),new p.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(A.TextEdit.to))),new p.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range,new p.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(A.TextEdit.to))),new p.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,new p.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new p.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(A.TextEdit.to))),new p.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",o)),new p.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",o)),new p.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",o)),new p.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",o)),new p.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location-instances.",E(A.location.to))),new p.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Hover-instances.",E(A.Hover.to))),new p.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>_.Position.isPosition(i)),t=>t.map(A.Position.from))],new p.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(i=>{let a;for(const g of i.reverse())a=new _.SelectionRange(A.Range.to(g),a);return a}))),new p.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.ApiCommandArgument.String.with("query","Search string")],new p.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(A.WorkspaceSymbol.to))),new p.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(A.CallHierarchyItem.to))),new p.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.ApiCommandArgument.CallHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(A.CallHierarchyIncomingCall.to))),new p.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.ApiCommandArgument.CallHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(A.CallHierarchyOutgoingCall.to))),new p.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:A.Range.to(t.range),placeholder:t.text}})),new p.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("newName","The new symbol name")],new p.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return A.WorkspaceEdit.to(t)}})),new p.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(A.DocumentLink.to))),new p.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new _.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new p.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,T.decodeSemanticTokensDto)(t);if(i.type==="full")return new _.SemanticTokens(i.data,void 0)})),new p.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range.optional()],new p.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new _.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new p.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,T.decodeSemanticTokensDto)(t);if(i.type==="full")return new _.SemanticTokens(i.data,void 0)})),new p.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,i,a)=>{if(!t)return new _.CompletionList([]);const g=t.suggestions.map(C=>A.CompletionItem.to(C,a));return new _.CompletionList(g,t.incomplete)})),new p.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return A.SignatureHelp.to(t)})),new p.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,i,a)=>E(g=>new _.CodeLens(A.Range.to(g.range),g.command&&a.fromInternal(g.command)))(t))),new p.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>_.Range.isRange(t),t=>_.Selection.isSelection(t)?A.Selection.from(t):A.Range.from(t)),p.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),p.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,i,a)=>E(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(g.command)}else{const C=new _.CodeAction(g.title,g.kind?new _.CodeActionKind(g.kind):void 0);return g.edit&&(C.edit=A.WorkspaceEdit.to(g.edit)),g.command&&(C.command=a.fromInternal(g.command)),C.isPreferred=g.isPreferred,C}})(t))),new p.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new _.ColorInformation(A.Range.to(i.range),A.Color.to(i.color))):[])),new p.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.ApiCommandArgument("color","The color to show and insert",t=>t instanceof _.Color,A.Color.from),new p.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:A.Range.from(t.range)}))],new p.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(A.ColorPresentation.to):[])),new p.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,i,a)=>t.map(A.InlayHint.to.bind(void 0,a)))),new p.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(A.FoldingRange.to)})),new p.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",E(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>A.NotebookExclusiveDocumentPattern.to(i))})))),new p.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(A.InlineValue.to))),new p.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>I.URI.isUri(t)||typeof t=="string"&&(0,y.matchesSomeScheme)(t,O.Schemas.http,O.Schemas.https),t=>t),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional(),p.ApiCommandArgument.String.with("label","").optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.ApiCommandArgument.Uri.with("resource","Resource to open"),p.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VSCodium's default editor"),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),p.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),p.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)]).optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new p.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.ApiCommandArgument.TypeHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new p.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.ApiCommandArgument.TypeHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new p.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.ApiCommandArgument.TestItem],p.ApiCommandResult.Void),new p.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.ApiCommandResult.Void),new p.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.ApiCommandArgument.String.with("name","The context key name"),new p.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],p.ApiCommandResult.Void)];class S{static register(i){c.forEach(i.registerApiCommand,i),this._registerValidateWhenClausesCommand(i)}static _registerValidateWhenClausesCommand(i){i.registerCommand(!1,"_validateWhenClauses",h.validateWhenClauses)}}e.ExtHostApiCommands=S;function E(t){return i=>{if(Array.isArray(i))return i.map(t)}}function o(t){if(!Array.isArray(t))return;const i=[];for(const a of t)M.isLocationLink(a)?i.push(A.DefinitionLink.to(a)):i.push(A.location.to(a));return i}}),define(Pe[222],Ae([1,0,16,66,5,6,2,78,21,8,7,4,26,12]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function E(o,t,i){const a=o.getProxy(_.MainContext.MainThreadComments);class g{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new y.ExtensionIdentifierMap,t.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const m=this._commentControllers.get(u.handle);return m?m.value:u}else if(u&&u.$mid===7){const m=this._commentControllers.get(u.commentControlHandle);if(!m)return u;const b=m.getCommentThread(u.commentThreadHandle);return b?b.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const m=this._commentControllers.get(u.thread.commentControlHandle);if(!m)return u;const b=m.getCommentThread(u.thread.commentThreadHandle);return b?u.$mid===8?b.value:{thread:b.value,text:u.text}:u}else if(u&&u.$mid===10){const m=this._commentControllers.get(u.thread.commentControlHandle);if(!m)return u;const b=m.getCommentThread(u.thread.commentThreadHandle);if(!b)return u;const l=u.commentUniqueId,f=b.getCommentByUniqueId(l);return f||u}else if(u&&u.$mid===11){const m=this._commentControllers.get(u.thread.commentControlHandle);if(!m)return u;const b=m.getCommentThread(u.thread.commentThreadHandle);if(!b)return u;const l=u.text,f=u.commentUniqueId,P=b.getCommentByUniqueId(f);return P?(typeof P.body=="string"?P.body=l:P.body=new A.MarkdownString(l),P):u}return u}})}createCommentController(u,m,b){const l=g.handlePool++,f=new k(u,l,m,b);this._commentControllers.set(f.handle,f);const P=this._commentControllersByExtension.get(u.identifier)||[];return P.push(f),this._commentControllersByExtension.set(u.identifier,P),f.value}$createCommentThreadTemplate(u,m,b){const l=this._commentControllers.get(u);l&&l.$createCommentThreadTemplate(m,b)}async $updateCommentThreadTemplate(u,m,b){const l=this._commentControllers.get(u);l&&l.$updateCommentThreadTemplate(m,b)}$deleteCommentThread(u,m){this._commentControllers.get(u)?.$deleteCommentThread(m)}$provideCommentingRanges(u,m,b){const l=this._commentControllers.get(u);if(!l||!l.commentingRangeProvider)return Promise.resolve(void 0);const f=i.getDocument(T.URI.revive(m));return(0,w.asPromise)(async()=>{const P=await l.commentingRangeProvider.provideCommentingRanges(f,b);let z;return Array.isArray(P)?z={ranges:P,fileComments:!1}:P?z={ranges:P.ranges||[],fileComments:P.fileComments||!1}:z=(0,S.withNullAsUndefined)(P),z}).then(P=>{let z;return P&&(z={ranges:P.ranges.map($=>p.Range.from($)),fileComments:P.fileComments}),z})}$toggleReaction(u,m,b,l,f){const P=this._commentControllers.get(u);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,w.asPromise)(()=>{const z=P.getCommentThread(m);if(z){const $=z.getCommentByUniqueId(l.uniqueIdInThread);if(P!==void 0&&$&&P.reactionHandler)return P.reactionHandler($,n(f))}return Promise.resolve(void 0)})}}class C{static{this._handlePool=0}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){(u===void 0!=(this._range===void 0)||!u||!this._range||!u.isEqual(this._range))&&(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(u){this._state=u,this.modifications.state=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(u,m,b,l,f,P,z,$){this._commentControllerHandle=m,this._id=b,this._uri=l,this._range=f,this._comments=P,this.extensionDescription=z,this._isTemplate=$,this.handle=C._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputDisposables.value=new M.DisposableStore,this._id===void 0&&(this._id=`${u}.${this.handle}`),a.$createCommentThread(m,this.handle,this._id,this._uri,p.Range.from(this._range),z.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this._localDisposables.push({dispose:()=>{a.$deleteCommentThread(m,this.handle)}});const H=this;this.value={get uri(){return H.uri},get range(){return H.range},set range(x){H.range=x},get comments(){return H.comments},set comments(x){H.comments=x},get collapsibleState(){return H.collapsibleState},set collapsibleState(x){H.collapsibleState=x},get canReply(){return H.canReply},set canReply(x){H.canReply=x},get contextValue(){return H.contextValue},set contextValue(x){H.contextValue=x},get label(){return H.label},set label(x){H.label=x},get state(){return H.state},set state(x){H.state=x},dispose:()=>{H.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new M.DisposableStore);const u=b=>Object.prototype.hasOwnProperty.call(this.modifications,b),m={};u("range")&&(m.range=p.Range.from(this._range)),u("label")&&(m.label=this.label),u("contextValue")&&(m.contextValue=this.contextValue??null),u("comments")&&(m.comments=this._comments.map(b=>r(this,b,this._commentsMap,this.extensionDescription))),u("collapsibleState")&&(m.collapseState=s(this._collapseState)),u("canReply")&&(m.canReply=this.canReply),u("state")&&(m.state=v(this._state)),u("isTemplate")&&(m.isTemplate=this._isTemplate),this.modifications={},a.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,m)}getCommentByUniqueId(u){for(const m of this._commentsMap){const b=m[0],l=m[1];if(u===l)return b}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose())}}We([(0,O.debounce)(100)],C.prototype,"eventuallyUpdateCommentThread",null);class k{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(u){this._commentingRangeProvider=u,a.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,a.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(u,m,b,l){this._extension=u,this._handle=m,this._id=b,this._label=l,this._threads=new Map,a.$registerCommentController(this.handle,b,l);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(P){f.options=P},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(P){f.commentingRangeProvider=P},get reactionHandler(){return f.reactionHandler},set reactionHandler(P){f.reactionHandler=P},createCommentThread(P,z,$){return f.createCommentThread(P,z,$).value},dispose:()=>{f.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(u,m,b){m===void 0&&(0,c.checkProposedApiEnabled)(this._extension,"fileComments");const l=new C(this.id,this.handle,void 0,u,m,b,this._extension,!1);return this._threads.set(l.handle,l),l}$createCommentThreadTemplate(u,m){const b=new C(this.id,this.handle,void 0,T.URI.revive(u),p.Range.to(m),[],this._extension,!0);return b.collapsibleState=h.CommentThreadCollapsibleState.Expanded,this._threads.set(b.handle,b),b}$updateCommentThreadTemplate(u,m){const b=this._threads.get(u);b&&(b.range=p.Range.to(m))}$deleteCommentThread(u){this._threads.get(u)?.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._localDisposables.forEach(u=>u.dispose())}}function r(D,u,m,b){let l=m.get(u);return l||(l=++D.commentHandle,m.set(u,l)),u.state!==void 0&&(0,c.checkProposedApiEnabled)(b,"commentsDraftState"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:l,body:typeof u.body=="string"?u.body:p.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(f=>d(f)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function d(D){return{label:D.label,iconPath:D.iconPath?p.pathOrURIToURI(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted}}function n(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?T.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1}}function s(D){if(D!==void 0)switch(D){case A.CommentThreadCollapsibleState.Expanded:return h.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return h.CommentThreadCollapsibleState.Collapsed}return h.CommentThreadCollapsibleState.Collapsed}function v(D){if(D!==void 0)switch(D){case A.CommentThreadState.Unresolved:return h.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return h.CommentThreadState.Resolved}return h.CommentThreadState.Unresolved}return new g}e.createExtHostComments=E}),define(Pe[223],Ae([1,0,24,4,27,17]),function(pe,e,w,O,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let T=class{constructor(A,_){this._mainThreadConsole=A.getProxy(O.MainContext.MainThreadConsole),this._includeStack=_.consoleForward.includeStack,this._logNative=_.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(A,_){const c=this,S=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){c._handleConsoleCall(A,_,S,arguments)}})}_handleConsoleCall(A,_,c,S){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:_,arguments:y(S,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(A,c,S)}};e.AbstractExtHostConsoleForwarder=T,e.AbstractExtHostConsoleForwarder=T=We([He(0,M.IExtHostRpcService),He(1,I.IExtHostInitDataService)],T);const h=1e5;function y(p,A){const _=[];if(p.length)for(let c=0;c<p.length;c++){let S=p[c];if(typeof S>"u")S="undefined";else if(S instanceof Error){const E=S;E.stack?S=E.stack:S=E.toString()}_.push(S)}if(A){const c=new Error().stack;c&&_.push({__$stack:c.split(`
`).slice(3).join(`
`)})}try{const c=(0,w.safeStringify)(_);return c.length>h?"Output omitted for a large object that exceeds the limits":c}catch(c){return`Output omitted for an object that cannot be inspected ('${c.toString()}')`}}}),define(Pe[107],Ae([1,0,2,4,7,3,17,14,18,15,19,26]),function(pe,e,w,O,I,M,T,h,y,p,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let c=class Qi{static{this._handlePool=0}static{this._maxEventSize=250}constructor(E,o){this._logService=o,this._provider=new Map,this._proxy=E.getProxy(O.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,o){const t=Qi._handlePool++;this._provider.set(t,{provider:E,extensionDescription:o}),this._proxy.$registerDecorationProvider(t,o.identifier.value);const i=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(a=>{if(!a){this._proxy.$onDidChange(t,null);return}const g=(0,y.asArray)(a);if(g.length<=Qi._maxEventSize){this._proxy.$onDidChange(t,g);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,g.length);const C=g.map(d=>({uri:d,rank:(0,p.count)(d.path,"/")})),k=(0,y.groupBy)(C,(d,n)=>d.rank-n.rank||(0,p.compare)(d.uri.path,n.uri.path)),r=[];e:for(const d of k){let n;for(const s of d){const v=(0,A.dirname)(s.uri.path);if(n!==v&&(n=v,r.push(s.uri)>=Qi._maxEventSize))break e}}this._proxy.$onDidChange(t,r)});return new I.Disposable(()=>{i?.dispose(),this._proxy.$unregisterDecorationProvider(t),this._provider.delete(t)})}async $provideDecorations(E,o,t){if(!this._provider.has(E))return Object.create(null);const i=Object.create(null),{provider:a,extensionDescription:g}=this._provider.get(E);return await Promise.all(o.map(async C=>{try{const{uri:k,id:r}=C,d=await Promise.resolve(a.provideFileDecoration(w.URI.revive(k),t));if(!d)return;try{I.FileDecoration.validate(d),d.badge&&typeof d.badge!="string"&&(0,_.checkProposedApiEnabled)(g,"codiconDecoration"),i[r]=[d.propagate,d.tooltip,d.badge,d.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${g.identifier.value}': ${n}`)}}catch(k){this._logService.error(k)}})),i}};e.ExtHostDecorations=c,e.ExtHostDecorations=c=We([He(0,T.IExtHostRpcService),He(1,h.ILogService)],c),e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")}),define(Pe[224],Ae([1,0,147,94,2,4,7,8,5,14,28,39]),function(pe,e,w,O,I,M,T,h,y,p,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class c{#e;#t;#i;constructor(o,t,i,a,g,C,k,r){this._name=o,this._owner=t,this._maxDiagnosticsTotal=i,this._maxDiagnosticsPerFile=a,this._modelVersionIdProvider=g,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(a,i),this.#i=new A.ResourceMap(d=>C.getComparisonKey(d)),this.#e=k,this.#t=r}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,t){if(!o){this.clear();return}this._checkDisposed();let i=[];if(I.URI.isUri(o)){if(!t){this.delete(o);return}this.#i.set(o,t.slice()),i=[o]}else if(Array.isArray(o)){i=[];let C;o=[...o].sort(c._compareIndexedTuplesByUri);for(const k of o){const[r,d]=k;if((!C||r.toString()!==C.toString())&&(C&&this.#i.get(C).length===0&&this.#i.delete(C),C=r,i.push(r),this.#i.set(r,[])),d)this.#i.get(r)?.push(...d);else{const n=this.#i.get(r);n&&(n.length=0)}}}if(this.#t.fire(i),!this.#e)return;const a=[];let g=0;for(const C of i){let k=[];const r=this.#i.get(C);if(r)if(r.length>this._maxDiagnosticsPerFile){k=[];const d=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(const s of r)if(s.severity===d[n]&&k.push({...h.Diagnostic.from(s),modelVersionId:this._modelVersionIdProvider(C)})===this._maxDiagnosticsPerFile)break e;k.push({severity:O.MarkerSeverity.Info,message:(0,w.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:k[k.length-1].startLineNumber,startColumn:k[k.length-1].startColumn,endLineNumber:k[k.length-1].endLineNumber,endColumn:k[k.length-1].endColumn})}else k=r.map(d=>({...h.Diagnostic.from(d),modelVersionId:this._modelVersionIdProvider(C)}));if(a.push([C,k]),g+=k.length,g>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,a)}delete(o){this._checkDisposed(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(o,t){this._checkDisposed();for(const[i,a]of this)o.call(t,i,a,this)}*[Symbol.iterator](){this._checkDisposed();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this._checkDisposed();const t=this.#i.get(o);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(this.#i.get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,t){return o[0].toString()<t[0].toString()?-1:o[0].toString()>t[0].toString()?1:0}}e.DiagnosticCollection=c;let S=class ui{static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*ui._maxDiagnosticsPerFile}static _mapper(o){const t=new A.ResourceMap;for(const i of o)t.set(i,i);return{uris:Object.freeze(Array.from(t.values()))}}constructor(o,t,i,a){this._logService=t,this._fileSystemInfoService=i,this._extHostDocumentsAndEditors=a,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,ui._mapper),this._proxy=o.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(o,t){const{_collections:i,_proxy:a,_onDidChangeDiagnostics:g,_logService:C,_fileSystemInfoService:k,_extHostDocumentsAndEditors:r}=this,d=new class{$changeMany(v,D){a.$changeMany(v,D),C.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,v,D.length===0?"CLEARING":D)}$clear(v){a.$clear(v),C.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,v)}dispose(){a.dispose()}};let n;if(!t)t="_generated_diagnostic_collection_name_#"+ui._idPool++,n=t;else if(!i.has(t))n=t;else{this._logService.warn(`DiagnosticCollection with name '${t}' does already exist.`);do n=t+ui._idPool++;while(i.has(n))}return new class extends c{constructor(){super(t,n,ui._maxDiagnosticsTotal,ui._maxDiagnosticsPerFile,v=>r.getDocument(v)?.version,k.extUri,d,g),i.set(n,this)}dispose(){super.dispose(),i.delete(n)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const t=new Map,i=[];for(const a of this._collections.values())a.forEach((g,C)=>{let k=t.get(g.toString());typeof k>"u"&&(k=i.length,t.set(g.toString(),k),i.push([g,[]])),i[k][1]=i[k][1].concat(...C)});return i}}_getDiagnostics(o){let t=[];for(const i of this._collections.values())i.has(o)&&(t=t.concat(i.get(o)));return t}$acceptMarkersChange(o){if(!this._mirrorCollection){const t="_generated_mirror",i=new c(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,a=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(t,i),this._mirrorCollection=i}for(const[t,i]of o)this._mirrorCollection.set(I.URI.revive(t),i.map(h.Diagnostic.to))}};e.ExtHostDiagnostics=S,e.ExtHostDiagnostics=S=We([He(1,p.ILogService),He(2,_.IExtHostFileSystemInfo)],S)}),define(Pe[225],Ae([1,0,2,4,26]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class M{constructor(h){this._proxy=h.getProxy(O.MainContext.MainThreadDialogs)}showOpenDialog(h,y){return y?.allowUIResources&&(0,I.checkProposedApiEnabled)(h,"showLocal"),this._proxy.$showOpenDialog(y).then(p=>p?p.map(A=>w.URI.revive(A)):void 0)}showSaveDialog(h){return this._proxy.$showSaveDialog(h).then(y=>y?w.URI.revive(y):void 0)}}e.ExtHostDialogs=M}),define(Pe[226],Ae([1,0,11,2,7,4,13,20,15]),function(pe,e,w,O,I,M,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class p{static{this._handlePool=0}constructor(_,c,S){this._documentsAndEditors=c,this._logService=S,this._documentContentProviders=new Map,this._proxy=_.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,c){if(Object.keys(T.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const S=p._handlePool++;this._documentContentProviders.set(S,c),this._proxy.$registerTextContentProvider(S,_);let E;return typeof c.onDidChange=="function"&&(E=c.onDidChange(o=>{if(o.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(o)&&this.$provideTextDocumentContent(S,o).then(t=>{if(!t&&typeof t!="string")return;const i=this._documentsAndEditors.getDocument(o);if(!i)return;const a=(0,y.splitLines)(t);if(!i.equalLines(a))return this._proxy.$onVirtualDocumentChange(o,t)},w.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(S)&&this._proxy.$unregisterTextContentProvider(S),E&&(E.dispose(),E=void 0)})}$provideTextDocumentContent(_,c){const S=this._documentContentProviders.get(_);return S?Promise.resolve(S.provideTextDocumentContent(O.URI.revive(c),h.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=p}),define(Pe[227],Ae([1,0,5,6,2,4,100,8,12,24,7,11]),function(pe,e,w,O,I,M,T,h,y,p,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class c{constructor(E,o){this._onDidAddDocument=new w.Emitter({onListenerError:_.onUnexpectedExternalError}),this._onDidRemoveDocument=new w.Emitter({onListenerError:_.onUnexpectedExternalError}),this._onDidChangeDocument=new w.Emitter({onListenerError:_.onUnexpectedExternalError}),this._onDidSaveDocument=new w.Emitter({onListenerError:_.onUnexpectedExternalError}),this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new O.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(M.MainContext.MainThreadDocuments),this._documentsAndEditors=o,this._documentsAndEditors.onDidRemoveDocuments(t=>{for(const i of t)this._onDidRemoveDocument.fire(i.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(t=>{for(const i of t)this._onDidAddDocument.fire(i.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const o=this._documentsAndEditors.getDocument(E);if(o)return o}getDocument(E){const o=this.getDocumentData(E);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return o.document}ensureDocumentData(E){const o=this._documentsAndEditors.getDocument(E);if(o)return Promise.resolve(o);let t=this._documentLoader.get(E.toString());return t||(t=this._proxy.$tryOpenDocument(E).then(i=>{this._documentLoader.delete(E.toString());const a=I.URI.revive(i);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(a))},i=>(this._documentLoader.delete(E.toString()),Promise.reject(i))),this._documentLoader.set(E.toString(),t)),t}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(o=>I.URI.revive(o))}$acceptModelLanguageChanged(E,o){const t=I.URI.revive(E),i=this._documentsAndEditors.getDocument(t);if(!i)throw new Error("unknown document");this._onDidRemoveDocument.fire(i.document),i._acceptLanguageId(o),this._onDidAddDocument.fire(i.document)}$acceptModelSaved(E){const o=I.URI.revive(E),t=this._documentsAndEditors.getDocument(o);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(t.document)}$acceptDirtyStateChanged(E,o){const t=I.URI.revive(E),i=this._documentsAndEditors.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(o),this._onDidChangeDocument.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,o,t){const i=I.URI.revive(E),a=this._documentsAndEditors.getDocument(i);if(!a)throw new Error("unknown document");a._acceptIsDirty(t),a.onEvents(o);let g;o.isUndoing?g=A.TextDocumentChangeReason.Undo:o.isRedoing&&(g=A.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,p.deepFreeze)({document:a.document,contentChanges:o.changes.map(C=>({range:h.Range.to(C.range),rangeOffset:C.rangeOffset,rangeLength:C.rangeLength,text:C.text})),reason:g}))}setWordDefinitionFor(E,o){(0,T.setWordDefinitionFor)(E,o)}}e.ExtHostDocuments=c}),define(Pe[60],Ae([1,0,50,5,6,2,3,4,100,17,105,8,14,28,13,68,67]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class i{constructor(C){this.value=C,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let a=class{constructor(C,k){this._extHostRpc=C,this._logService=k,this._activeEditorId=null,this._editors=new Map,this._documents=new S.ResourceMap,this._onDidAddDocuments=new O.Emitter,this._onDidRemoveDocuments=new O.Emitter,this._onDidChangeVisibleTextEditors=new O.Emitter,this._onDidChangeActiveTextEditor=new O.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(C){this.acceptDocumentsAndEditorsDelta(C)}acceptDocumentsAndEditorsDelta(C){const k=[],r=[],d=[];if(C.removedDocuments)for(const n of C.removedDocuments){const s=M.URI.revive(n),v=this._documents.get(s);v?.unref()&&(this._documents.delete(s),k.push(v.value))}if(C.addedDocuments)for(const n of C.addedDocuments){const s=M.URI.revive(n.uri);let v=this._documents.get(s);if(v&&s.scheme!==E.Schemas.vscodeNotebookCell&&s.scheme!==E.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);v||(v=new i(new y.ExtHostDocumentData(this._extHostRpc.getProxy(h.MainContext.MainThreadDocuments),s,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(s,v),r.push(v.value)),v.ref()}if(C.removedEditors)for(const n of C.removedEditors){const s=this._editors.get(n);this._editors.delete(n),s&&d.push(s)}if(C.addedEditors)for(const n of C.addedEditors){const s=M.URI.revive(n.documentUri);w.ok(this._documents.has(s),`document '${s}' does not exist`),w.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const v=this._documents.get(s).value,D=new A.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(h.MainContext.MainThreadTextEditors),this._logService,new t.Lazy(()=>v.document),n.selections.map(_.Selection.to),n.options,n.visibleRanges.map(u=>_.Range.to(u)),typeof n.editorPosition=="number"?_.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,D)}C.newActiveEditor!==void 0&&(w.ok(C.newActiveEditor===null||this._editors.has(C.newActiveEditor),`active editor '${C.newActiveEditor}' does not exist`),this._activeEditorId=C.newActiveEditor),(0,I.dispose)(k),(0,I.dispose)(d),C.removedDocuments&&this._onDidRemoveDocuments.fire(k),C.addedDocuments&&this._onDidAddDocuments.fire(r),(C.removedEditors||C.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),C.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(C){return this._documents.get(C)?.value}allDocuments(){return o.Iterable.map(this._documents.values(),C=>C.value)}getEditor(C){return this._editors.get(C)}activeEditor(C){if(!this._activeEditorId)return;const k=this._editors.get(this._activeEditorId);return C?k:k?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=a,e.ExtHostDocumentsAndEditors=a=We([He(0,p.IExtHostRpcService),He(1,c.ILogService)],a),e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(Pe[61],Ae([1,0,8,4,2,5,3,7,17,12,65]),function(pe,e,w,O,I,M,T,h,y,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");class _{constructor(t,i,a){this._activeTabIdGetter=a,this._parentGroup=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this._apiObject){const t=this,i={get isActive(){return t._dto.id===t._activeTabIdGetter()},get label(){return t._dto.label},get input(){return t._input},get isDirty(){return t._dto.isDirty},get isPinned(){return t._dto.isPinned},get isPreview(){return t._dto.isPreview},get group(){return t._parentGroup.apiObject}};this._apiObject=Object.freeze(i)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(t){this._dto=t,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new h.TextTabInput(I.URI.revive(this._dto.input.uri));case 2:return new h.TextDiffTabInput(I.URI.revive(this._dto.input.original),I.URI.revive(this._dto.input.modified));case 3:return new h.TextMergeTabInput(I.URI.revive(this._dto.input.base),I.URI.revive(this._dto.input.input1),I.URI.revive(this._dto.input.input2),I.URI.revive(this._dto.input.result));case 6:return new h.CustomEditorTabInput(I.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new h.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new h.NotebookEditorTabInput(I.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new h.NotebookDiffEditorTabInput(I.URI.revive(this._dto.input.original),I.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new h.TerminalEditorTabInput;case 9:return new h.InteractiveWindowInput(I.URI.revive(this._dto.input.uri),I.URI.revive(this._dto.input.inputBoxUri));default:return}}}class c{constructor(t,i){this._tabs=[],this._activeTabId="",this._dto=t,this._activeGroupIdGetter=i;for(const a of t.tabs)a.isActive&&(this._activeTabId=a.id),this._tabs.push(new _(a,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const t=this,i={get isActive(){return t._dto.groupId===t._activeGroupIdGetter()},get viewColumn(){return w.ViewColumn.to(t._dto.viewColumn)},get activeTab(){return t._tabs.find(a=>a.tabId===t._activeTabId)?.apiObject},get tabs(){return Object.freeze(t._tabs.map(a=>a.apiObject))}};this._apiObject=Object.freeze(i)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(t){this._dto=t}acceptTabOperation(t){if(t.kind===0){const a=new _(t.tabDto,this,()=>this.activeTabId());return this._tabs.splice(t.index,0,a),t.tabDto.isActive&&(this._activeTabId=a.tabId),a}else if(t.kind===1){const a=this._tabs.splice(t.index,1)[0];if(!a)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return a.tabId===this._activeTabId&&(this._activeTabId=""),a}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const a=this._tabs.splice(t.oldIndex,1)[0];if(!a)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this._tabs.splice(t.index,0,a),a}const i=this._tabs.find(a=>a.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this._activeTabId=t.tabDto.id:this._activeTabId===t.tabDto.id&&!t.tabDto.isActive&&(this._activeTabId=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this._activeTabId}}let S=class{constructor(t){this._onDidChangeTabs=new M.Emitter,this._onDidChangeTabGroups=new M.Emitter,this._extHostTabGroups=[],this._proxy=t.getProxy(O.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const t=this,i={onDidChangeTabGroups:t._onDidChangeTabGroups.event,onDidChangeTabs:t._onDidChangeTabs.event,get all(){return Object.freeze(t._extHostTabGroups.map(a=>a.apiObject))},get activeTabGroup(){const a=t._activeGroupId;return(0,p.assertIsDefined)(t._extHostTabGroups.find(C=>C.groupId===a)?.apiObject)},close:async(a,g)=>{const C=Array.isArray(a)?a:[a];return C.length?E(C[0])?this._closeGroups(C,g):this._closeTabs(C,g):!0}};this._apiObject=Object.freeze(i)}return this._apiObject}$acceptEditorTabModel(t){const i=new Set(this._extHostTabGroups.map(n=>n.groupId)),a=new Set(t.map(n=>n.groupId)),g=(0,A.diffSets)(i,a),C=this._extHostTabGroups.filter(n=>g.removed.includes(n.groupId)).map(n=>n.apiObject),k=[],r=[];this._extHostTabGroups=t.map(n=>{const s=new c(n,()=>this._activeGroupId);return g.added.includes(s.groupId)?k.push(s.apiObject):r.push(s.apiObject),s});const d=(0,p.assertIsDefined)(t.find(n=>n.isActive===!0)?.groupId);d!==void 0&&this._activeGroupId!==d&&(this._activeGroupId=d),this._onDidChangeTabGroups.fire(Object.freeze({opened:k,closed:C,changed:r}))}$acceptTabGroupUpdate(t){const i=this._extHostTabGroups.find(a=>a.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this._activeGroupId=t.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this._extHostTabGroups.find(g=>g.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const a=i.acceptTabOperation(t);switch(t.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[a.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[a.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[a.apiObject]}));return}}_findExtHostTabFromApi(t){for(const i of this._extHostTabGroups)for(const a of i.tabs)if(a.apiObject===t)return a}_findExtHostTabGroupFromApi(t){return this._extHostTabGroups.find(i=>i.apiObject===t)}async _closeTabs(t,i){const a=[];for(const g of t){const C=this._findExtHostTabFromApi(g);if(!C)throw new Error("Tab close: Invalid tab not found!");a.push(C.tabId)}return this._proxy.$closeTab(a,i)}async _closeGroups(t,i){const a=[];for(const g of t){const C=this._findExtHostTabGroupFromApi(g);if(!C)throw new Error("Group close: Invalid group not found!");a.push(C.groupId)}return this._proxy.$closeGroup(a,i)}};e.ExtHostEditorTabs=S,e.ExtHostEditorTabs=S=We([He(0,y.IExtHostRpcService)],S);function E(o){return o.tabs!==void 0}}),define(Pe[228],Ae([1,0,2,4,6,7,8,275,15,25,26,49]),function(pe,e,w,O,I,M,T,h,y,p,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class c{constructor(){this._schemes=[]}add(o){this._stateMachine=void 0,this._schemes.push(o)}delete(o){const t=this._schemes.indexOf(o);t>=0&&(this._schemes.splice(t,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const o=this._schemes.sort(),t=[];let i,a,g=14,C=14;for(const k of o){let r=i?(0,y.commonPrefixLength)(i,k):0;for(r===0?a=1:a=C;r<k.length;r++)r+1===k.length?(g=C,C=9):C+=1,t.push([a,k.toUpperCase().charCodeAt(r),C]),t.push([a,k.toLowerCase().charCodeAt(r),C]),a=C;i=k,C=g}t.push([9,58,10]),t.push([10,47,12]),this._stateMachine=new h.StateMachine(t)}}provideDocumentLinks(o){this._initStateMachine();const t=[],i=h.LinkComputer.computeLinks({getLineContent(a){return o.lineAt(a-1).text},getLineCount(){return o.lineCount}},this._stateMachine);for(const a of i){const g=T.DocumentLink.to(a);g.target&&t.push(g)}return t}}class S{constructor(o,t){this._extHostLanguageFeatures=t,this._linkProvider=new c,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=o.getProxy(O.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(o,t,i,a={}){if(S._validateFileSystemProvider(i),this._registeredSchemes.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(o,"*",this._linkProvider));const g=this._handlePool++;this._linkProvider.add(t),this._registeredSchemes.add(t),this._fsProvider.set(g,i);let C=2;a.isCaseSensitive&&(C+=1024),a.isReadonly&&(C+=2048),typeof i.copy=="function"&&(C+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,A.checkProposedApiEnabled)(o,"fsChunks"),C+=4);let k;a.isReadonly&&(0,_.isMarkdownString)(a.isReadonly)&&((0,A.checkProposedApiEnabled)(o,"readonlyMessage"),k={value:a.isReadonly.value,isTrusted:a.isReadonly.isTrusted,supportThemeIcons:a.isReadonly.supportThemeIcons,supportHtml:a.isReadonly.supportHtml,baseUri:a.isReadonly.baseUri,uris:a.isReadonly.uris}),this._proxy.$registerFileSystemProvider(g,t,C,k).catch(d=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${t}`),console.error(d)});const r=i.onDidChangeFile(d=>{const n=[];for(const s of d){const{uri:v,type:D}=s;if(v.scheme!==t)continue;let u;switch(D){case M.FileChangeType.Changed:u=0;break;case M.FileChangeType.Created:u=1;break;case M.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:v,type:u})}this._proxy.$onFileSystemChange(g,n)});return(0,I.toDisposable)(()=>{r.dispose(),this._linkProvider.delete(t),this._registeredSchemes.delete(t),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _validateFileSystemProvider(o){if(!o)throw new Error("MISSING provider");if(typeof o.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof o.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof o.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof o.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof o.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof o.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof o.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof o.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(o){const{type:t,ctime:i,mtime:a,size:g,permissions:C}=o;return{type:t,ctime:i,mtime:a,size:g,permissions:C}}$stat(o,t){return Promise.resolve(this._getFsProvider(o).stat(w.URI.revive(t))).then(i=>S._asIStat(i))}$readdir(o,t){return Promise.resolve(this._getFsProvider(o).readDirectory(w.URI.revive(t)))}$readFile(o,t){return Promise.resolve(this._getFsProvider(o).readFile(w.URI.revive(t))).then(i=>p.VSBuffer.wrap(i))}$writeFile(o,t,i,a){return Promise.resolve(this._getFsProvider(o).writeFile(w.URI.revive(t),i.buffer,a))}$delete(o,t,i){return Promise.resolve(this._getFsProvider(o).delete(w.URI.revive(t),i))}$rename(o,t,i,a){return Promise.resolve(this._getFsProvider(o).rename(w.URI.revive(t),w.URI.revive(i),a))}$copy(o,t,i,a){const g=this._getFsProvider(o);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(w.URI.revive(t),w.URI.revive(i),a))}$mkdir(o,t){return Promise.resolve(this._getFsProvider(o).createDirectory(w.URI.revive(t)))}$watch(o,t,i,a){const g=this._getFsProvider(o).watch(w.URI.revive(i),a);this._watches.set(t,g)}$unwatch(o,t){const i=this._watches.get(t);i&&(i.dispose(),this._watches.delete(t))}$open(o,t,i){const a=this._getFsProvider(o);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(w.URI.revive(t),i))}$close(o,t){const i=this._getFsProvider(o);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(o,t,i,a){const g=this._getFsProvider(o);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const C=p.VSBuffer.alloc(a);return Promise.resolve(g.read(t,i,C.buffer,0,a)).then(k=>C.slice(0,k))}$write(o,t,i,a){const g=this._getFsProvider(o);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(t,i,a.buffer,0,a.byteLength))}_getFsProvider(o){const t=this._fsProvider.get(o);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.ExtHostFileSystem=S}),define(Pe[62],Ae([1,0,4,38,7,25,3,17,39,6,16,23,13]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let S=class ii{constructor(o,t){this._fileSystemProvider=new Map,this._writeQueue=new A.ResourceQueue,this._proxy=o.getProxy(w.MainContext.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(a){try{let g;const C=i._fileSystemProvider.get(a.scheme);return C?(await i._proxy.$ensureActivation(a.scheme),g=await C.impl.stat(a)):g=await i._proxy.$stat(a),{type:g.type,ctime:g.ctime,mtime:g.mtime,size:g.size,permissions:g.permissions===O.FilePermission.Readonly?1:void 0}}catch(g){ii._handleError(g)}},async readDirectory(a){try{const g=i._fileSystemProvider.get(a.scheme);return g?(await i._proxy.$ensureActivation(a.scheme),(await g.impl.readDirectory(a)).slice()):await i._proxy.$readdir(a)}catch(g){return ii._handleError(g)}},async createDirectory(a){try{const g=i._fileSystemProvider.get(a.scheme);return g&&!g.isReadonly?(await i._proxy.$ensureActivation(a.scheme),await i.mkdirp(g.impl,g.extUri,a)):await i._proxy.$mkdir(a)}catch(g){return ii._handleError(g)}},async readFile(a){try{const g=i._fileSystemProvider.get(a.scheme);return g?(await i._proxy.$ensureActivation(a.scheme),(await g.impl.readFile(a)).slice()):(await i._proxy.$readFile(a)).buffer}catch(g){return ii._handleError(g)}},async writeFile(a,g){try{const C=i._fileSystemProvider.get(a.scheme);return C&&!C.isReadonly?(await i._proxy.$ensureActivation(a.scheme),await i.mkdirp(C.impl,C.extUri,C.extUri.dirname(a)),await i._writeQueue.queueFor(a).queue(()=>Promise.resolve(C.impl.writeFile(a,g,{create:!0,overwrite:!0})))):await i._proxy.$writeFile(a,M.VSBuffer.wrap(g))}catch(C){return ii._handleError(C)}},async delete(a,g){try{const C=i._fileSystemProvider.get(a.scheme);return C&&!C.isReadonly?(await i._proxy.$ensureActivation(a.scheme),await C.impl.delete(a,{recursive:!1,...g})):await i._proxy.$delete(a,{recursive:!1,useTrash:!1,atomic:!1,...g})}catch(C){return ii._handleError(C)}},async rename(a,g,C){try{return await i._proxy.$rename(a,g,{overwrite:!1,...C})}catch(k){return ii._handleError(k)}},async copy(a,g,C){try{return await i._proxy.$copy(a,g,{overwrite:!1,...C})}catch(k){return ii._handleError(k)}},isWritableFileSystem(a){const g=t.getCapabilities(a);if(typeof g=="number")return!(g&2048)}})}async mkdirp(o,t,i){const a=[];for(;!t.isEqual(i,t.dirname(i));)try{if(!((await o.stat(i)).type&O.FileType.Directory))throw I.FileSystemError.FileExists(`Unable to create folder '${i.scheme===c.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(g){if(O.toFileSystemProviderErrorCode(g)!==O.FileSystemProviderErrorCode.FileNotFound)throw g;a.push(t.basename(i)),i=t.dirname(i)}for(let g=a.length-1;g>=0;g--){i=t.joinPath(i,a[g]);try{await o.createDirectory(i)}catch(C){if(O.toFileSystemProviderErrorCode(C)!==O.FileSystemProviderErrorCode.FileExists)throw C}}}static _handleError(o){if(o instanceof I.FileSystemError)throw o;if(o instanceof O.FileSystemProviderError)switch(o.code){case O.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(o.message);case O.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(o.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(o.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(o.message);case O.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(o.message);case O.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(o.message);default:throw new I.FileSystemError(o.message,o.name)}if(!(o instanceof Error))throw new I.FileSystemError(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw I.FileSystemError.Unavailable(o.message);switch(o.name){case O.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(o.message);case O.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(o.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(o.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(o.message);case O.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(o.message);case O.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(o.message);default:throw new I.FileSystemError(o.message,o.name)}}addFileSystemProvider(o,t,i){return this._fileSystemProvider.set(o,{impl:t,extUri:i?.isCaseSensitive?_.extUri:_.extUriIgnorePathCase,isReadonly:!!i?.isReadonly}),(0,p.toDisposable)(()=>this._fileSystemProvider.delete(o))}getFileSystemProviderExtUri(o){return this._fileSystemProvider.get(o)?.extUri??_.extUri}};e.ExtHostConsumerFileSystem=S,e.ExtHostConsumerFileSystem=S=We([He(0,h.IExtHostRpcService),He(1,y.IExtHostFileSystemInfo)],S),e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(Pe[229],Ae([1,0,5,37,2,4,8,7]),function(pe,e,w,O,I,M,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(_,c,S,E,o,t,i,a){this._onDidCreate=new w.Emitter,this._onDidChange=new w.Emitter,this._onDidDelete=new w.Emitter;const g=this.ensureWatching(_,S,o);this._config=0,t&&(this._config+=1),i&&(this._config+=2),a&&(this._config+=4);const C=(0,O.parse)(o),k=typeof o=="string",r=E(d=>{if(!t)for(const n of d.created){const s=I.URI.revive(n);C(s.fsPath)&&(!k||c.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!i)for(const n of d.changed){const s=I.URI.revive(n);C(s.fsPath)&&(!k||c.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!a)for(const n of d.deleted){const s=I.URI.revive(n);C(s.fsPath)&&(!k||c.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=h.Disposable.from(g,this._onDidCreate,this._onDidChange,this._onDidDelete,r)}ensureWatching(_,c,S){const E=h.Disposable.from();if(typeof S=="string")return E;const o=_.getProxy(M.MainContext.MainThreadFileSystem);let t=!1;(S.pattern.includes(O.GLOBSTAR)||S.pattern.includes(O.GLOB_SPLIT))&&(t=!0);const i=Math.random();return o.$watch(c.identifier.value,i,S.baseUri,{recursive:t,excludes:[]}),h.Disposable.from({dispose:()=>o.$unwatch(i)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class p{constructor(_,c,S){this._mainContext=_,this._logService=c,this._extHostDocumentsAndEditors=S,this._onFileSystemEvent=new w.Emitter,this._onDidRenameFile=new w.Emitter,this._onDidCreateFile=new w.Emitter,this._onDidDeleteFile=new w.Emitter,this._onWillRenameFile=new w.AsyncEmitter,this._onWillCreateFile=new w.AsyncEmitter,this._onWillDeleteFile=new w.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(_,c,S,E,o,t){return new y(this._mainContext,_,c,this._onFileSystemEvent.event,T.GlobPattern.from(S),E,o,t)}$onFileEvent(_){this._onFileSystemEvent.fire(_)}$onDidRunFileOperation(_,c){switch(_){case 2:this._onDidRenameFile.fire(Object.freeze({files:c.map(S=>({oldUri:I.URI.revive(S.source),newUri:I.URI.revive(S.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:c.map(S=>I.URI.revive(S.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:c.map(S=>I.URI.revive(S.target))}));break;default:}}getOnWillRenameFileEvent(_){return this._createWillExecuteEvent(_,this._onWillRenameFile)}getOnWillCreateFileEvent(_){return this._createWillExecuteEvent(_,this._onWillCreateFile)}getOnWillDeleteFileEvent(_){return this._createWillExecuteEvent(_,this._onWillDeleteFile)}_createWillExecuteEvent(_,c){return(S,E,o)=>{const t=function(a){S.call(E,a)};return t.extension=_,c.event(t,void 0,o)}}async $onWillRunFileOperation(_,c,S,E){switch(_){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:c.map(o=>({oldUri:I.URI.revive(o.source),newUri:I.URI.revive(o.target)}))},S,E);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:c.map(o=>I.URI.revive(o.target))},S,E);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:c.map(o=>I.URI.revive(o.target))},S,E)}}async _fireWillEvent(_,c,S,E){const o=new Set,t=[];if(await _.fireAsync(c,E,async(a,g)=>{const C=Date.now(),k=await Promise.resolve(a);k instanceof h.WorkspaceEdit&&(t.push([g.extension,k]),o.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-C>S&&this._logService.warn("SLOW file-participant",g.extension.identifier)}),E.isCancellationRequested||t.length===0)return;const i={edits:[]};for(const[,a]of t){const{edits:g}=T.WorkspaceEdit.from(a,{getTextDocumentVersion:C=>this._extHostDocumentsAndEditors.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(g)}return{edit:i,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=p}),define(Pe[230],Ae([1,0,6,2,4,8,7,32]),function(pe,e,w,O,I,M,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class y{static{this._pool=0}constructor(c,S){this.extension=c,this.provider=S,this.handle=y._pool++}}class p{constructor(c){this.session=c,this.responses=[]}}class A{static{this._nextId=0}constructor(c,S,E,o){this._documents=E,this._logService=o,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=c.getProxy(I.MainContext.MainThreadInlineChat),S.registerApiCommand(new h.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new h.ApiCommandArgument("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?M.Range.from(t.initialRange):void 0,message:t.message,autoSend:t.autoSend,position:t.position?M.Position.from(t.position):void 0}})],h.ApiCommandResult.Void))}registerProvider(c,S){const E=new y(c,S);return this._inputProvider.set(E.handle,E),this._proxy.$registerInteractiveEditorProvider(E.handle,c.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function"),(0,w.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(E.handle),this._inputProvider.delete(E.handle)})}async $prepareSession(c,S,E,o){const t=this._inputProvider.get(c);if(!t){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this._documents.getDocument(O.URI.revive(S)),a=M.Selection.to(E),g=await t.provider.prepareInteractiveEditorSession({document:i,selection:a},o);if(!g)return;if(g.wholeRange&&!g.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const C=A._nextId++;return this._inputSessions.set(C,new p(g)),{id:C,placeholder:g.placeholder,slashCommands:g.slashCommands?.map(k=>({command:k.command,detail:k.detail,refer:k.refer,executeImmediately:k.executeImmediately})),wholeRange:M.Range.from(g.wholeRange),message:g.message}}async $provideResponse(c,S,E,o){const t=this._inputProvider.get(c);if(!t)return;const i=this._inputSessions.get(S.id);if(!i)return;const a={session:i.session,prompt:E.prompt,selection:M.Selection.to(E.selection),wholeRange:M.Range.to(E.wholeRange),attempt:E.attempt,live:E.live};let g=!1;const C={report:d=>{if(!E.live)throw new Error("Progress reporting is only supported for live sessions");g||o.isCancellationRequested||!d.message&&!d.edits||this._proxy.$handleProgressChunk(E.requestId,{message:d.message,edits:d.edits?.map(M.TextEdit.from)})}},k=typeof t.provider.provideInteractiveEditorResponse2=="function"?t.provider.provideInteractiveEditorResponse2(a,C,o):t.provider.provideInteractiveEditorResponse(a,o);Promise.resolve(k).finally(()=>g=!0);const r=await k;if(r){const d=i.responses.push(r)-1,n={wholeRange:M.Range.from(r.wholeRange),placeholder:r.placeholder};if(A._isMessageResponse(r))return{...n,id:d,type:"message",message:M.MarkdownString.from(r.contents)};const{edits:s}=r;if(s instanceof T.WorkspaceEdit)return{...n,id:d,type:"bulkEdit",edits:M.WorkspaceEdit.from(s)};if(Array.isArray(s))return{...n,id:d,type:"editorEdit",edits:s.map(M.TextEdit.from)}}}$handleFeedback(c,S,E,o){const t=this._inputProvider.get(c),i=this._inputSessions.get(S),a=i?.responses[E];if(t&&a){let g;switch(o){case 1:g=T.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:g=T.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:g=T.InteractiveEditorResponseFeedbackKind.Undone;break;case 3:g=T.InteractiveEditorResponseFeedbackKind.Accepted;break}t.provider.handleInteractiveEditorResponseFeedback?.(i.session,a,g)}}$releaseSession(c,S){const E=this._inputSessions.get(S),o=this._inputProvider.get(c);E&&o&&o.provider.releaseInteractiveEditorSession?.(E.session),this._inputSessions.delete(S)}static _isMessageResponse(c){return typeof c=="object"&&typeof c.contents=="object"}}e.ExtHostInteractiveEditor=A}),define(Pe[231],Ae([1,0,2,32]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(T,h,y,p,A){this._extHostNotebooks=h,this._textDocumentsAndEditors=y,this._commands=p;const _=new O.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.ApiCommandArgument("showOptions","Show Options",c=>!0,c=>c),new O.ApiCommandArgument("resource","Interactive resource Uri",c=>!0,c=>c),new O.ApiCommandArgument("controllerId","Notebook controller Id",c=>!0,c=>c),new O.ApiCommandArgument("title","Interactive editor title",c=>!0,c=>c)],new O.ApiCommandResult("Notebook and input URI",c=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",c.notebookEditorId),c.notebookEditorId!==void 0){const S=this._extHostNotebooks.getEditorById(c.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:w.URI.revive(c.notebookUri),inputUri:w.URI.revive(c.inputUri),notebookEditor:S.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",c.notebookUri,c.inputUri),{notebookUri:w.URI.revive(c.notebookUri),inputUri:w.URI.revive(c.inputUri)}}));this._commands.registerApiCommand(_)}$willAddInteractiveDocument(T,h,y,p){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:h,lines:[""],languageId:y,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(w.URI.revive(p))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,h){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=I}),define(Pe[232],Ae([1,0,4,7]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class I{constructor(T){this._IssueUriRequestHandlers=new Map,this._proxy=T.getProxy(w.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(T,h){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const y=this._IssueUriRequestHandlers.get(T);if(!y)throw new Error("Issue request handler not found");const p=await y.handleIssueUrlRequest();if(!p)throw new Error("Issue request handler returned no result");return p}registerIssueUriRequestHandler(T,h){const y=T.identifier.value;return this._IssueUriRequestHandlers.set(y,h),this._proxy.$registerIssueUriRequestHandler(y),new O.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(y),this._IssueUriRequestHandlers.delete(y)})}}e.ExtHostIssueReporter=I}),define(Pe[233],Ae([1,0,6,4]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(T){this._handlePool=0,this._proxy=T.getProxy(O.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const h=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(h,T),(0,w.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(h)})}}e.ExtHostLabelService=I}),define(Pe[234],Ae([1,0,2,24,8,7,78,4,15,44,18,12,276,20,21,6,91,88,55,59,11,16,26,149]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t,i,a,g,C,k,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class n{constructor(R,W){this._documents=R,this._provider=W}async provideDocumentSymbols(R,W){const V=this._documents.getDocument(R),q=await this._provider.provideDocumentSymbols(V,W);if(!(0,A.isFalsyOrEmpty)(q))return q[0]instanceof M.DocumentSymbol?q.map(I.DocumentSymbol.from):n._asDocumentSymbolTree(q)}static _asDocumentSymbolTree(R){R=R.slice(0).sort((q,oe)=>{let j=q.location.range.start.compareTo(oe.location.range.start);return j===0&&(j=oe.location.range.end.compareTo(q.location.range.end)),j});const W=[],V=[];for(const q of R){const oe={name:q.name||"!!MISSING: name!!",kind:I.SymbolKind.from(q.kind),tags:q.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:I.Range.from(q.location.range),selectionRange:I.Range.from(q.location.range),children:[]};for(;;){if(V.length===0){V.push(oe),W.push(oe);break}const j=V[V.length-1];if(p.Range.containsRange(j.range,oe.range)&&!p.Range.equalsRange(j.range,oe.range)){j.children?.push(oe),V.push(oe);break}V.pop()}}return W}}class s{static{this._badCmd={command:"missing",title:"!!MISSING: command!!"}}constructor(R,W,V){this._documents=R,this._commands=W,this._provider=V,this._cache=new a.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(R,W){const V=this._documents.getDocument(R),q=await this._provider.provideCodeLenses(V,W);if(!q||W.isCancellationRequested)return;const oe=this._cache.add(q),j=new o.DisposableStore;this._disposables.set(oe,j);const ce={cacheId:oe,lenses:[]};for(let ve=0;ve<q.length;ve++)ce.lenses.push({cacheId:[oe,ve],range:I.Range.from(q[ve].range),command:this._commands.toInternal(q[ve].command,j)});return ce}async resolveCodeLens(R,W){const V=R.cacheId&&this._cache.get(...R.cacheId);if(!V)return;let q;if(typeof this._provider.resolveCodeLens!="function"||V.isResolved?q=V:q=await this._provider.resolveCodeLens(V,W),q||(q=V),W.isCancellationRequested)return;const oe=R.cacheId&&this._disposables.get(R.cacheId[0]);if(oe)return R.command=this._commands.toInternal(q.command??s._badCmd,oe),R}releaseCodeLenses(R){this._disposables.get(R)?.dispose(),this._disposables.delete(R),this._cache.delete(R)}}function v(de){return Array.isArray(de)?de.map(I.DefinitionLink.from):de?[I.DefinitionLink.from(de)]:[]}class D{constructor(R,W){this._documents=R,this._provider=W}async provideDefinition(R,W,V){const q=this._documents.getDocument(R),oe=I.Position.to(W),j=await this._provider.provideDefinition(q,oe,V);return v(j)}}class u{constructor(R,W){this._documents=R,this._provider=W}async provideDeclaration(R,W,V){const q=this._documents.getDocument(R),oe=I.Position.to(W),j=await this._provider.provideDeclaration(q,oe,V);return v(j)}}class m{constructor(R,W){this._documents=R,this._provider=W}async provideImplementation(R,W,V){const q=this._documents.getDocument(R),oe=I.Position.to(W),j=await this._provider.provideImplementation(q,oe,V);return v(j)}}class b{constructor(R,W){this._documents=R,this._provider=W}async provideTypeDefinition(R,W,V){const q=this._documents.getDocument(R),oe=I.Position.to(W),j=await this._provider.provideTypeDefinition(q,oe,V);return v(j)}}class l{constructor(R,W){this._documents=R,this._provider=W}async provideHover(R,W,V){const q=this._documents.getDocument(R),oe=I.Position.to(W),j=await this._provider.provideHover(q,oe,V);if(!(!j||(0,A.isFalsyOrEmpty)(j.contents)))return j.range||(j.range=q.getWordRangeAtPosition(oe)),j.range||(j.range=new M.Range(oe,oe)),I.Hover.from(j)}}class f{constructor(R,W){this._documents=R,this._provider=W}async provideEvaluatableExpression(R,W,V){const q=this._documents.getDocument(R),oe=I.Position.to(W),j=await this._provider.provideEvaluatableExpression(q,oe,V);if(j)return I.EvaluatableExpression.from(j)}}class P{constructor(R,W){this._documents=R,this._provider=W}async provideInlineValues(R,W,V,q){const oe=this._documents.getDocument(R),j=await this._provider.provideInlineValues(oe,I.Range.to(W),I.InlineValueContext.to(V),q);if(Array.isArray(j))return j.map(ce=>I.InlineValue.from(ce))}}class z{constructor(R,W){this._documents=R,this._provider=W}async provideDocumentHighlights(R,W,V){const q=this._documents.getDocument(R),oe=I.Position.to(W),j=await this._provider.provideDocumentHighlights(q,oe,V);if(Array.isArray(j))return j.map(I.DocumentHighlight.from)}}class ${constructor(R,W){this._documents=R,this._provider=W}async provideLinkedEditingRanges(R,W,V){const q=this._documents.getDocument(R),oe=I.Position.to(W),j=await this._provider.provideLinkedEditingRanges(q,oe,V);if(j&&Array.isArray(j.ranges))return{ranges:(0,A.coalesce)(j.ranges.map(I.Range.from)),wordPattern:j.wordPattern}}}class H{constructor(R,W){this._documents=R,this._provider=W}async provideReferences(R,W,V,q){const oe=this._documents.getDocument(R),j=I.Position.to(W),ce=await this._provider.provideReferences(oe,j,V,q);if(Array.isArray(ce))return ce.map(I.location.from)}}class x{static{this._maxCodeActionsPerFile=1e3}constructor(R,W,V,q,oe,j,ce){this._documents=R,this._commands=W,this._diagnostics=V,this._provider=q,this._logService=oe,this._extension=j,this._apiDeprecation=ce,this._cache=new a.Cache("CodeAction"),this._disposables=new Map,this.nbKind=new M.CodeActionKind("notebook")}async provideCodeActions(R,W,V,q){const oe=this._documents.getDocument(R),j=c.Selection.isISelection(W)?I.Selection.to(W):I.Range.to(W),ce=[];for(const Ye of this._diagnostics.getDiagnostics(R))if(j.intersection(Ye.range)&&ce.push(Ye)>x._maxCodeActionsPerFile)break;const ve={diagnostics:ce,only:V.only?new M.CodeActionKind(V.only):void 0,triggerKind:I.CodeActionTriggerKind.to(V.trigger)},Ue=await this._provider.provideCodeActions(oe,j,ve,q);if(!(0,A.isNonEmptyArray)(Ue)||q.isCancellationRequested)return;const $e=this._cache.add(Ue),Qe=new o.DisposableStore;this._disposables.set($e,Qe);const qe=[];for(let Ye=0;Ye<Ue.length;Ye++){const Ke=Ue[Ye];if(Ke)if(x._isCommand(Ke))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:Ke.title,command:this._commands.toInternal(Ke,Qe)});else{if(ve.triggerKind!==M.CodeActionTriggerKind.Invoke&&Ke.kind&&this.nbKind.contains(Ke.kind))continue;ve.only&&(Ke.kind?ve.only.contains(Ke.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action is of kind '${Ke.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[$e,Ye],title:Ke.title,command:Ke.command&&this._commands.toInternal(Ke.command,Qe),diagnostics:Ke.diagnostics&&Ke.diagnostics.map(I.Diagnostic.from),edit:Ke.edit&&I.WorkspaceEdit.from(Ke.edit,void 0),kind:Ke.kind&&Ke.kind.value,isPreferred:Ke.isPreferred,disabled:Ke.disabled?.reason})}}return{cacheId:$e,actions:qe}}async resolveCodeAction(R,W){const[V,q]=R,oe=this._cache.get(V,q);if(!oe||x._isCommand(oe))return{};if(!this._provider.resolveCodeAction)return{};const j=await this._provider.resolveCodeAction(oe,W)??oe;let ce;j.edit&&(ce=I.WorkspaceEdit.from(j.edit,void 0));let ve;if(j.command){const Ue=this._disposables.get(V);Ue&&(ve=this._commands.toInternal(j.command,Ue))}return{edit:ce,command:ve}}releaseCodeActions(R){this._disposables.get(R)?.dispose(),this._disposables.delete(R),this._cache.delete(R)}static _isCommand(R){return typeof R.command=="string"&&typeof R.title=="string"}}class U{constructor(R,W,V,q,oe){this._proxy=R,this._documents=W,this._provider=V,this._handle=q,this._extension=oe}async prepareDocumentPaste(R,W,V,q){if(!this._provider.prepareDocumentPaste)return;const oe=this._documents.getDocument(R),j=W.map(Ue=>I.Range.to(Ue)),ce=I.DataTransfer.toDataTransfer(V,()=>{throw new C.NotImplementedError});if(await this._provider.prepareDocumentPaste(oe,j,ce,q),q.isCancellationRequested)return;const ve=Array.from(ce).filter(([,Ue])=>!(Ue instanceof M.InternalDataTransferItem));return I.DataTransfer.from(ve)}async providePasteEdits(R,W,V,q,oe){if(!this._provider.provideDocumentPasteEdits)return;const j=this._documents.getDocument(W),ce=V.map($e=>I.Range.to($e)),ve=I.DataTransfer.toDataTransfer(q,async $e=>(await this._proxy.$resolvePasteFileData(this._handle,R,$e)).buffer),Ue=await this._provider.provideDocumentPasteEdits(j,ce,ve,oe);if(Ue)return{id:Ue.id?this._extension.identifier.value+"."+Ue.id:this._extension.identifier.value,label:Ue.label??(0,d.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,priority:Ue.priority??0,insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?I.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class N{constructor(R,W){this._documents=R,this._provider=W}async provideDocumentFormattingEdits(R,W,V){const q=this._documents.getDocument(R),oe=await this._provider.provideDocumentFormattingEdits(q,W,V);if(Array.isArray(oe))return oe.map(I.TextEdit.from)}}class ae{constructor(R,W){this._documents=R,this._provider=W}async provideDocumentRangeFormattingEdits(R,W,V,q){const oe=this._documents.getDocument(R),j=I.Range.to(W),ce=await this._provider.provideDocumentRangeFormattingEdits(oe,j,V,q);if(Array.isArray(ce))return ce.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(R,W,V,q){(0,_.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const oe=this._documents.getDocument(R),j=W.map(I.Range.to),ce=await this._provider.provideDocumentRangesFormattingEdits(oe,j,V,q);if(Array.isArray(ce))return ce.map(I.TextEdit.from)}}class Y{constructor(R,W){this._documents=R,this._provider=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(R,W,V,q,oe){const j=this._documents.getDocument(R),ce=I.Position.to(W),ve=await this._provider.provideOnTypeFormattingEdits(j,ce,V,q,oe);if(Array.isArray(ve))return ve.map(I.TextEdit.from)}}class Ee{constructor(R,W){this._provider=R,this._logService=W,this._cache=new a.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(R,W){const V=await this._provider.provideWorkspaceSymbols(R,W);if(!(0,A.isNonEmptyArray)(V))return{symbols:[]};const q=this._cache.add(V),oe={cacheId:q,symbols:[]};for(let j=0;j<V.length;j++){const ce=V[j];if(!ce||!ce.name){this._logService.warn("INVALID SymbolInformation",ce);continue}oe.symbols.push({...I.WorkspaceSymbol.from(ce),cacheId:[q,j]})}return oe}async resolveWorkspaceSymbol(R,W){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!R.cacheId)return R;const V=this._cache.get(...R.cacheId);if(V){const q=await this._provider.resolveWorkspaceSymbol(V,W);return q&&(0,O.mixin)(R,I.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(R){this._cache.delete(R)}}class ye{static supportsResolving(R){return typeof R.prepareRename=="function"}constructor(R,W,V){this._documents=R,this._provider=W,this._logService=V}async provideRenameEdits(R,W,V,q){const oe=this._documents.getDocument(R),j=I.Position.to(W);try{const ce=await this._provider.provideRenameEdits(oe,j,V,q);return ce?I.WorkspaceEdit.from(ce):void 0}catch(ce){const ve=ye._asMessage(ce);return ve?{rejectReason:ve,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(R,W,V){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const q=this._documents.getDocument(R),oe=I.Position.to(W);try{const j=await this._provider.prepareRename(q,oe,V);let ce,ve;if(M.Range.isRange(j)?(ce=j,ve=q.getText(j)):(0,_.isObject)(j)&&(ce=j.range,ve=j.placeholder),!ce||!ve)return;if(ce.start.line>oe.line||ce.end.line<oe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ce),text:ve}}catch(j){const ce=ye._asMessage(j);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(j)}}static _asMessage(R){return typeof R=="string"?R:R instanceof Error&&typeof R.message=="string"?R.message:void 0}}class Re{constructor(R,W){this.resultId=R,this.tokens=W}}class K{constructor(R,W){this._documents=R,this._provider=W,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(R,W,V){const q=this._documents.getDocument(R),oe=W!==0?this._previousResults.get(W):null;let j=typeof oe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(q,oe.resultId,V):await this._provider.provideDocumentSemanticTokens(q,V);return oe&&this._previousResults.delete(W),j?(j=K._fixProvidedSemanticTokens(j),this._send(K._convertToEdits(oe,j),j)):null}async releaseDocumentSemanticColoring(R){this._previousResults.delete(R)}static _fixProvidedSemanticTokens(R){return K._isSemanticTokens(R)?K._isCorrectSemanticTokens(R)?R:new M.SemanticTokens(new Uint32Array(R.data),R.resultId):K._isSemanticTokensEdits(R)?K._isCorrectSemanticTokensEdits(R)?R:new M.SemanticTokensEdits(R.edits.map(W=>new M.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),R.resultId):R}static _isSemanticTokens(R){return R&&!!R.data}static _isCorrectSemanticTokens(R){return R.data instanceof Uint32Array}static _isSemanticTokensEdits(R){return R&&Array.isArray(R.edits)}static _isCorrectSemanticTokensEdits(R){for(const W of R.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(R,W){if(!K._isSemanticTokens(W)||!R||!R.tokens)return W;const V=R.tokens,q=V.length,oe=W.data,j=oe.length;let ce=0;const ve=Math.min(q,j);for(;ce<ve&&V[ce]===oe[ce];)ce++;if(ce===q&&ce===j)return new M.SemanticTokensEdits([],W.resultId);let Ue=0;const $e=ve-ce;for(;Ue<$e&&V[q-Ue-1]===oe[j-Ue-1];)Ue++;return new M.SemanticTokensEdits([{start:ce,deleteCount:q-ce-Ue,data:oe.subarray(ce,j-Ue)}],W.resultId)}_send(R,W){if(K._isSemanticTokens(R)){const V=this._nextResultId++;return this._previousResults.set(V,new Re(R.resultId,R.data)),(0,t.encodeSemanticTokensDto)({id:V,type:"full",data:R.data})}if(K._isSemanticTokensEdits(R)){const V=this._nextResultId++;return K._isSemanticTokens(W)?this._previousResults.set(V,new Re(W.resultId,W.data)):this._previousResults.set(V,new Re(R.resultId)),(0,t.encodeSemanticTokensDto)({id:V,type:"delta",deltas:(R.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class Q{constructor(R,W){this._documents=R,this._provider=W}async provideDocumentRangeSemanticTokens(R,W,V){const q=this._documents.getDocument(R),oe=await this._provider.provideDocumentRangeSemanticTokens(q,I.Range.to(W),V);return oe?this._send(oe):null}_send(R){return(0,t.encodeSemanticTokensDto)({id:0,type:"full",data:R.data})}}class ue{static supportsResolving(R){return typeof R.resolveCompletionItem=="function"}constructor(R,W,V,q,oe){this._documents=R,this._commands=W,this._provider=V,this._apiDeprecation=q,this._extension=oe,this._cache=new a.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(R,W,V,q){const oe=this._documents.getDocument(R),j=I.Position.to(W),ce=oe.getWordRangeAtPosition(j)||new M.Range(j,j),ve=ce.with({end:j}),Ue=new g.StopWatch,$e=await this._provider.provideCompletionItems(oe,j,q,I.CompletionContext.to(V));if(!$e||q.isCancellationRequested)return;const Qe=Array.isArray($e)?new M.CompletionList($e):$e,qe=ue.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),Ye=new o.DisposableStore;this._disposables.set(qe,Ye);const Ke=[],ct={x:qe,b:Ke,a:{replace:I.Range.from(ce),insert:I.Range.from(ve)},c:Qe.isIncomplete||void 0,d:Ue.elapsed()};for(let Ze=0;Ze<Qe.items.length;Ze++){const tt=Qe.items[Ze],Ne=this._convertCompletionItem(tt,[qe,Ze],ve,ce);Ke.push(Ne)}return ct}async resolveCompletionItem(R,W){if(typeof this._provider.resolveCompletionItem!="function")return;const V=this._cache.get(...R);if(!V)return;const q=this._convertCompletionItem(V,R),oe=await this._provider.resolveCompletionItem(V,W);if(!oe)return;const j=this._convertCompletionItem(oe,R);return(q.h!==j.h||q.i!==j.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(q.n!==j.n||q.o!==j.o||!(0,O.equals)(q.p,j.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...q,d:j.d,c:j.c,l:j.l,h:j.h,i:j.i,n:j.n,o:j.o,p:j.p}}releaseCompletionItems(R){this._disposables.get(R)?.dispose(),this._disposables.delete(R),this._cache.delete(R)}_convertCompletionItem(R,W,V,q){const oe=this._disposables.get(W[0]);if(!oe)throw Error("DisposableStore is missing...");const j=this._commands.toInternal(R.command,oe),ce={x:W,a:R.label,b:R.kind!==void 0?I.CompletionItemKind.from(R.kind):void 0,m:R.tags&&R.tags.map(I.CompletionItemTag.from),c:R.detail,d:typeof R.documentation>"u"?void 0:I.MarkdownString.fromStrict(R.documentation),e:R.sortText!==R.label?R.sortText:void 0,f:R.filterText!==R.label?R.filterText:void 0,g:R.preselect||void 0,i:R.keepWhitespace?1:0,k:R.commitCharacters?.join(""),l:R.additionalTextEdits&&R.additionalTextEdits.map(I.TextEdit.from),n:j?.$ident,o:j?.id,p:j?.$ident?void 0:j?.arguments};R.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=R.textEdit.newText):typeof R.insertText=="string"?ce.h=R.insertText:R.insertText instanceof M.SnippetString&&(ce.h=R.insertText.value,ce.i|=4);let ve;return R.textEdit?ve=R.textEdit.range:R.range&&(ve=R.range),M.Range.isRange(ve)?ce.j=I.Range.from(ve):ve&&(!V?.isEqual(ve.inserting)||!q?.isEqual(ve.replacing))&&(ce.j={insert:I.Range.from(ve.inserting),replace:I.Range.from(ve.replacing)}),ce}}class ne{async provideInlineCompletions(R,W,V,q){}disposeCompletions(R){}handleDidShowCompletionItem(R,W,V){}handlePartialAccept(R,W,V){}}class he extends ne{constructor(R,W,V,q){super(),this._extension=R,this._documents=W,this._provider=V,this._commands=q,this._references=new le,this._isAdditionsProposedApiEnabled=(0,r.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[T.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[T.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(R,W,V,q){const oe=this._documents.getDocument(R),j=I.Position.to(W),ce=await this._provider.provideInlineCompletionItems(oe,j,{selectedCompletionInfo:V.selectedSuggestionInfo?{range:I.Range.to(V.selectedSuggestionInfo.range),text:V.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[V.triggerKind]},q);if(!ce||q.isCancellationRequested)return;const ve=Array.isArray(ce)?ce:ce.items,Ue=this._isAdditionsProposedApiEnabled?Array.isArray(ce)?[]:ce.commands||[]:[],$e=this._isAdditionsProposedApiEnabled&&!Array.isArray(ce)?ce.suppressSuggestions:void 0,Qe=this._isAdditionsProposedApiEnabled&&!Array.isArray(ce)?ce.enableForwardStability:void 0;let qe;return{pid:this._references.createReferenceId({dispose(){qe?.dispose()},items:ve}),items:ve.map((Ke,ct)=>{let Ze;Ke.command&&(qe||(qe=new o.DisposableStore),Ze=this._commands.toInternal(Ke.command,qe));const tt=Ke.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ke.filterText,range:Ke.range?I.Range.from(Ke.range):void 0,command:Ze,idx:ct,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ke.completeBracketPairs:!1}}),commands:Ue.map(Ke=>(qe||(qe=new o.DisposableStore),this._commands.toInternal(Ke,qe))),suppressSuggestions:$e,enableForwardStability:Qe}}disposeCompletions(R){this._references.disposeReferenceId(R)?.dispose()}handleDidShowCompletionItem(R,W,V){const q=this._references.get(R)?.items[W];q&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(q,V)}handlePartialAccept(R,W,V){const q=this._references.get(R)?.items[W];q&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(q,V)}}class le{constructor(){this._references=new Map,this._idPool=1}createReferenceId(R){const W=this._idPool++;return this._references.set(W,R),W}disposeReferenceId(R){const W=this._references.get(R);return this._references.delete(R),W}get(R){return this._references.get(R)}}class F{constructor(R,W){this._documents=R,this._provider=W,this._cache=new a.Cache("SignatureHelp")}async provideSignatureHelp(R,W,V,q){const oe=this._documents.getDocument(R),j=I.Position.to(W),ce=this.reviveContext(V),ve=await this._provider.provideSignatureHelp(oe,j,q,ce);if(ve){const Ue=this._cache.add([ve]);return{...I.SignatureHelp.from(ve),id:Ue}}}reviveContext(R){let W;if(R.activeSignatureHelp){const V=I.SignatureHelp.to(R.activeSignatureHelp),q=this._cache.get(R.activeSignatureHelp.id,0);q?(W=q,W.activeSignature=V.activeSignature,W.activeParameter=V.activeParameter):W=V}return{...R,activeSignatureHelp:W}}releaseSignatureHelp(R){this._cache.delete(R)}}class J{constructor(R,W,V,q,oe){this._documents=R,this._commands=W,this._provider=V,this._logService=q,this._extension=oe,this._cache=new a.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(R,W,V){const q=this._documents.getDocument(R),oe=I.Range.to(W),j=await this._provider.provideInlayHints(q,oe,V);if(!Array.isArray(j)||j.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${W}`);return}if(V.isCancellationRequested)return;const ce=this._cache.add(j);this._disposables.set(ce,new o.DisposableStore);const ve={hints:[],cacheId:ce};for(let Ue=0;Ue<j.length;Ue++)this._isValidInlayHint(j[Ue],oe)&&ve.hints.push(this._convertInlayHint(j[Ue],[ce,Ue]));return this._logService.trace(`[InlayHints] ${ve.hints.length} inlay hints from '${this._extension.identifier.value}' for ${W}`),ve}async resolveInlayHint(R,W){if(typeof this._provider.resolveInlayHint!="function")return;const V=this._cache.get(...R);if(!V)return;const q=await this._provider.resolveInlayHint(V,W);if(q&&this._isValidInlayHint(q))return this._convertInlayHint(q,R)}releaseHints(R){this._disposables.get(R)?.dispose(),this._disposables.delete(R),this._cache.delete(R)}_isValidInlayHint(R,W){return R.label.length===0||Array.isArray(R.label)&&R.label.every(V=>V.value.length===0)?(console.log("INVALID inlay hint, empty label",R),!1):!(W&&!W.contains(R.position))}_convertInlayHint(R,W){const V=this._disposables.get(W[0]);if(!V)throw Error("DisposableStore is missing...");const q={label:"",cacheId:W,tooltip:I.MarkdownString.fromStrict(R.tooltip),position:I.Position.from(R.position),textEdits:R.textEdits&&R.textEdits.map(I.TextEdit.from),kind:R.kind&&I.InlayHintKind.from(R.kind),paddingLeft:R.paddingLeft,paddingRight:R.paddingRight};return typeof R.label=="string"?q.label=R.label:q.label=R.label.map(oe=>{const j={label:oe.value};return j.tooltip=I.MarkdownString.fromStrict(oe.tooltip),M.Location.isLocation(oe.location)&&(j.location=I.location.from(oe.location)),oe.command&&(j.command=this._commands.toInternal(oe.command,V)),j}),q}}class Se{constructor(R,W){this._documents=R,this._provider=W,this._cache=new a.Cache("DocumentLink")}async provideLinks(R,W){const V=this._documents.getDocument(R),q=await this._provider.provideDocumentLinks(V,W);if(!(!Array.isArray(q)||q.length===0)&&!W.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:q.filter(Se._validateLink).map(I.DocumentLink.from)};{const oe=this._cache.add(q),j={links:[],cacheId:oe};for(let ce=0;ce<q.length;ce++){if(!Se._validateLink(q[ce]))continue;const ve=I.DocumentLink.from(q[ce]);ve.cacheId=[oe,ce],j.links.push(ve)}return j}}}static _validateLink(R){return R.target&&R.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(R,W){if(typeof this._provider.resolveDocumentLink!="function")return;const V=this._cache.get(...R);if(!V)return;const q=await this._provider.resolveDocumentLink(V,W);if(!(!q||!Se._validateLink(q)))return I.DocumentLink.from(q)}releaseLinks(R){this._cache.delete(R)}}class ke{constructor(R,W){this._documents=R,this._provider=W}async provideColors(R,W){const V=this._documents.getDocument(R),q=await this._provider.provideDocumentColors(V,W);return Array.isArray(q)?q.map(j=>({color:I.Color.from(j.color),range:I.Range.from(j.range)})):[]}async provideColorPresentations(R,W,V){const q=this._documents.getDocument(R),oe=I.Range.to(W.range),j=I.Color.to(W.color),ce=await this._provider.provideColorPresentations(j,{document:q,range:oe},V);if(Array.isArray(ce))return ce.map(I.ColorPresentation.from)}}class Ce{constructor(R,W){this._documents=R,this._provider=W}async provideFoldingRanges(R,W,V){const q=this._documents.getDocument(R),oe=await this._provider.provideFoldingRanges(q,W,V);if(Array.isArray(oe))return oe.map(I.FoldingRange.from)}}class _e{constructor(R,W,V){this._documents=R,this._provider=W,this._logService=V}async provideSelectionRanges(R,W,V){const q=this._documents.getDocument(R),oe=W.map(I.Position.to),j=await this._provider.provideSelectionRanges(q,oe,V);if(!(0,A.isNonEmptyArray)(j))return[];if(j.length!==oe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let ve=0;ve<oe.length;ve++){const Ue=[];ce.push(Ue);let $e=oe[ve],Qe=j[ve];for(;;){if(!Qe.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(I.SelectionRange.from(Qe)),!Qe.parent)break;$e=Qe.range,Qe=Qe.parent}}return ce}}class Ie{constructor(R,W){this._documents=R,this._provider=W,this._idPool=new i.IdGenerator(""),this._cache=new Map}async prepareSession(R,W,V){const q=this._documents.getDocument(R),oe=I.Position.to(W),j=await this._provider.prepareCallHierarchy(q,oe,V);if(!j)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(j)?j.map(ve=>this._cacheAndConvertItem(ce,ve)):[this._cacheAndConvertItem(ce,j)]}async provideCallsTo(R,W,V){const q=this._itemFromCache(R,W);if(!q)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyIncomingCalls(q,V);if(oe)return oe.map(j=>({from:this._cacheAndConvertItem(R,j.from),fromRanges:j.fromRanges.map(ce=>I.Range.from(ce))}))}async provideCallsFrom(R,W,V){const q=this._itemFromCache(R,W);if(!q)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyOutgoingCalls(q,V);if(oe)return oe.map(j=>({to:this._cacheAndConvertItem(R,j.to),fromRanges:j.fromRanges.map(ce=>I.Range.from(ce))}))}releaseSession(R){this._cache.delete(R)}_cacheAndConvertItem(R,W){const V=this._cache.get(R),q=I.CallHierarchyItem.from(W,R,V.size.toString(36));return V.set(q._itemId,W),q}_itemFromCache(R,W){return this._cache.get(R)?.get(W)}}class se{constructor(R,W){this._documents=R,this._provider=W,this._idPool=new i.IdGenerator(""),this._cache=new Map}async prepareSession(R,W,V){const q=this._documents.getDocument(R),oe=I.Position.to(W),j=await this._provider.prepareTypeHierarchy(q,oe,V);if(!j)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(j)?j.map(ve=>this._cacheAndConvertItem(ce,ve)):[this._cacheAndConvertItem(ce,j)]}async provideSupertypes(R,W,V){const q=this._itemFromCache(R,W);if(!q)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySupertypes(q,V);if(oe)return oe.map(j=>this._cacheAndConvertItem(R,j))}async provideSubtypes(R,W,V){const q=this._itemFromCache(R,W);if(!q)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySubtypes(q,V);if(oe)return oe.map(j=>this._cacheAndConvertItem(R,j))}releaseSession(R){this._cache.delete(R)}_cacheAndConvertItem(R,W){const V=this._cache.get(R),q=I.TypeHierarchyItem.from(W,R,V.size.toString(36));return V.set(q._itemId,W),q}_itemFromCache(R,W){return this._cache.get(R)?.get(W)}}class fe{constructor(R,W,V,q,oe){this._proxy=R,this._documents=W,this._provider=V,this._handle=q,this._extension=oe}async provideDocumentOnDropEdits(R,W,V,q,oe){const j=this._documents.getDocument(W),ce=I.Position.to(V),ve=I.DataTransfer.toDataTransfer(q,async $e=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,R,$e)).buffer),Ue=await this._provider.provideDocumentDropEdits(j,ce,ve,oe);if(Ue)return{id:Ue.id?this._extension.identifier.value+"."+Ue.id:this._extension.identifier.value,label:Ue.label??(0,d.localize)(1,null,this._extension.displayName||this._extension.name),priority:Ue.priority??0,insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?I.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class ee{constructor(R,W){this.adapter=R,this.extension=W}}class ie{static{this._handlePool=0}constructor(R,W,V,q,oe,j,ce,ve){this._uriTransformer=W,this._documents=V,this._commands=q,this._diagnostics=oe,this._logService=j,this._apiDeprecation=ce,this._extensionTelemetry=ve,this._adapter=new Map,this._proxy=R.getProxy(h.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(R,W){return I.DocumentSelector.from(R,this._uriTransformer,W)}_createDisposable(R){return new M.Disposable(()=>{this._adapter.delete(R),this._proxy.$unregister(R)})}_nextHandle(){return ie._handlePool++}async _withAdapter(R,W,V,q,oe,j=!1){const ce=this._adapter.get(R);if(!ce||!(ce.adapter instanceof W))return q;const ve=Date.now();j||this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${V.toString().replace(/[\r\n]/g,"")}'`);const Ue=V(ce.adapter,ce.extension);return Promise.resolve(Ue).catch($e=>{(0,C.isCancellationError)($e)||(this._logService.error(`[${ce.extension.identifier.value}] provider FAILED`),this._logService.error($e),this._extensionTelemetry.onExtensionError(ce.extension.identifier,$e))}).finally(()=>{j||this._logService.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-ve}ms`)}),S.CancellationToken.isCancellationToken(oe)?(0,k.raceCancellationError)(Ue,oe):Ue}_addNewAdapter(R,W){const V=this._nextHandle();return this._adapter.set(V,new ee(R,W)),V}static _extLabel(R){return R.displayName||R.name}registerDocumentSymbolProvider(R,W,V,q){const oe=this._addNewAdapter(new n(this._documents,V),R),j=q&&q.label||ie._extLabel(R);return this._proxy.$registerDocumentSymbolProvider(oe,this._transformDocumentSelector(W,R),j),this._createDisposable(oe)}$provideDocumentSymbols(R,W,V){return this._withAdapter(R,n,q=>q.provideDocumentSymbols(w.URI.revive(W),V),void 0,V)}registerCodeLensProvider(R,W,V){const q=this._nextHandle(),oe=typeof V.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(q,new ee(new s(this._documents,this._commands.converter,V),R)),this._proxy.$registerCodeLensSupport(q,this._transformDocumentSelector(W,R),oe);let j=this._createDisposable(q);if(oe!==void 0){const ce=V.onDidChangeCodeLenses(ve=>this._proxy.$emitCodeLensEvent(oe));j=M.Disposable.from(j,ce)}return j}$provideCodeLenses(R,W,V){return this._withAdapter(R,s,q=>q.provideCodeLenses(w.URI.revive(W),V),void 0,V)}$resolveCodeLens(R,W,V){return this._withAdapter(R,s,q=>q.resolveCodeLens(W,V),void 0,void 0)}$releaseCodeLenses(R,W){this._withAdapter(R,s,V=>Promise.resolve(V.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(R,W,V){const q=this._addNewAdapter(new D(this._documents,V),R);return this._proxy.$registerDefinitionSupport(q,this._transformDocumentSelector(W,R)),this._createDisposable(q)}$provideDefinition(R,W,V,q){return this._withAdapter(R,D,oe=>oe.provideDefinition(w.URI.revive(W),V,q),[],q)}registerDeclarationProvider(R,W,V){const q=this._addNewAdapter(new u(this._documents,V),R);return this._proxy.$registerDeclarationSupport(q,this._transformDocumentSelector(W,R)),this._createDisposable(q)}$provideDeclaration(R,W,V,q){return this._withAdapter(R,u,oe=>oe.provideDeclaration(w.URI.revive(W),V,q),[],q)}registerImplementationProvider(R,W,V){const q=this._addNewAdapter(new m(this._documents,V),R);return this._proxy.$registerImplementationSupport(q,this._transformDocumentSelector(W,R)),this._createDisposable(q)}$provideImplementation(R,W,V,q){return this._withAdapter(R,m,oe=>oe.provideImplementation(w.URI.revive(W),V,q),[],q)}registerTypeDefinitionProvider(R,W,V){const q=this._addNewAdapter(new b(this._documents,V),R);return this._proxy.$registerTypeDefinitionSupport(q,this._transformDocumentSelector(W,R)),this._createDisposable(q)}$provideTypeDefinition(R,W,V,q){return this._withAdapter(R,b,oe=>oe.provideTypeDefinition(w.URI.revive(W),V,q),[],q)}registerHoverProvider(R,W,V,q){const oe=this._addNewAdapter(new l(this._documents,V),R);return this._proxy.$registerHoverProvider(oe,this._transformDocumentSelector(W,R)),this._createDisposable(oe)}$provideHover(R,W,V,q){return this._withAdapter(R,l,oe=>oe.provideHover(w.URI.revive(W),V,q),void 0,q)}registerEvaluatableExpressionProvider(R,W,V,q){const oe=this._addNewAdapter(new f(this._documents,V),R);return this._proxy.$registerEvaluatableExpressionProvider(oe,this._transformDocumentSelector(W,R)),this._createDisposable(oe)}$provideEvaluatableExpression(R,W,V,q){return this._withAdapter(R,f,oe=>oe.provideEvaluatableExpression(w.URI.revive(W),V,q),void 0,q)}registerInlineValuesProvider(R,W,V,q){const oe=typeof V.onDidChangeInlineValues=="function"?this._nextHandle():void 0,j=this._addNewAdapter(new P(this._documents,V),R);this._proxy.$registerInlineValuesProvider(j,this._transformDocumentSelector(W,R),oe);let ce=this._createDisposable(j);if(oe!==void 0){const ve=V.onDidChangeInlineValues(Ue=>this._proxy.$emitInlineValuesEvent(oe));ce=M.Disposable.from(ce,ve)}return ce}$provideInlineValues(R,W,V,q,oe){return this._withAdapter(R,P,j=>j.provideInlineValues(w.URI.revive(W),V,q,oe),void 0,oe)}registerDocumentHighlightProvider(R,W,V){const q=this._addNewAdapter(new z(this._documents,V),R);return this._proxy.$registerDocumentHighlightProvider(q,this._transformDocumentSelector(W,R)),this._createDisposable(q)}$provideDocumentHighlights(R,W,V,q){return this._withAdapter(R,z,oe=>oe.provideDocumentHighlights(w.URI.revive(W),V,q),void 0,q)}registerLinkedEditingRangeProvider(R,W,V){const q=this._addNewAdapter(new $(this._documents,V),R);return this._proxy.$registerLinkedEditingRangeProvider(q,this._transformDocumentSelector(W,R)),this._createDisposable(q)}$provideLinkedEditingRanges(R,W,V,q){return this._withAdapter(R,$,async oe=>{const j=await oe.provideLinkedEditingRanges(w.URI.revive(W),V,q);if(j)return{ranges:j.ranges,wordPattern:j.wordPattern?ie._serializeRegExp(j.wordPattern):void 0}},void 0,q)}registerReferenceProvider(R,W,V){const q=this._addNewAdapter(new H(this._documents,V),R);return this._proxy.$registerReferenceSupport(q,this._transformDocumentSelector(W,R)),this._createDisposable(q)}$provideReferences(R,W,V,q,oe){return this._withAdapter(R,H,j=>j.provideReferences(w.URI.revive(W),V,q,oe),void 0,oe)}registerCodeActionProvider(R,W,V,q){const oe=new o.DisposableStore,j=this._addNewAdapter(new x(this._documents,this._commands.converter,this._diagnostics,V,this._logService,R,this._apiDeprecation),R);return this._proxy.$registerQuickFixSupport(j,this._transformDocumentSelector(W,R),{providedKinds:q?.providedCodeActionKinds?.map(ce=>ce.value),documentation:q?.documentation?.map(ce=>({kind:ce.kind.value,command:this._commands.converter.toInternal(ce.command,oe)}))},ie._extLabel(R),!!V.resolveCodeAction),oe.add(this._createDisposable(j)),oe}$provideCodeActions(R,W,V,q,oe){return this._withAdapter(R,x,j=>j.provideCodeActions(w.URI.revive(W),V,q,oe),void 0,oe)}$resolveCodeAction(R,W,V){return this._withAdapter(R,x,q=>q.resolveCodeAction(W,V),{},void 0)}$releaseCodeActions(R,W){this._withAdapter(R,x,V=>Promise.resolve(V.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(R,W,V){const q=this._addNewAdapter(new N(this._documents,V),R);return this._proxy.$registerDocumentFormattingSupport(q,this._transformDocumentSelector(W,R),R.identifier,R.displayName||R.name),this._createDisposable(q)}$provideDocumentFormattingEdits(R,W,V,q){return this._withAdapter(R,N,oe=>oe.provideDocumentFormattingEdits(w.URI.revive(W),V,q),void 0,q)}registerDocumentRangeFormattingEditProvider(R,W,V){const q=typeof V.provideDocumentRangesFormattingEdits=="function";q&&(0,r.checkProposedApiEnabled)(R,"formatMultipleRanges");const oe=this._addNewAdapter(new ae(this._documents,V),R);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(W,R),R.identifier,R.displayName||R.name,q),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(R,W,V,q,oe){return this._withAdapter(R,ae,j=>j.provideDocumentRangeFormattingEdits(w.URI.revive(W),V,q,oe),void 0,oe)}$provideDocumentRangesFormattingEdits(R,W,V,q,oe){return this._withAdapter(R,ae,j=>j.provideDocumentRangesFormattingEdits(w.URI.revive(W),V,q,oe),void 0,oe)}registerOnTypeFormattingEditProvider(R,W,V,q){const oe=this._addNewAdapter(new Y(this._documents,V),R);return this._proxy.$registerOnTypeFormattingSupport(oe,this._transformDocumentSelector(W,R),q,R.identifier),this._createDisposable(oe)}$provideOnTypeFormattingEdits(R,W,V,q,oe,j){return this._withAdapter(R,Y,ce=>ce.provideOnTypeFormattingEdits(w.URI.revive(W),V,q,oe,j),void 0,j)}registerWorkspaceSymbolProvider(R,W){const V=this._addNewAdapter(new Ee(W,this._logService),R);return this._proxy.$registerNavigateTypeSupport(V,typeof W.resolveWorkspaceSymbol=="function"),this._createDisposable(V)}$provideWorkspaceSymbols(R,W,V){return this._withAdapter(R,Ee,q=>q.provideWorkspaceSymbols(W,V),{symbols:[]},V)}$resolveWorkspaceSymbol(R,W,V){return this._withAdapter(R,Ee,q=>q.resolveWorkspaceSymbol(W,V),void 0,void 0)}$releaseWorkspaceSymbols(R,W){this._withAdapter(R,Ee,V=>V.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(R,W,V){const q=this._addNewAdapter(new ye(this._documents,V,this._logService),R);return this._proxy.$registerRenameSupport(q,this._transformDocumentSelector(W,R),ye.supportsResolving(V)),this._createDisposable(q)}$provideRenameEdits(R,W,V,q,oe){return this._withAdapter(R,ye,j=>j.provideRenameEdits(w.URI.revive(W),V,q,oe),void 0,oe)}$resolveRenameLocation(R,W,V,q){return this._withAdapter(R,ye,oe=>oe.resolveRenameLocation(w.URI.revive(W),V,q),void 0,q)}registerDocumentSemanticTokensProvider(R,W,V,q){const oe=this._addNewAdapter(new K(this._documents,V),R),j=typeof V.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(oe,this._transformDocumentSelector(W,R),q,j);let ce=this._createDisposable(oe);if(j){const ve=V.onDidChangeSemanticTokens(Ue=>this._proxy.$emitDocumentSemanticTokensEvent(j));ce=M.Disposable.from(ce,ve)}return ce}$provideDocumentSemanticTokens(R,W,V,q){return this._withAdapter(R,K,oe=>oe.provideDocumentSemanticTokens(w.URI.revive(W),V,q),null,q)}$releaseDocumentSemanticTokens(R,W){this._withAdapter(R,K,V=>V.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(R,W,V,q){const oe=this._addNewAdapter(new Q(this._documents,V),R);return this._proxy.$registerDocumentRangeSemanticTokensProvider(oe,this._transformDocumentSelector(W,R),q),this._createDisposable(oe)}$provideDocumentRangeSemanticTokens(R,W,V,q){return this._withAdapter(R,Q,oe=>oe.provideDocumentRangeSemanticTokens(w.URI.revive(W),V,q),null,q)}registerCompletionItemProvider(R,W,V,q){const oe=this._addNewAdapter(new ue(this._documents,this._commands.converter,V,this._apiDeprecation,R),R);return this._proxy.$registerCompletionsProvider(oe,this._transformDocumentSelector(W,R),q,ue.supportsResolving(V),R.identifier),this._createDisposable(oe)}$provideCompletionItems(R,W,V,q,oe){return this._withAdapter(R,ue,j=>j.provideCompletionItems(w.URI.revive(W),V,q,oe),void 0,oe)}$resolveCompletionItem(R,W,V){return this._withAdapter(R,ue,q=>q.resolveCompletionItem(W,V),void 0,V)}$releaseCompletionItems(R,W){this._withAdapter(R,ue,V=>V.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(R,W,V,q){const oe=new he(R,this._documents,V,this._commands.converter),j=this._addNewAdapter(oe,R);return this._proxy.$registerInlineCompletionsSupport(j,this._transformDocumentSelector(W,R),oe.supportsHandleEvents,E.ExtensionIdentifier.toKey(R.identifier.value),q?.yieldTo?.map(ce=>E.ExtensionIdentifier.toKey(ce))||[]),this._createDisposable(j)}$provideInlineCompletions(R,W,V,q,oe){return this._withAdapter(R,ne,j=>j.provideInlineCompletions(w.URI.revive(W),V,q,oe),void 0,oe)}$handleInlineCompletionDidShow(R,W,V,q){this._withAdapter(R,ne,async oe=>{oe.handleDidShowCompletionItem(W,V,q)},void 0,void 0)}$handleInlineCompletionPartialAccept(R,W,V,q){this._withAdapter(R,ne,async oe=>{oe.handlePartialAccept(W,V,q)},void 0,void 0)}$freeInlineCompletionsList(R,W){this._withAdapter(R,ne,async V=>{V.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(R,W,V,q){const oe=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,j=this._addNewAdapter(new F(this._documents,V),R);return this._proxy.$registerSignatureHelpProvider(j,this._transformDocumentSelector(W,R),oe),this._createDisposable(j)}$provideSignatureHelp(R,W,V,q,oe){return this._withAdapter(R,F,j=>j.provideSignatureHelp(w.URI.revive(W),V,q,oe),void 0,oe)}$releaseSignatureHelp(R,W){this._withAdapter(R,F,V=>V.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(R,W,V){const q=typeof V.onDidChangeInlayHints=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new J(this._documents,this._commands.converter,V,this._logService,R),R);this._proxy.$registerInlayHintsProvider(oe,this._transformDocumentSelector(W,R),typeof V.resolveInlayHint=="function",q,ie._extLabel(R));let j=this._createDisposable(oe);if(q!==void 0){const ce=V.onDidChangeInlayHints(ve=>this._proxy.$emitInlayHintsEvent(q));j=M.Disposable.from(j,ce)}return j}$provideInlayHints(R,W,V,q){return this._withAdapter(R,J,oe=>oe.provideInlayHints(w.URI.revive(W),V,q),void 0,q)}$resolveInlayHint(R,W,V){return this._withAdapter(R,J,q=>q.resolveInlayHint(W,V),void 0,V)}$releaseInlayHints(R,W){this._withAdapter(R,J,V=>V.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(R,W,V){const q=this._addNewAdapter(new Se(this._documents,V),R);return this._proxy.$registerDocumentLinkProvider(q,this._transformDocumentSelector(W,R),typeof V.resolveDocumentLink=="function"),this._createDisposable(q)}$provideDocumentLinks(R,W,V){return this._withAdapter(R,Se,q=>q.provideLinks(w.URI.revive(W),V),void 0,V,W.scheme==="output")}$resolveDocumentLink(R,W,V){return this._withAdapter(R,Se,q=>q.resolveLink(W,V),void 0,void 0,!0)}$releaseDocumentLinks(R,W){this._withAdapter(R,Se,V=>V.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(R,W,V){const q=this._addNewAdapter(new ke(this._documents,V),R);return this._proxy.$registerDocumentColorProvider(q,this._transformDocumentSelector(W,R)),this._createDisposable(q)}$provideDocumentColors(R,W,V){return this._withAdapter(R,ke,q=>q.provideColors(w.URI.revive(W),V),[],V)}$provideColorPresentations(R,W,V,q){return this._withAdapter(R,ke,oe=>oe.provideColorPresentations(w.URI.revive(W),V,q),void 0,q)}registerFoldingRangeProvider(R,W,V){const q=this._nextHandle(),oe=typeof V.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(q,new ee(new Ce(this._documents,V),R)),this._proxy.$registerFoldingRangeProvider(q,this._transformDocumentSelector(W,R),R.identifier,oe);let j=this._createDisposable(q);if(oe!==void 0){const ce=V.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(oe));j=M.Disposable.from(j,ce)}return j}$provideFoldingRanges(R,W,V,q){return this._withAdapter(R,Ce,oe=>oe.provideFoldingRanges(w.URI.revive(W),V,q),void 0,q)}registerSelectionRangeProvider(R,W,V){const q=this._addNewAdapter(new _e(this._documents,V,this._logService),R);return this._proxy.$registerSelectionRangeProvider(q,this._transformDocumentSelector(W,R)),this._createDisposable(q)}$provideSelectionRanges(R,W,V,q){return this._withAdapter(R,_e,oe=>oe.provideSelectionRanges(w.URI.revive(W),V,q),[],q)}registerCallHierarchyProvider(R,W,V){const q=this._addNewAdapter(new Ie(this._documents,V),R);return this._proxy.$registerCallHierarchyProvider(q,this._transformDocumentSelector(W,R)),this._createDisposable(q)}$prepareCallHierarchy(R,W,V,q){return this._withAdapter(R,Ie,oe=>Promise.resolve(oe.prepareSession(w.URI.revive(W),V,q)),void 0,q)}$provideCallHierarchyIncomingCalls(R,W,V,q){return this._withAdapter(R,Ie,oe=>oe.provideCallsTo(W,V,q),void 0,q)}$provideCallHierarchyOutgoingCalls(R,W,V,q){return this._withAdapter(R,Ie,oe=>oe.provideCallsFrom(W,V,q),void 0,q)}$releaseCallHierarchy(R,W){this._withAdapter(R,Ie,V=>Promise.resolve(V.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(R,W,V){const q=this._addNewAdapter(new se(this._documents,V),R);return this._proxy.$registerTypeHierarchyProvider(q,this._transformDocumentSelector(W,R)),this._createDisposable(q)}$prepareTypeHierarchy(R,W,V,q){return this._withAdapter(R,se,oe=>Promise.resolve(oe.prepareSession(w.URI.revive(W),V,q)),void 0,q)}$provideTypeHierarchySupertypes(R,W,V,q){return this._withAdapter(R,se,oe=>oe.provideSupertypes(W,V,q),void 0,q)}$provideTypeHierarchySubtypes(R,W,V,q){return this._withAdapter(R,se,oe=>oe.provideSubtypes(W,V,q),void 0,q)}$releaseTypeHierarchy(R,W){this._withAdapter(R,se,V=>Promise.resolve(V.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(R,W,V,q){const oe=this._nextHandle();return this._adapter.set(oe,new ee(new fe(this._proxy,this._documents,V,oe,R),R)),this._proxy.$registerDocumentOnDropEditProvider(oe,this._transformDocumentSelector(W,R),(0,r.isProposedApiEnabled)(R,"dropMetadata")?q:void 0),this._createDisposable(oe)}$provideDocumentOnDropEdits(R,W,V,q,oe,j){return this._withAdapter(R,fe,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(W,w.URI.revive(V),q,oe,j)),void 0,void 0)}registerDocumentPasteEditProvider(R,W,V,q){const oe=this._nextHandle();return this._adapter.set(oe,new ee(new U(this._proxy,this._documents,V,oe,R),R)),this._proxy.$registerPasteEditProvider(oe,this._transformDocumentSelector(W,R),{supportsCopy:!!V.prepareDocumentPaste,supportsPaste:!!V.provideDocumentPasteEdits,copyMimeTypes:q.copyMimeTypes,pasteMimeTypes:q.pasteMimeTypes}),this._createDisposable(oe)}$prepareDocumentPaste(R,W,V,q,oe){return this._withAdapter(R,U,j=>j.prepareDocumentPaste(w.URI.revive(W),V,q,oe),void 0,oe)}$providePasteEdits(R,W,V,q,oe,j){return this._withAdapter(R,U,ce=>ce.providePasteEdits(W,w.URI.revive(V),q,oe,j),void 0,j)}static _serializeRegExp(R){return{pattern:R.source,flags:(0,y.regExpFlags)(R)}}static _serializeIndentationRule(R){return{decreaseIndentPattern:ie._serializeRegExp(R.decreaseIndentPattern),increaseIndentPattern:ie._serializeRegExp(R.increaseIndentPattern),indentNextLinePattern:R.indentNextLinePattern?ie._serializeRegExp(R.indentNextLinePattern):void 0,unIndentedLinePattern:R.unIndentedLinePattern?ie._serializeRegExp(R.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(R){return{beforeText:ie._serializeRegExp(R.beforeText),afterText:R.afterText?ie._serializeRegExp(R.afterText):void 0,previousLineText:R.previousLineText?ie._serializeRegExp(R.previousLineText):void 0,action:R.action}}static _serializeOnEnterRules(R){return R.map(ie._serializeOnEnterRule)}setLanguageConfiguration(R,W,V){const{wordPattern:q}=V;if(q&&(0,y.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this._documents.setWordDefinitionFor(W,q):this._documents.setWordDefinitionFor(W,void 0),V.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",R,"Do not use."),V.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",R,"Do not use."),V.autoClosingPairs&&(0,r.checkProposedApiEnabled)(R,"languageConfigurationAutoClosingPairs");const oe=this._nextHandle(),j={comments:V.comments,brackets:V.brackets,wordPattern:V.wordPattern?ie._serializeRegExp(V.wordPattern):void 0,indentationRules:V.indentationRules?ie._serializeIndentationRule(V.indentationRules):void 0,onEnterRules:V.onEnterRules?ie._serializeOnEnterRules(V.onEnterRules):void 0,__electricCharacterSupport:V.__electricCharacterSupport,__characterPairSupport:V.__characterPairSupport,autoClosingPairs:V.autoClosingPairs};return this._proxy.$setLanguageConfiguration(oe,W,j),this._createDisposable(oe)}$setWordDefinitions(R){for(const W of R)this._documents.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.ExtHostLanguageFeatures=ie}),define(Pe[235],Ae([1,0,4,8,7,29,16,6]),function(pe,e,w,O,I,M,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(A,_,c,S){this._documents=_,this._commands=c,this._uriTransformer=S,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=A.getProxy(w.MainContext.MainThreadLanguages)}$acceptLanguageIds(A){this._languageIds=A}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(A,_){await this._proxy.$changeLanguage(A,_);const c=this._documents.getDocumentData(A);if(!c)throw new Error(`document '${A.toString()}' NOT found`);return c.document}async tokenAtPosition(A,_){const c=A.version,S=O.Position.from(_),E=await this._proxy.$tokensAtPosition(A.uri,S),o={type:I.StandardTokenType.Other,range:A.getWordRangeAtPosition(_)??new I.Range(_.line,_.character,_.line,_.character)};if(!E)return o;const t={range:O.Range.to(E.range),type:O.TokenType.to(E.type)};return!t.range.contains(_)||c!==A.version?o:t}createLanguageStatusItem(A,_,c){const S=this._handlePool++,E=this._proxy,o=this._ids,t=`${A.identifier.value}/${_}`;if(o.has(t))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);o.add(t);const i={selector:c,id:_,name:A.displayName??A.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const g=new h.DisposableStore,C=()=>{if(a?.dispose(),!o.has(t)){console.warn(`LanguageStatusItem (${_}) from ${A.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,T.disposableTimeout)(()=>{g.clear(),this._proxy.$setLanguageStatus(S,{id:t,name:i.name??A.displayName??A.name,source:A.displayName??A.name,selector:O.DocumentSelector.from(i.selector,this._uriTransformer),label:i.text,detail:i.detail??"",severity:i.severity===I.LanguageStatusSeverity.Error?M.default.Error:i.severity===I.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:i.command&&this._commands.toInternal(i.command,g),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},k={dispose(){g.dispose(),a?.dispose(),E.$removeLanguageStatus(S),o.delete(t)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,C()},get selector(){return i.selector},set selector(r){i.selector=r,C()},get text(){return i.text},set text(r){i.text=r,C()},get detail(){return i.detail},set detail(r){i.detail=r,C()},get severity(){return i.severity},set severity(r){i.severity=r,C()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,C()},get command(){return i.command},set command(r){i.command=r,C()},get busy(){return i.busy},set busy(r){i.busy=r,C()}};return C(),k}}e.ExtHostLanguages=y}),define(Pe[81],Ae([1,0,22,15,2,3,14,4,27,17]),function(pe,e,w,O,I,M,T,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let A=class{constructor(c,S,E){this.logService=E,this.bundleCache=new Map,this._proxy=S.getProxy(h.MainContext.MainThreadLocalization),this.currentLanguage=c.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===w.LANGUAGE_DEFAULT}getMessage(c,S){const{message:E,args:o,comment:t}=S;if(this.isDefaultLanguage)return(0,O.format2)(E,o??{});let i=E;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const a=this.bundleCache.get(c)?.contents[i];return a||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,O.format2)(a??E,o??{})}getBundle(c){return this.bundleCache.get(c)?.contents}getBundleUri(c){return this.bundleCache.get(c)?.uri}async initializeLocalizedMessages(c){if(this.isDefaultLanguage||!c.l10n&&!c.isBuiltin||this.bundleCache.has(c.identifier.value))return;let S;const E=await this.getBundleLocation(c);if(!E){this.logService.error(`No bundle location found for extension ${c.identifier.value}`);return}try{const o=await this._proxy.$fetchBundleContents(E),t=JSON.parse(o);S=c.isBuiltin?t.contents?.bundle:t}catch(o){this.logService.error(`Failed to load translations for ${c.identifier.value} from ${E}: ${o.message}`);return}S&&this.bundleCache.set(c.identifier.value,{contents:S,uri:E})}async getBundleLocation(c){if(c.isBuiltin){const S=await this._proxy.$fetchBuiltInBundleUri(c.identifier.value,this.currentLanguage);return I.URI.revive(S)}return c.l10n?I.URI.joinPath(c.extensionLocation,c.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=A,e.ExtHostLocalizationService=A=We([He(0,y.IExtHostInitDataService),He(1,p.IExtHostRpcService),He(2,T.ILogService)],A),e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(Pe[236],Ae([1,0,14,4,27,17,2,70]),function(pe,e,w,O,I,M,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends w.AbstractLoggerService{constructor(_,c){super(c.logLevel,c.logsLocation,c.loggers.map(S=>(0,h.revive)(S))),this._proxy=_.getProxy(O.MainContext.MainThreadLogger)}$setLogLevel(_,c){c?this.setLogLevel(T.URI.revive(c),_):this.setLogLevel(_)}setVisibility(_,c){super.setVisibility(_,c),this._proxy.$setVisibility(_,c)}doCreateLogger(_,c,S){return new p(this._proxy,_,c,S)}};e.ExtHostLoggerService=y,e.ExtHostLoggerService=y=We([He(0,M.IExtHostRpcService),He(1,I.IExtHostInitDataService)],y);class p extends w.AbstractMessageLogger{constructor(_,c,S,E){super(E?.logLevel==="always"),this.proxy=_,this.file=c,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(S),this.proxy.$createLogger(c,E).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(_,c){const S=[[_,c]];this.isLoggerCreated?this.doLog(S):this.buffer.push(...S)}doLog(_){this.proxy.$log(this.file,_)}flush(){this.proxy.$flush(this.file)}}}),define(Pe[82],Ae([1,0,4,3,6,17,25]),function(pe,e,w,O,I,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,O.createDecorator)("IExtHostManagedSockets");let h=class{constructor(_){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=_.getProxy(w.MainContext.MainThreadManagedSockets)}setFactory(_,c){for(const S of this._managedRemoteSockets.values())S.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new y(_,c),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(_){if(!this._factory||this._factory.socketFactoryId!==_)throw new Error(`No socket factory with id ${_}`);const c=++this._remoteSocketIdCounter,S=await this._factory.makeConnection(),E=new I.DisposableStore;return this._managedRemoteSockets.set(c,new p(c,S,E)),E.add((0,I.toDisposable)(()=>this._managedRemoteSockets.delete(c))),E.add(S.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(c),E.dispose()})),E.add(S.onDidClose(o=>{this._proxy.$onDidManagedSocketClose(c,o?.stack??o?.message),E.dispose()})),E.add(S.onDidReceiveMessage(o=>this._proxy.$onDidManagedSocketHaveData(c,T.VSBuffer.wrap(o)))),c}$remoteSocketWrite(_,c){this._managedRemoteSockets.get(_)?.actual.send(c.buffer)}$remoteSocketEnd(_){const c=this._managedRemoteSockets.get(_);c&&(c.actual.end(),c.dispose())}async $remoteSocketDrain(_){await this._managedRemoteSockets.get(_)?.actual.drain?.()}};e.ExtHostManagedSockets=h,e.ExtHostManagedSockets=h=We([He(0,M.IExtHostRpcService)],h);class y{constructor(_,c){this.socketFactoryId=_,this.makeConnection=c}}class p extends I.Disposable{constructor(_,c,S){super(),this.socketId=_,this.actual=c,this._register(S)}}}),define(Pe[237],Ae([1,0,4,14,26]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(h){return h&&h.title}let T=class{constructor(y,p){this._logService=p,this._proxy=y.getProxy(w.MainContext.MainThreadMessageService)}showMessage(y,p,A,_,c){const S={source:{identifier:y.identifier,label:y.displayName||y.name}};let E;typeof _=="string"||M(_)?E=[_,...c]:(S.modal=_?.modal,S.useCustom=_?.useCustom,S.detail=_?.detail,E=c),S.useCustom&&(0,I.checkProposedApiEnabled)(y,"resolvers");const o=[];for(let t=0;t<E.length;t++){const i=E[t];if(typeof i=="string")o.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:a,isCloseAffordance:g}=i;o.push({title:a,isCloseAffordance:!!g,handle:t})}else this._logService.warn("Invalid message item:",i)}return this._proxy.$showMessage(p,A,S,o).then(t=>{if(typeof t=="number")return E[t]})}};e.ExtHostMessageService=T,e.ExtHostMessageService=T=We([He(1,O.ILogService)],T)}),define(Pe[238],Ae([1,0,151,25,5,6,28,15,12,2,38,55,4,32,8,7,46,205,103,11,24,13]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t,i,a,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class r{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(n=>n.apiEditor)}constructor(n,s,v,D,u){this._textDocumentsAndEditors=v,this._textDocuments=D,this._extHostFileSystem=u,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new I.Emitter({onListenerError:g.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter({onListenerError:g.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter({onListenerError:g.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter({onListenerError:g.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new _.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=n.getProxy(c.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=n.getProxy(c.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=n.getProxy(c.MainContext.MainThreadNotebookEditors),this._commandsConverter=s.converter,s.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===13){const b=m.notebookEditor?.notebookUri,l=m.cell.handle,P=this._documents.get(b)?.getCell(l);if(P)return P.apiCell}if(m&&m.$mid===14){const b=m.uri,l=this._documents.get(b);if(l)return l.apiNotebook}return m}}),r._registerApiCommands(s)}getEditorById(n){const s=this._editors.get(n);if(!s)throw new Error(`unknown text editor: ${n}. known editors: ${[...this._editors.keys()]} `);return s}getIdByEditor(n){for(const[s,v]of this._editors)if(v.apiEditor===n)return s}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(n,s){const v=this._documents.get(n);if(!v&&!s)throw new Error(`NO notebook document for '${n}'`);return v}static _convertNotebookRegistrationData(n,s){if(!s)return;const v=s.filenamePattern.map(D=>E.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(s.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:n.identifier,providerDisplayName:n.displayName||n.name,displayName:s.displayName,filenamePattern:v,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(n,s,v){const D=r._notebookStatusBarItemProviderHandlePool++,u=typeof v.onDidChangeCellStatusBarItems=="function"?r._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(D,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(D,u,s);let m;return u!==void 0&&(m=v.onDidChangeCellStatusBarItems(b=>this._notebookProxy.$emitCellStatusBarEvent(u))),new o.Disposable(()=>{this._notebookStatusBarItemProviders.delete(D),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(D,u),m?.dispose()})}async createNotebookDocument(n){const s=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:n.viewType,content:n.content&&E.NotebookData.from(n.content)});return p.URI.revive(s)}async openNotebookDocument(n){const s=this._documents.get(n);if(s)return s.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenNotebook(n),D=this._documents.get(p.URI.revive(v));return(0,y.assertIsDefined)(D?.apiNotebook)}async showNotebookDocument(n,s){p.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let v;typeof s=="object"?v={position:E.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(E.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:v={preserveFocus:!1};const D=await this._notebookEditorsProxy.$tryShowNotebookDocument(n.uri,n.notebookType,v),u=D&&this._editors.get(D)?.apiEditor;if(u)return u;throw D?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(n,s,v,D){const u=this._notebookStatusBarItemProviders.get(n),m=p.URI.revive(s),b=this._documents.get(m);if(!b||!u)return;const l=b.getCellFromIndex(v);if(!l)return;const f=await u.provideCellStatusBarItems(l.apiCell,D);if(!f)return;const P=new M.DisposableStore,z=this._statusBarCache.add([P]),H=(Array.isArray(f)?f:[f]).map(x=>E.NotebookStatusBarItem.from(x,this._commandsConverter,P));return{cacheId:z,items:H}}$releaseNotebookCellStatusBarItems(n){this._statusBarCache.delete(n)}registerNotebookSerializer(n,s,v,D,u){if((0,h.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");const m=this._handlePool++;return this._notebookSerializer.set(m,{viewType:s,serializer:v,options:D}),this._notebookProxy.$registerNotebookSerializer(m,{id:n.identifier,location:n.extensionLocation},s,E.NotebookDocumentContentOptions.from(D),r._convertNotebookRegistrationData(n,u)),(0,M.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(m)})}async $dataToNotebook(n,s,v){const D=this._notebookSerializer.get(n);if(!D)throw new Error("NO serializer found");const u=await D.serializer.deserializeNotebook(s.buffer,v);return new t.SerializableObjectWithBuffers(E.NotebookData.from(u))}async $notebookToData(n,s,v){const D=this._notebookSerializer.get(n);if(!D)throw new Error("NO serializer found");const u=await D.serializer.serializeNotebook(E.NotebookData.to(s.value),v);return O.VSBuffer.wrap(u)}async $saveNotebook(n,s,v,D,u){const m=p.URI.revive(s),b=this._notebookSerializer.get(n);if(!b)throw new Error("NO serializer found");const l=this._documents.get(m);if(!l)throw new Error("Document NOT found");if(l.versionId!==v)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(m.scheme))throw new A.FileOperationError((0,w.localize)(0,null,this._resourceForError(m)),6);await this._validateWriteFile(m,D);const f={metadata:(0,C.filter)(l.apiNotebook.metadata,x=>!(b.options?.transientDocumentMetadata??{})[x]),cells:[]};for(const x of l.apiNotebook.getCells()){const U=new o.NotebookCellData(x.kind,x.document.getText(),x.document.languageId,x.mime,b.options?.transientOutputs?[]:[...x.outputs],x.metadata,x.executionSummary);U.metadata=(0,C.filter)(x.metadata,N=>!(b.options?.transientCellMetadata??{})[N]),f.cells.push(U)}const P=await b.serializer.serializeNotebook(f,u);await this._extHostFileSystem.value.writeFile(m,P);const z=this._extHostFileSystem.getFileSystemProviderExtUri(m.scheme),$=await this._extHostFileSystem.value.stat(m);return{name:z.basename(m),isFile:($.type&A.FileType.File)!==0,isDirectory:($.type&A.FileType.Directory)!==0,isSymbolicLink:($.type&A.FileType.SymbolicLink)!==0,mtime:$.mtime,ctime:$.ctime,size:$.size,readonly:!!(($.permissions??0)&A.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(m.scheme),locked:!!(($.permissions??0)&A.FilePermission.Locked),etag:A.etag({mtime:$.mtime,size:$.size}),children:void 0}}async _validateWriteFile(n,s){const v=await this._extHostFileSystem.value.stat(n);if(typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==A.ETAG_DISABLED&&typeof v.mtime=="number"&&typeof v.size=="number"&&s.mtime<v.mtime&&s.etag!==A.etag({mtime:s.mtime,size:v.size}))throw new A.FileOperationError((0,w.localize)(1,null),3,s)}_resourceForError(n){return n.scheme===k.Schemas.file?n.fsPath:n.toString()}_createExtHostEditor(n,s,v){if(this._editors.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const D=new a.ExtHostNotebookEditor(s,this._notebookEditorsProxy,n,v.visibleRanges.map(E.NotebookRange.to),v.selections.map(E.NotebookRange.to),typeof v.viewColumn=="number"?E.ViewColumn.to(v.viewColumn):void 0);this._editors.set(s,D)}$acceptDocumentAndEditorsDelta(n){if(n.value.removedDocuments)for(const v of n.value.removedDocuments){const D=p.URI.revive(v),u=this._documents.get(D);u&&(u.dispose(),this._documents.delete(D),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:u.apiNotebook.getCells().map(m=>m.document.uri)}),this._onDidCloseNotebookDocument.fire(u.apiNotebook));for(const m of this._editors.values())m.notebookData.uri.toString()===D.toString()&&this._editors.delete(m.id)}if(n.value.addedDocuments){const v=[];for(const D of n.value.addedDocuments){const u=p.URI.revive(D.uri);if(this._documents.has(u))throw new Error(`adding EXISTING notebook ${u} `);const m=new i.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,u,D);v.push(...D.cells.map(b=>i.ExtHostCell.asModelAddData(m.apiNotebook,b))),this._documents.get(u)?.dispose(),this._documents.set(u,m),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this._onDidOpenNotebookDocument.fire(m.apiNotebook)}}if(n.value.addedEditors)for(const v of n.value.addedEditors){if(this._editors.has(v.id))return;const D=p.URI.revive(v.documentUri),u=this._documents.get(D);u&&this._createExtHostEditor(u,v.id,v)}const s=[];if(n.value.removedEditors)for(const v of n.value.removedEditors){const D=this._editors.get(v);D&&(this._editors.delete(v),this._activeNotebookEditor?.id===D.id&&(this._activeNotebookEditor=void 0),s.push(D))}if(n.value.visibleEditors){this._visibleNotebookEditors=n.value.visibleEditors.map(D=>this._editors.get(D)).filter(D=>!!D);const v=new Set;this._visibleNotebookEditors.forEach(D=>v.add(D.id));for(const D of this._editors.values()){const u=v.has(D.id);D._acceptVisibility(u)}this._visibleNotebookEditors=[...this._editors.values()].map(D=>D).filter(D=>D.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}n.value.newActiveEditor===null?this._activeNotebookEditor=void 0:n.value.newActiveEditor&&(this._editors.get(n.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${n.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(n.value.newActiveEditor)),n.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(n){const s=S.ApiCommandArgument.String.with("notebookType","A notebook type"),v=new S.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[s,new S.ApiCommandArgument("data","Bytes to convert to data",u=>u instanceof Uint8Array,u=>O.VSBuffer.wrap(u))],new S.ApiCommandResult("Notebook Data",u=>E.NotebookData.to(u.value))),D=new S.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[s,new S.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",u=>!0,u=>new t.SerializableObjectWithBuffers(E.NotebookData.from(u)))],new S.ApiCommandResult("Bytes",u=>u.buffer));n.registerApiCommand(v),n.registerApiCommand(D)}}e.ExtHostNotebookController=r}),define(Pe[239],Ae([1,0,18,16,20,5,6,28,2,21,14,55,4,32,8,7,77,198,26,46]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t,i,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let C=class{constructor(u,m,b,l,f){this._initData=m,this._extHostNotebook=b,this._commands=l,this._logService=f,this._activeExecutions=new h.ResourceMap,this._activeNotebookExecutions=new h.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new _.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=u.getProxy(c.MainContext.MainThreadNotebookKernels);const P=new S.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new S.ApiCommandArgument("options","Select kernel options",z=>!0,z=>{if(z&&"notebookEditor"in z&&"id"in z){const $=this._extHostNotebook.getIdByEditor(z.notebookEditor);return{id:z.id,extension:z.extension,notebookEditorId:$}}else if(z&&"notebookEditor"in z){const $=this._extHostNotebook.getIdByEditor(z.notebookEditor);if($===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${z.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:$}}return z})],S.ApiCommandResult.Void);this._commands.registerApiCommand(P)}createNotebookController(u,m,b,l,f,P){for(const ne of this._kernelData.values())if(ne.controller.id===m&&p.ExtensionIdentifier.equals(u.identifier,ne.extensionId))throw new Error(`notebook controller with id '${m}' ALREADY exist`);const z=this._handlePool++,$=this;this._logService.trace(`NotebookController[${z}], CREATED by ${u.identifier.value}, ${m}`);const H=()=>console.warn(`NO execute handler from notebook controller '${Y.id}' of extension: '${u.identifier}'`);let x=!1;const U=new T.DisposableStore,N=new M.Emitter,ae=new M.Emitter,Y={id:v(u.identifier,m),notebookType:b,extensionId:u.identifier,extensionLocation:u.extensionLocation,label:l||u.identifier.value,preloads:P?P.map(E.NotebookRendererScript.from):[]};let Ee=f??H,ye;this._proxy.$addKernel(z,Y).catch(ne=>{console.log(ne),x=!0});let Re=0;const K=()=>{if(x)return;const ne=++Re;Promise.resolve().then(()=>{ne===Re&&this._proxy.$updateKernel(z,Y)})},Q=new h.ResourceMap,ue={get id(){return m},get notebookType(){return Y.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return Y.label},set label(ne){Y.label=ne??u.displayName??u.name,K()},get detail(){return Y.detail??""},set detail(ne){Y.detail=ne,K()},get description(){return Y.description??""},set description(ne){Y.description=ne,K()},get supportedLanguages(){return Y.supportedLanguages},set supportedLanguages(ne){Y.supportedLanguages=ne,K()},get supportsExecutionOrder(){return Y.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){Y.supportsExecutionOrder=ne,K()},get rendererScripts(){return Y.preloads?Y.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return Ee},set executeHandler(ne){Ee=ne??H},get interruptHandler(){return ye},set interruptHandler(ne){ye=ne,Y.supportsInterrupt=!!ne,K()},createNotebookCellExecution(ne){if(x)throw new Error("notebook controller is DISPOSED");if(!Q.has(ne.notebook.uri))throw $._logService.trace(`NotebookController[${z}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(he=>he.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return $._createNotebookCellExecution(ne,v(u.identifier,this.id))},createNotebookExecution(ne){if((0,a.checkProposedApiEnabled)(u,"notebookExecution"),x)throw new Error("notebook controller is DISPOSED");if(!Q.has(ne.uri))throw $._logService.trace(`NotebookController[${z}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(he=>he.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return $._createNotebookExecution(ne,v(u.identifier,this.id))},dispose:()=>{x||(this._logService.trace(`NotebookController[${z}], DISPOSED`),x=!0,this._kernelData.delete(z),U.dispose(),N.dispose(),ae.dispose(),this._proxy.$removeKernel(z))},updateNotebookAffinity(ne,he){he===o.NotebookControllerAffinity2.Hidden&&(0,a.checkProposedApiEnabled)(u,"notebookControllerAffinityHidden"),$._proxy.$updateNotebookPriority(z,ne.uri,he)},onDidReceiveMessage:ae.event,postMessage(ne,he){return(0,a.checkProposedApiEnabled)(u,"notebookMessaging"),$._proxy.$postMessage(z,he&&$._extHostNotebook.getIdByEditor(he),ne)},asWebviewUri(ne){return(0,a.checkProposedApiEnabled)(u,"notebookMessaging"),(0,t.asWebviewUri)(ne,$._initData.remote)}};return this._kernelData.set(z,{extensionId:u.identifier,controller:ue,onDidReceiveMessage:ae,onDidChangeSelection:N,associatedNotebooks:Q}),ue}getIdByController(u){for(const[m,b]of this._kernelData)if(b.controller===u)return v(b.extensionId,u.id);return null}createNotebookControllerDetectionTask(u,m){const b=this._kernelDetectionTaskHandlePool++,l=this;this._logService.trace(`NotebookControllerDetectionTask[${b}], CREATED by ${u.identifier.value}`),this._proxy.$addKernelDetectionTask(b,m);const f={dispose:()=>{this._kernelDetectionTask.delete(b),l._proxy.$removeKernelDetectionTask(b)}};return this._kernelDetectionTask.set(b,f),f}registerKernelSourceActionProvider(u,m,b){const l=this._kernelSourceActionProviderHandlePool++,f=typeof b.onDidChangeNotebookKernelSourceActions=="function"?l:void 0,P=this;this._kernelSourceActionProviders.set(l,b),this._logService.trace(`NotebookKernelSourceActionProvider[${l}], CREATED by ${u.identifier.value}`),this._proxy.$addKernelSourceActionProvider(l,l,m);let z;return f!==void 0&&(z=b.onDidChangeNotebookKernelSourceActions($=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this._kernelSourceActionProviders.delete(l),P._proxy.$removeKernelSourceActionProvider(l,l),z?.dispose()}}}async $provideKernelSourceActions(u,m){const b=this._kernelSourceActionProviders.get(u);if(b){const l=new T.DisposableStore;return this._kernelSourceActionProviderCache.add([l]),(await b.provideNotebookKernelSourceActions(m)??[]).map(P=>E.NotebookKernelSourceAction.from(P,this._commands.converter,l))}return[]}$acceptNotebookAssociation(u,m,b){const l=this._kernelData.get(u);if(l){const f=this._extHostNotebook.getNotebookDocument(y.URI.revive(m));b?l.associatedNotebooks.set(f.uri,!0):l.associatedNotebooks.delete(f.uri),this._logService.trace(`NotebookController[${u}] ASSOCIATE notebook`,f.uri.toString(),b),l.onDidChangeSelection.fire({selected:b,notebook:f.apiNotebook})}}async $executeCells(u,m,b){const l=this._kernelData.get(u);if(!l)return;const f=this._extHostNotebook.getNotebookDocument(y.URI.revive(m)),P=[];for(const z of b){const $=f.getCell(z);$&&P.push($.apiCell)}try{this._logService.trace(`NotebookController[${u}] EXECUTE cells`,f.uri.toString(),P.length),await l.controller.executeHandler.call(l.controller,P,f.apiNotebook,l.controller)}catch(z){this._logService.error(`NotebookController[${u}] execute cells FAILED`,z),console.error(z)}}async $cancelCells(u,m,b){const l=this._kernelData.get(u);if(!l)return;const f=this._extHostNotebook.getNotebookDocument(y.URI.revive(m));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,f.apiNotebook);else for(const P of b){const z=f.getCell(P);z&&this._activeExecutions.get(z.uri)?.cancel()}if(l.controller.interruptHandler){const P=this._activeNotebookExecutions.get(f.uri);b.length&&Array.isArray(P)&&P.length&&P.forEach(z=>z.dispose())}}$acceptKernelMessageFromRenderer(u,m,b){const l=this._kernelData.get(u);if(!l)return;const f=this._extHostNotebook.getEditorById(m);l.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:b}))}$cellExecutionChanged(u,m,b){const f=this._extHostNotebook.getNotebookDocument(y.URI.revive(u)).getCell(m);if(f){const P=b?E.NotebookCellExecutionState.to(b):o.NotebookCellExecutionState.Idle;P!==void 0&&this._onDidChangeCellExecutionState.fire({cell:f.apiCell,state:P})}}_createNotebookCellExecution(u,m){if(u.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this._extHostNotebook.getNotebookDocument(u.notebook.uri).getCellFromApiCell(u);if(!l)throw new Error("invalid cell");if(this._activeExecutions.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const f=new r(m,l,this._proxy);this._activeExecutions.set(l.uri,f);const P=f.onDidChangeState(()=>{f.state===k.Resolved&&(f.dispose(),P.dispose(),this._activeExecutions.delete(l.uri))});return f.asApiObject()}_createNotebookExecution(u,m){const b=this._extHostNotebook.getNotebookDocument(u.uri),l=u.getCells().find(z=>{const $=b.getCellFromApiCell(z);return $&&this._activeExecutions.has($.uri)});if(l)throw new Error(`duplicate cell execution for ${l.document.uri}`);if(this._activeNotebookExecutions.has(b.uri))throw new Error(`duplicate notebook execution for ${b.uri}`);const f=new n(m,b,this._proxy),P=f.onDidChangeState(()=>{f.state===d.Resolved&&(f.dispose(),P.dispose(),this._activeNotebookExecutions.delete(b.uri))});return this._activeNotebookExecutions.set(b.uri,[f,P]),f.asApiObject()}};e.ExtHostNotebookKernels=C,e.ExtHostNotebookKernels=C=We([He(4,A.ILogService)],C);var k;(function(D){D[D.Init=0]="Init",D[D.Started=1]="Started",D[D.Resolved=2]="Resolved"})(k||(k={}));class r extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(u,m,b){super(),this._cell=m,this._proxy=b,this._handle=r.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=k.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new s(10,l=>this.update(l)),this._executionOrder=m.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,u,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(u){await this._collector.addItem(u)}async update(u){const m=Array.isArray(u)?u:[u];return this._proxy.$updateExecution(this._handle,new g.SerializableObjectWithBuffers(m))}verifyStateForOutput(){if(this._state===k.Init)throw new Error("Must call start before modifying cell output");if(this._state===k.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(u){let m=this._cell;if(u&&(m=this._cell.notebook.getCellFromApiCell(u)),!m)throw new Error("INVALID cell");return m.handle}validateAndConvertOutputs(u){return u.map(m=>{const b=o.NotebookCellOutput.ensureUniqueMimeTypes(m.items,!0);return b===m.items?E.NotebookCellOutput.from(m):E.NotebookCellOutput.from({items:b,id:m.id,metadata:m.metadata})})}async updateOutputs(u,m,b){const l=this.cellIndexToHandle(m),f=this.validateAndConvertOutputs((0,w.asArray)(u));return this.updateSoon({editType:i.CellExecutionUpdateType.Output,cellHandle:l,append:b,outputs:f})}async updateOutputItems(u,m,b){return u=o.NotebookCellOutput.ensureUniqueMimeTypes((0,w.asArray)(u),!0),this.updateSoon({editType:i.CellExecutionUpdateType.OutputItems,items:u.map(E.NotebookCellOutputItem.from),outputId:m.id,append:b})}asApiObject(){const u=this;return Object.freeze({get token(){return u._tokenSource.token},get cell(){return u._cell.apiCell},get executionOrder(){return u._executionOrder},set executionOrder(b){u._executionOrder=b,u.update([{editType:i.CellExecutionUpdateType.ExecutionState,executionOrder:u._executionOrder}])},start(b){if(u._state===k.Resolved||u._state===k.Started)throw new Error("Cannot call start again");u._state=k.Started,u._onDidChangeState.fire(),u.update({editType:i.CellExecutionUpdateType.ExecutionState,runStartTime:b})},end(b,l){if(u._state===k.Resolved)throw new Error("Cannot call resolve twice");u._state=k.Resolved,u._onDidChangeState.fire(),u._collector.flush(),u._proxy.$completeExecution(u._handle,new g.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:b}))},clearOutput(b){return u.verifyStateForOutput(),u.updateOutputs([],b,!1)},appendOutput(b,l){return u.verifyStateForOutput(),u.updateOutputs(b,l,!0)},replaceOutput(b,l){return u.verifyStateForOutput(),u.updateOutputs(b,l,!1)},appendOutputItems(b,l){return u.verifyStateForOutput(),u.updateOutputItems(b,l,!0)},replaceOutputItems(b,l){return u.verifyStateForOutput(),u.updateOutputItems(b,l,!1)}})}}var d;(function(D){D[D.Init=0]="Init",D[D.Started=1]="Started",D[D.Resolved=2]="Resolved"})(d||(d={}));class n extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(u,m,b){super(),this._notebook=m,this._proxy=b,this._handle=n.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,u,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===d.Resolved||this._state===d.Started)throw new Error("Cannot call start again");this._state=d.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===d.Resolved)throw new Error("Cannot call resolve twice");this._state=d.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class s{constructor(u,m){this.delay=u,this.callback=m,this.batch=[],this.startedTimer=Date.now()}addItem(u){return this.batch.push(u),this.currentDeferred||(this.currentDeferred=new O.DeferredPromise,this.startedTimer=Date.now(),(0,O.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const u=this.currentDeferred;this.currentDeferred=void 0;const m=this.batch;return this.batch=[],this.callback(m).finally(()=>u.complete())}}function v(D,u){return`${D.value}/${u}`}e.createKernelId=v}),define(Pe[240],Ae([1,0,5,4,103]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(h,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=h.getProxy(O.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(h,y,p){const A=this._extHostNotebook.getEditorById(h);this._rendererMessageEmitters.get(y)?.fire({editor:A.apiEditor,message:p})}createRendererMessaging(h,y){if(!h.contributes?.notebookRenderer?.some(A=>A.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(A,_,c)=>this.getOrCreateEmitterFor(y).event(A,_,c),postMessage:(A,_)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(A)&&([A,_]=[_,A]);const c=_&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(_);return this.proxy.$postMessage(c?.id,y,A)}}}getOrCreateEmitterFor(h){let y=this._rendererMessageEmitters.get(h);return y||(y=new w.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this._rendererMessageEmitters.delete(h)}}),this._rendererMessageEmitters.set(h,y),y)}}e.ExtHostNotebookRenderers=M}),define(Pe[241],Ae([1,0,6,12,2,26,4]),function(pe,e,w,O,I,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class h{constructor(p){this.handlers=new Map,this.proxy=p.getProxy(T.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(p,A,_){if((0,M.checkProposedApiEnabled)(p,"profileContentHandlers"),this.handlers.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.handlers.set(A,_),this.proxy.$registerProfileContentHandler(A,_.name,_.description,p.identifier.value),(0,w.toDisposable)(()=>{this.handlers.delete(A),this.proxy.$unregisterProfileContentHandler(A)})}async $saveProfile(p,A,_,c){const S=this.handlers.get(p);if(!S)throw new Error(`Unknown handler with id: ${p}`);return S.saveProfile(A,_,c)}async $readProfile(p,A,_){const c=this.handlers.get(p);if(!c)throw new Error(`Unknown handler with id: ${p}`);return c.readProfile((0,O.isString)(A)?A:I.URI.revive(A),_)}}e.ExtHostProfileContentHandlers=h}),define(Pe[242],Ae([1,0,2,4,16,8]),function(pe,e,w,O,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class T{static{this.handlePool=0}constructor(y,p){this.uriTransformer=p,this.providers=new Map,this.proxy=y.getProxy(O.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,p,A){const _=w.URI.revive(p),c=this.providers.get(y);return c?(0,I.asPromise)(()=>c.provideOriginalResource(_,A)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(y,p,A,_){const c=T.handlePool++;return this.providers.set(c,p),this.proxy.$registerQuickDiffProvider(c,M.DocumentSelector.from(y,this.uriTransformer),A,_),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(c),this.providers.delete(c)}}}}e.ExtHostQuickDiff=T}),define(Pe[243],Ae([1,0,20,5,6,4,2,7,11,18,29,40,26,8]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(o,t,i){const a=o.getProxy(M.MainContext.MainThreadQuickOpen);class g{constructor(u,m){this._sessions=new Map,this._instances=0,this._workspace=u,this._commands=m}showQuickPick(u,m,b,l=w.CancellationToken.None){this._onDidSelectItem=void 0;const f=Promise.resolve(m),P=++this._instances,z=a.$show(P,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},l),$={},H=z.then(()=>$);return Promise.race([H,f]).then(x=>{if(x===$)return;const U=(0,c.isProposedApiEnabled)(u,"quickPickItemTooltip");return f.then(N=>{const ae=[];for(let Y=0;Y<N.length;Y++){const Ee=N[Y];if(typeof Ee=="string")ae.push({label:Ee,handle:Y});else if(Ee.kind===h.QuickPickItemKind.Separator)ae.push({type:"separator",label:Ee.label});else{Ee.tooltip&&!U&&console.warn(`Extension '${u.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${u.identifier.value}`);const ye=Ee.iconPath?n(Ee.iconPath):void 0;ae.push({label:Ee.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:Ee.description,detail:Ee.detail,picked:Ee.picked,alwaysShow:Ee.alwaysShow,tooltip:U?S.MarkdownString.fromStrict(Ee.tooltip):void 0,handle:Y})}}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=Y=>{b.onDidSelectItem(N[Y])}),a.$setItems(P,ae),z.then(Y=>{if(typeof Y=="number")return N[Y];if(Array.isArray(Y))return Y.map(Ee=>N[Ee])})})}).then(void 0,x=>{if(!(0,y.isCancellationError)(x))return a.$setError(P,x),Promise.reject(x)})}$onItemSelected(u){this._onDidSelectItem?.(u)}showInput(u,m=w.CancellationToken.None){return this._validateInput=u?.validateInput,a.$input(u,typeof this._validateInput=="function",m).then(void 0,b=>{if(!(0,y.isCancellationError)(b))return Promise.reject(b)})}async $validateInput(u){if(!this._validateInput)return;const m=await this._validateInput(u);if(!m||typeof m=="string")return m;let b;switch(m.severity){case h.InputBoxValidationSeverity.Info:b=A.default.Info;break;case h.InputBoxValidationSeverity.Warning:b=A.default.Warning;break;case h.InputBoxValidationSeverity.Error:b=A.default.Error;break;default:b=m.message?A.default.Error:A.default.Ignore;break}return{content:m.message,severity:b}}async showWorkspaceFolderPick(u,m=w.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[u]);if(!b)return;const l=await this._workspace.getWorkspaceFolders2();if(l)return l.find(f=>f.uri.toString()===b.uri.toString())}createQuickPick(u){const m=new s(u,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}createInputBox(u){const m=new v(u,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}$onDidChangeValue(u,m){this._sessions.get(u)?._fireDidChangeValue(m)}$onDidAccept(u){this._sessions.get(u)?._fireDidAccept()}$onDidChangeActive(u,m){const b=this._sessions.get(u);b instanceof s&&b._fireDidChangeActive(m)}$onDidChangeSelection(u,m){const b=this._sessions.get(u);b instanceof s&&b._fireDidChangeSelection(m)}$onDidTriggerButton(u,m){this._sessions.get(u)?._fireDidTriggerButton(m)}$onDidTriggerItemButton(u,m,b){const l=this._sessions.get(u);l instanceof s&&l._fireDidTriggerItemButton(m,b)}$onDidHide(u){this._sessions.get(u)?._fireDidHide()}}class C{static{this._nextId=1}constructor(u,m){this._extensionId=u,this._onDidDispose=m,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new O.Emitter,this._onDidChangeValueEmitter=new O.Emitter,this._onDidTriggerButtonEmitter=new O.Emitter,this._onDidHideEmitter=new O.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(u){this._title=u,this.update({title:u})}get step(){return this._steps}set step(u){this._steps=u,this.update({step:u})}get totalSteps(){return this._totalSteps}set totalSteps(u){this._totalSteps=u,this.update({totalSteps:u})}get enabled(){return this._enabled}set enabled(u){this._enabled=u,this.update({enabled:u})}get busy(){return this._busy}set busy(u){this._busy=u,this.update({busy:u})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(u){this._ignoreFocusOut=u,this.update({ignoreFocusOut:u})}get value(){return this._value}set value(u){this._value=u,this.update({value:u})}get placeholder(){return this._placeholder}set placeholder(u){this._placeholder=u,this.update({placeholder:u})}get buttons(){return this._buttons}set buttons(u){this._buttons=u.slice(),this._handlesToButtons.clear(),u.forEach((m,b)=>{const l=m===h.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(l,m)}),this.update({buttons:u.map((m,b)=>({...n(m.iconPath),tooltip:m.tooltip,handle:m===h.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(u){this._value=u,this._onDidChangeValueEmitter.fire(u)}_fireDidTriggerButton(u){const m=this._handlesToButtons.get(u);m&&this._onDidTriggerButtonEmitter.fire(m)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,I.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),a.$dispose(this._id))}update(u){if(!this._disposed){for(const m of Object.keys(u)){const b=u[m];this._pendingUpdate[m]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){a.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function k(D){if(D instanceof h.ThemeIcon)return{id:D.id};const u=d(D),m=r(D);return{dark:typeof u=="string"?T.URI.file(u):u,light:typeof m=="string"?T.URI.file(m):m}}function r(D){return typeof D=="object"&&"light"in D?D.light:D}function d(D){return typeof D=="object"&&"dark"in D?D.dark:D}function n(D){const u=k(D);let m,b;return"id"in u?b=_.ThemeIcon.asClassName(u):m=u,{iconPath:m,iconClass:b}}class s extends C{constructor(u,m){super(u.identifier,m),this.extension=u,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new O.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new O.Emitter,this._onDidTriggerItemButtonEmitter=new O.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(u){this._items=u.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),u.forEach((l,f)=>{this._handlesToItems.set(f,l),this._itemsToHandles.set(l,f)});const m=(0,c.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),b=[];for(let l=0;l<u.length;l++){const f=u[l];if(f.kind===h.QuickPickItemKind.Separator)b.push({type:"separator",label:f.label});else{f.tooltip&&!m&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const P=f.iconPath?n(f.iconPath):void 0;b.push({handle:l,label:f.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:m?S.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((z,$)=>({...n(z.iconPath),tooltip:z.tooltip,handle:$}))})}}this.update({items:b})}get canSelectMany(){return this._canSelectMany}set canSelectMany(u){this._canSelectMany=u,this.update({canSelectMany:u})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(u){this._matchOnDescription=u,this.update({matchOnDescription:u})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(u){this._matchOnDetail=u,this.update({matchOnDetail:u})}get sortByLabel(){return this._sortByLabel}set sortByLabel(u){this._sortByLabel=u,this.update({sortByLabel:u})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(u){this._keepScrollPosition=u,this.update({keepScrollPosition:u})}get activeItems(){return this._activeItems}set activeItems(u){this._activeItems=u.filter(m=>this._itemsToHandles.has(m)),this.update({activeItems:this._activeItems.map(m=>this._itemsToHandles.get(m))})}get selectedItems(){return this._selectedItems}set selectedItems(u){this._selectedItems=u.filter(m=>this._itemsToHandles.has(m)),this.update({selectedItems:this._selectedItems.map(m=>this._itemsToHandles.get(m))})}_fireDidChangeActive(u){const m=(0,p.coalesce)(u.map(b=>this._handlesToItems.get(b)));this._activeItems=m,this._onDidChangeActiveEmitter.fire(m)}_fireDidChangeSelection(u){const m=(0,p.coalesce)(u.map(b=>this._handlesToItems.get(b)));this._selectedItems=m,this._onDidChangeSelectionEmitter.fire(m)}_fireDidTriggerItemButton(u,m){const b=this._handlesToItems.get(u);if(!b||!b.buttons||!b.buttons.length)return;const l=b.buttons[m];l&&this._onDidTriggerItemButtonEmitter.fire({button:l,item:b})}}class v extends C{constructor(u,m){super(u.identifier,m),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(u){this._password=u,this.update({password:u})}get prompt(){return this._prompt}set prompt(u){this._prompt=u,this.update({prompt:u})}get valueSelection(){return this._valueSelection}set valueSelection(u){this._valueSelection=u,this.update({valueSelection:u})}get validationMessage(){return this._validationMessage}set validationMessage(u){this._validationMessage=u,u?typeof u=="string"?this.update({validationMessage:u,severity:A.default.Error}):this.update({validationMessage:u.message,severity:u.severity??A.default.Error}):this.update({validationMessage:void 0,severity:A.default.Ignore})}}return new g(t,i)}e.createExtHostQuickOpen=E}),define(Pe[244],Ae([1,0,2,5,66,6,16,4,18,131,14,21,40,8,26,13]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function t(u){if(u)return typeof u.iconPath=="string"?w.URI.file(u.iconPath):w.URI.isUri(u.iconPath)||c.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function i(u,m){if(!u.iconPath&&!m.iconPath)return 0;if(u.iconPath){if(!m.iconPath)return 1}else return-1;const b=typeof u.iconPath=="string"?u.iconPath:w.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,l=typeof m.iconPath=="string"?m.iconPath:w.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,p.comparePaths)(b,l)}function a(u,m){let b=0;if(u.strikeThrough!==m.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==m.faded)return u.faded?1:-1;if(u.tooltip!==m.tooltip)return(u.tooltip||"").localeCompare(m.tooltip||"");if(b=i(u,m),b!==0)return b;if(u.light&&m.light)b=i(u.light,m.light);else{if(u.light)return 1;if(m.light)return-1}if(b!==0)return b;if(u.dark&&m.dark)b=i(u.dark,m.dark);else{if(u.dark)return 1;if(m.dark)return-1}return b}function g(u,m){if(u.command!==m.command)return u.command<m.command?-1:1;if(u.title!==m.title)return u.title<m.title?-1:1;if(u.tooltip!==m.tooltip){if(u.tooltip!==void 0&&m.tooltip!==void 0)return u.tooltip<m.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(u.arguments===m.arguments)return 0;if(u.arguments)if(m.arguments){if(u.arguments.length!==m.arguments.length)return u.arguments.length-m.arguments.length}else return 1;else return-1;for(let b=0;b<u.arguments.length;b++){const l=u.arguments[b],f=m.arguments[b];if(l!==f)return l<f?-1:1}return 0}function C(u,m){let b=(0,p.comparePaths)(u.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(b!==0)return b;if(u.command&&m.command)b=g(u.command,m.command);else{if(u.command)return 1;if(m.command)return-1}if(b!==0)return b;if(u.decorations&&m.decorations)b=a(u.decorations,m.decorations);else{if(u.decorations)return 1;if(m.decorations)return-1}return b}function k(u,m){for(let b=0;b<u.length;b++)if(u[b]!==m[b])return!1;return!0}function r(u,m){return u.command===m.command&&u.title===m.title&&u.tooltip===m.tooltip&&(u.arguments&&m.arguments?k(u.arguments,m.arguments):u.arguments===m.arguments)}function d(u,m){return(0,y.equals)(u,m,r)}class n{#e;#t;get value(){return this._value}set value(m){m=m??"",this.#e.$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(m){if((0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get enabled(){return this._enabled}set enabled(m){m=!!m,this._enabled!==m&&(this._enabled=m,this.#e.$setInputBoxEnablement(this._sourceControlHandle,m))}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,this.#e.$setInputBoxVisibility(this._sourceControlHandle,m))}get document(){return(0,E.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(m,b,l,f,P){this._extension=m,this._sourceControlHandle=f,this._documentUri=P,this._value="",this._onDidChange=new O.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=b,this.#e=l}showValidationMessage(m,b){(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,m,b)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=n;class s{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}constructor(m,b,l,f,P){this._proxy=m,this._commands=b,this._sourceControlHandle=l,this._id=f,this._label=P,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new O.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new O.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,b){const l=this._resourceStatesCommandsMap.get(m);return l?(0,T.asPromise)(()=>this._commands.executeCommand(l.command,...l.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(C),l=(0,y.sortedDiff)(this._resourceSnapshot,m,C).map(z=>{const $=z.toInsert.map(H=>{const x=this._resourceHandlePool++;this._resourceStatesMap.set(x,H);const U=H.resourceUri;let N;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const he=new M.DisposableStore;N=this._commands.converter.toInternal(H.command,he),this._resourceStatesDisposablesMap.set(x,he)}else this._resourceStatesCommandsMap.set(x,H.command);const ae=t(H.decorations),Y=H.decorations&&t(H.decorations.light)||ae,Ee=H.decorations&&t(H.decorations.dark)||ae,ye=[Y,Ee],Re=H.decorations&&H.decorations.tooltip||"",K=H.decorations&&!!H.decorations.strikeThrough,Q=H.decorations&&!!H.decorations.faded,ue=H.contextValue||"";return{rawResource:[x,U,ye,Re,K,Q,ue,N],handle:x}});return{start:z.start,deleteCount:z.deleteCount,toInsert:$}}),f=l.map(({start:z,deleteCount:$,toInsert:H})=>[z,$,H.map(x=>x.rawResource)]),P=l.reverse();for(const{start:z,deleteCount:$,toInsert:H}of P){const x=H.map(N=>N.handle),U=this._handlesSnapshot.splice(z,$,...x);for(const N of U)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=m,f}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class v{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,this.#e.$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m;let b;(0,E.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(b=m?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m,quickDiffLabel:b})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,this.#e.$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new M.DisposableStore,this._acceptInputCommand=m;const b=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:b})}get actionButton(){return(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(m){(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new M.DisposableStore,this._actionButton=m;const b=m!==void 0?{command:this._commands.converter.toInternal(m.command,this._actionButtonDisposables.value),secondaryCommands:m.secondaryCommands?.map(l=>l.map(f=>this._commands.converter.toInternal(f,this._actionButtonDisposables.value))),description:m.description,enabled:m.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:b??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&d(this._statusBarCommands,m))return;this._statusBarDisposables.value=new M.DisposableStore,this._statusBarCommands=m;const b=(m||[]).map(l=>this._commands.converter.toInternal(l,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}constructor(m,b,l,f,P,z,$){this._extension=m,this._commands=f,this._id=P,this._label=z,this._rootUri=$,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new M.MutableDisposable,this._statusBarDisposables=new M.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new O.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=v._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=l;const H=w.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${P}/scm${this.handle}/input`,query:$?`rootUri=${encodeURIComponent($.toString())}`:void 0});this._inputBox=new n(m,b,this.#e,this.handle,H),this.#e.$registerSourceControl(this.handle,P,z,$,H)}createResourceGroup(m,b){const l=new s(this.#e,this._commands,this.handle,m,b),f=O.Event.once(l.onDidDispose)(()=>this.createdResourceGroups.delete(l));return this.createdResourceGroups.set(l,f),this.eventuallyAddResourceGroups(),l}eventuallyAddResourceGroups(){const m=[],b=[];for(const[l,f]of this.createdResourceGroups){f.dispose();const P=l.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(l),this.eventuallyUpdateResourceStates()});O.Event.once(l.onDidDispose)(()=>{this.updatedResourceGroups.delete(l),P.dispose(),this._groups.delete(l.handle),this.#e.$unregisterGroup(this.handle,l.handle)}),m.push([l.handle,l.id,l.label,l.features]);const z=l._takeResourceStateSnapshot();z.length>0&&b.push([l.handle,z]),this._groups.set(l.handle,l)}this.#e.$registerGroups(this.handle,m,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(b=>{const l=b._takeResourceStateSnapshot();l.length!==0&&m.push([b.handle,l])}),m.length>0&&this.#e.$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),this.#e.$unregisterSourceControl(this.handle)}}We([(0,I.debounce)(100)],v.prototype,"eventuallyAddResourceGroups",null),We([(0,I.debounce)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let D=class _n{static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(m,b,l,f){this._commands=b,this._extHostDocuments=l,this.logService=f,this._sourceControls=new Map,this._sourceControlsByExtension=new _.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new O.Emitter,this._proxy=m.getProxy(h.MainContext.MainThreadSCM),this._telemetry=m.getProxy(h.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const z=this._sourceControls.get(P.sourceControlHandle);if(!z)return P;const $=z.getResourceGroup(P.groupHandle);return $?$.getResourceState(P.handle):P}else if(P&&P.$mid===4){const z=this._sourceControls.get(P.sourceControlHandle);return z?z.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const z=this._sourceControls.get(P.handle);return z||P}return P}})}createSourceControl(m,b,l,f){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,b,l,f),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const P=_n._handlePool++,z=new v(m,this._extHostDocuments,this._proxy,this._commands,b,l,f);this._sourceControls.set(P,z);const $=this._sourceControlsByExtension.get(m.identifier)||[];return $.push(z),this._sourceControlsByExtension.set(m.identifier,$),z}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const b=this._sourceControlsByExtension.get(m.identifier),l=b&&b[b.length-1];return l&&l.inputBox}$provideOriginalResource(m,b,l){const f=w.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,f.toString());const P=this._sourceControls.get(m);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>P.quickDiffProvider.provideOriginalResource(f,l)).then(z=>z||null)}$onInputBoxValueChange(m,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const l=this._sourceControls.get(m);return l&&l.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(m,b,l,f){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,b,l);const P=this._sourceControls.get(m);if(!P)return Promise.resolve(void 0);const z=P.getResourceGroup(b);return z?z.$executeResourceCommand(l,f):Promise.resolve(void 0)}$validateInput(m,b,l){this.logService.trace("ExtHostSCM#$validateInput",m);const f=this._sourceControls.get(m);return!f||!f.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>f.inputBox.validateInput(b,l)).then(P=>{if(!P)return Promise.resolve(void 0);const z=S.MarkdownString.fromStrict(P.message);return z?Promise.resolve([z,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};e.ExtHostSCM=D,e.ExtHostSCM=D=We([He(3,A.ILogService)],D)}),define(Pe[83],Ae([1,0,4,5,3]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(h){this._onDidChangePassword=new O.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=h.getProxy(w.MainContext.MainThreadSecretState)}async $onDidChangePassword(h){this._onDidChangePassword.fire(h)}get(h,y){return this._proxy.$getPassword(h,y)}store(h,y,p){return this._proxy.$setPassword(h,y,p)}delete(h,y){return this._proxy.$deletePassword(h,y)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(Pe[245],Ae([1,0,4,7]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSemanticSimilarity=void 0;class I{constructor(T){this._semanticSimilarityProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(w.MainContext.MainThreadSemanticSimilarity)}async $provideSimilarityScore(T,h,y,p){if(this._semanticSimilarityProviders.size===0)throw new Error("No semantic similarity providers registered");const A=this._semanticSimilarityProviders.get(T);if(!A)throw new Error("Semantic similarity provider not found");return await A.provideSimilarityScore(h,y,p)}registerSemanticSimilarityProvider(T,h){const y=this._nextHandle;return this._nextHandle++,this._semanticSimilarityProviders.set(y,h),this._proxy.$registerSemanticSimilarityProvider(y),new O.Disposable(()=>{this._proxy.$unregisterSemanticSimilarityProvider(y),this._semanticSimilarityProviders.delete(y)})}}e.ExtHostSemanticSimilarity=I}),define(Pe[246],Ae([1,0,4,8,2]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class M{static{this.handlePool=0}constructor(h,y){this.uriTransformer=y,this.providers=new Map,this.proxy=h.getProxy(w.MainContext.MainThreadShare)}async $provideShare(h,y,p){return await this.providers.get(h)?.provideShare({selection:O.Range.to(y.selection),resourceUri:I.URI.revive(y.resourceUri)},p)??void 0}registerShareProvider(h,y){const p=M.handlePool++;return this.providers.set(p,y),this.proxy.$registerShareProvider(p,O.DocumentSelector.from(h,this.uriTransformer),y.id,y.label,y.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(p),this.providers.delete(p)}}}}e.ExtHostShare=M}),define(Pe[247],Ae([1,0,7,4,153,6,8,12]),function(pe,e,w,O,I,M,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new w.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(c,S,E,o,t,i=w.StatusBarAlignment.Left,a){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new M.DisposableStore,this.#e=c,this.#t=S,t&&o){this._entryId=(0,w.asStatusBarItemIdentifier)(o.identifier,t);const g=E.get(this._entryId);g&&(i=g.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,a=g.priority,this._visible=!0,this.name=g.name,this.text=g.text,this.tooltip=g.tooltip,this.command=g.command,this.accessibilityInformation=g.accessibilityInformation)}else this._entryId=String(y.ID_GEN++);this._extension=o,this._id=t,this._alignment=i,this._priority=this.validatePriority(a)}validatePriority(c){if((0,h.isNumber)(c))return c===Number.POSITIVE_INFINITY?Number.MAX_VALUE:c===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:c}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(c){this._text=c,this.update()}set name(c){this._name=c,this.update()}set tooltip(c){this._tooltip=c,this.update()}set color(c){this._color=c,this.update()}set backgroundColor(c){c&&!y.ALLOWED_BACKGROUND_COLORS.has(c.id)&&(c=void 0),this._backgroundColor=c,this.update()}set command(c){this._command?.fromApi!==c&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new M.DisposableStore,typeof c=="string"?this._command={fromApi:c,internal:this.#t.toInternal({title:"",command:c},this._latestCommandRegistration)}:c?this._command={fromApi:c,internal:this.#t.toInternal(c,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(c){this._accessibilityInformation=c,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let c;this._extension?this._id?c=`${this._extension.identifier.value}.${this._id}`:c=this._extension.identifier.value:c=this._id;let S;this._name?S=this._name:S=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let E=this._color;this._backgroundColor&&(E=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const o=T.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,c,this._extension?.identifier.value,S,this._text,o,this._command?.internal,E,this._backgroundColor,this._alignment===w.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y;class p{constructor(c){this._messages=[],this._item=c.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(c){const S={message:c};return this._messages.unshift(S),this._update(),new w.Disposable(()=>{const E=this._messages.indexOf(S);E>=0&&(this._messages.splice(E,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class A{constructor(c,S){this._existingItems=new Map,this._proxy=c.getProxy(O.MainContext.MainThreadStatusBar),this._commands=S,this._statusMessage=new p(this)}$acceptStaticEntries(c){for(const S of c)this._existingItems.set(S.entryId,S)}createStatusBarEntry(c,S,E,o){return new y(this._proxy,this._commands,this._existingItems,c,S,E,o)}setStatusBarMessage(c,S){const E=this._statusMessage.setMessage(c);let o;return typeof S=="number"?o=setTimeout(()=>E.dispose(),S):typeof S<"u"&&S.then(()=>E.dispose(),()=>E.dispose()),new w.Disposable(()=>{E.dispose(),clearTimeout(o)})}}e.ExtHostStatusBar=A}),define(Pe[84],Ae([1,0,4,5,3]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(h,y){this._logService=y,this._onDidChangeStorage=new O.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=h.getProxy(w.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(h,y){this._proxy.$registerExtensionStorageKeysToSync(h,y)}async initializeExtensionStorage(h,y,p){const A=await this._proxy.$initializeExtensionStorage(h,y);let _;return A&&(_=this.safeParseValue(h,y,A)),_||p}setValue(h,y,p){return this._proxy.$setValue(h,y,p)}$acceptValue(h,y,p){const A=this.safeParseValue(h,y,p);A&&this._onDidChangeStorage.fire({shared:h,key:y,value:A})}safeParseValue(h,y,p){try{return JSON.parse(p)}catch(A){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${h}): ${A}`)}}}e.ExtHostStorage=M,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(Pe[85],Ae([1,0,3,27,14,62,2]),function(pe,e,w,O,I,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,w.createDecorator)("IExtensionStoragePaths");let h=class{constructor(p,A,_){this._logService=A,this._extHostFileSystem=_,this._workspace=p.workspace??void 0,this._environment=p.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(p){return T.URI.joinPath(this._environment.workspaceStorageHome,p)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const p=this._workspace.id,A=await this._getWorkspaceStorageURI(p);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),A}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(p){if(this._value)return T.URI.joinPath(this._value,p.identifier.value)}globalValue(p){return T.URI.joinPath(this._environment.globalStorageHome,p.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=h,e.ExtensionStoragePaths=h=We([He(0,O.IExtHostInitDataService),He(1,I.ILogService),He(2,M.IExtHostConsumerFileSystem)],h)}),define(Pe[63],Ae([1,0,5,4,3,2,17,6,7,155,11,182,20,36,183,40,12,16,8,26]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t,i,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class C{constructor(l,f,P,z){this._proxy=l,this._id=f,this._creationOptions=P,this._name=z,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(H=>this._pidPromiseComplete=H);const $=this;this.value={get name(){return $._name||""},get processId(){return $._pidPromise},get creationOptions(){return $._creationOptions},get exitStatus(){return $._exitStatus},get state(){return $._state},get selection(){return $._selection},sendText(H,x=!0){$._checkDisposed(),$._proxy.$sendText($._id,H,x)},show(H){$._checkDisposed(),$._proxy.$show($._id,H)},hide(){$._checkDisposed(),$._proxy.$hide($._id)},dispose(){$._disposed||($._disposed=!0,$._proxy.$dispose($._id))},get dimensions(){if(!($._cols===void 0||$._rows===void 0))return{columns:$._cols,rows:$._rows}}}}async create(l,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:l.name,shellPath:(0,t.withNullAsUndefined)(l.shellPath),shellArgs:(0,t.withNullAsUndefined)(l.shellArgs),cwd:(0,t.withNullAsUndefined)(l.cwd),env:(0,t.withNullAsUndefined)(l.env),icon:(0,t.withNullAsUndefined)(D(l.iconPath)),color:o.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:(0,t.withNullAsUndefined)(l.message),strictEnv:(0,t.withNullAsUndefined)(l.strictEnv),hideFromUser:(0,t.withNullAsUndefined)(l.hideFromUser),isFeatureTerminal:(0,t.withNullAsUndefined)(f?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,t.withNullAsUndefined)(f?.useShellEnvironment),location:f?.location||this._serializeParentTerminal(l.location,f?.resolvedExtHostIdentifier),isTransient:(0,t.withNullAsUndefined)(l.isTransient)})}async createExtensionTerminal(l,f,P,z){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:P,color:o.ThemeColor.isThemeColor(z)?z.id:void 0,location:this._serializeParentTerminal(l,f),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(l,f){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in l?{viewColumn:a.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus}:void 0:l}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(l){this._name=l}setExitStatus(l,f){this._exitStatus=Object.freeze({code:l,reason:f})}setDimensions(l,f){return l===this._cols&&f===this._rows||l===0||f===0?!1:(this._cols=l,this._rows=f,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(l){this._selection=l}_setProcessId(l){this._pidPromiseComplete?(this._pidPromiseComplete(l),this._pidPromiseComplete=void 0):this._pidPromise.then(f=>{f!==l&&(this._pidPromise=Promise.resolve(l))})}}e.ExtHostTerminal=C;class k{get onProcessReady(){return this._onProcessReady.event}constructor(l){this._pty=l,this.id=0,this.shouldPersist=!1,this._onProcessData=new w.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new w.Emitter,this._onDidChangeProperty=new w.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new w.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(l){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${l}`)}updateProperty(l,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${l}, value: ${f}`)}async start(){}shutdown(){this._pty.close()}input(l){this._pty.handleInput?.(l)}resize(l,f){this._pty.setDimensions?.({columns:l,rows:f})}clearBuffer(){}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(l){this._pty.onDidWrite(f=>this._onProcessData.fire(f)),this._pty.onDidClose?.((f=void 0)=>{this._onProcessExit.fire(f===void 0?void 0:f)}),this._pty.onDidOverrideDimensions?.(f=>{f&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:f.columns,rows:f.rows}})}),this._pty.onDidChangeName?.(f=>{this._onDidChangeProperty.fire({type:"title",value:f})}),this._pty.open(l||void 0),l&&this._pty.setDimensions?.(l),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let r=1,d=class extends h.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(l=>l.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(l,f){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new w.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new w.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new w.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new w.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new w.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new w.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=f.getProxy(O.MainContext.MainThreadTerminalService),this._bufferer=new E.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new w.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(l),this._register({dispose:()=>{for(const[P,z]of this._terminalProcesses)z.shutdown(!0)}})}getDefaultShell(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(l,f){const P=new C(this._proxy,(0,S.generateUuid)(),l,l.name),z=new k(l.pty);return P.createExtensionTerminal(l.location,this._serializeParentTerminal(l,f).resolvedExtHostIdentifier,D(l.iconPath),u(l.color)).then($=>{const H=this._setupExtHostProcessListeners($,z);this._terminalProcessDisposables[$]=H}),this._terminals.push(P),P.value}_serializeParentTerminal(l,f){if(f=f||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const P=l.location.parentTerminal;if(P){const z=this._terminals.find($=>$.value===P);z&&(f.resolvedExtHostIdentifier=z._id)}}else l.location&&typeof l.location!="object"?f.location=l.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal(l,f){if(!this._getTerminalById(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const z=new k(f),$=this._setupExtHostProcessListeners(l,z);this._terminalProcessDisposables[l]=$}async $acceptActiveTerminalChanged(l){const f=this._activeTerminal;if(l===null){this._activeTerminal=void 0,f!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const P=this._getTerminalById(l);P&&(this._activeTerminal=P,f!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(l,f){const P=this._getTerminalById(l);P&&this._onDidWriteTerminalData.fire({terminal:P.value,data:f})}async $acceptTerminalDimensions(l,f,P){const z=this._getTerminalById(l);z&&z.setDimensions(f,P)&&this._onDidChangeTerminalDimensions.fire({terminal:z.value,dimensions:z.value.dimensions})}async $acceptTerminalMaximumDimensions(l,f,P){this._terminalProcesses.get(l)?.resize(f,P)}async $acceptTerminalTitleChange(l,f){const P=this._getTerminalById(l);P&&(P.name=f)}async $acceptTerminalClosed(l,f,P){const z=this._getTerminalObjectIndexById(this._terminals,l);if(z!==null){const $=this._terminals.splice(z,1)[0];$.setExitStatus(f,P),this._onDidCloseTerminal.fire($.value)}}$acceptTerminalOpened(l,f,P,z){if(f){const x=this._getTerminalObjectIndexById(this._terminals,f);if(x!==null){this._terminals[x]._id=l,this._onDidOpenTerminal.fire(this.terminals[x]),this._terminals[x].isOpen=!0;return}}const $={name:z.name,shellPath:z.executable,shellArgs:z.args,cwd:typeof z.cwd=="string"?z.cwd:M.URI.revive(z.cwd),env:z.env,hideFromUser:z.hideFromUser},H=new C(this._proxy,l,$,P);this._terminals.push(H),this._onDidOpenTerminal.fire(H.value),H.isOpen=!0}async $acceptTerminalProcessId(l,f){this._getTerminalById(l)?._setProcessId(f)}async $startExtensionTerminal(l,f){const P=this._getTerminalById(l);if(!P)return{message:(0,p.localize)(0,null,l)};P.isOpen||await new Promise($=>{const H=this.onDidOpenTerminal(async x=>{x===P.value&&(H.dispose(),$())})});const z=this._terminalProcesses.get(l);z?z.startSendingEvents(f):this._extensionTerminalAwaitingStart[l]={initialDimensions:f}}_setupExtHostProcessListeners(l,f){const P=new h.DisposableStore;P.add(f.onProcessReady($=>this._proxy.$sendProcessReady(l,$.pid,$.cwd,$.windowsPty))),P.add(f.onDidChangeProperty($=>this._proxy.$sendProcessProperty(l,$))),this._bufferer.startBuffering(l,f.onProcessData),P.add(f.onProcessExit($=>this._onProcessExit(l,$))),this._terminalProcesses.set(l,f);const z=this._extensionTerminalAwaitingStart[l];return z&&f instanceof k&&(f.startSendingEvents(z.initialDimensions),delete this._extensionTerminalAwaitingStart[l]),P}$acceptProcessAckDataEvent(l,f){this._terminalProcesses.get(l)?.acknowledgeDataEvent(f)}$acceptProcessInput(l,f){this._terminalProcesses.get(l)?.input(f)}$acceptTerminalInteraction(l){const f=this._getTerminalById(l);f?.setInteractedWith()&&this._onDidChangeTerminalState.fire(f.value)}$acceptTerminalSelection(l,f){this._getTerminalById(l)?.setSelection(f)}$acceptProcessResize(l,f,P){try{this._terminalProcesses.get(l)?.resize(f,P)}catch(z){if(z.code!=="EPIPE"&&z.code!=="ERR_IPC_CHANNEL_CLOSED")throw z}}$acceptProcessShutdown(l,f){this._terminalProcesses.get(l)?.shutdown(f)}$acceptProcessRequestInitialCwd(l){this._terminalProcesses.get(l)?.getInitialCwd().then(f=>this._proxy.$sendProcessProperty(l,{type:"initialCwd",value:f}))}$acceptProcessRequestCwd(l){this._terminalProcesses.get(l)?.getCwd().then(f=>this._proxy.$sendProcessProperty(l,{type:"cwd",value:f}))}$acceptProcessRequestLatency(l){return Promise.resolve(l)}registerLinkProvider(l){return this._linkProviders.add(l),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(l),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(l,f,P){if(this._profileProviders.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this._profileProviders.set(f,P),this._proxy.$registerProfileProvider(f,l.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(f),this._proxy.$unregisterProfileProvider(f)})}registerTerminalQuickFixProvider(l,f,P){if(this._quickFixProviders.has(l))throw new Error(`Terminal quick fix provider "${l}" is already registered`);return this._quickFixProviders.set(l,P),this._proxy.$registerQuickFixProvider(l,f),new y.Disposable(()=>{this._quickFixProviders.delete(l),this._proxy.$unregisterQuickFixProvider(l)})}async $provideTerminalQuickFixes(l,f){const P=new c.CancellationTokenSource().token;if(P.isCancellationRequested)return;const z=this._quickFixProviders.get(l);if(!z)return;const $=await z.provideTerminalQuickFixes(f,P);if($!==null)return $}async $createContributedProfileTerminal(l,f){const P=new c.CancellationTokenSource().token;let z=await this._profileProviders.get(l)?.provideTerminalProfile(P);if(!P.isCancellationRequested){if(z&&!("options"in z)&&(z={options:z}),!z||!("options"in z))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in z.options){this.createExtensionTerminal(z.options,f);return}this.createTerminalFromOptions(z.options,f)}}async $provideLinks(l,f){const P=this._getTerminalById(l);if(!P)return[];this._terminalLinkCache.delete(l),this._terminalLinkCancellationSource.get(l)?.dispose(!0);const $=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(l,$);const H=[],x={terminal:P.value,line:f},U=[];for(const Y of this._linkProviders)U.push(i.Promises.withAsyncBody(async Ee=>{$.token.onCancellationRequested(()=>Ee({provider:Y,links:[]}));const ye=await Y.provideTerminalLinks(x,$.token)||[];$.token.isCancellationRequested||Ee({provider:Y,links:ye})}));const N=await Promise.all(U);if($.token.isCancellationRequested)return[];const ae=new Map;for(const Y of N)Y&&Y.links.length>0&&H.push(...Y.links.map(Ee=>{const ye={id:r++,startIndex:Ee.startIndex,length:Ee.length,label:Ee.tooltip};return ae.set(ye.id,{provider:Y.provider,link:Ee}),ye}));return this._terminalLinkCache.set(l,ae),H}$activateLink(l,f){const P=this._terminalLinkCache.get(l)?.get(f);P&&P.provider.handleTerminalLink(P.link)}_onProcessExit(l,f){this._bufferer.stopBuffering(l),this._terminalProcesses.delete(l),delete this._extensionTerminalAwaitingStart[l];const P=this._terminalProcessDisposables[l];P&&(P.dispose(),delete this._terminalProcessDisposables[l]),this._proxy.$sendProcessExit(l,f)}_getTerminalById(l){return this._getTerminalObjectById(this._terminals,l)}_getTerminalObjectById(l,f){const P=this._getTerminalObjectIndexById(l,f);return P!==null?l[P]:null}_getTerminalObjectIndexById(l,f){const P=l.findIndex(z=>z._id===f);return P===-1?null:P}getEnvironmentVariableCollection(l){let f=this._environmentVariableCollections.get(l.identifier.value);return f||(f=new n(l),this._setEnvironmentVariableCollection(l.identifier.value,f)),f.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(l,f){const P=(0,_.serializeEnvironmentVariableCollection)(f.map),z=(0,_.serializeEnvironmentDescriptionMap)(f.descriptionMap);this._proxy.$setEnvironmentVariableCollection(l,f.persistent,P.length===0?void 0:P,z)}$initEnvironmentVariableCollections(l){l.forEach(f=>{const P=f[0],z=new n(void 0,f[1]);this._setEnvironmentVariableCollection(P,z)})}$acceptDefaultProfile(l,f){const P=this._defaultProfile;this._defaultProfile=l,this._defaultAutomationProfile=f,P?.path!==l.path&&this._onDidChangeShell.fire(l.path)}_setEnvironmentVariableCollection(l,f){this._environmentVariableCollections.set(l,f),f.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(l,f)})}};e.BaseExtHostTerminalService=d,e.BaseExtHostTerminalService=d=We([He(1,T.IExtHostRpcService)],d);class n{get persistent(){return this._persistent}set persistent(l){this._persistent=l,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(l,f){this._extension=l,this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new w.Emitter,this.map=new Map(f)}getScopedEnvironmentVariableCollection(l){this._extension&&l&&(0,g.checkProposedApiEnabled)(this._extension,"envCollectionWorkspace");const f=this.getScopeKey(l);let P=this.scopedCollections.get(f);return P||(P=new s(this,l),this.scopedCollections.set(f,P),P.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),P}replace(l,f,P,z){this._extension&&P&&(0,g.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(l,{value:f,type:y.EnvironmentVariableMutatorType.Replace,options:P??{},scope:z})}append(l,f,P,z){this._extension&&P&&(0,g.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(l,{value:f,type:y.EnvironmentVariableMutatorType.Append,options:P??{},scope:z})}prepend(l,f,P,z){this._extension&&P&&(0,g.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(l,{value:f,type:y.EnvironmentVariableMutatorType.Prepend,options:P??{},scope:z})}_setIfDiffers(l,f){if(f.options&&f.options.applyAtProcessCreation===!1&&!f.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const P=this.getKey(l,f.scope),z=this.map.get(P);if(!z||z.value!==f.value||z.type!==f.type||z.options?.applyAtProcessCreation!==(f.options.applyAtProcessCreation??!0)||z.options?.applyAtShellIntegration!==(f.options.applyAtShellIntegration??!1)||z.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index){const $=this.getKey(l,f.scope),H={variable:l,...f,options:{applyAtProcessCreation:f.options.applyAtProcessCreation??!0,applyAtShellIntegration:f.options.applyAtShellIntegration??!1}};this.map.set($,H),this._onDidChangeCollection.fire()}}get(l,f){const P=this.getKey(l,f),z=this.map.get(P);return z?m(z):void 0}getKey(l,f){const P=this.getScopeKey(f);return P.length?`${l}:::${P}`:l}getScopeKey(l){return this.getWorkspaceKey(l?.workspaceFolder)??""}getWorkspaceKey(l){return l?l.uri.toString():void 0}getVariableMap(l){const f=new Map;for(const[P,z]of this.map)this.getScopeKey(z.scope)===this.getScopeKey(l)&&f.set(z.variable,m(z));return f}delete(l,f){const P=this.getKey(l,f);this.map.delete(P),this._onDidChangeCollection.fire()}clear(l){if(l?.workspaceFolder){for(const[f,P]of this.map)P.scope?.workspaceFolder?.index===l.workspaceFolder.index&&this.map.delete(f);this.clearDescription(l)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(l,f){const P=this.getScopeKey(f),z=this.descriptionMap.get(P);if(!z||z.description!==l){let $;typeof l=="string"?$=l:$=l?.value.split(`

`)[0];const H={description:$,scope:f};this.descriptionMap.set(P,H),this._onDidChangeCollection.fire()}}getDescription(l){const f=this.getScopeKey(l);return this.descriptionMap.get(f)?.description}clearDescription(l){const f=this.getScopeKey(l);this.descriptionMap.delete(f)}}class s{get persistent(){return this.collection.persistent}set persistent(l){this.collection.persistent=l}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(l,f){this.collection=l,this.scope=f,this._onDidChangeCollection=new w.Emitter}getScopedEnvironmentVariableCollection(l){return this.collection.getScopedEnvironmentVariableCollection(l)}replace(l,f,P){this.collection.replace(l,f,P,this.scope)}append(l,f,P){this.collection.append(l,f,P,this.scope)}prepend(l,f,P){this.collection.prepend(l,f,P,this.scope)}get(l){return this.collection.get(l,this.scope)}forEach(l,f){this.collection.getVariableMap(this.scope).forEach((P,z)=>l.call(f,z,P,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(l){this.collection.delete(l,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(l){this.collection.setDescription(l,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let v=class extends d{constructor(l){super(!1,l)}createTerminal(l,f,P){throw new A.NotSupportedError}createTerminalFromOptions(l,f){throw new A.NotSupportedError}};e.WorkerExtHostTerminalService=v,e.WorkerExtHostTerminalService=v=We([He(0,T.IExtHostRpcService)],v);function D(b){if(!(!b||typeof b=="string"))return"id"in b?{id:b.id,color:b.color}:b}function u(b){return o.ThemeColor.isThemeColor(b)?b:void 0}function m(b){const l={...b};return delete l.scope,l.options=l.options??void 0,delete l.variable,l}}),define(Pe[248],Ae([1,0,18,16,25,20,5,203,93,6,24,12,36,4,17,104,8,7,45,76,57]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t,i,a,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let k=class{constructor($,H,x){this.editors=x,this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=$.getProxy(S.MainContext.MainThreadTesting),this.observer=new l(this.proxy),this.runTracker=new s(this.proxy),H.registerArgumentProcessor({processArgument:U=>{if(U?.$mid!==15)return U;const N=U,ae=N.tests[N.tests.length-1].item.extId;return this.controllers.get(a.TestId.root(ae))?.collection.tree.get(ae)?.actual??(0,o.toItemFromContext)(U)}}),H.registerCommand(!1,"testing.getExplorerSelection",async()=>{const U=await H.executeCommand("_testing.getExplorerSelection"),N=ae=>{const Y=this.controllers.get(a.TestId.root(ae));if(Y)return a.TestId.isRoot(ae)?Y.controller:Y.collection.tree.get(ae)?.actual};return{include:U?.include.map(N).filter(_.isDefined)||[],exclude:U?.exclude.map(N).filter(_.isDefined)||[]}})}createTestController($,H,x,U){if(this.controllers.has(H))throw new Error(`Attempt to insert a duplicate controller with ID "${H}"`);const N=new p.DisposableStore,ae=N.add(new o.ExtHostTestItemCollection(H,x,this.editors));ae.root.label=x;const Y=new Map,Ee=this.proxy,ye={items:ae.root.children,get label(){return x},set label(K){x=K,ae.root.label=K,Ee.$updateController(H,{label:x})},get refreshHandler(){return U},set refreshHandler(K){U=K,Ee.$updateController(H,{canRefresh:!!K})},get id(){return H},createRunProfile:(K,Q,ue,ne,he,le)=>{let F=(0,y.hash)(K);for(;Y.has(F);)F++;return new f(this.proxy,Y,H,F,K,Q,ue,ne,he,le)},createTestItem(K,Q,ue){return new o.TestItemImpl(H,K,Q,ue)},createTestRun:(K,Q,ue=!0)=>this.runTracker.createTestRun(H,ae,K,Q,ue),invalidateTestResults:K=>{if(K===void 0)this.proxy.$markTestRetired(void 0);else{const Q=K instanceof Array?K:[K];this.proxy.$markTestRetired(Q.map(ue=>a.TestId.fromExtHostTestItem(ue,H).toString()))}},set resolveHandler(K){ae.resolveHandler=K},get resolveHandler(){return ae.resolveHandler},dispose:()=>{N.dispose()}};Ee.$registerTestController(H,x,!!U),N.add((0,p.toDisposable)(()=>Ee.$unregisterTestController(H)));const Re={controller:ye,collection:ae,profiles:Y};return this.controllers.set(H,Re),N.add((0,p.toDisposable)(()=>this.controllers.delete(H))),N.add(ae.onDidGenerateDiff(K=>Ee.$publishDiff(H,K.map(C.TestsDiffOp.serialize)))),ye}createTestObserver(){return this.observer.checkout()}async runTests($,H=M.CancellationToken.None){const x=v($);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.controllers.get(x.controllerId);if(!U)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:$.include?.map(N=>a.TestId.fromExtHostTestItem(N,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:P[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:$.exclude?.map(N=>N.id)},H)}$syncTests(){for(const{collection:$}of this.controllers.values())$.flushDiff();return Promise.resolve()}$provideFileCoverage($,H,x){return(0,w.mapFind)(this.runTracker.trackers,N=>N.id===$?N.getCoverage(H):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage($,H,x,U){return(0,w.mapFind)(this.runTracker.trackers,ae=>ae.id===$?ae.getCoverage(H):void 0)?.resolveFileCoverage(x,U)??Promise.resolve([])}$configureRunProfile($,H){this.controllers.get($)?.profiles.get(H)?.configureHandler?.()}async $refreshTests($,H){await this.controllers.get($)?.controller.refreshHandler?.(H)}$publishTestResults($){this.results=Object.freeze($.map(H=>(0,A.deepFreeze)(t.TestResults.to(H))).concat(this.results).sort((H,x)=>x.completedAt-H.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest($,H){const x=this.controllers.get(a.TestId.fromString($).controllerId)?.collection;x&&(await x.expand($,H<0?1/0:H),x.flushDiff())}$acceptDiff($){this.observer.applyDiff($.map(C.TestsDiffOp.deserialize))}async $runControllerTests($,H){return Promise.all($.map(x=>this.runControllerTestRequest(x,!1,H)))}async $startContinuousRun($,H){const x=new M.CancellationTokenSource(H),U=await Promise.all($.map(N=>this.runControllerTestRequest(N,!0,x.token)));return!H.isCancellationRequested&&!U.some(N=>N.error)&&await new Promise(N=>H.onCancellationRequested(N)),x.dispose(!0),U}async runControllerTestRequest($,H,x){const U=this.controllers.get($.controllerId);if(!U)return{};const{collection:N,profiles:ae}=U,Y=ae.get($.profileId);if(!Y)return{};const Ee=$.testIds.map(Q=>N.tree.get(Q)).filter(_.isDefined),ye=$.excludeExtIds.map(Q=>U.collection.tree.get(Q)).filter(_.isDefined).filter(Q=>Ee.some(ue=>ue.fullId.compare(Q.fullId)===2));if(!Ee.length)return{};const Re=new i.TestRunRequest(Ee.some(Q=>Q.actual instanceof o.TestItemRootImpl)?void 0:Ee.map(Q=>Q.actual),ye.map(Q=>Q.actual),Y,H),K=(0,C.isStartControllerTests)($)&&this.runTracker.prepareForMainThreadTestRun(Re,D.fromInternal($,U.collection),x);try{return await Y.runHandler(Re,x),{}}catch(Q){return{error:String(Q)}}finally{K&&(K.hasRunningTasks&&!x.isCancellationRequested&&await T.Event.toPromise(K.onEnd),K.dispose())}}$cancelExtensionTestRun($){$===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById($)}};e.ExtHostTesting=k,e.ExtHostTesting=k=We([He(0,E.IExtHostRpcService)],k);const r=1e4;var d;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(d||(d={}));class n extends p.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor($,H,x){super(),this.dto=$,this.proxy=H,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new M.CancellationTokenSource(x));const U=this._register(new O.RunOnceScheduler(()=>this.forciblyEndTasks(),r));this._register(this.cts.token.onCancellationRequested(()=>U.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage($){return this.tasks.get($)?.coverage}createRun($){const H=this.dto.id,x=this.dto.controllerId,U=(0,c.generateUuid)(),N=new u(this.proxy,H,U),ae=Re=>(K,...Q)=>{if(Ee){console.warn(`Setting the state of test "${K.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(K)&&(this.ensureTestIsKnown(K),Re(K,...Q))},Y=(Re,K)=>{const Q=K instanceof Array?K.map(t.TestMessage.from):[t.TestMessage.from(K)];if(Re.uri&&Re.range){const ue={range:t.Range.from(Re.range),uri:Re.uri};for(const ne of Q)ne.location=ne.location||ue}this.proxy.$appendTestMessagesInRun(H,U,a.TestId.fromExtHostTestItem(Re,x).toString(),Q)};let Ee=!1;const ye={isPersisted:this.dto.isPersisted,token:this.cts.token,name:$,get coverageProvider(){return N.coverageProvider},set coverageProvider(Re){N.coverageProvider=Re},enqueued:ae(Re=>{this.proxy.$updateTestStateInRun(H,U,a.TestId.fromExtHostTestItem(Re,x).toString(),1)}),skipped:ae(Re=>{this.proxy.$updateTestStateInRun(H,U,a.TestId.fromExtHostTestItem(Re,x).toString(),5)}),started:ae(Re=>{this.proxy.$updateTestStateInRun(H,U,a.TestId.fromExtHostTestItem(Re,x).toString(),2)}),errored:ae((Re,K,Q)=>{Y(Re,K),this.proxy.$updateTestStateInRun(H,U,a.TestId.fromExtHostTestItem(Re,x).toString(),6,Q)}),failed:ae((Re,K,Q)=>{Y(Re,K),this.proxy.$updateTestStateInRun(H,U,a.TestId.fromExtHostTestItem(Re,x).toString(),4,Q)}),passed:ae((Re,K)=>{this.proxy.$updateTestStateInRun(H,U,a.TestId.fromExtHostTestItem(Re,this.dto.controllerId).toString(),3,K)}),appendOutput:(Re,K,Q)=>{Ee||(Q&&(this.dto.isIncluded(Q)?this.ensureTestIsKnown(Q):Q=void 0),this.proxy.$appendOutputToRun(H,U,I.VSBuffer.fromString(Re),K&&t.location.from(K),Q&&a.TestId.fromExtHostTestItem(Q,x).toString()))},end:()=>{Ee||(Ee=!0,this.proxy.$finishedTestRunTask(H,U),this.tasks.delete(U),this.tasks.size||this.markEnded())}};return this.tasks.set(U,{run:ye,coverage:N}),this.proxy.$startedTestRunTask(H,{id:U,name:$,running:!0}),ye}forciblyEndTasks(){for(const{run:$}of this.tasks.values())$.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown($){if(!($ instanceof o.TestItemImpl))throw new g.InvalidTestItemError($.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem($,this.dto.controllerId).toString()))return;const H=[],x=this.dto.colllection.root;for(;;){const U=t.TestItem.from($);if(H.unshift(U),this.sharedTestIds.has(U.extId)||(this.sharedTestIds.add(U.extId),$===x))break;$=$.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,H)}}class s{get trackers(){return this.tracked.values()}constructor($){this.proxy=$,this.tracked=new Map}prepareForMainThreadTestRun($,H,x){return this.getTracker($,H,x)}cancelRunById($){for(const H of this.tracked.values())if(H.id===$){H.cancel();return}}cancelAllRuns(){for(const $ of this.tracked.values())$.cancel()}createTestRun($,H,x,U,N){const ae=this.tracked.get(x);if(ae)return ae.createRun(U);const Y=D.fromPublic($,H,x,N),Ee=v(x);this.proxy.$startedExtensionTestRun({controllerId:$,continuous:!!x.continuous,profile:Ee&&{group:P[Ee.kind],id:Ee.profileId},exclude:x.exclude?.map(Re=>a.TestId.fromExtHostTestItem(Re,H.root.id).toString())??[],id:Y.id,include:x.include?.map(Re=>a.TestId.fromExtHostTestItem(Re,H.root.id).toString())??[H.root.id],persist:N});const ye=this.getTracker(x,Y);return ye.onEnd(()=>{this.proxy.$finishedExtensionTestRun(Y.id),ye.dispose()}),ye.createRun(U)}getTracker($,H,x){const U=new n(H,this.proxy,x);return this.tracked.set($,U),U.onEnd(()=>this.tracked.delete($)),U}}e.TestRunCoordinator=s;const v=z=>{if(z.profile){if(!(z.profile instanceof f))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class D{static fromPublic($,H,x,U){return new D($,(0,c.generateUuid)(),x.include?.map(N=>a.TestId.fromExtHostTestItem(N,$).toString())??[$],x.exclude?.map(N=>a.TestId.fromExtHostTestItem(N,$).toString())??[],U,H)}static fromInternal($,H){return new D($.controllerId,$.runId,$.testIds,$.excludeExtIds,!0,H)}constructor($,H,x,U,N,ae){this.controllerId=$,this.id=H,this.isPersisted=N,this.colllection=ae,this.includePrefix=x.map(Y=>Y+"\0"),this.excludePrefix=U.map(Y=>Y+"\0")}isIncluded($){const H=a.TestId.fromExtHostTestItem($,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(H===x||H.startsWith(x))return!1;for(const x of this.includePrefix)if(H===x||H.startsWith(x))return!0;return!1}}e.TestRunDto=D;class u{set coverageProvider($){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");$&&(this._coverageProvider=$,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor($,H,x){this.proxy=$,this.runId=H,this.taskId=x}async provideFileCoverage($){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage($))());try{return(await this.fileCoverage)?.map(t.TestCoverage.fromFile)??[]}catch(H){throw this.fileCoverage=void 0,H}}async resolveFileCoverage($,H){const x=await this.fileCoverage;let U=x?.[$];return!this._coverageProvider||!x||!U?[]:(U.detailedCoverage||(U=x[$]=await this._coverageProvider.resolveFileCoverage?.(U,H)??U),U.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class m{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor($){this.emitter=$,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add($){this.added.add($)}update($){Object.assign($.revived,t.TestItem.toPlain($.item)),this.added.has($)||this.updated.add($)}remove($){if(this.added.has($)){this.added.delete($);return}this.updated.delete($);const H=a.TestId.parentId($.item.extId);if(H&&this.alreadyRemoved.has(H.toString())){this.alreadyRemoved.add($.item.extId);return}this.removed.add($)}getChangeEvent(){const{added:$,updated:H,removed:x}=this;return{get added(){return[...$].map(U=>U.revived)},get updated(){return[...H].map(U=>U.revived)},get removed(){return[...x].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class b extends C.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById($){return this.items.get($)}getMirroredTestDataByReference($){return this.items.get($.id)}createItem($,H){return{...$,revived:t.TestItem.toPlain($.item),depth:H?H.depth+1:0,children:new Set}}createChangeCollector(){return new m(this.changeEmitter)}}class l{constructor($){this.proxy=$}checkout(){this.current||(this.current=this.createObserverData());const $=this.current;return $.observers++,{onDidChangeTest:$.tests.onDidChangeTests,get tests(){return[...$.tests.rootTests].map(H=>H.revived)},dispose:(0,h.once)(()=>{--$.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference($){return this.current?.tests.getMirroredTestDataByReference($)}applyDiff($){this.current?.tests.apply($)}createObserverData(){const $=new b;return this.proxy.$subscribeToDiffs(),{observers:0,tests:$}}}class f{#e;#t;get label(){return this._label}set label($){$!==this._label&&(this._label=$,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:$}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun($){$!==this._supportsContinuousRun&&(this._supportsContinuousRun=$,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:$}))}get isDefault(){return this._isDefault}set isDefault($){$!==this._isDefault&&(this._isDefault=$,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:$}))}get tag(){return this._tag}set tag($){$?.id!==this._tag?.id&&(this._tag=$,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:$?t.TestTag.namespace(this.controllerId,$.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler($){$!==this._configureHandler&&(this._configureHandler=$,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!$}))}constructor($,H,x,U,N,ae,Y,Ee=!1,ye=void 0,Re=!1){this.controllerId=x,this.profileId=U,this._label=N,this.kind=ae,this.runHandler=Y,this._isDefault=Ee,this._tag=ye,this._supportsContinuousRun=Re,this.#e=$,this.#t=H,H.set(U,this);const K=P[ae];if(typeof K!="number")throw new Error(`Unknown TestRunProfile.group ${ae}`);this.#e.$publishTestRunProfile({profileId:U,controllerId:x,tag:ye?t.TestTag.namespace(this.controllerId,ye.id):null,label:N,group:K,isDefault:Ee,hasConfigurationHandler:!1,supportsContinuousRun:Re})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=f;const P={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Pe[249],Ae([1,0,18,11,5,4,105,8,7]),function(pe,e,w,O,I,M,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class p{constructor(_,c){this._extHostDocumentsAndEditors=c,this._onDidChangeTextEditorSelection=new I.Emitter({onListenerError:O.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new I.Emitter({onListenerError:O.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new I.Emitter({onListenerError:O.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new I.Emitter({onListenerError:O.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new I.Emitter({onListenerError:O.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new I.Emitter({onListenerError:O.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=_.getProxy(M.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(S=>this._onDidChangeVisibleTextEditors.fire(S)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(S=>this._onDidChangeActiveTextEditor.fire(S))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(_){const c=this._extHostDocumentsAndEditors.allEditors();return _?c:c.map(S=>S.value)}async showTextDocument(_,c,S){let E;typeof c=="number"?E={position:h.ViewColumn.from(c),preserveFocus:S}:typeof c=="object"?E={position:h.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selection:typeof c.selection=="object"?h.Range.from(c.selection):void 0,pinned:typeof c.preview=="boolean"?!c.preview:void 0}:E={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(_.uri,E),t=o&&this._extHostDocumentsAndEditors.getEditor(o);if(t)return t.value;throw o?new Error(`Could NOT open editor for "${_.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${_.uri.toString()}".`)}createTextEditorDecorationType(_,c){return new T.TextEditorDecorationType(this._proxy,_,c).value}$acceptEditorPropertiesChanged(_,c){const S=this._extHostDocumentsAndEditors.getEditor(_);if(!S)throw new Error("unknown text editor");if(c.options&&S._acceptOptions(c.options),c.selections){const E=c.selections.selections.map(h.Selection.to);S._acceptSelections(E)}if(c.visibleRanges){const E=w.coalesce(c.visibleRanges.map(h.Range.to));S._acceptVisibleRanges(E)}if(c.options&&this._onDidChangeTextEditorOptions.fire({textEditor:S.value,options:{...c.options,lineNumbers:h.TextEditorLineNumbersStyle.to(c.options.lineNumbers)}}),c.selections){const E=y.TextEditorSelectionChangeKind.fromValue(c.selections.source),o=c.selections.selections.map(h.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:S.value,selections:o,kind:E})}if(c.visibleRanges){const E=w.coalesce(c.visibleRanges.map(h.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:S.value,visibleRanges:E})}}$acceptEditorPositionData(_){for(const c in _){const S=this._extHostDocumentsAndEditors.getEditor(c);if(!S)throw new Error("Unknown text editor");const E=h.ViewColumn.to(_[c]);S.value.viewColumn!==E&&(S._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:S.value,viewColumn:E}))}}getDiffInformation(_){return Promise.resolve(this._proxy.$getDiffInformation(_))}}e.ExtHostEditors=p}),define(Pe[250],Ae([1,0,2,3,4,6,7,8,21,12]),function(pe,e,w,O,I,M,T,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,O.createDecorator)("IExtHostTimeline");class A{constructor(S,E){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=S.getProxy(I.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:(o,t)=>{if(o&&o.$mid===12)if(this._providers.get(o.source)&&y.ExtensionIdentifier.equals(t,this._providers.get(o.source)?.extension)){const i=o.uri===void 0?void 0:w.URI.revive(o.uri);return this._itemsBySourceAndUriMap.get(o.source)?.get(_(i))?.get(o.handle)}else return;return o}})}async $getTimeline(S,E,o,t){return this._providers.get(S)?.provider.provideTimeline(w.URI.revive(E),o,t)}registerTimelineProvider(S,E,o,t){const i=new M.DisposableStore,a=this.convertTimelineItem(E.id,t,i).bind(this);let g;E.onDidChange&&(g=E.onDidChange(k=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...k,id:E.id}),this));const C=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...E,scheme:S,onDidChange:void 0,async provideTimeline(k,r,d){r?.resetCache&&(i.clear(),C.get(E.id)?.clear());const n=await E.provideTimeline(k,r,d);if(n==null)return;const s=a(k,r);return{...n,source:E.id,items:n.items.map(s)}},dispose(){for(const k of C.values())k.get(E.id)?.clear();g?.dispose(),i.dispose()}},o)}convertTimelineItem(S,E,o){return(t,i)=>{let a;if(i?.cacheResults){let g=this._itemsBySourceAndUriMap.get(S);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(S,g));const C=_(t);a=g.get(C),a===void 0&&(a=new Map,g.set(C,a))}return g=>{const{iconPath:C,...k}=g,r=`${S}|${g.id??g.timestamp}`;a?.set(r,g);let d,n,s;g.iconPath&&(C instanceof T.ThemeIcon?s={id:C.id,color:C.color}:w.URI.isUri(C)?(d=C,n=C):{light:d,dark:n}=C);let v;return T.MarkdownString.isMarkdownString(k.tooltip)?v=h.MarkdownString.from(k.tooltip):(0,p.isString)(k.tooltip)?v=k.tooltip:T.MarkdownString.isMarkdownString(k.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=h.MarkdownString.from(k.detail)):(0,p.isString)(k.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=k.detail),{...k,id:k.id??void 0,handle:r,source:S,command:g.command?E.toInternal(g.command,o):void 0,icon:d,iconDark:n,themeIcon:s,tooltip:v,accessibilityInformation:g.accessibilityInformation}}}}registerTimelineProviderCore(S,E){if(this._providers.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this._proxy.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this._providers.set(S.id,{provider:S,extension:E}),(0,M.toDisposable)(()=>{for(const t of this._itemsBySourceAndUriMap.values())t.get(S.id)?.clear();this._providers.delete(S.id),this._proxy.$unregisterTimelineProvider(S.id),S.dispose()})}}e.ExtHostTimeline=A;function _(c){return c?.toString()}}),define(Pe[86],Ae([1,0,20,5,6,157,3,14,185,4,27,17,7]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class S extends y.DisposableTunnel{}var E;(function(t){function i(g){return{remoteAddress:g.remoteAddress,localAddress:g.localAddress,public:!!g.public,privacy:g.privacy??(g.public?y.TunnelPrivacyId.Public:y.TunnelPrivacyId.Private),protocol:g.protocol}}t.fromApiTunnel=i;function a(g){return{remoteAddress:{host:g.tunnelRemoteHost,port:g.tunnelRemotePort},localAddress:g.localAddress,public:g.privacy!==y.TunnelPrivacyId.ConstantPrivate&&g.privacy!==y.TunnelPrivacyId.ConstantPrivate,privacy:g.privacy,protocol:g.protocol}}t.fromServiceTunnel=a})(E||(e.TunnelDtoConverter=E={})),e.IExtHostTunnelService=(0,T.createDecorator)("IExtHostTunnelService");let o=class extends I.Disposable{constructor(i,a,g){super(),this.logService=g,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new O.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=i.getProxy(p.MainContext.MainThreadTunnelService)}async openTunnel(i,a){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${a.remoteAddress.host}:${a.remoteAddress.port}.`);const g=await this._proxy.$openTunnel(a,i.displayName);if(g){const C=new S(g.remoteAddress,g.localAddress,()=>this._proxy.$closeTunnel(g.remoteAddress));return this._register(C),C}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(i,a){const g=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(g,{selector:i,provider:a}),this._proxy.$registerPortsAttributesProvider(i,g),new c.Disposable(()=>{this._portAttributesProviders.delete(g),this._proxy.$unregisterPortsAttributesProvider(g)})}async $providePortAttributes(i,a,g,C,k){const r=[];for(const n of i){const s=this._portAttributesProviders.get(n);if(!s)return[];r.push(...await Promise.all(a.map(async v=>({providedAttributes:await s.provider.providePortAttributes(v,g,C,k),port:v}))))}const d=r.filter(n=>!!n.providedAttributes);return d.length>0?d.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,a){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(C,k)=>await i.provideTunnel(C,k,new w.CancellationTokenSource().token)??void 0;const g=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,privacyOptions:a.tunnelFeatures?.privacyOptions}:void 0;return this._proxy.$setTunnelProvider(g),Promise.resolve((0,I.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(i){if(i){if(i.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this._showCandidatePort=i.showCandidatePort,this._proxy.$setCandidateFilter()),i.tunnelFactory){this._forwardPortProvider=i.tunnelFactory;let a=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const g=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:a}:void 0;this._proxy.$setTunnelProvider(g)}}else this._forwardPortProvider=void 0;return(0,I.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(i,a){if(this._extensionTunnels.has(i.host)){const g=this._extensionTunnels.get(i.host);g.has(i.port)&&(a&&g.get(i.port).disposeListener.dispose(),await g.get(i.port).tunnel.dispose(),g.delete(i.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(i,a){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const g=this._forwardPortProvider(i,a);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),g!==void 0){const C=await g;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),C===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(i.remoteAddress.host)||this._extensionTunnels.set(i.remoteAddress.host,new Map);const k=this._register(C.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(C.remoteAddress))));return this._extensionTunnels.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:C,disposeListener:k}),E.fromApiTunnel(C)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(i){const a=await Promise.all(i.map(C=>this._showCandidatePort(C.host,C.port,C.detail??""))),g=i.filter((C,k)=>a[k]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(C=>C.port).join(", ")} to ${g.map(C=>C.port).join(", ")}`),g}};e.ExtHostTunnelService=o,e.ExtHostTunnelService=o=We([He(0,_.IExtHostRpcService),He(1,A.IExtHostInitDataService),He(2,h.ILogService)],o)}),define(Pe[251],Ae([1,0,6,13,2,4]),function(pe,e,w,O,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{static{this.supportedSchemes=new Set([O.Schemas.http,O.Schemas.https])}constructor(y){this._openers=new Map,this._proxy=y.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,p,A,_){if(this._openers.has(p))throw new Error(`Opener with id '${p}' already registered`);const c=_.schemes.find(S=>!T.supportedSchemes.has(S));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(p,A),this._proxy.$registerUriOpener(p,_.schemes,y,_.label),(0,w.toDisposable)(()=>{this._openers.delete(p),this._proxy.$unregisterUriOpener(p)})}async $canOpenUri(y,p,A){const _=this._openers.get(y);if(!_)throw new Error(`Unknown opener with id: ${y}`);const c=I.URI.revive(p);return _.canOpenExternalUri(c,A)}async $openUri(y,p,A){const _=this._openers.get(y);if(!_)throw new Error(`Unknown opener id: '${y}'`);return _.openExternalUri(I.URI.revive(p.resolvedUri),{sourceUri:I.URI.revive(p.sourceUri)},A)}}e.ExtHostUriOpeners=T}),define(Pe[252],Ae([1,0,4,2,6,11,21]),function(pe,e,w,O,I,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class h{static{this.HandlePool=0}constructor(p){this.handles=new T.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=p.getProxy(w.MainContext.MainThreadUrls)}registerUriHandler(p,A){const _=p.identifier;if(this.handles.has(_))throw new Error(`Protocol handler already registered for extension ${_}`);const c=h.HandlePool++;return this.handles.add(_),this.handlers.set(c,A),this._proxy.$registerUriHandler(c,_,p.displayName||p.name),(0,I.toDisposable)(()=>{this.handles.delete(_),this.handlers.delete(c),this._proxy.$unregisterUriHandler(c)})}$handleExternalUri(p,A){const _=this.handlers.get(p);if(!_)return Promise.resolve(void 0);try{_.handleUri(O.URI.revive(A))}catch(c){(0,M.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(p){return O.URI.revive(await this._proxy.$createAppUri(p))}}e.ExtHostUrls=h}),define(Pe[64],Ae([1,0,5,13,24,2,169,192,77,4]),function(pe,e,w,O,I,M,T,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class A{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;constructor(g,C,k,r,d,n,s){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new w.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new w.Emitter,this._onDidDispose=this.#d.event,this.#e=g,this.#t=C,this.#r=k,this.#u=r,this.#l=d,this.#n=n,this.#c=_(n),this.#h=c(n),this.#i=s}#d;dispose(){this.#o=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return this.#a=!0,(0,y.asWebviewUri)(g,this.#u)}get cspSource(){const g=this.#n.extensionLocation;if(g.scheme===O.Schemas.https||g.scheme===O.Schemas.http){let C=g.toString();return C.endsWith("/")||(C+="/"),C+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#s}set html(g){this.assertNotDisposed(),this.#s!==g&&(this.#s=g,this.#h&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(g)))}get options(){return this.assertNotDisposed(),this.#r}set options(g){this.assertNotDisposed(),I.equals(this.#r,g)||this.#t.$setOptions(this.#e,o(this.#n,this.#l,g)),this.#r=g}async postMessage(g){if(this.#o)return!1;const C=(0,h.serializeWebviewMessage)(g,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,C.message,...C.buffers)}assertNotDisposed(){if(this.#o)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(g){if(!this.#h)return g;const C=this.#n.extensionLocation?.scheme===O.Schemas.vscodeRemote,k=this.#n.extensionLocation.scheme===O.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return g.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,n,s,v,D)=>{const u=M.URI.from({scheme:s||"file",path:decodeURIComponent(v)}),m=(0,y.asWebviewUri)(u,{isRemote:C,authority:k}).toString();return`${d}${m}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,n,s,v,D)=>{const u=M.URI.from({scheme:s||"file",path:decodeURIComponent(v)}),m=(0,y.asWebviewUri)(u,{isRemote:C,authority:k}).toString();return`${d}${m}${D}`})}}e.ExtHostWebview=A;function _(a){try{const g=(0,T.normalizeVersion)((0,T.parseVersion)(a.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=_;function c(a){try{const g=(0,T.normalizeVersion)((0,T.parseVersion)(a.engines.vscode));return g?g.majorBase<1||g.majorBase===1&&g.minorBase<60:!1}catch{return!1}}class S{constructor(g,C,k,r,d){this.remoteInfo=C,this.workspace=k,this._logService=r,this._deprecationService=d,this._webviews=new Map,this._webviewProxy=g.getProxy(p.MainContext.MainThreadWebviews)}$onMessage(g,C,k){const r=this.getWebview(g);if(r){const{message:d}=(0,h.deserializeWebviewMessage)(C,k.value);r._onMessageEmitter.fire(d)}}$onMissingCsp(g,C){this._logService.warn(`${C} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,C,k){const r=new A(g,this._webviewProxy,t(C),this.remoteInfo,this.workspace,k,this._deprecationService);return this._webviews.set(g,r),r._onDidDispose(()=>{this._webviews.delete(g)}),r}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=S;function E(a){return{id:a.identifier,location:a.extensionLocation}}e.toExtensionData=E;function o(a,g,C){return{enableCommandUris:C.enableCommandUris,enableScripts:C.enableScripts,enableForms:C.enableForms,portMapping:C.portMapping,localResourceRoots:C.localResourceRoots||i(a,g)}}e.serializeWebviewOptions=o;function t(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(g=>M.URI.from(g))}}function i(a,g){return[...(g?.getWorkspaceFolders()||[]).map(C=>C.uri),a.extensionLocation]}}),define(Pe[253],Ae([1,0,20,93,6,13,23,2,8,64,55,4,7]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class S{constructor(d,n){this.document=d,this._storagePath=n,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(d){return this._edits.add([d])}async undo(d,n){await this.getEdit(d).undo(),n||this.disposeBackup()}async redo(d,n){await this.getEdit(d).redo(),n||this.disposeBackup()}disposeEdits(d){for(const n of d)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const d=k(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,d)}updateBackup(d){this._backup?.delete(),this._backup=d}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(d){const n=this._edits.get(d,0);if(!n)throw new Error("No edit found");return n}}class E{constructor(){this._documents=new Map}get(d,n){return this._documents.get(this.key(d,n))}add(d,n,s){const v=this.key(d,n.uri);if(this._documents.has(v))throw new Error(`Document already exists for viewType:${d} resource:${n.uri}`);const D=new S(n,s);return this._documents.set(v,D),D}delete(d,n){const s=this.key(d,n.uri);this._documents.delete(s)}key(d,n){return`${d}@@@${n}`}}var o;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(o||(o={}));class t{constructor(){this._providers=new Map}addTextProvider(d,n,s){return this.add(0,d,n,s)}addCustomProvider(d,n,s){return this.add(1,d,n,s)}get(d){return this._providers.get(d)}add(d,n,s,v){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:d,extension:s,provider:v}),new c.Disposable(()=>this._providers.delete(n))}}class i{constructor(d,n,s,v,D){this._extHostDocuments=n,this._extensionStoragePaths=s,this._extHostWebview=v,this._extHostWebviewPanels=D,this._editorProviders=new t,this._documents=new E,this._proxy=d.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(d,n,s,v){const D=new I.DisposableStore;return g(s)?(D.add(this._editorProviders.addTextProvider(n,d,s)),this._proxy.$registerTextEditorProvider((0,p.toExtensionData)(d),n,v.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,p.shouldSerializeBuffersForPostMessage)(d))):(D.add(this._editorProviders.addCustomProvider(n,d,s)),a(s)&&D.add(s.onDidChangeCustomDocument(u=>{const m=this.getCustomDocumentEntry(n,u.document.uri);if(C(u)){const b=m.addEdit(u);this._proxy.$onDidEdit(u.document.uri,n,b,u.label)}else this._proxy.$onContentChange(u.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,p.toExtensionData)(d),n,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,p.shouldSerializeBuffersForPostMessage)(d))),c.Disposable.from(D,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(d,n,s,v,D){const u=this._editorProviders.get(n);if(!u)throw new Error(`No provider found for '${n}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${n}'`);const m=h.URI.revive(d),b=await u.provider.openCustomDocument(m,{backupId:s,untitledDocumentData:v?.buffer},D);let l;return a(u.provider)&&this._extensionStoragePaths&&(l=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension)),this._documents.add(n,b,l),{editable:a(u.provider)}}async $disposeCustomDocument(d,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const v=h.URI.revive(d),{document:D}=this.getCustomDocumentEntry(n,v);this._documents.delete(n,D),D.dispose()}async $resolveCustomEditor(d,n,s,v,D,u){const m=this._editorProviders.get(s);if(!m)throw new Error(`No provider found for '${s}'`);const b=y.ViewColumn.to(D),l=this._extHostWebview.createNewWebview(n,v.contentOptions,m.extension),f=this._extHostWebviewPanels.createNewWebviewPanel(n,s,v.title,b,v.options,l,v.active),P=h.URI.revive(d);switch(m.type){case 1:{const{document:z}=this.getCustomDocumentEntry(s,P);return m.provider.resolveCustomEditor(z,f,u)}case 0:{const z=this._extHostDocuments.getDocument(P);return m.provider.resolveCustomTextEditor(z,f,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,n,s){this.getCustomDocumentEntry(n,d).disposeEdits(s)}async $onMoveCustomEditor(d,n,s){const v=this._editorProviders.get(s);if(!v)throw new Error(`No provider found for '${s}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const D=this._extHostWebviewPanels.getWebviewPanel(d);if(!D)throw new Error("No webview found");const u=h.URI.revive(n),m=this._extHostDocuments.getDocument(u);await v.provider.moveCustomTextEditor(m,D,w.CancellationToken.None)}async $undo(d,n,s,v){return this.getCustomDocumentEntry(n,d).undo(s,v)}async $redo(d,n,s,v){return this.getCustomDocumentEntry(n,d).redo(s,v)}async $revert(d,n,s){const v=this.getCustomDocumentEntry(n,d);await this.getCustomEditorProvider(n).revertCustomDocument(v.document,s),v.disposeBackup()}async $onSave(d,n,s){const v=this.getCustomDocumentEntry(n,d);await this.getCustomEditorProvider(n).saveCustomDocument(v.document,s),v.disposeBackup()}async $onSaveAs(d,n,s,v){const D=this.getCustomDocumentEntry(n,d);return this.getCustomEditorProvider(n).saveCustomDocumentAs(D.document,h.URI.revive(s),v)}async $backup(d,n,s){const v=this.getCustomDocumentEntry(n,d),u=await this.getCustomEditorProvider(n).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},s);return v.updateBackup(u),u.id}getCustomDocumentEntry(d,n){const s=this._documents.get(d,h.URI.revive(n));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(d){const s=this._editorProviders.get(d)?.provider;if(!s||!a(s))throw new Error("Custom document is not editable");return s}}e.ExtHostCustomEditors=i;function a(r){return!!r.onDidChangeCustomDocument}function g(r){return typeof r.resolveCustomTextEditor=="function"}function C(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function k(r){const d=r.scheme===M.Schemas.file||r.scheme===M.Schemas.untitled?r.fsPath:r.toString();return(0,O.hash)(d)+""}}),define(Pe[254],Ae([1,0,5,6,2,36,8,64,4,7]),function(pe,e,w,O,I,M,T,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class A extends O.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;#d;constructor(E,o,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#h=this._register(new w.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new w.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=E,this.#t=o,this.#u=t,this.#i=i.viewType,this.#l=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#u.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#u}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#n}set title(E){this.assertNotDisposed(),this.#n!==E&&(this.#n=E,this.#t.$setTitle(this.#e,E))}get iconPath(){return this.assertNotDisposed(),this.#s}set iconPath(E){this.assertNotDisposed(),this.#s!==E&&(this.#s=E,this.#t.$setIconPath(this.#e,I.URI.isUri(E)?{light:E,dark:E}:E))}get options(){return this.#l}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.assertNotDisposed(),this.#a}get visible(){return this.assertNotDisposed(),this.#o}_updateViewState(E){this.#c||(this.active!==E.active||this.visible!==E.visible||this.viewColumn!==E.viewColumn)&&(this.#a=E.active,this.#o=E.visible,this.#r=E.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(E,o){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof E>"u"?void 0:T.ViewColumn.from(E),preserveFocus:!!o})}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}}class _{static newHandle(){return(0,M.generateUuid)()}constructor(E,o,t){this.webviews=o,this.workspace=t,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=E.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(E,o,t,i,a={}){const g=typeof i=="object"?i.viewColumn:i,C={viewColumn:T.ViewColumn.from(g),preserveFocus:typeof i=="object"&&!!i.preserveFocus},k=(0,h.shouldSerializeBuffersForPostMessage)(E),r=_.newHandle();this._proxy.$createWebviewPanel((0,h.toExtensionData)(E),r,o,{title:t,panelOptions:c(a),webviewOptions:(0,h.serializeWebviewOptions)(E,this.workspace,a),serializeBuffersForPostMessage:k},C);const d=this.webviews.createNewWebview(r,a,E);return this.createNewWebviewPanel(r,o,t,g,a,d,!0)}$onDidChangeWebviewPanelViewStates(E){const o=Object.keys(E);o.sort((t,i)=>{const a=E[t],g=E[i];return a.active?1:g.active?-1:+a.visible-+g.visible});for(const t of o){const i=this.getWebviewPanel(t);if(!i)continue;const a=E[t];i._updateViewState({active:a.active,visible:a.visible,viewColumn:T.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(E){this.getWebviewPanel(E)?.dispose(),this._webviewPanels.delete(E),this.webviews.deleteWebview(E)}registerWebviewPanelSerializer(E,o,t){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:t,extension:E}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,h.shouldSerializeBuffersForPostMessage)(E)}),new p.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(E,o,t,i){const a=this._serializers.get(o);if(!a)throw new Error(`No serializer found for '${o}'`);const{serializer:g,extension:C}=a,k=this.webviews.createNewWebview(E,t.webviewOptions,C),r=this.createNewWebviewPanel(E,o,t.title,i,t.panelOptions,k,t.active);await g.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel(E,o,t,i,a,g,C){const k=new A(E,this._proxy,g,{viewType:o,title:t,viewColumn:i,panelOptions:a,active:C});return this._webviewPanels.set(E,k),k}getWebviewPanel(E){return this._webviewPanels.get(E)}}e.ExtHostWebviewPanels=_;function c(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(Pe[255],Ae([1,0,5,6,64,8,4,7]),function(pe,e,w,O,I,M,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class y extends O.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;constructor(_,c,S,E,o,t){super(),this.#l=!1,this.#a=this._register(new w.Emitter),this.onDidChangeVisibility=this.#a.event,this.#c=this._register(new w.Emitter),this.onDidDispose=this.#c.event,this.#i=S,this.#s=E,this.#e=_,this.#t=c,this.#u=o,this.#n=t}dispose(){this.#l||(this.#l=!0,this.#c.fire(),this.#u.dispose(),super.dispose())}#a;#c;get title(){return this.assertNotDisposed(),this.#s}set title(_){this.assertNotDisposed(),this.#s!==_&&(this.#s=_,this.#t.$setWebviewViewTitle(this.#e,_))}get description(){return this.assertNotDisposed(),this.#r}set description(_){this.assertNotDisposed(),this.#r!==_&&(this.#r=_,this.#t.$setWebviewViewDescription(this.#e,_))}get visible(){return this.#n}get webview(){return this.#u}get viewType(){return this.#i}_setVisible(_){_===this.#n||this.#l||(this.#n=_,this.#a.fire())}get badge(){return this.assertNotDisposed(),this.#o}set badge(_){this.assertNotDisposed(),!(_?.value===this.#o?.value&&_?.tooltip===this.#o?.tooltip)&&(this.#o=M.ViewBadge.from(_),this.#t.$setWebviewViewBadge(this.#e,_))}show(_){this.assertNotDisposed(),this.#t.$show(this.#e,!!_)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}}class p{constructor(_,c){this._extHostWebview=c,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(_,c,S,E){if(this._viewProviders.has(c))throw new Error(`View provider for '${c}' already registered`);return this._viewProviders.set(c,{provider:S,extension:_}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(_),c,{retainContextWhenHidden:E?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(_)}),new h.Disposable(()=>{this._viewProviders.delete(c),this._proxy.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(_,c,S,E,o){const t=this._viewProviders.get(c);if(!t)throw new Error(`No view provider found for '${c}'`);const{provider:i,extension:a}=t,g=this._extHostWebview.createNewWebview(_,{},a),C=new y(_,this._proxy,c,S,g,!0);this._webviewViews.set(_,C),await i.resolveWebviewView(C,{state:E},o)}async $onDidChangeWebviewViewVisibility(_,c){this.getWebviewView(_)._setVisible(c)}async $disposeWebviewView(_){const c=this.getWebviewView(_);this._webviewViews.delete(_),c.dispose(),this._extHostWebview.deleteWebview(_)}getWebviewView(_){const c=this._webviewViews.get(_);if(!c)throw new Error("No webview found");return c}}e.ExtHostWebviewViews=p}),define(Pe[108],Ae([1,0,5,4,2,13,15,3,17,26]),function(pe,e,w,O,I,M,T,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class yn{static{this.InitialState={focused:!0,active:!0}}getState(c){const S=this._state;return{get focused(){return S.focused},get active(){return(0,p.checkProposedApiEnabled)(c,"windowActivity"),S.active}}}constructor(c){this._onDidChangeWindowState=new w.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=yn.InitialState,this._proxy=c.getProxy(O.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:S,isActive:E})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",E)})}$onDidChangeWindowFocus(c){this.onDidChangeWindowProperty("focused",c)}$onDidChangeWindowActive(c){this.onDidChangeWindowProperty("active",c)}onDidChangeWindowProperty(c,S){S!==this._state[c]&&(this._state={...this._state,[c]:S},this._onDidChangeWindowState.fire(this._state))}openUri(c,S){let E;if(typeof c=="string"){E=c;try{c=I.URI.parse(c)}catch{return Promise.reject(`Invalid uri - '${c}'`)}}return(0,T.isFalsyOrWhitespace)(c.scheme)?Promise.reject("Invalid scheme - cannot be empty"):c.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${c.scheme}'`):this._proxy.$openUri(c,E,S)}async asExternalUri(c,S){if((0,T.isFalsyOrWhitespace)(c.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(c,S);return I.URI.from(E)}};e.ExtHostWindow=A,e.ExtHostWindow=A=We([He(0,y.IExtHostRpcService)],A),e.IExtHostWindow=(0,h.createDecorator)("IExtHostWindow")}),define(Pe[256],Ae([1,0,223,27,17]),function(pe,e,w,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends w.AbstractExtHostConsoleForwarder{constructor(h,y){super(h,y)}_nativeConsoleLogMessage(h,y,p){y.apply(console,p)}};e.ExtHostConsoleForwarder=M,e.ExtHostConsoleForwarder=M=We([He(0,I.IExtHostRpcService),He(1,O.IExtHostInitDataService)],M)}),define(Pe[257],Ae([1,0,16,25,20,11,5,6,132,216,46]),function(pe,e,w,O,I,M,T,h,y,p,A){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(l,f){try{return JSON.stringify(l,f)}catch{return"null"}}const S="$$ref$$",E={[S]:-1};class o{constructor(f,P){this.jsonString=f,this.referencedBuffers=P}}function t(l,f=null,P=!1){const z=[];return{jsonString:(P?c:JSON.stringify)(l,(H,x)=>{if(typeof x>"u")return E;if(typeof x=="object"){if(x instanceof O.VSBuffer){const U=z.push(x)-1;return{[S]:U}}if(f)return f(H,x)}return x}),referencedBuffers:z}}e.stringifyJsonWithBufferRefs=t;function i(l,f,P){return JSON.parse(l,(z,$)=>{if($){const H=$[S];if(typeof H=="number")return f[H];if(P&&$.$mid===1)return P.transformIncoming($)}return $})}e.parseJsonAndRestoreBufferRefs=i;function a(l,f){return JSON.stringify(l,f)}function g(l){return l?(f,P)=>P&&P.$mid===1?l.transformOutgoing(P):P:null}var C;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));var k;(function(l){l[l.Responsive=0]="Responsive",l[l.Unresponsive=1]="Unresponsive"})(k||(e.ResponsiveState=k={}));const r=()=>{},d=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class s extends h.Disposable{static{_=d}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(f,P=null,z=null){super(),this[_]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=f,this._logger=P,this._uriTransformer=z,this._uriReplacer=g(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let $=0,H=A.ProxyIdentifier.count;$<H;$++)this._locals[$]=null,this._proxies[$]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new w.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage($=>this._receiveOneMessage($))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(f=>{this._pendingRPCReplies[f].resolveErr(M.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(f){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(f){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(f){this._responsiveState!==f&&(this._responsiveState=f,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(f){return this._uriTransformer?(0,y.transformIncomingURIs)(f,this._uriTransformer):f}getProxy(f){const{nid:P,sid:z}=f;return this._proxies[P]||(this._proxies[P]=this._createProxy(P,z)),this._proxies[P]}_createProxy(f,P){const z={get:($,H)=>(typeof H=="string"&&!$[H]&&H.charCodeAt(0)===36&&($[H]=(...x)=>this._remoteCall(f,H,x)),H===n?P:$[H])};return new Proxy(Object.create(null),z)}set(f,P){return this._locals[f.nid]=P,P}assertRegistered(f){for(let P=0,z=f.length;P<z;P++){const $=f[P];if(!this._locals[$.nid])throw new Error(`Missing proxy instance ${$.sid}`)}}_receiveOneMessage(f){if(this._isDisposed)return;const P=f.byteLength,z=v.read(f,0),$=z.readUInt8(),H=z.readUInt32();switch($){case 1:case 2:{let{rpcId:x,method:U,args:N}=u.deserializeRequestJSONArgs(z);this._uriTransformer&&(N=(0,y.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(P,H,x,U,N,$===2);break}case 3:case 4:{let{rpcId:x,method:U,args:N}=u.deserializeRequestMixedArgs(z);this._uriTransformer&&(N=(0,y.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(P,H,x,U,N,$===4);break}case 5:{this._logger?.logIncoming(P,H,0,"ack"),this._onDidReceiveAcknowledge(H);break}case 6:{this._receiveCancel(P,H);break}case 7:{this._receiveReply(P,H,void 0);break}case 9:{let x=u.deserializeReplyOKJSON(z);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(P,H,x);break}case 10:{const x=u.deserializeReplyOKJSONWithBuffers(z,this._uriTransformer);this._receiveReply(P,H,x);break}case 8:{const x=u.deserializeReplyOKVSBuffer(z);this._receiveReply(P,H,x);break}case 11:{let x=u.deserializeReplyErrError(z);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(P,H,x);break}case 12:{this._receiveReplyErr(P,H,void 0);break}default:console.error("received unexpected message"),console.error(f)}}_receiveRequest(f,P,z,$,H,x){this._logger?.logIncoming(f,P,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(z)}.${$}(`,H);const U=String(P);let N,ae;if(x){const Ee=new I.CancellationTokenSource;H.push(Ee.token),N=this._invokeHandler(z,$,H),ae=()=>Ee.cancel()}else N=this._invokeHandler(z,$,H),ae=r;this._cancelInvokedHandlers[U]=ae;const Y=u.serializeAcknowledged(P);this._logger?.logOutgoing(Y.byteLength,P,1,"ack"),this._protocol.send(Y),N.then(Ee=>{delete this._cancelInvokedHandlers[U];const ye=u.serializeReplyOK(P,Ee,this._uriReplacer);this._logger?.logOutgoing(ye.byteLength,P,1,"reply:",Ee),this._protocol.send(ye)},Ee=>{delete this._cancelInvokedHandlers[U];const ye=u.serializeReplyErr(P,Ee);this._logger?.logOutgoing(ye.byteLength,P,1,"replyErr:",Ee),this._protocol.send(ye)})}_receiveCancel(f,P){this._logger?.logIncoming(f,P,1,"receiveCancel");const z=String(P);this._cancelInvokedHandlers[z]?.()}_receiveReply(f,P,z){this._logger?.logIncoming(f,P,0,"receiveReply:",z);const $=String(P);if(!this._pendingRPCReplies.hasOwnProperty($))return;const H=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$],H.resolveOk(z)}_receiveReplyErr(f,P,z){this._logger?.logIncoming(f,P,0,"receiveReplyErr:",z);const $=String(P);if(!this._pendingRPCReplies.hasOwnProperty($))return;const H=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$];let x;z&&(z.$isError?(x=new Error,x.name=z.name,x.message=z.message,x.stack=z.stack):x=z),H.resolveErr(x)}_invokeHandler(f,P,z){try{return Promise.resolve(this._doInvokeHandler(f,P,z))}catch($){return Promise.reject($)}}_doInvokeHandler(f,P,z){const $=this._locals[f];if(!$)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(f));const H=$[P];if(typeof H!="function")throw new Error("Unknown method "+P+" on actor "+(0,A.getStringIdentifierForProxy)(f));return H.apply($,z)}_remoteCall(f,P,z){if(this._isDisposed)return new p.CanceledLazyPromise;let $=null;if(z.length>0&&I.CancellationToken.isCancellationToken(z[z.length-1])&&($=z.pop()),$&&$.isCancellationRequested)return Promise.reject(M.canceled());const H=u.serializeRequestArguments(z,this._uriReplacer),x=++this._lastMessageId,U=String(x),N=new p.LazyPromise;$&&$.onCancellationRequested(()=>{const Y=u.serializeCancel(x);this._logger?.logOutgoing(Y.byteLength,x,0,"cancel"),this._protocol.send(u.serializeCancel(x))}),this._pendingRPCReplies[U]=N,this._onWillSendRequest(x);const ae=u.serializeRequest(x,f,P,H,!!$);return this._logger?.logOutgoing(ae.byteLength,x,0,`request: ${(0,A.getStringIdentifierForProxy)(f)}.${P}(`,z),this._protocol.send(ae),N}}e.RPCProtocol=s;class v{static alloc(f,P,z){const $=new v(O.VSBuffer.alloc(z+1+4),0);return $.writeUInt8(f),$.writeUInt32(P),$}static read(f,P){return new v(f,P)}get buffer(){return this._buff}constructor(f,P){this._buff=f,this._offset=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(f){this._buff.writeUInt8(f,this._offset),this._offset+=1}readUInt8(){const f=this._buff.readUInt8(this._offset);return this._offset+=1,f}writeUInt32(f){this._buff.writeUInt32BE(f,this._offset),this._offset+=4}readUInt32(){const f=this._buff.readUInt32BE(this._offset);return this._offset+=4,f}static sizeShortString(f){return 1+f.byteLength}writeShortString(f){this._buff.writeUInt8(f.byteLength,this._offset),this._offset+=1,this._buff.set(f,this._offset),this._offset+=f.byteLength}readShortString(){const f=this._buff.readUInt8(this._offset);this._offset+=1;const z=this._buff.slice(this._offset,this._offset+f).toString();return this._offset+=f,z}static sizeLongString(f){return 4+f.byteLength}writeLongString(f){this._buff.writeUInt32BE(f.byteLength,this._offset),this._offset+=4,this._buff.set(f,this._offset),this._offset+=f.byteLength}readLongString(){const f=this._buff.readUInt32BE(this._offset);this._offset+=4;const z=this._buff.slice(this._offset,this._offset+f).toString();return this._offset+=f,z}writeBuffer(f){this._buff.writeUInt32BE(f.byteLength,this._offset),this._offset+=4,this._buff.set(f,this._offset),this._offset+=f.byteLength}static sizeVSBuffer(f){return 4+f.byteLength}writeVSBuffer(f){this._buff.writeUInt32BE(f.byteLength,this._offset),this._offset+=4,this._buff.set(f,this._offset),this._offset+=f.byteLength}readVSBuffer(){const f=this._buff.readUInt32BE(this._offset);this._offset+=4;const P=this._buff.slice(this._offset,this._offset+f);return this._offset+=f,P}static sizeMixedArray(f){let P=0;P+=1;for(let z=0,$=f.length;z<$;z++){const H=f[z];switch(P+=1,H.type){case 1:P+=this.sizeLongString(H.value);break;case 2:P+=this.sizeVSBuffer(H.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(H.value);for(let x=0;x<H.buffers.length;++x)P+=this.sizeVSBuffer(H.buffers[x]);break;case 4:break}}return P}writeMixedArray(f){this._buff.writeUInt8(f.length,this._offset),this._offset+=1;for(let P=0,z=f.length;P<z;P++){const $=f[P];switch($.type){case 1:this.writeUInt8(1),this.writeLongString($.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer($.value);break;case 3:this.writeUInt8(3),this.writeUInt32($.buffers.length),this.writeLongString($.value);for(let H=0;H<$.buffers.length;++H)this.writeBuffer($.buffers[H]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const f=this._buff.readUInt8(this._offset);this._offset+=1;const P=new Array(f);for(let z=0;z<f;z++)switch(this.readUInt8()){case 1:P[z]=this.readLongString();break;case 2:P[z]=this.readVSBuffer();break;case 3:{const H=this.readUInt32(),x=this.readLongString(),U=[];for(let N=0;N<H;++N)U.push(this.readVSBuffer());P[z]=new A.SerializableObjectWithBuffers(i(x,U,null));break}case 4:P[z]=void 0;break}return P}}var D;(function(l){l[l.Simple=0]="Simple",l[l.Mixed=1]="Mixed"})(D||(D={}));class u{static _useMixedArgSerialization(f){for(let P=0,z=f.length;P<z;P++)if(f[P]instanceof O.VSBuffer||f[P]instanceof A.SerializableObjectWithBuffers||typeof f[P]>"u")return!0;return!1}static serializeRequestArguments(f,P){if(this._useMixedArgSerialization(f)){const z=[];for(let $=0,H=f.length;$<H;$++){const x=f[$];if(x instanceof O.VSBuffer)z[$]={type:2,value:x};else if(typeof x>"u")z[$]={type:4};else if(x instanceof A.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:N}=t(x.value,P);z[$]={type:3,value:O.VSBuffer.fromString(U),buffers:N}}else z[$]={type:1,value:O.VSBuffer.fromString(a(x,P))}}return{type:1,args:z}}return{type:0,args:a(f,P)}}static serializeRequest(f,P,z,$,H){switch($.type){case 0:return this._requestJSONArgs(f,P,z,$.args,H);case 1:return this._requestMixedArgs(f,P,z,$.args,H)}}static _requestJSONArgs(f,P,z,$,H){const x=O.VSBuffer.fromString(z),U=O.VSBuffer.fromString($);let N=0;N+=v.sizeUInt8(),N+=v.sizeShortString(x),N+=v.sizeLongString(U);const ae=v.alloc(H?2:1,f,N);return ae.writeUInt8(P),ae.writeShortString(x),ae.writeLongString(U),ae.buffer}static deserializeRequestJSONArgs(f){const P=f.readUInt8(),z=f.readShortString(),$=f.readLongString();return{rpcId:P,method:z,args:JSON.parse($)}}static _requestMixedArgs(f,P,z,$,H){const x=O.VSBuffer.fromString(z);let U=0;U+=v.sizeUInt8(),U+=v.sizeShortString(x),U+=v.sizeMixedArray($);const N=v.alloc(H?4:3,f,U);return N.writeUInt8(P),N.writeShortString(x),N.writeMixedArray($),N.buffer}static deserializeRequestMixedArgs(f){const P=f.readUInt8(),z=f.readShortString(),$=f.readMixedArray(),H=new Array($.length);for(let x=0,U=$.length;x<U;x++){const N=$[x];typeof N=="string"?H[x]=JSON.parse(N):H[x]=N}return{rpcId:P,method:z,args:H}}static serializeAcknowledged(f){return v.alloc(5,f,0).buffer}static serializeCancel(f){return v.alloc(6,f,0).buffer}static serializeReplyOK(f,P,z){if(typeof P>"u")return this._serializeReplyOKEmpty(f);if(P instanceof O.VSBuffer)return this._serializeReplyOKVSBuffer(f,P);if(P instanceof A.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:H}=t(P.value,z,!0);return this._serializeReplyOKJSONWithBuffers(f,$,H)}else return this._serializeReplyOKJSON(f,c(P,z))}static _serializeReplyOKEmpty(f){return v.alloc(7,f,0).buffer}static _serializeReplyOKVSBuffer(f,P){let z=0;z+=v.sizeVSBuffer(P);const $=v.alloc(8,f,z);return $.writeVSBuffer(P),$.buffer}static deserializeReplyOKVSBuffer(f){return f.readVSBuffer()}static _serializeReplyOKJSON(f,P){const z=O.VSBuffer.fromString(P);let $=0;$+=v.sizeLongString(z);const H=v.alloc(9,f,$);return H.writeLongString(z),H.buffer}static _serializeReplyOKJSONWithBuffers(f,P,z){const $=O.VSBuffer.fromString(P);let H=0;H+=v.sizeUInt32,H+=v.sizeLongString($);for(const U of z)H+=v.sizeVSBuffer(U);const x=v.alloc(10,f,H);x.writeUInt32(z.length),x.writeLongString($);for(const U of z)x.writeBuffer(U);return x.buffer}static deserializeReplyOKJSON(f){const P=f.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(f,P){const z=f.readUInt32(),$=f.readLongString(),H=[];for(let x=0;x<z;++x)H.push(f.readVSBuffer());return new A.SerializableObjectWithBuffers(i($,H,P))}static serializeReplyErr(f,P){const z=P?c(M.transformErrorForSerialization(P),null):void 0;if(typeof z!="string")return this._serializeReplyErrEmpty(f);const $=O.VSBuffer.fromString(z);let H=0;H+=v.sizeLongString($);const x=v.alloc(11,f,H);return x.writeLongString($),x.buffer}static deserializeReplyErrError(f){const P=f.readLongString();return JSON.parse(P)}static _serializeReplyErrEmpty(f){return v.alloc(12,f,0).buffer}}var m;(function(l){l[l.RequestJSONArgs=1]="RequestJSONArgs",l[l.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",l[l.RequestMixedArgs=3]="RequestMixedArgs",l[l.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",l[l.Acknowledged=5]="Acknowledged",l[l.Cancel=6]="Cancel",l[l.ReplyOKEmpty=7]="ReplyOKEmpty",l[l.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",l[l.ReplyOKJSON=9]="ReplyOKJSON",l[l.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",l[l.ReplyErrError=11]="ReplyErrError",l[l.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var b;(function(l){l[l.String=1]="String",l[l.VSBuffer=2]="VSBuffer",l[l.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",l[l.Undefined=4]="Undefined"})(b||(b={}))}),define(Pe[258],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const w=function(M){const T=h=>{globalThis.removeEventListener("message",T);const y=h.data;Object.defineProperties(globalThis,{postMessage:{value(p,A){y.postMessage(p,A)}},onmessage:{get(){return y.onmessage},set(p){y.onmessage=p}}}),y.addEventListener("message",p=>{globalThis.dispatchEvent(new MessageEvent("message",{data:p.data,ports:p.ports?[...p.ports]:void 0}))}),y.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",T)}.toString();class O extends EventTarget{constructor(M,T,h){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${w})('${T}'))`,p=new Blob([y],{type:"application/javascript"}),A=URL.createObjectURL(p),_=new MessageChannel,c=A,S={type:"_newWorker",id:c,port:_.port2,url:A,options:h};M(S,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{M({type:"_terminateWorker",id:c}),URL.revokeObjectURL(A),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(E){_.port1.onmessage=E}},onmessageerror:{get(){return _.port1.onmessageerror},set(E){_.port1.onmessageerror=E}}}),_.port1.addEventListener("messageerror",E=>{const o=new MessageEvent("messageerror",{data:E.data});this.dispatchEvent(o)}),_.port1.addEventListener("message",E=>{const o=new MessageEvent("message",{data:E.data});this.dispatchEvent(o)}),_.port1.start()}}e.NestedWorker=O}),define(Pe[259],Ae([1,0,5,30,31,3]),function(pe,e,w,O,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)("outputService");var T;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class h{constructor(){this.channels=new Map,this._onDidRegisterChannel=new w.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new w.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(p){this.channels.has(p.id)||(this.channels.set(p.id,p),this._onDidRegisterChannel.fire(p.id))}getChannels(){const p=[];return this.channels.forEach(A=>p.push(A)),p}getChannel(p){return this.channels.get(p)}removeChannel(p){this.channels.delete(p),this._onDidRemoveChannel.fire(p)}}O.Registry.add(e.Extensions.OutputChannels,new h),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new I.RawContextKey("activeOutputChannel","")}),define(Pe[109],Ae([1,0,4,3,17,21,14,259,62,27,39,129,25,12,38,5,6]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class i extends T.AbstractMessageLogger{get disposed(){return this._disposed}constructor(k,r,d,n,s){super(),this.id=k,this.name=r,this.logger=d,this.proxy=n,this.extension=s,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(d.getLevel()),this._register(d.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(k){this.append(k+`
`)}append(k){this.info(k)}clear(){const k=this.offset;this.logger.flush(),this.proxy.$update(this.id,h.OutputChannelUpdateMode.Clear,k)}replace(k){const r=this.offset;this.info(k),this.proxy.$update(this.id,h.OutputChannelUpdateMode.Replace,r),this.visible&&this.logger.flush()}show(k,r){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof k=="boolean"?k:r))}hide(){this.proxy.$close(this.id)}log(k,r){this.offset+=c.VSBuffer.fromString(r).byteLength,(0,T.log)(this.logger,k,r),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,h.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class a extends i{appendLine(k){this.append(k)}}let g=class{constructor(k,r,d,n,s,v){this.initData=r,this.extHostFileSystem=d,this.extHostFileSystemInfo=n,this.loggerService=s,this.logService=v,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=k.getProxy(w.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(r.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(k){this.visibleChannelId=k;for(const[r,d]of this.channels)d.visible=r===this.visibleChannelId}createOutputChannel(k,r,d){if(k=k.trim(),!k)throw new Error("illegal argument `name`. must not be falsy");const n=typeof r=="object"&&r.log,s=(0,S.isString)(r)?r:void 0;if((0,S.isString)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const D=this.initData.environment.extensionLogLevel?.find(([m])=>M.ExtensionIdentifier.equals(d.identifier,m))?.[1];D&&(v=(0,T.parseLogLevel)(D));const u=n?this.doCreateLogOutputChannel(k,v,d):this.doCreateOutputChannel(k,s,d);return u.then(m=>{this.channels.set(m.id,m),m.visible=m.id===this.visibleChannelId}),n?this.createExtHostLogOutputChannel(k,v??this.logService.getLevel(),u):this.createExtHostOutputChannel(k,u)}async doCreateOutputChannel(k,r,d){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const n=await this.outputDirectoryPromise,s=this.extHostFileSystemInfo.extUri.joinPath(n,`${this.namePool++}-${k.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.loggerService.createLogger(s,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),D=await this.proxy.$register(k,s,r,d.identifier.value);return new i(D,k,v,this.proxy,d)}async doCreateLogOutputChannel(k,r,d){const n=await this.createExtensionLogDirectory(d),s=k.replace(/[\\/:\*\?"<>\|]/g,""),v=this.extHostFileSystemInfo.extUri.joinPath(n,`${s}.log`),D=`${d.identifier.value}.${s}`,u=this.loggerService.createLogger(v,{id:D,name:k,logLevel:r,extensionId:d.identifier.value});return new a(D,k,u,this.proxy,d)}createExtensionLogDirectory(k){let r=this.extensionLogDirectoryPromise.get(k.identifier.value);if(!r){const d=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,k.identifier.value);this.extensionLogDirectoryPromise.set(k.identifier.value,r=(async()=>{try{await this.extHostFileSystem.value.createDirectory(d)}catch(n){if((0,E.toFileSystemProviderErrorCode)(n)!==E.FileSystemProviderErrorCode.FileExists)throw n}return d})())}return r}createExtHostOutputChannel(k,r){let d=!1;const n=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return k},append(s){n(),r.then(v=>v.append(s))},appendLine(s){n(),r.then(v=>v.appendLine(s))},clear(){n(),r.then(s=>s.clear())},replace(s){n(),r.then(v=>v.replace(s))},show(s,v){n(),r.then(D=>D.show(s,v))},hide(){n(),r.then(s=>s.hide())},dispose(){d=!0,r.then(s=>s.dispose())}}}createExtHostLogOutputChannel(k,r,d){const n=new t.DisposableStore,s=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},v=n.add(new o.Emitter);function D(u){r=u,v.fire(u)}return d.then(u=>{n.add(u),u.logLevel!==r&&D(u.logLevel),n.add(u.onDidChangeLogLevel(m=>D(m)))}),{...this.createExtHostOutputChannel(k,d),get logLevel(){return r},onDidChangeLogLevel:v.event,trace(u,...m){s(),d.then(b=>b.trace(u,...m))},debug(u,...m){s(),d.then(b=>b.debug(u,...m))},info(u,...m){s(),d.then(b=>b.info(u,...m))},warn(u,...m){s(),d.then(b=>b.warn(u,...m))},error(u,...m){s(),d.then(b=>b.error(u,...m))},dispose(){n.dispose()}}}};e.ExtHostOutputService=g,e.ExtHostOutputService=g=We([He(0,I.IExtHostRpcService),He(1,p.IExtHostInitDataService),He(2,y.IExtHostConsumerFileSystem),He(3,A.IExtHostFileSystemInfo),He(4,T.ILoggerService),He(5,T.ILogService)],g),e.IExtHostOutputService=(0,O.createDecorator)("IExtHostOutputService")}),define(Pe[260],Ae([1,0,3,16]),function(pe,e,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,w.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let M=1/0;for(let h=0;h<this.maxSampleCount;h++){const y=await I.getRoundTripTime();if(y===void 0)return;M=Math.min(M,y/2),await(0,O.timeout)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(M):T=this.initial.reduce((h,y)=>h+y,0)/this.initial.length,this.lastMeasurement={initial:T,current:M,average:this.average.reduce((h,y)=>h+y,0)/this.average.length,high:(()=>typeof T>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>T*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[261],Ae([1,0,42,13,19,22,23,2,3,187,54,209,260]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let S=class Dn{constructor(o,t,i,a){this.localUserHome=o,this.remoteAgentService=t,this.environmentService=i,this.contextService=a,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||M.OS)(),this.resolveUserHome=(async()=>{const g=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=g?.userHome??o})()}hasValidBasename(o,t,i){return typeof t=="string"||typeof t>"u"?this.resolveOS.then(a=>this.doHasValidBasename(o,a,t)):this.doHasValidBasename(o,t,i)}doHasValidBasename(o,t,i){return o.scheme===O.Schemas.file||o.scheme===O.Schemas.vscodeRemote?(0,w.isValidBasename)(i??(0,T.basename)(o),t===1):!0}get defaultUriScheme(){return Dn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(o,t){if(o.remoteAuthority)return O.Schemas.vscodeRemote;const i=(0,p.getVirtualWorkspaceScheme)(t.getWorkspace());if(i)return i;const a=t.getWorkspace().folders[0];if(a)return a.uri.scheme;const g=t.getWorkspace().configuration;return g?g.scheme:O.Schemas.file}userHome(o){return o?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(o=>o===1?I.win32:I.posix)}async fileURI(o){let t="";if(await this.resolveOS===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const a=o.indexOf("/",2);a===-1?(t=o.substring(2),o="/"):(t=o.substring(2,a),o=o.substring(a)||"/")}return h.URI.from({scheme:O.Schemas.file,authority:t,path:o,query:"",fragment:""})}};e.AbstractPathService=S,e.AbstractPathService=S=We([He(1,c.IRemoteAgentService),He(2,_.IWorkbenchEnvironmentService),He(3,A.IWorkspaceContextService)],S)}),define(Pe[110],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class w{constructor(T,h){this.line=T,this.character=h}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,h){return new w(0,0)}with(T){return new w(0,0)}}e.Position=w;class O{constructor(T,h,y,p){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(T,h),this.end=new w(y,p)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new O(0,0,0,0)}with(T){return new O(0,0,0,0)}}e.Range=O;var I;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Pe[47],Ae([1,0,18,37,24,42,15,3,19,11,110,16]),function(pe,e,w,O,I,M,T,h,y,p,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",S=" characters skipped \u27EB",E=(c.length+S.length+5)*2;e.ISearchService=(0,h.createDecorator)("searchService");var o;(function(K){K[K.file=0]="file",K[K.text=1]="text"})(o||(e.SearchProviderType=o={}));var t;(function(K){K[K.File=1]="File",K[K.Text=2]="Text"})(t||(e.QueryType=t={}));function i(K){return!!K.preview}e.resultIsMatch=i;function a(K){return!!K.resource}e.isFileMatch=a;function g(K){return!!K.message}e.isProgressMessage=g;var C;(function(K){K[K.Normal=0]="Normal",K[K.NewSearchStarted=1]="NewSearchStarted"})(C||(e.SearchCompletionExitCode=C={}));class k{constructor(Q){this.resource=Q,this.results=[]}}e.FileMatch=k;class r{constructor(Q,ue,ne,he){this.ranges=ue,this.webviewIndex=he;const le=Array.isArray(ue)?ue:[ue];if(ne&&ne.matchLines===1&&d(le)){Q=(0,T.getNLines)(Q,ne.matchLines);let F="",J=0,Se=0;const ke=Math.floor(ne.charsPerLine/5),Ce=[];for(const _e of le){const Ie=Math.max(_e.startColumn-ke,0),se=_e.startColumn+ne.charsPerLine;if(Ie>Se+ke+E){const fe=c+(Ie-Se)+S;F+=fe+Q.slice(Ie,se),J+=Ie-(Se+fe.length)}else F+=Q.slice(Se,se);Ce.push(new s(0,_e.startColumn-J,_e.endColumn-J)),Se=se}this.preview={text:F,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const F=Array.isArray(ue)?ue[0].startLineNumber:ue.startLineNumber;this.preview={text:Q,matches:(0,w.mapArrayOrNot)(ue,J=>new n(J.startLineNumber-F,J.startColumn,J.endLineNumber-F,J.endColumn))}}}}e.TextSearchMatch=r;function d(K){const Q=K[0].startLineNumber;for(const ue of K)if(ue.startLineNumber!==Q||ue.endLineNumber!==Q)return!1;return!0}class n{constructor(Q,ue,ne,he){this.startLineNumber=Q,this.startColumn=ue,this.endLineNumber=ne,this.endColumn=he}}e.SearchRange=n;class s extends n{constructor(Q,ue,ne){super(Q,ue,Q,ne)}}e.OneLineRange=s;var v;(function(K){K.List="list",K.Tree="tree"})(v||(e.ViewMode=v={}));var D;(function(K){K.Default="default",K.FileNames="fileNames",K.Type="type",K.Modified="modified",K.CountDescending="countDescending",K.CountAscending="countAscending"})(D||(e.SearchSortOrder=D={}));function u(K,Q=!0){const ue=K&&K.files&&K.files.exclude,ne=Q&&K&&K.search&&K.search.exclude;if(!ue&&!ne)return;if(!ue||!ne)return ue||ne;let he=Object.create(null);return he=I.mixin(he,I.deepClone(ue)),he=I.mixin(he,I.deepClone(ne),!0),he}e.getExcludes=u;function m(K,Q){return K.excludePattern&&O.match(K.excludePattern,Q)?!1:K.includePattern||K.usingSearchPaths?K.includePattern&&O.match(K.includePattern,Q)?!0:K.usingSearchPaths?!!K.folderQueries&&K.folderQueries.some(ue=>{const ne=ue.folder.fsPath;if(M.isEqualOrParent(Q,ne)){const he=y.relative(ne,Q);return!ue.includePattern||!!O.match(ue.includePattern,he)}else return!1}):!1:!0}e.pathIncludedInQuery=m;var b;(function(K){K[K.unknownEncoding=1]="unknownEncoding",K[K.regexParseError=2]="regexParseError",K[K.globParseError=3]="globParseError",K[K.invalidLiteral=4]="invalidLiteral",K[K.rgProcessError=5]="rgProcessError",K[K.other=6]="other",K[K.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class l extends Error{constructor(Q,ue){super(Q),this.code=ue}}e.SearchError=l;function f(K){const Q=K.message;if((0,p.isCancellationError)(K))return new l(Q,b.canceled);try{const ue=JSON.parse(Q);return new l(ue.message,ue.code)}catch{return new l(Q,b.other)}}e.deserializeSearchError=f;function P(K){const Q={message:K.message,code:K.code};return new Error(JSON.stringify(Q))}e.serializeSearchError=P;function z(K){return K.type==="error"?!0:K.type==="success"}e.isSerializedSearchComplete=z;function $(K){return K.type==="success"}e.isSerializedSearchSuccess=$;function H(K){return!!K.path}e.isSerializedFileMatch=H;function x(K,Q){const ue=K.searchPath?K.searchPath:K.relativePath;return(0,T.fuzzyContains)(ue,Q)}e.isFilePatternMatch=x;class U{constructor(Q){this.path=Q,this.results=[]}addMatch(Q){this.results.push(Q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function N(K,Q){const ue={...K||{},...Q||{}};return Object.keys(ue).filter(ne=>{const he=ue[ne];return typeof he=="boolean"&&he})}e.resolvePatternsForProvider=N;class ae{constructor(Q,ue){this._parsedIncludeExpression=null,this._excludeExpression={...Q.excludePattern||{},...ue.excludePattern||{}},this._parsedExcludeExpression=O.parse(this._excludeExpression);let ne=Q.includePattern;ue.includePattern&&(ne?ne={...ne,...ue.includePattern}:ne=ue.includePattern),ne&&(this._parsedIncludeExpression=O.parse(ne))}matchesExcludesSync(Q,ue,ne){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Q,ue,ne))}includedInQuerySync(Q,ue,ne){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Q,ue,ne)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Q,ue,ne))}includedInQuery(Q,ue,ne){const he=this._parsedExcludeExpression(Q,ue,ne),le=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(Q,ue,ne):!0;return(0,_.isThenable)(he)?he.then(F=>F?!1:le()):le()}hasSiblingExcludeClauses(){return Y(this._excludeExpression)}}e.QueryGlobTester=ae;function Y(K){for(const Q in K)if(typeof K[Q]!="boolean")return!0;return!1}function Ee(K){if(!K)return;let Q;return ue=>(Q||(Q=(K()||Promise.resolve([])).then(ne=>ne?Re(ne):{})),Q.then(ne=>!!ne[ue]))}e.hasSiblingPromiseFn=Ee;function ye(K){if(!K)return;let Q;return ue=>{if(!Q){const ne=K();Q=ne?Re(ne):{}}return!!Q[ue]}}e.hasSiblingFn=ye;function Re(K){const Q={};for(const ue of K)Q[ue]=!0;return Q}}),define(Pe[33],Ae([1,0,18,16,20,5,6,48,13,117,23,15,12,2,158,3,14,175,54,39,27,17,8,7,56,47,4]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t,i,a,g,C,k,r,d,n,s,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function D($,H,x){return new A.ExtUri(U=>l(U,x)).isEqual($,H)}function u($,H,x){return D($.uri,H.uri,x)?0:(0,_.compare)($.uri.toString(),H.uri.toString())}function m($,H,x){return $.index!==H.index?$.index<H.index?-1:1:D($.uri,H.uri,x)?(0,_.compare)($.name,H.name):(0,_.compare)($.uri.toString(),H.uri.toString())}function b($,H,x,U){const N=$.slice(0).sort((Y,Ee)=>x(Y,Ee,U)),ae=H.slice(0).sort((Y,Ee)=>x(Y,Ee,U));return(0,w.delta)(N,ae,(Y,Ee)=>x(Y,Ee,U))}function l($,H){const x=H.getCapabilities($.scheme);return!(x&&x&1024)}class f extends a.Workspace{static toExtHostWorkspace(H,x,U,N){if(!H)return{workspace:null,added:[],removed:[]};const{id:ae,name:Y,folders:Ee,configuration:ye,transient:Re,isUntitled:K}=H,Q=[],ue=x;x?Ee.forEach((F,J)=>{const Se=S.URI.revive(F.uri),ke=f._findFolder(U||x,Se,N);ke?(ke.name=F.name,ke.index=F.index,Q.push(ke)):Q.push({uri:Se,name:F.name,index:J})}):Q.push(...Ee.map(({uri:F,name:J,index:Se})=>({uri:S.URI.revive(F),name:J,index:Se}))),Q.sort((F,J)=>F.index<J.index?-1:1);const ne=new f(ae,Y,Q,!!Re,ye?S.URI.revive(ye):null,!!K,F=>l(F,N)),{added:he,removed:le}=b(ue?ue.workspaceFolders:[],ne.workspaceFolders,u,N);return{workspace:ne,added:he,removed:le}}static _findFolder(H,x,U){for(let N=0;N<H.folders.length;N++){const ae=H.workspaceFolders[N];if(D(ae.uri,x,U))return ae}}constructor(H,x,U,N,ae,Y,Ee){super(H,U.map(ye=>new a.WorkspaceFolder(ye)),N,ae,Ee),this._name=x,this._isUntitled=Y,this._workspaceFolders=[],this._structure=h.TernarySearchTree.forUris(Ee),U.forEach(ye=>{this._workspaceFolders.push(ye),this._structure.set(ye.uri,ye)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(H,x){return x&&this._structure.get(H)&&(H=(0,A.dirname)(H)),this._structure.findSubstr(H)}resolveWorkspaceFolder(H){return this._structure.get(H)}}let P=class{constructor(H,x,U,N,ae){this._onDidChangeWorkspace=new M.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new M.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new M.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=N,this._extHostFileSystemInfo=U,this._uriTransformerService=ae,this._requestIdProvider=new p.Counter,this._barrier=new O.Barrier,this._proxy=H.getProxy(v.MainContext.MainThreadWorkspace),this._messageService=H.getProxy(v.MainContext.MainThreadMessageService);const Y=x.workspace;this._confirmedWorkspace=Y?new f(Y.id,Y.name,[],!!Y.transient,Y.configuration?S.URI.revive(Y.configuration):null,!!Y.isUntitled,Ee=>l(Ee,U)):void 0}$initializeWorkspace(H,x){this._trusted=x,this.$acceptWorkspaceData(H),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?S.URI.from({scheme:y.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(H,x,U,...N){const ae=[];if(Array.isArray(N)&&N.forEach(K=>{S.URI.isUri(K.uri)&&!ae.some(Q=>D(Q.uri,K.uri,this._extHostFileSystemInfo))&&ae.push({uri:K.uri,name:K.name||(0,A.basenameOrAuthority)(K.uri)})}),this._unconfirmedWorkspace||[x,U].some(K=>typeof K!="number"||K<0)||U===0&&ae.length===0)return!1;const Y=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+U>Y.length)return!1;const Ee=Y.slice(0);Ee.splice(x,U,...ae.map(K=>({uri:K.uri,name:K.name||(0,A.basenameOrAuthority)(K.uri),index:void 0})));for(let K=0;K<Ee.length;K++){const Q=Ee[K];if(Ee.some((ue,ne)=>ne!==K&&D(Q.uri,ue.uri,this._extHostFileSystemInfo)))return!1}Ee.forEach((K,Q)=>K.index=Q);const{added:ye,removed:Re}=b(Y,Ee,m,this._extHostFileSystemInfo);if(ye.length===0&&Re.length===0)return!1;if(this._proxy){const K=H.displayName||H.name;this._proxy.$updateWorkspaceFolders(K,x,U,ae).then(void 0,Q=>{this._unconfirmedWorkspace=void 0;const ue={source:{identifier:H.identifier,label:H.displayName||H.name}};this._messageService.$showMessage(i.Severity.Error,(0,E.localize)(0,null,K,Q.toString()),ue,[])})}return this.trySetWorkspaceFolders(Ee),!0}getWorkspaceFolder(H,x){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(H,x)}async getWorkspaceFolder2(H,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(H,x)}async resolveWorkspaceFolder(H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(H)}getPath(){if(!this._actualWorkspace)return;const{folders:H}=this._actualWorkspace;if(H.length!==0)return H[0].uri.fsPath}getRelativePath(H,x){let U,N="";if(typeof H=="string"?(U=S.URI.file(H),N=H):typeof H<"u"&&(U=H,N=H.fsPath),!U)return N;const ae=this.getWorkspaceFolder(U,!0);if(!ae)return N;typeof x>"u"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let Y=(0,A.relativePath)(ae.uri,U);return x&&ae.name&&(Y=`${ae.name}/${Y}`),Y}trySetWorkspaceFolders(H){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:H,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(H){const{workspace:x,added:U,removed:N}=f.toExtHostWorkspace(H,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:U,removed:N}))}findFiles(H,x,U,N,ae=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let Y;if(x===null?Y=!1:x&&(typeof x=="string"?Y=x:Y=x.pattern),ae&&ae.isCancellationRequested)return Promise.resolve([]);const{includePattern:Ee,folder:ye}=z(r.GlobPattern.from(H));return this._proxy.$startFileSearch((0,c.withUndefinedAsNull)(Ee),(0,c.withUndefinedAsNull)(ye),(0,c.withUndefinedAsNull)(Y),(0,c.withUndefinedAsNull)(U),ae).then(Re=>Array.isArray(Re)?Re.map(K=>S.URI.revive(K)):[])}async findTextInFiles(H,x,U,N,ae=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const Y=this._requestIdProvider.getNext(),Ee=typeof x.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:ye,folder:Re}=z(r.GlobPattern.from(x.include)),K=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,Q={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof x.useParentIgnoreFiles=="boolean"?!x.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:Ee,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:ye,excludePattern:K},ue=!1;if(this._activeSearchCallbacks[Y]=ne=>{if(ue)return;const he=S.URI.revive(ne.resource);ne.results.forEach(le=>{(0,s.resultIsMatch)(le)?U({uri:he,preview:{text:le.preview.text,matches:(0,w.mapArrayOrNot)(le.preview.matches,F=>new d.Range(F.startLineNumber,F.startColumn,F.endLineNumber,F.endColumn))},ranges:(0,w.mapArrayOrNot)(le.ranges,F=>new d.Range(F.startLineNumber,F.startColumn,F.endLineNumber,F.endColumn))}):U({uri:he,text:le.text,lineNumber:le.lineNumber})})},ae.isCancellationRequested)return{};try{const ne=await this._proxy.$startTextSearch(H,(0,c.withUndefinedAsNull)(Re),Q,Y,ae);return delete this._activeSearchCallbacks[Y],ne||{}}catch(ne){throw delete this._activeSearchCallbacks[Y],ne}}$handleTextSearchResult(H,x){this._activeSearchCallbacks[x]?.(H)}async save(H){const x=await this._proxy.$save(H,{saveAs:!1});return S.URI.revive(x)}async saveAs(H){const x=await this._proxy.$save(H,{saveAs:!0});return S.URI.revive(x)}saveAll(H){return this._proxy.$saveAll(H)}resolveProxy(H){return this._proxy.$resolveProxy(H)}get trusted(){return this._trusted}requestWorkspaceTrust(H){return this._proxy.$requestWorkspaceTrust(H)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(H,x){if(this._editSessionIdentityProviders.has(H))throw new Error(`A provider has already been registered for scheme ${H}`);this._editSessionIdentityProviders.set(H,x);const U=this._uriTransformerService.transformOutgoingScheme(H),N=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(N,U),(0,T.toDisposable)(()=>{this._editSessionIdentityProviders.delete(H),this._proxy.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(H,x){this._logService.info("Getting edit session identifier for workspaceFolder",H);const U=await this.resolveWorkspaceFolder(S.URI.revive(H));if(!U){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const N=this._editSessionIdentityProviders.get(U.uri.scheme);if(this._logService.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!N),!N)return;const ae=await N.provideEditSessionIdentity(U,x);if(this._logService.info("Provider returned edit session identifier: ",ae),!!ae)return ae}async $provideEditSessionIdentityMatch(H,x,U,N){this._logService.info("Getting edit session identifier for workspaceFolder",H);const ae=await this.resolveWorkspaceFolder(S.URI.revive(H));if(!ae){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",ae);const Y=this._editSessionIdentityProviders.get(ae.uri.scheme);if(this._logService.info(`Provider for scheme ${ae.uri.scheme} is defined: `,!!Y),!Y)return;const Ee=await Y.provideEditSessionIdentityMatch?.(x,U,N);if(this._logService.info("Provider returned edit session identifier match result: ",Ee),!!Ee)return Ee}getOnWillCreateEditSessionIdentityEvent(H){return(x,U,N)=>{const ae=function(Ee){x.call(U,Ee)};return ae.extension=H,this._onWillCreateEditSessionIdentityEvent.event(ae,void 0,N)}}async $onWillCreateEditSessionIdentity(H,x,U){const N=await this.resolveWorkspaceFolder(S.URI.revive(H));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:N},x,async(ae,Y)=>{const Ee=Date.now();await Promise.resolve(ae),Date.now()-Ee>U&&this._logService.warn("SLOW edit session create-participant",Y.extension.identifier)}),x.isCancellationRequested}registerCanonicalUriProvider(H,x){if(this._canonicalUriProviders.has(H))throw new Error(`A provider has already been registered for scheme ${H}`);this._canonicalUriProviders.set(H,x);const U=this._uriTransformerService.transformOutgoingScheme(H),N=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(N,U),(0,T.toDisposable)(()=>{this._canonicalUriProviders.delete(H),this._proxy.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(H,x,U){const N=this._canonicalUriProviders.get(H.scheme);if(!N)return;const ae=await N.provideCanonicalUri?.(S.URI.revive(H),x,U);if(ae)return ae}async $provideCanonicalUri(H,x,U){return this.provideCanonicalUri(S.URI.revive(H),{targetScheme:x},U)}};e.ExtHostWorkspace=P,e.ExtHostWorkspace=P=We([He(0,k.IExtHostRpcService),He(1,C.IExtHostInitDataService),He(2,g.IExtHostFileSystemInfo),He(3,t.ILogService),He(4,n.IURITransformerService)],P),e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function z($){let H,x;return $&&(typeof $=="string"?H=$:(H=$.pattern,x=S.URI.revive($.baseUri))),{includePattern:H,folder:x}}}),define(Pe[34],Ae([1,0,24,5,33,4,7,178,96,12,16,3,17,14,2]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function o(d,n){if(n){const s=n.split(".");let v=d;for(let D=0;v&&D<s.length;D++)v=v[s[D]];return v}}function t(d){return d instanceof E.URI}function i(d){return d&&d.uri instanceof E.URI&&d.languageId&&typeof d.languageId=="string"}function a(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function g(d){return d&&d.uri instanceof E.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function C(d){if(t(d))return{resource:d};if(i(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(a(d))return{overrideIdentifier:d.languageId};if(g(d))return{resource:d.uri};if(d===null)return{resource:null}}let k=class{constructor(n,s,v){this._proxy=n.getProxy(M.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=v,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new r(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,s){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(n,s))}};e.ExtHostConfiguration=k,e.ExtHostConfiguration=k=We([He(0,c.IExtHostRpcService),He(1,I.IExtHostWorkspace),He(2,S.ILogService)],k);class r{constructor(n,s,v,D){this._onDidChangeConfiguration=new O.Emitter,this._proxy=n,this._logService=D,this._extHostWorkspace=s,this._configuration=h.Configuration.parse(v),this._configurationScopes=this._toMap(v.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,s){const v={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=h.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,v))}getConfiguration(n,s,v){const D=C(s)||{},u=this._toReadonlyValue(n?o(this._configuration.getValue(void 0,D,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,D,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,D,v?.identifier);function m(l){if(l==null)return null;if(typeof l=="boolean")return l?2:5;switch(l){case T.ConfigurationTarget.Global:return 2;case T.ConfigurationTarget.Workspace:return 5;case T.ConfigurationTarget.WorkspaceFolder:return 6}}const b={has(l){return typeof o(u,l)<"u"},get:(l,f)=>{this._validateConfigurationAccess(n?`${n}.${l}`:l,D,v?.identifier);let P=o(u,l);if(typeof P>"u")P=f;else{let z;const $=(H,x)=>{if((0,p.isObject)(H)){let U;const N=()=>{z=z||(0,w.deepClone)(u),U=U||o(z,x)};return new Proxy(H,{get:(ae,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return N(),()=>U;if(z)return U=U||o(z,x),U[Y];const Ee=ae[Y];return typeof Y=="string"?$(Ee,`${x}.${Y}`):Ee},set:(ae,Y,Ee)=>(N(),U&&(U[Y]=Ee),!0),deleteProperty:(ae,Y)=>(N(),U&&delete U[Y],!0),defineProperty:(ae,Y,Ee)=>(N(),U&&Object.defineProperty(U,Y,Ee),!0)})}return Array.isArray(H)?(0,w.deepClone)(H):H};P=$(P,l)}return P},update:(l,f,P,z)=>{l=n?`${n}.${l}`:l;const $=m(P);return f!==void 0?this._proxy.$updateConfigurationOption($,l,f,D,z):this._proxy.$removeConfigurationOption($,l,D,z)},inspect:l=>{l=n?`${n}.${l}`:l;const f=this._configuration.inspect(l,D,this._extHostWorkspace.workspace);if(f)return{key:l,defaultValue:(0,w.deepClone)(f.policy?.value??f.default?.value),globalValue:(0,w.deepClone)(f.user?.value??f.application?.value),workspaceValue:(0,w.deepClone)(f.workspace?.value),workspaceFolderValue:(0,w.deepClone)(f.workspaceFolder?.value),defaultLanguageValue:(0,w.deepClone)(f.default?.override),globalLanguageValue:(0,w.deepClone)(f.user?.override??f.application?.override),workspaceLanguageValue:(0,w.deepClone)(f.workspace?.override),workspaceFolderLanguageValue:(0,w.deepClone)(f.workspaceFolder?.override),languageIds:(0,w.deepClone)(f.overrideIdentifiers)}}};return typeof u=="object"&&(0,w.mixin)(b,u,!1),Object.freeze(b)}_toReadonlyValue(n){const s=v=>(0,p.isObject)(v)?new Proxy(v,{get:(D,u)=>s(D[u]),set:(D,u,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(u)}' of object`)},deleteProperty:(D,u)=>{throw new Error(`TypeError: Cannot delete read only property '${String(u)}' of object`)},defineProperty:(D,u)=>{throw new Error(`TypeError: Cannot define property '${String(u)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return s(n)}_validateConfigurationAccess(n,s,v){const D=y.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),u=v?`[${v.value}] `:"";if(D===4){typeof s?.resource>"u"&&this._logService.warn(`${u}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(D===3){s?.resource&&this._logService.warn(`${u}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,s){const v=new h.ConfigurationChangeEvent(n,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(D,u)=>v.affectsConfiguration(D,C(u))})}_toMap(n){return n.reduce((s,v)=>(s.set(v[0],v[1]),s),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")}),define(Pe[111],Ae([1,0,2,16,5,4,7,33,60,34,20,63,17,27,3,13,22,14,80,215,11]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t,i,a,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var k;(function($){function H(U){if(U!=null)return U}$.from=H;function x(U){if(U!=null)return U}$.to=x})(k||(k={}));var r;(function($){function H(U){if(U!=null)return U}$.from=H;function x(U){if(U!=null)return U}$.to=x})(r||(r={}));var d;(function($){function H(U){if(U!=null)return U}$.from=H;function x(U){if(U!=null)return U}$.to=x})(d||(d={}));var n;(function($){function H(N){if(N){const ae=N;return ae&&!!ae.process}else return!1}$.is=H;function x(N){if(N==null)return;const ae={process:N.process,args:N.args};return N.options&&(ae.options=d.from(N.options)),ae}$.from=x;function U(N){if(N!=null)return new T.ProcessExecution(N.process,N.args,N.options)}$.to=U})(n||(n={}));var s;(function($){function H(U){if(U!=null)return U}$.from=H;function x(U){if(U!=null)return U}$.to=x})(s||(s={}));var v;(function($){function H(N){if(N){const ae=N;return ae&&(!!ae.commandLine||!!ae.command)}else return!1}$.is=H;function x(N){if(N==null)return;const ae={};return N.commandLine!==void 0?ae.commandLine=N.commandLine:(ae.command=N.command,ae.args=N.args),N.options&&(ae.options=s.from(N.options)),ae}$.from=x;function U(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new T.ShellExecution(N.commandLine,N.options):new T.ShellExecution(N.command,N.args?N.args:[],N.options)}$.to=U})(v||(v={}));var D;(function($){function H(N){if(N){const ae=N;return ae&&ae.customExecution==="customExecution"}else return!1}$.is=H;function x(N){return{customExecution:"customExecution"}}$.from=x;function U(N,ae){return ae.get(N)}$.to=U})(D||(e.CustomExecutionDTO=D={}));var u;(function($){function H(x,U){let N;return x.scope!==void 0&&typeof x.scope!="number"?N=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===T.TaskScope.Workspace&&U&&U.workspaceFile?N=U.workspaceFile:N=g.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:N}}$.from=H})(u||(e.TaskHandleDTO=u={}));var m;(function($){function H(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}$.from=H})(m||(m={}));var b;(function($){function H(N,ae){if(N==null)return[];const Y=[];for(const Ee of N){const ye=x(Ee,ae);ye&&Y.push(ye)}return Y}$.fromMany=H;function x(N,ae){if(N==null)return;let Y;N.execution instanceof T.ProcessExecution?Y=n.from(N.execution):N.execution instanceof T.ShellExecution?Y=v.from(N.execution):N.execution&&N.execution instanceof T.CustomExecution&&(Y=D.from(N.execution));const Ee=k.from(N.definition);let ye;return N.scope?typeof N.scope=="number"?ye=N.scope:ye=N.scope.uri:ye=T.TaskScope.Workspace,!Ee||!ye?void 0:{_id:N._id,definition:Ee,name:N.name,source:{extensionId:ae.identifier.value,label:N.source,scope:ye},execution:Y,isBackground:N.isBackground,group:m.from(N.group),presentationOptions:r.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}$.from=x;async function U(N,ae,Y){if(N==null)return;let Ee;n.is(N.execution)?Ee=n.to(N.execution):v.is(N.execution)?Ee=v.to(N.execution):D.is(N.execution)&&(Ee=D.to(N._id,Y));const ye=k.to(N.definition);let Re;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Re=N.source.scope:Re=await ae.resolveWorkspaceFolder(w.URI.revive(N.source.scope)):Re=T.TaskScope.Workspace),!ye||!Re)return;const K=new T.Task(ye,Re,N.name,N.source.label,Ee,N.problemMatchers);return N.isBackground!==void 0&&(K.isBackground=N.isBackground),N.group!==void 0&&(K.group=T.TaskGroup.from(N.group._id),K.group&&N.group.isDefault&&(K.group=new T.TaskGroup(K.group.id,K.group.label),N.group.isDefault===!0&&(K.group.isDefault=N.group.isDefault))),N.presentationOptions&&(K.presentationOptions=r.to(N.presentationOptions)),N._id&&(K._id=N._id),N.detail&&(K.detail=N.detail),K}$.to=U})(b||(e.TaskDTO=b={}));var l;(function($){function H(U){return U}$.from=H;function x(U){if(U)return Object.assign(Object.create(null),U)}$.to=x})(l||(l={}));class f{#e;constructor(H,x,U){this._id=x,this._task=U,this.#e=H}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}let P=class{constructor(H,x,U,N,ae,Y,Ee,ye){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=H.getProxy(M.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=N,this._configurationService=ae,this._terminalService=Y,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Ee,this._deprecationService=ye,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,x,U){if(!U)return new T.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:x,provider:U,extension:H}),this._proxy.$registerTaskProvider(N,x),new T.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(H,x){this._proxy.$registerTaskSystem(H,x)}fetchTasks(H){return this._proxy.$fetchTasks(l.from(H)).then(async x=>{const U=[];for(const N of x){const ae=await b.to(N,this._workspaceProvider,this._providedCustomExecutions2);ae&&U.push(ae)}return U})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(x=>H.push(x)),H}terminateTask(H){if(!(H instanceof f))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,x,U){const N=this._providedCustomExecutions2.get(H.id);N&&(this._activeCustomExecutions2.set(H.id,N),this._terminalService.attachPtyToTerminal(x,await N.callback(U))),this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const x=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const x=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:x,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const x=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:H.exitCode})}$provideTasks(H,x){const U=this._handlers.get(H);if(!U)return Promise.reject(new Error("no handler found"));const N=[],ae=(0,O.asPromise)(()=>U.provider.provideTasks(A.CancellationToken.None)).then(Y=>this.provideTasksInternal(x,N,U,Y));return new Promise(Y=>{ae.then(Ee=>{Promise.all(N).then(()=>{Y(Ee)})})})}async $resolveTask(H,x){const U=this._handlers.get(H);if(!U)return Promise.reject(new Error("no handler found"));if(x.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${U.type}].`);const N=await b.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const ae=await U.provider.resolveTask(N,A.CancellationToken.None);if(!ae)return;this.checkDeprecation(ae,U);const Y=b.from(ae,U.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(ae.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return D.is(Y.execution)&&await this.addCustomExecution(Y,ae,!0),await this.resolveTaskInternal(Y)}nextHandle(){return this._handleCounter++}async addCustomExecution(H,x,U){const N=await this._proxy.$createTaskId(H);!U&&!this._providedCustomExecutions2.has(N)&&(this._notProvidedCustomExecutions.add(N),this._activeCustomExecutions2.set(N,x.execution)),this._providedCustomExecutions2.set(N,x.execution)}async getTaskExecution(H,x){if(typeof H=="string"){const ae=this._taskExecutionPromises.get(H);if(!ae)throw new C.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return ae}const U=this._taskExecutionPromises.get(H.id);if(U)return U;const N=new Promise((ae,Y)=>{function Ee(ye,Re,K){K?ae(new f(ye,Re.id,K)):Y("Unexpected: Task does not exist.")}x?Ee(this,H,x):b.to(H.task,this._workspaceProvider,this._providedCustomExecutions2).then(ye=>Ee(this,H,ye))});return this._taskExecutionPromises.set(H.id,N),N.then(ae=>(this._taskExecutions.set(H.id,ae),ae),ae=>Promise.reject(ae))}checkDeprecation(H,x){H._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));const U=this._notProvidedCustomExecutions.values();let N=U.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=U.next()}};e.ExtHostTaskBase=P,e.ExtHostTaskBase=P=We([He(0,c.IExtHostRpcService),He(1,S.IExtHostInitDataService),He(2,h.IExtHostWorkspace),He(3,y.IExtHostDocumentsAndEditors),He(4,p.IExtHostConfiguration),He(5,_.IExtHostTerminalService),He(6,i.ILogService),He(7,a.IExtHostApiDeprecationService)],P);let z=class extends P{constructor(H,x,U,N,ae,Y,Ee,ye){super(H,x,U,N,ae,Y,Ee,ye),this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:"",platform:t.PlatformToString(0)})}async executeTask(H,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const U=b.from(x,H);if(U===void 0)throw new Error("Task is not valid");if(D.is(U.execution))await this.addCustomExecution(U,x,!1);else throw new C.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),x);return this._proxy.$executeTask(U).catch(ae=>{throw new Error(ae)}),N}provideTasksInternal(H,x,U,N){const ae=[];if(N)for(const Y of N){this.checkDeprecation(Y,U),(!Y.definition||!H[Y.definition.type])&&this._logService.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const Ee=b.from(Y,U.extension);Ee&&D.is(Ee.execution)?(ae.push(Ee),x.push(this.addCustomExecution(Ee,Y,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ae,extension:U.extension}}async resolveTaskInternal(H){if(D.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(H,x,U){}};e.WorkerExtHostTask=z,e.WorkerExtHostTask=z=We([He(0,c.IExtHostRpcService),He(1,S.IExtHostInitDataService),He(2,h.IExtHostWorkspace),He(3,y.IExtHostDocumentsAndEditors),He(4,p.IExtHostConfiguration),He(5,_.IExtHostTerminalService),He(6,i.ILogService),He(7,a.IExtHostApiDeprecationService)],z),e.IExtHostTask=(0,E.createDecorator)("IExtHostTask")}),define(Pe[262],Ae([1,0,19,20,41,37,23,59,47]),function(pe,e,w,O,I,M,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class p{constructor(c,S,E){this.config=c,this.provider=S,this.sessionToken=E,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&M.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&M.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const S=this.config.folderQueries||[];return new Promise((E,o)=>{const t=i=>{this.resultCount++,c(i)};if(this.isCanceled)return E({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(i=>{const a=i.toString(),g=w.basename(a);this.globalExcludePattern&&this.globalExcludePattern(a,g)||this.matchFile(t,{base:i,basename:g})}),Promise.all(S.map(i=>this.searchInFolder(i,t))).then(i=>{E({limitHit:this.isLimitHit,stats:i[0]||void 0})},i=>{o(new Error((0,I.toErrorMessage)(i)))})})}async searchInFolder(c,S){const E=new O.CancellationTokenSource,o=this.getSearchOptionsForFolder(c),t=this.initDirectoryTree(),i=new y.QueryGlobTester(this.config,c),a=!i.hasSiblingExcludeClauses();let g;try{this.activeCancellationTokens.add(E),g=h.StopWatch.create();const C=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},o,E.token),k=g.elapsed(),r=h.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(C&&C.forEach(d=>{const n=w.posix.relative(c.folder.path,d.path);if(a){const s=w.basename(d.path);this.matchFile(S,{base:c.folder,relativePath:n,basename:s});return}this.addDirectoryEntries(t,c.folder,n,S)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(t,i,S),{providerTime:k,postProcessTime:r.elapsed()})}finally{E.dispose(),this.activeCancellationTokens.delete(E)}}getSearchOptionsForFolder(c){const S=(0,y.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),E=(0,y.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:E,includes:S,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},S,E,o){if(E===this.filePattern){const i=w.basename(this.filePattern);this.matchFile(o,{base:S,relativePath:this.filePattern,basename:i})}function t(i){const a=w.basename(i),g=w.dirname(i);let C=c[g];C||(C=c[g]=[],t(g)),C.push({base:S,relativePath:i,basename:a})}t(E)}matchDirectoryTree({rootEntries:c,pathToEntries:S},E,o){const t=this,i=this.filePattern;function a(g){const C=(0,y.hasSiblingFn)(()=>g.map(k=>k.basename));for(let k=0,r=g.length;k<r;k++){const d=g[k],{relativePath:n,basename:s}=d;if(E.matchesExcludesSync(n,s,i!==s?C:void 0))continue;const v=S[n];if(v)a(v);else{if(n===i)continue;t.matchFile(o,d)}if(t.isLimitHit)break}}a(c)}matchFile(c,S){(!this.includePattern||S.relativePath&&this.includePattern(S.relativePath,S.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(S))}}class A{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(c,S,E,o){const t=this.getSessionTokenSource(c.cacheKey),i=new p(c,S,t&&t.token);let a=0;const g=C=>{a+=C.length,E(C.map(k=>this.rawMatchToSearchItem(k)))};return this.doSearch(i,A.BATCH_SIZE,g,o).then(C=>({limitHit:C.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:a,detailStats:C.stats}}))}clearCache(c){this.getSessionTokenSource(c)?.cancel()}getSessionTokenSource(c){if(c)return this.sessions.has(c)||this.sessions.set(c,new O.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:T.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,S,E,o){o.onCancellationRequested(()=>{c.cancel()});const t=a=>{a&&(i.push(a),S>0&&i.length>=S&&(E(i),i=[]))};let i=[];return c.search(t).then(a=>(i.length&&E(i),a),a=>(i.length&&E(i),Promise.reject(a)))}}e.FileSearchManager=A}),define(Pe[263],Ae([1,0,18,65,37,90,28,13,19,23,15,12,2,277,167,43,14,54,102,261,47]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t,i,a,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let k=class{constructor(l,f,P,z,$){this.configurationService=l,this.workspaceContextService=f,this.editorGroupsService=P,this.logService=z,this.pathService=$}text(l,f,P={}){l=this.getContentPattern(l,P);const z=this.configurationService.getValue(),$=f&&f.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(f?.map(i.toWorkspaceFolder),P),type:2,contentPattern:l,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:z.search.usePCRE2||$||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}getContentPattern(l,f){const P=this.configurationService.getValue();l.isRegExp&&(l.pattern=l.pattern.replace(/\r?\n/g,"\\n"));const z={...l,wordSeparators:P.editor.wordSeparators};return this.isCaseSensitive(l,f)&&(z.isCaseSensitive=!0),this.isMultiline(l)&&(z.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeMarkupPreview&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownPreview=f.notebookSearchConfig.includeMarkupPreview),f.notebookSearchConfig?.includeCodeInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),z}file(l,f={}){return{...this.commonQuery(l,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}handleIncludeExclude(l,f){return l?(l=Array.isArray(l)?l.map(v):v(l),f?this.parseSearchPaths(l):{pattern:d(...Array.isArray(l)?l:[l])}):{}}commonQuery(l=[],f={}){const P=this.handleIncludeExclude(f.includePattern,f.expandPatterns),z=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),$=l.length>1,H=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,f,z)):l.map(N=>this.getFolderQueryForRoot(N,f,z,$))).filter(N=>!!N),x={_reason:f._reason,folderQueries:H,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:z.pattern,includePattern:P.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const N=w.coalesce(w.flatten(this.editorGroupsService.groups.map(Ee=>Ee.editors.map(ye=>ye.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const ae=N.filter(Ee=>(0,C.pathIncludedInQuery)(x,Ee.fsPath)),Y=this.commonQueryFromFileList(ae);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...x,...Y}}const U=f.extraFileResources&&f.extraFileResources.filter(N=>(0,C.pathIncludedInQuery)(x,N.fsPath));return x.extraFileResources=U&&U.length?U:void 0,x}commonQueryFromFileList(l){const f=[],P=new T.ResourceMap,z={};let $=!1;return l.forEach(H=>{if(H.scheme===h.Schemas.walkThrough)return;if((0,p.isAbsolutePath)(H)){const U=this.workspaceContextService.getWorkspaceFolder(H)?.uri??H.with({path:y.dirname(H.fsPath)});let N=P.get(U);N||($=!0,N={folder:U,includePattern:{}},f.push(N),P.set(U,N));const ae=y.relative(U.fsPath,H.fsPath);(0,_.assertIsDefined)(N.includePattern)[ae.replace(/\\/g,"/")]=!0}else H.fsPath&&($=!0,z[H.fsPath]=!0)}),{folderQueries:f,includePattern:z,usingSearchPaths:!0,excludePattern:$?void 0:{"**/*":!0}}}isCaseSensitive(l,f){if(f.isSmartCase){if(l.isRegExp){if(A.containsUppercaseCharacter(l.pattern,!0))return!0}else if(A.containsUppercaseCharacter(l.pattern))return!0}return!!l.isCaseSensitive}isMultiline(l){return l.isMultiline||l.isRegExp&&(0,S.isMultilineRegexSource)(l.pattern)||l.pattern.indexOf(`
`)>=0?!0:!!l.isMultiline}parseSearchPaths(l){const f=Y=>y.isAbsolute(Y)||/^\.\.?([\/\\]|$)/.test(Y),z=(Array.isArray(l)?l:n(l)).map(Y=>{const Ee=this.pathService.resolvedUserHome;return Ee?(0,M.untildify)(Y,Ee.scheme===h.Schemas.file?Ee.fsPath:Ee.path):Y}),$=O.groupBy(z,Y=>f(Y)?"searchPaths":"exprSegments"),H=($.exprSegments||[]).map(Y=>A.rtrim(Y,"/")).map(Y=>A.rtrim(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),s(Y))),x={},U=this.expandSearchPathPatterns($.searchPaths||[]);U&&U.length&&(x.searchPaths=U);const N=w.flatten(H),ae=d(...N);return ae&&(x.pattern=ae),x}getExcludesForFolder(l,f){return f.disregardExcludeSettings?void 0:(0,C.getExcludes)(l,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(l){if(!l||!l.length)return[];const f=l.flatMap(z=>{let{pathPortion:$,globPortion:H}=r(z);return H&&(H=D(H)),this.expandOneSearchPath($).flatMap(U=>this.resolveOneSearchPathPattern(U,H))}),P=new Map;return f.forEach(z=>{const $=z.searchPath.toString(),H=P.get($);H?z.pattern&&(H.pattern=H.pattern||{},H.pattern[z.pattern]=!0):P.set($,{searchPath:z.searchPath,pattern:z.pattern?d(z.pattern):void 0})}),Array.from(P.values())}expandOneSearchPath(l){if(y.isAbsolute(l)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==h.Schemas.file?[{searchPath:f[0].uri.with({path:l})}]:[{searchPath:c.URI.file(y.normalize(l))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(l=v(l),l.startsWith("../")||l===".."){const z=y.posix.resolve(f.path,l);return[{searchPath:f.with({path:z})}]}const P=D(l);return[{searchPath:f,pattern:P}]}else{if(l==="./"||l===".\\")return[];{const f=l.replace(/^\.[\/\\]/,""),z=this.workspaceContextService.getWorkspace().folders.map($=>{const H=f.match(new RegExp(`^${A.escapeRegExpCharacters($.name)}(?:/(.*)|$)`));return H?{match:H,folder:$}:null}).filter(_.isDefined);if(z.length)return z.map($=>{const H=$.match[1];return{searchPath:$.folder.uri,pattern:H&&D(H)}});{const $=l.match(/\.[\/\\](.+)[\/\\]?/),H=$?$[1]:l,x=E.localize(0,null,H);throw new Error(x)}}}}resolveOneSearchPathPattern(l,f){const P=l.pattern&&f?`${l.pattern}/${f}`:l.pattern||f,z=[{searchPath:l.searchPath,pattern:P}];return P&&!P.endsWith("**")&&z.push({searchPath:l.searchPath,pattern:P+"/**"}),z}getFolderQueryForSearchPath(l,f,P){const z=this.getFolderQueryForRoot((0,i.toWorkspaceFolder)(l.searchPath),f,P,!1);return z?{...z,includePattern:l.pattern}:null}getFolderQueryForRoot(l,f,P,z){let $;const H=c.URI.isUri(l)?l:l.uri;if(P.searchPaths){const Y=P.searchPaths.filter(Ee=>(0,p.isEqual)(Ee.searchPath,H))[0];if(Y&&!Y.pattern)return null;Y&&($=Y.pattern)}const x=this.configurationService.getValue({resource:H}),N={...this.getExcludesForFolder(x,f)||{},...$||{}},ae=c.URI.isUri(l)?(0,p.basename)(l):l.name;return{folder:H,folderName:z?ae:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!x.search.followSymlinks}}};e.QueryBuilder=k,e.QueryBuilder=k=We([He(0,o.IConfigurationService),He(1,i.IWorkspaceContextService),He(2,a.IEditorGroupsService),He(3,t.ILogService),He(4,g.IPathService)],k);function r(b){const l=b.match(/[\*\{\}\(\)\[\]\?]/);if(l){const f=l.index,P=b.substr(0,f).match(/[/|\\][^/\\]*$/);if(P){let z=b.substr(0,P.index);return z.match(/[/\\]/)||(z+="/"),{pathPortion:z,globPortion:b.substr((P.index||0)+1)}}}return{pathPortion:b}}function d(...b){return b.length?b.reduce((l,f)=>(l[f]=!0,l),Object.create(null)):void 0}function n(b){return I.splitGlobAware(b,",").map(l=>l.trim()).filter(l=>!!l.length)}function s(b){return[`**/${b}/**`,`**/${b}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function v(b){return b.replace(/\\/g,"/")}function D(b){return v(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(b){return b.replace(/([?*[\]])/g,"[$1]")}function m(b,l){b=w.distinct(b,z=>z.toString());const f=[],P=l.getWorkspace();return b&&b.forEach(z=>{let $;if(l.getWorkbenchState()===2)$=(0,p.relativePath)(P.folders[0].uri,z),$&&$!=="."&&($="./"+$);else{const H=l.getWorkspaceFolder(z);if(H){const x=H.name;if(P.folders.filter(N=>N.name===x).length===1){const N=(0,p.relativePath)(H.uri,z);N===""?$=`./${H.name}`:$=`./${H.name}/${N}`}else $=z.fsPath}}$&&f.push(u($))}),f}e.resolveResourcesForSearchIncludes=m}),define(Pe[264],Ae([1,0,23,2,20,11,3,263,47,54]),function(pe,e,w,O,I,M,T,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function _(o,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const a=[],g=[];for(const s of i)if(/^workspaceContains:/.test(s)){const v=s.substr(18);v.indexOf("*")>=0||v.indexOf("?")>=0||o.forceUsingSearch?g.push(v):a.push(v)}if(a.length===0&&g.length===0)return Promise.resolve(void 0);let C;const k=new Promise((s,v)=>{C=s}),r=s=>C({activationEvent:s}),d=Promise.all(a.map(s=>c(o,s,r))).then(()=>{}),n=S(o,t.identifier,g,r);return Promise.all([d,n]).then(()=>{C(void 0)}),k}e.checkActivateWorkspaceContainsExtension=_;async function c(o,t,i){for(const a of o.folders)if(await o.exists(w.joinPath(O.URI.revive(a),t))){i(`workspaceContains:${t}`);return}}async function S(o,t,i,a){if(i.length===0)return Promise.resolve(void 0);const g=new I.CancellationTokenSource,C=o.checkExists(o.folders,i,g.token),k=setTimeout(async()=>{g.cancel(),o.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},A);let r=!1;try{r=await C}catch(d){M.isCancellationError(d)||M.onUnexpectedError(d)}g.dispose(),clearTimeout(k),r&&a(`workspaceContains:${i.join(",")}`)}function E(o,t,i,a){const g=o.get(T.IInstantiationService),C=o.get(y.ISearchService),r=g.createInstance(h.QueryBuilder).file(t.map(d=>(0,p.toWorkspaceFolder)(O.URI.revive(d))),{_reason:"checkExists",includePattern:i,exists:!0});return C.fileSearch(r,a).then(d=>!!d.limitHit,d=>M.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=E}),define(Pe[35],Ae([1,0,148,19,87,23,16,6,48,2,14,4,34,210,84,33,26,106,11,21,25,189,7,97,3,27,85,17,73,86,63,5,264,83,191,13,81,59,22,82]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t,i,a,g,C,k,r,d,n,s,v,D,u,m,b,l,f,P,z,$,H,x,U,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let ae=class Cn extends h.Disposable{constructor(ne,he,le,F,J,Se,ke,Ce,_e,Ie,se,fe){super(),this._extHostManagedSockets=fe,this._onDidChangeRemoteConnectionData=this._register(new l.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=he,this._extHostContext=le,this._initData=ke,this._extHostWorkspace=F,this._extHostConfiguration=J,this._logService=Se,this._extHostTunnelService=_e,this._extHostTerminalService=Ie,this._extHostLocalizationService=se,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._activationEventsReader=new Q(this._initData.activationEvents),this._globalRegistry=new i.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.allExtensions);const ee=new g.ExtensionIdentifierSet(this._initData.myExtensions);this._myRegistry=new i.ExtensionDescriptionRegistry(this._activationEventsReader,Re(this._globalRegistry,ee)),this._storage=new E.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new P.ExtHostSecretState(this._extHostContext),this._storagePath=Ce,this._instaService=ne.createChild(new u.ServiceCollection([E.IExtHostStorage,this._storage],[P.IExtHostSecretState,this._secretState])),this._activator=this._register(new S.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(ie,de,R)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ie,a.transformErrorForSerialization(de),R)},actualActivateExtension:async(ie,de)=>{if(i.ExtensionDescriptionRegistry.isHostExtension(ie,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(ie,de),new S.HostExtension;const R=this._myRegistry.getExtensionDescription(ie);return this._activateExtension(R,de)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ne){a.onUnexpectedError(ne)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ne=[];try{ne=this._myRegistry.getAllExtensionDescriptions().map(J=>J.identifier).filter(J=>this.isActivated(J)).map(J=>this._deactivate(J))}catch{}await Promise.all(ne)}terminate(ne,he=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ne}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),a.setUnexpectedErrorHandler(F=>{this._logService.error(F)}),this._extHostContext.dispose();const le=this._deactivateAll();Promise.race([(0,T.timeout)(5e3),le]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${he}`):this._logService.info(`Extension host exiting with code ${he}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(he)})}isActivated(ne){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ne):!1}async getExtension(ne){const he=await this._mainThreadExtensionsProxy.$getExtension(ne);return he&&{...he,identifier:new g.ExtensionIdentifier(he.identifier.value),extensionLocation:p.URI.revive(he.extensionLocation)}}_activateByEvent(ne,he){return this._activator.activateByEvent(ne,he)}_activateById(ne,he){return this._activator.activateById(ne,he)}activateByIdWithErrors(ne,he){return this._activateById(ne,he).then(()=>{const le=this._activator.getActivatedExtension(ne);if(le.activationFailed)return Promise.reject(le.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ne=>this._myRegistry)}getExtensionExports(ne){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(ne).exports;try{return this._activator.getActivatedExtension(ne).exports}catch{return null}}async _realPathExtensionUri(ne){if(ne.scheme===$.Schemas.file&&this._hostUtils.fsRealpath){const he=await this._hostUtils.fsRealpath(ne.fsPath);return p.URI.file(he)}return ne}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ne=>new K(ne))),this._extensionPathIndex}async _createExtensionPathIndex(ne){const he=y.TernarySearchTree.forUris(le=>M.extUriBiasedIgnorePathCase.ignorePathCasing(le));return await Promise.all(ne.map(async le=>{if(this._getEntryPoint(le)){const F=await this._realPathExtensionUri(le.extensionLocation);he.set(F,le)}})),he}_deactivate(ne){let he=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ne))return he;const le=this._activator.getActivatedExtension(ne);if(!le)return he;try{typeof le.module.deactivate=="function"&&(he=Promise.resolve(le.module.deactivate()).then(void 0,F=>(this._logService.error(F),Promise.resolve(void 0))))}catch(F){this._logService.error(`An error occurred when deactivating the extension '${ne.value}':`),this._logService.error(F)}try{(0,h.dispose)(le.subscriptions)}catch(F){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ne.value}':`),this._logService.error(F)}return he}async _activateExtension(ne,he){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ne.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ne.identifier),this._doActivateExtension(ne,he).then(le=>{const F=le.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ne.identifier,F.codeLoadingTime,F.activateCallTime,F.activateResolvedTime,he),this._logExtensionActivationTimes(ne,he,"success",F),le},le=>{throw this._logExtensionActivationTimes(ne,he,"failure"),le})}_logExtensionActivationTimes(ne,he,le,F){const J=Ee(ne,he);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...J,...F||{},outcome:le})}_doActivateExtension(ne,he){const le=Ee(ne,he);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",le);const F=this._getEntryPoint(ne);if(!F)return Promise.resolve(new S.EmptyExtension(S.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ne.identifier.value}, startup: ${he.startup}, activationEvent: '${he.activationEvent}'${ne.identifier.value!==he.extensionId.value?`, root cause: ${he.extensionId.value}`:""}`),this._logService.flush();const J=new S.ExtensionActivationTimesBuilder(he.startup);return Promise.all([this._loadCommonJSModule(ne,(0,M.joinPath)(ne.extensionLocation,F),J),this._loadExtensionContext(ne)]).then(Se=>(I.mark(`code/extHost/willActivateExtension/${ne.identifier.value}`),Cn._callActivate(this._logService,ne.identifier,Se[0],Se[1],J))).then(Se=>(I.mark(`code/extHost/didActivateExtension/${ne.identifier.value}`),Se))}_loadExtensionContext(ne){const he=new k.ExtensionGlobalMemento(ne,this._storage),le=new k.ExtensionMemento(ne.identifier.value,!1,this._storage),F=new z.ExtensionSecrets(ne,this._secretState),J=ne.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Se=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ne.identifier.value}`),Promise.all([he.whenReady,le.whenReady,this._storagePath.whenReady]).then(()=>{const ke=this;let Ce,_e;const Ie=(0,t.isProposedApiEnabled)(ne,"ipc")?this._initData.messagePorts?.get(g.ExtensionIdentifier.toKey(ne.identifier)):void 0;return Object.freeze({globalState:he,workspaceState:le,secrets:F,subscriptions:[],get extensionUri(){return ne.extensionLocation},get extensionPath(){return ne.extensionLocation.fsPath},asAbsolutePath(se){return O.join(ne.extensionLocation.fsPath,se)},get storagePath(){return ke._storagePath.workspaceValue(ne)?.fsPath},get globalStoragePath(){return ke._storagePath.globalValue(ne).fsPath},get logPath(){return O.join(ke._initData.logsLocation.fsPath,ne.identifier.value)},get logUri(){return p.URI.joinPath(ke._initData.logsLocation,ne.identifier.value)},get storageUri(){return ke._storagePath.workspaceValue(ne)},get globalStorageUri(){return ke._storagePath.globalValue(ne)},get extensionMode(){return J},get extension(){return Ce===void 0&&(Ce=new ye(ke,ne.identifier,ne,Se,!1)),Ce},get extensionRuntime(){return(0,t.checkProposedApiEnabled)(ne,"extensionRuntime"),ke.extensionRuntime},get environmentVariableCollection(){return ke._extHostTerminalService.getEnvironmentVariableCollection(ne)},get messagePassingProtocol(){if(!_e){if(!Ie)return;const se=l.Event.buffer(l.Event.fromDOMEventEmitter(Ie,"message",fe=>fe.data));Ie.start(),_e={onDidReceiveMessage:se,postMessage:Ie.postMessage.bind(Ie)}}return _e}})})}static _callActivate(ne,he,le,F,J){return le=le||{activate:void 0,deactivate:void 0},this._callActivateOptional(ne,he,le,F,J).then(Se=>new S.ActivatedExtension(!1,null,J.build(),le,Se,F.subscriptions))}static _callActivateOptional(ne,he,le,F,J){if(typeof le.activate=="function")try{J.activateCallStart(),ne.trace(`ExtensionService#_callActivateOptional ${he.value}`);const Se=typeof global=="object"?global:self,ke=le.activate.apply(Se,[F]);return J.activateCallStop(),J.activateResolveStart(),Promise.resolve(ke).then(Ce=>(J.activateResolveStop(),Ce))}catch(Se){return Promise.reject(Se)}else return Promise.resolve(le)}_activateOneStartupFinished(ne,he){this._activateById(ne.identifier,{startup:!1,extensionId:ne.identifier,activationEvent:he}).then(void 0,le=>{this._logService.error(le)})}_activateAllStartupFinishedDeferred(ne,he=0){const F=Date.now();(0,U.setTimeout0)(()=>{for(let J=he;J<ne.length;J+=1){const Se=ne[J];for(const ke of Se.activationEvents??[])if(ke==="onStartupFinished")if(Date.now()-F>50){this._activateAllStartupFinishedDeferred(ne,J);break}else this._activateOneStartupFinished(Se,ke)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks()),this._extHostConfiguration.getConfigProvider().then(ne=>{const he=ne.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),le=this._myRegistry.getAllExtensionDescriptions();if(he)this._activateAllStartupFinishedDeferred(le);else for(const F of le)if(F.activationEvents)for(const J of F.activationEvents)J==="onStartupFinished"&&this._activateOneStartupFinished(F,J)})}_handleEagerExtensions(){const ne=this._activateByEvent("*",!0).then(void 0,Se=>{this._logService.error(Se)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Se=>this._handleWorkspaceContainsEagerExtensions(Se.added)));const he=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],le=this._handleWorkspaceContainsEagerExtensions(he),F=this._handleRemoteResolverEagerExtensions(),J=Promise.all([F,ne,le]).then(()=>{});return Promise.race([J,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),J}_handleWorkspaceContainsEagerExtensions(ne){return ne.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(he=>this._handleWorkspaceContainsEagerExtension(ne,he))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ne,he){if(this.isActivated(he.identifier))return;const le=!this._initData.remote.isRemote&&!!this._initData.remote.authority,F={logService:this._logService,folders:ne.map(Se=>Se.uri),forceUsingSearch:le||!this._hostUtils.fsExists,exists:Se=>this._hostUtils.fsExists(Se.fsPath),checkExists:(Se,ke,Ce)=>this._mainThreadWorkspaceProxy.$checkExists(Se,ke,Ce)},J=await(0,f.checkActivateWorkspaceContainsExtension)(F,he);if(J)return this._activateById(he.identifier,{startup:!0,extensionId:he.identifier,activationEvent:J.activationEvent}).then(void 0,Se=>this._logService.error(Se))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ne){throw console.error(ne),ne}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ne,extensionTestsLocationURI:he}=this._initData.environment;if(!ne||!he)throw new Error(w.localize(0,null));const le=await this._loadCommonJSModule(null,he,new S.ExtensionActivationTimesBuilder(!1));if(!le||typeof le.run!="function")throw new Error(w.localize(1,null,he.toString()));return new Promise((F,J)=>{const Se=(_e,Ie)=>{_e?J(_e):F(typeof Ie=="number"&&Ie>0?1:0)},ke=(0,M.originalFSPath)(he),Ce=le.run(ke,Se);Ce&&Ce.then&&Ce.then(()=>{F(0)}).catch(_e=>{J(_e instanceof Error&&_e.stack?_e.stack:String(_e))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,T.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ne,he){return this._resolvers[ne]=he,(0,h.toDisposable)(()=>{delete this._resolvers[ne]})}async getRemoteExecServer(ne){const{resolver:he}=await this._activateAndGetResolver(ne);return he?.resolveExecServer?.(ne,{resolveAttempt:0})}async _activateAndGetResolver(ne){const he=ne.indexOf("+");if(he===-1)throw new r.RemoteAuthorityResolverError("Not an authority that can be resolved!",d.RemoteAuthorityResolverErrorCode.InvalidAuthority);const le=ne.substr(0,he);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${le}`,!1),{authorityPrefix:le,resolver:this._resolvers[le]}}async $resolveAuthority(ne,he){const le=x.StopWatch.create(!1),F=()=>`[resolveAuthority(${(0,d.getRemoteAuthorityPrefix)(ne)},${he})][${le.elapsed()}ms] `,J=V=>this._logService.info(`${F()}${V}`),Se=V=>this._logService.warn(`${F()}${V}`),ke=(V,q=void 0)=>this._logService.error(`${F()}${V}`,q),Ce=V=>{if(V instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:V._code,message:V._message,detail:V._detail}};throw V},_e=async V=>{J(`activating resolver for ${V}...`);const{resolver:q,authorityPrefix:oe}=await this._activateAndGetResolver(V);if(!q)throw ke(`no resolver for ${oe}`),new r.RemoteAuthorityResolverError(`No remote extension installed to resolve ${oe}.`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:oe,remoteAuthority:V}},Ie=ne.split(/@|%40/g).reverse();J(`activating remote resolvers ${Ie.join(" -> ")}`);let se;try{se=await Promise.all(Ie.map(_e)).catch(async V=>{if(!(V instanceof r.RemoteAuthorityResolverError)||V._code!==d.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw V;return Se(`resolving nested authorities failed: ${V.message}`),[await _e(ne)]})}catch(V){return Ce(V)}const fe=new T.IntervalTimer;fe.cancelAndSet(()=>J("waiting..."),1e3);let ee,ie;for(const[V,{authorityPrefix:q,resolver:oe,remoteAuthority:j}]of se.entries())try{if(V===se.length-1)J("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${q}`),ee=await oe.resolve(j,{resolveAttempt:he,execServer:ie}),I.mark(`code/extHost/didResolveAuthorityOK/${q}`),J("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(oe));else{if(J(`invoking resolveExecServer() for ${j}`),I.mark(`code/extHost/willResolveExecServer/${q}`),ie=await oe.resolveExecServer?.(j,{resolveAttempt:he,execServer:ie}),!ie)throw new r.RemoteAuthorityResolverError(`Exec server was not available for ${j}`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(ce){return I.mark(`code/extHost/didResolveAuthorityError/${q}`),ke("returned an error",ce),fe.dispose(),Ce(ce)}fe.dispose();const de={environmentTunnels:ee.environmentTunnels,features:ee.tunnelFeatures},R={extensionHostEnv:ee.extensionHostEnv,isTrusted:ee.isTrusted,authenticationSession:ee.authenticationSessionForInitializingExtensions?{id:ee.authenticationSessionForInitializingExtensions.id,providerId:ee.authenticationSessionForInitializingExtensions.providerId}:void 0};J(`returned ${r.ManagedResolvedAuthority.isManagedResolvedAuthority(ee)?"managed authority":`${ee.host}:${ee.port}`}`);let W;if(r.ManagedResolvedAuthority.isManagedResolvedAuthority(ee)){const V=he;this._extHostManagedSockets.setFactory(V,ee.makeConnection),W={authority:ne,connectTo:new d.ManagedRemoteConnection(V),connectionToken:ee.connectionToken}}else W={authority:ne,connectTo:new d.WebSocketRemoteConnection(ee.host,ee.port),connectionToken:ee.connectionToken};return{type:"ok",value:{authority:W,options:R,tunnelInformation:de}}}async $getCanonicalURI(ne,he){this._logService.info(`$getCanonicalURI invoked for authority (${(0,d.getRemoteAuthorityPrefix)(ne)})`);const{resolver:le}=await this._activateAndGetResolver(ne);if(!le)return null;const F=p.URI.revive(he);if(typeof le.getCanonicalURI>"u")return F;const J=await(0,T.asPromise)(()=>le.getCanonicalURI(F));return J||F}$startExtensionHost(ne){ne.toAdd.forEach(F=>F.extensionLocation=p.URI.revive(F.extensionLocation));const{globalRegistry:he,myExtensions:le}=Y(this._activationEventsReader,this._globalRegistry,this._myRegistry,ne);return this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(le),this._startExtensionHost()}$activateByEvent(ne,he){return he===1?this._almostReadyToRunExtensions.wait().then(le=>this._activateByEvent(ne,!1)):this._readyToRunExtensions.wait().then(le=>this._activateByEvent(ne,!1))}async $activate(ne,he){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ne)?(await this._activateById(ne,he),!0):!1}async $deltaExtensions(ne){ne.toAdd.forEach(Se=>Se.extensionLocation=p.URI.revive(Se.extensionLocation));const{globalRegistry:he,myExtensions:le}=Y(this._activationEventsReader,this._globalRegistry,this._myRegistry,ne),F=await this._createExtensionPathIndex(le);return(await this.getExtensionPathIndex()).setSearchTree(F),this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(le),Promise.resolve(void 0)}async $test_latency(ne){return ne}async $test_up(ne){return ne.byteLength}async $test_down(ne){const he=C.VSBuffer.alloc(ne),le=Math.random()%256;for(let F=0;F<ne;F++)he.writeUInt8(le,F);return he}async $updateRemoteConnectionData(ne){this._remoteConnectionData=ne,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=ae,e.AbstractExtHostExtensionService=ae=We([He(0,n.IInstantiationService),He(1,e.IHostUtils),He(2,D.IExtHostRpcService),He(3,o.IExtHostWorkspace),He(4,c.IExtHostConfiguration),He(5,A.ILogService),He(6,s.IExtHostInitDataService),He(7,v.IExtensionStoragePaths),He(8,m.IExtHostTunnelService),He(9,b.IExtHostTerminalService),He(10,H.IExtHostLocalizationService),He(11,N.IExtHostManagedSockets)],ae);function Y(ue,ne,he,le){ue.addActivationEvents(le.addActivationEvents);const F=new i.ExtensionDescriptionRegistry(ue,ne.getAllExtensionDescriptions());F.deltaExtensions(le.toAdd,le.toRemove);const J=new g.ExtensionIdentifierSet(he.getAllExtensionDescriptions().map(ke=>ke.identifier));for(const ke of le.myToRemove)J.delete(ke);for(const ke of le.myToAdd)J.add(ke);const Se=Re(F,J);return{globalRegistry:F,myExtensions:Se}}function Ee(ue,ne){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:ne.activationEvent,reasonId:ne.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class ye{#e;#t;#i;constructor(ne,he,le,F,J){this.#e=ne,this.#t=he,this.#i=le.identifier,this.id=le.identifier.value,this.extensionUri=le.extensionLocation,this.extensionPath=O.normalize((0,M.originalFSPath)(le.extensionLocation)),this.packageJSON=le,this.extensionKind=F,this.isFromDifferentExtensionHost=J}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=ye;function Re(ue,ne){return ue.getAllExtensionDescriptions().filter(he=>ne.has(he.identifier))}class K{constructor(ne){this._searchTree=ne}setSearchTree(ne){this._searchTree=ne}findSubstr(ne){return this._searchTree.findSubstr(ne)}forEach(ne){return this._searchTree.forEach(ne)}}e.ExtensionPaths=K;class Q{constructor(ne){this._map=new g.ExtensionIdentifierMap,this.addActivationEvents(ne)}readActivationEvents(ne){return this._map.get(ne.identifier)}addActivationEvents(ne){for(const he of Object.keys(ne))this._map.set(he,ne[he])}}}),define(Pe[265],Ae([1,0,87,2,4,34,26,21,17,27,3,35,52,14,15]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(k,r,d,n,s,v,D){this._apiFactory=k,this._extensionRegistry=r,this._instaService=d,this._extHostConfiguration=n,this._extHostExtensionService=s,this._initData=v,this._logService=D,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),w.mark("code/extHost/willWaitForConfig");const k=await this._extHostConfiguration.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new i(this._apiFactory,r,this._extensionRegistry,k,this._logService)),this.register(this._instaService.createInstance(a,r)),this.register(this._instaService.createInstance(t)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(g,r,this._initData.environment.appUriScheme))}register(k){if("nodeModuleName"in k)if(Array.isArray(k.nodeModuleName))for(const r of k.nodeModuleName)this._factories.set(r,k);else this._factories.set(k.nodeModuleName,k);typeof k.alternativeModuleName=="function"&&this._alternatives.push(r=>k.alternativeModuleName(r))}};e.RequireInterceptor=o,e.RequireInterceptor=o=We([He(2,A.IInstantiationService),He(3,M.IExtHostConfiguration),He(4,_.IExtHostExtensionService),He(5,p.IExtHostInitDataService),He(6,S.ILogService)],o);let t=class mn{static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(k){if(k.environment.appRoot&&mn.aliased.size){const r=(0,E.escapeRegExpCharacters)(this.forceForwardSlashes(k.environment.appRoot.fsPath)),d="[a-z0-9_.-]",n=`@${d}+\\/${d}+|${d}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${r}/${s}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(k){if(!this.re)return;const r=this.re.exec(this.forceForwardSlashes(k));if(!r)return;const[,d,n,s]=r,v=mn.aliased.get(n);if(v!==void 0)return console.warn(`${n} as been renamed to ${v}, please update your imports`),d+v+s}forceForwardSlashes(k){return k.replace(/\\/g,"/")}};t=We([He(0,p.IExtHostInitDataService)],t);class i{constructor(k,r,d,n,s){this._apiFactory=k,this._extensionPaths=r,this._extensionRegistry=d,this._configProvider=n,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new h.ExtensionIdentifierMap}load(k,r){const d=this._extensionPaths.findSubstr(r);if(d){let n=this._extApiImpl.get(d.identifier);return n||(n=this._apiFactory(d,this._extensionRegistry,this._configProvider),this._extApiImpl.set(d.identifier,n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((s,v)=>n+=`	${v} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let a=class{constructor(k,r,d){this._extensionPaths=k,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(I.MainContext.MainThreadTelemetry);const{environment:n}=d,s=r.getProxy(I.MainContext.MainThreadKeytar);if(n.appRoot){let v=n.appRoot.fsPath;c.platform==="win32"&&(v=v.replace(/\\/g,"/")),v[v.length-1]==="/"&&(v=v.substr(0,v.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${v}/node_modules.asar/keytar`),this.alternativeNames.add(`${v}/node_modules/keytar`)}this._impl={getPassword:(v,D)=>s.$getPassword(v,D),setPassword:(v,D,u)=>s.$setPassword(v,D,u),deletePassword:(v,D)=>s.$deletePassword(v,D),findPassword:v=>s.$findPassword(v),findCredentials(v){return s.$findCredentials(v)}}}load(k,r){const d=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(k){const r=k.length;if(r<=7||!this.alternativeNames)return;const d=r-7;if((k.charAt(d)==="/"||k.charAt(d)==="\\")&&k.endsWith("keytar")&&(k=k.replace(/\\/g,"/"),this.alternativeNames.has(k)))return"keytar"}};a=We([He(1,y.IExtHostRpcService),He(2,p.IExtHostInitDataService)],a);let g=class{constructor(k,r,d){this._extensionPaths=k,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=d.getProxy(I.MainContext.MainThreadTelemetry);const n=d.getProxy(I.MainContext.MainThreadWindow);this._impl=(s,v)=>{const D=O.URI.parse(s);return v?this.callOriginal(s,v):D.scheme==="http"||D.scheme==="https"?n.$openUri(D,s,{allowTunneling:!0}):D.scheme==="mailto"||D.scheme===this._appUriScheme?n.$openUri(D,s,{}):this.callOriginal(s,v)}}load(k,r,d){const n=this._extensionPaths.findSubstr(r);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=d(k),this._impl}callOriginal(k,r){return this.sendNoForwardTelemetry(),this._original(k,r)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};g=We([He(2,y.IExtHostRpcService)],g)}),define(Pe[112],Ae([1,0,67,6,19,52,3,60,61,35,7,33,201,34]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,T.createDecorator)("IExtHostVariableResolverProvider");class E extends c.AbstractVariableResolverService{constructor(i,a,g,C,k,r,d){function n(){if(g){const s=g.activeEditor();if(s)return s.document.uri;const v=C.tabGroups.all.find(D=>D.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof A.TextDiffTabInput||v.input instanceof A.NotebookDiffEditorTabInput)return v.input.modified;if(v.input instanceof A.TextTabInput||v.input instanceof A.NotebookEditorTabInput||v.input instanceof A.CustomEditorTabInput)return v.input.uri}}}super({getFolderUri:s=>{const v=r.folders.filter(D=>D.name===s);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(s,v)=>k.getConfiguration(void 0,s).get(v),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=n();if(s)return I.normalize(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(a){const s=n();if(s){const v=a.getWorkspaceFolder(s);if(v)return I.normalize(v.uri.fsPath)}}},getSelectedText:()=>{if(g){const s=g.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(g){const s=g.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>i.getExtension(s)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(M.env))}}let o=class extends O.Disposable{constructor(i,a,g,C,k){super(),this.extensionService=i,this.workspaceService=a,this.editorService=g,this.configurationService=C,this.editorTabs=k,this._resolver=new w.Lazy(async()=>{const r=await this.configurationService.getConfigProvider(),n={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async s=>{n.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new E(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,r,n,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=o,e.ExtHostVariableResolverProviderService=o=We([He(0,p.IExtHostExtensionService),He(1,_.IExtHostWorkspace),He(2,h.IExtHostDocumentsAndEditors),He(3,S.IExtHostConfiguration),He(4,y.IExtHostEditorTabs)],o)}),define(Pe[113],Ae([1,0,16,5,12,2,3,4,61,35,17,7,33,194,196,34,112]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,T.createDecorator)("IExtHostDebugService");let i=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(n,s,v,D,u,m){this._workspaceService=s,this._extensionService=v,this._configurationService=D,this._editorTabs=u,this._variableResolver=m,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new O.Emitter,this._onDidTerminateDebugSession=new O.Emitter,this._onDidChangeActiveDebugSession=new O.Emitter,this._onDidReceiveDebugSessionCustomEvent=new O.Emitter,this._debugServiceProxy=n.getProxy(h.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new O.Emitter,this._onDidChangeStackFrameFocus=new O.Emitter,this._activeDebugConsole=new g(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(b=>{b.onDidChange(l=>{this.registerAllDebugTypes(b)}),this.registerAllDebugTypes(b)})}asDebugSourceUri(n,s){const v=n;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let D=`debug:${encodeURIComponent(v.path||"")}`,u="?";return s&&(D+=`${u}session=${encodeURIComponent(s.id)}`,u="&"),D+=`${u}ref=${v.sourceReference}`,M.URI.parse(D)}else{if(v.path)return M.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const s=[];for(const v of n.getAllExtensionDescriptions())if(v.contributes){const D=v.contributes.debuggers;if(D&&D.length>0)for(const u of D)(0,E.isDebuggerMainContribution)(u)&&s.push(u.type)}this._debugServiceProxy.$registerDebugTypes(s)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const n=[];return this._breakpoints.forEach(s=>n.push(s)),n}addBreakpoints(n){const s=n.filter(u=>{const m=u.id;return this._breakpoints.has(m)?!1:(this._breakpoints.set(m,u),!0)});this.fireBreakpointChanges(s,[],[]);const v=[],D=new Map;for(const u of s)if(u instanceof _.SourceBreakpoint){let m=D.get(u.location.uri.toString());m||(m={type:"sourceMulti",uri:u.location.uri,lines:[]},D.set(u.location.uri.toString(),m),v.push(m)),m.lines.push({id:u.id,enabled:u.enabled,condition:u.condition,hitCondition:u.hitCondition,logMessage:u.logMessage,line:u.location.range.start.line,character:u.location.range.start.character})}else u instanceof _.FunctionBreakpoint&&v.push({type:"function",id:u.id,enabled:u.enabled,hitCondition:u.hitCondition,logMessage:u.logMessage,condition:u.condition,functionName:u.functionName});return this._debugServiceProxy.$registerBreakpoints(v)}removeBreakpoints(n){const s=n.filter(m=>this._breakpoints.delete(m.id));this.fireBreakpointChanges([],s,[]);const v=s.filter(m=>m instanceof _.SourceBreakpoint).map(m=>m.id),D=s.filter(m=>m instanceof _.FunctionBreakpoint).map(m=>m.id),u=s.filter(m=>m instanceof _.DataBreakpoint).map(m=>m.id);return this._debugServiceProxy.$unregisterBreakpoints(v,D,u)}startDebugging(n,s,v){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,s,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===_.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,s,v){if(!s)return new _.Disposable(()=>{});const D=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:D,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,v,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,D),new _.Disposable(()=>{this._configProviders=this._configProviders.filter(u=>u.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(D)})}registerDebugAdapterDescriptorFactory(n,s,v){if(!v)return new _.Disposable(()=>{});if(!this.definesDebugType(n,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const D=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:D,factory:v}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,D),new _.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(u=>u.factory!==v),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(D)})}registerDebugAdapterTrackerFactory(n,s){if(!s)return new _.Disposable(()=>{});const v=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:v,factory:s}),new _.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(D=>D.factory!==s)})}async $runInTerminal(n,s){return Promise.resolve(void 0)}async $substituteVariables(n,s){let v;const D=await this.getFolder(n);return D&&(v={uri:D.uri,name:D.name,index:D.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(v,s)}createDebugAdapter(n,s){if(n.type==="implementation")return new k(n.implementation)}createSignService(){}async $startDASession(n,s){const v=this,D=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(D.type),D).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}' (extension might have failed to activate)`);const m=this.convertToDto(u),b=this.createDebugAdapter(m,D);if(!b)throw new Error(`Couldn't create a debug adapter for type '${D.type}'.`);const l=b;return this._debugAdapters.set(n,l),this.getDebugAdapterTrackers(D).then(f=>(f&&this._debugAdaptersTrackers.set(n,f),l.onMessage(async P=>{if(P.type==="request"&&P.command==="handshake"){const z=P,$={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(z.arguments.value);$.body={signature:H},l.sendResponse($)}else throw new Error("no signer")}catch(H){$.success=!1,$.message=H.message,l.sendResponse($)}}else f&&f.onDidSendMessage&&f.onDidSendMessage(P),P=(0,E.convertToVSCPaths)(P,!0),v._debugServiceProxy.$acceptDAMessage(n,P)}),l.onError(P=>{f&&f.onError&&f.onError(P),this._debugServiceProxy.$acceptDAError(n,P.name,P.message,P.stack)}),l.onExit(P=>{f&&f.onExit&&f.onExit((0,I.withNullAsUndefined)(P),void 0),this._debugServiceProxy.$acceptDAExit(n,(0,I.withNullAsUndefined)(P),void 0)}),f&&f.onWillStartSession&&f.onWillStartSession(),l.startSession()))})}$sendDAMessage(n,s){s=(0,E.convertToDAPaths)(s,!1);const v=this._debugAdaptersTrackers.get(n);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(s),this._debugAdapters.get(n)?.sendMessage(s)}$stopDASession(n){const s=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),s&&s.onWillStopSession&&s.onWillStopSession();const v=this._debugAdapters.get(n);return this._debugAdapters.delete(n),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const s=[],v=[],D=[];if(n.added)for(const u of n.added){const m=u.id;if(m&&!this._breakpoints.has(m)){let b;if(u.type==="function")b=new _.FunctionBreakpoint(u.functionName,u.enabled,u.condition,u.hitCondition,u.logMessage);else if(u.type==="data")b=new _.DataBreakpoint(u.label,u.dataId,u.canPersist,u.enabled,u.hitCondition,u.condition,u.logMessage);else{const l=M.URI.revive(u.uri);b=new _.SourceBreakpoint(new _.Location(l,new _.Position(u.line,u.character)),u.enabled,u.condition,u.hitCondition,u.logMessage)}(0,_.setBreakpointId)(b,m),this._breakpoints.set(m,b),s.push(b)}}if(n.removed)for(const u of n.removed){const m=this._breakpoints.get(u);m&&(this._breakpoints.delete(u),v.push(m))}if(n.changed){for(const u of n.changed)if(u.id){const m=this._breakpoints.get(u.id);if(m){if(m instanceof _.FunctionBreakpoint&&u.type==="function"){const b=m;b.enabled=u.enabled,b.condition=u.condition,b.hitCondition=u.hitCondition,b.logMessage=u.logMessage,b.functionName=u.functionName}else if(m instanceof _.SourceBreakpoint&&u.type==="source"){const b=m;b.enabled=u.enabled,b.condition=u.condition,b.hitCondition=u.hitCondition,b.logMessage=u.logMessage,b.location=new _.Location(M.URI.revive(u.uri),new _.Position(u.line,u.character))}D.push(m)}}}this.fireBreakpointChanges(s,v,D)}async $acceptStackFrameFocus(n){let s;const v=n.sessionId?await this.getSession(n.sessionId):void 0;if(!v)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?s=new _.ThreadFocus(v,n.threadId):s=new _.StackFrameFocus(v,n.threadId,n.frameId),this._stackFrameFocus=s,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(n,s,v){return(0,w.asPromise)(async()=>{const D=this.getConfigProviderByHandle(n);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const u=await this.getFolder(s);return D.provideDebugConfigurations(u,v)}).then(D=>{if(!D)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return D})}$resolveDebugConfiguration(n,s,v,D){return(0,w.asPromise)(async()=>{const u=this.getConfigProviderByHandle(n);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const m=await this.getFolder(s);return u.resolveDebugConfiguration(m,v,D)})}$resolveDebugConfigurationWithSubstitutedVariables(n,s,v,D){return(0,w.asPromise)(async()=>{const u=this.getConfigProviderByHandle(n);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const m=await this.getFolder(s);return u.resolveDebugConfigurationWithSubstitutedVariables(m,v,D)})}async $provideDebugAdapter(n,s){const v=this.getAdapterDescriptorFactoryByHandle(n);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const D=await this.getSession(s);return this.getAdapterDescriptor(v,D).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}'`);return this.convertToDto(u)})}async $acceptDebugSessionStarted(n){const s=await this.getSession(n);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(n){const s=await this.getSession(n);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,s){(await this.getSession(n))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(n,s){const D={session:await this.getSession(n),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(D)}convertToDto(n){if(n instanceof _.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof _.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof _.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof _.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const s=this._adapterFactories.filter(v=>v.type===n);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(n){const s=this._adapterFactories.filter(v=>v.handle===n);if(s.length>0)return s[0].factory}getConfigProviderByHandle(n){const s=this._configProviders.filter(v=>v.handle===n);if(s.length>0)return s[0].provider}definesDebugType(n,s){if(n.contributes){const v=n.contributes.debuggers;if(v&&v.length>0){for(const D of v)if(D.label&&D.type&&D.type===s)return!0}}return!1}getDebugAdapterTrackers(n){const v=n.configuration.type,D=this._trackerFactories.filter(u=>u.type===v||u.type==="*").map(u=>(0,w.asPromise)(()=>u.factory.createDebugAdapterTracker(n)).then(m=>m,m=>null));return Promise.race([Promise.all(D).then(u=>{const m=u.filter(b=>!!b);if(m.length>0)return new C(m)}),new Promise(u=>setTimeout(()=>u(void 0),1e3))]).catch(u=>{})}async getAdapterDescriptor(n,s){const v=s.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new _.DebugAdapterServer(v));if(n){const u=await this._extensionService.getExtensionRegistry();return(0,w.asPromise)(()=>n.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,u))).then(m=>{if(m)return m})}const D=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,D))}daExecutableFromPackage(n,s){}fireBreakpointChanges(n,s,v){(n.length>0||s.length>0||v.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:s,changed:v}))}async getSession(n){if(n)if(typeof n=="string"){const s=this._debugSessions.get(n);if(s)return s}else{let s=this._debugSessions.get(n.id);if(!s){const v=await this.getFolder(n.folderUri),D=n.parent?this._debugSessions.get(n.parent):void 0;s=new a(this._debugServiceProxy,n.id,n.type,n.name,v,n.configuration,D),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(n){if(n){const s=M.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=i,e.ExtHostDebugServiceBase=i=We([He(0,A.IExtHostRpcService),He(1,c.IExtHostWorkspace),He(2,p.IExtHostExtensionService),He(3,o.IExtHostConfiguration),He(4,y.IExtHostEditorTabs),He(5,t.IExtHostVariableResolverProvider)],i);class a{constructor(n,s,v,D,u,m,b){this._debugServiceProxy=n,this._id=s,this._type=v,this._name=D,this._workspaceFolder=u,this._configuration=m,this._parentSession=b}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}get parentSession(){return this._parentSession}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,s)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=a;class g{constructor(n){this.value=Object.freeze({append(s){n.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=g;class C{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(s=>s.onError?s.onError(n):void 0)}onExit(n,s){this.trackers.forEach(v=>v.onExit?v.onExit(n,s):void 0)}}class k extends S.AbstractDebugAdapter{constructor(n){super(),this.implementation=n,n.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends i{constructor(n,s,v,D,u,m){super(n,s,v,D,u,m)}};e.WorkerExtHostDebugService=r,e.WorkerExtHostDebugService=r=We([He(0,A.IExtHostRpcService),He(1,c.IExtHostWorkspace),He(2,p.IExtHostExtensionService),He(3,o.IExtHostConfiguration),He(4,y.IExtHostEditorTabs),He(5,t.IExtHostVariableResolverProvider)],r)}),define(Pe[266],Ae([1,0,11,87,2,4,257,14,72,73,27,172,17,56,35,58]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class t{static async installEarlyHandler(g){Error.stackTraceLimit=100;const C=g.get(h.ILogService),r=g.get(c.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);w.setUnexpectedErrorHandler(d=>{C.error(d);const n=w.transformErrorForSerialization(d);r.$onUnexpectedError(n)})}static async installFullHandler(g){const C=g.get(h.ILogService),k=g.get(c.IExtHostRpcService),r=g.get(E.IExtHostExtensionService),d=g.get(o.IExtHostTelemetry),n=k.getProxy(M.MainContext.MainThreadExtensionService),s=k.getProxy(M.MainContext.MainThreadErrors),v=await r.getExtensionPathIndex(),D=new WeakMap;function u(l,f){if(D.has(l))return D.get(l).stack;let P="",z,$;for(const x of f)P+=`
	at ${x.toString()}`,$=x.getFileName(),!z&&$&&(z=v.findSubstr(I.URI.file($)));const H=`${l.name||"Error"}: ${l.message||""}${P}`;return D.set(l,{extensionIdentifier:z?.identifier,stack:H}),H}const m=Symbol("prepareStackTrace wrapped");let b=u;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return b},set(l){if(l===u||l[m]){b=l;return}b=function(f,P){return u(f,P),l.call(Error,f,P)},Object.assign(b,{[m]:!0})}}),w.setUnexpectedErrorHandler(l=>{C.error(l);const f=w.transformErrorForSerialization(l),P=D.get(l);if(!P?.extensionIdentifier){s.$onUnexpectedError(f);return}n.$onExtensionRuntimeError(P.extensionIdentifier,f);const z=d.onExtensionError(P.extensionIdentifier,l);C.trace("forwarded error to extension?",z,P)})}}e.ErrorHandler=t;class i{constructor(g,C,k,r,d){this._hostUtils=k,this._rpcProtocol=new T.RPCProtocol(g,null,r),C=i._transform(C,this._rpcProtocol);const n=new p.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());n.set(A.IExtHostInitDataService,{_serviceBrand:void 0,...C,messagePorts:d}),n.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),n.set(S.IURITransformerService,new S.URITransformerService(r)),n.set(E.IHostUtils,k);const s=new _.InstantiationService(n,!0);s.invokeFunction(t.installEarlyHandler),this._logService=s.invokeFunction(v=>v.get(h.ILogService)),O.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",C),this._extensionService=s.invokeFunction(v=>v.get(E.IExtHostExtensionService)),this._extensionService.initialize(),s.invokeFunction(t.installFullHandler)}async asBrowserUri(g){const C=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService);return I.URI.revive(await C.$asBrowserUri(g))}terminate(g){this._extensionService.terminate(g)}static _transform(g,C){g.allExtensions.forEach(r=>{r.extensionLocation=I.URI.revive(C.transformIncomingURIs(r.extensionLocation))}),g.environment.appRoot=I.URI.revive(C.transformIncomingURIs(g.environment.appRoot));const k=g.environment.extensionDevelopmentLocationURI;return k&&(g.environment.extensionDevelopmentLocationURI=k.map(r=>I.URI.revive(C.transformIncomingURIs(r)))),g.environment.extensionTestsLocationURI=I.URI.revive(C.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=I.URI.revive(C.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=I.URI.revive(C.transformIncomingURIs(g.environment.workspaceStorageHome)),g.environment.extensionTelemetryLogResource=I.URI.revive(C.transformIncomingURIs(g.environment.extensionTelemetryLogResource)),g.nlsBaseUrl=I.URI.revive(C.transformIncomingURIs(g.nlsBaseUrl)),g.logsLocation=I.URI.revive(C.transformIncomingURIs(g.logsLocation)),g.workspace=C.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=i}),define(Pe[267],Ae([1,0,18,16,20,41,13,19,23,2,47]),function(pe,e,w,O,I,M,T,h,y,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class _{constructor(a,g,C,k){this.query=a,this.provider=g,this.fileUtils=C,this.processType=k,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,g){const C=this.query.folderQueries||[],k=new I.CancellationTokenSource;return g.onCancellationRequested(()=>k.cancel()),new Promise((r,d)=>{this.collector=new S(a);let n=!1;const s=(v,D)=>{if(!n&&!this.isLimitHit){const u=this.resultSize(v);o(v)&&typeof this.query.maxResults=="number"&&this.resultCount+u>this.query.maxResults&&(this.isLimitHit=!0,n=!0,k.cancel(),v=this.trimResultToSize(v,this.query.maxResults-this.resultCount));const m=this.resultSize(v);this.resultCount+=m,(m>0||!o(v))&&this.collector.add(v,D)}};Promise.all(C.map((v,D)=>this.searchInFolder(v,u=>s(u,D),k.token))).then(v=>{k.dispose(),this.collector.flush();const D=v.some(u=>!!u&&!!u.limitHit);r({limitHit:this.isLimitHit||D,messages:(0,w.flatten)(v.map(u=>u?.message?Array.isArray(u.message)?u.message:[u.message]:[])),stats:{type:this.processType}})},v=>{k.dispose();const D=(0,M.toErrorMessage)(v);d(new Error(D))})})}resultSize(a){return o(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,g){const C=Array.isArray(a.ranges)?a.ranges:[a.ranges],k=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:C.slice(0,g),preview:{matches:k.slice(0,g),text:a.preview.text},uri:a.uri}}async searchInFolder(a,g,C){const k=new A.QueryGlobTester(this.query,a),r=[],d={report:v=>{if(!this.validateProviderResult(v))return;const D=a.folder.scheme===T.Schemas.file?(0,A.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(v.uri))):void 0,u=y.relativePath(a.folder,v.uri);if(u){const m=k.includedInQuery(u,h.basename(u),D);(0,O.isThenable)(m)?r.push(m.then(b=>{b&&g(v)})):m&&g(v)}}},n=this.getSearchOptionsForFolder(a),s=await this.provider.provideTextSearchResults(c(this.query.contentPattern),n,d,C);return r.length&&await Promise.all(r),s}validateProviderResult(a){if(o(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const g=(0,A.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),C=(0,A.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),k={folder:p.URI.from(a.folder),excludes:C,includes:g,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return k.usePCRE2=this.query.usePCRE2,k}}e.TextSearchManager=_;function c(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class S{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new t(512,g=>this.sendItems(g))}add(a,g){this._currentFileMatch&&(this._currentFolderIdx!==g||!y.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=g,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(E(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=S;function E(i){return o(i)?{preview:{matches:(0,w.mapArrayOrNot)(i.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:i.preview.text},ranges:(0,w.mapArrayOrNot)(i.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function o(i){return!!i.preview}e.extensionResultIsMatch=o;class t{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(a,g){this.maxBatchSize=a,this.cb=g,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,g){a&&this.addItemToBatch(a,g)}addItems(a,g){a&&this.addItemsToBatch(a,g)}addItemToBatch(a,g){this.batch.push(a),this.batchSize+=g,this.onUpdate()}addItemsToBatch(a,g){this.batch=this.batch.concat(a),this.batchSize+=g,this.onUpdate()}onUpdate(){this.totalNumberCompleted<t.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},t.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=t}),define(Pe[114],Ae([1,0,6,4,3,262,17,56,14,2,267]),function(pe,e,w,O,I,M,T,h,y,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let _=class{constructor(o,t,i){this.extHostRpc=o,this._uriTransformer=t,this._logService=i,this._proxy=this.extHostRpc.getProxy(O.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new M.FileSearchManager}_transformScheme(o){return this._uriTransformer.transformOutgoingScheme(o)}registerTextSearchProvider(o,t){if(this._textSearchUsedSchemes.has(o))throw new Error(`a text search provider for the scheme '${o}' is already registered`);this._textSearchUsedSchemes.add(o);const i=this._handlePool++;return this._textSearchProvider.set(i,t),this._proxy.$registerTextSearchProvider(i,this._transformScheme(o)),(0,w.toDisposable)(()=>{this._textSearchUsedSchemes.delete(o),this._textSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}registerFileSearchProvider(o,t){if(this._fileSearchUsedSchemes.has(o))throw new Error(`a file search provider for the scheme '${o}' is already registered`);this._fileSearchUsedSchemes.add(o);const i=this._handlePool++;return this._fileSearchProvider.set(i,t),this._proxy.$registerFileSearchProvider(i,this._transformScheme(o)),(0,w.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(o),this._fileSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}$provideFileSearchResults(o,t,i,a){const g=c(i),C=this._fileSearchProvider.get(o);if(C)return this._fileSearchManager.fileSearch(g,C,k=>{this._proxy.$handleFileMatch(o,t,k.map(r=>r.resource))},a);throw new Error("unknown provider: "+o)}$clearCache(o){return this._fileSearchManager.clearCache(o),Promise.resolve(void 0)}$provideTextSearchResults(o,t,i,a){const g=this._textSearchProvider.get(o);if(!g||!g.provideTextSearchResults)throw new Error(`Unknown provider ${o}`);const C=c(i);return this.createTextSearchManager(C,g).search(r=>this._proxy.$handleTextMatch(o,t,r),a)}$enableExtensionHostSearch(){}createTextSearchManager(o,t){return new A.TextSearchManager(o,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.ExtHostSearch=_,e.ExtHostSearch=_=We([He(0,T.IExtHostRpcService),He(1,h.IURITransformerService),He(2,y.ILogService)],_);function c(E){return{...E,folderQueries:E.folderQueries&&E.folderQueries.map(S),extraFileResources:E.extraFileResources&&E.extraFileResources.map(o=>p.URI.revive(o))}}e.reviveQuery=c;function S(E){return{...E,folder:p.URI.revive(E.folder)}}}),define(Pe[268],Ae([1,0,20,11,5,29,2,135,278,124,133,38,4,79,221,220,32,222,34,224,225,226,204,227,60,35,228,229,234,235,237,109,208,243,244,247,84,63,249,211,8,7,53,252,64,108,33,21,199,233,51,107,111,113,114,14,56,17,27,238,197,86,80,217,250,85,62,255,253,254,218,39,248,251,83,61,58,239,110,240,13,95,207,190,231,6,26,195,81,186,241,242,219,230,206,245,232,82,246]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t,i,a,g,C,k,r,d,n,s,v,D,u,m,b,l,f,P,z,$,H,x,U,N,ae,Y,Ee,ye,Re,K,Q,ue,ne,he,le,F,J,Se,ke,Ce,_e,Ie,se,fe,ee,ie,de,R,W,V,q,oe,j,ce,ve,Ue,$e,Qe,qe,Ye,Ke,ct,Ze,tt,Ne,nt,Z,X,ge,Be,Me,Ge,et,mt,wt,Ut,Vt,zt,St,At,Rt,Lt,xt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ot(st){const dt=st.get(se.IExtHostInitDataService),Bt=st.get(Ue.IExtHostFileSystemInfo),Ft=st.get(q.IExtHostConsumerFileSystem),yt=st.get(s.IExtHostExtensionService),ot=st.get(Q.IExtHostWorkspace),Tt=st.get(Ke.IExtHostTelemetry),Mt=st.get(a.IExtHostConfiguration),Te=st.get(_e.IURITransformerService),we=st.get(Ie.IExtHostRpcService),be=st.get(H.IExtHostStorage),G=st.get(V.IExtensionStoragePaths),Oe=st.get(Ce.ILoggerService),xe=st.get(Ce.ILogService),je=st.get(ie.IExtHostTunnelService),ze=st.get(de.IExtHostApiDeprecationService),Je=st.get(K.IExtHostWindow),Et=st.get(qe.IExtHostSecretState),Dt=st.get(Ye.IExtHostEditorTabs),Ct=st.get(Lt.IExtHostManagedSockets);we.set(c.ExtHostContext.ExtHostFileSystemInfo,Bt),we.set(c.ExtHostContext.ExtHostLogLevelServiceShape,Oe),we.set(c.ExtHostContext.ExtHostWorkspace,ot),we.set(c.ExtHostContext.ExtHostConfiguration,Mt),we.set(c.ExtHostContext.ExtHostExtensionService,yt),we.set(c.ExtHostContext.ExtHostStorage,be),we.set(c.ExtHostContext.ExtHostTunnelService,je),we.set(c.ExtHostContext.ExtHostWindow,Je),we.set(c.ExtHostContext.ExtHostSecretState,Et),we.set(c.ExtHostContext.ExtHostTelemetry,Tt),we.set(c.ExtHostContext.ExtHostEditorTabs,Dt),we.set(c.ExtHostContext.ExtHostManagedSockets,Ct);const vt=we.set(c.ExtHostContext.ExtHostDecorations,st.get(F.IExtHostDecorations)),gt=we.set(c.ExtHostContext.ExtHostDocumentsAndEditors,st.get(n.IExtHostDocumentsAndEditors)),ut=we.set(c.ExtHostContext.ExtHostCommands,st.get(t.IExtHostCommands)),pt=we.set(c.ExtHostContext.ExtHostTerminalService,st.get(x.IExtHostTerminalService)),ft=we.set(c.ExtHostContext.ExtHostDebugService,st.get(Se.IExtHostDebugService)),Qt=we.set(c.ExtHostContext.ExtHostSearch,st.get(ke.IExtHostSearch)),$t=we.set(c.ExtHostContext.ExtHostTask,st.get(J.IExtHostTask)),Yi=we.set(c.ExtHostContext.ExtHostOutputService,st.get(l.IExtHostOutputService)),di=we.set(c.ExtHostContext.ExtHostLocalization,st.get(et.IExtHostLocalizationService)),hi=we.set(c.ExtHostContext.ExtHostUrls,new ye.ExtHostUrls(we)),It=we.set(c.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(we,gt)),Si=we.set(c.ExtHostContext.ExtHostDocumentContentProviders,new k.ExtHostDocumentContentProvider(we,gt,xe)),qt=we.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(xe,It,we.getProxy(c.MainContext.MainThreadBulkEdits))),_t=we.set(c.ExtHostContext.ExtHostNotebook,new fe.ExtHostNotebookController(we,ut,gt,It,Ft)),_i=we.set(c.ExtHostContext.ExtHostNotebookDocuments,new X.ExtHostNotebookDocuments(_t)),fi=we.set(c.ExtHostContext.ExtHostNotebookEditors,new Z.ExtHostNotebookEditors(xe,_t)),ai=we.set(c.ExtHostContext.ExtHostNotebookKernels,new ct.ExtHostNotebookKernels(we,dt,_t,ut,xe)),Ji=we.set(c.ExtHostContext.ExtHostNotebookRenderers,new tt.ExtHostNotebookRenderers(we,_t)),ni=we.set(c.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new St.ExtHostNotebookDocumentSaveParticipant(xe,_t,we.getProxy(c.MainContext.MainThreadBulkEdits))),Pt=we.set(c.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(we,gt)),mi=we.set(c.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(we.getProxy(c.MainContext.MainThreadTreeViews),ut,xe)),yi=we.set(c.ExtHostContext.ExtHostEditorInsets,new ne.ExtHostEditorInsets(we.getProxy(c.MainContext.MainThreadEditorInsets),Pt,dt.remote)),ri=we.set(c.ExtHostContext.ExtHostDiagnostics,new g.ExtHostDiagnostics(we,xe,Bt,gt)),si=we.set(c.ExtHostContext.ExtHostLanguages,new m.ExtHostLanguages(we,It,ut.converter,Te)),at=we.set(c.ExtHostContext.ExtHostLanguageFeatures,new u.ExtHostLanguageFeatures(we,Te,It,ut,ri,xe,ze,Tt)),Di=we.set(c.ExtHostContext.ExtHostFileSystem,new v.ExtHostFileSystem(we,at)),jt=we.set(c.ExtHostContext.ExtHostFileSystemEventService,new D.ExtHostFileSystemEventService(we,xe,gt)),Zt=we.set(c.ExtHostContext.ExtHostQuickOpen,(0,P.createExtHostQuickOpen)(we,ot,ut)),gi=we.set(c.ExtHostContext.ExtHostSCM,new z.ExtHostSCM(we,ut,It,xe)),Ui=we.set(c.ExtHostContext.ExtHostQuickDiff,new Ut.ExtHostQuickDiff(we,Te)),Ci=we.set(c.ExtHostContext.ExtHostShare,new xt.ExtHostShare(we,Te)),Ii=we.set(c.ExtHostContext.ExtHostComments,(0,i.createExtHostComments)(we,ut,It)),pi=we.set(c.ExtHostContext.ExtHostProgress,new f.ExtHostProgress(we.getProxy(c.MainContext.MainThreadProgress))),ki=we.set(c.ExtHostContext.ExtHosLabelService,new he.ExtHostLabelService(we)),Ti=we.set(c.ExtHostContext.ExtHostTheming,new ee.ExtHostTheming(we)),ei=we.set(c.ExtHostContext.ExtHostAuthentication,new R.ExtHostAuthentication(we)),Pi=we.set(c.ExtHostContext.ExtHostTimeline,new W.ExtHostTimeline(we,ut)),vi=we.set(c.ExtHostContext.ExtHostWebviews,new Re.ExtHostWebviews(we,dt.remote,ot,xe,ze)),Ei=we.set(c.ExtHostContext.ExtHostWebviewPanels,new ce.ExtHostWebviewPanels(we,vi,ot)),xi=we.set(c.ExtHostContext.ExtHostCustomEditors,new j.ExtHostCustomEditors(we,It,G,vi,Ei)),Bi=we.set(c.ExtHostContext.ExtHostWebviewViews,new oe.ExtHostWebviewViews(we,vi)),oi=we.set(c.ExtHostContext.ExtHostTesting,new $e.ExtHostTesting(we,ut,gt)),Zi=we.set(c.ExtHostContext.ExtHostUriOpeners,new Qe.ExtHostUriOpeners(we)),en=we.set(c.ExtHostContext.ExtHostProfileContentHandlers,new wt.ExtHostProfileContentHandlers(we));we.set(c.ExtHostContext.ExtHostInteractive,new ge.ExtHostInteractive(we,_t,gt,ut,xe));const Ai=we.set(c.ExtHostContext.ExtHostInlineChat,new zt.ExtHostInteractiveEditor(we,ut,It,xe)),Yt=we.set(c.ExtHostContext.ExtHostChat,new Vt.ExtHostChat(we,xe)),tn=we.set(c.ExtHostContext.ExtHostSemanticSimilarity,new At.ExtHostSemanticSimilarity(we)),nn=we.set(c.ExtHostContext.ExtHostIssueReporter,new Rt.ExtHostIssueReporter(we)),Ri=we.set(c.ExtHostContext.ExtHostStatusBar,new $.ExtHostStatusBar(we,ut.converter)),Oi=Object.values(c.ExtHostContext);we.assertRegistered(Oi);const $i=new ve.ExtHostBulkEdits(we,gt),zi=new o.ExtHostClipboard(we),bi=new b.ExtHostMessageService(we,xe),Hi=new C.ExtHostDialogs(we);return E.ExtHostApiCommands.register(ut),function(Le,Kt,Gt){const ht=function(){let te=!Le.isUnderDevelopment;function me(){te||(xe.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Fe(it){if(Array.isArray(it))it.forEach(Fe);else if(typeof it=="string")me();else{const bt=it;typeof bt.scheme>"u"&&me(),typeof bt.exclusive=="boolean"&&(0,Me.checkProposedApiEnabled)(Le,"documentFiltersExclusive")}return it}}(),rn={getSession(te,me,Fe){return ei.getSession(Le,te,me,Fe)},getSessions(te,me){return(0,Me.checkProposedApiEnabled)(Le,"authGetSessions"),ei.getSessions(Le,te,me)},async hasSession(te,me){return(0,Me.checkProposedApiEnabled)(Le,"authSession"),!!await ei.getSession(Le,te,me,{silent:!0})},get onDidChangeSessions(){return ei.onDidChangeSessions},registerAuthenticationProvider(te,me,Fe,it){return ei.registerAuthenticationProvider(te,me,Fe,it)}},Ht={registerCommand(te,me,Fe){return ut.registerCommand(!0,te,me,Fe,void 0,Le)},registerTextEditorCommand(te,me,Fe){return ut.registerCommand(!0,te,(...it)=>{const bt=Pt.getActiveTextEditor();if(!bt){xe.warn("Cannot execute "+te+" because there is no active text editor.");return}return bt.edit(kt=>{me.apply(Fe,[bt,kt,...it])}).then(kt=>{kt||xe.warn("Edits from command "+te+" were not applied.")},kt=>{xe.warn("An error occurred while running command "+te,kt)})},void 0,void 0,Le)},registerDiffInformationCommand:(te,me,Fe)=>((0,Me.checkProposedApiEnabled)(Le,"diffCommand"),ut.registerCommand(!0,te,async(...it)=>{const bt=gt.activeEditor(!0);if(!bt){xe.warn("Cannot execute "+te+" because there is no active text editor.");return}const kt=await Pt.getDiffInformation(bt.id);me.apply(Fe,[kt,...it])},void 0,void 0,Le)),executeCommand(te,...me){return ut.executeCommand(te,...me)},getCommands(te=!1){return ut.getCommands(te)}},ci={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return zi.value},get shell(){return pt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Me.checkProposedApiEnabled)(Le,"envShellEvent"),pt.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Me.checkProposedApiEnabled)(Le,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Me.checkProposedApiEnabled)(Le,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ke.isNewAppInstall)(dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,me){return Ke.ExtHostTelemetryLogger.validateSender(te),Tt.instantiateLogger(Le,te,me)},openExternal(te,me){return Je.openUri(te,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:me?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===dt.environment.appUriScheme)return hi.createAppUri(te);try{return await Je.asExternalUri(te,{allowTunneling:!!dt.remote.authority})}catch(me){if((0,nt.matchesScheme)(te,Ne.Schemas.http)||(0,nt.matchesScheme)(te,Ne.Schemas.https))return te;throw me}},get remoteName(){return(0,le.getRemoteName)(dt.remote.authority)},get remoteAuthority(){return(0,Me.checkProposedApiEnabled)(Le,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind},get logLevel(){return xe.getLevel()},get onDidChangeLogLevel(){return xe.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Me.checkProposedApiEnabled)(Le,"handleIssueUri"),nn.registerIssueUriRequestHandler(Le,te)},get appQuality(){return(0,Me.checkProposedApiEnabled)(Le,"resolvers"),dt.quality},get appCommit(){return(0,Me.checkProposedApiEnabled)(Le,"resolvers"),dt.commit}};dt.environment.extensionTestsLocationURI||Object.freeze(ci);const Wi={createTestController(te,me,Fe){return oi.createTestController(Le,te,me,Fe)},createTestObserver(){return(0,Me.checkProposedApiEnabled)(Le,"testObserver"),oi.createTestObserver()},runTests(te){return(0,Me.checkProposedApiEnabled)(Le,"testObserver"),oi.runTests(te)},get onDidChangeTestResults(){return(0,Me.checkProposedApiEnabled)(Le,"testObserver"),oi.onResultsChanged},get testResults(){return(0,Me.checkProposedApiEnabled)(Le,"testObserver"),oi.results}},li=dt.remote.isRemote?Y.ExtensionKind.Workspace:Y.ExtensionKind.UI,Vi={getExtension(te,me){(0,Me.isProposedApiEnabled)(Le,"extensionsAny")||(me=!1);const Fe=Kt.mine.getExtensionDescription(te);if(Fe)return new s.Extension(yt,Le.identifier,Fe,li,!1);if(me){const it=Kt.all.getExtensionDescription(te);if(it)return new s.Extension(yt,Le.identifier,it,li,!0)}},get all(){const te=[];for(const me of Kt.mine.getAllExtensionDescriptions())te.push(new s.Extension(yt,Le.identifier,me,li,!1));return te},get allAcrossExtensionHosts(){(0,Me.checkProposedApiEnabled)(Le,"extensionsAny");const te=new ue.ExtensionIdentifierSet(Kt.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),me=[];for(const Fe of Kt.all.getAllExtensionDescriptions()){const it=!te.has(Fe.identifier);me.push(new s.Extension(yt,Le.identifier,Fe,li,it))}return me},get onDidChange(){return(0,Me.isProposedApiEnabled)(Le,"extensionsAny")?I.Event.any(Kt.mine.onDidChange,Kt.all.onDidChange):Kt.mine.onDidChange}},qi={createDiagnosticCollection(te){return ri.createDiagnosticCollection(Le.identifier,te)},get onDidChangeDiagnostics(){return ri.onDidChangeDiagnostics},getDiagnostics:te=>ri.getDiagnostics(te),getLanguages(){return si.getLanguages()},setTextDocumentLanguage(te,me){return si.changeLanguage(te.uri,me)},match(te,me){const Fe=It.getDocumentData(me.uri)?.notebook;return(0,A.score)(ae.LanguageSelector.from(te),me.uri,me.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(te,me,Fe){return at.registerCodeActionProvider(Le,ht(te),me,Fe)},registerDocumentPasteEditProvider(te,me,Fe){return(0,Me.checkProposedApiEnabled)(Le,"documentPaste"),at.registerDocumentPasteEditProvider(Le,ht(te),me,Fe)},registerCodeLensProvider(te,me){return at.registerCodeLensProvider(Le,ht(te),me)},registerDefinitionProvider(te,me){return at.registerDefinitionProvider(Le,ht(te),me)},registerDeclarationProvider(te,me){return at.registerDeclarationProvider(Le,ht(te),me)},registerImplementationProvider(te,me){return at.registerImplementationProvider(Le,ht(te),me)},registerTypeDefinitionProvider(te,me){return at.registerTypeDefinitionProvider(Le,ht(te),me)},registerHoverProvider(te,me){return at.registerHoverProvider(Le,ht(te),me,Le.identifier)},registerEvaluatableExpressionProvider(te,me){return at.registerEvaluatableExpressionProvider(Le,ht(te),me,Le.identifier)},registerInlineValuesProvider(te,me){return at.registerInlineValuesProvider(Le,ht(te),me,Le.identifier)},registerDocumentHighlightProvider(te,me){return at.registerDocumentHighlightProvider(Le,ht(te),me)},registerLinkedEditingRangeProvider(te,me){return at.registerLinkedEditingRangeProvider(Le,ht(te),me)},registerReferenceProvider(te,me){return at.registerReferenceProvider(Le,ht(te),me)},registerRenameProvider(te,me){return at.registerRenameProvider(Le,ht(te),me)},registerDocumentSymbolProvider(te,me,Fe){return at.registerDocumentSymbolProvider(Le,ht(te),me,Fe)},registerWorkspaceSymbolProvider(te){return at.registerWorkspaceSymbolProvider(Le,te)},registerDocumentFormattingEditProvider(te,me){return at.registerDocumentFormattingEditProvider(Le,ht(te),me)},registerDocumentRangeFormattingEditProvider(te,me){return at.registerDocumentRangeFormattingEditProvider(Le,ht(te),me)},registerOnTypeFormattingEditProvider(te,me,Fe,...it){return at.registerOnTypeFormattingEditProvider(Le,ht(te),me,[Fe].concat(it))},registerDocumentSemanticTokensProvider(te,me,Fe){return at.registerDocumentSemanticTokensProvider(Le,ht(te),me,Fe)},registerDocumentRangeSemanticTokensProvider(te,me,Fe){return at.registerDocumentRangeSemanticTokensProvider(Le,ht(te),me,Fe)},registerSignatureHelpProvider(te,me,Fe,...it){return typeof Fe=="object"?at.registerSignatureHelpProvider(Le,ht(te),me,Fe):at.registerSignatureHelpProvider(Le,ht(te),me,typeof Fe>"u"?[]:[Fe,...it])},registerCompletionItemProvider(te,me,...Fe){return at.registerCompletionItemProvider(Le,ht(te),me,Fe)},registerInlineCompletionItemProvider(te,me,Fe){return me.handleDidShowCompletionItem&&(0,Me.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),me.handleDidPartiallyAcceptCompletionItem&&(0,Me.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),Fe&&(0,Me.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),at.registerInlineCompletionsProvider(Le,ht(te),me,Fe)},registerDocumentLinkProvider(te,me){return at.registerDocumentLinkProvider(Le,ht(te),me)},registerColorProvider(te,me){return at.registerColorProvider(Le,ht(te),me)},registerFoldingRangeProvider(te,me){return at.registerFoldingRangeProvider(Le,ht(te),me)},registerSelectionRangeProvider(te,me){return at.registerSelectionRangeProvider(Le,te,me)},registerCallHierarchyProvider(te,me){return at.registerCallHierarchyProvider(Le,te,me)},registerTypeHierarchyProvider(te,me){return at.registerTypeHierarchyProvider(Le,te,me)},setLanguageConfiguration:(te,me)=>at.setLanguageConfiguration(Le,te,me),getTokenInformationAtPosition(te,me){return(0,Me.checkProposedApiEnabled)(Le,"tokenInformation"),si.tokenAtPosition(te,me)},registerInlayHintsProvider(te,me){return at.registerInlayHintsProvider(Le,te,me)},createLanguageStatusItem(te,me){return si.createLanguageStatusItem(Le,te,me)},registerDocumentDropEditProvider(te,me,Fe){return at.registerDocumentOnDropEditProvider(Le,te,me,(0,Me.isProposedApiEnabled)(Le,"dropMetadata")?Fe:void 0)}},sn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return pt.activeTerminal},get terminals(){return pt.terminals},async showTextDocument(te,me,Fe){const it=await(T.URI.isUri(te)?Promise.resolve(Fi.openTextDocument(te)):Promise.resolve(te));return Pt.showTextDocument(it,me,Fe)},createTextEditorDecorationType(te){return Pt.createTextEditorDecorationType(Le,te)},onDidChangeActiveTextEditor(te,me,Fe){return Pt.onDidChangeActiveTextEditor(te,me,Fe)},onDidChangeVisibleTextEditors(te,me,Fe){return Pt.onDidChangeVisibleTextEditors(te,me,Fe)},onDidChangeTextEditorSelection(te,me,Fe){return Pt.onDidChangeTextEditorSelection(te,me,Fe)},onDidChangeTextEditorOptions(te,me,Fe){return Pt.onDidChangeTextEditorOptions(te,me,Fe)},onDidChangeTextEditorVisibleRanges(te,me,Fe){return Pt.onDidChangeTextEditorVisibleRanges(te,me,Fe)},onDidChangeTextEditorViewColumn(te,me,Fe){return Pt.onDidChangeTextEditorViewColumn(te,me,Fe)},onDidCloseTerminal(te,me,Fe){return pt.onDidCloseTerminal(te,me,Fe)},onDidOpenTerminal(te,me,Fe){return pt.onDidOpenTerminal(te,me,Fe)},onDidChangeActiveTerminal(te,me,Fe){return pt.onDidChangeActiveTerminal(te,me,Fe)},onDidChangeTerminalDimensions(te,me,Fe){return(0,Me.checkProposedApiEnabled)(Le,"terminalDimensions"),pt.onDidChangeTerminalDimensions(te,me,Fe)},onDidChangeTerminalState(te,me,Fe){return pt.onDidChangeTerminalState(te,me,Fe)},onDidWriteTerminalData(te,me,Fe){return(0,Me.checkProposedApiEnabled)(Le,"terminalDataWriteEvent"),pt.onDidWriteTerminalData(te,me,Fe)},get state(){return Je.getState(Le)},onDidChangeWindowState(te,me,Fe){return Je.onDidChangeWindowState(te,me,Fe)},showInformationMessage(te,...me){return bi.showMessage(Le,M.default.Info,te,me[0],me.slice(1))},showWarningMessage(te,...me){return bi.showMessage(Le,M.default.Warning,te,me[0],me.slice(1))},showErrorMessage(te,...me){return bi.showMessage(Le,M.default.Error,te,me[0],me.slice(1))},showQuickPick(te,me,Fe){return Zt.showQuickPick(Le,te,me,Fe)},showWorkspaceFolderPick(te){return Zt.showWorkspaceFolderPick(te)},showInputBox(te,me){return Zt.showInput(te,me)},showOpenDialog(te){return Hi.showOpenDialog(Le,te)},showSaveDialog(te){return Hi.showSaveDialog(te)},createStatusBarItem(te,me,Fe){let it,bt,kt;return typeof te=="string"?(it=te,bt=me,kt=Fe):(bt=te,kt=me),Ri.createStatusBarEntry(Le,it,bt,kt)},setStatusBarMessage(te,me){return Ri.setStatusBarMessage(te,me)},withScmProgress(te){return ze.report("window.withScmProgress",Le,"Use 'withProgress' instead."),pi.withProgress(Le,{location:Y.ProgressLocation.SourceControl},(me,Fe)=>te({report(it){}}))},withProgress(te,me){return pi.withProgress(Le,te,me)},createOutputChannel(te,me){return Yi.createOutputChannel(te,me,Le)},createWebviewPanel(te,me,Fe,it){return Ei.createWebviewPanel(Le,te,me,Fe,it)},createWebviewTextEditorInset(te,me,Fe,it){return(0,Me.checkProposedApiEnabled)(Le,"editorInsets"),yi.createWebviewEditorInset(te,me,Fe,it,Le)},createTerminal(te,me,Fe){return typeof te=="object"?"pty"in te?pt.createExtensionTerminal(te):pt.createTerminalFromOptions(te):pt.createTerminal(te,me,Fe)},registerTerminalLinkProvider(te){return pt.registerLinkProvider(te)},registerTerminalProfileProvider(te,me){return pt.registerProfileProvider(Le,te,me)},registerTerminalQuickFixProvider(te,me){return(0,Me.checkProposedApiEnabled)(Le,"terminalQuickFixProvider"),pt.registerTerminalQuickFixProvider(te,Le.identifier.value,me)},registerTreeDataProvider(te,me){return mi.registerTreeDataProvider(te,me,Le)},createTreeView(te,me){return mi.createTreeView(te,me,Le)},registerWebviewPanelSerializer:(te,me)=>Ei.registerWebviewPanelSerializer(Le,te,me),registerCustomEditorProvider:(te,me,Fe={})=>xi.registerCustomEditorProvider(Le,te,me,Fe),registerFileDecorationProvider(te){return vt.registerFileDecorationProvider(te,Le)},registerUriHandler(te){return hi.registerUriHandler(Le,te)},createQuickPick(){return Zt.createQuickPick(Le)},createInputBox(){return Zt.createInputBox(Le)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(te,me,Fe){return Ti.onDidChangeActiveColorTheme(te,me,Fe)},registerWebviewViewProvider(te,me,Fe){return Bi.registerWebviewViewProvider(Le,te,me,Fe?.webviewOptions)},get activeNotebookEditor(){return _t.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,me,Fe){return _t.onDidChangeActiveNotebookEditor(te,me,Fe)},get visibleNotebookEditors(){return _t.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return _t.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,me,Fe){return fi.onDidChangeNotebookEditorSelection(te,me,Fe)},onDidChangeNotebookEditorVisibleRanges(te,me,Fe){return fi.onDidChangeNotebookEditorVisibleRanges(te,me,Fe)},showNotebookDocument(te,me){return _t.showNotebookDocument(te,me)},registerExternalUriOpener(te,me,Fe){return(0,Me.checkProposedApiEnabled)(Le,"externalUriOpener"),Zi.registerExternalUriOpener(Le.identifier,te,me,Fe)},registerProfileContentHandler(te,me){return(0,Me.checkProposedApiEnabled)(Le,"profileContentHandlers"),en.registrProfileContentHandler(Le,te,me)},registerQuickDiffProvider(te,me,Fe,it){return(0,Me.checkProposedApiEnabled)(Le,"quickDiffProvider"),Ui.registerQuickDiffProvider(ht(te),me,Fe,it)},get tabGroups(){return Dt.tabGroups},registerShareProvider(te,me){return(0,Me.checkProposedApiEnabled)(Le,"shareProvider"),Ci.registerShareProvider(ht(te),me)}},Fi={get rootPath(){return ze.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(te){throw O.readonly()},getWorkspaceFolder(te){return ot.getWorkspaceFolder(te)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(te){throw O.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(te){throw O.readonly()},updateWorkspaceFolders:(te,me,...Fe)=>ot.updateWorkspaceFolders(Le,te,me||0,...Fe),onDidChangeWorkspaceFolders:function(te,me,Fe){return ot.onDidChangeWorkspace(te,me,Fe)},asRelativePath:(te,me)=>ot.getRelativePath(te,me),findFiles:(te,me,Fe,it)=>ot.findFiles(te,me,Fe,Le.identifier,it),findTextInFiles:(te,me,Fe,it)=>{(0,Me.checkProposedApiEnabled)(Le,"findTextInFiles");let bt,kt;return typeof me=="object"?(bt=me,kt=Fe):(bt={},kt=me,it=Fe),ot.findTextInFiles(te,bt||{},kt,Le.identifier,it)},save:te=>((0,Me.checkProposedApiEnabled)(Le,"saveEditor"),ot.save(te)),saveAs:te=>((0,Me.checkProposedApiEnabled)(Le,"saveEditor"),ot.saveAs(te)),saveAll:te=>ot.saveAll(te),applyEdit(te,me){return $i.applyWorkspaceEdit(te,Le,me)},createFileSystemWatcher:(te,me,Fe,it)=>jt.createFileSystemWatcher(ot,Le,te,me,Fe,it),get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw O.readonly()},openTextDocument(te){let me;const Fe=te;if(typeof te=="string")me=Promise.resolve(T.URI.file(te));else if(T.URI.isUri(te))me=Promise.resolve(te);else if(!Fe||typeof Fe=="object")me=It.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(it=>It.ensureDocumentData(it).then(bt=>bt.document))},onDidOpenTextDocument:(te,me,Fe)=>It.onDidAddDocument(te,me,Fe),onDidCloseTextDocument:(te,me,Fe)=>It.onDidRemoveDocument(te,me,Fe),onDidChangeTextDocument:(te,me,Fe)=>It.onDidChangeDocument(te,me,Fe),onDidSaveTextDocument:(te,me,Fe)=>It.onDidSaveDocument(te,me,Fe),onWillSaveTextDocument:(te,me,Fe)=>qt.getOnWillSaveTextDocumentEvent(Le)(te,me,Fe),get notebookDocuments(){return _t.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,me){let Fe;if(T.URI.isUri(te))Fe=te,await _t.openNotebookDocument(te);else if(typeof te=="string")Fe=T.URI.revive(await _t.createNotebookDocument({viewType:te,content:me}));else throw new Error("Invalid arguments");return _t.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(te,me,Fe){return _i.onDidSaveNotebookDocument(te,me,Fe)},onDidChangeNotebookDocument(te,me,Fe){return _i.onDidChangeNotebookDocument(te,me,Fe)},onWillSaveNotebookDocument(te,me,Fe){return ni.getOnWillSaveNotebookDocumentEvent(Le)(te,me,Fe)},get onDidOpenNotebookDocument(){return _t.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return _t.onDidCloseNotebookDocument},registerNotebookSerializer(te,me,Fe,it){return _t.registerNotebookSerializer(Le,te,me,Fe,(0,Me.isProposedApiEnabled)(Le,"notebookLiveShare")?it:void 0)},onDidChangeConfiguration:(te,me,Fe)=>Gt.onDidChangeConfiguration(te,me,Fe),getConfiguration(te,me){return me=arguments.length===1?void 0:me,Gt.getConfiguration(te,me,Le)},registerTextDocumentContentProvider(te,me){return Si.registerTextDocumentContentProvider(te,me)},registerTaskProvider:(te,me)=>(ze.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),$t.registerTaskProvider(Le,te,me)),registerFileSystemProvider(te,me,Fe){return(0,Be.combinedDisposable)(Di.registerFileSystemProvider(Le,te,me,Fe),Ft.addFileSystemProvider(te,me,Fe))},get fs(){return Ft.value},registerFileSearchProvider:(te,me)=>((0,Me.checkProposedApiEnabled)(Le,"fileSearchProvider"),Qt.registerFileSearchProvider(te,me)),registerTextSearchProvider:(te,me)=>((0,Me.checkProposedApiEnabled)(Le,"textSearchProvider"),Qt.registerTextSearchProvider(te,me)),registerRemoteAuthorityResolver:(te,me)=>((0,Me.checkProposedApiEnabled)(Le,"resolvers"),yt.registerRemoteAuthorityResolver(te,me)),registerResourceLabelFormatter:te=>((0,Me.checkProposedApiEnabled)(Le,"resolvers"),ki.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Me.checkProposedApiEnabled)(Le,"resolvers"),yt.getRemoteExecServer(te)),onDidCreateFiles:(te,me,Fe)=>jt.onDidCreateFile(te,me,Fe),onDidDeleteFiles:(te,me,Fe)=>jt.onDidDeleteFile(te,me,Fe),onDidRenameFiles:(te,me,Fe)=>jt.onDidRenameFile(te,me,Fe),onWillCreateFiles:(te,me,Fe)=>jt.getOnWillCreateFileEvent(Le)(te,me,Fe),onWillDeleteFiles:(te,me,Fe)=>jt.getOnWillDeleteFileEvent(Le)(te,me,Fe),onWillRenameFiles:(te,me,Fe)=>jt.getOnWillRenameFileEvent(Le)(te,me,Fe),openTunnel:te=>((0,Me.checkProposedApiEnabled)(Le,"tunnels"),je.openTunnel(Le,te).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,Me.checkProposedApiEnabled)(Le,"tunnels"),je.getTunnels()},onDidChangeTunnels:(te,me,Fe)=>((0,Me.checkProposedApiEnabled)(Le,"tunnels"),je.onDidChangeTunnels(te,me,Fe)),registerPortAttributesProvider:(te,me)=>((0,Me.checkProposedApiEnabled)(Le,"portsAttributes"),je.registerPortsAttributesProvider(te,me)),registerTunnelProvider:(te,me)=>((0,Me.checkProposedApiEnabled)(Le,"tunnelFactory"),je.registerTunnelProvider(te,me)),registerTimelineProvider:(te,me)=>((0,Me.checkProposedApiEnabled)(Le,"timeline"),Pi.registerTimelineProvider(te,me,Le.identifier,ut.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:te=>((0,Me.checkProposedApiEnabled)(Le,"workspaceTrust"),ot.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,me,Fe)=>ot.onDidGrantWorkspaceTrust(te,me,Fe),registerEditSessionIdentityProvider:(te,me)=>((0,Me.checkProposedApiEnabled)(Le,"editSessionIdentityProvider"),ot.registerEditSessionIdentityProvider(te,me)),onWillCreateEditSessionIdentity:(te,me,Fe)=>((0,Me.checkProposedApiEnabled)(Le,"editSessionIdentityProvider"),ot.getOnWillCreateEditSessionIdentityEvent(Le)(te,me,Fe)),registerCanonicalUriProvider:(te,me)=>((0,Me.checkProposedApiEnabled)(Le,"canonicalUriProvider"),ot.registerCanonicalUriProvider(te,me)),getCanonicalUri:(te,me,Fe)=>((0,Me.checkProposedApiEnabled)(Le,"canonicalUriProvider"),ot.provideCanonicalUri(te,me,Fe))},ji={get inputBox(){return ze.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),gi.getLastInputBox(Le)},createSourceControl(te,me,Fe){return gi.createSourceControl(Le,te,me,Fe)}},on={createCommentController(te,me){return Ii.createCommentController(Le,te,me)}},an={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},get stackFrameFocus(){return ft.stackFrameFocus},onDidStartDebugSession(te,me,Fe){return ft.onDidStartDebugSession(te,me,Fe)},onDidTerminateDebugSession(te,me,Fe){return ft.onDidTerminateDebugSession(te,me,Fe)},onDidChangeActiveDebugSession(te,me,Fe){return ft.onDidChangeActiveDebugSession(te,me,Fe)},onDidReceiveDebugSessionCustomEvent(te,me,Fe){return ft.onDidReceiveDebugSessionCustomEvent(te,me,Fe)},onDidChangeBreakpoints(te,me,Fe){return ft.onDidChangeBreakpoints(te,me,Fe)},onDidChangeStackFrameFocus(te,me,Fe){return(0,Me.checkProposedApiEnabled)(Le,"debugFocus"),ft.onDidChangeStackFrameFocus(te,me,Fe)},registerDebugConfigurationProvider(te,me,Fe){return ft.registerDebugConfigurationProvider(te,me,Fe||Ge.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,me){return ft.registerDebugAdapterDescriptorFactory(Le,te,me)},registerDebugAdapterTrackerFactory(te,me){return ft.registerDebugAdapterTrackerFactory(te,me)},startDebugging(te,me,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?ft.startDebugging(te,me,{parentSession:Fe}):ft.startDebugging(te,me,Fe||{})},stopDebugging(te){return ft.stopDebugging(te)},addBreakpoints(te){return ft.addBreakpoints(te)},removeBreakpoints(te){return ft.removeBreakpoints(te)},asDebugSourceUri(te,me){return ft.asDebugSourceUri(te,me)}},Li={registerTaskProvider:(te,me)=>$t.registerTaskProvider(Le,te,me),fetchTasks:te=>$t.fetchTasks(te),executeTask:te=>$t.executeTask(Le,te),get taskExecutions(){return $t.taskExecutions},onDidStartTask:(te,me,Fe)=>$t.onDidStartTask(te,me,Fe),onDidEndTask:(te,me,Fe)=>$t.onDidEndTask(te,me,Fe),onDidStartTaskProcess:(te,me,Fe)=>$t.onDidStartTaskProcess(te,me,Fe),onDidEndTaskProcess:(te,me,Fe)=>$t.onDidEndTaskProcess(te,me,Fe)},Ki={createNotebookController(te,me,Fe,it,bt){return ai.createNotebookController(Le,te,me,Fe,it,(0,Me.isProposedApiEnabled)(Le,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(te,me)=>_t.registerNotebookCellStatusBarItemProvider(Le,te,me),createRendererMessaging(te){return Ji.createRendererMessaging(Le,te)},createNotebookControllerDetectionTask(te){return(0,Me.checkProposedApiEnabled)(Le,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(Le,te)},registerKernelSourceActionProvider(te,me){return(0,Me.checkProposedApiEnabled)(Le,"notebookKernelSource"),ai.registerKernelSourceActionProvider(Le,te,me)},onDidChangeNotebookCellExecutionState(te,me,Fe){return(0,Me.checkProposedApiEnabled)(Le,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState(te,me,Fe)}},Gi={t(...te){if(typeof te[0]=="string"){const me=te.shift(),Fe=!te||typeof te[0]!="object"?te:te[0];return di.getMessage(Le.identifier.value,{message:me,args:Fe})}return di.getMessage(Le.identifier.value,te[0])},get bundle(){return di.getBundle(Le.identifier.value)},get uri(){return di.getBundleUri(Le.identifier.value)}},Xi={_version:1,registerInteractiveEditorSessionProvider(te){return(0,Me.checkProposedApiEnabled)(Le,"interactive"),Ai.registerProvider(Le,te)},registerInteractiveSessionProvider(te,me){return(0,Me.checkProposedApiEnabled)(Le,"interactive"),Yt.registerChatProvider(Le,te,me)},addInteractiveRequest(te){return(0,Me.checkProposedApiEnabled)(Le,"interactive"),Yt.addChatRequest(te)},sendInteractiveRequestToProvider(te,me){return(0,Me.checkProposedApiEnabled)(Le,"interactive"),Yt.sendInteractiveRequestToProvider(te,me)},get onDidPerformUserAction(){return(0,Me.checkProposedApiEnabled)(Le,"interactiveUserActions"),Yt.onDidPerformUserAction},transferChatSession(te,me){return(0,Me.checkProposedApiEnabled)(Le,"interactive"),Yt.transferChatSession(te,me)}},cn={registerSlashCommandProvider(te,me){return(0,Me.checkProposedApiEnabled)(Le,"interactiveSlashCommands"),Yt.registerSlashCommandProvider(Le,te,me)}},ln={registerSemanticSimilarityProvider(te){return(0,Me.checkProposedApiEnabled)(Le,"semanticSimilarity"),tn.registerSemanticSimilarityProvider(Le,te)}};return{version:dt.version,ai:ln,authentication:rn,commands:Ht,comments:on,debug:an,env:ci,extensions:Vi,interactive:Xi,interactiveSlashCommands:cn,l10n:Gi,languages:qi,notebooks:Ki,scm:ji,tasks:Li,tests:Wi,window:sn,workspace:Fi,Breakpoint:Y.Breakpoint,TerminalOutputAnchor:Y.TerminalOutputAnchor,CallHierarchyIncomingCall:Y.CallHierarchyIncomingCall,CallHierarchyItem:Y.CallHierarchyItem,CallHierarchyOutgoingCall:Y.CallHierarchyOutgoingCall,CancellationError:O.CancellationError,CancellationTokenSource:w.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:Y.CodeAction,CodeActionKind:Y.CodeActionKind,CodeActionTriggerKind:Y.CodeActionTriggerKind,CodeLens:Y.CodeLens,Color:Y.Color,ColorInformation:Y.ColorInformation,ColorPresentation:Y.ColorPresentation,ColorThemeKind:Y.ColorThemeKind,CommentMode:Y.CommentMode,CommentState:Y.CommentState,CommentThreadCollapsibleState:Y.CommentThreadCollapsibleState,CommentThreadState:Y.CommentThreadState,CompletionItem:Y.CompletionItem,CompletionItemKind:Y.CompletionItemKind,CompletionItemTag:Y.CompletionItemTag,CompletionList:Y.CompletionList,CompletionTriggerKind:Y.CompletionTriggerKind,ConfigurationTarget:Y.ConfigurationTarget,CustomExecution:Y.CustomExecution,DebugAdapterExecutable:Y.DebugAdapterExecutable,DebugAdapterInlineImplementation:Y.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:Y.DebugAdapterNamedPipeServer,DebugAdapterServer:Y.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ge.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Y.DebugConsoleMode,DecorationRangeBehavior:Y.DecorationRangeBehavior,Diagnostic:Y.Diagnostic,DiagnosticRelatedInformation:Y.DiagnosticRelatedInformation,DiagnosticSeverity:Y.DiagnosticSeverity,DiagnosticTag:Y.DiagnosticTag,Disposable:Y.Disposable,DocumentHighlight:Y.DocumentHighlight,DocumentHighlightKind:Y.DocumentHighlightKind,DocumentLink:Y.DocumentLink,DocumentSymbol:Y.DocumentSymbol,EndOfLine:Y.EndOfLine,EnvironmentVariableMutatorType:Y.EnvironmentVariableMutatorType,EvaluatableExpression:Y.EvaluatableExpression,InlineValueText:Y.InlineValueText,InlineValueVariableLookup:Y.InlineValueVariableLookup,InlineValueEvaluatableExpression:Y.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:Y.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:Y.ExtensionKind,ExtensionMode:Y.ExtensionMode,ExternalUriOpenerPriority:Y.ExternalUriOpenerPriority,FileChangeType:Y.FileChangeType,FileDecoration:Y.FileDecoration,FileDecoration2:Y.FileDecoration,FileSystemError:Y.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:Y.FoldingRange,FoldingRangeKind:Y.FoldingRangeKind,FunctionBreakpoint:Y.FunctionBreakpoint,InlineCompletionItem:Y.InlineSuggestion,InlineCompletionList:Y.InlineSuggestionList,Hover:Y.Hover,IndentAction:p.IndentAction,Location:Y.Location,MarkdownString:Y.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:Y.ParameterInformation,PortAutoForwardAction:Y.PortAutoForwardAction,Position:Y.Position,ProcessExecution:Y.ProcessExecution,ProgressLocation:Y.ProgressLocation,QuickInputButtons:Y.QuickInputButtons,Range:Y.Range,RelativePattern:Y.RelativePattern,Selection:Y.Selection,SelectionRange:Y.SelectionRange,SemanticTokens:Y.SemanticTokens,SemanticTokensBuilder:Y.SemanticTokensBuilder,SemanticTokensEdit:Y.SemanticTokensEdit,SemanticTokensEdits:Y.SemanticTokensEdits,SemanticTokensLegend:Y.SemanticTokensLegend,ShellExecution:Y.ShellExecution,ShellQuoting:Y.ShellQuoting,SignatureHelp:Y.SignatureHelp,SignatureHelpTriggerKind:Y.SignatureHelpTriggerKind,SignatureInformation:Y.SignatureInformation,SnippetString:Y.SnippetString,SourceBreakpoint:Y.SourceBreakpoint,StandardTokenType:Y.StandardTokenType,StatusBarAlignment:Y.StatusBarAlignment,SymbolInformation:Y.SymbolInformation,SymbolKind:Y.SymbolKind,SymbolTag:Y.SymbolTag,Task:Y.Task,TaskGroup:Y.TaskGroup,TaskPanelKind:Y.TaskPanelKind,TaskRevealKind:Y.TaskRevealKind,TaskScope:Y.TaskScope,TerminalLink:Y.TerminalLink,TerminalQuickFixCommand:Y.TerminalQuickFixCommand,TerminalQuickFixOpener:Y.TerminalQuickFixOpener,TerminalLocation:Y.TerminalLocation,TerminalProfile:Y.TerminalProfile,TerminalExitReason:Y.TerminalExitReason,TerminalQuickFixType:Y.TerminalQuickFixType,TextDocumentSaveReason:Y.TextDocumentSaveReason,TextEdit:Y.TextEdit,SnippetTextEdit:Y.SnippetTextEdit,TextEditorCursorStyle:h.TextEditorCursorStyle,TextEditorLineNumbersStyle:Y.TextEditorLineNumbersStyle,TextEditorRevealType:Y.TextEditorRevealType,TextEditorSelectionChangeKind:Y.TextEditorSelectionChangeKind,TextDocumentChangeReason:Y.TextDocumentChangeReason,ThemeColor:Y.ThemeColor,ThemeIcon:Y.ThemeIcon,TreeItem:Y.TreeItem,TreeItemCheckboxState:Y.TreeItemCheckboxState,TreeItemCollapsibleState:Y.TreeItemCollapsibleState,TypeHierarchyItem:Y.TypeHierarchyItem,UIKind:S.UIKind,Uri:T.URI,ViewColumn:Y.ViewColumn,WorkspaceEdit:Y.WorkspaceEdit,DocumentDropEdit:Y.DocumentDropEdit,DocumentPasteEdit:Y.DocumentPasteEdit,InlayHint:Y.InlayHint,InlayHintLabelPart:Y.InlayHintLabelPart,InlayHintKind:Y.InlayHintKind,RemoteAuthorityResolverError:Y.RemoteAuthorityResolverError,ResolvedAuthority:Y.ResolvedAuthority,ManagedResolvedAuthority:Y.ManagedResolvedAuthority,SourceControlInputBoxValidationType:Y.SourceControlInputBoxValidationType,ExtensionRuntime:Y.ExtensionRuntime,TimelineItem:Y.TimelineItem,NotebookRange:Y.NotebookRange,NotebookCellKind:Y.NotebookCellKind,NotebookCellExecutionState:Y.NotebookCellExecutionState,NotebookCellData:Y.NotebookCellData,NotebookData:Y.NotebookData,NotebookRendererScript:Y.NotebookRendererScript,NotebookCellStatusBarAlignment:Y.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Y.NotebookEditorRevealType,NotebookCellOutput:Y.NotebookCellOutput,NotebookCellOutputItem:Y.NotebookCellOutputItem,NotebookCellStatusBarItem:Y.NotebookCellStatusBarItem,NotebookControllerAffinity:Y.NotebookControllerAffinity,NotebookControllerAffinity2:Y.NotebookControllerAffinity2,NotebookEdit:Y.NotebookEdit,NotebookKernelSourceAction:Y.NotebookKernelSourceAction,PortAttributes:Y.PortAttributes,LinkedEditingRanges:Y.LinkedEditingRanges,TestResultState:Y.TestResultState,TestRunRequest:Y.TestRunRequest,TestRunRequest2:Y.TestRunRequest2,TestMessage:Y.TestMessage,TestTag:Y.TestTag,TestRunProfileKind:Y.TestRunProfileKind,TextSearchCompleteMessageType:Ze.TextSearchCompleteMessageType,DataTransfer:Y.DataTransfer,DataTransferItem:Y.DataTransferItem,CoveredCount:Y.CoveredCount,FileCoverage:Y.FileCoverage,StatementCoverage:Y.StatementCoverage,BranchCoverage:Y.BranchCoverage,FunctionCoverage:Y.FunctionCoverage,WorkspaceTrustState:Y.WorkspaceTrustState,LanguageStatusSeverity:Y.LanguageStatusSeverity,QuickPickItemKind:Y.QuickPickItemKind,InputBoxValidationSeverity:Y.InputBoxValidationSeverity,TabInputText:Y.TextTabInput,TabInputTextDiff:Y.TextDiffTabInput,TabInputTextMerge:Y.TextMergeTabInput,TabInputCustom:Y.CustomEditorTabInput,TabInputNotebook:Y.NotebookEditorTabInput,TabInputNotebookDiff:Y.NotebookDiffEditorTabInput,TabInputWebview:Y.WebviewEditorTabInput,TabInputTerminal:Y.TerminalEditorTabInput,TabInputInteractiveWindow:Y.InteractiveWindowInput,TelemetryTrustedValue:Ee.TelemetryTrustedValue,LogLevel:Ce.LogLevel,EditSessionIdentityMatch:mt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Y.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Y.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Y.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Y.StackFrameFocus,ThreadFocus:Y.ThreadFocus,NotebookCodeActionKind:Y.NotebookCodeActionKind}}}e.createApiFactoryAndRegisterActors=Ot}),define(Pe[269],Ae([1,0,72,109,33,107,34,32,60,63,111,113,114,84,86,80,108,62,39,83,58,61,236,14,112,81,82]),function(pe,e,w,O,I,M,T,h,y,p,A,_,c,S,E,o,t,i,a,g,C,k,r,d,n,s,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(s.IExtHostLocalizationService,s.ExtHostLocalizationService,1),(0,w.registerSingleton)(d.ILoggerService,r.ExtHostLoggerService,1),(0,w.registerSingleton)(o.IExtHostApiDeprecationService,o.ExtHostApiDeprecationService,1),(0,w.registerSingleton)(h.IExtHostCommands,h.ExtHostCommands,0),(0,w.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration,0),(0,w.registerSingleton)(i.IExtHostConsumerFileSystem,i.ExtHostConsumerFileSystem,0),(0,w.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService,0),(0,w.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,w.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,w.registerSingleton)(v.IExtHostManagedSockets,v.ExtHostManagedSockets,0),(0,w.registerSingleton)(a.IExtHostFileSystemInfo,a.ExtHostFileSystemInfo,0),(0,w.registerSingleton)(O.IExtHostOutputService,O.ExtHostOutputService,1),(0,w.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch,0),(0,w.registerSingleton)(S.IExtHostStorage,S.ExtHostStorage,0),(0,w.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask,0),(0,w.registerSingleton)(p.IExtHostTerminalService,p.WorkerExtHostTerminalService,0),(0,w.registerSingleton)(E.IExtHostTunnelService,E.ExtHostTunnelService,0),(0,w.registerSingleton)(t.IExtHostWindow,t.ExtHostWindow,0),(0,w.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace,0),(0,w.registerSingleton)(g.IExtHostSecretState,g.ExtHostSecretState,0),(0,w.registerSingleton)(C.IExtHostTelemetry,C.ExtHostTelemetry,0),(0,w.registerSingleton)(k.IExtHostEditorTabs,k.ExtHostEditorTabs,0),(0,w.registerSingleton)(n.IExtHostVariableResolverProvider,n.ExtHostVariableResolverProviderService,0)}),define(Pe[270],Ae([1,0,268,35,2,265,7,16,256]),function(pe,e,w,O,I,M,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class p extends M.RequireInterceptor{_installInterceptor(){}getModule(S,E){for(const o of this._alternatives){const t=o(S);if(t){S=t;break}}if(this._factories.has(S))return this._factories.get(S).load(S,E,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends O.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(y.ExtHostConsoleForwarder);const S=this._instaService.invokeFunction(w.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(p,S,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(S){return S.browser}async _loadCommonJSModule(S,E,o){E=E.with({path:_(E.path,".js")});const t=S?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=I.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(E)),a=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),a.status!==200)throw new Error(a.statusText);const g=await a.text(),C=`${E.toString(!0)}#vscode-extension`,k=`${g}
//# sourceURL=${C}`;let r;try{r=new Function("module","exports","require",k)}catch(v){throw console.error(t?`Loading code for extension ${t} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${E.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}S&&await this._extHostLocalizationService.initializeLocalizedMessages(S);const d={},n={exports:d},s=v=>{const D=this._fakeModules.getModule(v,E);if(D===void 0)throw new Error(`Cannot load module '${v}'`);return D};try{return o.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(n,d,s),n.exports!==d?n.exports:d}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}}async $setRemoteEnvironment(S){}async _waitForDebuggerAttachment(S=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const E=Date.now()+S;for(;Date.now()<E&&!("__jsDebugIsReady"in globalThis);)await(0,h.timeout)(10)}}e.ExtHostExtensionService=A;function _(c,S){return c.endsWith(S)?c:c+S}}),define(Pe[271],Ae([1,0,71,72,14,35,188,85,270]),function(pe,e,w,O,I,M,T,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,O.registerSingleton)(I.ILogService,new w.SyncDescriptor(T.ExtHostLogService,[!0],!0)),(0,O.registerSingleton)(M.IExtHostExtensionService,y.ExtHostExtensionService,0),(0,O.registerSingleton)(h.IExtensionStoragePaths,h.ExtensionStoragePaths,0)}),define(Pe[279],Ae([1,0,25,5,79,266,258,19,87,13,2,269,271]),function(pe,e,w,O,I,M,T,h,y,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const c=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function S(r){return/^(file|vscode-remote):/i.test(r)}const E=fetch.bind(self);function o(r){self.fetch=async function(d,n){return d instanceof Request||S(String(d))&&(d=(await r(A.URI.parse(String(d)))).toString(!0)),E(d,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,n,s,v,D){(async()=>(S(n.toString())&&(n=(await r(A.URI.parse(n.toString()))).toString(!0)),super.open(d,n,s??!0,v,D)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(d,n){if(/^file:/i.test(d.toString()))d=p.FileAccess.uriToBrowserUri(A.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const v=`(${function(b){function l(z){return typeof z=="string"||z instanceof URL?String(z).replace(/^file:\/\//i,"vscode-file://vscode-app"):z}const f=fetch.bind(self);self.fetch=function(z,$){return z instanceof Request?f(z,$):f(l(z),$)},self.XMLHttpRequest=class extends XMLHttpRequest{open(z,$,H,x,U){return super.open(z,l($),H??!0,x,U)}};const P=importScripts.bind(self);self.importScripts=(...z)=>{P(...z.map(l))},P(b)}.toString()}('${d}'))`;n=n||{},n.name=n.name||h.basename(d.toString());const D=new Blob([v],{type:"application/javascript"}),u=URL.createObjectURL(D);return new r(u,n)}}else self.Worker=class extends T.NestedWorker{constructor(r,d){super(c,r,{name:h.basename(r.toString()),...d})}};const t=new class{constructor(){this.pid=void 0}exit(r){_()}};class i{constructor(){const d=new MessageChannel,n=new O.Emitter;let s=!1;c(d.port2,[d.port2]),d.port1.onmessage=v=>{const{data:D}=v;if(!(D instanceof ArrayBuffer)){console.warn("UNKNOWN data received",D);return}const u=w.VSBuffer.wrap(new Uint8Array(D,0,D.byteLength));if((0,I.isMessageOfType)(u,2)){s=!0,g("received terminate message from renderer");return}n.fire(u)},this.protocol={onMessage:n.event,send:v=>{if(!s){const D=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);d.port1.postMessage(D,[D])}}}}}function a(r){return new Promise(d=>{const n=r.onMessage(s=>{n.dispose();const v=JSON.parse(s.toString());r.send((0,I.createMessageOfType)(0)),d({protocol:r,initData:v})});r.send((0,I.createMessageOfType)(1))})}let g=r=>_();function C(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function k(){y.mark("code/extHost/willConnectToRenderer");const r=new i;return{onmessage(d){C(d)&&a(r.protocol).then(n=>{y.mark("code/extHost/didWaitForInitData");const s=new M.ExtensionHostMain(n.protocol,n.initData,t,null,d.data);o(v=>s.asBrowserUri(v)),g=v=>s.terminate(v)})}}}e.create=k})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/aef377c42cea6e9aea642829953104f07097abfa/core/vs/workbench/api/worker/extensionHostWorker.js.map
