/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var W=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableImpl/logging","vs/base/common/errors","vs/base/common/observableImpl/base","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableImpl/autorun","vs/base/common/observableImpl/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableImpl/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],j=function(U){for(var e=[],E=0,T=U.length;E<T;E++)e[E]=W[U[E]];return e};define(W[21],j([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class E{static get(){const k=new Map,y=new Map,i=new Map,d=new Map;function t(u,n){u.has(n.detail)||u.set(n.detail,-n.timestamp)}function r(u,n){const o=u.get(n.detail);o&&(o>=0||u.set(n.detail,o+n.timestamp))}let l=[];typeof U=="function"&&typeof U.getStats=="function"&&(l=U.getStats().slice(0).sort((u,n)=>u.timestamp-n.timestamp));for(const u of l)switch(u.type){case 10:t(k,u);break;case 11:case 12:r(k,u);break;case 21:t(y,u);break;case 22:r(y,u);break;case 33:t(i,u);break;case 34:r(i,u);break;case 31:t(d,u);break;case 32:r(d,u);break}let a=0;i.forEach(u=>a+=u);function c(u){const n=[];return u.forEach((o,s)=>n.push([s,o])),n}return{amdLoad:c(k),amdInvoke:c(y),nodeRequire:c(i),nodeEval:c(d),nodeRequireTotal:a}}static toMarkdownTable(k,y){let i="";const d=[];return k.forEach((t,r)=>{d[r]=t.length}),y.forEach(t=>{t.forEach((r,l)=>{typeof r>"u"&&(r=t[l]="-");const a=r.toString().length;d[l]=Math.max(a,d[l])})}),k.forEach((t,r)=>{i+=`| ${t+" ".repeat(d[r]-t.toString().length)} `}),i+=`|
`,k.forEach((t,r)=>{i+=`| ${"-".repeat(d[r])} `}),i+=`|
`,y.forEach(t=>{t.forEach((r,l)=>{typeof r<"u"&&(i+=`| ${r+" ".repeat(d[l]-r.toString().length)} `)}),i+=`|
`}),i}}e.LoaderStats=E}),define(W[4],j([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=e.getLogger=e.setLogger=void 0;let E;function T(o){E=o}e.setLogger=T;function k(){return E}e.getLogger=k;class y{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(s){return i([d(u("|  ",this.indentation)),s])}formatInfo(s){return s.didChange?[d(" "),r(l(s.oldValue,70),{color:"red",strikeThrough:!0}),d(" "),r(l(s.newValue,60),{color:"green"})]:[d(" (unchanged)")]}handleObservableChanged(s,_){console.log(...this.textToConsoleArgs([t("observable value changed"),r(s.debugName,{color:"BlueViolet"}),...this.formatInfo(_)]))}formatChanges(s){if(s.size!==0)return r(" (changed deps: "+[...s].map(_=>_.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const _=s.handleChange;this.changedObservablesSets.set(s,new Set),s.handleChange=(O,A)=>(this.changedObservablesSets.get(s).add(O),_.apply(s,[O,A]))}handleDerivedRecomputed(s,_){const O=this.changedObservablesSets.get(s);console.log(...this.textToConsoleArgs([t("derived recomputed"),r(s.debugName,{color:"BlueViolet"}),...this.formatInfo(_),this.formatChanges(O)])),O.clear()}handleFromEventObservableTriggered(s,_){console.log(...this.textToConsoleArgs([t("observable from event triggered"),r(s.debugName,{color:"BlueViolet"}),...this.formatInfo(_)]))}handleAutorunCreated(s){const _=s.handleChange;this.changedObservablesSets.set(s,new Set),s.handleChange=(O,A)=>(this.changedObservablesSets.get(s).add(O),_.apply(s,[O,A]))}handleAutorunTriggered(s){const _=this.changedObservablesSets.get(s);console.log(...this.textToConsoleArgs([t("autorun"),r(s.debugName,{color:"BlueViolet"}),this.formatChanges(_)])),_.clear()}handleBeginTransaction(s){let _=s.getDebugName();_===void 0&&(_=""),console.log(...this.textToConsoleArgs([t("transaction"),r(_,{color:"BlueViolet"})])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=y;function i(o){const s=new Array,O={};let A="";function R(f){if("length"in f)for(const b of f)b&&R(b);else"text"in f?(A+=`%c${f.text}`,s.push(f.style),f.data&&Object.assign(O,f.data)):"data"in f&&Object.assign(O,f.data)}R(o);const w=[A,...s];return Object.keys(O).length>0&&w.push(O),w}function d(o){return r(o,{color:"black"})}function t(o){return r(n(`${o}: `,10),{color:"black",bold:!0})}function r(o,s={color:"black"}){function _(A){return Object.entries(A).reduce((R,[w,f])=>`${R}${w}:${f};`,"")}const O={color:s.color};return s.strikeThrough&&(O["text-decoration"]="line-through"),s.bold&&(O["font-weight"]="bold"),{text:o,style:_(O)}}function l(o,s){switch(typeof o){case"number":return""+o;case"string":return o.length+2<=s?`"${o}"`:`"${o.substr(0,s-7)}"+...`;case"boolean":return o?"true":"false";case"undefined":return"undefined";case"object":return o===null?"null":Array.isArray(o)?a(o,s):c(o,s);case"symbol":return o.toString();case"function":return`[[Function${o.name?" "+o.name:""}]]`;default:return""+o}}function a(o,s){let _="[ ",O=!0;for(const A of o){if(O||(_+=", "),_.length-5>s){_+="...";break}O=!1,_+=`${l(A,s-_.length)}`}return _+=" ]",_}function c(o,s){let _="{ ",O=!0;for(const[A,R]of Object.entries(o)){if(O||(_+=", "),_.length-5>s){_+="...";break}O=!1,_+=`${A}: ${l(R,s-_.length)}`}return _+=" }",_}function u(o,s){let _="";for(let O=1;O<=s;O++)_+=o;return _}function n(o,s){for(;o.length<s;)o+=" ";return o}}),define(W[9],j([0,1,42,2,4]),function(U,e,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunDelta=e.AutorunObserver=e.autorunWithStore=e.autorunWithStoreHandleChanges=e.autorunWithStore2=e.autorunHandleChanges=e.autorun=void 0;function y(u,n){return new a(u,n,void 0,void 0)}e.autorun=y;function i(u,n,o){return new a(u,o,n.createEmptyChangeSummary,n.handleChange)}e.autorunHandleChanges=i;function d(u,n){return r(n,u)}e.autorunWithStore2=d;function t(u,n,o){const s=new T.DisposableStore,_=i(u,{createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(O,A)=>{s.clear(),o(O,A,s)});return(0,T.toDisposable)(()=>{_.dispose(),s.dispose()})}e.autorunWithStoreHandleChanges=t;function r(u,n){const o=new T.DisposableStore,s=y(n,_=>{o.clear(),u(_,o)});return(0,T.toDisposable)(()=>{s.dispose(),o.dispose()})}e.autorunWithStore=r;var l;(function(u){u[u.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",u[u.stale=2]="stale",u[u.upToDate=3]="upToDate"})(l||(l={}));class a{constructor(n,o,s,_){this.debugName=n,this.runFn=o,this.createChangeSummary=s,this._handleChange=_,this.state=2,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,k.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded()}dispose(){this.disposed=!0;for(const n of this.dependencies)n.removeObserver(this);this.dependencies.clear()}_runIfNeeded(){if(this.state===3)return;const n=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=n,this.state=3,(0,k.getLogger)()?.handleAutorunTriggered(this);try{const o=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this.runFn(this,o)}finally{for(const o of this.dependenciesToBeRemoved)o.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===3&&(this.state=1),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===1){this.state=3;for(const n of this.dependencies)if(n.reportChanges(),this.state===2)break}this._runIfNeeded()}while(this.state!==3);this.updateCount--,(0,E.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(n){this.state===3&&this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)&&(this.state=1)}handleChange(n,o){this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)&&(!this._handleChange||this._handleChange({changedObservable:n,change:o,didChange:_=>_===n},this.changeSummary))&&(this.state=2)}readObservable(n){if(this.disposed)return n.get();n.addObserver(this);const o=n.get();return this.dependencies.add(n),this.dependenciesToBeRemoved.delete(n),o}}e.AutorunObserver=a,function(u){u.Observer=a}(y||(e.autorun=y={}));function c(u,n,o){let s;return y(u,_=>{const O=n.read(_),A=s;s=O,o({lastValue:A,newValue:O})})}e.autorunDelta=c}),define(W[6],j([0,1,4]),function(U,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.disposableObservableValue=e.ObservableValue=e.observableValue=e.getFunctionName=e.TransactionImpl=e.subtransaction=e.transaction=e.BaseObservable=e.ConvenientObservable=e._setDerived=void 0;let T;function k(o){T=o}e._setDerived=k;class y{get TChange(){return null}reportChanges(){this.get()}read(s){return s?s.readObservable(this):this.get()}map(s){return T(()=>{const _=l(s);return _!==void 0?_:`${this.debugName} (mapped)`},_=>s(this.read(_),_))}}e.ConvenientObservable=y;class i extends y{constructor(){super(...arguments),this.observers=new Set}addObserver(s){const _=this.observers.size;this.observers.add(s),_===0&&this.onFirstObserverAdded()}removeObserver(s){this.observers.delete(s)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=i;function d(o,s){const _=new r(o,s);try{(0,E.getLogger)()?.handleBeginTransaction(_),o(_)}finally{_.finish(),(0,E.getLogger)()?.handleEndTransaction()}}e.transaction=d;function t(o,s,_){o?s(o):d(s,_)}e.subtransaction=t;class r{constructor(s,_){this.fn=s,this._getDebugName=_,this.updatingObservers=[]}getDebugName(){return this._getDebugName?this._getDebugName():l(this.fn)}updateObserver(s,_){this.updatingObservers.push({observer:s,observable:_}),s.beginUpdate(_)}finish(){const s=this.updatingObservers;this.updatingObservers=null;for(const{observer:_,observable:O}of s)_.endUpdate(O)}}e.TransactionImpl=r;function l(o){const s=o.toString(),O=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(s);return(O?O[1]:void 0)?.trim()}e.getFunctionName=l;function a(o,s){return new c(o,s)}e.observableValue=a;class c extends i{constructor(s,_){super(),this.debugName=s,this._value=_}get(){return this._value}set(s,_,O){if(this._value===s)return;let A;_||(_=A=new r(()=>{},()=>`Setting ${this.debugName}`));try{const R=this._value;this._setValue(s),(0,E.getLogger)()?.handleObservableChanged(this,{oldValue:R,newValue:s,change:O,didChange:!0});for(const w of this.observers)_.updateObserver(w,this),w.handleChange(this,O)}finally{A&&A.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(s){this._value=s}}e.ObservableValue=c;function u(o,s){return new n(o,s)}e.disposableObservableValue=u;class n extends c{_setValue(s){this._value!==s&&(this._value&&this._value.dispose(),this._value=s)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=n}),define(W[10],j([0,1,5,2,6,4]),function(U,e,E,T,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Derived=e.derivedWithStore=e.derivedHandleChanges=e.derived=void 0;function i(a,c){return new l(a,c,void 0,void 0,void 0)}e.derived=i;function d(a,c,u){return new l(a,u,c.createEmptyChangeSummary,c.handleChange,void 0)}e.derivedHandleChanges=d;function t(a,c){const u=new T.DisposableStore;return new l(a,n=>(u.clear(),c(n,u)),void 0,void 0,()=>u.dispose())}e.derivedWithStore=t,(0,k._setDerived)(i);var r;(function(a){a[a.initial=0]="initial",a[a.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",a[a.stale=2]="stale",a[a.upToDate=3]="upToDate"})(r||(r={}));class l extends k.BaseObservable{get debugName(){return typeof this._debugName=="function"?this._debugName():this._debugName}constructor(c,u,n,o,s=void 0){super(),this._debugName=c,this.computeFn=u,this.createChangeSummary=n,this._handleChange=o,this._handleLastObserverRemoved=s,this.state=0,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,y.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=0,this.value=void 0;for(const c of this.dependencies)c.removeObserver(this);this.dependencies.clear(),this._handleLastObserverRemoved?.()}get(){if(this.observers.size===0){const c=this.computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),c}else{do{if(this.state===1){this.state=3;for(const c of this.dependencies)if(c.reportChanges(),this.state===2)break}this._recomputeIfNeeded()}while(this.state!==3);return this.value}}_recomputeIfNeeded(){if(this.state===3)return;const c=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=c;const u=this.state!==0,n=this.value;this.state=3;const o=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this.computeFn(this,o)}finally{for(const _ of this.dependenciesToBeRemoved)_.removeObserver(this);this.dependenciesToBeRemoved.clear()}const s=u&&n!==this.value;if((0,y.getLogger)()?.handleDerivedRecomputed(this,{oldValue:n,newValue:this.value,change:void 0,didChange:s}),s)for(const _ of this.observers)_.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(c){this.updateCount++;const u=this.updateCount===1;if(this.state===3&&(this.state=1,!u))for(const n of this.observers)n.handlePossibleChange(this);if(u)for(const n of this.observers)n.beginUpdate(this)}endUpdate(c){if(this.updateCount--,this.updateCount===0){const u=[...this.observers];for(const n of u)n.endUpdate(this)}if(this.updateCount<0)throw new E.BugIndicatingError}handlePossibleChange(c){if(this.state===3&&this.dependencies.has(c)&&!this.dependenciesToBeRemoved.has(c)){this.state=1;for(const u of this.observers)u.handlePossibleChange(this)}}handleChange(c,u){if(this.dependencies.has(c)&&!this.dependenciesToBeRemoved.has(c)){const n=this._handleChange?this._handleChange({changedObservable:c,change:u,didChange:s=>s===c},this.changeSummary):!0,o=this.state===3;if(n&&(this.state===1||o)&&(this.state=2,o))for(const s of this.observers)s.handlePossibleChange(this)}}readObservable(c){c.addObserver(this);const u=c.get();return this.dependencies.add(c),this.dependenciesToBeRemoved.delete(c),u}addObserver(c){const u=!this.observers.has(c)&&this.updateCount>0;super.addObserver(c),u&&c.beginUpdate(this)}removeObserver(c){const u=this.observers.has(c)&&this.updateCount>0;super.removeObserver(c),u&&c.endUpdate(this)}}e.Derived=l}),define(W[22],j([0,1,2,9,6,10,4]),function(U,e,E,T,k,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.keepAlive=e.wasEventTriggeredRecently=e.debouncedObservable=e.observableSignal=e.observableSignalFromEvent=e.FromEventObservable=e.observableFromEvent=e.waitForState=e.observableFromPromise=e.constObservable=void 0;function d(b){return new t(b)}e.constObservable=d;class t extends k.ConvenientObservable{constructor(v){super(),this.value=v}get debugName(){return this.toString()}get(){return this.value}addObserver(v){}removeObserver(v){}toString(){return`Const: ${this.value}`}}function r(b){const v=(0,k.observableValue)("promiseValue",{});return b.then(P=>{v.set({value:P},void 0)}),v}e.observableFromPromise=r;function l(b,v){return new Promise(P=>{let z=!1,g=!1;const L=(0,T.autorun)("waitForState",D=>{const F=b.read(D);v(F)&&(z?L.dispose():g=!0,P(F))});z=!0,g&&L.dispose()})}e.waitForState=l;function a(b,v){return new c(b,v)}e.observableFromEvent=a;class c extends k.BaseObservable{constructor(v,P){super(),this.event=v,this.getValue=P,this.hasValue=!1,this.handleEvent=z=>{const g=this.getValue(z),L=!this.hasValue||this.value!==g;(0,i.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:this.value,newValue:g,change:void 0,didChange:L}),L&&(this.value=g,this.hasValue&&(0,k.transaction)(D=>{for(const F of this.observers)D.updateObserver(F,this),F.handleChange(this,void 0)},()=>{const D=this.getDebugName();return"Event fired"+(D?`: ${D}`:"")}),this.hasValue=!0)}}getDebugName(){return(0,k.getFunctionName)(this.getValue)}get debugName(){const v=this.getDebugName();return"From Event"+(v?`: ${v}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this.getValue(void 0)}}e.FromEventObservable=c,function(b){b.Observer=c}(a||(e.observableFromEvent=a={}));function u(b,v){return new n(b,v)}e.observableSignalFromEvent=u;class n extends k.BaseObservable{constructor(v,P){super(),this.debugName=v,this.event=P,this.handleEvent=()=>{(0,k.transaction)(z=>{for(const g of this.observers)z.updateObserver(g,this),g.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function o(b){return new s(b)}e.observableSignal=o;class s extends k.BaseObservable{constructor(v){super(),this.debugName=v}trigger(v,P){if(!v){(0,k.transaction)(z=>{this.trigger(z,P)},()=>`Trigger signal ${this.debugName}`);return}for(const z of this.observers)v.updateObserver(z,this),z.handleChange(this,P)}get(){}}function _(b,v,P){const z=(0,k.observableValue)("debounced",void 0);let g;return P.add((0,T.autorun)("debounce",L=>{const D=b.read(L);g&&clearTimeout(g),g=setTimeout(()=>{(0,k.transaction)(F=>{z.set(D,F)})},v)})),z}e.debouncedObservable=_;function O(b,v,P){const z=(0,k.observableValue)("triggeredRecently",!1);let g;return P.add(b(()=>{z.set(!0,void 0),g&&clearTimeout(g),g=setTimeout(()=>{z.set(!1,void 0)},v)})),z}e.wasEventTriggeredRecently=O;function A(b,v){const P=new R(v??!1);return b.addObserver(P),v&&b.reportChanges(),(0,E.toDisposable)(()=>{b.removeObserver(P)})}e.keepAlive=A;class R{constructor(v){this.forceRecompute=v,this.counter=0}beginUpdate(v){this.counter++}endUpdate(v){this.counter--,this.counter===0&&this.forceRecompute&&v.reportChanges()}handlePossibleChange(v){}handleChange(v,P){}}function w(b,v){let P;return(0,y.derived)(b,g=>(P=v(g,P),P))}e.derivedObservableWithCache=w;function f(b,v){let P;const z=(0,k.observableValue)("derivedObservableWithWritableCache.counter",0),g=(0,y.derived)(b,L=>(z.read(L),P=v(L,P),P));return Object.assign(g,{clearCache:L=>{P=void 0,z.set(z.get()+1,L)}})}e.derivedObservableWithWritableCache=f});var re=this&&this.__createBinding||(Object.create?function(U,e,E,T){T===void 0&&(T=E);var k=Object.getOwnPropertyDescriptor(e,E);(!k||("get"in k?!e.__esModule:k.writable||k.configurable))&&(k={enumerable:!0,get:function(){return e[E]}}),Object.defineProperty(U,T,k)}:function(U,e,E,T){T===void 0&&(T=E),U[T]=e[E]}),se=this&&this.__exportStar||function(U,e){for(var E in U)E!=="default"&&!Object.prototype.hasOwnProperty.call(e,E)&&re(e,U,E)};define(W[11],j([0,1,6,10,9,22,4]),function(U,e,E,T,k,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derived=e.transaction=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return E.observableValue}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return E.transaction}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return T.derived}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return k.autorun}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return k.autorunDelta}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return k.autorunHandleChanges}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return k.autorunWithStore}}),se(y,e),!1&&(0,i.setLogger)(new i.ConsoleObservableLogger)}),define(W[23],j([0,1,5,2]),function(U,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(R){const w=R;return w?typeof w.read=="function":!1}e.isReadable=k;function y(R){const w=R;return w?[w.on,w.pause,w.resume,w.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=y;function i(R){const w=R;return w?y(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=i;function d(R,w){return new t(R,w)}e.newWriteableStream=d;class t{constructor(w,f){this.reducer=w,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(f=>this.pendingWritePromises.push(f))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w<"u"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(f=>f(w))}emitError(w){this.listeners.error.length===0?(0,E.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(f=>f(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,f){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(w,f){if(this.state.destroyed)return;let b;switch(w){case"data":b=this.listeners.data;break;case"end":b=this.listeners.end;break;case"error":b=this.listeners.error;break}if(b){const v=b.indexOf(f);v>=0&&b.splice(v,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(b=>b())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function r(R,w){const f=[];let b;for(;(b=R.read())!==null;)f.push(b);return w(f)}e.consumeReadable=r;function l(R,w,f){const b=[];let v;for(;(v=R.read())!==null&&b.length<f;)b.push(v);return v===null&&b.length>0?w(b):{read:()=>{if(b.length>0)return b.shift();if(typeof v<"u"){const P=v;return v=void 0,P}return R.read()}}}e.peekReadable=l;function a(R,w){return new Promise((f,b)=>{const v=[];c(R,{onData:P=>{w&&v.push(P)},onError:P=>{w?b(P):f(void 0)},onEnd:()=>{f(w?w(v):void 0)}})})}e.consumeStream=a;function c(R,w){let f=!1;return R.on("error",b=>{f||w.onError(b)}),R.on("end",()=>{f||w.onEnd()}),R.on("data",b=>{f||w.onData(b)}),(0,T.toDisposable)(()=>f=!0)}e.listenStream=c;function u(R,w){return new Promise((f,b)=>{const v=new T.DisposableStore,P=[],z=D=>{if(P.push(D),P.length>w)return v.dispose(),R.pause(),f({stream:R,buffer:P,ended:!1})},g=D=>b(D),L=()=>f({stream:R,buffer:P,ended:!0});v.add((0,T.toDisposable)(()=>R.removeListener("error",g))),R.on("error",g),v.add((0,T.toDisposable)(()=>R.removeListener("end",L))),R.on("end",L),v.add((0,T.toDisposable)(()=>R.removeListener("data",z))),R.on("data",z)})}e.peekStream=u;function n(R,w){const f=d(w);return f.end(R),f}e.toStream=n;function o(){const R=d(()=>{throw new Error("not supported")});return R.end(),R}e.emptyStream=o;function s(R){let w=!1;return{read:()=>w?null:(w=!0,R)}}e.toReadable=s;function _(R,w,f){const b=d(f);return c(R,{onData:v=>b.write(w.data(v)),onError:v=>b.error(w.error?w.error(v):v),onEnd:()=>b.end()}),b}e.transform=_;function O(R,w,f){let b=!1;return{read:()=>{const v=w.read();return b?v:(b=!0,v!==null?f([R,v]):R)}}}e.prefixedReadable=O;function A(R,w,f){let b=!1;const v=d(f);return c(w,{onData:P=>b?v.write(P):(b=!0,v.write(f([R,P]))),onError:P=>v.error(P),onEnd:()=>{b||(b=!0,v.write(R)),v.end()}}),v}e.prefixedStream=A}),define(W[12],j([0,1,43,23]),function(U,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const k=typeof Buffer<"u",y=new E.Lazy(()=>new Uint8Array(256));let i,d;class t{static alloc(m){return k?new t(Buffer.allocUnsafe(m)):new t(new Uint8Array(m))}static wrap(m){return k&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new t(m)}static fromString(m,M){return!(M?.dontUseNodeBuffer||!1)&&k?new t(Buffer.from(m)):(i||(i=new TextEncoder),new t(i.encode(m)))}static fromByteArray(m){const M=t.alloc(m.length);for(let K=0,V=m.length;K<V;K++)M.buffer[K]=m[K];return M}static concat(m,M){if(typeof M>"u"){M=0;for(let G=0,H=m.length;G<H;G++)M+=m[G].byteLength}const K=t.alloc(M);let V=0;for(let G=0,H=m.length;G<H;G++){const q=m[G];K.set(q,V),V+=q.byteLength}return K}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=t.alloc(this.byteLength);return m.set(this),m}toString(){return k?this.buffer.toString():(d||(d=new TextDecoder),d.decode(this.buffer))}slice(m,M){return new t(this.buffer.subarray(m,M))}set(m,M){if(m instanceof t)this.buffer.set(m.buffer,M);else if(m instanceof Uint8Array)this.buffer.set(m,M);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),M);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return c(this.buffer,m)}writeUInt32BE(m,M){u(this.buffer,m,M)}readUInt32LE(m){return n(this.buffer,m)}writeUInt32LE(m,M){o(this.buffer,m,M)}readUInt8(m){return s(this.buffer,m)}writeUInt8(m,M){_(this.buffer,m,M)}indexOf(m,M=0){return r(this.buffer,m instanceof t?m.buffer:m,M)}}e.VSBuffer=t;function r(C,m,M=0){const K=m.byteLength,V=C.byteLength;if(K===0)return 0;if(K===1)return C.indexOf(m[0]);if(K>V-M)return-1;const G=y.value;G.fill(m.length);for(let J=0;J<m.length;J++)G[m[J]]=m.length-J-1;let H=M+m.length-1,q=H,$=-1;for(;H<V;)if(C[H]===m[q]){if(q===0){$=H;break}H--,q--}else H+=Math.max(m.length-q,G[C[H]]),q=m.length-1;return $}e.binaryIndexOf=r;function l(C,m){return C[m+0]<<0>>>0|C[m+1]<<8>>>0}e.readUInt16LE=l;function a(C,m,M){C[M+0]=m&255,m=m>>>8,C[M+1]=m&255}e.writeUInt16LE=a;function c(C,m){return C[m]*2**24+C[m+1]*2**16+C[m+2]*2**8+C[m+3]}e.readUInt32BE=c;function u(C,m,M){C[M+3]=m,m=m>>>8,C[M+2]=m,m=m>>>8,C[M+1]=m,m=m>>>8,C[M]=m}e.writeUInt32BE=u;function n(C,m){return C[m+0]<<0>>>0|C[m+1]<<8>>>0|C[m+2]<<16>>>0|C[m+3]<<24>>>0}e.readUInt32LE=n;function o(C,m,M){C[M+0]=m&255,m=m>>>8,C[M+1]=m&255,m=m>>>8,C[M+2]=m&255,m=m>>>8,C[M+3]=m&255}e.writeUInt32LE=o;function s(C,m){return C[m]}e.readUInt8=s;function _(C,m,M){C[M]=m}e.writeUInt8=_;function O(C){return T.consumeReadable(C,m=>t.concat(m))}e.readableToBuffer=O;function A(C){return T.toReadable(C)}e.bufferToReadable=A;function R(C){return T.consumeStream(C,m=>t.concat(m))}e.streamToBuffer=R;async function w(C){return C.ended?t.concat(C.buffer):t.concat([...C.buffer,await R(C.stream)])}e.bufferedStreamToBuffer=w;function f(C){return T.toStream(C,m=>t.concat(m))}e.bufferToStream=f;function b(C){return T.transform(C,{data:m=>typeof m=="string"?t.fromString(m):t.wrap(m)},m=>t.concat(m))}e.streamToBufferReadableStream=b;function v(C){return T.newWriteableStream(m=>t.concat(m),C)}e.newWriteableBufferStream=v;function P(C,m){return T.prefixedReadable(C,m,M=>t.concat(M))}e.prefixedBufferReadable=P;function z(C,m){return T.prefixedStream(C,m,M=>t.concat(M))}e.prefixedBufferStream=z;function g(C){let m=0,M=0,K=0;const V=new Uint8Array(Math.floor(C.length/4*3)),G=q=>{switch(M){case 3:V[K++]=m|q,M=0;break;case 2:V[K++]=m|q>>>2,m=q<<6,M=3;break;case 1:V[K++]=m|q>>>4,m=q<<4,M=2;break;default:m=q<<2,M=1}};for(let q=0;q<C.length;q++){const $=C.charCodeAt(q);if($>=65&&$<=90)G($-65);else if($>=97&&$<=122)G($-97+26);else if($>=48&&$<=57)G($-48+52);else if($===43||$===45)G(62);else if($===47||$===95)G(63);else{if($===61)break;throw new SyntaxError(`Unexpected base64 character ${C[q]}`)}}const H=K;for(;M>0;)G(0);return t.wrap(V).slice(0,H)}e.decodeBase64=g;const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function F({buffer:C},m=!0,M=!1){const K=M?D:L;let V="";const G=C.byteLength%3;let H=0;for(;H<C.byteLength-G;H+=3){const q=C[H+0],$=C[H+1],J=C[H+2];V+=K[q>>>2],V+=K[(q<<4|$>>>4)&63],V+=K[($<<2|J>>>6)&63],V+=K[J&63]}if(G===1){const q=C[H+0];V+=K[q>>>2],V+=K[q<<4&63],m&&(V+="==")}else if(G===2){const q=C[H+0],$=C[H+1];V+=K[q>>>2],V+=K[(q<<4|$>>>4)&63],V+=K[$<<2&63],m&&(V+="=")}return V}e.encodeBase64=F}),define(W[24],j([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(W[13],j([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var E;(function(k){k[k.Unknown=0]="Unknown",k[k.Invalid=3]="Invalid",k[k.LF=1]="LF",k[k.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function T(k){let y=0,i=0,d=0,t=0;for(let r=0,l=k.length;r<l;r++){const a=k.charCodeAt(r);a===13?(y===0&&(i=r),y++,r+1<l&&k.charCodeAt(r+1)===10?(t|=2,r++):t|=3,d=r+1):a===10&&(t|=1,y===0&&(i=r),y++,d=r+1)}return y===0&&(i=k.length),[y,i,k.length-d,t]}e.countEOL=T}),define(W[14],j([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var E;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(E||(e.LanguageId=E={}));var T;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(T||(e.FontStyle=T={}));var k;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(k||(e.ColorId=k={}));var y;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(y||(e.StandardTokenType=y={}));var i;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(i||(e.MetadataConsts=i={}));class d{static getLanguageId(r){return(r&255)>>>0}static getTokenType(r){return(r&768)>>>8}static containsBalancedBrackets(r){return(r&1024)!==0}static getFontStyle(r){return(r&30720)>>>11}static getForeground(r){return(r&16744448)>>>15}static getBackground(r){return(r&4278190080)>>>24}static getClassNameFromMetadata(r){let a="mtk"+this.getForeground(r);const c=this.getFontStyle(r);return c&1&&(a+=" mtki"),c&2&&(a+=" mtkb"),c&4&&(a+=" mtku"),c&8&&(a+=" mtks"),a}static getInlineStyleFromMetadata(r,l){const a=this.getForeground(r),c=this.getFontStyle(r);let u=`color: ${l[a]};`;c&1&&(u+="font-style: italic;"),c&2&&(u+="font-weight: bold;");let n="";return c&4&&(n+=" underline"),c&8&&(n+=" line-through"),n&&(u+=`text-decoration:${n};`),u}static getPresentationFromMetadata(r){const l=this.getForeground(r),a=this.getFontStyle(r);return{foreground:l,italic:!!(a&1),bold:!!(a&2),underline:!!(a&4),strikethrough:!!(a&8)}}}e.TokenMetadata=d}),define(W[25],j([0,1,26]),function(U,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FixedArray=void 0;class T{constructor(i){this._default=i,this._store=[]}get(i){return i<this._store.length?this._store[i]:this._default}set(i,d){for(;i>=this._store.length;)this._store[this._store.length]=this._default;this._store[i]=d}replace(i,d,t){if(i>=this._store.length)return;if(d===0){this.insert(i,t);return}else if(t===0){this.delete(i,d);return}const r=this._store.slice(0,i),l=this._store.slice(i+d),a=k(t,this._default);this._store=r.concat(a,l)}delete(i,d){d===0||i>=this._store.length||this._store.splice(i,d)}insert(i,d){if(d===0||i>=this._store.length)return;const t=[];for(let r=0;r<d;r++)t[r]=this._default;this._store=(0,E.arrayInsert)(this._store,i,t)}}e.FixedArray=T;function k(y,i){const d=[];for(let t=0;t<y;t++)d[t]=i;return d}}),define(W[7],j([0,1,14]),function(U,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class T{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(i,d){const t=T.defaultTokenMetadata,r=new Uint32Array(2);return r[0]=i.length,r[1]=t,new T(r,i,d)}constructor(i,d,t){this._lineTokensBrand=void 0,this._tokens=i,this._tokensCount=this._tokens.length>>>1,this._text=d,this._languageIdCodec=t}equals(i){return i instanceof T?this.slicedEquals(i,0,this._tokensCount):!1}slicedEquals(i,d,t){if(this._text!==i._text||this._tokensCount!==i._tokensCount)return!1;const r=d<<1,l=r+(t<<1);for(let a=r;a<l;a++)if(this._tokens[a]!==i._tokens[a])return!1;return!0}getLineContent(){return this._text}getCount(){return this._tokensCount}getStartOffset(i){return i>0?this._tokens[i-1<<1]:0}getMetadata(i){return this._tokens[(i<<1)+1]}getLanguageId(i){const d=this._tokens[(i<<1)+1],t=E.TokenMetadata.getLanguageId(d);return this._languageIdCodec.decodeLanguageId(t)}getStandardTokenType(i){const d=this._tokens[(i<<1)+1];return E.TokenMetadata.getTokenType(d)}getForeground(i){const d=this._tokens[(i<<1)+1];return E.TokenMetadata.getForeground(d)}getClassName(i){const d=this._tokens[(i<<1)+1];return E.TokenMetadata.getClassNameFromMetadata(d)}getInlineStyle(i,d){const t=this._tokens[(i<<1)+1];return E.TokenMetadata.getInlineStyleFromMetadata(t,d)}getPresentation(i){const d=this._tokens[(i<<1)+1];return E.TokenMetadata.getPresentationFromMetadata(d)}getEndOffset(i){return this._tokens[i<<1]}findTokenIndexAtOffset(i){return T.findIndexInTokensArray(this._tokens,i)}inflate(){return this}sliceAndInflate(i,d,t){return new k(this,i,d,t)}static convertToEndOffset(i,d){const r=(i.length>>>1)-1;for(let l=0;l<r;l++)i[l<<1]=i[l+1<<1];i[r<<1]=d}static findIndexInTokensArray(i,d){if(i.length<=2)return 0;let t=0,r=(i.length>>>1)-1;for(;t<r;){const l=t+Math.floor((r-t)/2),a=i[l<<1];if(a===d)return l+1;a<d?t=l+1:a>d&&(r=l)}return t}withInserted(i){if(i.length===0)return this;let d=0,t=0,r="";const l=new Array;let a=0;for(;;){const c=d<this._tokensCount?this._tokens[d<<1]:-1,u=t<i.length?i[t]:null;if(c!==-1&&(u===null||c<=u.offset)){r+=this._text.substring(a,c);const n=this._tokens[(d<<1)+1];l.push(r.length,n),d++,a=c}else if(u){if(u.offset>a){r+=this._text.substring(a,u.offset);const n=this._tokens[(d<<1)+1];l.push(r.length,n),a=u.offset}r+=u.text,l.push(r.length,u.tokenMetadata),t++}else break}return new T(new Uint32Array(l),r,this._languageIdCodec)}}e.LineTokens=T;class k{constructor(i,d,t,r){this._source=i,this._startOffset=d,this._endOffset=t,this._deltaOffset=r,this._firstTokenIndex=i.findTokenIndexAtOffset(d),this._tokensCount=0;for(let l=this._firstTokenIndex,a=i.getCount();l<a&&!(i.getStartOffset(l)>=t);l++)this._tokensCount++}getMetadata(i){return this._source.getMetadata(this._firstTokenIndex+i)}getLanguageId(i){return this._source.getLanguageId(this._firstTokenIndex+i)}getLineContent(){return this._source.getLineContent().substring(this._startOffset,this._endOffset)}equals(i){return i instanceof k?this._startOffset===i._startOffset&&this._endOffset===i._endOffset&&this._deltaOffset===i._deltaOffset&&this._source.slicedEquals(i._source,this._firstTokenIndex,this._tokensCount):!1}getCount(){return this._tokensCount}getForeground(i){return this._source.getForeground(this._firstTokenIndex+i)}getEndOffset(i){const d=this._source.getEndOffset(this._firstTokenIndex+i);return Math.min(this._endOffset,d)-this._startOffset+this._deltaOffset}getClassName(i){return this._source.getClassName(this._firstTokenIndex+i)}getInlineStyle(i,d){return this._source.getInlineStyle(this._firstTokenIndex+i,d)}getPresentation(i){return this._source.getPresentation(this._firstTokenIndex+i)}findTokenIndexAtOffset(i){return this._source.findTokenIndexAtOffset(i+this._startOffset-this._deltaOffset)-this._firstTokenIndex}}}),define(W[27],j([0,1,7]),function(U,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class T{static deleteBeginning(i,d){return i===null||i===e.EMPTY_LINE_TOKENS?i:T.delete(i,0,d)}static deleteEnding(i,d){if(i===null||i===e.EMPTY_LINE_TOKENS)return i;const t=k(i),r=t[t.length-2];return T.delete(i,d,r)}static delete(i,d,t){if(i===null||i===e.EMPTY_LINE_TOKENS||d===t)return i;const r=k(i),l=r.length>>>1;if(d===0&&r[r.length-2]===t)return e.EMPTY_LINE_TOKENS;const a=E.LineTokens.findIndexInTokensArray(r,d),c=a>0?r[a-1<<1]:0,u=r[a<<1];if(t<u){const O=t-d;for(let A=a;A<l;A++)r[A<<1]-=O;return i}let n,o;c!==d?(r[a<<1]=d,n=a+1<<1,o=d):(n=a<<1,o=c);const s=t-d;for(let O=a+1;O<l;O++){const A=r[O<<1]-s;A>o&&(r[n++]=A,r[n++]=r[(O<<1)+1],o=A)}if(n===r.length)return i;const _=new Uint32Array(n);return _.set(r.subarray(0,n),0),_.buffer}static append(i,d){if(d===e.EMPTY_LINE_TOKENS)return i;if(i===e.EMPTY_LINE_TOKENS)return d;if(i===null)return i;if(d===null)return null;const t=k(i),r=k(d),l=r.length>>>1,a=new Uint32Array(t.length+r.length);a.set(t,0);let c=t.length;const u=t[t.length-2];for(let n=0;n<l;n++)a[c++]=r[n<<1]+u,a[c++]=r[(n<<1)+1];return a.buffer}static insert(i,d,t){if(i===null||i===e.EMPTY_LINE_TOKENS)return i;const r=k(i),l=r.length>>>1;let a=E.LineTokens.findIndexInTokensArray(r,d);a>0&&r[a-1<<1]===d&&a--;for(let c=a;c<l;c++)r[c<<1]+=t;return i}}e.ContiguousTokensEditing=T;function k(y){return y instanceof Uint32Array?y:new Uint32Array(y)}e.toUint32Array=k}),define(W[28],j([0,1,26,12,44,13,27,15]),function(U,e,E,T,k,y,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class t{static deserialize(l,a,c){const u=new Uint32Array(l.buffer),n=(0,T.readUInt32BE)(l,a);a+=4;const o=(0,T.readUInt32BE)(l,a);a+=4;const s=[];for(let _=0;_<o;_++){const O=(0,T.readUInt32BE)(l,a);a+=4,s.push(u.subarray(a/4,a/4+O/4)),a+=O}return c.push(new t(n,s)),a}get startLineNumber(){return this._startLineNumber}get endLineNumber(){return this._startLineNumber+this._tokens.length-1}constructor(l,a){this._startLineNumber=l,this._tokens=a}getLineRange(){return new d.LineRange(this._startLineNumber,this._startLineNumber+this._tokens.length)}getLineTokens(l){return this._tokens[l-this._startLineNumber]}appendLineTokens(l){this._tokens.push(l)}serializeSize(){let l=0;l+=4,l+=4;for(let a=0;a<this._tokens.length;a++){const c=this._tokens[a];if(!(c instanceof Uint32Array))throw new Error("Not supported!");l+=4,l+=c.byteLength}return l}serialize(l,a){(0,T.writeUInt32BE)(l,this._startLineNumber,a),a+=4,(0,T.writeUInt32BE)(l,this._tokens.length,a),a+=4;for(let c=0;c<this._tokens.length;c++){const u=this._tokens[c];if(!(u instanceof Uint32Array))throw new Error("Not supported!");(0,T.writeUInt32BE)(l,u.byteLength,a),a+=4,l.set(new Uint8Array(u.buffer),a),a+=u.byteLength}return a}applyEdit(l,a){const[c,u]=(0,y.countEOL)(a);this._acceptDeleteRange(l),this._acceptInsertText(new k.Position(l.startLineNumber,l.startColumn),c,u)}_acceptDeleteRange(l){if(l.startLineNumber===l.endLineNumber&&l.startColumn===l.endColumn)return;const a=l.startLineNumber-this._startLineNumber,c=l.endLineNumber-this._startLineNumber;if(c<0){const u=c-a;this._startLineNumber-=u;return}if(!(a>=this._tokens.length)){if(a<0&&c>=this._tokens.length){this._startLineNumber=0,this._tokens=[];return}if(a===c){this._tokens[a]=i.ContiguousTokensEditing.delete(this._tokens[a],l.startColumn-1,l.endColumn-1);return}if(a>=0)if(this._tokens[a]=i.ContiguousTokensEditing.deleteEnding(this._tokens[a],l.startColumn-1),c<this._tokens.length){const u=i.ContiguousTokensEditing.deleteBeginning(this._tokens[c],l.endColumn-1);this._tokens[a]=i.ContiguousTokensEditing.append(this._tokens[a],u),this._tokens.splice(a+1,c-a)}else this._tokens[a]=i.ContiguousTokensEditing.append(this._tokens[a],null),this._tokens=this._tokens.slice(0,a+1);else{const u=-a;this._startLineNumber-=u,this._tokens[c]=i.ContiguousTokensEditing.deleteBeginning(this._tokens[c],l.endColumn-1),this._tokens=this._tokens.slice(c)}}}_acceptInsertText(l,a,c){if(a===0&&c===0)return;const u=l.lineNumber-this._startLineNumber;if(u<0){this._startLineNumber+=a;return}if(!(u>=this._tokens.length)){if(a===0){this._tokens[u]=i.ContiguousTokensEditing.insert(this._tokens[u],l.column-1,c);return}this._tokens[u]=i.ContiguousTokensEditing.deleteEnding(this._tokens[u],l.column-1),this._tokens[u]=i.ContiguousTokensEditing.insert(this._tokens[u],l.column-1,c),this._insertLines(l.lineNumber,a)}}_insertLines(l,a){if(a===0)return;const c=[];for(let u=0;u<a;u++)c[u]=null;this._tokens=E.arrayInsert(this._tokens,l,c)}}e.ContiguousMultilineTokens=t}),define(W[16],j([0,1,12,28]),function(U,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class k{static deserialize(i){let d=0;const t=(0,E.readUInt32BE)(i,d);d+=4;const r=[];for(let l=0;l<t;l++)d=T.ContiguousMultilineTokens.deserialize(i,d,r);return r}constructor(){this._tokens=[]}add(i,d){if(this._tokens.length>0){const t=this._tokens[this._tokens.length-1];if(t.endLineNumber+1===i){t.appendLineTokens(d);return}}this._tokens.push(new T.ContiguousMultilineTokens(i,[d]))}finalize(){return this._tokens}serialize(){const i=this._serializeSize(),d=new Uint8Array(i);return this._serialize(d),d}_serializeSize(){let i=0;i+=4;for(let d=0;d<this._tokens.length;d++)i+=this._tokens[d].serializeSize();return i}_serialize(i){let d=0;(0,E.writeUInt32BE)(i,this._tokens.length,d),d+=4;for(let t=0;t<this._tokens.length;t++)d=this._tokens[t].serialize(i,d)}}e.ContiguousMultilineTokensBuilder=k}),define(W[29],j([0,1,30,3,31,45]),function(U,e,E,T,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function i(g){return g===47||g===92}e.isPathSeparator=i;function d(g){return g.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=d;function t(g){return g.indexOf("/")===-1&&(g=d(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}e.toPosixPath=t;function r(g,L=E.posix.sep){if(!g)return"";const D=g.length,F=g.charCodeAt(0);if(i(F)){if(i(g.charCodeAt(1))&&!i(g.charCodeAt(2))){let m=3;const M=m;for(;m<D&&!i(g.charCodeAt(m));m++);if(M!==m&&!i(g.charCodeAt(m+1))){for(m+=1;m<D;m++)if(i(g.charCodeAt(m)))return g.slice(0,m+1).replace(/[\\/]/g,L)}}return L}else if(_(F)&&g.charCodeAt(1)===58)return i(g.charCodeAt(2))?g.slice(0,2)+L:g.slice(0,2);let C=g.indexOf("://");if(C!==-1){for(C+=3;C<D;C++)if(i(g.charCodeAt(C)))return g.slice(0,C+1)}return""}e.getRoot=r;function l(g){if(!T.isWindows||!g||g.length<5)return!1;let L=g.charCodeAt(0);if(L!==92||(L=g.charCodeAt(1),L!==92))return!1;let D=2;const F=D;for(;D<g.length&&(L=g.charCodeAt(D),L!==92);D++);return!(F===D||(L=g.charCodeAt(D+1),isNaN(L)||L===92))}e.isUNC=l;const a=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(g,L=T.isWindows){const D=L?a:c;return!(!g||g.length===0||/^\s+$/.test(g)||(D.lastIndex=0,D.test(g))||L&&u.test(g)||g==="."||g===".."||L&&g[g.length-1]==="."||L&&g.length!==g.trim().length||g.length>255)}e.isValidBasename=n;function o(g,L,D){const F=g===L;return!D||F?F:!g||!L?!1:(0,k.equalsIgnoreCase)(g,L)}e.isEqual=o;function s(g,L,D,F=E.sep){if(g===L)return!0;if(!g||!L||L.length>g.length)return!1;if(D){if(!(0,k.startsWithIgnoreCase)(g,L))return!1;if(L.length===g.length)return!0;let m=L.length;return L.charAt(L.length-1)===F&&m--,g.charAt(m)===F}return L.charAt(L.length-1)!==F&&(L+=F),g.indexOf(L)===0}e.isEqualOrParent=s;function _(g){return g>=65&&g<=90||g>=97&&g<=122}e.isWindowsDriveLetter=_;function O(g,L){return T.isWindows&&g.endsWith(":")&&(g+=E.sep),(0,E.isAbsolute)(g)||(g=(0,E.join)(L,g)),g=(0,E.normalize)(g),T.isWindows?(g=(0,k.rtrim)(g,E.sep),g.endsWith(":")&&(g+=E.sep)):(g=(0,k.rtrim)(g,E.sep),g||(g=E.sep)),g}e.sanitizeFilePath=O;function A(g){const L=(0,E.normalize)(g);return T.isWindows?g.length>3?!1:R(L)&&(g.length===2||L.charCodeAt(2)===92):L===E.posix.sep}e.isRootOrDriveLetter=A;function R(g,L=T.isWindows){return L?_(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}e.hasDriveLetter=R;function w(g,L=T.isWindows){return R(g,L)?g[0]:void 0}e.getDriveLetter=w;function f(g,L,D){return L.length>g.length?-1:g===L?0:(D&&(g=g.toLowerCase(),L=L.toLowerCase()),g.indexOf(L))}e.indexOfPath=f;function b(g){const L=g.split(":");let D,F,C;for(const m of L){const M=Number(m);(0,y.isNumber)(M)?F===void 0?F=M:C===void 0&&(C=M):D=D?[D,m].join(":"):m}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:F!==void 0?F:void 0,column:C!==void 0?C:F!==void 0?1:void 0}}e.parseLineAndColumnAware=b;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",P="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function z(g,L,D=8){let F="";for(let m=0;m<D;m++){let M;m===0&&T.isWindows&&!L&&(D===3||D===4)?M=P:M=v,F+=M.charAt(Math.floor(Math.random()*M.length))}let C;return L?C=`${L}-${F}`:C=F,g?(0,E.join)(g,C):C}e.randomPath=z}),define(W[17],j([0,1,5,3,8]),function(U,e,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var y;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.vscodeManagedRemoteResource="vscode-managed-remote-resource",r.vscodeUserData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeInteractiveInput="vscode-interactive-input",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.vscodeChatSesssion="vscode-chat-editor",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp",r.vsls="vsls",r.vscodeSourceControl="vscode-scm"})(y||(e.Schemas=y={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class i{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${y.vscodeRemoteResource}`}setPreferredWebSchema(l){this._preferredWebSchema=l}setDelegate(l){this._delegate=l}setServerRootPath(l){this._remoteResourcesPath=`${l}/${y.vscodeRemoteResource}`}set(l,a,c){this._hosts[l]=a,this._ports[l]=c}setConnectionToken(l,a){this._connectionTokens[l]=a}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(l){if(this._delegate)try{return this._delegate(l)}catch(s){return E.onUnexpectedError(s),l}const a=l.authority;let c=this._hosts[a];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const u=this._ports[a],n=this._connectionTokens[a];let o=`path=${encodeURIComponent(l.path)}`;return typeof n=="string"&&(o+=`&${e.connectionTokenQueryName}=${encodeURIComponent(n)}`),k.URI.from({scheme:T.isWeb?this._preferredWebSchema:y.vscodeRemoteResource,authority:`${c}:${u}`,path:this._remoteResourcesPath,query:o})}}e.RemoteAuthorities=new i,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class d{static{this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(l){const a=this.toUri(l,U);return this.uriToBrowserUri(a)}uriToBrowserUri(l){return l.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(l):l.scheme===y.file&&(T.isNative||T.isWebWorker&&T.globals.origin===`${y.vscodeFileResource}://${d.FALLBACK_AUTHORITY}`)?l.with({scheme:y.vscodeFileResource,authority:l.authority||d.FALLBACK_AUTHORITY,query:null,fragment:null}):l}asFileUri(l){const a=this.toUri(l,U);return this.uriToFileUri(a)}uriToFileUri(l){return l.scheme===y.vscodeFileResource?l.with({scheme:y.file,authority:l.authority!==d.FALLBACK_AUTHORITY?l.authority:null,query:null,fragment:null}):l}toUri(l,a){return k.URI.isUri(l)?l:k.URI.parse(a.toUrl(l))}}e.FileAccess=new d;var t;(function(r){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);r.CoopAndCoep=Object.freeze(l.get("3"));const a="vscode-coi";function c(n){let o;typeof n=="string"?o=new URL(n).searchParams:n instanceof URL?o=n.searchParams:k.URI.isUri(n)&&(o=new URL(n.toString(!0)).searchParams);const s=o?.get(a);if(s)return l.get(s)}r.getHeadersFromQuery=c;function u(n,o,s){if(!globalThis.crossOriginIsolated)return;const _=o&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(a,_):n[a]=_}r.addSearchParam=u})(t||(e.COI=t={}))}),define(W[32],j([0,1,21,17,3,8]),function(U,e,E,T,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class i{constructor(c,u,n){this.id=c,this.dependencies=u,this.callback=n}}class d{static{this.INSTANCE=new d}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(c,u,n)=>{typeof c!="string"&&(n=u,u=c,c=null),(typeof u!="object"||!Array.isArray(u))&&(n=u,u=null),this._defineCalls.push(new i(c,u,n))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(c){if(c.startsWith(window.location.origin)||c.startsWith("vscode-file://vscode-app"))return c;throw new Error(`[trusted_script_src] Invalid script url: ${c}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(c){return c}})))}async load(c){this._initialize();const u=await(this._isWebWorker?this._workerLoadScript(c):this._isRenderer?this._rendererLoadScript(c):this._nodeJSLoadScript(c));if(!u)throw new Error(`Did not receive a define call from script ${c}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${c}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}_rendererLoadScript(c){return new Promise((u,n)=>{const o=document.createElement("script");o.setAttribute("async","async"),o.setAttribute("type","text/javascript");const s=()=>{o.removeEventListener("load",_),o.removeEventListener("error",O)},_=A=>{s(),u(this._defineCalls.pop())},O=A=>{s(),n(A)};o.addEventListener("load",_),o.addEventListener("error",O),this._amdPolicy&&(c=this._amdPolicy.createScriptURL(c)),o.setAttribute("src",c),document.getElementsByTagName("head")[0].appendChild(o)})}_workerLoadScript(c){return new Promise((u,n)=>{try{this._amdPolicy&&(c=this._amdPolicy.createScriptURL(c)),importScripts(c),u(this._defineCalls.pop())}catch(o){n(o)}})}async _nodeJSLoadScript(c){try{const u=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,o=globalThis._VSCODE_NODE_MODULES.module,s=y.URI.parse(c).fsPath,_=u.readFileSync(s).toString(),O=o.wrap(_.replace(/^#!.*/,""));return new n.Script(O).runInThisContext().apply(),this._defineCalls.pop()}catch(u){throw u}}}const t=new Map;let r={};typeof globalThis.require=="object"&&(r=globalThis.require.paths??{});async function l(a,c,u){if(E.isESM){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),r[a]&&(a=r[a]);const n=`${a}/${c}`;if(t.has(n))return t.get(n);let o;if(/^\w[\w\d+.-]*:\/\//.test(n))o=n;else{const A=`${u&&!k.isWeb?T.nodeModulesAsarPath:T.nodeModulesPath}/${n}`;o=T.FileAccess.asBrowserUri(A).toString(!0)}const s=d.INSTANCE.load(o);return t.set(n,s),s}else return await new Promise((n,o)=>{U([a],n,o)})}e.importAMDNodeModule=l}),define(W[18],j([0,1,29,17,30,3,31,8]),function(U,e,E,T,k,y,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function t(u){return(0,d.uriToFsPath)(u,!0)}e.originalFSPath=t;class r{constructor(n){this._ignorePathCasing=n}compare(n,o,s=!1){return n===o?0:(0,i.compare)(this.getComparisonKey(n,s),this.getComparisonKey(o,s))}isEqual(n,o,s=!1){return n===o?!0:!n||!o?!1:this.getComparisonKey(n,s)===this.getComparisonKey(o,s)}getComparisonKey(n,o=!1){return n.with({path:this._ignorePathCasing(n)?n.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(n){return this._ignorePathCasing(n)}isEqualOrParent(n,o,s=!1){if(n.scheme===o.scheme){if(n.scheme===T.Schemas.file)return E.isEqualOrParent(t(n),t(o),this._ignorePathCasing(n))&&n.query===o.query&&(s||n.fragment===o.fragment);if((0,e.isEqualAuthority)(n.authority,o.authority))return E.isEqualOrParent(n.path,o.path,this._ignorePathCasing(n),"/")&&n.query===o.query&&(s||n.fragment===o.fragment)}return!1}joinPath(n,...o){return d.URI.joinPath(n,...o)}basenameOrAuthority(n){return(0,e.basename)(n)||n.authority}basename(n){return k.posix.basename(n.path)}extname(n){return k.posix.extname(n.path)}dirname(n){if(n.path.length===0)return n;let o;return n.scheme===T.Schemas.file?o=d.URI.file(k.dirname(t(n))).path:(o=k.posix.dirname(n.path),n.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),o="/")),n.with({path:o})}normalizePath(n){if(!n.path.length)return n;let o;return n.scheme===T.Schemas.file?o=d.URI.file(k.normalize(t(n))).path:o=k.posix.normalize(n.path),n.with({path:o})}relativePath(n,o){if(n.scheme!==o.scheme||!(0,e.isEqualAuthority)(n.authority,o.authority))return;if(n.scheme===T.Schemas.file){const O=k.relative(t(n),t(o));return y.isWindows?E.toSlashes(O):O}let s=n.path||"/";const _=o.path||"/";if(this._ignorePathCasing(n)){let O=0;for(const A=Math.min(s.length,_.length);O<A&&!(s.charCodeAt(O)!==_.charCodeAt(O)&&s.charAt(O).toLowerCase()!==_.charAt(O).toLowerCase());O++);s=_.substr(0,O)+s.substr(O)}return k.posix.relative(s,_)}resolvePath(n,o){if(n.scheme===T.Schemas.file){const s=d.URI.file(k.resolve(t(n),o));return n.with({authority:s.authority,path:s.path})}return o=E.toPosixPath(o),n.with({path:k.posix.resolve(n.path,o)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,o){return n===o||n!==void 0&&o!==void 0&&(0,i.equalsIgnoreCase)(n,o)}hasTrailingPathSeparator(n,o=k.sep){if(n.scheme===T.Schemas.file){const s=t(n);return s.length>E.getRoot(s).length&&s[s.length-1]===o}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,o=k.sep){return(0,e.hasTrailingPathSeparator)(n,o)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,o=k.sep){let s=!1;if(n.scheme===T.Schemas.file){const _=t(n);s=_!==void 0&&_.length===E.getRoot(_).length&&_[_.length-1]===o}else{o="/";const _=n.path;s=_.length===1&&_.charCodeAt(_.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(n,o)?n.with({path:n.path+"/"}):n}}e.ExtUri=r,e.extUri=new r(()=>!1),e.extUriBiasedIgnorePathCase=new r(u=>u.scheme===T.Schemas.file?!y.isLinux:!0),e.extUriIgnorePathCase=new r(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function l(u,n){const o=[];for(let s=0;s<u.length;s++){const _=n(u[s]);u.some((O,A)=>A===s?!1:(0,e.isEqualOrParent)(_,n(O)))||o.push(u[s])}return o}e.distinctParents=l;var a;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function n(o){const s=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(A=>{const[R,w]=A.split(":");R&&w&&s.set(R,w)});const O=o.path.substring(0,o.path.indexOf(";"));return O&&s.set(u.META_DATA_MIME,O),s}u.parseMetaData=n})(a||(e.DataUri=a={}));function c(u,n,o){if(n){let s=u.path;return s&&s[0]!==k.posix.sep&&(s=k.posix.sep+s),u.with({scheme:o,authority:n,path:s})}return u.with({scheme:o})}e.toLocalResource=c}),define(W[19],j([0,1,46,5,33,2,18,3,24]),function(U,e,E,T,k,y,i,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function r(I){return!!I&&typeof I.then=="function"}e.isThenable=r;function l(I){const h=new E.CancellationTokenSource,S=I(h.token),p=new Promise((N,B)=>{const Y=h.token.onCancellationRequested(()=>{Y.dispose(),h.dispose(),B(new T.CancellationError)});Promise.resolve(S).then(Z=>{Y.dispose(),h.dispose(),N(Z)},Z=>{Y.dispose(),h.dispose(),B(Z)})});return new class{cancel(){h.cancel()}then(N,B){return p.then(N,B)}catch(N){return this.then(void 0,N)}finally(N){return p.finally(N)}}}e.createCancelablePromise=l;function a(I,h,S){return new Promise((p,N)=>{const B=h.onCancellationRequested(()=>{B.dispose(),p(S)});I.then(p,N).finally(()=>B.dispose())})}e.raceCancellation=a;function c(I,h){return new Promise((S,p)=>{const N=h.onCancellationRequested(()=>{N.dispose(),p(new T.CancellationError)});I.then(S,p).finally(()=>N.dispose())})}e.raceCancellationError=c;async function u(I){let h=-1;const S=I.map((p,N)=>p.then(B=>(h=N,B)));try{return await Promise.race(S)}finally{I.forEach((p,N)=>{N!==h&&p.cancel()})}}e.raceCancellablePromises=u;function n(I,h,S){let p;const N=setTimeout(()=>{p?.(void 0),S?.()},h);return Promise.race([I.finally(()=>clearTimeout(N)),new Promise(B=>p=B)])}e.raceTimeout=n;function o(I){return new Promise((h,S)=>{const p=I();r(p)?p.then(h,S):h(p)})}e.asPromise=o;class s{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(h){if(this.isDisposed)throw new Error("Throttler is disposed");if(this.activePromise){if(this.queuedPromiseFactory=h,!this.queuedPromise){const S=()=>{if(this.queuedPromise=null,this.isDisposed)return;const p=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,p};this.queuedPromise=new Promise(p=>{this.activePromise.then(S,S).then(p)})}return new Promise((S,p)=>{this.queuedPromise.then(S,p)})}return this.activePromise=h(),new Promise((S,p)=>{this.activePromise.then(N=>{this.activePromise=null,S(N)},N=>{this.activePromise=null,p(N)})})}dispose(){this.isDisposed=!0}}e.Throttler=s;class _{constructor(){this.current=Promise.resolve(null)}queue(h){return this.current=this.current.then(()=>h(),()=>h())}}e.Sequencer=_;class O{constructor(){this.promiseMap=new Map}queue(h,S){const N=(this.promiseMap.get(h)??Promise.resolve()).catch(()=>{}).then(S).finally(()=>{this.promiseMap.get(h)===N&&this.promiseMap.delete(h)});return this.promiseMap.set(h,N),N}}e.SequencerByKey=O;const A=(I,h)=>{let S=!0;const p=setTimeout(()=>{S=!1,h()},I);return{isTriggered:()=>S,dispose:()=>{clearTimeout(p),S=!1}}},R=I=>{let h=!0;return queueMicrotask(()=>{h&&(h=!1,I())}),{isTriggered:()=>h,dispose:()=>{h=!1}}};class w{constructor(h){this.defaultDelay=h,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(h,S=this.defaultDelay){this.task=h,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,B)=>{this.doResolve=N,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}}));const p=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=S===t.MicrotaskDelay?R(p):A(S,p),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new T.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=w;class f{constructor(h){this.delayer=new w(h),this.throttler=new s}trigger(h,S){return this.delayer.trigger(()=>this.throttler.queue(h),S)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=f;class b{constructor(){this._isOpen=!1,this._promise=new Promise((h,S)=>{this._completePromise=h})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class v extends b{constructor(h){super(),this._timeout=setTimeout(()=>this.open(),h)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=v;function P(I,h){return h?new Promise((S,p)=>{const N=setTimeout(()=>{B.dispose(),S()},I),B=h.onCancellationRequested(()=>{clearTimeout(N),B.dispose(),p(new T.CancellationError)})}):l(S=>P(I,S))}e.timeout=P;function z(I,h=0){const S=setTimeout(I,h);return(0,y.toDisposable)(()=>clearTimeout(S))}e.disposableTimeout=z;function g(I){const h=[];let S=0;const p=I.length;function N(){return S<p?I[S++]():null}function B(Y){Y!=null&&h.push(Y);const Z=N();return Z?Z.then(B):Promise.resolve(h)}return Promise.resolve(null).then(B)}e.sequence=g;function L(I,h=p=>!!p,S=null){let p=0;const N=I.length,B=()=>{if(p>=N)return Promise.resolve(S);const Y=I[p++];return Promise.resolve(Y()).then(X=>h(X)?Promise.resolve(X):B())};return B()}e.first=L;function D(I,h=p=>!!p,S=null){if(I.length===0)return Promise.resolve(S);let p=I.length;const N=()=>{p=-1;for(const B of I)B.cancel?.()};return new Promise((B,Y)=>{for(const Z of I)Z.then(X=>{--p>=0&&h(X)?(N(),B(X)):p===0&&B(S)}).catch(X=>{--p>=0&&(N(),Y(X))})})}e.firstParallel=D;class F{constructor(h){this._size=0,this.maxDegreeOfParalellism=h,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(h){return this._size++,new Promise((S,p)=>{this.outstandingPromises.push({factory:h,c:S,e:p}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const h=this.outstandingPromises.shift();this.runningPromises++;const S=h.factory();S.then(h.c,h.e),S.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=F;class C extends F{constructor(){super(1)}}e.Queue=C;class m{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const h=new ee;return this.drainers.add(h),h.p}isDrained(){for(const[,h]of this.queues)if(h.size>0)return!1;return!0}queueFor(h,S=i.extUri){const p=S.getComparisonKey(h);let N=this.queues.get(p);return N||(N=new C,k.Event.once(N.onDrained)(()=>{N?.dispose(),this.queues.delete(p),this.onDidQueueDrain()}),this.queues.set(p,N)),N}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const h of this.drainers)h.complete();this.drainers.clear()}dispose(){for(const[,h]of this.queues)h.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=m;class M{constructor(h,S){this._token=-1,typeof h=="function"&&typeof S=="number"&&this.setIfNotSet(h,S)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(h,S){this.cancel(),this._token=setTimeout(()=>{this._token=-1,h()},S)}setIfNotSet(h,S){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,h()},S))}}e.TimeoutTimer=M;class K{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(h,S){this.cancel(),this._token=setInterval(()=>{h()},S)}}e.IntervalTimer=K;class V{constructor(h,S){this.timeoutToken=-1,this.runner=h,this.timeout=S,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(h=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,h)}get delay(){return this.timeout}set delay(h){this.timeout=h}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=V;class G{constructor(h,S){S%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${S}ms is not a multiple of 1000ms.`),this.runner=h,this.timeout=S,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(h=this.timeout){h%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(h/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=G;class H extends V{constructor(h,S){super(h,S),this.units=[]}work(h){this.units.push(h),this.isScheduled()||this.schedule()}doRun(){const h=this.units;this.units=[],this.runner?.(h)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=H;class q extends y.Disposable{constructor(h,S){super(),this.options=h,this.handler=S,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(h){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+h.length>this.options.maxBufferedWork)return!1}else if(this.pending+h.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const S of h)this.pendingWork.push(S);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new V(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=I=>{(0,d.setTimeout0)(()=>{if(h)return;const S=Date.now()+15;I(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,S-Date.now())}}))});let h=!1;return{dispose(){h||(h=!0)}}}:e.runWhenIdle=(I,h)=>{const S=requestIdleCallback(I,typeof h=="number"?{timeout:h}:void 0);let p=!1;return{dispose(){p||(p=!0,cancelIdleCallback(S))}}}}();class ${constructor(h){this._didRun=!1,this._executor=()=>{try{this._value=h()}catch(S){this._error=S}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function J(I,h,S){let p;for(let N=0;N<S;N++)try{return await I()}catch(B){p=B,await P(h)}throw p}e.retry=J;class oe{hasPending(h){return this._pending?typeof h=="number"?this._pending.taskId===h:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(h,S,p){return this._pending={taskId:h,cancel:()=>p?.(),promise:S},S.then(()=>this.donePending(h),()=>this.donePending(h)),S}donePending(h){this._pending&&h===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const h=this._next;this._next=void 0,h.run().then(h.promiseResolve,h.promiseReject)}}setNext(h){if(this._next)this._next.run=h;else{let S,p;const N=new Promise((B,Y)=>{S=B,p=Y});this._next={run:h,promise:N,promiseResolve:S,promiseReject:p}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=oe;class ae{constructor(h,S=()=>Date.now()){this.interval=h,this.nowFn=S,this.lastIncrementTime=0,this.value=0}increment(){const h=this.nowFn();return h-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=h,this.value=0),this.value++,this.value}}e.IntervalCounter=ae;var x;(function(I){I[I.Resolved=0]="Resolved",I[I.Rejected=1]="Rejected"})(x||(x={}));class ee{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((h,S)=>{this.completeCallback=h,this.errorCallback=S})}complete(h){return new Promise(S=>{this.completeCallback(h),this.outcome={outcome:0,value:h},S()})}error(h){return new Promise(S=>{this.errorCallback(h),this.outcome={outcome:1,value:h},S()})}cancel(){return this.error(new T.CancellationError)}}e.DeferredPromise=ee;var te;(function(I){async function h(p){let N;const B=await Promise.all(p.map(Y=>Y.then(Z=>Z,Z=>{N||(N=Z)})));if(typeof N<"u")throw N;return B}I.settled=h;function S(p){return new Promise(async(N,B)=>{try{await p(N,B)}catch(Y){B(Y)}})}I.withAsyncBody=S})(te||(e.Promises=te={}));var ne;(function(I){I[I.Initial=0]="Initial",I[I.DoneOK=1]="DoneOK",I[I.DoneError=2]="DoneError"})(ne||(ne={}));class Q{static fromArray(h){return new Q(S=>{S.emitMany(h)})}static fromPromise(h){return new Q(async S=>{S.emitMany(await h)})}static fromPromises(h){return new Q(async S=>{await Promise.all(h.map(async p=>S.emitOne(await p)))})}static merge(h){return new Q(async S=>{await Promise.all(h.map(async p=>{for await(const N of p)S.emitOne(N)}))})}static{this.EMPTY=Q.fromArray([])}constructor(h){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const S={emitOne:p=>this.emitOne(p),emitMany:p=>this.emitMany(p),reject:p=>this.reject(p)};try{await Promise.resolve(h(S)),this.resolve()}catch(p){this.reject(p)}finally{S.emitOne=void 0,S.emitMany=void 0,S.reject=void 0}})}[Symbol.asyncIterator](){let h=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(h<this._results.length)return{done:!1,value:this._results[h++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(h,S){return new Q(async p=>{for await(const N of h)p.emitOne(S(N))})}map(h){return Q.map(this,h)}static filter(h,S){return new Q(async p=>{for await(const N of h)S(N)&&p.emitOne(N)})}filter(h){return Q.filter(this,h)}static coalesce(h){return Q.filter(h,S=>!!S)}coalesce(){return Q.coalesce(this)}static async toPromise(h){const S=[];for await(const p of h)S.push(p);return S}toPromise(){return Q.toPromise(this)}emitOne(h){this._state===0&&(this._results.push(h),this._onStateChanged.fire())}emitMany(h){this._state===0&&(this._results=this._results.concat(h),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(h){this._state===0&&(this._state=2,this._error=h,this._onStateChanged.fire())}}e.AsyncIterableObject=Q;class ie extends Q{constructor(h,S){super(S),this._source=h}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ie;function ue(I){const h=new E.CancellationTokenSource,S=I(h.token);return new ie(h,async p=>{const N=h.token.onCancellationRequested(()=>{N.dispose(),h.dispose(),p.reject(new T.CancellationError)});try{for await(const B of S){if(h.token.isCancellationRequested)return;p.emitOne(B)}N.dispose(),h.dispose()}catch(B){N.dispose(),h.dispose(),p.reject(B)}})}e.createCancelableAsyncIterable=ue}),define(W[20],j([0,1,34]),function(U,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(y){return this===y}};function T(y,i){return new E.TokenizationResult([new E.Token(0,"",y)],i)}e.nullTokenize=T;function k(y,i){const d=new Uint32Array(2);return d[0]=0,d[1]=(y<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new E.EncodedTokenizationResult(d,i===null?e.NullState:i)}e.nullTokenizeEncoded=k}),define(W[35],j([0,1,19,5,3,36,13,15,47,20,25,16,7]),function(U,e,E,T,k,y,i,d,t,r,l,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultBackgroundTokenizer=e.RangePriorityQueueImpl=e.TokenizationStateStore=e.TrackingTokenizationStateStore=e.TokenizerWithStateStoreAndTextModel=e.TokenizerWithStateStore=void 0;var u;(function(w){w[w.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(u||(u={}));class n{constructor(f,b){this.tokenizationSupport=b,this.initialState=this.tokenizationSupport.getInitialState(),this.store=new s(f)}getStartState(f){return this.store.getStartState(f,this.initialState)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.initialState)}}e.TokenizerWithStateStore=n;class o extends n{constructor(f,b,v,P){super(f,b),this._textModel=v,this._languageIdCodec=P}updateTokensUntilLine(f,b){const v=this._textModel.getLanguageId();for(;;){const P=this.getFirstInvalidLine();if(!P||P.lineNumber>b)break;const z=this._textModel.getLineContent(P.lineNumber),g=A(this._languageIdCodec,v,this.tokenizationSupport,z,!0,P.startState);f.add(P.lineNumber,g.tokens),this.store.setEndState(P.lineNumber,g.endState)}}getTokenTypeIfInsertingCharacter(f,b){const v=this.getStartState(f.lineNumber);if(!v)return 0;const P=this._textModel.getLanguageId(),z=this._textModel.getLineContent(f.lineNumber),g=z.substring(0,f.column-1)+b+z.substring(f.column-1),L=A(this._languageIdCodec,P,this.tokenizationSupport,g,!0,v),D=new c.LineTokens(L.tokens,g,this._languageIdCodec);if(D.getCount()===0)return 0;const F=D.findTokenIndexAtOffset(f.column-1);return D.getStandardTokenType(F)}tokenizeLineWithEdit(f,b,v){const P=f.lineNumber,z=f.column,g=this.getStartState(P);if(!g)return null;const L=this._textModel.getLineContent(P),D=L.substring(0,z-1)+v+L.substring(z-1+b),F=this._textModel.getLanguageIdAtPosition(P,0),C=A(this._languageIdCodec,F,this.tokenizationSupport,D,!0,g);return new c.LineTokens(C.tokens,D,this._languageIdCodec)}isCheapToTokenize(f){const b=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<b||f===b&&this._textModel.getLineLength(f)<2048}tokenizeHeuristically(f,b,v){if(v<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(b<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(f,v),{heuristicTokens:!1};let P=this.guessStartState(b);const z=this._textModel.getLanguageId();for(let g=b;g<=v;g++){const L=this._textModel.getLineContent(g),D=A(this._languageIdCodec,z,this.tokenizationSupport,L,!0,P);f.add(g,D.tokens),P=D.endState}return{heuristicTokens:!0}}guessStartState(f){let b=this._textModel.getLineFirstNonWhitespaceColumn(f);const v=[];let P=null;for(let L=f-1;b>1&&L>=1;L--){const D=this._textModel.getLineFirstNonWhitespaceColumn(L);if(D!==0&&D<b&&(v.push(this._textModel.getLineContent(L)),b=D,P=this.getStartState(L),P))break}P||(P=this.tokenizationSupport.getInitialState()),v.reverse();const z=this._textModel.getLanguageId();let g=P;for(const L of v)g=A(this._languageIdCodec,z,this.tokenizationSupport,L,!1,g).endState;return g}}e.TokenizerWithStateStoreAndTextModel=o;class s{constructor(f){this.lineCount=f,this._tokenizationStateStore=new _,this._invalidEndStatesLineNumbers=new O,this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(1,f+1))}getEndState(f){return this._tokenizationStateStore.getEndState(f)}setEndState(f,b){if(!b)throw new T.BugIndicatingError("Cannot set null/undefined state");this._invalidEndStatesLineNumbers.delete(f);const v=this._tokenizationStateStore.setEndState(f,b);return v&&f<this.lineCount&&this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(f+1,f+2)),v}acceptChange(f,b){this.lineCount+=b-f.length,this._tokenizationStateStore.acceptChange(f,b),this._invalidEndStatesLineNumbers.addRangeAndResize(new t.OffsetRange(f.startLineNumber,f.endLineNumberExclusive),b)}acceptChanges(f){for(const b of f){const[v]=(0,i.countEOL)(b.text);this.acceptChange(new d.LineRange(b.range.startLineNumber,b.range.endLineNumber+1),v+1)}}invalidateEndStateRange(f){this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(f.startLineNumber,f.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this._invalidEndStatesLineNumbers.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this._invalidEndStatesLineNumbers.min===null}getStartState(f,b){return f===1?b:this.getEndState(f-1)}getFirstInvalidLine(f){const b=this.getFirstInvalidEndStateLineNumber();if(b===null)return null;const v=this.getStartState(b,f);if(!v)throw new T.BugIndicatingError("Start state must be defined");return{lineNumber:b,startState:v}}}e.TrackingTokenizationStateStore=s;class _{constructor(){this._lineEndStates=new l.FixedArray(null)}getEndState(f){return this._lineEndStates.get(f)}setEndState(f,b){const v=this._lineEndStates.get(f);return v&&v.equals(b)?!1:(this._lineEndStates.set(f,b),!0)}acceptChange(f,b){let v=f.length;b>0&&v>0&&(v--,b--),this._lineEndStates.replace(f.startLineNumber,v,b)}acceptChanges(f){for(const b of f){const[v]=(0,i.countEOL)(b.text);this.acceptChange(new d.LineRange(b.range.startLineNumber,b.range.endLineNumber+1),v+1)}}}e.TokenizationStateStore=_;class O{constructor(){this._ranges=[]}getRanges(){return this._ranges}get min(){return this._ranges.length===0?null:this._ranges[0].start}removeMin(){if(this._ranges.length===0)return null;const f=this._ranges[0];return f.start+1===f.endExclusive?this._ranges.shift():this._ranges[0]=new t.OffsetRange(f.start+1,f.endExclusive),f.start}delete(f){const b=this._ranges.findIndex(v=>v.contains(f));if(b!==-1){const v=this._ranges[b];v.start===f?v.endExclusive===f+1?this._ranges.splice(b,1):this._ranges[b]=new t.OffsetRange(f+1,v.endExclusive):v.endExclusive===f+1?this._ranges[b]=new t.OffsetRange(v.start,f):this._ranges.splice(b,1,new t.OffsetRange(v.start,f),new t.OffsetRange(f+1,v.endExclusive))}}addRange(f){t.OffsetRange.addRange(f,this._ranges)}addRangeAndResize(f,b){let v=0;for(;!(v>=this._ranges.length||f.start<=this._ranges[v].endExclusive);)v++;let P=v;for(;!(P>=this._ranges.length||f.endExclusive<this._ranges[P].start);)P++;const z=b-f.length;for(let g=P;g<this._ranges.length;g++)this._ranges[g]=this._ranges[g].delta(z);if(v===P){const g=new t.OffsetRange(f.start,f.start+b);g.isEmpty||this._ranges.splice(v,0,g)}else{const g=Math.min(f.start,this._ranges[v].start),L=Math.max(f.endExclusive,this._ranges[P-1].endExclusive),D=new t.OffsetRange(g,L+z);D.isEmpty?this._ranges.splice(v,P-v):this._ranges.splice(v,P-v,D)}}toString(){return this._ranges.map(f=>f.toString()).join(" + ")}}e.RangePriorityQueueImpl=O;function A(w,f,b,v,P,z){let g=null;if(b)try{g=b.tokenizeEncoded(v,P,z.clone())}catch(L){(0,T.onUnexpectedError)(L)}return g||(g=(0,r.nullTokenizeEncoded)(w.encodeLanguageId(f),z)),c.LineTokens.convertToEndOffset(g.tokens,v.length),g}class R{constructor(f,b){this._tokenizerWithStateStore=f,this._backgroundTokenStore=b,this._isDisposed=!1,this._isScheduled=!1}dispose(){this._isDisposed=!0}handleChanges(){this._beginBackgroundTokenization()}_beginBackgroundTokenization(){this._isScheduled||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._isScheduled=!0,(0,E.runWhenIdle)(f=>{this._isScheduled=!1,this._backgroundTokenizeWithDeadline(f)}))}_backgroundTokenizeWithDeadline(f){const b=Date.now()+f.timeRemaining(),v=()=>{this._isDisposed||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._backgroundTokenizeForAtLeast1ms(),Date.now()<b?(0,k.setTimeout0)(v):this._beginBackgroundTokenization())};v()}_backgroundTokenizeForAtLeast1ms(){const f=this._tokenizerWithStateStore._textModel.getLineCount(),b=new a.ContiguousMultilineTokensBuilder,v=y.StopWatch.create(!1);do if(v.elapsed()>1||this._tokenizeOneInvalidLine(b)>=f)break;while(this._hasLinesToTokenize());this._backgroundTokenStore.setTokens(b.finalize()),this.checkFinished()}_hasLinesToTokenize(){return this._tokenizerWithStateStore?!this._tokenizerWithStateStore.store.allStatesValid():!1}_tokenizeOneInvalidLine(f){const b=this._tokenizerWithStateStore?.getFirstInvalidLine();return b?(this._tokenizerWithStateStore.updateTokensUntilLine(f,b.lineNumber),b.lineNumber):this._tokenizerWithStateStore._textModel.getLineCount()+1}checkFinished(){this._isDisposed||this._tokenizerWithStateStore.store.allStatesValid()&&this._backgroundTokenStore.backgroundTokenizationFinished()}requestTokens(f,b){this._tokenizerWithStateStore.store.invalidateEndStateRange(new d.LineRange(f,b))}}e.DefaultBackgroundTokenizer=R}),define(W[37],j([0,1,33,2,36,14,34]),function(U,e,E,T,k,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class d extends T.Disposable{constructor(r,l,a,c,u,n,o){super(),this._grammar=r,this._initialState=l,this._containsEmbeddedLanguages=a,this._createBackgroundTokenizer=c,this._backgroundTokenizerShouldOnlyVerifyTokens=u,this._reportTokenizationTime=n,this._reportSlowTokenization=o,this._seenLanguages=[],this._onDidEncounterLanguage=this._register(new E.Emitter),this.onDidEncounterLanguage=this._onDidEncounterLanguage.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this._backgroundTokenizerShouldOnlyVerifyTokens()}getInitialState(){return this._initialState}tokenize(r,l,a){throw new Error("Not supported!")}createBackgroundTokenizer(r,l){if(this._createBackgroundTokenizer)return this._createBackgroundTokenizer(r,l)}tokenizeEncoded(r,l,a){const c=Math.random()*1e4<1,u=this._reportSlowTokenization||c,n=u?new k.StopWatch(!0):void 0,o=this._grammar.tokenizeLine2(r,a,500);if(u){const _=n.elapsed();(c||_>32)&&this._reportTokenizationTime(_,r.length,c)}if(o.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${r.substring(0,100)}`),new i.EncodedTokenizationResult(o.tokens,a);if(this._containsEmbeddedLanguages){const _=this._seenLanguages,O=o.tokens;for(let A=0,R=O.length>>>1;A<R;A++){const w=O[(A<<1)+1],f=y.TokenMetadata.getLanguageId(w);_[f]||(_[f]=!0,this._onDidEncounterLanguage.fire(f))}}let s;return a.equals(o.ruleStack)?s=a:s=o.ruleStack,new i.EncodedTokenizationResult(o.tokens,s)}}e.TextMateTokenizationSupport=d}),define(W[38],j([0,1,20,2,11]),function(U,e,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationSupportWithLineLimit=void 0;class y extends T.Disposable{get backgroundTokenizerShouldOnlyVerifyTokens(){return this._actual.backgroundTokenizerShouldOnlyVerifyTokens}constructor(d,t,r){super(),this._encodedLanguageId=d,this._actual=t,this._maxTokenizationLineLength=r,this._register((0,k.keepAlive)(this._maxTokenizationLineLength))}getInitialState(){return this._actual.getInitialState()}tokenize(d,t,r){throw new Error("Not supported!")}tokenizeEncoded(d,t,r){return d.length>=this._maxTokenizationLineLength.get()?(0,E.nullTokenizeEncoded)(this._encodedLanguageId,r):this._actual.tokenizeEncoded(d,t,r)}createBackgroundTokenizer(d,t){if(this._actual.createBackgroundTokenizer)return this._actual.createBackgroundTokenizer(d,t)}}e.TokenizationSupportWithLineLimit=y}),define(W[39],j([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(U,e,E,T,k,y,i,d,t,r,l,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerTokenizer=void 0;class u extends d.MirrorTextModel{constructor(s,_,O,A,R,w,f,b){super(s,_,O,A),this._host=R,this._languageId=w,this._encodedLanguageId=f,this._tokenizerWithStateStore=null,this._isDisposed=!1,this._maxTokenizationLineLength=(0,k.observableValue)("_maxTokenizationLineLength",-1),this._tokenizeDebouncer=new T.RunOnceScheduler(()=>this._tokenize(),10),this._maxTokenizationLineLength.set(b,void 0),this._resetTokenization()}dispose(){this._isDisposed=!0,super.dispose()}onLanguageId(s,_){this._languageId=s,this._encodedLanguageId=_,this._resetTokenization()}onEvents(s){super.onEvents(s),this._tokenizerWithStateStore?.store.acceptChanges(s.changes),this._tokenizeDebouncer.schedule()}acceptMaxTokenizationLineLength(s){this._maxTokenizationLineLength.set(s,void 0)}retokenize(s,_){this._tokenizerWithStateStore&&(this._tokenizerWithStateStore.store.invalidateEndStateRange(new i.LineRange(s,_)),this._tokenizeDebouncer.schedule())}async _resetTokenization(){this._tokenizerWithStateStore=null;const s=this._languageId,_=this._encodedLanguageId,O=await this._host.getOrCreateGrammar(s,_);if(!(this._isDisposed||s!==this._languageId||_!==this._encodedLanguageId||!O)){if(O.grammar){const A=new c.TokenizationSupportWithLineLimit(this._encodedLanguageId,new a.TextMateTokenizationSupport(O.grammar,O.initialState,!1,void 0,()=>!1,(R,w,f)=>{this._host.reportTokenizationTime(R,s,O.sourceExtensionId,w,f)},!1),this._maxTokenizationLineLength);this._tokenizerWithStateStore=new t.TokenizerWithStateStore(this._lines.length,A)}else this._tokenizerWithStateStore=null;this._tokenize()}}async _tokenize(){if(this._isDisposed||!this._tokenizerWithStateStore)return;if(!this._diffStateStacksRefEqFn){const{diffStateStacksRefEq:_}=await(0,E.importAMDNodeModule)("vscode-textmate","release/main.js");this._diffStateStacksRefEqFn=_}const s=new Date().getTime();for(;;){let _=0;const O=new r.ContiguousMultilineTokensBuilder,A=new n;for(;;){const f=this._tokenizerWithStateStore.getFirstInvalidLine();if(f===null||_>200)break;_++;const b=this._lines[f.lineNumber-1],v=this._tokenizerWithStateStore.tokenizationSupport.tokenizeEncoded(b,!0,f.startState);if(this._tokenizerWithStateStore.store.setEndState(f.lineNumber,v.endState)){const z=this._diffStateStacksRefEqFn(f.startState,v.endState);A.setState(f.lineNumber,z)}else A.setState(f.lineNumber,null);if(l.LineTokens.convertToEndOffset(v.tokens,b.length),O.add(f.lineNumber,v.tokens),new Date().getTime()-s>20)break}if(_===0)break;const R=A.getStateDeltas();if(this._host.setTokensAndStates(this._versionId,O.serialize(),R),new Date().getTime()-s>20){(0,y.setTimeout0)(()=>this._tokenize());return}}}}e.TextMateWorkerTokenizer=u;class n{constructor(){this._lastStartLineNumber=-1,this._stateDeltas=[]}setState(s,_){s===this._lastStartLineNumber+1?this._stateDeltas[this._stateDeltas.length-1].stateDeltas.push(_):this._stateDeltas.push({startLineNumber:s,stateDeltas:[_]}),this._lastStartLineNumber=s}getStateDeltas(){return this._stateDeltas}}}),define(W[40],j([0,1,18]),function(U,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class T{constructor(){this._scopeNameToLanguageRegistration=Object.create(null)}reset(){this._scopeNameToLanguageRegistration=Object.create(null)}register(y){if(this._scopeNameToLanguageRegistration[y.scopeName]){const i=this._scopeNameToLanguageRegistration[y.scopeName];E.isEqual(i.location,y.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${y.scopeName}.
Old grammar file: ${i.location.toString()}.
New grammar file: ${y.location.toString()}`)}this._scopeNameToLanguageRegistration[y.scopeName]=y}getGrammarDefinition(y){return this._scopeNameToLanguageRegistration[y]||null}}e.TMScopeRegistry=T}),define(W[41],j([0,1,2,40]),function(U,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class k extends E.Disposable{constructor(i,d,t,r){super(),this._host=i,this._initialState=t.INITIAL,this._scopeRegistry=new T.TMScopeRegistry,this._injections={},this._injectedEmbeddedLanguages={},this._languageToScope=new Map,this._grammarRegistry=this._register(new t.Registry({onigLib:r,loadGrammar:async l=>{const a=this._scopeRegistry.getGrammarDefinition(l);if(!a)return this._host.logTrace(`No grammar found for scope ${l}`),null;const c=a.location;try{const u=await this._host.readFile(c);return t.parseRawGrammar(u,c.path)}catch(u){return this._host.logError(`Unable to load and parse grammar for scope ${l} from ${c}`,u),null}},getInjections:l=>{const a=l.split(".");let c=[];for(let u=1;u<=a.length;u++){const n=a.slice(0,u).join(".");c=[...c,...this._injections[n]||[]]}return c}}));for(const l of d){if(this._scopeRegistry.register(l),l.injectTo){for(const a of l.injectTo){let c=this._injections[a];c||(this._injections[a]=c=[]),c.push(l.scopeName)}if(l.embeddedLanguages)for(const a of l.injectTo){let c=this._injectedEmbeddedLanguages[a];c||(this._injectedEmbeddedLanguages[a]=c=[]),c.push(l.embeddedLanguages)}}l.language&&this._languageToScope.set(l.language,l.scopeName)}}has(i){return this._languageToScope.has(i)}setTheme(i,d){this._grammarRegistry.setTheme(i,d)}getColorMap(){return this._grammarRegistry.getColorMap()}async createGrammar(i,d){const t=this._languageToScope.get(i);if(typeof t!="string")throw new Error(e.missingTMGrammarErrorMessage);const r=this._scopeRegistry.getGrammarDefinition(t);if(!r)throw new Error(e.missingTMGrammarErrorMessage);const l=r.embeddedLanguages;if(this._injectedEmbeddedLanguages[t]){const u=this._injectedEmbeddedLanguages[t];for(const n of u)for(const o of Object.keys(n))l[o]=n[o]}const a=Object.keys(l).length>0;let c;try{c=await this._grammarRegistry.loadGrammarWithConfiguration(t,d,{embeddedLanguages:l,tokenTypes:r.tokenTypes,balancedBracketSelectors:r.balancedBracketSelectors,unbalancedBracketSelectors:r.unbalancedBracketSelectors})}catch(u){throw u.message&&u.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):u}return{languageId:i,grammar:c,initialState:this._initialState,containsEmbeddedLanguages:a,sourceExtensionId:r.sourceExtensionId}}}e.TMGrammarFactory=k}),define(W[49],j([0,1,8,41,39]),function(U,e,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function y(d,t){return new i(d,t)}e.create=y;class i{constructor(t,r){this._createData=r,this._models=new Map,this._grammarCache=[],this._host=t.host;const l=r.grammarDefinitions.map(a=>({location:E.URI.revive(a.location),language:a.language,scopeName:a.scopeName,embeddedLanguages:a.embeddedLanguages,tokenTypes:a.tokenTypes,injectTo:a.injectTo,balancedBracketSelectors:a.balancedBracketSelectors,unbalancedBracketSelectors:a.unbalancedBracketSelectors,sourceExtensionId:a.sourceExtensionId}));this._grammarFactory=this._loadTMGrammarFactory(l)}async _loadTMGrammarFactory(t){const r=this._createData.textmateMainUri,l=await new Promise((o,s)=>{U([r],o,s)}),a=await new Promise((o,s)=>{U([this._createData.onigurumaMainUri],o,s)}),u=await(await fetch(this._createData.onigurumaWASMUri)).arrayBuffer();await a.loadWASM(u);const n=Promise.resolve({createOnigScanner:o=>a.createOnigScanner(o),createOnigString:o=>a.createOnigString(o)});return new T.TMGrammarFactory({logTrace:o=>{},logError:(o,s)=>console.error(o,s),readFile:o=>this._host.readFile(o)},t,l,n)}acceptNewModel(t){const r=E.URI.revive(t.uri),l=this;this._models.set(t.controllerId,new k.TextMateWorkerTokenizer(r,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(a,c){const u=await l._grammarFactory;return u?(l._grammarCache[c]||(l._grammarCache[c]=u.createGrammar(a,c)),l._grammarCache[c]):Promise.resolve(null)},setTokensAndStates(a,c,u){l._host.setTokensAndStates(t.controllerId,a,c,u)},reportTokenizationTime(a,c,u,n,o){l._host.reportTokenizationTime(a,c,u,n,o)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,r){this._models.get(t).onEvents(r)}retokenize(t,r,l){this._models.get(t).retokenize(r,l)}acceptModelLanguageChanged(t,r,l){this._models.get(t).onLanguageId(r,l)}acceptRemovedModel(t){const r=this._models.get(t);r&&(r.dispose(),this._models.delete(t))}async acceptTheme(t,r){(await this._grammarFactory)?.setTheme(t,r)}acceptMaxTokenizationLineLength(t,r){this._models.get(t).acceptMaxTokenizationLineLength(r)}}e.TextMateTokenizationWorker=i})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/aef377c42cea6e9aea642829953104f07097abfa/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
